var N = null;var searchIndex = {};
searchIndex["aho_corasick"]={"doc":"An implementation of the Aho-Corasick string search algorithm.","items":[[3,"Match","aho_corasick","Records a match in the search text.",N,N],[12,"pati","","The pattern index.",0,N],[12,"start","","The starting byte offset of the match in the search text.",0,N],[12,"end","","The ending byte offset of the match in the search text.",0,N],[3,"Matches","","An iterator of non-overlapping matches for in-memory text.",N,N],[12,"aut","","",1,N],[12,"text","","",1,N],[12,"texti","","",1,N],[12,"si","","",1,N],[12,"_m","","",1,N],[3,"MatchesOverlapping","","An iterator of overlapping matches for in-memory text.",N,N],[12,"aut","","",2,N],[12,"text","","",2,N],[12,"texti","","",2,N],[12,"si","","",2,N],[12,"outi","","",2,N],[12,"_m","","",2,N],[3,"StreamMatches","","An iterator of non-overlapping matches for streaming text.",N,N],[12,"aut","","",3,N],[12,"buf","","",3,N],[12,"texti","","",3,N],[12,"si","","",3,N],[12,"_m","","",3,N],[3,"StreamMatchesOverlapping","","An iterator of overlapping matches for streaming text.",N,N],[12,"aut","","",4,N],[12,"buf","","",4,N],[12,"texti","","",4,N],[12,"si","","",4,N],[12,"outi","","",4,N],[12,"_m","","",4,N],[3,"FullAcAutomaton","","A complete Aho-Corasick automaton.",N,N],[12,"pats","","",5,N],[12,"trans","","",5,N],[12,"out","","",5,N],[12,"start_bytes","","",5,N],[3,"AcAutomaton","","An Aho-Corasick finite automaton.",N,N],[12,"pats","","",6,N],[12,"states","","",6,N],[12,"start_bytes","","",6,N],[3,"State","","",N,N],[12,"out","","",7,N],[12,"fail","","",7,N],[12,"goto","","",7,N],[12,"depth","","",7,N],[3,"AllBytesIter","","",N,N],[12,"0","","",8,N],[3,"Dense","","State transitions that can be stored either sparsely or densely.",N,N],[12,"0","","",9,N],[3,"Sparse","","State transitions that are always sparse.",N,N],[12,"0","","",10,N],[4,"DenseChoice","","",N,N],[13,"Sparse","","",11,N],[13,"Dense","","",11,N],[5,"vec_bytes","","",N,[[],["usize"]]],[5,"usize_bytes","","",N,[[],["usize"]]],[0,"autiter","","",N,N],[3,"Match","aho_corasick::autiter","Records a match in the search text.",N,N],[12,"pati","","The pattern index.",0,N],[12,"start","","The starting byte offset of the match in the search text.",0,N],[12,"end","","The ending byte offset of the match in the search text.",0,N],[3,"Matches","","An iterator of non-overlapping matches for in-memory text.",N,N],[12,"aut","","",1,N],[12,"text","","",1,N],[12,"texti","","",1,N],[12,"si","","",1,N],[12,"_m","","",1,N],[3,"StreamMatches","","An iterator of non-overlapping matches for streaming text.",N,N],[12,"aut","","",3,N],[12,"buf","","",3,N],[12,"texti","","",3,N],[12,"si","","",3,N],[12,"_m","","",3,N],[3,"MatchesOverlapping","","An iterator of overlapping matches for in-memory text.",N,N],[12,"aut","","",2,N],[12,"text","","",2,N],[12,"texti","","",2,N],[12,"si","","",2,N],[12,"outi","","",2,N],[12,"_m","","",2,N],[3,"StreamMatchesOverlapping","","An iterator of overlapping matches for streaming text.",N,N],[12,"aut","","",4,N],[12,"buf","","",4,N],[12,"texti","","",4,N],[12,"si","","",4,N],[12,"outi","","",4,N],[12,"_m","","",4,N],[5,"step_to_match","","",N,N],[5,"skip_to_match","","",N,N],[5,"skip1","","",N,N],[5,"skip2","","",N,N],[5,"skip3","","",N,N],[8,"Automaton","","An abstraction over automatons and their corresponding iterators. The type parameter `P` is the type of the pattern that was used to construct this Automaton.",N,N],[10,"next_state","","Return the next state given the current state and next character.",12,[[["self"],["stateidx"],["u8"]],["stateidx"]]],[10,"has_match","","Return true if and only if the given state and current pattern index indicate a match.",12,[[["self"],["stateidx"],["usize"]],["bool"]]],[10,"get_match","","Build a match given the current state, pattern index and input index.",12,[[["self"],["stateidx"],["usize"],["usize"]],["match"]]],[10,"start_bytes","","Return the set of bytes that have transitions in the root state.",12,N],[10,"patterns","","Returns all of the patterns matched by this automaton.",12,N],[10,"pattern","","Returns the pattern indexed at `i`.",12,[[["self"],["usize"]],["p"]]],[11,"len","","Return the number of patterns in the automaton.",12,[[["self"]],["usize"]]],[11,"is_empty","","Returns true if the automaton has no patterns.",12,[[["self"]],["bool"]]],[11,"find","","Returns an iterator of non-overlapping matches in `s`.",12,[[["self"],["q"]],["matches"]]],[11,"find_overlapping","","Returns an iterator of overlapping matches in `s`.",12,[[["self"],["q"]],["matchesoverlapping"]]],[11,"stream_find","","Returns an iterator of non-overlapping matches in the given reader.",12,[[["self"],["r"]],["streammatches"]]],[11,"stream_find_overlapping","","Returns an iterator of overlapping matches in the given reader.",12,[[["self"],["r"]],["streammatchesoverlapping"]]],[11,"clone","aho_corasick","",0,[[["self"]],["match"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"hash","","",0,N],[11,"eq","","",0,[[["self"],["match"]],["bool"]]],[11,"ne","","",0,[[["self"],["match"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"next","","",1,[[["self"]],["option",["match"]]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"next","","",3,[[["self"]],["option",["result"]]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"next","","",2,[[["self"]],["option",["match"]]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"next","","",4,[[["self"]],["option",["result"]]]],[0,"full","","",N,N],[3,"FullAcAutomaton","aho_corasick::full","A complete Aho-Corasick automaton.",N,N],[12,"pats","","",5,N],[12,"trans","","",5,N],[12,"out","","",5,N],[12,"start_bytes","","",5,N],[11,"clone","aho_corasick","",5,[[["self"]],["fullacautomaton"]]],[11,"new","","Build a new expanded Aho-Corasick automaton from an existing Aho-Corasick automaton.",5,[[["acautomaton"]],["fullacautomaton"]]],[11,"memory_usage","","",5,[[["self"]],["usize"]]],[11,"heap_bytes","","",5,[[["self"]],["usize"]]],[11,"set","","",5,[[["self"],["stateidx"],["u8"],["stateidx"]]]],[11,"num_states","","",5,[[["self"]],["usize"]]],[11,"next_state","","",5,[[["self"],["stateidx"],["u8"]],["stateidx"]]],[11,"get_match","","",5,[[["self"],["stateidx"],["usize"],["usize"]],["match"]]],[11,"has_match","","",5,[[["self"],["stateidx"],["usize"]],["bool"]]],[11,"start_bytes","","",5,N],[11,"patterns","","",5,N],[11,"pattern","","",5,[[["self"],["usize"]],["p"]]],[11,"build_matrix","","",5,[[["self"],["acautomaton"]]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[6,"StateIdx","","The integer type used for the state index.",N,N],[17,"FAIL_STATE","","",N,N],[17,"ROOT_STATE","","",N,N],[17,"DENSE_DEPTH_THRESHOLD","","",N,N],[8,"Automaton","","An abstraction over automatons and their corresponding iterators. The type parameter `P` is the type of the pattern that was used to construct this Automaton.",N,N],[10,"next_state","","Return the next state given the current state and next character.",12,[[["self"],["stateidx"],["u8"]],["stateidx"]]],[10,"has_match","","Return true if and only if the given state and current pattern index indicate a match.",12,[[["self"],["stateidx"],["usize"]],["bool"]]],[10,"get_match","","Build a match given the current state, pattern index and input index.",12,[[["self"],["stateidx"],["usize"],["usize"]],["match"]]],[10,"start_bytes","","Return the set of bytes that have transitions in the root state.",12,N],[10,"patterns","","Returns all of the patterns matched by this automaton.",12,N],[10,"pattern","","Returns the pattern indexed at `i`.",12,[[["self"],["usize"]],["p"]]],[11,"len","aho_corasick::autiter","Return the number of patterns in the automaton.",12,[[["self"]],["usize"]]],[11,"is_empty","","Returns true if the automaton has no patterns.",12,[[["self"]],["bool"]]],[11,"find","","Returns an iterator of non-overlapping matches in `s`.",12,[[["self"],["q"]],["matches"]]],[11,"find_overlapping","","Returns an iterator of overlapping matches in `s`.",12,[[["self"],["q"]],["matchesoverlapping"]]],[11,"stream_find","","Returns an iterator of non-overlapping matches in the given reader.",12,[[["self"],["r"]],["streammatches"]]],[11,"stream_find_overlapping","","Returns an iterator of overlapping matches in the given reader.",12,[[["self"],["r"]],["streammatchesoverlapping"]]],[8,"Transitions","aho_corasick","An abstraction over state transition strategies.",N,N],[10,"new","","Return a new state at the given depth.",13,[[["u32"]],["self"]]],[10,"goto","","Return the next state index given the next character.",13,[[["self"],["u8"]],["stateidx"]]],[10,"set_goto","","Set the next state index for the character given.",13,[[["self"],["u8"],["stateidx"]]]],[10,"heap_bytes","","The memory use in bytes (on the heap) of this set of transitions.",13,[[["self"]],["usize"]]],[11,"clone","","",6,[[["self"]],["acautomaton"]]],[11,"clone","","",7,[[["self"]],["state"]]],[11,"new","","Create a new automaton from an iterator of patterns.",6,[[["i"]],["acautomaton",["dense"]]]],[11,"with_transitions","","Create a new automaton from an iterator of patterns.",6,[[["i"]],["acautomaton"]]],[11,"into_full","","Build out the entire automaton into a single matrix.",6,[[["self"]],["fullacautomaton"]]],[11,"num_states","","",6,[[["self"]],["usize"]]],[11,"heap_bytes","","",6,[[["self"]],["usize"]]],[11,"memoized_next_state","","",6,[[["self"],["fullacautomaton"],["stateidx"],["u8"]],["stateidx"]]],[11,"next_state","","",6,[[["self"],["stateidx"],["u8"]],["stateidx"]]],[11,"get_match","","",6,[[["self"],["stateidx"],["usize"],["usize"]],["match"]]],[11,"has_match","","",6,[[["self"],["stateidx"],["usize"]],["bool"]]],[11,"start_bytes","","",6,N],[11,"patterns","","",6,N],[11,"pattern","","",6,[[["self"],["usize"]],["p"]]],[11,"next","","",8,[[["self"]],["option"]]],[11,"new","","",8,[[],["allbytesiter"]]],[11,"build","","",6,[[["self"],["vec"]],["acautomaton"]]],[11,"fill","","",6,[[["self"]],["acautomaton"]]],[11,"add_state","","",6,[[["self"],["state"]],["stateidx"]]],[11,"new","","",7,[[["u32"]],["state"]]],[11,"goto","","",7,[[["self"],["u8"]],["stateidx"]]],[11,"set_goto","","",7,[[["self"],["u8"],["stateidx"]]]],[11,"heap_bytes","","",7,[[["self"]],["usize"]]],[11,"clone","","",9,[[["self"]],["dense"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"clone","","",11,[[["self"]],["densechoice"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"new","","",9,[[["u32"]],["dense"]]],[11,"goto","","",9,[[["self"],["u8"]],["stateidx"]]],[11,"set_goto","","",9,[[["self"],["u8"],["stateidx"]]]],[11,"heap_bytes","","",9,[[["self"]],["usize"]]],[11,"clone","","",10,[[["self"]],["sparse"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"new","","",10,[[["u32"]],["sparse"]]],[11,"goto","","",10,[[["self"],["u8"]],["stateidx"]]],[11,"set_goto","","",10,[[["self"],["u8"],["stateidx"]]]],[11,"heap_bytes","","",10,[[["self"]],["usize"]]],[11,"from_iter","","Create an automaton from an iterator of strings.",6,[[["t"]],["acautomaton"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"debug","","",7,[[["self"],["bool"]],["string"]]],[11,"goto_string","","",7,[[["self"],["bool"]],["string"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"dot","","",6,[[["self"]],["string"]]]],"paths":[[3,"Match"],[3,"Matches"],[3,"MatchesOverlapping"],[3,"StreamMatches"],[3,"StreamMatchesOverlapping"],[3,"FullAcAutomaton"],[3,"AcAutomaton"],[3,"State"],[3,"AllBytesIter"],[3,"Dense"],[3,"Sparse"],[4,"DenseChoice"],[8,"Automaton"],[8,"Transitions"]]};
searchIndex["arena"]={"doc":"The arena, a fast but limited type of allocator.","items":[[3,"TypedArena","arena","An arena that can hold objects of only one type.",N,N],[12,"ptr","","A pointer to the next object to be allocated.",0,N],[12,"end","","A pointer to the end of the allocated area. When this pointer is reached, a new chunk is allocated.",0,N],[12,"chunks","","A vector of arena chunks.",0,N],[12,"_own","","Marker indicating that dropping the arena causes its owned instances of `T` to be dropped.",0,N],[3,"TypedArenaChunk","","",N,N],[12,"storage","","The raw storage for the arena chunk.",1,N],[3,"DroplessArena","","",N,N],[12,"ptr","","A pointer to the next object to be allocated.",2,N],[12,"end","","A pointer to the end of the allocated area. When this pointer is reached, a new chunk is allocated.",2,N],[12,"chunks","","A vector of arena chunks.",2,N],[3,"SyncTypedArena","","",N,N],[12,"lock","","",3,N],[3,"SyncDroplessArena","","",N,N],[12,"lock","","",4,N],[17,"PAGE","","",N,N],[11,"new","","",1,[[["usize"]],["typedarenachunk"]]],[11,"destroy","","Destroys this arena chunk.",1,[[["self"],["usize"]]]],[11,"start","","",1,N],[11,"end","","",1,N],[11,"new","","Creates a new `TypedArena`.",0,[[],["typedarena"]]],[11,"alloc","","Allocates an object in the `TypedArena`, returning a reference to it.",0,[[["self"],["t"]],["t"]]],[11,"alloc_slice","","Allocates a slice of objects that are copied into the `TypedArena`, returning a mutable reference to it. Will panic if passed a zero-sized types.",0,N],[11,"grow","","Grows the arena.",0,[[["self"],["usize"]]]],[11,"clear","","Clears the arena. Deallocates all but the longest chunk which may be reused.",0,[[["self"]]]],[11,"clear_last_chunk","","",0,[[["self"],["typedarenachunk"]]]],[11,"drop","","",0,[[["self"]]]],[11,"new","","",2,[[],["droplessarena"]]],[11,"in_arena","","",2,N],[11,"align","","",2,[[["self"],["usize"]]]],[11,"grow","","",2,[[["self"],["usize"]]]],[11,"alloc_raw","","",2,N],[11,"alloc","","",2,[[["self"],["t"]],["t"]]],[11,"alloc_slice","","Allocates a slice of objects that are copied into the `DroplessArena`, returning a mutable reference to it. Will panic if passed a zero-sized type.",2,N],[11,"new","","",3,[[],["synctypedarena"]]],[11,"alloc","","",3,[[["self"],["t"]],["t"]]],[11,"alloc_slice","","",3,N],[11,"clear","","",3,[[["self"]]]],[11,"new","","",4,[[],["syncdroplessarena"]]],[11,"in_arena","","",4,N],[11,"alloc_raw","","",4,N],[11,"alloc","","",4,[[["self"],["t"]],["t"]]],[11,"alloc_slice","","",4,N]],"paths":[[3,"TypedArena"],[3,"TypedArenaChunk"],[3,"DroplessArena"],[3,"SyncTypedArena"],[3,"SyncDroplessArena"]]};
searchIndex["bitflags"]={"doc":"A typesafe bitmask flag generator useful for sets of C-style bitmask flags. It can be used for creating typesafe wrappers around C APIs.","items":[[0,"example_generated","bitflags","This module shows an example of code generated by the macro. IT MUST NOT BE USED OUTSIDE THIS CRATE.",N,N],[3,"Flags","bitflags::example_generated","This is the same `Flags` struct defined in the crate level example. Note that this struct is just for documentation purposes only, it must not be used outside this crate.",N,N],[12,"bits","","",0,N],[17,"FLAG_A","","",N,N],[17,"FLAG_B","","",N,N],[17,"FLAG_C","","",N,N],[17,"FLAG_ABC","","",N,N],[11,"eq","","",0,[[["self"],["flags"]],["bool"]]],[11,"ne","","",0,[[["self"],["flags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"clone","","",0,[[["self"]],["flags"]]],[11,"partial_cmp","","",0,[[["self"],["flags"]],["option",["ordering"]]]],[11,"lt","","",0,[[["self"],["flags"]],["bool"]]],[11,"le","","",0,[[["self"],["flags"]],["bool"]]],[11,"gt","","",0,[[["self"],["flags"]],["bool"]]],[11,"ge","","",0,[[["self"],["flags"]],["bool"]]],[11,"cmp","","",0,[[["self"],["flags"]],["ordering"]]],[11,"hash","","",0,N],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"empty","","Returns an empty set of flags.",0,[[],["flags"]]],[11,"all","","Returns the set containing all flags.",0,[[],["flags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",0,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",0,[[["u32"]],["option",["flags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",0,[[["u32"]],["flags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",0,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",0,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",0,[[["self"],["flags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",0,[[["self"],["flags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",0,[[["self"],["flags"]]]],[11,"remove","","Removes the specified flags in-place.",0,[[["self"],["flags"]]]],[11,"toggle","","Toggles the specified flags in-place.",0,[[["self"],["flags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",0,[[["self"],["flags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",0,[[["self"],["flags"]],["flags"]]],[11,"bitor_assign","","Adds the set of flags.",0,[[["self"],["flags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",0,[[["self"],["flags"]],["flags"]]],[11,"bitxor_assign","","Toggles the set of flags.",0,[[["self"],["flags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",0,[[["self"],["flags"]],["flags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",0,[[["self"],["flags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",0,[[["self"],["flags"]],["flags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",0,[[["self"],["flags"]]]],[11,"not","","Returns the complement of this set of flags.",0,[[["self"]],["flags"]]],[11,"extend","","",0,[[["self"],["t"]]]],[11,"from_iter","","",0,[[["t"]],["flags"]]],[14,"bitflags","bitflags","The macro used to generate the flag structure.",N,N],[14,"__impl_bitflags","","",N,N]],"paths":[[3,"Flags"]]};
searchIndex["fmt_macros"]={"doc":"Macro support for format strings","items":[[3,"Argument","fmt_macros","Representation of an argument specification.",N,N],[12,"position","","Where to find this argument",0,N],[12,"format","","How to format the argument",0,N],[3,"FormatSpec","","Specification for the formatting of an argument in the format string.",N,N],[12,"fill","","Optionally specified character to fill alignment with",1,N],[12,"align","","Optionally specified alignment",1,N],[12,"flags","","Packed version of various flags provided",1,N],[12,"precision","","The integer precision to use",1,N],[12,"width","","The string width requested for the resulting format",1,N],[12,"ty","","The descriptor string representing the name of the format desired for this argument, this can be empty or any number of characters, although it is required to be one word.",1,N],[3,"ParseError","","",N,N],[12,"description","","",2,N],[12,"note","","",2,N],[12,"label","","",2,N],[12,"start","","",2,N],[12,"end","","",2,N],[3,"Parser","","The parser structure for interpreting the input format string. This is modeled as an iterator over `Piece` structures to form a stream of tokens being output.",N,N],[12,"input","","",3,N],[12,"cur","","",3,N],[12,"errors","","Error messages accumulated during parsing",3,N],[12,"curarg","","Current position of implicit positional argument pointer",3,N],[12,"style","","`Some(raw count)` when the string is \"raw\", used to position spans correctly",3,N],[12,"seen_newlines","","How many newlines have been seen in the string so far, to adjust the error spans",3,N],[12,"arg_places","","Start and end byte offset of every successfuly parsed argument",3,N],[4,"Piece","","A piece is a portion of the format string which represents the next part to emit. These are emitted as a stream by the `Parser` class.",N,N],[13,"String","","A literal string which should directly be emitted",4,N],[13,"NextArgument","","This describes that formatting should process the next argument (as specified inside) for emission.",4,N],[4,"Position","","Enum describing where an argument for a format can be located.",N,N],[13,"ArgumentImplicitlyIs","","The argument is implied to be located at an index",5,N],[13,"ArgumentIs","","The argument is located at a specific index given in the format",5,N],[13,"ArgumentNamed","","The argument has a name.",5,N],[4,"Alignment","","Enum of alignments which are supported.",N,N],[13,"AlignLeft","","The value will be aligned to the left.",6,N],[13,"AlignRight","","The value will be aligned to the right.",6,N],[13,"AlignCenter","","The value will be aligned in the center.",6,N],[13,"AlignUnknown","","The value will take on a default alignment.",6,N],[4,"Flag","","Various flags which can be applied to format strings. The meaning of these flags is defined by the formatters themselves.",N,N],[13,"FlagSignPlus","","A `+` will be used to denote positive numbers.",7,N],[13,"FlagSignMinus","","A `-` will be used to denote negative numbers. This is the default.",7,N],[13,"FlagAlternate","","An alternate form will be used for the value. In the case of numbers, this means that the number will be prefixed with the supplied string.",7,N],[13,"FlagSignAwareZeroPad","","For numbers, this means that the number will be padded with zeroes, and the sign (`+` or `-`) will precede them.",7,N],[13,"FlagDebugLowerHex","","For Debug / `?`, format integers in lower-case hexadecimal.",7,N],[13,"FlagDebugUpperHex","","For Debug / `?`, format integers in upper-case hexadecimal.",7,N],[4,"Count","","A count is used for the precision and width parameters of an integer, and can reference either an argument or a literal integer.",N,N],[13,"CountIs","","The count is specified explicitly.",8,N],[13,"CountIsName","","The count is specified by the argument with the given name.",8,N],[13,"CountIsParam","","The count is specified by the argument at the given index.",8,N],[13,"CountImplied","","The count is implied and cannot be explicitly specified.",8,N],[11,"clone","","",4,[[["self"]],["piece"]]],[11,"eq","","",4,[[["self"],["piece"]],["bool"]]],[11,"ne","","",4,[[["self"],["piece"]],["bool"]]],[11,"clone","","",0,[[["self"]],["argument"]]],[11,"eq","","",0,[[["self"],["argument"]],["bool"]]],[11,"ne","","",0,[[["self"],["argument"]],["bool"]]],[11,"clone","","",1,[[["self"]],["formatspec"]]],[11,"eq","","",1,[[["self"],["formatspec"]],["bool"]]],[11,"ne","","",1,[[["self"],["formatspec"]],["bool"]]],[11,"clone","","",5,[[["self"]],["position"]]],[11,"eq","","",5,[[["self"],["position"]],["bool"]]],[11,"ne","","",5,[[["self"],["position"]],["bool"]]],[11,"clone","","",6,[[["self"]],["alignment"]]],[11,"eq","","",6,[[["self"],["alignment"]],["bool"]]],[11,"clone","","",7,[[["self"]],["flag"]]],[11,"eq","","",7,[[["self"],["flag"]],["bool"]]],[11,"clone","","",8,[[["self"]],["count"]]],[11,"eq","","",8,[[["self"],["count"]],["bool"]]],[11,"ne","","",8,[[["self"],["count"]],["bool"]]],[11,"next","","",3,[[["self"]],["option",["piece"]]]],[11,"new","","Creates a new parser for the given format string",3,[[["str"],["option",["usize"]]],["parser"]]],[11,"err","","Notifies of an error. The message doesn't actually need to be of type String, but I think it does when this eventually uses conditions so it might as well start using it now.",3,[[["self"],["s1"],["s2"],["usize"],["usize"]]]],[11,"err_with_note","","Notifies of an error. The message doesn't actually need to be of type String, but I think it does when this eventually uses conditions so it might as well start using it now.",3,[[["self"],["s1"],["s2"],["s3"],["usize"],["usize"]]]],[11,"consume","","Optionally consumes the specified character. If the character is not at the current position, then the current iterator isn't moved and false is returned, otherwise the character is consumed and true is returned.",3,[[["self"],["char"]],["bool"]]],[11,"must_consume","","Forces consumption of the specified character. If the character is not found, an error is emitted.",3,[[["self"],["char"]],["option",["usize"]]]],[11,"ws","","Consumes all whitespace characters until the first non-whitespace character",3,[[["self"]]]],[11,"string","","Parses all of a string which is to be considered a \"raw literal\" in a format string. This is everything outside of the braces.",3,[[["self"],["usize"]],["str"]]],[11,"argument","","Parses an Argument structure, or what's contained within braces inside the format string",3,[[["self"]],["argument"]]],[11,"position","","Parses a positional argument for a format. This could either be an integer index of an argument, a named argument, or a blank string. Returns `Some(parsed_position)` if the position is not implicitly consuming a macro argument, `None` if it's the case.",3,[[["self"]],["option",["position"]]]],[11,"format","","Parses a format specifier at the current position, returning all of the relevant information in the FormatSpec struct.",3,[[["self"]],["formatspec"]]],[11,"count","","Parses a Count parameter at the current position. This does not check for 'CountIsNextParam' because that is only used in precision, not width.",3,[[["self"]],["count"]]],[11,"word","","Parses a word starting at the current position. A word is considered to be an alphabetic character followed by any number of alphanumeric characters.",3,[[["self"]],["str"]]],[11,"integer","","Optionally parses an integer at the current position. This doesn't deal with overflow at all, it's just accumulating digits.",3,[[["self"]],["option",["usize"]]]]],"paths":[[3,"Argument"],[3,"FormatSpec"],[3,"ParseError"],[3,"Parser"],[4,"Piece"],[4,"Position"],[4,"Alignment"],[4,"Flag"],[4,"Count"]]};
searchIndex["graphviz"]={"doc":"Generate files suitable for use with Graphviz","items":[[3,"Id","graphviz","`Id` is a Graphviz `ID`.",N,N],[12,"name","","",0,N],[4,"LabelText","","The text for a graphviz label on a node or edge.",N,N],[13,"LabelStr","","This kind of label preserves the text directly as is.",1,N],[13,"EscStr","","This kind of label uses the graphviz label escString type: http://www.graphviz.org/content/attrs#kescString",1,N],[13,"HtmlStr","","This uses a graphviz [HTML string label][html]. The string is printed exactly as given, but between `<` and `>`. No escaping is performed.",1,N],[4,"Style","","The style for a node or edge. See http://www.graphviz.org/doc/info/attrs.html#k:style for descriptions. Note that some of these are not valid for edges.",N,N],[13,"None","","",2,N],[13,"Solid","","",2,N],[13,"Dashed","","",2,N],[13,"Dotted","","",2,N],[13,"Bold","","",2,N],[13,"Rounded","","",2,N],[13,"Diagonals","","",2,N],[13,"Filled","","",2,N],[13,"Striped","","",2,N],[13,"Wedged","","",2,N],[4,"RenderOption","","",N,N],[13,"NoEdgeLabels","","",3,N],[13,"NoNodeLabels","","",3,N],[13,"NoEdgeStyles","","",3,N],[13,"NoNodeStyles","","",3,N],[5,"escape_html","","Escape tags in such a way that it is suitable for inclusion in a Graphviz HTML label.",N,[[["str"]],["string"]]],[5,"default_options","","Returns vec holding all the default render options.",N,[[],["vec",["renderoption"]]]],[5,"render","","Renders directed graph `g` into the writer `w` in DOT syntax. (Simple wrapper around `render_opts` that passes a default set of options.)",N,[[["g"],["w"]],["result"]]],[5,"render_opts","","Renders directed graph `g` into the writer `w` in DOT syntax. (Main entry point for the library.)",N,N],[6,"Nodes","","",N,N],[6,"Edges","","",N,N],[8,"Labeller","","Each instance of a type that implements `Label<C>` maps to a unique identifier with respect to `C`, which is used to identify it in the generated .dot file. They can also provide more elaborate (and non-unique) label text that is used in the graphviz rendered output. The graph instance is responsible for providing the DOT compatible identifiers for the nodes and (optionally) rendered labels for the nodes and edges, as well as an identifier for the graph itself.",N,N],[16,"Node","","",4,N],[16,"Edge","","",4,N],[10,"graph_id","","Must return a DOT compatible identifier naming the graph.",4,[[["self"]],["id"]]],[10,"node_id","","Maps `n` to a unique identifier with respect to `self`. The implementor is responsible for ensuring that the returned name is a valid DOT identifier.",4,N],[11,"node_shape","","Maps `n` to one of the [graphviz `shape` names][1]. If `None` is returned, no `shape` attribute is specified.",4,N],[11,"node_label","","Maps `n` to a label that will be used in the rendered output. The label need not be unique, and may be the empty string; the default is just the output from `node_id`.",4,N],[11,"edge_label","","Maps `e` to a label that will be used in the rendered output. The label need not be unique, and may be the empty string; the default is in fact the empty string.",4,N],[11,"node_style","","Maps `n` to a style that will be used in the rendered output.",4,N],[11,"edge_style","","Maps `e` to a style that will be used in the rendered output.",4,N],[8,"GraphWalk","","GraphWalk is an abstraction over a directed graph = (nodes,edges) made up of node handles `N` and edge handles `E`, where each `E` can be mapped to its source and target nodes.",N,N],[16,"Node","","",5,N],[16,"Edge","","",5,N],[10,"nodes","","Returns all the nodes in this graph.",5,[[["self"]],["nodes"]]],[10,"edges","","Returns all of the edges in this graph.",5,[[["self"]],["edges"]]],[10,"source","","The source node for `edge`.",5,N],[10,"target","","The target node for `edge`.",5,N],[8,"IntoCow","","",N,N],[10,"into_cow","","",6,[[["self"]],["cow"]]],[11,"clone","","",2,[[["self"]],["style"]]],[11,"eq","","",2,[[["self"],["style"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"as_slice","","",2,[[["self"]],["str"]]],[11,"new","","Creates an `Id` named `name`.",0,[[["name"]],["result",["id"]]]],[11,"as_slice","","",0,[[["self"]],["str"]]],[11,"name","","",0,[[["self"]],["cow",["str"]]]],[11,"label","","",1,[[["s"]],["labeltext"]]],[11,"escaped","","",1,[[["s"]],["labeltext"]]],[11,"html","","",1,[[["s"]],["labeltext"]]],[11,"escape_char","","",1,[[["char"],["f"]]]],[11,"escape_str","","",1,[[["str"]],["string"]]],[11,"to_dot_string","","Renders text as string suitable for a label in a .dot file. This includes quotes or suitable delimiters.",1,[[["self"]],["string"]]],[11,"pre_escaped_content","","Decomposes content into string suitable for making EscStr that yields same content as self.  The result obeys the law render(`lt`) == render(`EscStr(lt.pre_escaped_content())`) for all `lt: LabelText`.",1,[[["self"]],["cow",["str"]]]],[11,"prefix_line","","Puts `prefix` on a line above this label, with a blank line separator.",1,[[["self"],["labeltext"]],["labeltext"]]],[11,"suffix_line","","Puts `suffix` on a line below this label, with a blank line separator.",1,[[["self"],["labeltext"]],["labeltext"]]],[11,"clone","","",3,[[["self"]],["renderoption"]]],[11,"eq","","",3,[[["self"],["renderoption"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]]],"paths":[[3,"Id"],[4,"LabelText"],[4,"Style"],[4,"RenderOption"],[8,"Labeller"],[8,"GraphWalk"],[8,"IntoCow"]]};
searchIndex["lazy_static"]={"doc":"A macro for declaring lazily evaluated statics.","items":[[5,"initialize","lazy_static","Takes a shared reference to a lazy static and initializes it if it has not been already.",N,[[["t"]]]],[0,"lazy","","",N,N],[17,"ONCE_INIT","lazy_static::lazy","Initialization value for static [`Once`] values.",N,N],[3,"Lazy","","",N,N],[12,"0","","",0,N],[12,"1","","",0,N],[11,"get","","",0,[[["self"],["f"]],["t"]]],[8,"LazyStatic","lazy_static","Support trait for enabling a few common operation on lazy static values.",N,N],[10,"initialize","","",1,[[["self"]]]],[14,"__lazy_static_create","","",N,N],[14,"__lazy_static_internal","","",N,N],[14,"lazy_static","","",N,N]],"paths":[[3,"Lazy"],[8,"LazyStatic"]]};
searchIndex["libc"]={"doc":"Crate docs","items":[[3,"group","libc","",N,N],[12,"gr_name","","",0,N],[12,"gr_passwd","","",0,N],[12,"gr_gid","","",0,N],[12,"gr_mem","","",0,N],[3,"utimbuf","","",N,N],[12,"actime","","",1,N],[12,"modtime","","",1,N],[3,"timeval","","",N,N],[12,"tv_sec","","",2,N],[12,"tv_usec","","",2,N],[3,"timespec","","",N,N],[12,"tv_sec","","",3,N],[12,"tv_nsec","","",3,N],[3,"rlimit","","",N,N],[12,"rlim_cur","","",4,N],[12,"rlim_max","","",4,N],[3,"rusage","","",N,N],[12,"ru_utime","","",5,N],[12,"ru_stime","","",5,N],[12,"ru_maxrss","","",5,N],[12,"ru_ixrss","","",5,N],[12,"ru_idrss","","",5,N],[12,"ru_isrss","","",5,N],[12,"ru_minflt","","",5,N],[12,"ru_majflt","","",5,N],[12,"ru_nswap","","",5,N],[12,"ru_inblock","","",5,N],[12,"ru_oublock","","",5,N],[12,"ru_msgsnd","","",5,N],[12,"ru_msgrcv","","",5,N],[12,"ru_nsignals","","",5,N],[12,"ru_nvcsw","","",5,N],[12,"ru_nivcsw","","",5,N],[3,"in_addr","","",N,N],[12,"s_addr","","",6,N],[3,"in6_addr","","",N,N],[12,"s6_addr","","",7,N],[12,"__align","","",7,N],[3,"ip_mreq","","",N,N],[12,"imr_multiaddr","","",8,N],[12,"imr_interface","","",8,N],[3,"ipv6_mreq","","",N,N],[12,"ipv6mr_multiaddr","","",9,N],[12,"ipv6mr_interface","","",9,N],[3,"hostent","","",N,N],[12,"h_name","","",10,N],[12,"h_aliases","","",10,N],[12,"h_addrtype","","",10,N],[12,"h_length","","",10,N],[12,"h_addr_list","","",10,N],[3,"iovec","","",N,N],[12,"iov_base","","",11,N],[12,"iov_len","","",11,N],[3,"pollfd","","",N,N],[12,"fd","","",12,N],[12,"events","","",12,N],[12,"revents","","",12,N],[3,"winsize","","",N,N],[12,"ws_row","","",13,N],[12,"ws_col","","",13,N],[12,"ws_xpixel","","",13,N],[12,"ws_ypixel","","",13,N],[3,"linger","","",N,N],[12,"l_onoff","","",14,N],[12,"l_linger","","",14,N],[3,"sigval","","",N,N],[12,"sival_ptr","","",15,N],[3,"itimerval","","",N,N],[12,"it_interval","","",16,N],[12,"it_value","","",16,N],[3,"tms","","",N,N],[12,"tms_utime","","",17,N],[12,"tms_stime","","",17,N],[12,"tms_cutime","","",17,N],[12,"tms_cstime","","",17,N],[3,"servent","","",N,N],[12,"s_name","","",18,N],[12,"s_aliases","","",18,N],[12,"s_port","","",18,N],[12,"s_proto","","",18,N],[3,"protoent","","",N,N],[12,"p_name","","",19,N],[12,"p_aliases","","",19,N],[12,"p_proto","","",19,N],[3,"sockaddr","","",N,N],[12,"sa_family","","",20,N],[12,"sa_data","","",20,N],[3,"sockaddr_in","","",N,N],[12,"sin_family","","",21,N],[12,"sin_port","","",21,N],[12,"sin_addr","","",21,N],[12,"sin_zero","","",21,N],[3,"sockaddr_in6","","",N,N],[12,"sin6_family","","",22,N],[12,"sin6_port","","",22,N],[12,"sin6_flowinfo","","",22,N],[12,"sin6_addr","","",22,N],[12,"sin6_scope_id","","",22,N],[3,"sockaddr_un","","",N,N],[12,"sun_family","","",23,N],[12,"sun_path","","",23,N],[3,"sockaddr_storage","","",N,N],[12,"ss_family","","",24,N],[12,"__ss_align","","",24,N],[12,"__ss_pad2","","",24,N],[3,"addrinfo","","",N,N],[12,"ai_flags","","",25,N],[12,"ai_family","","",25,N],[12,"ai_socktype","","",25,N],[12,"ai_protocol","","",25,N],[12,"ai_addrlen","","",25,N],[12,"ai_addr","","",25,N],[12,"ai_canonname","","",25,N],[12,"ai_next","","",25,N],[3,"sockaddr_nl","","",N,N],[12,"nl_family","","",26,N],[12,"nl_pad","","",26,N],[12,"nl_pid","","",26,N],[12,"nl_groups","","",26,N],[3,"sockaddr_ll","","",N,N],[12,"sll_family","","",27,N],[12,"sll_protocol","","",27,N],[12,"sll_ifindex","","",27,N],[12,"sll_hatype","","",27,N],[12,"sll_pkttype","","",27,N],[12,"sll_halen","","",27,N],[12,"sll_addr","","",27,N],[3,"fd_set","","",N,N],[12,"fds_bits","","",28,N],[3,"tm","","",N,N],[12,"tm_sec","","",29,N],[12,"tm_min","","",29,N],[12,"tm_hour","","",29,N],[12,"tm_mday","","",29,N],[12,"tm_mon","","",29,N],[12,"tm_year","","",29,N],[12,"tm_wday","","",29,N],[12,"tm_yday","","",29,N],[12,"tm_isdst","","",29,N],[12,"tm_gmtoff","","",29,N],[12,"tm_zone","","",29,N],[3,"sched_param","","",N,N],[12,"sched_priority","","",30,N],[3,"Dl_info","","",N,N],[12,"dli_fname","","",31,N],[12,"dli_fbase","","",31,N],[12,"dli_sname","","",31,N],[12,"dli_saddr","","",31,N],[3,"epoll_event","","",N,N],[12,"events","","",32,N],[12,"u64","","",32,N],[3,"utsname","","",N,N],[12,"sysname","","",33,N],[12,"nodename","","",33,N],[12,"release","","",33,N],[12,"version","","",33,N],[12,"machine","","",33,N],[12,"domainname","","",33,N],[3,"lconv","","",N,N],[12,"decimal_point","","",34,N],[12,"thousands_sep","","",34,N],[12,"grouping","","",34,N],[12,"int_curr_symbol","","",34,N],[12,"currency_symbol","","",34,N],[12,"mon_decimal_point","","",34,N],[12,"mon_thousands_sep","","",34,N],[12,"mon_grouping","","",34,N],[12,"positive_sign","","",34,N],[12,"negative_sign","","",34,N],[12,"int_frac_digits","","",34,N],[12,"frac_digits","","",34,N],[12,"p_cs_precedes","","",34,N],[12,"p_sep_by_space","","",34,N],[12,"n_cs_precedes","","",34,N],[12,"n_sep_by_space","","",34,N],[12,"p_sign_posn","","",34,N],[12,"n_sign_posn","","",34,N],[12,"int_p_cs_precedes","","",34,N],[12,"int_p_sep_by_space","","",34,N],[12,"int_n_cs_precedes","","",34,N],[12,"int_n_sep_by_space","","",34,N],[12,"int_p_sign_posn","","",34,N],[12,"int_n_sign_posn","","",34,N],[3,"sigevent","","",N,N],[12,"sigev_value","","",35,N],[12,"sigev_signo","","",35,N],[12,"sigev_notify","","",35,N],[12,"sigev_notify_thread_id","","",35,N],[12,"__unused1","","",35,N],[3,"in_pktinfo","","",N,N],[12,"ipi_ifindex","","",36,N],[12,"ipi_spec_dst","","",36,N],[12,"ipi_addr","","",36,N],[3,"ifaddrs","","",N,N],[12,"ifa_next","","",37,N],[12,"ifa_name","","",37,N],[12,"ifa_flags","","",37,N],[12,"ifa_addr","","",37,N],[12,"ifa_netmask","","",37,N],[12,"ifa_ifu","","",37,N],[12,"ifa_data","","",37,N],[3,"in6_rtmsg","","",N,N],[12,"rtmsg_dst","","",38,N],[12,"rtmsg_src","","",38,N],[12,"rtmsg_gateway","","",38,N],[12,"rtmsg_type","","",38,N],[12,"rtmsg_dst_len","","",38,N],[12,"rtmsg_src_len","","",38,N],[12,"rtmsg_metric","","",38,N],[12,"rtmsg_info","","",38,N],[12,"rtmsg_flags","","",38,N],[12,"rtmsg_ifindex","","",38,N],[3,"dirent","","",N,N],[12,"d_ino","","",39,N],[12,"d_off","","",39,N],[12,"d_reclen","","",39,N],[12,"d_type","","",39,N],[12,"d_name","","",39,N],[3,"dirent64","","",N,N],[12,"d_ino","","",40,N],[12,"d_off","","",40,N],[12,"d_reclen","","",40,N],[12,"d_type","","",40,N],[12,"d_name","","",40,N],[3,"rlimit64","","",N,N],[12,"rlim_cur","","",41,N],[12,"rlim_max","","",41,N],[3,"glob_t","","",N,N],[12,"gl_pathc","","",42,N],[12,"gl_pathv","","",42,N],[12,"gl_offs","","",42,N],[12,"gl_flags","","",42,N],[12,"__unused1","","",42,N],[12,"__unused2","","",42,N],[12,"__unused3","","",42,N],[12,"__unused4","","",42,N],[12,"__unused5","","",42,N],[3,"pthread_mutex_t","","",N,N],[12,"__align","","",43,N],[12,"size","","",43,N],[3,"pthread_rwlock_t","","",N,N],[12,"__align","","",44,N],[12,"size","","",44,N],[3,"pthread_mutexattr_t","","",N,N],[12,"__align","","",45,N],[12,"size","","",45,N],[3,"pthread_rwlockattr_t","","",N,N],[12,"__align","","",46,N],[12,"size","","",46,N],[3,"pthread_cond_t","","",N,N],[12,"__align","","",47,N],[12,"size","","",47,N],[3,"pthread_condattr_t","","",N,N],[12,"__align","","",48,N],[12,"size","","",48,N],[3,"passwd","","",N,N],[12,"pw_name","","",49,N],[12,"pw_passwd","","",49,N],[12,"pw_uid","","",49,N],[12,"pw_gid","","",49,N],[12,"pw_gecos","","",49,N],[12,"pw_dir","","",49,N],[12,"pw_shell","","",49,N],[3,"spwd","","",N,N],[12,"sp_namp","","",50,N],[12,"sp_pwdp","","",50,N],[12,"sp_lstchg","","",50,N],[12,"sp_min","","",50,N],[12,"sp_max","","",50,N],[12,"sp_warn","","",50,N],[12,"sp_inact","","",50,N],[12,"sp_expire","","",50,N],[12,"sp_flag","","",50,N],[3,"dqblk","","",N,N],[12,"dqb_bhardlimit","","",51,N],[12,"dqb_bsoftlimit","","",51,N],[12,"dqb_curspace","","",51,N],[12,"dqb_ihardlimit","","",51,N],[12,"dqb_isoftlimit","","",51,N],[12,"dqb_curinodes","","",51,N],[12,"dqb_btime","","",51,N],[12,"dqb_itime","","",51,N],[12,"dqb_valid","","",51,N],[3,"signalfd_siginfo","","",N,N],[12,"ssi_signo","","",52,N],[12,"ssi_errno","","",52,N],[12,"ssi_code","","",52,N],[12,"ssi_pid","","",52,N],[12,"ssi_uid","","",52,N],[12,"ssi_fd","","",52,N],[12,"ssi_tid","","",52,N],[12,"ssi_band","","",52,N],[12,"ssi_overrun","","",52,N],[12,"ssi_trapno","","",52,N],[12,"ssi_status","","",52,N],[12,"ssi_int","","",52,N],[12,"ssi_ptr","","",52,N],[12,"ssi_utime","","",52,N],[12,"ssi_stime","","",52,N],[12,"ssi_addr","","",52,N],[12,"_pad","","",52,N],[3,"itimerspec","","",N,N],[12,"it_interval","","",53,N],[12,"it_value","","",53,N],[3,"fsid_t","","",N,N],[12,"__val","","",54,N],[3,"mq_attr","","",N,N],[12,"mq_flags","","",55,N],[12,"mq_maxmsg","","",55,N],[12,"mq_msgsize","","",55,N],[12,"mq_curmsgs","","",55,N],[12,"pad","","",55,N],[3,"cpu_set_t","","",N,N],[12,"bits","","",56,N],[3,"if_nameindex","","",N,N],[12,"if_index","","",57,N],[12,"if_name","","",57,N],[3,"msginfo","","",N,N],[12,"msgpool","","",58,N],[12,"msgmap","","",58,N],[12,"msgmax","","",58,N],[12,"msgmnb","","",58,N],[12,"msgmni","","",58,N],[12,"msgssz","","",58,N],[12,"msgtql","","",58,N],[12,"msgseg","","",58,N],[3,"mmsghdr","","",N,N],[12,"msg_hdr","","",59,N],[12,"msg_len","","",59,N],[3,"sembuf","","",N,N],[12,"sem_num","","",60,N],[12,"sem_op","","",60,N],[12,"sem_flg","","",60,N],[3,"input_event","","",N,N],[12,"time","","",61,N],[12,"type_","","",61,N],[12,"code","","",61,N],[12,"value","","",61,N],[3,"input_id","","",N,N],[12,"bustype","","",62,N],[12,"vendor","","",62,N],[12,"product","","",62,N],[12,"version","","",62,N],[3,"input_absinfo","","",N,N],[12,"value","","",63,N],[12,"minimum","","",63,N],[12,"maximum","","",63,N],[12,"fuzz","","",63,N],[12,"flat","","",63,N],[12,"resolution","","",63,N],[3,"input_keymap_entry","","",N,N],[12,"flags","","",64,N],[12,"len","","",64,N],[12,"index","","",64,N],[12,"keycode","","",64,N],[12,"scancode","","",64,N],[3,"input_mask","","",N,N],[12,"type_","","",65,N],[12,"codes_size","","",65,N],[12,"codes_ptr","","",65,N],[3,"ff_replay","","",N,N],[12,"length","","",66,N],[12,"delay","","",66,N],[3,"ff_trigger","","",N,N],[12,"button","","",67,N],[12,"interval","","",67,N],[3,"ff_envelope","","",N,N],[12,"attack_length","","",68,N],[12,"attack_level","","",68,N],[12,"fade_length","","",68,N],[12,"fade_level","","",68,N],[3,"ff_constant_effect","","",N,N],[12,"level","","",69,N],[12,"envelope","","",69,N],[3,"ff_ramp_effect","","",N,N],[12,"start_level","","",70,N],[12,"end_level","","",70,N],[12,"envelope","","",70,N],[3,"ff_condition_effect","","",N,N],[12,"right_saturation","","",71,N],[12,"left_saturation","","",71,N],[12,"right_coeff","","",71,N],[12,"left_coeff","","",71,N],[12,"deadband","","",71,N],[12,"center","","",71,N],[3,"ff_periodic_effect","","",N,N],[12,"waveform","","",72,N],[12,"period","","",72,N],[12,"magnitude","","",72,N],[12,"offset","","",72,N],[12,"phase","","",72,N],[12,"envelope","","",72,N],[12,"custom_len","","",72,N],[12,"custom_data","","",72,N],[3,"ff_rumble_effect","","",N,N],[12,"strong_magnitude","","",73,N],[12,"weak_magnitude","","",73,N],[3,"ff_effect","","",N,N],[12,"type_","","",74,N],[12,"id","","",74,N],[12,"direction","","",74,N],[12,"trigger","","",74,N],[12,"replay","","",74,N],[12,"u","","",74,N],[3,"dl_phdr_info","","",N,N],[12,"dlpi_addr","","",75,N],[12,"dlpi_name","","",75,N],[12,"dlpi_phdr","","",75,N],[12,"dlpi_phnum","","",75,N],[12,"dlpi_adds","","",75,N],[12,"dlpi_subs","","",75,N],[12,"dlpi_tls_modid","","",75,N],[12,"dlpi_tls_data","","",75,N],[3,"Elf32_Phdr","","",N,N],[12,"p_type","","",76,N],[12,"p_offset","","",76,N],[12,"p_vaddr","","",76,N],[12,"p_paddr","","",76,N],[12,"p_filesz","","",76,N],[12,"p_memsz","","",76,N],[12,"p_flags","","",76,N],[12,"p_align","","",76,N],[3,"Elf64_Phdr","","",N,N],[12,"p_type","","",77,N],[12,"p_flags","","",77,N],[12,"p_offset","","",77,N],[12,"p_vaddr","","",77,N],[12,"p_paddr","","",77,N],[12,"p_filesz","","",77,N],[12,"p_memsz","","",77,N],[12,"p_align","","",77,N],[3,"ucred","","",N,N],[12,"pid","","",78,N],[12,"uid","","",78,N],[12,"gid","","",78,N],[3,"mntent","","",N,N],[12,"mnt_fsname","","",79,N],[12,"mnt_dir","","",79,N],[12,"mnt_type","","",79,N],[12,"mnt_opts","","",79,N],[12,"mnt_freq","","",79,N],[12,"mnt_passno","","",79,N],[3,"posix_spawn_file_actions_t","","",N,N],[12,"__allocated","","",80,N],[12,"__used","","",80,N],[12,"__actions","","",80,N],[12,"__pad","","",80,N],[3,"posix_spawnattr_t","","",N,N],[12,"__flags","","",81,N],[12,"__pgrp","","",81,N],[12,"__sd","","",81,N],[12,"__ss","","",81,N],[12,"__sp","","",81,N],[12,"__policy","","",81,N],[12,"__pad","","",81,N],[3,"genlmsghdr","","",N,N],[12,"cmd","","",82,N],[12,"version","","",82,N],[12,"reserved","","",82,N],[3,"in6_pktinfo","","",N,N],[12,"ipi6_addr","","",83,N],[12,"ipi6_ifindex","","",83,N],[3,"aiocb","","",N,N],[12,"aio_fildes","","",84,N],[12,"aio_lio_opcode","","",84,N],[12,"aio_reqprio","","",84,N],[12,"aio_buf","","",84,N],[12,"aio_nbytes","","",84,N],[12,"aio_sigevent","","",84,N],[12,"__next_prio","","",84,N],[12,"__abs_prio","","",84,N],[12,"__policy","","",84,N],[12,"__error_code","","",84,N],[12,"__return_value","","",84,N],[12,"aio_offset","","",84,N],[12,"__glibc_reserved","","",84,N],[3,"__exit_status","","",N,N],[12,"e_termination","","",85,N],[12,"e_exit","","",85,N],[3,"__timeval","","",N,N],[12,"tv_sec","","",86,N],[12,"tv_usec","","",86,N],[3,"utmpx","","",N,N],[12,"ut_type","","",87,N],[12,"ut_pid","","",87,N],[12,"ut_line","","",87,N],[12,"ut_id","","",87,N],[12,"ut_user","","",87,N],[12,"ut_host","","",87,N],[12,"ut_exit","","",87,N],[12,"ut_session","","",87,N],[12,"ut_tv","","",87,N],[12,"ut_addr_v6","","",87,N],[12,"__glibc_reserved","","",87,N],[3,"sigaction","","",N,N],[12,"sa_sigaction","","",88,N],[12,"sa_mask","","",88,N],[12,"sa_flags","","",88,N],[12,"sa_restorer","","",88,N],[3,"stack_t","","",N,N],[12,"ss_sp","","",89,N],[12,"ss_flags","","",89,N],[12,"ss_size","","",89,N],[3,"siginfo_t","","",N,N],[12,"si_signo","","",90,N],[12,"si_errno","","",90,N],[12,"si_code","","",90,N],[12,"_pad","","",90,N],[12,"_align","","",90,N],[3,"glob64_t","","",N,N],[12,"gl_pathc","","",91,N],[12,"gl_pathv","","",91,N],[12,"gl_offs","","",91,N],[12,"gl_flags","","",91,N],[12,"__unused1","","",91,N],[12,"__unused2","","",91,N],[12,"__unused3","","",91,N],[12,"__unused4","","",91,N],[12,"__unused5","","",91,N],[3,"statfs","","",N,N],[12,"f_type","","",92,N],[12,"f_bsize","","",92,N],[12,"f_blocks","","",92,N],[12,"f_bfree","","",92,N],[12,"f_bavail","","",92,N],[12,"f_files","","",92,N],[12,"f_ffree","","",92,N],[12,"f_fsid","","",92,N],[12,"f_namelen","","",92,N],[12,"f_frsize","","",92,N],[12,"f_spare","","",92,N],[3,"msghdr","","",N,N],[12,"msg_name","","",93,N],[12,"msg_namelen","","",93,N],[12,"msg_iov","","",93,N],[12,"msg_iovlen","","",93,N],[12,"msg_control","","",93,N],[12,"msg_controllen","","",93,N],[12,"msg_flags","","",93,N],[3,"cmsghdr","","",N,N],[12,"cmsg_len","","",94,N],[12,"cmsg_level","","",94,N],[12,"cmsg_type","","",94,N],[3,"termios","","",N,N],[12,"c_iflag","","",95,N],[12,"c_oflag","","",95,N],[12,"c_cflag","","",95,N],[12,"c_lflag","","",95,N],[12,"c_line","","",95,N],[12,"c_cc","","",95,N],[12,"c_ispeed","","",95,N],[12,"c_ospeed","","",95,N],[3,"flock","","",N,N],[12,"l_type","","",96,N],[12,"l_whence","","",96,N],[12,"l_start","","",96,N],[12,"l_len","","",96,N],[12,"l_pid","","",96,N],[3,"sem_t","","",N,N],[12,"__size","","",97,N],[12,"__align","","",97,N],[3,"mallinfo","","",N,N],[12,"arena","","",98,N],[12,"ordblks","","",98,N],[12,"smblks","","",98,N],[12,"hblks","","",98,N],[12,"hblkhd","","",98,N],[12,"usmblks","","",98,N],[12,"fsmblks","","",98,N],[12,"uordblks","","",98,N],[12,"fordblks","","",98,N],[12,"keepcost","","",98,N],[3,"nlmsghdr","","",N,N],[12,"nlmsg_len","","",99,N],[12,"nlmsg_type","","",99,N],[12,"nlmsg_flags","","",99,N],[12,"nlmsg_seq","","",99,N],[12,"nlmsg_pid","","",99,N],[3,"nlmsgerr","","",N,N],[12,"error","","",100,N],[12,"msg","","",100,N],[3,"nl_pktinfo","","",N,N],[12,"group","","",101,N],[3,"nl_mmap_req","","",N,N],[12,"nm_block_size","","",102,N],[12,"nm_block_nr","","",102,N],[12,"nm_frame_size","","",102,N],[12,"nm_frame_nr","","",102,N],[3,"nl_mmap_hdr","","",N,N],[12,"nm_status","","",103,N],[12,"nm_len","","",103,N],[12,"nm_group","","",103,N],[12,"nm_pid","","",103,N],[12,"nm_uid","","",103,N],[12,"nm_gid","","",103,N],[3,"nlattr","","",N,N],[12,"nla_len","","",104,N],[12,"nla_type","","",104,N],[3,"rtentry","","",N,N],[12,"rt_pad1","","",105,N],[12,"rt_dst","","",105,N],[12,"rt_gateway","","",105,N],[12,"rt_genmask","","",105,N],[12,"rt_flags","","",105,N],[12,"rt_pad2","","",105,N],[12,"rt_pad3","","",105,N],[12,"rt_tos","","",105,N],[12,"rt_class","","",105,N],[12,"rt_pad4","","",105,N],[12,"rt_metric","","",105,N],[12,"rt_dev","","",105,N],[12,"rt_mtu","","",105,N],[12,"rt_window","","",105,N],[12,"rt_irtt","","",105,N],[3,"sigset_t","","",N,N],[12,"__val","","",106,N],[3,"sysinfo","","",N,N],[12,"uptime","","",107,N],[12,"loads","","",107,N],[12,"totalram","","",107,N],[12,"freeram","","",107,N],[12,"sharedram","","",107,N],[12,"bufferram","","",107,N],[12,"totalswap","","",107,N],[12,"freeswap","","",107,N],[12,"procs","","",107,N],[12,"pad","","",107,N],[12,"totalhigh","","",107,N],[12,"freehigh","","",107,N],[12,"mem_unit","","",107,N],[12,"_f","","",107,N],[3,"msqid_ds","","",N,N],[12,"msg_perm","","",108,N],[12,"msg_stime","","",108,N],[12,"msg_rtime","","",108,N],[12,"msg_ctime","","",108,N],[12,"__msg_cbytes","","",108,N],[12,"msg_qnum","","",108,N],[12,"msg_qbytes","","",108,N],[12,"msg_lspid","","",108,N],[12,"msg_lrpid","","",108,N],[12,"__glibc_reserved4","","",108,N],[12,"__glibc_reserved5","","",108,N],[3,"stat","","",N,N],[12,"st_dev","","",109,N],[12,"st_ino","","",109,N],[12,"st_nlink","","",109,N],[12,"st_mode","","",109,N],[12,"st_uid","","",109,N],[12,"st_gid","","",109,N],[12,"__pad0","","",109,N],[12,"st_rdev","","",109,N],[12,"st_size","","",109,N],[12,"st_blksize","","",109,N],[12,"st_blocks","","",109,N],[12,"st_atime","","",109,N],[12,"st_atime_nsec","","",109,N],[12,"st_mtime","","",109,N],[12,"st_mtime_nsec","","",109,N],[12,"st_ctime","","",109,N],[12,"st_ctime_nsec","","",109,N],[12,"__unused","","",109,N],[3,"stat64","","",N,N],[12,"st_dev","","",110,N],[12,"st_ino","","",110,N],[12,"st_nlink","","",110,N],[12,"st_mode","","",110,N],[12,"st_uid","","",110,N],[12,"st_gid","","",110,N],[12,"__pad0","","",110,N],[12,"st_rdev","","",110,N],[12,"st_size","","",110,N],[12,"st_blksize","","",110,N],[12,"st_blocks","","",110,N],[12,"st_atime","","",110,N],[12,"st_atime_nsec","","",110,N],[12,"st_mtime","","",110,N],[12,"st_mtime_nsec","","",110,N],[12,"st_ctime","","",110,N],[12,"st_ctime_nsec","","",110,N],[12,"__reserved","","",110,N],[3,"statfs64","","",N,N],[12,"f_type","","",111,N],[12,"f_bsize","","",111,N],[12,"f_blocks","","",111,N],[12,"f_bfree","","",111,N],[12,"f_bavail","","",111,N],[12,"f_files","","",111,N],[12,"f_ffree","","",111,N],[12,"f_fsid","","",111,N],[12,"f_namelen","","",111,N],[12,"f_frsize","","",111,N],[12,"f_flags","","",111,N],[12,"f_spare","","",111,N],[3,"statvfs64","","",N,N],[12,"f_bsize","","",112,N],[12,"f_frsize","","",112,N],[12,"f_blocks","","",112,N],[12,"f_bfree","","",112,N],[12,"f_bavail","","",112,N],[12,"f_files","","",112,N],[12,"f_ffree","","",112,N],[12,"f_favail","","",112,N],[12,"f_fsid","","",112,N],[12,"f_flag","","",112,N],[12,"f_namemax","","",112,N],[12,"__f_spare","","",112,N],[3,"pthread_attr_t","","",N,N],[12,"__size","","",113,N],[3,"_libc_fpxreg","","",N,N],[12,"significand","","",114,N],[12,"exponent","","",114,N],[12,"__private","","",114,N],[3,"_libc_xmmreg","","",N,N],[12,"element","","",115,N],[3,"_libc_fpstate","","",N,N],[12,"cwd","","",116,N],[12,"swd","","",116,N],[12,"ftw","","",116,N],[12,"fop","","",116,N],[12,"rip","","",116,N],[12,"rdp","","",116,N],[12,"mxcsr","","",116,N],[12,"mxcr_mask","","",116,N],[12,"_st","","",116,N],[12,"_xmm","","",116,N],[12,"__private","","",116,N],[3,"user_fpregs_struct","","",N,N],[12,"cwd","","",117,N],[12,"swd","","",117,N],[12,"ftw","","",117,N],[12,"fop","","",117,N],[12,"rip","","",117,N],[12,"rdp","","",117,N],[12,"mxcsr","","",117,N],[12,"mxcr_mask","","",117,N],[12,"st_space","","",117,N],[12,"xmm_space","","",117,N],[12,"padding","","",117,N],[3,"user_regs_struct","","",N,N],[12,"r15","","",118,N],[12,"r14","","",118,N],[12,"r13","","",118,N],[12,"r12","","",118,N],[12,"rbp","","",118,N],[12,"rbx","","",118,N],[12,"r11","","",118,N],[12,"r10","","",118,N],[12,"r9","","",118,N],[12,"r8","","",118,N],[12,"rax","","",118,N],[12,"rcx","","",118,N],[12,"rdx","","",118,N],[12,"rsi","","",118,N],[12,"rdi","","",118,N],[12,"orig_rax","","",118,N],[12,"rip","","",118,N],[12,"cs","","",118,N],[12,"eflags","","",118,N],[12,"rsp","","",118,N],[12,"ss","","",118,N],[12,"fs_base","","",118,N],[12,"gs_base","","",118,N],[12,"ds","","",118,N],[12,"es","","",118,N],[12,"fs","","",118,N],[12,"gs","","",118,N],[3,"user","","",N,N],[12,"regs","","",119,N],[12,"u_fpvalid","","",119,N],[12,"i387","","",119,N],[12,"u_tsize","","",119,N],[12,"u_dsize","","",119,N],[12,"u_ssize","","",119,N],[12,"start_code","","",119,N],[12,"start_stack","","",119,N],[12,"signal","","",119,N],[12,"__reserved","","",119,N],[12,"u_ar0","","",119,N],[12,"u_fpstate","","",119,N],[12,"magic","","",119,N],[12,"u_comm","","",119,N],[12,"u_debugreg","","",119,N],[3,"mcontext_t","","",N,N],[12,"gregs","","",120,N],[12,"fpregs","","",120,N],[12,"__private","","",120,N],[3,"ucontext_t","","",N,N],[12,"uc_flags","","",121,N],[12,"uc_link","","",121,N],[12,"uc_stack","","",121,N],[12,"uc_mcontext","","",121,N],[12,"uc_sigmask","","",121,N],[12,"__private","","",121,N],[3,"ipc_perm","","",N,N],[12,"__key","","",122,N],[12,"uid","","",122,N],[12,"gid","","",122,N],[12,"cuid","","",122,N],[12,"cgid","","",122,N],[12,"mode","","",122,N],[12,"__pad1","","",122,N],[12,"__seq","","",122,N],[12,"__pad2","","",122,N],[12,"__unused1","","",122,N],[12,"__unused2","","",122,N],[3,"shmid_ds","","",N,N],[12,"shm_perm","","",123,N],[12,"shm_segsz","","",123,N],[12,"shm_atime","","",123,N],[12,"shm_dtime","","",123,N],[12,"shm_ctime","","",123,N],[12,"shm_cpid","","",123,N],[12,"shm_lpid","","",123,N],[12,"shm_nattch","","",123,N],[12,"__unused4","","",123,N],[12,"__unused5","","",123,N],[3,"termios2","","",N,N],[12,"c_iflag","","",124,N],[12,"c_oflag","","",124,N],[12,"c_cflag","","",124,N],[12,"c_lflag","","",124,N],[12,"c_line","","",124,N],[12,"c_cc","","",124,N],[12,"c_ispeed","","",124,N],[12,"c_ospeed","","",124,N],[3,"statvfs","","",N,N],[12,"f_bsize","","",125,N],[12,"f_frsize","","",125,N],[12,"f_blocks","","",125,N],[12,"f_bfree","","",125,N],[12,"f_bavail","","",125,N],[12,"f_files","","",125,N],[12,"f_ffree","","",125,N],[12,"f_favail","","",125,N],[12,"f_fsid","","",125,N],[12,"f_flag","","",125,N],[12,"f_namemax","","",125,N],[12,"__f_spare","","",125,N],[4,"c_void","","",N,N],[13,"__variant1","","",126,N],[13,"__variant2","","",126,N],[4,"FILE","","",N,N],[4,"fpos_t","","",N,N],[4,"DIR","","",N,N],[4,"locale_t","","",N,N],[4,"timezone","","",N,N],[4,"fpos64_t","","",N,N],[5,"FD_CLR","","",N,N],[5,"FD_ISSET","","",N,N],[5,"FD_SET","","",N,N],[5,"FD_ZERO","","",N,N],[5,"WIFSTOPPED","","",N,[[["c_int"]],["bool"]]],[5,"WSTOPSIG","","",N,[[["c_int"]],["c_int"]]],[5,"WIFCONTINUED","","",N,[[["c_int"]],["bool"]]],[5,"WIFSIGNALED","","",N,[[["c_int"]],["bool"]]],[5,"WTERMSIG","","",N,[[["c_int"]],["c_int"]]],[5,"WIFEXITED","","",N,[[["c_int"]],["bool"]]],[5,"WEXITSTATUS","","",N,[[["c_int"]],["c_int"]]],[5,"WCOREDUMP","","",N,[[["c_int"]],["bool"]]],[5,"QCMD","","",N,[[["c_int"],["c_int"]],["c_int"]]],[5,"IPOPT_COPIED","","",N,[[["u8"]],["u8"]]],[5,"IPOPT_CLASS","","",N,[[["u8"]],["u8"]]],[5,"IPOPT_NUMBER","","",N,[[["u8"]],["u8"]]],[5,"CPU_ZERO","","",N,N],[5,"CPU_SET","","",N,N],[5,"CPU_CLR","","",N,N],[5,"CPU_ISSET","","",N,[[["usize"],["cpu_set_t"]],["bool"]]],[5,"CPU_EQUAL","","",N,[[["cpu_set_t"],["cpu_set_t"]],["bool"]]],[5,"major","","",N,[[["dev_t"]],["c_uint"]]],[5,"minor","","",N,[[["dev_t"]],["c_uint"]]],[5,"makedev","","",N,[[["c_uint"],["c_uint"]],["dev_t"]]],[5,"IPTOS_TOS","","",N,[[["u8"]],["u8"]]],[5,"IPTOS_PREC","","",N,[[["u8"]],["u8"]]],[5,"RT_TOS","","",N,[[["u8"]],["u8"]]],[5,"RT_ADDRCLASS","","",N,[[["u32"]],["u32"]]],[5,"RT_LOCALADDR","","",N,[[["u32"]],["bool"]]],[5,"NLA_ALIGN","","",N,[[["c_int"]],["c_int"]]],[5,"isalnum","","",N,N],[5,"isalpha","","",N,N],[5,"iscntrl","","",N,N],[5,"isdigit","","",N,N],[5,"isgraph","","",N,N],[5,"islower","","",N,N],[5,"isprint","","",N,N],[5,"ispunct","","",N,N],[5,"isspace","","",N,N],[5,"isupper","","",N,N],[5,"isxdigit","","",N,N],[5,"tolower","","",N,N],[5,"toupper","","",N,N],[5,"fopen","","",N,N],[5,"freopen","","",N,N],[5,"fflush","","",N,N],[5,"fclose","","",N,N],[5,"remove","","",N,N],[5,"rename","","",N,N],[5,"tmpfile","","",N,N],[5,"setvbuf","","",N,N],[5,"setbuf","","",N,N],[5,"getchar","","",N,N],[5,"putchar","","",N,N],[5,"fgetc","","",N,N],[5,"fgets","","",N,N],[5,"fputc","","",N,N],[5,"fputs","","",N,N],[5,"puts","","",N,N],[5,"ungetc","","",N,N],[5,"fread","","",N,N],[5,"fwrite","","",N,N],[5,"fseek","","",N,N],[5,"ftell","","",N,N],[5,"rewind","","",N,N],[5,"fgetpos","","",N,N],[5,"fsetpos","","",N,N],[5,"feof","","",N,N],[5,"ferror","","",N,N],[5,"perror","","",N,N],[5,"atoi","","",N,N],[5,"strtod","","",N,N],[5,"strtol","","",N,N],[5,"strtoul","","",N,N],[5,"calloc","","",N,N],[5,"malloc","","",N,N],[5,"realloc","","",N,N],[5,"free","","",N,N],[5,"abort","","",N,N],[5,"exit","","",N,N],[5,"_exit","","",N,N],[5,"atexit","","",N,N],[5,"system","","",N,N],[5,"getenv","","",N,N],[5,"strcpy","","",N,N],[5,"strncpy","","",N,N],[5,"strcat","","",N,N],[5,"strncat","","",N,N],[5,"strcmp","","",N,N],[5,"strncmp","","",N,N],[5,"strcoll","","",N,N],[5,"strchr","","",N,N],[5,"strrchr","","",N,N],[5,"strspn","","",N,N],[5,"strcspn","","",N,N],[5,"strdup","","",N,N],[5,"strpbrk","","",N,N],[5,"strstr","","",N,N],[5,"strlen","","",N,N],[5,"strnlen","","",N,N],[5,"strerror","","",N,N],[5,"strtok","","",N,N],[5,"strxfrm","","",N,N],[5,"wcslen","","",N,N],[5,"wcstombs","","",N,N],[5,"memchr","","",N,N],[5,"memcmp","","",N,N],[5,"memcpy","","",N,N],[5,"memmove","","",N,N],[5,"memset","","",N,N],[5,"abs","","",N,N],[5,"atof","","",N,N],[5,"labs","","",N,N],[5,"rand","","",N,N],[5,"srand","","",N,N],[5,"getpwnam","","",N,N],[5,"getpwuid","","",N,N],[5,"fprintf","","",N,N],[5,"printf","","",N,N],[5,"snprintf","","",N,N],[5,"sprintf","","",N,N],[5,"fscanf","","",N,N],[5,"scanf","","",N,N],[5,"sscanf","","",N,N],[5,"getchar_unlocked","","",N,N],[5,"putchar_unlocked","","",N,N],[5,"socket","","",N,N],[5,"connect","","",N,N],[5,"listen","","",N,N],[5,"accept","","",N,N],[5,"getpeername","","",N,N],[5,"getsockname","","",N,N],[5,"setsockopt","","",N,N],[5,"socketpair","","",N,N],[5,"sendto","","",N,N],[5,"shutdown","","",N,N],[5,"chmod","","",N,N],[5,"fchmod","","",N,N],[5,"fstat","","",N,N],[5,"mkdir","","",N,N],[5,"stat","","",N,N],[5,"pclose","","",N,N],[5,"fdopen","","",N,N],[5,"fileno","","",N,N],[5,"open","","",N,N],[5,"creat","","",N,N],[5,"fcntl","","",N,N],[5,"opendir","","",N,N],[5,"readdir","","",N,N],[5,"readdir_r","","",N,N],[5,"closedir","","",N,N],[5,"rewinddir","","",N,N],[5,"openat","","",N,N],[5,"fchmodat","","",N,N],[5,"fchown","","",N,N],[5,"fchownat","","",N,N],[5,"fstatat","","",N,N],[5,"linkat","","",N,N],[5,"mkdirat","","",N,N],[5,"readlinkat","","",N,N],[5,"renameat","","",N,N],[5,"symlinkat","","",N,N],[5,"unlinkat","","",N,N],[5,"access","","",N,N],[5,"alarm","","",N,N],[5,"chdir","","",N,N],[5,"fchdir","","",N,N],[5,"chown","","",N,N],[5,"lchown","","",N,N],[5,"close","","",N,N],[5,"dup","","",N,N],[5,"dup2","","",N,N],[5,"execl","","",N,N],[5,"execle","","",N,N],[5,"execlp","","",N,N],[5,"execv","","",N,N],[5,"execve","","",N,N],[5,"execvp","","",N,N],[5,"fork","","",N,N],[5,"fpathconf","","",N,N],[5,"getcwd","","",N,N],[5,"getegid","","",N,N],[5,"geteuid","","",N,N],[5,"getgid","","",N,N],[5,"getgroups","","",N,N],[5,"getlogin","","",N,N],[5,"getopt","","",N,N],[5,"getpgid","","",N,N],[5,"getpgrp","","",N,N],[5,"getpid","","",N,N],[5,"getppid","","",N,N],[5,"getuid","","",N,N],[5,"isatty","","",N,N],[5,"link","","",N,N],[5,"lseek","","",N,N],[5,"pathconf","","",N,N],[5,"pause","","",N,N],[5,"pipe","","",N,N],[5,"posix_memalign","","",N,N],[5,"read","","",N,N],[5,"rmdir","","",N,N],[5,"seteuid","","",N,N],[5,"setgid","","",N,N],[5,"setpgid","","",N,N],[5,"setsid","","",N,N],[5,"setuid","","",N,N],[5,"sleep","","",N,N],[5,"nanosleep","","",N,N],[5,"tcgetpgrp","","",N,N],[5,"tcsetpgrp","","",N,N],[5,"ttyname","","",N,N],[5,"unlink","","",N,N],[5,"wait","","",N,N],[5,"waitpid","","",N,N],[5,"write","","",N,N],[5,"pread","","",N,N],[5,"pwrite","","",N,N],[5,"umask","","",N,N],[5,"utime","","",N,N],[5,"kill","","",N,N],[5,"killpg","","",N,N],[5,"mlock","","",N,N],[5,"munlock","","",N,N],[5,"mlockall","","",N,N],[5,"munlockall","","",N,N],[5,"mmap","","",N,N],[5,"munmap","","",N,N],[5,"if_nametoindex","","",N,N],[5,"if_indextoname","","",N,N],[5,"lstat","","",N,N],[5,"fsync","","",N,N],[5,"setenv","","",N,N],[5,"unsetenv","","",N,N],[5,"symlink","","",N,N],[5,"ftruncate","","",N,N],[5,"signal","","",N,N],[5,"getrlimit","","",N,N],[5,"setrlimit","","",N,N],[5,"getrusage","","",N,N],[5,"realpath","","",N,N],[5,"flock","","",N,N],[5,"gettimeofday","","",N,N],[5,"times","","",N,N],[5,"pthread_self","","",N,N],[5,"pthread_join","","",N,N],[5,"pthread_exit","","",N,N],[5,"pthread_attr_init","","",N,N],[5,"pthread_attr_destroy","","",N,N],[5,"pthread_attr_setstacksize","","",N,N],[5,"pthread_attr_setdetachstate","","",N,N],[5,"pthread_detach","","",N,N],[5,"sched_yield","","",N,N],[5,"pthread_key_create","","",N,N],[5,"pthread_key_delete","","",N,N],[5,"pthread_getspecific","","",N,N],[5,"pthread_setspecific","","",N,N],[5,"pthread_mutex_init","","",N,N],[5,"pthread_mutex_destroy","","",N,N],[5,"pthread_mutex_lock","","",N,N],[5,"pthread_mutex_trylock","","",N,N],[5,"pthread_mutex_unlock","","",N,N],[5,"pthread_mutexattr_init","","",N,N],[5,"pthread_mutexattr_destroy","","",N,N],[5,"pthread_mutexattr_settype","","",N,N],[5,"pthread_cond_init","","",N,N],[5,"pthread_cond_wait","","",N,N],[5,"pthread_cond_timedwait","","",N,N],[5,"pthread_cond_signal","","",N,N],[5,"pthread_cond_broadcast","","",N,N],[5,"pthread_cond_destroy","","",N,N],[5,"pthread_condattr_init","","",N,N],[5,"pthread_condattr_destroy","","",N,N],[5,"pthread_rwlock_init","","",N,N],[5,"pthread_rwlock_destroy","","",N,N],[5,"pthread_rwlock_rdlock","","",N,N],[5,"pthread_rwlock_tryrdlock","","",N,N],[5,"pthread_rwlock_wrlock","","",N,N],[5,"pthread_rwlock_trywrlock","","",N,N],[5,"pthread_rwlock_unlock","","",N,N],[5,"pthread_rwlockattr_init","","",N,N],[5,"pthread_rwlockattr_destroy","","",N,N],[5,"strerror_r","","",N,N],[5,"getsockopt","","",N,N],[5,"raise","","",N,N],[5,"sigaction","","",N,N],[5,"utimes","","",N,N],[5,"dlopen","","",N,N],[5,"dlerror","","",N,N],[5,"dlsym","","",N,N],[5,"dlclose","","",N,N],[5,"dladdr","","",N,N],[5,"getaddrinfo","","",N,N],[5,"freeaddrinfo","","",N,N],[5,"gai_strerror","","",N,N],[5,"res_init","","",N,N],[5,"gmtime_r","","",N,N],[5,"localtime_r","","",N,N],[5,"mktime","","",N,N],[5,"time","","",N,N],[5,"gmtime","","",N,N],[5,"localtime","","",N,N],[5,"difftime","","",N,N],[5,"mknod","","",N,N],[5,"uname","","",N,N],[5,"gethostname","","",N,N],[5,"getservbyname","","",N,N],[5,"getprotobyname","","",N,N],[5,"getprotobynumber","","",N,N],[5,"chroot","","",N,N],[5,"usleep","","",N,N],[5,"send","","",N,N],[5,"recv","","",N,N],[5,"putenv","","",N,N],[5,"poll","","",N,N],[5,"select","","",N,N],[5,"setlocale","","",N,N],[5,"localeconv","","",N,N],[5,"sem_destroy","","",N,N],[5,"sem_wait","","",N,N],[5,"sem_trywait","","",N,N],[5,"sem_post","","",N,N],[5,"sem_init","","",N,N],[5,"statvfs","","",N,N],[5,"fstatvfs","","",N,N],[5,"readlink","","",N,N],[5,"sigemptyset","","",N,N],[5,"sigaddset","","",N,N],[5,"sigfillset","","",N,N],[5,"sigdelset","","",N,N],[5,"sigismember","","",N,N],[5,"sigprocmask","","",N,N],[5,"sigpending","","",N,N],[5,"timegm","","",N,N],[5,"getsid","","",N,N],[5,"sysconf","","",N,N],[5,"mkfifo","","",N,N],[5,"pselect","","",N,N],[5,"fseeko","","",N,N],[5,"ftello","","",N,N],[5,"tcdrain","","",N,N],[5,"cfgetispeed","","",N,N],[5,"cfgetospeed","","",N,N],[5,"cfmakeraw","","",N,N],[5,"cfsetispeed","","",N,N],[5,"cfsetospeed","","",N,N],[5,"cfsetspeed","","",N,N],[5,"tcgetattr","","",N,N],[5,"tcsetattr","","",N,N],[5,"tcflow","","",N,N],[5,"tcflush","","",N,N],[5,"tcgetsid","","",N,N],[5,"tcsendbreak","","",N,N],[5,"mkstemp","","",N,N],[5,"mkdtemp","","",N,N],[5,"tmpnam","","",N,N],[5,"openlog","","",N,N],[5,"closelog","","",N,N],[5,"setlogmask","","",N,N],[5,"syslog","","",N,N],[5,"nice","","",N,N],[5,"grantpt","","",N,N],[5,"posix_openpt","","",N,N],[5,"ptsname","","",N,N],[5,"unlockpt","","",N,N],[5,"fdatasync","","",N,N],[5,"mincore","","",N,N],[5,"clock_getres","","",N,N],[5,"clock_gettime","","",N,N],[5,"clock_settime","","",N,N],[5,"dirfd","","",N,N],[5,"pthread_getattr_np","","",N,N],[5,"pthread_attr_getstack","","",N,N],[5,"memalign","","",N,N],[5,"setgroups","","",N,N],[5,"pipe2","","",N,N],[5,"statfs","","",N,N],[5,"statfs64","","",N,N],[5,"fstatfs","","",N,N],[5,"fstatfs64","","",N,N],[5,"statvfs64","","",N,N],[5,"fstatvfs64","","",N,N],[5,"memrchr","","",N,N],[5,"posix_fadvise","","",N,N],[5,"futimens","","",N,N],[5,"utimensat","","",N,N],[5,"duplocale","","",N,N],[5,"freelocale","","",N,N],[5,"newlocale","","",N,N],[5,"uselocale","","",N,N],[5,"creat64","","",N,N],[5,"fstat64","","",N,N],[5,"fstatat64","","",N,N],[5,"ftruncate64","","",N,N],[5,"getrlimit64","","",N,N],[5,"lseek64","","",N,N],[5,"lstat64","","",N,N],[5,"mmap64","","",N,N],[5,"open64","","",N,N],[5,"openat64","","",N,N],[5,"pread64","","",N,N],[5,"preadv64","","",N,N],[5,"pwrite64","","",N,N],[5,"pwritev64","","",N,N],[5,"readdir64","","",N,N],[5,"readdir64_r","","",N,N],[5,"setrlimit64","","",N,N],[5,"stat64","","",N,N],[5,"truncate64","","",N,N],[5,"fdopendir","","",N,N],[5,"mknodat","","",N,N],[5,"pthread_condattr_getclock","","",N,N],[5,"pthread_condattr_setclock","","",N,N],[5,"pthread_condattr_setpshared","","",N,N],[5,"accept4","","",N,N],[5,"pthread_mutexattr_setpshared","","",N,N],[5,"pthread_rwlockattr_getpshared","","",N,N],[5,"pthread_rwlockattr_setpshared","","",N,N],[5,"ptsname_r","","",N,N],[5,"clearenv","","",N,N],[5,"waitid","","",N,N],[5,"setreuid","","",N,N],[5,"setregid","","",N,N],[5,"getresuid","","",N,N],[5,"getresgid","","",N,N],[5,"acct","","",N,N],[5,"brk","","",N,N],[5,"sbrk","","",N,N],[5,"vfork","","",N,N],[5,"setresgid","","",N,N],[5,"setresuid","","",N,N],[5,"wait4","","",N,N],[5,"openpty","","",N,N],[5,"execvpe","","",N,N],[5,"fexecve","","",N,N],[5,"getifaddrs","","",N,N],[5,"freeifaddrs","","",N,N],[5,"bind","","",N,N],[5,"writev","","",N,N],[5,"readv","","",N,N],[5,"sendmsg","","",N,N],[5,"recvmsg","","",N,N],[5,"aio_read","","",N,N],[5,"aio_write","","",N,N],[5,"aio_fsync","","",N,N],[5,"aio_error","","",N,N],[5,"aio_return","","",N,N],[5,"aio_suspend","","",N,N],[5,"aio_cancel","","",N,N],[5,"lio_listio","","",N,N],[5,"lutimes","","",N,N],[5,"setpwent","","",N,N],[5,"endpwent","","",N,N],[5,"getpwent","","",N,N],[5,"setgrent","","",N,N],[5,"endgrent","","",N,N],[5,"getgrent","","",N,N],[5,"setspent","","",N,N],[5,"endspent","","",N,N],[5,"getspent","","",N,N],[5,"getspnam","","",N,N],[5,"shm_open","","",N,N],[5,"shmget","","",N,N],[5,"shmat","","",N,N],[5,"shmdt","","",N,N],[5,"shmctl","","",N,N],[5,"ftok","","",N,N],[5,"semget","","",N,N],[5,"semop","","",N,N],[5,"semctl","","",N,N],[5,"msgctl","","",N,N],[5,"msgget","","",N,N],[5,"msgrcv","","",N,N],[5,"msgsnd","","",N,N],[5,"mprotect","","",N,N],[5,"__errno_location","","",N,N],[5,"fopen64","","",N,N],[5,"freopen64","","",N,N],[5,"tmpfile64","","",N,N],[5,"fgetpos64","","",N,N],[5,"fsetpos64","","",N,N],[5,"fseeko64","","",N,N],[5,"ftello64","","",N,N],[5,"fallocate","","",N,N],[5,"posix_fallocate","","",N,N],[5,"readahead","","",N,N],[5,"getxattr","","",N,N],[5,"lgetxattr","","",N,N],[5,"fgetxattr","","",N,N],[5,"setxattr","","",N,N],[5,"lsetxattr","","",N,N],[5,"fsetxattr","","",N,N],[5,"listxattr","","",N,N],[5,"llistxattr","","",N,N],[5,"flistxattr","","",N,N],[5,"removexattr","","",N,N],[5,"lremovexattr","","",N,N],[5,"fremovexattr","","",N,N],[5,"signalfd","","",N,N],[5,"timerfd_create","","",N,N],[5,"timerfd_gettime","","",N,N],[5,"timerfd_settime","","",N,N],[5,"pwritev","","",N,N],[5,"preadv","","",N,N],[5,"quotactl","","",N,N],[5,"mq_open","","",N,N],[5,"mq_close","","",N,N],[5,"mq_unlink","","",N,N],[5,"mq_receive","","",N,N],[5,"mq_send","","",N,N],[5,"mq_getattr","","",N,N],[5,"mq_setattr","","",N,N],[5,"epoll_pwait","","",N,N],[5,"dup3","","",N,N],[5,"mkostemp","","",N,N],[5,"mkostemps","","",N,N],[5,"sigtimedwait","","",N,N],[5,"sigwaitinfo","","",N,N],[5,"nl_langinfo_l","","",N,N],[5,"getnameinfo","","",N,N],[5,"pthread_setschedprio","","",N,N],[5,"prlimit","","",N,N],[5,"prlimit64","","",N,N],[5,"getloadavg","","",N,N],[5,"process_vm_readv","","",N,N],[5,"process_vm_writev","","",N,N],[5,"reboot","","",N,N],[5,"setfsgid","","",N,N],[5,"setfsuid","","",N,N],[5,"mkfifoat","","",N,N],[5,"if_nameindex","","",N,N],[5,"if_freenameindex","","",N,N],[5,"sync_file_range","","",N,N],[5,"mremap","","",N,N],[5,"glob","","",N,N],[5,"globfree","","",N,N],[5,"posix_madvise","","",N,N],[5,"shm_unlink","","",N,N],[5,"seekdir","","",N,N],[5,"telldir","","",N,N],[5,"madvise","","",N,N],[5,"msync","","",N,N],[5,"remap_file_pages","","",N,N],[5,"recvfrom","","",N,N],[5,"mkstemps","","",N,N],[5,"futimes","","",N,N],[5,"nl_langinfo","","",N,N],[5,"getdomainname","","",N,N],[5,"setdomainname","","",N,N],[5,"vhangup","","",N,N],[5,"sendmmsg","","",N,N],[5,"recvmmsg","","",N,N],[5,"sync","","",N,N],[5,"syscall","","",N,N],[5,"sched_getaffinity","","",N,N],[5,"sched_setaffinity","","",N,N],[5,"epoll_create","","",N,N],[5,"epoll_create1","","",N,N],[5,"epoll_wait","","",N,N],[5,"epoll_ctl","","",N,N],[5,"pthread_getschedparam","","",N,N],[5,"unshare","","",N,N],[5,"umount","","",N,N],[5,"sched_get_priority_max","","",N,N],[5,"tee","","",N,N],[5,"settimeofday","","",N,N],[5,"splice","","",N,N],[5,"eventfd","","",N,N],[5,"sched_rr_get_interval","","",N,N],[5,"sem_timedwait","","",N,N],[5,"sem_getvalue","","",N,N],[5,"sched_setparam","","",N,N],[5,"setns","","",N,N],[5,"swapoff","","",N,N],[5,"vmsplice","","",N,N],[5,"mount","","",N,N],[5,"personality","","",N,N],[5,"prctl","","",N,N],[5,"sched_getparam","","",N,N],[5,"ppoll","","",N,N],[5,"pthread_mutex_timedlock","","",N,N],[5,"clone","","",N,N],[5,"sched_getscheduler","","",N,N],[5,"clock_nanosleep","","",N,N],[5,"pthread_attr_getguardsize","","",N,N],[5,"sethostname","","",N,N],[5,"sched_get_priority_min","","",N,N],[5,"pthread_condattr_getpshared","","",N,N],[5,"sysinfo","","",N,N],[5,"umount2","","",N,N],[5,"pthread_setschedparam","","",N,N],[5,"swapon","","",N,N],[5,"sched_setscheduler","","",N,N],[5,"sendfile","","",N,N],[5,"sigsuspend","","",N,N],[5,"getgrgid_r","","",N,N],[5,"sigaltstack","","",N,N],[5,"sem_close","","",N,N],[5,"getdtablesize","","",N,N],[5,"getgrnam_r","","",N,N],[5,"initgroups","","",N,N],[5,"pthread_sigmask","","",N,N],[5,"sem_open","","",N,N],[5,"getgrnam","","",N,N],[5,"pthread_cancel","","",N,N],[5,"pthread_kill","","",N,N],[5,"sem_unlink","","",N,N],[5,"daemon","","",N,N],[5,"getpwnam_r","","",N,N],[5,"getpwuid_r","","",N,N],[5,"sigwait","","",N,N],[5,"pthread_atfork","","",N,N],[5,"getgrgid","","",N,N],[5,"getgrouplist","","",N,N],[5,"pthread_mutexattr_getpshared","","",N,N],[5,"popen","","",N,N],[5,"faccessat","","",N,N],[5,"pthread_create","","",N,N],[5,"dl_iterate_phdr","","",N,N],[5,"setmntent","","",N,N],[5,"getmntent","","",N,N],[5,"addmntent","","",N,N],[5,"endmntent","","",N,N],[5,"hasmntopt","","",N,N],[5,"posix_spawn","","",N,N],[5,"posix_spawnp","","",N,N],[5,"posix_spawnattr_init","","",N,N],[5,"posix_spawnattr_destroy","","",N,N],[5,"posix_spawnattr_getsigdefault","","",N,N],[5,"posix_spawnattr_setsigdefault","","",N,N],[5,"posix_spawnattr_getsigmask","","",N,N],[5,"posix_spawnattr_setsigmask","","",N,N],[5,"posix_spawnattr_getflags","","",N,N],[5,"posix_spawnattr_setflags","","",N,N],[5,"posix_spawnattr_getpgroup","","",N,N],[5,"posix_spawnattr_setpgroup","","",N,N],[5,"posix_spawnattr_getschedpolicy","","",N,N],[5,"posix_spawnattr_setschedpolicy","","",N,N],[5,"posix_spawnattr_getschedparam","","",N,N],[5,"posix_spawnattr_setschedparam","","",N,N],[5,"posix_spawn_file_actions_init","","",N,N],[5,"posix_spawn_file_actions_destroy","","",N,N],[5,"posix_spawn_file_actions_addopen","","",N,N],[5,"posix_spawn_file_actions_addclose","","",N,N],[5,"posix_spawn_file_actions_adddup2","","",N,N],[5,"fread_unlocked","","",N,N],[5,"utmpxname","","",N,N],[5,"getutxent","","",N,N],[5,"getutxid","","",N,N],[5,"getutxline","","",N,N],[5,"pututxline","","",N,N],[5,"setutxent","","",N,N],[5,"endutxent","","",N,N],[5,"getpt","","",N,N],[5,"ioctl","","",N,N],[5,"backtrace","","",N,N],[5,"glob64","","",N,N],[5,"globfree64","","",N,N],[5,"ptrace","","",N,N],[5,"pthread_attr_getaffinity_np","","",N,N],[5,"pthread_attr_setaffinity_np","","",N,N],[5,"getpriority","","",N,N],[5,"setpriority","","",N,N],[5,"pthread_getaffinity_np","","",N,N],[5,"pthread_setaffinity_np","","",N,N],[5,"pthread_rwlockattr_getkind_np","","",N,N],[5,"pthread_rwlockattr_setkind_np","","",N,N],[5,"sched_getcpu","","",N,N],[5,"mallinfo","","",N,N],[5,"malloc_usable_size","","",N,N],[5,"getauxval","","",N,N],[5,"getpwent_r","","",N,N],[5,"getgrent_r","","",N,N],[5,"getcontext","","",N,N],[5,"setcontext","","",N,N],[5,"makecontext","","",N,N],[5,"swapcontext","","",N,N],[5,"iopl","","",N,N],[5,"ioperm","","",N,N],[5,"sysctl","","",N,N],[0,"macros","","",N,N],[0,"dox","","",N,N],[0,"imp","libc::dox","",N,N],[4,"Option","libc::dox::imp","The `Option` type. See the module level documentation for more.",N,N],[13,"None","","No value",127,N],[13,"Some","","Some value `T`",127,N],[8,"Clone","","A common trait for the ability to explicitly duplicate an object.",N,N],[10,"clone","","Returns a copy of the value.",128,[[["self"]],["self"]]],[11,"clone_from","","Performs copy-assignment from `source`.",128,N],[8,"Copy","","Types whose values can be duplicated simply by copying bits.",N,N],[0,"mem","","Basic functions for dealing with memory.",N,N],[5,"forget","libc::dox::imp::mem","Leaks a value: takes ownership and \"forgets\" about the value without running its destructor.",N,N],[5,"size_of","","Returns the size of a type in bytes.",N,[[],["usize"]]],[5,"size_of_val","","Returns the size of the pointed-to value in bytes.",N,[[["t"]],["usize"]]],[5,"min_align_of","","Returns the [ABI]-required minimum alignment of a type.",N,[[],["usize"]]],[5,"min_align_of_val","","Returns the [ABI]-required minimum alignment of the type of the value that `val` points to.",N,[[["t"]],["usize"]]],[5,"align_of","","Returns the [ABI]-required minimum alignment of a type.",N,[[],["usize"]]],[5,"align_of_val","","Returns the [ABI]-required minimum alignment of the type of the value that `val` points to.",N,[[["t"]],["usize"]]],[5,"needs_drop","","Returns whether dropping values of type `T` matters.",N,[[],["bool"]]],[5,"zeroed","","Creates a value whose bytes are all zero.",N,[[],["t"]]],[5,"uninitialized","","Bypasses Rust's normal memory-initialization checks by pretending to produce a value of type `T`, while doing nothing at all.",N,[[],["t"]]],[5,"swap","","Swaps the values at two mutable locations, without deinitializing either one.",N,N],[5,"replace","","Moves `src` into the referenced `dest`, returning the previous `dest` value.",N,[[["t"],["t"]],["t"]]],[5,"drop","","Disposes of a value.",N,N],[5,"transmute_copy","","Interprets `src` as having type `&U`, and then reads `src` without moving the contained value.",N,[[["t"]],["u"]]],[3,"Discriminant","","Opaque type representing the discriminant of an enum.",N,N],[12,"0","","",129,N],[12,"1","","",129,N],[5,"discriminant","","Returns a value uniquely identifying the enum variant in `v`.",N,[[["t"]],["discriminant"]]],[3,"ManuallyDrop","","A wrapper to inhibit compiler from automatically calling `T`’s destructor.",N,N],[12,"value","","",130,N],[3,"PinMut","","A pinned reference.",N,N],[12,"inner","","",131,N],[5,"transmute","","Reinterprets the bits of a value of one type as another type.",N,[[["t"]],["u"]]],[0,"unix","libc","Definitions found commonly among almost all Unix derivatives",N,N],[3,"group","libc::unix","",N,N],[12,"gr_name","","",0,N],[12,"gr_passwd","","",0,N],[12,"gr_gid","","",0,N],[12,"gr_mem","","",0,N],[3,"utimbuf","","",N,N],[12,"actime","","",1,N],[12,"modtime","","",1,N],[3,"timeval","","",N,N],[12,"tv_sec","","",2,N],[12,"tv_usec","","",2,N],[3,"timespec","","",N,N],[12,"tv_sec","","",3,N],[12,"tv_nsec","","",3,N],[3,"rlimit","","",N,N],[12,"rlim_cur","","",4,N],[12,"rlim_max","","",4,N],[3,"rusage","","",N,N],[12,"ru_utime","","",5,N],[12,"ru_stime","","",5,N],[12,"ru_maxrss","","",5,N],[12,"ru_ixrss","","",5,N],[12,"ru_idrss","","",5,N],[12,"ru_isrss","","",5,N],[12,"ru_minflt","","",5,N],[12,"ru_majflt","","",5,N],[12,"ru_nswap","","",5,N],[12,"ru_inblock","","",5,N],[12,"ru_oublock","","",5,N],[12,"ru_msgsnd","","",5,N],[12,"ru_msgrcv","","",5,N],[12,"ru_nsignals","","",5,N],[12,"ru_nvcsw","","",5,N],[12,"ru_nivcsw","","",5,N],[3,"in_addr","","",N,N],[12,"s_addr","","",6,N],[3,"in6_addr","","",N,N],[12,"s6_addr","","",7,N],[12,"__align","","",7,N],[3,"ip_mreq","","",N,N],[12,"imr_multiaddr","","",8,N],[12,"imr_interface","","",8,N],[3,"ipv6_mreq","","",N,N],[12,"ipv6mr_multiaddr","","",9,N],[12,"ipv6mr_interface","","",9,N],[3,"hostent","","",N,N],[12,"h_name","","",10,N],[12,"h_aliases","","",10,N],[12,"h_addrtype","","",10,N],[12,"h_length","","",10,N],[12,"h_addr_list","","",10,N],[3,"iovec","","",N,N],[12,"iov_base","","",11,N],[12,"iov_len","","",11,N],[3,"pollfd","","",N,N],[12,"fd","","",12,N],[12,"events","","",12,N],[12,"revents","","",12,N],[3,"winsize","","",N,N],[12,"ws_row","","",13,N],[12,"ws_col","","",13,N],[12,"ws_xpixel","","",13,N],[12,"ws_ypixel","","",13,N],[3,"linger","","",N,N],[12,"l_onoff","","",14,N],[12,"l_linger","","",14,N],[3,"sigval","","",N,N],[12,"sival_ptr","","",15,N],[3,"itimerval","","",N,N],[12,"it_interval","","",16,N],[12,"it_value","","",16,N],[3,"tms","","",N,N],[12,"tms_utime","","",17,N],[12,"tms_stime","","",17,N],[12,"tms_cutime","","",17,N],[12,"tms_cstime","","",17,N],[3,"servent","","",N,N],[12,"s_name","","",18,N],[12,"s_aliases","","",18,N],[12,"s_port","","",18,N],[12,"s_proto","","",18,N],[3,"protoent","","",N,N],[12,"p_name","","",19,N],[12,"p_aliases","","",19,N],[12,"p_proto","","",19,N],[4,"DIR","","",N,N],[4,"locale_t","","",N,N],[5,"getpwnam","","",N,N],[5,"getpwuid","","",N,N],[5,"fprintf","","",N,N],[5,"printf","","",N,N],[5,"snprintf","","",N,N],[5,"sprintf","","",N,N],[5,"fscanf","","",N,N],[5,"scanf","","",N,N],[5,"sscanf","","",N,N],[5,"getchar_unlocked","","",N,N],[5,"putchar_unlocked","","",N,N],[5,"socket","","",N,N],[5,"connect","","",N,N],[5,"listen","","",N,N],[5,"accept","","",N,N],[5,"getpeername","","",N,N],[5,"getsockname","","",N,N],[5,"setsockopt","","",N,N],[5,"socketpair","","",N,N],[5,"sendto","","",N,N],[5,"shutdown","","",N,N],[5,"chmod","","",N,N],[5,"fchmod","","",N,N],[5,"fstat","","",N,N],[5,"mkdir","","",N,N],[5,"stat","","",N,N],[5,"pclose","","",N,N],[5,"fdopen","","",N,N],[5,"fileno","","",N,N],[5,"open","","",N,N],[5,"creat","","",N,N],[5,"fcntl","","",N,N],[5,"opendir","","",N,N],[5,"readdir","","",N,N],[5,"readdir_r","","",N,N],[5,"closedir","","",N,N],[5,"rewinddir","","",N,N],[5,"openat","","",N,N],[5,"fchmodat","","",N,N],[5,"fchown","","",N,N],[5,"fchownat","","",N,N],[5,"fstatat","","",N,N],[5,"linkat","","",N,N],[5,"mkdirat","","",N,N],[5,"readlinkat","","",N,N],[5,"renameat","","",N,N],[5,"symlinkat","","",N,N],[5,"unlinkat","","",N,N],[5,"access","","",N,N],[5,"alarm","","",N,N],[5,"chdir","","",N,N],[5,"fchdir","","",N,N],[5,"chown","","",N,N],[5,"lchown","","",N,N],[5,"close","","",N,N],[5,"dup","","",N,N],[5,"dup2","","",N,N],[5,"execl","","",N,N],[5,"execle","","",N,N],[5,"execlp","","",N,N],[5,"execv","","",N,N],[5,"execve","","",N,N],[5,"execvp","","",N,N],[5,"fork","","",N,N],[5,"fpathconf","","",N,N],[5,"getcwd","","",N,N],[5,"getegid","","",N,N],[5,"geteuid","","",N,N],[5,"getgid","","",N,N],[5,"getgroups","","",N,N],[5,"getlogin","","",N,N],[5,"getopt","","",N,N],[5,"getpgid","","",N,N],[5,"getpgrp","","",N,N],[5,"getpid","","",N,N],[5,"getppid","","",N,N],[5,"getuid","","",N,N],[5,"isatty","","",N,N],[5,"link","","",N,N],[5,"lseek","","",N,N],[5,"pathconf","","",N,N],[5,"pause","","",N,N],[5,"pipe","","",N,N],[5,"posix_memalign","","",N,N],[5,"read","","",N,N],[5,"rmdir","","",N,N],[5,"seteuid","","",N,N],[5,"setgid","","",N,N],[5,"setpgid","","",N,N],[5,"setsid","","",N,N],[5,"setuid","","",N,N],[5,"sleep","","",N,N],[5,"nanosleep","","",N,N],[5,"tcgetpgrp","","",N,N],[5,"tcsetpgrp","","",N,N],[5,"ttyname","","",N,N],[5,"unlink","","",N,N],[5,"wait","","",N,N],[5,"waitpid","","",N,N],[5,"write","","",N,N],[5,"pread","","",N,N],[5,"pwrite","","",N,N],[5,"umask","","",N,N],[5,"utime","","",N,N],[5,"kill","","",N,N],[5,"killpg","","",N,N],[5,"mlock","","",N,N],[5,"munlock","","",N,N],[5,"mlockall","","",N,N],[5,"munlockall","","",N,N],[5,"mmap","","",N,N],[5,"munmap","","",N,N],[5,"if_nametoindex","","",N,N],[5,"if_indextoname","","",N,N],[5,"lstat","","",N,N],[5,"fsync","","",N,N],[5,"setenv","","",N,N],[5,"unsetenv","","",N,N],[5,"symlink","","",N,N],[5,"ftruncate","","",N,N],[5,"signal","","",N,N],[5,"getrlimit","","",N,N],[5,"setrlimit","","",N,N],[5,"getrusage","","",N,N],[5,"realpath","","",N,N],[5,"flock","","",N,N],[5,"gettimeofday","","",N,N],[5,"times","","",N,N],[5,"pthread_self","","",N,N],[5,"pthread_join","","",N,N],[5,"pthread_exit","","",N,N],[5,"pthread_attr_init","","",N,N],[5,"pthread_attr_destroy","","",N,N],[5,"pthread_attr_setstacksize","","",N,N],[5,"pthread_attr_setdetachstate","","",N,N],[5,"pthread_detach","","",N,N],[5,"sched_yield","","",N,N],[5,"pthread_key_create","","",N,N],[5,"pthread_key_delete","","",N,N],[5,"pthread_getspecific","","",N,N],[5,"pthread_setspecific","","",N,N],[5,"pthread_mutex_init","","",N,N],[5,"pthread_mutex_destroy","","",N,N],[5,"pthread_mutex_lock","","",N,N],[5,"pthread_mutex_trylock","","",N,N],[5,"pthread_mutex_unlock","","",N,N],[5,"pthread_mutexattr_init","","",N,N],[5,"pthread_mutexattr_destroy","","",N,N],[5,"pthread_mutexattr_settype","","",N,N],[5,"pthread_cond_init","","",N,N],[5,"pthread_cond_wait","","",N,N],[5,"pthread_cond_timedwait","","",N,N],[5,"pthread_cond_signal","","",N,N],[5,"pthread_cond_broadcast","","",N,N],[5,"pthread_cond_destroy","","",N,N],[5,"pthread_condattr_init","","",N,N],[5,"pthread_condattr_destroy","","",N,N],[5,"pthread_rwlock_init","","",N,N],[5,"pthread_rwlock_destroy","","",N,N],[5,"pthread_rwlock_rdlock","","",N,N],[5,"pthread_rwlock_tryrdlock","","",N,N],[5,"pthread_rwlock_wrlock","","",N,N],[5,"pthread_rwlock_trywrlock","","",N,N],[5,"pthread_rwlock_unlock","","",N,N],[5,"pthread_rwlockattr_init","","",N,N],[5,"pthread_rwlockattr_destroy","","",N,N],[5,"strerror_r","","",N,N],[5,"getsockopt","","",N,N],[5,"raise","","",N,N],[5,"sigaction","","",N,N],[5,"utimes","","",N,N],[5,"dlopen","","",N,N],[5,"dlerror","","",N,N],[5,"dlsym","","",N,N],[5,"dlclose","","",N,N],[5,"dladdr","","",N,N],[5,"getaddrinfo","","",N,N],[5,"freeaddrinfo","","",N,N],[5,"gai_strerror","","",N,N],[5,"res_init","","",N,N],[5,"gmtime_r","","",N,N],[5,"localtime_r","","",N,N],[5,"mktime","","",N,N],[5,"time","","",N,N],[5,"gmtime","","",N,N],[5,"localtime","","",N,N],[5,"difftime","","",N,N],[5,"mknod","","",N,N],[5,"uname","","",N,N],[5,"gethostname","","",N,N],[5,"getservbyname","","",N,N],[5,"getprotobyname","","",N,N],[5,"getprotobynumber","","",N,N],[5,"chroot","","",N,N],[5,"usleep","","",N,N],[5,"send","","",N,N],[5,"recv","","",N,N],[5,"putenv","","",N,N],[5,"poll","","",N,N],[5,"select","","",N,N],[5,"setlocale","","",N,N],[5,"localeconv","","",N,N],[5,"sem_destroy","","",N,N],[5,"sem_wait","","",N,N],[5,"sem_trywait","","",N,N],[5,"sem_post","","",N,N],[5,"sem_init","","",N,N],[5,"statvfs","","",N,N],[5,"fstatvfs","","",N,N],[5,"readlink","","",N,N],[5,"sigemptyset","","",N,N],[5,"sigaddset","","",N,N],[5,"sigfillset","","",N,N],[5,"sigdelset","","",N,N],[5,"sigismember","","",N,N],[5,"sigprocmask","","",N,N],[5,"sigpending","","",N,N],[5,"timegm","","",N,N],[5,"getsid","","",N,N],[5,"sysconf","","",N,N],[5,"mkfifo","","",N,N],[5,"pselect","","",N,N],[5,"fseeko","","",N,N],[5,"ftello","","",N,N],[5,"tcdrain","","",N,N],[5,"cfgetispeed","","",N,N],[5,"cfgetospeed","","",N,N],[5,"cfmakeraw","","",N,N],[5,"cfsetispeed","","",N,N],[5,"cfsetospeed","","",N,N],[5,"cfsetspeed","","",N,N],[5,"tcgetattr","","",N,N],[5,"tcsetattr","","",N,N],[5,"tcflow","","",N,N],[5,"tcflush","","",N,N],[5,"tcgetsid","","",N,N],[5,"tcsendbreak","","",N,N],[5,"mkstemp","","",N,N],[5,"mkdtemp","","",N,N],[5,"tmpnam","","",N,N],[5,"openlog","","",N,N],[5,"closelog","","",N,N],[5,"setlogmask","","",N,N],[5,"syslog","","",N,N],[5,"nice","","",N,N],[5,"grantpt","","",N,N],[5,"posix_openpt","","",N,N],[5,"ptsname","","",N,N],[5,"unlockpt","","",N,N],[0,"notbsd","","",N,N],[3,"sockaddr","libc::unix::notbsd","",N,N],[12,"sa_family","","",20,N],[12,"sa_data","","",20,N],[3,"sockaddr_in","","",N,N],[12,"sin_family","","",21,N],[12,"sin_port","","",21,N],[12,"sin_addr","","",21,N],[12,"sin_zero","","",21,N],[3,"sockaddr_in6","","",N,N],[12,"sin6_family","","",22,N],[12,"sin6_port","","",22,N],[12,"sin6_flowinfo","","",22,N],[12,"sin6_addr","","",22,N],[12,"sin6_scope_id","","",22,N],[3,"sockaddr_un","","",N,N],[12,"sun_family","","",23,N],[12,"sun_path","","",23,N],[3,"sockaddr_storage","","",N,N],[12,"ss_family","","",24,N],[12,"__ss_align","","",24,N],[12,"__ss_pad2","","",24,N],[3,"addrinfo","","",N,N],[12,"ai_flags","","",25,N],[12,"ai_family","","",25,N],[12,"ai_socktype","","",25,N],[12,"ai_protocol","","",25,N],[12,"ai_addrlen","","",25,N],[12,"ai_addr","","",25,N],[12,"ai_canonname","","",25,N],[12,"ai_next","","",25,N],[3,"sockaddr_nl","","",N,N],[12,"nl_family","","",26,N],[12,"nl_pad","","",26,N],[12,"nl_pid","","",26,N],[12,"nl_groups","","",26,N],[3,"sockaddr_ll","","",N,N],[12,"sll_family","","",27,N],[12,"sll_protocol","","",27,N],[12,"sll_ifindex","","",27,N],[12,"sll_hatype","","",27,N],[12,"sll_pkttype","","",27,N],[12,"sll_halen","","",27,N],[12,"sll_addr","","",27,N],[3,"fd_set","","",N,N],[12,"fds_bits","","",28,N],[3,"tm","","",N,N],[12,"tm_sec","","",29,N],[12,"tm_min","","",29,N],[12,"tm_hour","","",29,N],[12,"tm_mday","","",29,N],[12,"tm_mon","","",29,N],[12,"tm_year","","",29,N],[12,"tm_wday","","",29,N],[12,"tm_yday","","",29,N],[12,"tm_isdst","","",29,N],[12,"tm_gmtoff","","",29,N],[12,"tm_zone","","",29,N],[3,"sched_param","","",N,N],[12,"sched_priority","","",30,N],[3,"Dl_info","","",N,N],[12,"dli_fname","","",31,N],[12,"dli_fbase","","",31,N],[12,"dli_sname","","",31,N],[12,"dli_saddr","","",31,N],[3,"epoll_event","","",N,N],[12,"events","","",32,N],[12,"u64","","",32,N],[3,"utsname","","",N,N],[12,"sysname","","",33,N],[12,"nodename","","",33,N],[12,"release","","",33,N],[12,"version","","",33,N],[12,"machine","","",33,N],[12,"domainname","","",33,N],[3,"lconv","","",N,N],[12,"decimal_point","","",34,N],[12,"thousands_sep","","",34,N],[12,"grouping","","",34,N],[12,"int_curr_symbol","","",34,N],[12,"currency_symbol","","",34,N],[12,"mon_decimal_point","","",34,N],[12,"mon_thousands_sep","","",34,N],[12,"mon_grouping","","",34,N],[12,"positive_sign","","",34,N],[12,"negative_sign","","",34,N],[12,"int_frac_digits","","",34,N],[12,"frac_digits","","",34,N],[12,"p_cs_precedes","","",34,N],[12,"p_sep_by_space","","",34,N],[12,"n_cs_precedes","","",34,N],[12,"n_sep_by_space","","",34,N],[12,"p_sign_posn","","",34,N],[12,"n_sign_posn","","",34,N],[12,"int_p_cs_precedes","","",34,N],[12,"int_p_sep_by_space","","",34,N],[12,"int_n_cs_precedes","","",34,N],[12,"int_n_sep_by_space","","",34,N],[12,"int_p_sign_posn","","",34,N],[12,"int_n_sign_posn","","",34,N],[3,"sigevent","","",N,N],[12,"sigev_value","","",35,N],[12,"sigev_signo","","",35,N],[12,"sigev_notify","","",35,N],[12,"sigev_notify_thread_id","","",35,N],[12,"__unused1","","",35,N],[3,"in_pktinfo","","",N,N],[12,"ipi_ifindex","","",36,N],[12,"ipi_spec_dst","","",36,N],[12,"ipi_addr","","",36,N],[3,"ifaddrs","","",N,N],[12,"ifa_next","","",37,N],[12,"ifa_name","","",37,N],[12,"ifa_flags","","",37,N],[12,"ifa_addr","","",37,N],[12,"ifa_netmask","","",37,N],[12,"ifa_ifu","","",37,N],[12,"ifa_data","","",37,N],[3,"in6_rtmsg","","",N,N],[12,"rtmsg_dst","","",38,N],[12,"rtmsg_src","","",38,N],[12,"rtmsg_gateway","","",38,N],[12,"rtmsg_type","","",38,N],[12,"rtmsg_dst_len","","",38,N],[12,"rtmsg_src_len","","",38,N],[12,"rtmsg_metric","","",38,N],[12,"rtmsg_info","","",38,N],[12,"rtmsg_flags","","",38,N],[12,"rtmsg_ifindex","","",38,N],[4,"timezone","","",N,N],[5,"FD_CLR","","",N,N],[5,"FD_ISSET","","",N,N],[5,"FD_SET","","",N,N],[5,"FD_ZERO","","",N,N],[5,"WIFSTOPPED","","",N,[[["c_int"]],["bool"]]],[5,"WSTOPSIG","","",N,[[["c_int"]],["c_int"]]],[5,"WIFCONTINUED","","",N,[[["c_int"]],["bool"]]],[5,"WIFSIGNALED","","",N,[[["c_int"]],["bool"]]],[5,"WTERMSIG","","",N,[[["c_int"]],["c_int"]]],[5,"WIFEXITED","","",N,[[["c_int"]],["bool"]]],[5,"WEXITSTATUS","","",N,[[["c_int"]],["c_int"]]],[5,"WCOREDUMP","","",N,[[["c_int"]],["bool"]]],[5,"QCMD","","",N,[[["c_int"],["c_int"]],["c_int"]]],[5,"IPOPT_COPIED","","",N,[[["u8"]],["u8"]]],[5,"IPOPT_CLASS","","",N,[[["u8"]],["u8"]]],[5,"IPOPT_NUMBER","","",N,[[["u8"]],["u8"]]],[5,"fdatasync","","",N,N],[5,"mincore","","",N,N],[5,"clock_getres","","",N,N],[5,"clock_gettime","","",N,N],[5,"clock_settime","","",N,N],[5,"dirfd","","",N,N],[5,"pthread_getattr_np","","",N,N],[5,"pthread_attr_getstack","","",N,N],[5,"memalign","","",N,N],[5,"setgroups","","",N,N],[5,"pipe2","","",N,N],[5,"statfs","","",N,N],[5,"statfs64","","",N,N],[5,"fstatfs","","",N,N],[5,"fstatfs64","","",N,N],[5,"statvfs64","","",N,N],[5,"fstatvfs64","","",N,N],[5,"memrchr","","",N,N],[5,"posix_fadvise","","",N,N],[5,"futimens","","",N,N],[5,"utimensat","","",N,N],[5,"duplocale","","",N,N],[5,"freelocale","","",N,N],[5,"newlocale","","",N,N],[5,"uselocale","","",N,N],[5,"creat64","","",N,N],[5,"fstat64","","",N,N],[5,"fstatat64","","",N,N],[5,"ftruncate64","","",N,N],[5,"getrlimit64","","",N,N],[5,"lseek64","","",N,N],[5,"lstat64","","",N,N],[5,"mmap64","","",N,N],[5,"open64","","",N,N],[5,"openat64","","",N,N],[5,"pread64","","",N,N],[5,"preadv64","","",N,N],[5,"pwrite64","","",N,N],[5,"pwritev64","","",N,N],[5,"readdir64","","",N,N],[5,"readdir64_r","","",N,N],[5,"setrlimit64","","",N,N],[5,"stat64","","",N,N],[5,"truncate64","","",N,N],[5,"fdopendir","","",N,N],[5,"mknodat","","",N,N],[5,"pthread_condattr_getclock","","",N,N],[5,"pthread_condattr_setclock","","",N,N],[5,"pthread_condattr_setpshared","","",N,N],[5,"accept4","","",N,N],[5,"pthread_mutexattr_setpshared","","",N,N],[5,"pthread_rwlockattr_getpshared","","",N,N],[5,"pthread_rwlockattr_setpshared","","",N,N],[5,"ptsname_r","","",N,N],[5,"clearenv","","",N,N],[5,"waitid","","",N,N],[5,"setreuid","","",N,N],[5,"setregid","","",N,N],[5,"getresuid","","",N,N],[5,"getresgid","","",N,N],[5,"acct","","",N,N],[5,"brk","","",N,N],[5,"sbrk","","",N,N],[5,"vfork","","",N,N],[5,"setresgid","","",N,N],[5,"setresuid","","",N,N],[5,"wait4","","",N,N],[5,"openpty","","",N,N],[5,"execvpe","","",N,N],[5,"fexecve","","",N,N],[5,"getifaddrs","","",N,N],[5,"freeifaddrs","","",N,N],[5,"bind","","",N,N],[5,"writev","","",N,N],[5,"readv","","",N,N],[5,"sendmsg","","",N,N],[5,"recvmsg","","",N,N],[0,"linux","","Linux-specific definitions for linux-like values",N,N],[3,"dirent","libc::unix::notbsd::linux","",N,N],[12,"d_ino","","",39,N],[12,"d_off","","",39,N],[12,"d_reclen","","",39,N],[12,"d_type","","",39,N],[12,"d_name","","",39,N],[3,"dirent64","","",N,N],[12,"d_ino","","",40,N],[12,"d_off","","",40,N],[12,"d_reclen","","",40,N],[12,"d_type","","",40,N],[12,"d_name","","",40,N],[3,"rlimit64","","",N,N],[12,"rlim_cur","","",41,N],[12,"rlim_max","","",41,N],[3,"glob_t","","",N,N],[12,"gl_pathc","","",42,N],[12,"gl_pathv","","",42,N],[12,"gl_offs","","",42,N],[12,"gl_flags","","",42,N],[12,"__unused1","","",42,N],[12,"__unused2","","",42,N],[12,"__unused3","","",42,N],[12,"__unused4","","",42,N],[12,"__unused5","","",42,N],[3,"pthread_mutex_t","","",N,N],[12,"__align","","",43,N],[12,"size","","",43,N],[3,"pthread_rwlock_t","","",N,N],[12,"__align","","",44,N],[12,"size","","",44,N],[3,"pthread_mutexattr_t","","",N,N],[12,"__align","","",45,N],[12,"size","","",45,N],[3,"pthread_rwlockattr_t","","",N,N],[12,"__align","","",46,N],[12,"size","","",46,N],[3,"pthread_cond_t","","",N,N],[12,"__align","","",47,N],[12,"size","","",47,N],[3,"pthread_condattr_t","","",N,N],[12,"__align","","",48,N],[12,"size","","",48,N],[3,"passwd","","",N,N],[12,"pw_name","","",49,N],[12,"pw_passwd","","",49,N],[12,"pw_uid","","",49,N],[12,"pw_gid","","",49,N],[12,"pw_gecos","","",49,N],[12,"pw_dir","","",49,N],[12,"pw_shell","","",49,N],[3,"spwd","","",N,N],[12,"sp_namp","","",50,N],[12,"sp_pwdp","","",50,N],[12,"sp_lstchg","","",50,N],[12,"sp_min","","",50,N],[12,"sp_max","","",50,N],[12,"sp_warn","","",50,N],[12,"sp_inact","","",50,N],[12,"sp_expire","","",50,N],[12,"sp_flag","","",50,N],[3,"dqblk","","",N,N],[12,"dqb_bhardlimit","","",51,N],[12,"dqb_bsoftlimit","","",51,N],[12,"dqb_curspace","","",51,N],[12,"dqb_ihardlimit","","",51,N],[12,"dqb_isoftlimit","","",51,N],[12,"dqb_curinodes","","",51,N],[12,"dqb_btime","","",51,N],[12,"dqb_itime","","",51,N],[12,"dqb_valid","","",51,N],[3,"signalfd_siginfo","","",N,N],[12,"ssi_signo","","",52,N],[12,"ssi_errno","","",52,N],[12,"ssi_code","","",52,N],[12,"ssi_pid","","",52,N],[12,"ssi_uid","","",52,N],[12,"ssi_fd","","",52,N],[12,"ssi_tid","","",52,N],[12,"ssi_band","","",52,N],[12,"ssi_overrun","","",52,N],[12,"ssi_trapno","","",52,N],[12,"ssi_status","","",52,N],[12,"ssi_int","","",52,N],[12,"ssi_ptr","","",52,N],[12,"ssi_utime","","",52,N],[12,"ssi_stime","","",52,N],[12,"ssi_addr","","",52,N],[12,"_pad","","",52,N],[3,"itimerspec","","",N,N],[12,"it_interval","","",53,N],[12,"it_value","","",53,N],[3,"fsid_t","","",N,N],[12,"__val","","",54,N],[3,"mq_attr","","",N,N],[12,"mq_flags","","",55,N],[12,"mq_maxmsg","","",55,N],[12,"mq_msgsize","","",55,N],[12,"mq_curmsgs","","",55,N],[12,"pad","","",55,N],[3,"cpu_set_t","","",N,N],[12,"bits","","",56,N],[3,"if_nameindex","","",N,N],[12,"if_index","","",57,N],[12,"if_name","","",57,N],[3,"msginfo","","",N,N],[12,"msgpool","","",58,N],[12,"msgmap","","",58,N],[12,"msgmax","","",58,N],[12,"msgmnb","","",58,N],[12,"msgmni","","",58,N],[12,"msgssz","","",58,N],[12,"msgtql","","",58,N],[12,"msgseg","","",58,N],[3,"mmsghdr","","",N,N],[12,"msg_hdr","","",59,N],[12,"msg_len","","",59,N],[3,"sembuf","","",N,N],[12,"sem_num","","",60,N],[12,"sem_op","","",60,N],[12,"sem_flg","","",60,N],[3,"input_event","","",N,N],[12,"time","","",61,N],[12,"type_","","",61,N],[12,"code","","",61,N],[12,"value","","",61,N],[3,"input_id","","",N,N],[12,"bustype","","",62,N],[12,"vendor","","",62,N],[12,"product","","",62,N],[12,"version","","",62,N],[3,"input_absinfo","","",N,N],[12,"value","","",63,N],[12,"minimum","","",63,N],[12,"maximum","","",63,N],[12,"fuzz","","",63,N],[12,"flat","","",63,N],[12,"resolution","","",63,N],[3,"input_keymap_entry","","",N,N],[12,"flags","","",64,N],[12,"len","","",64,N],[12,"index","","",64,N],[12,"keycode","","",64,N],[12,"scancode","","",64,N],[3,"input_mask","","",N,N],[12,"type_","","",65,N],[12,"codes_size","","",65,N],[12,"codes_ptr","","",65,N],[3,"ff_replay","","",N,N],[12,"length","","",66,N],[12,"delay","","",66,N],[3,"ff_trigger","","",N,N],[12,"button","","",67,N],[12,"interval","","",67,N],[3,"ff_envelope","","",N,N],[12,"attack_length","","",68,N],[12,"attack_level","","",68,N],[12,"fade_length","","",68,N],[12,"fade_level","","",68,N],[3,"ff_constant_effect","","",N,N],[12,"level","","",69,N],[12,"envelope","","",69,N],[3,"ff_ramp_effect","","",N,N],[12,"start_level","","",70,N],[12,"end_level","","",70,N],[12,"envelope","","",70,N],[3,"ff_condition_effect","","",N,N],[12,"right_saturation","","",71,N],[12,"left_saturation","","",71,N],[12,"right_coeff","","",71,N],[12,"left_coeff","","",71,N],[12,"deadband","","",71,N],[12,"center","","",71,N],[3,"ff_periodic_effect","","",N,N],[12,"waveform","","",72,N],[12,"period","","",72,N],[12,"magnitude","","",72,N],[12,"offset","","",72,N],[12,"phase","","",72,N],[12,"envelope","","",72,N],[12,"custom_len","","",72,N],[12,"custom_data","","",72,N],[3,"ff_rumble_effect","","",N,N],[12,"strong_magnitude","","",73,N],[12,"weak_magnitude","","",73,N],[3,"ff_effect","","",N,N],[12,"type_","","",74,N],[12,"id","","",74,N],[12,"direction","","",74,N],[12,"trigger","","",74,N],[12,"replay","","",74,N],[12,"u","","",74,N],[3,"dl_phdr_info","","",N,N],[12,"dlpi_addr","","",75,N],[12,"dlpi_name","","",75,N],[12,"dlpi_phdr","","",75,N],[12,"dlpi_phnum","","",75,N],[12,"dlpi_adds","","",75,N],[12,"dlpi_subs","","",75,N],[12,"dlpi_tls_modid","","",75,N],[12,"dlpi_tls_data","","",75,N],[3,"Elf32_Phdr","","",N,N],[12,"p_type","","",76,N],[12,"p_offset","","",76,N],[12,"p_vaddr","","",76,N],[12,"p_paddr","","",76,N],[12,"p_filesz","","",76,N],[12,"p_memsz","","",76,N],[12,"p_flags","","",76,N],[12,"p_align","","",76,N],[3,"Elf64_Phdr","","",N,N],[12,"p_type","","",77,N],[12,"p_flags","","",77,N],[12,"p_offset","","",77,N],[12,"p_vaddr","","",77,N],[12,"p_paddr","","",77,N],[12,"p_filesz","","",77,N],[12,"p_memsz","","",77,N],[12,"p_align","","",77,N],[3,"ucred","","",N,N],[12,"pid","","",78,N],[12,"uid","","",78,N],[12,"gid","","",78,N],[3,"mntent","","",N,N],[12,"mnt_fsname","","",79,N],[12,"mnt_dir","","",79,N],[12,"mnt_type","","",79,N],[12,"mnt_opts","","",79,N],[12,"mnt_freq","","",79,N],[12,"mnt_passno","","",79,N],[3,"posix_spawn_file_actions_t","","",N,N],[12,"__allocated","","",80,N],[12,"__used","","",80,N],[12,"__actions","","",80,N],[12,"__pad","","",80,N],[3,"posix_spawnattr_t","","",N,N],[12,"__flags","","",81,N],[12,"__pgrp","","",81,N],[12,"__sd","","",81,N],[12,"__ss","","",81,N],[12,"__sp","","",81,N],[12,"__policy","","",81,N],[12,"__pad","","",81,N],[3,"genlmsghdr","","",N,N],[12,"cmd","","",82,N],[12,"version","","",82,N],[12,"reserved","","",82,N],[3,"in6_pktinfo","","",N,N],[12,"ipi6_addr","","",83,N],[12,"ipi6_ifindex","","",83,N],[4,"fpos64_t","","",N,N],[5,"CPU_ZERO","","",N,N],[5,"CPU_SET","","",N,N],[5,"CPU_CLR","","",N,N],[5,"CPU_ISSET","","",N,[[["usize"],["cpu_set_t"]],["bool"]]],[5,"CPU_EQUAL","","",N,[[["cpu_set_t"],["cpu_set_t"]],["bool"]]],[5,"major","","",N,[[["dev_t"]],["c_uint"]]],[5,"minor","","",N,[[["dev_t"]],["c_uint"]]],[5,"makedev","","",N,[[["c_uint"],["c_uint"]],["dev_t"]]],[5,"IPTOS_TOS","","",N,[[["u8"]],["u8"]]],[5,"IPTOS_PREC","","",N,[[["u8"]],["u8"]]],[5,"RT_TOS","","",N,[[["u8"]],["u8"]]],[5,"RT_ADDRCLASS","","",N,[[["u32"]],["u32"]]],[5,"RT_LOCALADDR","","",N,[[["u32"]],["bool"]]],[5,"aio_read","","",N,N],[5,"aio_write","","",N,N],[5,"aio_fsync","","",N,N],[5,"aio_error","","",N,N],[5,"aio_return","","",N,N],[5,"aio_suspend","","",N,N],[5,"aio_cancel","","",N,N],[5,"lio_listio","","",N,N],[5,"lutimes","","",N,N],[5,"setpwent","","",N,N],[5,"endpwent","","",N,N],[5,"getpwent","","",N,N],[5,"setgrent","","",N,N],[5,"endgrent","","",N,N],[5,"getgrent","","",N,N],[5,"setspent","","",N,N],[5,"endspent","","",N,N],[5,"getspent","","",N,N],[5,"getspnam","","",N,N],[5,"shm_open","","",N,N],[5,"shmget","","",N,N],[5,"shmat","","",N,N],[5,"shmdt","","",N,N],[5,"shmctl","","",N,N],[5,"ftok","","",N,N],[5,"semget","","",N,N],[5,"semop","","",N,N],[5,"semctl","","",N,N],[5,"msgctl","","",N,N],[5,"msgget","","",N,N],[5,"msgrcv","","",N,N],[5,"msgsnd","","",N,N],[5,"mprotect","","",N,N],[5,"__errno_location","","",N,N],[5,"fopen64","","",N,N],[5,"freopen64","","",N,N],[5,"tmpfile64","","",N,N],[5,"fgetpos64","","",N,N],[5,"fsetpos64","","",N,N],[5,"fseeko64","","",N,N],[5,"ftello64","","",N,N],[5,"fallocate","","",N,N],[5,"posix_fallocate","","",N,N],[5,"readahead","","",N,N],[5,"getxattr","","",N,N],[5,"lgetxattr","","",N,N],[5,"fgetxattr","","",N,N],[5,"setxattr","","",N,N],[5,"lsetxattr","","",N,N],[5,"fsetxattr","","",N,N],[5,"listxattr","","",N,N],[5,"llistxattr","","",N,N],[5,"flistxattr","","",N,N],[5,"removexattr","","",N,N],[5,"lremovexattr","","",N,N],[5,"fremovexattr","","",N,N],[5,"signalfd","","",N,N],[5,"timerfd_create","","",N,N],[5,"timerfd_gettime","","",N,N],[5,"timerfd_settime","","",N,N],[5,"pwritev","","",N,N],[5,"preadv","","",N,N],[5,"quotactl","","",N,N],[5,"mq_open","","",N,N],[5,"mq_close","","",N,N],[5,"mq_unlink","","",N,N],[5,"mq_receive","","",N,N],[5,"mq_send","","",N,N],[5,"mq_getattr","","",N,N],[5,"mq_setattr","","",N,N],[5,"epoll_pwait","","",N,N],[5,"dup3","","",N,N],[5,"mkostemp","","",N,N],[5,"mkostemps","","",N,N],[5,"sigtimedwait","","",N,N],[5,"sigwaitinfo","","",N,N],[5,"nl_langinfo_l","","",N,N],[5,"getnameinfo","","",N,N],[5,"pthread_setschedprio","","",N,N],[5,"prlimit","","",N,N],[5,"prlimit64","","",N,N],[5,"getloadavg","","",N,N],[5,"process_vm_readv","","",N,N],[5,"process_vm_writev","","",N,N],[5,"reboot","","",N,N],[5,"setfsgid","","",N,N],[5,"setfsuid","","",N,N],[5,"mkfifoat","","",N,N],[5,"if_nameindex","","",N,N],[5,"if_freenameindex","","",N,N],[5,"sync_file_range","","",N,N],[5,"mremap","","",N,N],[5,"glob","","",N,N],[5,"globfree","","",N,N],[5,"posix_madvise","","",N,N],[5,"shm_unlink","","",N,N],[5,"seekdir","","",N,N],[5,"telldir","","",N,N],[5,"madvise","","",N,N],[5,"msync","","",N,N],[5,"remap_file_pages","","",N,N],[5,"recvfrom","","",N,N],[5,"mkstemps","","",N,N],[5,"futimes","","",N,N],[5,"nl_langinfo","","",N,N],[5,"getdomainname","","",N,N],[5,"setdomainname","","",N,N],[5,"vhangup","","",N,N],[5,"sendmmsg","","",N,N],[5,"recvmmsg","","",N,N],[5,"sync","","",N,N],[5,"syscall","","",N,N],[5,"sched_getaffinity","","",N,N],[5,"sched_setaffinity","","",N,N],[5,"epoll_create","","",N,N],[5,"epoll_create1","","",N,N],[5,"epoll_wait","","",N,N],[5,"epoll_ctl","","",N,N],[5,"pthread_getschedparam","","",N,N],[5,"unshare","","",N,N],[5,"umount","","",N,N],[5,"sched_get_priority_max","","",N,N],[5,"tee","","",N,N],[5,"settimeofday","","",N,N],[5,"splice","","",N,N],[5,"eventfd","","",N,N],[5,"sched_rr_get_interval","","",N,N],[5,"sem_timedwait","","",N,N],[5,"sem_getvalue","","",N,N],[5,"sched_setparam","","",N,N],[5,"setns","","",N,N],[5,"swapoff","","",N,N],[5,"vmsplice","","",N,N],[5,"mount","","",N,N],[5,"personality","","",N,N],[5,"prctl","","",N,N],[5,"sched_getparam","","",N,N],[5,"ppoll","","",N,N],[5,"pthread_mutex_timedlock","","",N,N],[5,"clone","","",N,N],[5,"sched_getscheduler","","",N,N],[5,"clock_nanosleep","","",N,N],[5,"pthread_attr_getguardsize","","",N,N],[5,"sethostname","","",N,N],[5,"sched_get_priority_min","","",N,N],[5,"pthread_condattr_getpshared","","",N,N],[5,"sysinfo","","",N,N],[5,"umount2","","",N,N],[5,"pthread_setschedparam","","",N,N],[5,"swapon","","",N,N],[5,"sched_setscheduler","","",N,N],[5,"sendfile","","",N,N],[5,"sigsuspend","","",N,N],[5,"getgrgid_r","","",N,N],[5,"sigaltstack","","",N,N],[5,"sem_close","","",N,N],[5,"getdtablesize","","",N,N],[5,"getgrnam_r","","",N,N],[5,"initgroups","","",N,N],[5,"pthread_sigmask","","",N,N],[5,"sem_open","","",N,N],[5,"getgrnam","","",N,N],[5,"pthread_cancel","","",N,N],[5,"pthread_kill","","",N,N],[5,"sem_unlink","","",N,N],[5,"daemon","","",N,N],[5,"getpwnam_r","","",N,N],[5,"getpwuid_r","","",N,N],[5,"sigwait","","",N,N],[5,"pthread_atfork","","",N,N],[5,"getgrgid","","",N,N],[5,"getgrouplist","","",N,N],[5,"pthread_mutexattr_getpshared","","",N,N],[5,"popen","","",N,N],[5,"faccessat","","",N,N],[5,"pthread_create","","",N,N],[5,"dl_iterate_phdr","","",N,N],[5,"setmntent","","",N,N],[5,"getmntent","","",N,N],[5,"addmntent","","",N,N],[5,"endmntent","","",N,N],[5,"hasmntopt","","",N,N],[5,"posix_spawn","","",N,N],[5,"posix_spawnp","","",N,N],[5,"posix_spawnattr_init","","",N,N],[5,"posix_spawnattr_destroy","","",N,N],[5,"posix_spawnattr_getsigdefault","","",N,N],[5,"posix_spawnattr_setsigdefault","","",N,N],[5,"posix_spawnattr_getsigmask","","",N,N],[5,"posix_spawnattr_setsigmask","","",N,N],[5,"posix_spawnattr_getflags","","",N,N],[5,"posix_spawnattr_setflags","","",N,N],[5,"posix_spawnattr_getpgroup","","",N,N],[5,"posix_spawnattr_setpgroup","","",N,N],[5,"posix_spawnattr_getschedpolicy","","",N,N],[5,"posix_spawnattr_setschedpolicy","","",N,N],[5,"posix_spawnattr_getschedparam","","",N,N],[5,"posix_spawnattr_setschedparam","","",N,N],[5,"posix_spawn_file_actions_init","","",N,N],[5,"posix_spawn_file_actions_destroy","","",N,N],[5,"posix_spawn_file_actions_addopen","","",N,N],[5,"posix_spawn_file_actions_addclose","","",N,N],[5,"posix_spawn_file_actions_adddup2","","",N,N],[5,"fread_unlocked","","",N,N],[0,"other","","",N,N],[3,"aiocb","libc::unix::notbsd::linux::other","",N,N],[12,"aio_fildes","","",84,N],[12,"aio_lio_opcode","","",84,N],[12,"aio_reqprio","","",84,N],[12,"aio_buf","","",84,N],[12,"aio_nbytes","","",84,N],[12,"aio_sigevent","","",84,N],[12,"__next_prio","","",84,N],[12,"__abs_prio","","",84,N],[12,"__policy","","",84,N],[12,"__error_code","","",84,N],[12,"__return_value","","",84,N],[12,"aio_offset","","",84,N],[12,"__glibc_reserved","","",84,N],[3,"__exit_status","","",N,N],[12,"e_termination","","",85,N],[12,"e_exit","","",85,N],[3,"__timeval","","",N,N],[12,"tv_sec","","",86,N],[12,"tv_usec","","",86,N],[3,"utmpx","","",N,N],[12,"ut_type","","",87,N],[12,"ut_pid","","",87,N],[12,"ut_line","","",87,N],[12,"ut_id","","",87,N],[12,"ut_user","","",87,N],[12,"ut_host","","",87,N],[12,"ut_exit","","",87,N],[12,"ut_session","","",87,N],[12,"ut_tv","","",87,N],[12,"ut_addr_v6","","",87,N],[12,"__glibc_reserved","","",87,N],[3,"sigaction","","",N,N],[12,"sa_sigaction","","",88,N],[12,"sa_mask","","",88,N],[12,"sa_flags","","",88,N],[12,"sa_restorer","","",88,N],[3,"stack_t","","",N,N],[12,"ss_sp","","",89,N],[12,"ss_flags","","",89,N],[12,"ss_size","","",89,N],[3,"siginfo_t","","",N,N],[12,"si_signo","","",90,N],[12,"si_errno","","",90,N],[12,"si_code","","",90,N],[12,"_pad","","",90,N],[12,"_align","","",90,N],[3,"glob64_t","","",N,N],[12,"gl_pathc","","",91,N],[12,"gl_pathv","","",91,N],[12,"gl_offs","","",91,N],[12,"gl_flags","","",91,N],[12,"__unused1","","",91,N],[12,"__unused2","","",91,N],[12,"__unused3","","",91,N],[12,"__unused4","","",91,N],[12,"__unused5","","",91,N],[3,"statfs","","",N,N],[12,"f_type","","",92,N],[12,"f_bsize","","",92,N],[12,"f_blocks","","",92,N],[12,"f_bfree","","",92,N],[12,"f_bavail","","",92,N],[12,"f_files","","",92,N],[12,"f_ffree","","",92,N],[12,"f_fsid","","",92,N],[12,"f_namelen","","",92,N],[12,"f_frsize","","",92,N],[12,"f_spare","","",92,N],[3,"msghdr","","",N,N],[12,"msg_name","","",93,N],[12,"msg_namelen","","",93,N],[12,"msg_iov","","",93,N],[12,"msg_iovlen","","",93,N],[12,"msg_control","","",93,N],[12,"msg_controllen","","",93,N],[12,"msg_flags","","",93,N],[3,"cmsghdr","","",N,N],[12,"cmsg_len","","",94,N],[12,"cmsg_level","","",94,N],[12,"cmsg_type","","",94,N],[3,"termios","","",N,N],[12,"c_iflag","","",95,N],[12,"c_oflag","","",95,N],[12,"c_cflag","","",95,N],[12,"c_lflag","","",95,N],[12,"c_line","","",95,N],[12,"c_cc","","",95,N],[12,"c_ispeed","","",95,N],[12,"c_ospeed","","",95,N],[3,"flock","","",N,N],[12,"l_type","","",96,N],[12,"l_whence","","",96,N],[12,"l_start","","",96,N],[12,"l_len","","",96,N],[12,"l_pid","","",96,N],[3,"sem_t","","",N,N],[12,"__size","","",97,N],[12,"__align","","",97,N],[3,"mallinfo","","",N,N],[12,"arena","","",98,N],[12,"ordblks","","",98,N],[12,"smblks","","",98,N],[12,"hblks","","",98,N],[12,"hblkhd","","",98,N],[12,"usmblks","","",98,N],[12,"fsmblks","","",98,N],[12,"uordblks","","",98,N],[12,"fordblks","","",98,N],[12,"keepcost","","",98,N],[3,"nlmsghdr","","",N,N],[12,"nlmsg_len","","",99,N],[12,"nlmsg_type","","",99,N],[12,"nlmsg_flags","","",99,N],[12,"nlmsg_seq","","",99,N],[12,"nlmsg_pid","","",99,N],[3,"nlmsgerr","","",N,N],[12,"error","","",100,N],[12,"msg","","",100,N],[3,"nl_pktinfo","","",N,N],[12,"group","","",101,N],[3,"nl_mmap_req","","",N,N],[12,"nm_block_size","","",102,N],[12,"nm_block_nr","","",102,N],[12,"nm_frame_size","","",102,N],[12,"nm_frame_nr","","",102,N],[3,"nl_mmap_hdr","","",N,N],[12,"nm_status","","",103,N],[12,"nm_len","","",103,N],[12,"nm_group","","",103,N],[12,"nm_pid","","",103,N],[12,"nm_uid","","",103,N],[12,"nm_gid","","",103,N],[3,"nlattr","","",N,N],[12,"nla_len","","",104,N],[12,"nla_type","","",104,N],[3,"rtentry","","",N,N],[12,"rt_pad1","","",105,N],[12,"rt_dst","","",105,N],[12,"rt_gateway","","",105,N],[12,"rt_genmask","","",105,N],[12,"rt_flags","","",105,N],[12,"rt_pad2","","",105,N],[12,"rt_pad3","","",105,N],[12,"rt_tos","","",105,N],[12,"rt_class","","",105,N],[12,"rt_pad4","","",105,N],[12,"rt_metric","","",105,N],[12,"rt_dev","","",105,N],[12,"rt_mtu","","",105,N],[12,"rt_window","","",105,N],[12,"rt_irtt","","",105,N],[5,"NLA_ALIGN","","",N,[[["c_int"]],["c_int"]]],[5,"utmpxname","","",N,N],[5,"getutxent","","",N,N],[5,"getutxid","","",N,N],[5,"getutxline","","",N,N],[5,"pututxline","","",N,N],[5,"setutxent","","",N,N],[5,"endutxent","","",N,N],[5,"getpt","","",N,N],[5,"ioctl","","",N,N],[5,"backtrace","","",N,N],[5,"glob64","","",N,N],[5,"globfree64","","",N,N],[5,"ptrace","","",N,N],[5,"pthread_attr_getaffinity_np","","",N,N],[5,"pthread_attr_setaffinity_np","","",N,N],[5,"getpriority","","",N,N],[5,"setpriority","","",N,N],[5,"pthread_getaffinity_np","","",N,N],[5,"pthread_setaffinity_np","","",N,N],[5,"pthread_rwlockattr_getkind_np","","",N,N],[5,"pthread_rwlockattr_setkind_np","","",N,N],[5,"sched_getcpu","","",N,N],[5,"mallinfo","","",N,N],[5,"malloc_usable_size","","",N,N],[5,"getauxval","","",N,N],[5,"getpwent_r","","",N,N],[5,"getgrent_r","","",N,N],[0,"b64","","64-bit specific definitions for linux-like values",N,N],[3,"sigset_t","libc::unix::notbsd::linux::other::b64","",N,N],[12,"__val","","",106,N],[3,"sysinfo","","",N,N],[12,"uptime","","",107,N],[12,"loads","","",107,N],[12,"totalram","","",107,N],[12,"freeram","","",107,N],[12,"sharedram","","",107,N],[12,"bufferram","","",107,N],[12,"totalswap","","",107,N],[12,"freeswap","","",107,N],[12,"procs","","",107,N],[12,"pad","","",107,N],[12,"totalhigh","","",107,N],[12,"freehigh","","",107,N],[12,"mem_unit","","",107,N],[12,"_f","","",107,N],[3,"msqid_ds","","",N,N],[12,"msg_perm","","",108,N],[12,"msg_stime","","",108,N],[12,"msg_rtime","","",108,N],[12,"msg_ctime","","",108,N],[12,"__msg_cbytes","","",108,N],[12,"msg_qnum","","",108,N],[12,"msg_qbytes","","",108,N],[12,"msg_lspid","","",108,N],[12,"msg_lrpid","","",108,N],[12,"__glibc_reserved4","","",108,N],[12,"__glibc_reserved5","","",108,N],[0,"x86_64","","x86_64-specific definitions for 64-bit linux-like values",N,N],[3,"stat","libc::unix::notbsd::linux::other::b64::x86_64","",N,N],[12,"st_dev","","",109,N],[12,"st_ino","","",109,N],[12,"st_nlink","","",109,N],[12,"st_mode","","",109,N],[12,"st_uid","","",109,N],[12,"st_gid","","",109,N],[12,"__pad0","","",109,N],[12,"st_rdev","","",109,N],[12,"st_size","","",109,N],[12,"st_blksize","","",109,N],[12,"st_blocks","","",109,N],[12,"st_atime","","",109,N],[12,"st_atime_nsec","","",109,N],[12,"st_mtime","","",109,N],[12,"st_mtime_nsec","","",109,N],[12,"st_ctime","","",109,N],[12,"st_ctime_nsec","","",109,N],[12,"__unused","","",109,N],[3,"stat64","","",N,N],[12,"st_dev","","",110,N],[12,"st_ino","","",110,N],[12,"st_nlink","","",110,N],[12,"st_mode","","",110,N],[12,"st_uid","","",110,N],[12,"st_gid","","",110,N],[12,"__pad0","","",110,N],[12,"st_rdev","","",110,N],[12,"st_size","","",110,N],[12,"st_blksize","","",110,N],[12,"st_blocks","","",110,N],[12,"st_atime","","",110,N],[12,"st_atime_nsec","","",110,N],[12,"st_mtime","","",110,N],[12,"st_mtime_nsec","","",110,N],[12,"st_ctime","","",110,N],[12,"st_ctime_nsec","","",110,N],[12,"__reserved","","",110,N],[3,"statfs64","","",N,N],[12,"f_type","","",111,N],[12,"f_bsize","","",111,N],[12,"f_blocks","","",111,N],[12,"f_bfree","","",111,N],[12,"f_bavail","","",111,N],[12,"f_files","","",111,N],[12,"f_ffree","","",111,N],[12,"f_fsid","","",111,N],[12,"f_namelen","","",111,N],[12,"f_frsize","","",111,N],[12,"f_flags","","",111,N],[12,"f_spare","","",111,N],[3,"statvfs64","","",N,N],[12,"f_bsize","","",112,N],[12,"f_frsize","","",112,N],[12,"f_blocks","","",112,N],[12,"f_bfree","","",112,N],[12,"f_bavail","","",112,N],[12,"f_files","","",112,N],[12,"f_ffree","","",112,N],[12,"f_favail","","",112,N],[12,"f_fsid","","",112,N],[12,"f_flag","","",112,N],[12,"f_namemax","","",112,N],[12,"__f_spare","","",112,N],[3,"pthread_attr_t","","",N,N],[12,"__size","","",113,N],[3,"_libc_fpxreg","","",N,N],[12,"significand","","",114,N],[12,"exponent","","",114,N],[12,"__private","","",114,N],[3,"_libc_xmmreg","","",N,N],[12,"element","","",115,N],[3,"_libc_fpstate","","",N,N],[12,"cwd","","",116,N],[12,"swd","","",116,N],[12,"ftw","","",116,N],[12,"fop","","",116,N],[12,"rip","","",116,N],[12,"rdp","","",116,N],[12,"mxcsr","","",116,N],[12,"mxcr_mask","","",116,N],[12,"_st","","",116,N],[12,"_xmm","","",116,N],[12,"__private","","",116,N],[3,"user_fpregs_struct","","",N,N],[12,"cwd","","",117,N],[12,"swd","","",117,N],[12,"ftw","","",117,N],[12,"fop","","",117,N],[12,"rip","","",117,N],[12,"rdp","","",117,N],[12,"mxcsr","","",117,N],[12,"mxcr_mask","","",117,N],[12,"st_space","","",117,N],[12,"xmm_space","","",117,N],[12,"padding","","",117,N],[3,"user_regs_struct","","",N,N],[12,"r15","","",118,N],[12,"r14","","",118,N],[12,"r13","","",118,N],[12,"r12","","",118,N],[12,"rbp","","",118,N],[12,"rbx","","",118,N],[12,"r11","","",118,N],[12,"r10","","",118,N],[12,"r9","","",118,N],[12,"r8","","",118,N],[12,"rax","","",118,N],[12,"rcx","","",118,N],[12,"rdx","","",118,N],[12,"rsi","","",118,N],[12,"rdi","","",118,N],[12,"orig_rax","","",118,N],[12,"rip","","",118,N],[12,"cs","","",118,N],[12,"eflags","","",118,N],[12,"rsp","","",118,N],[12,"ss","","",118,N],[12,"fs_base","","",118,N],[12,"gs_base","","",118,N],[12,"ds","","",118,N],[12,"es","","",118,N],[12,"fs","","",118,N],[12,"gs","","",118,N],[3,"user","","",N,N],[12,"regs","","",119,N],[12,"u_fpvalid","","",119,N],[12,"i387","","",119,N],[12,"u_tsize","","",119,N],[12,"u_dsize","","",119,N],[12,"u_ssize","","",119,N],[12,"start_code","","",119,N],[12,"start_stack","","",119,N],[12,"signal","","",119,N],[12,"__reserved","","",119,N],[12,"u_ar0","","",119,N],[12,"u_fpstate","","",119,N],[12,"magic","","",119,N],[12,"u_comm","","",119,N],[12,"u_debugreg","","",119,N],[3,"mcontext_t","","",N,N],[12,"gregs","","",120,N],[12,"fpregs","","",120,N],[12,"__private","","",120,N],[3,"ucontext_t","","",N,N],[12,"uc_flags","","",121,N],[12,"uc_link","","",121,N],[12,"uc_stack","","",121,N],[12,"uc_mcontext","","",121,N],[12,"uc_sigmask","","",121,N],[12,"__private","","",121,N],[3,"ipc_perm","","",N,N],[12,"__key","","",122,N],[12,"uid","","",122,N],[12,"gid","","",122,N],[12,"cuid","","",122,N],[12,"cgid","","",122,N],[12,"mode","","",122,N],[12,"__pad1","","",122,N],[12,"__seq","","",122,N],[12,"__pad2","","",122,N],[12,"__unused1","","",122,N],[12,"__unused2","","",122,N],[3,"shmid_ds","","",N,N],[12,"shm_perm","","",123,N],[12,"shm_segsz","","",123,N],[12,"shm_atime","","",123,N],[12,"shm_dtime","","",123,N],[12,"shm_ctime","","",123,N],[12,"shm_cpid","","",123,N],[12,"shm_lpid","","",123,N],[12,"shm_nattch","","",123,N],[12,"__unused4","","",123,N],[12,"__unused5","","",123,N],[3,"termios2","","",N,N],[12,"c_iflag","","",124,N],[12,"c_oflag","","",124,N],[12,"c_cflag","","",124,N],[12,"c_lflag","","",124,N],[12,"c_line","","",124,N],[12,"c_cc","","",124,N],[12,"c_ispeed","","",124,N],[12,"c_ospeed","","",124,N],[5,"getcontext","","",N,N],[5,"setcontext","","",N,N],[5,"makecontext","","",N,N],[5,"swapcontext","","",N,N],[5,"iopl","","",N,N],[5,"ioperm","","",N,N],[6,"c_char","","",N,N],[6,"wchar_t","","",N,N],[6,"nlink_t","","",N,N],[6,"blksize_t","","",N,N],[6,"greg_t","","",N,N],[6,"suseconds_t","","",N,N],[6,"__u64","","",N,N],[17,"TIOCGSOFTCAR","","",N,N],[17,"TIOCSSOFTCAR","","",N,N],[17,"RLIMIT_NOFILE","","",N,N],[17,"RLIMIT_NPROC","","",N,N],[17,"O_APPEND","","",N,N],[17,"O_CREAT","","",N,N],[17,"O_EXCL","","",N,N],[17,"O_NOCTTY","","",N,N],[17,"O_NONBLOCK","","",N,N],[17,"O_SYNC","","",N,N],[17,"O_RSYNC","","",N,N],[17,"O_DSYNC","","",N,N],[17,"O_FSYNC","","",N,N],[17,"O_NOATIME","","",N,N],[17,"O_PATH","","",N,N],[17,"O_TMPFILE","","",N,N],[17,"MAP_GROWSDOWN","","",N,N],[17,"EDEADLK","","",N,N],[17,"ENAMETOOLONG","","",N,N],[17,"ENOLCK","","",N,N],[17,"ENOSYS","","",N,N],[17,"ENOTEMPTY","","",N,N],[17,"ELOOP","","",N,N],[17,"ENOMSG","","",N,N],[17,"EIDRM","","",N,N],[17,"ECHRNG","","",N,N],[17,"EL2NSYNC","","",N,N],[17,"EL3HLT","","",N,N],[17,"EL3RST","","",N,N],[17,"ELNRNG","","",N,N],[17,"EUNATCH","","",N,N],[17,"ENOCSI","","",N,N],[17,"EL2HLT","","",N,N],[17,"EBADE","","",N,N],[17,"EBADR","","",N,N],[17,"EXFULL","","",N,N],[17,"ENOANO","","",N,N],[17,"EBADRQC","","",N,N],[17,"EBADSLT","","",N,N],[17,"EMULTIHOP","","",N,N],[17,"EOVERFLOW","","",N,N],[17,"ENOTUNIQ","","",N,N],[17,"EBADFD","","",N,N],[17,"EBADMSG","","",N,N],[17,"EREMCHG","","",N,N],[17,"ELIBACC","","",N,N],[17,"ELIBBAD","","",N,N],[17,"ELIBSCN","","",N,N],[17,"ELIBMAX","","",N,N],[17,"ELIBEXEC","","",N,N],[17,"EILSEQ","","",N,N],[17,"ERESTART","","",N,N],[17,"ESTRPIPE","","",N,N],[17,"EUSERS","","",N,N],[17,"ENOTSOCK","","",N,N],[17,"EDESTADDRREQ","","",N,N],[17,"EMSGSIZE","","",N,N],[17,"EPROTOTYPE","","",N,N],[17,"ENOPROTOOPT","","",N,N],[17,"EPROTONOSUPPORT","","",N,N],[17,"ESOCKTNOSUPPORT","","",N,N],[17,"EOPNOTSUPP","","",N,N],[17,"EPFNOSUPPORT","","",N,N],[17,"EAFNOSUPPORT","","",N,N],[17,"EADDRINUSE","","",N,N],[17,"EADDRNOTAVAIL","","",N,N],[17,"ENETDOWN","","",N,N],[17,"ENETUNREACH","","",N,N],[17,"ENETRESET","","",N,N],[17,"ECONNABORTED","","",N,N],[17,"ECONNRESET","","",N,N],[17,"ENOBUFS","","",N,N],[17,"EISCONN","","",N,N],[17,"ENOTCONN","","",N,N],[17,"ESHUTDOWN","","",N,N],[17,"ETOOMANYREFS","","",N,N],[17,"ETIMEDOUT","","",N,N],[17,"ECONNREFUSED","","",N,N],[17,"EHOSTDOWN","","",N,N],[17,"EHOSTUNREACH","","",N,N],[17,"EALREADY","","",N,N],[17,"EINPROGRESS","","",N,N],[17,"ESTALE","","",N,N],[17,"EDQUOT","","",N,N],[17,"ENOMEDIUM","","",N,N],[17,"EMEDIUMTYPE","","",N,N],[17,"ECANCELED","","",N,N],[17,"ENOKEY","","",N,N],[17,"EKEYEXPIRED","","",N,N],[17,"EKEYREVOKED","","",N,N],[17,"EKEYREJECTED","","",N,N],[17,"EOWNERDEAD","","",N,N],[17,"ENOTRECOVERABLE","","",N,N],[17,"EHWPOISON","","",N,N],[17,"ERFKILL","","",N,N],[17,"SOL_SOCKET","","",N,N],[17,"SO_REUSEADDR","","",N,N],[17,"SO_TYPE","","",N,N],[17,"SO_ERROR","","",N,N],[17,"SO_DONTROUTE","","",N,N],[17,"SO_BROADCAST","","",N,N],[17,"SO_SNDBUF","","",N,N],[17,"SO_RCVBUF","","",N,N],[17,"SO_SNDBUFFORCE","","",N,N],[17,"SO_RCVBUFFORCE","","",N,N],[17,"SO_KEEPALIVE","","",N,N],[17,"SO_OOBINLINE","","",N,N],[17,"SO_NO_CHECK","","",N,N],[17,"SO_PRIORITY","","",N,N],[17,"SO_LINGER","","",N,N],[17,"SO_BSDCOMPAT","","",N,N],[17,"SO_REUSEPORT","","",N,N],[17,"SO_PASSCRED","","",N,N],[17,"SO_PEERCRED","","",N,N],[17,"SO_RCVLOWAT","","",N,N],[17,"SO_SNDLOWAT","","",N,N],[17,"SO_RCVTIMEO","","",N,N],[17,"SO_SNDTIMEO","","",N,N],[17,"SO_SECURITY_AUTHENTICATION","","",N,N],[17,"SO_SECURITY_ENCRYPTION_TRANSPORT","","",N,N],[17,"SO_SECURITY_ENCRYPTION_NETWORK","","",N,N],[17,"SO_BINDTODEVICE","","",N,N],[17,"SO_ATTACH_FILTER","","",N,N],[17,"SO_DETACH_FILTER","","",N,N],[17,"SO_GET_FILTER","","",N,N],[17,"SO_PEERNAME","","",N,N],[17,"SO_TIMESTAMP","","",N,N],[17,"SO_ACCEPTCONN","","",N,N],[17,"SO_PEERSEC","","",N,N],[17,"SO_PASSSEC","","",N,N],[17,"SO_TIMESTAMPNS","","",N,N],[17,"SCM_TIMESTAMPNS","","",N,N],[17,"SO_MARK","","",N,N],[17,"SO_TIMESTAMPING","","",N,N],[17,"SCM_TIMESTAMPING","","",N,N],[17,"SO_PROTOCOL","","",N,N],[17,"SO_DOMAIN","","",N,N],[17,"SO_RXQ_OVFL","","",N,N],[17,"SO_WIFI_STATUS","","",N,N],[17,"SCM_WIFI_STATUS","","",N,N],[17,"SO_PEEK_OFF","","",N,N],[17,"SO_NOFCS","","",N,N],[17,"SO_LOCK_FILTER","","",N,N],[17,"SO_SELECT_ERR_QUEUE","","",N,N],[17,"SO_BUSY_POLL","","",N,N],[17,"SO_MAX_PACING_RATE","","",N,N],[17,"SO_BPF_EXTENSIONS","","",N,N],[17,"SO_INCOMING_CPU","","",N,N],[17,"SO_ATTACH_BPF","","",N,N],[17,"SO_DETACH_BPF","","",N,N],[17,"SA_ONSTACK","","",N,N],[17,"SA_SIGINFO","","",N,N],[17,"SA_NOCLDWAIT","","",N,N],[17,"SIGCHLD","","",N,N],[17,"SIGBUS","","",N,N],[17,"SIGUSR1","","",N,N],[17,"SIGUSR2","","",N,N],[17,"SIGCONT","","",N,N],[17,"SIGSTOP","","",N,N],[17,"SIGTSTP","","",N,N],[17,"SIGURG","","",N,N],[17,"SIGIO","","",N,N],[17,"SIGSYS","","",N,N],[17,"SIGSTKFLT","","",N,N],[17,"SIGUNUSED","","",N,N],[17,"SIGPOLL","","",N,N],[17,"SIGPWR","","",N,N],[17,"SIG_SETMASK","","",N,N],[17,"SIG_BLOCK","","",N,N],[17,"SIG_UNBLOCK","","",N,N],[17,"POLLWRNORM","","",N,N],[17,"POLLWRBAND","","",N,N],[17,"O_ASYNC","","",N,N],[17,"O_NDELAY","","",N,N],[17,"PTRACE_DETACH","","",N,N],[17,"EFD_NONBLOCK","","",N,N],[17,"F_GETLK","","",N,N],[17,"F_GETOWN","","",N,N],[17,"F_SETOWN","","",N,N],[17,"F_SETLK","","",N,N],[17,"F_SETLKW","","",N,N],[17,"F_RDLCK","","",N,N],[17,"F_WRLCK","","",N,N],[17,"F_UNLCK","","",N,N],[17,"SFD_NONBLOCK","","",N,N],[17,"TIOCEXCL","","",N,N],[17,"TIOCNXCL","","",N,N],[17,"TIOCSCTTY","","",N,N],[17,"TIOCSTI","","",N,N],[17,"TIOCMGET","","",N,N],[17,"TIOCMBIS","","",N,N],[17,"TIOCMBIC","","",N,N],[17,"TIOCMSET","","",N,N],[17,"TIOCCONS","","",N,N],[17,"SFD_CLOEXEC","","",N,N],[17,"NCCS","","",N,N],[17,"O_TRUNC","","",N,N],[17,"O_CLOEXEC","","",N,N],[17,"EBFONT","","",N,N],[17,"ENOSTR","","",N,N],[17,"ENODATA","","",N,N],[17,"ETIME","","",N,N],[17,"ENOSR","","",N,N],[17,"ENONET","","",N,N],[17,"ENOPKG","","",N,N],[17,"EREMOTE","","",N,N],[17,"ENOLINK","","",N,N],[17,"EADV","","",N,N],[17,"ESRMNT","","",N,N],[17,"ECOMM","","",N,N],[17,"EPROTO","","",N,N],[17,"EDOTDOT","","",N,N],[17,"SA_NODEFER","","",N,N],[17,"SA_RESETHAND","","",N,N],[17,"SA_RESTART","","",N,N],[17,"SA_NOCLDSTOP","","",N,N],[17,"EPOLL_CLOEXEC","","",N,N],[17,"EFD_CLOEXEC","","",N,N],[17,"__SIZEOF_PTHREAD_CONDATTR_T","","",N,N],[17,"__SIZEOF_PTHREAD_MUTEXATTR_T","","",N,N],[17,"O_DIRECT","","",N,N],[17,"O_DIRECTORY","","",N,N],[17,"O_NOFOLLOW","","",N,N],[17,"MAP_LOCKED","","",N,N],[17,"MAP_NORESERVE","","",N,N],[17,"MAP_32BIT","","",N,N],[17,"EDEADLOCK","","",N,N],[17,"FIOCLEX","","",N,N],[17,"FIONBIO","","",N,N],[17,"PTRACE_GETFPREGS","","",N,N],[17,"PTRACE_SETFPREGS","","",N,N],[17,"PTRACE_GETFPXREGS","","",N,N],[17,"PTRACE_SETFPXREGS","","",N,N],[17,"PTRACE_GETREGS","","",N,N],[17,"PTRACE_SETREGS","","",N,N],[17,"PTRACE_PEEKSIGINFO_SHARED","","",N,N],[17,"MCL_CURRENT","","",N,N],[17,"MCL_FUTURE","","",N,N],[17,"SIGSTKSZ","","",N,N],[17,"MINSIGSTKSZ","","",N,N],[17,"CBAUD","","",N,N],[17,"TAB1","","",N,N],[17,"TAB2","","",N,N],[17,"TAB3","","",N,N],[17,"CR1","","",N,N],[17,"CR2","","",N,N],[17,"CR3","","",N,N],[17,"FF1","","",N,N],[17,"BS1","","",N,N],[17,"VT1","","",N,N],[17,"VWERASE","","",N,N],[17,"VREPRINT","","",N,N],[17,"VSUSP","","",N,N],[17,"VSTART","","",N,N],[17,"VSTOP","","",N,N],[17,"VDISCARD","","",N,N],[17,"VTIME","","",N,N],[17,"IXON","","",N,N],[17,"IXOFF","","",N,N],[17,"ONLCR","","",N,N],[17,"CSIZE","","",N,N],[17,"CS6","","",N,N],[17,"CS7","","",N,N],[17,"CS8","","",N,N],[17,"CSTOPB","","",N,N],[17,"CREAD","","",N,N],[17,"PARENB","","",N,N],[17,"PARODD","","",N,N],[17,"HUPCL","","",N,N],[17,"CLOCAL","","",N,N],[17,"ECHOKE","","",N,N],[17,"ECHOE","","",N,N],[17,"ECHOK","","",N,N],[17,"ECHONL","","",N,N],[17,"ECHOPRT","","",N,N],[17,"ECHOCTL","","",N,N],[17,"ISIG","","",N,N],[17,"ICANON","","",N,N],[17,"PENDIN","","",N,N],[17,"NOFLSH","","",N,N],[17,"CIBAUD","","",N,N],[17,"CBAUDEX","","",N,N],[17,"VSWTC","","",N,N],[17,"OLCUC","","",N,N],[17,"NLDLY","","",N,N],[17,"CRDLY","","",N,N],[17,"TABDLY","","",N,N],[17,"BSDLY","","",N,N],[17,"FFDLY","","",N,N],[17,"VTDLY","","",N,N],[17,"XTABS","","",N,N],[17,"B0","","",N,N],[17,"B50","","",N,N],[17,"B75","","",N,N],[17,"B110","","",N,N],[17,"B134","","",N,N],[17,"B150","","",N,N],[17,"B200","","",N,N],[17,"B300","","",N,N],[17,"B600","","",N,N],[17,"B1200","","",N,N],[17,"B1800","","",N,N],[17,"B2400","","",N,N],[17,"B4800","","",N,N],[17,"B9600","","",N,N],[17,"B19200","","",N,N],[17,"B38400","","",N,N],[17,"EXTA","","",N,N],[17,"EXTB","","",N,N],[17,"BOTHER","","",N,N],[17,"B57600","","",N,N],[17,"B115200","","",N,N],[17,"B230400","","",N,N],[17,"B460800","","",N,N],[17,"B500000","","",N,N],[17,"B576000","","",N,N],[17,"B921600","","",N,N],[17,"B1000000","","",N,N],[17,"B1152000","","",N,N],[17,"B1500000","","",N,N],[17,"B2000000","","",N,N],[17,"B2500000","","",N,N],[17,"B3000000","","",N,N],[17,"B3500000","","",N,N],[17,"B4000000","","",N,N],[17,"VEOL","","",N,N],[17,"VEOL2","","",N,N],[17,"VMIN","","",N,N],[17,"IEXTEN","","",N,N],[17,"TOSTOP","","",N,N],[17,"FLUSHO","","",N,N],[17,"EXTPROC","","",N,N],[17,"TCGETS","","",N,N],[17,"TCSETS","","",N,N],[17,"TCSETSW","","",N,N],[17,"TCSETSF","","",N,N],[17,"TCGETA","","",N,N],[17,"TCSETA","","",N,N],[17,"TCSETAW","","",N,N],[17,"TCSETAF","","",N,N],[17,"TCSBRK","","",N,N],[17,"TCXONC","","",N,N],[17,"TCFLSH","","",N,N],[17,"TIOCINQ","","",N,N],[17,"TIOCGPGRP","","",N,N],[17,"TIOCSPGRP","","",N,N],[17,"TIOCOUTQ","","",N,N],[17,"TIOCGWINSZ","","",N,N],[17,"TIOCSWINSZ","","",N,N],[17,"FIONREAD","","",N,N],[17,"R15","","",N,N],[17,"R14","","",N,N],[17,"R13","","",N,N],[17,"R12","","",N,N],[17,"RBP","","",N,N],[17,"RBX","","",N,N],[17,"R11","","",N,N],[17,"R10","","",N,N],[17,"R9","","",N,N],[17,"R8","","",N,N],[17,"RAX","","",N,N],[17,"RCX","","",N,N],[17,"RDX","","",N,N],[17,"RSI","","",N,N],[17,"RDI","","",N,N],[17,"ORIG_RAX","","",N,N],[17,"RIP","","",N,N],[17,"CS","","",N,N],[17,"EFLAGS","","",N,N],[17,"RSP","","",N,N],[17,"SS","","",N,N],[17,"FS_BASE","","",N,N],[17,"GS_BASE","","",N,N],[17,"DS","","",N,N],[17,"ES","","",N,N],[17,"FS","","",N,N],[17,"GS","","",N,N],[11,"clone","libc","",109,[[["self"]],["stat"]]],[11,"clone","","",110,[[["self"]],["stat64"]]],[11,"clone","","",111,[[["self"]],["statfs64"]]],[11,"clone","","",112,[[["self"]],["statvfs64"]]],[11,"clone","","",113,[[["self"]],["pthread_attr_t"]]],[11,"clone","","",114,[[["self"]],["_libc_fpxreg"]]],[11,"clone","","",115,[[["self"]],["_libc_xmmreg"]]],[11,"clone","","",116,[[["self"]],["_libc_fpstate"]]],[11,"clone","","",117,[[["self"]],["user_fpregs_struct"]]],[11,"clone","","",118,[[["self"]],["user_regs_struct"]]],[11,"clone","","",119,[[["self"]],["user"]]],[11,"clone","","",120,[[["self"]],["mcontext_t"]]],[11,"clone","","",121,[[["self"]],["ucontext_t"]]],[11,"clone","","",122,[[["self"]],["ipc_perm"]]],[11,"clone","","",123,[[["self"]],["shmid_ds"]]],[11,"clone","","",124,[[["self"]],["termios2"]]],[0,"not_x32","libc::unix::notbsd::linux::other::b64","",N,N],[3,"statvfs","libc::unix::notbsd::linux::other::b64::not_x32","",N,N],[12,"f_bsize","","",125,N],[12,"f_frsize","","",125,N],[12,"f_blocks","","",125,N],[12,"f_bfree","","",125,N],[12,"f_bavail","","",125,N],[12,"f_files","","",125,N],[12,"f_ffree","","",125,N],[12,"f_favail","","",125,N],[12,"f_fsid","","",125,N],[12,"f_flag","","",125,N],[12,"f_namemax","","",125,N],[12,"__f_spare","","",125,N],[5,"sysctl","","",N,N],[6,"c_long","","",N,N],[6,"c_ulong","","",N,N],[17,"__SIZEOF_PTHREAD_MUTEX_T","","",N,N],[17,"__SIZEOF_PTHREAD_RWLOCK_T","","",N,N],[17,"PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP","","",N,N],[17,"PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP","","",N,N],[17,"PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP","","",N,N],[17,"SYS_read","","",N,N],[17,"SYS_write","","",N,N],[17,"SYS_open","","",N,N],[17,"SYS_close","","",N,N],[17,"SYS_stat","","",N,N],[17,"SYS_fstat","","",N,N],[17,"SYS_lstat","","",N,N],[17,"SYS_poll","","",N,N],[17,"SYS_lseek","","",N,N],[17,"SYS_mmap","","",N,N],[17,"SYS_mprotect","","",N,N],[17,"SYS_munmap","","",N,N],[17,"SYS_brk","","",N,N],[17,"SYS_rt_sigaction","","",N,N],[17,"SYS_rt_sigprocmask","","",N,N],[17,"SYS_rt_sigreturn","","",N,N],[17,"SYS_ioctl","","",N,N],[17,"SYS_pread64","","",N,N],[17,"SYS_pwrite64","","",N,N],[17,"SYS_readv","","",N,N],[17,"SYS_writev","","",N,N],[17,"SYS_access","","",N,N],[17,"SYS_pipe","","",N,N],[17,"SYS_select","","",N,N],[17,"SYS_sched_yield","","",N,N],[17,"SYS_mremap","","",N,N],[17,"SYS_msync","","",N,N],[17,"SYS_mincore","","",N,N],[17,"SYS_madvise","","",N,N],[17,"SYS_shmget","","",N,N],[17,"SYS_shmat","","",N,N],[17,"SYS_shmctl","","",N,N],[17,"SYS_dup","","",N,N],[17,"SYS_dup2","","",N,N],[17,"SYS_pause","","",N,N],[17,"SYS_nanosleep","","",N,N],[17,"SYS_getitimer","","",N,N],[17,"SYS_alarm","","",N,N],[17,"SYS_setitimer","","",N,N],[17,"SYS_getpid","","",N,N],[17,"SYS_sendfile","","",N,N],[17,"SYS_socket","","",N,N],[17,"SYS_connect","","",N,N],[17,"SYS_accept","","",N,N],[17,"SYS_sendto","","",N,N],[17,"SYS_recvfrom","","",N,N],[17,"SYS_sendmsg","","",N,N],[17,"SYS_recvmsg","","",N,N],[17,"SYS_shutdown","","",N,N],[17,"SYS_bind","","",N,N],[17,"SYS_listen","","",N,N],[17,"SYS_getsockname","","",N,N],[17,"SYS_getpeername","","",N,N],[17,"SYS_socketpair","","",N,N],[17,"SYS_setsockopt","","",N,N],[17,"SYS_getsockopt","","",N,N],[17,"SYS_clone","","",N,N],[17,"SYS_fork","","",N,N],[17,"SYS_vfork","","",N,N],[17,"SYS_execve","","",N,N],[17,"SYS_exit","","",N,N],[17,"SYS_wait4","","",N,N],[17,"SYS_kill","","",N,N],[17,"SYS_uname","","",N,N],[17,"SYS_semget","","",N,N],[17,"SYS_semop","","",N,N],[17,"SYS_semctl","","",N,N],[17,"SYS_shmdt","","",N,N],[17,"SYS_msgget","","",N,N],[17,"SYS_msgsnd","","",N,N],[17,"SYS_msgrcv","","",N,N],[17,"SYS_msgctl","","",N,N],[17,"SYS_fcntl","","",N,N],[17,"SYS_flock","","",N,N],[17,"SYS_fsync","","",N,N],[17,"SYS_fdatasync","","",N,N],[17,"SYS_truncate","","",N,N],[17,"SYS_ftruncate","","",N,N],[17,"SYS_getdents","","",N,N],[17,"SYS_getcwd","","",N,N],[17,"SYS_chdir","","",N,N],[17,"SYS_fchdir","","",N,N],[17,"SYS_rename","","",N,N],[17,"SYS_mkdir","","",N,N],[17,"SYS_rmdir","","",N,N],[17,"SYS_creat","","",N,N],[17,"SYS_link","","",N,N],[17,"SYS_unlink","","",N,N],[17,"SYS_symlink","","",N,N],[17,"SYS_readlink","","",N,N],[17,"SYS_chmod","","",N,N],[17,"SYS_fchmod","","",N,N],[17,"SYS_chown","","",N,N],[17,"SYS_fchown","","",N,N],[17,"SYS_lchown","","",N,N],[17,"SYS_umask","","",N,N],[17,"SYS_gettimeofday","","",N,N],[17,"SYS_getrlimit","","",N,N],[17,"SYS_getrusage","","",N,N],[17,"SYS_sysinfo","","",N,N],[17,"SYS_times","","",N,N],[17,"SYS_ptrace","","",N,N],[17,"SYS_getuid","","",N,N],[17,"SYS_syslog","","",N,N],[17,"SYS_getgid","","",N,N],[17,"SYS_setuid","","",N,N],[17,"SYS_setgid","","",N,N],[17,"SYS_geteuid","","",N,N],[17,"SYS_getegid","","",N,N],[17,"SYS_setpgid","","",N,N],[17,"SYS_getppid","","",N,N],[17,"SYS_getpgrp","","",N,N],[17,"SYS_setsid","","",N,N],[17,"SYS_setreuid","","",N,N],[17,"SYS_setregid","","",N,N],[17,"SYS_getgroups","","",N,N],[17,"SYS_setgroups","","",N,N],[17,"SYS_setresuid","","",N,N],[17,"SYS_getresuid","","",N,N],[17,"SYS_setresgid","","",N,N],[17,"SYS_getresgid","","",N,N],[17,"SYS_getpgid","","",N,N],[17,"SYS_setfsuid","","",N,N],[17,"SYS_setfsgid","","",N,N],[17,"SYS_getsid","","",N,N],[17,"SYS_capget","","",N,N],[17,"SYS_capset","","",N,N],[17,"SYS_rt_sigpending","","",N,N],[17,"SYS_rt_sigtimedwait","","",N,N],[17,"SYS_rt_sigqueueinfo","","",N,N],[17,"SYS_rt_sigsuspend","","",N,N],[17,"SYS_sigaltstack","","",N,N],[17,"SYS_utime","","",N,N],[17,"SYS_mknod","","",N,N],[17,"SYS_uselib","","",N,N],[17,"SYS_personality","","",N,N],[17,"SYS_ustat","","",N,N],[17,"SYS_statfs","","",N,N],[17,"SYS_fstatfs","","",N,N],[17,"SYS_sysfs","","",N,N],[17,"SYS_getpriority","","",N,N],[17,"SYS_setpriority","","",N,N],[17,"SYS_sched_setparam","","",N,N],[17,"SYS_sched_getparam","","",N,N],[17,"SYS_sched_setscheduler","","",N,N],[17,"SYS_sched_getscheduler","","",N,N],[17,"SYS_sched_get_priority_max","","",N,N],[17,"SYS_sched_get_priority_min","","",N,N],[17,"SYS_sched_rr_get_interval","","",N,N],[17,"SYS_mlock","","",N,N],[17,"SYS_munlock","","",N,N],[17,"SYS_mlockall","","",N,N],[17,"SYS_munlockall","","",N,N],[17,"SYS_vhangup","","",N,N],[17,"SYS_modify_ldt","","",N,N],[17,"SYS_pivot_root","","",N,N],[17,"SYS__sysctl","","",N,N],[17,"SYS_prctl","","",N,N],[17,"SYS_arch_prctl","","",N,N],[17,"SYS_adjtimex","","",N,N],[17,"SYS_setrlimit","","",N,N],[17,"SYS_chroot","","",N,N],[17,"SYS_sync","","",N,N],[17,"SYS_acct","","",N,N],[17,"SYS_settimeofday","","",N,N],[17,"SYS_mount","","",N,N],[17,"SYS_umount2","","",N,N],[17,"SYS_swapon","","",N,N],[17,"SYS_swapoff","","",N,N],[17,"SYS_reboot","","",N,N],[17,"SYS_sethostname","","",N,N],[17,"SYS_setdomainname","","",N,N],[17,"SYS_iopl","","",N,N],[17,"SYS_ioperm","","",N,N],[17,"SYS_create_module","","",N,N],[17,"SYS_init_module","","",N,N],[17,"SYS_delete_module","","",N,N],[17,"SYS_get_kernel_syms","","",N,N],[17,"SYS_query_module","","",N,N],[17,"SYS_quotactl","","",N,N],[17,"SYS_nfsservctl","","",N,N],[17,"SYS_getpmsg","","",N,N],[17,"SYS_putpmsg","","",N,N],[17,"SYS_afs_syscall","","",N,N],[17,"SYS_tuxcall","","",N,N],[17,"SYS_security","","",N,N],[17,"SYS_gettid","","",N,N],[17,"SYS_readahead","","",N,N],[17,"SYS_setxattr","","",N,N],[17,"SYS_lsetxattr","","",N,N],[17,"SYS_fsetxattr","","",N,N],[17,"SYS_getxattr","","",N,N],[17,"SYS_lgetxattr","","",N,N],[17,"SYS_fgetxattr","","",N,N],[17,"SYS_listxattr","","",N,N],[17,"SYS_llistxattr","","",N,N],[17,"SYS_flistxattr","","",N,N],[17,"SYS_removexattr","","",N,N],[17,"SYS_lremovexattr","","",N,N],[17,"SYS_fremovexattr","","",N,N],[17,"SYS_tkill","","",N,N],[17,"SYS_time","","",N,N],[17,"SYS_futex","","",N,N],[17,"SYS_sched_setaffinity","","",N,N],[17,"SYS_sched_getaffinity","","",N,N],[17,"SYS_set_thread_area","","",N,N],[17,"SYS_io_setup","","",N,N],[17,"SYS_io_destroy","","",N,N],[17,"SYS_io_getevents","","",N,N],[17,"SYS_io_submit","","",N,N],[17,"SYS_io_cancel","","",N,N],[17,"SYS_get_thread_area","","",N,N],[17,"SYS_lookup_dcookie","","",N,N],[17,"SYS_epoll_create","","",N,N],[17,"SYS_epoll_ctl_old","","",N,N],[17,"SYS_epoll_wait_old","","",N,N],[17,"SYS_remap_file_pages","","",N,N],[17,"SYS_getdents64","","",N,N],[17,"SYS_set_tid_address","","",N,N],[17,"SYS_restart_syscall","","",N,N],[17,"SYS_semtimedop","","",N,N],[17,"SYS_fadvise64","","",N,N],[17,"SYS_timer_create","","",N,N],[17,"SYS_timer_settime","","",N,N],[17,"SYS_timer_gettime","","",N,N],[17,"SYS_timer_getoverrun","","",N,N],[17,"SYS_timer_delete","","",N,N],[17,"SYS_clock_settime","","",N,N],[17,"SYS_clock_gettime","","",N,N],[17,"SYS_clock_getres","","",N,N],[17,"SYS_clock_nanosleep","","",N,N],[17,"SYS_exit_group","","",N,N],[17,"SYS_epoll_wait","","",N,N],[17,"SYS_epoll_ctl","","",N,N],[17,"SYS_tgkill","","",N,N],[17,"SYS_utimes","","",N,N],[17,"SYS_vserver","","",N,N],[17,"SYS_mbind","","",N,N],[17,"SYS_set_mempolicy","","",N,N],[17,"SYS_get_mempolicy","","",N,N],[17,"SYS_mq_open","","",N,N],[17,"SYS_mq_unlink","","",N,N],[17,"SYS_mq_timedsend","","",N,N],[17,"SYS_mq_timedreceive","","",N,N],[17,"SYS_mq_notify","","",N,N],[17,"SYS_mq_getsetattr","","",N,N],[17,"SYS_kexec_load","","",N,N],[17,"SYS_waitid","","",N,N],[17,"SYS_add_key","","",N,N],[17,"SYS_request_key","","",N,N],[17,"SYS_keyctl","","",N,N],[17,"SYS_ioprio_set","","",N,N],[17,"SYS_ioprio_get","","",N,N],[17,"SYS_inotify_init","","",N,N],[17,"SYS_inotify_add_watch","","",N,N],[17,"SYS_inotify_rm_watch","","",N,N],[17,"SYS_migrate_pages","","",N,N],[17,"SYS_openat","","",N,N],[17,"SYS_mkdirat","","",N,N],[17,"SYS_mknodat","","",N,N],[17,"SYS_fchownat","","",N,N],[17,"SYS_futimesat","","",N,N],[17,"SYS_newfstatat","","",N,N],[17,"SYS_unlinkat","","",N,N],[17,"SYS_renameat","","",N,N],[17,"SYS_linkat","","",N,N],[17,"SYS_symlinkat","","",N,N],[17,"SYS_readlinkat","","",N,N],[17,"SYS_fchmodat","","",N,N],[17,"SYS_faccessat","","",N,N],[17,"SYS_pselect6","","",N,N],[17,"SYS_ppoll","","",N,N],[17,"SYS_unshare","","",N,N],[17,"SYS_set_robust_list","","",N,N],[17,"SYS_get_robust_list","","",N,N],[17,"SYS_splice","","",N,N],[17,"SYS_tee","","",N,N],[17,"SYS_sync_file_range","","",N,N],[17,"SYS_vmsplice","","",N,N],[17,"SYS_move_pages","","",N,N],[17,"SYS_utimensat","","",N,N],[17,"SYS_epoll_pwait","","",N,N],[17,"SYS_signalfd","","",N,N],[17,"SYS_timerfd_create","","",N,N],[17,"SYS_eventfd","","",N,N],[17,"SYS_fallocate","","",N,N],[17,"SYS_timerfd_settime","","",N,N],[17,"SYS_timerfd_gettime","","",N,N],[17,"SYS_accept4","","",N,N],[17,"SYS_signalfd4","","",N,N],[17,"SYS_eventfd2","","",N,N],[17,"SYS_epoll_create1","","",N,N],[17,"SYS_dup3","","",N,N],[17,"SYS_pipe2","","",N,N],[17,"SYS_inotify_init1","","",N,N],[17,"SYS_preadv","","",N,N],[17,"SYS_pwritev","","",N,N],[17,"SYS_rt_tgsigqueueinfo","","",N,N],[17,"SYS_perf_event_open","","",N,N],[17,"SYS_recvmmsg","","",N,N],[17,"SYS_fanotify_init","","",N,N],[17,"SYS_fanotify_mark","","",N,N],[17,"SYS_prlimit64","","",N,N],[17,"SYS_name_to_handle_at","","",N,N],[17,"SYS_open_by_handle_at","","",N,N],[17,"SYS_clock_adjtime","","",N,N],[17,"SYS_syncfs","","",N,N],[17,"SYS_sendmmsg","","",N,N],[17,"SYS_setns","","",N,N],[17,"SYS_getcpu","","",N,N],[17,"SYS_process_vm_readv","","",N,N],[17,"SYS_process_vm_writev","","",N,N],[17,"SYS_kcmp","","",N,N],[17,"SYS_finit_module","","",N,N],[17,"SYS_sched_setattr","","",N,N],[17,"SYS_sched_getattr","","",N,N],[17,"SYS_renameat2","","",N,N],[17,"SYS_seccomp","","",N,N],[17,"SYS_getrandom","","",N,N],[17,"SYS_memfd_create","","",N,N],[17,"SYS_kexec_file_load","","",N,N],[17,"SYS_bpf","","",N,N],[17,"SYS_execveat","","",N,N],[17,"SYS_userfaultfd","","",N,N],[17,"SYS_membarrier","","",N,N],[17,"SYS_mlock2","","",N,N],[17,"SYS_copy_file_range","","",N,N],[17,"SYS_preadv2","","",N,N],[17,"SYS_pwritev2","","",N,N],[17,"SYS_pkey_mprotect","","",N,N],[17,"SYS_pkey_alloc","","",N,N],[17,"SYS_pkey_free","","",N,N],[11,"clone","libc","",125,[[["self"]],["statvfs"]]],[6,"clock_t","libc::unix::notbsd::linux::other::b64","",N,N],[6,"time_t","","",N,N],[6,"ino_t","","",N,N],[6,"off_t","","",N,N],[6,"blkcnt_t","","",N,N],[6,"__fsword_t","","",N,N],[6,"shmatt_t","","",N,N],[6,"msgqnum_t","","",N,N],[6,"msglen_t","","",N,N],[6,"fsblkcnt_t","","",N,N],[6,"fsfilcnt_t","","",N,N],[6,"rlim_t","","",N,N],[17,"__SIZEOF_PTHREAD_RWLOCKATTR_T","","",N,N],[17,"O_LARGEFILE","","",N,N],[11,"clone","libc","",106,[[["self"]],["sigset_t"]]],[11,"clone","","",107,[[["self"]],["sysinfo"]]],[11,"clone","","",108,[[["self"]],["msqid_ds"]]],[6,"__priority_which_t","libc::unix::notbsd::linux::other","",N,N],[17,"__UT_LINESIZE","","",N,N],[17,"__UT_NAMESIZE","","",N,N],[17,"__UT_HOSTSIZE","","",N,N],[17,"EMPTY","","",N,N],[17,"RUN_LVL","","",N,N],[17,"BOOT_TIME","","",N,N],[17,"NEW_TIME","","",N,N],[17,"OLD_TIME","","",N,N],[17,"INIT_PROCESS","","",N,N],[17,"LOGIN_PROCESS","","",N,N],[17,"USER_PROCESS","","",N,N],[17,"DEAD_PROCESS","","",N,N],[17,"ACCOUNTING","","",N,N],[17,"RLIMIT_RSS","","",N,N],[17,"RLIMIT_AS","","",N,N],[17,"RLIMIT_MEMLOCK","","",N,N],[17,"RLIM_INFINITY","","",N,N],[17,"RLIMIT_RTTIME","","",N,N],[17,"RLIMIT_NLIMITS","","",N,N],[17,"SOCK_NONBLOCK","","",N,N],[17,"SOL_RXRPC","","",N,N],[17,"SOL_PPPOL2TP","","",N,N],[17,"SOL_BLUETOOTH","","",N,N],[17,"SOL_PNPIPE","","",N,N],[17,"SOL_RDS","","",N,N],[17,"SOL_IUCV","","",N,N],[17,"SOL_CAIF","","",N,N],[17,"SOL_ALG","","",N,N],[17,"SOL_NFC","","",N,N],[17,"MSG_TRYHARD","","",N,N],[17,"LC_PAPER","","",N,N],[17,"LC_NAME","","",N,N],[17,"LC_ADDRESS","","",N,N],[17,"LC_TELEPHONE","","",N,N],[17,"LC_MEASUREMENT","","",N,N],[17,"LC_IDENTIFICATION","","",N,N],[17,"LC_PAPER_MASK","","",N,N],[17,"LC_NAME_MASK","","",N,N],[17,"LC_ADDRESS_MASK","","",N,N],[17,"LC_TELEPHONE_MASK","","",N,N],[17,"LC_MEASUREMENT_MASK","","",N,N],[17,"LC_IDENTIFICATION_MASK","","",N,N],[17,"LC_ALL_MASK","","",N,N],[17,"MAP_ANON","","",N,N],[17,"MAP_ANONYMOUS","","",N,N],[17,"MAP_DENYWRITE","","",N,N],[17,"MAP_EXECUTABLE","","",N,N],[17,"MAP_POPULATE","","",N,N],[17,"MAP_NONBLOCK","","",N,N],[17,"MAP_STACK","","",N,N],[17,"ENOTSUP","","",N,N],[17,"EUCLEAN","","",N,N],[17,"ENOTNAM","","",N,N],[17,"ENAVAIL","","",N,N],[17,"EISNAM","","",N,N],[17,"EREMOTEIO","","",N,N],[17,"SOCK_STREAM","","",N,N],[17,"SOCK_DGRAM","","",N,N],[17,"SOCK_SEQPACKET","","",N,N],[17,"SOCK_DCCP","","",N,N],[17,"SOCK_PACKET","","",N,N],[17,"TCP_COOKIE_TRANSACTIONS","","",N,N],[17,"TCP_THIN_LINEAR_TIMEOUTS","","",N,N],[17,"TCP_THIN_DUPACK","","",N,N],[17,"TCP_USER_TIMEOUT","","",N,N],[17,"TCP_REPAIR","","",N,N],[17,"TCP_REPAIR_QUEUE","","",N,N],[17,"TCP_QUEUE_SEQ","","",N,N],[17,"TCP_REPAIR_OPTIONS","","",N,N],[17,"TCP_FASTOPEN","","",N,N],[17,"TCP_TIMESTAMP","","",N,N],[17,"DCCP_SOCKOPT_PACKET_SIZE","","",N,N],[17,"DCCP_SOCKOPT_SERVICE","","",N,N],[17,"DCCP_SOCKOPT_CHANGE_L","","",N,N],[17,"DCCP_SOCKOPT_CHANGE_R","","",N,N],[17,"DCCP_SOCKOPT_GET_CUR_MPS","","",N,N],[17,"DCCP_SOCKOPT_SERVER_TIMEWAIT","","",N,N],[17,"DCCP_SOCKOPT_SEND_CSCOV","","",N,N],[17,"DCCP_SOCKOPT_RECV_CSCOV","","",N,N],[17,"DCCP_SOCKOPT_AVAILABLE_CCIDS","","",N,N],[17,"DCCP_SOCKOPT_CCID","","",N,N],[17,"DCCP_SOCKOPT_TX_CCID","","",N,N],[17,"DCCP_SOCKOPT_RX_CCID","","",N,N],[17,"DCCP_SOCKOPT_QPOLICY_ID","","",N,N],[17,"DCCP_SOCKOPT_QPOLICY_TXQLEN","","",N,N],[17,"DCCP_SOCKOPT_CCID_RX_INFO","","",N,N],[17,"DCCP_SOCKOPT_CCID_TX_INFO","","",N,N],[17,"DCCP_SERVICE_LIST_MAX_LEN","","maximum number of services provided on the same listening port",N,N],[17,"SIGTTIN","","",N,N],[17,"SIGTTOU","","",N,N],[17,"SIGXCPU","","",N,N],[17,"SIGXFSZ","","",N,N],[17,"SIGVTALRM","","",N,N],[17,"SIGPROF","","",N,N],[17,"SIGWINCH","","",N,N],[17,"SIGEV_THREAD_ID","","",N,N],[17,"BUFSIZ","","",N,N],[17,"TMP_MAX","","",N,N],[17,"FOPEN_MAX","","",N,N],[17,"POSIX_FADV_DONTNEED","","",N,N],[17,"POSIX_FADV_NOREUSE","","",N,N],[17,"POSIX_MADV_DONTNEED","","",N,N],[17,"_SC_EQUIV_CLASS_MAX","","",N,N],[17,"_SC_CHARCLASS_NAME_MAX","","",N,N],[17,"_SC_PII","","",N,N],[17,"_SC_PII_XTI","","",N,N],[17,"_SC_PII_SOCKET","","",N,N],[17,"_SC_PII_INTERNET","","",N,N],[17,"_SC_PII_OSI","","",N,N],[17,"_SC_POLL","","",N,N],[17,"_SC_SELECT","","",N,N],[17,"_SC_PII_INTERNET_STREAM","","",N,N],[17,"_SC_PII_INTERNET_DGRAM","","",N,N],[17,"_SC_PII_OSI_COTS","","",N,N],[17,"_SC_PII_OSI_CLTS","","",N,N],[17,"_SC_PII_OSI_M","","",N,N],[17,"_SC_T_IOV_MAX","","",N,N],[17,"_SC_2_C_VERSION","","",N,N],[17,"_SC_CHAR_BIT","","",N,N],[17,"_SC_CHAR_MAX","","",N,N],[17,"_SC_CHAR_MIN","","",N,N],[17,"_SC_INT_MAX","","",N,N],[17,"_SC_INT_MIN","","",N,N],[17,"_SC_LONG_BIT","","",N,N],[17,"_SC_WORD_BIT","","",N,N],[17,"_SC_MB_LEN_MAX","","",N,N],[17,"_SC_SSIZE_MAX","","",N,N],[17,"_SC_SCHAR_MAX","","",N,N],[17,"_SC_SCHAR_MIN","","",N,N],[17,"_SC_SHRT_MAX","","",N,N],[17,"_SC_SHRT_MIN","","",N,N],[17,"_SC_UCHAR_MAX","","",N,N],[17,"_SC_UINT_MAX","","",N,N],[17,"_SC_ULONG_MAX","","",N,N],[17,"_SC_USHRT_MAX","","",N,N],[17,"_SC_NL_ARGMAX","","",N,N],[17,"_SC_NL_LANGMAX","","",N,N],[17,"_SC_NL_MSGMAX","","",N,N],[17,"_SC_NL_NMAX","","",N,N],[17,"_SC_NL_SETMAX","","",N,N],[17,"_SC_NL_TEXTMAX","","",N,N],[17,"_SC_BASE","","",N,N],[17,"_SC_C_LANG_SUPPORT","","",N,N],[17,"_SC_C_LANG_SUPPORT_R","","",N,N],[17,"_SC_DEVICE_IO","","",N,N],[17,"_SC_DEVICE_SPECIFIC","","",N,N],[17,"_SC_DEVICE_SPECIFIC_R","","",N,N],[17,"_SC_FD_MGMT","","",N,N],[17,"_SC_FIFO","","",N,N],[17,"_SC_PIPE","","",N,N],[17,"_SC_FILE_ATTRIBUTES","","",N,N],[17,"_SC_FILE_LOCKING","","",N,N],[17,"_SC_FILE_SYSTEM","","",N,N],[17,"_SC_MULTI_PROCESS","","",N,N],[17,"_SC_SINGLE_PROCESS","","",N,N],[17,"_SC_NETWORKING","","",N,N],[17,"_SC_REGEX_VERSION","","",N,N],[17,"_SC_SIGNALS","","",N,N],[17,"_SC_SYSTEM_DATABASE","","",N,N],[17,"_SC_SYSTEM_DATABASE_R","","",N,N],[17,"_SC_USER_GROUPS","","",N,N],[17,"_SC_USER_GROUPS_R","","",N,N],[17,"_SC_LEVEL1_ICACHE_SIZE","","",N,N],[17,"_SC_LEVEL1_ICACHE_ASSOC","","",N,N],[17,"_SC_LEVEL1_ICACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL1_DCACHE_SIZE","","",N,N],[17,"_SC_LEVEL1_DCACHE_ASSOC","","",N,N],[17,"_SC_LEVEL1_DCACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL2_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL2_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL2_CACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL3_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL3_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL3_CACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL4_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL4_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL4_CACHE_LINESIZE","","",N,N],[17,"O_ACCMODE","","",N,N],[17,"ST_RELATIME","","",N,N],[17,"NI_MAXHOST","","",N,N],[17,"ADFS_SUPER_MAGIC","","",N,N],[17,"AFFS_SUPER_MAGIC","","",N,N],[17,"CODA_SUPER_MAGIC","","",N,N],[17,"CRAMFS_MAGIC","","",N,N],[17,"EFS_SUPER_MAGIC","","",N,N],[17,"EXT2_SUPER_MAGIC","","",N,N],[17,"EXT3_SUPER_MAGIC","","",N,N],[17,"EXT4_SUPER_MAGIC","","",N,N],[17,"HPFS_SUPER_MAGIC","","",N,N],[17,"HUGETLBFS_MAGIC","","",N,N],[17,"ISOFS_SUPER_MAGIC","","",N,N],[17,"JFFS2_SUPER_MAGIC","","",N,N],[17,"MINIX_SUPER_MAGIC","","",N,N],[17,"MINIX_SUPER_MAGIC2","","",N,N],[17,"MINIX2_SUPER_MAGIC","","",N,N],[17,"MINIX2_SUPER_MAGIC2","","",N,N],[17,"MSDOS_SUPER_MAGIC","","",N,N],[17,"NCP_SUPER_MAGIC","","",N,N],[17,"NFS_SUPER_MAGIC","","",N,N],[17,"OPENPROM_SUPER_MAGIC","","",N,N],[17,"PROC_SUPER_MAGIC","","",N,N],[17,"QNX4_SUPER_MAGIC","","",N,N],[17,"REISERFS_SUPER_MAGIC","","",N,N],[17,"SMB_SUPER_MAGIC","","",N,N],[17,"TMPFS_MAGIC","","",N,N],[17,"USBDEVICE_SUPER_MAGIC","","",N,N],[17,"VEOF","","",N,N],[17,"CPU_SETSIZE","","",N,N],[17,"PTRACE_TRACEME","","",N,N],[17,"PTRACE_PEEKTEXT","","",N,N],[17,"PTRACE_PEEKDATA","","",N,N],[17,"PTRACE_PEEKUSER","","",N,N],[17,"PTRACE_POKETEXT","","",N,N],[17,"PTRACE_POKEDATA","","",N,N],[17,"PTRACE_POKEUSER","","",N,N],[17,"PTRACE_CONT","","",N,N],[17,"PTRACE_KILL","","",N,N],[17,"PTRACE_SINGLESTEP","","",N,N],[17,"PTRACE_ATTACH","","",N,N],[17,"PTRACE_SYSCALL","","",N,N],[17,"PTRACE_SETOPTIONS","","",N,N],[17,"PTRACE_GETEVENTMSG","","",N,N],[17,"PTRACE_GETSIGINFO","","",N,N],[17,"PTRACE_SETSIGINFO","","",N,N],[17,"PTRACE_GETREGSET","","",N,N],[17,"PTRACE_SETREGSET","","",N,N],[17,"PTRACE_SEIZE","","",N,N],[17,"PTRACE_INTERRUPT","","",N,N],[17,"PTRACE_LISTEN","","",N,N],[17,"PTRACE_PEEKSIGINFO","","",N,N],[17,"EPOLLWAKEUP","","",N,N],[17,"MAP_HUGETLB","","",N,N],[17,"SEEK_DATA","","",N,N],[17,"SEEK_HOLE","","",N,N],[17,"TCSANOW","","",N,N],[17,"TCSADRAIN","","",N,N],[17,"TCSAFLUSH","","",N,N],[17,"TIOCLINUX","","",N,N],[17,"TIOCGSERIAL","","",N,N],[17,"RTLD_DEEPBIND","","",N,N],[17,"RTLD_GLOBAL","","",N,N],[17,"RTLD_NOLOAD","","",N,N],[17,"LINUX_REBOOT_MAGIC1","","",N,N],[17,"LINUX_REBOOT_MAGIC2","","",N,N],[17,"LINUX_REBOOT_MAGIC2A","","",N,N],[17,"LINUX_REBOOT_MAGIC2B","","",N,N],[17,"LINUX_REBOOT_MAGIC2C","","",N,N],[17,"LINUX_REBOOT_CMD_RESTART","","",N,N],[17,"LINUX_REBOOT_CMD_HALT","","",N,N],[17,"LINUX_REBOOT_CMD_CAD_ON","","",N,N],[17,"LINUX_REBOOT_CMD_CAD_OFF","","",N,N],[17,"LINUX_REBOOT_CMD_POWER_OFF","","",N,N],[17,"LINUX_REBOOT_CMD_RESTART2","","",N,N],[17,"LINUX_REBOOT_CMD_SW_SUSPEND","","",N,N],[17,"LINUX_REBOOT_CMD_KEXEC","","",N,N],[17,"NETLINK_ROUTE","","",N,N],[17,"NETLINK_UNUSED","","",N,N],[17,"NETLINK_USERSOCK","","",N,N],[17,"NETLINK_FIREWALL","","",N,N],[17,"NETLINK_SOCK_DIAG","","",N,N],[17,"NETLINK_NFLOG","","",N,N],[17,"NETLINK_XFRM","","",N,N],[17,"NETLINK_SELINUX","","",N,N],[17,"NETLINK_ISCSI","","",N,N],[17,"NETLINK_AUDIT","","",N,N],[17,"NETLINK_FIB_LOOKUP","","",N,N],[17,"NETLINK_CONNECTOR","","",N,N],[17,"NETLINK_NETFILTER","","",N,N],[17,"NETLINK_IP6_FW","","",N,N],[17,"NETLINK_DNRTMSG","","",N,N],[17,"NETLINK_KOBJECT_UEVENT","","",N,N],[17,"NETLINK_GENERIC","","",N,N],[17,"NETLINK_SCSITRANSPORT","","",N,N],[17,"NETLINK_ECRYPTFS","","",N,N],[17,"NETLINK_RDMA","","",N,N],[17,"NETLINK_CRYPTO","","",N,N],[17,"NETLINK_INET_DIAG","","",N,N],[17,"MAX_LINKS","","",N,N],[17,"NLM_F_REQUEST","","",N,N],[17,"NLM_F_MULTI","","",N,N],[17,"NLM_F_ACK","","",N,N],[17,"NLM_F_ECHO","","",N,N],[17,"NLM_F_DUMP_INTR","","",N,N],[17,"NLM_F_DUMP_FILTERED","","",N,N],[17,"NLM_F_ROOT","","",N,N],[17,"NLM_F_MATCH","","",N,N],[17,"NLM_F_ATOMIC","","",N,N],[17,"NLM_F_DUMP","","",N,N],[17,"NLM_F_REPLACE","","",N,N],[17,"NLM_F_EXCL","","",N,N],[17,"NLM_F_CREATE","","",N,N],[17,"NLM_F_APPEND","","",N,N],[17,"NETLINK_ADD_MEMBERSHIP","","",N,N],[17,"NETLINK_DROP_MEMBERSHIP","","",N,N],[17,"NETLINK_PKTINFO","","",N,N],[17,"NETLINK_BROADCAST_ERROR","","",N,N],[17,"NETLINK_NO_ENOBUFS","","",N,N],[17,"NETLINK_RX_RING","","",N,N],[17,"NETLINK_TX_RING","","",N,N],[17,"NETLINK_LISTEN_ALL_NSID","","",N,N],[17,"NETLINK_LIST_MEMBERSHIPS","","",N,N],[17,"NETLINK_CAP_ACK","","",N,N],[17,"NLA_F_NESTED","","",N,N],[17,"NLA_F_NET_BYTEORDER","","",N,N],[17,"NLA_TYPE_MASK","","",N,N],[17,"NLA_ALIGNTO","","",N,N],[17,"GENL_UNS_ADMIN_PERM","","",N,N],[17,"GENL_ID_VFS_DQUOT","","",N,N],[17,"GENL_ID_PMCRAID","","",N,N],[17,"TIOCM_LE","","",N,N],[17,"TIOCM_DTR","","",N,N],[17,"TIOCM_RTS","","",N,N],[17,"TIOCM_ST","","",N,N],[17,"TIOCM_SR","","",N,N],[17,"TIOCM_CTS","","",N,N],[17,"TIOCM_CAR","","",N,N],[17,"TIOCM_RNG","","",N,N],[17,"TIOCM_DSR","","",N,N],[17,"TIOCM_CD","","",N,N],[17,"TIOCM_RI","","",N,N],[17,"NF_NETDEV_INGRESS","","",N,N],[17,"NF_NETDEV_NUMHOOKS","","",N,N],[17,"NFPROTO_INET","","",N,N],[17,"NFPROTO_NETDEV","","",N,N],[17,"NFT_TABLE_MAXNAMELEN","","",N,N],[17,"NFT_CHAIN_MAXNAMELEN","","",N,N],[17,"NFT_SET_MAXNAMELEN","","",N,N],[17,"NFT_OBJ_MAXNAMELEN","","",N,N],[17,"NFT_USERDATA_MAXLEN","","",N,N],[17,"NFT_REG_VERDICT","","",N,N],[17,"NFT_REG_1","","",N,N],[17,"NFT_REG_2","","",N,N],[17,"NFT_REG_3","","",N,N],[17,"NFT_REG_4","","",N,N],[17,"__NFT_REG_MAX","","",N,N],[17,"NFT_REG32_00","","",N,N],[17,"NFT_REG32_01","","",N,N],[17,"NFT_REG32_02","","",N,N],[17,"NFT_REG32_03","","",N,N],[17,"NFT_REG32_04","","",N,N],[17,"NFT_REG32_05","","",N,N],[17,"NFT_REG32_06","","",N,N],[17,"NFT_REG32_07","","",N,N],[17,"NFT_REG32_08","","",N,N],[17,"NFT_REG32_09","","",N,N],[17,"NFT_REG32_10","","",N,N],[17,"NFT_REG32_11","","",N,N],[17,"NFT_REG32_12","","",N,N],[17,"NFT_REG32_13","","",N,N],[17,"NFT_REG32_14","","",N,N],[17,"NFT_REG32_15","","",N,N],[17,"NFT_REG_SIZE","","",N,N],[17,"NFT_REG32_SIZE","","",N,N],[17,"NFT_CONTINUE","","",N,N],[17,"NFT_BREAK","","",N,N],[17,"NFT_JUMP","","",N,N],[17,"NFT_GOTO","","",N,N],[17,"NFT_RETURN","","",N,N],[17,"NFT_MSG_NEWTABLE","","",N,N],[17,"NFT_MSG_GETTABLE","","",N,N],[17,"NFT_MSG_DELTABLE","","",N,N],[17,"NFT_MSG_NEWCHAIN","","",N,N],[17,"NFT_MSG_GETCHAIN","","",N,N],[17,"NFT_MSG_DELCHAIN","","",N,N],[17,"NFT_MSG_NEWRULE","","",N,N],[17,"NFT_MSG_GETRULE","","",N,N],[17,"NFT_MSG_DELRULE","","",N,N],[17,"NFT_MSG_NEWSET","","",N,N],[17,"NFT_MSG_GETSET","","",N,N],[17,"NFT_MSG_DELSET","","",N,N],[17,"NFT_MSG_NEWSETELEM","","",N,N],[17,"NFT_MSG_GETSETELEM","","",N,N],[17,"NFT_MSG_DELSETELEM","","",N,N],[17,"NFT_MSG_NEWGEN","","",N,N],[17,"NFT_MSG_GETGEN","","",N,N],[17,"NFT_MSG_TRACE","","",N,N],[17,"NFT_MSG_NEWOBJ","","",N,N],[17,"NFT_MSG_GETOBJ","","",N,N],[17,"NFT_MSG_DELOBJ","","",N,N],[17,"NFT_MSG_GETOBJ_RESET","","",N,N],[17,"NFT_MSG_MAX","","",N,N],[17,"NFT_SET_ANONYMOUS","","",N,N],[17,"NFT_SET_CONSTANT","","",N,N],[17,"NFT_SET_INTERVAL","","",N,N],[17,"NFT_SET_MAP","","",N,N],[17,"NFT_SET_TIMEOUT","","",N,N],[17,"NFT_SET_EVAL","","",N,N],[17,"NFT_SET_POL_PERFORMANCE","","",N,N],[17,"NFT_SET_POL_MEMORY","","",N,N],[17,"NFT_SET_ELEM_INTERVAL_END","","",N,N],[17,"NFT_DATA_VALUE","","",N,N],[17,"NFT_DATA_VERDICT","","",N,N],[17,"NFT_DATA_RESERVED_MASK","","",N,N],[17,"NFT_DATA_VALUE_MAXLEN","","",N,N],[17,"NFT_BYTEORDER_NTOH","","",N,N],[17,"NFT_BYTEORDER_HTON","","",N,N],[17,"NFT_CMP_EQ","","",N,N],[17,"NFT_CMP_NEQ","","",N,N],[17,"NFT_CMP_LT","","",N,N],[17,"NFT_CMP_LTE","","",N,N],[17,"NFT_CMP_GT","","",N,N],[17,"NFT_CMP_GTE","","",N,N],[17,"NFT_RANGE_EQ","","",N,N],[17,"NFT_RANGE_NEQ","","",N,N],[17,"NFT_LOOKUP_F_INV","","",N,N],[17,"NFT_DYNSET_OP_ADD","","",N,N],[17,"NFT_DYNSET_OP_UPDATE","","",N,N],[17,"NFT_DYNSET_F_INV","","",N,N],[17,"NFT_PAYLOAD_LL_HEADER","","",N,N],[17,"NFT_PAYLOAD_NETWORK_HEADER","","",N,N],[17,"NFT_PAYLOAD_TRANSPORT_HEADER","","",N,N],[17,"NFT_PAYLOAD_CSUM_NONE","","",N,N],[17,"NFT_PAYLOAD_CSUM_INET","","",N,N],[17,"NFT_META_LEN","","",N,N],[17,"NFT_META_PROTOCOL","","",N,N],[17,"NFT_META_PRIORITY","","",N,N],[17,"NFT_META_MARK","","",N,N],[17,"NFT_META_IIF","","",N,N],[17,"NFT_META_OIF","","",N,N],[17,"NFT_META_IIFNAME","","",N,N],[17,"NFT_META_OIFNAME","","",N,N],[17,"NFT_META_IIFTYPE","","",N,N],[17,"NFT_META_OIFTYPE","","",N,N],[17,"NFT_META_SKUID","","",N,N],[17,"NFT_META_SKGID","","",N,N],[17,"NFT_META_NFTRACE","","",N,N],[17,"NFT_META_RTCLASSID","","",N,N],[17,"NFT_META_SECMARK","","",N,N],[17,"NFT_META_NFPROTO","","",N,N],[17,"NFT_META_L4PROTO","","",N,N],[17,"NFT_META_BRI_IIFNAME","","",N,N],[17,"NFT_META_BRI_OIFNAME","","",N,N],[17,"NFT_META_PKTTYPE","","",N,N],[17,"NFT_META_CPU","","",N,N],[17,"NFT_META_IIFGROUP","","",N,N],[17,"NFT_META_OIFGROUP","","",N,N],[17,"NFT_META_CGROUP","","",N,N],[17,"NFT_META_PRANDOM","","",N,N],[17,"NFT_CT_STATE","","",N,N],[17,"NFT_CT_DIRECTION","","",N,N],[17,"NFT_CT_STATUS","","",N,N],[17,"NFT_CT_MARK","","",N,N],[17,"NFT_CT_SECMARK","","",N,N],[17,"NFT_CT_EXPIRATION","","",N,N],[17,"NFT_CT_HELPER","","",N,N],[17,"NFT_CT_L3PROTOCOL","","",N,N],[17,"NFT_CT_SRC","","",N,N],[17,"NFT_CT_DST","","",N,N],[17,"NFT_CT_PROTOCOL","","",N,N],[17,"NFT_CT_PROTO_SRC","","",N,N],[17,"NFT_CT_PROTO_DST","","",N,N],[17,"NFT_CT_LABELS","","",N,N],[17,"NFT_CT_PKTS","","",N,N],[17,"NFT_CT_BYTES","","",N,N],[17,"NFT_LIMIT_PKTS","","",N,N],[17,"NFT_LIMIT_PKT_BYTES","","",N,N],[17,"NFT_LIMIT_F_INV","","",N,N],[17,"NFT_QUEUE_FLAG_BYPASS","","",N,N],[17,"NFT_QUEUE_FLAG_CPU_FANOUT","","",N,N],[17,"NFT_QUEUE_FLAG_MASK","","",N,N],[17,"NFT_QUOTA_F_INV","","",N,N],[17,"NFT_REJECT_ICMP_UNREACH","","",N,N],[17,"NFT_REJECT_TCP_RST","","",N,N],[17,"NFT_REJECT_ICMPX_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_NO_ROUTE","","",N,N],[17,"NFT_REJECT_ICMPX_PORT_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_HOST_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_ADMIN_PROHIBITED","","",N,N],[17,"NFT_NAT_SNAT","","",N,N],[17,"NFT_NAT_DNAT","","",N,N],[17,"NFT_TRACETYPE_UNSPEC","","",N,N],[17,"NFT_TRACETYPE_POLICY","","",N,N],[17,"NFT_TRACETYPE_RETURN","","",N,N],[17,"NFT_TRACETYPE_RULE","","",N,N],[17,"NFT_NG_INCREMENTAL","","",N,N],[17,"NFT_NG_RANDOM","","",N,N],[17,"AF_MAX","","",N,N],[17,"PF_MAX","","",N,N],[17,"PTHREAD_STACK_MIN","","",N,N],[17,"PTHREAD_MUTEX_ADAPTIVE_NP","","",N,N],[11,"clone","libc","",84,[[["self"]],["aiocb"]]],[11,"clone","","",85,[[["self"]],["__exit_status"]]],[11,"clone","","",86,[[["self"]],["__timeval"]]],[11,"clone","","",87,[[["self"]],["utmpx"]]],[11,"clone","","",88,[[["self"]],["sigaction"]]],[11,"clone","","",89,[[["self"]],["stack_t"]]],[11,"clone","","",90,[[["self"]],["siginfo_t"]]],[11,"clone","","",91,[[["self"]],["glob64_t"]]],[11,"clone","","",92,[[["self"]],["statfs"]]],[11,"clone","","",93,[[["self"]],["msghdr"]]],[11,"clone","","",94,[[["self"]],["cmsghdr"]]],[11,"clone","","",95,[[["self"]],["termios"]]],[11,"clone","","",96,[[["self"]],["flock"]]],[11,"clone","","",97,[[["self"]],["sem_t"]]],[11,"clone","","",98,[[["self"]],["mallinfo"]]],[11,"clone","","",99,[[["self"]],["nlmsghdr"]]],[11,"clone","","",100,[[["self"]],["nlmsgerr"]]],[11,"clone","","",101,[[["self"]],["nl_pktinfo"]]],[11,"clone","","",102,[[["self"]],["nl_mmap_req"]]],[11,"clone","","",103,[[["self"]],["nl_mmap_hdr"]]],[11,"clone","","",104,[[["self"]],["nlattr"]]],[11,"clone","","",105,[[["self"]],["rtentry"]]],[6,"useconds_t","libc::unix::notbsd::linux","",N,N],[6,"dev_t","","",N,N],[6,"socklen_t","","",N,N],[6,"pthread_t","","",N,N],[6,"mode_t","","",N,N],[6,"ino64_t","","",N,N],[6,"off64_t","","",N,N],[6,"blkcnt64_t","","",N,N],[6,"rlim64_t","","",N,N],[6,"mqd_t","","",N,N],[6,"nfds_t","","",N,N],[6,"nl_item","","",N,N],[6,"idtype_t","","",N,N],[6,"loff_t","","",N,N],[6,"__u8","","",N,N],[6,"__u16","","",N,N],[6,"__s16","","",N,N],[6,"__u32","","",N,N],[6,"__s32","","",N,N],[6,"Elf32_Half","","",N,N],[6,"Elf32_Word","","",N,N],[6,"Elf32_Off","","",N,N],[6,"Elf32_Addr","","",N,N],[6,"Elf64_Half","","",N,N],[6,"Elf64_Word","","",N,N],[6,"Elf64_Off","","",N,N],[6,"Elf64_Addr","","",N,N],[6,"Elf64_Xword","","",N,N],[17,"ABDAY_1","","",N,N],[17,"ABDAY_2","","",N,N],[17,"ABDAY_3","","",N,N],[17,"ABDAY_4","","",N,N],[17,"ABDAY_5","","",N,N],[17,"ABDAY_6","","",N,N],[17,"ABDAY_7","","",N,N],[17,"DAY_1","","",N,N],[17,"DAY_2","","",N,N],[17,"DAY_3","","",N,N],[17,"DAY_4","","",N,N],[17,"DAY_5","","",N,N],[17,"DAY_6","","",N,N],[17,"DAY_7","","",N,N],[17,"ABMON_1","","",N,N],[17,"ABMON_2","","",N,N],[17,"ABMON_3","","",N,N],[17,"ABMON_4","","",N,N],[17,"ABMON_5","","",N,N],[17,"ABMON_6","","",N,N],[17,"ABMON_7","","",N,N],[17,"ABMON_8","","",N,N],[17,"ABMON_9","","",N,N],[17,"ABMON_10","","",N,N],[17,"ABMON_11","","",N,N],[17,"ABMON_12","","",N,N],[17,"MON_1","","",N,N],[17,"MON_2","","",N,N],[17,"MON_3","","",N,N],[17,"MON_4","","",N,N],[17,"MON_5","","",N,N],[17,"MON_6","","",N,N],[17,"MON_7","","",N,N],[17,"MON_8","","",N,N],[17,"MON_9","","",N,N],[17,"MON_10","","",N,N],[17,"MON_11","","",N,N],[17,"MON_12","","",N,N],[17,"AM_STR","","",N,N],[17,"PM_STR","","",N,N],[17,"D_T_FMT","","",N,N],[17,"D_FMT","","",N,N],[17,"T_FMT","","",N,N],[17,"T_FMT_AMPM","","",N,N],[17,"ERA","","",N,N],[17,"ERA_D_FMT","","",N,N],[17,"ALT_DIGITS","","",N,N],[17,"ERA_D_T_FMT","","",N,N],[17,"ERA_T_FMT","","",N,N],[17,"CODESET","","",N,N],[17,"CRNCYSTR","","",N,N],[17,"RUSAGE_THREAD","","",N,N],[17,"RUSAGE_CHILDREN","","",N,N],[17,"RADIXCHAR","","",N,N],[17,"THOUSEP","","",N,N],[17,"YESEXPR","","",N,N],[17,"NOEXPR","","",N,N],[17,"YESSTR","","",N,N],[17,"NOSTR","","",N,N],[17,"FILENAME_MAX","","",N,N],[17,"L_tmpnam","","",N,N],[17,"_PC_LINK_MAX","","",N,N],[17,"_PC_MAX_CANON","","",N,N],[17,"_PC_MAX_INPUT","","",N,N],[17,"_PC_NAME_MAX","","",N,N],[17,"_PC_PATH_MAX","","",N,N],[17,"_PC_PIPE_BUF","","",N,N],[17,"_PC_CHOWN_RESTRICTED","","",N,N],[17,"_PC_NO_TRUNC","","",N,N],[17,"_PC_VDISABLE","","",N,N],[17,"_PC_SYNC_IO","","",N,N],[17,"_PC_ASYNC_IO","","",N,N],[17,"_PC_PRIO_IO","","",N,N],[17,"_PC_SOCK_MAXBUF","","",N,N],[17,"_PC_FILESIZEBITS","","",N,N],[17,"_PC_REC_INCR_XFER_SIZE","","",N,N],[17,"_PC_REC_MAX_XFER_SIZE","","",N,N],[17,"_PC_REC_MIN_XFER_SIZE","","",N,N],[17,"_PC_REC_XFER_ALIGN","","",N,N],[17,"_PC_ALLOC_SIZE_MIN","","",N,N],[17,"_PC_SYMLINK_MAX","","",N,N],[17,"_PC_2_SYMLINKS","","",N,N],[17,"_SC_ARG_MAX","","",N,N],[17,"_SC_CHILD_MAX","","",N,N],[17,"_SC_CLK_TCK","","",N,N],[17,"_SC_NGROUPS_MAX","","",N,N],[17,"_SC_OPEN_MAX","","",N,N],[17,"_SC_STREAM_MAX","","",N,N],[17,"_SC_TZNAME_MAX","","",N,N],[17,"_SC_JOB_CONTROL","","",N,N],[17,"_SC_SAVED_IDS","","",N,N],[17,"_SC_REALTIME_SIGNALS","","",N,N],[17,"_SC_PRIORITY_SCHEDULING","","",N,N],[17,"_SC_TIMERS","","",N,N],[17,"_SC_ASYNCHRONOUS_IO","","",N,N],[17,"_SC_PRIORITIZED_IO","","",N,N],[17,"_SC_SYNCHRONIZED_IO","","",N,N],[17,"_SC_FSYNC","","",N,N],[17,"_SC_MAPPED_FILES","","",N,N],[17,"_SC_MEMLOCK","","",N,N],[17,"_SC_MEMLOCK_RANGE","","",N,N],[17,"_SC_MEMORY_PROTECTION","","",N,N],[17,"_SC_MESSAGE_PASSING","","",N,N],[17,"_SC_SEMAPHORES","","",N,N],[17,"_SC_SHARED_MEMORY_OBJECTS","","",N,N],[17,"_SC_AIO_LISTIO_MAX","","",N,N],[17,"_SC_AIO_MAX","","",N,N],[17,"_SC_AIO_PRIO_DELTA_MAX","","",N,N],[17,"_SC_DELAYTIMER_MAX","","",N,N],[17,"_SC_MQ_OPEN_MAX","","",N,N],[17,"_SC_MQ_PRIO_MAX","","",N,N],[17,"_SC_VERSION","","",N,N],[17,"_SC_PAGESIZE","","",N,N],[17,"_SC_PAGE_SIZE","","",N,N],[17,"_SC_RTSIG_MAX","","",N,N],[17,"_SC_SEM_NSEMS_MAX","","",N,N],[17,"_SC_SEM_VALUE_MAX","","",N,N],[17,"_SC_SIGQUEUE_MAX","","",N,N],[17,"_SC_TIMER_MAX","","",N,N],[17,"_SC_BC_BASE_MAX","","",N,N],[17,"_SC_BC_DIM_MAX","","",N,N],[17,"_SC_BC_SCALE_MAX","","",N,N],[17,"_SC_BC_STRING_MAX","","",N,N],[17,"_SC_COLL_WEIGHTS_MAX","","",N,N],[17,"_SC_EXPR_NEST_MAX","","",N,N],[17,"_SC_LINE_MAX","","",N,N],[17,"_SC_RE_DUP_MAX","","",N,N],[17,"_SC_2_VERSION","","",N,N],[17,"_SC_2_C_BIND","","",N,N],[17,"_SC_2_C_DEV","","",N,N],[17,"_SC_2_FORT_DEV","","",N,N],[17,"_SC_2_FORT_RUN","","",N,N],[17,"_SC_2_SW_DEV","","",N,N],[17,"_SC_2_LOCALEDEF","","",N,N],[17,"_SC_UIO_MAXIOV","","",N,N],[17,"_SC_IOV_MAX","","",N,N],[17,"_SC_THREADS","","",N,N],[17,"_SC_THREAD_SAFE_FUNCTIONS","","",N,N],[17,"_SC_GETGR_R_SIZE_MAX","","",N,N],[17,"_SC_GETPW_R_SIZE_MAX","","",N,N],[17,"_SC_LOGIN_NAME_MAX","","",N,N],[17,"_SC_TTY_NAME_MAX","","",N,N],[17,"_SC_THREAD_DESTRUCTOR_ITERATIONS","","",N,N],[17,"_SC_THREAD_KEYS_MAX","","",N,N],[17,"_SC_THREAD_STACK_MIN","","",N,N],[17,"_SC_THREAD_THREADS_MAX","","",N,N],[17,"_SC_THREAD_ATTR_STACKADDR","","",N,N],[17,"_SC_THREAD_ATTR_STACKSIZE","","",N,N],[17,"_SC_THREAD_PRIORITY_SCHEDULING","","",N,N],[17,"_SC_THREAD_PRIO_INHERIT","","",N,N],[17,"_SC_THREAD_PRIO_PROTECT","","",N,N],[17,"_SC_THREAD_PROCESS_SHARED","","",N,N],[17,"_SC_NPROCESSORS_CONF","","",N,N],[17,"_SC_NPROCESSORS_ONLN","","",N,N],[17,"_SC_PHYS_PAGES","","",N,N],[17,"_SC_AVPHYS_PAGES","","",N,N],[17,"_SC_ATEXIT_MAX","","",N,N],[17,"_SC_PASS_MAX","","",N,N],[17,"_SC_XOPEN_VERSION","","",N,N],[17,"_SC_XOPEN_XCU_VERSION","","",N,N],[17,"_SC_XOPEN_UNIX","","",N,N],[17,"_SC_XOPEN_CRYPT","","",N,N],[17,"_SC_XOPEN_ENH_I18N","","",N,N],[17,"_SC_XOPEN_SHM","","",N,N],[17,"_SC_2_CHAR_TERM","","",N,N],[17,"_SC_2_UPE","","",N,N],[17,"_SC_XOPEN_XPG2","","",N,N],[17,"_SC_XOPEN_XPG3","","",N,N],[17,"_SC_XOPEN_XPG4","","",N,N],[17,"_SC_NZERO","","",N,N],[17,"_SC_XBS5_ILP32_OFF32","","",N,N],[17,"_SC_XBS5_ILP32_OFFBIG","","",N,N],[17,"_SC_XBS5_LP64_OFF64","","",N,N],[17,"_SC_XBS5_LPBIG_OFFBIG","","",N,N],[17,"_SC_XOPEN_LEGACY","","",N,N],[17,"_SC_XOPEN_REALTIME","","",N,N],[17,"_SC_XOPEN_REALTIME_THREADS","","",N,N],[17,"_SC_ADVISORY_INFO","","",N,N],[17,"_SC_BARRIERS","","",N,N],[17,"_SC_CLOCK_SELECTION","","",N,N],[17,"_SC_CPUTIME","","",N,N],[17,"_SC_THREAD_CPUTIME","","",N,N],[17,"_SC_MONOTONIC_CLOCK","","",N,N],[17,"_SC_READER_WRITER_LOCKS","","",N,N],[17,"_SC_SPIN_LOCKS","","",N,N],[17,"_SC_REGEXP","","",N,N],[17,"_SC_SHELL","","",N,N],[17,"_SC_SPAWN","","",N,N],[17,"_SC_SPORADIC_SERVER","","",N,N],[17,"_SC_THREAD_SPORADIC_SERVER","","",N,N],[17,"_SC_TIMEOUTS","","",N,N],[17,"_SC_TYPED_MEMORY_OBJECTS","","",N,N],[17,"_SC_2_PBS","","",N,N],[17,"_SC_2_PBS_ACCOUNTING","","",N,N],[17,"_SC_2_PBS_LOCATE","","",N,N],[17,"_SC_2_PBS_MESSAGE","","",N,N],[17,"_SC_2_PBS_TRACK","","",N,N],[17,"_SC_SYMLOOP_MAX","","",N,N],[17,"_SC_STREAMS","","",N,N],[17,"_SC_2_PBS_CHECKPOINT","","",N,N],[17,"_SC_V6_ILP32_OFF32","","",N,N],[17,"_SC_V6_ILP32_OFFBIG","","",N,N],[17,"_SC_V6_LP64_OFF64","","",N,N],[17,"_SC_V6_LPBIG_OFFBIG","","",N,N],[17,"_SC_HOST_NAME_MAX","","",N,N],[17,"_SC_TRACE","","",N,N],[17,"_SC_TRACE_EVENT_FILTER","","",N,N],[17,"_SC_TRACE_INHERIT","","",N,N],[17,"_SC_TRACE_LOG","","",N,N],[17,"_SC_IPV6","","",N,N],[17,"_SC_RAW_SOCKETS","","",N,N],[17,"_SC_V7_ILP32_OFF32","","",N,N],[17,"_SC_V7_ILP32_OFFBIG","","",N,N],[17,"_SC_V7_LP64_OFF64","","",N,N],[17,"_SC_V7_LPBIG_OFFBIG","","",N,N],[17,"_SC_SS_REPL_MAX","","",N,N],[17,"_SC_TRACE_EVENT_NAME_MAX","","",N,N],[17,"_SC_TRACE_NAME_MAX","","",N,N],[17,"_SC_TRACE_SYS_MAX","","",N,N],[17,"_SC_TRACE_USER_EVENT_MAX","","",N,N],[17,"_SC_XOPEN_STREAMS","","",N,N],[17,"_SC_THREAD_ROBUST_PRIO_INHERIT","","",N,N],[17,"_SC_THREAD_ROBUST_PRIO_PROTECT","","",N,N],[17,"RLIM_SAVED_MAX","","",N,N],[17,"RLIM_SAVED_CUR","","",N,N],[17,"GLOB_ERR","","",N,N],[17,"GLOB_MARK","","",N,N],[17,"GLOB_NOSORT","","",N,N],[17,"GLOB_DOOFFS","","",N,N],[17,"GLOB_NOCHECK","","",N,N],[17,"GLOB_APPEND","","",N,N],[17,"GLOB_NOESCAPE","","",N,N],[17,"GLOB_NOSPACE","","",N,N],[17,"GLOB_ABORTED","","",N,N],[17,"GLOB_NOMATCH","","",N,N],[17,"POSIX_MADV_NORMAL","","",N,N],[17,"POSIX_MADV_RANDOM","","",N,N],[17,"POSIX_MADV_SEQUENTIAL","","",N,N],[17,"POSIX_MADV_WILLNEED","","",N,N],[17,"S_IEXEC","","",N,N],[17,"S_IWRITE","","",N,N],[17,"S_IREAD","","",N,N],[17,"F_LOCK","","",N,N],[17,"F_TEST","","",N,N],[17,"F_TLOCK","","",N,N],[17,"F_ULOCK","","",N,N],[17,"IFF_LOWER_UP","","",N,N],[17,"IFF_DORMANT","","",N,N],[17,"IFF_ECHO","","",N,N],[17,"IFF_TUN","","",N,N],[17,"IFF_TAP","","",N,N],[17,"IFF_NO_PI","","",N,N],[17,"TUN_READQ_SIZE","","",N,N],[17,"TUN_TUN_DEV","","",N,N],[17,"TUN_TAP_DEV","","",N,N],[17,"TUN_TYPE_MASK","","",N,N],[17,"IFF_ONE_QUEUE","","",N,N],[17,"IFF_VNET_HDR","","",N,N],[17,"IFF_TUN_EXCL","","",N,N],[17,"IFF_MULTI_QUEUE","","",N,N],[17,"IFF_ATTACH_QUEUE","","",N,N],[17,"IFF_DETACH_QUEUE","","",N,N],[17,"IFF_PERSIST","","",N,N],[17,"IFF_NOFILTER","","",N,N],[17,"ST_RDONLY","","",N,N],[17,"ST_NOSUID","","",N,N],[17,"ST_NODEV","","",N,N],[17,"ST_NOEXEC","","",N,N],[17,"ST_SYNCHRONOUS","","",N,N],[17,"ST_MANDLOCK","","",N,N],[17,"ST_WRITE","","",N,N],[17,"ST_APPEND","","",N,N],[17,"ST_IMMUTABLE","","",N,N],[17,"ST_NOATIME","","",N,N],[17,"ST_NODIRATIME","","",N,N],[17,"RTLD_NEXT","","",N,N],[17,"RTLD_DEFAULT","","",N,N],[17,"RTLD_NODELETE","","",N,N],[17,"RTLD_NOW","","",N,N],[17,"TCP_MD5SIG","","",N,N],[17,"PTHREAD_MUTEX_INITIALIZER","","",N,N],[17,"PTHREAD_COND_INITIALIZER","","",N,N],[17,"PTHREAD_RWLOCK_INITIALIZER","","",N,N],[17,"PTHREAD_MUTEX_NORMAL","","",N,N],[17,"PTHREAD_MUTEX_RECURSIVE","","",N,N],[17,"PTHREAD_MUTEX_ERRORCHECK","","",N,N],[17,"PTHREAD_MUTEX_DEFAULT","","",N,N],[17,"PTHREAD_PROCESS_PRIVATE","","",N,N],[17,"PTHREAD_PROCESS_SHARED","","",N,N],[17,"__SIZEOF_PTHREAD_COND_T","","",N,N],[17,"RENAME_NOREPLACE","","",N,N],[17,"RENAME_EXCHANGE","","",N,N],[17,"RENAME_WHITEOUT","","",N,N],[17,"SCHED_OTHER","","",N,N],[17,"SCHED_FIFO","","",N,N],[17,"SCHED_RR","","",N,N],[17,"SCHED_BATCH","","",N,N],[17,"SCHED_IDLE","","",N,N],[17,"IPPROTO_HOPOPTS","","Hop-by-hop option header",N,N],[17,"IPPROTO_IGMP","","group mgmt protocol",N,N],[17,"IPPROTO_IPIP","","for compatibility",N,N],[17,"IPPROTO_EGP","","exterior gateway protocol",N,N],[17,"IPPROTO_PUP","","pup",N,N],[17,"IPPROTO_IDP","","xns idp",N,N],[17,"IPPROTO_TP","","tp-4 w/ class negotiation",N,N],[17,"IPPROTO_DCCP","","DCCP",N,N],[17,"IPPROTO_ROUTING","","IP6 routing header",N,N],[17,"IPPROTO_FRAGMENT","","IP6 fragmentation header",N,N],[17,"IPPROTO_RSVP","","resource reservation",N,N],[17,"IPPROTO_GRE","","General Routing Encap.",N,N],[17,"IPPROTO_ESP","","IP6 Encap Sec. Payload",N,N],[17,"IPPROTO_AH","","IP6 Auth Header",N,N],[17,"IPPROTO_NONE","","IP6 no next header",N,N],[17,"IPPROTO_DSTOPTS","","IP6 destination option",N,N],[17,"IPPROTO_MTP","","",N,N],[17,"IPPROTO_BEETPH","","",N,N],[17,"IPPROTO_ENCAP","","encapsulation header",N,N],[17,"IPPROTO_PIM","","Protocol indep. multicast",N,N],[17,"IPPROTO_COMP","","IP Payload Comp. Protocol",N,N],[17,"IPPROTO_SCTP","","SCTP",N,N],[17,"IPPROTO_MH","","",N,N],[17,"IPPROTO_UDPLITE","","",N,N],[17,"IPPROTO_MPLS","","",N,N],[17,"IPPROTO_RAW","","raw IP packet",N,N],[17,"IPPROTO_MAX","","",N,N],[17,"AF_IB","","",N,N],[17,"AF_MPLS","","",N,N],[17,"AF_NFC","","",N,N],[17,"AF_VSOCK","","",N,N],[17,"PF_IB","","",N,N],[17,"PF_MPLS","","",N,N],[17,"PF_NFC","","",N,N],[17,"PF_VSOCK","","",N,N],[17,"IPC_PRIVATE","","",N,N],[17,"IPC_CREAT","","",N,N],[17,"IPC_EXCL","","",N,N],[17,"IPC_NOWAIT","","",N,N],[17,"IPC_RMID","","",N,N],[17,"IPC_SET","","",N,N],[17,"IPC_STAT","","",N,N],[17,"IPC_INFO","","",N,N],[17,"MSG_STAT","","",N,N],[17,"MSG_INFO","","",N,N],[17,"MSG_NOERROR","","",N,N],[17,"MSG_EXCEPT","","",N,N],[17,"MSG_COPY","","",N,N],[17,"SHM_R","","",N,N],[17,"SHM_W","","",N,N],[17,"SHM_RDONLY","","",N,N],[17,"SHM_RND","","",N,N],[17,"SHM_REMAP","","",N,N],[17,"SHM_EXEC","","",N,N],[17,"SHM_LOCK","","",N,N],[17,"SHM_UNLOCK","","",N,N],[17,"SHM_HUGETLB","","",N,N],[17,"SHM_NORESERVE","","",N,N],[17,"EPOLLRDHUP","","",N,N],[17,"EPOLLEXCLUSIVE","","",N,N],[17,"EPOLLONESHOT","","",N,N],[17,"QFMT_VFS_OLD","","",N,N],[17,"QFMT_VFS_V0","","",N,N],[17,"QFMT_VFS_V1","","",N,N],[17,"EFD_SEMAPHORE","","",N,N],[17,"LOG_NFACILITIES","","",N,N],[17,"SEM_FAILED","","",N,N],[17,"RB_AUTOBOOT","","",N,N],[17,"RB_HALT_SYSTEM","","",N,N],[17,"RB_ENABLE_CAD","","",N,N],[17,"RB_DISABLE_CAD","","",N,N],[17,"RB_POWER_OFF","","",N,N],[17,"RB_SW_SUSPEND","","",N,N],[17,"RB_KEXEC","","",N,N],[17,"AI_PASSIVE","","",N,N],[17,"AI_CANONNAME","","",N,N],[17,"AI_NUMERICHOST","","",N,N],[17,"AI_V4MAPPED","","",N,N],[17,"AI_ALL","","",N,N],[17,"AI_ADDRCONFIG","","",N,N],[17,"AI_NUMERICSERV","","",N,N],[17,"EAI_BADFLAGS","","",N,N],[17,"EAI_NONAME","","",N,N],[17,"EAI_AGAIN","","",N,N],[17,"EAI_FAIL","","",N,N],[17,"EAI_NODATA","","",N,N],[17,"EAI_FAMILY","","",N,N],[17,"EAI_SOCKTYPE","","",N,N],[17,"EAI_SERVICE","","",N,N],[17,"EAI_MEMORY","","",N,N],[17,"EAI_SYSTEM","","",N,N],[17,"EAI_OVERFLOW","","",N,N],[17,"NI_NUMERICHOST","","",N,N],[17,"NI_NUMERICSERV","","",N,N],[17,"NI_NOFQDN","","",N,N],[17,"NI_NAMEREQD","","",N,N],[17,"NI_DGRAM","","",N,N],[17,"SYNC_FILE_RANGE_WAIT_BEFORE","","",N,N],[17,"SYNC_FILE_RANGE_WRITE","","",N,N],[17,"SYNC_FILE_RANGE_WAIT_AFTER","","",N,N],[17,"AIO_CANCELED","","",N,N],[17,"AIO_NOTCANCELED","","",N,N],[17,"AIO_ALLDONE","","",N,N],[17,"LIO_READ","","",N,N],[17,"LIO_WRITE","","",N,N],[17,"LIO_NOP","","",N,N],[17,"LIO_WAIT","","",N,N],[17,"LIO_NOWAIT","","",N,N],[17,"MREMAP_MAYMOVE","","",N,N],[17,"MREMAP_FIXED","","",N,N],[17,"PR_SET_PDEATHSIG","","",N,N],[17,"PR_GET_PDEATHSIG","","",N,N],[17,"PR_GET_DUMPABLE","","",N,N],[17,"PR_SET_DUMPABLE","","",N,N],[17,"PR_GET_UNALIGN","","",N,N],[17,"PR_SET_UNALIGN","","",N,N],[17,"PR_UNALIGN_NOPRINT","","",N,N],[17,"PR_UNALIGN_SIGBUS","","",N,N],[17,"PR_GET_KEEPCAPS","","",N,N],[17,"PR_SET_KEEPCAPS","","",N,N],[17,"PR_GET_FPEMU","","",N,N],[17,"PR_SET_FPEMU","","",N,N],[17,"PR_FPEMU_NOPRINT","","",N,N],[17,"PR_FPEMU_SIGFPE","","",N,N],[17,"PR_GET_FPEXC","","",N,N],[17,"PR_SET_FPEXC","","",N,N],[17,"PR_FP_EXC_SW_ENABLE","","",N,N],[17,"PR_FP_EXC_DIV","","",N,N],[17,"PR_FP_EXC_OVF","","",N,N],[17,"PR_FP_EXC_UND","","",N,N],[17,"PR_FP_EXC_RES","","",N,N],[17,"PR_FP_EXC_INV","","",N,N],[17,"PR_FP_EXC_DISABLED","","",N,N],[17,"PR_FP_EXC_NONRECOV","","",N,N],[17,"PR_FP_EXC_ASYNC","","",N,N],[17,"PR_FP_EXC_PRECISE","","",N,N],[17,"PR_GET_TIMING","","",N,N],[17,"PR_SET_TIMING","","",N,N],[17,"PR_TIMING_STATISTICAL","","",N,N],[17,"PR_TIMING_TIMESTAMP","","",N,N],[17,"PR_SET_NAME","","",N,N],[17,"PR_GET_NAME","","",N,N],[17,"PR_GET_ENDIAN","","",N,N],[17,"PR_SET_ENDIAN","","",N,N],[17,"PR_ENDIAN_BIG","","",N,N],[17,"PR_ENDIAN_LITTLE","","",N,N],[17,"PR_ENDIAN_PPC_LITTLE","","",N,N],[17,"PR_GET_SECCOMP","","",N,N],[17,"PR_SET_SECCOMP","","",N,N],[17,"PR_CAPBSET_READ","","",N,N],[17,"PR_CAPBSET_DROP","","",N,N],[17,"PR_GET_TSC","","",N,N],[17,"PR_SET_TSC","","",N,N],[17,"PR_TSC_ENABLE","","",N,N],[17,"PR_TSC_SIGSEGV","","",N,N],[17,"PR_GET_SECUREBITS","","",N,N],[17,"PR_SET_SECUREBITS","","",N,N],[17,"PR_SET_TIMERSLACK","","",N,N],[17,"PR_GET_TIMERSLACK","","",N,N],[17,"PR_TASK_PERF_EVENTS_DISABLE","","",N,N],[17,"PR_TASK_PERF_EVENTS_ENABLE","","",N,N],[17,"PR_MCE_KILL","","",N,N],[17,"PR_MCE_KILL_CLEAR","","",N,N],[17,"PR_MCE_KILL_SET","","",N,N],[17,"PR_MCE_KILL_LATE","","",N,N],[17,"PR_MCE_KILL_EARLY","","",N,N],[17,"PR_MCE_KILL_DEFAULT","","",N,N],[17,"PR_MCE_KILL_GET","","",N,N],[17,"PR_SET_MM","","",N,N],[17,"PR_SET_MM_START_CODE","","",N,N],[17,"PR_SET_MM_END_CODE","","",N,N],[17,"PR_SET_MM_START_DATA","","",N,N],[17,"PR_SET_MM_END_DATA","","",N,N],[17,"PR_SET_MM_START_STACK","","",N,N],[17,"PR_SET_MM_START_BRK","","",N,N],[17,"PR_SET_MM_BRK","","",N,N],[17,"PR_SET_MM_ARG_START","","",N,N],[17,"PR_SET_MM_ARG_END","","",N,N],[17,"PR_SET_MM_ENV_START","","",N,N],[17,"PR_SET_MM_ENV_END","","",N,N],[17,"PR_SET_MM_AUXV","","",N,N],[17,"PR_SET_MM_EXE_FILE","","",N,N],[17,"PR_SET_MM_MAP","","",N,N],[17,"PR_SET_MM_MAP_SIZE","","",N,N],[17,"PR_SET_PTRACER","","",N,N],[17,"PR_SET_CHILD_SUBREAPER","","",N,N],[17,"PR_GET_CHILD_SUBREAPER","","",N,N],[17,"PR_SET_NO_NEW_PRIVS","","",N,N],[17,"PR_GET_NO_NEW_PRIVS","","",N,N],[17,"PR_GET_TID_ADDRESS","","",N,N],[17,"PR_SET_THP_DISABLE","","",N,N],[17,"PR_GET_THP_DISABLE","","",N,N],[17,"PR_MPX_ENABLE_MANAGEMENT","","",N,N],[17,"PR_MPX_DISABLE_MANAGEMENT","","",N,N],[17,"PR_SET_FP_MODE","","",N,N],[17,"PR_GET_FP_MODE","","",N,N],[17,"PR_FP_MODE_FR","","",N,N],[17,"PR_FP_MODE_FRE","","",N,N],[17,"PR_CAP_AMBIENT","","",N,N],[17,"PR_CAP_AMBIENT_IS_SET","","",N,N],[17,"PR_CAP_AMBIENT_RAISE","","",N,N],[17,"PR_CAP_AMBIENT_LOWER","","",N,N],[17,"PR_CAP_AMBIENT_CLEAR_ALL","","",N,N],[17,"GRND_NONBLOCK","","",N,N],[17,"GRND_RANDOM","","",N,N],[17,"SECCOMP_MODE_DISABLED","","",N,N],[17,"SECCOMP_MODE_STRICT","","",N,N],[17,"SECCOMP_MODE_FILTER","","",N,N],[17,"ITIMER_REAL","","",N,N],[17,"ITIMER_VIRTUAL","","",N,N],[17,"ITIMER_PROF","","",N,N],[17,"TFD_CLOEXEC","","",N,N],[17,"TFD_NONBLOCK","","",N,N],[17,"TFD_TIMER_ABSTIME","","",N,N],[17,"XATTR_CREATE","","",N,N],[17,"XATTR_REPLACE","","",N,N],[17,"_POSIX_VDISABLE","","",N,N],[17,"FALLOC_FL_KEEP_SIZE","","",N,N],[17,"FALLOC_FL_PUNCH_HOLE","","",N,N],[17,"FALLOC_FL_COLLAPSE_RANGE","","",N,N],[17,"FALLOC_FL_ZERO_RANGE","","",N,N],[17,"FALLOC_FL_INSERT_RANGE","","",N,N],[17,"FALLOC_FL_UNSHARE_RANGE","","",N,N],[17,"ENOATTR","","",N,N],[17,"SO_ORIGINAL_DST","","",N,N],[17,"IUTF8","","",N,N],[17,"CMSPAR","","",N,N],[17,"MFD_CLOEXEC","","",N,N],[17,"MFD_ALLOW_SEALING","","",N,N],[17,"PT_NULL","","",N,N],[17,"PT_LOAD","","",N,N],[17,"PT_DYNAMIC","","",N,N],[17,"PT_INTERP","","",N,N],[17,"PT_NOTE","","",N,N],[17,"PT_SHLIB","","",N,N],[17,"PT_PHDR","","",N,N],[17,"PT_TLS","","",N,N],[17,"PT_NUM","","",N,N],[17,"PT_LOOS","","",N,N],[17,"PT_GNU_EH_FRAME","","",N,N],[17,"PT_GNU_STACK","","",N,N],[17,"PT_GNU_RELRO","","",N,N],[17,"ETH_ALEN","","",N,N],[17,"ETH_HLEN","","",N,N],[17,"ETH_ZLEN","","",N,N],[17,"ETH_DATA_LEN","","",N,N],[17,"ETH_FRAME_LEN","","",N,N],[17,"ETH_FCS_LEN","","",N,N],[17,"ETH_P_LOOP","","",N,N],[17,"ETH_P_PUP","","",N,N],[17,"ETH_P_PUPAT","","",N,N],[17,"ETH_P_IP","","",N,N],[17,"ETH_P_X25","","",N,N],[17,"ETH_P_ARP","","",N,N],[17,"ETH_P_BPQ","","",N,N],[17,"ETH_P_IEEEPUP","","",N,N],[17,"ETH_P_IEEEPUPAT","","",N,N],[17,"ETH_P_BATMAN","","",N,N],[17,"ETH_P_DEC","","",N,N],[17,"ETH_P_DNA_DL","","",N,N],[17,"ETH_P_DNA_RC","","",N,N],[17,"ETH_P_DNA_RT","","",N,N],[17,"ETH_P_LAT","","",N,N],[17,"ETH_P_DIAG","","",N,N],[17,"ETH_P_CUST","","",N,N],[17,"ETH_P_SCA","","",N,N],[17,"ETH_P_TEB","","",N,N],[17,"ETH_P_RARP","","",N,N],[17,"ETH_P_ATALK","","",N,N],[17,"ETH_P_AARP","","",N,N],[17,"ETH_P_8021Q","","",N,N],[17,"ETH_P_IPX","","",N,N],[17,"ETH_P_IPV6","","",N,N],[17,"ETH_P_PAUSE","","",N,N],[17,"ETH_P_SLOW","","",N,N],[17,"ETH_P_WCCP","","",N,N],[17,"ETH_P_MPLS_UC","","",N,N],[17,"ETH_P_MPLS_MC","","",N,N],[17,"ETH_P_ATMMPOA","","",N,N],[17,"ETH_P_PPP_DISC","","",N,N],[17,"ETH_P_PPP_SES","","",N,N],[17,"ETH_P_LINK_CTL","","",N,N],[17,"ETH_P_ATMFATE","","",N,N],[17,"ETH_P_PAE","","",N,N],[17,"ETH_P_AOE","","",N,N],[17,"ETH_P_8021AD","","",N,N],[17,"ETH_P_802_EX1","","",N,N],[17,"ETH_P_TIPC","","",N,N],[17,"ETH_P_MACSEC","","",N,N],[17,"ETH_P_8021AH","","",N,N],[17,"ETH_P_MVRP","","",N,N],[17,"ETH_P_1588","","",N,N],[17,"ETH_P_PRP","","",N,N],[17,"ETH_P_FCOE","","",N,N],[17,"ETH_P_TDLS","","",N,N],[17,"ETH_P_FIP","","",N,N],[17,"ETH_P_80221","","",N,N],[17,"ETH_P_LOOPBACK","","",N,N],[17,"ETH_P_QINQ1","","",N,N],[17,"ETH_P_QINQ2","","",N,N],[17,"ETH_P_QINQ3","","",N,N],[17,"ETH_P_EDSA","","",N,N],[17,"ETH_P_AF_IUCV","","",N,N],[17,"ETH_P_802_3_MIN","","",N,N],[17,"ETH_P_802_3","","",N,N],[17,"ETH_P_AX25","","",N,N],[17,"ETH_P_ALL","","",N,N],[17,"ETH_P_802_2","","",N,N],[17,"ETH_P_SNAP","","",N,N],[17,"ETH_P_DDCMP","","",N,N],[17,"ETH_P_WAN_PPP","","",N,N],[17,"ETH_P_PPP_MP","","",N,N],[17,"ETH_P_LOCALTALK","","",N,N],[17,"ETH_P_CANFD","","",N,N],[17,"ETH_P_PPPTALK","","",N,N],[17,"ETH_P_TR_802_2","","",N,N],[17,"ETH_P_MOBITEX","","",N,N],[17,"ETH_P_CONTROL","","",N,N],[17,"ETH_P_IRDA","","",N,N],[17,"ETH_P_ECONET","","",N,N],[17,"ETH_P_HDLC","","",N,N],[17,"ETH_P_ARCNET","","",N,N],[17,"ETH_P_DSA","","",N,N],[17,"ETH_P_TRAILER","","",N,N],[17,"ETH_P_PHONET","","",N,N],[17,"ETH_P_IEEE802154","","",N,N],[17,"ETH_P_CAIF","","",N,N],[17,"POSIX_SPAWN_RESETIDS","","",N,N],[17,"POSIX_SPAWN_SETPGROUP","","",N,N],[17,"POSIX_SPAWN_SETSIGDEF","","",N,N],[17,"POSIX_SPAWN_SETSIGMASK","","",N,N],[17,"POSIX_SPAWN_SETSCHEDPARAM","","",N,N],[17,"POSIX_SPAWN_SETSCHEDULER","","",N,N],[17,"NLMSG_NOOP","","",N,N],[17,"NLMSG_ERROR","","",N,N],[17,"NLMSG_DONE","","",N,N],[17,"NLMSG_OVERRUN","","",N,N],[17,"NLMSG_MIN_TYPE","","",N,N],[17,"GENL_NAMSIZ","","",N,N],[17,"GENL_MIN_ID","","",N,N],[17,"GENL_MAX_ID","","",N,N],[17,"GENL_ADMIN_PERM","","",N,N],[17,"GENL_CMD_CAP_DO","","",N,N],[17,"GENL_CMD_CAP_DUMP","","",N,N],[17,"GENL_CMD_CAP_HASPOL","","",N,N],[17,"GENL_ID_CTRL","","",N,N],[17,"CTRL_CMD_UNSPEC","","",N,N],[17,"CTRL_CMD_NEWFAMILY","","",N,N],[17,"CTRL_CMD_DELFAMILY","","",N,N],[17,"CTRL_CMD_GETFAMILY","","",N,N],[17,"CTRL_CMD_NEWOPS","","",N,N],[17,"CTRL_CMD_DELOPS","","",N,N],[17,"CTRL_CMD_GETOPS","","",N,N],[17,"CTRL_CMD_NEWMCAST_GRP","","",N,N],[17,"CTRL_CMD_DELMCAST_GRP","","",N,N],[17,"CTRL_CMD_GETMCAST_GRP","","",N,N],[17,"CTRL_ATTR_UNSPEC","","",N,N],[17,"CTRL_ATTR_FAMILY_ID","","",N,N],[17,"CTRL_ATTR_FAMILY_NAME","","",N,N],[17,"CTRL_ATTR_VERSION","","",N,N],[17,"CTRL_ATTR_HDRSIZE","","",N,N],[17,"CTRL_ATTR_MAXATTR","","",N,N],[17,"CTRL_ATTR_OPS","","",N,N],[17,"CTRL_ATTR_MCAST_GROUPS","","",N,N],[17,"CTRL_ATTR_OP_UNSPEC","","",N,N],[17,"CTRL_ATTR_OP_ID","","",N,N],[17,"CTRL_ATTR_OP_FLAGS","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_UNSPEC","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_NAME","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_ID","","",N,N],[17,"NF_DROP","","",N,N],[17,"NF_ACCEPT","","",N,N],[17,"NF_STOLEN","","",N,N],[17,"NF_QUEUE","","",N,N],[17,"NF_REPEAT","","",N,N],[17,"NF_STOP","","",N,N],[17,"NF_MAX_VERDICT","","",N,N],[17,"NF_VERDICT_MASK","","",N,N],[17,"NF_VERDICT_FLAG_QUEUE_BYPASS","","",N,N],[17,"NF_VERDICT_QMASK","","",N,N],[17,"NF_VERDICT_QBITS","","",N,N],[17,"NF_VERDICT_BITS","","",N,N],[17,"NF_INET_PRE_ROUTING","","",N,N],[17,"NF_INET_LOCAL_IN","","",N,N],[17,"NF_INET_FORWARD","","",N,N],[17,"NF_INET_LOCAL_OUT","","",N,N],[17,"NF_INET_POST_ROUTING","","",N,N],[17,"NF_INET_NUMHOOKS","","",N,N],[17,"NFPROTO_UNSPEC","","",N,N],[17,"NFPROTO_IPV4","","",N,N],[17,"NFPROTO_ARP","","",N,N],[17,"NFPROTO_BRIDGE","","",N,N],[17,"NFPROTO_IPV6","","",N,N],[17,"NFPROTO_DECNET","","",N,N],[17,"NFPROTO_NUMPROTO","","",N,N],[17,"NF_IP_PRE_ROUTING","","",N,N],[17,"NF_IP_LOCAL_IN","","",N,N],[17,"NF_IP_FORWARD","","",N,N],[17,"NF_IP_LOCAL_OUT","","",N,N],[17,"NF_IP_POST_ROUTING","","",N,N],[17,"NF_IP_NUMHOOKS","","",N,N],[17,"NF_IP_PRI_FIRST","","",N,N],[17,"NF_IP_PRI_CONNTRACK_DEFRAG","","",N,N],[17,"NF_IP_PRI_RAW","","",N,N],[17,"NF_IP_PRI_SELINUX_FIRST","","",N,N],[17,"NF_IP_PRI_CONNTRACK","","",N,N],[17,"NF_IP_PRI_MANGLE","","",N,N],[17,"NF_IP_PRI_NAT_DST","","",N,N],[17,"NF_IP_PRI_FILTER","","",N,N],[17,"NF_IP_PRI_SECURITY","","",N,N],[17,"NF_IP_PRI_NAT_SRC","","",N,N],[17,"NF_IP_PRI_SELINUX_LAST","","",N,N],[17,"NF_IP_PRI_CONNTRACK_HELPER","","",N,N],[17,"NF_IP_PRI_CONNTRACK_CONFIRM","","",N,N],[17,"NF_IP_PRI_LAST","","",N,N],[17,"NF_IP6_PRE_ROUTING","","",N,N],[17,"NF_IP6_LOCAL_IN","","",N,N],[17,"NF_IP6_FORWARD","","",N,N],[17,"NF_IP6_LOCAL_OUT","","",N,N],[17,"NF_IP6_POST_ROUTING","","",N,N],[17,"NF_IP6_NUMHOOKS","","",N,N],[17,"NF_IP6_PRI_FIRST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK_DEFRAG","","",N,N],[17,"NF_IP6_PRI_RAW","","",N,N],[17,"NF_IP6_PRI_SELINUX_FIRST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK","","",N,N],[17,"NF_IP6_PRI_MANGLE","","",N,N],[17,"NF_IP6_PRI_NAT_DST","","",N,N],[17,"NF_IP6_PRI_FILTER","","",N,N],[17,"NF_IP6_PRI_SECURITY","","",N,N],[17,"NF_IP6_PRI_NAT_SRC","","",N,N],[17,"NF_IP6_PRI_SELINUX_LAST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK_HELPER","","",N,N],[17,"NF_IP6_PRI_LAST","","",N,N],[17,"SIOCADDRT","","",N,N],[17,"SIOCDELRT","","",N,N],[17,"SIOCGIFNAME","","",N,N],[17,"SIOCSIFLINK","","",N,N],[17,"SIOCGIFCONF","","",N,N],[17,"SIOCGIFFLAGS","","",N,N],[17,"SIOCSIFFLAGS","","",N,N],[17,"SIOCGIFADDR","","",N,N],[17,"SIOCSIFADDR","","",N,N],[17,"SIOCGIFDSTADDR","","",N,N],[17,"SIOCSIFDSTADDR","","",N,N],[17,"SIOCGIFBRDADDR","","",N,N],[17,"SIOCSIFBRDADDR","","",N,N],[17,"SIOCGIFNETMASK","","",N,N],[17,"SIOCSIFNETMASK","","",N,N],[17,"SIOCGIFMETRIC","","",N,N],[17,"SIOCSIFMETRIC","","",N,N],[17,"SIOCGIFMEM","","",N,N],[17,"SIOCSIFMEM","","",N,N],[17,"SIOCGIFMTU","","",N,N],[17,"SIOCSIFMTU","","",N,N],[17,"SIOCSIFHWADDR","","",N,N],[17,"SIOCGIFENCAP","","",N,N],[17,"SIOCSIFENCAP","","",N,N],[17,"SIOCGIFHWADDR","","",N,N],[17,"SIOCGIFSLAVE","","",N,N],[17,"SIOCSIFSLAVE","","",N,N],[17,"SIOCADDMULTI","","",N,N],[17,"SIOCDELMULTI","","",N,N],[17,"SIOCDARP","","",N,N],[17,"SIOCGARP","","",N,N],[17,"SIOCSARP","","",N,N],[17,"SIOCDRARP","","",N,N],[17,"SIOCGRARP","","",N,N],[17,"SIOCSRARP","","",N,N],[17,"SIOCGIFMAP","","",N,N],[17,"SIOCSIFMAP","","",N,N],[17,"IPTOS_TOS_MASK","","",N,N],[17,"IPTOS_PREC_MASK","","",N,N],[17,"RTF_UP","","",N,N],[17,"RTF_GATEWAY","","",N,N],[17,"RTF_HOST","","",N,N],[17,"RTF_REINSTATE","","",N,N],[17,"RTF_DYNAMIC","","",N,N],[17,"RTF_MODIFIED","","",N,N],[17,"RTF_MTU","","",N,N],[17,"RTF_MSS","","",N,N],[17,"RTF_WINDOW","","",N,N],[17,"RTF_IRTT","","",N,N],[17,"RTF_REJECT","","",N,N],[17,"RTF_STATIC","","",N,N],[17,"RTF_XRESOLVE","","",N,N],[17,"RTF_NOFORWARD","","",N,N],[17,"RTF_THROW","","",N,N],[17,"RTF_NOPMTUDISC","","",N,N],[17,"RTF_DEFAULT","","",N,N],[17,"RTF_ALLONLINK","","",N,N],[17,"RTF_ADDRCONF","","",N,N],[17,"RTF_LINKRT","","",N,N],[17,"RTF_NONEXTHOP","","",N,N],[17,"RTF_CACHE","","",N,N],[17,"RTF_FLOW","","",N,N],[17,"RTF_POLICY","","",N,N],[17,"RTCF_VALVE","","",N,N],[17,"RTCF_MASQ","","",N,N],[17,"RTCF_NAT","","",N,N],[17,"RTCF_DOREDIRECT","","",N,N],[17,"RTCF_LOG","","",N,N],[17,"RTCF_DIRECTSRC","","",N,N],[17,"RTF_LOCAL","","",N,N],[17,"RTF_INTERFACE","","",N,N],[17,"RTF_MULTICAST","","",N,N],[17,"RTF_BROADCAST","","",N,N],[17,"RTF_NAT","","",N,N],[17,"RTF_ADDRCLASSMASK","","",N,N],[17,"RT_CLASS_UNSPEC","","",N,N],[17,"RT_CLASS_DEFAULT","","",N,N],[17,"RT_CLASS_MAIN","","",N,N],[17,"RT_CLASS_LOCAL","","",N,N],[17,"RT_CLASS_MAX","","",N,N],[17,"RTMSG_OVERRUN","","",N,N],[17,"RTMSG_NEWDEVICE","","",N,N],[17,"RTMSG_DELDEVICE","","",N,N],[17,"RTMSG_NEWROUTE","","",N,N],[17,"RTMSG_DELROUTE","","",N,N],[17,"RTMSG_NEWRULE","","",N,N],[17,"RTMSG_DELRULE","","",N,N],[17,"RTMSG_CONTROL","","",N,N],[17,"RTMSG_AR_FAILED","","",N,N],[11,"clone","libc","",39,[[["self"]],["dirent"]]],[11,"clone","","",40,[[["self"]],["dirent64"]]],[11,"clone","","",41,[[["self"]],["rlimit64"]]],[11,"clone","","",42,[[["self"]],["glob_t"]]],[11,"clone","","",43,[[["self"]],["pthread_mutex_t"]]],[11,"clone","","",44,[[["self"]],["pthread_rwlock_t"]]],[11,"clone","","",45,[[["self"]],["pthread_mutexattr_t"]]],[11,"clone","","",46,[[["self"]],["pthread_rwlockattr_t"]]],[11,"clone","","",47,[[["self"]],["pthread_cond_t"]]],[11,"clone","","",48,[[["self"]],["pthread_condattr_t"]]],[11,"clone","","",49,[[["self"]],["passwd"]]],[11,"clone","","",50,[[["self"]],["spwd"]]],[11,"clone","","",51,[[["self"]],["dqblk"]]],[11,"clone","","",52,[[["self"]],["signalfd_siginfo"]]],[11,"clone","","",53,[[["self"]],["itimerspec"]]],[11,"clone","","",54,[[["self"]],["fsid_t"]]],[11,"clone","","",55,[[["self"]],["mq_attr"]]],[11,"clone","","",56,[[["self"]],["cpu_set_t"]]],[11,"clone","","",57,[[["self"]],["if_nameindex"]]],[11,"clone","","",58,[[["self"]],["msginfo"]]],[11,"clone","","",59,[[["self"]],["mmsghdr"]]],[11,"clone","","",60,[[["self"]],["sembuf"]]],[11,"clone","","",61,[[["self"]],["input_event"]]],[11,"clone","","",62,[[["self"]],["input_id"]]],[11,"clone","","",63,[[["self"]],["input_absinfo"]]],[11,"clone","","",64,[[["self"]],["input_keymap_entry"]]],[11,"clone","","",65,[[["self"]],["input_mask"]]],[11,"clone","","",66,[[["self"]],["ff_replay"]]],[11,"clone","","",67,[[["self"]],["ff_trigger"]]],[11,"clone","","",68,[[["self"]],["ff_envelope"]]],[11,"clone","","",69,[[["self"]],["ff_constant_effect"]]],[11,"clone","","",70,[[["self"]],["ff_ramp_effect"]]],[11,"clone","","",71,[[["self"]],["ff_condition_effect"]]],[11,"clone","","",72,[[["self"]],["ff_periodic_effect"]]],[11,"clone","","",73,[[["self"]],["ff_rumble_effect"]]],[11,"clone","","",74,[[["self"]],["ff_effect"]]],[11,"clone","","",75,[[["self"]],["dl_phdr_info"]]],[11,"clone","","",76,[[["self"]],["elf32_phdr"]]],[11,"clone","","",77,[[["self"]],["elf64_phdr"]]],[11,"clone","","",78,[[["self"]],["ucred"]]],[11,"clone","","",79,[[["self"]],["mntent"]]],[11,"clone","","",80,[[["self"]],["posix_spawn_file_actions_t"]]],[11,"clone","","",81,[[["self"]],["posix_spawnattr_t"]]],[11,"clone","","",82,[[["self"]],["genlmsghdr"]]],[11,"clone","","",83,[[["self"]],["in6_pktinfo"]]],[6,"sa_family_t","libc::unix::notbsd","",N,N],[6,"pthread_key_t","","",N,N],[6,"speed_t","","",N,N],[6,"tcflag_t","","",N,N],[6,"clockid_t","","",N,N],[6,"key_t","","",N,N],[6,"id_t","","",N,N],[17,"ULONG_SIZE","","",N,N],[17,"EXIT_FAILURE","","",N,N],[17,"EXIT_SUCCESS","","",N,N],[17,"RAND_MAX","","",N,N],[17,"EOF","","",N,N],[17,"SEEK_SET","","",N,N],[17,"SEEK_CUR","","",N,N],[17,"SEEK_END","","",N,N],[17,"_IOFBF","","",N,N],[17,"_IONBF","","",N,N],[17,"_IOLBF","","",N,N],[17,"F_DUPFD","","",N,N],[17,"F_GETFD","","",N,N],[17,"F_SETFD","","",N,N],[17,"F_GETFL","","",N,N],[17,"F_SETFL","","",N,N],[17,"F_SETLEASE","","",N,N],[17,"F_GETLEASE","","",N,N],[17,"F_NOTIFY","","",N,N],[17,"F_CANCELLK","","",N,N],[17,"F_DUPFD_CLOEXEC","","",N,N],[17,"F_SETPIPE_SZ","","",N,N],[17,"F_GETPIPE_SZ","","",N,N],[17,"F_ADD_SEALS","","",N,N],[17,"F_GET_SEALS","","",N,N],[17,"F_SEAL_SEAL","","",N,N],[17,"F_SEAL_SHRINK","","",N,N],[17,"F_SEAL_GROW","","",N,N],[17,"F_SEAL_WRITE","","",N,N],[17,"SIGTRAP","","",N,N],[17,"PTHREAD_CREATE_JOINABLE","","",N,N],[17,"PTHREAD_CREATE_DETACHED","","",N,N],[17,"CLOCK_REALTIME","","",N,N],[17,"CLOCK_MONOTONIC","","",N,N],[17,"CLOCK_PROCESS_CPUTIME_ID","","",N,N],[17,"CLOCK_THREAD_CPUTIME_ID","","",N,N],[17,"CLOCK_MONOTONIC_RAW","","",N,N],[17,"CLOCK_REALTIME_COARSE","","",N,N],[17,"CLOCK_MONOTONIC_COARSE","","",N,N],[17,"CLOCK_BOOTTIME","","",N,N],[17,"CLOCK_REALTIME_ALARM","","",N,N],[17,"CLOCK_BOOTTIME_ALARM","","",N,N],[17,"TIMER_ABSTIME","","",N,N],[17,"RLIMIT_CPU","","",N,N],[17,"RLIMIT_FSIZE","","",N,N],[17,"RLIMIT_DATA","","",N,N],[17,"RLIMIT_STACK","","",N,N],[17,"RLIMIT_CORE","","",N,N],[17,"RLIMIT_LOCKS","","",N,N],[17,"RLIMIT_SIGPENDING","","",N,N],[17,"RLIMIT_MSGQUEUE","","",N,N],[17,"RLIMIT_NICE","","",N,N],[17,"RLIMIT_RTPRIO","","",N,N],[17,"RUSAGE_SELF","","",N,N],[17,"O_RDONLY","","",N,N],[17,"O_WRONLY","","",N,N],[17,"O_RDWR","","",N,N],[17,"SOCK_CLOEXEC","","",N,N],[17,"S_IFIFO","","",N,N],[17,"S_IFCHR","","",N,N],[17,"S_IFBLK","","",N,N],[17,"S_IFDIR","","",N,N],[17,"S_IFREG","","",N,N],[17,"S_IFLNK","","",N,N],[17,"S_IFSOCK","","",N,N],[17,"S_IFMT","","",N,N],[17,"S_IRWXU","","",N,N],[17,"S_IXUSR","","",N,N],[17,"S_IWUSR","","",N,N],[17,"S_IRUSR","","",N,N],[17,"S_IRWXG","","",N,N],[17,"S_IXGRP","","",N,N],[17,"S_IWGRP","","",N,N],[17,"S_IRGRP","","",N,N],[17,"S_IRWXO","","",N,N],[17,"S_IXOTH","","",N,N],[17,"S_IWOTH","","",N,N],[17,"S_IROTH","","",N,N],[17,"F_OK","","",N,N],[17,"R_OK","","",N,N],[17,"W_OK","","",N,N],[17,"X_OK","","",N,N],[17,"STDIN_FILENO","","",N,N],[17,"STDOUT_FILENO","","",N,N],[17,"STDERR_FILENO","","",N,N],[17,"SIGHUP","","",N,N],[17,"SIGINT","","",N,N],[17,"SIGQUIT","","",N,N],[17,"SIGILL","","",N,N],[17,"SIGABRT","","",N,N],[17,"SIGFPE","","",N,N],[17,"SIGKILL","","",N,N],[17,"SIGSEGV","","",N,N],[17,"SIGPIPE","","",N,N],[17,"SIGALRM","","",N,N],[17,"SIGTERM","","",N,N],[17,"PROT_NONE","","",N,N],[17,"PROT_READ","","",N,N],[17,"PROT_WRITE","","",N,N],[17,"PROT_EXEC","","",N,N],[17,"LC_CTYPE","","",N,N],[17,"LC_NUMERIC","","",N,N],[17,"LC_TIME","","",N,N],[17,"LC_COLLATE","","",N,N],[17,"LC_MONETARY","","",N,N],[17,"LC_MESSAGES","","",N,N],[17,"LC_ALL","","",N,N],[17,"LC_CTYPE_MASK","","",N,N],[17,"LC_NUMERIC_MASK","","",N,N],[17,"LC_TIME_MASK","","",N,N],[17,"LC_COLLATE_MASK","","",N,N],[17,"LC_MONETARY_MASK","","",N,N],[17,"LC_MESSAGES_MASK","","",N,N],[17,"MAP_FILE","","",N,N],[17,"MAP_SHARED","","",N,N],[17,"MAP_PRIVATE","","",N,N],[17,"MAP_FIXED","","",N,N],[17,"MAP_FAILED","","",N,N],[17,"MS_ASYNC","","",N,N],[17,"MS_INVALIDATE","","",N,N],[17,"MS_SYNC","","",N,N],[17,"MS_RDONLY","","",N,N],[17,"MS_NOSUID","","",N,N],[17,"MS_NODEV","","",N,N],[17,"MS_NOEXEC","","",N,N],[17,"MS_SYNCHRONOUS","","",N,N],[17,"MS_REMOUNT","","",N,N],[17,"MS_MANDLOCK","","",N,N],[17,"MS_DIRSYNC","","",N,N],[17,"MS_NOATIME","","",N,N],[17,"MS_NODIRATIME","","",N,N],[17,"MS_BIND","","",N,N],[17,"MS_MOVE","","",N,N],[17,"MS_REC","","",N,N],[17,"MS_SILENT","","",N,N],[17,"MS_POSIXACL","","",N,N],[17,"MS_UNBINDABLE","","",N,N],[17,"MS_PRIVATE","","",N,N],[17,"MS_SLAVE","","",N,N],[17,"MS_SHARED","","",N,N],[17,"MS_RELATIME","","",N,N],[17,"MS_KERNMOUNT","","",N,N],[17,"MS_I_VERSION","","",N,N],[17,"MS_STRICTATIME","","",N,N],[17,"MS_ACTIVE","","",N,N],[17,"MS_NOUSER","","",N,N],[17,"MS_MGC_VAL","","",N,N],[17,"MS_MGC_MSK","","",N,N],[17,"MS_RMT_MASK","","",N,N],[17,"EPERM","","",N,N],[17,"ENOENT","","",N,N],[17,"ESRCH","","",N,N],[17,"EINTR","","",N,N],[17,"EIO","","",N,N],[17,"ENXIO","","",N,N],[17,"E2BIG","","",N,N],[17,"ENOEXEC","","",N,N],[17,"EBADF","","",N,N],[17,"ECHILD","","",N,N],[17,"EAGAIN","","",N,N],[17,"ENOMEM","","",N,N],[17,"EACCES","","",N,N],[17,"EFAULT","","",N,N],[17,"ENOTBLK","","",N,N],[17,"EBUSY","","",N,N],[17,"EEXIST","","",N,N],[17,"EXDEV","","",N,N],[17,"ENODEV","","",N,N],[17,"ENOTDIR","","",N,N],[17,"EISDIR","","",N,N],[17,"EINVAL","","",N,N],[17,"ENFILE","","",N,N],[17,"EMFILE","","",N,N],[17,"ENOTTY","","",N,N],[17,"ETXTBSY","","",N,N],[17,"EFBIG","","",N,N],[17,"ENOSPC","","",N,N],[17,"ESPIPE","","",N,N],[17,"EROFS","","",N,N],[17,"EMLINK","","",N,N],[17,"EPIPE","","",N,N],[17,"EDOM","","",N,N],[17,"ERANGE","","",N,N],[17,"EWOULDBLOCK","","",N,N],[17,"SCM_RIGHTS","","",N,N],[17,"SCM_CREDENTIALS","","",N,N],[17,"PROT_GROWSDOWN","","",N,N],[17,"PROT_GROWSUP","","",N,N],[17,"MAP_TYPE","","",N,N],[17,"MADV_NORMAL","","",N,N],[17,"MADV_RANDOM","","",N,N],[17,"MADV_SEQUENTIAL","","",N,N],[17,"MADV_WILLNEED","","",N,N],[17,"MADV_DONTNEED","","",N,N],[17,"MADV_FREE","","",N,N],[17,"MADV_REMOVE","","",N,N],[17,"MADV_DONTFORK","","",N,N],[17,"MADV_DOFORK","","",N,N],[17,"MADV_MERGEABLE","","",N,N],[17,"MADV_UNMERGEABLE","","",N,N],[17,"MADV_HUGEPAGE","","",N,N],[17,"MADV_NOHUGEPAGE","","",N,N],[17,"MADV_DONTDUMP","","",N,N],[17,"MADV_DODUMP","","",N,N],[17,"MADV_HWPOISON","","",N,N],[17,"MADV_SOFT_OFFLINE","","",N,N],[17,"IFF_UP","","",N,N],[17,"IFF_BROADCAST","","",N,N],[17,"IFF_DEBUG","","",N,N],[17,"IFF_LOOPBACK","","",N,N],[17,"IFF_POINTOPOINT","","",N,N],[17,"IFF_NOTRAILERS","","",N,N],[17,"IFF_RUNNING","","",N,N],[17,"IFF_NOARP","","",N,N],[17,"IFF_PROMISC","","",N,N],[17,"IFF_ALLMULTI","","",N,N],[17,"IFF_MASTER","","",N,N],[17,"IFF_SLAVE","","",N,N],[17,"IFF_MULTICAST","","",N,N],[17,"IFF_PORTSEL","","",N,N],[17,"IFF_AUTOMEDIA","","",N,N],[17,"IFF_DYNAMIC","","",N,N],[17,"SOL_IP","","",N,N],[17,"SOL_TCP","","",N,N],[17,"SOL_UDP","","",N,N],[17,"SOL_IPV6","","",N,N],[17,"SOL_ICMPV6","","",N,N],[17,"SOL_RAW","","",N,N],[17,"SOL_DECNET","","",N,N],[17,"SOL_X25","","",N,N],[17,"SOL_PACKET","","",N,N],[17,"SOL_ATM","","",N,N],[17,"SOL_AAL","","",N,N],[17,"SOL_IRDA","","",N,N],[17,"SOL_NETBEUI","","",N,N],[17,"SOL_LLC","","",N,N],[17,"SOL_DCCP","","",N,N],[17,"SOL_NETLINK","","",N,N],[17,"SOL_TIPC","","",N,N],[17,"AF_UNSPEC","","",N,N],[17,"AF_UNIX","","",N,N],[17,"AF_LOCAL","","",N,N],[17,"AF_INET","","",N,N],[17,"AF_AX25","","",N,N],[17,"AF_IPX","","",N,N],[17,"AF_APPLETALK","","",N,N],[17,"AF_NETROM","","",N,N],[17,"AF_BRIDGE","","",N,N],[17,"AF_ATMPVC","","",N,N],[17,"AF_X25","","",N,N],[17,"AF_INET6","","",N,N],[17,"AF_ROSE","","",N,N],[17,"AF_DECnet","","",N,N],[17,"AF_NETBEUI","","",N,N],[17,"AF_SECURITY","","",N,N],[17,"AF_KEY","","",N,N],[17,"AF_NETLINK","","",N,N],[17,"AF_ROUTE","","",N,N],[17,"AF_PACKET","","",N,N],[17,"AF_ASH","","",N,N],[17,"AF_ECONET","","",N,N],[17,"AF_ATMSVC","","",N,N],[17,"AF_RDS","","",N,N],[17,"AF_SNA","","",N,N],[17,"AF_IRDA","","",N,N],[17,"AF_PPPOX","","",N,N],[17,"AF_WANPIPE","","",N,N],[17,"AF_LLC","","",N,N],[17,"AF_CAN","","",N,N],[17,"AF_TIPC","","",N,N],[17,"AF_BLUETOOTH","","",N,N],[17,"AF_IUCV","","",N,N],[17,"AF_RXRPC","","",N,N],[17,"AF_ISDN","","",N,N],[17,"AF_PHONET","","",N,N],[17,"AF_IEEE802154","","",N,N],[17,"AF_CAIF","","",N,N],[17,"AF_ALG","","",N,N],[17,"PF_UNSPEC","","",N,N],[17,"PF_UNIX","","",N,N],[17,"PF_LOCAL","","",N,N],[17,"PF_INET","","",N,N],[17,"PF_AX25","","",N,N],[17,"PF_IPX","","",N,N],[17,"PF_APPLETALK","","",N,N],[17,"PF_NETROM","","",N,N],[17,"PF_BRIDGE","","",N,N],[17,"PF_ATMPVC","","",N,N],[17,"PF_X25","","",N,N],[17,"PF_INET6","","",N,N],[17,"PF_ROSE","","",N,N],[17,"PF_DECnet","","",N,N],[17,"PF_NETBEUI","","",N,N],[17,"PF_SECURITY","","",N,N],[17,"PF_KEY","","",N,N],[17,"PF_NETLINK","","",N,N],[17,"PF_ROUTE","","",N,N],[17,"PF_PACKET","","",N,N],[17,"PF_ASH","","",N,N],[17,"PF_ECONET","","",N,N],[17,"PF_ATMSVC","","",N,N],[17,"PF_RDS","","",N,N],[17,"PF_SNA","","",N,N],[17,"PF_IRDA","","",N,N],[17,"PF_PPPOX","","",N,N],[17,"PF_WANPIPE","","",N,N],[17,"PF_LLC","","",N,N],[17,"PF_CAN","","",N,N],[17,"PF_TIPC","","",N,N],[17,"PF_BLUETOOTH","","",N,N],[17,"PF_IUCV","","",N,N],[17,"PF_RXRPC","","",N,N],[17,"PF_ISDN","","",N,N],[17,"PF_PHONET","","",N,N],[17,"PF_IEEE802154","","",N,N],[17,"PF_CAIF","","",N,N],[17,"PF_ALG","","",N,N],[17,"SOMAXCONN","","",N,N],[17,"MSG_OOB","","",N,N],[17,"MSG_PEEK","","",N,N],[17,"MSG_DONTROUTE","","",N,N],[17,"MSG_CTRUNC","","",N,N],[17,"MSG_TRUNC","","",N,N],[17,"MSG_DONTWAIT","","",N,N],[17,"MSG_EOR","","",N,N],[17,"MSG_WAITALL","","",N,N],[17,"MSG_FIN","","",N,N],[17,"MSG_SYN","","",N,N],[17,"MSG_CONFIRM","","",N,N],[17,"MSG_RST","","",N,N],[17,"MSG_ERRQUEUE","","",N,N],[17,"MSG_NOSIGNAL","","",N,N],[17,"MSG_MORE","","",N,N],[17,"MSG_WAITFORONE","","",N,N],[17,"MSG_FASTOPEN","","",N,N],[17,"MSG_CMSG_CLOEXEC","","",N,N],[17,"SCM_TIMESTAMP","","",N,N],[17,"SOCK_RAW","","",N,N],[17,"SOCK_RDM","","",N,N],[17,"IP_MULTICAST_IF","","",N,N],[17,"IP_MULTICAST_TTL","","",N,N],[17,"IP_MULTICAST_LOOP","","",N,N],[17,"IP_TTL","","",N,N],[17,"IP_HDRINCL","","",N,N],[17,"IP_PKTINFO","","",N,N],[17,"IP_ADD_MEMBERSHIP","","",N,N],[17,"IP_DROP_MEMBERSHIP","","",N,N],[17,"IP_TRANSPARENT","","",N,N],[17,"IPV6_UNICAST_HOPS","","",N,N],[17,"IPV6_MULTICAST_IF","","",N,N],[17,"IPV6_MULTICAST_HOPS","","",N,N],[17,"IPV6_MULTICAST_LOOP","","",N,N],[17,"IPV6_ADD_MEMBERSHIP","","",N,N],[17,"IPV6_DROP_MEMBERSHIP","","",N,N],[17,"IPV6_V6ONLY","","",N,N],[17,"IPV6_RECVPKTINFO","","",N,N],[17,"IPV6_PKTINFO","","",N,N],[17,"TCP_NODELAY","","",N,N],[17,"TCP_MAXSEG","","",N,N],[17,"TCP_CORK","","",N,N],[17,"TCP_KEEPIDLE","","",N,N],[17,"TCP_KEEPINTVL","","",N,N],[17,"TCP_KEEPCNT","","",N,N],[17,"TCP_SYNCNT","","",N,N],[17,"TCP_LINGER2","","",N,N],[17,"TCP_DEFER_ACCEPT","","",N,N],[17,"TCP_WINDOW_CLAMP","","",N,N],[17,"TCP_INFO","","",N,N],[17,"TCP_QUICKACK","","",N,N],[17,"TCP_CONGESTION","","",N,N],[17,"SO_DEBUG","","",N,N],[17,"SHUT_RD","","",N,N],[17,"SHUT_WR","","",N,N],[17,"SHUT_RDWR","","",N,N],[17,"LOCK_SH","","",N,N],[17,"LOCK_EX","","",N,N],[17,"LOCK_NB","","",N,N],[17,"LOCK_UN","","",N,N],[17,"SS_ONSTACK","","",N,N],[17,"SS_DISABLE","","",N,N],[17,"PATH_MAX","","",N,N],[17,"FD_SETSIZE","","",N,N],[17,"EPOLLIN","","",N,N],[17,"EPOLLPRI","","",N,N],[17,"EPOLLOUT","","",N,N],[17,"EPOLLRDNORM","","",N,N],[17,"EPOLLRDBAND","","",N,N],[17,"EPOLLWRNORM","","",N,N],[17,"EPOLLWRBAND","","",N,N],[17,"EPOLLMSG","","",N,N],[17,"EPOLLERR","","",N,N],[17,"EPOLLHUP","","",N,N],[17,"EPOLLET","","",N,N],[17,"EPOLL_CTL_ADD","","",N,N],[17,"EPOLL_CTL_MOD","","",N,N],[17,"EPOLL_CTL_DEL","","",N,N],[17,"MNT_DETACH","","",N,N],[17,"MNT_EXPIRE","","",N,N],[17,"Q_GETFMT","","",N,N],[17,"Q_GETINFO","","",N,N],[17,"Q_SETINFO","","",N,N],[17,"QIF_BLIMITS","","",N,N],[17,"QIF_SPACE","","",N,N],[17,"QIF_ILIMITS","","",N,N],[17,"QIF_INODES","","",N,N],[17,"QIF_BTIME","","",N,N],[17,"QIF_ITIME","","",N,N],[17,"QIF_LIMITS","","",N,N],[17,"QIF_USAGE","","",N,N],[17,"QIF_TIMES","","",N,N],[17,"QIF_ALL","","",N,N],[17,"MNT_FORCE","","",N,N],[17,"Q_SYNC","","",N,N],[17,"Q_QUOTAON","","",N,N],[17,"Q_QUOTAOFF","","",N,N],[17,"Q_GETQUOTA","","",N,N],[17,"Q_SETQUOTA","","",N,N],[17,"TCIOFF","","",N,N],[17,"TCION","","",N,N],[17,"TCOOFF","","",N,N],[17,"TCOON","","",N,N],[17,"TCIFLUSH","","",N,N],[17,"TCOFLUSH","","",N,N],[17,"TCIOFLUSH","","",N,N],[17,"NL0","","",N,N],[17,"NL1","","",N,N],[17,"TAB0","","",N,N],[17,"CR0","","",N,N],[17,"FF0","","",N,N],[17,"BS0","","",N,N],[17,"VT0","","",N,N],[17,"VERASE","","",N,N],[17,"VKILL","","",N,N],[17,"VINTR","","",N,N],[17,"VQUIT","","",N,N],[17,"VLNEXT","","",N,N],[17,"IGNBRK","","",N,N],[17,"BRKINT","","",N,N],[17,"IGNPAR","","",N,N],[17,"PARMRK","","",N,N],[17,"INPCK","","",N,N],[17,"ISTRIP","","",N,N],[17,"INLCR","","",N,N],[17,"IGNCR","","",N,N],[17,"ICRNL","","",N,N],[17,"IXANY","","",N,N],[17,"IMAXBEL","","",N,N],[17,"OPOST","","",N,N],[17,"CS5","","",N,N],[17,"CRTSCTS","","",N,N],[17,"ECHO","","",N,N],[17,"OCRNL","","",N,N],[17,"ONOCR","","",N,N],[17,"ONLRET","","",N,N],[17,"OFILL","","",N,N],[17,"OFDEL","","",N,N],[17,"CLONE_VM","","",N,N],[17,"CLONE_FS","","",N,N],[17,"CLONE_FILES","","",N,N],[17,"CLONE_SIGHAND","","",N,N],[17,"CLONE_PTRACE","","",N,N],[17,"CLONE_VFORK","","",N,N],[17,"CLONE_PARENT","","",N,N],[17,"CLONE_THREAD","","",N,N],[17,"CLONE_NEWNS","","",N,N],[17,"CLONE_SYSVSEM","","",N,N],[17,"CLONE_SETTLS","","",N,N],[17,"CLONE_PARENT_SETTID","","",N,N],[17,"CLONE_CHILD_CLEARTID","","",N,N],[17,"CLONE_DETACHED","","",N,N],[17,"CLONE_UNTRACED","","",N,N],[17,"CLONE_CHILD_SETTID","","",N,N],[17,"CLONE_NEWUTS","","",N,N],[17,"CLONE_NEWIPC","","",N,N],[17,"CLONE_NEWUSER","","",N,N],[17,"CLONE_NEWPID","","",N,N],[17,"CLONE_NEWNET","","",N,N],[17,"CLONE_IO","","",N,N],[17,"CLONE_NEWCGROUP","","",N,N],[17,"WNOHANG","","",N,N],[17,"WUNTRACED","","",N,N],[17,"WSTOPPED","","",N,N],[17,"WEXITED","","",N,N],[17,"WCONTINUED","","",N,N],[17,"WNOWAIT","","",N,N],[17,"PTRACE_O_TRACESYSGOOD","","",N,N],[17,"PTRACE_O_TRACEFORK","","",N,N],[17,"PTRACE_O_TRACEVFORK","","",N,N],[17,"PTRACE_O_TRACECLONE","","",N,N],[17,"PTRACE_O_TRACEEXEC","","",N,N],[17,"PTRACE_O_TRACEVFORKDONE","","",N,N],[17,"PTRACE_O_TRACEEXIT","","",N,N],[17,"PTRACE_O_TRACESECCOMP","","",N,N],[17,"PTRACE_O_EXITKILL","","",N,N],[17,"PTRACE_O_SUSPEND_SECCOMP","","",N,N],[17,"PTRACE_O_MASK","","",N,N],[17,"PTRACE_EVENT_FORK","","",N,N],[17,"PTRACE_EVENT_VFORK","","",N,N],[17,"PTRACE_EVENT_CLONE","","",N,N],[17,"PTRACE_EVENT_EXEC","","",N,N],[17,"PTRACE_EVENT_VFORK_DONE","","",N,N],[17,"PTRACE_EVENT_EXIT","","",N,N],[17,"PTRACE_EVENT_SECCOMP","","",N,N],[17,"__WNOTHREAD","","",N,N],[17,"__WALL","","",N,N],[17,"__WCLONE","","",N,N],[17,"SPLICE_F_MOVE","","",N,N],[17,"SPLICE_F_NONBLOCK","","",N,N],[17,"SPLICE_F_MORE","","",N,N],[17,"SPLICE_F_GIFT","","",N,N],[17,"RTLD_LOCAL","","",N,N],[17,"RTLD_LAZY","","",N,N],[17,"POSIX_FADV_NORMAL","","",N,N],[17,"POSIX_FADV_RANDOM","","",N,N],[17,"POSIX_FADV_SEQUENTIAL","","",N,N],[17,"POSIX_FADV_WILLNEED","","",N,N],[17,"AT_FDCWD","","",N,N],[17,"AT_SYMLINK_NOFOLLOW","","",N,N],[17,"AT_REMOVEDIR","","",N,N],[17,"AT_SYMLINK_FOLLOW","","",N,N],[17,"AT_NO_AUTOMOUNT","","",N,N],[17,"AT_EMPTY_PATH","","",N,N],[17,"LOG_CRON","","",N,N],[17,"LOG_AUTHPRIV","","",N,N],[17,"LOG_FTP","","",N,N],[17,"LOG_PERROR","","",N,N],[17,"PIPE_BUF","","",N,N],[17,"SI_LOAD_SHIFT","","",N,N],[17,"SIGEV_SIGNAL","","",N,N],[17,"SIGEV_NONE","","",N,N],[17,"SIGEV_THREAD","","",N,N],[17,"P_ALL","","",N,N],[17,"P_PID","","",N,N],[17,"P_PGID","","",N,N],[17,"UTIME_OMIT","","",N,N],[17,"UTIME_NOW","","",N,N],[17,"POLLIN","","",N,N],[17,"POLLPRI","","",N,N],[17,"POLLOUT","","",N,N],[17,"POLLERR","","",N,N],[17,"POLLHUP","","",N,N],[17,"POLLNVAL","","",N,N],[17,"POLLRDNORM","","",N,N],[17,"POLLRDBAND","","",N,N],[17,"IPTOS_LOWDELAY","","",N,N],[17,"IPTOS_THROUGHPUT","","",N,N],[17,"IPTOS_RELIABILITY","","",N,N],[17,"IPTOS_MINCOST","","",N,N],[17,"IPTOS_PREC_NETCONTROL","","",N,N],[17,"IPTOS_PREC_INTERNETCONTROL","","",N,N],[17,"IPTOS_PREC_CRITIC_ECP","","",N,N],[17,"IPTOS_PREC_FLASHOVERRIDE","","",N,N],[17,"IPTOS_PREC_FLASH","","",N,N],[17,"IPTOS_PREC_IMMEDIATE","","",N,N],[17,"IPTOS_PREC_PRIORITY","","",N,N],[17,"IPTOS_PREC_ROUTINE","","",N,N],[17,"IPOPT_COPY","","",N,N],[17,"IPOPT_CLASS_MASK","","",N,N],[17,"IPOPT_NUMBER_MASK","","",N,N],[17,"IPOPT_CONTROL","","",N,N],[17,"IPOPT_RESERVED1","","",N,N],[17,"IPOPT_MEASUREMENT","","",N,N],[17,"IPOPT_RESERVED2","","",N,N],[17,"IPOPT_END","","",N,N],[17,"IPOPT_NOOP","","",N,N],[17,"IPOPT_SEC","","",N,N],[17,"IPOPT_LSRR","","",N,N],[17,"IPOPT_TIMESTAMP","","",N,N],[17,"IPOPT_RR","","",N,N],[17,"IPOPT_SID","","",N,N],[17,"IPOPT_SSRR","","",N,N],[17,"IPOPT_RA","","",N,N],[17,"IPVERSION","","",N,N],[17,"MAXTTL","","",N,N],[17,"IPDEFTTL","","",N,N],[17,"IPOPT_OPTVAL","","",N,N],[17,"IPOPT_OLEN","","",N,N],[17,"IPOPT_OFFSET","","",N,N],[17,"IPOPT_MINOFF","","",N,N],[17,"MAX_IPOPTLEN","","",N,N],[17,"IPOPT_NOP","","",N,N],[17,"IPOPT_EOL","","",N,N],[17,"IPOPT_TS","","",N,N],[17,"IPOPT_TS_TSONLY","","",N,N],[17,"IPOPT_TS_TSANDADDR","","",N,N],[17,"IPOPT_TS_PRESPEC","","",N,N],[11,"clone","libc","",20,[[["self"]],["sockaddr"]]],[11,"clone","","",21,[[["self"]],["sockaddr_in"]]],[11,"clone","","",22,[[["self"]],["sockaddr_in6"]]],[11,"clone","","",23,[[["self"]],["sockaddr_un"]]],[11,"clone","","",24,[[["self"]],["sockaddr_storage"]]],[11,"clone","","",25,[[["self"]],["addrinfo"]]],[11,"clone","","",26,[[["self"]],["sockaddr_nl"]]],[11,"clone","","",27,[[["self"]],["sockaddr_ll"]]],[11,"clone","","",28,[[["self"]],["fd_set"]]],[11,"clone","","",29,[[["self"]],["tm"]]],[11,"clone","","",30,[[["self"]],["sched_param"]]],[11,"clone","","",31,[[["self"]],["dl_info"]]],[11,"clone","","",32,[[["self"]],["epoll_event"]]],[11,"clone","","",33,[[["self"]],["utsname"]]],[11,"clone","","",34,[[["self"]],["lconv"]]],[11,"clone","","",35,[[["self"]],["sigevent"]]],[11,"clone","","",36,[[["self"]],["in_pktinfo"]]],[11,"clone","","",37,[[["self"]],["ifaddrs"]]],[11,"clone","","",38,[[["self"]],["in6_rtmsg"]]],[6,"pid_t","libc::unix","",N,N],[6,"uid_t","","",N,N],[6,"gid_t","","",N,N],[6,"in_addr_t","","",N,N],[6,"in_port_t","","",N,N],[6,"sighandler_t","","",N,N],[6,"cc_t","","",N,N],[17,"SIG_DFL","","",N,N],[17,"SIG_IGN","","",N,N],[17,"SIG_ERR","","",N,N],[17,"DT_UNKNOWN","","",N,N],[17,"DT_FIFO","","",N,N],[17,"DT_CHR","","",N,N],[17,"DT_DIR","","",N,N],[17,"DT_BLK","","",N,N],[17,"DT_REG","","",N,N],[17,"DT_LNK","","",N,N],[17,"DT_SOCK","","",N,N],[17,"FD_CLOEXEC","","",N,N],[17,"USRQUOTA","","",N,N],[17,"GRPQUOTA","","",N,N],[17,"SIGIOT","","",N,N],[17,"S_ISUID","","",N,N],[17,"S_ISGID","","",N,N],[17,"S_ISVTX","","",N,N],[17,"IF_NAMESIZE","","",N,N],[17,"IFNAMSIZ","","",N,N],[17,"LOG_EMERG","","",N,N],[17,"LOG_ALERT","","",N,N],[17,"LOG_CRIT","","",N,N],[17,"LOG_ERR","","",N,N],[17,"LOG_WARNING","","",N,N],[17,"LOG_NOTICE","","",N,N],[17,"LOG_INFO","","",N,N],[17,"LOG_DEBUG","","",N,N],[17,"LOG_KERN","","",N,N],[17,"LOG_USER","","",N,N],[17,"LOG_MAIL","","",N,N],[17,"LOG_DAEMON","","",N,N],[17,"LOG_AUTH","","",N,N],[17,"LOG_SYSLOG","","",N,N],[17,"LOG_LPR","","",N,N],[17,"LOG_NEWS","","",N,N],[17,"LOG_UUCP","","",N,N],[17,"LOG_LOCAL0","","",N,N],[17,"LOG_LOCAL1","","",N,N],[17,"LOG_LOCAL2","","",N,N],[17,"LOG_LOCAL3","","",N,N],[17,"LOG_LOCAL4","","",N,N],[17,"LOG_LOCAL5","","",N,N],[17,"LOG_LOCAL6","","",N,N],[17,"LOG_LOCAL7","","",N,N],[17,"LOG_PID","","",N,N],[17,"LOG_CONS","","",N,N],[17,"LOG_ODELAY","","",N,N],[17,"LOG_NDELAY","","",N,N],[17,"LOG_NOWAIT","","",N,N],[17,"LOG_PRIMASK","","",N,N],[17,"LOG_FACMASK","","",N,N],[17,"PRIO_PROCESS","","",N,N],[17,"PRIO_PGRP","","",N,N],[17,"PRIO_USER","","",N,N],[17,"PRIO_MIN","","",N,N],[17,"PRIO_MAX","","",N,N],[17,"IPPROTO_ICMP","","",N,N],[17,"IPPROTO_ICMPV6","","",N,N],[17,"IPPROTO_TCP","","",N,N],[17,"IPPROTO_UDP","","",N,N],[17,"IPPROTO_IP","","",N,N],[17,"IPPROTO_IPV6","","",N,N],[17,"INADDR_LOOPBACK","","",N,N],[17,"INADDR_ANY","","",N,N],[17,"INADDR_BROADCAST","","",N,N],[17,"INADDR_NONE","","",N,N],[11,"clone","libc","",0,[[["self"]],["group"]]],[11,"clone","","",1,[[["self"]],["utimbuf"]]],[11,"clone","","",2,[[["self"]],["timeval"]]],[11,"clone","","",3,[[["self"]],["timespec"]]],[11,"clone","","",4,[[["self"]],["rlimit"]]],[11,"clone","","",5,[[["self"]],["rusage"]]],[11,"clone","","",6,[[["self"]],["in_addr"]]],[11,"clone","","",7,[[["self"]],["in6_addr"]]],[11,"clone","","",8,[[["self"]],["ip_mreq"]]],[11,"clone","","",9,[[["self"]],["ipv6_mreq"]]],[11,"clone","","",10,[[["self"]],["hostent"]]],[11,"clone","","",11,[[["self"]],["iovec"]]],[11,"clone","","",12,[[["self"]],["pollfd"]]],[11,"clone","","",13,[[["self"]],["winsize"]]],[11,"clone","","",14,[[["self"]],["linger"]]],[11,"clone","","",15,[[["self"]],["sigval"]]],[11,"clone","","",16,[[["self"]],["itimerval"]]],[11,"clone","","",17,[[["self"]],["tms"]]],[11,"clone","","",18,[[["self"]],["servent"]]],[11,"clone","","",19,[[["self"]],["protoent"]]],[6,"int8_t","","",N,N],[6,"int16_t","","",N,N],[6,"int32_t","","",N,N],[6,"int64_t","","",N,N],[6,"uint8_t","","",N,N],[6,"uint16_t","","",N,N],[6,"uint32_t","","",N,N],[6,"uint64_t","","",N,N],[6,"c_schar","","",N,N],[6,"c_uchar","","",N,N],[6,"c_short","","",N,N],[6,"c_ushort","","",N,N],[6,"c_int","","",N,N],[6,"c_uint","","",N,N],[6,"c_float","","",N,N],[6,"c_double","","",N,N],[6,"c_longlong","","",N,N],[6,"c_ulonglong","","",N,N],[6,"intmax_t","","",N,N],[6,"uintmax_t","","",N,N],[6,"size_t","","",N,N],[6,"ptrdiff_t","","",N,N],[6,"intptr_t","","",N,N],[6,"uintptr_t","","",N,N],[6,"ssize_t","","",N,N],[6,"pid_t","","",N,N],[6,"uid_t","","",N,N],[6,"gid_t","","",N,N],[6,"in_addr_t","","",N,N],[6,"in_port_t","","",N,N],[6,"sighandler_t","","",N,N],[6,"cc_t","","",N,N],[6,"sa_family_t","","",N,N],[6,"pthread_key_t","","",N,N],[6,"speed_t","","",N,N],[6,"tcflag_t","","",N,N],[6,"clockid_t","","",N,N],[6,"key_t","","",N,N],[6,"id_t","","",N,N],[6,"useconds_t","","",N,N],[6,"dev_t","","",N,N],[6,"socklen_t","","",N,N],[6,"pthread_t","","",N,N],[6,"mode_t","","",N,N],[6,"ino64_t","","",N,N],[6,"off64_t","","",N,N],[6,"blkcnt64_t","","",N,N],[6,"rlim64_t","","",N,N],[6,"mqd_t","","",N,N],[6,"nfds_t","","",N,N],[6,"nl_item","","",N,N],[6,"idtype_t","","",N,N],[6,"loff_t","","",N,N],[6,"__u8","","",N,N],[6,"__u16","","",N,N],[6,"__s16","","",N,N],[6,"__u32","","",N,N],[6,"__s32","","",N,N],[6,"Elf32_Half","","",N,N],[6,"Elf32_Word","","",N,N],[6,"Elf32_Off","","",N,N],[6,"Elf32_Addr","","",N,N],[6,"Elf64_Half","","",N,N],[6,"Elf64_Word","","",N,N],[6,"Elf64_Off","","",N,N],[6,"Elf64_Addr","","",N,N],[6,"Elf64_Xword","","",N,N],[6,"__priority_which_t","","",N,N],[6,"clock_t","","",N,N],[6,"time_t","","",N,N],[6,"ino_t","","",N,N],[6,"off_t","","",N,N],[6,"blkcnt_t","","",N,N],[6,"__fsword_t","","",N,N],[6,"shmatt_t","","",N,N],[6,"msgqnum_t","","",N,N],[6,"msglen_t","","",N,N],[6,"fsblkcnt_t","","",N,N],[6,"fsfilcnt_t","","",N,N],[6,"rlim_t","","",N,N],[6,"c_char","","",N,N],[6,"wchar_t","","",N,N],[6,"nlink_t","","",N,N],[6,"blksize_t","","",N,N],[6,"greg_t","","",N,N],[6,"suseconds_t","","",N,N],[6,"__u64","","",N,N],[6,"c_long","","",N,N],[6,"c_ulong","","",N,N],[17,"INT_MIN","","",N,N],[17,"INT_MAX","","",N,N],[17,"SIG_DFL","","",N,N],[17,"SIG_IGN","","",N,N],[17,"SIG_ERR","","",N,N],[17,"DT_UNKNOWN","","",N,N],[17,"DT_FIFO","","",N,N],[17,"DT_CHR","","",N,N],[17,"DT_DIR","","",N,N],[17,"DT_BLK","","",N,N],[17,"DT_REG","","",N,N],[17,"DT_LNK","","",N,N],[17,"DT_SOCK","","",N,N],[17,"FD_CLOEXEC","","",N,N],[17,"USRQUOTA","","",N,N],[17,"GRPQUOTA","","",N,N],[17,"SIGIOT","","",N,N],[17,"S_ISUID","","",N,N],[17,"S_ISGID","","",N,N],[17,"S_ISVTX","","",N,N],[17,"IF_NAMESIZE","","",N,N],[17,"IFNAMSIZ","","",N,N],[17,"LOG_EMERG","","",N,N],[17,"LOG_ALERT","","",N,N],[17,"LOG_CRIT","","",N,N],[17,"LOG_ERR","","",N,N],[17,"LOG_WARNING","","",N,N],[17,"LOG_NOTICE","","",N,N],[17,"LOG_INFO","","",N,N],[17,"LOG_DEBUG","","",N,N],[17,"LOG_KERN","","",N,N],[17,"LOG_USER","","",N,N],[17,"LOG_MAIL","","",N,N],[17,"LOG_DAEMON","","",N,N],[17,"LOG_AUTH","","",N,N],[17,"LOG_SYSLOG","","",N,N],[17,"LOG_LPR","","",N,N],[17,"LOG_NEWS","","",N,N],[17,"LOG_UUCP","","",N,N],[17,"LOG_LOCAL0","","",N,N],[17,"LOG_LOCAL1","","",N,N],[17,"LOG_LOCAL2","","",N,N],[17,"LOG_LOCAL3","","",N,N],[17,"LOG_LOCAL4","","",N,N],[17,"LOG_LOCAL5","","",N,N],[17,"LOG_LOCAL6","","",N,N],[17,"LOG_LOCAL7","","",N,N],[17,"LOG_PID","","",N,N],[17,"LOG_CONS","","",N,N],[17,"LOG_ODELAY","","",N,N],[17,"LOG_NDELAY","","",N,N],[17,"LOG_NOWAIT","","",N,N],[17,"LOG_PRIMASK","","",N,N],[17,"LOG_FACMASK","","",N,N],[17,"PRIO_PROCESS","","",N,N],[17,"PRIO_PGRP","","",N,N],[17,"PRIO_USER","","",N,N],[17,"PRIO_MIN","","",N,N],[17,"PRIO_MAX","","",N,N],[17,"IPPROTO_ICMP","","",N,N],[17,"IPPROTO_ICMPV6","","",N,N],[17,"IPPROTO_TCP","","",N,N],[17,"IPPROTO_UDP","","",N,N],[17,"IPPROTO_IP","","",N,N],[17,"IPPROTO_IPV6","","",N,N],[17,"INADDR_LOOPBACK","","",N,N],[17,"INADDR_ANY","","",N,N],[17,"INADDR_BROADCAST","","",N,N],[17,"INADDR_NONE","","",N,N],[17,"EXIT_FAILURE","","",N,N],[17,"EXIT_SUCCESS","","",N,N],[17,"RAND_MAX","","",N,N],[17,"EOF","","",N,N],[17,"SEEK_SET","","",N,N],[17,"SEEK_CUR","","",N,N],[17,"SEEK_END","","",N,N],[17,"_IOFBF","","",N,N],[17,"_IONBF","","",N,N],[17,"_IOLBF","","",N,N],[17,"F_DUPFD","","",N,N],[17,"F_GETFD","","",N,N],[17,"F_SETFD","","",N,N],[17,"F_GETFL","","",N,N],[17,"F_SETFL","","",N,N],[17,"F_SETLEASE","","",N,N],[17,"F_GETLEASE","","",N,N],[17,"F_NOTIFY","","",N,N],[17,"F_CANCELLK","","",N,N],[17,"F_DUPFD_CLOEXEC","","",N,N],[17,"F_SETPIPE_SZ","","",N,N],[17,"F_GETPIPE_SZ","","",N,N],[17,"F_ADD_SEALS","","",N,N],[17,"F_GET_SEALS","","",N,N],[17,"F_SEAL_SEAL","","",N,N],[17,"F_SEAL_SHRINK","","",N,N],[17,"F_SEAL_GROW","","",N,N],[17,"F_SEAL_WRITE","","",N,N],[17,"SIGTRAP","","",N,N],[17,"PTHREAD_CREATE_JOINABLE","","",N,N],[17,"PTHREAD_CREATE_DETACHED","","",N,N],[17,"CLOCK_REALTIME","","",N,N],[17,"CLOCK_MONOTONIC","","",N,N],[17,"CLOCK_PROCESS_CPUTIME_ID","","",N,N],[17,"CLOCK_THREAD_CPUTIME_ID","","",N,N],[17,"CLOCK_MONOTONIC_RAW","","",N,N],[17,"CLOCK_REALTIME_COARSE","","",N,N],[17,"CLOCK_MONOTONIC_COARSE","","",N,N],[17,"CLOCK_BOOTTIME","","",N,N],[17,"CLOCK_REALTIME_ALARM","","",N,N],[17,"CLOCK_BOOTTIME_ALARM","","",N,N],[17,"TIMER_ABSTIME","","",N,N],[17,"RLIMIT_CPU","","",N,N],[17,"RLIMIT_FSIZE","","",N,N],[17,"RLIMIT_DATA","","",N,N],[17,"RLIMIT_STACK","","",N,N],[17,"RLIMIT_CORE","","",N,N],[17,"RLIMIT_LOCKS","","",N,N],[17,"RLIMIT_SIGPENDING","","",N,N],[17,"RLIMIT_MSGQUEUE","","",N,N],[17,"RLIMIT_NICE","","",N,N],[17,"RLIMIT_RTPRIO","","",N,N],[17,"RUSAGE_SELF","","",N,N],[17,"O_RDONLY","","",N,N],[17,"O_WRONLY","","",N,N],[17,"O_RDWR","","",N,N],[17,"SOCK_CLOEXEC","","",N,N],[17,"S_IFIFO","","",N,N],[17,"S_IFCHR","","",N,N],[17,"S_IFBLK","","",N,N],[17,"S_IFDIR","","",N,N],[17,"S_IFREG","","",N,N],[17,"S_IFLNK","","",N,N],[17,"S_IFSOCK","","",N,N],[17,"S_IFMT","","",N,N],[17,"S_IRWXU","","",N,N],[17,"S_IXUSR","","",N,N],[17,"S_IWUSR","","",N,N],[17,"S_IRUSR","","",N,N],[17,"S_IRWXG","","",N,N],[17,"S_IXGRP","","",N,N],[17,"S_IWGRP","","",N,N],[17,"S_IRGRP","","",N,N],[17,"S_IRWXO","","",N,N],[17,"S_IXOTH","","",N,N],[17,"S_IWOTH","","",N,N],[17,"S_IROTH","","",N,N],[17,"F_OK","","",N,N],[17,"R_OK","","",N,N],[17,"W_OK","","",N,N],[17,"X_OK","","",N,N],[17,"STDIN_FILENO","","",N,N],[17,"STDOUT_FILENO","","",N,N],[17,"STDERR_FILENO","","",N,N],[17,"SIGHUP","","",N,N],[17,"SIGINT","","",N,N],[17,"SIGQUIT","","",N,N],[17,"SIGILL","","",N,N],[17,"SIGABRT","","",N,N],[17,"SIGFPE","","",N,N],[17,"SIGKILL","","",N,N],[17,"SIGSEGV","","",N,N],[17,"SIGPIPE","","",N,N],[17,"SIGALRM","","",N,N],[17,"SIGTERM","","",N,N],[17,"PROT_NONE","","",N,N],[17,"PROT_READ","","",N,N],[17,"PROT_WRITE","","",N,N],[17,"PROT_EXEC","","",N,N],[17,"LC_CTYPE","","",N,N],[17,"LC_NUMERIC","","",N,N],[17,"LC_TIME","","",N,N],[17,"LC_COLLATE","","",N,N],[17,"LC_MONETARY","","",N,N],[17,"LC_MESSAGES","","",N,N],[17,"LC_ALL","","",N,N],[17,"LC_CTYPE_MASK","","",N,N],[17,"LC_NUMERIC_MASK","","",N,N],[17,"LC_TIME_MASK","","",N,N],[17,"LC_COLLATE_MASK","","",N,N],[17,"LC_MONETARY_MASK","","",N,N],[17,"LC_MESSAGES_MASK","","",N,N],[17,"MAP_FILE","","",N,N],[17,"MAP_SHARED","","",N,N],[17,"MAP_PRIVATE","","",N,N],[17,"MAP_FIXED","","",N,N],[17,"MAP_FAILED","","",N,N],[17,"MS_ASYNC","","",N,N],[17,"MS_INVALIDATE","","",N,N],[17,"MS_SYNC","","",N,N],[17,"MS_RDONLY","","",N,N],[17,"MS_NOSUID","","",N,N],[17,"MS_NODEV","","",N,N],[17,"MS_NOEXEC","","",N,N],[17,"MS_SYNCHRONOUS","","",N,N],[17,"MS_REMOUNT","","",N,N],[17,"MS_MANDLOCK","","",N,N],[17,"MS_DIRSYNC","","",N,N],[17,"MS_NOATIME","","",N,N],[17,"MS_NODIRATIME","","",N,N],[17,"MS_BIND","","",N,N],[17,"MS_MOVE","","",N,N],[17,"MS_REC","","",N,N],[17,"MS_SILENT","","",N,N],[17,"MS_POSIXACL","","",N,N],[17,"MS_UNBINDABLE","","",N,N],[17,"MS_PRIVATE","","",N,N],[17,"MS_SLAVE","","",N,N],[17,"MS_SHARED","","",N,N],[17,"MS_RELATIME","","",N,N],[17,"MS_KERNMOUNT","","",N,N],[17,"MS_I_VERSION","","",N,N],[17,"MS_STRICTATIME","","",N,N],[17,"MS_ACTIVE","","",N,N],[17,"MS_NOUSER","","",N,N],[17,"MS_MGC_VAL","","",N,N],[17,"MS_MGC_MSK","","",N,N],[17,"MS_RMT_MASK","","",N,N],[17,"EPERM","","",N,N],[17,"ENOENT","","",N,N],[17,"ESRCH","","",N,N],[17,"EINTR","","",N,N],[17,"EIO","","",N,N],[17,"ENXIO","","",N,N],[17,"E2BIG","","",N,N],[17,"ENOEXEC","","",N,N],[17,"EBADF","","",N,N],[17,"ECHILD","","",N,N],[17,"EAGAIN","","",N,N],[17,"ENOMEM","","",N,N],[17,"EACCES","","",N,N],[17,"EFAULT","","",N,N],[17,"ENOTBLK","","",N,N],[17,"EBUSY","","",N,N],[17,"EEXIST","","",N,N],[17,"EXDEV","","",N,N],[17,"ENODEV","","",N,N],[17,"ENOTDIR","","",N,N],[17,"EISDIR","","",N,N],[17,"EINVAL","","",N,N],[17,"ENFILE","","",N,N],[17,"EMFILE","","",N,N],[17,"ENOTTY","","",N,N],[17,"ETXTBSY","","",N,N],[17,"EFBIG","","",N,N],[17,"ENOSPC","","",N,N],[17,"ESPIPE","","",N,N],[17,"EROFS","","",N,N],[17,"EMLINK","","",N,N],[17,"EPIPE","","",N,N],[17,"EDOM","","",N,N],[17,"ERANGE","","",N,N],[17,"EWOULDBLOCK","","",N,N],[17,"SCM_RIGHTS","","",N,N],[17,"SCM_CREDENTIALS","","",N,N],[17,"PROT_GROWSDOWN","","",N,N],[17,"PROT_GROWSUP","","",N,N],[17,"MAP_TYPE","","",N,N],[17,"MADV_NORMAL","","",N,N],[17,"MADV_RANDOM","","",N,N],[17,"MADV_SEQUENTIAL","","",N,N],[17,"MADV_WILLNEED","","",N,N],[17,"MADV_DONTNEED","","",N,N],[17,"MADV_FREE","","",N,N],[17,"MADV_REMOVE","","",N,N],[17,"MADV_DONTFORK","","",N,N],[17,"MADV_DOFORK","","",N,N],[17,"MADV_MERGEABLE","","",N,N],[17,"MADV_UNMERGEABLE","","",N,N],[17,"MADV_HUGEPAGE","","",N,N],[17,"MADV_NOHUGEPAGE","","",N,N],[17,"MADV_DONTDUMP","","",N,N],[17,"MADV_DODUMP","","",N,N],[17,"MADV_HWPOISON","","",N,N],[17,"MADV_SOFT_OFFLINE","","",N,N],[17,"IFF_UP","","",N,N],[17,"IFF_BROADCAST","","",N,N],[17,"IFF_DEBUG","","",N,N],[17,"IFF_LOOPBACK","","",N,N],[17,"IFF_POINTOPOINT","","",N,N],[17,"IFF_NOTRAILERS","","",N,N],[17,"IFF_RUNNING","","",N,N],[17,"IFF_NOARP","","",N,N],[17,"IFF_PROMISC","","",N,N],[17,"IFF_ALLMULTI","","",N,N],[17,"IFF_MASTER","","",N,N],[17,"IFF_SLAVE","","",N,N],[17,"IFF_MULTICAST","","",N,N],[17,"IFF_PORTSEL","","",N,N],[17,"IFF_AUTOMEDIA","","",N,N],[17,"IFF_DYNAMIC","","",N,N],[17,"SOL_IP","","",N,N],[17,"SOL_TCP","","",N,N],[17,"SOL_UDP","","",N,N],[17,"SOL_IPV6","","",N,N],[17,"SOL_ICMPV6","","",N,N],[17,"SOL_RAW","","",N,N],[17,"SOL_DECNET","","",N,N],[17,"SOL_X25","","",N,N],[17,"SOL_PACKET","","",N,N],[17,"SOL_ATM","","",N,N],[17,"SOL_AAL","","",N,N],[17,"SOL_IRDA","","",N,N],[17,"SOL_NETBEUI","","",N,N],[17,"SOL_LLC","","",N,N],[17,"SOL_DCCP","","",N,N],[17,"SOL_NETLINK","","",N,N],[17,"SOL_TIPC","","",N,N],[17,"AF_UNSPEC","","",N,N],[17,"AF_UNIX","","",N,N],[17,"AF_LOCAL","","",N,N],[17,"AF_INET","","",N,N],[17,"AF_AX25","","",N,N],[17,"AF_IPX","","",N,N],[17,"AF_APPLETALK","","",N,N],[17,"AF_NETROM","","",N,N],[17,"AF_BRIDGE","","",N,N],[17,"AF_ATMPVC","","",N,N],[17,"AF_X25","","",N,N],[17,"AF_INET6","","",N,N],[17,"AF_ROSE","","",N,N],[17,"AF_DECnet","","",N,N],[17,"AF_NETBEUI","","",N,N],[17,"AF_SECURITY","","",N,N],[17,"AF_KEY","","",N,N],[17,"AF_NETLINK","","",N,N],[17,"AF_ROUTE","","",N,N],[17,"AF_PACKET","","",N,N],[17,"AF_ASH","","",N,N],[17,"AF_ECONET","","",N,N],[17,"AF_ATMSVC","","",N,N],[17,"AF_RDS","","",N,N],[17,"AF_SNA","","",N,N],[17,"AF_IRDA","","",N,N],[17,"AF_PPPOX","","",N,N],[17,"AF_WANPIPE","","",N,N],[17,"AF_LLC","","",N,N],[17,"AF_CAN","","",N,N],[17,"AF_TIPC","","",N,N],[17,"AF_BLUETOOTH","","",N,N],[17,"AF_IUCV","","",N,N],[17,"AF_RXRPC","","",N,N],[17,"AF_ISDN","","",N,N],[17,"AF_PHONET","","",N,N],[17,"AF_IEEE802154","","",N,N],[17,"AF_CAIF","","",N,N],[17,"AF_ALG","","",N,N],[17,"PF_UNSPEC","","",N,N],[17,"PF_UNIX","","",N,N],[17,"PF_LOCAL","","",N,N],[17,"PF_INET","","",N,N],[17,"PF_AX25","","",N,N],[17,"PF_IPX","","",N,N],[17,"PF_APPLETALK","","",N,N],[17,"PF_NETROM","","",N,N],[17,"PF_BRIDGE","","",N,N],[17,"PF_ATMPVC","","",N,N],[17,"PF_X25","","",N,N],[17,"PF_INET6","","",N,N],[17,"PF_ROSE","","",N,N],[17,"PF_DECnet","","",N,N],[17,"PF_NETBEUI","","",N,N],[17,"PF_SECURITY","","",N,N],[17,"PF_KEY","","",N,N],[17,"PF_NETLINK","","",N,N],[17,"PF_ROUTE","","",N,N],[17,"PF_PACKET","","",N,N],[17,"PF_ASH","","",N,N],[17,"PF_ECONET","","",N,N],[17,"PF_ATMSVC","","",N,N],[17,"PF_RDS","","",N,N],[17,"PF_SNA","","",N,N],[17,"PF_IRDA","","",N,N],[17,"PF_PPPOX","","",N,N],[17,"PF_WANPIPE","","",N,N],[17,"PF_LLC","","",N,N],[17,"PF_CAN","","",N,N],[17,"PF_TIPC","","",N,N],[17,"PF_BLUETOOTH","","",N,N],[17,"PF_IUCV","","",N,N],[17,"PF_RXRPC","","",N,N],[17,"PF_ISDN","","",N,N],[17,"PF_PHONET","","",N,N],[17,"PF_IEEE802154","","",N,N],[17,"PF_CAIF","","",N,N],[17,"PF_ALG","","",N,N],[17,"SOMAXCONN","","",N,N],[17,"MSG_OOB","","",N,N],[17,"MSG_PEEK","","",N,N],[17,"MSG_DONTROUTE","","",N,N],[17,"MSG_CTRUNC","","",N,N],[17,"MSG_TRUNC","","",N,N],[17,"MSG_DONTWAIT","","",N,N],[17,"MSG_EOR","","",N,N],[17,"MSG_WAITALL","","",N,N],[17,"MSG_FIN","","",N,N],[17,"MSG_SYN","","",N,N],[17,"MSG_CONFIRM","","",N,N],[17,"MSG_RST","","",N,N],[17,"MSG_ERRQUEUE","","",N,N],[17,"MSG_NOSIGNAL","","",N,N],[17,"MSG_MORE","","",N,N],[17,"MSG_WAITFORONE","","",N,N],[17,"MSG_FASTOPEN","","",N,N],[17,"MSG_CMSG_CLOEXEC","","",N,N],[17,"SCM_TIMESTAMP","","",N,N],[17,"SOCK_RAW","","",N,N],[17,"SOCK_RDM","","",N,N],[17,"IP_MULTICAST_IF","","",N,N],[17,"IP_MULTICAST_TTL","","",N,N],[17,"IP_MULTICAST_LOOP","","",N,N],[17,"IP_TTL","","",N,N],[17,"IP_HDRINCL","","",N,N],[17,"IP_PKTINFO","","",N,N],[17,"IP_ADD_MEMBERSHIP","","",N,N],[17,"IP_DROP_MEMBERSHIP","","",N,N],[17,"IP_TRANSPARENT","","",N,N],[17,"IPV6_UNICAST_HOPS","","",N,N],[17,"IPV6_MULTICAST_IF","","",N,N],[17,"IPV6_MULTICAST_HOPS","","",N,N],[17,"IPV6_MULTICAST_LOOP","","",N,N],[17,"IPV6_ADD_MEMBERSHIP","","",N,N],[17,"IPV6_DROP_MEMBERSHIP","","",N,N],[17,"IPV6_V6ONLY","","",N,N],[17,"IPV6_RECVPKTINFO","","",N,N],[17,"IPV6_PKTINFO","","",N,N],[17,"TCP_NODELAY","","",N,N],[17,"TCP_MAXSEG","","",N,N],[17,"TCP_CORK","","",N,N],[17,"TCP_KEEPIDLE","","",N,N],[17,"TCP_KEEPINTVL","","",N,N],[17,"TCP_KEEPCNT","","",N,N],[17,"TCP_SYNCNT","","",N,N],[17,"TCP_LINGER2","","",N,N],[17,"TCP_DEFER_ACCEPT","","",N,N],[17,"TCP_WINDOW_CLAMP","","",N,N],[17,"TCP_INFO","","",N,N],[17,"TCP_QUICKACK","","",N,N],[17,"TCP_CONGESTION","","",N,N],[17,"SO_DEBUG","","",N,N],[17,"SHUT_RD","","",N,N],[17,"SHUT_WR","","",N,N],[17,"SHUT_RDWR","","",N,N],[17,"LOCK_SH","","",N,N],[17,"LOCK_EX","","",N,N],[17,"LOCK_NB","","",N,N],[17,"LOCK_UN","","",N,N],[17,"SS_ONSTACK","","",N,N],[17,"SS_DISABLE","","",N,N],[17,"PATH_MAX","","",N,N],[17,"FD_SETSIZE","","",N,N],[17,"EPOLLIN","","",N,N],[17,"EPOLLPRI","","",N,N],[17,"EPOLLOUT","","",N,N],[17,"EPOLLRDNORM","","",N,N],[17,"EPOLLRDBAND","","",N,N],[17,"EPOLLWRNORM","","",N,N],[17,"EPOLLWRBAND","","",N,N],[17,"EPOLLMSG","","",N,N],[17,"EPOLLERR","","",N,N],[17,"EPOLLHUP","","",N,N],[17,"EPOLLET","","",N,N],[17,"EPOLL_CTL_ADD","","",N,N],[17,"EPOLL_CTL_MOD","","",N,N],[17,"EPOLL_CTL_DEL","","",N,N],[17,"MNT_DETACH","","",N,N],[17,"MNT_EXPIRE","","",N,N],[17,"Q_GETFMT","","",N,N],[17,"Q_GETINFO","","",N,N],[17,"Q_SETINFO","","",N,N],[17,"QIF_BLIMITS","","",N,N],[17,"QIF_SPACE","","",N,N],[17,"QIF_ILIMITS","","",N,N],[17,"QIF_INODES","","",N,N],[17,"QIF_BTIME","","",N,N],[17,"QIF_ITIME","","",N,N],[17,"QIF_LIMITS","","",N,N],[17,"QIF_USAGE","","",N,N],[17,"QIF_TIMES","","",N,N],[17,"QIF_ALL","","",N,N],[17,"MNT_FORCE","","",N,N],[17,"Q_SYNC","","",N,N],[17,"Q_QUOTAON","","",N,N],[17,"Q_QUOTAOFF","","",N,N],[17,"Q_GETQUOTA","","",N,N],[17,"Q_SETQUOTA","","",N,N],[17,"TCIOFF","","",N,N],[17,"TCION","","",N,N],[17,"TCOOFF","","",N,N],[17,"TCOON","","",N,N],[17,"TCIFLUSH","","",N,N],[17,"TCOFLUSH","","",N,N],[17,"TCIOFLUSH","","",N,N],[17,"NL0","","",N,N],[17,"NL1","","",N,N],[17,"TAB0","","",N,N],[17,"CR0","","",N,N],[17,"FF0","","",N,N],[17,"BS0","","",N,N],[17,"VT0","","",N,N],[17,"VERASE","","",N,N],[17,"VKILL","","",N,N],[17,"VINTR","","",N,N],[17,"VQUIT","","",N,N],[17,"VLNEXT","","",N,N],[17,"IGNBRK","","",N,N],[17,"BRKINT","","",N,N],[17,"IGNPAR","","",N,N],[17,"PARMRK","","",N,N],[17,"INPCK","","",N,N],[17,"ISTRIP","","",N,N],[17,"INLCR","","",N,N],[17,"IGNCR","","",N,N],[17,"ICRNL","","",N,N],[17,"IXANY","","",N,N],[17,"IMAXBEL","","",N,N],[17,"OPOST","","",N,N],[17,"CS5","","",N,N],[17,"CRTSCTS","","",N,N],[17,"ECHO","","",N,N],[17,"OCRNL","","",N,N],[17,"ONOCR","","",N,N],[17,"ONLRET","","",N,N],[17,"OFILL","","",N,N],[17,"OFDEL","","",N,N],[17,"CLONE_VM","","",N,N],[17,"CLONE_FS","","",N,N],[17,"CLONE_FILES","","",N,N],[17,"CLONE_SIGHAND","","",N,N],[17,"CLONE_PTRACE","","",N,N],[17,"CLONE_VFORK","","",N,N],[17,"CLONE_PARENT","","",N,N],[17,"CLONE_THREAD","","",N,N],[17,"CLONE_NEWNS","","",N,N],[17,"CLONE_SYSVSEM","","",N,N],[17,"CLONE_SETTLS","","",N,N],[17,"CLONE_PARENT_SETTID","","",N,N],[17,"CLONE_CHILD_CLEARTID","","",N,N],[17,"CLONE_DETACHED","","",N,N],[17,"CLONE_UNTRACED","","",N,N],[17,"CLONE_CHILD_SETTID","","",N,N],[17,"CLONE_NEWUTS","","",N,N],[17,"CLONE_NEWIPC","","",N,N],[17,"CLONE_NEWUSER","","",N,N],[17,"CLONE_NEWPID","","",N,N],[17,"CLONE_NEWNET","","",N,N],[17,"CLONE_IO","","",N,N],[17,"CLONE_NEWCGROUP","","",N,N],[17,"WNOHANG","","",N,N],[17,"WUNTRACED","","",N,N],[17,"WSTOPPED","","",N,N],[17,"WEXITED","","",N,N],[17,"WCONTINUED","","",N,N],[17,"WNOWAIT","","",N,N],[17,"PTRACE_O_TRACESYSGOOD","","",N,N],[17,"PTRACE_O_TRACEFORK","","",N,N],[17,"PTRACE_O_TRACEVFORK","","",N,N],[17,"PTRACE_O_TRACECLONE","","",N,N],[17,"PTRACE_O_TRACEEXEC","","",N,N],[17,"PTRACE_O_TRACEVFORKDONE","","",N,N],[17,"PTRACE_O_TRACEEXIT","","",N,N],[17,"PTRACE_O_TRACESECCOMP","","",N,N],[17,"PTRACE_O_EXITKILL","","",N,N],[17,"PTRACE_O_SUSPEND_SECCOMP","","",N,N],[17,"PTRACE_O_MASK","","",N,N],[17,"PTRACE_EVENT_FORK","","",N,N],[17,"PTRACE_EVENT_VFORK","","",N,N],[17,"PTRACE_EVENT_CLONE","","",N,N],[17,"PTRACE_EVENT_EXEC","","",N,N],[17,"PTRACE_EVENT_VFORK_DONE","","",N,N],[17,"PTRACE_EVENT_EXIT","","",N,N],[17,"PTRACE_EVENT_SECCOMP","","",N,N],[17,"__WNOTHREAD","","",N,N],[17,"__WALL","","",N,N],[17,"__WCLONE","","",N,N],[17,"SPLICE_F_MOVE","","",N,N],[17,"SPLICE_F_NONBLOCK","","",N,N],[17,"SPLICE_F_MORE","","",N,N],[17,"SPLICE_F_GIFT","","",N,N],[17,"RTLD_LOCAL","","",N,N],[17,"RTLD_LAZY","","",N,N],[17,"POSIX_FADV_NORMAL","","",N,N],[17,"POSIX_FADV_RANDOM","","",N,N],[17,"POSIX_FADV_SEQUENTIAL","","",N,N],[17,"POSIX_FADV_WILLNEED","","",N,N],[17,"AT_FDCWD","","",N,N],[17,"AT_SYMLINK_NOFOLLOW","","",N,N],[17,"AT_REMOVEDIR","","",N,N],[17,"AT_SYMLINK_FOLLOW","","",N,N],[17,"AT_NO_AUTOMOUNT","","",N,N],[17,"AT_EMPTY_PATH","","",N,N],[17,"LOG_CRON","","",N,N],[17,"LOG_AUTHPRIV","","",N,N],[17,"LOG_FTP","","",N,N],[17,"LOG_PERROR","","",N,N],[17,"PIPE_BUF","","",N,N],[17,"SI_LOAD_SHIFT","","",N,N],[17,"SIGEV_SIGNAL","","",N,N],[17,"SIGEV_NONE","","",N,N],[17,"SIGEV_THREAD","","",N,N],[17,"P_ALL","","",N,N],[17,"P_PID","","",N,N],[17,"P_PGID","","",N,N],[17,"UTIME_OMIT","","",N,N],[17,"UTIME_NOW","","",N,N],[17,"POLLIN","","",N,N],[17,"POLLPRI","","",N,N],[17,"POLLOUT","","",N,N],[17,"POLLERR","","",N,N],[17,"POLLHUP","","",N,N],[17,"POLLNVAL","","",N,N],[17,"POLLRDNORM","","",N,N],[17,"POLLRDBAND","","",N,N],[17,"IPTOS_LOWDELAY","","",N,N],[17,"IPTOS_THROUGHPUT","","",N,N],[17,"IPTOS_RELIABILITY","","",N,N],[17,"IPTOS_MINCOST","","",N,N],[17,"IPTOS_PREC_NETCONTROL","","",N,N],[17,"IPTOS_PREC_INTERNETCONTROL","","",N,N],[17,"IPTOS_PREC_CRITIC_ECP","","",N,N],[17,"IPTOS_PREC_FLASHOVERRIDE","","",N,N],[17,"IPTOS_PREC_FLASH","","",N,N],[17,"IPTOS_PREC_IMMEDIATE","","",N,N],[17,"IPTOS_PREC_PRIORITY","","",N,N],[17,"IPTOS_PREC_ROUTINE","","",N,N],[17,"IPOPT_COPY","","",N,N],[17,"IPOPT_CLASS_MASK","","",N,N],[17,"IPOPT_NUMBER_MASK","","",N,N],[17,"IPOPT_CONTROL","","",N,N],[17,"IPOPT_RESERVED1","","",N,N],[17,"IPOPT_MEASUREMENT","","",N,N],[17,"IPOPT_RESERVED2","","",N,N],[17,"IPOPT_END","","",N,N],[17,"IPOPT_NOOP","","",N,N],[17,"IPOPT_SEC","","",N,N],[17,"IPOPT_LSRR","","",N,N],[17,"IPOPT_TIMESTAMP","","",N,N],[17,"IPOPT_RR","","",N,N],[17,"IPOPT_SID","","",N,N],[17,"IPOPT_SSRR","","",N,N],[17,"IPOPT_RA","","",N,N],[17,"IPVERSION","","",N,N],[17,"MAXTTL","","",N,N],[17,"IPDEFTTL","","",N,N],[17,"IPOPT_OPTVAL","","",N,N],[17,"IPOPT_OLEN","","",N,N],[17,"IPOPT_OFFSET","","",N,N],[17,"IPOPT_MINOFF","","",N,N],[17,"MAX_IPOPTLEN","","",N,N],[17,"IPOPT_NOP","","",N,N],[17,"IPOPT_EOL","","",N,N],[17,"IPOPT_TS","","",N,N],[17,"IPOPT_TS_TSONLY","","",N,N],[17,"IPOPT_TS_TSANDADDR","","",N,N],[17,"IPOPT_TS_PRESPEC","","",N,N],[17,"ABDAY_1","","",N,N],[17,"ABDAY_2","","",N,N],[17,"ABDAY_3","","",N,N],[17,"ABDAY_4","","",N,N],[17,"ABDAY_5","","",N,N],[17,"ABDAY_6","","",N,N],[17,"ABDAY_7","","",N,N],[17,"DAY_1","","",N,N],[17,"DAY_2","","",N,N],[17,"DAY_3","","",N,N],[17,"DAY_4","","",N,N],[17,"DAY_5","","",N,N],[17,"DAY_6","","",N,N],[17,"DAY_7","","",N,N],[17,"ABMON_1","","",N,N],[17,"ABMON_2","","",N,N],[17,"ABMON_3","","",N,N],[17,"ABMON_4","","",N,N],[17,"ABMON_5","","",N,N],[17,"ABMON_6","","",N,N],[17,"ABMON_7","","",N,N],[17,"ABMON_8","","",N,N],[17,"ABMON_9","","",N,N],[17,"ABMON_10","","",N,N],[17,"ABMON_11","","",N,N],[17,"ABMON_12","","",N,N],[17,"MON_1","","",N,N],[17,"MON_2","","",N,N],[17,"MON_3","","",N,N],[17,"MON_4","","",N,N],[17,"MON_5","","",N,N],[17,"MON_6","","",N,N],[17,"MON_7","","",N,N],[17,"MON_8","","",N,N],[17,"MON_9","","",N,N],[17,"MON_10","","",N,N],[17,"MON_11","","",N,N],[17,"MON_12","","",N,N],[17,"AM_STR","","",N,N],[17,"PM_STR","","",N,N],[17,"D_T_FMT","","",N,N],[17,"D_FMT","","",N,N],[17,"T_FMT","","",N,N],[17,"T_FMT_AMPM","","",N,N],[17,"ERA","","",N,N],[17,"ERA_D_FMT","","",N,N],[17,"ALT_DIGITS","","",N,N],[17,"ERA_D_T_FMT","","",N,N],[17,"ERA_T_FMT","","",N,N],[17,"CODESET","","",N,N],[17,"CRNCYSTR","","",N,N],[17,"RUSAGE_THREAD","","",N,N],[17,"RUSAGE_CHILDREN","","",N,N],[17,"RADIXCHAR","","",N,N],[17,"THOUSEP","","",N,N],[17,"YESEXPR","","",N,N],[17,"NOEXPR","","",N,N],[17,"YESSTR","","",N,N],[17,"NOSTR","","",N,N],[17,"FILENAME_MAX","","",N,N],[17,"L_tmpnam","","",N,N],[17,"_PC_LINK_MAX","","",N,N],[17,"_PC_MAX_CANON","","",N,N],[17,"_PC_MAX_INPUT","","",N,N],[17,"_PC_NAME_MAX","","",N,N],[17,"_PC_PATH_MAX","","",N,N],[17,"_PC_PIPE_BUF","","",N,N],[17,"_PC_CHOWN_RESTRICTED","","",N,N],[17,"_PC_NO_TRUNC","","",N,N],[17,"_PC_VDISABLE","","",N,N],[17,"_PC_SYNC_IO","","",N,N],[17,"_PC_ASYNC_IO","","",N,N],[17,"_PC_PRIO_IO","","",N,N],[17,"_PC_SOCK_MAXBUF","","",N,N],[17,"_PC_FILESIZEBITS","","",N,N],[17,"_PC_REC_INCR_XFER_SIZE","","",N,N],[17,"_PC_REC_MAX_XFER_SIZE","","",N,N],[17,"_PC_REC_MIN_XFER_SIZE","","",N,N],[17,"_PC_REC_XFER_ALIGN","","",N,N],[17,"_PC_ALLOC_SIZE_MIN","","",N,N],[17,"_PC_SYMLINK_MAX","","",N,N],[17,"_PC_2_SYMLINKS","","",N,N],[17,"_SC_ARG_MAX","","",N,N],[17,"_SC_CHILD_MAX","","",N,N],[17,"_SC_CLK_TCK","","",N,N],[17,"_SC_NGROUPS_MAX","","",N,N],[17,"_SC_OPEN_MAX","","",N,N],[17,"_SC_STREAM_MAX","","",N,N],[17,"_SC_TZNAME_MAX","","",N,N],[17,"_SC_JOB_CONTROL","","",N,N],[17,"_SC_SAVED_IDS","","",N,N],[17,"_SC_REALTIME_SIGNALS","","",N,N],[17,"_SC_PRIORITY_SCHEDULING","","",N,N],[17,"_SC_TIMERS","","",N,N],[17,"_SC_ASYNCHRONOUS_IO","","",N,N],[17,"_SC_PRIORITIZED_IO","","",N,N],[17,"_SC_SYNCHRONIZED_IO","","",N,N],[17,"_SC_FSYNC","","",N,N],[17,"_SC_MAPPED_FILES","","",N,N],[17,"_SC_MEMLOCK","","",N,N],[17,"_SC_MEMLOCK_RANGE","","",N,N],[17,"_SC_MEMORY_PROTECTION","","",N,N],[17,"_SC_MESSAGE_PASSING","","",N,N],[17,"_SC_SEMAPHORES","","",N,N],[17,"_SC_SHARED_MEMORY_OBJECTS","","",N,N],[17,"_SC_AIO_LISTIO_MAX","","",N,N],[17,"_SC_AIO_MAX","","",N,N],[17,"_SC_AIO_PRIO_DELTA_MAX","","",N,N],[17,"_SC_DELAYTIMER_MAX","","",N,N],[17,"_SC_MQ_OPEN_MAX","","",N,N],[17,"_SC_MQ_PRIO_MAX","","",N,N],[17,"_SC_VERSION","","",N,N],[17,"_SC_PAGESIZE","","",N,N],[17,"_SC_PAGE_SIZE","","",N,N],[17,"_SC_RTSIG_MAX","","",N,N],[17,"_SC_SEM_NSEMS_MAX","","",N,N],[17,"_SC_SEM_VALUE_MAX","","",N,N],[17,"_SC_SIGQUEUE_MAX","","",N,N],[17,"_SC_TIMER_MAX","","",N,N],[17,"_SC_BC_BASE_MAX","","",N,N],[17,"_SC_BC_DIM_MAX","","",N,N],[17,"_SC_BC_SCALE_MAX","","",N,N],[17,"_SC_BC_STRING_MAX","","",N,N],[17,"_SC_COLL_WEIGHTS_MAX","","",N,N],[17,"_SC_EXPR_NEST_MAX","","",N,N],[17,"_SC_LINE_MAX","","",N,N],[17,"_SC_RE_DUP_MAX","","",N,N],[17,"_SC_2_VERSION","","",N,N],[17,"_SC_2_C_BIND","","",N,N],[17,"_SC_2_C_DEV","","",N,N],[17,"_SC_2_FORT_DEV","","",N,N],[17,"_SC_2_FORT_RUN","","",N,N],[17,"_SC_2_SW_DEV","","",N,N],[17,"_SC_2_LOCALEDEF","","",N,N],[17,"_SC_UIO_MAXIOV","","",N,N],[17,"_SC_IOV_MAX","","",N,N],[17,"_SC_THREADS","","",N,N],[17,"_SC_THREAD_SAFE_FUNCTIONS","","",N,N],[17,"_SC_GETGR_R_SIZE_MAX","","",N,N],[17,"_SC_GETPW_R_SIZE_MAX","","",N,N],[17,"_SC_LOGIN_NAME_MAX","","",N,N],[17,"_SC_TTY_NAME_MAX","","",N,N],[17,"_SC_THREAD_DESTRUCTOR_ITERATIONS","","",N,N],[17,"_SC_THREAD_KEYS_MAX","","",N,N],[17,"_SC_THREAD_STACK_MIN","","",N,N],[17,"_SC_THREAD_THREADS_MAX","","",N,N],[17,"_SC_THREAD_ATTR_STACKADDR","","",N,N],[17,"_SC_THREAD_ATTR_STACKSIZE","","",N,N],[17,"_SC_THREAD_PRIORITY_SCHEDULING","","",N,N],[17,"_SC_THREAD_PRIO_INHERIT","","",N,N],[17,"_SC_THREAD_PRIO_PROTECT","","",N,N],[17,"_SC_THREAD_PROCESS_SHARED","","",N,N],[17,"_SC_NPROCESSORS_CONF","","",N,N],[17,"_SC_NPROCESSORS_ONLN","","",N,N],[17,"_SC_PHYS_PAGES","","",N,N],[17,"_SC_AVPHYS_PAGES","","",N,N],[17,"_SC_ATEXIT_MAX","","",N,N],[17,"_SC_PASS_MAX","","",N,N],[17,"_SC_XOPEN_VERSION","","",N,N],[17,"_SC_XOPEN_XCU_VERSION","","",N,N],[17,"_SC_XOPEN_UNIX","","",N,N],[17,"_SC_XOPEN_CRYPT","","",N,N],[17,"_SC_XOPEN_ENH_I18N","","",N,N],[17,"_SC_XOPEN_SHM","","",N,N],[17,"_SC_2_CHAR_TERM","","",N,N],[17,"_SC_2_UPE","","",N,N],[17,"_SC_XOPEN_XPG2","","",N,N],[17,"_SC_XOPEN_XPG3","","",N,N],[17,"_SC_XOPEN_XPG4","","",N,N],[17,"_SC_NZERO","","",N,N],[17,"_SC_XBS5_ILP32_OFF32","","",N,N],[17,"_SC_XBS5_ILP32_OFFBIG","","",N,N],[17,"_SC_XBS5_LP64_OFF64","","",N,N],[17,"_SC_XBS5_LPBIG_OFFBIG","","",N,N],[17,"_SC_XOPEN_LEGACY","","",N,N],[17,"_SC_XOPEN_REALTIME","","",N,N],[17,"_SC_XOPEN_REALTIME_THREADS","","",N,N],[17,"_SC_ADVISORY_INFO","","",N,N],[17,"_SC_BARRIERS","","",N,N],[17,"_SC_CLOCK_SELECTION","","",N,N],[17,"_SC_CPUTIME","","",N,N],[17,"_SC_THREAD_CPUTIME","","",N,N],[17,"_SC_MONOTONIC_CLOCK","","",N,N],[17,"_SC_READER_WRITER_LOCKS","","",N,N],[17,"_SC_SPIN_LOCKS","","",N,N],[17,"_SC_REGEXP","","",N,N],[17,"_SC_SHELL","","",N,N],[17,"_SC_SPAWN","","",N,N],[17,"_SC_SPORADIC_SERVER","","",N,N],[17,"_SC_THREAD_SPORADIC_SERVER","","",N,N],[17,"_SC_TIMEOUTS","","",N,N],[17,"_SC_TYPED_MEMORY_OBJECTS","","",N,N],[17,"_SC_2_PBS","","",N,N],[17,"_SC_2_PBS_ACCOUNTING","","",N,N],[17,"_SC_2_PBS_LOCATE","","",N,N],[17,"_SC_2_PBS_MESSAGE","","",N,N],[17,"_SC_2_PBS_TRACK","","",N,N],[17,"_SC_SYMLOOP_MAX","","",N,N],[17,"_SC_STREAMS","","",N,N],[17,"_SC_2_PBS_CHECKPOINT","","",N,N],[17,"_SC_V6_ILP32_OFF32","","",N,N],[17,"_SC_V6_ILP32_OFFBIG","","",N,N],[17,"_SC_V6_LP64_OFF64","","",N,N],[17,"_SC_V6_LPBIG_OFFBIG","","",N,N],[17,"_SC_HOST_NAME_MAX","","",N,N],[17,"_SC_TRACE","","",N,N],[17,"_SC_TRACE_EVENT_FILTER","","",N,N],[17,"_SC_TRACE_INHERIT","","",N,N],[17,"_SC_TRACE_LOG","","",N,N],[17,"_SC_IPV6","","",N,N],[17,"_SC_RAW_SOCKETS","","",N,N],[17,"_SC_V7_ILP32_OFF32","","",N,N],[17,"_SC_V7_ILP32_OFFBIG","","",N,N],[17,"_SC_V7_LP64_OFF64","","",N,N],[17,"_SC_V7_LPBIG_OFFBIG","","",N,N],[17,"_SC_SS_REPL_MAX","","",N,N],[17,"_SC_TRACE_EVENT_NAME_MAX","","",N,N],[17,"_SC_TRACE_NAME_MAX","","",N,N],[17,"_SC_TRACE_SYS_MAX","","",N,N],[17,"_SC_TRACE_USER_EVENT_MAX","","",N,N],[17,"_SC_XOPEN_STREAMS","","",N,N],[17,"_SC_THREAD_ROBUST_PRIO_INHERIT","","",N,N],[17,"_SC_THREAD_ROBUST_PRIO_PROTECT","","",N,N],[17,"RLIM_SAVED_MAX","","",N,N],[17,"RLIM_SAVED_CUR","","",N,N],[17,"GLOB_ERR","","",N,N],[17,"GLOB_MARK","","",N,N],[17,"GLOB_NOSORT","","",N,N],[17,"GLOB_DOOFFS","","",N,N],[17,"GLOB_NOCHECK","","",N,N],[17,"GLOB_APPEND","","",N,N],[17,"GLOB_NOESCAPE","","",N,N],[17,"GLOB_NOSPACE","","",N,N],[17,"GLOB_ABORTED","","",N,N],[17,"GLOB_NOMATCH","","",N,N],[17,"POSIX_MADV_NORMAL","","",N,N],[17,"POSIX_MADV_RANDOM","","",N,N],[17,"POSIX_MADV_SEQUENTIAL","","",N,N],[17,"POSIX_MADV_WILLNEED","","",N,N],[17,"S_IEXEC","","",N,N],[17,"S_IWRITE","","",N,N],[17,"S_IREAD","","",N,N],[17,"F_LOCK","","",N,N],[17,"F_TEST","","",N,N],[17,"F_TLOCK","","",N,N],[17,"F_ULOCK","","",N,N],[17,"IFF_LOWER_UP","","",N,N],[17,"IFF_DORMANT","","",N,N],[17,"IFF_ECHO","","",N,N],[17,"IFF_TUN","","",N,N],[17,"IFF_TAP","","",N,N],[17,"IFF_NO_PI","","",N,N],[17,"TUN_READQ_SIZE","","",N,N],[17,"TUN_TUN_DEV","","",N,N],[17,"TUN_TAP_DEV","","",N,N],[17,"TUN_TYPE_MASK","","",N,N],[17,"IFF_ONE_QUEUE","","",N,N],[17,"IFF_VNET_HDR","","",N,N],[17,"IFF_TUN_EXCL","","",N,N],[17,"IFF_MULTI_QUEUE","","",N,N],[17,"IFF_ATTACH_QUEUE","","",N,N],[17,"IFF_DETACH_QUEUE","","",N,N],[17,"IFF_PERSIST","","",N,N],[17,"IFF_NOFILTER","","",N,N],[17,"ST_RDONLY","","",N,N],[17,"ST_NOSUID","","",N,N],[17,"ST_NODEV","","",N,N],[17,"ST_NOEXEC","","",N,N],[17,"ST_SYNCHRONOUS","","",N,N],[17,"ST_MANDLOCK","","",N,N],[17,"ST_WRITE","","",N,N],[17,"ST_APPEND","","",N,N],[17,"ST_IMMUTABLE","","",N,N],[17,"ST_NOATIME","","",N,N],[17,"ST_NODIRATIME","","",N,N],[17,"RTLD_NEXT","","",N,N],[17,"RTLD_DEFAULT","","",N,N],[17,"RTLD_NODELETE","","",N,N],[17,"RTLD_NOW","","",N,N],[17,"TCP_MD5SIG","","",N,N],[17,"PTHREAD_MUTEX_INITIALIZER","","",N,N],[17,"PTHREAD_COND_INITIALIZER","","",N,N],[17,"PTHREAD_RWLOCK_INITIALIZER","","",N,N],[17,"PTHREAD_MUTEX_NORMAL","","",N,N],[17,"PTHREAD_MUTEX_RECURSIVE","","",N,N],[17,"PTHREAD_MUTEX_ERRORCHECK","","",N,N],[17,"PTHREAD_MUTEX_DEFAULT","","",N,N],[17,"PTHREAD_PROCESS_PRIVATE","","",N,N],[17,"PTHREAD_PROCESS_SHARED","","",N,N],[17,"__SIZEOF_PTHREAD_COND_T","","",N,N],[17,"RENAME_NOREPLACE","","",N,N],[17,"RENAME_EXCHANGE","","",N,N],[17,"RENAME_WHITEOUT","","",N,N],[17,"SCHED_OTHER","","",N,N],[17,"SCHED_FIFO","","",N,N],[17,"SCHED_RR","","",N,N],[17,"SCHED_BATCH","","",N,N],[17,"SCHED_IDLE","","",N,N],[17,"IPPROTO_HOPOPTS","","Hop-by-hop option header",N,N],[17,"IPPROTO_IGMP","","group mgmt protocol",N,N],[17,"IPPROTO_IPIP","","for compatibility",N,N],[17,"IPPROTO_EGP","","exterior gateway protocol",N,N],[17,"IPPROTO_PUP","","pup",N,N],[17,"IPPROTO_IDP","","xns idp",N,N],[17,"IPPROTO_TP","","tp-4 w/ class negotiation",N,N],[17,"IPPROTO_DCCP","","DCCP",N,N],[17,"IPPROTO_ROUTING","","IP6 routing header",N,N],[17,"IPPROTO_FRAGMENT","","IP6 fragmentation header",N,N],[17,"IPPROTO_RSVP","","resource reservation",N,N],[17,"IPPROTO_GRE","","General Routing Encap.",N,N],[17,"IPPROTO_ESP","","IP6 Encap Sec. Payload",N,N],[17,"IPPROTO_AH","","IP6 Auth Header",N,N],[17,"IPPROTO_NONE","","IP6 no next header",N,N],[17,"IPPROTO_DSTOPTS","","IP6 destination option",N,N],[17,"IPPROTO_MTP","","",N,N],[17,"IPPROTO_BEETPH","","",N,N],[17,"IPPROTO_ENCAP","","encapsulation header",N,N],[17,"IPPROTO_PIM","","Protocol indep. multicast",N,N],[17,"IPPROTO_COMP","","IP Payload Comp. Protocol",N,N],[17,"IPPROTO_SCTP","","SCTP",N,N],[17,"IPPROTO_MH","","",N,N],[17,"IPPROTO_UDPLITE","","",N,N],[17,"IPPROTO_MPLS","","",N,N],[17,"IPPROTO_RAW","","raw IP packet",N,N],[17,"IPPROTO_MAX","","",N,N],[17,"AF_IB","","",N,N],[17,"AF_MPLS","","",N,N],[17,"AF_NFC","","",N,N],[17,"AF_VSOCK","","",N,N],[17,"PF_IB","","",N,N],[17,"PF_MPLS","","",N,N],[17,"PF_NFC","","",N,N],[17,"PF_VSOCK","","",N,N],[17,"IPC_PRIVATE","","",N,N],[17,"IPC_CREAT","","",N,N],[17,"IPC_EXCL","","",N,N],[17,"IPC_NOWAIT","","",N,N],[17,"IPC_RMID","","",N,N],[17,"IPC_SET","","",N,N],[17,"IPC_STAT","","",N,N],[17,"IPC_INFO","","",N,N],[17,"MSG_STAT","","",N,N],[17,"MSG_INFO","","",N,N],[17,"MSG_NOERROR","","",N,N],[17,"MSG_EXCEPT","","",N,N],[17,"MSG_COPY","","",N,N],[17,"SHM_R","","",N,N],[17,"SHM_W","","",N,N],[17,"SHM_RDONLY","","",N,N],[17,"SHM_RND","","",N,N],[17,"SHM_REMAP","","",N,N],[17,"SHM_EXEC","","",N,N],[17,"SHM_LOCK","","",N,N],[17,"SHM_UNLOCK","","",N,N],[17,"SHM_HUGETLB","","",N,N],[17,"SHM_NORESERVE","","",N,N],[17,"EPOLLRDHUP","","",N,N],[17,"EPOLLEXCLUSIVE","","",N,N],[17,"EPOLLONESHOT","","",N,N],[17,"QFMT_VFS_OLD","","",N,N],[17,"QFMT_VFS_V0","","",N,N],[17,"QFMT_VFS_V1","","",N,N],[17,"EFD_SEMAPHORE","","",N,N],[17,"LOG_NFACILITIES","","",N,N],[17,"SEM_FAILED","","",N,N],[17,"RB_AUTOBOOT","","",N,N],[17,"RB_HALT_SYSTEM","","",N,N],[17,"RB_ENABLE_CAD","","",N,N],[17,"RB_DISABLE_CAD","","",N,N],[17,"RB_POWER_OFF","","",N,N],[17,"RB_SW_SUSPEND","","",N,N],[17,"RB_KEXEC","","",N,N],[17,"AI_PASSIVE","","",N,N],[17,"AI_CANONNAME","","",N,N],[17,"AI_NUMERICHOST","","",N,N],[17,"AI_V4MAPPED","","",N,N],[17,"AI_ALL","","",N,N],[17,"AI_ADDRCONFIG","","",N,N],[17,"AI_NUMERICSERV","","",N,N],[17,"EAI_BADFLAGS","","",N,N],[17,"EAI_NONAME","","",N,N],[17,"EAI_AGAIN","","",N,N],[17,"EAI_FAIL","","",N,N],[17,"EAI_NODATA","","",N,N],[17,"EAI_FAMILY","","",N,N],[17,"EAI_SOCKTYPE","","",N,N],[17,"EAI_SERVICE","","",N,N],[17,"EAI_MEMORY","","",N,N],[17,"EAI_SYSTEM","","",N,N],[17,"EAI_OVERFLOW","","",N,N],[17,"NI_NUMERICHOST","","",N,N],[17,"NI_NUMERICSERV","","",N,N],[17,"NI_NOFQDN","","",N,N],[17,"NI_NAMEREQD","","",N,N],[17,"NI_DGRAM","","",N,N],[17,"SYNC_FILE_RANGE_WAIT_BEFORE","","",N,N],[17,"SYNC_FILE_RANGE_WRITE","","",N,N],[17,"SYNC_FILE_RANGE_WAIT_AFTER","","",N,N],[17,"AIO_CANCELED","","",N,N],[17,"AIO_NOTCANCELED","","",N,N],[17,"AIO_ALLDONE","","",N,N],[17,"LIO_READ","","",N,N],[17,"LIO_WRITE","","",N,N],[17,"LIO_NOP","","",N,N],[17,"LIO_WAIT","","",N,N],[17,"LIO_NOWAIT","","",N,N],[17,"MREMAP_MAYMOVE","","",N,N],[17,"MREMAP_FIXED","","",N,N],[17,"PR_SET_PDEATHSIG","","",N,N],[17,"PR_GET_PDEATHSIG","","",N,N],[17,"PR_GET_DUMPABLE","","",N,N],[17,"PR_SET_DUMPABLE","","",N,N],[17,"PR_GET_UNALIGN","","",N,N],[17,"PR_SET_UNALIGN","","",N,N],[17,"PR_UNALIGN_NOPRINT","","",N,N],[17,"PR_UNALIGN_SIGBUS","","",N,N],[17,"PR_GET_KEEPCAPS","","",N,N],[17,"PR_SET_KEEPCAPS","","",N,N],[17,"PR_GET_FPEMU","","",N,N],[17,"PR_SET_FPEMU","","",N,N],[17,"PR_FPEMU_NOPRINT","","",N,N],[17,"PR_FPEMU_SIGFPE","","",N,N],[17,"PR_GET_FPEXC","","",N,N],[17,"PR_SET_FPEXC","","",N,N],[17,"PR_FP_EXC_SW_ENABLE","","",N,N],[17,"PR_FP_EXC_DIV","","",N,N],[17,"PR_FP_EXC_OVF","","",N,N],[17,"PR_FP_EXC_UND","","",N,N],[17,"PR_FP_EXC_RES","","",N,N],[17,"PR_FP_EXC_INV","","",N,N],[17,"PR_FP_EXC_DISABLED","","",N,N],[17,"PR_FP_EXC_NONRECOV","","",N,N],[17,"PR_FP_EXC_ASYNC","","",N,N],[17,"PR_FP_EXC_PRECISE","","",N,N],[17,"PR_GET_TIMING","","",N,N],[17,"PR_SET_TIMING","","",N,N],[17,"PR_TIMING_STATISTICAL","","",N,N],[17,"PR_TIMING_TIMESTAMP","","",N,N],[17,"PR_SET_NAME","","",N,N],[17,"PR_GET_NAME","","",N,N],[17,"PR_GET_ENDIAN","","",N,N],[17,"PR_SET_ENDIAN","","",N,N],[17,"PR_ENDIAN_BIG","","",N,N],[17,"PR_ENDIAN_LITTLE","","",N,N],[17,"PR_ENDIAN_PPC_LITTLE","","",N,N],[17,"PR_GET_SECCOMP","","",N,N],[17,"PR_SET_SECCOMP","","",N,N],[17,"PR_CAPBSET_READ","","",N,N],[17,"PR_CAPBSET_DROP","","",N,N],[17,"PR_GET_TSC","","",N,N],[17,"PR_SET_TSC","","",N,N],[17,"PR_TSC_ENABLE","","",N,N],[17,"PR_TSC_SIGSEGV","","",N,N],[17,"PR_GET_SECUREBITS","","",N,N],[17,"PR_SET_SECUREBITS","","",N,N],[17,"PR_SET_TIMERSLACK","","",N,N],[17,"PR_GET_TIMERSLACK","","",N,N],[17,"PR_TASK_PERF_EVENTS_DISABLE","","",N,N],[17,"PR_TASK_PERF_EVENTS_ENABLE","","",N,N],[17,"PR_MCE_KILL","","",N,N],[17,"PR_MCE_KILL_CLEAR","","",N,N],[17,"PR_MCE_KILL_SET","","",N,N],[17,"PR_MCE_KILL_LATE","","",N,N],[17,"PR_MCE_KILL_EARLY","","",N,N],[17,"PR_MCE_KILL_DEFAULT","","",N,N],[17,"PR_MCE_KILL_GET","","",N,N],[17,"PR_SET_MM","","",N,N],[17,"PR_SET_MM_START_CODE","","",N,N],[17,"PR_SET_MM_END_CODE","","",N,N],[17,"PR_SET_MM_START_DATA","","",N,N],[17,"PR_SET_MM_END_DATA","","",N,N],[17,"PR_SET_MM_START_STACK","","",N,N],[17,"PR_SET_MM_START_BRK","","",N,N],[17,"PR_SET_MM_BRK","","",N,N],[17,"PR_SET_MM_ARG_START","","",N,N],[17,"PR_SET_MM_ARG_END","","",N,N],[17,"PR_SET_MM_ENV_START","","",N,N],[17,"PR_SET_MM_ENV_END","","",N,N],[17,"PR_SET_MM_AUXV","","",N,N],[17,"PR_SET_MM_EXE_FILE","","",N,N],[17,"PR_SET_MM_MAP","","",N,N],[17,"PR_SET_MM_MAP_SIZE","","",N,N],[17,"PR_SET_PTRACER","","",N,N],[17,"PR_SET_CHILD_SUBREAPER","","",N,N],[17,"PR_GET_CHILD_SUBREAPER","","",N,N],[17,"PR_SET_NO_NEW_PRIVS","","",N,N],[17,"PR_GET_NO_NEW_PRIVS","","",N,N],[17,"PR_GET_TID_ADDRESS","","",N,N],[17,"PR_SET_THP_DISABLE","","",N,N],[17,"PR_GET_THP_DISABLE","","",N,N],[17,"PR_MPX_ENABLE_MANAGEMENT","","",N,N],[17,"PR_MPX_DISABLE_MANAGEMENT","","",N,N],[17,"PR_SET_FP_MODE","","",N,N],[17,"PR_GET_FP_MODE","","",N,N],[17,"PR_FP_MODE_FR","","",N,N],[17,"PR_FP_MODE_FRE","","",N,N],[17,"PR_CAP_AMBIENT","","",N,N],[17,"PR_CAP_AMBIENT_IS_SET","","",N,N],[17,"PR_CAP_AMBIENT_RAISE","","",N,N],[17,"PR_CAP_AMBIENT_LOWER","","",N,N],[17,"PR_CAP_AMBIENT_CLEAR_ALL","","",N,N],[17,"GRND_NONBLOCK","","",N,N],[17,"GRND_RANDOM","","",N,N],[17,"SECCOMP_MODE_DISABLED","","",N,N],[17,"SECCOMP_MODE_STRICT","","",N,N],[17,"SECCOMP_MODE_FILTER","","",N,N],[17,"ITIMER_REAL","","",N,N],[17,"ITIMER_VIRTUAL","","",N,N],[17,"ITIMER_PROF","","",N,N],[17,"TFD_CLOEXEC","","",N,N],[17,"TFD_NONBLOCK","","",N,N],[17,"TFD_TIMER_ABSTIME","","",N,N],[17,"XATTR_CREATE","","",N,N],[17,"XATTR_REPLACE","","",N,N],[17,"_POSIX_VDISABLE","","",N,N],[17,"FALLOC_FL_KEEP_SIZE","","",N,N],[17,"FALLOC_FL_PUNCH_HOLE","","",N,N],[17,"FALLOC_FL_COLLAPSE_RANGE","","",N,N],[17,"FALLOC_FL_ZERO_RANGE","","",N,N],[17,"FALLOC_FL_INSERT_RANGE","","",N,N],[17,"FALLOC_FL_UNSHARE_RANGE","","",N,N],[17,"ENOATTR","","",N,N],[17,"SO_ORIGINAL_DST","","",N,N],[17,"IUTF8","","",N,N],[17,"CMSPAR","","",N,N],[17,"MFD_CLOEXEC","","",N,N],[17,"MFD_ALLOW_SEALING","","",N,N],[17,"PT_NULL","","",N,N],[17,"PT_LOAD","","",N,N],[17,"PT_DYNAMIC","","",N,N],[17,"PT_INTERP","","",N,N],[17,"PT_NOTE","","",N,N],[17,"PT_SHLIB","","",N,N],[17,"PT_PHDR","","",N,N],[17,"PT_TLS","","",N,N],[17,"PT_NUM","","",N,N],[17,"PT_LOOS","","",N,N],[17,"PT_GNU_EH_FRAME","","",N,N],[17,"PT_GNU_STACK","","",N,N],[17,"PT_GNU_RELRO","","",N,N],[17,"ETH_ALEN","","",N,N],[17,"ETH_HLEN","","",N,N],[17,"ETH_ZLEN","","",N,N],[17,"ETH_DATA_LEN","","",N,N],[17,"ETH_FRAME_LEN","","",N,N],[17,"ETH_FCS_LEN","","",N,N],[17,"ETH_P_LOOP","","",N,N],[17,"ETH_P_PUP","","",N,N],[17,"ETH_P_PUPAT","","",N,N],[17,"ETH_P_IP","","",N,N],[17,"ETH_P_X25","","",N,N],[17,"ETH_P_ARP","","",N,N],[17,"ETH_P_BPQ","","",N,N],[17,"ETH_P_IEEEPUP","","",N,N],[17,"ETH_P_IEEEPUPAT","","",N,N],[17,"ETH_P_BATMAN","","",N,N],[17,"ETH_P_DEC","","",N,N],[17,"ETH_P_DNA_DL","","",N,N],[17,"ETH_P_DNA_RC","","",N,N],[17,"ETH_P_DNA_RT","","",N,N],[17,"ETH_P_LAT","","",N,N],[17,"ETH_P_DIAG","","",N,N],[17,"ETH_P_CUST","","",N,N],[17,"ETH_P_SCA","","",N,N],[17,"ETH_P_TEB","","",N,N],[17,"ETH_P_RARP","","",N,N],[17,"ETH_P_ATALK","","",N,N],[17,"ETH_P_AARP","","",N,N],[17,"ETH_P_8021Q","","",N,N],[17,"ETH_P_IPX","","",N,N],[17,"ETH_P_IPV6","","",N,N],[17,"ETH_P_PAUSE","","",N,N],[17,"ETH_P_SLOW","","",N,N],[17,"ETH_P_WCCP","","",N,N],[17,"ETH_P_MPLS_UC","","",N,N],[17,"ETH_P_MPLS_MC","","",N,N],[17,"ETH_P_ATMMPOA","","",N,N],[17,"ETH_P_PPP_DISC","","",N,N],[17,"ETH_P_PPP_SES","","",N,N],[17,"ETH_P_LINK_CTL","","",N,N],[17,"ETH_P_ATMFATE","","",N,N],[17,"ETH_P_PAE","","",N,N],[17,"ETH_P_AOE","","",N,N],[17,"ETH_P_8021AD","","",N,N],[17,"ETH_P_802_EX1","","",N,N],[17,"ETH_P_TIPC","","",N,N],[17,"ETH_P_MACSEC","","",N,N],[17,"ETH_P_8021AH","","",N,N],[17,"ETH_P_MVRP","","",N,N],[17,"ETH_P_1588","","",N,N],[17,"ETH_P_PRP","","",N,N],[17,"ETH_P_FCOE","","",N,N],[17,"ETH_P_TDLS","","",N,N],[17,"ETH_P_FIP","","",N,N],[17,"ETH_P_80221","","",N,N],[17,"ETH_P_LOOPBACK","","",N,N],[17,"ETH_P_QINQ1","","",N,N],[17,"ETH_P_QINQ2","","",N,N],[17,"ETH_P_QINQ3","","",N,N],[17,"ETH_P_EDSA","","",N,N],[17,"ETH_P_AF_IUCV","","",N,N],[17,"ETH_P_802_3_MIN","","",N,N],[17,"ETH_P_802_3","","",N,N],[17,"ETH_P_AX25","","",N,N],[17,"ETH_P_ALL","","",N,N],[17,"ETH_P_802_2","","",N,N],[17,"ETH_P_SNAP","","",N,N],[17,"ETH_P_DDCMP","","",N,N],[17,"ETH_P_WAN_PPP","","",N,N],[17,"ETH_P_PPP_MP","","",N,N],[17,"ETH_P_LOCALTALK","","",N,N],[17,"ETH_P_CANFD","","",N,N],[17,"ETH_P_PPPTALK","","",N,N],[17,"ETH_P_TR_802_2","","",N,N],[17,"ETH_P_MOBITEX","","",N,N],[17,"ETH_P_CONTROL","","",N,N],[17,"ETH_P_IRDA","","",N,N],[17,"ETH_P_ECONET","","",N,N],[17,"ETH_P_HDLC","","",N,N],[17,"ETH_P_ARCNET","","",N,N],[17,"ETH_P_DSA","","",N,N],[17,"ETH_P_TRAILER","","",N,N],[17,"ETH_P_PHONET","","",N,N],[17,"ETH_P_IEEE802154","","",N,N],[17,"ETH_P_CAIF","","",N,N],[17,"POSIX_SPAWN_RESETIDS","","",N,N],[17,"POSIX_SPAWN_SETPGROUP","","",N,N],[17,"POSIX_SPAWN_SETSIGDEF","","",N,N],[17,"POSIX_SPAWN_SETSIGMASK","","",N,N],[17,"POSIX_SPAWN_SETSCHEDPARAM","","",N,N],[17,"POSIX_SPAWN_SETSCHEDULER","","",N,N],[17,"NLMSG_NOOP","","",N,N],[17,"NLMSG_ERROR","","",N,N],[17,"NLMSG_DONE","","",N,N],[17,"NLMSG_OVERRUN","","",N,N],[17,"NLMSG_MIN_TYPE","","",N,N],[17,"GENL_NAMSIZ","","",N,N],[17,"GENL_MIN_ID","","",N,N],[17,"GENL_MAX_ID","","",N,N],[17,"GENL_ADMIN_PERM","","",N,N],[17,"GENL_CMD_CAP_DO","","",N,N],[17,"GENL_CMD_CAP_DUMP","","",N,N],[17,"GENL_CMD_CAP_HASPOL","","",N,N],[17,"GENL_ID_CTRL","","",N,N],[17,"CTRL_CMD_UNSPEC","","",N,N],[17,"CTRL_CMD_NEWFAMILY","","",N,N],[17,"CTRL_CMD_DELFAMILY","","",N,N],[17,"CTRL_CMD_GETFAMILY","","",N,N],[17,"CTRL_CMD_NEWOPS","","",N,N],[17,"CTRL_CMD_DELOPS","","",N,N],[17,"CTRL_CMD_GETOPS","","",N,N],[17,"CTRL_CMD_NEWMCAST_GRP","","",N,N],[17,"CTRL_CMD_DELMCAST_GRP","","",N,N],[17,"CTRL_CMD_GETMCAST_GRP","","",N,N],[17,"CTRL_ATTR_UNSPEC","","",N,N],[17,"CTRL_ATTR_FAMILY_ID","","",N,N],[17,"CTRL_ATTR_FAMILY_NAME","","",N,N],[17,"CTRL_ATTR_VERSION","","",N,N],[17,"CTRL_ATTR_HDRSIZE","","",N,N],[17,"CTRL_ATTR_MAXATTR","","",N,N],[17,"CTRL_ATTR_OPS","","",N,N],[17,"CTRL_ATTR_MCAST_GROUPS","","",N,N],[17,"CTRL_ATTR_OP_UNSPEC","","",N,N],[17,"CTRL_ATTR_OP_ID","","",N,N],[17,"CTRL_ATTR_OP_FLAGS","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_UNSPEC","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_NAME","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_ID","","",N,N],[17,"NF_DROP","","",N,N],[17,"NF_ACCEPT","","",N,N],[17,"NF_STOLEN","","",N,N],[17,"NF_QUEUE","","",N,N],[17,"NF_REPEAT","","",N,N],[17,"NF_STOP","","",N,N],[17,"NF_MAX_VERDICT","","",N,N],[17,"NF_VERDICT_MASK","","",N,N],[17,"NF_VERDICT_FLAG_QUEUE_BYPASS","","",N,N],[17,"NF_VERDICT_QMASK","","",N,N],[17,"NF_VERDICT_QBITS","","",N,N],[17,"NF_VERDICT_BITS","","",N,N],[17,"NF_INET_PRE_ROUTING","","",N,N],[17,"NF_INET_LOCAL_IN","","",N,N],[17,"NF_INET_FORWARD","","",N,N],[17,"NF_INET_LOCAL_OUT","","",N,N],[17,"NF_INET_POST_ROUTING","","",N,N],[17,"NF_INET_NUMHOOKS","","",N,N],[17,"NFPROTO_UNSPEC","","",N,N],[17,"NFPROTO_IPV4","","",N,N],[17,"NFPROTO_ARP","","",N,N],[17,"NFPROTO_BRIDGE","","",N,N],[17,"NFPROTO_IPV6","","",N,N],[17,"NFPROTO_DECNET","","",N,N],[17,"NFPROTO_NUMPROTO","","",N,N],[17,"NF_IP_PRE_ROUTING","","",N,N],[17,"NF_IP_LOCAL_IN","","",N,N],[17,"NF_IP_FORWARD","","",N,N],[17,"NF_IP_LOCAL_OUT","","",N,N],[17,"NF_IP_POST_ROUTING","","",N,N],[17,"NF_IP_NUMHOOKS","","",N,N],[17,"NF_IP_PRI_FIRST","","",N,N],[17,"NF_IP_PRI_CONNTRACK_DEFRAG","","",N,N],[17,"NF_IP_PRI_RAW","","",N,N],[17,"NF_IP_PRI_SELINUX_FIRST","","",N,N],[17,"NF_IP_PRI_CONNTRACK","","",N,N],[17,"NF_IP_PRI_MANGLE","","",N,N],[17,"NF_IP_PRI_NAT_DST","","",N,N],[17,"NF_IP_PRI_FILTER","","",N,N],[17,"NF_IP_PRI_SECURITY","","",N,N],[17,"NF_IP_PRI_NAT_SRC","","",N,N],[17,"NF_IP_PRI_SELINUX_LAST","","",N,N],[17,"NF_IP_PRI_CONNTRACK_HELPER","","",N,N],[17,"NF_IP_PRI_CONNTRACK_CONFIRM","","",N,N],[17,"NF_IP_PRI_LAST","","",N,N],[17,"NF_IP6_PRE_ROUTING","","",N,N],[17,"NF_IP6_LOCAL_IN","","",N,N],[17,"NF_IP6_FORWARD","","",N,N],[17,"NF_IP6_LOCAL_OUT","","",N,N],[17,"NF_IP6_POST_ROUTING","","",N,N],[17,"NF_IP6_NUMHOOKS","","",N,N],[17,"NF_IP6_PRI_FIRST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK_DEFRAG","","",N,N],[17,"NF_IP6_PRI_RAW","","",N,N],[17,"NF_IP6_PRI_SELINUX_FIRST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK","","",N,N],[17,"NF_IP6_PRI_MANGLE","","",N,N],[17,"NF_IP6_PRI_NAT_DST","","",N,N],[17,"NF_IP6_PRI_FILTER","","",N,N],[17,"NF_IP6_PRI_SECURITY","","",N,N],[17,"NF_IP6_PRI_NAT_SRC","","",N,N],[17,"NF_IP6_PRI_SELINUX_LAST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK_HELPER","","",N,N],[17,"NF_IP6_PRI_LAST","","",N,N],[17,"SIOCADDRT","","",N,N],[17,"SIOCDELRT","","",N,N],[17,"SIOCGIFNAME","","",N,N],[17,"SIOCSIFLINK","","",N,N],[17,"SIOCGIFCONF","","",N,N],[17,"SIOCGIFFLAGS","","",N,N],[17,"SIOCSIFFLAGS","","",N,N],[17,"SIOCGIFADDR","","",N,N],[17,"SIOCSIFADDR","","",N,N],[17,"SIOCGIFDSTADDR","","",N,N],[17,"SIOCSIFDSTADDR","","",N,N],[17,"SIOCGIFBRDADDR","","",N,N],[17,"SIOCSIFBRDADDR","","",N,N],[17,"SIOCGIFNETMASK","","",N,N],[17,"SIOCSIFNETMASK","","",N,N],[17,"SIOCGIFMETRIC","","",N,N],[17,"SIOCSIFMETRIC","","",N,N],[17,"SIOCGIFMEM","","",N,N],[17,"SIOCSIFMEM","","",N,N],[17,"SIOCGIFMTU","","",N,N],[17,"SIOCSIFMTU","","",N,N],[17,"SIOCSIFHWADDR","","",N,N],[17,"SIOCGIFENCAP","","",N,N],[17,"SIOCSIFENCAP","","",N,N],[17,"SIOCGIFHWADDR","","",N,N],[17,"SIOCGIFSLAVE","","",N,N],[17,"SIOCSIFSLAVE","","",N,N],[17,"SIOCADDMULTI","","",N,N],[17,"SIOCDELMULTI","","",N,N],[17,"SIOCDARP","","",N,N],[17,"SIOCGARP","","",N,N],[17,"SIOCSARP","","",N,N],[17,"SIOCDRARP","","",N,N],[17,"SIOCGRARP","","",N,N],[17,"SIOCSRARP","","",N,N],[17,"SIOCGIFMAP","","",N,N],[17,"SIOCSIFMAP","","",N,N],[17,"IPTOS_TOS_MASK","","",N,N],[17,"IPTOS_PREC_MASK","","",N,N],[17,"RTF_UP","","",N,N],[17,"RTF_GATEWAY","","",N,N],[17,"RTF_HOST","","",N,N],[17,"RTF_REINSTATE","","",N,N],[17,"RTF_DYNAMIC","","",N,N],[17,"RTF_MODIFIED","","",N,N],[17,"RTF_MTU","","",N,N],[17,"RTF_MSS","","",N,N],[17,"RTF_WINDOW","","",N,N],[17,"RTF_IRTT","","",N,N],[17,"RTF_REJECT","","",N,N],[17,"RTF_STATIC","","",N,N],[17,"RTF_XRESOLVE","","",N,N],[17,"RTF_NOFORWARD","","",N,N],[17,"RTF_THROW","","",N,N],[17,"RTF_NOPMTUDISC","","",N,N],[17,"RTF_DEFAULT","","",N,N],[17,"RTF_ALLONLINK","","",N,N],[17,"RTF_ADDRCONF","","",N,N],[17,"RTF_LINKRT","","",N,N],[17,"RTF_NONEXTHOP","","",N,N],[17,"RTF_CACHE","","",N,N],[17,"RTF_FLOW","","",N,N],[17,"RTF_POLICY","","",N,N],[17,"RTCF_VALVE","","",N,N],[17,"RTCF_MASQ","","",N,N],[17,"RTCF_NAT","","",N,N],[17,"RTCF_DOREDIRECT","","",N,N],[17,"RTCF_LOG","","",N,N],[17,"RTCF_DIRECTSRC","","",N,N],[17,"RTF_LOCAL","","",N,N],[17,"RTF_INTERFACE","","",N,N],[17,"RTF_MULTICAST","","",N,N],[17,"RTF_BROADCAST","","",N,N],[17,"RTF_NAT","","",N,N],[17,"RTF_ADDRCLASSMASK","","",N,N],[17,"RT_CLASS_UNSPEC","","",N,N],[17,"RT_CLASS_DEFAULT","","",N,N],[17,"RT_CLASS_MAIN","","",N,N],[17,"RT_CLASS_LOCAL","","",N,N],[17,"RT_CLASS_MAX","","",N,N],[17,"RTMSG_OVERRUN","","",N,N],[17,"RTMSG_NEWDEVICE","","",N,N],[17,"RTMSG_DELDEVICE","","",N,N],[17,"RTMSG_NEWROUTE","","",N,N],[17,"RTMSG_DELROUTE","","",N,N],[17,"RTMSG_NEWRULE","","",N,N],[17,"RTMSG_DELRULE","","",N,N],[17,"RTMSG_CONTROL","","",N,N],[17,"RTMSG_AR_FAILED","","",N,N],[17,"__UT_LINESIZE","","",N,N],[17,"__UT_NAMESIZE","","",N,N],[17,"__UT_HOSTSIZE","","",N,N],[17,"EMPTY","","",N,N],[17,"RUN_LVL","","",N,N],[17,"BOOT_TIME","","",N,N],[17,"NEW_TIME","","",N,N],[17,"OLD_TIME","","",N,N],[17,"INIT_PROCESS","","",N,N],[17,"LOGIN_PROCESS","","",N,N],[17,"USER_PROCESS","","",N,N],[17,"DEAD_PROCESS","","",N,N],[17,"ACCOUNTING","","",N,N],[17,"RLIMIT_RSS","","",N,N],[17,"RLIMIT_AS","","",N,N],[17,"RLIMIT_MEMLOCK","","",N,N],[17,"RLIM_INFINITY","","",N,N],[17,"RLIMIT_RTTIME","","",N,N],[17,"RLIMIT_NLIMITS","","",N,N],[17,"SOCK_NONBLOCK","","",N,N],[17,"SOL_RXRPC","","",N,N],[17,"SOL_PPPOL2TP","","",N,N],[17,"SOL_BLUETOOTH","","",N,N],[17,"SOL_PNPIPE","","",N,N],[17,"SOL_RDS","","",N,N],[17,"SOL_IUCV","","",N,N],[17,"SOL_CAIF","","",N,N],[17,"SOL_ALG","","",N,N],[17,"SOL_NFC","","",N,N],[17,"MSG_TRYHARD","","",N,N],[17,"LC_PAPER","","",N,N],[17,"LC_NAME","","",N,N],[17,"LC_ADDRESS","","",N,N],[17,"LC_TELEPHONE","","",N,N],[17,"LC_MEASUREMENT","","",N,N],[17,"LC_IDENTIFICATION","","",N,N],[17,"LC_PAPER_MASK","","",N,N],[17,"LC_NAME_MASK","","",N,N],[17,"LC_ADDRESS_MASK","","",N,N],[17,"LC_TELEPHONE_MASK","","",N,N],[17,"LC_MEASUREMENT_MASK","","",N,N],[17,"LC_IDENTIFICATION_MASK","","",N,N],[17,"LC_ALL_MASK","","",N,N],[17,"MAP_ANON","","",N,N],[17,"MAP_ANONYMOUS","","",N,N],[17,"MAP_DENYWRITE","","",N,N],[17,"MAP_EXECUTABLE","","",N,N],[17,"MAP_POPULATE","","",N,N],[17,"MAP_NONBLOCK","","",N,N],[17,"MAP_STACK","","",N,N],[17,"ENOTSUP","","",N,N],[17,"EUCLEAN","","",N,N],[17,"ENOTNAM","","",N,N],[17,"ENAVAIL","","",N,N],[17,"EISNAM","","",N,N],[17,"EREMOTEIO","","",N,N],[17,"SOCK_STREAM","","",N,N],[17,"SOCK_DGRAM","","",N,N],[17,"SOCK_SEQPACKET","","",N,N],[17,"SOCK_DCCP","","",N,N],[17,"SOCK_PACKET","","",N,N],[17,"TCP_COOKIE_TRANSACTIONS","","",N,N],[17,"TCP_THIN_LINEAR_TIMEOUTS","","",N,N],[17,"TCP_THIN_DUPACK","","",N,N],[17,"TCP_USER_TIMEOUT","","",N,N],[17,"TCP_REPAIR","","",N,N],[17,"TCP_REPAIR_QUEUE","","",N,N],[17,"TCP_QUEUE_SEQ","","",N,N],[17,"TCP_REPAIR_OPTIONS","","",N,N],[17,"TCP_FASTOPEN","","",N,N],[17,"TCP_TIMESTAMP","","",N,N],[17,"DCCP_SOCKOPT_PACKET_SIZE","","",N,N],[17,"DCCP_SOCKOPT_SERVICE","","",N,N],[17,"DCCP_SOCKOPT_CHANGE_L","","",N,N],[17,"DCCP_SOCKOPT_CHANGE_R","","",N,N],[17,"DCCP_SOCKOPT_GET_CUR_MPS","","",N,N],[17,"DCCP_SOCKOPT_SERVER_TIMEWAIT","","",N,N],[17,"DCCP_SOCKOPT_SEND_CSCOV","","",N,N],[17,"DCCP_SOCKOPT_RECV_CSCOV","","",N,N],[17,"DCCP_SOCKOPT_AVAILABLE_CCIDS","","",N,N],[17,"DCCP_SOCKOPT_CCID","","",N,N],[17,"DCCP_SOCKOPT_TX_CCID","","",N,N],[17,"DCCP_SOCKOPT_RX_CCID","","",N,N],[17,"DCCP_SOCKOPT_QPOLICY_ID","","",N,N],[17,"DCCP_SOCKOPT_QPOLICY_TXQLEN","","",N,N],[17,"DCCP_SOCKOPT_CCID_RX_INFO","","",N,N],[17,"DCCP_SOCKOPT_CCID_TX_INFO","","",N,N],[17,"DCCP_SERVICE_LIST_MAX_LEN","","maximum number of services provided on the same listening port",N,N],[17,"SIGTTIN","","",N,N],[17,"SIGTTOU","","",N,N],[17,"SIGXCPU","","",N,N],[17,"SIGXFSZ","","",N,N],[17,"SIGVTALRM","","",N,N],[17,"SIGPROF","","",N,N],[17,"SIGWINCH","","",N,N],[17,"SIGEV_THREAD_ID","","",N,N],[17,"BUFSIZ","","",N,N],[17,"TMP_MAX","","",N,N],[17,"FOPEN_MAX","","",N,N],[17,"POSIX_FADV_DONTNEED","","",N,N],[17,"POSIX_FADV_NOREUSE","","",N,N],[17,"POSIX_MADV_DONTNEED","","",N,N],[17,"_SC_EQUIV_CLASS_MAX","","",N,N],[17,"_SC_CHARCLASS_NAME_MAX","","",N,N],[17,"_SC_PII","","",N,N],[17,"_SC_PII_XTI","","",N,N],[17,"_SC_PII_SOCKET","","",N,N],[17,"_SC_PII_INTERNET","","",N,N],[17,"_SC_PII_OSI","","",N,N],[17,"_SC_POLL","","",N,N],[17,"_SC_SELECT","","",N,N],[17,"_SC_PII_INTERNET_STREAM","","",N,N],[17,"_SC_PII_INTERNET_DGRAM","","",N,N],[17,"_SC_PII_OSI_COTS","","",N,N],[17,"_SC_PII_OSI_CLTS","","",N,N],[17,"_SC_PII_OSI_M","","",N,N],[17,"_SC_T_IOV_MAX","","",N,N],[17,"_SC_2_C_VERSION","","",N,N],[17,"_SC_CHAR_BIT","","",N,N],[17,"_SC_CHAR_MAX","","",N,N],[17,"_SC_CHAR_MIN","","",N,N],[17,"_SC_INT_MAX","","",N,N],[17,"_SC_INT_MIN","","",N,N],[17,"_SC_LONG_BIT","","",N,N],[17,"_SC_WORD_BIT","","",N,N],[17,"_SC_MB_LEN_MAX","","",N,N],[17,"_SC_SSIZE_MAX","","",N,N],[17,"_SC_SCHAR_MAX","","",N,N],[17,"_SC_SCHAR_MIN","","",N,N],[17,"_SC_SHRT_MAX","","",N,N],[17,"_SC_SHRT_MIN","","",N,N],[17,"_SC_UCHAR_MAX","","",N,N],[17,"_SC_UINT_MAX","","",N,N],[17,"_SC_ULONG_MAX","","",N,N],[17,"_SC_USHRT_MAX","","",N,N],[17,"_SC_NL_ARGMAX","","",N,N],[17,"_SC_NL_LANGMAX","","",N,N],[17,"_SC_NL_MSGMAX","","",N,N],[17,"_SC_NL_NMAX","","",N,N],[17,"_SC_NL_SETMAX","","",N,N],[17,"_SC_NL_TEXTMAX","","",N,N],[17,"_SC_BASE","","",N,N],[17,"_SC_C_LANG_SUPPORT","","",N,N],[17,"_SC_C_LANG_SUPPORT_R","","",N,N],[17,"_SC_DEVICE_IO","","",N,N],[17,"_SC_DEVICE_SPECIFIC","","",N,N],[17,"_SC_DEVICE_SPECIFIC_R","","",N,N],[17,"_SC_FD_MGMT","","",N,N],[17,"_SC_FIFO","","",N,N],[17,"_SC_PIPE","","",N,N],[17,"_SC_FILE_ATTRIBUTES","","",N,N],[17,"_SC_FILE_LOCKING","","",N,N],[17,"_SC_FILE_SYSTEM","","",N,N],[17,"_SC_MULTI_PROCESS","","",N,N],[17,"_SC_SINGLE_PROCESS","","",N,N],[17,"_SC_NETWORKING","","",N,N],[17,"_SC_REGEX_VERSION","","",N,N],[17,"_SC_SIGNALS","","",N,N],[17,"_SC_SYSTEM_DATABASE","","",N,N],[17,"_SC_SYSTEM_DATABASE_R","","",N,N],[17,"_SC_USER_GROUPS","","",N,N],[17,"_SC_USER_GROUPS_R","","",N,N],[17,"_SC_LEVEL1_ICACHE_SIZE","","",N,N],[17,"_SC_LEVEL1_ICACHE_ASSOC","","",N,N],[17,"_SC_LEVEL1_ICACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL1_DCACHE_SIZE","","",N,N],[17,"_SC_LEVEL1_DCACHE_ASSOC","","",N,N],[17,"_SC_LEVEL1_DCACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL2_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL2_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL2_CACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL3_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL3_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL3_CACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL4_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL4_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL4_CACHE_LINESIZE","","",N,N],[17,"O_ACCMODE","","",N,N],[17,"ST_RELATIME","","",N,N],[17,"NI_MAXHOST","","",N,N],[17,"ADFS_SUPER_MAGIC","","",N,N],[17,"AFFS_SUPER_MAGIC","","",N,N],[17,"CODA_SUPER_MAGIC","","",N,N],[17,"CRAMFS_MAGIC","","",N,N],[17,"EFS_SUPER_MAGIC","","",N,N],[17,"EXT2_SUPER_MAGIC","","",N,N],[17,"EXT3_SUPER_MAGIC","","",N,N],[17,"EXT4_SUPER_MAGIC","","",N,N],[17,"HPFS_SUPER_MAGIC","","",N,N],[17,"HUGETLBFS_MAGIC","","",N,N],[17,"ISOFS_SUPER_MAGIC","","",N,N],[17,"JFFS2_SUPER_MAGIC","","",N,N],[17,"MINIX_SUPER_MAGIC","","",N,N],[17,"MINIX_SUPER_MAGIC2","","",N,N],[17,"MINIX2_SUPER_MAGIC","","",N,N],[17,"MINIX2_SUPER_MAGIC2","","",N,N],[17,"MSDOS_SUPER_MAGIC","","",N,N],[17,"NCP_SUPER_MAGIC","","",N,N],[17,"NFS_SUPER_MAGIC","","",N,N],[17,"OPENPROM_SUPER_MAGIC","","",N,N],[17,"PROC_SUPER_MAGIC","","",N,N],[17,"QNX4_SUPER_MAGIC","","",N,N],[17,"REISERFS_SUPER_MAGIC","","",N,N],[17,"SMB_SUPER_MAGIC","","",N,N],[17,"TMPFS_MAGIC","","",N,N],[17,"USBDEVICE_SUPER_MAGIC","","",N,N],[17,"VEOF","","",N,N],[17,"CPU_SETSIZE","","",N,N],[17,"PTRACE_TRACEME","","",N,N],[17,"PTRACE_PEEKTEXT","","",N,N],[17,"PTRACE_PEEKDATA","","",N,N],[17,"PTRACE_PEEKUSER","","",N,N],[17,"PTRACE_POKETEXT","","",N,N],[17,"PTRACE_POKEDATA","","",N,N],[17,"PTRACE_POKEUSER","","",N,N],[17,"PTRACE_CONT","","",N,N],[17,"PTRACE_KILL","","",N,N],[17,"PTRACE_SINGLESTEP","","",N,N],[17,"PTRACE_ATTACH","","",N,N],[17,"PTRACE_SYSCALL","","",N,N],[17,"PTRACE_SETOPTIONS","","",N,N],[17,"PTRACE_GETEVENTMSG","","",N,N],[17,"PTRACE_GETSIGINFO","","",N,N],[17,"PTRACE_SETSIGINFO","","",N,N],[17,"PTRACE_GETREGSET","","",N,N],[17,"PTRACE_SETREGSET","","",N,N],[17,"PTRACE_SEIZE","","",N,N],[17,"PTRACE_INTERRUPT","","",N,N],[17,"PTRACE_LISTEN","","",N,N],[17,"PTRACE_PEEKSIGINFO","","",N,N],[17,"EPOLLWAKEUP","","",N,N],[17,"MAP_HUGETLB","","",N,N],[17,"SEEK_DATA","","",N,N],[17,"SEEK_HOLE","","",N,N],[17,"TCSANOW","","",N,N],[17,"TCSADRAIN","","",N,N],[17,"TCSAFLUSH","","",N,N],[17,"TIOCLINUX","","",N,N],[17,"TIOCGSERIAL","","",N,N],[17,"RTLD_DEEPBIND","","",N,N],[17,"RTLD_GLOBAL","","",N,N],[17,"RTLD_NOLOAD","","",N,N],[17,"LINUX_REBOOT_MAGIC1","","",N,N],[17,"LINUX_REBOOT_MAGIC2","","",N,N],[17,"LINUX_REBOOT_MAGIC2A","","",N,N],[17,"LINUX_REBOOT_MAGIC2B","","",N,N],[17,"LINUX_REBOOT_MAGIC2C","","",N,N],[17,"LINUX_REBOOT_CMD_RESTART","","",N,N],[17,"LINUX_REBOOT_CMD_HALT","","",N,N],[17,"LINUX_REBOOT_CMD_CAD_ON","","",N,N],[17,"LINUX_REBOOT_CMD_CAD_OFF","","",N,N],[17,"LINUX_REBOOT_CMD_POWER_OFF","","",N,N],[17,"LINUX_REBOOT_CMD_RESTART2","","",N,N],[17,"LINUX_REBOOT_CMD_SW_SUSPEND","","",N,N],[17,"LINUX_REBOOT_CMD_KEXEC","","",N,N],[17,"NETLINK_ROUTE","","",N,N],[17,"NETLINK_UNUSED","","",N,N],[17,"NETLINK_USERSOCK","","",N,N],[17,"NETLINK_FIREWALL","","",N,N],[17,"NETLINK_SOCK_DIAG","","",N,N],[17,"NETLINK_NFLOG","","",N,N],[17,"NETLINK_XFRM","","",N,N],[17,"NETLINK_SELINUX","","",N,N],[17,"NETLINK_ISCSI","","",N,N],[17,"NETLINK_AUDIT","","",N,N],[17,"NETLINK_FIB_LOOKUP","","",N,N],[17,"NETLINK_CONNECTOR","","",N,N],[17,"NETLINK_NETFILTER","","",N,N],[17,"NETLINK_IP6_FW","","",N,N],[17,"NETLINK_DNRTMSG","","",N,N],[17,"NETLINK_KOBJECT_UEVENT","","",N,N],[17,"NETLINK_GENERIC","","",N,N],[17,"NETLINK_SCSITRANSPORT","","",N,N],[17,"NETLINK_ECRYPTFS","","",N,N],[17,"NETLINK_RDMA","","",N,N],[17,"NETLINK_CRYPTO","","",N,N],[17,"NETLINK_INET_DIAG","","",N,N],[17,"MAX_LINKS","","",N,N],[17,"NLM_F_REQUEST","","",N,N],[17,"NLM_F_MULTI","","",N,N],[17,"NLM_F_ACK","","",N,N],[17,"NLM_F_ECHO","","",N,N],[17,"NLM_F_DUMP_INTR","","",N,N],[17,"NLM_F_DUMP_FILTERED","","",N,N],[17,"NLM_F_ROOT","","",N,N],[17,"NLM_F_MATCH","","",N,N],[17,"NLM_F_ATOMIC","","",N,N],[17,"NLM_F_DUMP","","",N,N],[17,"NLM_F_REPLACE","","",N,N],[17,"NLM_F_EXCL","","",N,N],[17,"NLM_F_CREATE","","",N,N],[17,"NLM_F_APPEND","","",N,N],[17,"NETLINK_ADD_MEMBERSHIP","","",N,N],[17,"NETLINK_DROP_MEMBERSHIP","","",N,N],[17,"NETLINK_PKTINFO","","",N,N],[17,"NETLINK_BROADCAST_ERROR","","",N,N],[17,"NETLINK_NO_ENOBUFS","","",N,N],[17,"NETLINK_RX_RING","","",N,N],[17,"NETLINK_TX_RING","","",N,N],[17,"NETLINK_LISTEN_ALL_NSID","","",N,N],[17,"NETLINK_LIST_MEMBERSHIPS","","",N,N],[17,"NETLINK_CAP_ACK","","",N,N],[17,"NLA_F_NESTED","","",N,N],[17,"NLA_F_NET_BYTEORDER","","",N,N],[17,"NLA_TYPE_MASK","","",N,N],[17,"NLA_ALIGNTO","","",N,N],[17,"GENL_UNS_ADMIN_PERM","","",N,N],[17,"GENL_ID_VFS_DQUOT","","",N,N],[17,"GENL_ID_PMCRAID","","",N,N],[17,"TIOCM_LE","","",N,N],[17,"TIOCM_DTR","","",N,N],[17,"TIOCM_RTS","","",N,N],[17,"TIOCM_ST","","",N,N],[17,"TIOCM_SR","","",N,N],[17,"TIOCM_CTS","","",N,N],[17,"TIOCM_CAR","","",N,N],[17,"TIOCM_RNG","","",N,N],[17,"TIOCM_DSR","","",N,N],[17,"TIOCM_CD","","",N,N],[17,"TIOCM_RI","","",N,N],[17,"NF_NETDEV_INGRESS","","",N,N],[17,"NF_NETDEV_NUMHOOKS","","",N,N],[17,"NFPROTO_INET","","",N,N],[17,"NFPROTO_NETDEV","","",N,N],[17,"NFT_TABLE_MAXNAMELEN","","",N,N],[17,"NFT_CHAIN_MAXNAMELEN","","",N,N],[17,"NFT_SET_MAXNAMELEN","","",N,N],[17,"NFT_OBJ_MAXNAMELEN","","",N,N],[17,"NFT_USERDATA_MAXLEN","","",N,N],[17,"NFT_REG_VERDICT","","",N,N],[17,"NFT_REG_1","","",N,N],[17,"NFT_REG_2","","",N,N],[17,"NFT_REG_3","","",N,N],[17,"NFT_REG_4","","",N,N],[17,"__NFT_REG_MAX","","",N,N],[17,"NFT_REG32_00","","",N,N],[17,"NFT_REG32_01","","",N,N],[17,"NFT_REG32_02","","",N,N],[17,"NFT_REG32_03","","",N,N],[17,"NFT_REG32_04","","",N,N],[17,"NFT_REG32_05","","",N,N],[17,"NFT_REG32_06","","",N,N],[17,"NFT_REG32_07","","",N,N],[17,"NFT_REG32_08","","",N,N],[17,"NFT_REG32_09","","",N,N],[17,"NFT_REG32_10","","",N,N],[17,"NFT_REG32_11","","",N,N],[17,"NFT_REG32_12","","",N,N],[17,"NFT_REG32_13","","",N,N],[17,"NFT_REG32_14","","",N,N],[17,"NFT_REG32_15","","",N,N],[17,"NFT_REG_SIZE","","",N,N],[17,"NFT_REG32_SIZE","","",N,N],[17,"NFT_CONTINUE","","",N,N],[17,"NFT_BREAK","","",N,N],[17,"NFT_JUMP","","",N,N],[17,"NFT_GOTO","","",N,N],[17,"NFT_RETURN","","",N,N],[17,"NFT_MSG_NEWTABLE","","",N,N],[17,"NFT_MSG_GETTABLE","","",N,N],[17,"NFT_MSG_DELTABLE","","",N,N],[17,"NFT_MSG_NEWCHAIN","","",N,N],[17,"NFT_MSG_GETCHAIN","","",N,N],[17,"NFT_MSG_DELCHAIN","","",N,N],[17,"NFT_MSG_NEWRULE","","",N,N],[17,"NFT_MSG_GETRULE","","",N,N],[17,"NFT_MSG_DELRULE","","",N,N],[17,"NFT_MSG_NEWSET","","",N,N],[17,"NFT_MSG_GETSET","","",N,N],[17,"NFT_MSG_DELSET","","",N,N],[17,"NFT_MSG_NEWSETELEM","","",N,N],[17,"NFT_MSG_GETSETELEM","","",N,N],[17,"NFT_MSG_DELSETELEM","","",N,N],[17,"NFT_MSG_NEWGEN","","",N,N],[17,"NFT_MSG_GETGEN","","",N,N],[17,"NFT_MSG_TRACE","","",N,N],[17,"NFT_MSG_NEWOBJ","","",N,N],[17,"NFT_MSG_GETOBJ","","",N,N],[17,"NFT_MSG_DELOBJ","","",N,N],[17,"NFT_MSG_GETOBJ_RESET","","",N,N],[17,"NFT_MSG_MAX","","",N,N],[17,"NFT_SET_ANONYMOUS","","",N,N],[17,"NFT_SET_CONSTANT","","",N,N],[17,"NFT_SET_INTERVAL","","",N,N],[17,"NFT_SET_MAP","","",N,N],[17,"NFT_SET_TIMEOUT","","",N,N],[17,"NFT_SET_EVAL","","",N,N],[17,"NFT_SET_POL_PERFORMANCE","","",N,N],[17,"NFT_SET_POL_MEMORY","","",N,N],[17,"NFT_SET_ELEM_INTERVAL_END","","",N,N],[17,"NFT_DATA_VALUE","","",N,N],[17,"NFT_DATA_VERDICT","","",N,N],[17,"NFT_DATA_RESERVED_MASK","","",N,N],[17,"NFT_DATA_VALUE_MAXLEN","","",N,N],[17,"NFT_BYTEORDER_NTOH","","",N,N],[17,"NFT_BYTEORDER_HTON","","",N,N],[17,"NFT_CMP_EQ","","",N,N],[17,"NFT_CMP_NEQ","","",N,N],[17,"NFT_CMP_LT","","",N,N],[17,"NFT_CMP_LTE","","",N,N],[17,"NFT_CMP_GT","","",N,N],[17,"NFT_CMP_GTE","","",N,N],[17,"NFT_RANGE_EQ","","",N,N],[17,"NFT_RANGE_NEQ","","",N,N],[17,"NFT_LOOKUP_F_INV","","",N,N],[17,"NFT_DYNSET_OP_ADD","","",N,N],[17,"NFT_DYNSET_OP_UPDATE","","",N,N],[17,"NFT_DYNSET_F_INV","","",N,N],[17,"NFT_PAYLOAD_LL_HEADER","","",N,N],[17,"NFT_PAYLOAD_NETWORK_HEADER","","",N,N],[17,"NFT_PAYLOAD_TRANSPORT_HEADER","","",N,N],[17,"NFT_PAYLOAD_CSUM_NONE","","",N,N],[17,"NFT_PAYLOAD_CSUM_INET","","",N,N],[17,"NFT_META_LEN","","",N,N],[17,"NFT_META_PROTOCOL","","",N,N],[17,"NFT_META_PRIORITY","","",N,N],[17,"NFT_META_MARK","","",N,N],[17,"NFT_META_IIF","","",N,N],[17,"NFT_META_OIF","","",N,N],[17,"NFT_META_IIFNAME","","",N,N],[17,"NFT_META_OIFNAME","","",N,N],[17,"NFT_META_IIFTYPE","","",N,N],[17,"NFT_META_OIFTYPE","","",N,N],[17,"NFT_META_SKUID","","",N,N],[17,"NFT_META_SKGID","","",N,N],[17,"NFT_META_NFTRACE","","",N,N],[17,"NFT_META_RTCLASSID","","",N,N],[17,"NFT_META_SECMARK","","",N,N],[17,"NFT_META_NFPROTO","","",N,N],[17,"NFT_META_L4PROTO","","",N,N],[17,"NFT_META_BRI_IIFNAME","","",N,N],[17,"NFT_META_BRI_OIFNAME","","",N,N],[17,"NFT_META_PKTTYPE","","",N,N],[17,"NFT_META_CPU","","",N,N],[17,"NFT_META_IIFGROUP","","",N,N],[17,"NFT_META_OIFGROUP","","",N,N],[17,"NFT_META_CGROUP","","",N,N],[17,"NFT_META_PRANDOM","","",N,N],[17,"NFT_CT_STATE","","",N,N],[17,"NFT_CT_DIRECTION","","",N,N],[17,"NFT_CT_STATUS","","",N,N],[17,"NFT_CT_MARK","","",N,N],[17,"NFT_CT_SECMARK","","",N,N],[17,"NFT_CT_EXPIRATION","","",N,N],[17,"NFT_CT_HELPER","","",N,N],[17,"NFT_CT_L3PROTOCOL","","",N,N],[17,"NFT_CT_SRC","","",N,N],[17,"NFT_CT_DST","","",N,N],[17,"NFT_CT_PROTOCOL","","",N,N],[17,"NFT_CT_PROTO_SRC","","",N,N],[17,"NFT_CT_PROTO_DST","","",N,N],[17,"NFT_CT_LABELS","","",N,N],[17,"NFT_CT_PKTS","","",N,N],[17,"NFT_CT_BYTES","","",N,N],[17,"NFT_LIMIT_PKTS","","",N,N],[17,"NFT_LIMIT_PKT_BYTES","","",N,N],[17,"NFT_LIMIT_F_INV","","",N,N],[17,"NFT_QUEUE_FLAG_BYPASS","","",N,N],[17,"NFT_QUEUE_FLAG_CPU_FANOUT","","",N,N],[17,"NFT_QUEUE_FLAG_MASK","","",N,N],[17,"NFT_QUOTA_F_INV","","",N,N],[17,"NFT_REJECT_ICMP_UNREACH","","",N,N],[17,"NFT_REJECT_TCP_RST","","",N,N],[17,"NFT_REJECT_ICMPX_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_NO_ROUTE","","",N,N],[17,"NFT_REJECT_ICMPX_PORT_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_HOST_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_ADMIN_PROHIBITED","","",N,N],[17,"NFT_NAT_SNAT","","",N,N],[17,"NFT_NAT_DNAT","","",N,N],[17,"NFT_TRACETYPE_UNSPEC","","",N,N],[17,"NFT_TRACETYPE_POLICY","","",N,N],[17,"NFT_TRACETYPE_RETURN","","",N,N],[17,"NFT_TRACETYPE_RULE","","",N,N],[17,"NFT_NG_INCREMENTAL","","",N,N],[17,"NFT_NG_RANDOM","","",N,N],[17,"AF_MAX","","",N,N],[17,"PF_MAX","","",N,N],[17,"PTHREAD_STACK_MIN","","",N,N],[17,"PTHREAD_MUTEX_ADAPTIVE_NP","","",N,N],[17,"__SIZEOF_PTHREAD_RWLOCKATTR_T","","",N,N],[17,"O_LARGEFILE","","",N,N],[17,"TIOCGSOFTCAR","","",N,N],[17,"TIOCSSOFTCAR","","",N,N],[17,"RLIMIT_NOFILE","","",N,N],[17,"RLIMIT_NPROC","","",N,N],[17,"O_APPEND","","",N,N],[17,"O_CREAT","","",N,N],[17,"O_EXCL","","",N,N],[17,"O_NOCTTY","","",N,N],[17,"O_NONBLOCK","","",N,N],[17,"O_SYNC","","",N,N],[17,"O_RSYNC","","",N,N],[17,"O_DSYNC","","",N,N],[17,"O_FSYNC","","",N,N],[17,"O_NOATIME","","",N,N],[17,"O_PATH","","",N,N],[17,"O_TMPFILE","","",N,N],[17,"MAP_GROWSDOWN","","",N,N],[17,"EDEADLK","","",N,N],[17,"ENAMETOOLONG","","",N,N],[17,"ENOLCK","","",N,N],[17,"ENOSYS","","",N,N],[17,"ENOTEMPTY","","",N,N],[17,"ELOOP","","",N,N],[17,"ENOMSG","","",N,N],[17,"EIDRM","","",N,N],[17,"ECHRNG","","",N,N],[17,"EL2NSYNC","","",N,N],[17,"EL3HLT","","",N,N],[17,"EL3RST","","",N,N],[17,"ELNRNG","","",N,N],[17,"EUNATCH","","",N,N],[17,"ENOCSI","","",N,N],[17,"EL2HLT","","",N,N],[17,"EBADE","","",N,N],[17,"EBADR","","",N,N],[17,"EXFULL","","",N,N],[17,"ENOANO","","",N,N],[17,"EBADRQC","","",N,N],[17,"EBADSLT","","",N,N],[17,"EMULTIHOP","","",N,N],[17,"EOVERFLOW","","",N,N],[17,"ENOTUNIQ","","",N,N],[17,"EBADFD","","",N,N],[17,"EBADMSG","","",N,N],[17,"EREMCHG","","",N,N],[17,"ELIBACC","","",N,N],[17,"ELIBBAD","","",N,N],[17,"ELIBSCN","","",N,N],[17,"ELIBMAX","","",N,N],[17,"ELIBEXEC","","",N,N],[17,"EILSEQ","","",N,N],[17,"ERESTART","","",N,N],[17,"ESTRPIPE","","",N,N],[17,"EUSERS","","",N,N],[17,"ENOTSOCK","","",N,N],[17,"EDESTADDRREQ","","",N,N],[17,"EMSGSIZE","","",N,N],[17,"EPROTOTYPE","","",N,N],[17,"ENOPROTOOPT","","",N,N],[17,"EPROTONOSUPPORT","","",N,N],[17,"ESOCKTNOSUPPORT","","",N,N],[17,"EOPNOTSUPP","","",N,N],[17,"EPFNOSUPPORT","","",N,N],[17,"EAFNOSUPPORT","","",N,N],[17,"EADDRINUSE","","",N,N],[17,"EADDRNOTAVAIL","","",N,N],[17,"ENETDOWN","","",N,N],[17,"ENETUNREACH","","",N,N],[17,"ENETRESET","","",N,N],[17,"ECONNABORTED","","",N,N],[17,"ECONNRESET","","",N,N],[17,"ENOBUFS","","",N,N],[17,"EISCONN","","",N,N],[17,"ENOTCONN","","",N,N],[17,"ESHUTDOWN","","",N,N],[17,"ETOOMANYREFS","","",N,N],[17,"ETIMEDOUT","","",N,N],[17,"ECONNREFUSED","","",N,N],[17,"EHOSTDOWN","","",N,N],[17,"EHOSTUNREACH","","",N,N],[17,"EALREADY","","",N,N],[17,"EINPROGRESS","","",N,N],[17,"ESTALE","","",N,N],[17,"EDQUOT","","",N,N],[17,"ENOMEDIUM","","",N,N],[17,"EMEDIUMTYPE","","",N,N],[17,"ECANCELED","","",N,N],[17,"ENOKEY","","",N,N],[17,"EKEYEXPIRED","","",N,N],[17,"EKEYREVOKED","","",N,N],[17,"EKEYREJECTED","","",N,N],[17,"EOWNERDEAD","","",N,N],[17,"ENOTRECOVERABLE","","",N,N],[17,"EHWPOISON","","",N,N],[17,"ERFKILL","","",N,N],[17,"SOL_SOCKET","","",N,N],[17,"SO_REUSEADDR","","",N,N],[17,"SO_TYPE","","",N,N],[17,"SO_ERROR","","",N,N],[17,"SO_DONTROUTE","","",N,N],[17,"SO_BROADCAST","","",N,N],[17,"SO_SNDBUF","","",N,N],[17,"SO_RCVBUF","","",N,N],[17,"SO_SNDBUFFORCE","","",N,N],[17,"SO_RCVBUFFORCE","","",N,N],[17,"SO_KEEPALIVE","","",N,N],[17,"SO_OOBINLINE","","",N,N],[17,"SO_NO_CHECK","","",N,N],[17,"SO_PRIORITY","","",N,N],[17,"SO_LINGER","","",N,N],[17,"SO_BSDCOMPAT","","",N,N],[17,"SO_REUSEPORT","","",N,N],[17,"SO_PASSCRED","","",N,N],[17,"SO_PEERCRED","","",N,N],[17,"SO_RCVLOWAT","","",N,N],[17,"SO_SNDLOWAT","","",N,N],[17,"SO_RCVTIMEO","","",N,N],[17,"SO_SNDTIMEO","","",N,N],[17,"SO_SECURITY_AUTHENTICATION","","",N,N],[17,"SO_SECURITY_ENCRYPTION_TRANSPORT","","",N,N],[17,"SO_SECURITY_ENCRYPTION_NETWORK","","",N,N],[17,"SO_BINDTODEVICE","","",N,N],[17,"SO_ATTACH_FILTER","","",N,N],[17,"SO_DETACH_FILTER","","",N,N],[17,"SO_GET_FILTER","","",N,N],[17,"SO_PEERNAME","","",N,N],[17,"SO_TIMESTAMP","","",N,N],[17,"SO_ACCEPTCONN","","",N,N],[17,"SO_PEERSEC","","",N,N],[17,"SO_PASSSEC","","",N,N],[17,"SO_TIMESTAMPNS","","",N,N],[17,"SCM_TIMESTAMPNS","","",N,N],[17,"SO_MARK","","",N,N],[17,"SO_TIMESTAMPING","","",N,N],[17,"SCM_TIMESTAMPING","","",N,N],[17,"SO_PROTOCOL","","",N,N],[17,"SO_DOMAIN","","",N,N],[17,"SO_RXQ_OVFL","","",N,N],[17,"SO_WIFI_STATUS","","",N,N],[17,"SCM_WIFI_STATUS","","",N,N],[17,"SO_PEEK_OFF","","",N,N],[17,"SO_NOFCS","","",N,N],[17,"SO_LOCK_FILTER","","",N,N],[17,"SO_SELECT_ERR_QUEUE","","",N,N],[17,"SO_BUSY_POLL","","",N,N],[17,"SO_MAX_PACING_RATE","","",N,N],[17,"SO_BPF_EXTENSIONS","","",N,N],[17,"SO_INCOMING_CPU","","",N,N],[17,"SO_ATTACH_BPF","","",N,N],[17,"SO_DETACH_BPF","","",N,N],[17,"SA_ONSTACK","","",N,N],[17,"SA_SIGINFO","","",N,N],[17,"SA_NOCLDWAIT","","",N,N],[17,"SIGCHLD","","",N,N],[17,"SIGBUS","","",N,N],[17,"SIGUSR1","","",N,N],[17,"SIGUSR2","","",N,N],[17,"SIGCONT","","",N,N],[17,"SIGSTOP","","",N,N],[17,"SIGTSTP","","",N,N],[17,"SIGURG","","",N,N],[17,"SIGIO","","",N,N],[17,"SIGSYS","","",N,N],[17,"SIGSTKFLT","","",N,N],[17,"SIGUNUSED","","",N,N],[17,"SIGPOLL","","",N,N],[17,"SIGPWR","","",N,N],[17,"SIG_SETMASK","","",N,N],[17,"SIG_BLOCK","","",N,N],[17,"SIG_UNBLOCK","","",N,N],[17,"POLLWRNORM","","",N,N],[17,"POLLWRBAND","","",N,N],[17,"O_ASYNC","","",N,N],[17,"O_NDELAY","","",N,N],[17,"PTRACE_DETACH","","",N,N],[17,"EFD_NONBLOCK","","",N,N],[17,"F_GETLK","","",N,N],[17,"F_GETOWN","","",N,N],[17,"F_SETOWN","","",N,N],[17,"F_SETLK","","",N,N],[17,"F_SETLKW","","",N,N],[17,"F_RDLCK","","",N,N],[17,"F_WRLCK","","",N,N],[17,"F_UNLCK","","",N,N],[17,"SFD_NONBLOCK","","",N,N],[17,"TIOCEXCL","","",N,N],[17,"TIOCNXCL","","",N,N],[17,"TIOCSCTTY","","",N,N],[17,"TIOCSTI","","",N,N],[17,"TIOCMGET","","",N,N],[17,"TIOCMBIS","","",N,N],[17,"TIOCMBIC","","",N,N],[17,"TIOCMSET","","",N,N],[17,"TIOCCONS","","",N,N],[17,"SFD_CLOEXEC","","",N,N],[17,"NCCS","","",N,N],[17,"O_TRUNC","","",N,N],[17,"O_CLOEXEC","","",N,N],[17,"EBFONT","","",N,N],[17,"ENOSTR","","",N,N],[17,"ENODATA","","",N,N],[17,"ETIME","","",N,N],[17,"ENOSR","","",N,N],[17,"ENONET","","",N,N],[17,"ENOPKG","","",N,N],[17,"EREMOTE","","",N,N],[17,"ENOLINK","","",N,N],[17,"EADV","","",N,N],[17,"ESRMNT","","",N,N],[17,"ECOMM","","",N,N],[17,"EPROTO","","",N,N],[17,"EDOTDOT","","",N,N],[17,"SA_NODEFER","","",N,N],[17,"SA_RESETHAND","","",N,N],[17,"SA_RESTART","","",N,N],[17,"SA_NOCLDSTOP","","",N,N],[17,"EPOLL_CLOEXEC","","",N,N],[17,"EFD_CLOEXEC","","",N,N],[17,"__SIZEOF_PTHREAD_CONDATTR_T","","",N,N],[17,"__SIZEOF_PTHREAD_MUTEXATTR_T","","",N,N],[17,"O_DIRECT","","",N,N],[17,"O_DIRECTORY","","",N,N],[17,"O_NOFOLLOW","","",N,N],[17,"MAP_LOCKED","","",N,N],[17,"MAP_NORESERVE","","",N,N],[17,"MAP_32BIT","","",N,N],[17,"EDEADLOCK","","",N,N],[17,"FIOCLEX","","",N,N],[17,"FIONBIO","","",N,N],[17,"PTRACE_GETFPREGS","","",N,N],[17,"PTRACE_SETFPREGS","","",N,N],[17,"PTRACE_GETFPXREGS","","",N,N],[17,"PTRACE_SETFPXREGS","","",N,N],[17,"PTRACE_GETREGS","","",N,N],[17,"PTRACE_SETREGS","","",N,N],[17,"PTRACE_PEEKSIGINFO_SHARED","","",N,N],[17,"MCL_CURRENT","","",N,N],[17,"MCL_FUTURE","","",N,N],[17,"SIGSTKSZ","","",N,N],[17,"MINSIGSTKSZ","","",N,N],[17,"CBAUD","","",N,N],[17,"TAB1","","",N,N],[17,"TAB2","","",N,N],[17,"TAB3","","",N,N],[17,"CR1","","",N,N],[17,"CR2","","",N,N],[17,"CR3","","",N,N],[17,"FF1","","",N,N],[17,"BS1","","",N,N],[17,"VT1","","",N,N],[17,"VWERASE","","",N,N],[17,"VREPRINT","","",N,N],[17,"VSUSP","","",N,N],[17,"VSTART","","",N,N],[17,"VSTOP","","",N,N],[17,"VDISCARD","","",N,N],[17,"VTIME","","",N,N],[17,"IXON","","",N,N],[17,"IXOFF","","",N,N],[17,"ONLCR","","",N,N],[17,"CSIZE","","",N,N],[17,"CS6","","",N,N],[17,"CS7","","",N,N],[17,"CS8","","",N,N],[17,"CSTOPB","","",N,N],[17,"CREAD","","",N,N],[17,"PARENB","","",N,N],[17,"PARODD","","",N,N],[17,"HUPCL","","",N,N],[17,"CLOCAL","","",N,N],[17,"ECHOKE","","",N,N],[17,"ECHOE","","",N,N],[17,"ECHOK","","",N,N],[17,"ECHONL","","",N,N],[17,"ECHOPRT","","",N,N],[17,"ECHOCTL","","",N,N],[17,"ISIG","","",N,N],[17,"ICANON","","",N,N],[17,"PENDIN","","",N,N],[17,"NOFLSH","","",N,N],[17,"CIBAUD","","",N,N],[17,"CBAUDEX","","",N,N],[17,"VSWTC","","",N,N],[17,"OLCUC","","",N,N],[17,"NLDLY","","",N,N],[17,"CRDLY","","",N,N],[17,"TABDLY","","",N,N],[17,"BSDLY","","",N,N],[17,"FFDLY","","",N,N],[17,"VTDLY","","",N,N],[17,"XTABS","","",N,N],[17,"B0","","",N,N],[17,"B50","","",N,N],[17,"B75","","",N,N],[17,"B110","","",N,N],[17,"B134","","",N,N],[17,"B150","","",N,N],[17,"B200","","",N,N],[17,"B300","","",N,N],[17,"B600","","",N,N],[17,"B1200","","",N,N],[17,"B1800","","",N,N],[17,"B2400","","",N,N],[17,"B4800","","",N,N],[17,"B9600","","",N,N],[17,"B19200","","",N,N],[17,"B38400","","",N,N],[17,"EXTA","","",N,N],[17,"EXTB","","",N,N],[17,"BOTHER","","",N,N],[17,"B57600","","",N,N],[17,"B115200","","",N,N],[17,"B230400","","",N,N],[17,"B460800","","",N,N],[17,"B500000","","",N,N],[17,"B576000","","",N,N],[17,"B921600","","",N,N],[17,"B1000000","","",N,N],[17,"B1152000","","",N,N],[17,"B1500000","","",N,N],[17,"B2000000","","",N,N],[17,"B2500000","","",N,N],[17,"B3000000","","",N,N],[17,"B3500000","","",N,N],[17,"B4000000","","",N,N],[17,"VEOL","","",N,N],[17,"VEOL2","","",N,N],[17,"VMIN","","",N,N],[17,"IEXTEN","","",N,N],[17,"TOSTOP","","",N,N],[17,"FLUSHO","","",N,N],[17,"EXTPROC","","",N,N],[17,"TCGETS","","",N,N],[17,"TCSETS","","",N,N],[17,"TCSETSW","","",N,N],[17,"TCSETSF","","",N,N],[17,"TCGETA","","",N,N],[17,"TCSETA","","",N,N],[17,"TCSETAW","","",N,N],[17,"TCSETAF","","",N,N],[17,"TCSBRK","","",N,N],[17,"TCXONC","","",N,N],[17,"TCFLSH","","",N,N],[17,"TIOCINQ","","",N,N],[17,"TIOCGPGRP","","",N,N],[17,"TIOCSPGRP","","",N,N],[17,"TIOCOUTQ","","",N,N],[17,"TIOCGWINSZ","","",N,N],[17,"TIOCSWINSZ","","",N,N],[17,"FIONREAD","","",N,N],[17,"R15","","",N,N],[17,"R14","","",N,N],[17,"R13","","",N,N],[17,"R12","","",N,N],[17,"RBP","","",N,N],[17,"RBX","","",N,N],[17,"R11","","",N,N],[17,"R10","","",N,N],[17,"R9","","",N,N],[17,"R8","","",N,N],[17,"RAX","","",N,N],[17,"RCX","","",N,N],[17,"RDX","","",N,N],[17,"RSI","","",N,N],[17,"RDI","","",N,N],[17,"ORIG_RAX","","",N,N],[17,"RIP","","",N,N],[17,"CS","","",N,N],[17,"EFLAGS","","",N,N],[17,"RSP","","",N,N],[17,"SS","","",N,N],[17,"FS_BASE","","",N,N],[17,"GS_BASE","","",N,N],[17,"DS","","",N,N],[17,"ES","","",N,N],[17,"FS","","",N,N],[17,"GS","","",N,N],[17,"__SIZEOF_PTHREAD_MUTEX_T","","",N,N],[17,"__SIZEOF_PTHREAD_RWLOCK_T","","",N,N],[17,"PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP","","",N,N],[17,"PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP","","",N,N],[17,"PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP","","",N,N],[17,"SYS_read","","",N,N],[17,"SYS_write","","",N,N],[17,"SYS_open","","",N,N],[17,"SYS_close","","",N,N],[17,"SYS_stat","","",N,N],[17,"SYS_fstat","","",N,N],[17,"SYS_lstat","","",N,N],[17,"SYS_poll","","",N,N],[17,"SYS_lseek","","",N,N],[17,"SYS_mmap","","",N,N],[17,"SYS_mprotect","","",N,N],[17,"SYS_munmap","","",N,N],[17,"SYS_brk","","",N,N],[17,"SYS_rt_sigaction","","",N,N],[17,"SYS_rt_sigprocmask","","",N,N],[17,"SYS_rt_sigreturn","","",N,N],[17,"SYS_ioctl","","",N,N],[17,"SYS_pread64","","",N,N],[17,"SYS_pwrite64","","",N,N],[17,"SYS_readv","","",N,N],[17,"SYS_writev","","",N,N],[17,"SYS_access","","",N,N],[17,"SYS_pipe","","",N,N],[17,"SYS_select","","",N,N],[17,"SYS_sched_yield","","",N,N],[17,"SYS_mremap","","",N,N],[17,"SYS_msync","","",N,N],[17,"SYS_mincore","","",N,N],[17,"SYS_madvise","","",N,N],[17,"SYS_shmget","","",N,N],[17,"SYS_shmat","","",N,N],[17,"SYS_shmctl","","",N,N],[17,"SYS_dup","","",N,N],[17,"SYS_dup2","","",N,N],[17,"SYS_pause","","",N,N],[17,"SYS_nanosleep","","",N,N],[17,"SYS_getitimer","","",N,N],[17,"SYS_alarm","","",N,N],[17,"SYS_setitimer","","",N,N],[17,"SYS_getpid","","",N,N],[17,"SYS_sendfile","","",N,N],[17,"SYS_socket","","",N,N],[17,"SYS_connect","","",N,N],[17,"SYS_accept","","",N,N],[17,"SYS_sendto","","",N,N],[17,"SYS_recvfrom","","",N,N],[17,"SYS_sendmsg","","",N,N],[17,"SYS_recvmsg","","",N,N],[17,"SYS_shutdown","","",N,N],[17,"SYS_bind","","",N,N],[17,"SYS_listen","","",N,N],[17,"SYS_getsockname","","",N,N],[17,"SYS_getpeername","","",N,N],[17,"SYS_socketpair","","",N,N],[17,"SYS_setsockopt","","",N,N],[17,"SYS_getsockopt","","",N,N],[17,"SYS_clone","","",N,N],[17,"SYS_fork","","",N,N],[17,"SYS_vfork","","",N,N],[17,"SYS_execve","","",N,N],[17,"SYS_exit","","",N,N],[17,"SYS_wait4","","",N,N],[17,"SYS_kill","","",N,N],[17,"SYS_uname","","",N,N],[17,"SYS_semget","","",N,N],[17,"SYS_semop","","",N,N],[17,"SYS_semctl","","",N,N],[17,"SYS_shmdt","","",N,N],[17,"SYS_msgget","","",N,N],[17,"SYS_msgsnd","","",N,N],[17,"SYS_msgrcv","","",N,N],[17,"SYS_msgctl","","",N,N],[17,"SYS_fcntl","","",N,N],[17,"SYS_flock","","",N,N],[17,"SYS_fsync","","",N,N],[17,"SYS_fdatasync","","",N,N],[17,"SYS_truncate","","",N,N],[17,"SYS_ftruncate","","",N,N],[17,"SYS_getdents","","",N,N],[17,"SYS_getcwd","","",N,N],[17,"SYS_chdir","","",N,N],[17,"SYS_fchdir","","",N,N],[17,"SYS_rename","","",N,N],[17,"SYS_mkdir","","",N,N],[17,"SYS_rmdir","","",N,N],[17,"SYS_creat","","",N,N],[17,"SYS_link","","",N,N],[17,"SYS_unlink","","",N,N],[17,"SYS_symlink","","",N,N],[17,"SYS_readlink","","",N,N],[17,"SYS_chmod","","",N,N],[17,"SYS_fchmod","","",N,N],[17,"SYS_chown","","",N,N],[17,"SYS_fchown","","",N,N],[17,"SYS_lchown","","",N,N],[17,"SYS_umask","","",N,N],[17,"SYS_gettimeofday","","",N,N],[17,"SYS_getrlimit","","",N,N],[17,"SYS_getrusage","","",N,N],[17,"SYS_sysinfo","","",N,N],[17,"SYS_times","","",N,N],[17,"SYS_ptrace","","",N,N],[17,"SYS_getuid","","",N,N],[17,"SYS_syslog","","",N,N],[17,"SYS_getgid","","",N,N],[17,"SYS_setuid","","",N,N],[17,"SYS_setgid","","",N,N],[17,"SYS_geteuid","","",N,N],[17,"SYS_getegid","","",N,N],[17,"SYS_setpgid","","",N,N],[17,"SYS_getppid","","",N,N],[17,"SYS_getpgrp","","",N,N],[17,"SYS_setsid","","",N,N],[17,"SYS_setreuid","","",N,N],[17,"SYS_setregid","","",N,N],[17,"SYS_getgroups","","",N,N],[17,"SYS_setgroups","","",N,N],[17,"SYS_setresuid","","",N,N],[17,"SYS_getresuid","","",N,N],[17,"SYS_setresgid","","",N,N],[17,"SYS_getresgid","","",N,N],[17,"SYS_getpgid","","",N,N],[17,"SYS_setfsuid","","",N,N],[17,"SYS_setfsgid","","",N,N],[17,"SYS_getsid","","",N,N],[17,"SYS_capget","","",N,N],[17,"SYS_capset","","",N,N],[17,"SYS_rt_sigpending","","",N,N],[17,"SYS_rt_sigtimedwait","","",N,N],[17,"SYS_rt_sigqueueinfo","","",N,N],[17,"SYS_rt_sigsuspend","","",N,N],[17,"SYS_sigaltstack","","",N,N],[17,"SYS_utime","","",N,N],[17,"SYS_mknod","","",N,N],[17,"SYS_uselib","","",N,N],[17,"SYS_personality","","",N,N],[17,"SYS_ustat","","",N,N],[17,"SYS_statfs","","",N,N],[17,"SYS_fstatfs","","",N,N],[17,"SYS_sysfs","","",N,N],[17,"SYS_getpriority","","",N,N],[17,"SYS_setpriority","","",N,N],[17,"SYS_sched_setparam","","",N,N],[17,"SYS_sched_getparam","","",N,N],[17,"SYS_sched_setscheduler","","",N,N],[17,"SYS_sched_getscheduler","","",N,N],[17,"SYS_sched_get_priority_max","","",N,N],[17,"SYS_sched_get_priority_min","","",N,N],[17,"SYS_sched_rr_get_interval","","",N,N],[17,"SYS_mlock","","",N,N],[17,"SYS_munlock","","",N,N],[17,"SYS_mlockall","","",N,N],[17,"SYS_munlockall","","",N,N],[17,"SYS_vhangup","","",N,N],[17,"SYS_modify_ldt","","",N,N],[17,"SYS_pivot_root","","",N,N],[17,"SYS__sysctl","","",N,N],[17,"SYS_prctl","","",N,N],[17,"SYS_arch_prctl","","",N,N],[17,"SYS_adjtimex","","",N,N],[17,"SYS_setrlimit","","",N,N],[17,"SYS_chroot","","",N,N],[17,"SYS_sync","","",N,N],[17,"SYS_acct","","",N,N],[17,"SYS_settimeofday","","",N,N],[17,"SYS_mount","","",N,N],[17,"SYS_umount2","","",N,N],[17,"SYS_swapon","","",N,N],[17,"SYS_swapoff","","",N,N],[17,"SYS_reboot","","",N,N],[17,"SYS_sethostname","","",N,N],[17,"SYS_setdomainname","","",N,N],[17,"SYS_iopl","","",N,N],[17,"SYS_ioperm","","",N,N],[17,"SYS_create_module","","",N,N],[17,"SYS_init_module","","",N,N],[17,"SYS_delete_module","","",N,N],[17,"SYS_get_kernel_syms","","",N,N],[17,"SYS_query_module","","",N,N],[17,"SYS_quotactl","","",N,N],[17,"SYS_nfsservctl","","",N,N],[17,"SYS_getpmsg","","",N,N],[17,"SYS_putpmsg","","",N,N],[17,"SYS_afs_syscall","","",N,N],[17,"SYS_tuxcall","","",N,N],[17,"SYS_security","","",N,N],[17,"SYS_gettid","","",N,N],[17,"SYS_readahead","","",N,N],[17,"SYS_setxattr","","",N,N],[17,"SYS_lsetxattr","","",N,N],[17,"SYS_fsetxattr","","",N,N],[17,"SYS_getxattr","","",N,N],[17,"SYS_lgetxattr","","",N,N],[17,"SYS_fgetxattr","","",N,N],[17,"SYS_listxattr","","",N,N],[17,"SYS_llistxattr","","",N,N],[17,"SYS_flistxattr","","",N,N],[17,"SYS_removexattr","","",N,N],[17,"SYS_lremovexattr","","",N,N],[17,"SYS_fremovexattr","","",N,N],[17,"SYS_tkill","","",N,N],[17,"SYS_time","","",N,N],[17,"SYS_futex","","",N,N],[17,"SYS_sched_setaffinity","","",N,N],[17,"SYS_sched_getaffinity","","",N,N],[17,"SYS_set_thread_area","","",N,N],[17,"SYS_io_setup","","",N,N],[17,"SYS_io_destroy","","",N,N],[17,"SYS_io_getevents","","",N,N],[17,"SYS_io_submit","","",N,N],[17,"SYS_io_cancel","","",N,N],[17,"SYS_get_thread_area","","",N,N],[17,"SYS_lookup_dcookie","","",N,N],[17,"SYS_epoll_create","","",N,N],[17,"SYS_epoll_ctl_old","","",N,N],[17,"SYS_epoll_wait_old","","",N,N],[17,"SYS_remap_file_pages","","",N,N],[17,"SYS_getdents64","","",N,N],[17,"SYS_set_tid_address","","",N,N],[17,"SYS_restart_syscall","","",N,N],[17,"SYS_semtimedop","","",N,N],[17,"SYS_fadvise64","","",N,N],[17,"SYS_timer_create","","",N,N],[17,"SYS_timer_settime","","",N,N],[17,"SYS_timer_gettime","","",N,N],[17,"SYS_timer_getoverrun","","",N,N],[17,"SYS_timer_delete","","",N,N],[17,"SYS_clock_settime","","",N,N],[17,"SYS_clock_gettime","","",N,N],[17,"SYS_clock_getres","","",N,N],[17,"SYS_clock_nanosleep","","",N,N],[17,"SYS_exit_group","","",N,N],[17,"SYS_epoll_wait","","",N,N],[17,"SYS_epoll_ctl","","",N,N],[17,"SYS_tgkill","","",N,N],[17,"SYS_utimes","","",N,N],[17,"SYS_vserver","","",N,N],[17,"SYS_mbind","","",N,N],[17,"SYS_set_mempolicy","","",N,N],[17,"SYS_get_mempolicy","","",N,N],[17,"SYS_mq_open","","",N,N],[17,"SYS_mq_unlink","","",N,N],[17,"SYS_mq_timedsend","","",N,N],[17,"SYS_mq_timedreceive","","",N,N],[17,"SYS_mq_notify","","",N,N],[17,"SYS_mq_getsetattr","","",N,N],[17,"SYS_kexec_load","","",N,N],[17,"SYS_waitid","","",N,N],[17,"SYS_add_key","","",N,N],[17,"SYS_request_key","","",N,N],[17,"SYS_keyctl","","",N,N],[17,"SYS_ioprio_set","","",N,N],[17,"SYS_ioprio_get","","",N,N],[17,"SYS_inotify_init","","",N,N],[17,"SYS_inotify_add_watch","","",N,N],[17,"SYS_inotify_rm_watch","","",N,N],[17,"SYS_migrate_pages","","",N,N],[17,"SYS_openat","","",N,N],[17,"SYS_mkdirat","","",N,N],[17,"SYS_mknodat","","",N,N],[17,"SYS_fchownat","","",N,N],[17,"SYS_futimesat","","",N,N],[17,"SYS_newfstatat","","",N,N],[17,"SYS_unlinkat","","",N,N],[17,"SYS_renameat","","",N,N],[17,"SYS_linkat","","",N,N],[17,"SYS_symlinkat","","",N,N],[17,"SYS_readlinkat","","",N,N],[17,"SYS_fchmodat","","",N,N],[17,"SYS_faccessat","","",N,N],[17,"SYS_pselect6","","",N,N],[17,"SYS_ppoll","","",N,N],[17,"SYS_unshare","","",N,N],[17,"SYS_set_robust_list","","",N,N],[17,"SYS_get_robust_list","","",N,N],[17,"SYS_splice","","",N,N],[17,"SYS_tee","","",N,N],[17,"SYS_sync_file_range","","",N,N],[17,"SYS_vmsplice","","",N,N],[17,"SYS_move_pages","","",N,N],[17,"SYS_utimensat","","",N,N],[17,"SYS_epoll_pwait","","",N,N],[17,"SYS_signalfd","","",N,N],[17,"SYS_timerfd_create","","",N,N],[17,"SYS_eventfd","","",N,N],[17,"SYS_fallocate","","",N,N],[17,"SYS_timerfd_settime","","",N,N],[17,"SYS_timerfd_gettime","","",N,N],[17,"SYS_accept4","","",N,N],[17,"SYS_signalfd4","","",N,N],[17,"SYS_eventfd2","","",N,N],[17,"SYS_epoll_create1","","",N,N],[17,"SYS_dup3","","",N,N],[17,"SYS_pipe2","","",N,N],[17,"SYS_inotify_init1","","",N,N],[17,"SYS_preadv","","",N,N],[17,"SYS_pwritev","","",N,N],[17,"SYS_rt_tgsigqueueinfo","","",N,N],[17,"SYS_perf_event_open","","",N,N],[17,"SYS_recvmmsg","","",N,N],[17,"SYS_fanotify_init","","",N,N],[17,"SYS_fanotify_mark","","",N,N],[17,"SYS_prlimit64","","",N,N],[17,"SYS_name_to_handle_at","","",N,N],[17,"SYS_open_by_handle_at","","",N,N],[17,"SYS_clock_adjtime","","",N,N],[17,"SYS_syncfs","","",N,N],[17,"SYS_sendmmsg","","",N,N],[17,"SYS_setns","","",N,N],[17,"SYS_getcpu","","",N,N],[17,"SYS_process_vm_readv","","",N,N],[17,"SYS_process_vm_writev","","",N,N],[17,"SYS_kcmp","","",N,N],[17,"SYS_finit_module","","",N,N],[17,"SYS_sched_setattr","","",N,N],[17,"SYS_sched_getattr","","",N,N],[17,"SYS_renameat2","","",N,N],[17,"SYS_seccomp","","",N,N],[17,"SYS_getrandom","","",N,N],[17,"SYS_memfd_create","","",N,N],[17,"SYS_kexec_file_load","","",N,N],[17,"SYS_bpf","","",N,N],[17,"SYS_execveat","","",N,N],[17,"SYS_userfaultfd","","",N,N],[17,"SYS_membarrier","","",N,N],[17,"SYS_mlock2","","",N,N],[17,"SYS_copy_file_range","","",N,N],[17,"SYS_preadv2","","",N,N],[17,"SYS_pwritev2","","",N,N],[17,"SYS_pkey_mprotect","","",N,N],[17,"SYS_pkey_alloc","","",N,N],[17,"SYS_pkey_free","","",N,N],[11,"is_some","libc::dox::imp","Returns `true` if the option is a [`Some`] value.",127,[[["self"]],["bool"]]],[11,"is_none","","Returns `true` if the option is a [`None`] value.",127,[[["self"]],["bool"]]],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`.",127,[[["self"]],["option"]]],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`.",127,[[["self"]],["option"]]],[11,"as_pin_mut","","Converts from `Option<T>` to `Option<PinMut<'_, T>>`",127,[[["pinmut",["option"]]],["option",["pinmut"]]]],[11,"expect","","Unwraps an option, yielding the content of a [`Some`].",127,[[["self"],["str"]],["t"]]],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is [`Some(v)`].",127,[[["self"]],["t"]]],[11,"unwrap_or","","Returns the contained value or a default.",127,[[["self"],["t"]],["t"]]],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",127,[[["self"],["f"]],["t"]]],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value.",127,[[["self"],["f"]],["option"]]],[11,"map_or","","Applies a function to the contained value (if any), or returns the provided default (if not).",127,[[["self"],["u"],["f"]],["u"]]],[11,"map_or_else","","Applies a function to the contained value (if any), or computes a default (if not).",127,[[["self"],["d"],["f"]],["u"]]],[11,"ok_or","","Transforms the `Option<T>` into a [`Result<T, E>`], mapping [`Some(v)`] to [`Ok(v)`] and [`None`] to [`Err(err)`].",127,[[["self"],["e"]],["result"]]],[11,"ok_or_else","","Transforms the `Option<T>` into a [`Result<T, E>`], mapping [`Some(v)`] to [`Ok(v)`] and [`None`] to [`Err(err())`].",127,[[["self"],["f"]],["result"]]],[11,"iter","","Returns an iterator over the possibly contained value.",127,[[["self"]],["iter"]]],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",127,[[["self"]],["itermut"]]],[11,"and","","Returns [`None`] if the option is [`None`], otherwise returns `optb`.",127,[[["self"],["option"]],["option"]]],[11,"and_then","","Returns [`None`] if the option is [`None`], otherwise calls `f` with the wrapped value and returns the result.",127,[[["self"],["f"]],["option"]]],[11,"filter","","Returns `None` if the option is `None`, otherwise calls `predicate` with the wrapped value and returns:",127,[[["self"],["p"]],["option"]]],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",127,[[["self"],["option"]],["option"]]],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and returns the result.",127,[[["self"],["f"]],["option"]]],[11,"xor","","Returns [`Some`] if exactly one of `self`, `optb` is [`Some`], otherwise returns `None`.",127,[[["self"],["option"]],["option"]]],[11,"get_or_insert","","Inserts `v` into the option if it is [`None`], then returns a mutable reference to the contained value.",127,[[["self"],["t"]],["t"]]],[11,"get_or_insert_with","","Inserts a value computed from `f` into the option if it is [`None`], then returns a mutable reference to the contained value.",127,[[["self"],["f"]],["t"]]],[11,"take","","Takes the value out of the option, leaving a [`None`] in its place.",127,[[["self"]],["option"]]],[11,"replace","","Replaces the actual value in the option by the value given in parameter, returning the old value if present, leaving a [`Some`] in its place without deinitializing either one.",127,[[["self"],["t"]],["option"]]],[11,"cloned","","Maps an `Option<&T>` to an `Option<T>` by cloning the contents of the option.",127,[[["self"]],["option"]]],[11,"cloned","","Maps an `Option<&mut T>` to an `Option<T>` by cloning the contents of the option.",127,[[["self"]],["option"]]],[11,"unwrap_or_default","","Returns the contained value or a default",127,[[["self"]],["t"]]],[11,"transpose","","Transposes an `Option` of a `Result` into a `Result` of an `Option`.",127,[[["self"]],["result",["option"]]]],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",127,[[["self"]],["intoiter"]]],[11,"hash","libc::dox::imp::mem","",129,N],[11,"hash","","",130,N],[11,"hash","libc::dox::imp","",127,N],[11,"from","","",127,[[["t"]],["option"]]],[11,"fmt","libc::dox::imp::mem","",131,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","libc::dox::imp","",127,[[["self"]],["option"]]],[11,"clone","libc::dox::imp::mem","",130,[[["self"]],["manuallydrop"]]],[11,"clone","","",129,[[["self"]],["discriminant"]]],[11,"fmt","","",129,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","libc::dox::imp","",127,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","libc::dox::imp::mem","",130,[[["self"],["formatter"]],["result",["error"]]]],[11,"partial_cmp","libc::dox::imp","",127,[[["self"],["option"]],["option",["ordering"]]]],[11,"lt","","",127,[[["self"],["option"]],["bool"]]],[11,"le","","",127,[[["self"],["option"]],["bool"]]],[11,"gt","","",127,[[["self"],["option"]],["bool"]]],[11,"ge","","",127,[[["self"],["option"]],["bool"]]],[11,"partial_cmp","libc::dox::imp::mem","",130,[[["self"],["manuallydrop"]],["option",["ordering"]]]],[11,"lt","","",130,[[["self"],["manuallydrop"]],["bool"]]],[11,"le","","",130,[[["self"],["manuallydrop"]],["bool"]]],[11,"gt","","",130,[[["self"],["manuallydrop"]],["bool"]]],[11,"ge","","",130,[[["self"],["manuallydrop"]],["bool"]]],[11,"cmp","","",130,[[["self"],["manuallydrop"]],["ordering"]]],[11,"cmp","libc::dox::imp","",127,[[["self"],["option"]],["ordering"]]],[11,"from_iter","","Takes each element in the [`Iterator`]: if it is [`None`], no further elements are taken, and the [`None`] is returned. Should no [`None`] occur, a container with the values of each `Option` is returned.",127,[[["i"]],["option"]]],[11,"assert_receiver_is_total_eq","","",127,N],[11,"assert_receiver_is_total_eq","libc::dox::imp::mem","",130,N],[11,"eq","","",129,[[["self"],["discriminant"]],["bool"]]],[11,"eq","libc::dox::imp","",127,[[["self"],["option"]],["bool"]]],[11,"ne","","",127,[[["self"],["option"]],["bool"]]],[11,"eq","libc::dox::imp::mem","",130,[[["self"],["manuallydrop"]],["bool"]]],[11,"ne","","",130,[[["self"],["manuallydrop"]],["bool"]]],[11,"into_raw","","",131,N],[11,"poll","","",131,N],[11,"drop","","",131,N],[11,"poll","","",131,[[["pinmut",["pinmut"]],["context"]],["poll"]]],[11,"into_result","libc::dox::imp","",127,[[["self"]],["result",["noneerror"]]]],[11,"from_ok","","",127,[[["t"]],["option"]]],[11,"from_error","","",127,[[["noneerror"]],["option"]]],[11,"deref_mut","libc::dox::imp::mem","",131,[[["self"]],["t"]]],[11,"deref_mut","","",130,N],[11,"default","","",130,[[],["manuallydrop"]]],[11,"default","libc::dox::imp","Returns [`None`].",127,[[],["option"]]],[11,"deref","libc::dox::imp::mem","",130,N],[11,"deref","","",131,[[["self"]],["t"]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result",["error"]]]],[11,"new","","Wrap a value to be manually dropped.",130,[[["t"]],["manuallydrop"]]],[11,"into_inner","","Extract the value from the ManuallyDrop container.",130,[[["manuallydrop"]],["t"]]],[11,"drop","","Manually drops the contained value.",130,N],[11,"new","","Construct a new `PinMut` around a reference to some data of a type that implements `Unpin`.",131,[[["t"]],["pinmut"]]],[11,"get_mut","","Get a mutable reference to the data inside of this `PinMut`.",131,[[["pinmut"]],["t"]]],[11,"new_unchecked","","Construct a new `PinMut` around a reference to some data of a type that may or may not implement `Unpin`.",131,[[["t"]],["pinmut"]]],[11,"reborrow","","Reborrow a `PinMut` for a shorter lifetime.",131,[[["self"]],["pinmut"]]],[11,"get_mut_unchecked","","Get a mutable reference to the data inside of this `PinMut`.",131,[[["pinmut"]],["t"]]],[11,"map_unchecked","","Construct a new pin by mapping the interior value.",131,[[["pinmut"],["f"]],["pinmut"]]],[11,"set","","Assign a new value to the memory behind the pinned reference.",131,N]],"paths":[[3,"group"],[3,"utimbuf"],[3,"timeval"],[3,"timespec"],[3,"rlimit"],[3,"rusage"],[3,"in_addr"],[3,"in6_addr"],[3,"ip_mreq"],[3,"ipv6_mreq"],[3,"hostent"],[3,"iovec"],[3,"pollfd"],[3,"winsize"],[3,"linger"],[3,"sigval"],[3,"itimerval"],[3,"tms"],[3,"servent"],[3,"protoent"],[3,"sockaddr"],[3,"sockaddr_in"],[3,"sockaddr_in6"],[3,"sockaddr_un"],[3,"sockaddr_storage"],[3,"addrinfo"],[3,"sockaddr_nl"],[3,"sockaddr_ll"],[3,"fd_set"],[3,"tm"],[3,"sched_param"],[3,"Dl_info"],[3,"epoll_event"],[3,"utsname"],[3,"lconv"],[3,"sigevent"],[3,"in_pktinfo"],[3,"ifaddrs"],[3,"in6_rtmsg"],[3,"dirent"],[3,"dirent64"],[3,"rlimit64"],[3,"glob_t"],[3,"pthread_mutex_t"],[3,"pthread_rwlock_t"],[3,"pthread_mutexattr_t"],[3,"pthread_rwlockattr_t"],[3,"pthread_cond_t"],[3,"pthread_condattr_t"],[3,"passwd"],[3,"spwd"],[3,"dqblk"],[3,"signalfd_siginfo"],[3,"itimerspec"],[3,"fsid_t"],[3,"mq_attr"],[3,"cpu_set_t"],[3,"if_nameindex"],[3,"msginfo"],[3,"mmsghdr"],[3,"sembuf"],[3,"input_event"],[3,"input_id"],[3,"input_absinfo"],[3,"input_keymap_entry"],[3,"input_mask"],[3,"ff_replay"],[3,"ff_trigger"],[3,"ff_envelope"],[3,"ff_constant_effect"],[3,"ff_ramp_effect"],[3,"ff_condition_effect"],[3,"ff_periodic_effect"],[3,"ff_rumble_effect"],[3,"ff_effect"],[3,"dl_phdr_info"],[3,"Elf32_Phdr"],[3,"Elf64_Phdr"],[3,"ucred"],[3,"mntent"],[3,"posix_spawn_file_actions_t"],[3,"posix_spawnattr_t"],[3,"genlmsghdr"],[3,"in6_pktinfo"],[3,"aiocb"],[3,"__exit_status"],[3,"__timeval"],[3,"utmpx"],[3,"sigaction"],[3,"stack_t"],[3,"siginfo_t"],[3,"glob64_t"],[3,"statfs"],[3,"msghdr"],[3,"cmsghdr"],[3,"termios"],[3,"flock"],[3,"sem_t"],[3,"mallinfo"],[3,"nlmsghdr"],[3,"nlmsgerr"],[3,"nl_pktinfo"],[3,"nl_mmap_req"],[3,"nl_mmap_hdr"],[3,"nlattr"],[3,"rtentry"],[3,"sigset_t"],[3,"sysinfo"],[3,"msqid_ds"],[3,"stat"],[3,"stat64"],[3,"statfs64"],[3,"statvfs64"],[3,"pthread_attr_t"],[3,"_libc_fpxreg"],[3,"_libc_xmmreg"],[3,"_libc_fpstate"],[3,"user_fpregs_struct"],[3,"user_regs_struct"],[3,"user"],[3,"mcontext_t"],[3,"ucontext_t"],[3,"ipc_perm"],[3,"shmid_ds"],[3,"termios2"],[3,"statvfs"],[4,"c_void"],[4,"Option"],[8,"Clone"],[3,"Discriminant"],[3,"ManuallyDrop"],[3,"PinMut"]]};
searchIndex["memchr"]={"doc":"This crate defines two functions, `memchr` and `memrchr`, which expose a safe interface to the corresponding functions in `libc`.","items":[[3,"Memchr","memchr","An iterator for memchr",N,N],[12,"needle","","",0,N],[12,"haystack","","",0,N],[12,"position","","",0,N],[3,"Memchr2","","An iterator for Memchr2",N,N],[12,"needle1","","",1,N],[12,"needle2","","",1,N],[12,"haystack","","",1,N],[12,"position","","",1,N],[3,"Memchr3","","An iterator for Memchr3",N,N],[12,"needle1","","",2,N],[12,"needle2","","",2,N],[12,"needle3","","",2,N],[12,"haystack","","",2,N],[12,"position","","",2,N],[5,"contains_zero_byte","","Return `true` if `x` contains any zero byte.",N,[[["usize"]],["bool"]]],[5,"repeat_byte","","",N,[[["u8"]],["usize"]]],[5,"memchr","","A safe interface to `memchr`.",N,N],[5,"memrchr","","A safe interface to `memrchr`.",N,N],[5,"memchr2","","Like `memchr`, but searches for two bytes instead of one.",N,N],[5,"memchr3","","Like `memchr`, but searches for three bytes instead of one.",N,N],[17,"LO_U64","","",N,N],[17,"HI_U64","","",N,N],[17,"LO_USIZE","","",N,N],[17,"HI_USIZE","","",N,N],[17,"USIZE_BYTES","","",N,N],[11,"new","","Creates a new iterator that yields all positions of needle in haystack.",0,N],[11,"next","","",0,[[["self"]],["option",["usize"]]]],[11,"size_hint","","",0,N],[11,"next_back","","",0,[[["self"]],["option"]]],[11,"new","","Creates a new iterator that yields all positions of needle in haystack.",1,N],[11,"next","","",1,[[["self"]],["option",["usize"]]]],[11,"size_hint","","",1,N],[11,"new","","Create a new Memchr2 that's initalized to zero with a haystack",2,N],[11,"next","","",2,[[["self"]],["option",["usize"]]]],[11,"size_hint","","",2,N]],"paths":[[3,"Memchr"],[3,"Memchr2"],[3,"Memchr3"]]};
searchIndex["minifier"]={"doc":"","items":[[0,"html","minifier","",N,N],[5,"condense_whitespace","minifier::html","",N,[[["str"]],["string"]]],[5,"condense","","",N,[[["str"]],["string"]]],[5,"clean_unneeded_tags","","",N,[[["str"]],["string"]]],[5,"remove_comments","","",N,[[["str"]],["string"]]],[5,"unquote_attributes","","",N,[[["str"]],["string"]]],[5,"minify","","Returns a minified version of the provided HTML source.",N,[[["str"]],["string"]]],[0,"js","minifier","",N,N],[4,"Keyword","minifier::js","",N,N],[13,"Break","","",0,N],[13,"Case","","",0,N],[13,"Catch","","",0,N],[13,"Const","","",0,N],[13,"Continue","","",0,N],[13,"Default","","",0,N],[13,"Do","","",0,N],[13,"Else","","",0,N],[13,"False","","",0,N],[13,"Finally","","",0,N],[13,"Function","","",0,N],[13,"For","","",0,N],[13,"If","","",0,N],[13,"In","","",0,N],[13,"InstanceOf","","",0,N],[13,"New","","",0,N],[13,"Null","","",0,N],[13,"Private","","",0,N],[13,"Protected","","",0,N],[13,"Public","","",0,N],[13,"Return","","",0,N],[13,"Switch","","",0,N],[13,"This","","",0,N],[13,"Throw","","",0,N],[13,"True","","",0,N],[13,"Try","","",0,N],[13,"Typeof","","",0,N],[13,"Static","","",0,N],[13,"Var","","",0,N],[13,"While","","",0,N],[5,"minify","","",N,[[["str"]],["string"]]],[5,"minify_and_replace_keywords","","",N,N],[0,"token","","",N,N],[3,"Tokens","minifier::js::token","",N,N],[12,"0","","",1,N],[4,"ReservedChar","","",N,N],[13,"Comma","","",2,N],[13,"OpenParenthese","","",2,N],[13,"CloseParenthese","","",2,N],[13,"OpenCurlyBrace","","",2,N],[13,"CloseCurlyBrace","","",2,N],[13,"OpenBracket","","",2,N],[13,"CloseBracket","","",2,N],[13,"Colon","","",2,N],[13,"SemiColon","","",2,N],[13,"Dot","","",2,N],[13,"Quote","","",2,N],[13,"DoubleQuote","","",2,N],[13,"ExclamationMark","","",2,N],[13,"QuestionMark","","",2,N],[13,"Slash","","",2,N],[13,"Modulo","","",2,N],[13,"Star","","",2,N],[13,"Minus","","",2,N],[13,"Plus","","",2,N],[13,"EqualSign","","",2,N],[13,"Backslash","","",2,N],[13,"Space","","",2,N],[13,"Tab","","",2,N],[13,"Backline","","",2,N],[13,"LessThan","","",2,N],[13,"SuperiorThan","","",2,N],[13,"Pipe","","",2,N],[13,"Ampersand","","",2,N],[4,"Keyword","","",N,N],[13,"Break","","",0,N],[13,"Case","","",0,N],[13,"Catch","","",0,N],[13,"Const","","",0,N],[13,"Continue","","",0,N],[13,"Default","","",0,N],[13,"Do","","",0,N],[13,"Else","","",0,N],[13,"False","","",0,N],[13,"Finally","","",0,N],[13,"Function","","",0,N],[13,"For","","",0,N],[13,"If","","",0,N],[13,"In","","",0,N],[13,"InstanceOf","","",0,N],[13,"New","","",0,N],[13,"Null","","",0,N],[13,"Private","","",0,N],[13,"Protected","","",0,N],[13,"Public","","",0,N],[13,"Return","","",0,N],[13,"Switch","","",0,N],[13,"This","","",0,N],[13,"Throw","","",0,N],[13,"True","","",0,N],[13,"Try","","",0,N],[13,"Typeof","","",0,N],[13,"Static","","",0,N],[13,"Var","","",0,N],[13,"While","","",0,N],[4,"Condition","","",N,N],[13,"And","","",3,N],[13,"Or","","",3,N],[13,"DifferentThan","","",3,N],[13,"SuperDifferentThan","","",3,N],[13,"EqualTo","","",3,N],[13,"SuperEqualTo","","",3,N],[13,"SuperiorThan","","",3,N],[13,"SuperiorOrEqualTo","","",3,N],[13,"InferiorThan","","",3,N],[13,"InferiorOrEqualTo","","",3,N],[4,"Operation","","",N,N],[13,"Addition","","",4,N],[13,"AdditionEqual","","",4,N],[13,"Subtract","","",4,N],[13,"SubtractEqual","","",4,N],[13,"Multiply","","",4,N],[13,"MultiplyEqual","","",4,N],[13,"Divide","","",4,N],[13,"DivideEqual","","",4,N],[13,"Modulo","","",4,N],[13,"ModuloEqual","","",4,N],[13,"Equal","","",4,N],[4,"Token","","",N,N],[13,"Keyword","","",5,N],[13,"Char","","",5,N],[13,"String","","",5,N],[13,"Comment","","",5,N],[13,"License","","",5,N],[13,"Other","","",5,N],[13,"Regex","","",5,N],[12,"regex","minifier::js::token::Token","",5,N],[12,"is_global","","",5,N],[12,"is_interactive","","",5,N],[13,"Condition","minifier::js::token","",5,N],[13,"Operation","","",5,N],[5,"get_required","","",N,[[["token"]],["option",["char"]]]],[5,"get_line_comment","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_regex","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_comment","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_string","","",N,[[["str"],["peekable"],["usize"],["reservedchar"]],["option",["token"]]]],[5,"first_useful","","",N,N],[5,"fill_other","","",N,[[["str"],["vec"],["usize"],["usize"]]]],[5,"tokenize","","",N,[[["str"]],["tokens"]]],[5,"clean_tokens","","",N,[[["tokens"]]]],[8,"MyTryFrom","","",N,N],[16,"Error","","",6,N],[10,"try_from","","",6,[[["t"]],["result"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"eq","","",2,[[["self"],["reservedchar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"clone","","",2,[[["self"]],["reservedchar"]]],[11,"is_useless","","",2,[[["self"]],["bool"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",2,[[["char"]],["result",["reservedchar"]]]],[11,"fmt","minifier::js","",0,[[["self"],["formatter"]],["result"]]],[11,"eq","","",0,[[["self"],["keyword"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"clone","","",0,[[["self"]],["keyword"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",0,[[["str"]],["result",["keyword"]]]],[11,"fmt","minifier::js::token","",3,[[["self"],["formatter"]],["result"]]],[11,"eq","","",3,[[["self"],["condition"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"clone","","",3,[[["self"]],["condition"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",3,[[["reservedchar"]],["result",["condition"]]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["operation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"clone","","",4,[[["self"]],["operation"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",4,[[["reservedchar"]],["result",["operation"]]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"eq","","",5,[[["self"],["token"]],["bool"]]],[11,"ne","","",5,[[["self"],["token"]],["bool"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"is_comment","","",5,[[["self"]],["bool"]]],[11,"get_char","","",5,[[["self"]],["option",["reservedchar"]]]],[11,"is_char","","",5,[[["self"],["reservedchar"]],["bool"]]],[11,"is_operation","","",5,[[["self"],["operation"]],["bool"]]],[11,"is_condition","","",5,[[["self"],["condition"]],["bool"]]],[11,"is_other","","",5,[[["self"]],["bool"]]],[11,"is_white_character","","",5,[[["self"]],["bool"]]],[11,"get_keyword","","",5,[[["self"]],["option",["keyword"]]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1,[[["self"],["tokens"]],["bool"]]],[11,"ne","","",1,[[["self"],["tokens"]],["bool"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[0,"js","minifier::js","",N,N],[5,"minify","minifier::js::js","",N,[[["str"]],["string"]]],[5,"minify_and_replace_keywords","","",N,N],[0,"css","minifier","",N,N],[5,"minify","minifier::css","",N,[[["str"]],["result",["string","str"]]]],[0,"token","","",N,N],[3,"Tokens","minifier::css::token","",N,N],[12,"0","","",7,N],[4,"ReservedChar","","",N,N],[13,"Comma","","",8,N],[13,"SuperiorThan","","",8,N],[13,"OpenParenthese","","",8,N],[13,"CloseParenthese","","",8,N],[13,"OpenCurlyBrace","","",8,N],[13,"CloseCurlyBrace","","",8,N],[13,"OpenBracket","","",8,N],[13,"CloseBracket","","",8,N],[13,"Colon","","",8,N],[13,"SemiColon","","",8,N],[13,"Slash","","",8,N],[13,"Plus","","",8,N],[13,"EqualSign","","",8,N],[13,"Space","","",8,N],[13,"Tab","","",8,N],[13,"Backline","","",8,N],[13,"Star","","",8,N],[13,"Quote","","",8,N],[13,"DoubleQuote","","",8,N],[13,"Pipe","","",8,N],[13,"Tilde","","",8,N],[13,"Dollar","","",8,N],[13,"Circumflex","","",8,N],[4,"SelectorElement","","",N,N],[13,"PseudoClass","","",9,N],[13,"Class","","",9,N],[13,"Id","","",9,N],[13,"Tag","","",9,N],[13,"Media","","",9,N],[4,"SelectorOperator","","",N,N],[13,"OneAttributeEquals","","`~=`",10,N],[13,"EqualsOrStartsWithFollowedByDash","","`|=`",10,N],[13,"EndsWith","","`$=`",10,N],[13,"FirstStartsWith","","`^=`",10,N],[13,"Contains","","`*=`",10,N],[4,"Token","","",N,N],[13,"Comment","","Comment.",11,N],[13,"License","","Comment starting with `/**`.",11,N],[13,"Char","","",11,N],[13,"Other","","",11,N],[13,"SelectorElement","","",11,N],[13,"String","","",11,N],[13,"SelectorOperator","","",11,N],[5,"get_line_comment","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_comment","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_string","","",N,[[["str"],["peekable"],["usize"],["reservedchar"]],["option",["token"]]]],[5,"fill_other","","",N,[[["str"],["vec"],["usize"],["usize"],["isize"],["bool"],["bool"]]]],[5,"tokenize","","",N,[[["str"]],["result",["tokens","str"]]]],[5,"clean_tokens","","",N,[[["vec",["token"]]],["vec",["token"]]]],[8,"MyTryFrom","","",N,N],[16,"Error","","",12,N],[10,"try_from","","",12,[[["t"]],["result"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"eq","","",8,[[["self"],["reservedchar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"clone","","",8,[[["self"]],["reservedchar"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",8,[[["char"]],["result",["reservedchar"]]]],[11,"is_useless","","",8,[[["self"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"eq","","",9,[[["self"],["selectorelement"]],["bool"]]],[11,"ne","","",9,[[["self"],["selectorelement"]],["bool"]]],[11,"clone","","",9,[[["self"]],["selectorelement"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",9,[[["str"]],["result",["selectorelement"]]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"eq","","",10,[[["self"],["selectoroperator"]],["bool"]]],[11,"clone","","",10,[[["self"]],["selectoroperator"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",11,N],[11,"eq","","",11,[[["self"],["token"]],["bool"]]],[11,"ne","","",11,[[["self"],["token"]],["bool"]]],[11,"clone","","",11,[[["self"]],["token"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"is_comment","","",11,[[["self"]],["bool"]]],[11,"is_char","","",11,[[["self"]],["bool"]]],[11,"get_char","","",11,[[["self"]],["option",["reservedchar"]]]],[11,"is_useless","","",11,[[["self"]],["bool"]]],[11,"is_media","","",11,[[["self"],["str"]],["bool"]]],[11,"is_a_media","","",11,[[["self"]],["bool"]]],[11,"is_a_license","","",11,[[["self"]],["bool"]]],[11,"eq","","",11,[[["self"],["reservedchar"]],["bool"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"eq","","",7,[[["self"],["tokens"]],["bool"]]],[11,"ne","","",7,[[["self"],["tokens"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"clone","","",7,[[["self"]],["tokens"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[0,"css","minifier::css","",N,N],[5,"minify","minifier::css::css","",N,[[["str"]],["result",["string","str"]]]]],"paths":[[4,"Keyword"],[3,"Tokens"],[4,"ReservedChar"],[4,"Condition"],[4,"Operation"],[4,"Token"],[8,"MyTryFrom"],[3,"Tokens"],[4,"ReservedChar"],[4,"SelectorElement"],[4,"SelectorOperator"],[4,"Token"],[8,"MyTryFrom"]]};
searchIndex["proc_macro"]={"doc":"A support library for macro authors when defining new macros.","items":[[3,"Diagnostic","proc_macro","A structure representing a diagnostic message and associated children messages.",N,N],[12,"level","","",0,N],[12,"message","","",0,N],[12,"span","","",0,N],[12,"children","","",0,N],[3,"TokenStream","","The main type provided by this crate, representing an abstract stream of tokens, or, more specifically, a sequence of token trees. The type provide interfaces for iterating over those token trees and, conversely, collecting a number of token trees into one stream.",N,N],[12,"0","","",1,N],[3,"LexError","","Error returned from `TokenStream::from_str`.",N,N],[12,"_inner","","",2,N],[3,"Span","","A region of source code, along with macro expansion information.",N,N],[12,"0","","",3,N],[3,"LineColumn","","A line-column pair representing the start or end of a `Span`.",N,N],[12,"line","","The 1-indexed line in the source file on which the span starts or ends (inclusive).",4,N],[12,"column","","The 0-indexed column (in UTF-8 characters) in the source file on which the span starts or ends (inclusive).",4,N],[3,"SourceFile","","The source file of a given `Span`.",N,N],[12,"filemap","","",5,N],[3,"Group","","A delimited token stream.",N,N],[12,"delimiter","","",6,N],[12,"stream","","",6,N],[12,"span","","",6,N],[3,"Punct","","An `Punct` is an single punctuation character like `+`, `-` or `#`.",N,N],[12,"ch","","",7,N],[12,"spacing","","",7,N],[12,"span","","",7,N],[3,"Ident","","An identifier (`ident`).",N,N],[12,"sym","","",8,N],[12,"span","","",8,N],[12,"is_raw","","",8,N],[3,"Literal","","A literal string (`\"hello\"`), byte string (`b\"hello\"`), character (`'a'`), byte character (`b'a'`), an integer or floating point number with or without a suffix (`1`, `1u8`, `2.3`, `2.3f32`). Boolean literals like `true` and `false` do not belong here, they are `Ident`s.",N,N],[12,"lit","","",9,N],[12,"suffix","","",9,N],[12,"span","","",9,N],[4,"Level","","An enum representing a diagnostic level.",N,N],[13,"Error","","An error.",10,N],[13,"Warning","","A warning.",10,N],[13,"Note","","A note.",10,N],[13,"Help","","A help message.",10,N],[13,"__Nonexhaustive","","",10,N],[4,"TokenTree","","A single token or a delimited sequence of token trees (e.g. `[1, (), ..]`).",N,N],[13,"Group","","A token stream surrounded by bracket delimiters.",11,N],[13,"Ident","","An identifier.",11,N],[13,"Punct","","A single punctuation character (`+`, `,`, `$`, etc.).",11,N],[13,"Literal","","A literal character (`'a'`), string (`\"hello\"`), number (`2.3`), etc.",11,N],[4,"Delimiter","","Describes how a sequence of token trees is delimited.",N,N],[13,"Parenthesis","","`( ... )`",12,N],[13,"Brace","","`{ ... }`",12,N],[13,"Bracket","","`[ ... ]`",12,N],[13,"None","","`Ø ... Ø` An implicit delimiter, that may, for example, appear around tokens coming from a \"macro variable\" `$var`. It is important to preserve operator priorities in cases like `$var * 3` where `$var` is `1 + 2`. Implicit delimiters may not survive roundtrip of a token stream through a string.",12,N],[4,"Spacing","","Whether an `Punct` is followed immediately by another `Punct` or followed by another token or whitespace.",N,N],[13,"Alone","","E.g. `+` is `Alone` in `+ =`, `+ident` or `+()`.",13,N],[13,"Joint","","E.g. `+` is `Joint` in `+=` or `'#`. Additionally, single quote `'` can join with identifiers to form lifetimes `'ident`.",13,N],[5,"quote","","Quote a `TokenStream` into a `TokenStream`. This is the actual `quote!()` proc macro.",N,[[["tokenstream"]],["tokenstream"]]],[5,"quote_span","","Quote a `Span` into a `TokenStream`. This is needed to implement a custom quoter.",N,[[["span"]],["tokenstream"]]],[5,"parse_to_lex_err","","",N,[[["diagnosticbuilder"]],["lexerror"]]],[0,"rustc","","",N,N],[11,"new_maybe_raw","","",8,[[["str"],["span"],["bool"]],["ident"]]],[11,"from_internal","","",12,[[["delimtoken"]],["delimiter"]]],[11,"to_internal","","",12,[[["self"]],["delimtoken"]]],[11,"from_internal","","",11,[[["tokenstream"],["vec"]],["tokentree"]]],[11,"to_internal","","",11,[[["self"]],["tokenstream"]]],[11,"to_internal","","",10,[[["self"]],["level"]]],[0,"diagnostic","","",N,N],[3,"Diagnostic","proc_macro::diagnostic","A structure representing a diagnostic message and associated children messages.",N,N],[12,"level","","",0,N],[12,"message","","",0,N],[12,"span","","",0,N],[12,"children","","",0,N],[4,"Level","","An enum representing a diagnostic level.",N,N],[13,"Error","","An error.",10,N],[13,"Warning","","A warning.",10,N],[13,"Note","","A note.",10,N],[13,"Help","","A help message.",10,N],[13,"__Nonexhaustive","","",10,N],[11,"clone","proc_macro","",10,[[["self"]],["level"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"clone","","",0,[[["self"]],["diagnostic"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new diagnostic with the given `level` and `message`.",0,[[["level"],["t"]],["diagnostic"]]],[11,"spanned","","Create a new diagnostic with the given `level` and `message` pointing to the given `span`.",0,[[["span"],["level"],["t"]],["diagnostic"]]],[11,"span_error","","Add a new child diagnostic message to `self` with the level identified by this methods name with the given `span` and `message`.",0,[[["self"],["span"],["t"]],["diagnostic"]]],[11,"error","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,[[["self"],["t"]],["diagnostic"]]],[11,"span_warning","","Add a new child diagnostic message to `self` with the level identified by this methods name with the given `span` and `message`.",0,[[["self"],["span"],["t"]],["diagnostic"]]],[11,"warning","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,[[["self"],["t"]],["diagnostic"]]],[11,"span_note","","Add a new child diagnostic message to `self` with the level identified by this methods name with the given `span` and `message`.",0,[[["self"],["span"],["t"]],["diagnostic"]]],[11,"note","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,[[["self"],["t"]],["diagnostic"]]],[11,"span_help","","Add a new child diagnostic message to `self` with the level identified by this methods name with the given `span` and `message`.",0,[[["self"],["span"],["t"]],["diagnostic"]]],[11,"help","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,[[["self"],["t"]],["diagnostic"]]],[11,"level","","Returns the diagnostic `level` for `self`.",0,[[["self"]],["level"]]],[11,"emit","","Emit the diagnostic.",0,[[["self"]]]],[0,"token_stream","","Public implementation details for the `TokenStream` type, such as iterators.",N,N],[3,"IntoIter","proc_macro::token_stream","An iterator over `TokenStream`'s `TokenTree`s. The iteration is \"shallow\", e.g. the iterator doesn't recurse into delimited groups, and returns whole groups as token trees.",N,N],[12,"cursor","","",14,N],[12,"stack","","",14,N],[11,"clone","","",14,[[["self"]],["intoiter"]]],[11,"next","","",14,[[["self"]],["option",["tokentree"]]]],[11,"into_iter","proc_macro","",1,[[["self"]],["intoiter"]]],[0,"quote","","Quasiquoter This file contains the implementation internals of the quasiquoter provided by `quote!`. This quasiquoter uses macros 2.0 hygiene to reliably access items from `proc_macro`, to build a `proc_macro::TokenStream`.",N,N],[5,"quote","proc_macro::quote","Quote a `TokenStream` into a `TokenStream`. This is the actual `quote!()` proc macro.",N,[[["tokenstream"]],["tokenstream"]]],[5,"quote_span","","Quote a `Span` into a `TokenStream`. This is needed to implement a custom quoter.",N,[[["span"]],["tokenstream"]]],[0,"__internal","proc_macro","Permanently unstable internal implementation details of this crate. This should not be used.",N,N],[3,"ProcMacroData","proc_macro::__internal","",N,N],[12,"def_site","","",15,N],[12,"call_site","","",15,N],[3,"ProcMacroSess","","",N,N],[12,"parse_sess","","",16,N],[12,"data","","",16,N],[5,"lookup_char_pos","","",N,[[["bytepos"]],["loc"]]],[5,"new_token_stream","","",N,[[["p",["item"]]],["tokenstream"]]],[5,"token_stream_wrap","","",N,[[["tokenstream"]],["tokenstream"]]],[5,"token_stream_parse_items","","",N,[[["tokenstream"]],["result",["vec","lexerror"]]]],[5,"token_stream_inner","","",N,[[["tokenstream"]],["tokenstream"]]],[5,"set_sess","","",N,[[["extctxt"],["f"]],["r"]]],[5,"in_sess","","",N,[[],["bool"]]],[5,"with_sess","","",N,[[["f"]],["r"]]],[17,"CURRENT_SESS","","",N,N],[8,"Registry","","",N,N],[10,"register_custom_derive","","",17,N],[10,"register_attr_proc_macro","","",17,N],[10,"register_bang_proc_macro","","",17,N],[11,"clone","","",15,[[["self"]],["procmacrodata"]]],[11,"clone","","",16,[[["self"]],["procmacrosess"]]],[11,"clone","proc_macro","",1,[[["self"]],["tokenstream"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"new","","Returns an empty `TokenStream` containing no token trees.",1,[[],["tokenstream"]]],[11,"is_empty","","Checks if this `TokenStream` is empty.",1,[[["self"]],["bool"]]],[11,"from_str","","",1,[[["str"]],["result",["tokenstream","lexerror"]]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"from","","",1,[[["tokentree"]],["tokenstream"]]],[11,"from_iter","","",1,[[["i"]],["self"]]],[11,"from_iter","","",1,[[["i"]],["self"]]],[11,"clone","","",3,[[["self"]],["span"]]],[11,"def_site","","A span that resolves at the macro definition site.",3,[[],["span"]]],[11,"call_site","","The span of the invocation of the current procedural macro. Identifiers created with this span will be resolved as if they were written directly at the macro call location (call-site hygiene) and other code at the macro call site will be able to refer to them as well.",3,[[],["span"]]],[11,"source_file","","The original source file into which this span points.",3,[[["self"]],["sourcefile"]]],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated from, if any.",3,[[["self"]],["option",["span"]]]],[11,"source","","The span for the origin source code that `self` was generated from. If this `Span` wasn't generated from other macro expansions then the return value is the same as `*self`.",3,[[["self"]],["span"]]],[11,"start","","Get the starting line/column in the source file for this span.",3,[[["self"]],["linecolumn"]]],[11,"end","","Get the ending line/column in the source file for this span.",3,[[["self"]],["linecolumn"]]],[11,"join","","Create a new span encompassing `self` and `other`.",3,[[["self"],["span"]],["option",["span"]]]],[11,"resolved_at","","Creates a new span with the same line/column information as `self` but that resolves symbols as though it were at `other`.",3,[[["self"],["span"]],["span"]]],[11,"located_at","","Creates a new span with the same name resolution behavior as `self` but with the line/column information of `other`.",3,[[["self"],["span"]],["span"]]],[11,"eq","","Compares to spans to see if they're equal.",3,[[["self"],["span"]],["bool"]]],[11,"error","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,[[["self"],["t"]],["diagnostic"]]],[11,"warning","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,[[["self"],["t"]],["diagnostic"]]],[11,"note","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,[[["self"],["t"]],["diagnostic"]]],[11,"help","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,[[["self"],["t"]],["diagnostic"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["linecolumn"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["linecolumn"]],["bool"]]],[11,"ne","","",4,[[["self"],["linecolumn"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"clone","","",5,[[["self"]],["sourcefile"]]],[11,"path","","Get the path to this source file.",5,[[["self"]],["pathbuf"]]],[11,"is_real","","Returns `true` if this source file is a real source file, and not generated by an external macro's expansion.",5,[[["self"]],["bool"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"eq","","",5,[[["self"],["self"]],["bool"]]],[11,"clone","","",11,[[["self"]],["tokentree"]]],[11,"span","","Returns the span of this tree, delegating to the `span` method of the contained token or a delimited stream.",11,[[["self"]],["span"]]],[11,"set_span","","Configures the span for only this token.",11,[[["self"],["span"]]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"from","","",11,[[["group"]],["tokentree"]]],[11,"from","","",11,[[["ident"]],["tokentree"]]],[11,"from","","",11,[[["punct"]],["tokentree"]]],[11,"from","","",11,[[["literal"]],["tokentree"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"clone","","",6,[[["self"]],["group"]]],[11,"clone","","",12,[[["self"]],["delimiter"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"eq","","",12,[[["self"],["delimiter"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"new","","Creates a new `Group` with the given delimiter and token stream.",6,[[["delimiter"],["tokenstream"]],["group"]]],[11,"delimiter","","Returns the delimiter of this `Group`",6,[[["self"]],["delimiter"]]],[11,"stream","","Returns the `TokenStream` of tokens that are delimited in this `Group`.",6,[[["self"]],["tokenstream"]]],[11,"span","","Returns the span for the delimiters of this token stream, spanning the entire `Group`.",6,[[["self"]],["span"]]],[11,"set_span","","Configures the span for this `Group`'s delimiters, but not its internal tokens.",6,[[["self"],["span"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"clone","","",7,[[["self"]],["punct"]]],[11,"clone","","",13,[[["self"]],["spacing"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"eq","","",13,[[["self"],["spacing"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"new","","Creates a new `Punct` from the given character and spacing. The `ch` argument must be a valid punctuation character permitted by the language, otherwise the function will panic.",7,[[["char"],["spacing"]],["punct"]]],[11,"as_char","","Returns the value of this punctuation character as `char`.",7,[[["self"]],["char"]]],[11,"spacing","","Returns the spacing of this punctuation character, indicating whether it's immediately followed by another `Punct` in the token stream, so they can potentially be combined into a multicharacter operator (`Joint`), or it's followed by some other token or whitespace (`Alone`) so the operator has certainly ended.",7,[[["self"]],["spacing"]]],[11,"span","","Returns the span for this punctuation character.",7,[[["self"]],["span"]]],[11,"set_span","","Configure the span for this punctuation character.",7,[[["self"],["span"]]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["ident"]]],[11,"is_valid","","",8,[[["str"]],["bool"]]],[11,"new","","Creates a new `Ident` with the given `string` as well as the specified `span`. The `string` argument must be a valid identifier permitted by the language, otherwise the function will panic.",8,[[["str"],["span"]],["ident"]]],[11,"new_raw","","Same as `Ident::new`, but creates a raw identifier (`r#ident`).",8,[[["str"],["span"]],["ident"]]],[11,"span","","Returns the span of this `Ident`, encompassing the entire string returned by `as_str`.",8,[[["self"]],["span"]]],[11,"set_span","","Configures the span of this `Ident`, possibly changing its hygiene context.",8,[[["self"],["span"]]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"clone","","",9,[[["self"]],["literal"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"u8_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u8"]],["literal"]]],[11,"u16_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u16"]],["literal"]]],[11,"u32_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u32"]],["literal"]]],[11,"u64_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u64"]],["literal"]]],[11,"u128_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u128"]],["literal"]]],[11,"usize_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["usize"]],["literal"]]],[11,"i8_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i8"]],["literal"]]],[11,"i16_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i16"]],["literal"]]],[11,"i32_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i32"]],["literal"]]],[11,"i64_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i64"]],["literal"]]],[11,"i128_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i128"]],["literal"]]],[11,"isize_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["isize"]],["literal"]]],[11,"u8_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u8"]],["literal"]]],[11,"u16_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u16"]],["literal"]]],[11,"u32_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u32"]],["literal"]]],[11,"u64_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u64"]],["literal"]]],[11,"u128_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u128"]],["literal"]]],[11,"usize_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["usize"]],["literal"]]],[11,"i8_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i8"]],["literal"]]],[11,"i16_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i16"]],["literal"]]],[11,"i32_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i32"]],["literal"]]],[11,"i64_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i64"]],["literal"]]],[11,"i128_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i128"]],["literal"]]],[11,"isize_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["isize"]],["literal"]]],[11,"f32_unsuffixed","","Creates a new unsuffixed floating-point literal.",9,[[["f32"]],["literal"]]],[11,"f32_suffixed","","Creates a new suffixed floating-point literal.",9,[[["f32"]],["literal"]]],[11,"f64_unsuffixed","","Creates a new unsuffixed floating-point literal.",9,[[["f64"]],["literal"]]],[11,"f64_suffixed","","Creates a new suffixed floating-point literal.",9,[[["f64"]],["literal"]]],[11,"string","","String literal.",9,[[["str"]],["literal"]]],[11,"character","","Character literal.",9,[[["char"]],["literal"]]],[11,"byte_string","","Byte string literal.",9,N],[11,"span","","Returns the span encompassing this literal.",9,[[["self"]],["span"]]],[11,"set_span","","Configures the span associated for this literal.",9,[[["self"],["span"]]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[14,"quote","","`quote!(..)` accepts arbitrary tokens and expands into a `TokenStream` describing the input. For example, `quote!(a + b)` will produce a expression, that, when evaluated, constructs the `TokenStream` `[Ident(\"a\"), Punct('+', Alone), Ident(\"b\")]`.",N,N]],"paths":[[3,"Diagnostic"],[3,"TokenStream"],[3,"LexError"],[3,"Span"],[3,"LineColumn"],[3,"SourceFile"],[3,"Group"],[3,"Punct"],[3,"Ident"],[3,"Literal"],[4,"Level"],[4,"TokenTree"],[4,"Delimiter"],[4,"Spacing"],[3,"IntoIter"],[3,"ProcMacroData"],[3,"ProcMacroSess"],[8,"Registry"]]};
searchIndex["pulldown_cmark"]={"doc":"Pull parser for commonmark.","items":[[3,"Parser","pulldown_cmark","",N,N],[12,"inner","","",0,N],[12,"loose_lists","","",0,N],[12,"loose_stack","","",0,N],[3,"Options","","",N,N],[12,"bits","","",1,N],[4,"Alignment","","",N,N],[13,"None","","",2,N],[13,"Left","","",2,N],[13,"Center","","",2,N],[13,"Right","","",2,N],[4,"Event","","",N,N],[13,"Start","","",3,N],[13,"End","","",3,N],[13,"Text","","",3,N],[13,"Html","","",3,N],[13,"InlineHtml","","",3,N],[13,"FootnoteReference","","",3,N],[13,"SoftBreak","","",3,N],[13,"HardBreak","","",3,N],[4,"Tag","","",N,N],[13,"Paragraph","","",4,N],[13,"Rule","","",4,N],[13,"Header","","A heading. The field indicates the level of the heading.",4,N],[13,"BlockQuote","","",4,N],[13,"CodeBlock","","",4,N],[13,"List","","A list. If the list is ordered the field indicates the number of the first item.",4,N],[13,"Item","","",4,N],[13,"FootnoteDefinition","","",4,N],[13,"Table","","",4,N],[13,"TableHead","","",4,N],[13,"TableRow","","",4,N],[13,"TableCell","","",4,N],[13,"Emphasis","","",4,N],[13,"Strong","","",4,N],[13,"Code","","",4,N],[13,"Link","","A link. The first field is the destination URL, the second is a title",4,N],[13,"Image","","An image. The first field is the destination URL, the second is a title",4,N],[0,"html","","HTML renderer that takes an iterator of events as input.",N,N],[3,"Ctx","pulldown_cmark::html","",N,N],[12,"iter","","",5,N],[12,"buf","","",5,N],[12,"table_state","","",5,N],[12,"table_alignments","","",5,N],[12,"table_cell_index","","",5,N],[4,"TableState","","",N,N],[13,"Head","","",6,N],[13,"Body","","",6,N],[5,"push_html","","Iterate over an `Iterator` of `Event`s, generate HTML for each `Event`, and push it to a `String`.",N,[[["string"],["i"]]]],[11,"fresh_line","","",5,[[["self"]]]],[11,"run","","",5,[[["self"]]]],[11,"start_tag","","",5,[[["self"],["tag"],["hashmap"]]]],[11,"end_tag","","",5,[[["self"],["tag"]]]],[11,"raw_text","","",5,[[["self"],["hashmap"]]]],[0,"passes","pulldown_cmark","Main public pull parse interface, running two passes over input.",N,N],[3,"Parser","pulldown_cmark::passes","",N,N],[12,"inner","","",0,N],[12,"loose_lists","","",0,N],[12,"loose_stack","","",0,N],[11,"new","pulldown_cmark","",0,[[["str"]],["parser"]]],[11,"new_ext","","",0,[[["str"],["options"]],["parser"]]],[11,"new_with_broken_link_callback","","In case the parser encounters any potential links that have a broken reference (e.g `[foo]` when there is no `[foo]:` entry at the bottom) the provided callback will be called with the reference name, and the returned pair will be used as the link name and title if not None.",0,[[["str"],["options"],["option",["fn"]]],["parser"]]],[11,"get_offset","","",0,[[["self"]],["usize"]]],[11,"next","","",0,[[["self"]],["option",["event"]]]],[0,"parse","","Raw parser, for doing a single pass over input.",N,N],[3,"RawParser","pulldown_cmark::parse","",N,N],[12,"text","","",7,N],[12,"off","","",7,N],[12,"opts","","",7,N],[12,"active_tab","","",7,N],[12,"state","","",7,N],[12,"stack","","",7,N],[12,"leading_space","","",7,N],[12,"containers","","",7,N],[12,"last_line_was_empty","","",7,N],[12,"broken_link_callback","","In case we have a broken link/image reference, we can call this callback with the reference name (both normalized and not normalized) and use the link/title pair returned instead",7,N],[12,"fence_char","","",7,N],[12,"fence_count","","",7,N],[12,"fence_indent","","",7,N],[12,"loose_lists","","",7,N],[12,"links","","",7,N],[3,"ParseInfo","","",N,N],[12,"loose_lists","","",8,N],[12,"links","","",8,N],[3,"Options","","",N,N],[12,"bits","","",1,N],[4,"State","","",N,N],[13,"StartBlock","","",9,N],[13,"InContainers","","",9,N],[13,"Inline","","",9,N],[13,"TableHead","","",9,N],[13,"TableBody","","",9,N],[13,"TableRow","","",9,N],[13,"CodeLineStart","","",9,N],[13,"Code","","",9,N],[13,"InlineCode","","",9,N],[13,"Literal","","",9,N],[4,"Container","","",N,N],[13,"BlockQuote","","",10,N],[13,"List","","",10,N],[13,"ListItem","","",10,N],[13,"FootnoteDefinition","","",10,N],[4,"Tag","","",N,N],[13,"Paragraph","","",4,N],[13,"Rule","","",4,N],[13,"Header","","A heading. The field indicates the level of the heading.",4,N],[13,"BlockQuote","","",4,N],[13,"CodeBlock","","",4,N],[13,"List","","A list. If the list is ordered the field indicates the number of the first item.",4,N],[13,"Item","","",4,N],[13,"FootnoteDefinition","","",4,N],[13,"Table","","",4,N],[13,"TableHead","","",4,N],[13,"TableRow","","",4,N],[13,"TableCell","","",4,N],[13,"Emphasis","","",4,N],[13,"Strong","","",4,N],[13,"Code","","",4,N],[13,"Link","","A link. The first field is the destination URL, the second is a title",4,N],[13,"Image","","An image. The first field is the destination URL, the second is a title",4,N],[4,"Event","","",N,N],[13,"Start","","",3,N],[13,"End","","",3,N],[13,"Text","","",3,N],[13,"Html","","",3,N],[13,"InlineHtml","","",3,N],[13,"FootnoteReference","","",3,N],[13,"SoftBreak","","",3,N],[13,"HardBreak","","",3,N],[4,"Alignment","","",N,N],[13,"None","","",2,N],[13,"Left","","",2,N],[13,"Center","","",2,N],[13,"Right","","",2,N],[17,"OPTION_FIRST_PASS","","",N,N],[17,"OPTION_ENABLE_TABLES","","",N,N],[17,"OPTION_ENABLE_FOOTNOTES","","",N,N],[17,"MAX_LINK_NEST","","",N,N],[11,"eq","","",9,[[["self"],["state"]],["bool"]]],[11,"ne","","",9,[[["self"],["state"]],["bool"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"clone","","",10,[[["self"]],["container"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["container"]],["bool"]]],[11,"ne","","",10,[[["self"],["container"]],["bool"]]],[11,"clone","pulldown_cmark","",4,[[["self"]],["tag"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["tag"]],["bool"]]],[11,"ne","","",4,[[["self"],["tag"]],["bool"]]],[11,"clone","","",3,[[["self"]],["event"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"eq","","",3,[[["self"],["event"]],["bool"]]],[11,"ne","","",3,[[["self"],["event"]],["bool"]]],[11,"clone","","",2,[[["self"]],["alignment"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"eq","","",2,[[["self"],["alignment"]],["bool"]]],[11,"eq","","",1,[[["self"],["options"]],["bool"]]],[11,"ne","","",1,[[["self"],["options"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1,N],[11,"clone","","",1,[[["self"]],["options"]]],[11,"partial_cmp","","",1,[[["self"],["options"]],["option",["ordering"]]]],[11,"lt","","",1,[[["self"],["options"]],["bool"]]],[11,"le","","",1,[[["self"],["options"]],["bool"]]],[11,"gt","","",1,[[["self"],["options"]],["bool"]]],[11,"ge","","",1,[[["self"],["options"]],["bool"]]],[11,"cmp","","",1,[[["self"],["options"]],["ordering"]]],[11,"hash","","",1,N],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"empty","","Returns an empty set of flags.",1,[[],["options"]]],[11,"all","","Returns the set containing all flags.",1,[[],["options"]]],[11,"bits","","Returns the raw value of the flags currently stored.",1,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",1,[[["u32"]],["option",["options"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",1,[[["u32"]],["options"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",1,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",1,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",1,[[["self"],["options"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",1,[[["self"],["options"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",1,[[["self"],["options"]]]],[11,"remove","","Removes the specified flags in-place.",1,[[["self"],["options"]]]],[11,"toggle","","Toggles the specified flags in-place.",1,[[["self"],["options"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",1,[[["self"],["options"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",1,[[["self"],["options"]],["options"]]],[11,"bitor_assign","","Adds the set of flags.",1,[[["self"],["options"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",1,[[["self"],["options"]],["options"]]],[11,"bitxor_assign","","Toggles the set of flags.",1,[[["self"],["options"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",1,[[["self"],["options"]],["options"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",1,[[["self"],["options"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",1,[[["self"],["options"]],["options"]]],[11,"sub_assign","","Disables all flags enabled in the set.",1,[[["self"],["options"]]]],[11,"not","","Returns the complement of this set of flags.",1,[[["self"]],["options"]]],[11,"extend","","",1,[[["self"],["t"]]]],[11,"from_iter","","",1,[[["t"]],["options"]]],[11,"new_with_links_and_callback","pulldown_cmark::parse","",7,[[["str"],["options"],["hashmap",["string"]],["option",["fn"]]],["rawparser"]]],[11,"new_with_links","","",7,[[["str"],["options"],["hashmap",["string"]]],["rawparser"]]],[11,"new","","",7,[[["str"],["options"]],["rawparser"]]],[11,"get_offset","","",7,[[["self"]],["usize"]]],[11,"get_info","","",7,[[["self"]],["parseinfo"]]],[11,"init_active","","",7,[[["self"]]]],[11,"limit","","",7,[[["self"]],["usize"]]],[11,"start","","",7,[[["self"],["tag"],["usize"],["usize"]],["event"]]],[11,"end","","",7,[[["self"]],["event"]]],[11,"skip_leading_whitespace","","",7,[[["self"]]]],[11,"skip_blank_lines","","",7,[[["self"]]]],[11,"scan_containers","","",7,N],[11,"scan_empty_lines","","",7,N],[11,"scan_whitespace_inline","","",7,[[["self"],["str"]],["usize"]]],[11,"at_list","","",7,[[["self"],["usize"]],["option",["usize"]]]],[11,"start_block","","",7,[[["self"]],["option",["event"]]]],[11,"start_paragraph","","",7,[[["self"]],["event"]]],[11,"start_table_head","","",7,[[["self"]],["event"]]],[11,"start_table_body","","",7,[[["self"]],["event"]]],[11,"start_hrule","","",7,[[["self"]],["event"]]],[11,"start_atx_header","","",7,[[["self"],["i32"]],["event"]]],[11,"start_indented_code","","",7,[[["self"]],["event"]]],[11,"start_listitem","","",7,[[["self"],["usize"],["u8"],["usize"],["usize"]],["event"]]],[11,"start_code_fence","","",7,[[["self"],["usize"],["u8"],["usize"]],["event"]]],[11,"next_code_line_start","","",7,[[["self"]],["event"]]],[11,"next_code","","",7,[[["self"]],["event"]]],[11,"is_code_block_end","","",7,[[["self"],["usize"],["usize"]],["bool"]]],[11,"scan_html_block_tag","","",7,N],[11,"is_html_block","","",7,[[["self"],["str"]],["bool"]]],[11,"get_html_tag","","",7,[[["self"]],["option",["str"]]]],[11,"do_html_block","","",7,[[["self"]],["event"]]],[11,"try_link_reference_definition","","",7,[[["self"],["str"]],["bool"]]],[11,"normalize_link_ref","","",7,[[["self"],["str"]],["string"]]],[11,"is_inline_block_end","","",7,[[["self"],["str"],["usize"]],["bool"]]],[11,"next_table_cell","","",7,[[["self"]],["event"]]],[11,"next_inline","","",7,[[["self"]],["event"]]],[11,"active_char","","",7,[[["self"],["u8"]],["option",["event"]]]],[11,"char_null","","",7,[[["self"]],["event"]]],[11,"char_tab","","",7,[[["self"]],["event"]]],[11,"char_backslash","","",7,[[["self"]],["option",["event"]]]],[11,"char_entity","","",7,[[["self"]],["option",["event"]]]],[11,"char_emphasis","","",7,[[["self"]],["option",["event"]]]],[11,"scan_link_label","","",7,N],[11,"scan_link_title","","",7,N],[11,"char_link","","",7,[[["self"]],["option",["event"]]]],[11,"parse_link","","",7,[[["self"],["str"],["bool"]],["option"]]],[11,"contains_link","","",7,[[["self"],["str"]],["bool"]]],[11,"parse_footnote_definition","","",7,[[["self"],["str"]],["option"]]],[11,"char_link_footnote","","",7,[[["self"]],["option",["event"]]]],[11,"parse_footnote","","",7,[[["self"],["str"]],["option"]]],[11,"scan_footnote_label","","",7,N],[11,"char_lt","","",7,[[["self"]],["option",["event"]]]],[11,"scan_autolink_or_html","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_inline_html","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_html_tag","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_attribute_value","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_html_comment","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_processing_instruction","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_declaration","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_cdata","","",7,[[["self"],["str"]],["usize"]]],[11,"inline_html_event","","",7,[[["self"],["usize"]],["event"]]],[11,"next_literal","","",7,[[["self"]],["event"]]],[11,"scan_inline_code","","",7,N],[11,"char_backtick","","",7,[[["self"]],["option",["event"]]]],[11,"next_inline_code","","",7,[[["self"]],["event"]]],[11,"next","","",7,[[["self"]],["option",["event"]]]],[0,"scanners","pulldown_cmark","Scanners for fragments of CommonMark syntax",N,N],[5,"is_ascii_whitespace","pulldown_cmark::scanners","",N,[[["u8"]],["bool"]]],[5,"is_ascii_whitespace_no_nl","","",N,[[["u8"]],["bool"]]],[5,"is_ascii_alpha","","",N,[[["u8"]],["bool"]]],[5,"is_ascii_upper","","",N,[[["u8"]],["bool"]]],[5,"is_ascii_alphanumeric","","",N,[[["u8"]],["bool"]]],[5,"is_hexdigit","","",N,[[["u8"]],["bool"]]],[5,"is_digit","","",N,[[["u8"]],["bool"]]],[5,"scan_ch","","",N,[[["str"],["u8"]],["usize"]]],[5,"scan_while","","",N,[[["str"],["f"]],["usize"]]],[5,"scan_ch_repeat","","",N,[[["str"],["u8"]],["usize"]]],[5,"scan_whitespace_no_nl","","",N,[[["str"]],["usize"]]],[5,"scan_eol","","",N,N],[5,"scan_trailing_whitespace","","",N,[[["str"]],["usize"]]],[5,"scan_codepoint","","",N,[[["str"]],["option",["char"]]]],[5,"scan_trailing_codepoint","","",N,[[["str"]],["option",["char"]]]],[5,"scan_blank_line","","",N,[[["str"]],["usize"]]],[5,"scan_nextline","","",N,[[["str"]],["usize"]]],[5,"count_tab","","",N,N],[5,"scan_leading_space","","",N,N],[5,"calc_indent","","",N,N],[5,"scan_hrule","","",N,[[["str"]],["usize"]]],[5,"scan_atx_header","","",N,N],[5,"scan_setext_header","","",N,N],[5,"scan_table_head","","",N,N],[5,"scan_code_fence","","",N,N],[5,"scan_backticks","","",N,[[["str"]],["usize"]]],[5,"scan_blockquote_start","","",N,[[["str"]],["usize"]]],[5,"scan_listitem","","",N,N],[5,"compute_open_close","","",N,N],[5,"cow_from_codepoint_str","","",N,[[["str"],["u32"]],["cow",["str"]]]],[5,"scan_entity","","",N,N],[5,"scan_link_dest","","",N,[[["str"]],["option"]]],[5,"scan_autolink","","",N,[[["str"]],["option"]]],[5,"scan_uri","","",N,[[["str"]],["usize"]]],[5,"scan_email","","",N,[[["str"]],["usize"]]],[5,"scan_attribute_name","","",N,[[["str"]],["usize"]]],[5,"is_escaped","","",N,[[["str"],["usize"]],["bool"]]],[5,"unescape","","",N,[[["str"]],["cow",["str"]]]],[5,"is_html_tag","","",N,[[["str"]],["bool"]]],[5,"spaces","","",N,[[["usize"]],["cow",["str"]]]],[17,"HTML_TAGS","","",N,N],[17,"URI_SCHEMES","","",N,N],[0,"entities","pulldown_cmark","Expansions of HTML5 entities",N,N],[5,"get_entity","pulldown_cmark::entities","",N,[[["str"]],["option",["str"]]]],[17,"ENTITIES","","",N,N],[17,"ENTITY_VALUES","","",N,N],[0,"escape","pulldown_cmark","Utility functions for HTML escaping",N,N],[5,"escape_href","pulldown_cmark::escape","",N,[[["string"],["str"]]]],[5,"escape_html","","",N,[[["string"],["str"],["bool"]]]],[7,"HREF_SAFE","","",N,N],[7,"HEX_CHARS","","",N,N],[7,"HTML_ESCAPE_TABLE","","",N,N],[7,"HTML_ESCAPES","","",N,N],[0,"puncttable","pulldown_cmark","CommonMark punctuation set based on spec and Unicode properties.",N,N],[5,"is_ascii_punctuation","pulldown_cmark::puncttable","",N,[[["u8"]],["bool"]]],[5,"is_punctuation","","",N,[[["char"]],["bool"]]],[17,"PUNCT_MASKS_ASCII","","",N,N],[17,"PUNCT_TAB","","",N,N],[17,"PUNCT_MASKS","","",N,N],[0,"utils","pulldown_cmark","Utilities for manipulating strings.",N,N],[5,"ascii_tolower","pulldown_cmark::utils","",N,[[["u8"]],["u8"]]],[5,"strcasecmp","","",N,[[["str"],["str"]],["ordering"]]],[5,"cow_append","","",N,[[["cow",["str"]],["cow",["str"]]],["cow",["str"]]]],[17,"OPTION_ENABLE_TABLES","pulldown_cmark","",N,N],[17,"OPTION_ENABLE_FOOTNOTES","","",N,N]],"paths":[[3,"Parser"],[3,"Options"],[4,"Alignment"],[4,"Event"],[4,"Tag"],[3,"Ctx"],[4,"TableState"],[3,"RawParser"],[3,"ParseInfo"],[4,"State"],[4,"Container"]]};
searchIndex["rand"]={"doc":"Utilities for random number generation","items":[[3,"IsaacRng","rand","A random number generator that uses the ISAAC algorithm[1].",N,N],[12,"cnt","","",0,N],[12,"rsl","","",0,N],[12,"mem","","",0,N],[12,"a","","",0,N],[12,"b","","",0,N],[12,"c","","",0,N],[3,"Isaac64Rng","","A random number generator that uses ISAAC-64[1], the 64-bit variant of the ISAAC algorithm.",N,N],[12,"cnt","","",1,N],[12,"rsl","","",1,N],[12,"mem","","",1,N],[12,"a","","",1,N],[12,"b","","",1,N],[12,"c","","",1,N],[3,"ChaChaRng","","A random number generator that uses the ChaCha20 algorithm [1].",N,N],[12,"buffer","","",2,N],[12,"state","","",2,N],[12,"index","","",2,N],[3,"XorShiftRng","","An Xorshift[1] random number generator.",N,N],[12,"x","","",3,N],[12,"y","","",3,N],[12,"z","","",3,N],[12,"w","","",3,N],[3,"Generator","","Iterator which will generate a stream of random items.",N,N],[12,"rng","","",4,N],[12,"_marker","","",4,N],[3,"AsciiGenerator","","Iterator which will continuously generate random ascii characters.",N,N],[12,"rng","","",5,N],[3,"Open01","","A wrapper for generating floating point numbers uniformly in the open interval `(0,1)` (not including either endpoint).",N,N],[12,"0","","",6,N],[3,"Closed01","","A wrapper for generating floating point numbers uniformly in the closed interval `[0,1]` (including both endpoints).",N,N],[12,"0","","",7,N],[3,"StdRng","","The standard RNG. This is designed to be efficient on the current platform.",N,N],[12,"rng","","",8,N],[3,"ThreadRngReseeder","","Controls how the thread-local RNG is reseeded.",N,N],[3,"ThreadRng","","The thread-local RNG.",N,N],[12,"rng","","",9,N],[5,"weak_rng","","Create a weak random number generator with a default algorithm and seed.",N,[[],["xorshiftrng"]]],[5,"thread_rng","","Retrieve the lazily-initialized thread-local random number generator, seeded by the system. Intended to be used in method chaining style, e.g. `thread_rng().gen::<i32>()`.",N,[[],["threadrng"]]],[5,"random","","Generates a random value using the thread-local random number generator.",N,[[],["t"]]],[5,"sample","","DEPRECATED: use `seq::sample_iter` instead.",N,[[["r"],["i"],["usize"]],["vec"]]],[0,"distributions","","Sampling from random distributions.",N,N],[3,"RandSample","rand::distributions","A wrapper for generating types that implement `Rand` via the `Sample` & `IndependentSample` traits.",N,N],[12,"_marker","","",10,N],[3,"Weighted","","A value with a particular weight for use with `WeightedChoice`.",N,N],[12,"weight","","The numerical weight of this item",11,N],[12,"item","","The actual item which is being weighted",11,N],[3,"WeightedChoice","","A distribution that selects from a finite collection of weighted items.",N,N],[12,"items","","",12,N],[12,"weight_range","","",12,N],[5,"ziggurat","","Sample a random number using the Ziggurat method (specifically the ZIGNOR variant from Doornik 2005). Most of the arguments are directly from the paper:",N,N],[0,"range","","Generating numbers between two others.",N,N],[3,"Range","rand::distributions::range","Sample values uniformly between two bounds.",N,N],[12,"low","","",13,N],[12,"range","","",13,N],[12,"accept_zone","","",13,N],[8,"SampleRange","","The helper trait for types that have a sensible way to sample uniformly between two values. This should not be used directly, and is only to facilitate `Range`.",N,N],[10,"construct_range","","Construct the `Range` object that `sample_range` requires. This should not ever be called directly, only via `Range::new`, which will check that `low < high`, so this function doesn't have to repeat the check.",14,[[["self"],["self"]],["range"]]],[10,"sample_range","","Sample a value from the given `Range` with the given `Rng` as a source of randomness.",14,[[["range"],["r"]],["self"]]],[11,"clone","","",13,[[["self"]],["range"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `Range` instance that samples uniformly from `[low, high)`. Panics if `low >= high`.",13,[[["x"],["x"]],["range"]]],[11,"sample","","",13,[[["self"],["r"]],["sup"]]],[11,"ind_sample","","",13,[[["self"],["r"]],["sup"]]],[0,"gamma","rand::distributions","The Gamma and derived distributions.",N,N],[3,"Gamma","rand::distributions::gamma","The Gamma distribution `Gamma(shape, scale)` distribution.",N,N],[12,"repr","","",15,N],[3,"GammaSmallShape","","Gamma distribution where the shape parameter is less than 1.",N,N],[12,"inv_shape","","",16,N],[12,"large_shape","","",16,N],[3,"GammaLargeShape","","Gamma distribution where the shape parameter is larger than 1.",N,N],[12,"scale","","",17,N],[12,"c","","",17,N],[12,"d","","",17,N],[3,"ChiSquared","","The chi-squared distribution `χ²(k)`, where `k` is the degrees of freedom.",N,N],[12,"repr","","",18,N],[3,"FisherF","","The Fisher F distribution `F(m, n)`.",N,N],[12,"numer","","",19,N],[12,"denom","","",19,N],[12,"dof_ratio","","",19,N],[3,"StudentT","","The Student t distribution, `t(nu)`, where `nu` is the degrees of freedom.",N,N],[12,"chi","","",20,N],[12,"dof","","",20,N],[4,"GammaRepr","","",N,N],[13,"Large","","",21,N],[13,"One","","",21,N],[13,"Small","","",21,N],[4,"ChiSquaredRepr","","",N,N],[13,"DoFExactlyOne","","",22,N],[13,"DoFAnythingElse","","",22,N],[11,"clone","","",15,[[["self"]],["gamma"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"clone","","",21,[[["self"]],["gammarepr"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"clone","","",16,[[["self"]],["gammasmallshape"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"clone","","",17,[[["self"]],["gammalargeshape"]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct an object representing the `Gamma(shape, scale)` distribution.",15,[[["f64"],["f64"]],["gamma"]]],[11,"new_raw","","",16,[[["f64"],["f64"]],["gammasmallshape"]]],[11,"new_raw","","",17,[[["f64"],["f64"]],["gammalargeshape"]]],[11,"sample","","",15,[[["self"],["r"]],["f64"]]],[11,"sample","","",16,[[["self"],["r"]],["f64"]]],[11,"sample","","",17,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",15,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",16,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",17,[[["self"],["r"]],["f64"]]],[11,"clone","","",18,[[["self"]],["chisquared"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",22,[[["self"]],["chisquaredrepr"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new chi-squared distribution with degrees-of-freedom `k`. Panics if `k < 0`.",18,[[["f64"]],["chisquared"]]],[11,"sample","","",18,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",18,[[["self"],["r"]],["f64"]]],[11,"clone","","",19,[[["self"]],["fisherf"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `FisherF` distribution, with the given parameter. Panics if either `m` or `n` are not positive.",19,[[["f64"],["f64"]],["fisherf"]]],[11,"sample","","",19,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",19,[[["self"],["r"]],["f64"]]],[11,"clone","","",20,[[["self"]],["studentt"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new Student t distribution with `n` degrees of freedom. Panics if `n <= 0`.",20,[[["f64"]],["studentt"]]],[11,"sample","","",20,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",20,[[["self"],["r"]],["f64"]]],[0,"normal","rand::distributions","The normal and derived distributions.",N,N],[3,"StandardNormal","rand::distributions::normal","A wrapper around an `f64` to generate N(0, 1) random numbers (a.k.a.  a standard normal, or Gaussian).",N,N],[12,"0","","",23,N],[3,"Normal","","The normal distribution `N(mean, std_dev**2)`.",N,N],[12,"mean","","",24,N],[12,"std_dev","","",24,N],[3,"LogNormal","","The log-normal distribution `ln N(mean, std_dev**2)`.",N,N],[12,"norm","","",25,N],[11,"clone","","",23,[[["self"]],["standardnormal"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"rand","","",23,[[["r"]],["standardnormal"]]],[11,"clone","","",24,[[["self"]],["normal"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `Normal` distribution with the given mean and standard deviation.",24,[[["f64"],["f64"]],["normal"]]],[11,"sample","","",24,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",24,[[["self"],["r"]],["f64"]]],[11,"clone","","",25,[[["self"]],["lognormal"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `LogNormal` distribution with the given mean and standard deviation.",25,[[["f64"],["f64"]],["lognormal"]]],[11,"sample","","",25,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",25,[[["self"],["r"]],["f64"]]],[0,"exponential","rand::distributions","The exponential distribution.",N,N],[3,"Exp1","rand::distributions::exponential","A wrapper around an `f64` to generate Exp(1) random numbers.",N,N],[12,"0","","",26,N],[3,"Exp","","The exponential distribution `Exp(lambda)`.",N,N],[12,"lambda_inverse","","`lambda` stored as `1/lambda`, since this is what we scale by.",27,N],[11,"clone","","",26,[[["self"]],["exp1"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"rand","","",26,[[["r"]],["exp1"]]],[11,"clone","","",27,[[["self"]],["exp"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `Exp` with the given shape parameter `lambda`. Panics if `lambda <= 0`.",27,[[["f64"]],["exp"]]],[11,"sample","","",27,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",27,[[["self"],["r"]],["f64"]]],[0,"ziggurat_tables","rand::distributions","",N,N],[6,"ZigTable","rand::distributions::ziggurat_tables","",N,N],[7,"ZIG_NORM_X","","",N,N],[7,"ZIG_NORM_F","","",N,N],[7,"ZIG_EXP_X","","",N,N],[7,"ZIG_EXP_F","","",N,N],[17,"ZIG_NORM_R","","",N,N],[17,"ZIG_EXP_R","","",N,N],[8,"Sample","rand::distributions","Types that can be used to create a random instance of `Support`.",N,N],[10,"sample","","Generate a random value of `Support`, using `rng` as the source of randomness.",28,[[["self"],["r"]],["support"]]],[8,"IndependentSample","","`Sample`s that do not require keeping track of state.",N,N],[10,"ind_sample","","Generate a random value.",29,[[["self"],["r"]],["support"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"clone","","",10,[[["self"]],["self"]]],[11,"sample","","",10,[[["self"],["r"]],["sup"]]],[11,"ind_sample","","",10,[[["self"],["r"]],["sup"]]],[11,"new","","",10,[[],["randsample"]]],[11,"clone","","",11,[[["self"]],["weighted"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `WeightedChoice`.",12,N],[11,"sample","","",12,[[["self"],["r"]],["t"]]],[11,"ind_sample","","",12,[[["self"],["r"]],["t"]]],[0,"jitter","rand","Non-physical true random number generator based on timing jitter.",N,N],[3,"JitterRng","rand::jitter","A true random number generator based on jitter in the CPU execution time, and jitter in memory access time.",N,N],[12,"data","","",30,N],[12,"rounds","","",30,N],[12,"timer","","",30,N],[12,"prev_time","","",30,N],[12,"last_delta","","",30,N],[12,"last_delta2","","",30,N],[12,"mem_prev_index","","",30,N],[12,"mem","","",30,N],[12,"data_remaining","","",30,N],[4,"TimerError","","An error that can occur when `test_timer` fails.",N,N],[13,"NoTimer","","No timer available.",31,N],[13,"CoarseTimer","","Timer too coarse to use as an entropy source.",31,N],[13,"NotMonotonic","","Timer is not monotonically increasing.",31,N],[13,"TinyVariantions","","Variations of deltas of time too small.",31,N],[13,"TooManyStuck","","Too many stuck results (indicating no added entropy).",31,N],[13,"__Nonexhaustive","","",31,N],[5,"black_box","","",N,[[["t"]],["t"]]],[0,"platform","","",N,N],[5,"get_nstime","rand::jitter::platform","",N,[[],["u64"]]],[7,"JITTER_ROUNDS","rand::jitter","",N,N],[17,"MEMORY_BLOCKS","","",N,N],[17,"MEMORY_BLOCKSIZE","","",N,N],[17,"MEMORY_SIZE","","",N,N],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"clone","","",31,[[["self"]],["timererror"]]],[11,"eq","","",31,[[["self"],["timererror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",31,N],[11,"description","","",31,[[["self"]],["str"]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"description","","",31,[[["self"]],["str"]]],[11,"new","","Create a new `JitterRng`. Makes use of `std::time` for a timer.",30,[[],["result",["jitterrng","timererror"]]]],[11,"new_with_timer","","Create a new `JitterRng`. A custom timer can be supplied, making it possible to use `JitterRng` in `no_std` environments.",30,N],[11,"set_rounds","","Configures how many rounds are used to generate each 64-bit value. This must be greater than zero, and has a big impact on performance and output quality.",30,[[["self"],["u32"]]]],[11,"random_loop_cnt","","",30,[[["self"],["u32"]],["u32"]]],[11,"lfsr_time","","",30,[[["self"],["u64"],["bool"]]]],[11,"memaccess","","",30,[[["self"],["bool"]]]],[11,"stuck","","",30,[[["self"],["i64"]],["bool"]]],[11,"measure_jitter","","",30,[[["self"]],["option"]]],[11,"stir_pool","","",30,[[["self"]]]],[11,"gen_entropy","","",30,[[["self"]],["u64"]]],[11,"test_timer","","Basic quality tests on the timer, by measuring CPU timing jitter a few hundred times.",30,[[["self"]],["result",["u32","timererror"]]]],[11,"timer_stats","","Statistical test: return the timer delta of one normal run of the `JitterEntropy` entropy collector.",30,[[["self"],["bool"]],["i64"]]],[11,"next_u32","","",30,[[["self"]],["u32"]]],[11,"next_u64","","",30,[[["self"]],["u64"]]],[11,"fill_bytes","","",30,N],[0,"os","rand","Interfaces to the operating system provided random number generators.",N,N],[3,"OsRng","rand::os","A random number generator that retrieves randomness straight from the operating system. Platform sources:",N,N],[12,"0","","",32,N],[5,"next_u32","","",N,[[["fnmut"]],["u32"]]],[5,"next_u64","","",N,[[["fnmut"]],["u64"]]],[0,"imp","","",N,N],[3,"OsRng","rand::os::imp","",N,N],[12,"inner","","",33,N],[4,"OsRngInner","","",N,N],[13,"OsGetrandomRng","","",34,N],[13,"OsReadRng","","",34,N],[5,"getrandom","","",N,N],[5,"getrandom_fill_bytes","","",N,N],[5,"is_getrandom_available","","",N,[[],["bool"]]],[11,"new","","",33,[[],["result",["osrng"]]]],[11,"next_u32","","",33,[[["self"]],["u32"]]],[11,"next_u64","","",33,[[["self"]],["u64"]]],[11,"fill_bytes","","",33,N],[11,"new","rand::os","Create a new `OsRng`.",32,[[],["result",["osrng"]]]],[11,"next_u32","","",32,[[["self"]],["u32"]]],[11,"next_u64","","",32,[[["self"]],["u64"]]],[11,"fill_bytes","","",32,N],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[0,"read","rand","A wrapper around any Read to treat it as an RNG.",N,N],[3,"ReadRng","rand::read","An RNG that reads random bytes straight from a `Read`. This will work best with an infinite reader, but this is not required.",N,N],[12,"reader","","",35,N],[5,"fill","","",N,N],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `ReadRng` from a `Read`.",35,[[["r"]],["readrng"]]],[11,"next_u32","","",35,[[["self"]],["u32"]]],[11,"next_u64","","",35,[[["self"]],["u64"]]],[11,"fill_bytes","","",35,N],[0,"reseeding","rand","A wrapper around another RNG that reseeds it after it generates a certain number of random bytes.",N,N],[3,"ReseedingRng","rand::reseeding","A wrapper around any RNG which reseeds the underlying RNG after it has generated a certain number of random bytes.",N,N],[12,"rng","","",36,N],[12,"generation_threshold","","",36,N],[12,"bytes_generated","","",36,N],[12,"reseeder","","Controls the behaviour when reseeding the RNG.",36,N],[3,"ReseedWithDefault","","Reseed an RNG using a `Default` instance. This reseeds by replacing the RNG with the result of a `Default::default` call.",N,N],[17,"DEFAULT_GENERATION_THRESHOLD","","How many bytes of entropy the underling RNG is allowed to generate before it is reseeded",N,N],[8,"Reseeder","","Something that can be used to reseed an RNG via `ReseedingRng`.",N,N],[10,"reseed","","Reseed the given RNG.",37,[[["self"],["r"]]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `ReseedingRng` with the given parameters.",36,[[["r"],["u64"],["rsdr"]],["reseedingrng"]]],[11,"reseed_if_necessary","","Reseed the internal RNG if the number of bytes that have been generated exceed the threshold.",36,[[["self"]]]],[11,"next_u32","","",36,[[["self"]],["u32"]]],[11,"next_u64","","",36,[[["self"]],["u64"]]],[11,"fill_bytes","","",36,N],[11,"reseed","","",36,N],[11,"from_seed","","Create a new `ReseedingRng` from the given reseeder and seed. This uses a default value for `generation_threshold`.",36,N],[11,"clone","","",38,[[["self"]],["reseedwithdefault"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"reseed","","",38,[[["self"],["r"]]]],[11,"default","","",38,[[],["reseedwithdefault"]]],[0,"seq","rand","Functions for randomly accessing and sampling sequences.",N,N],[5,"sample_iter","rand::seq","Randomly sample `amount` elements from a finite iterator.",N,[[["r"],["i"],["usize"]],["result",["vec","vec"]]]],[5,"sample_slice","","Randomly sample exactly `amount` values from `slice`.",N,N],[5,"sample_slice_ref","","Randomly sample exactly `amount` references from `slice`.",N,N],[5,"sample_indices","","Randomly sample exactly `amount` indices from `0..length`.",N,[[["r"],["usize"],["usize"]],["vec",["usize"]]]],[5,"sample_indices_inplace","","Sample an amount of indices using an inplace partial fisher yates method.",N,[[["r"],["usize"],["usize"]],["vec",["usize"]]]],[5,"sample_indices_cache","","This method performs a partial fisher-yates on a range of indices using a HashMap as a cache to record potential collisions.",N,[[["r"],["usize"],["usize"]],["vec",["usize"]]]],[0,"chacha","rand","The ChaCha random number generator.",N,N],[3,"ChaChaRng","rand::chacha","A random number generator that uses the ChaCha20 algorithm [1].",N,N],[12,"buffer","","",2,N],[12,"state","","",2,N],[12,"index","","",2,N],[0,"isaac","rand","The ISAAC random number generator.",N,N],[3,"IsaacRng","rand::isaac","A random number generator that uses the ISAAC algorithm[1].",N,N],[12,"cnt","","",0,N],[12,"rsl","","",0,N],[12,"mem","","",0,N],[12,"a","","",0,N],[12,"b","","",0,N],[12,"c","","",0,N],[3,"Isaac64Rng","","A random number generator that uses ISAAC-64[1], the 64-bit variant of the ISAAC algorithm.",N,N],[12,"cnt","","",1,N],[12,"rsl","","",1,N],[12,"mem","","",1,N],[12,"a","","",1,N],[12,"b","","",1,N],[12,"c","","",1,N],[0,"rand_impls","rand","The implementations of `Rand` for the built-in types.",N,N],[0,"f64_rand_impls","rand::rand_impls","",N,N],[17,"SCALE","rand::rand_impls::f64_rand_impls","",N,N],[11,"rand","rand","",6,[[["r"]],["open01",["f64"]]]],[11,"rand","","",7,[[["r"]],["closed01",["f64"]]]],[0,"f32_rand_impls","rand::rand_impls","",N,N],[17,"SCALE","rand::rand_impls::f32_rand_impls","",N,N],[11,"rand","rand","",6,[[["r"]],["open01",["f32"]]]],[11,"rand","","",7,[[["r"]],["closed01",["f32"]]]],[0,"prng","","Pseudo random number generators are algorithms to produce apparently random numbers deterministically, and usually fairly quickly.",N,N],[0,"chacha","rand::prng","The ChaCha random number generator.",N,N],[3,"ChaChaRng","rand::prng::chacha","A random number generator that uses the ChaCha20 algorithm [1].",N,N],[12,"buffer","","",2,N],[12,"state","","",2,N],[12,"index","","",2,N],[5,"core","","",N,N],[6,"w32","","",N,N],[7,"EMPTY","","",N,N],[17,"KEY_WORDS","","",N,N],[17,"STATE_WORDS","","",N,N],[17,"CHACHA_ROUNDS","","",N,N],[11,"clone","rand","",2,[[["self"]],["chacharng"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"new_unseeded","","Create an ChaCha random number generator using the default fixed key of 8 zero words.",2,[[],["chacharng"]]],[11,"set_counter","","Sets the internal 128-bit ChaCha counter to a user-provided value. This permits jumping arbitrarily ahead (or backwards) in the pseudorandom stream.",2,[[["self"],["u64"],["u64"]]]],[11,"init","","Initializes `self.state` with the appropriate key and constants",2,N],[11,"update","","Refill the internal output buffer (`self.buffer`)",2,[[["self"]]]],[11,"next_u32","","",2,[[["self"]],["u32"]]],[11,"reseed","","",2,N],[11,"from_seed","","Create a ChaCha generator from a seed, obtained from a variable-length u32 array. Only up to 8 words are used; if less than 8 words are used, the remaining are set to zero.",2,N],[11,"rand","","",2,[[["r"]],["chacharng"]]],[0,"isaac","rand::prng","The ISAAC random number generator.",N,N],[3,"IsaacRng","rand::prng::isaac","A random number generator that uses the ISAAC algorithm[1].",N,N],[12,"cnt","","",0,N],[12,"rsl","","",0,N],[12,"mem","","",0,N],[12,"a","","",0,N],[12,"b","","",0,N],[12,"c","","",0,N],[6,"w32","","",N,N],[7,"EMPTY","","",N,N],[17,"RAND_SIZE_LEN","","",N,N],[17,"RAND_SIZE","","",N,N],[17,"RAND_SIZE_USIZE","","",N,N],[11,"new_unseeded","rand","Create an ISAAC random number generator using the default fixed seed.",0,[[],["isaacrng"]]],[11,"init","","Initialises `self`. If `use_rsl` is true, then use the current value of `rsl` as a seed, otherwise construct one algorithmically (not randomly).",0,[[["self"],["bool"]]]],[11,"isaac","","Refills the output buffer (`self.rsl`)",0,[[["self"]]]],[11,"clone","","",0,[[["self"]],["isaacrng"]]],[11,"next_u32","","",0,[[["self"]],["u32"]]],[11,"reseed","","",0,N],[11,"from_seed","","Create an ISAAC random number generator with a seed. This can be any length, although the maximum number of elements used is 256 and any more will be silently ignored. A generator constructed with a given seed will generate the same sequence of values as all other generators constructed with that seed.",0,N],[11,"rand","","",0,[[["r"]],["isaacrng"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[0,"isaac64","rand::prng","The ISAAC-64 random number generator.",N,N],[3,"Isaac64Rng","rand::prng::isaac64","A random number generator that uses ISAAC-64[1], the 64-bit variant of the ISAAC algorithm.",N,N],[12,"cnt","","",1,N],[12,"rsl","","",1,N],[12,"mem","","",1,N],[12,"a","","",1,N],[12,"b","","",1,N],[12,"c","","",1,N],[6,"w64","","",N,N],[7,"EMPTY_64","","",N,N],[17,"RAND_SIZE_64_LEN","","",N,N],[17,"RAND_SIZE_64","","",N,N],[11,"new_unseeded","rand","Create a 64-bit ISAAC random number generator using the default fixed seed.",1,[[],["isaac64rng"]]],[11,"init","","Initialises `self`. If `use_rsl` is true, then use the current value of `rsl` as a seed, otherwise construct one algorithmically (not randomly).",1,[[["self"],["bool"]]]],[11,"isaac64","","Refills the output buffer (`self.rsl`)",1,[[["self"]]]],[11,"clone","","",1,[[["self"]],["isaac64rng"]]],[11,"next_u32","","",1,[[["self"]],["u32"]]],[11,"next_u64","","",1,[[["self"]],["u64"]]],[11,"reseed","","",1,N],[11,"from_seed","","Create an ISAAC random number generator with a seed. This can be any length, although the maximum number of elements used is 256 and any more will be silently ignored. A generator constructed with a given seed will generate the same sequence of values as all other generators constructed with that seed.",1,N],[11,"rand","","",1,[[["r"]],["isaac64rng"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[0,"xorshift","rand::prng","Xorshift generators",N,N],[3,"XorShiftRng","rand::prng::xorshift","An Xorshift[1] random number generator.",N,N],[12,"x","","",3,N],[12,"y","","",3,N],[12,"z","","",3,N],[12,"w","","",3,N],[11,"clone","rand","",3,[[["self"]],["xorshiftrng"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"new_unseeded","","Creates a new XorShiftRng instance which is not seeded.",3,[[],["xorshiftrng"]]],[11,"next_u32","","",3,[[["self"]],["u32"]]],[11,"reseed","","Reseed an XorShiftRng. This will panic if `seed` is entirely 0.",3,N],[11,"from_seed","","Create a new XorShiftRng. This will panic if `seed` is entirely 0.",3,N],[11,"rand","","",3,[[["r"]],["xorshiftrng"]]],[6,"ThreadRngInner","","",N,N],[17,"THREAD_RNG_RESEED_THRESHOLD","","",N,N],[8,"Rand","","A type that can be randomly generated using an `Rng`.",N,N],[10,"rand","","Generates a random instance of this type using the specified source of randomness.",39,[[["r"]],["self"]]],[8,"Rng","","A random number generator.",N,N],[10,"next_u32","","Return the next random u32.",40,[[["self"]],["u32"]]],[11,"next_u64","","Return the next random u64.",40,[[["self"]],["u64"]]],[11,"next_f32","","Return the next random f32 selected from the half-open interval `[0, 1)`.",40,[[["self"]],["f32"]]],[11,"next_f64","","Return the next random f64 selected from the half-open interval `[0, 1)`.",40,[[["self"]],["f64"]]],[11,"fill_bytes","","Fill `dest` with random data.",40,N],[11,"gen","","Return a random value of a `Rand` type.",40,[[["self"]],["t"]]],[11,"gen_iter","","Return an iterator that will yield an infinite number of randomly generated items.",40,[[["self"]],["generator"]]],[11,"gen_range","","Generate a random value in the range [`low`, `high`).",40,[[["self"],["t"],["t"]],["t"]]],[11,"gen_weighted_bool","","Return a bool with a 1 in n chance of true",40,[[["self"],["u32"]],["bool"]]],[11,"gen_ascii_chars","","Return an iterator of random characters from the set A-Z,a-z,0-9.",40,[[["self"]],["asciigenerator"]]],[11,"choose","","Return a random element from `values`.",40,N],[11,"choose_mut","","Return a mutable pointer to a random element from `values`.",40,N],[11,"shuffle","","Shuffle a mutable slice in place.",40,N],[8,"SeedableRng","","A random number generator that can be explicitly seeded to produce the same stream of randomness multiple times.",N,N],[10,"reseed","","Reseed an RNG with the given seed.",41,[[["self"],["seed"]]]],[10,"from_seed","","Create a new RNG with the given seed.",41,[[["seed"]],["self"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"next","","",4,[[["self"]],["option"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"next","","",5,[[["self"]],["option",["char"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["stdrng"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a randomly seeded instance of `StdRng`.",8,[[],["result",["stdrng"]]]],[11,"next_u32","","",8,[[["self"]],["u32"]]],[11,"next_u64","","",8,[[["self"]],["u64"]]],[11,"reseed","","",8,N],[11,"from_seed","","",8,N],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"reseed","","",42,[[["self"],["stdrng"]]]],[11,"clone","","",9,[[["self"]],["threadrng"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"next_u32","","",9,[[["self"]],["u32"]]],[11,"next_u64","","",9,[[["self"]],["u64"]]],[11,"fill_bytes","","",9,N]],"paths":[[3,"IsaacRng"],[3,"Isaac64Rng"],[3,"ChaChaRng"],[3,"XorShiftRng"],[3,"Generator"],[3,"AsciiGenerator"],[3,"Open01"],[3,"Closed01"],[3,"StdRng"],[3,"ThreadRng"],[3,"RandSample"],[3,"Weighted"],[3,"WeightedChoice"],[3,"Range"],[8,"SampleRange"],[3,"Gamma"],[3,"GammaSmallShape"],[3,"GammaLargeShape"],[3,"ChiSquared"],[3,"FisherF"],[3,"StudentT"],[4,"GammaRepr"],[4,"ChiSquaredRepr"],[3,"StandardNormal"],[3,"Normal"],[3,"LogNormal"],[3,"Exp1"],[3,"Exp"],[8,"Sample"],[8,"IndependentSample"],[3,"JitterRng"],[4,"TimerError"],[3,"OsRng"],[3,"OsRng"],[4,"OsRngInner"],[3,"ReadRng"],[3,"ReseedingRng"],[8,"Reseeder"],[3,"ReseedWithDefault"],[8,"Rand"],[8,"Rng"],[8,"SeedableRng"],[3,"ThreadRngReseeder"]]};
searchIndex["regex"]={"doc":"This crate provides a library for parsing, compiling, and executing regular expressions. Its syntax is similar to Perl-style regular expressions, but lacks a few features like look around and backreferences. In exchange, all searches execute in linear time with respect to the size of the regular expression and search text.","items":[[3,"RegexBuilder","regex","A configurable builder for a regular expression.",N,N],[12,"0","","",0,N],[3,"RegexSetBuilder","","A configurable builder for a set of regular expressions.",N,N],[12,"0","","",1,N],[3,"RegexSet","","Match multiple (possibly overlapping) regular expressions in a single scan.",N,N],[12,"0","","",2,N],[3,"SetMatches","","A set of matches returned by a regex set.",N,N],[12,"matched_any","","",3,N],[12,"matches","","",3,N],[3,"SetMatchesIntoIter","","An owned iterator over the set of matches from a regex set.",N,N],[12,"0","","",4,N],[3,"SetMatchesIter","","A borrowed iterator over the set of matches from a regex set.",N,N],[12,"0","","",5,N],[3,"Locations","","Locations represents the offsets of each capturing group in a regex for a single match.",N,N],[12,"0","","",6,N],[3,"Regex","","A compiled regular expression for matching Unicode strings.",N,N],[12,"0","","",7,N],[3,"Match","","Match represents a single match of a regex in a haystack.",N,N],[12,"text","","",8,N],[12,"start","","",8,N],[12,"end","","",8,N],[3,"Captures","","Captures represents a group of captured strings for a single match.",N,N],[12,"text","","",9,N],[12,"locs","","",9,N],[12,"named_groups","","",9,N],[3,"CaptureNames","","An iterator over the names of all possible captures.",N,N],[12,"0","","",10,N],[3,"Matches","","An iterator over all non-overlapping matches for a particular string.",N,N],[12,"0","","",11,N],[3,"CaptureMatches","","An iterator that yields all non-overlapping capture groups matching a particular regular expression.",N,N],[12,"0","","",12,N],[3,"SubCaptureMatches","","An iterator that yields all capturing matches in the order in which they appear in the regex.",N,N],[12,"caps","","",13,N],[12,"it","","",13,N],[3,"ReplacerRef","","By-reference adaptor for a `Replacer`",N,N],[12,"0","","",14,N],[3,"NoExpand","","`NoExpand` indicates literal string replacement.",N,N],[12,"0","","",15,N],[3,"Split","","Yields all substrings delimited by a regular expression match.",N,N],[12,"finder","","",16,N],[12,"last","","",16,N],[3,"SplitN","","Yields at most `N` substrings delimited by a regular expression match.",N,N],[12,"splits","","",17,N],[12,"n","","",17,N],[4,"Error","","An error that occurred during parsing or compiling a regular expression.",N,N],[13,"Syntax","","A syntax error.",18,N],[13,"CompiledTooBig","","The compiled program exceeded the set size limit. The argument is the size limit imposed.",18,N],[13,"__Nonexhaustive","","Hints that destructuring should not be exhaustive.",18,N],[5,"escape","","Escapes all regular expression meta characters in `text`.",N,[[["str"]],["string"]]],[0,"bytes","","Match regular expressions on arbitrary bytes.",N,N],[3,"RegexBuilder","regex::bytes","A configurable builder for a regular expression.",N,N],[12,"0","","",19,N],[3,"RegexSetBuilder","","A configurable builder for a set of regular expressions.",N,N],[12,"0","","",20,N],[3,"Match","","Match represents a single match of a regex in a haystack.",N,N],[12,"text","","",21,N],[12,"start","","",21,N],[12,"end","","",21,N],[3,"Regex","","A compiled regular expression for matching arbitrary bytes.",N,N],[12,"0","","",22,N],[3,"Matches","","An iterator over all non-overlapping matches for a particular string.",N,N],[12,"0","","",23,N],[3,"CaptureMatches","","An iterator that yields all non-overlapping capture groups matching a particular regular expression.",N,N],[12,"0","","",24,N],[3,"Split","","Yields all substrings delimited by a regular expression match.",N,N],[12,"finder","","",25,N],[12,"last","","",25,N],[3,"SplitN","","Yields at most `N` substrings delimited by a regular expression match.",N,N],[12,"splits","","",26,N],[12,"n","","",26,N],[3,"CaptureNames","","An iterator over the names of all possible captures.",N,N],[12,"0","","",27,N],[3,"Captures","","Captures represents a group of captured byte strings for a single match.",N,N],[12,"text","","",28,N],[12,"locs","","",28,N],[12,"named_groups","","",28,N],[3,"SubCaptureMatches","","An iterator that yields all capturing matches in the order in which they appear in the regex.",N,N],[12,"caps","","",29,N],[12,"it","","",29,N],[3,"ReplacerRef","","By-reference adaptor for a `Replacer`",N,N],[12,"0","","",30,N],[3,"NoExpand","","`NoExpand` indicates literal byte string replacement.",N,N],[12,"0","","",31,N],[3,"RegexSet","","Match multiple (possibly overlapping) regular expressions in a single scan.",N,N],[12,"0","","",32,N],[3,"SetMatches","","A set of matches returned by a regex set.",N,N],[12,"matched_any","","",33,N],[12,"matches","","",33,N],[3,"SetMatchesIntoIter","","An owned iterator over the set of matches from a regex set.",N,N],[12,"0","","",34,N],[3,"SetMatchesIter","","A borrowed iterator over the set of matches from a regex set.",N,N],[12,"0","","",35,N],[3,"Locations","","Locations represents the offsets of each capturing group in a regex for a single match.",N,N],[12,"0","","",6,N],[8,"Replacer","","Replacer describes types that can be used to replace matches in a byte string.",N,N],[10,"replace_append","","Appends text to `dst` to replace the current match.",36,[[["self"],["captures"],["vec"]]]],[11,"no_expansion","","Return a fixed unchanging replacement byte string.",36,[[["self"]],["option",["cow"]]]],[11,"by_ref","","Return a `Replacer` that borrows and wraps this `Replacer`.",36,[[["self"]],["replacerref"]]],[0,"backtrack","regex","",N,N],[3,"Bounded","regex::backtrack","A backtracking matching engine.",N,N],[12,"prog","","",37,N],[12,"input","","",37,N],[12,"matches","","",37,N],[12,"slots","","",37,N],[12,"m","","",37,N],[3,"Cache","","Shared cached state between multiple invocations of a backtracking engine in the same thread.",N,N],[12,"jobs","","",38,N],[12,"visited","","",38,N],[4,"Job","","A job is an explicit unit of stack space in the backtracking engine.",N,N],[13,"Inst","","",39,N],[12,"ip","regex::backtrack::Job","",39,N],[12,"at","","",39,N],[13,"SaveRestore","regex::backtrack","",39,N],[12,"slot","regex::backtrack::Job","",39,N],[12,"old_pos","","",39,N],[5,"should_exec","regex::backtrack","Returns true iff the given regex and input should be executed by this engine with reasonable memory usage.",N,[[["usize"],["usize"]],["bool"]]],[5,"usize_to_u32","","",N,[[["usize"]],["u32"]]],[6,"Bits","","",N,N],[17,"BIT_SIZE","","",N,N],[17,"MAX_SIZE_BYTES","","",N,N],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"clone","","",38,[[["self"]],["cache"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"new","","Create new empty cache for the backtracking engine.",38,[[["program"]],["self"]]],[11,"clone","","",39,[[["self"]],["job"]]],[11,"fmt","","",39,[[["self"],["formatter"]],["result"]]],[11,"exec","","Execute the backtracking matching engine.",37,N],[11,"clear","","Clears the cache such that the backtracking engine can be executed on some input of fixed length.",37,[[["self"]]]],[11,"exec_","","Start backtracking at the given position in the input, but also look for literal prefixes.",37,[[["self"],["inputat"]],["bool"]]],[11,"backtrack","","The main backtracking loop starting at the given input position.",37,[[["self"],["inputat"]],["bool"]]],[11,"step","","",37,[[["self"],["usize"],["inputat"]],["bool"]]],[11,"has_visited","","",37,[[["self"],["usize"],["inputat"]],["bool"]]],[0,"utf8","regex","",N,N],[5,"next_utf8","regex::utf8","Returns the smallest possible index of the next valid UTF-8 sequence starting after `i`.",N,N],[5,"encode_utf8","","Encode the given Unicode character to `dst` as a single UTF-8 sequence.",N,N],[5,"decode_utf8","","Decode a single UTF-8 sequence into a single Unicode codepoint from `src`.",N,N],[5,"decode_last_utf8","","Like `decode_utf8`, but decodes the last UTF-8 sequence in `src` instead of the first.",N,N],[5,"is_start_byte","","",N,[[["u8"]],["bool"]]],[17,"TAG_CONT","","",N,N],[17,"TAG_TWO","","",N,N],[17,"TAG_THREE","","",N,N],[17,"TAG_FOUR","","",N,N],[0,"compile","regex","",N,N],[3,"Patch","regex::compile","",N,N],[12,"hole","","",40,N],[12,"entry","","",40,N],[3,"Compiler","","A compiler translates a regular expression AST to a sequence of instructions. The sequence of instructions represents an NFA.",N,N],[12,"insts","","",41,N],[12,"compiled","","",41,N],[12,"capture_name_idx","","",41,N],[12,"num_exprs","","",41,N],[12,"size_limit","","",41,N],[12,"suffix_cache","","",41,N],[12,"utf8_seqs","","",41,N],[12,"byte_classes","","",41,N],[3,"CompileClass","","",N,N],[12,"c","","",42,N],[12,"ranges","","",42,N],[3,"SuffixCache","","`SuffixCache` is a simple bounded hash map for caching suffix entries in UTF-8 automata. For example, consider the Unicode range \\u{0}-\\u{FFFF}. The set of byte ranges looks like this:",N,N],[12,"table","","",43,N],[12,"version","","",43,N],[3,"SuffixCacheEntry","","",N,N],[12,"key","","",44,N],[12,"pc","","",44,N],[12,"version","","",44,N],[3,"SuffixCacheKey","","",N,N],[12,"from_inst","","",45,N],[12,"start","","",45,N],[12,"end","","",45,N],[3,"ByteClassSet","","",N,N],[12,"0","","",46,N],[4,"Hole","","",N,N],[13,"None","","",47,N],[13,"One","","",47,N],[13,"Many","","",47,N],[4,"MaybeInst","","",N,N],[13,"Compiled","","",48,N],[13,"Uncompiled","","",48,N],[13,"Split","","",48,N],[13,"Split1","","",48,N],[13,"Split2","","",48,N],[4,"InstHole","","",N,N],[13,"Save","","",49,N],[12,"slot","regex::compile::InstHole","",49,N],[13,"EmptyLook","regex::compile","",49,N],[12,"look","regex::compile::InstHole","",49,N],[13,"Char","regex::compile","",49,N],[12,"c","regex::compile::InstHole","",49,N],[13,"Ranges","regex::compile","",49,N],[12,"ranges","regex::compile::InstHole","",49,N],[13,"Bytes","regex::compile","",49,N],[12,"start","regex::compile::InstHole","",49,N],[12,"end","","",49,N],[5,"u32_to_usize","regex::compile","",N,[[["u32"]],["usize"]]],[6,"Result","","",N,N],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new regular expression compiler.",41,[[],["self"]]],[11,"size_limit","","The size of the resulting program is limited by size_limit. If the program approximately exceeds the given size (in bytes), then compilation will stop and return an error.",41,[[["self"],["usize"]],["self"]]],[11,"bytes","","If bytes is true, then the program is compiled as a byte based automaton, which incorporates UTF-8 decoding into the machine. If it's false, then the automaton is Unicode scalar value based, e.g., an engine utilizing such an automaton is resposible for UTF-8 decoding.",41,[[["self"],["bool"]],["self"]]],[11,"only_utf8","","When disabled, the program compiled may match arbitrary bytes.",41,[[["self"],["bool"]],["self"]]],[11,"dfa","","When set, the machine returned is suitable for use in the DFA matching engine.",41,[[["self"],["bool"]],["self"]]],[11,"reverse","","When set, the machine returned is suitable for matching text in reverse. In particular, all concatenations are flipped.",41,[[["self"],["bool"]],["self"]]],[11,"compile","","Compile a regular expression given its AST.",41,N],[11,"compile_one","","",41,[[["self"],["hir"]],["result",["program","error"]]]],[11,"compile_many","","",41,N],[11,"compile_finish","","",41,[[["self"]],["result",["program","error"]]]],[11,"c","","Compile expr into self.insts, returning a patch on success, or an error if we run out of memory.",41,[[["self"],["hir"]],["result",["patch","error"]]]],[11,"c_capture","","",41,[[["self"],["usize"],["hir"]],["result",["patch","error"]]]],[11,"c_dotstar","","",41,[[["self"]],["result",["patch","error"]]]],[11,"c_literal","","",41,N],[11,"c_char","","",41,[[["self"],["char"]],["result",["patch","error"]]]],[11,"c_class","","",41,N],[11,"c_bytes","","",41,N],[11,"c_byte","","",41,[[["self"],["u8"]],["result",["patch","error"]]]],[11,"c_class_bytes","","",41,N],[11,"c_empty_look","","",41,[[["self"],["emptylook"]],["result",["patch","error"]]]],[11,"c_concat","","",41,[[["self"],["i"]],["result",["patch","error"]]]],[11,"c_alternate","","",41,N],[11,"c_repeat","","",41,[[["self"],["repetition"]],["result",["patch","error"]]]],[11,"c_repeat_zero_or_one","","",41,[[["self"],["hir"],["bool"]],["result",["patch","error"]]]],[11,"c_repeat_zero_or_more","","",41,[[["self"],["hir"],["bool"]],["result",["patch","error"]]]],[11,"c_repeat_one_or_more","","",41,[[["self"],["hir"],["bool"]],["result",["patch","error"]]]],[11,"c_repeat_range_min_or_more","","",41,[[["self"],["hir"],["bool"],["u32"]],["result",["patch","error"]]]],[11,"c_repeat_range","","",41,[[["self"],["hir"],["bool"],["u32"],["u32"]],["result",["patch","error"]]]],[11,"fill","","",41,[[["self"],["hole"],["usize"]]]],[11,"fill_to_next","","",41,[[["self"],["hole"]]]],[11,"fill_split","","",41,[[["self"],["hole"],["option",["usize"]],["option",["usize"]]],["hole"]]],[11,"push_compiled","","",41,[[["self"],["inst"]]]],[11,"push_hole","","",41,[[["self"],["insthole"]],["hole"]]],[11,"push_split_hole","","",41,[[["self"]],["hole"]]],[11,"check_size","","",41,[[["self"]],["result",["error"]]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"clone","","",48,[[["self"]],["maybeinst"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"fill","","",48,[[["self"],["usize"]]]],[11,"fill_split","","",48,[[["self"],["usize"],["usize"]]]],[11,"half_fill_split_goto1","","",48,[[["self"],["usize"]]]],[11,"half_fill_split_goto2","","",48,[[["self"],["usize"]]]],[11,"unwrap","","",48,[[["self"]],["inst"]]],[11,"clone","","",49,[[["self"]],["insthole"]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"fill","","",49,[[["self"],["usize"]],["inst"]]],[11,"compile","","",42,[[["self"]],["result",["patch","error"]]]],[11,"c_utf8_seq","","",42,[[["self"],["utf8sequence"]],["result",["patch","error"]]]],[11,"c_utf8_seq_","","",42,[[["self"],["i"]],["result",["patch","error"]]]],[11,"clone","","",44,[[["self"]],["suffixcacheentry"]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"default","","",44,[[],["suffixcacheentry"]]],[11,"assert_receiver_is_total_eq","","",44,N],[11,"hash","","",44,N],[11,"eq","","",44,[[["self"],["suffixcacheentry"]],["bool"]]],[11,"ne","","",44,[[["self"],["suffixcacheentry"]],["bool"]]],[11,"clone","","",45,[[["self"]],["suffixcachekey"]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"default","","",45,[[],["suffixcachekey"]]],[11,"assert_receiver_is_total_eq","","",45,N],[11,"hash","","",45,N],[11,"eq","","",45,[[["self"],["suffixcachekey"]],["bool"]]],[11,"ne","","",45,[[["self"],["suffixcachekey"]],["bool"]]],[11,"new","","",43,[[["usize"]],["self"]]],[11,"get","","",43,[[["self"],["suffixcachekey"],["usize"]],["option",["usize"]]]],[11,"clear","","",43,[[["self"]]]],[11,"hash","","",43,[[["self"],["suffixcachekey"]],["usize"]]],[11,"new","","",46,[[],["self"]]],[11,"set_range","","",46,[[["self"],["u8"],["u8"]]]],[11,"set_word_boundary","","",46,[[["self"]]]],[11,"byte_classes","","",46,[[["self"]],["vec",["u8"]]]],[0,"dfa","regex","The DFA matching engine.",N,N],[3,"Cache","regex::dfa","A reusable cache of DFA states.",N,N],[12,"inner","","Group persistent DFA related cache state together. The sparse sets listed below are used as scratch space while computing uncached states.",50,N],[12,"qcur","","qcur and qnext are ordered sets with constant time addition/membership/clearing-whole-set and linear time iteration. They are used to manage the sets of NFA states in DFA states when computing cached DFA states. In particular, the order of the NFA states matters for leftmost-first style matching. Namely, when computing a cached state, the set of NFA states stops growing as soon as the first Match instruction is observed.",50,N],[12,"qnext","","",50,N],[3,"CacheInner","","`CacheInner` is logically just a part of Cache, but groups together fields that aren't passed as function parameters throughout search. (This split is mostly an artifact of the borrow checker. It is happily paid.)",N,N],[12,"compiled","","A cache of pre-compiled DFA states, keyed by the set of NFA states and the set of empty-width flags set at the byte in the input when the state was observed.",51,N],[12,"trans","","The transition table.",51,N],[12,"states","","Our set of states. Note that `StatePtr / num_byte_classes` indexes this Vec rather than just a `StatePtr`.",51,N],[12,"start_states","","A set of cached start states, which are limited to the number of permutations of flags set just before the initial byte of input. (The index into this vec is a `EmptyFlags`.)",51,N],[12,"stack","","Stack scratch space used to follow epsilon transitions in the NFA. (This permits us to avoid recursion.)",51,N],[12,"flush_count","","The total number of times this cache has been flushed by the DFA because of space constraints.",51,N],[12,"size","","The total heap size of the DFA's cache. We use this to determine when we should flush the cache.",51,N],[3,"Transitions","","The transition table.",N,N],[12,"table","","The table.",52,N],[12,"num_byte_classes","","The stride.",52,N],[3,"Fsm","","Fsm encapsulates the actual execution of the DFA.",N,N],[12,"prog","","prog contains the NFA instruction opcodes. DFA execution uses either the `dfa` instructions or the `dfa_reverse` instructions from `exec::ExecReadOnly`. (It never uses `ExecReadOnly.nfa`, which may have Unicode opcodes that cannot be executed by the DFA.)",53,N],[12,"start","","The start state. We record it here because the pointer may change when the cache is wiped.",53,N],[12,"at","","The current position in the input.",53,N],[12,"quit_after_match","","Should we quit after seeing the first match? e.g., When the caller uses `is_match` or `shortest_match`.",53,N],[12,"last_match_si","","The last state that matched.",53,N],[12,"last_cache_flush","","The input position of the last cache flush. We use this to determine if we're thrashing in the cache too often. If so, the DFA quits so that we can fall back to the NFA algorithm.",53,N],[12,"cache","","All cached DFA information that is persisted between searches.",53,N],[3,"State","","`State` is a DFA state. It contains an ordered set of NFA states (not necessarily complete) and a smattering of flags.",N,N],[12,"data","","",54,N],[3,"InstPtrs","","",N,N],[12,"base","","",55,N],[12,"data","","",55,N],[3,"Byte","","Byte is a u8 in spirit, but a u16 in practice so that we can represent the special EOF sentinel value.",N,N],[12,"0","","",56,N],[3,"EmptyFlags","","A set of flags for zero-width assertions.",N,N],[12,"start","","",57,N],[12,"end","","",57,N],[12,"start_line","","",57,N],[12,"end_line","","",57,N],[12,"word_boundary","","",57,N],[12,"not_word_boundary","","",57,N],[3,"StateFlags","","A set of flags describing various configurations of a DFA state. This is represented by a `u8` so that it is compact.",N,N],[12,"0","","",58,N],[3,"TransitionsRow","","",N,N],[12,"0","","",59,N],[4,"Result","","The result of running the DFA.",N,N],[13,"Match","","",60,N],[13,"NoMatch","","",60,N],[13,"Quit","","",60,N],[5,"can_exec","","Return true if and only if the given program can be executed by a DFA.",N,[[["program"]],["bool"]]],[5,"push_inst_ptr","","Adds ip to data using delta encoding with respect to prev.",N,[[["vec"],["u32"],["u32"]]]],[5,"vb","","Helper function for formatting a byte as a nice-to-read escaped string.",N,[[["usize"]],["string"]]],[5,"usize_to_u32","","",N,[[["usize"]],["u32"]]],[5,"show_state_ptr","","",N,[[["u32"]],["string"]]],[5,"write_vari32","","https://developers.google.com/protocol-buffers/docs/encoding#varints",N,[[["vec"],["i32"]]]],[5,"read_vari32","","https://developers.google.com/protocol-buffers/docs/encoding#varints",N,N],[5,"write_varu32","","https://developers.google.com/protocol-buffers/docs/encoding#varints",N,[[["vec"],["u32"]]]],[5,"read_varu32","","https://developers.google.com/protocol-buffers/docs/encoding#varints",N,N],[6,"InstPtr","","`InstPtr` is a 32 bit pointer into a sequence of opcodes (i.e., it indexes an NFA state).",N,N],[6,"StatePtr","","`StatePtr` is a 32 bit pointer to the start of a row in the transition table.",N,N],[17,"STATE_UNKNOWN","","An unknown state means that the state has not been computed yet, and that the only way to progress is to compute it.",N,N],[17,"STATE_DEAD","","A dead state means that the state has been computed and it is known that once it is entered, no future match can ever occur.",N,N],[17,"STATE_QUIT","","A quit state means that the DFA came across some input that it doesn't know how to process correctly. The DFA should quit and another matching engine should be run in its place.",N,N],[17,"STATE_START","","A start state is a state that the DFA can start in.",N,N],[17,"STATE_MATCH","","A match state means that the regex has successfully matched.",N,N],[17,"STATE_MAX","","The maximum state pointer. This is useful to mask out the \"valid\" state pointer from a state with the \"start\" or \"match\" bits set.",N,N],[11,"clone","","",50,[[["self"]],["cache"]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"clone","","",51,[[["self"]],["cacheinner"]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"clone","","",52,[[["self"]],["transitions"]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"clone","","",60,[[["self"]],["result"]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"is_match","","Returns true if this result corresponds to a match.",60,[[["self"]],["bool"]]],[11,"map","","Maps the given function onto T and returns the result.",60,[[["self"],["f"]],["result"]]],[11,"set_non_match","","Sets the non-match position.",60,[[["self"],["usize"]],["result"]]],[11,"clone","","",54,[[["self"]],["state"]]],[11,"assert_receiver_is_total_eq","","",54,N],[11,"hash","","",54,N],[11,"eq","","",54,[[["self"],["state"]],["bool"]]],[11,"ne","","",54,[[["self"],["state"]],["bool"]]],[11,"next","","",55,[[["self"]],["option",["usize"]]]],[11,"flags","","",54,[[["self"]],["stateflags"]]],[11,"inst_ptrs","","",54,[[["self"]],["instptrs"]]],[11,"clone","","",56,[[["self"]],["byte"]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"clone","","",57,[[["self"]],["emptyflags"]]],[11,"assert_receiver_is_total_eq","","",57,N],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"default","","",57,[[],["emptyflags"]]],[11,"hash","","",57,N],[11,"eq","","",57,[[["self"],["emptyflags"]],["bool"]]],[11,"ne","","",57,[[["self"],["emptyflags"]],["bool"]]],[11,"clone","","",58,[[["self"]],["stateflags"]]],[11,"assert_receiver_is_total_eq","","",58,N],[11,"default","","",58,[[],["stateflags"]]],[11,"hash","","",58,N],[11,"eq","","",58,[[["self"],["stateflags"]],["bool"]]],[11,"ne","","",58,[[["self"],["stateflags"]],["bool"]]],[11,"new","","Create new empty cache for the DFA engine.",50,[[["program"]],["self"]]],[11,"reset_size","","Resets the cache size to account for fixed costs, such as the program and stack sizes.",51,[[["self"]]]],[11,"forward","","",53,N],[11,"reverse","","",53,N],[11,"forward_many","","",53,N],[11,"exec_at","","Executes the DFA on a forward NFA.",53,N],[11,"exec_at_reverse","","Executes the DFA on a reverse NFA.",53,N],[11,"next_si","","next_si transitions to the next state, where the transition input corresponds to text[i].",53,N],[11,"exec_byte","","Computes the next state given the current state and the current input byte (which may be EOF).",53,[[["self"],["sparseset"],["sparseset"],["u32"],["byte"]],["option",["u32"]]]],[11,"follow_epsilons","","Follows the epsilon transitions starting at (and including) `ip`. The resulting states are inserted into the ordered set `q`.",53,[[["self"],["u32"],["sparseset"],["emptyflags"]]]],[11,"cached_state","","Find a previously computed state matching the given set of instructions and is_match bool.",53,[[["self"],["sparseset"],["stateflags"],["option",["u32"]]],["option",["u32"]]]],[11,"cached_state_key","","Produces a key suitable for describing a state in the DFA cache.",53,[[["self"],["sparseset"],["stateflags"]],["option",["state"]]]],[11,"clear_cache_and_save","","Clears the cache, but saves and restores current_state if it is not none.",53,[[["self"],["option",["u32"]]],["bool"]]],[11,"clear_cache","","Wipes the state cache, but saves and restores the current start state.",53,[[["self"]],["bool"]]],[11,"restore_state","","Restores the given state back into the cache, and returns a pointer to it.",53,[[["self"],["state"]],["option",["u32"]]]],[11,"next_state","","Returns the next state given the current state si and current byte b. {qcur,qnext} are used as scratch space for storing ordered NFA states.",53,[[["self"],["sparseset"],["sparseset"],["u32"],["byte"]],["option",["u32"]]]],[11,"start_state","","Computes and returns the start state, where searching begins at position `at` in `text`. If the state has already been computed, then it is pulled from the cache. If the state hasn't been cached, then it is computed, cached and a pointer to it is returned.",53,[[["self"],["sparseset"],["emptyflags"],["stateflags"]],["option",["u32"]]]],[11,"start_flags","","Computes the set of starting flags for the given position in text.",53,N],[11,"start_flags_reverse","","Computes the set of starting flags for the given position in text.",53,N],[11,"state","","Returns a reference to a State given a pointer to it.",53,[[["self"],["u32"]],["state"]]],[11,"add_state","","Adds the given state to the DFA.",53,[[["self"],["state"]],["option",["u32"]]]],[11,"prefix_at","","Quickly finds the next occurrence of any literal prefixes in the regex. If there are no literal prefixes, then the current position is returned. If there are literal prefixes and one could not be found, then None is returned.",53,N],[11,"num_byte_classes","","Returns the number of byte classes required to discriminate transitions in each state.",53,[[["self"]],["usize"]]],[11,"byte_class","","Given an input byte or the special EOF sentinel, return its corresponding byte class.",53,[[["self"],["byte"]],["usize"]]],[11,"u8_class","","Like byte_class, but explicitly for u8s.",53,[[["self"],["u8"]],["usize"]]],[11,"continue_past_first_match","","Returns true if the DFA should continue searching past the first match.",53,[[["self"]],["bool"]]],[11,"has_prefix","","Returns true if there is a prefix we can quickly search for.",53,[[["self"]],["bool"]]],[11,"start_ptr","","Sets the STATE_START bit in the given state pointer if and only if we have a prefix to scan for.",53,[[["self"],["u32"]],["u32"]]],[11,"approximate_size","","Approximate size returns the approximate heap space currently used by the DFA. It is used to determine whether the DFA's state cache needs to be wiped. Namely, it is possible that for certain regexes on certain inputs, a new state could be created for every byte of input. (This is bad for memory use, so we bound it with a cache.)",53,[[["self"]],["usize"]]],[11,"new","","Create a new transition table.",52,[[["usize"]],["transitions"]]],[11,"num_states","","Returns the total number of states currently in this table.",52,[[["self"]],["usize"]]],[11,"add","","Allocates room for one additional state and returns a pointer to it.",52,[[["self"]],["option",["u32"]]]],[11,"clear","","Clears the table of all states.",52,[[["self"]]]],[11,"set_next","","Sets the transition from (si, cls) to next.",52,[[["self"],["u32"],["usize"],["u32"]]]],[11,"next","","Returns the transition corresponding to (si, cls).",52,[[["self"],["u32"],["usize"]],["u32"]]],[11,"state_heap_size","","The heap size, in bytes, of a single state in the transition table.",52,[[["self"]],["usize"]]],[11,"next_unchecked","","Like `next`, but uses unchecked access and is therefore unsafe.",52,[[["self"],["u32"],["usize"]],["u32"]]],[11,"is_match","","",58,[[["self"]],["bool"]]],[11,"set_match","","",58,[[["self"]]]],[11,"is_word","","",58,[[["self"]],["bool"]]],[11,"set_word","","",58,[[["self"]]]],[11,"has_empty","","",58,[[["self"]],["bool"]]],[11,"set_empty","","",58,[[["self"]]]],[11,"byte","","",56,[[["u8"]],["self"]]],[11,"eof","","",56,[[],["self"]]],[11,"is_eof","","",56,[[["self"]],["bool"]]],[11,"is_ascii_word","","",56,[[["self"]],["bool"]]],[11,"as_byte","","",56,[[["self"]],["option",["u8"]]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[0,"error","regex","",N,N],[4,"Error","regex::error","An error that occurred during parsing or compiling a regular expression.",N,N],[13,"Syntax","","A syntax error.",18,N],[13,"CompiledTooBig","","The compiled program exceeded the set size limit. The argument is the size limit imposed.",18,N],[13,"__Nonexhaustive","","Hints that destructuring should not be exhaustive.",18,N],[11,"clone","regex","",18,[[["self"]],["error"]]],[11,"eq","","",18,[[["self"],["error"]],["bool"]]],[11,"ne","","",18,[[["self"],["error"]],["bool"]]],[11,"description","","",18,[[["self"]],["str"]]],[11,"cause","","",18,[[["self"]],["option",["error"]]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"from","","",18,[[["error"]],["error"]]],[0,"exec","","",N,N],[3,"Exec","regex::exec","`Exec` manages the execution of a regular expression.",N,N],[12,"ro","","All read only state.",61,N],[12,"cache","","Caches for the various matching engines.",61,N],[3,"ExecNoSync","","`ExecNoSync` is like `Exec`, except it embeds a reference to a cache. This means it is no longer Sync, but we can now avoid the overhead of synchronization to fetch the cache.",N,N],[12,"ro","","All read only state.",62,N],[12,"cache","","Caches for the various matching engines.",62,N],[3,"ExecNoSyncStr","","`ExecNoSyncStr` is like `ExecNoSync`, but matches on &str instead of &[u8].",N,N],[12,"0","","",63,N],[3,"ExecReadOnly","","`ExecReadOnly` comprises all read only state for a regex. Namely, all such state is determined at compile time and never changes during search.",N,N],[12,"res","","The original regular expressions given by the caller to compile.",64,N],[12,"nfa","","A compiled program that is used in the NFA simulation and backtracking. It can be byte-based or Unicode codepoint based.",64,N],[12,"dfa","","A compiled byte based program for DFA execution. This is only used if a DFA can be executed. (Currently, only word boundary assertions are not supported.) Note that this program contains an embedded `.*?` preceding the first capture group, unless the regex is anchored at the beginning.",64,N],[12,"dfa_reverse","","The same as above, except the program is reversed (and there is no preceding `.*?`). This is used by the DFA to find the starting location of matches.",64,N],[12,"suffixes","","A set of suffix literals extracted from the regex.",64,N],[12,"match_type","","match_type encodes as much upfront knowledge about how we're going to execute a search as possible.",64,N],[3,"ExecBuilder","","Facilitates the construction of an executor by exposing various knobs to control how a regex is executed and what kinds of resources it's permitted to use.",N,N],[12,"options","","",65,N],[12,"match_type","","",65,N],[12,"bytes","","",65,N],[12,"only_utf8","","",65,N],[3,"Parsed","","Parsed represents a set of parsed regular expressions and their detected literals.",N,N],[12,"exprs","","",66,N],[12,"prefixes","","",66,N],[12,"suffixes","","",66,N],[12,"bytes","","",66,N],[3,"ProgramCacheInner","","",N,N],[12,"pikevm","","",67,N],[12,"backtrack","","",67,N],[12,"dfa","","",67,N],[12,"dfa_reverse","","",67,N],[4,"MatchType","","",N,N],[13,"Literal","","A single or multiple literal search. This is only used when the regex can be decomposed into unambiguous literal search.",68,N],[13,"Dfa","","A normal DFA search.",68,N],[13,"DfaAnchoredReverse","","A reverse DFA search starting from the end of a haystack.",68,N],[13,"DfaSuffix","","A reverse DFA search with suffix literal scanning.",68,N],[13,"DfaMany","","Use the DFA on two or more regular expressions.",68,N],[13,"Nfa","","An NFA variant.",68,N],[13,"Nothing","","No match is ever possible, so don't ever try to search.",68,N],[4,"MatchLiteralType","","",N,N],[13,"Unanchored","","Match literals anywhere in text.",69,N],[13,"AnchoredStart","","Match literals only at the start of text.",69,N],[13,"AnchoredEnd","","Match literals only at the end of text.",69,N],[4,"MatchNfaType","","",N,N],[13,"Auto","","Choose between Backtrack and PikeVM.",70,N],[13,"Backtrack","","NFA bounded backtracking.",70,N],[13,"PikeVM","","The Pike VM.",70,N],[6,"ProgramCache","","`ProgramCache` maintains reusable allocations for each matching engine available to a particular program.",N,N],[11,"fmt","","",62,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",64,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a regex execution builder.",65,[[["str"]],["self"]]],[11,"new_many","","Like new, but compiles the union of the given regular expressions.",65,[[["i"]],["self"]]],[11,"new_options","","Create a regex execution builder.",65,[[["regexoptions"]],["self"]]],[11,"automatic","","Set the matching engine to be automatically determined.",65,[[["self"]],["self"]]],[11,"nfa","","Sets the matching engine to use the NFA algorithm no matter what optimizations are possible.",65,[[["self"]],["self"]]],[11,"bounded_backtracking","","Sets the matching engine to use a bounded backtracking engine no matter what optimizations are possible.",65,[[["self"]],["self"]]],[11,"bytes","","Compiles byte based programs for use with the NFA matching engines.",65,[[["self"],["bool"]],["self"]]],[11,"only_utf8","","When disabled, the program compiled may match arbitrary bytes.",65,[[["self"],["bool"]],["self"]]],[11,"unicode","","Set the Unicode flag.",65,[[["self"],["bool"]],["self"]]],[11,"parse","","Parse the current set of patterns into their AST and extract literals.",65,[[["self"]],["result",["parsed","error"]]]],[11,"build","","Build an executor that can run a regular expression.",65,[[["self"]],["result",["exec","error"]]]],[11,"slots_len","","",63,[[["self"]],["usize"]]],[11,"next_after_empty","","",63,[[["self"],["str"],["usize"]],["usize"]]],[11,"shortest_match_at","","",63,[[["self"],["str"],["usize"]],["option",["usize"]]]],[11,"is_match_at","","",63,[[["self"],["str"],["usize"]],["bool"]]],[11,"find_at","","",63,[[["self"],["str"],["usize"]],["option"]]],[11,"read_captures_at","","",63,[[["self"],["locations"],["str"],["usize"]],["option"]]],[11,"slots_len","","Returns the number of capture slots in the regular expression. (There are two slots for every capture group, corresponding to possibly empty start and end locations of the capture.)",62,[[["self"]],["usize"]]],[11,"next_after_empty","","",62,N],[11,"shortest_match_at","","Returns the end of a match location, possibly occurring before the end location of the correct leftmost-first match.",62,N],[11,"is_match_at","","Returns true if and only if the regex matches text.",62,N],[11,"find_at","","Finds the start and end location of the leftmost-first match, starting at the given location.",62,N],[11,"read_captures_at","","Finds the start and end location of the leftmost-first match and also fills in all matching capture groups.",62,N],[11,"find_literals","","Finds the leftmost-first match using only literal search.",62,N],[11,"find_dfa_forward","","Finds the leftmost-first match (start and end) using only the DFA.",62,N],[11,"find_dfa_anchored_reverse","","Finds the leftmost-first match (start and end) using only the DFA, but assumes the regex is anchored at the end and therefore starts at the end of the regex and matches in reverse.",62,N],[11,"shortest_dfa","","Finds the end of the shortest match using only the DFA.",62,N],[11,"shortest_dfa_reverse_suffix","","Finds the end of the shortest match using only the DFA by scanning for suffix literals.",62,N],[11,"exec_dfa_reverse_suffix","","Finds the end of the shortest match using only the DFA by scanning for suffix literals. It also reports the start of the match.",62,N],[11,"find_dfa_reverse_suffix","","Finds the leftmost-first match (start and end) using only the DFA by scanning for suffix literals.",62,N],[11,"match_nfa","","Executes the NFA engine to return whether there is a match or not.",62,N],[11,"match_nfa_type","","Like match_nfa, but allows specification of the type of NFA engine.",62,N],[11,"shortest_nfa","","Finds the shortest match using an NFA.",62,N],[11,"shortest_nfa_type","","Like shortest_nfa, but allows specification of the type of NFA engine.",62,N],[11,"find_nfa","","Like find, but executes an NFA engine.",62,N],[11,"captures_nfa_with_match","","Like find_nfa, but fills in captures and restricts the search space using previously found match information.",62,N],[11,"captures_nfa","","Like find_nfa, but fills in captures.",62,N],[11,"captures_nfa_type","","Like captures_nfa, but allows specification of type of NFA engine.",62,N],[11,"exec_nfa","","",62,N],[11,"exec_pikevm","","Always run the NFA algorithm.",62,N],[11,"exec_backtrack","","Always runs the NFA using bounded backtracking.",62,N],[11,"many_matches_at","","Finds which regular expressions match the given text.",62,N],[11,"is_anchor_end_match","","",62,N],[11,"capture_name_idx","","",62,[[["self"]],["arc"]]],[11,"capture_name_idx","","",63,[[["self"]],["arc"]]],[11,"searcher","","Get a searcher that isn't Sync.",61,[[["self"]],["execnosync"]]],[11,"searcher_str","","Get a searcher that isn't Sync and can match on &str.",61,[[["self"]],["execnosyncstr"]]],[11,"into_regex","","Build a Regex from this executor.",61,[[["self"]],["regex"]]],[11,"into_regex_set","","Build a RegexSet from this executor.",61,[[["self"]],["regexset"]]],[11,"into_byte_regex","","Build a Regex from this executor that can match arbitrary bytes.",61,[[["self"]],["regex"]]],[11,"into_byte_regex_set","","Build a RegexSet from this executor that can match arbitrary bytes.",61,[[["self"]],["regexset"]]],[11,"regex_strings","","The original regular expressions given by the caller that were compiled.",61,N],[11,"capture_names","","Return a slice of capture names.",61,N],[11,"capture_name_idx","","Return a reference to named groups mapping (from group name to group position).",61,[[["self"]],["arc"]]],[11,"clone","","",61,[[["self"]],["exec"]]],[11,"choose_match_type","","",64,[[["self"],["option",["matchtype"]]],["matchtype"]]],[11,"should_suffix_scan","","Returns true if the program is amenable to suffix scanning.",64,[[["self"]],["bool"]]],[11,"clone","","",68,[[["self"]],["matchtype"]]],[11,"fmt","","",68,[[["self"],["formatter"]],["result"]]],[11,"clone","","",69,[[["self"]],["matchliteraltype"]]],[11,"fmt","","",69,[[["self"],["formatter"]],["result"]]],[11,"clone","","",70,[[["self"]],["matchnfatype"]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"clone","","",67,[[["self"]],["programcacheinner"]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"new","","",67,[[["execreadonly"]],["self"]]],[0,"expand","regex","",N,N],[3,"CaptureRef","regex::expand","`CaptureRef` represents a reference to a capture group inside some text. The reference is either a capture group name or a number.",N,N],[12,"cap","","",71,N],[12,"end","","",71,N],[4,"Ref","","A reference to a capture group in some text.",N,N],[13,"Named","","",72,N],[13,"Number","","",72,N],[5,"expand_str","","",N,[[["captures"],["str"],["string"]]]],[5,"expand_bytes","","",N,N],[5,"find_cap_ref","","Parses a possible reference to a capture group name in the given text, starting at the beginning of `replacement`.",N,[[["t"]],["option",["captureref"]]]],[5,"is_valid_cap_letter","","Returns true if and only if the given byte is allowed in a capture name.",N,[[["u8"]],["bool"]]],[11,"clone","","",71,[[["self"]],["captureref"]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",71,N],[11,"eq","","",71,[[["self"],["captureref"]],["bool"]]],[11,"ne","","",71,[[["self"],["captureref"]],["bool"]]],[11,"clone","","",72,[[["self"]],["ref"]]],[11,"fmt","","",72,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",72,N],[11,"eq","","",72,[[["self"],["ref"]],["bool"]]],[11,"ne","","",72,[[["self"],["ref"]],["bool"]]],[11,"from","","",72,[[["str"]],["ref"]]],[11,"from","","",72,[[["usize"]],["ref"]]],[0,"freqs","regex","",N,N],[17,"BYTE_FREQUENCIES","regex::freqs","",N,N],[0,"input","regex","",N,N],[3,"InputAt","regex::input","Represents a location in the input.",N,N],[12,"pos","","",73,N],[12,"c","","",73,N],[12,"byte","","",73,N],[12,"len","","",73,N],[3,"CharInput","","An input reader over characters.",N,N],[12,"0","","",74,N],[3,"ByteInput","","An input reader over bytes.",N,N],[12,"text","","",75,N],[12,"only_utf8","","",75,N],[3,"Char","","An inline representation of `Option<char>`.",N,N],[12,"0","","",76,N],[8,"Input","","An abstraction over input used in the matching engines.",N,N],[10,"at","","Return an encoding of the position at byte offset `i`.",77,[[["self"],["usize"]],["inputat"]]],[10,"next_char","","Return the Unicode character occurring next to `at`.",77,[[["self"],["inputat"]],["char"]]],[10,"previous_char","","Return the Unicode character occurring previous to `at`.",77,[[["self"],["inputat"]],["char"]]],[10,"is_empty_match","","Return true if the given empty width instruction matches at the input position given.",77,[[["self"],["inputat"],["instemptylook"]],["bool"]]],[10,"prefix_at","","Scan the input for a matching prefix.",77,[[["self"],["literalsearcher"],["inputat"]],["option",["inputat"]]]],[10,"len","","The number of bytes in the input.",77,[[["self"]],["usize"]]],[11,"is_empty","","Whether the input is empty.",77,[[["self"]],["bool"]]],[10,"as_bytes","","Return the given input as a sequence of bytes.",77,N],[11,"clone","","",73,[[["self"]],["inputat"]]],[11,"fmt","","",73,[[["self"],["formatter"]],["result"]]],[11,"is_start","","Returns true iff this position is at the beginning of the input.",73,[[["self"]],["bool"]]],[11,"is_end","","Returns true iff this position is past the end of the input.",73,[[["self"]],["bool"]]],[11,"char","","Returns the character at this position.",73,[[["self"]],["char"]]],[11,"byte","","Returns the byte at this position.",73,[[["self"]],["option",["u8"]]]],[11,"len","","Returns the UTF-8 width of the character at this position.",73,[[["self"]],["usize"]]],[11,"is_empty","","Returns whether the UTF-8 width of the character at this position is zero.",73,[[["self"]],["bool"]]],[11,"pos","","Returns the byte offset of this position.",73,[[["self"]],["usize"]]],[11,"next_pos","","Returns the byte offset of the next position in the input.",73,[[["self"]],["usize"]]],[11,"clone","","",74,[[["self"]],["charinput"]]],[11,"fmt","","",74,[[["self"],["formatter"]],["result"]]],[11,"new","","Return a new character input reader for the given string.",74,N],[11,"deref","","",74,N],[11,"at","","",74,[[["self"],["usize"]],["inputat"]]],[11,"next_char","","",74,[[["self"],["inputat"]],["char"]]],[11,"previous_char","","",74,[[["self"],["inputat"]],["char"]]],[11,"is_empty_match","","",74,[[["self"],["inputat"],["instemptylook"]],["bool"]]],[11,"prefix_at","","",74,[[["self"],["literalsearcher"],["inputat"]],["option",["inputat"]]]],[11,"len","","",74,[[["self"]],["usize"]]],[11,"as_bytes","","",74,N],[11,"clone","","",75,[[["self"]],["byteinput"]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"new","","Return a new byte-based input reader for the given string.",75,N],[11,"deref","","",75,N],[11,"at","","",75,[[["self"],["usize"]],["inputat"]]],[11,"next_char","","",75,[[["self"],["inputat"]],["char"]]],[11,"previous_char","","",75,[[["self"],["inputat"]],["char"]]],[11,"is_empty_match","","",75,[[["self"],["inputat"],["instemptylook"]],["bool"]]],[11,"prefix_at","","",75,[[["self"],["literalsearcher"],["inputat"]],["option",["inputat"]]]],[11,"len","","",75,[[["self"]],["usize"]]],[11,"as_bytes","","",75,N],[11,"clone","","",76,[[["self"]],["char"]]],[11,"hash","","",76,N],[11,"eq","","",76,[[["self"],["char"]],["bool"]]],[11,"ne","","",76,[[["self"],["char"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",76,N],[11,"partial_cmp","","",76,[[["self"],["char"]],["option",["ordering"]]]],[11,"lt","","",76,[[["self"],["char"]],["bool"]]],[11,"le","","",76,[[["self"],["char"]],["bool"]]],[11,"gt","","",76,[[["self"],["char"]],["bool"]]],[11,"ge","","",76,[[["self"],["char"]],["bool"]]],[11,"cmp","","",76,[[["self"],["char"]],["ordering"]]],[11,"fmt","","",76,[[["self"],["formatter"]],["result"]]],[11,"is_none","","Returns true iff the character is absent.",76,[[["self"]],["bool"]]],[11,"len_utf8","","Returns the length of the character's UTF-8 encoding.",76,[[["self"]],["usize"]]],[11,"is_word_char","","Returns true iff the character is a word character.",76,[[["self"]],["bool"]]],[11,"is_word_byte","","Returns true iff the byte is a word byte.",76,[[["self"]],["bool"]]],[11,"from","","",76,[[["char"]],["char"]]],[11,"from","","",76,[[["option",["char"]]],["char"]]],[11,"eq","","",76,[[["self"],["char"]],["bool"]]],[11,"partial_cmp","","",76,[[["self"],["char"]],["option",["ordering"]]]],[0,"literal","regex","",N,N],[3,"LiteralSearcher","regex::literal","A prefix extracted from a compiled regular expression.",N,N],[12,"complete","","",78,N],[12,"lcp","","",78,N],[12,"lcs","","",78,N],[12,"matcher","","",78,N],[3,"SingleByteSet","","",N,N],[12,"sparse","","",79,N],[12,"dense","","",79,N],[12,"complete","","",79,N],[12,"all_ascii","","",79,N],[3,"FreqyPacked","","Provides an implementation of fast subtring search using frequency analysis.",N,N],[12,"pat","","The pattern.",80,N],[12,"char_len","","The number of Unicode characters in the pattern. This is useful for determining the effective length of a pattern when deciding which optimizations to perform. A trailing incomplete UTF-8 sequence counts as one character.",80,N],[12,"rare1","","The rarest byte in the pattern, according to pre-computed frequency analysis.",80,N],[12,"rare1i","","The offset of the rarest byte in `pat`.",80,N],[12,"rare2","","The second rarest byte in the pattern, according to pre-computed frequency analysis. (This may be equivalent to the rarest byte.)",80,N],[12,"rare2i","","The offset of the second rarest byte in `pat`.",80,N],[3,"BoyerMooreSearch","","An implementation of Tuned Boyer-Moore as laid out by Andrew Hume and Daniel Sunday in \"Fast String Searching\". O(n) in the size of the input.",N,N],[12,"pattern","","The pattern we are going to look for in the haystack.",81,N],[12,"skip_table","","The skip table for the skip loop.",81,N],[12,"guard","","The guard character (least frequently occurring char).",81,N],[12,"guard_reverse_idx","","The reverse-index of the guard character in the pattern.",81,N],[12,"md2_shift","","Daniel Sunday's mini generalized delta2 shift table.",81,N],[4,"Matcher","","",N,N],[13,"Empty","","No literals. (Never advances through the input.)",82,N],[13,"Bytes","","A set of four or more single byte literals.",82,N],[13,"FreqyPacked","","A single substring, find using memchr and frequency analysis.",82,N],[13,"BoyerMoore","","A single substring, find using Boyer-Moore.",82,N],[13,"AC","","An Aho-Corasick automaton.",82,N],[13,"TeddySSSE3","","A simd accelerated multiple string matcher. Used only for a small number of small literals.",82,N],[13,"TeddyAVX2","","A simd accelerated multiple string matcher. Used only for a small number of small literals. This uses 256-bit vectors.",82,N],[4,"LiteralIter","","",N,N],[13,"Empty","","",83,N],[13,"Bytes","","",83,N],[13,"Single","","",83,N],[13,"AC","","",83,N],[13,"TeddySSSE3","","",83,N],[13,"TeddyAVX2","","",83,N],[5,"char_len_lossy","","",N,N],[5,"freq_rank","","",N,[[["u8"]],["usize"]]],[0,"teddy_avx2","","",N,N],[0,"imp","regex::literal::teddy_avx2","",N,N],[3,"Teddy","regex::literal::teddy_avx2::imp","",N,N],[12,"0","","",84,N],[3,"Match","","",N,N],[12,"pat","","",85,N],[12,"start","","",85,N],[12,"end","","",85,N],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"clone","","",84,[[["self"]],["teddy"]]],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"clone","","",85,[[["self"]],["match"]]],[11,"available","","",84,[[],["bool"]]],[11,"new","","",84,[[["literals"]],["option",["teddy"]]]],[11,"patterns","","",84,N],[11,"len","","",84,[[["self"]],["usize"]]],[11,"approximate_size","","",84,[[["self"]],["usize"]]],[11,"find","","",84,N],[0,"teddy_ssse3","regex::literal","",N,N],[0,"imp","regex::literal::teddy_ssse3","",N,N],[3,"Teddy","regex::literal::teddy_ssse3::imp","",N,N],[12,"0","","",86,N],[3,"Match","","",N,N],[12,"pat","","",87,N],[12,"start","","",87,N],[12,"end","","",87,N],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"clone","","",86,[[["self"]],["teddy"]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[11,"clone","","",87,[[["self"]],["match"]]],[11,"available","","",86,[[],["bool"]]],[11,"new","","",86,[[["literals"]],["option",["teddy"]]]],[11,"patterns","","",86,N],[11,"len","","",86,[[["self"]],["usize"]]],[11,"approximate_size","","",86,[[["self"]],["usize"]]],[11,"find","","",86,N],[11,"clone","regex::literal","",78,[[["self"]],["literalsearcher"]]],[11,"fmt","","",78,[[["self"],["formatter"]],["result"]]],[11,"clone","","",82,[[["self"]],["matcher"]]],[11,"fmt","","",82,[[["self"],["formatter"]],["result"]]],[11,"empty","","Returns a matcher that never matches and never advances the input.",78,[[],["self"]]],[11,"prefixes","","Returns a matcher for literal prefixes from the given set.",78,[[["literals"]],["self"]]],[11,"suffixes","","Returns a matcher for literal suffixes from the given set.",78,[[["literals"]],["self"]]],[11,"new","","",78,[[["literals"],["matcher"]],["self"]]],[11,"complete","","Returns true if all matches comprise the entire regular expression.",78,[[["self"]],["bool"]]],[11,"find","","Find the position of a literal in `haystack` if it exists.",78,N],[11,"find_start","","Like find, except matches must start at index `0`.",78,N],[11,"find_end","","Like find, except matches must end at index `haystack.len()`.",78,N],[11,"iter","","Returns an iterator over all literals to be matched.",78,[[["self"]],["literaliter"]]],[11,"lcp","","Returns a matcher for the longest common prefix of this matcher.",78,[[["self"]],["freqypacked"]]],[11,"lcs","","Returns a matcher for the longest common suffix of this matcher.",78,[[["self"]],["freqypacked"]]],[11,"is_empty","","Returns true iff this prefix is empty.",78,[[["self"]],["bool"]]],[11,"len","","Returns the number of prefixes in this machine.",78,[[["self"]],["usize"]]],[11,"approximate_size","","Return the approximate heap usage of literals in bytes.",78,[[["self"]],["usize"]]],[11,"prefixes","","",82,[[["literals"]],["self"]]],[11,"suffixes","","",82,[[["literals"]],["self"]]],[11,"new","","",82,[[["literals"],["singlebyteset"]],["self"]]],[11,"next","","",83,[[["self"]],["option"]]],[11,"clone","","",79,[[["self"]],["singlebyteset"]]],[11,"fmt","","",79,[[["self"],["formatter"]],["result"]]],[11,"new","","",79,[[],["singlebyteset"]]],[11,"prefixes","","",79,[[["literals"]],["singlebyteset"]]],[11,"suffixes","","",79,[[["literals"]],["singlebyteset"]]],[11,"find","","Faster find that special cases certain sizes to use memchr.",79,N],[11,"_find","","Generic find that works on any sized set.",79,N],[11,"approximate_size","","",79,[[["self"]],["usize"]]],[11,"clone","","",80,[[["self"]],["freqypacked"]]],[11,"fmt","","",80,[[["self"],["formatter"]],["result"]]],[11,"new","","",80,[[["vec",["u8"]]],["freqypacked"]]],[11,"empty","","",80,[[],["freqypacked"]]],[11,"find","","",80,N],[11,"is_suffix","","",80,N],[11,"len","","",80,[[["self"]],["usize"]]],[11,"char_len","","",80,[[["self"]],["usize"]]],[11,"approximate_size","","",80,[[["self"]],["usize"]]],[11,"clone","","",81,[[["self"]],["boyermooresearch"]]],[11,"fmt","","",81,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new string searcher, performing whatever compilation steps are required.",81,[[["vec",["u8"]]],["self"]]],[11,"find","","Find the pattern in `haystack`, returning the offset of the start of the first occurrence of the pattern in `haystack`.",81,N],[11,"len","","",81,[[["self"]],["usize"]]],[11,"should_use","","The key heuristic behind which the BoyerMooreSearch lives.",81,N],[11,"check_match","","Check to see if there is a match at the given position",81,N],[11,"skip_loop","","Skip forward according to the shift table.",81,N],[11,"compile_skip_table","","Compute the ufast skip table.",81,N],[11,"select_guard","","Select the guard character based off of the precomputed frequency table.",81,N],[11,"compile_md2_shift","","If there is another occurrence of the skip char, shift to it, otherwise just shift to the next window.",81,N],[11,"approximate_size","","",81,[[["self"]],["usize"]]],[0,"pikevm","regex","",N,N],[3,"Fsm","regex::pikevm","An NFA simulation matching engine.",N,N],[12,"prog","","The sequence of opcodes (among other things) that is actually executed.",88,N],[12,"stack","","An explicit stack used for following epsilon transitions. (This is borrowed from the cache.)",88,N],[12,"input","","The input to search.",88,N],[3,"Cache","","A cached allocation that can be reused on each execution.",N,N],[12,"clist","","A pair of ordered sets for tracking NFA states.",89,N],[12,"nlist","","",89,N],[12,"stack","","An explicit stack used for following epsilon transitions.",89,N],[3,"Threads","","An ordered set of NFA states and their captures.",N,N],[12,"set","","An ordered set of opcodes (each opcode is an NFA state).",90,N],[12,"caps","","Captures for every NFA state.",90,N],[12,"slots_per_thread","","The number of capture slots stored per thread. (Every capture has two slots.)",90,N],[4,"FollowEpsilon","","A representation of an explicit stack frame when following epsilon transitions. This is used to avoid recursion.",N,N],[13,"IP","","Follow transitions at the given instruction pointer.",91,N],[13,"Capture","","Restore the capture slot with the given position in the input.",91,N],[12,"slot","regex::pikevm::FollowEpsilon","",91,N],[12,"pos","","",91,N],[11,"fmt","regex::pikevm","",88,[[["self"],["formatter"]],["result"]]],[11,"clone","","",89,[[["self"]],["cache"]]],[11,"fmt","","",89,[[["self"],["formatter"]],["result"]]],[11,"clone","","",90,[[["self"]],["threads"]]],[11,"fmt","","",90,[[["self"],["formatter"]],["result"]]],[11,"clone","","",91,[[["self"]],["followepsilon"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new allocation used by the NFA machine to record execution and captures.",89,[[["program"]],["self"]]],[11,"exec","","Execute the NFA matching engine.",88,N],[11,"exec_","","",88,N],[11,"step","","Step through the input, one token (byte or codepoint) at a time.",88,N],[11,"add","","Follows epsilon transitions and adds them for processing to nlist, starting at and including ip.",88,N],[11,"add_step","","A helper function for add that avoids excessive pushing to the stack.",88,N],[11,"new","","",90,[[],["self"]]],[11,"resize","","",90,[[["self"],["usize"],["usize"]]]],[11,"caps","","",90,N],[0,"prog","regex","",N,N],[3,"Program","regex::prog","Program is a sequence of instructions and various facts about thos instructions.",N,N],[12,"insts","","A sequence of instructions that represents an NFA.",92,N],[12,"matches","","Pointers to each Match instruction in the sequence.",92,N],[12,"captures","","The ordered sequence of all capture groups extracted from the AST. Unnamed groups are `None`.",92,N],[12,"capture_name_idx","","Pointers to all named capture groups into `captures`.",92,N],[12,"start","","A pointer to the start instruction. This can vary depending on how the program was compiled. For example, programs for use with the DFA engine have a `.*?` inserted at the beginning of unanchored regular expressions. The actual starting point of the program is after the `.*?`.",92,N],[12,"byte_classes","","A set of equivalence classes for discriminating bytes in the compiled program.",92,N],[12,"only_utf8","","When true, this program can only match valid UTF-8.",92,N],[12,"is_bytes","","When true, this program uses byte range instructions instead of Unicode range instructions.",92,N],[12,"is_dfa","","When true, the program is compiled for DFA matching. For example, this implies `is_bytes` and also inserts a preceding `.*?` for unanchored regexes.",92,N],[12,"is_reverse","","When true, the program matches text in reverse (for use only in the DFA).",92,N],[12,"is_anchored_start","","Whether the regex must match from the start of the input.",92,N],[12,"is_anchored_end","","Whether the regex must match at the end of the input.",92,N],[12,"has_unicode_word_boundary","","Whether this program contains a Unicode word boundary instruction.",92,N],[12,"prefixes","","A possibly empty machine for very quickly matching prefix literals.",92,N],[12,"dfa_size_limit","","A limit on the size of the cache that the DFA is allowed to use while matching.",92,N],[3,"InstSave","","Representation of the Save instruction.",N,N],[12,"goto","","The next location to execute in the program.",93,N],[12,"slot","","The capture slot (there are two slots for every capture in a regex, including the zeroth capture for the entire match).",93,N],[3,"InstSplit","","Representation of the Split instruction.",N,N],[12,"goto1","","The first instruction to try. A match resulting from following goto1 has precedence over a match resulting from following goto2.",94,N],[12,"goto2","","The second instruction to try. A match resulting from following goto1 has precedence over a match resulting from following goto2.",94,N],[3,"InstEmptyLook","","Representation of the `EmptyLook` instruction.",N,N],[12,"goto","","The next location to execute in the program if this instruction succeeds.",95,N],[12,"look","","The type of zero-width assertion to check.",95,N],[3,"InstChar","","Representation of the Char instruction.",N,N],[12,"goto","","The next location to execute in the program if this instruction succeeds.",96,N],[12,"c","","The character to test.",96,N],[3,"InstRanges","","Representation of the Ranges instruction.",N,N],[12,"goto","","The next location to execute in the program if this instruction succeeds.",97,N],[12,"ranges","","The set of Unicode scalar value ranges to test.",97,N],[3,"InstBytes","","Representation of the Bytes instruction.",N,N],[12,"goto","","The next location to execute in the program if this instruction succeeds.",98,N],[12,"start","","The start (inclusive) of this byte range.",98,N],[12,"end","","The end (inclusive) of this byte range.",98,N],[4,"Inst","","Inst is an instruction code in a Regex program.",N,N],[13,"Match","","Match indicates that the program has reached a match state.",99,N],[13,"Save","","Save causes the program to save the current location of the input in the slot indicated by InstSave.",99,N],[13,"Split","","Split causes the program to diverge to one of two paths in the program, preferring goto1 in InstSplit.",99,N],[13,"EmptyLook","","EmptyLook represents a zero-width assertion in a regex program. A zero-width assertion does not consume any of the input text.",99,N],[13,"Char","","Char requires the regex program to match the character in InstChar at the current position in the input.",99,N],[13,"Ranges","","Ranges requires the regex program to match the character at the current position in the input with one of the ranges specified in InstRanges.",99,N],[13,"Bytes","","Bytes is like Ranges, except it expresses a single byte range. It is used in conjunction with Split instructions to implement multi-byte character classes.",99,N],[4,"EmptyLook","","The set of zero-width match instructions.",N,N],[13,"StartLine","","Start of line or input.",100,N],[13,"EndLine","","End of line or input.",100,N],[13,"StartText","","Start of input.",100,N],[13,"EndText","","End of input.",100,N],[13,"WordBoundary","","Word character on one side and non-word character on other.",100,N],[13,"NotWordBoundary","","Word character on both sides or non-word character on both sides.",100,N],[13,"WordBoundaryAscii","","ASCII word boundary.",100,N],[13,"NotWordBoundaryAscii","","Not ASCII word boundary.",100,N],[6,"InstPtr","","`InstPtr` represents the index of an instruction in a regex program.",N,N],[11,"clone","","",92,[[["self"]],["program"]]],[11,"new","","Creates an empty instruction sequence. Fields are given default values.",92,[[],["self"]]],[11,"skip","","If pc is an index to a no-op instruction (like Save), then return the next pc that is not a no-op instruction.",92,[[["self"],["usize"]],["usize"]]],[11,"leads_to_match","","Return true if and only if an execution engine at instruction `pc` will always lead to a match.",92,[[["self"],["usize"]],["bool"]]],[11,"needs_dotstar","","Returns true if the current configuration demands that an implicit `.*?` be prepended to the instruction sequence.",92,[[["self"]],["bool"]]],[11,"uses_bytes","","Returns true if this program uses Byte instructions instead of Char/Range instructions.",92,[[["self"]],["bool"]]],[11,"only_utf8","","Returns true if this program exclusively matches valid UTF-8 bytes.",92,[[["self"]],["bool"]]],[11,"approximate_size","","Return the approximate heap usage of this instruction sequence in bytes.",92,[[["self"]],["usize"]]],[11,"deref","","",92,N],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"clone","","",99,[[["self"]],["inst"]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result"]]],[11,"is_match","","Returns true if and only if this is a match instruction.",99,[[["self"]],["bool"]]],[11,"clone","","",93,[[["self"]],["instsave"]]],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[11,"clone","","",94,[[["self"]],["instsplit"]]],[11,"fmt","","",94,[[["self"],["formatter"]],["result"]]],[11,"clone","","",95,[[["self"]],["instemptylook"]]],[11,"fmt","","",95,[[["self"],["formatter"]],["result"]]],[11,"clone","","",100,[[["self"]],["emptylook"]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result"]]],[11,"eq","","",100,[[["self"],["emptylook"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",100,N],[11,"clone","","",96,[[["self"]],["instchar"]]],[11,"fmt","","",96,[[["self"],["formatter"]],["result"]]],[11,"clone","","",97,[[["self"]],["instranges"]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"matches","","Tests whether the given input character matches this instruction.",97,[[["self"],["char"]],["bool"]]],[11,"num_chars","","Return the number of distinct characters represented by all of the ranges.",97,[[["self"]],["usize"]]],[11,"clone","","",98,[[["self"]],["instbytes"]]],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[11,"matches","","Returns true if and only if the given byte is in this range.",98,[[["self"],["u8"]],["bool"]]],[0,"re_builder","regex","",N,N],[3,"RegexOptions","regex::re_builder","The set of user configurable options for compiling zero or more regexes.",N,N],[12,"pats","","",101,N],[12,"size_limit","","",101,N],[12,"dfa_size_limit","","",101,N],[12,"nest_limit","","",101,N],[12,"case_insensitive","","",101,N],[12,"multi_line","","",101,N],[12,"dot_matches_new_line","","",101,N],[12,"swap_greed","","",101,N],[12,"ignore_whitespace","","",101,N],[12,"unicode","","",101,N],[0,"bytes","","",N,N],[3,"RegexBuilder","regex::re_builder::bytes","A configurable builder for a regular expression.",N,N],[12,"0","","",19,N],[11,"new","regex::bytes","Create a new regular expression builder with the given pattern.",19,[[["str"]],["regexbuilder"]]],[11,"build","","Consume the builder and compile the regular expression.",19,[[["self"]],["result",["regex","error"]]]],[11,"case_insensitive","","Set the value for the case insensitive (`i`) flag.",19,[[["self"],["bool"]],["regexbuilder"]]],[11,"multi_line","","Set the value for the multi-line matching (`m`) flag.",19,[[["self"],["bool"]],["regexbuilder"]]],[11,"dot_matches_new_line","","Set the value for the any character (`s`) flag, where in `.` matches anything when `s` is set and matches anything except for new line when it is not set (the default).",19,[[["self"],["bool"]],["regexbuilder"]]],[11,"swap_greed","","Set the value for the greedy swap (`U`) flag.",19,[[["self"],["bool"]],["regexbuilder"]]],[11,"ignore_whitespace","","Set the value for the ignore whitespace (`x`) flag.",19,[[["self"],["bool"]],["regexbuilder"]]],[11,"unicode","","Set the value for the Unicode (`u`) flag.",19,[[["self"],["bool"]],["regexbuilder"]]],[11,"size_limit","","Set the approximate size limit of the compiled regular expression.",19,[[["self"],["usize"]],["regexbuilder"]]],[11,"dfa_size_limit","","Set the approximate size of the cache used by the DFA.",19,[[["self"],["usize"]],["regexbuilder"]]],[11,"nest_limit","","Set the nesting limit for this parser.",19,[[["self"],["u32"]],["regexbuilder"]]],[0,"unicode","regex::re_builder","",N,N],[3,"RegexBuilder","regex::re_builder::unicode","A configurable builder for a regular expression.",N,N],[12,"0","","",0,N],[11,"new","regex","Create a new regular expression builder with the given pattern.",0,[[["str"]],["regexbuilder"]]],[11,"build","","Consume the builder and compile the regular expression.",0,[[["self"]],["result",["regex","error"]]]],[11,"case_insensitive","","Set the value for the case insensitive (`i`) flag.",0,[[["self"],["bool"]],["regexbuilder"]]],[11,"multi_line","","Set the value for the multi-line matching (`m`) flag.",0,[[["self"],["bool"]],["regexbuilder"]]],[11,"dot_matches_new_line","","Set the value for the any character (`s`) flag, where in `.` matches anything when `s` is set and matches anything except for new line when it is not set (the default).",0,[[["self"],["bool"]],["regexbuilder"]]],[11,"swap_greed","","Set the value for the greedy swap (`U`) flag.",0,[[["self"],["bool"]],["regexbuilder"]]],[11,"ignore_whitespace","","Set the value for the ignore whitespace (`x`) flag.",0,[[["self"],["bool"]],["regexbuilder"]]],[11,"unicode","","Set the value for the Unicode (`u`) flag.",0,[[["self"],["bool"]],["regexbuilder"]]],[11,"size_limit","","Set the approximate size limit of the compiled regular expression.",0,[[["self"],["usize"]],["regexbuilder"]]],[11,"dfa_size_limit","","Set the approximate size of the cache used by the DFA.",0,[[["self"],["usize"]],["regexbuilder"]]],[11,"nest_limit","","Set the nesting limit for this parser.",0,[[["self"],["u32"]],["regexbuilder"]]],[0,"set_bytes","regex::re_builder","",N,N],[3,"RegexSetBuilder","regex::re_builder::set_bytes","A configurable builder for a set of regular expressions.",N,N],[12,"0","","",20,N],[11,"new","regex::bytes","Create a new regular expression builder with the given pattern.",20,[[["i"]],["regexsetbuilder"]]],[11,"build","","Consume the builder and compile the regular expressions into a set.",20,[[["self"]],["result",["regexset","error"]]]],[11,"case_insensitive","","Set the value for the case insensitive (`i`) flag.",20,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"multi_line","","Set the value for the multi-line matching (`m`) flag.",20,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"dot_matches_new_line","","Set the value for the any character (`s`) flag, where in `.` matches anything when `s` is set and matches anything except for new line when it is not set (the default).",20,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"swap_greed","","Set the value for the greedy swap (`U`) flag.",20,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"ignore_whitespace","","Set the value for the ignore whitespace (`x`) flag.",20,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"unicode","","Set the value for the Unicode (`u`) flag.",20,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"size_limit","","Set the approximate size limit of the compiled regular expression.",20,[[["self"],["usize"]],["regexsetbuilder"]]],[11,"dfa_size_limit","","Set the approximate size of the cache used by the DFA.",20,[[["self"],["usize"]],["regexsetbuilder"]]],[11,"nest_limit","","Set the nesting limit for this parser.",20,[[["self"],["u32"]],["regexsetbuilder"]]],[0,"set_unicode","regex::re_builder","",N,N],[3,"RegexSetBuilder","regex::re_builder::set_unicode","A configurable builder for a set of regular expressions.",N,N],[12,"0","","",1,N],[11,"new","regex","Create a new regular expression builder with the given pattern.",1,[[["i"]],["regexsetbuilder"]]],[11,"build","","Consume the builder and compile the regular expressions into a set.",1,[[["self"]],["result",["regexset","error"]]]],[11,"case_insensitive","","Set the value for the case insensitive (`i`) flag.",1,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"multi_line","","Set the value for the multi-line matching (`m`) flag.",1,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"dot_matches_new_line","","Set the value for the any character (`s`) flag, where in `.` matches anything when `s` is set and matches anything except for new line when it is not set (the default).",1,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"swap_greed","","Set the value for the greedy swap (`U`) flag.",1,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"ignore_whitespace","","Set the value for the ignore whitespace (`x`) flag.",1,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"unicode","","Set the value for the Unicode (`u`) flag.",1,[[["self"],["bool"]],["regexsetbuilder"]]],[11,"size_limit","","Set the approximate size limit of the compiled regular expression.",1,[[["self"],["usize"]],["regexsetbuilder"]]],[11,"dfa_size_limit","","Set the approximate size of the cache used by the DFA.",1,[[["self"],["usize"]],["regexsetbuilder"]]],[11,"nest_limit","","Set the nesting limit for this parser.",1,[[["self"],["u32"]],["regexsetbuilder"]]],[11,"clone","regex::re_builder","",101,[[["self"]],["regexoptions"]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"default","","",101,[[],["self"]]],[0,"re_bytes","regex","",N,N],[3,"Match","regex::re_bytes","Match represents a single match of a regex in a haystack.",N,N],[12,"text","","",21,N],[12,"start","","",21,N],[12,"end","","",21,N],[3,"Regex","","A compiled regular expression for matching arbitrary bytes.",N,N],[12,"0","","",22,N],[3,"Matches","","An iterator over all non-overlapping matches for a particular string.",N,N],[12,"0","","",23,N],[3,"CaptureMatches","","An iterator that yields all non-overlapping capture groups matching a particular regular expression.",N,N],[12,"0","","",24,N],[3,"Split","","Yields all substrings delimited by a regular expression match.",N,N],[12,"finder","","",25,N],[12,"last","","",25,N],[3,"SplitN","","Yields at most `N` substrings delimited by a regular expression match.",N,N],[12,"splits","","",26,N],[12,"n","","",26,N],[3,"CaptureNames","","An iterator over the names of all possible captures.",N,N],[12,"0","","",27,N],[3,"Captures","","Captures represents a group of captured byte strings for a single match.",N,N],[12,"text","","",28,N],[12,"locs","","",28,N],[12,"named_groups","","",28,N],[3,"CapturesDebug","","",N,N],[12,"0","","",102,N],[3,"SubCaptureMatches","","An iterator that yields all capturing matches in the order in which they appear in the regex.",N,N],[12,"caps","","",29,N],[12,"it","","",29,N],[3,"ReplacerRef","","By-reference adaptor for a `Replacer`",N,N],[12,"0","","",30,N],[3,"NoExpand","","`NoExpand` indicates literal byte string replacement.",N,N],[12,"0","","",31,N],[8,"Replacer","","Replacer describes types that can be used to replace matches in a byte string.",N,N],[10,"replace_append","","Appends text to `dst` to replace the current match.",36,[[["self"],["captures"],["vec"]]]],[11,"no_expansion","regex::bytes","Return a fixed unchanging replacement byte string.",36,[[["self"]],["option",["cow"]]]],[11,"by_ref","","Return a `Replacer` that borrows and wraps this `Replacer`.",36,[[["self"]],["replacerref"]]],[11,"clone","","",21,[[["self"]],["match"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"eq","","",21,[[["self"],["match"]],["bool"]]],[11,"ne","","",21,[[["self"],["match"]],["bool"]]],[11,"start","","Returns the starting byte offset of the match in the haystack.",21,[[["self"]],["usize"]]],[11,"end","","Returns the ending byte offset of the match in the haystack.",21,[[["self"]],["usize"]]],[11,"as_bytes","","Returns the matched text.",21,N],[11,"new","","Creates a new match from the given haystack and byte offsets.",21,N],[11,"clone","","",22,[[["self"]],["regex"]]],[11,"fmt","","Shows the original regular expression.",22,[[["self"],["formatter"]],["result"]]],[11,"fmt","","Shows the original regular expression.",22,[[["self"],["formatter"]],["result"]]],[11,"from","","",22,[[["exec"]],["regex"]]],[11,"from_str","","Attempts to parse a string into a regular expression",22,[[["str"]],["result",["regex","error"]]]],[11,"new","","Compiles a regular expression. Once compiled, it can be used repeatedly to search, split or replace text in a string.",22,[[["str"]],["result",["regex","error"]]]],[11,"is_match","","Returns true if and only if the regex matches the string given.",22,N],[11,"find","","Returns the start and end byte range of the leftmost-first match in `text`. If no match exists, then `None` is returned.",22,N],[11,"find_iter","","Returns an iterator for each successive non-overlapping match in `text`, returning the start and end byte indices with respect to `text`.",22,N],[11,"captures","","Returns the capture groups corresponding to the leftmost-first match in `text`. Capture group `0` always corresponds to the entire match. If no match is found, then `None` is returned.",22,N],[11,"captures_iter","","Returns an iterator over all the non-overlapping capture groups matched in `text`. This is operationally the same as `find_iter`, except it yields information about capturing group matches.",22,N],[11,"split","","Returns an iterator of substrings of `text` delimited by a match of the regular expression. Namely, each element of the iterator corresponds to text that isn't matched by the regular expression.",22,N],[11,"splitn","","Returns an iterator of at most `limit` substrings of `text` delimited by a match of the regular expression. (A `limit` of `0` will return no substrings.) Namely, each element of the iterator corresponds to text that isn't matched by the regular expression. The remainder of the string that is not split will be the last element in the iterator.",22,N],[11,"replace","","Replaces the leftmost-first match with the replacement provided. The replacement can be a regular byte string (where `$N` and `$name` are expanded to match capture groups) or a function that takes the matches' `Captures` and returns the replaced byte string.",22,N],[11,"replace_all","","Replaces all non-overlapping matches in `text` with the replacement provided. This is the same as calling `replacen` with `limit` set to `0`.",22,N],[11,"replacen","","Replaces at most `limit` non-overlapping matches in `text` with the replacement provided. If `limit` is 0, then all non-overlapping matches are replaced.",22,N],[11,"shortest_match","","Returns the end location of a match in the text given.",22,N],[11,"shortest_match_at","","Returns the same as shortest_match, but starts the search at the given offset.",22,N],[11,"is_match_at","","Returns the same as is_match, but starts the search at the given offset.",22,N],[11,"find_at","","Returns the same as find, but starts the search at the given offset.",22,N],[11,"read_captures_at","","Returns the same as captures, but starts the search at the given offset and populates the capture locations given.",22,N],[11,"as_str","","Returns the original string of this regex.",22,[[["self"]],["str"]]],[11,"capture_names","","Returns an iterator over the capture names.",22,[[["self"]],["capturenames"]]],[11,"captures_len","","Returns the number of captures.",22,[[["self"]],["usize"]]],[11,"locations","","Returns an empty set of locations that can be reused in multiple calls to `read_captures`.",22,[[["self"]],["locations"]]],[11,"next","","",23,[[["self"]],["option",["match"]]]],[11,"next","","",24,[[["self"]],["option",["captures"]]]],[11,"next","","",25,[[["self"]],["option"]]],[11,"next","","",26,[[["self"]],["option"]]],[11,"next","","",27,[[["self"]],["option",["option"]]]],[11,"size_hint","","",27,N],[11,"get","","Returns the match associated with the capture group at index `i`. If `i` does not correspond to a capture group, or if the capture group did not participate in the match, then `None` is returned.",28,[[["self"],["usize"]],["option",["match"]]]],[11,"name","","Returns the match for the capture group named `name`. If `name` isn't a valid capture group or didn't match anything, then `None` is returned.",28,[[["self"],["str"]],["option",["match"]]]],[11,"iter","","An iterator that yields all capturing matches in the order in which they appear in the regex. If a particular capture group didn't participate in the match, then `None` is yielded for that capture.",28,[[["self"]],["subcapturematches"]]],[11,"expand","","Expands all instances of `$name` in `replacement` to the corresponding capture group `name`, and writes them to the `dst` buffer given.",28,N],[11,"len","","Returns the number of captured groups.",28,[[["self"]],["usize"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"fmt","regex::re_bytes","",102,[[["self"],["formatter"]],["result"]]],[11,"index","regex::bytes","",28,N],[11,"index","","",28,N],[11,"next","","",29,[[["self"]],["option",["option"]]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"replace_append","","",30,[[["self"],["captures"],["vec"]]]],[11,"no_expansion","","",30,[[["self"]],["option",["cow"]]]],[11,"replace_append","","",31,[[["self"],["captures"],["vec"]]]],[11,"no_expansion","","",31,[[["self"]],["option",["cow"]]]],[0,"re_set","regex","",N,N],[0,"unicode","regex::re_set","",N,N],[3,"RegexSet","regex::re_set::unicode","Match multiple (possibly overlapping) regular expressions in a single scan.",N,N],[12,"0","","",2,N],[3,"SetMatches","","A set of matches returned by a regex set.",N,N],[12,"matched_any","","",3,N],[12,"matches","","",3,N],[3,"SetMatchesIntoIter","","An owned iterator over the set of matches from a regex set.",N,N],[12,"0","","",4,N],[3,"SetMatchesIter","","A borrowed iterator over the set of matches from a regex set.",N,N],[12,"0","","",5,N],[5,"as_bytes_str","","",N,N],[5,"as_bytes_bytes","","",N,N],[11,"clone","regex","",2,[[["self"]],["regexset"]]],[11,"new","","Create a new regex set with the given regular expressions.",2,[[["i"]],["result",["regexset","error"]]]],[11,"is_match","","Returns true if and only if one of the regexes in this set matches the text given.",2,[[["self"],["str"]],["bool"]]],[11,"is_match_at","","Returns the same as is_match, but starts the search at the given offset.",2,[[["self"],["str"],["usize"]],["bool"]]],[11,"matches","","Returns the set of regular expressions that match in the given text.",2,[[["self"],["str"]],["setmatches"]]],[11,"read_matches_at","","Returns the same as matches, but starts the search at the given offset and stores the matches into the slice given.",2,N],[11,"len","","Returns the total number of regular expressions in this set.",2,[[["self"]],["usize"]]],[11,"clone","","",3,[[["self"]],["setmatches"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"matched_any","","Whether this set contains any matches.",3,[[["self"]],["bool"]]],[11,"matched","","Whether the regex at the given index matched.",3,[[["self"],["usize"]],["bool"]]],[11,"len","","The total number of regexes in the set that created these matches.",3,[[["self"]],["usize"]]],[11,"iter","","Returns an iterator over indexes in the regex that matched.",3,[[["self"]],["setmatchesiter"]]],[11,"into_iter","","",3,N],[11,"next","","",4,[[["self"]],["option",["usize"]]]],[11,"next_back","","",4,[[["self"]],["option",["usize"]]]],[11,"clone","","",5,[[["self"]],["setmatchesiter"]]],[11,"next","","",5,[[["self"]],["option",["usize"]]]],[11,"next_back","","",5,[[["self"]],["option",["usize"]]]],[11,"from","","",2,[[["exec"]],["self"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[0,"bytes","regex::re_set","",N,N],[3,"RegexSet","regex::re_set::bytes","Match multiple (possibly overlapping) regular expressions in a single scan.",N,N],[12,"0","","",32,N],[3,"SetMatches","","A set of matches returned by a regex set.",N,N],[12,"matched_any","","",33,N],[12,"matches","","",33,N],[3,"SetMatchesIntoIter","","An owned iterator over the set of matches from a regex set.",N,N],[12,"0","","",34,N],[3,"SetMatchesIter","","A borrowed iterator over the set of matches from a regex set.",N,N],[12,"0","","",35,N],[5,"as_bytes_str","","",N,N],[5,"as_bytes_bytes","","",N,N],[11,"clone","regex::bytes","",32,[[["self"]],["regexset"]]],[11,"new","","Create a new regex set with the given regular expressions.",32,[[["i"]],["result",["regexset","error"]]]],[11,"is_match","","Returns true if and only if one of the regexes in this set matches the text given.",32,N],[11,"is_match_at","","Returns the same as is_match, but starts the search at the given offset.",32,N],[11,"matches","","Returns the set of regular expressions that match in the given text.",32,N],[11,"read_matches_at","","Returns the same as matches, but starts the search at the given offset and stores the matches into the slice given.",32,N],[11,"len","","Returns the total number of regular expressions in this set.",32,[[["self"]],["usize"]]],[11,"clone","","",33,[[["self"]],["setmatches"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"matched_any","","Whether this set contains any matches.",33,[[["self"]],["bool"]]],[11,"matched","","Whether the regex at the given index matched.",33,[[["self"],["usize"]],["bool"]]],[11,"len","","The total number of regexes in the set that created these matches.",33,[[["self"]],["usize"]]],[11,"iter","","Returns an iterator over indexes in the regex that matched.",33,[[["self"]],["setmatchesiter"]]],[11,"into_iter","","",33,N],[11,"next","","",34,[[["self"]],["option",["usize"]]]],[11,"next_back","","",34,[[["self"]],["option",["usize"]]]],[11,"clone","","",35,[[["self"]],["setmatchesiter"]]],[11,"next","","",35,[[["self"]],["option",["usize"]]]],[11,"next_back","","",35,[[["self"]],["option",["usize"]]]],[11,"from","","",32,[[["exec"]],["self"]]],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[0,"re_trait","regex","",N,N],[3,"Locations","regex::re_trait","Locations represents the offsets of each capturing group in a regex for a single match.",N,N],[12,"0","","",6,N],[3,"SubCapturesPosIter","","An iterator over capture group positions for a particular match of a regular expression.",N,N],[12,"idx","","",103,N],[12,"locs","","",103,N],[3,"Matches","","An iterator over all non-overlapping successive leftmost-first matches.",N,N],[12,"re","","",104,N],[12,"text","","",104,N],[12,"last_end","","",104,N],[12,"last_match","","",104,N],[3,"CaptureMatches","","An iterator over all non-overlapping successive leftmost-first matches with captures.",N,N],[12,"0","","",105,N],[5,"as_slots","","This is a hack to make Locations -> &mut [Slot] be available internally without exposing it in the public API.",N,N],[6,"Slot","","Slot is a single saved capture location. Note that there are two slots for every capture in a regular expression (one slot each for the start and end of the capture).",N,N],[8,"RegularExpression","","`RegularExpression` describes types that can implement regex searching.",N,N],[16,"Text","","The type of the haystack.",106,N],[10,"slots_len","","The number of capture slots in the compiled regular expression. This is always two times the number of capture groups (two slots per group).",106,[[["self"]],["usize"]]],[11,"locations","","Allocates fresh space for all capturing groups in this regex.",106,[[["self"]],["locations"]]],[10,"next_after_empty","","Returns the position of the next character after `i`.",106,N],[10,"shortest_match_at","","Returns the location of the shortest match.",106,N],[10,"is_match_at","","Returns whether the regex matches the text given.",106,N],[10,"find_at","","Returns the leftmost-first match location if one exists.",106,N],[10,"read_captures_at","","Returns the leftmost-first match location if one exists, and also fills in any matching capture slot locations.",106,N],[11,"find_iter","","Returns an iterator over all non-overlapping successive leftmost-first matches.",106,N],[11,"captures_iter","","Returns an iterator over all non-overlapping successive leftmost-first matches with captures.",106,N],[11,"pos","regex","Returns the start and end positions of the Nth capture group. Returns `None` if `i` is not a valid capture group or if the capture group did not match anything. The positions returned are always byte indices with respect to the original string matched.",6,[[["self"],["usize"]],["option"]]],[11,"iter","","Creates an iterator of all the capture group positions in order of appearance in the regular expression. Positions are byte indices in terms of the original string matched.",6,[[["self"]],["subcapturespositer"]]],[11,"len","","Returns the total number of capturing groups.",6,[[["self"]],["usize"]]],[11,"next","regex::re_trait","",103,[[["self"]],["option",["option"]]]],[11,"text","","Return the text being searched.",104,N],[11,"regex","","Return the underlying regex.",104,[[["self"]],["r"]]],[11,"next","","",104,[[["self"]],["option"]]],[11,"text","","Return the text being searched.",105,N],[11,"regex","","Return the underlying regex.",105,[[["self"]],["r"]]],[11,"next","","",105,[[["self"]],["option",["locations"]]]],[0,"re_unicode","regex","",N,N],[3,"Match","regex::re_unicode","Match represents a single match of a regex in a haystack.",N,N],[12,"text","","",8,N],[12,"start","","",8,N],[12,"end","","",8,N],[3,"Regex","","A compiled regular expression for matching Unicode strings.",N,N],[12,"0","","",7,N],[3,"CaptureNames","","An iterator over the names of all possible captures.",N,N],[12,"0","","",10,N],[3,"Split","","Yields all substrings delimited by a regular expression match.",N,N],[12,"finder","","",16,N],[12,"last","","",16,N],[3,"SplitN","","Yields at most `N` substrings delimited by a regular expression match.",N,N],[12,"splits","","",17,N],[12,"n","","",17,N],[3,"Captures","","Captures represents a group of captured strings for a single match.",N,N],[12,"text","","",9,N],[12,"locs","","",9,N],[12,"named_groups","","",9,N],[3,"CapturesDebug","","",N,N],[12,"0","","",107,N],[3,"SubCaptureMatches","","An iterator that yields all capturing matches in the order in which they appear in the regex.",N,N],[12,"caps","","",13,N],[12,"it","","",13,N],[3,"CaptureMatches","","An iterator that yields all non-overlapping capture groups matching a particular regular expression.",N,N],[12,"0","","",12,N],[3,"Matches","","An iterator over all non-overlapping matches for a particular string.",N,N],[12,"0","","",11,N],[3,"ReplacerRef","","By-reference adaptor for a `Replacer`",N,N],[12,"0","","",14,N],[3,"NoExpand","","`NoExpand` indicates literal string replacement.",N,N],[12,"0","","",15,N],[5,"escape","","Escapes all regular expression meta characters in `text`.",N,[[["str"]],["string"]]],[8,"Replacer","","Replacer describes types that can be used to replace matches in a string.",N,N],[10,"replace_append","","Appends text to `dst` to replace the current match.",108,[[["self"],["captures"],["string"]]]],[11,"no_expansion","","Return a fixed unchanging replacement string.",108,[[["self"]],["option",["cow"]]]],[11,"by_ref","","Return a `Replacer` that borrows and wraps this `Replacer`.",108,[[["self"]],["replacerref"]]],[11,"clone","regex","",8,[[["self"]],["match"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"eq","","",8,[[["self"],["match"]],["bool"]]],[11,"ne","","",8,[[["self"],["match"]],["bool"]]],[11,"start","","Returns the starting byte offset of the match in the haystack.",8,[[["self"]],["usize"]]],[11,"end","","Returns the ending byte offset of the match in the haystack.",8,[[["self"]],["usize"]]],[11,"as_str","","Returns the matched text.",8,[[["self"]],["str"]]],[11,"new","","Creates a new match from the given haystack and byte offsets.",8,[[["str"],["usize"],["usize"]],["match"]]],[11,"clone","","",7,[[["self"]],["regex"]]],[11,"fmt","","Shows the original regular expression.",7,[[["self"],["formatter"]],["result"]]],[11,"fmt","","Shows the original regular expression.",7,[[["self"],["formatter"]],["result"]]],[11,"from","","",7,[[["exec"]],["regex"]]],[11,"from_str","","Attempts to parse a string into a regular expression",7,[[["str"]],["result",["regex","error"]]]],[11,"new","","Compiles a regular expression. Once compiled, it can be used repeatedly to search, split or replace text in a string.",7,[[["str"]],["result",["regex","error"]]]],[11,"is_match","","Returns true if and only if the regex matches the string given.",7,[[["self"],["str"]],["bool"]]],[11,"find","","Returns the start and end byte range of the leftmost-first match in `text`. If no match exists, then `None` is returned.",7,[[["self"],["str"]],["option",["match"]]]],[11,"find_iter","","Returns an iterator for each successive non-overlapping match in `text`, returning the start and end byte indices with respect to `text`.",7,[[["self"],["str"]],["matches"]]],[11,"captures","","Returns the capture groups corresponding to the leftmost-first match in `text`. Capture group `0` always corresponds to the entire match. If no match is found, then `None` is returned.",7,[[["self"],["str"]],["option",["captures"]]]],[11,"captures_iter","","Returns an iterator over all the non-overlapping capture groups matched in `text`. This is operationally the same as `find_iter`, except it yields information about capturing group matches.",7,[[["self"],["str"]],["capturematches"]]],[11,"split","","Returns an iterator of substrings of `text` delimited by a match of the regular expression. Namely, each element of the iterator corresponds to text that isn't matched by the regular expression.",7,[[["self"],["str"]],["split"]]],[11,"splitn","","Returns an iterator of at most `limit` substrings of `text` delimited by a match of the regular expression. (A `limit` of `0` will return no substrings.) Namely, each element of the iterator corresponds to text that isn't matched by the regular expression. The remainder of the string that is not split will be the last element in the iterator.",7,[[["self"],["str"],["usize"]],["splitn"]]],[11,"replace","","Replaces the leftmost-first match with the replacement provided. The replacement can be a regular string (where `$N` and `$name` are expanded to match capture groups) or a function that takes the matches' `Captures` and returns the replaced string.",7,[[["self"],["str"],["r"]],["cow",["str"]]]],[11,"replace_all","","Replaces all non-overlapping matches in `text` with the replacement provided. This is the same as calling `replacen` with `limit` set to `0`.",7,[[["self"],["str"],["r"]],["cow",["str"]]]],[11,"replacen","","Replaces at most `limit` non-overlapping matches in `text` with the replacement provided. If `limit` is 0, then all non-overlapping matches are replaced.",7,[[["self"],["str"],["usize"],["r"]],["cow",["str"]]]],[11,"shortest_match","","Returns the end location of a match in the text given.",7,[[["self"],["str"]],["option",["usize"]]]],[11,"shortest_match_at","","Returns the same as shortest_match, but starts the search at the given offset.",7,[[["self"],["str"],["usize"]],["option",["usize"]]]],[11,"is_match_at","","Returns the same as is_match, but starts the search at the given offset.",7,[[["self"],["str"],["usize"]],["bool"]]],[11,"find_at","","Returns the same as find, but starts the search at the given offset.",7,[[["self"],["str"],["usize"]],["option",["match"]]]],[11,"read_captures_at","","Returns the same as captures, but starts the search at the given offset and populates the capture locations given.",7,[[["self"],["locations"],["str"],["usize"]],["option",["match"]]]],[11,"as_str","","Returns the original string of this regex.",7,[[["self"]],["str"]]],[11,"capture_names","","Returns an iterator over the capture names.",7,[[["self"]],["capturenames"]]],[11,"captures_len","","Returns the number of captures.",7,[[["self"]],["usize"]]],[11,"locations","","Returns an empty set of locations that can be reused in multiple calls to `read_captures`.",7,[[["self"]],["locations"]]],[11,"next","","",10,[[["self"]],["option",["option"]]]],[11,"size_hint","","",10,N],[11,"next","","",16,[[["self"]],["option",["str"]]]],[11,"next","","",17,[[["self"]],["option",["str"]]]],[11,"get","","Returns the match associated with the capture group at index `i`. If `i` does not correspond to a capture group, or if the capture group did not participate in the match, then `None` is returned.",9,[[["self"],["usize"]],["option",["match"]]]],[11,"name","","Returns the match for the capture group named `name`. If `name` isn't a valid capture group or didn't match anything, then `None` is returned.",9,[[["self"],["str"]],["option",["match"]]]],[11,"iter","","An iterator that yields all capturing matches in the order in which they appear in the regex. If a particular capture group didn't participate in the match, then `None` is yielded for that capture.",9,[[["self"]],["subcapturematches"]]],[11,"expand","","Expands all instances of `$name` in `replacement` to the corresponding capture group `name`, and writes them to the `dst` buffer given.",9,[[["self"],["str"],["string"]]]],[11,"len","","Returns the number of captured groups.",9,[[["self"]],["usize"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"fmt","regex::re_unicode","",107,[[["self"],["formatter"]],["result"]]],[11,"index","regex","",9,[[["self"],["usize"]],["str"]]],[11,"index","","",9,[[["self"],["str"]],["str"]]],[11,"next","","",13,[[["self"]],["option",["option"]]]],[11,"next","","",12,[[["self"]],["option",["captures"]]]],[11,"next","","",11,[[["self"]],["option",["match"]]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"replace_append","","",14,[[["self"],["captures"],["string"]]]],[11,"no_expansion","","",14,[[["self"]],["option",["cow"]]]],[11,"replace_append","","",15,[[["self"],["captures"],["string"]]]],[11,"no_expansion","","",15,[[["self"]],["option",["cow"]]]],[0,"sparse","","",N,N],[3,"SparseSet","regex::sparse","A sparse set used for representing ordered NFA states.",N,N],[12,"dense","","Dense contains the instruction pointers in the order in which they were inserted. Accessing elements >= self.size is illegal.",109,N],[12,"sparse","","Sparse maps instruction pointers to their location in dense.",109,N],[12,"size","","The number of elements in the set.",109,N],[11,"clone","","",109,[[["self"]],["sparseset"]]],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"new","","",109,[[["usize"]],["sparseset"]]],[11,"len","","",109,[[["self"]],["usize"]]],[11,"is_empty","","",109,[[["self"]],["bool"]]],[11,"capacity","","",109,[[["self"]],["usize"]]],[11,"insert","","",109,[[["self"],["usize"]]]],[11,"contains","","",109,[[["self"],["usize"]],["bool"]]],[11,"clear","","",109,[[["self"]]]],[11,"deref","","",109,N],[0,"internal","regex","The `internal` module exists to support suspicious activity, such as testing different matching engines and supporting the `regex-debug` CLI utility.",N,N],[3,"Compiler","regex::internal","A compiler translates a regular expression AST to a sequence of instructions. The sequence of instructions represents an NFA.",N,N],[12,"insts","","",41,N],[12,"compiled","","",41,N],[12,"capture_name_idx","","",41,N],[12,"num_exprs","","",41,N],[12,"size_limit","","",41,N],[12,"suffix_cache","","",41,N],[12,"utf8_seqs","","",41,N],[12,"byte_classes","","",41,N],[3,"Exec","","`Exec` manages the execution of a regular expression.",N,N],[12,"ro","","All read only state.",61,N],[12,"cache","","Caches for the various matching engines.",61,N],[3,"ExecBuilder","","Facilitates the construction of an executor by exposing various knobs to control how a regex is executed and what kinds of resources it's permitted to use.",N,N],[12,"options","","",65,N],[12,"match_type","","",65,N],[12,"bytes","","",65,N],[12,"only_utf8","","",65,N],[3,"Char","","An inline representation of `Option<char>`.",N,N],[12,"0","","",76,N],[3,"CharInput","","An input reader over characters.",N,N],[12,"0","","",74,N],[3,"InputAt","","Represents a location in the input.",N,N],[12,"pos","","",73,N],[12,"c","","",73,N],[12,"byte","","",73,N],[12,"len","","",73,N],[3,"LiteralSearcher","","A prefix extracted from a compiled regular expression.",N,N],[12,"complete","","",78,N],[12,"lcp","","",78,N],[12,"lcs","","",78,N],[12,"matcher","","",78,N],[3,"Program","","Program is a sequence of instructions and various facts about thos instructions.",N,N],[12,"insts","","A sequence of instructions that represents an NFA.",92,N],[12,"matches","","Pointers to each Match instruction in the sequence.",92,N],[12,"captures","","The ordered sequence of all capture groups extracted from the AST. Unnamed groups are `None`.",92,N],[12,"capture_name_idx","","Pointers to all named capture groups into `captures`.",92,N],[12,"start","","A pointer to the start instruction. This can vary depending on how the program was compiled. For example, programs for use with the DFA engine have a `.*?` inserted at the beginning of unanchored regular expressions. The actual starting point of the program is after the `.*?`.",92,N],[12,"byte_classes","","A set of equivalence classes for discriminating bytes in the compiled program.",92,N],[12,"only_utf8","","When true, this program can only match valid UTF-8.",92,N],[12,"is_bytes","","When true, this program uses byte range instructions instead of Unicode range instructions.",92,N],[12,"is_dfa","","When true, the program is compiled for DFA matching. For example, this implies `is_bytes` and also inserts a preceding `.*?` for unanchored regexes.",92,N],[12,"is_reverse","","When true, the program matches text in reverse (for use only in the DFA).",92,N],[12,"is_anchored_start","","Whether the regex must match from the start of the input.",92,N],[12,"is_anchored_end","","Whether the regex must match at the end of the input.",92,N],[12,"has_unicode_word_boundary","","Whether this program contains a Unicode word boundary instruction.",92,N],[12,"prefixes","","A possibly empty machine for very quickly matching prefix literals.",92,N],[12,"dfa_size_limit","","A limit on the size of the cache that the DFA is allowed to use while matching.",92,N],[3,"InstRanges","","Representation of the Ranges instruction.",N,N],[12,"goto","","The next location to execute in the program if this instruction succeeds.",97,N],[12,"ranges","","The set of Unicode scalar value ranges to test.",97,N],[4,"Inst","","Inst is an instruction code in a Regex program.",N,N],[13,"Match","","Match indicates that the program has reached a match state.",99,N],[13,"Save","","Save causes the program to save the current location of the input in the slot indicated by InstSave.",99,N],[13,"Split","","Split causes the program to diverge to one of two paths in the program, preferring goto1 in InstSplit.",99,N],[13,"EmptyLook","","EmptyLook represents a zero-width assertion in a regex program. A zero-width assertion does not consume any of the input text.",99,N],[13,"Char","","Char requires the regex program to match the character in InstChar at the current position in the input.",99,N],[13,"Ranges","","Ranges requires the regex program to match the character at the current position in the input with one of the ranges specified in InstRanges.",99,N],[13,"Bytes","","Bytes is like Ranges, except it expresses a single byte range. It is used in conjunction with Split instructions to implement multi-byte character classes.",99,N],[4,"EmptyLook","","The set of zero-width match instructions.",N,N],[13,"StartLine","","Start of line or input.",100,N],[13,"EndLine","","End of line or input.",100,N],[13,"StartText","","Start of input.",100,N],[13,"EndText","","End of input.",100,N],[13,"WordBoundary","","Word character on one side and non-word character on other.",100,N],[13,"NotWordBoundary","","Word character on both sides or non-word character on both sides.",100,N],[13,"WordBoundaryAscii","","ASCII word boundary.",100,N],[13,"NotWordBoundaryAscii","","Not ASCII word boundary.",100,N],[8,"Input","","An abstraction over input used in the matching engines.",N,N],[10,"at","","Return an encoding of the position at byte offset `i`.",77,[[["self"],["usize"]],["inputat"]]],[10,"next_char","","Return the Unicode character occurring next to `at`.",77,[[["self"],["inputat"]],["char"]]],[10,"previous_char","","Return the Unicode character occurring previous to `at`.",77,[[["self"],["inputat"]],["char"]]],[10,"is_empty_match","","Return true if the given empty width instruction matches at the input position given.",77,[[["self"],["inputat"],["instemptylook"]],["bool"]]],[10,"prefix_at","","Scan the input for a matching prefix.",77,[[["self"],["literalsearcher"],["inputat"]],["option",["inputat"]]]],[10,"len","","The number of bytes in the input.",77,[[["self"]],["usize"]]],[11,"is_empty","regex::input","Whether the input is empty.",77,[[["self"]],["bool"]]],[10,"as_bytes","regex::internal","Return the given input as a sequence of bytes.",77,N],[8,"Replacer","regex","Replacer describes types that can be used to replace matches in a string.",N,N],[10,"replace_append","","Appends text to `dst` to replace the current match.",108,[[["self"],["captures"],["string"]]]],[11,"no_expansion","regex::re_unicode","Return a fixed unchanging replacement string.",108,[[["self"]],["option",["cow"]]]],[11,"by_ref","","Return a `Replacer` that borrows and wraps this `Replacer`.",108,[[["self"]],["replacerref"]]]],"paths":[[3,"RegexBuilder"],[3,"RegexSetBuilder"],[3,"RegexSet"],[3,"SetMatches"],[3,"SetMatchesIntoIter"],[3,"SetMatchesIter"],[3,"Locations"],[3,"Regex"],[3,"Match"],[3,"Captures"],[3,"CaptureNames"],[3,"Matches"],[3,"CaptureMatches"],[3,"SubCaptureMatches"],[3,"ReplacerRef"],[3,"NoExpand"],[3,"Split"],[3,"SplitN"],[4,"Error"],[3,"RegexBuilder"],[3,"RegexSetBuilder"],[3,"Match"],[3,"Regex"],[3,"Matches"],[3,"CaptureMatches"],[3,"Split"],[3,"SplitN"],[3,"CaptureNames"],[3,"Captures"],[3,"SubCaptureMatches"],[3,"ReplacerRef"],[3,"NoExpand"],[3,"RegexSet"],[3,"SetMatches"],[3,"SetMatchesIntoIter"],[3,"SetMatchesIter"],[8,"Replacer"],[3,"Bounded"],[3,"Cache"],[4,"Job"],[3,"Patch"],[3,"Compiler"],[3,"CompileClass"],[3,"SuffixCache"],[3,"SuffixCacheEntry"],[3,"SuffixCacheKey"],[3,"ByteClassSet"],[4,"Hole"],[4,"MaybeInst"],[4,"InstHole"],[3,"Cache"],[3,"CacheInner"],[3,"Transitions"],[3,"Fsm"],[3,"State"],[3,"InstPtrs"],[3,"Byte"],[3,"EmptyFlags"],[3,"StateFlags"],[3,"TransitionsRow"],[4,"Result"],[3,"Exec"],[3,"ExecNoSync"],[3,"ExecNoSyncStr"],[3,"ExecReadOnly"],[3,"ExecBuilder"],[3,"Parsed"],[3,"ProgramCacheInner"],[4,"MatchType"],[4,"MatchLiteralType"],[4,"MatchNfaType"],[3,"CaptureRef"],[4,"Ref"],[3,"InputAt"],[3,"CharInput"],[3,"ByteInput"],[3,"Char"],[8,"Input"],[3,"LiteralSearcher"],[3,"SingleByteSet"],[3,"FreqyPacked"],[3,"BoyerMooreSearch"],[4,"Matcher"],[4,"LiteralIter"],[3,"Teddy"],[3,"Match"],[3,"Teddy"],[3,"Match"],[3,"Fsm"],[3,"Cache"],[3,"Threads"],[4,"FollowEpsilon"],[3,"Program"],[3,"InstSave"],[3,"InstSplit"],[3,"InstEmptyLook"],[3,"InstChar"],[3,"InstRanges"],[3,"InstBytes"],[4,"Inst"],[4,"EmptyLook"],[3,"RegexOptions"],[3,"CapturesDebug"],[3,"SubCapturesPosIter"],[3,"Matches"],[3,"CaptureMatches"],[8,"RegularExpression"],[3,"CapturesDebug"],[8,"Replacer"],[3,"SparseSet"]]};
searchIndex["regex_syntax"]={"doc":"This crate provides a robust regular expression parser.","items":[[3,"Parser","regex_syntax","A convenience parser for regular expressions.",N,N],[12,"ast","","",0,N],[12,"hir","","",0,N],[3,"ParserBuilder","","A builder for a regular expression parser.",N,N],[12,"ast","","",1,N],[12,"hir","","",1,N],[4,"Error","","This error type encompasses any error that can be returned by this crate.",N,N],[13,"Parse","","An error that occurred while translating concrete syntax into abstract syntax (AST).",2,N],[13,"Translate","","An error that occurred while translating abstract syntax into a high level intermediate representation (HIR).",2,N],[13,"__Nonexhaustive","","Hints that destructuring should not be exhaustive.",2,N],[5,"escape","","Escapes all regular expression meta characters in `text`.",N,[[["str"]],["string"]]],[5,"escape_into","","Escapes all meta characters in `text` and writes the result into `buf`.",N,[[["str"],["string"]]]],[5,"is_meta_character","","Returns true if the give character has significance in a regex.",N,[[["char"]],["bool"]]],[5,"is_word_character","","Returns true if and only if the given character is a Unicode word character.",N,[[["char"]],["bool"]]],[5,"is_word_byte","","Returns true if and only if the given character is an ASCII word character.",N,[[["u8"]],["bool"]]],[0,"ast","","Defines an abstract syntax for regular expressions.",N,N],[3,"Error","regex_syntax::ast","An error that occurred while parsing a regular expression into an abstract syntax tree.",N,N],[12,"kind","","The kind of error.",3,N],[12,"pattern","","The original pattern that the parser generated the error from. Every span in an error is a valid range into this string.",3,N],[12,"span","","The span of this error.",3,N],[3,"Span","","Span represents the position information of a single AST item.",N,N],[12,"start","","The start byte offset.",4,N],[12,"end","","The end byte offset.",4,N],[3,"Position","","A single position in a regular expression.",N,N],[12,"offset","","The absolute offset of this position, starting at `0` from the beginning of the regular expression pattern string.",5,N],[12,"line","","The line number, starting at `1`.",5,N],[12,"column","","The approximate column number, starting at `1`.",5,N],[3,"WithComments","","An abstract syntax tree for a singular expression along with comments found.",N,N],[12,"ast","","The actual ast.",6,N],[12,"comments","","All comments found in the original regular expression.",6,N],[3,"Comment","","A comment from a regular expression with an associated span.",N,N],[12,"span","","The span of this comment, including the beginning `#` and ending `\\n`.",7,N],[12,"comment","","The comment text, starting with the first character following the `#` and ending with the last character preceding the `\\n`.",7,N],[3,"Alternation","","An alternation of regular expressions.",N,N],[12,"span","","The span of this alternation.",8,N],[12,"asts","","The alternate regular expressions.",8,N],[3,"Concat","","A concatenation of regular expressions.",N,N],[12,"span","","The span of this concatenation.",9,N],[12,"asts","","The concatenation regular expressions.",9,N],[3,"Literal","","A single literal expression.",N,N],[12,"span","","The span of this literal.",10,N],[12,"kind","","The kind of this literal.",10,N],[12,"c","","The Unicode scalar value corresponding to this literal.",10,N],[3,"ClassPerl","","A Perl character class.",N,N],[12,"span","","The span of this class.",11,N],[12,"kind","","The kind of Perl class.",11,N],[12,"negated","","Whether the class is negated or not. e.g., `\\d` is not negated but `\\D` is.",11,N],[3,"ClassAscii","","An ASCII character class.",N,N],[12,"span","","The span of this class.",12,N],[12,"kind","","The kind of ASCII class.",12,N],[12,"negated","","Whether the class is negated or not. e.g., `[[:alpha:]]` is not negated but `[[:^alpha:]]` is.",12,N],[3,"ClassUnicode","","A Unicode character class.",N,N],[12,"span","","The span of this class.",13,N],[12,"negated","","Whether this class is negated or not.",13,N],[12,"kind","","The kind of Unicode class.",13,N],[3,"ClassBracketed","","A bracketed character class, e.g., `[a-z0-9]`.",N,N],[12,"span","","The span of this class.",14,N],[12,"negated","","Whether this class is negated or not. e.g., `[a]` is not negated but `[^a]` is.",14,N],[12,"kind","","The type of this set. A set is either a normal union of things, e.g., `[abc]` or a result of applying set operations, e.g., `[\\pL--c]`.",14,N],[3,"ClassSetRange","","A single character class range in a set.",N,N],[12,"span","","The span of this range.",15,N],[12,"start","","The start of this range.",15,N],[12,"end","","The end of this range.",15,N],[3,"ClassSetUnion","","A union of items inside a character class set.",N,N],[12,"span","","The span of the items in this operation. e.g., the `a-z0-9` in `[^a-z0-9]`",16,N],[12,"items","","The sequence of items that make up this union.",16,N],[3,"ClassSetBinaryOp","","A Unicode character class set operation.",N,N],[12,"span","","The span of this operation. e.g., the `a-z--[h-p]` in `[a-z--h-p]`.",17,N],[12,"kind","","The type of this set operation.",17,N],[12,"lhs","","The left hand side of the operation.",17,N],[12,"rhs","","The right hand side of the operation.",17,N],[3,"Assertion","","A single zero-width assertion.",N,N],[12,"span","","The span of this assertion.",18,N],[12,"kind","","The assertion kind, e.g., `\\b` or `^`.",18,N],[3,"Repetition","","A repetition operation applied to a regular expression.",N,N],[12,"span","","The span of this operation.",19,N],[12,"op","","The actual operation.",19,N],[12,"greedy","","Whether this operation was applied greedily or not.",19,N],[12,"ast","","The regular expression under repetition.",19,N],[3,"RepetitionOp","","The repetition operator itself.",N,N],[12,"span","","The span of this operator. This includes things like `+`, `*?` and `{m,n}`.",20,N],[12,"kind","","The type of operation.",20,N],[3,"Group","","A grouped regular expression.",N,N],[12,"span","","The span of this group.",21,N],[12,"kind","","The kind of this group.",21,N],[12,"ast","","The regular expression in this group.",21,N],[3,"CaptureName","","A capture name.",N,N],[12,"span","","The span of this capture name.",22,N],[12,"name","","The capture name.",22,N],[12,"index","","The capture index.",22,N],[3,"SetFlags","","A group of flags that is not applied to a particular regular expression.",N,N],[12,"span","","The span of these flags, including the grouping parentheses.",23,N],[12,"flags","","The actual sequence of flags.",23,N],[3,"Flags","","A group of flags.",N,N],[12,"span","","The span of this group of flags.",24,N],[12,"items","","A sequence of flag items. Each item is either a flag or a negation operator.",24,N],[3,"FlagsItem","","A single item in a group of flags.",N,N],[12,"span","","The span of this item.",25,N],[12,"kind","","The kind of this item.",25,N],[4,"ErrorKind","","The type of an error that occurred while building an AST.",N,N],[13,"CaptureLimitExceeded","","The capturing group limit was exceeded.",26,N],[13,"ClassEscapeInvalid","","An invalid escape sequence was found in a character class set.",26,N],[13,"ClassRangeInvalid","","An invalid character class range was found. An invalid range is any range where the start is greater than the end.",26,N],[13,"ClassRangeLiteral","","An invalid range boundary was found in a character class. Range boundaries must be a single literal codepoint, but this error indicates that something else was found, such as a nested class.",26,N],[13,"ClassUnclosed","","An opening `[` was found with no corresponding closing `]`.",26,N],[13,"DecimalEmpty","","An empty decimal number was given where one was expected.",26,N],[13,"DecimalInvalid","","An invalid decimal number was given where one was expected.",26,N],[13,"EscapeHexEmpty","","A bracketed hex literal was empty.",26,N],[13,"EscapeHexInvalid","","A bracketed hex literal did not correspond to a Unicode scalar value.",26,N],[13,"EscapeHexInvalidDigit","","An invalid hexadecimal digit was found.",26,N],[13,"EscapeUnexpectedEof","","EOF was found before an escape sequence was completed.",26,N],[13,"EscapeUnrecognized","","An unrecognized escape sequence.",26,N],[13,"FlagDanglingNegation","","A dangling negation was used when setting flags, e.g., `i-`.",26,N],[13,"FlagDuplicate","","A flag was used twice, e.g., `i-i`.",26,N],[12,"original","regex_syntax::ast::ErrorKind","The position of the original flag. The error position points to the duplicate flag.",26,N],[13,"FlagRepeatedNegation","regex_syntax::ast","The negation operator was used twice, e.g., `-i-s`.",26,N],[12,"original","regex_syntax::ast::ErrorKind","The position of the original negation operator. The error position points to the duplicate negation operator.",26,N],[13,"FlagUnexpectedEof","regex_syntax::ast","Expected a flag but got EOF, e.g., `(?`.",26,N],[13,"FlagUnrecognized","","Unrecognized flag, e.g., `a`.",26,N],[13,"GroupNameDuplicate","","A duplicate capture name was found.",26,N],[12,"original","regex_syntax::ast::ErrorKind","The position of the initial occurrence of the capture name. The error position itself points to the duplicate occurrence.",26,N],[13,"GroupNameEmpty","regex_syntax::ast","A capture group name is empty, e.g., `(?P<>abc)`.",26,N],[13,"GroupNameInvalid","","An invalid character was seen for a capture group name. This includes errors where the first character is a digit (even though subsequent characters are allowed to be digits).",26,N],[13,"GroupNameUnexpectedEof","","A closing `>` could not be found for a capture group name.",26,N],[13,"GroupUnclosed","","An unclosed group, e.g., `(ab`.",26,N],[13,"GroupUnopened","","An unopened group, e.g., `ab)`.",26,N],[13,"NestLimitExceeded","","The nest limit was exceeded. The limit stored here is the limit configured in the parser.",26,N],[13,"RepetitionCountInvalid","","The range provided in a counted repetition operator is invalid. The range is invalid if the start is greater than the end.",26,N],[13,"RepetitionCountUnclosed","","An opening `{` was found with no corresponding closing `}`.",26,N],[13,"RepetitionMissing","","A repetition operator was applied to a missing sub-expression. This occurs, for example, in the regex consisting of just a `*` or even `(?i)*`. It is, however, possible to create a repetition operating on an empty sub-expression. For example, `()*` is still considered valid.",26,N],[13,"UnsupportedBackreference","","When octal support is disabled, this error is produced when an octal escape is used. The octal escape is assumed to be an invocation of a backreference, which is the common case.",26,N],[13,"UnsupportedLookAround","","When syntax similar to PCRE's look-around is used, this error is returned. Some example syntaxes that are rejected include, but are not necessarily limited to, `(?=re)`, `(?!re)`, `(?<=re)` and `(?<!re)`. Note that all of these syntaxes are otherwise invalid; this error is used to improve the user experience.",26,N],[13,"__Nonexhaustive","","Hints that destructuring should not be exhaustive.",26,N],[4,"Ast","","An abstract syntax tree for a single regular expression.",N,N],[13,"Empty","","An empty regex that matches everything.",27,N],[13,"Flags","","A set of flags, e.g., `(?is)`.",27,N],[13,"Literal","","A single character literal, which includes escape sequences.",27,N],[13,"Dot","","The \"any character\" class.",27,N],[13,"Assertion","","A single zero-width assertion.",27,N],[13,"Class","","A single character class. This includes all forms of character classes except for `.`. e.g., `\\d`, `\\pN`, `[a-z]` and `[[:alpha:]]`.",27,N],[13,"Repetition","","A repetition operator applied to an arbitrary regular expression.",27,N],[13,"Group","","A grouped regular expression.",27,N],[13,"Alternation","","An alternation of regular expressions.",27,N],[13,"Concat","","A concatenation of regular expressions.",27,N],[4,"LiteralKind","","The kind of a single literal expression.",N,N],[13,"Verbatim","","The literal is written verbatim, e.g., `a` or `☃`.",28,N],[13,"Punctuation","","The literal is written as an escape because it is punctuation, e.g., `\\*` or `\\[`.",28,N],[13,"Octal","","The literal is written as an octal escape, e.g., `\\141`.",28,N],[13,"HexFixed","","The literal is written as a hex code with a fixed number of digits depending on the type of the escape, e.g., `\\x61` or or `\\u0061` or `\\U00000061`.",28,N],[13,"HexBrace","","The literal is written as a hex code with a bracketed number of digits. The only restriction is that the bracketed hex code must refer to a valid Unicode scalar value.",28,N],[13,"Special","","The literal is written as a specially recognized escape, e.g., `\\f` or `\\n`.",28,N],[4,"SpecialLiteralKind","","The type of a special literal.",N,N],[13,"Bell","","Bell, spelled `\\a` (`\\x07`).",29,N],[13,"FormFeed","","Form feed, spelled `\\f` (`\\x0C`).",29,N],[13,"Tab","","Tab, spelled `\\t` (`\\x09`).",29,N],[13,"LineFeed","","Line feed, spelled `\\n` (`\\x0A`).",29,N],[13,"CarriageReturn","","Carriage return, spelled `\\r` (`\\x0D`).",29,N],[13,"VerticalTab","","Vertical tab, spelled `\\v` (`\\x0B`).",29,N],[13,"Space","","Space, spelled `\\` (`\\x20`). Note that this can only appear when parsing in verbose mode.",29,N],[4,"HexLiteralKind","","The type of a Unicode hex literal.",N,N],[13,"X","","A `\\x` prefix. When used without brackets, this form is limited to two digits.",30,N],[13,"UnicodeShort","","A `\\u` prefix. When used without brackets, this form is limited to four digits.",30,N],[13,"UnicodeLong","","A `\\U` prefix. When used without brackets, this form is limited to eight digits.",30,N],[4,"Class","","A single character class expression.",N,N],[13,"Unicode","","A Unicode character class, e.g., `\\pL` or `\\p{Greek}`.",31,N],[13,"Perl","","A perl character class, e.g., `\\d` or `\\W`.",31,N],[13,"Bracketed","","A bracketed character class set, which may contain zero or more character ranges and/or zero or more nested classes. e.g., `[a-zA-Z\\pL]`.",31,N],[4,"ClassPerlKind","","The available Perl character classes.",N,N],[13,"Digit","","Decimal numbers.",32,N],[13,"Space","","Whitespace.",32,N],[13,"Word","","Word characters.",32,N],[4,"ClassAsciiKind","","The available ASCII character classes.",N,N],[13,"Alnum","","`[0-9A-Za-z]`",33,N],[13,"Alpha","","`[A-Za-z]`",33,N],[13,"Ascii","","`[\\x00-\\x7F]`",33,N],[13,"Blank","","`[ \\t]`",33,N],[13,"Cntrl","","`[\\x00-\\x1F\\x7F]`",33,N],[13,"Digit","","`[0-9]`",33,N],[13,"Graph","","`[!-~]`",33,N],[13,"Lower","","`[a-z]`",33,N],[13,"Print","","`[ -~]`",33,N],[13,"Punct","","`[!-/:-@\\[-`{-~]`",33,N],[13,"Space","","`[\\t\\n\\v\\f\\r ]`",33,N],[13,"Upper","","`[A-Z]`",33,N],[13,"Word","","`[0-9A-Za-z_]`",33,N],[13,"Xdigit","","`[0-9A-Fa-f]`",33,N],[4,"ClassUnicodeKind","","The available forms of Unicode character classes.",N,N],[13,"OneLetter","","A one letter abbreviated class, e.g., `\\pN`.",34,N],[13,"Named","","A binary property, general category or script. The string may be empty.",34,N],[13,"NamedValue","","A property name and an associated value.",34,N],[12,"op","regex_syntax::ast::ClassUnicodeKind","The type of Unicode op used to associate `name` with `value`.",34,N],[12,"name","","The property name (which may be empty).",34,N],[12,"value","","The property value (which may be empty).",34,N],[4,"ClassUnicodeOpKind","regex_syntax::ast","The type of op used in a Unicode character class.",N,N],[13,"Equal","","A property set to a specific value, e.g., `\\p{scx=Katakana}`.",35,N],[13,"Colon","","A property set to a specific value using a colon, e.g., `\\p{scx:Katakana}`.",35,N],[13,"NotEqual","","A property that isn't a particular value, e.g., `\\p{scx!=Katakana}`.",35,N],[4,"ClassSet","","A character class set.",N,N],[13,"Item","","An item, which can be a single literal, range, nested character class or a union of items.",36,N],[13,"BinaryOp","","A single binary operation (i.e., &&, -- or ~~).",36,N],[4,"ClassSetItem","","A single component of a character class set.",N,N],[13,"Empty","","An empty item.",37,N],[13,"Literal","","A single literal.",37,N],[13,"Range","","A range between two literals.",37,N],[13,"Ascii","","An ASCII character class, e.g., `[:alnum:]` or `[:punct:]`.",37,N],[13,"Unicode","","A Unicode character class, e.g., `\\pL` or `\\p{Greek}`.",37,N],[13,"Perl","","A perl character class, e.g., `\\d` or `\\W`.",37,N],[13,"Bracketed","","A bracketed character class set, which may contain zero or more character ranges and/or zero or more nested classes. e.g., `[a-zA-Z\\pL]`.",37,N],[13,"Union","","A union of items.",37,N],[4,"ClassSetBinaryOpKind","","The type of a Unicode character class set operation.",N,N],[13,"Intersection","","The intersection of two sets, e.g., `\\pN&&[a-z]`.",38,N],[13,"Difference","","The difference of two sets, e.g., `\\pN--[0-9]`.",38,N],[13,"SymmetricDifference","","The symmetric difference of two sets. The symmetric difference is the set of elements belonging to one but not both sets. e.g., `[\\pL~~[:ascii:]]`.",38,N],[4,"AssertionKind","","An assertion kind.",N,N],[13,"StartLine","","`^`",39,N],[13,"EndLine","","`$`",39,N],[13,"StartText","","`\\A`",39,N],[13,"EndText","","`\\z`",39,N],[13,"WordBoundary","","`\\b`",39,N],[13,"NotWordBoundary","","`\\B`",39,N],[4,"RepetitionKind","","The kind of a repetition operator.",N,N],[13,"ZeroOrOne","","`?`",40,N],[13,"ZeroOrMore","","`*`",40,N],[13,"OneOrMore","","`+`",40,N],[13,"Range","","`{m,n}`",40,N],[4,"RepetitionRange","","A range repetition operator.",N,N],[13,"Exactly","","`{m}`",41,N],[13,"AtLeast","","`{m,}`",41,N],[13,"Bounded","","`{m,n}`",41,N],[4,"GroupKind","","The kind of a group.",N,N],[13,"CaptureIndex","","`(a)`",42,N],[13,"CaptureName","","`(?P<name>a)`",42,N],[13,"NonCapturing","","`(?:a)` and `(?i:a)`",42,N],[4,"FlagsItemKind","","The kind of an item in a group of flags.",N,N],[13,"Negation","","A negation operator applied to all subsequent flags in the enclosing group.",43,N],[13,"Flag","","A single flag in a group.",43,N],[4,"Flag","","A single flag.",N,N],[13,"CaseInsensitive","","`i`",44,N],[13,"MultiLine","","`m`",44,N],[13,"DotMatchesNewLine","","`s`",44,N],[13,"SwapGreed","","`U`",44,N],[13,"Unicode","","`u`",44,N],[13,"IgnoreWhitespace","","`x`",44,N],[5,"visit","","Executes an implementation of `Visitor` in constant stack space.",N,[[["ast"],["v"]],["result"]]],[0,"parse","","This module provides a regular expression parser.",N,N],[3,"ParserBuilder","regex_syntax::ast::parse","A builder for a regular expression parser.",N,N],[12,"ignore_whitespace","","",45,N],[12,"nest_limit","","",45,N],[12,"octal","","",45,N],[3,"Parser","","A regular expression parser.",N,N],[12,"pos","","The current position of the parser.",46,N],[12,"capture_index","","The current capture index.",46,N],[12,"nest_limit","","The maximum number of open parens/brackets allowed. If the parser exceeds this number, then an error is returned.",46,N],[12,"octal","","Whether to support octal syntax or not. When `false`, the parser will return an error helpfully pointing out that backreferences are not supported.",46,N],[12,"initial_ignore_whitespace","","The initial setting for `ignore_whitespace` as provided by Th`ParserBuilder`. is is used when reseting the parser's state.",46,N],[12,"ignore_whitespace","","Whether whitespace should be ignored. When enabled, comments are also permitted.",46,N],[12,"comments","","A list of comments, in order of appearance.",46,N],[12,"stack_group","","A stack of grouped sub-expressions, including alternations.",46,N],[12,"stack_class","","A stack of nested character classes. This is only non-empty when parsing a class.",46,N],[12,"capture_names","","A sorted sequence of capture names. This is used to detect duplicate capture names and report an error if one is detected.",46,N],[12,"scratch","","A scratch buffer used in various places. Mostly this is used to accumulate relevant characters from parts of a pattern.",46,N],[3,"ParserI","","ParserI is the internal parser implementation.",N,N],[12,"parser","","The parser state/configuration.",47,N],[12,"pattern","","The full regular expression provided by the user.",47,N],[3,"NestLimiter","","A type that traverses a fully parsed Ast and checks whether its depth exceeds the specified nesting limit. If it does, then an error is returned.",N,N],[12,"p","","The parser that is checking the nest limit.",48,N],[12,"depth","","The current depth while walking an Ast.",48,N],[4,"Primitive","","A primitive is an expression with no sub-expressions. This includes literals, assertions and non-set character classes. This representation is used as intermediate state in the parser.",N,N],[13,"Literal","","",49,N],[13,"Assertion","","",49,N],[13,"Dot","","",49,N],[13,"Perl","","",49,N],[13,"Unicode","","",49,N],[4,"GroupState","","GroupState represents a single stack frame while parsing nested groups and alternations. Each frame records the state up to an opening parenthesis or a alternating bracket `|`.",N,N],[13,"Group","","This state is pushed whenever an opening group is found.",50,N],[12,"concat","regex_syntax::ast::parse::GroupState","The concatenation immediately preceding the opening group.",50,N],[12,"group","","The group that has been opened. Its sub-AST is always empty.",50,N],[12,"ignore_whitespace","","Whether this group has the `x` flag enabled or not.",50,N],[13,"Alternation","regex_syntax::ast::parse","This state is pushed whenever a new alternation branch is found. If an alternation branch is found and this state is at the top of the stack, then this state should be modified to include the new alternation.",50,N],[4,"ClassState","","ClassState represents a single stack frame while parsing character classes. Each frame records the state up to an intersection, difference, symmetric difference or nested class.",N,N],[13,"Open","","This state is pushed whenever an opening bracket is found.",51,N],[12,"union","regex_syntax::ast::parse::ClassState","The union of class items immediately preceding this class.",51,N],[12,"set","","The class that has been opened. Typically this just corresponds to the `[`, but it can also include `[^` since `^` indicates negation of the class.",51,N],[13,"Op","regex_syntax::ast::parse","This state is pushed when a operator is seen. When popped, the stored set becomes the left hand side of the operator.",51,N],[12,"kind","regex_syntax::ast::parse::ClassState","The type of the operation, i.e., &&, -- or ~~.",51,N],[12,"lhs","","The left-hand side of the operator.",51,N],[5,"is_hex","regex_syntax::ast::parse","Returns true if the given character is a hexadecimal digit.",N,[[["char"]],["bool"]]],[5,"is_capture_char","","Returns true if the given character is a valid in a capture group name.",N,[[["char"],["bool"]],["bool"]]],[6,"Result","","",N,N],[11,"clone","","",49,[[["self"]],["primitive"]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",49,N],[11,"eq","","",49,[[["self"],["primitive"]],["bool"]]],[11,"ne","","",49,[[["self"],["primitive"]],["bool"]]],[11,"span","","Return the span of this primitive.",49,[[["self"]],["span"]]],[11,"into_ast","","Convert this primitive into a proper AST.",49,[[["self"]],["ast"]]],[11,"into_class_set_item","","Convert this primitive into an item in a character class.",49,[[["self"],["parseri"]],["result",["classsetitem","error"]]]],[11,"into_class_literal","","Convert this primitive into a literal in a character class. In particular, literals are the only valid items that can appear in ranges.",49,[[["self"],["parseri"]],["result",["literal","error"]]]],[11,"clone","","",45,[[["self"]],["parserbuilder"]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"default","","",45,[[],["parserbuilder"]]],[11,"new","","Create a new parser builder with a default configuration.",45,[[],["parserbuilder"]]],[11,"build","","Build a parser from this configuration with the given pattern.",45,[[["self"]],["parser"]]],[11,"nest_limit","","Set the nesting limit for this parser.",45,[[["self"],["u32"]],["parserbuilder"]]],[11,"octal","","Whether to support octal syntax or not.",45,[[["self"],["bool"]],["parserbuilder"]]],[11,"ignore_whitespace","","Enable verbose mode in the regular expression.",45,[[["self"],["bool"]],["parserbuilder"]]],[11,"clone","","",46,[[["self"]],["parser"]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"clone","","",47,[[["self"]],["parseri"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"clone","","",50,[[["self"]],["groupstate"]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"clone","","",51,[[["self"]],["classstate"]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new parser with a default configuration.",46,[[],["parser"]]],[11,"parse","","Parse the regular expression into an abstract syntax tree.",46,[[["self"],["str"]],["result",["ast","error"]]]],[11,"parse_with_comments","","Parse the regular expression and return an abstract syntax tree with all of the comments found in the pattern.",46,[[["self"],["str"]],["result",["withcomments","error"]]]],[11,"reset","","Reset the internal state of a parser.",46,[[["self"]]]],[11,"new","","Build an internal parser from a parser configuration and a pattern.",47,[[["p"],["str"]],["parseri"]]],[11,"parser","","Return a reference to the parser state.",47,[[["self"]],["parser"]]],[11,"pattern","","Return a reference to the pattern being parsed.",47,[[["self"]],["str"]]],[11,"error","","Create a new error with the given span and error type.",47,[[["self"],["span"],["errorkind"]],["error"]]],[11,"offset","","Return the current offset of the parser.",47,[[["self"]],["usize"]]],[11,"line","","Return the current line number of the parser.",47,[[["self"]],["usize"]]],[11,"column","","Return the current column of the parser.",47,[[["self"]],["usize"]]],[11,"next_capture_index","","Return the next capturing index. Each subsequent call increments the internal index.",47,[[["self"],["span"]],["result",["u32","error"]]]],[11,"add_capture_name","","Adds the given capture name to this parser. If this capture name has already been used, then an error is returned.",47,[[["self"],["capturename"]],["result",["error"]]]],[11,"ignore_whitespace","","Return whether the parser should ignore whitespace or not.",47,[[["self"]],["bool"]]],[11,"char","","Return the character at the current position of the parser.",47,[[["self"]],["char"]]],[11,"char_at","","Return the character at the given position.",47,[[["self"],["usize"]],["char"]]],[11,"bump","","Bump the parser to the next Unicode scalar value.",47,[[["self"]],["bool"]]],[11,"bump_if","","If the substring starting at the current position of the parser has the given prefix, then bump the parser to the character immediately following the prefix and return true. Otherwise, don't bump the parser and return false.",47,[[["self"],["str"]],["bool"]]],[11,"is_lookaround_prefix","","Returns true if and only if the parser is positioned at a look-around prefix. The conditions under which this returns true must always correspond to a regular expression that would otherwise be consider invalid.",47,[[["self"]],["bool"]]],[11,"bump_and_bump_space","","Bump the parser, and if the `x` flag is enabled, bump through any subsequent spaces. Return true if and only if the parser is not at EOF.",47,[[["self"]],["bool"]]],[11,"bump_space","","If the `x` flag is enabled (i.e., whitespace insensitivity with comments), then this will advance the parser through all whitespace and comments to the next non-whitespace non-comment byte.",47,[[["self"]]]],[11,"peek","","Peek at the next character in the input without advancing the parser.",47,[[["self"]],["option",["char"]]]],[11,"peek_space","","Like peek, but will ignore spaces when the parser is in whitespace insensitive mode.",47,[[["self"]],["option",["char"]]]],[11,"is_eof","","Returns true if the next call to `bump` would return false.",47,[[["self"]],["bool"]]],[11,"pos","","Return the current position of the parser, which includes the offset, line and column.",47,[[["self"]],["position"]]],[11,"span","","Create a span at the current position of the parser. Both the start and end of the span are set.",47,[[["self"]],["span"]]],[11,"span_char","","Create a span that covers the current character.",47,[[["self"]],["span"]]],[11,"push_alternate","","Parse and push a single alternation on to the parser's internal stack. If the top of the stack already has an alternation, then add to that instead of pushing a new one.",47,[[["self"],["concat"]],["result",["concat","error"]]]],[11,"push_or_add_alternation","","Pushes or adds the given branch of an alternation to the parser's internal stack of state.",47,[[["self"],["concat"]]]],[11,"push_group","","Parse and push a group AST (and its parent concatenation) on to the parser's internal stack. Return a fresh concatenation corresponding to the group's sub-AST.",47,[[["self"],["concat"]],["result",["concat","error"]]]],[11,"pop_group","","Pop a group AST from the parser's internal stack and set the group's AST to the given concatenation. Return the concatenation containing the group.",47,[[["self"],["concat"]],["result",["concat","error"]]]],[11,"pop_group_end","","Pop the last state from the parser's internal stack, if it exists, and add the given concatenation to it. There either must be no state or a single alternation item on the stack. Any other scenario produces an error.",47,[[["self"],["concat"]],["result",["ast","error"]]]],[11,"push_class_open","","Parse the opening of a character class and push the current class parsing context onto the parser's stack. This assumes that the parser is positioned at an opening `[`. The given union should correspond to the union of set items built up before seeing the `[`.",47,[[["self"],["classsetunion"]],["result",["classsetunion","error"]]]],[11,"pop_class","","Parse the end of a character class set and pop the character class parser stack. The union given corresponds to the last union built before seeing the closing `]`. The union returned corresponds to the parent character class set with the nested class added to it.",47,[[["self"],["classsetunion"]],["result",["either","error"]]]],[11,"unclosed_class_error","","Return an \"unclosed class\" error whose span points to the most recently opened class.",47,[[["self"]],["error"]]],[11,"push_class_op","","Push the current set of class items on to the class parser's stack as the left hand side of the given operator.",47,[[["self"],["classsetbinaryopkind"],["classsetunion"]],["classsetunion"]]],[11,"pop_class_op","","Pop a character class set from the character class parser stack. If the top of the stack is just an item (not an operation), then return the given set unchanged. If the top of the stack is an operation, then the given set will be used as the rhs of the operation on the top of the stack. In that case, the binary operation is returned as a set.",47,[[["self"],["classset"]],["classset"]]],[11,"parse","","Parse the regular expression into an abstract syntax tree.",47,[[["self"]],["result",["ast","error"]]]],[11,"parse_with_comments","","Parse the regular expression and return an abstract syntax tree with all of the comments found in the pattern.",47,[[["self"]],["result",["withcomments","error"]]]],[11,"parse_uncounted_repetition","","Parses an uncounted repetition operation. An uncounted repetition operator includes ?, * and +, but does not include the {m,n} syntax. The given `kind` should correspond to the operator observed by the caller.",47,[[["self"],["concat"],["repetitionkind"]],["result",["concat","error"]]]],[11,"parse_counted_repetition","","Parses a counted repetition operation. A counted repetition operator corresponds to the {m,n} syntax, and does not include the ?, * or + operators.",47,[[["self"],["concat"]],["result",["concat","error"]]]],[11,"parse_group","","Parse a group (which contains a sub-expression) or a set of flags.",47,[[["self"]],["result",["either","error"]]]],[11,"parse_capture_name","","Parses a capture group name. Assumes that the parser is positioned at the first character in the name following the opening `<` (and may possibly be EOF). This advances the parser to the first character following the closing `>`.",47,[[["self"],["u32"]],["result",["capturename","error"]]]],[11,"parse_flags","","Parse a sequence of flags starting at the current character.",47,[[["self"]],["result",["flags","error"]]]],[11,"parse_flag","","Parse the current character as a flag. Do not advance the parser.",47,[[["self"]],["result",["flag","error"]]]],[11,"parse_primitive","","Parse a primitive AST. e.g., A literal, non-set character class or assertion.",47,[[["self"]],["result",["primitive","error"]]]],[11,"parse_escape","","Parse an escape sequence as a primitive AST.",47,[[["self"]],["result",["primitive","error"]]]],[11,"parse_octal","","Parse an octal representation of a Unicode codepoint up to 3 digits long. This expects the parser to be positioned at the first octal digit and advances the parser to the first character immediately following the octal number. This also assumes that parsing octal escapes is enabled.",47,[[["self"]],["literal"]]],[11,"parse_hex","","Parse a hex representation of a Unicode codepoint. This handles both hex notations, i.e., `\\xFF` and `\\x{FFFF}`. This expects the parser to be positioned at the `x`, `u` or `U` prefix. The parser is advanced to the first character immediately following the hexadecimal literal.",47,[[["self"]],["result",["literal","error"]]]],[11,"parse_hex_digits","","Parse an N-digit hex representation of a Unicode codepoint. This expects the parser to be positioned at the first digit and will advance the parser to the first character immediately following the escape sequence.",47,[[["self"],["hexliteralkind"]],["result",["literal","error"]]]],[11,"parse_hex_brace","","Parse a hex representation of any Unicode scalar value. This expects the parser to be positioned at the opening brace `{` and will advance the parser to the first character following the closing brace `}`.",47,[[["self"],["hexliteralkind"]],["result",["literal","error"]]]],[11,"parse_decimal","","Parse a decimal number into a u32 while trimming leading and trailing whitespace.",47,[[["self"]],["result",["u32","error"]]]],[11,"parse_set_class","","Parse a standard character class consisting primarily of characters or character ranges, but can also contain nested character classes of any type (sans `.`).",47,[[["self"]],["result",["class","error"]]]],[11,"parse_set_class_range","","Parse a single primitive item in a character class set. The item to be parsed can either be one of a simple literal character, a range between two simple literal characters or a \"primitive\" character class like \\w or \\p{Greek}.",47,[[["self"]],["result",["classsetitem","error"]]]],[11,"parse_set_class_item","","Parse a single item in a character class as a primitive, where the primitive either consists of a verbatim literal or a single escape sequence.",47,[[["self"]],["result",["primitive","error"]]]],[11,"parse_set_class_open","","Parses the opening of a character class set. This includes the opening bracket along with `^` if present to indicate negation. This also starts parsing the opening set of unioned items if applicable, since there are special rules applied to certain characters in the opening of a character class. For example, `[^]]` is the class of all characters not equal to `]`. (`]` would need to be escaped in any other position.) Similarly for `-`.",47,[[["self"]],["result",["error"]]]],[11,"maybe_parse_ascii_class","","Attempt to parse an ASCII character class, e.g., `[:alnum:]`.",47,[[["self"]],["option",["classascii"]]]],[11,"parse_unicode_class","","Parse a Unicode class in either the single character notation, `\\pN` or the multi-character bracketed notation, `\\p{Greek}`. This assumes the parser is positioned at the `p` (or `P` for negation) and will advance the parser to the character immediately following the class.",47,[[["self"]],["result",["classunicode","error"]]]],[11,"parse_perl_class","","Parse a Perl character class, e.g., `\\d` or `\\W`. This assumes the parser is currently at a valid character class name and will be advanced to the character immediately following the class.",47,[[["self"]],["classperl"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"new","","",48,[[["parseri"]],["nestlimiter"]]],[11,"check","","",48,[[["self"],["ast"]],["result",["error"]]]],[11,"increment_depth","","",48,[[["self"],["span"]],["result",["error"]]]],[11,"decrement_depth","","",48,[[["self"]]]],[11,"finish","","",48,[[["self"]],["result",["error"]]]],[11,"visit_pre","","",48,[[["self"],["ast"]],["result",["error"]]]],[11,"visit_post","","",48,[[["self"],["ast"]],["result",["error"]]]],[11,"visit_class_set_item_pre","","",48,[[["self"],["classsetitem"]],["result",["error"]]]],[11,"visit_class_set_item_post","","",48,[[["self"],["classsetitem"]],["result",["error"]]]],[11,"visit_class_set_binary_op_pre","","",48,[[["self"],["classsetbinaryop"]],["result",["error"]]]],[11,"visit_class_set_binary_op_post","","",48,[[["self"],["classsetbinaryop"]],["result",["error"]]]],[0,"print","regex_syntax::ast","This module provides a regular expression printer for `Ast`.",N,N],[3,"PrinterBuilder","regex_syntax::ast::print","A builder for constructing a printer.",N,N],[12,"_priv","","",52,N],[3,"Printer","","A printer for a regular expression abstract syntax tree.",N,N],[12,"_priv","","",53,N],[3,"Writer","","",N,N],[12,"printer","","",54,N],[12,"wtr","","",54,N],[11,"clone","","",52,[[["self"]],["printerbuilder"]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"default","","",52,[[],["printerbuilder"]]],[11,"new","","",52,[[],["printerbuilder"]]],[11,"build","","",52,[[["self"]],["printer"]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new printer.",53,[[],["printer"]]],[11,"print","","Print the given `Ast` to the given writer. The writer must implement `fmt::Write`. Typical implementations of `fmt::Write` that can be used here are a `fmt::Formatter` (which is available in `fmt::Display` implementations) or a `&mut String`.",53,[[["self"],["ast"],["w"]],["result"]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"finish","","",54,[[["self"]],["result"]]],[11,"visit_pre","","",54,[[["self"],["ast"]],["result"]]],[11,"visit_post","","",54,[[["self"],["ast"]],["result"]]],[11,"visit_alternation_in","","",54,[[["self"]],["result"]]],[11,"visit_class_set_item_pre","","",54,[[["self"],["classsetitem"]],["result"]]],[11,"visit_class_set_item_post","","",54,[[["self"],["classsetitem"]],["result"]]],[11,"visit_class_set_binary_op_in","","",54,[[["self"],["classsetbinaryop"]],["result"]]],[11,"fmt_group_pre","","",54,[[["self"],["group"]],["result"]]],[11,"fmt_group_post","","",54,[[["self"],["group"]],["result"]]],[11,"fmt_repetition","","",54,[[["self"],["repetition"]],["result"]]],[11,"fmt_repetition_range","","",54,[[["self"],["repetitionrange"]],["result"]]],[11,"fmt_literal","","",54,[[["self"],["literal"]],["result"]]],[11,"fmt_assertion","","",54,[[["self"],["assertion"]],["result"]]],[11,"fmt_set_flags","","",54,[[["self"],["setflags"]],["result"]]],[11,"fmt_flags","","",54,[[["self"],["flags"]],["result"]]],[11,"fmt_class_bracketed_pre","","",54,[[["self"],["classbracketed"]],["result"]]],[11,"fmt_class_bracketed_post","","",54,[[["self"],["classbracketed"]],["result"]]],[11,"fmt_class_set_binary_op_kind","","",54,[[["self"],["classsetbinaryopkind"]],["result"]]],[11,"fmt_class_perl","","",54,[[["self"],["classperl"]],["result"]]],[11,"fmt_class_ascii","","",54,[[["self"],["classascii"]],["result"]]],[11,"fmt_class_unicode","","",54,[[["self"],["classunicode"]],["result"]]],[0,"visitor","regex_syntax::ast","",N,N],[3,"HeapVisitor","regex_syntax::ast::visitor","HeapVisitor visits every item in an `Ast` recursively using constant stack size and a heap size proportional to the size of the `Ast`.",N,N],[12,"stack","","A stack of `Ast` nodes. This is roughly analogous to the call stack used in a typical recursive visitor.",55,N],[12,"stack_class","","Similar to the `Ast` stack above, but is used only for character classes. In particular, character classes embed their own mini recursive syntax.",55,N],[4,"Frame","","Represents a single stack frame while performing structural induction over an `Ast`.",N,N],[13,"Repetition","","A stack frame allocated just before descending into a repetition operator's child node.",56,N],[13,"Group","","A stack frame allocated just before descending into a group's child node.",56,N],[13,"Concat","","The stack frame used while visiting every child node of a concatenation of expressions.",56,N],[12,"head","regex_syntax::ast::visitor::Frame","The child node we are currently visiting.",56,N],[12,"tail","","The remaining child nodes to visit (which may be empty).",56,N],[13,"Alternation","regex_syntax::ast::visitor","The stack frame used while visiting every child node of an alternation of expressions.",56,N],[12,"head","regex_syntax::ast::visitor::Frame","The child node we are currently visiting.",56,N],[12,"tail","","The remaining child nodes to visit (which may be empty).",56,N],[4,"ClassFrame","regex_syntax::ast::visitor","Represents a single stack frame while performing structural induction over a character class.",N,N],[13,"Union","","The stack frame used while visiting every child node of a union of character class items.",57,N],[12,"head","regex_syntax::ast::visitor::ClassFrame","The child node we are currently visiting.",57,N],[12,"tail","","The remaining child nodes to visit (which may be empty).",57,N],[13,"Binary","regex_syntax::ast::visitor","The stack frame used while a binary class operation.",57,N],[12,"op","regex_syntax::ast::visitor::ClassFrame","",57,N],[13,"BinaryLHS","regex_syntax::ast::visitor","A stack frame allocated just before descending into a binary operator's left hand child node.",57,N],[12,"op","regex_syntax::ast::visitor::ClassFrame","",57,N],[12,"lhs","","",57,N],[12,"rhs","","",57,N],[13,"BinaryRHS","regex_syntax::ast::visitor","A stack frame allocated just before descending into a binary operator's right hand child node.",57,N],[12,"op","regex_syntax::ast::visitor::ClassFrame","",57,N],[12,"rhs","","",57,N],[4,"ClassInduct","regex_syntax::ast::visitor","A representation of the inductive step when performing structural induction over a character class.",N,N],[13,"Item","","",58,N],[13,"BinaryOp","","",58,N],[5,"visit","","Executes an implementation of `Visitor` in constant stack space.",N,[[["ast"],["v"]],["result"]]],[8,"Visitor","","A trait for visiting an abstract syntax tree (AST) in depth first order.",N,N],[16,"Output","","The result of visiting an AST.",59,N],[16,"Err","","An error that visiting an AST might return.",59,N],[10,"finish","","All implementors of `Visitor` must provide a `finish` method, which yields the result of visiting the AST or an error.",59,[[["self"]],["result"]]],[11,"start","","This method is called before beginning traversal of the AST.",59,[[["self"]]]],[11,"visit_pre","","This method is called on an `Ast` before descending into child `Ast` nodes.",59,[[["self"],["ast"]],["result"]]],[11,"visit_post","","This method is called on an `Ast` after descending all of its child `Ast` nodes.",59,[[["self"],["ast"]],["result"]]],[11,"visit_alternation_in","","This method is called between child nodes of an `Alternation`.",59,[[["self"]],["result"]]],[11,"visit_class_set_item_pre","","This method is called on every `ClassSetItem` before descending into child nodes.",59,[[["self"],["classsetitem"]],["result"]]],[11,"visit_class_set_item_post","","This method is called on every `ClassSetItem` after descending into child nodes.",59,[[["self"],["classsetitem"]],["result"]]],[11,"visit_class_set_binary_op_pre","","This method is called on every `ClassSetBinaryOp` before descending into child nodes.",59,[[["self"],["classsetbinaryop"]],["result"]]],[11,"visit_class_set_binary_op_post","","This method is called on every `ClassSetBinaryOp` after descending into child nodes.",59,[[["self"],["classsetbinaryop"]],["result"]]],[11,"visit_class_set_binary_op_in","","This method is called between the left hand and right hand child nodes of a `ClassSetBinaryOp`.",59,[[["self"],["classsetbinaryop"]],["result"]]],[11,"new","","",55,[[],["heapvisitor"]]],[11,"visit","","",55,[[["self"],["ast"],["v"]],["result"]]],[11,"induct","","Build a stack frame for the given AST if one is needed (which occurs if and only if there are child nodes in the AST). Otherwise, return None.",55,[[["self"],["ast"],["v"]],["result",["option"]]]],[11,"pop","","Pops the given frame. If the frame has an additional inductive step, then return it, otherwise return `None`.",55,[[["self"],["frame"]],["option",["frame"]]]],[11,"visit_class","","",55,[[["self"],["classbracketed"],["v"]],["result"]]],[11,"visit_class_pre","","Call the appropriate `Visitor` methods given an inductive step.",55,[[["self"],["classinduct"],["v"]],["result"]]],[11,"visit_class_post","","Call the appropriate `Visitor` methods given an inductive step.",55,[[["self"],["classinduct"],["v"]],["result"]]],[11,"induct_class","","Build a stack frame for the given class node if one is needed (which occurs if and only if there are child nodes). Otherwise, return None.",55,[[["self"],["classinduct"]],["option",["classframe"]]]],[11,"pop_class","","Pops the given frame. If the frame has an additional inductive step, then return it, otherwise return `None`.",55,[[["self"],["classframe"]],["option",["classframe"]]]],[11,"child","","Perform the next inductive step on this frame and return the next child AST node to visit.",56,[[["self"]],["ast"]]],[11,"child","","Perform the next inductive step on this frame and return the next child class node to visit.",57,[[["self"]],["classinduct"]]],[11,"from_bracketed","","",58,[[["classbracketed"]],["classinduct"]]],[11,"from_set","","",58,[[["classset"]],["classinduct"]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[8,"Visitor","regex_syntax::ast","A trait for visiting an abstract syntax tree (AST) in depth first order.",N,N],[16,"Output","","The result of visiting an AST.",59,N],[16,"Err","","An error that visiting an AST might return.",59,N],[10,"finish","","All implementors of `Visitor` must provide a `finish` method, which yields the result of visiting the AST or an error.",59,[[["self"]],["result"]]],[11,"start","regex_syntax::ast::visitor","This method is called before beginning traversal of the AST.",59,[[["self"]]]],[11,"visit_pre","","This method is called on an `Ast` before descending into child `Ast` nodes.",59,[[["self"],["ast"]],["result"]]],[11,"visit_post","","This method is called on an `Ast` after descending all of its child `Ast` nodes.",59,[[["self"],["ast"]],["result"]]],[11,"visit_alternation_in","","This method is called between child nodes of an `Alternation`.",59,[[["self"]],["result"]]],[11,"visit_class_set_item_pre","","This method is called on every `ClassSetItem` before descending into child nodes.",59,[[["self"],["classsetitem"]],["result"]]],[11,"visit_class_set_item_post","","This method is called on every `ClassSetItem` after descending into child nodes.",59,[[["self"],["classsetitem"]],["result"]]],[11,"visit_class_set_binary_op_pre","","This method is called on every `ClassSetBinaryOp` before descending into child nodes.",59,[[["self"],["classsetbinaryop"]],["result"]]],[11,"visit_class_set_binary_op_post","","This method is called on every `ClassSetBinaryOp` after descending into child nodes.",59,[[["self"],["classsetbinaryop"]],["result"]]],[11,"visit_class_set_binary_op_in","","This method is called between the left hand and right hand child nodes of a `ClassSetBinaryOp`.",59,[[["self"],["classsetbinaryop"]],["result"]]],[11,"clone","regex_syntax::ast","",3,[[["self"]],["error"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"eq","","",3,[[["self"],["error"]],["bool"]]],[11,"ne","","",3,[[["self"],["error"]],["bool"]]],[11,"kind","","Return the type of this error.",3,[[["self"]],["errorkind"]]],[11,"pattern","","The original pattern string in which this error occurred.",3,[[["self"]],["str"]]],[11,"span","","Return the span at which this error occurred.",3,[[["self"]],["span"]]],[11,"auxiliary_span","","Return an auxiliary span. This span exists only for some errors that benefit from being able to point to two locations in the original regular expression. For example, \"duplicate\" errors will have the main error position set to the duplicate occurrence while its auxiliary span will be set to the initial occurrence.",3,[[["self"]],["option",["span"]]]],[11,"clone","","",26,[[["self"]],["errorkind"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",26,N],[11,"eq","","",26,[[["self"],["errorkind"]],["bool"]]],[11,"ne","","",26,[[["self"],["errorkind"]],["bool"]]],[11,"description","","",3,[[["self"]],["str"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["span"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"eq","","",4,[[["self"],["span"]],["bool"]]],[11,"ne","","",4,[[["self"],["span"]],["bool"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"cmp","","",4,[[["self"],["span"]],["ordering"]]],[11,"partial_cmp","","",4,[[["self"],["span"]],["option",["ordering"]]]],[11,"clone","","",5,[[["self"]],["position"]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"eq","","",5,[[["self"],["position"]],["bool"]]],[11,"ne","","",5,[[["self"],["position"]],["bool"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"cmp","","",5,[[["self"],["position"]],["ordering"]]],[11,"partial_cmp","","",5,[[["self"],["position"]],["option",["ordering"]]]],[11,"new","","Create a new span with the given positions.",4,[[["position"],["position"]],["span"]]],[11,"splat","","Create a new span using the given position as the start and end.",4,[[["position"]],["span"]]],[11,"with_start","","Create a new span by replacing the starting the position with the one given.",4,[[["self"],["position"]],["span"]]],[11,"with_end","","Create a new span by replacing the ending the position with the one given.",4,[[["self"],["position"]],["span"]]],[11,"is_one_line","","Returns true if and only if this span occurs on a single line.",4,[[["self"]],["bool"]]],[11,"is_empty","","Returns true if and only if this span is empty. That is, it points to a single position in the concrete syntax of a regular expression.",4,[[["self"]],["bool"]]],[11,"new","","Create a new position with the given information.",5,[[["usize"],["usize"],["usize"]],["position"]]],[11,"clone","","",6,[[["self"]],["withcomments"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"eq","","",6,[[["self"],["withcomments"]],["bool"]]],[11,"ne","","",6,[[["self"],["withcomments"]],["bool"]]],[11,"clone","","",7,[[["self"]],["comment"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"eq","","",7,[[["self"],["comment"]],["bool"]]],[11,"ne","","",7,[[["self"],["comment"]],["bool"]]],[11,"clone","","",27,[[["self"]],["ast"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",27,N],[11,"eq","","",27,[[["self"],["ast"]],["bool"]]],[11,"ne","","",27,[[["self"],["ast"]],["bool"]]],[11,"span","","Return the span of this abstract syntax tree.",27,[[["self"]],["span"]]],[11,"is_empty","","Return true if and only if this Ast is empty.",27,[[["self"]],["bool"]]],[11,"has_subexprs","","Returns true if and only if this AST has any (including possibly empty) subexpressions.",27,[[["self"]],["bool"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["alternation"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"eq","","",8,[[["self"],["alternation"]],["bool"]]],[11,"ne","","",8,[[["self"],["alternation"]],["bool"]]],[11,"into_ast","","Return this alternation as an AST.",8,[[["self"]],["ast"]]],[11,"clone","","",9,[[["self"]],["concat"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"eq","","",9,[[["self"],["concat"]],["bool"]]],[11,"ne","","",9,[[["self"],["concat"]],["bool"]]],[11,"into_ast","","Return this concatenation as an AST.",9,[[["self"]],["ast"]]],[11,"clone","","",10,[[["self"]],["literal"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"eq","","",10,[[["self"],["literal"]],["bool"]]],[11,"ne","","",10,[[["self"],["literal"]],["bool"]]],[11,"byte","","If this literal was written as a `\\x` hex escape, then this returns the corresponding byte value. Otherwise, this returns `None`.",10,[[["self"]],["option",["u8"]]]],[11,"clone","","",28,[[["self"]],["literalkind"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",28,N],[11,"eq","","",28,[[["self"],["literalkind"]],["bool"]]],[11,"ne","","",28,[[["self"],["literalkind"]],["bool"]]],[11,"clone","","",29,[[["self"]],["specialliteralkind"]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",29,N],[11,"eq","","",29,[[["self"],["specialliteralkind"]],["bool"]]],[11,"clone","","",30,[[["self"]],["hexliteralkind"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",30,N],[11,"eq","","",30,[[["self"],["hexliteralkind"]],["bool"]]],[11,"digits","","The number of digits that must be used with this literal form when used without brackets. When used with brackets, there is no restriction on the number of digits.",30,[[["self"]],["u32"]]],[11,"clone","","",31,[[["self"]],["class"]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",31,N],[11,"eq","","",31,[[["self"],["class"]],["bool"]]],[11,"ne","","",31,[[["self"],["class"]],["bool"]]],[11,"span","","Return the span of this character class.",31,[[["self"]],["span"]]],[11,"clone","","",11,[[["self"]],["classperl"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",11,N],[11,"eq","","",11,[[["self"],["classperl"]],["bool"]]],[11,"ne","","",11,[[["self"],["classperl"]],["bool"]]],[11,"clone","","",32,[[["self"]],["classperlkind"]]],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",32,N],[11,"eq","","",32,[[["self"],["classperlkind"]],["bool"]]],[11,"clone","","",12,[[["self"]],["classascii"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"eq","","",12,[[["self"],["classascii"]],["bool"]]],[11,"ne","","",12,[[["self"],["classascii"]],["bool"]]],[11,"clone","","",33,[[["self"]],["classasciikind"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",33,N],[11,"eq","","",33,[[["self"],["classasciikind"]],["bool"]]],[11,"from_name","","Return the corresponding ClassAsciiKind variant for the given name.",33,[[["str"]],["option",["classasciikind"]]]],[11,"clone","","",13,[[["self"]],["classunicode"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"eq","","",13,[[["self"],["classunicode"]],["bool"]]],[11,"ne","","",13,[[["self"],["classunicode"]],["bool"]]],[11,"is_negated","","Returns true if this class has been negated.",13,[[["self"]],["bool"]]],[11,"clone","","",34,[[["self"]],["classunicodekind"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",34,N],[11,"eq","","",34,[[["self"],["classunicodekind"]],["bool"]]],[11,"ne","","",34,[[["self"],["classunicodekind"]],["bool"]]],[11,"clone","","",35,[[["self"]],["classunicodeopkind"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",35,N],[11,"eq","","",35,[[["self"],["classunicodeopkind"]],["bool"]]],[11,"is_equal","","Whether the op is an equality op or not.",35,[[["self"]],["bool"]]],[11,"clone","","",14,[[["self"]],["classbracketed"]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",14,N],[11,"eq","","",14,[[["self"],["classbracketed"]],["bool"]]],[11,"ne","","",14,[[["self"],["classbracketed"]],["bool"]]],[11,"clone","","",36,[[["self"]],["classset"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",36,N],[11,"eq","","",36,[[["self"],["classset"]],["bool"]]],[11,"ne","","",36,[[["self"],["classset"]],["bool"]]],[11,"union","","Build a set from a union.",36,[[["classsetunion"]],["classset"]]],[11,"span","","Return the span of this character class set.",36,[[["self"]],["span"]]],[11,"is_empty","","Return true if and only if this class set is empty.",36,[[["self"]],["bool"]]],[11,"clone","","",37,[[["self"]],["classsetitem"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",37,N],[11,"eq","","",37,[[["self"],["classsetitem"]],["bool"]]],[11,"ne","","",37,[[["self"],["classsetitem"]],["bool"]]],[11,"span","","Return the span of this character class set item.",37,[[["self"]],["span"]]],[11,"clone","","",15,[[["self"]],["classsetrange"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",15,N],[11,"eq","","",15,[[["self"],["classsetrange"]],["bool"]]],[11,"ne","","",15,[[["self"],["classsetrange"]],["bool"]]],[11,"is_valid","","Returns true if and only if this character class range is valid.",15,[[["self"]],["bool"]]],[11,"clone","","",16,[[["self"]],["classsetunion"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",16,N],[11,"eq","","",16,[[["self"],["classsetunion"]],["bool"]]],[11,"ne","","",16,[[["self"],["classsetunion"]],["bool"]]],[11,"push","","Push a new item in this union.",16,[[["self"],["classsetitem"]]]],[11,"into_item","","Return this union as a character class set item.",16,[[["self"]],["classsetitem"]]],[11,"clone","","",17,[[["self"]],["classsetbinaryop"]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"eq","","",17,[[["self"],["classsetbinaryop"]],["bool"]]],[11,"ne","","",17,[[["self"],["classsetbinaryop"]],["bool"]]],[11,"clone","","",38,[[["self"]],["classsetbinaryopkind"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",38,N],[11,"eq","","",38,[[["self"],["classsetbinaryopkind"]],["bool"]]],[11,"clone","","",18,[[["self"]],["assertion"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"eq","","",18,[[["self"],["assertion"]],["bool"]]],[11,"ne","","",18,[[["self"],["assertion"]],["bool"]]],[11,"clone","","",39,[[["self"]],["assertionkind"]]],[11,"fmt","","",39,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",39,N],[11,"eq","","",39,[[["self"],["assertionkind"]],["bool"]]],[11,"clone","","",19,[[["self"]],["repetition"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"eq","","",19,[[["self"],["repetition"]],["bool"]]],[11,"ne","","",19,[[["self"],["repetition"]],["bool"]]],[11,"clone","","",20,[[["self"]],["repetitionop"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",20,N],[11,"eq","","",20,[[["self"],["repetitionop"]],["bool"]]],[11,"ne","","",20,[[["self"],["repetitionop"]],["bool"]]],[11,"clone","","",40,[[["self"]],["repetitionkind"]]],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",40,N],[11,"eq","","",40,[[["self"],["repetitionkind"]],["bool"]]],[11,"ne","","",40,[[["self"],["repetitionkind"]],["bool"]]],[11,"clone","","",41,[[["self"]],["repetitionrange"]]],[11,"fmt","","",41,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",41,N],[11,"eq","","",41,[[["self"],["repetitionrange"]],["bool"]]],[11,"ne","","",41,[[["self"],["repetitionrange"]],["bool"]]],[11,"is_valid","","Returns true if and only if this repetition range is valid.",41,[[["self"]],["bool"]]],[11,"clone","","",21,[[["self"]],["group"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"eq","","",21,[[["self"],["group"]],["bool"]]],[11,"ne","","",21,[[["self"],["group"]],["bool"]]],[11,"flags","","If this group is non-capturing, then this returns the (possibly empty) set of flags. Otherwise, `None` is returned.",21,[[["self"]],["option",["flags"]]]],[11,"is_capturing","","Returns true if and only if this group is capturing.",21,[[["self"]],["bool"]]],[11,"capture_index","","Returns the capture index of this group, if this is a capturing group.",21,[[["self"]],["option",["u32"]]]],[11,"clone","","",42,[[["self"]],["groupkind"]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",42,N],[11,"eq","","",42,[[["self"],["groupkind"]],["bool"]]],[11,"ne","","",42,[[["self"],["groupkind"]],["bool"]]],[11,"clone","","",22,[[["self"]],["capturename"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",22,N],[11,"eq","","",22,[[["self"],["capturename"]],["bool"]]],[11,"ne","","",22,[[["self"],["capturename"]],["bool"]]],[11,"clone","","",23,[[["self"]],["setflags"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",23,N],[11,"eq","","",23,[[["self"],["setflags"]],["bool"]]],[11,"ne","","",23,[[["self"],["setflags"]],["bool"]]],[11,"clone","","",24,[[["self"]],["flags"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",24,N],[11,"eq","","",24,[[["self"],["flags"]],["bool"]]],[11,"ne","","",24,[[["self"],["flags"]],["bool"]]],[11,"add_item","","Add the given item to this sequence of flags.",24,[[["self"],["flagsitem"]],["option",["usize"]]]],[11,"flag_state","","Returns the state of the given flag in this set.",24,[[["self"],["flag"]],["option",["bool"]]]],[11,"clone","","",25,[[["self"]],["flagsitem"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",25,N],[11,"eq","","",25,[[["self"],["flagsitem"]],["bool"]]],[11,"ne","","",25,[[["self"],["flagsitem"]],["bool"]]],[11,"clone","","",43,[[["self"]],["flagsitemkind"]]],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",43,N],[11,"eq","","",43,[[["self"],["flagsitemkind"]],["bool"]]],[11,"ne","","",43,[[["self"],["flagsitemkind"]],["bool"]]],[11,"is_negation","","Returns true if and only if this item is a negation operator.",43,[[["self"]],["bool"]]],[11,"clone","","",44,[[["self"]],["flag"]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",44,N],[11,"eq","","",44,[[["self"],["flag"]],["bool"]]],[11,"drop","","",27,[[["self"]]]],[11,"drop","","",36,[[["self"]]]],[0,"either","regex_syntax","",N,N],[4,"Either","regex_syntax::either","A simple binary sum type.",N,N],[13,"Left","","",60,N],[13,"Right","","",60,N],[11,"clone","","",60,[[["self"]],["either"]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",60,N],[11,"eq","","",60,[[["self"],["either"]],["bool"]]],[11,"ne","","",60,[[["self"],["either"]],["bool"]]],[0,"error","regex_syntax","",N,N],[3,"Formatter","regex_syntax::error","A helper type for formatting nice error messages.",N,N],[12,"pattern","","The original regex pattern in which the error occurred.",61,N],[12,"err","","The error kind. It must impl fmt::Display.",61,N],[12,"span","","The primary span of the error.",61,N],[12,"aux_span","","An auxiliary and optional span, in case the error needs to point to two locations (e.g., when reporting a duplicate capture group name).",61,N],[3,"Spans","","This type represents an arbitrary number of error spans in a way that makes it convenient to notate the regex pattern. (\"Notate\" means \"point out exactly where the error occurred in the regex pattern.\")",N,N],[12,"pattern","","The original regex pattern string.",62,N],[12,"line_number_width","","The total width that should be used for line numbers. The width is used for left padding the line numbers for alignment.",62,N],[12,"by_line","","All error spans that occur on a single line. This sequence always has length equivalent to the number of lines in `pattern`, where the index of the sequence represents a line number, starting at `0`. The spans in each line are sorted in ascending order.",62,N],[12,"multi_line","","All error spans that occur over one or more lines. That is, the start and end position of the span have different line numbers. The spans are sorted in ascending order.",62,N],[4,"Error","","This error type encompasses any error that can be returned by this crate.",N,N],[13,"Parse","","An error that occurred while translating concrete syntax into abstract syntax (AST).",2,N],[13,"Translate","","An error that occurred while translating abstract syntax into a high level intermediate representation (HIR).",2,N],[13,"__Nonexhaustive","","Hints that destructuring should not be exhaustive.",2,N],[5,"repeat_char","","",N,[[["char"],["usize"]],["string"]]],[6,"Result","","A type alias for dealing with errors returned by this crate.",N,N],[11,"clone","regex_syntax","",2,[[["self"]],["error"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"eq","","",2,[[["self"],["error"]],["bool"]]],[11,"ne","","",2,[[["self"],["error"]],["bool"]]],[11,"from","","",2,[[["error"]],["error"]]],[11,"from","","",2,[[["error"]],["error"]]],[11,"description","","",2,[[["self"]],["str"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"fmt","regex_syntax::error","",61,[[["self"],["formatter"]],["result"]]],[11,"from","","",61,[[["error"]],["self"]]],[11,"from","","",61,[[["error"]],["self"]]],[11,"fmt","","",61,[[["self"],["formatter"]],["result"]]],[11,"from_formatter","","Build a sequence of spans from a formatter.",62,[[["formatter"]],["spans"]]],[11,"add","","Add the given span to this sequence, putting it in the right place.",62,[[["self"],["span"]]]],[11,"notate","","Notate the pattern string with carents (`^`) pointing at each span location. This only applies to spans that occur within a single line.",62,[[["self"]],["string"]]],[11,"notate_line","","Return notes for the line indexed at `i` (zero-based). If there are no spans for the given line, then `None` is returned. Otherwise, an appropriately space padded string with correctly positioned `^` is returned, accounting for line numbers.",62,[[["self"],["usize"]],["option",["string"]]]],[11,"left_pad_line_number","","Left pad the given line number with spaces such that it is aligned with other line numbers.",62,[[["self"],["usize"]],["string"]]],[11,"line_number_padding","","Return the line number padding beginning at the start of each line of the pattern.",62,[[["self"]],["usize"]]],[0,"hir","regex_syntax","Defines a high-level intermediate representation for regular expressions.",N,N],[3,"Error","regex_syntax::hir","An error that can occur while translating an `Ast` to a `Hir`.",N,N],[12,"kind","","The kind of error.",63,N],[12,"pattern","","The original pattern that the translator's Ast was parsed from. Every span in an error is a valid range into this string.",63,N],[12,"span","","The span of this error, derived from the Ast given to the translator.",63,N],[3,"Hir","","A high-level intermediate representation (HIR) for a regular expression.",N,N],[12,"kind","","The underlying HIR kind.",64,N],[12,"info","","Analysis info about this HIR, computed during construction.",64,N],[3,"ClassUnicode","","A set of characters represented by Unicode scalar values.",N,N],[12,"set","","",65,N],[3,"ClassUnicodeIter","","An iterator over all ranges in a Unicode character class.",N,N],[12,"0","","",66,N],[3,"ClassUnicodeRange","","A single range of characters represented by Unicode scalar values.",N,N],[12,"start","","",67,N],[12,"end","","",67,N],[3,"ClassBytes","","A set of characters represented by arbitrary bytes (where one byte corresponds to one character).",N,N],[12,"set","","",68,N],[3,"ClassBytesIter","","An iterator over all ranges in a byte character class.",N,N],[12,"0","","",69,N],[3,"ClassBytesRange","","A single range of characters represented by arbitrary bytes.",N,N],[12,"start","","",70,N],[12,"end","","",70,N],[3,"Group","","The high-level intermediate representation for a group.",N,N],[12,"kind","","The kind of this group. If it is a capturing group, then the kind contains the capture group index (and the name, if it is a named group).",71,N],[12,"hir","","The expression inside the capturing group, which may be empty.",71,N],[3,"Repetition","","The high-level intermediate representation of a repetition operator.",N,N],[12,"kind","","The kind of this repetition operator.",72,N],[12,"greedy","","Whether this repetition operator is greedy or not. A greedy operator will match as much as it can. A non-greedy operator will match as little as it can.",72,N],[12,"hir","","The expression being repeated.",72,N],[3,"HirInfo","","A type that documents various attributes of an HIR expression.",N,N],[12,"bools","","Represent yes/no questions by a bitfield to conserve space, since this is included in every HIR expression.",73,N],[4,"ErrorKind","","The type of an error that occurred while building an `Hir`.",N,N],[13,"UnicodeNotAllowed","","This error occurs when a Unicode feature is used when Unicode support is disabled. For example `(?-u:\\pL)` would trigger this error.",74,N],[13,"InvalidUtf8","","This error occurs when translating a pattern that could match a byte sequence that isn't UTF-8 and `allow_invalid_utf8` was disabled.",74,N],[13,"UnicodePropertyNotFound","","This occurs when an unrecognized Unicode property name could not be found.",74,N],[13,"UnicodePropertyValueNotFound","","This occurs when an unrecognized Unicode property value could not be found.",74,N],[13,"EmptyClassNotAllowed","","This occurs when the translator attempts to construct a character class that is empty.",74,N],[13,"__Nonexhaustive","","Hints that destructuring should not be exhaustive.",74,N],[4,"HirKind","","The kind of an arbitrary `Hir` expression.",N,N],[13,"Empty","","The empty regular expression, which matches everything, including the empty string.",75,N],[13,"Literal","","A single literal character that matches exactly this character.",75,N],[13,"Class","","A single character class that matches any of the characters in the class. A class can either consist of Unicode scalar values as characters, or it can use bytes.",75,N],[13,"Anchor","","An anchor assertion. An anchor assertion match always has zero length.",75,N],[13,"WordBoundary","","A word boundary assertion, which may or may not be Unicode aware. A word boundary assertion match always has zero length.",75,N],[13,"Repetition","","A repetition operation applied to a child expression.",75,N],[13,"Group","","A possibly capturing group, which contains a child expression.",75,N],[13,"Concat","","A concatenation of expressions. A concatenation always has at least two child expressions.",75,N],[13,"Alternation","","An alternation of expressions. An alternation always has at least two child expressions.",75,N],[4,"Literal","","The high-level intermediate representation of a literal.",N,N],[13,"Unicode","","A single character represented by a Unicode scalar value.",76,N],[13,"Byte","","A single character represented by an arbitrary byte.",76,N],[4,"Class","","The high-level intermediate representation of a character class.",N,N],[13,"Unicode","","A set of characters represented by Unicode scalar values.",77,N],[13,"Bytes","","A set of characters represented by arbitrary bytes (one byte per character).",77,N],[4,"Anchor","","The high-level intermediate representation for an anchor assertion.",N,N],[13,"StartLine","","Match the beginning of a line or the beginning of text. Specifically, this matches at the starting position of the input, or at the position immediately following a `\\n` character.",78,N],[13,"EndLine","","Match the end of a line or the end of text. Specifically, this matches at the end position of the input, or at the position immediately preceding a `\\n` character.",78,N],[13,"StartText","","Match the beginning of text. Specifically, this matches at the starting position of the input.",78,N],[13,"EndText","","Match the end of text. Specifically, this matches at the ending position of the input.",78,N],[4,"WordBoundary","","The high-level intermediate representation for a word-boundary assertion.",N,N],[13,"Unicode","","Match a Unicode-aware word boundary. That is, this matches a position where the left adjacent character and right adjacent character correspond to a word and non-word or a non-word and word character.",79,N],[13,"UnicodeNegate","","Match a Unicode-aware negation of a word boundary.",79,N],[13,"Ascii","","Match an ASCII-only word boundary. That is, this matches a position where the left adjacent character and right adjacent character correspond to a word and non-word or a non-word and word character.",79,N],[13,"AsciiNegate","","Match an ASCII-only negation of a word boundary.",79,N],[4,"GroupKind","","The kind of group.",N,N],[13,"CaptureIndex","","A normal unnamed capturing group.",80,N],[13,"CaptureName","","A named capturing group.",80,N],[12,"name","regex_syntax::hir::GroupKind","The name of the group.",80,N],[12,"index","","The capture index of the group.",80,N],[13,"NonCapturing","regex_syntax::hir","A non-capturing group.",80,N],[4,"RepetitionKind","","The kind of a repetition operator.",N,N],[13,"ZeroOrOne","","Matches a sub-expression zero or one times.",81,N],[13,"ZeroOrMore","","Matches a sub-expression zero or more times.",81,N],[13,"OneOrMore","","Matches a sub-expression one or more times.",81,N],[13,"Range","","Matches a sub-expression within a bounded range of times.",81,N],[4,"RepetitionRange","","The kind of a counted repetition operator.",N,N],[13,"Exactly","","Matches a sub-expression exactly this many times.",82,N],[13,"AtLeast","","Matches a sub-expression at least this many times.",82,N],[13,"Bounded","","Matches a sub-expression at least `m` times and at most `n` times.",82,N],[5,"visit","","Executes an implementation of `Visitor` in constant stack space.",N,[[["hir"],["v"]],["result"]]],[0,"interval","","",N,N],[3,"IntervalSet","regex_syntax::hir::interval","",N,N],[12,"ranges","","",83,N],[3,"IntervalSetIter","","An iterator over intervals.",N,N],[12,"0","","",84,N],[8,"Interval","","",N,N],[16,"Bound","","",85,N],[10,"lower","","",85,N],[10,"upper","","",85,N],[10,"set_lower","","",85,N],[10,"set_upper","","",85,N],[10,"case_fold_simple","","",85,[[["self"],["vec"]]]],[11,"create","","Create a new interval.",85,N],[11,"union","","Union the given overlapping range into this range.",85,[[["self"],["self"]],["option"]]],[11,"intersect","","Intersect this range with the given range and return the result.",85,[[["self"],["self"]],["option"]]],[11,"difference","","Subtract the given range from this range and return the resulting ranges.",85,N],[11,"symmetric_difference","","Compute the symmetric difference the given range from this range. This returns the union of the two ranges minus its intersection.",85,N],[11,"is_contiguous","","Returns true if and only if the two ranges are contiguous. Two ranges are contiguous if and only if the ranges are either overlapping or adjacent.",85,[[["self"],["self"]],["bool"]]],[11,"is_intersection_empty","","Returns true if and only if the intersection of this range and the other range is empty.",85,[[["self"],["self"]],["bool"]]],[11,"is_subset","","Returns true if and only if this range is a subset of the other range.",85,[[["self"],["self"]],["bool"]]],[8,"Bound","","",N,N],[10,"min_value","","",86,[[],["self"]]],[10,"max_value","","",86,[[],["self"]]],[10,"as_u32","","",86,[[["self"]],["u32"]]],[10,"increment","","",86,[[["self"]],["self"]]],[10,"decrement","","",86,[[["self"]],["self"]]],[11,"clone","","",83,[[["self"]],["intervalset"]]],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",83,N],[11,"eq","","",83,[[["self"],["intervalset"]],["bool"]]],[11,"ne","","",83,[[["self"],["intervalset"]],["bool"]]],[11,"new","","Create a new set from a sequence of intervals. Each interval is specified as a pair of bounds, where both bounds are inclusive.",83,[[["t"]],["intervalset"]]],[11,"push","","Add a new interval to this set.",83,[[["self"],["i"]]]],[11,"iter","","Return an iterator over all intervals in this set.",83,[[["self"]],["intervalsetiter"]]],[11,"intervals","","Return an immutable slice of intervals in this set.",83,N],[11,"case_fold_simple","","Expand this interval set such that it contains all case folded characters. For example, if this class consists of the range `a-z`, then applying case folding will result in the class containing both the ranges `a-z` and `A-Z`.",83,[[["self"]]]],[11,"union","","Union this set with the given set, in place.",83,[[["self"],["intervalset"]]]],[11,"intersect","","Intersect this set with the given set, in place.",83,[[["self"],["intervalset"]]]],[11,"difference","","Subtract the given set from this set, in place.",83,[[["self"],["intervalset"]]]],[11,"symmetric_difference","","Compute the symmetric difference of the two sets, in place.",83,[[["self"],["intervalset"]]]],[11,"negate","","Negate this interval set.",83,[[["self"]]]],[11,"canonicalize","","Converts this set into a canonical ordering.",83,[[["self"]]]],[11,"is_canonical","","Returns true if and only if this class is in a canonical ordering.",83,[[["self"]],["bool"]]],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"next","","",84,[[["self"]],["option"]]],[0,"literal","regex_syntax::hir","Provides routines for extracting literal prefixes and suffixes from an `Hir`.",N,N],[3,"Literals","regex_syntax::hir::literal","A set of literal byte strings extracted from a regular expression.",N,N],[12,"lits","","",87,N],[12,"limit_size","","",87,N],[12,"limit_class","","",87,N],[3,"Literal","","A single member of a set of literals extracted from a regular expression.",N,N],[12,"v","","",88,N],[12,"cut","","",88,N],[5,"prefixes","","",N,[[["hir"],["literals"]]]],[5,"suffixes","","",N,[[["hir"],["literals"]]]],[5,"repeat_zero_or_one_literals","","",N,[[["hir"],["literals"],["f"]]]],[5,"repeat_zero_or_more_literals","","",N,[[["hir"],["literals"],["f"]]]],[5,"repeat_one_or_more_literals","","",N,[[["hir"],["literals"],["f"]]]],[5,"repeat_range_literals","","",N,[[["hir"],["u32"],["option",["u32"]],["bool"],["literals"],["f"]]]],[5,"alternate_literals","","",N,N],[5,"position","","",N,N],[5,"escape_unicode","","",N,N],[5,"escape_bytes","","",N,N],[5,"escape_byte","","",N,[[["u8"]],["string"]]],[5,"cls_char_count","","",N,[[["classunicode"]],["usize"]]],[5,"cls_byte_count","","",N,[[["classbytes"]],["usize"]]],[11,"clone","","",87,[[["self"]],["literals"]]],[11,"assert_receiver_is_total_eq","","",87,N],[11,"eq","","",87,[[["self"],["literals"]],["bool"]]],[11,"ne","","",87,[[["self"],["literals"]],["bool"]]],[11,"clone","","",88,[[["self"]],["literal"]]],[11,"assert_receiver_is_total_eq","","",88,N],[11,"cmp","","",88,[[["self"],["literal"]],["ordering"]]],[11,"empty","","Returns a new empty set of literals using default limits.",87,[[],["literals"]]],[11,"prefixes","","Returns a set of literal prefixes extracted from the given `Hir`.",87,[[["hir"]],["literals"]]],[11,"suffixes","","Returns a set of literal suffixes extracted from the given `Hir`.",87,[[["hir"]],["literals"]]],[11,"limit_size","","Get the approximate size limit (in bytes) of this set.",87,[[["self"]],["usize"]]],[11,"set_limit_size","","Set the approximate size limit (in bytes) of this set.",87,[[["self"],["usize"]],["literals"]]],[11,"limit_class","","Get the character class size limit for this set.",87,[[["self"]],["usize"]]],[11,"set_limit_class","","Limits the size of character(or byte) classes considered.",87,[[["self"],["usize"]],["literals"]]],[11,"literals","","Returns the set of literals as a slice. Its order is unspecified.",87,N],[11,"min_len","","Returns the length of the smallest literal.",87,[[["self"]],["option",["usize"]]]],[11,"all_complete","","Returns true if all members in this set are complete.",87,[[["self"]],["bool"]]],[11,"any_complete","","Returns true if any member in this set is complete.",87,[[["self"]],["bool"]]],[11,"contains_empty","","Returns true if this set contains an empty literal.",87,[[["self"]],["bool"]]],[11,"is_empty","","Returns true if this set is empty or if all of its members is empty.",87,[[["self"]],["bool"]]],[11,"to_empty","","Returns a new empty set of literals using this set's limits.",87,[[["self"]],["literals"]]],[11,"longest_common_prefix","","Returns the longest common prefix of all members in this set.",87,N],[11,"longest_common_suffix","","Returns the longest common suffix of all members in this set.",87,N],[11,"trim_suffix","","Returns a new set of literals with the given number of bytes trimmed from the suffix of each literal.",87,[[["self"],["usize"]],["option",["literals"]]]],[11,"unambiguous_prefixes","","Returns a new set of prefixes of this set of literals that are guaranteed to be unambiguous.",87,[[["self"]],["literals"]]],[11,"unambiguous_suffixes","","Returns a new set of suffixes of this set of literals that are guaranteed to be unambiguous.",87,[[["self"]],["literals"]]],[11,"union_prefixes","","Unions the prefixes from the given expression to this set.",87,[[["self"],["hir"]],["bool"]]],[11,"union_suffixes","","Unions the suffixes from the given expression to this set.",87,[[["self"],["hir"]],["bool"]]],[11,"union","","Unions this set with another set.",87,[[["self"],["literals"]],["bool"]]],[11,"cross_product","","Extends this set with another set.",87,[[["self"],["literals"]],["bool"]]],[11,"cross_add","","Extends each literal in this set with the bytes given.",87,N],[11,"add","","Adds the given literal to this set.",87,[[["self"],["literal"]],["bool"]]],[11,"add_char_class","","Extends each literal in this set with the character class given.",87,[[["self"],["classunicode"]],["bool"]]],[11,"add_char_class_reverse","","Extends each literal in this set with the character class given, writing the bytes of each character in reverse.",87,[[["self"],["classunicode"]],["bool"]]],[11,"_add_char_class","","",87,[[["self"],["classunicode"],["bool"]],["bool"]]],[11,"add_byte_class","","Extends each literal in this set with the byte class given.",87,[[["self"],["classbytes"]],["bool"]]],[11,"cut","","Cuts every member of this set. When a member is cut, it can never be extended.",87,[[["self"]]]],[11,"reverse","","Reverses all members in place.",87,[[["self"]]]],[11,"clear","","Clears this set of all members.",87,[[["self"]]]],[11,"remove_complete","","Pops all complete literals out of this set.",87,[[["self"]],["vec",["literal"]]]],[11,"num_bytes","","Returns the total number of bytes in this set.",87,[[["self"]],["usize"]]],[11,"class_exceeds_limits","","Returns true if a character class with the given size would cause this set to exceed its limits.",87,[[["self"],["usize"]],["bool"]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[11,"new","","Returns a new complete literal with the bytes given.",88,[[["vec",["u8"]]],["literal"]]],[11,"empty","","Returns a new complete empty literal.",88,[[],["literal"]]],[11,"is_cut","","Returns true if this literal was \"cut.\"",88,[[["self"]],["bool"]]],[11,"cut","","Cuts this literal.",88,[[["self"]]]],[11,"eq","","",88,[[["self"],["literal"]],["bool"]]],[11,"partial_cmp","","",88,[[["self"],["literal"]],["option",["ordering"]]]],[11,"fmt","","",88,[[["self"],["formatter"]],["result"]]],[11,"as_ref","","",88,N],[11,"deref","","",88,[[["self"]],["vec"]]],[11,"deref_mut","","",88,[[["self"]],["vec"]]],[0,"print","regex_syntax::hir","This module provides a regular expression printer for `Hir`.",N,N],[3,"PrinterBuilder","regex_syntax::hir::print","A builder for constructing a printer.",N,N],[12,"_priv","","",89,N],[3,"Printer","","A printer for a regular expression's high-level intermediate representation.",N,N],[12,"_priv","","",90,N],[3,"Writer","","",N,N],[12,"printer","","",91,N],[12,"wtr","","",91,N],[11,"clone","","",89,[[["self"]],["printerbuilder"]]],[11,"fmt","","",89,[[["self"],["formatter"]],["result"]]],[11,"default","","",89,[[],["printerbuilder"]]],[11,"new","","",89,[[],["printerbuilder"]]],[11,"build","","",89,[[["self"]],["printer"]]],[11,"fmt","","",90,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new printer.",90,[[],["printer"]]],[11,"print","","Print the given `Ast` to the given writer. The writer must implement `fmt::Write`. Typical implementations of `fmt::Write` that can be used here are a `fmt::Formatter` (which is available in `fmt::Display` implementations) or a `&mut String`.",90,[[["self"],["hir"],["w"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"finish","","",91,[[["self"]],["result"]]],[11,"visit_pre","","",91,[[["self"],["hir"]],["result"]]],[11,"visit_post","","",91,[[["self"],["hir"]],["result"]]],[11,"visit_alternation_in","","",91,[[["self"]],["result"]]],[11,"write_literal_char","","",91,[[["self"],["char"]],["result"]]],[11,"write_literal_byte","","",91,[[["self"],["u8"]],["result"]]],[11,"write_literal_class_byte","","",91,[[["self"],["u8"]],["result"]]],[0,"translate","regex_syntax::hir","Defines a translator that converts an `Ast` to an `Hir`.",N,N],[3,"TranslatorBuilder","regex_syntax::hir::translate","A builder for constructing an AST->HIR translator.",N,N],[12,"allow_invalid_utf8","","",92,N],[12,"flags","","",92,N],[3,"Translator","","A translator maps abstract syntax to a high level intermediate representation.",N,N],[12,"stack","","Our call stack, but on the heap.",93,N],[12,"flags","","The current flag settings.",93,N],[12,"allow_invalid_utf8","","Whether we're allowed to produce HIR that can match arbitrary bytes.",93,N],[3,"TranslatorI","","The internal implementation of a translator.",N,N],[12,"trans","","",94,N],[12,"pattern","","",94,N],[3,"Flags","","A translator's representation of a regular expression's flags at any given moment in time.",N,N],[12,"case_insensitive","","",95,N],[12,"multi_line","","",95,N],[12,"dot_matches_new_line","","",95,N],[12,"swap_greed","","",95,N],[12,"unicode","","",95,N],[4,"HirFrame","","An HirFrame is a single stack frame, represented explicitly, which is created for each item in the Ast that we traverse.",N,N],[13,"Expr","","An arbitrary HIR expression. These get pushed whenever we hit a base case in the Ast. They get popped after an inductive (i.e., recursive) step is complete.",96,N],[13,"ClassUnicode","","A Unicode character class. This frame is mutated as we descend into the Ast of a character class (which is itself its own mini recursive structure).",96,N],[13,"ClassBytes","","A byte-oriented character class. This frame is mutated as we descend into the Ast of a character class (which is itself its own mini recursive structure).",96,N],[13,"Group","","This is pushed on to the stack upon first seeing any kind of group, indicated by parentheses (including non-capturing groups). It is popped upon leaving a group.",96,N],[12,"old_flags","regex_syntax::hir::translate::HirFrame","The old active flags, if any, when this group was opened.",96,N],[13,"Concat","regex_syntax::hir::translate","This is pushed whenever a concatenation is observed. After visiting every sub-expression in the concatenation, the translator's stack is popped until it sees a Concat frame.",96,N],[13,"Alternation","","This is pushed whenever an alternation is observed. After visiting every sub-expression in the alternation, the translator's stack is popped until it sees an Alternation frame.",96,N],[5,"hir_ascii_class_bytes","","",N,[[["classasciikind"]],["classbytes"]]],[5,"ascii_class","","",N,N],[6,"Result","","",N,N],[11,"clone","","",92,[[["self"]],["translatorbuilder"]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"default","","",92,[[],["translatorbuilder"]]],[11,"new","","Create a new translator builder with a default c onfiguration.",92,[[],["translatorbuilder"]]],[11,"build","","Build a translator using the current configuration.",92,[[["self"]],["translator"]]],[11,"allow_invalid_utf8","","When enabled, translation will permit the construction of a regular expression that may match invalid UTF-8.",92,[[["self"],["bool"]],["translatorbuilder"]]],[11,"case_insensitive","","Enable or disable the case insensitive flag (`i`) by default.",92,[[["self"],["bool"]],["translatorbuilder"]]],[11,"multi_line","","Enable or disable the multi-line matching flag (`m`) by default.",92,[[["self"],["bool"]],["translatorbuilder"]]],[11,"dot_matches_new_line","","Enable or disable the \"dot matches any character\" flag (`s`) by default.",92,[[["self"],["bool"]],["translatorbuilder"]]],[11,"swap_greed","","Enable or disable the \"swap greed\" flag (`U`) by default.",92,[[["self"],["bool"]],["translatorbuilder"]]],[11,"unicode","","Enable or disable the Unicode flag (`u`) by default.",92,[[["self"],["bool"]],["translatorbuilder"]]],[11,"clone","","",93,[[["self"]],["translator"]]],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new translator using the default configuration.",93,[[],["translator"]]],[11,"translate","","Translate the given abstract syntax tree (AST) into a high level intermediate representation (HIR).",93,[[["self"],["str"],["ast"]],["result",["hir","error"]]]],[11,"clone","","",96,[[["self"]],["hirframe"]]],[11,"fmt","","",96,[[["self"],["formatter"]],["result"]]],[11,"unwrap_expr","","Assert that the current stack frame is an Hir expression and return it.",96,[[["self"]],["hir"]]],[11,"unwrap_class_unicode","","Assert that the current stack frame is a Unicode class expression and return it.",96,[[["self"]],["classunicode"]]],[11,"unwrap_class_bytes","","Assert that the current stack frame is a byte class expression and return it.",96,[[["self"]],["classbytes"]]],[11,"unwrap_group","","Assert that the current stack frame is a group indicator and return its corresponding flags (the flags that were active at the time the group was entered) if they exist.",96,[[["self"]],["option",["flags"]]]],[11,"finish","","",94,[[["self"]],["result",["hir","error"]]]],[11,"visit_pre","","",94,[[["self"],["ast"]],["result",["error"]]]],[11,"visit_post","","",94,[[["self"],["ast"]],["result",["error"]]]],[11,"visit_class_set_item_pre","","",94,[[["self"],["classsetitem"]],["result",["error"]]]],[11,"visit_class_set_item_post","","",94,[[["self"],["classsetitem"]],["result",["error"]]]],[11,"visit_class_set_binary_op_pre","","",94,[[["self"],["classsetbinaryop"]],["result",["error"]]]],[11,"visit_class_set_binary_op_in","","",94,[[["self"],["classsetbinaryop"]],["result",["error"]]]],[11,"visit_class_set_binary_op_post","","",94,[[["self"],["classsetbinaryop"]],["result",["error"]]]],[11,"clone","","",94,[[["self"]],["translatori"]]],[11,"fmt","","",94,[[["self"],["formatter"]],["result"]]],[11,"new","","Build a new internal translator.",94,[[["translator"],["str"]],["translatori"]]],[11,"trans","","Return a reference to the underlying translator.",94,[[["self"]],["translator"]]],[11,"push","","Push the given frame on to the call stack.",94,[[["self"],["hirframe"]]]],[11,"pop","","Pop the top of the call stack. If the call stack is empty, return None.",94,[[["self"]],["option",["hirframe"]]]],[11,"error","","Create a new error with the given span and error type.",94,[[["self"],["span"],["errorkind"]],["error"]]],[11,"flags","","Return a copy of the active flags.",94,[[["self"]],["flags"]]],[11,"set_flags","","Set the flags of this translator from the flags set in the given AST. Then, return the old flags.",94,[[["self"],["flags"]],["flags"]]],[11,"hir_literal","","",94,[[["self"],["literal"]],["result",["hir","error"]]]],[11,"literal_to_char","","Convert an Ast literal to its scalar representation.",94,[[["self"],["literal"]],["result",["literal","error"]]]],[11,"hir_from_char","","",94,[[["self"],["span"],["char"]],["result",["hir","error"]]]],[11,"hir_from_char_case_insensitive","","",94,[[["self"],["span"],["char"]],["result",["hir","error"]]]],[11,"hir_dot","","",94,[[["self"],["span"]],["result",["hir","error"]]]],[11,"hir_assertion","","",94,[[["self"],["assertion"]],["result",["hir","error"]]]],[11,"hir_group","","",94,[[["self"],["group"],["hir"]],["hir"]]],[11,"hir_repetition","","",94,[[["self"],["repetition"],["hir"]],["hir"]]],[11,"hir_unicode_class","","",94,[[["self"],["classunicode"]],["result",["classunicode","error"]]]],[11,"hir_perl_unicode_class","","",94,[[["self"],["classperl"]],["classunicode"]]],[11,"hir_perl_byte_class","","",94,[[["self"],["classperl"]],["classbytes"]]],[11,"unicode_fold_and_negate","","",94,[[["self"],["bool"],["classunicode"]]]],[11,"bytes_fold_and_negate","","",94,[[["self"],["span"],["bool"],["classbytes"]],["result",["error"]]]],[11,"class_literal_byte","","Return a scalar byte value suitable for use as a literal in a byte character class.",94,[[["self"],["literal"]],["result",["u8","error"]]]],[11,"clone","","",95,[[["self"]],["flags"]]],[11,"fmt","","",95,[[["self"],["formatter"]],["result"]]],[11,"default","","",95,[[],["flags"]]],[11,"from_ast","","",95,[[["flags"]],["flags"]]],[11,"merge","","",95,[[["self"],["flags"]]]],[11,"case_insensitive","","",95,[[["self"]],["bool"]]],[11,"multi_line","","",95,[[["self"]],["bool"]]],[11,"dot_matches_new_line","","",95,[[["self"]],["bool"]]],[11,"swap_greed","","",95,[[["self"]],["bool"]]],[11,"unicode","","",95,[[["self"]],["bool"]]],[0,"visitor","regex_syntax::hir","",N,N],[3,"HeapVisitor","regex_syntax::hir::visitor","HeapVisitor visits every item in an `Hir` recursively using constant stack size and a heap size proportional to the size of the `Hir`.",N,N],[12,"stack","","A stack of `Hir` nodes. This is roughly analogous to the call stack used in a typical recursive visitor.",97,N],[4,"Frame","","Represents a single stack frame while performing structural induction over an `Hir`.",N,N],[13,"Repetition","","A stack frame allocated just before descending into a repetition operator's child node.",98,N],[13,"Group","","A stack frame allocated just before descending into a group's child node.",98,N],[13,"Concat","","The stack frame used while visiting every child node of a concatenation of expressions.",98,N],[12,"head","regex_syntax::hir::visitor::Frame","The child node we are currently visiting.",98,N],[12,"tail","","The remaining child nodes to visit (which may be empty).",98,N],[13,"Alternation","regex_syntax::hir::visitor","The stack frame used while visiting every child node of an alternation of expressions.",98,N],[12,"head","regex_syntax::hir::visitor::Frame","The child node we are currently visiting.",98,N],[12,"tail","","The remaining child nodes to visit (which may be empty).",98,N],[5,"visit","regex_syntax::hir::visitor","Executes an implementation of `Visitor` in constant stack space.",N,[[["hir"],["v"]],["result"]]],[8,"Visitor","","A trait for visiting the high-level IR (HIR) in depth first order.",N,N],[16,"Output","","The result of visiting an HIR.",99,N],[16,"Err","","An error that visiting an HIR might return.",99,N],[10,"finish","","All implementors of `Visitor` must provide a `finish` method, which yields the result of visiting the HIR or an error.",99,[[["self"]],["result"]]],[11,"start","","This method is called before beginning traversal of the HIR.",99,[[["self"]]]],[11,"visit_pre","","This method is called on an `Hir` before descending into child `Hir` nodes.",99,[[["self"],["hir"]],["result"]]],[11,"visit_post","","This method is called on an `Hir` after descending all of its child `Hir` nodes.",99,[[["self"],["hir"]],["result"]]],[11,"visit_alternation_in","","This method is called between child nodes of an alternation.",99,[[["self"]],["result"]]],[11,"new","","",97,[[],["heapvisitor"]]],[11,"visit","","",97,[[["self"],["hir"],["v"]],["result"]]],[11,"induct","","Build a stack frame for the given HIR if one is needed (which occurs if and only if there are child nodes in the HIR). Otherwise, return None.",97,[[["self"],["hir"]],["option",["frame"]]]],[11,"pop","","Pops the given frame. If the frame has an additional inductive step, then return it, otherwise return `None`.",97,[[["self"],["frame"]],["option",["frame"]]]],[11,"child","","Perform the next inductive step on this frame and return the next child HIR node to visit.",98,[[["self"]],["hir"]]],[8,"Visitor","regex_syntax::hir","A trait for visiting the high-level IR (HIR) in depth first order.",N,N],[16,"Output","","The result of visiting an HIR.",99,N],[16,"Err","","An error that visiting an HIR might return.",99,N],[10,"finish","","All implementors of `Visitor` must provide a `finish` method, which yields the result of visiting the HIR or an error.",99,[[["self"]],["result"]]],[11,"start","regex_syntax::hir::visitor","This method is called before beginning traversal of the HIR.",99,[[["self"]]]],[11,"visit_pre","","This method is called on an `Hir` before descending into child `Hir` nodes.",99,[[["self"],["hir"]],["result"]]],[11,"visit_post","","This method is called on an `Hir` after descending all of its child `Hir` nodes.",99,[[["self"],["hir"]],["result"]]],[11,"visit_alternation_in","","This method is called between child nodes of an alternation.",99,[[["self"]],["result"]]],[11,"clone","regex_syntax::hir","",63,[[["self"]],["error"]]],[11,"fmt","","",63,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",63,N],[11,"eq","","",63,[[["self"],["error"]],["bool"]]],[11,"ne","","",63,[[["self"],["error"]],["bool"]]],[11,"kind","","Return the type of this error.",63,[[["self"]],["errorkind"]]],[11,"pattern","","The original pattern string in which this error occurred.",63,[[["self"]],["str"]]],[11,"span","","Return the span at which this error occurred.",63,[[["self"]],["span"]]],[11,"clone","","",74,[[["self"]],["errorkind"]]],[11,"fmt","","",74,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",74,N],[11,"eq","","",74,[[["self"],["errorkind"]],["bool"]]],[11,"description","","",74,[[["self"]],["str"]]],[11,"description","","",63,[[["self"]],["str"]]],[11,"fmt","","",63,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",74,[[["self"],["formatter"]],["result"]]],[11,"clone","","",64,[[["self"]],["hir"]]],[11,"fmt","","",64,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",64,N],[11,"eq","","",64,[[["self"],["hir"]],["bool"]]],[11,"ne","","",64,[[["self"],["hir"]],["bool"]]],[11,"clone","","",75,[[["self"]],["hirkind"]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",75,N],[11,"eq","","",75,[[["self"],["hirkind"]],["bool"]]],[11,"ne","","",75,[[["self"],["hirkind"]],["bool"]]],[11,"kind","","Returns a reference to the underlying HIR kind.",64,[[["self"]],["hirkind"]]],[11,"into_kind","","Consumes ownership of this HIR expression and returns its underlying `HirKind`.",64,[[["self"]],["hirkind"]]],[11,"empty","","Returns an empty HIR expression.",64,[[],["hir"]]],[11,"literal","","Creates a literal HIR expression.",64,[[["literal"]],["hir"]]],[11,"class","","Creates a class HIR expression.",64,[[["class"]],["hir"]]],[11,"anchor","","Creates an anchor assertion HIR expression.",64,[[["anchor"]],["hir"]]],[11,"word_boundary","","Creates a word boundary assertion HIR expression.",64,[[["wordboundary"]],["hir"]]],[11,"repetition","","Creates a repetition HIR expression.",64,[[["repetition"]],["hir"]]],[11,"group","","Creates a group HIR expression.",64,[[["group"]],["hir"]]],[11,"concat","","Returns the concatenation of the given expressions.",64,[[["vec",["hir"]]],["hir"]]],[11,"alternation","","Returns the alternation of the given expressions.",64,[[["vec",["hir"]]],["hir"]]],[11,"dot","","Build an HIR expression for `.`.",64,[[["bool"]],["hir"]]],[11,"any","","Build an HIR expression for `(?s).`.",64,[[["bool"]],["hir"]]],[11,"is_always_utf8","","Return true if and only if this HIR will always match valid UTF-8.",64,[[["self"]],["bool"]]],[11,"is_all_assertions","","Returns true if and only if this entire HIR expression is made up of zero-width assertions.",64,[[["self"]],["bool"]]],[11,"is_anchored_start","","Return true if and only if this HIR is required to match from the beginning of text. This includes expressions like `^foo`, `^(foo|bar)`, `^foo|^bar` but not `^foo|bar`.",64,[[["self"]],["bool"]]],[11,"is_anchored_end","","Return true if and only if this HIR is required to match at the end of text. This includes expressions like `foo$`, `(foo|bar)$`, `foo$|bar$` but not `foo$|bar`.",64,[[["self"]],["bool"]]],[11,"is_any_anchored_start","","Return true if and only if this HIR contains any sub-expression that is required to match at the beginning of text. Specifically, this returns true if the `^` symbol (when multiline mode is disabled) or the `\\A` escape appear anywhere in the regex.",64,[[["self"]],["bool"]]],[11,"is_any_anchored_end","","Return true if and only if this HIR contains any sub-expression that is required to match at the end of text. Specifically, this returns true if the `$` symbol (when multiline mode is disabled) or the `\\z` escape appear anywhere in the regex.",64,[[["self"]],["bool"]]],[11,"is_match_empty","","Return true if and only if the empty string is part of the language matched by this regular expression.",64,[[["self"]],["bool"]]],[11,"is_empty","","Return true if and only if this HIR is the empty regular expression.",75,[[["self"]],["bool"]]],[11,"has_subexprs","","Returns true if and only if this kind has any (including possibly empty) subexpressions.",75,[[["self"]],["bool"]]],[11,"fmt","","",64,[[["self"],["formatter"]],["result"]]],[11,"clone","","",76,[[["self"]],["literal"]]],[11,"fmt","","",76,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",76,N],[11,"eq","","",76,[[["self"],["literal"]],["bool"]]],[11,"ne","","",76,[[["self"],["literal"]],["bool"]]],[11,"is_unicode","","Returns true if and only if this literal corresponds to a Unicode scalar value.",76,[[["self"]],["bool"]]],[11,"clone","","",77,[[["self"]],["class"]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",77,N],[11,"eq","","",77,[[["self"],["class"]],["bool"]]],[11,"ne","","",77,[[["self"],["class"]],["bool"]]],[11,"case_fold_simple","","Apply Unicode simple case folding to this character class, in place. The character class will be expanded to include all simple case folded character variants.",77,[[["self"]]]],[11,"negate","","Negate this character class in place.",77,[[["self"]]]],[11,"is_always_utf8","","Returns true if and only if this character class will only ever match valid UTF-8.",77,[[["self"]],["bool"]]],[11,"clone","","",65,[[["self"]],["classunicode"]]],[11,"fmt","","",65,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",65,N],[11,"eq","","",65,[[["self"],["classunicode"]],["bool"]]],[11,"ne","","",65,[[["self"],["classunicode"]],["bool"]]],[11,"new","","Create a new class from a sequence of ranges.",65,[[["i"]],["classunicode"]]],[11,"empty","","Create a new class with no ranges.",65,[[],["classunicode"]]],[11,"push","","Add a new range to this set.",65,[[["self"],["classunicoderange"]]]],[11,"iter","","Return an iterator over all ranges in this class.",65,[[["self"]],["classunicodeiter"]]],[11,"ranges","","Return the underlying ranges as a slice.",65,N],[11,"case_fold_simple","","Expand this character class such that it contains all case folded characters, according to Unicode's \"simple\" mapping. For example, if this class consists of the range `a-z`, then applying case folding will result in the class containing both the ranges `a-z` and `A-Z`.",65,[[["self"]]]],[11,"negate","","Negate this character class.",65,[[["self"]]]],[11,"union","","Union this character class with the given character class, in place.",65,[[["self"],["classunicode"]]]],[11,"intersect","","Intersect this character class with the given character class, in place.",65,[[["self"],["classunicode"]]]],[11,"difference","","Subtract the given character class from this character class, in place.",65,[[["self"],["classunicode"]]]],[11,"symmetric_difference","","Compute the symmetric difference of the given character classes, in place.",65,[[["self"],["classunicode"]]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"next","","",66,[[["self"]],["option",["classunicoderange"]]]],[11,"clone","","",67,[[["self"]],["classunicoderange"]]],[11,"default","","",67,[[],["classunicoderange"]]],[11,"assert_receiver_is_total_eq","","",67,N],[11,"eq","","",67,[[["self"],["classunicoderange"]],["bool"]]],[11,"ne","","",67,[[["self"],["classunicoderange"]],["bool"]]],[11,"partial_cmp","","",67,[[["self"],["classunicoderange"]],["option",["ordering"]]]],[11,"lt","","",67,[[["self"],["classunicoderange"]],["bool"]]],[11,"le","","",67,[[["self"],["classunicoderange"]],["bool"]]],[11,"gt","","",67,[[["self"],["classunicoderange"]],["bool"]]],[11,"ge","","",67,[[["self"],["classunicoderange"]],["bool"]]],[11,"cmp","","",67,[[["self"],["classunicoderange"]],["ordering"]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"lower","","",67,[[["self"]],["char"]]],[11,"upper","","",67,[[["self"]],["char"]]],[11,"set_lower","","",67,[[["self"],["char"]]]],[11,"set_upper","","",67,[[["self"],["char"]]]],[11,"case_fold_simple","","Apply simple case folding to this Unicode scalar value range.",67,[[["self"],["vec"]]]],[11,"new","","Create a new Unicode scalar value range for a character class.",67,[[["char"],["char"]],["classunicoderange"]]],[11,"start","","Return the start of this range.",67,[[["self"]],["char"]]],[11,"end","","Return the end of this range.",67,[[["self"]],["char"]]],[11,"clone","","",68,[[["self"]],["classbytes"]]],[11,"fmt","","",68,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",68,N],[11,"eq","","",68,[[["self"],["classbytes"]],["bool"]]],[11,"ne","","",68,[[["self"],["classbytes"]],["bool"]]],[11,"new","","Create a new class from a sequence of ranges.",68,[[["i"]],["classbytes"]]],[11,"empty","","Create a new class with no ranges.",68,[[],["classbytes"]]],[11,"push","","Add a new range to this set.",68,[[["self"],["classbytesrange"]]]],[11,"iter","","Return an iterator over all ranges in this class.",68,[[["self"]],["classbytesiter"]]],[11,"ranges","","Return the underlying ranges as a slice.",68,N],[11,"case_fold_simple","","Expand this character class such that it contains all case folded characters. For example, if this class consists of the range `a-z`, then applying case folding will result in the class containing both the ranges `a-z` and `A-Z`.",68,[[["self"]]]],[11,"negate","","Negate this byte class.",68,[[["self"]]]],[11,"union","","Union this byte class with the given byte class, in place.",68,[[["self"],["classbytes"]]]],[11,"intersect","","Intersect this byte class with the given byte class, in place.",68,[[["self"],["classbytes"]]]],[11,"difference","","Subtract the given byte class from this byte class, in place.",68,[[["self"],["classbytes"]]]],[11,"symmetric_difference","","Compute the symmetric difference of the given byte classes, in place.",68,[[["self"],["classbytes"]]]],[11,"is_all_ascii","","Returns true if and only if this character class will either match nothing or only ASCII bytes. Stated differently, this returns false if and only if this class contains a non-ASCII byte.",68,[[["self"]],["bool"]]],[11,"fmt","","",69,[[["self"],["formatter"]],["result"]]],[11,"next","","",69,[[["self"]],["option",["classbytesrange"]]]],[11,"clone","","",70,[[["self"]],["classbytesrange"]]],[11,"default","","",70,[[],["classbytesrange"]]],[11,"assert_receiver_is_total_eq","","",70,N],[11,"eq","","",70,[[["self"],["classbytesrange"]],["bool"]]],[11,"ne","","",70,[[["self"],["classbytesrange"]],["bool"]]],[11,"partial_cmp","","",70,[[["self"],["classbytesrange"]],["option",["ordering"]]]],[11,"lt","","",70,[[["self"],["classbytesrange"]],["bool"]]],[11,"le","","",70,[[["self"],["classbytesrange"]],["bool"]]],[11,"gt","","",70,[[["self"],["classbytesrange"]],["bool"]]],[11,"ge","","",70,[[["self"],["classbytesrange"]],["bool"]]],[11,"cmp","","",70,[[["self"],["classbytesrange"]],["ordering"]]],[11,"lower","","",70,[[["self"]],["u8"]]],[11,"upper","","",70,[[["self"]],["u8"]]],[11,"set_lower","","",70,[[["self"],["u8"]]]],[11,"set_upper","","",70,[[["self"],["u8"]]]],[11,"case_fold_simple","","Apply simple case folding to this byte range. Only ASCII case mappings (for a-z) are applied.",70,[[["self"],["vec"]]]],[11,"new","","Create a new byte range for a character class.",70,[[["u8"],["u8"]],["classbytesrange"]]],[11,"start","","Return the start of this range.",70,[[["self"]],["u8"]]],[11,"end","","Return the end of this range.",70,[[["self"]],["u8"]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"clone","","",78,[[["self"]],["anchor"]]],[11,"fmt","","",78,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",78,N],[11,"eq","","",78,[[["self"],["anchor"]],["bool"]]],[11,"clone","","",79,[[["self"]],["wordboundary"]]],[11,"fmt","","",79,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",79,N],[11,"eq","","",79,[[["self"],["wordboundary"]],["bool"]]],[11,"is_negated","","Returns true if and only if this word boundary assertion is negated.",79,[[["self"]],["bool"]]],[11,"clone","","",71,[[["self"]],["group"]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",71,N],[11,"eq","","",71,[[["self"],["group"]],["bool"]]],[11,"ne","","",71,[[["self"],["group"]],["bool"]]],[11,"clone","","",80,[[["self"]],["groupkind"]]],[11,"fmt","","",80,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",80,N],[11,"eq","","",80,[[["self"],["groupkind"]],["bool"]]],[11,"ne","","",80,[[["self"],["groupkind"]],["bool"]]],[11,"clone","","",72,[[["self"]],["repetition"]]],[11,"fmt","","",72,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",72,N],[11,"eq","","",72,[[["self"],["repetition"]],["bool"]]],[11,"ne","","",72,[[["self"],["repetition"]],["bool"]]],[11,"is_match_empty","","Returns true if and only if this repetition operator makes it possible to match the empty string.",72,[[["self"]],["bool"]]],[11,"clone","","",81,[[["self"]],["repetitionkind"]]],[11,"fmt","","",81,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",81,N],[11,"eq","","",81,[[["self"],["repetitionkind"]],["bool"]]],[11,"ne","","",81,[[["self"],["repetitionkind"]],["bool"]]],[11,"clone","","",82,[[["self"]],["repetitionrange"]]],[11,"fmt","","",82,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",82,N],[11,"eq","","",82,[[["self"],["repetitionrange"]],["bool"]]],[11,"ne","","",82,[[["self"],["repetitionrange"]],["bool"]]],[11,"drop","","",64,[[["self"]]]],[11,"clone","","",73,[[["self"]],["hirinfo"]]],[11,"fmt","","",73,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",73,N],[11,"eq","","",73,[[["self"],["hirinfo"]],["bool"]]],[11,"ne","","",73,[[["self"],["hirinfo"]],["bool"]]],[11,"new","","",73,[[],["hirinfo"]]],[11,"is_always_utf8","","",73,[[["self"]],["bool"]]],[11,"set_always_utf8","","",73,[[["self"],["bool"]]]],[11,"is_all_assertions","","",73,[[["self"]],["bool"]]],[11,"set_all_assertions","","",73,[[["self"],["bool"]]]],[11,"is_anchored_start","","",73,[[["self"]],["bool"]]],[11,"set_anchored_start","","",73,[[["self"],["bool"]]]],[11,"is_anchored_end","","",73,[[["self"]],["bool"]]],[11,"set_anchored_end","","",73,[[["self"],["bool"]]]],[11,"is_any_anchored_start","","",73,[[["self"]],["bool"]]],[11,"set_any_anchored_start","","",73,[[["self"],["bool"]]]],[11,"is_any_anchored_end","","",73,[[["self"]],["bool"]]],[11,"set_any_anchored_end","","",73,[[["self"],["bool"]]]],[11,"is_match_empty","","",73,[[["self"]],["bool"]]],[11,"set_match_empty","","",73,[[["self"],["bool"]]]],[0,"parser","regex_syntax","",N,N],[3,"ParserBuilder","regex_syntax::parser","A builder for a regular expression parser.",N,N],[12,"ast","","",1,N],[12,"hir","","",1,N],[3,"Parser","","A convenience parser for regular expressions.",N,N],[12,"ast","","",0,N],[12,"hir","","",0,N],[11,"clone","regex_syntax","",1,[[["self"]],["parserbuilder"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"default","","",1,[[],["parserbuilder"]]],[11,"new","","Create a new parser builder with a default configuration.",1,[[],["parserbuilder"]]],[11,"build","","Build a parser from this configuration with the given pattern.",1,[[["self"]],["parser"]]],[11,"nest_limit","","Set the nesting limit for this parser.",1,[[["self"],["u32"]],["parserbuilder"]]],[11,"octal","","Whether to support octal syntax or not.",1,[[["self"],["bool"]],["parserbuilder"]]],[11,"allow_invalid_utf8","","When enabled, the parser will permit the construction of a regular expression that may match invalid UTF-8.",1,[[["self"],["bool"]],["parserbuilder"]]],[11,"ignore_whitespace","","Enable verbose mode in the regular expression.",1,[[["self"],["bool"]],["parserbuilder"]]],[11,"case_insensitive","","Enable or disable the case insensitive flag by default.",1,[[["self"],["bool"]],["parserbuilder"]]],[11,"multi_line","","Enable or disable the multi-line matching flag by default.",1,[[["self"],["bool"]],["parserbuilder"]]],[11,"dot_matches_new_line","","Enable or disable the \"dot matches any character\" flag by default.",1,[[["self"],["bool"]],["parserbuilder"]]],[11,"swap_greed","","Enable or disable the \"swap greed\" flag by default.",1,[[["self"],["bool"]],["parserbuilder"]]],[11,"unicode","","Enable or disable the Unicode flag (`u`) by default.",1,[[["self"],["bool"]],["parserbuilder"]]],[11,"clone","","",0,[[["self"]],["parser"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new parser with a default configuration.",0,[[],["parser"]]],[11,"parse","","Parse the regular expression into a high level intermediate representation.",0,[[["self"],["str"]],["result",["hir"]]]],[0,"unicode","","",N,N],[3,"SimpleFoldIter","regex_syntax::unicode","An iterator over a codepoint's simple case equivalence class.",N,N],[12,"0","","",100,N],[3,"AgeIter","","An iterator over Unicode Age sets. Each item corresponds to a set of codepoints that were added in a particular revision of Unicode. The iterator yields items in chronological order.",N,N],[12,"ages","","",101,N],[4,"Error","","An error that occurs when dealing with Unicode.",N,N],[13,"PropertyNotFound","","",102,N],[13,"PropertyValueNotFound","","",102,N],[4,"ClassQuery","","A query for finding a character class defined by Unicode. This supports either use of a property name directly, or lookup by property value. The former generally refers to Binary properties (see UTS#44, Table 8), but as a special exception (see UTS#18, Section 1.2) both general categories (an enumeration) and scripts (a catalog) are supported as if each of their possible values were a binary property.",N,N],[13,"OneLetter","","Return a class corresponding to a Unicode binary property, named by a single letter.",103,N],[13,"Binary","","Return a class corresponding to a Unicode binary property.",103,N],[13,"ByValue","","Return a class corresponding to all codepoints whose property (identified by `property_name`) corresponds to the given value (identified by `property_value`).",103,N],[12,"property_name","regex_syntax::unicode::ClassQuery","A property name.",103,N],[12,"property_value","","A property value.",103,N],[4,"CanonicalClassQuery","regex_syntax::unicode","Like ClassQuery, but its parameters have been canonicalized. This also differentiates binary properties from flattened general categories and scripts.",N,N],[13,"Binary","","The canonical binary property name.",104,N],[13,"GeneralCategory","","The canonical general category name.",104,N],[13,"Script","","The canonical script name.",104,N],[13,"ByValue","","An arbitrary association between property and value, both of which have been canonicalized.",104,N],[12,"property_name","regex_syntax::unicode::CanonicalClassQuery","The canonical property name.",104,N],[12,"property_value","","The canonical property value.",104,N],[5,"encode_utf8","regex_syntax::unicode","Encode the given Unicode character to `dst` as a single UTF-8 sequence.",N,N],[5,"simple_fold","","Return an iterator over the equivalence class of simple case mappings for the given codepoint. The equivalence class does not include the given codepoint.",N,[[["char"]],["result",["simplefolditer","option"]]]],[5,"contains_simple_case_mapping","","Returns true if and only if the given (inclusive) range contains at least one Unicode scalar value that has a non-empty non-trivial simple case mapping.",N,[[["char"],["char"]],["bool"]]],[5,"class","","Looks up a Unicode class given a query. If one doesn't exist, then `None` is returned.",N,[[["classquery"]],["result",["classunicode","error"]]]],[5,"hir_class","","Build a Unicode HIR class from a sequence of Unicode scalar value ranges.",N,N],[5,"canonical_prop","","",N,[[["str"]],["option",["str"]]]],[5,"canonical_gencat","","",N,[[["str"]],["option",["str"]]]],[5,"canonical_script","","",N,[[["str"]],["option",["str"]]]],[5,"canonical_value","","",N,[[["propertyvalues"],["str"]],["option",["str"]]]],[5,"normalize","","",N,[[["str"]],["string"]]],[5,"property_values","","",N,[[["str"]],["option",["propertyvalues"]]]],[5,"property_set","","",N,N],[5,"ages","","",N,[[["str"]],["result",["ageiter","error"]]]],[6,"Result","","",N,N],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result"]]],[11,"next","","",100,[[["self"]],["option",["char"]]]],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[11,"canonicalize","","",103,[[["self"]],["result",["canonicalclassquery","error"]]]],[11,"canonical_binary","","",103,[[["self"],["str"]],["result",["canonicalclassquery","error"]]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",104,N],[11,"eq","","",104,[[["self"],["canonicalclassquery"]],["bool"]]],[11,"ne","","",104,[[["self"],["canonicalclassquery"]],["bool"]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"next","","",101,[[["self"]],["option"]]],[0,"unicode_tables","regex_syntax","",N,N],[0,"age","regex_syntax::unicode_tables","",N,N],[17,"BY_NAME","regex_syntax::unicode_tables::age","",N,N],[17,"V10_0","","",N,N],[17,"V1_1","","",N,N],[17,"V2_0","","",N,N],[17,"V2_1","","",N,N],[17,"V3_0","","",N,N],[17,"V3_1","","",N,N],[17,"V3_2","","",N,N],[17,"V4_0","","",N,N],[17,"V4_1","","",N,N],[17,"V5_0","","",N,N],[17,"V5_1","","",N,N],[17,"V5_2","","",N,N],[17,"V6_0","","",N,N],[17,"V6_1","","",N,N],[17,"V6_2","","",N,N],[17,"V6_3","","",N,N],[17,"V7_0","","",N,N],[17,"V8_0","","",N,N],[17,"V9_0","","",N,N],[0,"case_folding_simple","regex_syntax::unicode_tables","",N,N],[17,"CASE_FOLDING_SIMPLE","regex_syntax::unicode_tables::case_folding_simple","",N,N],[0,"general_category","regex_syntax::unicode_tables","",N,N],[17,"BY_NAME","regex_syntax::unicode_tables::general_category","",N,N],[17,"CASED_LETTER","","",N,N],[17,"CLOSE_PUNCTUATION","","",N,N],[17,"CONNECTOR_PUNCTUATION","","",N,N],[17,"CONTROL","","",N,N],[17,"CURRENCY_SYMBOL","","",N,N],[17,"DASH_PUNCTUATION","","",N,N],[17,"DECIMAL_NUMBER","","",N,N],[17,"ENCLOSING_MARK","","",N,N],[17,"FINAL_PUNCTUATION","","",N,N],[17,"FORMAT","","",N,N],[17,"INITIAL_PUNCTUATION","","",N,N],[17,"LETTER","","",N,N],[17,"LETTER_NUMBER","","",N,N],[17,"LINE_SEPARATOR","","",N,N],[17,"LOWERCASE_LETTER","","",N,N],[17,"MARK","","",N,N],[17,"MATH_SYMBOL","","",N,N],[17,"MODIFIER_LETTER","","",N,N],[17,"MODIFIER_SYMBOL","","",N,N],[17,"NONSPACING_MARK","","",N,N],[17,"NUMBER","","",N,N],[17,"OPEN_PUNCTUATION","","",N,N],[17,"OTHER","","",N,N],[17,"OTHER_LETTER","","",N,N],[17,"OTHER_NUMBER","","",N,N],[17,"OTHER_PUNCTUATION","","",N,N],[17,"OTHER_SYMBOL","","",N,N],[17,"PARAGRAPH_SEPARATOR","","",N,N],[17,"PRIVATE_USE","","",N,N],[17,"PUNCTUATION","","",N,N],[17,"SEPARATOR","","",N,N],[17,"SPACE_SEPARATOR","","",N,N],[17,"SPACING_MARK","","",N,N],[17,"SYMBOL","","",N,N],[17,"TITLECASE_LETTER","","",N,N],[17,"UNASSIGNED","","",N,N],[17,"UPPERCASE_LETTER","","",N,N],[0,"perl_word","regex_syntax::unicode_tables","",N,N],[17,"PERL_WORD","regex_syntax::unicode_tables::perl_word","",N,N],[0,"property_bool","regex_syntax::unicode_tables","",N,N],[17,"BY_NAME","regex_syntax::unicode_tables::property_bool","",N,N],[17,"ASCII_HEX_DIGIT","","",N,N],[17,"ALPHABETIC","","",N,N],[17,"BIDI_CONTROL","","",N,N],[17,"CASE_IGNORABLE","","",N,N],[17,"CASED","","",N,N],[17,"CHANGES_WHEN_CASEFOLDED","","",N,N],[17,"CHANGES_WHEN_CASEMAPPED","","",N,N],[17,"CHANGES_WHEN_LOWERCASED","","",N,N],[17,"CHANGES_WHEN_TITLECASED","","",N,N],[17,"CHANGES_WHEN_UPPERCASED","","",N,N],[17,"DASH","","",N,N],[17,"DEFAULT_IGNORABLE_CODE_POINT","","",N,N],[17,"DEPRECATED","","",N,N],[17,"DIACRITIC","","",N,N],[17,"EXTENDER","","",N,N],[17,"GRAPHEME_BASE","","",N,N],[17,"GRAPHEME_EXTEND","","",N,N],[17,"GRAPHEME_LINK","","",N,N],[17,"HEX_DIGIT","","",N,N],[17,"HYPHEN","","",N,N],[17,"IDS_BINARY_OPERATOR","","",N,N],[17,"IDS_TRINARY_OPERATOR","","",N,N],[17,"ID_CONTINUE","","",N,N],[17,"ID_START","","",N,N],[17,"IDEOGRAPHIC","","",N,N],[17,"JOIN_CONTROL","","",N,N],[17,"LOGICAL_ORDER_EXCEPTION","","",N,N],[17,"LOWERCASE","","",N,N],[17,"MATH","","",N,N],[17,"NONCHARACTER_CODE_POINT","","",N,N],[17,"OTHER_ALPHABETIC","","",N,N],[17,"OTHER_DEFAULT_IGNORABLE_CODE_POINT","","",N,N],[17,"OTHER_GRAPHEME_EXTEND","","",N,N],[17,"OTHER_ID_CONTINUE","","",N,N],[17,"OTHER_ID_START","","",N,N],[17,"OTHER_LOWERCASE","","",N,N],[17,"OTHER_MATH","","",N,N],[17,"OTHER_UPPERCASE","","",N,N],[17,"PATTERN_SYNTAX","","",N,N],[17,"PATTERN_WHITE_SPACE","","",N,N],[17,"PREPENDED_CONCATENATION_MARK","","",N,N],[17,"QUOTATION_MARK","","",N,N],[17,"RADICAL","","",N,N],[17,"REGIONAL_INDICATOR","","",N,N],[17,"SENTENCE_TERMINAL","","",N,N],[17,"SOFT_DOTTED","","",N,N],[17,"TERMINAL_PUNCTUATION","","",N,N],[17,"UNIFIED_IDEOGRAPH","","",N,N],[17,"UPPERCASE","","",N,N],[17,"VARIATION_SELECTOR","","",N,N],[17,"WHITE_SPACE","","",N,N],[17,"XID_CONTINUE","","",N,N],[17,"XID_START","","",N,N],[0,"property_names","regex_syntax::unicode_tables","",N,N],[17,"PROPERTY_NAMES","regex_syntax::unicode_tables::property_names","",N,N],[0,"property_values","regex_syntax::unicode_tables","",N,N],[17,"PROPERTY_VALUES","regex_syntax::unicode_tables::property_values","",N,N],[0,"script_extension","regex_syntax::unicode_tables","",N,N],[17,"BY_NAME","regex_syntax::unicode_tables::script_extension","",N,N],[17,"ADLAM","","",N,N],[17,"AHOM","","",N,N],[17,"ANATOLIAN_HIEROGLYPHS","","",N,N],[17,"ARABIC","","",N,N],[17,"ARMENIAN","","",N,N],[17,"AVESTAN","","",N,N],[17,"BALINESE","","",N,N],[17,"BAMUM","","",N,N],[17,"BASSA_VAH","","",N,N],[17,"BATAK","","",N,N],[17,"BENGALI","","",N,N],[17,"BHAIKSUKI","","",N,N],[17,"BOPOMOFO","","",N,N],[17,"BRAHMI","","",N,N],[17,"BRAILLE","","",N,N],[17,"BUGINESE","","",N,N],[17,"BUHID","","",N,N],[17,"CANADIAN_ABORIGINAL","","",N,N],[17,"CARIAN","","",N,N],[17,"CAUCASIAN_ALBANIAN","","",N,N],[17,"CHAKMA","","",N,N],[17,"CHAM","","",N,N],[17,"CHEROKEE","","",N,N],[17,"COMMON","","",N,N],[17,"COPTIC","","",N,N],[17,"CUNEIFORM","","",N,N],[17,"CYPRIOT","","",N,N],[17,"CYRILLIC","","",N,N],[17,"DESERET","","",N,N],[17,"DEVANAGARI","","",N,N],[17,"DUPLOYAN","","",N,N],[17,"EGYPTIAN_HIEROGLYPHS","","",N,N],[17,"ELBASAN","","",N,N],[17,"ETHIOPIC","","",N,N],[17,"GEORGIAN","","",N,N],[17,"GLAGOLITIC","","",N,N],[17,"GOTHIC","","",N,N],[17,"GRANTHA","","",N,N],[17,"GREEK","","",N,N],[17,"GUJARATI","","",N,N],[17,"GURMUKHI","","",N,N],[17,"HAN","","",N,N],[17,"HANGUL","","",N,N],[17,"HANUNOO","","",N,N],[17,"HATRAN","","",N,N],[17,"HEBREW","","",N,N],[17,"HIRAGANA","","",N,N],[17,"IMPERIAL_ARAMAIC","","",N,N],[17,"INHERITED","","",N,N],[17,"INSCRIPTIONAL_PAHLAVI","","",N,N],[17,"INSCRIPTIONAL_PARTHIAN","","",N,N],[17,"JAVANESE","","",N,N],[17,"KAITHI","","",N,N],[17,"KANNADA","","",N,N],[17,"KATAKANA","","",N,N],[17,"KAYAH_LI","","",N,N],[17,"KHAROSHTHI","","",N,N],[17,"KHMER","","",N,N],[17,"KHOJKI","","",N,N],[17,"KHUDAWADI","","",N,N],[17,"LAO","","",N,N],[17,"LATIN","","",N,N],[17,"LEPCHA","","",N,N],[17,"LIMBU","","",N,N],[17,"LINEAR_A","","",N,N],[17,"LINEAR_B","","",N,N],[17,"LISU","","",N,N],[17,"LYCIAN","","",N,N],[17,"LYDIAN","","",N,N],[17,"MAHAJANI","","",N,N],[17,"MALAYALAM","","",N,N],[17,"MANDAIC","","",N,N],[17,"MANICHAEAN","","",N,N],[17,"MARCHEN","","",N,N],[17,"MASARAM_GONDI","","",N,N],[17,"MEETEI_MAYEK","","",N,N],[17,"MENDE_KIKAKUI","","",N,N],[17,"MEROITIC_CURSIVE","","",N,N],[17,"MEROITIC_HIEROGLYPHS","","",N,N],[17,"MIAO","","",N,N],[17,"MODI","","",N,N],[17,"MONGOLIAN","","",N,N],[17,"MRO","","",N,N],[17,"MULTANI","","",N,N],[17,"MYANMAR","","",N,N],[17,"NABATAEAN","","",N,N],[17,"NEW_TAI_LUE","","",N,N],[17,"NEWA","","",N,N],[17,"NKO","","",N,N],[17,"NUSHU","","",N,N],[17,"OGHAM","","",N,N],[17,"OL_CHIKI","","",N,N],[17,"OLD_HUNGARIAN","","",N,N],[17,"OLD_ITALIC","","",N,N],[17,"OLD_NORTH_ARABIAN","","",N,N],[17,"OLD_PERMIC","","",N,N],[17,"OLD_PERSIAN","","",N,N],[17,"OLD_SOUTH_ARABIAN","","",N,N],[17,"OLD_TURKIC","","",N,N],[17,"ORIYA","","",N,N],[17,"OSAGE","","",N,N],[17,"OSMANYA","","",N,N],[17,"PAHAWH_HMONG","","",N,N],[17,"PALMYRENE","","",N,N],[17,"PAU_CIN_HAU","","",N,N],[17,"PHAGS_PA","","",N,N],[17,"PHOENICIAN","","",N,N],[17,"PSALTER_PAHLAVI","","",N,N],[17,"REJANG","","",N,N],[17,"RUNIC","","",N,N],[17,"SAMARITAN","","",N,N],[17,"SAURASHTRA","","",N,N],[17,"SHARADA","","",N,N],[17,"SHAVIAN","","",N,N],[17,"SIDDHAM","","",N,N],[17,"SIGNWRITING","","",N,N],[17,"SINHALA","","",N,N],[17,"SORA_SOMPENG","","",N,N],[17,"SOYOMBO","","",N,N],[17,"SUNDANESE","","",N,N],[17,"SYLOTI_NAGRI","","",N,N],[17,"SYRIAC","","",N,N],[17,"TAGALOG","","",N,N],[17,"TAGBANWA","","",N,N],[17,"TAI_LE","","",N,N],[17,"TAI_THAM","","",N,N],[17,"TAI_VIET","","",N,N],[17,"TAKRI","","",N,N],[17,"TAMIL","","",N,N],[17,"TANGUT","","",N,N],[17,"TELUGU","","",N,N],[17,"THAANA","","",N,N],[17,"THAI","","",N,N],[17,"TIBETAN","","",N,N],[17,"TIFINAGH","","",N,N],[17,"TIRHUTA","","",N,N],[17,"UGARITIC","","",N,N],[17,"VAI","","",N,N],[17,"WARANG_CITI","","",N,N],[17,"YI","","",N,N],[17,"ZANABAZAR_SQUARE","","",N,N],[0,"script","regex_syntax::unicode_tables","",N,N],[17,"BY_NAME","regex_syntax::unicode_tables::script","",N,N],[17,"ADLAM","","",N,N],[17,"AHOM","","",N,N],[17,"ANATOLIAN_HIEROGLYPHS","","",N,N],[17,"ARABIC","","",N,N],[17,"ARMENIAN","","",N,N],[17,"AVESTAN","","",N,N],[17,"BALINESE","","",N,N],[17,"BAMUM","","",N,N],[17,"BASSA_VAH","","",N,N],[17,"BATAK","","",N,N],[17,"BENGALI","","",N,N],[17,"BHAIKSUKI","","",N,N],[17,"BOPOMOFO","","",N,N],[17,"BRAHMI","","",N,N],[17,"BRAILLE","","",N,N],[17,"BUGINESE","","",N,N],[17,"BUHID","","",N,N],[17,"CANADIAN_ABORIGINAL","","",N,N],[17,"CARIAN","","",N,N],[17,"CAUCASIAN_ALBANIAN","","",N,N],[17,"CHAKMA","","",N,N],[17,"CHAM","","",N,N],[17,"CHEROKEE","","",N,N],[17,"COMMON","","",N,N],[17,"COPTIC","","",N,N],[17,"CUNEIFORM","","",N,N],[17,"CYPRIOT","","",N,N],[17,"CYRILLIC","","",N,N],[17,"DESERET","","",N,N],[17,"DEVANAGARI","","",N,N],[17,"DUPLOYAN","","",N,N],[17,"EGYPTIAN_HIEROGLYPHS","","",N,N],[17,"ELBASAN","","",N,N],[17,"ETHIOPIC","","",N,N],[17,"GEORGIAN","","",N,N],[17,"GLAGOLITIC","","",N,N],[17,"GOTHIC","","",N,N],[17,"GRANTHA","","",N,N],[17,"GREEK","","",N,N],[17,"GUJARATI","","",N,N],[17,"GURMUKHI","","",N,N],[17,"HAN","","",N,N],[17,"HANGUL","","",N,N],[17,"HANUNOO","","",N,N],[17,"HATRAN","","",N,N],[17,"HEBREW","","",N,N],[17,"HIRAGANA","","",N,N],[17,"IMPERIAL_ARAMAIC","","",N,N],[17,"INHERITED","","",N,N],[17,"INSCRIPTIONAL_PAHLAVI","","",N,N],[17,"INSCRIPTIONAL_PARTHIAN","","",N,N],[17,"JAVANESE","","",N,N],[17,"KAITHI","","",N,N],[17,"KANNADA","","",N,N],[17,"KATAKANA","","",N,N],[17,"KAYAH_LI","","",N,N],[17,"KHAROSHTHI","","",N,N],[17,"KHMER","","",N,N],[17,"KHOJKI","","",N,N],[17,"KHUDAWADI","","",N,N],[17,"LAO","","",N,N],[17,"LATIN","","",N,N],[17,"LEPCHA","","",N,N],[17,"LIMBU","","",N,N],[17,"LINEAR_A","","",N,N],[17,"LINEAR_B","","",N,N],[17,"LISU","","",N,N],[17,"LYCIAN","","",N,N],[17,"LYDIAN","","",N,N],[17,"MAHAJANI","","",N,N],[17,"MALAYALAM","","",N,N],[17,"MANDAIC","","",N,N],[17,"MANICHAEAN","","",N,N],[17,"MARCHEN","","",N,N],[17,"MASARAM_GONDI","","",N,N],[17,"MEETEI_MAYEK","","",N,N],[17,"MENDE_KIKAKUI","","",N,N],[17,"MEROITIC_CURSIVE","","",N,N],[17,"MEROITIC_HIEROGLYPHS","","",N,N],[17,"MIAO","","",N,N],[17,"MODI","","",N,N],[17,"MONGOLIAN","","",N,N],[17,"MRO","","",N,N],[17,"MULTANI","","",N,N],[17,"MYANMAR","","",N,N],[17,"NABATAEAN","","",N,N],[17,"NEW_TAI_LUE","","",N,N],[17,"NEWA","","",N,N],[17,"NKO","","",N,N],[17,"NUSHU","","",N,N],[17,"OGHAM","","",N,N],[17,"OL_CHIKI","","",N,N],[17,"OLD_HUNGARIAN","","",N,N],[17,"OLD_ITALIC","","",N,N],[17,"OLD_NORTH_ARABIAN","","",N,N],[17,"OLD_PERMIC","","",N,N],[17,"OLD_PERSIAN","","",N,N],[17,"OLD_SOUTH_ARABIAN","","",N,N],[17,"OLD_TURKIC","","",N,N],[17,"ORIYA","","",N,N],[17,"OSAGE","","",N,N],[17,"OSMANYA","","",N,N],[17,"PAHAWH_HMONG","","",N,N],[17,"PALMYRENE","","",N,N],[17,"PAU_CIN_HAU","","",N,N],[17,"PHAGS_PA","","",N,N],[17,"PHOENICIAN","","",N,N],[17,"PSALTER_PAHLAVI","","",N,N],[17,"REJANG","","",N,N],[17,"RUNIC","","",N,N],[17,"SAMARITAN","","",N,N],[17,"SAURASHTRA","","",N,N],[17,"SHARADA","","",N,N],[17,"SHAVIAN","","",N,N],[17,"SIDDHAM","","",N,N],[17,"SIGNWRITING","","",N,N],[17,"SINHALA","","",N,N],[17,"SORA_SOMPENG","","",N,N],[17,"SOYOMBO","","",N,N],[17,"SUNDANESE","","",N,N],[17,"SYLOTI_NAGRI","","",N,N],[17,"SYRIAC","","",N,N],[17,"TAGALOG","","",N,N],[17,"TAGBANWA","","",N,N],[17,"TAI_LE","","",N,N],[17,"TAI_THAM","","",N,N],[17,"TAI_VIET","","",N,N],[17,"TAKRI","","",N,N],[17,"TAMIL","","",N,N],[17,"TANGUT","","",N,N],[17,"TELUGU","","",N,N],[17,"THAANA","","",N,N],[17,"THAI","","",N,N],[17,"TIBETAN","","",N,N],[17,"TIFINAGH","","",N,N],[17,"TIRHUTA","","",N,N],[17,"UGARITIC","","",N,N],[17,"VAI","","",N,N],[17,"WARANG_CITI","","",N,N],[17,"YI","","",N,N],[17,"ZANABAZAR_SQUARE","","",N,N],[6,"Result","regex_syntax","A type alias for dealing with errors returned by this crate.",N,N]],"paths":[[3,"Parser"],[3,"ParserBuilder"],[4,"Error"],[3,"Error"],[3,"Span"],[3,"Position"],[3,"WithComments"],[3,"Comment"],[3,"Alternation"],[3,"Concat"],[3,"Literal"],[3,"ClassPerl"],[3,"ClassAscii"],[3,"ClassUnicode"],[3,"ClassBracketed"],[3,"ClassSetRange"],[3,"ClassSetUnion"],[3,"ClassSetBinaryOp"],[3,"Assertion"],[3,"Repetition"],[3,"RepetitionOp"],[3,"Group"],[3,"CaptureName"],[3,"SetFlags"],[3,"Flags"],[3,"FlagsItem"],[4,"ErrorKind"],[4,"Ast"],[4,"LiteralKind"],[4,"SpecialLiteralKind"],[4,"HexLiteralKind"],[4,"Class"],[4,"ClassPerlKind"],[4,"ClassAsciiKind"],[4,"ClassUnicodeKind"],[4,"ClassUnicodeOpKind"],[4,"ClassSet"],[4,"ClassSetItem"],[4,"ClassSetBinaryOpKind"],[4,"AssertionKind"],[4,"RepetitionKind"],[4,"RepetitionRange"],[4,"GroupKind"],[4,"FlagsItemKind"],[4,"Flag"],[3,"ParserBuilder"],[3,"Parser"],[3,"ParserI"],[3,"NestLimiter"],[4,"Primitive"],[4,"GroupState"],[4,"ClassState"],[3,"PrinterBuilder"],[3,"Printer"],[3,"Writer"],[3,"HeapVisitor"],[4,"Frame"],[4,"ClassFrame"],[4,"ClassInduct"],[8,"Visitor"],[4,"Either"],[3,"Formatter"],[3,"Spans"],[3,"Error"],[3,"Hir"],[3,"ClassUnicode"],[3,"ClassUnicodeIter"],[3,"ClassUnicodeRange"],[3,"ClassBytes"],[3,"ClassBytesIter"],[3,"ClassBytesRange"],[3,"Group"],[3,"Repetition"],[3,"HirInfo"],[4,"ErrorKind"],[4,"HirKind"],[4,"Literal"],[4,"Class"],[4,"Anchor"],[4,"WordBoundary"],[4,"GroupKind"],[4,"RepetitionKind"],[4,"RepetitionRange"],[3,"IntervalSet"],[3,"IntervalSetIter"],[8,"Interval"],[8,"Bound"],[3,"Literals"],[3,"Literal"],[3,"PrinterBuilder"],[3,"Printer"],[3,"Writer"],[3,"TranslatorBuilder"],[3,"Translator"],[3,"TranslatorI"],[3,"Flags"],[4,"HirFrame"],[3,"HeapVisitor"],[4,"Frame"],[8,"Visitor"],[3,"SimpleFoldIter"],[3,"AgeIter"],[4,"Error"],[4,"ClassQuery"],[4,"CanonicalClassQuery"]]};
searchIndex["remove_dir_all"]={"doc":"","items":[[5,"remove_dir_all","remove_dir_all","Removes a directory at this path, after removing all its contents. Use carefully!",N,[[["p"]],["result",["error"]]]]],"paths":[]};
searchIndex["rustc"]={"doc":"The \"main crate\" of the Rust compiler. This crate contains common type definitions that are used by the other crates in the rustc \"family\". Some prominent examples (note that each of these modules has their own README with further details).","items":[[0,"macros","rustc","",N,N],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0038","rustc::diagnostics","",N,N],[0,"__register_diagnostic_E0072","","",N,N],[0,"__register_diagnostic_E0080","","",N,N],[0,"__register_diagnostic_E0106","","",N,N],[0,"__register_diagnostic_E0119","","",N,N],[0,"__register_diagnostic_E0136","","",N,N],[0,"__register_diagnostic_E0137","","",N,N],[0,"__register_diagnostic_E0138","","",N,N],[0,"__register_diagnostic_E0139","","",N,N],[0,"__register_diagnostic_E0152","","",N,N],[0,"__register_diagnostic_E0214","","",N,N],[0,"__register_diagnostic_E0230","","",N,N],[0,"__register_diagnostic_E0231","","",N,N],[0,"__register_diagnostic_E0232","","",N,N],[0,"__register_diagnostic_E0261","","",N,N],[0,"__register_diagnostic_E0262","","",N,N],[0,"__register_diagnostic_E0263","","",N,N],[0,"__register_diagnostic_E0264","","",N,N],[0,"__register_diagnostic_E0271","","",N,N],[0,"__register_diagnostic_E0275","","",N,N],[0,"__register_diagnostic_E0276","","",N,N],[0,"__register_diagnostic_E0277","","",N,N],[0,"__register_diagnostic_E0281","","",N,N],[0,"__register_diagnostic_E0282","","",N,N],[0,"__register_diagnostic_E0283","","",N,N],[0,"__register_diagnostic_E0296","","",N,N],[0,"__register_diagnostic_E0308","","",N,N],[0,"__register_diagnostic_E0309","","",N,N],[0,"__register_diagnostic_E0310","","",N,N],[0,"__register_diagnostic_E0317","","",N,N],[0,"__register_diagnostic_E0391","","",N,N],[0,"__register_diagnostic_E0398","","",N,N],[0,"__register_diagnostic_E0452","","",N,N],[0,"__register_diagnostic_E0453","","",N,N],[0,"__register_diagnostic_E0478","","",N,N],[0,"__register_diagnostic_E0491","","",N,N],[0,"__register_diagnostic_E0496","","",N,N],[0,"__register_diagnostic_E0497","","",N,N],[0,"__register_diagnostic_E0512","","",N,N],[0,"__register_diagnostic_E0517","","",N,N],[0,"__register_diagnostic_E0518","","",N,N],[0,"__register_diagnostic_E0522","","",N,N],[0,"__register_diagnostic_E0525","","",N,N],[0,"__register_diagnostic_E0580","","",N,N],[0,"__register_diagnostic_E0562","","",N,N],[0,"__register_diagnostic_E0591","","",N,N],[0,"__register_diagnostic_E0593","","",N,N],[0,"__register_diagnostic_E0601","","",N,N],[0,"__register_diagnostic_E0602","","",N,N],[0,"__register_diagnostic_E0621","","",N,N],[0,"__register_diagnostic_E0644","","",N,N],[0,"__register_diagnostic_E0692","","",N,N],[0,"__register_diagnostic_E0700","","",N,N],[0,"__register_diagnostic_E0701","","",N,N],[0,"__register_diagnostic_E0702","","",N,N],[0,"__register_diagnostic_E0278","","",N,N],[0,"__register_diagnostic_E0279","","",N,N],[0,"__register_diagnostic_E0280","","",N,N],[0,"__register_diagnostic_E0284","","",N,N],[0,"__register_diagnostic_E0311","","",N,N],[0,"__register_diagnostic_E0312","","",N,N],[0,"__register_diagnostic_E0313","","",N,N],[0,"__register_diagnostic_E0314","","",N,N],[0,"__register_diagnostic_E0315","","",N,N],[0,"__register_diagnostic_E0316","","",N,N],[0,"__register_diagnostic_E0320","","",N,N],[0,"__register_diagnostic_E0473","","",N,N],[0,"__register_diagnostic_E0474","","",N,N],[0,"__register_diagnostic_E0475","","",N,N],[0,"__register_diagnostic_E0476","","",N,N],[0,"__register_diagnostic_E0477","","",N,N],[0,"__register_diagnostic_E0479","","",N,N],[0,"__register_diagnostic_E0480","","",N,N],[0,"__register_diagnostic_E0481","","",N,N],[0,"__register_diagnostic_E0482","","",N,N],[0,"__register_diagnostic_E0483","","",N,N],[0,"__register_diagnostic_E0484","","",N,N],[0,"__register_diagnostic_E0485","","",N,N],[0,"__register_diagnostic_E0486","","",N,N],[0,"__register_diagnostic_E0487","","",N,N],[0,"__register_diagnostic_E0488","","",N,N],[0,"__register_diagnostic_E0489","","",N,N],[0,"__register_diagnostic_E0490","","",N,N],[0,"__register_diagnostic_E0495","","",N,N],[0,"__register_diagnostic_E0566","","",N,N],[0,"__register_diagnostic_E0623","","",N,N],[0,"__register_diagnostic_E0628","","",N,N],[0,"__register_diagnostic_E0631","","",N,N],[0,"__register_diagnostic_E0637","","",N,N],[0,"__register_diagnostic_E0657","","",N,N],[0,"__register_diagnostic_E0687","","",N,N],[0,"__register_diagnostic_E0688","","",N,N],[0,"__register_diagnostic_E0697","","",N,N],[0,"__register_diagnostic_E0707","","",N,N],[0,"__register_diagnostic_E0708","","",N,N],[0,"__register_diagnostic_E0709","","",N,N],[0,"__register_diagnostic_E0710","","",N,N],[0,"cfg","rustc","Module that constructs a control-flow graph representing an item. Uses `Graph` as the underlying representation.",N,N],[3,"CFG","rustc::cfg","",N,N],[12,"owner_def_id","","",0,N],[12,"graph","","",0,N],[12,"entry","","",0,N],[12,"exit","","",0,N],[3,"CFGEdgeData","","",N,N],[12,"exiting_scopes","","",1,N],[4,"CFGNodeData","","",N,N],[13,"AST","","",2,N],[13,"Entry","","",2,N],[13,"Exit","","",2,N],[13,"Dummy","","",2,N],[13,"Unreachable","","",2,N],[0,"construct","","",N,N],[3,"CFGBuilder","rustc::cfg::construct","",N,N],[12,"tcx","","",3,N],[12,"owner_def_id","","",3,N],[12,"tables","","",3,N],[12,"graph","","",3,N],[12,"fn_exit","","",3,N],[12,"loop_scopes","","",3,N],[12,"breakable_block_scopes","","",3,N],[3,"BlockScope","","",N,N],[12,"block_expr_id","","",4,N],[12,"break_index","","",4,N],[3,"LoopScope","","",N,N],[12,"loop_id","","",5,N],[12,"continue_index","","",5,N],[12,"break_index","","",5,N],[4,"ScopeCfKind","","",N,N],[13,"Break","","",6,N],[13,"Continue","","",6,N],[5,"construct","","",N,[[["tyctxt"],["body"]],["cfg"]]],[11,"clone","","",4,[[["self"]],["blockscope"]]],[11,"clone","","",5,[[["self"]],["loopscope"]]],[11,"block","","",3,[[["self"],["block"],["cfgindex"]],["cfgindex"]]],[11,"stmt","","",3,[[["self"],["stmt"],["cfgindex"]],["cfgindex"]]],[11,"decl","","",3,[[["self"],["decl"],["cfgindex"]],["cfgindex"]]],[11,"pat","","",3,[[["self"],["pat"],["cfgindex"]],["cfgindex"]]],[11,"pats_all","","Handles case where all of the patterns must match.",3,[[["self"],["i"],["cfgindex"]],["cfgindex"]]],[11,"expr","","",3,[[["self"],["expr"],["cfgindex"]],["cfgindex"]]],[11,"call","","",3,[[["self"],["expr"],["cfgindex"],["expr"],["i"]],["cfgindex"]]],[11,"exprs","","Constructs graph for `exprs` evaluated in order",3,[[["self"],["i"],["cfgindex"]],["cfgindex"]]],[11,"opt_expr","","Constructs graph for `opt_expr` evaluated, if Some",3,[[["self"],["option"],["cfgindex"]],["cfgindex"]]],[11,"straightline","","Handles case of an expression that evaluates `subexprs` in order",3,[[["self"],["expr"],["cfgindex"],["i"]],["cfgindex"]]],[11,"match_","","",3,N],[11,"add_dummy_node","","",3,N],[11,"add_ast_node","","",3,N],[11,"add_unreachable_node","","",3,[[["self"]],["cfgindex"]]],[11,"add_node","","",3,N],[11,"add_contained_edge","","",3,[[["self"],["cfgindex"],["cfgindex"]]]],[11,"add_exiting_edge","","",3,[[["self"],["expr"],["cfgindex"],["scope"],["cfgindex"]]]],[11,"add_returning_edge","","",3,[[["self"],["expr"],["cfgindex"]]]],[11,"find_scope_edge","","",3,N],[11,"clone","","",6,[[["self"]],["scopecfkind"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"eq","","",6,[[["self"],["scopecfkind"]],["bool"]]],[0,"graphviz","rustc::cfg","",N,N],[3,"LabelledCFG","rustc::cfg::graphviz","",N,N],[12,"tcx","","",7,N],[12,"cfg","","",7,N],[12,"name","","",7,N],[12,"labelled_edges","","`labelled_edges` controls whether we emit labels on the edges",7,N],[6,"Node","","",N,N],[6,"Edge","","",N,N],[11,"local_id_to_string","","",7,[[["self"],["itemlocalid"]],["string"]]],[11,"graph_id","","",7,[[["self"]],["id"]]],[11,"node_id","","",7,[[["self"],["node"]],["id"]]],[11,"node_label","","",7,[[["self"],["node"]],["labeltext"]]],[11,"edge_label","","",7,[[["self"],["edge"]],["labeltext"]]],[11,"nodes","","",7,[[["self"]],["nodes",["node"]]]],[11,"edges","","",7,[[["self"]],["edges",["edge"]]]],[11,"source","","",7,[[["self"],["edge"]],["node"]]],[11,"target","","",7,[[["self"],["edge"]],["node"]]],[6,"CFGIndex","rustc::cfg","",N,N],[6,"CFGGraph","","",N,N],[6,"CFGNode","","",N,N],[6,"CFGEdge","","",N,N],[11,"clone","","",2,[[["self"]],["cfgnodedata"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"eq","","",2,[[["self"],["cfgnodedata"]],["bool"]]],[11,"ne","","",2,[[["self"],["cfgnodedata"]],["bool"]]],[11,"id","","",2,[[["self"]],["itemlocalid"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"new","","",0,[[["tyctxt"],["body"]],["cfg"]]],[11,"node_is_reachable","","",0,[[["self"],["itemlocalid"]],["bool"]]],[0,"dep_graph","rustc","",N,N],[3,"DepTrackingMap","rustc::dep_graph","A DepTrackingMap offers a subset of the `Map` API and ensures that we make calls to `read` and `write` as appropriate. We key the maps with a unique type for brevity.",N,N],[12,"phantom","","",8,N],[12,"graph","","",8,N],[12,"map","","",8,N],[3,"DepNode","","",N,N],[12,"kind","","",9,N],[12,"hash","","",9,N],[3,"WorkProductId","","A \"work product\" corresponds to a `.o` (or other) file that we save in between runs. These ids do not have a DefId but rather some independent path or string that persists between runs without the need to be mapped or unmapped. (This ensures we can serialize them even in the absence of a tcx.)",N,N],[12,"hash","","",10,N],[3,"DepGraph","","",N,N],[12,"data","","",11,N],[12,"fingerprints","","",11,N],[3,"WorkProduct","","A \"work product\" is an intermediate result that we save into the incremental directory for later re-use. The primary example are the object files that we save for each partition at code generation time.",N,N],[12,"cgu_name","","",12,N],[12,"saved_files","","Saved files associated with this CGU",12,N],[3,"DepNodeIndex","","",N,N],[12,"0","","",13,N],[3,"PreviousDepGraph","","",N,N],[12,"data","","",14,N],[12,"index","","",14,N],[3,"DepGraphQuery","","",N,N],[12,"graph","","",15,N],[12,"indices","","",15,N],[3,"AssertDepGraphSafe","","A convenient override that lets you pass arbitrary state into a task. Every use should be accompanied by a comment explaining why it makes sense (or how it could be refactored away in the future).",N,N],[12,"0","","",16,N],[3,"SerializedDepGraph","","Data for use when recompiling the current crate.",N,N],[12,"nodes","","The set of all DepNodes in the graph",17,N],[12,"fingerprints","","The set of all Fingerprints in the graph. Each Fingerprint corresponds to the DepNode at the same index in the nodes vector.",17,N],[12,"edge_list_indices","","For each DepNode, stores the list of edges originating from that DepNode. Encoded as a [start, end) pair indexing into edge_list_data, which holds the actual DepNodeIndices of the target nodes.",17,N],[12,"edge_list_data","","A flattened list of all edge targets in the graph. Edge sources are implicit in edge_list_indices.",17,N],[3,"SerializedDepNodeIndex","","",N,N],[12,"0","","",18,N],[4,"DepKind","","",N,N],[13,"Null","","",19,N],[13,"Krate","","",19,N],[13,"HirBody","","",19,N],[13,"Hir","","",19,N],[13,"CrateMetadata","","",19,N],[13,"RegionScopeTree","","",19,N],[13,"Coherence","","",19,N],[13,"CoherenceInherentImplOverlapCheck","","",19,N],[13,"CoherenceCheckTrait","","",19,N],[13,"PrivacyAccessLevels","","",19,N],[13,"MirConstQualif","","",19,N],[13,"MirBuilt","","",19,N],[13,"MirConst","","",19,N],[13,"MirValidated","","",19,N],[13,"MirOptimized","","",19,N],[13,"MirShim","","",19,N],[13,"BorrowCheckKrate","","",19,N],[13,"BorrowCheck","","",19,N],[13,"MirBorrowCheck","","",19,N],[13,"UnsafetyCheckResult","","",19,N],[13,"UnsafeDeriveOnReprPacked","","",19,N],[13,"Reachability","","",19,N],[13,"MirKeys","","",19,N],[13,"CrateVariances","","",19,N],[13,"AssociatedItems","","",19,N],[13,"TypeOfItem","","",19,N],[13,"GenericsOfItem","","",19,N],[13,"PredicatesOfItem","","",19,N],[13,"ExplicitPredicatesOfItem","","",19,N],[13,"PredicatesDefinedOnItem","","",19,N],[13,"InferredOutlivesOf","","",19,N],[13,"InferredOutlivesCrate","","",19,N],[13,"SuperPredicatesOfItem","","",19,N],[13,"TraitDefOfItem","","",19,N],[13,"AdtDefOfItem","","",19,N],[13,"ImplTraitRef","","",19,N],[13,"ImplPolarity","","",19,N],[13,"FnSignature","","",19,N],[13,"CoerceUnsizedInfo","","",19,N],[13,"ItemVarianceConstraints","","",19,N],[13,"ItemVariances","","",19,N],[13,"IsConstFn","","",19,N],[13,"IsForeignItem","","",19,N],[13,"TypeParamPredicates","","",19,N],[13,"SizedConstraint","","",19,N],[13,"DtorckConstraint","","",19,N],[13,"AdtDestructor","","",19,N],[13,"AssociatedItemDefIds","","",19,N],[13,"InherentImpls","","",19,N],[13,"TypeckBodiesKrate","","",19,N],[13,"TypeckTables","","",19,N],[13,"UsedTraitImports","","",19,N],[13,"HasTypeckTables","","",19,N],[13,"ConstEval","","",19,N],[13,"CheckMatch","","",19,N],[13,"SymbolName","","",19,N],[13,"InstanceSymbolName","","",19,N],[13,"SpecializationGraph","","",19,N],[13,"ObjectSafety","","",19,N],[13,"FulfillObligation","","",19,N],[13,"VtableMethods","","",19,N],[13,"IsCopy","","",19,N],[13,"IsSized","","",19,N],[13,"IsFreeze","","",19,N],[13,"NeedsDrop","","",19,N],[13,"Layout","","",19,N],[13,"TraitImpls","","",19,N],[13,"AllLocalTraitImpls","","",19,N],[13,"TraitSelect","","",19,N],[13,"ParamEnv","","",19,N],[13,"DescribeDef","","",19,N],[13,"DefSpan","","",19,N],[13,"LookupStability","","",19,N],[13,"LookupDeprecationEntry","","",19,N],[13,"ConstIsRvaluePromotableToStatic","","",19,N],[13,"RvaluePromotableMap","","",19,N],[13,"ImplParent","","",19,N],[13,"TraitOfItem","","",19,N],[13,"IsReachableNonGeneric","","",19,N],[13,"IsUnreachableLocalDefinition","","",19,N],[13,"IsMirAvailable","","",19,N],[13,"ItemAttrs","","",19,N],[13,"CodegenFnAttrs","","",19,N],[13,"FnArgNames","","",19,N],[13,"RenderedConst","","",19,N],[13,"DylibDepFormats","","",19,N],[13,"IsPanicRuntime","","",19,N],[13,"IsCompilerBuiltins","","",19,N],[13,"HasGlobalAllocator","","",19,N],[13,"ExternCrate","","",19,N],[13,"LintLevels","","",19,N],[13,"Specializes","","",19,N],[13,"InScopeTraits","","",19,N],[13,"ModuleExports","","",19,N],[13,"IsSanitizerRuntime","","",19,N],[13,"IsProfilerRuntime","","",19,N],[13,"GetPanicStrategy","","",19,N],[13,"IsNoBuiltins","","",19,N],[13,"ImplDefaultness","","",19,N],[13,"CheckItemWellFormed","","",19,N],[13,"CheckTraitItemWellFormed","","",19,N],[13,"CheckImplItemWellFormed","","",19,N],[13,"ReachableNonGenerics","","",19,N],[13,"NativeLibraries","","",19,N],[13,"PluginRegistrarFn","","",19,N],[13,"DeriveRegistrarFn","","",19,N],[13,"CrateDisambiguator","","",19,N],[13,"CrateHash","","",19,N],[13,"OriginalCrateName","","",19,N],[13,"ExtraFileName","","",19,N],[13,"ImplementationsOfTrait","","",19,N],[13,"AllTraitImplementations","","",19,N],[13,"DllimportForeignItems","","",19,N],[13,"IsDllimportForeignItem","","",19,N],[13,"IsStaticallyIncludedForeignItem","","",19,N],[13,"NativeLibraryKind","","",19,N],[13,"LinkArgs","","",19,N],[13,"ResolveLifetimes","","",19,N],[13,"NamedRegion","","",19,N],[13,"IsLateBound","","",19,N],[13,"ObjectLifetimeDefaults","","",19,N],[13,"Visibility","","",19,N],[13,"DepKind","","",19,N],[13,"CrateName","","",19,N],[13,"ItemChildren","","",19,N],[13,"ExternModStmtCnum","","",19,N],[13,"GetLangItems","","",19,N],[13,"DefinedLangItems","","",19,N],[13,"MissingLangItems","","",19,N],[13,"VisibleParentMap","","",19,N],[13,"MissingExternCrateItem","","",19,N],[13,"UsedCrateSource","","",19,N],[13,"PostorderCnums","","",19,N],[13,"EraseRegionsTy","","",19,N],[13,"ConstValueToAllocation","","",19,N],[13,"Freevars","","",19,N],[13,"MaybeUnusedTraitImport","","",19,N],[13,"MaybeUnusedExternCrates","","",19,N],[13,"StabilityIndex","","",19,N],[13,"AllTraits","","",19,N],[13,"AllCrateNums","","",19,N],[13,"ExportedSymbols","","",19,N],[13,"CollectAndPartitionMonoItems","","",19,N],[13,"IsCodegenedItem","","",19,N],[13,"CodegenUnit","","",19,N],[13,"CompileCodegenUnit","","",19,N],[13,"OutputFilenames","","",19,N],[13,"NormalizeProjectionTy","","",19,N],[13,"NormalizeTyAfterErasingRegions","","",19,N],[13,"ImpliedOutlivesBounds","","",19,N],[13,"DropckOutlives","","",19,N],[13,"EvaluateObligation","","",19,N],[13,"TypeOpEq","","",19,N],[13,"TypeOpSubtype","","",19,N],[13,"TypeOpProvePredicate","","",19,N],[13,"TypeOpNormalizeTy","","",19,N],[13,"TypeOpNormalizePredicate","","",19,N],[13,"TypeOpNormalizePolyFnSig","","",19,N],[13,"TypeOpNormalizeFnSig","","",19,N],[13,"SubstituteNormalizeAndTestPredicates","","",19,N],[13,"TargetFeaturesWhitelist","","",19,N],[13,"InstanceDefSizeEstimate","","",19,N],[13,"Features","","",19,N],[13,"ProgramClausesFor","","",19,N],[13,"ProgramClausesForEnv","","",19,N],[13,"WasmImportModuleMap","","",19,N],[13,"ForeignModules","","",19,N],[13,"UpstreamMonomorphizations","","",19,N],[13,"UpstreamMonomorphizationsFor","","",19,N],[4,"DepConstructor","","",N,N],[13,"Null","","",20,N],[13,"Krate","","",20,N],[13,"HirBody","","",20,N],[13,"Hir","","",20,N],[13,"CrateMetadata","","",20,N],[13,"RegionScopeTree","","",20,N],[13,"Coherence","","",20,N],[13,"CoherenceInherentImplOverlapCheck","","",20,N],[13,"CoherenceCheckTrait","","",20,N],[13,"PrivacyAccessLevels","","",20,N],[13,"MirConstQualif","","",20,N],[13,"MirBuilt","","",20,N],[13,"MirConst","","",20,N],[13,"MirValidated","","",20,N],[13,"MirOptimized","","",20,N],[13,"MirShim","","",20,N],[12,"instance_def","rustc::dep_graph::DepConstructor","",20,N],[13,"BorrowCheckKrate","rustc::dep_graph","",20,N],[13,"BorrowCheck","","",20,N],[13,"MirBorrowCheck","","",20,N],[13,"UnsafetyCheckResult","","",20,N],[13,"UnsafeDeriveOnReprPacked","","",20,N],[13,"Reachability","","",20,N],[13,"MirKeys","","",20,N],[13,"CrateVariances","","",20,N],[13,"AssociatedItems","","",20,N],[13,"TypeOfItem","","",20,N],[13,"GenericsOfItem","","",20,N],[13,"PredicatesOfItem","","",20,N],[13,"ExplicitPredicatesOfItem","","",20,N],[13,"PredicatesDefinedOnItem","","",20,N],[13,"InferredOutlivesOf","","",20,N],[13,"InferredOutlivesCrate","","",20,N],[13,"SuperPredicatesOfItem","","",20,N],[13,"TraitDefOfItem","","",20,N],[13,"AdtDefOfItem","","",20,N],[13,"ImplTraitRef","","",20,N],[13,"ImplPolarity","","",20,N],[13,"FnSignature","","",20,N],[13,"CoerceUnsizedInfo","","",20,N],[13,"ItemVarianceConstraints","","",20,N],[13,"ItemVariances","","",20,N],[13,"IsConstFn","","",20,N],[13,"IsForeignItem","","",20,N],[13,"TypeParamPredicates","","",20,N],[12,"item_id","rustc::dep_graph::DepConstructor","",20,N],[12,"param_id","","",20,N],[13,"SizedConstraint","rustc::dep_graph","",20,N],[13,"DtorckConstraint","","",20,N],[13,"AdtDestructor","","",20,N],[13,"AssociatedItemDefIds","","",20,N],[13,"InherentImpls","","",20,N],[13,"TypeckBodiesKrate","","",20,N],[13,"TypeckTables","","",20,N],[13,"UsedTraitImports","","",20,N],[13,"HasTypeckTables","","",20,N],[13,"ConstEval","","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"CheckMatch","rustc::dep_graph","",20,N],[13,"SymbolName","","",20,N],[13,"InstanceSymbolName","","",20,N],[12,"instance","rustc::dep_graph::DepConstructor","",20,N],[13,"SpecializationGraph","rustc::dep_graph","",20,N],[13,"ObjectSafety","","",20,N],[13,"FulfillObligation","","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[12,"trait_ref","","",20,N],[13,"VtableMethods","rustc::dep_graph","",20,N],[12,"trait_ref","rustc::dep_graph::DepConstructor","",20,N],[13,"IsCopy","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"IsSized","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"IsFreeze","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"NeedsDrop","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"Layout","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"TraitImpls","rustc::dep_graph","",20,N],[13,"AllLocalTraitImpls","","",20,N],[13,"TraitSelect","","",20,N],[13,"ParamEnv","","",20,N],[13,"DescribeDef","","",20,N],[13,"DefSpan","","",20,N],[13,"LookupStability","","",20,N],[13,"LookupDeprecationEntry","","",20,N],[13,"ConstIsRvaluePromotableToStatic","","",20,N],[13,"RvaluePromotableMap","","",20,N],[13,"ImplParent","","",20,N],[13,"TraitOfItem","","",20,N],[13,"IsReachableNonGeneric","","",20,N],[13,"IsUnreachableLocalDefinition","","",20,N],[13,"IsMirAvailable","","",20,N],[13,"ItemAttrs","","",20,N],[13,"CodegenFnAttrs","","",20,N],[13,"FnArgNames","","",20,N],[13,"RenderedConst","","",20,N],[13,"DylibDepFormats","","",20,N],[13,"IsPanicRuntime","","",20,N],[13,"IsCompilerBuiltins","","",20,N],[13,"HasGlobalAllocator","","",20,N],[13,"ExternCrate","","",20,N],[13,"LintLevels","","",20,N],[13,"Specializes","","",20,N],[12,"impl1","rustc::dep_graph::DepConstructor","",20,N],[12,"impl2","","",20,N],[13,"InScopeTraits","rustc::dep_graph","",20,N],[13,"ModuleExports","","",20,N],[13,"IsSanitizerRuntime","","",20,N],[13,"IsProfilerRuntime","","",20,N],[13,"GetPanicStrategy","","",20,N],[13,"IsNoBuiltins","","",20,N],[13,"ImplDefaultness","","",20,N],[13,"CheckItemWellFormed","","",20,N],[13,"CheckTraitItemWellFormed","","",20,N],[13,"CheckImplItemWellFormed","","",20,N],[13,"ReachableNonGenerics","","",20,N],[13,"NativeLibraries","","",20,N],[13,"PluginRegistrarFn","","",20,N],[13,"DeriveRegistrarFn","","",20,N],[13,"CrateDisambiguator","","",20,N],[13,"CrateHash","","",20,N],[13,"OriginalCrateName","","",20,N],[13,"ExtraFileName","","",20,N],[13,"ImplementationsOfTrait","","",20,N],[12,"krate","rustc::dep_graph::DepConstructor","",20,N],[12,"trait_id","","",20,N],[13,"AllTraitImplementations","rustc::dep_graph","",20,N],[13,"DllimportForeignItems","","",20,N],[13,"IsDllimportForeignItem","","",20,N],[13,"IsStaticallyIncludedForeignItem","","",20,N],[13,"NativeLibraryKind","","",20,N],[13,"LinkArgs","","",20,N],[13,"ResolveLifetimes","","",20,N],[13,"NamedRegion","","",20,N],[13,"IsLateBound","","",20,N],[13,"ObjectLifetimeDefaults","","",20,N],[13,"Visibility","","",20,N],[13,"DepKind","","",20,N],[13,"CrateName","","",20,N],[13,"ItemChildren","","",20,N],[13,"ExternModStmtCnum","","",20,N],[13,"GetLangItems","","",20,N],[13,"DefinedLangItems","","",20,N],[13,"MissingLangItems","","",20,N],[13,"VisibleParentMap","","",20,N],[13,"MissingExternCrateItem","","",20,N],[13,"UsedCrateSource","","",20,N],[13,"PostorderCnums","","",20,N],[13,"EraseRegionsTy","","",20,N],[12,"ty","rustc::dep_graph::DepConstructor","",20,N],[13,"ConstValueToAllocation","rustc::dep_graph","",20,N],[12,"val","rustc::dep_graph::DepConstructor","",20,N],[13,"Freevars","rustc::dep_graph","",20,N],[13,"MaybeUnusedTraitImport","","",20,N],[13,"MaybeUnusedExternCrates","","",20,N],[13,"StabilityIndex","","",20,N],[13,"AllTraits","","",20,N],[13,"AllCrateNums","","",20,N],[13,"ExportedSymbols","","",20,N],[13,"CollectAndPartitionMonoItems","","",20,N],[13,"IsCodegenedItem","","",20,N],[13,"CodegenUnit","","",20,N],[13,"CompileCodegenUnit","","",20,N],[13,"OutputFilenames","","",20,N],[13,"NormalizeProjectionTy","","",20,N],[13,"NormalizeTyAfterErasingRegions","","",20,N],[13,"ImpliedOutlivesBounds","","",20,N],[13,"DropckOutlives","","",20,N],[13,"EvaluateObligation","","",20,N],[13,"TypeOpEq","","",20,N],[13,"TypeOpSubtype","","",20,N],[13,"TypeOpProvePredicate","","",20,N],[13,"TypeOpNormalizeTy","","",20,N],[13,"TypeOpNormalizePredicate","","",20,N],[13,"TypeOpNormalizePolyFnSig","","",20,N],[13,"TypeOpNormalizeFnSig","","",20,N],[13,"SubstituteNormalizeAndTestPredicates","","",20,N],[12,"key","rustc::dep_graph::DepConstructor","",20,N],[13,"TargetFeaturesWhitelist","rustc::dep_graph","",20,N],[13,"InstanceDefSizeEstimate","","",20,N],[12,"instance_def","rustc::dep_graph::DepConstructor","",20,N],[13,"Features","rustc::dep_graph","",20,N],[13,"ProgramClausesFor","","",20,N],[13,"ProgramClausesForEnv","","",20,N],[13,"WasmImportModuleMap","","",20,N],[13,"ForeignModules","","",20,N],[13,"UpstreamMonomorphizations","","",20,N],[13,"UpstreamMonomorphizationsFor","","",20,N],[4,"DepNodeColor","","",N,N],[13,"Red","","",21,N],[13,"Green","","",21,N],[4,"OpenTask","","",N,N],[13,"Regular","","",22,N],[13,"Anon","","",22,N],[13,"Ignore","","",22,N],[13,"EvalAlways","","",22,N],[12,"node","rustc::dep_graph::OpenTask","",22,N],[4,"WorkProductFileKind","rustc::dep_graph","",N,N],[13,"Object","","",23,N],[13,"Bytecode","","",23,N],[13,"BytecodeCompressed","","",23,N],[0,"debug","","Code for debugging the dep-graph.",N,N],[3,"DepNodeFilter","rustc::dep_graph::debug","A dep-node filter goes from a user-defined string to a query over nodes. Right now the format is like this:",N,N],[12,"text","","",24,N],[3,"EdgeFilter","","A filter like `F -> G` where `F` and `G` are valid dep-node filters. This can be used to test the source/target independently.",N,N],[12,"source","","",25,N],[12,"target","","",25,N],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"new","","",24,[[["str"]],["self"]]],[11,"accepts_all","","True if all nodes always pass the filter.",24,[[["self"]],["bool"]]],[11,"test","","Tests whether `node` meets the filter, returning true if so.",24,[[["self"],["depnode"]],["bool"]]],[11,"new","","",25,[[["str"]],["result",["edgefilter","box"]]]],[11,"test","","",25,[[["self"],["depnode"],["depnode"]],["bool"]]],[0,"dep_node","rustc::dep_graph","This module defines the `DepNode` type which the compiler uses to represent nodes in the dependency graph. A `DepNode` consists of a `DepKind` (which specifies the kind of thing it represents, like a piece of HIR, MIR, etc) and a `Fingerprint`, a 128 bit hash value the exact meaning of which depends on the node's `DepKind`. Together, the kind and the fingerprint fully identify a dependency node, even across multiple compilation sessions. In other words, the value of the fingerprint does not depend on anything that is specific to a given compilation session, like an unpredictable interning key (e.g. NodeId, DefId, Symbol) or the numeric value of a pointer. The concept behind this could be compared to how git commit hashes uniquely identify a given commit and has a few advantages:",N,N],[3,"DepNode","rustc::dep_graph::dep_node","",N,N],[12,"kind","","",9,N],[12,"hash","","",9,N],[3,"WorkProductId","","A \"work product\" corresponds to a `.o` (or other) file that we save in between runs. These ids do not have a DefId but rather some independent path or string that persists between runs without the need to be mapped or unmapped. (This ensures we can serialize them even in the absence of a tcx.)",N,N],[12,"hash","","",10,N],[4,"DepKind","","",N,N],[13,"Null","","",19,N],[13,"Krate","","",19,N],[13,"HirBody","","",19,N],[13,"Hir","","",19,N],[13,"CrateMetadata","","",19,N],[13,"RegionScopeTree","","",19,N],[13,"Coherence","","",19,N],[13,"CoherenceInherentImplOverlapCheck","","",19,N],[13,"CoherenceCheckTrait","","",19,N],[13,"PrivacyAccessLevels","","",19,N],[13,"MirConstQualif","","",19,N],[13,"MirBuilt","","",19,N],[13,"MirConst","","",19,N],[13,"MirValidated","","",19,N],[13,"MirOptimized","","",19,N],[13,"MirShim","","",19,N],[13,"BorrowCheckKrate","","",19,N],[13,"BorrowCheck","","",19,N],[13,"MirBorrowCheck","","",19,N],[13,"UnsafetyCheckResult","","",19,N],[13,"UnsafeDeriveOnReprPacked","","",19,N],[13,"Reachability","","",19,N],[13,"MirKeys","","",19,N],[13,"CrateVariances","","",19,N],[13,"AssociatedItems","","",19,N],[13,"TypeOfItem","","",19,N],[13,"GenericsOfItem","","",19,N],[13,"PredicatesOfItem","","",19,N],[13,"ExplicitPredicatesOfItem","","",19,N],[13,"PredicatesDefinedOnItem","","",19,N],[13,"InferredOutlivesOf","","",19,N],[13,"InferredOutlivesCrate","","",19,N],[13,"SuperPredicatesOfItem","","",19,N],[13,"TraitDefOfItem","","",19,N],[13,"AdtDefOfItem","","",19,N],[13,"ImplTraitRef","","",19,N],[13,"ImplPolarity","","",19,N],[13,"FnSignature","","",19,N],[13,"CoerceUnsizedInfo","","",19,N],[13,"ItemVarianceConstraints","","",19,N],[13,"ItemVariances","","",19,N],[13,"IsConstFn","","",19,N],[13,"IsForeignItem","","",19,N],[13,"TypeParamPredicates","","",19,N],[13,"SizedConstraint","","",19,N],[13,"DtorckConstraint","","",19,N],[13,"AdtDestructor","","",19,N],[13,"AssociatedItemDefIds","","",19,N],[13,"InherentImpls","","",19,N],[13,"TypeckBodiesKrate","","",19,N],[13,"TypeckTables","","",19,N],[13,"UsedTraitImports","","",19,N],[13,"HasTypeckTables","","",19,N],[13,"ConstEval","","",19,N],[13,"CheckMatch","","",19,N],[13,"SymbolName","","",19,N],[13,"InstanceSymbolName","","",19,N],[13,"SpecializationGraph","","",19,N],[13,"ObjectSafety","","",19,N],[13,"FulfillObligation","","",19,N],[13,"VtableMethods","","",19,N],[13,"IsCopy","","",19,N],[13,"IsSized","","",19,N],[13,"IsFreeze","","",19,N],[13,"NeedsDrop","","",19,N],[13,"Layout","","",19,N],[13,"TraitImpls","","",19,N],[13,"AllLocalTraitImpls","","",19,N],[13,"TraitSelect","","",19,N],[13,"ParamEnv","","",19,N],[13,"DescribeDef","","",19,N],[13,"DefSpan","","",19,N],[13,"LookupStability","","",19,N],[13,"LookupDeprecationEntry","","",19,N],[13,"ConstIsRvaluePromotableToStatic","","",19,N],[13,"RvaluePromotableMap","","",19,N],[13,"ImplParent","","",19,N],[13,"TraitOfItem","","",19,N],[13,"IsReachableNonGeneric","","",19,N],[13,"IsUnreachableLocalDefinition","","",19,N],[13,"IsMirAvailable","","",19,N],[13,"ItemAttrs","","",19,N],[13,"CodegenFnAttrs","","",19,N],[13,"FnArgNames","","",19,N],[13,"RenderedConst","","",19,N],[13,"DylibDepFormats","","",19,N],[13,"IsPanicRuntime","","",19,N],[13,"IsCompilerBuiltins","","",19,N],[13,"HasGlobalAllocator","","",19,N],[13,"ExternCrate","","",19,N],[13,"LintLevels","","",19,N],[13,"Specializes","","",19,N],[13,"InScopeTraits","","",19,N],[13,"ModuleExports","","",19,N],[13,"IsSanitizerRuntime","","",19,N],[13,"IsProfilerRuntime","","",19,N],[13,"GetPanicStrategy","","",19,N],[13,"IsNoBuiltins","","",19,N],[13,"ImplDefaultness","","",19,N],[13,"CheckItemWellFormed","","",19,N],[13,"CheckTraitItemWellFormed","","",19,N],[13,"CheckImplItemWellFormed","","",19,N],[13,"ReachableNonGenerics","","",19,N],[13,"NativeLibraries","","",19,N],[13,"PluginRegistrarFn","","",19,N],[13,"DeriveRegistrarFn","","",19,N],[13,"CrateDisambiguator","","",19,N],[13,"CrateHash","","",19,N],[13,"OriginalCrateName","","",19,N],[13,"ExtraFileName","","",19,N],[13,"ImplementationsOfTrait","","",19,N],[13,"AllTraitImplementations","","",19,N],[13,"DllimportForeignItems","","",19,N],[13,"IsDllimportForeignItem","","",19,N],[13,"IsStaticallyIncludedForeignItem","","",19,N],[13,"NativeLibraryKind","","",19,N],[13,"LinkArgs","","",19,N],[13,"ResolveLifetimes","","",19,N],[13,"NamedRegion","","",19,N],[13,"IsLateBound","","",19,N],[13,"ObjectLifetimeDefaults","","",19,N],[13,"Visibility","","",19,N],[13,"DepKind","","",19,N],[13,"CrateName","","",19,N],[13,"ItemChildren","","",19,N],[13,"ExternModStmtCnum","","",19,N],[13,"GetLangItems","","",19,N],[13,"DefinedLangItems","","",19,N],[13,"MissingLangItems","","",19,N],[13,"VisibleParentMap","","",19,N],[13,"MissingExternCrateItem","","",19,N],[13,"UsedCrateSource","","",19,N],[13,"PostorderCnums","","",19,N],[13,"EraseRegionsTy","","",19,N],[13,"ConstValueToAllocation","","",19,N],[13,"Freevars","","",19,N],[13,"MaybeUnusedTraitImport","","",19,N],[13,"MaybeUnusedExternCrates","","",19,N],[13,"StabilityIndex","","",19,N],[13,"AllTraits","","",19,N],[13,"AllCrateNums","","",19,N],[13,"ExportedSymbols","","",19,N],[13,"CollectAndPartitionMonoItems","","",19,N],[13,"IsCodegenedItem","","",19,N],[13,"CodegenUnit","","",19,N],[13,"CompileCodegenUnit","","",19,N],[13,"OutputFilenames","","",19,N],[13,"NormalizeProjectionTy","","",19,N],[13,"NormalizeTyAfterErasingRegions","","",19,N],[13,"ImpliedOutlivesBounds","","",19,N],[13,"DropckOutlives","","",19,N],[13,"EvaluateObligation","","",19,N],[13,"TypeOpEq","","",19,N],[13,"TypeOpSubtype","","",19,N],[13,"TypeOpProvePredicate","","",19,N],[13,"TypeOpNormalizeTy","","",19,N],[13,"TypeOpNormalizePredicate","","",19,N],[13,"TypeOpNormalizePolyFnSig","","",19,N],[13,"TypeOpNormalizeFnSig","","",19,N],[13,"SubstituteNormalizeAndTestPredicates","","",19,N],[13,"TargetFeaturesWhitelist","","",19,N],[13,"InstanceDefSizeEstimate","","",19,N],[13,"Features","","",19,N],[13,"ProgramClausesFor","","",19,N],[13,"ProgramClausesForEnv","","",19,N],[13,"WasmImportModuleMap","","",19,N],[13,"ForeignModules","","",19,N],[13,"UpstreamMonomorphizations","","",19,N],[13,"UpstreamMonomorphizationsFor","","",19,N],[4,"DepConstructor","","",N,N],[13,"Null","","",20,N],[13,"Krate","","",20,N],[13,"HirBody","","",20,N],[13,"Hir","","",20,N],[13,"CrateMetadata","","",20,N],[13,"RegionScopeTree","","",20,N],[13,"Coherence","","",20,N],[13,"CoherenceInherentImplOverlapCheck","","",20,N],[13,"CoherenceCheckTrait","","",20,N],[13,"PrivacyAccessLevels","","",20,N],[13,"MirConstQualif","","",20,N],[13,"MirBuilt","","",20,N],[13,"MirConst","","",20,N],[13,"MirValidated","","",20,N],[13,"MirOptimized","","",20,N],[13,"MirShim","","",20,N],[12,"instance_def","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"BorrowCheckKrate","rustc::dep_graph::dep_node","",20,N],[13,"BorrowCheck","","",20,N],[13,"MirBorrowCheck","","",20,N],[13,"UnsafetyCheckResult","","",20,N],[13,"UnsafeDeriveOnReprPacked","","",20,N],[13,"Reachability","","",20,N],[13,"MirKeys","","",20,N],[13,"CrateVariances","","",20,N],[13,"AssociatedItems","","",20,N],[13,"TypeOfItem","","",20,N],[13,"GenericsOfItem","","",20,N],[13,"PredicatesOfItem","","",20,N],[13,"ExplicitPredicatesOfItem","","",20,N],[13,"PredicatesDefinedOnItem","","",20,N],[13,"InferredOutlivesOf","","",20,N],[13,"InferredOutlivesCrate","","",20,N],[13,"SuperPredicatesOfItem","","",20,N],[13,"TraitDefOfItem","","",20,N],[13,"AdtDefOfItem","","",20,N],[13,"ImplTraitRef","","",20,N],[13,"ImplPolarity","","",20,N],[13,"FnSignature","","",20,N],[13,"CoerceUnsizedInfo","","",20,N],[13,"ItemVarianceConstraints","","",20,N],[13,"ItemVariances","","",20,N],[13,"IsConstFn","","",20,N],[13,"IsForeignItem","","",20,N],[13,"TypeParamPredicates","","",20,N],[12,"item_id","rustc::dep_graph::dep_node::DepConstructor","",20,N],[12,"param_id","","",20,N],[13,"SizedConstraint","rustc::dep_graph::dep_node","",20,N],[13,"DtorckConstraint","","",20,N],[13,"AdtDestructor","","",20,N],[13,"AssociatedItemDefIds","","",20,N],[13,"InherentImpls","","",20,N],[13,"TypeckBodiesKrate","","",20,N],[13,"TypeckTables","","",20,N],[13,"UsedTraitImports","","",20,N],[13,"HasTypeckTables","","",20,N],[13,"ConstEval","","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"CheckMatch","rustc::dep_graph::dep_node","",20,N],[13,"SymbolName","","",20,N],[13,"InstanceSymbolName","","",20,N],[12,"instance","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"SpecializationGraph","rustc::dep_graph::dep_node","",20,N],[13,"ObjectSafety","","",20,N],[13,"FulfillObligation","","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[12,"trait_ref","","",20,N],[13,"VtableMethods","rustc::dep_graph::dep_node","",20,N],[12,"trait_ref","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"IsCopy","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"IsSized","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"IsFreeze","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"NeedsDrop","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"Layout","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"TraitImpls","rustc::dep_graph::dep_node","",20,N],[13,"AllLocalTraitImpls","","",20,N],[13,"TraitSelect","","",20,N],[13,"ParamEnv","","",20,N],[13,"DescribeDef","","",20,N],[13,"DefSpan","","",20,N],[13,"LookupStability","","",20,N],[13,"LookupDeprecationEntry","","",20,N],[13,"ConstIsRvaluePromotableToStatic","","",20,N],[13,"RvaluePromotableMap","","",20,N],[13,"ImplParent","","",20,N],[13,"TraitOfItem","","",20,N],[13,"IsReachableNonGeneric","","",20,N],[13,"IsUnreachableLocalDefinition","","",20,N],[13,"IsMirAvailable","","",20,N],[13,"ItemAttrs","","",20,N],[13,"CodegenFnAttrs","","",20,N],[13,"FnArgNames","","",20,N],[13,"RenderedConst","","",20,N],[13,"DylibDepFormats","","",20,N],[13,"IsPanicRuntime","","",20,N],[13,"IsCompilerBuiltins","","",20,N],[13,"HasGlobalAllocator","","",20,N],[13,"ExternCrate","","",20,N],[13,"LintLevels","","",20,N],[13,"Specializes","","",20,N],[12,"impl1","rustc::dep_graph::dep_node::DepConstructor","",20,N],[12,"impl2","","",20,N],[13,"InScopeTraits","rustc::dep_graph::dep_node","",20,N],[13,"ModuleExports","","",20,N],[13,"IsSanitizerRuntime","","",20,N],[13,"IsProfilerRuntime","","",20,N],[13,"GetPanicStrategy","","",20,N],[13,"IsNoBuiltins","","",20,N],[13,"ImplDefaultness","","",20,N],[13,"CheckItemWellFormed","","",20,N],[13,"CheckTraitItemWellFormed","","",20,N],[13,"CheckImplItemWellFormed","","",20,N],[13,"ReachableNonGenerics","","",20,N],[13,"NativeLibraries","","",20,N],[13,"PluginRegistrarFn","","",20,N],[13,"DeriveRegistrarFn","","",20,N],[13,"CrateDisambiguator","","",20,N],[13,"CrateHash","","",20,N],[13,"OriginalCrateName","","",20,N],[13,"ExtraFileName","","",20,N],[13,"ImplementationsOfTrait","","",20,N],[12,"krate","rustc::dep_graph::dep_node::DepConstructor","",20,N],[12,"trait_id","","",20,N],[13,"AllTraitImplementations","rustc::dep_graph::dep_node","",20,N],[13,"DllimportForeignItems","","",20,N],[13,"IsDllimportForeignItem","","",20,N],[13,"IsStaticallyIncludedForeignItem","","",20,N],[13,"NativeLibraryKind","","",20,N],[13,"LinkArgs","","",20,N],[13,"ResolveLifetimes","","",20,N],[13,"NamedRegion","","",20,N],[13,"IsLateBound","","",20,N],[13,"ObjectLifetimeDefaults","","",20,N],[13,"Visibility","","",20,N],[13,"DepKind","","",20,N],[13,"CrateName","","",20,N],[13,"ItemChildren","","",20,N],[13,"ExternModStmtCnum","","",20,N],[13,"GetLangItems","","",20,N],[13,"DefinedLangItems","","",20,N],[13,"MissingLangItems","","",20,N],[13,"VisibleParentMap","","",20,N],[13,"MissingExternCrateItem","","",20,N],[13,"UsedCrateSource","","",20,N],[13,"PostorderCnums","","",20,N],[13,"EraseRegionsTy","","",20,N],[12,"ty","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"ConstValueToAllocation","rustc::dep_graph::dep_node","",20,N],[12,"val","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"Freevars","rustc::dep_graph::dep_node","",20,N],[13,"MaybeUnusedTraitImport","","",20,N],[13,"MaybeUnusedExternCrates","","",20,N],[13,"StabilityIndex","","",20,N],[13,"AllTraits","","",20,N],[13,"AllCrateNums","","",20,N],[13,"ExportedSymbols","","",20,N],[13,"CollectAndPartitionMonoItems","","",20,N],[13,"IsCodegenedItem","","",20,N],[13,"CodegenUnit","","",20,N],[13,"CompileCodegenUnit","","",20,N],[13,"OutputFilenames","","",20,N],[13,"NormalizeProjectionTy","","",20,N],[13,"NormalizeTyAfterErasingRegions","","",20,N],[13,"ImpliedOutlivesBounds","","",20,N],[13,"DropckOutlives","","",20,N],[13,"EvaluateObligation","","",20,N],[13,"TypeOpEq","","",20,N],[13,"TypeOpSubtype","","",20,N],[13,"TypeOpProvePredicate","","",20,N],[13,"TypeOpNormalizeTy","","",20,N],[13,"TypeOpNormalizePredicate","","",20,N],[13,"TypeOpNormalizePolyFnSig","","",20,N],[13,"TypeOpNormalizeFnSig","","",20,N],[13,"SubstituteNormalizeAndTestPredicates","","",20,N],[12,"key","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"TargetFeaturesWhitelist","rustc::dep_graph::dep_node","",20,N],[13,"InstanceDefSizeEstimate","","",20,N],[12,"instance_def","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"Features","rustc::dep_graph::dep_node","",20,N],[13,"ProgramClausesFor","","",20,N],[13,"ProgramClausesForEnv","","",20,N],[13,"WasmImportModuleMap","","",20,N],[13,"ForeignModules","","",20,N],[13,"UpstreamMonomorphizations","","",20,N],[13,"UpstreamMonomorphizationsFor","","",20,N],[0,"label_strs","","Contains variant => str representations for constructing DepNode groups for tests.",N,N],[17,"Null","rustc::dep_graph::dep_node::label_strs","",N,N],[17,"Krate","","",N,N],[17,"HirBody","","",N,N],[17,"Hir","","",N,N],[17,"CrateMetadata","","",N,N],[17,"RegionScopeTree","","",N,N],[17,"Coherence","","",N,N],[17,"CoherenceInherentImplOverlapCheck","","",N,N],[17,"CoherenceCheckTrait","","",N,N],[17,"PrivacyAccessLevels","","",N,N],[17,"MirConstQualif","","",N,N],[17,"MirBuilt","","",N,N],[17,"MirConst","","",N,N],[17,"MirValidated","","",N,N],[17,"MirOptimized","","",N,N],[17,"MirShim","","",N,N],[17,"BorrowCheckKrate","","",N,N],[17,"BorrowCheck","","",N,N],[17,"MirBorrowCheck","","",N,N],[17,"UnsafetyCheckResult","","",N,N],[17,"UnsafeDeriveOnReprPacked","","",N,N],[17,"Reachability","","",N,N],[17,"MirKeys","","",N,N],[17,"CrateVariances","","",N,N],[17,"AssociatedItems","","",N,N],[17,"TypeOfItem","","",N,N],[17,"GenericsOfItem","","",N,N],[17,"PredicatesOfItem","","",N,N],[17,"ExplicitPredicatesOfItem","","",N,N],[17,"PredicatesDefinedOnItem","","",N,N],[17,"InferredOutlivesOf","","",N,N],[17,"InferredOutlivesCrate","","",N,N],[17,"SuperPredicatesOfItem","","",N,N],[17,"TraitDefOfItem","","",N,N],[17,"AdtDefOfItem","","",N,N],[17,"ImplTraitRef","","",N,N],[17,"ImplPolarity","","",N,N],[17,"FnSignature","","",N,N],[17,"CoerceUnsizedInfo","","",N,N],[17,"ItemVarianceConstraints","","",N,N],[17,"ItemVariances","","",N,N],[17,"IsConstFn","","",N,N],[17,"IsForeignItem","","",N,N],[17,"TypeParamPredicates","","",N,N],[17,"SizedConstraint","","",N,N],[17,"DtorckConstraint","","",N,N],[17,"AdtDestructor","","",N,N],[17,"AssociatedItemDefIds","","",N,N],[17,"InherentImpls","","",N,N],[17,"TypeckBodiesKrate","","",N,N],[17,"TypeckTables","","",N,N],[17,"UsedTraitImports","","",N,N],[17,"HasTypeckTables","","",N,N],[17,"ConstEval","","",N,N],[17,"CheckMatch","","",N,N],[17,"SymbolName","","",N,N],[17,"InstanceSymbolName","","",N,N],[17,"SpecializationGraph","","",N,N],[17,"ObjectSafety","","",N,N],[17,"FulfillObligation","","",N,N],[17,"VtableMethods","","",N,N],[17,"IsCopy","","",N,N],[17,"IsSized","","",N,N],[17,"IsFreeze","","",N,N],[17,"NeedsDrop","","",N,N],[17,"Layout","","",N,N],[17,"TraitImpls","","",N,N],[17,"AllLocalTraitImpls","","",N,N],[17,"TraitSelect","","",N,N],[17,"ParamEnv","","",N,N],[17,"DescribeDef","","",N,N],[17,"DefSpan","","",N,N],[17,"LookupStability","","",N,N],[17,"LookupDeprecationEntry","","",N,N],[17,"ConstIsRvaluePromotableToStatic","","",N,N],[17,"RvaluePromotableMap","","",N,N],[17,"ImplParent","","",N,N],[17,"TraitOfItem","","",N,N],[17,"IsReachableNonGeneric","","",N,N],[17,"IsUnreachableLocalDefinition","","",N,N],[17,"IsMirAvailable","","",N,N],[17,"ItemAttrs","","",N,N],[17,"CodegenFnAttrs","","",N,N],[17,"FnArgNames","","",N,N],[17,"RenderedConst","","",N,N],[17,"DylibDepFormats","","",N,N],[17,"IsPanicRuntime","","",N,N],[17,"IsCompilerBuiltins","","",N,N],[17,"HasGlobalAllocator","","",N,N],[17,"ExternCrate","","",N,N],[17,"LintLevels","","",N,N],[17,"Specializes","","",N,N],[17,"InScopeTraits","","",N,N],[17,"ModuleExports","","",N,N],[17,"IsSanitizerRuntime","","",N,N],[17,"IsProfilerRuntime","","",N,N],[17,"GetPanicStrategy","","",N,N],[17,"IsNoBuiltins","","",N,N],[17,"ImplDefaultness","","",N,N],[17,"CheckItemWellFormed","","",N,N],[17,"CheckTraitItemWellFormed","","",N,N],[17,"CheckImplItemWellFormed","","",N,N],[17,"ReachableNonGenerics","","",N,N],[17,"NativeLibraries","","",N,N],[17,"PluginRegistrarFn","","",N,N],[17,"DeriveRegistrarFn","","",N,N],[17,"CrateDisambiguator","","",N,N],[17,"CrateHash","","",N,N],[17,"OriginalCrateName","","",N,N],[17,"ExtraFileName","","",N,N],[17,"ImplementationsOfTrait","","",N,N],[17,"AllTraitImplementations","","",N,N],[17,"DllimportForeignItems","","",N,N],[17,"IsDllimportForeignItem","","",N,N],[17,"IsStaticallyIncludedForeignItem","","",N,N],[17,"NativeLibraryKind","","",N,N],[17,"LinkArgs","","",N,N],[17,"ResolveLifetimes","","",N,N],[17,"NamedRegion","","",N,N],[17,"IsLateBound","","",N,N],[17,"ObjectLifetimeDefaults","","",N,N],[17,"Visibility","","",N,N],[17,"DepKind","","",N,N],[17,"CrateName","","",N,N],[17,"ItemChildren","","",N,N],[17,"ExternModStmtCnum","","",N,N],[17,"GetLangItems","","",N,N],[17,"DefinedLangItems","","",N,N],[17,"MissingLangItems","","",N,N],[17,"VisibleParentMap","","",N,N],[17,"MissingExternCrateItem","","",N,N],[17,"UsedCrateSource","","",N,N],[17,"PostorderCnums","","",N,N],[17,"EraseRegionsTy","","",N,N],[17,"ConstValueToAllocation","","",N,N],[17,"Freevars","","",N,N],[17,"MaybeUnusedTraitImport","","",N,N],[17,"MaybeUnusedExternCrates","","",N,N],[17,"StabilityIndex","","",N,N],[17,"AllTraits","","",N,N],[17,"AllCrateNums","","",N,N],[17,"ExportedSymbols","","",N,N],[17,"CollectAndPartitionMonoItems","","",N,N],[17,"IsCodegenedItem","","",N,N],[17,"CodegenUnit","","",N,N],[17,"CompileCodegenUnit","","",N,N],[17,"OutputFilenames","","",N,N],[17,"NormalizeProjectionTy","","",N,N],[17,"NormalizeTyAfterErasingRegions","","",N,N],[17,"ImpliedOutlivesBounds","","",N,N],[17,"DropckOutlives","","",N,N],[17,"EvaluateObligation","","",N,N],[17,"TypeOpEq","","",N,N],[17,"TypeOpSubtype","","",N,N],[17,"TypeOpProvePredicate","","",N,N],[17,"TypeOpNormalizeTy","","",N,N],[17,"TypeOpNormalizePredicate","","",N,N],[17,"TypeOpNormalizePolyFnSig","","",N,N],[17,"TypeOpNormalizeFnSig","","",N,N],[17,"SubstituteNormalizeAndTestPredicates","","",N,N],[17,"TargetFeaturesWhitelist","","",N,N],[17,"InstanceDefSizeEstimate","","",N,N],[17,"Features","","",N,N],[17,"ProgramClausesFor","","",N,N],[17,"ProgramClausesForEnv","","",N,N],[17,"WasmImportModuleMap","","",N,N],[17,"ForeignModules","","",N,N],[17,"UpstreamMonomorphizations","","",N,N],[17,"UpstreamMonomorphizationsFor","","",N,N],[8,"DepNodeParams","rustc::dep_graph::dep_node","",N,N],[18,"CAN_RECONSTRUCT_QUERY_KEY","","",26,N],[11,"to_fingerprint","","This method turns the parameters of a DepNodeConstructor into an opaque Fingerprint to be used in DepNode. Not all DepNodeParams support being turned into a Fingerprint (they don't need to if the corresponding DepNode is anonymous).",26,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"to_debug_str","","",26,[[["self"],["tyctxt"]],["string"]]],[11,"fmt","rustc::dep_graph","",9,[[["self"],["formatter"]],["result"]]],[11,"fingerprint_needed_for_crate_hash","","",19,[[["self"]],["bool"]]],[11,"clone","","",19,[[["self"]],["depkind"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"eq","","",19,[[["self"],["depkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"partial_cmp","","",19,[[["self"],["depkind"]],["option",["ordering"]]]],[11,"cmp","","",19,[[["self"],["depkind"]],["ordering"]]],[11,"hash","","",19,N],[11,"encode","","",19,[[["self"],["__s"]],["result"]]],[11,"decode","","",19,[[["__d"]],["result",["depkind"]]]],[11,"can_reconstruct_query_key","","",19,[[["self"]],["bool"]]],[11,"is_anon","","",19,[[["self"]],["bool"]]],[11,"is_input","","",19,[[["self"]],["bool"]]],[11,"is_eval_always","","",19,[[["self"]],["bool"]]],[11,"has_params","","",19,[[["self"]],["bool"]]],[11,"clone","","",9,[[["self"]],["depnode"]]],[11,"eq","","",9,[[["self"],["depnode"]],["bool"]]],[11,"ne","","",9,[[["self"],["depnode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"partial_cmp","","",9,[[["self"],["depnode"]],["option",["ordering"]]]],[11,"lt","","",9,[[["self"],["depnode"]],["bool"]]],[11,"le","","",9,[[["self"],["depnode"]],["bool"]]],[11,"gt","","",9,[[["self"],["depnode"]],["bool"]]],[11,"ge","","",9,[[["self"],["depnode"]],["bool"]]],[11,"cmp","","",9,[[["self"],["depnode"]],["ordering"]]],[11,"hash","","",9,N],[11,"encode","","",9,[[["self"],["__s"]],["result"]]],[11,"decode","","",9,[[["__d"]],["result",["depnode"]]]],[11,"new","","",9,[[["tyctxt"],["depconstructor"]],["depnode"]]],[11,"from_def_path_hash","","Construct a DepNode from the given DepKind and DefPathHash. This method will assert that the given DepKind actually requires a single DefId/DefPathHash parameter.",9,[[["depkind"],["defpathhash"]],["depnode"]]],[11,"new_no_params","","Create a new, parameterless DepNode. This method will assert that the DepNode corresponding to the given DepKind actually does not require any parameters.",9,[[["depkind"]],["depnode"]]],[11,"extract_def_id","","Extract the DefId corresponding to this DepNode. This will work if two conditions are met:",9,[[["self"],["tyctxt"]],["option",["defid"]]]],[11,"from_label_string","","Used in testing",9,[[["str"],["defpathhash"]],["result",["depnode"]]]],[11,"has_label_string","","Used in testing",9,[[["str"]],["bool"]]],[11,"clone","","",10,[[["self"]],["workproductid"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"ne","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"partial_cmp","","",10,[[["self"],["workproductid"]],["option",["ordering"]]]],[11,"lt","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"le","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"gt","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"ge","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"cmp","","",10,[[["self"],["workproductid"]],["ordering"]]],[11,"hash","","",10,N],[11,"encode","","",10,[[["self"],["__s"]],["result"]]],[11,"decode","","",10,[[["__d"]],["result",["workproductid"]]]],[11,"from_cgu_name","","",10,[[["str"]],["workproductid"]]],[11,"from_fingerprint","","",10,[[["fingerprint"]],["workproductid"]]],[11,"hash_stable","","",10,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"dep_tracking_map","","",N,N],[3,"DepTrackingMap","rustc::dep_graph::dep_tracking_map","A DepTrackingMap offers a subset of the `Map` API and ensures that we make calls to `read` and `write` as appropriate. We key the maps with a unique type for brevity.",N,N],[12,"phantom","","",8,N],[12,"graph","","",8,N],[12,"map","","",8,N],[8,"DepTrackingMapConfig","","",N,N],[16,"Key","","",27,N],[16,"Value","","",27,N],[10,"to_dep_kind","","",27,[[],["depkind"]]],[11,"new","rustc::dep_graph","",8,[[["depgraph"]],["deptrackingmap"]]],[0,"graph","","",N,N],[3,"DepGraph","rustc::dep_graph::graph","",N,N],[12,"data","","",11,N],[12,"fingerprints","","",11,N],[3,"DepNodeIndex","","",N,N],[12,"0","","",13,N],[3,"DepGraphData","","",N,N],[12,"current","","The new encoding of the dependency graph, optimized for red/green tracking. The `current` field is the dependency graph of only the current compilation session: We don't merge the previous dep-graph into current one anymore.",28,N],[12,"previous","","The dep-graph from the previous compilation session. It contains all nodes and edges as well as all fingerprints of nodes that have them.",28,N],[12,"colors","","",28,N],[12,"previous_work_products","","When we load, there may be `.o` files, cached mir, or other such things available to us. If we find that they are not dirty, we load the path to the file storing those work-products here into this map. We can later look for and extract that data.",28,N],[12,"dep_node_debug","","",28,N],[12,"loaded_from_cache","","",28,N],[3,"WorkProduct","","A \"work product\" is an intermediate result that we save into the incremental directory for later re-use. The primary example are the object files that we save for each partition at code generation time.",N,N],[12,"cgu_name","","",12,N],[12,"saved_files","","Saved files associated with this CGU",12,N],[3,"CurrentDepGraph","","",N,N],[12,"nodes","","",29,N],[12,"edges","","",29,N],[12,"node_to_node_index","","",29,N],[12,"forbidden_edge","","",29,N],[12,"anon_id_seed","","",29,N],[12,"total_read_count","","",29,N],[12,"total_duplicate_read_count","","",29,N],[3,"RegularOpenTask","","",N,N],[12,"node","","",30,N],[12,"reads","","",30,N],[12,"read_set","","",30,N],[3,"AnonOpenTask","","",N,N],[12,"reads","","",31,N],[12,"read_set","","",31,N],[3,"DepNodeColorMap","","",N,N],[12,"values","","",32,N],[4,"DepNodeColor","","",N,N],[13,"Red","","",21,N],[13,"Green","","",21,N],[4,"WorkProductFileKind","","",N,N],[13,"Object","","",23,N],[13,"Bytecode","","",23,N],[13,"BytecodeCompressed","","",23,N],[4,"OpenTask","","",N,N],[13,"Regular","","",22,N],[13,"Anon","","",22,N],[13,"Ignore","","",22,N],[13,"EvalAlways","","",22,N],[12,"node","rustc::dep_graph::graph::OpenTask","",22,N],[17,"COMPRESSED_NONE","rustc::dep_graph::graph","",N,N],[17,"COMPRESSED_RED","","",N,N],[17,"COMPRESSED_FIRST_GREEN","","",N,N],[11,"clone","rustc::dep_graph","",11,[[["self"]],["depgraph"]]],[11,"clone","","",13,[[["self"]],["depnodeindex"]]],[11,"eq","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"ne","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"hash","","",13,N],[11,"partial_cmp","","",13,[[["self"],["depnodeindex"]],["option",["ordering"]]]],[11,"lt","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"le","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"gt","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"ge","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"cmp","","",13,[[["self"],["depnodeindex"]],["ordering"]]],[11,"decode","","",13,[[["__d"]],["result",["depnodeindex"]]]],[11,"encode","","",13,[[["self"],["__s"]],["result"]]],[11,"new","","",13,[[["usize"]],["self"]]],[11,"index","","",13,[[["self"]],["usize"]]],[11,"steps_between","","",13,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",13,[[["self"]],["self"]]],[11,"replace_zero","","",13,[[["self"]],["self"]]],[11,"add_one","","",13,[[["self"]],["self"]]],[11,"sub_one","","",13,[[["self"]],["self"]]],[11,"add_usize","","",13,[[["self"],["usize"]],["option"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[18,"INVALID","","",13,N],[11,"clone","","",21,[[["self"]],["depnodecolor"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"eq","","",21,[[["self"],["depnodecolor"]],["bool"]]],[11,"ne","","",21,[[["self"],["depnodecolor"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"hash","","",21,N],[11,"is_green","","",21,[[["self"]],["bool"]]],[11,"new","","",11,[[["previousdepgraph"],["fxhashmap",["workproductid","workproduct"]]],["depgraph"]]],[11,"new_disabled","","",11,[[],["depgraph"]]],[11,"is_fully_enabled","","True if we are actually building the full dep-graph.",11,[[["self"]],["bool"]]],[11,"query","","",11,[[["self"]],["depgraphquery"]]],[11,"assert_ignored","","",11,[[["self"]]]],[11,"with_ignore","","",11,[[["self"],["op"]],["r"]]],[11,"with_task","","Starts a new dep-graph task. Dep-graph tasks are specified using a free function (`task`) and not a closure -- this is intentional because we want to exercise tight control over what state they have access to. In particular, we want to prevent implicit 'leaks' of tracked state into the task (which could then be read without generating correct edges in the dep-graph -- see the [rustc guide] for more details on the dep-graph). To this end, the task function gets exactly two pieces of state: the context `cx` and an argument `arg`. Both of these bits of state must be of some type that implements `DepGraphSafe` and hence does not leak.",11,N],[11,"input_task","","Creates a new dep-graph input with value `input`",11,N],[11,"with_task_impl","","",11,N],[11,"with_anon_task","","Execute something within an \"anonymous\" task, that is, a task the DepNode of which is determined by the list of inputs it read from.",11,N],[11,"with_eval_always_task","","Execute something within an \"eval-always\" task which is a task",11,N],[11,"read","","",11,[[["self"],["depnode"]]]],[11,"read_index","","",11,[[["self"],["depnodeindex"]]]],[11,"dep_node_index_of","","",11,[[["self"],["depnode"]],["depnodeindex"]]],[11,"dep_node_exists","","",11,[[["self"],["depnode"]],["bool"]]],[11,"fingerprint_of","","",11,[[["self"],["depnodeindex"]],["fingerprint"]]],[11,"prev_fingerprint_of","","",11,[[["self"],["depnode"]],["option",["fingerprint"]]]],[11,"prev_dep_node_index_of","","",11,[[["self"],["depnode"]],["serializeddepnodeindex"]]],[11,"previous_work_product","","Check whether a previous work product exists for `v` and, if so, return the path that leads to it. Used to skip doing work.",11,[[["self"],["workproductid"]],["option",["workproduct"]]]],[11,"previous_work_products","","Access the map of work-products created during the cached run. Only used during saving of the dep-graph.",11,[[["self"]],["fxhashmap"]]],[11,"register_dep_node_debug_str","","",11,[[["self"],["depnode"],["f"]]]],[11,"dep_node_debug_str","","",11,[[["self"],["depnode"]],["option",["string"]]]],[11,"edge_deduplication_data","","",11,N],[11,"serialize","","",11,[[["self"]],["serializeddepgraph"]]],[11,"node_color","","",11,[[["self"],["depnode"]],["option",["depnodecolor"]]]],[11,"try_mark_green","","",11,[[["self"],["tyctxt"],["depnode"]],["option",["depnodeindex"]]]],[11,"is_green","","",11,[[["self"],["depnode"]],["bool"]]],[11,"exec_cache_promotions","","",11,[[["self"],["tyctxt"]]]],[11,"mark_loaded_from_cache","","",11,[[["self"],["depnodeindex"],["bool"]]]],[11,"was_loaded_from_cache","","",11,[[["self"],["depnode"]],["option",["bool"]]]],[11,"clone","","",12,[[["self"]],["workproduct"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"encode","","",12,[[["self"],["__s"]],["result"]]],[11,"decode","","",12,[[["__d"]],["result",["workproduct"]]]],[11,"clone","","",23,[[["self"]],["workproductfilekind"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"encode","","",23,[[["self"],["__s"]],["result"]]],[11,"decode","","",23,[[["__d"]],["result",["workproductfilekind"]]]],[11,"new","rustc::dep_graph::graph","",29,[[],["currentdepgraph"]]],[11,"complete_task","","",29,[[["self"],["depnode"],["opentask"]],["depnodeindex"]]],[11,"pop_anon_task","","",29,[[["self"],["depkind"],["opentask"]],["depnodeindex"]]],[11,"complete_eval_always_task","","",29,[[["self"],["depnode"],["opentask"]],["depnodeindex"]]],[11,"read_index","","",29,[[["self"],["depnodeindex"]]]],[11,"alloc_node","","",29,[[["self"],["depnode"],["smallvec"]],["depnodeindex"]]],[11,"new","","",32,[[["usize"]],["depnodecolormap"]]],[11,"get","","",32,[[["self"],["serializeddepnodeindex"]],["option",["depnodecolor"]]]],[11,"insert","","",32,[[["self"],["serializeddepnodeindex"],["depnodecolor"]]]],[0,"prev","rustc::dep_graph","",N,N],[3,"PreviousDepGraph","rustc::dep_graph::prev","",N,N],[12,"data","","",14,N],[12,"index","","",14,N],[11,"fmt","rustc::dep_graph","",14,[[["self"],["formatter"]],["result"]]],[11,"encode","","",14,[[["self"],["__s"]],["result"]]],[11,"decode","","",14,[[["__d"]],["result",["previousdepgraph"]]]],[11,"new","","",14,[[["serializeddepgraph"]],["previousdepgraph"]]],[11,"edges_from","","",14,[[["self"],["depnode"]],["option"]]],[11,"index_to_node","","",14,[[["self"],["serializeddepnodeindex"]],["depnode"]]],[11,"node_to_index","","",14,[[["self"],["depnode"]],["serializeddepnodeindex"]]],[11,"node_to_index_opt","","",14,[[["self"],["depnode"]],["option",["serializeddepnodeindex"]]]],[11,"fingerprint_of","","",14,[[["self"],["depnode"]],["option",["fingerprint"]]]],[11,"fingerprint_by_index","","",14,[[["self"],["serializeddepnodeindex"]],["fingerprint"]]],[11,"node_count","","",14,[[["self"]],["usize"]]],[0,"query","","",N,N],[3,"DepGraphQuery","rustc::dep_graph::query","",N,N],[12,"graph","","",15,N],[12,"indices","","",15,N],[11,"new","rustc::dep_graph","",15,N],[11,"contains_node","","",15,[[["self"],["depnode"]],["bool"]]],[11,"nodes","","",15,[[["self"]],["vec",["depnode"]]]],[11,"edges","","",15,[[["self"]],["vec"]]],[11,"reachable_nodes","","",15,[[["self"],["depnode"],["direction"]],["vec",["depnode"]]]],[11,"transitive_successors","","All nodes reachable from `node`. In other words, things that will have to be recomputed if `node` changes.",15,[[["self"],["depnode"]],["vec",["depnode"]]]],[11,"transitive_predecessors","","All nodes that can reach `node`.",15,[[["self"],["depnode"]],["vec",["depnode"]]]],[11,"immediate_successors","","Just the outgoing edges from `node`.",15,[[["self"],["depnode"]],["vec",["depnode"]]]],[0,"safe","","The `DepGraphSafe` trait",N,N],[3,"AssertDepGraphSafe","rustc::dep_graph::safe","A convenient override that lets you pass arbitrary state into a task. Every use should be accompanied by a comment explaining why it makes sense (or how it could be refactored away in the future).",N,N],[12,"0","","",16,N],[8,"DepGraphSafe","","The `DepGraphSafe` trait is used to specify what kinds of values are safe to \"leak\" into a task. The idea is that this should be only be implemented for things like the tcx as well as various id types, which will create reads in the dep-graph whenever the trait loads anything that might depend on the input program.",N,N],[0,"serialized","rustc::dep_graph","The data that we will serialize and deserialize.",N,N],[3,"SerializedDepNodeIndex","rustc::dep_graph::serialized","",N,N],[12,"0","","",18,N],[3,"SerializedDepGraph","","Data for use when recompiling the current crate.",N,N],[12,"nodes","","The set of all DepNodes in the graph",17,N],[12,"fingerprints","","The set of all Fingerprints in the graph. Each Fingerprint corresponds to the DepNode at the same index in the nodes vector.",17,N],[12,"edge_list_indices","","For each DepNode, stores the list of edges originating from that DepNode. Encoded as a [start, end) pair indexing into edge_list_data, which holds the actual DepNodeIndices of the target nodes.",17,N],[12,"edge_list_data","","A flattened list of all edge targets in the graph. Edge sources are implicit in edge_list_indices.",17,N],[11,"clone","rustc::dep_graph","",18,[[["self"]],["serializeddepnodeindex"]]],[11,"eq","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"ne","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"hash","","",18,N],[11,"partial_cmp","","",18,[[["self"],["serializeddepnodeindex"]],["option",["ordering"]]]],[11,"lt","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"le","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"gt","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"ge","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"cmp","","",18,[[["self"],["serializeddepnodeindex"]],["ordering"]]],[11,"decode","","",18,[[["__d"]],["result",["serializeddepnodeindex"]]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[11,"new","","",18,[[["usize"]],["self"]]],[11,"index","","",18,[[["self"]],["usize"]]],[11,"steps_between","","",18,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",18,[[["self"]],["self"]]],[11,"replace_zero","","",18,[[["self"]],["self"]]],[11,"add_one","","",18,[[["self"]],["self"]]],[11,"sub_one","","",18,[[["self"]],["self"]]],[11,"add_usize","","",18,[[["self"],["usize"]],["option"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"encode","","",17,[[["self"],["__s"]],["result"]]],[11,"decode","","",17,[[["__d"]],["result",["serializeddepgraph"]]]],[11,"new","","",17,[[],["serializeddepgraph"]]],[11,"edge_targets_from","","",17,N],[0,"label_strs","","Contains variant => str representations for constructing DepNode groups for tests.",N,N],[17,"Null","rustc::dep_graph::label_strs","",N,N],[17,"Krate","","",N,N],[17,"HirBody","","",N,N],[17,"Hir","","",N,N],[17,"CrateMetadata","","",N,N],[17,"RegionScopeTree","","",N,N],[17,"Coherence","","",N,N],[17,"CoherenceInherentImplOverlapCheck","","",N,N],[17,"CoherenceCheckTrait","","",N,N],[17,"PrivacyAccessLevels","","",N,N],[17,"MirConstQualif","","",N,N],[17,"MirBuilt","","",N,N],[17,"MirConst","","",N,N],[17,"MirValidated","","",N,N],[17,"MirOptimized","","",N,N],[17,"MirShim","","",N,N],[17,"BorrowCheckKrate","","",N,N],[17,"BorrowCheck","","",N,N],[17,"MirBorrowCheck","","",N,N],[17,"UnsafetyCheckResult","","",N,N],[17,"UnsafeDeriveOnReprPacked","","",N,N],[17,"Reachability","","",N,N],[17,"MirKeys","","",N,N],[17,"CrateVariances","","",N,N],[17,"AssociatedItems","","",N,N],[17,"TypeOfItem","","",N,N],[17,"GenericsOfItem","","",N,N],[17,"PredicatesOfItem","","",N,N],[17,"ExplicitPredicatesOfItem","","",N,N],[17,"PredicatesDefinedOnItem","","",N,N],[17,"InferredOutlivesOf","","",N,N],[17,"InferredOutlivesCrate","","",N,N],[17,"SuperPredicatesOfItem","","",N,N],[17,"TraitDefOfItem","","",N,N],[17,"AdtDefOfItem","","",N,N],[17,"ImplTraitRef","","",N,N],[17,"ImplPolarity","","",N,N],[17,"FnSignature","","",N,N],[17,"CoerceUnsizedInfo","","",N,N],[17,"ItemVarianceConstraints","","",N,N],[17,"ItemVariances","","",N,N],[17,"IsConstFn","","",N,N],[17,"IsForeignItem","","",N,N],[17,"TypeParamPredicates","","",N,N],[17,"SizedConstraint","","",N,N],[17,"DtorckConstraint","","",N,N],[17,"AdtDestructor","","",N,N],[17,"AssociatedItemDefIds","","",N,N],[17,"InherentImpls","","",N,N],[17,"TypeckBodiesKrate","","",N,N],[17,"TypeckTables","","",N,N],[17,"UsedTraitImports","","",N,N],[17,"HasTypeckTables","","",N,N],[17,"ConstEval","","",N,N],[17,"CheckMatch","","",N,N],[17,"SymbolName","","",N,N],[17,"InstanceSymbolName","","",N,N],[17,"SpecializationGraph","","",N,N],[17,"ObjectSafety","","",N,N],[17,"FulfillObligation","","",N,N],[17,"VtableMethods","","",N,N],[17,"IsCopy","","",N,N],[17,"IsSized","","",N,N],[17,"IsFreeze","","",N,N],[17,"NeedsDrop","","",N,N],[17,"Layout","","",N,N],[17,"TraitImpls","","",N,N],[17,"AllLocalTraitImpls","","",N,N],[17,"TraitSelect","","",N,N],[17,"ParamEnv","","",N,N],[17,"DescribeDef","","",N,N],[17,"DefSpan","","",N,N],[17,"LookupStability","","",N,N],[17,"LookupDeprecationEntry","","",N,N],[17,"ConstIsRvaluePromotableToStatic","","",N,N],[17,"RvaluePromotableMap","","",N,N],[17,"ImplParent","","",N,N],[17,"TraitOfItem","","",N,N],[17,"IsReachableNonGeneric","","",N,N],[17,"IsUnreachableLocalDefinition","","",N,N],[17,"IsMirAvailable","","",N,N],[17,"ItemAttrs","","",N,N],[17,"CodegenFnAttrs","","",N,N],[17,"FnArgNames","","",N,N],[17,"RenderedConst","","",N,N],[17,"DylibDepFormats","","",N,N],[17,"IsPanicRuntime","","",N,N],[17,"IsCompilerBuiltins","","",N,N],[17,"HasGlobalAllocator","","",N,N],[17,"ExternCrate","","",N,N],[17,"LintLevels","","",N,N],[17,"Specializes","","",N,N],[17,"InScopeTraits","","",N,N],[17,"ModuleExports","","",N,N],[17,"IsSanitizerRuntime","","",N,N],[17,"IsProfilerRuntime","","",N,N],[17,"GetPanicStrategy","","",N,N],[17,"IsNoBuiltins","","",N,N],[17,"ImplDefaultness","","",N,N],[17,"CheckItemWellFormed","","",N,N],[17,"CheckTraitItemWellFormed","","",N,N],[17,"CheckImplItemWellFormed","","",N,N],[17,"ReachableNonGenerics","","",N,N],[17,"NativeLibraries","","",N,N],[17,"PluginRegistrarFn","","",N,N],[17,"DeriveRegistrarFn","","",N,N],[17,"CrateDisambiguator","","",N,N],[17,"CrateHash","","",N,N],[17,"OriginalCrateName","","",N,N],[17,"ExtraFileName","","",N,N],[17,"ImplementationsOfTrait","","",N,N],[17,"AllTraitImplementations","","",N,N],[17,"DllimportForeignItems","","",N,N],[17,"IsDllimportForeignItem","","",N,N],[17,"IsStaticallyIncludedForeignItem","","",N,N],[17,"NativeLibraryKind","","",N,N],[17,"LinkArgs","","",N,N],[17,"ResolveLifetimes","","",N,N],[17,"NamedRegion","","",N,N],[17,"IsLateBound","","",N,N],[17,"ObjectLifetimeDefaults","","",N,N],[17,"Visibility","","",N,N],[17,"DepKind","","",N,N],[17,"CrateName","","",N,N],[17,"ItemChildren","","",N,N],[17,"ExternModStmtCnum","","",N,N],[17,"GetLangItems","","",N,N],[17,"DefinedLangItems","","",N,N],[17,"MissingLangItems","","",N,N],[17,"VisibleParentMap","","",N,N],[17,"MissingExternCrateItem","","",N,N],[17,"UsedCrateSource","","",N,N],[17,"PostorderCnums","","",N,N],[17,"EraseRegionsTy","","",N,N],[17,"ConstValueToAllocation","","",N,N],[17,"Freevars","","",N,N],[17,"MaybeUnusedTraitImport","","",N,N],[17,"MaybeUnusedExternCrates","","",N,N],[17,"StabilityIndex","","",N,N],[17,"AllTraits","","",N,N],[17,"AllCrateNums","","",N,N],[17,"ExportedSymbols","","",N,N],[17,"CollectAndPartitionMonoItems","","",N,N],[17,"IsCodegenedItem","","",N,N],[17,"CodegenUnit","","",N,N],[17,"CompileCodegenUnit","","",N,N],[17,"OutputFilenames","","",N,N],[17,"NormalizeProjectionTy","","",N,N],[17,"NormalizeTyAfterErasingRegions","","",N,N],[17,"ImpliedOutlivesBounds","","",N,N],[17,"DropckOutlives","","",N,N],[17,"EvaluateObligation","","",N,N],[17,"TypeOpEq","","",N,N],[17,"TypeOpSubtype","","",N,N],[17,"TypeOpProvePredicate","","",N,N],[17,"TypeOpNormalizeTy","","",N,N],[17,"TypeOpNormalizePredicate","","",N,N],[17,"TypeOpNormalizePolyFnSig","","",N,N],[17,"TypeOpNormalizeFnSig","","",N,N],[17,"SubstituteNormalizeAndTestPredicates","","",N,N],[17,"TargetFeaturesWhitelist","","",N,N],[17,"InstanceDefSizeEstimate","","",N,N],[17,"Features","","",N,N],[17,"ProgramClausesFor","","",N,N],[17,"ProgramClausesForEnv","","",N,N],[17,"WasmImportModuleMap","","",N,N],[17,"ForeignModules","","",N,N],[17,"UpstreamMonomorphizations","","",N,N],[17,"UpstreamMonomorphizationsFor","","",N,N],[8,"DepTrackingMapConfig","rustc::dep_graph","",N,N],[16,"Key","","",27,N],[16,"Value","","",27,N],[10,"to_dep_kind","","",27,[[],["depkind"]]],[8,"DepGraphSafe","","The `DepGraphSafe` trait is used to specify what kinds of values are safe to \"leak\" into a task. The idea is that this should be only be implemented for things like the tcx as well as various id types, which will create reads in the dep-graph whenever the trait loads anything that might depend on the input program.",N,N],[0,"hir","rustc","",N,N],[3,"HirId","rustc::hir","A HirId uniquely identifies a node in the HIR of the current crate. It is composed of the `owner`, which is the DefIndex of the directly enclosing hir::Item, hir::TraitItem, or hir::ImplItem (i.e. the closest \"item-like\"), and the `local_id` which is unique within the given owner.",N,N],[12,"owner","","",33,N],[12,"local_id","","",33,N],[3,"ItemLocalId","","An `ItemLocalId` uniquely identifies something within a given \"item-like\", that is within a hir::Item, hir::TraitItem, or hir::ImplItem. There is no guarantee that the numerical value of a given `ItemLocalId` corresponds to the node's position within the owning item in any way, but there is a guarantee that the `LocalItemId`s within an owner occupy a dense range of integers starting at zero, so a mapping that maps all or most nodes within an \"item-like\" to something else can be implement by a `Vec` instead of a tree or hash map.",N,N],[12,"0","","",34,N],[3,"Label","","",N,N],[12,"ident","","",35,N],[3,"Lifetime","","",N,N],[12,"id","","",36,N],[12,"span","","",36,N],[12,"name","","Either \"'a\", referring to a named lifetime definition, or \"\" (aka keywords::Invalid), for elision placeholders.",36,N],[3,"Path","","A \"Path\" is essentially Rust's notion of a name; for instance: `std::cmp::PartialEq`. It's represented as a sequence of identifiers, along with a bunch of supporting information.",N,N],[12,"span","","",37,N],[12,"def","","The definition that the path resolved to.",37,N],[12,"segments","","The segments in the path: the things separated by `::`.",37,N],[3,"PathSegment","","A segment of a path: an identifier, an optional lifetime, and a set of types.",N,N],[12,"ident","","The identifier portion of this path segment.",38,N],[12,"args","","Type/lifetime parameters attached to this path. They come in two flavors: `Path<A,B,C>` and `Path(A,B) -> C`. Note that this is more than just simple syntactic sugar; the use of parens affects the region binding rules, so we preserve the distinction.",38,N],[12,"infer_types","","Whether to infer remaining type parameters, if any. This only applies to expression and pattern paths, and out of those only the segments with no type parameters to begin with, e.g. `Vec::new` is `<Vec<..>>::new::<..>`.",38,N],[3,"GenericArgs","","",N,N],[12,"args","","The generic arguments for this path segment.",39,N],[12,"bindings","","Bindings (equality constraints) on associated types, if present. E.g., `Foo<A=Bar>`.",39,N],[12,"parenthesized","","Were arguments written in parenthesized form `Fn(T) -> U`? This is required mostly for pretty-printing and diagnostics, but also for changing lifetime elision rules to be \"function-like\".",39,N],[3,"GenericParam","","",N,N],[12,"id","","",40,N],[12,"name","","",40,N],[12,"attrs","","",40,N],[12,"bounds","","",40,N],[12,"span","","",40,N],[12,"pure_wrt_drop","","",40,N],[12,"kind","","",40,N],[3,"GenericParamCount","","",N,N],[12,"lifetimes","","",41,N],[12,"types","","",41,N],[3,"Generics","","Represents lifetimes and type parameters attached to a declaration of a function, enum, trait, etc.",N,N],[12,"params","","",42,N],[12,"where_clause","","",42,N],[12,"span","","",42,N],[3,"WhereClause","","A `where` clause in a definition",N,N],[12,"id","","",43,N],[12,"predicates","","",43,N],[3,"WhereBoundPredicate","","A type bound, eg `for<'c> Foo: Send+Clone+'c`",N,N],[12,"span","","",44,N],[12,"bound_generic_params","","Any generics from a `for` binding",44,N],[12,"bounded_ty","","The type being bounded",44,N],[12,"bounds","","Trait and lifetime bounds (`Clone+Send+'static`)",44,N],[3,"WhereRegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",N,N],[12,"span","","",45,N],[12,"lifetime","","",45,N],[12,"bounds","","",45,N],[3,"WhereEqPredicate","","An equality predicate (unsupported), e.g. `T=int`",N,N],[12,"id","","",46,N],[12,"span","","",46,N],[12,"lhs_ty","","",46,N],[12,"rhs_ty","","",46,N],[3,"Crate","","The top-level data structure that stores the entire contents of the crate currently being compiled.",N,N],[12,"module","","",47,N],[12,"attrs","","",47,N],[12,"span","","",47,N],[12,"exported_macros","","",47,N],[12,"items","","",47,N],[12,"trait_items","","",47,N],[12,"impl_items","","",47,N],[12,"bodies","","",47,N],[12,"trait_impls","","",47,N],[12,"trait_auto_impl","","",47,N],[12,"body_ids","","A list of the body ids written out in the order in which they appear in the crate. If you're going to process all the bodies in the crate, you should iterate over this list rather than the keys of bodies.",47,N],[3,"MacroDef","","A macro definition, in this crate or imported from another.",N,N],[12,"name","","",48,N],[12,"vis","","",48,N],[12,"attrs","","",48,N],[12,"id","","",48,N],[12,"span","","",48,N],[12,"body","","",48,N],[12,"legacy","","",48,N],[3,"Block","","",N,N],[12,"stmts","","Statements in a block",49,N],[12,"expr","","An expression at the end of the block without a semicolon, if any",49,N],[12,"id","","",49,N],[12,"hir_id","","",49,N],[12,"rules","","Distinguishes between `unsafe { ... }` and `{ ... }`",49,N],[12,"span","","",49,N],[12,"targeted_by_break","","If true, then there may exist `break 'a` values that aim to break out of this block early. Used by `'label: {}` blocks and by `catch` statements.",49,N],[12,"recovered","","If true, don't emit return value type errors as the parser had to recover from a parse error so this block will not have an appropriate type. A parse error will have been emitted so the compilation will never succeed if this is true.",49,N],[3,"Pat","","",N,N],[12,"id","","",50,N],[12,"hir_id","","",50,N],[12,"node","","",50,N],[12,"span","","",50,N],[3,"FieldPat","","A single field in a struct pattern",N,N],[12,"id","","",51,N],[12,"ident","","The identifier for the field",51,N],[12,"pat","","The pattern the field is destructured to",51,N],[12,"is_shorthand","","",51,N],[3,"Local","","Local represents a `let` statement, e.g., `let <pat>:<ty> = <expr>;`",N,N],[12,"pat","","",52,N],[12,"ty","","",52,N],[12,"init","","Initializer expression to set the value, if any",52,N],[12,"id","","",52,N],[12,"hir_id","","",52,N],[12,"span","","",52,N],[12,"attrs","","",52,N],[12,"source","","",52,N],[3,"Arm","","represents one arm of a 'match'",N,N],[12,"attrs","","",53,N],[12,"pats","","",53,N],[12,"guard","","",53,N],[12,"body","","",53,N],[3,"Field","","",N,N],[12,"id","","",54,N],[12,"ident","","",54,N],[12,"expr","","",54,N],[12,"span","","",54,N],[12,"is_shorthand","","",54,N],[3,"BodyId","","",N,N],[12,"node_id","","",55,N],[3,"Body","","The body of a function, closure, or constant value. In the case of a function, the body contains not only the function body itself (which is an expression), but also the argument patterns, since those are something that the caller doesn't really care about.",N,N],[12,"arguments","","",56,N],[12,"value","","",56,N],[12,"is_generator","","",56,N],[3,"AnonConst","","A constant (expression) that's not an item or associated item, but needs its own `DefId` for type-checking, const-eval, etc. These are usually found nested inside types (e.g. array lengths) or expressions (e.g. repeat counts), and also used to define explicit discriminant values for enum variants.",N,N],[12,"id","","",57,N],[12,"hir_id","","",57,N],[12,"body","","",57,N],[3,"Expr","","An expression",N,N],[12,"id","","",58,N],[12,"span","","",58,N],[12,"node","","",58,N],[12,"attrs","","",58,N],[12,"hir_id","","",58,N],[3,"Destination","","",N,N],[12,"label","","",59,N],[12,"target_id","","",59,N],[3,"MutTy","","",N,N],[12,"ty","","",60,N],[12,"mutbl","","",60,N],[3,"MethodSig","","Represents a method's signature in a trait declaration or implementation.",N,N],[12,"header","","",61,N],[12,"decl","","",61,N],[3,"TraitItemId","","",N,N],[12,"node_id","","",62,N],[3,"TraitItem","","Represents an item declaration within a trait declaration, possibly including a default implementation. A trait item is either required (meaning it doesn't have an implementation, just a signature) or provided (meaning it has a default implementation).",N,N],[12,"id","","",63,N],[12,"ident","","",63,N],[12,"hir_id","","",63,N],[12,"attrs","","",63,N],[12,"generics","","",63,N],[12,"node","","",63,N],[12,"span","","",63,N],[3,"ImplItemId","","",N,N],[12,"node_id","","",64,N],[3,"ImplItem","","Represents anything within an `impl` block",N,N],[12,"id","","",65,N],[12,"ident","","",65,N],[12,"hir_id","","",65,N],[12,"vis","","",65,N],[12,"defaultness","","",65,N],[12,"attrs","","",65,N],[12,"generics","","",65,N],[12,"node","","",65,N],[12,"span","","",65,N],[3,"TypeBinding","","",N,N],[12,"id","","",66,N],[12,"ident","","",66,N],[12,"ty","","",66,N],[12,"span","","",66,N],[3,"Ty","","",N,N],[12,"id","","",67,N],[12,"node","","",67,N],[12,"span","","",67,N],[12,"hir_id","","",67,N],[3,"BareFnTy","","",N,N],[12,"unsafety","","",68,N],[12,"abi","","",68,N],[12,"generic_params","","",68,N],[12,"decl","","",68,N],[12,"arg_names","","",68,N],[3,"ExistTy","","",N,N],[12,"generics","","",69,N],[12,"bounds","","",69,N],[12,"impl_trait_fn","","",69,N],[3,"InlineAsmOutput","","",N,N],[12,"constraint","","",70,N],[12,"is_rw","","",70,N],[12,"is_indirect","","",70,N],[3,"InlineAsm","","",N,N],[12,"asm","","",71,N],[12,"asm_str_style","","",71,N],[12,"outputs","","",71,N],[12,"inputs","","",71,N],[12,"clobbers","","",71,N],[12,"volatile","","",71,N],[12,"alignstack","","",71,N],[12,"dialect","","",71,N],[12,"ctxt","","",71,N],[3,"Arg","","represents an argument in a function header",N,N],[12,"pat","","",72,N],[12,"id","","",72,N],[12,"hir_id","","",72,N],[3,"FnDecl","","Represents the header (not the body) of a function declaration",N,N],[12,"inputs","","",73,N],[12,"output","","",73,N],[12,"variadic","","",73,N],[12,"has_implicit_self","","True if this function has an `self`, `&self` or `&mut self` receiver (but not a `self: Xxx` one).",73,N],[3,"Mod","","",N,N],[12,"inner","","A span from the first token past `{` to the last token until `}`. For `mod foo;`, the inner span ranges from the first token to the last token in the external file.",74,N],[12,"item_ids","","",74,N],[3,"ForeignMod","","",N,N],[12,"abi","","",75,N],[12,"items","","",75,N],[3,"GlobalAsm","","",N,N],[12,"asm","","",76,N],[12,"ctxt","","",76,N],[3,"EnumDef","","",N,N],[12,"variants","","",77,N],[3,"VariantKind","","",N,N],[12,"name","","",78,N],[12,"attrs","","",78,N],[12,"data","","",78,N],[12,"disr_expr","","Explicit discriminant, eg `Foo = 1`",78,N],[3,"TraitRef","","TraitRef's appear in impls.",N,N],[12,"path","","",79,N],[12,"ref_id","","",79,N],[3,"PolyTraitRef","","",N,N],[12,"bound_generic_params","","The `'a` in `<'a> Foo<&'a T>`",80,N],[12,"trait_ref","","The `Foo<&'a T>` in `<'a> Foo<&'a T>`",80,N],[12,"span","","",80,N],[3,"StructField","","",N,N],[12,"span","","",81,N],[12,"ident","","",81,N],[12,"vis","","",81,N],[12,"id","","",81,N],[12,"ty","","",81,N],[12,"attrs","","",81,N],[3,"ItemId","","",N,N],[12,"id","","",82,N],[3,"Item","","An item",N,N],[12,"name","","",83,N],[12,"id","","",83,N],[12,"hir_id","","",83,N],[12,"attrs","","",83,N],[12,"node","","",83,N],[12,"vis","","",83,N],[12,"span","","",83,N],[3,"FnHeader","","",N,N],[12,"unsafety","","",84,N],[12,"constness","","",84,N],[12,"asyncness","","",84,N],[12,"abi","","",84,N],[3,"TraitItemRef","","A reference from an trait to one of its associated items. This contains the item's id, naturally, but also the item's name and some other high-level details (like whether it is an associated type or method, and whether it is public). This allows other passes to find the impl they want without loading the id (which means fewer edges in the incremental compilation graph).",N,N],[12,"id","","",85,N],[12,"ident","","",85,N],[12,"kind","","",85,N],[12,"span","","",85,N],[12,"defaultness","","",85,N],[3,"ImplItemRef","","A reference from an impl to one of its associated items. This contains the item's id, naturally, but also the item's name and some other high-level details (like whether it is an associated type or method, and whether it is public). This allows other passes to find the impl they want without loading the id (which means fewer edges in the incremental compilation graph).",N,N],[12,"id","","",86,N],[12,"ident","","",86,N],[12,"kind","","",86,N],[12,"span","","",86,N],[12,"vis","","",86,N],[12,"defaultness","","",86,N],[3,"ForeignItem","","",N,N],[12,"name","","",87,N],[12,"attrs","","",87,N],[12,"node","","",87,N],[12,"id","","",87,N],[12,"span","","",87,N],[12,"vis","","",87,N],[3,"Freevar","","A free variable referred to in a function.",N,N],[12,"def","","The variable being accessed free.",88,N],[12,"span","","",88,N],[3,"TraitCandidate","","",N,N],[12,"def_id","","",89,N],[12,"import_id","","",89,N],[3,"CodegenFnAttrs","","",N,N],[12,"flags","","",90,N],[12,"inline","","",90,N],[12,"export_name","","",90,N],[12,"target_features","","",90,N],[12,"linkage","","",90,N],[12,"link_section","","",90,N],[3,"CodegenFnAttrFlags","","",N,N],[12,"bits","","",91,N],[4,"ParamName","","",N,N],[13,"Plain","","Some user-given name like `T` or `'x`.",92,N],[13,"Fresh","","Synthetic name generated when user elided a lifetime in an impl header, e.g. the lifetimes in cases like these:",92,N],[4,"LifetimeName","","",N,N],[13,"Param","","User-given names or fresh (synthetic) names.",93,N],[13,"Implicit","","User typed nothing. e.g. the lifetime in `&u32`.",93,N],[13,"Underscore","","User typed `'_`.",93,N],[13,"Static","","User wrote `'static`",93,N],[4,"GenericArg","","",N,N],[13,"Lifetime","","",94,N],[13,"Type","","",94,N],[4,"TraitBoundModifier","","A modifier on a bound, currently this is only used for `?Sized`, where the modifier is `Maybe`. Negative bounds should also be handled here.",N,N],[13,"None","","",95,N],[13,"Maybe","","",95,N],[4,"GenericBound","","The AST represents all type param bounds as types. typeck::collect::compute_bounds matches these against the \"special\" built-in traits (see middle::lang_items) and detects Copy, Send and Sync.",N,N],[13,"Trait","","",96,N],[13,"Outlives","","",96,N],[4,"GenericParamKind","","",N,N],[13,"Lifetime","","A lifetime definition, eg `'a: 'b + 'c + 'd`.",97,N],[12,"in_band","rustc::hir::GenericParamKind","",97,N],[13,"Type","rustc::hir","",97,N],[12,"default","rustc::hir::GenericParamKind","",97,N],[12,"synthetic","","",97,N],[4,"SyntheticTyParamKind","rustc::hir","Synthetic Type Parameters are converted to an other form during lowering, this allows to track the original form they had. Useful for error messages.",N,N],[13,"ImplTrait","","",98,N],[4,"WherePredicate","","A single predicate in a `where` clause",N,N],[13,"BoundPredicate","","A type binding, eg `for<'c> Foo: Send+Clone+'c`",99,N],[13,"RegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",99,N],[13,"EqPredicate","","An equality predicate (unsupported)",99,N],[4,"BindingAnnotation","","Explicit binding annotations given in the HIR for a binding. Note that this is not the final binding mode that we infer after type inference.",N,N],[13,"Unannotated","","No binding annotation given: this means that the final binding mode will depend on whether we have skipped through a `&` reference when matching. For example, the `x` in `Some(x)` will have binding mode `None`; if you do `let Some(x) = &Some(22)`, it will ultimately be inferred to be by-reference.",100,N],[13,"Mutable","","Annotated with `mut x` -- could be either ref or not, similar to `None`.",100,N],[13,"Ref","","Annotated as `ref`, like `ref x`",100,N],[13,"RefMut","","Annotated as `ref mut x`.",100,N],[4,"RangeEnd","","",N,N],[13,"Included","","",101,N],[13,"Excluded","","",101,N],[4,"PatKind","","",N,N],[13,"Wild","","Represents a wildcard pattern (`_`)",102,N],[13,"Binding","","A fresh binding `ref mut binding @ OPT_SUBPATTERN`. The `NodeId` is the canonical ID for the variable being bound, e.g. in `Ok(x) | Err(x)`, both `x` use the same canonical ID, which is the pattern ID of the first `x`.",102,N],[13,"Struct","","A struct or struct variant pattern, e.g. `Variant {x, y, ..}`. The `bool` is `true` in the presence of a `..`.",102,N],[13,"TupleStruct","","A tuple struct/variant pattern `Variant(x, y, .., z)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",102,N],[13,"Path","","A path pattern for an unit struct/variant or a (maybe-associated) constant.",102,N],[13,"Tuple","","A tuple pattern `(a, b)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",102,N],[13,"Box","","A `box` pattern",102,N],[13,"Ref","","A reference pattern, e.g. `&mut (a, b)`",102,N],[13,"Lit","","A literal",102,N],[13,"Range","","A range pattern, e.g. `1...2` or `1..2`",102,N],[13,"Slice","","`[a, b, ..i, y, z]` is represented as: `PatKind::Slice(box [a, b], Some(i), box [y, z])`",102,N],[4,"Mutability","","",N,N],[13,"MutMutable","","",103,N],[13,"MutImmutable","","",103,N],[4,"BinOpKind","","",N,N],[13,"Add","","The `+` operator (addition)",104,N],[13,"Sub","","The `-` operator (subtraction)",104,N],[13,"Mul","","The `*` operator (multiplication)",104,N],[13,"Div","","The `/` operator (division)",104,N],[13,"Rem","","The `%` operator (modulus)",104,N],[13,"And","","The `&&` operator (logical and)",104,N],[13,"Or","","The `||` operator (logical or)",104,N],[13,"BitXor","","The `^` operator (bitwise xor)",104,N],[13,"BitAnd","","The `&` operator (bitwise and)",104,N],[13,"BitOr","","The `|` operator (bitwise or)",104,N],[13,"Shl","","The `<<` operator (shift left)",104,N],[13,"Shr","","The `>>` operator (shift right)",104,N],[13,"Eq","","The `==` operator (equality)",104,N],[13,"Lt","","The `<` operator (less than)",104,N],[13,"Le","","The `<=` operator (less than or equal to)",104,N],[13,"Ne","","The `!=` operator (not equal to)",104,N],[13,"Ge","","The `>=` operator (greater than or equal to)",104,N],[13,"Gt","","The `>` operator (greater than)",104,N],[4,"UnOp","","",N,N],[13,"UnDeref","","The `*` operator for dereferencing",105,N],[13,"UnNot","","The `!` operator for logical inversion",105,N],[13,"UnNeg","","The `-` operator for negation",105,N],[4,"StmtKind","","",N,N],[13,"Decl","","Could be an item or a local (let) binding:",106,N],[13,"Expr","","Expr without trailing semi-colon (must have unit type):",106,N],[13,"Semi","","Expr with trailing semi-colon (may have any type):",106,N],[4,"DeclKind","","",N,N],[13,"Local","","A local (let) binding:",107,N],[13,"Item","","An item binding:",107,N],[4,"BlockCheckMode","","",N,N],[13,"DefaultBlock","","",108,N],[13,"UnsafeBlock","","",108,N],[13,"PushUnsafeBlock","","",108,N],[13,"PopUnsafeBlock","","",108,N],[4,"UnsafeSource","","",N,N],[13,"CompilerGenerated","","",109,N],[13,"UserProvided","","",109,N],[4,"BodyOwnerKind","","",N,N],[13,"Fn","","Functions and methods.",110,N],[13,"Const","","Constants and associated constants.",110,N],[13,"Static","","Initializer of a `static` item.",110,N],[4,"ExprKind","","",N,N],[13,"Box","","A `box x` expression.",111,N],[13,"Array","","An array (`[a, b, c, d]`)",111,N],[13,"Call","","A function call",111,N],[13,"MethodCall","","A method call (`x.foo::<'static, Bar, Baz>(a, b, c, d)`)",111,N],[13,"Tup","","A tuple (`(a, b, c ,d)`)",111,N],[13,"Binary","","A binary operation (For example: `a + b`, `a * b`)",111,N],[13,"Unary","","A unary operation (For example: `!x`, `*x`)",111,N],[13,"Lit","","A literal (For example: `1`, `\"foo\"`)",111,N],[13,"Cast","","A cast (`foo as f64`)",111,N],[13,"Type","","",111,N],[13,"If","","An `if` block, with an optional else block",111,N],[13,"While","","A while loop, with an optional label",111,N],[13,"Loop","","Conditionless loop (can be exited with break, continue, or return)",111,N],[13,"Match","","A `match` block, with a source that indicates whether or not it is the result of a desugaring, and if so, which kind.",111,N],[13,"Closure","","A closure (for example, `move |a, b, c| {a + b + c}`).",111,N],[13,"Block","","A block (`'label: { ... }`)",111,N],[13,"Assign","","An assignment (`a = foo()`)",111,N],[13,"AssignOp","","An assignment with an operator",111,N],[13,"Field","","Access of a named (`obj.foo`) or unnamed (`obj.0`) struct or tuple field",111,N],[13,"Index","","An indexing operation (`foo[2]`)",111,N],[13,"Path","","Path to a definition, possibly containing lifetime or type parameters.",111,N],[13,"AddrOf","","A referencing operation (`&a` or `&mut a`)",111,N],[13,"Break","","A `break`, with an optional label to break",111,N],[13,"Continue","","A `continue`, with an optional label",111,N],[13,"Ret","","A `return`, with an optional value to be returned",111,N],[13,"InlineAsm","","Inline assembly (from `asm!`), with its outputs and inputs.",111,N],[13,"Struct","","A struct or struct-like variant literal expression.",111,N],[13,"Repeat","","An array literal constructed from one repeated element.",111,N],[13,"Yield","","A suspension point for generators. This is `yield <expr>` in Rust.",111,N],[4,"QPath","","Optionally `Self`-qualified value/type path or associated extension.",N,N],[13,"Resolved","","Path to a definition, optionally \"fully-qualified\" with a `Self` type, if the path points to an associated item in a trait.",112,N],[13,"TypeRelative","","Type-related paths, e.g. `<T>::default` or `<T>::Output`. Will be resolved by type-checking to an associated item.",112,N],[4,"LocalSource","","Hints at the original code for a let statement",N,N],[13,"Normal","","A `match _ { .. }`",113,N],[13,"ForLoopDesugar","","A desugared `for _ in _ { .. }` loop",113,N],[4,"MatchSource","","Hints at the original code for a `match _ { .. }`",N,N],[13,"Normal","","A `match _ { .. }`",114,N],[13,"IfLetDesugar","","An `if let _ = _ { .. }` (optionally with `else { .. }`)",114,N],[12,"contains_else_clause","rustc::hir::MatchSource","",114,N],[13,"WhileLetDesugar","rustc::hir","A `while let _ = _ { .. }` (which was desugared to a `loop { match _ { .. } }`)",114,N],[13,"ForLoopDesugar","","A desugared `for _ in _ { .. }` loop",114,N],[13,"TryDesugar","","A desugared `?` operator",114,N],[4,"LoopSource","","The loop type that yielded an ExprKind::Loop",N,N],[13,"Loop","","A `loop { .. }` loop",115,N],[13,"WhileLet","","A `while let _ = _ { .. }` loop",115,N],[13,"ForLoop","","A `for _ in _ { .. }` loop",115,N],[4,"LoopIdError","","",N,N],[13,"OutsideLoopScope","","",116,N],[13,"UnlabeledCfInWhileCondition","","",116,N],[13,"UnresolvedLabel","","",116,N],[4,"GeneratorMovability","","",N,N],[13,"Static","","",117,N],[13,"Movable","","",117,N],[4,"CaptureClause","","",N,N],[13,"CaptureByValue","","",118,N],[13,"CaptureByRef","","",118,N],[4,"TraitMethod","","A trait method's body (or just argument names).",N,N],[13,"Required","","No default body in the trait, just a signature.",119,N],[13,"Provided","","Both signature and body are provided in the trait.",119,N],[4,"TraitItemKind","","Represents a trait method or associated constant or type",N,N],[13,"Const","","An associated constant with an optional value (otherwise `impl`s must contain a value)",120,N],[13,"Method","","A method with an optional body",120,N],[13,"Type","","An associated type with (possibly empty) bounds and optional concrete type",120,N],[4,"ImplItemKind","","Represents different contents within `impl`s",N,N],[13,"Const","","An associated constant of the given type, set to the constant result of the expression",121,N],[13,"Method","","A method implementation with the given signature and body",121,N],[13,"Type","","An associated type",121,N],[13,"Existential","","An associated existential type",121,N],[4,"PrimTy","","Not represented directly in the AST, referred to by name through a ty_path.",N,N],[13,"TyInt","","",122,N],[13,"TyUint","","",122,N],[13,"TyFloat","","",122,N],[13,"TyStr","","",122,N],[13,"TyBool","","",122,N],[13,"TyChar","","",122,N],[4,"TyKind","","The different kinds of types recognized by the compiler",N,N],[13,"Slice","","A variable length slice (`[T]`)",123,N],[13,"Array","","A fixed length array (`[T; n]`)",123,N],[13,"Ptr","","A raw pointer (`*const T` or `*mut T`)",123,N],[13,"Rptr","","A reference (`&'a T` or `&'a mut T`)",123,N],[13,"BareFn","","A bare function (e.g. `fn(usize) -> bool`)",123,N],[13,"Never","","The never type (`!`)",123,N],[13,"Tup","","A tuple (`(A, B, C, D,...)`)",123,N],[13,"Path","","A path to a type definition (`module::module::...::Type`), or an associated type, e.g. `<Vec<T> as Trait>::Type` or `<T>::Target`.",123,N],[13,"TraitObject","","A trait object type `Bound1 + Bound2 + Bound3` where `Bound` is a trait or a lifetime.",123,N],[13,"Typeof","","Unused for now",123,N],[13,"Infer","","TyKind::Infer means the type should be inferred instead of it having been specified. This can appear anywhere in a type.",123,N],[13,"Err","","Placeholder for a type that has failed to be defined.",123,N],[4,"IsAuto","","Is the trait definition an auto trait?",N,N],[13,"Yes","","",124,N],[13,"No","","",124,N],[4,"IsAsync","","",N,N],[13,"Async","","",125,N],[13,"NotAsync","","",125,N],[4,"Unsafety","","",N,N],[13,"Unsafe","","",126,N],[13,"Normal","","",126,N],[4,"Constness","","",N,N],[13,"Const","","",127,N],[13,"NotConst","","",127,N],[4,"Defaultness","","",N,N],[13,"Default","","",128,N],[12,"has_value","rustc::hir::Defaultness","",128,N],[13,"Final","rustc::hir","",128,N],[4,"ImplPolarity","","",N,N],[13,"Positive","","`impl Trait for Type`",129,N],[13,"Negative","","`impl !Trait for Type`",129,N],[4,"FunctionRetTy","","",N,N],[13,"DefaultReturn","","Return type is not specified.",130,N],[13,"Return","","Everything else",130,N],[4,"UseKind","","",N,N],[13,"Single","","One import, e.g. `use foo::bar` or `use foo::bar as baz`. Also produced for each element of a list `use`, e.g.",131,N],[13,"Glob","","Glob import, e.g. `use foo::*`.",131,N],[13,"ListStem","","Degenerate list import, e.g. `use foo::{a, b}` produces an additional `use foo::{}` for performing checks such as unstable feature gating. May be removed in the future.",131,N],[4,"VisibilityKind","","",N,N],[13,"Public","","",132,N],[13,"Crate","","",132,N],[13,"Restricted","","",132,N],[12,"path","rustc::hir::VisibilityKind","",132,N],[12,"id","","",132,N],[13,"Inherited","rustc::hir","",132,N],[4,"VariantData","","Fields and Ids of enum variants and structs",N,N],[13,"Struct","","",133,N],[13,"Tuple","","",133,N],[13,"Unit","","",133,N],[4,"ItemKind","","",N,N],[13,"ExternCrate","","An `extern crate` item, with optional original crate name if the crate was renamed.",134,N],[13,"Use","","`use foo::bar::*;` or `use foo::bar::baz as quux;`",134,N],[13,"Static","","A `static` item",134,N],[13,"Const","","A `const` item",134,N],[13,"Fn","","A function declaration",134,N],[13,"Mod","","A module",134,N],[13,"ForeignMod","","An external module",134,N],[13,"GlobalAsm","","Module-level inline assembly (from global_asm!)",134,N],[13,"Ty","","A type alias, e.g. `type Foo = Bar<u8>`",134,N],[13,"Existential","","An existential type definition, e.g. `existential type Foo: Bar;`",134,N],[13,"Enum","","An enum definition, e.g. `enum Foo<A, B> {C<A>, D<B>}`",134,N],[13,"Struct","","A struct definition, e.g. `struct Foo<A> {x: A}`",134,N],[13,"Union","","A union definition, e.g. `union Foo<A, B> {x: A, y: B}`",134,N],[13,"Trait","","Represents a Trait Declaration",134,N],[13,"TraitAlias","","Represents a Trait Alias Declaration",134,N],[13,"Impl","","An implementation, eg `impl<A> Trait for Foo { .. }`",134,N],[4,"AssociatedItemKind","","",N,N],[13,"Const","","",135,N],[13,"Method","","",135,N],[12,"has_self","rustc::hir::AssociatedItemKind","",135,N],[13,"Type","rustc::hir","",135,N],[13,"Existential","","",135,N],[4,"ForeignItemKind","","An item within an `extern` block",N,N],[13,"Fn","","A foreign function",136,N],[13,"Static","","A foreign static item (`static ext: u8`), with optional mutability (the boolean is true when mutable)",136,N],[13,"Type","","A foreign type",136,N],[5,"provide","","",N,[[["providers"]]]],[0,"check_attr","","This module implements some validity checks for attributes. In particular it verifies that `#[inline]` and `#[repr]` attributes are attached to items that actually support them and if there are conflicts between multiple such attributes attached to the same item.",N,N],[3,"CheckAttrVisitor","rustc::hir::check_attr","",N,N],[12,"tcx","","",137,N],[4,"Target","","",N,N],[13,"Fn","","",138,N],[13,"Struct","","",138,N],[13,"Union","","",138,N],[13,"Enum","","",138,N],[13,"Const","","",138,N],[13,"ForeignMod","","",138,N],[13,"Expression","","",138,N],[13,"Statement","","",138,N],[13,"Closure","","",138,N],[13,"Static","","",138,N],[13,"Other","","",138,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"is_c_like_enum","","",N,[[["item"]],["bool"]]],[11,"clone","","",138,[[["self"]],["target"]]],[11,"eq","","",138,[[["self"],["target"]],["bool"]]],[11,"from_item","","",138,[[["item"]],["target"]]],[11,"check_attributes","","Check any attribute.",137,[[["self"],["item"],["target"]]]],[11,"check_inline","","Check if an `#[inline]` is applied to a function or a closure.",137,[[["self"],["attribute"],["span"],["target"]]]],[11,"check_non_exhaustive","","Check if the `#[non_exhaustive]` attribute on an `item` is valid.",137,[[["self"],["attribute"],["item"],["target"]]]],[11,"check_repr","","Check if the `#[repr]` attributes on `item` are valid.",137,[[["self"],["item"],["target"]]]],[11,"emit_repr_error","","",137,[[["self"],["span"],["span"],["str"],["str"]]]],[11,"check_stmt_attributes","","",137,[[["self"],["stmt"]]]],[11,"check_expr_attributes","","",137,[[["self"],["expr"]]]],[11,"check_used","","",137,[[["self"],["item"],["target"]]]],[11,"nested_visit_map","","",137,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",137,[[["self"],["item"]]]],[11,"visit_stmt","","",137,[[["self"],["stmt"]]]],[11,"visit_expr","","",137,[[["self"],["expr"]]]],[0,"def","rustc::hir","",N,N],[3,"PathResolution","rustc::hir::def","The result of resolving a path before lowering to HIR. `base_def` is definition of resolved part of the path, `unresolved_segments` is the number of unresolved segments.",N,N],[12,"base_def","","",139,N],[12,"unresolved_segments","","",139,N],[3,"PerNS","","Just a helper ‒ separate structure for each namespace.",N,N],[12,"value_ns","","",140,N],[12,"type_ns","","",140,N],[12,"macro_ns","","",140,N],[3,"Export","","",N,N],[12,"ident","","The name of the target.",141,N],[12,"def","","The definition of the target.",141,N],[12,"span","","The span of the target definition.",141,N],[12,"vis","","The visibility of the export. We include non-`pub` exports for hygienic macros that get used from extern crates.",141,N],[4,"CtorKind","","",N,N],[13,"Fn","","Constructor function automatically created by a tuple struct/variant.",142,N],[13,"Const","","Constructor constant automatically created by a unit struct/variant.",142,N],[13,"Fictive","","Unusable name in value namespace created by a struct variant.",142,N],[4,"Def","","",N,N],[13,"Mod","","",143,N],[13,"Struct","","",143,N],[13,"Union","","",143,N],[13,"Enum","","",143,N],[13,"Variant","","",143,N],[13,"Trait","","",143,N],[13,"Existential","","`existential type Foo: Bar;`",143,N],[13,"TyAlias","","`type Foo = Bar;`",143,N],[13,"TyForeign","","",143,N],[13,"TraitAlias","","",143,N],[13,"AssociatedTy","","",143,N],[13,"AssociatedExistential","","`existential type Foo: Bar;`",143,N],[13,"PrimTy","","",143,N],[13,"TyParam","","",143,N],[13,"SelfTy","","",143,N],[13,"Fn","","",143,N],[13,"Const","","",143,N],[13,"Static","","",143,N],[13,"StructCtor","","",143,N],[13,"VariantCtor","","",143,N],[13,"Method","","",143,N],[13,"AssociatedConst","","",143,N],[13,"Local","","",143,N],[13,"Upvar","","",143,N],[13,"Label","","",143,N],[13,"Macro","","",143,N],[13,"GlobalAsm","","",143,N],[13,"Err","","",143,N],[4,"Namespace","","Different kinds of symbols don't influence each other.",N,N],[13,"TypeNS","","",144,N],[13,"ValueNS","","",144,N],[13,"MacroNS","","",144,N],[6,"DefMap","","Definition mapping",N,N],[6,"ExportMap","","This is the replacement export map. It maps a module to all of the exports within.",N,N],[6,"ImportMap","","Map used to track the `use` statements within a scope, matching it with all the items in every namespace.",N,N],[22,"","","",N,N],[11,"clone","","",142,[[["self"]],["ctorkind"]]],[11,"eq","","",142,[[["self"],["ctorkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",142,N],[11,"encode","","",142,[[["self"],["__s"]],["result"]]],[11,"decode","","",142,[[["__d"]],["result",["ctorkind"]]]],[11,"hash","","",142,N],[11,"fmt","","",142,[[["self"],["formatter"]],["result"]]],[11,"clone","","",143,[[["self"]],["def"]]],[11,"eq","","",143,[[["self"],["def"]],["bool"]]],[11,"ne","","",143,[[["self"],["def"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",143,N],[11,"encode","","",143,[[["self"],["__s"]],["result"]]],[11,"decode","","",143,[[["__d"]],["result",["def"]]]],[11,"hash","","",143,N],[11,"fmt","","",143,[[["self"],["formatter"]],["result"]]],[11,"clone","","",139,[[["self"]],["pathresolution"]]],[11,"fmt","","",139,[[["self"],["formatter"]],["result"]]],[11,"new","","",139,[[["def"]],["self"]]],[11,"with_unresolved_segments","","",139,[[["def"],["usize"]],["self"]]],[11,"base_def","","",139,[[["self"]],["def"]]],[11,"unresolved_segments","","",139,[[["self"]],["usize"]]],[11,"kind_name","","",139,[[["self"]],["str"]]],[11,"clone","","",144,[[["self"]],["namespace"]]],[11,"eq","","",144,[[["self"],["namespace"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",144,N],[11,"partial_cmp","","",144,[[["self"],["namespace"]],["option",["ordering"]]]],[11,"cmp","","",144,[[["self"],["namespace"]],["ordering"]]],[11,"hash","","",144,N],[11,"fmt","","",144,[[["self"],["formatter"]],["result"]]],[11,"descr","","",144,[[["self"]],["str"]]],[11,"clone","","",140,[[["self"]],["perns"]]],[11,"default","","",140,[[],["perns"]]],[11,"fmt","","",140,[[["self"],["formatter"]],["result"]]],[11,"map","","",140,[[["self"],["f"]],["perns"]]],[11,"index","","",140,[[["self"],["namespace"]],["t"]]],[11,"index_mut","","",140,[[["self"],["namespace"]],["t"]]],[11,"is_empty","","Returns whether all the items in this collection are `None`.",140,[[["self"]],["bool"]]],[11,"present_items","","Returns an iterator over the items which are `Some`.",140,[[["self"]],[""]]],[11,"clone","","",141,[[["self"]],["export"]]],[11,"fmt","","",141,[[["self"],["formatter"]],["result"]]],[11,"encode","","",141,[[["self"],["__s"]],["result"]]],[11,"decode","","",141,[[["__d"]],["result",["export"]]]],[11,"from_ast","","",142,[[["variantdata"]],["ctorkind"]]],[11,"from_hir","","",142,[[["variantdata"]],["ctorkind"]]],[11,"def_id","","",143,[[["self"]],["defid"]]],[11,"kind_name","","A human readable kind name",143,[[["self"]],["str"]]],[0,"def_id","rustc::hir","",N,N],[3,"CrateNum","rustc::hir::def_id","",N,N],[12,"0","","",145,N],[3,"DefIndex","","A DefIndex is an index into the hir-map for a crate, identifying a particular definition. It should really be considered an interned shorthand for a particular DefPath.",N,N],[12,"0","","",146,N],[3,"DefId","","A DefId identifies a particular definition, by combining a crate index and a def index.",N,N],[12,"krate","","",147,N],[12,"index","","",147,N],[3,"LocalDefId","","A LocalDefId is equivalent to a DefId with `krate == LOCAL_CRATE`. Since we encode this information in the type, we can ensure at compile time that no DefIds from upstream crates get thrown into the mix. There are quite a few cases where we know that only DefIds from the local crate are expected and a DefId from a different crate would signify a bug somewhere. This is when LocalDefId comes in handy.",N,N],[12,"0","","",148,N],[4,"DefIndexAddressSpace","","",N,N],[13,"Low","","",149,N],[13,"High","","",149,N],[17,"LOCAL_CRATE","","Item definitions in the currently-compiled crate would have the CrateNum LOCAL_CRATE in their DefId.",N,N],[17,"BUILTIN_MACROS_CRATE","","Virtual crate for builtin macros",N,N],[17,"INVALID_CRATE","","A CrateNum value that indicates that something is wrong.",N,N],[17,"RESERVED_FOR_INCR_COMP_CACHE","","A special CrateNum that we use for the tcx.rcache when decoding from the incr. comp. cache.",N,N],[17,"CRATE_DEF_INDEX","","The crate root is always assigned index 0 by the AST Map code, thanks to `NodeCollector::new`.",N,N],[11,"clone","","",145,[[["self"]],["cratenum"]]],[11,"eq","","",145,[[["self"],["cratenum"]],["bool"]]],[11,"ne","","",145,[[["self"],["cratenum"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",145,N],[11,"hash","","",145,N],[11,"partial_cmp","","",145,[[["self"],["cratenum"]],["option",["ordering"]]]],[11,"lt","","",145,[[["self"],["cratenum"]],["bool"]]],[11,"le","","",145,[[["self"],["cratenum"]],["bool"]]],[11,"gt","","",145,[[["self"],["cratenum"]],["bool"]]],[11,"ge","","",145,[[["self"],["cratenum"]],["bool"]]],[11,"cmp","","",145,[[["self"],["cratenum"]],["ordering"]]],[11,"new","","",145,[[["usize"]],["self"]]],[11,"index","","",145,[[["self"]],["usize"]]],[11,"steps_between","","",145,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",145,[[["self"]],["self"]]],[11,"replace_zero","","",145,[[["self"]],["self"]]],[11,"add_one","","",145,[[["self"]],["self"]]],[11,"sub_one","","",145,[[["self"]],["self"]]],[11,"add_usize","","",145,[[["self"],["usize"]],["option"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"new","","",145,[[["usize"]],["cratenum"]]],[11,"from_u32","","",145,[[["u32"]],["cratenum"]]],[11,"as_usize","","",145,[[["self"]],["usize"]]],[11,"as_u32","","",145,[[["self"]],["u32"]]],[11,"as_def_id","","",145,[[["self"]],["defid"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"clone","","",146,[[["self"]],["defindex"]]],[11,"eq","","",146,[[["self"],["defindex"]],["bool"]]],[11,"ne","","",146,[[["self"],["defindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",146,N],[11,"partial_cmp","","",146,[[["self"],["defindex"]],["option",["ordering"]]]],[11,"lt","","",146,[[["self"],["defindex"]],["bool"]]],[11,"le","","",146,[[["self"],["defindex"]],["bool"]]],[11,"gt","","",146,[[["self"],["defindex"]],["bool"]]],[11,"ge","","",146,[[["self"],["defindex"]],["bool"]]],[11,"cmp","","",146,[[["self"],["defindex"]],["ordering"]]],[11,"hash","","",146,N],[11,"fmt","","",146,[[["self"],["formatter"]],["result"]]],[11,"address_space","","",146,[[["self"]],["defindexaddressspace"]]],[11,"as_array_index","","Converts this DefIndex into a zero-based array index. This index is the offset within the given DefIndexAddressSpace.",146,[[["self"]],["usize"]]],[11,"from_array_index","","",146,[[["usize"],["defindexaddressspace"]],["defindex"]]],[11,"from_proc_macro_index","","",146,[[["usize"]],["defindex"]]],[11,"to_proc_macro_index","","",146,[[["defindex"]],["usize"]]],[11,"from_raw_u32","","",146,[[["u32"]],["defindex"]]],[11,"as_raw_u32","","",146,[[["self"]],["u32"]]],[11,"clone","","",149,[[["self"]],["defindexaddressspace"]]],[11,"hash","","",149,N],[11,"index","","",149,[[["self"]],["usize"]]],[11,"clone","","",147,[[["self"]],["defid"]]],[11,"eq","","",147,[[["self"],["defid"]],["bool"]]],[11,"ne","","",147,[[["self"],["defid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",147,N],[11,"partial_cmp","","",147,[[["self"],["defid"]],["option",["ordering"]]]],[11,"lt","","",147,[[["self"],["defid"]],["bool"]]],[11,"le","","",147,[[["self"],["defid"]],["bool"]]],[11,"gt","","",147,[[["self"],["defid"]],["bool"]]],[11,"ge","","",147,[[["self"],["defid"]],["bool"]]],[11,"cmp","","",147,[[["self"],["defid"]],["ordering"]]],[11,"hash","","",147,N],[11,"fmt","","",147,[[["self"],["formatter"]],["result"]]],[11,"local","","Make a local `DefId` with the given index.",147,[[["defindex"]],["defid"]]],[11,"is_local","","",147,[[["self"]],["bool"]]],[11,"to_local","","",147,[[["self"]],["localdefid"]]],[11,"clone","","",148,[[["self"]],["localdefid"]]],[11,"eq","","",148,[[["self"],["localdefid"]],["bool"]]],[11,"ne","","",148,[[["self"],["localdefid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",148,N],[11,"hash","","",148,N],[11,"from_def_id","","",148,[[["defid"]],["localdefid"]]],[11,"to_def_id","","",148,[[["self"]],["defid"]]],[11,"fmt","","",148,[[["self"],["formatter"]],["result"]]],[0,"intravisit","rustc::hir","HIR walker for walking the contents of nodes.",N,N],[3,"IdRange","rustc::hir::intravisit","",N,N],[12,"min","","",150,N],[12,"max","","",150,N],[3,"IdRangeComputingVisitor","","",N,N],[12,"result","","",151,N],[12,"map","","",151,N],[4,"FnKind","","",N,N],[13,"ItemFn","","#[xxx] pub async/const/extern \"Abi\" fn foo()",152,N],[13,"Method","","fn foo(&self)",152,N],[13,"Closure","","|x, y| {}",152,N],[4,"NestedVisitorMap","","Specifies what nested things a visitor wants to visit. The most common choice is `OnlyBodies`, which will cause the visitor to visit fn bodies for fns that it encounters, but skip over nested item-like things.",N,N],[13,"None","","Do not visit any nested things. When you add a new \"non-nested\" thing, you will want to audit such uses to see if they remain valid.",153,N],[13,"OnlyBodies","","Do not visit nested item-like things, but visit nested things that are inside of an item-like.",153,N],[13,"All","","Visit all nested things, including item-likes.",153,N],[5,"walk_crate","","Walks the contents of a crate. See also `Crate::visit_all_items`.",N,[[["v"],["crate"]]]],[5,"walk_macro_def","","",N,[[["v"],["macrodef"]]]],[5,"walk_mod","","",N,[[["v"],["mod"],["nodeid"]]]],[5,"walk_body","","",N,[[["v"],["body"]]]],[5,"walk_local","","",N,[[["v"],["local"]]]],[5,"walk_ident","","",N,[[["v"],["ident"]]]],[5,"walk_label","","",N,[[["v"],["label"]]]],[5,"walk_lifetime","","",N,[[["v"],["lifetime"]]]],[5,"walk_poly_trait_ref","","",N,[[["v"],["polytraitref"],["traitboundmodifier"]]]],[5,"walk_trait_ref","","",N,[[["v"],["traitref"]]]],[5,"walk_item","","",N,[[["v"],["item"]]]],[5,"walk_enum_def","","",N,[[["v"],["enumdef"],["generics"],["nodeid"]]]],[5,"walk_variant","","",N,[[["v"],["variant"],["generics"],["nodeid"]]]],[5,"walk_ty","","",N,[[["v"],["ty"]]]],[5,"walk_qpath","","",N,[[["v"],["qpath"],["nodeid"],["span"]]]],[5,"walk_path","","",N,[[["v"],["path"]]]],[5,"walk_path_segment","","",N,[[["v"],["span"],["pathsegment"]]]],[5,"walk_generic_args","","",N,[[["v"],["span"],["genericargs"]]]],[5,"walk_assoc_type_binding","","",N,[[["v"],["typebinding"]]]],[5,"walk_pat","","",N,[[["v"],["pat"]]]],[5,"walk_foreign_item","","",N,[[["v"],["foreignitem"]]]],[5,"walk_param_bound","","",N,[[["v"],["genericbound"]]]],[5,"walk_generic_param","","",N,[[["v"],["genericparam"]]]],[5,"walk_generics","","",N,[[["v"],["generics"]]]],[5,"walk_where_predicate","","",N,[[["v"],["wherepredicate"]]]],[5,"walk_fn_ret_ty","","",N,[[["v"],["functionretty"]]]],[5,"walk_fn_decl","","",N,[[["v"],["fndecl"]]]],[5,"walk_fn_kind","","",N,[[["v"],["fnkind"]]]],[5,"walk_fn","","",N,[[["v"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[5,"walk_trait_item","","",N,[[["v"],["traititem"]]]],[5,"walk_trait_item_ref","","",N,[[["v"],["traititemref"]]]],[5,"walk_impl_item","","",N,[[["v"],["implitem"]]]],[5,"walk_impl_item_ref","","",N,[[["v"],["implitemref"]]]],[5,"walk_struct_def","","",N,[[["v"],["variantdata"]]]],[5,"walk_struct_field","","",N,[[["v"],["structfield"]]]],[5,"walk_block","","",N,[[["v"],["block"]]]],[5,"walk_stmt","","",N,[[["v"],["stmt"]]]],[5,"walk_decl","","",N,[[["v"],["decl"]]]],[5,"walk_anon_const","","",N,[[["v"],["anonconst"]]]],[5,"walk_expr","","",N,[[["v"],["expr"]]]],[5,"walk_arm","","",N,[[["v"],["arm"]]]],[5,"walk_vis","","",N,[[["v"],["visibility"]]]],[5,"walk_associated_item_kind","","",N,[[["v"],["associateditemkind"]]]],[5,"walk_defaultness","","",N,[[["v"],["defaultness"]]]],[8,"Visitor","","Each method of the Visitor trait is a hook to be potentially overridden.  Each method's default implementation recursively visits the substructure of the input via the corresponding `walk` method; e.g. the `visit_mod` method by default calls `intravisit::walk_mod`.",N,N],[10,"nested_visit_map","","The default versions of the `visit_nested_XXX` routines invoke this method to get a map to use. By selecting an enum variant, you control which kinds of nested HIR are visited; see `NestedVisitorMap` for details. By \"nested HIR\", we are referring to bits of HIR that are not directly embedded within one another but rather indirectly, through a table in the crate. This is done to control dependencies during incremental compilation: the non-inline bits of HIR can be tracked and hashed separately.",154,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_item","","Invoked when a nested item is encountered. By default does nothing unless you override `nested_visit_map` to return `Some(_)`, in which case it will walk the item. You probably don't want to override this method -- instead, override `nested_visit_map` or use the \"shallow\" or \"deep\" visit patterns described on `itemlikevisit::ItemLikeVisitor`. The only reason to override this method is if you want a nested pattern but cannot supply a `Map`; see `nested_visit_map` for advice.",154,[[["self"],["itemid"]]]],[11,"visit_nested_trait_item","","Like `visit_nested_item()`, but for trait items. See `visit_nested_item()` for advice on when to override this method.",154,[[["self"],["traititemid"]]]],[11,"visit_nested_impl_item","","Like `visit_nested_item()`, but for impl items. See `visit_nested_item()` for advice on when to override this method.",154,[[["self"],["implitemid"]]]],[11,"visit_nested_body","","Invoked to visit the body of a function, method or closure. Like visit_nested_item, does nothing by default unless you override `nested_visit_map` to return `Some(_)`, in which case it will walk the body.",154,[[["self"],["bodyid"]]]],[11,"visit_item","","Visit the top-level item and (optionally) nested items / impl items. See `visit_nested_item` for details.",154,[[["self"],["item"]]]],[11,"visit_body","","",154,[[["self"],["body"]]]],[11,"as_deep_visitor","","When invoking `visit_all_item_likes()`, you need to supply an item-like visitor.  This method converts a \"intra-visit\" visitor into an item-like visitor that walks the entire tree. If you use this, you probably don't want to process the contents of nested item-like things, since the outer loop will visit them as well.",154,[[["self"]],["deepvisitor"]]],[11,"visit_id","","",154,[[["self"],["nodeid"]]]],[11,"visit_def_mention","","",154,[[["self"],["def"]]]],[11,"visit_name","","",154,[[["self"],["span"],["name"]]]],[11,"visit_ident","","",154,[[["self"],["ident"]]]],[11,"visit_mod","","",154,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"visit_foreign_item","","",154,[[["self"],["foreignitem"]]]],[11,"visit_local","","",154,[[["self"],["local"]]]],[11,"visit_block","","",154,[[["self"],["block"]]]],[11,"visit_stmt","","",154,[[["self"],["stmt"]]]],[11,"visit_arm","","",154,[[["self"],["arm"]]]],[11,"visit_pat","","",154,[[["self"],["pat"]]]],[11,"visit_decl","","",154,[[["self"],["decl"]]]],[11,"visit_anon_const","","",154,[[["self"],["anonconst"]]]],[11,"visit_expr","","",154,[[["self"],["expr"]]]],[11,"visit_ty","","",154,[[["self"],["ty"]]]],[11,"visit_generic_param","","",154,[[["self"],["genericparam"]]]],[11,"visit_generics","","",154,[[["self"],["generics"]]]],[11,"visit_where_predicate","","",154,[[["self"],["wherepredicate"]]]],[11,"visit_fn_decl","","",154,[[["self"],["fndecl"]]]],[11,"visit_fn","","",154,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",154,[[["self"],["traititem"]]]],[11,"visit_trait_item_ref","","",154,[[["self"],["traititemref"]]]],[11,"visit_impl_item","","",154,[[["self"],["implitem"]]]],[11,"visit_impl_item_ref","","",154,[[["self"],["implitemref"]]]],[11,"visit_trait_ref","","",154,[[["self"],["traitref"]]]],[11,"visit_param_bound","","",154,[[["self"],["genericbound"]]]],[11,"visit_poly_trait_ref","","",154,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_variant_data","","",154,[[["self"],["variantdata"],["name"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",154,[[["self"],["structfield"]]]],[11,"visit_enum_def","","",154,[[["self"],["enumdef"],["generics"],["nodeid"],["span"]]]],[11,"visit_variant","","",154,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_label","","",154,[[["self"],["label"]]]],[11,"visit_generic_arg","","",154,[[["self"],["genericarg"]]]],[11,"visit_lifetime","","",154,[[["self"],["lifetime"]]]],[11,"visit_qpath","","",154,[[["self"],["qpath"],["nodeid"],["span"]]]],[11,"visit_path","","",154,[[["self"],["path"],["nodeid"]]]],[11,"visit_path_segment","","",154,[[["self"],["span"],["pathsegment"]]]],[11,"visit_generic_args","","",154,[[["self"],["span"],["genericargs"]]]],[11,"visit_assoc_type_binding","","",154,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",154,[[["self"],["attribute"]]]],[11,"visit_macro_def","","",154,[[["self"],["macrodef"]]]],[11,"visit_vis","","",154,[[["self"],["visibility"]]]],[11,"visit_associated_item_kind","","",154,[[["self"],["associateditemkind"]]]],[11,"visit_defaultness","","",154,[[["self"],["defaultness"]]]],[11,"clone","","",152,[[["self"]],["fnkind"]]],[11,"attrs","","",152,N],[11,"intra","","Returns the map to use for an \"intra item-like\" thing (if any). e.g., function body.",153,[[["self"]],["option",["map"]]]],[11,"inter","","Returns the map to use for an \"item-like\" thing (if any). e.g., item, impl-item.",153,[[["self"]],["option",["map"]]]],[11,"clone","","",150,[[["self"]],["idrange"]]],[11,"encode","","",150,[[["self"],["__s"]],["result"]]],[11,"decode","","",150,[[["__d"]],["result",["idrange"]]]],[11,"fmt","","",150,[[["self"],["formatter"]],["result"]]],[11,"max","","",150,[[],["idrange"]]],[11,"empty","","",150,[[["self"]],["bool"]]],[11,"contains","","",150,[[["self"],["nodeid"]],["bool"]]],[11,"add","","",150,[[["self"],["nodeid"]]]],[11,"new","","",151,[[["map"]],["idrangecomputingvisitor"]]],[11,"result","","",151,[[["self"]],["idrange"]]],[11,"nested_visit_map","","",151,[[["self"]],["nestedvisitormap"]]],[11,"visit_id","","",151,[[["self"],["nodeid"]]]],[0,"itemlikevisit","rustc::hir","",N,N],[3,"DeepVisitor","rustc::hir::itemlikevisit","",N,N],[12,"visitor","","",155,N],[3,"ParDeepVisitor","","",N,N],[12,"0","","",156,N],[8,"ItemLikeVisitor","","The \"item-like visitor\" visitor defines only the top-level methods that can be invoked by `Crate::visit_all_item_likes()`. Whether this trait is the right one to implement will depend on the overall pattern you need. Here are the three available patterns, in roughly the order of desirability:",N,N],[10,"visit_item","","",157,[[["self"],["item"]]]],[10,"visit_trait_item","","",157,[[["self"],["traititem"]]]],[10,"visit_impl_item","","",157,[[["self"],["implitem"]]]],[8,"ParItemLikeVisitor","","A parallel variant of ItemLikeVisitor",N,N],[10,"visit_item","","",158,[[["self"],["item"]]]],[10,"visit_trait_item","","",158,[[["self"],["traititem"]]]],[10,"visit_impl_item","","",158,[[["self"],["implitem"]]]],[8,"IntoVisitor","","",N,N],[16,"Visitor","","",159,N],[10,"into_visitor","","",159,N],[11,"new","","",155,[[["v"]],["self"]]],[11,"visit_item","","",155,[[["self"],["item"]]]],[11,"visit_trait_item","","",155,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",155,[[["self"],["implitem"]]]],[11,"visit_item","","",156,[[["self"],["item"]]]],[11,"visit_trait_item","","",156,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",156,[[["self"],["implitem"]]]],[0,"lowering","rustc::hir","Lowers the AST to the HIR.",N,N],[3,"LoweringContext","rustc::hir::lowering","",N,N],[12,"crate_root","","",160,N],[12,"sess","","",160,N],[12,"cstore","","",160,N],[12,"resolver","","",160,N],[12,"items","","The items being lowered are collected here.",160,N],[12,"trait_items","","",160,N],[12,"impl_items","","",160,N],[12,"bodies","","",160,N],[12,"exported_macros","","",160,N],[12,"trait_impls","","",160,N],[12,"trait_auto_impl","","",160,N],[12,"is_generator","","",160,N],[12,"catch_scopes","","",160,N],[12,"loop_scopes","","",160,N],[12,"is_in_loop_condition","","",160,N],[12,"is_in_trait_impl","","",160,N],[12,"anonymous_lifetime_mode","","What to do when we encounter either an \"anonymous lifetime reference\". The term \"anonymous\" is meant to encompass both `'_` lifetimes as well as fully elided cases where nothing is written at all (e.g., `&T` or `std::cell::Ref<T>`).",160,N],[12,"lifetimes_to_define","","",160,N],[12,"is_collecting_in_band_lifetimes","","",160,N],[12,"in_scope_lifetimes","","",160,N],[12,"type_def_lifetime_params","","",160,N],[12,"current_hir_id_owner","","",160,N],[12,"item_local_id_counters","","",160,N],[12,"node_id_to_hir_id","","",160,N],[3,"LoweredNodeId","","",N,N],[12,"node_id","","",161,N],[12,"hir_id","","",161,N],[4,"ImplTraitContext","","",N,N],[13,"Universal","","Treat `impl Trait` as shorthand for a new universal generic parameter. Example: `fn foo(x: impl Debug)`, where `impl Debug` is conceptually equivalent to a fresh universal parameter like `fn foo<T: Debug>(x: T)`.",162,N],[13,"Existential","","Treat `impl Trait` as shorthand for a new universal existential parameter. Example: `fn foo() -> impl Debug`, where `impl Debug` is conceptually equivalent to a fresh existential parameter like `abstract type T; fn foo() -> T`.",162,N],[13,"Disallowed","","`impl Trait` is not accepted in this position.",162,N],[4,"ParamMode","","",N,N],[13,"Explicit","","Any path in a type context.",163,N],[13,"Optional","","The `module::Type` in `module::Type::method` in an expression.",163,N],[4,"ParenthesizedGenericArgs","","",N,N],[13,"Ok","","",164,N],[13,"Warn","","",164,N],[13,"Err","","",164,N],[4,"AnonymousLifetimeMode","","What to do when we encounter an anonymous lifetime reference. Anonymous lifetime references come in two flavors.  You have implicit, or fully elided, references to lifetimes, like the one in `&T` or `Ref<T>`, and you have `'_` lifetimes, like `&'_ T` or `Ref<'_, T>`.  These often behave the same, but not always:",N,N],[13,"CreateParameter","","For Modern cases, create a new anonymous region parameter and reference that.",165,N],[13,"PassThrough","","Pass responsibility to `resolve_lifetime` code for all cases.",165,N],[5,"lower_crate","","",N,[[["session"],["cratestore"],["depgraph"],["crate"],["resolver"]],["crate"]]],[5,"body_ids","","",N,[[["btreemap"]],["vec",["bodyid"]]]],[22,"","","",N,N],[17,"HIR_ID_COUNTER_LOCKED","","",N,N],[8,"Resolver","","",N,N],[10,"resolve_hir_path","","Resolve a hir path generated by the lowerer when expanding `for`, `if let`, etc.",166,[[["self"],["path"],["bool"]]]],[10,"get_resolution","","Obtain the resolution for a node id",166,[[["self"],["nodeid"]],["option",["pathresolution"]]]],[10,"get_import","","Obtain the possible resolutions for the given `use` statement.",166,[[["self"],["nodeid"]],["perns",["option"]]]],[10,"definitions","","We must keep the set of definitions up to date as we add nodes that weren't in the AST. This should only return `None` during testing.",166,[[["self"]],["definitions"]]],[10,"resolve_str_path","","Given suffix [\"b\",\"c\",\"d\"], creates a HIR path for `[::crate_root]::b::c::d` and resolves it based on `is_value`.",166,N],[11,"fmt","","",162,[[["self"],["formatter"]],["result"]]],[11,"reborrow","","",162,[[["self"]],["impltraitcontext"]]],[11,"clone","","",163,[[["self"]],["parammode"]]],[11,"eq","","",163,[[["self"],["parammode"]],["bool"]]],[11,"fmt","","",161,[[["self"],["formatter"]],["result"]]],[11,"clone","","",165,[[["self"]],["anonymouslifetimemode"]]],[11,"lower_crate","","",160,[[["self"],["crate"]],["crate"]]],[11,"allocate_hir_id_counter","","",160,[[["self"],["nodeid"],["t"]],["lowerednodeid"]]],[11,"lower_node_id_generic","","",160,[[["self"],["nodeid"],["f"]],["lowerednodeid"]]],[11,"with_hir_id_owner","","",160,[[["self"],["nodeid"],["f"]],["t"]]],[11,"lower_node_id","","This method allocates a new HirId for the given NodeId and stores it in the LoweringContext's NodeId => HirId map. Take care not to call this method if the resulting HirId is then not actually used in the HIR, as that would trigger an assertion in the HirIdValidator later on, which makes sure that all NodeIds got mapped properly. Calling the method twice with the same NodeId is fine though.",160,[[["self"],["nodeid"]],["lowerednodeid"]]],[11,"lower_node_id_with_owner","","",160,[[["self"],["nodeid"],["nodeid"]],["lowerednodeid"]]],[11,"record_body","","",160,[[["self"],["expr"],["option",["fndecl"]]],["bodyid"]]],[11,"next_id","","",160,[[["self"]],["lowerednodeid"]]],[11,"expect_full_def","","",160,[[["self"],["nodeid"]],["def"]]],[11,"expect_full_def_from_use","","",160,[[["self"],["nodeid"]],[""]]],[11,"diagnostic","","",160,[[["self"]],["handler"]]],[11,"str_to_ident","","",160,[[["self"],["str"]],["ident"]]],[11,"allow_internal_unstable","","",160,[[["self"],["compilerdesugaringkind"],["span"]],["span"]]],[11,"with_anonymous_lifetime_mode","","",160,N],[11,"collect_in_band_defs","","Creates a new hir::GenericParam for every new lifetime and type parameter encountered while evaluating `f`. Definitions are created with the parent provided. If no `parent_id` is provided, no definitions will be returned.",160,N],[11,"maybe_collect_in_band_lifetime","","When there is a reference to some lifetime `'a`, and in-band lifetimes are enabled, then we want to push that lifetime into the vector of names to define later. In that case, it will get added to the appropriate generics.",160,[[["self"],["ident"]]]],[11,"collect_fresh_in_band_lifetime","","When we have either an elided or `'_` lifetime in an impl header, we convert it to",160,[[["self"],["span"]],["paramname"]]],[11,"with_in_scope_lifetime_defs","","",160,N],[11,"with_parent_impl_lifetime_defs","","",160,[[["self"],["hirvec"],["f"]],["t"]]],[11,"add_in_band_defs","","Appends in-band lifetime defs and argument-position `impl Trait` defs to the existing set of generics.",160,N],[11,"with_catch_scope","","",160,[[["self"],["nodeid"],["f"]],["t"]]],[11,"make_async_expr","","",160,N],[11,"lower_body","","",160,[[["self"],["option",["fndecl"]],["f"]],["bodyid"]]],[11,"with_loop_scope","","",160,[[["self"],["nodeid"],["f"]],["t"]]],[11,"with_loop_condition_scope","","",160,[[["self"],["f"]],["t"]]],[11,"with_new_scopes","","",160,[[["self"],["f"]],["t"]]],[11,"def_key","","",160,[[["self"],["defid"]],["defkey"]]],[11,"lower_label","","",160,[[["self"],["option",["label"]]],["option",["label"]]]],[11,"lower_loop_destination","","",160,[[["self"],["option"]],["destination"]]],[11,"lower_attrs","","",160,N],[11,"lower_attr","","",160,[[["self"],["attribute"]],["attribute"]]],[11,"lower_token_stream","","",160,[[["self"],["tokenstream"]],["tokenstream"]]],[11,"lower_token_tree","","",160,[[["self"],["tokentree"]],["tokenstream"]]],[11,"lower_token","","",160,[[["self"],["token"],["span"]],["tokenstream"]]],[11,"lower_arm","","",160,[[["self"],["arm"]],["arm"]]],[11,"lower_ty_binding","","",160,[[["self"],["typebinding"],["impltraitcontext"]],["typebinding"]]],[11,"lower_generic_arg","","",160,[[["self"],["genericarg"],["impltraitcontext"]],["genericarg"]]],[11,"lower_ty","","",160,[[["self"],["ty"],["impltraitcontext"]],["p",["ty"]]]],[11,"lower_ty_direct","","",160,[[["self"],["ty"],["impltraitcontext"]],["ty"]]],[11,"lower_existential_impl_trait","","",160,N],[11,"lifetimes_from_impl_trait_bounds","","",160,N],[11,"lower_foreign_mod","","",160,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"lower_global_asm","","",160,[[["self"],["globalasm"]],["p",["globalasm"]]]],[11,"lower_variant","","",160,[[["self"],["variant"]],["variant"]]],[11,"lower_qpath","","",160,[[["self"],["nodeid"],["option"],["path"],["parammode"],["impltraitcontext"]],["qpath"]]],[11,"lower_path_extra","","",160,[[["self"],["def"],["path"],["option",["ident"]],["parammode"]],["path"]]],[11,"lower_path","","",160,[[["self"],["nodeid"],["path"],["parammode"]],["path"]]],[11,"lower_path_segment","","",160,[[["self"],["span"],["pathsegment"],["parammode"],["usize"],["parenthesizedgenericargs"],["impltraitcontext"]],["pathsegment"]]],[11,"lower_angle_bracketed_parameter_data","","",160,N],[11,"lower_parenthesized_parameter_data","","",160,N],[11,"lower_local","","",160,[[["self"],["local"]],["p",["local"]]]],[11,"lower_mutability","","",160,[[["self"],["mutability"]],["mutability"]]],[11,"lower_arg","","",160,[[["self"],["arg"]],["arg"]]],[11,"lower_fn_args_to_names","","",160,[[["self"],["fndecl"]],["hirvec",["ident"]]]],[11,"lower_fn_decl","","",160,[[["self"],["fndecl"],["option"],["bool"],["option",["nodeid"]]],["p",["fndecl"]]]],[11,"lower_async_fn_ret_ty","","",160,N],[11,"lower_param_bound","","",160,[[["self"],["genericbound"],["impltraitcontext"]],["genericbound"]]],[11,"lower_lifetime","","",160,[[["self"],["lifetime"]],["lifetime"]]],[11,"new_named_lifetime","","",160,[[["self"],["nodeid"],["span"],["lifetimename"]],["lifetime"]]],[11,"lower_generic_params","","",160,N],[11,"lower_generic_param","","",160,[[["self"],["genericparam"],["nodemap"],["impltraitcontext"]],["genericparam"]]],[11,"lower_generics","","",160,[[["self"],["generics"],["impltraitcontext"]],["generics"]]],[11,"lower_where_clause","","",160,[[["self"],["whereclause"]],["whereclause"]]],[11,"lower_where_predicate","","",160,[[["self"],["wherepredicate"]],["wherepredicate"]]],[11,"lower_variant_data","","",160,[[["self"],["variantdata"]],["variantdata"]]],[11,"lower_trait_ref","","",160,[[["self"],["traitref"],["impltraitcontext"]],["traitref"]]],[11,"lower_poly_trait_ref","","",160,[[["self"],["polytraitref"],["impltraitcontext"]],["polytraitref"]]],[11,"lower_struct_field","","",160,N],[11,"lower_field","","",160,[[["self"],["field"]],["field"]]],[11,"lower_mt","","",160,[[["self"],["mutty"],["impltraitcontext"]],["mutty"]]],[11,"lower_param_bounds","","",160,N],[11,"lower_block","","",160,[[["self"],["block"],["bool"]],["p",["block"]]]],[11,"lower_async_body","","",160,[[["self"],["fndecl"],["isasync"],["block"]],["bodyid"]]],[11,"lower_item_kind","","",160,[[["self"],["nodeid"],["name"],["hirvec"],["visibility"],["itemkind"]],["itemkind"]]],[11,"lower_use_tree","","",160,[[["self"],["usetree"],["path"],["nodeid"],["visibility"],["name"],["hirvec"]],["itemkind"]]],[11,"lower_trait_item","","",160,[[["self"],["traititem"]],["traititem"]]],[11,"lower_trait_item_ref","","",160,[[["self"],["traititem"]],["traititemref"]]],[11,"lower_impl_item","","",160,[[["self"],["implitem"]],["implitem"]]],[11,"lower_impl_item_ref","","",160,[[["self"],["implitem"]],["implitemref"]]],[11,"lower_mod","","",160,[[["self"],["mod"]],["mod"]]],[11,"lower_impl_trait_ids","","Lowers `impl Trait` items and appends them to the list",160,[[["self"],["fndecl"],["fnheader"],["smallvector"]]]],[11,"lower_item_id","","",160,[[["self"],["item"]],["smallvector",["itemid"]]]],[11,"lower_item_id_use_tree","","",160,[[["self"],["usetree"],["nodeid"],["smallvector"]]]],[11,"lower_item","","",160,[[["self"],["item"]],["option",["item"]]]],[11,"lower_foreign_item","","",160,[[["self"],["foreignitem"]],["foreignitem"]]],[11,"lower_method_sig","","",160,N],[11,"lower_is_auto","","",160,[[["self"],["isauto"]],["isauto"]]],[11,"lower_fn_header","","",160,[[["self"],["fnheader"]],["fnheader"]]],[11,"lower_unsafety","","",160,[[["self"],["unsafety"]],["unsafety"]]],[11,"lower_constness","","",160,[[["self"],["spanned",["constness"]]],["constness"]]],[11,"lower_asyncness","","",160,[[["self"],["isasync"]],["isasync"]]],[11,"lower_unop","","",160,[[["self"],["unop"]],["unop"]]],[11,"lower_binop","","",160,[[["self"],["binop"]],["binop"]]],[11,"lower_pat","","",160,[[["self"],["pat"]],["p",["pat"]]]],[11,"lower_range_end","","",160,[[["self"],["rangeend"]],["rangeend"]]],[11,"lower_anon_const","","",160,[[["self"],["anonconst"]],["anonconst"]]],[11,"lower_expr","","",160,[[["self"],["expr"]],["expr"]]],[11,"lower_stmt","","",160,[[["self"],["stmt"]],["smallvector",["stmt"]]]],[11,"lower_capture_clause","","",160,[[["self"],["captureby"]],["captureclause"]]],[11,"lower_visibility","","If an `explicit_owner` is given, this method allocates the `HirId` in the address space of that item instead of the item currently being lowered. This can happen during `lower_impl_item_ref()` where we need to lower a `Visibility` value although we haven't lowered the owning `ImplItem` in question yet.",160,[[["self"],["visibility"],["option",["nodeid"]]],["visibility"]]],[11,"lower_defaultness","","",160,[[["self"],["defaultness"],["bool"]],["defaultness"]]],[11,"lower_block_check_mode","","",160,[[["self"],["blockcheckmode"]],["blockcheckmode"]]],[11,"lower_binding_mode","","",160,[[["self"],["bindingmode"]],["bindingannotation"]]],[11,"lower_unsafe_source","","",160,[[["self"],["unsafesource"]],["unsafesource"]]],[11,"lower_impl_polarity","","",160,[[["self"],["implpolarity"]],["implpolarity"]]],[11,"lower_trait_bound_modifier","","",160,[[["self"],["traitboundmodifier"]],["traitboundmodifier"]]],[11,"arm","","",160,[[["self"],["hirvec",["p"]],["p",["expr"]]],["arm"]]],[11,"field","","",160,[[["self"],["ident"],["p",["expr"]],["span"]],["field"]]],[11,"expr_break","","",160,[[["self"],["span"],["thinvec",["attribute"]]],["p",["expr"]]]],[11,"expr_call","","",160,[[["self"],["span"],["p",["expr"]],["hirvec",["expr"]]],["expr"]]],[11,"expr_ident","","",160,[[["self"],["span"],["ident"],["nodeid"]],["expr"]]],[11,"expr_ident_with_attrs","","",160,[[["self"],["span"],["ident"],["nodeid"],["thinvec",["attribute"]]],["expr"]]],[11,"expr_mut_addr_of","","",160,[[["self"],["span"],["p",["expr"]]],["expr"]]],[11,"expr_std_path","","",160,N],[11,"expr_match","","",160,[[["self"],["span"],["p",["expr"]],["hirvec",["arm"]],["matchsource"]],["expr"]]],[11,"expr_block","","",160,[[["self"],["p",["block"]],["thinvec",["attribute"]]],["expr"]]],[11,"expr_tuple","","",160,[[["self"],["span"],["hirvec",["expr"]]],["p",["expr"]]]],[11,"expr","","",160,[[["self"],["span"],["exprkind"],["thinvec",["attribute"]]],["expr"]]],[11,"stmt_let_pat","","",160,[[["self"],["span"],["option",["p"]],["p",["pat"]],["localsource"]],["stmt"]]],[11,"stmt_let","","",160,N],[11,"block_expr","","",160,[[["self"],["p",["expr"]]],["block"]]],[11,"block_all","","",160,[[["self"],["span"],["hirvec",["stmt"]],["option",["p"]]],["block"]]],[11,"pat_ok","","",160,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_err","","",160,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_some","","",160,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_none","","",160,[[["self"],["span"]],["p",["pat"]]]],[11,"pat_std_enum","","",160,N],[11,"pat_ident","","",160,[[["self"],["span"],["ident"]],["p",["pat"]]]],[11,"pat_ident_binding_mode","","",160,[[["self"],["span"],["ident"],["bindingannotation"]],["p",["pat"]]]],[11,"pat_wild","","",160,[[["self"],["span"]],["p",["pat"]]]],[11,"pat","","",160,[[["self"],["span"],["patkind"]],["p",["pat"]]]],[11,"std_path","","Given suffix [\"b\",\"c\",\"d\"], returns path `::std::b::c::d` when `fld.cx.use_std`, and `::core::b::c::d` otherwise. The path is also resolved according to `is_value`.",160,N],[11,"ty_path","","",160,[[["self"],["lowerednodeid"],["span"],["qpath"]],["ty"]]],[11,"elided_ref_lifetime","","Invoked to create the lifetime argument for a type `&T` with no explicit lifetime.",160,[[["self"],["span"]],["lifetime"]]],[11,"elided_path_lifetimes","","Invoked to create the lifetime argument(s) for a path like `std::cell::Ref<T>`; note that implicit lifetimes in these sorts of cases are deprecated. This may therefore report a warning or an error, depending on the mode.",160,[[["self"],["span"],["usize"]],["p"]]],[11,"elided_dyn_bound","","Invoked to create the lifetime argument(s) for an elided trait object bound, like the bound in `Box<dyn Debug>`. This method is not invoked when the bound is written, even if it is written with `'_` like in `Box<dyn Debug + '_>`. In those cases, `lower_lifetime` is invoked.",160,[[["self"],["span"]],["lifetime"]]],[11,"new_implicit_lifetime","","",160,[[["self"],["span"]],["lifetime"]]],[11,"maybe_lint_bare_trait","","",160,[[["self"],["span"],["nodeid"],["bool"]]]],[11,"wrap_in_try_constructor","","",160,[[["self"],["str"],["expr"],["span"]],["p",["expr"]]]],[0,"map","rustc::hir","",N,N],[3,"DefCollector","rustc::hir::map","Creates def ids for nodes in the AST.",N,N],[12,"definitions","","",167,N],[12,"parent_def","","",167,N],[12,"expansion","","",167,N],[12,"visit_macro_invoc","","",167,N],[3,"MacroInvocationData","","",N,N],[12,"mark","","",168,N],[12,"def_index","","",168,N],[3,"Forest","","Stores a crate and any number of inlined items from other crates.",N,N],[12,"krate","","",169,N],[12,"dep_graph","","",169,N],[3,"Map","","Represents a mapping from Node IDs to AST elements and their parent Node IDs",N,N],[12,"forest","","The backing storage for all the AST nodes.",170,N],[12,"dep_graph","","Same as the dep_graph in forest, just available with one fewer deref. This is a gratuitous micro-optimization.",170,N],[12,"crate_hash","","The SVH of the local crate.",170,N],[12,"map","","NodeIds are sequential integers from 0, so we can be super-compact by storing them in a vector. Not everything with a NodeId is in the map, but empirically the occupancy is about 75-80%, so there's not too much overhead (certainly less than a hashmap, since they (at the time of writing) have a maximum of 75% occupancy).",170,N],[12,"definitions","","",170,N],[12,"hir_to_node_id","","The reverse mapping of `node_to_hir_id`.",170,N],[3,"NodesMatchingSuffix","","",N,N],[12,"map","","",171,N],[12,"item_name","","",171,N],[12,"in_which","","",171,N],[12,"idx","","",171,N],[4,"Node","","",N,N],[13,"NodeItem","","",172,N],[13,"NodeForeignItem","","",172,N],[13,"NodeTraitItem","","",172,N],[13,"NodeImplItem","","",172,N],[13,"NodeVariant","","",172,N],[13,"NodeField","","",172,N],[13,"NodeAnonConst","","",172,N],[13,"NodeExpr","","",172,N],[13,"NodeStmt","","",172,N],[13,"NodeTy","","",172,N],[13,"NodeTraitRef","","",172,N],[13,"NodeBinding","","",172,N],[13,"NodePat","","",172,N],[13,"NodeBlock","","",172,N],[13,"NodeLocal","","",172,N],[13,"NodeMacroDef","","",172,N],[13,"NodeStructCtor","","NodeStructCtor represents a tuple struct.",172,N],[13,"NodeLifetime","","",172,N],[13,"NodeGenericParam","","",172,N],[13,"NodeVisibility","","",172,N],[4,"MapEntry","","Represents an entry and its parent NodeID. The odd layout is to bring down the total size.",N,N],[13,"NotPresent","","Placeholder for holes in the map.",173,N],[13,"EntryItem","","All the node types, with a parent ID.",173,N],[13,"EntryForeignItem","","",173,N],[13,"EntryTraitItem","","",173,N],[13,"EntryImplItem","","",173,N],[13,"EntryVariant","","",173,N],[13,"EntryField","","",173,N],[13,"EntryAnonConst","","",173,N],[13,"EntryExpr","","",173,N],[13,"EntryStmt","","",173,N],[13,"EntryTy","","",173,N],[13,"EntryTraitRef","","",173,N],[13,"EntryBinding","","",173,N],[13,"EntryPat","","",173,N],[13,"EntryBlock","","",173,N],[13,"EntryStructCtor","","",173,N],[13,"EntryLifetime","","",173,N],[13,"EntryGenericParam","","",173,N],[13,"EntryVisibility","","",173,N],[13,"EntryLocal","","",173,N],[13,"EntryMacroDef","","",173,N],[13,"RootCrate","","Roots for node trees. The DepNodeIndex is the dependency node of the crate's root module.",173,N],[5,"map_crate","","",N,[[["session"],["cratestore"],["forest"],["definitions"]],["map"]]],[5,"node_id_to_string","","",N,[[["map"],["nodeid"],["bool"]],["string"]]],[5,"describe_def","","",N,[[["tyctxt"],["defid"]],["option",["def"]]]],[0,"blocks","","This module provides a simplified abstraction for working with code blocks identified by their integer node-id.  In particular, it captures a common set of attributes that all \"function-like things\" (represented by `FnLike` instances) share.  For example, all `FnLike` instances have a type signature (be it explicit or inferred).  And all `FnLike` instances have a body, i.e. the code that is run when the function-like thing it represents is invoked.",N,N],[3,"FnLikeNode","rustc::hir::map::blocks","An FnLikeNode is a Node that is like a fn, in that it has a decl and a body (as well as a NodeId, a span, etc).",N,N],[12,"node","","",174,N],[3,"ItemFnParts","","These are all the components one can extract from a fn item for use when implementing FnLikeNode operations.",N,N],[12,"name","","",175,N],[12,"decl","","",175,N],[12,"header","","",175,N],[12,"vis","","",175,N],[12,"generics","","",175,N],[12,"body","","",175,N],[12,"id","","",175,N],[12,"span","","",175,N],[12,"attrs","","",175,N],[3,"ClosureParts","","These are all the components one can extract from a closure expr for use when implementing FnLikeNode operations.",N,N],[12,"decl","","",176,N],[12,"body","","",176,N],[12,"id","","",176,N],[12,"span","","",176,N],[12,"attrs","","",176,N],[4,"Code","","Carries either an FnLikeNode or a Expr, as these are the two constructs that correspond to \"code\" (as in, something from which we can construct a control-flow graph).",N,N],[13,"FnLike","","",177,N],[13,"Expr","","",177,N],[8,"MaybeFnLike","","MaybeFnLike wraps a method that indicates if an object corresponds to some FnLikeNode.",N,N],[10,"is_fn_like","","",178,[[["self"]],["bool"]]],[11,"clone","","",174,[[["self"]],["fnlikenode"]]],[11,"fmt","","",174,[[["self"],["formatter"]],["result"]]],[11,"is_fn_like","rustc::hir","",83,[[["self"]],["bool"]]],[11,"is_fn_like","","",65,[[["self"]],["bool"]]],[11,"is_fn_like","","",63,[[["self"]],["bool"]]],[11,"is_fn_like","","",58,[[["self"]],["bool"]]],[11,"clone","rustc::hir::map::blocks","",177,[[["self"]],["code"]]],[11,"id","","",177,[[["self"]],["nodeid"]]],[11,"from_node","","Attempts to construct a Code from presumed FnLike or Expr node input.",177,[[["map"],["nodeid"]],["option",["code"]]]],[11,"new","","",176,N],[11,"from_node","","Attempts to construct a FnLikeNode from presumed FnLike node input.",174,[[["node"]],["option",["fnlikenode"]]]],[11,"body","","",174,[[["self"]],["bodyid"]]],[11,"decl","","",174,[[["self"]],["fndecl"]]],[11,"span","","",174,[[["self"]],["span"]]],[11,"id","","",174,[[["self"]],["nodeid"]]],[11,"constness","","",174,[[["self"]],["constness"]]],[11,"asyncness","","",174,[[["self"]],["isasync"]]],[11,"unsafety","","",174,[[["self"]],["unsafety"]]],[11,"kind","","",174,[[["self"]],["fnkind"]]],[11,"handle","","",174,[[["self"],["i"],["m"],["c"]],["a"]]],[0,"collector","rustc::hir::map","",N,N],[3,"NodeCollector","rustc::hir::map::collector","A Visitor that walks over the HIR and collects Nodes into a HIR map",N,N],[12,"krate","","The crate",179,N],[12,"map","","The node map",179,N],[12,"parent_node","","The parent of this node",179,N],[12,"current_dep_node_owner","","",179,N],[12,"current_signature_dep_index","","",179,N],[12,"current_full_dep_index","","",179,N],[12,"currently_in_body","","",179,N],[12,"dep_graph","","",179,N],[12,"definitions","","",179,N],[12,"hcx","","",179,N],[12,"hir_body_nodes","","",179,N],[3,"HirItemLike","","",N,N],[12,"item_like","","",180,N],[12,"hash_bodies","","",180,N],[11,"root","","",179,[[["crate"],["depgraph"],["definitions"],["stablehashingcontext"]],["nodecollector"]]],[11,"finalize_and_compute_crate_hash","","",179,N],[11,"insert_entry","","",179,[[["self"],["nodeid"],["mapentry"]]]],[11,"insert","","",179,[[["self"],["nodeid"],["node"]]]],[11,"with_parent","","",179,[[["self"],["nodeid"],["f"]]]],[11,"with_dep_node_owner","","",179,[[["self"],["defindex"],["t"],["f"]]]],[11,"nested_visit_map","","Because we want to track parent items and so forth, enable deep walking so that we walk nested items in the context of their outer items.",179,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_item","","",179,[[["self"],["itemid"]]]],[11,"visit_nested_trait_item","","",179,[[["self"],["traititemid"]]]],[11,"visit_nested_impl_item","","",179,[[["self"],["implitemid"]]]],[11,"visit_nested_body","","",179,[[["self"],["bodyid"]]]],[11,"visit_item","","",179,[[["self"],["item"]]]],[11,"visit_foreign_item","","",179,[[["self"],["foreignitem"]]]],[11,"visit_generic_param","","",179,[[["self"],["genericparam"]]]],[11,"visit_trait_item","","",179,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",179,[[["self"],["implitem"]]]],[11,"visit_pat","","",179,[[["self"],["pat"]]]],[11,"visit_anon_const","","",179,[[["self"],["anonconst"]]]],[11,"visit_expr","","",179,[[["self"],["expr"]]]],[11,"visit_stmt","","",179,[[["self"],["stmt"]]]],[11,"visit_ty","","",179,[[["self"],["ty"]]]],[11,"visit_trait_ref","","",179,[[["self"],["traitref"]]]],[11,"visit_fn","","",179,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_block","","",179,[[["self"],["block"]]]],[11,"visit_local","","",179,[[["self"],["local"]]]],[11,"visit_lifetime","","",179,[[["self"],["lifetime"]]]],[11,"visit_vis","","",179,[[["self"],["visibility"]]]],[11,"visit_macro_def","","",179,[[["self"],["macrodef"]]]],[11,"visit_variant","","",179,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",179,[[["self"],["structfield"]]]],[11,"visit_trait_item_ref","","",179,[[["self"],["traititemref"]]]],[11,"visit_impl_item_ref","","",179,[[["self"],["implitemref"]]]],[11,"hash_stable","","",180,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"def_collector","rustc::hir::map","",N,N],[3,"DefCollector","rustc::hir::map::def_collector","Creates def ids for nodes in the AST.",N,N],[12,"definitions","","",167,N],[12,"parent_def","","",167,N],[12,"expansion","","",167,N],[12,"visit_macro_invoc","","",167,N],[3,"MacroInvocationData","","",N,N],[12,"mark","","",168,N],[12,"def_index","","",168,N],[11,"new","rustc::hir::map","",167,[[["definitions"],["mark"]],["self"]]],[11,"collect_root","","",167,[[["self"],["str"],["cratedisambiguator"]]]],[11,"create_def","","",167,[[["self"],["nodeid"],["defpathdata"],["defindexaddressspace"],["span"]],["defindex"]]],[11,"with_parent","","",167,[[["self"],["defindex"],["f"]]]],[11,"visit_async_fn","","",167,N],[11,"visit_macro_invoc","","",167,[[["self"],["nodeid"]]]],[11,"visit_item","","",167,[[["self"],["item"]]]],[11,"visit_use_tree","","",167,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_foreign_item","","",167,[[["self"],["foreignitem"]]]],[11,"visit_variant","","",167,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_variant_data","","",167,[[["self"],["variantdata"],["ident"],["generics"],["nodeid"],["span"]]]],[11,"visit_generic_param","","",167,[[["self"],["genericparam"]]]],[11,"visit_trait_item","","",167,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",167,[[["self"],["implitem"]]]],[11,"visit_pat","","",167,[[["self"],["pat"]]]],[11,"visit_anon_const","","",167,[[["self"],["anonconst"]]]],[11,"visit_expr","","",167,[[["self"],["expr"]]]],[11,"visit_ty","","",167,[[["self"],["ty"]]]],[11,"visit_stmt","","",167,[[["self"],["stmt"]]]],[11,"visit_token","","",167,[[["self"],["token"]]]],[0,"definitions","","For each definition, we track the following data.  A definition here is defined somewhat circularly as \"something with a def-id\", but it generally corresponds to things like structs, enums, etc. There are also some rather random cases (like const initializer expressions) that are mostly just leftovers.",N,N],[3,"DefPathTable","rustc::hir::map::definitions","The DefPathTable maps DefIndexes to DefKeys and vice versa. Internally the DefPathTable holds a tree of DefKeys, where each DefKey stores the DefIndex of its parent. There is one DefPathTable for each crate.",N,N],[12,"index_to_key","","",181,N],[12,"def_path_hashes","","",181,N],[3,"Definitions","","The definition table containing node definitions. It holds the DefPathTable for local DefIds/DefPaths and it also stores a mapping from NodeIds to local DefIds.",N,N],[12,"table","","",182,N],[12,"node_to_def_index","","",182,N],[12,"def_index_to_node","","",182,N],[12,"node_to_hir_id","","",182,N],[12,"parent_modules_of_macro_defs","","If `Mark` is an ID of some macro expansion, then `DefId` is the normal module (`mod`) in which the expanded macro was defined.",182,N],[12,"expansions_that_defined","","Item with a given `DefIndex` was defined during macro expansion with ID `Mark`.",182,N],[12,"next_disambiguator","","",182,N],[12,"def_index_to_span","","",182,N],[3,"DefKey","","A unique identifier that we can use to lookup a definition precisely. It combines the index of the definition's parent (if any) with a `DisambiguatedDefPathData`.",N,N],[12,"parent","","Parent path.",183,N],[12,"disambiguated_data","","Identifier of this node.",183,N],[3,"DisambiguatedDefPathData","","Pair of `DefPathData` and an integer disambiguator. The integer is normally 0, but in the event that there are multiple defs with the same `parent` and `data`, we use this field to disambiguate between them. This introduces some artificial ordering dependency but means that if you have (e.g.) two impls for the same type in the same module, they do get distinct def-ids.",N,N],[12,"data","","",184,N],[12,"disambiguator","","",184,N],[3,"DefPath","","",N,N],[12,"data","","the path leading from the crate root to the item",185,N],[12,"krate","","what krate root is this path relative to?",185,N],[3,"DefPathHash","","",N,N],[12,"0","","",186,N],[4,"DefPathData","","",N,N],[13,"CrateRoot","","The crate root (marker)",187,N],[13,"Misc","","",187,N],[13,"Impl","","An impl",187,N],[13,"Trait","","A trait",187,N],[13,"AssocTypeInTrait","","An associated type declaration (i.e., in a trait)",187,N],[13,"AssocTypeInImpl","","An associated type value (i.e., in an impl)",187,N],[13,"AssocExistentialInImpl","","An existential associated type value (i.e., in an impl)",187,N],[13,"TypeNs","","Something in the type NS",187,N],[13,"ValueNs","","Something in the value NS",187,N],[13,"Module","","A module declaration",187,N],[13,"MacroDef","","A macro rule",187,N],[13,"ClosureExpr","","A closure expression",187,N],[13,"TypeParam","","A type parameter (generic parameter)",187,N],[13,"LifetimeParam","","A lifetime definition",187,N],[13,"EnumVariant","","A variant of a enum",187,N],[13,"Field","","A struct field",187,N],[13,"StructCtor","","Implicit ctor for a tuple-like struct",187,N],[13,"AnonConst","","A constant expression (see {ast,hir}::AnonConst).",187,N],[13,"ImplTrait","","An `impl Trait` type node",187,N],[13,"GlobalMetaData","","GlobalMetaData identifies a piece of crate metadata that is global to a whole crate (as opposed to just one item). GlobalMetaData components are only supposed to show up right below the crate root.",187,N],[4,"GlobalMetaDataKind","","",N,N],[13,"Krate","","",188,N],[13,"CrateDeps","","",188,N],[13,"DylibDependencyFormats","","",188,N],[13,"LangItems","","",188,N],[13,"LangItemsMissing","","",188,N],[13,"NativeLibraries","","",188,N],[13,"CodeMap","","",188,N],[13,"Impls","","",188,N],[13,"ExportedSymbols","","",188,N],[17,"GLOBAL_MD_ADDRESS_SPACE","","",N,N],[11,"clone","","",181,[[["self"]],["self"]]],[11,"allocate","","",181,[[["self"],["defkey"],["defpathhash"],["defindexaddressspace"]],["defindex"]]],[11,"next_id","","",181,[[["self"],["defindexaddressspace"]],["defindex"]]],[11,"def_key","","",181,[[["self"],["defindex"]],["defkey"]]],[11,"def_path_hash","","",181,[[["self"],["defindex"]],["defpathhash"]]],[11,"add_def_path_hashes_to","","",181,[[["self"],["cratenum"],["fxhashmap"]]]],[11,"size","","",181,[[["self"]],["usize"]]],[11,"encode","","",181,[[["self"],["s"]],["result"]]],[11,"decode","","",181,[[["d"]],["result",["defpathtable"]]]],[11,"clone","","",182,[[["self"]],["definitions"]]],[11,"clone","","",183,[[["self"]],["defkey"]]],[11,"eq","","",183,[[["self"],["defkey"]],["bool"]]],[11,"ne","","",183,[[["self"],["defkey"]],["bool"]]],[11,"fmt","","",183,[[["self"],["formatter"]],["result"]]],[11,"hash","","",183,N],[11,"encode","","",183,[[["self"],["__s"]],["result"]]],[11,"decode","","",183,[[["__d"]],["result",["defkey"]]]],[11,"compute_stable_hash","","",183,[[["self"],["defpathhash"]],["defpathhash"]]],[11,"root_parent_stable_hash","","",183,[[["str"],["cratedisambiguator"]],["defpathhash"]]],[11,"clone","","",184,[[["self"]],["disambiguateddefpathdata"]]],[11,"eq","","",184,[[["self"],["disambiguateddefpathdata"]],["bool"]]],[11,"ne","","",184,[[["self"],["disambiguateddefpathdata"]],["bool"]]],[11,"fmt","","",184,[[["self"],["formatter"]],["result"]]],[11,"hash","","",184,N],[11,"encode","","",184,[[["self"],["__s"]],["result"]]],[11,"decode","","",184,[[["__d"]],["result",["disambiguateddefpathdata"]]]],[11,"clone","","",185,[[["self"]],["defpath"]]],[11,"fmt","","",185,[[["self"],["formatter"]],["result"]]],[11,"hash","","",185,N],[11,"encode","","",185,[[["self"],["__s"]],["result"]]],[11,"decode","","",185,[[["__d"]],["result",["defpath"]]]],[11,"is_local","","",185,[[["self"]],["bool"]]],[11,"make","","",185,[[["cratenum"],["defindex"],["fn"]],["defpath"]]],[11,"to_string_no_crate","","Returns a string representation of the DefPath without the crate-prefix. This method is useful if you don't have a TyCtxt available.",185,[[["self"]],["string"]]],[11,"to_filename_friendly_no_crate","","Return filename friendly string of the DefPah without the crate-prefix. This method is useful if you don't have a TyCtxt available.",185,[[["self"]],["string"]]],[11,"clone","","",187,[[["self"]],["defpathdata"]]],[11,"fmt","","",187,[[["self"],["formatter"]],["result"]]],[11,"eq","","",187,[[["self"],["defpathdata"]],["bool"]]],[11,"ne","","",187,[[["self"],["defpathdata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",187,N],[11,"hash","","",187,N],[11,"encode","","",187,[[["self"],["__s"]],["result"]]],[11,"decode","","",187,[[["__d"]],["result",["defpathdata"]]]],[11,"clone","","",186,[[["self"]],["defpathhash"]]],[11,"hash","","",186,N],[11,"eq","","",186,[[["self"],["defpathhash"]],["bool"]]],[11,"ne","","",186,[[["self"],["defpathhash"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",186,N],[11,"partial_cmp","","",186,[[["self"],["defpathhash"]],["option",["ordering"]]]],[11,"lt","","",186,[[["self"],["defpathhash"]],["bool"]]],[11,"le","","",186,[[["self"],["defpathhash"]],["bool"]]],[11,"gt","","",186,[[["self"],["defpathhash"]],["bool"]]],[11,"ge","","",186,[[["self"],["defpathhash"]],["bool"]]],[11,"cmp","","",186,[[["self"],["defpathhash"]],["ordering"]]],[11,"fmt","","",186,[[["self"],["formatter"]],["result"]]],[11,"encode","","",186,[[["self"],["__s"]],["result"]]],[11,"decode","","",186,[[["__d"]],["result",["defpathhash"]]]],[11,"hash_stable","","",186,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"borrow","","",186,[[["self"]],["fingerprint"]]],[11,"new","","Create new empty definition map.",182,[[],["definitions"]]],[11,"def_path_table","","",182,[[["self"]],["defpathtable"]]],[11,"def_index_counts_lo_hi","","Get the number of definitions.",182,N],[11,"def_key","","",182,[[["self"],["defindex"]],["defkey"]]],[11,"def_path_hash","","",182,[[["self"],["defindex"]],["defpathhash"]]],[11,"def_path","","Returns the path from the crate root to `index`. The root nodes are not included in the path (i.e., this will be an empty vector for the crate root). For an inlined item, this will be the path of the item in the external crate (but the path will begin with the path to the external crate).",182,[[["self"],["defindex"]],["defpath"]]],[11,"opt_def_index","","",182,[[["self"],["nodeid"]],["option",["defindex"]]]],[11,"opt_local_def_id","","",182,[[["self"],["nodeid"]],["option",["defid"]]]],[11,"local_def_id","","",182,[[["self"],["nodeid"]],["defid"]]],[11,"as_local_node_id","","",182,[[["self"],["defid"]],["option",["nodeid"]]]],[11,"node_to_hir_id","","",182,[[["self"],["nodeid"]],["hirid"]]],[11,"def_index_to_hir_id","","",182,[[["self"],["defindex"]],["hirid"]]],[11,"opt_span","","Retrieve the span of the given `DefId` if `DefId` is in the local crate, the span exists and it's not DUMMY_SP",182,[[["self"],["defid"]],["option",["span"]]]],[11,"create_root_def","","Add a definition with a parent definition.",182,[[["self"],["str"],["cratedisambiguator"]],["defindex"]]],[11,"create_def_with_parent","","Add a definition with a parent definition.",182,[[["self"],["defindex"],["nodeid"],["defpathdata"],["defindexaddressspace"],["mark"],["span"]],["defindex"]]],[11,"init_node_id_to_hir_id_mapping","","Initialize the ast::NodeId to HirId mapping once it has been generated during AST to HIR lowering.",182,[[["self"],["indexvec",["nodeid","hirid"]]]]],[11,"expansion_that_defined","","",182,[[["self"],["defindex"]],["mark"]]],[11,"parent_module_of_macro_def","","",182,[[["self"],["mark"]],["defid"]]],[11,"add_parent_module_of_macro_def","","",182,[[["self"],["mark"],["defid"]]]],[11,"get_opt_name","","",187,[[["self"]],["option",["internedstring"]]]],[11,"as_interned_str","","",187,[[["self"]],["internedstring"]]],[11,"to_string","","",187,[[["self"]],["string"]]],[11,"clone","","",188,[[["self"]],["globalmetadatakind"]]],[11,"fmt","","",188,[[["self"],["formatter"]],["result"]]],[11,"hash","","",188,N],[11,"encode","","",188,[[["self"],["__s"]],["result"]]],[11,"decode","","",188,[[["__d"]],["result",["globalmetadatakind"]]]],[11,"allocate_def_indices","","",188,[[["definitions"]]]],[11,"def_index","","",188,[[["self"],["defpathtable"]],["defindex"]]],[11,"name","","",188,[[["self"]],["symbol"]]],[0,"hir_id_validator","rustc::hir::map","",N,N],[3,"HirIdValidator","rustc::hir::map::hir_id_validator","",N,N],[12,"hir_map","","",189,N],[12,"owner_def_index","","",189,N],[12,"hir_ids_seen","","",189,N],[12,"errors","","",189,N],[3,"OuterVisitor","","",N,N],[12,"hir_map","","",190,N],[12,"errors","","",190,N],[5,"check_crate","","",N,[[["map"]]]],[11,"new_inner_visitor","","",190,[[["self"],["map"]],["hiridvalidator"]]],[11,"visit_item","","",190,[[["self"],["item"]]]],[11,"visit_trait_item","","",190,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",190,[[["self"],["implitem"]]]],[11,"check","","",189,[[["self"],["nodeid"],["f"]]]],[11,"nested_visit_map","","",189,[[["self"]],["nestedvisitormap"]]],[11,"visit_id","","",189,[[["self"],["nodeid"]]]],[11,"visit_impl_item_ref","","",189,[[["self"],["implitemref"]]]],[17,"ITEM_LIKE_SPACE","rustc::hir::map","",N,N],[17,"REGULAR_SPACE","","",N,N],[8,"Named","","",N,N],[10,"name","","",191,[[["self"]],["name"]]],[11,"clone","","",172,[[["self"]],["node"]]],[11,"fmt","","",172,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",173,[[["self"],["formatter"]],["result"]]],[11,"clone","","",173,[[["self"]],["mapentry"]]],[11,"parent_node","","",173,[[["self"]],["option",["nodeid"]]]],[11,"to_node","","",173,[[["self"]],["option",["node"]]]],[11,"fn_decl","","",173,[[["self"]],["option",["fndecl"]]]],[11,"associated_body","","",173,[[["self"]],["option",["bodyid"]]]],[11,"is_body_owner","","",173,[[["self"],["nodeid"]],["bool"]]],[11,"new","","",169,[[["crate"],["depgraph"]],["forest"]]],[11,"krate","","",169,[[["self"]],["crate"]]],[11,"clone","","",170,[[["self"]],["map"]]],[11,"read","","Registers a read in the dependency graph of the AST node with the given `id`. This needs to be called each time a public function returns the HIR for a node -- in other words, when it \"reveals\" the content of a node to the caller (who might not otherwise have had access to those contents, and hence needs a read recorded). If the function just returns a DefId or NodeId, no actual content was returned, so no read is needed.",170,[[["self"],["nodeid"]]]],[11,"definitions","","",170,[[["self"]],["definitions"]]],[11,"def_key","","",170,[[["self"],["defid"]],["defkey"]]],[11,"def_path_from_id","","",170,[[["self"],["nodeid"]],["option",["defpath"]]]],[11,"def_path","","",170,[[["self"],["defid"]],["defpath"]]],[11,"local_def_id","","",170,[[["self"],["nodeid"]],["defid"]]],[11,"opt_local_def_id","","",170,[[["self"],["nodeid"]],["option",["defid"]]]],[11,"as_local_node_id","","",170,[[["self"],["defid"]],["option",["nodeid"]]]],[11,"hir_to_node_id","","",170,[[["self"],["hirid"]],["nodeid"]]],[11,"node_to_hir_id","","",170,[[["self"],["nodeid"]],["hirid"]]],[11,"def_index_to_hir_id","","",170,[[["self"],["defindex"]],["hirid"]]],[11,"def_index_to_node_id","","",170,[[["self"],["defindex"]],["nodeid"]]],[11,"local_def_id_to_hir_id","","",170,[[["self"],["localdefid"]],["hirid"]]],[11,"local_def_id_to_node_id","","",170,[[["self"],["localdefid"]],["nodeid"]]],[11,"describe_def","","",170,[[["self"],["nodeid"]],["option",["def"]]]],[11,"entry_count","","",170,[[["self"]],["usize"]]],[11,"find_entry","","",170,[[["self"],["nodeid"]],["option",["mapentry"]]]],[11,"krate","","",170,[[["self"]],["crate"]]],[11,"trait_item","","",170,[[["self"],["traititemid"]],["traititem"]]],[11,"impl_item","","",170,[[["self"],["implitemid"]],["implitem"]]],[11,"body","","",170,[[["self"],["bodyid"]],["body"]]],[11,"fn_decl","","",170,[[["self"],["nodeid"]],["option",["fndecl"]]]],[11,"body_owner","","Returns the `NodeId` that corresponds to the definition of which this is the body of, i.e. a `fn`, `const` or `static` item (possibly associated), a closure, or a `hir::AnonConst`.",170,[[["self"],["bodyid"]],["nodeid"]]],[11,"body_owner_def_id","","",170,[[["self"],["bodyid"]],["defid"]]],[11,"maybe_body_owned_by","","Given a node id, returns the `BodyId` associated with it, if the node is a body owner, otherwise returns `None`.",170,[[["self"],["nodeid"]],["option",["bodyid"]]]],[11,"body_owned_by","","Given a body owner's id, returns the `BodyId` associated with it.",170,[[["self"],["nodeid"]],["bodyid"]]],[11,"body_owner_kind","","",170,[[["self"],["nodeid"]],["bodyownerkind"]]],[11,"ty_param_owner","","",170,[[["self"],["nodeid"]],["nodeid"]]],[11,"ty_param_name","","",170,[[["self"],["nodeid"]],["name"]]],[11,"trait_impls","","",170,N],[11,"trait_auto_impl","","",170,[[["self"],["defid"]],["option",["nodeid"]]]],[11,"trait_is_auto","","",170,[[["self"],["defid"]],["bool"]]],[11,"krate_attrs","","Get the attributes on the krate. This is preferable to invoking `krate.attrs` because it registers a tighter dep-graph access.",170,N],[11,"get","","Retrieve the Node corresponding to `id`, panicking if it cannot be found.",170,[[["self"],["nodeid"]],["node"]]],[11,"get_if_local","","",170,[[["self"],["defid"]],["option",["node"]]]],[11,"get_generics","","",170,[[["self"],["defid"]],["option",["generics"]]]],[11,"get_generics_span","","",170,[[["self"],["defid"]],["option",["span"]]]],[11,"find","","Retrieve the Node corresponding to `id`, returning None if cannot be found.",170,[[["self"],["nodeid"]],["option",["node"]]]],[11,"get_parent_node","","Similar to get_parent, returns the parent node id or id if there is no parent. Note that the parent may be CRATE_NODE_ID, which is not itself present in the map -- so passing the return value of get_parent_node to get may actually panic. This function returns the immediate parent in the AST, whereas get_parent returns the enclosing item. Note that this might not be the actual parent node in the AST - some kinds of nodes are not in the map and these will never appear as the parent_node. So you can always walk the parent_nodes from a node to the root of the ast (unless you get the same id back here that can happen if the id is not in the map itself or is just weird).",170,[[["self"],["nodeid"]],["nodeid"]]],[11,"is_argument","","Check if the node is an argument. An argument is a local variable whose immediate parent is an item or a closure.",170,[[["self"],["nodeid"]],["bool"]]],[11,"walk_parent_nodes","","If there is some error when walking the parents (e.g., a node does not have a parent in the map or a node can't be found), then we return the last good node id we found. Note that reaching the crate root (id == 0), is not an error, since items in the crate module have the crate root as parent.",170,[[["self"],["nodeid"],["f"],["f2"]],["result",["nodeid","nodeid"]]]],[11,"get_return_block","","Retrieve the NodeId for `id`'s enclosing method, unless there's a `while` or `loop` before reaching it, as block tail returns are not available in them.",170,[[["self"],["nodeid"]],["option",["nodeid"]]]],[11,"get_parent","","Retrieve the NodeId for `id`'s parent item, or `id` itself if no parent item is in this map. The \"parent item\" is the closest parent node in the HIR which is recorded by the map and is an item, either an item in a module, trait, or impl.",170,[[["self"],["nodeid"]],["nodeid"]]],[11,"get_module_parent","","Returns the NodeId of `id`'s nearest module parent, or `id` itself if no module parent is in this map.",170,[[["self"],["nodeid"]],["defid"]]],[11,"get_enclosing_scope","","Returns the nearest enclosing scope. A scope is an item or block. FIXME it is not clear to me that all items qualify as scopes - statics and associated types probably shouldn't, for example. Behavior in this regard should be expected to be highly unstable.",170,[[["self"],["nodeid"]],["option",["nodeid"]]]],[11,"get_parent_did","","",170,[[["self"],["nodeid"]],["defid"]]],[11,"get_foreign_abi","","",170,[[["self"],["nodeid"]],["abi"]]],[11,"expect_item","","",170,[[["self"],["nodeid"]],["item"]]],[11,"expect_impl_item","","",170,[[["self"],["nodeid"]],["implitem"]]],[11,"expect_trait_item","","",170,[[["self"],["nodeid"]],["traititem"]]],[11,"expect_variant_data","","",170,[[["self"],["nodeid"]],["variantdata"]]],[11,"expect_variant","","",170,[[["self"],["nodeid"]],["variant"]]],[11,"expect_foreign_item","","",170,[[["self"],["nodeid"]],["foreignitem"]]],[11,"expect_expr","","",170,[[["self"],["nodeid"]],["expr"]]],[11,"name","","Returns the name associated with the given NodeId's AST.",170,[[["self"],["nodeid"]],["name"]]],[11,"attrs","","Given a node ID, get a list of attributes associated with the AST corresponding to the Node ID",170,N],[11,"nodes_matching_suffix","","Returns an iterator that yields the node id's with paths that match `parts`.  (Requires `parts` is non-empty.)",170,N],[11,"span","","",170,[[["self"],["nodeid"]],["span"]]],[11,"span_if_local","","",170,[[["self"],["defid"]],["option",["span"]]]],[11,"node_to_string","","",170,[[["self"],["nodeid"]],["string"]]],[11,"node_to_user_string","","",170,[[["self"],["nodeid"]],["string"]]],[11,"node_to_pretty_string","","",170,[[["self"],["nodeid"]],["string"]]],[11,"suffix_matches","","Returns true only if some suffix of the module path for parent matches `self.in_which`.",171,[[["self"],["nodeid"]],["bool"]]],[11,"matches_names","","",171,[[["self"],["nodeid"],["name"]],["bool"]]],[11,"next","","",171,[[["self"]],["option",["nodeid"]]]],[11,"name","rustc::hir","",83,[[["self"]],["name"]]],[11,"name","","",87,[[["self"]],["name"]]],[11,"name","","",78,[[["self"]],["name"]]],[11,"name","","",81,[[["self"]],["name"]]],[11,"name","","",63,[[["self"]],["name"]]],[11,"name","","",65,[[["self"]],["name"]]],[11,"nested","rustc::hir::map","",170,[[["self"],["state"],["nested"]],["result"]]],[0,"pat_util","rustc::hir","",N,N],[3,"EnumerateAndAdjust","rustc::hir::pat_util","",N,N],[12,"enumerate","","",192,N],[12,"gap_pos","","",192,N],[12,"gap_len","","",192,N],[8,"EnumerateAndAdjustIterator","","",N,N],[10,"enumerate_and_adjust","","",193,[[["self"],["usize"],["option",["usize"]]],["enumerateandadjust"]]],[11,"next","","",192,[[["self"]],["option"]]],[11,"size_hint","","",192,N],[11,"is_refutable","rustc::hir","",50,[[["self"]],["bool"]]],[11,"is_const","","",50,[[["self"]],["bool"]]],[11,"each_binding","","Call `f` on every \"binding\" in a pattern, e.g., on `a` in `match foo() { Some(a) => (), None => () }`",50,[[["self"],["f"]]]],[11,"contains_bindings","","Checks if the pattern contains any patterns that bind something to an ident, e.g. `foo`, or `Foo(foo)` or `foo @ Bar(..)`.",50,[[["self"]],["bool"]]],[11,"contains_bindings_or_wild","","Checks if the pattern contains any patterns that bind something to an ident or wildcard, e.g. `foo`, or `Foo(_)`, `foo @ Bar(..)`,",50,[[["self"]],["bool"]]],[11,"simple_ident","","",50,[[["self"]],["option",["ident"]]]],[11,"necessary_variants","","Return variants that are necessary to exist for the pattern to match.",50,[[["self"]],["vec",["defid"]]]],[11,"contains_explicit_ref_binding","","Checks if the pattern contains any `ref` or `ref mut` bindings, and if yes whether it contains mutable or just immutables ones.",50,[[["self"]],["option",["mutability"]]]],[11,"contains_explicit_ref_binding","","Checks if the patterns for this arm contain any `ref` or `ref mut` bindings, and if yes whether its containing mutable ones or just immutables ones.",53,[[["self"]],["option",["mutability"]]]],[0,"print","","",N,N],[3,"NoAnn","rustc::hir::print","",N,N],[3,"State","","",N,N],[12,"s","","",194,N],[12,"cm","","",194,N],[12,"comments","","",194,N],[12,"literals","","",194,N],[12,"cur_cmnt","","",194,N],[12,"boxes","","",194,N],[12,"ann","","",194,N],[4,"AnnNode","","",N,N],[13,"NodeName","","",195,N],[13,"NodeBlock","","",195,N],[13,"NodeItem","","",195,N],[13,"NodeSubItem","","",195,N],[13,"NodeExpr","","",195,N],[13,"NodePat","","",195,N],[4,"Nested","","",N,N],[13,"Item","","",196,N],[13,"TraitItem","","",196,N],[13,"ImplItem","","",196,N],[13,"Body","","",196,N],[13,"BodyArgPat","","",196,N],[5,"print_crate","","Requires you to pass an input filename and reader so that it can scan the input text for comments and literals to copy forward.",N,[[["codemap"],["parsesess"],["crate"],["filename"],["read"],["box",["write"]],["ppann"],["bool"]],["result"]]],[5,"to_string","","",N,[[["ppann"],["f"]],["string"]]],[5,"visibility_qualified","","",N,[[["visibility"],["str"]],["string"]]],[5,"expr_requires_semi_to_be_stmt","","Does this expression require a semicolon to be treated as a statement? The negation of this: 'can this expression be used as a statement without a semicolon' -- is used as an early-bail-out in the parser so that, for instance,     if true {...} else {...}      |x| 5 isn't parsed as (if true {...} else {...} | x) | 5",N,[[["expr"]],["bool"]]],[5,"stmt_ends_with_semi","","this statement requires a semicolon after it. note that in one case (stmt_semi), we've already seen the semicolon, and thus don't need another.",N,[[["stmtkind"]],["bool"]]],[5,"bin_op_to_assoc_op","","",N,[[["binopkind"]],["assocop"]]],[5,"contains_exterior_struct_lit","","Expressions that syntactically contain an \"exterior\" struct literal i.e. not surrounded by any parens or other delimiters, e.g. `X { y: 1 }`, `X { y: 1 }.method()`, `foo == X { y: 1 }` and `X { y: 1 } == foo` all do, but `(X { y: 1 }) == foo` does not.",N,[[["expr"]],["bool"]]],[17,"NO_ANN","","",N,N],[17,"indent_unit","","",N,N],[17,"default_columns","","",N,N],[8,"PpAnn","","",N,N],[11,"nested","","",197,[[["self"],["state"],["nested"]],["result"]]],[11,"pre","","",197,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",197,[[["self"],["state"],["annnode"]],["result"]]],[11,"try_fetch_item","","",197,[[["self"],["nodeid"]],["option",["item"]]]],[11,"try_fetch_item","rustc::hir","",47,[[["self"],["nodeid"]],["option",["item"]]]],[11,"nested","","",47,[[["self"],["state"],["nested"]],["result"]]],[11,"writer","rustc::hir::print","",194,[[["self"]],["printer"]]],[11,"boxes","","",194,[[["self"]],["vec"]]],[11,"comments","","",194,[[["self"]],["option"]]],[11,"cur_cmnt","","",194,[[["self"]],["usize"]]],[11,"cur_lit","","",194,[[["self"]],["option",["literal"]]]],[11,"bump_lit","","",194,[[["self"]],["option",["literal"]]]],[11,"new_from_input","","",194,[[["codemap"],["parsesess"],["filename"],["read"],["box",["write"]],["ppann"],["bool"]],["state"]]],[11,"new","","",194,[[["codemap"],["box",["write"]],["ppann"],["option",["vec"]],["option",["vec"]]],["state"]]],[11,"cbox","","",194,[[["self"],["usize"]],["result"]]],[11,"nbsp","","",194,[[["self"]],["result"]]],[11,"word_nbsp","","",194,[[["self"],["str"]],["result"]]],[11,"head","","",194,[[["self"],["str"]],["result"]]],[11,"bopen","","",194,[[["self"]],["result"]]],[11,"bclose_","","",194,[[["self"],["span"],["usize"]],["result"]]],[11,"bclose_maybe_open","","",194,[[["self"],["span"],["usize"],["bool"]],["result"]]],[11,"bclose","","",194,[[["self"],["span"]],["result"]]],[11,"in_cbox","","",194,[[["self"]],["bool"]]],[11,"space_if_not_bol","","",194,[[["self"]],["result"]]],[11,"break_offset_if_not_bol","","",194,[[["self"],["usize"],["isize"]],["result"]]],[11,"synth_comment","","",194,[[["self"],["string"]],["result"]]],[11,"commasep_cmnt","","",194,N],[11,"commasep_exprs","","",194,N],[11,"print_mod","","",194,N],[11,"print_foreign_mod","","",194,N],[11,"print_opt_lifetime","","",194,[[["self"],["lifetime"]],["result"]]],[11,"print_type","","",194,[[["self"],["ty"]],["result"]]],[11,"print_foreign_item","","",194,[[["self"],["foreignitem"]],["result"]]],[11,"print_associated_const","","",194,[[["self"],["ident"],["ty"],["option",["bodyid"]],["visibility"]],["result"]]],[11,"print_associated_type","","",194,[[["self"],["ident"],["option",["genericbounds"]],["option",["ty"]]],["result"]]],[11,"print_item","","Pretty-print an item",194,[[["self"],["item"]],["result"]]],[11,"print_trait_ref","","",194,[[["self"],["traitref"]],["result"]]],[11,"print_formal_generic_params","","",194,N],[11,"print_poly_trait_ref","","",194,[[["self"],["polytraitref"]],["result"]]],[11,"print_enum_def","","",194,[[["self"],["enumdef"],["generics"],["name"],["span"],["visibility"]],["result"]]],[11,"print_variants","","",194,N],[11,"print_visibility","","",194,[[["self"],["visibility"]],["result"]]],[11,"print_defaultness","","",194,[[["self"],["defaultness"]],["result"]]],[11,"print_struct","","",194,[[["self"],["variantdata"],["generics"],["name"],["span"],["bool"]],["result"]]],[11,"print_variant","","",194,[[["self"],["variant"]],["result"]]],[11,"print_method_sig","","",194,N],[11,"print_trait_item","","",194,[[["self"],["traititem"]],["result"]]],[11,"print_impl_item","","",194,[[["self"],["implitem"]],["result"]]],[11,"print_stmt","","",194,[[["self"],["stmt"]],["result"]]],[11,"print_block","","",194,[[["self"],["block"]],["result"]]],[11,"print_block_unclosed","","",194,[[["self"],["block"]],["result"]]],[11,"print_block_unclosed_indent","","",194,[[["self"],["block"],["usize"]],["result"]]],[11,"print_block_with_attrs","","",194,N],[11,"print_block_maybe_unclosed","","",194,N],[11,"print_else","","",194,[[["self"],["option",["expr"]]],["result"]]],[11,"print_if","","",194,[[["self"],["expr"],["expr"],["option",["expr"]]],["result"]]],[11,"print_if_let","","",194,[[["self"],["pat"],["expr"],["block"],["option",["expr"]]],["result"]]],[11,"print_anon_const","","",194,[[["self"],["anonconst"]],["result"]]],[11,"print_call_post","","",194,N],[11,"print_expr_maybe_paren","","",194,[[["self"],["expr"],["i8"]],["result"]]],[11,"print_expr_as_cond","","Print an expr using syntax that's acceptable in a condition position, such as the `cond` in `if cond { ... }`.",194,[[["self"],["expr"]],["result"]]],[11,"print_expr_vec","","",194,N],[11,"print_expr_repeat","","",194,[[["self"],["expr"],["anonconst"]],["result"]]],[11,"print_expr_struct","","",194,N],[11,"print_expr_tup","","",194,N],[11,"print_expr_call","","",194,N],[11,"print_expr_method_call","","",194,N],[11,"print_expr_binary","","",194,[[["self"],["binop"],["expr"],["expr"]],["result"]]],[11,"print_expr_unary","","",194,[[["self"],["unop"],["expr"]],["result"]]],[11,"print_expr_addr_of","","",194,[[["self"],["mutability"],["expr"]],["result"]]],[11,"print_expr","","",194,[[["self"],["expr"]],["result"]]],[11,"print_local_decl","","",194,[[["self"],["local"]],["result"]]],[11,"print_decl","","",194,[[["self"],["decl"]],["result"]]],[11,"print_usize","","",194,[[["self"],["usize"]],["result"]]],[11,"print_ident","","",194,[[["self"],["ident"]],["result"]]],[11,"print_name","","",194,[[["self"],["name"]],["result"]]],[11,"print_for_decl","","",194,[[["self"],["local"],["expr"]],["result"]]],[11,"print_path","","",194,[[["self"],["path"],["bool"]],["result"]]],[11,"print_qpath","","",194,[[["self"],["qpath"],["bool"]],["result"]]],[11,"print_generic_args","","",194,[[["self"],["genericargs"],["bool"],["bool"]],["result"]]],[11,"print_pat","","",194,[[["self"],["pat"]],["result"]]],[11,"print_arm","","",194,[[["self"],["arm"]],["result"]]],[11,"print_fn","","",194,N],[11,"print_closure_args","","",194,[[["self"],["fndecl"],["bodyid"]],["result"]]],[11,"print_capture_clause","","",194,[[["self"],["captureclause"]],["result"]]],[11,"print_bounds","","",194,N],[11,"print_generic_params","","",194,N],[11,"print_generic_param","","",194,[[["self"],["genericparam"]],["result"]]],[11,"print_lifetime","","",194,[[["self"],["lifetime"]],["result"]]],[11,"print_where_clause","","",194,[[["self"],["whereclause"]],["result"]]],[11,"print_mutability","","",194,[[["self"],["mutability"]],["result"]]],[11,"print_mt","","",194,[[["self"],["mutty"]],["result"]]],[11,"print_fn_output","","",194,[[["self"],["fndecl"]],["result"]]],[11,"print_ty_fn","","",194,N],[11,"maybe_print_trailing_comment","","",194,[[["self"],["span"],["option",["bytepos"]]],["result"]]],[11,"print_remaining_comments","","",194,[[["self"]],["result"]]],[11,"print_opt_abi_and_extern_if_nondefault","","",194,[[["self"],["option",["abi"]]],["result"]]],[11,"print_extern_opt_abi","","",194,[[["self"],["option",["abi"]]],["result"]]],[11,"print_fn_header_info","","",194,[[["self"],["fnheader"],["visibility"]],["result"]]],[11,"print_unsafety","","",194,[[["self"],["unsafety"]],["result"]]],[11,"print_is_auto","","",194,[[["self"],["isauto"]],["result"]]],[0,"svh","rustc::hir","Calculation and management of a Strict Version Hash for crates",N,N],[3,"Svh","rustc::hir::svh","",N,N],[12,"hash","","",198,N],[11,"clone","","",198,[[["self"]],["svh"]]],[11,"eq","","",198,[[["self"],["svh"]],["bool"]]],[11,"ne","","",198,[[["self"],["svh"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",198,N],[11,"fmt","","",198,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `Svh` given the hash. If you actually want to compute the SVH from some HIR, you want the `calculate_svh` function found in `librustc_incremental`.",198,[[["u64"]],["svh"]]],[11,"as_u64","","",198,[[["self"]],["u64"]]],[11,"to_string","","",198,[[["self"]],["string"]]],[11,"hash","","",198,[[["self"],["h"]]]],[11,"fmt","","",198,[[["self"],["formatter"]],["result"]]],[11,"encode","","",198,[[["self"],["s"]],["result"]]],[11,"decode","","",198,[[["d"]],["result",["svh"]]]],[11,"hash_stable","","",198,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[6,"HirVec","rustc::hir","HIR doesn't commit to a concrete storage type and has its own alias for a vector. It can be `Vec`, `P<[T]>` or potentially `Box<[T]>`, or some other container with similar behavior. Unlike AST, HIR is mostly a static structure, so we can use an owned slice instead of `Vec` to avoid keeping extra capacity.",N,N],[6,"GenericBounds","","",N,N],[6,"CrateConfig","","",N,N],[6,"BinOp","","",N,N],[6,"Stmt","","A statement",N,N],[6,"Decl","","",N,N],[6,"Variant","","",N,N],[6,"Visibility","","",N,N],[6,"FreevarMap","","",N,N],[6,"CaptureModeMap","","",N,N],[6,"TraitMap","","",N,N],[6,"GlobMap","","",N,N],[17,"CRATE_HIR_ID","","The `HirId` corresponding to CRATE_NODE_ID and CRATE_DEF_INDEX",N,N],[17,"DUMMY_HIR_ID","","",N,N],[17,"DUMMY_ITEM_LOCAL_ID","","",N,N],[11,"clone","","",33,[[["self"]],["hirid"]]],[11,"eq","","",33,[[["self"],["hirid"]],["bool"]]],[11,"ne","","",33,[[["self"],["hirid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",33,N],[11,"hash","","",33,N],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"owner_def_id","","",33,[[["self"]],["defid"]]],[11,"owner_local_def_id","","",33,[[["self"]],["localdefid"]]],[11,"default_encode","","",33,[[["self"],["s"]],["result"]]],[11,"default_decode","","",33,[[["d"]],["result",["hirid"]]]],[11,"clone","","",34,[[["self"]],["itemlocalid"]]],[11,"eq","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"ne","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",34,N],[11,"partial_cmp","","",34,[[["self"],["itemlocalid"]],["option",["ordering"]]]],[11,"lt","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"le","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"gt","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"ge","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"cmp","","",34,[[["self"],["itemlocalid"]],["ordering"]]],[11,"hash","","",34,N],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"encode","","",34,[[["self"],["__s"]],["result"]]],[11,"decode","","",34,[[["__d"]],["result",["itemlocalid"]]]],[11,"as_usize","","",34,[[["self"]],["usize"]]],[11,"new","","",34,[[["usize"]],["self"]]],[11,"index","","",34,[[["self"]],["usize"]]],[11,"clone","","",35,[[["self"]],["label"]]],[11,"encode","","",35,[[["self"],["__s"]],["result"]]],[11,"decode","","",35,[[["__d"]],["result",["label"]]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"clone","","",36,[[["self"]],["lifetime"]]],[11,"encode","","",36,[[["self"],["__s"]],["result"]]],[11,"decode","","",36,[[["__d"]],["result",["lifetime"]]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"clone","","",92,[[["self"]],["paramname"]]],[11,"eq","","",92,[[["self"],["paramname"]],["bool"]]],[11,"ne","","",92,[[["self"],["paramname"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",92,N],[11,"encode","","",92,[[["self"],["__s"]],["result"]]],[11,"decode","","",92,[[["__d"]],["result",["paramname"]]]],[11,"hash","","",92,N],[11,"ident","","",92,[[["self"]],["ident"]]],[11,"modern","","",92,[[["self"]],["paramname"]]],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[11,"clone","","",93,[[["self"]],["lifetimename"]]],[11,"eq","","",93,[[["self"],["lifetimename"]],["bool"]]],[11,"ne","","",93,[[["self"],["lifetimename"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",93,N],[11,"encode","","",93,[[["self"],["__s"]],["result"]]],[11,"decode","","",93,[[["__d"]],["result",["lifetimename"]]]],[11,"hash","","",93,N],[11,"ident","","",93,[[["self"]],["ident"]]],[11,"is_elided","","",93,[[["self"]],["bool"]]],[11,"is_static","","",93,[[["self"]],["bool"]]],[11,"modern","","",93,[[["self"]],["lifetimename"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"is_elided","","",36,[[["self"]],["bool"]]],[11,"is_static","","",36,[[["self"]],["bool"]]],[11,"clone","","",37,[[["self"]],["path"]]],[11,"encode","","",37,[[["self"],["__s"]],["result"]]],[11,"decode","","",37,[[["__d"]],["result",["path"]]]],[11,"is_global","","",37,[[["self"]],["bool"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"clone","","",38,[[["self"]],["pathsegment"]]],[11,"encode","","",38,[[["self"],["__s"]],["result"]]],[11,"decode","","",38,[[["__d"]],["result",["pathsegment"]]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"from_ident","","Convert an identifier to the corresponding segment.",38,[[["ident"]],["pathsegment"]]],[11,"new","","",38,[[["ident"],["genericargs"],["bool"]],["self"]]],[11,"with_generic_args","","",38,[[["self"],["f"]],["r"]]],[11,"clone","","",94,[[["self"]],["genericarg"]]],[11,"encode","","",94,[[["self"],["__s"]],["result"]]],[11,"decode","","",94,[[["__d"]],["result",["genericarg"]]]],[11,"fmt","","",94,[[["self"],["formatter"]],["result"]]],[11,"span","","",94,[[["self"]],["span"]]],[11,"clone","","",39,[[["self"]],["genericargs"]]],[11,"encode","","",39,[[["self"],["__s"]],["result"]]],[11,"decode","","",39,[[["__d"]],["result",["genericargs"]]]],[11,"fmt","","",39,[[["self"],["formatter"]],["result"]]],[11,"none","","",39,[[],["self"]]],[11,"is_empty","","",39,[[["self"]],["bool"]]],[11,"inputs","","",39,N],[11,"clone","","",95,[[["self"]],["traitboundmodifier"]]],[11,"eq","","",95,[[["self"],["traitboundmodifier"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",95,N],[11,"encode","","",95,[[["self"],["__s"]],["result"]]],[11,"decode","","",95,[[["__d"]],["result",["traitboundmodifier"]]]],[11,"hash","","",95,N],[11,"fmt","","",95,[[["self"],["formatter"]],["result"]]],[11,"clone","","",96,[[["self"]],["genericbound"]]],[11,"encode","","",96,[[["self"],["__s"]],["result"]]],[11,"decode","","",96,[[["__d"]],["result",["genericbound"]]]],[11,"fmt","","",96,[[["self"],["formatter"]],["result"]]],[11,"span","","",96,[[["self"]],["span"]]],[11,"clone","","",97,[[["self"]],["genericparamkind"]]],[11,"encode","","",97,[[["self"],["__s"]],["result"]]],[11,"decode","","",97,[[["__d"]],["result",["genericparamkind"]]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"clone","","",40,[[["self"]],["genericparam"]]],[11,"encode","","",40,[[["self"],["__s"]],["result"]]],[11,"decode","","",40,[[["__d"]],["result",["genericparam"]]]],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"clone","","",42,[[["self"]],["generics"]]],[11,"encode","","",42,[[["self"],["__s"]],["result"]]],[11,"decode","","",42,[[["__d"]],["result",["generics"]]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"empty","","",42,[[],["generics"]]],[11,"own_counts","","",42,[[["self"]],["genericparamcount"]]],[11,"get_named","","",42,[[["self"],["internedstring"]],["option",["genericparam"]]]],[11,"clone","","",98,[[["self"]],["synthetictyparamkind"]]],[11,"eq","","",98,[[["self"],["synthetictyparamkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",98,N],[11,"encode","","",98,[[["self"],["__s"]],["result"]]],[11,"decode","","",98,[[["__d"]],["result",["synthetictyparamkind"]]]],[11,"hash","","",98,N],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[11,"clone","","",43,[[["self"]],["whereclause"]]],[11,"encode","","",43,[[["self"],["__s"]],["result"]]],[11,"decode","","",43,[[["__d"]],["result",["whereclause"]]]],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"span","","",43,[[["self"]],["option",["span"]]]],[11,"clone","","",99,[[["self"]],["wherepredicate"]]],[11,"encode","","",99,[[["self"],["__s"]],["result"]]],[11,"decode","","",99,[[["__d"]],["result",["wherepredicate"]]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result"]]],[11,"span","","",99,[[["self"]],["span"]]],[11,"clone","","",44,[[["self"]],["whereboundpredicate"]]],[11,"encode","","",44,[[["self"],["__s"]],["result"]]],[11,"decode","","",44,[[["__d"]],["result",["whereboundpredicate"]]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"clone","","",45,[[["self"]],["whereregionpredicate"]]],[11,"encode","","",45,[[["self"],["__s"]],["result"]]],[11,"decode","","",45,[[["__d"]],["result",["whereregionpredicate"]]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"clone","","",46,[[["self"]],["whereeqpredicate"]]],[11,"encode","","",46,[[["self"],["__s"]],["result"]]],[11,"decode","","",46,[[["__d"]],["result",["whereeqpredicate"]]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"clone","","",47,[[["self"]],["crate"]]],[11,"encode","","",47,[[["self"],["__s"]],["result"]]],[11,"decode","","",47,[[["__d"]],["result",["crate"]]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"item","","",47,[[["self"],["nodeid"]],["item"]]],[11,"trait_item","","",47,[[["self"],["traititemid"]],["traititem"]]],[11,"impl_item","","",47,[[["self"],["implitemid"]],["implitem"]]],[11,"visit_all_item_likes","","Visits all items in the crate in some deterministic (but unspecified) order. If you just need to process every item, but don't care about nesting, this method is the best choice.",47,[[["self"],["v"]]]],[11,"par_visit_all_item_likes","","A parallel version of visit_all_item_likes",47,[[["self"],["v"]]]],[11,"body","","",47,[[["self"],["bodyid"]],["body"]]],[11,"clone","","",48,[[["self"]],["macrodef"]]],[11,"encode","","",48,[[["self"],["__s"]],["result"]]],[11,"decode","","",48,[[["__d"]],["result",["macrodef"]]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"clone","","",49,[[["self"]],["block"]]],[11,"encode","","",49,[[["self"],["__s"]],["result"]]],[11,"decode","","",49,[[["__d"]],["result",["block"]]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"clone","","",50,[[["self"]],["pat"]]],[11,"encode","","",50,[[["self"],["__s"]],["result"]]],[11,"decode","","",50,[[["__d"]],["result",["pat"]]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"walk_","","",50,[[["self"],["g"]],["bool"]]],[11,"walk","","",50,[[["self"],["f"]],["bool"]]],[11,"clone","","",51,[[["self"]],["fieldpat"]]],[11,"encode","","",51,[[["self"],["__s"]],["result"]]],[11,"decode","","",51,[[["__d"]],["result",["fieldpat"]]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"clone","","",100,[[["self"]],["bindingannotation"]]],[11,"eq","","",100,[[["self"],["bindingannotation"]],["bool"]]],[11,"encode","","",100,[[["self"],["__s"]],["result"]]],[11,"decode","","",100,[[["__d"]],["result",["bindingannotation"]]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result"]]],[11,"clone","","",101,[[["self"]],["rangeend"]]],[11,"eq","","",101,[[["self"],["rangeend"]],["bool"]]],[11,"encode","","",101,[[["self"],["__s"]],["result"]]],[11,"decode","","",101,[[["__d"]],["result",["rangeend"]]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"clone","","",102,[[["self"]],["patkind"]]],[11,"encode","","",102,[[["self"],["__s"]],["result"]]],[11,"decode","","",102,[[["__d"]],["result",["patkind"]]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"clone","","",103,[[["self"]],["mutability"]]],[11,"eq","","",103,[[["self"],["mutability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",103,N],[11,"partial_cmp","","",103,[[["self"],["mutability"]],["option",["ordering"]]]],[11,"cmp","","",103,[[["self"],["mutability"]],["ordering"]]],[11,"encode","","",103,[[["self"],["__s"]],["result"]]],[11,"decode","","",103,[[["__d"]],["result",["mutability"]]]],[11,"hash","","",103,N],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[11,"and","","Return MutMutable only if both arguments are mutable.",103,[[["self"],["self"]],["self"]]],[11,"clone","","",104,[[["self"]],["binopkind"]]],[11,"eq","","",104,[[["self"],["binopkind"]],["bool"]]],[11,"encode","","",104,[[["self"],["__s"]],["result"]]],[11,"decode","","",104,[[["__d"]],["result",["binopkind"]]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"hash","","",104,N],[11,"as_str","","",104,[[["self"]],["str"]]],[11,"is_lazy","","",104,[[["self"]],["bool"]]],[11,"is_shift","","",104,[[["self"]],["bool"]]],[11,"is_comparison","","",104,[[["self"]],["bool"]]],[11,"is_by_value","","Returns `true` if the binary operator takes its arguments by value",104,[[["self"]],["bool"]]],[11,"into","","",104,[[["self"]],["binopkind"]]],[11,"clone","","",105,[[["self"]],["unop"]]],[11,"eq","","",105,[[["self"],["unop"]],["bool"]]],[11,"encode","","",105,[[["self"],["__s"]],["result"]]],[11,"decode","","",105,[[["__d"]],["result",["unop"]]]],[11,"fmt","","",105,[[["self"],["formatter"]],["result"]]],[11,"hash","","",105,N],[11,"as_str","","",105,[[["self"]],["str"]]],[11,"is_by_value","","Returns `true` if the unary operator takes its argument by value",105,[[["self"]],["bool"]]],[11,"fmt","","",106,[[["self"],["formatter"]],["result"]]],[11,"clone","","",106,[[["self"]],["stmtkind"]]],[11,"encode","","",106,[[["self"],["__s"]],["result"]]],[11,"decode","","",106,[[["__d"]],["result",["stmtkind"]]]],[11,"attrs","","",106,N],[11,"id","","",106,[[["self"]],["nodeid"]]],[11,"clone","","",52,[[["self"]],["local"]]],[11,"encode","","",52,[[["self"],["__s"]],["result"]]],[11,"decode","","",52,[[["__d"]],["result",["local"]]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"clone","","",107,[[["self"]],["declkind"]]],[11,"encode","","",107,[[["self"],["__s"]],["result"]]],[11,"decode","","",107,[[["__d"]],["result",["declkind"]]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[11,"attrs","","",107,N],[11,"is_local","","",107,[[["self"]],["bool"]]],[11,"clone","","",53,[[["self"]],["arm"]]],[11,"encode","","",53,[[["self"],["__s"]],["result"]]],[11,"decode","","",53,[[["__d"]],["result",["arm"]]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"clone","","",54,[[["self"]],["field"]]],[11,"encode","","",54,[[["self"],["__s"]],["result"]]],[11,"decode","","",54,[[["__d"]],["result",["field"]]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"clone","","",108,[[["self"]],["blockcheckmode"]]],[11,"eq","","",108,[[["self"],["blockcheckmode"]],["bool"]]],[11,"ne","","",108,[[["self"],["blockcheckmode"]],["bool"]]],[11,"encode","","",108,[[["self"],["__s"]],["result"]]],[11,"decode","","",108,[[["__d"]],["result",["blockcheckmode"]]]],[11,"fmt","","",108,[[["self"],["formatter"]],["result"]]],[11,"clone","","",109,[[["self"]],["unsafesource"]]],[11,"eq","","",109,[[["self"],["unsafesource"]],["bool"]]],[11,"encode","","",109,[[["self"],["__s"]],["result"]]],[11,"decode","","",109,[[["__d"]],["result",["unsafesource"]]]],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"clone","","",55,[[["self"]],["bodyid"]]],[11,"eq","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"ne","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",55,N],[11,"partial_cmp","","",55,[[["self"],["bodyid"]],["option",["ordering"]]]],[11,"lt","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"le","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"gt","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"ge","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"cmp","","",55,[[["self"],["bodyid"]],["ordering"]]],[11,"encode","","",55,[[["self"],["__s"]],["result"]]],[11,"decode","","",55,[[["__d"]],["result",["bodyid"]]]],[11,"hash","","",55,N],[11,"fmt","","",55,[[["self"],["formatter"]],["result"]]],[11,"clone","","",56,[[["self"]],["body"]]],[11,"encode","","",56,[[["self"],["__s"]],["result"]]],[11,"decode","","",56,[[["__d"]],["result",["body"]]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"id","","",56,[[["self"]],["bodyid"]]],[11,"clone","","",110,[[["self"]],["bodyownerkind"]]],[11,"fmt","","",110,[[["self"],["formatter"]],["result"]]],[11,"clone","","",57,[[["self"]],["anonconst"]]],[11,"eq","","",57,[[["self"],["anonconst"]],["bool"]]],[11,"ne","","",57,[[["self"],["anonconst"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",57,N],[11,"encode","","",57,[[["self"],["__s"]],["result"]]],[11,"decode","","",57,[[["__d"]],["result",["anonconst"]]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"clone","","",58,[[["self"]],["expr"]]],[11,"encode","","",58,[[["self"],["__s"]],["result"]]],[11,"decode","","",58,[[["__d"]],["result",["expr"]]]],[11,"precedence","","",58,[[["self"]],["exprprecedence"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[11,"clone","","",111,[[["self"]],["exprkind"]]],[11,"encode","","",111,[[["self"],["__s"]],["result"]]],[11,"decode","","",111,[[["__d"]],["result",["exprkind"]]]],[11,"fmt","","",111,[[["self"],["formatter"]],["result"]]],[11,"clone","","",112,[[["self"]],["qpath"]]],[11,"encode","","",112,[[["self"],["__s"]],["result"]]],[11,"decode","","",112,[[["__d"]],["result",["qpath"]]]],[11,"fmt","","",112,[[["self"],["formatter"]],["result"]]],[11,"clone","","",113,[[["self"]],["localsource"]]],[11,"encode","","",113,[[["self"],["__s"]],["result"]]],[11,"decode","","",113,[[["__d"]],["result",["localsource"]]]],[11,"fmt","","",113,[[["self"],["formatter"]],["result"]]],[11,"clone","","",114,[[["self"]],["matchsource"]]],[11,"eq","","",114,[[["self"],["matchsource"]],["bool"]]],[11,"ne","","",114,[[["self"],["matchsource"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",114,N],[11,"encode","","",114,[[["self"],["__s"]],["result"]]],[11,"decode","","",114,[[["__d"]],["result",["matchsource"]]]],[11,"hash","","",114,N],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"clone","","",115,[[["self"]],["loopsource"]]],[11,"eq","","",115,[[["self"],["loopsource"]],["bool"]]],[11,"encode","","",115,[[["self"],["__s"]],["result"]]],[11,"decode","","",115,[[["__d"]],["result",["loopsource"]]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",116,[[["self"]],["loopiderror"]]],[11,"encode","","",116,[[["self"],["__s"]],["result"]]],[11,"decode","","",116,[[["__d"]],["result",["loopiderror"]]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"clone","","",59,[[["self"]],["destination"]]],[11,"encode","","",59,[[["self"],["__s"]],["result"]]],[11,"decode","","",59,[[["__d"]],["result",["destination"]]]],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"clone","","",117,[[["self"]],["generatormovability"]]],[11,"eq","","",117,[[["self"],["generatormovability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",117,N],[11,"partial_cmp","","",117,[[["self"],["generatormovability"]],["option",["ordering"]]]],[11,"cmp","","",117,[[["self"],["generatormovability"]],["ordering"]]],[11,"encode","","",117,[[["self"],["__s"]],["result"]]],[11,"decode","","",117,[[["__d"]],["result",["generatormovability"]]]],[11,"hash","","",117,N],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"clone","","",118,[[["self"]],["captureclause"]]],[11,"encode","","",118,[[["self"],["__s"]],["result"]]],[11,"decode","","",118,[[["__d"]],["result",["captureclause"]]]],[11,"fmt","","",118,[[["self"],["formatter"]],["result"]]],[11,"clone","","",60,[[["self"]],["mutty"]]],[11,"encode","","",60,[[["self"],["__s"]],["result"]]],[11,"decode","","",60,[[["__d"]],["result",["mutty"]]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"clone","","",61,[[["self"]],["methodsig"]]],[11,"encode","","",61,[[["self"],["__s"]],["result"]]],[11,"decode","","",61,[[["__d"]],["result",["methodsig"]]]],[11,"fmt","","",61,[[["self"],["formatter"]],["result"]]],[11,"clone","","",62,[[["self"]],["traititemid"]]],[11,"eq","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"ne","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",62,N],[11,"partial_cmp","","",62,[[["self"],["traititemid"]],["option",["ordering"]]]],[11,"lt","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"le","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"gt","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"ge","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"cmp","","",62,[[["self"],["traititemid"]],["ordering"]]],[11,"encode","","",62,[[["self"],["__s"]],["result"]]],[11,"decode","","",62,[[["__d"]],["result",["traititemid"]]]],[11,"fmt","","",62,[[["self"],["formatter"]],["result"]]],[11,"clone","","",63,[[["self"]],["traititem"]]],[11,"encode","","",63,[[["self"],["__s"]],["result"]]],[11,"decode","","",63,[[["__d"]],["result",["traititem"]]]],[11,"fmt","","",63,[[["self"],["formatter"]],["result"]]],[11,"clone","","",119,[[["self"]],["traitmethod"]]],[11,"encode","","",119,[[["self"],["__s"]],["result"]]],[11,"decode","","",119,[[["__d"]],["result",["traitmethod"]]]],[11,"fmt","","",119,[[["self"],["formatter"]],["result"]]],[11,"clone","","",120,[[["self"]],["traititemkind"]]],[11,"encode","","",120,[[["self"],["__s"]],["result"]]],[11,"decode","","",120,[[["__d"]],["result",["traititemkind"]]]],[11,"fmt","","",120,[[["self"],["formatter"]],["result"]]],[11,"clone","","",64,[[["self"]],["implitemid"]]],[11,"eq","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"ne","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",64,N],[11,"partial_cmp","","",64,[[["self"],["implitemid"]],["option",["ordering"]]]],[11,"lt","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"le","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"gt","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"ge","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"cmp","","",64,[[["self"],["implitemid"]],["ordering"]]],[11,"encode","","",64,[[["self"],["__s"]],["result"]]],[11,"decode","","",64,[[["__d"]],["result",["implitemid"]]]],[11,"fmt","","",64,[[["self"],["formatter"]],["result"]]],[11,"clone","","",65,[[["self"]],["implitem"]]],[11,"encode","","",65,[[["self"],["__s"]],["result"]]],[11,"decode","","",65,[[["__d"]],["result",["implitem"]]]],[11,"fmt","","",65,[[["self"],["formatter"]],["result"]]],[11,"clone","","",121,[[["self"]],["implitemkind"]]],[11,"encode","","",121,[[["self"],["__s"]],["result"]]],[11,"decode","","",121,[[["__d"]],["result",["implitemkind"]]]],[11,"fmt","","",121,[[["self"],["formatter"]],["result"]]],[11,"clone","","",66,[[["self"]],["typebinding"]]],[11,"encode","","",66,[[["self"],["__s"]],["result"]]],[11,"decode","","",66,[[["__d"]],["result",["typebinding"]]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"clone","","",67,[[["self"]],["ty"]]],[11,"encode","","",67,[[["self"],["__s"]],["result"]]],[11,"decode","","",67,[[["__d"]],["result",["ty"]]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"clone","","",122,[[["self"]],["primty"]]],[11,"eq","","",122,[[["self"],["primty"]],["bool"]]],[11,"ne","","",122,[[["self"],["primty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",122,N],[11,"encode","","",122,[[["self"],["__s"]],["result"]]],[11,"decode","","",122,[[["__d"]],["result",["primty"]]]],[11,"hash","","",122,N],[11,"fmt","","",122,[[["self"],["formatter"]],["result"]]],[11,"clone","","",68,[[["self"]],["barefnty"]]],[11,"encode","","",68,[[["self"],["__s"]],["result"]]],[11,"decode","","",68,[[["__d"]],["result",["barefnty"]]]],[11,"fmt","","",68,[[["self"],["formatter"]],["result"]]],[11,"clone","","",69,[[["self"]],["existty"]]],[11,"encode","","",69,[[["self"],["__s"]],["result"]]],[11,"decode","","",69,[[["__d"]],["result",["existty"]]]],[11,"fmt","","",69,[[["self"],["formatter"]],["result"]]],[11,"clone","","",123,[[["self"]],["tykind"]]],[11,"encode","","",123,[[["self"],["__s"]],["result"]]],[11,"decode","","",123,[[["__d"]],["result",["tykind"]]]],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"clone","","",70,[[["self"]],["inlineasmoutput"]]],[11,"encode","","",70,[[["self"],["__s"]],["result"]]],[11,"decode","","",70,[[["__d"]],["result",["inlineasmoutput"]]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"clone","","",71,[[["self"]],["inlineasm"]]],[11,"encode","","",71,[[["self"],["__s"]],["result"]]],[11,"decode","","",71,[[["__d"]],["result",["inlineasm"]]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"clone","","",72,[[["self"]],["arg"]]],[11,"encode","","",72,[[["self"],["__s"]],["result"]]],[11,"decode","","",72,[[["__d"]],["result",["arg"]]]],[11,"fmt","","",72,[[["self"],["formatter"]],["result"]]],[11,"clone","","",73,[[["self"]],["fndecl"]]],[11,"encode","","",73,[[["self"],["__s"]],["result"]]],[11,"decode","","",73,[[["__d"]],["result",["fndecl"]]]],[11,"fmt","","",73,[[["self"],["formatter"]],["result"]]],[11,"clone","","",124,[[["self"]],["isauto"]]],[11,"eq","","",124,[[["self"],["isauto"]],["bool"]]],[11,"encode","","",124,[[["self"],["__s"]],["result"]]],[11,"decode","","",124,[[["__d"]],["result",["isauto"]]]],[11,"fmt","","",124,[[["self"],["formatter"]],["result"]]],[11,"clone","","",125,[[["self"]],["isasync"]]],[11,"eq","","",125,[[["self"],["isasync"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",125,N],[11,"partial_cmp","","",125,[[["self"],["isasync"]],["option",["ordering"]]]],[11,"cmp","","",125,[[["self"],["isasync"]],["ordering"]]],[11,"encode","","",125,[[["self"],["__s"]],["result"]]],[11,"decode","","",125,[[["__d"]],["result",["isasync"]]]],[11,"fmt","","",125,[[["self"],["formatter"]],["result"]]],[11,"clone","","",126,[[["self"]],["unsafety"]]],[11,"eq","","",126,[[["self"],["unsafety"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",126,N],[11,"partial_cmp","","",126,[[["self"],["unsafety"]],["option",["ordering"]]]],[11,"cmp","","",126,[[["self"],["unsafety"]],["ordering"]]],[11,"encode","","",126,[[["self"],["__s"]],["result"]]],[11,"decode","","",126,[[["__d"]],["result",["unsafety"]]]],[11,"hash","","",126,N],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"clone","","",127,[[["self"]],["constness"]]],[11,"eq","","",127,[[["self"],["constness"]],["bool"]]],[11,"encode","","",127,[[["self"],["__s"]],["result"]]],[11,"decode","","",127,[[["__d"]],["result",["constness"]]]],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"clone","","",128,[[["self"]],["defaultness"]]],[11,"eq","","",128,[[["self"],["defaultness"]],["bool"]]],[11,"ne","","",128,[[["self"],["defaultness"]],["bool"]]],[11,"encode","","",128,[[["self"],["__s"]],["result"]]],[11,"decode","","",128,[[["__d"]],["result",["defaultness"]]]],[11,"fmt","","",128,[[["self"],["formatter"]],["result"]]],[11,"has_value","","",128,[[["self"]],["bool"]]],[11,"is_final","","",128,[[["self"]],["bool"]]],[11,"is_default","","",128,[[["self"]],["bool"]]],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"clone","","",129,[[["self"]],["implpolarity"]]],[11,"eq","","",129,[[["self"],["implpolarity"]],["bool"]]],[11,"encode","","",129,[[["self"],["__s"]],["result"]]],[11,"decode","","",129,[[["__d"]],["result",["implpolarity"]]]],[11,"fmt","","",129,[[["self"],["formatter"]],["result"]]],[11,"clone","","",130,[[["self"]],["functionretty"]]],[11,"encode","","",130,[[["self"],["__s"]],["result"]]],[11,"decode","","",130,[[["__d"]],["result",["functionretty"]]]],[11,"fmt","","",130,[[["self"],["formatter"]],["result"]]],[11,"span","","",130,[[["self"]],["span"]]],[11,"clone","","",74,[[["self"]],["mod"]]],[11,"encode","","",74,[[["self"],["__s"]],["result"]]],[11,"decode","","",74,[[["__d"]],["result",["mod"]]]],[11,"fmt","","",74,[[["self"],["formatter"]],["result"]]],[11,"clone","","",75,[[["self"]],["foreignmod"]]],[11,"encode","","",75,[[["self"],["__s"]],["result"]]],[11,"decode","","",75,[[["__d"]],["result",["foreignmod"]]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"clone","","",76,[[["self"]],["globalasm"]]],[11,"encode","","",76,[[["self"],["__s"]],["result"]]],[11,"decode","","",76,[[["__d"]],["result",["globalasm"]]]],[11,"fmt","","",76,[[["self"],["formatter"]],["result"]]],[11,"clone","","",77,[[["self"]],["enumdef"]]],[11,"encode","","",77,[[["self"],["__s"]],["result"]]],[11,"decode","","",77,[[["__d"]],["result",["enumdef"]]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"clone","","",78,[[["self"]],["variantkind"]]],[11,"encode","","",78,[[["self"],["__s"]],["result"]]],[11,"decode","","",78,[[["__d"]],["result",["variantkind"]]]],[11,"fmt","","",78,[[["self"],["formatter"]],["result"]]],[11,"clone","","",131,[[["self"]],["usekind"]]],[11,"eq","","",131,[[["self"],["usekind"]],["bool"]]],[11,"encode","","",131,[[["self"],["__s"]],["result"]]],[11,"decode","","",131,[[["__d"]],["result",["usekind"]]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result"]]],[11,"clone","","",79,[[["self"]],["traitref"]]],[11,"encode","","",79,[[["self"],["__s"]],["result"]]],[11,"decode","","",79,[[["__d"]],["result",["traitref"]]]],[11,"fmt","","",79,[[["self"],["formatter"]],["result"]]],[11,"clone","","",80,[[["self"]],["polytraitref"]]],[11,"encode","","",80,[[["self"],["__s"]],["result"]]],[11,"decode","","",80,[[["__d"]],["result",["polytraitref"]]]],[11,"fmt","","",80,[[["self"],["formatter"]],["result"]]],[11,"clone","","",132,[[["self"]],["visibilitykind"]]],[11,"encode","","",132,[[["self"],["__s"]],["result"]]],[11,"decode","","",132,[[["__d"]],["result",["visibilitykind"]]]],[11,"fmt","","",132,[[["self"],["formatter"]],["result"]]],[11,"is_pub","","",132,[[["self"]],["bool"]]],[11,"is_pub_restricted","","",132,[[["self"]],["bool"]]],[11,"clone","","",81,[[["self"]],["structfield"]]],[11,"encode","","",81,[[["self"],["__s"]],["result"]]],[11,"decode","","",81,[[["__d"]],["result",["structfield"]]]],[11,"fmt","","",81,[[["self"],["formatter"]],["result"]]],[11,"is_positional","","",81,[[["self"]],["bool"]]],[11,"clone","","",133,[[["self"]],["variantdata"]]],[11,"encode","","",133,[[["self"],["__s"]],["result"]]],[11,"decode","","",133,[[["__d"]],["result",["variantdata"]]]],[11,"fmt","","",133,[[["self"],["formatter"]],["result"]]],[11,"fields","","",133,N],[11,"id","","",133,[[["self"]],["nodeid"]]],[11,"is_struct","","",133,[[["self"]],["bool"]]],[11,"is_tuple","","",133,[[["self"]],["bool"]]],[11,"is_unit","","",133,[[["self"]],["bool"]]],[11,"clone","","",82,[[["self"]],["itemid"]]],[11,"encode","","",82,[[["self"],["__s"]],["result"]]],[11,"decode","","",82,[[["__d"]],["result",["itemid"]]]],[11,"fmt","","",82,[[["self"],["formatter"]],["result"]]],[11,"clone","","",83,[[["self"]],["item"]]],[11,"encode","","",83,[[["self"],["__s"]],["result"]]],[11,"decode","","",83,[[["__d"]],["result",["item"]]]],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"clone","","",84,[[["self"]],["fnheader"]]],[11,"encode","","",84,[[["self"],["__s"]],["result"]]],[11,"decode","","",84,[[["__d"]],["result",["fnheader"]]]],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"clone","","",134,[[["self"]],["itemkind"]]],[11,"encode","","",134,[[["self"],["__s"]],["result"]]],[11,"decode","","",134,[[["__d"]],["result",["itemkind"]]]],[11,"fmt","","",134,[[["self"],["formatter"]],["result"]]],[11,"descriptive_variant","","",134,[[["self"]],["str"]]],[11,"adt_kind","","",134,[[["self"]],["option",["adtkind"]]]],[11,"generics","","",134,[[["self"]],["option",["generics"]]]],[11,"clone","","",85,[[["self"]],["traititemref"]]],[11,"encode","","",85,[[["self"],["__s"]],["result"]]],[11,"decode","","",85,[[["__d"]],["result",["traititemref"]]]],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"clone","","",86,[[["self"]],["implitemref"]]],[11,"encode","","",86,[[["self"],["__s"]],["result"]]],[11,"decode","","",86,[[["__d"]],["result",["implitemref"]]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"clone","","",135,[[["self"]],["associateditemkind"]]],[11,"eq","","",135,[[["self"],["associateditemkind"]],["bool"]]],[11,"ne","","",135,[[["self"],["associateditemkind"]],["bool"]]],[11,"encode","","",135,[[["self"],["__s"]],["result"]]],[11,"decode","","",135,[[["__d"]],["result",["associateditemkind"]]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result"]]],[11,"clone","","",87,[[["self"]],["foreignitem"]]],[11,"encode","","",87,[[["self"],["__s"]],["result"]]],[11,"decode","","",87,[[["__d"]],["result",["foreignitem"]]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[11,"clone","","",136,[[["self"]],["foreignitemkind"]]],[11,"encode","","",136,[[["self"],["__s"]],["result"]]],[11,"decode","","",136,[[["__d"]],["result",["foreignitemkind"]]]],[11,"fmt","","",136,[[["self"],["formatter"]],["result"]]],[11,"descriptive_variant","","",136,[[["self"]],["str"]]],[11,"fmt","","",88,[[["self"],["formatter"]],["result"]]],[11,"clone","","",88,[[["self"]],["freevar"]]],[11,"encode","","",88,[[["self"],["__s"]],["result"]]],[11,"decode","","",88,[[["__d"]],["result",["freevar"]]]],[11,"var_id","","",88,[[["self"]],["nodeid"]]],[11,"clone","","",89,[[["self"]],["traitcandidate"]]],[11,"fmt","","",89,[[["self"],["formatter"]],["result"]]],[11,"clone","","",90,[[["self"]],["codegenfnattrs"]]],[11,"encode","","",90,[[["self"],["__s"]],["result"]]],[11,"decode","","",90,[[["__d"]],["result",["codegenfnattrs"]]]],[11,"eq","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"ne","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",91,N],[11,"clone","","",91,[[["self"]],["codegenfnattrflags"]]],[11,"partial_cmp","","",91,[[["self"],["codegenfnattrflags"]],["option",["ordering"]]]],[11,"lt","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"le","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"gt","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"ge","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"cmp","","",91,[[["self"],["codegenfnattrflags"]],["ordering"]]],[11,"hash","","",91,N],[11,"encode","","",91,[[["self"],["__s"]],["result"]]],[11,"decode","","",91,[[["__d"]],["result",["codegenfnattrflags"]]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[18,"COLD","","",91,N],[18,"ALLOCATOR","","",91,N],[18,"UNWIND","","",91,N],[18,"RUSTC_ALLOCATOR_NOUNWIND","","",91,N],[18,"NAKED","","",91,N],[18,"NO_MANGLE","","",91,N],[18,"RUSTC_STD_INTERNAL_SYMBOL","","",91,N],[18,"NO_DEBUG","","",91,N],[18,"THREAD_LOCAL","","",91,N],[18,"USED","","",91,N],[11,"empty","","Returns an empty set of flags.",91,[[],["codegenfnattrflags"]]],[11,"all","","Returns the set containing all flags.",91,[[],["codegenfnattrflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",91,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",91,[[["u32"]],["option",["codegenfnattrflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",91,[[["u32"]],["codegenfnattrflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",91,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",91,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",91,[[["self"],["codegenfnattrflags"]]]],[11,"remove","","Removes the specified flags in-place.",91,[[["self"],["codegenfnattrflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",91,[[["self"],["codegenfnattrflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",91,[[["self"],["codegenfnattrflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",91,[[["self"],["codegenfnattrflags"]],["codegenfnattrflags"]]],[11,"bitor_assign","","Adds the set of flags.",91,[[["self"],["codegenfnattrflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",91,[[["self"],["codegenfnattrflags"]],["codegenfnattrflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",91,[[["self"],["codegenfnattrflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",91,[[["self"],["codegenfnattrflags"]],["codegenfnattrflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",91,[[["self"],["codegenfnattrflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",91,[[["self"],["codegenfnattrflags"]],["codegenfnattrflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",91,[[["self"],["codegenfnattrflags"]]]],[11,"not","","Returns the complement of this set of flags.",91,[[["self"]],["codegenfnattrflags"]]],[11,"extend","","",91,[[["self"],["t"]]]],[11,"from_iter","","",91,[[["t"]],["codegenfnattrflags"]]],[11,"new","","",90,[[],["codegenfnattrs"]]],[11,"requests_inline","","True if `#[inline]` or `#[inline(always)]` is present.",90,[[["self"]],["bool"]]],[11,"contains_extern_indicator","","True if `#[no_mangle]` or `#[export_name(...)]` is present.",90,[[["self"]],["bool"]]],[0,"ich","rustc","ICH - Incremental Compilation Hash",N,N],[3,"Fingerprint","rustc::ich","",N,N],[12,"0","","",199,N],[12,"1","","",199,N],[3,"CachingCodemapView","","",N,N],[12,"codemap","","",200,N],[12,"line_cache","","",200,N],[12,"time_stamp","","",200,N],[3,"StableHashingContext","","This is the context state available during incr. comp. hashing. It contains enough information to transform DefIds and HirIds into stable DefPaths (i.e. a reference to the TyCtxt) and it holds a few caches for speeding up various things (e.g. each DefId/DefPath is only hashed once).",N,N],[12,"sess","","",201,N],[12,"definitions","","",201,N],[12,"cstore","","",201,N],[12,"body_resolver","","",201,N],[12,"hash_spans","","",201,N],[12,"hash_bodies","","",201,N],[12,"node_id_hashing_mode","","",201,N],[12,"raw_codemap","","",201,N],[12,"caching_codemap","","",201,N],[12,"alloc_id_recursion_tracker","","",201,N],[4,"NodeIdHashingMode","","",N,N],[13,"Ignore","","",202,N],[13,"HashDefPath","","",202,N],[5,"hash_stable_trait_impls","","",N,N],[5,"compute_ignored_attr_names","","",N,[[],["fxhashset",["symbol"]]]],[0,"fingerprint","","",N,N],[3,"Fingerprint","rustc::ich::fingerprint","",N,N],[12,"0","","",199,N],[12,"1","","",199,N],[11,"assert_receiver_is_total_eq","rustc::ich","",199,N],[11,"eq","","",199,[[["self"],["fingerprint"]],["bool"]]],[11,"ne","","",199,[[["self"],["fingerprint"]],["bool"]]],[11,"cmp","","",199,[[["self"],["fingerprint"]],["ordering"]]],[11,"partial_cmp","","",199,[[["self"],["fingerprint"]],["option",["ordering"]]]],[11,"lt","","",199,[[["self"],["fingerprint"]],["bool"]]],[11,"le","","",199,[[["self"],["fingerprint"]],["bool"]]],[11,"gt","","",199,[[["self"],["fingerprint"]],["bool"]]],[11,"ge","","",199,[[["self"],["fingerprint"]],["bool"]]],[11,"hash","","",199,N],[11,"fmt","","",199,[[["self"],["formatter"]],["result"]]],[11,"clone","","",199,[[["self"]],["fingerprint"]]],[18,"ZERO","","",199,N],[11,"from_smaller_hash","","",199,[[["u64"]],["fingerprint"]]],[11,"to_smaller_hash","","",199,[[["self"]],["u64"]]],[11,"as_value","","",199,N],[11,"combine","","",199,[[["self"],["fingerprint"]],["fingerprint"]]],[11,"combine_commutative","","",199,[[["self"],["fingerprint"]],["fingerprint"]]],[11,"to_hex","","",199,[[["self"]],["string"]]],[11,"encode_opaque","","",199,[[["self"],["encoder"]],["encoderesult"]]],[11,"decode_opaque","","",199,[[["decoder"]],["result",["fingerprint","string"]]]],[11,"fmt","","",199,[[["self"],["formatter"]],["result"]]],[11,"finish","","",199,[[["stablehasher"]],["self"]]],[11,"hash_stable","","",199,[[["self"],["ctx"],["stablehasher"]]]],[0,"caching_codemap_view","","",N,N],[3,"CacheEntry","rustc::ich::caching_codemap_view","",N,N],[12,"time_stamp","","",203,N],[12,"line_number","","",203,N],[12,"line_start","","",203,N],[12,"line_end","","",203,N],[12,"file","","",203,N],[12,"file_index","","",203,N],[3,"CachingCodemapView","","",N,N],[12,"codemap","","",200,N],[12,"line_cache","","",200,N],[12,"time_stamp","","",200,N],[11,"clone","","",203,[[["self"]],["cacheentry"]]],[11,"clone","rustc::ich","",200,[[["self"]],["cachingcodemapview"]]],[11,"new","","",200,[[["codemap"]],["cachingcodemapview"]]],[11,"byte_pos_to_line_and_col","","",200,[[["self"],["bytepos"]],["option"]]],[0,"hcx","","",N,N],[3,"StableHashingContext","rustc::ich::hcx","This is the context state available during incr. comp. hashing. It contains enough information to transform DefIds and HirIds into stable DefPaths (i.e. a reference to the TyCtxt) and it holds a few caches for speeding up various things (e.g. each DefId/DefPath is only hashed once).",N,N],[12,"sess","","",201,N],[12,"definitions","","",201,N],[12,"cstore","","",201,N],[12,"body_resolver","","",201,N],[12,"hash_spans","","",201,N],[12,"hash_bodies","","",201,N],[12,"node_id_hashing_mode","","",201,N],[12,"raw_codemap","","",201,N],[12,"caching_codemap","","",201,N],[12,"alloc_id_recursion_tracker","","",201,N],[3,"BodyResolver","","The BodyResolver allows to map a BodyId to the corresponding hir::Body. We could also just store a plain reference to the hir::Crate but we want to avoid that the crate is used to get untracked access to all of the HIR.",N,N],[12,"0","","",204,N],[4,"NodeIdHashingMode","","",N,N],[13,"Ignore","","",202,N],[13,"HashDefPath","","",202,N],[5,"compute_ignored_attr_names","","",N,[[],["fxhashset",["symbol"]]]],[5,"hash_stable_trait_impls","","",N,N],[8,"StableHashingContextProvider","","Something that can provide a stable hashing context.",N,N],[10,"get_stable_hashing_context","","",205,[[["self"]],["stablehashingcontext"]]],[11,"clone","rustc::ich","",201,[[["self"]],["stablehashingcontext"]]],[11,"eq","","",202,[[["self"],["nodeidhashingmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",202,N],[11,"clone","","",202,[[["self"]],["nodeidhashingmode"]]],[11,"clone","rustc::ich::hcx","",204,[[["self"]],["bodyresolver"]]],[11,"body","","",204,[[["self"],["bodyid"]],["body"]]],[11,"new","rustc::ich","",201,[[["session"],["crate"],["definitions"],["cratestore"]],["self"]]],[11,"sess","","",201,[[["self"]],["session"]]],[11,"while_hashing_hir_bodies","","",201,[[["self"],["bool"],["f"]]]],[11,"while_hashing_spans","","",201,[[["self"],["bool"],["f"]]]],[11,"with_node_id_hashing_mode","","",201,[[["self"],["nodeidhashingmode"],["f"]]]],[11,"def_path_hash","","",201,[[["self"],["defid"]],["defpathhash"]]],[11,"local_def_path_hash","","",201,[[["self"],["defindex"]],["defpathhash"]]],[11,"node_to_hir_id","","",201,[[["self"],["nodeid"]],["hirid"]]],[11,"hash_bodies","","",201,[[["self"]],["bool"]]],[11,"codemap","","",201,[[["self"]],["cachingcodemapview"]]],[11,"is_ignored_attr","","",201,[[["self"],["symbol"]],["bool"]]],[11,"hash_hir_item_like","","",201,[[["self"],["f"]]]],[11,"get_stable_hashing_context","","",201,[[["self"]],["stablehashingcontext"]]],[11,"hash_stable","rustc::hir","",55,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",33,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",33,N],[0,"impls_cstore","rustc::ich","This module contains `HashStable` implementations for various data types from rustc::middle::cstore in no particular order.",N,N],[0,"impls_hir","","This module contains `HashStable` implementations for various HIR data types in no particular order.",N,N],[11,"hash_stable","rustc::hir::def_id","",147,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",147,[[["self"],["stablehashingcontext"]],["defpathhash"]]],[11,"hash_stable","","",148,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",148,[[["self"],["stablehashingcontext"]],["defpathhash"]]],[11,"hash_stable","","",145,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",145,[[["self"],["stablehashingcontext"]],["defpathhash"]]],[11,"hash_stable","rustc::hir","",34,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",34,[[["self"],["stablehashingcontext"]],["itemlocalid"]]],[11,"hash_stable","","",82,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",62,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",64,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",92,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",93,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",35,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",36,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",37,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",38,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",94,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",39,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",96,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",95,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",40,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",97,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",42,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",98,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",43,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",99,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",44,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",45,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",46,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",60,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",61,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",66,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",84,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",67,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",122,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",68,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",69,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",123,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",73,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",130,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",79,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",80,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",112,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",48,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",49,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",50,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",51,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",100,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",101,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",102,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",104,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",105,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",52,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",107,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",53,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",54,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",108,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",109,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",57,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",58,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",111,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",113,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",115,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",114,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",117,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",118,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",59,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",116,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",63,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",119,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",120,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",65,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",121,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",132,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",128,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",129,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",74,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",75,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",77,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",78,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",131,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",81,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",133,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",83,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",134,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",85,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",86,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",135,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",87,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",136,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",106,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",72,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",56,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",55,N],[11,"hash_stable","","",70,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",76,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",71,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::hir::def","",142,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",143,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::hir","",103,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",124,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",126,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",125,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",127,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::hir::def_id","",146,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",146,[[["self"],["stablehashingcontext"]],["defpathhash"]]],[11,"hash_stable","rustc::hir::def","",141,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::hir","",89,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",89,N],[11,"hash_stable","","",90,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",91,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",88,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"impls_mir","rustc::ich","This module contains `HashStable` implementations for various MIR data types in no particular order.",N,N],[0,"impls_misc","","This module contains `HashStable` implementations for various data types that don't fit into any of the other impls_xxx modules.",N,N],[0,"impls_ty","","This module contains `HashStable` implementations for various data types from rustc::ty in no particular order.",N,N],[0,"impls_syntax","","This module contains `HashStable` implementations for various data types from libsyntax in no particular order.",N,N],[5,"hash_token","rustc::ich::impls_syntax","",N,[[["token"],["stablehashingcontext"],["stablehasher"]]]],[5,"stable_byte_pos","","",N,[[["bytepos"],["bytepos"]],["u32"]]],[5,"stable_multibyte_char","","",N,N],[5,"stable_non_narrow_char","","",N,N],[17,"ATTR_DIRTY","rustc::ich","",N,N],[17,"ATTR_CLEAN","","",N,N],[17,"ATTR_IF_THIS_CHANGED","","",N,N],[17,"ATTR_THEN_THIS_WOULD_NEED","","",N,N],[17,"ATTR_PARTITION_REUSED","","",N,N],[17,"ATTR_PARTITION_CODEGENED","","",N,N],[17,"DEP_GRAPH_ASSERT_ATTRS","","",N,N],[17,"IGNORED_ATTRIBUTES","","",N,N],[8,"StableHashingContextProvider","","Something that can provide a stable hashing context.",N,N],[10,"get_stable_hashing_context","","",205,[[["self"]],["stablehashingcontext"]]],[0,"infer","rustc","See the Book for more information.",N,N],[3,"TypeFreshener","rustc::infer","",N,N],[12,"infcx","","",206,N],[12,"freshen_count","","",206,N],[12,"freshen_map","","",206,N],[3,"InferOk","","",N,N],[12,"value","","",207,N],[12,"obligations","","",207,N],[3,"InferCtxt","","",N,N],[12,"tcx","","",208,N],[12,"in_progress_tables","","During type-checking/inference of a body, `in_progress_tables` contains a reference to the tables being built up, which are used for reading closure kinds/signatures as they are inferred, and for error reporting logic to read arbitrary node types.",208,N],[12,"projection_cache","","",208,N],[12,"type_variables","","",208,N],[12,"int_unification_table","","",208,N],[12,"float_unification_table","","",208,N],[12,"region_constraints","","",208,N],[12,"lexical_region_resolutions","","",208,N],[12,"selection_cache","","Caches the results of trait selection. This cache is used for things that have to do with the parameters in scope.",208,N],[12,"evaluation_cache","","Caches the results of trait evaluation.",208,N],[12,"reported_trait_errors","","",208,N],[12,"tainted_by_errors_flag","","",208,N],[12,"err_count_on_creation","","",208,N],[12,"in_snapshot","","",208,N],[12,"region_obligations","","",208,N],[12,"universe","","What is the innermost universe we have created? Starts out as `UniverseIndex::root()` but grows from there as we enter universal quantifiers.",208,N],[3,"TypeTrace","","The trace designates the path through inference that we took to encounter an error or subtyping constraint.",N,N],[12,"cause","","",209,N],[12,"values","","",209,N],[3,"RegionObligation","","See the `region_obligations` field for more information.",N,N],[12,"sub_region","","",210,N],[12,"sup_type","","",210,N],[12,"cause","","",210,N],[3,"InferCtxtBuilder","","Helper type of a temporary returned by tcx.infer_ctxt(). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(InferCtxt<'b, 'gcx, 'tcx>).",N,N],[12,"global_tcx","","",211,N],[12,"arena","","",211,N],[12,"fresh_tables","","",211,N],[3,"CombinedSnapshot","","",N,N],[12,"projection_cache_snapshot","","",212,N],[12,"type_snapshot","","",212,N],[12,"int_snapshot","","",212,N],[12,"float_snapshot","","",212,N],[12,"region_constraints_snapshot","","",212,N],[12,"region_obligations_snapshot","","",212,N],[12,"universe","","",212,N],[12,"was_in_snapshot","","",212,N],[12,"_in_progress_tables","","",212,N],[4,"ValuePairs","","See `error_reporting` module for more details",N,N],[13,"Types","","",213,N],[13,"Regions","","",213,N],[13,"TraitRefs","","",213,N],[13,"PolyTraitRefs","","",213,N],[4,"SubregionOrigin","","The origin of a `r1 <= r2` constraint.",N,N],[13,"Subtype","","",214,N],[13,"InfStackClosure","","",214,N],[13,"InvokeClosure","","",214,N],[13,"DerefPointer","","",214,N],[13,"FreeVariable","","",214,N],[13,"IndexSlice","","",214,N],[13,"RelateObjectBound","","",214,N],[13,"RelateParamBound","","",214,N],[13,"RelateRegionParamBound","","",214,N],[13,"RelateDefaultParamBound","","",214,N],[13,"Reborrow","","",214,N],[13,"ReborrowUpvar","","",214,N],[13,"DataBorrowed","","",214,N],[13,"ReferenceOutlivesReferent","","",214,N],[13,"ParameterInScope","","",214,N],[13,"ExprTypeIsNotInScope","","",214,N],[13,"BindingTypeIsNotValidAtDecl","","",214,N],[13,"CallRcvr","","",214,N],[13,"CallArg","","",214,N],[13,"CallReturn","","",214,N],[13,"Operand","","",214,N],[13,"AddrOf","","",214,N],[13,"AutoBorrow","","",214,N],[13,"SafeDestructor","","",214,N],[13,"CompareImplMethodObligation","","",214,N],[12,"span","rustc::infer::SubregionOrigin","",214,N],[12,"item_name","","",214,N],[12,"impl_item_def_id","","",214,N],[12,"trait_item_def_id","","",214,N],[4,"ParameterOrigin","rustc::infer","Places that type/region parameters can appear.",N,N],[13,"Path","","",215,N],[13,"MethodCall","","",215,N],[13,"OverloadedOperator","","",215,N],[13,"OverloadedDeref","","",215,N],[4,"LateBoundRegionConversionTime","","Times when we replace late-bound regions with variables:",N,N],[13,"FnCall","","when a fn is called",216,N],[13,"HigherRankedType","","when two higher-ranked types are compared",216,N],[13,"AssocTypeProjection","","when projecting an associated type",216,N],[4,"RegionVariableOrigin","","Reasons to create a region inference variable",N,N],[13,"MiscVariable","","",217,N],[13,"PatternRegion","","",217,N],[13,"AddrOfRegion","","",217,N],[13,"Autoref","","",217,N],[13,"Coercion","","",217,N],[13,"EarlyBoundRegion","","",217,N],[13,"LateBoundRegion","","",217,N],[13,"UpvarRegion","","",217,N],[13,"BoundRegionInCoherence","","",217,N],[13,"NLL","","",217,N],[4,"NLLRegionVariableOrigin","","",N,N],[13,"FreeRegion","","",218,N],[13,"BoundRegion","","",218,N],[13,"Existential","","",218,N],[4,"FixupError","","",N,N],[13,"UnresolvedIntTy","","",219,N],[13,"UnresolvedFloatTy","","",219,N],[13,"UnresolvedTy","","",219,N],[0,"anon_types","","",N,N],[3,"AnonTypeDecl","rustc::infer::anon_types","Information about the anonymous, abstract types whose values we are inferring in this function (these are the `impl Trait` that appear in the return type).",N,N],[12,"substs","","The substitutions that we apply to the abstract that that this `impl Trait` desugars to. e.g., if:",220,N],[12,"concrete_ty","","The type variable that represents the value of the abstract type that we require. In other words, after we compile this function, we will be created a constraint like:",220,N],[12,"has_required_region_bounds","","True if the `impl Trait` bounds include region bounds. For example, this would be true for:",220,N],[3,"ReverseMapper","","",N,N],[12,"tcx","","",221,N],[12,"tainted_by_errors","","If errors have already been reported in this fn, we suppress our own errors because they are sometimes derivative.",221,N],[12,"anon_type_def_id","","",221,N],[12,"map","","",221,N],[12,"map_missing_regions_to_empty","","",221,N],[12,"hidden_ty","","initially `Some`, set to `None` once error has been reported",221,N],[3,"Instantiator","","",N,N],[12,"infcx","","",222,N],[12,"parent_def_id","","",222,N],[12,"body_id","","",222,N],[12,"param_env","","",222,N],[12,"anon_types","","",222,N],[12,"obligations","","",222,N],[5,"may_define_existential_type","","Whether `anon_node_id` is a sibling or a child of a sibling of `def_id`",N,[[["tyctxt"],["defid"],["nodeid"]],["bool"]]],[6,"AnonTypeMap","","",N,N],[11,"clone","","",220,[[["self"]],["anontypedecl"]]],[11,"fmt","","",220,[[["self"],["formatter"]],["result"]]],[11,"instantiate_anon_types","rustc::infer","Replace all anonymized types in `value` with fresh inference variables and creates appropriate obligations. For example, given the input:",208,[[["self"],["defid"],["nodeid"],["paramenv"],["t"]],["inferok"]]],[11,"constrain_anon_types","","Given the map `anon_types` containing the existential `impl Trait` types whose underlying, hidden types are being inferred, this method adds constraints to the regions appearing in those underlying hidden types to ensure that they at least do not refer to random scopes within the current function. These constraints are not (quite) sufficient to guarantee that the regions are actually legal values; that final condition is imposed after region inference is done.",208,[[["self"],["anontypemap"],["frr"]]]],[11,"constrain_anon_type","","",208,[[["self"],["defid"],["anontypedecl"],["frr"]]]],[11,"infer_anon_definition_from_instantiation","","Given the fully resolved, instantiated type for an anonymous type, i.e., the value of an inference variable like C1 or C2 (*), computes the \"definition type\" for an abstract type definition -- that is, the inferred value of `Foo1<'x>` or `Foo2<'x>` that we would conceptually use in its definition:",208,[[["self"],["defid"],["anontypedecl"],["ty"]],["ty"]]],[11,"new","rustc::infer::anon_types","",221,[[["tyctxt"],["bool"],["defid"],["fxhashmap",["kind","kind"]],["ty"]],["self"]]],[11,"fold_kind_mapping_missing_regions_to_empty","","",221,[[["self"],["kind"]],["kind"]]],[11,"fold_kind_normally","","",221,[[["self"],["kind"]],["kind"]]],[11,"tcx","","",221,[[["self"]],["tyctxt"]]],[11,"fold_region","","",221,[[["self"],["region"]],["region"]]],[11,"fold_ty","","",221,[[["self"],["ty"]],["ty"]]],[11,"instantiate_anon_types_in_map","","",222,[[["self"],["t"]],["t"]]],[11,"fold_anon_ty","","",222,[[["self"],["ty"],["defid"],["substs"]],["ty"]]],[0,"at","rustc::infer","A nice interface for working with the infcx.  The basic idea is to do `infcx.at(cause, param_env)`, which sets the \"cause\" of the operation as well as the surrounding parameter environment.  Then you can do something like `.sub(a, b)` or `.eq(a, b)` to create a subtype or equality relationship respectively. The first argument is always the \"expected\" output from the POV of diagnostics.",N,N],[3,"At","rustc::infer::at","",N,N],[12,"infcx","","",223,N],[12,"cause","","",223,N],[12,"param_env","","",223,N],[3,"Trace","","",N,N],[12,"at","","",224,N],[12,"a_is_expected","","",224,N],[12,"trace","","",224,N],[8,"ToTrace","","",N,N],[10,"to_trace","","",225,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"at","rustc::infer","",208,[[["self"],["obligationcause"],["paramenv"]],["at"]]],[11,"eq_impl_headers","rustc::infer::at","Hacky routine for equating two impl headers in coherence.",223,[[["self"],["implheader"],["implheader"]],["inferresult"]]],[11,"sub_exp","","Make `a <: b` where `a` may or may not be expected",223,[[["self"],["bool"],["t"],["t"]],["inferresult"]]],[11,"sup","","Make `actual <: expected`. For example, if type-checking a call like `foo(x)`, where `foo: fn(i32)`, you might have `sup(i32, x)`, since the \"expected\" type is the type that appears in the signature.",223,[[["self"],["t"],["t"]],["inferresult"]]],[11,"sub","","Make `expected <: actual`",223,[[["self"],["t"],["t"]],["inferresult"]]],[11,"eq_exp","","Make `expected <: actual`",223,[[["self"],["bool"],["t"],["t"]],["inferresult"]]],[11,"eq","","Make `expected <: actual`",223,[[["self"],["t"],["t"]],["inferresult"]]],[11,"lub","","Compute the least-upper-bound, or mutual supertype, of two values. The order of the arguments doesn't matter, but since this can result in an error (e.g., if asked to compute LUB of u32 and i32), it is meaningful to call one of them the \"expected type\".",223,[[["self"],["t"],["t"]],["inferresult"]]],[11,"glb","","Compute the greatest-lower-bound, or mutual subtype, of two values. As with `lub` order doesn't matter, except for error cases.",223,[[["self"],["t"],["t"]],["inferresult"]]],[11,"trace","","Sets the \"trace\" values that will be used for error-reporting, but doesn't actually perform any operation yet (this is useful when you want to set the trace using distinct values from those you wish to operate upon).",223,[[["self"],["t"],["t"]],["trace"]]],[11,"trace_exp","","Like `trace`, but the expected value is determined by the boolean argument (if true, then the first argument `a` is the \"expected\" value).",223,[[["self"],["bool"],["t"],["t"]],["trace"]]],[11,"sub","","Make `a <: b` where `a` may or may not be expected (if `a_is_expected` is true, then `a` is expected). Make `expected <: actual`",224,[[["self"],["t"],["t"]],["inferresult"]]],[11,"eq","","Make `a == b`; the expectation is set by the call to `trace()`.",224,[[["self"],["t"],["t"]],["inferresult"]]],[11,"lub","","",224,[[["self"],["t"],["t"]],["inferresult"]]],[11,"glb","","",224,[[["self"],["t"],["t"]],["inferresult"]]],[0,"canonical","rustc::infer","Canonicalization is the key to constructing a query in the middle of type inference. Ordinarily, it is not possible to store types from type inference in query keys, because they contain references to inference variables whose lifetimes are too short and so forth. Canonicalizing a value T1 using `canonicalize_query` produces two things:",N,N],[3,"Canonical","rustc::infer::canonical","A \"canonicalized\" type `V` is one where all free inference variables have been rewriten to \"canonical vars\". These are numbered starting from 0 in order of first appearance.",N,N],[12,"variables","","",226,N],[12,"value","","",226,N],[3,"CanonicalVarValues","","A set of values corresponding to the canonical variables from some `Canonical`. You can give these values to `canonical_value.substitute` to substitute them into the canonical value at the right places.",N,N],[12,"var_values","","",227,N],[3,"CanonicalVarInfo","","Information about a canonical variable that is included with the canonical value. This is sufficient information for code to create a copy of the canonical value in some other inference context, with fresh inference variables replacing the canonical values.",N,N],[12,"kind","","",228,N],[3,"QueryResult","","After we execute a query with a canonicalized key, we get back a `Canonical<QueryResult<..>>`. You can use `instantiate_query_result` to access the data in this result.",N,N],[12,"var_values","","",229,N],[12,"region_constraints","","",229,N],[12,"certainty","","",229,N],[12,"value","","",229,N],[4,"CanonicalVarKind","","Describes the \"kind\" of the canonical variable. This is a \"kind\" in the type-theory sense of the term -- i.e., a \"meta\" type system that analyzes type-like values.",N,N],[13,"Ty","","Some kind of type inference variable.",230,N],[13,"Region","","Region variable `'?R`.",230,N],[4,"CanonicalTyVarKind","","Rust actually has more than one category of type variables; notably, the type variables we create for literals (e.g., 22 or 22.) can only be instantiated with integral/float types (e.g., usize or f32). In order to faithfully reproduce a type, we need to know what set of types a given type variable can be unified with.",N,N],[13,"General","","General type variable `?T` that can be unified with arbitrary types.",231,N],[13,"Int","","Integral type variable `?I` (that can only be unified with integral types).",231,N],[13,"Float","","Floating-point type variable `?F` (that can only be unified with float types).",231,N],[4,"Certainty","","Indicates whether or not we were able to prove the query to be true.",N,N],[13,"Proven","","The query is known to be true, presuming that you apply the given `var_values` and the region-constraints are satisfied.",232,N],[13,"Ambiguous","","The query is not known to be true, but also not known to be false. The `var_values` represent either values that must hold in order for the query to be true, or helpful tips that might make it true. Currently rustc's trait solver cannot distinguish the two (e.g., due to our preference for where clauses over impls).",232,N],[0,"canonicalizer","","This module contains the \"canonicalizer\" itself.",N,N],[3,"CanonicalizeRegionMode","rustc::infer::canonical::canonicalizer","If this flag is true, then all free regions will be replaced with a canonical var. This is used to make queries as generic as possible. For example, the query `F: Foo<'static>` would be canonicalized to `F: Foo<'0>`.",N,N],[12,"static_region","","",233,N],[12,"other_free_regions","","",233,N],[3,"Canonicalizer","","",N,N],[12,"infcx","","",234,N],[12,"tcx","","",234,N],[12,"variables","","",234,N],[12,"var_values","","",234,N],[12,"indices","","",234,N],[12,"canonicalize_region_mode","","",234,N],[12,"needs_canonical_flags","","",234,N],[11,"canonicalize_query","rustc::infer","Canonicalizes a query value `V`. When we canonicalize a query, we not only canonicalize unbound inference variables, but we also replace all free regions whatsoever. So for example a query like `T: Trait<'static>` would be canonicalized to",208,[[["self"],["v"],["smallcanonicalvarvalues"]],["canonicalized"]]],[11,"canonicalize_response","","Canonicalizes a query response `V`. When we canonicalize a query response, we only canonicalize unbound inference variables, and we leave other free regions alone. So, continuing with the example from `canonicalize_query`, if there was an input query `T: Trait<'static>`, it would have been canonicalized to",208,[[["self"],["v"]],["canonicalized"]]],[11,"canonicalize_hr_query_hack","","A hacky variant of `canonicalize_query` that does not canonicalize `'static`.  Unfortunately, the existing leak check treaks `'static` differently in some cases (see also #33684), so if we are performing an operation that may need to prove \"leak-check\" related things, we leave `'static` alone.",208,[[["self"],["v"],["smallcanonicalvarvalues"]],["canonicalized"]]],[11,"any","rustc::infer::canonical::canonicalizer","",233,[[["self"]],["bool"]]],[11,"tcx","","",234,[[["self"]],["tyctxt"]]],[11,"fold_region","","",234,[[["self"],["region"]],["region"]]],[11,"fold_ty","","",234,[[["self"],["ty"]],["ty"]]],[11,"canonicalize","","The main `canonicalize` method, shared impl of `canonicalize_query` and `canonicalize_response`.",234,[[["v"],["option",["inferctxt"]],["tyctxt"],["canonicalizeregionmode"],["smallcanonicalvarvalues"]],["canonicalized"]]],[11,"canonical_var","","Creates a canonical variable replacing `kind` from the input, or returns an existing variable if `kind` has already been seen. `kind` is expected to be an unbound variable (or potentially a free region).",234,[[["self"],["canonicalvarinfo"],["kind"]],["canonicalvar"]]],[11,"canonicalize_ty_var","","Given a type variable `ty_var` of the given kind, first check if `ty_var` is bound to anything; if so, canonicalize that. Otherwise, create a new canonical variable for `ty_var`.",234,[[["self"],["canonicaltyvarkind"],["ty"]],["ty"]]],[0,"query_result","rustc::infer::canonical","This module contains the code to instantiate a \"query result\", and in particular to extract out the resulting region obligations and encode them therein.",N,N],[5,"make_query_outlives","rustc::infer::canonical::query_result","Given the region obligations and constraints scraped from the infcx, creates query region constraints.",N,[[["tyctxt"],["vec"],["regionconstraintdata"]],["vec",["queryregionconstraint"]]]],[22,"","","",N,N],[11,"enter_canonical_trait_query","rustc::infer","The \"main method\" for a canonicalized trait query. Given the canonical key `canonical_key`, this method will create a new inference context, instantiate the key, and run your operation `op`. The operation should yield up a result (of type `R`) as well as a set of trait obligations that must be fully satisfied. These obligations will be processed and the canonical result created.",211,N],[11,"make_canonicalized_query_result","","This method is meant to be invoked as the final step of a canonical query implementation. It is given:",208,[[["self"],["canonicalvarvalues"],["t"],["fulfillmentcontext"]],["fallible",["canonicalizedqueryresult"]]]],[11,"make_query_result","","Helper for `make_canonicalized_query_result` that does everything up until the final canonicalization.",208,[[["self"],["canonicalvarvalues"],["t"],["fulfillmentcontext"]],["result",["queryresult","nosolution"]]]],[11,"instantiate_query_result_and_region_obligations","","Given the (canonicalized) result to a canonical query, instantiates the result so it can be used, plugging in the values from the canonical query. (Note that the result may have been ambiguous; you should check the certainty level of the query before applying this function.)",208,[[["self"],["obligationcause"],["paramenv"],["smallcanonicalvarvalues"],["canonical"]],["inferresult"]]],[11,"instantiate_nll_query_result_and_region_obligations","","An alternative to `instantiate_query_result_and_region_obligations` that is more efficient for NLL. NLL is a bit more advanced in the \"transition to chalk\" than the rest of the compiler. During the NLL type check, all of the \"processing\" of types and things happens in queries -- the NLL checker itself is only interested in the region obligations (`'a: 'b` or `T: 'b`) that come out of these queries, which it wants to convert into MIR-based constraints and solve. Therefore, it is most convenient for the NLL Type Checker to directly consume the `QueryRegionConstraint` values that arise from doing a query. This is contrast to other parts of the compiler, which would prefer for those `QueryRegionConstraint` to be converted into the older infcx-style constraints (e.g., calls to `sub_regions` or `register_region_obligation`).",208,[[["self"],["obligationcause"],["paramenv"],["smallcanonicalvarvalues"],["canonical"],["vec"]],["inferresult"]]],[11,"query_result_substitution","","Given the original values and the (canonicalized) result from computing a query, returns a substitution that can be applied to the query result to convert the result back into the original namespace.",208,[[["self"],["obligationcause"],["paramenv"],["smallcanonicalvarvalues"],["canonical"]],["inferresult",["canonicalvarvalues"]]]],[11,"query_result_substitution_guess","","Given the original values and the (canonicalized) result from computing a query, returns a guess at a substitution that can be applied to the query result to convert the result back into the original namespace. This is called a guess because it uses a quick heuristic to find the values for each canonical variable; if that quick heuristic fails, then we will instantiate fresh inference variables for each canonical variable instead. Therefore, the result of this method must be properly unified",208,[[["self"],["obligationcause"],["smallcanonicalvarvalues"],["canonical"]],["canonicalvarvalues"]]],[11,"unify_query_result_substitution_guess","","Given a \"guess\" at the values for the canonical variables in the input, try to unify with the actual values found in the query result.  Often, but not always, this is a no-op, because we already found the mapping in the \"guessing\" step.",208,[[["self"],["obligationcause"],["paramenv"],["smallcanonicalvarvalues"],["canonicalvarvalues"],["canonical"]],["inferresult"]]],[11,"query_region_constraints_into_obligations","","Converts the region constraints resulting from a query into an iterator of obligations.",208,N],[11,"unify_canonical_vars","","Given two sets of values for the same set of canonical variables, unify them. The second set is produced lazilly by supplying indices from the first set.",208,N],[0,"substitute","rustc::infer::canonical","This module contains code to substitute new values into a `Canonical<'tcx, T>`.",N,N],[3,"CanonicalVarValuesSubst","rustc::infer::canonical::substitute","",N,N],[12,"tcx","","",235,N],[12,"var_values","","",235,N],[5,"substitute_value","","Substitute the values from `var_values` into `value`. `var_values` must be values for the set of canonical variables that appear in `value`.",N,[[["tyctxt"],["canonicalvarvalues"],["t"]],["t"]]],[11,"substitute","rustc::infer::canonical","Instantiate the wrapped value, replacing each canonical value with the value given in `var_values`.",226,[[["self"],["tyctxt"],["canonicalvarvalues"]],["v"]]],[11,"substitute_projected","","Allows one to apply a substitute to some subset of `self.value`. Invoke `projection_fn` with `self.value` to get a value V that is expressed in terms of the same canonical variables bound in `self` (usually this extracts from subset of `self`). Apply the substitution `var_values` to this value V, replacing each of the canonical variables.",226,N],[11,"tcx","rustc::infer::canonical::substitute","",235,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",235,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",235,[[["self"],["region"]],["region"]]],[6,"CanonicalVarInfos","rustc::infer::canonical","",N,N],[6,"SmallCanonicalVarValues","","Like CanonicalVarValues, but for use in places where a SmallVec is appropriate.",N,N],[6,"Canonicalized","","",N,N],[6,"CanonicalizedQueryResult","","",N,N],[6,"QueryRegionConstraint","","",N,N],[11,"clone","","",226,[[["self"]],["canonical"]]],[11,"fmt","","",226,[[["self"],["formatter"]],["result"]]],[11,"eq","","",226,[[["self"],["canonical"]],["bool"]]],[11,"ne","","",226,[[["self"],["canonical"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",226,N],[11,"hash","","",226,N],[11,"decode","","",226,[[["__dv"]],["result",["canonical"]]]],[11,"encode","","",226,[[["self"],["__sv"]],["result"]]],[11,"clone","","",227,[[["self"]],["canonicalvarvalues"]]],[11,"fmt","","",227,[[["self"],["formatter"]],["result"]]],[11,"eq","","",227,[[["self"],["canonicalvarvalues"]],["bool"]]],[11,"ne","","",227,[[["self"],["canonicalvarvalues"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",227,N],[11,"hash","","",227,N],[11,"decode","","",227,[[["__d"]],["result",["canonicalvarvalues"]]]],[11,"encode","","",227,[[["self"],["__s"]],["result"]]],[11,"clone","","",228,[[["self"]],["canonicalvarinfo"]]],[11,"fmt","","",228,[[["self"],["formatter"]],["result"]]],[11,"eq","","",228,[[["self"],["canonicalvarinfo"]],["bool"]]],[11,"ne","","",228,[[["self"],["canonicalvarinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",228,N],[11,"hash","","",228,N],[11,"decode","","",228,[[["__d"]],["result",["canonicalvarinfo"]]]],[11,"encode","","",228,[[["self"],["__s"]],["result"]]],[11,"clone","","",230,[[["self"]],["canonicalvarkind"]]],[11,"fmt","","",230,[[["self"],["formatter"]],["result"]]],[11,"eq","","",230,[[["self"],["canonicalvarkind"]],["bool"]]],[11,"ne","","",230,[[["self"],["canonicalvarkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",230,N],[11,"hash","","",230,N],[11,"decode","","",230,[[["__d"]],["result",["canonicalvarkind"]]]],[11,"encode","","",230,[[["self"],["__s"]],["result"]]],[11,"clone","","",231,[[["self"]],["canonicaltyvarkind"]]],[11,"fmt","","",231,[[["self"],["formatter"]],["result"]]],[11,"eq","","",231,[[["self"],["canonicaltyvarkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",231,N],[11,"hash","","",231,N],[11,"decode","","",231,[[["__d"]],["result",["canonicaltyvarkind"]]]],[11,"encode","","",231,[[["self"],["__s"]],["result"]]],[11,"clone","","",229,[[["self"]],["queryresult"]]],[11,"fmt","","",229,[[["self"],["formatter"]],["result"]]],[11,"clone","","",232,[[["self"]],["certainty"]]],[11,"fmt","","",232,[[["self"],["formatter"]],["result"]]],[11,"is_proven","","",232,[[["self"]],["bool"]]],[11,"is_ambiguous","","",232,[[["self"]],["bool"]]],[11,"is_proven","","",229,[[["self"]],["bool"]]],[11,"is_ambiguous","","",229,[[["self"]],["bool"]]],[11,"is_proven","","",226,[[["self"]],["bool"]]],[11,"is_ambiguous","","",226,[[["self"]],["bool"]]],[11,"instantiate_canonical_with_fresh_inference_vars","rustc::infer","Creates a substitution S for the canonical value with fresh inference variables and applies it to the canonical value. Returns both the instantiated result and the substitution S.",208,N],[11,"fresh_inference_vars_for_canonical_vars","","Given the \"infos\" about the canonical variables from some canonical, creates fresh inference variables with the same characteristics. You can then use `substitute` to instantiate the canonical variable with these inference variables.",208,[[["self"],["span"],["slice"]],["canonicalvarvalues"]]],[11,"fresh_inference_var_for_canonical_var","","Given the \"info\" about a canonical variable, creates a fresh inference variable with the same characteristics.",208,[[["self"],["span"],["canonicalvarinfo"]],["kind"]]],[11,"super_fold_with","rustc::infer::canonical","",232,[[["self"],["f"]],["certainty"]]],[11,"super_visit_with","","",232,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",228,[[["self"],["f"]],["canonicalvarinfo"]]],[11,"super_visit_with","","",228,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",230,[[["self"],["f"]],["canonicalvarkind"]]],[11,"super_visit_with","","",230,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",232,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",228,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",230,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",236,[[["self"],["f"]],["canonicalvarinfos"]]],[11,"super_visit_with","","",236,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",226,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",226,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",226,[[["self"],["tyctxt"]],["option",["canonical"]]]],[11,"len","","",227,[[["self"]],["usize"]]],[11,"lift_to_tcx","","",227,[[["self"],["tyctxt"]],["option",["canonicalvarvalues"]]]],[11,"super_fold_with","","",227,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",227,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",229,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",229,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",229,[[["self"],["tyctxt"]],["option",["queryresult"]]]],[11,"index","","",227,[[["self"],["canonicalvar"]],["kind"]]],[0,"combine","rustc::infer","",N,N],[3,"CombineFields","rustc::infer::combine","",N,N],[12,"infcx","","",237,N],[12,"trace","","",237,N],[12,"cause","","",237,N],[12,"param_env","","",237,N],[12,"obligations","","",237,N],[3,"Generalizer","","",N,N],[12,"infcx","","",238,N],[12,"span","","Span, used when creating new type variables and things.",238,N],[12,"for_vid_sub_root","","The vid of the type variable that is in the process of being instantiated; if we find this within the type we are folding, that means we would have created a cyclic type.",238,N],[12,"ambient_variance","","Track the variance as we descend into the type.",238,N],[12,"needs_wf","","See the field `needs_wf` in `Generalization`.",238,N],[12,"root_ty","","The root type that we are generalizing. Used when reporting cycles.",238,N],[3,"Generalization","","Result from a generalization operation. This includes not only the generalized type, but also a bool flag indicating whether further WF checks are needed.",N,N],[12,"ty","","",239,N],[12,"needs_wf","","If true, then the generalized type may not be well-formed, even if the source type is well-formed, so we should add an additional check to enforce that it is. This arises in particular around 'bivariant' type parameters that are only constrained by a where-clause. As an example, imagine a type:",239,N],[4,"RelationDir","","",N,N],[13,"SubtypeOf","","",240,N],[13,"SupertypeOf","","",240,N],[13,"EqTo","","",240,N],[5,"int_unification_error","","",N,N],[5,"float_unification_error","","",N,N],[8,"RelateResultCompare","","",N,N],[10,"compare","","",241,[[["self"],["t"],["f"]],["relateresult"]]],[11,"clone","","",237,[[["self"]],["combinefields"]]],[11,"clone","","",240,[[["self"]],["relationdir"]]],[11,"assert_receiver_is_total_eq","","",240,N],[11,"eq","","",240,[[["self"],["relationdir"]],["bool"]]],[11,"hash","","",240,N],[11,"fmt","","",240,[[["self"],["formatter"]],["result"]]],[11,"super_combine_tys","rustc::infer","",208,[[["self"],["r"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"unify_integral_variable","","",208,[[["self"],["bool"],["intvid"],["intvarvalue"]],["relateresult",["ty"]]]],[11,"unify_float_variable","","",208,[[["self"],["bool"],["floatvid"],["floatty"]],["relateresult",["ty"]]]],[11,"tcx","rustc::infer::combine","",237,[[["self"]],["tyctxt"]]],[11,"equate","","",237,[[["self"],["bool"]],["equate"]]],[11,"sub","","",237,[[["self"],["bool"]],["sub"]]],[11,"lub","","",237,[[["self"],["bool"]],["lub"]]],[11,"glb","","",237,[[["self"],["bool"]],["glb"]]],[11,"instantiate","","Here dir is either EqTo, SubtypeOf, or SupertypeOf. The idea is that we should ensure that the type `a_ty` is equal to, a subtype of, or a supertype of (respectively) the type to which `b_vid` is bound.",237,[[["self"],["ty"],["relationdir"],["tyvid"],["bool"]],["relateresult"]]],[11,"generalize","","Attempts to generalize `ty` for the type variable `for_vid`. This checks for cycle -- that is, whether the type `ty` references `for_vid`. The `dir` is the \"direction\" for which we a performing the generalization (i.e., are we producing a type that can be used as a supertype etc).",237,[[["self"],["ty"],["tyvid"],["relationdir"]],["relateresult",["generalization"]]]],[11,"tcx","","",238,[[["self"]],["tyctxt"]]],[11,"tag","","",238,[[["self"]],["str"]]],[11,"a_is_expected","","",238,[[["self"]],["bool"]]],[11,"binders","","",238,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[11,"relate_item_substs","","",238,[[["self"],["defid"],["substs"],["substs"]],["relateresult",["substs"]]]],[11,"relate_with_variance","","",238,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",238,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",238,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[0,"equate","rustc::infer","",N,N],[3,"Equate","rustc::infer::equate","Ensures `a` is made equal to `b`. Returns `a` on success.",N,N],[12,"fields","","",242,N],[12,"a_is_expected","","",242,N],[11,"new","","",242,[[["combinefields"],["bool"]],["equate"]]],[11,"tag","","",242,[[["self"]],["str"]]],[11,"tcx","","",242,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",242,[[["self"]],["bool"]]],[11,"relate_item_substs","","",242,[[["self"],["defid"],["substs"],["substs"]],["relateresult",["substs"]]]],[11,"relate_with_variance","","",242,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",242,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",242,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",242,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[0,"error_reporting","rustc::infer","Error Reporting Code for the inference engine",N,N],[4,"FailureCode","rustc::infer::error_reporting","",N,N],[13,"Error0317","","",243,N],[13,"Error0580","","",243,N],[13,"Error0308","","",243,N],[13,"Error0644","","",243,N],[0,"note","","",N,N],[11,"note_region_origin","rustc::infer","",208,[[["self"],["diagnosticbuilder"],["subregionorigin"]]]],[11,"report_concrete_failure","","",208,[[["self"],["scopetree"],["subregionorigin"],["region"],["region"]],["diagnosticbuilder"]]],[0,"need_type_info","rustc::infer::error_reporting","",N,N],[3,"FindLocalByTypeVisitor","rustc::infer::error_reporting::need_type_info","",N,N],[12,"infcx","","",244,N],[12,"target_ty","","",244,N],[12,"hir_map","","",244,N],[12,"found_local_pattern","","",244,N],[12,"found_arg_pattern","","",244,N],[11,"node_matches_type","","",244,[[["self"],["hirid"]],["bool"]]],[11,"nested_visit_map","","",244,[[["self"]],["nestedvisitormap"]]],[11,"visit_local","","",244,[[["self"],["local"]]]],[11,"visit_body","","",244,[[["self"],["body"]]]],[11,"extract_type_name","rustc::infer","",208,[[["self"],["ty"]],["string"]]],[11,"need_type_info_err","","",208,[[["self"],["option",["bodyid"]],["span"],["ty"]],["diagnosticbuilder"]]],[0,"nice_region_error","rustc::infer::error_reporting","",N,N],[3,"NiceRegionError","rustc::infer::error_reporting::nice_region_error","",N,N],[12,"tcx","","",245,N],[12,"error","","",245,N],[12,"regions","","",245,N],[12,"tables","","",245,N],[0,"different_lifetimes","","Error Reporting for Anonymous Region Lifetime Errors where both the regions are anonymous.",N,N],[11,"try_report_anon_anon_conflict","","Print the error message for lifetime errors when both the concerned regions are anonymous.",245,[[["self"]],["option",["errorreported"]]]],[0,"find_anon_type","","",N,N],[3,"FindNestedTypeVisitor","rustc::infer::error_reporting::nice_region_error::find_anon_type","",N,N],[12,"tcx","","",246,N],[12,"bound_region","","",246,N],[12,"found_type","","",246,N],[12,"current_index","","",246,N],[3,"TyPathVisitor","","",N,N],[12,"tcx","","",247,N],[12,"found_it","","",247,N],[12,"bound_region","","",247,N],[12,"current_index","","",247,N],[11,"find_anon_type","rustc::infer::error_reporting::nice_region_error","This function calls the `visit_ty` method for the parameters corresponding to the anonymous regions. The `nested_visitor.found_type` contains the anonymous type.",245,[[["self"],["region"],["boundregion"]],["option"]]],[11,"find_component_for_bound_region","","",245,[[["self"],["ty"],["boundregion"]],["option",["ty"]]]],[11,"nested_visit_map","rustc::infer::error_reporting::nice_region_error::find_anon_type","",246,[[["self"]],["nestedvisitormap"]]],[11,"visit_ty","","",246,[[["self"],["ty"]]]],[11,"nested_visit_map","","",247,[[["self"]],["nestedvisitormap"]]],[11,"visit_lifetime","","",247,[[["self"],["lifetime"]]]],[11,"visit_ty","","",247,[[["self"],["ty"]]]],[0,"named_anon_conflict","rustc::infer::error_reporting::nice_region_error","Error Reporting for Anonymous Region Lifetime Errors where one region is named and the other is anonymous.",N,N],[11,"try_report_named_anon_conflict","","When given a `ConcreteFailure` for a function with arguments containing a named region and an anonymous region, emit an descriptive diagnostic error.",245,[[["self"]],["option",["errorreported"]]]],[11,"is_named_region","","",245,[[["self"],["region"]],["bool"]]],[0,"outlives_closure","","Error Reporting for Anonymous Region Lifetime Errors where both the regions are anonymous.",N,N],[11,"try_report_outlives_closure","","Print the error message for lifetime errors when binding excapes a closure.",245,[[["self"]],["option",["errorreported"]]]],[0,"static_impl_trait","","Error Reporting for static impl Traits.",N,N],[11,"try_report_static_impl_trait","","Print the error message for lifetime errors when the return type is a static impl Trait.",245,[[["self"]],["option",["errorreported"]]]],[0,"util","","Helper functions corresponding to lifetime errors due to anonymous regions.",N,N],[3,"AnonymousArgInfo","rustc::infer::error_reporting::nice_region_error::util","",N,N],[12,"arg","","",248,N],[12,"arg_ty","","",248,N],[12,"bound_region","","",248,N],[12,"is_first","","",248,N],[3,"FreeRegionInfo","","",N,N],[12,"def_id","","",249,N],[12,"boundregion","","",249,N],[12,"is_impl_item","","",249,N],[11,"fmt","","",248,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",249,[[["self"],["formatter"]],["result"]]],[11,"find_arg_with_region","rustc::infer::error_reporting::nice_region_error","",245,[[["self"],["region"],["region"]],["option",["anonymousarginfo"]]]],[11,"is_suitable_region","","",245,[[["self"],["region"]],["option",["freeregioninfo"]]]],[11,"is_return_type_anon","","",245,[[["self"],["defid"],["boundregion"],["fndecl"]],["option",["span"]]]],[11,"is_return_type_impl_trait","","",245,[[["self"],["defid"]],["bool"]]],[11,"is_self_anon","","",245,[[["self"],["bool"],["defid"]],["bool"]]],[11,"is_bound_region_in_impl_item","","",245,[[["self"],["defid"]],["bool"]]],[11,"try_report_nice_region_error","rustc::infer","",208,[[["self"],["regionresolutionerror"]],["bool"]]],[11,"new","rustc::infer::error_reporting::nice_region_error","",245,[[["tyctxt"],["regionresolutionerror"],["option",["typecktables"]]],["self"]]],[11,"new_from_span","","",245,[[["tyctxt"],["span"],["region"],["region"],["option",["typecktables"]]],["self"]]],[11,"try_report","","",245,[[["self"]],["option",["errorreported"]]]],[11,"get_regions","","",245,N],[11,"report_region_errors","rustc::infer","",208,[[["self"],["scopetree"],["vec"],["bool"]]]],[11,"process_errors","","",208,[[["self"],["vec"]],["vec",["regionresolutionerror"]]]],[11,"check_and_note_conflicting_crates","","Adds a note if the types come from similarly named crates",208,[[["self"],["diagnosticbuilder"],["typeerror"],["span"]]]],[11,"note_error_origin","","",208,[[["self"],["diagnosticbuilder"],["obligationcause"]]]],[11,"highlight_outer","","Given that `other_ty` is the same as a type argument for `name` in `sub`, populate `value` highlighting `name` and every type argument that isn't at `pos` (which is `other_ty`), and populate `other_value` with `other_ty`.",208,[[["self"],["diagnosticstyledstring"],["diagnosticstyledstring"],["string"],["substs"],["usize"],["ty"]]]],[11,"cmp_type_arg","","If `other_ty` is the same as a type argument present in `sub`, highlight `path` in `t1_out`, as that is the difference to the other type.",208,[[["self"],["diagnosticstyledstring"],["diagnosticstyledstring"],["string"],["substs"],["string"],["ty"]],["option"]]],[11,"push_comma","","Add a `,` to the type representation only if it is appropriate.",208,[[["self"],["diagnosticstyledstring"],["diagnosticstyledstring"],["usize"],["usize"]]]],[11,"strip_generic_default_params","","For generic types with parameters with defaults, remove the parameters corresponding to the defaults. This repeats a lot of the logic found in `PrintContext::parameterized`.",208,[[["self"],["defid"],["substs"]],["substs"]]],[11,"cmp","","Compare two given types, eliding parts that are the same between them and highlighting relevant differences, and return two representation of those types for highlighted printing.",208,N],[11,"note_type_err","","",208,[[["self"],["diagnosticbuilder"],["obligationcause"],["option"],["option",["valuepairs"]],["typeerror"]]]],[11,"report_and_explain_type_error","","",208,[[["self"],["typetrace"],["typeerror"]],["diagnosticbuilder"]]],[11,"values_str","","",208,[[["self"],["valuepairs"]],["option"]]],[11,"expected_found_str_ty","","",208,[[["self"],["expectedfound"]],["option"]]],[11,"expected_found_str","","Returns a string of the form \"expected `{}`, found `{}`\".",208,[[["self"],["expectedfound"]],["option"]]],[11,"report_generic_bound_failure","","",208,[[["self"],["scopetree"],["span"],["option",["subregionorigin"]],["generickind"],["region"]]]],[11,"construct_generic_bound_failure","","",208,[[["self"],["scopetree"],["span"],["option",["subregionorigin"]],["generickind"],["region"]],["diagnosticbuilder"]]],[11,"report_sub_sup_conflict","","",208,[[["self"],["scopetree"],["regionvariableorigin"],["subregionorigin"],["region"],["subregionorigin"],["region"]]]],[11,"report_inference_failure","","",208,[[["self"],["regionvariableorigin"]],["diagnosticbuilder"]]],[0,"fudge","","",N,N],[3,"RegionFudger","rustc::infer::fudge","",N,N],[12,"infcx","","",250,N],[12,"type_variables","","",250,N],[12,"region_vars","","",250,N],[12,"origin","","",250,N],[11,"fudge_regions_if_ok","rustc::infer","This rather funky routine is used while processing expected types. What happens here is that we want to propagate a coercion through the return type of a fn to its argument. Consider the type of `Option::Some`, which is basically `for<T> fn(T) -> Option<T>`. So if we have an expression `Some(&[1, 2, 3])`, and that has the expected type `Option<&[u32]>`, we would like to type check `&[1, 2, 3]` with the expectation of `&[u32]`. This will cause us to coerce from `&[u32; 3]` to `&[u32]` and make the users life more pleasant.",208,[[["self"],["regionvariableorigin"],["f"]],["result"]]],[11,"tcx","rustc::infer::fudge","",250,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",250,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",250,[[["self"],["region"]],["region"]]],[0,"glb","rustc::infer","",N,N],[3,"Glb","rustc::infer::glb","\"Greatest lower bound\" (common subtype)",N,N],[12,"fields","","",251,N],[12,"a_is_expected","","",251,N],[11,"new","","",251,[[["combinefields"],["bool"]],["glb"]]],[11,"tag","","",251,[[["self"]],["str"]]],[11,"tcx","","",251,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",251,[[["self"]],["bool"]]],[11,"relate_with_variance","","",251,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",251,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",251,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",251,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[11,"infcx","","",251,[[["self"]],["inferctxt"]]],[11,"cause","","",251,[[["self"]],["obligationcause"]]],[11,"relate_bound","","",251,[[["self"],["ty"],["ty"],["ty"]],["relateresult"]]],[0,"higher_ranked","rustc::infer","Helper routines for higher-ranked things. See the `doc` module at the end of the file for details.",N,N],[3,"HrMatchResult","rustc::infer::higher_ranked","",N,N],[12,"value","","",252,N],[5,"var_ids","","",N,[[["combinefields"],["btreemap"]],["vec",["regionvid"]]]],[5,"is_var_in_set","","",N,N],[5,"fold_regions_in","","",N,[[["tyctxt"],["t"],["f"]],["t"]]],[11,"higher_ranked_sub","rustc::infer::combine","",237,[[["self"],["binder"],["binder"],["bool"]],["relateresult",["binder"]]]],[11,"higher_ranked_match","","The value consists of a pair `(t, u)` where `t` is the matcher and `u` is a value. The idea is to find a substitution `S` such that `S(t) == b`, and then return `S(u)`. In other words, find values for the late-bound regions in `a` that can make `t == b` and then replace the LBR in `u` with those values.",237,[[["self"],["binder"],["t"],["bool"]],["relateresult",["hrmatchresult"]]]],[11,"higher_ranked_lub","","",237,[[["self"],["binder"],["binder"],["bool"]],["relateresult",["binder"]]]],[11,"higher_ranked_glb","","",237,[[["self"],["binder"],["binder"],["bool"]],["relateresult",["binder"]]]],[11,"tainted_regions","rustc::infer","",208,[[["self"],["combinedsnapshot"],["region"],["taintdirections"]],["fxhashset",["region"]]]],[11,"region_vars_confined_to_snapshot","","Returns the set of region variables that do not affect any types/regions which existed before `snapshot` was started. This is used in the sub/lub/glb computations. The idea here is that when we are computing lub/glb of two regions, we sometimes create intermediate region variables. Those region variables may touch some of the skolemized or other \"forbidden\" regions we created to replace bound regions, but they don't really represent an \"external\" constraint.",208,[[["self"],["combinedsnapshot"]],["vec",["regionvid"]]]],[11,"skolemize_late_bound_regions","","Replace all regions bound by `binder` with skolemized regions and return a map indicating which bound-region was replaced with what skolemized region. This is the first step of checking subtyping when higher-ranked things are involved.",208,N],[11,"leak_check","","Searches the region constraints created since `snapshot` was started and checks to determine whether any of the skolemized regions created in `skol_map` would \"escape\" -- meaning that they are related to other regions in some way. If so, the higher-ranked subtyping doesn't hold. See `README.md` for more details.",208,[[["self"],["bool"],["span"],["skolemizationmap"],["combinedsnapshot"]],["relateresult"]]],[11,"plug_leaks","","This code converts from skolemized regions back to late-bound regions. It works by replacing each region in the taint set of a skolemized region with a bound-region. The bound region will be bound by the outer-most binder in `value`; the caller must ensure that there is such a binder and it is the right place.",208,[[["self"],["skolemizationmap"],["combinedsnapshot"],["t"]],["t"]]],[11,"pop_skolemized","","Pops the skolemized regions found in `skol_map` from the region inference context. Whenever you create skolemized regions via `skolemize_late_bound_regions`, they must be popped before you commit the enclosing snapshot (if you do not commit, e.g. within a probe or as a result of an error, then this is not necessary, as popping happens as part of the rollback).",208,[[["self"],["skolemizationmap"],["combinedsnapshot"]]]],[0,"lattice","","Lattice Variables",N,N],[5,"super_lattice_tys","rustc::infer::lattice","",N,[[["l"],["ty"],["ty"]],["relateresult",["ty"]]]],[8,"LatticeDir","","",N,N],[10,"infcx","","",253,[[["self"]],["inferctxt"]]],[10,"cause","","",253,[[["self"]],["obligationcause"]]],[10,"relate_bound","","",253,[[["self"],["ty"],["ty"],["ty"]],["relateresult"]]],[0,"lub","rustc::infer","",N,N],[3,"Lub","rustc::infer::lub","\"Least upper bound\" (common supertype)",N,N],[12,"fields","","",254,N],[12,"a_is_expected","","",254,N],[11,"new","","",254,[[["combinefields"],["bool"]],["lub"]]],[11,"tag","","",254,[[["self"]],["str"]]],[11,"tcx","","",254,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",254,[[["self"]],["bool"]]],[11,"relate_with_variance","","",254,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",254,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",254,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",254,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[11,"infcx","","",254,[[["self"]],["inferctxt"]]],[11,"cause","","",254,[[["self"]],["obligationcause"]]],[11,"relate_bound","","",254,[[["self"],["ty"],["ty"],["ty"]],["relateresult"]]],[0,"region_constraints","rustc::infer","See README.md",N,N],[3,"RegionConstraintCollector","rustc::infer::region_constraints","",N,N],[12,"var_infos","","For each `RegionVid`, the corresponding `RegionVariableOrigin`.",255,N],[12,"data","","",255,N],[12,"lubs","","For a given pair of regions (R1, R2), maps to a region R3 that is designated as their LUB (edges R1 <= R3 and R2 <= R3 exist). This prevents us from making many such regions.",255,N],[12,"glbs","","For a given pair of regions (R1, R2), maps to a region R3 that is designated as their GLB (edges R3 <= R1 and R3 <= R2 exist). This prevents us from making many such regions.",255,N],[12,"bound_count","","Global counter used during the GLB algorithm to create unique names for fresh bound regions",255,N],[12,"undo_log","","The undo log records actions that might later be undone.",255,N],[12,"unification_table","","When we add a R1 == R2 constriant, we currently add (a) edges R1 <= R2 and R2 <= R1 and (b) we unify the two regions in this table. You can then call `opportunistic_resolve_var` early which will map R1 and R2 to some common region (i.e., either R1 or R2). This is important when dropck and other such code is iterating to a fixed point, because otherwise we sometimes would wind up with a fresh stream of region variables that have been equated but appear distinct.",255,N],[12,"any_unifications","","a flag set to true when we perform any unifications; this is used to micro-optimize `take_and_reset_data`",255,N],[3,"RegionConstraintData","","The full set of region constraints gathered up by the collector. Describes constraints between the region variables and other regions, as well as other conditions that must be verified, or assumptions that can be made.",N,N],[12,"constraints","","Constraints of the form `A <= B`, where either `A` or `B` can be a region variable (or neither, as it happens).",256,N],[12,"verifys","","A \"verify\" is something that we need to verify after inference is done, but which does not directly affect inference in any way.",256,N],[12,"givens","","A \"given\" is a relationship that is known to hold. In particular, we often know from closure fn signatures that a particular free region must be a subregion of a region variable:",256,N],[3,"Verify","","VerifyGenericBound(T, _, R, RS): The parameter type `T` (or associated type) must outlive the region `R`. `T` is known to outlive `RS`. Therefore verify that `R <= RS[i]` for some `i`. Inference variables may be involved (but this verification step doesn't influence inference).",N,N],[12,"kind","","",257,N],[12,"origin","","",257,N],[12,"region","","",257,N],[12,"bound","","",257,N],[3,"TwoRegions","","",N,N],[12,"a","","",258,N],[12,"b","","",258,N],[3,"RegionVariableInfo","","",N,N],[12,"origin","","",259,N],[12,"universe","","",259,N],[3,"RegionSnapshot","","",N,N],[12,"length","","",260,N],[12,"region_snapshot","","",260,N],[12,"any_unifications","","",260,N],[3,"TaintDirections","","When working with skolemized regions, we often wish to find all of the regions that are either reachable from a skolemized region, or which can reach a skolemized region, or both. We call such regions tained regions.  This struct allows you to decide what set of tainted regions you want.",N,N],[12,"incoming","","",261,N],[12,"outgoing","","",261,N],[4,"Constraint","","A constraint that influences the inference process.",N,N],[13,"VarSubVar","","One region variable is subregion of another",262,N],[13,"RegSubVar","","Concrete region is subregion of region variable",262,N],[13,"VarSubReg","","Region variable is subregion of concrete region. This does not directly affect inference, but instead is checked after inference is complete.",262,N],[13,"RegSubReg","","A constraint where neither side is a variable. This does not directly affect inference, but instead is checked after inference is complete.",262,N],[4,"GenericKind","","",N,N],[13,"Param","","",263,N],[13,"Projection","","",263,N],[4,"VerifyBound","","When we introduce a verification step, we wish to test that a particular region (let's call it `'min`) meets some bound. The bound is described the by the following grammar:",N,N],[13,"AnyRegion","","B = exists {R} --> some 'r in {R} must outlive 'min",264,N],[13,"AllRegions","","B = forall {R} --> all 'r in {R} must outlive 'min",264,N],[13,"AnyBound","","B = exists {B} --> 'min must meet some bound b in {B}",264,N],[13,"AllBounds","","B = forall {B} --> 'min must meet all bounds b in {B}",264,N],[4,"UndoLogEntry","","",N,N],[13,"OpenSnapshot","","Pushed when we start a snapshot.",265,N],[13,"CommitedSnapshot","","Replaces an `OpenSnapshot` when a snapshot is committed, but that snapshot is not the root. If the root snapshot is unrolled, all nested snapshots must be committed.",265,N],[13,"AddVar","","We added `RegionVid`",265,N],[13,"AddConstraint","","We added the given `constraint`",265,N],[13,"AddVerify","","We added the given `verify`",265,N],[13,"AddGiven","","We added the given `given`",265,N],[13,"AddCombination","","We added a GLB/LUB \"combination variable\"",265,N],[13,"Purged","","During skolemization, we sometimes purge entries from the undo log in a kind of minisnapshot (unlike other snapshots, this purging actually takes place on success). In that case, we replace the corresponding entry with `Noop` so as to avoid the need to do a bunch of swapping. (We can't use `swap_remove` as the order of the vector is important.)",265,N],[4,"CombineMapType","","",N,N],[13,"Lub","","",266,N],[13,"Glb","","",266,N],[0,"taint","","",N,N],[3,"TaintSet","rustc::infer::region_constraints::taint","",N,N],[12,"directions","","",267,N],[12,"regions","","",267,N],[11,"fmt","","",267,[[["self"],["formatter"]],["result"]]],[11,"new","","",267,[[["taintdirections"],["region"]],["self"]]],[11,"fixed_point","","",267,N],[11,"into_set","","",267,[[["self"]],["fxhashset",["region"]]]],[11,"len","","",267,[[["self"]],["usize"]]],[11,"add_edge","","",267,[[["self"],["region"],["region"]]]],[6,"VarInfos","rustc::infer::region_constraints","",N,N],[6,"CombineMap","","",N,N],[11,"fmt","","",256,[[["self"],["formatter"]],["result"]]],[11,"default","","",256,[[],["regionconstraintdata"]]],[11,"clone","","",256,[[["self"]],["regionconstraintdata"]]],[11,"clone","","",262,[[["self"]],["constraint"]]],[11,"eq","","",262,[[["self"],["constraint"]],["bool"]]],[11,"ne","","",262,[[["self"],["constraint"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",262,N],[11,"hash","","",262,N],[11,"fmt","","",262,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",262,[[["self"],["constraint"]],["option",["ordering"]]]],[11,"lt","","",262,[[["self"],["constraint"]],["bool"]]],[11,"le","","",262,[[["self"],["constraint"]],["bool"]]],[11,"gt","","",262,[[["self"],["constraint"]],["bool"]]],[11,"ge","","",262,[[["self"],["constraint"]],["bool"]]],[11,"cmp","","",262,[[["self"],["constraint"]],["ordering"]]],[11,"fmt","","",257,[[["self"],["formatter"]],["result"]]],[11,"clone","","",257,[[["self"]],["verify"]]],[11,"clone","","",263,[[["self"]],["generickind"]]],[11,"eq","","",263,[[["self"],["generickind"]],["bool"]]],[11,"ne","","",263,[[["self"],["generickind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",263,N],[11,"fmt","","",264,[[["self"],["formatter"]],["result"]]],[11,"clone","","",264,[[["self"]],["verifybound"]]],[11,"clone","","",258,[[["self"]],["tworegions"]]],[11,"eq","","",258,[[["self"],["tworegions"]],["bool"]]],[11,"ne","","",258,[[["self"],["tworegions"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",258,N],[11,"hash","","",258,N],[11,"clone","","",265,[[["self"]],["undologentry"]]],[11,"eq","","",265,[[["self"],["undologentry"]],["bool"]]],[11,"ne","","",265,[[["self"],["undologentry"]],["bool"]]],[11,"clone","","",266,[[["self"]],["combinemaptype"]]],[11,"eq","","",266,[[["self"],["combinemaptype"]],["bool"]]],[11,"fmt","","",259,[[["self"],["formatter"]],["result"]]],[11,"clone","","",259,[[["self"]],["regionvariableinfo"]]],[11,"fmt","","",261,[[["self"],["formatter"]],["result"]]],[11,"incoming","","",261,[[],["self"]]],[11,"outgoing","","",261,[[],["self"]]],[11,"both","","",261,[[],["self"]]],[11,"new","","",255,[[],["regionconstraintcollector"]]],[11,"num_region_vars","","",255,[[["self"]],["usize"]]],[11,"region_constraint_data","","",255,[[["self"]],["regionconstraintdata"]]],[11,"into_infos_and_data","","Once all the constraints have been gathered, extract out the final data.",255,N],[11,"take_and_reset_data","","Takes (and clears) the current set of constraints. Note that the set of variables remains intact, but all relationships between them are reset.  This is used during NLL checking to grab the set of constraints that arose from a particular operation.",255,[[["self"]],["regionconstraintdata"]]],[11,"data","","",255,[[["self"]],["regionconstraintdata"]]],[11,"in_snapshot","","",255,[[["self"]],["bool"]]],[11,"start_snapshot","","",255,[[["self"]],["regionsnapshot"]]],[11,"commit","","",255,[[["self"],["regionsnapshot"]]]],[11,"rollback_to","","",255,[[["self"],["regionsnapshot"]]]],[11,"rollback_undo_entry","","",255,[[["self"],["undologentry"]]]],[11,"new_region_var","","",255,[[["self"],["universeindex"],["regionvariableorigin"]],["regionvid"]]],[11,"var_universe","","Returns the universe for the given variable.",255,[[["self"],["regionvid"]],["universeindex"]]],[11,"var_origin","","Returns the origin for the given variable.",255,[[["self"],["regionvid"]],["regionvariableorigin"]]],[11,"pop_skolemized","","Removes all the edges to/from the skolemized regions that are in `skols`. This is used after a higher-ranked operation completes to remove all trace of the skolemized regions created in that time.",255,[[["self"],["universeindex"],["fxhashset"],["regionsnapshot"]]]],[11,"new_bound","","",255,[[["self"],["tyctxt"],["debruijnindex"]],["region"]]],[11,"add_constraint","","",255,[[["self"],["constraint"],["subregionorigin"]]]],[11,"add_verify","","",255,[[["self"],["verify"]]]],[11,"add_given","","",255,[[["self"],["region"],["regionvid"]]]],[11,"make_eqregion","","",255,[[["self"],["subregionorigin"],["region"],["region"]]]],[11,"make_subregion","","",255,[[["self"],["subregionorigin"],["region"],["region"]]]],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",255,[[["self"],["subregionorigin"],["generickind"],["region"],["verifybound"]]]],[11,"lub_regions","","",255,[[["self"],["tyctxt"],["subregionorigin"],["region"],["region"]],["region"]]],[11,"glb_regions","","",255,[[["self"],["tyctxt"],["subregionorigin"],["region"],["region"]],["region"]]],[11,"opportunistic_resolve_var","","",255,[[["self"],["tyctxt"],["regionvid"]],["region"]]],[11,"combine_map","","",255,[[["self"],["combinemaptype"]],["fxhashmap"]]],[11,"combine_vars","","",255,[[["self"],["tyctxt"],["combinemaptype"],["region"],["region"],["subregionorigin"]],["region"]]],[11,"universe","","",255,[[["self"],["region"]],["universeindex"]]],[11,"vars_created_since_snapshot","","",255,[[["self"],["regionsnapshot"]],["vec",["regionvid"]]]],[11,"tainted","","Computes all regions that have been related to `r0` since the mark `mark` was made---`r0` itself will be the first entry. The `directions` parameter controls what kind of relations are considered. For example, one can say that only \"incoming\" edges to `r0` are desired, in which case one will get the set of regions `{r|r <= r0}`. This is used when checking whether skolemized regions are being improperly related to other regions.",255,[[["self"],["tyctxt"],["regionsnapshot"],["region"],["taintdirections"]],["fxhashset",["region"]]]],[11,"fmt","","",260,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",263,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",263,[[["self"],["formatter"]],["result"]]],[11,"to_ty","","",263,[[["self"],["tyctxt"]],["ty"]]],[11,"for_each_region","","",264,[[["self"],["fnmut"]]]],[11,"must_hold","","",264,[[["self"]],["bool"]]],[11,"cannot_hold","","",264,[[["self"]],["bool"]]],[11,"or","","",264,[[["self"],["verifybound"]],["verifybound"]]],[11,"and","","",264,[[["self"],["verifybound"]],["verifybound"]]],[11,"is_empty","","True if this region constraint data contains no constraints.",256,[[["self"]],["bool"]]],[0,"lexical_region_resolve","rustc::infer","The code to do lexical region resolution.",N,N],[3,"LexicalRegionResolutions","rustc::infer::lexical_region_resolve","Contains the result of lexical region resolution. Offers methods to lookup up the final value of a region variable.",N,N],[12,"values","","",268,N],[12,"error_region","","",268,N],[3,"RegionAndOrigin","","",N,N],[12,"region","","",269,N],[12,"origin","","",269,N],[3,"LexicalResolver","","",N,N],[12,"region_rels","","",270,N],[12,"var_infos","","",270,N],[12,"data","","",270,N],[4,"VarValue","","",N,N],[13,"Value","","",271,N],[13,"ErrorValue","","",271,N],[4,"RegionResolutionError","","",N,N],[13,"ConcreteFailure","","`ConcreteFailure(o, a, b)`:",272,N],[13,"GenericBoundFailure","","`GenericBoundFailure(p, s, a)",272,N],[13,"SubSupConflict","","`SubSupConflict(v, sub_origin, sub_r, sup_origin, sup_r)`:",272,N],[5,"resolve","","This function performs lexical region resolution given a complete set of constraints and variable origins. It performs a fixed-point iteration to find region values which satisfy all constraints, assuming such values can be found. It returns the final values of all the variables as well as a set of errors that must be reported.",N,N],[0,"graphviz","","This module provides linkage between libgraphviz traits and `rustc::middle::typeck::infer::region_constraints`, generating a rendering of the graph represented by the list of `Constraint` instances (which make up the edges of the graph), as well as the origin for each constraint (which are attached to the labels on each edge).",N,N],[3,"ConstraintGraph","rustc::infer::lexical_region_resolve::graphviz","",N,N],[12,"graph_name","","",273,N],[12,"region_rels","","",273,N],[12,"map","","",273,N],[12,"node_ids","","",273,N],[4,"Node","","",N,N],[13,"RegionVid","","",274,N],[13,"Region","","",274,N],[4,"Edge","","",N,N],[13,"Constraint","","",275,N],[13,"EnclScope","","",275,N],[5,"print_help_message","","",N,[[]]],[5,"maybe_print_constraints_for","","",N,[[["regionconstraintdata"],["regionrelations"]]]],[5,"constraint_to_nodes","","",N,N],[5,"edge_to_nodes","","",N,N],[5,"dump_region_data_to","","",N,[[["regionrelations"],["btreemap"],["str"]],["result"]]],[6,"ConstraintMap","","",N,N],[11,"clone","","",274,[[["self"]],["node"]]],[11,"hash","","",274,N],[11,"eq","","",274,[[["self"],["node"]],["bool"]]],[11,"ne","","",274,[[["self"],["node"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",274,N],[11,"fmt","","",274,[[["self"],["formatter"]],["result"]]],[11,"clone","","",275,[[["self"]],["edge"]]],[11,"eq","","",275,[[["self"],["edge"]],["bool"]]],[11,"ne","","",275,[[["self"],["edge"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",275,N],[11,"fmt","","",275,[[["self"],["formatter"]],["result"]]],[11,"new","","",273,[[["string"],["regionrelations"],["btreemap"]],["constraintgraph"]]],[11,"graph_id","","",273,[[["self"]],["id"]]],[11,"node_id","","",273,[[["self"],["node"]],["id"]]],[11,"node_label","","",273,[[["self"],["node"]],["labeltext"]]],[11,"edge_label","","",273,[[["self"],["edge"]],["labeltext"]]],[11,"nodes","","",273,[[["self"]],["nodes",["node"]]]],[11,"edges","","",273,[[["self"]],["edges",["edge"]]]],[11,"source","","",273,[[["self"],["edge"]],["node"]]],[11,"target","","",273,[[["self"],["edge"]],["node"]]],[6,"RegionGraph","rustc::infer::lexical_region_resolve","",N,N],[11,"clone","","",271,[[["self"]],["varvalue"]]],[11,"fmt","","",271,[[["self"],["formatter"]],["result"]]],[11,"clone","","",272,[[["self"]],["regionresolutionerror"]]],[11,"fmt","","",272,[[["self"],["formatter"]],["result"]]],[11,"infer_variable_values","","",270,[[["self"],["vec"]],["lexicalregionresolutions"]]],[11,"num_vars","","",270,[[["self"]],["usize"]]],[11,"construct_var_data","","Initially, the value for all variables is set to `'empty`, the empty region. The `expansion` phase will grow this larger.",270,[[["self"],["tyctxt"]],["lexicalregionresolutions"]]],[11,"dump_constraints","","",270,[[["self"],["regionrelations"]]]],[11,"expand_givens","","",270,[[["self"],["graph"]]]],[11,"expansion","","",270,[[["self"],["lexicalregionresolutions"]]]],[11,"expand_node","","",270,[[["self"],["region"],["regionvid"],["varvalue"]],["bool"]]],[11,"lub_concrete_regions","","",270,[[["self"],["region"],["region"]],["region"]]],[11,"collect_errors","","After expansion is complete, go and check upper bounds (i.e., cases where the region cannot grow larger than a fixed point) and check that they are satisfied.",270,[[["self"],["lexicalregionresolutions"],["vec"]]]],[11,"collect_var_errors","","Go over the variables that were declared to be error variables and create a `RegionResolutionError` for each of them.",270,[[["self"],["lexicalregionresolutions"],["graph"],["vec"]]]],[11,"construct_graph","","",270,[[["self"]],["graph",["constraint"]]]],[11,"collect_error_for_expanding_node","","",270,N],[11,"collect_concrete_regions","","",270,N],[11,"iterate_until_fixed_point","","",270,[[["self"],["str"],["f"]]]],[11,"bound_is_met","","",270,[[["self"],["verifybound"],["lexicalregionresolutions"],["region"]],["bool"]]],[11,"fmt","","",269,[[["self"],["formatter"]],["result"]]],[11,"normalize","","",268,[[["self"],["region"]],["region"]]],[11,"value","","",268,[[["self"],["regionvid"]],["varvalue"]]],[11,"value_mut","","",268,[[["self"],["regionvid"]],["varvalue"]]],[11,"resolve_var","","",268,[[["self"],["regionvid"]],["region"]]],[0,"outlives","rustc::infer","Various code related to computing outlives relations.",N,N],[0,"env","rustc::infer::outlives","",N,N],[3,"OutlivesEnvironment","rustc::infer::outlives::env","The `OutlivesEnvironment` collects information about what outlives what in a given type-checking setting. For example, if we have a where-clause like `where T: 'a` in scope, then the `OutlivesEnvironment` would record that (in its `region_bound_pairs` field). Similarly, it contains methods for processing and adding implied bounds into the outlives environment.",N,N],[12,"param_env","","",276,N],[12,"free_region_map","","",276,N],[12,"region_bound_pairs","","",276,N],[11,"clone","","",276,[[["self"]],["outlivesenvironment"]]],[11,"new","","",276,[[["paramenv"]],["self"]]],[11,"free_region_map","","Borrows current value of the `free_region_map`.",276,[[["self"]],["freeregionmap"]]],[11,"region_bound_pairs","","Borrows current value of the `region_bound_pairs`.",276,N],[11,"into_free_region_map","","Returns ownership of the `free_region_map`.",276,[[["self"]],["freeregionmap"]]],[11,"push_snapshot_pre_closure","","This is a hack to support the old-skool regionck, which processes region constraints from the main function and the closure together. In that context, when we enter a closure, we want to be able to \"save\" the state of the surrounding a function. We can then add implied bounds and the like from the closure arguments into the environment -- these should only apply in the closure body, so once we exit, we invoke `pop_snapshot_post_closure` to remove them.",276,[[["self"]],["usize"]]],[11,"pop_snapshot_post_closure","","See `push_snapshot_pre_closure`.",276,[[["self"],["usize"]]]],[11,"add_implied_bounds","","This method adds \"implied bounds\" into the outlives environment. Implied bounds are outlives relationships that we can deduce on the basis that certain types must be well-formed -- these are either the types that appear in the function signature or else the input types to an impl. For example, if you have a function like",276,N],[11,"add_outlives_bounds","","Processes outlives bounds that are known to hold, whether from implied or other sources.",276,[[["self"],["option",["inferctxt"]],["i"]]]],[0,"free_region_map","rustc::infer::outlives","",N,N],[3,"FreeRegionMap","rustc::infer::outlives::free_region_map","",N,N],[12,"relation","","",277,N],[5,"is_free","","",N,[[["region"]],["bool"]]],[5,"is_free_or_static","","",N,[[["region"]],["bool"]]],[8,"FreeRegionRelations","","The NLL region handling code represents free region relations in a slightly different way; this trait allows functions to be abstract over which version is in use.",N,N],[10,"sub_free_regions","","Tests whether `r_a <= r_b`. Both must be free regions or `'static`.",278,[[["self"],["region"],["region"]],["bool"]]],[11,"clone","","",277,[[["self"]],["freeregionmap"]]],[11,"encode","","",277,[[["self"],["__s"]],["result"]]],[11,"decode","","",277,[[["__d"]],["result",["freeregionmap"]]]],[11,"fmt","","",277,[[["self"],["formatter"]],["result"]]],[11,"new","","",277,[[],["self"]]],[11,"is_empty","","",277,[[["self"]],["bool"]]],[11,"relate_regions","","",277,[[["self"],["region"],["region"]]]],[11,"lub_free_regions","","Compute the least-upper-bound of two free regions. In some cases, this is more conservative than necessary, in order to avoid making arbitrary choices. See `TransitiveRelation::postdom_upper_bound` for more details.",277,[[["self"],["tyctxt"],["region"],["region"]],["region"]]],[11,"sub_free_regions","","",277,[[["self"],["region"],["region"]],["bool"]]],[11,"hash_stable","","",277,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"lift_to_tcx","","",277,[[["self"],["tyctxt"]],["option",["freeregionmap"]]]],[0,"obligations","rustc::infer::outlives","Code that handles \"type-outlives\" constraints like `T: 'a`. This is based on the `outlives_components` function defined on the tcx, but it adds a bit of heuristics on top, in particular to deal with associated types and projections.",N,N],[3,"TypeOutlives","rustc::infer::outlives::obligations","The `TypeOutlives` struct has the job of \"lowering\" a `T: 'a` obligation into a series of `'a: 'b` constraints and \"verifys\", as described on the module comment. The final constraints are emitted via a \"delegate\" of type `D` -- this is usually the `infcx`, which accrues them into the `region_obligations` code, but for NLL we use something else.",N,N],[12,"delegate","","",279,N],[12,"tcx","","",279,N],[12,"region_bound_pairs","","",279,N],[12,"implicit_region_bound","","",279,N],[12,"param_env","","",279,N],[8,"TypeOutlivesDelegate","","",N,N],[10,"push_sub_region_constraint","","",280,[[["self"],["subregionorigin"],["region"],["region"]]]],[10,"push_verify","","",280,[[["self"],["subregionorigin"],["generickind"],["region"],["verifybound"]]]],[11,"register_region_obligation","rustc::infer","Registers that the given region obligation must be resolved from within the scope of `body_id`. These regions are enqueued and later processed by regionck, when full type information is available (see `region_obligations` field for more information).",208,[[["self"],["nodeid"],["regionobligation"]]]],[11,"take_registered_region_obligations","","Trait queries just want to pass back type obligations \"as is\"",208,[[["self"]],["vec"]]],[11,"process_registered_region_obligations","","Process the region obligations that must be proven (during `regionck`) for the given `body_id`, given information about the region bounds in scope and so forth. This function must be invoked for all relevant body-ids before region inference is done (or else an assert will fire).",208,N],[11,"type_must_outlive","","Processes a single ad-hoc region obligation that was not registered in advance.",208,N],[11,"new","rustc::infer::outlives::obligations","",279,N],[11,"type_must_outlive","","Adds constraints to inference such that `T: 'a` holds (or reports an error if it cannot).",279,[[["self"],["subregionorigin"],["ty"],["region"]]]],[11,"components_must_outlive","","",279,[[["self"],["subregionorigin"],["vec",["component"]],["region"]]]],[11,"param_ty_must_outlive","","",279,[[["self"],["subregionorigin"],["region"],["paramty"]]]],[11,"projection_must_outlive","","",279,[[["self"],["subregionorigin"],["region"],["projectionty"]]]],[11,"type_bound","","",279,[[["self"],["ty"]],["verifybound"]]],[11,"param_bound","","",279,[[["self"],["paramty"]],["verifybound"]]],[11,"projection_declared_bounds","","",279,[[["self"],["projectionty"]],["vec",["region"]]]],[11,"projection_bound","","",279,[[["self"],["vec",["region"]],["projectionty"]],["verifybound"]]],[11,"recursive_type_bound","","",279,[[["self"],["ty"]],["verifybound"]]],[11,"declared_generic_bounds_from_env","","",279,[[["self"],["generickind"]],["vec",["region"]]]],[11,"declared_projection_bounds_from_trait","","Given a projection like `<T as Foo<'x>>::Bar`, returns any bounds declared in the trait definition. For example, if the trait were",279,[[["self"],["projectionty"]],["vec",["region"]]]],[11,"region_bounds_declared_on_associated_item","","Given the def-id of an associated item, returns any region bounds attached to that associated item from the trait definition.",279,[[["self"],["defid"]],["vec",["region"]]]],[11,"collect_outlives_from_predicate_list","","Searches through a predicate list for a predicate `T: 'a`.",279,[[["self"],["ty"],["i"]],["vec",["region"]]]],[0,"resolve","rustc::infer","",N,N],[3,"OpportunisticTypeResolver","rustc::infer::resolve","The opportunistic type resolver can be used at any time. It simply replaces type variables that have been unified with the things they have been unified with (similar to `shallow_resolve`, but deep). This is useful for printing messages etc but also required at various points for correctness.",N,N],[12,"infcx","","",281,N],[3,"OpportunisticTypeAndRegionResolver","","The opportunistic type and region resolver is similar to the opportunistic type resolver, but also opportunistically resolves regions. It is useful for canonicalization.",N,N],[12,"infcx","","",282,N],[3,"UnresolvedTypeFinder","","The unresolved type finder walks your type and searches for type variables that don't yet have a value. They get pushed into a vector. It does not construct the fully resolved type (which might involve some hashing and so forth).",N,N],[12,"infcx","","",283,N],[3,"FullTypeResolver","","",N,N],[12,"infcx","","",284,N],[12,"err","","",284,N],[5,"fully_resolve","","Full type resolution replaces all type and region variables with their concrete results. If any variable cannot be replaced (never unified, etc) then an `Err` result is returned.",N,[[["inferctxt"],["t"]],["fixupresult"]]],[11,"new","","",281,[[["inferctxt"]],["self"]]],[11,"tcx","","",281,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",281,[[["self"],["ty"]],["ty"]]],[11,"new","","",282,[[["inferctxt"]],["self"]]],[11,"tcx","","",282,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",282,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",282,[[["self"],["region"]],["region"]]],[11,"new","","",283,[[["inferctxt"]],["self"]]],[11,"visit_ty","","",283,[[["self"],["ty"]],["bool"]]],[11,"tcx","","",284,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",284,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",284,[[["self"],["region"]],["region"]]],[0,"freshen","rustc::infer","Freshening is the process of replacing unknown variables with fresh types. The idea is that the type, after freshening, contains no inference variables but instead contains either a value for each variable or fresh \"arbitrary\" types wherever a variable would have been.",N,N],[3,"TypeFreshener","rustc::infer::freshen","",N,N],[12,"infcx","","",206,N],[12,"freshen_count","","",206,N],[12,"freshen_map","","",206,N],[11,"new","rustc::infer","",206,[[["inferctxt"]],["typefreshener"]]],[11,"freshen","","",206,[[["self"],["option",["ty"]],["inferty"],["f"]],["ty"]]],[11,"tcx","","",206,[[["self"]],["tyctxt"]]],[11,"fold_region","","",206,[[["self"],["region"]],["region"]]],[11,"fold_ty","","",206,[[["self"],["ty"]],["ty"]]],[0,"sub","","",N,N],[3,"Sub","rustc::infer::sub","Ensures `a` is made a subtype of `b`. Returns `a` on success.",N,N],[12,"fields","","",285,N],[12,"a_is_expected","","",285,N],[11,"new","","",285,[[["combinefields"],["bool"]],["sub"]]],[11,"with_expected_switched","","",285,[[["self"],["f"]],["r"]]],[11,"tag","","",285,[[["self"]],["str"]]],[11,"tcx","","",285,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",285,[[["self"]],["bool"]]],[11,"with_cause","","",285,[[["self"],["cause"],["f"]],["r"]]],[11,"relate_with_variance","","",285,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",285,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",285,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",285,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[0,"type_variable","rustc::infer","",N,N],[3,"TypeVariableTable","rustc::infer::type_variable","",N,N],[12,"values","","",286,N],[12,"eq_relations","","Two variables are unified in `eq_relations` when we have a constraint `?X == ?Y`. This table also stores, for each key, the known value.",286,N],[12,"sub_relations","","Two variables are unified in `eq_relations` when we have a constraint `?X <: ?Y` or a constraint `?Y <: ?X`. This second table exists only to help with the occurs check. In particular, we want to report constraints like these as an occurs check violation:",286,N],[3,"TypeVariableData","","",N,N],[12,"origin","","",287,N],[12,"diverging","","",287,N],[3,"Snapshot","","",N,N],[12,"snapshot","","",288,N],[12,"eq_snapshot","","",288,N],[12,"sub_snapshot","","",288,N],[3,"Instantiate","","",N,N],[12,"vid","","",289,N],[3,"Delegate","","",N,N],[3,"TyVidEqKey","","These structs (a newtyped TyVid) are used as the unification key for the `eq_relations`; they carry a `TypeVariableValue` along with them.",N,N],[12,"vid","","",290,N],[12,"phantom","","",290,N],[4,"TypeVariableOrigin","","Reasons to create a type inference variable",N,N],[13,"MiscVariable","","",291,N],[13,"NormalizeProjectionType","","",291,N],[13,"TypeInference","","",291,N],[13,"TypeParameterDefinition","","",291,N],[13,"ClosureSynthetic","","one of the upvars or closure kind parameters in a `ClosureSubsts` (before it has been determined)",291,N],[13,"SubstitutionPlaceholder","","",291,N],[13,"AutoDeref","","",291,N],[13,"AdjustmentType","","",291,N],[13,"DivergingStmt","","",291,N],[13,"DivergingBlockExpr","","",291,N],[13,"DivergingFn","","",291,N],[13,"LatticeVariable","","",291,N],[13,"Generalized","","",291,N],[4,"TypeVariableValue","","",N,N],[13,"Known","","",292,N],[12,"value","rustc::infer::type_variable::TypeVariableValue","",292,N],[13,"Unknown","rustc::infer::type_variable","",292,N],[12,"universe","rustc::infer::type_variable::TypeVariableValue","",292,N],[6,"TypeVariableMap","rustc::infer::type_variable","",N,N],[11,"clone","","",291,[[["self"]],["typevariableorigin"]]],[11,"fmt","","",291,[[["self"],["formatter"]],["result"]]],[11,"clone","","",292,[[["self"]],["typevariablevalue"]]],[11,"fmt","","",292,[[["self"],["formatter"]],["result"]]],[11,"known","","If this value is known, returns the type it is known to be. Otherwise, `None`.",292,[[["self"]],["option",["ty"]]]],[11,"is_unknown","","",292,[[["self"]],["bool"]]],[11,"new","","",286,[[],["typevariabletable"]]],[11,"var_diverges","","Returns the diverges flag given when `vid` was created.",286,[[["self"],["tyvid"]],["bool"]]],[11,"var_origin","","Returns the origin that was given when `vid` was created.",286,[[["self"],["tyvid"]],["typevariableorigin"]]],[11,"equate","","Records that `a == b`, depending on `dir`.",286,[[["self"],["tyvid"],["tyvid"]]]],[11,"sub","","Records that `a <: b`, depending on `dir`.",286,[[["self"],["tyvid"],["tyvid"]]]],[11,"instantiate","","Instantiates `vid` with the type `ty`.",286,[[["self"],["tyvid"],["ty"]]]],[11,"new_var","","Creates a new type variable.",286,[[["self"],["universeindex"],["bool"],["typevariableorigin"]],["tyvid"]]],[11,"num_vars","","Returns the number of type variables created thus far.",286,[[["self"]],["usize"]]],[11,"root_var","","Returns the \"root\" variable of `vid` in the `eq_relations` equivalence table. All type variables that have been equated will yield the same root variable (per the union-find algorithm), so `root_var(a) == root_var(b)` implies that `a == b` (transitively).",286,[[["self"],["tyvid"]],["tyvid"]]],[11,"sub_root_var","","Returns the \"root\" variable of `vid` in the `sub_relations` equivalence table. All type variables that have been are related via equality or subtyping will yield the same root variable (per the union-find algorithm), so `sub_root_var(a) == sub_root_var(b)` implies that:",286,[[["self"],["tyvid"]],["tyvid"]]],[11,"sub_unified","","True if `a` and `b` have same \"sub-root\" (i.e., exists some type X such that `forall i in {a, b}. (i <: X || X <: i)`.",286,[[["self"],["tyvid"],["tyvid"]],["bool"]]],[11,"probe","","Retrieves the type to which `vid` has been instantiated, if any.",286,[[["self"],["tyvid"]],["typevariablevalue"]]],[11,"replace_if_possible","","If `t` is a type-inference variable, and it has been instantiated, then return the with which it was instantiated. Otherwise, returns `t`.",286,[[["self"],["ty"]],["ty"]]],[11,"snapshot","","Creates a snapshot of the type variable state.  This snapshot must later be committed (`commit()`) or rolled back (`rollback_to()`).  Nested snapshots are permitted, but must be processed in a stack-like fashion.",286,[[["self"]],["snapshot"]]],[11,"rollback_to","","Undoes all changes since the snapshot was created. Any snapshots created since that point must already have been committed or rolled back.",286,[[["self"],["snapshot"]]]],[11,"commit","","Commits all changes since the snapshot was created, making them permanent (unless this snapshot was created within another snapshot). Any snapshots created since that point must already have been committed or rolled back.",286,[[["self"],["snapshot"]]]],[11,"types_created_since_snapshot","","Returns a map `{V1 -> V2}`, where the keys `{V1}` are ty-variables created during the snapshot, and the values `{V2}` are the root variables that they were unified with, along with their origin.",286,[[["self"],["snapshot"]],["typevariablemap"]]],[11,"types_escaping_snapshot","","Find the set of type variables that existed before `s` but which have only been unified since `s` started, and return the types with which they were unified. So if we had a type variable `V0`, then we started the snapshot, then we created a type variable `V1`, unifed `V0` with `T0`, and unified `V1` with `T1`, this function would return `{T0}`.",286,[[["self"],["snapshot"]],["vec",["ty"]]]],[11,"unsolved_variables","","Returns indices of all variables that are not yet instantiated.",286,[[["self"]],["vec",["tyvid"]]]],[11,"reverse","","",293,[[["vec"],["instantiate"]]]],[11,"clone","","",290,[[["self"]],["tyvideqkey"]]],[11,"fmt","","",290,[[["self"],["formatter"]],["result"]]],[11,"eq","","",290,[[["self"],["tyvideqkey"]],["bool"]]],[11,"ne","","",290,[[["self"],["tyvideqkey"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",290,N],[11,"from","","",290,[[["tyvid"]],["self"]]],[11,"index","","",290,[[["self"]],["u32"]]],[11,"from_index","","",290,[[["u32"]],["self"]]],[11,"tag","","",290,[[],["str"]]],[11,"unify_values","","",292,[[["self"],["self"]],["result",["noerror"]]]],[0,"unify_key","rustc::infer","",N,N],[3,"RegionVidKey","rustc::infer::unify_key","",N,N],[12,"min_vid","","The minimum region vid in the unification set. This is needed to have a canonical name for a type to prevent infinite recursion.",294,N],[8,"ToType","","",N,N],[10,"to_type","","",295,[[["self"],["tyctxt"]],["ty"]]],[11,"eq","","",294,[[["self"],["regionvidkey"]],["bool"]]],[11,"ne","","",294,[[["self"],["regionvidkey"]],["bool"]]],[11,"clone","","",294,[[["self"]],["regionvidkey"]]],[11,"fmt","","",294,[[["self"],["formatter"]],["result"]]],[11,"unify_values","","",294,[[["self"],["self"]],["result",["noerror"]]]],[6,"InferResult","rustc::infer","",N,N],[6,"Bound","","",N,N],[6,"UnitResult","","",N,N],[6,"FixupResult","","",N,N],[6,"SkolemizationMap","","A map returned by `skolemize_late_bound_regions()` indicating the skolemized region that each late-bound region was replaced with.",N,N],[11,"fmt","","",207,[[["self"],["formatter"]],["result"]]],[11,"clone","","",213,[[["self"]],["valuepairs"]]],[11,"fmt","","",213,[[["self"],["formatter"]],["result"]]],[11,"clone","","",209,[[["self"]],["typetrace"]]],[11,"clone","","",214,[[["self"]],["subregionorigin"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"clone","","",215,[[["self"]],["parameterorigin"]]],[11,"fmt","","",215,[[["self"],["formatter"]],["result"]]],[11,"clone","","",216,[[["self"]],["lateboundregionconversiontime"]]],[11,"fmt","","",216,[[["self"],["formatter"]],["result"]]],[11,"clone","","",217,[[["self"]],["regionvariableorigin"]]],[11,"fmt","","",217,[[["self"],["formatter"]],["result"]]],[11,"clone","","",218,[[["self"]],["nllregionvariableorigin"]]],[11,"fmt","","",218,[[["self"],["formatter"]],["result"]]],[11,"eq","","",218,[[["self"],["nllregionvariableorigin"]],["bool"]]],[11,"ne","","",218,[[["self"],["nllregionvariableorigin"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",218,N],[11,"hash","","",218,N],[11,"is_universal","","",218,[[["self"]],["bool"]]],[11,"is_existential","","",218,[[["self"]],["bool"]]],[11,"clone","","",219,[[["self"]],["fixuperror"]]],[11,"fmt","","",219,[[["self"],["formatter"]],["result"]]],[11,"clone","","",210,[[["self"]],["regionobligation"]]],[11,"fmt","","",219,[[["self"],["formatter"]],["result"]]],[11,"with_fresh_in_progress_tables","","Used only by `rustc_typeck` during body type-checking/inference, will initialize `in_progress_tables` with fresh `TypeckTables`.",211,[[["self"],["defid"]],["self"]]],[11,"enter","","",211,[[["self"],["f"]],["r"]]],[11,"unit","","",207,[[["self"]],["inferok"]]],[11,"into_value_registering_obligations","","Extract `value`, registering any obligations into `fulfill_cx`",207,N],[11,"into_obligations","","",207,[[["self"]],["predicateobligations"]]],[11,"is_in_snapshot","","",208,[[["self"]],["bool"]]],[11,"freshen","","",208,[[["self"],["t"]],["t"]]],[11,"type_var_diverges","","",208,[[["self"],["ty"]],["bool"]]],[11,"freshener","","",208,[[["self"]],["typefreshener"]]],[11,"type_is_unconstrained_numeric","","",208,[[["self"],["ty"]],["unconstrainednumeric"]]],[11,"unsolved_variables","","",208,[[["self"]],["vec",["ty"]]]],[11,"combine_fields","","",208,[[["self"],["typetrace"],["paramenv"]],["combinefields"]]],[11,"save_and_restore_in_snapshot_flag","","",208,[[["self"],["f"]],["r"]]],[11,"start_snapshot","","",208,[[["self"]],["combinedsnapshot"]]],[11,"rollback_to","","",208,[[["self"],["str"],["combinedsnapshot"]]]],[11,"commit_from","","",208,[[["self"],["combinedsnapshot"]]]],[11,"commit_unconditionally","","Execute `f` and commit the bindings",208,[[["self"],["f"]],["r"]]],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",208,[[["self"],["f"]],["result"]]],[11,"in_snapshot","","",208,[[["self"],["f"]],["t"]]],[11,"probe","","Execute `f` then unroll any bindings it creates",208,[[["self"],["f"]],["r"]]],[11,"add_given","","",208,[[["self"],["region"],["regionvid"]]]],[11,"can_sub","","",208,[[["self"],["paramenv"],["t"],["t"]],["unitresult"]]],[11,"can_eq","","",208,[[["self"],["paramenv"],["t"],["t"]],["unitresult"]]],[11,"sub_regions","","",208,[[["self"],["subregionorigin"],["region"],["region"]]]],[11,"subtype_predicate","","",208,[[["self"],["obligationcause"],["paramenv"],["polysubtypepredicate"]],["option",["inferresult"]]]],[11,"region_outlives_predicate","","",208,[[["self"],["obligationcause"],["polyregionoutlivespredicate"]],["unitresult"]]],[11,"next_ty_var_id","","",208,[[["self"],["bool"],["typevariableorigin"]],["tyvid"]]],[11,"next_ty_var","","",208,[[["self"],["typevariableorigin"]],["ty"]]],[11,"next_diverging_ty_var","","",208,[[["self"],["typevariableorigin"]],["ty"]]],[11,"next_int_var_id","","",208,[[["self"]],["intvid"]]],[11,"next_float_var_id","","",208,[[["self"]],["floatvid"]]],[11,"next_region_var","","Create a fresh region variable with the next available index.",208,[[["self"],["regionvariableorigin"]],["region"]]],[11,"num_region_vars","","Number of region variables created so far.",208,[[["self"]],["usize"]]],[11,"next_nll_region_var","","Just a convenient wrapper of `next_region_var` for using during NLL.",208,[[["self"],["nllregionvariableorigin"]],["region"]]],[11,"var_for_def","","",208,[[["self"],["span"],["genericparamdef"]],["kind"]]],[11,"fresh_substs_for_item","","Given a set of generics defined on a type or impl, returns a substitution mapping each type/region parameter to a fresh inference variable.",208,[[["self"],["span"],["defid"]],["substs"]]],[11,"is_tainted_by_errors","","True if errors have been reported since this infcx was created.  This is sometimes used as a heuristic to skip reporting errors that often occur as a result of earlier errors, but where it's hard to be 100% sure (e.g., unresolved inference variables, regionck errors).",208,[[["self"]],["bool"]]],[11,"set_tainted_by_errors","","Set the \"tainted by errors\" flag to true. We call this when we observe an error from a prior pass.",208,[[["self"]]]],[11,"resolve_regions_and_report_errors","","Process the region constraints and report any errors that result. After this, no more unification operations should be done -- or the compiler will panic -- but it is legal to use `resolve_type_vars_if_possible` as well as `fully_resolve`.",208,[[["self"],["defid"],["scopetree"],["outlivesenvironment"]]]],[11,"resolve_regions_and_report_errors_unless_nll","","Like `resolve_regions_and_report_errors`, but skips error reporting if NLL is enabled.  This is used for fn bodies where the same error may later be reported by the NLL-based inference.",208,[[["self"],["defid"],["scopetree"],["outlivesenvironment"]]]],[11,"resolve_regions_and_report_errors_inner","","",208,[[["self"],["defid"],["scopetree"],["outlivesenvironment"],["bool"]]]],[11,"take_and_reset_region_constraints","","Obtains (and clears) the current set of region constraints. The inference context is still usable: further unifications will simply add new constraints.",208,[[["self"]],["regionconstraintdata"]]],[11,"with_region_constraints","","Gives temporary access to the region constraint data.",208,N],[11,"take_region_var_origins","","Takes ownership of the list of variable regions. This implies that all the region constriants have already been taken, and hence that `resolve_regions_and_report_errors` can never be called. This is used only during NLL processing to \"hand off\" ownership of the set of region vairables into the NLL region context.",208,[[["self"]],["varinfos"]]],[11,"ty_to_string","","",208,[[["self"],["ty"]],["string"]]],[11,"tys_to_string","","",208,N],[11,"trait_ref_to_string","","",208,[[["self"],["traitref"]],["string"]]],[11,"shallow_resolve","","",208,[[["self"],["ty"]],["ty"]]],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in `value` with their final value. Note that region variables are unaffected. If a type variable has not been unified, it is left as is.  This is an idempotent operation that does not affect inference state in any way and so you can do it at will.",208,[[["self"],["t"]],["t"]]],[11,"any_unresolved_type_vars","","Returns true if `T` contains unresolved type variables. In the process of visiting `T`, this will resolve (where possible) type variables in `T`, but it never constructs the final, resolved type, so it's more efficient than `resolve_type_vars_if_possible()`.",208,[[["self"],["t"]],["bool"]]],[11,"resolve_type_and_region_vars_if_possible","","",208,[[["self"],["t"]],["t"]]],[11,"fully_resolve","","Attempts to resolve all type/region variables in `value`. Region inference must have been run already (e.g., by calling `resolve_regions_and_report_errors`).  If some variable was never unified, an `Err` results.",208,[[["self"],["t"]],["fixupresult"]]],[11,"type_error_struct_with_diag","","",208,[[["self"],["span"],["m"],["ty"]],["diagnosticbuilder"]]],[11,"report_mismatched_types","","",208,[[["self"],["obligationcause"],["ty"],["ty"],["typeerror"]],["diagnosticbuilder"]]],[11,"replace_late_bound_regions_with_fresh_var","","",208,N],[11,"match_poly_projection_predicate","","Given a higher-ranked projection predicate like:",208,[[["self"],["obligationcause"],["paramenv"],["polyprojectionpredicate"],["traitref"]],["inferresult",["hrmatchresult"]]]],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_constraints`",208,[[["self"],["subregionorigin"],["generickind"],["region"],["verifybound"]]]],[11,"type_moves_by_default","","",208,[[["self"],["paramenv"],["ty"],["span"]],["bool"]]],[11,"closure_kind","","Obtains the latest type of the given closure; this may be a closure in the current function, in which case its `ClosureKind` may not yet be known.",208,[[["self"],["defid"],["closuresubsts"]],["option",["closurekind"]]]],[11,"closure_sig","","Obtain the signature of a closure.  For closures, unlike `tcx.fn_sig(def_id)`, this method will work during the type-checking of the enclosing function and return the closure signature in its partially inferred state.",208,[[["self"],["defid"],["closuresubsts"]],["polyfnsig"]]],[11,"partially_normalize_associated_types_in","","Normalizes associated types in `value`, potentially returning new obligations that must further be processed.",208,[[["self"],["span"],["nodeid"],["paramenv"],["t"]],["inferok"]]],[11,"borrow_region_constraints","","",208,[[["self"]],["refmut",["regionconstraintcollector"]]]],[11,"clear_caches","","Clears the selection, evaluation, and projection cachesThis is useful when repeatedly attemping to select an Obligation while changing only its ParamEnv, since FulfillmentContext doesn't use 'probe'",208,[[["self"]]]],[11,"universe","","",208,[[["self"]],["universeindex"]]],[11,"create_subuniverse","","Create and return a new subunivese of the current universe; update `self.universe` to that new subuniverse. At present, used only in the NLL subtyping code, which uses the new universe-based scheme instead of the more limited leak-check scheme.",208,[[["self"]],["universeindex"]]],[11,"span","","",209,[[["self"]],["span"]]],[11,"types","","",209,[[["obligationcause"],["bool"],["ty"],["ty"]],["typetrace"]]],[11,"dummy","","",209,[[["tyctxt"]],["typetrace"]]],[11,"fmt","","",209,[[["self"],["formatter"]],["result"]]],[11,"span","","",214,[[["self"]],["span"]]],[11,"from_obligation_cause","","",214,[[["obligationcause"],["f"]],["self"]]],[11,"span","","",217,[[["self"]],["span"]]],[11,"super_fold_with","","",213,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",213,[[["self"],["v"]],["bool"]]],[11,"fmt","","",210,[[["self"],["formatter"]],["result"]]],[0,"lint","rustc","Lints, aka compiler warnings.",N,N],[3,"LateContext","rustc::lint","Context for lint checking after type checking.",N,N],[12,"tcx","","Type context we're checking in.",296,N],[12,"tables","","Side-tables for the body we are in.",296,N],[12,"param_env","","Parameter environment for the item we are in.",296,N],[12,"access_levels","","Items accessible from the crate being checked.",296,N],[12,"lint_sess","","The store of registered lints and the lint levels.",296,N],[12,"last_ast_node_with_lint_attrs","","",296,N],[12,"generics","","Generic type parameters in scope for the item we are in.",296,N],[3,"EarlyContext","","Context for lint checking of the AST, after expansion, before lowering to HIR.",N,N],[12,"sess","","Type context we're checking in.",297,N],[12,"krate","","The crate being checked.",297,N],[12,"builder","","",297,N],[12,"lint_sess","","The store of registered lints and the lint levels.",297,N],[12,"buffered","","",297,N],[3,"LintStore","","Information about the registered lints.",N,N],[12,"lints","","Registered lints. The bool is true if the lint was added by a plugin.",298,N],[12,"pre_expansion_passes","","Trait objects for each lint pass. This is only `None` while performing a lint pass.",298,N],[12,"early_passes","","",298,N],[12,"late_passes","","",298,N],[12,"by_name","","Lints indexed by name.",298,N],[12,"lint_groups","","Map of registered lint groups to what lints they expand to. The bool is true if the lint group was added by a plugin.",298,N],[12,"future_incompatible","","Extra info for future incompatibility lints, describing the issue or RFC that caused the incompatibility.",298,N],[3,"FutureIncompatibleInfo","","Extra information for a future incompatibility lint. See the call to `register_future_incompatible` in `librustc_lint/lib.rs` for guidelines.",N,N],[12,"id","","",299,N],[12,"reference","","e.g., a URL for an issue/PR/RFC or error code",299,N],[12,"edition","","If this is an edition fixing lint, the edition in which this lint becomes obsolete",299,N],[3,"BufferedEarlyLint","","Lints that are buffered up early on in the `Session` before the `LintLevels` is calculated",N,N],[12,"lint_id","","",300,N],[12,"ast_id","","",300,N],[12,"span","","",300,N],[12,"msg","","",300,N],[12,"diagnostic","","",300,N],[3,"Lint","","Specification of a single lint.",N,N],[12,"name","","A string identifier for the lint.",301,N],[12,"default_level","","Default level for the lint.",301,N],[12,"desc","","Description of the lint or the issue it detects.",301,N],[12,"edition_lint_opts","","Starting at the given edition, default to the given lint level. If this is `None`, then use `default_level`.",301,N],[12,"report_in_external_macro","","Whether this lint is reported even inside expansions of external macros",301,N],[3,"LintId","","Identifies a lint known to the compiler.",N,N],[12,"lint","","",302,N],[3,"LintLevelSets","","",N,N],[12,"list","","",303,N],[12,"lint_cap","","",303,N],[3,"LintLevelMap","","",N,N],[12,"sets","","",304,N],[12,"id_to_set","","",304,N],[3,"LintBuffer","","",N,N],[12,"map","","",305,N],[3,"LintLevelMapBuilder","","",N,N],[12,"levels","","",306,N],[12,"tcx","","",306,N],[4,"Level","","Setting for how to handle a lint.",N,N],[13,"Allow","","",307,N],[13,"Warn","","",307,N],[13,"Deny","","",307,N],[13,"Forbid","","",307,N],[4,"LintSource","","How a lint level was set.",N,N],[13,"Default","","Lint is at the default level as declared in rustc or a plugin.",308,N],[13,"Node","","Lint level was set by an attribute.",308,N],[13,"CommandLine","","Lint level was set by a command-line flag.",308,N],[5,"check_crate","","Perform lint checking on a crate.",N,[[["tyctxt"]]]],[5,"check_ast_crate","","",N,[[["session"],["crate"],["bool"]]]],[5,"struct_lint_level","","",N,[[["session"],["lint"],["level"],["lintsource"],["option",["multispan"]],["str"]],["diagnosticbuilder"]]],[5,"lint_levels","","",N,[[["tyctxt"],["cratenum"]],["lrc",["lintlevelmap"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"in_external_macro","","Returns whether `span` originates in a foreign crate's external macro.",N,[[["session"],["span"]],["bool"]]],[0,"builtin","","Some lints that are built in to the compiler.",N,N],[3,"HardwiredLints","rustc::lint::builtin","Does nothing as a lint pass, but registers some `Lint`s which are used by other parts of the compiler.",N,N],[4,"BuiltinLintDiagnostics","","",N,N],[13,"Normal","","",309,N],[13,"BareTraitObject","","",309,N],[13,"AbsPathWithModule","","",309,N],[13,"DuplicatedMacroExports","","",309,N],[13,"ProcMacroDeriveResolutionFallback","","",309,N],[13,"ElidedLifetimesInPaths","","",309,N],[0,"parser","","Some lints that are buffered from `libsyntax`. See `syntax::early_buffered_lints`.",N,N],[7,"QUESTION_MARK_MACRO_SEP","rustc::lint::builtin::parser","",N,N],[7,"EXCEEDING_BITSHIFTS","rustc::lint::builtin","",N,N],[7,"CONST_ERR","","",N,N],[7,"UNUSED_IMPORTS","","",N,N],[7,"UNUSED_EXTERN_CRATES","","",N,N],[7,"UNUSED_QUALIFICATIONS","","",N,N],[7,"UNKNOWN_LINTS","","",N,N],[7,"UNUSED_VARIABLES","","",N,N],[7,"UNUSED_ASSIGNMENTS","","",N,N],[7,"DEAD_CODE","","",N,N],[7,"UNREACHABLE_CODE","","",N,N],[7,"UNREACHABLE_PATTERNS","","",N,N],[7,"UNUSED_MACROS","","",N,N],[7,"WARNINGS","","",N,N],[7,"UNUSED_FEATURES","","",N,N],[7,"STABLE_FEATURES","","",N,N],[7,"UNKNOWN_CRATE_TYPES","","",N,N],[7,"TRIVIAL_CASTS","","",N,N],[7,"TRIVIAL_NUMERIC_CASTS","","",N,N],[7,"PRIVATE_IN_PUBLIC","","",N,N],[7,"PUB_USE_OF_PRIVATE_EXTERN_CRATE","","",N,N],[7,"INVALID_TYPE_PARAM_DEFAULT","","",N,N],[7,"RENAMED_AND_REMOVED_LINTS","","",N,N],[7,"SAFE_EXTERN_STATICS","","",N,N],[7,"SAFE_PACKED_BORROWS","","",N,N],[7,"PATTERNS_IN_FNS_WITHOUT_BODY","","",N,N],[7,"LEGACY_DIRECTORY_OWNERSHIP","","",N,N],[7,"LEGACY_CONSTRUCTOR_VISIBILITY","","",N,N],[7,"MISSING_FRAGMENT_SPECIFIER","","",N,N],[7,"PARENTHESIZED_PARAMS_IN_TYPES_AND_MODULES","","",N,N],[7,"LATE_BOUND_LIFETIME_ARGUMENTS","","",N,N],[7,"INCOHERENT_FUNDAMENTAL_IMPLS","","",N,N],[7,"BAD_REPR","","",N,N],[7,"DEPRECATED","","",N,N],[7,"UNUSED_UNSAFE","","",N,N],[7,"UNUSED_MUT","","",N,N],[7,"SINGLE_USE_LIFETIMES","","",N,N],[7,"UNUSED_LIFETIMES","","",N,N],[7,"TYVAR_BEHIND_RAW_POINTER","","",N,N],[7,"ELIDED_LIFETIMES_IN_PATHS","","",N,N],[7,"BARE_TRAIT_OBJECTS","","",N,N],[7,"ABSOLUTE_PATHS_NOT_STARTING_WITH_CRATE","","",N,N],[7,"ILLEGAL_FLOATING_POINT_LITERAL_PATTERN","","",N,N],[7,"UNSTABLE_NAME_COLLISIONS","","",N,N],[7,"IRREFUTABLE_LET_PATTERNS","","",N,N],[7,"UNUSED_LABELS","","",N,N],[7,"DUPLICATE_ASSOCIATED_TYPE_BINDINGS","","",N,N],[7,"DUPLICATE_MACRO_EXPORTS","","",N,N],[7,"INTRA_DOC_LINK_RESOLUTION_FAILURE","","",N,N],[7,"WHERE_CLAUSES_OBJECT_SAFETY","","",N,N],[7,"PROC_MACRO_DERIVE_RESOLUTION_FALLBACK","","",N,N],[7,"MACRO_USE_EXTERN_CRATE","","",N,N],[11,"clone","","",310,[[["self"]],["hardwiredlints"]]],[11,"get_lints","","",310,[[["self"]],["lintarray"]]],[11,"eq","","",309,[[["self"],["builtinlintdiagnostics"]],["bool"]]],[11,"ne","","",309,[[["self"],["builtinlintdiagnostics"]],["bool"]]],[11,"encode","","",309,[[["self"],["__s"]],["result"]]],[11,"decode","","",309,[[["__d"]],["result",["builtinlintdiagnostics"]]]],[11,"fmt","","",309,[[["self"],["formatter"]],["result"]]],[11,"run","","",309,[[["self"],["session"],["diagnosticbuilder"]]]],[0,"context","rustc::lint","Implementation of lint checking.",N,N],[3,"LintStore","rustc::lint::context","Information about the registered lints.",N,N],[12,"lints","","Registered lints. The bool is true if the lint was added by a plugin.",298,N],[12,"pre_expansion_passes","","Trait objects for each lint pass. This is only `None` while performing a lint pass.",298,N],[12,"early_passes","","",298,N],[12,"late_passes","","",298,N],[12,"by_name","","Lints indexed by name.",298,N],[12,"lint_groups","","Map of registered lint groups to what lints they expand to. The bool is true if the lint group was added by a plugin.",298,N],[12,"future_incompatible","","Extra info for future incompatibility lints, describing the issue or RFC that caused the incompatibility.",298,N],[3,"LintSession","","",N,N],[12,"lints","","Reference to the store of registered lints.",311,N],[12,"passes","","Trait objects for each lint pass.",311,N],[3,"BufferedEarlyLint","","Lints that are buffered up early on in the `Session` before the `LintLevels` is calculated",N,N],[12,"lint_id","","",300,N],[12,"ast_id","","",300,N],[12,"span","","",300,N],[12,"msg","","",300,N],[12,"diagnostic","","",300,N],[3,"FutureIncompatibleInfo","","Extra information for a future incompatibility lint. See the call to `register_future_incompatible` in `librustc_lint/lib.rs` for guidelines.",N,N],[12,"id","","",299,N],[12,"reference","","e.g., a URL for an issue/PR/RFC or error code",299,N],[12,"edition","","If this is an edition fixing lint, the edition in which this lint becomes obsolete",299,N],[3,"LateContext","","Context for lint checking after type checking.",N,N],[12,"tcx","","Type context we're checking in.",296,N],[12,"tables","","Side-tables for the body we are in.",296,N],[12,"param_env","","Parameter environment for the item we are in.",296,N],[12,"access_levels","","Items accessible from the crate being checked.",296,N],[12,"lint_sess","","The store of registered lints and the lint levels.",296,N],[12,"last_ast_node_with_lint_attrs","","",296,N],[12,"generics","","Generic type parameters in scope for the item we are in.",296,N],[3,"EarlyContext","","Context for lint checking of the AST, after expansion, before lowering to HIR.",N,N],[12,"sess","","Type context we're checking in.",297,N],[12,"krate","","The crate being checked.",297,N],[12,"builder","","",297,N],[12,"lint_sess","","The store of registered lints and the lint levels.",297,N],[12,"buffered","","",297,N],[4,"TargetLint","","The target of the `by_name` map, which accounts for renaming/deprecation.",N,N],[13,"Id","","A direct lint target",312,N],[13,"Renamed","","Temporary renaming, used for easing migration pain; see #16545",312,N],[13,"Removed","","Lint with this name existed previously, but has been removed/deprecated. The string argument is the reason for removal.",312,N],[4,"FindLintError","","",N,N],[13,"NotFound","","",313,N],[13,"Removed","","",313,N],[4,"CheckLintNameResult","","",N,N],[13,"Ok","","",314,N],[13,"NoLint","","Lint doesn't exist",314,N],[13,"Warning","","The lint is either renamed or removed. This is the warning message, and an optional new name (`None` if removed).",314,N],[5,"check_crate","","Perform lint checking on a crate.",N,[[["tyctxt"]]]],[5,"check_ast_crate","","",N,[[["session"],["crate"],["bool"]]]],[8,"LintPassObject","","",N,N],[8,"LintContext","","",N,N],[16,"PassObject","","",315,N],[10,"sess","","",315,[[["self"]],["session"]]],[10,"lints","","",315,[[["self"]],["lintstore"]]],[10,"lint_sess","","",315,[[["self"]],["lintsession"]]],[10,"lint_sess_mut","","",315,[[["self"]],["lintsession"]]],[10,"enter_attrs","","",315,N],[10,"exit_attrs","","",315,N],[11,"lookup_and_emit","","",315,[[["self"],["lint"],["option"],["str"]]]],[11,"lookup_and_emit_with_diagnostics","","",315,[[["self"],["lint"],["option"],["str"],["builtinlintdiagnostics"]]]],[10,"lookup","","",315,[[["self"],["lint"],["option"],["str"]],["diagnosticbuilder"]]],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",315,[[["self"],["lint"],["s"],["str"]]]],[11,"struct_span_lint","","",315,[[["self"],["lint"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_lint_note","","Emit a lint and note at the appropriate level, for a particular span.",315,[[["self"],["lint"],["span"],["str"],["span"],["str"]]]],[11,"span_lint_help","","Emit a lint and help at the appropriate level, for a particular span.",315,[[["self"],["lint"],["span"],["str"],["str"]]]],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",315,[[["self"],["lint"],["str"]]]],[10,"with_lint_attrs","","Merge the lints specified by any lint attributes into the current lint context, call the provided function, then reset the lints in effect to their previous state.",315,N],[11,"eq","rustc::lint","",300,[[["self"],["bufferedearlylint"]],["bool"]]],[11,"ne","","",300,[[["self"],["bufferedearlylint"]],["bool"]]],[11,"encode","","",300,[[["self"],["__s"]],["result"]]],[11,"decode","","",300,[[["__d"]],["result",["bufferedearlylint"]]]],[11,"fmt","","",300,[[["self"],["formatter"]],["result"]]],[11,"new","","",298,[[],["lintstore"]]],[11,"get_lints","","",298,N],[11,"get_lint_groups","","",298,[[["self"]],["vec"]]],[11,"register_early_pass","","",298,[[["self"],["option",["session"]],["bool"],["earlylintpassobject"]]]],[11,"register_pre_expansion_pass","","",298,[[["self"],["option",["session"]],["earlylintpassobject"]]]],[11,"register_late_pass","","",298,[[["self"],["option",["session"]],["bool"],["latelintpassobject"]]]],[11,"push_pass","","",298,[[["self"],["option",["session"]],["bool"],["box"]]]],[11,"register_future_incompatible","","",298,[[["self"],["option",["session"]],["vec",["futureincompatibleinfo"]]]]],[11,"future_incompatible","","",298,[[["self"],["lintid"]],["option",["futureincompatibleinfo"]]]],[11,"register_group","","",298,[[["self"],["option",["session"]],["bool"],["str"],["vec",["lintid"]]]]],[11,"register_renamed","","",298,[[["self"],["str"],["str"]]]],[11,"register_removed","","",298,[[["self"],["str"],["str"]]]],[11,"find_lints","","",298,[[["self"],["str"]],["result",["vec","findlinterror"]]]],[11,"check_lint_name_cmdline","","Checks the validity of lint names derived from the command line",298,[[["self"],["session"],["str"],["level"]]]],[11,"check_lint_name","","Checks the name of a lint for its existence, and whether it was renamed or removed. Generates a DiagnosticBuilder containing a warning for renamed and removed lints. This is over both lint names from attributes and those passed on the command line. Since it emits non-fatal warnings and there are two lint passes that inspect attributes, this is only run from the late pass to avoid printing duplicate warnings.",298,[[["self"],["str"]],["checklintnameresult"]]],[11,"new","","",297,[[["session"],["crate"],["option",["vec"]],["lintbuffer"]],["earlycontext"]]],[11,"check_id","","",297,[[["self"],["nodeid"]]]],[11,"sess","","Get the overall compiler `Session` object.",296,[[["self"]],["session"]]],[11,"lints","","",296,[[["self"]],["lintstore"]]],[11,"lint_sess","","",296,[[["self"]],["lintsession"]]],[11,"lint_sess_mut","","",296,[[["self"]],["lintsession"]]],[11,"enter_attrs","","",296,N],[11,"exit_attrs","","",296,N],[11,"lookup","","",296,[[["self"],["lint"],["option"],["str"]],["diagnosticbuilder"]]],[11,"with_lint_attrs","","",296,N],[11,"sess","","Get the overall compiler `Session` object.",297,[[["self"]],["session"]]],[11,"lints","","",297,[[["self"]],["lintstore"]]],[11,"lint_sess","","",297,[[["self"]],["lintsession"]]],[11,"lint_sess_mut","","",297,[[["self"]],["lintsession"]]],[11,"enter_attrs","","",297,N],[11,"exit_attrs","","",297,N],[11,"lookup","","",297,[[["self"],["lint"],["option"],["str"]],["diagnosticbuilder"]]],[11,"with_lint_attrs","","",297,N],[11,"with_param_env","","",296,[[["self"],["nodeid"],["f"]]]],[11,"current_lint_root","","",296,[[["self"]],["nodeid"]]],[11,"nested_visit_map","","Because lints are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",296,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",296,[[["self"],["bodyid"]]]],[11,"visit_body","","",296,[[["self"],["body"]]]],[11,"visit_item","","",296,[[["self"],["item"]]]],[11,"visit_foreign_item","","",296,[[["self"],["foreignitem"]]]],[11,"visit_pat","","",296,[[["self"],["pat"]]]],[11,"visit_expr","","",296,[[["self"],["expr"]]]],[11,"visit_stmt","","",296,[[["self"],["stmt"]]]],[11,"visit_fn","","",296,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_variant_data","","",296,[[["self"],["variantdata"],["name"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",296,[[["self"],["structfield"]]]],[11,"visit_variant","","",296,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_ty","","",296,[[["self"],["ty"]]]],[11,"visit_name","","",296,[[["self"],["span"],["name"]]]],[11,"visit_mod","","",296,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"visit_local","","",296,[[["self"],["local"]]]],[11,"visit_block","","",296,[[["self"],["block"]]]],[11,"visit_arm","","",296,[[["self"],["arm"]]]],[11,"visit_decl","","",296,[[["self"],["decl"]]]],[11,"visit_generic_param","","",296,[[["self"],["genericparam"]]]],[11,"visit_generics","","",296,[[["self"],["generics"]]]],[11,"visit_where_predicate","","",296,[[["self"],["wherepredicate"]]]],[11,"visit_poly_trait_ref","","",296,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_trait_item","","",296,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",296,[[["self"],["implitem"]]]],[11,"visit_lifetime","","",296,[[["self"],["lifetime"]]]],[11,"visit_path","","",296,[[["self"],["path"],["nodeid"]]]],[11,"visit_attribute","","",296,[[["self"],["attribute"]]]],[11,"visit_item","","",297,[[["self"],["item"]]]],[11,"visit_foreign_item","","",297,[[["self"],["foreignitem"]]]],[11,"visit_pat","","",297,[[["self"],["pat"]]]],[11,"visit_expr","","",297,[[["self"],["expr"]]]],[11,"visit_stmt","","",297,[[["self"],["stmt"]]]],[11,"visit_fn","","",297,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_variant_data","","",297,[[["self"],["variantdata"],["ident"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",297,[[["self"],["structfield"]]]],[11,"visit_variant","","",297,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_ty","","",297,[[["self"],["ty"]]]],[11,"visit_ident","","",297,[[["self"],["ident"]]]],[11,"visit_mod","","",297,N],[11,"visit_local","","",297,[[["self"],["local"]]]],[11,"visit_block","","",297,[[["self"],["block"]]]],[11,"visit_arm","","",297,[[["self"],["arm"]]]],[11,"visit_expr_post","","",297,[[["self"],["expr"]]]],[11,"visit_generic_param","","",297,[[["self"],["genericparam"]]]],[11,"visit_generics","","",297,[[["self"],["generics"]]]],[11,"visit_where_predicate","","",297,[[["self"],["wherepredicate"]]]],[11,"visit_poly_trait_ref","","",297,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_trait_item","","",297,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",297,[[["self"],["implitem"]]]],[11,"visit_lifetime","","",297,[[["self"],["lifetime"]]]],[11,"visit_path","","",297,[[["self"],["path"],["nodeid"]]]],[11,"visit_attribute","","",297,[[["self"],["attribute"]]]],[11,"visit_mac_def","","",297,[[["self"],["macrodef"],["nodeid"]]]],[11,"visit_mac","","",297,[[["self"],["mac"]]]],[11,"encode","","",302,[[["self"],["s"]],["result"]]],[11,"decode","","",302,[[["d"]],["result",["lintid"]]]],[0,"levels","","",N,N],[3,"LintLevelSets","rustc::lint::levels","",N,N],[12,"list","","",303,N],[12,"lint_cap","","",303,N],[3,"LintLevelsBuilder","","",N,N],[12,"sess","","",316,N],[12,"sets","","",316,N],[12,"id_to_set","","",316,N],[12,"cur","","",316,N],[12,"warn_about_weird_lints","","",316,N],[3,"BuilderPush","","",N,N],[12,"prev","","",317,N],[3,"LintLevelMap","","",N,N],[12,"sets","","",304,N],[12,"id_to_set","","",304,N],[4,"LintSet","","",N,N],[13,"CommandLine","","",318,N],[12,"specs","rustc::lint::levels::LintSet","",318,N],[13,"Node","rustc::lint::levels","",318,N],[12,"specs","rustc::lint::levels::LintSet","",318,N],[12,"parent","","",318,N],[11,"new","rustc::lint","",303,[[["session"]],["lintlevelsets"]]],[11,"builder","","",303,[[["session"]],["lintlevelsbuilder"]]],[11,"process_command_line","","",303,[[["self"],["session"]]]],[11,"get_lint_level","","",303,N],[11,"get_lint_id_level","","",303,N],[11,"new","rustc::lint::levels","",316,[[["session"],["lintlevelsets"]],["lintlevelsbuilder"]]],[11,"push","","Pushes a list of AST lint attributes onto this context.",316,N],[11,"pop","","Called after `push` when the scope of a set of attributes are exited.",316,[[["self"],["builderpush"]]]],[11,"struct_lint","","Used to emit a lint-related diagnostic based on the current state of this lint context.",316,[[["self"],["lint"],["option",["multispan"]],["str"]],["diagnosticbuilder"]]],[11,"register_id","","Registers the ID provided with the current set of lints stored in this context.",316,[[["self"],["hirid"]]]],[11,"build","","",316,[[["self"]],["lintlevelsets"]]],[11,"build_map","","",316,[[["self"]],["lintlevelmap"]]],[11,"level_and_source","rustc::lint","If the `id` was previously registered with `register_id` when building this `LintLevelMap` this returns the corresponding lint level and source of the lint level for the lint provided.",304,[[["self"],["lint"],["hirid"],["session"]],["option"]]],[11,"lint_level_set","","Returns if this `id` has lint level information.",304,[[["self"],["hirid"]],["option",["u32"]]]],[11,"hash_stable","","",304,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",302,[[["self"],["hcx"],["stablehasher"]]]],[11,"to_stable_hash_key","","",302,[[["self"],["hcx"]],["str"]]],[6,"LintArray","","",N,N],[6,"EarlyLintPassObject","","A lint pass boxed up as a trait object.",N,N],[6,"LateLintPassObject","","",N,N],[6,"LevelSource","","",N,N],[8,"LintContext","","",N,N],[16,"PassObject","","",315,N],[10,"sess","","",315,[[["self"]],["session"]]],[10,"lints","","",315,[[["self"]],["lintstore"]]],[10,"lint_sess","","",315,[[["self"]],["lintsession"]]],[10,"lint_sess_mut","","",315,[[["self"]],["lintsession"]]],[10,"enter_attrs","","",315,N],[10,"exit_attrs","","",315,N],[11,"lookup_and_emit","rustc::lint::context","",315,[[["self"],["lint"],["option"],["str"]]]],[11,"lookup_and_emit_with_diagnostics","","",315,[[["self"],["lint"],["option"],["str"],["builtinlintdiagnostics"]]]],[10,"lookup","rustc::lint","",315,[[["self"],["lint"],["option"],["str"]],["diagnosticbuilder"]]],[11,"span_lint","rustc::lint::context","Emit a lint at the appropriate level, for a particular span.",315,[[["self"],["lint"],["s"],["str"]]]],[11,"struct_span_lint","","",315,[[["self"],["lint"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_lint_note","","Emit a lint and note at the appropriate level, for a particular span.",315,[[["self"],["lint"],["span"],["str"],["span"],["str"]]]],[11,"span_lint_help","","Emit a lint and help at the appropriate level, for a particular span.",315,[[["self"],["lint"],["span"],["str"],["str"]]]],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",315,[[["self"],["lint"],["str"]]]],[10,"with_lint_attrs","rustc::lint","Merge the lints specified by any lint attributes into the current lint context, call the provided function, then reset the lints in effect to their previous state.",315,N],[8,"LintPass","","",N,N],[10,"get_lints","","Get descriptions of the lints this `LintPass` object can emit.",319,[[["self"]],["lintarray"]]],[8,"LateLintPass","","",N,N],[11,"check_body","","",320,[[["self"],["latecontext"],["body"]]]],[11,"check_body_post","","",320,[[["self"],["latecontext"],["body"]]]],[11,"check_name","","",320,[[["self"],["latecontext"],["span"],["name"]]]],[11,"check_crate","","",320,[[["self"],["latecontext"],["crate"]]]],[11,"check_crate_post","","",320,[[["self"],["latecontext"],["crate"]]]],[11,"check_mod","","",320,[[["self"],["latecontext"],["mod"],["span"],["nodeid"]]]],[11,"check_mod_post","","",320,[[["self"],["latecontext"],["mod"],["span"],["nodeid"]]]],[11,"check_foreign_item","","",320,[[["self"],["latecontext"],["foreignitem"]]]],[11,"check_foreign_item_post","","",320,[[["self"],["latecontext"],["foreignitem"]]]],[11,"check_item","","",320,[[["self"],["latecontext"],["item"]]]],[11,"check_item_post","","",320,[[["self"],["latecontext"],["item"]]]],[11,"check_local","","",320,[[["self"],["latecontext"],["local"]]]],[11,"check_block","","",320,[[["self"],["latecontext"],["block"]]]],[11,"check_block_post","","",320,[[["self"],["latecontext"],["block"]]]],[11,"check_stmt","","",320,[[["self"],["latecontext"],["stmt"]]]],[11,"check_arm","","",320,[[["self"],["latecontext"],["arm"]]]],[11,"check_pat","","",320,[[["self"],["latecontext"],["pat"]]]],[11,"check_decl","","",320,[[["self"],["latecontext"],["decl"]]]],[11,"check_expr","","",320,[[["self"],["latecontext"],["expr"]]]],[11,"check_expr_post","","",320,[[["self"],["latecontext"],["expr"]]]],[11,"check_ty","","",320,[[["self"],["latecontext"],["ty"]]]],[11,"check_generic_param","","",320,[[["self"],["latecontext"],["genericparam"]]]],[11,"check_generics","","",320,[[["self"],["latecontext"],["generics"]]]],[11,"check_where_predicate","","",320,[[["self"],["latecontext"],["wherepredicate"]]]],[11,"check_poly_trait_ref","","",320,[[["self"],["latecontext"],["polytraitref"],["traitboundmodifier"]]]],[11,"check_fn","","",320,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"check_fn_post","","",320,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"check_trait_item","","",320,[[["self"],["latecontext"],["traititem"]]]],[11,"check_trait_item_post","","",320,[[["self"],["latecontext"],["traititem"]]]],[11,"check_impl_item","","",320,[[["self"],["latecontext"],["implitem"]]]],[11,"check_impl_item_post","","",320,[[["self"],["latecontext"],["implitem"]]]],[11,"check_struct_def","","",320,[[["self"],["latecontext"],["variantdata"],["name"],["generics"],["nodeid"]]]],[11,"check_struct_def_post","","",320,[[["self"],["latecontext"],["variantdata"],["name"],["generics"],["nodeid"]]]],[11,"check_struct_field","","",320,[[["self"],["latecontext"],["structfield"]]]],[11,"check_variant","","",320,[[["self"],["latecontext"],["variant"],["generics"]]]],[11,"check_variant_post","","",320,[[["self"],["latecontext"],["variant"],["generics"]]]],[11,"check_lifetime","","",320,[[["self"],["latecontext"],["lifetime"]]]],[11,"check_path","","",320,[[["self"],["latecontext"],["path"],["nodeid"]]]],[11,"check_attribute","","",320,[[["self"],["latecontext"],["attribute"]]]],[11,"enter_lint_attrs","","",320,N],[11,"exit_lint_attrs","","",320,N],[8,"EarlyLintPass","","",N,N],[11,"check_ident","","",321,[[["self"],["earlycontext"],["ident"]]]],[11,"check_crate","","",321,[[["self"],["earlycontext"],["crate"]]]],[11,"check_crate_post","","",321,[[["self"],["earlycontext"],["crate"]]]],[11,"check_mod","","",321,[[["self"],["earlycontext"],["mod"],["span"],["nodeid"]]]],[11,"check_mod_post","","",321,[[["self"],["earlycontext"],["mod"],["span"],["nodeid"]]]],[11,"check_foreign_item","","",321,[[["self"],["earlycontext"],["foreignitem"]]]],[11,"check_foreign_item_post","","",321,[[["self"],["earlycontext"],["foreignitem"]]]],[11,"check_item","","",321,[[["self"],["earlycontext"],["item"]]]],[11,"check_item_post","","",321,[[["self"],["earlycontext"],["item"]]]],[11,"check_local","","",321,[[["self"],["earlycontext"],["local"]]]],[11,"check_block","","",321,[[["self"],["earlycontext"],["block"]]]],[11,"check_block_post","","",321,[[["self"],["earlycontext"],["block"]]]],[11,"check_stmt","","",321,[[["self"],["earlycontext"],["stmt"]]]],[11,"check_arm","","",321,[[["self"],["earlycontext"],["arm"]]]],[11,"check_pat","","",321,[[["self"],["earlycontext"],["pat"]]]],[11,"check_expr","","",321,[[["self"],["earlycontext"],["expr"]]]],[11,"check_expr_post","","",321,[[["self"],["earlycontext"],["expr"]]]],[11,"check_ty","","",321,[[["self"],["earlycontext"],["ty"]]]],[11,"check_generic_param","","",321,[[["self"],["earlycontext"],["genericparam"]]]],[11,"check_generics","","",321,[[["self"],["earlycontext"],["generics"]]]],[11,"check_where_predicate","","",321,[[["self"],["earlycontext"],["wherepredicate"]]]],[11,"check_poly_trait_ref","","",321,[[["self"],["earlycontext"],["polytraitref"],["traitboundmodifier"]]]],[11,"check_fn","","",321,[[["self"],["earlycontext"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"check_fn_post","","",321,[[["self"],["earlycontext"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"check_trait_item","","",321,[[["self"],["earlycontext"],["traititem"]]]],[11,"check_trait_item_post","","",321,[[["self"],["earlycontext"],["traititem"]]]],[11,"check_impl_item","","",321,[[["self"],["earlycontext"],["implitem"]]]],[11,"check_impl_item_post","","",321,[[["self"],["earlycontext"],["implitem"]]]],[11,"check_struct_def","","",321,[[["self"],["earlycontext"],["variantdata"],["ident"],["generics"],["nodeid"]]]],[11,"check_struct_def_post","","",321,[[["self"],["earlycontext"],["variantdata"],["ident"],["generics"],["nodeid"]]]],[11,"check_struct_field","","",321,[[["self"],["earlycontext"],["structfield"]]]],[11,"check_variant","","",321,[[["self"],["earlycontext"],["variant"],["generics"]]]],[11,"check_variant_post","","",321,[[["self"],["earlycontext"],["variant"],["generics"]]]],[11,"check_lifetime","","",321,[[["self"],["earlycontext"],["lifetime"]]]],[11,"check_path","","",321,[[["self"],["earlycontext"],["path"],["nodeid"]]]],[11,"check_attribute","","",321,[[["self"],["earlycontext"],["attribute"]]]],[11,"check_mac_def","","",321,[[["self"],["earlycontext"],["macrodef"],["nodeid"]]]],[11,"check_mac","","",321,[[["self"],["earlycontext"],["mac"]]]],[11,"enter_lint_attrs","","Called when entering a syntax node that can have lint attributes such as `#[allow(...)]`. Called with all the attributes of that node.",321,N],[11,"exit_lint_attrs","","Counterpart to `enter_lint_attrs`.",321,N],[11,"clone","","",301,[[["self"]],["lint"]]],[11,"fmt","","",301,[[["self"],["formatter"]],["result"]]],[11,"from_parser_lint_id","","Returns the `rust::lint::Lint` for a `syntax::early_buffered_lints::BufferedEarlyLintId`.",301,[[["bufferedearlylintid"]],["self"]]],[11,"name_lower","","Get the lint's name, with ASCII letters converted to lowercase.",301,[[["self"]],["string"]]],[11,"default_level","","",301,[[["self"],["session"]],["level"]]],[11,"clone","","",302,[[["self"]],["lintid"]]],[11,"fmt","","",302,[[["self"],["formatter"]],["result"]]],[11,"eq","","",302,[[["self"],["lintid"]],["bool"]]],[11,"hash","","",302,[[["self"],["h"]]]],[11,"of","","Get the `LintId` for a `Lint`.",302,[[["lint"]],["lintid"]]],[11,"lint_name_raw","","",302,[[["self"]],["str"]]],[11,"to_string","","Get the name of the lint.",302,[[["self"]],["string"]]],[11,"clone","","",307,[[["self"]],["level"]]],[11,"eq","","",307,[[["self"],["level"]],["bool"]]],[11,"partial_cmp","","",307,[[["self"],["level"]],["option",["ordering"]]]],[11,"assert_receiver_is_total_eq","","",307,N],[11,"cmp","","",307,[[["self"],["level"]],["ordering"]]],[11,"fmt","","",307,[[["self"],["formatter"]],["result"]]],[11,"hash","","",307,N],[11,"hash_stable","","",307,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"as_str","","Convert a level to a lower-case string.",307,[[["self"]],["str"]]],[11,"from_str","","Convert a lower-case string to a level.",307,[[["str"]],["option",["level"]]]],[11,"clone","","",308,[[["self"]],["lintsource"]]],[11,"eq","","",308,[[["self"],["lintsource"]],["bool"]]],[11,"ne","","",308,[[["self"],["lintsource"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",308,N],[11,"hash_stable","","",308,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",305,[[],["lintbuffer"]]],[11,"add_lint","","",305,[[["self"],["lint"],["nodeid"],["multispan"],["str"],["builtinlintdiagnostics"]]]],[11,"take","","",305,[[["self"],["nodeid"]],["vec",["bufferedearlylint"]]]],[11,"get_any","","",305,[[["self"]],["option"]]],[11,"with_lint_attrs","","",306,N],[11,"nested_visit_map","","",306,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",306,[[["self"],["item"]]]],[11,"visit_foreign_item","","",306,[[["self"],["foreignitem"]]]],[11,"visit_expr","","",306,[[["self"],["expr"]]]],[11,"visit_struct_field","","",306,[[["self"],["structfield"]]]],[11,"visit_variant","","",306,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_local","","",306,[[["self"],["local"]]]],[11,"visit_trait_item","","",306,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",306,[[["self"],["implitem"]]]],[0,"middle","rustc","",N,N],[0,"allocator","rustc::middle","",N,N],[4,"AllocatorKind","rustc::middle::allocator","",N,N],[13,"Global","","",322,N],[13,"DefaultLib","","",322,N],[13,"DefaultExe","","",322,N],[11,"clone","","",322,[[["self"]],["allocatorkind"]]],[11,"fn_name","","",322,[[["self"],["str"]],["string"]]],[0,"borrowck","rustc::middle","",N,N],[3,"BorrowCheckResult","rustc::middle::borrowck","",N,N],[12,"used_mut_nodes","","",323,N],[12,"signalled_any_error","","",323,N],[4,"SignalledError","","",N,N],[13,"SawSomeError","","",324,N],[13,"NoErrorsSeen","","",324,N],[11,"clone","","",324,[[["self"]],["signallederror"]]],[11,"fmt","","",324,[[["self"],["formatter"]],["result"]]],[11,"encode","","",324,[[["self"],["__s"]],["result"]]],[11,"decode","","",324,[[["__d"]],["result",["signallederror"]]]],[11,"hash_stable","","",324,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"fmt","","",323,[[["self"],["formatter"]],["result"]]],[11,"encode","","",323,[[["self"],["__s"]],["result"]]],[11,"decode","","",323,[[["__d"]],["result",["borrowcheckresult"]]]],[11,"hash_stable","","",323,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"expr_use_visitor","rustc::middle","A different sort of visitor for walking fn bodies.  Unlike the normal visitor, which just walks the entire body in one shot, the `ExprUseVisitor` determines how expressions are being used.",N,N],[3,"ExprUseVisitor","rustc::middle::expr_use_visitor","",N,N],[12,"mc","","",325,N],[12,"delegate","","",325,N],[12,"param_env","","",325,N],[4,"LoanCause","","",N,N],[13,"ClosureCapture","","",326,N],[13,"AddrOf","","",326,N],[13,"AutoRef","","",326,N],[13,"AutoUnsafe","","",326,N],[13,"RefBinding","","",326,N],[13,"OverloadedOperator","","",326,N],[13,"ClosureInvocation","","",326,N],[13,"ForLoop","","",326,N],[13,"MatchDiscriminant","","",326,N],[4,"ConsumeMode","","",N,N],[13,"Copy","","",327,N],[13,"Move","","",327,N],[4,"MoveReason","","",N,N],[13,"DirectRefMove","","",328,N],[13,"PatBindingMove","","",328,N],[13,"CaptureMove","","",328,N],[4,"MatchMode","","",N,N],[13,"NonBindingMatch","","",329,N],[13,"BorrowingMatch","","",329,N],[13,"CopyingMatch","","",329,N],[13,"MovingMatch","","",329,N],[4,"TrackMatchMode","","",N,N],[13,"Unknown","","",330,N],[13,"Definite","","",330,N],[13,"Conflicting","","",330,N],[4,"MutateMode","","",N,N],[13,"Init","","",331,N],[13,"JustWrite","","",331,N],[13,"WriteAndRead","","",331,N],[4,"OverloadedCallType","","",N,N],[13,"FnOverloadedCall","","",332,N],[13,"FnMutOverloadedCall","","",332,N],[13,"FnOnceOverloadedCall","","",332,N],[5,"copy_or_move","","",N,[[["memcategorizationcontext"],["paramenv"],["cmt_"],["movereason"]],["consumemode"]]],[8,"Delegate","","This trait defines the callbacks you can expect to receive when employing the ExprUseVisitor.",N,N],[10,"consume","","",333,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[10,"matched_pat","","",333,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[10,"consume_pat","","",333,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[10,"borrow","","",333,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[10,"decl_without_init","","",333,[[["self"],["nodeid"],["span"]]]],[10,"mutate","","",333,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"clone","","",326,[[["self"]],["loancause"]]],[11,"eq","","",326,[[["self"],["loancause"]],["bool"]]],[11,"ne","","",326,[[["self"],["loancause"]],["bool"]]],[11,"fmt","","",326,[[["self"],["formatter"]],["result"]]],[11,"clone","","",327,[[["self"]],["consumemode"]]],[11,"eq","","",327,[[["self"],["consumemode"]],["bool"]]],[11,"ne","","",327,[[["self"],["consumemode"]],["bool"]]],[11,"fmt","","",327,[[["self"],["formatter"]],["result"]]],[11,"clone","","",328,[[["self"]],["movereason"]]],[11,"eq","","",328,[[["self"],["movereason"]],["bool"]]],[11,"fmt","","",328,[[["self"],["formatter"]],["result"]]],[11,"clone","","",329,[[["self"]],["matchmode"]]],[11,"eq","","",329,[[["self"],["matchmode"]],["bool"]]],[11,"fmt","","",329,[[["self"],["formatter"]],["result"]]],[11,"clone","","",330,[[["self"]],["trackmatchmode"]]],[11,"eq","","",330,[[["self"],["trackmatchmode"]],["bool"]]],[11,"ne","","",330,[[["self"],["trackmatchmode"]],["bool"]]],[11,"fmt","","",330,[[["self"],["formatter"]],["result"]]],[11,"lub","","",330,[[["self"],["matchmode"]]]],[11,"match_mode","","",330,[[["self"]],["matchmode"]]],[11,"clone","","",331,[[["self"]],["mutatemode"]]],[11,"eq","","",331,[[["self"],["mutatemode"]],["bool"]]],[11,"fmt","","",331,[[["self"],["formatter"]],["result"]]],[11,"clone","","",332,[[["self"]],["overloadedcalltype"]]],[11,"from_trait_id","","",332,[[["tyctxt"],["defid"]],["overloadedcalltype"]]],[11,"from_method_id","","",332,[[["tyctxt"],["defid"]],["overloadedcalltype"]]],[11,"new","","Creates the ExprUseVisitor, configuring it with the various options provided:",325,[[["delegate"],["tyctxt"],["paramenv"],["scopetree"],["typecktables"],["option",["lrc"]]],["self"]]],[11,"with_infer","","",325,[[["delegate"],["inferctxt"],["paramenv"],["scopetree"],["typecktables"]],["self"]]],[11,"consume_body","","",325,[[["self"],["body"]]]],[11,"tcx","","",325,[[["self"]],["tyctxt"]]],[11,"delegate_consume","","",325,[[["self"],["nodeid"],["span"],["cmt_"]]]],[11,"consume_exprs","","",325,N],[11,"consume_expr","","",325,[[["self"],["expr"]]]],[11,"mutate_expr","","",325,[[["self"],["expr"],["expr"],["mutatemode"]]]],[11,"borrow_expr","","",325,[[["self"],["expr"],["region"],["borrowkind"],["loancause"]]]],[11,"select_from_expr","","",325,[[["self"],["expr"]]]],[11,"walk_expr","","",325,[[["self"],["expr"]]]],[11,"walk_callee","","",325,[[["self"],["expr"],["expr"]]]],[11,"walk_stmt","","",325,[[["self"],["stmt"]]]],[11,"walk_local","","",325,[[["self"],["local"]]]],[11,"walk_block","","Indicates that the value of `blk` will be consumed, meaning either copied or moved depending on its type.",325,[[["self"],["block"]]]],[11,"walk_struct_expr","","",325,N],[11,"walk_adjustment","","",325,[[["self"],["expr"]]]],[11,"walk_autoref","","Walks the autoref `autoref` applied to the autoderef'd `expr`. `cmt_base` is the mem-categorized form of `expr` after all relevant autoderefs have occurred.",325,[[["self"],["expr"],["cmt_"],["autoborrow"]]]],[11,"arm_move_mode","","",325,[[["self"],["cmt"],["arm"]],["trackmatchmode"]]],[11,"walk_arm","","",325,[[["self"],["cmt"],["arm"],["matchmode"]]]],[11,"walk_irrefutable_pat","","Walks a pat that occurs in isolation (i.e. top-level of fn arg or let binding.  Not a match arm or nested pat.)",325,[[["self"],["cmt"],["pat"]]]],[11,"determine_pat_move_mode","","Identifies any bindings within `pat` and accumulates within `mode` whether the overall pattern/match structure is a move, copy, or borrow.",325,[[["self"],["cmt"],["pat"],["trackmatchmode"]]]],[11,"walk_pat","","The core driver for walking a pattern; `match_mode` must be established up front, e.g. via `determine_pat_move_mode` (see also `walk_irrefutable_pat` for patterns that stand alone).",325,[[["self"],["cmt"],["pat"],["matchmode"]]]],[11,"walk_captures","","",325,[[["self"],["expr"],["span"]]]],[11,"cat_captured_var","","",325,[[["self"],["hirid"],["span"],["freevar"]],["mcresult",["cmt_"]]]],[0,"cstore","rustc::middle","the rustc crate store interface. This also includes types that are mostly used as a part of that interface, but these should probably get a better home if someone can find one.",N,N],[3,"LinkMeta","rustc::middle::cstore","",N,N],[12,"crate_hash","","",334,N],[3,"CrateSource","","Where a crate came from on the local filesystem. One of these three options must be non-None.",N,N],[12,"dylib","","",335,N],[12,"rlib","","",335,N],[12,"rmeta","","",335,N],[3,"NativeLibrary","","",N,N],[12,"kind","","",336,N],[12,"name","","",336,N],[12,"cfg","","",336,N],[12,"foreign_module","","",336,N],[12,"wasm_import_module","","",336,N],[3,"ForeignModule","","",N,N],[12,"foreign_items","","",337,N],[12,"def_id","","",337,N],[3,"ExternCrate","","",N,N],[12,"src","","",338,N],[12,"span","","span of the extern crate that caused this to be loaded",338,N],[12,"path_len","","Number of links to reach the extern; used to select the extern with the shortest path",338,N],[12,"direct","","If true, then this crate is the crate named by the extern crate referenced above. If false, then this crate is a dep of the crate.",338,N],[3,"EncodedMetadata","","",N,N],[12,"raw_data","","",339,N],[3,"DummyCrateStore","","A dummy crate store that does not support any non-local crates, for test purposes.",N,N],[4,"DepKind","","",N,N],[13,"UnexportedMacrosOnly","","A dependency that is only used for its macros, none of which are visible from other crates. These are included in the metadata only as placeholders and are ignored when decoding.",340,N],[13,"MacrosOnly","","A dependency that is only used for its macros.",340,N],[13,"Implicit","","A dependency that is always injected into the dependency list and so doesn't need to be linked to an rlib, e.g. the injected allocator.",340,N],[13,"Explicit","","A dependency that is required by an rlib version of this crate. Ordinary `extern crate`s result in `Explicit` dependencies.",340,N],[4,"LibSource","","",N,N],[13,"Some","","",341,N],[13,"MetadataOnly","","",341,N],[13,"None","","",341,N],[4,"LinkagePreference","","",N,N],[13,"RequireDynamic","","",342,N],[13,"RequireStatic","","",342,N],[4,"NativeLibraryKind","","",N,N],[13,"NativeStatic","","native static library (.a archive)",343,N],[13,"NativeStaticNobundle","","native static library, which doesn't get bundled into .rlibs",343,N],[13,"NativeFramework","","macOS-specific",343,N],[13,"NativeUnknown","","default way to specify a dynamic library",343,N],[4,"LoadedMacro","","",N,N],[13,"MacroDef","","",344,N],[13,"ProcMacro","","",344,N],[4,"ExternCrateSource","","",N,N],[13,"Extern","","Crate is loaded by `extern crate`.",345,N],[13,"Use","","",345,N],[13,"Path","","Crate is implicitly loaded by an absolute or an `extern::` path.",345,N],[5,"validate_crate_name","","",N,[[["option",["session"]],["str"],["option",["span"]]]]],[5,"used_crates","","",N,[[["tyctxt"],["linkagepreference"]],["vec"]]],[6,"CrateStoreDyn","","",N,N],[8,"MetadataLoader","","The backend's way to give the crate store access to the metadata in a library. Note that it returns the raw metadata bytes stored in the library file, whether it is compressed, uncompressed, some weird mix, etc. rmeta files are backend independent and not handled here.",N,N],[10,"get_rlib_metadata","","",346,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[10,"get_dylib_metadata","","",346,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[8,"CrateStore","","A store of Rust crates, through with their metadata can be accessed.",N,N],[10,"crate_data_as_rc_any","","",347,[[["self"],["cratenum"]],["lrc",["any"]]]],[10,"metadata_loader","","",347,[[["self"]],["metadataloader"]]],[10,"def_key","","",347,[[["self"],["defid"]],["defkey"]]],[10,"def_path","","",347,[[["self"],["defid"]],["defpath"]]],[10,"def_path_hash","","",347,[[["self"],["defid"]],["defpathhash"]]],[10,"def_path_table","","",347,[[["self"],["cratenum"]],["lrc",["defpathtable"]]]],[10,"visibility_untracked","","",347,[[["self"],["defid"]],["visibility"]]],[10,"export_macros_untracked","","",347,[[["self"],["cratenum"]]]],[10,"dep_kind_untracked","","",347,[[["self"],["cratenum"]],["depkind"]]],[10,"crate_name_untracked","","",347,[[["self"],["cratenum"]],["symbol"]]],[10,"crate_disambiguator_untracked","","",347,[[["self"],["cratenum"]],["cratedisambiguator"]]],[10,"crate_hash_untracked","","",347,[[["self"],["cratenum"]],["svh"]]],[10,"crate_edition_untracked","","",347,[[["self"],["cratenum"]],["edition"]]],[10,"struct_field_names_untracked","","",347,[[["self"],["defid"]],["vec",["name"]]]],[10,"item_children_untracked","","",347,[[["self"],["defid"],["session"]],["vec",["export"]]]],[10,"load_macro_untracked","","",347,[[["self"],["defid"],["session"]],["loadedmacro"]]],[10,"extern_mod_stmt_cnum_untracked","","",347,[[["self"],["nodeid"]],["option",["cratenum"]]]],[10,"item_generics_cloned_untracked","","",347,[[["self"],["defid"],["session"]],["generics"]]],[10,"associated_item_cloned_untracked","","",347,[[["self"],["defid"]],["associateditem"]]],[10,"postorder_cnums_untracked","","",347,[[["self"]],["vec",["cratenum"]]]],[10,"crates_untracked","","",347,[[["self"]],["vec",["cratenum"]]]],[10,"encode_metadata","","",347,[[["self"],["tyctxt"],["linkmeta"]],["encodedmetadata"]]],[10,"metadata_encoding_version","","",347,N],[8,"CrateLoader","","",N,N],[10,"process_extern_crate","","",348,[[["self"],["item"],["definitions"]],["cratenum"]]],[10,"process_path_extern","","",348,[[["self"],["symbol"],["span"]],["cratenum"]]],[10,"process_use_extern","","",348,[[["self"],["symbol"],["span"],["nodeid"],["definitions"]],["cratenum"]]],[10,"postprocess","","",348,[[["self"],["crate"]]]],[11,"clone","","",334,[[["self"]],["linkmeta"]]],[11,"fmt","","",334,[[["self"],["formatter"]],["result"]]],[11,"eq","","",335,[[["self"],["cratesource"]],["bool"]]],[11,"ne","","",335,[[["self"],["cratesource"]],["bool"]]],[11,"clone","","",335,[[["self"]],["cratesource"]]],[11,"fmt","","",335,[[["self"],["formatter"]],["result"]]],[11,"encode","","",340,[[["self"],["__s"]],["result"]]],[11,"decode","","",340,[[["__d"]],["result",["depkind"]]]],[11,"clone","","",340,[[["self"]],["depkind"]]],[11,"cmp","","",340,[[["self"],["depkind"]],["ordering"]]],[11,"partial_cmp","","",340,[[["self"],["depkind"]],["option",["ordering"]]]],[11,"assert_receiver_is_total_eq","","",340,N],[11,"eq","","",340,[[["self"],["depkind"]],["bool"]]],[11,"fmt","","",340,[[["self"],["formatter"]],["result"]]],[11,"macros_only","","",340,[[["self"]],["bool"]]],[11,"eq","","",341,[[["self"],["libsource"]],["bool"]]],[11,"ne","","",341,[[["self"],["libsource"]],["bool"]]],[11,"clone","","",341,[[["self"]],["libsource"]]],[11,"fmt","","",341,[[["self"],["formatter"]],["result"]]],[11,"is_some","","",341,[[["self"]],["bool"]]],[11,"option","","",341,[[["self"]],["option",["pathbuf"]]]],[11,"fmt","","",342,[[["self"],["formatter"]],["result"]]],[11,"eq","","",342,[[["self"],["linkagepreference"]],["bool"]]],[11,"clone","","",342,[[["self"]],["linkagepreference"]]],[11,"encode","","",342,[[["self"],["__s"]],["result"]]],[11,"decode","","",342,[[["__d"]],["result",["linkagepreference"]]]],[11,"clone","","",343,[[["self"]],["nativelibrarykind"]]],[11,"eq","","",343,[[["self"],["nativelibrarykind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",343,N],[11,"partial_cmp","","",343,[[["self"],["nativelibrarykind"]],["option",["ordering"]]]],[11,"cmp","","",343,[[["self"],["nativelibrarykind"]],["ordering"]]],[11,"hash","","",343,N],[11,"encode","","",343,[[["self"],["__s"]],["result"]]],[11,"decode","","",343,[[["__d"]],["result",["nativelibrarykind"]]]],[11,"clone","","",336,[[["self"]],["nativelibrary"]]],[11,"encode","","",336,[[["self"],["__s"]],["result"]]],[11,"decode","","",336,[[["__d"]],["result",["nativelibrary"]]]],[11,"clone","","",337,[[["self"]],["foreignmodule"]]],[11,"hash","","",337,N],[11,"encode","","",337,[[["self"],["__s"]],["result"]]],[11,"decode","","",337,[[["__d"]],["result",["foreignmodule"]]]],[11,"clone","","",338,[[["self"]],["externcrate"]]],[11,"fmt","","",338,[[["self"],["formatter"]],["result"]]],[11,"clone","","",345,[[["self"]],["externcratesource"]]],[11,"fmt","","",345,[[["self"],["formatter"]],["result"]]],[11,"new","","",339,[[],["encodedmetadata"]]],[11,"crate_data_as_rc_any","","",349,[[["self"],["cratenum"]],["lrc",["any"]]]],[11,"visibility_untracked","","",349,[[["self"],["defid"]],["visibility"]]],[11,"item_generics_cloned_untracked","","",349,[[["self"],["defid"],["session"]],["generics"]]],[11,"associated_item_cloned_untracked","","",349,[[["self"],["defid"]],["associateditem"]]],[11,"dep_kind_untracked","","",349,[[["self"],["cratenum"]],["depkind"]]],[11,"export_macros_untracked","","",349,[[["self"],["cratenum"]]]],[11,"crate_name_untracked","","",349,[[["self"],["cratenum"]],["symbol"]]],[11,"crate_disambiguator_untracked","","",349,[[["self"],["cratenum"]],["cratedisambiguator"]]],[11,"crate_hash_untracked","","",349,[[["self"],["cratenum"]],["svh"]]],[11,"crate_edition_untracked","","",349,[[["self"],["cratenum"]],["edition"]]],[11,"def_key","","",349,[[["self"],["defid"]],["defkey"]]],[11,"def_path","","",349,[[["self"],["defid"]],["defpath"]]],[11,"def_path_hash","","",349,[[["self"],["defid"]],["defpathhash"]]],[11,"def_path_table","","",349,[[["self"],["cratenum"]],["lrc",["defpathtable"]]]],[11,"struct_field_names_untracked","","",349,[[["self"],["defid"]],["vec",["name"]]]],[11,"item_children_untracked","","",349,[[["self"],["defid"],["session"]],["vec",["export"]]]],[11,"load_macro_untracked","","",349,[[["self"],["defid"],["session"]],["loadedmacro"]]],[11,"crates_untracked","","",349,[[["self"]],["vec",["cratenum"]]]],[11,"extern_mod_stmt_cnum_untracked","","",349,[[["self"],["nodeid"]],["option",["cratenum"]]]],[11,"encode_metadata","","",349,[[["self"],["tyctxt"],["linkmeta"]],["encodedmetadata"]]],[11,"metadata_encoding_version","","",349,N],[11,"postorder_cnums_untracked","","",349,[[["self"]],["vec",["cratenum"]]]],[11,"metadata_loader","","",349,[[["self"]],["metadataloader"]]],[0,"dataflow","rustc::middle","A module for propagating forward dataflow information. The analysis assumes that the items to be propagated can be represented as bits and thus uses bitvectors. Your job is simply to specify the so-called GEN and KILL bits for each expression.",N,N],[3,"DataFlowContext","rustc::middle::dataflow","",N,N],[12,"tcx","","",350,N],[12,"analysis_name","","a name for the analysis using this dataflow instance",350,N],[12,"oper","","the data flow operator",350,N],[12,"bits_per_id","","number of bits to propagate per id",350,N],[12,"words_per_id","","number of words we will use to store bits_per_id. equal to bits_per_id/usize::BITS rounded up.",350,N],[12,"local_id_to_index","","",350,N],[12,"gens","","bits generated as we exit the cfg node. Updated by `add_gen()`.",350,N],[12,"scope_kills","","bits killed as we exit the cfg node, or non-locally jump over it. Updated by `add_kill(KillFrom::ScopeEnd)`.",350,N],[12,"action_kills","","bits killed as we exit the cfg node directly; if it is jumped over, e.g. via `break`, the kills are not reflected in the jump's effects. Updated by `add_kill(KillFrom::Execution)`.",350,N],[12,"on_entry","","bits that are valid on entry to the cfg node. Updated by `propagate()`.",350,N],[3,"PropagationContext","","",N,N],[12,"dfcx","","",351,N],[12,"changed","","",351,N],[3,"Union","","",N,N],[3,"Subtract","","",N,N],[4,"EntryOrExit","","",N,N],[13,"Entry","","",352,N],[13,"Exit","","",352,N],[4,"KillFrom","","Flag used by `add_kill` to indicate whether the provided kill takes effect only when control flows directly through the node in question, or if the kill's effect is associated with any control-flow directly through or indirectly over the node.",N,N],[13,"ScopeEnd","","A `ScopeEnd` kill is one that takes effect when any control flow goes over the node. A kill associated with the end of the scope of a variable declaration `let x;` is an example of a `ScopeEnd` kill.",353,N],[13,"Execution","","An `Execution` kill is one that takes effect only when control flow goes through the node to completion. A kill associated with an assignment statement `x = expr;` is an example of an `Execution` kill.",353,N],[5,"get_cfg_indices","","",N,N],[5,"build_local_id_to_index","","",N,[[["option",["body"]],["cfg"]],["fxhashmap",["itemlocalid","vec"]]]],[5,"mut_bits_to_string","","",N,N],[5,"bits_to_string","","",N,N],[5,"bitwise","","",N,N],[5,"set_bit","","",N,N],[5,"bit_str","","",N,[[["usize"]],["string"]]],[8,"BitwiseOperator","","",N,N],[10,"join","","Joins two predecessor bits together, typically either `|` or `&`",354,[[["self"],["usize"],["usize"]],["usize"]]],[8,"DataFlowOperator","","Parameterization for the precise form of data flow that is used.",N,N],[10,"initial_value","","Specifies the initial value for each bit in the `on_entry` set",355,[[["self"]],["bool"]]],[11,"clone","","",352,[[["self"]],["entryorexit"]]],[11,"fmt","","",352,[[["self"],["formatter"]],["result"]]],[11,"clone","","",350,[[["self"]],["dataflowcontext"]]],[11,"has_bitset_for_local_id","","",350,[[["self"],["itemlocalid"]],["bool"]]],[11,"nested","","",350,[[["self"],["state"],["nested"]],["result"]]],[11,"pre","","",350,[[["self"],["state"],["annnode"]],["result"]]],[11,"clone","","",353,[[["self"]],["killfrom"]]],[11,"eq","","",353,[[["self"],["killfrom"]],["bool"]]],[11,"fmt","","",353,[[["self"],["formatter"]],["result"]]],[11,"new","","",350,[[["tyctxt"],["str"],["option",["body"]],["cfg"],["o"],["idrange"],["usize"]],["dataflowcontext"]]],[11,"add_gen","","Indicates that `id` generates `bit`",350,[[["self"],["itemlocalid"],["usize"]]]],[11,"add_kill","","Indicates that `id` kills `bit`",350,[[["self"],["killfrom"],["itemlocalid"],["usize"]]]],[11,"apply_gen_kill","","Applies the gen and kill sets for `cfgidx` to `bits`",350,N],[11,"compute_id_range","","",350,N],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`. Only useful after `propagate()` has been called.",350,[[["self"],["itemlocalid"],["f"]],["bool"]]],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`. Only useful after `propagate()` has been called.",350,[[["self"],["entryorexit"],["cfgindex"],["f"]],["bool"]]],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",350,[[["self"],["itemlocalid"],["f"]],["bool"]]],[11,"each_bit","","Helper for iterating over the bits in a bit set. Returns false on the first call to `f` that returns false; if all calls to `f` return true, then returns true.",350,N],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow exits through any number of enclosing scopes on its way to the new destination. This function infers the kill bits of those control operators based on the kill bits associated with those scopes.",350,[[["self"],["cfg"]]]],[11,"propagate","","Performs the data flow analysis.",350,[[["self"],["cfg"],["body"]]]],[11,"walk_cfg","","",351,N],[11,"reset","","",351,N],[11,"propagate_bits_into_graph_successors_of","","",351,N],[11,"propagate_bits_into_entry_set_for","","",351,N],[11,"join","","",356,[[["self"],["usize"],["usize"]],["usize"]]],[11,"join","","",357,[[["self"],["usize"],["usize"]],["usize"]]],[0,"dead","rustc::middle","",N,N],[3,"MarkSymbolVisitor","rustc::middle::dead","",N,N],[12,"worklist","","",358,N],[12,"tcx","","",358,N],[12,"tables","","",358,N],[12,"live_symbols","","",358,N],[12,"repr_has_repr_c","","",358,N],[12,"in_pat","","",358,N],[12,"inherited_pub_visibility","","",358,N],[12,"ignore_variant_stack","","",358,N],[3,"LifeSeeder","","",N,N],[12,"worklist","","",359,N],[12,"krate","","",359,N],[12,"tcx","","",359,N],[3,"DeadVisitor","","",N,N],[12,"tcx","","",360,N],[12,"live_symbols","","",360,N],[5,"should_explore","","",N,[[["tyctxt"],["nodeid"]],["bool"]]],[5,"has_allow_dead_code_or_lang_attr","","",N,N],[5,"create_and_seed_worklist","","",N,[[["tyctxt"],["accesslevels"],["crate"]],["vec",["nodeid"]]]],[5,"find_live","","",N,[[["tyctxt"],["accesslevels"],["crate"]],["box",["fxhashset"]]]],[5,"get_struct_ctor_id","","",N,[[["item"]],["option",["nodeid"]]]],[5,"check_crate","","",N,[[["tyctxt"]]]],[11,"check_def_id","","",358,[[["self"],["defid"]]]],[11,"insert_def_id","","",358,[[["self"],["defid"]]]],[11,"handle_definition","","",358,[[["self"],["def"]]]],[11,"lookup_and_handle_method","","",358,[[["self"],["hirid"]]]],[11,"handle_field_access","","",358,[[["self"],["expr"],["nodeid"]]]],[11,"handle_field_pattern_match","","",358,N],[11,"mark_live_symbols","","",358,[[["self"]]]],[11,"visit_node","","",358,[[["self"],["node"]]]],[11,"mark_as_used_if_union","","",358,[[["self"],["adtdef"],["hirvec"]]]],[11,"nested_visit_map","","",358,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",358,[[["self"],["bodyid"]]]],[11,"visit_variant_data","","",358,[[["self"],["variantdata"],["name"],["generics"],["nodeid"],["span"]]]],[11,"visit_expr","","",358,[[["self"],["expr"]]]],[11,"visit_arm","","",358,[[["self"],["arm"]]]],[11,"visit_pat","","",358,[[["self"],["pat"]]]],[11,"visit_path","","",358,[[["self"],["path"],["nodeid"]]]],[11,"visit_item","","",359,[[["self"],["item"]]]],[11,"visit_trait_item","","",359,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",359,[[["self"],["implitem"]]]],[11,"should_warn_about_item","","",360,[[["self"],["item"]],["bool"]]],[11,"should_warn_about_field","","",360,[[["self"],["structfield"]],["bool"]]],[11,"should_warn_about_variant","","",360,[[["self"],["variantkind"]],["bool"]]],[11,"should_warn_about_foreign_item","","",360,[[["self"],["foreignitem"]],["bool"]]],[11,"symbol_is_live","","",360,[[["self"],["nodeid"],["option",["nodeid"]]],["bool"]]],[11,"warn_dead_code","","",360,[[["self"],["nodeid"],["span"],["name"],["str"],["str"]]]],[11,"nested_visit_map","","Walk nested items in place so that we don't report dead-code on inner functions when the outer function is already getting an error. We could do this also by checking the parents, but this is how the code is setup and it seems harmless enough.",360,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",360,[[["self"],["item"]]]],[11,"visit_variant","","",360,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_foreign_item","","",360,[[["self"],["foreignitem"]]]],[11,"visit_struct_field","","",360,[[["self"],["structfield"]]]],[11,"visit_impl_item","","",360,[[["self"],["implitem"]]]],[11,"visit_trait_item","","",360,[[["self"],["traititem"]]]],[0,"dependency_format","rustc::middle","Resolution of mixing rlibs and dylibs",N,N],[4,"Linkage","rustc::middle::dependency_format","",N,N],[13,"NotLinked","","",361,N],[13,"IncludedFromDylib","","",361,N],[13,"Static","","",361,N],[13,"Dynamic","","",361,N],[5,"calculate","","",N,[[["tyctxt"]]]],[5,"calculate_type","","",N,[[["tyctxt"],["cratetype"]],["dependencylist"]]],[5,"add_library","","",N,[[["tyctxt"],["cratenum"],["linkagepreference"],["fxhashmap"]]]],[5,"attempt_static","","",N,[[["tyctxt"]],["option",["dependencylist"]]]],[5,"activate_injected_dep","","",N,[[["option",["cratenum"]],["dependencylist"],["fn"]]]],[5,"activate_injected_allocator","","",N,[[["session"],["dependencylist"]]]],[5,"verify_ok","","",N,N],[6,"DependencyList","","A list of dependencies for a certain crate type.",N,N],[6,"Dependencies","","A mapping of all required dependencies for a particular flavor of output.",N,N],[11,"clone","","",361,[[["self"]],["linkage"]]],[11,"eq","","",361,[[["self"],["linkage"]],["bool"]]],[11,"fmt","","",361,[[["self"],["formatter"]],["result"]]],[0,"entry","rustc::middle","",N,N],[3,"EntryContext","rustc::middle::entry","",N,N],[12,"session","","",362,N],[12,"map","","",362,N],[12,"main_fn","","",362,N],[12,"attr_main_fn","","",362,N],[12,"start_fn","","",362,N],[12,"non_main_fns","","",362,N],[5,"find_entry_point","","",N,[[["session"],["map"],["str"]]]],[5,"entry_point_type","","",N,[[["item"],["bool"]],["entrypointtype"]]],[5,"find_item","","",N,[[["item"],["entrycontext"],["bool"]]]],[5,"configure_main","","",N,[[["entrycontext"],["str"]]]],[11,"visit_item","","",362,[[["self"],["item"]]]],[11,"visit_trait_item","","",362,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",362,[[["self"],["implitem"]]]],[0,"exported_symbols","rustc::middle","",N,N],[4,"SymbolExportLevel","rustc::middle::exported_symbols","The SymbolExportLevel of a symbols specifies from which kinds of crates the symbol will be exported. `C` symbols will be exported from any kind of crate, including cdylibs which export very few things. `Rust` will only be exported if the crate produced is a Rust dylib.",N,N],[13,"C","","",363,N],[13,"Rust","","",363,N],[4,"ExportedSymbol","","",N,N],[13,"NonGeneric","","",364,N],[13,"Generic","","",364,N],[13,"NoDefId","","",364,N],[5,"metadata_symbol_name","","",N,[[["tyctxt"]],["string"]]],[11,"assert_receiver_is_total_eq","","",363,N],[11,"eq","","",363,[[["self"],["symbolexportlevel"]],["bool"]]],[11,"fmt","","",363,[[["self"],["formatter"]],["result"]]],[11,"clone","","",363,[[["self"]],["symbolexportlevel"]]],[11,"encode","","",363,[[["self"],["__s"]],["result"]]],[11,"decode","","",363,[[["__d"]],["result",["symbolexportlevel"]]]],[11,"hash_stable","","",363,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"is_below_threshold","","",363,[[["self"],["symbolexportlevel"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",364,N],[11,"eq","","",364,[[["self"],["exportedsymbol"]],["bool"]]],[11,"ne","","",364,[[["self"],["exportedsymbol"]],["bool"]]],[11,"fmt","","",364,[[["self"],["formatter"]],["result"]]],[11,"clone","","",364,[[["self"]],["exportedsymbol"]]],[11,"encode","","",364,[[["self"],["__s"]],["result"]]],[11,"decode","","",364,[[["__d"]],["result",["exportedsymbol"]]]],[11,"symbol_name","","",364,[[["self"],["tyctxt"]],["symbolname"]]],[11,"compare_stable","","",364,[[["self"],["tyctxt"],["exportedsymbol"]],["ordering"]]],[11,"hash_stable","","",364,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"free_region","rustc::middle","This file handles the relationships between free regions -- meaning lifetime parameters. Ordinarily, free regions are unrelated to one another, but they can be related via implied or explicit bounds.  In that case, we track the bounds using the `TransitiveRelation` type and use that to decide when one free region outlives another and so forth.",N,N],[3,"RegionRelations","rustc::middle::free_region","Combines a `region::ScopeTree` (which governs relationships between scopes) and a `FreeRegionMap` (which governs relationships between free regions) to yield a complete relation between concrete regions.",N,N],[12,"tcx","","",365,N],[12,"context","","context used to fetch the region maps",365,N],[12,"region_scope_tree","","region maps for the given context",365,N],[12,"free_regions","","free-region relationships",365,N],[11,"new","","",365,[[["tyctxt"],["defid"],["scopetree"],["freeregionmap"]],["self"]]],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run after inference and sadly the logic is somewhat duplicated with the code in infer.rs.",365,[[["self"],["region"],["region"]],["bool"]]],[11,"is_static","","Determines whether this free-region is required to be 'static",365,[[["self"],["region"]],["bool"]]],[11,"lub_free_regions","","",365,[[["self"],["region"],["region"]],["region"]]],[0,"intrinsicck","rustc::middle","",N,N],[3,"ItemVisitor","rustc::middle::intrinsicck","",N,N],[12,"tcx","","",366,N],[3,"ExprVisitor","","",N,N],[12,"tcx","","",367,N],[12,"tables","","",367,N],[12,"param_env","","",367,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"unpack_option_like","","If the type is `Option<T>`, it will return `T`, otherwise the type itself. Works on most `Option`-like types.",N,[[["tyctxt"],["ty"]],["ty"]]],[11,"def_id_is_transmute","","",367,[[["self"],["defid"]],["bool"]]],[11,"check_transmute","","",367,[[["self"],["span"],["ty"],["ty"]]]],[11,"nested_visit_map","","",366,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",366,[[["self"],["bodyid"]]]],[11,"nested_visit_map","","",367,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",367,[[["self"],["expr"]]]],[0,"lang_items","rustc::middle","",N,N],[3,"LanguageItems","rustc::middle::lang_items","",N,N],[12,"items","","",368,N],[12,"missing","","",368,N],[3,"LanguageItemCollector","","",N,N],[12,"items","","",369,N],[12,"tcx","","",369,N],[12,"item_refs","","",369,N],[4,"LangItem","","",N,N],[13,"CharImplItem","","",370,N],[13,"StrImplItem","","",370,N],[13,"SliceImplItem","","",370,N],[13,"SliceU8ImplItem","","",370,N],[13,"StrAllocImplItem","","",370,N],[13,"SliceAllocImplItem","","",370,N],[13,"SliceU8AllocImplItem","","",370,N],[13,"ConstPtrImplItem","","",370,N],[13,"MutPtrImplItem","","",370,N],[13,"I8ImplItem","","",370,N],[13,"I16ImplItem","","",370,N],[13,"I32ImplItem","","",370,N],[13,"I64ImplItem","","",370,N],[13,"I128ImplItem","","",370,N],[13,"IsizeImplItem","","",370,N],[13,"U8ImplItem","","",370,N],[13,"U16ImplItem","","",370,N],[13,"U32ImplItem","","",370,N],[13,"U64ImplItem","","",370,N],[13,"U128ImplItem","","",370,N],[13,"UsizeImplItem","","",370,N],[13,"F32ImplItem","","",370,N],[13,"F64ImplItem","","",370,N],[13,"F32RuntimeImplItem","","",370,N],[13,"F64RuntimeImplItem","","",370,N],[13,"SizedTraitLangItem","","",370,N],[13,"UnsizeTraitLangItem","","",370,N],[13,"CopyTraitLangItem","","",370,N],[13,"CloneTraitLangItem","","",370,N],[13,"SyncTraitLangItem","","",370,N],[13,"FreezeTraitLangItem","","",370,N],[13,"DropTraitLangItem","","",370,N],[13,"CoerceUnsizedTraitLangItem","","",370,N],[13,"AddTraitLangItem","","",370,N],[13,"SubTraitLangItem","","",370,N],[13,"MulTraitLangItem","","",370,N],[13,"DivTraitLangItem","","",370,N],[13,"RemTraitLangItem","","",370,N],[13,"NegTraitLangItem","","",370,N],[13,"NotTraitLangItem","","",370,N],[13,"BitXorTraitLangItem","","",370,N],[13,"BitAndTraitLangItem","","",370,N],[13,"BitOrTraitLangItem","","",370,N],[13,"ShlTraitLangItem","","",370,N],[13,"ShrTraitLangItem","","",370,N],[13,"AddAssignTraitLangItem","","",370,N],[13,"SubAssignTraitLangItem","","",370,N],[13,"MulAssignTraitLangItem","","",370,N],[13,"DivAssignTraitLangItem","","",370,N],[13,"RemAssignTraitLangItem","","",370,N],[13,"BitXorAssignTraitLangItem","","",370,N],[13,"BitAndAssignTraitLangItem","","",370,N],[13,"BitOrAssignTraitLangItem","","",370,N],[13,"ShlAssignTraitLangItem","","",370,N],[13,"ShrAssignTraitLangItem","","",370,N],[13,"IndexTraitLangItem","","",370,N],[13,"IndexMutTraitLangItem","","",370,N],[13,"UnsafeCellTypeLangItem","","",370,N],[13,"DerefTraitLangItem","","",370,N],[13,"DerefMutTraitLangItem","","",370,N],[13,"FnTraitLangItem","","",370,N],[13,"FnMutTraitLangItem","","",370,N],[13,"FnOnceTraitLangItem","","",370,N],[13,"GeneratorStateLangItem","","",370,N],[13,"GeneratorTraitLangItem","","",370,N],[13,"EqTraitLangItem","","",370,N],[13,"PartialOrdTraitLangItem","","",370,N],[13,"OrdTraitLangItem","","",370,N],[13,"PanicFnLangItem","","",370,N],[13,"PanicBoundsCheckFnLangItem","","",370,N],[13,"PanicInfoLangItem","","",370,N],[13,"PanicImplLangItem","","",370,N],[13,"ExchangeMallocFnLangItem","","",370,N],[13,"BoxFreeFnLangItem","","",370,N],[13,"DropInPlaceFnLangItem","","",370,N],[13,"OomLangItem","","",370,N],[13,"AllocLayoutLangItem","","",370,N],[13,"StartFnLangItem","","",370,N],[13,"EhPersonalityLangItem","","",370,N],[13,"EhUnwindResumeLangItem","","",370,N],[13,"MSVCTryFilterLangItem","","",370,N],[13,"OwnedBoxLangItem","","",370,N],[13,"PhantomDataItem","","",370,N],[13,"NonZeroItem","","",370,N],[13,"ManuallyDropItem","","",370,N],[13,"DebugTraitLangItem","","",370,N],[13,"I128AddFnLangItem","","",370,N],[13,"U128AddFnLangItem","","",370,N],[13,"I128SubFnLangItem","","",370,N],[13,"U128SubFnLangItem","","",370,N],[13,"I128MulFnLangItem","","",370,N],[13,"U128MulFnLangItem","","",370,N],[13,"I128DivFnLangItem","","",370,N],[13,"U128DivFnLangItem","","",370,N],[13,"I128RemFnLangItem","","",370,N],[13,"U128RemFnLangItem","","",370,N],[13,"I128ShlFnLangItem","","",370,N],[13,"U128ShlFnLangItem","","",370,N],[13,"I128ShrFnLangItem","","",370,N],[13,"U128ShrFnLangItem","","",370,N],[13,"I128AddoFnLangItem","","",370,N],[13,"U128AddoFnLangItem","","",370,N],[13,"I128SuboFnLangItem","","",370,N],[13,"U128SuboFnLangItem","","",370,N],[13,"I128MuloFnLangItem","","",370,N],[13,"U128MuloFnLangItem","","",370,N],[13,"I128ShloFnLangItem","","",370,N],[13,"U128ShloFnLangItem","","",370,N],[13,"I128ShroFnLangItem","","",370,N],[13,"U128ShroFnLangItem","","",370,N],[13,"AlignOffsetLangItem","","",370,N],[13,"TerminationTraitLangItem","","",370,N],[5,"extract","","",N,N],[5,"collect","","",N,[[["tyctxt"]],["languageitems"]]],[11,"fmt","","",370,[[["self"],["formatter"]],["result"]]],[11,"clone","","",370,[[["self"]],["langitem"]]],[11,"eq","","",370,[[["self"],["langitem"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",370,N],[11,"hash","","",370,N],[11,"encode","","",370,[[["self"],["__s"]],["result"]]],[11,"decode","","",370,[[["__d"]],["result",["langitem"]]]],[11,"from_u32","","",370,[[["u32"]],["option",["langitem"]]]],[11,"name","","",370,[[["self"]],["str"]]],[11,"new","","",368,[[],["languageitems"]]],[11,"items","","",368,N],[11,"require","","",368,[[["self"],["langitem"]],["result",["defid","string"]]]],[11,"fn_trait_kind","","",368,[[["self"],["defid"]],["option",["closurekind"]]]],[11,"char_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"str_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"slice_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"slice_u8_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"str_alloc_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"slice_alloc_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"slice_u8_alloc_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"const_ptr_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"mut_ptr_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"i8_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"i16_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"i32_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"i64_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"isize_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"u8_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"u16_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"u32_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"u64_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"usize_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"f32_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"f64_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"f32_runtime_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"f64_runtime_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"sized_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"unsize_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"copy_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"clone_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"sync_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"freeze_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"drop_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"coerce_unsized_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"add_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"sub_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"mul_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"div_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"rem_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"neg_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"not_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"bitxor_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"bitand_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"bitor_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"shl_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"shr_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"add_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"sub_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"mul_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"div_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"rem_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"bitxor_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"bitand_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"bitor_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"shl_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"shr_assign_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"index_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"index_mut_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"unsafe_cell_type","","",368,[[["self"]],["option",["defid"]]]],[11,"deref_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"deref_mut_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"fn_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"fn_mut_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"fn_once_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"gen_state","","",368,[[["self"]],["option",["defid"]]]],[11,"gen_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"eq_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"partial_ord_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"ord_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"panic_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"panic_bounds_check_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"panic_info","","",368,[[["self"]],["option",["defid"]]]],[11,"panic_impl","","",368,[[["self"]],["option",["defid"]]]],[11,"exchange_malloc_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"box_free_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"drop_in_place_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"oom","","",368,[[["self"]],["option",["defid"]]]],[11,"alloc_layout","","",368,[[["self"]],["option",["defid"]]]],[11,"start_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"eh_personality","","",368,[[["self"]],["option",["defid"]]]],[11,"eh_unwind_resume","","",368,[[["self"]],["option",["defid"]]]],[11,"msvc_try_filter","","",368,[[["self"]],["option",["defid"]]]],[11,"owned_box","","",368,[[["self"]],["option",["defid"]]]],[11,"phantom_data","","",368,[[["self"]],["option",["defid"]]]],[11,"non_zero","","",368,[[["self"]],["option",["defid"]]]],[11,"manually_drop","","",368,[[["self"]],["option",["defid"]]]],[11,"debug_trait","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_add_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_add_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_sub_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_sub_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_mul_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_mul_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_div_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_div_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_rem_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_rem_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_shl_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_shl_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_shr_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_shr_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_addo_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_addo_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_subo_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_subo_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_mulo_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_mulo_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_shlo_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_shlo_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"i128_shro_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"u128_shro_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"align_offset_fn","","",368,[[["self"]],["option",["defid"]]]],[11,"termination","","",368,[[["self"]],["option",["defid"]]]],[11,"visit_item","","",369,[[["self"],["item"]]]],[11,"visit_trait_item","","",369,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",369,[[["self"],["implitem"]]]],[11,"new","","",369,[[["tyctxt"]],["languageitemcollector"]]],[11,"collect_item","","",369,[[["self"],["usize"],["defid"]]]],[0,"liveness","rustc::middle","A classic liveness analysis based on dataflow over the AST.  Computes, for each local variable in a function, whether that variable is live at a given point.  Program execution points are identified by their id.",N,N],[3,"Variable","rustc::middle::liveness","",N,N],[12,"0","","",371,N],[3,"LiveNode","","",N,N],[12,"0","","",372,N],[3,"CaptureInfo","","",N,N],[12,"ln","","",373,N],[12,"var_hid","","",373,N],[3,"LocalInfo","","",N,N],[12,"id","","",374,N],[12,"name","","",374,N],[12,"is_shorthand","","",374,N],[3,"IrMaps","","",N,N],[12,"tcx","","",375,N],[12,"num_live_nodes","","",375,N],[12,"num_vars","","",375,N],[12,"live_node_map","","",375,N],[12,"variable_map","","",375,N],[12,"capture_info_map","","",375,N],[12,"var_kinds","","",375,N],[12,"lnks","","",375,N],[3,"Users","","",N,N],[12,"reader","","",376,N],[12,"writer","","",376,N],[12,"used","","",376,N],[3,"Specials","","",N,N],[12,"exit_ln","","",377,N],[12,"fallthrough_ln","","",377,N],[12,"clean_exit_var","","",377,N],[3,"Liveness","","",N,N],[12,"ir","","",378,N],[12,"tables","","",378,N],[12,"s","","",378,N],[12,"successors","","",378,N],[12,"users","","",378,N],[12,"break_ln","","",378,N],[12,"cont_ln","","",378,N],[4,"LoopKind","","For use with `propagate_through_loop`.",N,N],[13,"LoopLoop","","An endless `loop` loop.",379,N],[13,"WhileLoop","","A `while` loop, with the given expression as condition.",379,N],[4,"LiveNodeKind","","",N,N],[13,"FreeVarNode","","",380,N],[13,"ExprNode","","",380,N],[13,"VarDefNode","","",380,N],[13,"ExitNode","","",380,N],[4,"VarKind","","",N,N],[13,"Arg","","",381,N],[13,"Local","","",381,N],[13,"CleanExit","","",381,N],[5,"live_node_kind_to_string","","",N,[[["livenodekind"],["tyctxt"]],["string"]]],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"invalid_node","","",N,[[],["livenode"]]],[5,"visit_fn","","",N,[[["irmaps"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[5,"add_from_pat","","",N,[[["irmaps"],["p"]]]],[5,"visit_local","","",N,[[["irmaps"],["local"]]]],[5,"visit_arm","","",N,[[["irmaps"],["arm"]]]],[5,"visit_expr","","",N,[[["irmaps"],["expr"]]]],[5,"invalid_users","","",N,[[],["users"]]],[5,"check_local","","",N,[[["liveness"],["local"]]]],[5,"check_arm","","",N,[[["liveness"],["arm"]]]],[5,"check_expr","","",N,[[["liveness"],["expr"]]]],[17,"ACC_READ","","",N,N],[17,"ACC_WRITE","","",N,N],[17,"ACC_USE","","",N,N],[11,"clone","","",371,[[["self"]],["variable"]]],[11,"eq","","",371,[[["self"],["variable"]],["bool"]]],[11,"ne","","",371,[[["self"],["variable"]],["bool"]]],[11,"clone","","",372,[[["self"]],["livenode"]]],[11,"eq","","",372,[[["self"],["livenode"]],["bool"]]],[11,"ne","","",372,[[["self"],["livenode"]],["bool"]]],[11,"get","","",371,[[["self"]],["usize"]]],[11,"get","","",372,[[["self"]],["usize"]]],[11,"clone","","",380,[[["self"]],["livenodekind"]]],[11,"eq","","",380,[[["self"],["livenodekind"]],["bool"]]],[11,"ne","","",380,[[["self"],["livenodekind"]],["bool"]]],[11,"fmt","","",380,[[["self"],["formatter"]],["result"]]],[11,"nested_visit_map","","",375,[[["self"]],["nestedvisitormap"]]],[11,"visit_fn","","",375,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_local","","",375,[[["self"],["local"]]]],[11,"visit_expr","","",375,[[["self"],["expr"]]]],[11,"visit_arm","","",375,[[["self"],["arm"]]]],[11,"fmt","","",372,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",371,[[["self"],["formatter"]],["result"]]],[11,"is_valid","","",372,[[["self"]],["bool"]]],[11,"clone","","",374,[[["self"]],["localinfo"]]],[11,"fmt","","",374,[[["self"],["formatter"]],["result"]]],[11,"clone","","",381,[[["self"]],["varkind"]]],[11,"fmt","","",381,[[["self"],["formatter"]],["result"]]],[11,"new","","",375,[[["tyctxt"]],["irmaps"]]],[11,"add_live_node","","",375,[[["self"],["livenodekind"]],["livenode"]]],[11,"add_live_node_for_node","","",375,[[["self"],["hirid"],["livenodekind"]]]],[11,"add_variable","","",375,[[["self"],["varkind"]],["variable"]]],[11,"variable","","",375,[[["self"],["hirid"],["span"]],["variable"]]],[11,"variable_name","","",375,[[["self"],["variable"]],["string"]]],[11,"variable_is_shorthand","","",375,[[["self"],["variable"]],["bool"]]],[11,"set_captures","","",375,[[["self"],["nodeid"],["vec",["captureinfo"]]]]],[11,"lnk","","",375,[[["self"],["livenode"]],["livenodekind"]]],[11,"clone","","",376,[[["self"]],["users"]]],[11,"clone","","",377,[[["self"]],["specials"]]],[11,"new","","",378,[[["irmaps"],["bodyid"]],["liveness"]]],[11,"live_node","","",378,[[["self"],["hirid"],["span"]],["livenode"]]],[11,"variable","","",378,[[["self"],["hirid"],["span"]],["variable"]]],[11,"pat_bindings","","",378,[[["self"],["pat"],["f"]]]],[11,"arm_pats_bindings","","",378,[[["self"],["option",["pat"]],["f"]]]],[11,"define_bindings_in_pat","","",378,[[["self"],["pat"],["livenode"]],["livenode"]]],[11,"define_bindings_in_arm_pats","","",378,[[["self"],["option",["pat"]],["livenode"]],["livenode"]]],[11,"idx","","",378,[[["self"],["livenode"],["variable"]],["usize"]]],[11,"live_on_entry","","",378,[[["self"],["livenode"],["variable"]],["option",["livenodekind"]]]],[11,"live_on_exit","","",378,[[["self"],["livenode"],["variable"]],["option",["livenodekind"]]]],[11,"used_on_entry","","",378,[[["self"],["livenode"],["variable"]],["bool"]]],[11,"assigned_on_entry","","",378,[[["self"],["livenode"],["variable"]],["option",["livenodekind"]]]],[11,"assigned_on_exit","","",378,[[["self"],["livenode"],["variable"]],["option",["livenodekind"]]]],[11,"indices2","","",378,[[["self"],["livenode"],["livenode"],["f"]]]],[11,"write_vars","","",378,[[["self"],["write"],["livenode"],["f"]],["result"]]],[11,"ln_str","","",378,[[["self"],["livenode"]],["string"]]],[11,"init_empty","","",378,[[["self"],["livenode"],["livenode"]]]],[11,"init_from_succ","","",378,[[["self"],["livenode"],["livenode"]]]],[11,"merge_from_succ","","",378,[[["self"],["livenode"],["livenode"],["bool"]],["bool"]]],[11,"define","","",378,[[["self"],["livenode"],["variable"]]]],[11,"acc","","",378,[[["self"],["livenode"],["variable"],["u32"]]]],[11,"compute","","",378,[[["self"],["expr"]],["livenode"]]],[11,"propagate_through_block","","",378,[[["self"],["block"],["livenode"]],["livenode"]]],[11,"propagate_through_stmt","","",378,[[["self"],["stmt"],["livenode"]],["livenode"]]],[11,"propagate_through_decl","","",378,[[["self"],["decl"],["livenode"]],["livenode"]]],[11,"propagate_through_local","","",378,[[["self"],["local"],["livenode"]],["livenode"]]],[11,"propagate_through_exprs","","",378,N],[11,"propagate_through_opt_expr","","",378,[[["self"],["option",["expr"]],["livenode"]],["livenode"]]],[11,"propagate_through_expr","","",378,[[["self"],["expr"],["livenode"]],["livenode"]]],[11,"propagate_through_place_components","","",378,[[["self"],["expr"],["livenode"]],["livenode"]]],[11,"write_place","","",378,[[["self"],["expr"],["livenode"],["u32"]],["livenode"]]],[11,"access_var","","",378,[[["self"],["hirid"],["nodeid"],["livenode"],["u32"],["span"]],["livenode"]]],[11,"access_path","","",378,[[["self"],["hirid"],["path"],["livenode"],["u32"]],["livenode"]]],[11,"propagate_through_loop","","",378,[[["self"],["expr"],["loopkind"],["block"],["livenode"]],["livenode"]]],[11,"nested_visit_map","","",378,[[["self"]],["nestedvisitormap"]]],[11,"visit_local","","",378,[[["self"],["local"]]]],[11,"visit_expr","","",378,[[["self"],["expr"]]]],[11,"visit_arm","","",378,[[["self"],["arm"]]]],[11,"check_place","","",378,[[["self"],["expr"]]]],[11,"should_warn","","",378,[[["self"],["variable"]],["option",["string"]]]],[11,"warn_about_unused_args","","",378,[[["self"],["body"],["livenode"]]]],[11,"warn_about_unused_or_dead_vars_in_pat","","",378,[[["self"],["pat"]]]],[11,"warn_about_unused","","",378,[[["self"],["span"],["hirid"],["livenode"],["variable"]],["bool"]]],[11,"warn_about_dead_assign","","",378,[[["self"],["span"],["hirid"],["livenode"],["variable"]]]],[11,"report_dead_assign","","",378,[[["self"],["hirid"],["span"],["variable"],["bool"]]]],[0,"mem_categorization","rustc::middle","Categorization",N,N],[3,"Upvar","rustc::middle::mem_categorization","",N,N],[12,"id","","",382,N],[12,"kind","","",382,N],[3,"FieldIndex","","",N,N],[12,"0","","",383,N],[12,"1","","",383,N],[3,"cmt_","","",N,N],[12,"hir_id","","",384,N],[12,"span","","",384,N],[12,"cat","","",384,N],[12,"mutbl","","",384,N],[12,"ty","","",384,N],[12,"note","","",384,N],[3,"MemCategorizationContext","","",N,N],[12,"tcx","","",385,N],[12,"region_scope_tree","","",385,N],[12,"tables","","",385,N],[12,"rvalue_promotable_map","","",385,N],[12,"infcx","","",385,N],[4,"Categorization","","",N,N],[13,"Rvalue","","",386,N],[13,"StaticItem","","",386,N],[13,"Upvar","","",386,N],[13,"Local","","",386,N],[13,"Deref","","",386,N],[13,"Interior","","",386,N],[13,"Downcast","","",386,N],[4,"PointerKind","","",N,N],[13,"Unique","","`Box<T>`",387,N],[13,"BorrowedPtr","","`&T`",387,N],[13,"UnsafePtr","","`*T`",387,N],[4,"InteriorKind","","",N,N],[13,"InteriorField","","",388,N],[13,"InteriorElement","","",388,N],[4,"InteriorOffsetKind","","",N,N],[13,"Index","","",389,N],[13,"Pattern","","",389,N],[4,"MutabilityCategory","","",N,N],[13,"McImmutable","","",390,N],[13,"McDeclared","","",390,N],[13,"McInherited","","",390,N],[4,"Note","","",N,N],[13,"NoteClosureEnv","","",391,N],[13,"NoteUpvarRef","","",391,N],[13,"NoteIndex","","",391,N],[13,"NoteNone","","",391,N],[4,"ImmutabilityBlame","","",N,N],[13,"ImmLocal","","",392,N],[13,"ClosureEnv","","",392,N],[13,"LocalDeref","","",392,N],[13,"AdtFieldDeref","","",392,N],[4,"Aliasability","","",N,N],[13,"FreelyAliasable","","",393,N],[13,"NonAliasable","","",393,N],[13,"ImmutableUnique","","",393,N],[4,"AliasableReason","","",N,N],[13,"AliasableBorrowed","","",394,N],[13,"AliasableStatic","","",394,N],[13,"AliasableStaticMut","","",394,N],[5,"ptr_sigil","","",N,[[["pointerkind"]],["str"]]],[6,"cmt","","",N,N],[6,"McResult","","",N,N],[8,"HirNode","","",N,N],[10,"hir_id","","",395,[[["self"]],["hirid"]]],[10,"span","","",395,[[["self"]],["span"]]],[11,"clone","","",386,[[["self"]],["categorization"]]],[11,"fmt","","",386,[[["self"],["formatter"]],["result"]]],[11,"eq","","",386,[[["self"],["categorization"]],["bool"]]],[11,"ne","","",386,[[["self"],["categorization"]],["bool"]]],[11,"clone","","",382,[[["self"]],["upvar"]]],[11,"eq","","",382,[[["self"],["upvar"]],["bool"]]],[11,"ne","","",382,[[["self"],["upvar"]],["bool"]]],[11,"clone","","",387,[[["self"]],["pointerkind"]]],[11,"fmt","","",387,[[["self"],["formatter"]],["result"]]],[11,"eq","","",387,[[["self"],["pointerkind"]],["bool"]]],[11,"ne","","",387,[[["self"],["pointerkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",387,N],[11,"hash","","",387,N],[11,"clone","","",388,[[["self"]],["interiorkind"]]],[11,"eq","","",388,[[["self"],["interiorkind"]],["bool"]]],[11,"ne","","",388,[[["self"],["interiorkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",388,N],[11,"hash","","",388,N],[11,"clone","","",383,[[["self"]],["fieldindex"]]],[11,"assert_receiver_is_total_eq","","",383,N],[11,"eq","","",383,[[["self"],["self"]],["bool"]]],[11,"hash","","",383,[[["self"],["h"]]]],[11,"clone","","",389,[[["self"]],["interioroffsetkind"]]],[11,"eq","","",389,[[["self"],["interioroffsetkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",389,N],[11,"hash","","",389,N],[11,"fmt","","",389,[[["self"],["formatter"]],["result"]]],[11,"clone","","",390,[[["self"]],["mutabilitycategory"]]],[11,"eq","","",390,[[["self"],["mutabilitycategory"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",390,N],[11,"hash","","",390,N],[11,"fmt","","",390,[[["self"],["formatter"]],["result"]]],[11,"clone","","",391,[[["self"]],["note"]]],[11,"eq","","",391,[[["self"],["note"]],["bool"]]],[11,"ne","","",391,[[["self"],["note"]],["bool"]]],[11,"fmt","","",391,[[["self"],["formatter"]],["result"]]],[11,"clone","","",384,[[["self"]],["cmt_"]]],[11,"fmt","","",384,[[["self"],["formatter"]],["result"]]],[11,"eq","","",384,[[["self"],["cmt_"]],["bool"]]],[11,"ne","","",384,[[["self"],["cmt_"]],["bool"]]],[11,"resolve_field","","",384,[[["self"],["usize"]],["option"]]],[11,"immutability_blame","","",384,[[["self"]],["option",["immutabilityblame"]]]],[11,"hir_id","rustc::hir","",58,[[["self"]],["hirid"]]],[11,"span","","",58,[[["self"]],["span"]]],[11,"hir_id","","",50,[[["self"]],["hirid"]]],[11,"span","","",50,[[["self"]],["span"]]],[11,"clone","rustc::middle::mem_categorization","",385,[[["self"]],["memcategorizationcontext"]]],[11,"from_mutbl","","",390,[[["mutability"]],["mutabilitycategory"]]],[11,"from_borrow_kind","","",390,[[["borrowkind"]],["mutabilitycategory"]]],[11,"from_pointer_kind","","",390,[[["mutabilitycategory"],["pointerkind"]],["mutabilitycategory"]]],[11,"from_local","","",390,[[["tyctxt"],["typecktables"],["nodeid"]],["mutabilitycategory"]]],[11,"inherit","","",390,[[["self"]],["mutabilitycategory"]]],[11,"is_mutable","","",390,[[["self"]],["bool"]]],[11,"is_immutable","","",390,[[["self"]],["bool"]]],[11,"to_user_str","","",390,[[["self"]],["str"]]],[11,"new","","",385,[[["tyctxt"],["scopetree"],["typecktables"],["option",["lrc"]]],["memcategorizationcontext"]]],[11,"with_infer","","Creates a `MemCategorizationContext` during type inference. This is used during upvar analysis and a few other places. Because the typeck tables are not yet complete, the results from the analysis must be used with caution:",385,[[["inferctxt"],["scopetree"],["typecktables"]],["memcategorizationcontext"]]],[11,"type_moves_by_default","","",385,[[["self"],["paramenv"],["ty"],["span"]],["bool"]]],[11,"resolve_type_vars_if_possible","","",385,[[["self"],["t"]],["t"]]],[11,"is_tainted_by_errors","","",385,[[["self"]],["bool"]]],[11,"resolve_type_vars_or_error","","",385,[[["self"],["hirid"],["option",["ty"]]],["mcresult",["ty"]]]],[11,"node_ty","","",385,[[["self"],["hirid"]],["mcresult",["ty"]]]],[11,"expr_ty","","",385,[[["self"],["expr"]],["mcresult",["ty"]]]],[11,"expr_ty_adjusted","","",385,[[["self"],["expr"]],["mcresult",["ty"]]]],[11,"pat_ty_adjusted","","Returns the type of value that this pattern matches against. Some non-obvious cases:",385,[[["self"],["pat"]],["mcresult",["ty"]]]],[11,"pat_ty_unadjusted","","Like `pat_ty`, but ignores implicit `&` patterns.",385,[[["self"],["pat"]],["mcresult",["ty"]]]],[11,"cat_expr","","",385,[[["self"],["expr"]],["mcresult",["cmt_"]]]],[11,"cat_expr_adjusted","","",385,[[["self"],["expr"],["cmt_"],["adjustment"]],["mcresult",["cmt_"]]]],[11,"cat_expr_adjusted_with","","",385,[[["self"],["expr"],["f"],["adjustment"]],["mcresult",["cmt_"]]]],[11,"cat_expr_unadjusted","","",385,[[["self"],["expr"]],["mcresult",["cmt_"]]]],[11,"cat_def","","",385,[[["self"],["hirid"],["span"],["ty"],["def"]],["mcresult",["cmt_"]]]],[11,"cat_upvar","","",385,[[["self"],["hirid"],["span"],["nodeid"],["nodeid"]],["mcresult",["cmt_"]]]],[11,"env_deref","","",385,[[["self"],["hirid"],["span"],["upvarid"],["mutabilitycategory"],["borrowkind"],["cmt_"]],["cmt_"]]],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`. This could be `'static` if `id` is part of a constant expression.",385,[[["self"],["itemlocalid"]],["region"]]],[11,"cat_rvalue_node","","",385,[[["self"],["hirid"],["span"],["ty"]],["cmt_"]]],[11,"cat_rvalue","","",385,[[["self"],["hirid"],["span"],["region"],["ty"]],["cmt_"]]],[11,"cat_field","","",385,[[["self"],["n"],["cmt"],["usize"],["ident"],["ty"]],["cmt_"]]],[11,"cat_overloaded_place","","",385,[[["self"],["expr"],["expr"],["note"]],["mcresult",["cmt_"]]]],[11,"cat_deref","","",385,N],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",385,[[["self"],["n"],["cmt"],["ty"],["interioroffsetkind"]],["mcresult",["cmt_"]]]],[11,"cat_imm_interior","","",385,[[["self"],["n"],["cmt"],["ty"],["interiorkind"]],["cmt_"]]],[11,"cat_downcast_if_needed","","",385,[[["self"],["n"],["cmt"],["defid"]],["cmt"]]],[11,"cat_pattern","","",385,[[["self"],["cmt"],["pat"],["f"]],["mcresult"]]],[11,"cat_pattern_","","",385,[[["self"],["cmt"],["pat"],["f"]],["mcresult"]]],[11,"clone","","",393,[[["self"]],["aliasability"]]],[11,"fmt","","",393,[[["self"],["formatter"]],["result"]]],[11,"clone","","",394,[[["self"]],["aliasablereason"]]],[11,"fmt","","",394,[[["self"],["formatter"]],["result"]]],[11,"guarantor","","Returns `self` after stripping away any derefs or interior content. The return value is basically the `cmt` which determines how long the value in `self` remains live.",384,[[["self"]],["cmt_"]]],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this place represents a freely aliasable pointer type.",384,[[["self"]],["aliasability"]]],[11,"upvar_cat","","",384,[[["self"]],["option",["categorization"]]]],[11,"descriptive_string","","",384,[[["self"],["tyctxt"]],["string"]]],[11,"fmt","","",388,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",382,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",382,[[["self"],["formatter"]],["result"]]],[0,"privacy","rustc::middle","A pass that checks to make sure private fields and methods aren't used outside their scopes. This pass will also generate a set of exported items which are available for use externally when compiled as a library.",N,N],[3,"AccessLevels","rustc::middle::privacy","",N,N],[12,"map","","",396,N],[4,"AccessLevel","","",N,N],[13,"Reachable","","",397,N],[13,"Exported","","",397,N],[13,"Public","","",397,N],[6,"ExternalExports","","A set containing all exported definitions from external crates. The set does not contain any entries from local crates.",N,N],[11,"clone","","",397,[[["self"]],["accesslevel"]]],[11,"fmt","","",397,[[["self"],["formatter"]],["result"]]],[11,"eq","","",397,[[["self"],["accesslevel"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",397,N],[11,"partial_cmp","","",397,[[["self"],["accesslevel"]],["option",["ordering"]]]],[11,"cmp","","",397,[[["self"],["accesslevel"]],["ordering"]]],[11,"clone","","",396,[[["self"]],["accesslevels"]]],[11,"is_reachable","","",396,[[["self"],["id"]],["bool"]]],[11,"is_exported","","",396,[[["self"],["id"]],["bool"]]],[11,"is_public","","",396,[[["self"],["id"]],["bool"]]],[11,"default","","",396,[[],["self"]]],[11,"fmt","","",396,[[["self"],["formatter"]],["result"]]],[0,"reachable","rustc::middle","",N,N],[3,"ReachableContext","rustc::middle::reachable","",N,N],[12,"tcx","","",398,N],[12,"tables","","",398,N],[12,"reachable_symbols","","",398,N],[12,"worklist","","",398,N],[12,"any_library","","",398,N],[3,"CollectPrivateImplItemsVisitor","","",N,N],[12,"tcx","","",399,N],[12,"access_levels","","",399,N],[12,"worklist","","",399,N],[3,"ReachableSet","","",N,N],[12,"0","","",400,N],[5,"generics_require_inlining","","",N,[[["generics"]],["bool"]]],[5,"item_might_be_inlined","","",N,[[["tyctxt"],["item"],["codegenfnattrs"]],["bool"]]],[5,"method_might_be_inlined","","",N,[[["tyctxt"],["implitem"],["defid"]],["bool"]]],[5,"reachable_set","","",N,[[["tyctxt"],["cratenum"]],["reachableset"]]],[5,"provide","","",N,[[["providers"]]]],[11,"nested_visit_map","","",398,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",398,[[["self"],["bodyid"]]]],[11,"visit_expr","","",398,[[["self"],["expr"]]]],[11,"def_id_represents_local_inlined_item","","",398,[[["self"],["defid"]],["bool"]]],[11,"propagate","","",398,[[["self"]]]],[11,"propagate_node","","",398,[[["self"],["node"],["nodeid"]]]],[11,"visit_item","","",399,[[["self"],["item"]]]],[11,"visit_trait_item","","",399,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",399,[[["self"],["implitem"]]]],[11,"clone","","",400,[[["self"]],["reachableset"]]],[0,"region","rustc::middle","This file builds up the `ScopeTree`, which describes the parent links in the region hierarchy.",N,N],[3,"Scope","rustc::middle::region","Scope represents a statically-describable scope that can be used to bound the lifetime/region for values.",N,N],[12,"id","","",401,N],[12,"code","","",401,N],[3,"BlockRemainder","","Represents a subscope of `block` for a binding that is introduced by `block.stmts[first_statement_index]`. Such subscopes represent a suffix of the block. Note that each subscope does not include the initializer expression, if any, for the statement indexed by `first_statement_index`.",N,N],[12,"block","","",402,N],[12,"first_statement_index","","",402,N],[3,"FirstStatementIndex","","",N,N],[12,"0","","",403,N],[3,"ScopeTree","","The region scope tree encodes information about region relationships.",N,N],[12,"root_body","","If not empty, this body is the root of this region hierarchy.",404,N],[12,"root_parent","","The parent of the root body owner, if the latter is an an associated const or method, as impls/traits can also have lifetime parameters free in this body.",404,N],[12,"parent_map","","`parent_map` maps from a scope id to the enclosing scope id; this is usually corresponding to the lexical nesting, though in the case of closures the parent scope is the innermost conditional expression or repeating block. (Note that the enclosing scope id for the block associated with a closure is the closure itself.)",404,N],[12,"var_map","","`var_map` maps from a variable or binding id to the block in which that variable is declared.",404,N],[12,"destruction_scopes","","maps from a node-id to the associated destruction scope (if any)",404,N],[12,"rvalue_scopes","","`rvalue_scopes` includes entries for those expressions whose cleanup scope is larger than the default. The map goes from the expression id to the cleanup scope id. For rvalues not present in this table, the appropriate cleanup scope is the innermost enclosing statement, conditional expression, or repeating block (see `terminating_scopes`). In constants, None is used to indicate that certain expressions escape into 'static and should have no local cleanup scope.",404,N],[12,"closure_tree","","Encodes the hierarchy of fn bodies. Every fn body (including closures) forms its own distinct region hierarchy, rooted in the block that is the fn body. This map points from the id of that root block to the id of the root block for the enclosing fn, if any. Thus the map structures the fn bodies into a hierarchy based on their lexical mapping. This is used to handle the relationships between regions in a fn and in a closure defined by that fn. See the \"Modeling closures\" section of the README in infer::region_constraints for more details.",404,N],[12,"yield_in_scope","","If there are any `yield` nested within a scope, this map stores the `Span` of the last one and its index in the postorder of the Visitor traversal on the HIR.",404,N],[12,"body_expr_count","","The number of visit_expr and visit_pat calls done in the body. Used to sanity check visit_expr/visit_pat call count when calculating generator interiors.",404,N],[3,"Context","","",N,N],[12,"root_id","","the root of the current region tree. This is typically the id of the innermost fn body. Each fn forms its own disjoint tree in the region hierarchy. These fn bodies are themselves arranged into a tree. See the \"Modeling closures\" section of the README in infer::region_constraints for more details.",405,N],[12,"var_parent","","The scope that contains any new variables declared, plus its depth in the scope tree.",405,N],[12,"parent","","Region parent of expressions, etc., plus its depth in the scope tree.",405,N],[3,"RegionResolutionVisitor","","",N,N],[12,"tcx","","",406,N],[12,"expr_and_pat_count","","",406,N],[12,"scope_tree","","",406,N],[12,"cx","","",406,N],[12,"terminating_scopes","","`terminating_scopes` is a set containing the ids of each statement, or conditional/repeating expression. These scopes are calling \"terminating scopes\" because, when attempting to find the scope of a temporary, by default we search up the enclosing scopes until we encounter the terminating scope. A conditional/repeating expression is one which is not guaranteed to execute exactly once upon entering the parent scope. This could be because the expression only executes conditionally, such as the expression `b` in `a && b`, or because the expression may execute many times, such as a loop body. The reason that we distinguish such expressions is that, upon exiting the parent scope, we cannot statically know how many times the expression executed, and thus if the expression creates temporaries we cannot know statically how many such temporaries we would have to cleanup. Therefore we ensure that the temporaries never outlast the conditional/repeating expression, preventing the need for dynamic checks and/or arbitrary amounts of stack space. Terminating scopes end up being contained in a DestructionScope that contains the destructor's execution.",406,N],[3,"ExprLocatorVisitor","","",N,N],[12,"hir_id","","",407,N],[12,"result","","",407,N],[12,"expr_and_pat_count","","",407,N],[4,"ScopeData","","",N,N],[13,"Node","","",408,N],[13,"CallSite","","",408,N],[13,"Arguments","","",408,N],[13,"Destruction","","",408,N],[13,"Remainder","","",408,N],[5,"record_var_lifetime","","Records the lifetime of a local variable as `cx.var_parent`",N,[[["regionresolutionvisitor"],["itemlocalid"],["span"]]]],[5,"resolve_block","","",N,[[["regionresolutionvisitor"],["block"]]]],[5,"resolve_arm","","",N,[[["regionresolutionvisitor"],["arm"]]]],[5,"resolve_pat","","",N,[[["regionresolutionvisitor"],["pat"]]]],[5,"resolve_stmt","","",N,[[["regionresolutionvisitor"],["stmt"]]]],[5,"resolve_expr","","",N,[[["regionresolutionvisitor"],["expr"]]]],[5,"resolve_local","","",N,[[["regionresolutionvisitor"],["option",["pat"]],["option",["expr"]]]]],[5,"region_scope_tree","","",N,[[["tyctxt"],["defid"]],["lrc",["scopetree"]]]],[5,"provide","","",N,[[["providers"]]]],[6,"ScopeDepth","","",N,N],[17,"SCOPE_DATA_NODE","","",N,N],[17,"SCOPE_DATA_CALLSITE","","",N,N],[17,"SCOPE_DATA_ARGUMENTS","","",N,N],[17,"SCOPE_DATA_DESTRUCTION","","",N,N],[17,"SCOPE_DATA_REMAINDER_MAX","","",N,N],[11,"clone","","",401,[[["self"]],["scope"]]],[11,"eq","","",401,[[["self"],["scope"]],["bool"]]],[11,"ne","","",401,[[["self"],["scope"]],["bool"]]],[11,"partial_cmp","","",401,[[["self"],["scope"]],["option",["ordering"]]]],[11,"lt","","",401,[[["self"],["scope"]],["bool"]]],[11,"le","","",401,[[["self"],["scope"]],["bool"]]],[11,"gt","","",401,[[["self"],["scope"]],["bool"]]],[11,"ge","","",401,[[["self"],["scope"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",401,N],[11,"cmp","","",401,[[["self"],["scope"]],["ordering"]]],[11,"hash","","",401,N],[11,"encode","","",401,[[["self"],["__s"]],["result"]]],[11,"decode","","",401,[[["__d"]],["result",["scope"]]]],[11,"clone","","",408,[[["self"]],["scopedata"]]],[11,"eq","","",408,[[["self"],["scopedata"]],["bool"]]],[11,"ne","","",408,[[["self"],["scopedata"]],["bool"]]],[11,"partial_cmp","","",408,[[["self"],["scopedata"]],["option",["ordering"]]]],[11,"lt","","",408,[[["self"],["scopedata"]],["bool"]]],[11,"le","","",408,[[["self"],["scopedata"]],["bool"]]],[11,"gt","","",408,[[["self"],["scopedata"]],["bool"]]],[11,"ge","","",408,[[["self"],["scopedata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",408,N],[11,"cmp","","",408,[[["self"],["scopedata"]],["ordering"]]],[11,"hash","","",408,N],[11,"fmt","","",408,[[["self"],["formatter"]],["result"]]],[11,"encode","","",408,[[["self"],["__s"]],["result"]]],[11,"decode","","",408,[[["__d"]],["result",["scopedata"]]]],[11,"clone","","",402,[[["self"]],["blockremainder"]]],[11,"eq","","",402,[[["self"],["blockremainder"]],["bool"]]],[11,"ne","","",402,[[["self"],["blockremainder"]],["bool"]]],[11,"partial_cmp","","",402,[[["self"],["blockremainder"]],["option",["ordering"]]]],[11,"lt","","",402,[[["self"],["blockremainder"]],["bool"]]],[11,"le","","",402,[[["self"],["blockremainder"]],["bool"]]],[11,"gt","","",402,[[["self"],["blockremainder"]],["bool"]]],[11,"ge","","",402,[[["self"],["blockremainder"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",402,N],[11,"cmp","","",402,[[["self"],["blockremainder"]],["ordering"]]],[11,"hash","","",402,N],[11,"encode","","",402,[[["self"],["__s"]],["result"]]],[11,"decode","","",402,[[["__d"]],["result",["blockremainder"]]]],[11,"fmt","","",402,[[["self"],["formatter"]],["result"]]],[11,"clone","","",403,[[["self"]],["firststatementindex"]]],[11,"eq","","",403,[[["self"],["firststatementindex"]],["bool"]]],[11,"ne","","",403,[[["self"],["firststatementindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",403,N],[11,"hash","","",403,N],[11,"partial_cmp","","",403,[[["self"],["firststatementindex"]],["option",["ordering"]]]],[11,"lt","","",403,[[["self"],["firststatementindex"]],["bool"]]],[11,"le","","",403,[[["self"],["firststatementindex"]],["bool"]]],[11,"gt","","",403,[[["self"],["firststatementindex"]],["bool"]]],[11,"ge","","",403,[[["self"],["firststatementindex"]],["bool"]]],[11,"cmp","","",403,[[["self"],["firststatementindex"]],["ordering"]]],[11,"decode","","",403,[[["__d"]],["result",["firststatementindex"]]]],[11,"encode","","",403,[[["self"],["__s"]],["result"]]],[11,"new","","",403,[[["usize"]],["self"]]],[11,"index","","",403,[[["self"]],["usize"]]],[11,"steps_between","","",403,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",403,[[["self"]],["self"]]],[11,"replace_zero","","",403,[[["self"]],["self"]]],[11,"add_one","","",403,[[["self"]],["self"]]],[11,"sub_one","","",403,[[["self"]],["self"]]],[11,"add_usize","","",403,[[["self"],["usize"]],["option"]]],[11,"fmt","","",403,[[["self"],["formatter"]],["result"]]],[11,"from","","",401,[[["scopedata"]],["self"]]],[11,"fmt","","",401,[[["self"],["formatter"]],["result"]]],[11,"data","","",401,[[["self"]],["scopedata"]]],[11,"Node","","",401,[[["itemlocalid"]],["self"]]],[11,"CallSite","","",401,[[["itemlocalid"]],["self"]]],[11,"Arguments","","",401,[[["itemlocalid"]],["self"]]],[11,"Destruction","","",401,[[["itemlocalid"]],["self"]]],[11,"Remainder","","",401,[[["blockremainder"]],["self"]]],[11,"item_local_id","","Returns a item-local id associated with this scope.",401,[[["self"]],["itemlocalid"]]],[11,"node_id","","",401,[[["self"],["tyctxt"],["scopetree"]],["nodeid"]]],[11,"span","","Returns the span of this Scope.  Note that in general the returned span may not correspond to the span of any node id in the AST.",401,[[["self"],["tyctxt"],["scopetree"]],["span"]]],[11,"default","","",404,[[],["scopetree"]]],[11,"fmt","","",404,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",405,[[["self"],["formatter"]],["result"]]],[11,"clone","","",405,[[["self"]],["context"]]],[11,"nested_visit_map","","",407,[[["self"]],["nestedvisitormap"]]],[11,"visit_pat","","",407,[[["self"],["pat"]]]],[11,"visit_expr","","",407,[[["self"],["expr"]]]],[11,"record_scope_parent","","",404,[[["self"],["scope"],["option"]]]],[11,"each_encl_scope","","",404,[[["self"],["e"]]]],[11,"each_var_scope","","",404,[[["self"],["e"]]]],[11,"opt_destruction_scope","","",404,[[["self"],["itemlocalid"]],["option",["scope"]]]],[11,"record_closure_parent","","Records that `sub_closure` is defined within `sup_closure`. These ids should be the id of the block that is the fn body, which is also the root of the region hierarchy for that fn.",404,[[["self"],["itemlocalid"],["itemlocalid"]]]],[11,"record_var_scope","","",404,[[["self"],["itemlocalid"],["scope"]]]],[11,"record_rvalue_scope","","",404,[[["self"],["itemlocalid"],["option",["scope"]]]]],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",404,[[["self"],["scope"]],["option",["scope"]]]],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",404,[[["self"],["scope"]],["scope"]]],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",404,[[["self"],["itemlocalid"]],["scope"]]],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",404,[[["self"],["itemlocalid"]],["option",["scope"]]]],[11,"var_region","","Returns the lifetime of the variable `id`.",404,[[["self"],["itemlocalid"]],["regionkind"]]],[11,"scopes_intersect","","",404,[[["self"],["scope"],["scope"]],["bool"]]],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false otherwise.",404,[[["self"],["scope"],["scope"]],["bool"]]],[11,"containing_body","","Returns the id of the innermost containing body",404,[[["self"],["scope"]],["option",["itemlocalid"]]]],[11,"nearest_common_ancestor","","Finds the nearest common ancestor of two scopes.  That is, finds the smallest scope which is greater than or equal to both `scope_a` and `scope_b`.",404,[[["self"],["scope"],["scope"]],["scope"]]],[11,"early_free_scope","","Assuming that the provided region was defined within this `ScopeTree`, returns the outermost `Scope` that the region outlives.",404,[[["self"],["tyctxt"],["earlyboundregion"]],["scope"]]],[11,"free_scope","","Assuming that the provided region was defined within this `ScopeTree`, returns the outermost `Scope` that the region outlives.",404,[[["self"],["tyctxt"],["freeregion"]],["scope"]]],[11,"yield_in_scope","","Checks whether the given scope contains a `yield`. If so, returns `Some((span, expr_count))` with the span of a yield we found and the number of expressions and patterns appearing before the `yield` in the body + 1. If there a are multiple yields in a scope, the one with the highest number is returned.",404,[[["self"],["scope"]],["option"]]],[11,"yield_in_scope_for_expr","","Checks whether the given scope contains a `yield` and if that yield could execute after `expr`. If so, it returns the span of that `yield`. `scope` must be inside the body.",404,[[["self"],["scope"],["hirid"],["body"]],["option",["span"]]]],[11,"body_expr_count","","Gives the number of expressions visited in a body. Used to sanity check visit_expr call count when calculating generator interiors.",404,[[["self"],["bodyid"]],["option",["usize"]]]],[11,"record_child_scope","","Records the current parent (if any) as the parent of `child_scope`. Returns the depth of `child_scope`.",406,[[["self"],["scope"]],["scopedepth"]]],[11,"enter_scope","","Records the current parent (if any) as the parent of `child_scope`, and sets `child_scope` as the new current parent.",406,[[["self"],["scope"]]]],[11,"enter_node_scope_with_dtor","","",406,[[["self"],["itemlocalid"]]]],[11,"nested_visit_map","","",406,[[["self"]],["nestedvisitormap"]]],[11,"visit_block","","",406,[[["self"],["block"]]]],[11,"visit_body","","",406,[[["self"],["body"]]]],[11,"visit_arm","","",406,[[["self"],["arm"]]]],[11,"visit_pat","","",406,[[["self"],["pat"]]]],[11,"visit_stmt","","",406,[[["self"],["stmt"]]]],[11,"visit_expr","","",406,[[["self"],["expr"]]]],[11,"visit_local","","",406,[[["self"],["local"]]]],[11,"hash_stable","","",404,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"recursion_limit","rustc::middle","",N,N],[5,"update_limits","rustc::middle::recursion_limit","",N,[[["session"],["crate"]]]],[5,"update_limit","","",N,[[["session"],["crate"],["once"],["str"],["str"],["usize"]]]],[0,"resolve_lifetime","rustc::middle","Name resolution for lifetimes.",N,N],[3,"NamedRegionMap","rustc::middle::resolve_lifetime","Maps the id of each lifetime reference to the lifetime decl that it corresponds to.",N,N],[12,"defs","","",409,N],[12,"late_bound","","",409,N],[12,"object_lifetime_defaults","","",409,N],[3,"ResolveLifetimes","","See `NamedRegionMap`.",N,N],[12,"defs","","",410,N],[12,"late_bound","","",410,N],[12,"object_lifetime_defaults","","",410,N],[3,"LifetimeContext","","",N,N],[12,"tcx","","",411,N],[12,"map","","",411,N],[12,"scope","","",411,N],[12,"trait_ref_hack","","Deep breath. Our representation for poly trait refs contains a single binder and thus we only allow a single level of quantification. However, the syntax of Rust permits quantification in two places, e.g., `T: for <'a> Foo<'a>` and `for <'a, 'b> &'b T: Foo<'a>`. In order to get the de Bruijn indices correct when representing these constraints, we should only introduce one scope. However, we want to support both locations for the quantifier and during lifetime resolution we want precise information (so we can't desugar in an earlier phase).",411,N],[12,"is_in_fn_syntax","","Used to disallow the use of in-band lifetimes in `fn` or `Fn` syntax.",411,N],[12,"labels_in_fn","","List of labels in the function/method currently under analysis.",411,N],[12,"xcrate_object_lifetime_defaults","","Cache for cross-crate per-definition object lifetime defaults.",411,N],[12,"lifetime_uses","","",411,N],[3,"ElisionFailureInfo","","",N,N],[12,"parent","","Where we can find the argument pattern.",412,N],[12,"index","","The index of the argument in the original definition.",412,N],[12,"lifetime_count","","",412,N],[12,"have_bound_regions","","",412,N],[3,"Original","","",N,N],[12,"kind","","",413,N],[12,"span","","",413,N],[3,"Shadower","","",N,N],[12,"kind","","",414,N],[12,"span","","",414,N],[4,"LifetimeDefOrigin","","The origin of a named lifetime definition.",N,N],[13,"Explicit","","",415,N],[13,"InBand","","",415,N],[4,"LifetimeUseSet","","",N,N],[13,"One","","",416,N],[13,"Many","","",416,N],[4,"Region","","",N,N],[13,"Static","","",417,N],[13,"EarlyBound","","",417,N],[13,"LateBound","","",417,N],[13,"LateBoundAnon","","",417,N],[13,"Free","","",417,N],[4,"Set1","","A set containing, at most, one known element. If two distinct values are inserted into a set, then it becomes `Many`, which can be used to detect ambiguities.",N,N],[13,"Empty","","",418,N],[13,"One","","",418,N],[13,"Many","","",418,N],[4,"Scope","","",N,N],[13,"Binder","","Declares lifetimes, and each can be early-bound or late-bound. The `DebruijnIndex` of late-bound lifetimes starts at `1` and it should be shifted by the number of `Binder`s in between the declaration `Binder` and the location it's referenced from.",419,N],[12,"lifetimes","rustc::middle::resolve_lifetime::Scope","",419,N],[12,"next_early_index","","if we extend this scope with another scope, what is the next index we should use for an early-bound region?",419,N],[12,"track_lifetime_uses","","Flag is set to true if, in this binder, `'_` would be equivalent to a \"single-use region\". This is true on impls, but not other kinds of items.",419,N],[12,"abstract_type_parent","","Whether or not this binder would serve as the parent binder for abstract types introduced within. For example:",419,N],[12,"s","","",419,N],[13,"Body","rustc::middle::resolve_lifetime","Lifetimes introduced by a fn are scoped to the call-site for that fn, if this is a fn body, otherwise the original definitions are used. Unspecified lifetimes are inferred, unless an elision scope is nested, e.g. `(&T, fn(&T) -> &T);` becomes `(&'_ T, for<'a> fn(&'a T) -> &'a T)`.",419,N],[12,"id","rustc::middle::resolve_lifetime::Scope","",419,N],[12,"s","","",419,N],[13,"Elision","rustc::middle::resolve_lifetime","A scope which either determines unspecified lifetimes or errors on them (e.g. due to ambiguity). For more details, see `Elide`.",419,N],[12,"elide","rustc::middle::resolve_lifetime::Scope","",419,N],[12,"s","","",419,N],[13,"ObjectLifetimeDefault","rustc::middle::resolve_lifetime","Use a specific lifetime (if `Some`) or leave it unset (to be inferred in a function body or potentially error outside one), for the default choice of lifetime in a trait object type.",419,N],[12,"lifetime","rustc::middle::resolve_lifetime::Scope","",419,N],[12,"s","","",419,N],[13,"Root","rustc::middle::resolve_lifetime","",419,N],[4,"Elide","","",N,N],[13,"FreshLateAnon","","Use a fresh anonymous late-bound lifetime each time, by incrementing the counter to generate sequential indices.",420,N],[13,"Exact","","Always use this one lifetime.",420,N],[13,"Error","","Less or more than one lifetime were found, error on unspecified.",420,N],[4,"ShadowKind","","",N,N],[13,"Label","","",421,N],[13,"Lifetime","","",421,N],[5,"provide","","",N,[[["providers"]]]],[5,"resolve_lifetimes","","Computes the `ResolveLifetimes` map that contains data for the entire crate. You should not read the result of this query directly, but rather use `named_region_map`, `is_late_bound_map`, etc.",N,[[["tyctxt"],["cratenum"]],["lrc",["resolvelifetimes"]]]],[5,"krate","","",N,[[["tyctxt"]],["namedregionmap"]]],[5,"original_label","","",N,[[["span"]],["original"]]],[5,"shadower_label","","",N,[[["span"]],["shadower"]]],[5,"original_lifetime","","",N,[[["span"]],["original"]]],[5,"shadower_lifetime","","",N,[[["genericparam"]],["shadower"]]],[5,"check_mixed_explicit_and_in_band_defs","","",N,[[["tyctxt"],["p"]]]],[5,"signal_shadowing_problem","","",N,[[["tyctxt"],["name"],["original"],["shadower"]]]],[5,"extract_labels","","",N,[[["lifetimecontext"],["body"]]]],[5,"compute_object_lifetime_defaults","","",N,[[["tyctxt"]],["nodemap",["vec"]]]],[5,"object_lifetime_defaults_for_item","","Scan the bounds and where-clauses on parameters to extract bounds of the form `T:'a` so as to determine the `ObjectLifetimeDefault` for each type parameter.",N,[[["tyctxt"],["generics"]],["vec",["objectlifetimedefault"]]]],[5,"insert_late_bound_lifetimes","","Detects late-bound lifetimes and inserts them into `map.late_bound`.",N,[[["namedregionmap"],["fndecl"],["generics"]]]],[5,"report_missing_lifetime_specifiers","","",N,[[["session"],["span"],["usize"]],["diagnosticbuilder"]]],[6,"ObjectLifetimeDefault","","",N,N],[6,"ScopeRef","","",N,N],[17,"ROOT_SCOPE","","",N,N],[11,"clone","","",415,[[["self"]],["lifetimedeforigin"]]],[11,"eq","","",415,[[["self"],["lifetimedeforigin"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",415,N],[11,"hash","","",415,N],[11,"encode","","",415,[[["self"],["__s"]],["result"]]],[11,"decode","","",415,[[["__d"]],["result",["lifetimedeforigin"]]]],[11,"fmt","","",415,[[["self"],["formatter"]],["result"]]],[11,"from_param","","",415,[[["genericparam"]],["self"]]],[11,"clone","","",416,[[["self"]],["lifetimeuseset"]]],[11,"fmt","","",416,[[["self"],["formatter"]],["result"]]],[11,"clone","","",417,[[["self"]],["region"]]],[11,"eq","","",417,[[["self"],["region"]],["bool"]]],[11,"ne","","",417,[[["self"],["region"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",417,N],[11,"hash","","",417,N],[11,"encode","","",417,[[["self"],["__s"]],["result"]]],[11,"decode","","",417,[[["__d"]],["result",["region"]]]],[11,"fmt","","",417,[[["self"],["formatter"]],["result"]]],[11,"early","","",417,N],[11,"late","","",417,N],[11,"late_anon","","",417,[[["cell"]],["region"]]],[11,"id","","",417,[[["self"]],["option",["defid"]]]],[11,"shifted","","",417,[[["self"],["u32"]],["region"]]],[11,"shifted_out_to_binder","","",417,[[["self"],["debruijnindex"]],["region"]]],[11,"subst","","",417,[[["self"],["l"],["namedregionmap"]],["option",["region"]]]],[11,"clone","","",418,[[["self"]],["set1"]]],[11,"eq","","",418,[[["self"],["set1"]],["bool"]]],[11,"ne","","",418,[[["self"],["set1"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",418,N],[11,"encode","","",418,[[["self"],["__st"]],["result"]]],[11,"decode","","",418,[[["__dt"]],["result",["set1"]]]],[11,"fmt","","",418,[[["self"],["formatter"]],["result"]]],[11,"insert","","",418,[[["self"],["t"]]]],[11,"default","","",409,[[],["namedregionmap"]]],[11,"hash_stable","","",410,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"fmt","","",419,[[["self"],["formatter"]],["result"]]],[11,"clone","","",420,[[["self"]],["elide"]]],[11,"fmt","","",420,[[["self"],["formatter"]],["result"]]],[11,"clone","","",412,[[["self"]],["elisionfailureinfo"]]],[11,"fmt","","",412,[[["self"],["formatter"]],["result"]]],[11,"nested_visit_map","","",411,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_item","","",411,[[["self"],["itemid"]]]],[11,"visit_nested_body","","",411,[[["self"],["bodyid"]]]],[11,"visit_item","","",411,[[["self"],["item"]]]],[11,"visit_foreign_item","","",411,[[["self"],["foreignitem"]]]],[11,"visit_ty","","",411,[[["self"],["ty"]]]],[11,"visit_trait_item","","",411,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",411,[[["self"],["implitem"]]]],[11,"visit_lifetime","","",411,[[["self"],["lifetime"]]]],[11,"visit_path","","",411,[[["self"],["path"],["nodeid"]]]],[11,"visit_fn_decl","","",411,[[["self"],["fndecl"]]]],[11,"visit_generics","","",411,[[["self"],["generics"]]]],[11,"visit_poly_trait_ref","","",411,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"clone","","",421,[[["self"]],["shadowkind"]]],[11,"eq","","",421,[[["self"],["shadowkind"]],["bool"]]],[11,"desc","","",421,[[["self"]],["str"]]],[11,"hack","","",411,[[["self"],["f"]]]],[11,"with","","",411,[[["self"],["scope"],["f"]]]],[11,"check_uses_for_lifetimes_defined_by_scope","","",411,[[["self"]]]],[11,"visit_early_late","","Visits self by adding a scope and handling recursive walk over the contents with `walk`.",411,[[["self"],["option",["nodeid"]],["fndecl"],["generics"],["f"]]]],[11,"next_early_index_helper","","",411,[[["self"],["bool"]],["u32"]]],[11,"next_early_index","","Returns the next index one would use for an early-bound-region if extending the current scope.",411,[[["self"]],["u32"]]],[11,"next_early_index_for_abstract_type","","Returns the next index one would use for an `impl Trait` that is being converted into an `abstract type`. This will be the next early index from the enclosing item, for the most part. See the `abstract_type_parent` field for more info.",411,[[["self"]],["u32"]]],[11,"resolve_lifetime_ref","","",411,[[["self"],["lifetime"]]]],[11,"visit_segment_args","","",411,[[["self"],["def"],["usize"],["genericargs"]]]],[11,"visit_fn_like_elision","","",411,N],[11,"resolve_elided_lifetimes","","",411,[[["self"],["vec",["lifetime"]]]]],[11,"report_elision_failure","","",411,N],[11,"resolve_object_lifetime_default","","",411,[[["self"],["lifetime"]]]],[11,"check_lifetime_params","","",411,N],[11,"check_lifetime_param_for_shadowing","","",411,[[["self"],["scope"],["genericparam"]]]],[11,"track_lifetime_uses","","Returns true if, in the current scope, replacing `'_` would be equivalent to a single-use lifetime.",411,[[["self"]],["bool"]]],[11,"insert_lifetime","","",411,[[["self"],["lifetime"],["region"]]]],[11,"uninsert_lifetime_on_error","","Sometimes we resolve a lifetime, but later find that it is an error (esp. around impl trait). In that case, we remove the entry into `map.defs` so as not to confuse later code.",411,[[["self"],["lifetime"],["region"]]]],[0,"stability","rustc::middle","A pass that annotates every item and method with its stability level, propagating default levels lexically from parent to children ast nodes.",N,N],[3,"DeprecationEntry","rustc::middle::stability","An entry in the `depr_map`.",N,N],[12,"attr","","The metadata of the attribute associated with this entry.",422,N],[12,"origin","","The def id where the attr was originally attached. `None` for non-local `DefId`'s.",422,N],[3,"Index","","A stability index, giving the stability level for items and methods.",N,N],[12,"stab_map","","This is mostly a cache, except the stabilities of local items are filled by the annotator.",423,N],[12,"depr_map","","",423,N],[12,"staged_api","","Maps for each crate whether it is part of the staged API.",423,N],[12,"active_features","","Features enabled for this crate.",423,N],[3,"Annotator","","",N,N],[12,"tcx","","",424,N],[12,"index","","",424,N],[12,"parent_stab","","",424,N],[12,"parent_depr","","",424,N],[12,"in_trait_impl","","",424,N],[3,"MissingStabilityAnnotations","","",N,N],[12,"tcx","","",425,N],[12,"access_levels","","",425,N],[3,"Checker","","",N,N],[12,"tcx","","",426,N],[4,"StabilityLevel","","",N,N],[13,"Unstable","","",427,N],[13,"Stable","","",427,N],[4,"AnnotationKind","","",N,N],[13,"Required","","",428,N],[13,"Prohibited","","",428,N],[13,"Container","","",428,N],[4,"EvalResult","","Result of `TyCtxt::eval_stability`.",N,N],[13,"Allow","","We can use the item because it is stable or we provided the corresponding feature gate.",429,N],[13,"Deny","","We cannot use the item because it is unstable and we did not provide the corresponding feature gate.",429,N],[12,"feature","rustc::middle::stability::EvalResult","",429,N],[12,"reason","","",429,N],[12,"issue","","",429,N],[13,"Unmarked","rustc::middle::stability","The item does not have the `#[stable]` or `#[unstable]` marker assigned.",429,N],[5,"check_unstable_api_usage","","Cross-references the feature names of unstable APIs with enabled features and possibly prints errors.",N,[[["tyctxt"]]]],[5,"deprecation_in_effect","","Check whether an item marked with `deprecated(since=\"X\")` is currently deprecated (i.e. whether X is not greater than the current rustc version).",N,[[["str"]],["bool"]]],[5,"check_unused_or_stable_features","","Given the list of enabled features that were not language features (i.e. that were expected to be library features), and the list of features used from libraries, identify activated features that don't exist and error about them.",N,[[["tyctxt"]]]],[5,"format_stable_since_msg","","",N,[[["str"]],["string"]]],[11,"encode","","",427,[[["self"],["__s"]],["result"]]],[11,"decode","","",427,[[["__d"]],["result",["stabilitylevel"]]]],[11,"eq","","",427,[[["self"],["stabilitylevel"]],["bool"]]],[11,"partial_cmp","","",427,[[["self"],["stabilitylevel"]],["option",["ordering"]]]],[11,"clone","","",427,[[["self"]],["stabilitylevel"]]],[11,"fmt","","",427,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",427,N],[11,"hash","","",427,N],[11,"from_attr_level","","",427,[[["stabilitylevel"]],["self"]]],[11,"eq","","",428,[[["self"],["annotationkind"]],["bool"]]],[11,"clone","","",422,[[["self"]],["deprecationentry"]]],[11,"hash_stable","","",422,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"local","","",422,[[["deprecation"],["hirid"]],["deprecationentry"]]],[11,"external","","",422,[[["deprecation"]],["deprecationentry"]]],[11,"same_origin","","",422,[[["self"],["deprecationentry"]],["bool"]]],[11,"hash_stable","","",423,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"annotate","","",424,N],[11,"nested_visit_map","","Because stability levels are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",424,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",424,[[["self"],["item"]]]],[11,"visit_trait_item","","",424,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",424,[[["self"],["implitem"]]]],[11,"visit_variant","","",424,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",424,[[["self"],["structfield"]]]],[11,"visit_foreign_item","","",424,[[["self"],["foreignitem"]]]],[11,"visit_macro_def","","",424,[[["self"],["macrodef"]]]],[11,"check_missing_stability","","",425,[[["self"],["nodeid"],["span"]]]],[11,"nested_visit_map","","",425,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",425,[[["self"],["item"]]]],[11,"visit_trait_item","","",425,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",425,[[["self"],["implitem"]]]],[11,"visit_variant","","",425,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",425,[[["self"],["structfield"]]]],[11,"visit_foreign_item","","",425,[[["self"],["foreignitem"]]]],[11,"visit_macro_def","","",425,[[["self"],["macrodef"]]]],[11,"new","","",423,[[["tyctxt"]],["index"]]],[11,"local_stability","","",423,[[["self"],["hirid"]],["option",["stability"]]]],[11,"local_deprecation_entry","","",423,[[["self"],["hirid"]],["option",["deprecationentry"]]]],[11,"nested_visit_map","","Because stability levels are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",426,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",426,[[["self"],["item"]]]],[11,"visit_path","","",426,[[["self"],["path"],["nodeid"]]]],[0,"weak_lang_items","rustc::middle","Validity checking for weak lang items",N,N],[3,"Context","rustc::middle::weak_lang_items","",N,N],[12,"tcx","","",430,N],[12,"items","","",430,N],[5,"check_crate","","Checks the crate for usage of weak lang items, returning a vector of all the language items required by this crate, but not defined yet.",N,[[["tyctxt"],["languageitems"]]]],[5,"link_name","","",N,N],[5,"whitelisted","","Returns whether the specified `lang_item` doesn't actually need to be present for this compilation.",N,[[["tyctxt"],["langitem"]],["bool"]]],[5,"verify","","",N,[[["tyctxt"],["languageitems"]]]],[11,"register","","",430,[[["self"],["str"],["span"]]]],[11,"nested_visit_map","","",430,[[["self"]],["nestedvisitormap"]]],[11,"visit_foreign_item","","",430,[[["self"],["foreignitem"]]]],[0,"mir","rustc","MIR datatypes and passes. See the [rustc guide] for more info.",N,N],[3,"Mir","rustc::mir","Lowered representation of a single function.",N,N],[12,"basic_blocks","","List of basic blocks. References to basic block use a newtyped index type `BasicBlock` that indexes into this vector.",431,N],[12,"source_scopes","","List of source scopes; these are referenced by statements and used for debuginfo. Indexed by a `SourceScope`.",431,N],[12,"source_scope_local_data","","Crate-local information for each source scope, that can't (and needn't) be tracked across crates.",431,N],[12,"promoted","","Rvalues promoted from this function, such as borrows of constants. Each of them is the Mir of a constant with the fn's type parameters in scope, but a separate set of locals.",431,N],[12,"yield_ty","","Yield type of the function, if it is a generator.",431,N],[12,"generator_drop","","Generator drop glue",431,N],[12,"generator_layout","","The layout of a generator. Produced by the state transformation.",431,N],[12,"local_decls","","Declarations of locals.",431,N],[12,"arg_count","","Number of arguments this function takes.",431,N],[12,"upvar_decls","","Names and capture modes of all the closure upvars, assuming the first argument is either the closure or a reference to it.",431,N],[12,"spread_arg","","Mark an argument local (which must be a tuple) as getting passed as its individual components at the LLVM level.",431,N],[12,"span","","A span representing this MIR, for error reporting",431,N],[12,"cache","","A cache for various calculations",431,N],[3,"SourceInfo","","Grouped information about the source code origin of a MIR entity. Intended to be inspected by diagnostics and debuginfo. Most passes can work with it as a whole, within a single function.",N,N],[12,"span","","Source span for the AST pertaining to this MIR entity.",432,N],[12,"scope","","The source scope, keeping track of which bindings can be seen by debuginfo, active lint levels, `unsafe {...}`, etc.",432,N],[3,"Local","","",N,N],[12,"0","","",433,N],[3,"VarBindingForm","","",N,N],[12,"binding_mode","","Is variable bound via `x`, `mut x`, `ref x`, or `ref mut x`?",434,N],[12,"opt_ty_info","","If an explicit type was provided for this variable binding, this holds the source Span of that type.",434,N],[12,"opt_match_place","","Place of the RHS of the =, or the subject of the `match` where this variable is initialized. None in the case of `let PATTERN;`. Some((None, ..)) in the case of and `let [mut] x = ...` because (a) the right-hand side isn't evaluated as a place expression. (b) it gives a way to separate this case from the remaining cases     for diagnostics.",434,N],[3,"LocalDecl","","A MIR local.",N,N],[12,"mutability","","`let mut x` vs `let x`.",435,N],[12,"is_user_variable","","Some(binding_mode) if this corresponds to a user-declared local variable.",435,N],[12,"internal","","True if this is an internal local",435,N],[12,"ty","","Type of this local.",435,N],[12,"name","","Name of the local, used in debuginfo and pretty-printing.",435,N],[12,"source_info","","The syntactic (i.e. not visibility) source scope the local is defined in. If the local was defined in a let-statement, this is within the let-statement, rather than outside of it.",435,N],[12,"visibility_scope","","Source scope within which the local is visible (for debuginfo) (see `source_info` for more details).",435,N],[3,"UpvarDecl","","A closure capture, with its name and mode.",N,N],[12,"debug_name","","",436,N],[12,"var_hir_id","","`HirId` of the captured variable",436,N],[12,"by_ref","","If true, the capture is behind a reference.",436,N],[12,"mutability","","",436,N],[3,"BasicBlock","","",N,N],[12,"0","","",437,N],[3,"BasicBlockData","","",N,N],[12,"statements","","List of statements in this block.",438,N],[12,"terminator","","Terminator for this block.",438,N],[12,"is_cleanup","","If true, this block lies on an unwind path. This is used during codegen where distinct kinds of basic blocks may be generated (particularly for MSVC cleanup). Unwind blocks must only branch to other unwind blocks.",438,N],[3,"Terminator","","",N,N],[12,"source_info","","",439,N],[12,"kind","","",439,N],[3,"Statement","","",N,N],[12,"source_info","","",440,N],[12,"kind","","",440,N],[3,"ValidationOperand","","",N,N],[12,"place","","",441,N],[12,"ty","","",441,N],[12,"re","","",441,N],[12,"mutbl","","",441,N],[3,"Static","","The def-id of a static, along with its normalized type (which is stored to avoid requiring normalization when reading MIR).",N,N],[12,"def_id","","",442,N],[12,"ty","","",442,N],[3,"Projection","","The `Projection` data structure defines things of the form `B.x` or `*B` or `B[index]`. Note that it is parameterized because it is shared between `Constant` and `Place`. See the aliases `PlaceProjection` etc below.",N,N],[12,"base","","",443,N],[12,"elem","","",443,N],[3,"Field","","",N,N],[12,"0","","",444,N],[3,"SourceScope","","",N,N],[12,"0","","",445,N],[3,"SourceScopeData","","",N,N],[12,"span","","",446,N],[12,"parent_scope","","",446,N],[3,"SourceScopeLocalData","","",N,N],[12,"lint_root","","A NodeId with lint levels equivalent to this scope's lint levels.",447,N],[12,"safety","","The unsafe block that contains this node.",447,N],[3,"Constant","","Constants",N,N],[12,"span","","",448,N],[12,"ty","","",448,N],[12,"literal","","",448,N],[3,"Promoted","","",N,N],[12,"0","","",449,N],[3,"Location","","",N,N],[12,"block","","the location is within this block",450,N],[12,"statement_index","","the location is the start of the statement; or, if `statement_index` == num-statements, then the start of the terminator.",450,N],[3,"UnsafetyViolation","","",N,N],[12,"source_info","","",451,N],[12,"description","","",451,N],[12,"details","","",451,N],[12,"kind","","",451,N],[3,"UnsafetyCheckResult","","",N,N],[12,"violations","","Violations that are propagated upwards from this function",452,N],[12,"unsafe_blocks","","unsafe blocks in this function, along with whether they are used. This is used for the \"unused_unsafe\" lint.",452,N],[3,"GeneratorLayout","","The layout of generator state",N,N],[12,"fields","","",453,N],[3,"BorrowCheckResult","","",N,N],[12,"closure_requirements","","",454,N],[12,"used_mut_upvars","","",454,N],[3,"ClosureRegionRequirements","","After we borrow check a closure, we are left with various requirements that we have inferred between the free regions that appear in the closure's signature or on its field types.  These requirements are then verified and proved by the closure's creating function. This struct encodes those requirements.",N,N],[12,"num_external_vids","","The number of external regions defined on the closure.  In our example above, it would be 3 -- one for `'static`, then `'1` and `'2`. This is just used for a sanity check later on, to make sure that the number of regions we see at the callsite matches.",455,N],[12,"outlives_requirements","","Requirements between the various free regions defined in indices.",455,N],[3,"ClosureOutlivesRequirement","","Indicates an outlives constraint between a type or between two free-regions declared on the closure.",N,N],[12,"subject","","",456,N],[12,"outlived_free_region","","",456,N],[12,"blame_span","","",456,N],[4,"Safety","","",N,N],[13,"Safe","","",457,N],[13,"BuiltinUnsafe","","Unsafe because of a PushUnsafeBlock",457,N],[13,"FnUnsafe","","Unsafe because of an unsafe fn",457,N],[13,"ExplicitUnsafe","","Unsafe because of an `unsafe` block",457,N],[4,"ClearCrossCrate","","",N,N],[13,"Clear","","",458,N],[13,"Set","","",458,N],[4,"Mutability","","",N,N],[13,"Mut","","",459,N],[13,"Not","","",459,N],[4,"BorrowKind","","",N,N],[13,"Shared","","Data must be immutable and is aliasable.",460,N],[13,"Unique","","Data must be immutable but not aliasable.  This kind of borrow cannot currently be expressed by the user and is used only in implicit closure bindings. It is needed when you the closure is borrowing or mutating a mutable referent, e.g.:",460,N],[13,"Mut","","Data is mutable and not aliasable.",460,N],[12,"allow_two_phase_borrow","rustc::mir::BorrowKind","True if this borrow arose from method-call auto-ref (i.e. `adjustment::Adjust::Borrow`)",460,N],[4,"LocalKind","rustc::mir","Classifies locals into categories. See `Mir::local_kind`.",N,N],[13,"Var","","User-declared variable binding",461,N],[13,"Temp","","Compiler-introduced temporary",461,N],[13,"Arg","","Function argument",461,N],[13,"ReturnPointer","","Location of function's return value",461,N],[4,"BindingForm","","",N,N],[13,"Var","","This is a binding for a non-`self` binding, or a `self` that has an explicit type.",462,N],[13,"ImplicitSelf","","Binding for a `self`/`&self`/`&mut self` binding where the type is implicit.",462,N],[13,"RefForGuard","","Reference used in a guard expression to ensure immutability.",462,N],[4,"TerminatorKind","","",N,N],[13,"Goto","","block should have one successor in the graph; we jump there",463,N],[12,"target","rustc::mir::TerminatorKind","",463,N],[13,"SwitchInt","rustc::mir","operand evaluates to an integer; jump depending on its value to one of the targets, and otherwise fallback to `otherwise`",463,N],[12,"discr","rustc::mir::TerminatorKind","discriminant value being tested",463,N],[12,"switch_ty","","type of value being tested",463,N],[12,"values","","Possible values. The locations to branch to in each case are found in the corresponding indices from the `targets` vector.",463,N],[12,"targets","","Possible branch sites. The last element of this vector is used for the otherwise branch, so targets.len() == values.len() + 1 should hold.",463,N],[13,"Resume","rustc::mir","Indicates that the landing pad is finished and unwinding should continue. Emitted by build::scope::diverge_cleanup.",463,N],[13,"Abort","","Indicates that the landing pad is finished and that the process should abort. Used to prevent unwinding for foreign items.",463,N],[13,"Return","","Indicates a normal return. The return place should have been filled in by now. This should occur at most once.",463,N],[13,"Unreachable","","Indicates a terminator that can never be reached.",463,N],[13,"Drop","","Drop the Place",463,N],[12,"location","rustc::mir::TerminatorKind","",463,N],[12,"target","","",463,N],[12,"unwind","","",463,N],[13,"DropAndReplace","rustc::mir","Drop the Place and assign the new value over it. This ensures that the assignment to `P` occurs even if the destructor for place unwinds. Its semantics are best explained by by the elaboration:",463,N],[12,"location","rustc::mir::TerminatorKind","",463,N],[12,"value","","",463,N],[12,"target","","",463,N],[12,"unwind","","",463,N],[13,"Call","rustc::mir","Block ends with a call of a converging function",463,N],[12,"func","rustc::mir::TerminatorKind","The function that’s being called",463,N],[12,"args","","Arguments the function is called with. These are owned by the callee, which is free to modify them. This allows the memory occupied by \"by-value\" arguments to be reused across function calls without duplicating the contents.",463,N],[12,"destination","","Destination for the return value. If some, the call is converging.",463,N],[12,"cleanup","","Cleanups to be done if the call unwinds.",463,N],[13,"Assert","rustc::mir","Jump to the target if the condition has the expected value, otherwise panic with a message and a cleanup target.",463,N],[12,"cond","rustc::mir::TerminatorKind","",463,N],[12,"expected","","",463,N],[12,"msg","","",463,N],[12,"target","","",463,N],[12,"cleanup","","",463,N],[13,"Yield","rustc::mir","A suspend point",463,N],[12,"value","rustc::mir::TerminatorKind","The value to return",463,N],[12,"resume","","Where to resume to",463,N],[12,"drop","","Cleanup to be done if the generator is dropped at this suspend point",463,N],[13,"GeneratorDrop","rustc::mir","Indicates the end of the dropping of a generator",463,N],[13,"FalseEdges","","A block where control flow only ever takes one real path, but borrowck needs to be more conservative.",463,N],[12,"real_target","rustc::mir::TerminatorKind","The target normal control flow will take",463,N],[12,"imaginary_targets","","The list of blocks control flow could conceptually take, but won't in practice",463,N],[13,"FalseUnwind","rustc::mir","A terminator for blocks that only take one path in reality, but where we reserve the right to unwind in borrowck, even if it won't happen in practice. This can arise in infinite loops with no function calls for example.",463,N],[12,"real_target","rustc::mir::TerminatorKind","The target normal control flow will take",463,N],[12,"unwind","","The imaginary cleanup block link. This particular path will never be taken in practice, but in order to avoid fragility we want to always consider it in borrowck. We don't want to accept programs which pass borrowck only when panic=abort or some assertions are disabled due to release vs. debug mode builds. This needs to be an Option because of the remove_noop_landing_pads and no_landing_pads passes",463,N],[4,"StatementKind","rustc::mir","",N,N],[13,"Assign","","Write the RHS Rvalue to the LHS Place.",464,N],[13,"ReadForMatch","","This represents all the reading that a pattern match may do (e.g. inspecting constants and discriminant values).",464,N],[13,"SetDiscriminant","","Write the discriminant for a variant to the enum Place.",464,N],[12,"place","rustc::mir::StatementKind","",464,N],[12,"variant_index","","",464,N],[13,"StorageLive","rustc::mir","Start a live range for the storage of the local.",464,N],[13,"StorageDead","","End the current live range for the storage of the local.",464,N],[13,"InlineAsm","","Execute a piece of inline Assembly.",464,N],[12,"asm","rustc::mir::StatementKind","",464,N],[12,"outputs","","",464,N],[12,"inputs","","",464,N],[13,"Validate","rustc::mir","Assert the given places to be valid inhabitants of their type.  These statements are currently only interpreted by miri and only generated when \"-Z mir-emit-validate\" is passed. See https://internals.rust-lang.org/t/types-as-contracts/5562/73 for more details.",464,N],[13,"EndRegion","","Mark one terminating point of a region scope (i.e. static region). (The starting point(s) arise implicitly from borrows.)",464,N],[13,"UserAssertTy","","Encodes a user's type assertion. These need to be preserved intact so that NLL can respect them. For example:",464,N],[13,"Nop","","No-op. Useful for deleting instructions without affecting statement indices.",464,N],[4,"ValidationOp","","The `ValidationOp` describes what happens with each of the operands of a `Validate` statement.",N,N],[13,"Acquire","","Recursively traverse the place following the type and validate that all type invariants are maintained.  Furthermore, acquire exclusive/read-only access to the memory reachable from the place.",465,N],[13,"Release","","Recursive traverse the mutable part of the type and relinquish all exclusive access.",465,N],[13,"Suspend","","Recursive traverse the mutable part of the type and relinquish all exclusive access until the given region ends.  Then, access will be recovered.",465,N],[4,"Place","","A path to a value; something that can be evaluated without changing or disturbing program state.",N,N],[13,"Local","","local variable",466,N],[13,"Static","","static or static mut variable",466,N],[13,"Promoted","","Constant code promoted to an injected static",466,N],[13,"Projection","","projection out of a place (access a field, deref a pointer, etc)",466,N],[4,"ProjectionElem","","",N,N],[13,"Deref","","",467,N],[13,"Field","","",467,N],[13,"Index","","",467,N],[13,"ConstantIndex","","These indices are generated by slice patterns. Easiest to explain by example:",467,N],[12,"offset","rustc::mir::ProjectionElem","index or -index (in Python terms), depending on from_end",467,N],[12,"min_length","","thing being indexed must be at least this long",467,N],[12,"from_end","","counting backwards from end?",467,N],[13,"Subslice","rustc::mir","These indices are generated by slice patterns.",467,N],[12,"from","rustc::mir::ProjectionElem","",467,N],[12,"to","","",467,N],[13,"Downcast","rustc::mir","\"Downcast\" to a variant of an ADT. Currently, we only introduce this for ADTs with more than one variant. It may be better to just introduce it always, or always for enums.",467,N],[4,"Operand","","These are values that can appear inside an rvalue (or an index place). They are intentionally limited to prevent rvalues from being nested in one another.",N,N],[13,"Copy","","Copy: The value must be available for use afterwards.",468,N],[13,"Move","","Move: The value (including old borrows of it) will not be used again.",468,N],[13,"Constant","","",468,N],[4,"Rvalue","","Rvalues",N,N],[13,"Use","","x (either a move or copy, depending on type of x)",469,N],[13,"Repeat","","[x; 32]",469,N],[13,"Ref","","&x or &mut x",469,N],[13,"Len","","length of a [X] or [X;n] value",469,N],[13,"Cast","","",469,N],[13,"BinaryOp","","",469,N],[13,"CheckedBinaryOp","","",469,N],[13,"NullaryOp","","",469,N],[13,"UnaryOp","","",469,N],[13,"Discriminant","","Read the discriminant of an ADT.",469,N],[13,"Aggregate","","Create an aggregate value, like a tuple or struct.  This is only needed because we want to distinguish `dest = Foo { x: ..., y: ... }` from `dest.x = ...; dest.y = ...;` in the case that `Foo` has a destructor. These rvalues can be optimized away after type-checking and before lowering.",469,N],[4,"CastKind","","",N,N],[13,"Misc","","",470,N],[13,"ReifyFnPointer","","Convert unique, zero-sized type for a fn to fn()",470,N],[13,"ClosureFnPointer","","Convert non capturing closure to fn()",470,N],[13,"UnsafeFnPointer","","Convert safe fn() to unsafe fn()",470,N],[13,"Unsize","","\"Unsize\" -- convert a thin-or-fat pointer to a fat pointer. codegen must figure out the details once full monomorphization is known. For example, this could be used to cast from a `&[i32;N]` to a `&[i32]`, or a `Box<T>` to a `Box<Trait>` (presuming `T: Trait`).",470,N],[4,"AggregateKind","","",N,N],[13,"Array","","The type is of the element",471,N],[13,"Tuple","","",471,N],[13,"Adt","","The second field is the variant index. It's equal to 0 for struct and union expressions. The fourth field is active field number and is present only for union expressions -- e.g. for a union expression `SomeUnion { c: .. }`, the active field index would identity the field `c`",471,N],[13,"Closure","","",471,N],[13,"Generator","","",471,N],[4,"BinOp","","",N,N],[13,"Add","","The `+` operator (addition)",472,N],[13,"Sub","","The `-` operator (subtraction)",472,N],[13,"Mul","","The `*` operator (multiplication)",472,N],[13,"Div","","The `/` operator (division)",472,N],[13,"Rem","","The `%` operator (modulus)",472,N],[13,"BitXor","","The `^` operator (bitwise xor)",472,N],[13,"BitAnd","","The `&` operator (bitwise and)",472,N],[13,"BitOr","","The `|` operator (bitwise or)",472,N],[13,"Shl","","The `<<` operator (shift left)",472,N],[13,"Shr","","The `>>` operator (shift right)",472,N],[13,"Eq","","The `==` operator (equality)",472,N],[13,"Lt","","The `<` operator (less than)",472,N],[13,"Le","","The `<=` operator (less than or equal to)",472,N],[13,"Ne","","The `!=` operator (not equal to)",472,N],[13,"Ge","","The `>=` operator (greater than or equal to)",472,N],[13,"Gt","","The `>` operator (greater than)",472,N],[13,"Offset","","The `ptr.offset` operator",472,N],[4,"NullOp","","",N,N],[13,"SizeOf","","Return the size of a value of that type",473,N],[13,"Box","","Create a new uninitialized box for a value of that type",473,N],[4,"UnOp","","",N,N],[13,"Not","","The `!` operator for logical inversion",474,N],[13,"Neg","","The `-` operator for negation",474,N],[4,"UnsafetyViolationKind","","",N,N],[13,"General","","",475,N],[13,"ExternStatic","","",475,N],[13,"BorrowPacked","","",475,N],[4,"ClosureOutlivesSubject","","The subject of a ClosureOutlivesRequirement -- that is, the thing that must outlive some region.",N,N],[13,"Ty","","Subject is a type, typically a type parameter, but could also be a projection. Indicates a requirement like `T: 'a` being passed to the caller, where the type here is `T`.",476,N],[13,"Region","","Subject is a free region from the closure. Indicates a requirement like `'a: 'b` being passed to the caller; the region here is `'a`.",476,N],[5,"fmt_const_val","","Write a `ConstValue` in a way closer to the original source code than the `Debug` output.",N,[[["w"],["const"]],["result"]]],[5,"print_miri_value","","",N,[[["value"],["ty"],["w"]],["result"]]],[5,"item_path_str","","",N,[[["defid"]],["string"]]],[0,"cache","","",N,N],[3,"Cache","rustc::mir::cache","",N,N],[12,"predecessors","","",477,N],[5,"calculate_predecessors","","",N,[[["mir"]],["indexvec",["basicblock","vec"]]]],[11,"clone","","",477,[[["self"]],["cache"]]],[11,"fmt","","",477,[[["self"],["formatter"]],["result"]]],[11,"encode","","",477,[[["self"],["s"]],["result"]]],[11,"decode","","",477,[[["d"]],["result"]]],[11,"hash_stable","","",477,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",477,[[],["self"]]],[11,"invalidate","","",477,[[["self"]]]],[11,"predecessors","","",477,[[["self"],["mir"]],["readguard",["indexvec"]]]],[11,"super_fold_with","","",477,[[["self"],["f"]],["cache"]]],[11,"super_visit_with","","",477,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",477,[[["self"],["tyctxt"]],["option"]]],[0,"interpret","rustc::mir","An interpreter for MIR used in CTFE and by miri",N,N],[3,"EvalError","rustc::mir::interpret","",N,N],[12,"kind","","",478,N],[3,"ConstEvalErr","","",N,N],[12,"span","","",479,N],[12,"error","","",479,N],[12,"stacktrace","","",479,N],[3,"FrameInfo","","",N,N],[12,"span","","",480,N],[12,"location","","",480,N],[12,"lint_root","","",480,N],[3,"DynamicLifetime","","",N,N],[12,"frame","","",481,N],[12,"region","","",481,N],[3,"GlobalId","","Uniquely identifies a specific constant or static.",N,N],[12,"instance","","For a constant or static, the `Instance` of the item itself. For a promoted global, the `Instance` of the function they belong to.",482,N],[12,"promoted","","The index for promoted globals within their function's `Mir`.",482,N],[3,"Pointer","","",N,N],[12,"alloc_id","","",483,N],[12,"offset","","",483,N],[3,"AllocId","","",N,N],[12,"0","","",484,N],[3,"AllocDecodingState","","",N,N],[12,"decoding_state","","",485,N],[12,"data_offsets","","",485,N],[3,"AllocDecodingSession","","",N,N],[12,"state","","",486,N],[12,"session_id","","",486,N],[3,"AllocMap","","",N,N],[12,"id_to_type","","Lets you know what an AllocId refers to",487,N],[12,"type_interner","","Used to ensure that functions and statics only get one associated AllocId",487,N],[12,"next_id","","The AllocId to assign to the next requested id. Always incremented, never gets smaller.",487,N],[3,"Allocation","","",N,N],[12,"bytes","","The actual bytes of the allocation. Note that the bytes of a pointer represent the offset of the pointer",488,N],[12,"relocations","","Maps from byte addresses to allocations. Only the first byte of a pointer is inserted into the map.",488,N],[12,"undef_mask","","Denotes undefined memory. Reading from undefined memory is forbidden in miri",488,N],[12,"align","","The alignment of the allocation to detect unaligned reads.",488,N],[12,"runtime_mutability","","Whether the allocation (of a static) should be put into mutable memory when codegenning",488,N],[3,"Relocations","","",N,N],[12,"0","","",489,N],[3,"UndefMask","","",N,N],[12,"blocks","","",490,N],[12,"len","","",490,N],[4,"EvalErrorKind","","",N,N],[13,"MachineError","","This variant is used by machines to signal their own errors that do not match an existing variant",491,N],[13,"FunctionPointerTyMismatch","","",491,N],[13,"NoMirFor","","",491,N],[13,"UnterminatedCString","","",491,N],[13,"DanglingPointerDeref","","",491,N],[13,"DoubleFree","","",491,N],[13,"InvalidMemoryAccess","","",491,N],[13,"InvalidFunctionPointer","","",491,N],[13,"InvalidBool","","",491,N],[13,"InvalidDiscriminant","","",491,N],[13,"PointerOutOfBounds","","",491,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",491,N],[12,"access","","",491,N],[12,"allocation_size","","",491,N],[13,"InvalidNullPointerUsage","rustc::mir::interpret","",491,N],[13,"ReadPointerAsBytes","","",491,N],[13,"ReadBytesAsPointer","","",491,N],[13,"ReadForeignStatic","","",491,N],[13,"InvalidPointerMath","","",491,N],[13,"ReadUndefBytes","","",491,N],[13,"DeadLocal","","",491,N],[13,"InvalidBoolOp","","",491,N],[13,"Unimplemented","","",491,N],[13,"DerefFunctionPointer","","",491,N],[13,"ExecuteMemory","","",491,N],[13,"BoundsCheck","","",491,N],[12,"len","rustc::mir::interpret::EvalErrorKind","",491,N],[12,"index","","",491,N],[13,"Overflow","rustc::mir::interpret","",491,N],[13,"OverflowNeg","","",491,N],[13,"DivisionByZero","","",491,N],[13,"RemainderByZero","","",491,N],[13,"Intrinsic","","",491,N],[13,"InvalidChar","","",491,N],[13,"StackFrameLimitReached","","",491,N],[13,"OutOfTls","","",491,N],[13,"TlsOutOfBounds","","",491,N],[13,"AbiViolation","","",491,N],[13,"AlignmentCheckFailed","","",491,N],[12,"required","rustc::mir::interpret::EvalErrorKind","",491,N],[12,"has","","",491,N],[13,"MemoryLockViolation","rustc::mir::interpret","",491,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",491,N],[12,"len","","",491,N],[12,"frame","","",491,N],[12,"access","","",491,N],[12,"lock","","",491,N],[13,"MemoryAcquireConflict","rustc::mir::interpret","",491,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",491,N],[12,"len","","",491,N],[12,"kind","","",491,N],[12,"lock","","",491,N],[13,"InvalidMemoryLockRelease","rustc::mir::interpret","",491,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",491,N],[12,"len","","",491,N],[12,"frame","","",491,N],[12,"lock","","",491,N],[13,"DeallocatedLockedMemory","rustc::mir::interpret","",491,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",491,N],[12,"lock","","",491,N],[13,"ValidationFailure","rustc::mir::interpret","",491,N],[13,"CalledClosureAsFunction","","",491,N],[13,"VtableForArgumentlessMethod","","",491,N],[13,"ModifiedConstantMemory","","",491,N],[13,"AssumptionNotHeld","","",491,N],[13,"InlineAsm","","",491,N],[13,"TypeNotPrimitive","","",491,N],[13,"ReallocatedWrongMemoryKind","","",491,N],[13,"DeallocatedWrongMemoryKind","","",491,N],[13,"ReallocateNonBasePtr","","",491,N],[13,"DeallocateNonBasePtr","","",491,N],[13,"IncorrectAllocationInformation","","",491,N],[13,"Layout","","",491,N],[13,"HeapAllocZeroBytes","","",491,N],[13,"HeapAllocNonPowerOfTwoAlignment","","",491,N],[13,"Unreachable","","",491,N],[13,"Panic","","",491,N],[13,"ReadFromReturnPointer","","",491,N],[13,"PathNotFound","","",491,N],[13,"UnimplementedTraitSelection","","",491,N],[13,"TypeckError","","Abort in case type errors are reached",491,N],[13,"TooGeneric","","Resolution can fail if we are in a too generic context",491,N],[13,"CheckMatchError","","",491,N],[13,"ReferencedConstant","","Cannot compute this constant because it depends on another one which already produced an error",491,N],[13,"GeneratorResumedAfterReturn","","",491,N],[13,"GeneratorResumedAfterPanic","","",491,N],[13,"InfiniteLoop","","",491,N],[4,"Scalar","","A `Scalar` represents an immediate, primitive value existing outside of a `memory::Allocation`. It is in many ways like a small chunk of a `Allocation`, up to 8 bytes in size. Like a range of bytes in an `Allocation`, a `Scalar` can either represent the raw bytes of a simple value or a pointer into another `Allocation`",N,N],[13,"Bits","","The raw bytes of a simple value.",492,N],[12,"defined","rustc::mir::interpret::Scalar","The first `defined` number of bits are valid",492,N],[12,"bits","","",492,N],[13,"Ptr","rustc::mir::interpret","A pointer into an `Allocation`. An `Allocation` in the `memory` module has a list of relocations, but a `Scalar` is only large enough to contain one, so we just represent the relocation and its associated offset together as a `Pointer` here.",492,N],[4,"Value","","A `Value` represents a single self-contained Rust value.",N,N],[13,"ByRef","","",493,N],[13,"Scalar","","",493,N],[13,"ScalarPair","","",493,N],[4,"ConstValue","","Represents a constant value in Rust. Scalar and ScalarPair are optimizations which matches Value's optimizations for easy conversions between these two types",N,N],[13,"Unevaluated","","Never returned from the `const_eval` query, but the HIR contains these frequently in order to allow HIR creation to happen for everything before needing to be able to run constant evaluation",494,N],[13,"Scalar","","Used only for types with layout::abi::Scalar ABI and ZSTs which use Scalar::undef()",494,N],[13,"ScalarPair","","Used only for types with layout::abi::ScalarPair",494,N],[13,"ByRef","","Used only for the remaining cases. An allocation + offset into the allocation",494,N],[4,"Lock","","",N,N],[13,"NoLock","","",495,N],[13,"WriteLock","","",495,N],[13,"ReadLock","","This should never be empty -- that would be a read lock held and nobody there to release it...",495,N],[4,"AccessKind","","",N,N],[13,"Read","","",496,N],[13,"Write","","",496,N],[4,"AllocKind","","",N,N],[13,"Alloc","","",497,N],[13,"Fn","","",497,N],[13,"Static","","",497,N],[4,"State","","",N,N],[13,"Empty","","",498,N],[13,"InProgressNonAlloc","","",498,N],[13,"InProgress","","",498,N],[13,"Done","","",498,N],[4,"AllocType","","",N,N],[13,"Function","","The alloc id is used as a function pointer",499,N],[13,"Static","","The alloc id points to a static variable",499,N],[13,"Memory","","The alloc id points to memory",499,N],[5,"struct_error","","",N,[[["tyctxtat"],["str"]],["diagnosticbuilder"]]],[5,"specialized_encode_alloc_id","","",N,[[["e"],["tyctxt"],["allocid"]],["result"]]],[5,"write_target_uint","","",N,N],[5,"write_target_int","","",N,N],[5,"read_target_uint","","",N,N],[5,"bit_index","","",N,N],[0,"error","","",N,N],[3,"ConstEvalErr","rustc::mir::interpret::error","",N,N],[12,"span","","",479,N],[12,"error","","",479,N],[12,"stacktrace","","",479,N],[3,"FrameInfo","","",N,N],[12,"span","","",480,N],[12,"location","","",480,N],[12,"lint_root","","",480,N],[3,"EvalError","","",N,N],[12,"kind","","",478,N],[4,"EvalErrorKind","","",N,N],[13,"MachineError","","This variant is used by machines to signal their own errors that do not match an existing variant",491,N],[13,"FunctionPointerTyMismatch","","",491,N],[13,"NoMirFor","","",491,N],[13,"UnterminatedCString","","",491,N],[13,"DanglingPointerDeref","","",491,N],[13,"DoubleFree","","",491,N],[13,"InvalidMemoryAccess","","",491,N],[13,"InvalidFunctionPointer","","",491,N],[13,"InvalidBool","","",491,N],[13,"InvalidDiscriminant","","",491,N],[13,"PointerOutOfBounds","","",491,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",491,N],[12,"access","","",491,N],[12,"allocation_size","","",491,N],[13,"InvalidNullPointerUsage","rustc::mir::interpret::error","",491,N],[13,"ReadPointerAsBytes","","",491,N],[13,"ReadBytesAsPointer","","",491,N],[13,"ReadForeignStatic","","",491,N],[13,"InvalidPointerMath","","",491,N],[13,"ReadUndefBytes","","",491,N],[13,"DeadLocal","","",491,N],[13,"InvalidBoolOp","","",491,N],[13,"Unimplemented","","",491,N],[13,"DerefFunctionPointer","","",491,N],[13,"ExecuteMemory","","",491,N],[13,"BoundsCheck","","",491,N],[12,"len","rustc::mir::interpret::error::EvalErrorKind","",491,N],[12,"index","","",491,N],[13,"Overflow","rustc::mir::interpret::error","",491,N],[13,"OverflowNeg","","",491,N],[13,"DivisionByZero","","",491,N],[13,"RemainderByZero","","",491,N],[13,"Intrinsic","","",491,N],[13,"InvalidChar","","",491,N],[13,"StackFrameLimitReached","","",491,N],[13,"OutOfTls","","",491,N],[13,"TlsOutOfBounds","","",491,N],[13,"AbiViolation","","",491,N],[13,"AlignmentCheckFailed","","",491,N],[12,"required","rustc::mir::interpret::error::EvalErrorKind","",491,N],[12,"has","","",491,N],[13,"MemoryLockViolation","rustc::mir::interpret::error","",491,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",491,N],[12,"len","","",491,N],[12,"frame","","",491,N],[12,"access","","",491,N],[12,"lock","","",491,N],[13,"MemoryAcquireConflict","rustc::mir::interpret::error","",491,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",491,N],[12,"len","","",491,N],[12,"kind","","",491,N],[12,"lock","","",491,N],[13,"InvalidMemoryLockRelease","rustc::mir::interpret::error","",491,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",491,N],[12,"len","","",491,N],[12,"frame","","",491,N],[12,"lock","","",491,N],[13,"DeallocatedLockedMemory","rustc::mir::interpret::error","",491,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",491,N],[12,"lock","","",491,N],[13,"ValidationFailure","rustc::mir::interpret::error","",491,N],[13,"CalledClosureAsFunction","","",491,N],[13,"VtableForArgumentlessMethod","","",491,N],[13,"ModifiedConstantMemory","","",491,N],[13,"AssumptionNotHeld","","",491,N],[13,"InlineAsm","","",491,N],[13,"TypeNotPrimitive","","",491,N],[13,"ReallocatedWrongMemoryKind","","",491,N],[13,"DeallocatedWrongMemoryKind","","",491,N],[13,"ReallocateNonBasePtr","","",491,N],[13,"DeallocateNonBasePtr","","",491,N],[13,"IncorrectAllocationInformation","","",491,N],[13,"Layout","","",491,N],[13,"HeapAllocZeroBytes","","",491,N],[13,"HeapAllocNonPowerOfTwoAlignment","","",491,N],[13,"Unreachable","","",491,N],[13,"Panic","","",491,N],[13,"ReadFromReturnPointer","","",491,N],[13,"PathNotFound","","",491,N],[13,"UnimplementedTraitSelection","","",491,N],[13,"TypeckError","","Abort in case type errors are reached",491,N],[13,"TooGeneric","","Resolution can fail if we are in a too generic context",491,N],[13,"CheckMatchError","","",491,N],[13,"ReferencedConstant","","Cannot compute this constant because it depends on another one which already produced an error",491,N],[13,"GeneratorResumedAfterReturn","","",491,N],[13,"GeneratorResumedAfterPanic","","",491,N],[13,"InfiniteLoop","","",491,N],[5,"struct_error","","",N,[[["tyctxtat"],["str"]],["diagnosticbuilder"]]],[6,"ConstEvalResult","","",N,N],[6,"AssertMessage","","",N,N],[6,"EvalResult","","",N,N],[11,"clone","rustc::mir::interpret","",479,[[["self"]],["constevalerr"]]],[11,"fmt","","",479,[[["self"],["formatter"]],["result"]]],[11,"encode","","",479,[[["self"],["__s"]],["result"]]],[11,"decode","","",479,[[["__d"]],["result",["constevalerr"]]]],[11,"clone","","",480,[[["self"]],["frameinfo"]]],[11,"fmt","","",480,[[["self"],["formatter"]],["result"]]],[11,"encode","","",480,[[["self"],["__s"]],["result"]]],[11,"decode","","",480,[[["__d"]],["result",["frameinfo"]]]],[11,"struct_error","","",479,[[["self"],["tyctxtat"],["str"]],["option",["diagnosticbuilder"]]]],[11,"report_as_error","","",479,[[["self"],["tyctxtat"],["str"]]]],[11,"report_as_lint","","",479,[[["self"],["tyctxtat"],["str"],["nodeid"]]]],[11,"struct_generic","","",479,[[["self"],["tyctxtat"],["str"],["option",["nodeid"]]],["option",["diagnosticbuilder"]]]],[11,"fmt","","",478,[[["self"],["formatter"]],["result"]]],[11,"clone","","",478,[[["self"]],["evalerror"]]],[11,"encode","","",478,[[["self"],["__s"]],["result"]]],[11,"decode","","",478,[[["__d"]],["result",["evalerror"]]]],[11,"from","","",478,[[["evalerrorkind",["u64"]]],["self"]]],[11,"clone","","",491,[[["self"]],["evalerrorkind"]]],[11,"encode","","",491,[[["self"],["__so"]],["result"]]],[11,"decode","","",491,[[["__do"]],["result",["evalerrorkind"]]]],[11,"description","","",491,[[["self"]],["str"]]],[11,"fmt","","",478,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",491,[[["self"],["formatter"]],["result"]]],[0,"value","","",N,N],[4,"ConstValue","rustc::mir::interpret::value","Represents a constant value in Rust. Scalar and ScalarPair are optimizations which matches Value's optimizations for easy conversions between these two types",N,N],[13,"Unevaluated","","Never returned from the `const_eval` query, but the HIR contains these frequently in order to allow HIR creation to happen for everything before needing to be able to run constant evaluation",494,N],[13,"Scalar","","Used only for types with layout::abi::Scalar ABI and ZSTs which use Scalar::undef()",494,N],[13,"ScalarPair","","Used only for types with layout::abi::ScalarPair",494,N],[13,"ByRef","","Used only for the remaining cases. An allocation + offset into the allocation",494,N],[4,"Value","","A `Value` represents a single self-contained Rust value.",N,N],[13,"ByRef","","",493,N],[13,"Scalar","","",493,N],[13,"ScalarPair","","",493,N],[4,"Scalar","","A `Scalar` represents an immediate, primitive value existing outside of a `memory::Allocation`. It is in many ways like a small chunk of a `Allocation`, up to 8 bytes in size. Like a range of bytes in an `Allocation`, a `Scalar` can either represent the raw bytes of a simple value or a pointer into another `Allocation`",N,N],[13,"Bits","","The raw bytes of a simple value.",492,N],[12,"defined","rustc::mir::interpret::value::Scalar","The first `defined` number of bits are valid",492,N],[12,"bits","","",492,N],[13,"Ptr","rustc::mir::interpret::value","A pointer into an `Allocation`. An `Allocation` in the `memory` module has a list of relocations, but a `Scalar` is only large enough to contain one, so we just represent the relocation and its associated offset together as a `Pointer` here.",492,N],[11,"clone","rustc::mir::interpret","",494,[[["self"]],["constvalue"]]],[11,"fmt","","",494,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",494,N],[11,"eq","","",494,[[["self"],["constvalue"]],["bool"]]],[11,"ne","","",494,[[["self"],["constvalue"]],["bool"]]],[11,"partial_cmp","","",494,[[["self"],["constvalue"]],["option",["ordering"]]]],[11,"lt","","",494,[[["self"],["constvalue"]],["bool"]]],[11,"le","","",494,[[["self"],["constvalue"]],["bool"]]],[11,"gt","","",494,[[["self"],["constvalue"]],["bool"]]],[11,"ge","","",494,[[["self"],["constvalue"]],["bool"]]],[11,"cmp","","",494,[[["self"],["constvalue"]],["ordering"]]],[11,"encode","","",494,[[["self"],["__s"]],["result"]]],[11,"decode","","",494,[[["__d"]],["result",["constvalue"]]]],[11,"hash","","",494,N],[11,"from_byval_value","","",494,[[["value"]],["self"]]],[11,"to_byval_value","","",494,[[["self"]],["option",["value"]]]],[11,"from_scalar","","",494,[[["scalar"]],["self"]]],[11,"to_scalar","","",494,[[["self"]],["option",["scalar"]]]],[11,"to_bits","","",494,[[["self"],["size"]],["option",["u128"]]]],[11,"to_ptr","","",494,[[["self"]],["option",["pointer"]]]],[11,"clone","","",493,[[["self"]],["value"]]],[11,"fmt","","",493,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",493,N],[11,"eq","","",493,[[["self"],["value"]],["bool"]]],[11,"ne","","",493,[[["self"],["value"]],["bool"]]],[11,"cmp","","",493,[[["self"],["value"]],["ordering"]]],[11,"partial_cmp","","",493,[[["self"],["value"]],["option",["ordering"]]]],[11,"lt","","",493,[[["self"],["value"]],["bool"]]],[11,"le","","",493,[[["self"],["value"]],["bool"]]],[11,"gt","","",493,[[["self"],["value"]],["bool"]]],[11,"ge","","",493,[[["self"],["value"]],["bool"]]],[11,"encode","","",493,[[["self"],["__s"]],["result"]]],[11,"decode","","",493,[[["__d"]],["result",["value"]]]],[11,"hash","","",493,N],[11,"super_fold_with","","",493,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",493,[[["self"],["v"]],["bool"]]],[11,"ptr_null","","",492,[[["c"]],["self"]]],[11,"ptr_signed_offset","","",492,[[["self"],["i64"],["c"]],["evalresult"]]],[11,"ptr_offset","","",492,[[["self"],["size"],["c"]],["evalresult"]]],[11,"ptr_wrapping_signed_offset","","",492,[[["self"],["i64"],["c"]],["evalresult"]]],[11,"is_null_ptr","","",492,[[["self"],["c"]],["evalresult",["bool"]]]],[11,"to_value_with_len","","",492,[[["self"],["u64"],["c"]],["value"]]],[11,"to_value_with_vtable","","",492,[[["self"],["pointer"]],["value"]]],[11,"to_value","","",492,[[["self"]],["value"]]],[11,"from","","",492,[[["pointer"]],["self"]]],[11,"clone","","",492,[[["self"]],["scalar"]]],[11,"fmt","","",492,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",492,N],[11,"eq","","",492,[[["self"],["scalar"]],["bool"]]],[11,"ne","","",492,[[["self"],["scalar"]],["bool"]]],[11,"cmp","","",492,[[["self"],["scalar"]],["ordering"]]],[11,"partial_cmp","","",492,[[["self"],["scalar"]],["option",["ordering"]]]],[11,"lt","","",492,[[["self"],["scalar"]],["bool"]]],[11,"le","","",492,[[["self"],["scalar"]],["bool"]]],[11,"gt","","",492,[[["self"],["scalar"]],["bool"]]],[11,"ge","","",492,[[["self"],["scalar"]],["bool"]]],[11,"encode","","",492,[[["self"],["__s"]],["result"]]],[11,"decode","","",492,[[["__d"]],["result",["scalar"]]]],[11,"hash","","",492,N],[11,"undef","","",492,[[],["self"]]],[11,"from_bool","","",492,[[["bool"]],["self"]]],[11,"from_char","","",492,[[["char"]],["self"]]],[11,"to_bits","","",492,[[["self"],["size"]],["evalresult",["u128"]]]],[11,"to_ptr","","",492,[[["self"]],["evalresult",["pointer"]]]],[11,"is_bits","","",492,[[["self"]],["bool"]]],[11,"is_ptr","","",492,[[["self"]],["bool"]]],[11,"to_bool","","",492,[[["self"]],["evalresult",["bool"]]]],[6,"EvalResult","","",N,N],[6,"AssertMessage","","",N,N],[6,"ConstEvalResult","","",N,N],[6,"DecodingSessionId","","",N,N],[6,"Block","","",N,N],[17,"BLOCK_SIZE","","",N,N],[8,"PointerArithmetic","","",N,N],[11,"truncate_to_ptr","","",500,N],[11,"overflowing_signed_offset","","",500,N],[11,"overflowing_offset","","",500,N],[11,"signed_offset","","",500,[[["self"],["u64"],["i64"]],["evalresult",["u64"]]]],[11,"offset","","",500,[[["self"],["u64"],["u64"]],["evalresult",["u64"]]]],[11,"wrapping_signed_offset","","",500,[[["self"],["u64"],["i64"]],["u64"]]],[11,"clone","","",495,[[["self"]],["lock"]]],[11,"fmt","","",495,[[["self"],["formatter"]],["result"]]],[11,"eq","","",495,[[["self"],["lock"]],["bool"]]],[11,"ne","","",495,[[["self"],["lock"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",495,N],[11,"hash","","",495,N],[11,"encode","","",495,[[["self"],["__s"]],["result"]]],[11,"decode","","",495,[[["__d"]],["result",["lock"]]]],[11,"clone","","",481,[[["self"]],["dynamiclifetime"]]],[11,"fmt","","",481,[[["self"],["formatter"]],["result"]]],[11,"eq","","",481,[[["self"],["dynamiclifetime"]],["bool"]]],[11,"ne","","",481,[[["self"],["dynamiclifetime"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",481,N],[11,"hash","","",481,N],[11,"encode","","",481,[[["self"],["__s"]],["result"]]],[11,"decode","","",481,[[["__d"]],["result",["dynamiclifetime"]]]],[11,"clone","","",496,[[["self"]],["accesskind"]]],[11,"fmt","","",496,[[["self"],["formatter"]],["result"]]],[11,"eq","","",496,[[["self"],["accesskind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",496,N],[11,"encode","","",496,[[["self"],["__s"]],["result"]]],[11,"decode","","",496,[[["__d"]],["result",["accesskind"]]]],[11,"clone","","",482,[[["self"]],["globalid"]]],[11,"fmt","","",482,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",482,N],[11,"eq","","",482,[[["self"],["globalid"]],["bool"]]],[11,"ne","","",482,[[["self"],["globalid"]],["bool"]]],[11,"hash","","",482,N],[11,"encode","","",482,[[["self"],["__s"]],["result"]]],[11,"decode","","",482,[[["__d"]],["result",["globalid"]]]],[11,"clone","","",483,[[["self"]],["pointer"]]],[11,"fmt","","",483,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",483,N],[11,"eq","","",483,[[["self"],["pointer"]],["bool"]]],[11,"ne","","",483,[[["self"],["pointer"]],["bool"]]],[11,"cmp","","",483,[[["self"],["pointer"]],["ordering"]]],[11,"partial_cmp","","",483,[[["self"],["pointer"]],["option",["ordering"]]]],[11,"lt","","",483,[[["self"],["pointer"]],["bool"]]],[11,"le","","",483,[[["self"],["pointer"]],["bool"]]],[11,"gt","","",483,[[["self"],["pointer"]],["bool"]]],[11,"ge","","",483,[[["self"],["pointer"]],["bool"]]],[11,"encode","","",483,[[["self"],["__s"]],["result"]]],[11,"decode","","",483,[[["__d"]],["result",["pointer"]]]],[11,"hash","","",483,N],[11,"from","","",483,[[["allocid"]],["self"]]],[11,"new","","",483,[[["allocid"],["size"]],["self"]]],[11,"wrapping_signed_offset","","",483,[[["self"],["i64"],["c"]],["self"]]],[11,"overflowing_signed_offset","","",483,N],[11,"signed_offset","","",483,[[["self"],["i64"],["c"]],["evalresult"]]],[11,"overflowing_offset","","",483,N],[11,"offset","","",483,[[["self"],["size"],["c"]],["evalresult"]]],[11,"clone","","",484,[[["self"]],["allocid"]]],[11,"assert_receiver_is_total_eq","","",484,N],[11,"hash","","",484,N],[11,"cmp","","",484,[[["self"],["allocid"]],["ordering"]]],[11,"eq","","",484,[[["self"],["allocid"]],["bool"]]],[11,"ne","","",484,[[["self"],["allocid"]],["bool"]]],[11,"partial_cmp","","",484,[[["self"],["allocid"]],["option",["ordering"]]]],[11,"lt","","",484,[[["self"],["allocid"]],["bool"]]],[11,"le","","",484,[[["self"],["allocid"]],["bool"]]],[11,"gt","","",484,[[["self"],["allocid"]],["bool"]]],[11,"ge","","",484,[[["self"],["allocid"]],["bool"]]],[11,"fmt","","",484,[[["self"],["formatter"]],["result"]]],[11,"decode","","",497,[[["__d"]],["result",["allockind"]]]],[11,"encode","","",497,[[["self"],["__s"]],["result"]]],[11,"clone","","",498,[[["self"]],["state"]]],[11,"new_decoding_session","","",485,[[["self"]],["allocdecodingsession"]]],[11,"new","","",485,[[["vec",["u32"]]],["allocdecodingstate"]]],[11,"clone","","",486,[[["self"]],["allocdecodingsession"]]],[11,"decode_alloc_id","","",486,[[["self"],["d"]],["result",["allocid"]]]],[11,"fmt","","",484,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",499,[[["self"],["formatter"]],["result"]]],[11,"clone","","",499,[[["self"]],["alloctype"]]],[11,"assert_receiver_is_total_eq","","",499,N],[11,"eq","","",499,[[["self"],["alloctype"]],["bool"]]],[11,"ne","","",499,[[["self"],["alloctype"]],["bool"]]],[11,"hash","","",499,N],[11,"decode","","",499,[[["__dm"]],["result",["alloctype"]]]],[11,"encode","","",499,[[["self"],["__sm"]],["result"]]],[11,"new","","",487,[[],["self"]]],[11,"reserve","","obtains a new allocation ID that can be referenced but does not yet have an allocation backing it.",487,[[["self"]],["allocid"]]],[11,"intern","","",487,[[["self"],["alloctype"]],["allocid"]]],[11,"create_fn_alloc","","",487,[[["self"],["instance"]],["allocid"]]],[11,"get","","",487,[[["self"],["allocid"]],["option",["alloctype"]]]],[11,"unwrap_memory","","",487,[[["self"],["allocid"]],["m"]]],[11,"intern_static","","",487,[[["self"],["defid"]],["allocid"]]],[11,"allocate","","",487,[[["self"],["m"]],["allocid"]]],[11,"set_id_memory","","",487,[[["self"],["allocid"],["m"]]]],[11,"set_id_same_memory","","",487,[[["self"],["allocid"],["m"]]]],[11,"clone","","",488,[[["self"]],["allocation"]]],[11,"fmt","","",488,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",488,N],[11,"eq","","",488,[[["self"],["allocation"]],["bool"]]],[11,"ne","","",488,[[["self"],["allocation"]],["bool"]]],[11,"partial_cmp","","",488,[[["self"],["allocation"]],["option",["ordering"]]]],[11,"lt","","",488,[[["self"],["allocation"]],["bool"]]],[11,"le","","",488,[[["self"],["allocation"]],["bool"]]],[11,"gt","","",488,[[["self"],["allocation"]],["bool"]]],[11,"ge","","",488,[[["self"],["allocation"]],["bool"]]],[11,"cmp","","",488,[[["self"],["allocation"]],["ordering"]]],[11,"hash","","",488,N],[11,"encode","","",488,[[["self"],["__s"]],["result"]]],[11,"decode","","",488,[[["__d"]],["result",["allocation"]]]],[11,"from_bytes","","",488,N],[11,"from_byte_aligned_bytes","","",488,N],[11,"undef","","",488,[[["size"],["align"]],["self"]]],[11,"clone","","",489,[[["self"]],["relocations"]]],[11,"eq","","",489,[[["self"],["relocations"]],["bool"]]],[11,"ne","","",489,[[["self"],["relocations"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",489,N],[11,"partial_cmp","","",489,[[["self"],["relocations"]],["option",["ordering"]]]],[11,"lt","","",489,[[["self"],["relocations"]],["bool"]]],[11,"le","","",489,[[["self"],["relocations"]],["bool"]]],[11,"gt","","",489,[[["self"],["relocations"]],["bool"]]],[11,"ge","","",489,[[["self"],["relocations"]],["bool"]]],[11,"cmp","","",489,[[["self"],["relocations"]],["ordering"]]],[11,"hash","","",489,N],[11,"fmt","","",489,[[["self"],["formatter"]],["result"]]],[11,"encode","","",489,[[["self"],["__s"]],["result"]]],[11,"decode","","",489,[[["__d"]],["result",["relocations"]]]],[11,"new","","",489,[[],["relocations"]]],[11,"from_presorted","","",489,[[["vec"]],["relocations"]]],[11,"deref","","",489,N],[11,"deref_mut","","",489,N],[11,"clone","","",490,[[["self"]],["undefmask"]]],[11,"fmt","","",490,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",490,N],[11,"eq","","",490,[[["self"],["undefmask"]],["bool"]]],[11,"ne","","",490,[[["self"],["undefmask"]],["bool"]]],[11,"partial_cmp","","",490,[[["self"],["undefmask"]],["option",["ordering"]]]],[11,"lt","","",490,[[["self"],["undefmask"]],["bool"]]],[11,"le","","",490,[[["self"],["undefmask"]],["bool"]]],[11,"gt","","",490,[[["self"],["undefmask"]],["bool"]]],[11,"ge","","",490,[[["self"],["undefmask"]],["bool"]]],[11,"cmp","","",490,[[["self"],["undefmask"]],["ordering"]]],[11,"hash","","",490,N],[11,"encode","","",490,[[["self"],["__s"]],["result"]]],[11,"decode","","",490,[[["__d"]],["result",["undefmask"]]]],[11,"hash_stable","","",490,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",490,[[["size"]],["self"]]],[11,"is_range_defined","","Check whether the range `start..end` (end-exclusive) is entirely defined.",490,[[["self"],["size"],["size"]],["bool"]]],[11,"set_range","","",490,[[["self"],["size"],["size"],["bool"]]]],[11,"set_range_inbounds","","",490,[[["self"],["size"],["size"],["bool"]]]],[11,"get","","",490,[[["self"],["size"]],["bool"]]],[11,"set","","",490,[[["self"],["size"],["bool"]]]],[11,"grow","","",490,[[["self"],["size"],["bool"]]]],[0,"mono","rustc::mir","",N,N],[3,"CodegenUnit","rustc::mir::mono","",N,N],[12,"name","","A name for this CGU. Incremental compilation requires that name be unique amongst all crates.  Therefore, it should contain something unique to this crate (e.g., a module path) as well as the crate name and disambiguator.",501,N],[12,"items","","",501,N],[12,"size_estimate","","",501,N],[3,"Stats","","",N,N],[12,"n_glues_created","","",502,N],[12,"n_null_glues","","",502,N],[12,"n_real_glues","","",502,N],[12,"n_fns","","",502,N],[12,"n_inlines","","",502,N],[12,"n_closures","","",502,N],[12,"n_llvm_insns","","",502,N],[12,"llvm_insns","","",502,N],[12,"fn_stats","","",502,N],[4,"MonoItem","","",N,N],[13,"Fn","","",503,N],[13,"Static","","",503,N],[13,"GlobalAsm","","",503,N],[4,"Linkage","","",N,N],[13,"External","","",504,N],[13,"AvailableExternally","","",504,N],[13,"LinkOnceAny","","",504,N],[13,"LinkOnceODR","","",504,N],[13,"WeakAny","","",504,N],[13,"WeakODR","","",504,N],[13,"Appending","","",504,N],[13,"Internal","","",504,N],[13,"Private","","",504,N],[13,"ExternalWeak","","",504,N],[13,"Common","","",504,N],[4,"Visibility","","",N,N],[13,"Default","","",505,N],[13,"Hidden","","",505,N],[13,"Protected","","",505,N],[11,"eq","","",503,[[["self"],["monoitem"]],["bool"]]],[11,"ne","","",503,[[["self"],["monoitem"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",503,N],[11,"clone","","",503,[[["self"]],["monoitem"]]],[11,"fmt","","",503,[[["self"],["formatter"]],["result"]]],[11,"hash","","",503,N],[11,"size_estimate","","",503,[[["self"],["tyctxt"]],["usize"]]],[11,"hash_stable","","",503,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",504,[[["self"]],["linkage"]]],[11,"eq","","",504,[[["self"],["linkage"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",504,N],[11,"hash","","",504,N],[11,"fmt","","",504,[[["self"],["formatter"]],["result"]]],[11,"encode","","",504,[[["self"],["__s"]],["result"]]],[11,"decode","","",504,[[["__d"]],["result",["linkage"]]]],[11,"hash_stable","","",504,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",505,[[["self"]],["visibility"]]],[11,"eq","","",505,[[["self"],["visibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",505,N],[11,"hash","","",505,N],[11,"fmt","","",505,[[["self"],["formatter"]],["result"]]],[11,"hash_stable","","",505,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",501,[[["internedstring"]],["codegenunit"]]],[11,"name","","",501,[[["self"]],["internedstring"]]],[11,"set_name","","",501,[[["self"],["internedstring"]]]],[11,"items","","",501,[[["self"]],["fxhashmap"]]],[11,"items_mut","","",501,[[["self"]],["fxhashmap"]]],[11,"mangle_name","","",501,[[["str"]],["string"]]],[11,"estimate_size","","",501,[[["self"],["tyctxt"]]]],[11,"size_estimate","","",501,[[["self"]],["usize"]]],[11,"modify_size_estimate","","",501,[[["self"],["usize"]]]],[11,"hash_stable","","",501,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",502,[[["self"]],["stats"]]],[11,"default","","",502,[[],["stats"]]],[11,"hash_stable","","",502,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"extend","","",502,[[["self"],["stats"]]]],[0,"tcx","rustc::mir","Methods for the various MIR types. These are intended for use after building is complete.",N,N],[4,"PlaceTy","rustc::mir::tcx","",N,N],[13,"Ty","","Normal type.",506,N],[12,"ty","rustc::mir::tcx::PlaceTy","",506,N],[13,"Downcast","rustc::mir::tcx","Downcast to a particular variant of an enum.",506,N],[12,"adt_def","rustc::mir::tcx::PlaceTy","",506,N],[12,"substs","","",506,N],[12,"variant_index","","",506,N],[4,"RvalueInitializationState","rustc::mir::tcx","",N,N],[13,"Shallow","","",507,N],[13,"Deep","","",507,N],[11,"clone","","",506,[[["self"]],["placety"]]],[11,"fmt","","",506,[[["self"],["formatter"]],["result"]]],[11,"from_ty","","",506,[[["ty"]],["placety"]]],[11,"to_ty","","",506,[[["self"],["tyctxt"]],["ty"]]],[11,"projection_ty","","",506,[[["self"],["tyctxt"],["placeelem"]],["placety"]]],[11,"super_fold_with","","",506,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",506,[[["self"],["v"]],["bool"]]],[11,"ty","rustc::mir","",466,[[["self"],["d"],["tyctxt"]],["placety"]]],[11,"is_upvar_field_projection","","If this is a field projection, and the field is being projected from a closure type, then returns the index of the field being projected. Note that this closure will always be `self` in the current MIR, because that is the only time we directly access the fields of a closure type.",466,[[["self"],["mir"],["tyctxt"]],["option",["field"]]]],[11,"ty","","",469,[[["self"],["d"],["tyctxt"]],["ty"]]],[11,"initialization_state","","Returns whether this rvalue is deeply initialized (most rvalues) or whether its only shallowly initialized (`Rvalue::Box`).",469,[[["self"]],["rvalueinitializationstate"]]],[11,"ty","","",468,[[["self"],["d"],["tyctxt"]],["ty"]]],[11,"ty","","",472,[[["self"],["tyctxt"],["ty"],["ty"]],["ty"]]],[11,"to_mutbl_lossy","","",460,[[["self"]],["mutability"]]],[11,"to_hir_binop","","",472,[[["self"]],["binopkind"]]],[0,"traversal","","",N,N],[3,"Preorder","rustc::mir::traversal","Preorder traversal of a graph.",N,N],[12,"mir","","",508,N],[12,"visited","","",508,N],[12,"worklist","","",508,N],[3,"Postorder","","Postorder traversal of a graph.",N,N],[12,"mir","","",509,N],[12,"visited","","",509,N],[12,"visit_stack","","",509,N],[3,"ReversePostorder","","Reverse postorder traversal of a graph",N,N],[12,"mir","","",510,N],[12,"blocks","","",510,N],[12,"idx","","",510,N],[5,"preorder","","",N,[[["mir"]],["preorder"]]],[5,"postorder","","",N,[[["mir"]],["postorder"]]],[5,"reverse_postorder","","",N,[[["mir"]],["reversepostorder"]]],[11,"clone","","",508,[[["self"]],["preorder"]]],[11,"new","","",508,[[["mir"],["basicblock"]],["preorder"]]],[11,"next","","",508,[[["self"]],["option"]]],[11,"size_hint","","",508,N],[11,"new","","",509,[[["mir"],["basicblock"]],["postorder"]]],[11,"traverse_successor","","",509,[[["self"]]]],[11,"next","","",509,[[["self"]],["option"]]],[11,"size_hint","","",509,N],[11,"clone","","",510,[[["self"]],["reversepostorder"]]],[11,"new","","",510,[[["mir"],["basicblock"]],["reversepostorder"]]],[11,"reset","","",510,[[["self"]]]],[11,"next","","",510,[[["self"]],["option"]]],[11,"size_hint","","",510,N],[0,"visit","rustc::mir","",N,N],[4,"TyContext","rustc::mir::visit","Extra information passed to `visit_ty` and friends to give context about where the type etc appears.",N,N],[13,"LocalDecl","","",511,N],[12,"local","rustc::mir::visit::TyContext","The index of the local variable we are visiting.",511,N],[12,"source_info","","The source location where this local variable was declared.",511,N],[13,"ReturnTy","rustc::mir::visit","The return type of the function.",511,N],[13,"YieldTy","","",511,N],[13,"Location","","A type found at some location.",511,N],[4,"PlaceContext","","",N,N],[13,"Store","","",512,N],[13,"AsmOutput","","",512,N],[13,"Call","","",512,N],[13,"Drop","","",512,N],[13,"Inspect","","",512,N],[13,"Borrow","","",512,N],[12,"region","rustc::mir::visit::PlaceContext","",512,N],[12,"kind","","",512,N],[13,"Projection","rustc::mir::visit","",512,N],[13,"Copy","","",512,N],[13,"Move","","",512,N],[13,"StorageLive","","",512,N],[13,"StorageDead","","",512,N],[13,"Validate","","",512,N],[8,"Visitor","","",N,N],[11,"visit_mir","","",513,[[["self"],["mir"]]]],[11,"visit_basic_block_data","","",513,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_source_scope_data","","",513,[[["self"],["sourcescopedata"]]]],[11,"visit_statement","","",513,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_assign","","",513,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_terminator","","",513,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_terminator_kind","","",513,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_assert_message","","",513,[[["self"],["assertmessage"],["location"]]]],[11,"visit_rvalue","","",513,[[["self"],["rvalue"],["location"]]]],[11,"visit_operand","","",513,[[["self"],["operand"],["location"]]]],[11,"visit_user_assert_ty","","",513,[[["self"],["canonicalty"],["local"],["location"]]]],[11,"visit_place","","",513,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_static","","",513,[[["self"],["static"],["placecontext"],["location"]]]],[11,"visit_projection","","",513,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"visit_projection_elem","","",513,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"visit_branch","","",513,[[["self"],["basicblock"],["basicblock"]]]],[11,"visit_constant","","",513,[[["self"],["constant"],["location"]]]],[11,"visit_def_id","","",513,[[["self"],["defid"],["location"]]]],[11,"visit_span","","",513,[[["self"],["span"]]]],[11,"visit_source_info","","",513,[[["self"],["sourceinfo"]]]],[11,"visit_ty","","",513,[[["self"],["ty"],["tycontext"]]]],[11,"visit_region","","",513,[[["self"],["region"],["location"]]]],[11,"visit_const","","",513,[[["self"],["const"],["location"]]]],[11,"visit_substs","","",513,[[["self"],["substs"],["location"]]]],[11,"visit_closure_substs","","",513,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_generator_substs","","",513,[[["self"],["generatorsubsts"],["location"]]]],[11,"visit_local_decl","","",513,[[["self"],["local"],["localdecl"]]]],[11,"visit_local","","",513,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_source_scope","","",513,[[["self"],["sourcescope"]]]],[11,"super_mir","","",513,[[["self"],["mir"]]]],[11,"super_basic_block_data","","",513,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"super_source_scope_data","","",513,[[["self"],["sourcescopedata"]]]],[11,"super_statement","","",513,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"super_assign","","",513,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"super_terminator","","",513,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"super_terminator_kind","","",513,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"super_assert_message","","",513,[[["self"],["assertmessage"],["location"]]]],[11,"super_rvalue","","",513,[[["self"],["rvalue"],["location"]]]],[11,"super_operand","","",513,[[["self"],["operand"],["location"]]]],[11,"super_user_assert_ty","","",513,[[["self"],["canonicalty"],["local"],["location"]]]],[11,"super_place","","",513,[[["self"],["place"],["placecontext"],["location"]]]],[11,"super_static","","",513,[[["self"],["static"],["placecontext"],["location"]]]],[11,"super_projection","","",513,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"super_projection_elem","","",513,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"super_local_decl","","",513,[[["self"],["local"],["localdecl"]]]],[11,"super_source_scope","","",513,[[["self"],["sourcescope"]]]],[11,"super_branch","","",513,[[["self"],["basicblock"],["basicblock"]]]],[11,"super_constant","","",513,[[["self"],["constant"],["location"]]]],[11,"super_def_id","","",513,[[["self"],["defid"]]]],[11,"super_span","","",513,[[["self"],["span"]]]],[11,"super_source_info","","",513,[[["self"],["sourceinfo"]]]],[11,"super_ty","","",513,[[["self"],["ty"]]]],[11,"super_region","","",513,[[["self"],["region"]]]],[11,"super_const","","",513,[[["self"],["const"]]]],[11,"super_substs","","",513,[[["self"],["substs"]]]],[11,"super_generator_substs","","",513,[[["self"],["generatorsubsts"]]]],[11,"super_closure_substs","","",513,[[["self"],["closuresubsts"]]]],[11,"visit_location","","",513,[[["self"],["mir"],["location"]]]],[8,"MutVisitor","","",N,N],[11,"visit_mir","","",514,[[["self"],["mir"]]]],[11,"visit_basic_block_data","","",514,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_source_scope_data","","",514,[[["self"],["sourcescopedata"]]]],[11,"visit_statement","","",514,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_assign","","",514,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_terminator","","",514,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_terminator_kind","","",514,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_assert_message","","",514,[[["self"],["assertmessage"],["location"]]]],[11,"visit_rvalue","","",514,[[["self"],["rvalue"],["location"]]]],[11,"visit_operand","","",514,[[["self"],["operand"],["location"]]]],[11,"visit_user_assert_ty","","",514,[[["self"],["canonicalty"],["local"],["location"]]]],[11,"visit_place","","",514,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_static","","",514,[[["self"],["static"],["placecontext"],["location"]]]],[11,"visit_projection","","",514,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"visit_projection_elem","","",514,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"visit_branch","","",514,[[["self"],["basicblock"],["basicblock"]]]],[11,"visit_constant","","",514,[[["self"],["constant"],["location"]]]],[11,"visit_def_id","","",514,[[["self"],["defid"],["location"]]]],[11,"visit_span","","",514,[[["self"],["span"]]]],[11,"visit_source_info","","",514,[[["self"],["sourceinfo"]]]],[11,"visit_ty","","",514,[[["self"],["ty"],["tycontext"]]]],[11,"visit_region","","",514,[[["self"],["region"],["location"]]]],[11,"visit_const","","",514,[[["self"],["const"],["location"]]]],[11,"visit_substs","","",514,[[["self"],["substs"],["location"]]]],[11,"visit_closure_substs","","",514,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_generator_substs","","",514,[[["self"],["generatorsubsts"],["location"]]]],[11,"visit_local_decl","","",514,[[["self"],["local"],["localdecl"]]]],[11,"visit_local","","",514,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_source_scope","","",514,[[["self"],["sourcescope"]]]],[11,"super_mir","","",514,[[["self"],["mir"]]]],[11,"super_basic_block_data","","",514,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"super_source_scope_data","","",514,[[["self"],["sourcescopedata"]]]],[11,"super_statement","","",514,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"super_assign","","",514,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"super_terminator","","",514,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"super_terminator_kind","","",514,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"super_assert_message","","",514,[[["self"],["assertmessage"],["location"]]]],[11,"super_rvalue","","",514,[[["self"],["rvalue"],["location"]]]],[11,"super_operand","","",514,[[["self"],["operand"],["location"]]]],[11,"super_user_assert_ty","","",514,[[["self"],["canonicalty"],["local"],["location"]]]],[11,"super_place","","",514,[[["self"],["place"],["placecontext"],["location"]]]],[11,"super_static","","",514,[[["self"],["static"],["placecontext"],["location"]]]],[11,"super_projection","","",514,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"super_projection_elem","","",514,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"super_local_decl","","",514,[[["self"],["local"],["localdecl"]]]],[11,"super_source_scope","","",514,[[["self"],["sourcescope"]]]],[11,"super_branch","","",514,[[["self"],["basicblock"],["basicblock"]]]],[11,"super_constant","","",514,[[["self"],["constant"],["location"]]]],[11,"super_def_id","","",514,[[["self"],["defid"]]]],[11,"super_span","","",514,[[["self"],["span"]]]],[11,"super_source_info","","",514,[[["self"],["sourceinfo"]]]],[11,"super_ty","","",514,[[["self"],["ty"]]]],[11,"super_region","","",514,[[["self"],["region"]]]],[11,"super_const","","",514,[[["self"],["const"]]]],[11,"super_substs","","",514,[[["self"],["substs"]]]],[11,"super_generator_substs","","",514,[[["self"],["generatorsubsts"]]]],[11,"super_closure_substs","","",514,[[["self"],["closuresubsts"]]]],[11,"visit_location","","",514,[[["self"],["mir"],["location"]]]],[8,"MirVisitable","","",N,N],[10,"apply","","",515,[[["self"],["location"],["visitor"]]]],[11,"apply","rustc::mir","",440,[[["self"],["location"],["visitor"]]]],[11,"apply","","",439,[[["self"],["location"],["visitor"]]]],[11,"clone","rustc::mir::visit","",511,[[["self"]],["tycontext"]]],[11,"fmt","","",511,[[["self"],["formatter"]],["result"]]],[11,"eq","","",511,[[["self"],["tycontext"]],["bool"]]],[11,"ne","","",511,[[["self"],["tycontext"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",511,N],[11,"hash","","",511,N],[11,"clone","","",512,[[["self"]],["placecontext"]]],[11,"fmt","","",512,[[["self"],["formatter"]],["result"]]],[11,"eq","","",512,[[["self"],["placecontext"]],["bool"]]],[11,"ne","","",512,[[["self"],["placecontext"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",512,N],[11,"is_drop","","Returns true if this place context represents a drop.",512,[[["self"]],["bool"]]],[11,"is_storage_marker","","Returns true if this place context represents a storage live or storage dead marker.",512,[[["self"]],["bool"]]],[11,"is_storage_live_marker","","Returns true if this place context represents a storage live marker.",512,[[["self"]],["bool"]]],[11,"is_storage_dead_marker","","Returns true if this place context represents a storage dead marker.",512,[[["self"]],["bool"]]],[11,"is_mutating_use","","Returns true if this place context represents a use that potentially changes the value.",512,[[["self"]],["bool"]]],[11,"is_nonmutating_use","","Returns true if this place context represents a use that does not change the value.",512,[[["self"]],["bool"]]],[11,"is_use","","",512,[[["self"]],["bool"]]],[0,"binding_form_impl","rustc::mir","",N,N],[11,"hash_stable","","",462,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[6,"AssertMessage","","",N,N],[6,"LocalDecls","","Types for locals",N,N],[6,"Successors","","",N,N],[6,"SuccessorsMut","","",N,N],[6,"PlaceProjection","","Alias for projections as they appear in places, where the base is a place and the index is a local.",N,N],[6,"PlaceElem","","Alias for projections as they appear in places, where the base is a place and the index is a local.",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"START_BLOCK","","where execution begins",N,N],[17,"RETURN_PLACE","","",N,N],[17,"OUTERMOST_SOURCE_SCOPE","","",N,N],[8,"HasLocalDecls","","",N,N],[10,"local_decls","","",516,[[["self"]],["indexvec"]]],[11,"local_decls","","",431,[[["self"]],["indexvec"]]],[11,"clone","","",431,[[["self"]],["mir"]]],[11,"encode","","",431,[[["self"],["__s"]],["result"]]],[11,"decode","","",431,[[["__d"]],["result",["mir"]]]],[11,"fmt","","",431,[[["self"],["formatter"]],["result"]]],[11,"new","","",431,[[["indexvec",["basicblock","basicblockdata"]],["indexvec",["sourcescope","sourcescopedata"]],["clearcrosscrate",["indexvec"]],["indexvec",["promoted","mir"]],["option",["ty"]],["indexvec",["local","localdecl"]],["usize"],["vec",["upvardecl"]],["span"]],["self"]]],[11,"basic_blocks","","",431,[[["self"]],["indexvec"]]],[11,"basic_blocks_mut","","",431,[[["self"]],["indexvec"]]],[11,"basic_blocks_and_local_decls_mut","","",431,N],[11,"predecessors","","",431,[[["self"]],["readguard",["indexvec"]]]],[11,"predecessors_for","","",431,[[["self"],["basicblock"]],["readguard",["vec"]]]],[11,"dominators","","",431,[[["self"]],["dominators",["basicblock"]]]],[11,"local_kind","","",431,[[["self"],["local"]],["localkind"]]],[11,"temps_iter","","Returns an iterator over all temporaries.",431,[[["self"]],[""]]],[11,"vars_iter","","Returns an iterator over all user-declared locals.",431,[[["self"]],[""]]],[11,"mut_vars_and_args_iter","","Returns an iterator over all user-declared mutable arguments and locals.",431,[[["self"]],[""]]],[11,"args_iter","","Returns an iterator over all function arguments.",431,[[["self"]],[""]]],[11,"vars_and_temps_iter","","Returns an iterator over all user-defined variables and compiler-generated temporaries (all locals that are neither arguments nor the return place).",431,[[["self"]],[""]]],[11,"make_statement_nop","","Changes a statement to a nop. This is both faster than deleting instructions and avoids invalidating statement indices in `Location`s.",431,[[["self"],["location"]]]],[11,"source_info","","Returns the source info associated with `location`.",431,[[["self"],["location"]],["sourceinfo"]]],[11,"is_sub_scope","","Check if `sub` is a sub scope of `sup`",431,[[["self"],["sourcescope"],["sourcescope"]],["bool"]]],[11,"return_ty","","Return the return type, it always return first element from `local_decls` array",431,[[["self"]],["ty"]]],[11,"clone","","",457,[[["self"]],["safety"]]],[11,"fmt","","",457,[[["self"],["formatter"]],["result"]]],[11,"encode","","",457,[[["self"],["__s"]],["result"]]],[11,"decode","","",457,[[["__d"]],["result",["safety"]]]],[11,"hash_stable","","",431,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"index","","",431,[[["self"],["basicblock"]],["basicblockdata"]]],[11,"index_mut","","",431,[[["self"],["basicblock"]],["basicblockdata"]]],[11,"clone","","",458,[[["self"]],["clearcrosscrate"]]],[11,"fmt","","",458,[[["self"],["formatter"]],["result"]]],[11,"assert_crate_local","","",458,[[["self"]],["t"]]],[11,"clone","","",432,[[["self"]],["sourceinfo"]]],[11,"fmt","","",432,[[["self"],["formatter"]],["result"]]],[11,"eq","","",432,[[["self"],["sourceinfo"]],["bool"]]],[11,"ne","","",432,[[["self"],["sourceinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",432,N],[11,"encode","","",432,[[["self"],["__s"]],["result"]]],[11,"decode","","",432,[[["__d"]],["result",["sourceinfo"]]]],[11,"hash","","",432,N],[11,"clone","","",459,[[["self"]],["mutability"]]],[11,"fmt","","",459,[[["self"],["formatter"]],["result"]]],[11,"eq","","",459,[[["self"],["mutability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",459,N],[11,"encode","","",459,[[["self"],["__s"]],["result"]]],[11,"decode","","",459,[[["__d"]],["result",["mutability"]]]],[11,"from","rustc::hir","",103,[[["mutability"]],["self"]]],[11,"clone","rustc::mir","",460,[[["self"]],["borrowkind"]]],[11,"fmt","","",460,[[["self"],["formatter"]],["result"]]],[11,"eq","","",460,[[["self"],["borrowkind"]],["bool"]]],[11,"ne","","",460,[[["self"],["borrowkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",460,N],[11,"encode","","",460,[[["self"],["__s"]],["result"]]],[11,"decode","","",460,[[["__d"]],["result",["borrowkind"]]]],[11,"allows_two_phase_borrow","","",460,[[["self"]],["bool"]]],[11,"clone","","",433,[[["self"]],["local"]]],[11,"eq","","",433,[[["self"],["local"]],["bool"]]],[11,"ne","","",433,[[["self"],["local"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",433,N],[11,"hash","","",433,N],[11,"partial_cmp","","",433,[[["self"],["local"]],["option",["ordering"]]]],[11,"lt","","",433,[[["self"],["local"]],["bool"]]],[11,"le","","",433,[[["self"],["local"]],["bool"]]],[11,"gt","","",433,[[["self"],["local"]],["bool"]]],[11,"ge","","",433,[[["self"],["local"]],["bool"]]],[11,"cmp","","",433,[[["self"],["local"]],["ordering"]]],[11,"decode","","",433,[[["__d"]],["result",["local"]]]],[11,"encode","","",433,[[["self"],["__s"]],["result"]]],[11,"new","","",433,[[["usize"]],["self"]]],[11,"index","","",433,[[["self"]],["usize"]]],[11,"steps_between","","",433,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",433,[[["self"]],["self"]]],[11,"replace_zero","","",433,[[["self"]],["self"]]],[11,"add_one","","",433,[[["self"]],["self"]]],[11,"sub_one","","",433,[[["self"]],["self"]]],[11,"add_usize","","",433,[[["self"],["usize"]],["option"]]],[11,"fmt","","",433,[[["self"],["formatter"]],["result"]]],[11,"eq","","",461,[[["self"],["localkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",461,N],[11,"fmt","","",461,[[["self"],["formatter"]],["result"]]],[11,"clone","","",434,[[["self"]],["varbindingform"]]],[11,"eq","","",434,[[["self"],["varbindingform"]],["bool"]]],[11,"ne","","",434,[[["self"],["varbindingform"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",434,N],[11,"hash","","",434,N],[11,"fmt","","",434,[[["self"],["formatter"]],["result"]]],[11,"encode","","",434,[[["self"],["__s"]],["result"]]],[11,"decode","","",434,[[["__d"]],["result",["varbindingform"]]]],[11,"clone","","",462,[[["self"]],["bindingform"]]],[11,"eq","","",462,[[["self"],["bindingform"]],["bool"]]],[11,"ne","","",462,[[["self"],["bindingform"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",462,N],[11,"hash","","",462,N],[11,"fmt","","",462,[[["self"],["formatter"]],["result"]]],[11,"encode","","",462,[[["self"],["__s"]],["result"]]],[11,"decode","","",462,[[["__d"]],["result",["bindingform"]]]],[11,"super_fold_with","","",462,[[["self"],["f"]],["bindingform"]]],[11,"super_visit_with","","",462,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",462,[[["self"],["tyctxt"]],["option"]]],[11,"hash_stable","","",434,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",435,[[["self"]],["localdecl"]]],[11,"fmt","","",435,[[["self"],["formatter"]],["result"]]],[11,"encode","","",435,[[["self"],["__s"]],["result"]]],[11,"decode","","",435,[[["__d"]],["result",["localdecl"]]]],[11,"can_be_made_mutable","","Returns true only if local is a binding that can itself be made mutable via the addition of the `mut` keyword, namely something like the occurrences of `x` in: - `fn foo(x: Type) { ... }`, - `let x = ...`, - or `match ... { C(x) => ... }`",435,[[["self"]],["bool"]]],[11,"is_nonref_binding","","Returns true if local is definitely not a `ref ident` or `ref mut ident` binding. (Such bindings cannot be made into mutable bindings, but the inverse does not necessarily hold).",435,[[["self"]],["bool"]]],[11,"new_temp","","Create a new `LocalDecl` for a temporary.",435,[[["ty"],["span"]],["self"]]],[11,"new_internal","","Create a new `LocalDecl` for a internal temporary.",435,[[["ty"],["span"]],["self"]]],[11,"new_return_place","","Builds a `LocalDecl` for the return place.",435,[[["ty"],["span"]],["localdecl"]]],[11,"clone","","",436,[[["self"]],["upvardecl"]]],[11,"fmt","","",436,[[["self"],["formatter"]],["result"]]],[11,"encode","","",436,[[["self"],["__s"]],["result"]]],[11,"decode","","",436,[[["__d"]],["result",["upvardecl"]]]],[11,"clone","","",437,[[["self"]],["basicblock"]]],[11,"eq","","",437,[[["self"],["basicblock"]],["bool"]]],[11,"ne","","",437,[[["self"],["basicblock"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",437,N],[11,"hash","","",437,N],[11,"partial_cmp","","",437,[[["self"],["basicblock"]],["option",["ordering"]]]],[11,"lt","","",437,[[["self"],["basicblock"]],["bool"]]],[11,"le","","",437,[[["self"],["basicblock"]],["bool"]]],[11,"gt","","",437,[[["self"],["basicblock"]],["bool"]]],[11,"ge","","",437,[[["self"],["basicblock"]],["bool"]]],[11,"cmp","","",437,[[["self"],["basicblock"]],["ordering"]]],[11,"decode","","",437,[[["__d"]],["result",["basicblock"]]]],[11,"encode","","",437,[[["self"],["__s"]],["result"]]],[11,"new","","",437,[[["usize"]],["self"]]],[11,"index","","",437,[[["self"]],["usize"]]],[11,"steps_between","","",437,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",437,[[["self"]],["self"]]],[11,"replace_zero","","",437,[[["self"]],["self"]]],[11,"add_one","","",437,[[["self"]],["self"]]],[11,"sub_one","","",437,[[["self"]],["self"]]],[11,"add_usize","","",437,[[["self"],["usize"]],["option"]]],[11,"fmt","","",437,[[["self"],["formatter"]],["result"]]],[11,"start_location","","",437,[[["self"]],["location"]]],[11,"clone","","",438,[[["self"]],["basicblockdata"]]],[11,"fmt","","",438,[[["self"],["formatter"]],["result"]]],[11,"encode","","",438,[[["self"],["__s"]],["result"]]],[11,"decode","","",438,[[["__d"]],["result",["basicblockdata"]]]],[11,"clone","","",439,[[["self"]],["terminator"]]],[11,"fmt","","",439,[[["self"],["formatter"]],["result"]]],[11,"encode","","",439,[[["self"],["__s"]],["result"]]],[11,"decode","","",439,[[["__d"]],["result",["terminator"]]]],[11,"clone","","",463,[[["self"]],["terminatorkind"]]],[11,"encode","","",463,[[["self"],["__s"]],["result"]]],[11,"decode","","",463,[[["__d"]],["result",["terminatorkind"]]]],[11,"successors","","",439,[[["self"]],["successors"]]],[11,"successors_mut","","",439,[[["self"]],["successorsmut"]]],[11,"unwind","","",439,[[["self"]],["option",["option"]]]],[11,"unwind_mut","","",439,[[["self"]],["option",["option"]]]],[11,"if_","","",463,[[["tyctxt"],["operand"],["basicblock"],["basicblock"]],["terminatorkind"]]],[11,"successors","","",463,[[["self"]],["successors"]]],[11,"successors_mut","","",463,[[["self"]],["successorsmut"]]],[11,"unwind","","",463,[[["self"]],["option",["option"]]]],[11,"unwind_mut","","",463,[[["self"]],["option",["option"]]]],[11,"new","","",438,[[["option",["terminator"]]],["basicblockdata"]]],[11,"terminator","","Accessor for terminator.",438,[[["self"]],["terminator"]]],[11,"terminator_mut","","",438,[[["self"]],["terminator"]]],[11,"retain_statements","","",438,[[["self"],["f"]]]],[11,"expand_statements","","",438,[[["self"],["f"]]]],[11,"visitable","","",438,[[["self"],["usize"]],["mirvisitable"]]],[11,"fmt","","",463,[[["self"],["formatter"]],["result"]]],[11,"fmt_head","","Write the \"head\" part of the terminator; that is, its name and the data it uses to pick the successor basic block, if any. The only information not included is the list of possible successors, which may be rendered differently between the text and the graphviz format.",463,[[["self"],["w"]],["result"]]],[11,"fmt_successor_labels","","Return the list of labels for the edges to the successor basic blocks.",463,[[["self"]],["vec",["cow"]]]],[11,"clone","","",440,[[["self"]],["statement"]]],[11,"encode","","",440,[[["self"],["__s"]],["result"]]],[11,"decode","","",440,[[["__d"]],["result",["statement"]]]],[11,"make_nop","","Changes a statement to a nop. This is both faster than deleting instructions and avoids invalidating statement indices in `Location`s.",440,[[["self"]]]],[11,"replace_nop","","Changes a statement to a nop and returns the original statement.",440,[[["self"]],["self"]]],[11,"clone","","",464,[[["self"]],["statementkind"]]],[11,"fmt","","",464,[[["self"],["formatter"]],["result"]]],[11,"encode","","",464,[[["self"],["__s"]],["result"]]],[11,"decode","","",464,[[["__d"]],["result",["statementkind"]]]],[11,"clone","","",465,[[["self"]],["validationop"]]],[11,"encode","","",465,[[["self"],["__s"]],["result"]]],[11,"decode","","",465,[[["__d"]],["result",["validationop"]]]],[11,"eq","","",465,[[["self"],["validationop"]],["bool"]]],[11,"ne","","",465,[[["self"],["validationop"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",465,N],[11,"fmt","","",465,[[["self"],["formatter"]],["result"]]],[11,"clone","","",441,[[["self"]],["validationoperand"]]],[11,"hash","","",441,N],[11,"eq","","",441,[[["self"],["validationoperand"]],["bool"]]],[11,"ne","","",441,[[["self"],["validationoperand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",441,N],[11,"encode","","",441,[[["self"],["__st"]],["result"]]],[11,"decode","","",441,[[["__dt"]],["result",["validationoperand"]]]],[11,"fmt","","",441,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",440,[[["self"],["formatter"]],["result"]]],[11,"clone","","",466,[[["self"]],["place"]]],[11,"eq","","",466,[[["self"],["place"]],["bool"]]],[11,"ne","","",466,[[["self"],["place"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",466,N],[11,"hash","","",466,N],[11,"encode","","",466,[[["self"],["__s"]],["result"]]],[11,"decode","","",466,[[["__d"]],["result",["place"]]]],[11,"clone","","",442,[[["self"]],["static"]]],[11,"eq","","",442,[[["self"],["static"]],["bool"]]],[11,"ne","","",442,[[["self"],["static"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",442,N],[11,"hash","","",442,N],[11,"encode","","",442,[[["self"],["__s"]],["result"]]],[11,"decode","","",442,[[["__d"]],["result",["static"]]]],[11,"hash_stable","","",442,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",443,[[["self"]],["projection"]]],[11,"fmt","","",443,[[["self"],["formatter"]],["result"]]],[11,"eq","","",443,[[["self"],["projection"]],["bool"]]],[11,"ne","","",443,[[["self"],["projection"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",443,N],[11,"hash","","",443,N],[11,"encode","","",443,[[["self"],["__sbvt"]],["result"]]],[11,"decode","","",443,[[["__dbvt"]],["result",["projection"]]]],[11,"clone","","",467,[[["self"]],["projectionelem"]]],[11,"fmt","","",467,[[["self"],["formatter"]],["result"]]],[11,"eq","","",467,[[["self"],["projectionelem"]],["bool"]]],[11,"ne","","",467,[[["self"],["projectionelem"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",467,N],[11,"hash","","",467,N],[11,"encode","","",467,[[["self"],["__svt"]],["result"]]],[11,"decode","","",467,[[["__dvt"]],["result",["projectionelem"]]]],[11,"clone","","",444,[[["self"]],["field"]]],[11,"eq","","",444,[[["self"],["field"]],["bool"]]],[11,"ne","","",444,[[["self"],["field"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",444,N],[11,"hash","","",444,N],[11,"partial_cmp","","",444,[[["self"],["field"]],["option",["ordering"]]]],[11,"lt","","",444,[[["self"],["field"]],["bool"]]],[11,"le","","",444,[[["self"],["field"]],["bool"]]],[11,"gt","","",444,[[["self"],["field"]],["bool"]]],[11,"ge","","",444,[[["self"],["field"]],["bool"]]],[11,"cmp","","",444,[[["self"],["field"]],["ordering"]]],[11,"decode","","",444,[[["__d"]],["result",["field"]]]],[11,"encode","","",444,[[["self"],["__s"]],["result"]]],[11,"new","","",444,[[["usize"]],["self"]]],[11,"index","","",444,[[["self"]],["usize"]]],[11,"steps_between","","",444,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",444,[[["self"]],["self"]]],[11,"replace_zero","","",444,[[["self"]],["self"]]],[11,"add_one","","",444,[[["self"]],["self"]]],[11,"sub_one","","",444,[[["self"]],["self"]]],[11,"add_usize","","",444,[[["self"],["usize"]],["option"]]],[11,"fmt","","",444,[[["self"],["formatter"]],["result"]]],[11,"field","","",466,[[["self"],["field"],["ty"]],["place"]]],[11,"deref","","",466,[[["self"]],["place"]]],[11,"downcast","","",466,[[["self"],["adtdef"],["usize"]],["place"]]],[11,"index","","",466,[[["self"],["local"]],["place"]]],[11,"elem","","",466,[[["self"],["placeelem"]],["place"]]],[11,"fmt","","",466,[[["self"],["formatter"]],["result"]]],[11,"clone","","",445,[[["self"]],["sourcescope"]]],[11,"eq","","",445,[[["self"],["sourcescope"]],["bool"]]],[11,"ne","","",445,[[["self"],["sourcescope"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",445,N],[11,"hash","","",445,N],[11,"partial_cmp","","",445,[[["self"],["sourcescope"]],["option",["ordering"]]]],[11,"lt","","",445,[[["self"],["sourcescope"]],["bool"]]],[11,"le","","",445,[[["self"],["sourcescope"]],["bool"]]],[11,"gt","","",445,[[["self"],["sourcescope"]],["bool"]]],[11,"ge","","",445,[[["self"],["sourcescope"]],["bool"]]],[11,"cmp","","",445,[[["self"],["sourcescope"]],["ordering"]]],[11,"decode","","",445,[[["__d"]],["result",["sourcescope"]]]],[11,"encode","","",445,[[["self"],["__s"]],["result"]]],[11,"new","","",445,[[["usize"]],["self"]]],[11,"index","","",445,[[["self"]],["usize"]]],[11,"steps_between","","",445,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",445,[[["self"]],["self"]]],[11,"replace_zero","","",445,[[["self"]],["self"]]],[11,"add_one","","",445,[[["self"]],["self"]]],[11,"sub_one","","",445,[[["self"]],["self"]]],[11,"add_usize","","",445,[[["self"],["usize"]],["option"]]],[11,"fmt","","",445,[[["self"],["formatter"]],["result"]]],[11,"clone","","",446,[[["self"]],["sourcescopedata"]]],[11,"fmt","","",446,[[["self"],["formatter"]],["result"]]],[11,"encode","","",446,[[["self"],["__s"]],["result"]]],[11,"decode","","",446,[[["__d"]],["result",["sourcescopedata"]]]],[11,"clone","","",447,[[["self"]],["sourcescopelocaldata"]]],[11,"fmt","","",447,[[["self"],["formatter"]],["result"]]],[11,"encode","","",447,[[["self"],["__s"]],["result"]]],[11,"decode","","",447,[[["__d"]],["result",["sourcescopelocaldata"]]]],[11,"clone","","",468,[[["self"]],["operand"]]],[11,"eq","","",468,[[["self"],["operand"]],["bool"]]],[11,"ne","","",468,[[["self"],["operand"]],["bool"]]],[11,"encode","","",468,[[["self"],["__s"]],["result"]]],[11,"decode","","",468,[[["__d"]],["result",["operand"]]]],[11,"fmt","","",468,[[["self"],["formatter"]],["result"]]],[11,"function_handle","","",468,[[["tyctxt"],["defid"],["substs"],["span"]],["self"]]],[11,"to_copy","","",468,[[["self"]],["self"]]],[11,"clone","","",469,[[["self"]],["rvalue"]]],[11,"encode","","",469,[[["self"],["__s"]],["result"]]],[11,"decode","","",469,[[["__d"]],["result",["rvalue"]]]],[11,"clone","","",470,[[["self"]],["castkind"]]],[11,"fmt","","",470,[[["self"],["formatter"]],["result"]]],[11,"eq","","",470,[[["self"],["castkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",470,N],[11,"encode","","",470,[[["self"],["__s"]],["result"]]],[11,"decode","","",470,[[["__d"]],["result",["castkind"]]]],[11,"clone","","",471,[[["self"]],["aggregatekind"]]],[11,"fmt","","",471,[[["self"],["formatter"]],["result"]]],[11,"eq","","",471,[[["self"],["aggregatekind"]],["bool"]]],[11,"ne","","",471,[[["self"],["aggregatekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",471,N],[11,"encode","","",471,[[["self"],["__s"]],["result"]]],[11,"decode","","",471,[[["__d"]],["result",["aggregatekind"]]]],[11,"clone","","",472,[[["self"]],["binop"]]],[11,"fmt","","",472,[[["self"],["formatter"]],["result"]]],[11,"eq","","",472,[[["self"],["binop"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",472,N],[11,"encode","","",472,[[["self"],["__s"]],["result"]]],[11,"decode","","",472,[[["__d"]],["result",["binop"]]]],[11,"is_checkable","","",472,[[["self"]],["bool"]]],[11,"clone","","",473,[[["self"]],["nullop"]]],[11,"fmt","","",473,[[["self"],["formatter"]],["result"]]],[11,"eq","","",473,[[["self"],["nullop"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",473,N],[11,"encode","","",473,[[["self"],["__s"]],["result"]]],[11,"decode","","",473,[[["__d"]],["result",["nullop"]]]],[11,"clone","","",474,[[["self"]],["unop"]]],[11,"fmt","","",474,[[["self"],["formatter"]],["result"]]],[11,"eq","","",474,[[["self"],["unop"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",474,N],[11,"encode","","",474,[[["self"],["__s"]],["result"]]],[11,"decode","","",474,[[["__d"]],["result",["unop"]]]],[11,"fmt","","",469,[[["self"],["formatter"]],["result"]]],[11,"clone","","",448,[[["self"]],["constant"]]],[11,"eq","","",448,[[["self"],["constant"]],["bool"]]],[11,"ne","","",448,[[["self"],["constant"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",448,N],[11,"hash","","",448,N],[11,"encode","","",448,[[["self"],["__s"]],["result"]]],[11,"decode","","",448,[[["__d"]],["result",["constant"]]]],[11,"clone","","",449,[[["self"]],["promoted"]]],[11,"eq","","",449,[[["self"],["promoted"]],["bool"]]],[11,"ne","","",449,[[["self"],["promoted"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",449,N],[11,"hash","","",449,N],[11,"partial_cmp","","",449,[[["self"],["promoted"]],["option",["ordering"]]]],[11,"lt","","",449,[[["self"],["promoted"]],["bool"]]],[11,"le","","",449,[[["self"],["promoted"]],["bool"]]],[11,"gt","","",449,[[["self"],["promoted"]],["bool"]]],[11,"ge","","",449,[[["self"],["promoted"]],["bool"]]],[11,"cmp","","",449,[[["self"],["promoted"]],["ordering"]]],[11,"decode","","",449,[[["__d"]],["result",["promoted"]]]],[11,"encode","","",449,[[["self"],["__s"]],["result"]]],[11,"new","","",449,[[["usize"]],["self"]]],[11,"index","","",449,[[["self"]],["usize"]]],[11,"steps_between","","",449,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",449,[[["self"]],["self"]]],[11,"replace_zero","","",449,[[["self"]],["self"]]],[11,"add_one","","",449,[[["self"]],["self"]]],[11,"sub_one","","",449,[[["self"]],["self"]]],[11,"add_usize","","",449,[[["self"],["usize"]],["option"]]],[11,"fmt","","",449,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",448,[[["self"],["formatter"]],["result"]]],[11,"num_nodes","","",431,[[["self"]],["usize"]]],[11,"start_node","","",431,N],[11,"predecessors","","",431,N],[11,"successors","","",431,N],[11,"clone","","",450,[[["self"]],["location"]]],[11,"eq","","",450,[[["self"],["location"]],["bool"]]],[11,"ne","","",450,[[["self"],["location"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",450,N],[11,"hash","","",450,N],[11,"cmp","","",450,[[["self"],["location"]],["ordering"]]],[11,"partial_cmp","","",450,[[["self"],["location"]],["option",["ordering"]]]],[11,"lt","","",450,[[["self"],["location"]],["bool"]]],[11,"le","","",450,[[["self"],["location"]],["bool"]]],[11,"gt","","",450,[[["self"],["location"]],["bool"]]],[11,"ge","","",450,[[["self"],["location"]],["bool"]]],[11,"fmt","","",450,[[["self"],["formatter"]],["result"]]],[18,"START","","",450,N],[11,"successor_within_block","","Returns the location immediately after this one within the enclosing block.",450,[[["self"]],["location"]]],[11,"dominates","","",450,[[["self"],["location"],["dominators"]],["bool"]]],[11,"clone","","",475,[[["self"]],["unsafetyviolationkind"]]],[11,"fmt","","",475,[[["self"],["formatter"]],["result"]]],[11,"eq","","",475,[[["self"],["unsafetyviolationkind"]],["bool"]]],[11,"ne","","",475,[[["self"],["unsafetyviolationkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",475,N],[11,"hash","","",475,N],[11,"encode","","",475,[[["self"],["__s"]],["result"]]],[11,"decode","","",475,[[["__d"]],["result",["unsafetyviolationkind"]]]],[11,"clone","","",451,[[["self"]],["unsafetyviolation"]]],[11,"fmt","","",451,[[["self"],["formatter"]],["result"]]],[11,"eq","","",451,[[["self"],["unsafetyviolation"]],["bool"]]],[11,"ne","","",451,[[["self"],["unsafetyviolation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",451,N],[11,"hash","","",451,N],[11,"encode","","",451,[[["self"],["__s"]],["result"]]],[11,"decode","","",451,[[["__d"]],["result",["unsafetyviolation"]]]],[11,"clone","","",452,[[["self"]],["unsafetycheckresult"]]],[11,"fmt","","",452,[[["self"],["formatter"]],["result"]]],[11,"eq","","",452,[[["self"],["unsafetycheckresult"]],["bool"]]],[11,"ne","","",452,[[["self"],["unsafetycheckresult"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",452,N],[11,"hash","","",452,N],[11,"encode","","",452,[[["self"],["__s"]],["result"]]],[11,"decode","","",452,[[["__d"]],["result",["unsafetycheckresult"]]]],[11,"clone","","",453,[[["self"]],["generatorlayout"]]],[11,"fmt","","",453,[[["self"],["formatter"]],["result"]]],[11,"encode","","",453,[[["self"],["__s"]],["result"]]],[11,"decode","","",453,[[["__d"]],["result",["generatorlayout"]]]],[11,"clone","","",454,[[["self"]],["borrowcheckresult"]]],[11,"fmt","","",454,[[["self"],["formatter"]],["result"]]],[11,"encode","","",454,[[["self"],["__s"]],["result"]]],[11,"decode","","",454,[[["__d"]],["result",["borrowcheckresult"]]]],[11,"clone","","",455,[[["self"]],["closureregionrequirements"]]],[11,"fmt","","",455,[[["self"],["formatter"]],["result"]]],[11,"encode","","",455,[[["self"],["__s"]],["result"]]],[11,"decode","","",455,[[["__d"]],["result",["closureregionrequirements"]]]],[11,"clone","","",456,[[["self"]],["closureoutlivesrequirement"]]],[11,"fmt","","",456,[[["self"],["formatter"]],["result"]]],[11,"encode","","",456,[[["self"],["__s"]],["result"]]],[11,"decode","","",456,[[["__d"]],["result",["closureoutlivesrequirement"]]]],[11,"clone","","",476,[[["self"]],["closureoutlivessubject"]]],[11,"fmt","","",476,[[["self"],["formatter"]],["result"]]],[11,"encode","","",476,[[["self"],["__s"]],["result"]]],[11,"decode","","",476,[[["__d"]],["result",["closureoutlivessubject"]]]],[11,"super_fold_with","","",459,[[["self"],["f"]],["mutability"]]],[11,"super_visit_with","","",459,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",432,[[["self"],["f"]],["sourceinfo"]]],[11,"super_visit_with","","",432,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",436,[[["self"],["f"]],["upvardecl"]]],[11,"super_visit_with","","",436,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",465,[[["self"],["f"]],["validationop"]]],[11,"super_visit_with","","",465,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",445,[[["self"],["f"]],["sourcescope"]]],[11,"super_visit_with","","",445,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",446,[[["self"],["f"]],["sourcescopedata"]]],[11,"super_visit_with","","",446,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",447,[[["self"],["f"]],["sourcescopelocaldata"]]],[11,"super_visit_with","","",447,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",459,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",432,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",436,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",465,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",445,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",446,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",447,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",431,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",431,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",453,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",453,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",435,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",435,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",438,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",438,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",441,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",441,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",440,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",440,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",464,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",464,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",458,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",458,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",439,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",439,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",466,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",466,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",469,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",469,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",468,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",468,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",443,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",443,[[["self"],["vs"]],["bool"]]],[11,"super_fold_with","","",444,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",444,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",448,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",448,[[["self"],["v"]],["bool"]]],[0,"session","rustc","",N,N],[3,"CodeStats","rustc::session","",N,N],[12,"type_sizes","","",517,N],[3,"FieldInfo","","",N,N],[12,"name","","",518,N],[12,"offset","","",518,N],[12,"size","","",518,N],[12,"align","","",518,N],[3,"TypeSizeInfo","","",N,N],[12,"kind","","",519,N],[12,"type_description","","",519,N],[12,"align","","",519,N],[12,"overall_size","","",519,N],[12,"packed","","",519,N],[12,"opt_discr_size","","",519,N],[12,"variants","","",519,N],[3,"VariantInfo","","",N,N],[12,"name","","",520,N],[12,"kind","","",520,N],[12,"size","","",520,N],[12,"align","","",520,N],[12,"fields","","",520,N],[3,"Session","","Represents the data associated with a compilation session for a single crate.",N,N],[12,"target","","",521,N],[12,"host","","",521,N],[12,"opts","","",521,N],[12,"parse_sess","","",521,N],[12,"entry_fn","","For a library crate, this is always none",521,N],[12,"plugin_registrar_fn","","",521,N],[12,"derive_registrar_fn","","",521,N],[12,"default_sysroot","","",521,N],[12,"local_crate_source_file","","The name of the root source file of the crate, in the local file system. `None` means that there is no source file.",521,N],[12,"working_dir","","The directory the compiler has been executed in plus a flag indicating if the value stored here has been affected by path remapping.",521,N],[12,"lint_store","","",521,N],[12,"buffered_lints","","",521,N],[12,"one_time_diagnostics","","Set of (DiagnosticId, Option, message) tuples tracking (sub)diagnostics that have been set once, but should not be set again, in order to avoid redundantly verbose output (Issue #24690, #44953).",521,N],[12,"plugin_llvm_passes","","",521,N],[12,"plugin_attributes","","",521,N],[12,"crate_types","","",521,N],[12,"dependency_formats","","",521,N],[12,"crate_disambiguator","","The crate_disambiguator is constructed out of all the `-C metadata` arguments passed to the compiler. Its value together with the crate-name forms a unique global identifier for the crate. It is used to allow multiple crates with the same name to coexist. See the rustc_codegen_llvm::back::symbol_names module for more information.",521,N],[12,"features","","",521,N],[12,"recursion_limit","","The maximum recursion limit for potentially infinitely recursive operations such as auto-dereference and monomorphization.",521,N],[12,"type_length_limit","","The maximum length of types during monomorphization.",521,N],[12,"const_eval_stack_frame_limit","","The maximum number of stackframes allowed in const eval",521,N],[12,"injected_allocator","","The metadata::creader module may inject an allocator/panic_runtime dependency if it didn't already find one, and this tracks what was injected.",521,N],[12,"allocator_kind","","",521,N],[12,"injected_panic_runtime","","",521,N],[12,"imported_macro_spans","","Map from imported macro spans (which consist of the localized span for the macro body) to the macro name and definition span in the source crate.",521,N],[12,"incr_comp_session","","",521,N],[12,"ignored_attr_names","","A cache of attributes ignored by StableHashingContext",521,N],[12,"profile_channel","","Used by -Z profile-queries in util::common",521,N],[12,"perf_stats","","Some measurements that are being gathered during compilation.",521,N],[12,"code_stats","","Data about code being compiled, gathered during compilation.",521,N],[12,"next_node_id","","",521,N],[12,"optimization_fuel_crate","","If -zfuel=crate=n is specified, Some(crate).",521,N],[12,"optimization_fuel_limit","","If -zfuel=crate=n is specified, initially set to n. Otherwise 0.",521,N],[12,"out_of_fuel","","We're rejecting all further optimizations.",521,N],[12,"print_fuel_crate","","If -zprint-fuel=crate, Some(crate).",521,N],[12,"print_fuel","","Always set to zero and incremented so that we can print fuel expended by a crate.",521,N],[12,"jobserver","","Loaded up early on in the initialization of this `Session` to avoid false positives about a job server in our environment.",521,N],[12,"has_global_allocator","","Metadata about the allocators for the current crate being compiled",521,N],[12,"driver_lint_caps","","Cap lint level specified by a driver specifically.",521,N],[3,"PerfStats","","",N,N],[12,"symbol_hash_time","","The accumulated time spent on computing symbol hashes",522,N],[12,"decode_def_path_tables_time","","The accumulated time spent decoding def path tables from metadata",522,N],[12,"queries_canonicalized","","Total number of values canonicalized queries constructed.",522,N],[12,"normalize_ty_after_erasing_regions","","Number of times this query is invoked.",522,N],[12,"normalize_projection_ty","","Number of times this query is invoked.",522,N],[3,"CrateDisambiguator","","Hash value constructed out of all the `-C metadata` arguments passed to the compiler. Together with the crate-name forms a unique global identifier for the crate.",N,N],[12,"0","","",523,N],[4,"DataTypeKind","","",N,N],[13,"Struct","","",524,N],[13,"Union","","",524,N],[13,"Enum","","",524,N],[13,"Closure","","",524,N],[4,"SizeKind","","",N,N],[13,"Exact","","",525,N],[13,"Min","","",525,N],[4,"DiagnosticBuilderMethod","","Enum to support dispatch of one-time diagnostics (in Session.diag_once)",N,N],[13,"Note","","",526,N],[13,"SpanNote","","",526,N],[13,"SpanSuggestion","","",526,N],[4,"DiagnosticMessageId","","Diagnostic message ID—used by `Session.one_time_diagnostics` to avoid emitting the same message more than once",N,N],[13,"ErrorId","","",527,N],[13,"LintId","","",527,N],[13,"StabilityId","","",527,N],[4,"IncrCompSession","","Holds data on the current incremental compilation session, if there is one.",N,N],[13,"NotInitialized","","This is the state the session will be in until the incr. comp. dir is needed.",528,N],[13,"Active","","This is the state during which the session directory is private and can be modified.",528,N],[12,"session_directory","rustc::session::IncrCompSession","",528,N],[12,"lock_file","","",528,N],[12,"load_dep_graph","","",528,N],[13,"Finalized","rustc::session","This is the state after the session directory has been finalized. In this state, the contents of the directory must not be modified any more.",528,N],[12,"session_directory","rustc::session::IncrCompSession","",528,N],[13,"InvalidBecauseOfErrors","rustc::session","This is an error state that is reached when some compilation error has occurred. It indicates that the contents of the session directory must not be used, since they might be invalid.",528,N],[12,"session_directory","rustc::session::IncrCompSession","",528,N],[4,"CompileIncomplete","rustc::session","",N,N],[13,"Stopped","","",529,N],[13,"Errored","","",529,N],[5,"build_session","","",N,[[["options"],["option",["pathbuf"]],["registry"]],["session"]]],[5,"build_session_with_codemap","","",N,[[["options"],["option",["pathbuf"]],["registry"],["lrc",["codemap"]],["option",["box"]]],["session"]]],[5,"build_session_","","",N,[[["options"],["option",["pathbuf"]],["handler"],["lrc",["codemap"]]],["session"]]],[5,"early_error","","",N,N],[5,"early_warn","","",N,[[["erroroutputtype"],["str"]]]],[5,"compile_result_from_err_count","","",N,[[["usize"]],["compileresult"]]],[5,"bug_fmt","","",N,N],[5,"span_bug_fmt","","",N,N],[5,"opt_span_bug_fmt","","",N,N],[0,"code_stats","","",N,N],[3,"VariantInfo","rustc::session::code_stats","",N,N],[12,"name","","",520,N],[12,"kind","","",520,N],[12,"size","","",520,N],[12,"align","","",520,N],[12,"fields","","",520,N],[3,"FieldInfo","","",N,N],[12,"name","","",518,N],[12,"offset","","",518,N],[12,"size","","",518,N],[12,"align","","",518,N],[3,"TypeSizeInfo","","",N,N],[12,"kind","","",519,N],[12,"type_description","","",519,N],[12,"align","","",519,N],[12,"overall_size","","",519,N],[12,"packed","","",519,N],[12,"opt_discr_size","","",519,N],[12,"variants","","",519,N],[3,"CodeStats","","",N,N],[12,"type_sizes","","",517,N],[4,"SizeKind","","",N,N],[13,"Exact","","",525,N],[13,"Min","","",525,N],[4,"DataTypeKind","","",N,N],[13,"Struct","","",524,N],[13,"Union","","",524,N],[13,"Enum","","",524,N],[13,"Closure","","",524,N],[11,"clone","rustc::session","",520,[[["self"]],["variantinfo"]]],[11,"eq","","",520,[[["self"],["variantinfo"]],["bool"]]],[11,"ne","","",520,[[["self"],["variantinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",520,N],[11,"hash","","",520,N],[11,"fmt","","",520,[[["self"],["formatter"]],["result"]]],[11,"clone","","",525,[[["self"]],["sizekind"]]],[11,"eq","","",525,[[["self"],["sizekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",525,N],[11,"hash","","",525,N],[11,"fmt","","",525,[[["self"],["formatter"]],["result"]]],[11,"clone","","",518,[[["self"]],["fieldinfo"]]],[11,"eq","","",518,[[["self"],["fieldinfo"]],["bool"]]],[11,"ne","","",518,[[["self"],["fieldinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",518,N],[11,"hash","","",518,N],[11,"fmt","","",518,[[["self"],["formatter"]],["result"]]],[11,"from","","",524,[[["adtkind"]],["self"]]],[11,"clone","","",524,[[["self"]],["datatypekind"]]],[11,"eq","","",524,[[["self"],["datatypekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",524,N],[11,"hash","","",524,N],[11,"fmt","","",524,[[["self"],["formatter"]],["result"]]],[11,"eq","","",519,[[["self"],["typesizeinfo"]],["bool"]]],[11,"ne","","",519,[[["self"],["typesizeinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",519,N],[11,"hash","","",519,N],[11,"fmt","","",519,[[["self"],["formatter"]],["result"]]],[11,"eq","","",517,[[["self"],["codestats"]],["bool"]]],[11,"ne","","",517,[[["self"],["codestats"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",517,N],[11,"fmt","","",517,[[["self"],["formatter"]],["result"]]],[11,"new","","",517,[[],["self"]]],[11,"record_type_size","","",517,[[["self"],["datatypekind"],["s"],["align"],["size"],["bool"],["option",["size"]],["vec",["variantinfo"]]]]],[11,"print_type_sizes","","",517,[[["self"]]]],[0,"config","","Contains infrastructure for configuring the compiler, including parsing command line options.",N,N],[3,"Config","rustc::session::config","",N,N],[12,"target","","",530,N],[12,"isize_ty","","",530,N],[12,"usize_ty","","",530,N],[3,"OutputTypes","","",N,N],[12,"0","","",531,N],[3,"Externs","","",N,N],[12,"0","","",532,N],[3,"Options","","",N,N],[12,"crate_types","","",533,N],[12,"optimize","","",533,N],[12,"debug_assertions","","",533,N],[12,"debuginfo","","",533,N],[12,"lint_opts","","",533,N],[12,"lint_cap","","",533,N],[12,"describe_lints","","",533,N],[12,"output_types","","",533,N],[12,"search_paths","","",533,N],[12,"libs","","",533,N],[12,"maybe_sysroot","","",533,N],[12,"target_triple","","",533,N],[12,"test","","",533,N],[12,"error_format","","",533,N],[12,"incremental","","",533,N],[12,"debugging_opts","","",533,N],[12,"prints","","",533,N],[12,"borrowck_mode","","",533,N],[12,"cg","","",533,N],[12,"externs","","",533,N],[12,"crate_name","","",533,N],[12,"alt_std_name","","",533,N],[12,"unstable_features","","",533,N],[12,"actually_rustdoc","","",533,N],[12,"cli_forced_codegen_units","","",533,N],[12,"cli_forced_thinlto_off","","",533,N],[12,"remap_path_prefix","","",533,N],[12,"edition","","",533,N],[3,"OutputFilenames","","",N,N],[12,"out_directory","","",534,N],[12,"out_filestem","","",534,N],[12,"single_output_file","","",534,N],[12,"extra","","",534,N],[12,"outputs","","",534,N],[3,"CodegenOptions","","",N,N],[12,"ar","","",535,N],[12,"linker","","",535,N],[12,"link_arg","","",535,N],[12,"link_args","","",535,N],[12,"link_dead_code","","",535,N],[12,"lto","","",535,N],[12,"target_cpu","","",535,N],[12,"target_feature","","",535,N],[12,"passes","","",535,N],[12,"llvm_args","","",535,N],[12,"save_temps","","",535,N],[12,"rpath","","",535,N],[12,"overflow_checks","","",535,N],[12,"no_prepopulate_passes","","",535,N],[12,"no_vectorize_loops","","",535,N],[12,"no_vectorize_slp","","",535,N],[12,"soft_float","","",535,N],[12,"prefer_dynamic","","",535,N],[12,"no_integrated_as","","",535,N],[12,"no_redzone","","",535,N],[12,"relocation_model","","",535,N],[12,"code_model","","",535,N],[12,"metadata","","",535,N],[12,"extra_filename","","",535,N],[12,"codegen_units","","",535,N],[12,"remark","","",535,N],[12,"no_stack_check","","",535,N],[12,"debuginfo","","",535,N],[12,"opt_level","","",535,N],[12,"force_frame_pointers","","",535,N],[12,"debug_assertions","","",535,N],[12,"inline_threshold","","",535,N],[12,"panic","","",535,N],[12,"incremental","","",535,N],[3,"DebuggingOptions","","",N,N],[12,"codegen_backend","","",536,N],[12,"verbose","","",536,N],[12,"span_free_formats","","",536,N],[12,"identify_regions","","",536,N],[12,"emit_end_regions","","",536,N],[12,"borrowck","","",536,N],[12,"two_phase_borrows","","",536,N],[12,"two_phase_beyond_autoref","","",536,N],[12,"time_passes","","",536,N],[12,"count_llvm_insns","","",536,N],[12,"time_llvm_passes","","",536,N],[12,"input_stats","","",536,N],[12,"codegen_stats","","",536,N],[12,"asm_comments","","",536,N],[12,"verify_llvm_ir","","",536,N],[12,"borrowck_stats","","",536,N],[12,"no_landing_pads","","",536,N],[12,"fewer_names","","",536,N],[12,"meta_stats","","",536,N],[12,"print_link_args","","",536,N],[12,"print_llvm_passes","","",536,N],[12,"ast_json","","",536,N],[12,"query_threads","","",536,N],[12,"ast_json_noexpand","","",536,N],[12,"ls","","",536,N],[12,"save_analysis","","",536,N],[12,"flowgraph_print_loans","","",536,N],[12,"flowgraph_print_moves","","",536,N],[12,"flowgraph_print_assigns","","",536,N],[12,"flowgraph_print_all","","",536,N],[12,"print_region_graph","","",536,N],[12,"parse_only","","",536,N],[12,"no_codegen","","",536,N],[12,"treat_err_as_bug","","",536,N],[12,"report_delayed_bugs","","",536,N],[12,"external_macro_backtrace","","",536,N],[12,"teach","","",536,N],[12,"continue_parse_after_error","","",536,N],[12,"incremental","","",536,N],[12,"incremental_queries","","",536,N],[12,"incremental_info","","",536,N],[12,"incremental_dump_hash","","",536,N],[12,"incremental_verify_ich","","",536,N],[12,"incremental_ignore_spans","","",536,N],[12,"dump_dep_graph","","",536,N],[12,"query_dep_graph","","",536,N],[12,"profile_queries","","",536,N],[12,"profile_queries_and_keys","","",536,N],[12,"no_analysis","","",536,N],[12,"extra_plugins","","",536,N],[12,"unstable_options","","",536,N],[12,"force_overflow_checks","","",536,N],[12,"trace_macros","","",536,N],[12,"debug_macros","","",536,N],[12,"keep_hygiene_data","","",536,N],[12,"keep_ast","","",536,N],[12,"show_span","","",536,N],[12,"print_type_sizes","","",536,N],[12,"print_mono_items","","",536,N],[12,"mir_opt_level","","",536,N],[12,"mutable_noalias","","",536,N],[12,"arg_align_attributes","","",536,N],[12,"dump_mir","","",536,N],[12,"dump_mir_dir","","",536,N],[12,"dump_mir_graphviz","","",536,N],[12,"dump_mir_exclude_pass_number","","",536,N],[12,"mir_emit_validate","","",536,N],[12,"perf_stats","","",536,N],[12,"hir_stats","","",536,N],[12,"mir_stats","","",536,N],[12,"always_encode_mir","","",536,N],[12,"osx_rpath_install_name","","",536,N],[12,"sanitizer","","",536,N],[12,"linker_flavor","","",536,N],[12,"fuel","","",536,N],[12,"print_fuel","","",536,N],[12,"force_unstable_if_unmarked","","",536,N],[12,"pre_link_arg","","",536,N],[12,"pre_link_args","","",536,N],[12,"profile","","",536,N],[12,"pgo_gen","","",536,N],[12,"pgo_use","","",536,N],[12,"disable_instrumentation_preinliner","","",536,N],[12,"relro_level","","",536,N],[12,"disable_ast_check_for_mutation_in_guard","","",536,N],[12,"nll_subminimal_causes","","",536,N],[12,"nll_facts","","",536,N],[12,"disable_nll_user_type_assert","","",536,N],[12,"nll_dont_emit_read_for_match","","",536,N],[12,"polonius","","",536,N],[12,"codegen_time_graph","","",536,N],[12,"thinlto","","",536,N],[12,"inline_in_all_cgus","","",536,N],[12,"tls_model","","",536,N],[12,"saturating_float_casts","","",536,N],[12,"lower_128bit_ops","","",536,N],[12,"human_readable_cgu_names","","",536,N],[12,"dep_info_omit_d_target","","",536,N],[12,"unpretty","","",536,N],[12,"run_dsymutil","","",536,N],[12,"ui_testing","","",536,N],[12,"embed_bitcode","","",536,N],[12,"strip_debuginfo_if_disabled","","",536,N],[12,"share_generics","","",536,N],[12,"chalk","","",536,N],[12,"cross_lang_lto","","",536,N],[12,"no_parallel_llvm","","",536,N],[12,"no_leak_check","","",536,N],[12,"crate_attr","","",536,N],[3,"RustcOptGroup","","",N,N],[12,"apply","","",537,N],[12,"name","","",537,N],[12,"stability","","",537,N],[4,"Sanitizer","","",N,N],[13,"Address","","",538,N],[13,"Leak","","",538,N],[13,"Memory","","",538,N],[13,"Thread","","",538,N],[4,"OptLevel","","",N,N],[13,"No","","",539,N],[13,"Less","","",539,N],[13,"Default","","",539,N],[13,"Aggressive","","",539,N],[13,"Size","","",539,N],[13,"SizeMin","","",539,N],[4,"Lto","","",N,N],[13,"No","","Don't do any LTO whatsoever",540,N],[13,"Yes","","Do a full crate graph LTO. The flavor is determined by the compiler (currently the default is \"fat\").",540,N],[13,"Thin","","Do a full crate graph LTO with ThinLTO",540,N],[13,"ThinLocal","","Do a local graph LTO with ThinLTO (only relevant for multiple codegen units).",540,N],[13,"Fat","","Do a full crate graph LTO with \"fat\" LTO",540,N],[4,"CrossLangLto","","",N,N],[13,"LinkerPlugin","","",541,N],[13,"LinkerPluginAuto","","",541,N],[13,"Disabled","","",541,N],[4,"DebugInfoLevel","","",N,N],[13,"NoDebugInfo","","",542,N],[13,"LimitedDebugInfo","","",542,N],[13,"FullDebugInfo","","",542,N],[4,"OutputType","","",N,N],[13,"Bitcode","","",543,N],[13,"Assembly","","",543,N],[13,"LlvmAssembly","","",543,N],[13,"Mir","","",543,N],[13,"Metadata","","",543,N],[13,"Object","","",543,N],[13,"Exe","","",543,N],[13,"DepInfo","","",543,N],[4,"ErrorOutputType","","",N,N],[13,"HumanReadable","","",544,N],[13,"Json","","",544,N],[13,"Short","","",544,N],[4,"PrintRequest","","",N,N],[13,"FileNames","","",545,N],[13,"Sysroot","","",545,N],[13,"CrateName","","",545,N],[13,"Cfg","","",545,N],[13,"TargetList","","",545,N],[13,"TargetCPUs","","",545,N],[13,"TargetFeatures","","",545,N],[13,"RelocationModels","","",545,N],[13,"CodeModels","","",545,N],[13,"TlsModels","","",545,N],[13,"TargetSpec","","",545,N],[13,"NativeStaticLibs","","",545,N],[4,"BorrowckMode","","",N,N],[13,"Ast","","",546,N],[13,"Mir","","",546,N],[13,"Compare","","",546,N],[13,"Migrate","","",546,N],[4,"Input","","",N,N],[13,"File","","Load source from file",547,N],[13,"Str","","",547,N],[12,"name","rustc::session::config::Input","String that is shown in place of a filename",547,N],[12,"input","","Anonymous source string",547,N],[4,"EntryFnType","rustc::session::config","",N,N],[13,"EntryMain","","",548,N],[13,"EntryStart","","",548,N],[4,"CrateType","","",N,N],[13,"CrateTypeExecutable","","",549,N],[13,"CrateTypeDylib","","",549,N],[13,"CrateTypeRlib","","",549,N],[13,"CrateTypeStaticlib","","",549,N],[13,"CrateTypeCdylib","","",549,N],[13,"CrateTypeProcMacro","","",549,N],[4,"Passes","","",N,N],[13,"SomePasses","","",550,N],[13,"AllPasses","","",550,N],[4,"OptionStability","","",N,N],[13,"Stable","","",551,N],[13,"Unstable","","",551,N],[5,"host_triple","","",N,[[],["str"]]],[5,"basic_options","","Some reasonable defaults",N,[[],["options"]]],[5,"basic_codegen_options","","",N,[[],["codegenoptions"]]],[5,"build_codegen_options","","",N,[[["matches"],["erroroutputtype"]],["codegenoptions"]]],[5,"basic_debugging_options","","",N,[[],["debuggingoptions"]]],[5,"build_debugging_options","","",N,[[["matches"],["erroroutputtype"]],["debuggingoptions"]]],[5,"default_lib_output","","",N,[[],["cratetype"]]],[5,"default_configuration","","",N,[[["session"]],["crateconfig"]]],[5,"build_configuration","","",N,[[["session"],["crateconfig"]],["crateconfig"]]],[5,"build_target_config","","",N,[[["options"],["handler"]],["config"]]],[5,"rustc_short_optgroups","","Returns the \"short\" subset of the rustc command line options, including metadata for each option, such as whether the option is part of the stable long-term interface for rustc.",N,[[],["vec",["rustcoptgroup"]]]],[5,"rustc_optgroups","","Returns all rustc command line options, including metadata for each option, such as whether the option is part of the stable long-term interface for rustc.",N,[[],["vec",["rustcoptgroup"]]]],[5,"parse_cfgspecs","","",N,[[["vec",["string"]]],["crateconfig"]]],[5,"get_cmd_lint_options","","",N,N],[5,"build_session_options_and_crate_config","","",N,N],[5,"parse_crate_types_from_list","","",N,[[["vec",["string"]]],["result",["vec","string"]]]],[0,"cg_type_desc","","",N,N],[17,"parse_bool","rustc::session::config::cg_type_desc","",N,N],[17,"parse_opt_bool","","",N,N],[17,"parse_string","","",N,N],[17,"parse_string_push","","",N,N],[17,"parse_pathbuf_push","","",N,N],[17,"parse_opt_string","","",N,N],[17,"parse_opt_pathbuf","","",N,N],[17,"parse_list","","",N,N],[17,"parse_opt_list","","",N,N],[17,"parse_uint","","",N,N],[17,"parse_passes","","",N,N],[17,"parse_opt_uint","","",N,N],[17,"parse_panic_strategy","","",N,N],[17,"parse_relro_level","","",N,N],[17,"parse_sanitizer","","",N,N],[17,"parse_linker_flavor","","",N,N],[17,"parse_optimization_fuel","","",N,N],[17,"parse_unpretty","","",N,N],[17,"parse_lto","","",N,N],[17,"parse_cross_lang_lto","","",N,N],[0,"cgsetters","rustc::session::config","",N,N],[5,"ar","rustc::session::config::cgsetters","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"linker","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"link_arg","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"link_args","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"link_dead_code","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"lto","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"target_cpu","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"target_feature","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"passes","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"llvm_args","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"save_temps","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"rpath","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"overflow_checks","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_prepopulate_passes","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_vectorize_loops","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_vectorize_slp","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"soft_float","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"prefer_dynamic","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_integrated_as","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_redzone","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"relocation_model","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"code_model","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"metadata","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"extra_filename","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"codegen_units","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"remark","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_stack_check","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"debuginfo","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"opt_level","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"force_frame_pointers","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"debug_assertions","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"inline_threshold","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"panic","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"incremental","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"parse_bool","","",N,[[["bool"],["option",["str"]]],["bool"]]],[5,"parse_opt_bool","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_opt_string","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_opt_pathbuf","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_string","","",N,[[["string"],["option",["str"]]],["bool"]]],[5,"parse_string_push","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_pathbuf_push","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_list","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_opt_list","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_uint","","",N,[[["usize"],["option",["str"]]],["bool"]]],[5,"parse_opt_uint","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_passes","","",N,[[["passes"],["option",["str"]]],["bool"]]],[5,"parse_panic_strategy","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_relro_level","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_sanitizer","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_linker_flavor","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_optimization_fuel","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_unpretty","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_lto","","",N,[[["lto"],["option",["str"]]],["bool"]]],[5,"parse_cross_lang_lto","","",N,[[["crosslanglto"],["option",["str"]]],["bool"]]],[0,"db_type_desc","rustc::session::config","",N,N],[17,"parse_bool","rustc::session::config::db_type_desc","",N,N],[17,"parse_opt_bool","","",N,N],[17,"parse_string","","",N,N],[17,"parse_string_push","","",N,N],[17,"parse_pathbuf_push","","",N,N],[17,"parse_opt_string","","",N,N],[17,"parse_opt_pathbuf","","",N,N],[17,"parse_list","","",N,N],[17,"parse_opt_list","","",N,N],[17,"parse_uint","","",N,N],[17,"parse_passes","","",N,N],[17,"parse_opt_uint","","",N,N],[17,"parse_panic_strategy","","",N,N],[17,"parse_relro_level","","",N,N],[17,"parse_sanitizer","","",N,N],[17,"parse_linker_flavor","","",N,N],[17,"parse_optimization_fuel","","",N,N],[17,"parse_unpretty","","",N,N],[17,"parse_lto","","",N,N],[17,"parse_cross_lang_lto","","",N,N],[0,"dbsetters","rustc::session::config","",N,N],[5,"codegen_backend","rustc::session::config::dbsetters","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"verbose","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"span_free_formats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"identify_regions","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"emit_end_regions","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"borrowck","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"two_phase_borrows","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"two_phase_beyond_autoref","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"time_passes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"count_llvm_insns","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"time_llvm_passes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"input_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"codegen_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"asm_comments","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"verify_llvm_ir","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"borrowck_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_landing_pads","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"fewer_names","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"meta_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_link_args","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_llvm_passes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"ast_json","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"query_threads","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"ast_json_noexpand","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"ls","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"save_analysis","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"flowgraph_print_loans","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"flowgraph_print_moves","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"flowgraph_print_assigns","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"flowgraph_print_all","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_region_graph","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"parse_only","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_codegen","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"treat_err_as_bug","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"report_delayed_bugs","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"external_macro_backtrace","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"teach","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"continue_parse_after_error","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_queries","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_info","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_dump_hash","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_verify_ich","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_ignore_spans","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_dep_graph","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"query_dep_graph","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"profile_queries","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"profile_queries_and_keys","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_analysis","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"extra_plugins","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"unstable_options","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"force_overflow_checks","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"trace_macros","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"debug_macros","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"keep_hygiene_data","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"keep_ast","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"show_span","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_type_sizes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_mono_items","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"mir_opt_level","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"mutable_noalias","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"arg_align_attributes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_mir","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_mir_dir","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_mir_graphviz","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_mir_exclude_pass_number","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"mir_emit_validate","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"perf_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"hir_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"mir_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"always_encode_mir","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"osx_rpath_install_name","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"sanitizer","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"linker_flavor","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"fuel","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_fuel","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"force_unstable_if_unmarked","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"pre_link_arg","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"pre_link_args","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"profile","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"pgo_gen","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"pgo_use","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"disable_instrumentation_preinliner","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"relro_level","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"disable_ast_check_for_mutation_in_guard","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"nll_subminimal_causes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"nll_facts","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"disable_nll_user_type_assert","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"nll_dont_emit_read_for_match","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"polonius","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"codegen_time_graph","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"thinlto","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"inline_in_all_cgus","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"tls_model","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"saturating_float_casts","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"lower_128bit_ops","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"human_readable_cgu_names","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dep_info_omit_d_target","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"unpretty","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"run_dsymutil","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"ui_testing","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"embed_bitcode","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"strip_debuginfo_if_disabled","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"share_generics","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"chalk","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"cross_lang_lto","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_parallel_llvm","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_leak_check","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"crate_attr","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"parse_bool","","",N,[[["bool"],["option",["str"]]],["bool"]]],[5,"parse_opt_bool","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_opt_string","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_opt_pathbuf","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_string","","",N,[[["string"],["option",["str"]]],["bool"]]],[5,"parse_string_push","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_pathbuf_push","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_list","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_opt_list","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_uint","","",N,[[["usize"],["option",["str"]]],["bool"]]],[5,"parse_opt_uint","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_passes","","",N,[[["passes"],["option",["str"]]],["bool"]]],[5,"parse_panic_strategy","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_relro_level","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_sanitizer","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_linker_flavor","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_optimization_fuel","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_unpretty","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_lto","","",N,[[["lto"],["option",["str"]]],["bool"]]],[5,"parse_cross_lang_lto","","",N,[[["crosslanglto"],["option",["str"]]],["bool"]]],[0,"opt","rustc::session::config","",N,N],[5,"stable","rustc::session::config::opt","",N,[[["str"],["f"]],["rustcoptgroup"]]],[5,"unstable","","",N,[[["str"],["f"]],["rustcoptgroup"]]],[5,"longer","","",N,[[["str"],["str"]],["str"]]],[5,"opt_s","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"multi_s","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flag_s","","",N,[[["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flagopt_s","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flagmulti_s","","",N,[[["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"opt","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"multi","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flag","","",N,[[["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flagopt","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flagmulti","","",N,[[["str"],["str"],["str"]],["rustcoptgroup"]]],[6,"R","","",N,N],[6,"S","","",N,N],[0,"nightly_options","rustc::session::config","",N,N],[5,"is_unstable_enabled","rustc::session::config::nightly_options","",N,[[["matches"]],["bool"]]],[5,"is_nightly_build","","",N,[[],["bool"]]],[5,"check_nightly_options","","",N,N],[0,"dep_tracking","rustc::session::config","Commandline arguments passed to the compiler have to be incorporated with the dependency tracking system for incremental compilation. This module provides some utilities to make this more convenient.",N,N],[5,"stable_hash","rustc::session::config::dep_tracking","",N,[[["btreemap",["str","deptrackinghash"]],["defaulthasher"],["erroroutputtype"]]]],[8,"DepTrackingHash","","",N,N],[10,"hash","","",552,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","rustc::lint","",307,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","rustc::session::config","",549,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",550,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",539,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",540,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",542,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",531,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","rustc::middle::cstore","",343,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","rustc::session::config","",538,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",541,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[6,"CodegenSetter","","",N,N],[6,"DebuggingSetter","","",N,N],[17,"RUST_CGU_EXT","","",N,N],[17,"CG_OPTIONS","","",N,N],[17,"DB_OPTIONS","","",N,N],[11,"clone","","",538,[[["self"]],["sanitizer"]]],[11,"hash","","",538,N],[11,"fmt","","",538,[[["self"],["formatter"]],["result"]]],[11,"clone","","",539,[[["self"]],["optlevel"]]],[11,"eq","","",539,[[["self"],["optlevel"]],["bool"]]],[11,"hash","","",539,N],[11,"clone","","",540,[[["self"]],["lto"]]],[11,"eq","","",540,[[["self"],["lto"]],["bool"]]],[11,"hash","","",540,N],[11,"clone","","",541,[[["self"]],["crosslanglto"]]],[11,"eq","","",541,[[["self"],["crosslanglto"]],["bool"]]],[11,"ne","","",541,[[["self"],["crosslanglto"]],["bool"]]],[11,"hash","","",541,N],[11,"enabled","","",541,[[["self"]],["bool"]]],[11,"clone","","",542,[[["self"]],["debuginfolevel"]]],[11,"eq","","",542,[[["self"],["debuginfolevel"]],["bool"]]],[11,"hash","","",542,N],[11,"clone","","",543,[[["self"]],["outputtype"]]],[11,"eq","","",543,[[["self"],["outputtype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",543,N],[11,"hash","","",543,N],[11,"fmt","","",543,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",543,[[["self"],["outputtype"]],["option",["ordering"]]]],[11,"cmp","","",543,[[["self"],["outputtype"]],["ordering"]]],[11,"encode","","",543,[[["self"],["__s"]],["result"]]],[11,"decode","","",543,[[["__d"]],["result",["outputtype"]]]],[11,"hash_stable","","",543,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",543,N],[11,"is_compatible_with_codegen_units_and_single_output_file","","",543,[[["self"]],["bool"]]],[11,"shorthand","","",543,[[["self"]],["str"]]],[11,"from_shorthand","","",543,[[["str"]],["option"]]],[11,"shorthands_display","","",543,[[],["string"]]],[11,"extension","","",543,[[["self"]],["str"]]],[11,"clone","","",544,[[["self"]],["erroroutputtype"]]],[11,"fmt","","",544,[[["self"],["formatter"]],["result"]]],[11,"eq","","",544,[[["self"],["erroroutputtype"]],["bool"]]],[11,"ne","","",544,[[["self"],["erroroutputtype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",544,N],[11,"default","","",544,[[],["erroroutputtype"]]],[11,"clone","","",531,[[["self"]],["outputtypes"]]],[11,"hash","","",531,N],[11,"hash_stable","","",531,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",531,N],[11,"get","","",531,[[["self"],["outputtype"]],["option",["option"]]]],[11,"contains_key","","",531,[[["self"],["outputtype"]],["bool"]]],[11,"keys","","",531,[[["self"]],["btreemapkeysiter",["outputtype","option"]]]],[11,"values","","",531,[[["self"]],["btreemapvaluesiter",["outputtype","option"]]]],[11,"len","","",531,[[["self"]],["usize"]]],[11,"should_codegen","","",531,[[["self"]],["bool"]]],[11,"clone","","",532,[[["self"]],["externs"]]],[11,"hash","","",532,N],[11,"new","","",532,[[["btreemap",["string","btreeset"]]],["externs"]]],[11,"get","","",532,[[["self"],["str"]],["option",["btreeset"]]]],[11,"iter","","",532,[[["self"]],["btreemapiter",["string","btreeset"]]]],[11,"clone","","",533,[[["self"]],["options"]]],[11,"dep_tracking_hash","","",533,[[["self"]],["u64"]]],[11,"clone","","",545,[[["self"]],["printrequest"]]],[11,"eq","","",545,[[["self"],["printrequest"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",545,N],[11,"fmt","","",545,[[["self"],["formatter"]],["result"]]],[11,"clone","","",546,[[["self"]],["borrowckmode"]]],[11,"fmt","","",546,[[["self"],["formatter"]],["result"]]],[11,"eq","","",546,[[["self"],["borrowckmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",546,N],[11,"partial_cmp","","",546,[[["self"],["borrowckmode"]],["option",["ordering"]]]],[11,"cmp","","",546,[[["self"],["borrowckmode"]],["ordering"]]],[11,"hash","","",546,N],[11,"migrate","","Should we run the MIR-based borrow check, but also fall back on the AST borrow check if the MIR-based one errors.",546,[[["self"]],["bool"]]],[11,"use_ast","","Should we emit the AST-based borrow checker errors?",546,[[["self"]],["bool"]]],[11,"use_mir","","Should we emit the MIR-based borrow checker errors?",546,[[["self"]],["bool"]]],[11,"filestem","","",547,[[["self"]],["string"]]],[11,"get_input","","",547,[[["self"]],["option",["string"]]]],[11,"clone","","",534,[[["self"]],["outputfilenames"]]],[11,"hash_stable","","",534,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"path","","",534,[[["self"],["outputtype"]],["pathbuf"]]],[11,"temp_path","","Get the path where a compilation artifact of the given type for the given codegen unit should be placed on disk. If codegen_unit_name is None, a path distinct from those of any codegen unit will be generated.",534,[[["self"],["outputtype"],["option",["str"]]],["pathbuf"]]],[11,"temp_path_ext","","Like temp_path, but also supports things where there is no corresponding OutputType, like no-opt-bitcode or lto-bitcode.",534,[[["self"],["str"],["option",["str"]]],["pathbuf"]]],[11,"with_extension","","",534,[[["self"],["str"]],["pathbuf"]]],[11,"filestem","","",534,[[["self"]],["string"]]],[11,"build_dep_graph","","True if there is a reason to build the dep graph.",533,[[["self"]],["bool"]]],[11,"enable_dep_node_debug_strs","","",533,[[["self"]],["bool"]]],[11,"file_path_mapping","","",533,[[["self"]],["filepathmapping"]]],[11,"will_create_output_file","","True if there will be an output file generated",533,[[["self"]],["bool"]]],[11,"clone","","",548,[[["self"]],["entryfntype"]]],[11,"eq","","",548,[[["self"],["entryfntype"]],["bool"]]],[11,"eq","","",549,[[["self"],["cratetype"]],["bool"]]],[11,"partial_cmp","","",549,[[["self"],["cratetype"]],["option",["ordering"]]]],[11,"clone","","",549,[[["self"]],["cratetype"]]],[11,"cmp","","",549,[[["self"],["cratetype"]],["ordering"]]],[11,"assert_receiver_is_total_eq","","",549,N],[11,"hash","","",549,N],[11,"fmt","","",549,[[["self"],["formatter"]],["result"]]],[11,"clone","","",550,[[["self"]],["passes"]]],[11,"hash","","",550,N],[11,"is_empty","","",550,[[["self"]],["bool"]]],[11,"clone","","",535,[[["self"]],["codegenoptions"]]],[11,"hash","","",535,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"clone","","",536,[[["self"]],["debuggingoptions"]]],[11,"hash","","",536,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"clone","","",551,[[["self"]],["optionstability"]]],[11,"eq","","",551,[[["self"],["optionstability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",551,N],[11,"fmt","","",551,[[["self"],["formatter"]],["result"]]],[11,"is_stable","","",537,[[["self"]],["bool"]]],[11,"stable","","",537,[[["str"],["f"]],["rustcoptgroup"]]],[11,"unstable","","",537,[[["str"],["f"]],["rustcoptgroup"]]],[11,"fmt","","",549,[[["self"],["formatter"]],["result"]]],[0,"filesearch","rustc::session","",N,N],[3,"FileSearch","rustc::session::filesearch","",N,N],[12,"sysroot","","",553,N],[12,"search_paths","","",553,N],[12,"triple","","",553,N],[12,"kind","","",553,N],[4,"FileMatch","","",N,N],[13,"FileMatches","","",554,N],[13,"FileDoesntMatch","","",554,N],[5,"relative_target_lib_path","","",N,[[["path"],["str"]],["pathbuf"]]],[5,"make_target_lib_path","","",N,[[["path"],["str"]],["pathbuf"]]],[5,"get_or_default_sysroot","","",N,[[],["pathbuf"]]],[5,"find_libdir","","",N,[[["path"]],["cow",["str"]]]],[17,"RUST_LIB_DIR","","",N,N],[11,"clone","","",554,[[["self"]],["filematch"]]],[11,"for_each_lib_search_path","","",553,[[["self"],["f"]]]],[11,"get_lib_path","","",553,[[["self"]],["pathbuf"]]],[11,"search","","",553,[[["self"],["f"]]]],[11,"new","","",553,[[["path"],["str"],["searchpaths"],["pathkind"]],["filesearch"]]],[11,"get_dylib_search_paths","","",553,[[["self"]],["vec",["pathbuf"]]]],[11,"get_tools_search_paths","","",553,[[["self"]],["vec",["pathbuf"]]]],[0,"search_paths","rustc::session","",N,N],[3,"SearchPaths","rustc::session::search_paths","",N,N],[12,"paths","","",555,N],[3,"Iter","","",N,N],[12,"kind","","",556,N],[12,"iter","","",556,N],[4,"PathKind","","",N,N],[13,"Native","","",557,N],[13,"Crate","","",557,N],[13,"Dependency","","",557,N],[13,"Framework","","",557,N],[13,"ExternFlag","","",557,N],[13,"All","","",557,N],[11,"clone","","",555,[[["self"]],["searchpaths"]]],[11,"fmt","","",555,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",557,N],[11,"eq","","",557,[[["self"],["pathkind"]],["bool"]]],[11,"clone","","",557,[[["self"]],["pathkind"]]],[11,"fmt","","",557,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",557,[[["self"],["pathkind"]],["option",["ordering"]]]],[11,"cmp","","",557,[[["self"],["pathkind"]],["ordering"]]],[11,"hash","","",557,N],[11,"new","","",555,[[],["searchpaths"]]],[11,"add_path","","",555,[[["self"],["str"],["erroroutputtype"]]]],[11,"iter","","",555,[[["self"],["pathkind"]],["iter"]]],[11,"next","","",556,[[["self"]],["option"]]],[11,"size_hint","","",556,N],[6,"CompileResult","rustc::session","",N,N],[11,"clone","","",527,[[["self"]],["diagnosticmessageid"]]],[11,"fmt","","",527,[[["self"],["formatter"]],["result"]]],[11,"eq","","",527,[[["self"],["diagnosticmessageid"]],["bool"]]],[11,"ne","","",527,[[["self"],["diagnosticmessageid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",527,N],[11,"hash","","",527,N],[11,"from","","",527,[[["lint"]],["self"]]],[11,"local_crate_disambiguator","","",521,[[["self"]],["cratedisambiguator"]]],[11,"struct_span_warn","","",521,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_warn_with_code","","",521,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_warn","","",521,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err","","",521,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err_with_code","","",521,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_err","","",521,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_err_with_code","","",521,[[["self"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_span_fatal","","",521,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_fatal_with_code","","",521,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_fatal","","",521,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_fatal","","",521,N],[11,"span_fatal_with_code","","",521,N],[11,"fatal","","",521,N],[11,"span_err_or_warn","","",521,[[["self"],["bool"],["s"],["str"]]]],[11,"span_err","","",521,[[["self"],["s"],["str"]]]],[11,"span_err_with_code","","",521,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"err","","",521,[[["self"],["str"]]]],[11,"err_count","","",521,[[["self"]],["usize"]]],[11,"has_errors","","",521,[[["self"]],["bool"]]],[11,"abort_if_errors","","",521,[[["self"]]]],[11,"compile_status","","",521,[[["self"]],["result",["compileincomplete"]]]],[11,"track_errors","","",521,[[["self"],["f"]],["result",["errorreported"]]]],[11,"span_warn","","",521,[[["self"],["s"],["str"]]]],[11,"span_warn_with_code","","",521,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"warn","","",521,[[["self"],["str"]]]],[11,"opt_span_warn","","",521,[[["self"],["option"],["str"]]]],[11,"delay_span_bug","","Delay a span_bug() call until abort_if_errors()",521,[[["self"],["s"],["str"]]]],[11,"note_without_error","","",521,[[["self"],["str"]]]],[11,"span_note_without_error","","",521,[[["self"],["s"],["str"]]]],[11,"span_unimpl","","",521,N],[11,"unimpl","","",521,N],[11,"buffer_lint","","",521,[[["self"],["lint"],["nodeid"],["s"],["str"]]]],[11,"buffer_lint_with_diagnostic","","",521,[[["self"],["lint"],["nodeid"],["s"],["str"],["builtinlintdiagnostics"]]]],[11,"reserve_node_ids","","",521,[[["self"],["usize"]],["nodeid"]]],[11,"next_node_id","","",521,[[["self"]],["nodeid"]]],[11,"diagnostic","","",521,[[["self"]],["handler"]]],[11,"diag_once","","Analogous to calling methods on the given `DiagnosticBuilder`, but deduplicates on lint ID, span (if any), and message for this `Session`",521,[[["self"],["diagnosticbuilder"],["diagnosticbuildermethod"],["diagnosticmessageid"],["str"],["option",["span"]]]]],[11,"diag_span_note_once","","",521,[[["self"],["diagnosticbuilder"],["diagnosticmessageid"],["span"],["str"]]]],[11,"diag_note_once","","",521,[[["self"],["diagnosticbuilder"],["diagnosticmessageid"],["str"]]]],[11,"diag_span_suggestion_once","","",521,[[["self"],["diagnosticbuilder"],["diagnosticmessageid"],["span"],["str"],["string"]]]],[11,"codemap","","",521,[[["self"]],["codemap"]]],[11,"verbose","","",521,[[["self"]],["bool"]]],[11,"time_passes","","",521,[[["self"]],["bool"]]],[11,"profile_queries","","",521,[[["self"]],["bool"]]],[11,"profile_queries_and_keys","","",521,[[["self"]],["bool"]]],[11,"count_llvm_insns","","",521,[[["self"]],["bool"]]],[11,"time_llvm_passes","","",521,[[["self"]],["bool"]]],[11,"codegen_stats","","",521,[[["self"]],["bool"]]],[11,"meta_stats","","",521,[[["self"]],["bool"]]],[11,"asm_comments","","",521,[[["self"]],["bool"]]],[11,"verify_llvm_ir","","",521,[[["self"]],["bool"]]],[11,"borrowck_stats","","",521,[[["self"]],["bool"]]],[11,"print_llvm_passes","","",521,[[["self"]],["bool"]]],[11,"features_untracked","","Get the features enabled for the current compilation session. DO NOT USE THIS METHOD if there is a TyCtxt available, as it circumvents dependency tracking. Use tcx.features() instead.",521,[[["self"]],["features"]]],[11,"init_features","","",521,[[["self"],["features"]]]],[11,"lto","","Calculates the flavor of LTO to use for this compilation.",521,[[["self"]],["lto"]]],[11,"panic_strategy","","Returns the panic strategy for this compile session. If the user explicitly selected one using '-C panic', use that, otherwise use the panic strategy defined by the target.",521,[[["self"]],["panicstrategy"]]],[11,"linker_flavor","","",521,[[["self"]],["linkerflavor"]]],[11,"fewer_names","","",521,[[["self"]],["bool"]]],[11,"no_landing_pads","","",521,[[["self"]],["bool"]]],[11,"unstable_options","","",521,[[["self"]],["bool"]]],[11,"overflow_checks","","",521,[[["self"]],["bool"]]],[11,"crt_static","","",521,[[["self"]],["bool"]]],[11,"crt_static_feature","","",521,[[["self"]],["bool"]]],[11,"target_cpu","","",521,[[["self"]],["str"]]],[11,"must_not_eliminate_frame_pointers","","",521,[[["self"]],["bool"]]],[11,"generate_plugin_registrar_symbol","","Returns the symbol name for the registrar function, given the crate Svh and the function DefIndex.",521,[[["self"],["cratedisambiguator"]],["string"]]],[11,"generate_derive_registrar_symbol","","",521,[[["self"],["cratedisambiguator"]],["string"]]],[11,"sysroot","","",521,[[["self"]],["path"]]],[11,"target_filesearch","","",521,[[["self"],["pathkind"]],["filesearch"]]],[11,"host_filesearch","","",521,[[["self"],["pathkind"]],["filesearch"]]],[11,"set_incr_session_load_dep_graph","","",521,[[["self"],["bool"]]]],[11,"incr_session_load_dep_graph","","",521,[[["self"]],["bool"]]],[11,"init_incr_comp_session","","",521,[[["self"],["pathbuf"],["lock"],["bool"]]]],[11,"finalize_incr_comp_session","","",521,[[["self"],["pathbuf"]]]],[11,"mark_incr_comp_session_as_invalid","","",521,[[["self"]]]],[11,"incr_comp_session_dir","","",521,[[["self"]],["ref",["pathbuf"]]]],[11,"incr_comp_session_dir_opt","","",521,[[["self"]],["option",["ref"]]]],[11,"print_perf_stats","","",521,[[["self"]]]],[11,"consider_optimizing","","We want to know if we're allowed to do an optimization for crate foo from -z fuel=foo=n. This expends fuel if applicable, and records fuel if applicable.",521,[[["self"],["str"],["t"]],["bool"]]],[11,"query_threads_from_opts","","Returns the number of query threads that should be used for this compilation",521,[[["options"]],["usize"]]],[11,"query_threads","","Returns the number of query threads that should be used for this compilation",521,[[["self"]],["usize"]]],[11,"codegen_units","","Returns the number of codegen units that should be used for this compilation",521,[[["self"]],["usize"]]],[11,"teach","","",521,[[["self"],["diagnosticid"]],["bool"]]],[11,"rust_2018","","Are we allowed to use features from the Rust 2018 edition?",521,[[["self"]],["bool"]]],[11,"edition","","",521,[[["self"]],["edition"]]],[11,"assert_receiver_is_total_eq","","",523,N],[11,"eq","","",523,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"ne","","",523,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"cmp","","",523,[[["self"],["cratedisambiguator"]],["ordering"]]],[11,"partial_cmp","","",523,[[["self"],["cratedisambiguator"]],["option",["ordering"]]]],[11,"lt","","",523,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"le","","",523,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"gt","","",523,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"ge","","",523,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"hash","","",523,N],[11,"fmt","","",523,[[["self"],["formatter"]],["result"]]],[11,"clone","","",523,[[["self"]],["cratedisambiguator"]]],[11,"encode","","",523,[[["self"],["__s"]],["result"]]],[11,"decode","","",523,[[["__d"]],["result",["cratedisambiguator"]]]],[11,"to_fingerprint","","",523,[[["self"]],["fingerprint"]]],[11,"from","","",523,[[["fingerprint"]],["cratedisambiguator"]]],[11,"hash_stable","","",523,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"fmt","","",528,[[["self"],["formatter"]],["result"]]],[11,"clone","","",529,[[["self"]],["compileincomplete"]]],[11,"fmt","","",529,[[["self"],["formatter"]],["result"]]],[11,"from","","",529,[[["errorreported"]],["compileincomplete"]]],[0,"traits","rustc","Trait Resolution. See [rustc guide] for more info on how this works.",N,N],[3,"OverlapResult","rustc::traits","",N,N],[12,"impl_header","","",558,N],[12,"intercrate_ambiguity_causes","","",558,N],[3,"FulfillmentContext","","The fulfillment context is used to drive trait resolution.  It consists of a list of obligations that must be (eventually) satisfied. The job is to track which are satisfied, which yielded errors, and which are still pending. At any point, users can call `select_where_possible`, and the fulfillment context will try to do selection, retaining only those obligations that remain ambiguous. This may be helpful in pushing type inference along. Once all type inference constraints have been generated, the method `select_all_or_error` can be used to report any remaining ambiguous cases as errors.",N,N],[12,"predicates","","",559,N],[12,"register_region_obligations","","",559,N],[3,"PendingPredicateObligation","","",N,N],[12,"obligation","","",560,N],[12,"stalled_on","","",560,N],[3,"MismatchedProjectionTypes","","",N,N],[12,"err","","",561,N],[3,"ProjectionCache","","The projection cache. Unlike the standard caches, this can include infcx-dependent type variables - therefore, we have to roll the cache back each time we roll a snapshot back, to avoid assumptions on yet-unresolved inference variables. Types with skolemized regions also have to be removed when the respective snapshot ends.",N,N],[12,"map","","",562,N],[3,"ProjectionCacheSnapshot","","",N,N],[12,"snapshot","","",563,N],[3,"Normalized","","",N,N],[12,"value","","",564,N],[12,"obligations","","",564,N],[3,"OnUnimplementedDirective","","",N,N],[12,"condition","","",565,N],[12,"subcommands","","",565,N],[12,"message","","",565,N],[12,"label","","",565,N],[12,"note","","",565,N],[3,"OnUnimplementedNote","","",N,N],[12,"message","","",566,N],[12,"label","","",566,N],[12,"note","","",566,N],[3,"EvaluationCache","","",N,N],[12,"hashmap","","",567,N],[3,"SelectionContext","","",N,N],[12,"infcx","","",568,N],[12,"freshener","","Freshener used specifically for skolemizing entries on the obligation stack. This ensures that all entries on the stack at one time will have the same set of skolemized entries, which is important for checking for trait bounds that recursively require themselves.",568,N],[12,"intercrate","","If true, indicates that the evaluation should be conservative and consider the possibility of types outside this crate. This comes up primarily when resolving ambiguity. Imagine there is some trait reference `$0 : Bar` where `$0` is an inference variable. If `intercrate` is true, then we can never say for sure that this reference is not implemented, even if there are no impls at all for `Bar`, because `$0` could be bound to some type that in a downstream crate that implements `Bar`. This is the suitable mode for coherence. Elsewhere, though, we set this to false, because we are only interested in types that the user could actually have written --- in other words, we consider `$0 : Bar` to be unimplemented if there is no type that the user could actually name that would satisfy it. This avoids crippling inference, basically.",568,N],[12,"intercrate_ambiguity_causes","","",568,N],[12,"allow_negative_impls","","Controls whether or not to filter out negative impls when selecting. This is used in librustdoc to distinguish between the lack of an impl and a negative impl",568,N],[12,"query_mode","","The mode that trait queries run in, which informs our error handling policy. In essence, canonicalized queries need their errors propagated rather than immediately reported because we do not have accurate spans.",568,N],[3,"SelectionCache","","",N,N],[12,"hashmap","","",569,N],[3,"OverflowError","","Indicates that trait evaluation caused overflow.",N,N],[3,"OverlapError","","Information pertinent to an overlapping impl error.",N,N],[12,"with_impl","","",570,N],[12,"trait_desc","","",570,N],[12,"self_desc","","",570,N],[12,"intercrate_ambiguity_causes","","",570,N],[3,"SpecializesCache","","",N,N],[12,"map","","",571,N],[3,"SupertraitDefIds","","",N,N],[12,"tcx","","",572,N],[12,"stack","","",572,N],[12,"visited","","",572,N],[3,"Obligation","","An `Obligation` represents some trait reference (e.g. `int:Eq`) for which the vtable must be found.  The process of finding a vtable is called \"resolving\" the `Obligation`. This process consists of either identifying an `impl` (e.g., `impl Eq for int`) that provides the required vtable, or else finding a bound that is in scope. The eventual result is usually a `Selection` (defined below).",N,N],[12,"cause","","Why do we have to prove this thing?",573,N],[12,"param_env","","In which environment should we prove this thing?",573,N],[12,"predicate","","What are we trying to prove?",573,N],[12,"recursion_depth","","If we started proving this as a result of trying to prove something else, track the total depth to ensure termination. If this goes over a certain threshold, we abort compilation -- in such cases, we can not say whether or not the predicate holds for certain. Stupid halting problem. Such a drag.",573,N],[3,"ObligationCause","","Why did we incur this obligation? Used for error reporting.",N,N],[12,"span","","",574,N],[12,"body_id","","",574,N],[12,"code","","",574,N],[3,"DerivedObligationCause","","",N,N],[12,"parent_trait_ref","","The trait reference of the parent obligation that led to the current obligation. Note that only trait obligations lead to derived obligations, so we just store the trait reference here directly.",575,N],[12,"parent_code","","The parent trait had this cause",575,N],[3,"ProgramClause","","A \"program clause\" has the form `D :- G1, ..., Gn`. It is saying that the domain goal `D` is true if `G1...Gn` are provable. This is equivalent to the implication `G1..Gn => D`; we usually write it with the reverse implication operator `:-` to emphasize the way that programs are actually solved (via backchaining, which starts with the goal to solve and proceeds from there).",N,N],[12,"goal","","This goal will be considered true...",576,N],[12,"hypotheses","","...if we can prove these hypotheses (there may be no hypotheses at all):",576,N],[3,"FulfillmentError","","",N,N],[12,"obligation","","",577,N],[12,"code","","",577,N],[3,"VtableImplData","","Identifies a particular impl in the source, along with a set of substitutions from the impl's type/lifetime parameters. The `nested` vector corresponds to the nested obligations attached to the impl's type parameters.",N,N],[12,"impl_def_id","","",578,N],[12,"substs","","",578,N],[12,"nested","","",578,N],[3,"VtableGeneratorData","","",N,N],[12,"generator_def_id","","",579,N],[12,"substs","","",579,N],[12,"nested","","Nested obligations. This can be non-empty if the generator signature contains associated types.",579,N],[3,"VtableClosureData","","",N,N],[12,"closure_def_id","","",580,N],[12,"substs","","",580,N],[12,"nested","","Nested obligations. This can be non-empty if the closure signature contains associated types.",580,N],[3,"VtableAutoImplData","","",N,N],[12,"trait_def_id","","",581,N],[12,"nested","","",581,N],[3,"VtableBuiltinData","","",N,N],[12,"nested","","",582,N],[3,"VtableObjectData","","A vtable for some object-safe trait `Foo` automatically derived for the object type `Foo`.",N,N],[12,"upcast_trait_ref","","`Foo` upcast to the obligation trait. This will be some supertrait of `Foo`.",583,N],[12,"vtable_base","","The vtable is formed by concatenating together the method lists of the base object trait and all supertraits; this is the start of `upcast_trait_ref`'s methods in that vtable.",583,N],[12,"nested","","",583,N],[3,"VtableFnPointerData","","",N,N],[12,"fn_ty","","",584,N],[12,"nested","","",584,N],[4,"OrphanCheckErr","","",N,N],[13,"NoLocalInputType","","",585,N],[13,"UncoveredTy","","",585,N],[4,"Reveal","","Depending on the stage of compilation, we want projection to be more or less conservative.",N,N],[13,"UserFacing","","At type-checking time, we refuse to project any associated type that is marked `default`. Non-`default` (\"final\") types are always projected. This is necessary in general for soundness of specialization. However, we could allow projections in fully-monomorphic cases. We choose not to, because we prefer for `default type` to force the type definition to be treated abstractly by any consumers of the impl. Concretely, that means that the following example will fail to compile:",586,N],[13,"All","","At codegen time, all monomorphic projections will succeed. Also, `impl Trait` is normalized to the concrete type, which has to be already collected by type-checking.",586,N],[4,"ObjectSafetyViolation","","",N,N],[13,"SizedSelf","","Self : Sized declared on the trait",587,N],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location (e.g. `trait Foo : Bar<Self>`)",587,N],[13,"Method","","Method has something illegal",587,N],[13,"AssociatedConst","","Associated const",587,N],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",N,N],[13,"StaticMethod","","e.g., `fn foo()`",588,N],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",588,N],[13,"WhereClauseReferencesSelf","","e.g. `fn foo(&self) where Self: Clone`",588,N],[13,"Generic","","e.g., `fn foo<A>()`",588,N],[13,"NonStandardSelfType","","arbitrary `self` type, e.g. `self: Rc<Self>`",588,N],[4,"EvaluationResult","","The result of trait evaluation. The order is important here as the evaluation of a list is the maximum of the evaluations.",N,N],[13,"EvaluatedToOk","","Evaluation successful",589,N],[13,"EvaluatedToAmbig","","Evaluation is known to be ambiguous - it might hold for some assignment of inference variables, but it might not.",589,N],[13,"EvaluatedToUnknown","","Evaluation failed because of recursion involving inference variables. We are somewhat imprecise there, so we don't actually know the real result.",589,N],[13,"EvaluatedToRecur","","Evaluation failed because we encountered an obligation we are already trying to prove on this branch.",589,N],[13,"EvaluatedToErr","","Evaluation failed",589,N],[4,"IntercrateAmbiguityCause","","",N,N],[13,"DownstreamCrate","","",590,N],[12,"trait_desc","rustc::traits::IntercrateAmbiguityCause","",590,N],[12,"self_desc","","",590,N],[13,"UpstreamCrateUpdate","rustc::traits","",590,N],[12,"trait_desc","rustc::traits::IntercrateAmbiguityCause","",590,N],[12,"self_desc","","",590,N],[4,"IntercrateMode","rustc::traits","",N,N],[13,"Issue43355","","",591,N],[13,"Fixed","","",591,N],[4,"TraitQueryMode","","",N,N],[13,"Standard","","",592,N],[13,"Canonical","","",592,N],[4,"ObligationCauseCode","","",N,N],[13,"MiscObligation","","Not well classified or should be obvious from span.",593,N],[13,"SliceOrArrayElem","","A slice or array is WF only if `T: Sized`",593,N],[13,"TupleElem","","A tuple is WF only if its middle elements are Sized",593,N],[13,"ProjectionWf","","This is the trait reference from the given projection",593,N],[13,"ItemObligation","","In an impl of trait X for type Y, type Y must also implement all supertraits of X.",593,N],[13,"ReferenceOutlivesReferent","","A type like `&'a T` is WF only if `T: 'a`.",593,N],[13,"ObjectTypeBound","","A type like `Box<Foo<'a> + 'b>` is WF only if `'b: 'a`.",593,N],[13,"ObjectCastObligation","","Obligation incurred due to an object cast.",593,N],[13,"AssignmentLhsSized","","L = X implies that L is Sized",593,N],[13,"TupleInitializerSized","","(x1, .., xn) must be Sized",593,N],[13,"StructInitializerSized","","S { ... } must be Sized",593,N],[13,"VariableType","","Type of each variable must be Sized",593,N],[13,"SizedReturnType","","Return type must be Sized",593,N],[13,"SizedYieldType","","Yield type must be Sized",593,N],[13,"RepeatVec","","[T,..n] --> T must be Copy",593,N],[13,"FieldSized","","Types of fields (other than the last) in a struct must be sized.",593,N],[13,"ConstSized","","Constant expressions must be sized.",593,N],[13,"SharedStatic","","static items must have `Sync` type",593,N],[13,"BuiltinDerivedObligation","","",593,N],[13,"ImplDerivedObligation","","",593,N],[13,"CompareImplMethodObligation","","error derived when matching traits/impls; see ObligationCause for more details",593,N],[12,"item_name","rustc::traits::ObligationCauseCode","",593,N],[12,"impl_item_def_id","","",593,N],[12,"trait_item_def_id","","",593,N],[13,"ExprAssignable","rustc::traits","Checking that this expression can be assigned where it needs to be",593,N],[13,"MatchExpressionArm","","Computing common supertype in the arms of a match expression",593,N],[12,"arm_span","rustc::traits::ObligationCauseCode","",593,N],[12,"source","","",593,N],[13,"IfExpression","rustc::traits","Computing common supertype in an if expression",593,N],[13,"IfExpressionWithNoElse","","Computing common supertype of an if expression with no else counter-part",593,N],[13,"MainFunctionType","","`main` has wrong type",593,N],[13,"StartFunctionType","","`start` has wrong type",593,N],[13,"IntrinsicType","","intrinsic has wrong type",593,N],[13,"MethodReceiver","","method receiver",593,N],[13,"ReturnNoExpression","","`return` with no expression",593,N],[13,"ReturnType","","`return` with an expression",593,N],[13,"BlockTailExpression","","Block implicit return",593,N],[13,"TrivialBound","","#[feature(trivial_bounds)] is not enabled",593,N],[4,"WhereClause","","The following types: * `WhereClause` * `WellFormed` * `FromEnv` * `DomainGoal` * `Goal` * `Clause` are used for representing the trait system in the form of logic programming clauses. They are part of the interface for the chalk SLG solver.",N,N],[13,"Implemented","","",594,N],[13,"ProjectionEq","","",594,N],[13,"RegionOutlives","","",594,N],[13,"TypeOutlives","","",594,N],[4,"WellFormed","","",N,N],[13,"Trait","","",595,N],[13,"Ty","","",595,N],[4,"FromEnv","","",N,N],[13,"Trait","","",596,N],[13,"Ty","","",596,N],[4,"DomainGoal","","",N,N],[13,"Holds","","",597,N],[13,"WellFormed","","",597,N],[13,"FromEnv","","",597,N],[13,"Normalize","","",597,N],[4,"QuantifierKind","","",N,N],[13,"Universal","","",598,N],[13,"Existential","","",598,N],[4,"Goal","","",N,N],[13,"Implies","","",599,N],[13,"And","","",599,N],[13,"Not","","",599,N],[13,"DomainGoal","","",599,N],[13,"Quantified","","",599,N],[13,"CannotProve","","",599,N],[4,"Clause","","This matches the definition from Page 7 of \"A Proof Procedure for the Logic of Hereditary Harrop Formulas\".",N,N],[13,"Implies","","",600,N],[13,"ForAll","","",600,N],[4,"SelectionError","","",N,N],[13,"Unimplemented","","",601,N],[13,"OutputTypeParameterMismatch","","",601,N],[13,"TraitNotObjectSafe","","",601,N],[13,"ConstEvalFailure","","",601,N],[13,"Overflow","","",601,N],[4,"FulfillmentErrorCode","","",N,N],[13,"CodeSelectionError","","",602,N],[13,"CodeProjectionError","","",602,N],[13,"CodeSubtypeError","","",602,N],[13,"CodeAmbiguity","","",602,N],[4,"Vtable","","Given the successful resolution of an obligation, the `Vtable` indicates where the vtable comes from. Note that while we call this a \"vtable\", it does not necessarily indicate dynamic dispatch at runtime. `Vtable` instances just tell the compiler where to find methods, but in generic code those methods are typically statically dispatched -- only when an object is constructed is a `Vtable` instance reified into an actual vtable.",N,N],[13,"VtableImpl","","Vtable identifying a particular impl.",603,N],[13,"VtableAutoImpl","","Vtable for auto trait implementations This carries the information and nested obligations with regards to an auto implementation for a trait `Trait`. The nested obligations ensure the trait implementation holds for all the constituent types.",603,N],[13,"VtableParam","","Successful resolution to an obligation provided by the caller for some type parameter. The `Vec<N>` represents the obligations incurred from normalizing the where-clause (if any).",603,N],[13,"VtableObject","","Virtual calls through an object",603,N],[13,"VtableBuiltin","","Successful resolution for a builtin trait.",603,N],[13,"VtableClosure","","Vtable automatically generated for a closure. The def ID is the ID of the closure expression. This is a `VtableImpl` in spirit, but the impl is generated by the compiler and does not appear in the source.",603,N],[13,"VtableFnPointer","","Same as above, but for a fn pointer type with the given signature.",603,N],[13,"VtableGenerator","","Vtable automatically generated for a generator",603,N],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the def-id of a trait impl. To pass, either the trait must be local, or else two conditions must be satisfied:",N,[[["tyctxt"],["defid"]],["result",["orphancheckerr"]]]],[5,"overlapping_impls","","If there are types that satisfy both impls, invokes `on_overlap` with a suitably-freshened `ImplHeader` with those types substituted. Otherwise, invokes `no_overlap`.",N,[[["tyctxt"],["defid"],["defid"],["intercratemode"],["f1"],["f2"]],["r"]]],[5,"normalize","","Normalizes any associated type projections in `value`, replacing them with a fully resolved type where possible. The return value combines the normalized result and any additional obligations that were incurred as result.",N,[[["selectioncontext"],["paramenv"],["obligationcause"],["t"]],["normalized"]]],[5,"normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). If ambiguity arises, which implies that there are unresolved type variables in the projection, we will substitute a fresh type variable `$X` and generate a new obligation `<T as Trait>::Item == $X` for later.",N,[[["selectioncontext"],["paramenv"],["projectionty"],["obligationcause"],["usize"],["vec"]],["ty"]]],[5,"poly_project_and_unify_type","","Evaluates constraints of the form:",N,[[["selectioncontext"],["obligation"]],["result",["option","mismatchedprojectiontypes"]]]],[5,"translate_substs","","Given a subst for the requested impl, translate it to a subst appropriate for the actual item definition (whether it be in that impl, a parent impl, or the trait).",N,[[["inferctxt"],["paramenv"],["defid"],["substs"],["node"]],["substs"]]],[5,"find_associated_item","","Given a selected impl described by `impl_data`, returns the definition and substitutions for the method with the name `name` the kind `kind`, and trait method substitutions `substs`, in that impl, a less specialized impl, or the trait default, whichever applies.",N,N],[5,"elaborate_predicates","","",N,[[["tyctxt"],["vec",["predicate"]]],["elaborator"]]],[5,"supertraits","","",N,[[["tyctxt"],["polytraitref"]],["supertraits"]]],[5,"supertrait_def_ids","","",N,[[["tyctxt"],["defid"]],["supertraitdefids"]]],[5,"transitive_bounds","","",N,N],[5,"predicates_for_generics","","Creates predicate obligations from the generic bounds.",N,[[["obligationcause"],["paramenv"],["instantiatedpredicates"]],["predicateobligations"]]],[5,"type_known_to_meet_bound","","Determines whether the type `ty` is known to meet `bound` and returns true if so. Returns false if `ty` either does not meet `bound` or is not known to meet bound (note that this is conservative towards no impl, which is the opposite of the `evaluate` methods).",N,[[["inferctxt"],["paramenv"],["ty"],["defid"],["span"]],["bool"]]],[5,"normalize_param_env_or_error","","Normalizes the parameter environment, reporting errors if they occur.",N,[[["tyctxt"],["defid"],["paramenv"],["obligationcause"]],["paramenv"]]],[5,"fully_normalize","","",N,[[["inferctxt"],["fulfillmentcontext"],["obligationcause"],["paramenv"],["t"]],["result",["vec"]]]],[5,"normalize_and_test_predicates","","Normalizes the predicates and checks whether they hold in an empty environment. If this returns false, then either normalize encountered an error or one of the predicates did not hold. Used when creating vtables to check for unsatisfiable methods.",N,[[["tyctxt"],["vec",["predicate"]]],["bool"]]],[5,"substitute_normalize_and_test_predicates","","",N,N],[5,"vtable_methods","","Given a trait `trait_ref`, iterates the vtable entries that come from `trait_ref`, including its supertraits.",N,[[["tyctxt"],["polytraitref"]],["lrc",["vec"]]]],[5,"provide","","",N,[[["providers"]]]],[0,"specialization_graph","","",N,N],[3,"Graph","rustc::traits::specialization_graph","A per-trait graph of impls in specialization order. At the moment, this graph forms a tree rooted with the trait itself, with all other nodes representing impls, and parent-child relationships representing specializations.",N,N],[12,"parent","","",604,N],[12,"children","","",604,N],[3,"Ancestors","","",N,N],[12,"trait_def_id","","",605,N],[12,"specialization_graph","","",605,N],[12,"current_source","","",605,N],[3,"NodeItem","","",N,N],[12,"node","","",606,N],[12,"item","","",606,N],[4,"Node","","A node in the specialization graph is either an impl or a trait definition; either can serve as a source of item definitions. There is always exactly one trait definition node: the root.",N,N],[13,"Impl","","",607,N],[13,"Trait","","",607,N],[5,"ancestors","","Walk up the specialization ancestors of a given impl, starting with that impl itself.",N,[[["tyctxt"],["defid"],["defid"]],["ancestors"]]],[0,"auto_trait","rustc::traits","Support code for rustdoc and external tools . You really don't want to be using this unless you need to.",N,N],[3,"RegionDeps","rustc::traits::auto_trait","",N,N],[12,"larger","","",608,N],[12,"smaller","","",608,N],[3,"AutoTraitInfo","","",N,N],[12,"full_user_env","","",609,N],[12,"region_data","","",609,N],[12,"names_map","","",609,N],[12,"vid_to_region","","",609,N],[3,"AutoTraitFinder","","",N,N],[12,"tcx","","",610,N],[3,"RegionReplacer","","",N,N],[12,"vid_to_region","","",611,N],[12,"tcx","","",611,N],[4,"RegionTarget","","",N,N],[13,"Region","","",612,N],[13,"RegionVid","","",612,N],[4,"AutoTraitResult","","",N,N],[13,"ExplicitImpl","","",613,N],[13,"PositiveImpl","","",613,N],[13,"NegativeImpl","","",613,N],[11,"assert_receiver_is_total_eq","","",612,N],[11,"eq","","",612,[[["self"],["regiontarget"]],["bool"]]],[11,"ne","","",612,[[["self"],["regiontarget"]],["bool"]]],[11,"hash","","",612,N],[11,"clone","","",612,[[["self"]],["regiontarget"]]],[11,"fmt","","",612,[[["self"],["formatter"]],["result"]]],[11,"default","","",608,[[],["regiondeps"]]],[11,"fmt","","",608,[[["self"],["formatter"]],["result"]]],[11,"clone","","",608,[[["self"]],["regiondeps"]]],[11,"is_auto","","",613,[[["self"]],["bool"]]],[11,"new","","",610,[[["tyctxt"]],["self"]]],[11,"find_auto_trait_generics","","Make a best effort to determine whether and under which conditions an auto trait is implemented for a type. For example, if you have",610,N],[11,"evaluate_predicates","","",610,[[["self"],["inferctxt"],["defid"],["defid"],["ty"],["paramenv"],["paramenv"],["fxhashset"],["bool"]],["option"]]],[11,"region_name","","",610,[[["self"],["region"]],["option",["string"]]]],[11,"get_lifetime","","",610,[[["self"],["region"],["fxhashmap"]],["string"]]],[11,"map_vid_to_region","","",610,[[["self"],["regionconstraintdata"]],["fxhashmap",["regionvid","region"]]]],[11,"is_of_param","","",610,[[["self"],["substs"]],["bool"]]],[11,"evaluate_nested_obligations","","",610,[[["self"],["ty"],["t"],["fxhashset"],["fxhashset"],["vecdeque"],["selectioncontext"],["bool"]],["bool"]]],[11,"clean_pred","","",610,[[["self"],["inferctxt"],["predicate"]],["predicate"]]],[11,"tcx","","",611,[[["self"]],["tyctxt"]]],[11,"fold_region","","",611,[[["self"],["region"]],["region"]]],[0,"coherence","rustc::traits","See rustc guide chapters on [trait-resolution] and [trait-specialization] for more info on how this works.",N,N],[3,"OverlapResult","rustc::traits::coherence","",N,N],[12,"impl_header","","",558,N],[12,"intercrate_ambiguity_causes","","",558,N],[4,"InCrate","","Whether we do the orphan check relative to this crate or to some remote crate.",N,N],[13,"Local","","",614,N],[13,"Remote","","",614,N],[4,"Conflict","","",N,N],[13,"Upstream","","",615,N],[13,"Downstream","","",615,N],[12,"used_to_be_broken","rustc::traits::coherence::Conflict","",615,N],[4,"OrphanCheckErr","rustc::traits::coherence","",N,N],[13,"NoLocalInputType","","",585,N],[13,"UncoveredTy","","",585,N],[5,"overlapping_impls","","If there are types that satisfy both impls, invokes `on_overlap` with a suitably-freshened `ImplHeader` with those types substituted. Otherwise, invokes `no_overlap`.",N,[[["tyctxt"],["defid"],["defid"],["intercratemode"],["f1"],["f2"]],["r"]]],[5,"with_fresh_ty_vars","","",N,[[["selectioncontext"],["paramenv"],["defid"]],["implheader"]]],[5,"overlap","","Can both impl `a` and impl `b` be satisfied by a common type (including `where` clauses)? If so, returns an `ImplHeader` that unifies the two impls.",N,[[["selectioncontext"],["defid"],["defid"]],["option",["overlapresult"]]]],[5,"trait_ref_is_knowable","","",N,[[["tyctxt"],["traitref"]],["option",["conflict"]]]],[5,"trait_ref_is_local_or_fundamental","","",N,[[["tyctxt"],["traitref"]],["bool"]]],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the def-id of a trait impl. To pass, either the trait must be local, or else two conditions must be satisfied:",N,[[["tyctxt"],["defid"]],["result",["orphancheckerr"]]]],[5,"orphan_check_trait_ref","","Check whether a trait-ref is potentially implementable by a crate.",N,[[["tyctxt"],["traitref"],["incrate"]],["result",["orphancheckerr"]]]],[5,"uncovered_tys","","",N,[[["tyctxt"],["ty"],["incrate"]],["vec",["ty"]]]],[5,"is_possibly_remote_type","","",N,[[["ty"],["incrate"]],["bool"]]],[5,"ty_is_local","","",N,[[["tyctxt"],["ty"],["incrate"]],["bool"]]],[5,"fundamental_ty","","",N,[[["tyctxt"],["ty"]],["bool"]]],[5,"def_id_is_local","","",N,[[["defid"],["incrate"]],["bool"]]],[5,"ty_is_local_constructor","","",N,[[["ty"],["incrate"]],["bool"]]],[11,"clone","","",614,[[["self"]],["incrate"]]],[11,"fmt","","",614,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",615,[[["self"],["formatter"]],["result"]]],[11,"clone","","",615,[[["self"]],["conflict"]]],[0,"error_reporting","rustc::traits","",N,N],[4,"ArgKind","rustc::traits::error_reporting","Summarizes information",N,N],[13,"Arg","","An argument of non-tuple type. Parameters are (name, ty)",616,N],[13,"Tuple","","An argument of tuple type. For a \"found\" argument, the span is the locationo in the source of the pattern. For a \"expected\" argument, it will be None. The vector is a list of (name, ty) strings for the components of the tuple.",616,N],[11,"report_fulfillment_errors","rustc::infer","",208,N],[11,"error_implies","","",208,[[["self"],["predicate"],["predicate"]],["bool"]]],[11,"report_fulfillment_error","","",208,[[["self"],["fulfillmenterror"],["option",["bodyid"]],["bool"]]]],[11,"report_projection_error","","",208,[[["self"],["predicateobligation"],["mismatchedprojectiontypes"]]]],[11,"fuzzy_match_tys","","",208,[[["self"],["ty"],["ty"]],["bool"]]],[11,"impl_similar_to","","",208,[[["self"],["polytraitref"],["predicateobligation"]],["option",["defid"]]]],[11,"on_unimplemented_note","","",208,[[["self"],["polytraitref"],["predicateobligation"]],["onunimplementednote"]]],[11,"find_similar_impl_candidates","","",208,[[["self"],["polytraitref"]],["vec",["traitref"]]]],[11,"report_similar_impl_candidates","","",208,[[["self"],["vec",["traitref"]],["diagnosticbuilder"]]]],[11,"report_overflow_error","","Reports that an overflow has occurred and halts compilation. We halt compilation unconditionally because it is important that overflows never be masked -- they basically represent computations whose result could not be truly determined and thus we can't say if the program type checks or not -- and they are unusual occurrences in any case.",208,N],[11,"report_overflow_error_cycle","","Reports that a cycle was detected which led to overflow and halts compilation. This is equivalent to `report_overflow_error` except that we can give a more helpful error message (and, in particular, we do not suggest increasing the overflow limit, which is not going to help).",208,N],[11,"report_extra_impl_obligation","","",208,[[["self"],["span"],["name"],["defid"],["defid"],["display"]],["diagnosticbuilder"]]],[11,"get_parent_trait_ref","","Get the parent trait chain start",208,[[["self"],["obligationcausecode"]],["option",["string"]]]],[11,"report_selection_error","","",208,[[["self"],["predicateobligation"],["selectionerror"],["bool"]]]],[11,"suggest_borrow_on_unsized_slice","","When encountering an assignment of an unsized trait, like `let x = \"\"[..];`, provide a suggestion to borrow the initializer in order to use have a slice instead.",208,[[["self"],["obligationcausecode"],["diagnosticbuilder"]]]],[11,"suggest_remove_reference","","Whenever references are used by mistake, like `for (i, e) in &vec.iter().enumerate()`, suggest removing these references until we reach a type that implements the trait.",208,[[["self"],["predicateobligation"],["diagnosticbuilder"],["binder"]]]],[11,"get_fn_like_arguments","","Given some node representing a fn-like thing in the HIR map, returns a span and `ArgKind` information that describes the arguments it expects. This can be supplied to `report_arg_count_mismatch`.",208,N],[11,"report_arg_count_mismatch","","Reports an error when the number of arguments needed by a trait match doesn't match the number that the expression provides.",208,[[["self"],["span"],["option",["span"]],["vec",["argkind"]],["vec",["argkind"]],["bool"]],["diagnosticbuilder"]]],[11,"report_closure_arg_mismatch","","",208,[[["self"],["span"],["option",["span"]],["polytraitref"],["polytraitref"]],["diagnosticbuilder"]]],[11,"maybe_report_ambiguity","","",208,[[["self"],["predicateobligation"],["option",["bodyid"]]]]],[11,"predicate_can_apply","","Returns whether the trait predicate may apply for some assignment to the type parameters.",208,[[["self"],["paramenv"],["polytraitref"]],["bool"]]],[11,"note_obligation_cause","","",208,[[["self"],["diagnosticbuilder"],["obligation"]]]],[11,"note_obligation_cause_code","","",208,[[["self"],["diagnosticbuilder"],["t"],["obligationcausecode"],["vec"]]]],[11,"suggest_new_overflow_limit","","",208,[[["self"],["diagnosticbuilder"]]]],[11,"is_recursive_obligation","","",208,[[["self"],["vec"],["obligationcausecode"]],["bool"]]],[11,"empty","rustc::traits::error_reporting","",616,[[],["argkind"]]],[11,"from_expected_ty","","Creates an `ArgKind` from the expected type of an argument. This has no name (`_`) and no source spans..",616,[[["ty"]],["argkind"]]],[0,"engine","rustc::traits","",N,N],[8,"TraitEngine","rustc::traits::engine","",N,N],[10,"normalize_projection_type","","",617,[[["self"],["inferctxt"],["paramenv"],["projectionty"],["obligationcause"]],["ty"]]],[10,"register_bound","","",617,[[["self"],["inferctxt"],["paramenv"],["ty"],["defid"],["obligationcause"]]]],[10,"register_predicate_obligation","","",617,[[["self"],["inferctxt"],["predicateobligation"]]]],[10,"select_all_or_error","","",617,[[["self"],["inferctxt"]],["result",["vec"]]]],[10,"select_where_possible","","",617,[[["self"],["inferctxt"]],["result",["vec"]]]],[10,"pending_obligations","","",617,[[["self"]],["vec",["predicateobligation"]]]],[8,"TraitEngineExt","","",N,N],[10,"register_predicate_obligations","","",618,N],[11,"new","","",617,[[["tyctxt"]],["box"]]],[0,"fulfill","rustc::traits","",N,N],[3,"FulfillmentContext","rustc::traits::fulfill","The fulfillment context is used to drive trait resolution.  It consists of a list of obligations that must be (eventually) satisfied. The job is to track which are satisfied, which yielded errors, and which are still pending. At any point, users can call `select_where_possible`, and the fulfillment context will try to do selection, retaining only those obligations that remain ambiguous. This may be helpful in pushing type inference along. Once all type inference constraints have been generated, the method `select_all_or_error` can be used to report any remaining ambiguous cases as errors.",N,N],[12,"predicates","","",559,N],[12,"register_region_obligations","","",559,N],[3,"PendingPredicateObligation","","",N,N],[12,"obligation","","",560,N],[12,"stalled_on","","",560,N],[3,"FulfillProcessor","","",N,N],[12,"selcx","","",619,N],[12,"register_region_obligations","","",619,N],[5,"mk_pending","","",N,[[["vec",["predicateobligation"]]],["vec",["pendingpredicateobligation"]]]],[5,"trait_ref_type_vars","","Return the set of type variables contained in a trait ref",N,[[["selectioncontext"],["polytraitref"]],["vec",["ty"]]]],[5,"to_fulfillment_error","","",N,[[["error",["pendingpredicateobligation","fulfillmenterrorcode"]]],["fulfillmenterror"]]],[11,"as_predicate","rustc::traits","",560,N],[11,"clone","","",560,[[["self"]],["pendingpredicateobligation"]]],[11,"fmt","","",560,[[["self"],["formatter"]],["result"]]],[11,"new","","Creates a new fulfillment context.",559,[[],["fulfillmentcontext"]]],[11,"new_ignoring_regions","","",559,[[],["fulfillmentcontext"]]],[11,"select","","Attempts to select obligations using `selcx`.",559,[[["self"],["selectioncontext"]],["result",["vec"]]]],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by creating a fresh type variable `$0` as well as a projection predicate `<SomeType as SomeTrait>::X == $0`. When the inference engine runs, it will attempt to find an impl of `SomeTrait` or a where clause that lets us unify `$0` with something concrete. If this fails, we'll unify `$0` with `projection_ty` again.",559,[[["self"],["inferctxt"],["paramenv"],["projectionty"],["obligationcause"]],["ty"]]],[11,"register_bound","","Requires that `ty` must implement the trait with `def_id` in the given environment. This trait must not have any type parameters (except for `Self`).",559,[[["self"],["inferctxt"],["paramenv"],["ty"],["defid"],["obligationcause"]]]],[11,"register_predicate_obligation","","",559,[[["self"],["inferctxt"],["predicateobligation"]]]],[11,"select_all_or_error","","",559,[[["self"],["inferctxt"]],["result",["vec"]]]],[11,"select_where_possible","","",559,[[["self"],["inferctxt"]],["result",["vec"]]]],[11,"pending_obligations","","",559,[[["self"]],["vec",["predicateobligation"]]]],[11,"process_obligation","rustc::traits::fulfill","Processes a predicate obligation and returns either: - `Changed(v)` if the predicate is true, presuming that `v` are also true - `Unchanged` if we don't have enough info to be sure - `Error(e)` if the predicate does not hold",619,N],[11,"process_backedge","","",619,[[["self"],["i"],["phantomdata",["pendingpredicateobligation"]]]]],[0,"project","rustc::traits","Code for projecting associated types out of trait references.",N,N],[3,"MismatchedProjectionTypes","rustc::traits::project","",N,N],[12,"err","","",561,N],[3,"AssociatedTypeNormalizer","","",N,N],[12,"selcx","","",620,N],[12,"param_env","","",620,N],[12,"cause","","",620,N],[12,"obligations","","",620,N],[12,"depth","","",620,N],[3,"Normalized","","",N,N],[12,"value","","",564,N],[12,"obligations","","",564,N],[3,"Progress","","",N,N],[12,"ty","","",621,N],[12,"obligations","","",621,N],[3,"ProjectionCache","","The projection cache. Unlike the standard caches, this can include infcx-dependent type variables - therefore, we have to roll the cache back each time we roll a snapshot back, to avoid assumptions on yet-unresolved inference variables. Types with skolemized regions also have to be removed when the respective snapshot ends.",N,N],[12,"map","","",562,N],[3,"ProjectionCacheKey","","",N,N],[12,"ty","","",622,N],[3,"ProjectionCacheSnapshot","","",N,N],[12,"snapshot","","",563,N],[4,"Reveal","","Depending on the stage of compilation, we want projection to be more or less conservative.",N,N],[13,"UserFacing","","At type-checking time, we refuse to project any associated type that is marked `default`. Non-`default` (\"final\") types are always projected. This is necessary in general for soundness of specialization. However, we could allow projections in fully-monomorphic cases. We choose not to, because we prefer for `default type` to force the type definition to be treated abstractly by any consumers of the impl. Concretely, that means that the following example will fail to compile:",586,N],[13,"All","","At codegen time, all monomorphic projections will succeed. Also, `impl Trait` is normalized to the concrete type, which has to be already collected by type-checking.",586,N],[4,"ProjectionTyError","","When attempting to resolve `<T as TraitRef>::Name` ...",N,N],[13,"TooManyCandidates","","...we found multiple sources of information and couldn't resolve the ambiguity.",623,N],[13,"TraitSelectionError","","...an error occurred matching `T : TraitRef`",623,N],[4,"ProjectionTyCandidate","","",N,N],[13,"ParamEnv","","",624,N],[13,"TraitDef","","",624,N],[13,"Select","","",624,N],[4,"ProjectionTyCandidateSet","","",N,N],[13,"None","","",625,N],[13,"Single","","",625,N],[13,"Ambiguous","","",625,N],[13,"Error","","",625,N],[4,"ProjectedTy","","",N,N],[13,"Progress","","",626,N],[13,"NoProgress","","",626,N],[4,"ProjectionCacheEntry","","",N,N],[13,"InProgress","","",627,N],[13,"Ambiguous","","",627,N],[13,"Error","","",627,N],[13,"NormalizedTy","","",627,N],[5,"poly_project_and_unify_type","","Evaluates constraints of the form:",N,[[["selectioncontext"],["obligation"]],["result",["option","mismatchedprojectiontypes"]]]],[5,"project_and_unify_type","","Evaluates constraints of the form:",N,[[["selectioncontext"],["obligation"]],["result",["option","mismatchedprojectiontypes"]]]],[5,"normalize","","Normalizes any associated type projections in `value`, replacing them with a fully resolved type where possible. The return value combines the normalized result and any additional obligations that were incurred as result.",N,[[["selectioncontext"],["paramenv"],["obligationcause"],["t"]],["normalized"]]],[5,"normalize_with_depth","","As `normalize`, but with a custom depth.",N,[[["selectioncontext"],["paramenv"],["obligationcause"],["usize"],["t"]],["normalized"]]],[5,"normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). If ambiguity arises, which implies that there are unresolved type variables in the projection, we will substitute a fresh type variable `$X` and generate a new obligation `<T as Trait>::Item == $X` for later.",N,[[["selectioncontext"],["paramenv"],["projectionty"],["obligationcause"],["usize"],["vec"]],["ty"]]],[5,"opt_normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). Returns `None` in the case of ambiguity, which indicates that there are unbound type variables.",N,[[["selectioncontext"],["paramenv"],["projectionty"],["obligationcause"],["usize"],["vec"]],["option",["ty"]]]],[5,"prune_cache_value_obligations","","If there are unresolved type variables, then we need to include any subobligations that bind them, at least until those type variables are fully resolved.",N,[[["inferctxt"],["normalized"]],["normalized",["ty"]]]],[5,"get_paranoid_cache_value_obligation","","Whenever we give back a cache result for a projection like `<T as Trait>::Item ==> X`, we always include the obligation to prove that `T: Trait` (we may also include some other obligations). This may or may not be necessary -- in principle, all the obligations that must be proven to show that `T: Trait` were also returned when the cache was first populated. But there are some vague concerns, and so we take the precautionary measure of including `T: Trait` in the result:",N,[[["inferctxt"],["paramenv"],["projectionty"],["obligationcause"],["usize"]],["predicateobligation"]]],[5,"normalize_to_error","","If we are projecting `<T as Trait>::Item`, but `T: Trait` does not hold. In various error cases, we cannot generate a valid normalized projection. Therefore, we create an inference variable return an associated obligation that, when fulfilled, will lead to an error.",N,[[["selectioncontext"],["paramenv"],["projectionty"],["obligationcause"],["usize"]],["normalized",["ty"]]]],[5,"project_type","","Compute the result of a projection type (if we can).",N,[[["selectioncontext"],["obligation"]],["result",["projectedty","projectiontyerror"]]]],[5,"assemble_candidates_from_param_env","","The first thing we have to do is scan through the parameter environment to see whether there are any projection predicates there that can answer this question.",N,[[["selectioncontext"],["obligation"],["traitref"],["projectiontycandidateset"]]]],[5,"assemble_candidates_from_trait_def","","In the case of a nested projection like <::FooT as Bar>::BarT, we may find that the definition of `Foo` has some clues:",N,[[["selectioncontext"],["obligation"],["traitref"],["projectiontycandidateset"]]]],[5,"assemble_candidates_from_predicates","","",N,N],[5,"assemble_candidates_from_impls","","",N,[[["selectioncontext"],["obligation"],["traitref"],["projectiontycandidateset"]]]],[5,"confirm_candidate","","",N,[[["selectioncontext"],["obligation"],["traitref"],["projectiontycandidate"]],["progress"]]],[5,"confirm_select_candidate","","",N,[[["selectioncontext"],["obligation"],["traitref"],["selection"]],["progress"]]],[5,"confirm_object_candidate","","",N,[[["selectioncontext"],["obligation"],["traitref"]],["progress"]]],[5,"confirm_generator_candidate","","",N,[[["selectioncontext"],["obligation"],["vtablegeneratordata",["predicateobligation"]]],["progress"]]],[5,"confirm_fn_pointer_candidate","","",N,[[["selectioncontext"],["obligation"],["vtablefnpointerdata",["predicateobligation"]]],["progress"]]],[5,"confirm_closure_candidate","","",N,[[["selectioncontext"],["obligation"],["vtableclosuredata",["predicateobligation"]]],["progress"]]],[5,"confirm_callable_candidate","","",N,[[["selectioncontext"],["obligation"],["polyfnsig"],["tupleargumentsflag"]],["progress"]]],[5,"confirm_param_env_candidate","","",N,[[["selectioncontext"],["obligation"],["polyprojectionpredicate"]],["progress"]]],[5,"confirm_impl_candidate","","",N,[[["selectioncontext"],["obligation"],["vtableimpldata",["predicateobligation"]]],["progress"]]],[5,"assoc_ty_def","","Locate the definition of an associated type in the specialization hierarchy, starting from the given impl.",N,[[["selectioncontext"],["defid"],["defid"]],["nodeitem",["associateditem"]]]],[6,"PolyProjectionObligation","","",N,N],[6,"ProjectionObligation","","",N,N],[6,"ProjectionTyObligation","","",N,N],[6,"NormalizedTy","","",N,N],[11,"fmt","rustc::traits","",586,[[["self"],["formatter"]],["result"]]],[11,"clone","","",586,[[["self"]],["reveal"]]],[11,"eq","","",586,[[["self"],["reveal"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",586,N],[11,"hash","","",586,N],[11,"fmt","rustc::traits::project","",623,[[["self"],["formatter"]],["result"]]],[11,"clone","rustc::traits","",561,[[["self"]],["mismatchedprojectiontypes"]]],[11,"eq","rustc::traits::project","",624,[[["self"],["projectiontycandidate"]],["bool"]]],[11,"ne","","",624,[[["self"],["projectiontycandidate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",624,N],[11,"fmt","","",624,[[["self"],["formatter"]],["result"]]],[11,"mark_ambiguous","","",625,[[["self"]]]],[11,"mark_error","","",625,[[["self"],["selectionerror"]]]],[11,"push_candidate","","",625,[[["self"],["projectiontycandidate"]],["bool"]]],[11,"new","","",620,[[["selectioncontext"],["paramenv"],["obligationcause"],["usize"]],["associatedtypenormalizer"]]],[11,"fold","","",620,[[["self"],["t"]],["t"]]],[11,"tcx","","",620,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",620,[[["self"],["ty"]],["ty"]]],[11,"fold_const","","",620,[[["self"],["const"]],["const"]]],[11,"clone","rustc::traits","",564,[[["self"]],["normalized"]]],[11,"with","","",564,[[["self"],["u"]],["normalized"]]],[11,"error","rustc::traits::project","",621,[[["tyctxt"]],["self"]]],[11,"with_addl_obligations","","",621,[[["self"],["vec",["predicateobligation"]]],["self"]]],[11,"clone","","",622,[[["self"]],["projectioncachekey"]]],[11,"fmt","","",622,[[["self"],["formatter"]],["result"]]],[11,"hash","","",622,N],[11,"eq","","",622,[[["self"],["projectioncachekey"]],["bool"]]],[11,"ne","","",622,[[["self"],["projectioncachekey"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",622,N],[11,"from_poly_projection_predicate","","",622,[[["selectioncontext"],["polyprojectionpredicate"]],["option"]]],[11,"clone","","",627,[[["self"]],["projectioncacheentry"]]],[11,"fmt","","",627,[[["self"],["formatter"]],["result"]]],[11,"new","rustc::traits","",562,[[],["self"]]],[11,"clear","","",562,[[["self"]]]],[11,"snapshot","","",562,[[["self"]],["projectioncachesnapshot"]]],[11,"rollback_to","","",562,[[["self"],["projectioncachesnapshot"]]]],[11,"rollback_skolemized","","",562,[[["self"],["projectioncachesnapshot"]]]],[11,"commit","","",562,[[["self"],["projectioncachesnapshot"]]]],[11,"try_start","","Try to start normalize `key`; returns an error if normalization already occurred (this error corresponds to a cache hit, so it's actually a good thing).",562,[[["self"],["projectioncachekey"]],["result",["projectioncacheentry"]]]],[11,"insert_ty","","Indicates that `key` was normalized to `value`.",562,[[["self"],["projectioncachekey"],["normalized",["ty"]]]]],[11,"complete","","Mark the relevant projection cache key as having its derived obligations complete, so they won't have to be re-computed (this is OK to do in a snapshot - if the snapshot is rolled back, the obligations will be marked as incomplete again).",562,[[["self"],["projectioncachekey"]]]],[11,"complete_normalized","","A specialized version of `complete` for when the key's value is known to be a NormalizedTy.",562,[[["self"],["projectioncachekey"],["normalized"]]]],[11,"ambiguous","","Indicates that trying to normalize `key` resulted in ambiguity. No point in trying it again then until we gain more type information (in which case, the \"fully resolved\" key will be different).",562,[[["self"],["projectioncachekey"]]]],[11,"error","","Indicates that trying to normalize `key` resulted in error.",562,[[["self"],["projectioncachekey"]]]],[0,"object_safety","","\"Object safety\" refers to the ability for a trait to be converted to an object. In general, traits may only be converted to an object if all of their methods meet certain criteria. In particular, they must:",N,N],[4,"ObjectSafetyViolation","rustc::traits::object_safety","",N,N],[13,"SizedSelf","","Self : Sized declared on the trait",587,N],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location (e.g. `trait Foo : Bar<Self>`)",587,N],[13,"Method","","Method has something illegal",587,N],[13,"AssociatedConst","","Associated const",587,N],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",N,N],[13,"StaticMethod","","e.g., `fn foo()`",588,N],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",588,N],[13,"WhereClauseReferencesSelf","","e.g. `fn foo(&self) where Self: Clone`",588,N],[13,"Generic","","e.g., `fn foo<A>()`",588,N],[13,"NonStandardSelfType","","arbitrary `self` type, e.g. `self: Rc<Self>`",588,N],[5,"is_object_safe_provider","","",N,[[["tyctxt"],["defid"]],["bool"]]],[11,"clone","rustc::traits","",587,[[["self"]],["objectsafetyviolation"]]],[11,"fmt","","",587,[[["self"],["formatter"]],["result"]]],[11,"eq","","",587,[[["self"],["objectsafetyviolation"]],["bool"]]],[11,"ne","","",587,[[["self"],["objectsafetyviolation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",587,N],[11,"hash","","",587,N],[11,"error_msg","","",587,[[["self"]],["cow",["str"]]]],[11,"clone","","",588,[[["self"]],["methodviolationcode"]]],[11,"fmt","","",588,[[["self"],["formatter"]],["result"]]],[11,"eq","","",588,[[["self"],["methodviolationcode"]],["bool"]]],[11,"ne","","",588,[[["self"],["methodviolationcode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",588,N],[11,"hash","","",588,N],[0,"on_unimplemented","","",N,N],[3,"OnUnimplementedFormatString","rustc::traits::on_unimplemented","",N,N],[12,"0","","",628,N],[3,"OnUnimplementedDirective","","",N,N],[12,"condition","","",565,N],[12,"subcommands","","",565,N],[12,"message","","",565,N],[12,"label","","",565,N],[12,"note","","",565,N],[3,"OnUnimplementedNote","","",N,N],[12,"message","","",566,N],[12,"label","","",566,N],[12,"note","","",566,N],[5,"parse_error","","",N,[[["tyctxt"],["span"],["str"],["str"],["option",["str"]]],["errorreported"]]],[11,"clone","","",628,[[["self"]],["onunimplementedformatstring"]]],[11,"fmt","","",628,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustc::traits","",565,[[["self"],["formatter"]],["result"]]],[11,"empty","","",566,[[],["self"]]],[11,"parse","","",565,N],[11,"of_item","","",565,[[["tyctxt"],["defid"],["defid"]],["result",["option","errorreported"]]]],[11,"evaluate","","",565,N],[11,"try_parse","rustc::traits::on_unimplemented","",628,[[["tyctxt"],["defid"],["localinternedstring"],["span"]],["result",["errorreported"]]]],[11,"verify","","",628,[[["self"],["tyctxt"],["defid"],["span"]],["result",["errorreported"]]]],[11,"format","","",628,[[["self"],["tyctxt"],["traitref"]],["string"]]],[0,"select","rustc::traits","See [rustc guide] for more info on how this works.",N,N],[3,"SelectionContext","rustc::traits::select","",N,N],[12,"infcx","","",568,N],[12,"freshener","","Freshener used specifically for skolemizing entries on the obligation stack. This ensures that all entries on the stack at one time will have the same set of skolemized entries, which is important for checking for trait bounds that recursively require themselves.",568,N],[12,"intercrate","","If true, indicates that the evaluation should be conservative and consider the possibility of types outside this crate. This comes up primarily when resolving ambiguity. Imagine there is some trait reference `$0 : Bar` where `$0` is an inference variable. If `intercrate` is true, then we can never say for sure that this reference is not implemented, even if there are no impls at all for `Bar`, because `$0` could be bound to some type that in a downstream crate that implements `Bar`. This is the suitable mode for coherence. Elsewhere, though, we set this to false, because we are only interested in types that the user could actually have written --- in other words, we consider `$0 : Bar` to be unimplemented if there is no type that the user could actually name that would satisfy it. This avoids crippling inference, basically.",568,N],[12,"intercrate_ambiguity_causes","","",568,N],[12,"allow_negative_impls","","Controls whether or not to filter out negative impls when selecting. This is used in librustdoc to distinguish between the lack of an impl and a negative impl",568,N],[12,"query_mode","","The mode that trait queries run in, which informs our error handling policy. In essence, canonicalized queries need their errors propagated rather than immediately reported because we do not have accurate spans.",568,N],[3,"TraitObligationStack","","",N,N],[12,"obligation","","",629,N],[12,"fresh_trait_ref","","Trait ref from `obligation` but skolemized with the selection-context's freshener. Used to check for recursion.",629,N],[12,"previous","","",629,N],[3,"SelectionCache","","",N,N],[12,"hashmap","","",569,N],[3,"SelectionCandidateSet","","",N,N],[12,"vec","","",630,N],[12,"ambiguous","","",630,N],[3,"EvaluatedCandidate","","",N,N],[12,"candidate","","",631,N],[12,"evaluation","","",631,N],[3,"OverflowError","","Indicates that trait evaluation caused overflow.",N,N],[3,"EvaluationCache","","",N,N],[12,"hashmap","","",567,N],[3,"TraitObligationStackList","","",N,N],[12,"head","","",632,N],[3,"WithDepNode","","",N,N],[12,"dep_node","","",633,N],[12,"cached_value","","",633,N],[4,"IntercrateAmbiguityCause","","",N,N],[13,"DownstreamCrate","","",590,N],[12,"trait_desc","rustc::traits::select::IntercrateAmbiguityCause","",590,N],[12,"self_desc","","",590,N],[13,"UpstreamCrateUpdate","rustc::traits::select","",590,N],[12,"trait_desc","rustc::traits::select::IntercrateAmbiguityCause","",590,N],[12,"self_desc","","",590,N],[4,"SelectionCandidate","rustc::traits::select","The selection process begins by considering all impls, where clauses, and so forth that might resolve an obligation.  Sometimes we'll be able to say definitively that (e.g.) an impl does not apply to the obligation: perhaps it is defined for `usize` but the obligation is for `int`. In that case, we drop the impl out of the list.  But the other cases are considered candidates.",N,N],[13,"BuiltinCandidate","","",634,N],[12,"has_nested","rustc::traits::select::SelectionCandidate","",634,N],[13,"ParamCandidate","rustc::traits::select","",634,N],[13,"ImplCandidate","","",634,N],[13,"AutoImplCandidate","","",634,N],[13,"ProjectionCandidate","","This is a trait matching with a projected type as `Self`, and we found an applicable bound in the trait definition.",634,N],[13,"ClosureCandidate","","Implementation of a `Fn`-family trait by one of the anonymous types generated for a `||` expression.",634,N],[13,"GeneratorCandidate","","Implementation of a `Generator` trait by one of the anonymous types generated for a generator.",634,N],[13,"FnPointerCandidate","","Implementation of a `Fn`-family trait by one of the anonymous types generated for a fn pointer type (e.g., `fn(int)->int`)",634,N],[13,"ObjectCandidate","","",634,N],[13,"BuiltinObjectCandidate","","",634,N],[13,"BuiltinUnsizeCandidate","","",634,N],[4,"BuiltinImplConditions","","When does the builtin impl for `T: Trait` apply?",N,N],[13,"Where","","The impl is conditional on T1,T2,.. : Trait",635,N],[13,"None","","There is no built-in impl. There may be some other candidate (a where-clause or user-defined impl).",635,N],[13,"Ambiguous","","It is unknown whether there is an impl.",635,N],[4,"EvaluationResult","","The result of trait evaluation. The order is important here as the evaluation of a list is the maximum of the evaluations.",N,N],[13,"EvaluatedToOk","","Evaluation successful",589,N],[13,"EvaluatedToAmbig","","Evaluation is known to be ambiguous - it might hold for some assignment of inference variables, but it might not.",589,N],[13,"EvaluatedToUnknown","","Evaluation failed because of recursion involving inference variables. We are somewhat imprecise there, so we don't actually know the real result.",589,N],[13,"EvaluatedToRecur","","Evaluation failed because we encountered an obligation we are already trying to prove on this branch.",589,N],[13,"EvaluatedToErr","","Evaluation failed",589,N],[11,"clone","rustc::traits","",590,[[["self"]],["intercrateambiguitycause"]]],[11,"fmt","","",590,[[["self"],["formatter"]],["result"]]],[11,"add_intercrate_ambiguity_hint","","Emits notes when the overlap is caused by complex intercrate ambiguities. See #23980 for details.",590,[[["self"],["diagnosticbuilder"]]]],[11,"intercrate_ambiguity_hint","","",590,[[["self"]],["string"]]],[11,"clone","","",569,[[["self"]],["selectioncache"]]],[11,"eq","rustc::traits::select","",634,[[["self"],["selectioncandidate"]],["bool"]]],[11,"ne","","",634,[[["self"],["selectioncandidate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",634,N],[11,"fmt","","",634,[[["self"],["formatter"]],["result"]]],[11,"clone","","",634,[[["self"]],["selectioncandidate"]]],[11,"lift_to_tcx","","",634,[[["self"],["tyctxt"]],["option"]]],[11,"eq","","",631,[[["self"],["evaluatedcandidate"]],["bool"]]],[11,"ne","","",631,[[["self"],["evaluatedcandidate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",631,N],[11,"fmt","","",631,[[["self"],["formatter"]],["result"]]],[11,"clone","","",631,[[["self"]],["evaluatedcandidate"]]],[11,"clone","rustc::traits","",589,[[["self"]],["evaluationresult"]]],[11,"fmt","","",589,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",589,[[["self"],["evaluationresult"]],["option",["ordering"]]]],[11,"cmp","","",589,[[["self"],["evaluationresult"]],["ordering"]]],[11,"eq","","",589,[[["self"],["evaluationresult"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",589,N],[11,"may_apply","","",589,[[["self"]],["bool"]]],[11,"is_stack_dependent","","",589,[[["self"]],["bool"]]],[11,"hash_stable","","",589,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",636,[[["self"]],["overflowerror"]]],[11,"fmt","","",636,[[["self"],["formatter"]],["result"]]],[11,"eq","","",636,[[["self"],["overflowerror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",636,N],[11,"hash_stable","","",636,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"from","","",601,[[["overflowerror"]],["selectionerror"]]],[11,"clone","","",567,[[["self"]],["evaluationcache"]]],[11,"new","","",568,[[["inferctxt"]],["selectioncontext"]]],[11,"intercrate","","",568,[[["inferctxt"],["intercratemode"]],["selectioncontext"]]],[11,"with_negative","","",568,[[["inferctxt"],["bool"]],["selectioncontext"]]],[11,"with_query_mode","","",568,[[["inferctxt"],["traitquerymode"]],["selectioncontext"]]],[11,"enable_tracking_intercrate_ambiguity_causes","","Enables tracking of intercrate ambiguity causes. These are used in coherence to give improved diagnostics. We don't do this until we detect a coherence error because it can lead to false overflow results (#47139) and because it costs computation time.",568,[[["self"]]]],[11,"take_intercrate_ambiguity_causes","","Gets the intercrate ambiguity causes collected since tracking was enabled and disables tracking at the same time. If tracking is not enabled, just returns an empty vector.",568,[[["self"]],["vec",["intercrateambiguitycause"]]]],[11,"infcx","","",568,[[["self"]],["inferctxt"]]],[11,"tcx","","",568,[[["self"]],["tyctxt"]]],[11,"closure_typer","","",568,[[["self"]],["inferctxt"]]],[11,"in_snapshot","","Wraps the inference context's in_snapshot s.t. snapshot handling is only from the selection context's self.",568,[[["self"],["f"]],["r"]]],[11,"probe","","Wraps a probe s.t. obligations collected during it are ignored and old obligations are retained.",568,[[["self"],["f"]],["r"]]],[11,"commit_if_ok","","Wraps a commit_if_ok s.t. obligations collected during it are not returned in selection if the transaction fails and s.t. old obligations are retained.",568,[[["self"],["f"]],["result"]]],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding type environment by performing unification.",568,[[["self"],["traitobligation"]],["selectionresult",["selection"]]]],[11,"predicate_may_hold_fatal","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",568,[[["self"],["predicateobligation"]],["bool"]]],[11,"evaluate_obligation_recursively","","Evaluates whether the obligation `obligation` can be satisfied and returns an `EvaluationResult`.",568,[[["self"],["predicateobligation"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_predicates_recursively","","Evaluates the predicates in `predicates` recursively. Note that this applies projections in the predicates, and therefore is run within an inference probe.",568,[[["self"],["traitobligationstacklist"],["i"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_predicate_recursively","","",568,[[["self"],["traitobligationstacklist"],["predicateobligation"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_trait_predicate_recursively","","",568,[[["self"],["traitobligationstacklist"],["traitobligation"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_stack","","",568,[[["self"],["traitobligationstack"]],["result",["evaluationresult","overflowerror"]]]],[11,"coinductive_match","","For defaulted traits, we use a co-inductive strategy to solve, so that recursion is ok. This routine returns true if the top of the stack (`cycle[0]`):",568,[[["self"],["i"]],["bool"]]],[11,"coinductive_predicate","","",568,[[["self"],["predicate"]],["bool"]]],[11,"evaluate_candidate","","Further evaluate `candidate` to decide whether all type parameters match and whether nested obligations are met. Returns true if `candidate` remains viable after this further scrutiny.",568,[[["self"],["traitobligationstack"],["selectioncandidate"]],["result",["evaluationresult","overflowerror"]]]],[11,"check_evaluation_cache","","",568,[[["self"],["paramenv"],["polytraitref"]],["option",["evaluationresult"]]]],[11,"insert_evaluation_cache","","",568,[[["self"],["paramenv"],["polytraitref"],["depnodeindex"],["evaluationresult"]]]],[11,"candidate_from_obligation","","",568,[[["self"],["traitobligationstack"]],["selectionresult",["selectioncandidate"]]]],[11,"in_task","","",568,N],[11,"filter_negative_impls","","",568,[[["self"],["selectioncandidate"]],["selectionresult",["selectioncandidate"]]]],[11,"candidate_from_obligation_no_cache","","",568,[[["self"],["traitobligationstack"]],["selectionresult",["selectioncandidate"]]]],[11,"is_knowable","","",568,[[["self"],["traitobligationstack"]],["option",["conflict"]]]],[11,"can_use_global_caches","","Returns true if the global caches can be used. Do note that if the type itself is not in the global tcx, the local caches will be used.",568,[[["self"],["paramenv"]],["bool"]]],[11,"check_candidate_cache","","",568,[[["self"],["paramenv"],["polytraitpredicate"]],["option",["selectionresult"]]]],[11,"insert_candidate_cache","","",568,[[["self"],["paramenv"],["polytraitpredicate"],["depnodeindex"],["selectionresult",["selectioncandidate"]]]]],[11,"assemble_candidates","","",568,[[["self"],["traitobligationstack"]],["result",["selectioncandidateset","selectionerror"]]]],[11,"assemble_candidates_from_projected_tys","","",568,[[["self"],["traitobligation"],["selectioncandidateset"]]]],[11,"match_projection_obligation_against_definition_bounds","","",568,[[["self"],["traitobligation"],["combinedsnapshot"]],["bool"]]],[11,"match_projection","","",568,[[["self"],["traitobligation"],["polytraitref"],["traitref"],["skolemizationmap"],["combinedsnapshot"]],["bool"]]],[11,"assemble_candidates_from_caller_bounds","","Given an obligation like `<SomeTrait for T>`, search the obligations that the caller supplied to find out whether it is listed among them.",568,[[["self"],["traitobligationstack"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"evaluate_where_clause","","",568,[[["self"],["traitobligationstack"],["polytraitref"]],["result",["evaluationresult","overflowerror"]]]],[11,"assemble_generator_candidates","","",568,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_closure_candidates","","Check for the artificial impl that the compiler will create for an obligation like `X : FnMut<..>` where `X` is a closure type.",568,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_fn_pointer_candidates","","Implement one of the `Fn()` family for a fn pointer.",568,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_candidates_from_impls","","Search for impls that might apply to `obligation`.",568,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_candidates_from_auto_impls","","",568,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_candidates_from_object_ty","","Search for impls that might apply to `obligation`.",568,[[["self"],["traitobligation"],["selectioncandidateset"]]]],[11,"assemble_candidates_for_unsizing","","Search for unsizing that might apply to `obligation`.",568,[[["self"],["traitobligation"],["selectioncandidateset"]]]],[11,"candidate_should_be_dropped_in_favor_of","","Returns true if `victim` should be dropped in favor of `other`.  Generally speaking we will drop duplicate candidates and prefer where-clause candidates.",568,[[["self"],["evaluatedcandidate"],["evaluatedcandidate"]],["bool"]]],[11,"assemble_builtin_bound_candidates","","",568,[[["self"],["builtinimplconditions"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"sized_conditions","","",568,[[["self"],["traitobligation"]],["builtinimplconditions"]]],[11,"copy_clone_conditions","","",568,[[["self"],["traitobligation"]],["builtinimplconditions"]]],[11,"constituent_types_for_ty","","For default impls, we need to break apart a type into its \"constituent types\" -- meaning, the types that it contains.",568,[[["self"],["ty"]],["vec",["ty"]]]],[11,"collect_predicates_for_types","","",568,[[["self"],["paramenv"],["obligationcause"],["usize"],["defid"],["binder",["vec"]]],["vec",["predicateobligation"]]]],[11,"confirm_candidate","","",568,[[["self"],["traitobligation"],["selectioncandidate"]],["result",["selection","selectionerror"]]]],[11,"confirm_projection_candidate","","",568,[[["self"],["traitobligation"]]]],[11,"confirm_param_candidate","","",568,[[["self"],["traitobligation"],["polytraitref"]],["vec",["predicateobligation"]]]],[11,"confirm_builtin_candidate","","",568,[[["self"],["traitobligation"],["bool"]],["vtablebuiltindata",["predicateobligation"]]]],[11,"confirm_auto_impl_candidate","","This handles the case where a `auto trait Foo` impl is being used. The idea is that the impl applies to `X : Foo` if the following conditions are met:",568,[[["self"],["traitobligation"],["defid"]],["vtableautoimpldata",["predicateobligation"]]]],[11,"vtable_auto_impl","","See `confirm_auto_impl_candidate`",568,[[["self"],["traitobligation"],["defid"],["binder",["vec"]]],["vtableautoimpldata",["predicateobligation"]]]],[11,"confirm_impl_candidate","","",568,[[["self"],["traitobligation"],["defid"]],["vtableimpldata",["predicateobligation"]]]],[11,"vtable_impl","","",568,[[["self"],["defid"],["normalized",["substs"]],["obligationcause"],["usize"],["paramenv"],["skolemizationmap"],["combinedsnapshot"]],["vtableimpldata",["predicateobligation"]]]],[11,"confirm_object_candidate","","",568,[[["self"],["traitobligation"]],["vtableobjectdata",["predicateobligation"]]]],[11,"confirm_fn_pointer_candidate","","",568,[[["self"],["traitobligation"]],["result",["vtablefnpointerdata","selectionerror"]]]],[11,"confirm_generator_candidate","","",568,[[["self"],["traitobligation"]],["result",["vtablegeneratordata","selectionerror"]]]],[11,"confirm_closure_candidate","","",568,[[["self"],["traitobligation"]],["result",["vtableclosuredata","selectionerror"]]]],[11,"confirm_poly_trait_refs","","In the case of closure types and fn pointers, we currently treat the input type parameters on the trait as outputs. This means that when we have a match we have only considered the self type, so we have to go back and make sure to relate the argument types too.  This is kind of wrong, but since we control the full set of impls, also not that wrong, and it DOES yield better error messages (since we don't report errors as if there is no applicable impl, but rather report errors are about mismatched argument types.",568,[[["self"],["obligationcause"],["paramenv"],["polytraitref"],["polytraitref"]],["result",["vec","selectionerror"]]]],[11,"confirm_builtin_unsize_candidate","","",568,[[["self"],["traitobligation"]],["result",["vtablebuiltindata","selectionerror"]]]],[11,"rematch_impl","","",568,N],[11,"match_impl","","",568,[[["self"],["defid"],["traitobligation"],["combinedsnapshot"]],["result"]]],[11,"fast_reject_trait_refs","","",568,[[["self"],["traitobligation"],["traitref"]],["bool"]]],[11,"match_where_clause_trait_ref","","Normalize `where_clause_trait_ref` and try to match it against `obligation`.  If successful, return any predicates that result from the normalization. Normalization is necessary because where-clauses are stored in the parameter environment unnormalized.",568,[[["self"],["traitobligation"],["polytraitref"]],["result",["vec"]]]],[11,"match_poly_trait_ref","","Returns `Ok` if `poly_trait_ref` being true implies that the obligation is satisfied.",568,[[["self"],["traitobligation"],["polytraitref"]],["result",["vec"]]]],[11,"match_fresh_trait_refs","","",568,[[["self"],["polytraitref"],["polytraitref"]],["bool"]]],[11,"push_stack","","",568,[[["self"],["traitobligationstacklist"],["traitobligation"]],["traitobligationstack"]]],[11,"closure_trait_ref_unnormalized","","",568,[[["self"],["traitobligation"],["defid"],["closuresubsts"]],["polytraitref"]]],[11,"generator_trait_ref_unnormalized","","",568,[[["self"],["traitobligation"],["defid"],["generatorsubsts"]],["polytraitref"]]],[11,"impl_or_trait_obligations","","Returns the obligations that are implied by instantiating an impl or trait. The obligations are substituted and fully normalized. This is used when confirming an impl or default impl.",568,[[["self"],["obligationcause"],["usize"],["paramenv"],["defid"],["substs"],["skolemizationmap"],["combinedsnapshot"]],["vec",["predicateobligation"]]]],[11,"new","","",569,[[],["selectioncache"]]],[11,"clear","","",569,[[["self"]]]],[11,"new","","",567,[[],["evaluationcache"]]],[11,"clear","","",567,[[["self"]]]],[11,"list","rustc::traits::select","",629,[[["self"]],["traitobligationstacklist"]]],[11,"iter","","",629,[[["self"]],["traitobligationstacklist"]]],[11,"clone","","",632,[[["self"]],["traitobligationstacklist"]]],[11,"empty","","",632,[[],["traitobligationstacklist"]]],[11,"with","","",632,[[["traitobligationstack"]],["traitobligationstacklist"]]],[11,"next","","",632,[[["self"]],["option",["traitobligationstack"]]]],[11,"fmt","","",629,[[["self"],["formatter"]],["result"]]],[11,"clone","","",633,[[["self"]],["withdepnode"]]],[11,"assert_receiver_is_total_eq","","",633,N],[11,"eq","","",633,[[["self"],["withdepnode"]],["bool"]]],[11,"ne","","",633,[[["self"],["withdepnode"]],["bool"]]],[11,"new","","",633,[[["depnodeindex"],["t"]],["self"]]],[11,"get","","",633,[[["self"],["tyctxt"]],["t"]]],[0,"specialize","rustc::traits","Logic and data structures related to impl specialization, explained in greater detail below.",N,N],[3,"OverlapError","rustc::traits::specialize","Information pertinent to an overlapping impl error.",N,N],[12,"with_impl","","",570,N],[12,"trait_desc","","",570,N],[12,"self_desc","","",570,N],[12,"intercrate_ambiguity_causes","","",570,N],[3,"SpecializesCache","","",N,N],[12,"map","","",571,N],[5,"translate_substs","","Given a subst for the requested impl, translate it to a subst appropriate for the actual item definition (whether it be in that impl, a parent impl, or the trait).",N,[[["inferctxt"],["paramenv"],["defid"],["substs"],["node"]],["substs"]]],[5,"find_associated_item","","Given a selected impl described by `impl_data`, returns the definition and substitutions for the method with the name `name` the kind `kind`, and trait method substitutions `substs`, in that impl, a less specialized impl, or the trait default, whichever applies.",N,N],[5,"specializes","","Is impl1 a specialization of impl2?",N,N],[5,"fulfill_implication","","Attempt to fulfill all obligations of `target_impl` after unification with `source_trait_ref`. If successful, returns a substitution for all the generics of `target_impl`, including both those needed to unify with `source_trait_ref` and those whose identity is determined via a where clause in the impl.",N,[[["inferctxt"],["paramenv"],["traitref"],["defid"]],["result",["substs"]]]],[5,"specialization_graph_provider","","",N,[[["tyctxt"],["defid"]],["lrc",["graph"]]]],[5,"to_pretty_impl_header","","Recovers the \"impl X for Y\" signature from `impl_def_id` and returns it as a string.",N,[[["tyctxt"],["defid"]],["option",["string"]]]],[0,"specialization_graph","","",N,N],[3,"Graph","rustc::traits::specialize::specialization_graph","A per-trait graph of impls in specialization order. At the moment, this graph forms a tree rooted with the trait itself, with all other nodes representing impls, and parent-child relationships representing specializations.",N,N],[12,"parent","","",604,N],[12,"children","","",604,N],[3,"Children","","Children of a given impl, grouped into blanket/non-blanket varieties as is done in `TraitDef`.",N,N],[12,"nonblanket_impls","","Impls of the trait.",637,N],[12,"blanket_impls","","Blanket impls associated with the trait.",637,N],[3,"Ancestors","","",N,N],[12,"trait_def_id","","",605,N],[12,"specialization_graph","","",605,N],[12,"current_source","","",605,N],[3,"NodeItem","","",N,N],[12,"node","","",606,N],[12,"item","","",606,N],[4,"Inserted","","The result of attempting to insert an impl into a group of children.",N,N],[13,"BecameNewSibling","","The impl was inserted as a new child in this group of children.",638,N],[13,"ReplaceChild","","The impl should replace an existing impl X, because the impl specializes X.",638,N],[13,"ShouldRecurseOn","","The impl is a specialization of an existing child.",638,N],[4,"Node","","A node in the specialization graph is either an impl or a trait definition; either can serve as a source of item definitions. There is always exactly one trait definition node: the root.",N,N],[13,"Impl","","",607,N],[13,"Trait","","",607,N],[5,"ancestors","","Walk up the specialization ancestors of a given impl, starting with that impl itself.",N,[[["tyctxt"],["defid"],["defid"]],["ancestors"]]],[22,"","","",N,N],[22,"","","",N,N],[11,"encode","rustc::traits::specialization_graph","",604,[[["self"],["__s"]],["result"]]],[11,"decode","","",604,[[["__d"]],["result",["graph"]]]],[11,"encode","rustc::traits::specialize::specialization_graph","",637,[[["self"],["__s"]],["result"]]],[11,"decode","","",637,[[["__d"]],["result",["children"]]]],[11,"new","","",637,[[],["children"]]],[11,"insert_blindly","","Insert an impl into this set of children without comparing to any existing impls",637,[[["self"],["tyctxt"],["defid"]]]],[11,"remove_existing","","Remove an impl from this set of children. Used when replacing an impl with a parent. The impl must be present in the list of children already.",637,[[["self"],["tyctxt"],["defid"]]]],[11,"insert","","Attempt to insert an impl into this set of children, while comparing for specialization relationships.",637,[[["self"],["tyctxt"],["defid"],["option",["simplifiedtype"]]],["result",["inserted","overlaperror"]]]],[11,"iter","","",637,[[["self"]],["box",["iterator"]]]],[11,"filtered","","",637,[[["self"],["simplifiedtype"]],["box",["iterator"]]]],[11,"new","rustc::traits::specialization_graph","",604,[[],["graph"]]],[11,"insert","","Insert a local impl into the specialization graph. If an existing impl conflicts with it (has overlap, but neither specializes the other), information about the area of overlap is returned in the `Err`.",604,[[["self"],["tyctxt"],["defid"]],["result",["option","overlaperror"]]]],[11,"record_impl_from_cstore","","Insert cached metadata mapping from a child impl back to its parent.",604,[[["self"],["tyctxt"],["defid"],["defid"]]]],[11,"parent","","The parent of a given impl, which is the def id of the trait when the impl is a \"specialization root\".",604,[[["self"],["defid"]],["defid"]]],[11,"fmt","","",607,[[["self"],["formatter"]],["result"]]],[11,"clone","","",607,[[["self"]],["node"]]],[11,"is_from_trait","","",607,[[["self"]],["bool"]]],[11,"items","","Iterate over the items defined directly by the given (impl or trait) node.",607,[[["self"],["tyctxt"]],[""]]],[11,"def_id","","",607,[[["self"]],["defid"]]],[11,"next","","",605,[[["self"]],["option",["node"]]]],[11,"map","","",606,[[["self"],["f"]],["nodeitem"]]],[11,"defs","","Search the items from the given ancestors, returning each definition with the given name and the given kind.",605,[[["self"],["tyctxt"],["ident"],["associatedkind"],["defid"]],[""]]],[11,"hash_stable","rustc::traits::specialize::specialization_graph","",637,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::traits::specialization_graph","",604,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","rustc::traits","",571,[[],["self"]]],[11,"check","","",571,[[["self"],["defid"],["defid"]],["option",["bool"]]]],[11,"insert","","",571,[[["self"],["defid"],["defid"],["bool"]]]],[0,"structural_impls","","",N,N],[11,"fmt","","",564,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",573,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",603,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",578,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",579,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",580,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",582,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",581,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",583,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",584,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",577,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",602,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",561,[[["self"],["formatter"]],["result"]]],[11,"lift_to_tcx","","",601,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",593,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",575,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",574,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",603,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",573,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",573,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",578,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",578,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",579,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",579,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",580,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",580,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",581,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",581,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",582,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",582,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",583,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",583,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",584,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",584,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",603,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",603,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",564,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",564,[[["self"],["v"]],["bool"]]],[11,"fmt","","",594,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",595,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",596,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",597,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",598,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",599,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",576,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",600,[[["self"],["formatter"]],["result"]]],[11,"super_fold_with","","",594,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",594,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",594,[[["self"],["tyctxt"]],["option",["whereclause"]]]],[11,"super_fold_with","","",595,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",595,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",595,[[["self"],["tyctxt"]],["option",["wellformed"]]]],[11,"super_fold_with","","",596,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",596,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",596,[[["self"],["tyctxt"]],["option",["fromenv"]]]],[11,"super_fold_with","","",597,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",597,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",597,[[["self"],["tyctxt"]],["option",["domaingoal"]]]],[11,"super_fold_with","","",598,[[["self"],["f"]],["quantifierkind"]]],[11,"super_visit_with","","",598,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",598,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",599,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",599,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",599,[[["self"],["tyctxt"]],["option",["goal"]]]],[11,"super_fold_with","","",576,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",576,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",600,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",600,[[["self"],["v"]],["bool"]]],[0,"codegen","","",N,N],[3,"TraitSelectionCache","rustc::traits::codegen","",N,N],[12,"data","","",639,N],[3,"ProjectionCache","","",N,N],[12,"data","","",640,N],[5,"codegen_fulfill_obligation","","Attempts to resolve an obligation to a vtable.. The result is a shallow vtable resolution -- meaning that we do not (necessarily) resolve all nested obligations on the impl. Note that type check should guarantee to us that all nested obligations could be resolved if we wanted to. Assumes that this is run after the entire crate has been successfully type-checked.",N,N],[11,"to_dep_kind","","",639,[[],["depkind"]]],[11,"to_dep_kind","","",640,[[],["depkind"]]],[11,"drain_fulfillment_cx_or_panic","rustc::infer","Finishes processes any obligations that remain in the fulfillment context, and then returns the result with all type variables removed and regions erased. Because this is intended for use after type-check has completed, if any errors occur, it will panic. It is used during normalization and other cases where processing the obligations in `fulfill_cx` may cause type inference variables that appear in `result` to be unified, and hence we need to process those obligations to get the complete picture of the type.",208,N],[0,"util","rustc::traits","",N,N],[3,"PredicateSet","rustc::traits::util","",N,N],[12,"tcx","","",641,N],[12,"set","","",641,N],[3,"Elaborator","","\"Elaboration\" is the process of identifying all the predicates that are implied by a source predicate. Currently this basically means walking the \"supertraits\" and other similar assumptions. For example, if we know that `T : Ord`, the elaborator would deduce that `T : PartialOrd` holds as well. Similarly, if we have `trait Foo : 'static`, and we know that `T : Foo`, then we know that `T : 'static`.",N,N],[12,"stack","","",642,N],[12,"visited","","",642,N],[3,"SupertraitDefIds","","",N,N],[12,"tcx","","",572,N],[12,"stack","","",572,N],[12,"visited","","",572,N],[3,"FilterToTraits","","A filter around an iterator of predicates that makes it yield up just trait references.",N,N],[12,"base_iterator","","",643,N],[4,"TupleArgumentsFlag","","",N,N],[13,"Yes","","",644,N],[13,"No","","",644,N],[5,"anonymize_predicate","","",N,[[["tyctxt"],["predicate"]],["predicate"]]],[5,"elaborate_trait_ref","","",N,[[["tyctxt"],["polytraitref"]],["elaborator"]]],[5,"elaborate_trait_refs","","",N,N],[5,"elaborate_predicates","","",N,[[["tyctxt"],["vec",["predicate"]]],["elaborator"]]],[5,"supertraits","","",N,[[["tyctxt"],["polytraitref"]],["supertraits"]]],[5,"transitive_bounds","","",N,N],[5,"supertrait_def_ids","","",N,[[["tyctxt"],["defid"]],["supertraitdefids"]]],[5,"impl_trait_ref_and_oblig","","Instantiate all bound parameters of the impl with the given substs, returning the resulting trait ref and all obligations that arise. The obligations are closed under normalization.",N,N],[5,"predicates_for_generics","","See `super::obligations_for_generics`",N,[[["obligationcause"],["usize"],["paramenv"],["instantiatedpredicates"]],["vec",["predicateobligation"]]]],[5,"predicate_for_trait_ref","","",N,[[["obligationcause"],["paramenv"],["traitref"],["usize"]],["predicateobligation"]]],[6,"Supertraits","","",N,N],[11,"new","","",641,[[["tyctxt"]],["predicateset"]]],[11,"insert","","",641,[[["self"],["predicate"]],["bool"]]],[11,"filter_to_traits","","",642,[[["self"]],["filtertotraits"]]],[11,"push","","",642,[[["self"],["predicate"]]]],[11,"next","","",642,[[["self"]],["option",["predicate"]]]],[11,"next","rustc::traits","",572,[[["self"]],["option",["defid"]]]],[11,"new","rustc::traits::util","",643,[[["i"]],["filtertotraits"]]],[11,"next","","",643,[[["self"]],["option",["polytraitref"]]]],[11,"size_hint","","",643,N],[0,"query","rustc::traits","Experimental types for the trait query interface. The methods defined in this module are all based on canonicalization, which makes a canonical query by replacing unbound inference variables and regions, so that results can be reused more broadly. The providers for the queries defined here can be found in `librustc_traits`.",N,N],[3,"NoSolution","rustc::traits::query","",N,N],[0,"dropck_outlives","","",N,N],[3,"DropckOutlivesResult","rustc::traits::query::dropck_outlives","",N,N],[12,"kinds","","",645,N],[12,"overflows","","",645,N],[3,"DtorckConstraint","","A set of constraints that need to be satisfied in order for a type to be valid for destruction.",N,N],[12,"outlives","","Types that are required to be alive in order for this type to be valid for destruction.",646,N],[12,"dtorck_types","","Types that could not be resolved: projections and params.",646,N],[12,"overflows","","If, during the computation of the dtorck constraint, we overflow, that gets recorded here. The caller is expected to report an error.",646,N],[5,"trivial_dropck_outlives","","This returns true if the type `ty` is \"trivial\" for dropck-outlives -- that is, if it doesn't require any types to outlive. This is similar but not quite the same as the `needs_drop` test in the compiler already -- that is, for every type T for which this function return true, needs-drop would return false. But the reverse does not hold: in particular, `needs_drop` returns false for `PhantomData`, but it is not trivial for dropck-outlives.",N,[[["tyctxt"],["ty"]],["bool"]]],[11,"dropck_outlives","rustc::infer::at","Given a type `ty` of some value being dropped, computes a set of \"kinds\" (types, regions) that must be outlive the execution of the destructor. These basically correspond to data that the destructor might access. This is used during regionck to impose \"outlives\" constraints on any lifetimes referenced within.",223,[[["self"],["ty"]],["inferok",["vec"]]]],[11,"clone","rustc::traits::query::dropck_outlives","",645,[[["self"]],["dropckoutlivesresult"]]],[11,"fmt","","",645,[[["self"],["formatter"]],["result"]]],[11,"default","","",645,[[],["dropckoutlivesresult"]]],[11,"report_overflows","","",645,[[["self"],["tyctxt"],["span"],["ty"]]]],[11,"into_kinds_reporting_overflows","","",645,[[["self"],["tyctxt"],["span"],["ty"]],["vec",["kind"]]]],[11,"clone","","",646,[[["self"]],["dtorckconstraint"]]],[11,"fmt","","",646,[[["self"],["formatter"]],["result"]]],[11,"empty","","",646,[[],["dtorckconstraint"]]],[11,"from_iter","","",646,[[["i"]],["self"]]],[11,"super_fold_with","","",645,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",645,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",645,[[["self"],["tyctxt"]],["option",["dropckoutlivesresult"]]]],[11,"hash_stable","","",645,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",646,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"evaluate_obligation","rustc::traits::query","",N,N],[11,"predicate_may_hold","rustc::infer","Evaluates whether the predicate can be satisfied (by any means) in the given `ParamEnv`.",208,[[["self"],["predicateobligation"]],["bool"]]],[11,"predicate_must_hold","","Evaluates whether the predicate can be satisfied in the given `ParamEnv`, and returns `false` if not certain. However, this is not entirely accurate if inference variables are involved.",208,[[["self"],["predicateobligation"]],["bool"]]],[11,"evaluate_obligation","","",208,[[["self"],["predicateobligation"]],["evaluationresult"]]],[0,"normalize","rustc::traits::query","Code for the 'normalization' query. This consists of a wrapper which folds deeply, invoking the underlying `normalize_projection_ty` query when it encounters projections.",N,N],[3,"NormalizationResult","rustc::traits::query::normalize","Result from the `normalize_projection_ty` query.",N,N],[12,"normalized_ty","","Result of normalization.",647,N],[3,"QueryNormalizer","","",N,N],[12,"infcx","","",648,N],[12,"cause","","",648,N],[12,"param_env","","",648,N],[12,"obligations","","",648,N],[12,"error","","",648,N],[12,"anon_depth","","",648,N],[11,"normalize","rustc::infer::at","Normalize `value` in the context of the inference context, yielding a resulting type, or an error if `value` cannot be normalized. If you don't care about regions, you should prefer `normalize_erasing_regions`, which is more efficient.",223,[[["self"],["t"]],["result",["normalized","nosolution"]]]],[11,"clone","rustc::traits::query::normalize","",647,[[["self"]],["normalizationresult"]]],[11,"fmt","","",647,[[["self"],["formatter"]],["result"]]],[11,"tcx","","",648,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",648,[[["self"],["ty"]],["ty"]]],[11,"fold_const","","",648,[[["self"],["const"]],["const"]]],[11,"super_fold_with","","",647,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",647,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",647,[[["self"],["tyctxt"]],["option",["normalizationresult"]]]],[11,"hash_stable","","",647,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"normalize_erasing_regions","rustc::traits::query","Methods for normalizing when you don't care about regions (and aren't doing type inference). If either of those things don't apply to you, use `infcx.normalize(...)`.",N,N],[3,"NormalizeAfterErasingRegionsFolder","rustc::traits::query::normalize_erasing_regions","",N,N],[12,"tcx","","",649,N],[12,"param_env","","",649,N],[11,"tcx","","",649,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",649,[[["self"],["ty"]],["ty"]]],[0,"outlives_bounds","rustc::traits::query","",N,N],[4,"OutlivesBound","rustc::traits::query::outlives_bounds","Outlives bounds are relationships between generic parameters, whether they both be regions (`'a: 'b`) or whether types are involved (`T: 'a`).  These relationships can be extracted from the full set of predicates we understand or also from types (in which case they are called implied bounds). They are fed to the `OutlivesEnv` which in turn is supplied to the region checker and other parts of the inference system.",N,N],[13,"RegionSubRegion","","",650,N],[13,"RegionSubParam","","",650,N],[13,"RegionSubProjection","","",650,N],[5,"explicit_outlives_bounds","","",N,[[["paramenv"]],[""]]],[22,"","","",N,N],[11,"clone","","",650,[[["self"]],["outlivesbound"]]],[11,"fmt","","",650,[[["self"],["formatter"]],["result"]]],[11,"lift_to_tcx","","",650,[[["self"],["tyctxt"]],["option",["outlivesbound"]]]],[11,"super_fold_with","","",650,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",650,[[["self"],["v"]],["bool"]]],[11,"hash_stable","","",650,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"implied_outlives_bounds","rustc::infer","Implied bounds are region relationships that we deduce automatically.  The idea is that (e.g.) a caller must check that a function's argument types are well-formed immediately before calling that fn, and hence the callee can assume that its argument types are well-formed. This may imply certain relationships between generic parameters. For example:",208,[[["self"],["paramenv"],["nodeid"],["ty"],["span"]],["vec",["outlivesbound"]]]],[0,"type_op","rustc::traits::query","",N,N],[0,"custom","rustc::traits::query::type_op","",N,N],[3,"CustomTypeOp","rustc::traits::query::type_op::custom","",N,N],[12,"closure","","",651,N],[12,"description","","",651,N],[5,"scrape_region_constraints","","Executes `op` and then scrapes out all the \"old style\" region constraints that result, creating query-region-constraints.",N,N],[11,"new","","",651,[[["f"],["g"]],["self"]]],[11,"fully_perform","","Processes the operation and all resulting obligations, returning the final result along with any region constraints (they will be given over to the NLL region solver).",651,[[["self"],["inferctxt"]],["fallible"]]],[11,"fmt","","",651,[[["self"],["formatter"]],["result"]]],[0,"eq","rustc::traits::query::type_op","",N,N],[3,"Eq","rustc::traits::query::type_op::eq","",N,N],[12,"a","","",652,N],[12,"b","","",652,N],[11,"clone","","",652,[[["self"]],["eq"]]],[11,"fmt","","",652,[[["self"],["formatter"]],["result"]]],[11,"hash","","",652,N],[11,"eq","","",652,[[["self"],["eq"]],["bool"]]],[11,"ne","","",652,[[["self"],["eq"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",652,N],[11,"new","","",652,[[["ty"],["ty"]],["self"]]],[11,"try_fast_path","","",652,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",652,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",652,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",652,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",652,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",652,[[["self"],["tyctxt"]],["option",["eq"]]]],[11,"hash_stable","","",652,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"normalize","rustc::traits::query::type_op","",N,N],[3,"Normalize","rustc::traits::query::type_op::normalize","",N,N],[12,"value","","",653,N],[8,"Normalizable","","",N,N],[10,"type_op_method","","",654,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[10,"shrink_to_tcx_lifetime","","Convert from the `'gcx` (lifted) form of `Self` into the `tcx` form of `Self`.",654,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"clone","","",653,[[["self"]],["normalize"]]],[11,"fmt","","",653,[[["self"],["formatter"]],["result"]]],[11,"hash","","",653,N],[11,"eq","","",653,[[["self"],["normalize"]],["bool"]]],[11,"ne","","",653,[[["self"],["normalize"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",653,N],[11,"new","","",653,[[["t"]],["self"]]],[11,"try_fast_path","","",653,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",653,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",653,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",653,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",653,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",653,[[["self"],["tyctxt"]],["option",["normalize"]]]],[11,"hash_stable","","",653,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"outlives","rustc::traits::query::type_op","",N,N],[3,"DropckOutlives","rustc::traits::query::type_op::outlives","",N,N],[12,"dropped_ty","","",655,N],[11,"clone","","",655,[[["self"]],["dropckoutlives"]]],[11,"fmt","","",655,[[["self"],["formatter"]],["result"]]],[11,"new","","",655,[[["ty"]],["self"]]],[11,"try_fast_path","","",655,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",655,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",655,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",655,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",655,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",655,[[["self"],["tyctxt"]],["option",["dropckoutlives"]]]],[11,"hash_stable","","",655,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"prove_predicate","rustc::traits::query::type_op","",N,N],[3,"ProvePredicate","rustc::traits::query::type_op::prove_predicate","",N,N],[12,"predicate","","",656,N],[11,"clone","","",656,[[["self"]],["provepredicate"]]],[11,"fmt","","",656,[[["self"],["formatter"]],["result"]]],[11,"hash","","",656,N],[11,"eq","","",656,[[["self"],["provepredicate"]],["bool"]]],[11,"ne","","",656,[[["self"],["provepredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",656,N],[11,"new","","",656,[[["predicate"]],["self"]]],[11,"try_fast_path","","",656,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",656,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",656,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",656,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",656,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",656,[[["self"],["tyctxt"]],["option",["provepredicate"]]]],[11,"hash_stable","","",656,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"subtype","rustc::traits::query::type_op","",N,N],[3,"Subtype","rustc::traits::query::type_op::subtype","",N,N],[12,"sub","","",657,N],[12,"sup","","",657,N],[11,"clone","","",657,[[["self"]],["subtype"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"hash","","",657,N],[11,"eq","","",657,[[["self"],["subtype"]],["bool"]]],[11,"ne","","",657,[[["self"],["subtype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",657,N],[11,"new","","",657,[[["ty"],["ty"]],["self"]]],[11,"try_fast_path","","",657,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",657,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",657,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",657,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",657,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",657,[[["self"],["tyctxt"]],["option",["subtype"]]]],[11,"hash_stable","","",657,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[8,"TypeOp","rustc::traits::query::type_op","\"Type ops\" are used in NLL to perform some particular action and extract out the resulting region constraints (or an error if it cannot be completed).",N,N],[16,"Output","","",658,N],[10,"fully_perform","","Processes the operation and all resulting obligations, returning the final result along with any region constraints (they will be given over to the NLL region solver).",658,[[["self"],["inferctxt"]],["fallible"]]],[8,"QueryTypeOp","","\"Query type ops\" are type ops that are implemented using a [canonical query][c]. The `Self` type here contains the kernel of information needed to do the operation -- `TypeOp` is actually implemented for `ParamEnvAnd<Self>`, since we always need to bring along a parameter environment as well. For query type-ops, we will first canonicalize the key and then invoke the query on the tcx, which produces the resulting query region constraints.",N,N],[16,"QueryResult","","",659,N],[10,"try_fast_path","","Give query the option for a simple fast path that never actually hits the tcx cache lookup etc. Return `Some(r)` with a final result or `None` to do the full path.",659,[[["tyctxt"],["paramenvand"]],["option"]]],[10,"perform_query","","Performs the actual query with the canonicalized key -- the real work happens here. This method is not given an `infcx` because it shouldn't need one -- and if it had access to one, it might do things like invoke `sub_regions`, which would be bad, because it would create subregion relationships that are not captured in the return value.",659,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[10,"shrink_to_tcx_lifetime","","Casts a lifted query result (which is in the gcx lifetime) into the tcx lifetime. This is always just an identity cast, but the generic code doesn't realize it -- put another way, in the generic code, we have a `Lifted<'gcx, Self::QueryResult>` and we want to convert that to a `Self::QueryResult`. This is not a priori valid, so we can't do it -- but in practice, it is always a no-op (e.g., the lifted form of a type, `Ty<'gcx>`, is a subtype of `Ty<'tcx>`). So we have to push the operation into the impls that know more specifically what `QueryResult` is. This operation would (maybe) be nicer with something like HKTs or GATs, since then we could make `QueryResult` parametric and `'gcx` and `'tcx` etc.",659,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"fully_perform_into","","",659,[[["paramenvand"],["inferctxt"],["vec"]],["fallible"]]],[6,"CanonicalProjectionGoal","rustc::traits::query","",N,N],[6,"CanonicalTyGoal","","",N,N],[6,"CanonicalPredicateGoal","","",N,N],[6,"CanonicalTypeOpEqGoal","","",N,N],[6,"CanonicalTypeOpSubtypeGoal","","",N,N],[6,"CanonicalTypeOpProvePredicateGoal","","",N,N],[6,"CanonicalTypeOpNormalizeGoal","","",N,N],[6,"Fallible","","",N,N],[11,"clone","","",660,[[["self"]],["nosolution"]]],[11,"fmt","","",660,[[["self"],["formatter"]],["result"]]],[11,"eq","","",660,[[["self"],["nosolution"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",660,N],[11,"hash","","",660,N],[11,"from","","",660,[[["typeerror"]],["nosolution"]]],[11,"hash_stable","","",660,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[6,"Supertraits","rustc::traits","",N,N],[6,"PredicateObligation","","",N,N],[6,"TraitObligation","","",N,N],[6,"Obligations","","",N,N],[6,"PredicateObligations","","",N,N],[6,"TraitObligations","","",N,N],[6,"PolyDomainGoal","","",N,N],[6,"Goals","","",N,N],[6,"Clauses","","Multiple clauses.",N,N],[6,"Selection","","",N,N],[6,"SelectionResult","","When performing resolution, it is typically the case that there can be one of three outcomes:",N,N],[8,"TraitEngine","","",N,N],[10,"normalize_projection_type","","",617,[[["self"],["inferctxt"],["paramenv"],["projectionty"],["obligationcause"]],["ty"]]],[10,"register_bound","","",617,[[["self"],["inferctxt"],["paramenv"],["ty"],["defid"],["obligationcause"]]]],[10,"register_predicate_obligation","","",617,[[["self"],["inferctxt"],["predicateobligation"]]]],[10,"select_all_or_error","","",617,[[["self"],["inferctxt"]],["result",["vec"]]]],[10,"select_where_possible","","",617,[[["self"],["inferctxt"]],["result",["vec"]]]],[10,"pending_obligations","","",617,[[["self"]],["vec",["predicateobligation"]]]],[8,"TraitEngineExt","","",N,N],[10,"register_predicate_obligations","","",618,N],[8,"ExClauseFold","","",N,N],[10,"fold_ex_clause_with","","",661,[[["exclause"],["f"]],["exclause"]]],[10,"visit_ex_clause_with","","",661,[[["exclause"],["v"]],["bool"]]],[8,"ExClauseLift","","",N,N],[16,"LiftedExClause","","",662,N],[10,"lift_ex_clause_to_tcx","","",662,[[["exclause"],["tyctxt"]],["option"]]],[11,"clone","","",591,[[["self"]],["intercratemode"]]],[11,"eq","","",591,[[["self"],["intercratemode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",591,N],[11,"fmt","","",591,[[["self"],["formatter"]],["result"]]],[11,"clone","","",592,[[["self"]],["traitquerymode"]]],[11,"eq","","",592,[[["self"],["traitquerymode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",592,N],[11,"fmt","","",592,[[["self"],["formatter"]],["result"]]],[11,"clone","","",573,[[["self"]],["obligation"]]],[11,"eq","","",573,[[["self"],["obligation"]],["bool"]]],[11,"ne","","",573,[[["self"],["obligation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",573,N],[11,"hash","","",573,N],[11,"clone","","",574,[[["self"]],["obligationcause"]]],[11,"fmt","","",574,[[["self"],["formatter"]],["result"]]],[11,"eq","","",574,[[["self"],["obligationcause"]],["bool"]]],[11,"ne","","",574,[[["self"],["obligationcause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",574,N],[11,"hash","","",574,N],[11,"span","","",574,[[["self"],["tyctxt"]],["span"]]],[11,"clone","","",593,[[["self"]],["obligationcausecode"]]],[11,"fmt","","",593,[[["self"],["formatter"]],["result"]]],[11,"eq","","",593,[[["self"],["obligationcausecode"]],["bool"]]],[11,"ne","","",593,[[["self"],["obligationcausecode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",593,N],[11,"hash","","",593,N],[11,"clone","","",575,[[["self"]],["derivedobligationcause"]]],[11,"fmt","","",575,[[["self"],["formatter"]],["result"]]],[11,"eq","","",575,[[["self"],["derivedobligationcause"]],["bool"]]],[11,"ne","","",575,[[["self"],["derivedobligationcause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",575,N],[11,"hash","","",575,N],[11,"clone","","",594,[[["self"]],["whereclause"]]],[11,"eq","","",594,[[["self"],["whereclause"]],["bool"]]],[11,"ne","","",594,[[["self"],["whereclause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",594,N],[11,"hash","","",594,N],[11,"fmt","","",594,[[["self"],["formatter"]],["result"]]],[11,"clone","","",595,[[["self"]],["wellformed"]]],[11,"eq","","",595,[[["self"],["wellformed"]],["bool"]]],[11,"ne","","",595,[[["self"],["wellformed"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",595,N],[11,"hash","","",595,N],[11,"fmt","","",595,[[["self"],["formatter"]],["result"]]],[11,"clone","","",596,[[["self"]],["fromenv"]]],[11,"eq","","",596,[[["self"],["fromenv"]],["bool"]]],[11,"ne","","",596,[[["self"],["fromenv"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",596,N],[11,"hash","","",596,N],[11,"fmt","","",596,[[["self"],["formatter"]],["result"]]],[11,"clone","","",597,[[["self"]],["domaingoal"]]],[11,"eq","","",597,[[["self"],["domaingoal"]],["bool"]]],[11,"ne","","",597,[[["self"],["domaingoal"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",597,N],[11,"hash","","",597,N],[11,"fmt","","",597,[[["self"],["formatter"]],["result"]]],[11,"clone","","",598,[[["self"]],["quantifierkind"]]],[11,"eq","","",598,[[["self"],["quantifierkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",598,N],[11,"hash","","",598,N],[11,"fmt","","",598,[[["self"],["formatter"]],["result"]]],[11,"clone","","",599,[[["self"]],["goal"]]],[11,"eq","","",599,[[["self"],["goal"]],["bool"]]],[11,"ne","","",599,[[["self"],["goal"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",599,N],[11,"hash","","",599,N],[11,"fmt","","",599,[[["self"],["formatter"]],["result"]]],[11,"into_goal","","",597,[[["self"]],["goal"]]],[11,"from_poly_domain_goal","","",599,[[["polydomaingoal"],["tyctxt"]],["goal"]]],[11,"clone","","",600,[[["self"]],["clause"]]],[11,"eq","","",600,[[["self"],["clause"]],["bool"]]],[11,"ne","","",600,[[["self"],["clause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",600,N],[11,"hash","","",600,N],[11,"fmt","","",600,[[["self"],["formatter"]],["result"]]],[11,"clone","","",576,[[["self"]],["programclause"]]],[11,"eq","","",576,[[["self"],["programclause"]],["bool"]]],[11,"ne","","",576,[[["self"],["programclause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",576,N],[11,"hash","","",576,N],[11,"fmt","","",576,[[["self"],["formatter"]],["result"]]],[11,"clone","","",601,[[["self"]],["selectionerror"]]],[11,"fmt","","",601,[[["self"],["formatter"]],["result"]]],[11,"clone","","",602,[[["self"]],["fulfillmenterrorcode"]]],[11,"clone","","",603,[[["self"]],["vtable"]]],[11,"eq","","",603,[[["self"],["vtable"]],["bool"]]],[11,"ne","","",603,[[["self"],["vtable"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",603,N],[11,"encode","","",603,[[["self"],["__sn"]],["result"]]],[11,"decode","","",603,[[["__dn"]],["result",["vtable"]]]],[11,"clone","","",578,[[["self"]],["vtableimpldata"]]],[11,"eq","","",578,[[["self"],["vtableimpldata"]],["bool"]]],[11,"ne","","",578,[[["self"],["vtableimpldata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",578,N],[11,"encode","","",578,[[["self"],["__sn"]],["result"]]],[11,"decode","","",578,[[["__dn"]],["result",["vtableimpldata"]]]],[11,"clone","","",579,[[["self"]],["vtablegeneratordata"]]],[11,"eq","","",579,[[["self"],["vtablegeneratordata"]],["bool"]]],[11,"ne","","",579,[[["self"],["vtablegeneratordata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",579,N],[11,"encode","","",579,[[["self"],["__sn"]],["result"]]],[11,"decode","","",579,[[["__dn"]],["result",["vtablegeneratordata"]]]],[11,"clone","","",580,[[["self"]],["vtableclosuredata"]]],[11,"eq","","",580,[[["self"],["vtableclosuredata"]],["bool"]]],[11,"ne","","",580,[[["self"],["vtableclosuredata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",580,N],[11,"encode","","",580,[[["self"],["__sn"]],["result"]]],[11,"decode","","",580,[[["__dn"]],["result",["vtableclosuredata"]]]],[11,"clone","","",581,[[["self"]],["vtableautoimpldata"]]],[11,"eq","","",581,[[["self"],["vtableautoimpldata"]],["bool"]]],[11,"ne","","",581,[[["self"],["vtableautoimpldata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",581,N],[11,"encode","","",581,[[["self"],["__sn"]],["result"]]],[11,"decode","","",581,[[["__dn"]],["result",["vtableautoimpldata"]]]],[11,"clone","","",582,[[["self"]],["vtablebuiltindata"]]],[11,"eq","","",582,[[["self"],["vtablebuiltindata"]],["bool"]]],[11,"ne","","",582,[[["self"],["vtablebuiltindata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",582,N],[11,"encode","","",582,[[["self"],["__sn"]],["result"]]],[11,"decode","","",582,[[["__dn"]],["result",["vtablebuiltindata"]]]],[11,"eq","","",583,[[["self"],["vtableobjectdata"]],["bool"]]],[11,"ne","","",583,[[["self"],["vtableobjectdata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",583,N],[11,"clone","","",583,[[["self"]],["vtableobjectdata"]]],[11,"encode","","",583,[[["self"],["__sn"]],["result"]]],[11,"decode","","",583,[[["__dn"]],["result",["vtableobjectdata"]]]],[11,"clone","","",584,[[["self"]],["vtablefnpointerdata"]]],[11,"eq","","",584,[[["self"],["vtablefnpointerdata"]],["bool"]]],[11,"ne","","",584,[[["self"],["vtablefnpointerdata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",584,N],[11,"encode","","",584,[[["self"],["__sn"]],["result"]]],[11,"decode","","",584,[[["__dn"]],["result",["vtablefnpointerdata"]]]],[11,"new","","",573,[[["obligationcause"],["paramenv"],["o"]],["obligation"]]],[11,"with_depth","","",573,[[["obligationcause"],["usize"],["paramenv"],["o"]],["obligation"]]],[11,"misc","","",573,[[["span"],["nodeid"],["paramenv"],["o"]],["obligation"]]],[11,"with","","",573,[[["self"],["p"]],["obligation"]]],[11,"new","","",574,[[["span"],["nodeid"],["obligationcausecode"]],["obligationcause"]]],[11,"misc","","",574,[[["span"],["nodeid"]],["obligationcause"]]],[11,"dummy","","",574,[[],["obligationcause"]]],[11,"nested_obligations","","",603,[[["self"]],["vec"]]],[11,"map","","",603,[[["self"],["f"]],["vtable"]]],[11,"new","","",577,[[["predicateobligation"],["fulfillmenterrorcode"]],["fulfillmenterror"]]],[11,"self_ty","","",663,[[["self"]],["binder",["ty"]]]],[0,"ty","rustc","",N,N],[3,"Binder","rustc::ty","Binder is a binder for higher-ranked lifetimes. It is part of the compiler's representation for things like `for<'a> Fn(&'a isize)` (which would be represented by the type `PolyTraitRef == Binder<TraitRef>`). Note that when we skolemize, instantiate, erase, or otherwise \"discharge\" these bound regions, we change the type from `Binder<T>` to just `T` (see e.g. `liberate_late_bound_regions`).",N,N],[12,"0","","",664,N],[3,"CanonicalVar","","",N,N],[12,"0","","",665,N],[3,"DebruijnIndex","","",N,N],[12,"0","","",666,N],[3,"FnSig","","Signature of a function type, which I have arbitrarily decided to use to refer to the input/output types.",N,N],[12,"inputs_and_output","","",667,N],[12,"variadic","","",667,N],[12,"unsafety","","",667,N],[12,"abi","","",667,N],[3,"GenSig","","",N,N],[12,"yield_ty","","",668,N],[12,"return_ty","","",668,N],[3,"ParamTy","","",N,N],[12,"idx","","",669,N],[12,"name","","",669,N],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS form this would be written `<T as Trait<..>>::N`.",N,N],[12,"substs","","The parameters of the associated item.",670,N],[12,"item_def_id","","The DefId of the TraitItem for the associated type N.",670,N],[3,"ClosureSubsts","","A closure can be modeled as a struct that looks like:",N,N],[12,"substs","","Lifetime and type parameters from the enclosing function, concatenated with the types of the upvars.",671,N],[3,"GeneratorSubsts","","",N,N],[12,"substs","","",672,N],[3,"TypeAndMut","","",N,N],[12,"ty","","",673,N],[12,"mutbl","","",673,N],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax, but perhaps the most recognizable form is in a where clause:",N,N],[12,"def_id","","",674,N],[12,"substs","","",674,N],[3,"ExistentialTraitRef","","An existential reference to a trait, where `Self` is erased. For example, the trait object `Trait<'a, 'b, X, Y>` is:",N,N],[12,"def_id","","",675,N],[12,"substs","","",675,N],[3,"ExistentialProjection","","A `ProjectionPredicate` for an `ExistentialTraitRef`.",N,N],[12,"item_def_id","","",676,N],[12,"substs","","",676,N],[12,"ty","","",676,N],[3,"Const","","Typed constant value.",N,N],[12,"ty","","",677,N],[12,"val","","",677,N],[3,"EarlyBoundRegion","","",N,N],[12,"def_id","","",678,N],[12,"index","","",678,N],[12,"name","","",678,N],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region at least as big as the scope `fr.scope`\".",N,N],[12,"scope","","",679,N],[12,"bound_region","","",679,N],[3,"TyVid","","",N,N],[12,"index","","",680,N],[3,"IntVid","","",N,N],[12,"index","","",681,N],[3,"FloatVid","","",N,N],[12,"index","","",682,N],[3,"RegionVid","","",N,N],[12,"0","","",683,N],[3,"TyCtxt","","The central data structure of the compiler. It stores references to the various arenas and also houses the results of the various compiler queries that have been performed. See the [rustc guide] for more details.",N,N],[12,"gcx","","",684,N],[12,"interners","","",684,N],[3,"GlobalArenas","","Internal storage",N,N],[12,"layout","","",685,N],[12,"generics","","",685,N],[12,"trait_def","","",685,N],[12,"adt_def","","",685,N],[12,"steal_mir","","",685,N],[12,"mir","","",685,N],[12,"tables","","",685,N],[12,"const_allocs","","miri allocations",685,N],[3,"AllArenas","","",N,N],[12,"global","","",686,N],[12,"interner","","",686,N],[3,"TypeckTables","","",N,N],[12,"local_id_root","","The HirId::owner all ItemLocalIds in this table are relative to.",687,N],[12,"type_dependent_defs","","Resolved definitions for `<T>::X` associated paths and method calls, including those of overloaded operators.",687,N],[12,"field_indices","","Resolved field indices for field accesses in expressions (`S { field }`, `obj.field`) or patterns (`S { field }`). The index is often useful by itself, but to learn more about the field you also need definition of the variant to which the field belongs, but it may not exist if it's a tuple field (`tuple.0`).",687,N],[12,"user_provided_tys","","Stores the canonicalized types provided by the user. See also `UserAssertTy` statement in MIR.",687,N],[12,"node_types","","Stores the types for various nodes in the AST.  Note that this table is not guaranteed to be populated until after typeck.  See typeck::check::fn_ctxt for details.",687,N],[12,"node_substs","","Stores the type parameters which were substituted to obtain the type of this node.  This only applies to nodes that refer to entities parameterized by type parameters, such as generic fns, types, or other items.",687,N],[12,"adjustments","","",687,N],[12,"pat_binding_modes","","Stores the actual binding mode for all instances of hir::BindingAnnotation.",687,N],[12,"pat_adjustments","","Stores the types which were implicitly dereferenced in pattern binding modes for later usage in HAIR lowering. For example,",687,N],[12,"upvar_capture_map","","Borrows",687,N],[12,"closure_kind_origins","","Records the reasons that we picked the kind of each closure; not all closures are present in the map.",687,N],[12,"liberated_fn_sigs","","For each fn, records the \"liberated\" types of its arguments and return type. Liberated means that all bound regions (including late-bound regions) are replaced with free equivalents. This table is not used in codegen (since regions are erased there) and hence is not serialized to metadata.",687,N],[12,"fru_field_types","","For each FRU expression, record the normalized types of the fields of the struct - this is needed because it is non-trivial to normalize while preserving regions. This table is used only in MIR construction and hence is not serialized to metadata.",687,N],[12,"cast_kinds","","Maps a cast expression to its kind. This is keyed on the from expression of the cast, not the cast itself.",687,N],[12,"used_trait_imports","","Set of trait imports actually used in the method resolution. This is used for warning unused imports. During type checking, this `Lrc` should not be cloned: it must have a ref-count of 1 so that we can insert things into the set mutably.",687,N],[12,"tainted_by_errors","","If any errors occurred while type-checking this body, this field will be set to `true`.",687,N],[12,"free_region_map","","Stores the free-region relationships that were deduced from its where clauses and parameter types. These are then read-again by borrowck.",687,N],[12,"concrete_existential_types","","All the existential types that are restricted to concrete types by this function",687,N],[3,"Instance","","",N,N],[12,"def","","",688,N],[12,"substs","","",688,N],[3,"CrateAnalysis","","The complete set of all analyses described in this module. This is produced by the driver and fed to codegen and later passes.",N,N],[12,"access_levels","","",689,N],[12,"name","","",689,N],[12,"glob_map","","",689,N],[3,"Resolutions","","",N,N],[12,"freevars","","",690,N],[12,"trait_map","","",690,N],[12,"maybe_unused_trait_imports","","",690,N],[12,"maybe_unused_extern_crates","","",690,N],[12,"export_map","","",690,N],[3,"ImplHeader","","The \"header\" of an impl is everything outside the body: a Self type, a trait ref (in the case of a trait impl), and a set of predicates (from the bounds/where clauses).",N,N],[12,"impl_def_id","","",691,N],[12,"self_ty","","",691,N],[12,"trait_ref","","",691,N],[12,"predicates","","",691,N],[3,"AssociatedItem","","",N,N],[12,"def_id","","",692,N],[12,"ident","","",692,N],[12,"kind","","",692,N],[12,"vis","","",692,N],[12,"defaultness","","",692,N],[12,"container","","",692,N],[12,"method_has_self_argument","","Whether this is a method with an explicit self as its first argument, allowing method calls.",692,N],[3,"CrateVariancesMap","","The crate variances map is computed during typeck and contains the variance of every item in the local crate. You should not use it directly, because to do so will make your pass dependent on the HIR of every item in the local crate. Instead, use `tcx.variances_of()` to get the variance for a particular item.",N,N],[12,"variances","","For each item with generics, maps to a vector of the variance of its generics.  If an item has no generics, it will have no entry.",693,N],[12,"empty_variance","","An empty vector, useful for cloning.",693,N],[3,"CReaderCacheKey","","",N,N],[12,"cnum","","",694,N],[12,"pos","","",694,N],[3,"TypeFlags","","",N,N],[12,"bits","","",695,N],[3,"TyS","","",N,N],[12,"sty","","",696,N],[12,"flags","","",696,N],[12,"outer_exclusive_binder","","This is a kind of confusing thing: it stores the smallest binder such that",696,N],[3,"Slice","","A wrapper for slices with the additional invariant that the slice is interned and no other slice with the same contents can exist in the same context. This means we can use pointer for both equality comparisons and hashing.",N,N],[12,"len","","",697,N],[12,"data","","",697,N],[12,"opaque","","",697,N],[3,"UpvarId","","Upvars do not get their own node-id. Instead, we use the pair of the original var id (that is, the root variable that is referenced by the upvar) and the id of the closure expression.",N,N],[12,"var_id","","",698,N],[12,"closure_expr_id","","",698,N],[3,"UpvarBorrow","","",N,N],[12,"kind","","The kind of borrow: by-ref upvars have access to shared immutable borrows, which are not part of the normal language syntax.",699,N],[12,"region","","Region of the resulting reference.",699,N],[3,"ClosureUpvar","","",N,N],[12,"def","","",700,N],[12,"span","","",700,N],[12,"ty","","",700,N],[3,"FloatVarValue","","",N,N],[12,"0","","",701,N],[3,"GenericParamDef","","",N,N],[12,"name","","",702,N],[12,"def_id","","",702,N],[12,"index","","",702,N],[12,"pure_wrt_drop","","`pure_wrt_drop`, set by the (unsafe) `#[may_dangle]` attribute on generic parameter `'a`/`T`, asserts data behind the parameter `'a`/`T` won't be accessed during the parent type's `Drop` impl.",702,N],[12,"kind","","",702,N],[3,"GenericParamCount","","",N,N],[12,"lifetimes","","",703,N],[12,"types","","",703,N],[3,"Generics","","Information about the formal type/lifetime parameters associated with an item or method. Analogous to hir::Generics.",N,N],[12,"parent","","",704,N],[12,"parent_count","","",704,N],[12,"params","","",704,N],[12,"param_def_id_to_index","","Reverse map to the `index` field of each `GenericParamDef`",704,N],[12,"has_self","","",704,N],[12,"has_late_bound_regions","","",704,N],[3,"GenericPredicates","","Bounds on generics.",N,N],[12,"parent","","",705,N],[12,"predicates","","",705,N],[3,"CratePredicatesMap","","The crate outlives map is computed during typeck and contains the outlives of every item in the local crate. You should not use it directly, because to do so will make your pass dependent on the HIR of every item in the local crate. Instead, use `tcx.inferred_outlives_of()` to get the outlives for a particular item.",N,N],[12,"predicates","","For each struct with outlive bounds, maps to a vector of the predicate of its outlive bounds. If an item has no outlives bounds, it will have no entry.",706,N],[12,"empty_predicate","","An empty vector, useful for cloning.",706,N],[3,"TraitPredicate","","",N,N],[12,"trait_ref","","",707,N],[3,"OutlivesPredicate","","",N,N],[12,"0","","",708,N],[12,"1","","",708,N],[3,"SubtypePredicate","","",N,N],[12,"a_is_expected","","",709,N],[12,"a","","",709,N],[12,"b","","",709,N],[3,"ProjectionPredicate","","This kind of predicate has no direct correspondent in the syntax, but it roughly corresponds to the syntactic forms:",N,N],[12,"projection_ty","","",710,N],[12,"ty","","",710,N],[3,"InstantiatedPredicates","","Represents the bounds declared on a particular set of type parameters.  Should eventually be generalized into a flag list of where clauses.  You can obtain a `InstantiatedPredicates` list from a `GenericPredicates` by using the `instantiate` method. Note that this method reflects an important semantic invariant of `InstantiatedPredicates`: while the `GenericPredicates` are expressed in terms of the bound type parameters of the impl/trait/whatever, an `InstantiatedPredicates` instance represented a set of bounds for some particular instantiation, meaning that the generic parameters have been substituted with their values.",N,N],[12,"predicates","","",711,N],[3,"UniverseIndex","","\"Universes\" are used during type- and trait-checking in the presence of `for<..>` binders to control what sets of names are visible. Universes are arranged into a tree: the root universe contains names that are always visible. But when you enter into some subuniverse, then it may add names that are only visible within that subtree (but it can still name the names of its ancestor universes).",N,N],[12,"0","","",712,N],[3,"ParamEnv","","When type checking, we use the `ParamEnv` to track details about the set of where-clauses that are in scope at this particular point.",N,N],[12,"caller_bounds","","Obligations that the caller must satisfy. This is basically the set of bounds on the in-scope type parameters, translated into Obligations, and elaborated and normalized.",713,N],[12,"reveal","","Typically, this is `Reveal::UserFacing`, but during codegen we want `Reveal::All` -- note that this is always paired with an empty environment. To get that, use `ParamEnv::reveal()`.",713,N],[3,"ParamEnvAnd","","",N,N],[12,"param_env","","",714,N],[12,"value","","",714,N],[3,"Destructor","","",N,N],[12,"did","","The def-id of the destructor method",715,N],[3,"AdtFlags","","",N,N],[12,"bits","","",716,N],[3,"VariantDef","","",N,N],[12,"did","","The variant's DefId. If this is a tuple-like struct, this is the DefId of the struct's ctor.",717,N],[12,"name","","",717,N],[12,"discr","","",717,N],[12,"fields","","",717,N],[12,"ctor_kind","","",717,N],[3,"FieldDef","","",N,N],[12,"did","","",718,N],[12,"ident","","",718,N],[12,"vis","","",718,N],[3,"AdtDef","","The definition of an abstract data type - a struct or enum.",N,N],[12,"did","","",719,N],[12,"variants","","",719,N],[12,"flags","","",719,N],[12,"repr","","",719,N],[3,"ReprFlags","","",N,N],[12,"bits","","",720,N],[3,"ReprOptions","","Represents the repr options provided by the user,",N,N],[12,"int","","",721,N],[12,"align","","",721,N],[12,"pack","","",721,N],[12,"flags","","",721,N],[3,"CrateInherentImpls","","A map for the local crate mapping each type to a vector of its inherent impls. This is not meant to be used outside of coherence; rather, you should request the vector for a specific type via `tcx.inherent_impls(def_id)` so as to minimize your dependencies (constructing this map requires touching the entire crate).",N,N],[12,"inherent_impls","","",722,N],[3,"SymbolName","","",N,N],[12,"name","","",723,N],[4,"InferTy","","",N,N],[13,"TyVar","","",724,N],[13,"IntVar","","",724,N],[13,"FloatVar","","",724,N],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an unbound type variable. This is convenient for caching etc. See `infer::freshen` for more details.",724,N],[13,"FreshIntTy","","",724,N],[13,"FreshFloatTy","","",724,N],[13,"CanonicalTy","","Canonicalized type variable, used only when preparing a trait query.",724,N],[4,"ExistentialPredicate","","",N,N],[13,"Trait","","e.g. Iterator",725,N],[13,"Projection","","e.g. Iterator::Item = T",725,N],[13,"AutoTrait","","e.g. Send",725,N],[4,"UpvarSubsts","","",N,N],[13,"Closure","","",726,N],[13,"Generator","","",726,N],[4,"TypeVariants","","NB: If you change this, you'll probably want to change the corresponding AST structure in libsyntax/ast.rs as well.",N,N],[13,"TyBool","","The primitive boolean type. Written as `bool`.",727,N],[13,"TyChar","","The primitive character type; holds a Unicode scalar value (a non-surrogate code point).  Written as `char`.",727,N],[13,"TyInt","","A primitive signed integer type. For example, `i32`.",727,N],[13,"TyUint","","A primitive unsigned integer type. For example, `u32`.",727,N],[13,"TyFloat","","A primitive floating-point type. For example, `f64`.",727,N],[13,"TyAdt","","Structures, enumerations and unions.",727,N],[13,"TyForeign","","",727,N],[13,"TyStr","","The pointee of a string slice. Written as `str`.",727,N],[13,"TyArray","","An array with the given length. Written as `[T; n]`.",727,N],[13,"TySlice","","The pointee of an array slice.  Written as `[T]`.",727,N],[13,"TyRawPtr","","A raw pointer. Written as `*mut T` or `*const T`",727,N],[13,"TyRef","","A reference; a pointer with an associated lifetime. Written as `&'a mut T` or `&'a T`.",727,N],[13,"TyFnDef","","The anonymous type of a function declaration/definition. Each function has a unique type.",727,N],[13,"TyFnPtr","","A pointer to a function.  Written as `fn() -> i32`.",727,N],[13,"TyDynamic","","A trait, defined with `trait`.",727,N],[13,"TyClosure","","The anonymous type of a closure. Used to represent the type of `|a| a`.",727,N],[13,"TyGenerator","","The anonymous type of a generator. Used to represent the type of `|a| yield a`.",727,N],[13,"TyGeneratorWitness","","A type representin the types stored inside a generator. This should only appear in GeneratorInteriors.",727,N],[13,"TyNever","","The never type `!`",727,N],[13,"TyTuple","","A tuple type.  For example, `(i32, bool)`.",727,N],[13,"TyProjection","","The projection of an associated type.  For example, `<T as Trait<..>>::N`.",727,N],[13,"TyAnon","","Anonymized (`impl Trait`) type found in a return type. The DefId comes either from * the `impl Trait` ast::Ty node, * or the `existential type` declaration The substitutions are for the generics of the function in question. After typeck, the concrete type can be found in the `types` map.",727,N],[13,"TyParam","","A type parameter; for example, `T` in `fn f(x: T) {}",727,N],[13,"TyInfer","","A type variable used during type-checking.",727,N],[13,"TyError","","A placeholder for a type which could not be computed; this is propagated to avoid useless error messages.",727,N],[4,"BoundRegion","","",N,N],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",728,N],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",728,N],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",728,N],[13,"BrEnv","","Anonymous region for the implicit env pointer parameter to a closure",728,N],[4,"RegionKind","","Representation of regions.",N,N],[13,"ReEarlyBound","","",729,N],[13,"ReLateBound","","",729,N],[13,"ReFree","","When checking a function body, the types of all arguments and so forth that refer to bound region parameters are modified to refer to free region parameters.",729,N],[13,"ReScope","","A concrete region naming some statically determined scope (e.g. an expression or sequence of statements) within the current function.",729,N],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",729,N],[13,"ReVar","","A region variable.  Should not exist after typeck.",729,N],[13,"ReSkolemized","","A skolemized region - basically the higher-ranked version of ReFree. Should not exist after typeck.",729,N],[13,"ReEmpty","","Empty lifetime is for data that is never accessed. Bottom in the region lattice. We treat ReEmpty somewhat specially; at least right now, we do not generate instances of it during the GLB computations, but rather generate an error instead. This is to improve error messages. The only way to get an instance of ReEmpty is to have a region variable with no constraints.",729,N],[13,"ReErased","","Erased region, used by trait selection, in MIR and during codegen.",729,N],[13,"ReClosureBound","","These are regions bound in the \"defining type\" for a closure. They are used ONLY as part of the `ClosureRegionRequirements` that are produced by MIR borrowck. See `ClosureRegionRequirements` for more details.",729,N],[13,"ReCanonical","","Canonicalized region, used only when preparing a trait query.",729,N],[4,"InstanceDef","","",N,N],[13,"Item","","",730,N],[13,"Intrinsic","","",730,N],[13,"FnPtrShim","","<fn() as FnTrait>::call_* def-id is FnTrait::call_*",730,N],[13,"Virtual","","::fn",730,N],[13,"ClosureOnceShim","","<[mut closure] as FnOnce>::call_once",730,N],[12,"call_once","rustc::ty::InstanceDef","",730,N],[13,"DropGlue","rustc::ty","drop_in_place::; None for empty drop glue.",730,N],[13,"CloneShim","","`<T as Clone>::clone` shim.",730,N],[4,"AssociatedItemContainer","","",N,N],[13,"TraitContainer","","",731,N],[13,"ImplContainer","","",731,N],[4,"AssociatedKind","","",N,N],[13,"Const","","",732,N],[13,"Method","","",732,N],[13,"Existential","","",732,N],[13,"Type","","",732,N],[4,"Visibility","","",N,N],[13,"Public","","Visible everywhere (including in other crates).",733,N],[13,"Restricted","","Visible only in the given crate-local module.",733,N],[13,"Invisible","","Not visible anywhere in the local crate. This is the visibility of private external items.",733,N],[4,"Variance","","",N,N],[13,"Covariant","","",734,N],[13,"Invariant","","",734,N],[13,"Contravariant","","",734,N],[13,"Bivariant","","",734,N],[4,"BorrowKind","","",N,N],[13,"ImmBorrow","","Data must be immutable and is aliasable.",735,N],[13,"UniqueImmBorrow","","Data must be immutable but not aliasable.  This kind of borrow cannot currently be expressed by the user and is used only in implicit closure bindings. It is needed when the closure is borrowing or mutating a mutable referent, e.g.:",735,N],[13,"MutBorrow","","Data is mutable and not aliasable.",735,N],[4,"UpvarCapture","","Information describing the capture of an upvar. This is computed during `typeck`, specifically by `regionck`.",N,N],[13,"ByValue","","Upvar is captured by value. This is always true when the closure is labeled `move`, but can also be true in other cases depending on inference.",736,N],[13,"ByRef","","Upvar is captured by reference.",736,N],[4,"IntVarValue","","",N,N],[13,"IntType","","",737,N],[13,"UintType","","",737,N],[4,"GenericParamDefKind","","",N,N],[13,"Lifetime","","",738,N],[13,"Type","","",738,N],[12,"has_default","rustc::ty::GenericParamDefKind","",738,N],[12,"object_lifetime_default","","",738,N],[12,"synthetic","","",738,N],[4,"Predicate","rustc::ty","",N,N],[13,"Trait","","Corresponds to `where Foo : Bar<A,B,C>`. `Foo` here would be the `Self` type of the trait reference and `A`, `B`, and `C` would be the type parameters.",739,N],[13,"RegionOutlives","","where 'a : 'b",739,N],[13,"TypeOutlives","","where T : 'a",739,N],[13,"Projection","","where ::Name == X, approximately. See `ProjectionPredicate` struct for details.",739,N],[13,"WellFormed","","no syntax: T WF",739,N],[13,"ObjectSafe","","trait must be object-safe",739,N],[13,"ClosureKind","","No direct syntax. May be thought of as `where T : FnFoo<...>` for some substitutions `...` and T being a closure type. Satisfied (or refuted) once we know the closure's kind.",739,N],[13,"Subtype","","`T1 <: T2`",739,N],[13,"ConstEvaluatable","","Constant initializer must evaluate successfully.",739,N],[4,"VariantDiscr","","",N,N],[13,"Explicit","","Explicit value for this variant, i.e. `X = 123`. The `DefId` corresponds to the embedded constant.",740,N],[13,"Relative","","The previous variant's discriminant plus one. For efficiency reasons, the distance from the last `Explicit` discriminant is being stored, or `0` for the first variant, if it has none.",740,N],[4,"AdtKind","","",N,N],[13,"Struct","","",741,N],[13,"Union","","",741,N],[13,"Enum","","",741,N],[4,"ClosureKind","","Represents the various closure traits in the Rust language. This will determine the type of the environment (`self`, in the desuaring) argument that the closure expects.",N,N],[13,"Fn","","",742,N],[13,"FnMut","","",742,N],[13,"FnOnce","","",742,N],[4,"Attributes","","",N,N],[13,"Owned","","",743,N],[13,"Borrowed","","",743,N],[5,"keep_local","","",N,[[["t"]],["bool"]]],[5,"associated_item","","",N,[[["tyctxt"],["defid"]],["associateditem"]]],[5,"adt_sized_constraint","","Calculates the Sized-constraint.",N,N],[5,"associated_item_def_ids","","",N,[[["tyctxt"],["defid"]],["lrc",["vec"]]]],[5,"def_span","","",N,[[["tyctxt"],["defid"]],["span"]]],[5,"trait_of_item","","If the given def ID describes an item belonging to a trait, return the ID of the trait that the trait item belongs to. Otherwise, return `None`.",N,[[["tyctxt"],["defid"]],["option",["defid"]]]],[5,"is_impl_trait_defn","","Yields the parent function's `DefId` if `def_id` is an `impl Trait` definition",N,[[["tyctxt"],["defid"]],["option",["defid"]]]],[5,"param_env","","See `ParamEnv` struct def'n for details.",N,[[["tyctxt"],["defid"]],["paramenv"]]],[5,"crate_disambiguator","","",N,[[["tyctxt"],["cratenum"]],["cratedisambiguator"]]],[5,"original_crate_name","","",N,[[["tyctxt"],["cratenum"]],["symbol"]]],[5,"crate_hash","","",N,[[["tyctxt"],["cratenum"]],["svh"]]],[5,"instance_def_size_estimate","","",N,[[["tyctxt"],["instancedef"]],["usize"]]],[5,"provide","","",N,[[["providers"]]]],[20,"OpaqueSliceContents","","A dummy type used to force Slice to by unsized without requiring fat pointers",N,N],[0,"tls","","",N,N],[3,"ImplicitCtxt","rustc::ty::tls","This is the implicit state of rustc. It contains the current TyCtxt and query. It is updated when creating a local interner or executing a new query. Whenever there's a TyCtxt value available you should also have access to an ImplicitCtxt through the functions in this module.",N,N],[12,"tcx","","The current TyCtxt. Initially created by `enter_global` and updated by `enter_local` with a new local interner",744,N],[12,"query","","The current query job, if any. This is updated by start_job in ty::query::plumbing when executing a query",744,N],[12,"layout_depth","","Used to prevent layout from recursing too deeply.",744,N],[12,"task","","The current dep graph task. This is used to add dependencies to queries when executing them",744,N],[5,"with_thread_locals","","Sets up the callbacks from libsyntax on the current thread",N,[[["f"]],["r"]]],[5,"enter_context","","Sets `context` as the new current ImplicitCtxt for the duration of the function `f`",N,[[["implicitctxt"],["f"]],["r"]]],[5,"enter_global","","Enters GlobalCtxt by setting up libsyntax callbacks and creating a initial TyCtxt and ImplicitCtxt. This happens once per rustc session and TyCtxts only exists inside the `f` function.",N,[[["globalctxt"],["f"]],["r"]]],[5,"with_global","","Creates a TyCtxt and ImplicitCtxt based on the GCX_PTR thread local. This is used in the deadlock handler.",N,[[["f"]],["r"]]],[5,"with_context_opt","","Allows access to the current ImplicitCtxt in a closure if one is available",N,[[["f"]],["r"]]],[5,"with_context","","Allows access to the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[5,"with_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'gcx lifetime as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner from the current ImplicitCtxt's tcx field.",N,[[["tyctxt"],["f"]],["r"]]],[5,"with_fully_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner and local interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'tcx and 'gcx lifetimes as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner or a different local interner from the current ImplicitCtxt's tcx field.",N,[[["tyctxt"],["f"]],["r"]]],[5,"with","","Allows access to the TyCtxt in the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[5,"with_opt","","Allows access to the TyCtxt in the current ImplicitCtxt. The closure is passed None if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[7,"GCX_PTR","","",N,N],[0,"adjustment","rustc::ty","",N,N],[3,"Adjustment","rustc::ty::adjustment","Represents coercing a value to a different type of value.",N,N],[12,"kind","","",745,N],[12,"target","","",745,N],[3,"OverloadedDeref","","An overloaded autoderef step, representing a `Deref(Mut)::deref(_mut)` call, with the signature `&'a T -> &'a U` or `&'a mut T -> &'a mut U`. The target type is `U` in both cases, with the region and mutability being those shared by both the receiver and the returned reference.",N,N],[12,"region","","",746,N],[12,"mutbl","","",746,N],[3,"CoerceUnsizedInfo","","Information for `CoerceUnsized` impls, storing information we have computed about the coercion.",N,N],[12,"custom_kind","","If this is a \"custom coerce\" impl, then what kind of custom coercion is it? This applies to impls of `CoerceUnsized` for structs, primarily, where we store a bit of info about which fields need to be coerced.",747,N],[4,"Adjust","","",N,N],[13,"NeverToAny","","Go from ! to any type.",748,N],[13,"ReifyFnPointer","","Go from a fn-item type to a fn-pointer type.",748,N],[13,"UnsafeFnPointer","","Go from a safe fn pointer to an unsafe fn pointer.",748,N],[13,"ClosureFnPointer","","Go from a non-capturing closure to an fn pointer.",748,N],[13,"MutToConstPointer","","Go from a mut raw pointer to a const raw pointer.",748,N],[13,"Deref","","Dereference once, producing a place.",748,N],[13,"Borrow","","Take the address and produce either a `&` or `*` pointer.",748,N],[13,"Unsize","","Unsize a pointer/reference value, e.g. `&[T; n]` to `&[T]`. Note that the source could be a thin or fat pointer. This will do things like convert thin pointers to fat pointers, or convert structs containing thin pointers to structs containing fat pointers, or convert between fat pointers.  We don't store the details of how the transform is done (in fact, we don't know that, because it might depend on the precise type parameters). We just store the target type. Codegen backends and miri figure out what has to be done based on the precise source/target type at hand.",748,N],[4,"AllowTwoPhase","","At least for initial deployment, we want to limit two-phase borrows to only a few specific cases. Right now, those mostly \"things that desugar\" into method calls     - using x.some_method() syntax, where some_method takes &mut self     - using Foo::some_method(&mut x, ...) syntax     - binary assignment operators (+=, -=, *=, etc.) Anything else should be rejected until generalized two phase borrow support is implemented. Right now, dataflow can't handle the general case where there is more than one use of a mutable borrow, and we don't want to accept too much new code via two-phase borrows, so we try to limit where we create two-phase capable mutable borrows. See #49434 for tracking.",N,N],[13,"Yes","","",749,N],[13,"No","","",749,N],[4,"AutoBorrowMutability","","",N,N],[13,"Mutable","","",750,N],[12,"allow_two_phase_borrow","rustc::ty::adjustment::AutoBorrowMutability","",750,N],[13,"Immutable","rustc::ty::adjustment","",750,N],[4,"AutoBorrow","","",N,N],[13,"Ref","","Convert from T to &T.",751,N],[13,"RawPtr","","Convert from T to *T.",751,N],[4,"CustomCoerceUnsized","","",N,N],[13,"Struct","","Records the index of the field being coerced.",752,N],[11,"clone","","",745,[[["self"]],["adjustment"]]],[11,"encode","","",745,[[["self"],["__s"]],["result"]]],[11,"decode","","",745,[[["__d"]],["result",["adjustment"]]]],[11,"clone","","",748,[[["self"]],["adjust"]]],[11,"fmt","","",748,[[["self"],["formatter"]],["result"]]],[11,"encode","","",748,[[["self"],["__s"]],["result"]]],[11,"decode","","",748,[[["__d"]],["result",["adjust"]]]],[11,"clone","","",746,[[["self"]],["overloadedderef"]]],[11,"eq","","",746,[[["self"],["overloadedderef"]],["bool"]]],[11,"ne","","",746,[[["self"],["overloadedderef"]],["bool"]]],[11,"fmt","","",746,[[["self"],["formatter"]],["result"]]],[11,"encode","","",746,[[["self"],["__s"]],["result"]]],[11,"decode","","",746,[[["__d"]],["result",["overloadedderef"]]]],[11,"method_call","","",746,N],[11,"clone","","",749,[[["self"]],["allowtwophase"]]],[11,"eq","","",749,[[["self"],["allowtwophase"]],["bool"]]],[11,"fmt","","",749,[[["self"],["formatter"]],["result"]]],[11,"encode","","",749,[[["self"],["__s"]],["result"]]],[11,"decode","","",749,[[["__d"]],["result",["allowtwophase"]]]],[11,"clone","","",750,[[["self"]],["autoborrowmutability"]]],[11,"eq","","",750,[[["self"],["autoborrowmutability"]],["bool"]]],[11,"ne","","",750,[[["self"],["autoborrowmutability"]],["bool"]]],[11,"fmt","","",750,[[["self"],["formatter"]],["result"]]],[11,"encode","","",750,[[["self"],["__s"]],["result"]]],[11,"decode","","",750,[[["__d"]],["result",["autoborrowmutability"]]]],[11,"from","rustc::hir","",103,[[["autoborrowmutability"]],["self"]]],[11,"clone","rustc::ty::adjustment","",751,[[["self"]],["autoborrow"]]],[11,"eq","","",751,[[["self"],["autoborrow"]],["bool"]]],[11,"ne","","",751,[[["self"],["autoborrow"]],["bool"]]],[11,"fmt","","",751,[[["self"],["formatter"]],["result"]]],[11,"encode","","",751,[[["self"],["__s"]],["result"]]],[11,"decode","","",751,[[["__d"]],["result",["autoborrow"]]]],[11,"clone","","",747,[[["self"]],["coerceunsizedinfo"]]],[11,"encode","","",747,[[["self"],["__s"]],["result"]]],[11,"decode","","",747,[[["__d"]],["result",["coerceunsizedinfo"]]]],[11,"fmt","","",747,[[["self"],["formatter"]],["result"]]],[11,"clone","","",752,[[["self"]],["customcoerceunsized"]]],[11,"encode","","",752,[[["self"],["__s"]],["result"]]],[11,"decode","","",752,[[["__d"]],["result",["customcoerceunsized"]]]],[11,"fmt","","",752,[[["self"],["formatter"]],["result"]]],[0,"binding","rustc::ty","",N,N],[4,"BindingMode","rustc::ty::binding","",N,N],[13,"BindByReference","","",753,N],[13,"BindByValue","","",753,N],[11,"clone","","",753,[[["self"]],["bindingmode"]]],[11,"eq","","",753,[[["self"],["bindingmode"]],["bool"]]],[11,"ne","","",753,[[["self"],["bindingmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",753,N],[11,"encode","","",753,[[["self"],["__s"]],["result"]]],[11,"decode","","",753,[[["__d"]],["result",["bindingmode"]]]],[11,"hash","","",753,N],[11,"fmt","","",753,[[["self"],["formatter"]],["result"]]],[11,"super_fold_with","","",753,[[["self"],["f"]],["bindingmode"]]],[11,"super_visit_with","","",753,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",753,[[["self"],["tyctxt"]],["option"]]],[11,"convert","","",753,[[["bindingannotation"]],["bindingmode"]]],[11,"hash_stable","","",753,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"cast","rustc::ty","",N,N],[4,"IntTy","rustc::ty::cast","Types that are represented as ints.",N,N],[13,"U","","",754,N],[13,"I","","",754,N],[13,"CEnum","","",754,N],[13,"Bool","","",754,N],[13,"Char","","",754,N],[4,"CastTy","","",N,N],[13,"Int","","Various types that are represented as ints and handled mostly in the same way, merged for easier matching.",755,N],[13,"Float","","Floating-Point types",755,N],[13,"FnPtr","","Function Pointers",755,N],[13,"Ptr","","Raw pointers",755,N],[13,"RPtr","","References",755,N],[4,"CastKind","","Cast Kind. See RFC 401 (or librustc_typeck/check/cast.rs)",N,N],[13,"CoercionCast","","",756,N],[13,"PtrPtrCast","","",756,N],[13,"PtrAddrCast","","",756,N],[13,"AddrPtrCast","","",756,N],[13,"NumericCast","","",756,N],[13,"EnumCast","","",756,N],[13,"PrimIntCast","","",756,N],[13,"U8CharCast","","",756,N],[13,"ArrayPtrCast","","",756,N],[13,"FnPtrPtrCast","","",756,N],[13,"FnPtrAddrCast","","",756,N],[11,"clone","","",754,[[["self"]],["intty"]]],[11,"fmt","","",754,[[["self"],["formatter"]],["result"]]],[11,"eq","","",754,[[["self"],["intty"]],["bool"]]],[11,"ne","","",754,[[["self"],["intty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",754,N],[11,"clone","","",755,[[["self"]],["castty"]]],[11,"fmt","","",755,[[["self"],["formatter"]],["result"]]],[11,"eq","","",755,[[["self"],["castty"]],["bool"]]],[11,"ne","","",755,[[["self"],["castty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",755,N],[11,"clone","","",756,[[["self"]],["castkind"]]],[11,"fmt","","",756,[[["self"],["formatter"]],["result"]]],[11,"encode","","",756,[[["self"],["__s"]],["result"]]],[11,"decode","","",756,[[["__d"]],["result",["castkind"]]]],[11,"from_ty","","",755,[[["ty"]],["option",["castty"]]]],[0,"codec","rustc::ty","",N,N],[5,"encode_with_shorthand","rustc::ty::codec","Encode the given value or a previously cached shorthand.",N,[[["e"],["t"],["m"]],["result"]]],[5,"encode_predicates","","",N,[[["e"],["genericpredicates"],["c"]],["result"]]],[5,"decode_cnum","","",N,[[["d"]],["result",["cratenum"]]]],[5,"decode_ty","","",N,[[["d"]],["result",["ty"]]]],[5,"decode_predicates","","",N,[[["d"]],["result",["genericpredicates"]]]],[5,"decode_substs","","",N,[[["d"]],["result",["substs"]]]],[5,"decode_region","","",N,[[["d"]],["result",["region"]]]],[5,"decode_ty_slice","","",N,[[["d"]],["result",["slice"]]]],[5,"decode_adt_def","","",N,[[["d"]],["result",["adtdef"]]]],[5,"decode_existential_predicate_slice","","",N,[[["d"]],["result",["slice"]]]],[5,"decode_canonical_var_infos","","",N,[[["d"]],["result",["canonicalvarinfos"]]]],[5,"decode_const","","",N,[[["d"]],["result",["const"]]]],[5,"decode_allocation","","",N,[[["d"]],["result",["allocation"]]]],[17,"SHORTHAND_OFFSET","","The shorthand encoding uses an enum's variant index `usize` and is offset by this value so it never matches a real variant. This offset is also chosen so that the first byte is never < 0x80.",N,N],[8,"EncodableWithShorthand","","",N,N],[16,"Variant","","",757,N],[10,"variant","","",757,N],[8,"TyEncoder","","",N,N],[10,"position","","",758,[[["self"]],["usize"]]],[8,"TyDecoder","","",N,N],[10,"tcx","","",759,[[["self"]],["tyctxt"]]],[10,"peek_byte","","",759,[[["self"]],["u8"]]],[10,"position","","",759,[[["self"]],["usize"]]],[10,"cached_ty_for_shorthand","","",759,[[["self"],["usize"],["f"]],["result",["ty"]]]],[10,"with_position","","",759,[[["self"],["usize"],["f"]],["r"]]],[10,"map_encoded_cnum_to_current","","",759,[[["self"],["cratenum"]],["cratenum"]]],[11,"positioned_at_shorthand","","",759,[[["self"]],["bool"]]],[11,"variant","rustc::ty","",739,N],[0,"error","","",N,N],[3,"ExpectedFound","rustc::ty::error","",N,N],[12,"expected","","",760,N],[12,"found","","",760,N],[4,"TypeError","","",N,N],[13,"Mismatch","","",761,N],[13,"UnsafetyMismatch","","",761,N],[13,"AbiMismatch","","",761,N],[13,"Mutability","","",761,N],[13,"TupleSize","","",761,N],[13,"FixedArraySize","","",761,N],[13,"ArgCount","","",761,N],[13,"RegionsDoesNotOutlive","","",761,N],[13,"RegionsInsufficientlyPolymorphic","","",761,N],[13,"RegionsOverlyPolymorphic","","",761,N],[13,"Sorts","","",761,N],[13,"IntMismatch","","",761,N],[13,"FloatMismatch","","",761,N],[13,"Traits","","",761,N],[13,"VariadicMismatch","","",761,N],[13,"CyclicTy","","Instantiating a type variable with the given type would have created a cycle (because it appears somewhere within that type).",761,N],[13,"ProjectionMismatched","","",761,N],[13,"ProjectionBoundsLength","","",761,N],[13,"ExistentialMismatch","","",761,N],[13,"OldStyleLUB","","",761,N],[4,"UnconstrainedNumeric","","",N,N],[13,"UnconstrainedFloat","","",762,N],[13,"UnconstrainedInt","","",762,N],[13,"Neither","","",762,N],[11,"clone","","",760,[[["self"]],["expectedfound"]]],[11,"fmt","","",760,[[["self"],["formatter"]],["result"]]],[11,"clone","","",761,[[["self"]],["typeerror"]]],[11,"fmt","","",761,[[["self"],["formatter"]],["result"]]],[11,"clone","","",762,[[["self"]],["unconstrainednumeric"]]],[11,"encode","","",762,[[["self"],["__s"]],["result"]]],[11,"decode","","",762,[[["__d"]],["result",["unconstrainednumeric"]]]],[11,"eq","","",762,[[["self"],["unconstrainednumeric"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",762,N],[11,"hash","","",762,N],[11,"fmt","","",762,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",761,[[["self"],["formatter"]],["result"]]],[11,"sort_string","rustc::ty","",696,[[["self"],["tyctxt"]],["string"]]],[11,"note_and_explain_type_err","","",684,[[["self"],["diagnosticbuilder"],["typeerror"],["span"]]]],[0,"erase_regions","","",N,N],[3,"RegionEraserVisitor","rustc::ty::erase_regions","",N,N],[12,"tcx","","",763,N],[5,"provide","","",N,[[["providers"]]]],[5,"erase_regions_ty","","",N,[[["tyctxt"],["ty"]],["ty"]]],[11,"erase_regions","rustc::ty","Returns an equivalent value with all free regions removed (note that late-bound regions remain, because they are important for subtyping, but they are anonymized and normalized as well)..",684,[[["self"],["t"]],["t"]]],[11,"tcx","rustc::ty::erase_regions","",763,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",763,[[["self"],["ty"]],["ty"]]],[11,"fold_binder","","",763,[[["self"],["binder"]],["binder"]]],[11,"fold_region","","",763,[[["self"],["region"]],["region"]]],[0,"fast_reject","rustc::ty","",N,N],[4,"SimplifiedTypeGen","rustc::ty::fast_reject","See `simplify_type`",N,N],[13,"BoolSimplifiedType","","",764,N],[13,"CharSimplifiedType","","",764,N],[13,"IntSimplifiedType","","",764,N],[13,"UintSimplifiedType","","",764,N],[13,"FloatSimplifiedType","","",764,N],[13,"AdtSimplifiedType","","",764,N],[13,"StrSimplifiedType","","",764,N],[13,"ArraySimplifiedType","","",764,N],[13,"PtrSimplifiedType","","",764,N],[13,"NeverSimplifiedType","","",764,N],[13,"TupleSimplifiedType","","",764,N],[13,"TraitSimplifiedType","","",764,N],[13,"ClosureSimplifiedType","","",764,N],[13,"GeneratorSimplifiedType","","",764,N],[13,"GeneratorWitnessSimplifiedType","","",764,N],[13,"AnonSimplifiedType","","",764,N],[13,"FunctionSimplifiedType","","",764,N],[13,"ParameterSimplifiedType","","",764,N],[13,"ForeignSimplifiedType","","",764,N],[5,"simplify_type","","Tries to simplify a type by dropping type parameters, deref'ing away any reference types, etc. The idea is to get something simple that we can use to quickly decide if two types could unify during method lookup.",N,[[["tyctxt"],["ty"],["bool"]],["option",["simplifiedtype"]]]],[6,"SimplifiedType","","",N,N],[11,"clone","","",764,[[["self"]],["simplifiedtypegen"]]],[11,"fmt","","",764,[[["self"],["formatter"]],["result"]]],[11,"eq","","",764,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"ne","","",764,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",764,N],[11,"hash","","",764,N],[11,"partial_cmp","","",764,[[["self"],["simplifiedtypegen"]],["option",["ordering"]]]],[11,"lt","","",764,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"le","","",764,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"gt","","",764,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"ge","","",764,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"cmp","","",764,[[["self"],["simplifiedtypegen"]],["ordering"]]],[11,"encode","","",764,[[["self"],["__sd"]],["result"]]],[11,"decode","","",764,[[["__dd"]],["result",["simplifiedtypegen"]]]],[11,"map_def","","",764,[[["self"],["f"]],["simplifiedtypegen"]]],[11,"hash_stable","","",764,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"fold","rustc::ty","Generalized type folding mechanism. The setup is a bit convoluted but allows for convenient usage. Let T be an instance of some \"foldable type\" (one which implements `TypeFoldable`) and F be an instance of a \"folder\" (a type which implements `TypeFolder`). Then the setup is intended to be:",N,N],[3,"BottomUpFolder","rustc::ty::fold","",N,N],[12,"tcx","","",765,N],[12,"fldop","","",765,N],[12,"reg_op","","",765,N],[3,"RegionFolder","","Folds over the substructure of a type, visiting its component types and all regions that occur free within it.",N,N],[12,"tcx","","",766,N],[12,"skipped_regions","","",766,N],[12,"current_index","","Stores the index of a binder just outside the stuff we have visited.  So this begins as INNERMOST; when we pass through a binder, it is incremented (via `shift_in`).",766,N],[12,"fold_region_fn","","Callback invokes for each free region. The `DebruijnIndex` points to the binder just outside the ones we have passed through.",766,N],[3,"RegionReplacer","","",N,N],[12,"tcx","","",767,N],[12,"current_index","","As with `RegionFolder`, represents the index of a binder just outside the ones we have visited.",767,N],[12,"fld_r","","",767,N],[12,"map","","",767,N],[3,"HasEscapingRegionsVisitor","","An \"escaping region\" is a bound region whose binder is not part of `t`.",N,N],[12,"outer_index","","Anything bound by `outer_index` or \"above\" is escaping",768,N],[3,"HasTypeFlagsVisitor","","",N,N],[12,"flags","","",769,N],[3,"LateBoundRegionsCollector","","Collects all the late-bound regions at the innermost binding level into a hash set.",N,N],[12,"current_index","","",770,N],[12,"regions","","",770,N],[12,"just_constrained","","If true, we only want regions that are known to be \"constrained\" when you equate this type with another type. In partcular, if you have e.g. `&'a u32` and `&'b u32`, equating them constraints `'a == 'b`.  But if you have `<&'a u32 as Trait>::Foo` and `<&'b u32 as Trait>::Foo`, normalizing those types may mean that `'a` and `'b` don't appear in the results, so they are not considered constrained.",770,N],[5,"shift_region","","",N,[[["regionkind"],["u32"]],["regionkind"]]],[5,"shift_region_ref","","",N,[[["tyctxt"],["region"],["u32"]],["region"]]],[5,"shift_regions","","",N,[[["tyctxt"],["u32"],["t"]],["t"]]],[8,"TypeFoldable","","The TypeFoldable trait is implemented for every type that can be folded. Basically, every type that has a corresponding method in TypeFolder.",N,N],[10,"super_fold_with","","",771,[[["self"],["f"]],["self"]]],[11,"fold_with","","",771,[[["self"],["f"]],["self"]]],[10,"super_visit_with","","",771,[[["self"],["v"]],["bool"]]],[11,"visit_with","","",771,[[["self"],["v"]],["bool"]]],[11,"has_regions_bound_at_or_above","","True if `self` has any late-bound regions that are either bound by `binder` or bound by some binder outside of `binder`. If `binder` is `ty::INNERMOST`, this indicates whether there are any late-bound regions that appear free.",771,[[["self"],["debruijnindex"]],["bool"]]],[11,"has_regions_bound_above","","True if this `self` has any regions that escape `binder` (and hence are not bound by it).",771,[[["self"],["debruijnindex"]],["bool"]]],[11,"has_escaping_regions","","",771,[[["self"]],["bool"]]],[11,"has_type_flags","","",771,[[["self"],["typeflags"]],["bool"]]],[11,"has_projections","","",771,[[["self"]],["bool"]]],[11,"references_error","","",771,[[["self"]],["bool"]]],[11,"has_param_types","","",771,[[["self"]],["bool"]]],[11,"has_self_ty","","",771,[[["self"]],["bool"]]],[11,"has_infer_types","","",771,[[["self"]],["bool"]]],[11,"needs_infer","","",771,[[["self"]],["bool"]]],[11,"has_skol","","",771,[[["self"]],["bool"]]],[11,"needs_subst","","",771,[[["self"]],["bool"]]],[11,"has_re_skol","","",771,[[["self"]],["bool"]]],[11,"has_closure_types","","",771,[[["self"]],["bool"]]],[11,"has_free_regions","","\"Free\" regions in this context means that it has any region that is not (a) erased or (b) late-bound.",771,[[["self"]],["bool"]]],[11,"has_erasable_regions","","True if there any any un-erased free regions.",771,[[["self"]],["bool"]]],[11,"is_global","","Indicates whether this value references only 'global' types/lifetimes that are the same regardless of what fn we are in. This is used for caching.",771,[[["self"]],["bool"]]],[11,"has_late_bound_regions","","True if there are any late-bound regions",771,[[["self"]],["bool"]]],[11,"visit_tys_shallow","","A visitor that does not recurse into types, works like `fn walk_shallow` in `Ty`.",771,N],[8,"TypeFolder","","The TypeFolder trait defines the actual folding. There is a method defined for every foldable type. Each of these has a default implementation that does an \"identity\" fold. Within each identity fold, it should invoke `foo.fold_with(self)` to fold each sub-item.",N,N],[10,"tcx","","",772,[[["self"]],["tyctxt"]]],[11,"fold_binder","","",772,[[["self"],["binder"]],["binder"]]],[11,"fold_ty","","",772,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",772,[[["self"],["region"]],["region"]]],[11,"fold_const","","",772,[[["self"],["const"]],["const"]]],[8,"TypeVisitor","","",N,N],[11,"visit_binder","","",773,[[["self"],["binder"]],["bool"]]],[11,"visit_ty","","",773,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",773,[[["self"],["region"]],["bool"]]],[11,"visit_const","","",773,[[["self"],["const"]],["bool"]]],[11,"tcx","","",765,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",765,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",765,[[["self"],["region"]],["region"]]],[11,"collect_regions","rustc::ty","Collects the free and escaping regions in `value` into `region_set`. Returns whether any late-bound regions were skipped",684,[[["self"],["t"],["fxhashset"]],["bool"]]],[11,"fold_regions","","Folds the escaping and free regions in `value` using `f`, and sets `skipped_regions` to true if any late-bound region was found and skipped.",684,N],[11,"for_each_free_region","","Invoke `callback` on every region appearing free in `value`.",684,N],[11,"all_free_regions_meet","","True if `callback` returns true for every region appearing free in `value`.",684,N],[11,"any_free_region_meets","","True if `callback` returns true for some region appearing free in `value`.",684,N],[11,"new","rustc::ty::fold","",766,[[["tyctxt"],["bool"],["fnmut"]],["regionfolder"]]],[11,"tcx","","",766,[[["self"]],["tyctxt"]]],[11,"fold_binder","","",766,[[["self"],["binder"]],["binder"]]],[11,"fold_region","","",766,[[["self"],["region"]],["region"]]],[11,"replace_late_bound_regions","rustc::ty","Replace all regions bound by the given `Binder` with the results returned by the closure; the closure is expected to return a free region (relative to this binder), and hence the binder is removed in the return type. The closure is invoked once for each unique `BoundRegion`; multiple references to the same `BoundRegion` will reuse the previous result.  A map is returned at the end with each bound region and the free region that replaced it.",684,N],[11,"liberate_late_bound_regions","","Replace any late-bound regions bound in `value` with free variants attached to `all_outlive_scope`.",684,[[["self"],["defid"],["binder"]],["t"]]],[11,"flatten_late_bound_regions","","Flattens multiple binding levels into one. So `for<'a> for<'b> Foo` becomes `for<'a,'b> Foo`.",684,[[["self"],["binder"]],["binder"]]],[11,"collect_constrained_late_bound_regions","","Returns a set of all late-bound regions that are constrained by `value`, meaning that if we instantiate those LBR with variables and equate `value` with something else, those variables will also be equated.",684,[[["self"],["binder"]],["fxhashset",["boundregion"]]]],[11,"collect_referenced_late_bound_regions","","Returns a set of all late-bound regions that appear in `value` anywhere.",684,[[["self"],["binder"]],["fxhashset",["boundregion"]]]],[11,"collect_late_bound_regions","","",684,[[["self"],["binder"],["bool"]],["fxhashset",["boundregion"]]]],[11,"erase_late_bound_regions","","Replace any late-bound regions bound in `value` with `'erased`. Useful in codegen but also method lookup and a few other places where precise region relationships are not required.",684,[[["self"],["binder"]],["t"]]],[11,"anonymize_late_bound_regions","","Rewrite any late-bound regions so that they are anonymous.  Region numbers are assigned starting at 1 and increasing monotonically in the order traversed by the fold operation.",684,[[["self"],["binder"]],["binder"]]],[11,"new","rustc::ty::fold","",767,[[["tyctxt"],["f"]],["regionreplacer"]]],[11,"tcx","","",767,[[["self"]],["tyctxt"]]],[11,"fold_binder","","",767,[[["self"],["binder"]],["binder"]]],[11,"fold_ty","","",767,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",767,[[["self"],["region"]],["region"]]],[11,"visit_binder","","",768,[[["self"],["binder"]],["bool"]]],[11,"visit_ty","","",768,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",768,[[["self"],["region"]],["bool"]]],[11,"visit_ty","","",769,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",769,[[["self"],["region"]],["bool"]]],[11,"visit_const","","",769,[[["self"],["const"]],["bool"]]],[11,"new","","",770,[[["bool"]],["self"]]],[11,"visit_binder","","",770,[[["self"],["binder"]],["bool"]]],[11,"visit_ty","","",770,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",770,[[["self"],["region"]],["bool"]]],[0,"inhabitedness","rustc::ty","",N,N],[3,"DefIdForest","rustc::ty::inhabitedness","Represents a forest of DefIds closed under the ancestor relation. That is, if a DefId representing a module is contained in the forest then all DefIds defined in that module or submodules are also implicitly contained in the forest.",N,N],[12,"root_ids","","The minimal set of DefIds required to represent the whole set. If A and B are DefIds in the DefIdForest, and A is a descendant of B, then only B will be in root_ids. We use a SmallVec here because (for its use for caching inhabitedness) its rare that this will contain even two ids.",774,N],[0,"def_id_forest","","",N,N],[3,"DefIdForest","rustc::ty::inhabitedness::def_id_forest","Represents a forest of DefIds closed under the ancestor relation. That is, if a DefId representing a module is contained in the forest then all DefIds defined in that module or submodules are also implicitly contained in the forest.",N,N],[12,"root_ids","","The minimal set of DefIds required to represent the whole set. If A and B are DefIds in the DefIdForest, and A is a descendant of B, then only B will be in root_ids. We use a SmallVec here because (for its use for caching inhabitedness) its rare that this will contain even two ids.",774,N],[11,"clone","rustc::ty::inhabitedness","",774,[[["self"]],["defidforest"]]],[11,"empty","","Create an empty forest.",774,[[],["defidforest"]]],[11,"full","","Create a forest consisting of a single tree representing the entire crate.",774,[[["tyctxt"]],["defidforest"]]],[11,"from_id","","Create a forest containing a DefId and all its descendants.",774,[[["defid"]],["defidforest"]]],[11,"is_empty","","Test whether the forest is empty.",774,[[["self"]],["bool"]]],[11,"contains","","Test whether the forest contains a given DefId.",774,[[["self"],["tyctxt"],["defid"]],["bool"]]],[11,"intersection","","Calculate the intersection of a collection of forests.",774,[[["tyctxt"],["i"]],["defidforest"]]],[11,"union","","Calculate the union of a collection of forests.",774,[[["tyctxt"],["i"]],["defidforest"]]],[11,"is_ty_uninhabited_from","rustc::ty","Checks whether a type is visibly uninhabited from a particular module. # Example ```rust enum Void {} mod a {     pub mod b {         pub struct SecretlyUninhabited {             _priv: !,         }     } }",684,[[["self"],["defid"],["ty"]],["bool"]]],[11,"is_ty_uninhabited_from_all_modules","","",684,[[["self"],["ty"]],["bool"]]],[11,"ty_inhabitedness_forest","","",684,[[["self"],["ty"]],["defidforest"]]],[11,"is_enum_variant_uninhabited_from","","",684,[[["self"],["defid"],["variantdef"],["substs"]],["bool"]]],[11,"is_variant_uninhabited_from_all_modules","","",684,[[["self"],["variantdef"],["substs"]],["bool"]]],[11,"variant_inhabitedness_forest","","",684,[[["self"],["variantdef"],["substs"]],["defidforest"]]],[11,"uninhabited_from","","Calculate the forest of DefIds from which this adt is visibly uninhabited.",719,[[["self"],["fxhashmap"],["tyctxt"],["substs"]],["defidforest"]]],[11,"uninhabited_from","","Calculate the forest of DefIds from which this variant is visibly uninhabited.",717,[[["self"],["fxhashmap"],["tyctxt"],["substs"],["adtkind"]],["defidforest"]]],[11,"uninhabited_from","","Calculate the forest of DefIds from which this field is visibly uninhabited.",718,[[["self"],["fxhashmap"],["tyctxt"],["substs"],["bool"]],["defidforest"]]],[11,"uninhabited_from","","Calculate the forest of DefIds from which this type is visibly uninhabited.",696,[[["self"],["fxhashmap"],["tyctxt"]],["defidforest"]]],[0,"item_path","","",N,N],[3,"LocalPathBuffer","rustc::ty::item_path","",N,N],[12,"root_mode","","",775,N],[12,"str","","",775,N],[4,"RootMode","","",N,N],[13,"Local","","Try to make a path relative to the local crate.  In particular, local paths have no prefix, and if the path comes from an extern crate, start with the path to the `extern crate` declaration.",776,N],[13,"Absolute","","Always prepend the crate name to the path, forming an absolute path from within a given set of crates.",776,N],[5,"with_forced_absolute_paths","","Enforces that item_path_str always returns an absolute path and also enables \"type-based\" impl paths. This is used when building symbols that contain types, where we want the crate name to be part of the symbol.",N,[[["f"]],["r"]]],[5,"with_forced_impl_filename_line","","Force us to name impls with just the filename/line number. We normally try to use types. But at some points, notably while printing cycle errors, this can result in extra or suboptimal error output, so this variable disables that check.",N,[[["f"]],["r"]]],[5,"characteristic_def_id_of_type","","As a heuristic, when we see an impl, if we see that the 'self-type' is a type defined in the same module as the impl, we can omit including the path to the impl itself. This function tries to find a \"characteristic def-id\" for a type. It's just a heuristic so it makes some questionable decisions and we may want to adjust it later.",N,[[["ty"]],["option",["defid"]]]],[17,"FORCE_ABSOLUTE","","",N,N],[17,"FORCE_IMPL_FILENAME_LINE","","",N,N],[8,"ItemPathBuffer","","Unifying Trait for different kinds of item paths we might construct. The basic interface is that components get pushed: the instance can also customize how we handle the root of a crate.",N,N],[10,"root_mode","","",777,[[["self"]],["rootmode"]]],[10,"push","","",777,[[["self"],["str"]]]],[11,"item_path_str","rustc::ty","Returns a string identifying this def-id. This string is suitable for user output. It is relative to the current crate root, unless with_forced_absolute_paths was used.",684,[[["self"],["defid"]],["string"]]],[11,"node_path_str","","Returns a string identifying this local node-id.",684,[[["self"],["nodeid"]],["string"]]],[11,"absolute_item_path_str","","Returns a string identifying this def-id. This string is suitable for user output. It always begins with a crate identifier.",684,[[["self"],["defid"]],["string"]]],[11,"push_krate_path","","Returns the \"path\" to a particular crate. This can proceed in various ways, depending on the `root_mode` of the `buffer`. (See `RootMode` enum for more details.)",684,[[["self"],["t"],["cratenum"]]]],[11,"try_push_visible_item_path","","If possible, this pushes a global path resolving to `external_def_id` that is visible from at least one local module and returns true. If the crate defining `external_def_id` is declared with an `extern crate`, the path is guaranteed to use the `extern crate`.",684,[[["self"],["t"],["defid"]],["bool"]]],[11,"push_item_path","","",684,[[["self"],["t"],["defid"]]]],[11,"push_impl_path","","",684,[[["self"],["t"],["defid"]]]],[11,"push_impl_path_fallback","","",684,[[["self"],["t"],["defid"]]]],[11,"parent_def_id","","Returns the def-id of `def_id`'s parent in the def tree. If this returns `None`, then `def_id` represents a crate root or inlined root.",684,[[["self"],["defid"]],["option",["defid"]]]],[11,"fmt","rustc::ty::item_path","",776,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",775,[[["self"],["formatter"]],["result"]]],[11,"new","","",775,[[["rootmode"]],["localpathbuffer"]]],[11,"into_string","","",775,[[["self"]],["string"]]],[11,"root_mode","","",775,[[["self"]],["rootmode"]]],[11,"push","","",775,[[["self"],["str"]]]],[0,"layout","rustc::ty","",N,N],[0,"call","rustc::ty::layout","",N,N],[4,"PassMode","rustc::ty::layout::call","",N,N],[13,"Ignore","","Ignore the argument (useful for empty struct).",778,N],[13,"Direct","","Pass the argument directly.",778,N],[13,"Pair","","Pass a pair's elements directly in two arguments.",778,N],[13,"Cast","","Pass the argument after casting it, to either a single uniform or a pair of registers.",778,N],[13,"Indirect","","Pass the argument indirectly via a hidden pointer.",778,N],[3,"ArgAttributes","","A compact representation of LLVM attributes (at least those relevant for this module) that can be manipulated without interacting with LLVM's Attribute machinery.",N,N],[12,"regular","","",779,N],[12,"pointee_size","","",779,N],[12,"pointee_align","","",779,N],[4,"RegKind","","",N,N],[13,"Integer","","",780,N],[13,"Float","","",780,N],[13,"Vector","","",780,N],[3,"Reg","","",N,N],[12,"kind","","",781,N],[12,"size","","",781,N],[3,"Uniform","","An argument passed entirely registers with the same kind (e.g. HFA / HVA on PPC64 and AArch64).",N,N],[12,"unit","","",782,N],[12,"total","","The total size of the argument, which can be: * equal to `unit.size` (one scalar/vector) * a multiple of `unit.size` (an array of scalar/vectors) * if `unit.kind` is `Integer`, the last element   can be shorter, i.e. `{ i64, i64, i32 }` for   64-bit integers with a total size of 20 bytes",782,N],[3,"CastTarget","","",N,N],[12,"prefix","","",783,N],[12,"prefix_chunk","","",783,N],[12,"rest","","",783,N],[3,"ArgType","","Information about how to pass an argument to, or return a value from, a function, under some ABI.",N,N],[12,"layout","","",784,N],[12,"pad","","Dummy argument, which is emitted before the real argument.",784,N],[12,"mode","","",784,N],[4,"Conv","","",N,N],[13,"C","","",785,N],[13,"ArmAapcs","","",785,N],[13,"Msp430Intr","","",785,N],[13,"PtxKernel","","",785,N],[13,"X86Fastcall","","",785,N],[13,"X86Intr","","",785,N],[13,"X86Stdcall","","",785,N],[13,"X86ThisCall","","",785,N],[13,"X86VectorCall","","",785,N],[13,"X86_64SysV","","",785,N],[13,"X86_64Win64","","",785,N],[13,"AmdGpuKernel","","",785,N],[3,"FnType","","Metadata describing how the arguments to a native function should be passed in order to respect the native ABI.",N,N],[12,"args","","The LLVM types of each argument.",786,N],[12,"ret","","LLVM return type.",786,N],[12,"variadic","","",786,N],[12,"conv","","",786,N],[3,"ArgAttribute","","",N,N],[12,"bits","","",787,N],[3,"TargetDataLayout","rustc::ty::layout","Parsed Data layout for a target, which contains everything needed to compute layouts.",N,N],[12,"endian","","",788,N],[12,"i1_align","","",788,N],[12,"i8_align","","",788,N],[12,"i16_align","","",788,N],[12,"i32_align","","",788,N],[12,"i64_align","","",788,N],[12,"i128_align","","",788,N],[12,"f32_align","","",788,N],[12,"f64_align","","",788,N],[12,"pointer_size","","",788,N],[12,"pointer_align","","",788,N],[12,"aggregate_align","","",788,N],[12,"vector_align","","Alignments for vector types.",788,N],[8,"HasDataLayout","","",N,N],[10,"data_layout","","",789,[[["self"]],["targetdatalayout"]]],[4,"Endian","","Endianness of the target, which must match cfg(target-endian).",N,N],[13,"Little","","",790,N],[13,"Big","","",790,N],[3,"Size","","Size of a type in bytes.",N,N],[12,"raw","","",791,N],[3,"Align","","Alignment of a type in bytes, both ABI-mandated and preferred. Each field is a power of two, giving the alignment a maximum value of 2(28 - 1), which is limited by LLVM to a maximum capacity of 229 or 536870912.",N,N],[12,"abi_pow2","","",792,N],[12,"pref_pow2","","",792,N],[4,"Integer","","Integers, also used for enum discriminants.",N,N],[13,"I8","","",793,N],[13,"I16","","",793,N],[13,"I32","","",793,N],[13,"I64","","",793,N],[13,"I128","","",793,N],[4,"FloatTy","","",N,N],[13,"F32","","",794,N],[13,"F64","","",794,N],[4,"Primitive","","Fundamental unit of memory access and layout.",N,N],[13,"Int","","The `bool` is the signedness of the `Integer` type.",795,N],[13,"Float","","",795,N],[13,"Pointer","","",795,N],[3,"Scalar","","Information about one scalar component of a Rust type.",N,N],[12,"value","","",796,N],[12,"valid_range","","Inclusive wrap-around range of valid values, that is, if min > max, it represents min..=u128::MAX followed by 0..=max.",796,N],[4,"FieldPlacement","","Describes how the fields of a type are located in memory.",N,N],[13,"Union","","All fields start at no offset. The `usize` is the field count.",797,N],[13,"Array","","Array/vector-like placement, with all fields of identical types.",797,N],[12,"stride","rustc::ty::layout::FieldPlacement","",797,N],[12,"count","","",797,N],[13,"Arbitrary","rustc::ty::layout","Struct-like placement, with precomputed offsets.",797,N],[12,"offsets","rustc::ty::layout::FieldPlacement","Offsets for the first byte of each field, ordered to match the source definition order. This vector does not go in increasing order.",797,N],[12,"memory_index","","Maps source order field indices to memory order indices, depending how fields were permuted.",797,N],[4,"Abi","rustc::ty::layout","Describes how values of the type are passed by target ABIs, in terms of categories of C types there are ABI rules for.",N,N],[13,"Uninhabited","","",798,N],[13,"Scalar","","",798,N],[13,"ScalarPair","","",798,N],[13,"Vector","","",798,N],[12,"element","rustc::ty::layout::Abi","",798,N],[12,"count","","",798,N],[13,"Aggregate","rustc::ty::layout","",798,N],[12,"sized","rustc::ty::layout::Abi","If true, the size is exact, otherwise it's only a lower bound.",798,N],[4,"Variants","rustc::ty::layout","",N,N],[13,"Single","","Single enum variants, structs/tuples, unions, and all non-ADTs.",799,N],[12,"index","rustc::ty::layout::Variants","",799,N],[13,"Tagged","rustc::ty::layout","General-case enums: for each case there is a struct, and they all have all space reserved for the tag, and their first field starts at a non-0 offset, after where the tag would go.",799,N],[12,"tag","rustc::ty::layout::Variants","",799,N],[12,"variants","","",799,N],[13,"NicheFilling","rustc::ty::layout","Multiple cases distinguished by a niche (values invalid for a type): the variant `dataful_variant` contains a niche at an arbitrary offset (field 0 of the enum), which for a variant with discriminant `d` is set to `(d - niche_variants.start).wrapping_add(niche_start)`.",799,N],[12,"dataful_variant","rustc::ty::layout::Variants","",799,N],[12,"niche_variants","","",799,N],[12,"niche","","",799,N],[12,"niche_start","","",799,N],[12,"variants","","",799,N],[3,"LayoutDetails","rustc::ty::layout","",N,N],[12,"variants","","",800,N],[12,"fields","","",800,N],[12,"abi","","",800,N],[12,"align","","",800,N],[12,"size","","",800,N],[3,"TyLayout","","The details of the layout of a type, alongside the type itself. Provides various type traversal APIs (e.g. recursing into fields).",N,N],[12,"ty","","",801,N],[12,"details","","",801,N],[8,"LayoutOf","","",N,N],[16,"Ty","","",802,N],[16,"TyLayout","","",802,N],[10,"layout_of","","",802,N],[8,"TyLayoutMethods","","",N,N],[10,"for_variant","","",803,[[["tylayout"],["c"],["usize"]],["tylayout"]]],[10,"field","","",803,N],[3,"LayoutCx","","",N,N],[12,"tcx","","",804,N],[12,"param_env","","",804,N],[3,"Niche","","",N,N],[12,"offset","","",805,N],[12,"scalar","","",805,N],[12,"available","","",805,N],[4,"LayoutError","","",N,N],[13,"Unknown","","",806,N],[13,"SizeOverflow","","",806,N],[4,"SizeSkeleton","","Type size \"skeleton\", i.e. the only information determining a type's size. While this is conservative, (aside from constant sizes, only pointers, newtypes thereof and null pointer optimized enums are allowed), it is enough to statically check common usecases of transmute.",N,N],[13,"Known","","Any statically computable Layout.",807,N],[13,"Pointer","","A potentially-fat pointer.",807,N],[12,"non_zero","rustc::ty::layout::SizeSkeleton","If true, this pointer is never null.",807,N],[12,"tail","","The type which determines the unsized metadata, if any, of this pointer. Either a type parameter or a projection depending on one, with regions erased.",807,N],[5,"layout_raw","rustc::ty::layout","",N,[[["tyctxt"],["paramenvand",["ty"]]],["result",["layoutdetails","layouterror"]]]],[5,"provide","","",N,[[["providers"]]]],[6,"TyLayout","","",N,N],[17,"FAT_PTR_ADDR","","The first half of a fat pointer.",N,N],[17,"FAT_PTR_EXTRA","","The second half of a fat pointer.",N,N],[8,"IntegerExt","","",N,N],[10,"to_ty","","",808,[[["self"],["tyctxt"],["bool"]],["ty"]]],[10,"from_attr","","",808,[[["c"],["inttype"]],["integer"]]],[10,"repr_discr","","",808,N],[8,"PrimitiveExt","","",N,N],[10,"to_ty","","",809,[[["self"],["tyctxt"]],["ty"]]],[8,"HasTyCtxt","","",N,N],[10,"tcx","","",810,[[["self"]],["tyctxt"]]],[8,"MaybeResult","","",N,N],[10,"from_ok","","",811,[[["t"]],["self"]]],[10,"map_same","","",811,[[["self"],["f"]],["self"]]],[11,"to_ty","","",793,[[["self"],["tyctxt"],["bool"]],["ty"]]],[11,"from_attr","","Get the Integer type from an attr::IntType.",793,[[["c"],["inttype"]],["integer"]]],[11,"repr_discr","","Find the appropriate Integer type and signedness for the given signed discriminant range and #[repr] attribute. N.B.: u128 values above i128::MAX will be treated as signed, but that shouldn't affect anything, other than maybe debuginfo.",793,N],[11,"to_ty","","",795,[[["self"],["tyctxt"]],["ty"]]],[11,"clone","","",806,[[["self"]],["layouterror"]]],[11,"fmt","","",806,[[["self"],["formatter"]],["result"]]],[11,"encode","","",806,[[["self"],["__s"]],["result"]]],[11,"decode","","",806,[[["__d"]],["result",["layouterror"]]]],[11,"fmt","","",806,[[["self"],["formatter"]],["result"]]],[11,"clone","","",804,[[["self"]],["layoutcx"]]],[11,"layout_raw_uncached","","",804,[[["self"],["ty"]],["result",["layoutdetails","layouterror"]]]],[11,"record_layout_for_printing","","This is invoked by the `layout_raw` query to record the final layout of each type.",804,[[["self"],["tylayout"]]]],[11,"record_layout_for_printing_outlined","","",804,[[["self"],["tylayout"]]]],[11,"clone","","",807,[[["self"]],["sizeskeleton"]]],[11,"fmt","","",807,[[["self"],["formatter"]],["result"]]],[11,"compute","","",807,[[["ty"],["tyctxt"],["paramenv"]],["result",["sizeskeleton","layouterror"]]]],[11,"same_size","","",807,[[["self"],["sizeskeleton"]],["bool"]]],[11,"data_layout","rustc::ty","",684,[[["self"]],["targetdatalayout"]]],[11,"tcx","","",684,[[["self"]],["tyctxt"]]],[11,"data_layout","rustc::ty::layout","",804,[[["self"]],["targetdatalayout"]]],[11,"tcx","","",804,[[["self"]],["tyctxt"]]],[11,"layout_of","","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",804,N],[11,"layout_of","","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",804,N],[11,"layout_of","rustc::ty","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",684,[[["self"],["paramenvand",["ty"]]],["result",["tylayout","layouterror"]]]],[11,"reserve","rustc::ty::layout","",805,[[["self"],["layoutcx",["tyctxt"]],["u128"]],["option"]]],[11,"find_niche","","Find the offset of a niche leaf field, starting from the given type and recursing through aggregates.",804,[[["self"],["tylayout"]],["result",["option","layouterror"]]]],[11,"hash_stable","","",799,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",797,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",798,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",796,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",800,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",793,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",795,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",792,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",791,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",806,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"_match","rustc::ty","",N,N],[3,"Match","rustc::ty::_match","A type \"A\" matches \"B\" if the fresh types in B could be substituted with values so as to make it equal to A. Matching is intended to be used only on freshened types, and it basically indicates if the non-freshened versions of A and B could have been unified.",N,N],[12,"tcx","","",812,N],[11,"new","","",812,[[["tyctxt"]],["match"]]],[11,"tag","","",812,[[["self"]],["str"]]],[11,"tcx","","",812,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",812,[[["self"]],["bool"]]],[11,"relate_with_variance","","",812,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"regions","","",812,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"tys","","",812,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"binders","","",812,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[0,"outlives","rustc::ty","",N,N],[4,"Component","rustc::ty::outlives","",N,N],[13,"Region","","",813,N],[13,"Param","","",813,N],[13,"UnresolvedInferenceVariable","","",813,N],[13,"Projection","","",813,N],[13,"EscapingProjection","","",813,N],[5,"push_region_constraints","","",N,[[["vec"],["vec",["region"]]]]],[11,"fmt","","",813,[[["self"],["formatter"]],["result"]]],[11,"outlives_components","rustc::ty","Returns all the things that must outlive `'a` for the condition `ty0: 'a` to hold. Note that `ty0` must be a fully resolved type.",684,[[["self"],["ty"]],["vec",["component"]]]],[11,"compute_components","","",684,[[["self"],["ty"],["vec"]]]],[11,"capture_components","","",684,[[["self"],["ty"]],["vec",["component"]]]],[0,"query","","",N,N],[3,"CycleError","rustc::ty::query","",N,N],[12,"usage","","The query and related span which uses the cycle",814,N],[12,"cycle","","",814,N],[3,"QueryJob","","A object representing an active query job.",N,N],[12,"info","","",815,N],[12,"parent","","The parent query job which created this job and is implicitly waiting on it.",815,N],[12,"diagnostics","","Diagnostic messages which are emitted while the query executes",815,N],[3,"QueryInfo","","A span and a query key",N,N],[12,"span","","The span for a reason this query was required",816,N],[12,"query","","",816,N],[3,"OnDiskCache","","`OnDiskCache` provides an interface to incr. comp. data cached from the previous compilation session. This data will eventually include the results of a few selected queries (like `typeck_tables_of` and `mir_optimized`) and any diagnostics that have been emitted during a query.",N,N],[12,"serialized_data","","",817,N],[12,"current_diagnostics","","",817,N],[12,"prev_cnums","","",817,N],[12,"cnum_map","","",817,N],[12,"codemap","","",817,N],[12,"file_index_to_stable_id","","",817,N],[12,"file_index_to_file","","",817,N],[12,"synthetic_expansion_infos","","",817,N],[12,"query_result_index","","",817,N],[12,"prev_diagnostics_index","","",817,N],[12,"alloc_decoding_state","","",817,N],[3,"Queries","","",N,N],[12,"on_disk_cache","","This provides access to the incr. comp. on-disk cache for query results. Do not access this directly. It is only meant to be used by `DepGraph::try_mark_green()` and the query infrastructure.",818,N],[12,"providers","","",818,N],[12,"type_of","","Records the type of every item.",818,N],[12,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics.",818,N],[12,"predicates_of","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) that must be proven true in order to reference it. This is almost always the \"predicates query\" that you want.",818,N],[12,"predicates_defined_on","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) directly defined on it. This is equal to the `explicit_predicates_of` predicates plus the `inferred_outlives_of` predicates.",818,N],[12,"explicit_predicates_of","","Returns the predicates written explicit by the user.",818,N],[12,"inferred_outlives_of","","Returns the inferred outlives predicates (e.g., for `struct Foo<'a, T> { x: &'a T }`, this would return `T: 'a`).",818,N],[12,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",818,N],[12,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",818,N],[12,"trait_def","","",818,N],[12,"adt_def","","",818,N],[12,"adt_destructor","","",818,N],[12,"adt_sized_constraint","","",818,N],[12,"adt_dtorck_constraint","","",818,N],[12,"is_const_fn","","True if this is a const fn",818,N],[12,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",818,N],[12,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",818,N],[12,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",818,N],[12,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",818,N],[12,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",818,N],[12,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",818,N],[12,"impl_trait_ref","","",818,N],[12,"impl_polarity","","",818,N],[12,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",818,N],[12,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",818,N],[12,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",818,N],[12,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",818,N],[12,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",818,N],[12,"mir_validated","","",818,N],[12,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for codegen. This is also the only query that can fetch non-local MIR, at present.",818,N],[12,"unsafety_check_result","","The result of unsafety-checking this def-id.",818,N],[12,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",818,N],[12,"fn_sig","","The signature of functions and closures.",818,N],[12,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",818,N],[12,"typeck_item_bodies","","",818,N],[12,"typeck_tables_of","","",818,N],[12,"used_trait_imports","","",818,N],[12,"has_typeck_tables","","",818,N],[12,"coherent_trait","","",818,N],[12,"borrowck","","",818,N],[12,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",818,N],[12,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",818,N],[12,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",818,N],[12,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",818,N],[12,"const_value_to_allocation","","Converts a constant value to an constant allocation",818,N],[12,"check_match","","",818,N],[12,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",818,N],[12,"reachable_set","","",818,N],[12,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",818,N],[12,"mir_shims","","",818,N],[12,"def_symbol_name","","",818,N],[12,"symbol_name","","",818,N],[12,"describe_def","","",818,N],[12,"def_span","","",818,N],[12,"lookup_stability","","",818,N],[12,"lookup_deprecation_entry","","",818,N],[12,"item_attrs","","",818,N],[12,"codegen_fn_attrs","","",818,N],[12,"fn_arg_names","","",818,N],[12,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",818,N],[12,"impl_parent","","",818,N],[12,"trait_of_item","","",818,N],[12,"const_is_rvalue_promotable_to_static","","",818,N],[12,"rvalue_promotable_map","","",818,N],[12,"is_mir_available","","",818,N],[12,"vtable_methods","","",818,N],[12,"codegen_fulfill_obligation","","",818,N],[12,"trait_impls_of","","",818,N],[12,"specialization_graph_of","","",818,N],[12,"is_object_safe","","",818,N],[12,"param_env","","",818,N],[12,"is_copy_raw","","",818,N],[12,"is_sized_raw","","",818,N],[12,"is_freeze_raw","","",818,N],[12,"needs_drop_raw","","",818,N],[12,"layout_raw","","",818,N],[12,"dylib_dependency_formats","","",818,N],[12,"is_panic_runtime","","",818,N],[12,"is_compiler_builtins","","",818,N],[12,"has_global_allocator","","",818,N],[12,"is_sanitizer_runtime","","",818,N],[12,"is_profiler_runtime","","",818,N],[12,"panic_strategy","","",818,N],[12,"is_no_builtins","","",818,N],[12,"extern_crate","","",818,N],[12,"specializes","","",818,N],[12,"in_scope_traits_map","","",818,N],[12,"module_exports","","",818,N],[12,"lint_levels","","",818,N],[12,"impl_defaultness","","",818,N],[12,"check_item_well_formed","","",818,N],[12,"check_trait_item_well_formed","","",818,N],[12,"check_impl_item_well_formed","","",818,N],[12,"reachable_non_generics","","",818,N],[12,"is_reachable_non_generic","","",818,N],[12,"is_unreachable_local_definition","","",818,N],[12,"upstream_monomorphizations","","",818,N],[12,"upstream_monomorphizations_for","","",818,N],[12,"native_libraries","","",818,N],[12,"foreign_modules","","",818,N],[12,"plugin_registrar_fn","","",818,N],[12,"derive_registrar_fn","","",818,N],[12,"crate_disambiguator","","",818,N],[12,"crate_hash","","",818,N],[12,"original_crate_name","","",818,N],[12,"extra_filename","","",818,N],[12,"implementations_of_trait","","",818,N],[12,"all_trait_implementations","","",818,N],[12,"dllimport_foreign_items","","",818,N],[12,"is_dllimport_foreign_item","","",818,N],[12,"is_statically_included_foreign_item","","",818,N],[12,"native_library_kind","","",818,N],[12,"link_args","","",818,N],[12,"resolve_lifetimes","","",818,N],[12,"named_region_map","","",818,N],[12,"is_late_bound_map","","",818,N],[12,"object_lifetime_defaults_map","","",818,N],[12,"visibility","","",818,N],[12,"dep_kind","","",818,N],[12,"crate_name","","",818,N],[12,"item_children","","",818,N],[12,"extern_mod_stmt_cnum","","",818,N],[12,"get_lang_items","","",818,N],[12,"defined_lang_items","","",818,N],[12,"missing_lang_items","","",818,N],[12,"visible_parent_map","","",818,N],[12,"missing_extern_crate_item","","",818,N],[12,"used_crate_source","","",818,N],[12,"postorder_cnums","","",818,N],[12,"freevars","","",818,N],[12,"maybe_unused_trait_import","","",818,N],[12,"maybe_unused_extern_crates","","",818,N],[12,"stability_index","","",818,N],[12,"all_crate_nums","","",818,N],[12,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",818,N],[12,"exported_symbols","","",818,N],[12,"collect_and_partition_mono_items","","",818,N],[12,"is_codegened_item","","",818,N],[12,"codegen_unit","","",818,N],[12,"compile_codegen_unit","","",818,N],[12,"output_filenames","","",818,N],[12,"erase_regions_ty","","",818,N],[12,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",818,N],[12,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",818,N],[12,"implied_outlives_bounds","","",818,N],[12,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",818,N],[12,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",818,N],[12,"type_op_eq","","Do not call this query directly: part of the `Eq` type-op",818,N],[12,"type_op_subtype","","Do not call this query directly: part of the `Subtype` type-op",818,N],[12,"type_op_prove_predicate","","Do not call this query directly: part of the `ProvePredicate` type-op",818,N],[12,"type_op_normalize_ty","","Do not call this query directly: part of the `Normalize` type-op",818,N],[12,"type_op_normalize_predicate","","Do not call this query directly: part of the `Normalize` type-op",818,N],[12,"type_op_normalize_poly_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",818,N],[12,"type_op_normalize_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",818,N],[12,"substitute_normalize_and_test_predicates","","",818,N],[12,"target_features_whitelist","","",818,N],[12,"instance_def_size_estimate","","",818,N],[12,"features_query","","",818,N],[12,"program_clauses_for","","",818,N],[12,"program_clauses_for_env","","",818,N],[12,"wasm_import_module_map","","",818,N],[3,"TyCtxtAt","","",N,N],[12,"tcx","","",819,N],[12,"span","","",819,N],[3,"Providers","","",N,N],[12,"type_of","","",820,N],[12,"generics_of","","",820,N],[12,"predicates_of","","",820,N],[12,"predicates_defined_on","","",820,N],[12,"explicit_predicates_of","","",820,N],[12,"inferred_outlives_of","","",820,N],[12,"super_predicates_of","","",820,N],[12,"type_param_predicates","","",820,N],[12,"trait_def","","",820,N],[12,"adt_def","","",820,N],[12,"adt_destructor","","",820,N],[12,"adt_sized_constraint","","",820,N],[12,"adt_dtorck_constraint","","",820,N],[12,"is_const_fn","","",820,N],[12,"is_foreign_item","","",820,N],[12,"crate_variances","","",820,N],[12,"variances_of","","",820,N],[12,"inferred_outlives_crate","","",820,N],[12,"associated_item_def_ids","","",820,N],[12,"associated_item","","",820,N],[12,"impl_trait_ref","","",820,N],[12,"impl_polarity","","",820,N],[12,"inherent_impls","","",820,N],[12,"mir_keys","","",820,N],[12,"mir_const_qualif","","",820,N],[12,"mir_built","","",820,N],[12,"mir_const","","",820,N],[12,"mir_validated","","",820,N],[12,"optimized_mir","","",820,N],[12,"unsafety_check_result","","",820,N],[12,"unsafe_derive_on_repr_packed","","",820,N],[12,"fn_sig","","",820,N],[12,"coerce_unsized_info","","",820,N],[12,"typeck_item_bodies","","",820,N],[12,"typeck_tables_of","","",820,N],[12,"used_trait_imports","","",820,N],[12,"has_typeck_tables","","",820,N],[12,"coherent_trait","","",820,N],[12,"borrowck","","",820,N],[12,"mir_borrowck","","",820,N],[12,"crate_inherent_impls","","",820,N],[12,"crate_inherent_impls_overlap_check","","",820,N],[12,"const_eval","","",820,N],[12,"const_value_to_allocation","","",820,N],[12,"check_match","","",820,N],[12,"privacy_access_levels","","",820,N],[12,"reachable_set","","",820,N],[12,"region_scope_tree","","",820,N],[12,"mir_shims","","",820,N],[12,"def_symbol_name","","",820,N],[12,"symbol_name","","",820,N],[12,"describe_def","","",820,N],[12,"def_span","","",820,N],[12,"lookup_stability","","",820,N],[12,"lookup_deprecation_entry","","",820,N],[12,"item_attrs","","",820,N],[12,"codegen_fn_attrs","","",820,N],[12,"fn_arg_names","","",820,N],[12,"rendered_const","","",820,N],[12,"impl_parent","","",820,N],[12,"trait_of_item","","",820,N],[12,"const_is_rvalue_promotable_to_static","","",820,N],[12,"rvalue_promotable_map","","",820,N],[12,"is_mir_available","","",820,N],[12,"vtable_methods","","",820,N],[12,"codegen_fulfill_obligation","","",820,N],[12,"trait_impls_of","","",820,N],[12,"specialization_graph_of","","",820,N],[12,"is_object_safe","","",820,N],[12,"param_env","","",820,N],[12,"is_copy_raw","","",820,N],[12,"is_sized_raw","","",820,N],[12,"is_freeze_raw","","",820,N],[12,"needs_drop_raw","","",820,N],[12,"layout_raw","","",820,N],[12,"dylib_dependency_formats","","",820,N],[12,"is_panic_runtime","","",820,N],[12,"is_compiler_builtins","","",820,N],[12,"has_global_allocator","","",820,N],[12,"is_sanitizer_runtime","","",820,N],[12,"is_profiler_runtime","","",820,N],[12,"panic_strategy","","",820,N],[12,"is_no_builtins","","",820,N],[12,"extern_crate","","",820,N],[12,"specializes","","",820,N],[12,"in_scope_traits_map","","",820,N],[12,"module_exports","","",820,N],[12,"lint_levels","","",820,N],[12,"impl_defaultness","","",820,N],[12,"check_item_well_formed","","",820,N],[12,"check_trait_item_well_formed","","",820,N],[12,"check_impl_item_well_formed","","",820,N],[12,"reachable_non_generics","","",820,N],[12,"is_reachable_non_generic","","",820,N],[12,"is_unreachable_local_definition","","",820,N],[12,"upstream_monomorphizations","","",820,N],[12,"upstream_monomorphizations_for","","",820,N],[12,"native_libraries","","",820,N],[12,"foreign_modules","","",820,N],[12,"plugin_registrar_fn","","",820,N],[12,"derive_registrar_fn","","",820,N],[12,"crate_disambiguator","","",820,N],[12,"crate_hash","","",820,N],[12,"original_crate_name","","",820,N],[12,"extra_filename","","",820,N],[12,"implementations_of_trait","","",820,N],[12,"all_trait_implementations","","",820,N],[12,"dllimport_foreign_items","","",820,N],[12,"is_dllimport_foreign_item","","",820,N],[12,"is_statically_included_foreign_item","","",820,N],[12,"native_library_kind","","",820,N],[12,"link_args","","",820,N],[12,"resolve_lifetimes","","",820,N],[12,"named_region_map","","",820,N],[12,"is_late_bound_map","","",820,N],[12,"object_lifetime_defaults_map","","",820,N],[12,"visibility","","",820,N],[12,"dep_kind","","",820,N],[12,"crate_name","","",820,N],[12,"item_children","","",820,N],[12,"extern_mod_stmt_cnum","","",820,N],[12,"get_lang_items","","",820,N],[12,"defined_lang_items","","",820,N],[12,"missing_lang_items","","",820,N],[12,"visible_parent_map","","",820,N],[12,"missing_extern_crate_item","","",820,N],[12,"used_crate_source","","",820,N],[12,"postorder_cnums","","",820,N],[12,"freevars","","",820,N],[12,"maybe_unused_trait_import","","",820,N],[12,"maybe_unused_extern_crates","","",820,N],[12,"stability_index","","",820,N],[12,"all_crate_nums","","",820,N],[12,"all_traits","","",820,N],[12,"exported_symbols","","",820,N],[12,"collect_and_partition_mono_items","","",820,N],[12,"is_codegened_item","","",820,N],[12,"codegen_unit","","",820,N],[12,"compile_codegen_unit","","",820,N],[12,"output_filenames","","",820,N],[12,"erase_regions_ty","","",820,N],[12,"normalize_projection_ty","","",820,N],[12,"normalize_ty_after_erasing_regions","","",820,N],[12,"implied_outlives_bounds","","",820,N],[12,"dropck_outlives","","",820,N],[12,"evaluate_obligation","","",820,N],[12,"type_op_eq","","",820,N],[12,"type_op_subtype","","",820,N],[12,"type_op_prove_predicate","","",820,N],[12,"type_op_normalize_ty","","",820,N],[12,"type_op_normalize_predicate","","",820,N],[12,"type_op_normalize_poly_fn_sig","","",820,N],[12,"type_op_normalize_fn_sig","","",820,N],[12,"substitute_normalize_and_test_predicates","","",820,N],[12,"target_features_whitelist","","",820,N],[12,"instance_def_size_estimate","","",820,N],[12,"features_query","","",820,N],[12,"program_clauses_for","","",820,N],[12,"program_clauses_for_env","","",820,N],[12,"wasm_import_module_map","","",820,N],[4,"Query","","",N,N],[13,"type_of","","Records the type of every item.",821,N],[13,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics.",821,N],[13,"predicates_of","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) that must be proven true in order to reference it. This is almost always the \"predicates query\" that you want.",821,N],[13,"predicates_defined_on","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) directly defined on it. This is equal to the `explicit_predicates_of` predicates plus the `inferred_outlives_of` predicates.",821,N],[13,"explicit_predicates_of","","Returns the predicates written explicit by the user.",821,N],[13,"inferred_outlives_of","","Returns the inferred outlives predicates (e.g., for `struct Foo<'a, T> { x: &'a T }`, this would return `T: 'a`).",821,N],[13,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",821,N],[13,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",821,N],[13,"trait_def","","",821,N],[13,"adt_def","","",821,N],[13,"adt_destructor","","",821,N],[13,"adt_sized_constraint","","",821,N],[13,"adt_dtorck_constraint","","",821,N],[13,"is_const_fn","","True if this is a const fn",821,N],[13,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",821,N],[13,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",821,N],[13,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",821,N],[13,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",821,N],[13,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",821,N],[13,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",821,N],[13,"impl_trait_ref","","",821,N],[13,"impl_polarity","","",821,N],[13,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",821,N],[13,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",821,N],[13,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",821,N],[13,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",821,N],[13,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",821,N],[13,"mir_validated","","",821,N],[13,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for codegen. This is also the only query that can fetch non-local MIR, at present.",821,N],[13,"unsafety_check_result","","The result of unsafety-checking this def-id.",821,N],[13,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",821,N],[13,"fn_sig","","The signature of functions and closures.",821,N],[13,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",821,N],[13,"typeck_item_bodies","","",821,N],[13,"typeck_tables_of","","",821,N],[13,"used_trait_imports","","",821,N],[13,"has_typeck_tables","","",821,N],[13,"coherent_trait","","",821,N],[13,"borrowck","","",821,N],[13,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",821,N],[13,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",821,N],[13,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",821,N],[13,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",821,N],[13,"const_value_to_allocation","","Converts a constant value to an constant allocation",821,N],[13,"check_match","","",821,N],[13,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",821,N],[13,"reachable_set","","",821,N],[13,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",821,N],[13,"mir_shims","","",821,N],[13,"def_symbol_name","","",821,N],[13,"symbol_name","","",821,N],[13,"describe_def","","",821,N],[13,"def_span","","",821,N],[13,"lookup_stability","","",821,N],[13,"lookup_deprecation_entry","","",821,N],[13,"item_attrs","","",821,N],[13,"codegen_fn_attrs","","",821,N],[13,"fn_arg_names","","",821,N],[13,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",821,N],[13,"impl_parent","","",821,N],[13,"trait_of_item","","",821,N],[13,"const_is_rvalue_promotable_to_static","","",821,N],[13,"rvalue_promotable_map","","",821,N],[13,"is_mir_available","","",821,N],[13,"vtable_methods","","",821,N],[13,"codegen_fulfill_obligation","","",821,N],[13,"trait_impls_of","","",821,N],[13,"specialization_graph_of","","",821,N],[13,"is_object_safe","","",821,N],[13,"param_env","","",821,N],[13,"is_copy_raw","","",821,N],[13,"is_sized_raw","","",821,N],[13,"is_freeze_raw","","",821,N],[13,"needs_drop_raw","","",821,N],[13,"layout_raw","","",821,N],[13,"dylib_dependency_formats","","",821,N],[13,"is_panic_runtime","","",821,N],[13,"is_compiler_builtins","","",821,N],[13,"has_global_allocator","","",821,N],[13,"is_sanitizer_runtime","","",821,N],[13,"is_profiler_runtime","","",821,N],[13,"panic_strategy","","",821,N],[13,"is_no_builtins","","",821,N],[13,"extern_crate","","",821,N],[13,"specializes","","",821,N],[13,"in_scope_traits_map","","",821,N],[13,"module_exports","","",821,N],[13,"lint_levels","","",821,N],[13,"impl_defaultness","","",821,N],[13,"check_item_well_formed","","",821,N],[13,"check_trait_item_well_formed","","",821,N],[13,"check_impl_item_well_formed","","",821,N],[13,"reachable_non_generics","","",821,N],[13,"is_reachable_non_generic","","",821,N],[13,"is_unreachable_local_definition","","",821,N],[13,"upstream_monomorphizations","","",821,N],[13,"upstream_monomorphizations_for","","",821,N],[13,"native_libraries","","",821,N],[13,"foreign_modules","","",821,N],[13,"plugin_registrar_fn","","",821,N],[13,"derive_registrar_fn","","",821,N],[13,"crate_disambiguator","","",821,N],[13,"crate_hash","","",821,N],[13,"original_crate_name","","",821,N],[13,"extra_filename","","",821,N],[13,"implementations_of_trait","","",821,N],[13,"all_trait_implementations","","",821,N],[13,"dllimport_foreign_items","","",821,N],[13,"is_dllimport_foreign_item","","",821,N],[13,"is_statically_included_foreign_item","","",821,N],[13,"native_library_kind","","",821,N],[13,"link_args","","",821,N],[13,"resolve_lifetimes","","",821,N],[13,"named_region_map","","",821,N],[13,"is_late_bound_map","","",821,N],[13,"object_lifetime_defaults_map","","",821,N],[13,"visibility","","",821,N],[13,"dep_kind","","",821,N],[13,"crate_name","","",821,N],[13,"item_children","","",821,N],[13,"extern_mod_stmt_cnum","","",821,N],[13,"get_lang_items","","",821,N],[13,"defined_lang_items","","",821,N],[13,"missing_lang_items","","",821,N],[13,"visible_parent_map","","",821,N],[13,"missing_extern_crate_item","","",821,N],[13,"used_crate_source","","",821,N],[13,"postorder_cnums","","",821,N],[13,"freevars","","",821,N],[13,"maybe_unused_trait_import","","",821,N],[13,"maybe_unused_extern_crates","","",821,N],[13,"stability_index","","",821,N],[13,"all_crate_nums","","",821,N],[13,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",821,N],[13,"exported_symbols","","",821,N],[13,"collect_and_partition_mono_items","","",821,N],[13,"is_codegened_item","","",821,N],[13,"codegen_unit","","",821,N],[13,"compile_codegen_unit","","",821,N],[13,"output_filenames","","",821,N],[13,"erase_regions_ty","","",821,N],[13,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",821,N],[13,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",821,N],[13,"implied_outlives_bounds","","",821,N],[13,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",821,N],[13,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",821,N],[13,"type_op_eq","","Do not call this query directly: part of the `Eq` type-op",821,N],[13,"type_op_subtype","","Do not call this query directly: part of the `Subtype` type-op",821,N],[13,"type_op_prove_predicate","","Do not call this query directly: part of the `ProvePredicate` type-op",821,N],[13,"type_op_normalize_ty","","Do not call this query directly: part of the `Normalize` type-op",821,N],[13,"type_op_normalize_predicate","","Do not call this query directly: part of the `Normalize` type-op",821,N],[13,"type_op_normalize_poly_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",821,N],[13,"type_op_normalize_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",821,N],[13,"substitute_normalize_and_test_predicates","","",821,N],[13,"target_features_whitelist","","",821,N],[13,"instance_def_size_estimate","","",821,N],[13,"features_query","","",821,N],[13,"program_clauses_for","","",821,N],[13,"program_clauses_for_env","","",821,N],[13,"wasm_import_module_map","","",821,N],[5,"force_from_dep_node","","The red/green evaluation system will try to mark a specific DepNode in the dependency graph as green by recursively trying to mark the dependencies of that DepNode as green. While doing so, it will sometimes encounter a DepNode where we don't know if it is red or green and we therefore actually have to recompute its value in order to find out. Since the only piece of information that we have at that point is the DepNode we are trying to re-evaluate, we need some way to re-run a query from just that. This is what `force_from_dep_node()` implements.",N,[[["tyctxt"],["depnode"]],["bool"]]],[5,"features_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"codegen_fn_attrs","","",N,[[["defid"]],["depconstructor"]]],[5,"erase_regions_ty","","",N,[[["ty"]],["depconstructor"]]],[5,"const_value_to_allocation","","",N,[[["const"]],["depconstructor"]]],[5,"type_param_predicates","","",N,N],[5,"fulfill_obligation_dep_node","","",N,N],[5,"crate_inherent_impls_dep_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"inherent_impls_overlap_check_dep_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"reachability_dep_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"mir_shim_dep_node","","",N,[[["instancedef"]],["depconstructor"]]],[5,"symbol_name_dep_node","","",N,[[["instance"]],["depconstructor"]]],[5,"typeck_item_bodies_dep_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"const_eval_dep_node","","",N,[[["paramenvand",["globalid"]]],["depconstructor"]]],[5,"mir_keys","","",N,[[["cratenum"]],["depconstructor"]]],[5,"crate_variances","","",N,[[["cratenum"]],["depconstructor"]]],[5,"is_copy_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"is_sized_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"is_freeze_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"needs_drop_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"layout_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"lint_levels_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"specializes_node","","",N,N],[5,"implementations_of_trait_node","","",N,N],[5,"link_args_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"get_lang_items_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"visible_parent_map_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"postorder_cnums_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"maybe_unused_extern_crates_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"stability_index_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"all_crate_nums_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"all_traits_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"collect_and_partition_mono_items_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"output_filenames_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"vtable_methods_node","","",N,[[["polytraitref"]],["depconstructor"]]],[5,"substitute_normalize_and_test_predicates_node","","",N,N],[5,"target_features_whitelist_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"instance_def_size_estimate_dep_node","","",N,[[["instancedef"]],["depconstructor"]]],[0,"plumbing","","The implementation of the query system itself. Defines the macros that generate the actual methods on tcx which find and execute the provider, manage the caches, and so forth.",N,N],[3,"QueryCache","rustc::ty::query::plumbing","",N,N],[12,"results","","",822,N],[12,"active","","",822,N],[3,"QueryValue","","",N,N],[12,"value","","",823,N],[12,"index","","",823,N],[3,"JobOwner","","A type representing the responsibility to execute the job in the `job` field. This will poison the relevant query if dropped.",N,N],[12,"cache","","",824,N],[12,"key","","",824,N],[12,"job","","",824,N],[3,"CycleError","","",N,N],[12,"usage","","The query and related span which uses the cycle",814,N],[12,"cycle","","",814,N],[4,"TryGetJob","","The result of `try_get_lock`",N,N],[13,"NotYetStarted","","The query is not yet started. Contains a guard to the cache eventually used to start it.",825,N],[13,"JobCompleted","","The query was already completed. Returns the result of the query and its dep node index if it succeeded or a cycle error if it failed",825,N],[5,"force_from_dep_node","","The red/green evaluation system will try to mark a specific DepNode in the dependency graph as green by recursively trying to mark the dependencies of that DepNode as green. While doing so, it will sometimes encounter a DepNode where we don't know if it is red or green and we therefore actually have to recompute its value in order to find out. Since the only piece of information that we have at that point is the DepNode we are trying to re-evaluate, we need some way to re-run a query from just that. This is what `force_from_dep_node()` implements.",N,[[["tyctxt"],["depnode"]],["bool"]]],[11,"new","","",823,[[["t"],["depnodeindex"]],["queryvalue"]]],[11,"new","","",822,[[],["querycache"]]],[11,"try_get","","Either gets a JobOwner corresponding the the query, allowing us to start executing the query, or it returns with the result of the query. If the query is executing elsewhere, this will wait for it. If the query panicked, this will silently panic.",824,N],[11,"complete","","Completes the query by updating the query cache with the `result`, signals the waiter and forgets the JobOwner, so it won't poison the query",824,N],[11,"start","","Executes a job by changing the ImplicitCtxt to point to the new query job while it executes. It returns the diagnostics captured during execution and the actual result.",824,N],[11,"drop","","",824,[[["self"]]]],[11,"clone","rustc::ty::query","",814,[[["self"]],["cycleerror"]]],[11,"report_cycle","rustc::ty","",684,[[["self"],["cycleerror"]],["diagnosticbuilder"]]],[11,"try_print_query_stack","","",684,[[]]],[11,"try_mark_green_and_read","","Try to read a node index for the node dep_node. A node will have an index, when it's already been marked green, or when we can mark it green. This function will mark the current task as a reader of the specified node, when the a node index can be found for that node.",684,[[["self"],["depnode"]],["option",["depnodeindex"]]]],[11,"try_get_with","","",684,N],[11,"load_from_disk_and_cache_in_memory","","",684,N],[11,"force_query_with_job","","",684,N],[11,"ensure_query","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",684,N],[11,"force_query","","",684,N],[11,"try_get_query","","",684,N],[11,"get_query","","",684,N],[11,"cache_on_disk","rustc::dep_graph","",9,[[["self"],["tyctxt"]],["bool"]]],[11,"load_from_on_disk_cache","","",9,[[["self"],["tyctxt"]]]],[0,"job","rustc::ty::query","",N,N],[3,"QueryInfo","rustc::ty::query::job","A span and a query key",N,N],[12,"span","","The span for a reason this query was required",816,N],[12,"query","","",816,N],[3,"QueryJob","","A object representing an active query job.",N,N],[12,"info","","",815,N],[12,"parent","","The parent query job which created this job and is implicitly waiting on it.",815,N],[12,"diagnostics","","Diagnostic messages which are emitted while the query executes",815,N],[4,"QueryResult","","Indicates the state of a query for a given key in a query map",N,N],[13,"Started","","An already executing query. The query job can be used to await for its completion",826,N],[13,"Poisoned","","The query panicked. Queries trying to wait on this will raise a fatal error / silently panic",826,N],[11,"clone","rustc::ty::query","",816,[[["self"]],["queryinfo"]]],[11,"fmt","","",816,[[["self"],["formatter"]],["result"]]],[11,"new","","Creates a new query job",815,[[["queryinfo"],["option",["lrc"]]],["self"]]],[11,"await","","Awaits for the query job to complete.",815,[[["self"],["tyctxt"],["span"]],["result",["cycleerror"]]]],[11,"find_cycle_in_stack","","",815,[[["self"],["tyctxt"],["span"]],["result",["cycleerror"]]]],[11,"signal_complete","","Signals to waiters that the query is complete.",815,[[["self"]]]],[11,"as_ptr","","",815,N],[0,"keys","","Defines the set of legal keys that can be used in queries.",N,N],[8,"Key","rustc::ty::query::keys","The `Key` trait controls what types can legally be used as the key for a query.",N,N],[10,"query_crate","","Given an instance of this key, what crate is it referring to? This is used to find the provider.",827,[[["self"]],["cratenum"]]],[10,"default_span","","In the event that a cycle occurs, if no explicit span has been given for a query with key `self`, what span should we use?",827,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::ty","",730,[[["self"]],["cratenum"]]],[11,"default_span","","",730,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","","",688,[[["self"]],["cratenum"]]],[11,"default_span","","",688,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::mir::interpret","",482,[[["self"]],["cratenum"]]],[11,"default_span","","",482,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::hir::def_id","",145,[[["self"]],["cratenum"]]],[11,"default_span","","",145,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","","",146,[[["self"]],["cratenum"]]],[11,"default_span","","",146,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","","",147,[[["self"]],["cratenum"]]],[11,"default_span","","",147,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::ty","",713,[[["self"]],["cratenum"]]],[11,"default_span","","",713,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","","",714,[[["self"]],["cratenum"]]],[11,"default_span","","",714,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::infer::canonical","",226,[[["self"]],["cratenum"]]],[11,"default_span","","",226,[[["self"],["tyctxt"]],["span"]]],[0,"values","rustc::ty::query","",N,N],[8,"Value","rustc::ty::query::values","",N,N],[10,"from_cycle_error","","",828,[[["tyctxt"]],["self"]]],[11,"from_cycle_error","rustc::ty","",723,[[["tyctxt"]],["self"]]],[0,"config","rustc::ty::query","",N,N],[8,"QueryConfig","rustc::ty::query::config","",N,N],[18,"NAME","","",829,N],[16,"Key","","",829,N],[16,"Value","","",829,N],[8,"QueryAccessors","","",N,N],[10,"query","","",830,N],[10,"query_cache","","",830,[[["tyctxt"]],["lock"]]],[10,"to_dep_node","","",830,N],[10,"compute","","",830,N],[10,"handle_cycle_error","","",830,N],[8,"QueryDescription","","",N,N],[10,"describe","","",831,N],[11,"cache_on_disk","","",831,N],[11,"try_load_from_disk","","",831,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[0,"on_disk_cache","rustc::ty::query","",N,N],[3,"OnDiskCache","rustc::ty::query::on_disk_cache","`OnDiskCache` provides an interface to incr. comp. data cached from the previous compilation session. This data will eventually include the results of a few selected queries (like `typeck_tables_of` and `mir_optimized`) and any diagnostics that have been emitted during a query.",N,N],[12,"serialized_data","","",817,N],[12,"current_diagnostics","","",817,N],[12,"prev_cnums","","",817,N],[12,"cnum_map","","",817,N],[12,"codemap","","",817,N],[12,"file_index_to_stable_id","","",817,N],[12,"file_index_to_file","","",817,N],[12,"synthetic_expansion_infos","","",817,N],[12,"query_result_index","","",817,N],[12,"prev_diagnostics_index","","",817,N],[12,"alloc_decoding_state","","",817,N],[3,"Footer","","",N,N],[12,"file_index_to_stable_id","","",832,N],[12,"prev_cnums","","",832,N],[12,"query_result_index","","",832,N],[12,"diagnostics_index","","",832,N],[12,"interpret_alloc_index","","",832,N],[3,"FileMapIndex","","",N,N],[12,"0","","",833,N],[3,"AbsoluteBytePos","","",N,N],[12,"0","","",834,N],[3,"CacheDecoder","","A decoder that can read the incr. comp. cache. It is similar to the one we use for crate metadata decoding in that it can rebase spans and eventually will also handle things that contain `Ty` instances.",N,N],[12,"tcx","","",835,N],[12,"opaque","","",835,N],[12,"codemap","","",835,N],[12,"cnum_map","","",835,N],[12,"synthetic_expansion_infos","","",835,N],[12,"file_index_to_file","","",835,N],[12,"file_index_to_stable_id","","",835,N],[12,"alloc_decoding_session","","",835,N],[3,"CacheEncoder","","",N,N],[12,"tcx","","",836,N],[12,"encoder","","",836,N],[12,"type_shorthands","","",836,N],[12,"predicate_shorthands","","",836,N],[12,"expn_info_shorthands","","",836,N],[12,"interpret_allocs","","",836,N],[12,"interpret_allocs_inverse","","",836,N],[12,"codemap","","",836,N],[12,"file_to_file_index","","",836,N],[3,"IntEncodedWithFixedSize","","",N,N],[12,"0","","",837,N],[5,"decode_tagged","","",N,[[["d"],["t"]],["result"]]],[5,"encode_query_results","","",N,[[["tyctxt"],["cacheencoder"],["vec"]],["result"]]],[0,"__ty_decoder_impl","","",N,N],[11,"read_nil","","",835,[[["self"]],["result"]]],[11,"read_u128","","",835,[[["self"]],["result",["u128"]]]],[11,"read_u64","","",835,[[["self"]],["result",["u64"]]]],[11,"read_u32","","",835,[[["self"]],["result",["u32"]]]],[11,"read_u16","","",835,[[["self"]],["result",["u16"]]]],[11,"read_u8","","",835,[[["self"]],["result",["u8"]]]],[11,"read_usize","","",835,[[["self"]],["result",["usize"]]]],[11,"read_i128","","",835,[[["self"]],["result",["i128"]]]],[11,"read_i64","","",835,[[["self"]],["result",["i64"]]]],[11,"read_i32","","",835,[[["self"]],["result",["i32"]]]],[11,"read_i16","","",835,[[["self"]],["result",["i16"]]]],[11,"read_i8","","",835,[[["self"]],["result",["i8"]]]],[11,"read_isize","","",835,[[["self"]],["result",["isize"]]]],[11,"read_bool","","",835,[[["self"]],["result",["bool"]]]],[11,"read_f64","","",835,[[["self"]],["result",["f64"]]]],[11,"read_f32","","",835,[[["self"]],["result",["f32"]]]],[11,"read_char","","",835,[[["self"]],["result",["char"]]]],[11,"read_str","","",835,[[["self"]],["result",["cow"]]]],[11,"error","","",835,N],[11,"specialized_decode","","",835,[[["self"]],["result",["cratenum"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["ty"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["genericpredicates"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["substs"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["region"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["slice"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["adtdef"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["slice"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["canonicalvarinfos"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["const"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["allocation"]]]],[6,"EncodedQueryResultIndex","","",N,N],[6,"EncodedDiagnosticsIndex","","",N,N],[6,"EncodedDiagnostics","","",N,N],[17,"TAG_FILE_FOOTER","","",N,N],[17,"TAG_CLEAR_CROSS_CRATE_CLEAR","","",N,N],[17,"TAG_CLEAR_CROSS_CRATE_SET","","",N,N],[17,"TAG_NO_EXPANSION_INFO","","",N,N],[17,"TAG_EXPANSION_INFO_SHORTHAND","","",N,N],[17,"TAG_EXPANSION_INFO_INLINE","","",N,N],[17,"TAG_VALID_SPAN","","",N,N],[17,"TAG_INVALID_SPAN","","",N,N],[8,"DecoderWithPosition","","",N,N],[10,"position","","",838,[[["self"]],["usize"]]],[11,"encode","","",832,[[["self"],["__s"]],["result"]]],[11,"decode","","",832,[[["__d"]],["result",["footer"]]]],[11,"clone","","",833,[[["self"]],["filemapindex"]]],[11,"eq","","",833,[[["self"],["filemapindex"]],["bool"]]],[11,"ne","","",833,[[["self"],["filemapindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",833,N],[11,"hash","","",833,N],[11,"fmt","","",833,[[["self"],["formatter"]],["result"]]],[11,"encode","","",833,[[["self"],["__s"]],["result"]]],[11,"decode","","",833,[[["__d"]],["result",["filemapindex"]]]],[11,"clone","","",834,[[["self"]],["absolutebytepos"]]],[11,"fmt","","",834,[[["self"],["formatter"]],["result"]]],[11,"hash","","",834,N],[11,"assert_receiver_is_total_eq","","",834,N],[11,"eq","","",834,[[["self"],["absolutebytepos"]],["bool"]]],[11,"ne","","",834,[[["self"],["absolutebytepos"]],["bool"]]],[11,"encode","","",834,[[["self"],["__s"]],["result"]]],[11,"decode","","",834,[[["__d"]],["result",["absolutebytepos"]]]],[11,"new","","",834,[[["usize"]],["absolutebytepos"]]],[11,"to_usize","","",834,[[["self"]],["usize"]]],[11,"new","rustc::ty::query","Create a new OnDiskCache instance from the serialized data in `data`.",817,[[["session"],["vec",["u8"]],["usize"]],["ondiskcache"]]],[11,"new_empty","","",817,[[["codemap"]],["ondiskcache"]]],[11,"serialize","","",817,[[["self"],["tyctxt"],["e"]],["result"]]],[11,"load_diagnostics","","Load a diagnostic emitted during the previous compilation session.",817,[[["self"],["tyctxt"],["serializeddepnodeindex"]],["vec",["diagnostic"]]]],[11,"store_diagnostics","","Store a diagnostic emitted during the current compilation session. Anything stored like this will be available via `load_diagnostics` in the next compilation session.",817,[[["self"],["depnodeindex"],["vec",["diagnostic"]]]]],[11,"try_load_query_result","","Returns the cached query result if there is something in the cache for the given SerializedDepNodeIndex. Otherwise returns None.",817,[[["self"],["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"store_diagnostics_for_anon_node","","Store a diagnostic emitted during computation of an anonymous query. Since many anonymous queries can share the same `DepNode`, we aggregate them -- as opposed to regular queries where we assume that there is a 1:1 relationship between query-key and `DepNode`.",817,[[["self"],["depnodeindex"],["vec",["diagnostic"]]]]],[11,"load_indexed","","",817,[[["self"],["tyctxt"],["serializeddepnodeindex"],["fxhashmap"],["str"]],["option"]]],[11,"compute_cnum_map","","",817,N],[11,"file_index_to_file","rustc::ty::query::on_disk_cache","",835,[[["self"],["filemapindex"]],["lrc",["filemap"]]]],[11,"position","","",835,[[["self"]],["usize"]]],[11,"tcx","","",835,[[["self"]],["tyctxt"]]],[11,"position","","",835,[[["self"]],["usize"]]],[11,"peek_byte","","",835,[[["self"]],["u8"]]],[11,"cached_ty_for_shorthand","","",835,[[["self"],["usize"],["f"]],["result",["ty"]]]],[11,"with_position","","",835,[[["self"],["usize"],["f"]],["r"]]],[11,"map_encoded_cnum_to_current","","",835,[[["self"],["cratenum"]],["cratenum"]]],[11,"specialized_decode","","",835,[[["self"]],["result",["allocid"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["span"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["defindex"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["defid"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["localdefid"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["hirid"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["nodeid"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["fingerprint"]]]],[11,"specialized_decode","","",835,[[["self"]],["result",["clearcrosscrate"]]]],[11,"filemap_index","","",836,[[["self"],["lrc",["filemap"]]],["filemapindex"]]],[11,"encode_tagged","","Encode something with additional information that allows to do some sanity checks when decoding the data again. This method will first encode the specified tag, then the given value, then the number of bytes taken up by tag and value. On decoding, we can then verify that we get the expected tag and read the expected number of bytes.",836,[[["self"],["t"],["v"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["allocid"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["span"]],["result"]]],[11,"position","","",836,[[["self"]],["usize"]]],[11,"specialized_encode","","",836,[[["self"],["cratenum"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["ty"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["genericpredicates"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["hirid"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["defid"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["localdefid"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["defindex"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["nodeid"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["fingerprint"]],["result"]]],[11,"specialized_encode","","",836,[[["self"],["clearcrosscrate"]],["result"]]],[11,"emit_nil","","",836,[[["self"]],["result"]]],[11,"emit_usize","","",836,[[["self"],["usize"]],["result"]]],[11,"emit_u128","","",836,[[["self"],["u128"]],["result"]]],[11,"emit_u64","","",836,[[["self"],["u64"]],["result"]]],[11,"emit_u32","","",836,[[["self"],["u32"]],["result"]]],[11,"emit_u16","","",836,[[["self"],["u16"]],["result"]]],[11,"emit_u8","","",836,[[["self"],["u8"]],["result"]]],[11,"emit_isize","","",836,[[["self"],["isize"]],["result"]]],[11,"emit_i128","","",836,[[["self"],["i128"]],["result"]]],[11,"emit_i64","","",836,[[["self"],["i64"]],["result"]]],[11,"emit_i32","","",836,[[["self"],["i32"]],["result"]]],[11,"emit_i16","","",836,[[["self"],["i16"]],["result"]]],[11,"emit_i8","","",836,[[["self"],["i8"]],["result"]]],[11,"emit_bool","","",836,[[["self"],["bool"]],["result"]]],[11,"emit_f64","","",836,[[["self"],["f64"]],["result"]]],[11,"emit_f32","","",836,[[["self"],["f32"]],["result"]]],[11,"emit_char","","",836,[[["self"],["char"]],["result"]]],[11,"emit_str","","",836,[[["self"],["str"]],["result"]]],[18,"ENCODED_SIZE","","",837,N],[0,"queries","rustc::ty::query","",N,N],[3,"type_of","rustc::ty::query::queries","",N,N],[12,"data","","",839,N],[3,"generics_of","","",N,N],[12,"data","","",840,N],[3,"predicates_of","","",N,N],[12,"data","","",841,N],[3,"predicates_defined_on","","",N,N],[12,"data","","",842,N],[3,"explicit_predicates_of","","",N,N],[12,"data","","",843,N],[3,"inferred_outlives_of","","",N,N],[12,"data","","",844,N],[3,"super_predicates_of","","",N,N],[12,"data","","",845,N],[3,"type_param_predicates","","",N,N],[12,"data","","",846,N],[3,"trait_def","","",N,N],[12,"data","","",847,N],[3,"adt_def","","",N,N],[12,"data","","",848,N],[3,"adt_destructor","","",N,N],[12,"data","","",849,N],[3,"adt_sized_constraint","","",N,N],[12,"data","","",850,N],[3,"adt_dtorck_constraint","","",N,N],[12,"data","","",851,N],[3,"is_const_fn","","",N,N],[12,"data","","",852,N],[3,"is_foreign_item","","",N,N],[12,"data","","",853,N],[3,"crate_variances","","",N,N],[12,"data","","",854,N],[3,"variances_of","","",N,N],[12,"data","","",855,N],[3,"inferred_outlives_crate","","",N,N],[12,"data","","",856,N],[3,"associated_item_def_ids","","",N,N],[12,"data","","",857,N],[3,"associated_item","","",N,N],[12,"data","","",858,N],[3,"impl_trait_ref","","",N,N],[12,"data","","",859,N],[3,"impl_polarity","","",N,N],[12,"data","","",860,N],[3,"inherent_impls","","",N,N],[12,"data","","",861,N],[3,"mir_keys","","",N,N],[12,"data","","",862,N],[3,"mir_const_qualif","","",N,N],[12,"data","","",863,N],[3,"mir_built","","",N,N],[12,"data","","",864,N],[3,"mir_const","","",N,N],[12,"data","","",865,N],[3,"mir_validated","","",N,N],[12,"data","","",866,N],[3,"optimized_mir","","",N,N],[12,"data","","",867,N],[3,"unsafety_check_result","","",N,N],[12,"data","","",868,N],[3,"unsafe_derive_on_repr_packed","","",N,N],[12,"data","","",869,N],[3,"fn_sig","","",N,N],[12,"data","","",870,N],[3,"coerce_unsized_info","","",N,N],[12,"data","","",871,N],[3,"typeck_item_bodies","","",N,N],[12,"data","","",872,N],[3,"typeck_tables_of","","",N,N],[12,"data","","",873,N],[3,"used_trait_imports","","",N,N],[12,"data","","",874,N],[3,"has_typeck_tables","","",N,N],[12,"data","","",875,N],[3,"coherent_trait","","",N,N],[12,"data","","",876,N],[3,"borrowck","","",N,N],[12,"data","","",877,N],[3,"mir_borrowck","","",N,N],[12,"data","","",878,N],[3,"crate_inherent_impls","","",N,N],[12,"data","","",879,N],[3,"crate_inherent_impls_overlap_check","","",N,N],[12,"data","","",880,N],[3,"const_eval","","",N,N],[12,"data","","",881,N],[3,"const_value_to_allocation","","",N,N],[12,"data","","",882,N],[3,"check_match","","",N,N],[12,"data","","",883,N],[3,"privacy_access_levels","","",N,N],[12,"data","","",884,N],[3,"reachable_set","","",N,N],[12,"data","","",885,N],[3,"region_scope_tree","","",N,N],[12,"data","","",886,N],[3,"mir_shims","","",N,N],[12,"data","","",887,N],[3,"def_symbol_name","","",N,N],[12,"data","","",888,N],[3,"symbol_name","","",N,N],[12,"data","","",889,N],[3,"describe_def","","",N,N],[12,"data","","",890,N],[3,"def_span","","",N,N],[12,"data","","",891,N],[3,"lookup_stability","","",N,N],[12,"data","","",892,N],[3,"lookup_deprecation_entry","","",N,N],[12,"data","","",893,N],[3,"item_attrs","","",N,N],[12,"data","","",894,N],[3,"codegen_fn_attrs","","",N,N],[12,"data","","",895,N],[3,"fn_arg_names","","",N,N],[12,"data","","",896,N],[3,"rendered_const","","",N,N],[12,"data","","",897,N],[3,"impl_parent","","",N,N],[12,"data","","",898,N],[3,"trait_of_item","","",N,N],[12,"data","","",899,N],[3,"const_is_rvalue_promotable_to_static","","",N,N],[12,"data","","",900,N],[3,"rvalue_promotable_map","","",N,N],[12,"data","","",901,N],[3,"is_mir_available","","",N,N],[12,"data","","",902,N],[3,"vtable_methods","","",N,N],[12,"data","","",903,N],[3,"codegen_fulfill_obligation","","",N,N],[12,"data","","",904,N],[3,"trait_impls_of","","",N,N],[12,"data","","",905,N],[3,"specialization_graph_of","","",N,N],[12,"data","","",906,N],[3,"is_object_safe","","",N,N],[12,"data","","",907,N],[3,"param_env","","",N,N],[12,"data","","",908,N],[3,"is_copy_raw","","",N,N],[12,"data","","",909,N],[3,"is_sized_raw","","",N,N],[12,"data","","",910,N],[3,"is_freeze_raw","","",N,N],[12,"data","","",911,N],[3,"needs_drop_raw","","",N,N],[12,"data","","",912,N],[3,"layout_raw","","",N,N],[12,"data","","",913,N],[3,"dylib_dependency_formats","","",N,N],[12,"data","","",914,N],[3,"is_panic_runtime","","",N,N],[12,"data","","",915,N],[3,"is_compiler_builtins","","",N,N],[12,"data","","",916,N],[3,"has_global_allocator","","",N,N],[12,"data","","",917,N],[3,"is_sanitizer_runtime","","",N,N],[12,"data","","",918,N],[3,"is_profiler_runtime","","",N,N],[12,"data","","",919,N],[3,"panic_strategy","","",N,N],[12,"data","","",920,N],[3,"is_no_builtins","","",N,N],[12,"data","","",921,N],[3,"extern_crate","","",N,N],[12,"data","","",922,N],[3,"specializes","","",N,N],[12,"data","","",923,N],[3,"in_scope_traits_map","","",N,N],[12,"data","","",924,N],[3,"module_exports","","",N,N],[12,"data","","",925,N],[3,"lint_levels","","",N,N],[12,"data","","",926,N],[3,"impl_defaultness","","",N,N],[12,"data","","",927,N],[3,"check_item_well_formed","","",N,N],[12,"data","","",928,N],[3,"check_trait_item_well_formed","","",N,N],[12,"data","","",929,N],[3,"check_impl_item_well_formed","","",N,N],[12,"data","","",930,N],[3,"reachable_non_generics","","",N,N],[12,"data","","",931,N],[3,"is_reachable_non_generic","","",N,N],[12,"data","","",932,N],[3,"is_unreachable_local_definition","","",N,N],[12,"data","","",933,N],[3,"upstream_monomorphizations","","",N,N],[12,"data","","",934,N],[3,"upstream_monomorphizations_for","","",N,N],[12,"data","","",935,N],[3,"native_libraries","","",N,N],[12,"data","","",936,N],[3,"foreign_modules","","",N,N],[12,"data","","",937,N],[3,"plugin_registrar_fn","","",N,N],[12,"data","","",938,N],[3,"derive_registrar_fn","","",N,N],[12,"data","","",939,N],[3,"crate_disambiguator","","",N,N],[12,"data","","",940,N],[3,"crate_hash","","",N,N],[12,"data","","",941,N],[3,"original_crate_name","","",N,N],[12,"data","","",942,N],[3,"extra_filename","","",N,N],[12,"data","","",943,N],[3,"implementations_of_trait","","",N,N],[12,"data","","",944,N],[3,"all_trait_implementations","","",N,N],[12,"data","","",945,N],[3,"dllimport_foreign_items","","",N,N],[12,"data","","",946,N],[3,"is_dllimport_foreign_item","","",N,N],[12,"data","","",947,N],[3,"is_statically_included_foreign_item","","",N,N],[12,"data","","",948,N],[3,"native_library_kind","","",N,N],[12,"data","","",949,N],[3,"link_args","","",N,N],[12,"data","","",950,N],[3,"resolve_lifetimes","","",N,N],[12,"data","","",951,N],[3,"named_region_map","","",N,N],[12,"data","","",952,N],[3,"is_late_bound_map","","",N,N],[12,"data","","",953,N],[3,"object_lifetime_defaults_map","","",N,N],[12,"data","","",954,N],[3,"visibility","","",N,N],[12,"data","","",955,N],[3,"dep_kind","","",N,N],[12,"data","","",956,N],[3,"crate_name","","",N,N],[12,"data","","",957,N],[3,"item_children","","",N,N],[12,"data","","",958,N],[3,"extern_mod_stmt_cnum","","",N,N],[12,"data","","",959,N],[3,"get_lang_items","","",N,N],[12,"data","","",960,N],[3,"defined_lang_items","","",N,N],[12,"data","","",961,N],[3,"missing_lang_items","","",N,N],[12,"data","","",962,N],[3,"visible_parent_map","","",N,N],[12,"data","","",963,N],[3,"missing_extern_crate_item","","",N,N],[12,"data","","",964,N],[3,"used_crate_source","","",N,N],[12,"data","","",965,N],[3,"postorder_cnums","","",N,N],[12,"data","","",966,N],[3,"freevars","","",N,N],[12,"data","","",967,N],[3,"maybe_unused_trait_import","","",N,N],[12,"data","","",968,N],[3,"maybe_unused_extern_crates","","",N,N],[12,"data","","",969,N],[3,"stability_index","","",N,N],[12,"data","","",970,N],[3,"all_crate_nums","","",N,N],[12,"data","","",971,N],[3,"all_traits","","",N,N],[12,"data","","",972,N],[3,"exported_symbols","","",N,N],[12,"data","","",973,N],[3,"collect_and_partition_mono_items","","",N,N],[12,"data","","",974,N],[3,"is_codegened_item","","",N,N],[12,"data","","",975,N],[3,"codegen_unit","","",N,N],[12,"data","","",976,N],[3,"compile_codegen_unit","","",N,N],[12,"data","","",977,N],[3,"output_filenames","","",N,N],[12,"data","","",978,N],[3,"erase_regions_ty","","",N,N],[12,"data","","",979,N],[3,"normalize_projection_ty","","",N,N],[12,"data","","",980,N],[3,"normalize_ty_after_erasing_regions","","",N,N],[12,"data","","",981,N],[3,"implied_outlives_bounds","","",N,N],[12,"data","","",982,N],[3,"dropck_outlives","","",N,N],[12,"data","","",983,N],[3,"evaluate_obligation","","",N,N],[12,"data","","",984,N],[3,"type_op_eq","","",N,N],[12,"data","","",985,N],[3,"type_op_subtype","","",N,N],[12,"data","","",986,N],[3,"type_op_prove_predicate","","",N,N],[12,"data","","",987,N],[3,"type_op_normalize_ty","","",N,N],[12,"data","","",988,N],[3,"type_op_normalize_predicate","","",N,N],[12,"data","","",989,N],[3,"type_op_normalize_poly_fn_sig","","",N,N],[12,"data","","",990,N],[3,"type_op_normalize_fn_sig","","",N,N],[12,"data","","",991,N],[3,"substitute_normalize_and_test_predicates","","",N,N],[12,"data","","",992,N],[3,"target_features_whitelist","","",N,N],[12,"data","","",993,N],[3,"instance_def_size_estimate","","",N,N],[12,"data","","",994,N],[3,"features_query","","",N,N],[12,"data","","",995,N],[3,"program_clauses_for","","",N,N],[12,"data","","",996,N],[3,"program_clauses_for_env","","",N,N],[12,"data","","",997,N],[3,"wasm_import_module_map","","",N,N],[12,"data","","",998,N],[0,"__query_compute","rustc::ty::query","",N,N],[5,"type_of","rustc::ty::query::__query_compute","",N,[[["f"]],["r"]]],[5,"generics_of","","",N,[[["f"]],["r"]]],[5,"predicates_of","","",N,[[["f"]],["r"]]],[5,"predicates_defined_on","","",N,[[["f"]],["r"]]],[5,"explicit_predicates_of","","",N,[[["f"]],["r"]]],[5,"inferred_outlives_of","","",N,[[["f"]],["r"]]],[5,"super_predicates_of","","",N,[[["f"]],["r"]]],[5,"type_param_predicates","","",N,[[["f"]],["r"]]],[5,"trait_def","","",N,[[["f"]],["r"]]],[5,"adt_def","","",N,[[["f"]],["r"]]],[5,"adt_destructor","","",N,[[["f"]],["r"]]],[5,"adt_sized_constraint","","",N,[[["f"]],["r"]]],[5,"adt_dtorck_constraint","","",N,[[["f"]],["r"]]],[5,"is_const_fn","","",N,[[["f"]],["r"]]],[5,"is_foreign_item","","",N,[[["f"]],["r"]]],[5,"crate_variances","","",N,[[["f"]],["r"]]],[5,"variances_of","","",N,[[["f"]],["r"]]],[5,"inferred_outlives_crate","","",N,[[["f"]],["r"]]],[5,"associated_item_def_ids","","",N,[[["f"]],["r"]]],[5,"associated_item","","",N,[[["f"]],["r"]]],[5,"impl_trait_ref","","",N,[[["f"]],["r"]]],[5,"impl_polarity","","",N,[[["f"]],["r"]]],[5,"inherent_impls","","",N,[[["f"]],["r"]]],[5,"mir_keys","","",N,[[["f"]],["r"]]],[5,"mir_const_qualif","","",N,[[["f"]],["r"]]],[5,"mir_built","","",N,[[["f"]],["r"]]],[5,"mir_const","","",N,[[["f"]],["r"]]],[5,"mir_validated","","",N,[[["f"]],["r"]]],[5,"optimized_mir","","",N,[[["f"]],["r"]]],[5,"unsafety_check_result","","",N,[[["f"]],["r"]]],[5,"unsafe_derive_on_repr_packed","","",N,[[["f"]],["r"]]],[5,"fn_sig","","",N,[[["f"]],["r"]]],[5,"coerce_unsized_info","","",N,[[["f"]],["r"]]],[5,"typeck_item_bodies","","",N,[[["f"]],["r"]]],[5,"typeck_tables_of","","",N,[[["f"]],["r"]]],[5,"used_trait_imports","","",N,[[["f"]],["r"]]],[5,"has_typeck_tables","","",N,[[["f"]],["r"]]],[5,"coherent_trait","","",N,[[["f"]],["r"]]],[5,"borrowck","","",N,[[["f"]],["r"]]],[5,"mir_borrowck","","",N,[[["f"]],["r"]]],[5,"crate_inherent_impls","","",N,[[["f"]],["r"]]],[5,"crate_inherent_impls_overlap_check","","",N,[[["f"]],["r"]]],[5,"const_eval","","",N,[[["f"]],["r"]]],[5,"const_value_to_allocation","","",N,[[["f"]],["r"]]],[5,"check_match","","",N,[[["f"]],["r"]]],[5,"privacy_access_levels","","",N,[[["f"]],["r"]]],[5,"reachable_set","","",N,[[["f"]],["r"]]],[5,"region_scope_tree","","",N,[[["f"]],["r"]]],[5,"mir_shims","","",N,[[["f"]],["r"]]],[5,"def_symbol_name","","",N,[[["f"]],["r"]]],[5,"symbol_name","","",N,[[["f"]],["r"]]],[5,"describe_def","","",N,[[["f"]],["r"]]],[5,"def_span","","",N,[[["f"]],["r"]]],[5,"lookup_stability","","",N,[[["f"]],["r"]]],[5,"lookup_deprecation_entry","","",N,[[["f"]],["r"]]],[5,"item_attrs","","",N,[[["f"]],["r"]]],[5,"codegen_fn_attrs","","",N,[[["f"]],["r"]]],[5,"fn_arg_names","","",N,[[["f"]],["r"]]],[5,"rendered_const","","",N,[[["f"]],["r"]]],[5,"impl_parent","","",N,[[["f"]],["r"]]],[5,"trait_of_item","","",N,[[["f"]],["r"]]],[5,"const_is_rvalue_promotable_to_static","","",N,[[["f"]],["r"]]],[5,"rvalue_promotable_map","","",N,[[["f"]],["r"]]],[5,"is_mir_available","","",N,[[["f"]],["r"]]],[5,"vtable_methods","","",N,[[["f"]],["r"]]],[5,"codegen_fulfill_obligation","","",N,[[["f"]],["r"]]],[5,"trait_impls_of","","",N,[[["f"]],["r"]]],[5,"specialization_graph_of","","",N,[[["f"]],["r"]]],[5,"is_object_safe","","",N,[[["f"]],["r"]]],[5,"param_env","","",N,[[["f"]],["r"]]],[5,"is_copy_raw","","",N,[[["f"]],["r"]]],[5,"is_sized_raw","","",N,[[["f"]],["r"]]],[5,"is_freeze_raw","","",N,[[["f"]],["r"]]],[5,"needs_drop_raw","","",N,[[["f"]],["r"]]],[5,"layout_raw","","",N,[[["f"]],["r"]]],[5,"dylib_dependency_formats","","",N,[[["f"]],["r"]]],[5,"is_panic_runtime","","",N,[[["f"]],["r"]]],[5,"is_compiler_builtins","","",N,[[["f"]],["r"]]],[5,"has_global_allocator","","",N,[[["f"]],["r"]]],[5,"is_sanitizer_runtime","","",N,[[["f"]],["r"]]],[5,"is_profiler_runtime","","",N,[[["f"]],["r"]]],[5,"panic_strategy","","",N,[[["f"]],["r"]]],[5,"is_no_builtins","","",N,[[["f"]],["r"]]],[5,"extern_crate","","",N,[[["f"]],["r"]]],[5,"specializes","","",N,[[["f"]],["r"]]],[5,"in_scope_traits_map","","",N,[[["f"]],["r"]]],[5,"module_exports","","",N,[[["f"]],["r"]]],[5,"lint_levels","","",N,[[["f"]],["r"]]],[5,"impl_defaultness","","",N,[[["f"]],["r"]]],[5,"check_item_well_formed","","",N,[[["f"]],["r"]]],[5,"check_trait_item_well_formed","","",N,[[["f"]],["r"]]],[5,"check_impl_item_well_formed","","",N,[[["f"]],["r"]]],[5,"reachable_non_generics","","",N,[[["f"]],["r"]]],[5,"is_reachable_non_generic","","",N,[[["f"]],["r"]]],[5,"is_unreachable_local_definition","","",N,[[["f"]],["r"]]],[5,"upstream_monomorphizations","","",N,[[["f"]],["r"]]],[5,"upstream_monomorphizations_for","","",N,[[["f"]],["r"]]],[5,"native_libraries","","",N,[[["f"]],["r"]]],[5,"foreign_modules","","",N,[[["f"]],["r"]]],[5,"plugin_registrar_fn","","",N,[[["f"]],["r"]]],[5,"derive_registrar_fn","","",N,[[["f"]],["r"]]],[5,"crate_disambiguator","","",N,[[["f"]],["r"]]],[5,"crate_hash","","",N,[[["f"]],["r"]]],[5,"original_crate_name","","",N,[[["f"]],["r"]]],[5,"extra_filename","","",N,[[["f"]],["r"]]],[5,"implementations_of_trait","","",N,[[["f"]],["r"]]],[5,"all_trait_implementations","","",N,[[["f"]],["r"]]],[5,"dllimport_foreign_items","","",N,[[["f"]],["r"]]],[5,"is_dllimport_foreign_item","","",N,[[["f"]],["r"]]],[5,"is_statically_included_foreign_item","","",N,[[["f"]],["r"]]],[5,"native_library_kind","","",N,[[["f"]],["r"]]],[5,"link_args","","",N,[[["f"]],["r"]]],[5,"resolve_lifetimes","","",N,[[["f"]],["r"]]],[5,"named_region_map","","",N,[[["f"]],["r"]]],[5,"is_late_bound_map","","",N,[[["f"]],["r"]]],[5,"object_lifetime_defaults_map","","",N,[[["f"]],["r"]]],[5,"visibility","","",N,[[["f"]],["r"]]],[5,"dep_kind","","",N,[[["f"]],["r"]]],[5,"crate_name","","",N,[[["f"]],["r"]]],[5,"item_children","","",N,[[["f"]],["r"]]],[5,"extern_mod_stmt_cnum","","",N,[[["f"]],["r"]]],[5,"get_lang_items","","",N,[[["f"]],["r"]]],[5,"defined_lang_items","","",N,[[["f"]],["r"]]],[5,"missing_lang_items","","",N,[[["f"]],["r"]]],[5,"visible_parent_map","","",N,[[["f"]],["r"]]],[5,"missing_extern_crate_item","","",N,[[["f"]],["r"]]],[5,"used_crate_source","","",N,[[["f"]],["r"]]],[5,"postorder_cnums","","",N,[[["f"]],["r"]]],[5,"freevars","","",N,[[["f"]],["r"]]],[5,"maybe_unused_trait_import","","",N,[[["f"]],["r"]]],[5,"maybe_unused_extern_crates","","",N,[[["f"]],["r"]]],[5,"stability_index","","",N,[[["f"]],["r"]]],[5,"all_crate_nums","","",N,[[["f"]],["r"]]],[5,"all_traits","","",N,[[["f"]],["r"]]],[5,"exported_symbols","","",N,[[["f"]],["r"]]],[5,"collect_and_partition_mono_items","","",N,[[["f"]],["r"]]],[5,"is_codegened_item","","",N,[[["f"]],["r"]]],[5,"codegen_unit","","",N,[[["f"]],["r"]]],[5,"compile_codegen_unit","","",N,[[["f"]],["r"]]],[5,"output_filenames","","",N,[[["f"]],["r"]]],[5,"erase_regions_ty","","",N,[[["f"]],["r"]]],[5,"normalize_projection_ty","","",N,[[["f"]],["r"]]],[5,"normalize_ty_after_erasing_regions","","",N,[[["f"]],["r"]]],[5,"implied_outlives_bounds","","",N,[[["f"]],["r"]]],[5,"dropck_outlives","","",N,[[["f"]],["r"]]],[5,"evaluate_obligation","","",N,[[["f"]],["r"]]],[5,"type_op_eq","","",N,[[["f"]],["r"]]],[5,"type_op_subtype","","",N,[[["f"]],["r"]]],[5,"type_op_prove_predicate","","",N,[[["f"]],["r"]]],[5,"type_op_normalize_ty","","",N,[[["f"]],["r"]]],[5,"type_op_normalize_predicate","","",N,[[["f"]],["r"]]],[5,"type_op_normalize_poly_fn_sig","","",N,[[["f"]],["r"]]],[5,"type_op_normalize_fn_sig","","",N,[[["f"]],["r"]]],[5,"substitute_normalize_and_test_predicates","","",N,[[["f"]],["r"]]],[5,"target_features_whitelist","","",N,[[["f"]],["r"]]],[5,"instance_def_size_estimate","","",N,[[["f"]],["r"]]],[5,"features_query","","",N,[[["f"]],["r"]]],[5,"program_clauses_for","","",N,[[["f"]],["r"]]],[5,"program_clauses_for_env","","",N,[[["f"]],["r"]]],[5,"wasm_import_module_map","","",N,[[["f"]],["r"]]],[8,"QueryConfig","rustc::ty::query","",N,N],[18,"NAME","rustc::ty::query::config","",829,N],[16,"Key","rustc::ty::query","",829,N],[16,"Value","","",829,N],[11,"new","","",818,[[["indexvec",["cratenum","providers"]],["ondiskcache"]],["self"]]],[11,"clone","","",821,[[["self"]],["query"]]],[11,"fmt","","",821,[[["self"],["formatter"]],["result"]]],[11,"eq","","",821,[[["self"],["query"]],["bool"]]],[11,"ne","","",821,[[["self"],["query"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",821,N],[11,"hash","","",821,N],[11,"name","","",821,[[["self"]],["str"]]],[11,"describe","","",821,[[["self"],["tyctxt"]],["string"]]],[11,"default_span","","",821,[[["self"],["tyctxt"],["span"]],["span"]]],[11,"hash_stable","","",821,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"query","rustc::ty::query::queries","",839,N],[11,"query_cache","","",839,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",839,N],[11,"compute","","",839,N],[11,"handle_cycle_error","","",839,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",839,N],[11,"query","","",840,N],[11,"query_cache","","",840,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",840,N],[11,"compute","","",840,N],[11,"handle_cycle_error","","",840,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",840,N],[11,"query","","",841,N],[11,"query_cache","","",841,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",841,N],[11,"compute","","",841,N],[11,"handle_cycle_error","","",841,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",841,N],[11,"query","","",842,N],[11,"query_cache","","",842,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",842,N],[11,"compute","","",842,N],[11,"handle_cycle_error","","",842,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",842,N],[11,"query","","",843,N],[11,"query_cache","","",843,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",843,N],[11,"compute","","",843,N],[11,"handle_cycle_error","","",843,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",843,N],[11,"query","","",844,N],[11,"query_cache","","",844,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",844,N],[11,"compute","","",844,N],[11,"handle_cycle_error","","",844,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",844,N],[11,"query","","",845,N],[11,"query_cache","","",845,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",845,N],[11,"compute","","",845,N],[11,"handle_cycle_error","","",845,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",845,N],[11,"query","","",846,N],[11,"query_cache","","",846,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",846,N],[11,"compute","","",846,N],[11,"handle_cycle_error","","",846,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",846,N],[11,"query","","",847,N],[11,"query_cache","","",847,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",847,N],[11,"compute","","",847,N],[11,"handle_cycle_error","","",847,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",847,N],[11,"query","","",848,N],[11,"query_cache","","",848,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",848,N],[11,"compute","","",848,N],[11,"handle_cycle_error","","",848,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",848,N],[11,"query","","",849,N],[11,"query_cache","","",849,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",849,N],[11,"compute","","",849,N],[11,"handle_cycle_error","","",849,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",849,N],[11,"query","","",850,N],[11,"query_cache","","",850,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",850,N],[11,"compute","","",850,N],[11,"handle_cycle_error","","",850,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",850,N],[11,"query","","",851,N],[11,"query_cache","","",851,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",851,N],[11,"compute","","",851,N],[11,"handle_cycle_error","","",851,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",851,N],[11,"query","","",852,N],[11,"query_cache","","",852,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",852,N],[11,"compute","","",852,N],[11,"handle_cycle_error","","",852,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",852,N],[11,"query","","",853,N],[11,"query_cache","","",853,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",853,N],[11,"compute","","",853,N],[11,"handle_cycle_error","","",853,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",853,N],[11,"query","","",854,N],[11,"query_cache","","",854,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",854,N],[11,"compute","","",854,N],[11,"handle_cycle_error","","",854,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",854,N],[11,"query","","",855,N],[11,"query_cache","","",855,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",855,N],[11,"compute","","",855,N],[11,"handle_cycle_error","","",855,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",855,N],[11,"query","","",856,N],[11,"query_cache","","",856,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",856,N],[11,"compute","","",856,N],[11,"handle_cycle_error","","",856,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",856,N],[11,"query","","",857,N],[11,"query_cache","","",857,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",857,N],[11,"compute","","",857,N],[11,"handle_cycle_error","","",857,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",857,N],[11,"query","","",858,N],[11,"query_cache","","",858,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",858,N],[11,"compute","","",858,N],[11,"handle_cycle_error","","",858,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",858,N],[11,"query","","",859,N],[11,"query_cache","","",859,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",859,N],[11,"compute","","",859,N],[11,"handle_cycle_error","","",859,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",859,N],[11,"query","","",860,N],[11,"query_cache","","",860,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",860,N],[11,"compute","","",860,N],[11,"handle_cycle_error","","",860,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",860,N],[11,"query","","",861,N],[11,"query_cache","","",861,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",861,N],[11,"compute","","",861,N],[11,"handle_cycle_error","","",861,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",861,N],[11,"query","","",862,N],[11,"query_cache","","",862,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",862,N],[11,"compute","","",862,N],[11,"handle_cycle_error","","",862,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",862,N],[11,"query","","",863,N],[11,"query_cache","","",863,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",863,N],[11,"compute","","",863,N],[11,"handle_cycle_error","","",863,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",863,N],[11,"query","","",864,N],[11,"query_cache","","",864,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",864,N],[11,"compute","","",864,N],[11,"handle_cycle_error","","",864,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",864,N],[11,"query","","",865,N],[11,"query_cache","","",865,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",865,N],[11,"compute","","",865,N],[11,"handle_cycle_error","","",865,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",865,N],[11,"query","","",866,N],[11,"query_cache","","",866,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",866,N],[11,"compute","","",866,N],[11,"handle_cycle_error","","",866,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",866,N],[11,"query","","",867,N],[11,"query_cache","","",867,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",867,N],[11,"compute","","",867,N],[11,"handle_cycle_error","","",867,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",867,N],[11,"query","","",868,N],[11,"query_cache","","",868,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",868,N],[11,"compute","","",868,N],[11,"handle_cycle_error","","",868,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",868,N],[11,"query","","",869,N],[11,"query_cache","","",869,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",869,N],[11,"compute","","",869,N],[11,"handle_cycle_error","","",869,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",869,N],[11,"query","","",870,N],[11,"query_cache","","",870,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",870,N],[11,"compute","","",870,N],[11,"handle_cycle_error","","",870,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",870,N],[11,"query","","",871,N],[11,"query_cache","","",871,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",871,N],[11,"compute","","",871,N],[11,"handle_cycle_error","","",871,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",871,N],[11,"query","","",872,N],[11,"query_cache","","",872,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",872,N],[11,"compute","","",872,N],[11,"handle_cycle_error","","",872,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",872,N],[11,"query","","",873,N],[11,"query_cache","","",873,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",873,N],[11,"compute","","",873,N],[11,"handle_cycle_error","","",873,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",873,N],[11,"query","","",874,N],[11,"query_cache","","",874,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",874,N],[11,"compute","","",874,N],[11,"handle_cycle_error","","",874,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",874,N],[11,"query","","",875,N],[11,"query_cache","","",875,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",875,N],[11,"compute","","",875,N],[11,"handle_cycle_error","","",875,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",875,N],[11,"query","","",876,N],[11,"query_cache","","",876,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",876,N],[11,"compute","","",876,N],[11,"handle_cycle_error","","",876,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",876,N],[11,"query","","",877,N],[11,"query_cache","","",877,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",877,N],[11,"compute","","",877,N],[11,"handle_cycle_error","","",877,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",877,N],[11,"query","","",878,N],[11,"query_cache","","",878,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",878,N],[11,"compute","","",878,N],[11,"handle_cycle_error","","",878,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",878,N],[11,"query","","",879,N],[11,"query_cache","","",879,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",879,N],[11,"compute","","",879,N],[11,"handle_cycle_error","","",879,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",879,N],[11,"query","","",880,N],[11,"query_cache","","",880,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",880,N],[11,"compute","","",880,N],[11,"handle_cycle_error","","",880,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",880,N],[11,"query","","",881,N],[11,"query_cache","","",881,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",881,N],[11,"compute","","",881,N],[11,"handle_cycle_error","","",881,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",881,N],[11,"query","","",882,N],[11,"query_cache","","",882,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",882,N],[11,"compute","","",882,N],[11,"handle_cycle_error","","",882,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",882,N],[11,"query","","",883,N],[11,"query_cache","","",883,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",883,N],[11,"compute","","",883,N],[11,"handle_cycle_error","","",883,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",883,N],[11,"query","","",884,N],[11,"query_cache","","",884,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",884,N],[11,"compute","","",884,N],[11,"handle_cycle_error","","",884,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",884,N],[11,"query","","",885,N],[11,"query_cache","","",885,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",885,N],[11,"compute","","",885,N],[11,"handle_cycle_error","","",885,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",885,N],[11,"query","","",886,N],[11,"query_cache","","",886,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",886,N],[11,"compute","","",886,N],[11,"handle_cycle_error","","",886,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",886,N],[11,"query","","",887,N],[11,"query_cache","","",887,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",887,N],[11,"compute","","",887,N],[11,"handle_cycle_error","","",887,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",887,N],[11,"query","","",888,N],[11,"query_cache","","",888,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",888,N],[11,"compute","","",888,N],[11,"handle_cycle_error","","",888,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",888,N],[11,"query","","",889,N],[11,"query_cache","","",889,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",889,N],[11,"compute","","",889,N],[11,"handle_cycle_error","","",889,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",889,N],[11,"query","","",890,N],[11,"query_cache","","",890,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",890,N],[11,"compute","","",890,N],[11,"handle_cycle_error","","",890,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",890,N],[11,"query","","",891,N],[11,"query_cache","","",891,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",891,N],[11,"compute","","",891,N],[11,"handle_cycle_error","","",891,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",891,N],[11,"query","","",892,N],[11,"query_cache","","",892,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",892,N],[11,"compute","","",892,N],[11,"handle_cycle_error","","",892,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",892,N],[11,"query","","",893,N],[11,"query_cache","","",893,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",893,N],[11,"compute","","",893,N],[11,"handle_cycle_error","","",893,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",893,N],[11,"query","","",894,N],[11,"query_cache","","",894,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",894,N],[11,"compute","","",894,N],[11,"handle_cycle_error","","",894,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",894,N],[11,"query","","",895,N],[11,"query_cache","","",895,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",895,N],[11,"compute","","",895,N],[11,"handle_cycle_error","","",895,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",895,N],[11,"query","","",896,N],[11,"query_cache","","",896,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",896,N],[11,"compute","","",896,N],[11,"handle_cycle_error","","",896,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",896,N],[11,"query","","",897,N],[11,"query_cache","","",897,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",897,N],[11,"compute","","",897,N],[11,"handle_cycle_error","","",897,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",897,N],[11,"query","","",898,N],[11,"query_cache","","",898,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",898,N],[11,"compute","","",898,N],[11,"handle_cycle_error","","",898,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",898,N],[11,"query","","",899,N],[11,"query_cache","","",899,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",899,N],[11,"compute","","",899,N],[11,"handle_cycle_error","","",899,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",899,N],[11,"query","","",900,N],[11,"query_cache","","",900,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",900,N],[11,"compute","","",900,N],[11,"handle_cycle_error","","",900,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",900,N],[11,"query","","",901,N],[11,"query_cache","","",901,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",901,N],[11,"compute","","",901,N],[11,"handle_cycle_error","","",901,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",901,N],[11,"query","","",902,N],[11,"query_cache","","",902,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",902,N],[11,"compute","","",902,N],[11,"handle_cycle_error","","",902,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",902,N],[11,"query","","",903,N],[11,"query_cache","","",903,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",903,N],[11,"compute","","",903,N],[11,"handle_cycle_error","","",903,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",903,N],[11,"query","","",904,N],[11,"query_cache","","",904,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",904,N],[11,"compute","","",904,N],[11,"handle_cycle_error","","",904,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",904,N],[11,"query","","",905,N],[11,"query_cache","","",905,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",905,N],[11,"compute","","",905,N],[11,"handle_cycle_error","","",905,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",905,N],[11,"query","","",906,N],[11,"query_cache","","",906,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",906,N],[11,"compute","","",906,N],[11,"handle_cycle_error","","",906,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",906,N],[11,"query","","",907,N],[11,"query_cache","","",907,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",907,N],[11,"compute","","",907,N],[11,"handle_cycle_error","","",907,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",907,N],[11,"query","","",908,N],[11,"query_cache","","",908,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",908,N],[11,"compute","","",908,N],[11,"handle_cycle_error","","",908,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",908,N],[11,"query","","",909,N],[11,"query_cache","","",909,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",909,N],[11,"compute","","",909,N],[11,"handle_cycle_error","","",909,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",909,N],[11,"query","","",910,N],[11,"query_cache","","",910,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",910,N],[11,"compute","","",910,N],[11,"handle_cycle_error","","",910,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",910,N],[11,"query","","",911,N],[11,"query_cache","","",911,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",911,N],[11,"compute","","",911,N],[11,"handle_cycle_error","","",911,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",911,N],[11,"query","","",912,N],[11,"query_cache","","",912,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",912,N],[11,"compute","","",912,N],[11,"handle_cycle_error","","",912,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",912,N],[11,"query","","",913,N],[11,"query_cache","","",913,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",913,N],[11,"compute","","",913,N],[11,"handle_cycle_error","","",913,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",913,N],[11,"query","","",914,N],[11,"query_cache","","",914,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",914,N],[11,"compute","","",914,N],[11,"handle_cycle_error","","",914,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",914,N],[11,"query","","",915,N],[11,"query_cache","","",915,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",915,N],[11,"compute","","",915,N],[11,"handle_cycle_error","","",915,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",915,N],[11,"query","","",916,N],[11,"query_cache","","",916,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",916,N],[11,"compute","","",916,N],[11,"handle_cycle_error","","",916,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",916,N],[11,"query","","",917,N],[11,"query_cache","","",917,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",917,N],[11,"compute","","",917,N],[11,"handle_cycle_error","","",917,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",917,N],[11,"query","","",918,N],[11,"query_cache","","",918,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",918,N],[11,"compute","","",918,N],[11,"handle_cycle_error","","",918,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",918,N],[11,"query","","",919,N],[11,"query_cache","","",919,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",919,N],[11,"compute","","",919,N],[11,"handle_cycle_error","","",919,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",919,N],[11,"query","","",920,N],[11,"query_cache","","",920,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",920,N],[11,"compute","","",920,N],[11,"handle_cycle_error","","",920,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",920,N],[11,"query","","",921,N],[11,"query_cache","","",921,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",921,N],[11,"compute","","",921,N],[11,"handle_cycle_error","","",921,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",921,N],[11,"query","","",922,N],[11,"query_cache","","",922,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",922,N],[11,"compute","","",922,N],[11,"handle_cycle_error","","",922,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",922,N],[11,"query","","",923,N],[11,"query_cache","","",923,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",923,N],[11,"compute","","",923,N],[11,"handle_cycle_error","","",923,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",923,N],[11,"query","","",924,N],[11,"query_cache","","",924,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",924,N],[11,"compute","","",924,N],[11,"handle_cycle_error","","",924,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",924,N],[11,"query","","",925,N],[11,"query_cache","","",925,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",925,N],[11,"compute","","",925,N],[11,"handle_cycle_error","","",925,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",925,N],[11,"query","","",926,N],[11,"query_cache","","",926,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",926,N],[11,"compute","","",926,N],[11,"handle_cycle_error","","",926,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",926,N],[11,"query","","",927,N],[11,"query_cache","","",927,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",927,N],[11,"compute","","",927,N],[11,"handle_cycle_error","","",927,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",927,N],[11,"query","","",928,N],[11,"query_cache","","",928,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",928,N],[11,"compute","","",928,N],[11,"handle_cycle_error","","",928,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",928,N],[11,"query","","",929,N],[11,"query_cache","","",929,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",929,N],[11,"compute","","",929,N],[11,"handle_cycle_error","","",929,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",929,N],[11,"query","","",930,N],[11,"query_cache","","",930,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",930,N],[11,"compute","","",930,N],[11,"handle_cycle_error","","",930,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",930,N],[11,"query","","",931,N],[11,"query_cache","","",931,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",931,N],[11,"compute","","",931,N],[11,"handle_cycle_error","","",931,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",931,N],[11,"query","","",932,N],[11,"query_cache","","",932,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",932,N],[11,"compute","","",932,N],[11,"handle_cycle_error","","",932,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",932,N],[11,"query","","",933,N],[11,"query_cache","","",933,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",933,N],[11,"compute","","",933,N],[11,"handle_cycle_error","","",933,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",933,N],[11,"query","","",934,N],[11,"query_cache","","",934,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",934,N],[11,"compute","","",934,N],[11,"handle_cycle_error","","",934,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",934,N],[11,"query","","",935,N],[11,"query_cache","","",935,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",935,N],[11,"compute","","",935,N],[11,"handle_cycle_error","","",935,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",935,N],[11,"query","","",936,N],[11,"query_cache","","",936,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",936,N],[11,"compute","","",936,N],[11,"handle_cycle_error","","",936,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",936,N],[11,"query","","",937,N],[11,"query_cache","","",937,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",937,N],[11,"compute","","",937,N],[11,"handle_cycle_error","","",937,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",937,N],[11,"query","","",938,N],[11,"query_cache","","",938,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",938,N],[11,"compute","","",938,N],[11,"handle_cycle_error","","",938,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",938,N],[11,"query","","",939,N],[11,"query_cache","","",939,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",939,N],[11,"compute","","",939,N],[11,"handle_cycle_error","","",939,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",939,N],[11,"query","","",940,N],[11,"query_cache","","",940,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",940,N],[11,"compute","","",940,N],[11,"handle_cycle_error","","",940,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",940,N],[11,"query","","",941,N],[11,"query_cache","","",941,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",941,N],[11,"compute","","",941,N],[11,"handle_cycle_error","","",941,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",941,N],[11,"query","","",942,N],[11,"query_cache","","",942,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",942,N],[11,"compute","","",942,N],[11,"handle_cycle_error","","",942,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",942,N],[11,"query","","",943,N],[11,"query_cache","","",943,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",943,N],[11,"compute","","",943,N],[11,"handle_cycle_error","","",943,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",943,N],[11,"query","","",944,N],[11,"query_cache","","",944,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",944,N],[11,"compute","","",944,N],[11,"handle_cycle_error","","",944,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",944,N],[11,"query","","",945,N],[11,"query_cache","","",945,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",945,N],[11,"compute","","",945,N],[11,"handle_cycle_error","","",945,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",945,N],[11,"query","","",946,N],[11,"query_cache","","",946,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",946,N],[11,"compute","","",946,N],[11,"handle_cycle_error","","",946,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",946,N],[11,"query","","",947,N],[11,"query_cache","","",947,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",947,N],[11,"compute","","",947,N],[11,"handle_cycle_error","","",947,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",947,N],[11,"query","","",948,N],[11,"query_cache","","",948,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",948,N],[11,"compute","","",948,N],[11,"handle_cycle_error","","",948,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",948,N],[11,"query","","",949,N],[11,"query_cache","","",949,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",949,N],[11,"compute","","",949,N],[11,"handle_cycle_error","","",949,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",949,N],[11,"query","","",950,N],[11,"query_cache","","",950,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",950,N],[11,"compute","","",950,N],[11,"handle_cycle_error","","",950,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",950,N],[11,"query","","",951,N],[11,"query_cache","","",951,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",951,N],[11,"compute","","",951,N],[11,"handle_cycle_error","","",951,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",951,N],[11,"query","","",952,N],[11,"query_cache","","",952,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",952,N],[11,"compute","","",952,N],[11,"handle_cycle_error","","",952,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",952,N],[11,"query","","",953,N],[11,"query_cache","","",953,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",953,N],[11,"compute","","",953,N],[11,"handle_cycle_error","","",953,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",953,N],[11,"query","","",954,N],[11,"query_cache","","",954,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",954,N],[11,"compute","","",954,N],[11,"handle_cycle_error","","",954,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",954,N],[11,"query","","",955,N],[11,"query_cache","","",955,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",955,N],[11,"compute","","",955,N],[11,"handle_cycle_error","","",955,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",955,N],[11,"query","","",956,N],[11,"query_cache","","",956,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",956,N],[11,"compute","","",956,N],[11,"handle_cycle_error","","",956,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",956,N],[11,"query","","",957,N],[11,"query_cache","","",957,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",957,N],[11,"compute","","",957,N],[11,"handle_cycle_error","","",957,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",957,N],[11,"query","","",958,N],[11,"query_cache","","",958,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",958,N],[11,"compute","","",958,N],[11,"handle_cycle_error","","",958,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",958,N],[11,"query","","",959,N],[11,"query_cache","","",959,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",959,N],[11,"compute","","",959,N],[11,"handle_cycle_error","","",959,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",959,N],[11,"query","","",960,N],[11,"query_cache","","",960,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",960,N],[11,"compute","","",960,N],[11,"handle_cycle_error","","",960,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",960,N],[11,"query","","",961,N],[11,"query_cache","","",961,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",961,N],[11,"compute","","",961,N],[11,"handle_cycle_error","","",961,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",961,N],[11,"query","","",962,N],[11,"query_cache","","",962,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",962,N],[11,"compute","","",962,N],[11,"handle_cycle_error","","",962,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",962,N],[11,"query","","",963,N],[11,"query_cache","","",963,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",963,N],[11,"compute","","",963,N],[11,"handle_cycle_error","","",963,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",963,N],[11,"query","","",964,N],[11,"query_cache","","",964,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",964,N],[11,"compute","","",964,N],[11,"handle_cycle_error","","",964,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",964,N],[11,"query","","",965,N],[11,"query_cache","","",965,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",965,N],[11,"compute","","",965,N],[11,"handle_cycle_error","","",965,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",965,N],[11,"query","","",966,N],[11,"query_cache","","",966,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",966,N],[11,"compute","","",966,N],[11,"handle_cycle_error","","",966,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",966,N],[11,"query","","",967,N],[11,"query_cache","","",967,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",967,N],[11,"compute","","",967,N],[11,"handle_cycle_error","","",967,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",967,N],[11,"query","","",968,N],[11,"query_cache","","",968,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",968,N],[11,"compute","","",968,N],[11,"handle_cycle_error","","",968,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",968,N],[11,"query","","",969,N],[11,"query_cache","","",969,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",969,N],[11,"compute","","",969,N],[11,"handle_cycle_error","","",969,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",969,N],[11,"query","","",970,N],[11,"query_cache","","",970,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",970,N],[11,"compute","","",970,N],[11,"handle_cycle_error","","",970,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",970,N],[11,"query","","",971,N],[11,"query_cache","","",971,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",971,N],[11,"compute","","",971,N],[11,"handle_cycle_error","","",971,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",971,N],[11,"query","","",972,N],[11,"query_cache","","",972,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",972,N],[11,"compute","","",972,N],[11,"handle_cycle_error","","",972,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",972,N],[11,"query","","",973,N],[11,"query_cache","","",973,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",973,N],[11,"compute","","",973,N],[11,"handle_cycle_error","","",973,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",973,N],[11,"query","","",974,N],[11,"query_cache","","",974,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",974,N],[11,"compute","","",974,N],[11,"handle_cycle_error","","",974,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",974,N],[11,"query","","",975,N],[11,"query_cache","","",975,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",975,N],[11,"compute","","",975,N],[11,"handle_cycle_error","","",975,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",975,N],[11,"query","","",976,N],[11,"query_cache","","",976,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",976,N],[11,"compute","","",976,N],[11,"handle_cycle_error","","",976,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",976,N],[11,"query","","",977,N],[11,"query_cache","","",977,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",977,N],[11,"compute","","",977,N],[11,"handle_cycle_error","","",977,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",977,N],[11,"query","","",978,N],[11,"query_cache","","",978,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",978,N],[11,"compute","","",978,N],[11,"handle_cycle_error","","",978,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",978,N],[11,"query","","",979,N],[11,"query_cache","","",979,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",979,N],[11,"compute","","",979,N],[11,"handle_cycle_error","","",979,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",979,N],[11,"query","","",980,N],[11,"query_cache","","",980,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",980,N],[11,"compute","","",980,N],[11,"handle_cycle_error","","",980,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",980,N],[11,"query","","",981,N],[11,"query_cache","","",981,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",981,N],[11,"compute","","",981,N],[11,"handle_cycle_error","","",981,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",981,N],[11,"query","","",982,N],[11,"query_cache","","",982,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",982,N],[11,"compute","","",982,N],[11,"handle_cycle_error","","",982,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",982,N],[11,"query","","",983,N],[11,"query_cache","","",983,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",983,N],[11,"compute","","",983,N],[11,"handle_cycle_error","","",983,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",983,N],[11,"query","","",984,N],[11,"query_cache","","",984,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",984,N],[11,"compute","","",984,N],[11,"handle_cycle_error","","",984,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",984,N],[11,"query","","",985,N],[11,"query_cache","","",985,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",985,N],[11,"compute","","",985,N],[11,"handle_cycle_error","","",985,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",985,N],[11,"query","","",986,N],[11,"query_cache","","",986,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",986,N],[11,"compute","","",986,N],[11,"handle_cycle_error","","",986,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",986,N],[11,"query","","",987,N],[11,"query_cache","","",987,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",987,N],[11,"compute","","",987,N],[11,"handle_cycle_error","","",987,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",987,N],[11,"query","","",988,N],[11,"query_cache","","",988,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",988,N],[11,"compute","","",988,N],[11,"handle_cycle_error","","",988,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",988,N],[11,"query","","",989,N],[11,"query_cache","","",989,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",989,N],[11,"compute","","",989,N],[11,"handle_cycle_error","","",989,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",989,N],[11,"query","","",990,N],[11,"query_cache","","",990,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",990,N],[11,"compute","","",990,N],[11,"handle_cycle_error","","",990,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",990,N],[11,"query","","",991,N],[11,"query_cache","","",991,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",991,N],[11,"compute","","",991,N],[11,"handle_cycle_error","","",991,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",991,N],[11,"query","","",992,N],[11,"query_cache","","",992,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",992,N],[11,"compute","","",992,N],[11,"handle_cycle_error","","",992,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",992,N],[11,"query","","",993,N],[11,"query_cache","","",993,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",993,N],[11,"compute","","",993,N],[11,"handle_cycle_error","","",993,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",993,N],[11,"query","","",994,N],[11,"query_cache","","",994,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",994,N],[11,"compute","","",994,N],[11,"handle_cycle_error","","",994,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",994,N],[11,"query","","",995,N],[11,"query_cache","","",995,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",995,N],[11,"compute","","",995,N],[11,"handle_cycle_error","","",995,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",995,N],[11,"query","","",996,N],[11,"query_cache","","",996,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",996,N],[11,"compute","","",996,N],[11,"handle_cycle_error","","",996,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",996,N],[11,"query","","",997,N],[11,"query_cache","","",997,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",997,N],[11,"compute","","",997,N],[11,"handle_cycle_error","","",997,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",997,N],[11,"query","","",998,N],[11,"query_cache","","",998,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",998,N],[11,"compute","","",998,N],[11,"handle_cycle_error","","",998,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",998,N],[11,"clone","rustc::ty::query","",819,[[["self"]],["tyctxtat"]]],[11,"deref","","",819,N],[11,"at","rustc::ty","Return a transparent wrapper for `TyCtxt` which uses `span` as the location of queries performed through it.",684,[[["self"],["span"]],["tyctxtat"]]],[11,"type_of","","Records the type of every item.",684,[[["self"],["defid"]],["ty"]]],[11,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics.",684,[[["self"],["defid"]],["generics"]]],[11,"predicates_of","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) that must be proven true in order to reference it. This is almost always the \"predicates query\" that you want.",684,[[["self"],["defid"]],["genericpredicates"]]],[11,"predicates_defined_on","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) directly defined on it. This is equal to the `explicit_predicates_of` predicates plus the `inferred_outlives_of` predicates.",684,[[["self"],["defid"]],["genericpredicates"]]],[11,"explicit_predicates_of","","Returns the predicates written explicit by the user.",684,[[["self"],["defid"]],["genericpredicates"]]],[11,"inferred_outlives_of","","Returns the inferred outlives predicates (e.g., for `struct Foo<'a, T> { x: &'a T }`, this would return `T: 'a`).",684,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",684,[[["self"],["defid"]],["genericpredicates"]]],[11,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",684,N],[11,"trait_def","","",684,[[["self"],["defid"]],["traitdef"]]],[11,"adt_def","","",684,[[["self"],["defid"]],["adtdef"]]],[11,"adt_destructor","","",684,[[["self"],["defid"]],["option",["destructor"]]]],[11,"adt_sized_constraint","","",684,N],[11,"adt_dtorck_constraint","","",684,[[["self"],["defid"]],["result",["dtorckconstraint","nosolution"]]]],[11,"is_const_fn","","True if this is a const fn",684,[[["self"],["defid"]],["bool"]]],[11,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",684,[[["self"],["defid"]],["bool"]]],[11,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",684,[[["self"],["cratenum"]],["lrc",["cratevariancesmap"]]]],[11,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",684,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",684,[[["self"],["cratenum"]],["lrc",["cratepredicatesmap"]]]],[11,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",684,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",684,[[["self"],["defid"]],["associateditem"]]],[11,"impl_trait_ref","","",684,[[["self"],["defid"]],["option",["traitref"]]]],[11,"impl_polarity","","",684,[[["self"],["defid"]],["implpolarity"]]],[11,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",684,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",684,[[["self"],["cratenum"]],["lrc",["defidset"]]]],[11,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",684,N],[11,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",684,[[["self"],["defid"]],["steal"]]],[11,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",684,[[["self"],["defid"]],["steal"]]],[11,"mir_validated","","",684,[[["self"],["defid"]],["steal"]]],[11,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for codegen. This is also the only query that can fetch non-local MIR, at present.",684,[[["self"],["defid"]],["mir"]]],[11,"unsafety_check_result","","The result of unsafety-checking this def-id.",684,[[["self"],["defid"]],["unsafetycheckresult"]]],[11,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",684,N],[11,"fn_sig","","The signature of functions and closures.",684,[[["self"],["defid"]],["polyfnsig"]]],[11,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",684,[[["self"],["defid"]],["coerceunsizedinfo"]]],[11,"typeck_item_bodies","","",684,[[["self"],["cratenum"]],["compileresult"]]],[11,"typeck_tables_of","","",684,[[["self"],["defid"]],["typecktables"]]],[11,"used_trait_imports","","",684,[[["self"],["defid"]],["lrc",["defidset"]]]],[11,"has_typeck_tables","","",684,[[["self"],["defid"]],["bool"]]],[11,"coherent_trait","","",684,N],[11,"borrowck","","",684,[[["self"],["defid"]],["lrc",["borrowcheckresult"]]]],[11,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",684,[[["self"],["defid"]],["borrowcheckresult"]]],[11,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",684,[[["self"],["cratenum"]],["crateinherentimpls"]]],[11,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",684,N],[11,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",684,[[["self"],["paramenvand",["globalid"]]],["constevalresult"]]],[11,"const_value_to_allocation","","Converts a constant value to an constant allocation",684,[[["self"],["const"]],["allocation"]]],[11,"check_match","","",684,[[["self"],["defid"]],["result",["errorreported"]]]],[11,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",684,[[["self"],["cratenum"]],["lrc",["accesslevels"]]]],[11,"reachable_set","","",684,[[["self"],["cratenum"]],["reachableset"]]],[11,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",684,[[["self"],["defid"]],["lrc",["scopetree"]]]],[11,"mir_shims","","",684,[[["self"],["instancedef"]],["mir"]]],[11,"def_symbol_name","","",684,[[["self"],["defid"]],["symbolname"]]],[11,"symbol_name","","",684,[[["self"],["instance"]],["symbolname"]]],[11,"describe_def","","",684,[[["self"],["defid"]],["option",["def"]]]],[11,"def_span","","",684,[[["self"],["defid"]],["span"]]],[11,"lookup_stability","","",684,[[["self"],["defid"]],["option",["stability"]]]],[11,"lookup_deprecation_entry","","",684,[[["self"],["defid"]],["option",["deprecationentry"]]]],[11,"item_attrs","","",684,[[["self"],["defid"]],["lrc"]]],[11,"codegen_fn_attrs","","",684,[[["self"],["defid"]],["codegenfnattrs"]]],[11,"fn_arg_names","","",684,[[["self"],["defid"]],["vec",["name"]]]],[11,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",684,[[["self"],["defid"]],["string"]]],[11,"impl_parent","","",684,[[["self"],["defid"]],["option",["defid"]]]],[11,"trait_of_item","","",684,[[["self"],["defid"]],["option",["defid"]]]],[11,"const_is_rvalue_promotable_to_static","","",684,[[["self"],["defid"]],["bool"]]],[11,"rvalue_promotable_map","","",684,[[["self"],["defid"]],["lrc",["itemlocalset"]]]],[11,"is_mir_available","","",684,[[["self"],["defid"]],["bool"]]],[11,"vtable_methods","","",684,[[["self"],["polytraitref"]],["lrc",["vec"]]]],[11,"codegen_fulfill_obligation","","",684,N],[11,"trait_impls_of","","",684,[[["self"],["defid"]],["lrc",["traitimpls"]]]],[11,"specialization_graph_of","","",684,[[["self"],["defid"]],["lrc",["graph"]]]],[11,"is_object_safe","","",684,[[["self"],["defid"]],["bool"]]],[11,"param_env","","",684,[[["self"],["defid"]],["paramenv"]]],[11,"is_copy_raw","","",684,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"is_sized_raw","","",684,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"is_freeze_raw","","",684,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"needs_drop_raw","","",684,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"layout_raw","","",684,[[["self"],["paramenvand",["ty"]]],["result",["layoutdetails","layouterror"]]]],[11,"dylib_dependency_formats","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"is_panic_runtime","","",684,[[["self"],["cratenum"]],["bool"]]],[11,"is_compiler_builtins","","",684,[[["self"],["cratenum"]],["bool"]]],[11,"has_global_allocator","","",684,[[["self"],["cratenum"]],["bool"]]],[11,"is_sanitizer_runtime","","",684,[[["self"],["cratenum"]],["bool"]]],[11,"is_profiler_runtime","","",684,[[["self"],["cratenum"]],["bool"]]],[11,"panic_strategy","","",684,[[["self"],["cratenum"]],["panicstrategy"]]],[11,"is_no_builtins","","",684,[[["self"],["cratenum"]],["bool"]]],[11,"extern_crate","","",684,[[["self"],["defid"]],["lrc",["option"]]]],[11,"specializes","","",684,N],[11,"in_scope_traits_map","","",684,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"module_exports","","",684,[[["self"],["defid"]],["option",["lrc"]]]],[11,"lint_levels","","",684,[[["self"],["cratenum"]],["lrc",["lintlevelmap"]]]],[11,"impl_defaultness","","",684,[[["self"],["defid"]],["defaultness"]]],[11,"check_item_well_formed","","",684,N],[11,"check_trait_item_well_formed","","",684,N],[11,"check_impl_item_well_formed","","",684,N],[11,"reachable_non_generics","","",684,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"is_reachable_non_generic","","",684,[[["self"],["defid"]],["bool"]]],[11,"is_unreachable_local_definition","","",684,[[["self"],["defid"]],["bool"]]],[11,"upstream_monomorphizations","","",684,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"upstream_monomorphizations_for","","",684,[[["self"],["defid"]],["option",["lrc"]]]],[11,"native_libraries","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"foreign_modules","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"plugin_registrar_fn","","",684,[[["self"],["cratenum"]],["option",["defid"]]]],[11,"derive_registrar_fn","","",684,[[["self"],["cratenum"]],["option",["defid"]]]],[11,"crate_disambiguator","","",684,[[["self"],["cratenum"]],["cratedisambiguator"]]],[11,"crate_hash","","",684,[[["self"],["cratenum"]],["svh"]]],[11,"original_crate_name","","",684,[[["self"],["cratenum"]],["symbol"]]],[11,"extra_filename","","",684,[[["self"],["cratenum"]],["string"]]],[11,"implementations_of_trait","","",684,N],[11,"all_trait_implementations","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"dllimport_foreign_items","","",684,[[["self"],["cratenum"]],["lrc",["fxhashset"]]]],[11,"is_dllimport_foreign_item","","",684,[[["self"],["defid"]],["bool"]]],[11,"is_statically_included_foreign_item","","",684,[[["self"],["defid"]],["bool"]]],[11,"native_library_kind","","",684,[[["self"],["defid"]],["option",["nativelibrarykind"]]]],[11,"link_args","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"resolve_lifetimes","","",684,[[["self"],["cratenum"]],["lrc",["resolvelifetimes"]]]],[11,"named_region_map","","",684,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"is_late_bound_map","","",684,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"object_lifetime_defaults_map","","",684,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"visibility","","",684,[[["self"],["defid"]],["visibility"]]],[11,"dep_kind","","",684,[[["self"],["cratenum"]],["depkind"]]],[11,"crate_name","","",684,[[["self"],["cratenum"]],["symbol"]]],[11,"item_children","","",684,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"extern_mod_stmt_cnum","","",684,[[["self"],["defid"]],["option",["cratenum"]]]],[11,"get_lang_items","","",684,[[["self"],["cratenum"]],["lrc",["languageitems"]]]],[11,"defined_lang_items","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"missing_lang_items","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"visible_parent_map","","",684,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"missing_extern_crate_item","","",684,[[["self"],["cratenum"]],["bool"]]],[11,"used_crate_source","","",684,[[["self"],["cratenum"]],["lrc",["cratesource"]]]],[11,"postorder_cnums","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"freevars","","",684,[[["self"],["defid"]],["option",["lrc"]]]],[11,"maybe_unused_trait_import","","",684,[[["self"],["defid"]],["bool"]]],[11,"maybe_unused_extern_crates","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"stability_index","","",684,[[["self"],["cratenum"]],["lrc",["index"]]]],[11,"all_crate_nums","","",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",684,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"exported_symbols","","",684,[[["self"],["cratenum"]],["arc",["vec"]]]],[11,"collect_and_partition_mono_items","","",684,N],[11,"is_codegened_item","","",684,[[["self"],["defid"]],["bool"]]],[11,"codegen_unit","","",684,[[["self"],["internedstring"]],["arc",["codegenunit"]]]],[11,"compile_codegen_unit","","",684,[[["self"],["internedstring"]],["stats"]]],[11,"output_filenames","","",684,[[["self"],["cratenum"]],["arc",["outputfilenames"]]]],[11,"erase_regions_ty","","",684,[[["self"],["ty"]],["ty"]]],[11,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",684,[[["self"],["canonicalprojectiongoal"]],["result",["lrc","nosolution"]]]],[11,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",684,[[["self"],["paramenvand",["ty"]]],["ty"]]],[11,"implied_outlives_bounds","","",684,[[["self"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[11,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",684,[[["self"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[11,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",684,[[["self"],["canonicalpredicategoal"]],["result",["evaluationresult","overflowerror"]]]],[11,"type_op_eq","","Do not call this query directly: part of the `Eq` type-op",684,[[["self"],["canonicaltypeopeqgoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_subtype","","Do not call this query directly: part of the `Subtype` type-op",684,[[["self"],["canonicaltypeopsubtypegoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_prove_predicate","","Do not call this query directly: part of the `ProvePredicate` type-op",684,[[["self"],["canonicaltypeopprovepredicategoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_ty","","Do not call this query directly: part of the `Normalize` type-op",684,[[["self"],["canonicaltypeopnormalizegoal",["ty"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_predicate","","Do not call this query directly: part of the `Normalize` type-op",684,[[["self"],["canonicaltypeopnormalizegoal",["predicate"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_poly_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",684,[[["self"],["canonicaltypeopnormalizegoal",["polyfnsig"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",684,[[["self"],["canonicaltypeopnormalizegoal",["fnsig"]]],["result",["lrc","nosolution"]]]],[11,"substitute_normalize_and_test_predicates","","",684,N],[11,"target_features_whitelist","","",684,[[["self"],["cratenum"]],["lrc",["fxhashmap"]]]],[11,"instance_def_size_estimate","","",684,[[["self"],["instancedef"]],["usize"]]],[11,"features_query","","",684,[[["self"],["cratenum"]],["lrc",["features"]]]],[11,"program_clauses_for","","",684,[[["self"],["defid"]],["clauses"]]],[11,"program_clauses_for_env","","",684,[[["self"],["paramenv"]],["clauses"]]],[11,"wasm_import_module_map","","",684,[[["self"],["cratenum"]],["lrc",["fxhashmap"]]]],[11,"type_of","rustc::ty::query","Records the type of every item.",819,[[["self"],["defid"]],["ty"]]],[11,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics.",819,[[["self"],["defid"]],["generics"]]],[11,"predicates_of","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) that must be proven true in order to reference it. This is almost always the \"predicates query\" that you want.",819,[[["self"],["defid"]],["genericpredicates"]]],[11,"predicates_defined_on","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) directly defined on it. This is equal to the `explicit_predicates_of` predicates plus the `inferred_outlives_of` predicates.",819,[[["self"],["defid"]],["genericpredicates"]]],[11,"explicit_predicates_of","","Returns the predicates written explicit by the user.",819,[[["self"],["defid"]],["genericpredicates"]]],[11,"inferred_outlives_of","","Returns the inferred outlives predicates (e.g., for `struct Foo<'a, T> { x: &'a T }`, this would return `T: 'a`).",819,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",819,[[["self"],["defid"]],["genericpredicates"]]],[11,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",819,N],[11,"trait_def","","",819,[[["self"],["defid"]],["traitdef"]]],[11,"adt_def","","",819,[[["self"],["defid"]],["adtdef"]]],[11,"adt_destructor","","",819,[[["self"],["defid"]],["option",["destructor"]]]],[11,"adt_sized_constraint","","",819,N],[11,"adt_dtorck_constraint","","",819,[[["self"],["defid"]],["result",["dtorckconstraint","nosolution"]]]],[11,"is_const_fn","","True if this is a const fn",819,[[["self"],["defid"]],["bool"]]],[11,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",819,[[["self"],["defid"]],["bool"]]],[11,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",819,[[["self"],["cratenum"]],["lrc",["cratevariancesmap"]]]],[11,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",819,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",819,[[["self"],["cratenum"]],["lrc",["cratepredicatesmap"]]]],[11,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",819,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",819,[[["self"],["defid"]],["associateditem"]]],[11,"impl_trait_ref","","",819,[[["self"],["defid"]],["option",["traitref"]]]],[11,"impl_polarity","","",819,[[["self"],["defid"]],["implpolarity"]]],[11,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",819,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",819,[[["self"],["cratenum"]],["lrc",["defidset"]]]],[11,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",819,N],[11,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",819,[[["self"],["defid"]],["steal"]]],[11,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",819,[[["self"],["defid"]],["steal"]]],[11,"mir_validated","","",819,[[["self"],["defid"]],["steal"]]],[11,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for codegen. This is also the only query that can fetch non-local MIR, at present.",819,[[["self"],["defid"]],["mir"]]],[11,"unsafety_check_result","","The result of unsafety-checking this def-id.",819,[[["self"],["defid"]],["unsafetycheckresult"]]],[11,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",819,N],[11,"fn_sig","","The signature of functions and closures.",819,[[["self"],["defid"]],["polyfnsig"]]],[11,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",819,[[["self"],["defid"]],["coerceunsizedinfo"]]],[11,"typeck_item_bodies","","",819,[[["self"],["cratenum"]],["compileresult"]]],[11,"typeck_tables_of","","",819,[[["self"],["defid"]],["typecktables"]]],[11,"used_trait_imports","","",819,[[["self"],["defid"]],["lrc",["defidset"]]]],[11,"has_typeck_tables","","",819,[[["self"],["defid"]],["bool"]]],[11,"coherent_trait","","",819,N],[11,"borrowck","","",819,[[["self"],["defid"]],["lrc",["borrowcheckresult"]]]],[11,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",819,[[["self"],["defid"]],["borrowcheckresult"]]],[11,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",819,[[["self"],["cratenum"]],["crateinherentimpls"]]],[11,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",819,N],[11,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",819,[[["self"],["paramenvand",["globalid"]]],["constevalresult"]]],[11,"const_value_to_allocation","","Converts a constant value to an constant allocation",819,[[["self"],["const"]],["allocation"]]],[11,"check_match","","",819,[[["self"],["defid"]],["result",["errorreported"]]]],[11,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",819,[[["self"],["cratenum"]],["lrc",["accesslevels"]]]],[11,"reachable_set","","",819,[[["self"],["cratenum"]],["reachableset"]]],[11,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",819,[[["self"],["defid"]],["lrc",["scopetree"]]]],[11,"mir_shims","","",819,[[["self"],["instancedef"]],["mir"]]],[11,"def_symbol_name","","",819,[[["self"],["defid"]],["symbolname"]]],[11,"symbol_name","","",819,[[["self"],["instance"]],["symbolname"]]],[11,"describe_def","","",819,[[["self"],["defid"]],["option",["def"]]]],[11,"def_span","","",819,[[["self"],["defid"]],["span"]]],[11,"lookup_stability","","",819,[[["self"],["defid"]],["option",["stability"]]]],[11,"lookup_deprecation_entry","","",819,[[["self"],["defid"]],["option",["deprecationentry"]]]],[11,"item_attrs","","",819,[[["self"],["defid"]],["lrc"]]],[11,"codegen_fn_attrs","","",819,[[["self"],["defid"]],["codegenfnattrs"]]],[11,"fn_arg_names","","",819,[[["self"],["defid"]],["vec",["name"]]]],[11,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",819,[[["self"],["defid"]],["string"]]],[11,"impl_parent","","",819,[[["self"],["defid"]],["option",["defid"]]]],[11,"trait_of_item","","",819,[[["self"],["defid"]],["option",["defid"]]]],[11,"const_is_rvalue_promotable_to_static","","",819,[[["self"],["defid"]],["bool"]]],[11,"rvalue_promotable_map","","",819,[[["self"],["defid"]],["lrc",["itemlocalset"]]]],[11,"is_mir_available","","",819,[[["self"],["defid"]],["bool"]]],[11,"vtable_methods","","",819,[[["self"],["polytraitref"]],["lrc",["vec"]]]],[11,"codegen_fulfill_obligation","","",819,N],[11,"trait_impls_of","","",819,[[["self"],["defid"]],["lrc",["traitimpls"]]]],[11,"specialization_graph_of","","",819,[[["self"],["defid"]],["lrc",["graph"]]]],[11,"is_object_safe","","",819,[[["self"],["defid"]],["bool"]]],[11,"param_env","","",819,[[["self"],["defid"]],["paramenv"]]],[11,"is_copy_raw","","",819,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"is_sized_raw","","",819,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"is_freeze_raw","","",819,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"needs_drop_raw","","",819,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"layout_raw","","",819,[[["self"],["paramenvand",["ty"]]],["result",["layoutdetails","layouterror"]]]],[11,"dylib_dependency_formats","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"is_panic_runtime","","",819,[[["self"],["cratenum"]],["bool"]]],[11,"is_compiler_builtins","","",819,[[["self"],["cratenum"]],["bool"]]],[11,"has_global_allocator","","",819,[[["self"],["cratenum"]],["bool"]]],[11,"is_sanitizer_runtime","","",819,[[["self"],["cratenum"]],["bool"]]],[11,"is_profiler_runtime","","",819,[[["self"],["cratenum"]],["bool"]]],[11,"panic_strategy","","",819,[[["self"],["cratenum"]],["panicstrategy"]]],[11,"is_no_builtins","","",819,[[["self"],["cratenum"]],["bool"]]],[11,"extern_crate","","",819,[[["self"],["defid"]],["lrc",["option"]]]],[11,"specializes","","",819,N],[11,"in_scope_traits_map","","",819,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"module_exports","","",819,[[["self"],["defid"]],["option",["lrc"]]]],[11,"lint_levels","","",819,[[["self"],["cratenum"]],["lrc",["lintlevelmap"]]]],[11,"impl_defaultness","","",819,[[["self"],["defid"]],["defaultness"]]],[11,"check_item_well_formed","","",819,N],[11,"check_trait_item_well_formed","","",819,N],[11,"check_impl_item_well_formed","","",819,N],[11,"reachable_non_generics","","",819,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"is_reachable_non_generic","","",819,[[["self"],["defid"]],["bool"]]],[11,"is_unreachable_local_definition","","",819,[[["self"],["defid"]],["bool"]]],[11,"upstream_monomorphizations","","",819,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"upstream_monomorphizations_for","","",819,[[["self"],["defid"]],["option",["lrc"]]]],[11,"native_libraries","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"foreign_modules","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"plugin_registrar_fn","","",819,[[["self"],["cratenum"]],["option",["defid"]]]],[11,"derive_registrar_fn","","",819,[[["self"],["cratenum"]],["option",["defid"]]]],[11,"crate_disambiguator","","",819,[[["self"],["cratenum"]],["cratedisambiguator"]]],[11,"crate_hash","","",819,[[["self"],["cratenum"]],["svh"]]],[11,"original_crate_name","","",819,[[["self"],["cratenum"]],["symbol"]]],[11,"extra_filename","","",819,[[["self"],["cratenum"]],["string"]]],[11,"implementations_of_trait","","",819,N],[11,"all_trait_implementations","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"dllimport_foreign_items","","",819,[[["self"],["cratenum"]],["lrc",["fxhashset"]]]],[11,"is_dllimport_foreign_item","","",819,[[["self"],["defid"]],["bool"]]],[11,"is_statically_included_foreign_item","","",819,[[["self"],["defid"]],["bool"]]],[11,"native_library_kind","","",819,[[["self"],["defid"]],["option",["nativelibrarykind"]]]],[11,"link_args","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"resolve_lifetimes","","",819,[[["self"],["cratenum"]],["lrc",["resolvelifetimes"]]]],[11,"named_region_map","","",819,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"is_late_bound_map","","",819,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"object_lifetime_defaults_map","","",819,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"visibility","","",819,[[["self"],["defid"]],["visibility"]]],[11,"dep_kind","","",819,[[["self"],["cratenum"]],["depkind"]]],[11,"crate_name","","",819,[[["self"],["cratenum"]],["symbol"]]],[11,"item_children","","",819,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"extern_mod_stmt_cnum","","",819,[[["self"],["defid"]],["option",["cratenum"]]]],[11,"get_lang_items","","",819,[[["self"],["cratenum"]],["lrc",["languageitems"]]]],[11,"defined_lang_items","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"missing_lang_items","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"visible_parent_map","","",819,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"missing_extern_crate_item","","",819,[[["self"],["cratenum"]],["bool"]]],[11,"used_crate_source","","",819,[[["self"],["cratenum"]],["lrc",["cratesource"]]]],[11,"postorder_cnums","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"freevars","","",819,[[["self"],["defid"]],["option",["lrc"]]]],[11,"maybe_unused_trait_import","","",819,[[["self"],["defid"]],["bool"]]],[11,"maybe_unused_extern_crates","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"stability_index","","",819,[[["self"],["cratenum"]],["lrc",["index"]]]],[11,"all_crate_nums","","",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",819,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"exported_symbols","","",819,[[["self"],["cratenum"]],["arc",["vec"]]]],[11,"collect_and_partition_mono_items","","",819,N],[11,"is_codegened_item","","",819,[[["self"],["defid"]],["bool"]]],[11,"codegen_unit","","",819,[[["self"],["internedstring"]],["arc",["codegenunit"]]]],[11,"compile_codegen_unit","","",819,[[["self"],["internedstring"]],["stats"]]],[11,"output_filenames","","",819,[[["self"],["cratenum"]],["arc",["outputfilenames"]]]],[11,"erase_regions_ty","","",819,[[["self"],["ty"]],["ty"]]],[11,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",819,[[["self"],["canonicalprojectiongoal"]],["result",["lrc","nosolution"]]]],[11,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",819,[[["self"],["paramenvand",["ty"]]],["ty"]]],[11,"implied_outlives_bounds","","",819,[[["self"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[11,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",819,[[["self"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[11,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",819,[[["self"],["canonicalpredicategoal"]],["result",["evaluationresult","overflowerror"]]]],[11,"type_op_eq","","Do not call this query directly: part of the `Eq` type-op",819,[[["self"],["canonicaltypeopeqgoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_subtype","","Do not call this query directly: part of the `Subtype` type-op",819,[[["self"],["canonicaltypeopsubtypegoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_prove_predicate","","Do not call this query directly: part of the `ProvePredicate` type-op",819,[[["self"],["canonicaltypeopprovepredicategoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_ty","","Do not call this query directly: part of the `Normalize` type-op",819,[[["self"],["canonicaltypeopnormalizegoal",["ty"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_predicate","","Do not call this query directly: part of the `Normalize` type-op",819,[[["self"],["canonicaltypeopnormalizegoal",["predicate"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_poly_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",819,[[["self"],["canonicaltypeopnormalizegoal",["polyfnsig"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",819,[[["self"],["canonicaltypeopnormalizegoal",["fnsig"]]],["result",["lrc","nosolution"]]]],[11,"substitute_normalize_and_test_predicates","","",819,N],[11,"target_features_whitelist","","",819,[[["self"],["cratenum"]],["lrc",["fxhashmap"]]]],[11,"instance_def_size_estimate","","",819,[[["self"],["instancedef"]],["usize"]]],[11,"features_query","","",819,[[["self"],["cratenum"]],["lrc",["features"]]]],[11,"program_clauses_for","","",819,[[["self"],["defid"]],["clauses"]]],[11,"program_clauses_for_env","","",819,[[["self"],["paramenv"]],["clauses"]]],[11,"wasm_import_module_map","","",819,[[["self"],["cratenum"]],["lrc",["fxhashmap"]]]],[11,"default","","",820,[[],["self"]]],[11,"clone","","",820,[[["self"]],["self"]]],[11,"try_adt_sized_constraint","rustc::ty","",684,[[["self"],["span"],["defid"]],["result",["diagnosticbuilder"]]]],[11,"try_needs_drop_raw","","",684,[[["self"],["span"],["paramenvand",["ty"]]],["result",["bool","diagnosticbuilder"]]]],[11,"try_optimized_mir","","",684,[[["self"],["span"],["defid"]],["result",["mir","diagnosticbuilder"]]]],[0,"relate","","Generalized type relating mechanism. A type relation R relates a pair of values (A, B). A and B are usually types or regions but can be other things. Examples of type relations are subtyping, type equality, etc.",N,N],[3,"GeneratorWitness","rustc::ty::relate","",N,N],[12,"0","","",999,N],[4,"Cause","","",N,N],[13,"ExistentialRegionBound","","",1000,N],[5,"relate_substs","","",N,[[["r"],["option",["vec"]],["substs"],["substs"]],["relateresult",["substs"]]]],[5,"super_relate_tys","","The main \"type relation\" routine. Note that this does not handle inference artifacts, so you should filter those out before calling it.",N,[[["r"],["ty"],["ty"]],["relateresult",["ty"]]]],[5,"expected_found","","",N,[[["r"],["t"],["t"]],["expectedfound"]]],[5,"expected_found_bool","","",N,[[["bool"],["t"],["t"]],["expectedfound"]]],[6,"RelateResult","","",N,N],[8,"TypeRelation","","",N,N],[10,"tcx","","",1001,[[["self"]],["tyctxt"]]],[10,"tag","","Returns a static string we can use for printouts.",1001,[[["self"]],["str"]]],[10,"a_is_expected","","Returns true if the value `a` is the \"expected\" type in the relation. Just affects error messages.",1001,[[["self"]],["bool"]]],[11,"with_cause","","",1001,[[["self"],["cause"],["f"]],["r"]]],[11,"relate","","Generic relation routine suitable for most anything.",1001,[[["self"],["t"],["t"]],["relateresult"]]],[11,"relate_item_substs","","Relate the two substitutions for the given item. The default is to look up the variance for the item and proceed accordingly.",1001,[[["self"],["defid"],["substs"],["substs"]],["relateresult",["substs"]]]],[10,"relate_with_variance","","Switch variance for the purpose of relating `a` and `b`.",1001,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[10,"tys","","",1001,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[10,"regions","","",1001,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[10,"binders","","",1001,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[8,"Relate","","",N,N],[10,"relate","","",1002,[[["r"],["self"],["self"]],["relateresult"]]],[11,"clone","","",1000,[[["self"]],["cause"]]],[11,"fmt","","",1000,[[["self"],["formatter"]],["result"]]],[11,"relate","rustc::ty","",673,[[["r"],["typeandmut"],["typeandmut"]],["relateresult",["typeandmut"]]]],[11,"relate","","",667,[[["r"],["fnsig"],["fnsig"]],["relateresult",["fnsig"]]]],[11,"relate","rustc::hir","",126,[[["r"],["unsafety"],["unsafety"]],["relateresult",["unsafety"]]]],[11,"relate","rustc::ty","",670,[[["r"],["projectionty"],["projectionty"]],["relateresult",["projectionty"]]]],[11,"relate","","",676,[[["r"],["existentialprojection"],["existentialprojection"]],["relateresult",["existentialprojection"]]]],[11,"relate","","",674,[[["r"],["traitref"],["traitref"]],["relateresult",["traitref"]]]],[11,"relate","","",675,[[["r"],["existentialtraitref"],["existentialtraitref"]],["relateresult",["existentialtraitref"]]]],[11,"fmt","rustc::ty::relate","",999,[[["self"],["formatter"]],["result"]]],[11,"clone","","",999,[[["self"]],["generatorwitness"]]],[11,"super_fold_with","","",999,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",999,[[["self"],["v"]],["bool"]]],[11,"relate","","",999,[[["r"],["generatorwitness"],["generatorwitness"]],["relateresult",["generatorwitness"]]]],[11,"relate","rustc::ty","",671,[[["r"],["closuresubsts"],["closuresubsts"]],["relateresult",["closuresubsts"]]]],[11,"relate","","",672,[[["r"],["generatorsubsts"],["generatorsubsts"]],["relateresult",["generatorsubsts"]]]],[11,"relate","","",664,[[["r"],["binder"],["binder"]],["relateresult",["binder"]]]],[0,"steal","","",N,N],[3,"Steal","rustc::ty::steal","The `Steal` struct is intended to used as the value for a query. Specifically, we sometimes have queries (cough MIR cough) where we create a large, complex value that we want to iteratively update (e.g., optimize). We could clone the value for each optimization, but that'd be expensive. And yet we don't just want to mutate it in place, because that would spoil the idea that queries are these pure functions that produce an immutable value (since if you did the query twice, you could observe the mutations). So instead we have the query produce a `&'tcx Steal<Mir<'tcx>>` (to be very specific). Now we can read from this as much as we want (using `borrow()`), but you can also `steal()`. Once you steal, any further attempt to read will panic. Therefore we know that -- assuming no ICE -- nobody is observing the fact that the MIR was updated.",N,N],[12,"value","","",1003,N],[11,"new","","",1003,[[["t"]],["self"]]],[11,"borrow","","",1003,[[["self"]],["readguard"]]],[11,"steal","","",1003,[[["self"]],["t"]]],[0,"subst","rustc::ty","",N,N],[3,"Kind","rustc::ty::subst","An entity in the Rust typesystem, which can be one of several kinds (only types and lifetimes for now). To reduce memory usage, a `Kind` is a interned pointer, with the lowest 2 bits being reserved for a tag to indicate the type (`Ty` or `Region`) it points to.",N,N],[12,"ptr","","",1004,N],[12,"marker","","",1004,N],[3,"SubstFolder","","",N,N],[12,"tcx","","",1005,N],[12,"substs","","",1005,N],[12,"span","","",1005,N],[12,"root_ty","","",1005,N],[12,"ty_stack_depth","","",1005,N],[12,"region_binders_passed","","",1005,N],[4,"UnpackedKind","","",N,N],[13,"Lifetime","","",1006,N],[13,"Type","","",1006,N],[6,"Substs","","A substitution mapping generic parameters to new values.",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"TAG_MASK","","",N,N],[17,"TYPE_TAG","","",N,N],[17,"REGION_TAG","","",N,N],[8,"Subst","","",N,N],[11,"subst","","",1007,N],[10,"subst_spanned","","",1007,N],[11,"clone","","",1004,[[["self"]],["kind"]]],[11,"eq","","",1004,[[["self"],["kind"]],["bool"]]],[11,"ne","","",1004,[[["self"],["kind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1004,N],[11,"hash","","",1004,N],[11,"fmt","","",1006,[[["self"],["formatter"]],["result"]]],[11,"encode","","",1006,[[["self"],["__s"]],["result"]]],[11,"decode","","",1006,[[["__d"]],["result",["unpackedkind"]]]],[11,"pack","","",1006,[[["self"]],["kind"]]],[11,"cmp","","",1004,[[["self"],["kind"]],["ordering"]]],[11,"partial_cmp","","",1004,[[["self"],["kind"]],["option",["ordering"]]]],[11,"from","","",1004,[[["region"]],["kind"]]],[11,"from","","",1004,[[["ty"]],["kind"]]],[11,"unpack","","",1004,[[["self"]],["unpackedkind"]]],[11,"fmt","","",1004,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1004,[[["self"],["formatter"]],["result"]]],[11,"lift_to_tcx","","",1004,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",1004,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",1004,[[["self"],["v"]],["bool"]]],[11,"encode","","",1004,[[["self"],["e"]],["result"]]],[11,"decode","","",1004,[[["d"]],["result",["kind"]]]],[11,"identity_for_item","","Creates a Substs that maps each generic parameter to itself.",1008,[[["tyctxt"],["defid"]],["substs"]]],[11,"for_item","","Creates a Substs for generic parameter definitions, by calling closures to obtain each kind. The closures get to observe the Substs as they're being built, which can be used to correctly substitute defaults of generic parameters.",1008,[[["tyctxt"],["defid"],["f"]],["substs"]]],[11,"extend_to","","",1008,[[["self"],["tyctxt"],["defid"],["f"]],["substs"]]],[11,"fill_item","","",1008,[[["accumulatevec"],["tyctxt"],["generics"],["f"]]]],[11,"fill_single","","",1008,[[["accumulatevec"],["generics"],["f"]]]],[11,"is_noop","","",1008,[[["self"]],["bool"]]],[11,"types","","",1008,[[["self"]],[""]]],[11,"regions","","",1008,[[["self"]],[""]]],[11,"type_at","","",1008,[[["self"],["usize"]],["ty"]]],[11,"region_at","","",1008,[[["self"],["usize"]],["region"]]],[11,"type_for_def","","",1008,[[["self"],["genericparamdef"]],["kind"]]],[11,"rebase_onto","","Transform from substitutions for a child of `source_ancestor` (e.g. a trait or impl) to substitutions for the same child in a different item, with `target_substs` as the base for the target impl/trait, with the source child-specific parameters (e.g. method parameters) on top of that base.",1008,[[["self"],["tyctxt"],["defid"],["substs"]],["substs"]]],[11,"truncate_to","","",1008,[[["self"],["tyctxt"],["generics"]],["substs"]]],[11,"tcx","","",1005,[[["self"]],["tyctxt"]]],[11,"fold_binder","","",1005,[[["self"],["binder"]],["binder"]]],[11,"fold_region","","",1005,[[["self"],["region"]],["region"]]],[11,"fold_ty","","",1005,[[["self"],["ty"]],["ty"]]],[11,"ty_for_param","","",1005,[[["self"],["paramty"],["ty"]],["ty"]]],[11,"shift_regions_through_binders","","It is sometimes necessary to adjust the debruijn indices during substitution. This occurs when we are substituting a type with escaping regions into a context where we have passed through region binders. That's quite a mouthful. Let's see an example:",1005,[[["self"],["ty"]],["ty"]]],[11,"shift_region_through_binders","","",1005,[[["self"],["region"]],["region"]]],[0,"trait_def","rustc::ty","",N,N],[3,"TraitDef","rustc::ty::trait_def","A trait's definition with type information.",N,N],[12,"def_id","","",1009,N],[12,"unsafety","","",1009,N],[12,"paren_sugar","","If `true`, then this trait had the `#[rustc_paren_sugar]` attribute, indicating that it should be used with `Foo()` sugar. This is a temporary thing -- eventually any trait will be usable with the sugar (or without it).",1009,N],[12,"has_auto_impl","","",1009,N],[12,"def_path_hash","","The ICH of this trait's DefPath, cached here so it doesn't have to be recomputed all the time.",1009,N],[3,"TraitImpls","","",N,N],[12,"blanket_impls","","",1010,N],[12,"non_blanket_impls","","Impls indexed by their simplified self-type, for fast lookup.",1010,N],[5,"trait_impls_of_provider","","",N,[[["tyctxt"],["defid"]],["lrc",["traitimpls"]]]],[11,"new","","",1009,[[["defid"],["unsafety"],["bool"],["bool"],["defpathhash"]],["traitdef"]]],[11,"ancestors","","",1009,[[["self"],["tyctxt"],["defid"]],["ancestors"]]],[11,"for_each_impl","rustc::ty","",684,[[["self"],["defid"],["f"]]]],[11,"for_each_relevant_impl","","Iterate over every impl that could possibly match the self-type `self_ty`.",684,[[["self"],["defid"],["ty"],["f"]]]],[11,"hash_stable","rustc::ty::trait_def","",1010,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"walk","rustc::ty","An iterator over the type substructure. WARNING: this does not keep track of the region depth.",N,N],[3,"TypeWalker","rustc::ty::walk","",N,N],[12,"stack","","",1011,N],[12,"last_subtree","","",1011,N],[5,"walk_shallow","","",N,[[["ty"]],["accintoiter",["typewalkerarray"]]]],[5,"push_subtypes","","",N,[[["typewalkerstack"],["ty"]]]],[5,"push_const","","",N,[[["typewalkerstack"],["const"]]]],[6,"TypeWalkerArray","","",N,N],[6,"TypeWalkerStack","","",N,N],[11,"new","","",1011,[[["ty"]],["typewalker"]]],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type returned by `next()`.",1011,[[["self"]]]],[11,"next","","",1011,[[["self"]],["option",["ty"]]]],[0,"wf","rustc::ty","",N,N],[3,"WfPredicates","rustc::ty::wf","",N,N],[12,"infcx","","",1012,N],[12,"param_env","","",1012,N],[12,"body_id","","",1012,N],[12,"span","","",1012,N],[12,"out","","",1012,N],[4,"Elaborate","","Controls whether we \"elaborate\" supertraits and so forth on the WF predicates. This is a kind of hack to address #43784. The underlying problem in that issue was a trait structure like:",N,N],[13,"All","","",1013,N],[13,"None","","",1013,N],[5,"obligations","","Returns the set of obligations needed to make `ty` well-formed. If `ty` contains unresolved inference variables, this may include further WF obligations. However, if `ty` IS an unresolved inference variable, returns `None`, because we are not able to make any progress at all. This is to prevent \"livelock\" where we say \"$0 is WF if $0 is WF\".",N,[[["inferctxt"],["paramenv"],["nodeid"],["ty"],["span"]],["option",["vec"]]]],[5,"trait_obligations","","Returns the obligations that make this trait reference well-formed.  For example, if there is a trait `Set` defined like `trait Set<K:Eq>`, then the trait reference `Foo: Set<Bar>` is WF if `Bar: Eq`.",N,[[["inferctxt"],["paramenv"],["nodeid"],["traitref"],["span"]],["vec",["predicateobligation"]]]],[5,"predicate_obligations","","",N,[[["inferctxt"],["paramenv"],["nodeid"],["predicate"],["span"]],["vec",["predicateobligation"]]]],[5,"object_region_bounds","","Given an object type like `SomeTrait+Send`, computes the lifetime bounds that must hold on the elided self type. These are derived from the declarations of `SomeTrait`, `Send`, and friends -- if they declare `trait SomeTrait : 'static`, for example, then `'static` would appear in the list. The hard work is done by `ty::required_region_bounds`, see that for more information.",N,[[["tyctxt"],["binder",["slice"]]],["vec",["region"]]]],[11,"fmt","","",1013,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1013,[[["self"],["elaborate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1013,N],[11,"clone","","",1013,[[["self"]],["elaborate"]]],[11,"cause","","",1012,[[["self"],["obligationcausecode"]],["obligationcause"]]],[11,"normalize","","",1012,[[["self"]],["vec",["predicateobligation"]]]],[11,"compute_trait_ref","","Pushes the obligations required for `trait_ref` to be WF into `self.out`.",1012,[[["self"],["traitref"],["elaborate"]]]],[11,"compute_projection","","Pushes the obligations required for `trait_ref::Item` to be WF into `self.out`.",1012,[[["self"],["projectionty"]]]],[11,"compute_const","","Pushes the obligations required for a constant value to be WF into `self.out`.",1012,[[["self"],["const"]]]],[11,"require_sized","","",1012,[[["self"],["ty"],["obligationcausecode"]]]],[11,"compute","","Push new obligations into `out`. Returns true if it was able to generate all the predicates needed to validate that `ty0` is WF. Returns false if `ty0` is an unresolved type variable, in which case we are not able to simplify at all.",1012,[[["self"],["ty"]],["bool"]]],[11,"nominal_obligations","","",1012,[[["self"],["defid"],["substs"]],["vec",["predicateobligation"]]]],[11,"from_object_ty","","",1012,[[["self"],["ty"],["binder",["slice"]],["region"]]]],[0,"util","rustc::ty","misc. type-system utilities too small to deserve their own file",N,N],[3,"Discr","rustc::ty::util","",N,N],[12,"val","","bit representation of the discriminant, so `-128i8` is `0xFF_u128`",1014,N],[12,"ty","","",1014,N],[4,"CopyImplementationError","","",N,N],[13,"InfrigingFields","","",1015,N],[13,"NotAnAdt","","",1015,N],[13,"HasDestructor","","",1015,N],[4,"Representability","","Describes whether a type is representable. For types that are not representable, 'SelfRecursive' and 'ContainsRecursive' are used to distinguish between types that are recursive with themselves and types that contain a different recursive type. These cases can therefore be treated differently when reporting errors.",N,N],[13,"Representable","","",1016,N],[13,"ContainsRecursive","","",1016,N],[13,"SelfRecursive","","",1016,N],[4,"ExplicitSelf","","",N,N],[13,"ByValue","","",1017,N],[13,"ByReference","","",1017,N],[13,"ByRawPointer","","",1017,N],[13,"ByBox","","",1017,N],[13,"Other","","",1017,N],[5,"is_copy_raw","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["bool"]]],[5,"is_sized_raw","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["bool"]]],[5,"is_freeze_raw","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["bool"]]],[5,"needs_drop_raw","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["bool"]]],[5,"provide","","",N,[[["providers"]]]],[8,"IntTypeExt","","",N,N],[10,"to_ty","","",1018,[[["self"],["tyctxt"]],["ty"]]],[10,"disr_incr","","",1018,[[["self"],["tyctxt"],["option",["discr"]]],["option",["discr"]]]],[10,"initial_discriminant","","",1018,[[["self"],["tyctxt"]],["discr"]]],[11,"clone","","",1014,[[["self"]],["discr"]]],[11,"fmt","","",1014,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1014,[[["self"],["formatter"]],["result"]]],[11,"wrap_incr","","Adds 1 to the value and wraps around if the maximum for the type is reached",1014,[[["self"],["tyctxt"]],["self"]]],[11,"checked_add","","",1014,N],[11,"clone","","",1015,[[["self"]],["copyimplementationerror"]]],[11,"clone","","",1016,[[["self"]],["representability"]]],[11,"partial_cmp","","",1016,[[["self"],["representability"]],["option",["ordering"]]]],[11,"lt","","",1016,[[["self"],["representability"]],["bool"]]],[11,"le","","",1016,[[["self"],["representability"]],["bool"]]],[11,"gt","","",1016,[[["self"],["representability"]],["bool"]]],[11,"ge","","",1016,[[["self"],["representability"]],["bool"]]],[11,"cmp","","",1016,[[["self"],["representability"]],["ordering"]]],[11,"assert_receiver_is_total_eq","","",1016,N],[11,"eq","","",1016,[[["self"],["representability"]],["bool"]]],[11,"ne","","",1016,[[["self"],["representability"]],["bool"]]],[11,"fmt","","",1016,[[["self"],["formatter"]],["result"]]],[11,"can_type_implement_copy","rustc::ty","",713,[[["self"],["tyctxt"],["ty"]],["result",["copyimplementationerror"]]]],[11,"type_id_hash","","Creates a hash of the type `Ty` which will be the same no matter what crate context it's calculated within. This is used by the `type_id` intrinsic.",684,[[["self"],["ty"]],["u64"]]],[11,"has_error_field","","",684,[[["self"],["ty"]],["bool"]]],[11,"struct_tail","","Returns the deeply last field of nested structures, or the same type, if not a structure at all. Corresponds to the only possible unsized field, and its type can be used to determine unsizing strategy.",684,[[["self"],["ty"]],["ty"]]],[11,"struct_lockstep_tails","","Same as applying struct_tail on `source` and `target`, but only keeps going as long as the two types are instances of the same structure definitions. For `(Foo<Foo<T>>, Foo<Trait>)`, the result will be `(Foo<T>, Trait)`, whereas struct_tail produces `T`, and `Trait`, respectively.",684,N],[11,"required_region_bounds","","Given a set of predicates that apply to an object type, returns the region bounds that the (erased) `Self` type must outlive. Precisely because the `Self` type is erased, the parameter `erased_self_ty` must be supplied to indicate what type has been used to represent `Self` in the predicates themselves. This should really be a unique type; `FreshTy(0)` is a popular choice.",684,[[["self"],["ty"],["vec",["predicate"]]],["vec",["region"]]]],[11,"calculate_dtor","","Calculate the destructor of a given type.",684,[[["self"],["defid"],["fnmut"]],["option",["destructor"]]]],[11,"destructor_constraints","","Return the set of types that are required to be alive in order to run the destructor of `def` (see RFCs 769 and 1238).",684,[[["self"],["adtdef"]],["vec",["kind"]]]],[11,"is_closure","","True if `def_id` refers to a closure (e.g., `|x| x * 2`). Note that closures have a def-id, but the closure expression also has a `HirId` that is located within the context where the closure appears (and, sadly, a corresponding `NodeId`, since those are not yet phased out). The parent of the closure's def-id will also be the context where it appears.",684,[[["self"],["defid"]],["bool"]]],[11,"is_trait","","True if `def_id` refers to a trait (e.g., `trait Foo { ... }`).",684,[[["self"],["defid"]],["bool"]]],[11,"is_struct_constructor","","True if this def-id refers to the implicit constructor for a tuple struct like `struct Foo(u32)`.",684,[[["self"],["defid"]],["bool"]]],[11,"closure_base_def_id","","Given the `DefId` of a fn or closure, returns the `DefId` of the innermost fn item that the closure is contained within. This is a significant def-id because, when we do type-checking, we type-check this fn item and all of its (transitive) closures together.  Therefore, when we fetch the `typeck_tables_of` the closure, for example, we really wind up fetching the `typeck_tables_of` the enclosing fn item.",684,[[["self"],["defid"]],["defid"]]],[11,"closure_env_ty","","Given the def-id and substs a closure, creates the type of `self` argument that the closure expects. For example, for a `Fn` closure, this would return a reference type `&T` where `T=closure_ty`.",684,[[["self"],["defid"],["closuresubsts"]],["option",["binder"]]]],[11,"empty_substs_for_def_id","","Given the def-id of some item that has no type parameters, make a suitable \"empty substs\" for it.",684,[[["self"],["defid"]],["substs"]]],[11,"is_static","","Return whether the node pointed to by def_id is a static item, and its mutability",684,[[["self"],["defid"]],["option",["mutability"]]]],[11,"moves_by_default","","",696,[[["self"],["tyctxt"],["paramenv"],["span"]],["bool"]]],[11,"is_sized","","",696,[[["self"],["tyctxtat"],["paramenv"]],["bool"]]],[11,"is_freeze","","",696,[[["self"],["tyctxt"],["paramenv"],["span"]],["bool"]]],[11,"needs_drop","","If `ty.needs_drop(...)` returns `true`, then `ty` is definitely non-copy and might have a destructor attached; if it returns `false`, then `ty` definitely has no destructor (i.e. no drop glue).",696,[[["self"],["tyctxt"],["paramenv"]],["bool"]]],[11,"is_representable","","Check whether a type is representable. This means it cannot contain unboxed structural recursion. This check is needed for structs and enums.",696,[[["self"],["tyctxt"],["span"]],["representability"]]],[11,"determine","rustc::ty::util","Categorizes an explicit self declaration like `self: SomeType` into either `self`, `&self`, `&mut self`, `Box<self>`, or `Other`. This is mainly used to require the arbitrary_self_types feature in the case of `Other`, to improve error messages in the common cases, and to make `Other` non-object-safe.",1017,[[["ty"],["p"]],["explicitself"]]],[0,"context","rustc::ty","type context book-keeping",N,N],[3,"AllArenas","rustc::ty::context","",N,N],[12,"global","","",686,N],[12,"interner","","",686,N],[3,"GlobalArenas","","Internal storage",N,N],[12,"layout","","",685,N],[12,"generics","","",685,N],[12,"trait_def","","",685,N],[12,"adt_def","","",685,N],[12,"steal_mir","","",685,N],[12,"mir","","",685,N],[12,"tables","","",685,N],[12,"const_allocs","","miri allocations",685,N],[3,"CtxtInterners","","",N,N],[12,"arena","","The arena that types, regions, etc are allocated from",1019,N],[12,"type_","","Specifically use a speedy hash algorithm for these hash sets, they're accessed quite often.",1019,N],[12,"type_list","","",1019,N],[12,"substs","","",1019,N],[12,"canonical_var_infos","","",1019,N],[12,"region","","",1019,N],[12,"existential_predicates","","",1019,N],[12,"predicates","","",1019,N],[12,"const_","","",1019,N],[12,"clauses","","",1019,N],[12,"goals","","",1019,N],[3,"CommonTypes","","",N,N],[12,"bool","","",1020,N],[12,"char","","",1020,N],[12,"isize","","",1020,N],[12,"i8","","",1020,N],[12,"i16","","",1020,N],[12,"i32","","",1020,N],[12,"i64","","",1020,N],[12,"i128","","",1020,N],[12,"usize","","",1020,N],[12,"u8","","",1020,N],[12,"u16","","",1020,N],[12,"u32","","",1020,N],[12,"u64","","",1020,N],[12,"u128","","",1020,N],[12,"f32","","",1020,N],[12,"f64","","",1020,N],[12,"never","","",1020,N],[12,"err","","",1020,N],[12,"re_empty","","",1020,N],[12,"re_static","","",1020,N],[12,"re_erased","","",1020,N],[3,"LocalTableInContext","","",N,N],[12,"local_id_root","","",1021,N],[12,"data","","",1021,N],[3,"LocalTableInContextMut","","",N,N],[12,"local_id_root","","",1022,N],[12,"data","","",1022,N],[3,"TypeckTables","","",N,N],[12,"local_id_root","","The HirId::owner all ItemLocalIds in this table are relative to.",687,N],[12,"type_dependent_defs","","Resolved definitions for `<T>::X` associated paths and method calls, including those of overloaded operators.",687,N],[12,"field_indices","","Resolved field indices for field accesses in expressions (`S { field }`, `obj.field`) or patterns (`S { field }`). The index is often useful by itself, but to learn more about the field you also need definition of the variant to which the field belongs, but it may not exist if it's a tuple field (`tuple.0`).",687,N],[12,"user_provided_tys","","Stores the canonicalized types provided by the user. See also `UserAssertTy` statement in MIR.",687,N],[12,"node_types","","Stores the types for various nodes in the AST.  Note that this table is not guaranteed to be populated until after typeck.  See typeck::check::fn_ctxt for details.",687,N],[12,"node_substs","","Stores the type parameters which were substituted to obtain the type of this node.  This only applies to nodes that refer to entities parameterized by type parameters, such as generic fns, types, or other items.",687,N],[12,"adjustments","","",687,N],[12,"pat_binding_modes","","Stores the actual binding mode for all instances of hir::BindingAnnotation.",687,N],[12,"pat_adjustments","","Stores the types which were implicitly dereferenced in pattern binding modes for later usage in HAIR lowering. For example,",687,N],[12,"upvar_capture_map","","Borrows",687,N],[12,"closure_kind_origins","","Records the reasons that we picked the kind of each closure; not all closures are present in the map.",687,N],[12,"liberated_fn_sigs","","For each fn, records the \"liberated\" types of its arguments and return type. Liberated means that all bound regions (including late-bound regions) are replaced with free equivalents. This table is not used in codegen (since regions are erased there) and hence is not serialized to metadata.",687,N],[12,"fru_field_types","","For each FRU expression, record the normalized types of the fields of the struct - this is needed because it is non-trivial to normalize while preserving regions. This table is used only in MIR construction and hence is not serialized to metadata.",687,N],[12,"cast_kinds","","Maps a cast expression to its kind. This is keyed on the from expression of the cast, not the cast itself.",687,N],[12,"used_trait_imports","","Set of trait imports actually used in the method resolution. This is used for warning unused imports. During type checking, this `Lrc` should not be cloned: it must have a ref-count of 1 so that we can insert things into the set mutably.",687,N],[12,"tainted_by_errors","","If any errors occurred while type-checking this body, this field will be set to `true`.",687,N],[12,"free_region_map","","Stores the free-region relationships that were deduced from its where clauses and parameter types. These are then read-again by borrowck.",687,N],[12,"concrete_existential_types","","All the existential types that are restricted to concrete types by this function",687,N],[3,"TyCtxt","","The central data structure of the compiler. It stores references to the various arenas and also houses the results of the various compiler queries that have been performed. See the [rustc guide] for more details.",N,N],[12,"gcx","","",684,N],[12,"interners","","",684,N],[3,"GlobalCtxt","","",N,N],[12,"global_arenas","","",1023,N],[12,"global_interners","","",1023,N],[12,"cstore","","",1023,N],[12,"sess","","",1023,N],[12,"dep_graph","","",1023,N],[12,"types","","Common types, pre-interned for your convenience.",1023,N],[12,"trait_map","","Map indicating what traits are in scope for places where this is relevant; generated by resolve.",1023,N],[12,"export_map","","Export map produced by name resolution.",1023,N],[12,"hir","","",1023,N],[12,"def_path_hash_to_def_id","","A map from DefPathHash -> DefId. Includes DefIds from the local crate as well as all upstream crates. Only populated in incremental mode.",1023,N],[12,"queries","","",1023,N],[12,"freevars","","",1023,N],[12,"maybe_unused_trait_imports","","",1023,N],[12,"maybe_unused_extern_crates","","",1023,N],[12,"rcache","","",1023,N],[12,"selection_cache","","Caches the results of trait selection. This cache is used for things that do not have to do with the parameters in scope.",1023,N],[12,"evaluation_cache","","Caches the results of trait evaluation. This cache is used for things that do not have to do with the parameters in scope. Merge this with `selection_cache`?",1023,N],[12,"crate_name","","The definite name of the current crate after taking into account attributes, commandline parameters, etc.",1023,N],[12,"data_layout","","Data layout specification for the current target.",1023,N],[12,"stability_interner","","",1023,N],[12,"allocation_interner","","Stores the value of constants (and deduplicates the actual memory)",1023,N],[12,"alloc_map","","",1023,N],[12,"layout_interner","","",1023,N],[12,"tx_to_llvm_workers","","A general purpose channel to throw data out the back towards LLVM worker threads.",1023,N],[12,"output_filenames","","",1023,N],[3,"Interned","","An entry in an interner.",N,N],[12,"0","","",1024,N],[5,"validate_hir_id_for_typeck_tables","","Validate that the given HirId (respectively its `local_id` part) can be safely used as a key in the tables of a TypeckTable. For that to be the case, the HirId must have the same `owner` as all the other IDs in this table (signified by `local_id_root`). Otherwise the HirId would be in a different frame of reference and using its `local_id` would result in lookup errors, or worse, in silently wrong data being stored/returned.",N,[[["option",["defid"]],["hirid"],["bool"]]]],[5,"keep_local","","",N,[[["t"]],["bool"]]],[5,"provide","","",N,[[["providers"]]]],[0,"tls","","",N,N],[3,"ImplicitCtxt","rustc::ty::context::tls","This is the implicit state of rustc. It contains the current TyCtxt and query. It is updated when creating a local interner or executing a new query. Whenever there's a TyCtxt value available you should also have access to an ImplicitCtxt through the functions in this module.",N,N],[12,"tcx","","The current TyCtxt. Initially created by `enter_global` and updated by `enter_local` with a new local interner",744,N],[12,"query","","The current query job, if any. This is updated by start_job in ty::query::plumbing when executing a query",744,N],[12,"layout_depth","","Used to prevent layout from recursing too deeply.",744,N],[12,"task","","The current dep graph task. This is used to add dependencies to queries when executing them",744,N],[5,"set_tlv","","Sets TLV to `value` during the call to `f`. It is restored to its previous value after. This is used to set the pointer to the new ImplicitCtxt.",N,[[["usize"],["f"]],["r"]]],[5,"get_tlv","","This is used to get the pointer to the current ImplicitCtxt.",N,[[],["usize"]]],[5,"span_debug","","This is a callback from libsyntax as it cannot access the implicit state in librustc otherwise",N,[[["span"],["formatter"]],["result"]]],[5,"track_diagnostic","","This is a callback from libsyntax as it cannot access the implicit state in librustc otherwise. It is used to when diagnostic messages are emitted and stores them in the current query, if there is one.",N,[[["diagnostic"]]]],[5,"with_thread_locals","","Sets up the callbacks from libsyntax on the current thread",N,[[["f"]],["r"]]],[5,"enter_context","","Sets `context` as the new current ImplicitCtxt for the duration of the function `f`",N,[[["implicitctxt"],["f"]],["r"]]],[5,"enter_global","","Enters GlobalCtxt by setting up libsyntax callbacks and creating a initial TyCtxt and ImplicitCtxt. This happens once per rustc session and TyCtxts only exists inside the `f` function.",N,[[["globalctxt"],["f"]],["r"]]],[5,"with_global","","Creates a TyCtxt and ImplicitCtxt based on the GCX_PTR thread local. This is used in the deadlock handler.",N,[[["f"]],["r"]]],[5,"with_context_opt","","Allows access to the current ImplicitCtxt in a closure if one is available",N,[[["f"]],["r"]]],[5,"with_context","","Allows access to the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[5,"with_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'gcx lifetime as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner from the current ImplicitCtxt's tcx field.",N,[[["tyctxt"],["f"]],["r"]]],[5,"with_fully_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner and local interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'tcx and 'gcx lifetimes as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner or a different local interner from the current ImplicitCtxt's tcx field.",N,[[["tyctxt"],["f"]],["r"]]],[5,"with","","Allows access to the TyCtxt in the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[5,"with_opt","","Allows access to the TyCtxt in the current ImplicitCtxt. The closure is passed None if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[7,"GCX_PTR","","",N,N],[17,"TLV","","",N,N],[11,"clone","rustc::ty::tls","",744,[[["self"]],["implicitctxt"]]],[6,"InternedSet","rustc::ty::context","",N,N],[8,"Lift","","A trait implemented for all X<'a> types which can be safely and efficiently converted to X<'tcx> as long as they are part of the provided TyCtxt<'tcx>. This can be done, for example, for Ty<'tcx> or &'tcx Substs<'tcx> by looking them up in their respective interners.",N,N],[16,"Lifted","","",1025,N],[10,"lift_to_tcx","","",1025,[[["self"],["tyctxt"]],["option"]]],[8,"InternAs","","",N,N],[16,"Output","","",1026,N],[10,"intern_with","","",1026,N],[8,"InternIteratorElement","","",N,N],[16,"Output","","",1027,N],[10,"intern_with","","",1027,N],[11,"new","rustc::ty","",686,[[],["self"]]],[11,"new","","",685,[[],["globalarenas"]]],[11,"new","rustc::ty::context","",1019,[[["syncdroplessarena"]],["ctxtinterners"]]],[11,"intern_ty","","Intern a type",1019,[[["ctxtinterners"],["ctxtinterners"],["typevariants"]],["ty"]]],[11,"contains_key","","",1021,[[["self"],["hirid"]],["bool"]]],[11,"get","","",1021,[[["self"],["hirid"]],["option"]]],[11,"iter","","",1021,[[["self"]],["iter",["itemlocalid"]]]],[11,"index","","",1021,[[["self"],["hirid"]],["v"]]],[11,"get_mut","","",1022,[[["self"],["hirid"]],["option"]]],[11,"entry","","",1022,[[["self"],["hirid"]],["entry",["itemlocalid"]]]],[11,"insert","","",1022,[[["self"],["hirid"],["v"]],["option"]]],[11,"remove","","",1022,[[["self"],["hirid"]],["option"]]],[11,"encode","rustc::ty","",687,[[["self"],["__s"]],["result"]]],[11,"decode","","",687,[[["__d"]],["result",["typecktables"]]]],[11,"fmt","","",687,[[["self"],["formatter"]],["result"]]],[11,"empty","","",687,[[["option",["defid"]]],["typecktables"]]],[11,"qpath_def","","Returns the final resolution of a `QPath` in an `Expr` or `Pat` node.",687,[[["self"],["qpath"],["hirid"]],["def"]]],[11,"type_dependent_defs","","",687,[[["self"]],["localtableincontext",["def"]]]],[11,"type_dependent_defs_mut","","",687,[[["self"]],["localtableincontextmut",["def"]]]],[11,"field_indices","","",687,[[["self"]],["localtableincontext",["usize"]]]],[11,"field_indices_mut","","",687,[[["self"]],["localtableincontextmut",["usize"]]]],[11,"user_provided_tys","","",687,[[["self"]],["localtableincontext",["canonicalty"]]]],[11,"user_provided_tys_mut","","",687,[[["self"]],["localtableincontextmut",["canonicalty"]]]],[11,"node_types","","",687,[[["self"]],["localtableincontext",["ty"]]]],[11,"node_types_mut","","",687,[[["self"]],["localtableincontextmut",["ty"]]]],[11,"node_id_to_type","","",687,[[["self"],["hirid"]],["ty"]]],[11,"node_id_to_type_opt","","",687,[[["self"],["hirid"]],["option",["ty"]]]],[11,"node_substs_mut","","",687,[[["self"]],["localtableincontextmut",["substs"]]]],[11,"node_substs","","",687,[[["self"],["hirid"]],["substs"]]],[11,"node_substs_opt","","",687,[[["self"],["hirid"]],["option",["substs"]]]],[11,"pat_ty","","",687,[[["self"],["pat"]],["ty"]]],[11,"pat_ty_opt","","",687,[[["self"],["pat"]],["option",["ty"]]]],[11,"expr_ty","","",687,[[["self"],["expr"]],["ty"]]],[11,"expr_ty_opt","","",687,[[["self"],["expr"]],["option",["ty"]]]],[11,"adjustments","","",687,[[["self"]],["localtableincontext",["vec"]]]],[11,"adjustments_mut","","",687,[[["self"]],["localtableincontextmut",["vec"]]]],[11,"expr_adjustments","","",687,N],[11,"expr_ty_adjusted","","Returns the type of `expr`, considering any `Adjustment` entry recorded for that expression.",687,[[["self"],["expr"]],["ty"]]],[11,"expr_ty_adjusted_opt","","",687,[[["self"],["expr"]],["option",["ty"]]]],[11,"is_method_call","","",687,[[["self"],["expr"]],["bool"]]],[11,"pat_binding_modes","","",687,[[["self"]],["localtableincontext",["bindingmode"]]]],[11,"pat_binding_modes_mut","","",687,[[["self"]],["localtableincontextmut",["bindingmode"]]]],[11,"pat_adjustments","","",687,[[["self"]],["localtableincontext",["vec"]]]],[11,"pat_adjustments_mut","","",687,[[["self"]],["localtableincontextmut",["vec"]]]],[11,"upvar_capture","","",687,[[["self"],["upvarid"]],["upvarcapture"]]],[11,"closure_kind_origins","","",687,[[["self"]],["localtableincontext"]]],[11,"closure_kind_origins_mut","","",687,[[["self"]],["localtableincontextmut"]]],[11,"liberated_fn_sigs","","",687,[[["self"]],["localtableincontext",["fnsig"]]]],[11,"liberated_fn_sigs_mut","","",687,[[["self"]],["localtableincontextmut",["fnsig"]]]],[11,"fru_field_types","","",687,[[["self"]],["localtableincontext",["vec"]]]],[11,"fru_field_types_mut","","",687,[[["self"]],["localtableincontextmut",["vec"]]]],[11,"cast_kinds","","",687,[[["self"]],["localtableincontext",["castkind"]]]],[11,"cast_kinds_mut","","",687,[[["self"]],["localtableincontextmut",["castkind"]]]],[11,"hash_stable","","",687,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","rustc::ty::context","",1020,[[["ctxtinterners"]],["commontypes"]]],[11,"clone","rustc::ty","",684,[[["self"]],["tyctxt"]]],[11,"deref","","",684,N],[11,"global_tcx","","Get the global TyCtxt.",684,[[["self"]],["tyctxt"]]],[11,"alloc_generics","","",684,[[["self"],["generics"]],["generics"]]],[11,"alloc_steal_mir","","",684,[[["self"],["mir"]],["steal"]]],[11,"alloc_mir","","",684,[[["self"],["mir"]],["mir"]]],[11,"alloc_tables","","",684,[[["self"],["typecktables"]],["typecktables"]]],[11,"alloc_trait_def","","",684,[[["self"],["traitdef"]],["traitdef"]]],[11,"alloc_adt_def","","",684,[[["self"],["defid"],["adtkind"],["vec",["variantdef"]],["reproptions"]],["adtdef"]]],[11,"alloc_byte_array","","",684,N],[11,"alloc_const_slice","","",684,N],[11,"alloc_name_const_slice","","",684,N],[11,"intern_const_alloc","","",684,[[["self"],["allocation"]],["allocation"]]],[11,"allocate_bytes","","Allocates a byte or string literal for `mir::interpret`",684,N],[11,"intern_stability","","",684,[[["self"],["stability"]],["stability"]]],[11,"intern_layout","","",684,[[["self"],["layoutdetails"]],["layoutdetails"]]],[11,"lift","","",684,[[["self"],["t"]],["option"]]],[11,"lift_to_global","","Like lift, but only tries in the global tcx.",684,[[["self"],["t"]],["option"]]],[11,"is_global","","Returns true if self is the same as self.global_tcx().",684,[[["self"]],["bool"]]],[11,"create_and_enter","","Create a type context and call the closure with a `TyCtxt` reference to the context. The closure enforces that the type context and any interned value (types, substs, etc.) can only be used while `ty::tls` has a valid reference to the context, to allow formatting values that need it.",684,[[["session"],["cratestoredyn"],["providers"],["providers"],["allarenas"],["resolutions"],["map"],["ondiskcache"],["str"],["sender",["box"]],["outputfilenames"],["f"]],["r"]]],[11,"consider_optimizing","","",684,[[["self"],["t"]],["bool"]]],[11,"lang_items","","",684,[[["self"]],["lrc",["languageitems"]]]],[11,"is_binop_lang_item","","Due to missing llvm support for lowering 128 bit math to software emulation (on some targets), the lowering can be done in MIR.",684,[[["self"],["defid"]],["option"]]],[11,"stability","","",684,[[["self"]],["lrc",["index"]]]],[11,"crates","","",684,[[["self"]],["lrc",["vec"]]]],[11,"features","","",684,[[["self"]],["lrc",["features"]]]],[11,"def_key","","",684,[[["self"],["defid"]],["defkey"]]],[11,"def_path","","Convert a `DefId` into its fully expanded `DefPath` (every `DefId` is really just an interned def-path).",684,[[["self"],["defid"]],["defpath"]]],[11,"def_path_hash","","",684,[[["self"],["defid"]],["defpathhash"]]],[11,"def_path_debug_str","","",684,[[["self"],["defid"]],["string"]]],[11,"metadata_encoding_version","","",684,[[["self"]],["vec",["u8"]]]],[11,"crate_data_as_rc_any","","",684,[[["self"],["cratenum"]],["lrc",["any"]]]],[11,"create_stable_hashing_context","","",684,[[["self"]],["stablehashingcontext"]]],[11,"allocate_metadata_dep_nodes","","",684,[[["self"]]]],[11,"precompute_in_scope_traits_hashes","","",684,[[["self"]]]],[11,"serialize_query_result_cache","","",684,[[["self"],["e"]],["result"]]],[11,"check_for_mutation_in_guard_via_ast_walk","","If true, we should use a naive AST walk to determine if match guard could perform bad mutations (or mutable-borrows).",684,[[["self"]],["bool"]]],[11,"use_ast_borrowck","","If true, we should use the AST-based borrowck (we may also use the MIR-based borrowck).",684,[[["self"]],["bool"]]],[11,"use_mir_borrowck","","If true, we should use the MIR-based borrowck (we may also use the AST-based borrowck).",684,[[["self"]],["bool"]]],[11,"migrate_borrowck","","If true, we should use the MIR-based borrow check, but also fall back on the AST borrow check if the MIR-based one errors.",684,[[["self"]],["bool"]]],[11,"generate_borrow_of_any_match_input","","If true, make MIR codegen for `match` emit a temp that holds a borrow of the input to the match expression.",684,[[["self"]],["bool"]]],[11,"emit_read_for_match","","If true, make MIR codegen for `match` emit ReadForMatch statements (which simulate the maximal effect of executing the patterns in a match arm).",684,[[["self"]],["bool"]]],[11,"all_pat_vars_are_implicit_refs_within_guards","","If true, pattern variables for use in guards on match arms will be bound as references to the data, and occurrences of those variables in the guard expression will implicitly dereference those bindings. (See rust-lang/rust#27282.)",684,[[["self"]],["bool"]]],[11,"two_phase_borrows","","If true, we should enable two-phase borrows checks. This is done with either `-Ztwo-phase-borrows` or with `#![feature(nll)]`.",684,[[["self"]],["bool"]]],[11,"borrowck_mode","","What mode(s) of borrowck should we run? AST? MIR? both? (Also considers the `#![feature(nll)]` setting.)",684,[[["self"]],["borrowckmode"]]],[11,"emit_end_regions","","Should we emit EndRegion MIR statements? These are consumed by MIR borrowck, but not when NLL is used. They are also consumed by the validation stuff.",684,[[["self"]],["bool"]]],[11,"share_generics","","",684,[[["self"]],["bool"]]],[11,"local_crate_exports_generics","","",684,[[["self"]],["bool"]]],[11,"encode_metadata","","",684,[[["self"],["linkmeta"]],["encodedmetadata"]]],[11,"enter_local","rustc::ty::context","Call the closure with a local `TyCtxt` using the given arena.",1023,[[["self"],["syncdroplessarena"],["f"]],["r"]]],[11,"print_debug_stats","rustc::ty","",684,[[["self"]]]],[11,"eq","rustc::ty::context","",1024,[[["self"],["interned"]],["bool"]]],[11,"hash","","",1024,[[["self"],["h"]]]],[11,"borrow","","",1024,[[["self"]],["typevariants"]]],[11,"eq","","",1024,[[["self"],["interned"]],["bool"]]],[11,"hash","","",1024,[[["self"],["h"]]]],[11,"borrow","","",1024,N],[11,"borrow","","",1024,N],[11,"borrow","","",1024,N],[11,"borrow","","",1024,[[["self"]],["regionkind"]]],[11,"borrow","","",1024,N],[11,"borrow","","",1024,N],[11,"borrow","","",1024,[[["self"]],["const"]]],[11,"borrow","","",1024,N],[11,"borrow","","",1024,N],[11,"eq","","",1024,[[["self"],["self"]],["bool"]]],[11,"hash","","",1024,[[["self"],["h"]]]],[11,"mk_region","rustc::ty","",684,[[["self"],["regionkind"]],["regionkind"]]],[11,"eq","rustc::ty::context","",1024,[[["self"],["self"]],["bool"]]],[11,"hash","","",1024,[[["self"],["h"]]]],[11,"mk_const","rustc::ty","",684,[[["self"],["const"]],["const"]]],[11,"_intern_existential_predicates","","",684,N],[11,"_intern_predicates","","",684,N],[11,"_intern_type_list","","",684,N],[11,"_intern_substs","","",684,N],[11,"_intern_clauses","","",684,N],[11,"_intern_goals","","",684,N],[11,"_intern_canonical_var_infos","","",684,N],[11,"safe_to_unsafe_fn_ty","","Given a `fn` type, returns an equivalent `unsafe fn` type; that is, a `fn` type that is equivalent in every way for being unsafe.",684,[[["self"],["polyfnsig"]],["ty"]]],[11,"coerce_closure_fn_ty","","Given a closure signature `sig`, returns an equivalent `fn` type with the same signature. Detuples and so forth -- so e.g. if we have a sig with `Fn<(u32, i32)>` then you would get a `fn(u32, i32)`.",684,[[["self"],["polyfnsig"]],["ty"]]],[11,"mk_ty","","",684,[[["self"],["typevariants"]],["ty"]]],[11,"mk_mach_int","","",684,[[["self"],["intty"]],["ty"]]],[11,"mk_mach_uint","","",684,[[["self"],["uintty"]],["ty"]]],[11,"mk_mach_float","","",684,[[["self"],["floatty"]],["ty"]]],[11,"mk_str","","",684,[[["self"]],["ty"]]],[11,"mk_static_str","","",684,[[["self"]],["ty"]]],[11,"mk_adt","","",684,[[["self"],["adtdef"],["substs"]],["ty"]]],[11,"mk_foreign","","",684,[[["self"],["defid"]],["ty"]]],[11,"mk_box","","",684,[[["self"],["ty"]],["ty"]]],[11,"mk_ptr","","",684,[[["self"],["typeandmut"]],["ty"]]],[11,"mk_ref","","",684,[[["self"],["region"],["typeandmut"]],["ty"]]],[11,"mk_mut_ref","","",684,[[["self"],["region"],["ty"]],["ty"]]],[11,"mk_imm_ref","","",684,[[["self"],["region"],["ty"]],["ty"]]],[11,"mk_mut_ptr","","",684,[[["self"],["ty"]],["ty"]]],[11,"mk_imm_ptr","","",684,[[["self"],["ty"]],["ty"]]],[11,"mk_nil_ptr","","",684,[[["self"]],["ty"]]],[11,"mk_array","","",684,[[["self"],["ty"],["u64"]],["ty"]]],[11,"mk_slice","","",684,[[["self"],["ty"]],["ty"]]],[11,"intern_tup","","",684,N],[11,"mk_tup","","",684,N],[11,"mk_nil","","",684,[[["self"]],["ty"]]],[11,"mk_diverging_default","","",684,[[["self"]],["ty"]]],[11,"mk_bool","","",684,[[["self"]],["ty"]]],[11,"mk_fn_def","","",684,[[["self"],["defid"],["substs"]],["ty"]]],[11,"mk_fn_ptr","","",684,[[["self"],["polyfnsig"]],["ty"]]],[11,"mk_dynamic","","",684,[[["self"],["binder",["slice"]],["region"]],["ty"]]],[11,"mk_projection","","",684,[[["self"],["defid"],["substs"]],["ty"]]],[11,"mk_closure","","",684,[[["self"],["defid"],["closuresubsts"]],["ty"]]],[11,"mk_generator","","",684,[[["self"],["defid"],["generatorsubsts"],["generatormovability"]],["ty"]]],[11,"mk_generator_witness","","",684,[[["self"],["binder",["slice"]]],["ty"]]],[11,"mk_var","","",684,[[["self"],["tyvid"]],["ty"]]],[11,"mk_int_var","","",684,[[["self"],["intvid"]],["ty"]]],[11,"mk_float_var","","",684,[[["self"],["floatvid"]],["ty"]]],[11,"mk_infer","","",684,[[["self"],["inferty"]],["ty"]]],[11,"mk_ty_param","","",684,[[["self"],["u32"],["internedstring"]],["ty"]]],[11,"mk_self_type","","",684,[[["self"]],["ty"]]],[11,"mk_param_from_def","","",684,[[["self"],["genericparamdef"]],["kind"]]],[11,"mk_anon","","",684,[[["self"],["defid"],["substs"]],["ty"]]],[11,"intern_existential_predicates","","",684,N],[11,"intern_predicates","","",684,N],[11,"intern_type_list","","",684,N],[11,"intern_substs","","",684,N],[11,"intern_canonical_var_infos","","",684,N],[11,"intern_clauses","","",684,N],[11,"intern_goals","","",684,N],[11,"mk_fn_sig","","",684,N],[11,"mk_existential_predicates","","",684,N],[11,"mk_predicates","","",684,N],[11,"mk_type_list","","",684,N],[11,"mk_substs","","",684,N],[11,"mk_substs_trait","","",684,N],[11,"mk_clauses","","",684,N],[11,"mk_goals","","",684,N],[11,"mk_goal","","",684,[[["self"],["goal"]],["goal"]]],[11,"lint_hir","","",684,[[["self"],["lint"],["hirid"],["s"],["str"]]]],[11,"lint_node","","",684,[[["self"],["lint"],["nodeid"],["s"],["str"]]]],[11,"lint_hir_note","","",684,[[["self"],["lint"],["hirid"],["s"],["str"],["str"]]]],[11,"lint_node_note","","",684,[[["self"],["lint"],["nodeid"],["s"],["str"],["str"]]]],[11,"lint_level_at_node","","",684,N],[11,"struct_span_lint_hir","","",684,[[["self"],["lint"],["hirid"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_lint_node","","",684,[[["self"],["lint"],["nodeid"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_lint_node","","",684,[[["self"],["lint"],["nodeid"],["str"]],["diagnosticbuilder"]]],[11,"in_scope_traits","","",684,[[["self"],["hirid"]],["option",["lrc"]]]],[11,"named_region","","",684,[[["self"],["hirid"]],["option",["region"]]]],[11,"is_late_bound","","",684,[[["self"],["hirid"]],["bool"]]],[11,"object_lifetime_defaults","","",684,[[["self"],["hirid"]],["option",["lrc"]]]],[0,"flags","","",N,N],[3,"FlagComputation","rustc::ty::flags","",N,N],[12,"flags","","",1028,N],[12,"outer_exclusive_binder","","",1028,N],[11,"fmt","","",1028,[[["self"],["formatter"]],["result"]]],[11,"new","","",1028,[[],["flagcomputation"]]],[11,"for_sty","","",1028,[[["typevariants"]],["flagcomputation"]]],[11,"add_flags","","",1028,[[["self"],["typeflags"]]]],[11,"add_binder","","indicates that `self` refers to something at binding level `binder`",1028,[[["self"],["debruijnindex"]]]],[11,"add_exclusive_binder","","indicates that `self` refers to something inside binding level `binder` -- not bound by `binder`, but bound by the next binder internal to it",1028,[[["self"],["debruijnindex"]]]],[11,"add_bound_computation","","Adds the flags/depth from a set of types that appear within the current type, but within a region binder.",1028,[[["self"],["flagcomputation"]]]],[11,"add_sty","","",1028,[[["self"],["typevariants"]]]],[11,"add_ty","","",1028,[[["self"],["ty"]]]],[11,"add_tys","","",1028,N],[11,"add_fn_sig","","",1028,[[["self"],["polyfnsig"]]]],[11,"add_region","","",1028,[[["self"],["region"]]]],[11,"add_const","","",1028,[[["self"],["const"]]]],[11,"add_existential_projection","","",1028,[[["self"],["existentialprojection"]]]],[11,"add_projection_ty","","",1028,[[["self"],["projectionty"]]]],[11,"add_substs","","",1028,[[["self"],["substs"]]]],[0,"instance","rustc::ty","",N,N],[3,"Instance","rustc::ty::instance","",N,N],[12,"def","","",688,N],[12,"substs","","",688,N],[4,"InstanceDef","","",N,N],[13,"Item","","",730,N],[13,"Intrinsic","","",730,N],[13,"FnPtrShim","","<fn() as FnTrait>::call_* def-id is FnTrait::call_*",730,N],[13,"Virtual","","::fn",730,N],[13,"ClosureOnceShim","","<[mut closure] as FnOnce>::call_once",730,N],[12,"call_once","rustc::ty::instance::InstanceDef","",730,N],[13,"DropGlue","rustc::ty::instance","drop_in_place::; None for empty drop glue.",730,N],[13,"CloneShim","","`<T as Clone>::clone` shim.",730,N],[5,"resolve_associated_item","","",N,[[["tyctxt"],["associateditem"],["paramenv"],["defid"],["substs"]],["option",["instance"]]]],[5,"needs_fn_once_adapter_shim","","",N,[[["closurekind"],["closurekind"]],["result",["bool"]]]],[5,"fn_once_adapter_instance","","",N,[[["tyctxt"],["defid"],["closuresubsts"]],["instance"]]],[11,"clone","rustc::ty","",688,[[["self"]],["instance"]]],[11,"eq","","",688,[[["self"],["instance"]],["bool"]]],[11,"ne","","",688,[[["self"],["instance"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",688,N],[11,"hash","","",688,N],[11,"fmt","","",688,[[["self"],["formatter"]],["result"]]],[11,"encode","","",688,[[["self"],["__s"]],["result"]]],[11,"decode","","",688,[[["__d"]],["result",["instance"]]]],[11,"clone","","",730,[[["self"]],["instancedef"]]],[11,"eq","","",730,[[["self"],["instancedef"]],["bool"]]],[11,"ne","","",730,[[["self"],["instancedef"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",730,N],[11,"hash","","",730,N],[11,"fmt","","",730,[[["self"],["formatter"]],["result"]]],[11,"encode","","",730,[[["self"],["__s"]],["result"]]],[11,"decode","","",730,[[["__d"]],["result",["instancedef"]]]],[11,"ty","","",688,[[["self"],["tyctxt"]],["ty"]]],[11,"def_id","","",730,[[["self"]],["defid"]]],[11,"attrs","","",730,[[["self"],["tyctxt"]],["attributes"]]],[11,"is_inline","","",730,[[["self"],["tyctxt"]],["bool"]]],[11,"requires_local","","",730,[[["self"],["tyctxt"]],["bool"]]],[11,"fmt","","",688,[[["self"],["formatter"]],["result"]]],[11,"new","","",688,[[["defid"],["substs"]],["instance"]]],[11,"mono","","",688,[[["tyctxt"],["defid"]],["instance"]]],[11,"def_id","","",688,[[["self"]],["defid"]]],[11,"resolve","","Resolve a (def_id, substs) pair to an (optional) instance -- most commonly, this is used to find the precise code that will run for a trait method invocation, if known.",688,[[["tyctxt"],["paramenv"],["defid"],["substs"]],["option",["instance"]]]],[11,"resolve_closure","","",688,[[["tyctxt"],["defid"],["closuresubsts"],["closurekind"]],["instance"]]],[0,"structural_impls","","This module contains implements of the `Lift` and `TypeFoldable` traits for various types in the Rust compiler. Most are written by hand, though we've recently added some macros (e.g., `BraceStructLiftImpl!`) to help with the tedium.",N,N],[11,"super_fold_with","rustc::middle::region","",401,[[["self"],["f"]],["scope"]]],[11,"super_visit_with","","",401,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::ty::layout","",794,[[["self"],["f"]],["floatty"]]],[11,"super_visit_with","","",794,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::hir::def","",143,[[["self"],["f"]],["def"]]],[11,"super_visit_with","","",143,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::hir::def_id","",147,[[["self"],["f"]],["defid"]]],[11,"super_visit_with","","",147,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::hir","",71,[[["self"],["f"]],["inlineasm"]]],[11,"super_visit_with","","",71,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",114,[[["self"],["f"]],["matchsource"]]],[11,"super_visit_with","","",114,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",103,[[["self"],["f"]],["mutability"]]],[11,"super_visit_with","","",103,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",126,[[["self"],["f"]],["unsafety"]]],[11,"super_visit_with","","",126,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::mir","",433,[[["self"],["f"]],["local"]]],[11,"super_visit_with","","",433,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",449,[[["self"],["f"]],["promoted"]]],[11,"super_visit_with","","",449,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::traits","",586,[[["self"],["f"]],["reveal"]]],[11,"super_visit_with","","",586,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::ty::adjustment","",750,[[["self"],["f"]],["autoborrowmutability"]]],[11,"super_visit_with","","",750,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::ty","",741,[[["self"],["f"]],["adtkind"]]],[11,"super_visit_with","","",741,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",728,[[["self"],["f"]],["boundregion"]]],[11,"super_visit_with","","",728,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",742,[[["self"],["f"]],["closurekind"]]],[11,"super_visit_with","","",742,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",737,[[["self"],["f"]],["intvarvalue"]]],[11,"super_visit_with","","",737,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",669,[[["self"],["f"]],["paramty"]]],[11,"super_visit_with","","",669,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","rustc::middle::region","",401,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::layout","",794,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::hir::def","",143,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::hir::def_id","",147,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::hir","",71,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",114,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",103,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",126,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::mir","",433,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",449,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::traits","",586,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::adjustment","",750,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty","",741,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",728,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",742,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",737,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",669,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",674,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",675,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",707,[[["self"],["tyctxt"]],["option",["traitpredicate"]]]],[11,"lift_to_tcx","","",709,[[["self"],["tyctxt"]],["option",["subtypepredicate"]]]],[11,"lift_to_tcx","","",708,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",670,[[["self"],["tyctxt"]],["option",["projectionty"]]]],[11,"lift_to_tcx","","",710,[[["self"],["tyctxt"]],["option",["projectionpredicate"]]]],[11,"lift_to_tcx","","",676,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",739,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",664,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",713,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",714,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",671,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",672,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::adjustment","",745,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",748,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",746,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",751,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty","",668,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",667,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::error","",760,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",761,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::mir::interpret","",479,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",478,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",491,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::layout","",806,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty","",730,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",688,[[["self"],["tyctxt"]],["option",["instance"]]]],[11,"lift_to_tcx","rustc::mir::interpret","",482,[[["self"],["tyctxt"]],["option",["globalid"]]]],[11,"super_fold_with","rustc::ty","",664,[[["self"],["f"]],["self"]]],[11,"fold_with","","",664,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",664,[[["self"],["v"]],["bool"]]],[11,"visit_with","","",664,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",713,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",713,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",725,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",725,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",688,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",688,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::mir::interpret","",482,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",482,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty","",673,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",673,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",668,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",668,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",667,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",667,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",674,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",674,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",675,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",675,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",691,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",691,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",671,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",671,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",672,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",672,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty::adjustment","",745,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",745,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",748,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",748,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",746,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",746,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",751,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",751,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty","",705,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",705,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",739,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",739,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",710,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",710,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",676,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",676,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",670,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",670,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",711,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",711,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",714,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",714,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",709,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",709,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",707,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",707,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",708,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",708,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",700,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",700,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty::error","",760,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",760,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",761,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",761,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::mir::interpret","",494,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",494,[[["self"],["v"]],["bool"]]],[0,"sty","rustc::ty","This module contains TypeVariants and its major components",N,N],[3,"TypeAndMut","rustc::ty::sty","",N,N],[12,"ty","","",673,N],[12,"mutbl","","",673,N],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region at least as big as the scope `fr.scope`\".",N,N],[12,"scope","","",679,N],[12,"bound_region","","",679,N],[3,"ClosureSubsts","","A closure can be modeled as a struct that looks like:",N,N],[12,"substs","","Lifetime and type parameters from the enclosing function, concatenated with the types of the upvars.",671,N],[3,"SplitClosureSubsts","","Struct returned by `split()`. Note that these are subslices of the parent slice and not canonical substs themselves.",N,N],[12,"closure_kind_ty","","",1029,N],[12,"closure_sig_ty","","",1029,N],[12,"upvar_kinds","","",1029,N],[3,"GeneratorSubsts","","",N,N],[12,"substs","","",672,N],[3,"SplitGeneratorSubsts","","",N,N],[12,"yield_ty","","",1030,N],[12,"return_ty","","",1030,N],[12,"witness","","",1030,N],[12,"upvar_kinds","","",1030,N],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax, but perhaps the most recognizable form is in a where clause:",N,N],[12,"def_id","","",674,N],[12,"substs","","",674,N],[3,"ExistentialTraitRef","","An existential reference to a trait, where `Self` is erased. For example, the trait object `Trait<'a, 'b, X, Y>` is:",N,N],[12,"def_id","","",675,N],[12,"substs","","",675,N],[3,"Binder","","Binder is a binder for higher-ranked lifetimes. It is part of the compiler's representation for things like `for<'a> Fn(&'a isize)` (which would be represented by the type `PolyTraitRef == Binder<TraitRef>`). Note that when we skolemize, instantiate, erase, or otherwise \"discharge\" these bound regions, we change the type from `Binder<T>` to just `T` (see e.g. `liberate_late_bound_regions`).",N,N],[12,"0","","",664,N],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS form this would be written `<T as Trait<..>>::N`.",N,N],[12,"substs","","The parameters of the associated item.",670,N],[12,"item_def_id","","The DefId of the TraitItem for the associated type N.",670,N],[3,"GenSig","","",N,N],[12,"yield_ty","","",668,N],[12,"return_ty","","",668,N],[3,"FnSig","","Signature of a function type, which I have arbitrarily decided to use to refer to the input/output types.",N,N],[12,"inputs_and_output","","",667,N],[12,"variadic","","",667,N],[12,"unsafety","","",667,N],[12,"abi","","",667,N],[3,"ParamTy","","",N,N],[12,"idx","","",669,N],[12,"name","","",669,N],[3,"DebruijnIndex","","",N,N],[12,"0","","",666,N],[3,"EarlyBoundRegion","","",N,N],[12,"def_id","","",678,N],[12,"index","","",678,N],[12,"name","","",678,N],[3,"TyVid","","",N,N],[12,"index","","",680,N],[3,"IntVid","","",N,N],[12,"index","","",681,N],[3,"FloatVid","","",N,N],[12,"index","","",682,N],[3,"RegionVid","","",N,N],[12,"0","","",683,N],[3,"CanonicalVar","","",N,N],[12,"0","","",665,N],[3,"ExistentialProjection","","A `ProjectionPredicate` for an `ExistentialTraitRef`.",N,N],[12,"item_def_id","","",676,N],[12,"substs","","",676,N],[12,"ty","","",676,N],[3,"Const","","Typed constant value.",N,N],[12,"ty","","",677,N],[12,"val","","",677,N],[4,"BoundRegion","","",N,N],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",728,N],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",728,N],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",728,N],[13,"BrEnv","","Anonymous region for the implicit env pointer parameter to a closure",728,N],[4,"TypeVariants","","NB: If you change this, you'll probably want to change the corresponding AST structure in libsyntax/ast.rs as well.",N,N],[13,"TyBool","","The primitive boolean type. Written as `bool`.",727,N],[13,"TyChar","","The primitive character type; holds a Unicode scalar value (a non-surrogate code point).  Written as `char`.",727,N],[13,"TyInt","","A primitive signed integer type. For example, `i32`.",727,N],[13,"TyUint","","A primitive unsigned integer type. For example, `u32`.",727,N],[13,"TyFloat","","A primitive floating-point type. For example, `f64`.",727,N],[13,"TyAdt","","Structures, enumerations and unions.",727,N],[13,"TyForeign","","",727,N],[13,"TyStr","","The pointee of a string slice. Written as `str`.",727,N],[13,"TyArray","","An array with the given length. Written as `[T; n]`.",727,N],[13,"TySlice","","The pointee of an array slice.  Written as `[T]`.",727,N],[13,"TyRawPtr","","A raw pointer. Written as `*mut T` or `*const T`",727,N],[13,"TyRef","","A reference; a pointer with an associated lifetime. Written as `&'a mut T` or `&'a T`.",727,N],[13,"TyFnDef","","The anonymous type of a function declaration/definition. Each function has a unique type.",727,N],[13,"TyFnPtr","","A pointer to a function.  Written as `fn() -> i32`.",727,N],[13,"TyDynamic","","A trait, defined with `trait`.",727,N],[13,"TyClosure","","The anonymous type of a closure. Used to represent the type of `|a| a`.",727,N],[13,"TyGenerator","","The anonymous type of a generator. Used to represent the type of `|a| yield a`.",727,N],[13,"TyGeneratorWitness","","A type representin the types stored inside a generator. This should only appear in GeneratorInteriors.",727,N],[13,"TyNever","","The never type `!`",727,N],[13,"TyTuple","","A tuple type.  For example, `(i32, bool)`.",727,N],[13,"TyProjection","","The projection of an associated type.  For example, `<T as Trait<..>>::N`.",727,N],[13,"TyAnon","","Anonymized (`impl Trait`) type found in a return type. The DefId comes either from * the `impl Trait` ast::Ty node, * or the `existential type` declaration The substitutions are for the generics of the function in question. After typeck, the concrete type can be found in the `types` map.",727,N],[13,"TyParam","","A type parameter; for example, `T` in `fn f(x: T) {}",727,N],[13,"TyInfer","","A type variable used during type-checking.",727,N],[13,"TyError","","A placeholder for a type which could not be computed; this is propagated to avoid useless error messages.",727,N],[4,"UpvarSubsts","","",N,N],[13,"Closure","","",726,N],[13,"Generator","","",726,N],[4,"ExistentialPredicate","","",N,N],[13,"Trait","","e.g. Iterator",725,N],[13,"Projection","","e.g. Iterator::Item = T",725,N],[13,"AutoTrait","","e.g. Send",725,N],[4,"RegionKind","","Representation of regions.",N,N],[13,"ReEarlyBound","","",729,N],[13,"ReLateBound","","",729,N],[13,"ReFree","","When checking a function body, the types of all arguments and so forth that refer to bound region parameters are modified to refer to free region parameters.",729,N],[13,"ReScope","","A concrete region naming some statically determined scope (e.g. an expression or sequence of statements) within the current function.",729,N],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",729,N],[13,"ReVar","","A region variable.  Should not exist after typeck.",729,N],[13,"ReSkolemized","","A skolemized region - basically the higher-ranked version of ReFree. Should not exist after typeck.",729,N],[13,"ReEmpty","","Empty lifetime is for data that is never accessed. Bottom in the region lattice. We treat ReEmpty somewhat specially; at least right now, we do not generate instances of it during the GLB computations, but rather generate an error instead. This is to improve error messages. The only way to get an instance of ReEmpty is to have a region variable with no constraints.",729,N],[13,"ReErased","","Erased region, used by trait selection, in MIR and during codegen.",729,N],[13,"ReClosureBound","","These are regions bound in the \"defining type\" for a closure. They are used ONLY as part of the `ClosureRegionRequirements` that are produced by MIR borrowck. See `ClosureRegionRequirements` for more details.",729,N],[13,"ReCanonical","","Canonicalized region, used only when preparing a trait query.",729,N],[4,"InferTy","","",N,N],[13,"TyVar","","",724,N],[13,"IntVar","","",724,N],[13,"FloatVar","","",724,N],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an unbound type variable. This is convenient for caching etc. See `infer::freshen` for more details.",724,N],[13,"FreshIntTy","","",724,N],[13,"FreshFloatTy","","",724,N],[13,"CanonicalTy","","Canonicalized type variable, used only when preparing a trait query.",724,N],[6,"PolyTraitRef","","",N,N],[6,"PolyExistentialTraitRef","","",N,N],[6,"PolyGenSig","","",N,N],[6,"PolyFnSig","","",N,N],[6,"Region","","",N,N],[6,"PolyExistentialProjection","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"INNERMOST","","",N,N],[11,"clone","rustc::ty","",673,[[["self"]],["typeandmut"]]],[11,"eq","","",673,[[["self"],["typeandmut"]],["bool"]]],[11,"ne","","",673,[[["self"],["typeandmut"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",673,N],[11,"partial_cmp","","",673,[[["self"],["typeandmut"]],["option",["ordering"]]]],[11,"lt","","",673,[[["self"],["typeandmut"]],["bool"]]],[11,"le","","",673,[[["self"],["typeandmut"]],["bool"]]],[11,"gt","","",673,[[["self"],["typeandmut"]],["bool"]]],[11,"ge","","",673,[[["self"],["typeandmut"]],["bool"]]],[11,"cmp","","",673,[[["self"],["typeandmut"]],["ordering"]]],[11,"hash","","",673,N],[11,"fmt","","",673,[[["self"],["formatter"]],["result"]]],[11,"encode","","",673,[[["self"],["__s"]],["result"]]],[11,"decode","","",673,[[["__d"]],["result",["typeandmut"]]]],[11,"clone","","",679,[[["self"]],["freeregion"]]],[11,"eq","","",679,[[["self"],["freeregion"]],["bool"]]],[11,"ne","","",679,[[["self"],["freeregion"]],["bool"]]],[11,"partial_cmp","","",679,[[["self"],["freeregion"]],["option",["ordering"]]]],[11,"lt","","",679,[[["self"],["freeregion"]],["bool"]]],[11,"le","","",679,[[["self"],["freeregion"]],["bool"]]],[11,"gt","","",679,[[["self"],["freeregion"]],["bool"]]],[11,"ge","","",679,[[["self"],["freeregion"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",679,N],[11,"cmp","","",679,[[["self"],["freeregion"]],["ordering"]]],[11,"hash","","",679,N],[11,"encode","","",679,[[["self"],["__s"]],["result"]]],[11,"decode","","",679,[[["__d"]],["result",["freeregion"]]]],[11,"clone","","",728,[[["self"]],["boundregion"]]],[11,"eq","","",728,[[["self"],["boundregion"]],["bool"]]],[11,"ne","","",728,[[["self"],["boundregion"]],["bool"]]],[11,"partial_cmp","","",728,[[["self"],["boundregion"]],["option",["ordering"]]]],[11,"lt","","",728,[[["self"],["boundregion"]],["bool"]]],[11,"le","","",728,[[["self"],["boundregion"]],["bool"]]],[11,"gt","","",728,[[["self"],["boundregion"]],["bool"]]],[11,"ge","","",728,[[["self"],["boundregion"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",728,N],[11,"cmp","","",728,[[["self"],["boundregion"]],["ordering"]]],[11,"hash","","",728,N],[11,"encode","","",728,[[["self"],["__s"]],["result"]]],[11,"decode","","",728,[[["__d"]],["result",["boundregion"]]]],[11,"is_named","","",728,[[["self"]],["bool"]]],[11,"clone","","",727,[[["self"]],["typevariants"]]],[11,"eq","","",727,[[["self"],["typevariants"]],["bool"]]],[11,"ne","","",727,[[["self"],["typevariants"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",727,N],[11,"partial_cmp","","",727,[[["self"],["typevariants"]],["option",["ordering"]]]],[11,"lt","","",727,[[["self"],["typevariants"]],["bool"]]],[11,"le","","",727,[[["self"],["typevariants"]],["bool"]]],[11,"gt","","",727,[[["self"],["typevariants"]],["bool"]]],[11,"ge","","",727,[[["self"],["typevariants"]],["bool"]]],[11,"cmp","","",727,[[["self"],["typevariants"]],["ordering"]]],[11,"hash","","",727,N],[11,"fmt","","",727,[[["self"],["formatter"]],["result"]]],[11,"encode","","",727,[[["self"],["__s"]],["result"]]],[11,"decode","","",727,[[["__d"]],["result",["typevariants"]]]],[11,"clone","","",671,[[["self"]],["closuresubsts"]]],[11,"eq","","",671,[[["self"],["closuresubsts"]],["bool"]]],[11,"ne","","",671,[[["self"],["closuresubsts"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",671,N],[11,"partial_cmp","","",671,[[["self"],["closuresubsts"]],["option",["ordering"]]]],[11,"lt","","",671,[[["self"],["closuresubsts"]],["bool"]]],[11,"le","","",671,[[["self"],["closuresubsts"]],["bool"]]],[11,"gt","","",671,[[["self"],["closuresubsts"]],["bool"]]],[11,"ge","","",671,[[["self"],["closuresubsts"]],["bool"]]],[11,"cmp","","",671,[[["self"],["closuresubsts"]],["ordering"]]],[11,"hash","","",671,N],[11,"fmt","","",671,[[["self"],["formatter"]],["result"]]],[11,"encode","","",671,[[["self"],["__s"]],["result"]]],[11,"decode","","",671,[[["__d"]],["result",["closuresubsts"]]]],[11,"split","","Divides the closure substs into their respective components. Single source of truth with respect to the ordering.",671,[[["self"],["defid"],["tyctxt"]],["splitclosuresubsts"]]],[11,"upvar_tys","","",671,[[["self"],["defid"],["tyctxt"]],[""]]],[11,"closure_kind_ty","","Returns the closure kind for this closure; may return a type variable during inference. To get the closure kind during inference, use `infcx.closure_kind(def_id, substs)`.",671,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"closure_sig_ty","","Returns the type representing the closure signature for this closure; may contain type variables during inference. To get the closure signature during inference, use `infcx.fn_sig(def_id)`.",671,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"closure_kind","","Returns the closure kind for this closure; only usable outside of an inference context, because in that context we know that there are no type variables.",671,[[["self"],["defid"],["tyctxt"]],["closurekind"]]],[11,"closure_sig","","Extracts the signature from the closure; only usable outside of an inference context, because in that context we know that there are no type variables.",671,[[["self"],["defid"],["tyctxt"]],["polyfnsig"]]],[11,"clone","","",672,[[["self"]],["generatorsubsts"]]],[11,"eq","","",672,[[["self"],["generatorsubsts"]],["bool"]]],[11,"ne","","",672,[[["self"],["generatorsubsts"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",672,N],[11,"partial_cmp","","",672,[[["self"],["generatorsubsts"]],["option",["ordering"]]]],[11,"lt","","",672,[[["self"],["generatorsubsts"]],["bool"]]],[11,"le","","",672,[[["self"],["generatorsubsts"]],["bool"]]],[11,"gt","","",672,[[["self"],["generatorsubsts"]],["bool"]]],[11,"ge","","",672,[[["self"],["generatorsubsts"]],["bool"]]],[11,"cmp","","",672,[[["self"],["generatorsubsts"]],["ordering"]]],[11,"hash","","",672,N],[11,"fmt","","",672,[[["self"],["formatter"]],["result"]]],[11,"encode","","",672,[[["self"],["__s"]],["result"]]],[11,"decode","","",672,[[["__d"]],["result",["generatorsubsts"]]]],[11,"split","","",672,[[["self"],["defid"],["tyctxt"]],["splitgeneratorsubsts"]]],[11,"witness","","This describes the types that can be contained in a generator. It will be a type variable initially and unified in the last stages of typeck of a body. It contains a tuple of all the types that could end up on a generator frame. The state transformation MIR pass may only produce layouts which mention types in this tuple. Upvars are not counted here.",672,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"upvar_tys","","",672,[[["self"],["defid"],["tyctxt"]],[""]]],[11,"yield_ty","","Returns the type representing the yield type of the generator.",672,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"return_ty","","Returns the type representing the return type of the generator.",672,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"poly_sig","","Return the \"generator signature\", which consists of its yield and return types.",672,[[["self"],["defid"],["tyctxt"]],["polygensig"]]],[11,"sig","","Return the \"generator signature\", which consists of its yield and return types.",672,[[["self"],["defid"],["tyctxt"]],["gensig"]]],[11,"state_tys","","This returns the types of the MIR locals which had to be stored across suspension points. It is calculated in rustc_mir::transform::generator::StateTransform. All the types here must be in the tuple in GeneratorInterior.",672,[[["self"],["defid"],["tyctxt"]],[""]]],[11,"pre_transforms_tys","","This is the types of the fields of a generate which is available before the generator transformation. It includes the upvars and the state discriminant which is u32.",672,[[["self"],["defid"],["tyctxt"]],[""]]],[11,"field_tys","","This is the types of all the fields stored in a generator. It includes the upvars, state types and the state discriminant which is u32.",672,[[["self"],["defid"],["tyctxt"]],[""]]],[11,"fmt","","",726,[[["self"],["formatter"]],["result"]]],[11,"clone","","",726,[[["self"]],["upvarsubsts"]]],[11,"upvar_tys","","",726,[[["self"],["defid"],["tyctxt"]],[""]]],[11,"fmt","","",725,[[["self"],["formatter"]],["result"]]],[11,"clone","","",725,[[["self"]],["existentialpredicate"]]],[11,"eq","","",725,[[["self"],["existentialpredicate"]],["bool"]]],[11,"ne","","",725,[[["self"],["existentialpredicate"]],["bool"]]],[11,"partial_cmp","","",725,[[["self"],["existentialpredicate"]],["option",["ordering"]]]],[11,"lt","","",725,[[["self"],["existentialpredicate"]],["bool"]]],[11,"le","","",725,[[["self"],["existentialpredicate"]],["bool"]]],[11,"gt","","",725,[[["self"],["existentialpredicate"]],["bool"]]],[11,"ge","","",725,[[["self"],["existentialpredicate"]],["bool"]]],[11,"cmp","","",725,[[["self"],["existentialpredicate"]],["ordering"]]],[11,"assert_receiver_is_total_eq","","",725,N],[11,"hash","","",725,N],[11,"encode","","",725,[[["self"],["__s"]],["result"]]],[11,"decode","","",725,[[["__d"]],["result",["existentialpredicate"]]]],[11,"stable_cmp","","Compares via an ordering that will not change if modules are reordered or other changes are made to the tree. In particular, this ordering is preserved across incremental compilations.",725,[[["self"],["tyctxt"],["self"]],["ordering"]]],[11,"with_self_ty","","",664,[[["self"],["tyctxt"],["ty"]],["predicate"]]],[11,"principal","","",697,[[["self"]],["option",["existentialtraitref"]]]],[11,"projection_bounds","","",697,[[["self"]],[""]]],[11,"auto_traits","","",697,[[["self"]],[""]]],[11,"principal","","",664,[[["self"]],["option",["polyexistentialtraitref"]]]],[11,"projection_bounds","","",664,[[["self"]],[""]]],[11,"auto_traits","","",664,[[["self"]],[""]]],[11,"iter","","",664,[[["self"]],[""]]],[11,"clone","","",674,[[["self"]],["traitref"]]],[11,"eq","","",674,[[["self"],["traitref"]],["bool"]]],[11,"ne","","",674,[[["self"],["traitref"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",674,N],[11,"hash","","",674,N],[11,"encode","","",674,[[["self"],["__s"]],["result"]]],[11,"decode","","",674,[[["__d"]],["result",["traitref"]]]],[11,"new","","",674,[[["defid"],["substs"]],["traitref"]]],[11,"identity","","Returns a TraitRef of the form `P0: Foo<P1..Pn>` where `Pi` are the parameters defined on trait.",674,[[["tyctxt"],["defid"]],["traitref"]]],[11,"self_ty","","",674,[[["self"]],["ty"]]],[11,"input_types","","",674,[[["self"]],[""]]],[11,"from_method","","",674,[[["tyctxt"],["defid"],["substs"]],["traitref"]]],[11,"self_ty","rustc::ty::sty","",1031,[[["self"]],["ty"]]],[11,"def_id","","",1031,[[["self"]],["defid"]]],[11,"to_poly_trait_predicate","","",1031,[[["self"]],["polytraitpredicate"]]],[11,"clone","rustc::ty","",675,[[["self"]],["existentialtraitref"]]],[11,"eq","","",675,[[["self"],["existentialtraitref"]],["bool"]]],[11,"ne","","",675,[[["self"],["existentialtraitref"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",675,N],[11,"partial_cmp","","",675,[[["self"],["existentialtraitref"]],["option",["ordering"]]]],[11,"lt","","",675,[[["self"],["existentialtraitref"]],["bool"]]],[11,"le","","",675,[[["self"],["existentialtraitref"]],["bool"]]],[11,"gt","","",675,[[["self"],["existentialtraitref"]],["bool"]]],[11,"ge","","",675,[[["self"],["existentialtraitref"]],["bool"]]],[11,"cmp","","",675,[[["self"],["existentialtraitref"]],["ordering"]]],[11,"hash","","",675,N],[11,"encode","","",675,[[["self"],["__s"]],["result"]]],[11,"decode","","",675,[[["__d"]],["result",["existentialtraitref"]]]],[11,"input_types","","",675,[[["self"]],[""]]],[11,"erase_self_ty","","",675,[[["tyctxt"],["traitref"]],["existentialtraitref"]]],[11,"with_self_ty","","Object types don't have a self-type specified. Therefore, when we convert the principal trait-ref into a normal trait-ref, you must give some self-type. A common choice is `mk_err()` or some skolemized type.",675,[[["self"],["tyctxt"],["ty"]],["traitref"]]],[11,"def_id","rustc::ty::sty","",1032,[[["self"]],["defid"]]],[11,"with_self_ty","","Object types don't have a self-type specified. Therefore, when we convert the principal trait-ref into a normal trait-ref, you must give some self-type. A common choice is `mk_err()` or some skolemized type.",1032,[[["self"],["tyctxt"],["ty"]],["polytraitref"]]],[11,"clone","rustc::ty","",664,[[["self"]],["binder"]]],[11,"eq","","",664,[[["self"],["binder"]],["bool"]]],[11,"ne","","",664,[[["self"],["binder"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",664,N],[11,"partial_cmp","","",664,[[["self"],["binder"]],["option",["ordering"]]]],[11,"lt","","",664,[[["self"],["binder"]],["bool"]]],[11,"le","","",664,[[["self"],["binder"]],["bool"]]],[11,"gt","","",664,[[["self"],["binder"]],["bool"]]],[11,"ge","","",664,[[["self"],["binder"]],["bool"]]],[11,"cmp","","",664,[[["self"],["binder"]],["ordering"]]],[11,"hash","","",664,N],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"encode","","",664,[[["self"],["__st"]],["result"]]],[11,"decode","","",664,[[["__dt"]],["result",["binder"]]]],[11,"dummy","","Wraps `value` in a binder, asserting that `value` does not contain any bound regions that would be bound by the binder. This is commonly used to 'inject' a value T into a different binding level.",664,[[["t"]],["binder"]]],[11,"bind","","Wraps `value` in a binder, binding late-bound regions (if any).",664,[[["t"]],["binder"]]],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a risky thing to do because it's easy to get confused about debruijn indices and the like. It is usually better to discharge the binder using `no_late_bound_regions` or `replace_late_bound_regions` or something like that. `skip_binder` is only valid when you are either extracting data that has nothing to do with bound regions, you are doing some sort of test that does not involve bound regions, or you are being very careful about your depth accounting.",664,[[["self"]],["t"]]],[11,"as_ref","","",664,[[["self"]],["binder"]]],[11,"map_bound_ref","","",664,[[["self"],["f"]],["binder"]]],[11,"map_bound","","",664,[[["self"],["f"]],["binder"]]],[11,"no_late_bound_regions","","Unwraps and returns the value within, but only if it contains no bound regions at all. (In other words, if this binder -- and indeed any enclosing binder -- doesn't bind anything at all.) Otherwise, returns `None`.",664,[[["self"]],["option"]]],[11,"fuse","","Given two things that have the same binder level, and an operation that wraps on their contents, execute the operation and then wrap its result.",664,[[["self"],["binder"],["f"]],["binder"]]],[11,"split","","Split the contents into two things that share the same binder level as the original, returning two distinct binders.",664,N],[11,"clone","","",670,[[["self"]],["projectionty"]]],[11,"eq","","",670,[[["self"],["projectionty"]],["bool"]]],[11,"ne","","",670,[[["self"],["projectionty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",670,N],[11,"partial_cmp","","",670,[[["self"],["projectionty"]],["option",["ordering"]]]],[11,"lt","","",670,[[["self"],["projectionty"]],["bool"]]],[11,"le","","",670,[[["self"],["projectionty"]],["bool"]]],[11,"gt","","",670,[[["self"],["projectionty"]],["bool"]]],[11,"ge","","",670,[[["self"],["projectionty"]],["bool"]]],[11,"cmp","","",670,[[["self"],["projectionty"]],["ordering"]]],[11,"hash","","",670,N],[11,"fmt","","",670,[[["self"],["formatter"]],["result"]]],[11,"encode","","",670,[[["self"],["__s"]],["result"]]],[11,"decode","","",670,[[["__d"]],["result",["projectionty"]]]],[11,"from_ref_and_name","","Construct a ProjectionTy by searching the trait from trait_ref for the associated item named item_name.",670,[[["tyctxt"],["traitref"],["ident"]],["projectionty"]]],[11,"trait_ref","","Extracts the underlying trait reference from this projection. For example, if this is a projection of `<T as Iterator>::Item`, then this function would return a `T: Iterator` trait reference.",670,[[["self"],["tyctxt"]],["traitref"]]],[11,"self_ty","","",670,[[["self"]],["ty"]]],[11,"clone","","",668,[[["self"]],["gensig"]]],[11,"fmt","","",668,[[["self"],["formatter"]],["result"]]],[11,"eq","","",668,[[["self"],["gensig"]],["bool"]]],[11,"ne","","",668,[[["self"],["gensig"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",668,N],[11,"hash","","",668,N],[11,"encode","","",668,[[["self"],["__s"]],["result"]]],[11,"decode","","",668,[[["__d"]],["result",["gensig"]]]],[11,"yield_ty","rustc::ty::sty","",1033,[[["self"]],["binder",["ty"]]]],[11,"return_ty","","",1033,[[["self"]],["binder",["ty"]]]],[11,"clone","rustc::ty","",667,[[["self"]],["fnsig"]]],[11,"eq","","",667,[[["self"],["fnsig"]],["bool"]]],[11,"ne","","",667,[[["self"],["fnsig"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",667,N],[11,"partial_cmp","","",667,[[["self"],["fnsig"]],["option",["ordering"]]]],[11,"lt","","",667,[[["self"],["fnsig"]],["bool"]]],[11,"le","","",667,[[["self"],["fnsig"]],["bool"]]],[11,"gt","","",667,[[["self"],["fnsig"]],["bool"]]],[11,"ge","","",667,[[["self"],["fnsig"]],["bool"]]],[11,"cmp","","",667,[[["self"],["fnsig"]],["ordering"]]],[11,"hash","","",667,N],[11,"encode","","",667,[[["self"],["__s"]],["result"]]],[11,"decode","","",667,[[["__d"]],["result",["fnsig"]]]],[11,"inputs","","",667,N],[11,"output","","",667,[[["self"]],["ty"]]],[11,"inputs","rustc::ty::sty","",1034,[[["self"]],["binder"]]],[11,"input","","",1034,[[["self"],["usize"]],["binder",["ty"]]]],[11,"inputs_and_output","","",1034,[[["self"]],["binder",["slice"]]]],[11,"output","","",1034,[[["self"]],["binder",["ty"]]]],[11,"variadic","","",1034,[[["self"]],["bool"]]],[11,"unsafety","","",1034,[[["self"]],["unsafety"]]],[11,"abi","","",1034,[[["self"]],["abi"]]],[11,"clone","rustc::ty","",669,[[["self"]],["paramty"]]],[11,"eq","","",669,[[["self"],["paramty"]],["bool"]]],[11,"ne","","",669,[[["self"],["paramty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",669,N],[11,"partial_cmp","","",669,[[["self"],["paramty"]],["option",["ordering"]]]],[11,"lt","","",669,[[["self"],["paramty"]],["bool"]]],[11,"le","","",669,[[["self"],["paramty"]],["bool"]]],[11,"gt","","",669,[[["self"],["paramty"]],["bool"]]],[11,"ge","","",669,[[["self"],["paramty"]],["bool"]]],[11,"cmp","","",669,[[["self"],["paramty"]],["ordering"]]],[11,"hash","","",669,N],[11,"encode","","",669,[[["self"],["__s"]],["result"]]],[11,"decode","","",669,[[["__d"]],["result",["paramty"]]]],[11,"new","","",669,[[["u32"],["internedstring"]],["paramty"]]],[11,"for_self","","",669,[[],["paramty"]]],[11,"for_def","","",669,[[["genericparamdef"]],["paramty"]]],[11,"to_ty","","",669,[[["self"],["tyctxt"]],["ty"]]],[11,"is_self","","",669,[[["self"]],["bool"]]],[11,"clone","","",666,[[["self"]],["debruijnindex"]]],[11,"eq","","",666,[[["self"],["debruijnindex"]],["bool"]]],[11,"ne","","",666,[[["self"],["debruijnindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",666,N],[11,"hash","","",666,N],[11,"partial_cmp","","",666,[[["self"],["debruijnindex"]],["option",["ordering"]]]],[11,"lt","","",666,[[["self"],["debruijnindex"]],["bool"]]],[11,"le","","",666,[[["self"],["debruijnindex"]],["bool"]]],[11,"gt","","",666,[[["self"],["debruijnindex"]],["bool"]]],[11,"ge","","",666,[[["self"],["debruijnindex"]],["bool"]]],[11,"cmp","","",666,[[["self"],["debruijnindex"]],["ordering"]]],[11,"decode","","",666,[[["__d"]],["result",["debruijnindex"]]]],[11,"encode","","",666,[[["self"],["__s"]],["result"]]],[11,"new","","",666,[[["usize"]],["self"]]],[11,"index","","",666,[[["self"]],["usize"]]],[11,"steps_between","","",666,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",666,[[["self"]],["self"]]],[11,"replace_zero","","",666,[[["self"]],["self"]]],[11,"add_one","","",666,[[["self"]],["self"]]],[11,"sub_one","","",666,[[["self"]],["self"]]],[11,"add_usize","","",666,[[["self"],["usize"]],["option"]]],[11,"fmt","","",666,[[["self"],["formatter"]],["result"]]],[11,"clone","","",729,[[["self"]],["regionkind"]]],[11,"eq","","",729,[[["self"],["regionkind"]],["bool"]]],[11,"ne","","",729,[[["self"],["regionkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",729,N],[11,"hash","","",729,N],[11,"encode","","",729,[[["self"],["__s"]],["result"]]],[11,"decode","","",729,[[["__d"]],["result",["regionkind"]]]],[11,"partial_cmp","","",729,[[["self"],["regionkind"]],["option",["ordering"]]]],[11,"lt","","",729,[[["self"],["regionkind"]],["bool"]]],[11,"le","","",729,[[["self"],["regionkind"]],["bool"]]],[11,"gt","","",729,[[["self"],["regionkind"]],["bool"]]],[11,"ge","","",729,[[["self"],["regionkind"]],["bool"]]],[11,"cmp","","",729,[[["self"],["regionkind"]],["ordering"]]],[11,"clone","","",678,[[["self"]],["earlyboundregion"]]],[11,"eq","","",678,[[["self"],["earlyboundregion"]],["bool"]]],[11,"ne","","",678,[[["self"],["earlyboundregion"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",678,N],[11,"hash","","",678,N],[11,"encode","","",678,[[["self"],["__s"]],["result"]]],[11,"decode","","",678,[[["__d"]],["result",["earlyboundregion"]]]],[11,"fmt","","",678,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",678,[[["self"],["earlyboundregion"]],["option",["ordering"]]]],[11,"lt","","",678,[[["self"],["earlyboundregion"]],["bool"]]],[11,"le","","",678,[[["self"],["earlyboundregion"]],["bool"]]],[11,"gt","","",678,[[["self"],["earlyboundregion"]],["bool"]]],[11,"ge","","",678,[[["self"],["earlyboundregion"]],["bool"]]],[11,"cmp","","",678,[[["self"],["earlyboundregion"]],["ordering"]]],[11,"clone","","",680,[[["self"]],["tyvid"]]],[11,"eq","","",680,[[["self"],["tyvid"]],["bool"]]],[11,"ne","","",680,[[["self"],["tyvid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",680,N],[11,"partial_cmp","","",680,[[["self"],["tyvid"]],["option",["ordering"]]]],[11,"lt","","",680,[[["self"],["tyvid"]],["bool"]]],[11,"le","","",680,[[["self"],["tyvid"]],["bool"]]],[11,"gt","","",680,[[["self"],["tyvid"]],["bool"]]],[11,"ge","","",680,[[["self"],["tyvid"]],["bool"]]],[11,"cmp","","",680,[[["self"],["tyvid"]],["ordering"]]],[11,"hash","","",680,N],[11,"encode","","",680,[[["self"],["__s"]],["result"]]],[11,"decode","","",680,[[["__d"]],["result",["tyvid"]]]],[11,"clone","","",681,[[["self"]],["intvid"]]],[11,"eq","","",681,[[["self"],["intvid"]],["bool"]]],[11,"ne","","",681,[[["self"],["intvid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",681,N],[11,"partial_cmp","","",681,[[["self"],["intvid"]],["option",["ordering"]]]],[11,"lt","","",681,[[["self"],["intvid"]],["bool"]]],[11,"le","","",681,[[["self"],["intvid"]],["bool"]]],[11,"gt","","",681,[[["self"],["intvid"]],["bool"]]],[11,"ge","","",681,[[["self"],["intvid"]],["bool"]]],[11,"cmp","","",681,[[["self"],["intvid"]],["ordering"]]],[11,"hash","","",681,N],[11,"encode","","",681,[[["self"],["__s"]],["result"]]],[11,"decode","","",681,[[["__d"]],["result",["intvid"]]]],[11,"clone","","",682,[[["self"]],["floatvid"]]],[11,"eq","","",682,[[["self"],["floatvid"]],["bool"]]],[11,"ne","","",682,[[["self"],["floatvid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",682,N],[11,"partial_cmp","","",682,[[["self"],["floatvid"]],["option",["ordering"]]]],[11,"lt","","",682,[[["self"],["floatvid"]],["bool"]]],[11,"le","","",682,[[["self"],["floatvid"]],["bool"]]],[11,"gt","","",682,[[["self"],["floatvid"]],["bool"]]],[11,"ge","","",682,[[["self"],["floatvid"]],["bool"]]],[11,"cmp","","",682,[[["self"],["floatvid"]],["ordering"]]],[11,"hash","","",682,N],[11,"encode","","",682,[[["self"],["__s"]],["result"]]],[11,"decode","","",682,[[["__d"]],["result",["floatvid"]]]],[11,"clone","","",683,[[["self"]],["regionvid"]]],[11,"eq","","",683,[[["self"],["regionvid"]],["bool"]]],[11,"ne","","",683,[[["self"],["regionvid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",683,N],[11,"hash","","",683,N],[11,"partial_cmp","","",683,[[["self"],["regionvid"]],["option",["ordering"]]]],[11,"lt","","",683,[[["self"],["regionvid"]],["bool"]]],[11,"le","","",683,[[["self"],["regionvid"]],["bool"]]],[11,"gt","","",683,[[["self"],["regionvid"]],["bool"]]],[11,"ge","","",683,[[["self"],["regionvid"]],["bool"]]],[11,"cmp","","",683,[[["self"],["regionvid"]],["ordering"]]],[11,"decode","","",683,[[["__d"]],["result",["regionvid"]]]],[11,"encode","","",683,[[["self"],["__s"]],["result"]]],[11,"new","","",683,[[["usize"]],["self"]]],[11,"index","","",683,[[["self"]],["usize"]]],[11,"steps_between","","",683,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",683,[[["self"]],["self"]]],[11,"replace_zero","","",683,[[["self"]],["self"]]],[11,"add_one","","",683,[[["self"]],["self"]]],[11,"sub_one","","",683,[[["self"]],["self"]]],[11,"add_usize","","",683,[[["self"],["usize"]],["option"]]],[11,"index","","",683,[[["self"]],["usize"]]],[11,"from","","",683,[[["usize"]],["regionvid"]]],[11,"clone","","",724,[[["self"]],["inferty"]]],[11,"eq","","",724,[[["self"],["inferty"]],["bool"]]],[11,"ne","","",724,[[["self"],["inferty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",724,N],[11,"partial_cmp","","",724,[[["self"],["inferty"]],["option",["ordering"]]]],[11,"lt","","",724,[[["self"],["inferty"]],["bool"]]],[11,"le","","",724,[[["self"],["inferty"]],["bool"]]],[11,"gt","","",724,[[["self"],["inferty"]],["bool"]]],[11,"ge","","",724,[[["self"],["inferty"]],["bool"]]],[11,"cmp","","",724,[[["self"],["inferty"]],["ordering"]]],[11,"hash","","",724,N],[11,"encode","","",724,[[["self"],["__s"]],["result"]]],[11,"decode","","",724,[[["__d"]],["result",["inferty"]]]],[11,"clone","","",665,[[["self"]],["canonicalvar"]]],[11,"eq","","",665,[[["self"],["canonicalvar"]],["bool"]]],[11,"ne","","",665,[[["self"],["canonicalvar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",665,N],[11,"hash","","",665,N],[11,"partial_cmp","","",665,[[["self"],["canonicalvar"]],["option",["ordering"]]]],[11,"lt","","",665,[[["self"],["canonicalvar"]],["bool"]]],[11,"le","","",665,[[["self"],["canonicalvar"]],["bool"]]],[11,"gt","","",665,[[["self"],["canonicalvar"]],["bool"]]],[11,"ge","","",665,[[["self"],["canonicalvar"]],["bool"]]],[11,"cmp","","",665,[[["self"],["canonicalvar"]],["ordering"]]],[11,"decode","","",665,[[["__d"]],["result",["canonicalvar"]]]],[11,"encode","","",665,[[["self"],["__s"]],["result"]]],[11,"new","","",665,[[["usize"]],["self"]]],[11,"index","","",665,[[["self"]],["usize"]]],[11,"steps_between","","",665,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",665,[[["self"]],["self"]]],[11,"replace_zero","","",665,[[["self"]],["self"]]],[11,"add_one","","",665,[[["self"]],["self"]]],[11,"sub_one","","",665,[[["self"]],["self"]]],[11,"add_usize","","",665,[[["self"],["usize"]],["option"]]],[11,"fmt","","",665,[[["self"],["formatter"]],["result"]]],[11,"clone","","",676,[[["self"]],["existentialprojection"]]],[11,"eq","","",676,[[["self"],["existentialprojection"]],["bool"]]],[11,"ne","","",676,[[["self"],["existentialprojection"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",676,N],[11,"partial_cmp","","",676,[[["self"],["existentialprojection"]],["option",["ordering"]]]],[11,"lt","","",676,[[["self"],["existentialprojection"]],["bool"]]],[11,"le","","",676,[[["self"],["existentialprojection"]],["bool"]]],[11,"gt","","",676,[[["self"],["existentialprojection"]],["bool"]]],[11,"ge","","",676,[[["self"],["existentialprojection"]],["bool"]]],[11,"cmp","","",676,[[["self"],["existentialprojection"]],["ordering"]]],[11,"hash","","",676,N],[11,"fmt","","",676,[[["self"],["formatter"]],["result"]]],[11,"encode","","",676,[[["self"],["__s"]],["result"]]],[11,"decode","","",676,[[["__d"]],["result",["existentialprojection"]]]],[11,"trait_ref","","Extracts the underlying existential trait reference from this projection. For example, if this is a projection of `exists T. <T as Iterator>::Item == X`, then this function would return a `exists T. T: Iterator` existential trait reference.",676,[[["self"],["tyctxt"]],["existentialtraitref"]]],[11,"with_self_ty","","",676,[[["self"],["tyctxt"],["ty"]],["projectionpredicate"]]],[11,"with_self_ty","rustc::ty::sty","",1035,[[["self"],["tyctxt"],["ty"]],["polyprojectionpredicate"]]],[11,"item_def_id","","",1035,[[["self"]],["defid"]]],[11,"shifted_in","rustc::ty","Returns the resulting index when this value is moved into `amount` number of new binders. So e.g. if you had",666,[[["self"],["u32"]],["debruijnindex"]]],[11,"shift_in","","Update this index in place by shifting it \"in\" through `amount` number of binders.",666,[[["self"],["u32"]]]],[11,"shifted_out","","Returns the resulting index when this value is moved out from `amount` number of new binders.",666,[[["self"],["u32"]],["debruijnindex"]]],[11,"shift_out","","Update in place by shifting out from `amount` binders.",666,[[["self"],["u32"]]]],[11,"shifted_out_to_binder","","Adjusts any Debruijn Indices so as to make `to_binder` the innermost binder. That is, if we have something bound at `to_binder`, it will now be bound at INNERMOST. This is an appropriate thing to do when moving a region out from inside binders:",666,[[["self"],["debruijnindex"]],["self"]]],[11,"hash_stable","","",666,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"is_late_bound","","",729,[[["self"]],["bool"]]],[11,"bound_at_or_above_binder","","",729,[[["self"],["debruijnindex"]],["bool"]]],[11,"shifted_out_to_binder","","Adjusts any Debruijn Indices so as to make `to_binder` the innermost binder. That is, if we have something bound at `to_binder`, it will now be bound at INNERMOST. This is an appropriate thing to do when moving a region out from inside binders:",729,[[["self"],["debruijnindex"]],["regionkind"]]],[11,"keep_in_local_tcx","","",729,[[["self"]],["bool"]]],[11,"type_flags","","",729,[[["self"]],["typeflags"]]],[11,"free_region_binding_scope","","Given an early-bound or free region, returns the def-id where it was bound. For example, consider the regions in this snippet of code:",729,[[["self"],["tyctxt"]],["defid"]]],[11,"is_nil","","",696,[[["self"]],["bool"]]],[11,"is_never","","",696,[[["self"]],["bool"]]],[11,"is_primitive","","",696,[[["self"]],["bool"]]],[11,"is_ty_var","","",696,[[["self"]],["bool"]]],[11,"is_ty_infer","","",696,[[["self"]],["bool"]]],[11,"is_phantom_data","","",696,[[["self"]],["bool"]]],[11,"is_bool","","",696,[[["self"]],["bool"]]],[11,"is_param","","",696,[[["self"],["u32"]],["bool"]]],[11,"is_self","","",696,[[["self"]],["bool"]]],[11,"is_slice","","",696,[[["self"]],["bool"]]],[11,"is_simd","","",696,[[["self"]],["bool"]]],[11,"sequence_element_type","","",696,[[["self"],["tyctxt"]],["ty"]]],[11,"simd_type","","",696,[[["self"],["tyctxt"]],["ty"]]],[11,"simd_size","","",696,[[["self"],["tyctxt"]],["usize"]]],[11,"is_region_ptr","","",696,[[["self"]],["bool"]]],[11,"is_mutable_pointer","","",696,[[["self"]],["bool"]]],[11,"is_unsafe_ptr","","",696,[[["self"]],["bool"]]],[11,"is_box","","",696,[[["self"]],["bool"]]],[11,"boxed_ty","","panics if called on any type other than `Box<T>`",696,[[["self"]],["ty"]]],[11,"is_scalar","","A scalar type is one that denotes an atomic datum, with no sub-components. (A TyRawPtr is scalar because it represents a non-managed pointer, so its contents are abstract to rustc.)",696,[[["self"]],["bool"]]],[11,"is_floating_point","","Returns true if this type is a floating point type and false otherwise.",696,[[["self"]],["bool"]]],[11,"is_trait","","",696,[[["self"]],["bool"]]],[11,"is_enum","","",696,[[["self"]],["bool"]]],[11,"is_closure","","",696,[[["self"]],["bool"]]],[11,"is_generator","","",696,[[["self"]],["bool"]]],[11,"is_integral","","",696,[[["self"]],["bool"]]],[11,"is_fresh_ty","","",696,[[["self"]],["bool"]]],[11,"is_fresh","","",696,[[["self"]],["bool"]]],[11,"is_char","","",696,[[["self"]],["bool"]]],[11,"is_fp","","",696,[[["self"]],["bool"]]],[11,"is_numeric","","",696,[[["self"]],["bool"]]],[11,"is_signed","","",696,[[["self"]],["bool"]]],[11,"is_machine","","",696,[[["self"]],["bool"]]],[11,"has_concrete_skeleton","","",696,[[["self"]],["bool"]]],[11,"builtin_deref","","Returns the type and mutability of *ty.",696,[[["self"],["bool"]],["option",["typeandmut"]]]],[11,"builtin_index","","Returns the type of `ty[i]`.",696,[[["self"]],["option",["ty"]]]],[11,"fn_sig","","",696,[[["self"],["tyctxt"]],["polyfnsig"]]],[11,"is_fn","","",696,[[["self"]],["bool"]]],[11,"is_impl_trait","","",696,[[["self"]],["bool"]]],[11,"ty_adt_def","","",696,[[["self"]],["option",["adtdef"]]]],[11,"regions","","Returns the regions directly referenced from this type (but not types reachable from this type via `walk_tys`). This ignores late-bound regions binders.",696,[[["self"]],["vec",["region"]]]],[11,"to_opt_closure_kind","","When we create a closure, we record its kind (i.e., what trait it implements) into its `ClosureSubsts` using a type parameter. This is kind of a phantom type, except that the most convenient thing for us to are the integral types. This function converts such a special type into the closure kind. To go the other way, use `tcx.closure_kind_ty(closure_kind)`.",696,[[["self"]],["option",["closurekind"]]]],[11,"clone","","",677,[[["self"]],["const"]]],[11,"fmt","","",677,[[["self"],["formatter"]],["result"]]],[11,"hash","","",677,N],[11,"encode","","",677,[[["self"],["__s"]],["result"]]],[11,"decode","","",677,[[["__d"]],["result",["const"]]]],[11,"assert_receiver_is_total_eq","","",677,N],[11,"eq","","",677,[[["self"],["const"]],["bool"]]],[11,"ne","","",677,[[["self"],["const"]],["bool"]]],[11,"cmp","","",677,[[["self"],["const"]],["ordering"]]],[11,"partial_cmp","","",677,[[["self"],["const"]],["option",["ordering"]]]],[11,"lt","","",677,[[["self"],["const"]],["bool"]]],[11,"le","","",677,[[["self"],["const"]],["bool"]]],[11,"gt","","",677,[[["self"],["const"]],["bool"]]],[11,"ge","","",677,[[["self"],["const"]],["bool"]]],[11,"unevaluated","","",677,[[["tyctxt"],["defid"],["substs"],["ty"]],["self"]]],[11,"from_const_value","","",677,[[["tyctxt"],["constvalue"],["ty"]],["self"]]],[11,"from_byval_value","","",677,[[["tyctxt"],["value"],["ty"]],["self"]]],[11,"from_scalar","","",677,[[["tyctxt"],["scalar"],["ty"]],["self"]]],[11,"from_bits","","",677,[[["tyctxt"],["u128"],["paramenvand",["ty"]]],["self"]]],[11,"zero_sized","","",677,[[["tyctxt"],["ty"]],["self"]]],[11,"from_bool","","",677,[[["tyctxt"],["bool"]],["self"]]],[11,"from_usize","","",677,[[["tyctxt"],["u64"]],["self"]]],[11,"to_bits","","",677,[[["self"],["tyctxt"],["paramenvand",["ty"]]],["option",["u128"]]]],[11,"to_ptr","","",677,[[["self"]],["option",["pointer"]]]],[11,"to_byval_value","","",677,[[["self"]],["option",["value"]]]],[11,"to_scalar","","",677,[[["self"]],["option",["scalar"]]]],[11,"assert_bits","","",677,[[["self"],["tyctxt"],["paramenvand",["ty"]]],["option",["u128"]]]],[11,"assert_bool","","",677,[[["self"],["tyctxt"]],["option",["bool"]]]],[11,"assert_usize","","",677,[[["self"],["tyctxt"]],["option",["u64"]]]],[11,"unwrap_bits","","",677,[[["self"],["tyctxt"],["paramenvand",["ty"]]],["u128"]]],[11,"unwrap_usize","","",677,[[["self"],["tyctxt"]],["u64"]]],[6,"PolyFnSig","","",N,N],[6,"PolyGenSig","","",N,N],[6,"PolyTraitRef","","",N,N],[6,"PolyExistentialTraitRef","","",N,N],[6,"PolyExistentialProjection","","",N,N],[6,"Region","","",N,N],[6,"Ty","","",N,N],[6,"CanonicalTy","","",N,N],[6,"UpvarCaptureMap","","",N,N],[6,"PolyTraitPredicate","","",N,N],[6,"PolyOutlivesPredicate","","",N,N],[6,"RegionOutlivesPredicate","","",N,N],[6,"TypeOutlivesPredicate","","",N,N],[6,"PolyRegionOutlivesPredicate","","",N,N],[6,"PolyTypeOutlivesPredicate","","",N,N],[6,"PolySubtypePredicate","","",N,N],[6,"PolyProjectionPredicate","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"INNERMOST","","",N,N],[8,"Lift","","A trait implemented for all X<'a> types which can be safely and efficiently converted to X<'tcx> as long as they are part of the provided TyCtxt<'tcx>. This can be done, for example, for Ty<'tcx> or &'tcx Substs<'tcx> by looking them up in their respective interners.",N,N],[16,"Lifted","","",1025,N],[10,"lift_to_tcx","","",1025,[[["self"],["tyctxt"]],["option"]]],[8,"DefIdTree","","",N,N],[10,"parent","","",1036,[[["self"],["defid"]],["option",["defid"]]]],[11,"is_descendant_of","","",1036,[[["self"],["defid"],["defid"]],["bool"]]],[8,"ToPolyTraitRef","","",N,N],[10,"to_poly_trait_ref","","",1037,[[["self"]],["polytraitref"]]],[8,"ToPredicate","","",N,N],[10,"to_predicate","","",1038,[[["self"]],["predicate"]]],[11,"clone","","",689,[[["self"]],["crateanalysis"]]],[11,"clone","","",690,[[["self"]],["resolutions"]]],[11,"clone","","",731,[[["self"]],["associateditemcontainer"]]],[11,"eq","","",731,[[["self"],["associateditemcontainer"]],["bool"]]],[11,"ne","","",731,[[["self"],["associateditemcontainer"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",731,N],[11,"fmt","","",731,[[["self"],["formatter"]],["result"]]],[11,"assert_trait","","Asserts that this is the def-id of an associated item declared in a trait, and returns the trait def-id.",731,[[["self"]],["defid"]]],[11,"id","","",731,[[["self"]],["defid"]]],[11,"clone","","",691,[[["self"]],["implheader"]]],[11,"eq","","",691,[[["self"],["implheader"]],["bool"]]],[11,"ne","","",691,[[["self"],["implheader"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",691,N],[11,"hash","","",691,N],[11,"fmt","","",691,[[["self"],["formatter"]],["result"]]],[11,"clone","","",692,[[["self"]],["associateditem"]]],[11,"fmt","","",692,[[["self"],["formatter"]],["result"]]],[11,"eq","","",692,[[["self"],["associateditem"]],["bool"]]],[11,"ne","","",692,[[["self"],["associateditem"]],["bool"]]],[11,"clone","","",732,[[["self"]],["associatedkind"]]],[11,"eq","","",732,[[["self"],["associatedkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",732,N],[11,"fmt","","",732,[[["self"],["formatter"]],["result"]]],[11,"hash","","",732,N],[11,"encode","","",732,[[["self"],["__s"]],["result"]]],[11,"decode","","",732,[[["__d"]],["result",["associatedkind"]]]],[11,"def","","",692,[[["self"]],["def"]]],[11,"relevant_for_never","","Tests whether the associated item admits a non-trivial implementation for !",692,[[["self"]],["bool"]]],[11,"signature","","",692,[[["self"],["tyctxt"]],["string"]]],[11,"clone","","",733,[[["self"]],["visibility"]]],[11,"fmt","","",733,[[["self"],["formatter"]],["result"]]],[11,"eq","","",733,[[["self"],["visibility"]],["bool"]]],[11,"ne","","",733,[[["self"],["visibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",733,N],[11,"encode","","",733,[[["self"],["__s"]],["result"]]],[11,"decode","","",733,[[["__d"]],["result",["visibility"]]]],[11,"parent","","",684,[[["self"],["defid"]],["option",["defid"]]]],[11,"from_hir","","",733,[[["visibility"],["nodeid"],["tyctxt"]],["self"]]],[11,"is_accessible_from","","Returns true if an item with this visibility is accessible from the given block.",733,[[["self"],["defid"],["t"]],["bool"]]],[11,"is_at_least","","Returns true if this visibility is at least as accessible as the given visibility",733,[[["self"],["visibility"],["t"]],["bool"]]],[11,"is_visible_locally","","",733,[[["self"]],["bool"]]],[11,"clone","","",734,[[["self"]],["variance"]]],[11,"eq","","",734,[[["self"],["variance"]],["bool"]]],[11,"decode","","",734,[[["__d"]],["result",["variance"]]]],[11,"encode","","",734,[[["self"],["__s"]],["result"]]],[11,"xform","","`a.xform(b)` combines the variance of a context with the variance of a type with the following meaning.  If we are in a context with variance `a`, and we encounter a type argument in a position with variance `b`, then `a.xform(b)` is the new variance with which the argument appears.",734,[[["self"],["variance"]],["variance"]]],[11,"clone","","",694,[[["self"]],["creadercachekey"]]],[11,"eq","","",694,[[["self"],["creadercachekey"]],["bool"]]],[11,"ne","","",694,[[["self"],["creadercachekey"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",694,N],[11,"hash","","",694,N],[11,"eq","","",695,[[["self"],["typeflags"]],["bool"]]],[11,"ne","","",695,[[["self"],["typeflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",695,N],[11,"clone","","",695,[[["self"]],["typeflags"]]],[11,"partial_cmp","","",695,[[["self"],["typeflags"]],["option",["ordering"]]]],[11,"lt","","",695,[[["self"],["typeflags"]],["bool"]]],[11,"le","","",695,[[["self"],["typeflags"]],["bool"]]],[11,"gt","","",695,[[["self"],["typeflags"]],["bool"]]],[11,"ge","","",695,[[["self"],["typeflags"]],["bool"]]],[11,"cmp","","",695,[[["self"],["typeflags"]],["ordering"]]],[11,"hash","","",695,N],[11,"fmt","","",695,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",695,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",695,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",695,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",695,[[["self"],["formatter"]],["result"]]],[18,"HAS_PARAMS","","",695,N],[18,"HAS_SELF","","",695,N],[18,"HAS_TY_INFER","","",695,N],[18,"HAS_RE_INFER","","",695,N],[18,"HAS_RE_SKOL","","",695,N],[18,"HAS_RE_EARLY_BOUND","","Does this have any `ReEarlyBound` regions? Used to determine whether substitition is required, since those represent regions that are bound in a `ty::Generics` and hence may be substituted.",695,N],[18,"HAS_FREE_REGIONS","","Does this have any region that \"appears free\" in the type? Basically anything but `ReLateBound` and `ReErased`.",695,N],[18,"HAS_TY_ERR","","Is an error type reachable?",695,N],[18,"HAS_PROJECTION","","",695,N],[18,"HAS_TY_CLOSURE","","",695,N],[18,"HAS_FREE_LOCAL_NAMES","","",695,N],[18,"KEEP_IN_LOCAL_TCX","","",695,N],[18,"HAS_NORMALIZABLE_PROJECTION","","",695,N],[18,"HAS_CANONICAL_VARS","","",695,N],[18,"HAS_RE_LATE_BOUND","","Does this have any `ReLateBound` regions? Used to check if a global bound is safe to evaluate.",695,N],[18,"NEEDS_SUBST","","",695,N],[18,"NOMINAL_FLAGS","","",695,N],[11,"empty","","Returns an empty set of flags.",695,[[],["typeflags"]]],[11,"all","","Returns the set containing all flags.",695,[[],["typeflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",695,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",695,[[["u32"]],["option",["typeflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",695,[[["u32"]],["typeflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",695,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",695,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",695,[[["self"],["typeflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",695,[[["self"],["typeflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",695,[[["self"],["typeflags"]]]],[11,"remove","","Removes the specified flags in-place.",695,[[["self"],["typeflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",695,[[["self"],["typeflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",695,[[["self"],["typeflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",695,[[["self"],["typeflags"]],["typeflags"]]],[11,"bitor_assign","","Adds the set of flags.",695,[[["self"],["typeflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",695,[[["self"],["typeflags"]],["typeflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",695,[[["self"],["typeflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",695,[[["self"],["typeflags"]],["typeflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",695,[[["self"],["typeflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",695,[[["self"],["typeflags"]],["typeflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",695,[[["self"],["typeflags"]]]],[11,"not","","Returns the complement of this set of flags.",695,[[["self"]],["typeflags"]]],[11,"extend","","",695,[[["self"],["t"]]]],[11,"from_iter","","",695,[[["t"]],["typeflags"]]],[11,"cmp","","",696,[[["self"],["tys"]],["ordering"]]],[11,"partial_cmp","","",696,[[["self"],["tys"]],["option",["ordering"]]]],[11,"eq","","",696,[[["self"],["tys"]],["bool"]]],[11,"hash","","",696,[[["self"],["h"]]]],[11,"is_primitive_ty","","",696,[[["self"]],["bool"]]],[11,"is_suggestable","","",696,[[["self"]],["bool"]]],[11,"hash_stable","","",696,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"from_arena","","",697,N],[11,"fmt","","",697,[[["self"],["formatter"]],["result"]]],[11,"encode","","",697,[[["self"],["s"]],["result"]]],[11,"cmp","","",697,[[["self"],["slice"]],["ordering"]]],[11,"partial_cmp","","",697,[[["self"],["slice"]],["option",["ordering"]]]],[11,"eq","","",697,[[["self"],["slice"]],["bool"]]],[11,"hash","","",697,[[["self"],["h"]]]],[11,"deref","","",697,N],[11,"empty","","",697,[[],["slice"]]],[11,"clone","","",698,[[["self"]],["upvarid"]]],[11,"eq","","",698,[[["self"],["upvarid"]],["bool"]]],[11,"ne","","",698,[[["self"],["upvarid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",698,N],[11,"hash","","",698,N],[11,"encode","","",698,[[["self"],["__s"]],["result"]]],[11,"decode","","",698,[[["__d"]],["result",["upvarid"]]]],[11,"clone","","",735,[[["self"]],["borrowkind"]]],[11,"eq","","",735,[[["self"],["borrowkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",735,N],[11,"hash","","",735,N],[11,"fmt","","",735,[[["self"],["formatter"]],["result"]]],[11,"encode","","",735,[[["self"],["__s"]],["result"]]],[11,"decode","","",735,[[["__d"]],["result",["borrowkind"]]]],[11,"eq","","",736,[[["self"],["upvarcapture"]],["bool"]]],[11,"ne","","",736,[[["self"],["upvarcapture"]],["bool"]]],[11,"clone","","",736,[[["self"]],["upvarcapture"]]],[11,"fmt","","",736,[[["self"],["formatter"]],["result"]]],[11,"encode","","",736,[[["self"],["__s"]],["result"]]],[11,"decode","","",736,[[["__d"]],["result",["upvarcapture"]]]],[11,"eq","","",699,[[["self"],["upvarborrow"]],["bool"]]],[11,"ne","","",699,[[["self"],["upvarborrow"]],["bool"]]],[11,"clone","","",699,[[["self"]],["upvarborrow"]]],[11,"encode","","",699,[[["self"],["__s"]],["result"]]],[11,"decode","","",699,[[["__d"]],["result",["upvarborrow"]]]],[11,"clone","","",700,[[["self"]],["closureupvar"]]],[11,"clone","","",737,[[["self"]],["intvarvalue"]]],[11,"eq","","",737,[[["self"],["intvarvalue"]],["bool"]]],[11,"ne","","",737,[[["self"],["intvarvalue"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",737,N],[11,"clone","","",701,[[["self"]],["floatvarvalue"]]],[11,"eq","","",701,[[["self"],["floatvarvalue"]],["bool"]]],[11,"ne","","",701,[[["self"],["floatvarvalue"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",701,N],[11,"to_bound_region","","",678,[[["self"]],["boundregion"]]],[11,"clone","","",738,[[["self"]],["genericparamdefkind"]]],[11,"fmt","","",738,[[["self"],["formatter"]],["result"]]],[11,"encode","","",738,[[["self"],["__s"]],["result"]]],[11,"decode","","",738,[[["__d"]],["result",["genericparamdefkind"]]]],[11,"clone","","",702,[[["self"]],["genericparamdef"]]],[11,"encode","","",702,[[["self"],["__s"]],["result"]]],[11,"decode","","",702,[[["__d"]],["result",["genericparamdef"]]]],[11,"to_early_bound_region_data","","",702,[[["self"]],["earlyboundregion"]]],[11,"to_bound_region","","",702,[[["self"]],["boundregion"]]],[11,"clone","","",704,[[["self"]],["generics"]]],[11,"fmt","","",704,[[["self"],["formatter"]],["result"]]],[11,"encode","","",704,[[["self"],["__s"]],["result"]]],[11,"decode","","",704,[[["__d"]],["result",["generics"]]]],[11,"count","","",704,[[["self"]],["usize"]]],[11,"own_counts","","",704,[[["self"]],["genericparamcount"]]],[11,"requires_monomorphization","","",704,[[["self"],["tyctxt"]],["bool"]]],[11,"region_param","","",704,[[["self"],["earlyboundregion"],["tyctxt"]],["genericparamdef"]]],[11,"type_param","","Returns the `GenericParamDef` associated with this `ParamTy`.",704,[[["self"],["paramty"],["tyctxt"]],["genericparamdef"]]],[11,"clone","","",705,[[["self"]],["genericpredicates"]]],[11,"default","","",705,[[],["genericpredicates"]]],[11,"instantiate","","",705,[[["self"],["tyctxt"],["substs"]],["instantiatedpredicates"]]],[11,"instantiate_own","","",705,[[["self"],["tyctxt"],["substs"]],["instantiatedpredicates"]]],[11,"instantiate_into","","",705,[[["self"],["tyctxt"],["instantiatedpredicates"],["substs"]]]],[11,"instantiate_identity","","",705,[[["self"],["tyctxt"]],["instantiatedpredicates"]]],[11,"instantiate_identity_into","","",705,[[["self"],["tyctxt"],["instantiatedpredicates"]]]],[11,"instantiate_supertrait","","",705,[[["self"],["tyctxt"],["polytraitref"]],["instantiatedpredicates"]]],[11,"clone","","",739,[[["self"]],["predicate"]]],[11,"eq","","",739,[[["self"],["predicate"]],["bool"]]],[11,"ne","","",739,[[["self"],["predicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",739,N],[11,"hash","","",739,N],[11,"encode","","",739,[[["self"],["__s"]],["result"]]],[11,"decode","","",739,[[["__d"]],["result",["predicate"]]]],[11,"as_ref","","",739,[[["self"]],["predicate"]]],[11,"subst_supertrait","","Performs a substitution suitable for going from a poly-trait-ref to supertraits that must hold if that poly-trait-ref holds. This is slightly different from a normal substitution in terms of what happens with bound regions.  See lengthy comment below for details.",739,[[["self"],["tyctxt"],["polytraitref"]],["predicate"]]],[11,"clone","","",707,[[["self"]],["traitpredicate"]]],[11,"eq","","",707,[[["self"],["traitpredicate"]],["bool"]]],[11,"ne","","",707,[[["self"],["traitpredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",707,N],[11,"hash","","",707,N],[11,"encode","","",707,[[["self"],["__s"]],["result"]]],[11,"decode","","",707,[[["__d"]],["result",["traitpredicate"]]]],[11,"def_id","","",707,[[["self"]],["defid"]]],[11,"input_types","","",707,[[["self"]],[""]]],[11,"self_ty","","",707,[[["self"]],["ty"]]],[11,"def_id","","",1039,[[["self"]],["defid"]]],[11,"clone","","",708,[[["self"]],["outlivespredicate"]]],[11,"eq","","",708,[[["self"],["outlivespredicate"]],["bool"]]],[11,"ne","","",708,[[["self"],["outlivespredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",708,N],[11,"partial_cmp","","",708,[[["self"],["outlivespredicate"]],["option",["ordering"]]]],[11,"lt","","",708,[[["self"],["outlivespredicate"]],["bool"]]],[11,"le","","",708,[[["self"],["outlivespredicate"]],["bool"]]],[11,"gt","","",708,[[["self"],["outlivespredicate"]],["bool"]]],[11,"ge","","",708,[[["self"],["outlivespredicate"]],["bool"]]],[11,"cmp","","",708,[[["self"],["outlivespredicate"]],["ordering"]]],[11,"hash","","",708,N],[11,"fmt","","",708,[[["self"],["formatter"]],["result"]]],[11,"encode","","",708,[[["self"],["__sab"]],["result"]]],[11,"decode","","",708,[[["__dab"]],["result",["outlivespredicate"]]]],[11,"clone","","",709,[[["self"]],["subtypepredicate"]]],[11,"eq","","",709,[[["self"],["subtypepredicate"]],["bool"]]],[11,"ne","","",709,[[["self"],["subtypepredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",709,N],[11,"hash","","",709,N],[11,"fmt","","",709,[[["self"],["formatter"]],["result"]]],[11,"encode","","",709,[[["self"],["__s"]],["result"]]],[11,"decode","","",709,[[["__d"]],["result",["subtypepredicate"]]]],[11,"clone","","",710,[[["self"]],["projectionpredicate"]]],[11,"eq","","",710,[[["self"],["projectionpredicate"]],["bool"]]],[11,"ne","","",710,[[["self"],["projectionpredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",710,N],[11,"hash","","",710,N],[11,"encode","","",710,[[["self"],["__s"]],["result"]]],[11,"decode","","",710,[[["__d"]],["result",["projectionpredicate"]]]],[11,"item_def_id","","Returns the def-id of the associated item being projected.",1040,[[["self"]],["defid"]]],[11,"to_poly_trait_ref","","",1040,[[["self"],["tyctxt"]],["polytraitref"]]],[11,"ty","","",1040,[[["self"]],["binder",["ty"]]]],[11,"projection_def_id","","The DefId of the TraitItem for the associated type.",1040,[[["self"]],["defid"]]],[11,"to_poly_trait_ref","","",674,[[["self"]],["polytraitref"]]],[11,"to_poly_trait_ref","","",1039,[[["self"]],["polytraitref"]]],[11,"to_predicate","","",674,[[["self"]],["predicate"]]],[11,"to_predicate","","",1031,[[["self"]],["predicate"]]],[11,"to_predicate","","",1041,[[["self"]],["predicate"]]],[11,"to_predicate","","",1042,[[["self"]],["predicate"]]],[11,"to_predicate","","",1040,[[["self"]],["predicate"]]],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all cases this is skipping over a binder, so late-bound regions with depth 0 are bound by the predicate.",739,[[["self"]],["intoiter",["ty"]]]],[11,"to_opt_poly_trait_ref","","",739,[[["self"]],["option",["polytraitref"]]]],[11,"to_opt_type_outlives","","",739,[[["self"]],["option",["polytypeoutlivespredicate"]]]],[11,"clone","","",711,[[["self"]],["instantiatedpredicates"]]],[11,"empty","","",711,[[],["instantiatedpredicates"]]],[11,"is_empty","","",711,[[["self"]],["bool"]]],[11,"clone","","",712,[[["self"]],["universeindex"]]],[11,"eq","","",712,[[["self"],["universeindex"]],["bool"]]],[11,"ne","","",712,[[["self"],["universeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",712,N],[11,"partial_cmp","","",712,[[["self"],["universeindex"]],["option",["ordering"]]]],[11,"lt","","",712,[[["self"],["universeindex"]],["bool"]]],[11,"le","","",712,[[["self"],["universeindex"]],["bool"]]],[11,"gt","","",712,[[["self"],["universeindex"]],["bool"]]],[11,"ge","","",712,[[["self"],["universeindex"]],["bool"]]],[11,"cmp","","",712,[[["self"],["universeindex"]],["ordering"]]],[11,"hash","","",712,N],[11,"encode","","",712,[[["self"],["__s"]],["result"]]],[11,"decode","","",712,[[["__d"]],["result",["universeindex"]]]],[18,"ROOT","","The root universe, where things that the user defined are visible.",712,N],[18,"MAX","","The \"max universe\" -- this isn't really a valid universe, but it's useful sometimes as a \"starting value\" when you are taking the minimum of a (non-empty!) set of universes.",712,N],[11,"from_u32","","Creates a universe index from the given integer.  Not to be used lightly lest you pick a bad value. But sometimes we convert universe indicies into integers and back for various reasons.",712,[[["u32"]],["self"]]],[11,"subuniverse","","A \"subuniverse\" corresponds to being inside a `forall` quantifier. So, for example, suppose we have this type in universe `U`:",712,[[["self"]],["universeindex"]]],[11,"is_subset_of","","True if the names in this universe are a subset of the names in `other`.",712,[[["self"],["universeindex"]],["bool"]]],[11,"as_u32","","",712,[[["self"]],["u32"]]],[11,"as_usize","","",712,[[["self"]],["usize"]]],[11,"fmt","","",712,[[["self"],["formatter"]],["result"]]],[11,"from","","",712,[[["u32"]],["self"]]],[11,"clone","","",713,[[["self"]],["paramenv"]]],[11,"fmt","","",713,[[["self"],["formatter"]],["result"]]],[11,"eq","","",713,[[["self"],["paramenv"]],["bool"]]],[11,"ne","","",713,[[["self"],["paramenv"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",713,N],[11,"hash","","",713,N],[11,"empty","","Construct a trait environment suitable for contexts where there are no where clauses in scope. Hidden types (like `impl Trait`) are left hidden, so this is suitable for ordinary type-checking.",713,[[],["self"]]],[11,"reveal_all","","Construct a trait environment with no where clauses in scope where the values of all `impl Trait` and other hidden types are revealed. This is suitable for monomorphized, post-typeck environments like codegen or doing optimizations.",713,[[],["self"]]],[11,"new","","Construct a trait environment with the given set of predicates.",713,[[["slice"],["reveal"]],["self"]]],[11,"with_reveal_all","","Returns a new parameter environment with the same clauses, but which \"reveals\" the true results of projections in all cases (even for associated types that are specializable).  This is the desired behavior during codegen and certain other special contexts; normally though we want to use `Reveal::UserFacing`, which is the default.",713,[[["self"]],["self"]]],[11,"without_caller_bounds","","Returns this same environment but with no caller bounds.",713,[[["self"]],["self"]]],[11,"and","","Creates a suitable environment in which to perform trait queries on the given value. When type-checking, this is simply the pair of the environment plus value. But when reveal is set to All, then if `value` does not reference any type parameters, we will pair it with the empty environment. This improves caching and is generally invisible.",713,[[["self"],["t"]],["paramenvand"]]],[11,"clone","","",714,[[["self"]],["paramenvand"]]],[11,"fmt","","",714,[[["self"],["formatter"]],["result"]]],[11,"eq","","",714,[[["self"],["paramenvand"]],["bool"]]],[11,"ne","","",714,[[["self"],["paramenvand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",714,N],[11,"hash","","",714,N],[11,"into_parts","","",714,N],[11,"hash_stable","","",714,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",715,[[["self"]],["destructor"]]],[11,"fmt","","",715,[[["self"],["formatter"]],["result"]]],[11,"eq","","",716,[[["self"],["adtflags"]],["bool"]]],[11,"ne","","",716,[[["self"],["adtflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",716,N],[11,"clone","","",716,[[["self"]],["adtflags"]]],[11,"partial_cmp","","",716,[[["self"],["adtflags"]],["option",["ordering"]]]],[11,"lt","","",716,[[["self"],["adtflags"]],["bool"]]],[11,"le","","",716,[[["self"],["adtflags"]],["bool"]]],[11,"gt","","",716,[[["self"],["adtflags"]],["bool"]]],[11,"ge","","",716,[[["self"],["adtflags"]],["bool"]]],[11,"cmp","","",716,[[["self"],["adtflags"]],["ordering"]]],[11,"hash","","",716,N],[11,"fmt","","",716,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",716,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",716,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",716,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",716,[[["self"],["formatter"]],["result"]]],[18,"NO_ADT_FLAGS","","",716,N],[18,"IS_ENUM","","",716,N],[18,"IS_PHANTOM_DATA","","",716,N],[18,"IS_FUNDAMENTAL","","",716,N],[18,"IS_UNION","","",716,N],[18,"IS_BOX","","",716,N],[18,"IS_NON_EXHAUSTIVE","","Indicates whether this abstract data type will be expanded on in future (new fields/variants) and as such, whether downstream crates must match exhaustively on the fields/variants of this data type.",716,N],[11,"empty","","Returns an empty set of flags.",716,[[],["adtflags"]]],[11,"all","","Returns the set containing all flags.",716,[[],["adtflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",716,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",716,[[["u32"]],["option",["adtflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",716,[[["u32"]],["adtflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",716,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",716,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",716,[[["self"],["adtflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",716,[[["self"],["adtflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",716,[[["self"],["adtflags"]]]],[11,"remove","","Removes the specified flags in-place.",716,[[["self"],["adtflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",716,[[["self"],["adtflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",716,[[["self"],["adtflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",716,[[["self"],["adtflags"]],["adtflags"]]],[11,"bitor_assign","","Adds the set of flags.",716,[[["self"],["adtflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",716,[[["self"],["adtflags"]],["adtflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",716,[[["self"],["adtflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",716,[[["self"],["adtflags"]],["adtflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",716,[[["self"],["adtflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",716,[[["self"],["adtflags"]],["adtflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",716,[[["self"],["adtflags"]]]],[11,"not","","Returns the complement of this set of flags.",716,[[["self"]],["adtflags"]]],[11,"extend","","",716,[[["self"],["t"]]]],[11,"from_iter","","",716,[[["t"]],["adtflags"]]],[11,"fmt","","",717,[[["self"],["formatter"]],["result"]]],[11,"clone","","",740,[[["self"]],["variantdiscr"]]],[11,"fmt","","",740,[[["self"],["formatter"]],["result"]]],[11,"eq","","",740,[[["self"],["variantdiscr"]],["bool"]]],[11,"ne","","",740,[[["self"],["variantdiscr"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",740,N],[11,"encode","","",740,[[["self"],["__s"]],["result"]]],[11,"decode","","",740,[[["__d"]],["result",["variantdiscr"]]]],[11,"fmt","","",718,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",719,[[["self"],["adtdef"]],["option",["ordering"]]]],[11,"cmp","","",719,[[["self"],["adtdef"]],["ordering"]]],[11,"eq","","",719,[[["self"],["self"]],["bool"]]],[11,"hash","","",719,[[["self"],["h"]]]],[11,"hash_stable","","",719,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",741,[[["self"]],["adtkind"]]],[11,"fmt","","",741,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",741,N],[11,"eq","","",741,[[["self"],["adtkind"]],["bool"]]],[11,"hash","","",741,N],[11,"eq","","",720,[[["self"],["reprflags"]],["bool"]]],[11,"ne","","",720,[[["self"],["reprflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",720,N],[11,"clone","","",720,[[["self"]],["reprflags"]]],[11,"partial_cmp","","",720,[[["self"],["reprflags"]],["option",["ordering"]]]],[11,"lt","","",720,[[["self"],["reprflags"]],["bool"]]],[11,"le","","",720,[[["self"],["reprflags"]],["bool"]]],[11,"gt","","",720,[[["self"],["reprflags"]],["bool"]]],[11,"ge","","",720,[[["self"],["reprflags"]],["bool"]]],[11,"cmp","","",720,[[["self"],["reprflags"]],["ordering"]]],[11,"hash","","",720,N],[11,"encode","","",720,[[["self"],["__s"]],["result"]]],[11,"decode","","",720,[[["__d"]],["result",["reprflags"]]]],[11,"default","","",720,[[],["reprflags"]]],[11,"fmt","","",720,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",720,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",720,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",720,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",720,[[["self"],["formatter"]],["result"]]],[18,"IS_C","","",720,N],[18,"IS_SIMD","","",720,N],[18,"IS_TRANSPARENT","","",720,N],[18,"IS_LINEAR","","",720,N],[18,"IS_UNOPTIMISABLE","","",720,N],[11,"empty","","Returns an empty set of flags.",720,[[],["reprflags"]]],[11,"all","","Returns the set containing all flags.",720,[[],["reprflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",720,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",720,[[["u8"]],["option",["reprflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",720,[[["u8"]],["reprflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",720,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",720,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",720,[[["self"],["reprflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",720,[[["self"],["reprflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",720,[[["self"],["reprflags"]]]],[11,"remove","","Removes the specified flags in-place.",720,[[["self"],["reprflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",720,[[["self"],["reprflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",720,[[["self"],["reprflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",720,[[["self"],["reprflags"]],["reprflags"]]],[11,"bitor_assign","","Adds the set of flags.",720,[[["self"],["reprflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",720,[[["self"],["reprflags"]],["reprflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",720,[[["self"],["reprflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",720,[[["self"],["reprflags"]],["reprflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",720,[[["self"],["reprflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",720,[[["self"],["reprflags"]],["reprflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",720,[[["self"],["reprflags"]]]],[11,"not","","Returns the complement of this set of flags.",720,[[["self"]],["reprflags"]]],[11,"extend","","",720,[[["self"],["t"]]]],[11,"from_iter","","",720,[[["t"]],["reprflags"]]],[11,"hash_stable","","",720,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",721,[[["self"]],["reproptions"]]],[11,"assert_receiver_is_total_eq","","",721,N],[11,"eq","","",721,[[["self"],["reproptions"]],["bool"]]],[11,"ne","","",721,[[["self"],["reproptions"]],["bool"]]],[11,"encode","","",721,[[["self"],["__s"]],["result"]]],[11,"decode","","",721,[[["__d"]],["result",["reproptions"]]]],[11,"default","","",721,[[],["reproptions"]]],[11,"hash_stable","","",721,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",721,[[["tyctxt"],["defid"]],["reproptions"]]],[11,"simd","","",721,[[["self"]],["bool"]]],[11,"c","","",721,[[["self"]],["bool"]]],[11,"packed","","",721,[[["self"]],["bool"]]],[11,"transparent","","",721,[[["self"]],["bool"]]],[11,"linear","","",721,[[["self"]],["bool"]]],[11,"discr_type","","",721,[[["self"]],["inttype"]]],[11,"inhibit_enum_layout_opt","","Returns true if this `#[repr()]` should inhabit \"smart enum layout\" optimizations, such as representing `Foo<&T>` as a single pointer.",721,[[["self"]],["bool"]]],[11,"inhibit_struct_field_reordering_opt","","Returns true if this `#[repr()]` should inhibit struct field reordering optimizations, such as with repr(C) or repr(packed(1)).",721,[[["self"]],["bool"]]],[11,"new","","",719,[[["tyctxt"],["defid"],["adtkind"],["vec",["variantdef"]],["reproptions"]],["self"]]],[11,"is_struct","","",719,[[["self"]],["bool"]]],[11,"is_union","","",719,[[["self"]],["bool"]]],[11,"is_enum","","",719,[[["self"]],["bool"]]],[11,"is_non_exhaustive","","",719,[[["self"]],["bool"]]],[11,"adt_kind","","Returns the kind of the ADT - Struct or Enum.",719,[[["self"]],["adtkind"]]],[11,"descr","","",719,[[["self"]],["str"]]],[11,"variant_descr","","",719,[[["self"]],["str"]]],[11,"is_fundamental","","Returns whether this type is #[fundamental] for the purposes of coherence checking.",719,[[["self"]],["bool"]]],[11,"is_phantom_data","","Returns true if this is PhantomData.",719,[[["self"]],["bool"]]],[11,"is_box","","Returns true if this is Box.",719,[[["self"]],["bool"]]],[11,"has_dtor","","Returns whether this type has a destructor.",719,[[["self"],["tyctxt"]],["bool"]]],[11,"non_enum_variant","","Asserts this is a struct or union and returns its unique variant.",719,[[["self"]],["variantdef"]]],[11,"predicates","","",719,[[["self"],["tyctxt"]],["genericpredicates"]]],[11,"all_fields","","Returns an iterator over all fields contained by this ADT.",719,[[["self"]],[""]]],[11,"is_payloadfree","","",719,[[["self"]],["bool"]]],[11,"variant_with_id","","",719,[[["self"],["defid"]],["variantdef"]]],[11,"variant_index_with_id","","",719,[[["self"],["defid"]],["usize"]]],[11,"variant_of_def","","",719,[[["self"],["def"]],["variantdef"]]],[11,"eval_explicit_discr","","",719,[[["self"],["tyctxt"],["defid"]],["option",["discr"]]]],[11,"discriminants","","",719,[[["self"],["tyctxt"]],[""]]],[11,"discriminant_for_variant","","Compute the discriminant value used by a specific variant. Unlike `discriminants`, this is (amortized) constant-time, only doing at most one query for evaluating an explicit discriminant (the last one before the requested variant), assuming there are no constant-evaluation errors there.",719,[[["self"],["tyctxt"],["usize"]],["discr"]]],[11,"discriminant_def_for_variant","","Yields a DefId for the discriminant and an offset to add to it Alternatively, if there is no explicit discriminant, returns the inferred discriminant directly",719,N],[11,"destructor","","",719,[[["self"],["tyctxt"]],["option",["destructor"]]]],[11,"sized_constraint","","Returns a list of types such that `Self: Sized` if and only if that type is Sized, or `TyErr` if this type is recursive.",719,N],[11,"sized_constraint_for_ty","","",719,[[["self"],["tyctxt"],["ty"]],["vec",["ty"]]]],[11,"ty","","",718,[[["self"],["tyctxt"],["substs"]],["ty"]]],[11,"clone","","",742,[[["self"]],["closurekind"]]],[11,"partial_cmp","","",742,[[["self"],["closurekind"]],["option",["ordering"]]]],[11,"cmp","","",742,[[["self"],["closurekind"]],["ordering"]]],[11,"eq","","",742,[[["self"],["closurekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",742,N],[11,"hash","","",742,N],[11,"fmt","","",742,[[["self"],["formatter"]],["result"]]],[11,"encode","","",742,[[["self"],["__s"]],["result"]]],[11,"decode","","",742,[[["__d"]],["result",["closurekind"]]]],[18,"LATTICE_BOTTOM","","",742,N],[11,"trait_did","","",742,[[["self"],["tyctxt"]],["defid"]]],[11,"extends","","True if this a type that impls this closure kind must also implement `other`.",742,[[["self"],["closurekind"]],["bool"]]],[11,"to_ty","","Returns the representative scalar type for this closure kind. See `TyS::to_opt_closure_kind` for more details.",742,[[["self"],["tyctxt"]],["ty"]]],[11,"walk","","Iterator that walks `self` and any types reachable from `self`, in depth-first order. Note that just walks the types that appear in `self`, it does not descend into the fields of structs or variants. For example:",696,[[["self"]],["typewalker"]]],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence `Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]` (but not `i32`, like `walk`).",696,[[["self"]],["accintoiter",["typewalkerarray"]]]],[11,"maybe_walk","","Walks `ty` and any types appearing within `ty`, invoking the callback `f` on each type. If the callback returns false, then the children of the current type are ignored.",696,[[["self"],["f"]]]],[11,"from_mutbl","","",735,[[["mutability"]],["borrowkind"]]],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow kind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a mutability that is stronger than necessary so that it at least would permit the borrow in question.",735,[[["self"]],["mutability"]]],[11,"to_user_str","","",735,[[["self"]],["str"]]],[11,"fmt","","",743,[[["self"],["formatter"]],["result"]]],[11,"clone","","",743,[[["self"]],["attributes"]]],[11,"deref","","",743,N],[11,"body_tables","","",684,[[["self"],["bodyid"]],["typecktables"]]],[11,"body_owners","","Returns an iterator of the def-ids for all body-owners in this crate. If you would prefer to iterate over the bodies themselves, you can do `self.hir.krate().body_ids.iter()`.",684,[[["self"]],[""]]],[11,"par_body_owners","","",684,[[["self"],["f"]]]],[11,"expr_span","","",684,[[["self"],["nodeid"]],["span"]]],[11,"provided_trait_methods","","",684,[[["self"],["defid"]],["vec",["associateditem"]]]],[11,"trait_relevant_for_never","","",684,[[["self"],["defid"]],["bool"]]],[11,"opt_associated_item","","",684,[[["self"],["defid"]],["option",["associateditem"]]]],[11,"associated_item_from_trait_item_ref","","",684,[[["self"],["defid"],["visibility"],["traititemref"]],["associateditem"]]],[11,"associated_item_from_impl_item_ref","","",684,[[["self"],["defid"],["implitemref"]],["associateditem"]]],[11,"field_index","","",684,[[["self"],["nodeid"],["typecktables"]],["usize"]]],[11,"find_field_index","","",684,[[["self"],["ident"],["variantdef"]],["option",["usize"]]]],[11,"associated_items","","",684,[[["self"],["defid"]],[""]]],[11,"impls_are_allowed_to_overlap","","Returns true if the impls are the same polarity and are implementing a trait which contains no items",684,[[["self"],["defid"],["defid"]],["bool"]]],[11,"expect_variant_def","","",684,[[["self"],["def"]],["variantdef"]]],[11,"adt_def_id_of_variant","","Given a `VariantDef`, returns the def-id of the `AdtDef` of which it is a part.",684,[[["self"],["variantdef"]],["defid"]]],[11,"item_name","","",684,[[["self"],["defid"]],["internedstring"]]],[11,"instance_mir","","Return the possibly-auto-generated MIR of a (DefId, Subst) pair.",684,[[["self"],["instancedef"]],["mir"]]],[11,"maybe_optimized_mir","","Given the DefId of an item, returns its MIR, borrowed immutably. Returns None if there is no MIR for the DefId",684,[[["self"],["defid"]],["option",["mir"]]]],[11,"get_attrs","","Get the attributes of a definition.",684,[[["self"],["defid"]],["attributes"]]],[11,"has_attr","","Determine whether an item is annotated with an attribute",684,[[["self"],["defid"],["str"]],["bool"]]],[11,"trait_is_auto","","Returns true if this is an `auto trait`.",684,[[["self"],["defid"]],["bool"]]],[11,"generator_layout","","",684,[[["self"],["defid"]],["generatorlayout"]]],[11,"trait_id_of_impl","","Given the def_id of an impl, return the def_id of the trait it implements. If it implements no trait, return `None`.",684,[[["self"],["defid"]],["option",["defid"]]]],[11,"impl_of_method","","If the given def ID describes a method belonging to an impl, return the ID of the impl that the method belongs to. Otherwise, return `None`.",684,[[["self"],["defid"]],["option",["defid"]]]],[11,"span_of_impl","","Looks up the span of `impl_did` if the impl is local; otherwise returns `Err` with the name of the crate containing the impl.",684,[[["self"],["defid"]],["result",["span","symbol"]]]],[11,"hygienic_eq","","",684,[[["self"],["ident"],["ident"],["defid"]],["bool"]]],[11,"adjust_ident","","",684,N],[11,"with_freevars","","",684,[[["self"],["nodeid"],["f"]],["t"]]],[11,"clone","","",722,[[["self"]],["crateinherentimpls"]]],[11,"fmt","","",722,[[["self"],["formatter"]],["result"]]],[11,"clone","","",723,[[["self"]],["symbolname"]]],[11,"eq","","",723,[[["self"],["symbolname"]],["bool"]]],[11,"ne","","",723,[[["self"],["symbolname"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",723,N],[11,"partial_cmp","","",723,[[["self"],["symbolname"]],["option",["ordering"]]]],[11,"lt","","",723,[[["self"],["symbolname"]],["bool"]]],[11,"le","","",723,[[["self"],["symbolname"]],["bool"]]],[11,"gt","","",723,[[["self"],["symbolname"]],["bool"]]],[11,"ge","","",723,[[["self"],["symbolname"]],["bool"]]],[11,"cmp","","",723,[[["self"],["symbolname"]],["ordering"]]],[11,"encode","","",723,[[["self"],["__s"]],["result"]]],[11,"decode","","",723,[[["__d"]],["result",["symbolname"]]]],[11,"hash_stable","","",723,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",723,[[["str"]],["symbolname"]]],[11,"as_str","","",723,[[["self"]],["localinternedstring"]]],[11,"fmt","","",723,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",723,[[["self"],["formatter"]],["result"]]],[0,"util","rustc","",N,N],[0,"captures","rustc::util","",N,N],[8,"Captures","rustc::util::captures","\"Signaling\" trait used in impl trait to tag lifetimes that you may need to capture but don't really need for other reasons. Basically a workaround; see [this comment] for details.",N,N],[0,"common","rustc::util","",N,N],[3,"ErrorReported","rustc::util::common","",N,N],[3,"DEFAULT_HOOK","","",N,N],[12,"__private_field","","",1043,N],[3,"ProfQDumpParams","","Parameters to the `Dump` variant of type `ProfileQueriesMsg`.",N,N],[12,"path","","A base path for the files we will dump",1044,N],[12,"ack","","To ensure that the compiler waits for us to finish our dumps",1044,N],[12,"dump_profq_msg_log","","toggle dumping a log file with every `ProfileQueriesMsg`",1044,N],[3,"QueryMsg","","",N,N],[12,"query","","",1045,N],[12,"msg","","",1045,N],[3,"Indenter","","",N,N],[12,"_cannot_construct_outside_of_this_module","","",1046,N],[4,"ProfileQueriesMsg","","A sequence of these messages induce a trace of query-based incremental compilation. FIXME(matthewhammer): Determine whether we should include cycle detection here or not.",N,N],[13,"TimeBegin","","begin a timed pass",1047,N],[13,"TimeEnd","","end a timed pass",1047,N],[13,"TaskBegin","","begin a task (see dep_graph::graph::with_task)",1047,N],[13,"TaskEnd","","end a task",1047,N],[13,"QueryBegin","","begin a new query can't use `Span` because queries are sent to other thread",1047,N],[13,"CacheHit","","query is satisfied by using an already-known value for the given key",1047,N],[13,"ProviderBegin","","query requires running a provider; providers may nest, permitting queries to nest.",1047,N],[13,"ProviderEnd","","query is satisfied by a provider terminating with a value",1047,N],[13,"Dump","","dump a record of the queries to the given path",1047,N],[13,"Halt","","halt the profiling/monitoring background thread",1047,N],[5,"panic_hook","","",N,[[["panicinfo"]]]],[5,"install_panic_hook","","",N,[[]]],[5,"profq_msg","","If enabled, send a message to the profile-queries thread",N,[[["session"],["profilequeriesmsg"]]]],[5,"profq_set_chan","","Set channel for profile queries channel",N,[[["session"],["sender",["profilequeriesmsg"]]],["bool"]]],[5,"time_depth","","Read the current depth of `time()` calls. This is used to encourage indentation across threads.",N,[[],["usize"]]],[5,"set_time_depth","","Set the current depth of `time()` calls. The idea is to call `set_time_depth()` with the result from `time_depth()` in the parent thread.",N,[[["usize"]]]],[5,"time","","",N,[[["session"],["str"],["f"]],["t"]]],[5,"time_ext","","",N,[[["bool"],["option",["session"]],["str"],["f"]],["t"]]],[5,"print_time_passes_entry","","",N,[[["bool"],["str"],["duration"]]]],[5,"print_time_passes_entry_internal","","",N,[[["str"],["duration"]]]],[5,"duration_to_secs_str","","",N,[[["duration"]],["string"]]],[5,"to_readable_str","","",N,[[["usize"]],["string"]]],[5,"record_time","","",N,[[["lock"],["f"]],["t"]]],[5,"get_resident","","",N,[[],["option",["usize"]]]],[5,"indent","","",N,[[["f"]],["r"]]],[5,"indenter","","",N,[[],["indenter"]]],[5,"path2cstr","","",N,[[["path"]],["cstring"]]],[7,"DEFAULT_HOOK","","",N,N],[17,"FN_OUTPUT_NAME","","",N,N],[17,"TIME_DEPTH","","",N,N],[8,"MemoizationMap","","",N,N],[16,"Key","","",1048,N],[16,"Value","","",1048,N],[10,"memoize","","If `key` is present in the map, return the value, otherwise invoke `op` and store the value in the map.",1048,N],[11,"clone","","",1049,[[["self"]],["errorreported"]]],[11,"fmt","","",1049,[[["self"],["formatter"]],["result"]]],[11,"encode","","",1049,[[["self"],["__s"]],["result"]]],[11,"decode","","",1049,[[["__d"]],["result",["errorreported"]]]],[11,"deref","","",1043,[[["self"]],["box"]]],[11,"initialize","","",1043,[[["self"]]]],[11,"clone","","",1044,[[["self"]],["profqdumpparams"]]],[11,"fmt","","",1044,[[["self"],["formatter"]],["result"]]],[11,"clone","","",1045,[[["self"]],["querymsg"]]],[11,"fmt","","",1045,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1045,[[["self"],["querymsg"]],["bool"]]],[11,"ne","","",1045,[[["self"],["querymsg"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1045,N],[11,"clone","","",1047,[[["self"]],["profilequeriesmsg"]]],[11,"fmt","","",1047,[[["self"],["formatter"]],["result"]]],[11,"drop","","",1046,[[["self"]]]],[0,"ppaux","rustc::util","",N,N],[3,"LateBoundRegionNameCollector","rustc::util::ppaux","",N,N],[12,"0","","",1050,N],[3,"PrintContext","","",N,N],[12,"is_debug","","",1051,N],[12,"is_verbose","","",1051,N],[12,"identify_regions","","",1051,N],[12,"used_region_names","","",1051,N],[12,"region_index","","",1051,N],[12,"binder_depth","","",1051,N],[5,"verbose","","",N,[[],["bool"]]],[5,"identify_regions","","",N,[[],["bool"]]],[5,"parameterized","","",N,N],[5,"get_highlight_region","","",N,[[],["option"]]],[5,"with_highlight_region","","",N,N],[17,"HIGHLIGHT_REGION","","Mechanism for highlighting of specific regions for display in NLL region inference errors. Contains region to highlight and counter for number to use when highlighting.",N,N],[8,"Print","","",N,N],[10,"print","","",1052,[[["self"],["f"],["printcontext"]],["result"]]],[11,"print_to_string","","",1052,[[["self"],["printcontext"]],["string"]]],[11,"print_display","","",1052,[[["self"],["f"],["printcontext"]],["result"]]],[11,"print_display_to_string","","",1052,[[["self"],["printcontext"]],["string"]]],[11,"print_debug","","",1052,[[["self"],["f"],["printcontext"]],["result"]]],[11,"print_debug_to_string","","",1052,[[["self"],["printcontext"]],["string"]]],[11,"visit_region","","",1050,[[["self"],["region"]],["bool"]]],[11,"fmt","","",1051,[[["self"],["formatter"]],["result"]]],[11,"new","","",1051,[[],["self"]]],[11,"prepare_late_bound_region_info","","",1051,[[["self"],["binder"]]]],[11,"fn_sig","","",1051,N],[11,"parameterized","","",1051,N],[11,"in_binder","","",1051,[[["self"],["f"],["tyctxt"],["binder"],["option",["binder"]]],["result"]]],[11,"is_name_used","","",1051,[[["self"],["internedstring"]],["bool"]]],[11,"fmt","rustc::ty","",702,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustc::ty::trait_def","",1009,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustc::ty","",719,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",700,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",698,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",699,[[["self"],["formatter"]],["result"]]],[11,"print","","",673,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",673,[[["self"],["formatter"]],["result"]]],[11,"print","","",675,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",675,[[["self"],["formatter"]],["result"]]],[11,"print","rustc::ty::adjustment","",745,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",745,[[["self"],["formatter"]],["result"]]],[11,"print","rustc::ty","",728,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",728,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",728,[[["self"],["formatter"]],["result"]]],[11,"print","","",729,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",729,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",729,[[["self"],["formatter"]],["result"]]],[11,"print","","",679,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",679,[[["self"],["formatter"]],["result"]]],[11,"print","","",734,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",734,[[["self"],["formatter"]],["result"]]],[11,"print","","",705,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",705,[[["self"],["formatter"]],["result"]]],[11,"print","","",711,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",711,[[["self"],["formatter"]],["result"]]],[11,"print","","",667,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",667,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",667,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",680,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",681,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",682,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",683,[[["self"],["formatter"]],["result"]]],[11,"print","","",724,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",724,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",724,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",737,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",701,[[["self"],["formatter"]],["result"]]],[11,"print","","",664,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"print","","",664,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"print","","",664,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"print","","",664,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"print","","",664,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"print","","",664,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"print","","",664,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"print","","",664,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"print","","",674,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",674,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",674,[[["self"],["formatter"]],["result"]]],[11,"print","","",727,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",727,[[["self"],["formatter"]],["result"]]],[11,"print","","",696,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",696,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",696,[[["self"],["formatter"]],["result"]]],[11,"print","","",669,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",669,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",669,[[["self"],["formatter"]],["result"]]],[11,"print","","",708,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",708,[[["self"],["formatter"]],["result"]]],[11,"print","","",709,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",709,[[["self"],["formatter"]],["result"]]],[11,"print","","",707,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",707,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",707,[[["self"],["formatter"]],["result"]]],[11,"print","","",710,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",710,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",710,[[["self"],["formatter"]],["result"]]],[11,"print","","",670,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",670,[[["self"],["formatter"]],["result"]]],[11,"print","","",742,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",742,[[["self"],["formatter"]],["result"]]],[11,"print","","",739,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",739,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",739,[[["self"],["formatter"]],["result"]]],[0,"nodemap","rustc::util","An efficient hash map for node IDs",N,N],[6,"FxHashMap","rustc::util::nodemap","Type alias for a hashmap using the `fx` hash algorithm.",N,N],[5,"FxHashMap","","",N,[[],["hashmap",["buildhasherdefault"]]]],[6,"FxHashSet","","Type alias for a hashmap using the `fx` hash algorithm.",N,N],[5,"FxHashSet","","",N,[[],["hashset",["buildhasherdefault"]]]],[5,"NodeMap","","",N,[[],["nodemap"]]],[5,"NodeSet","","",N,[[],["nodeset"]]],[5,"DefIdMap","","",N,[[],["defidmap"]]],[5,"DefIdSet","","",N,[[],["defidset"]]],[5,"HirIdMap","","",N,[[],["hiridmap"]]],[5,"HirIdSet","","",N,[[],["hiridset"]]],[5,"ItemLocalMap","","",N,[[],["itemlocalmap"]]],[5,"ItemLocalSet","","",N,[[],["itemlocalset"]]],[6,"NodeMap","","",N,N],[6,"NodeSet","","",N,N],[6,"DefIdMap","","",N,N],[6,"DefIdSet","","",N,N],[6,"HirIdMap","","",N,N],[6,"HirIdSet","","",N,N],[6,"ItemLocalMap","","",N,N],[6,"ItemLocalSet","","",N,N],[0,"fs","rustc::util","",N,N],[4,"LinkOrCopy","rustc::util::fs","",N,N],[13,"Link","","",1053,N],[13,"Copy","","",1053,N],[4,"RenameOrCopyRemove","","",N,N],[13,"Rename","","",1054,N],[13,"CopyRemove","","",1054,N],[5,"fix_windows_verbatim_for_gcc","","",N,[[["path"]],["pathbuf"]]],[5,"link_or_copy","","Copy `p` into `q`, preferring to use hard-linking if possible. If `q` already exists, it is removed first. The result indicates which of the two operations has been performed.",N,[[["p"],["q"]],["result",["linkorcopy"]]]],[5,"rename_or_copy_remove","","Rename `p` into `q`, preferring to use `rename` if possible. If `rename` fails (rename may fail for reasons such as crossing filesystem), fallback to copy & remove",N,[[["p"],["q"]],["result",["renameorcopyremove"]]]],[11,"fmt","","",1054,[[["self"],["formatter"]],["result"]]],[0,"time_graph","rustc::util","",N,N],[3,"Timing","rustc::util::time_graph","",N,N],[12,"start","","",1055,N],[12,"end","","",1055,N],[12,"work_package_kind","","",1055,N],[12,"name","","",1055,N],[12,"events","","",1055,N],[3,"TimelineId","","",N,N],[12,"0","","",1056,N],[3,"PerThread","","",N,N],[12,"timings","","",1057,N],[12,"open_work_package","","",1057,N],[3,"TimeGraph","","",N,N],[12,"data","","",1058,N],[3,"WorkPackageKind","","",N,N],[12,"0","","",1059,N],[3,"Timeline","","",N,N],[12,"token","","",1060,N],[3,"RaiiToken","","",N,N],[12,"graph","","",1061,N],[12,"timeline","","",1061,N],[12,"events","","",1061,N],[12,"_marker","","",1061,N],[5,"distance","","",N,[[["instant"],["instant"]],["u64"]]],[5,"normalize","","",N,[[["u64"],["u64"],["u64"]],["u64"]]],[17,"OUTPUT_WIDTH_IN_PX","","",N,N],[17,"TIME_LINE_HEIGHT_IN_PX","","",N,N],[17,"TIME_LINE_HEIGHT_STRIDE_IN_PX","","",N,N],[11,"clone","","",1055,[[["self"]],["timing"]]],[11,"clone","","",1056,[[["self"]],["timelineid"]]],[11,"hash","","",1056,N],[11,"assert_receiver_is_total_eq","","",1056,N],[11,"eq","","",1056,[[["self"],["timelineid"]],["bool"]]],[11,"ne","","",1056,[[["self"],["timelineid"]],["bool"]]],[11,"fmt","","",1056,[[["self"],["formatter"]],["result"]]],[11,"clone","","",1057,[[["self"]],["perthread"]]],[11,"clone","","",1058,[[["self"]],["timegraph"]]],[11,"clone","","",1059,[[["self"]],["workpackagekind"]]],[11,"drop","","",1061,[[["self"]]]],[11,"new","","",1058,[[],["timegraph"]]],[11,"start","","",1058,[[["self"],["timelineid"],["workpackagekind"],["str"]],["timeline"]]],[11,"end","","",1058,[[["self"],["timelineid"],["vec"]]]],[11,"dump","","",1058,[[["self"],["str"]]]],[11,"noop","","",1060,[[],["timeline"]]],[11,"record","","Record an event which happened at this moment on this timeline.",1060,[[["self"],["str"]]]],[0,"rustc","rustc","",N,N],[17,"DIAGNOSTICS","","",N,N],[14,"bug","","",N,N],[14,"span_bug","","",N,N],[14,"__impl_stable_hash_field","","",N,N],[14,"impl_stable_hash_for","","",N,N],[14,"impl_stable_hash_for_spanned","","",N,N],[14,"CloneLiftImpls","","",N,N],[14,"CloneTypeFoldableImpls","","Used for types that are `Copy` and which do not care arena allocated data (i.e., don't need to be folded).",N,N],[14,"CloneTypeFoldableAndLiftImpls","","",N,N],[14,"BraceStructLiftImpl","","",N,N],[14,"EnumLiftImpl","","",N,N],[14,"BraceStructTypeFoldableImpl","","",N,N],[14,"TupleStructTypeFoldableImpl","","",N,N],[14,"EnumTypeFoldableImpl","","",N,N],[14,"declare_lint","","Declare a static item of type `&'static Lint`.",N,N],[14,"lint_array","","Declare a static `LintArray` and return it as an expression.",N,N],[14,"late_lint_methods","","",N,N],[14,"expand_combined_late_lint_pass_method","","",N,N],[14,"expand_combined_late_lint_pass_methods","","",N,N],[14,"declare_combined_late_lint_pass","","",N,N],[14,"err","","",N,N],[14,"__impl_decoder_methods","","",N,N],[14,"implement_ty_decoder","","",N,N],[11,"to_dep_node","rustc::hir::map::definitions","",186,[[["self"],["depkind"]],["depnode"]]],[11,"to_dep_node","rustc::hir::def_id","",147,[[["self"],["tyctxt"],["depkind"]],["depnode"]]],[11,"to_fingerprint","","",147,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"to_debug_str","","",147,[[["self"],["tyctxt"]],["string"]]],[11,"to_fingerprint","","",146,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"to_debug_str","","",146,[[["self"],["tyctxt"]],["string"]]],[11,"to_fingerprint","","",145,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"to_debug_str","","",145,[[["self"],["tyctxt"]],["string"]]],[11,"to_fingerprint","rustc::hir","",33,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"print_node","rustc::hir::print","",194,[[["self"],["node"]],["result"]]],[11,"get_stable_hashing_context","rustc::ty","",684,[[["self"]],["stablehashingcontext"]]],[11,"hash_stable","rustc::middle::cstore","",340,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",343,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",336,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",337,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",342,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",338,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",345,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",335,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::lang_items","",370,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",368,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir","",453,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",432,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",459,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",461,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",435,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",436,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",438,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",451,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",452,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",460,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",475,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",439,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",458,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",433,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",437,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",444,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",445,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",449,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",463,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",440,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",464,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",441,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",465,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",466,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",443,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",467,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",446,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",447,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",457,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",468,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",469,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",470,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",471,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",472,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",474,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",473,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",448,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",450,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",454,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",455,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",456,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",476,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir::interpret","",482,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::session::search_paths","",557,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::subst","",1004,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",1006,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",729,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",683,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",665,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::adjustment","",751,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",748,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",745,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",746,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",699,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::adjustment","",749,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",750,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",698,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",735,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",736,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",668,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",667,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",664,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",742,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",733,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",674,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",707,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",709,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",708,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",710,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",670,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",739,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",716,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",717,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",740,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",718,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir::interpret","",494,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",493,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",483,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",484,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",499,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",488,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",492,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",677,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir::interpret","",479,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",480,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",671,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",672,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",705,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir::interpret","",478,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",491,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",495,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",481,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",496,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",734,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::adjustment","",752,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",704,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",702,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",738,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::resolve_lifetime","",418,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",415,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",417,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::cast","",756,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::region","",403,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",401,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",401,[[["self"],["stablehashingcontext"]],["scope"]]],[11,"hash_stable","","",402,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::adjustment","",747,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",679,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",728,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",727,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",724,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",680,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",681,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",682,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",669,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",673,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",725,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",675,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",676,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",688,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",730,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::trait_def","",1009,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",715,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",693,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",706,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",692,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",732,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",731,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::steal","",1003,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",713,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::traits","",586,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::privacy","",397,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",396,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",722,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::session","",529,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::util::common","",1049,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::reachable","",400,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::traits","",603,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",578,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",581,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",583,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",582,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",580,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",584,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",579,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::infer::canonical","",226,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",227,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",228,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",230,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",231,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",229,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",232,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::traits","",594,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",595,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",596,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",597,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",599,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",576,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",600,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",598,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::layout","",794,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_trace","rustc::ty","",1062,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"to_trace","rustc::ty::sty","",1063,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"to_trace","rustc::ty","",674,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"to_trace","rustc::ty::sty","",1031,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"compare","rustc::ty::relate","",1064,[[["self"],["t"],["f"]],["relateresult"]]],[11,"note_and_explain_region","rustc::ty","",684,[[["self"],["scopetree"],["diagnosticbuilder"],["str"],["region"],["str"]]]],[11,"note_and_explain_free_region","","",684,[[["self"],["diagnosticbuilder"],["str"],["region"],["str"]]]],[11,"msg_span_from_free_region","","",684,N],[11,"msg_span_from_early_bound_and_free_regions","","",684,N],[11,"emit_msg_span","","",684,[[["diagnosticbuilder"],["str"],["string"],["option",["span"]],["str"]]]],[11,"item_scope_tag","","",684,[[["item"]],["str"]]],[11,"trait_item_scope_tag","","",684,[[["traititem"]],["str"]]],[11,"impl_item_scope_tag","","",684,[[["implitem"]],["str"]]],[11,"explain_span","","",684,N],[11,"as_failure_code","rustc::traits","",574,[[["self"],["typeerror"]],["failurecode"]]],[11,"as_requirement_str","","",574,[[["self"]],["str"]]],[11,"index","rustc::ty","",680,[[["self"]],["u32"]]],[11,"from_index","","",680,[[["u32"]],["tyvid"]]],[11,"tag","","",680,[[],["str"]]],[11,"index","","",681,[[["self"]],["u32"]]],[11,"from_index","","",681,[[["u32"]],["intvid"]]],[11,"tag","","",681,[[],["str"]]],[11,"index","","",683,[[["self"]],["u32"]]],[11,"from_index","","",683,[[["u32"]],["regionvid"]]],[11,"tag","","",683,[[],["str"]]],[11,"to_type","","",737,[[["self"],["tyctxt"]],["ty"]]],[11,"index","","",682,[[["self"]],["u32"]]],[11,"from_index","","",682,[[["u32"]],["floatvid"]]],[11,"tag","","",682,[[],["str"]]],[11,"to_type","","",701,[[["self"],["tyctxt"]],["ty"]]],[11,"infer_ctxt","","",684,[[["self"]],["inferctxtbuilder"]]],[11,"new","rustc::ty::error","",760,[[["bool"],["t"],["t"]],["self"]]],[11,"require_lang_item","rustc::ty","",684,[[["self"],["langitem"]],["defid"]]],[11,"skip_stability_check_due_to_privacy","","",684,[[["self"],["defid"]],["bool"]]],[11,"eval_stability","","Evaluates the stability of an item.",684,[[["self"],["defid"],["option",["nodeid"]],["span"]],["evalresult"]]],[11,"check_stability","","Checks if an item is stable or error out.",684,[[["self"],["defid"],["option",["nodeid"]],["span"]]]],[11,"lookup_deprecation","","",684,[[["self"],["defid"]],["option",["deprecation"]]]],[11,"is_weak_lang_item","","",684,[[["self"],["defid"]],["bool"]]],[11,"clone","rustc::ty::layout","",790,[[["self"]],["endian"]]],[11,"clone","rustc::ty::layout::call","",785,[[["self"]],["conv"]]],[11,"clone","","",778,[[["self"]],["passmode"]]],[11,"clone","rustc::ty::layout","",794,[[["self"]],["floatty"]]],[11,"clone","rustc::ty::layout::call","",780,[[["self"]],["regkind"]]],[11,"clone","","",779,[[["self"]],["argattributes"]]],[11,"clone","rustc::ty::layout","",791,[[["self"]],["size"]]],[11,"clone","","",796,[[["self"]],["scalar"]]],[11,"clone","rustc::ty::layout::call","",783,[[["self"]],["casttarget"]]],[11,"clone","","",787,[[["self"]],["argattribute"]]],[11,"clone","rustc::ty::layout","",792,[[["self"]],["align"]]],[11,"clone","rustc::ty::layout::call","",782,[[["self"]],["uniform"]]],[11,"clone","rustc::ty::layout","",798,[[["self"]],["abi"]]],[11,"clone","rustc::ty::layout::call","",781,[[["self"]],["reg"]]],[11,"clone","rustc::ty::layout","",793,[[["self"]],["integer"]]],[11,"clone","","",795,[[["self"]],["primitive"]]],[11,"clone","","",801,[[["self"]],["tylayout"]]],[11,"bitand","rustc::ty::layout::call","Returns the intersection between the two sets of flags.",787,[[["self"],["argattribute"]],["argattribute"]]],[11,"fmt","rustc::ty::layout","",801,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",796,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",786,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",782,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",795,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",793,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",792,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",787,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",783,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",798,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",800,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",797,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",784,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",779,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",778,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",794,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",781,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",791,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",785,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",780,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",799,[[["self"],["formatter"]],["result",["error"]]]],[11,"encode","","",792,[[["self"],["__s"]],["result"]]],[11,"encode","","",794,[[["self"],["__s"]],["result"]]],[11,"encode","","",791,[[["self"],["__s"]],["result"]]],[11,"fmt","rustc::ty::layout::call","",787,[[["self"],["formatter"]],["result",["error"]]]],[11,"sub","rustc::ty::layout","",791,[[["self"],["size"]],["size"]]],[11,"sub","rustc::ty::layout::call","Returns the set difference of the two sets of flags.",787,[[["self"],["argattribute"]],["argattribute"]]],[11,"cmp","","",787,[[["self"],["argattribute"]],["ordering"]]],[11,"cmp","rustc::ty::layout","",791,[[["self"],["size"]],["ordering"]]],[11,"cmp","","",794,[[["self"],["floatty"]],["ordering"]]],[11,"cmp","","",792,[[["self"],["align"]],["ordering"]]],[11,"cmp","","",793,[[["self"],["integer"]],["ordering"]]],[11,"from_iter","rustc::ty::layout::call","",787,[[["t"]],["argattribute"]]],[11,"default","","",787,[[],["argattribute"]]],[11,"default","rustc::ty::layout","Creates an instance of `TargetDataLayout`.",788,[[],["targetdatalayout"]]],[11,"mul","","",791,[[["self"],["u64"]],["size"]]],[11,"assert_receiver_is_total_eq","","",798,N],[11,"assert_receiver_is_total_eq","","",799,N],[11,"assert_receiver_is_total_eq","","",797,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",787,N],[11,"assert_receiver_is_total_eq","","",779,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",791,N],[11,"assert_receiver_is_total_eq","","",794,N],[11,"assert_receiver_is_total_eq","","",796,N],[11,"assert_receiver_is_total_eq","","",792,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",778,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",795,N],[11,"assert_receiver_is_total_eq","","",800,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",783,N],[11,"assert_receiver_is_total_eq","","",780,N],[11,"assert_receiver_is_total_eq","","",782,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",793,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",781,N],[11,"decode","rustc::ty::layout","",791,[[["__d"]],["result",["size"]]]],[11,"decode","","",794,[[["__d"]],["result",["floatty"]]]],[11,"decode","","",792,[[["__d"]],["result",["align"]]]],[11,"add_assign","","",791,N],[11,"sub_assign","rustc::ty::layout::call","Disables all flags enabled in the set.",787,N],[11,"add","rustc::ty::layout","",791,[[["self"],["size"]],["size"]]],[11,"partial_cmp","","",792,[[["self"],["align"]],["option",["ordering"]]]],[11,"lt","","",792,[[["self"],["align"]],["bool"]]],[11,"le","","",792,[[["self"],["align"]],["bool"]]],[11,"gt","","",792,[[["self"],["align"]],["bool"]]],[11,"ge","","",792,[[["self"],["align"]],["bool"]]],[11,"partial_cmp","rustc::ty::layout::call","",787,[[["self"],["argattribute"]],["option",["ordering"]]]],[11,"lt","","",787,[[["self"],["argattribute"]],["bool"]]],[11,"le","","",787,[[["self"],["argattribute"]],["bool"]]],[11,"gt","","",787,[[["self"],["argattribute"]],["bool"]]],[11,"ge","","",787,[[["self"],["argattribute"]],["bool"]]],[11,"partial_cmp","rustc::ty::layout","",793,[[["self"],["integer"]],["option",["ordering"]]]],[11,"partial_cmp","","",794,[[["self"],["floatty"]],["option",["ordering"]]]],[11,"partial_cmp","","",791,[[["self"],["size"]],["option",["ordering"]]]],[11,"lt","","",791,[[["self"],["size"]],["bool"]]],[11,"le","","",791,[[["self"],["size"]],["bool"]]],[11,"gt","","",791,[[["self"],["size"]],["bool"]]],[11,"ge","","",791,[[["self"],["size"]],["bool"]]],[11,"bitand_assign","rustc::ty::layout::call","Disables all flags disabled in the set.",787,N],[11,"fmt","","",787,[[["self"],["formatter"]],["result",["error"]]]],[11,"bitor","","Returns the union of the two sets of flags.",787,[[["self"],["argattribute"]],["argattribute"]]],[11,"fmt","","",787,[[["self"],["formatter"]],["result",["error"]]]],[11,"hash","rustc::ty::layout","",800,N],[11,"hash","","",793,N],[11,"hash","","",794,N],[11,"hash","","",792,N],[11,"hash","","",797,N],[11,"hash","","",791,N],[11,"hash","","",799,N],[11,"hash","","",798,N],[11,"hash","rustc::ty::layout::call","",787,N],[11,"hash","rustc::ty::layout","",795,N],[11,"hash","","",796,N],[11,"deref","","",801,[[["self"]],["layoutdetails"]]],[11,"bitxor","rustc::ty::layout::call","Returns the left flags, but with all the right flags toggled.",787,[[["self"],["argattribute"]],["argattribute"]]],[11,"fmt","","",787,[[["self"],["formatter"]],["result",["error"]]]],[11,"from","","",783,[[["uniform"]],["casttarget"]]],[11,"from","","",783,[[["reg"]],["casttarget"]]],[11,"from","","",782,[[["reg"]],["uniform"]]],[11,"extend","","",787,N],[11,"bitxor_assign","","Toggles the set of flags.",787,N],[11,"not","","Returns the complement of this set of flags.",787,[[["self"]],["argattribute"]]],[11,"bitor_assign","","Adds the set of flags.",787,N],[11,"fmt","rustc::ty::layout","",794,[[["self"],["formatter"]],["result",["error"]]]],[11,"eq","","",798,[[["self"],["abi"]],["bool"]]],[11,"ne","","",798,[[["self"],["abi"]],["bool"]]],[11,"eq","","",799,[[["self"],["variants"]],["bool"]]],[11,"ne","","",799,[[["self"],["variants"]],["bool"]]],[11,"eq","rustc::ty::layout::call","",785,[[["self"],["conv"]],["bool"]]],[11,"eq","","",780,[[["self"],["regkind"]],["bool"]]],[11,"eq","","",781,[[["self"],["reg"]],["bool"]]],[11,"ne","","",781,[[["self"],["reg"]],["bool"]]],[11,"eq","rustc::ty::layout","",794,[[["self"],["floatty"]],["bool"]]],[11,"eq","rustc::ty::layout::call","",782,[[["self"],["uniform"]],["bool"]]],[11,"ne","","",782,[[["self"],["uniform"]],["bool"]]],[11,"eq","","",778,[[["self"],["passmode"]],["bool"]]],[11,"ne","","",778,[[["self"],["passmode"]],["bool"]]],[11,"eq","rustc::ty::layout","",791,[[["self"],["size"]],["bool"]]],[11,"ne","","",791,[[["self"],["size"]],["bool"]]],[11,"eq","","",796,[[["self"],["scalar"]],["bool"]]],[11,"ne","","",796,[[["self"],["scalar"]],["bool"]]],[11,"eq","","",793,[[["self"],["integer"]],["bool"]]],[11,"eq","","",797,[[["self"],["fieldplacement"]],["bool"]]],[11,"ne","","",797,[[["self"],["fieldplacement"]],["bool"]]],[11,"eq","","",795,[[["self"],["primitive"]],["bool"]]],[11,"ne","","",795,[[["self"],["primitive"]],["bool"]]],[11,"eq","rustc::ty::layout::call","",787,[[["self"],["argattribute"]],["bool"]]],[11,"ne","","",787,[[["self"],["argattribute"]],["bool"]]],[11,"eq","rustc::ty::layout","",792,[[["self"],["align"]],["bool"]]],[11,"ne","","",792,[[["self"],["align"]],["bool"]]],[11,"eq","","",800,[[["self"],["layoutdetails"]],["bool"]]],[11,"ne","","",800,[[["self"],["layoutdetails"]],["bool"]]],[11,"eq","rustc::ty::layout::call","",779,[[["self"],["argattributes"]],["bool"]]],[11,"ne","","",779,[[["self"],["argattributes"]],["bool"]]],[11,"eq","","",783,[[["self"],["casttarget"]],["bool"]]],[11,"ne","","",783,[[["self"],["casttarget"]],["bool"]]],[11,"recursive_type_with_infinite_size_error","rustc::ty","",684,[[["self"],["defid"]],["diagnosticbuilder"]]],[11,"report_object_safety_error","","",684,[[["self"],["span"],["defid"],["vec",["objectsafetyviolation"]]],["diagnosticbuilder"]]],[11,"astconv_object_safety_violations","","Returns the object safety violations that affect astconv - currently, Self in supertraits. This is needed because `object_safety_violations` can't be used during type collection.",684,[[["self"],["defid"]],["vec",["objectsafetyviolation"]]]],[11,"object_safety_violations","","",684,[[["self"],["defid"]],["vec",["objectsafetyviolation"]]]],[11,"object_safety_violations_for_trait","","",684,[[["self"],["defid"]],["vec",["objectsafetyviolation"]]]],[11,"predicates_reference_self","","",684,[[["self"],["defid"],["bool"]],["bool"]]],[11,"trait_has_sized_self","","",684,[[["self"],["defid"]],["bool"]]],[11,"generics_require_sized_self","","",684,[[["self"],["defid"]],["bool"]]],[11,"object_safety_violation_for_method","","Returns `Some(_)` if this method makes the containing trait not object safe.",684,[[["self"],["defid"],["associateditem"]],["option",["methodviolationcode"]]]],[11,"is_vtable_safe_method","","We say a method is vtable safe if it can be invoked on a trait object.  Note that object-safe traits can have some non-vtable-safe methods, so long as they require `Self:Sized` or otherwise ensure that they cannot be used when `Self=Trait`.",684,[[["self"],["defid"],["associateditem"]],["bool"]]],[11,"virtual_call_violation_for_method","","Returns `Some(_)` if this method cannot be called on a trait object; this does not necessarily imply that the enclosing trait is not object safe, because the method might have a where clause `Self:Sized`.",684,[[["self"],["defid"],["associateditem"]],["option",["methodviolationcode"]]]],[11,"contains_illegal_self_type_reference","","",684,[[["self"],["defid"],["ty"]],["bool"]]],[11,"derived_cause","rustc::traits","Creates a cause for obligations that are derived from `obligation` by a recursive search (e.g., for a builtin bound, or eventually a `auto trait Foo`). If `obligation` is itself a derived obligation, this is just a clone, but otherwise we create a \"derived obligation\" cause so as to keep track of the original root obligation for error reporting.",663,N],[11,"subst_and_normalize_erasing_regions","rustc::ty","Monomorphizes a type from the AST by first applying the in-scope substitutions and then normalizing any associated types.",684,[[["self"],["substs"],["paramenv"],["t"]],["t"]]],[11,"predicate_for_trait_def","","",684,N],[11,"upcast_choices","","Cast a trait reference into a reference to one of its super traits; returns `None` if `target_trait_def_id` is not a supertrait.",684,[[["self"],["polytraitref"],["defid"]],["vec",["polytraitref"]]]],[11,"count_own_vtable_entries","","Given a trait `trait_ref`, returns the number of vtable entries that come from `trait_ref`, excluding its supertraits. Used in computing the vtable base for an upcast trait of a trait object.",684,[[["self"],["polytraitref"]],["usize"]]],[11,"get_vtable_index_of_object_method","","Given an upcast trait object described by `object`, returns the index of the method `method_def_id` (which should be part of `object.upcast_trait_ref`) within the vtable for `object`.",684,[[["self"],["vtableobjectdata"],["defid"]],["usize"]]],[11,"closure_trait_ref_and_return_type","","",684,[[["self"],["defid"],["ty"],["polyfnsig"],["tupleargumentsflag"]],["binder"]]],[11,"generator_trait_ref_and_outputs","","",684,[[["self"],["defid"],["ty"],["polygensig"]],["binder"]]],[11,"impl_is_default","","",684,[[["self"],["defid"]],["bool"]]],[11,"impl_item_is_final","","",684,[[["self"],["nodeitem"]],["bool"]]],[11,"normalize_erasing_regions","","Erase the regions in `value` and then fully normalize all the types found within. The result will also have regions erased.",684,[[["self"],["paramenv"],["t"]],["t"]]],[11,"normalize_erasing_late_bound_regions","","If you have a `Binder<T>`, you can do this to strip out the late-bound regions and then normalize the result, yielding up a `T` (with regions erased). This is appropriate when the binder is being instantiated at the call site.",684,[[["self"],["paramenv"],["binder"]],["t"]]],[11,"type_op_method","","",1062,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",1062,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"type_op_method","","",739,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",739,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"type_op_method","rustc::ty::sty","",1034,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",1034,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"type_op_method","rustc::ty","",667,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",667,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"fully_perform","","",714,[[["self"],["inferctxt"]],["fallible"]]],[11,"variant","","",1062,N],[11,"new","rustc::ty::layout::call","",779,[[],["argattributes"]]],[11,"set","","",779,[[["self"],["argattribute"]],["argattributes"]]],[11,"contains","","",779,[[["self"],["argattribute"]],["bool"]]],[11,"i8","","",781,[[],["reg"]]],[11,"i16","","",781,[[],["reg"]]],[11,"i32","","",781,[[],["reg"]]],[11,"i64","","",781,[[],["reg"]]],[11,"f32","","",781,[[],["reg"]]],[11,"f64","","",781,[[],["reg"]]],[11,"align","","",781,[[["self"],["c"]],["align"]]],[11,"align","","",782,[[["self"],["c"]],["align"]]],[11,"pair","","",783,[[["reg"],["reg"]],["casttarget"]]],[11,"size","","",783,[[["self"],["c"]],["size"]]],[11,"align","","",783,[[["self"],["c"]],["align"]]],[11,"new","","",784,[[["tylayout"]],["argtype"]]],[11,"make_indirect","","",784,N],[11,"make_indirect_byval","","",784,N],[11,"extend_integer_width_to","","",784,N],[11,"cast_to","","",784,N],[11,"pad_with","","",784,N],[11,"is_indirect","","",784,[[["self"]],["bool"]]],[11,"is_ignore","","",784,[[["self"]],["bool"]]],[11,"adjust_for_cabi","","",786,[[["self"],["c"],["abi"]],["result",["string"]]]],[18,"ByVal","","",787,N],[18,"NoAlias","","",787,N],[18,"NoCapture","","",787,N],[18,"NonNull","","",787,N],[18,"ReadOnly","","",787,N],[18,"SExt","","",787,N],[18,"StructRet","","",787,N],[18,"ZExt","","",787,N],[18,"InReg","","",787,N],[11,"empty","","Returns an empty set of flags.",787,[[],["argattribute"]]],[11,"all","","Returns the set containing all flags.",787,[[],["argattribute"]]],[11,"bits","","Returns the raw value of the flags currently stored.",787,[[["self"]],["u16"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",787,[[["u16"]],["option",["argattribute"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",787,[[["u16"]],["argattribute"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",787,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",787,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",787,[[["self"],["argattribute"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",787,[[["self"],["argattribute"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",787,N],[11,"remove","","Removes the specified flags in-place.",787,N],[11,"toggle","","Toggles the specified flags in-place.",787,N],[11,"set","","Inserts or removes the specified flags depending on the passed value.",787,N],[11,"parse","rustc::ty::layout","",788,[[["target"]],["result",["targetdatalayout","string"]]]],[11,"obj_size_bound","","Return exclusive upper bound on object size.",788,[[["self"]],["u64"]]],[11,"ptr_sized_integer","","",788,[[["self"]],["integer"]]],[11,"vector_align","","",788,[[["self"],["size"]],["align"]]],[18,"ZERO","","",791,N],[11,"from_bits","","",791,[[["u64"]],["size"]]],[11,"from_bytes","","",791,[[["u64"]],["size"]]],[11,"bytes","","",791,[[["self"]],["u64"]]],[11,"bits","","",791,[[["self"]],["u64"]]],[11,"abi_align","","",791,[[["self"],["align"]],["size"]]],[11,"is_abi_aligned","","",791,[[["self"],["align"]],["bool"]]],[11,"checked_add","","",791,[[["self"],["size"],["c"]],["option",["size"]]]],[11,"checked_mul","","",791,[[["self"],["u64"],["c"]],["option",["size"]]]],[11,"from_bits","","",792,[[["u64"],["u64"]],["result",["align","string"]]]],[11,"from_bytes","","",792,[[["u64"],["u64"]],["result",["align","string"]]]],[11,"abi","","",792,[[["self"]],["u64"]]],[11,"pref","","",792,[[["self"]],["u64"]]],[11,"abi_bits","","",792,[[["self"]],["u64"]]],[11,"pref_bits","","",792,[[["self"]],["u64"]]],[11,"min","","",792,[[["self"],["align"]],["align"]]],[11,"max","","",792,[[["self"],["align"]],["align"]]],[11,"size","","",793,[[["self"]],["size"]]],[11,"align","","",793,[[["self"],["c"]],["align"]]],[11,"fit_signed","","Find the smallest Integer type which can represent the signed value.",793,[[["i128"]],["integer"]]],[11,"fit_unsigned","","Find the smallest Integer type which can represent the unsigned value.",793,[[["u128"]],["integer"]]],[11,"for_abi_align","","Find the smallest integer with the given alignment.",793,[[["c"],["align"]],["option",["integer"]]]],[11,"approximate_abi_align","","Find the largest integer with the given alignment or less.",793,[[["c"],["align"]],["integer"]]],[11,"ty_to_string","","",794,[[["self"]],["str"]]],[11,"bit_width","","",794,[[["self"]],["usize"]]],[11,"size","","",795,[[["self"],["c"]],["size"]]],[11,"align","","",795,[[["self"],["c"]],["align"]]],[11,"is_float","","",795,[[["self"]],["bool"]]],[11,"is_int","","",795,[[["self"]],["bool"]]],[11,"is_bool","","",796,[[["self"]],["bool"]]],[11,"valid_range_exclusive","","Returns the valid range as a `x..y` range.",796,[[["self"],["c"]],["range",["u128"]]]],[11,"count","","",797,[[["self"]],["usize"]]],[11,"offset","","",797,[[["self"],["usize"]],["size"]]],[11,"memory_index","","",797,[[["self"],["usize"]],["usize"]]],[11,"index_by_increasing_offset","","Get source indices of the fields by increasing offsets.",797,N],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",798,[[["self"]],["bool"]]],[11,"is_signed","","Returns true if this is a single signed integer scalar",798,[[["self"]],["bool"]]],[11,"scalar","","",800,[[["c"],["scalar"]],["layoutdetails"]]],[11,"for_variant","","",801,[[["self"],["c"],["usize"]],["tylayout"]]],[11,"field","","",801,N],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",801,[[["self"]],["bool"]]],[11,"is_zst","","Returns true if the type is a ZST and not unsized.",801,[[["self"]],["bool"]]],[11,"size_and_align","","",801,N],[11,"layout_of","rustc::ty::query","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",819,[[["self"],["paramenvand",["ty"]]],["result",["tylayout","layouterror"]]]],[11,"for_variant","rustc::ty","",1062,[[["tylayout"],["c"],["usize"]],["tylayout"]]],[11,"field","","",1062,N],[11,"query_crate","rustc::ty::sty","",1031,[[["self"]],["cratenum"]]],[11,"default_span","","",1031,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::ty","",1062,[[["self"]],["cratenum"]]],[11,"default_span","","",1062,[[["self"],["tyctxt"]],["span"]]],[11,"from_cycle_error","","",1062,[[["tyctxt"]],["ty"]]],[11,"describe","rustc::ty::query::queries","",980,[[["tyctxt"],["canonicalprojectiongoal"]],["string"]]],[11,"describe","","",982,[[["tyctxt"],["canonicaltygoal"]],["string"]]],[11,"describe","","",983,[[["tyctxt"],["canonicaltygoal"]],["string"]]],[11,"describe","","",981,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",984,[[["tyctxt"],["canonicalpredicategoal"]],["string"]]],[11,"describe","","",985,[[["tyctxt"],["canonicaltypeopeqgoal"]],["string"]]],[11,"describe","","",986,[[["tyctxt"],["canonicaltypeopsubtypegoal"]],["string"]]],[11,"describe","","",987,[[["tyctxt"],["canonicaltypeopprovepredicategoal"]],["string"]]],[11,"describe","","",988,[[["tyctxt"],["canonicaltypeopnormalizegoal",["ty"]]],["string"]]],[11,"describe","","",989,[[["tyctxt"],["canonicaltypeopnormalizegoal",["predicate"]]],["string"]]],[11,"describe","","",990,[[["tyctxt"],["canonicaltypeopnormalizegoal",["polyfnsig"]]],["string"]]],[11,"describe","","",991,[[["tyctxt"],["canonicaltypeopnormalizegoal",["fnsig"]]],["string"]]],[11,"describe","","",909,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",910,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",911,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",912,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",913,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",845,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",882,[[["tyctxt"],["const"]],["string"]]],[11,"describe","","",979,[[["tyctxt"],["ty"]],["string"]]],[11,"describe","","",846,N],[11,"describe","","",876,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",934,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",879,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",880,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",854,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",856,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",887,[[["tyctxt"],["instancedef"]],["string"]]],[11,"describe","","",884,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",872,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",885,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",881,[[["tyctxt"],["paramenvand",["globalid"]]],["string"]]],[11,"cache_on_disk","","",881,N],[11,"try_load_from_disk","","",881,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",862,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",889,[[["tyctxt"],["instance"]],["string"]]],[11,"cache_on_disk","","",889,N],[11,"try_load_from_disk","","",889,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",890,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",891,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",892,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",893,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",894,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",932,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",896,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",898,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",899,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",900,[[["tyctxt"],["defid"]],["string"]]],[11,"cache_on_disk","","",900,N],[11,"try_load_from_disk","","",900,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",901,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",902,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",904,N],[11,"cache_on_disk","","",904,N],[11,"try_load_from_disk","","",904,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",905,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",907,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",852,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",914,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",915,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",916,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",917,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",922,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",926,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",923,N],[11,"describe","","",924,[[["tyctxt"],["defindex"]],["string"]]],[11,"describe","","",921,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",920,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",919,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",918,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",931,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",936,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",937,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",938,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",939,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",940,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",941,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",942,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",943,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",944,N],[11,"describe","","",945,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",950,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",951,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",952,[[["tyctxt"],["defindex"]],["string"]]],[11,"describe","","",953,[[["tyctxt"],["defindex"]],["string"]]],[11,"describe","","",954,[[["tyctxt"],["defindex"]],["string"]]],[11,"describe","","",956,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",957,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",960,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",961,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",962,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",963,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",964,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",965,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",966,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",969,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",970,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",972,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",971,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",973,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",974,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",976,[[["tyctxt"],["internedstring"]],["string"]]],[11,"describe","","",977,[[["tyctxt"],["internedstring"]],["string"]]],[11,"describe","","",978,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",903,[[["tyctxt"],["polytraitref"]],["string"]]],[11,"describe","","",995,[[["tyctxt"],["cratenum"]],["string"]]],[11,"cache_on_disk","","",873,N],[11,"try_load_from_disk","","",873,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",867,N],[11,"try_load_from_disk","","",867,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",992,N],[11,"describe","","",993,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",994,[[["tyctxt"],["instancedef"]],["string"]]],[11,"cache_on_disk","","",840,N],[11,"try_load_from_disk","","",840,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",996,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",997,[[["tyctxt"],["paramenv"]],["string"]]],[11,"describe","","",998,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",946,[[["tyctxt"],["cratenum"]],["string"]]],[11,"cache_on_disk","","",868,N],[11,"try_load_from_disk","","",868,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",877,N],[11,"try_load_from_disk","","",877,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",878,N],[11,"try_load_from_disk","","",878,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",863,N],[11,"try_load_from_disk","","",863,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",883,N],[11,"try_load_from_disk","","",883,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",888,N],[11,"try_load_from_disk","","",888,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",839,N],[11,"try_load_from_disk","","",839,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",841,N],[11,"try_load_from_disk","","",841,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",874,N],[11,"try_load_from_disk","","",874,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",895,N],[11,"try_load_from_disk","","",895,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",906,N],[11,"try_load_from_disk","","",906,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"relate","rustc::ty","",1062,[[["r"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"relate","rustc::ty::sty","",1063,[[["r"],["region"],["region"]],["relateresult",["region"]]]],[11,"relate","rustc::ty::subst","",1004,[[["r"],["kind"],["kind"]],["relateresult",["kind"]]]],[11,"lift_to_tcx","rustc::ty","",1062,[[["self"],["tyctxt"]],["option",["ty"]]]],[11,"lift_to_tcx","rustc::ty::sty","",1063,[[["self"],["tyctxt"]],["option",["region"]]]],[11,"super_fold_with","rustc::ty","",1062,[[["self"],["f"]],["self"]]],[11,"fold_with","","",1062,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",1062,[[["self"],["v"]],["bool"]]],[11,"visit_with","","",1062,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty::sty","",1063,[[["self"],["f"]],["self"]]],[11,"fold_with","","",1063,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",1063,[[["self"],["v"]],["bool"]]],[11,"visit_with","","",1063,[[["self"],["v"]],["bool"]]]],"paths":[[3,"CFG"],[3,"CFGEdgeData"],[4,"CFGNodeData"],[3,"CFGBuilder"],[3,"BlockScope"],[3,"LoopScope"],[4,"ScopeCfKind"],[3,"LabelledCFG"],[3,"DepTrackingMap"],[3,"DepNode"],[3,"WorkProductId"],[3,"DepGraph"],[3,"WorkProduct"],[3,"DepNodeIndex"],[3,"PreviousDepGraph"],[3,"DepGraphQuery"],[3,"AssertDepGraphSafe"],[3,"SerializedDepGraph"],[3,"SerializedDepNodeIndex"],[4,"DepKind"],[4,"DepConstructor"],[4,"DepNodeColor"],[4,"OpenTask"],[4,"WorkProductFileKind"],[3,"DepNodeFilter"],[3,"EdgeFilter"],[8,"DepNodeParams"],[8,"DepTrackingMapConfig"],[3,"DepGraphData"],[3,"CurrentDepGraph"],[3,"RegularOpenTask"],[3,"AnonOpenTask"],[3,"DepNodeColorMap"],[3,"HirId"],[3,"ItemLocalId"],[3,"Label"],[3,"Lifetime"],[3,"Path"],[3,"PathSegment"],[3,"GenericArgs"],[3,"GenericParam"],[3,"GenericParamCount"],[3,"Generics"],[3,"WhereClause"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[3,"MacroDef"],[3,"Block"],[3,"Pat"],[3,"FieldPat"],[3,"Local"],[3,"Arm"],[3,"Field"],[3,"BodyId"],[3,"Body"],[3,"AnonConst"],[3,"Expr"],[3,"Destination"],[3,"MutTy"],[3,"MethodSig"],[3,"TraitItemId"],[3,"TraitItem"],[3,"ImplItemId"],[3,"ImplItem"],[3,"TypeBinding"],[3,"Ty"],[3,"BareFnTy"],[3,"ExistTy"],[3,"InlineAsmOutput"],[3,"InlineAsm"],[3,"Arg"],[3,"FnDecl"],[3,"Mod"],[3,"ForeignMod"],[3,"GlobalAsm"],[3,"EnumDef"],[3,"VariantKind"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"StructField"],[3,"ItemId"],[3,"Item"],[3,"FnHeader"],[3,"TraitItemRef"],[3,"ImplItemRef"],[3,"ForeignItem"],[3,"Freevar"],[3,"TraitCandidate"],[3,"CodegenFnAttrs"],[3,"CodegenFnAttrFlags"],[4,"ParamName"],[4,"LifetimeName"],[4,"GenericArg"],[4,"TraitBoundModifier"],[4,"GenericBound"],[4,"GenericParamKind"],[4,"SyntheticTyParamKind"],[4,"WherePredicate"],[4,"BindingAnnotation"],[4,"RangeEnd"],[4,"PatKind"],[4,"Mutability"],[4,"BinOpKind"],[4,"UnOp"],[4,"StmtKind"],[4,"DeclKind"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[4,"BodyOwnerKind"],[4,"ExprKind"],[4,"QPath"],[4,"LocalSource"],[4,"MatchSource"],[4,"LoopSource"],[4,"LoopIdError"],[4,"GeneratorMovability"],[4,"CaptureClause"],[4,"TraitMethod"],[4,"TraitItemKind"],[4,"ImplItemKind"],[4,"PrimTy"],[4,"TyKind"],[4,"IsAuto"],[4,"IsAsync"],[4,"Unsafety"],[4,"Constness"],[4,"Defaultness"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[4,"UseKind"],[4,"VisibilityKind"],[4,"VariantData"],[4,"ItemKind"],[4,"AssociatedItemKind"],[4,"ForeignItemKind"],[3,"CheckAttrVisitor"],[4,"Target"],[3,"PathResolution"],[3,"PerNS"],[3,"Export"],[4,"CtorKind"],[4,"Def"],[4,"Namespace"],[3,"CrateNum"],[3,"DefIndex"],[3,"DefId"],[3,"LocalDefId"],[4,"DefIndexAddressSpace"],[3,"IdRange"],[3,"IdRangeComputingVisitor"],[4,"FnKind"],[4,"NestedVisitorMap"],[8,"Visitor"],[3,"DeepVisitor"],[3,"ParDeepVisitor"],[8,"ItemLikeVisitor"],[8,"ParItemLikeVisitor"],[8,"IntoVisitor"],[3,"LoweringContext"],[3,"LoweredNodeId"],[4,"ImplTraitContext"],[4,"ParamMode"],[4,"ParenthesizedGenericArgs"],[4,"AnonymousLifetimeMode"],[8,"Resolver"],[3,"DefCollector"],[3,"MacroInvocationData"],[3,"Forest"],[3,"Map"],[3,"NodesMatchingSuffix"],[4,"Node"],[4,"MapEntry"],[3,"FnLikeNode"],[3,"ItemFnParts"],[3,"ClosureParts"],[4,"Code"],[8,"MaybeFnLike"],[3,"NodeCollector"],[3,"HirItemLike"],[3,"DefPathTable"],[3,"Definitions"],[3,"DefKey"],[3,"DisambiguatedDefPathData"],[3,"DefPath"],[3,"DefPathHash"],[4,"DefPathData"],[4,"GlobalMetaDataKind"],[3,"HirIdValidator"],[3,"OuterVisitor"],[8,"Named"],[3,"EnumerateAndAdjust"],[8,"EnumerateAndAdjustIterator"],[3,"State"],[4,"AnnNode"],[4,"Nested"],[8,"PpAnn"],[3,"Svh"],[3,"Fingerprint"],[3,"CachingCodemapView"],[3,"StableHashingContext"],[4,"NodeIdHashingMode"],[3,"CacheEntry"],[3,"BodyResolver"],[8,"StableHashingContextProvider"],[3,"TypeFreshener"],[3,"InferOk"],[3,"InferCtxt"],[3,"TypeTrace"],[3,"RegionObligation"],[3,"InferCtxtBuilder"],[3,"CombinedSnapshot"],[4,"ValuePairs"],[4,"SubregionOrigin"],[4,"ParameterOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"NLLRegionVariableOrigin"],[4,"FixupError"],[3,"AnonTypeDecl"],[3,"ReverseMapper"],[3,"Instantiator"],[3,"At"],[3,"Trace"],[8,"ToTrace"],[3,"Canonical"],[3,"CanonicalVarValues"],[3,"CanonicalVarInfo"],[3,"QueryResult"],[4,"CanonicalVarKind"],[4,"CanonicalTyVarKind"],[4,"Certainty"],[3,"CanonicalizeRegionMode"],[3,"Canonicalizer"],[3,"CanonicalVarValuesSubst"],[6,"CanonicalVarInfos"],[3,"CombineFields"],[3,"Generalizer"],[3,"Generalization"],[4,"RelationDir"],[8,"RelateResultCompare"],[3,"Equate"],[4,"FailureCode"],[3,"FindLocalByTypeVisitor"],[3,"NiceRegionError"],[3,"FindNestedTypeVisitor"],[3,"TyPathVisitor"],[3,"AnonymousArgInfo"],[3,"FreeRegionInfo"],[3,"RegionFudger"],[3,"Glb"],[3,"HrMatchResult"],[8,"LatticeDir"],[3,"Lub"],[3,"RegionConstraintCollector"],[3,"RegionConstraintData"],[3,"Verify"],[3,"TwoRegions"],[3,"RegionVariableInfo"],[3,"RegionSnapshot"],[3,"TaintDirections"],[4,"Constraint"],[4,"GenericKind"],[4,"VerifyBound"],[4,"UndoLogEntry"],[4,"CombineMapType"],[3,"TaintSet"],[3,"LexicalRegionResolutions"],[3,"RegionAndOrigin"],[3,"LexicalResolver"],[4,"VarValue"],[4,"RegionResolutionError"],[3,"ConstraintGraph"],[4,"Node"],[4,"Edge"],[3,"OutlivesEnvironment"],[3,"FreeRegionMap"],[8,"FreeRegionRelations"],[3,"TypeOutlives"],[8,"TypeOutlivesDelegate"],[3,"OpportunisticTypeResolver"],[3,"OpportunisticTypeAndRegionResolver"],[3,"UnresolvedTypeFinder"],[3,"FullTypeResolver"],[3,"Sub"],[3,"TypeVariableTable"],[3,"TypeVariableData"],[3,"Snapshot"],[3,"Instantiate"],[3,"TyVidEqKey"],[4,"TypeVariableOrigin"],[4,"TypeVariableValue"],[3,"Delegate"],[3,"RegionVidKey"],[8,"ToType"],[3,"LateContext"],[3,"EarlyContext"],[3,"LintStore"],[3,"FutureIncompatibleInfo"],[3,"BufferedEarlyLint"],[3,"Lint"],[3,"LintId"],[3,"LintLevelSets"],[3,"LintLevelMap"],[3,"LintBuffer"],[3,"LintLevelMapBuilder"],[4,"Level"],[4,"LintSource"],[4,"BuiltinLintDiagnostics"],[3,"HardwiredLints"],[3,"LintSession"],[4,"TargetLint"],[4,"FindLintError"],[4,"CheckLintNameResult"],[8,"LintContext"],[3,"LintLevelsBuilder"],[3,"BuilderPush"],[4,"LintSet"],[8,"LintPass"],[8,"LateLintPass"],[8,"EarlyLintPass"],[4,"AllocatorKind"],[3,"BorrowCheckResult"],[4,"SignalledError"],[3,"ExprUseVisitor"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"TrackMatchMode"],[4,"MutateMode"],[4,"OverloadedCallType"],[8,"Delegate"],[3,"LinkMeta"],[3,"CrateSource"],[3,"NativeLibrary"],[3,"ForeignModule"],[3,"ExternCrate"],[3,"EncodedMetadata"],[4,"DepKind"],[4,"LibSource"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[4,"LoadedMacro"],[4,"ExternCrateSource"],[8,"MetadataLoader"],[8,"CrateStore"],[8,"CrateLoader"],[3,"DummyCrateStore"],[3,"DataFlowContext"],[3,"PropagationContext"],[4,"EntryOrExit"],[4,"KillFrom"],[8,"BitwiseOperator"],[8,"DataFlowOperator"],[3,"Union"],[3,"Subtract"],[3,"MarkSymbolVisitor"],[3,"LifeSeeder"],[3,"DeadVisitor"],[4,"Linkage"],[3,"EntryContext"],[4,"SymbolExportLevel"],[4,"ExportedSymbol"],[3,"RegionRelations"],[3,"ItemVisitor"],[3,"ExprVisitor"],[3,"LanguageItems"],[3,"LanguageItemCollector"],[4,"LangItem"],[3,"Variable"],[3,"LiveNode"],[3,"CaptureInfo"],[3,"LocalInfo"],[3,"IrMaps"],[3,"Users"],[3,"Specials"],[3,"Liveness"],[4,"LoopKind"],[4,"LiveNodeKind"],[4,"VarKind"],[3,"Upvar"],[3,"FieldIndex"],[3,"cmt_"],[3,"MemCategorizationContext"],[4,"Categorization"],[4,"PointerKind"],[4,"InteriorKind"],[4,"InteriorOffsetKind"],[4,"MutabilityCategory"],[4,"Note"],[4,"ImmutabilityBlame"],[4,"Aliasability"],[4,"AliasableReason"],[8,"HirNode"],[3,"AccessLevels"],[4,"AccessLevel"],[3,"ReachableContext"],[3,"CollectPrivateImplItemsVisitor"],[3,"ReachableSet"],[3,"Scope"],[3,"BlockRemainder"],[3,"FirstStatementIndex"],[3,"ScopeTree"],[3,"Context"],[3,"RegionResolutionVisitor"],[3,"ExprLocatorVisitor"],[4,"ScopeData"],[3,"NamedRegionMap"],[3,"ResolveLifetimes"],[3,"LifetimeContext"],[3,"ElisionFailureInfo"],[3,"Original"],[3,"Shadower"],[4,"LifetimeDefOrigin"],[4,"LifetimeUseSet"],[4,"Region"],[4,"Set1"],[4,"Scope"],[4,"Elide"],[4,"ShadowKind"],[3,"DeprecationEntry"],[3,"Index"],[3,"Annotator"],[3,"MissingStabilityAnnotations"],[3,"Checker"],[4,"StabilityLevel"],[4,"AnnotationKind"],[4,"EvalResult"],[3,"Context"],[3,"Mir"],[3,"SourceInfo"],[3,"Local"],[3,"VarBindingForm"],[3,"LocalDecl"],[3,"UpvarDecl"],[3,"BasicBlock"],[3,"BasicBlockData"],[3,"Terminator"],[3,"Statement"],[3,"ValidationOperand"],[3,"Static"],[3,"Projection"],[3,"Field"],[3,"SourceScope"],[3,"SourceScopeData"],[3,"SourceScopeLocalData"],[3,"Constant"],[3,"Promoted"],[3,"Location"],[3,"UnsafetyViolation"],[3,"UnsafetyCheckResult"],[3,"GeneratorLayout"],[3,"BorrowCheckResult"],[3,"ClosureRegionRequirements"],[3,"ClosureOutlivesRequirement"],[4,"Safety"],[4,"ClearCrossCrate"],[4,"Mutability"],[4,"BorrowKind"],[4,"LocalKind"],[4,"BindingForm"],[4,"TerminatorKind"],[4,"StatementKind"],[4,"ValidationOp"],[4,"Place"],[4,"ProjectionElem"],[4,"Operand"],[4,"Rvalue"],[4,"CastKind"],[4,"AggregateKind"],[4,"BinOp"],[4,"NullOp"],[4,"UnOp"],[4,"UnsafetyViolationKind"],[4,"ClosureOutlivesSubject"],[3,"Cache"],[3,"EvalError"],[3,"ConstEvalErr"],[3,"FrameInfo"],[3,"DynamicLifetime"],[3,"GlobalId"],[3,"Pointer"],[3,"AllocId"],[3,"AllocDecodingState"],[3,"AllocDecodingSession"],[3,"AllocMap"],[3,"Allocation"],[3,"Relocations"],[3,"UndefMask"],[4,"EvalErrorKind"],[4,"Scalar"],[4,"Value"],[4,"ConstValue"],[4,"Lock"],[4,"AccessKind"],[4,"AllocKind"],[4,"State"],[4,"AllocType"],[8,"PointerArithmetic"],[3,"CodegenUnit"],[3,"Stats"],[4,"MonoItem"],[4,"Linkage"],[4,"Visibility"],[4,"PlaceTy"],[4,"RvalueInitializationState"],[3,"Preorder"],[3,"Postorder"],[3,"ReversePostorder"],[4,"TyContext"],[4,"PlaceContext"],[8,"Visitor"],[8,"MutVisitor"],[8,"MirVisitable"],[8,"HasLocalDecls"],[3,"CodeStats"],[3,"FieldInfo"],[3,"TypeSizeInfo"],[3,"VariantInfo"],[3,"Session"],[3,"PerfStats"],[3,"CrateDisambiguator"],[4,"DataTypeKind"],[4,"SizeKind"],[4,"DiagnosticBuilderMethod"],[4,"DiagnosticMessageId"],[4,"IncrCompSession"],[4,"CompileIncomplete"],[3,"Config"],[3,"OutputTypes"],[3,"Externs"],[3,"Options"],[3,"OutputFilenames"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[3,"RustcOptGroup"],[4,"Sanitizer"],[4,"OptLevel"],[4,"Lto"],[4,"CrossLangLto"],[4,"DebugInfoLevel"],[4,"OutputType"],[4,"ErrorOutputType"],[4,"PrintRequest"],[4,"BorrowckMode"],[4,"Input"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[4,"OptionStability"],[8,"DepTrackingHash"],[3,"FileSearch"],[4,"FileMatch"],[3,"SearchPaths"],[3,"Iter"],[4,"PathKind"],[3,"OverlapResult"],[3,"FulfillmentContext"],[3,"PendingPredicateObligation"],[3,"MismatchedProjectionTypes"],[3,"ProjectionCache"],[3,"ProjectionCacheSnapshot"],[3,"Normalized"],[3,"OnUnimplementedDirective"],[3,"OnUnimplementedNote"],[3,"EvaluationCache"],[3,"SelectionContext"],[3,"SelectionCache"],[3,"OverlapError"],[3,"SpecializesCache"],[3,"SupertraitDefIds"],[3,"Obligation"],[3,"ObligationCause"],[3,"DerivedObligationCause"],[3,"ProgramClause"],[3,"FulfillmentError"],[3,"VtableImplData"],[3,"VtableGeneratorData"],[3,"VtableClosureData"],[3,"VtableAutoImplData"],[3,"VtableBuiltinData"],[3,"VtableObjectData"],[3,"VtableFnPointerData"],[4,"OrphanCheckErr"],[4,"Reveal"],[4,"ObjectSafetyViolation"],[4,"MethodViolationCode"],[4,"EvaluationResult"],[4,"IntercrateAmbiguityCause"],[4,"IntercrateMode"],[4,"TraitQueryMode"],[4,"ObligationCauseCode"],[4,"WhereClause"],[4,"WellFormed"],[4,"FromEnv"],[4,"DomainGoal"],[4,"QuantifierKind"],[4,"Goal"],[4,"Clause"],[4,"SelectionError"],[4,"FulfillmentErrorCode"],[4,"Vtable"],[3,"Graph"],[3,"Ancestors"],[3,"NodeItem"],[4,"Node"],[3,"RegionDeps"],[3,"AutoTraitInfo"],[3,"AutoTraitFinder"],[3,"RegionReplacer"],[4,"RegionTarget"],[4,"AutoTraitResult"],[4,"InCrate"],[4,"Conflict"],[4,"ArgKind"],[8,"TraitEngine"],[8,"TraitEngineExt"],[3,"FulfillProcessor"],[3,"AssociatedTypeNormalizer"],[3,"Progress"],[3,"ProjectionCacheKey"],[4,"ProjectionTyError"],[4,"ProjectionTyCandidate"],[4,"ProjectionTyCandidateSet"],[4,"ProjectedTy"],[4,"ProjectionCacheEntry"],[3,"OnUnimplementedFormatString"],[3,"TraitObligationStack"],[3,"SelectionCandidateSet"],[3,"EvaluatedCandidate"],[3,"TraitObligationStackList"],[3,"WithDepNode"],[4,"SelectionCandidate"],[4,"BuiltinImplConditions"],[3,"OverflowError"],[3,"Children"],[4,"Inserted"],[3,"TraitSelectionCache"],[3,"ProjectionCache"],[3,"PredicateSet"],[3,"Elaborator"],[3,"FilterToTraits"],[4,"TupleArgumentsFlag"],[3,"DropckOutlivesResult"],[3,"DtorckConstraint"],[3,"NormalizationResult"],[3,"QueryNormalizer"],[3,"NormalizeAfterErasingRegionsFolder"],[4,"OutlivesBound"],[3,"CustomTypeOp"],[3,"Eq"],[3,"Normalize"],[8,"Normalizable"],[3,"DropckOutlives"],[3,"ProvePredicate"],[3,"Subtype"],[8,"TypeOp"],[8,"QueryTypeOp"],[3,"NoSolution"],[8,"ExClauseFold"],[8,"ExClauseLift"],[6,"TraitObligation"],[3,"Binder"],[3,"CanonicalVar"],[3,"DebruijnIndex"],[3,"FnSig"],[3,"GenSig"],[3,"ParamTy"],[3,"ProjectionTy"],[3,"ClosureSubsts"],[3,"GeneratorSubsts"],[3,"TypeAndMut"],[3,"TraitRef"],[3,"ExistentialTraitRef"],[3,"ExistentialProjection"],[3,"Const"],[3,"EarlyBoundRegion"],[3,"FreeRegion"],[3,"TyVid"],[3,"IntVid"],[3,"FloatVid"],[3,"RegionVid"],[3,"TyCtxt"],[3,"GlobalArenas"],[3,"AllArenas"],[3,"TypeckTables"],[3,"Instance"],[3,"CrateAnalysis"],[3,"Resolutions"],[3,"ImplHeader"],[3,"AssociatedItem"],[3,"CrateVariancesMap"],[3,"CReaderCacheKey"],[3,"TypeFlags"],[3,"TyS"],[3,"Slice"],[3,"UpvarId"],[3,"UpvarBorrow"],[3,"ClosureUpvar"],[3,"FloatVarValue"],[3,"GenericParamDef"],[3,"GenericParamCount"],[3,"Generics"],[3,"GenericPredicates"],[3,"CratePredicatesMap"],[3,"TraitPredicate"],[3,"OutlivesPredicate"],[3,"SubtypePredicate"],[3,"ProjectionPredicate"],[3,"InstantiatedPredicates"],[3,"UniverseIndex"],[3,"ParamEnv"],[3,"ParamEnvAnd"],[3,"Destructor"],[3,"AdtFlags"],[3,"VariantDef"],[3,"FieldDef"],[3,"AdtDef"],[3,"ReprFlags"],[3,"ReprOptions"],[3,"CrateInherentImpls"],[3,"SymbolName"],[4,"InferTy"],[4,"ExistentialPredicate"],[4,"UpvarSubsts"],[4,"TypeVariants"],[4,"BoundRegion"],[4,"RegionKind"],[4,"InstanceDef"],[4,"AssociatedItemContainer"],[4,"AssociatedKind"],[4,"Visibility"],[4,"Variance"],[4,"BorrowKind"],[4,"UpvarCapture"],[4,"IntVarValue"],[4,"GenericParamDefKind"],[4,"Predicate"],[4,"VariantDiscr"],[4,"AdtKind"],[4,"ClosureKind"],[4,"Attributes"],[3,"ImplicitCtxt"],[3,"Adjustment"],[3,"OverloadedDeref"],[3,"CoerceUnsizedInfo"],[4,"Adjust"],[4,"AllowTwoPhase"],[4,"AutoBorrowMutability"],[4,"AutoBorrow"],[4,"CustomCoerceUnsized"],[4,"BindingMode"],[4,"IntTy"],[4,"CastTy"],[4,"CastKind"],[8,"EncodableWithShorthand"],[8,"TyEncoder"],[8,"TyDecoder"],[3,"ExpectedFound"],[4,"TypeError"],[4,"UnconstrainedNumeric"],[3,"RegionEraserVisitor"],[4,"SimplifiedTypeGen"],[3,"BottomUpFolder"],[3,"RegionFolder"],[3,"RegionReplacer"],[3,"HasEscapingRegionsVisitor"],[3,"HasTypeFlagsVisitor"],[3,"LateBoundRegionsCollector"],[8,"TypeFoldable"],[8,"TypeFolder"],[8,"TypeVisitor"],[3,"DefIdForest"],[3,"LocalPathBuffer"],[4,"RootMode"],[8,"ItemPathBuffer"],[4,"PassMode"],[3,"ArgAttributes"],[4,"RegKind"],[3,"Reg"],[3,"Uniform"],[3,"CastTarget"],[3,"ArgType"],[4,"Conv"],[3,"FnType"],[3,"ArgAttribute"],[3,"TargetDataLayout"],[8,"HasDataLayout"],[4,"Endian"],[3,"Size"],[3,"Align"],[4,"Integer"],[4,"FloatTy"],[4,"Primitive"],[3,"Scalar"],[4,"FieldPlacement"],[4,"Abi"],[4,"Variants"],[3,"LayoutDetails"],[3,"TyLayout"],[8,"LayoutOf"],[8,"TyLayoutMethods"],[3,"LayoutCx"],[3,"Niche"],[4,"LayoutError"],[4,"SizeSkeleton"],[8,"IntegerExt"],[8,"PrimitiveExt"],[8,"HasTyCtxt"],[8,"MaybeResult"],[3,"Match"],[4,"Component"],[3,"CycleError"],[3,"QueryJob"],[3,"QueryInfo"],[3,"OnDiskCache"],[3,"Queries"],[3,"TyCtxtAt"],[3,"Providers"],[4,"Query"],[3,"QueryCache"],[3,"QueryValue"],[3,"JobOwner"],[4,"TryGetJob"],[4,"QueryResult"],[8,"Key"],[8,"Value"],[8,"QueryConfig"],[8,"QueryAccessors"],[8,"QueryDescription"],[3,"Footer"],[3,"FileMapIndex"],[3,"AbsoluteBytePos"],[3,"CacheDecoder"],[3,"CacheEncoder"],[3,"IntEncodedWithFixedSize"],[8,"DecoderWithPosition"],[3,"type_of"],[3,"generics_of"],[3,"predicates_of"],[3,"predicates_defined_on"],[3,"explicit_predicates_of"],[3,"inferred_outlives_of"],[3,"super_predicates_of"],[3,"type_param_predicates"],[3,"trait_def"],[3,"adt_def"],[3,"adt_destructor"],[3,"adt_sized_constraint"],[3,"adt_dtorck_constraint"],[3,"is_const_fn"],[3,"is_foreign_item"],[3,"crate_variances"],[3,"variances_of"],[3,"inferred_outlives_crate"],[3,"associated_item_def_ids"],[3,"associated_item"],[3,"impl_trait_ref"],[3,"impl_polarity"],[3,"inherent_impls"],[3,"mir_keys"],[3,"mir_const_qualif"],[3,"mir_built"],[3,"mir_const"],[3,"mir_validated"],[3,"optimized_mir"],[3,"unsafety_check_result"],[3,"unsafe_derive_on_repr_packed"],[3,"fn_sig"],[3,"coerce_unsized_info"],[3,"typeck_item_bodies"],[3,"typeck_tables_of"],[3,"used_trait_imports"],[3,"has_typeck_tables"],[3,"coherent_trait"],[3,"borrowck"],[3,"mir_borrowck"],[3,"crate_inherent_impls"],[3,"crate_inherent_impls_overlap_check"],[3,"const_eval"],[3,"const_value_to_allocation"],[3,"check_match"],[3,"privacy_access_levels"],[3,"reachable_set"],[3,"region_scope_tree"],[3,"mir_shims"],[3,"def_symbol_name"],[3,"symbol_name"],[3,"describe_def"],[3,"def_span"],[3,"lookup_stability"],[3,"lookup_deprecation_entry"],[3,"item_attrs"],[3,"codegen_fn_attrs"],[3,"fn_arg_names"],[3,"rendered_const"],[3,"impl_parent"],[3,"trait_of_item"],[3,"const_is_rvalue_promotable_to_static"],[3,"rvalue_promotable_map"],[3,"is_mir_available"],[3,"vtable_methods"],[3,"codegen_fulfill_obligation"],[3,"trait_impls_of"],[3,"specialization_graph_of"],[3,"is_object_safe"],[3,"param_env"],[3,"is_copy_raw"],[3,"is_sized_raw"],[3,"is_freeze_raw"],[3,"needs_drop_raw"],[3,"layout_raw"],[3,"dylib_dependency_formats"],[3,"is_panic_runtime"],[3,"is_compiler_builtins"],[3,"has_global_allocator"],[3,"is_sanitizer_runtime"],[3,"is_profiler_runtime"],[3,"panic_strategy"],[3,"is_no_builtins"],[3,"extern_crate"],[3,"specializes"],[3,"in_scope_traits_map"],[3,"module_exports"],[3,"lint_levels"],[3,"impl_defaultness"],[3,"check_item_well_formed"],[3,"check_trait_item_well_formed"],[3,"check_impl_item_well_formed"],[3,"reachable_non_generics"],[3,"is_reachable_non_generic"],[3,"is_unreachable_local_definition"],[3,"upstream_monomorphizations"],[3,"upstream_monomorphizations_for"],[3,"native_libraries"],[3,"foreign_modules"],[3,"plugin_registrar_fn"],[3,"derive_registrar_fn"],[3,"crate_disambiguator"],[3,"crate_hash"],[3,"original_crate_name"],[3,"extra_filename"],[3,"implementations_of_trait"],[3,"all_trait_implementations"],[3,"dllimport_foreign_items"],[3,"is_dllimport_foreign_item"],[3,"is_statically_included_foreign_item"],[3,"native_library_kind"],[3,"link_args"],[3,"resolve_lifetimes"],[3,"named_region_map"],[3,"is_late_bound_map"],[3,"object_lifetime_defaults_map"],[3,"visibility"],[3,"dep_kind"],[3,"crate_name"],[3,"item_children"],[3,"extern_mod_stmt_cnum"],[3,"get_lang_items"],[3,"defined_lang_items"],[3,"missing_lang_items"],[3,"visible_parent_map"],[3,"missing_extern_crate_item"],[3,"used_crate_source"],[3,"postorder_cnums"],[3,"freevars"],[3,"maybe_unused_trait_import"],[3,"maybe_unused_extern_crates"],[3,"stability_index"],[3,"all_crate_nums"],[3,"all_traits"],[3,"exported_symbols"],[3,"collect_and_partition_mono_items"],[3,"is_codegened_item"],[3,"codegen_unit"],[3,"compile_codegen_unit"],[3,"output_filenames"],[3,"erase_regions_ty"],[3,"normalize_projection_ty"],[3,"normalize_ty_after_erasing_regions"],[3,"implied_outlives_bounds"],[3,"dropck_outlives"],[3,"evaluate_obligation"],[3,"type_op_eq"],[3,"type_op_subtype"],[3,"type_op_prove_predicate"],[3,"type_op_normalize_ty"],[3,"type_op_normalize_predicate"],[3,"type_op_normalize_poly_fn_sig"],[3,"type_op_normalize_fn_sig"],[3,"substitute_normalize_and_test_predicates"],[3,"target_features_whitelist"],[3,"instance_def_size_estimate"],[3,"features_query"],[3,"program_clauses_for"],[3,"program_clauses_for_env"],[3,"wasm_import_module_map"],[3,"GeneratorWitness"],[4,"Cause"],[8,"TypeRelation"],[8,"Relate"],[3,"Steal"],[3,"Kind"],[3,"SubstFolder"],[4,"UnpackedKind"],[8,"Subst"],[6,"Substs"],[3,"TraitDef"],[3,"TraitImpls"],[3,"TypeWalker"],[3,"WfPredicates"],[4,"Elaborate"],[3,"Discr"],[4,"CopyImplementationError"],[4,"Representability"],[4,"ExplicitSelf"],[8,"IntTypeExt"],[3,"CtxtInterners"],[3,"CommonTypes"],[3,"LocalTableInContext"],[3,"LocalTableInContextMut"],[3,"GlobalCtxt"],[3,"Interned"],[8,"Lift"],[8,"InternAs"],[8,"InternIteratorElement"],[3,"FlagComputation"],[3,"SplitClosureSubsts"],[3,"SplitGeneratorSubsts"],[6,"PolyTraitRef"],[6,"PolyExistentialTraitRef"],[6,"PolyGenSig"],[6,"PolyFnSig"],[6,"PolyExistentialProjection"],[8,"DefIdTree"],[8,"ToPolyTraitRef"],[8,"ToPredicate"],[6,"PolyTraitPredicate"],[6,"PolyProjectionPredicate"],[6,"PolyRegionOutlivesPredicate"],[6,"PolyTypeOutlivesPredicate"],[3,"DEFAULT_HOOK"],[3,"ProfQDumpParams"],[3,"QueryMsg"],[3,"Indenter"],[4,"ProfileQueriesMsg"],[8,"MemoizationMap"],[3,"ErrorReported"],[3,"LateBoundRegionNameCollector"],[3,"PrintContext"],[8,"Print"],[4,"LinkOrCopy"],[4,"RenameOrCopyRemove"],[3,"Timing"],[3,"TimelineId"],[3,"PerThread"],[3,"TimeGraph"],[3,"WorkPackageKind"],[3,"Timeline"],[3,"RaiiToken"],[6,"Ty"],[6,"Region"],[6,"RelateResult"]]};
searchIndex["rustc_allocator"]={"doc":"","items":[[3,"AllocatorMethod","rustc_allocator","",N,N],[12,"name","","",0,N],[12,"inputs","","",0,N],[12,"output","","",0,N],[4,"AllocatorTy","","",N,N],[13,"Layout","","",1,N],[13,"Ptr","","",1,N],[13,"ResultPtr","","",1,N],[13,"Unit","","",1,N],[13,"Usize","","",1,N],[0,"expand","","",N,N],[3,"ExpandAllocatorDirectives","rustc_allocator::expand","",N,N],[12,"found","","",2,N],[12,"handler","","",2,N],[12,"sess","","",2,N],[12,"resolver","","",2,N],[12,"crate_name","","",2,N],[12,"in_submod","","",2,N],[3,"AllocFnFactory","","",N,N],[12,"span","","",3,N],[12,"kind","","",3,N],[12,"global","","",3,N],[12,"core","","",3,N],[12,"cx","","",3,N],[5,"modify","","",N,[[["parsesess"],["resolver"],["crate"],["string"],["handler"]],["crate"]]],[11,"fold_item","","",2,[[["self"],["p",["item"]]],["smallvector",["p"]]]],[11,"fold_mod","","",2,[[["self"],["mod"]],["mod"]]],[11,"fold_mac","","",2,[[["self"],["mac"]],["mac"]]],[11,"allocator_fn","","",3,[[["self"],["allocatormethod"]],["p",["item"]]]],[11,"call_allocator","","",3,[[["self"],["str"],["vec",["p"]]],["p",["expr"]]]],[11,"attrs","","",3,[[["self"]],["vec",["attribute"]]]],[11,"arg_ty","","",3,[[["self"],["allocatorty"],["vec"],["fnmut"]],["p",["expr"]]]],[11,"ret_ty","","",3,N],[11,"usize","","",3,[[["self"]],["p",["ty"]]]],[11,"ptr_u8","","",3,[[["self"]],["p",["ty"]]]],[7,"ALLOCATOR_METHODS","rustc_allocator","",N,N]],"paths":[[3,"AllocatorMethod"],[4,"AllocatorTy"],[3,"ExpandAllocatorDirectives"],[3,"AllocFnFactory"]]};
searchIndex["rustc_apfloat"]={"doc":"Port of LLVM's APFloat software floating-point implementation from the following C++ sources (please update commit hash when backporting): https://github.com/llvm-mirror/llvm/tree/23efab2bbd424ed13495a420ad8641cb2c6c28f9","items":[[3,"Status","rustc_apfloat","IEEE-754R 7: Default exception handling.",N,N],[12,"bits","","",0,N],[3,"StatusAnd","","",N,N],[12,"status","","",1,N],[12,"value","","",1,N],[3,"ParseError","","",N,N],[12,"0","","",2,N],[4,"Category","","Category of internally-represented number.",N,N],[13,"Infinity","","",3,N],[13,"NaN","","",3,N],[13,"Normal","","",3,N],[13,"Zero","","",3,N],[4,"Round","","IEEE-754R 4.3: Rounding-direction attributes.",N,N],[13,"NearestTiesToEven","","",4,N],[13,"TowardPositive","","",4,N],[13,"TowardNegative","","",4,N],[13,"TowardZero","","",4,N],[13,"NearestTiesToAway","","",4,N],[0,"ieee","","",N,N],[3,"IeeeFloat","rustc_apfloat::ieee","",N,N],[12,"sig","","Absolute significand value (including the integer bit).",5,N],[12,"exp","","The signed unbiased exponent of the value.",5,N],[12,"category","","What kind of floating point number this is.",5,N],[12,"sign","","Sign bit of the number.",5,N],[12,"marker","","",5,N],[3,"HalfS","","",N,N],[3,"SingleS","","",N,N],[3,"DoubleS","","",N,N],[3,"QuadS","","",N,N],[3,"X87DoubleExtendedS","","",N,N],[4,"Loss","","Enum that represents what fraction of the LSB truncated bits of an fp number represent.",N,N],[13,"ExactlyZero","","",6,N],[13,"LessThanHalf","","",6,N],[13,"ExactlyHalf","","",6,N],[13,"MoreThanHalf","","",6,N],[5,"limbs_for_bits","","",N,[[["usize"]],["usize"]]],[0,"sig","","Implementation details of IeeeFloat significands, such as big integer arithmetic. As a rule of thumb, no functions in this module should dynamically allocate.",N,N],[5,"is_all_zeros","rustc_apfloat::ieee::sig","",N,N],[5,"olsb","","One, not zero, based LSB. That is, returns 0 for a zeroed significand.",N,N],[5,"omsb","","One, not zero, based MSB. That is, returns 0 for a zeroed significand.",N,N],[5,"cmp","","Comparison (unsigned) of two significands.",N,N],[5,"get_bit","","Extract the given bit.",N,N],[5,"set_bit","","Set the given bit.",N,N],[5,"clear_bit","","Clear the given bit.",N,N],[5,"shift_left","","Shift `dst` left `bits` bits, subtract `bits` from its exponent.",N,N],[5,"shift_right","","Shift `dst` right `bits` bits noting lost fraction.",N,N],[5,"extract","","Copy the bit vector of width `src_bits` from `src`, starting at bit SRC_LSB, to `dst`, such that the bit SRC_LSB becomes the least significant bit of `dst`. All high bits above `src_bits` in `dst` are zero-filled.",N,N],[5,"from_limbs","","We want the most significant PRECISION bits of `src`. There may not be that many; extract what we can.",N,N],[5,"each_chunk","","For every consecutive chunk of `bits` bits from `limbs`, going from most significant to the least significant bits, call `f` to transform those bits and store the result back.",N,N],[5,"increment","","Increment in-place, return the carry flag.",N,N],[5,"decrement","","Decrement in-place, return the borrow flag.",N,N],[5,"add","","`a += b + c` where `c` is zero or one. Returns the carry flag.",N,N],[5,"sub","","`a -= b + c` where `c` is zero or one. Returns the borrow flag.",N,N],[5,"add_or_sub","","`a += b` or `a -= b`. Does not preserve `b`.",N,N],[5,"widening_mul","","`[low, high] = a * b`.",N,N],[5,"mul","","`dst = a * b` (for normal `a` and `b`). Returns the lost fraction.",N,N],[5,"div","","`quotient = dividend / divisor`. Returns the lost fraction. Does not preserve `dividend` or `divisor`.",N,N],[6,"Limb","rustc_apfloat::ieee","Fundamental unit of big integer arithmetic, but also large to store the largest significands by itself.",N,N],[6,"Half","","",N,N],[6,"Single","","",N,N],[6,"Double","","",N,N],[6,"Quad","","",N,N],[6,"X87DoubleExtended","","",N,N],[17,"LIMB_BITS","","",N,N],[8,"Semantics","","Represents floating point arithmetic semantics.",N,N],[18,"BITS","","Total number of bits in the in-memory format.",7,N],[18,"PRECISION","","Number of bits in the significand. This includes the integer bit.",7,N],[18,"MAX_EXP","","The largest E such that 2E is representable; this matches the definition of IEEE 754.",7,N],[18,"MIN_EXP","","The smallest E such that 2E is a normalized number; this matches the definition of IEEE 754.",7,N],[18,"QNAN_BIT","","The significand bit that marks NaN as quiet.",7,N],[18,"QNAN_SIGNIFICAND","","The significand bitpattern to mark a NaN as quiet. NOTE: for X87DoubleExtended we need to set two bits instead of 2.",7,N],[11,"from_bits","","",7,[[["u128"]],["ieeefloat"]]],[11,"to_bits","","",7,[[["ieeefloat"]],["u128"]]],[11,"clone","","",6,[[["self"]],["loss"]]],[11,"eq","","",6,[[["self"],["loss"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"clone","","",5,[[["self"]],["self"]]],[11,"from_bits","","Integer bit is explicit in this format. Intel hardware (387 and later) does not support these bit patterns:  exponent = all 1's, integer bit 0, significand 0 (\"pseudoinfinity\")  exponent = all 1's, integer bit 0, significand nonzero (\"pseudoNaN\")  exponent = 0, integer bit 1 (\"pseudodenormal\")  exponent!=0 nor all 1's, integer bit 0 (\"unnormal\") At the moment, the first two are treated as NaNs, the second two as Normal.",8,[[["u128"]],["ieeefloat"]]],[11,"to_bits","","",8,[[["ieeefloat"]],["u128"]]],[11,"default","","",5,[[],["self"]]],[11,"from_str","","",5,[[["str"]],["result",["parseerror"]]]],[11,"add","","",5,[[["self"],["self"]],["statusand"]]],[11,"sub","","",5,[[["self"],["self"]],["statusand"]]],[11,"mul","","",5,[[["self"],["self"]],["statusand"]]],[11,"div","","",5,[[["self"],["self"]],["statusand"]]],[11,"rem","","",5,[[["self"],["self"]],["statusand"]]],[11,"add_assign","","",5,[[["self"],["self"]]]],[11,"sub_assign","","",5,[[["self"],["self"]]]],[11,"mul_assign","","",5,[[["self"],["self"]]]],[11,"div_assign","","",5,[[["self"],["self"]]]],[11,"rem_assign","","",5,[[["self"],["self"]]]],[11,"eq","","",5,[[["self"],["self"]],["bool"]]],[11,"partial_cmp","","",5,[[["self"],["self"]],["option",["ordering"]]]],[11,"neg","","",5,[[["self"]],["self"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"qnan","","",5,[[["option",["u128"]]],["self"]]],[11,"snan","","",5,[[["option",["u128"]]],["self"]]],[11,"largest","","",5,[[],["self"]]],[11,"smallest_normalized","","",5,[[],["self"]]],[11,"add_r","","",5,[[["self"],["self"],["round"]],["statusand"]]],[11,"mul_r","","",5,[[["self"],["self"],["round"]],["statusand"]]],[11,"mul_add_r","","",5,[[["self"],["self"],["self"],["round"]],["statusand"]]],[11,"div_r","","",5,[[["self"],["self"],["round"]],["statusand"]]],[11,"c_fmod","","",5,[[["self"],["self"]],["statusand"]]],[11,"round_to_integral","","",5,[[["self"],["round"]],["statusand"]]],[11,"next_up","","",5,[[["self"]],["statusand"]]],[11,"from_bits","","",5,[[["u128"]],["self"]]],[11,"from_u128_r","","",5,[[["u128"],["round"]],["statusand"]]],[11,"from_str_r","","",5,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[11,"to_bits","","",5,[[["self"]],["u128"]]],[11,"to_u128_r","","",5,[[["self"],["usize"],["round"],["bool"]],["statusand",["u128"]]]],[11,"cmp_abs_normal","","",5,[[["self"],["self"]],["ordering"]]],[11,"bitwise_eq","","",5,[[["self"],["self"]],["bool"]]],[11,"is_negative","","",5,[[["self"]],["bool"]]],[11,"is_denormal","","",5,[[["self"]],["bool"]]],[11,"is_signaling","","",5,[[["self"]],["bool"]]],[11,"category","","",5,[[["self"]],["category"]]],[11,"get_exact_inverse","","",5,[[["self"]],["option"]]],[11,"ilogb","","",5,[[["self"]],["expint"]]],[11,"scalbn_r","","",5,[[["self"],["expint"],["round"]],["self"]]],[11,"frexp_r","","",5,[[["self"],["expint"],["round"]],["self"]]],[11,"convert_r","","",5,[[["self"],["round"],["bool"]],["statusand",["ieeefloat"]]]],[11,"overflow_result","","Handle positive overflow. We either return infinity or the largest finite number. For negative overflow, negate the `round` argument before calling.",5,[[["round"]],["statusand"]]],[11,"round_away_from_zero","","Returns TRUE if, when truncating the current number, with BIT the new LSB, with the given lost fraction and rounding mode, the result would need to be rounded away from zero (i.e., by increasing the signficand). This routine must work for Category::Zero of both signs, and Category::Normal numbers.",5,[[["self"],["round"],["loss"],["usize"]],["bool"]]],[11,"normalize","","",5,[[["self"],["round"],["loss"]],["statusand"]]],[11,"from_hexadecimal_string","","",5,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[11,"from_decimal_string","","",5,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[11,"combine","","Combine the effect of two lost fractions.",6,[[["self"],["loss"]],["loss"]]],[11,"through_truncation","","Return the fraction lost were a bignum truncated losing the least significant `bits` bits.",6,N],[0,"ppc","rustc_apfloat","",N,N],[3,"DoubleFloat","rustc_apfloat::ppc","",N,N],[12,"0","","",9,N],[12,"1","","",9,N],[3,"FallbackS","","",N,N],[12,"0","","",10,N],[3,"FallbackExtendedS","","",N,N],[12,"0","","",11,N],[6,"DoubleDouble","","",N,N],[6,"Fallback","","",N,N],[6,"FallbackExtended","","",N,N],[11,"clone","","",9,[[["self"]],["doublefloat"]]],[11,"eq","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"ne","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"partial_cmp","","",9,[[["self"],["doublefloat"]],["option",["ordering"]]]],[11,"lt","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"le","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"gt","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"ge","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"from","","",9,[[["ieeefloat",["fallbacks"]]],["self"]]],[11,"from","rustc_apfloat::ieee","",5,[[["doublefloat"]],["self"]]],[11,"default","rustc_apfloat::ppc","",9,[[],["self"]]],[11,"from_str","","",9,[[["str"]],["result",["parseerror"]]]],[11,"add","","",9,[[["self"],["self"]],["statusand"]]],[11,"sub","","",9,[[["self"],["self"]],["statusand"]]],[11,"mul","","",9,[[["self"],["self"]],["statusand"]]],[11,"div","","",9,[[["self"],["self"]],["statusand"]]],[11,"rem","","",9,[[["self"],["self"]],["statusand"]]],[11,"add_assign","","",9,[[["self"],["self"]]]],[11,"sub_assign","","",9,[[["self"],["self"]]]],[11,"mul_assign","","",9,[[["self"],["self"]]]],[11,"div_assign","","",9,[[["self"],["self"]]]],[11,"rem_assign","","",9,[[["self"],["self"]]]],[11,"neg","","",9,[[["self"]],["self"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"qnan","","",9,[[["option",["u128"]]],["self"]]],[11,"snan","","",9,[[["option",["u128"]]],["self"]]],[11,"largest","","",9,[[],["self"]]],[11,"smallest_normalized","","",9,[[],["self"]]],[11,"add_r","","",9,[[["self"],["self"],["round"]],["statusand"]]],[11,"mul_r","","",9,[[["self"],["self"],["round"]],["statusand"]]],[11,"mul_add_r","","",9,[[["self"],["self"],["self"],["round"]],["statusand"]]],[11,"div_r","","",9,[[["self"],["self"],["round"]],["statusand"]]],[11,"c_fmod","","",9,[[["self"],["self"]],["statusand"]]],[11,"round_to_integral","","",9,[[["self"],["round"]],["statusand"]]],[11,"next_up","","",9,[[["self"]],["statusand"]]],[11,"from_bits","","",9,[[["u128"]],["self"]]],[11,"from_u128_r","","",9,[[["u128"],["round"]],["statusand"]]],[11,"from_str_r","","",9,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[11,"to_bits","","",9,[[["self"]],["u128"]]],[11,"to_u128_r","","",9,[[["self"],["usize"],["round"],["bool"]],["statusand",["u128"]]]],[11,"cmp_abs_normal","","",9,[[["self"],["self"]],["ordering"]]],[11,"bitwise_eq","","",9,[[["self"],["self"]],["bool"]]],[11,"is_negative","","",9,[[["self"]],["bool"]]],[11,"is_denormal","","",9,[[["self"]],["bool"]]],[11,"is_signaling","","",9,[[["self"]],["bool"]]],[11,"category","","",9,[[["self"]],["category"]]],[11,"get_exact_inverse","","",9,[[["self"]],["option"]]],[11,"ilogb","","",9,[[["self"]],["expint"]]],[11,"scalbn_r","","",9,[[["self"],["expint"],["round"]],["self"]]],[11,"frexp_r","","",9,[[["self"],["expint"],["round"]],["self"]]],[6,"ExpInt","rustc_apfloat","A signed type to represent a floating point number's unbiased exponent.",N,N],[17,"IEK_INF","","",N,N],[17,"IEK_NAN","","",N,N],[17,"IEK_ZERO","","",N,N],[8,"Float","","A self-contained host- and target-independent arbitrary-precision floating-point software implementation.",N,N],[18,"BITS","","Total number of bits in the in-memory format.",12,N],[18,"PRECISION","","Number of bits in the significand. This includes the integer bit.",12,N],[18,"MAX_EXP","","The largest E such that 2E is representable; this matches the definition of IEEE 754.",12,N],[18,"MIN_EXP","","The smallest E such that 2E is a normalized number; this matches the definition of IEEE 754.",12,N],[18,"ZERO","","Positive Zero.",12,N],[18,"INFINITY","","Positive Infinity.",12,N],[18,"NAN","","NaN (Not a Number).",12,N],[10,"qnan","","Factory for QNaN values.",12,[[["option",["u128"]]],["self"]]],[10,"snan","","Factory for SNaN values.",12,[[["option",["u128"]]],["self"]]],[10,"largest","","Largest finite number.",12,[[],["self"]]],[18,"SMALLEST","","Smallest (by magnitude) finite number. Might be denormalized, which implies a relative loss of precision.",12,N],[10,"smallest_normalized","","Smallest (by magnitude) normalized finite number.",12,[[],["self"]]],[10,"add_r","","",12,[[["self"],["self"],["round"]],["statusand"]]],[11,"sub_r","","",12,[[["self"],["self"],["round"]],["statusand"]]],[10,"mul_r","","",12,[[["self"],["self"],["round"]],["statusand"]]],[10,"mul_add_r","","",12,[[["self"],["self"],["self"],["round"]],["statusand"]]],[11,"mul_add","","",12,[[["self"],["self"],["self"]],["statusand"]]],[10,"div_r","","",12,[[["self"],["self"],["round"]],["statusand"]]],[11,"ieee_rem","","IEEE remainder.",12,[[["self"],["self"]],["statusand"]]],[10,"c_fmod","","C fmod, or llvm frem.",12,[[["self"],["self"]],["statusand"]]],[10,"round_to_integral","","",12,[[["self"],["round"]],["statusand"]]],[10,"next_up","","IEEE-754R 2008 5.3.1: nextUp.",12,[[["self"]],["statusand"]]],[11,"next_down","","IEEE-754R 2008 5.3.1: nextDown.",12,[[["self"]],["statusand"]]],[11,"abs","","",12,[[["self"]],["self"]]],[11,"copy_sign","","",12,[[["self"],["self"]],["self"]]],[10,"from_bits","","",12,[[["u128"]],["self"]]],[11,"from_i128_r","","",12,[[["i128"],["round"]],["statusand"]]],[11,"from_i128","","",12,[[["i128"]],["statusand"]]],[10,"from_u128_r","","",12,[[["u128"],["round"]],["statusand"]]],[11,"from_u128","","",12,[[["u128"]],["statusand"]]],[10,"from_str_r","","",12,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[10,"to_bits","","",12,[[["self"]],["u128"]]],[11,"to_i128_r","","Convert a floating point number to an integer according to the rounding mode. In case of an invalid operation exception, deterministic values are returned, namely zero for NaNs and the minimal or maximal value respectively for underflow or overflow. If the rounded value is in range but the floating point number is not the exact integer, the C standard doesn't require an inexact exception to be raised. IEEE-854 does require it so we do that.",12,[[["self"],["usize"],["round"],["bool"]],["statusand",["i128"]]]],[11,"to_i128","","",12,[[["self"],["usize"]],["statusand",["i128"]]]],[10,"to_u128_r","","",12,[[["self"],["usize"],["round"],["bool"]],["statusand",["u128"]]]],[11,"to_u128","","",12,[[["self"],["usize"]],["statusand",["u128"]]]],[10,"cmp_abs_normal","","",12,[[["self"],["self"]],["ordering"]]],[10,"bitwise_eq","","Bitwise comparison for equality (QNaNs compare equal, 0!=-0).",12,[[["self"],["self"]],["bool"]]],[11,"min","","Implements IEEE minNum semantics. Returns the smaller of the 2 arguments if both are not NaN. If either argument is a NaN, returns the other argument.",12,[[["self"],["self"]],["self"]]],[11,"max","","Implements IEEE maxNum semantics. Returns the larger of the 2 arguments if both are not NaN. If either argument is a NaN, returns the other argument.",12,[[["self"],["self"]],["self"]]],[10,"is_negative","","IEEE-754R isSignMinus: Returns true if and only if the current value is negative.",12,[[["self"]],["bool"]]],[11,"is_normal","","IEEE-754R isNormal: Returns true if and only if the current value is normal.",12,[[["self"]],["bool"]]],[11,"is_finite","","Returns true if and only if the current value is zero, subnormal, or normal.",12,[[["self"]],["bool"]]],[11,"is_zero","","Returns true if and only if the float is plus or minus zero.",12,[[["self"]],["bool"]]],[10,"is_denormal","","IEEE-754R isSubnormal(): Returns true if and only if the float is a denormal.",12,[[["self"]],["bool"]]],[11,"is_infinite","","IEEE-754R isInfinite(): Returns true if and only if the float is infinity.",12,[[["self"]],["bool"]]],[11,"is_nan","","Returns true if and only if the float is a quiet or signaling NaN.",12,[[["self"]],["bool"]]],[10,"is_signaling","","Returns true if and only if the float is a signaling NaN.",12,[[["self"]],["bool"]]],[10,"category","","",12,[[["self"]],["category"]]],[11,"is_non_zero","","",12,[[["self"]],["bool"]]],[11,"is_finite_non_zero","","",12,[[["self"]],["bool"]]],[11,"is_pos_zero","","",12,[[["self"]],["bool"]]],[11,"is_neg_zero","","",12,[[["self"]],["bool"]]],[11,"is_smallest","","Returns true if and only if the number has the smallest possible non-zero magnitude in the current semantics.",12,[[["self"]],["bool"]]],[11,"is_largest","","Returns true if and only if the number has the largest possible finite magnitude in the current semantics.",12,[[["self"]],["bool"]]],[11,"is_integer","","Returns true if and only if the number is an exact integer.",12,[[["self"]],["bool"]]],[10,"get_exact_inverse","","If this value has an exact multiplicative inverse, return it.",12,[[["self"]],["option"]]],[10,"ilogb","","Returns the exponent of the internal representation of the Float.",12,[[["self"]],["expint"]]],[10,"scalbn_r","","Returns: self * 2exp for integral exponents.",12,[[["self"],["expint"],["round"]],["self"]]],[11,"scalbn","","",12,[[["self"],["expint"]],["self"]]],[10,"frexp_r","","Equivalent of C standard library function.",12,[[["self"],["expint"],["round"]],["self"]]],[11,"frexp","","",12,[[["self"],["expint"]],["self"]]],[8,"FloatConvert","","",N,N],[10,"convert_r","","Convert a value of one floating point type to another. The return value corresponds to the IEEE754 exceptions. *loses_info records whether the transformation lost information, i.e. whether converting the result back to the original type will produce the original value (this is almost the same as return value==Status::OK, but there are edge cases where this is not so).",13,[[["self"],["round"],["bool"]],["statusand"]]],[11,"convert","","",13,[[["self"],["bool"]],["statusand"]]],[11,"eq","","",0,[[["self"],["status"]],["bool"]]],[11,"ne","","",0,[[["self"],["status"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"clone","","",0,[[["self"]],["status"]]],[11,"partial_cmp","","",0,[[["self"],["status"]],["option",["ordering"]]]],[11,"lt","","",0,[[["self"],["status"]],["bool"]]],[11,"le","","",0,[[["self"],["status"]],["bool"]]],[11,"gt","","",0,[[["self"],["status"]],["bool"]]],[11,"ge","","",0,[[["self"],["status"]],["bool"]]],[11,"cmp","","",0,[[["self"],["status"]],["ordering"]]],[11,"hash","","",0,N],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[18,"OK","","",0,N],[18,"INVALID_OP","","",0,N],[18,"DIV_BY_ZERO","","",0,N],[18,"OVERFLOW","","",0,N],[18,"UNDERFLOW","","",0,N],[18,"INEXACT","","",0,N],[11,"empty","","Returns an empty set of flags.",0,[[],["status"]]],[11,"all","","Returns the set containing all flags.",0,[[],["status"]]],[11,"bits","","Returns the raw value of the flags currently stored.",0,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",0,[[["u8"]],["option",["status"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",0,[[["u8"]],["status"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",0,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",0,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",0,[[["self"],["status"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",0,[[["self"],["status"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",0,[[["self"],["status"]]]],[11,"remove","","Removes the specified flags in-place.",0,[[["self"],["status"]]]],[11,"toggle","","Toggles the specified flags in-place.",0,[[["self"],["status"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",0,[[["self"],["status"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",0,[[["self"],["status"]],["status"]]],[11,"bitor_assign","","Adds the set of flags.",0,[[["self"],["status"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",0,[[["self"],["status"]],["status"]]],[11,"bitxor_assign","","Toggles the set of flags.",0,[[["self"],["status"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",0,[[["self"],["status"]],["status"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",0,[[["self"],["status"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",0,[[["self"],["status"]],["status"]]],[11,"sub_assign","","Disables all flags enabled in the set.",0,[[["self"],["status"]]]],[11,"not","","Returns the complement of this set of flags.",0,[[["self"]],["status"]]],[11,"extend","","",0,[[["self"],["t"]]]],[11,"from_iter","","",0,[[["t"]],["status"]]],[11,"clone","","",1,[[["self"]],["statusand"]]],[11,"eq","","",1,[[["self"],["statusand"]],["bool"]]],[11,"ne","","",1,[[["self"],["statusand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1,N],[11,"partial_cmp","","",1,[[["self"],["statusand"]],["option",["ordering"]]]],[11,"lt","","",1,[[["self"],["statusand"]],["bool"]]],[11,"le","","",1,[[["self"],["statusand"]],["bool"]]],[11,"gt","","",1,[[["self"],["statusand"]],["bool"]]],[11,"ge","","",1,[[["self"],["statusand"]],["bool"]]],[11,"cmp","","",1,[[["self"],["statusand"]],["ordering"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"and","","",0,[[["self"],["t"]],["statusand"]]],[11,"map","","",1,[[["self"],["f"]],["statusand"]]],[11,"clone","","",3,[[["self"]],["category"]]],[11,"eq","","",3,[[["self"],["category"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["round"]]],[11,"eq","","",4,[[["self"],["round"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"neg","","",4,[[["self"]],["round"]]],[11,"clone","","",2,[[["self"]],["parseerror"]]],[11,"eq","","",2,[[["self"],["parseerror"]],["bool"]]],[11,"ne","","",2,[[["self"],["parseerror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[14,"unpack","","",N,N]],"paths":[[3,"Status"],[3,"StatusAnd"],[3,"ParseError"],[4,"Category"],[4,"Round"],[3,"IeeeFloat"],[4,"Loss"],[8,"Semantics"],[3,"X87DoubleExtendedS"],[3,"DoubleFloat"],[3,"FallbackS"],[3,"FallbackExtendedS"],[8,"Float"],[8,"FloatConvert"]]};
searchIndex["rustc_borrowck"]={"doc":"","items":[[5,"check_crate","rustc_borrowck","",N,[[["tyctxt"]]]],[5,"build_borrowck_dataflow_data_for_fn","","Accessor for introspective clients inspecting `AnalysisData` and the `BorrowckCtxt` itself , e.g. the flowgraph visualizer.",N,N],[5,"provide","","",N,[[["providers"]]]],[0,"borrowck","","See The Book chapter on the borrow checker for more details.",N,N],[3,"LoanDataFlowOperator","rustc_borrowck::borrowck","",N,N],[3,"AnalysisData","","Collection of conclusions determined via borrow checker analyses.",N,N],[12,"all_loans","","",0,N],[12,"loans","","",0,N],[12,"move_data","","",0,N],[3,"BorrowckCtxt","","",N,N],[12,"tcx","","",1,N],[12,"tables","","",1,N],[12,"region_scope_tree","","",1,N],[12,"owner_def_id","","",1,N],[12,"body","","",1,N],[12,"used_mut_nodes","","",1,N],[12,"signalled_any_error","","",1,N],[3,"Loan","","Record of a loan that was issued.",N,N],[12,"index","","",2,N],[12,"loan_path","","",2,N],[12,"kind","","",2,N],[12,"restricted_paths","","",2,N],[12,"gen_scope","","gen_scope indicates where loan is introduced. Typically the loan is introduced at the point of the borrow, but in some cases, notably method arguments, the loan may be introduced only later, once it comes into scope.  See also `GatherLoanCtxt::compute_gen_scope`.",2,N],[12,"kill_scope","","kill_scope indicates when the loan goes out of scope.  This is either when the lifetime expires or when the local variable which roots the loan-path goes out of scope, whichever happens faster. See also `GatherLoanCtxt::compute_kill_scope`.",2,N],[12,"span","","",2,N],[12,"cause","","",2,N],[3,"LoanPath","","",N,N],[12,"kind","","",3,N],[12,"ty","","",3,N],[3,"BckError","","",N,N],[12,"span","","",4,N],[12,"cause","","",4,N],[12,"cmt","","",4,N],[12,"code","","",4,N],[4,"LoanPathKind","","",N,N],[13,"LpVar","","",5,N],[13,"LpUpvar","","",5,N],[13,"LpDowncast","","",5,N],[13,"LpExtend","","",5,N],[4,"InteriorKind","","",N,N],[13,"InteriorField","","",6,N],[13,"InteriorElement","","",6,N],[4,"LoanPathElem","","",N,N],[13,"LpDeref","","",7,N],[13,"LpInterior","","",7,N],[4,"bckerr_code","","",N,N],[13,"err_mutbl","","",8,N],[13,"err_out_of_scope","","superscope, subscope, loan cause",8,N],[13,"err_borrowed_pointer_too_short","","",8,N],[4,"AliasableViolationKind","","",N,N],[13,"MutabilityViolation","","",9,N],[13,"BorrowViolation","","",9,N],[4,"MovedValueUseKind","","",N,N],[13,"MovedInUse","","",10,N],[13,"MovedInCapture","","",10,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"borrowck","","",N,[[["tyctxt"],["defid"]],["lrc",["borrowcheckresult"]]]],[5,"build_borrowck_dataflow_data","","",N,[[["borrowckctxt"],["bool"],["bodyid"],["f"]],["option",["analysisdata"]]]],[5,"build_borrowck_dataflow_data_for_fn","","Accessor for introspective clients inspecting `AnalysisData` and the `BorrowckCtxt` itself , e.g. the flowgraph visualizer.",N,N],[5,"closure_to_block","","",N,[[["localdefid"],["tyctxt"]],["nodeid"]]],[5,"opt_loan_path_is_field","","",N,N],[5,"opt_loan_path","","Computes the `LoanPath` (if any) for a `cmt`. Note that this logic is somewhat duplicated in the method `compute()` found in `gather_loans::restrictions`, which allows it to share common loan path pieces as it traverses the CMT.",N,[[["cmt_"]],["option",["rc"]]]],[0,"check_loans","","",N,N],[3,"CheckLoanCtxt","rustc_borrowck::borrowck::check_loans","",N,N],[12,"bccx","","",11,N],[12,"dfcx_loans","","",11,N],[12,"move_data","","",11,N],[12,"all_loans","","",11,N],[12,"param_env","","",11,N],[12,"movable_generator","","",11,N],[4,"UseError","","",N,N],[13,"UseOk","","",12,N],[13,"UseWhileBorrowed","","",12,N],[5,"owned_ptr_base_path","","Returns the base of the leftmost dereference of an Unique in `loan_path`. If there is no dereference of an Unique in `loan_path`, then it just returns `loan_path` itself.",N,[[["loanpath"]],["loanpath"]]],[5,"owned_ptr_base_path_rc","","The equivalent of `owned_ptr_base_path` for an &Rc rather than a &LoanPath.",N,[[["rc"]],["rc",["loanpath"]]]],[5,"check_loans","","",N,N],[5,"compatible_borrow_kinds","","",N,[[["borrowkind"],["borrowkind"]],["bool"]]],[11,"consume","","",11,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"matched_pat","","",11,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume_pat","","",11,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[11,"borrow","","",11,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"mutate","","",11,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"decl_without_init","","",11,[[["self"],["nodeid"],["span"]]]],[11,"eq","","",12,[[["self"],["useerror"]],["bool"]]],[11,"ne","","",12,[[["self"],["useerror"]],["bool"]]],[11,"tcx","","",11,[[["self"]],["tyctxt"]]],[11,"each_issued_loan","","Iterates over each loan that has been issued on entrance to `node`, regardless of whether it is actually in scope at that point.  Sometimes loans are issued for future scopes and thus they may have been issued but not yet be in effect.",11,[[["self"],["itemlocalid"],["f"]],["bool"]]],[11,"each_in_scope_loan","","Like `each_issued_loan()`, but only considers loans that are currently in scope.",11,[[["self"],["scope"],["f"]],["bool"]]],[11,"each_in_scope_loan_affecting_path","","Iterates through all of the in-scope loans affecting `loan_path`, calling `op`, and ceasing iteration if `false` is returned.",11,[[["self"],["scope"],["loanpath"],["f"]],["bool"]]],[11,"loans_generated_by","","Returns a vector of the loans that are generated as we enter `node`.",11,[[["self"],["itemlocalid"]],["vec",["usize"]]]],[11,"check_for_loans_across_yields","","",11,[[["self"],["cmt_"],["region"],["span"]]]],[11,"check_for_conflicting_loans","","Checks to see whether any of the loans that are issued on entrance to `node` conflict with loans that have already been issued when we enter `node` (for example, we do not permit two `&mut` borrows of the same variable).",11,[[["self"],["itemlocalid"]]]],[11,"report_error_if_loans_conflict","","Checks whether `old_loan` and `new_loan` can safely be issued simultaneously.",11,[[["self"],["loan"],["loan"]],["bool"]]],[11,"report_error_if_loan_conflicts_with_restriction","","Checks whether the restrictions introduced by `loan1` would prohibit `loan2`. Returns false if an error is reported.",11,[[["self"],["loan"],["loan"],["loan"],["loan"]],["result",["diagnosticbuilder"]]]],[11,"consume_common","","",11,[[["self"],["itemlocalid"],["span"],["cmt_"],["consumemode"]]]],[11,"check_for_copy_of_frozen_path","","",11,[[["self"],["itemlocalid"],["span"],["loanpath"]]]],[11,"check_for_move_of_borrowed_path","","",11,[[["self"],["itemlocalid"],["span"],["loanpath"],["movekind"]]]],[11,"analyze_restrictions_on_use","","",11,[[["self"],["itemlocalid"],["loanpath"],["borrowkind"]],["useerror"]]],[11,"check_if_path_is_moved","","Reports an error if `expr` (which should be a path) is using a moved/uninitialized value",11,[[["self"],["itemlocalid"],["span"],["movedvalueusekind"],["rc"]]]],[11,"check_if_assigned_path_is_moved","","Reports an error if assigning to `lp` will use a moved/uninitialized value. Mainly this is concerned with detecting derefs of uninitialized pointers.",11,[[["self"],["itemlocalid"],["span"],["movedvalueusekind"],["rc"]]]],[11,"check_assignment","","",11,[[["self"],["itemlocalid"],["span"],["cmt_"]]]],[11,"report_illegal_mutation","","",11,[[["self"],["span"],["loanpath"],["loan"]]]],[0,"gather_loans","rustc_borrowck::borrowck","",N,N],[3,"GatherLoanCtxt","rustc_borrowck::borrowck::gather_loans","",N,N],[12,"bccx","","",13,N],[12,"move_data","","",13,N],[12,"move_error_collector","","",13,N],[12,"all_loans","","",13,N],[12,"item_ub","","`item_ub` is used as an upper-bound on the lifetime whenever we ask for the scope of an expression categorized as an upvar.",13,N],[5,"gather_loans_in_fn","","",N,N],[5,"check_aliasability","","Implements the A-* rules in README.md.",N,[[["borrowckctxt"],["span"],["aliasableviolationkind"],["cmt_"],["borrowkind"]],["result"]]],[5,"check_mutability","","Implements the M-* rules in README.md.",N,[[["borrowckctxt"],["span"],["aliasableviolationkind"],["cmt_"],["borrowkind"]],["result"]]],[0,"lifetime","","This module implements the check that the lifetime of a borrow does not exceed the lifetime of the value being borrowed.",N,N],[3,"GuaranteeLifetimeContext","rustc_borrowck::borrowck::gather_loans::lifetime","",N,N],[12,"bccx","","",14,N],[12,"item_scope","","",14,N],[12,"span","","",14,N],[12,"cause","","",14,N],[12,"loan_region","","",14,N],[12,"cmt_original","","",14,N],[5,"guarantee_lifetime","","Reports error if `loan_region` is larger than S where S is `item_scope` if `cmt` is an upvar, and is scope of `cmt` otherwise.",N,[[["borrowckctxt"],["scope"],["span"],["loancause"],["cmt_"],["region"],["borrowkind"]],["result"]]],[6,"R","","",N,N],[11,"check","","Main routine. Walks down `cmt` until we find the \"guarantor\".  Reports an error if `self.loan_region` is larger than scope of `cmt`.",14,[[["self"],["cmt_"],["option",["nodeid"]]],["result"]]],[11,"check_scope","","Reports an error if `loan_region` is larger than `max_scope`",14,[[["self"],["region"]],["result"]]],[11,"scope","","Returns the maximal region scope for the which the place `cmt` is guaranteed to be valid without any rooting etc, and presuming `cmt` is not mutated.",14,[[["self"],["cmt_"]],["region"]]],[11,"report_error","","",14,[[["self"],["bckerr_code"]]]],[0,"restrictions","rustc_borrowck::borrowck::gather_loans","Computes the restrictions that result from a borrow.",N,N],[3,"RestrictionsContext","rustc_borrowck::borrowck::gather_loans::restrictions","",N,N],[12,"bccx","","",15,N],[12,"span","","",15,N],[12,"loan_region","","",15,N],[12,"cause","","",15,N],[4,"RestrictionResult","","",N,N],[13,"Safe","","",16,N],[13,"SafeIf","","",16,N],[5,"compute_restrictions","","",N,[[["borrowckctxt"],["span"],["loancause"],["cmt_"],["region"]],["restrictionresult"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"restrict","","",15,[[["self"],["cmt_"]],["restrictionresult"]]],[11,"extend","","",15,[[["self"],["restrictionresult"],["cmt_"],["loanpathelem"]],["restrictionresult"]]],[0,"gather_moves","rustc_borrowck::borrowck::gather_loans","Computes moves.",N,N],[3,"GatherMoveInfo","rustc_borrowck::borrowck::gather_loans::gather_moves","",N,N],[12,"id","","",17,N],[12,"kind","","",17,N],[12,"cmt","","",17,N],[12,"span_path_opt","","",17,N],[4,"PatternSource","","Represents the kind of pattern",N,N],[13,"MatchExpr","","",18,N],[13,"LetDecl","","",18,N],[13,"Other","","",18,N],[5,"get_pattern_source","","Analyzes the context where the pattern appears to determine the kind of hint we want to give. In particular, if the pattern is in a `match` or nested within other patterns, we want to suggest a `ref` binding:",N,[[["tyctxt"],["pat"]],["patternsource"]]],[5,"gather_decl","","",N,[[["borrowckctxt"],["movedata"],["nodeid"],["ty"]]]],[5,"gather_move_from_expr","","",N,[[["borrowckctxt"],["movedata"],["moveerrorcollector"],["itemlocalid"],["cmt_"],["movereason"]]]],[5,"gather_move_from_pat","","",N,[[["borrowckctxt"],["movedata"],["moveerrorcollector"],["pat"],["cmt_"]]]],[5,"gather_move","","",N,[[["borrowckctxt"],["movedata"],["moveerrorcollector"],["gathermoveinfo"]]]],[5,"gather_assignment","","",N,[[["borrowckctxt"],["movedata"],["itemlocalid"],["span"],["rc",["loanpath"]],["itemlocalid"],["mutatemode"]]]],[5,"check_and_get_illegal_move_origin","","",N,[[["borrowckctxt"],["cmt_"]],["option",["cmt_"]]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",18,[[["self"]],["patternsource"]]],[0,"move_error","rustc_borrowck::borrowck::gather_loans","",N,N],[3,"MoveErrorCollector","rustc_borrowck::borrowck::gather_loans::move_error","",N,N],[12,"errors","","",19,N],[3,"MoveError","","",N,N],[12,"move_from","","",20,N],[12,"move_to","","",20,N],[3,"MovePlace","","",N,N],[12,"span","","",21,N],[12,"name","","",21,N],[12,"pat_source","","",21,N],[3,"GroupedMoveErrors","","",N,N],[12,"move_from","","",22,N],[12,"move_to_places","","",22,N],[5,"report_move_errors","","",N,N],[5,"group_errors_with_same_origin","","",N,N],[5,"report_cannot_move_out_of","","",N,[[["borrowckctxt"],["cmt"]],["diagnosticbuilder"]]],[5,"note_move_destination","","",N,[[["diagnosticbuilder"],["span"],["name"],["bool"]],["diagnosticbuilder"]]],[11,"new","","",19,[[],["moveerrorcollector"]]],[11,"add_error","","",19,[[["self"],["moveerror"]]]],[11,"report_potential_errors","","",19,[[["self"],["borrowckctxt"]]]],[11,"with_move_info","","",20,[[["cmt"],["option",["moveplace"]]],["moveerror"]]],[11,"clone","","",21,[[["self"]],["moveplace"]]],[11,"consume","rustc_borrowck::borrowck::gather_loans","",13,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"matched_pat","","",13,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume_pat","","",13,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[11,"borrow","","",13,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"mutate","","",13,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"decl_without_init","","",13,[[["self"],["nodeid"],["span"]]]],[11,"tcx","","",13,[[["self"]],["tyctxt"]]],[11,"guarantee_assignment_valid","","Guarantees that `cmt` is assignable, or reports an error.",13,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"guarantee_valid","","Guarantees that `addr_of(cmt)` will be valid for the duration of `static_scope_r`, or reports an error.  This may entail taking out loans, which will be added to the `req_loan_map`.",13,[[["self"],["itemlocalid"],["span"],["cmt_"],["borrowkind"],["region"],["loancause"]]]],[11,"mark_loan_path_as_mutated","","For mutable loans of content whose mutability derives from a local variable, mark the mutability decl as necessary.",13,[[["self"],["loanpath"]]]],[11,"compute_gen_scope","","Determine when to introduce the loan. Typically the loan is introduced at the point of the borrow, but in some cases, notably method arguments, the loan may be introduced only later, once it comes into scope.",13,[[["self"],["scope"],["scope"]],["scope"]]],[11,"compute_kill_scope","","Determine when the loan restrictions go out of scope. This is either when the lifetime expires or when the local variable which roots the loan-path goes out of scope, whichever happens faster.",13,[[["self"],["scope"],["loanpath"]],["scope"]]],[11,"report_potential_errors","","",13,[[["self"]]]],[0,"move_data","rustc_borrowck::borrowck","Data structures used for tracking moves. Please see the extensive comments in the section \"Moves and initialization\" in `README.md`.",N,N],[3,"MoveData","rustc_borrowck::borrowck::move_data","",N,N],[12,"paths","","Move paths. See section \"Move paths\" in `README.md`.",23,N],[12,"path_map","","Cache of loan path to move path index, for easy lookup.",23,N],[12,"moves","","Each move or uninitialized variable gets an entry here.",23,N],[12,"var_assignments","","Assignments to a variable, like `x = foo`. These are assigned bits for dataflow, since we must track them to ensure that immutable variables are assigned at most once along each path.",23,N],[12,"path_assignments","","Assignments to a path, like `x.f = foo`. These are not assigned dataflow bits, but we track them because they still kill move bits.",23,N],[12,"assignee_ids","","Assignments to a variable or path, like `x = foo`, but not `x += foo`.",23,N],[3,"FlowedMoveData","","",N,N],[12,"move_data","","",24,N],[12,"dfcx_moves","","",24,N],[12,"dfcx_assign","","",24,N],[3,"MovePathIndex","","Index into `MoveData.paths`, used like a pointer",N,N],[12,"0","","",25,N],[3,"MoveIndex","","Index into `MoveData.moves`, used like a pointer",N,N],[12,"0","","",26,N],[3,"MovePath","","",N,N],[12,"loan_path","","Loan path corresponding to this move path",27,N],[12,"parent","","Parent pointer, `InvalidMovePathIndex` if root",27,N],[12,"first_move","","Head of linked list of moves to this path, `InvalidMoveIndex` if not moved",27,N],[12,"first_child","","First node in linked list of children, `InvalidMovePathIndex` if leaf",27,N],[12,"next_sibling","","Next node in linked list of parent's children (siblings), `InvalidMovePathIndex` if none.",27,N],[3,"Move","","",N,N],[12,"path","","Path being moved.",28,N],[12,"id","","id of node that is doing the move.",28,N],[12,"kind","","Kind of move, for error messages.",28,N],[12,"next_move","","Next node in linked list of moves from `path`, or `InvalidMoveIndex`",28,N],[3,"Assignment","","",N,N],[12,"path","","Path being assigned.",29,N],[12,"id","","id where assignment occurs",29,N],[12,"span","","span of node where assignment occurs",29,N],[12,"assignee_id","","id for place expression on lhs of assignment",29,N],[3,"MoveDataFlowOperator","","",N,N],[3,"AssignDataFlowOperator","","",N,N],[4,"MoveKind","","",N,N],[13,"Declared","","",30,N],[13,"MoveExpr","","",30,N],[13,"MovePat","","",30,N],[13,"Captured","","",30,N],[5,"loan_path_is_precise","","",N,[[["loanpath"]],["bool"]]],[6,"MoveDataFlow","","",N,N],[6,"AssignDataFlow","","",N,N],[17,"InvalidMovePathIndex","","",N,N],[17,"InvalidMoveIndex","","",N,N],[11,"default","","",23,[[],["movedata"]]],[11,"eq","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"ne","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",25,N],[11,"partial_cmp","","",25,[[["self"],["movepathindex"]],["option",["ordering"]]]],[11,"lt","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"le","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"gt","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"ge","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"cmp","","",25,[[["self"],["movepathindex"]],["ordering"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"get","","",25,[[["self"]],["usize"]]],[11,"clone","","",25,[[["self"]],["movepathindex"]]],[11,"clone","","",26,[[["self"]],["moveindex"]]],[11,"eq","","",26,[[["self"],["moveindex"]],["bool"]]],[11,"ne","","",26,[[["self"],["moveindex"]],["bool"]]],[11,"get","","",26,[[["self"]],["usize"]]],[11,"clone","","",30,[[["self"]],["movekind"]]],[11,"eq","","",30,[[["self"],["movekind"]],["bool"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"clone","","",28,[[["self"]],["move"]]],[11,"clone","","",29,[[["self"]],["assignment"]]],[11,"clone","","",31,[[["self"]],["movedataflowoperator"]]],[11,"clone","","",32,[[["self"]],["assigndataflowoperator"]]],[11,"is_empty","","return true if there are no trackable assignments or moves in this move data - that means that there is nothing that could cause a borrow error.",23,[[["self"]],["bool"]]],[11,"path_loan_path","","",23,[[["self"],["movepathindex"]],["rc",["loanpath"]]]],[11,"path_parent","","",23,[[["self"],["movepathindex"]],["movepathindex"]]],[11,"path_first_move","","",23,[[["self"],["movepathindex"]],["moveindex"]]],[11,"path_first_child","","Returns the index of first child, or `InvalidMovePathIndex` if `index` is leaf.",23,[[["self"],["movepathindex"]],["movepathindex"]]],[11,"path_next_sibling","","",23,[[["self"],["movepathindex"]],["movepathindex"]]],[11,"set_path_first_move","","",23,[[["self"],["movepathindex"],["moveindex"]]]],[11,"set_path_first_child","","",23,[[["self"],["movepathindex"],["movepathindex"]]]],[11,"move_next_move","","Type safe indexing operator",23,[[["self"],["moveindex"]],["moveindex"]]],[11,"is_var_path","","True if `index` refers to a variable",23,[[["self"],["movepathindex"]],["bool"]]],[11,"move_path","","Returns the existing move path index for `lp`, if any, and otherwise adds a new index for `lp` and any of its base paths that do not yet have an index.",23,[[["self"],["tyctxt"],["rc",["loanpath"]]],["movepathindex"]]],[11,"existing_move_path","","",23,[[["self"],["rc"]],["option",["movepathindex"]]]],[11,"existing_base_paths","","",23,[[["self"],["rc"]],["vec",["movepathindex"]]]],[11,"add_existing_base_paths","","Adds any existing move path indices for `lp` and any base paths of `lp` to `result`, but does not add new move paths",23,[[["self"],["rc"],["vec"]]]],[11,"add_move","","Adds a new move entry for a move of `lp` that occurs at location `id` with kind `kind`.",23,[[["self"],["tyctxt"],["rc",["loanpath"]],["itemlocalid"],["movekind"]]]],[11,"add_move_helper","","",23,[[["self"],["tyctxt"],["rc",["loanpath"]],["itemlocalid"],["movekind"]]]],[11,"add_assignment","","Adds a new record for an assignment to `lp` that occurs at location `id` with the given `span`.",23,[[["self"],["tyctxt"],["rc",["loanpath"]],["itemlocalid"],["span"],["itemlocalid"],["mutatemode"]]]],[11,"add_assignment_helper","","",23,[[["self"],["tyctxt"],["rc",["loanpath"]],["itemlocalid"],["span"],["itemlocalid"],["mutatemode"]]]],[11,"add_gen_kills","","Adds the gen/kills for the various moves and assignments into the provided data flow contexts. Moves are generated by moves and killed by assignments and scoping. Assignments are generated by assignment to variables and killed by scoping. See `README.md` for more details.",23,[[["self"],["borrowckctxt"],["dataflowcontext"],["dataflowcontext"]]]],[11,"each_base_path","","",23,[[["self"],["movepathindex"],["f"]],["bool"]]],[11,"each_extending_path_","","",23,[[["self"],["movepathindex"],["f"]],["bool"]]],[11,"each_extending_path","","",23,[[["self"],["movepathindex"],["f"]],["bool"]]],[11,"each_applicable_move","","",23,[[["self"],["movepathindex"],["f"]],["bool"]]],[11,"kill_moves","","",23,[[["self"],["movepathindex"],["itemlocalid"],["killfrom"],["dataflowcontext"]]]],[11,"new","","",24,[[["movedata"],["borrowckctxt"],["cfg"],["idrange"],["body"]],["flowedmovedata"]]],[11,"kind_of_move_of_path","","Returns the kind of a move of `loan_path` by `id`, if one exists.",24,[[["self"],["itemlocalid"],["rc"]],["option",["movekind"]]]],[11,"each_move_of","","Iterates through each move of `loan_path` (or some base path of `loan_path`) that may have occurred on entry to `id` without an intervening assignment. In other words, any moves that would invalidate a reference to `loan_path` at location `id`.",24,[[["self"],["itemlocalid"],["rc"],["f"]],["bool"]]],[11,"each_assignment_of","","Iterates through every assignment to `loan_path` that may have occurred on entry to `id`. `loan_path` must be a single variable.",24,[[["self"],["itemlocalid"],["rc"],["f"]],["bool"]]],[11,"join","","",31,[[["self"],["usize"],["usize"]],["usize"]]],[11,"initial_value","","",31,[[["self"]],["bool"]]],[11,"join","","",32,[[["self"],["usize"],["usize"]],["usize"]]],[11,"initial_value","","",32,[[["self"]],["bool"]]],[0,"unused","rustc_borrowck::borrowck","",N,N],[3,"UsedMutFinder","rustc_borrowck::borrowck::unused","",N,N],[12,"bccx","","",33,N],[12,"set","","",33,N],[3,"UnusedMutCx","","",N,N],[12,"bccx","","",34,N],[12,"used_mut","","",34,N],[5,"check","","",N,[[["borrowckctxt"],["body"]]]],[11,"check_unused_mut_pat","","",34,N],[11,"nested_visit_map","","",34,[[["self"]],["nestedvisitormap"]]],[11,"visit_arm","","",34,[[["self"],["arm"]]]],[11,"visit_local","","",34,[[["self"],["local"]]]],[11,"nested_visit_map","","",33,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",33,[[["self"],["bodyid"]]]],[6,"LoanDataFlow","rustc_borrowck::borrowck","",N,N],[17,"DOWNCAST_PRINTED_OPERATOR","","",N,N],[8,"ToInteriorKind","","",N,N],[10,"cleaned","","",35,[[["self"]],["interiorkind"]]],[11,"clone","","",36,[[["self"]],["loandataflowoperator"]]],[11,"signal_error","","",1,[[["self"]]]],[11,"loan_path","","",2,[[["self"]],["rc",["loanpath"]]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"eq","","",3,[[["self"],["loanpath"]],["bool"]]],[11,"hash","","",3,[[["self"],["h"]]]],[11,"eq","","",5,[[["self"],["loanpathkind"]],["bool"]]],[11,"ne","","",5,[[["self"],["loanpathkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"hash","","",5,N],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"new","","",3,[[["loanpathkind"],["ty"]],["loanpath"]]],[11,"to_type","","",3,[[["self"]],["ty"]]],[11,"has_downcast","","",3,[[["self"]],["bool"]]],[11,"clone","","",6,[[["self"]],["interiorkind"]]],[11,"eq","","",6,[[["self"],["interiorkind"]],["bool"]]],[11,"ne","","",6,[[["self"],["interiorkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"hash","","",6,N],[11,"clone","","",7,[[["self"]],["loanpathelem"]]],[11,"eq","","",7,[[["self"],["loanpathelem"]],["bool"]]],[11,"ne","","",7,[[["self"],["loanpathelem"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"hash","","",7,N],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"kill_scope","","",3,[[["self"],["borrowckctxt"]],["scope"]]],[11,"has_fork","","",3,[[["self"],["loanpath"]],["bool"]]],[11,"depth","","",3,[[["self"]],["usize"]]],[11,"common","","",3,[[["self"],["loanpath"]],["option",["loanpath"]]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"eq","","",8,[[["self"],["bckerr_code"]],["bool"]]],[11,"ne","","",8,[[["self"],["bckerr_code"]],["bool"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["bckerror"]],["bool"]]],[11,"ne","","",4,[[["self"],["bckerror"]],["bool"]]],[11,"clone","","",9,[[["self"]],["aliasableviolationkind"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"eq","","",9,[[["self"],["aliasableviolationkind"]],["bool"]]],[11,"ne","","",9,[[["self"],["aliasableviolationkind"]],["bool"]]],[11,"clone","","",10,[[["self"]],["movedvalueusekind"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"is_subregion_of","","",1,[[["self"],["region"],["region"]],["bool"]]],[11,"report","","",1,[[["self"],["bckerror"]]]],[11,"report_use_of_moved_value","","",1,[[["self"],["span"],["movedvalueusekind"],["loanpath"],["move"],["loanpath"],["paramenv"]]]],[11,"report_partial_reinitialization_of_uninitialized_structure","","",1,[[["self"],["span"],["loanpath"]]]],[11,"report_reassigned_immutable_variable","","",1,[[["self"],["span"],["loanpath"],["assignment"]]]],[11,"struct_span_err_with_code","","",1,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"span_err_with_code","","",1,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"report_bckerr","","",1,[[["self"],["bckerror"]]]],[11,"report_aliasability_violation","","",1,[[["self"],["span"],["aliasableviolationkind"],["aliasablereason"],["cmt_"]]]],[11,"suggest_mut_for_immutable","","Given a type, if it is an immutable reference, return a suggestion to make it mutable",1,[[["self"],["ty"],["bool"]],["option",["string"]]]],[11,"local_binding_mode","","",1,[[["self"],["nodeid"]],["bindingmode"]]],[11,"local_ty","","",1,N],[11,"note_immutability_blame","","",1,[[["self"],["diagnosticbuilder"],["option",["immutabilityblame"]],["nodeid"]]]],[11,"note_immutable_local","","",1,[[["self"],["diagnosticbuilder"],["nodeid"],["nodeid"]]]],[11,"report_out_of_scope_escaping_closure_capture","","",1,[[["self"],["bckerror"],["span"]]]],[11,"region_end_span","","",1,[[["self"],["region"]],["option",["span"]]]],[11,"note_and_explain_mutbl_error","","",1,[[["self"],["diagnosticbuilder"],["bckerror"],["span"]]]],[11,"append_loan_path_to_string","","",1,[[["self"],["loanpath"],["string"]]]],[11,"append_autoderefd_loan_path_to_string","","",1,[[["self"],["loanpath"],["string"]]]],[11,"loan_path_to_string","","",1,[[["self"],["loanpath"]],["string"]]],[11,"cmt_to_string","","",1,[[["self"],["cmt_"]],["string"]]],[11,"cmt_to_path_or_string","","",1,[[["self"],["cmt_"]],["string"]]],[11,"join","","",36,[[["self"],["usize"],["usize"]],["usize"]]],[11,"initial_value","","",36,[[["self"]],["bool"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[0,"graphviz","rustc_borrowck","This module provides linkage between rustc::middle::graph and libgraphviz traits, specialized to attaching borrowck analysis data to rendered labels.",N,N],[6,"Node","rustc_borrowck::graphviz","",N,N],[6,"Edge","","",N,N],[3,"DataflowLabeller","","",N,N],[12,"inner","","",37,N],[12,"variants","","",37,N],[12,"borrowck_ctxt","","",37,N],[12,"analysis_data","","",37,N],[4,"Variant","","",N,N],[13,"Loans","","",38,N],[13,"Moves","","",38,N],[13,"Assigns","","",38,N],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"clone","","",38,[[["self"]],["variant"]]],[11,"short_name","","",38,[[["self"]],["str"]]],[11,"dataflow_for","","",37,[[["self"],["entryorexit"],["node"]],["string"]]],[11,"dataflow_for_variant","","",37,[[["self"],["entryorexit"],["node"],["variant"]],["string"]]],[11,"build_set","","",37,[[["self"],["entryorexit"],["cfgindex"],["dataflowcontext"],["f"]],["string"]]],[11,"dataflow_loans_for","","",37,[[["self"],["entryorexit"],["cfgindex"]],["string"]]],[11,"dataflow_moves_for","","",37,[[["self"],["entryorexit"],["cfgindex"]],["string"]]],[11,"dataflow_assigns_for","","",37,[[["self"],["entryorexit"],["cfgindex"]],["string"]]],[11,"graph_id","","",37,[[["self"]],["id"]]],[11,"node_id","","",37,[[["self"],["node"]],["id"]]],[11,"node_label","","",37,[[["self"],["node"]],["labeltext"]]],[11,"edge_label","","",37,[[["self"],["edge"]],["labeltext"]]],[11,"nodes","","",37,[[["self"]],["nodes",["node"]]]],[11,"edges","","",37,[[["self"]],["edges",["edge"]]]],[11,"source","","",37,[[["self"],["edge"]],["node"]]],[11,"target","","",37,[[["self"],["edge"]],["node"]]]],"paths":[[3,"AnalysisData"],[3,"BorrowckCtxt"],[3,"Loan"],[3,"LoanPath"],[3,"BckError"],[4,"LoanPathKind"],[4,"InteriorKind"],[4,"LoanPathElem"],[4,"bckerr_code"],[4,"AliasableViolationKind"],[4,"MovedValueUseKind"],[3,"CheckLoanCtxt"],[4,"UseError"],[3,"GatherLoanCtxt"],[3,"GuaranteeLifetimeContext"],[3,"RestrictionsContext"],[4,"RestrictionResult"],[3,"GatherMoveInfo"],[4,"PatternSource"],[3,"MoveErrorCollector"],[3,"MoveError"],[3,"MovePlace"],[3,"GroupedMoveErrors"],[3,"MoveData"],[3,"FlowedMoveData"],[3,"MovePathIndex"],[3,"MoveIndex"],[3,"MovePath"],[3,"Move"],[3,"Assignment"],[4,"MoveKind"],[3,"MoveDataFlowOperator"],[3,"AssignDataFlowOperator"],[3,"UsedMutFinder"],[3,"UnusedMutCx"],[8,"ToInteriorKind"],[3,"LoanDataFlowOperator"],[3,"DataflowLabeller"],[4,"Variant"]]};
searchIndex["rustc_codegen_utils"]={"doc":"Note","items":[[5,"check_for_rustc_errors_attr","rustc_codegen_utils","check for the #[rustc_error] annotation, which forces an error in codegen. This is used to write compile-fail tests that actually test that compilation succeeds without reporting an error.",N,[[["tyctxt"]]]],[0,"link","","",N,N],[5,"out_filename","rustc_codegen_utils::link","",N,[[["session"],["cratetype"],["outputfilenames"],["str"]],["pathbuf"]]],[5,"check_file_is_writeable","","",N,[[["path"],["session"]]]],[5,"is_writeable","","",N,[[["path"]],["bool"]]],[5,"build_link_meta","","",N,[[["svh"]],["linkmeta"]]],[5,"find_crate_name","","",N,N],[5,"filename_for_input","","",N,[[["session"],["cratetype"],["str"],["outputfilenames"]],["pathbuf"]]],[5,"default_output_for_target","","Returns default crate type for target",N,[[["session"]],["cratetype"]]],[5,"invalid_output_for_target","","Checks if target supports crate_type as output",N,[[["session"],["cratetype"]],["bool"]]],[0,"codegen_backend","rustc_codegen_utils","The Rust compiler.",N,N],[6,"MetadataRef","rustc_codegen_utils::codegen_backend","",N,N],[3,"NoLlvmMetadataLoader","","",N,N],[3,"MetadataOnlyCodegenBackend","","",N,N],[12,"0","","",0,N],[3,"OngoingCodegen","","",N,N],[12,"metadata","","",1,N],[12,"metadata_version","","",1,N],[12,"crate_name","","",1,N],[8,"CodegenBackend","","",N,N],[11,"init","","",2,[[["self"],["session"]]]],[11,"print","","",2,[[["self"],["printrequest"],["session"]]]],[11,"target_features","","",2,[[["self"],["session"]],["vec",["symbol"]]]],[11,"print_passes","","",2,[[["self"]]]],[11,"print_version","","",2,[[["self"]]]],[11,"diagnostics","","",2,N],[10,"metadata_loader","","",2,[[["self"]],["box",["metadataloader"]]]],[10,"provide","","",2,[[["self"],["providers"]]]],[10,"provide_extern","","",2,[[["self"],["providers"]]]],[10,"codegen_crate","","",2,[[["self"],["tyctxt"],["receiver",["box"]]],["box",["any"]]]],[10,"join_codegen_and_link","","This is called on the returned `Box<dyn Any>` from `codegen_backend`",2,[[["self"],["box",["any"]],["session"],["depgraph"],["outputfilenames"]],["result",["compileincomplete"]]]],[11,"get_rlib_metadata","","",3,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[11,"get_dylib_metadata","","",3,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[11,"new","","",0,[[],["box",["codegenbackend"]]]],[11,"init","","",0,[[["self"],["session"]]]],[11,"metadata_loader","","",0,[[["self"]],["box",["metadataloader"]]]],[11,"provide","","",0,[[["self"],["providers"]]]],[11,"provide_extern","","",0,[[["self"],["providers"]]]],[11,"codegen_crate","","",0,[[["self"],["tyctxt"],["receiver",["box"]]],["box",["any"]]]],[11,"join_codegen_and_link","","",0,[[["self"],["box",["any"]],["session"],["depgraph"],["outputfilenames"]],["result",["compileincomplete"]]]],[0,"symbol_names","rustc_codegen_utils","The Rust Linkage Model and Symbol Names =======================================",N,N],[3,"SymbolPathBuffer","rustc_codegen_utils::symbol_names","",N,N],[12,"result","","",4,N],[12,"temp_buf","","",4,N],[5,"provide","","",N,[[["providers"]]]],[5,"get_symbol_hash","","",N,[[["tyctxt"],["defid"],["instance"],["ty"],["substs"]],["u64"]]],[5,"def_symbol_name","","",N,[[["tyctxt"],["defid"]],["symbolname"]]],[5,"symbol_name","","",N,[[["tyctxt"],["instance"]],["symbolname"]]],[5,"compute_symbol_name","","",N,[[["tyctxt"],["instance"]],["string"]]],[5,"sanitize","","",N,[[["string"],["str"]],["bool"]]],[11,"new","","",4,[[],["self"]]],[11,"from_interned","","",4,[[["symbolname"]],["self"]]],[11,"into_interned","","",4,[[["self"]],["symbolname"]]],[11,"finish","","",4,[[["self"],["u64"]],["string"]]],[11,"root_mode","","",4,[[["self"]],["rootmode"]]],[11,"push","","",4,[[["self"],["str"]]]],[0,"symbol_names_test","rustc_codegen_utils","Walks the crate looking for items/impl-items/trait-items that have either a `rustc_symbol_name` or `rustc_item_path` attribute and generates an error giving, respectively, the symbol name or item-path. This is used for unit testing the code that generates paths etc in all kinds of annoying scenarios.",N,N],[3,"SymbolNamesTest","rustc_codegen_utils::symbol_names_test","",N,N],[12,"tcx","","",5,N],[5,"report_symbol_names","","",N,[[["tyctxt"]]]],[17,"SYMBOL_NAME","","",N,N],[17,"ITEM_PATH","","",N,N],[11,"process_attrs","","",5,[[["self"],["nodeid"]]]],[11,"visit_item","","",5,[[["self"],["item"]]]],[11,"visit_trait_item","","",5,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",5,[[["self"],["implitem"]]]],[17,"DIAGNOSTICS","rustc_codegen_utils","",N,N]],"paths":[[3,"MetadataOnlyCodegenBackend"],[3,"OngoingCodegen"],[8,"CodegenBackend"],[3,"NoLlvmMetadataLoader"],[3,"SymbolPathBuffer"],[3,"SymbolNamesTest"]]};
searchIndex["rustc_data_structures"]={"doc":"Various data structures used by the Rust compiler. The intention is that code in here should be not be specific to rustc, so that it can be easily unit tested and so forth.","items":[[8,"ToHex","rustc_data_structures","A trait for converting a value to hexadecimal encoding",N,N],[10,"to_hex","","Converts the value of `self` to a hex value, returning the owned string.",0,[[["self"]],["string"]]],[0,"snapshot_vec","","A utility class for implementing \"snapshottable\" things; a snapshottable data structure permits you to take a snapshot (via `start_snapshot`) and then, after making some changes, elect either to rollback to the start of the snapshot or commit those changes.",N,N],[4,"UndoLog","rustc_data_structures::snapshot_vec","",N,N],[13,"OpenSnapshot","","Indicates where a snapshot started.",1,N],[13,"CommittedSnapshot","","Indicates a snapshot that has been committed.",1,N],[13,"NewElem","","New variable with given index was created.",1,N],[13,"SetElem","","Variable with given index was changed from the given value.",1,N],[13,"Other","","Extensible set of actions",1,N],[3,"SnapshotVec","","",N,N],[12,"values","","",2,N],[12,"undo_log","","",2,N],[3,"Snapshot","","",N,N],[12,"length","","",3,N],[8,"SnapshotVecDelegate","","",N,N],[16,"Value","","",4,N],[16,"Undo","","",4,N],[10,"reverse","","",4,N],[0,"unify","rustc_data_structures","Union-find implementation. The main type is `UnificationTable`.",N,N],[8,"UnifyKey","rustc_data_structures::unify","This trait is implemented by any type that can serve as a type variable. We call such variables unification keys. For example, this trait is implemented by `IntVid`, which represents integral variables.",N,N],[16,"Value","","",5,N],[10,"index","","",5,[[["self"]],["u32"]]],[10,"from_index","","",5,[[["u32"]],["self"]]],[10,"tag","","",5,[[],["str"]]],[11,"order_roots","","If true, then `self` should be preferred as root to `other`. Note that we assume a consistent partial ordering, so returning true implies that `other.prefer_as_root_to(self)` would return false.  If there is no ordering between two keys (i.e., `a.prefer_as_root_to(b)` and `b.prefer_as_root_to(a)` both return false) then the rank will be used to determine the root in an optimal way.",5,N],[8,"UnifyValue","","Trait implemented for values associated with a unification key. This trait defines how to merge the values from two keys that are unioned together. This merging can be fallible. If you attempt to union two keys whose values cannot be merged, then the error is propagated up and the two keys are not unioned.",N,N],[16,"Error","","Defines the type to return when merging of two values fails. If merging is infallible, use the special struct `NoError` found in this crate, which unlocks various more convenient methods on the unification table.",6,N],[10,"unify_values","","Given two values, produce a new value that combines them. If that is not possible, produce an error.",6,[[["self"],["self"]],["result"]]],[8,"EqUnifyValue","","A convenient helper for unification values which must be equal or else an error occurs. For example, if you are unifying types in a simple functional language, this may be appropriate, since (e.g.) you can't unify a type variable bound to `int` with one bound to `float` (but you can unify two type variables both bound to `int`).",N,N],[3,"NoError","","A struct which can never be instantiated. Used for the error type for infallible cases.",N,N],[12,"_dummy","","",7,N],[3,"VarValue","","Value of a unification key. We implement Tarjan's union-find algorithm: when two keys are unified, one of them is converted into a \"redirect\" pointing at the other. These redirects form a DAG: the roots of the DAG (nodes that are not redirected) are each associated with a value of type `V` and a rank. The rank is used to keep the DAG relatively balanced, which helps keep the running time of the algorithm under control. For more information, see http://en.wikipedia.org/wiki/Disjoint-set_data_structure.",N,N],[12,"parent","","",8,N],[12,"value","","",8,N],[12,"rank","","",8,N],[3,"UnificationTable","","Table of unification keys and their values. You must define a key type K that implements the `UnifyKey` trait. Unification tables can be used in two-modes:",N,N],[12,"values","","Indicates the current value of each key.",9,N],[6,"InPlaceUnificationTable","","A unification table that uses an \"in-place\" vector.",N,N],[3,"Snapshot","","At any time, users may snapshot a unification table.  The changes made during the snapshot may either be committed or rolled back.",N,N],[12,"marker","","",10,N],[12,"snapshot","","",10,N],[3,"InPlace","","Backing store for an in-place unification table. Not typically used directly.",N,N],[12,"values","","",11,N],[8,"UnificationStore","","Largely internal trait implemented by the unification table backing store types. The most common such type is `InPlace`, which indicates a standard, mutable unification table.",N,N],[16,"Key","","",12,N],[16,"Value","","",12,N],[16,"Snapshot","","",12,N],[10,"new","","",12,[[],["self"]]],[10,"start_snapshot","","",12,N],[10,"rollback_to","","",12,N],[10,"commit","","",12,N],[10,"reset_unifications","","",12,N],[10,"len","","",12,[[["self"]],["usize"]]],[10,"push","","",12,N],[10,"reserve","","",12,N],[10,"update","","",12,N],[11,"tag","","",12,[[],["str"]]],[3,"OnDrop","rustc_data_structures","",N,N],[12,"0","","",13,N],[5,"__noop_fix_for_27438","","",N,[[]]],[0,"accumulate_vec","","A vector type intended to be used for collecting from iterators onto the stack.",N,N],[3,"IntoIter","rustc_data_structures::accumulate_vec","",N,N],[12,"repr","","",14,N],[4,"AccumulateVec","","",N,N],[13,"Array","","",15,N],[13,"Heap","","",15,N],[4,"IntoIterRepr","","",N,N],[13,"Array","","",16,N],[13,"Heap","","",16,N],[4,"Drain","","",N,N],[13,"Array","","",17,N],[13,"Heap","","",17,N],[11,"hash","","",15,N],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"clone","","",15,[[["self"]],["self"]]],[11,"new","","",15,[[],["accumulatevec"]]],[11,"is_array","","",15,[[["self"]],["bool"]]],[11,"one","","",15,N],[11,"many","","",15,[[["i"]],["self"]]],[11,"len","","",15,[[["self"]],["usize"]]],[11,"is_empty","","",15,[[["self"]],["bool"]]],[11,"pop","","",15,[[["self"]],["option"]]],[11,"drain","","",15,[[["self"],["r"]],["drain"]]],[11,"deref","","",15,N],[11,"deref_mut","","",15,N],[11,"from_iter","","",15,[[["i"]],["accumulatevec"]]],[11,"next","","",14,[[["self"]],["option"]]],[11,"size_hint","","",14,N],[11,"next","","",17,[[["self"]],["option"]]],[11,"size_hint","","",17,N],[11,"into_iter","","",15,N],[11,"from","","",15,[[["vec"]],["accumulatevec"]]],[11,"default","","",15,[[],["accumulatevec"]]],[11,"encode","","",15,[[["self"],["s"]],["result"]]],[11,"decode","","",15,[[["d"]],["result",["accumulatevec"]]]],[0,"array_vec","rustc_data_structures","A stack-allocated vector, allowing storage of N elements on the stack.",N,N],[3,"ArrayVec","rustc_data_structures::array_vec","",N,N],[12,"count","","",18,N],[12,"values","","",18,N],[3,"Iter","","",N,N],[12,"indices","","",19,N],[12,"store","","",19,N],[3,"Drain","","",N,N],[12,"tail_start","","",20,N],[12,"tail_len","","",20,N],[12,"iter","","",20,N],[12,"array_vec","","",20,N],[8,"Array","","",N,N],[16,"Element","","",21,N],[16,"PartialStorage","","",21,N],[18,"LEN","","",21,N],[11,"hash","","",18,[[["self"],["h"]]]],[11,"clone","","",18,[[["self"]],["self"]]],[11,"new","","",18,[[],["self"]]],[11,"len","","",18,[[["self"]],["usize"]]],[11,"set_len","","",18,[[["self"],["usize"]]]],[11,"push","","Panics when the stack vector is full.",18,N],[11,"pop","","",18,[[["self"]],["option"]]],[11,"drain","","",18,[[["self"],["r"]],["drain"]]],[11,"default","","",18,[[],["self"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"deref","","",18,N],[11,"deref_mut","","",18,N],[11,"drop","","",18,[[["self"]]]],[11,"extend","","",18,[[["self"],["i"]]]],[11,"drop","","",19,[[["self"]]]],[11,"next","","",19,[[["self"]],["option"]]],[11,"size_hint","","",19,N],[11,"next","","",20,[[["self"]],["option"]]],[11,"size_hint","","",20,N],[11,"drop","","",20,[[["self"]]]],[11,"into_iter","","",18,N],[0,"base_n","rustc_data_structures","",N,N],[5,"push_str","rustc_data_structures::base_n","",N,[[["u128"],["usize"],["string"]]]],[5,"encode","","",N,[[["u128"],["usize"]],["string"]]],[17,"MAX_BASE","","",N,N],[17,"ALPHANUMERIC_ONLY","","",N,N],[17,"CASE_INSENSITIVE","","",N,N],[17,"BASE_64","","",N,N],[0,"bitslice","rustc_data_structures","",N,N],[3,"BitLookup","rustc_data_structures::bitslice","",N,N],[12,"word","","An index of the word holding the bit in original `[Word]` of query.",22,N],[12,"bit_in_word","","Index of the particular bit within the word holding the bit.",22,N],[12,"bit_mask","","Word with single 1-bit set corresponding to where the bit is located.",22,N],[3,"Intersect","","",N,N],[3,"Union","","",N,N],[3,"Subtract","","",N,N],[5,"bit_lookup","","",N,[[["usize"]],["bitlookup"]]],[5,"bits_to_string","","",N,N],[5,"bitwise","","",N,N],[6,"Word","","",N,N],[8,"BitSlice","","`BitSlice` provides helper methods for treating a `[Word]` as a bitvector.",N,N],[10,"clear_bit","","",23,[[["self"],["usize"]],["bool"]]],[10,"set_bit","","",23,[[["self"],["usize"]],["bool"]]],[10,"get_bit","","",23,[[["self"],["usize"]],["bool"]]],[8,"BitwiseOperator","","",N,N],[10,"join","","Applies some bit-operation pointwise to each of the bits in the two inputs.",24,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",25,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",26,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",27,[[["self"],["word"],["word"]],["word"]]],[0,"bitvec","rustc_data_structures","",N,N],[3,"BitVector","rustc_data_structures::bitvec","A very simple BitVector type.",N,N],[12,"data","","",28,N],[12,"marker","","",28,N],[3,"BitVectorIter","","",N,N],[12,"iter","","",29,N],[12,"current","","",29,N],[12,"idx","","",29,N],[12,"marker","","",29,N],[3,"BitMatrix","","A \"bit matrix\" is basically a matrix of booleans represented as one gigantic bitvector. In other words, it is as if you have `rows` bitvectors, each of length `columns`.",N,N],[12,"columns","","",30,N],[12,"vector","","",30,N],[12,"phantom","","",30,N],[3,"SparseBitMatrix","","A moderately sparse bit matrix: rows are appended lazily, but columns within appended rows are instantiated fully upon creation.",N,N],[12,"columns","","",31,N],[12,"vector","","",31,N],[5,"words","","",N,[[["c"]],["usize"]]],[5,"word_mask","","",N,N],[6,"Word","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"WORD_BITS","","",N,N],[11,"clone","","",28,[[["self"]],["bitvector"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"eq","","",28,[[["self"],["bitvector"]],["bool"]]],[11,"ne","","",28,[[["self"],["bitvector"]],["bool"]]],[11,"new","","",28,[[["usize"]],["bitvector"]]],[11,"clear","","",28,[[["self"]]]],[11,"count","","",28,[[["self"]],["usize"]]],[11,"contains","","True if `self` contains the bit `bit`.",28,[[["self"],["c"]],["bool"]]],[11,"contains_all","","True if `self` contains all the bits in `other`.",28,[[["self"],["bitvector"]],["bool"]]],[11,"is_empty","","",28,[[["self"]],["bool"]]],[11,"insert","","Returns true if the bit has changed.",28,[[["self"],["c"]],["bool"]]],[11,"insert_all","","Sets all bits to true.",28,[[["self"]]]],[11,"remove","","Returns true if the bit has changed.",28,[[["self"],["c"]],["bool"]]],[11,"merge","","",28,[[["self"],["bitvector"]],["bool"]]],[11,"grow","","",28,[[["self"],["c"]]]],[11,"iter","","Iterates over indexes of set bits in a sorted order",28,[[["self"]],["bitvectoriter"]]],[11,"next","","",29,[[["self"]],["option"]]],[11,"size_hint","","",29,N],[11,"from_iter","","",28,[[["i"]],["bitvector"]]],[11,"clone","","",30,[[["self"]],["bitmatrix"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `rows x columns` matrix, initially empty.",30,[[["usize"],["usize"]],["bitmatrix"]]],[11,"range","","The range of bits for a given row.",30,N],[11,"add","","Sets the cell at `(row, column)` to true. Put another way, add `column` to the bitset for `row`.",30,[[["self"],["r"],["r"]],["bool"]]],[11,"contains","","Do the bits from `row` contain `column`? Put another way, is the matrix cell at `(row, column)` true?  Put yet another way, if the matrix represents (transitive) reachability, can `row` reach `column`?",30,[[["self"],["r"],["r"]],["bool"]]],[11,"intersection","","Returns those indices that are true in rows `a` and `b`.  This is an O(n) operation where `n` is the number of elements (somewhat independent from the actual size of the intersection, in particular).",30,[[["self"],["r"],["r"]],["vec"]]],[11,"merge","","Add the bits from row `read` to the bits from row `write`, return true if anything changed.",30,[[["self"],["r"],["r"]],["bool"]]],[11,"iter","","Iterates through all the columns set to true in a given row of the matrix.",30,[[["self"],["r"]],["bitvectoriter"]]],[11,"clone","","",31,[[["self"]],["sparsebitmatrix"]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new empty sparse bit matrix with no rows or columns.",31,[[["usize"]],["self"]]],[11,"ensure_row","","",31,[[["self"],["r"]]]],[11,"add","","Sets the cell at `(row, column)` to true. Put another way, insert `column` to the bitset for `row`.",31,[[["self"],["r"],["c"]],["bool"]]],[11,"contains","","Do the bits from `row` contain `column`? Put another way, is the matrix cell at `(row, column)` true?  Put yet another way, if the matrix represents (transitive) reachability, can `row` reach `column`?",31,[[["self"],["r"],["c"]],["bool"]]],[11,"merge","","Add the bits from row `read` to the bits from row `write`, return true if anything changed.",31,[[["self"],["r"],["r"]],["bool"]]],[11,"merge_into","","Merge a row, `from`, into the `into` row.",31,[[["self"],["r"],["bitvector"]],["bool"]]],[11,"add_all","","Add all bits to the given row.",31,[[["self"],["r"]]]],[11,"len","","Number of elements in the matrix.",31,[[["self"]],["usize"]]],[11,"rows","","",31,[[["self"]],[""]]],[11,"iter","","Iterates through all the columns set to true in a given row of the matrix.",31,[[["self"],["r"]],[""]]],[11,"iter_enumerated","","Iterates through each row and the accompanying bit set.",31,[[["self"]],[""]]],[11,"row","","",31,[[["self"],["r"]],["option",["bitvector"]]]],[0,"flock","rustc_data_structures","Simple file-locking apis for each OS.",N,N],[3,"Lock","rustc_data_structures::flock","",N,N],[12,"fd","","",32,N],[0,"imp","","",N,N],[3,"Lock","rustc_data_structures::flock::imp","",N,N],[12,"fd","","",32,N],[0,"os","","",N,N],[3,"flock","rustc_data_structures::flock::imp::os","",N,N],[12,"l_type","","",33,N],[12,"l_whence","","",33,N],[12,"l_start","","",33,N],[12,"l_len","","",33,N],[12,"l_pid","","",33,N],[12,"l_sysid","","",33,N],[17,"F_RDLCK","","",N,N],[17,"F_WRLCK","","",N,N],[17,"F_UNLCK","","",N,N],[17,"F_SETLK","","",N,N],[17,"F_SETLKW","","",N,N],[11,"fmt","rustc_data_structures::flock","",32,[[["self"],["formatter"]],["result"]]],[11,"new","","",32,[[["path"],["bool"],["bool"],["bool"]],["result",["lock"]]]],[11,"drop","","",32,[[["self"]]]],[11,"panicking_new","","",32,[[["path"],["bool"],["bool"],["bool"]],["lock"]]],[0,"fx","rustc_data_structures","",N,N],[6,"FxHashMap","rustc_data_structures::fx","Type alias for a hashmap using the `fx` hash algorithm.",N,N],[6,"FxHashSet","","Type alias for a hashmap using the `fx` hash algorithm.",N,N],[3,"FxHasher","","A speedy hash algorithm for use within rustc. The hashmap in liballoc by default uses SipHash which isn't quite as speedy as we want. In the compiler we're not really worried about DOS attempts, so we use a fast non-cryptographic hash.",N,N],[12,"hash","","",34,N],[5,"FxHashMap","","",N,[[],["fxhashmap"]]],[5,"FxHashSet","","",N,[[],["fxhashset"]]],[0,"graph","rustc_data_structures","",N,N],[0,"dominators","rustc_data_structures::graph","Algorithm citation: A Simple, Fast Dominance Algorithm. Keith D. Cooper, Timothy J. Harvey, and Ken Kennedy Rice Computer Science TS-06-33870 https://www.cs.rice.edu/~keith/EMBED/dom.pdf",N,N],[3,"Dominators","rustc_data_structures::graph::dominators","",N,N],[12,"post_order_rank","","",35,N],[12,"immediate_dominators","","",35,N],[3,"Iter","","",N,N],[12,"dominators","","",36,N],[12,"node","","",36,N],[3,"DominatorTree","","",N,N],[12,"root","","",37,N],[12,"children","","",37,N],[3,"DominatorTreeNode","","",N,N],[12,"tree","","",38,N],[12,"node","","",38,N],[5,"dominators","","",N,[[["g"]],["dominators"]]],[5,"dominators_given_rpo","","",N,N],[5,"intersect_opt","","",N,[[["indexvec"],["indexvec"],["option"],["option"]],["option"]]],[5,"intersect","","",N,[[["indexvec"],["indexvec"],["node"],["node"]],["node"]]],[11,"clone","","",35,[[["self"]],["dominators"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"is_reachable","","",35,[[["self"],["node"]],["bool"]]],[11,"immediate_dominator","","",35,[[["self"],["node"]],["node"]]],[11,"dominators","","",35,[[["self"],["node"]],["iter"]]],[11,"is_dominated_by","","",35,[[["self"],["node"],["node"]],["bool"]]],[11,"next","","",36,[[["self"]],["option"]]],[11,"children","","",37,N],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[0,"implementation","rustc_data_structures::graph","A graph module for use in dataflow, region resolution, and elsewhere.",N,N],[3,"Graph","rustc_data_structures::graph::implementation","",N,N],[12,"nodes","","",39,N],[12,"edges","","",39,N],[3,"Node","","",N,N],[12,"first_edge","","",40,N],[12,"data","","",40,N],[3,"Edge","","",N,N],[12,"next_edge","","",41,N],[12,"source","","",41,N],[12,"target","","",41,N],[12,"data","","",41,N],[3,"NodeIndex","","",N,N],[12,"0","","",42,N],[3,"EdgeIndex","","",N,N],[12,"0","","",43,N],[3,"Direction","","",N,N],[12,"repr","","",44,N],[3,"AdjacentEdges","","",N,N],[12,"graph","","",45,N],[12,"direction","","",45,N],[12,"next","","",45,N],[3,"DepthFirstTraversal","","",N,N],[12,"graph","","",46,N],[12,"stack","","",46,N],[12,"visited","","",46,N],[12,"direction","","",46,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"INVALID_EDGE_INDEX","","",N,N],[17,"OUTGOING","","",N,N],[17,"INCOMING","","",N,N],[11,"fmt","","",41,[[["self"],["formatter"]],["result"]]],[11,"reverse","","",40,N],[11,"reverse","","",41,N],[11,"clone","","",42,[[["self"]],["nodeindex"]]],[11,"eq","","",42,[[["self"],["nodeindex"]],["bool"]]],[11,"ne","","",42,[[["self"],["nodeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",42,N],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"hash","","",42,N],[11,"clone","","",43,[[["self"]],["edgeindex"]]],[11,"eq","","",43,[[["self"],["edgeindex"]],["bool"]]],[11,"ne","","",43,[[["self"],["edgeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",43,N],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"hash","","",43,N],[11,"clone","","",44,[[["self"]],["direction"]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"eq","","",44,[[["self"],["direction"]],["bool"]]],[11,"ne","","",44,[[["self"],["direction"]],["bool"]]],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",42,[[["self"]],["usize"]]],[11,"new","","",39,[[],["graph"]]],[11,"with_capacity","","",39,[[["usize"],["usize"]],["graph"]]],[11,"all_nodes","","",39,N],[11,"len_nodes","","",39,[[["self"]],["usize"]]],[11,"all_edges","","",39,N],[11,"len_edges","","",39,[[["self"]],["usize"]]],[11,"next_node_index","","",39,[[["self"]],["nodeindex"]]],[11,"add_node","","",39,[[["self"],["n"]],["nodeindex"]]],[11,"mut_node_data","","",39,[[["self"],["nodeindex"]],["n"]]],[11,"node_data","","",39,[[["self"],["nodeindex"]],["n"]]],[11,"node","","",39,[[["self"],["nodeindex"]],["node"]]],[11,"next_edge_index","","",39,[[["self"]],["edgeindex"]]],[11,"add_edge","","",39,[[["self"],["nodeindex"],["nodeindex"],["e"]],["edgeindex"]]],[11,"edge","","",39,[[["self"],["edgeindex"]],["edge"]]],[11,"enumerated_nodes","","",39,[[["self"]],[""]]],[11,"enumerated_edges","","",39,[[["self"]],[""]]],[11,"each_node","","Iterates over all edges defined in the graph.",39,N],[11,"each_edge","","Iterates over all edges defined in the graph",39,N],[11,"outgoing_edges","","",39,[[["self"],["nodeindex"]],["adjacentedges"]]],[11,"incoming_edges","","",39,[[["self"],["nodeindex"]],["adjacentedges"]]],[11,"adjacent_edges","","",39,[[["self"],["nodeindex"],["direction"]],["adjacentedges"]]],[11,"successor_nodes","","",39,[[["self"],["nodeindex"]],[""]]],[11,"predecessor_nodes","","",39,[[["self"],["nodeindex"]],[""]]],[11,"depth_traverse","","",39,[[["self"],["nodeindex"],["direction"]],["depthfirsttraversal"]]],[11,"nodes_in_postorder","","",39,[[["self"],["direction"],["nodeindex"]],["vec",["nodeindex"]]]],[11,"targets","","",45,[[["self"]],[""]]],[11,"sources","","",45,[[["self"]],[""]]],[11,"next","","",45,[[["self"]],["option"]]],[11,"size_hint","","",45,N],[11,"with_start_node","","",46,[[["graph"],["nodeindex"],["direction"]],["self"]]],[11,"visit","","",46,[[["self"],["nodeindex"]]]],[11,"next","","",46,[[["self"]],["option",["nodeindex"]]]],[11,"size_hint","","",46,N],[11,"source","","",41,[[["self"]],["nodeindex"]]],[11,"target","","",41,[[["self"]],["nodeindex"]]],[11,"source_or_target","","",41,[[["self"],["direction"]],["nodeindex"]]],[0,"iterate","rustc_data_structures::graph","",N,N],[5,"post_order_from","rustc_data_structures::graph::iterate","",N,N],[5,"post_order_from_to","","",N,N],[5,"post_order_walk","","",N,N],[5,"reverse_post_order","","",N,N],[0,"reference","rustc_data_structures::graph","",N,N],[0,"scc","","Routine to compute the strongly connected components (SCCs) of a graph, as well as the resulting DAG if each SCC is replaced with a node in the graph. This uses Tarjan's algorithm that completes in O(n) time.",N,N],[3,"Sccs","rustc_data_structures::graph::scc","Strongly connected components (SCC) of a graph. The type `N` is the index type for the graph nodes and `S` is the index type for the SCCs. We can map from each node to the SCC that it participates in, and we also have the successors of each SCC.",N,N],[12,"scc_indices","","For each node, what is the SCC index of the SCC to which it belongs.",47,N],[12,"scc_data","","Data about each SCC.",47,N],[3,"SccData","","",N,N],[12,"ranges","","For each SCC, the range of `all_successors` where its successors can be found.",48,N],[12,"all_successors","","Contains the succcessors for all the Sccs, concatenated. The range of indices corresponding to a given SCC is found in its SccData.",48,N],[3,"SccsConstruction","","",N,N],[12,"graph","","",49,N],[12,"node_states","","The state of each node; used during walk to record the stack and after walk to record what cycle each node ended up being in.",49,N],[12,"node_stack","","The stack of nodes that we are visiting as part of the DFS.",49,N],[12,"successors_stack","","The stack of successors: as we visit a node, we mark our position in this stack, and when we encounter a successor SCC, we push it on the stack. When we complete an SCC, we can pop everything off the stack that was found along the way.",49,N],[12,"duplicate_set","","A set used to strip duplicates. As we accumulate successors into the successors_stack, we sometimes get duplicate entries. We use this set to remove those -- we also keep its storage around between successors to amortize memory allocation costs.",49,N],[12,"scc_data","","",49,N],[4,"NodeState","","",N,N],[13,"NotVisited","","This node has not yet been visited as part of the DFS.",50,N],[13,"BeingVisited","","This node is currently being walk as part of our DFS. It is on the stack at the depth `depth`.",50,N],[12,"depth","rustc_data_structures::graph::scc::NodeState","",50,N],[13,"InCycle","rustc_data_structures::graph::scc","Indicates that this node is a member of the given cycle.",50,N],[12,"scc_index","rustc_data_structures::graph::scc::NodeState","",50,N],[13,"InCycleWith","rustc_data_structures::graph::scc","Indicates that this node is a member of whatever cycle `parent` is a member of. This state is transient: whenever we see it, we try to overwrite it with the current state of `parent` (this is the \"path compression\" step of a union-find algorithm).",50,N],[12,"parent","rustc_data_structures::graph::scc::NodeState","",50,N],[4,"WalkReturn","rustc_data_structures::graph::scc","",N,N],[13,"Cycle","","",51,N],[12,"min_depth","rustc_data_structures::graph::scc::WalkReturn","",51,N],[13,"Complete","rustc_data_structures::graph::scc","",51,N],[12,"scc_index","rustc_data_structures::graph::scc::WalkReturn","",51,N],[22,"","rustc_data_structures::graph::scc","",N,N],[11,"new","","",47,N],[11,"num_sccs","","Returns the number of SCCs in the graph.",47,[[["self"]],["usize"]]],[11,"all_sccs","","Returns an iterator over the SCCs in the graph.",47,[[["self"]],[""]]],[11,"scc","","Returns the SCC to which a node `r` belongs.",47,[[["self"],["n"]],["s"]]],[11,"successors","","Returns the successors of the given SCC.",47,N],[11,"len","","Number of SCCs,",48,[[["self"]],["usize"]]],[11,"successors","","Returns the successors of the given SCC.",48,N],[11,"create_scc","","Creates a new SCC with `successors` as its successors and returns the resulting index.",48,N],[11,"clone","","",50,[[["self"]],["nodestate"]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"clone","","",51,[[["self"]],["walkreturn"]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"construct","","Identifies SCCs in the graph `G` and computes the resulting DAG. This uses a variant of [Tarjan's algorithm][wikipedia]. The high-level summary of the algorithm is that we do a depth-first search. Along the way, we keep a stack of each node whose successors are being visited. We track the depth of each node on this stack (there is no depth if the node is not on the stack). When we find that some node N with depth D can reach some other node N' with lower depth D' (i.e., D' < D), we know that N, N', and all nodes in between them on the stack are part of an SCC.",49,[[["g"]],["sccs"]]],[11,"walk_node","","Visit a node during the DFS. We first examine its current state -- if it is not yet visited (`NotVisited`), we can push it onto the stack and start walking its successors.",49,N],[11,"find_state","","Fetches the state of the node `r`. If `r` is recorded as being in a cycle with some other node `r2`, then fetches the state of `r2` (and updates `r` to reflect current result). This is basically the \"find\" part of a standard union-find algorithm (with path compression).",49,N],[11,"walk_unvisited_node","","Walks a node that has never been visited before.",49,N],[8,"DirectedGraph","rustc_data_structures::graph","",N,N],[16,"Node","","",52,N],[8,"WithNumNodes","","",N,N],[10,"num_nodes","","",53,[[["self"]],["usize"]]],[8,"WithSuccessors","","",N,N],[10,"successors","","",54,N],[8,"GraphSuccessors","","",N,N],[16,"Item","","",55,N],[16,"Iter","","",55,N],[8,"WithPredecessors","","",N,N],[10,"predecessors","","",56,N],[8,"GraphPredecessors","","",N,N],[16,"Item","","",57,N],[16,"Iter","","",57,N],[8,"WithStartNode","","",N,N],[10,"start_node","","",58,N],[8,"ControlFlowGraph","","",N,N],[0,"indexed_set","rustc_data_structures","",N,N],[3,"IdxSetBuf","rustc_data_structures::indexed_set","Represents a set (or packed family of sets), of some element type E, where each E is identified by some unique index type `T`.",N,N],[12,"_pd","","",59,N],[12,"bits","","",59,N],[3,"IdxSet","","Represents a set (or packed family of sets), of some element type E, where each E is identified by some unique index type `T`.",N,N],[12,"_pd","","",60,N],[12,"bits","","",60,N],[3,"Iter","","",N,N],[12,"cur","","",61,N],[12,"iter","","",61,N],[12,"_pd","","",61,N],[11,"assert_receiver_is_total_eq","","",59,N],[11,"eq","","",59,[[["self"],["idxsetbuf"]],["bool"]]],[11,"ne","","",59,[[["self"],["idxsetbuf"]],["bool"]]],[11,"clone","","",59,[[["self"]],["self"]]],[11,"encode","","",59,[[["self"],["e"]],["result"]]],[11,"decode","","",59,[[["d"]],["result",["idxsetbuf"]]]],[11,"borrow","","",59,[[["self"]],["idxset"]]],[11,"borrow_mut","","",59,[[["self"]],["idxset"]]],[11,"to_owned","","",60,N],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"new","","",59,[[["word"],["usize"]],["self"]]],[11,"new_filled","","Creates set holding every element whose index falls in range 0..universe_size.",59,[[["usize"]],["self"]]],[11,"new_empty","","Creates set holding no elements.",59,[[["usize"]],["self"]]],[11,"from_slice","","",60,N],[11,"from_slice_mut","","",60,N],[11,"deref","","",59,[[["self"]],["idxset"]]],[11,"deref_mut","","",59,[[["self"]],["idxset"]]],[11,"to_owned","","",60,[[["self"]],["idxsetbuf"]]],[11,"clear","","Removes all elements",60,[[["self"]]]],[11,"set_up_to","","Sets all elements up to `universe_size`",60,[[["self"],["usize"]]]],[11,"trim_to","","Clear all elements above `universe_size`.",60,[[["self"],["usize"]]]],[11,"remove","","Removes `elem` from the set `self`; returns true iff this changed `self`.",60,[[["self"],["t"]],["bool"]]],[11,"add","","Adds `elem` to the set `self`; returns true iff this changed `self`.",60,[[["self"],["t"]],["bool"]]],[11,"range","","",60,[[["self"],["range"]],["self"]]],[11,"range_mut","","",60,[[["self"],["range"]],["self"]]],[11,"contains","","Returns true iff set `self` contains `elem`.",60,[[["self"],["t"]],["bool"]]],[11,"words","","",60,N],[11,"words_mut","","",60,N],[11,"overwrite","","Efficiently overwrite `self` with `other`. Panics if `self` and `other` don't have the same length.",60,[[["self"],["idxset"]]]],[11,"union","","Set `self = self | other` and return true if `self` changed (i.e., if new bits were added).",60,[[["self"],["idxset"]],["bool"]]],[11,"subtract","","Set `self = self - other` and return true if `self` changed. (i.e., if any bits were removed).",60,[[["self"],["idxset"]],["bool"]]],[11,"intersect","","Set `self = self & other` and return true if `self` changed. (i.e., if any bits were removed).",60,[[["self"],["idxset"]],["bool"]]],[11,"iter","","",60,[[["self"]],["iter"]]],[11,"next","","",61,[[["self"]],["option"]]],[0,"indexed_vec","rustc_data_structures","",N,N],[3,"IndexVec","rustc_data_structures::indexed_vec","",N,N],[12,"raw","","",62,N],[12,"_marker","","",62,N],[3,"IntoIdx","","",N,N],[12,"_marker","","",63,N],[6,"Enumerated","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[8,"Idx","","Represents some newtyped `usize` wrapper.",N,N],[10,"new","","",64,[[["usize"]],["self"]]],[10,"index","","",64,[[["self"]],["usize"]]],[11,"increment_by","","",64,[[["self"],["usize"]]]],[11,"clone","","",62,[[["self"]],["indexvec"]]],[11,"eq","","",62,[[["self"],["indexvec"]],["bool"]]],[11,"ne","","",62,[[["self"],["indexvec"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",62,N],[11,"hash","","",62,N],[11,"encode","","",62,[[["self"],["s"]],["result"]]],[11,"decode","","",62,[[["d"]],["result"]]],[11,"fmt","","",62,[[["self"],["formatter"]],["result"]]],[11,"new","","",62,[[],["self"]]],[11,"from_raw","","",62,[[["vec"]],["self"]]],[11,"with_capacity","","",62,[[["usize"]],["self"]]],[11,"from_elem","","",62,[[["t"],["indexvec"]],["self"]]],[11,"from_elem_n","","",62,[[["t"],["usize"]],["self"]]],[11,"push","","",62,[[["self"],["t"]],["i"]]],[11,"pop","","",62,[[["self"]],["option"]]],[11,"len","","",62,[[["self"]],["usize"]]],[11,"is_empty","","",62,[[["self"]],["bool"]]],[11,"into_iter","","",62,[[["self"]],["intoiter"]]],[11,"into_iter_enumerated","","",62,[[["self"]],["enumerated",["intoiter"]]]],[11,"iter","","",62,[[["self"]],["iter"]]],[11,"iter_enumerated","","",62,[[["self"]],["enumerated",["iter"]]]],[11,"indices","","",62,[[["self"]],["map",["range","intoidx"]]]],[11,"iter_mut","","",62,[[["self"]],["itermut"]]],[11,"iter_enumerated_mut","","",62,[[["self"]],["enumerated",["itermut"]]]],[11,"drain","","",62,[[["self"],["r"]],[""]]],[11,"drain_enumerated","","",62,[[["self"],["r"]],[""]]],[11,"last","","",62,[[["self"]],["option"]]],[11,"shrink_to_fit","","",62,[[["self"]]]],[11,"swap","","",62,[[["self"],["i"],["i"]]]],[11,"truncate","","",62,[[["self"],["usize"]]]],[11,"get","","",62,[[["self"],["i"]],["option"]]],[11,"get_mut","","",62,[[["self"],["i"]],["option"]]],[11,"pick2_mut","","Return mutable references to two distinct elements, a and b. Panics if a == b.",62,N],[11,"convert_index_type","","",62,[[["self"]],["indexvec"]]],[11,"ensure_contains_elem","","Grows the index vector so that it contains an entry for `elem`; if that is already true, then has no effect. Otherwise, inserts new values as needed by invoking `fill_value`.",62,N],[11,"resize","","",62,[[["self"],["usize"],["t"]]]],[11,"resize_to_elem","","",62,N],[11,"binary_search","","",62,[[["self"],["t"]],["result"]]],[11,"index","","",62,[[["self"],["i"]],["t"]]],[11,"index_mut","","",62,[[["self"],["i"]],["t"]]],[11,"default","","",62,[[],["self"]]],[11,"extend","","",62,[[["self"],["j"]]]],[11,"from_iter","","",62,[[["j"]],["self"]]],[11,"into_iter","","",62,[[["self"]],["intoiter"]]],[11,"call_once","","",63,N],[11,"call_mut","","",63,N],[11,"call_once","","",63,N],[11,"call_mut","","",63,N],[0,"obligation_forest","rustc_data_structures","The `ObligationForest` is a utility data structure used in trait matching to track the set of outstanding obligations (those not yet resolved to success or error). It also tracks the \"backtrace\" of each pending obligation (why we are trying to figure this out in the first place). See README.md for a general overview of how to use this class.",N,N],[3,"ObligationForest","rustc_data_structures::obligation_forest","",N,N],[12,"nodes","","The list of obligations. In between calls to `process_obligations`, this list only contains nodes in the `Pending` or `Success` state (with a non-zero number of incomplete children). During processing, some of those nodes may be changed to the error state, or we may find that they are completed (That is, `num_incomplete_children` drops to 0). At the end of processing, those nodes will be removed by a call to `compress`.",65,N],[12,"done_cache","","A cache of predicates that have been successfully completed.",65,N],[12,"waiting_cache","","An cache of the nodes in `nodes`, indexed by predicate.",65,N],[12,"scratch","","",65,N],[3,"Node","","",N,N],[12,"obligation","","",66,N],[12,"state","","",66,N],[12,"parent","","The parent of a node - the original obligation of which it is a subobligation. Except for error reporting, it is just like any member of `dependents`.",66,N],[12,"dependents","","Obligations that depend on this obligation for their completion. They must all be in a non-pending state.",66,N],[3,"Outcome","","",N,N],[12,"completed","","Obligations that were completely evaluated, including all (transitive) subobligations.",67,N],[12,"errors","","Backtrace of obligations that were found to be in error.",67,N],[12,"stalled","","If true, then we saw no successful obligations, which means there is no point in further iteration. This is based on the assumption that when trait matching returns `Error` or `Unchanged`, those results do not affect environmental inference state. (Note that if we invoke `process_obligations` with no pending obligations, stalled will be true.)",67,N],[3,"Error","","",N,N],[12,"error","","",68,N],[12,"backtrace","","",68,N],[3,"GetObligation","","",N,N],[12,"0","","",69,N],[4,"ProcessResult","","The result type used by `process_obligation`.",N,N],[13,"Unchanged","","",70,N],[13,"Changed","","",70,N],[13,"Error","","",70,N],[4,"NodeState","","The state of one node in some tree within the forest. This represents the current state of processing for the obligation (of type `O`) associated with this node.",N,N],[13,"Pending","","Obligations for which selection had not yet returned a non-ambiguous result.",71,N],[13,"Success","","This obligation was selected successfully, but may or may not have subobligations.",71,N],[13,"Waiting","","This obligation was selected successfully, but it has a pending subobligation.",71,N],[13,"Done","","This obligation, along with its subobligations, are complete, and will be removed in the next collection.",71,N],[13,"Error","","This obligation was resolved to an error. Error nodes are removed from the vector by the compression step.",71,N],[13,"OnDfsStack","","This is a temporary state used in DFS loops to detect cycles, it should not exist outside of these DFSes.",71,N],[0,"node_index","","",N,N],[3,"NodeIndex","rustc_data_structures::obligation_forest::node_index","",N,N],[12,"index","","",72,N],[11,"clone","","",72,[[["self"]],["nodeindex"]]],[11,"fmt","","",72,[[["self"],["formatter"]],["result"]]],[11,"eq","","",72,[[["self"],["nodeindex"]],["bool"]]],[11,"ne","","",72,[[["self"],["nodeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",72,N],[11,"new","","",72,[[["usize"]],["nodeindex"]]],[11,"get","","",72,[[["self"]],["usize"]]],[8,"ForestObligation","rustc_data_structures::obligation_forest","",N,N],[16,"Predicate","","",73,N],[10,"as_predicate","","",73,N],[8,"ObligationProcessor","","",N,N],[16,"Obligation","","",74,N],[16,"Error","","",74,N],[10,"process_obligation","","",74,N],[10,"process_backedge","","As we do the cycle check, we invoke this callback when we encounter an actual cycle. `cycle` is an iterator that starts at the start of the cycle in the stack and walks toward the top.",74,[[["self"],["i"],["phantomdata"]]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"clone","","",71,[[["self"]],["nodestate"]]],[11,"eq","","",71,[[["self"],["nodestate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",71,N],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",68,[[["self"],["formatter"]],["result"]]],[11,"eq","","",68,[[["self"],["error"]],["bool"]]],[11,"ne","","",68,[[["self"],["error"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",68,N],[11,"new","","",65,[[],["obligationforest"]]],[11,"len","","Return the total number of nodes in the forest that have not yet been fully resolved.",65,[[["self"]],["usize"]]],[11,"register_obligation","","Registers an obligation",65,[[["self"],["o"]]]],[11,"register_obligation_at","","",65,[[["self"],["o"],["option",["nodeindex"]]],["result"]]],[11,"to_errors","","Convert all remaining obligations to the given error.",65,[[["self"],["e"]],["vec",["error"]]]],[11,"map_pending_obligations","","Returns the set of obligations that are in a pending state.",65,[[["self"],["f"]],["vec"]]],[11,"process_obligations","","Perform a pass through the obligation list. This must be called in a loop until `outcome.stalled` is false.",65,[[["self"],["p"]],["outcome"]]],[11,"process_cycles","","Mark all NodeState::Success nodes as NodeState::Done and report all cycles between them. This should be called after `mark_as_waiting` marks all nodes with pending subobligations as NodeState::Waiting.",65,[[["self"],["p"]]]],[11,"find_cycles_from_node","","",65,[[["self"],["vec"],["p"],["usize"]]]],[11,"error_at","","Returns a vector of obligations for `p` and all of its ancestors, putting them into the error state in the process.",65,[[["self"],["usize"]],["vec"]]],[11,"mark_neighbors_as_waiting_from","","",65,[[["self"],["node"]]]],[11,"mark_as_waiting","","Marks all nodes that depend on a pending node as NodeState::Waiting.",65,[[["self"]]]],[11,"mark_as_waiting_from","","",65,[[["self"],["node"]]]],[11,"compress","","Compresses the vector, removing all popped nodes. This adjusts the indices and hence invalidates any outstanding indices. Cannot be used during a transaction.",65,[[["self"]],["vec"]]],[11,"apply_rewrites","","",65,N],[11,"new","","",66,[[["option",["nodeindex"]],["o"]],["node"]]],[11,"clone","","",69,[[["self"]],["getobligation"]]],[11,"call_once","","",69,N],[11,"call_mut","","",69,N],[0,"owning_ref","rustc_data_structures","An owning reference.",N,N],[8,"StableAddress","rustc_data_structures::owning_ref","An unsafe marker trait for types that deref to a stable address, even when moved. For example, this is implemented by Box, Vec, Rc, Arc and String, among others. Even when a Box is moved, the underlying storage remains at a fixed location.",N,N],[8,"CloneStableAddress","","An unsafe marker trait for types where clones deref to the same address. This has all the requirements of StableDeref, and additionally requires that after calling clone(), both the old and new value deref to the same address. For example, Rc and Arc implement CloneStableDeref, but Box and Vec do not.",N,N],[3,"OwningRef","","An owning reference.",N,N],[12,"owner","","",75,N],[12,"reference","","",75,N],[3,"OwningRefMut","","An mutable owning reference.",N,N],[12,"owner","","",76,N],[12,"reference","","",76,N],[3,"OwningHandle","","`OwningHandle` is a complement to `OwningRef`. Where `OwningRef` allows consumers to pass around an owned object and a dependent reference, `OwningHandle` contains an owned object and a dependent object.",N,N],[12,"handle","","",77,N],[12,"_owner","","",77,N],[6,"BoxRef","","Typedef of a owning reference that uses a `Box` as the owner.",N,N],[6,"VecRef","","Typedef of a owning reference that uses a `Vec` as the owner.",N,N],[6,"StringRef","","Typedef of a owning reference that uses a `String` as the owner.",N,N],[6,"RcRef","","Typedef of a owning reference that uses a `Rc` as the owner.",N,N],[6,"ArcRef","","Typedef of a owning reference that uses a `Arc` as the owner.",N,N],[6,"RefRef","","Typedef of a owning reference that uses a `Ref` as the owner.",N,N],[6,"RefMutRef","","Typedef of a owning reference that uses a `RefMut` as the owner.",N,N],[6,"MutexGuardRef","","Typedef of a owning reference that uses a `MutexGuard` as the owner.",N,N],[6,"RwLockReadGuardRef","","Typedef of a owning reference that uses a `RwLockReadGuard` as the owner.",N,N],[6,"RwLockWriteGuardRef","","Typedef of a owning reference that uses a `RwLockWriteGuard` as the owner.",N,N],[6,"BoxRefMut","","Typedef of a mutable owning reference that uses a `Box` as the owner.",N,N],[6,"VecRefMut","","Typedef of a mutable owning reference that uses a `Vec` as the owner.",N,N],[6,"StringRefMut","","Typedef of a mutable owning reference that uses a `String` as the owner.",N,N],[6,"RefMutRefMut","","Typedef of a mutable owning reference that uses a `RefMut` as the owner.",N,N],[6,"MutexGuardRefMut","","Typedef of a mutable owning reference that uses a `MutexGuard` as the owner.",N,N],[6,"RwLockWriteGuardRefMut","","Typedef of a mutable owning reference that uses a `RwLockWriteGuard` as the owner.",N,N],[6,"ErasedBoxRef","","Typedef of a owning reference that uses an erased `Box` as the owner.",N,N],[6,"ErasedRcRef","","Typedef of a owning reference that uses an erased `Rc` as the owner.",N,N],[6,"ErasedArcRef","","Typedef of a owning reference that uses an erased `Arc` as the owner.",N,N],[6,"ErasedBoxRefMut","","Typedef of a mutable owning reference that uses an erased `Box` as the owner.",N,N],[8,"Erased","","Helper trait for an erased concrete type an owner dereferences to. This is used in form of a trait object for keeping something around to (virtually) call the destructor.",N,N],[8,"IntoErased","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased>`. This would be unneeded with higher kinded types support in the language.",N,N],[16,"Erased","","Owner with the dereference type substituted to `Erased`.",78,N],[10,"into_erased","","Perform the type erasure.",78,N],[8,"IntoErasedSend","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased + Send>`. This would be unneeded with higher kinded types support in the language.",N,N],[16,"Erased","","Owner with the dereference type substituted to `Erased + Send`.",79,N],[10,"into_erased_send","","Perform the type erasure.",79,N],[8,"IntoErasedSendSync","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased + Send + Sync>`. This would be unneeded with higher kinded types support in the language.",N,N],[16,"Erased","","Owner with the dereference type substituted to `Erased + Send + Sync`.",80,N],[10,"into_erased_send_sync","","Perform the type erasure.",80,N],[8,"ToHandle","","Trait to implement the conversion of owner to handle for common types.",N,N],[16,"Handle","","The type of handle to be encapsulated by the OwningHandle.",81,N],[10,"to_handle","","Given an appropriately-long-lived pointer to ourselves, create a handle to be encapsulated by the `OwningHandle`.",81,N],[8,"ToHandleMut","","Trait to implement the conversion of owner to mutable handle for common types.",N,N],[16,"HandleMut","","The type of handle to be encapsulated by the OwningHandle.",82,N],[10,"to_handle_mut","","Given an appropriately-long-lived pointer to ourselves, create a mutable handle to be encapsulated by the `OwningHandle`.",82,N],[11,"new","","Creates a new owning reference from a owner initialized to the direct dereference of it.",75,[[["o"]],["self"]]],[11,"new_assert_stable_address","","Like `new`, but doesn’t require `O` to implement the `StableAddress` trait. Instead, the caller is responsible to make the same promises as implementing the trait.",75,[[["o"]],["self"]]],[11,"map","","Converts `self` into a new owning reference that points at something reachable from the previous one.",75,[[["self"],["f"]],["owningref"]]],[11,"try_map","","Tries to convert `self` into a new owning reference that points at something reachable from the previous one.",75,[[["self"],["f"]],["result",["owningref"]]]],[11,"map_owner","","Converts `self` into a new owning reference with a different owner type.",75,[[["self"],["f"]],["owningref"]]],[11,"map_owner_box","","Converts `self` into a new owning reference where the owner is wrapped in an additional `Box<O>`.",75,[[["self"]],["owningref",["box"]]]],[11,"erase_owner","","Erases the concrete base type of the owner with a trait object.",75,[[["self"]],["owningref"]]],[11,"erase_send_owner","","Erases the concrete base type of the owner with a trait object which implements `Send`.",75,[[["self"]],["owningref"]]],[11,"erase_send_sync_owner","","Erases the concrete base type of the owner with a trait object which implements `Send` and `Sync`.",75,[[["self"]],["owningref"]]],[11,"owner","","A getter for the underlying owner.",75,[[["self"]],["o"]]],[11,"into_inner","","Discards the reference and retrieves the owner.",75,[[["self"]],["o"]]],[11,"new","","Creates a new owning reference from a owner initialized to the direct dereference of it.",76,[[["o"]],["self"]]],[11,"new_assert_stable_address","","Like `new`, but doesn’t require `O` to implement the `StableAddress` trait. Instead, the caller is responsible to make the same promises as implementing the trait.",76,[[["o"]],["self"]]],[11,"map","","Converts `self` into a new shared owning reference that points at something reachable from the previous one.",76,[[["self"],["f"]],["owningref"]]],[11,"map_mut","","Converts `self` into a new mutable owning reference that points at something reachable from the previous one.",76,[[["self"],["f"]],["owningrefmut"]]],[11,"try_map","","Tries to convert `self` into a new shared owning reference that points at something reachable from the previous one.",76,[[["self"],["f"]],["result",["owningref"]]]],[11,"try_map_mut","","Tries to convert `self` into a new mutable owning reference that points at something reachable from the previous one.",76,[[["self"],["f"]],["result",["owningrefmut"]]]],[11,"map_owner","","Converts `self` into a new owning reference with a different owner type.",76,[[["self"],["f"]],["owningrefmut"]]],[11,"map_owner_box","","Converts `self` into a new owning reference where the owner is wrapped in an additional `Box<O>`.",76,[[["self"]],["owningrefmut",["box"]]]],[11,"erase_owner","","Erases the concrete base type of the owner with a trait object.",76,[[["self"]],["owningrefmut"]]],[11,"owner","","A getter for the underlying owner.",76,[[["self"]],["o"]]],[11,"into_inner","","Discards the reference and retrieves the owner.",76,[[["self"]],["o"]]],[11,"deref","","",77,N],[11,"deref_mut","","",77,N],[11,"new","","Create a new `OwningHandle` for a type that implements `ToHandle`. For types that don't implement `ToHandle`, callers may invoke `new_with_fn`, which accepts a callback to perform the conversion.",77,[[["o"]],["self"]]],[11,"new_mut","","Create a new mutable `OwningHandle` for a type that implements `ToHandleMut`.",77,[[["o"]],["self"]]],[11,"new_with_fn","","Create a new OwningHandle. The provided callback will be invoked with a pointer to the object owned by `o`, and the returned value is stored as the object to which this `OwningHandle` will forward `Deref` and `DerefMut`.",77,[[["o"],["f"]],["self"]]],[11,"try_new","","Create a new OwningHandle. The provided callback will be invoked with a pointer to the object owned by `o`, and the returned value is stored as the object to which this `OwningHandle` will forward `Deref` and `DerefMut`.",77,[[["o"],["f"]],["result"]]],[11,"deref","","",75,[[["self"]],["t"]]],[11,"deref","","",76,[[["self"]],["t"]]],[11,"deref_mut","","",76,[[["self"]],["t"]]],[11,"as_ref","","",75,[[["self"]],["t"]]],[11,"as_ref","","",76,[[["self"]],["t"]]],[11,"as_mut","","",76,[[["self"]],["t"]]],[11,"borrow","","",75,[[["self"]],["t"]]],[11,"from","","",75,[[["o"]],["self"]]],[11,"from","","",76,[[["o"]],["self"]]],[11,"from","","",75,[[["owningrefmut"]],["self"]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",76,[[["self"],["formatter"]],["result"]]],[11,"clone","","",75,[[["self"]],["self"]]],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"eq","","",75,[[["self"],["self"]],["bool"]]],[11,"partial_cmp","","",75,[[["self"],["self"]],["option",["ordering"]]]],[11,"cmp","","",75,[[["self"],["self"]],["ordering"]]],[11,"hash","","",75,[[["self"],["h"]]]],[11,"eq","","",76,[[["self"],["self"]],["bool"]]],[11,"partial_cmp","","",76,[[["self"],["self"]],["option",["ordering"]]]],[11,"cmp","","",76,[[["self"],["self"]],["ordering"]]],[11,"hash","","",76,[[["self"],["h"]]]],[0,"ptr_key","rustc_data_structures","",N,N],[3,"PtrKey","rustc_data_structures::ptr_key","A wrapper around reference that compares and hashes like a pointer. Can be used as a key in sets/maps indexed by pointers to avoid `unsafe`.",N,N],[12,"0","","",84,N],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"clone","","",84,[[["self"]],["self"]]],[11,"eq","","",84,[[["self"],["self"]],["bool"]]],[11,"hash","","",84,[[["self"],["h"]]]],[11,"deref","","",84,N],[0,"sip128","rustc_data_structures","This is a copy of `core::hash::sip` adapted to providing 128 bit hashes.",N,N],[3,"SipHasher128","rustc_data_structures::sip128","",N,N],[12,"k0","","",85,N],[12,"k1","","",85,N],[12,"length","","",85,N],[12,"state","","",85,N],[12,"tail","","",85,N],[12,"ntail","","",85,N],[3,"State","","",N,N],[12,"v0","","",86,N],[12,"v2","","",86,N],[12,"v1","","",86,N],[12,"v3","","",86,N],[3,"Sip24Rounds","","",N,N],[5,"u8to64_le","","Load an u64 using up to 7 bytes of a byte slice.",N,N],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"clone","","",85,[[["self"]],["siphasher128"]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"clone","","",86,[[["self"]],["state"]]],[11,"new_with_keys","","",85,[[["u64"],["u64"]],["siphasher128"]]],[11,"reset","","",85,[[["self"]]]],[11,"short_write","","",85,N],[11,"short_write_gen","","",85,[[["self"],["t"]]]],[11,"finish128","","",85,N],[11,"write_u8","","",85,[[["self"],["u8"]]]],[11,"write_u16","","",85,[[["self"],["u16"]]]],[11,"write_u32","","",85,[[["self"],["u32"]]]],[11,"write_u64","","",85,[[["self"],["u64"]]]],[11,"write_usize","","",85,[[["self"],["usize"]]]],[11,"write_i8","","",85,[[["self"],["i8"]]]],[11,"write_i16","","",85,[[["self"],["i16"]]]],[11,"write_i32","","",85,[[["self"],["i32"]]]],[11,"write_i64","","",85,[[["self"],["i64"]]]],[11,"write_isize","","",85,[[["self"],["isize"]]]],[11,"write","","",85,N],[11,"finish","","",85,[[["self"]],["u64"]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[11,"clone","","",87,[[["self"]],["sip24rounds"]]],[11,"default","","",87,[[],["sip24rounds"]]],[11,"c_rounds","","",87,[[["state"]]]],[11,"d_rounds","","",87,[[["state"]]]],[0,"small_vec","rustc_data_structures","A vector type intended to be used for collecting from iterators onto the stack.",N,N],[3,"SmallVec","rustc_data_structures::small_vec","",N,N],[12,"0","","",88,N],[11,"clone","","",88,[[["self"]],["self"]]],[11,"fmt","","",88,[[["self"],["formatter"]],["result"]]],[11,"new","","",88,[[],["self"]]],[11,"is_array","","",88,[[["self"]],["bool"]]],[11,"with_capacity","","",88,[[["usize"]],["self"]]],[11,"one","","",88,N],[11,"many","","",88,[[["i"]],["self"]]],[11,"expect_one","","",88,N],[11,"push","","Will reallocate onto the heap if needed.",88,N],[11,"reserve","","",88,[[["self"],["usize"]]]],[11,"set_len","","",88,[[["self"],["usize"]]]],[11,"insert","","",88,N],[11,"truncate","","",88,[[["self"],["usize"]]]],[11,"deref","","",88,N],[11,"deref_mut","","",88,[[["self"]],["accumulatevec"]]],[11,"from_iter","","",88,[[["i"]],["self"]]],[11,"extend","","",88,[[["self"],["i"]]]],[11,"into_iter","","",88,N],[11,"default","","",88,[[],["smallvec"]]],[11,"encode","","",88,[[["self"],["s"]],["result"]]],[11,"decode","","",88,[[["d"]],["result",["smallvec"]]]],[0,"snapshot_map","rustc_data_structures","",N,N],[3,"SnapshotMap","rustc_data_structures::snapshot_map","",N,N],[12,"map","","",89,N],[12,"undo_log","","",89,N],[3,"Snapshot","","",N,N],[12,"len","","",90,N],[4,"UndoLog","","",N,N],[13,"OpenSnapshot","","",91,N],[13,"CommittedSnapshot","","",91,N],[13,"Inserted","","",91,N],[13,"Overwrite","","",91,N],[13,"Noop","","",91,N],[11,"new","","",89,[[],["self"]]],[11,"clear","","",89,[[["self"]]]],[11,"insert","","",89,[[["self"],["k"],["v"]],["bool"]]],[11,"insert_noop","","",89,[[["self"]]]],[11,"remove","","",89,[[["self"],["k"]],["bool"]]],[11,"get","","",89,[[["self"],["k"]],["option"]]],[11,"snapshot","","",89,[[["self"]],["snapshot"]]],[11,"assert_open_snapshot","","",89,[[["self"],["snapshot"]]]],[11,"commit","","",89,[[["self"],["snapshot"]]]],[11,"partial_rollback","","",89,[[["self"],["snapshot"],["f"]]]],[11,"rollback_to","","",89,[[["self"],["snapshot"]]]],[11,"reverse","","",89,[[["self"],["undolog"]]]],[11,"index","","",89,[[["self"],["k"]],["v"]]],[0,"sorted_map","rustc_data_structures","",N,N],[3,"SortedMap","rustc_data_structures::sorted_map","`SortedMap` is a data structure with similar characteristics as BTreeMap but slightly different trade-offs: lookup, inseration, and removal are O(log(N)) and elements can be iterated in order cheaply.",N,N],[12,"data","","",92,N],[22,"","","",N,N],[22,"","","",N,N],[11,"clone","","",92,[[["self"]],["sortedmap"]]],[11,"eq","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"ne","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",92,N],[11,"partial_cmp","","",92,[[["self"],["sortedmap"]],["option",["ordering"]]]],[11,"lt","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"le","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"gt","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"ge","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"cmp","","",92,[[["self"],["sortedmap"]],["ordering"]]],[11,"hash","","",92,N],[11,"default","","",92,[[],["sortedmap"]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"encode","","",92,[[["self"],["__skv"]],["result"]]],[11,"decode","","",92,[[["__dkv"]],["result",["sortedmap"]]]],[11,"new","","",92,[[],["sortedmap"]]],[11,"from_presorted_elements","","Construct a `SortedMap` from a presorted set of elements. This is faster than creating an empty map and then inserting the elements individually.",92,[[["vec"]],["sortedmap"]]],[11,"insert","","",92,[[["self"],["k"],["v"]],["option"]]],[11,"remove","","",92,[[["self"],["k"]],["option"]]],[11,"get","","",92,[[["self"],["k"]],["option"]]],[11,"get_mut","","",92,[[["self"],["k"]],["option"]]],[11,"clear","","",92,[[["self"]]]],[11,"iter","","Iterate over elements, sorted by key",92,[[["self"]],["iter"]]],[11,"keys","","Iterate over the keys, sorted",92,[[["self"]],[""]]],[11,"values","","Iterate over values, sorted by key",92,[[["self"]],[""]]],[11,"len","","",92,[[["self"]],["usize"]]],[11,"range","","",92,N],[11,"remove_range","","",92,[[["self"],["r"]]]],[11,"offset_keys","","Mutate all keys with the given function `f`. This mutation must not change the sort-order of keys.",92,[[["self"],["f"]]]],[11,"insert_presorted","","Inserts a presorted range of elements into the map. If the range can be inserted as a whole in between to existing elements of the map, this will be faster than inserting the elements individually.",92,[[["self"],["vec"]]]],[11,"lookup_index_for","","Looks up the key in `self.data` via `slice::binary_search()`.",92,[[["self"],["k"]],["result",["usize","usize"]]]],[11,"range_slice_indices","","",92,N],[11,"into_iter","","",92,N],[11,"index","","",92,N],[11,"index_mut","","",92,N],[11,"from","","",92,[[["i"]],["self"]]],[0,"stable_hasher","rustc_data_structures","",N,N],[3,"StableHasher","rustc_data_structures::stable_hasher","When hashing something that ends up affecting properties like symbol names, we want these symbol names to be calculated independently of other factors like what architecture you're compiling from.",N,N],[12,"state","","",93,N],[12,"bytes_hashed","","",93,N],[12,"width","","",93,N],[3,"StableVec","","A vector container that makes sure that its items are hashed in a stable order.",N,N],[12,"0","","",94,N],[5,"hash_stable_hashmap","","",N,[[["hcx"],["stablehasher"],["hashmap"],["f"]]]],[8,"StableHasherResult","","",N,N],[10,"finish","","",95,[[["stablehasher"]],["self"]]],[8,"HashStable","","Something that implements `HashStable<CTX>` can be hashed in a way that is stable across multiple compilation sessions.",N,N],[10,"hash_stable","","",96,[[["self"],["ctx"],["stablehasher"]]]],[8,"ToStableHashKey","","Implement this for types that can be turned into stable keys like, for example, for DefId that can be converted to a DefPathHash. This is used for bringing maps into a predictable order before hashing them.",N,N],[16,"KeyType","","",97,N],[10,"to_stable_hash_key","","",97,N],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[11,"new","","",93,[[],["self"]]],[11,"finish","","",93,[[["self"]],["w"]]],[11,"finalize","","",93,N],[11,"bytes_hashed","","",93,[[["self"]],["u64"]]],[11,"finish","","",93,[[["self"]],["u64"]]],[11,"write","","",93,N],[11,"write_u8","","",93,[[["self"],["u8"]]]],[11,"write_u16","","",93,[[["self"],["u16"]]]],[11,"write_u32","","",93,[[["self"],["u32"]]]],[11,"write_u64","","",93,[[["self"],["u64"]]]],[11,"write_u128","","",93,[[["self"],["u128"]]]],[11,"write_usize","","",93,[[["self"],["usize"]]]],[11,"write_i8","","",93,[[["self"],["i8"]]]],[11,"write_i16","","",93,[[["self"],["i16"]]]],[11,"write_i32","","",93,[[["self"],["i32"]]]],[11,"write_i64","","",93,[[["self"],["i64"]]]],[11,"write_i128","","",93,[[["self"],["i128"]]]],[11,"write_isize","","",93,[[["self"],["isize"]]]],[11,"hash_stable","rustc_data_structures::indexed_vec","",62,[[["self"],["ctx"],["stablehasher"]]]],[11,"hash_stable","rustc_data_structures::indexed_set","",59,[[["self"],["ctx"],["stablehasher"]]]],[11,"new","rustc_data_structures::stable_hasher","",94,[[["vec"]],["self"]]],[11,"deref","","",94,[[["self"]],["vec"]]],[11,"hash_stable","","",94,[[["self"],["hcx"],["stablehasher"]]]],[0,"sync","rustc_data_structures","This module defines types which are thread safe if cfg!(parallel_queries) is true.",N,N],[8,"ParallelIterator","rustc_data_structures::sync","An interface for dealing with iterators.",N,N],[16,"Item","","The type of the elements being iterated over.",98,N],[10,"next","","Advances the iterator and returns the next value.",98,[[["self"]],["option"]]],[11,"size_hint","","Returns the bounds on the remaining length of the iterator.",98,N],[11,"count","","Consumes the iterator, counting the number of iterations and returning it.",98,[[["self"]],["usize"]]],[11,"last","","Consumes the iterator, returning the last element.",98,[[["self"]],["option"]]],[11,"nth","","Returns the `n`th element of the iterator.",98,[[["self"],["usize"]],["option"]]],[11,"step_by","","Creates an iterator starting at the same point, but stepping by the given amount at each iteration.",98,[[["self"],["usize"]],["stepby"]]],[11,"chain","","Takes two iterators and creates a new iterator over both in sequence.",98,[[["self"],["u"]],["chain"]]],[11,"zip","","'Zips up' two iterators into a single iterator of pairs.",98,[[["self"],["u"]],["zip"]]],[11,"map","","Takes a closure and creates an iterator which calls that closure on each element.",98,[[["self"],["f"]],["map"]]],[11,"for_each","","Calls a closure on each element of an iterator.",98,N],[11,"filter","","Creates an iterator which uses a closure to determine if an element should be yielded.",98,[[["self"],["p"]],["filter"]]],[11,"filter_map","","Creates an iterator that both filters and maps.",98,[[["self"],["f"]],["filtermap"]]],[11,"enumerate","","Creates an iterator which gives the current iteration count as well as the next value.",98,[[["self"]],["enumerate"]]],[11,"peekable","","Creates an iterator which can use `peek` to look at the next element of the iterator without consuming it.",98,[[["self"]],["peekable"]]],[11,"skip_while","","Creates an iterator that [`skip`]s elements based on a predicate.",98,[[["self"],["p"]],["skipwhile"]]],[11,"take_while","","Creates an iterator that yields elements based on a predicate.",98,[[["self"],["p"]],["takewhile"]]],[11,"skip","","Creates an iterator that skips the first `n` elements.",98,[[["self"],["usize"]],["skip"]]],[11,"take","","Creates an iterator that yields its first `n` elements.",98,[[["self"],["usize"]],["take"]]],[11,"scan","","An iterator adaptor similar to [`fold`] that holds internal state and produces a new iterator.",98,[[["self"],["st"],["f"]],["scan"]]],[11,"flat_map","","Creates an iterator that works like map, but flattens nested structure.",98,[[["self"],["f"]],["flatmap"]]],[11,"flatten","","Creates an iterator that flattens nested structure.",98,[[["self"]],["flatten"]]],[11,"fuse","","Creates an iterator which ends after the first [`None`].",98,[[["self"]],["fuse"]]],[11,"inspect","","Do something with each element of an iterator, passing the value on.",98,[[["self"],["f"]],["inspect"]]],[11,"by_ref","","Borrows an iterator, rather than consuming it.",98,[[["self"]],["self"]]],[11,"collect","","Transforms an iterator into a collection.",98,[[["self"]],["b"]]],[11,"partition","","Consumes an iterator, creating two collections from it.",98,N],[11,"try_fold","","An iterator method that applies a function as long as it returns successfully, producing a single, final value.",98,[[["self"],["b"],["f"]],["r"]]],[11,"try_for_each","","An iterator method that applies a fallible function to each item in the iterator, stopping at the first error and returning that error.",98,[[["self"],["f"]],["r"]]],[11,"fold","","An iterator method that applies a function, producing a single, final value.",98,[[["self"],["b"],["f"]],["b"]]],[11,"all","","Tests if every element of the iterator matches a predicate.",98,[[["self"],["f"]],["bool"]]],[11,"any","","Tests if any element of the iterator matches a predicate.",98,[[["self"],["f"]],["bool"]]],[11,"find","","Searches for an element of an iterator that satisfies a predicate.",98,[[["self"],["p"]],["option"]]],[11,"find_map","","Applies function to the elements of iterator and returns the first non-none result.",98,[[["self"],["f"]],["option"]]],[11,"position","","Searches for an element in an iterator, returning its index.",98,[[["self"],["p"]],["option",["usize"]]]],[11,"rposition","","Searches for an element in an iterator from the right, returning its index.",98,[[["self"],["p"]],["option",["usize"]]]],[11,"max","","Returns the maximum element of an iterator.",98,[[["self"]],["option"]]],[11,"min","","Returns the minimum element of an iterator.",98,[[["self"]],["option"]]],[11,"max_by_key","","Returns the element that gives the maximum value from the specified function.",98,[[["self"],["f"]],["option"]]],[11,"max_by","","Returns the element that gives the maximum value with respect to the specified comparison function.",98,[[["self"],["f"]],["option"]]],[11,"min_by_key","","Returns the element that gives the minimum value from the specified function.",98,[[["self"],["f"]],["option"]]],[11,"min_by","","Returns the element that gives the minimum value with respect to the specified comparison function.",98,[[["self"],["f"]],["option"]]],[11,"rev","","Reverses an iterator's direction.",98,[[["self"]],["rev"]]],[11,"unzip","","Converts an iterator of pairs into a pair of containers.",98,N],[11,"cloned","","Creates an iterator which [`clone`]s all of its elements.",98,[[["self"]],["cloned"]]],[11,"cycle","","Repeats an iterator endlessly.",98,[[["self"]],["cycle"]]],[11,"sum","","Sums the elements of an iterator.",98,[[["self"]],["s"]]],[11,"product","","Iterates over the entire iterator, multiplying all the elements",98,[[["self"]],["p"]]],[11,"cmp","","Lexicographically compares the elements of this `Iterator` with those of another.",98,[[["self"],["i"]],["ordering"]]],[11,"partial_cmp","","Lexicographically compares the elements of this `Iterator` with those of another.",98,[[["self"],["i"]],["option",["ordering"]]]],[11,"eq","","Determines if the elements of this `Iterator` are equal to those of another.",98,[[["self"],["i"]],["bool"]]],[11,"ne","","Determines if the elements of this `Iterator` are unequal to those of another.",98,[[["self"],["i"]],["bool"]]],[11,"lt","","Determines if the elements of this `Iterator` are lexicographically less than those of another.",98,[[["self"],["i"]],["bool"]]],[11,"le","","Determines if the elements of this `Iterator` are lexicographically less or equal to those of another.",98,[[["self"],["i"]],["bool"]]],[11,"gt","","Determines if the elements of this `Iterator` are lexicographically greater than those of another.",98,[[["self"],["i"]],["bool"]]],[11,"ge","","Determines if the elements of this `Iterator` are lexicographically greater than or equal to those of another.",98,[[["self"],["i"]],["bool"]]],[3,"Lrc","","A single-threaded reference-counting pointer. 'Rc' stands for 'Reference Counted'.",N,N],[12,"ptr","","",99,N],[12,"phantom","","",99,N],[3,"Weak","","`Weak` is a version of [`Rc`] that holds a non-owning reference to the managed value. The value is accessed by calling [`upgrade`] on the `Weak` pointer, which returns an [`Option`]`<`[`Rc`]`<T>>`.",N,N],[12,"ptr","","",100,N],[3,"ReadGuard","","Wraps a borrowed reference to a value in a `RefCell` box. A wrapper type for an immutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",101,N],[12,"borrow","","",101,N],[3,"WriteGuard","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",102,N],[12,"borrow","","",102,N],[3,"LockGuard","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",102,N],[12,"borrow","","",102,N],[3,"SerialScope","","",N,N],[3,"WorkerLocal","","",N,N],[12,"0","","",103,N],[3,"MTLock","","",N,N],[12,"0","","",104,N],[3,"LockCell","","",N,N],[12,"0","","",105,N],[3,"Once","","A type whose inner value can be written once and then will stay read-only",N,N],[12,"0","","",106,N],[12,"1","","",106,N],[3,"Lock","","",N,N],[12,"0","","",107,N],[3,"RwLock","","",N,N],[12,"0","","",108,N],[3,"OneThread","","A type which only allows its inner value to be used in one thread. It will panic if it is used on multiple threads.",N,N],[12,"inner","","",109,N],[5,"serial_join","","",N,N],[5,"serial_scope","","",N,[[["f"]],["r"]]],[5,"par_iter","","",N,N],[5,"assert_sync","","",N,[[]]],[5,"assert_send_val","","",N,[[["t"]]]],[5,"assert_send_sync_val","","",N,[[["t"]]]],[6,"MetadataRef","","",N,N],[6,"MTRef","","",N,N],[8,"Send","","",N,N],[8,"Sync","","",N,N],[8,"HashMapExt","","",N,N],[10,"insert_same","","Same as HashMap::insert, but it may panic if there's already an entry for `key` with a value not equal to `value`",110,[[["self"],["k"],["v"]]]],[11,"spawn","","",111,[[["self"],["f"]]]],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[11,"new","","Creates a new worker local where the `initial` closure computes the value this worker local should take for each thread in the thread pool.",103,[[["f"]],["workerlocal"]]],[11,"into_inner","","Returns the worker-local value for each thread",103,[[["self"]],["vec"]]],[11,"deref","","",103,[[["self"]],["t"]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"new","","",104,[[["t"]],["self"]]],[11,"into_inner","","",104,[[["self"]],["t"]]],[11,"get_mut","","",104,[[["self"]],["t"]]],[11,"lock","","",104,[[["self"]],["t"]]],[11,"lock_mut","","",104,[[["self"]],["t"]]],[11,"clone","","",104,[[["self"]],["self"]]],[11,"new","","",105,[[["t"]],["self"]]],[11,"into_inner","","",105,[[["self"]],["t"]]],[11,"set","","",105,[[["self"],["t"]]]],[11,"get","","",105,[[["self"]],["t"]]],[11,"set_mut","","",105,[[["self"],["t"]]]],[11,"get_mut","","",105,[[["self"]],["t"]]],[11,"take","","",105,[[["self"]],["option"]]],[11,"new","","Creates an Once value which is uninitialized",106,[[],["self"]]],[11,"into_inner","","Consumes the value and returns Some(T) if it was initialized",106,[[["self"]],["option"]]],[11,"try_set","","Tries to initialize the inner value to `value`. Returns `None` if the inner value was uninitialized and `value` was consumed setting it otherwise if the inner value was already set it returns `value` back to the caller",106,[[["self"],["t"]],["option"]]],[11,"try_set_same","","Tries to initialize the inner value to `value`. Returns `None` if the inner value was uninitialized and `value` was consumed setting it otherwise if the inner value was already set it asserts that `value` is equal to the inner value and then returns `value` back to the caller",106,[[["self"],["t"]],["option"]]],[11,"set","","Tries to initialize the inner value to `value` and panics if it was already initialized",106,[[["self"],["t"]]]],[11,"init_locking","","Tries to initialize the inner value by calling the closure while ensuring that no-one else can access the value in the mean time by holding a lock for the duration of the closure. If the value was already initialized the closure is not called and `false` is returned, otherwise if the value from the closure initializes the inner value, `true` is returned",106,[[["self"],["f"]],["bool"]]],[11,"init_nonlocking","","Tries to initialize the inner value by calling the closure without ensuring that no-one else can access it. This mean when this is called from multiple threads, multiple closures may concurrently be computing a value which the inner value should take. Only one of these closures are used to actually initialize the value. If some other closure already set the value, we return the value our closure computed wrapped in a `Option`. If our closure set the value, `None` is returned. If the value is already initialized, the closure is not called and `None` is returned.",106,[[["self"],["f"]],["option"]]],[11,"init_nonlocking_same","","Tries to initialize the inner value by calling the closure without ensuring that no-one else can access it. This mean when this is called from multiple threads, multiple closures may concurrently be computing a value which the inner value should take. Only one of these closures are used to actually initialize the value. If some other closure already set the value, we assert that it our closure computed a value equal to the value aready set and then we return the value our closure computed wrapped in a `Option`. If our closure set the value, `None` is returned. If the value is already initialized, the closure is not called and `None` is returned.",106,[[["self"],["f"]],["option"]]],[11,"try_get","","Tries to get a reference to the inner value, returns `None` if it is not yet initialized",106,[[["self"]],["option"]]],[11,"get","","Gets reference to the inner value, panics if it is not yet initialized",106,[[["self"]],["t"]]],[11,"borrow","","Gets reference to the inner value, panics if it is not yet initialized",106,[[["self"]],["t"]]],[11,"fmt","","",105,[[["self"],["formatter"]],["result"]]],[11,"default","","Creates a `LockCell<T>`, with the `Default` value for T.",105,[[],["lockcell"]]],[11,"eq","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"partial_cmp","","",105,[[["self"],["lockcell"]],["option",["ordering"]]]],[11,"lt","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"le","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"gt","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"ge","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"cmp","","",105,[[["self"],["lockcell"]],["ordering"]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[11,"new","","",107,[[["t"]],["self"]]],[11,"into_inner","","",107,[[["self"]],["t"]]],[11,"get_mut","","",107,[[["self"]],["t"]]],[11,"try_lock","","",107,[[["self"]],["option",["lockguard"]]]],[11,"lock","","",107,[[["self"]],["lockguard"]]],[11,"with_lock","","",107,[[["self"],["f"]],["r"]]],[11,"borrow","","",107,[[["self"]],["lockguard"]]],[11,"borrow_mut","","",107,[[["self"]],["lockguard"]]],[11,"default","","",107,[[],["self"]]],[11,"clone","","",107,[[["self"]],["self"]]],[11,"fmt","","",108,[[["self"],["formatter"]],["result"]]],[11,"new","","",108,[[["t"]],["self"]]],[11,"into_inner","","",108,[[["self"]],["t"]]],[11,"get_mut","","",108,[[["self"]],["t"]]],[11,"read","","",108,[[["self"]],["readguard"]]],[11,"with_read_lock","","",108,[[["self"],["f"]],["r"]]],[11,"try_write","","",108,[[["self"]],["result",["writeguard"]]]],[11,"write","","",108,[[["self"]],["writeguard"]]],[11,"with_write_lock","","",108,[[["self"],["f"]],["r"]]],[11,"borrow","","",108,[[["self"]],["readguard"]]],[11,"borrow_mut","","",108,[[["self"]],["writeguard"]]],[11,"clone","","",108,[[["self"]],["self"]]],[11,"clone","","",109,[[["self"]],["onethread"]]],[11,"hash","","",109,N],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",109,N],[11,"eq","","",109,[[["self"],["onethread"]],["bool"]]],[11,"ne","","",109,[[["self"],["onethread"]],["bool"]]],[11,"check","","",109,[[["self"]]]],[11,"new","","",109,[[["t"]],["self"]]],[11,"into_inner","","",109,[[["self"]],["t"]]],[11,"deref","","",109,[[["self"]],["t"]]],[11,"deref_mut","","",109,[[["self"]],["t"]]],[0,"tiny_list","rustc_data_structures","A singly-linked list.",N,N],[3,"TinyList","rustc_data_structures::tiny_list","",N,N],[12,"head","","",112,N],[3,"Element","","",N,N],[12,"data","","",113,N],[12,"next","","",113,N],[11,"clone","","",112,[[["self"]],["tinylist"]]],[11,"hash","","",112,N],[11,"fmt","","",112,[[["self"],["formatter"]],["result"]]],[11,"eq","","",112,[[["self"],["tinylist"]],["bool"]]],[11,"ne","","",112,[[["self"],["tinylist"]],["bool"]]],[11,"new","","",112,[[],["tinylist"]]],[11,"new_single","","",112,[[["t"]],["tinylist"]]],[11,"insert","","",112,[[["self"],["t"]]]],[11,"remove","","",112,[[["self"],["t"]],["bool"]]],[11,"contains","","",112,[[["self"],["t"]],["bool"]]],[11,"len","","",112,[[["self"]],["usize"]]],[11,"clone","","",113,[[["self"]],["element"]]],[11,"hash","","",113,N],[11,"fmt","","",113,[[["self"],["formatter"]],["result"]]],[11,"eq","","",113,[[["self"],["element"]],["bool"]]],[11,"ne","","",113,[[["self"],["element"]],["bool"]]],[11,"remove_next","","",113,[[["self"],["t"]],["bool"]]],[11,"len","","",113,[[["self"]],["usize"]]],[11,"contains","","",113,[[["self"],["t"]],["bool"]]],[0,"transitive_relation","rustc_data_structures","",N,N],[3,"TransitiveRelation","rustc_data_structures::transitive_relation","",N,N],[12,"elements","","",114,N],[12,"map","","",114,N],[12,"edges","","",114,N],[12,"closure","","",114,N],[3,"Index","","",N,N],[12,"0","","",115,N],[3,"Edge","","",N,N],[12,"source","","",116,N],[12,"target","","",116,N],[5,"pare_down","","Pare down is used as a step in the LUB computation. It edits the candidates array in place by removing any element j for which there exists an earlier element i<j such that i -> j. That is, after you run `pare_down`, you know that for all elements that remain in candidates, they cannot reach any of the elements that come after them.",N,[[["vec"],["bitmatrix"]]]],[11,"clone","","",114,[[["self"]],["transitiverelation"]]],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"clone","","",115,[[["self"]],["index"]]],[11,"eq","","",115,[[["self"],["index"]],["bool"]]],[11,"ne","","",115,[[["self"],["index"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",115,N],[11,"partial_cmp","","",115,[[["self"],["index"]],["option",["ordering"]]]],[11,"lt","","",115,[[["self"],["index"]],["bool"]]],[11,"le","","",115,[[["self"],["index"]],["bool"]]],[11,"gt","","",115,[[["self"],["index"]],["bool"]]],[11,"ge","","",115,[[["self"],["index"]],["bool"]]],[11,"cmp","","",115,[[["self"],["index"]],["ordering"]]],[11,"hash","","",115,N],[11,"encode","","",115,[[["self"],["__s"]],["result"]]],[11,"decode","","",115,[[["__d"]],["result",["index"]]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",116,[[["self"]],["edge"]]],[11,"eq","","",116,[[["self"],["edge"]],["bool"]]],[11,"ne","","",116,[[["self"],["edge"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",116,N],[11,"encode","","",116,[[["self"],["__s"]],["result"]]],[11,"decode","","",116,[[["__d"]],["result",["edge"]]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"new","","",114,[[],["transitiverelation"]]],[11,"is_empty","","",114,[[["self"]],["bool"]]],[11,"index","","",114,[[["self"],["t"]],["option",["index"]]]],[11,"add_index","","",114,[[["self"],["t"]],["index"]]],[11,"maybe_map","","Applies the (partial) function to each edge and returns a new relation.  If `f` returns `None` for any end-point, returns `None`.",114,[[["self"],["f"]],["option",["transitiverelation"]]]],[11,"add","","Indicate that `a < b` (where `<` is this relation)",114,[[["self"],["t"],["t"]]]],[11,"contains","","Check whether `a < target` (transitively)",114,[[["self"],["t"],["t"]],["bool"]]],[11,"reachable_from","","Thinking of `x R y` as an edge `x -> y` in a graph, this returns all things reachable from `a`.",114,[[["self"],["t"]],["vec"]]],[11,"postdom_upper_bound","","Picks what I am referring to as the \"postdominating\" upper-bound for `a` and `b`. This is usually the least upper bound, but in cases where there is no single least upper bound, it is the \"mutual immediate postdominator\", if you imagine a graph where `a < b` means `a -> b`.",114,[[["self"],["t"],["t"]],["option"]]],[11,"mutual_immediate_postdominator","","Viewing the relation as a graph, computes the \"mutual immediate postdominator\" of a set of points (if one exists). See `postdom_upper_bound` for details.",114,[[["self"],["vec"]],["option"]]],[11,"minimal_upper_bounds","","Returns the set of bounds `X` such that:",114,[[["self"],["t"],["t"]],["vec"]]],[11,"parents","","Given an element A, returns the maximal set {B} of elements B such that",114,[[["self"],["t"]],["vec"]]],[11,"postdom_parent","","A \"best\" parent in some sense. See `parents` and `postdom_upper_bound` for more details.",114,[[["self"],["t"]],["option"]]],[11,"with_closure","","",114,[[["self"],["op"]],["r"]]],[11,"compute_closure","","",114,[[["self"]],["bitmatrix",["usize","usize"]]]],[11,"encode","","",114,[[["self"],["e"]],["result"]]],[11,"decode","","",114,[[["d"]],["result"]]],[11,"hash_stable","","",114,[[["self"],["ctx"],["stablehasher"]]]],[11,"hash_stable","","",116,[[["self"],["ctx"],["stablehasher"]]]],[11,"hash_stable","","",115,[[["self"],["ctx"],["stablehasher"]]]],[0,"tuple_slice","rustc_data_structures","",N,N],[8,"TupleSlice","rustc_data_structures::tuple_slice","Allows to view uniform tuples as slices",N,N],[10,"as_slice","","",117,N],[10,"as_mut_slice","","",117,N],[0,"work_queue","rustc_data_structures","",N,N],[3,"WorkQueue","rustc_data_structures::work_queue","A work queue is a handy data structure for tracking work left to do. (For example, basic blocks left to process.) It is basically a de-duplicating queue; so attempting to insert X if X is already enqueued has no effect. This implementation assumes that the elements are dense indices, so it can allocate the queue to size and also use a bit set to track occupancy.",N,N],[12,"deque","","",118,N],[12,"set","","",118,N],[11,"with_all","","Create a new work queue with all the elements from (0..len).",118,[[["usize"]],["self"]]],[11,"with_none","","Create a new work queue that starts empty, where elements range from (0..len).",118,[[["usize"]],["self"]]],[11,"insert","","Attempt to enqueue `element` in the work queue. Returns false if it was already present.",118,[[["self"],["t"]],["bool"]]],[11,"pop","","Attempt to enqueue `element` in the work queue. Returns false if it was already present.",118,[[["self"]],["option"]]],[11,"is_empty","","True if nothing is enqueued.",118,[[["self"]],["bool"]]],[11,"disable","rustc_data_structures","Forgets the function which prevents it from running. Ensure that the function owns no memory, otherwise it will be leaked.",13,[[["self"]]]],[11,"drop","","",13,[[["self"]]]],[14,"newtype_index","","",N,N],[14,"rustc_erase_owner","","",N,N],[11,"from","rustc_data_structures::sync","",99,[[["pathbuf"]],["rc",["path"]]]],[11,"from","","",99,[[["cstring"]],["rc",["cstr"]]]],[11,"from","","",99,[[["osstring"]],["rc",["osstr"]]]],[11,"from","","",99,[[["cstr"]],["rc",["cstr"]]]],[11,"from","","",99,[[["path"]],["rc",["path"]]]],[11,"from","","",99,[[["osstr"]],["rc",["osstr"]]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result",["error"]]]],[11,"deref_mut","","",102,[[["self"]],["t"]]],[11,"deref","","",101,[[["self"]],["t"]]],[11,"deref","","",102,[[["self"]],["t"]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result",["error"]]]],[11,"cmp","","Comparison for two `Rc`s.",99,[[["self"],["rc"]],["ordering"]]],[11,"clone","","Makes a clone of the `Rc` pointer.",99,[[["self"]],["rc"]]],[11,"clone","","Makes a clone of the `Weak` pointer that points to the same value.",100,[[["self"]],["weak"]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result",["error"]]]],[11,"as_ref","","",99,[[["self"]],["t"]]],[11,"deref","","",99,[[["self"]],["t"]]],[11,"drop","","Drops the `Weak` pointer.",100,N],[11,"drop","","Drops the `Rc`.",99,N],[11,"borrow","","",99,[[["self"]],["t"]]],[11,"default","","Constructs a new `Weak<T>`, allocating memory for `T` without initializing it. Calling [`upgrade`] on the return value always gives [`None`].",100,[[],["weak"]]],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",99,[[],["rc"]]],[11,"eq","","Equality for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"ne","","Inequality for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"from","","",99,[[["str"]],["rc",["str"]]]],[11,"from","","",99,[[["t"]],["rc"]]],[11,"from","","",99,[[["vec"]],["rc"]]],[11,"from","","",99,N],[11,"from","","",99,[[["box"]],["rc"]]],[11,"from","","",99,[[["string"]],["rc",["str"]]]],[11,"hash","","",99,N],[11,"partial_cmp","","Partial comparison for two `Rc`s.",99,[[["self"],["rc"]],["option",["ordering"]]]],[11,"lt","","Less-than comparison for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"le","","'Less than or equal to' comparison for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"gt","","Greater-than comparison for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"ge","","'Greater than or equal to' comparison for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","rustc_data_structures::snapshot_vec","",1,[[["self"]],["undolog"]]],[11,"clone","","",2,[[["self"]],["snapshotvec"]]],[11,"clone","rustc_data_structures::unify","",11,[[["self"]],["inplace"]]],[11,"clone","","",8,[[["self"]],["varvalue"]]],[11,"clone","","",9,[[["self"]],["unificationtable"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_data_structures::snapshot_vec","",1,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_data_structures::unify","",8,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_data_structures::snapshot_vec","",2,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_data_structures::unify","",9,[[["self"],["formatter"]],["result",["error"]]]],[11,"deref_mut","rustc_data_structures::snapshot_vec","",2,N],[11,"index_mut","","",2,N],[11,"index","","",2,N],[11,"index","rustc_data_structures::unify","",11,[[["self"],["usize"]],["varvalue"]]],[11,"deref","rustc_data_structures::snapshot_vec","",2,N],[11,"extend","","",2,N],[11,"new","rustc_data_structures::unify","",11,[[],["inplace"]]],[11,"start_snapshot","","",11,N],[11,"rollback_to","","",11,N],[11,"commit","","",11,N],[11,"reset_unifications","","",11,N],[11,"len","","",11,[[["self"]],["usize"]]],[11,"push","","",11,N],[11,"reserve","","",11,N],[11,"update","","",11,N],[11,"eq","","",8,[[["self"],["varvalue"]],["bool"]]],[11,"ne","","",8,[[["self"],["varvalue"]],["bool"]]],[11,"decode","rustc_data_structures::sync","",99,[[["d"]],["result",["rc"]]]],[11,"decode","","",99,[[["d"]],["result",["rc"]]]],[11,"encode","","",99,[[["self"],["s"]],["result"]]],[11,"encode","","",99,[[["self"],["e"]],["result"]]],[11,"into_erased","","",99,N],[11,"default","rustc_data_structures::fx","",34,[[],["fxhasher"]]],[11,"write","","",34,N],[11,"write_u8","","",34,N],[11,"write_u16","","",34,N],[11,"write_u32","","",34,N],[11,"write_u64","","",34,N],[11,"write_usize","","",34,N],[11,"finish","","",34,[[["self"]],["u64"]]],[11,"new","rustc_data_structures::snapshot_vec","",2,[[],["snapshotvec"]]],[11,"with_capacity","","",2,[[["usize"]],["snapshotvec"]]],[11,"record","","",2,N],[11,"len","","",2,[[["self"]],["usize"]]],[11,"push","","",2,N],[11,"get","","",2,N],[11,"reserve","","Reserve space for new values, just like an ordinary vec.",2,N],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone automatically, so you should be sure call `record()` with some sort of suitable undo action.",2,N],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if a snapshot is active.",2,N],[11,"set_all","","Updates all elements. Potentially more efficient -- but otherwise equivalent to -- invoking `set` for each element.",2,N],[11,"update","","",2,N],[11,"start_snapshot","","",2,[[["self"]],["snapshot"]]],[11,"actions_since_snapshot","","",2,N],[11,"rollback_to","","",2,N],[11,"commit","","Commits all changes since the last snapshot. Of course, they can still be undone if there is a snapshot further out.",2,N],[11,"new","rustc_data_structures::unify","",9,[[],["unificationtable"]]],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either rolled back or committed in a \"LIFO\" (stack) order.",9,[[["self"]],["snapshot"]]],[11,"rollback_to","","Reverses all changes since the last snapshot. Also removes any keys that have been created since then.",9,N],[11,"commit","","Commits all changes since the last snapshot. Of course, they can still be undone if there is a snapshot further out.",9,N],[11,"new_key","","Creates a fresh key with the given value.",9,N],[11,"reserve","","Reserve memory for `num_new_keys` to be created. Does not actually create the new keys; you must then invoke `new_key`.",9,N],[11,"reset_unifications","","Clears all unifications that have been performed, resetting to the initial state. The values of each variable are given by the closure.",9,N],[11,"len","","Returns the number of keys created so far.",9,[[["self"]],["usize"]]],[11,"union","","Unions two keys without the possibility of failure; only applicable when unify values use `NoError` as their error type.",9,N],[11,"union_value","","Unions a key and a value without the possibility of failure; only applicable when unify values use `NoError` as their error type.",9,N],[11,"unioned","","Given two keys, indicates whether they have been unioned together.",9,[[["self"],["k1"],["k2"]],["bool"]]],[11,"find","","Given a key, returns the (current) root key.",9,[[["self"],["k1"]],["k"]]],[11,"unify_var_var","","Unions together two variables, merging their values. If merging the values fails, the error is propagated and this method has no effect.",9,[[["self"],["k1"],["k2"]],["result"]]],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`, attempting to merge with the previous value.",9,[[["self"],["k1"],["v"]],["result"]]],[11,"probe_value","","Returns the current value for the given key. If the key has been union'd, this will give the value from the current root.",9,[[["self"],["k1"]],["v"]]],[11,"into_erased","rustc_data_structures::sync","",99,N],[11,"hash_stable","","",99,[[["self"],["ctx"],["stablehasher"]]]],[11,"new","","Constructs a new `Rc<T>`.",99,[[["t"]],["rc"]]],[11,"try_unwrap","","Returns the contained value, if the `Rc` has exactly one strong reference.",99,[[["rc"]],["result",["rc"]]]],[11,"into_raw","","Consumes the `Rc`, returning the wrapped pointer.",99,N],[11,"from_raw","","Constructs an `Rc` from a raw pointer.",99,N],[11,"downgrade","","Creates a new [`Weak`][weak] pointer to this value.",99,[[["rc"]],["weak"]]],[11,"weak_count","","Gets the number of [`Weak`][weak] pointers to this value.",99,[[["rc"]],["usize"]]],[11,"strong_count","","Gets the number of strong (`Rc`) pointers to this value.",99,[[["rc"]],["usize"]]],[11,"get_mut","","Returns a mutable reference to the inner value, if there are no other `Rc` or [`Weak`][weak] pointers to the same value.",99,[[["rc"]],["option"]]],[11,"ptr_eq","","Returns true if the two `Rc`s point to the same value (not just values that compare as equal).",99,[[["rc"],["rc"]],["bool"]]],[11,"make_mut","","Makes a mutable reference into the given `Rc`.",99,[[["rc"]],["t"]]],[11,"downcast","","Attempt to downcast the `Rc<Any>` to a concrete type.",99,[[["self"]],["result",["rc","rc"]]]],[11,"new","","Constructs a new `Weak<T>`, without allocating any memory. Calling [`upgrade`] on the return value always gives [`None`].",100,[[],["weak"]]],[11,"upgrade","","Attempts to upgrade the `Weak` pointer to an [`Rc`], extending the lifetime of the value if successful.",100,[[["self"]],["option",["rc"]]]],[11,"clone","","Copies a `Ref`.",101,[[["ref"]],["ref"]]],[11,"map","","Make a new `Ref` for a component of the borrowed data.",101,[[["ref"],["f"]],["ref"]]],[11,"map_split","","Split a `Ref` into multiple `Ref`s for different components of the borrowed data.",101,N],[11,"map","","Make a new `RefMut` for a component of the borrowed data, e.g. an enum variant.",102,[[["refmut"],["f"]],["refmut"]]],[11,"map_split","","Split a `RefMut` into multiple `RefMut`s for different components of the borrowed data.",102,N]],"paths":[[8,"ToHex"],[4,"UndoLog"],[3,"SnapshotVec"],[3,"Snapshot"],[8,"SnapshotVecDelegate"],[8,"UnifyKey"],[8,"UnifyValue"],[3,"NoError"],[3,"VarValue"],[3,"UnificationTable"],[3,"Snapshot"],[3,"InPlace"],[8,"UnificationStore"],[3,"OnDrop"],[3,"IntoIter"],[4,"AccumulateVec"],[4,"IntoIterRepr"],[4,"Drain"],[3,"ArrayVec"],[3,"Iter"],[3,"Drain"],[8,"Array"],[3,"BitLookup"],[8,"BitSlice"],[8,"BitwiseOperator"],[3,"Intersect"],[3,"Union"],[3,"Subtract"],[3,"BitVector"],[3,"BitVectorIter"],[3,"BitMatrix"],[3,"SparseBitMatrix"],[3,"Lock"],[3,"flock"],[3,"FxHasher"],[3,"Dominators"],[3,"Iter"],[3,"DominatorTree"],[3,"DominatorTreeNode"],[3,"Graph"],[3,"Node"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Direction"],[3,"AdjacentEdges"],[3,"DepthFirstTraversal"],[3,"Sccs"],[3,"SccData"],[3,"SccsConstruction"],[4,"NodeState"],[4,"WalkReturn"],[8,"DirectedGraph"],[8,"WithNumNodes"],[8,"WithSuccessors"],[8,"GraphSuccessors"],[8,"WithPredecessors"],[8,"GraphPredecessors"],[8,"WithStartNode"],[3,"IdxSetBuf"],[3,"IdxSet"],[3,"Iter"],[3,"IndexVec"],[3,"IntoIdx"],[8,"Idx"],[3,"ObligationForest"],[3,"Node"],[3,"Outcome"],[3,"Error"],[3,"GetObligation"],[4,"ProcessResult"],[4,"NodeState"],[3,"NodeIndex"],[8,"ForestObligation"],[8,"ObligationProcessor"],[3,"OwningRef"],[3,"OwningRefMut"],[3,"OwningHandle"],[8,"IntoErased"],[8,"IntoErasedSend"],[8,"IntoErasedSendSync"],[8,"ToHandle"],[8,"ToHandleMut"],[8,"Erased"],[3,"PtrKey"],[3,"SipHasher128"],[3,"State"],[3,"Sip24Rounds"],[3,"SmallVec"],[3,"SnapshotMap"],[3,"Snapshot"],[4,"UndoLog"],[3,"SortedMap"],[3,"StableHasher"],[3,"StableVec"],[8,"StableHasherResult"],[8,"HashStable"],[8,"ToStableHashKey"],[8,"ParallelIterator"],[3,"Lrc"],[3,"Weak"],[3,"ReadGuard"],[3,"LockGuard"],[3,"WorkerLocal"],[3,"MTLock"],[3,"LockCell"],[3,"Once"],[3,"Lock"],[3,"RwLock"],[3,"OneThread"],[8,"HashMapExt"],[3,"SerialScope"],[3,"TinyList"],[3,"Element"],[3,"TransitiveRelation"],[3,"Index"],[3,"Edge"],[8,"TupleSlice"],[3,"WorkQueue"]]};
searchIndex["rustc_driver"]={"doc":"The Rust compiler.","items":[[3,"RustcDefaultCalls","rustc_driver","CompilerCalls instance for a regular rustc build.",N,N],[3,"CompilationFailure","","",N,N],[4,"Compilation","","",N,N],[13,"Stop","","",0,N],[13,"Continue","","",0,N],[5,"abort_on_err","","",N,[[["result",["compileincomplete"]],["session"]],["t"]]],[5,"run","","",N,[[["f"]],["isize"]]],[5,"load_backend_from_dylib","","",N,N],[5,"get_codegen_backend","","",N,[[["session"]],["box",["codegenbackend"]]]],[5,"get_codegen_sysroot","","",N,N],[5,"run_compiler","","",N,N],[5,"run_compiler_with_pool","","",N,N],[5,"set_sigpipe_handler","","",N,[[]]],[5,"make_output","","",N,N],[5,"make_input","","",N,N],[5,"parse_pretty","","",N,[[["session"],["matches"]],["option"]]],[5,"stdout_isatty","","",N,[[],["bool"]]],[5,"handle_explain","","",N,[[["str"],["registry"],["erroroutputtype"]]]],[5,"show_content_with_pager","","",N,[[["string"]]]],[5,"enable_save_analysis","","",N,[[["compilecontroller"]]]],[5,"release_str","","Returns a version string such as \"0.12.0-dev\".",N,[[],["option",["str"]]]],[5,"commit_hash_str","","Returns the full SHA1 hash of HEAD of the Git repo from which rustc was built.",N,[[],["option",["str"]]]],[5,"commit_date_str","","Returns the \"commit date\" of HEAD of the Git repo from which rustc was built as a static string.",N,[[],["option",["str"]]]],[5,"version","","Prints version information",N,[[["str"],["matches"]]]],[5,"usage","","",N,[[["bool"],["bool"]]]],[5,"print_wall_help","","",N,[[]]],[5,"describe_lints","","",N,[[["session"],["lintstore"],["bool"]]]],[5,"describe_debug_flags","","",N,[[]]],[5,"describe_codegen_flags","","",N,[[]]],[5,"print_flag_list","","",N,N],[5,"handle_options","","Process command line options. Emits messages as appropriate. If compilation should continue, returns a getopts::Matches object parsed from args, otherwise returns None.",N,N],[5,"parse_crate_attrs","","",N,[[["session"],["input"]],["presult",["vec"]]]],[5,"in_named_rustc_thread","","Runs `f` in a suitable thread for running `rustc`; returns a `Result` with either the return value of `f` or -- if a panic occurs -- the panic value.",N,[[["string"],["f"]],["result",["box"]]]],[5,"in_rustc_thread","","Runs `f` in a suitable thread for running `rustc`; returns a `Result` with either the return value of `f` or -- if a panic occurs -- the panic value.",N,[[["f"]],["result",["box"]]]],[5,"extra_compiler_flags","","Get a list of extra command-line flags provided by the user, as strings.",N,[[],["option"]]],[5,"monitor","","Run a procedure which will detect panics in the compiler and print nicer error messages rather than just failing the test.",N,[[["f"]],["result",["compilationfailure"]]]],[5,"diagnostics_registry","","",N,[[],["registry"]]],[5,"init_rustc_env_logger","","This allows tools to enable rust logging without having to magically match rustc's log crate version",N,[[]]],[5,"main","","",N,[[]]],[0,"profile","","",N,N],[3,"StackFrame","rustc_driver::profile","",N,N],[12,"parse_st","","",1,N],[12,"traces","","",1,N],[4,"ParseState","","",N,N],[13,"Clear","","",2,N],[13,"HaveQuery","","",2,N],[13,"HaveTimeBegin","","",2,N],[13,"HaveTaskBegin","","",2,N],[5,"begin","","begin a profile thread, if not already running",N,[[["session"]]]],[5,"dump","","dump files with profiling information to the given base path, and wait for this dump to complete.",N,[[["session"],["string"]]]],[5,"total_duration","","",N,N],[5,"profile_queries_thread","","",N,[[["receiver",["profilequeriesmsg"]]]]],[0,"trace","","",N,N],[3,"Query","rustc_driver::profile::trace","",N,N],[12,"span","","",3,N],[12,"msg","","",3,N],[3,"Rec","","Recursive trace structure",N,N],[12,"effect","","",4,N],[12,"start","","",4,N],[12,"dur_self","","",4,N],[12,"dur_total","","",4,N],[12,"extent","","",4,N],[3,"QueryMetric","","",N,N],[12,"count","","",5,N],[12,"dur_self","","",5,N],[12,"dur_total","","",5,N],[4,"Effect","","",N,N],[13,"QueryBegin","","",6,N],[13,"TimeBegin","","",6,N],[13,"TaskBegin","","",6,N],[4,"CacheCase","","",N,N],[13,"Hit","","",7,N],[13,"Miss","","",7,N],[5,"cons_of_query_msg","","",N,[[["query"]],["string"]]],[5,"cons_of_key","","",N,[[["depnode"]],["string"]]],[5,"html_of_effect","","",N,N],[5,"html_of_duration","","",N,N],[5,"html_of_fraction","","",N,N],[5,"total_duration","","",N,N],[5,"duration_div","","",N,[[["duration"],["duration"]],["f64"]]],[5,"write_traces_rec","","",N,N],[5,"compute_counts_rec","","",N,N],[5,"write_counts","","",N,[[["file"],["hashmap"]]]],[5,"write_traces","","",N,N],[5,"write_style","","",N,[[["file"]]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",3,[[["self"]],["query"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"eq","","",3,[[["self"],["query"]],["bool"]]],[11,"ne","","",3,[[["self"],["query"]],["bool"]]],[11,"clone","rustc_driver::profile","",2,[[["self"]],["parsestate"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"eq","","",2,[[["self"],["parsestate"]],["bool"]]],[11,"ne","","",2,[[["self"],["parsestate"]],["bool"]]],[0,"driver","rustc_driver","",N,N],[3,"CompileController","rustc_driver::driver","CompileController is used to customize compilation, it allows compilation to be stopped and/or to call arbitrary code at various points in compilation. It also allows for various flags to be set to influence what information gets collected during compilation.",N,N],[12,"after_parse","","",8,N],[12,"after_expand","","",8,N],[12,"after_hir_lowering","","",8,N],[12,"after_analysis","","",8,N],[12,"compilation_done","","",8,N],[12,"make_glob_map","","",8,N],[12,"keep_ast","","",8,N],[12,"continue_parse_after_error","","",8,N],[12,"provide","","Allows overriding default rustc query providers, after `default_provide` has installed them.",8,N],[12,"provide_extern","","Same as `provide`, but only for non-local crates, applied after `default_provide_extern`.",8,N],[3,"PhaseController","","",N,N],[12,"stop","","",9,N],[12,"run_callback_on_error","","",9,N],[12,"callback","","",9,N],[3,"CompileState","","State that is passed to a callback. What state is available depends on when during compilation the callback is made. See the various constructor methods (`state_*`) in the impl to see which data is provided for any given entry point.",N,N],[12,"input","","",10,N],[12,"session","","",10,N],[12,"krate","","",10,N],[12,"registry","","",10,N],[12,"cstore","","",10,N],[12,"crate_name","","",10,N],[12,"output_filenames","","",10,N],[12,"out_dir","","",10,N],[12,"out_file","","",10,N],[12,"arenas","","",10,N],[12,"expanded_crate","","",10,N],[12,"hir_crate","","",10,N],[12,"hir_map","","",10,N],[12,"resolutions","","",10,N],[12,"analysis","","",10,N],[12,"tcx","","",10,N],[3,"ExpansionResult","","",N,N],[12,"expanded_crate","","",11,N],[12,"defs","","",11,N],[12,"analysis","","",11,N],[12,"resolutions","","",11,N],[12,"hir_forest","","",11,N],[3,"InnerExpansionResult","","",N,N],[12,"expanded_crate","","",12,N],[12,"resolver","","",12,N],[12,"hir_forest","","",12,N],[5,"spawn_thread_pool","","",N,[[["options"],["f"]],["r"]]],[5,"compile_input","","",N,[[["box",["codegenbackend"]],["session"],["cstore"],["option"],["input"],["option"],["option"],["option",["vec"]],["compilecontroller"]],["compileresult"]]],[5,"source_name","","",N,[[["input"]],["filename"]]],[5,"phase_1_parse_input","","",N,[[["compilecontroller"],["session"],["input"]],["presult",["crate"]]]],[5,"count_nodes","","",N,[[["crate"]],["usize"]]],[5,"phase_2_configure_and_expand","","Run the \"early phases\" of the compiler: initial `cfg` processing, loading compiler plugins (including those from `addl_plugins`), syntax expansion, secondary `cfg` expansion, synthesis of a test harness if one is to be provided, injection of a dependency on the standard library and prelude, and name resolution.",N,[[["session"],["cstore"],["crate"],["option",["registry"]],["str"],["option",["vec"]],["makeglobmap"],["f"]],["result",["expansionresult","compileincomplete"]]]],[5,"phase_2_configure_and_expand_inner","","Same as phase_2_configure_and_expand, but doesn't let you keep the resolver around",N,[[["session"],["cstore"],["crate"],["option",["registry"]],["str"],["option",["vec"]],["makeglobmap"],["resolverarenas"],["crateloader"],["f"]],["result",["innerexpansionresult","compileincomplete"]]]],[5,"default_provide","","",N,[[["providers"]]]],[5,"default_provide_extern","","",N,[[["providers"]]]],[5,"phase_3_run_analysis_passes","","Run the resolution, typechecking, region checking and other miscellaneous analysis passes on the crate. Return various structures carrying the results of the analysis.",N,[[["codegenbackend"],["compilecontroller"],["session"],["cratestoredyn"],["map"],["crateanalysis"],["resolutions"],["allarenas"],["str"],["outputfilenames"],["f"]],["result",["compileincomplete"]]]],[5,"phase_4_codegen","","Run the codegen backend, after which the AST and analysis can be discarded.",N,[[["codegenbackend"],["tyctxt"],["receiver",["box"]]],["box",["any"]]]],[5,"escape_dep_filename","","",N,[[["filename"]],["string"]]],[5,"generated_output_paths","","",N,[[["session"],["outputfilenames"],["bool"],["str"]],["vec",["pathbuf"]]]],[5,"check_output","","",N,N],[5,"output_contains_path","","",N,N],[5,"output_conflicts_with_dir","","",N,N],[5,"write_out_deps","","",N,N],[5,"collect_crate_types","","",N,N],[5,"compute_crate_disambiguator","","",N,[[["session"]],["cratedisambiguator"]]],[5,"build_output_filenames","","",N,N],[11,"basic","","",8,[[],["compilecontroller"]]],[11,"early_callback","","",8,[[["self"],["matches"],["options"],["crateconfig"],["registry"],["erroroutputtype"]],["compilation"]]],[11,"no_input","","",8,[[["self"],["matches"],["options"],["crateconfig"],["option"],["option"],["registry"]],["option"]]],[11,"late_callback","","",8,[[["self"],["codegenbackend"],["matches"],["session"],["cratestore"],["input"],["option"],["option"]],["compilation"]]],[11,"build_controller","","",8,[[["box"],["session"],["matches"]],["compilecontroller"]]],[11,"basic","","",9,[[],["phasecontroller"]]],[11,"empty","","",10,[[["input"],["session"],["option"]],["self"]]],[11,"state_after_parse","","",10,[[["input"],["session"],["option"],["option"],["crate"],["cstore"]],["self"]]],[11,"state_after_expand","","",10,[[["input"],["session"],["option"],["option"],["cstore"],["crate"],["str"]],["self"]]],[11,"state_after_hir_lowering","","",10,[[["input"],["session"],["option"],["option"],["allarenas"],["cstore"],["map"],["crateanalysis"],["resolutions"],["crate"],["crate"],["outputfilenames"],["str"]],["self"]]],[11,"state_after_analysis","","",10,[[["input"],["session"],["option"],["option"],["option",["crate"]],["crate"],["crateanalysis"],["tyctxt"],["str"]],["self"]]],[11,"state_when_compilation_done","","",10,[[["input"],["session"],["option"],["option"]],["self"]]],[0,"pretty","rustc_driver","The various pretty print routines.",N,N],[3,"NoAnn","rustc_driver::pretty","",N,N],[12,"sess","","",13,N],[12,"hir_map","","",13,N],[3,"IdentifiedAnnotation","","",N,N],[12,"sess","","",14,N],[12,"hir_map","","",14,N],[3,"HygieneAnnotation","","",N,N],[12,"sess","","",15,N],[3,"TypedAnnotation","","",N,N],[12,"tcx","","",16,N],[12,"tables","","",16,N],[3,"ReplaceBodyWithLoop","","",N,N],[12,"within_static_or_const","","",17,N],[12,"sess","","",17,N],[4,"PpSourceMode","","",N,N],[13,"PpmNormal","","",18,N],[13,"PpmEveryBodyLoops","","",18,N],[13,"PpmExpanded","","",18,N],[13,"PpmIdentified","","",18,N],[13,"PpmExpandedIdentified","","",18,N],[13,"PpmExpandedHygiene","","",18,N],[13,"PpmTyped","","",18,N],[4,"PpFlowGraphMode","","",N,N],[13,"Default","","",19,N],[13,"UnlabelledEdges","","Drops the labels from the edges in the flowgraph output. This is mostly for use in the -Z unpretty flowgraph run-make tests, since the labels are largely uninteresting in those cases and have become a pain to maintain.",19,N],[4,"PpMode","","",N,N],[13,"PpmSource","","",20,N],[13,"PpmHir","","",20,N],[13,"PpmHirTree","","",20,N],[13,"PpmFlowGraph","","",20,N],[13,"PpmMir","","",20,N],[13,"PpmMirCFG","","",20,N],[4,"UserIdentifiedItem","","",N,N],[13,"ItemViaNode","","",21,N],[13,"ItemViaPath","","",21,N],[4,"NodesMatchingUII","","",N,N],[13,"NodesMatchingDirect","","",22,N],[13,"NodesMatchingSuffix","","",22,N],[5,"parse_pretty","","",N,N],[5,"gather_flowgraph_variants","","",N,[[["session"]],["vec",["variant"]]]],[5,"print_flowgraph","","",N,[[["vec",["variant"]],["tyctxt"],["code"],["ppflowgraphmode"],["w"]],["result"]]],[5,"fold_crate","","",N,[[["session"],["crate"],["ppmode"]],["crate"]]],[5,"get_source","","",N,N],[5,"write_output","","",N,[[["vec",["u8"]],["option",["path"]]]]],[5,"print_after_parsing","","",N,[[["session"],["input"],["crate"],["ppmode"],["option",["path"]]]]],[5,"print_after_hir_lowering","","",N,[[["session"],["cratestoredyn"],["map"],["crateanalysis"],["resolutions"],["input"],["crate"],["str"],["ppmode"],["allarenas"],["outputfilenames"],["option",["useridentifieditem"]],["option",["path"]]]]],[5,"print_with_analysis","","",N,[[["session"],["cratestoredyn"],["map"],["crateanalysis"],["resolutions"],["str"],["allarenas"],["outputfilenames"],["ppmode"],["option",["useridentifieditem"]],["option",["path"]]]]],[8,"PrinterSupport","","",N,N],[10,"sess","","Provides a uniform interface for re-extracting a reference to a `Session` from a value that now owns it.",23,[[["self"]],["session"]]],[10,"pp_ann","","Produces the pretty-print annotation object.",23,[[["self"]],["ppann"]]],[8,"HirPrinterSupport","","",N,N],[10,"sess","","Provides a uniform interface for re-extracting a reference to a `Session` from a value that now owns it.",24,[[["self"]],["session"]]],[10,"hir_map","","Provides a uniform interface for re-extracting a reference to an `hir_map::Map` from a value that now owns it.",24,[[["self"]],["option",["map"]]]],[10,"pp_ann","","Produces the pretty-print annotation object.",24,[[["self"]],["ppann"]]],[11,"node_path","","Computes an user-readable representation of a path, if possible.",24,[[["self"],["nodeid"]],["option",["string"]]]],[11,"clone","","",18,[[["self"]],["ppsourcemode"]]],[11,"eq","","",18,[[["self"],["ppsourcemode"]],["bool"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",19,[[["self"]],["ppflowgraphmode"]]],[11,"eq","","",19,[[["self"],["ppflowgraphmode"]],["bool"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"clone","","",20,[[["self"]],["ppmode"]]],[11,"eq","","",20,[[["self"],["ppmode"]],["bool"]]],[11,"ne","","",20,[[["self"],["ppmode"]],["bool"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"needs_ast_map","","",20,[[["self"],["option"]],["bool"]]],[11,"needs_analysis","","",20,[[["self"]],["bool"]]],[11,"call_with_pp_support","","Constructs a `PrinterSupport` object and passes it to `f`.",18,[[["self"],["session"],["option",["map"]],["f"]],["a"]]],[11,"call_with_pp_support_hir","","",18,[[["self"],["session"],["cratestoredyn"],["map"],["crateanalysis"],["resolutions"],["allarenas"],["outputfilenames"],["str"],["f"]],["a"]]],[11,"sess","","",13,[[["self"]],["session"]]],[11,"pp_ann","","",13,[[["self"]],["ppann"]]],[11,"sess","","",13,[[["self"]],["session"]]],[11,"hir_map","","",13,[[["self"]],["option",["map"]]]],[11,"pp_ann","","",13,[[["self"]],["ppann"]]],[11,"nested","","",13,[[["self"],["state"],["nested"]],["result"]]],[11,"sess","","",14,[[["self"]],["session"]]],[11,"pp_ann","","",14,[[["self"]],["ppann"]]],[11,"pre","","",14,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",14,[[["self"],["state"],["annnode"]],["result"]]],[11,"sess","","",14,[[["self"]],["session"]]],[11,"hir_map","","",14,[[["self"]],["option",["map"]]]],[11,"pp_ann","","",14,[[["self"]],["ppann"]]],[11,"nested","","",14,[[["self"],["state"],["nested"]],["result"]]],[11,"pre","","",14,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",14,[[["self"],["state"],["annnode"]],["result"]]],[11,"sess","","",15,[[["self"]],["session"]]],[11,"pp_ann","","",15,[[["self"]],["ppann"]]],[11,"post","","",15,[[["self"],["state"],["annnode"]],["result"]]],[11,"sess","","",16,[[["self"]],["session"]]],[11,"hir_map","","",16,[[["self"]],["option",["map"]]]],[11,"pp_ann","","",16,[[["self"]],["ppann"]]],[11,"node_path","","",16,[[["self"],["nodeid"]],["option",["string"]]]],[11,"nested","","",16,[[["self"],["state"],["nested"]],["result"]]],[11,"pre","","",16,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",16,[[["self"],["state"],["annnode"]],["result"]]],[11,"clone","","",21,[[["self"]],["useridentifieditem"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"from_str","","",21,[[["str"]],["result",["useridentifieditem"]]]],[11,"next","","",22,[[["self"]],["option",["nodeid"]]]],[11,"size_hint","","",22,N],[11,"reconstructed_input","","",21,[[["self"]],["string"]]],[11,"all_matching_node_ids","","",21,[[["self"],["map"]],["nodesmatchinguii"]]],[11,"to_one_node_id","","",21,[[["self"],["str"],["session"],["map"]],["nodeid"]]],[11,"new","","",17,[[["session"]],["replacebodywithloop"]]],[11,"run","","",17,[[["self"],["bool"],["f"]],["r"]]],[11,"should_ignore_fn","","",17,[[["fndecl"]],["bool"]]],[11,"fold_item_kind","","",17,[[["self"],["itemkind"]],["itemkind"]]],[11,"fold_trait_item","","",17,[[["self"],["traititem"]],["smallvector",["traititem"]]]],[11,"fold_impl_item","","",17,[[["self"],["implitem"]],["smallvector",["implitem"]]]],[11,"fold_block","","",17,[[["self"],["p",["block"]]],["p",["block"]]]],[11,"fold_mac","","",17,[[["self"],["mac"]],["mac"]]],[0,"derive_registrar","rustc_driver","",N,N],[3,"Finder","rustc_driver::derive_registrar","",N,N],[12,"registrar","","",25,N],[5,"find","","",N,[[["map"]],["option",["nodeid"]]]],[11,"visit_item","","",25,[[["self"],["item"]]]],[11,"visit_trait_item","","",25,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",25,[[["self"],["implitem"]]]],[0,"target_features","rustc_driver","",N,N],[5,"add_configuration","rustc_driver::target_features","Add `target_feature = \"...\"` cfgs for a variety of platform specific features (SSE, NEON etc.).",N,[[["crateconfig"],["session"],["codegenbackend"]]]],[17,"EXIT_SUCCESS","rustc_driver","Exit status code used for successful compilation and help output.",N,N],[17,"EXIT_FAILURE","","Exit status code used for compilation failures and  invalid flags.",N,N],[17,"BUG_REPORT_URL","","",N,N],[17,"ICE_REPORT_COMPILER_FLAGS","","",N,N],[17,"ICE_REPORT_COMPILER_FLAGS_EXCLUDE","","",N,N],[17,"ICE_REPORT_COMPILER_FLAGS_STRIP_VALUE","","",N,N],[8,"CompilerCalls","","A trait for customising the compilation process. Offers a number of hooks for executing custom code or customising input.",N,N],[11,"early_callback","","Hook for a callback early in the process of handling arguments. This will be called straight after options have been parsed but before anything else (e.g., selecting input and output).",26,[[["self"],["matches"],["options"],["crateconfig"],["registry"],["erroroutputtype"]],["compilation"]]],[11,"late_callback","","Hook for a callback late in the process of handling arguments. This will be called just before actual compilation starts (and before build_controller is called), after all arguments etc. have been completely handled.",26,[[["self"],["codegenbackend"],["matches"],["session"],["cratestore"],["input"],["option"],["option"]],["compilation"]]],[11,"some_input","","Called after we extract the input from the arguments. Gives the implementer an opportunity to change the inputs or to add some custom input handling. The default behaviour is to simply pass through the inputs.",26,N],[11,"no_input","","Called after we extract the input from the arguments if there is no valid input. Gives the implementer an opportunity to supply alternate input (by returning a Some value) or to add custom behaviour for this error such as emitting error messages. Returning None will cause compilation to stop at this point.",26,[[["self"],["matches"],["options"],["crateconfig"],["option"],["option"],["registry"]],["option"]]],[10,"build_controller","","",26,[[["box"],["session"],["matches"]],["compilecontroller"]]],[11,"clone","","",0,[[["self"]],["compilation"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"eq","","",0,[[["self"],["compilation"]],["bool"]]],[11,"and_then","","",0,[[["self"],["f"]],["compilation"]]],[11,"clone","","",27,[[["self"]],["rustcdefaultcalls"]]],[11,"early_callback","","",27,[[["self"],["matches"],["options"],["crateconfig"],["registry"],["erroroutputtype"]],["compilation"]]],[11,"no_input","","",27,[[["self"],["matches"],["options"],["crateconfig"],["option"],["option"],["registry"]],["option"]]],[11,"late_callback","","",27,[[["self"],["codegenbackend"],["matches"],["session"],["cratestore"],["input"],["option"],["option"]],["compilation"]]],[11,"build_controller","","",27,[[["box"],["session"],["matches"]],["compilecontroller"]]],[11,"list_metadata","","",27,[[["session"],["cratestore"],["matches"],["input"]],["compilation"]]],[11,"print_crate_info","","",27,[[["codegenbackend"],["session"],["option",["input"]],["option"],["option"]],["compilation"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]]],"paths":[[4,"Compilation"],[3,"StackFrame"],[4,"ParseState"],[3,"Query"],[3,"Rec"],[3,"QueryMetric"],[4,"Effect"],[4,"CacheCase"],[3,"CompileController"],[3,"PhaseController"],[3,"CompileState"],[3,"ExpansionResult"],[3,"InnerExpansionResult"],[3,"NoAnn"],[3,"IdentifiedAnnotation"],[3,"HygieneAnnotation"],[3,"TypedAnnotation"],[3,"ReplaceBodyWithLoop"],[4,"PpSourceMode"],[4,"PpFlowGraphMode"],[4,"PpMode"],[4,"UserIdentifiedItem"],[4,"NodesMatchingUII"],[8,"PrinterSupport"],[8,"HirPrinterSupport"],[3,"Finder"],[8,"CompilerCalls"],[3,"RustcDefaultCalls"],[3,"CompilationFailure"]]};
searchIndex["rustc_errors"]={"doc":"","items":[[3,"CodeSuggestion","rustc_errors","",N,N],[12,"substitutions","","Each substitute can have multiple variants due to multiple applicable suggestions",0,N],[12,"msg","","",0,N],[12,"show_code_when_inline","","",0,N],[12,"applicability","","Whether or not the suggestion is approximate",0,N],[3,"Substitution","","See the docs on `CodeSuggestion::substitutions`",N,N],[12,"parts","","",1,N],[3,"SubstitutionPart","","",N,N],[12,"span","","",2,N],[12,"snippet","","",2,N],[3,"FatalError","","Used as a return value to signify a fatal error occurred. (It is also used as the argument to panic at the moment, but that will eventually not be true.)",N,N],[3,"FatalErrorMarker","","",N,N],[3,"ExplicitBug","","Signifies that the compiler died with an explicit call to `.bug` or `.span_bug` rather than a failed assertion, etc.",N,N],[3,"Diagnostic","","",N,N],[12,"level","","",3,N],[12,"message","","",3,N],[12,"code","","",3,N],[12,"span","","",3,N],[12,"children","","",3,N],[12,"suggestions","","",3,N],[3,"SubDiagnostic","","For example a note attached to an error.",N,N],[12,"level","","",4,N],[12,"message","","",4,N],[12,"span","","",4,N],[12,"render_span","","",4,N],[3,"DiagnosticStyledString","","",N,N],[12,"0","","",5,N],[3,"DiagnosticBuilder","","Used for emitting structured error messages and other diagnostic information.",N,N],[12,"handler","","",6,N],[12,"diagnostic","","",6,N],[3,"Handler","","A handler deals with errors; certain errors (fatal, bug, unimpl) may cause immediate exit, others log errors for later reporting.",N,N],[12,"flags","","",7,N],[12,"err_count","","",7,N],[12,"emitter","","",7,N],[12,"continue_after_error","","",7,N],[12,"delayed_span_bugs","","",7,N],[12,"taught_diagnostics","","",7,N],[12,"emitted_diagnostic_codes","","Used to suggest rustc --explain ",7,N],[12,"emitted_diagnostics","","",7,N],[3,"HandlerFlags","","",N,N],[12,"can_emit_warnings","","",8,N],[12,"treat_err_as_bug","","",8,N],[12,"report_delayed_bugs","","",8,N],[12,"external_macro_backtrace","","",8,N],[4,"Applicability","","",N,N],[13,"MachineApplicable","","",9,N],[13,"HasPlaceholders","","",9,N],[13,"MaybeIncorrect","","",9,N],[13,"Unspecified","","",9,N],[4,"DiagnosticId","","",N,N],[13,"Error","","",10,N],[13,"Lint","","",10,N],[4,"Level","","",N,N],[13,"Bug","","",11,N],[13,"Fatal","","",11,N],[13,"PhaseFatal","","",11,N],[13,"Error","","",11,N],[13,"Warning","","",11,N],[13,"Note","","",11,N],[13,"Help","","",11,N],[13,"Cancelled","","",11,N],[13,"FailureNote","","",11,N],[5,"default_track_diagnostic","","",N,[[["diagnostic"]]]],[0,"diagnostic","","",N,N],[3,"Diagnostic","rustc_errors::diagnostic","",N,N],[12,"level","","",3,N],[12,"message","","",3,N],[12,"code","","",3,N],[12,"span","","",3,N],[12,"children","","",3,N],[12,"suggestions","","",3,N],[3,"SubDiagnostic","","For example a note attached to an error.",N,N],[12,"level","","",4,N],[12,"message","","",4,N],[12,"span","","",4,N],[12,"render_span","","",4,N],[3,"DiagnosticStyledString","","",N,N],[12,"0","","",5,N],[4,"DiagnosticId","","",N,N],[13,"Error","","",10,N],[13,"Lint","","",10,N],[4,"StringPart","","",N,N],[13,"Normal","","",12,N],[13,"Highlighted","","",12,N],[11,"clone","rustc_errors","",3,[[["self"]],["diagnostic"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"eq","","",3,[[["self"],["diagnostic"]],["bool"]]],[11,"ne","","",3,[[["self"],["diagnostic"]],["bool"]]],[11,"hash","","",3,N],[11,"encode","","",3,[[["self"],["__s"]],["result"]]],[11,"decode","","",3,[[["__d"]],["result",["diagnostic"]]]],[11,"clone","","",10,[[["self"]],["diagnosticid"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["diagnosticid"]],["bool"]]],[11,"ne","","",10,[[["self"],["diagnosticid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"hash","","",10,N],[11,"encode","","",10,[[["self"],["__s"]],["result"]]],[11,"decode","","",10,[[["__d"]],["result",["diagnosticid"]]]],[11,"clone","","",4,[[["self"]],["subdiagnostic"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["subdiagnostic"]],["bool"]]],[11,"ne","","",4,[[["self"],["subdiagnostic"]],["bool"]]],[11,"hash","","",4,N],[11,"encode","","",4,[[["self"],["__s"]],["result"]]],[11,"decode","","",4,[[["__d"]],["result",["subdiagnostic"]]]],[11,"eq","","",5,[[["self"],["diagnosticstyledstring"]],["bool"]]],[11,"ne","","",5,[[["self"],["diagnosticstyledstring"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"new","","",5,[[],["diagnosticstyledstring"]]],[11,"push_normal","","",5,[[["self"],["s"]]]],[11,"push_highlighted","","",5,[[["self"],["s"]]]],[11,"normal","","",5,[[["s"]],["diagnosticstyledstring"]]],[11,"highlighted","","",5,[[["s"]],["diagnosticstyledstring"]]],[11,"content","","",5,[[["self"]],["string"]]],[11,"eq","rustc_errors::diagnostic","",12,[[["self"],["stringpart"]],["bool"]]],[11,"ne","","",12,[[["self"],["stringpart"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"content","","",12,[[["self"]],["string"]]],[11,"new","rustc_errors","",3,[[["level"],["str"]],["self"]]],[11,"new_with_code","","",3,[[["level"],["option",["diagnosticid"]],["str"]],["self"]]],[11,"is_error","","",3,[[["self"]],["bool"]]],[11,"cancel","","Cancel the diagnostic (a structured diagnostic must either be emitted or canceled or it will panic when dropped).",3,[[["self"]]]],[11,"cancelled","","",3,[[["self"]],["bool"]]],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",3,[[["self"],["span"],["t"]],["self"]]],[11,"note_expected_found","","",3,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"]],["self"]]],[11,"note_expected_found_extra","","",3,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"],["display"],["display"]],["self"]]],[11,"note_trait_signature","","",3,[[["self"],["string"],["string"]],["self"]]],[11,"note","","",3,[[["self"],["str"]],["self"]]],[11,"highlighted_note","","",3,[[["self"],["vec"]],["self"]]],[11,"span_note","","",3,[[["self"],["s"],["str"]],["self"]]],[11,"warn","","",3,[[["self"],["str"]],["self"]]],[11,"span_warn","","",3,[[["self"],["s"],["str"]],["self"]]],[11,"help","","",3,[[["self"],["str"]],["self"]]],[11,"span_help","","",3,[[["self"],["s"],["str"]],["self"]]],[11,"span_suggestion_short","","Prints out a message with a suggested edit of the code. If the suggestion is presented inline it will only show the text message and not the text.",3,[[["self"],["span"],["str"],["string"]],["self"]]],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",3,[[["self"],["span"],["str"],["string"]],["self"]]],[11,"multipart_suggestion","","",3,[[["self"],["str"],["vec"]],["self"]]],[11,"span_suggestions","","Prints out a message with multiple suggested edits of the code.",3,[[["self"],["span"],["str"],["vec",["string"]]],["self"]]],[11,"span_suggestion_with_applicability","","This is a suggestion that may contain mistakes or fillers and should be read and understood by a human.",3,[[["self"],["span"],["str"],["string"],["applicability"]],["self"]]],[11,"span_suggestions_with_applicability","","",3,[[["self"],["span"],["str"],["vec",["string"]],["applicability"]],["self"]]],[11,"span_suggestion_short_with_applicability","","",3,[[["self"],["span"],["str"],["string"],["applicability"]],["self"]]],[11,"set_span","","",3,[[["self"],["s"]],["self"]]],[11,"code","","",3,[[["self"],["diagnosticid"]],["self"]]],[11,"get_code","","",3,[[["self"]],["option",["diagnosticid"]]]],[11,"message","","",3,[[["self"]],["string"]]],[11,"styled_message","","",3,[[["self"]],["vec"]]],[11,"copy_details_not_message","","Used by a lint. Copies over all details but the \"main message\".",3,[[["self"],["diagnostic"]]]],[11,"sub","","Convenience function for internal use, clients should use one of the public methods above.",3,[[["self"],["level"],["str"],["multispan"],["option",["multispan"]]]]],[11,"sub_with_highlights","","Convenience function for internal use, clients should use one of the public methods above.",3,[[["self"],["level"],["vec"],["multispan"],["option",["multispan"]]]]],[11,"message","","",4,[[["self"]],["string"]]],[11,"styled_message","","",4,[[["self"]],["vec"]]],[0,"diagnostic_builder","","",N,N],[3,"DiagnosticBuilder","rustc_errors::diagnostic_builder","Used for emitting structured error messages and other diagnostic information.",N,N],[12,"handler","","",6,N],[12,"diagnostic","","",6,N],[11,"clone","rustc_errors","",6,[[["self"]],["diagnosticbuilder"]]],[11,"deref","","",6,[[["self"]],["diagnostic"]]],[11,"deref_mut","","",6,[[["self"]],["diagnostic"]]],[11,"emit","","Emit the diagnostic.",6,[[["self"]]]],[11,"buffer","","Buffers the diagnostic for later emission.",6,[[["self"],["vec"]]]],[11,"sub","","Convenience function for internal use, clients should use one of the span_* methods instead.",6,[[["self"],["level"],["str"],["option"]],["self"]]],[11,"delay_as_bug","","Delay emission of this diagnostic as a bug.",6,[[["self"]]]],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",6,[[["self"],["span"],["t"]],["self"]]],[11,"note_expected_found","","",6,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"]],["self"]]],[11,"note_expected_found_extra","","",6,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"],["display"],["display"]],["self"]]],[11,"note","","",6,[[["self"],["str"]],["self"]]],[11,"span_note","","",6,[[["self"],["s"],["str"]],["self"]]],[11,"warn","","",6,[[["self"],["str"]],["self"]]],[11,"span_warn","","",6,[[["self"],["s"],["str"]],["self"]]],[11,"help","","",6,[[["self"],["str"]],["self"]]],[11,"span_help","","",6,[[["self"],["s"],["str"]],["self"]]],[11,"span_suggestion_short","","",6,[[["self"],["span"],["str"],["string"]],["self"]]],[11,"multipart_suggestion","","",6,[[["self"],["str"],["vec"]],["self"]]],[11,"span_suggestion","","",6,[[["self"],["span"],["str"],["string"]],["self"]]],[11,"span_suggestions","","",6,[[["self"],["span"],["str"],["vec",["string"]]],["self"]]],[11,"span_suggestion_with_applicability","","",6,[[["self"],["span"],["str"],["string"],["applicability"]],["self"]]],[11,"span_suggestions_with_applicability","","",6,[[["self"],["span"],["str"],["vec",["string"]],["applicability"]],["self"]]],[11,"span_suggestion_short_with_applicability","","",6,[[["self"],["span"],["str"],["string"],["applicability"]],["self"]]],[11,"set_span","","",6,[[["self"],["s"]],["self"]]],[11,"code","","",6,[[["self"],["diagnosticid"]],["self"]]],[11,"new","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",6,[[["handler"],["level"],["str"]],["diagnosticbuilder"]]],[11,"new_with_code","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",6,[[["handler"],["level"],["option",["diagnosticid"]],["str"]],["diagnosticbuilder"]]],[11,"new_diagnostic","","Creates a new `DiagnosticBuilder` with an already constructed diagnostic.",6,[[["handler"],["diagnostic"]],["diagnosticbuilder"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"drop","","",6,[[["self"]]]],[0,"emitter","","",N,N],[3,"EmitterWriter","rustc_errors::emitter","",N,N],[12,"dst","","",13,N],[12,"cm","","",13,N],[12,"short_message","","",13,N],[12,"teach","","",13,N],[12,"ui_testing","","",13,N],[3,"FileWithAnnotatedLines","","",N,N],[12,"file","","",14,N],[12,"lines","","",14,N],[12,"multiline_depth","","",14,N],[4,"ColorConfig","","",N,N],[13,"Auto","","",15,N],[13,"Always","","",15,N],[13,"Never","","",15,N],[4,"Destination","","",N,N],[13,"Terminal","","",16,N],[13,"Buffered","","",16,N],[13,"Raw","","",16,N],[4,"WritableDst","","",N,N],[13,"Terminal","","",17,N],[13,"Buffered","","",17,N],[13,"Raw","","",17,N],[5,"draw_col_separator","","",N,[[["styledbuffer"],["usize"],["usize"]]]],[5,"draw_col_separator_no_space","","",N,[[["styledbuffer"],["usize"],["usize"]]]],[5,"draw_col_separator_no_space_with_style","","",N,[[["styledbuffer"],["usize"],["usize"],["style"]]]],[5,"draw_range","","",N,[[["styledbuffer"],["char"],["usize"],["usize"],["usize"],["style"]]]],[5,"draw_note_separator","","",N,[[["styledbuffer"],["usize"],["usize"]]]],[5,"draw_multiline_line","","",N,[[["styledbuffer"],["usize"],["usize"],["usize"],["style"]]]],[5,"num_overlap","","",N,[[["usize"],["usize"],["usize"],["usize"],["bool"]],["bool"]]],[5,"overlaps","","",N,[[["annotation"],["annotation"],["usize"]],["bool"]]],[5,"emit_to_destination","","",N,N],[17,"ANONYMIZED_LINE_NUM","","",N,N],[17,"MAX_HIGHLIGHT_LINES","","maximum number of lines we will print for each error; arbitrary.",N,N],[17,"MAX_SUGGESTIONS","","maximum number of suggestions to be shown",N,N],[8,"Emitter","","Emitter trait for emitting errors.",N,N],[10,"emit","","Emit a structured diagnostic.",18,[[["self"],["diagnosticbuilder"]]]],[11,"should_show_explain","","Check if should show explanations about \"rustc --explain\"",18,[[["self"]],["bool"]]],[11,"emit","","",13,[[["self"],["diagnosticbuilder"]]]],[11,"should_show_explain","","",13,[[["self"]],["bool"]]],[11,"clone","","",15,[[["self"]],["colorconfig"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"eq","","",15,[[["self"],["colorconfig"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",15,N],[11,"to_color_choice","","",15,[[["self"]],["colorchoice"]]],[11,"stderr","","",13,[[["colorconfig"],["option",["lrc"]],["bool"],["bool"]],["emitterwriter"]]],[11,"new","","",13,[[["box",["write"]],["option",["lrc"]],["bool"],["bool"]],["emitterwriter"]]],[11,"ui_testing","","",13,[[["self"],["bool"]],["self"]]],[11,"maybe_anonymized","","",13,[[["self"],["usize"]],["string"]]],[11,"preprocess_annotations","","",13,[[["self"],["multispan"]],["vec",["filewithannotatedlines"]]]],[11,"render_source_line","","",13,[[["self"],["styledbuffer"],["lrc",["filemap"]],["line"],["usize"],["usize"]],["vec"]]],[11,"get_multispan_max_line_num","","",13,[[["self"],["multispan"]],["usize"]]],[11,"get_max_line_num","","",13,N],[11,"fix_multispan_in_std_macros","","",13,[[["self"],["multispan"],["bool"]],["bool"]]],[11,"fix_multispans_in_std_macros","","",13,[[["self"],["multispan"],["vec"],["bool"]]]],[11,"msg_to_buffer","","Add a left margin to every line but the first, given a padding length and the label being displayed, keeping the provided highlighting.",13,N],[11,"emit_message_default","","",13,N],[11,"emit_suggestion_default","","",13,[[["self"],["codesuggestion"],["level"],["usize"]],["result"]]],[11,"emit_messages_default","","",13,N],[11,"from_stderr","","",16,[[["colorconfig"]],["destination"]]],[11,"writable","","",16,[[["self"]],["writabledst"]]],[11,"apply_style","","",17,[[["self"],["level"],["style"]],["result"]]],[11,"set_color","","",17,[[["self"],["colorspec"]],["result"]]],[11,"reset","","",17,[[["self"]],["result"]]],[11,"write","","",17,N],[11,"flush","","",17,[[["self"]],["result"]]],[11,"drop","","",17,[[["self"]]]],[0,"snippet","rustc_errors","",N,N],[3,"Line","rustc_errors::snippet","",N,N],[12,"line_index","","",19,N],[12,"annotations","","",19,N],[3,"MultilineAnnotation","","",N,N],[12,"depth","","",20,N],[12,"line_start","","",20,N],[12,"line_end","","",20,N],[12,"start_col","","",20,N],[12,"end_col","","",20,N],[12,"is_primary","","",20,N],[12,"label","","",20,N],[3,"Annotation","","",N,N],[12,"start_col","","Start column, 0-based indexing -- counting characters, not utf-8 bytes. Note that it is important that this field goes first, so that when we sort, we sort orderings by start column.",21,N],[12,"end_col","","End column within the line (exclusive)",21,N],[12,"is_primary","","Is this annotation derived from primary span",21,N],[12,"label","","Optional label to display adjacent to the annotation.",21,N],[12,"annotation_type","","Is this a single line, multiline or multiline span minimized down to a smaller span.",21,N],[3,"StyledString","","",N,N],[12,"text","","",22,N],[12,"style","","",22,N],[4,"AnnotationType","","",N,N],[13,"Singleline","","Annotation under a single line of code",23,N],[13,"Multiline","","Annotation enclosing the first and last character of a multiline span",23,N],[13,"MultilineStart","","Annotation marking the first character of a fully shown multiline span",23,N],[13,"MultilineEnd","","Annotation marking the last character of a fully shown multiline span",23,N],[13,"MultilineLine","","Line at the left enclosing the lines of a fully shown multiline span",23,N],[4,"Style","","",N,N],[13,"MainHeaderMsg","","",24,N],[13,"HeaderMsg","","",24,N],[13,"LineAndColumn","","",24,N],[13,"LineNumber","","",24,N],[13,"Quotation","","",24,N],[13,"UnderlinePrimary","","",24,N],[13,"UnderlineSecondary","","",24,N],[13,"LabelPrimary","","",24,N],[13,"LabelSecondary","","",24,N],[13,"OldSchoolNoteText","","",24,N],[13,"NoStyle","","",24,N],[13,"Level","","",24,N],[13,"Highlight","","",24,N],[11,"clone","","",19,[[["self"]],["line"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",19,[[["self"],["line"]],["option",["ordering"]]]],[11,"lt","","",19,[[["self"],["line"]],["bool"]]],[11,"le","","",19,[[["self"],["line"]],["bool"]]],[11,"gt","","",19,[[["self"],["line"]],["bool"]]],[11,"ge","","",19,[[["self"],["line"]],["bool"]]],[11,"cmp","","",19,[[["self"],["line"]],["ordering"]]],[11,"eq","","",19,[[["self"],["line"]],["bool"]]],[11,"ne","","",19,[[["self"],["line"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"clone","","",20,[[["self"]],["multilineannotation"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",20,[[["self"],["multilineannotation"]],["option",["ordering"]]]],[11,"lt","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"le","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"gt","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"ge","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"cmp","","",20,[[["self"],["multilineannotation"]],["ordering"]]],[11,"eq","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"ne","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",20,N],[11,"increase_depth","","",20,[[["self"]]]],[11,"as_start","","",20,[[["self"]],["annotation"]]],[11,"as_end","","",20,[[["self"]],["annotation"]]],[11,"as_line","","",20,[[["self"]],["annotation"]]],[11,"clone","","",23,[[["self"]],["annotationtype"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",23,[[["self"],["annotationtype"]],["option",["ordering"]]]],[11,"lt","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"le","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"gt","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"ge","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"cmp","","",23,[[["self"],["annotationtype"]],["ordering"]]],[11,"eq","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"ne","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",23,N],[11,"clone","","",21,[[["self"]],["annotation"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",21,[[["self"],["annotation"]],["option",["ordering"]]]],[11,"lt","","",21,[[["self"],["annotation"]],["bool"]]],[11,"le","","",21,[[["self"],["annotation"]],["bool"]]],[11,"gt","","",21,[[["self"],["annotation"]],["bool"]]],[11,"ge","","",21,[[["self"],["annotation"]],["bool"]]],[11,"cmp","","",21,[[["self"],["annotation"]],["ordering"]]],[11,"eq","","",21,[[["self"],["annotation"]],["bool"]]],[11,"ne","","",21,[[["self"],["annotation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"is_line","","Whether this annotation is a vertical line placeholder.",21,[[["self"]],["bool"]]],[11,"is_multiline","","",21,[[["self"]],["bool"]]],[11,"len","","",21,[[["self"]],["usize"]]],[11,"has_label","","",21,[[["self"]],["bool"]]],[11,"takes_space","","",21,[[["self"]],["bool"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",24,[[["self"]],["style"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"eq","","",24,[[["self"],["style"]],["bool"]]],[11,"ne","","",24,[[["self"],["style"]],["bool"]]],[11,"hash","","",24,N],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[11,"decode","","",24,[[["__d"]],["result",["style"]]]],[0,"registry","rustc_errors","",N,N],[3,"Registry","rustc_errors::registry","",N,N],[12,"descriptions","","",25,N],[11,"clone","","",25,[[["self"]],["registry"]]],[11,"new","","",25,N],[11,"find_description","","",25,[[["self"],["str"]],["option",["str"]]]],[0,"styled_buffer","rustc_errors","",N,N],[3,"StyledBuffer","rustc_errors::styled_buffer","",N,N],[12,"text","","",26,N],[12,"styles","","",26,N],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"new","","",26,[[],["styledbuffer"]]],[11,"replace_tabs","","",26,[[["self"]]]],[11,"render","","",26,[[["self"]],["vec",["vec"]]]],[11,"ensure_lines","","",26,[[["self"],["usize"]]]],[11,"putc","","",26,[[["self"],["usize"],["usize"],["char"],["style"]]]],[11,"puts","","",26,[[["self"],["usize"],["usize"],["str"],["style"]]]],[11,"prepend","","",26,[[["self"],["usize"],["str"],["style"]]]],[11,"append","","",26,[[["self"],["usize"],["str"],["style"]]]],[11,"num_lines","","",26,[[["self"]],["usize"]]],[11,"set_style_range","","",26,[[["self"],["usize"],["usize"],["usize"],["style"],["bool"]]]],[11,"set_style","","",26,[[["self"],["usize"],["usize"],["style"],["bool"]]]],[0,"lock","rustc_errors","Bindings to acquire a global named lock.",N,N],[5,"acquire_global_lock","rustc_errors::lock","",N,[[["str"]],["box",["any"]]]],[6,"CodeMapperDyn","rustc_errors","",N,N],[17,"TRACK_DIAGNOSTICS","","",N,N],[8,"CodeMapper","","",N,N],[10,"lookup_char_pos","","",27,[[["self"],["bytepos"]],["loc"]]],[10,"span_to_lines","","",27,[[["self"],["span"]],["filelinesresult"]]],[10,"span_to_string","","",27,[[["self"],["span"]],["string"]]],[10,"span_to_filename","","",27,[[["self"],["span"]],["filename"]]],[10,"merge_spans","","",27,[[["self"],["span"],["span"]],["option",["span"]]]],[10,"call_span_if_macro","","",27,[[["self"],["span"]],["span"]]],[10,"ensure_filemap_source_present","","",27,[[["self"],["lrc",["filemap"]]],["bool"]]],[10,"doctest_offset_line","","",27,[[["self"],["usize"]],["usize"]]],[11,"clone","","",9,[[["self"]],["applicability"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"eq","","",9,[[["self"],["applicability"]],["bool"]]],[11,"hash","","",9,N],[11,"encode","","",9,[[["self"],["__s"]],["result"]]],[11,"decode","","",9,[[["__d"]],["result",["applicability"]]]],[11,"clone","","",0,[[["self"]],["codesuggestion"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"eq","","",0,[[["self"],["codesuggestion"]],["bool"]]],[11,"ne","","",0,[[["self"],["codesuggestion"]],["bool"]]],[11,"hash","","",0,N],[11,"encode","","",0,[[["self"],["__s"]],["result"]]],[11,"decode","","",0,[[["__d"]],["result",["codesuggestion"]]]],[11,"clone","","",1,[[["self"]],["substitution"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1,[[["self"],["substitution"]],["bool"]]],[11,"ne","","",1,[[["self"],["substitution"]],["bool"]]],[11,"hash","","",1,N],[11,"encode","","",1,[[["self"],["__s"]],["result"]]],[11,"decode","","",1,[[["__d"]],["result",["substitution"]]]],[11,"clone","","",2,[[["self"]],["substitutionpart"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"eq","","",2,[[["self"],["substitutionpart"]],["bool"]]],[11,"ne","","",2,[[["self"],["substitutionpart"]],["bool"]]],[11,"hash","","",2,N],[11,"encode","","",2,[[["self"],["__s"]],["result"]]],[11,"decode","","",2,[[["__d"]],["result",["substitutionpart"]]]],[11,"splice_lines","","Returns the assembled code suggestions and whether they should be shown with an underline.",0,[[["self"],["codemapperdyn"]],["vec"]]],[11,"clone","","",28,[[["self"]],["fatalerror"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"raise","","",28,N],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"description","","",28,[[["self"]],["str"]]],[11,"clone","","",29,[[["self"]],["explicitbug"]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"description","","",29,[[["self"]],["str"]]],[11,"default","","",8,[[],["handlerflags"]]],[11,"drop","","",7,[[["self"]]]],[11,"with_tty_emitter","","",7,[[["colorconfig"],["bool"],["bool"],["option",["lrc"]]],["handler"]]],[11,"with_tty_emitter_and_flags","","",7,[[["colorconfig"],["option",["lrc"]],["handlerflags"]],["handler"]]],[11,"with_emitter","","",7,[[["bool"],["bool"],["box",["emitter"]]],["handler"]]],[11,"with_emitter_and_flags","","",7,[[["box",["emitter"]],["handlerflags"]],["handler"]]],[11,"set_continue_after_error","","",7,[[["self"],["bool"]]]],[11,"reset_err_count","","Resets the diagnostic error count as well as the cached emitted diagnostics.",7,[[["self"]]]],[11,"struct_dummy","","",7,[[["self"]],["diagnosticbuilder"]]],[11,"struct_span_warn","","",7,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_warn_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_warn","","",7,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err","","",7,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_err","","",7,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_err_with_code","","",7,[[["self"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_span_fatal","","",7,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_fatal_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_fatal","","",7,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"cancel","","",7,[[["self"],["diagnosticbuilder"]]]],[11,"panic_if_treat_err_as_bug","","",7,[[["self"]]]],[11,"span_fatal","","",7,[[["self"],["s"],["str"]],["fatalerror"]]],[11,"span_fatal_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]],["fatalerror"]]],[11,"span_err","","",7,[[["self"],["s"],["str"]]]],[11,"mut_span_err","","",7,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_err_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"span_warn","","",7,[[["self"],["s"],["str"]]]],[11,"span_warn_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"span_bug","","",7,N],[11,"delay_span_bug","","",7,[[["self"],["s"],["str"]]]],[11,"delay_as_bug","","",7,[[["self"],["diagnostic"]]]],[11,"span_bug_no_panic","","",7,[[["self"],["s"],["str"]]]],[11,"span_note_without_error","","",7,[[["self"],["s"],["str"]]]],[11,"span_note_diag","","",7,[[["self"],["span"],["str"]],["diagnosticbuilder"]]],[11,"span_unimpl","","",7,N],[11,"failure","","",7,[[["self"],["str"]]]],[11,"fatal","","",7,[[["self"],["str"]],["fatalerror"]]],[11,"err","","",7,[[["self"],["str"]]]],[11,"warn","","",7,[[["self"],["str"]]]],[11,"note_without_error","","",7,[[["self"],["str"]]]],[11,"bug","","",7,N],[11,"unimpl","","",7,N],[11,"bump_err_count","","",7,[[["self"]]]],[11,"err_count","","",7,[[["self"]],["usize"]]],[11,"has_errors","","",7,[[["self"]],["bool"]]],[11,"print_error_count","","",7,[[["self"]]]],[11,"abort_if_errors","","",7,[[["self"]]]],[11,"emit","","",7,[[["self"],["multispan"],["str"],["level"]]]],[11,"emit_with_code","","",7,[[["self"],["multispan"],["str"],["diagnosticid"],["level"]]]],[11,"must_teach","","`true` if we haven't taught a diagnostic with this code already. The caller must then teach the user about such a diagnostic.",7,[[["self"],["diagnosticid"]],["bool"]]],[11,"force_print_db","","",7,[[["self"],["diagnosticbuilder"]]]],[11,"emit_db","","",7,[[["self"],["diagnosticbuilder"]]]],[11,"eq","","",11,[[["self"],["level"]],["bool"]]],[11,"clone","","",11,[[["self"]],["level"]]],[11,"hash","","",11,N],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"encode","","",11,[[["self"],["__s"]],["result"]]],[11,"decode","","",11,[[["__d"]],["result",["level"]]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"color","","",11,[[["self"]],["colorspec"]]],[11,"to_str","","",11,[[["self"]],["str"]]],[11,"is_failure_note","","",11,[[["self"]],["bool"]]]],"paths":[[3,"CodeSuggestion"],[3,"Substitution"],[3,"SubstitutionPart"],[3,"Diagnostic"],[3,"SubDiagnostic"],[3,"DiagnosticStyledString"],[3,"DiagnosticBuilder"],[3,"Handler"],[3,"HandlerFlags"],[4,"Applicability"],[4,"DiagnosticId"],[4,"Level"],[4,"StringPart"],[3,"EmitterWriter"],[3,"FileWithAnnotatedLines"],[4,"ColorConfig"],[4,"Destination"],[4,"WritableDst"],[8,"Emitter"],[3,"Line"],[3,"MultilineAnnotation"],[3,"Annotation"],[3,"StyledString"],[4,"AnnotationType"],[4,"Style"],[3,"Registry"],[3,"StyledBuffer"],[8,"CodeMapper"],[3,"FatalError"],[3,"ExplicitBug"]]};
searchIndex["rustc_incremental"]={"doc":"Support for serializing the dep-graph and reloading it.","items":[[4,"LoadResult","rustc_incremental","",N,N],[13,"Ok","","",0,N],[12,"data","rustc_incremental::LoadResult","",0,N],[13,"DataOutOfDate","rustc_incremental","",0,N],[13,"Error","","",0,N],[12,"message","rustc_incremental::LoadResult","",0,N],[5,"assert_dep_graph","rustc_incremental","",N,[[["tyctxt"]]]],[5,"dep_graph_tcx_init","","",N,[[["tyctxt"]]]],[5,"load_dep_graph","","Launch a thread and load the dependency graph in the background.",N,[[["session"]],["maybeasync",["loadresult"]]]],[5,"load_query_result_cache","","",N,[[["session"]],["ondiskcache"]]],[5,"copy_cgu_workproducts_to_incr_comp_cache_dir","","",N,N],[5,"save_dep_graph","","",N,[[["tyctxt"]]]],[5,"save_work_product_index","","",N,[[["session"],["depgraph"],["fxhashmap",["workproductid","workproduct"]]]]],[5,"in_incr_comp_dir","","",N,[[["path"],["str"]],["pathbuf"]]],[5,"prepare_session_directory","","Allocates the private session directory. The boolean in the Ok() result indicates whether we should try loading a dep graph from the successfully initialized directory, or not. The post-condition of this fn is that we have a valid incremental compilation session directory, if the result is `Ok`. A valid session directory is one that contains a locked lock file. It may or may not contain a dep-graph and work products from a previous session. If the call fails, the fn may leave behind an invalid session directory. The garbage collection will take care of it.",N,[[["session"],["str"],["cratedisambiguator"]]]],[5,"finalize_session_directory","","This function finalizes and thus 'publishes' the session directory by renaming it to `s-{timestamp}-{svh}` and releasing the file lock. If there have been compilation errors, however, this function will just delete the presumably invalid session directory.",N,[[["session"],["svh"]]]],[5,"delete_workproduct_files","","",N,[[["session"],["workproduct"]]]],[5,"garbage_collect_session_directories","","",N,[[["session"]],["result"]]],[0,"assert_dep_graph","","This pass is only used for the UNIT TESTS and DEBUGGING NEEDS around dependency graph construction. It serves two purposes; it will dump graphs in graphviz form to disk, and it searches for `#[rustc_if_this_changed]` and `#[rustc_then_this_would_need]` annotations. These annotations can be used to test whether paths exist in the graph. These checks run after codegen, so they view the the final state of the dependency graph. Note that there are similar assertions found in `persist::dirty_clean` which check the initial state of the dependency graph, just after it has been loaded from disk.",N,N],[3,"IfThisChanged","rustc_incremental::assert_dep_graph","",N,N],[12,"tcx","","",1,N],[12,"if_this_changed","","",1,N],[12,"then_this_would_need","","",1,N],[3,"GraphvizDepGraph","","",N,N],[12,"0","","",2,N],[12,"1","","",2,N],[5,"assert_dep_graph","","",N,[[["tyctxt"]]]],[5,"check_paths","","",N,[[["tyctxt"],["vec"],["vec"]]]],[5,"dump_graph","","",N,[[["tyctxt"]]]],[5,"node_set","","",N,[[["depgraphquery"],["depnodefilter"]],["option",["fxhashset"]]]],[5,"filter_nodes","","",N,[[["depgraphquery"],["option"],["option"]],["fxhashset",["depnode"]]]],[5,"walk_nodes","","",N,[[["depgraphquery"],["fxhashset"],["direction"]],["fxhashset",["depnode"]]]],[5,"walk_between","","",N,[[["depgraphquery"],["fxhashset"],["fxhashset"]],["fxhashset",["depnode"]]]],[5,"filter_edges","","",N,[[["depgraphquery"],["fxhashset"]],["vec"]]],[6,"Sources","","",N,N],[6,"Targets","","",N,N],[11,"argument","","",1,[[["self"],["attribute"]],["option",["name"]]]],[11,"process_attrs","","",1,N],[11,"nested_visit_map","","",1,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",1,[[["self"],["item"]]]],[11,"visit_trait_item","","",1,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",1,[[["self"],["implitem"]]]],[11,"visit_struct_field","","",1,[[["self"],["structfield"]]]],[11,"nodes","","",2,[[["self"]],["nodes",["depnode"]]]],[11,"edges","","",2,[[["self"]],["edges"]]],[11,"source","","",2,N],[11,"target","","",2,N],[11,"graph_id","","",2,[[["self"]],["id"]]],[11,"node_id","","",2,[[["self"],["depnode"]],["id"]]],[11,"node_label","","",2,[[["self"],["depnode"]],["labeltext"]]],[0,"assert_module_sources","rustc_incremental","This pass is only used for UNIT TESTS related to incremental compilation. It tests whether a particular `.o` file will be re-used from a previous compilation or whether it must be regenerated.",N,N],[3,"AssertModuleSource","rustc_incremental::assert_module_sources","",N,N],[12,"tcx","","",3,N],[4,"Disposition","","",N,N],[13,"Reused","","",4,N],[13,"Codegened","","",4,N],[5,"assert_module_sources","","",N,[[["tyctxt"]]]],[17,"MODULE","","",N,N],[17,"CFG","","",N,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["disposition"]],["bool"]]],[11,"clone","","",4,[[["self"]],["disposition"]]],[11,"check_attr","","",3,[[["self"],["attribute"]]]],[11,"field","","",3,[[["self"],["attribute"],["str"]],["name"]]],[11,"check_config","","Scan for a `cfg=\"foo\"` attribute and check whether we have a cfg flag called `foo`.",3,[[["self"],["attribute"]],["bool"]]],[0,"persist","rustc_incremental","When in incremental mode, this pass dumps out the dependency graph into the given directory. At the same time, it also hashes the various HIR nodes.",N,N],[0,"data","rustc_incremental::persist","The data that we will serialize and deserialize.",N,N],[3,"SerializedWorkProduct","rustc_incremental::persist::data","",N,N],[12,"id","","node that produced the work-product",5,N],[12,"work_product","","work-product data itself",5,N],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"encode","","",5,[[["self"],["__s"]],["result"]]],[11,"decode","","",5,[[["__d"]],["result",["serializedworkproduct"]]]],[0,"dirty_clean","rustc_incremental::persist","Debugging code to test fingerprints computed for query results. For each node marked with `#[rustc_clean]` or `#[rustc_dirty]`, we will compare the fingerprint from the current and from the previous compilation session as appropriate:",N,N],[3,"Assertion","rustc_incremental::persist::dirty_clean","Represents the requested configuration by rustc_clean/dirty",N,N],[12,"clean","","",6,N],[12,"dirty","","",6,N],[3,"DirtyCleanVisitor","","",N,N],[12,"tcx","","",7,N],[12,"checked_attrs","","",7,N],[3,"FindAllAttrs","","",N,N],[12,"tcx","","",8,N],[12,"attr_names","","",8,N],[12,"found_attrs","","",8,N],[5,"check_dirty_clean_annotations","","",N,[[["tyctxt"]]]],[5,"check_config","","Given a `#[rustc_dirty]` or `#[rustc_clean]` attribute, scan for a `cfg=\"foo\"` attribute and check whether we have a cfg flag called `foo`.",N,[[["tyctxt"],["attribute"]],["bool"]]],[5,"expect_associated_value","","",N,[[["tyctxt"],["nestedmetaitem"]],["name"]]],[6,"Labels","","",N,N],[22,"","","",N,N],[17,"EXCEPT","","",N,N],[17,"LABEL","","",N,N],[17,"CFG","","",N,N],[17,"BASE_CONST","","For typedef, constants, and statics",N,N],[17,"BASE_FN","","DepNodes for functions + methods",N,N],[17,"BASE_HIR","","DepNodes for Hir, which is pretty much everything",N,N],[17,"BASE_IMPL","","`impl` implementation of struct/trait",N,N],[17,"BASE_MIR","","DepNodes for MirValidated/Optimized, which is relevant in \"executable\" code, i.e. functions+methods",N,N],[17,"BASE_STRUCT","","Struct, Enum and Union DepNodes",N,N],[17,"BASE_TRAIT_DEF","","Trait Definition DepNodes",N,N],[17,"EXTRA_ASSOCIATED","","extra DepNodes for methods (+fn)",N,N],[17,"EXTRA_TRAIT","","",N,N],[17,"LABELS_CONST","","",N,N],[17,"LABELS_CONST_IN_IMPL","","Constant/Typedef in an impl",N,N],[17,"LABELS_CONST_IN_TRAIT","","Trait-Const/Typedef DepNodes",N,N],[17,"LABELS_FN","","Function DepNode",N,N],[17,"LABELS_FN_IN_IMPL","","Method DepNodes",N,N],[17,"LABELS_FN_IN_TRAIT","","Trait-Method DepNodes",N,N],[17,"LABELS_HIR_ONLY","","For generic cases like inline-assemply/mod/etc",N,N],[17,"LABELS_IMPL","","Impl DepNodes",N,N],[17,"LABELS_ADT","","Abstract Data Type (Struct, Enum, Unions) DepNodes",N,N],[17,"LABELS_TRAIT","","Trait Definition DepNodes",N,N],[11,"from_clean_labels","","",6,[[["hashset",["string"]]],["assertion"]]],[11,"from_dirty_labels","","",6,[[["hashset",["string"]]],["assertion"]]],[11,"assertion_maybe","","Possibly \"deserialize\" the attribute into a clean/dirty assertion",7,[[["self"],["nodeid"],["attribute"]],["option",["assertion"]]]],[11,"assertion_auto","","Get the \"auto\" assertion on pre-validated attr, along with the `except` labels",7,[[["self"],["nodeid"],["attribute"],["bool"]],["assertion"]]],[11,"labels","","",7,[[["self"],["attribute"]],["option",["hashset"]]]],[11,"except","","`except=` attribute value",7,[[["self"],["attribute"]],["hashset",["string"]]]],[11,"auto_labels","","Return all DepNode labels that should be asserted for this item. index=0 is the \"name\" used for error messages",7,N],[11,"resolve_labels","","",7,[[["self"],["nestedmetaitem"],["str"]],["hashset",["string"]]]],[11,"dep_nodes","","",7,[[["self"],["hashset"],["defid"]],[""]]],[11,"dep_node_str","","",7,[[["self"],["depnode"]],["string"]]],[11,"assert_dirty","","",7,[[["self"],["span"],["depnode"]]]],[11,"assert_clean","","",7,[[["self"],["span"],["depnode"]]]],[11,"check_item","","",7,[[["self"],["nodeid"],["span"]]]],[11,"visit_item","","",7,[[["self"],["item"]]]],[11,"visit_trait_item","","",7,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",7,[[["self"],["implitem"]]]],[11,"is_active_attr","","",8,[[["self"],["attribute"]],["bool"]]],[11,"report_unchecked_attrs","","",8,[[["self"],["fxhashset"]]]],[11,"nested_visit_map","","",8,[[["self"]],["nestedvisitormap"]]],[11,"visit_attribute","","",8,[[["self"],["attribute"]]]],[0,"fs","rustc_incremental::persist","This module manages how the incremental compilation cache is represented in the file system.",N,N],[5,"dep_graph_path","rustc_incremental::persist::fs","",N,[[["session"]],["pathbuf"]]],[5,"dep_graph_path_from","","",N,[[["path"]],["pathbuf"]]],[5,"work_products_path","","",N,[[["session"]],["pathbuf"]]],[5,"query_cache_path","","",N,[[["session"]],["pathbuf"]]],[5,"lock_file_path","","",N,[[["path"]],["pathbuf"]]],[5,"in_incr_comp_dir_sess","","",N,[[["session"],["str"]],["pathbuf"]]],[5,"in_incr_comp_dir","","",N,[[["path"],["str"]],["pathbuf"]]],[5,"prepare_session_directory","","Allocates the private session directory. The boolean in the Ok() result indicates whether we should try loading a dep graph from the successfully initialized directory, or not. The post-condition of this fn is that we have a valid incremental compilation session directory, if the result is `Ok`. A valid session directory is one that contains a locked lock file. It may or may not contain a dep-graph and work products from a previous session. If the call fails, the fn may leave behind an invalid session directory. The garbage collection will take care of it.",N,[[["session"],["str"],["cratedisambiguator"]]]],[5,"finalize_session_directory","","This function finalizes and thus 'publishes' the session directory by renaming it to `s-{timestamp}-{svh}` and releasing the file lock. If there have been compilation errors, however, this function will just delete the presumably invalid session directory.",N,[[["session"],["svh"]]]],[5,"delete_all_session_dir_contents","","",N,[[["session"]],["result"]]],[5,"copy_files","","",N,[[["session"],["path"],["path"]],["result",["bool"]]]],[5,"generate_session_dir_path","","Generate unique directory path of the form: {crate_dir}/s-{timestamp}-{random-number}-working",N,[[["path"]],["pathbuf"]]],[5,"create_dir","","",N,[[["session"],["path"],["str"]],["result"]]],[5,"lock_directory","","Allocate a the lock-file and lock it.",N,[[["session"],["path"]],["result"]]],[5,"delete_session_dir_lock_file","","",N,[[["session"],["path"]]]],[5,"find_source_directory","","Find the most recent published session directory that is not in the ignore-list.",N,[[["path"],["fxhashset"]],["option",["pathbuf"]]]],[5,"find_source_directory_in_iter","","",N,[[["i"],["fxhashset"]],["option",["pathbuf"]]]],[5,"is_finalized","","",N,[[["str"]],["bool"]]],[5,"is_session_directory","","",N,[[["str"]],["bool"]]],[5,"is_session_directory_lock_file","","",N,[[["str"]],["bool"]]],[5,"extract_timestamp_from_session_dir","","",N,[[["str"]],["result",["systemtime"]]]],[5,"timestamp_to_string","","",N,[[["systemtime"]],["string"]]],[5,"string_to_timestamp","","",N,[[["str"]],["result",["systemtime"]]]],[5,"crate_path","","",N,[[["session"],["str"],["cratedisambiguator"]],["pathbuf"]]],[5,"assert_no_characters_lost","","",N,[[["str"]]]],[5,"is_old_enough_to_be_collected","","",N,[[["systemtime"]],["bool"]]],[5,"garbage_collect_session_directories","","",N,[[["session"]],["result"]]],[5,"all_except_most_recent","","",N,[[["vec"]],["fxhashmap",["pathbuf","option"]]]],[5,"safe_remove_dir_all","","Since paths of artifacts within session directories can get quite long, we need to support deleting files with very long paths. The regular WinApi functions only support paths up to 260 characters, however. In order to circumvent this limitation, we canonicalize the path of the directory before passing it to std::fs::remove_dir_all(). This will convert the path into the '\\?' format, which supports much longer paths.",N,[[["path"]],["result"]]],[5,"safe_remove_file","","",N,[[["path"]],["result"]]],[17,"LOCK_FILE_EXT","","",N,N],[17,"DEP_GRAPH_FILENAME","","",N,N],[17,"WORK_PRODUCTS_FILENAME","","",N,N],[17,"QUERY_CACHE_FILENAME","","",N,N],[17,"INT_ENCODE_BASE","","",N,N],[0,"load","rustc_incremental::persist","Code to save/load the dep-graph from files.",N,N],[4,"LoadResult","rustc_incremental::persist::load","",N,N],[13,"Ok","","",0,N],[12,"data","rustc_incremental::persist::load::LoadResult","",0,N],[13,"DataOutOfDate","rustc_incremental::persist::load","",0,N],[13,"Error","","",0,N],[12,"message","rustc_incremental::persist::load::LoadResult","",0,N],[4,"MaybeAsync","rustc_incremental::persist::load","Either a result that has already be computed or a handle that will let us wait until it is computed by a background thread.",N,N],[13,"Sync","","",9,N],[13,"Async","","",9,N],[5,"dep_graph_tcx_init","","",N,[[["tyctxt"]]]],[5,"load_data","","",N,[[["bool"],["path"]],["loadresult"]]],[5,"delete_dirty_work_product","","",N,[[["session"],["serializedworkproduct"]]]],[5,"load_dep_graph","","Launch a thread and load the dependency graph in the background.",N,[[["session"]],["maybeasync",["loadresult"]]]],[5,"load_query_result_cache","","",N,[[["session"]],["ondiskcache"]]],[6,"WorkProductMap","","",N,N],[11,"open","rustc_incremental","",0,N],[11,"open","rustc_incremental::persist::load","",9,[[["self"]],["result"]]],[0,"save","rustc_incremental::persist","",N,N],[5,"save_dep_graph","rustc_incremental::persist::save","",N,[[["tyctxt"]]]],[5,"save_work_product_index","","",N,[[["session"],["depgraph"],["fxhashmap",["workproductid","workproduct"]]]]],[5,"save_in","","",N,[[["session"],["pathbuf"],["f"]]]],[5,"encode_dep_graph","","",N,[[["tyctxt"],["encoder"]]]],[5,"encode_work_product_index","","",N,[[["fxhashmap"],["encoder"]]]],[5,"encode_query_cache","","",N,[[["tyctxt"],["encoder"]]]],[0,"work_product","rustc_incremental::persist","This module contains files for saving intermediate work-products.",N,N],[5,"copy_cgu_workproducts_to_incr_comp_cache_dir","rustc_incremental::persist::work_product","",N,N],[5,"delete_workproduct_files","","",N,[[["session"],["workproduct"]]]],[0,"file_format","rustc_incremental::persist","This module defines a generic file format that allows to check if a given file generated by incremental compilation was generated by a compatible compiler version. This file format is used for the on-disk version of the dependency graph and the exported metadata hashes.",N,N],[5,"write_file_header","rustc_incremental::persist::file_format","",N,[[["encoder"]]]],[5,"read_file","","Reads the contents of a file with a file header as defined in this module.",N,[[["bool"],["path"]],["result",["option"]]]],[5,"report_format_mismatch","","",N,[[["bool"],["path"],["str"]]]],[5,"rustc_version","","",N,[[],["string"]]],[17,"FILE_MAGIC","","The first few bytes of files generated by incremental compilation",N,N],[17,"HEADER_FORMAT_VERSION","","Change this if the header format changes",N,N],[17,"RUSTC_VERSION","","A version string that hopefully is always different for compiler versions with different encodings of incremental compilation artifacts. Contains the git commit hash.",N,N]],"paths":[[4,"LoadResult"],[3,"IfThisChanged"],[3,"GraphvizDepGraph"],[3,"AssertModuleSource"],[4,"Disposition"],[3,"SerializedWorkProduct"],[3,"Assertion"],[3,"DirtyCleanVisitor"],[3,"FindAllAttrs"],[4,"MaybeAsync"]]};
searchIndex["rustc_lint"]={"doc":"Lints in the Rust compiler.","items":[[5,"register_builtins","rustc_lint","Tell the `LintStore` about all the built-in lints (the ones defined in this crate and the ones defined in `rustc::lint::builtin`).",N,[[["lintstore"],["option",["session"]]]]],[0,"bad_style","","",N,N],[3,"NonCamelCaseTypes","rustc_lint::bad_style","",N,N],[3,"NonSnakeCase","","",N,N],[3,"NonUpperCaseGlobals","","",N,N],[4,"MethodLateContext","","",N,N],[13,"TraitAutoImpl","","",0,N],[13,"TraitImpl","","",0,N],[13,"PlainImpl","","",0,N],[5,"method_context","","",N,[[["latecontext"],["nodeid"]],["methodlatecontext"]]],[7,"NON_CAMEL_CASE_TYPES","","",N,N],[7,"NON_SNAKE_CASE","","",N,N],[7,"NON_UPPER_CASE_GLOBALS","","",N,N],[11,"eq","","",0,[[["self"],["methodlatecontext"]],["bool"]]],[11,"clone","","",1,[[["self"]],["noncamelcasetypes"]]],[11,"check_case","","",1,[[["self"],["latecontext"],["str"],["name"],["span"]]]],[11,"get_lints","","",1,[[["self"]],["lintarray"]]],[11,"check_item","","",1,[[["self"],["latecontext"],["item"]]]],[11,"check_variant","","",1,[[["self"],["latecontext"],["variant"],["generics"]]]],[11,"check_generic_param","","",1,[[["self"],["latecontext"],["genericparam"]]]],[11,"clone","","",2,[[["self"]],["nonsnakecase"]]],[11,"to_snake_case","","",2,[[["str"]],["string"]]],[11,"check_snake_case","","",2,[[["self"],["latecontext"],["str"],["str"],["option",["span"]]]]],[11,"get_lints","","",2,[[["self"]],["lintarray"]]],[11,"check_crate","","",2,[[["self"],["latecontext"],["crate"]]]],[11,"check_generic_param","","",2,[[["self"],["latecontext"],["genericparam"]]]],[11,"check_fn","","",2,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"check_item","","",2,[[["self"],["latecontext"],["item"]]]],[11,"check_trait_item","","",2,[[["self"],["latecontext"],["traititem"]]]],[11,"check_pat","","",2,[[["self"],["latecontext"],["pat"]]]],[11,"check_struct_def","","",2,[[["self"],["latecontext"],["variantdata"],["name"],["generics"],["nodeid"]]]],[11,"clone","","",3,[[["self"]],["nonuppercaseglobals"]]],[11,"check_upper_case","","",3,[[["latecontext"],["str"],["name"],["span"]]]],[11,"get_lints","","",3,[[["self"]],["lintarray"]]],[11,"check_item","","",3,[[["self"],["latecontext"],["item"]]]],[11,"check_trait_item","","",3,[[["self"],["latecontext"],["traititem"]]]],[11,"check_impl_item","","",3,[[["self"],["latecontext"],["implitem"]]]],[11,"check_pat","","",3,[[["self"],["latecontext"],["pat"]]]],[0,"builtin","rustc_lint","Lints in the Rust compiler.",N,N],[7,"EXCEEDING_BITSHIFTS","rustc_lint::builtin","",N,N],[7,"CONST_ERR","","",N,N],[7,"UNUSED_IMPORTS","","",N,N],[7,"UNUSED_EXTERN_CRATES","","",N,N],[7,"UNUSED_QUALIFICATIONS","","",N,N],[7,"UNKNOWN_LINTS","","",N,N],[7,"UNUSED_VARIABLES","","",N,N],[7,"UNUSED_ASSIGNMENTS","","",N,N],[7,"DEAD_CODE","","",N,N],[7,"UNREACHABLE_CODE","","",N,N],[7,"UNREACHABLE_PATTERNS","","",N,N],[7,"UNUSED_MACROS","","",N,N],[7,"WARNINGS","","",N,N],[7,"UNUSED_FEATURES","","",N,N],[7,"STABLE_FEATURES","","",N,N],[7,"UNKNOWN_CRATE_TYPES","","",N,N],[7,"TRIVIAL_CASTS","","",N,N],[7,"TRIVIAL_NUMERIC_CASTS","","",N,N],[7,"PRIVATE_IN_PUBLIC","","",N,N],[7,"PUB_USE_OF_PRIVATE_EXTERN_CRATE","","",N,N],[7,"INVALID_TYPE_PARAM_DEFAULT","","",N,N],[7,"RENAMED_AND_REMOVED_LINTS","","",N,N],[7,"SAFE_EXTERN_STATICS","","",N,N],[7,"SAFE_PACKED_BORROWS","","",N,N],[7,"PATTERNS_IN_FNS_WITHOUT_BODY","","",N,N],[7,"LEGACY_DIRECTORY_OWNERSHIP","","",N,N],[7,"LEGACY_CONSTRUCTOR_VISIBILITY","","",N,N],[7,"MISSING_FRAGMENT_SPECIFIER","","",N,N],[7,"PARENTHESIZED_PARAMS_IN_TYPES_AND_MODULES","","",N,N],[7,"LATE_BOUND_LIFETIME_ARGUMENTS","","",N,N],[7,"INCOHERENT_FUNDAMENTAL_IMPLS","","",N,N],[7,"BAD_REPR","","",N,N],[7,"DEPRECATED","","",N,N],[7,"UNUSED_UNSAFE","","",N,N],[7,"UNUSED_MUT","","",N,N],[7,"SINGLE_USE_LIFETIMES","","",N,N],[7,"UNUSED_LIFETIMES","","",N,N],[7,"TYVAR_BEHIND_RAW_POINTER","","",N,N],[7,"ELIDED_LIFETIMES_IN_PATHS","","",N,N],[7,"BARE_TRAIT_OBJECTS","","",N,N],[7,"ABSOLUTE_PATHS_NOT_STARTING_WITH_CRATE","","",N,N],[7,"ILLEGAL_FLOATING_POINT_LITERAL_PATTERN","","",N,N],[7,"UNSTABLE_NAME_COLLISIONS","","",N,N],[7,"IRREFUTABLE_LET_PATTERNS","","",N,N],[7,"UNUSED_LABELS","","",N,N],[7,"DUPLICATE_ASSOCIATED_TYPE_BINDINGS","","",N,N],[7,"DUPLICATE_MACRO_EXPORTS","","",N,N],[7,"INTRA_DOC_LINK_RESOLUTION_FAILURE","","",N,N],[7,"WHERE_CLAUSES_OBJECT_SAFETY","","",N,N],[7,"PROC_MACRO_DERIVE_RESOLUTION_FALLBACK","","",N,N],[7,"MACRO_USE_EXTERN_CRATE","","",N,N],[0,"parser","","Some lints that are buffered from `libsyntax`. See `syntax::early_buffered_lints`.",N,N],[7,"QUESTION_MARK_MACRO_SEP","rustc_lint::builtin::parser","",N,N],[3,"HardwiredLints","rustc_lint::builtin","Does nothing as a lint pass, but registers some `Lint`s which are used by other parts of the compiler.",N,N],[4,"BuiltinLintDiagnostics","","",N,N],[13,"Normal","","",4,N],[13,"BareTraitObject","","",4,N],[13,"AbsPathWithModule","","",4,N],[13,"DuplicatedMacroExports","","",4,N],[13,"ProcMacroDeriveResolutionFallback","","",4,N],[13,"ElidedLifetimesInPaths","","",4,N],[3,"WhileTrue","","",N,N],[3,"BoxPointers","","",N,N],[3,"NonShorthandFieldPatterns","","",N,N],[3,"UnsafeCode","","",N,N],[3,"MissingDoc","","",N,N],[12,"doc_hidden_stack","","Stack of whether #[doc(hidden)] is set at each level which has lint attributes.",5,N],[12,"private_traits","","Private traits or trait items that leaked through. Don't check their methods.",5,N],[3,"MissingCopyImplementations","","",N,N],[3,"MissingDebugImplementations","","",N,N],[12,"impling_types","","",6,N],[3,"AnonymousParameters","","Checks for use of anonymous parameters (RFC 1685)",N,N],[3,"BadRepr","","Checks for incorrect use use of `repr` attributes.",N,N],[3,"DeprecatedAttr","","Checks for use of attributes which have been deprecated.",N,N],[12,"depr_attrs","","",7,N],[3,"UnusedDocComment","","",N,N],[3,"UnconditionalRecursion","","",N,N],[3,"PluginAsLibrary","","",N,N],[3,"InvalidNoMangleItems","","",N,N],[3,"MutableTransmutes","","",N,N],[3,"UnstableFeatures","","Forbids using the `#[feature(...)]` attribute",N,N],[3,"UnionsWithDropFields","","Lint for unions that contain fields with possibly non-trivial destructors.",N,N],[3,"UnreachablePub","","Lint for items marked `pub` that aren't reachable from other crates",N,N],[3,"TypeAliasBounds","","Lint for trait and lifetime bounds in type aliases being mostly ignored: They are relevant when using associated types, but otherwise neither checked at definition site nor enforced at use site.",N,N],[3,"UnusedBrokenConst","","Lint constants that are erroneous. Without this lint, we might not get any diagnostic if the constant is unused within this crate, even though downstream crates can't use it without producing an error.",N,N],[3,"UnusedBrokenConstVisitor","","",N,N],[12,"0","","",8,N],[3,"TrivialConstraints","","Lint for trait and lifetime bounds that don't depend on type parameters which either do nothing, or stop the item from being used.",N,N],[3,"SoftLints","","Does nothing as a lint pass, but registers some `Lint`s which are used by other parts of the compiler.",N,N],[3,"EllipsisInclusiveRangePatterns","","",N,N],[3,"UnnameableTestFunctions","","",N,N],[3,"Async2018","","Checks for uses of `async` as an identifier",N,N],[5,"validate_const","","",N,[[["tyctxt"],["const"],["paramenv"],["globalid"],["str"]]]],[5,"check_const","","",N,[[["latecontext"],["bodyid"],["str"]]]],[7,"WHILE_TRUE","","",N,N],[7,"BOX_POINTERS","","",N,N],[7,"NON_SHORTHAND_FIELD_PATTERNS","","",N,N],[7,"UNSAFE_CODE","","",N,N],[7,"MISSING_DOCS","","",N,N],[7,"MISSING_COPY_IMPLEMENTATIONS","","",N,N],[7,"MISSING_DEBUG_IMPLEMENTATIONS","","",N,N],[7,"ANONYMOUS_PARAMETERS","","",N,N],[7,"UNUSED_DOC_COMMENTS","","",N,N],[7,"UNCONDITIONAL_RECURSION","","",N,N],[7,"PLUGIN_AS_LIBRARY","","",N,N],[7,"PRIVATE_NO_MANGLE_FNS","","",N,N],[7,"PRIVATE_NO_MANGLE_STATICS","","",N,N],[7,"NO_MANGLE_CONST_ITEMS","","",N,N],[7,"NO_MANGLE_GENERIC_ITEMS","","",N,N],[7,"MUTABLE_TRANSMUTES","","",N,N],[7,"UNSTABLE_FEATURES","","",N,N],[7,"UNIONS_WITH_DROP_FIELDS","","",N,N],[7,"UNREACHABLE_PUB","","",N,N],[7,"TYPE_ALIAS_BOUNDS","","",N,N],[7,"TRIVIAL_BOUNDS","","",N,N],[7,"ELLIPSIS_INCLUSIVE_RANGE_PATTERNS","","",N,N],[7,"UNNAMEABLE_TEST_FUNCTIONS","","",N,N],[7,"ASYNC_IDENTS","","",N,N],[11,"clone","","",9,[[["self"]],["whiletrue"]]],[11,"get_lints","","",9,[[["self"]],["lintarray"]]],[11,"check_expr","","",9,[[["self"],["latecontext"],["expr"]]]],[11,"clone","","",10,[[["self"]],["boxpointers"]]],[11,"check_heap_type","","",10,[[["self"],["latecontext"],["span"],["ty"]]]],[11,"get_lints","","",10,[[["self"]],["lintarray"]]],[11,"check_item","","",10,[[["self"],["latecontext"],["item"]]]],[11,"check_expr","","",10,[[["self"],["latecontext"],["expr"]]]],[11,"clone","","",11,[[["self"]],["nonshorthandfieldpatterns"]]],[11,"get_lints","","",11,[[["self"]],["lintarray"]]],[11,"check_pat","","",11,[[["self"],["latecontext"],["pat"]]]],[11,"clone","","",12,[[["self"]],["unsafecode"]]],[11,"get_lints","","",12,[[["self"]],["lintarray"]]],[11,"report_unsafe","","",12,[[["self"],["latecontext"],["span"],["str"]]]],[11,"check_expr","","",12,[[["self"],["latecontext"],["expr"]]]],[11,"check_item","","",12,[[["self"],["latecontext"],["item"]]]],[11,"check_fn","","",12,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"check_trait_item","","",12,[[["self"],["latecontext"],["traititem"]]]],[11,"new","","",5,[[],["missingdoc"]]],[11,"doc_hidden","","",5,[[["self"]],["bool"]]],[11,"check_missing_docs_attrs","","",5,N],[11,"get_lints","","",5,[[["self"]],["lintarray"]]],[11,"enter_lint_attrs","","",5,N],[11,"exit_lint_attrs","","",5,N],[11,"check_crate","","",5,[[["self"],["latecontext"],["crate"]]]],[11,"check_item","","",5,[[["self"],["latecontext"],["item"]]]],[11,"check_trait_item","","",5,[[["self"],["latecontext"],["traititem"]]]],[11,"check_impl_item","","",5,[[["self"],["latecontext"],["implitem"]]]],[11,"check_struct_field","","",5,[[["self"],["latecontext"],["structfield"]]]],[11,"check_variant","","",5,[[["self"],["latecontext"],["variant"],["generics"]]]],[11,"clone","","",13,[[["self"]],["missingcopyimplementations"]]],[11,"get_lints","","",13,[[["self"]],["lintarray"]]],[11,"check_item","","",13,[[["self"],["latecontext"],["item"]]]],[11,"new","","",6,[[],["missingdebugimplementations"]]],[11,"get_lints","","",6,[[["self"]],["lintarray"]]],[11,"check_item","","",6,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",14,[[["self"]],["anonymousparameters"]]],[11,"get_lints","","",14,[[["self"]],["lintarray"]]],[11,"check_trait_item","","",14,[[["self"],["earlycontext"],["traititem"]]]],[11,"clone","","",15,[[["self"]],["badrepr"]]],[11,"get_lints","","",15,[[["self"]],["lintarray"]]],[11,"check_attribute","","",15,[[["self"],["earlycontext"],["attribute"]]]],[11,"clone","","",7,[[["self"]],["deprecatedattr"]]],[11,"new","","",7,[[],["deprecatedattr"]]],[11,"get_lints","","",7,[[["self"]],["lintarray"]]],[11,"check_attribute","","",7,[[["self"],["earlycontext"],["attribute"]]]],[11,"clone","","",16,[[["self"]],["unuseddoccomment"]]],[11,"get_lints","","",16,[[["self"]],["lintarray"]]],[11,"warn_if_doc","","",16,[[["self"],["i"],["c"]]]],[11,"check_local","","",16,[[["self"],["earlycontext"],["local"]]]],[11,"check_arm","","",16,[[["self"],["earlycontext"],["arm"]]]],[11,"check_expr","","",16,[[["self"],["earlycontext"],["expr"]]]],[11,"clone","","",17,[[["self"]],["unconditionalrecursion"]]],[11,"get_lints","","",17,[[["self"]],["lintarray"]]],[11,"check_fn","","",17,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"clone","","",18,[[["self"]],["pluginaslibrary"]]],[11,"get_lints","","",18,[[["self"]],["lintarray"]]],[11,"check_item","","",18,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",19,[[["self"]],["invalidnomangleitems"]]],[11,"get_lints","","",19,[[["self"]],["lintarray"]]],[11,"check_item","","",19,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",20,[[["self"]],["mutabletransmutes"]]],[11,"get_lints","","",20,[[["self"]],["lintarray"]]],[11,"check_expr","","",20,[[["self"],["latecontext"],["expr"]]]],[11,"clone","","",21,[[["self"]],["unstablefeatures"]]],[11,"get_lints","","",21,[[["self"]],["lintarray"]]],[11,"check_attribute","","",21,[[["self"],["latecontext"],["attribute"]]]],[11,"get_lints","","",22,[[["self"]],["lintarray"]]],[11,"check_item","","",22,[[["self"],["latecontext"],["item"]]]],[11,"get_lints","","",23,[[["self"]],["lintarray"]]],[11,"perform_lint","","",23,[[["self"],["latecontext"],["str"],["nodeid"],["visibility"],["span"],["bool"]]]],[11,"check_item","","",23,[[["self"],["latecontext"],["item"]]]],[11,"check_foreign_item","","",23,[[["self"],["latecontext"],["foreignitem"]]]],[11,"check_struct_field","","",23,[[["self"],["latecontext"],["structfield"]]]],[11,"check_impl_item","","",23,[[["self"],["latecontext"],["implitem"]]]],[11,"get_lints","","",24,[[["self"]],["lintarray"]]],[11,"is_type_variable_assoc","","",24,[[["qpath"]],["bool"]]],[11,"suggest_changing_assoc_types","","",24,[[["ty"],["diagnosticbuilder"]]]],[11,"check_item","","",24,[[["self"],["latecontext"],["item"]]]],[11,"get_lints","","",25,[[["self"]],["lintarray"]]],[11,"visit_nested_body","","",8,[[["self"],["bodyid"]]]],[11,"nested_visit_map","","",8,[[["self"]],["nestedvisitormap"]]],[11,"check_item","","",25,[[["self"],["latecontext"],["item"]]]],[11,"get_lints","","",26,[[["self"]],["lintarray"]]],[11,"check_item","","",26,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",27,[[["self"]],["softlints"]]],[11,"get_lints","","",27,[[["self"]],["lintarray"]]],[11,"get_lints","","",28,[[["self"]],["lintarray"]]],[11,"check_pat","","",28,[[["self"],["earlycontext"],["pat"]]]],[11,"get_lints","","",29,[[["self"]],["lintarray"]]],[11,"check_item","","",29,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",30,[[["self"]],["async2018"]]],[11,"get_lints","","",30,[[["self"]],["lintarray"]]],[11,"check_tokens","","",30,[[["self"],["earlycontext"],["tokenstream"]]]],[11,"report","","",30,[[["self"],["earlycontext"],["span"]]]],[11,"check_mac_def","","",30,[[["self"],["earlycontext"],["macrodef"],["nodeid"]]]],[11,"check_mac","","",30,[[["self"],["earlycontext"],["mac"]]]],[11,"check_ident","","",30,[[["self"],["earlycontext"],["ident"]]]],[0,"types","rustc_lint","",N,N],[3,"TypeLimits","rustc_lint::types","",N,N],[12,"negated_expr_id","","Id of the last visited negated expression",31,N],[3,"ImproperCTypesVisitor","","",N,N],[12,"cx","","",32,N],[3,"ImproperCTypes","","",N,N],[3,"VariantSizeDifferences","","",N,N],[4,"FfiResult","","",N,N],[13,"FfiSafe","","",33,N],[13,"FfiPhantom","","",33,N],[13,"FfiUnsafe","","",33,N],[12,"ty","rustc_lint::types::FfiResult","",33,N],[12,"reason","","",33,N],[12,"help","","",33,N],[5,"is_repr_nullable_ptr","rustc_lint::types","Check if this enum can be safely exported based on the \"nullable pointer optimization\". Currently restricted to function pointers and references, but could be expanded to cover NonZero raw pointers and newtypes. FIXME: This duplicates code in codegen.",N,[[["tyctxt"],["adtdef"],["substs"]],["bool"]]],[7,"UNUSED_COMPARISONS","","",N,N],[7,"OVERFLOWING_LITERALS","","",N,N],[7,"VARIANT_SIZE_DIFFERENCES","","",N,N],[7,"IMPROPER_CTYPES","","",N,N],[11,"clone","","",31,[[["self"]],["typelimits"]]],[11,"new","","",31,[[],["typelimits"]]],[11,"get_lints","","",31,[[["self"]],["lintarray"]]],[11,"check_expr","","",31,[[["self"],["latecontext"],["expr"]]]],[11,"check_type_for_ffi","","Check if the given type is \"ffi-safe\" (has a stable, well-defined representation which can be exported to C code).",32,[[["self"],["fxhashset"],["ty"]],["ffiresult"]]],[11,"check_type_for_ffi_and_report_errors","","",32,[[["self"],["span"],["ty"]]]],[11,"check_foreign_fn","","",32,[[["self"],["nodeid"],["fndecl"]]]],[11,"check_foreign_static","","",32,[[["self"],["nodeid"],["span"]]]],[11,"clone","","",34,[[["self"]],["improperctypes"]]],[11,"get_lints","","",34,[[["self"]],["lintarray"]]],[11,"check_item","","",34,[[["self"],["latecontext"],["item"]]]],[11,"get_lints","","",35,[[["self"]],["lintarray"]]],[11,"check_item","","",35,[[["self"],["latecontext"],["item"]]]],[0,"unused","rustc_lint","",N,N],[3,"UnusedResults","rustc_lint::unused","",N,N],[3,"PathStatements","","",N,N],[3,"UnusedAttributes","","",N,N],[3,"UnusedParens","","",N,N],[3,"UnusedImportBraces","","",N,N],[3,"UnusedAllocation","","",N,N],[7,"UNUSED_MUST_USE","","",N,N],[7,"UNUSED_RESULTS","","",N,N],[7,"PATH_STATEMENTS","","",N,N],[7,"UNUSED_ATTRIBUTES","","",N,N],[7,"UNUSED_PARENS","","",N,N],[7,"UNUSED_IMPORT_BRACES","","",N,N],[7,"UNUSED_ALLOCATION","","",N,N],[11,"clone","","",36,[[["self"]],["unusedresults"]]],[11,"get_lints","","",36,[[["self"]],["lintarray"]]],[11,"check_stmt","","",36,[[["self"],["latecontext"],["stmt"]]]],[11,"clone","","",37,[[["self"]],["pathstatements"]]],[11,"get_lints","","",37,[[["self"]],["lintarray"]]],[11,"check_stmt","","",37,[[["self"],["latecontext"],["stmt"]]]],[11,"clone","","",38,[[["self"]],["unusedattributes"]]],[11,"get_lints","","",38,[[["self"]],["lintarray"]]],[11,"check_attribute","","",38,[[["self"],["latecontext"],["attribute"]]]],[11,"clone","","",39,[[["self"]],["unusedparens"]]],[11,"check_unused_parens_core","","",39,[[["self"],["earlycontext"],["expr"],["str"],["bool"]]]],[11,"get_lints","","",39,[[["self"]],["lintarray"]]],[11,"check_expr","","",39,[[["self"],["earlycontext"],["expr"]]]],[11,"check_stmt","","",39,[[["self"],["earlycontext"],["stmt"]]]],[11,"clone","","",40,[[["self"]],["unusedimportbraces"]]],[11,"check_use_tree","","",40,[[["self"],["earlycontext"],["usetree"],["item"]]]],[11,"get_lints","","",40,[[["self"]],["lintarray"]]],[11,"check_item","","",40,[[["self"],["earlycontext"],["item"]]]],[11,"clone","","",41,[[["self"]],["unusedallocation"]]],[11,"get_lints","","",41,[[["self"]],["lintarray"]]],[11,"check_expr","","",41,[[["self"],["latecontext"],["expr"]]]],[11,"clone","rustc_lint::builtin","",42,[[["self"]],["hardwiredlints"]]],[11,"encode","","",4,[[["self"],["__s"]],["result"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result",["error"]]]],[11,"get_lints","","",42,[[["self"]],["vec",["lint"]]]],[11,"decode","","",4,[[["__d"]],["result",["builtinlintdiagnostics"]]]],[11,"eq","","",4,[[["self"],["builtinlintdiagnostics"]],["bool"]]],[11,"ne","","",4,[[["self"],["builtinlintdiagnostics"]],["bool"]]],[11,"run","","",4,N]],"paths":[[4,"MethodLateContext"],[3,"NonCamelCaseTypes"],[3,"NonSnakeCase"],[3,"NonUpperCaseGlobals"],[4,"BuiltinLintDiagnostics"],[3,"MissingDoc"],[3,"MissingDebugImplementations"],[3,"DeprecatedAttr"],[3,"UnusedBrokenConstVisitor"],[3,"WhileTrue"],[3,"BoxPointers"],[3,"NonShorthandFieldPatterns"],[3,"UnsafeCode"],[3,"MissingCopyImplementations"],[3,"AnonymousParameters"],[3,"BadRepr"],[3,"UnusedDocComment"],[3,"UnconditionalRecursion"],[3,"PluginAsLibrary"],[3,"InvalidNoMangleItems"],[3,"MutableTransmutes"],[3,"UnstableFeatures"],[3,"UnionsWithDropFields"],[3,"UnreachablePub"],[3,"TypeAliasBounds"],[3,"UnusedBrokenConst"],[3,"TrivialConstraints"],[3,"SoftLints"],[3,"EllipsisInclusiveRangePatterns"],[3,"UnnameableTestFunctions"],[3,"Async2018"],[3,"TypeLimits"],[3,"ImproperCTypesVisitor"],[4,"FfiResult"],[3,"ImproperCTypes"],[3,"VariantSizeDifferences"],[3,"UnusedResults"],[3,"PathStatements"],[3,"UnusedAttributes"],[3,"UnusedParens"],[3,"UnusedImportBraces"],[3,"UnusedAllocation"],[3,"HardwiredLints"]]};
searchIndex["rustc_metadata"]={"doc":"","items":[[0,"diagnostics","rustc_metadata","",N,N],[0,"__register_diagnostic_E0454","rustc_metadata::diagnostics","",N,N],[0,"__register_diagnostic_E0455","","",N,N],[0,"__register_diagnostic_E0458","","",N,N],[0,"__register_diagnostic_E0459","","",N,N],[0,"__register_diagnostic_E0463","","",N,N],[0,"__register_diagnostic_E0456","","",N,N],[0,"__register_diagnostic_E0457","","",N,N],[0,"__register_diagnostic_E0514","","",N,N],[0,"__register_diagnostic_E0460","","",N,N],[0,"__register_diagnostic_E0461","","",N,N],[0,"__register_diagnostic_E0462","","",N,N],[0,"__register_diagnostic_E0464","","",N,N],[0,"__register_diagnostic_E0465","","",N,N],[0,"__register_diagnostic_E0519","","",N,N],[0,"__register_diagnostic_E0523","","",N,N],[0,"index_builder","rustc_metadata","Builder types for generating the \"item data\" section of the metadata. This section winds up looking like this:",N,N],[3,"IndexBuilder","rustc_metadata::index_builder","Builder that can encode new items, adding them into the index. Item encoding cannot be nested.",N,N],[12,"items","","",0,N],[12,"ecx","","",0,N],[3,"Untracked","","Leaks access to a value of type T without any tracking. This is suitable for ambiguous types like `usize`, which could represent tracked data (e.g., if you read it out of a HIR node) or might not (e.g., if it's an index). Adding in an `Untracked` is an assertion, essentially, that the data does not need to be tracked (or that read edges will be added by some other way).",N,N],[12,"0","","",1,N],[3,"FromId","","Newtype that can be used to package up misc data extracted from a HIR node that doesn't carry its own id. This will allow an arbitrary `T` to be passed in, but register a read on the given node-id.",N,N],[12,"0","","",2,N],[12,"1","","",2,N],[8,"DepGraphRead","","Trait used for data that can be passed from outside a dep-graph task.  The data must either be of some safe type, such as a `DefId` index, or implement the `read` method so that it can add a read of whatever dep-graph nodes are appropriate.",N,N],[10,"read","","",3,[[["self"],["tyctxt"]]]],[11,"deref","","",0,N],[11,"deref_mut","","",0,N],[11,"new","","",0,[[["encodecontext"]],["self"]]],[11,"record","","Emit the data for a def-id to the metadata. The function to emit the data is `op`, and it will be given `data` as arguments. This `record` function will call `op` to generate the `Entry` (which may point to other encoded information) and will then record the `Lazy<Entry>` for use in the index.",0,N],[11,"into_items","","",0,[[["self"]],["index"]]],[11,"read","","",1,[[["self"],["tyctxt"]]]],[11,"read","","",2,[[["self"],["tyctxt"]]]],[0,"index","rustc_metadata","",N,N],[3,"Index","rustc_metadata::index","While we are generating the metadata, we also track the position of each DefIndex. It is not required that all definitions appear in the metadata, nor that they are serialized in order, and therefore we first allocate the vector here and fill it with `u32::MAX`. Whenever an index is visited, we fill in the appropriate spot by calling `record_position`. We should never visit the same index twice.",N,N],[12,"positions","","",4,N],[3,"Unaligned","","",N,N],[12,"0","","",5,N],[5,"bytes_to_words","","",N,N],[5,"words_to_bytes","","",N,N],[11,"new","","",4,N],[11,"record","","",4,[[["self"],["defid"],["lazy",["entry"]]]]],[11,"record_index","","",4,[[["self"],["defindex"],["lazy",["entry"]]]]],[11,"write_index","","",4,[[["self"],["encoder"]],["lazyseq",["index"]]]],[11,"clone","","",5,[[["self"]],["self"]]],[11,"get","","",5,[[["self"]],["t"]]],[0,"encoder","rustc_metadata","",N,N],[3,"EncodeContext","rustc_metadata::encoder","",N,N],[12,"opaque","","",6,N],[12,"tcx","","",6,N],[12,"link_meta","","",6,N],[12,"lazy_state","","",6,N],[12,"type_shorthands","","",6,N],[12,"predicate_shorthands","","",6,N],[12,"interpret_allocs","","",6,N],[12,"interpret_allocs_inverse","","",6,N],[12,"filemap_cache","","",6,N],[3,"EncodeVisitor","","",N,N],[12,"index","","",7,N],[3,"ImplVisitor","","",N,N],[12,"tcx","","",8,N],[12,"impls","","",8,N],[5,"encode_metadata","","",N,[[["tyctxt"],["linkmeta"]],["encodedmetadata"]]],[5,"get_repr_options","","",N,[[["tyctxt"],["defid"]],["reproptions"]]],[11,"emit_nil","","",6,[[["self"]],["result"]]],[11,"emit_usize","","",6,[[["self"],["usize"]],["result"]]],[11,"emit_u128","","",6,[[["self"],["u128"]],["result"]]],[11,"emit_u64","","",6,[[["self"],["u64"]],["result"]]],[11,"emit_u32","","",6,[[["self"],["u32"]],["result"]]],[11,"emit_u16","","",6,[[["self"],["u16"]],["result"]]],[11,"emit_u8","","",6,[[["self"],["u8"]],["result"]]],[11,"emit_isize","","",6,[[["self"],["isize"]],["result"]]],[11,"emit_i128","","",6,[[["self"],["i128"]],["result"]]],[11,"emit_i64","","",6,[[["self"],["i64"]],["result"]]],[11,"emit_i32","","",6,[[["self"],["i32"]],["result"]]],[11,"emit_i16","","",6,[[["self"],["i16"]],["result"]]],[11,"emit_i8","","",6,[[["self"],["i8"]],["result"]]],[11,"emit_bool","","",6,[[["self"],["bool"]],["result"]]],[11,"emit_f64","","",6,[[["self"],["f64"]],["result"]]],[11,"emit_f32","","",6,[[["self"],["f32"]],["result"]]],[11,"emit_char","","",6,[[["self"],["char"]],["result"]]],[11,"emit_str","","",6,[[["self"],["str"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["lazy"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["lazyseq"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["cratenum"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["defid"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["defindex"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["span"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["localdefid"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["ty"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["allocid"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["genericpredicates"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["fingerprint"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["clearcrosscrate"]],["result"]]],[11,"position","","",6,[[["self"]],["usize"]]],[11,"emit_node","","",6,[[["self"],["f"]],["r"]]],[11,"emit_lazy_distance","","",6,[[["self"],["usize"],["usize"]],["result"]]],[11,"lazy","","",6,[[["self"],["t"]],["lazy"]]],[11,"lazy_seq","","",6,[[["self"],["i"]],["lazyseq"]]],[11,"lazy_seq_ref","","",6,[[["self"],["i"]],["lazyseq"]]],[11,"tracked","","",6,N],[11,"encode_info_for_items","","",6,[[["self"]],["index"]]],[11,"encode_def_path_table","","",6,[[["self"]],["lazy",["defpathtable"]]]],[11,"encode_codemap","","",6,[[["self"]],["lazyseq",["filemap"]]]],[11,"encode_crate_root","","",6,[[["self"]],["lazy",["crateroot"]]]],[11,"nested_visit_map","","",7,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",7,[[["self"],["expr"]]]],[11,"visit_item","","",7,[[["self"],["item"]]]],[11,"visit_foreign_item","","",7,[[["self"],["foreignitem"]]]],[11,"visit_variant","","",7,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_generics","","",7,[[["self"],["generics"]]]],[11,"visit_ty","","",7,[[["self"],["ty"]]]],[11,"visit_macro_def","","",7,[[["self"],["macrodef"]]]],[11,"encode_fields","rustc_metadata::index_builder","",0,[[["self"],["defid"]]]],[11,"encode_info_for_generics","","",0,[[["self"],["generics"]]]],[11,"encode_info_for_ty","","",0,[[["self"],["ty"]]]],[11,"encode_info_for_expr","","",0,[[["self"],["expr"]]]],[11,"encode_addl_info_for_item","","In some cases, along with the item itself, we also encode some sub-items. Usually we want some info from the item so it's easier to do that here then to wait until we would encounter normally in the visitor walk.",0,[[["self"],["item"]]]],[11,"visit_item","rustc_metadata::encoder","",8,[[["self"],["item"]]]],[11,"visit_trait_item","","",8,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",8,[[["self"],["implitem"]]]],[0,"decoder","rustc_metadata","",N,N],[3,"DecodeContext","rustc_metadata::decoder","",N,N],[12,"opaque","","",9,N],[12,"cdata","","",9,N],[12,"sess","","",9,N],[12,"tcx","","",9,N],[12,"last_filemap_index","","",9,N],[12,"lazy_state","","",9,N],[12,"alloc_decoding_session","","",9,N],[0,"__ty_decoder_impl","","",N,N],[11,"read_nil","","",9,[[["self"]],["result"]]],[11,"read_u128","","",9,[[["self"]],["result",["u128"]]]],[11,"read_u64","","",9,[[["self"]],["result",["u64"]]]],[11,"read_u32","","",9,[[["self"]],["result",["u32"]]]],[11,"read_u16","","",9,[[["self"]],["result",["u16"]]]],[11,"read_u8","","",9,[[["self"]],["result",["u8"]]]],[11,"read_usize","","",9,[[["self"]],["result",["usize"]]]],[11,"read_i128","","",9,[[["self"]],["result",["i128"]]]],[11,"read_i64","","",9,[[["self"]],["result",["i64"]]]],[11,"read_i32","","",9,[[["self"]],["result",["i32"]]]],[11,"read_i16","","",9,[[["self"]],["result",["i16"]]]],[11,"read_i8","","",9,[[["self"]],["result",["i8"]]]],[11,"read_isize","","",9,[[["self"]],["result",["isize"]]]],[11,"read_bool","","",9,[[["self"]],["result",["bool"]]]],[11,"read_f64","","",9,[[["self"]],["result",["f64"]]]],[11,"read_f32","","",9,[[["self"]],["result",["f32"]]]],[11,"read_char","","",9,[[["self"]],["result",["char"]]]],[11,"read_str","","",9,[[["self"]],["result",["cow"]]]],[11,"error","","",9,N],[11,"specialized_decode","","",9,[[["self"]],["result",["cratenum"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["ty"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["genericpredicates"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["substs"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["region"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["slice"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["adtdef"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["slice"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["canonicalvarinfos"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["const"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["allocation"]]]],[22,"","","",N,N],[8,"Metadata","","Abstract over the various ways one can create metadata decoders.",N,N],[10,"raw_bytes","","",10,N],[11,"cdata","","",10,[[["self"]],["option",["cratemetadata"]]]],[11,"sess","","",10,[[["self"]],["option",["session"]]]],[11,"tcx","","",10,[[["self"]],["option",["tyctxt"]]]],[11,"decoder","","",10,[[["self"],["usize"]],["decodecontext"]]],[11,"tcx","","",9,[[["self"]],["tyctxt"]]],[11,"cdata","","",9,[[["self"]],["cratemetadata"]]],[11,"read_lazy_distance","","",9,[[["self"],["usize"]],["result",["usize"]]]],[11,"tcx","","",9,[[["self"]],["tyctxt"]]],[11,"peek_byte","","",9,[[["self"]],["u8"]]],[11,"position","","",9,[[["self"]],["usize"]]],[11,"cached_ty_for_shorthand","","",9,[[["self"],["usize"],["f"]],["result",["ty"]]]],[11,"with_position","","",9,[[["self"],["usize"],["f"]],["r"]]],[11,"map_encoded_cnum_to_current","","",9,[[["self"],["cratenum"]],["cratenum"]]],[11,"specialized_decode","","",9,[[["self"]],["result",["lazy"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["lazyseq"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["defid"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["defindex"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["localdefid"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["allocid"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["span"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["fingerprint"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["clearcrosscrate"]]]],[0,"cstore_impl","rustc_metadata","",N,N],[5,"provide_extern","rustc_metadata::cstore_impl","",N,[[["providers"]]]],[5,"provide","","",N,[[["providers"]]]],[8,"IntoArgs","","",N,N],[10,"into_args","","",11,N],[0,"isolated_encoder","rustc_metadata","",N,N],[3,"IsolatedEncoder","rustc_metadata::isolated_encoder","The IsolatedEncoder provides facilities to write to crate metadata while making sure that anything going through it is also feed into an ICH hasher.",N,N],[12,"tcx","","",12,N],[12,"ecx","","",12,N],[11,"new","","",12,[[["encodecontext"]],["self"]]],[11,"lazy","","",12,[[["self"],["t"]],["lazy"]]],[11,"lazy_seq","","",12,[[["self"],["i"]],["lazyseq"]]],[11,"lazy_seq_ref","","",12,[[["self"],["i"]],["lazyseq"]]],[11,"lazy_seq_from_slice","","",12,N],[0,"schema","rustc_metadata","",N,N],[3,"Lazy","rustc_metadata::schema","A value of type T referred to by its absolute position in the metadata, and which can be decoded lazily.",N,N],[12,"position","","",13,N],[12,"_marker","","",13,N],[3,"LazySeq","","A sequence of type T referred to by its absolute position in the metadata and length, and which can be decoded lazily. The sequence is a single node for the purposes of `Lazy`.",N,N],[12,"len","","",14,N],[12,"position","","",14,N],[12,"_marker","","",14,N],[3,"CrateRoot","","",N,N],[12,"name","","",15,N],[12,"triple","","",15,N],[12,"extra_filename","","",15,N],[12,"hash","","",15,N],[12,"disambiguator","","",15,N],[12,"panic_strategy","","",15,N],[12,"edition","","",15,N],[12,"has_global_allocator","","",15,N],[12,"has_default_lib_allocator","","",15,N],[12,"plugin_registrar_fn","","",15,N],[12,"macro_derive_registrar","","",15,N],[12,"crate_deps","","",15,N],[12,"dylib_dependency_formats","","",15,N],[12,"lang_items","","",15,N],[12,"lang_items_missing","","",15,N],[12,"native_libraries","","",15,N],[12,"foreign_modules","","",15,N],[12,"codemap","","",15,N],[12,"def_path_table","","",15,N],[12,"impls","","",15,N],[12,"exported_symbols","","",15,N],[12,"interpret_alloc_index","","",15,N],[12,"index","","",15,N],[12,"compiler_builtins","","",15,N],[12,"needs_allocator","","",15,N],[12,"needs_panic_runtime","","",15,N],[12,"no_builtins","","",15,N],[12,"panic_runtime","","",15,N],[12,"profiler_runtime","","",15,N],[12,"sanitizer_runtime","","",15,N],[3,"CrateDep","","",N,N],[12,"name","","",16,N],[12,"hash","","",16,N],[12,"kind","","",16,N],[12,"extra_filename","","",16,N],[3,"TraitImpls","","",N,N],[12,"trait_id","","",17,N],[12,"impls","","",17,N],[3,"Entry","","",N,N],[12,"kind","","",18,N],[12,"visibility","","",18,N],[12,"span","","",18,N],[12,"attributes","","",18,N],[12,"children","","",18,N],[12,"stability","","",18,N],[12,"deprecation","","",18,N],[12,"ty","","",18,N],[12,"inherent_impls","","",18,N],[12,"variances","","",18,N],[12,"generics","","",18,N],[12,"predicates","","",18,N],[12,"predicates_defined_on","","",18,N],[12,"mir","","",18,N],[3,"ConstQualif","","Additional data for EntryKind::Const and EntryKind::AssociatedConst",N,N],[12,"mir","","",19,N],[12,"ast_promotable","","",19,N],[3,"RenderedConst","","Contains a constant which has been rendered to a String. Used by rustdoc.",N,N],[12,"0","","",20,N],[3,"ModData","","",N,N],[12,"reexports","","",21,N],[3,"MacroDef","","",N,N],[12,"body","","",22,N],[12,"legacy","","",22,N],[3,"FnData","","",N,N],[12,"constness","","",23,N],[12,"arg_names","","",23,N],[12,"sig","","",23,N],[3,"VariantData","","",N,N],[12,"ctor_kind","","",24,N],[12,"discr","","",24,N],[12,"struct_ctor","","If this is a struct's only variant, this is the index of the \"struct ctor\" item.",24,N],[12,"ctor_sig","","If this is a tuple struct or variant ctor, this is its \"function\" signature.",24,N],[3,"TraitData","","",N,N],[12,"unsafety","","",25,N],[12,"paren_sugar","","",25,N],[12,"has_auto_impl","","",25,N],[12,"super_predicates","","",25,N],[3,"ImplData","","",N,N],[12,"polarity","","",26,N],[12,"defaultness","","",26,N],[12,"parent_impl","","",26,N],[12,"coerce_unsized_info","","This is `Some` only for impls of `CoerceUnsized`.",26,N],[12,"trait_ref","","",26,N],[3,"MethodData","","",N,N],[12,"fn_data","","",27,N],[12,"container","","",27,N],[12,"has_self","","",27,N],[3,"ClosureData","","",N,N],[12,"sig","","",28,N],[3,"GeneratorData","","",N,N],[12,"layout","","",29,N],[3,"EncodedExportedSymbols","","",N,N],[12,"position","","",30,N],[12,"len","","",30,N],[4,"LazyState","","Encoding / decoding state for `Lazy` and `LazySeq`.",N,N],[13,"NoNode","","Outside of a metadata node.",31,N],[13,"NodeStart","","Inside a metadata node, and before any `Lazy` or `LazySeq`. The position is that of the node itself.",31,N],[13,"Previous","","Inside a metadata node, with a previous `Lazy` or `LazySeq`. The position is a conservative estimate of where that previous `Lazy` / `LazySeq` would end (see their comments).",31,N],[4,"EntryKind","","",N,N],[13,"Const","","",32,N],[13,"ImmStatic","","",32,N],[13,"MutStatic","","",32,N],[13,"ForeignImmStatic","","",32,N],[13,"ForeignMutStatic","","",32,N],[13,"ForeignMod","","",32,N],[13,"ForeignType","","",32,N],[13,"GlobalAsm","","",32,N],[13,"Type","","",32,N],[13,"Existential","","",32,N],[13,"Enum","","",32,N],[13,"Field","","",32,N],[13,"Variant","","",32,N],[13,"Struct","","",32,N],[13,"Union","","",32,N],[13,"Fn","","",32,N],[13,"ForeignFn","","",32,N],[13,"Mod","","",32,N],[13,"MacroDef","","",32,N],[13,"Closure","","",32,N],[13,"Generator","","",32,N],[13,"Trait","","",32,N],[13,"Impl","","",32,N],[13,"Method","","",32,N],[13,"AssociatedType","","",32,N],[13,"AssociatedExistential","","",32,N],[13,"AssociatedConst","","",32,N],[4,"AssociatedContainer","","Describes whether the container of an associated item is a trait or an impl and whether, in a trait, it has a default, or an in impl, whether it's marked \"default\".",N,N],[13,"TraitRequired","","",33,N],[13,"TraitWithDefault","","",33,N],[13,"ImplDefault","","",33,N],[13,"ImplFinal","","",33,N],[5,"rustc_version","","",N,[[],["string"]]],[17,"METADATA_VERSION","","Metadata encoding version. NB: increment this if you change the format of metadata such that the rustc version can't be found to compare with `rustc_version()`.",N,N],[17,"METADATA_HEADER","","Metadata header which includes `METADATA_VERSION`. To get older versions of rustc to ignore this metadata, there are 4 zero bytes at the start, which are treated as a length of 0 by old compilers.",N,N],[17,"TAG_VALID_SPAN","","",N,N],[17,"TAG_INVALID_SPAN","","",N,N],[11,"with_position","","",13,[[["usize"]],["lazy"]]],[11,"min_size","","Returns the minimum encoded size of a value of type `T`.",13,[[],["usize"]]],[11,"clone","","",13,[[["self"]],["self"]]],[11,"hash_stable","","",13,[[["self"],["ctx"],["stablehasher"]]]],[11,"empty","","",14,[[],["lazyseq"]]],[11,"with_position_and_length","","",14,[[["usize"],["usize"]],["lazyseq"]]],[11,"min_size","","Returns the minimum encoded size of `length` values of type `T`.",14,[[["usize"]],["usize"]]],[11,"clone","","",14,[[["self"]],["self"]]],[11,"hash_stable","","",14,[[["self"],["ctx"],["stablehasher"]]]],[11,"clone","","",31,[[["self"]],["lazystate"]]],[11,"eq","","",31,[[["self"],["lazystate"]],["bool"]]],[11,"ne","","",31,[[["self"],["lazystate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",31,N],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"encode","","",15,[[["self"],["__s"]],["result"]]],[11,"decode","","",15,[[["__d"]],["result",["crateroot"]]]],[11,"encode","","",16,[[["self"],["__s"]],["result"]]],[11,"decode","","",16,[[["__d"]],["result",["cratedep"]]]],[11,"hash_stable","","",16,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",17,[[["self"],["__s"]],["result"]]],[11,"decode","","",17,[[["__d"]],["result",["traitimpls"]]]],[11,"hash_stable","","",17,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[11,"decode","","",18,[[["__d"]],["result",["entry"]]]],[11,"hash_stable","","",18,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",32,[[["self"]],["entrykind"]]],[11,"encode","","",32,[[["self"],["__s"]],["result"]]],[11,"decode","","",32,[[["__d"]],["result",["entrykind"]]]],[11,"hash_stable","","",32,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",19,[[["self"]],["constqualif"]]],[11,"encode","","",19,[[["self"],["__s"]],["result"]]],[11,"decode","","",19,[[["__d"]],["result",["constqualif"]]]],[11,"hash_stable","","",19,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",20,[[["self"],["__s"]],["result"]]],[11,"decode","","",20,[[["__d"]],["result",["renderedconst"]]]],[11,"hash_stable","","",20,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",21,[[["self"],["__s"]],["result"]]],[11,"decode","","",21,[[["__d"]],["result",["moddata"]]]],[11,"hash_stable","","",21,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",22,[[["self"],["__s"]],["result"]]],[11,"decode","","",22,[[["__d"]],["result",["macrodef"]]]],[11,"hash_stable","","",22,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",23,[[["self"],["__s"]],["result"]]],[11,"decode","","",23,[[["__d"]],["result",["fndata"]]]],[11,"hash_stable","","",23,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[11,"decode","","",24,[[["__d"]],["result",["variantdata"]]]],[11,"hash_stable","","",24,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",25,[[["self"],["__s"]],["result"]]],[11,"decode","","",25,[[["__d"]],["result",["traitdata"]]]],[11,"hash_stable","","",25,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",26,[[["self"],["__s"]],["result"]]],[11,"decode","","",26,[[["__d"]],["result",["impldata"]]]],[11,"hash_stable","","",26,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",33,[[["self"]],["associatedcontainer"]]],[11,"encode","","",33,[[["self"],["__s"]],["result"]]],[11,"decode","","",33,[[["__d"]],["result",["associatedcontainer"]]]],[11,"hash_stable","","",33,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"with_def_id","","",33,[[["self"],["defid"]],["associateditemcontainer"]]],[11,"defaultness","","",33,[[["self"]],["defaultness"]]],[11,"encode","","",27,[[["self"],["__s"]],["result"]]],[11,"decode","","",27,[[["__d"]],["result",["methoddata"]]]],[11,"hash_stable","","",27,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",28,[[["self"],["__s"]],["result"]]],[11,"decode","","",28,[[["__d"]],["result",["closuredata"]]]],[11,"hash_stable","","",28,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",29,[[["self"],["__s"]],["result"]]],[11,"decode","","",29,[[["__d"]],["result",["generatordata"]]]],[11,"hash_stable","","",29,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",30,[[["self"],["__s"]],["result"]]],[11,"decode","","",30,[[["__d"]],["result",["encodedexportedsymbols"]]]],[0,"native_libs","rustc_metadata","",N,N],[3,"Collector","rustc_metadata::native_libs","",N,N],[12,"tcx","","",34,N],[12,"libs","","",34,N],[5,"collect","","",N,[[["tyctxt"]],["vec",["nativelibrary"]]]],[5,"relevant_lib","","",N,[[["session"],["nativelibrary"]],["bool"]]],[11,"visit_item","","",34,[[["self"],["item"]]]],[11,"visit_trait_item","","",34,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",34,[[["self"],["implitem"]]]],[11,"register_native_lib","","",34,[[["self"],["option",["span"]],["nativelibrary"]]]],[11,"process_command_line","","",34,[[["self"]]]],[0,"link_args","rustc_metadata","",N,N],[3,"Collector","rustc_metadata::link_args","",N,N],[12,"args","","",35,N],[5,"collect","","",N,[[["tyctxt"]],["vec",["string"]]]],[11,"visit_item","","",35,[[["self"],["item"]]]],[11,"visit_trait_item","","",35,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",35,[[["self"],["implitem"]]]],[11,"add_link_args","","",35,[[["self"],["str"]]]],[0,"foreign_modules","rustc_metadata","",N,N],[3,"Collector","rustc_metadata::foreign_modules","",N,N],[12,"tcx","","",36,N],[12,"modules","","",36,N],[5,"collect","","",N,[[["tyctxt"]],["vec",["foreignmodule"]]]],[11,"visit_item","","",36,[[["self"],["item"]]]],[11,"visit_trait_item","","",36,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",36,[[["self"],["implitem"]]]],[0,"creader","rustc_metadata","Validates all used crates and extern libraries and loads their metadata",N,N],[3,"Library","rustc_metadata::creader","",N,N],[12,"dylib","","",37,N],[12,"rlib","","",37,N],[12,"rmeta","","",37,N],[12,"metadata","","",37,N],[3,"CrateLoader","","",N,N],[12,"sess","","",38,N],[12,"cstore","","",38,N],[12,"local_crate_name","","",38,N],[3,"ExtensionCrate","","",N,N],[12,"metadata","","",39,N],[12,"dylib","","",39,N],[12,"target_only","","",39,N],[4,"PMDSource","","",N,N],[13,"Registered","","",40,N],[13,"Owned","","",40,N],[4,"LoadResult","","",N,N],[13,"Previous","","",41,N],[13,"Loaded","","",41,N],[5,"dump_crates","","",N,[[["cstore"]]]],[11,"deref","","",40,[[["self"]],["metadatablob"]]],[11,"new","","",38,[[["session"],["cstore"],["str"]],["self"]]],[11,"existing_match","","",38,[[["self"],["symbol"],["option",["svh"]],["pathkind"]],["option",["cratenum"]]]],[11,"verify_no_symbol_conflicts","","",38,[[["self"],["span"],["crateroot"]]]],[11,"register_crate","","",38,N],[11,"resolve_crate","","",38,N],[11,"load","","",38,[[["self"],["context"]],["option",["loadresult"]]]],[11,"update_extern_crate","","",38,[[["self"],["cratenum"],["externcrate"],["fxhashset"]]]],[11,"resolve_crate_deps","","",38,[[["self"],["option"],["crateroot"],["metadatablob"],["cratenum"],["span"],["depkind"]],["cratenummap"]]],[11,"read_extension_crate","","",38,[[["self"],["span"],["symbol"],["symbol"]],["extensioncrate"]]],[11,"load_derive_macros","","Load custom derive macros.",38,[[["self"],["crateroot"],["option",["pathbuf"]],["span"]],["vec"]]],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path, crate SVH and DefIndex of the registrar function.",38,[[["self"],["span"],["str"]],["option"]]],[11,"inject_panic_runtime","","",38,[[["self"],["crate"]]]],[11,"inject_sanitizer_runtime","","",38,[[["self"]]]],[11,"inject_profiler_runtime","","",38,[[["self"]]]],[11,"inject_allocator_crate","","",38,[[["self"],["crate"]]]],[11,"inject_dependency_if","","",38,[[["self"],["cratenum"],["str"],["fn"]]]],[11,"postprocess","","",38,[[["self"],["crate"]]]],[11,"process_extern_crate","","",38,[[["self"],["item"],["definitions"]],["cratenum"]]],[11,"process_path_extern","","",38,[[["self"],["symbol"],["span"]],["cratenum"]]],[11,"process_use_extern","","",38,[[["self"],["symbol"],["span"],["nodeid"],["definitions"]],["cratenum"]]],[0,"cstore","rustc_metadata","",N,N],[3,"NativeLibrary","rustc_metadata::cstore","",N,N],[12,"kind","","",42,N],[12,"name","","",42,N],[12,"cfg","","",42,N],[12,"foreign_module","","",42,N],[12,"wasm_import_module","","",42,N],[4,"NativeLibraryKind","","",N,N],[13,"NativeStatic","","native static library (.a archive)",43,N],[13,"NativeStaticNobundle","","native static library, which doesn't get bundled into .rlibs",43,N],[13,"NativeFramework","","macOS-specific",43,N],[13,"NativeUnknown","","default way to specify a dynamic library",43,N],[4,"LinkagePreference","","",N,N],[13,"RequireDynamic","","",44,N],[13,"RequireStatic","","",44,N],[3,"CrateSource","","Where a crate came from on the local filesystem. One of these three options must be non-None.",N,N],[12,"dylib","","",45,N],[12,"rlib","","",45,N],[12,"rmeta","","",45,N],[4,"LibSource","","",N,N],[13,"Some","","",46,N],[13,"MetadataOnly","","",46,N],[13,"None","","",46,N],[3,"ForeignModule","","",N,N],[12,"foreign_items","","",47,N],[12,"def_id","","",47,N],[6,"MetadataRef","","",N,N],[3,"MetadataBlob","","",N,N],[12,"0","","",48,N],[3,"ImportedFileMap","","Holds information about a syntax_pos::FileMap imported from another crate. See `imported_filemaps()` for more information.",N,N],[12,"original_start_pos","","This FileMap's byte-offset within the codemap of its original crate",49,N],[12,"original_end_pos","","The end of this FileMap within the codemap of its original crate",49,N],[12,"translated_filemap","","The imported FileMap's representation within the local codemap",49,N],[3,"CrateMetadata","","",N,N],[12,"name","","",50,N],[12,"extern_crate","","Information about the extern crate that caused this crate to be loaded. If this is `None`, then the crate was injected (e.g., by the allocator)",50,N],[12,"blob","","",50,N],[12,"cnum_map","","",50,N],[12,"cnum","","",50,N],[12,"dependencies","","",50,N],[12,"codemap_import_info","","",50,N],[12,"alloc_decoding_state","","Used for decoding interpret::AllocIds in a cached & thread-safe manner.",50,N],[12,"root","","",50,N],[12,"def_path_table","","For each public item in this crate, we encode a key.  When the crate is loaded, we read all the keys and put them in this hashmap, which gives the reverse mapping.  This allows us to quickly retrace a `DefPath`, which is needed for incremental compilation support.",50,N],[12,"trait_impls","","",50,N],[12,"dep_kind","","",50,N],[12,"source","","",50,N],[12,"proc_macros","","",50,N],[3,"CStore","","",N,N],[12,"metas","","",51,N],[12,"extern_mod_crate_map","","Map from NodeId's of local extern crate statements to crate numbers",51,N],[12,"metadata_loader","","",51,N],[5,"provide","","",N,[[["providers"]]]],[5,"provide_extern","","",N,[[["providers"]]]],[6,"CrateNumMap","","",N,N],[11,"new","","",51,[[["box",["metadataloader"]]],["cstore"]]],[11,"alloc_new_crate_num","","",51,[[["self"]],["cratenum"]]],[11,"get_crate_data","","",51,[[["self"],["cratenum"]],["lrc",["cratemetadata"]]]],[11,"set_crate_data","","",51,[[["self"],["cratenum"],["lrc",["cratemetadata"]]]]],[11,"iter_crate_data","","",51,[[["self"],["i"]]]],[11,"crate_dependencies_in_rpo","","",51,[[["self"],["cratenum"]],["vec",["cratenum"]]]],[11,"push_dependencies_in_postorder","","",51,[[["self"],["vec"],["cratenum"]]]],[11,"do_postorder_cnums_untracked","","",51,[[["self"]],["vec",["cratenum"]]]],[11,"add_extern_mod_stmt_cnum","","",51,[[["self"],["nodeid"],["cratenum"]]]],[11,"do_extern_mod_stmt_cnum","","",51,[[["self"],["nodeid"]],["option",["cratenum"]]]],[0,"dynamic_lib","rustc_metadata","Dynamic library facilities.",N,N],[3,"DynamicLibrary","rustc_metadata::dynamic_lib","",N,N],[12,"handle","","",52,N],[0,"dl","","",N,N],[5,"open","rustc_metadata::dynamic_lib::dl","",N,[[["option",["osstr"]]],["result",["string"]]]],[5,"open_global_now","","",N,[[["osstr"]],["result",["string"]]]],[5,"open_external","","",N,N],[5,"open_internal","","",N,N],[5,"check_for_errors_in","","",N,[[["f"]],["result",["string"]]]],[5,"symbol","","",N,N],[5,"close","","",N,N],[11,"drop","rustc_metadata::dynamic_lib","",52,[[["self"]]]],[11,"open","","Lazily open a dynamic library. When passed None it gives a handle to the calling process",52,[[["option",["path"]]],["result",["dynamiclibrary","string"]]]],[11,"open_global_now","","Load a dynamic library into the global namespace (RTLD_GLOBAL on Unix) and do it now (don't use RTLD_LAZY on Unix).",52,[[["path"]],["result",["dynamiclibrary","string"]]]],[11,"envvar","","Returns the environment variable for this process's dynamic library search path",52,[[],["str"]]],[11,"symbol","","Accesses the value at the symbol of the dynamic library.",52,[[["self"],["str"]],["result",["string"]]]],[0,"locator","rustc_metadata","Finds crate binaries and loads their metadata",N,N],[3,"CrateMismatch","rustc_metadata::locator","",N,N],[12,"path","","",53,N],[12,"got","","",53,N],[3,"Context","","",N,N],[12,"sess","","",54,N],[12,"span","","",54,N],[12,"ident","","",54,N],[12,"crate_name","","",54,N],[12,"hash","","",54,N],[12,"extra_filename","","",54,N],[12,"target","","",54,N],[12,"triple","","",54,N],[12,"filesearch","","",54,N],[12,"root","","",54,N],[12,"rejected_via_hash","","",54,N],[12,"rejected_via_triple","","",54,N],[12,"rejected_via_kind","","",54,N],[12,"rejected_via_version","","",54,N],[12,"rejected_via_filename","","",54,N],[12,"should_match_name","","",54,N],[12,"is_proc_macro","","",54,N],[12,"metadata_loader","","",54,N],[3,"CratePaths","","",N,N],[12,"ident","","",55,N],[12,"dylib","","",55,N],[12,"rlib","","",55,N],[12,"rmeta","","",55,N],[4,"CrateFlavor","","",N,N],[13,"Rlib","","",56,N],[13,"Rmeta","","",56,N],[13,"Dylib","","",56,N],[5,"get_metadata_section","","",N,[[["target"],["crateflavor"],["path"],["metadataloader"]],["result",["metadatablob","string"]]]],[5,"get_metadata_section_imp","","",N,[[["target"],["crateflavor"],["path"],["metadataloader"]],["result",["metadatablob","string"]]]],[5,"list_file_metadata","","",N,[[["target"],["path"],["metadataloader"],["write"]],["result"]]],[11,"clone","","",56,[[["self"]],["crateflavor"]]],[11,"eq","","",56,[[["self"],["crateflavor"]],["bool"]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"paths","","",55,[[["self"]],["vec",["pathbuf"]]]],[11,"maybe_load_library_crate","","",54,[[["self"]],["option",["library"]]]],[11,"report_errs","","",54,N],[11,"find_library_crate","","",54,[[["self"],["str"],["hashset"]],["option",["library"]]]],[11,"extract_one","","",54,[[["self"],["fxhashmap",["pathbuf","pathkind"]],["crateflavor"],["option"]],["option"]]],[11,"crate_matches","","",54,[[["self"],["metadatablob"],["path"]],["option",["svh"]]]],[11,"dylibname","","",54,N],[11,"staticlibname","","",54,N],[11,"find_commandline_library","","",54,[[["self"],["locs"]],["option",["library"]]]],[17,"DIAGNOSTICS","rustc_metadata","",N,N],[11,"lookup","rustc_metadata::schema","Given the metadata, extract out the offset of a particular DefIndex (if any).",14,N],[11,"encode_variances_of","rustc_metadata::isolated_encoder","",12,[[["self"],["defid"]],["lazyseq",["variance"]]]],[11,"encode_item_type","","",12,[[["self"],["defid"]],["lazy",["ty"]]]],[11,"encode_enum_variant_info","","Encode data for the given variant of the given ADT. The index of the variant is untracked: this is ok because we will have to lookup the adt-def by its id, and that gives us the right to access any information in the adt-def (including, e.g., the length of the various vectors).",12,N],[11,"encode_info_for_mod","","",12,[[["self"],["fromid"]],["entry"]]],[11,"encode_field","","Encode data for the given field of the given variant of the given ADT. The indices of the variant/field are untracked: this is ok because we will have to lookup the adt-def by its id, and that gives us the right to access any information in the adt-def (including, e.g., the length of the various vectors).",12,N],[11,"encode_struct_ctor","","",12,N],[11,"encode_generics","","",12,[[["self"],["defid"]],["lazy",["generics"]]]],[11,"encode_predicates","","",12,[[["self"],["defid"]],["lazy",["genericpredicates"]]]],[11,"encode_predicates_defined_on","","",12,[[["self"],["defid"]],["lazy",["genericpredicates"]]]],[11,"encode_info_for_trait_item","","",12,[[["self"],["defid"]],["entry"]]],[11,"metadata_output_only","","",12,[[["self"]],["bool"]]],[11,"const_qualif","","",12,[[["self"],["u8"],["bodyid"]],["constqualif"]]],[11,"encode_info_for_impl_item","","",12,[[["self"],["defid"]],["entry"]]],[11,"encode_fn_arg_names_for_body","","",12,[[["self"],["bodyid"]],["lazyseq",["name"]]]],[11,"encode_fn_arg_names","","",12,N],[11,"encode_optimized_mir","","",12,[[["self"],["defid"]],["option",["lazy"]]]],[11,"encode_inherent_implementations","","",12,[[["self"],["defid"]],["lazyseq",["defindex"]]]],[11,"encode_stability","","",12,[[["self"],["defid"]],["option",["lazy"]]]],[11,"encode_deprecation","","",12,[[["self"],["defid"]],["option",["lazy"]]]],[11,"encode_rendered_const_for_body","","",12,[[["self"],["bodyid"]],["lazy",["renderedconst"]]]],[11,"encode_info_for_item","","",12,N],[11,"encode_info_for_macro_def","","Serialize the text of exported macros",12,[[["self"],["macrodef"]],["entry"]]],[11,"encode_info_for_ty_param","","",12,N],[11,"encode_info_for_closure","","",12,[[["self"],["defid"]],["entry"]]],[11,"encode_info_for_anon_const","","",12,[[["self"],["defid"]],["entry"]]],[11,"encode_attributes","","",12,N],[11,"encode_native_libraries","","",12,N],[11,"encode_foreign_modules","","",12,N],[11,"encode_crate_deps","","",12,N],[11,"encode_lang_items","","",12,N],[11,"encode_lang_items_missing","","",12,N],[11,"encode_impls","","Encodes an index, mapping each trait to its (local) implementations.",12,N],[11,"encode_exported_symbols","","",12,N],[11,"encode_dylib_dependency_formats","","",12,N],[11,"encode_info_for_foreign_item","","",12,N],[11,"decode","rustc_metadata::schema","",13,[[["self"],["m"]],["t"]]],[11,"decode","","",14,[[["self"],["m"]],[""]]],[11,"is_compatible","rustc_metadata::cstore","",48,[[["self"]],["bool"]]],[11,"get_rustc_version","","",48,[[["self"]],["string"]]],[11,"get_root","","",48,[[["self"]],["crateroot"]]],[11,"list_crate_metadata","","",48,[[["self"],["write"]],["result"]]],[11,"to_def","rustc_metadata::schema","",32,[[["self"],["defid"]],["option",["def"]]]],[11,"is_proc_macro","rustc_metadata::cstore","",50,[[["self"],["defindex"]],["bool"]]],[11,"maybe_entry","","",50,[[["self"],["defindex"]],["option",["lazy"]]]],[11,"entry","","",50,[[["self"],["defindex"]],["entry"]]],[11,"local_def_id","","",50,[[["self"],["defindex"]],["defid"]]],[11,"item_name","","",50,[[["self"],["defindex"]],["internedstring"]]],[11,"get_def","","",50,[[["self"],["defindex"]],["option",["def"]]]],[11,"get_span","","",50,[[["self"],["defindex"],["session"]],["span"]]],[11,"get_trait_def","","",50,[[["self"],["defindex"],["session"]],["traitdef"]]],[11,"get_variant","","",50,[[["self"],["entry"],["defindex"]],["variantdef"]]],[11,"get_adt_def","","",50,[[["self"],["defindex"],["tyctxt"]],["adtdef"]]],[11,"get_predicates","","",50,[[["self"],["defindex"],["tyctxt"]],["genericpredicates"]]],[11,"get_predicates_defined_on","","",50,[[["self"],["defindex"],["tyctxt"]],["genericpredicates"]]],[11,"get_super_predicates","","",50,[[["self"],["defindex"],["tyctxt"]],["genericpredicates"]]],[11,"get_generics","","",50,[[["self"],["defindex"],["session"]],["generics"]]],[11,"get_type","","",50,[[["self"],["defindex"],["tyctxt"]],["ty"]]],[11,"get_stability","","",50,[[["self"],["defindex"]],["option",["stability"]]]],[11,"get_deprecation","","",50,[[["self"],["defindex"]],["option",["deprecation"]]]],[11,"get_visibility","","",50,[[["self"],["defindex"]],["visibility"]]],[11,"get_impl_data","","",50,[[["self"],["defindex"]],["impldata"]]],[11,"get_parent_impl","","",50,[[["self"],["defindex"]],["option",["defid"]]]],[11,"get_impl_polarity","","",50,[[["self"],["defindex"]],["implpolarity"]]],[11,"get_impl_defaultness","","",50,[[["self"],["defindex"]],["defaultness"]]],[11,"get_coerce_unsized_info","","",50,[[["self"],["defindex"]],["option",["coerceunsizedinfo"]]]],[11,"get_impl_trait","","",50,[[["self"],["defindex"],["tyctxt"]],["option",["traitref"]]]],[11,"get_lang_items","","Iterates over the language items in the given crate.",50,[[["self"]],["vec"]]],[11,"each_child_of_item","","Iterates over each child of the given item.",50,[[["self"],["defindex"],["f"],["session"]]]],[11,"const_is_rvalue_promotable_to_static","","",50,[[["self"],["defindex"]],["bool"]]],[11,"is_item_mir_available","","",50,[[["self"],["defindex"]],["bool"]]],[11,"maybe_get_optimized_mir","","",50,[[["self"],["tyctxt"],["defindex"]],["option",["mir"]]]],[11,"mir_const_qualif","","",50,[[["self"],["defindex"]],["u8"]]],[11,"get_associated_item","","",50,[[["self"],["defindex"]],["associateditem"]]],[11,"get_item_variances","","",50,[[["self"],["defindex"]],["vec",["variance"]]]],[11,"get_ctor_kind","","",50,[[["self"],["defindex"]],["ctorkind"]]],[11,"get_struct_ctor_def_id","","",50,[[["self"],["defindex"]],["option",["defid"]]]],[11,"get_item_attrs","","",50,[[["self"],["defindex"],["session"]],["lrc"]]],[11,"get_struct_field_names","","",50,[[["self"],["defindex"]],["vec",["name"]]]],[11,"get_attributes","","",50,[[["self"],["entry"],["session"]],["vec",["attribute"]]]],[11,"reverse_translate_def_id","","",50,[[["self"],["defid"]],["option",["defid"]]]],[11,"get_inherent_implementations_for_type","","",50,[[["self"],["defindex"]],["vec",["defid"]]]],[11,"get_implementations_for_trait","","",50,[[["self"],["option",["defid"]],["vec"]]]],[11,"get_trait_of_item","","",50,[[["self"],["defindex"]],["option",["defid"]]]],[11,"get_native_libraries","","",50,[[["self"],["session"]],["vec",["nativelibrary"]]]],[11,"get_foreign_modules","","",50,[[["self"],["session"]],["vec",["foreignmodule"]]]],[11,"get_dylib_dependency_formats","","",50,[[["self"]],["vec"]]],[11,"get_missing_lang_items","","",50,[[["self"]],["vec",["langitem"]]]],[11,"get_fn_arg_names","","",50,[[["self"],["defindex"]],["vec",["name"]]]],[11,"exported_symbols","","",50,[[["self"],["tyctxt"]],["vec"]]],[11,"get_rendered_const","","",50,[[["self"],["defindex"]],["string"]]],[11,"get_macro","","",50,N],[11,"is_const_fn","","",50,[[["self"],["defindex"]],["bool"]]],[11,"is_foreign_item","","",50,[[["self"],["defindex"]],["bool"]]],[11,"fn_sig","","",50,[[["self"],["defindex"],["tyctxt"]],["polyfnsig"]]],[11,"def_key","","",50,[[["self"],["defindex"]],["defkey"]]],[11,"def_path","","",50,[[["self"],["defindex"]],["defpath"]]],[11,"def_path_hash","","",50,[[["self"],["defindex"]],["defpathhash"]]],[11,"imported_filemaps","","Imports the codemap from an external crate into the codemap of the crate currently being compiled (the \"local crate\").",50,[[["self"],["codemap"]],["readguard",["vec"]]]],[11,"crate_data_as_rc_any","","",51,[[["self"],["cratenum"]],["lrc",["any"]]]],[11,"metadata_loader","","",51,[[["self"]],["metadataloader"]]],[11,"visibility_untracked","","",51,[[["self"],["defid"]],["visibility"]]],[11,"item_generics_cloned_untracked","","",51,[[["self"],["defid"],["session"]],["generics"]]],[11,"associated_item_cloned_untracked","","",51,[[["self"],["defid"]],["associateditem"]]],[11,"dep_kind_untracked","","",51,[[["self"],["cratenum"]],["depkind"]]],[11,"export_macros_untracked","","",51,[[["self"],["cratenum"]]]],[11,"crate_name_untracked","","",51,[[["self"],["cratenum"]],["symbol"]]],[11,"crate_disambiguator_untracked","","",51,[[["self"],["cratenum"]],["cratedisambiguator"]]],[11,"crate_hash_untracked","","",51,[[["self"],["cratenum"]],["svh"]]],[11,"crate_edition_untracked","","",51,[[["self"],["cratenum"]],["edition"]]],[11,"def_key","","Returns the `DefKey` for a given `DefId`. This indicates the parent `DefId` as well as some idea of what kind of data the `DefId` refers to.",51,[[["self"],["defid"]],["defkey"]]],[11,"def_path","","",51,[[["self"],["defid"]],["defpath"]]],[11,"def_path_hash","","",51,[[["self"],["defid"]],["defpathhash"]]],[11,"def_path_table","","",51,[[["self"],["cratenum"]],["lrc",["defpathtable"]]]],[11,"struct_field_names_untracked","","",51,[[["self"],["defid"]],["vec",["name"]]]],[11,"item_children_untracked","","",51,[[["self"],["defid"],["session"]],["vec",["export"]]]],[11,"load_macro_untracked","","",51,[[["self"],["defid"],["session"]],["loadedmacro"]]],[11,"crates_untracked","","",51,[[["self"]],["vec",["cratenum"]]]],[11,"extern_mod_stmt_cnum_untracked","","",51,[[["self"],["nodeid"]],["option",["cratenum"]]]],[11,"postorder_cnums_untracked","","",51,[[["self"]],["vec",["cratenum"]]]],[11,"encode_metadata","","",51,[[["self"],["tyctxt"],["linkmeta"]],["encodedmetadata"]]],[11,"metadata_encoding_version","","",51,N],[11,"clone","","",42,[[["self"]],["nativelibrary"]]],[11,"clone","","",47,[[["self"]],["foreignmodule"]]],[11,"clone","","",46,[[["self"]],["libsource"]]],[11,"clone","","",43,[[["self"]],["nativelibrarykind"]]],[11,"clone","","",44,[[["self"]],["linkagepreference"]]],[11,"clone","","",45,[[["self"]],["cratesource"]]],[11,"cmp","","",43,[[["self"],["nativelibrarykind"]],["ordering"]]],[11,"encode","","",47,[[["self"],["__s"]],["result"]]],[11,"encode","","",42,[[["self"],["__s"]],["result"]]],[11,"encode","","",44,[[["self"],["__s"]],["result"]]],[11,"encode","","",43,[[["self"],["__s"]],["result"]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result",["error"]]]],[11,"assert_receiver_is_total_eq","","",43,N],[11,"hash_stable","","",47,N],[11,"hash_stable","","",42,N],[11,"hash_stable","","",44,N],[11,"hash_stable","","",43,N],[11,"hash_stable","","",45,N],[11,"partial_cmp","","",43,[[["self"],["nativelibrarykind"]],["option",["ordering"]]]],[11,"decode","","",44,[[["__d"]],["result",["linkagepreference"]]]],[11,"decode","","",42,[[["__d"]],["result",["nativelibrary"]]]],[11,"decode","","",43,[[["__d"]],["result",["nativelibrarykind"]]]],[11,"decode","","",47,[[["__d"]],["result",["foreignmodule"]]]],[11,"hash","","",43,N],[11,"hash","","",47,N],[11,"eq","","",45,[[["self"],["cratesource"]],["bool"]]],[11,"ne","","",45,[[["self"],["cratesource"]],["bool"]]],[11,"eq","","",46,[[["self"],["libsource"]],["bool"]]],[11,"ne","","",46,[[["self"],["libsource"]],["bool"]]],[11,"eq","","",43,[[["self"],["nativelibrarykind"]],["bool"]]],[11,"eq","","",44,[[["self"],["linkagepreference"]],["bool"]]],[11,"is_some","","",46,[[["self"]],["bool"]]],[11,"option","","",46,[[["self"]],["option",["pathbuf"]]]]],"paths":[[3,"IndexBuilder"],[3,"Untracked"],[3,"FromId"],[8,"DepGraphRead"],[3,"Index"],[3,"Unaligned"],[3,"EncodeContext"],[3,"EncodeVisitor"],[3,"ImplVisitor"],[3,"DecodeContext"],[8,"Metadata"],[8,"IntoArgs"],[3,"IsolatedEncoder"],[3,"Lazy"],[3,"LazySeq"],[3,"CrateRoot"],[3,"CrateDep"],[3,"TraitImpls"],[3,"Entry"],[3,"ConstQualif"],[3,"RenderedConst"],[3,"ModData"],[3,"MacroDef"],[3,"FnData"],[3,"VariantData"],[3,"TraitData"],[3,"ImplData"],[3,"MethodData"],[3,"ClosureData"],[3,"GeneratorData"],[3,"EncodedExportedSymbols"],[4,"LazyState"],[4,"EntryKind"],[4,"AssociatedContainer"],[3,"Collector"],[3,"Collector"],[3,"Collector"],[3,"Library"],[3,"CrateLoader"],[3,"ExtensionCrate"],[4,"PMDSource"],[4,"LoadResult"],[3,"NativeLibrary"],[4,"NativeLibraryKind"],[4,"LinkagePreference"],[3,"CrateSource"],[4,"LibSource"],[3,"ForeignModule"],[3,"MetadataBlob"],[3,"ImportedFileMap"],[3,"CrateMetadata"],[3,"CStore"],[3,"DynamicLibrary"],[3,"CrateMismatch"],[3,"Context"],[3,"CratePaths"],[4,"CrateFlavor"]]};
searchIndex["rustc_mir"]={"doc":"Rust MIR: a lowered representation of Rust. Also: an experiment!","items":[[5,"provide","rustc_mir","",N,[[["providers"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0001","rustc_mir::diagnostics","",N,N],[0,"__register_diagnostic_E0002","","",N,N],[0,"__register_diagnostic_E0004","","",N,N],[0,"__register_diagnostic_E0005","","",N,N],[0,"__register_diagnostic_E0007","","",N,N],[0,"__register_diagnostic_E0008","","",N,N],[0,"__register_diagnostic_E0009","","",N,N],[0,"__register_diagnostic_E0030","","",N,N],[0,"__register_diagnostic_E0158","","",N,N],[0,"__register_diagnostic_E0162","","",N,N],[0,"__register_diagnostic_E0165","","",N,N],[0,"__register_diagnostic_E0170","","",N,N],[0,"__register_diagnostic_E0297","","",N,N],[0,"__register_diagnostic_E0301","","",N,N],[0,"__register_diagnostic_E0302","","",N,N],[0,"__register_diagnostic_E0303","","",N,N],[0,"__register_diagnostic_E0010","","",N,N],[0,"__register_diagnostic_E0013","","",N,N],[0,"__register_diagnostic_E0015","","",N,N],[0,"__register_diagnostic_E0017","","",N,N],[0,"__register_diagnostic_E0018","","",N,N],[0,"__register_diagnostic_E0019","","",N,N],[0,"__register_diagnostic_E0022","","",N,N],[0,"__register_diagnostic_E0133","","",N,N],[0,"__register_diagnostic_E0373","","",N,N],[0,"__register_diagnostic_E0381","","",N,N],[0,"__register_diagnostic_E0382","","",N,N],[0,"__register_diagnostic_E0383","","",N,N],[0,"__register_diagnostic_E0384","","",N,N],[0,"__register_diagnostic_E0387","","",N,N],[0,"__register_diagnostic_E0388","","",N,N],[0,"__register_diagnostic_E0389","","",N,N],[0,"__register_diagnostic_E0395","","",N,N],[0,"__register_diagnostic_E0161","","",N,N],[0,"__register_diagnostic_E0396","","",N,N],[0,"__register_diagnostic_E0492","","",N,N],[0,"__register_diagnostic_E0499","","",N,N],[0,"__register_diagnostic_E0500","","",N,N],[0,"__register_diagnostic_E0501","","",N,N],[0,"__register_diagnostic_E0502","","",N,N],[0,"__register_diagnostic_E0503","","",N,N],[0,"__register_diagnostic_E0504","","",N,N],[0,"__register_diagnostic_E0505","","",N,N],[0,"__register_diagnostic_E0506","","",N,N],[0,"__register_diagnostic_E0507","","",N,N],[0,"__register_diagnostic_E0508","","",N,N],[0,"__register_diagnostic_E0509","","",N,N],[0,"__register_diagnostic_E0579","","",N,N],[0,"__register_diagnostic_E0595","","",N,N],[0,"__register_diagnostic_E0596","","",N,N],[0,"__register_diagnostic_E0597","","",N,N],[0,"__register_diagnostic_E0626","","",N,N],[0,"__register_diagnostic_E0493","","",N,N],[0,"__register_diagnostic_E0524","","",N,N],[0,"__register_diagnostic_E0526","","",N,N],[0,"__register_diagnostic_E0594","","",N,N],[0,"__register_diagnostic_E0598","","",N,N],[0,"__register_diagnostic_E0625","","",N,N],[0,"borrow_check","rustc_mir","This query borrow-checks the MIR to (further) ensure it is not broken.",N,N],[3,"MirBorrowckCtxt","rustc_mir::borrow_check","",N,N],[12,"tcx","","",0,N],[12,"mir","","",0,N],[12,"mir_def_id","","",0,N],[12,"move_data","","",0,N],[12,"location_table","","Map from MIR `Location` to `LocationIndex`; created when MIR borrowck begins.",0,N],[12,"param_env","","",0,N],[12,"movable_generator","","",0,N],[12,"locals_are_invalidated_at_exit","","This keeps track of whether local variables are free-ed when the function exits even without a `StorageDead`, which appears to be the case for constants.",0,N],[12,"access_place_error_reported","","This field keeps track of when borrow errors are reported in the access_place function so that there is no duplicate reporting. This field cannot also be used for the conflicting borrow errors that is handled by the `reservation_error_reported` field as the inclusion of the `Span` type (while required to mute some errors) stops the muting of the reservation errors.",0,N],[12,"reservation_error_reported","","This field keeps track of when borrow conflict errors are reported for reservations, so that we don't report seemingly duplicate errors for corresponding activations",0,N],[12,"moved_error_reported","","This field keeps track of errors reported in the checking of moved variables, so that we don't report seemingly duplicate errors.",0,N],[12,"errors_buffer","","Errors to be reported buffer",0,N],[12,"used_mut","","This field keeps track of all the local variables that are declared mut and are mutated. Used for the warning issued by an unused mutable local variable.",0,N],[12,"used_mut_upvars","","If the function we're checking is a closure, then we'll need to report back the list of mutable upvars that have been used. This field keeps track of them.",0,N],[12,"nonlexical_regioncx","","Non-lexical region inference context, if NLL is enabled.  This contains the results from region inference and lets us e.g. find out which CFG points are contained in each borrow region.",0,N],[12,"borrow_set","","The set of borrows extracted from the MIR",0,N],[12,"dominators","","Dominators for MIR",0,N],[3,"AccessErrorsReported","","",N,N],[12,"mutability_error","","",1,N],[12,"conflict_error","","",1,N],[3,"RootPlace","","",N,N],[12,"place","","",2,N],[12,"is_local_mutation_allowed","","",2,N],[3,"Context","","",N,N],[12,"kind","","",3,N],[12,"loc","","",3,N],[4,"MutateMode","","",N,N],[13,"JustWrite","","",4,N],[13,"WriteAndRead","","",4,N],[4,"ArtificialField","","",N,N],[13,"Discriminant","","",5,N],[13,"ArrayLength","","",5,N],[4,"ShallowOrDeep","","",N,N],[13,"Shallow","","From the RFC: \"A shallow access means that the immediate fields reached at P are accessed, but references or pointers found within are not dereferenced. Right now, the only access that is shallow is an assignment like `x = ...;`, which would be a shallow write of `x`.\"",6,N],[13,"Deep","","From the RFC: \"A deep access means that all data reachable through the given place may be invalidated or accesses by this action.\"",6,N],[4,"ReadOrWrite","","Kind of access to a value: read or write (For informational purposes only)",N,N],[13,"Read","","From the RFC: \"A read means that the existing data may be read, but will not be changed.\"",7,N],[13,"Write","","From the RFC: \"A write means that the data may be mutated to new values or otherwise invalidated (for example, it could be de-initialized, as in a move operation).",7,N],[13,"Reservation","","For two-phase borrows, we distinguish a reservation (which is treated like a Read) from an activation (which is treated like a write), and each of those is furthermore distinguished from Reads/Writes above.",7,N],[13,"Activation","","",7,N],[4,"ReadKind","","Kind of read access to a value (For informational purposes only)",N,N],[13,"Borrow","","",8,N],[13,"Copy","","",8,N],[4,"WriteKind","","Kind of write access to a value (For informational purposes only)",N,N],[13,"StorageDeadOrDrop","","",9,N],[13,"MutableBorrow","","",9,N],[13,"Mutate","","",9,N],[13,"Move","","",9,N],[4,"LocalMutationIsAllowed","","When checking permissions for a place access, this flag is used to indicate that an immutable local place can be mutated.",N,N],[13,"Yes","","",10,N],[13,"ExceptUpvars","","We want use of immutable upvars to cause a \"write to immutable upvar\" error, not an \"reassignment\" error.",10,N],[13,"No","","",10,N],[4,"InitializationRequiringAction","","",N,N],[13,"Update","","",11,N],[13,"Borrow","","",11,N],[13,"Use","","",11,N],[13,"Assignment","","",11,N],[4,"NoMovePathFound","","",N,N],[13,"ReachedStatic","","",12,N],[4,"Overlap","","The degree of overlap between 2 places for borrow-checking.",N,N],[13,"Arbitrary","","The places might partially overlap - in this case, we give up and say that they might conflict. This occurs when different fields of a union are borrowed. For example, if `u` is a union, we have no way of telling how disjoint `u.a.x` and `a.b.y` are.",13,N],[13,"EqualOrDisjoint","","The places have the same type, and are either completely disjoint or equal - i.e. they can't \"partially\" overlap as can occur with unions. This is the \"base case\" on which we recur for extensions of the place.",13,N],[13,"Disjoint","","The places are disjoint, so we know all extensions of them will also be disjoint.",13,N],[4,"ContextKind","","",N,N],[13,"Activation","","",14,N],[13,"AssignLhs","","",14,N],[13,"AssignRhs","","",14,N],[13,"SetDiscrim","","",14,N],[13,"InlineAsm","","",14,N],[13,"SwitchInt","","",14,N],[13,"Drop","","",14,N],[13,"DropAndReplace","","",14,N],[13,"CallOperator","","",14,N],[13,"CallOperand","","",14,N],[13,"CallDest","","",14,N],[13,"Assert","","",14,N],[13,"Yield","","",14,N],[13,"ReadForMatch","","",14,N],[13,"StorageDead","","",14,N],[5,"provide","","",N,[[["providers"]]]],[5,"mir_borrowck","","",N,[[["tyctxt"],["defid"]],["borrowcheckresult"]]],[5,"do_mir_borrowck","","",N,[[["inferctxt"],["mir"],["defid"]],["borrowcheckresult"]]],[0,"borrow_set","","",N,N],[3,"BorrowSet","rustc_mir::borrow_check::borrow_set","",N,N],[12,"borrows","","The fundamental map relating bitvector indexes to the borrows in the MIR.",15,N],[12,"location_map","","Each borrow is also uniquely identified in the MIR by the `Location` of the assignment statement in which it appears on the right hand side; we map each such location to the corresponding `BorrowIndex`.",15,N],[12,"activation_map","","Locations which activate borrows. NOTE: A given location may activate more than one borrow in the future when more general two-phase borrow support is introduced, but for now we only need to store one borrow index",15,N],[12,"region_map","","Every borrow has a region; this maps each such regions back to its borrow-indexes.",15,N],[12,"local_map","","Map from local to all the borrows on that local",15,N],[3,"BorrowData","","",N,N],[12,"reserve_location","","Location where the borrow reservation starts. In many cases, this will be equal to the activation location but not always.",16,N],[12,"activation_location","","Location where the borrow is activated.",16,N],[12,"kind","","What kind of borrow this is",16,N],[12,"region","","The region for which this borrow is live",16,N],[12,"borrowed_place","","Place from which we are borrowing",16,N],[12,"assigned_place","","Place to which the borrow was stored",16,N],[3,"GatherBorrows","","",N,N],[12,"tcx","","",17,N],[12,"mir","","",17,N],[12,"idx_vec","","",17,N],[12,"location_map","","",17,N],[12,"activation_map","","",17,N],[12,"region_map","","",17,N],[12,"local_map","","",17,N],[12,"pending_activations","","When we encounter a 2-phase borrow statement, it will always be assigning into a temporary TEMP:",17,N],[4,"TwoPhaseActivation","","Location where a two phase borrow is activated, if a borrow is in fact a two phase borrow.",N,N],[13,"NotTwoPhase","","",18,N],[13,"NotActivated","","",18,N],[13,"ActivatedAt","","",18,N],[11,"index","","",15,[[["self"],["borrowindex"]],["borrowdata"]]],[11,"clone","","",18,[[["self"]],["twophaseactivation"]]],[11,"eq","","",18,[[["self"],["twophaseactivation"]],["bool"]]],[11,"ne","","",18,[[["self"],["twophaseactivation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"build","","",15,[[["tyctxt"],["mir"]],["self"]]],[11,"activations_at_location","","",15,N],[11,"visit_assign","","",17,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_place","","",17,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_rvalue","","",17,[[["self"],["rvalue"],["location"]]]],[11,"visit_statement","","",17,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"allow_two_phase_borrow","","Returns true if the borrow represented by `kind` is allowed to be split into separate Reservation and Activation phases.",17,[[["self"],["borrowkind"]],["bool"]]],[11,"insert_as_pending_if_two_phase","","If this is a two-phase borrow, then we will record it as \"pending\" until we find the activating use.",17,[[["self"],["location"],["place"],["region"],["borrowkind"],["borrowindex"]]]],[0,"error_reporting","rustc_mir::borrow_check","",N,N],[3,"IncludingDowncast","rustc_mir::borrow_check::error_reporting","",N,N],[12,"0","","",19,N],[11,"report_use_of_moved_or_uninitialized","rustc_mir::borrow_check","",0,N],[11,"report_move_out_while_borrowed","","",0,N],[11,"report_use_while_mutably_borrowed","","",0,N],[11,"find_closure_span","","Finds the span of arguments of a closure (within `maybe_closure_span`) and its usage of the local assigned at `location`. This is done by searching in statements succeeding `location` and originating from `maybe_closure_span`.",0,[[["self"],["span"],["location"]],["option"]]],[11,"report_conflicting_borrow","","",0,N],[11,"report_borrowed_value_does_not_live_long_enough","","",0,N],[11,"report_local_value_does_not_live_long_enough","","",0,[[["self"],["context"],["string"],["lrc"],["borrowdata"],["span"],["span"],["span"],["option"]]]],[11,"report_temporary_value_does_not_live_long_enough","","",0,[[["self"],["context"],["lrc"],["borrowdata"],["span"],["span"],["span"]]]],[11,"report_illegal_mutation_of_borrowed","","",0,N],[11,"report_illegal_reassignment","","Reports an illegal reassignment; for example, an assignment to (part of) a non-`mut` local that occurs potentially after that local has already been initialized. `place` is the path being assigned; `err_place` is a place providing a reason why `place` is not mutable (e.g. the non-`mut` local `x` in an assignment to `x.f`).",0,N],[11,"describe_place","","",0,[[["self"],["place"]],["option",["string"]]]],[11,"describe_place_with_options","","",0,[[["self"],["place"],["includingdowncast"]],["option",["string"]]]],[11,"append_place_to_string","","",0,[[["self"],["place"],["string"],["bool"],["includingdowncast"]],["result"]]],[11,"append_local_to_string","","",0,[[["self"],["local"],["string"]],["result"]]],[11,"describe_field","","",0,[[["self"],["place"],["field"]],["string"]]],[11,"describe_field_from_ty","","",0,[[["self"],["ty"],["field"]],["string"]]],[11,"retrieve_borrow_span","","",0,[[["self"],["borrowdata"]],["span"]]],[11,"retrieve_type_for_place","","",0,[[["self"],["place"]],["option",["ty"]]]],[0,"flows","","Manages the dataflow bits required for borrowck.",N,N],[3,"Flows","rustc_mir::borrow_check::flows","",N,N],[12,"borrows","","",20,N],[12,"uninits","","",20,N],[12,"move_outs","","",20,N],[12,"ever_inits","","",20,N],[12,"polonius_output","","Polonius Output",20,N],[22,"","","",N,N],[11,"new","","",20,[[["flowatlocation",["borrows"]],["flowatlocation",["maybeuninitializedplaces"]],["flowatlocation",["movingoutstatements"]],["flowatlocation",["everinitializedplaces"]],["option",["rc"]]],["self"]]],[11,"borrows_in_scope","","",20,[[["self"],["locationindex"]],[""]]],[11,"with_outgoing_borrows","","",20,N],[11,"reset_to_entry_of","","",20,[[["self"],["basicblock"]]]],[11,"reconstruct_statement_effect","","",20,[[["self"],["location"]]]],[11,"reconstruct_terminator_effect","","",20,[[["self"],["location"]]]],[11,"apply_local_effect","","",20,[[["self"],["location"]]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[0,"location","rustc_mir::borrow_check","",N,N],[3,"LocationTable","rustc_mir::borrow_check::location","Maps between a MIR Location, which identifies the a particular statement within a basic block, to a \"rich location\", which identifies at a finer granularity. In particular, we distinguish the start of a statement and the mid-point. The mid-point is the point just before the statement takes effect; in particular, for an assignment `A = B`, it is the point where B is about to be written into A. This mid-point is a kind of hack to work around our inability to track the position information at sufficient granularity through outlives relations; however, the rich location table serves another purpose: it compresses locations from multiple words into a single u32.",N,N],[12,"num_points","","",21,N],[12,"statements_before_block","","",21,N],[3,"LocationIndex","","",N,N],[12,"0","","",22,N],[4,"RichLocation","","",N,N],[13,"Start","","",23,N],[13,"Mid","","",23,N],[22,"","","",N,N],[11,"clone","","",22,[[["self"]],["locationindex"]]],[11,"eq","","",22,[[["self"],["locationindex"]],["bool"]]],[11,"ne","","",22,[[["self"],["locationindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",22,N],[11,"hash","","",22,N],[11,"partial_cmp","","",22,[[["self"],["locationindex"]],["option",["ordering"]]]],[11,"lt","","",22,[[["self"],["locationindex"]],["bool"]]],[11,"le","","",22,[[["self"],["locationindex"]],["bool"]]],[11,"gt","","",22,[[["self"],["locationindex"]],["bool"]]],[11,"ge","","",22,[[["self"],["locationindex"]],["bool"]]],[11,"cmp","","",22,[[["self"],["locationindex"]],["ordering"]]],[11,"decode","","",22,[[["__d"]],["result",["locationindex"]]]],[11,"encode","","",22,[[["self"],["__s"]],["result"]]],[11,"new","","",22,[[["usize"]],["self"]]],[11,"index","","",22,[[["self"]],["usize"]]],[11,"steps_between","","",22,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",22,[[["self"]],["self"]]],[11,"replace_zero","","",22,[[["self"]],["self"]]],[11,"add_one","","",22,[[["self"]],["self"]]],[11,"sub_one","","",22,[[["self"]],["self"]]],[11,"add_usize","","",22,[[["self"],["usize"]],["option"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",23,[[["self"]],["richlocation"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"new","","",21,[[["mir"]],["self"]]],[11,"all_points","","",21,[[["self"]],[""]]],[11,"start_index","","",21,[[["self"],["location"]],["locationindex"]]],[11,"mid_index","","",21,[[["self"],["location"]],["locationindex"]]],[11,"to_location","","",21,[[["self"],["locationindex"]],["richlocation"]]],[11,"is_start","","",22,[[["self"]],["bool"]]],[0,"move_errors","rustc_mir::borrow_check","",N,N],[4,"GroupedMoveError","rustc_mir::borrow_check::move_errors","",N,N],[13,"MovesFromMatchPlace","","",24,N],[12,"span","rustc_mir::borrow_check::move_errors::GroupedMoveError","",24,N],[12,"move_from","","",24,N],[12,"kind","","",24,N],[12,"binds_to","","",24,N],[13,"MovesFromPattern","rustc_mir::borrow_check::move_errors","",24,N],[12,"span","rustc_mir::borrow_check::move_errors::GroupedMoveError","",24,N],[12,"move_from","","",24,N],[12,"kind","","",24,N],[12,"binds_to","","",24,N],[13,"OtherIllegalMove","rustc_mir::borrow_check::move_errors","",24,N],[12,"span","rustc_mir::borrow_check::move_errors::GroupedMoveError","",24,N],[12,"kind","","",24,N],[11,"fmt","rustc_mir::borrow_check::move_errors","",24,[[["self"],["formatter"]],["result"]]],[11,"report_move_errors","rustc_mir::borrow_check","",0,[[["self"],["vec",["moveerror"]]]]],[11,"group_move_errors","","",0,[[["self"],["vec",["moveerror"]]],["vec",["groupedmoveerror"]]]],[11,"append_to_grouped_errors","","",0,[[["self"],["vec"],["moveerror"]]]],[11,"append_binding_error","","",0,[[["self"],["vec"],["illegalmoveoriginkind"],["place"],["local"],["option"],["span"],["span"]]]],[11,"report","","",0,[[["self"],["groupedmoveerror"]]]],[11,"add_move_hints","","",0,[[["self"],["groupedmoveerror"],["diagnosticbuilder"],["span"]]]],[11,"suitable_to_remove_deref","","",0,[[["self"],["placeprojection"],["str"]],["bool"]]],[0,"mutability_errors","","",N,N],[4,"AccessKind","rustc_mir::borrow_check::mutability_errors","",N,N],[13,"MutableBorrow","","",25,N],[13,"Mutate","","",25,N],[13,"Move","","",25,N],[5,"suggest_ampmut_self","","",N,N],[5,"suggest_ampmut","","",N,N],[5,"is_closure_or_generator","","",N,[[["ty"]],["bool"]]],[11,"clone","","",25,[[["self"]],["accesskind"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"report_mutability_error","rustc_mir::borrow_check","",0,[[["self"],["place"],["span"],["place"],["accesskind"],["location"]]]],[11,"is_upvar","","",0,[[["self"],["place"]],["bool"]]],[0,"path_utils","","",N,N],[4,"Control","rustc_mir::borrow_check::path_utils","Control for the path borrow checking code",N,N],[13,"Continue","","",26,N],[13,"Break","","",26,N],[5,"allow_two_phase_borrow","","Returns true if the borrow represented by `kind` is allowed to be split into separate Reservation and Activation phases.",N,[[["tyctxt"],["borrowkind"]],["bool"]]],[5,"each_borrow_involving_path","","Encapsulates the idea of iterating over every borrow that involves a particular path",N,N],[5,"is_active","","",N,[[["dominators"],["borrowdata"],["location"]],["bool"]]],[5,"borrow_of_local_data","","Determines if a given borrow is borrowing local data This is called for all Yield statements on movable generators",N,[[["place"]],["bool"]]],[11,"clone","","",26,[[["self"]],["control"]]],[11,"eq","","",26,[[["self"],["control"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",26,N],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[0,"place_ext","rustc_mir::borrow_check","",N,N],[8,"PlaceExt","rustc_mir::borrow_check::place_ext","Extension methods for the `Place` type.",N,N],[10,"is_unsafe_place","","True if this is a deref of a raw pointer.",27,[[["self"],["tyctxt"],["mir"]],["bool"]]],[10,"root_local","","If this is a place like `x.f.g`, returns the local `x`. Returns `None` if this is based in a static.",27,[[["self"]],["option",["local"]]]],[0,"places_conflict","rustc_mir::borrow_check","",N,N],[3,"PlaceComponents","rustc_mir::borrow_check::places_conflict","A linked list of places running up the stack; begins with the innermost place and extends to projections (e.g., `a.b` would have the place `a` with a \"next\" pointer to `a.b`).  Created by `unroll_place`.",N,N],[12,"component","","",28,N],[12,"next","","",28,N],[3,"PlaceComponentsIter","","Iterator over components; see `PlaceComponents::iter` for more information.",N,N],[12,"value","","",29,N],[5,"places_conflict","","",N,[[["tyctxt"],["mir"],["place"],["place"],["shallowordeep"]],["bool"]]],[5,"place_components_conflict","","",N,[[["tyctxt"],["mir"],["placecomponentsiter"],["placecomponentsiter"],["shallowordeep"]],["bool"]]],[5,"unroll_place","","Recursively \"unroll\" a place into a `PlaceComponents` list, invoking `op` with a `PlaceComponentsIter`.",N,N],[5,"place_element_conflict","","",N,[[["tyctxt"],["mir"],["place"],["place"]],["overlap"]]],[11,"iter","","Converts a list of `Place` components into an iterator; this iterator yields up a never-ending stream of `Option<&Place>`. These begin with the \"innermst\" place and then with each projection therefrom. So given a place like `a.b.c` it would yield up:",28,[[["self"]],["placecomponentsiter"]]],[11,"next","","",29,[[["self"]],["option",["place"]]]],[0,"prefixes","rustc_mir::borrow_check","From the NLL RFC: \"The deep [aka 'supporting'] prefixes for an place are formed by stripping away fields and derefs, except that we stop when we reach the deref of a shared reference. [...] \"",N,N],[3,"Prefixes","rustc_mir::borrow_check::prefixes","",N,N],[12,"mir","","",30,N],[12,"tcx","","",30,N],[12,"kind","","",30,N],[12,"next","","",30,N],[4,"PrefixSet","","",N,N],[13,"All","","Doesn't stop until it returns the base case (a Local or Static prefix).",31,N],[13,"Shallow","","Stops at any dereference.",31,N],[13,"Supporting","","Stops at the deref of a shared reference.",31,N],[8,"IsPrefixOf","","",N,N],[10,"is_prefix_of","","",32,[[["self"],["place"]],["bool"]]],[11,"clone","","",31,[[["self"]],["prefixset"]]],[11,"eq","","",31,[[["self"],["prefixset"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",31,N],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"prefixes","rustc_mir::borrow_check","Returns an iterator over the prefixes of `place` (inclusive) from longest to smallest, potentially terminating the iteration early based on `kind`.",0,[[["self"],["place"],["prefixset"]],["prefixes"]]],[11,"next","rustc_mir::borrow_check::prefixes","",30,[[["self"]],["option"]]],[0,"used_muts","rustc_mir::borrow_check","",N,N],[3,"GatherUsedMutsVisitor","rustc_mir::borrow_check::used_muts","MIR visitor gathering the assignments to a set of locals, in a single walk. 'visit = the duration of the MIR walk",N,N],[12,"needles","","",33,N],[12,"mbcx","","",33,N],[11,"gather_used_muts","rustc_mir::borrow_check","Walks the MIR looking for assignments to a set of locals, as part of the unused mutable local variables lint, to update the context's `used_mut` in a single walk.",0,[[["self"],["fxhashset",["local"]]]]],[11,"visit_local","rustc_mir::borrow_check::used_muts","",33,[[["self"],["local"],["placecontext"],["location"]]]],[0,"nll","rustc_mir::borrow_check","",N,N],[5,"replace_regions_in_mir","rustc_mir::borrow_check::nll","Rewrites the regions in the MIR to use NLL variables, also scraping out the set of universal regions (e.g., region parameters) declared on the function. That set will need to be given to `compute_regions`.",N,[[["inferctxt"],["defid"],["paramenv"],["mir"]],["universalregions"]]],[5,"compute_regions","","Computes the (non-lexical) regions from the input MIR.",N,N],[5,"dump_mir_results","","",N,[[["inferctxt"],["livenessresults"],["mirsource"],["mir"],["regioninferencecontext"],["option"]]]],[5,"dump_annotation","","",N,[[["inferctxt"],["mir"],["defid"],["regioninferencecontext"],["option"],["vec"]]]],[5,"for_each_region_constraint","","",N,[[["closureregionrequirements"],["fnmut"]],["result"]]],[5,"live_variable_set","","",N,[[["livevarset"],["livevarset"]],["string"]]],[0,"constraint_generation","","",N,N],[3,"ConstraintGeneration","rustc_mir::borrow_check::nll::constraint_generation","'cg = the duration of the constraint generation process itself.",N,N],[12,"infcx","","",34,N],[12,"all_facts","","",34,N],[12,"location_table","","",34,N],[12,"liveness_constraints","","",34,N],[12,"borrow_set","","",34,N],[5,"generate_constraints","","",N,[[["inferctxt"],["livenessvalues"],["option"],["locationtable"],["mir"],["borrowset"]]]],[11,"visit_basic_block_data","","",34,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_substs","","We sometimes have `substs` within an rvalue, or within a call. Make them live at the location where they appear.",34,[[["self"],["substs"],["location"]]]],[11,"visit_region","","We sometimes have `region` within an rvalue, or within a call. Make them live at the location where they appear.",34,[[["self"],["region"],["location"]]]],[11,"visit_ty","","We sometimes have `ty` within an rvalue, or within a call. Make them live at the location where they appear.",34,[[["self"],["ty"],["tycontext"]]]],[11,"visit_generator_substs","","We sometimes have `generator_substs` within an rvalue, or within a call. Make them live at the location where they appear.",34,[[["self"],["generatorsubsts"],["location"]]]],[11,"visit_closure_substs","","We sometimes have `closure_substs` within an rvalue, or within a call. Make them live at the location where they appear.",34,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_statement","","",34,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_assign","","",34,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_terminator","","",34,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_user_assert_ty","","",34,[[["self"],["canonicalty"],["local"],["location"]]]],[11,"add_regular_live_constraint","","Some variable with type `live_ty` is \"regular live\" at `location` -- i.e., it may be used later. This means that all regions appearing in the type `live_ty` must be live at `location`.",34,[[["self"],["t"],["location"]]]],[0,"explain_borrow","rustc_mir::borrow_check::nll","",N,N],[0,"find_use","rustc_mir::borrow_check::nll::explain_borrow","",N,N],[3,"UseFinder","rustc_mir::borrow_check::nll::explain_borrow::find_use","",N,N],[12,"mir","","",35,N],[12,"regioncx","","",35,N],[12,"tcx","","",35,N],[12,"region_vid","","",35,N],[12,"start_point","","",35,N],[12,"liveness_mode","","",35,N],[3,"DefUseVisitor","","",N,N],[12,"mir","","",36,N],[12,"tcx","","",36,N],[12,"region_vid","","",36,N],[12,"liveness_mode","","",36,N],[12,"def_use_result","","",36,N],[4,"DefUseResult","","",N,N],[13,"Def","","",37,N],[13,"UseLive","","",37,N],[12,"local","rustc_mir::borrow_check::nll::explain_borrow::find_use::DefUseResult","",37,N],[13,"UseDrop","rustc_mir::borrow_check::nll::explain_borrow::find_use","",37,N],[12,"local","rustc_mir::borrow_check::nll::explain_borrow::find_use::DefUseResult","",37,N],[5,"find","rustc_mir::borrow_check::nll::explain_borrow::find_use","",N,[[["mir"],["rc"],["tyctxt"],["regionvid"],["location"]],["option",["cause"]]]],[11,"find","","",35,[[["self"]],["option",["cause"]]]],[11,"def_use","","",35,[[["self"],["location"],["mirvisitable"]],["option",["defuseresult"]]]],[11,"visit_local","","",36,[[["self"],["local"],["placecontext"],["location"]]]],[11,"explain_why_borrow_contains_point","rustc_mir::borrow_check","Adds annotations to `err` explaining why the borrow contains the point from `context`. This is key for the \"3-point errors\" [described in the NLL RFC][d].",0,[[["self"],["context"],["borrowdata"],["option"],["diagnosticbuilder"]]]],[0,"facts","rustc_mir::borrow_check::nll","",N,N],[3,"FactWriter","rustc_mir::borrow_check::nll::facts","",N,N],[12,"location_table","","",38,N],[12,"dir","","",38,N],[5,"write_row","","",N,N],[6,"AllFacts","","",N,N],[8,"AllFactsExt","","",N,N],[10,"enabled","","Returns true if there is a need to gather `AllFacts` given the current `-Z` flags.",39,[[["tyctxt"]],["bool"]]],[10,"write_to_dir","","",39,N],[8,"FactRow","","",N,N],[10,"write","","",40,[[["self"],["file"],["locationtable"]],["result",["box"]]]],[8,"FactCell","","",N,N],[10,"to_string","","",41,[[["self"],["locationtable"]],["string"]]],[11,"index","rustc_mir::borrow_check::location","",22,[[["self"]],["usize"]]],[11,"from","","",22,[[["usize"]],["locationindex"]]],[11,"write_facts_to_path","rustc_mir::borrow_check::nll::facts","",38,N],[11,"to_string","rustc_mir::borrow_check::location","",22,[[["self"],["locationtable"]],["string"]]],[0,"invalidation","rustc_mir::borrow_check::nll","",N,N],[3,"InvalidationGenerator","rustc_mir::borrow_check::nll::invalidation","'cg = the duration of the constraint generation process itself.",N,N],[12,"infcx","","",42,N],[12,"all_facts","","",42,N],[12,"location_table","","",42,N],[12,"mir","","",42,N],[12,"dominators","","",42,N],[12,"borrow_set","","",42,N],[12,"param_env","","",42,N],[5,"generate_invalidates","","",N,[[["inferctxt"],["option"],["locationtable"],["mir"],["defid"],["borrowset"]]]],[11,"visit_statement","","",42,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_terminator","","",42,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_terminator_drop","","Simulates dropping of a variable",42,[[["self"],["location"],["terminator"],["place"],["ty"]]]],[11,"mutate_place","","Simulates mutation of a place",42,[[["self"],["context"],["place"],["shallowordeep"],["mutatemode"]]]],[11,"consume_operand","","Simulates consumption of an operand",42,[[["self"],["context"],["operand"]]]],[11,"consume_rvalue","","",42,[[["self"],["context"],["rvalue"]]]],[11,"access_place","","Simulates an access to a place",42,N],[11,"check_access_for_conflict","","",42,[[["self"],["context"],["place"],["shallowordeep"],["readorwrite"]]]],[11,"generate_invalidates","","Generate a new invalidates(L, B) fact",42,[[["self"],["borrowindex"],["location"]]]],[0,"region_infer","rustc_mir::borrow_check::nll","",N,N],[3,"RegionInferenceContext","rustc_mir::borrow_check::nll::region_infer","",N,N],[12,"definitions","","Contains the definition for every region variable.  Region variables are identified by their index (`RegionVid`). The definition contains information about where the region came from as well as its final inferred value.",43,N],[12,"liveness_constraints","","The liveness constraints added to each region. For most regions, these start out empty and steadily grow, though for each universally quantified region R they start out containing the entire CFG and `end(R)`.",43,N],[12,"constraints","","The outlives constraints computed by the type-check.",43,N],[12,"constraint_graph","","The constraint-set, but in graph form, making it easy to traverse the constraints adjacent to a particular region. Used to construct the SCC (see `constraint_sccs`) and for error reporting.",43,N],[12,"constraint_sccs","","The SCC computed from `constraints` and the constraint graph. Used to compute the values of each region.",43,N],[12,"scc_universes","","Contains the minimum universe of any variable within the same SCC. We will ensure that no SCC contains values that are not visible from this index.",43,N],[12,"scc_values","","The final inferred values of the region variables; we compute one value per SCC. To get the value for any given region, you first find which scc it is a part of.",43,N],[12,"type_tests","","Type constraints that we check after solving.",43,N],[12,"universal_regions","","Information about the universally quantified regions in scope on this function.",43,N],[12,"universal_region_relations","","Information about how the universally quantified regions in scope on this function relate to one another.",43,N],[3,"RegionDefinition","","",N,N],[12,"origin","","What kind of variable is this -- a free region? existential variable? etc. (See the `NLLRegionVariableOrigin` for more info.)",44,N],[12,"universe","","Which universe is this region variable defined in? This is most often `ty::UniverseIndex::ROOT`, but when we encounter forall-quantifiers like `for<'a> { 'a = 'b }`, we would create the variable for `'a` in a subuniverse.",44,N],[12,"external_name","","If this is 'static or an early-bound region, then this is `Some(X)` where `X` is the name of the region.",44,N],[3,"TypeTest","","A \"type test\" corresponds to an outlives constraint between a type and a lifetime, like `T: 'x` or `<T as Foo>::Bar: 'x`.  They are translated from the `Verify` region constraints in the ordinary inference context.",N,N],[12,"generic_kind","","The type `T` that must outlive the region.",45,N],[12,"lower_bound","","The region `'x` that the type must outlive.",45,N],[12,"locations","","Where did this constraint arise and why?",45,N],[12,"test","","A test which, if met by the region `'x`, proves that this type constraint is satisfied.",45,N],[4,"Cause","","NB: The variants in `Cause` are intentionally ordered. Lower values are preferred when it comes to error messages. Do not reorder willy nilly.",N,N],[13,"LiveVar","","point inserted because Local was live at the given Location",46,N],[13,"DropVar","","point inserted because Local was dropped at the given Location",46,N],[4,"RegionTest","","A \"test\" that can be applied to some \"subject region\" `'x`. These are used to describe type constraints. Tests do not presently affect the region values that get inferred for each variable; they only examine the results after inference.  This means they can conveniently include disjuction (\"a or b must be true\").",N,N],[13,"IsOutlivedByAnyRegionIn","","The subject region `'x` must by outlived by some region in the given set of regions.",47,N],[13,"IsOutlivedByAllRegionsIn","","The subject region `'x` must by outlived by all regions in the given set of regions.",47,N],[13,"Any","","Any of the given tests are true.",47,N],[13,"All","","All of the given tests are true.",47,N],[0,"annotation","","As part of the NLL unit tests, you can annotate a function with `#[rustc_regions]`, and we will emit information about the region inference context and -- in particular -- the external constraints that this region imposes on others. The methods in this file handle the part about dumping the inference context internal state.",N,N],[11,"annotate","","Write out our state into the `.mir` files.",43,[[["self"],["diagnosticbuilder"]]]],[0,"dump_mir","","As part of generating the regions, if you enable `-Zdump-mir=nll`, we will generate an annotated copy of the MIR that includes the state of region inference. This code handles emitting the region context internal state.",N,N],[17,"REGION_WIDTH","rustc_mir::borrow_check::nll::region_infer::dump_mir","",N,N],[11,"dump_mir","rustc_mir::borrow_check::nll::region_infer","Write out our state into the `.mir` files.",43,[[["self"],["write"]],["result"]]],[11,"for_each_constraint","","Debugging aid: Invokes the `with_msg` callback repeatedly with our internal region constraints.  These are dumped into the -Zdump-mir file so that we can figure out why the region inference resulted in the values that it did when debugging.",43,[[["self"],["fnmut"]],["result"]]],[0,"error_reporting","","",N,N],[4,"ConstraintCategory","rustc_mir::borrow_check::nll::region_infer::error_reporting","Constraints that are considered interesting can be categorized to determine why they are interesting. Order of variants indicates sort order of the category, thereby influencing diagnostic output.",N,N],[13,"Cast","","",48,N],[13,"Assignment","","",48,N],[13,"Return","","",48,N],[13,"CallArgument","","",48,N],[13,"Other","","",48,N],[13,"Boring","","",48,N],[4,"Trace","","",N,N],[13,"StartRegion","","",49,N],[13,"FromConstraint","","",49,N],[13,"NotVisited","","",49,N],[0,"region_name","","",N,N],[11,"give_region_a_name","rustc_mir::borrow_check::nll::region_infer","Maps from an internal MIR region vid to something that we can report to the user. In some cases, the region vids will map directly to lifetimes that the user has a name for (e.g., `'static`). But frequently they will not, in which case we have to find some way to identify the lifetime to the user. To that end, this function takes a \"diagnostic\" so that it can create auxiliary notes as needed.",43,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["usize"],["diagnosticbuilder"]],["internedstring"]]],[11,"give_name_from_error_region","","Check for the case where `fr` maps to something that the user has a name for. In that case, we'll be able to map `fr` to a `Region<'tcx>`, and that region will be one of named variants.",43,[[["self"],["tyctxt"],["defid"],["regionvid"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_anonymous_region_appears_in_arguments","","Find an argument that contains `fr` and label it with a fully elaborated type, returning something like `'1`. Result looks like:",43,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_we_can_match_hir_ty_from_argument","","",43,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["ty"],["usize"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_we_cannot_match_hir_ty","","Attempts to highlight the specific part of a type in an argument that has no type annotation. For example, we might produce an annotation like this:",43,[[["self"],["inferctxt"],["mir"],["regionvid"],["ty"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_we_can_match_hir_ty","","Attempts to highlight the specific part of a type annotation that contains the anonymous reference we want to give a name to. For example, we might produce an annotation like this:",43,[[["self"],["tyctxt"],["regionvid"],["ty"],["ty"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"match_adt_and_segment","","We've found an enum/struct/union type with the substitutions `substs` and -- in the HIR -- a path type with the final segment `last_segment`. Try to find a `'_` to highlight in the generic args (or, if not, to produce new zipped pairs of types+hir to search through).",43,[[["self"],["substs"],["regionvid"],["pathsegment"],["usize"],["diagnosticbuilder"],["vec"]],["option",["internedstring"]]]],[11,"try_match_adt_and_generic_args","","We've found an enum/struct/union type with the substitutions `substs` and -- in the HIR -- a path with the generic arguments `args`. If `needle_fr` appears in the args, return the `hir::Lifetime` that corresponds to it. If not, push onto `search_stack` the types+hir to search through.",43,[[["self"],["substs"],["regionvid"],["genericargs"],["vec"]],["option",["lifetime"]]]],[11,"give_name_if_anonymous_region_appears_in_upvars","","Find a closure upvar that contains `fr` and label it with a fully elaborated type, returning something like `'1`. Result looks like:",43,[[["self"],["tyctxt"],["mir"],["regionvid"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_anonymous_region_appears_in_output","","Check for arguments appearing in the (closure) return type. It must be a closure since, in a free fn, such an argument would have to either also appear in an argument (if using elision) or be early bound (named, not in argument).",43,[[["self"],["tyctxt"],["mir"],["regionvid"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"synthesize_region_name","","Create a synthetic region named `'1`, incrementing the counter.",43,[[["self"],["usize"]],["internedstring"]]],[0,"var_name","rustc_mir::borrow_check::nll::region_infer::error_reporting","",N,N],[11,"get_var_name_and_span_for_region","rustc_mir::borrow_check::nll::region_infer","",43,[[["self"],["tyctxt"],["mir"],["regionvid"]],["option"]]],[11,"get_upvar_index_for_region","","Search the upvars (if any) to find one that references fr. Return its index.",43,[[["self"],["tyctxt"],["regionvid"]],["option",["usize"]]]],[11,"get_upvar_name_and_span_for_region","","Given the index of an upvar, finds its name and the span from where it was declared.",43,N],[11,"get_argument_index_for_region","","Search the argument types for one that references fr (which should be a free region). Returns Some(_) with the index of the input if one is found.",43,[[["self"],["tyctxt"],["regionvid"]],["option",["usize"]]]],[11,"get_argument_name_and_span_for_region","","Given the index of an argument, finds its name (if any) and the span from where it was declared.",43,N],[11,"clone","rustc_mir::borrow_check::nll::region_infer::error_reporting","",48,[[["self"]],["constraintcategory"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",48,N],[11,"eq","","",48,[[["self"],["constraintcategory"]],["bool"]]],[11,"partial_cmp","","",48,[[["self"],["constraintcategory"]],["option",["ordering"]]]],[11,"cmp","","",48,[[["self"],["constraintcategory"]],["ordering"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"clone","","",49,[[["self"]],["trace"]]],[11,"eq","","",49,[[["self"],["trace"]],["bool"]]],[11,"ne","","",49,[[["self"],["trace"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",49,N],[11,"best_blame_constraint","rustc_mir::borrow_check::nll::region_infer","Tries to find the best constraint to blame for the fact that `R: from_region`, where `R` is some region that meets `target_test`. This works by following the constraint graph, creating a constraint path that forces `R` to outlive `from_region`, and then finding the best choices within that path to blame.",43,N],[11,"find_constraint_paths_between_regions","","Walks the graph of constraints (where `'a: 'b` is considered an edge `'a -> 'b`) to find all paths from `from_region` to `to_region`. The paths are accumulated into the vector `results`. The paths are stored as a series of `ConstraintIndex` values -- in other words, a list of edges.",43,N],[11,"constraint_is_interesting","","This function will return true if a constraint is interesting and false if a constraint is not. It is useful in filtering constraint paths to only interesting points.",43,[[["self"],["constraintindex"]],["bool"]]],[11,"classify_constraint","","This function classifies a constraint from a location.",43,N],[11,"report_error","","Report an error because the universal region `fr` was required to outlive `outlived_fr` but it is not known to do so. For example:",43,[[["self"],["mir"],["inferctxt"],["defid"],["regionvid"],["regionvid"],["vec"]]]],[11,"report_escaping_data_error","","",43,[[["self"],["mir"],["inferctxt"],["defid"],["regionvid"],["regionvid"],["constraintcategory"],["span"],["vec"]]]],[11,"report_general_error","","",43,[[["self"],["mir"],["inferctxt"],["defid"],["regionvid"],["bool"],["regionvid"],["bool"],["constraintcategory"],["span"],["vec"]]]],[11,"find_sub_region_live_at","","",43,[[["self"],["regionvid"],["location"]],["regionvid"]]],[11,"find_outlives_blame_span","","",43,[[["self"],["mir"],["regionvid"],["regionvid"]],["span"]]],[0,"graphviz","","This module provides linkage between RegionInferenceContext and libgraphviz traits, specialized to attaching borrowck analysis data to rendered labels.",N,N],[3,"RawConstraints","rustc_mir::borrow_check::nll::region_infer::graphviz","",N,N],[12,"regioncx","","",50,N],[3,"SccConstraints","","",N,N],[12,"regioncx","","",51,N],[12,"nodes_per_scc","","",51,N],[11,"dump_graphviz_raw_constraints","rustc_mir::borrow_check::nll::region_infer","Write out the region constraint graph.",43,[[["self"],["write"]],["result"]]],[11,"dump_graphviz_scc_constraints","","Write out the region constraint graph.",43,[[["self"],["write"]],["result"]]],[11,"graph_id","rustc_mir::borrow_check::nll::region_infer::graphviz","",50,[[["self"]],["id"]]],[11,"node_id","","",50,[[["self"],["regionvid"]],["id"]]],[11,"node_shape","","",50,[[["self"],["regionvid"]],["option",["labeltext"]]]],[11,"node_label","","",50,[[["self"],["regionvid"]],["labeltext"]]],[11,"edge_label","","",50,[[["self"],["outlivesconstraint"]],["labeltext"]]],[11,"nodes","","",50,[[["self"]],["nodes",["regionvid"]]]],[11,"edges","","",50,[[["self"]],["edges",["outlivesconstraint"]]]],[11,"source","","",50,[[["self"],["outlivesconstraint"]],["regionvid"]]],[11,"target","","",50,[[["self"],["outlivesconstraint"]],["regionvid"]]],[11,"graph_id","","",51,[[["self"]],["id"]]],[11,"node_id","","",51,[[["self"],["constraintsccindex"]],["id"]]],[11,"node_shape","","",51,[[["self"],["constraintsccindex"]],["option",["labeltext"]]]],[11,"node_label","","",51,[[["self"],["constraintsccindex"]],["labeltext"]]],[11,"nodes","","",51,[[["self"]],["nodes",["constraintsccindex"]]]],[11,"edges","","",51,[[["self"]],["edges"]]],[11,"source","","",51,N],[11,"target","","",51,N],[0,"values","rustc_mir::borrow_check::nll::region_infer","",N,N],[3,"RegionValueElements","rustc_mir::borrow_check::nll::region_infer::values","Maps between a `Location` and a `PointIndex` (and vice versa).",N,N],[12,"statements_before_block","","For each basic block, how many points are contained within?",52,N],[12,"num_points","","",52,N],[3,"PointIndex","","",N,N],[12,"0","","",53,N],[3,"PlaceholderIndex","","",N,N],[12,"0","","",54,N],[3,"LivenessValues","","When we initially compute liveness, we use a bit matrix storing points for each region-vid.",N,N],[12,"elements","","",55,N],[12,"points","","",55,N],[3,"RegionValues","","Stores the full values for a set of regions (in contrast to `LivenessValues`, which only stores those points in the where a region is live). The full value for a region may contain points in the CFG, but also free regions as well as bound universe placeholders.",N,N],[12,"elements","","",56,N],[12,"points","","",56,N],[12,"free_regions","","",56,N],[12,"placeholders","","Placeholders represent bound regions -- so something like `'a` in for<'a> fn(&'a u32)`.",56,N],[4,"RegionElement","","An individual element in a region value -- the value of a particular region variable consists of a set of these elements.",N,N],[13,"Location","","A point in the control-flow graph.",57,N],[13,"RootUniversalRegion","","A universally quantified region from the root universe (e.g., a lifetime parameter).",57,N],[13,"SubUniversalRegion","","A subuniverse from a subuniverse (e.g., instantiated from a `for<'a> fn(&'a u32)` type).",57,N],[5,"region_value_str","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[8,"ToElementIndex","","",N,N],[10,"add_to_row","","",58,[[["self"],["regionvalues"],["n"]],["bool"]]],[10,"contained_in_row","","",58,[[["self"],["regionvalues"],["n"]],["bool"]]],[11,"new","","",52,[[["mir"]],["self"]]],[11,"point_from_location","","Converts a `Location` into a `PointIndex`. O(1).",52,[[["self"],["location"]],["pointindex"]]],[11,"to_location","","Converts a `PointIndex` back to a location. O(N) where N is the number of blocks; could be faster if we ever cared.",52,[[["self"],["pointindex"]],["location"]]],[11,"clone","","",53,[[["self"]],["pointindex"]]],[11,"eq","","",53,[[["self"],["pointindex"]],["bool"]]],[11,"ne","","",53,[[["self"],["pointindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",53,N],[11,"hash","","",53,N],[11,"partial_cmp","","",53,[[["self"],["pointindex"]],["option",["ordering"]]]],[11,"lt","","",53,[[["self"],["pointindex"]],["bool"]]],[11,"le","","",53,[[["self"],["pointindex"]],["bool"]]],[11,"gt","","",53,[[["self"],["pointindex"]],["bool"]]],[11,"ge","","",53,[[["self"],["pointindex"]],["bool"]]],[11,"cmp","","",53,[[["self"],["pointindex"]],["ordering"]]],[11,"decode","","",53,[[["__d"]],["result",["pointindex"]]]],[11,"encode","","",53,[[["self"],["__s"]],["result"]]],[11,"new","","",53,[[["usize"]],["self"]]],[11,"index","","",53,[[["self"]],["usize"]]],[11,"steps_between","","",53,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",53,[[["self"]],["self"]]],[11,"replace_zero","","",53,[[["self"]],["self"]]],[11,"add_one","","",53,[[["self"]],["self"]]],[11,"sub_one","","",53,[[["self"]],["self"]]],[11,"add_usize","","",53,[[["self"],["usize"]],["option"]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"clone","","",54,[[["self"]],["placeholderindex"]]],[11,"eq","","",54,[[["self"],["placeholderindex"]],["bool"]]],[11,"ne","","",54,[[["self"],["placeholderindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",54,N],[11,"hash","","",54,N],[11,"partial_cmp","","",54,[[["self"],["placeholderindex"]],["option",["ordering"]]]],[11,"lt","","",54,[[["self"],["placeholderindex"]],["bool"]]],[11,"le","","",54,[[["self"],["placeholderindex"]],["bool"]]],[11,"gt","","",54,[[["self"],["placeholderindex"]],["bool"]]],[11,"ge","","",54,[[["self"],["placeholderindex"]],["bool"]]],[11,"cmp","","",54,[[["self"],["placeholderindex"]],["ordering"]]],[11,"decode","","",54,[[["__d"]],["result",["placeholderindex"]]]],[11,"encode","","",54,[[["self"],["__s"]],["result"]]],[11,"new","","",54,[[["usize"]],["self"]]],[11,"index","","",54,[[["self"]],["usize"]]],[11,"steps_between","","",54,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",54,[[["self"]],["self"]]],[11,"replace_zero","","",54,[[["self"]],["self"]]],[11,"add_one","","",54,[[["self"]],["self"]]],[11,"sub_one","","",54,[[["self"]],["self"]]],[11,"add_usize","","",54,[[["self"],["usize"]],["option"]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"clone","","",57,[[["self"]],["regionelement"]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"eq","","",57,[[["self"],["regionelement"]],["bool"]]],[11,"ne","","",57,[[["self"],["regionelement"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",57,N],[11,"hash","","",57,N],[11,"new","","Creates a new set of \"region values\" that tracks causal information. Each of the regions in num_region_variables will be initialized with an empty set of points and no causal information.",55,[[["rc"]],["self"]]],[11,"rows","","Iterate through each region that has a value in this set.",55,[[["self"]],[""]]],[11,"add_element","","Adds the given element to the value for the given region. Returns true if the element is newly added (i.e., was not already present).",55,[[["self"],["n"],["location"]],["bool"]]],[11,"add_all_points","","Adds all the control-flow points to the values for `r`.",55,[[["self"],["n"]]]],[11,"contains","","True if the region `r` contains the given element.",55,[[["self"],["n"],["location"]],["bool"]]],[11,"region_value_str","","Returns a \"pretty\" string value of the region. Meant for debugging.",55,[[["self"],["n"]],["string"]]],[11,"clone","","",56,[[["self"]],["regionvalues"]]],[11,"new","","Creates a new set of \"region values\" that tracks causal information. Each of the regions in num_region_variables will be initialized with an empty set of points and no causal information.",56,[[["rc"],["usize"],["universeindex"]],["self"]]],[11,"add_element","","Adds the given element to the value for the given region. Returns true if the element is newly added (i.e., was not already present).",56,N],[11,"add_all_points","","Adds all the control-flow points to the values for `r`.",56,[[["self"],["n"]]]],[11,"add_region","","Add all elements in `r_from` to `r_to` (because e.g. `r_to: r_from`).",56,[[["self"],["n"],["n"]],["bool"]]],[11,"contains","","True if the region `r` contains the given element.",56,N],[11,"merge_liveness","","`self[to] |= values[from]`, essentially: that is, take all the elements for the region `from` from `values` and add them to the region `to` in `self`.",56,[[["self"],["n"],["m"],["livenessvalues"]]]],[11,"contains_points","","True if `sup_region` contains all the CFG points that `sub_region` contains. Ignores universal regions.",56,[[["self"],["n"],["n"]],["bool"]]],[11,"locations_outlived_by","","Returns the locations contained within a given region `r`.",56,[[["self"],["n"]],[""]]],[11,"universal_regions_outlived_by","","Returns just the universal regions that are contained in a given region's value.",56,[[["self"],["n"]],[""]]],[11,"subuniverses_contained_in","","Returns all the elements contained in a given region's value.",56,[[["self"],["n"]],[""]]],[11,"elements_contained_in","","Returns all the elements contained in a given region's value.",56,[[["self"],["n"]],[""]]],[11,"region_value_str","","Returns a \"pretty\" string value of the region. Meant for debugging.",56,[[["self"],["n"]],["string"]]],[22,"","rustc_mir::borrow_check::nll::region_infer","",N,N],[8,"ClosureRegionRequirementsExt","","",N,N],[10,"apply_requirements","","",59,[[["self"],["tyctxt"],["location"],["defid"],["closuresubsts"]],["vec",["queryregionconstraint"]]]],[10,"subst_closure_mapping","","",59,[[["self"],["tyctxt"],["indexvec"],["t"]],["t"]]],[11,"clone","","",46,[[["self"]],["cause"]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",46,[[["self"],["cause"]],["option",["ordering"]]]],[11,"lt","","",46,[[["self"],["cause"]],["bool"]]],[11,"le","","",46,[[["self"],["cause"]],["bool"]]],[11,"gt","","",46,[[["self"],["cause"]],["bool"]]],[11,"ge","","",46,[[["self"],["cause"]],["bool"]]],[11,"cmp","","",46,[[["self"],["cause"]],["ordering"]]],[11,"eq","","",46,[[["self"],["cause"]],["bool"]]],[11,"ne","","",46,[[["self"],["cause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",46,N],[11,"clone","","",45,[[["self"]],["typetest"]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"clone","","",47,[[["self"]],["regiontest"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"new","","Creates a new region inference context with a total of `num_region_variables` valid inference variables; the first N of those will be constant regions representing the free regions defined in `universal_regions`.",43,[[["varinfos"],["rc",["universalregions"]],["rc",["universalregionrelations"]],["mir"],["constraintset"],["vec",["typetest"]],["livenessvalues",["regionvid"]],["rc"]],["self"]]],[11,"compute_scc_universes","","Each SCC is the combination of many region variables which have been equated. Therefore, we can associate a universe with each SCC which is minimum of all the universes of its constituent regions -- this is because whatever value the SCC takes on must be a value that each of the regions within the SCC could have as well. This implies that the SCC must have the minimum, or narrowest, universe.",43,[[["sccs"],["indexvec"]],["indexvec",["constraintsccindex","universeindex"]]]],[11,"init_free_and_bound_regions","","Initializes the region variables for each universally quantified region (lifetime parameter). The first N variables always correspond to the regions appearing in the function signature (both named and anonymous) and where clauses. This function iterates over those regions and initializes them with minimum values.",43,[[["self"]]]],[11,"regions","","Returns an iterator over all the region indices.",43,[[["self"]],[""]]],[11,"to_region_vid","","Given a universal region in scope on the MIR, returns the corresponding index.",43,[[["self"],["region"]],["regionvid"]]],[11,"region_contains","","Returns true if the region `r` contains the point `p`.",43,N],[11,"region_value_str","","Returns access to the value of `r` for debugging purposes.",43,[[["self"],["regionvid"]],["string"]]],[11,"region_universe","","Returns access to the value of `r` for debugging purposes.",43,[[["self"],["regionvid"]],["universeindex"]]],[11,"add_element_to_scc_of","","Adds `elem` to the value of the SCC in which `v` appears.",43,N],[11,"solve","","Perform region inference and report errors if we see any unsatisfiable constraints. If this is a closure, returns the region requirements to propagate to our creator, if any.",43,[[["self"],["inferctxt"],["mir"],["defid"],["vec"]],["option",["closureregionrequirements"]]]],[11,"solve_inner","","",43,[[["self"],["inferctxt"],["mir"],["defid"],["vec"]],["option",["closureregionrequirements"]]]],[11,"propagate_constraints","","Propagate the region constraints: this will grow the values for each region variable until all the constraints are satisfied. Note that some values may grow too large to be feasible, but we check this later.",43,[[["self"],["mir"]]]],[11,"propagate_constraint_sccs_if_new","","",43,[[["self"],["constraintsccindex"],["idxset"]]]],[11,"propagate_constraint_sccs_new","","",43,[[["self"],["constraintsccindex"],["idxset"]]]],[11,"universe_compatible","","True if all the elements in the value of `scc_b` are nameable in `scc_a`. Used during constraint propagation, and only once the value of `scc_b` has been computed.",43,[[["self"],["constraintsccindex"],["constraintsccindex"]],["bool"]]],[11,"check_type_tests","","Once regions have been propagated, this method is used to see whether the \"type tests\" produced by typeck were satisfied; type tests encode type-outlives relationships like `T: 'a`. See `TypeTest` for more details.",43,[[["self"],["inferctxt"],["mir"],["defid"],["option",["vec"]],["vec"]]]],[11,"to_error_region","","Converts a region inference variable into a `ty::Region` that we can use for error reporting. If `r` is universally bound, then we use the name that we have on record for it. If `r` is existentially bound, then we check its inferred value and try to find a good name from that. Returns `None` if we can't find one (e.g., this is just some random part of the CFG).",43,[[["self"],["regionvid"]],["option",["region"]]]],[11,"try_promote_type_test","","",43,[[["self"],["inferctxt"],["mir"],["typetest"],["vec"]],["bool"]]],[11,"try_promote_type_test_subject","","When we promote a type test `T: 'r`, we have to convert the type `T` into something we can store in a query result (so something allocated for `'gcx`). This is problematic if `ty` contains regions. During the course of NLL region checking, we will have replaced all of those regions with fresh inference variables. To create a test subject, we want to replace those inference variables with some region from the closure signature -- this is not always possible, so this is a fallible process. Presuming we do find a suitable region, we will represent it with a `ReClosureBound`, which is a `RegionKind` variant that can be allocated in the gcx.",43,[[["self"],["inferctxt"],["ty"]],["option",["closureoutlivessubject"]]]],[11,"non_local_universal_upper_bound","","Given some universal or existential region `r`, finds a non-local, universal region `r+` that outlives `r` at entry to (and exit from) the closure. In the worst case, this will be `'static`.",43,[[["self"],["regionvid"]],["regionvid"]]],[11,"universal_upper_bound","","Returns a universally quantified region that outlives the value of `r` (`r` may be existentially or universally quantified).",43,[[["self"],["regionvid"]],["regionvid"]]],[11,"eval_region_test","","Test if `test` is true when applied to `lower_bound` at `point`, and returns true or false.",43,[[["self"],["mir"],["regionvid"],["regiontest"]],["bool"]]],[11,"eval_outlives","","",43,[[["self"],["mir"],["regionvid"],["regionvid"]],["bool"]]],[11,"check_universal_regions","","Once regions have been propagated, this method is used to see whether any of the constraints were too strong. In particular, we want to check for a case where a universally quantified region exceeded its bounds.  Consider:",43,[[["self"],["inferctxt"],["mir"],["defid"],["option",["vec"]],["vec"]]]],[11,"check_universal_region","","Check the final value for the free region `fr` to see if it grew too large. In particular, examine what `end(X)` points wound up in `fr`'s final value; for each `end(X)` where `X != fr`, we want to check that `fr: X`. If not, that's either an error, or something we have to propagate to our creator.",43,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["option"],["vec"]]]],[11,"check_bound_universal_region","","",43,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["universeindex"]]]],[11,"new","","",44,[[["universeindex"],["regionvariableorigin"]],["self"]]],[0,"renumber","rustc_mir::borrow_check::nll","",N,N],[3,"NLLVisitor","rustc_mir::borrow_check::nll::renumber","",N,N],[12,"infcx","","",60,N],[5,"renumber_mir","","Replaces all free regions appearing in the MIR with fresh inference variables, returning the number of variables created.",N,[[["inferctxt"],["mir"]]]],[5,"renumber_regions","","Replaces all regions appearing in `value` with fresh inference variables.",N,[[["inferctxt"],["t"]],["t"]]],[11,"renumber_regions","","",60,[[["self"],["t"]],["t"]]],[11,"visit_ty","","",60,[[["self"],["ty"],["tycontext"]]]],[11,"visit_substs","","",60,[[["self"],["substs"],["location"]]]],[11,"visit_region","","",60,[[["self"],["region"],["location"]]]],[11,"visit_const","","",60,[[["self"],["const"],["location"]]]],[11,"visit_generator_substs","","",60,[[["self"],["generatorsubsts"],["location"]]]],[11,"visit_closure_substs","","",60,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_user_assert_ty","","",60,[[["self"],["canonicalty"],["local"],["location"]]]],[11,"visit_statement","","",60,[[["self"],["basicblock"],["statement"],["location"]]]],[0,"type_check","rustc_mir::borrow_check::nll","This pass type-checks the MIR to ensure it is not broken.",N,N],[3,"TypeVerifier","rustc_mir::borrow_check::nll::type_check","Verifies that MIR types are sane to not crash further checks.",N,N],[12,"cx","","",61,N],[12,"mir","","",61,N],[12,"last_span","","",61,N],[12,"mir_def_id","","",61,N],[12,"errors_reported","","",61,N],[3,"TypeChecker","","The MIR type checker. Visits the MIR and enforces all the constraints needed for it to be valid and well-typed. Along the way, it accrues region constraints -- these can later be used by NLL region checking.",N,N],[12,"infcx","","",62,N],[12,"param_env","","",62,N],[12,"last_span","","",62,N],[12,"mir","","",62,N],[12,"mir_def_id","","",62,N],[12,"region_bound_pairs","","",62,N],[12,"implicit_region_bound","","",62,N],[12,"reported_errors","","",62,N],[12,"borrowck_context","","",62,N],[3,"BorrowCheckContext","","",N,N],[12,"universal_regions","","",63,N],[12,"location_table","","",63,N],[12,"all_facts","","",63,N],[12,"borrow_set","","",63,N],[12,"constraints","","",63,N],[3,"MirTypeckRegionConstraints","","A collection of region constraints that must be satisfied for the program to be considered well-typed.",N,N],[12,"liveness_constraints","","In general, the type-checker is not responsible for enforcing liveness constraints; this job falls to the region inferencer, which performs a liveness analysis. However, in some limited cases, the MIR type-checker creates temporary regions that do not otherwise appear in the MIR -- in particular, the late-bound regions that it instantiates at call-sites -- and hence it must report on their liveness constraints.",64,N],[12,"outlives_constraints","","",64,N],[12,"type_tests","","",64,N],[3,"TypeckMir","","",N,N],[4,"FieldAccessError","","",N,N],[13,"OutOfRange","","",65,N],[12,"field_count","rustc_mir::borrow_check::nll::type_check::FieldAccessError","",65,N],[4,"Locations","rustc_mir::borrow_check::nll::type_check","The `Locations` type summarizes where region constraints are required to hold. Normally, this is at a particular point which created the obligation, but for constraints that the user gave, we want the constraint to hold at all points.",N,N],[13,"All","","Indicates that a type constraint should always be true. This is particularly important in the new borrowck analysis for things like the type of the return slot. Consider this example:",66,N],[13,"Boring","","A \"boring\" constraint (caused by the given location) is one that the user probably doesn't want to see described in diagnostics, because it is kind of an artifact of the type system setup.",66,N],[13,"Interesting","","An important outlives constraint (caused by the given location) is one that would be useful to highlight in diagnostics, because it represents a point where references flow from one spot to another (e.g., `x = y`)",66,N],[5,"type_check","","Type checks the given `mir` in the context of the inference context `infcx`. Returns any region constraints that have yet to be proven. This result is includes liveness constraints that ensure that regions appearing in the types of all local variables are live at all points where that local variable may later be used.",N,N],[5,"type_check_internal","","",N,N],[5,"mirbug","","",N,[[["tyctxt"],["span"],["str"]]]],[0,"constraint_conversion","","",N,N],[3,"ConstraintConversion","rustc_mir::borrow_check::nll::type_check::constraint_conversion","",N,N],[12,"tcx","","",67,N],[12,"universal_regions","","",67,N],[12,"location_table","","",67,N],[12,"region_bound_pairs","","",67,N],[12,"implicit_region_bound","","",67,N],[12,"param_env","","",67,N],[12,"locations","","",67,N],[12,"outlives_constraints","","",67,N],[12,"type_tests","","",67,N],[12,"all_facts","","",67,N],[11,"new","","",67,N],[11,"convert_all","","",67,N],[11,"convert","","",67,[[["self"],["queryregionconstraint"]]]],[11,"verify_to_type_test","","",67,[[["self"],["generickind"],["region"],["verifybound"]],["typetest"]]],[11,"verify_bound_to_region_test","","",67,[[["self"],["verifybound"]],["regiontest"]]],[11,"to_region_vid","","",67,[[["self"],["region"]],["regionvid"]]],[11,"add_outlives","","",67,[[["self"],["regionvid"],["regionvid"]]]],[11,"add_type_test","","",67,[[["self"],["typetest"]]]],[0,"free_region_relations","rustc_mir::borrow_check::nll::type_check","",N,N],[3,"UniversalRegionRelations","rustc_mir::borrow_check::nll::type_check::free_region_relations","",N,N],[12,"universal_regions","","",68,N],[12,"outlives","","Stores the outlives relations that are known to hold from the implied bounds, in-scope where clauses, and that sort of thing.",68,N],[12,"inverse_outlives","","This is the `<=` relation; that is, if `a: b`, then `b <= a`, and we store that here. This is useful when figuring out how to express some local region in terms of external regions our caller will understand.",68,N],[3,"CreateResult","","",N,N],[12,"universal_region_relations","","",69,N],[12,"region_bound_pairs","","",69,N],[12,"normalized_inputs_and_output","","",69,N],[3,"UniversalRegionRelationsBuilder","","",N,N],[12,"infcx","","",70,N],[12,"mir_def_id","","",70,N],[12,"mir_node_id","","",70,N],[12,"param_env","","",70,N],[12,"location_table","","",70,N],[12,"universal_regions","","",70,N],[12,"implicit_region_bound","","",70,N],[12,"constraints","","",70,N],[12,"all_facts","","",70,N],[12,"relations","","",70,N],[12,"region_bound_pairs","","",70,N],[5,"create","","",N,[[["inferctxt"],["defid"],["paramenv"],["locationtable"],["option",["region"]],["rc"],["mirtypeckregionconstraints"],["option"]],["createresult"]]],[6,"RegionBoundPairs","","Each RBP `('a, GK)` indicates that `GK: 'a` can be assumed to be true. These encode relationships like `T: 'a` that are added via implicit bounds.",N,N],[6,"NormalizedInputsAndOutput","","As part of computing the free region relations, we also have to normalize the input-output types, which we then need later. So we return those.  This vector consists of first the input types and then the output type as the last element.",N,N],[11,"fmt","","",68,[[["self"],["formatter"]],["result"]]],[11,"relate_universal_regions","","Records in the `outlives_relation` (and `inverse_outlives_relation`) that `fr_a: fr_b`. Invoked by the builder below.",68,[[["self"],["regionvid"],["regionvid"]]]],[11,"postdom_upper_bound","","Given two universal regions, returns the postdominating upper-bound (effectively the least upper bound).",68,[[["self"],["regionvid"],["regionvid"]],["regionvid"]]],[11,"non_local_upper_bound","","Finds an \"upper bound\" for `fr` that is not local. In other words, returns the smallest (*) known region `fr1` that (a) outlives `fr` and (b) is not local. This cannot fail, because we will always find `'static` at worst.",68,[[["self"],["regionvid"]],["regionvid"]]],[11,"non_local_lower_bound","","Finds a \"lower bound\" for `fr` that is not local. In other words, returns the largest (*) known region `fr1` that (a) is outlived by `fr` and (b) is not local. This cannot fail, because we will always find `'static` at worst.",68,[[["self"],["regionvid"]],["option",["regionvid"]]]],[11,"non_local_bound","","Helper for `non_local_upper_bound` and `non_local_lower_bound`.  Repeatedly invokes `postdom_parent` until we find something that is not local. Returns None if we never do so.",68,[[["self"],["transitiverelation"],["regionvid"]],["option",["regionvid"]]]],[11,"outlives","","True if fr1 is known to outlive fr2.",68,[[["self"],["regionvid"],["regionvid"]],["bool"]]],[11,"regions_outlived_by","","Returns a vector of free regions `x` such that `fr1: x` is known to hold.",68,[[["self"],["regionvid"]],["vec",["regionvid"]]]],[11,"create","","",70,[[["self"]],["createresult"]]],[11,"add_implied_bounds","","Update the type of a single local, which should represent either the return type of the MIR or one of its arguments. At the same time, compute and add any implied bounds that come from this local.",70,[[["self"],["ty"]]]],[11,"add_outlives_bounds","","Registers the `OutlivesBound` items from `outlives_bounds` in the outlives relation as well as the region-bound pairs listing.",70,[[["self"],["i"]]]],[11,"sub_free_regions","","",68,[[["self"],["region"],["region"]],["bool"]]],[0,"input_output","rustc_mir::borrow_check::nll::type_check","This module contains code to equate the input/output types appearing in the MIR with the expected input/output types from the function signature. This requires a bit of processing, as the expected types are supplied to us before normalization and may contain existential `impl Trait` instances. In contrast, the input/output types found in the MIR (specifically, in the special local variables for the `RETURN_PLACE` the MIR arguments) are always fully normalize (and contain revealed `impl Trait` values).",N,N],[3,"ObligationAccumulator","rustc_mir::borrow_check::nll::type_check::input_output","",N,N],[12,"obligations","","",71,N],[11,"equate_inputs_and_outputs","rustc_mir::borrow_check::nll::type_check","",62,N],[11,"equate_normalized_input_or_output","","",62,[[["self"],["ty"],["ty"]]]],[11,"fmt","rustc_mir::borrow_check::nll::type_check::input_output","",71,[[["self"],["formatter"]],["result"]]],[11,"default","","",71,[[],["obligationaccumulator"]]],[11,"add","","",71,[[["self"],["inferok"]],["t"]]],[11,"into_vec","","",71,[[["self"]],["predicateobligations"]]],[0,"liveness","rustc_mir::borrow_check::nll::type_check","",N,N],[3,"TypeLivenessGenerator","rustc_mir::borrow_check::nll::type_check::liveness","",N,N],[12,"cx","","",72,N],[12,"mir","","",72,N],[12,"liveness","","",72,N],[12,"flow_inits","","",72,N],[12,"move_data","","",72,N],[12,"drop_data","","",72,N],[12,"map","","",72,N],[3,"DropData","","",N,N],[12,"dropck_result","","",73,N],[12,"region_constraint_data","","",73,N],[5,"generate","","Combines liveness analysis with initialization analysis to determine which variables are live at which points, both due to ordinary uses and drops. Returns a set of (ty, location) pairs that indicate which types must be live at which point in the CFG. This vector is consumed by `constraint_generation`.",N,[[["typechecker"],["mir"],["livenessresults"],["flowatlocation"],["movedata"]]]],[11,"add_liveness_constraints","","Liveness constraints:",72,[[["self"],["basicblock"]]]],[11,"push_type_live_constraint","","Some variable with type `live_ty` is \"regular live\" at `location` -- i.e., it may be used later. This means that all regions appearing in the type `live_ty` must be live at `location`.",72,[[["typechecker"],["t"],["location"]]]],[11,"add_drop_live_constraint","","Some variable with type `live_ty` is \"drop live\" at `location` -- i.e., it may be dropped later. This means that some of the regions in its type must be live at `location`. The precise set will depend on the dropck constraints, and in particular this takes `#[may_dangle]` into account.",72,[[["self"],["localwithregion"],["ty"],["location"]]]],[11,"compute_drop_data","","",72,[[["typechecker"],["ty"]],["dropdata"]]],[0,"relate_tys","rustc_mir::borrow_check::nll::type_check","",N,N],[3,"TypeRelating","rustc_mir::borrow_check::nll::type_check::relate_tys","",N,N],[12,"infcx","","",74,N],[12,"ambient_variance","","How are we relating `a` and `b`?",74,N],[12,"a_scopes","","When we pass through a set of binders (e.g., when looking into a `fn` type), we push a new bound region scope onto here.  This will contain the instantiated region for each region in those binders. When we then encounter a `ReLateBound(d, br)`, we can use the debruijn index `d` to find the right scope, and then bound region name `br` to find the specific instantiation from within that scope. See `replace_bound_region`.",74,N],[12,"b_scopes","","Same as `a_scopes`, but for the `b` type.",74,N],[12,"locations","","Where (and why) is this relation taking place?",74,N],[12,"borrowck_context","","This will be `Some` when we are running the type check as part of NLL, and `None` if we are running a \"sanity check\".",74,N],[12,"canonical_var_values","","As we execute, the type on the LHS may come from a canonical source. In that case, we will sometimes find a constraint like `?0 = B`, where `B` is a type from the RHS. The first time we find that, we simply record `B` (and the list of scopes that tells us how to interpret `B`). The next time we encounter `?0`, then, we can read this value out and use it.",74,N],[3,"ScopesAndKind","","",N,N],[12,"scopes","","",75,N],[12,"kind","","",75,N],[3,"BoundRegionScope","","",N,N],[12,"map","","",76,N],[3,"UniversallyQuantified","","",N,N],[12,"0","","",77,N],[3,"ScopeInstantiator","","",N,N],[12,"infcx","","",78,N],[12,"target_index","","",78,N],[12,"universally_quantified","","",78,N],[12,"bound_region_scope","","",78,N],[5,"sub_types","","",N,[[["inferctxt"],["ty"],["ty"],["locations"],["option",["borrowcheckcontext"]]],["fallible"]]],[5,"eq_types","","",N,[[["inferctxt"],["ty"],["ty"],["locations"],["option",["borrowcheckcontext"]]],["fallible"]]],[5,"eq_canonical_type_and_type","","",N,[[["inferctxt"],["canonicalty"],["ty"],["locations"],["option",["borrowcheckcontext"]]],["fallible"]]],[11,"clone","","",75,[[["self"]],["scopesandkind"]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"clone","","",76,[[["self"]],["boundregionscope"]]],[11,"fmt","","",76,[[["self"],["formatter"]],["result"]]],[11,"default","","",76,[[],["boundregionscope"]]],[11,"clone","","",77,[[["self"]],["universallyquantified"]]],[11,"new","","",74,[[["inferctxt"],["variance"],["locations"],["option",["borrowcheckcontext"]],["canonicalvarinfos"]],["self"]]],[11,"ambient_covariance","","",74,[[["self"]],["bool"]]],[11,"ambient_contravariance","","",74,[[["self"]],["bool"]]],[11,"create_scope","","",74,[[["self"],["binder"],["universallyquantified"]],["boundregionscope"]]],[11,"replace_bound_region","","",74,N],[11,"push_outlives","","",74,[[["self"],["regionvid"],["regionvid"]]]],[11,"equate_var","","",74,[[["self"],["canonicalvar"],["kind"]],["relateresult",["kind"]]]],[11,"tcx","","",74,[[["self"]],["tyctxt"]]],[11,"tag","","",74,[[["self"]],["str"]]],[11,"a_is_expected","","",74,[[["self"]],["bool"]]],[11,"relate_with_variance","","",74,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",74,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",74,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",74,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[11,"visit_binder","","",78,[[["self"],["binder"]],["bool"]]],[11,"visit_region","","",78,[[["self"],["region"]],["bool"]]],[8,"AtLocation","rustc_mir::borrow_check::nll::type_check","",N,N],[10,"boring","","Indicates a \"boring\" constraint that the user probably woudln't want to see highlights.",79,[[["self"]],["locations"]]],[10,"interesting","","Indicates an \"interesting\" edge, which is of significance only for diagnostics.",79,[[["self"]],["locations"]]],[8,"NormalizeLocation","","",N,N],[10,"to_locations","","",80,[[["self"]],["locations"]]],[11,"visit_span","","",61,[[["self"],["span"]]]],[11,"visit_place","","",61,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_constant","","",61,[[["self"],["constant"],["location"]]]],[11,"visit_rvalue","","",61,[[["self"],["rvalue"],["location"]]]],[11,"visit_local_decl","","",61,[[["self"],["local"],["localdecl"]]]],[11,"visit_mir","","",61,[[["self"],["mir"]]]],[11,"new","","",61,[[["typechecker"],["mir"]],["self"]]],[11,"tcx","","",61,[[["self"]],["tyctxt"]]],[11,"sanitize_type","","",61,[[["self"],["debug"],["ty"]],["ty"]]],[11,"sanitize_constant","","Checks that the constant's `ty` field matches up with what would be expected from its literal.",61,[[["self"],["constant"],["location"]]]],[11,"sanitize_place","","Checks that the types internal to the `place` match up with what would be expected.",61,[[["self"],["place"],["location"],["placecontext"]],["placety"]]],[11,"sanitize_projection","","",61,[[["self"],["placety"],["placeelem"],["place"],["location"]],["placety"]]],[11,"error","","",61,[[["self"]],["ty"]]],[11,"field_ty","","",61,[[["self"],["debug"],["placety"],["field"],["location"]],["result",["ty","fieldaccesserror"]]]],[11,"clone","","",66,[[["self"]],["locations"]]],[11,"eq","","",66,[[["self"],["locations"]],["bool"]]],[11,"ne","","",66,[[["self"],["locations"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",66,N],[11,"partial_cmp","","",66,[[["self"],["locations"]],["option",["ordering"]]]],[11,"lt","","",66,[[["self"],["locations"]],["bool"]]],[11,"le","","",66,[[["self"],["locations"]],["bool"]]],[11,"gt","","",66,[[["self"],["locations"]],["bool"]]],[11,"ge","","",66,[[["self"],["locations"]],["bool"]]],[11,"cmp","","",66,[[["self"],["locations"]],["ordering"]]],[11,"hash","","",66,N],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"from_location","","",66,[[["self"]],["option",["location"]]]],[11,"span","","Gets a span representing the location.",66,[[["self"],["mir"]],["span"]]],[11,"new","","",62,N],[11,"fully_perform_op","","Given some operation `op` that manipulates types, proves predicates, or otherwise uses the inference context, executes `op` and then executes all the further obligations that `op` returns. This will yield a set of outlives constraints amongst regions which are extracted and stored as having occured at `locations`.",62,N],[11,"push_region_constraints","","",62,N],[11,"sub_types","","",62,[[["self"],["ty"],["ty"],["locations"]],["fallible"]]],[11,"eq_types","","",62,[[["self"],["ty"],["ty"],["locations"]],["fallible"]]],[11,"eq_canonical_type_and_type","","",62,[[["self"],["canonicalty"],["ty"],["locations"]],["fallible"]]],[11,"tcx","","",62,[[["self"]],["tyctxt"]]],[11,"check_stmt","","",62,[[["self"],["mir"],["statement"],["location"]]]],[11,"check_terminator","","",62,[[["self"],["mir"],["terminator"],["location"]]]],[11,"check_call_dest","","",62,[[["self"],["mir"],["terminator"],["fnsig"],["option"],["location"]]]],[11,"check_call_inputs","","",62,N],[11,"check_iscleanup","","",62,[[["self"],["mir"],["basicblockdata"]]]],[11,"assert_iscleanup","","",62,[[["self"],["mir"],["debug"],["basicblock"],["bool"]]]],[11,"check_local","","",62,[[["self"],["mir"],["local"],["localdecl"],["option"]]]],[11,"aggregate_field_ty","","",62,[[["self"],["aggregatekind"],["usize"],["location"]],["result",["ty","fieldaccesserror"]]]],[11,"check_rvalue","","",62,[[["self"],["mir"],["rvalue"],["location"]]]],[11,"check_aggregate_rvalue","","",62,N],[11,"add_reborrow_constraint","","Add the constraints that arise from a borrow expression `&'a P` at the location `L`.",62,[[["self"],["location"],["region"],["place"]]]],[11,"prove_aggregate_predicates","","",62,[[["self"],["aggregatekind"],["location"]]]],[11,"prove_trait_ref","","",62,[[["self"],["traitref"],["locations"]]]],[11,"normalize_and_prove_instantiated_predicates","","",62,[[["self"],["instantiatedpredicates"],["locations"]]]],[11,"prove_predicates","","",62,N],[11,"prove_predicate","","",62,[[["self"],["predicate"],["locations"]]]],[11,"typeck_mir","","",62,[[["self"],["mir"],["option",["vec"]]]]],[11,"normalize","","",62,N],[11,"run_pass","","",81,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"to_locations","","",66,[[["self"]],["locations"]]],[0,"universal_regions","rustc_mir::borrow_check::nll","Code to extract the universally quantified regions declared on a function and the relationships between them. For example:",N,N],[3,"UniversalRegions","rustc_mir::borrow_check::nll::universal_regions","",N,N],[12,"indices","","",82,N],[12,"fr_static","","The vid assigned to `'static`",82,N],[12,"fr_fn_body","","A special region vid created to represent the current MIR fn body.  It will outlive the entire CFG but it will not outlive any other universal regions.",82,N],[12,"first_extern_index","","We create region variables such that they are ordered by their `RegionClassification`. The first block are globals, then externals, then locals. So things from: - `FIRST_GLOBAL_INDEX..first_extern_index` are global; - `first_extern_index..first_local_index` are external; and - `first_local_index..num_universals` are local.",82,N],[12,"first_local_index","","See `first_extern_index`.",82,N],[12,"num_universals","","The total number of universal region variables instantiated.",82,N],[12,"defining_ty","","The \"defining\" type for this function, with all universal regions instantiated.  For a closure or generator, this is the closure type, but for a top-level function it's the `TyFnDef`.",82,N],[12,"unnormalized_output_ty","","The return type of this function, with all regions replaced by their universal `RegionVid` equivalents.",82,N],[12,"unnormalized_input_tys","","The fully liberated input types of this function, with all regions replaced by their universal `RegionVid` equivalents.",82,N],[12,"yield_ty","","",82,N],[3,"UniversalRegionIndices","","",N,N],[12,"indices","","For those regions that may appear in the parameter environment ('static and early-bound regions), we maintain a map from the `ty::Region` to the internal `RegionVid` we are using. This is used because trait matching and type-checking will feed us region constraints that reference those regions and we need to be able to map them our internal `RegionVid`. This is basically equivalent to a `Substs`, except that it also contains an entry for `ReStatic` -- it might be nice to just use a substs, and then handle `ReStatic` another way.",83,N],[3,"UniversalRegionsBuilder","","",N,N],[12,"infcx","","",84,N],[12,"mir_def_id","","",84,N],[12,"mir_hir_id","","",84,N],[12,"mir_node_id","","",84,N],[12,"param_env","","",84,N],[4,"DefiningTy","","The \"defining type\" for this MIR. The key feature of the \"defining type\" is that it contains the information needed to derive all the universal regions that are in scope as well as the types of the inputs/output from the MIR. In general, early-bound universal regions appear free in the defining type and late-bound regions appear bound in the signature.",N,N],[13,"Closure","","The MIR is a closure. The signature is found via `ClosureSubsts::closure_sig_ty`.",85,N],[13,"Generator","","The MIR is a generator. The signature is that generators take no parameters and return the result of `ClosureSubsts::generator_return_ty`.",85,N],[13,"FnDef","","The MIR is a fn item with the given def-id and substs. The signature of the function can be bound then with the `fn_sig` query.",85,N],[13,"Const","","The MIR represents some form of constant. The signature then is that it has no inputs and a single return value, which is the value of the constant.",85,N],[4,"RegionClassification","","",N,N],[13,"Global","","A global region is one that can be named from anywhere. There is only one, `'static`.",86,N],[13,"External","","An external region is only relevant for closures. In that case, it refers to regions that are free in the closure type -- basically, something bound in the surrounding context.",86,N],[13,"Local","","A local lifetime is one about which we know the full set of relevant constraints (that is, relationships to other named regions).  For a closure, this includes any region bound in the closure's signature.  For a fn item, this includes all regions other than global ones.",86,N],[5,"for_each_late_bound_region_defined_on","","Iterates over the late-bound regions defined on fn_def_id and invokes `f` with the liberated form of each one.",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"FIRST_GLOBAL_INDEX","","",N,N],[17,"FR","","",N,N],[8,"InferCtxtExt","","",N,N],[10,"replace_free_regions_with_nll_infer_vars","","",87,[[["self"],["nllregionvariableorigin"],["t"]],["t"]]],[10,"replace_bound_regions_with_nll_infer_vars","","",87,[[["self"],["nllregionvariableorigin"],["defid"],["binder"],["universalregionindices"]],["t"]]],[10,"replace_late_bound_regions_with_nll_infer_vars","","",87,[[["self"],["defid"],["universalregionindices"]]]],[11,"fmt","","",82,[[["self"],["formatter"]],["result"]]],[11,"clone","","",85,[[["self"]],["definingty"]]],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"upvar_tys","","Returns a list of all the upvar types for this MIR. If this is not a closure or generator, there are no upvars, and hence it will be an empty list. The order of types in this list will match up with the `upvar_decls` field of `Mir`.",85,[[["self"],["tyctxt"]],[""]]],[11,"implicit_inputs","","Number of implicit inputs -- notably the \"environment\" parameter for closures -- that appear in MIR but not in the user's code.",85,[[["self"]],["usize"]]],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"clone","","",86,[[["self"]],["regionclassification"]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"eq","","",86,[[["self"],["regionclassification"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",86,N],[11,"hash","","",86,N],[11,"new","","Creates a new and fully initialized `UniversalRegions` that contains indices for all the free regions found in the given MIR -- that is, all the regions that appear in the function's signature. This will also compute the relationships that are known between those regions.",82,[[["inferctxt"],["defid"],["paramenv"]],["self"]]],[11,"closure_mapping","","Given a reference to a closure type, extracts all the values from its free regions and returns a vector with them. This is used when the closure's creator checks that the `ClosureRegionRequirements` are met. The requirements from `ClosureRegionRequirements` are expressed in terms of `RegionVid` entries that map into the returned vector `V`: so if the `ClosureRegionRequirements` contains something like `'1: '2`, then the caller would impose the constraint that `V[1]: V[2]`.",82,[[["tyctxt"],["ty"],["usize"],["defid"]],["indexvec",["regionvid","region"]]]],[11,"is_universal_region","","True if `r` is a member of this set of universal regions.",82,[[["self"],["regionvid"]],["bool"]]],[11,"region_classification","","Classifies `r` as a universal region, returning `None` if this is not a member of this set of universal regions.",82,[[["self"],["regionvid"]],["option",["regionclassification"]]]],[11,"universal_regions","","Returns an iterator over all the RegionVids corresponding to universally quantified free regions.",82,[[["self"]],[""]]],[11,"is_local_free_region","","True if `r` is classified as an local region.",82,[[["self"],["regionvid"]],["bool"]]],[11,"len","","Returns the number of universal regions created in any category.",82,[[["self"]],["usize"]]],[11,"num_global_and_external_regions","","Returns the number of global plus external universal regions. For closures, these are the regions that appear free in the closure type (versus those bound in the closure signature). They are therefore the regions between which the closure may impose constraints that its creator must verify.",82,[[["self"]],["usize"]]],[11,"named_universal_regions","","Get an iterator over all the early-bound regions that have names.",82,[[["self"]],[""]]],[11,"to_region_vid","","See `UniversalRegionIndices::to_region_vid`.",82,[[["self"],["region"]],["regionvid"]]],[11,"build","","",84,[[["self"]],["universalregions"]]],[11,"defining_ty","","Returns the \"defining type\" of the current MIR; see `DefiningTy` for details.",84,[[["self"]],["definingty"]]],[11,"compute_indices","","Builds a hashmap that maps from the universal regions that are in scope (as a `ty::Region<'tcx>`) to their indices (as a `RegionVid`). The map returned by this function contains only the early-bound regions.",84,[[["self"],["regionvid"],["definingty"]],["universalregionindices"]]],[11,"compute_inputs_and_output","","",84,[[["self"],["universalregionindices"],["definingty"]],["binder",["slice"]]]],[11,"insert_late_bound_region","","Initially, the `UniversalRegionIndices` map contains only the early-bound regions in scope. Once that is all setup, we come in later and instantiate the late-bound regions, and then we insert the `ReFree` version of those into the map as well. These are used for error reporting.",83,[[["self"],["region"],["regionvid"]]]],[11,"to_region_vid","","Converts `r` into a local inference variable: `r` can either by a `ReVar` (i.e., already a reference to an inference variable) or it can be `'static` or some early-bound region. This is useful when taking the results from type-checking and trait-matching, which may sometimes reference those regions from the `ParamEnv`. It is also used during initialization. Relies on the `indices` map having been fully initialized.",83,[[["self"],["region"]],["regionvid"]]],[11,"fold_to_region_vids","","Replace all free regions in `value` with region vids, as returned by `to_region_vid`.",83,[[["self"],["tyctxt"],["t"]],["t"]]],[0,"liveness_map","rustc_mir::borrow_check::nll","For the NLL computation, we need to compute liveness, but only for those local variables whose types contain regions. The others are not of interest to us. This file defines a new index type (LocalWithRegion) that indexes into a list of \"variables whose type contain regions\". It also defines a map from Local to LocalWithRegion and vice versa -- this map can be given to the liveness code so that it only operates over variables with regions in their types, instead of all variables.",N,N],[3,"NllLivenessMap","rustc_mir::borrow_check::nll::liveness_map","Map between Local and LocalWithRegion indices: this map is supplied to the liveness code so that it will only analyze those variables whose types contain regions.",N,N],[12,"from_local","","For each local variable, contains either None (if the type has no regions) or Some(i) with a suitable index.",88,N],[12,"to_local","","For each LocalWithRegion, maps back to the original Local index.",88,N],[3,"LocalWithRegion","","",N,N],[12,"0","","",89,N],[11,"from_local","","",88,[[["self"],["local"]],["option"]]],[11,"from_live_var","","",88,N],[11,"num_variables","","",88,[[["self"]],["usize"]]],[11,"compute","","Iterates over the variables in Mir and assigns each Local whose type contains regions a LocalWithRegion index. Returns a map for converting back and forth.",88,[[["mir"]],["self"]]],[11,"clone","","",89,[[["self"]],["localwithregion"]]],[11,"eq","","",89,[[["self"],["localwithregion"]],["bool"]]],[11,"ne","","",89,[[["self"],["localwithregion"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",89,N],[11,"hash","","",89,N],[11,"partial_cmp","","",89,[[["self"],["localwithregion"]],["option",["ordering"]]]],[11,"lt","","",89,[[["self"],["localwithregion"]],["bool"]]],[11,"le","","",89,[[["self"],["localwithregion"]],["bool"]]],[11,"gt","","",89,[[["self"],["localwithregion"]],["bool"]]],[11,"ge","","",89,[[["self"],["localwithregion"]],["bool"]]],[11,"cmp","","",89,[[["self"],["localwithregion"]],["ordering"]]],[11,"decode","","",89,[[["__d"]],["result",["localwithregion"]]]],[11,"encode","","",89,[[["self"],["__s"]],["result"]]],[11,"new","","",89,[[["usize"]],["self"]]],[11,"index","","",89,[[["self"]],["usize"]]],[11,"steps_between","","",89,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",89,[[["self"]],["self"]]],[11,"replace_zero","","",89,[[["self"]],["self"]]],[11,"add_one","","",89,[[["self"]],["self"]]],[11,"sub_one","","",89,[[["self"]],["self"]]],[11,"add_usize","","",89,[[["self"],["usize"]],["option"]]],[11,"fmt","","",89,[[["self"],["formatter"]],["result"]]],[0,"constraints","rustc_mir::borrow_check::nll","",N,N],[3,"ConstraintSet","rustc_mir::borrow_check::nll::constraints","",N,N],[12,"constraints","","",90,N],[3,"OutlivesConstraint","","",N,N],[12,"sup","","The region SUP must outlive SUB...",91,N],[12,"sub","","Region that must be outlived.",91,N],[12,"locations","","Where did this constraint arise?",91,N],[3,"ConstraintIndex","","",N,N],[12,"0","","",92,N],[3,"ConstraintSccIndex","","",N,N],[12,"0","","",93,N],[0,"graph","","",N,N],[3,"ConstraintGraph","rustc_mir::borrow_check::nll::constraints::graph","",N,N],[12,"first_constraints","","",94,N],[12,"next_constraints","","",94,N],[3,"Edges","","",N,N],[12,"graph","","",95,N],[12,"pointer","","",95,N],[3,"RegionGraph","","",N,N],[12,"set","","",96,N],[12,"constraint_graph","","",96,N],[3,"Successors","","",N,N],[12,"set","","",97,N],[12,"edges","","",97,N],[11,"new","","Create a \"dependency graph\" where each region constraint `R1: R2` is treated as an edge `R1 -> R2`. We use this graph to construct SCCs for region inference but also for error reporting.",94,[[["constraintset"],["usize"]],["self"]]],[11,"outgoing_edges","","Given a region `R`, iterate over all constraints `R: R1`.",94,[[["self"],["regionvid"]],["edges"]]],[11,"next","","",95,[[["self"]],["option"]]],[11,"new","","Create a \"dependency graph\" where each region constraint `R1: R2` is treated as an edge `R1 -> R2`. We use this graph to construct SCCs for region inference but also for error reporting.",96,[[["constraintset"],["constraintgraph"]],["self"]]],[11,"sub_regions","","Given a region `R`, iterate over all regions `R1` such that there exists a constraint `R: R1`.",96,[[["self"],["regionvid"]],["successors"]]],[11,"next","","",97,[[["self"]],["option"]]],[11,"num_nodes","","",96,[[["self"]],["usize"]]],[11,"successors","","",96,N],[11,"clone","rustc_mir::borrow_check::nll::constraints","",90,[[["self"]],["constraintset"]]],[11,"default","","",90,[[],["constraintset"]]],[11,"push","","",90,[[["self"],["outlivesconstraint"]]]],[11,"graph","","Constructs a graph from the constraint set; the graph makes it easy to find the constraints affecting a particular region (you should not mutate the set once this graph is constructed).",90,[[["self"],["usize"]],["constraintgraph"]]],[11,"compute_sccs","","Compute cycles (SCCs) in the graph of regions. In particular, find all regions R1, R2 such that R1: R2 and R2: R1 and group them into an SCC, and find the relationships between SCCs.",90,[[["self"],["constraintgraph"]],["sccs",["regionvid","constraintsccindex"]]]],[11,"deref","","",90,N],[11,"clone","","",91,[[["self"]],["outlivesconstraint"]]],[11,"eq","","",91,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"ne","","",91,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",91,N],[11,"partial_cmp","","",91,[[["self"],["outlivesconstraint"]],["option",["ordering"]]]],[11,"lt","","",91,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"le","","",91,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"gt","","",91,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"ge","","",91,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"cmp","","",91,[[["self"],["outlivesconstraint"]],["ordering"]]],[11,"hash","","",91,N],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"clone","","",92,[[["self"]],["constraintindex"]]],[11,"eq","","",92,[[["self"],["constraintindex"]],["bool"]]],[11,"ne","","",92,[[["self"],["constraintindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",92,N],[11,"hash","","",92,N],[11,"partial_cmp","","",92,[[["self"],["constraintindex"]],["option",["ordering"]]]],[11,"lt","","",92,[[["self"],["constraintindex"]],["bool"]]],[11,"le","","",92,[[["self"],["constraintindex"]],["bool"]]],[11,"gt","","",92,[[["self"],["constraintindex"]],["bool"]]],[11,"ge","","",92,[[["self"],["constraintindex"]],["bool"]]],[11,"cmp","","",92,[[["self"],["constraintindex"]],["ordering"]]],[11,"decode","","",92,[[["__d"]],["result",["constraintindex"]]]],[11,"encode","","",92,[[["self"],["__s"]],["result"]]],[11,"new","","",92,[[["usize"]],["self"]]],[11,"index","","",92,[[["self"]],["usize"]]],[11,"steps_between","","",92,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",92,[[["self"]],["self"]]],[11,"replace_zero","","",92,[[["self"]],["self"]]],[11,"add_one","","",92,[[["self"]],["self"]]],[11,"sub_one","","",92,[[["self"]],["self"]]],[11,"add_usize","","",92,[[["self"],["usize"]],["option"]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"clone","","",93,[[["self"]],["constraintsccindex"]]],[11,"eq","","",93,[[["self"],["constraintsccindex"]],["bool"]]],[11,"ne","","",93,[[["self"],["constraintsccindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",93,N],[11,"hash","","",93,N],[11,"partial_cmp","","",93,[[["self"],["constraintsccindex"]],["option",["ordering"]]]],[11,"lt","","",93,[[["self"],["constraintsccindex"]],["bool"]]],[11,"le","","",93,[[["self"],["constraintsccindex"]],["bool"]]],[11,"gt","","",93,[[["self"],["constraintsccindex"]],["bool"]]],[11,"ge","","",93,[[["self"],["constraintsccindex"]],["bool"]]],[11,"cmp","","",93,[[["self"],["constraintsccindex"]],["ordering"]]],[11,"decode","","",93,[[["__d"]],["result",["constraintsccindex"]]]],[11,"encode","","",93,[[["self"],["__s"]],["result"]]],[11,"new","","",93,[[["usize"]],["self"]]],[11,"index","","",93,[[["self"]],["usize"]]],[11,"steps_between","","",93,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",93,[[["self"]],["self"]]],[11,"replace_zero","","",93,[[["self"]],["self"]]],[11,"add_one","","",93,[[["self"]],["self"]]],[11,"sub_one","","",93,[[["self"]],["self"]]],[11,"add_usize","","",93,[[["self"],["usize"]],["option"]]],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[8,"ToRegionVid","rustc_mir::borrow_check::nll","Right now, we piggy back on the `ReVar` to store our NLL inference regions. These are indexed with `RegionVid`. This method will assert that the region is a `ReVar` and extract its internal index. This is reasonable because in our MIR we replace all universal regions with inference variables.",N,N],[10,"to_region_vid","","",98,[[["self"]],["regionvid"]]],[11,"mir","rustc_mir::borrow_check","",0,[[["self"]],["mir"]]],[11,"visit_block_entry","","",0,N],[11,"visit_statement_entry","","",0,N],[11,"visit_terminator_entry","","",0,N],[11,"clone","","",4,[[["self"]],["mutatemode"]]],[11,"eq","","",4,[[["self"],["mutatemode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",5,[[["self"]],["artificialfield"]]],[11,"eq","","",5,[[["self"],["artificialfield"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"clone","","",6,[[["self"]],["shallowordeep"]]],[11,"eq","","",6,[[["self"],["shallowordeep"]],["bool"]]],[11,"ne","","",6,[[["self"],["shallowordeep"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"clone","","",7,[[["self"]],["readorwrite"]]],[11,"eq","","",7,[[["self"],["readorwrite"]],["bool"]]],[11,"ne","","",7,[[["self"],["readorwrite"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["readkind"]]],[11,"eq","","",8,[[["self"],["readkind"]],["bool"]]],[11,"ne","","",8,[[["self"],["readkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"clone","","",9,[[["self"]],["writekind"]]],[11,"eq","","",9,[[["self"],["writekind"]],["bool"]]],[11,"ne","","",9,[[["self"],["writekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"clone","","",10,[[["self"]],["localmutationisallowed"]]],[11,"eq","","",10,[[["self"],["localmutationisallowed"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"clone","","",11,[[["self"]],["initializationrequiringaction"]]],[11,"as_noun","","",11,[[["self"]],["str"]]],[11,"as_verb_in_past_tense","","",11,[[["self"]],["str"]]],[11,"visit_terminator_drop","","Invokes `access_place` as appropriate for dropping the value at `drop_place`. Note that the actual `Drop` in the MIR is always for a variable (e.g., `Drop(x)`) -- but we recursively break this variable down into subpaths (e.g., `Drop(x.foo)`) to indicate more precisely which fields might actually be accessed by a destructor.",0,[[["self"],["location"],["terminator"],["flows"],["place"],["ty"],["span"]]]],[11,"access_place","","Checks an access to the given place to see if it is allowed. Examines the set of borrows that are in scope, as well as which paths have been initialized, to ensure that (a) the place is initialized and (b) it is not borrowed in some way that would prevent this access.",0,N],[11,"check_access_for_conflict","","",0,N],[11,"mutate_place","","",0,N],[11,"consume_rvalue","","",0,N],[11,"consume_operand","","",0,N],[11,"check_for_invalidation_at_exit","","Returns whether a borrow of this place is invalidated when the function exits",0,[[["self"],["context"],["borrowdata"],["span"]]]],[11,"check_for_local_borrow","","Reports an error if this is a borrow of local data. This is called for all Yield statements on movable generators",0,[[["self"],["borrowdata"],["span"]]]],[11,"check_activations","","",0,[[["self"],["location"],["span"],["flows"]]]],[11,"check_if_reassignment_to_immutable_state","","",0,N],[11,"check_if_full_path_is_moved","","",0,N],[11,"check_if_path_or_subpath_is_moved","","",0,N],[11,"move_path_closest_to","","Currently MoveData does not store entries for all places in the input MIR. For example it will currently filter out places that are Copy; thus we do not track places of shared reference type. This routine will walk up a place along its prefixes, searching for a foundational place that is tracked in the MoveData.",0,[[["self"],["place"]],["result",["movepathindex","nomovepathfound"]]]],[11,"move_path_for_place","","",0,[[["self"],["place"]],["option",["movepathindex"]]]],[11,"check_if_assigned_path_is_moved","","",0,N],[11,"check_access_permissions","","Check the permissions for the given place and read or write kind",0,N],[11,"add_used_mut","","Adds the place into the used mutable variables set",0,[[["self"],["rootplace"],["flows"]]]],[11,"is_mutable","","Whether this value be written or borrowed mutably. Returns the root place if the place passed in is a projection.",0,[[["self"],["place"],["localmutationisallowed"]],["result",["rootplace","place"]]]],[11,"clone","","",12,[[["self"]],["nomovepathfound"]]],[11,"eq","","",12,[[["self"],["nomovepathfound"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"base_path","","Returns the base of the leftmost (deepest) dereference of an Box in `place`. If there is no dereference of an Box in `place`, then it just returns `place` itself.",0,[[["self"],["place"]],["place"]]],[11,"clone","","",3,[[["self"]],["context"]]],[11,"eq","","",3,[[["self"],["context"]],["bool"]]],[11,"ne","","",3,[[["self"],["context"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",14,[[["self"]],["contextkind"]]],[11,"eq","","",14,[[["self"],["contextkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",14,N],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"new","","",14,[[["self"],["location"]],["context"]]],[0,"build","rustc_mir","",N,N],[3,"GlobalizeMir","rustc_mir::build","A pass to lift all the types and substitutions in a Mir to the global tcx. Sadly, we don't have a \"folder\" that can change 'tcx so we have to transmute afterwards.",N,N],[12,"tcx","","",99,N],[12,"span","","",99,N],[3,"Builder","","",N,N],[12,"hir","","",100,N],[12,"cfg","","",100,N],[12,"fn_span","","",100,N],[12,"arg_count","","",100,N],[12,"scopes","","the current set of scopes, updated as we traverse; see the `scope` module for more details",100,N],[12,"unpushed_unsafe","","The current unsafe block in scope, even if it is hidden by a PushUnsafeBlock",100,N],[12,"push_unsafe_count","","The number of `push_unsafe_block` levels in scope",100,N],[12,"breakable_scopes","","the current set of breakables; see the `scope` module for more details",100,N],[12,"source_scopes","","the vector of all scopes that we have created thus far; we track this for debuginfo later",100,N],[12,"source_scope_local_data","","",100,N],[12,"source_scope","","",100,N],[12,"guard_context","","the guard-context: each time we build the guard expression for a match arm, we push onto this stack, and then pop when we finish building it.",100,N],[12,"var_indices","","Maps node ids of variable bindings to the `Local`s created for them. (A match binding can have two locals; the 2nd is for the arm's guard.)",100,N],[12,"local_decls","","",100,N],[12,"upvar_decls","","",100,N],[12,"unit_temp","","",100,N],[12,"cached_resume_block","","cached block with the RESUME terminator; this is created when first set of cleanups are built.",100,N],[12,"cached_return_block","","cached block with the RETURN terminator",100,N],[12,"cached_unreachable_block","","cached block with the UNREACHABLE terminator",100,N],[3,"GuardFrameLocal","","",N,N],[12,"id","","",101,N],[3,"GuardFrame","","",N,N],[12,"locals","","These are the id's of names that are bound by patterns of the arm of this guard.",102,N],[3,"CFG","","",N,N],[12,"basic_blocks","","",103,N],[3,"ScopeId","","",N,N],[12,"0","","",104,N],[3,"BlockAnd","","The `BlockAnd` \"monad\" packages up the new basic block along with a produced value (sometimes just unit, of course). The `unpack!` macro (and methods below) makes working with `BlockAnd` much more convenient.",N,N],[12,"0","","",105,N],[12,"1","","",105,N],[3,"ImplicitSelfBinding","","the main entry point for building MIR for a function",N,N],[3,"ArgInfo","","",N,N],[12,"0","","",106,N],[12,"1","","",106,N],[12,"2","","",106,N],[12,"3","","",106,N],[4,"LocalsForNode","","",N,N],[13,"One","","In the usual case, a node-id for an identifier maps to at most one Local declaration.",107,N],[13,"ForGuard","","The exceptional case is identifiers in a match arm's pattern that are referenced in a guard of that match arm. For these, we can have `2+k` Locals, where `k` is the number of candidate patterns (separated by `|`) in the arm.",107,N],[12,"vals_for_guard","rustc_mir::build::LocalsForNode","",107,N],[12,"ref_for_guard","","",107,N],[12,"for_arm_body","","",107,N],[4,"ForGuard","rustc_mir::build","ForGuard indicates whether we are talking about: 1. the temp for a local binding used solely within guard expressions, 2. the temp that holds reference to (1.), which is actually what the    guard expressions see, or 3. the temp for use outside of guard expressions.",N,N],[13,"ValWithinGuard","","The `usize` identifies for which candidate pattern we want the local binding. We keep a temp per-candidate to accommodate two-phase borrows (see `LocalsForNode` documentation).",108,N],[13,"RefWithinGuard","","",108,N],[13,"OutsideGuard","","",108,N],[5,"mir_build","","Construct the MIR for a given def-id.",N,[[["tyctxt"],["defid"]],["mir"]]],[5,"create_constructor_shim","","",N,[[["tyctxt"],["nodeid"],["variantdata"]],["mir"]]],[5,"liberated_closure_env_ty","","",N,[[["tyctxt"],["nodeid"],["bodyid"]],["ty"]]],[5,"should_abort_on_panic","","",N,[[["tyctxt"],["defid"],["abi"]],["bool"]]],[5,"construct_fn","","",N,[[["cx"],["nodeid"],["a"],["safety"],["abi"],["ty"],["option",["ty"]],["body"]],["mir"]]],[5,"construct_const","","",N,[[["cx"],["bodyid"]],["mir"]]],[5,"construct_error","","",N,[[["cx"],["bodyid"]],["mir"]]],[0,"block","","",N,N],[11,"ast_block","","",100,[[["self"],["place"],["basicblock"],["block"],["sourceinfo"]],["blockand"]]],[11,"ast_block_stmts","","",100,[[["self"],["place"],["basicblock"],["span"],["vec",["stmtref"]],["option",["exprref"]],["blocksafety"]],["blockand"]]],[11,"update_source_scope_for_safety_mode","","If we are changing the safety mode, create a new source scope",100,[[["self"],["span"],["blocksafety"]]]],[0,"cfg","","Routines for manipulating the control-flow graph.",N,N],[11,"block_data","","",103,[[["self"],["basicblock"]],["basicblockdata"]]],[11,"block_data_mut","","",103,[[["self"],["basicblock"]],["basicblockdata"]]],[11,"start_new_block","","",103,[[["self"]],["basicblock"]]],[11,"start_new_cleanup_block","","",103,[[["self"]],["basicblock"]]],[11,"push","","",103,[[["self"],["basicblock"],["statement"]]]],[11,"push_end_region","","",103,[[["self"],["tyctxt"],["basicblock"],["sourceinfo"],["scope"]]]],[11,"push_assign","","",103,[[["self"],["basicblock"],["sourceinfo"],["place"],["rvalue"]]]],[11,"push_assign_constant","","",103,[[["self"],["basicblock"],["sourceinfo"],["place"],["constant"]]]],[11,"push_assign_unit","","",103,[[["self"],["basicblock"],["sourceinfo"],["place"]]]],[11,"terminate","","",103,[[["self"],["basicblock"],["sourceinfo"],["terminatorkind"]]]],[0,"expr","","Builds MIR from expressions. As a caller into this module, you have many options, but the first thing you have to decide is whether you are evaluating this expression for its value, its location, or as a constant.",N,N],[0,"as_constant","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_constant","rustc_mir::build","Compile `expr`, yielding a compile-time constant. Assumes that `expr` is a valid compile-time constant!",100,[[["self"],["m"]],["constant"]]],[11,"expr_as_constant","","",100,[[["self"],["expr"]],["constant"]]],[0,"as_place","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_place","rustc_mir::build","Compile `expr`, yielding a place that we can move from etc.",100,[[["self"],["basicblock"],["m"]],["blockand",["place"]]]],[11,"expr_as_place","","",100,[[["self"],["basicblock"],["expr"]],["blockand",["place"]]]],[0,"as_rvalue","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_local_rvalue","rustc_mir::build","See comment on `as_local_operand`",100,[[["self"],["basicblock"],["m"]],["blockand",["rvalue"]]]],[11,"as_rvalue","","Compile `expr`, yielding an rvalue.",100,[[["self"],["basicblock"],["option",["scope"]],["m"]],["blockand",["rvalue"]]]],[11,"expr_as_rvalue","","",100,[[["self"],["basicblock"],["option",["scope"]],["expr"]],["blockand",["rvalue"]]]],[11,"build_binary_op","","",100,[[["self"],["basicblock"],["binop"],["span"],["ty"],["operand"],["operand"]],["blockand",["rvalue"]]]],[11,"limit_capture_mutability","","",100,[[["self"],["span"],["ty"],["option",["scope"]],["basicblock"],["exprref"],["regionkind"]],["blockand",["operand"]]]],[11,"neg_1_literal","","",100,[[["self"],["span"],["ty"]],["operand"]]],[11,"minval_literal","","",100,[[["self"],["span"],["ty"]],["operand"]]],[0,"as_operand","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_local_operand","rustc_mir::build","Returns an operand suitable for use until the end of the current scope expression.",100,[[["self"],["basicblock"],["m"]],["blockand",["operand"]]]],[11,"as_operand","","Compile `expr` into a value that can be used as an operand. If `expr` is a place like `x`, this will introduce a temporary `tmp = x`, so that we capture the value of `x` at this time.",100,[[["self"],["basicblock"],["option",["scope"]],["m"]],["blockand",["operand"]]]],[11,"expr_as_operand","","",100,[[["self"],["basicblock"],["option",["scope"]],["expr"]],["blockand",["operand"]]]],[0,"as_temp","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_temp","rustc_mir::build","Compile `expr` into a fresh temporary. This is used when building up rvalues so as to freeze the value that will be consumed.",100,[[["self"],["basicblock"],["option",["scope"]],["m"]],["blockand",["local"]]]],[11,"expr_as_temp","","",100,[[["self"],["basicblock"],["option",["scope"]],["expr"]],["blockand",["local"]]]],[0,"category","rustc_mir::build::expr","",N,N],[4,"Category","rustc_mir::build::expr::category","",N,N],[13,"Place","","",109,N],[13,"Constant","","",109,N],[13,"Rvalue","","",109,N],[4,"RvalueFunc","","",N,N],[13,"Into","","",110,N],[13,"AsRvalue","","",110,N],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"eq","","",109,[[["self"],["category"]],["bool"]]],[11,"ne","","",109,[[["self"],["category"]],["bool"]]],[11,"fmt","","",110,[[["self"],["formatter"]],["result"]]],[11,"eq","","",110,[[["self"],["rvaluefunc"]],["bool"]]],[11,"of","","",109,[[["exprkind"]],["option",["category"]]]],[0,"into","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"into_expr","rustc_mir::build","Compile `expr`, storing the result into `destination`, which is assumed to be uninitialized.",100,[[["self"],["place"],["basicblock"],["expr"]],["blockand"]]],[0,"stmt","rustc_mir::build::expr","",N,N],[11,"stmt_expr","rustc_mir::build","",100,[[["self"],["basicblock"],["expr"]],["blockand"]]],[0,"into","","In general, there are a number of things for which it's convenient to just call `builder.into` and have it emit its result into a given location. This is basically for expressions or things that can be wrapped up as expressions (e.g. blocks). To make this ergonomic, we use this latter `EvalInto` trait.",N,N],[8,"EvalInto","rustc_mir::build::into","",N,N],[10,"eval_into","","",111,[[["self"],["builder"],["place"],["basicblock"]],["blockand"]]],[11,"into","rustc_mir::build","",100,[[["self"],["place"],["basicblock"],["e"]],["blockand"]]],[0,"matches","","Code related to match expressions. These are sufficiently complex to warrant their own module and submodules. :) This main module includes the high-level algorithm, the submodules contain the details.",N,N],[3,"ArmHasGuard","rustc_mir::build::matches","ArmHasGuard is isomorphic to a boolean flag. It indicates whether a match arm has a guard expression attached to it.",N,N],[12,"0","","",112,N],[3,"ArmBlocks","","List of blocks for each arm (and potentially other metadata in the future).",N,N],[12,"blocks","","",113,N],[3,"Candidate","","",N,N],[12,"span","","",114,N],[12,"match_pairs","","",114,N],[12,"bindings","","",114,N],[12,"guard","","",114,N],[12,"arm_index","","",114,N],[12,"pre_binding_block","","",114,N],[12,"next_candidate_pre_binding_block","","",114,N],[12,"pat_index","","",114,N],[3,"Binding","","",N,N],[12,"span","","",115,N],[12,"source","","",115,N],[12,"name","","",115,N],[12,"var_id","","",115,N],[12,"var_ty","","",115,N],[12,"mutability","","",115,N],[12,"binding_mode","","",115,N],[3,"MatchPair","","",N,N],[12,"place","","",116,N],[12,"pattern","","",116,N],[12,"slice_len_checked","","",116,N],[3,"Test","","",N,N],[12,"span","","",117,N],[12,"kind","","",117,N],[4,"TestKind","","",N,N],[13,"Switch","","",118,N],[12,"adt_def","rustc_mir::build::matches::TestKind","",118,N],[12,"variants","","",118,N],[13,"SwitchInt","rustc_mir::build::matches","",118,N],[12,"switch_ty","rustc_mir::build::matches::TestKind","",118,N],[12,"options","","",118,N],[12,"indices","","",118,N],[13,"Eq","rustc_mir::build::matches","",118,N],[12,"value","rustc_mir::build::matches::TestKind","",118,N],[12,"ty","","",118,N],[13,"Range","rustc_mir::build::matches","",118,N],[12,"lo","rustc_mir::build::matches::TestKind","",118,N],[12,"hi","","",118,N],[12,"ty","","",118,N],[12,"end","","",118,N],[13,"Len","rustc_mir::build::matches","",118,N],[12,"len","rustc_mir::build::matches::TestKind","",118,N],[12,"op","","",118,N],[0,"simplify","rustc_mir::build::matches","Simplifying Candidates",N,N],[11,"simplify_candidate","rustc_mir::build","",100,[[["self"],["basicblock"],["candidate"]],["blockand"]]],[11,"simplify_match_pair","","Tries to simplify `match_pair`, returning true if successful. If successful, new match pairs and bindings will have been pushed into the candidate. If no simplification is possible, Err is returned and no changes are made to candidate.",100,[[["self"],["matchpair"],["candidate"]],["result",["matchpair"]]]],[0,"test","rustc_mir::build::matches","",N,N],[5,"is_switch_ty","rustc_mir::build::matches::test","",N,[[["ty"]],["bool"]]],[11,"test","rustc_mir::build","Identifies what test is needed to decide if `match_pair` is applicable.",100,[[["self"],["matchpair"]],["test"]]],[11,"add_cases_to_switch","","",100,[[["self"],["place"],["candidate"],["ty"],["vec"],["fxhashmap"]],["bool"]]],[11,"add_variants_to_switch","","",100,[[["self"],["place"],["candidate"],["bitvector"]],["bool"]]],[11,"perform_test","","Generates the code to perform a test.",100,[[["self"],["basicblock"],["place"],["test"]],["vec",["basicblock"]]]],[11,"compare","","",100,[[["self"],["basicblock"],["basicblock"],["span"],["binop"],["operand"],["operand"]],["basicblock"]]],[11,"sort_candidate","","Given that we are performing `test` against `test_place`, this job sorts out what the status of `candidate` will be after the test. The `resulting_candidates` vector stores, for each possible outcome of `test`, a vector of the candidates that will result. This fn should add a (possibly modified) clone of candidate into `resulting_candidates` wherever appropriate.",100,N],[11,"candidate_without_match_pair","","",100,[[["self"],["usize"],["candidate"]],["candidate"]]],[11,"candidate_after_slice_test","","",100,N],[11,"candidate_after_variant_switch","","",100,N],[11,"error_simplifyable","","",100,N],[0,"util","rustc_mir::build::matches","",N,N],[11,"field_match_pairs","rustc_mir::build","",100,N],[11,"prefix_slice_suffix","","",100,N],[11,"new","rustc_mir::build::matches","",116,[[["place"],["pattern"]],["matchpair"]]],[11,"clone","","",112,[[["self"]],["armhasguard"]]],[11,"fmt","","",112,[[["self"],["formatter"]],["result"]]],[11,"match_expr","rustc_mir::build","",100,[[["self"],["place"],["span"],["basicblock"],["exprref"],["vec",["arm"]]],["blockand"]]],[11,"user_assert_ty","","",100,[[["self"],["basicblock"],["hirid"],["nodeid"],["span"]]]],[11,"expr_into_pattern","","",100,[[["self"],["basicblock"],["option",["hirid"]],["pattern"],["exprref"]],["blockand"]]],[11,"place_into_pattern","","",100,[[["self"],["basicblock"],["pattern"],["place"],["bool"]],["blockand"]]],[11,"declare_bindings","","Declares the bindings of the given pattern and returns the visibility scope for the bindings in this patterns, if such a scope had to be created. NOTE: Declaring the bindings should always be done in their drop scope.",100,N],[11,"storage_live_binding","","",100,[[["self"],["basicblock"],["nodeid"],["span"],["forguard"]],["place"]]],[11,"schedule_drop_for_binding","","",100,[[["self"],["nodeid"],["span"],["forguard"]]]],[11,"visit_bindings","","",100,[[["self"],["pattern"],["f"]]]],[11,"clone","rustc_mir::build::matches","",114,[[["self"]],["candidate"]]],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"clone","","",115,[[["self"]],["binding"]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",116,[[["self"]],["matchpair"]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"clone","","",118,[[["self"]],["testkind"]]],[11,"fmt","","",118,[[["self"],["formatter"]],["result"]]],[11,"eq","","",118,[[["self"],["testkind"]],["bool"]]],[11,"ne","","",118,[[["self"],["testkind"]],["bool"]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"match_candidates","rustc_mir::build","The main match algorithm. It begins with a set of candidates `candidates` and has the job of generating code to determine which of these candidates, if any, is the correct one. The candidates are sorted such that the first item in the list has the highest priority. When a candidate is found to match the value, we will generate a branch to the appropriate block found in `arm_blocks`.",100,[[["self"],["span"],["armblocks"],["vec",["candidate"]],["basicblock"]],["vec",["basicblock"]]]],[11,"join_otherwise_blocks","","",100,[[["self"],["span"],["vec",["basicblock"]]],["basicblock"]]],[11,"test_candidates","","This is the most subtle part of the matching algorithm.  At this point, the input candidates have been fully simplified, and so we know that all remaining match-pairs require some sort of test. To decide what test to do, we take the highest priority candidate (last one in the list) and extract the first match-pair from the list. From this we decide what kind of test is needed using `test`, defined in the `test` module.",100,N],[11,"bind_and_guard_matched_candidate","","Initializes each of the bindings from the candidate by moving/copying/ref'ing the source as appropriate. Tests the guard, if any, and then branches to the arm. Returns the block for the case where the guard fails.",100,[[["self"],["basicblock"],["armblocks"],["candidate"]],["option",["basicblock"]]]],[11,"bind_matched_candidate_for_guard","","",100,N],[11,"bind_matched_candidate_for_arm_body","","",100,N],[11,"declare_binding","","Each binding (`ref mut var`/`ref var`/`mut var`/`var`, where the bound `var` has type `T` in the arm body) in a pattern maps to `2+N` locals. The first local is a binding for occurrences of `var` in the guard, which will all have type `&T`. The N locals are bindings for the `T` that is referenced by the first local; they are not used outside of the guard. The last local is a binding for occurrences of `var` in the arm body, which will have type `T`.",100,[[["self"],["sourceinfo"],["sourcescope"],["mutability"],["name"],["bindingmode"],["usize"],["nodeid"],["ty"],["armhasguard"],["option"]]]],[0,"misc","","Miscellaneous builder routines that are not specific to building any particular kind of thing.",N,N],[11,"temp","","Add a new temporary value of type `ty` storing the result of evaluating `expr`.",100,[[["self"],["ty"],["span"]],["place"]]],[11,"literal_operand","","",100,[[["self"],["span"],["ty"],["const"]],["operand"]]],[11,"unit_rvalue","","",100,[[["self"]],["rvalue"]]],[11,"zero_literal","","",100,[[["self"],["span"],["ty"]],["operand"]]],[11,"push_usize","","",100,[[["self"],["basicblock"],["sourceinfo"],["u64"]],["place"]]],[11,"consume_by_copy_or_move","","",100,[[["self"],["place"]],["operand"]]],[0,"scope","","Managing the scope stack. The scopes are tied to lexical scopes, so as we descend the HAIR, we push a scope on the stack, build its contents, and then pop it off. Every scope is named by a `region::Scope`.",N,N],[3,"Scope","rustc_mir::build::scope","",N,N],[12,"source_scope","","The source scope this scope was created in.",119,N],[12,"region_scope","","the region span of this scope within source code.",119,N],[12,"region_scope_span","","the span of that region_scope",119,N],[12,"needs_cleanup","","Whether there's anything to do for the cleanup path, that is, when unwinding through this scope. This includes destructors, but not StorageDead statements, which don't get emitted at all for unwinding, for several reasons:  * clang doesn't emit llvm.lifetime.end for C++ unwinding  * LLVM's memory dependency analysis can't handle it atm  * polluting the cleanup MIR with StorageDead creates    landing pads even though there's no actual destructors  * freeing up stack space has no effect during unwinding",119,N],[12,"drops","","set of places to drop when exiting this scope. This starts out empty but grows as variables are declared during the building process. This is a stack, so we always drop from the end of the vector (top of the stack) first.",119,N],[12,"cached_exits","","The cache for drop chain on “normal” exit into a particular BasicBlock.",119,N],[12,"cached_generator_drop","","The cache for drop chain on \"generator drop\" exit.",119,N],[12,"cached_unwind","","The cache for drop chain on \"unwind\" exit.",119,N],[3,"DropData","","",N,N],[12,"span","","span where drop obligation was incurred (typically where place was declared)",120,N],[12,"location","","place to drop",120,N],[12,"kind","","Whether this is a value Drop or a StorageDead.",120,N],[3,"CachedBlock","","",N,N],[12,"unwind","","The cached block for the cleanups-on-diverge path. This block contains code to run the current drop and all the preceding drops (i.e. those having lower index in Drop’s Scope drop array)",121,N],[12,"generator_drop","","The cached block for unwinds during cleanups-on-generator-drop path",121,N],[3,"BreakableScope","","",N,N],[12,"region_scope","","Region scope of the loop",122,N],[12,"continue_block","","Where the body of the loop begins. `None` if block",122,N],[12,"break_block","","Block to branch into when the loop or block terminates (either by being `break`-en out from, or by having its condition to become false)",122,N],[12,"break_destination","","The destination of the loop/block expression itself (i.e. where to put the result of a `break` expression)",122,N],[4,"DropKind","","",N,N],[13,"Value","","",123,N],[12,"cached_block","rustc_mir::build::scope::DropKind","",123,N],[13,"Storage","rustc_mir::build::scope","",123,N],[5,"build_scope_drops","","Builds drops for pop_scope and exit_scope.",N,N],[5,"build_diverge_scope","","",N,[[["tyctxt"],["cfg"],["span"],["scope"],["basicblock"],["bool"]],["basicblock"]]],[11,"fmt","","",119,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",120,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",121,[[["self"],["formatter"]],["result"]]],[11,"default","","",121,[[],["cachedblock"]]],[11,"clone","","",121,[[["self"]],["cachedblock"]]],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"clone","","",122,[[["self"]],["breakablescope"]]],[11,"fmt","","",122,[[["self"],["formatter"]],["result"]]],[11,"invalidate","","",121,[[["self"]]]],[11,"get","","",121,[[["self"],["bool"]],["option",["basicblock"]]]],[11,"ref_mut","","",121,[[["self"],["bool"]],["option"]]],[11,"may_panic","","",123,[[["self"]],["bool"]]],[11,"invalidate_cache","","Invalidate all the cached blocks in the scope.",119,[[["self"],["bool"],["bool"]]]],[11,"source_info","","Given a span and this scope's source scope, make a SourceInfo.",119,[[["self"],["span"]],["sourceinfo"]]],[11,"in_breakable_scope","rustc_mir::build","Start a breakable scope, which tracks where `continue` and `break` should branch to. See module comment for more details.",100,[[["self"],["option",["basicblock"]],["basicblock"],["place"],["f"]],["r"]]],[11,"in_opt_scope","","",100,[[["self"],["option"],["basicblock"],["f"]],["blockand"]]],[11,"in_scope","","Convenience wrapper that pushes a scope and then executes `f` to build its contents, popping the scope afterwards.",100,N],[11,"push_scope","","Push a scope onto the stack. You can then build code in this scope and call `pop_scope` afterwards. Note that these two calls must be paired; using `in_scope` as a convenience wrapper maybe preferable.",100,N],[11,"pop_scope","","Pops a scope, which should have region scope `region_scope`, adding any drops onto the end of `block` that are needed. This must match 1-to-1 with `push_scope`.",100,N],[11,"exit_scope","","Branch out of `block` to `target`, exiting all scopes up to and including `region_scope`.  This will insert whatever drops are needed, as well as tracking this exit for the SEME region. See module comment for details.",100,N],[11,"generator_drop_cleanup","","Creates a path that performs all required cleanup for dropping a generator.",100,[[["self"]],["option",["basicblock"]]]],[11,"new_source_scope","","Creates a new source scope, nested in the current one.",100,[[["self"],["span"],["lintlevel"],["option",["safety"]]],["sourcescope"]]],[11,"find_breakable_scope","","Finds the breakable scope for a given label. This is used for resolving `break` and `continue`.",100,[[["self"],["span"],["scope"]],["breakablescope"]]],[11,"source_info","","Given a span and the current source scope, make a SourceInfo.",100,[[["self"],["span"]],["sourceinfo"]]],[11,"region_scope_of_return_scope","","Returns the `region::Scope` of the scope which should be exited by a return.",100,[[["self"]],["scope"]]],[11,"topmost_scope","","Returns the topmost active scope, which is known to be alive until the next scope expression.",100,[[["self"]],["scope"]]],[11,"local_scope","","Returns the scope that we should use as the lifetime of an operand. Basically, an operand must live until it is consumed. This is similar to, but not quite the same as, the temporary scope (which can be larger or smaller).",100,[[["self"]],["option",["scope"]]]],[11,"schedule_abort","","",100,[[["self"]],["basicblock"]]],[11,"schedule_drop_storage_and_value","","",100,[[["self"],["span"],["scope"],["place"],["ty"]]]],[11,"schedule_drop","","Indicates that `place` should be dropped on exit from `region_scope`.",100,[[["self"],["span"],["scope"],["place"],["ty"],["dropkind"]]]],[11,"diverge_cleanup","","Creates a path that performs all required cleanup for unwinding.",100,[[["self"]],["basicblock"]]],[11,"resume_block","","",100,[[["self"]],["basicblock"]]],[11,"diverge_cleanup_gen","","",100,[[["self"],["bool"]],["basicblock"]]],[11,"build_drop","","Utility function for non-scope code to build their own drops",100,[[["self"],["basicblock"],["span"],["place"],["ty"]],["blockand"]]],[11,"build_drop_and_replace","","Utility function for non-scope code to build their own drops",100,[[["self"],["basicblock"],["span"],["place"],["operand"]],["blockand"]]],[11,"assert","","Create an Assert terminator and return the success block. If the boolean condition operand is not the expected value, a runtime panic will be caused with the given message.",100,[[["self"],["basicblock"],["operand"],["bool"],["assertmessage"],["span"]],["basicblock"]]],[8,"BlockAndExtension","","",N,N],[10,"and","","",124,[[["self"],["t"]],["blockand"]]],[10,"unit","","",124,[[["self"]],["blockand"]]],[11,"visit_ty","","",99,[[["self"],["ty"],["tycontext"]]]],[11,"visit_region","","",99,[[["self"],["region"],["location"]]]],[11,"visit_const","","",99,[[["self"],["const"],["location"]]]],[11,"visit_substs","","",99,[[["self"],["substs"],["location"]]]],[11,"is_bound_var_in_guard","","",100,[[["self"],["nodeid"]],["bool"]]],[11,"var_local_id","","",100,[[["self"],["nodeid"],["forguard"]],["local"]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"new","","",101,[[["nodeid"],["bindingmode"]],["self"]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"clone","","",108,[[["self"]],["forguard"]]],[11,"fmt","","",108,[[["self"],["formatter"]],["result"]]],[11,"eq","","",108,[[["self"],["forguard"]],["bool"]]],[11,"ne","","",108,[[["self"],["forguard"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",108,N],[11,"local_id","","",107,[[["self"],["forguard"]],["local"]]],[11,"clone","","",104,[[["self"]],["scopeid"]]],[11,"eq","","",104,[[["self"],["scopeid"]],["bool"]]],[11,"ne","","",104,[[["self"],["scopeid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",104,N],[11,"hash","","",104,N],[11,"partial_cmp","","",104,[[["self"],["scopeid"]],["option",["ordering"]]]],[11,"lt","","",104,[[["self"],["scopeid"]],["bool"]]],[11,"le","","",104,[[["self"],["scopeid"]],["bool"]]],[11,"gt","","",104,[[["self"],["scopeid"]],["bool"]]],[11,"ge","","",104,[[["self"],["scopeid"]],["bool"]]],[11,"cmp","","",104,[[["self"],["scopeid"]],["ordering"]]],[11,"decode","","",104,[[["__d"]],["result",["scopeid"]]]],[11,"encode","","",104,[[["self"],["__s"]],["result"]]],[11,"new","","",104,[[["usize"]],["self"]]],[11,"index","","",104,[[["self"]],["usize"]]],[11,"steps_between","","",104,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",104,[[["self"]],["self"]]],[11,"replace_zero","","",104,[[["self"]],["self"]]],[11,"add_one","","",104,[[["self"]],["self"]]],[11,"sub_one","","",104,[[["self"]],["self"]]],[11,"add_usize","","",104,[[["self"],["usize"]],["option"]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"new","","",100,[[["cx"],["span"],["usize"],["safety"],["ty"],["vec",["upvardecl"]]],["builder"]]],[11,"finish","","",100,[[["self"],["option",["ty"]]],["mir"]]],[11,"args_and_body","","",100,N],[11,"get_unit_temp","","",100,[[["self"]],["place"]]],[11,"return_block","","",100,[[["self"]],["basicblock"]]],[11,"unreachable_block","","",100,[[["self"]],["basicblock"]]],[0,"dataflow","rustc_mir","",N,N],[3,"DataflowBuilder","rustc_mir::dataflow","",N,N],[12,"node_id","","",125,N],[12,"flow_state","","",125,N],[12,"print_preflow_to","","",125,N],[12,"print_postflow_to","","",125,N],[3,"DebugFormatted","","`DebugFormatted` encapsulates the \"{:?}\" rendering of some arbitrary value. This way: you pay cost of allocating an extra string (as well as that of rendering up-front); in exchange, you don't have to hand over ownership of your value or deal with borrowing it.",N,N],[12,"0","","",126,N],[3,"MoveDataParamEnv","","",N,N],[12,"move_data","","",127,N],[12,"param_env","","",127,N],[3,"PropagationContext","","",N,N],[12,"builder","","",128,N],[3,"Bits","","Maps each block to a set of bits",N,N],[12,"bits","","",129,N],[3,"DataflowAnalysis","","",N,N],[12,"flow_state","","",130,N],[12,"dead_unwinds","","",130,N],[12,"mir","","",130,N],[3,"DataflowResults","","",N,N],[12,"0","","",131,N],[3,"DataflowState","","State of a dataflow analysis; couples a collection of bit sets with operator used to initialize and merge bits during analysis.",N,N],[12,"sets","","All the sets for the analysis. (Factored into its own structure so that we can borrow it mutably on its own separate from other fields.)",132,N],[12,"operator","","operator used to initialize, combine, and interpret bits.",132,N],[3,"AllSets","","",N,N],[12,"bits_per_block","","Analysis bitwidth for each block.",133,N],[12,"words_per_block","","Number of words associated with each block entry equal to bits_per_block / (mem::size_of:: * 8), rounded up.",133,N],[12,"gen_sets","","For each block, bits generated by executing the statements in the block. (For comparison, the Terminator for each block is handled in a flow-specific manner during propagation.)",133,N],[12,"kill_sets","","For each block, bits killed by executing the statements in the block. (For comparison, the Terminator for each block is handled in a flow-specific manner during propagation.)",133,N],[12,"on_entry_sets","","For each block, bits valid on entry to the block.",133,N],[3,"BlockSets","","Triple of sets associated with a given block.",N,N],[12,"on_entry","","Dataflow state immediately before control flow enters the given block.",134,N],[12,"gen_set","","Bits that are set to 1 by the time we exit the given block.",134,N],[12,"kill_set","","Bits that are set to 0 by the time we exit the given block.",134,N],[5,"has_rustc_mir_with","","",N,N],[5,"do_dataflow","","",N,N],[5,"dataflow_path","","",N,[[["str"],["str"],["str"]],["pathbuf"]]],[5,"state_for_location","","",N,[[["location"],["t"],["dataflowresults"],["mir"]],["idxsetbuf"]]],[0,"at_location","","A nice wrapper to consume dataflow results at several CFG locations.",N,N],[3,"FlowAtLocation","rustc_mir::dataflow::at_location","Represents the state of dataflow at a particular CFG location, both before and after it is executed.",N,N],[12,"base_results","","",135,N],[12,"curr_state","","",135,N],[12,"stmt_gen","","",135,N],[12,"stmt_kill","","",135,N],[8,"FlowsAtLocation","","A trait for \"cartesian products\" of multiple FlowAtLocation.",N,N],[10,"reset_to_entry_of","","Reset the state bitvector to represent the entry to block `bb`.",136,[[["self"],["basicblock"]]]],[10,"reconstruct_statement_effect","","Build gen + kill sets for statement at `loc`.",136,[[["self"],["location"]]]],[10,"reconstruct_terminator_effect","","Build gen + kill sets for terminator for `loc`.",136,[[["self"],["location"]]]],[10,"apply_local_effect","","Apply current gen + kill sets to `flow_state`.",136,[[["self"],["location"]]]],[11,"each_state_bit","","Iterate over each bit set in the current state.",135,[[["self"],["f"]]]],[11,"each_gen_bit","","Iterate over each `gen` bit in the current effect (invoke `reconstruct_statement_effect` or `reconstruct_terminator_effect` first).",135,[[["self"],["f"]]]],[11,"new","","",135,[[["dataflowresults"]],["self"]]],[11,"operator","","Access the underlying operator.",135,[[["self"]],["bd"]]],[11,"contains","","",135,N],[11,"iter_incoming","","Returns an iterator over the elements present in the current state.",135,[[["self"]],["peekable",["iter"]]]],[11,"with_iter_outgoing","","Creates a clone of the current state and applies the local effects to the clone (leaving the state of self intact). Invokes `f` with an iterator over the resulting state.",135,[[["self"],["f"]]]],[11,"reset_to_entry_of","","",135,[[["self"],["basicblock"]]]],[11,"reconstruct_statement_effect","","",135,[[["self"],["location"]]]],[11,"reconstruct_terminator_effect","","",135,[[["self"],["location"]]]],[11,"apply_local_effect","","",135,[[["self"],["location"]]]],[11,"has_any_child_of","","",135,N],[0,"drop_flag_effects","rustc_mir::dataflow","",N,N],[5,"move_path_children_matching","rustc_mir::dataflow::drop_flag_effects","",N,[[["movedata"],["movepathindex"],["f"]],["option",["movepathindex"]]]],[5,"place_contents_drop_state_cannot_differ","","When enumerating the child fragments of a path, don't recurse into paths (1.) past arrays, slices, and pointers, nor (2.) into a type that implements `Drop`.",N,[[["tyctxt"],["mir"],["place"]],["bool"]]],[5,"on_lookup_result_bits","","",N,[[["tyctxt"],["mir"],["movedata"],["lookupresult"],["f"]]]],[5,"on_all_children_bits","","",N,[[["tyctxt"],["mir"],["movedata"],["movepathindex"],["f"]]]],[5,"on_all_drop_children_bits","","",N,[[["tyctxt"],["mir"],["movedataparamenv"],["movepathindex"],["f"]]]],[5,"drop_flag_effects_for_function_entry","","",N,[[["tyctxt"],["mir"],["movedataparamenv"],["f"]]]],[5,"drop_flag_effects_for_location","","",N,[[["tyctxt"],["mir"],["movedataparamenv"],["location"],["f"]]]],[5,"for_location_inits","","",N,[[["tyctxt"],["mir"],["movedata"],["location"],["f"]]]],[0,"graphviz","rustc_mir::dataflow","Hook into libgraphviz for rendering dataflow graphs for MIR.",N,N],[3,"Graph","rustc_mir::dataflow::graphviz","",N,N],[12,"mbcx","","",137,N],[12,"phantom","","",137,N],[12,"render_idx","","",137,N],[3,"Edge","","",N,N],[12,"source","","",138,N],[12,"index","","",138,N],[5,"print_borrowck_graph_to","","",N,[[["dataflowbuilder"],["path"],["p"]],["result"]]],[5,"outgoing","","",N,[[["mir"],["basicblock"]],["vec",["edge"]]]],[6,"Node","","",N,N],[8,"MirWithFlowState","","",N,N],[16,"BD","","",139,N],[10,"node_id","","",139,[[["self"]],["nodeid"]]],[10,"mir","","",139,[[["self"]],["mir"]]],[10,"flow_state","","",139,[[["self"]],["dataflowstate"]]],[11,"node_id","rustc_mir::dataflow","",125,[[["self"]],["nodeid"]]],[11,"mir","","",125,[[["self"]],["mir"]]],[11,"flow_state","","",125,[[["self"]],["dataflowstate"]]],[11,"clone","rustc_mir::dataflow::graphviz","",138,[[["self"]],["edge"]]],[11,"eq","","",138,[[["self"],["edge"]],["bool"]]],[11,"ne","","",138,[[["self"],["edge"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",138,N],[11,"fmt","","",138,[[["self"],["formatter"]],["result"]]],[11,"graph_id","","",137,[[["self"]],["id"]]],[11,"node_id","","",137,[[["self"],["basicblock"]],["id"]]],[11,"node_label","","",137,[[["self"],["basicblock"]],["labeltext"]]],[11,"node_shape","","",137,[[["self"],["basicblock"]],["option",["labeltext"]]]],[11,"edge_label","","",137,[[["self"],["edge"]],["labeltext"]]],[11,"node_label_internal","","Generate the node label",137,[[["self"],["basicblock"],["w"],["basicblock"],["mir"]],["result"]]],[11,"node_label_verbose_row","","Build the verbose row: full MIR data, and detailed gen/kill/entry sets",137,[[["self"],["basicblock"],["w"],["basicblock"],["mir"]],["result"]]],[11,"node_label_final_row","","Build the summary row: terminator, gen/kill/entry bit sets",137,[[["self"],["basicblock"],["w"],["basicblock"],["mir"]],["result"]]],[11,"nodes","","",137,[[["self"]],["nodes",["basicblock"]]]],[11,"edges","","",137,[[["self"]],["edges",["edge"]]]],[11,"source","","",137,[[["self"],["edge"]],["basicblock"]]],[11,"target","","",137,[[["self"],["edge"]],["basicblock"]]],[0,"impls","rustc_mir::dataflow","Dataflow analyses are built upon some interpretation of the bitvectors attached to each basic block, represented via a zero-sized structure.",N,N],[3,"MaybeInitializedPlaces","rustc_mir::dataflow::impls","`MaybeInitializedPlaces` tracks all places that might be initialized upon reaching a particular point in the control flow for a function.",N,N],[12,"tcx","","",140,N],[12,"mir","","",140,N],[12,"mdpe","","",140,N],[3,"MaybeUninitializedPlaces","","`MaybeUninitializedPlaces` tracks all places that might be uninitialized upon reaching a particular point in the control flow for a function.",N,N],[12,"tcx","","",141,N],[12,"mir","","",141,N],[12,"mdpe","","",141,N],[3,"DefinitelyInitializedPlaces","","`DefinitelyInitializedPlaces` tracks all places that are definitely initialized upon reaching a particular point in the control flow for a function.",N,N],[12,"tcx","","",142,N],[12,"mir","","",142,N],[12,"mdpe","","",142,N],[3,"MovingOutStatements","","`MovingOutStatements` tracks the statements that perform moves out of particular places. More precisely, it tracks whether the effect of such moves (namely, the uninitialization of the place in question) can reach some point in the control-flow of the function, or if that effect is \"killed\" by some intervening operation reinitializing that place.",N,N],[12,"tcx","","",143,N],[12,"mir","","",143,N],[12,"mdpe","","",143,N],[3,"EverInitializedPlaces","","`EverInitializedPlaces` tracks all places that might have ever been initialized upon reaching a particular point in the control flow for a function, without an intervening `Storage Dead`.",N,N],[12,"tcx","","",144,N],[12,"mir","","",144,N],[12,"mdpe","","",144,N],[0,"storage_liveness","","",N,N],[3,"MaybeStorageLive","rustc_mir::dataflow::impls::storage_liveness","",N,N],[12,"mir","","",145,N],[11,"clone","","",145,[[["self"]],["maybestoragelive"]]],[11,"new","","",145,[[["mir"]],["self"]]],[11,"mir","","",145,[[["self"]],["mir"]]],[11,"name","","",145,[[],["str"]]],[11,"bits_per_block","","",145,[[["self"]],["usize"]]],[11,"start_block_effect","","",145,[[["self"],["idxset"]]]],[11,"statement_effect","","",145,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",145,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",145,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"join","","",145,[[["self"],["word"],["word"]],["word"]]],[11,"bottom_value","","",145,[[],["bool"]]],[0,"borrowed_locals","rustc_mir::dataflow::impls","",N,N],[3,"HaveBeenBorrowedLocals","rustc_mir::dataflow::impls::borrowed_locals","This calculates if any part of a MIR local could have previously been borrowed. This means that once a local has been borrowed, its bit will always be set from that point and onwards, even if the borrow ends. You could also think of this as computing the lifetimes of infinite borrows. This is used to compute which locals are live during a yield expression for immovable generators.",N,N],[12,"mir","","",146,N],[3,"BorrowedLocalsVisitor","","",N,N],[12,"sets","","",147,N],[5,"find_local","","",N,[[["place"]],["option",["local"]]]],[11,"clone","","",146,[[["self"]],["havebeenborrowedlocals"]]],[11,"new","","",146,[[["mir"]],["self"]]],[11,"mir","","",146,[[["self"]],["mir"]]],[11,"name","","",146,[[],["str"]]],[11,"bits_per_block","","",146,[[["self"]],["usize"]]],[11,"start_block_effect","","",146,[[["self"],["idxset"]]]],[11,"statement_effect","","",146,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",146,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",146,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"join","","",146,[[["self"],["word"],["word"]],["word"]]],[11,"bottom_value","","",146,[[],["bool"]]],[11,"visit_rvalue","","",147,[[["self"],["rvalue"],["location"]]]],[0,"borrows","rustc_mir::dataflow::impls","",N,N],[3,"Borrows","rustc_mir::dataflow::impls::borrows","`Borrows` stores the data used in the analyses that track the flow of borrows.",N,N],[12,"tcx","","",148,N],[12,"mir","","",148,N],[12,"scope_tree","","",148,N],[12,"root_scope","","",148,N],[12,"borrow_set","","",148,N],[12,"borrows_out_of_scope_at_location","","",148,N],[12,"_nonlexical_regioncx","","NLL region inference context with which NLL queries should be resolved",148,N],[5,"precompute_borrows_out_of_scope","","",N,[[["mir"],["rc"],["fxhashmap"],["borrowindex"],["regionvid"],["location"]]]],[11,"new","","",148,[[["tyctxt"],["mir"],["rc",["regioninferencecontext"]],["defid"],["option",["bodyid"]],["rc"]],["self"]]],[11,"borrows","","",148,[[["self"]],["indexvec"]]],[11,"scope_tree","","",148,[[["self"]],["lrc"]]],[11,"location","","",148,[[["self"],["borrowindex"]],["location"]]],[11,"kill_loans_out_of_scope_at_location","","Add all borrows to the kill set, if those borrows are out of scope at `location`. That means either they went out of either a nonlexical scope, if we care about those at the moment, or the location represents a lexical EndRegion",148,[[["self"],["blocksets"],["location"]]]],[11,"kill_borrows_on_local","","",148,[[["self"],["blocksets"],["local"]]]],[11,"name","","",148,[[],["str"]]],[11,"bits_per_block","","",148,[[["self"]],["usize"]]],[11,"start_block_effect","","",148,[[["self"],["idxset"]]]],[11,"before_statement_effect","","",148,[[["self"],["blocksets"],["location"]]]],[11,"statement_effect","","",148,[[["self"],["blocksets"],["location"]]]],[11,"before_terminator_effect","","",148,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",148,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",148,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"join","","",148,[[["self"],["word"],["word"]],["word"]]],[11,"bottom_value","","",148,[[],["bool"]]],[11,"new","rustc_mir::dataflow::impls","",140,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",140,[[["self"]],["movedata"]]],[11,"new","","",141,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",141,[[["self"]],["movedata"]]],[11,"new","","",142,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",142,[[["self"]],["movedata"]]],[11,"new","","",143,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",143,[[["self"]],["movedata"]]],[11,"new","","",144,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",144,[[["self"]],["movedata"]]],[11,"update_bits","","",140,[[["blocksets"],["movepathindex"],["dropflagstate"]]]],[11,"update_bits","","",141,[[["blocksets"],["movepathindex"],["dropflagstate"]]]],[11,"update_bits","","",142,[[["blocksets"],["movepathindex"],["dropflagstate"]]]],[11,"name","","",140,[[],["str"]]],[11,"bits_per_block","","",140,[[["self"]],["usize"]]],[11,"start_block_effect","","",140,[[["self"],["idxset"]]]],[11,"statement_effect","","",140,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",140,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",140,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"name","","",141,[[],["str"]]],[11,"bits_per_block","","",141,[[["self"]],["usize"]]],[11,"start_block_effect","","",141,[[["self"],["idxset"]]]],[11,"statement_effect","","",141,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",141,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",141,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"name","","",142,[[],["str"]]],[11,"bits_per_block","","",142,[[["self"]],["usize"]]],[11,"start_block_effect","","",142,[[["self"],["idxset"]]]],[11,"statement_effect","","",142,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",142,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",142,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"name","","",143,[[],["str"]]],[11,"bits_per_block","","",143,[[["self"]],["usize"]]],[11,"start_block_effect","","",143,[[["self"],["idxset"]]]],[11,"statement_effect","","",143,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",143,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",143,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"name","","",144,[[],["str"]]],[11,"bits_per_block","","",144,[[["self"]],["usize"]]],[11,"start_block_effect","","",144,[[["self"],["idxset"]]]],[11,"statement_effect","","",144,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",144,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",144,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"join","","",140,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",141,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",142,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",143,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",144,[[["self"],["word"],["word"]],["word"]]],[11,"bottom_value","","",140,[[],["bool"]]],[11,"bottom_value","","",141,[[],["bool"]]],[11,"bottom_value","","",142,[[],["bool"]]],[11,"bottom_value","","",143,[[],["bool"]]],[11,"bottom_value","","",144,[[],["bool"]]],[0,"move_paths","rustc_mir::dataflow","",N,N],[3,"MovePath","rustc_mir::dataflow::move_paths","`MovePath` is a canonicalized representation of a path that is moved or assigned to.",N,N],[12,"next_sibling","","",149,N],[12,"first_child","","",149,N],[12,"parent","","",149,N],[12,"place","","",149,N],[3,"MoveData","","",N,N],[12,"move_paths","","",150,N],[12,"moves","","",150,N],[12,"loc_map","","Each Location `l` is mapped to the MoveOut's that are effects of executing the code at `l`. (There can be multiple MoveOut's for a given `l` because each MoveOut is associated with one particular path being moved.)",150,N],[12,"path_map","","",150,N],[12,"rev_lookup","","",150,N],[12,"inits","","",150,N],[12,"init_loc_map","","Each Location `l` is mapped to the Inits that are effects of executing the code at `l`.",150,N],[12,"init_path_map","","",150,N],[3,"LocationMap","","",N,N],[12,"map","","Location-indexed (BasicBlock for outer index, index within BB for inner index) map.",151,N],[3,"MoveOut","","`MoveOut` represents a point in a program that moves out of some L-value; i.e., \"creates\" uninitialized memory.",N,N],[12,"path","","path being moved",152,N],[12,"source","","location of move",152,N],[3,"Init","","`Init` represents a point in a program that initializes some L-value;",N,N],[12,"path","","path being initialized",153,N],[12,"span","","span of initialization",153,N],[12,"kind","","Extra information about this initialization",153,N],[3,"MovePathLookup","","Tables mapping from a place to its MovePathIndex.",N,N],[12,"locals","","",154,N],[12,"projections","","projections are made from a base-place and a projection elem. The base-place will have a unique MovePathIndex; we use the latter as the index into the outer vector (narrowing subsequent search so that it is solely relative to that base-place). For the remaining lookup, we map the projection elem to the associated MovePathIndex.",154,N],[3,"IllegalMoveOrigin","","",N,N],[12,"location","","",155,N],[12,"kind","","",155,N],[4,"InitKind","","Additional information about the initialization.",N,N],[13,"Deep","","Deep init, even on panic",156,N],[13,"Shallow","","Only does a shallow init",156,N],[13,"NonPanicPathOnly","","This doesn't initialize the variable on panic (and a panic is possible).",156,N],[4,"LookupResult","","",N,N],[13,"Exact","","",157,N],[13,"Parent","","",157,N],[4,"IllegalMoveOriginKind","","",N,N],[13,"Static","","Illegal move due to attempt to move from `static` variable.",158,N],[13,"BorrowedContent","","Illegal move due to attempt to move from behind a reference.",158,N],[12,"target_place","rustc_mir::dataflow::move_paths::IllegalMoveOriginKind","The place the reference refers to: if erroneous code was trying to move from `(*x).f` this will be `*x`.",158,N],[13,"InteriorOfTypeWithDestructor","rustc_mir::dataflow::move_paths","Illegal move due to attempt to move from field of an ADT that implements `Drop`. Rust maintains invariant that all `Drop` ADT's remain fully-initialized so that user-defined destructor can safely read from all of the ADT's fields.",158,N],[12,"container_ty","rustc_mir::dataflow::move_paths::IllegalMoveOriginKind","",158,N],[13,"InteriorOfSliceOrArray","rustc_mir::dataflow::move_paths","Illegal move due to attempt to move out of a slice or array.",158,N],[12,"ty","rustc_mir::dataflow::move_paths::IllegalMoveOriginKind","",158,N],[12,"is_index","","",158,N],[4,"MoveError","rustc_mir::dataflow::move_paths","",N,N],[13,"IllegalMove","","",159,N],[12,"cannot_move_out_of","rustc_mir::dataflow::move_paths::MoveError","",159,N],[13,"UnionMove","rustc_mir::dataflow::move_paths","",159,N],[12,"path","rustc_mir::dataflow::move_paths::MoveError","",159,N],[0,"abs_domain","rustc_mir::dataflow::move_paths","The move-analysis portion of borrowck needs to work in an abstract domain of lifted Places.  Most of the Place variants fall into a one-to-one mapping between the concrete and abstract (e.g. a field-deref on a local-variable, `x.field`, has the same meaning in both domains). Indexed-Projections are the exception: `a[x]` needs to be treated as mapping to the same move path as `a[y]` as well as `a[13]`, et cetera.",N,N],[3,"AbstractOperand","rustc_mir::dataflow::move_paths::abs_domain","",N,N],[3,"AbstractType","","",N,N],[6,"AbstractElem","","",N,N],[8,"Lift","","",N,N],[16,"Abstract","","",160,N],[10,"lift","","",160,N],[11,"clone","","",161,[[["self"]],["abstractoperand"]]],[11,"eq","","",161,[[["self"],["abstractoperand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",161,N],[11,"hash","","",161,N],[11,"fmt","","",161,[[["self"],["formatter"]],["result"]]],[11,"clone","","",162,[[["self"]],["abstracttype"]]],[11,"eq","","",162,[[["self"],["abstracttype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",162,N],[11,"hash","","",162,N],[11,"fmt","","",162,[[["self"],["formatter"]],["result"]]],[0,"indexes","rustc_mir::dataflow::move_paths","",N,N],[3,"MovePathIndex","rustc_mir::dataflow::move_paths::indexes","",N,N],[12,"0","","",163,N],[3,"MoveOutIndex","","",N,N],[12,"0","","",164,N],[3,"InitIndex","","",N,N],[12,"0","","",165,N],[3,"BorrowIndex","","",N,N],[12,"0","","",166,N],[11,"clone","","",163,[[["self"]],["movepathindex"]]],[11,"eq","","",163,[[["self"],["movepathindex"]],["bool"]]],[11,"ne","","",163,[[["self"],["movepathindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",163,N],[11,"hash","","",163,N],[11,"partial_cmp","","",163,[[["self"],["movepathindex"]],["option",["ordering"]]]],[11,"lt","","",163,[[["self"],["movepathindex"]],["bool"]]],[11,"le","","",163,[[["self"],["movepathindex"]],["bool"]]],[11,"gt","","",163,[[["self"],["movepathindex"]],["bool"]]],[11,"ge","","",163,[[["self"],["movepathindex"]],["bool"]]],[11,"cmp","","",163,[[["self"],["movepathindex"]],["ordering"]]],[11,"new","","",163,[[["usize"]],["self"]]],[11,"index","","",163,[[["self"]],["usize"]]],[11,"fmt","","",163,[[["self"],["formatter"]],["result"]]],[11,"clone","","",164,[[["self"]],["moveoutindex"]]],[11,"eq","","",164,[[["self"],["moveoutindex"]],["bool"]]],[11,"ne","","",164,[[["self"],["moveoutindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",164,N],[11,"hash","","",164,N],[11,"partial_cmp","","",164,[[["self"],["moveoutindex"]],["option",["ordering"]]]],[11,"lt","","",164,[[["self"],["moveoutindex"]],["bool"]]],[11,"le","","",164,[[["self"],["moveoutindex"]],["bool"]]],[11,"gt","","",164,[[["self"],["moveoutindex"]],["bool"]]],[11,"ge","","",164,[[["self"],["moveoutindex"]],["bool"]]],[11,"cmp","","",164,[[["self"],["moveoutindex"]],["ordering"]]],[11,"new","","",164,[[["usize"]],["self"]]],[11,"index","","",164,[[["self"]],["usize"]]],[11,"fmt","","",164,[[["self"],["formatter"]],["result"]]],[11,"clone","","",165,[[["self"]],["initindex"]]],[11,"eq","","",165,[[["self"],["initindex"]],["bool"]]],[11,"ne","","",165,[[["self"],["initindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",165,N],[11,"hash","","",165,N],[11,"partial_cmp","","",165,[[["self"],["initindex"]],["option",["ordering"]]]],[11,"lt","","",165,[[["self"],["initindex"]],["bool"]]],[11,"le","","",165,[[["self"],["initindex"]],["bool"]]],[11,"gt","","",165,[[["self"],["initindex"]],["bool"]]],[11,"ge","","",165,[[["self"],["initindex"]],["bool"]]],[11,"cmp","","",165,[[["self"],["initindex"]],["ordering"]]],[11,"new","","",165,[[["usize"]],["self"]]],[11,"index","","",165,[[["self"]],["usize"]]],[11,"fmt","","",165,[[["self"],["formatter"]],["result"]]],[11,"clone","","",166,[[["self"]],["borrowindex"]]],[11,"eq","","",166,[[["self"],["borrowindex"]],["bool"]]],[11,"ne","","",166,[[["self"],["borrowindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",166,N],[11,"hash","","",166,N],[11,"partial_cmp","","",166,[[["self"],["borrowindex"]],["option",["ordering"]]]],[11,"lt","","",166,[[["self"],["borrowindex"]],["bool"]]],[11,"le","","",166,[[["self"],["borrowindex"]],["bool"]]],[11,"gt","","",166,[[["self"],["borrowindex"]],["bool"]]],[11,"ge","","",166,[[["self"],["borrowindex"]],["bool"]]],[11,"cmp","","",166,[[["self"],["borrowindex"]],["ordering"]]],[11,"new","","",166,[[["usize"]],["self"]]],[11,"index","","",166,[[["self"]],["usize"]]],[11,"fmt","","",166,[[["self"],["formatter"]],["result"]]],[0,"builder","rustc_mir::dataflow::move_paths","",N,N],[3,"MoveDataBuilder","rustc_mir::dataflow::move_paths::builder","",N,N],[12,"mir","","",167,N],[12,"tcx","","",167,N],[12,"data","","",167,N],[12,"errors","","",167,N],[3,"Gatherer","","",N,N],[12,"builder","","",168,N],[12,"loc","","",168,N],[5,"gather_moves","","",N,[[["mir"],["tyctxt"]],["result",["movedata"]]]],[11,"new","","",167,[[["mir"],["tyctxt"]],["self"]]],[11,"new_move_path","","",167,[[["indexvec"],["indexvec"],["indexvec"],["option",["movepathindex"]],["place"]],["movepathindex"]]],[11,"move_path_for","","This creates a MovePath for a given place, returning an `MovePathError` if that place can't be moved from.",168,[[["self"],["place"]],["result",["movepathindex","moveerror"]]]],[11,"create_move_path","","",168,[[["self"],["place"]]]],[11,"move_path_for_projection","","",168,[[["self"],["place"],["placeprojection"]],["result",["movepathindex","moveerror"]]]],[11,"finalize","","",167,[[["self"]],["result",["movedata"]]]],[11,"gather_args","","",167,[[["self"]]]],[11,"gather_statement","","",167,[[["self"],["location"],["statement"]]]],[11,"gather_terminator","","",167,[[["self"],["location"],["terminator"]]]],[11,"gather_statement","","",168,[[["self"],["statement"]]]],[11,"gather_rvalue","","",168,[[["self"],["rvalue"]]]],[11,"gather_terminator","","",168,[[["self"],["terminator"]]]],[11,"gather_operand","","",168,[[["self"],["operand"]]]],[11,"gather_move","","",168,[[["self"],["place"]]]],[11,"gather_init","","",168,[[["self"],["place"],["initkind"]]]],[8,"HasMoveData","rustc_mir::dataflow::move_paths","",N,N],[10,"move_data","","",169,[[["self"]],["movedata"]]],[11,"move_path_index","rustc_mir::dataflow::move_paths::indexes","",164,[[["self"],["movedata"]],["movepathindex"]]],[11,"clone","rustc_mir::dataflow::move_paths","",149,[[["self"]],["movepath"]]],[11,"fmt","","",149,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",149,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",150,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",151,[[["self"],["formatter"]],["result"]]],[11,"index","","",151,N],[11,"index_mut","","",151,N],[11,"new","","",151,[[["mir"]],["self"]]],[11,"clone","","",152,[[["self"]],["moveout"]]],[11,"fmt","","",152,[[["self"],["formatter"]],["result"]]],[11,"clone","","",153,[[["self"]],["init"]]],[11,"clone","","",156,[[["self"]],["initkind"]]],[11,"fmt","","",156,[[["self"],["formatter"]],["result"]]],[11,"eq","","",156,[[["self"],["initkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",156,N],[11,"fmt","","",153,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",154,[[["self"],["formatter"]],["result"]]],[11,"clone","","",157,[[["self"]],["lookupresult"]]],[11,"fmt","","",157,[[["self"],["formatter"]],["result"]]],[11,"find","","",154,[[["self"],["place"]],["lookupresult"]]],[11,"find_local","","",154,[[["self"],["local"]],["movepathindex"]]],[11,"fmt","","",155,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",158,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",159,[[["self"],["formatter"]],["result"]]],[11,"cannot_move_out_of","","",159,[[["location"],["illegalmoveoriginkind"]],["self"]]],[11,"gather_moves","","",150,[[["mir"],["tyctxt"]],["result"]]],[8,"Dataflow","rustc_mir::dataflow","",N,N],[11,"dataflow","","Sets up and runs the dataflow problem, using `p` to render results if implementation so chooses.",170,[[["self"],["p"]]]],[10,"build_sets","","Sets up the entry, gen, and kill sets for this instance of a dataflow problem.",170,[[["self"]]]],[10,"propagate","","Finds a fixed-point solution to this instance of a dataflow problem.",170,[[["self"]]]],[8,"DataflowResultsConsumer","","DataflowResultsConsumer abstracts over walking the MIR with some already constructed dataflow results.",N,N],[16,"FlowState","","",171,N],[11,"visit_block_entry","","",171,N],[11,"visit_statement_entry","","",171,N],[11,"visit_terminator_entry","","",171,N],[11,"analyze_results","","",171,N],[11,"process_basic_block","","",171,N],[10,"mir","","",171,[[["self"]],["mir"]]],[8,"InitialFlow","","Parameterization for the precise form of data flow that is used. `InitialFlow` handles initializing the bitvectors before any code is inspected by the analysis. Analyses that need more nuanced initialization (e.g. they need to consult the results of some other dataflow analysis to set up the initial bitvectors) should not implement this.",N,N],[10,"bottom_value","","Specifies the initial value for each bit in the `on_entry` set",172,[[],["bool"]]],[8,"BitDenotation","","",N,N],[16,"Idx","","Specifies what index type is used to access the bitvector.",173,N],[11,"accumulates_intrablock_state","","Some analyses want to accumulate knowledge within a block when analyzing its statements for building the gen/kill sets. Override this method to return true in such cases.",173,[[],["bool"]]],[10,"name","","A name describing the dataflow analysis that this BitDenotation is supporting.  The name should be something suitable for plugging in as part of a filename e.g. avoid space-characters or other things that tend to look bad on a file system, like slashes or periods. It is also better for the name to be reasonably short, again because it will be plugged into a filename.",173,[[],["str"]]],[10,"bits_per_block","","Size of each bitvector allocated for each block in the analysis.",173,[[["self"]],["usize"]]],[10,"start_block_effect","","Mutates the entry set according to the effects that have been established prior to entering the start block. This can't access the gen/kill sets, because these won't be accounted for correctly.",173,[[["self"],["idxset"]]]],[11,"before_statement_effect","","Similar to `statement_effect`, except it applies just before the statement rather than just after it.",173,[[["self"],["blocksets"],["location"]]]],[10,"statement_effect","","Mutates the block-sets (the flow sets for the given basic block) according to the effects of evaluating statement.",173,[[["self"],["blocksets"],["location"]]]],[11,"before_terminator_effect","","Similar to `terminator_effect`, except it applies just before the terminator rather than just after it.",173,[[["self"],["blocksets"],["location"]]]],[10,"terminator_effect","","Mutates the block-sets (the flow sets for the given basic block) according to the effects of evaluating the terminator.",173,[[["self"],["blocksets"],["location"]]]],[10,"propagate_call_return","","Mutates the block-sets according to the (flow-dependent) effect of a successful return from a Call terminator.",173,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"new","","",126,[[["debug"]],["debugformatted"]]],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"dataflow","","",125,[[["self"],["p"]]]],[11,"build_sets","","",125,[[["self"]]]],[11,"propagate","","",125,[[["self"]]]],[11,"run","","",130,N],[11,"propagate","","",130,[[["self"]]]],[11,"build_sets","","",130,[[["self"]]]],[11,"walk_cfg","","",128,[[["self"],["idxset"]]]],[11,"pre_dataflow_instrumentation","","",125,[[["self"],["p"]],["result"]]],[11,"post_dataflow_instrumentation","","",125,[[["self"],["p"]],["result"]]],[11,"fmt","","",129,[[["self"],["formatter"]],["result"]]],[11,"clone","","",129,[[["self"]],["self"]]],[11,"new","","",129,[[["idxsetbuf"]],["self"]]],[11,"results","","",130,[[["self"]],["dataflowresults"]]],[11,"mir","","",130,[[["self"]],["mir"]]],[11,"sets","","",131,[[["self"]],["allsets"]]],[11,"operator","","",131,[[["self"]],["o"]]],[11,"interpret_set","","",132,[[["self"],["o"],["idxset"],["p"]],["vec",["debugformatted"]]]],[11,"fmt","","",133,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",134,[[["self"],["formatter"]],["result"]]],[11,"gen","","",134,[[["self"],["e"]]]],[11,"gen_all","","",134,[[["self"],["i"]]]],[11,"gen_all_and_assert_dead","","",134,[[["self"],["i"]]]],[11,"kill","","",134,[[["self"],["e"]]]],[11,"kill_all","","",134,[[["self"],["i"]]]],[11,"apply_local_effect","","",134,[[["self"]]]],[11,"bits_per_block","","",133,[[["self"]],["usize"]]],[11,"for_block","","",133,[[["self"],["usize"]],["blocksets"]]],[11,"lookup_set_for","","",133,[[["self"],["bits"],["usize"]],["idxset"]]],[11,"gen_set_for","","",133,[[["self"],["usize"]],["idxset"]]],[11,"kill_set_for","","",133,[[["self"],["usize"]],["idxset"]]],[11,"on_entry_set_for","","",133,[[["self"],["usize"]],["idxset"]]],[11,"new","","",130,[[["mir"],["idxset"],["d"]],["self"]]],[11,"new_from_sets","","",130,[[["mir"],["idxset"],["allsets"],["d"]],["self"]]],[11,"propagate_bits_into_graph_successors_of","","Propagates the bits of `in_out` into all the successors of `bb`, using bitwise operator denoted by `self.operator`.",130,N],[11,"propagate_bits_into_entry_set_for","","",130,[[["self"],["idxset"],["basicblock"],["workqueue"]]]],[0,"hair","rustc_mir","The MIR is built from some high-level abstract IR (HAIR). This section defines the HAIR along with a trait for accessing it. The intention is to allow MIR construction to be unit-tested and separated from the Rust source and compiler data structures.",N,N],[3,"Block","rustc_mir::hair","",N,N],[12,"targeted_by_break","","",174,N],[12,"region_scope","","",174,N],[12,"opt_destruction_scope","","",174,N],[12,"span","","",174,N],[12,"stmts","","",174,N],[12,"expr","","",174,N],[12,"safety_mode","","",174,N],[3,"Stmt","","",N,N],[12,"kind","","",175,N],[12,"opt_destruction_scope","","",175,N],[3,"Expr","","The Hair trait implementor lowers their expressions (`&'tcx H::Expr`) into instances of this `Expr` enum. This lowering can be done basically as lazily or as eagerly as desired: every recursive reference to an expression in this enum is an `ExprRef<'tcx>`, which may in turn be another instance of this enum (boxed), or else an unlowered `&'tcx H::Expr`. Note that instances of `Expr` are very shortlived. They are created by `Hair::to_expr`, analyzed and converted into MIR, and then discarded.",N,N],[12,"ty","","type of this expression",176,N],[12,"temp_lifetime","","lifetime of this expression if it should be spilled into a temporary; should be None only if in a constant context",176,N],[12,"span","","span of the expression in the source",176,N],[12,"kind","","kind of expression",176,N],[3,"FieldExprRef","","",N,N],[12,"name","","",177,N],[12,"expr","","",177,N],[3,"FruInfo","","",N,N],[12,"base","","",178,N],[12,"field_types","","",178,N],[3,"Arm","","",N,N],[12,"patterns","","",179,N],[12,"guard","","",179,N],[12,"body","","",179,N],[12,"lint_level","","",179,N],[4,"LintLevel","","",N,N],[13,"Inherited","","",180,N],[13,"Explicit","","",180,N],[4,"BlockSafety","","",N,N],[13,"Safe","","",181,N],[13,"ExplicitUnsafe","","",181,N],[13,"PushUnsafe","","",181,N],[13,"PopUnsafe","","",181,N],[4,"StmtRef","","",N,N],[13,"Mirror","","",182,N],[4,"StmtKind","","",N,N],[13,"Expr","","",183,N],[12,"scope","rustc_mir::hair::StmtKind","scope for this statement; may be used as lifetime of temporaries",183,N],[12,"expr","","expression being evaluated in this statement",183,N],[13,"Let","rustc_mir::hair","",183,N],[12,"remainder_scope","rustc_mir::hair::StmtKind","scope for variables bound in this let; covers this and remaining statements in block",183,N],[12,"init_scope","","scope for the initialization itself; might be used as lifetime of temporaries",183,N],[12,"pattern","","let : ty = ...",183,N],[12,"ty","","let pat:  = init ...",183,N],[12,"initializer","","let pat: ty =  ...",183,N],[12,"lint_level","","the lint level for this let-statement",183,N],[4,"ExprKind","rustc_mir::hair","",N,N],[13,"Scope","","",184,N],[12,"region_scope","rustc_mir::hair::ExprKind","",184,N],[12,"lint_level","","",184,N],[12,"value","","",184,N],[13,"Box","rustc_mir::hair","",184,N],[12,"value","rustc_mir::hair::ExprKind","",184,N],[13,"Call","rustc_mir::hair","",184,N],[12,"ty","rustc_mir::hair::ExprKind","",184,N],[12,"fun","","",184,N],[12,"args","","",184,N],[13,"Deref","rustc_mir::hair","",184,N],[12,"arg","rustc_mir::hair::ExprKind","",184,N],[13,"Binary","rustc_mir::hair","",184,N],[12,"op","rustc_mir::hair::ExprKind","",184,N],[12,"lhs","","",184,N],[12,"rhs","","",184,N],[13,"LogicalOp","rustc_mir::hair","",184,N],[12,"op","rustc_mir::hair::ExprKind","",184,N],[12,"lhs","","",184,N],[12,"rhs","","",184,N],[13,"Unary","rustc_mir::hair","",184,N],[12,"op","rustc_mir::hair::ExprKind","",184,N],[12,"arg","","",184,N],[13,"Cast","rustc_mir::hair","",184,N],[12,"source","rustc_mir::hair::ExprKind","",184,N],[13,"Use","rustc_mir::hair","",184,N],[12,"source","rustc_mir::hair::ExprKind","",184,N],[13,"NeverToAny","rustc_mir::hair","",184,N],[12,"source","rustc_mir::hair::ExprKind","",184,N],[13,"ReifyFnPointer","rustc_mir::hair","",184,N],[12,"source","rustc_mir::hair::ExprKind","",184,N],[13,"ClosureFnPointer","rustc_mir::hair","",184,N],[12,"source","rustc_mir::hair::ExprKind","",184,N],[13,"UnsafeFnPointer","rustc_mir::hair","",184,N],[12,"source","rustc_mir::hair::ExprKind","",184,N],[13,"Unsize","rustc_mir::hair","",184,N],[12,"source","rustc_mir::hair::ExprKind","",184,N],[13,"If","rustc_mir::hair","",184,N],[12,"condition","rustc_mir::hair::ExprKind","",184,N],[12,"then","","",184,N],[12,"otherwise","","",184,N],[13,"Loop","rustc_mir::hair","",184,N],[12,"condition","rustc_mir::hair::ExprKind","",184,N],[12,"body","","",184,N],[13,"Match","rustc_mir::hair","",184,N],[12,"discriminant","rustc_mir::hair::ExprKind","",184,N],[12,"arms","","",184,N],[13,"Block","rustc_mir::hair","",184,N],[12,"body","rustc_mir::hair::ExprKind","",184,N],[13,"Assign","rustc_mir::hair","",184,N],[12,"lhs","rustc_mir::hair::ExprKind","",184,N],[12,"rhs","","",184,N],[13,"AssignOp","rustc_mir::hair","",184,N],[12,"op","rustc_mir::hair::ExprKind","",184,N],[12,"lhs","","",184,N],[12,"rhs","","",184,N],[13,"Field","rustc_mir::hair","",184,N],[12,"lhs","rustc_mir::hair::ExprKind","",184,N],[12,"name","","",184,N],[13,"Index","rustc_mir::hair","",184,N],[12,"lhs","rustc_mir::hair::ExprKind","",184,N],[12,"index","","",184,N],[13,"VarRef","rustc_mir::hair","",184,N],[12,"id","rustc_mir::hair::ExprKind","",184,N],[13,"SelfRef","rustc_mir::hair","first argument, used for self in a closure",184,N],[13,"StaticRef","","",184,N],[12,"id","rustc_mir::hair::ExprKind","",184,N],[13,"Borrow","rustc_mir::hair","",184,N],[12,"region","rustc_mir::hair::ExprKind","",184,N],[12,"borrow_kind","","",184,N],[12,"arg","","",184,N],[13,"Break","rustc_mir::hair","",184,N],[12,"label","rustc_mir::hair::ExprKind","",184,N],[12,"value","","",184,N],[13,"Continue","rustc_mir::hair","",184,N],[12,"label","rustc_mir::hair::ExprKind","",184,N],[13,"Return","rustc_mir::hair","",184,N],[12,"value","rustc_mir::hair::ExprKind","",184,N],[13,"Repeat","rustc_mir::hair","",184,N],[12,"value","rustc_mir::hair::ExprKind","",184,N],[12,"count","","",184,N],[13,"Array","rustc_mir::hair","",184,N],[12,"fields","rustc_mir::hair::ExprKind","",184,N],[13,"Tuple","rustc_mir::hair","",184,N],[12,"fields","rustc_mir::hair::ExprKind","",184,N],[13,"Adt","rustc_mir::hair","",184,N],[12,"adt_def","rustc_mir::hair::ExprKind","",184,N],[12,"variant_index","","",184,N],[12,"substs","","",184,N],[12,"fields","","",184,N],[12,"base","","",184,N],[13,"Closure","rustc_mir::hair","",184,N],[12,"closure_id","rustc_mir::hair::ExprKind","",184,N],[12,"substs","","",184,N],[12,"upvars","","",184,N],[12,"movability","","",184,N],[13,"Literal","rustc_mir::hair","",184,N],[12,"literal","rustc_mir::hair::ExprKind","",184,N],[13,"InlineAsm","rustc_mir::hair","",184,N],[12,"asm","rustc_mir::hair::ExprKind","",184,N],[12,"outputs","","",184,N],[12,"inputs","","",184,N],[13,"Yield","rustc_mir::hair","",184,N],[12,"value","rustc_mir::hair::ExprKind","",184,N],[4,"ExprRef","rustc_mir::hair","",N,N],[13,"Hair","","",185,N],[13,"Mirror","","",185,N],[4,"LogicalOp","","",N,N],[13,"And","","",186,N],[13,"Or","","",186,N],[0,"cx","","This module contains the code to convert from the wacky tcx data structures into the hair. The `builder` is generally ignorant of the tcx etc, and instead goes through the `Cx` for most of its work.",N,N],[3,"Cx","rustc_mir::hair::cx","",N,N],[12,"tcx","","",187,N],[12,"infcx","","",187,N],[12,"root_lint_level","","",187,N],[12,"param_env","","",187,N],[12,"identity_substs","","Identity `Substs` for use with const-evaluation.",187,N],[12,"region_scope_tree","","",187,N],[12,"tables","","",187,N],[12,"constness","","This is `Constness::Const` if we are compiling a `static`, `const`, or the body of a `const fn`.",187,N],[12,"body_owner_kind","","What kind of body is being compiled.",187,N],[12,"check_overflow","","True if this constant/function needs overflow checks.",187,N],[5,"lint_level_for_hir_id","","",N,[[["tyctxt"],["nodeid"]],["nodeid"]]],[0,"block","","",N,N],[5,"mirror_stmts","rustc_mir::hair::cx::block","",N,N],[5,"to_expr_ref","","",N,[[["cx"],["block"]],["exprref"]]],[0,"expr","rustc_mir::hair::cx","",N,N],[5,"apply_adjustment","rustc_mir::hair::cx::expr","",N,[[["cx"],["expr"],["expr"],["adjustment"]],["expr"]]],[5,"make_mirror_unadjusted","","",N,[[["cx"],["expr"]],["expr"]]],[5,"method_callee","","",N,[[["cx"],["expr"],["option"]],["expr"]]],[5,"convert_arm","","",N,[[["cx"],["arm"]],["arm"]]],[5,"convert_path_expr","","",N,[[["cx"],["expr"],["def"]],["exprkind"]]],[5,"convert_var","","",N,[[["cx"],["expr"],["def"]],["exprkind"]]],[5,"bin_op","","",N,[[["binopkind"]],["binop"]]],[5,"overloaded_operator","","",N,[[["cx"],["expr"],["vec",["exprref"]]],["exprkind"]]],[5,"overloaded_place","","",N,[[["cx"],["expr"],["ty"],["option"],["vec",["exprref"]]],["exprkind"]]],[5,"capture_freevar","","",N,[[["cx"],["expr"],["freevar"],["ty"]],["exprref"]]],[5,"field_refs","","Converts a list of named fields (i.e. for struct-like struct/enum ADTs) into FieldExprRef.",N,N],[8,"ToBorrowKind","","",N,N],[10,"to_borrow_kind","","",188,[[["self"]],["borrowkind"]]],[0,"to_ref","rustc_mir::hair::cx","",N,N],[8,"ToRef","rustc_mir::hair::cx::to_ref","",N,N],[16,"Output","","",189,N],[10,"to_ref","","",189,N],[11,"to_ref","rustc_mir::hair","",176,[[["self"]],["exprref"]]],[11,"clone","rustc_mir::hair::cx","",187,[[["self"]],["cx"]]],[11,"new","","",187,[[["inferctxt"],["nodeid"]],["cx"]]],[11,"mirror","","Normalizes `ast` into the appropriate `mirror` type.",187,N],[11,"usize_ty","","",187,[[["self"]],["ty"]]],[11,"usize_literal","","",187,[[["self"],["u64"]],["const"]]],[11,"bool_ty","","",187,[[["self"]],["ty"]]],[11,"unit_ty","","",187,[[["self"]],["ty"]]],[11,"true_literal","","",187,[[["self"]],["const"]]],[11,"false_literal","","",187,[[["self"]],["const"]]],[11,"const_eval_literal","","",187,[[["self"],["litkind"],["ty"],["span"],["bool"]],["const"]]],[11,"pattern_from_hir","","",187,[[["self"],["pat"]],["pattern"]]],[11,"trait_method","","",187,N],[11,"all_fields","","",187,[[["self"],["adtdef"],["usize"]],["vec",["field"]]]],[11,"needs_drop","","",187,[[["self"],["ty"]],["bool"]]],[11,"lint_level_of","","",187,[[["self"],["nodeid"]],["lintlevel"]]],[11,"tcx","","",187,[[["self"]],["tyctxt"]]],[11,"tables","","",187,[[["self"]],["typecktables"]]],[11,"check_overflow","","",187,[[["self"]],["bool"]]],[11,"type_moves_by_default","","",187,[[["self"],["ty"],["span"]],["bool"]]],[0,"pattern","rustc_mir::hair","Code to validate patterns/matches",N,N],[3,"FieldPattern","rustc_mir::hair::pattern","",N,N],[12,"field","","",190,N],[12,"pattern","","",190,N],[3,"Pattern","","",N,N],[12,"ty","","",191,N],[12,"span","","",191,N],[12,"kind","","",191,N],[3,"PatternContext","","",N,N],[12,"tcx","","",192,N],[12,"param_env","","",192,N],[12,"tables","","",192,N],[12,"substs","","",192,N],[12,"errors","","",192,N],[4,"PatternError","","",N,N],[13,"AssociatedConstInPattern","","",193,N],[13,"StaticInPattern","","",193,N],[13,"FloatBug","","",193,N],[13,"NonConstPath","","",193,N],[4,"BindingMode","","",N,N],[13,"ByValue","","",194,N],[13,"ByRef","","",194,N],[4,"PatternKind","","",N,N],[13,"Wild","","",195,N],[13,"Binding","","x, ref x, x @ P, etc",195,N],[12,"mutability","rustc_mir::hair::pattern::PatternKind","",195,N],[12,"name","","",195,N],[12,"mode","","",195,N],[12,"var","","",195,N],[12,"ty","","",195,N],[12,"subpattern","","",195,N],[13,"Variant","rustc_mir::hair::pattern","Foo(...) or Foo{...} or Foo, where `Foo` is a variant name from an adt with >1 variants",195,N],[12,"adt_def","rustc_mir::hair::pattern::PatternKind","",195,N],[12,"substs","","",195,N],[12,"variant_index","","",195,N],[12,"subpatterns","","",195,N],[13,"Leaf","rustc_mir::hair::pattern","(...), Foo(...), Foo{...}, or Foo, where `Foo` is a variant name from an adt with 1 variant",195,N],[12,"subpatterns","rustc_mir::hair::pattern::PatternKind","",195,N],[13,"Deref","rustc_mir::hair::pattern","box P, &P, &mut P, etc",195,N],[12,"subpattern","rustc_mir::hair::pattern::PatternKind","",195,N],[13,"Constant","rustc_mir::hair::pattern","",195,N],[12,"value","rustc_mir::hair::pattern::PatternKind","",195,N],[13,"Range","rustc_mir::hair::pattern","",195,N],[12,"lo","rustc_mir::hair::pattern::PatternKind","",195,N],[12,"hi","","",195,N],[12,"end","","",195,N],[13,"Slice","rustc_mir::hair::pattern","matches against a slice, checking the length and extracting elements. irrefutable when there is a slice pattern and both `prefix` and `suffix` are empty. e.g. `&[ref xs..]`.",195,N],[12,"prefix","rustc_mir::hair::pattern::PatternKind","",195,N],[12,"slice","","",195,N],[12,"suffix","","",195,N],[13,"Array","rustc_mir::hair::pattern","fixed match against an array, irrefutable",195,N],[12,"prefix","rustc_mir::hair::pattern::PatternKind","",195,N],[12,"slice","","",195,N],[12,"suffix","","",195,N],[4,"LitToConstError","rustc_mir::hair::pattern","",N,N],[13,"UnparseableFloat","","",196,N],[13,"Propagated","","",196,N],[5,"compare_const_vals","","",N,[[["tyctxt"],["const"],["const"],["paramenvand",["ty"]]],["option",["ordering"]]]],[5,"lit_to_const","","",N,[[["litkind"],["tyctxt"],["ty"],["bool"]],["result",["const","littoconsterror"]]]],[5,"parse_float","","",N,[[["symbol"],["floatty"],["bool"]],["result",["constvalue"]]]],[0,"_match","","",N,N],[3,"LiteralExpander","rustc_mir::hair::pattern::_match","",N,N],[3,"Matrix","","",N,N],[12,"0","","",197,N],[3,"MatchCheckCtxt","","",N,N],[12,"tcx","","",198,N],[12,"module","","The module in which the match occurs. This is necessary for checking inhabited-ness of types because whether a type is (visibly) inhabited can depend on whether it was defined in the current module or not. eg. `struct Foo { _private: ! }` cannot be seen to be empty outside it's module and should not be matchable with an empty match statement.",198,N],[12,"pattern_arena","","",198,N],[12,"byte_array_map","","",198,N],[3,"PatternContext","","",N,N],[12,"ty","","",199,N],[12,"max_slice_length","","",199,N],[3,"Witness","","A stack of patterns in reverse order of construction",N,N],[12,"0","","",200,N],[4,"Constructor","","",N,N],[13,"Single","","The constructor of all patterns that don't vary by constructor, e.g. struct patterns and fixed-length arrays.",201,N],[13,"Variant","","Enum variants.",201,N],[13,"ConstantValue","","Literal values.",201,N],[13,"ConstantRange","","Ranges of literal values (`2...5` and `2..5`).",201,N],[13,"Slice","","Array patterns of length n.",201,N],[4,"Usefulness","","",N,N],[13,"Useful","","",202,N],[13,"UsefulWithWitness","","",202,N],[13,"NotUseful","","",202,N],[4,"WitnessPreference","","",N,N],[13,"ConstructWitness","","",203,N],[13,"LeaveOutWitness","","",203,N],[5,"expand_pattern","","",N,[[["matchcheckctxt"],["pattern"]],["pattern"]]],[5,"all_constructors","","This determines the set of all possible constructors of a pattern matching values of type `left_ty`. For vectors, this would normally be an infinite set but is instead bounded by the maximum fixed length of slice patterns in the column of patterns being analyzed.",N,[[["matchcheckctxt"],["patterncontext"]],["vec",["constructor"]]]],[5,"max_slice_length","","",N,[[["matchcheckctxt"],["i"]],["u64"]]],[5,"is_useful","","Algorithm from http://moscova.inria.fr/~maranget/papers/warn/index.html The algorithm from the paper has been modified to correctly handle empty types. The changes are:   (0) We don't exit early if the pattern matrix has zero rows. We just       continue to recurse over columns.   (1) all_constructors will only return constructors that are statically       possible. eg. it will only return Ok for Result<T, !>",N,N],[5,"is_useful_specialized","","",N,N],[5,"pat_constructors","","Determines the constructors that the given pattern can be specialized to.",N,[[["matchcheckctxt"],["pattern"],["patterncontext"]],["option",["vec"]]]],[5,"constructor_arity","","This computes the arity of a constructor. The arity of a constructor is how many subpattern patterns of that constructor should be expanded to.",N,[[["matchcheckctxt"],["constructor"],["ty"]],["u64"]]],[5,"constructor_sub_pattern_tys","","This computes the types of the sub patterns that a constructor should be expanded to.",N,[[["matchcheckctxt"],["constructor"],["ty"]],["vec",["ty"]]]],[5,"slice_pat_covered_by_constructor","","",N,N],[5,"constructor_covered_by_range","","",N,[[["tyctxt"],["constructor"],["const"],["const"],["rangeend"],["ty"]],["result",["bool","errorreported"]]]],[5,"patterns_for_variant","","",N,N],[5,"specialize","","This is the main specialization step. It expands the first pattern in the given row into `arity` patterns based on the constructor. For most patterns, the step is trivial, for instance tuple patterns are flattened and box patterns expand into their inner pattern.",N,N],[11,"fold_pattern","","",204,[[["self"],["pattern"]],["pattern"]]],[11,"is_wildcard","rustc_mir::hair::pattern","",191,[[["self"]],["bool"]]],[11,"empty","rustc_mir::hair::pattern::_match","",197,[[],["self"]]],[11,"push","","",197,[[["self"],["vec",["pattern"]]]]],[11,"fmt","","",197,[[["self"],["formatter"]],["result"]]],[11,"from_iter","","",197,[[["t"]],["self"]]],[11,"create_and_enter","","",198,[[["tyctxt"],["defid"],["f"]],["r"]]],[11,"lower_byte_str_pattern","","",198,[[["self"],["pattern"]],["vec",["pattern"]]]],[11,"is_uninhabited","","",198,[[["self"],["ty"]],["bool"]]],[11,"is_non_exhaustive_enum","","",198,[[["self"],["ty"]],["bool"]]],[11,"is_local","","",198,[[["self"],["ty"]],["bool"]]],[11,"is_variant_uninhabited","","",198,[[["self"],["variantdef"],["substs"]],["bool"]]],[11,"clone","","",201,[[["self"]],["constructor"]]],[11,"fmt","","",201,[[["self"],["formatter"]],["result"]]],[11,"eq","","",201,[[["self"],["constructor"]],["bool"]]],[11,"ne","","",201,[[["self"],["constructor"]],["bool"]]],[11,"variant_index_for_adt","","",201,[[["self"],["adtdef"]],["usize"]]],[11,"clone","","",202,[[["self"]],["usefulness"]]],[11,"is_useful","","",202,[[["self"]],["bool"]]],[11,"clone","","",203,[[["self"]],["witnesspreference"]]],[11,"clone","","",199,[[["self"]],["patterncontext"]]],[11,"fmt","","",199,[[["self"],["formatter"]],["result"]]],[11,"clone","","",200,[[["self"]],["witness"]]],[11,"single_pattern","","",200,[[["self"]],["pattern"]]],[11,"push_wild_constructor","","",200,[[["self"],["matchcheckctxt"],["constructor"],["ty"]],["self"]]],[11,"apply_constructor","","Constructs a partial witness for a pattern given a list of patterns expanded by the specialization step.",200,[[["self"],["matchcheckctxt"],["constructor"],["ty"]],["self"]]],[0,"check_match","rustc_mir::hair::pattern","",N,N],[3,"OuterVisitor","rustc_mir::hair::pattern::check_match","",N,N],[12,"tcx","","",205,N],[3,"MatchVisitor","","",N,N],[12,"tcx","","",206,N],[12,"tables","","",206,N],[12,"param_env","","",206,N],[12,"identity_substs","","",206,N],[12,"region_scope_tree","","",206,N],[3,"MutationChecker","","",N,N],[12,"cx","","",207,N],[3,"AtBindingPatternVisitor","","",N,N],[12,"cx","","",208,N],[12,"bindings_allowed","","",208,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"check_match","","",N,[[["tyctxt"],["defid"]],["result",["errorreported"]]]],[5,"create_e0004","","",N,[[["session"],["span"],["string"]],["diagnosticbuilder"]]],[5,"check_for_bindings_named_the_same_as_variants","","",N,[[["matchvisitor"],["pat"]]]],[5,"pat_is_catchall","","Checks for common cases of \"catchall\" patterns that may not be intended as such.",N,[[["pat"]],["bool"]]],[5,"check_arms","","",N,N],[5,"check_exhaustive","","",N,[[["matchcheckctxt"],["ty"],["span"],["matrix"]]]],[5,"check_legality_of_move_bindings","","",N,N],[5,"check_for_mutation_in_guard","","Ensures that a pattern guard doesn't borrow by mutable reference or assign.",N,[[["matchvisitor"],["expr"]]]],[5,"check_legality_of_bindings_in_at_patterns","","Forbids bindings in `@` patterns. This is necessary for memory safety, because of the way rvalues are handled in the borrow check. (See issue #14587.)",N,[[["matchvisitor"],["pat"]]]],[11,"nested_visit_map","","",205,[[["self"]],["nestedvisitormap"]]],[11,"visit_body","","",205,[[["self"],["body"]]]],[11,"nested_visit_map","","",206,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",206,[[["self"],["expr"]]]],[11,"visit_local","","",206,[[["self"],["local"]]]],[11,"visit_body","","",206,[[["self"],["body"]]]],[11,"report_inlining_errors","rustc_mir::hair::pattern","",192,[[["self"],["span"]]]],[11,"span_e0158","","",192,[[["self"],["span"],["str"]]]],[11,"check_patterns","rustc_mir::hair::pattern::check_match","",206,N],[11,"check_match","","",206,N],[11,"conservative_is_uninhabited","","",206,[[["self"],["ty"]],["bool"]]],[11,"check_irrefutable","","",206,[[["self"],["pat"],["str"]]]],[11,"matched_pat","","",207,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume","","",207,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"consume_pat","","",207,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[11,"borrow","","",207,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"decl_without_init","","",207,[[["self"],["nodeid"],["span"]]]],[11,"mutate","","",207,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"nested_visit_map","","",208,[[["self"]],["nestedvisitormap"]]],[11,"visit_pat","","",208,[[["self"],["pat"]]]],[8,"PatternFoldable","rustc_mir::hair::pattern","",N,N],[11,"fold_with","","",209,[[["self"],["f"]],["self"]]],[10,"super_fold_with","","",209,[[["self"],["f"]],["self"]]],[8,"PatternFolder","","",N,N],[11,"fold_pattern","","",210,[[["self"],["pattern"]],["pattern"]]],[11,"fold_pattern_kind","","",210,[[["self"],["patternkind"]],["patternkind"]]],[11,"clone","","",193,[[["self"]],["patternerror"]]],[11,"fmt","","",193,[[["self"],["formatter"]],["result"]]],[11,"clone","","",194,[[["self"]],["bindingmode"]]],[11,"fmt","","",194,[[["self"],["formatter"]],["result"]]],[11,"clone","","",190,[[["self"]],["fieldpattern"]]],[11,"fmt","","",190,[[["self"],["formatter"]],["result"]]],[11,"clone","","",191,[[["self"]],["pattern"]]],[11,"fmt","","",191,[[["self"],["formatter"]],["result"]]],[11,"clone","","",195,[[["self"]],["patternkind"]]],[11,"fmt","","",195,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",191,[[["self"],["formatter"]],["result"]]],[11,"from_hir","","",191,[[["tyctxt"],["paramenvand",["substs"]],["typecktables"],["pat"]],["self"]]],[11,"new","","",192,[[["tyctxt"],["paramenvand",["substs"]],["typecktables"]],["self"]]],[11,"lower_pattern","","",192,[[["self"],["pat"]],["pattern"]]],[11,"lower_pattern_unadjusted","","",192,[[["self"],["pat"]],["pattern"]]],[11,"lower_patterns","","",192,N],[11,"lower_opt_pattern","","",192,[[["self"],["option"]],["option",["pattern"]]]],[11,"flatten_nested_slice_patterns","","",192,N],[11,"slice_or_array_pattern","","",192,N],[11,"lower_variant_or_leaf","","",192,[[["self"],["def"],["span"],["ty"],["vec",["fieldpattern"]]],["patternkind"]]],[11,"lower_path","","Takes a HIR Path. If the path is a constant, evaluates it and feeds it to `const_to_pat`. Any other path (like enum variants without fields) is converted to the corresponding pattern via `lower_variant_or_leaf`",192,[[["self"],["qpath"],["hirid"],["span"]],["pattern"]]],[11,"lower_lit","","Converts literals, paths and negation of literals to patterns. The special case for negation exists to allow things like -128i8 which would overflow if we tried to evaluate 128i8 and then negate afterwards.",192,[[["self"],["expr"]],["patternkind"]]],[11,"const_to_pat","","Converts an evaluated constant to a pattern (if possible). This means aggregate values (like structs and enums) are converted to a pattern that matches the value (as if you'd compare via eq).",192,[[["self"],["instance"],["const"],["hirid"],["span"]],["pattern"]]],[11,"super_fold_with","","",194,[[["self"],["f"]],["self"]]],[11,"super_fold_with","","",190,[[["self"],["f"]],["self"]]],[11,"fold_with","","",191,[[["self"],["f"]],["self"]]],[11,"super_fold_with","","",191,[[["self"],["f"]],["self"]]],[11,"fold_with","","",195,[[["self"],["f"]],["self"]]],[11,"super_fold_with","","",195,[[["self"],["f"]],["self"]]],[11,"eq","","",196,[[["self"],["littoconsterror"]],["bool"]]],[8,"Mirror","rustc_mir::hair","\"Mirroring\" is the process of converting from a HIR type into one of the HAIR types defined in this file. This is basically a \"on the fly\" desugaring step that hides a lot of the messiness in the tcx. For example, the mirror of a `&'tcx hir::Expr` is an `Expr<'tcx>`.",N,N],[16,"Output","","",211,N],[10,"make_mirror","","",211,N],[11,"clone","","",180,[[["self"]],["lintlevel"]]],[11,"fmt","","",180,[[["self"],["formatter"]],["result"]]],[11,"is_explicit","","",180,[[["self"]],["bool"]]],[11,"clone","","",174,[[["self"]],["block"]]],[11,"fmt","","",174,[[["self"],["formatter"]],["result"]]],[11,"clone","","",181,[[["self"]],["blocksafety"]]],[11,"fmt","","",181,[[["self"],["formatter"]],["result"]]],[11,"clone","","",182,[[["self"]],["stmtref"]]],[11,"fmt","","",182,[[["self"],["formatter"]],["result"]]],[11,"clone","","",175,[[["self"]],["stmt"]]],[11,"fmt","","",175,[[["self"],["formatter"]],["result"]]],[11,"clone","","",183,[[["self"]],["stmtkind"]]],[11,"fmt","","",183,[[["self"],["formatter"]],["result"]]],[11,"clone","","",176,[[["self"]],["expr"]]],[11,"fmt","","",176,[[["self"],["formatter"]],["result"]]],[11,"clone","","",184,[[["self"]],["exprkind"]]],[11,"fmt","","",184,[[["self"],["formatter"]],["result"]]],[11,"clone","","",185,[[["self"]],["exprref"]]],[11,"fmt","","",185,[[["self"],["formatter"]],["result"]]],[11,"clone","","",177,[[["self"]],["fieldexprref"]]],[11,"fmt","","",177,[[["self"],["formatter"]],["result"]]],[11,"clone","","",178,[[["self"]],["fruinfo"]]],[11,"fmt","","",178,[[["self"],["formatter"]],["result"]]],[11,"clone","","",179,[[["self"]],["arm"]]],[11,"fmt","","",179,[[["self"],["formatter"]],["result"]]],[11,"clone","","",186,[[["self"]],["logicalop"]]],[11,"fmt","","",186,[[["self"],["formatter"]],["result"]]],[11,"span","","",185,[[["self"]],["span"]]],[11,"make_mirror","","",176,[[["self"],["cx"]],["expr"]]],[11,"make_mirror","","",185,[[["self"],["cx"]],["expr"]]],[11,"make_mirror","","",175,[[["self"],["cx"]],["stmt"]]],[11,"make_mirror","","",182,[[["self"],["cx"]],["stmt"]]],[11,"make_mirror","","",174,[[["self"],["cx"]],["block"]]],[0,"shim","rustc_mir","",N,N],[3,"DropShimElaborator","rustc_mir::shim","",N,N],[12,"mir","","",212,N],[12,"patch","","",212,N],[12,"tcx","","",212,N],[12,"param_env","","",212,N],[3,"CloneShimBuilder","","",N,N],[12,"tcx","","",213,N],[12,"def_id","","",213,N],[12,"local_decls","","",213,N],[12,"blocks","","",213,N],[12,"span","","",213,N],[12,"sig","","",213,N],[4,"Adjustment","","",N,N],[13,"Identity","","",214,N],[13,"Deref","","",214,N],[13,"RefMut","","",214,N],[4,"CallKind","","",N,N],[13,"Indirect","","",215,N],[13,"Direct","","",215,N],[5,"provide","","",N,[[["providers"]]]],[5,"make_shim","","",N,[[["tyctxt"],["instancedef"]],["mir"]]],[5,"temp_decl","","",N,[[["mutability"],["ty"],["span"]],["localdecl"]]],[5,"local_decls_for_sig","","",N,[[["fnsig"],["span"]],["indexvec",["local","localdecl"]]]],[5,"build_drop_shim","","",N,[[["tyctxt"],["defid"],["option",["ty"]]],["mir"]]],[5,"build_clone_shim","","Build a `Clone::clone` shim for `self_ty`. Here, `def_id` is `Clone::clone`.",N,[[["tyctxt"],["defid"],["ty"]],["mir"]]],[5,"build_call_shim","","Build a \"call\" shim for `def_id`. The shim calls the function specified by `call_kind`, first adjusting its first argument according to `rcvr_adjustment`.",N,[[["tyctxt"],["defid"],["adjustment"],["callkind"],["option"]],["mir"]]],[5,"build_adt_ctor","","",N,N],[11,"clone","","",214,[[["self"]],["adjustment"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"eq","","",214,[[["self"],["adjustment"]],["bool"]]],[11,"clone","","",215,[[["self"]],["callkind"]]],[11,"fmt","","",215,[[["self"],["formatter"]],["result"]]],[11,"eq","","",215,[[["self"],["callkind"]],["bool"]]],[11,"ne","","",215,[[["self"],["callkind"]],["bool"]]],[11,"fmt","","",212,[[["self"],["formatter"]],["result",["error"]]]],[11,"patch","","",212,[[["self"]],["mirpatch"]]],[11,"mir","","",212,[[["self"]],["mir"]]],[11,"tcx","","",212,[[["self"]],["tyctxt"]]],[11,"param_env","","",212,[[["self"]],["paramenv"]]],[11,"drop_style","","",212,N],[11,"get_drop_flag","","",212,N],[11,"clear_drop_flag","","",212,N],[11,"field_subpath","","",212,N],[11,"deref_subpath","","",212,N],[11,"downcast_subpath","","",212,N],[11,"array_subpath","","",212,N],[11,"new","","",213,[[["tyctxt"],["defid"],["ty"]],["self"]]],[11,"into_mir","","",213,[[["self"]],["mir"]]],[11,"source_info","","",213,[[["self"]],["sourceinfo"]]],[11,"block","","",213,[[["self"],["vec",["statement"]],["terminatorkind"],["bool"]],["basicblock"]]],[11,"block_index_offset","","Gives the index of an upcoming BasicBlock, with an offset. offset=0 will give you the index of the next BasicBlock, offset=1 will give the index of the next-to-next block, offset=-1 will give you the index of the last-created block",213,[[["self"],["usize"]],["basicblock"]]],[11,"make_statement","","",213,[[["self"],["statementkind"]],["statement"]]],[11,"copy_shim","","",213,[[["self"]]]],[11,"make_place","","",213,[[["self"],["mutability"],["ty"]],["place"]]],[11,"make_clone_call","","",213,[[["self"],["place"],["place"],["ty"],["basicblock"],["basicblock"]]]],[11,"loop_header","","",213,[[["self"],["place"],["place"],["basicblock"],["basicblock"],["bool"]]]],[11,"make_usize","","",213,[[["self"],["u64"]],["box",["constant"]]]],[11,"array_shim","","",213,[[["self"],["place"],["place"],["ty"],["u64"]]]],[11,"tuple_like_shim","","",213,[[["self"],["place"],["place"],["i"]]]],[0,"transform","rustc_mir","",N,N],[3,"MirSource","rustc_mir::transform","Where a specific Mir comes from.",N,N],[12,"def_id","","",216,N],[12,"promoted","","If `Some`, this is a promoted rvalue within the parent function.",216,N],[5,"provide","","",N,[[["providers"]]]],[5,"is_mir_available","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"mir_keys","","Finds the full set of def-ids within the current crate that have MIR associated with them.",N,[[["tyctxt"],["cratenum"]],["lrc",["defidset"]]]],[5,"mir_built","","",N,[[["tyctxt"],["defid"]],["steal"]]],[5,"default_name","","Generates a default name for the pass based on the name of the type `T`.",N,[[],["cow",["str"]]]],[5,"mir_const","","",N,[[["tyctxt"],["defid"]],["steal"]]],[5,"mir_validated","","",N,[[["tyctxt"],["defid"]],["steal"]]],[5,"optimized_mir","","",N,[[["tyctxt"],["defid"]],["mir"]]],[0,"add_validation","","This pass adds validation calls (AcquireValid, ReleaseValid) where appropriate. It has to be run really early, before transformations like inlining, because introducing these calls adds UB -- so, conceptually, this pass is actually part of MIR building, and only after this pass we think of the program has having the normal MIR semantics.",N,N],[3,"AddValidation","rustc_mir::transform::add_validation","",N,N],[5,"place_context","","Determine the \"context\" of the place: Mutability and region.",N,N],[5,"fn_contains_unsafe","","Check if this function contains an unsafe block or is an unsafe function.",N,[[["tyctxt"],["mirsource"]],["bool"]]],[11,"run_pass","","",217,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"add_moves_for_packed_drops","rustc_mir::transform","",N,N],[3,"AddMovesForPackedDrops","rustc_mir::transform::add_moves_for_packed_drops","",N,N],[5,"add_moves_for_packed_drops","","",N,[[["tyctxt"],["mir"],["defid"]]]],[5,"add_moves_for_packed_drops_patch","","",N,[[["tyctxt"],["mir"],["defid"]],["mirpatch"]]],[5,"add_move_for_packed_drop","","",N,[[["tyctxt"],["mir"],["mirpatch"],["terminator"],["location"],["bool"]]]],[11,"run_pass","","",218,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"cleanup_post_borrowck","rustc_mir::transform","This module provides two passes:",N,N],[3,"CleanEndRegions","rustc_mir::transform::cleanup_post_borrowck","",N,N],[3,"GatherBorrowedRegions","","",N,N],[12,"seen_regions","","",219,N],[3,"DeleteTrivialEndRegions","","",N,N],[12,"seen_regions","","",220,N],[3,"CleanUserAssertTy","","",N,N],[3,"DeleteUserAssertTy","","",N,N],[11,"run_pass","","",221,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_rvalue","","",219,[[["self"],["rvalue"],["location"]]]],[11,"visit_ty","","",219,[[["self"],["ty"],["tycontext"]]]],[11,"visit_statement","","",220,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"run_pass","","",222,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_statement","","",223,[[["self"],["basicblock"],["statement"],["location"]]]],[0,"check_unsafety","rustc_mir::transform","",N,N],[3,"UnsafetyChecker","rustc_mir::transform::check_unsafety","",N,N],[12,"mir","","",224,N],[12,"source_scope_local_data","","",224,N],[12,"violations","","",224,N],[12,"source_info","","",224,N],[12,"tcx","","",224,N],[12,"param_env","","",224,N],[12,"used_unsafe","","",224,N],[12,"inherited_blocks","","",224,N],[3,"UnusedUnsafeVisitor","","",N,N],[12,"used_unsafe","","",225,N],[12,"unsafe_blocks","","",225,N],[5,"provide","","",N,[[["providers"]]]],[5,"check_unused_unsafe","","",N,[[["tyctxt"],["defid"],["fxhashset"],["vec"]]]],[5,"unsafety_check_result","","",N,[[["tyctxt"],["defid"]],["unsafetycheckresult"]]],[5,"unsafe_derive_on_repr_packed","","",N,[[["tyctxt"],["defid"]]]],[5,"is_enclosed","","Return the NodeId for an enclosing scope that is also `unsafe`",N,[[["tyctxt"],["fxhashset"],["nodeid"]],["option"]]],[5,"report_unused_unsafe","","",N,[[["tyctxt"],["fxhashset"],["nodeid"]]]],[5,"builtin_derive_def_id","","",N,[[["tyctxt"],["defid"]],["option",["defid"]]]],[5,"check_unsafety","","",N,[[["tyctxt"],["defid"]]]],[11,"new","","",224,[[["mir"],["indexvec"],["tyctxt"],["paramenv"]],["self"]]],[11,"visit_terminator","","",224,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_statement","","",224,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_rvalue","","",224,[[["self"],["rvalue"],["location"]]]],[11,"visit_place","","",224,[[["self"],["place"],["placecontext"],["location"]]]],[11,"require_unsafe","","",224,[[["self"],["str"],["str"]]]],[11,"register_violations","","",224,N],[11,"nested_visit_map","","",225,[[["self"]],["nestedvisitormap"]]],[11,"visit_block","","",225,[[["self"],["block"]]]],[0,"simplify_branches","rustc_mir::transform","A pass that simplifies branches when their condition is known.",N,N],[3,"SimplifyBranches","rustc_mir::transform::simplify_branches","",N,N],[12,"label","","",226,N],[11,"new","","",226,[[["str"]],["self"]]],[11,"name","","",226,[[["self"]],["cow",["str"]]]],[11,"run_pass","","",226,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"simplify","rustc_mir::transform","A number of passes which remove various redundancies in the CFG.",N,N],[3,"SimplifyCfg","rustc_mir::transform::simplify","",N,N],[12,"label","","",227,N],[3,"CfgSimplifier","","",N,N],[12,"basic_blocks","","",228,N],[12,"pred_count","","",228,N],[3,"SimplifyLocals","","",N,N],[3,"DeclMarker","","",N,N],[12,"locals","","",229,N],[3,"LocalUpdater","","",N,N],[12,"map","","",230,N],[5,"simplify_cfg","","",N,[[["mir"]]]],[5,"remove_dead_blocks","","",N,[[["mir"]]]],[5,"make_local_map","","Construct the mapping while swapping out unused stuff out from the `vec`.",N,[[["indexvec"],["bitvector",["local"]]],["indexvec",["local","option"]]]],[11,"new","","",227,[[["str"]],["self"]]],[11,"name","","",227,[[["self"]],["cow",["str"]]]],[11,"run_pass","","",227,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"new","","",228,[[["mir"]],["self"]]],[11,"simplify","","",228,[[["self"]]]],[11,"collapse_goto_chain","","",228,[[["self"],["basicblock"],["bool"]]]],[11,"merge_successor","","",228,[[["self"],["vec"],["terminator"]],["bool"]]],[11,"simplify_branch","","",228,[[["self"],["terminator"]],["bool"]]],[11,"strip_nops","","",228,[[["self"]]]],[11,"run_pass","","",231,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_local","","",229,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_basic_block_data","","",230,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_local","","",230,[[["self"],["local"],["placecontext"],["location"]]]],[0,"erase_regions","rustc_mir::transform","This pass erases all early-bound regions from the types occurring in the MIR. We want to do this once just before codegen, so codegen does not have to take care erasing regions all over the place. NOTE:  We do NOT erase regions of statements that are relevant for \"types-as-contracts\"-validation, namely, AcquireValid, ReleaseValid, and EndRegion.",N,N],[3,"EraseRegionsVisitor","rustc_mir::transform::erase_regions","",N,N],[12,"tcx","","",232,N],[12,"in_validation_statement","","",232,N],[3,"EraseRegions","","",N,N],[11,"new","","",232,[[["tyctxt"]],["self"]]],[11,"visit_ty","","",232,[[["self"],["ty"],["tycontext"]]]],[11,"visit_region","","",232,[[["self"],["region"],["location"]]]],[11,"visit_const","","",232,[[["self"],["const"],["location"]]]],[11,"visit_substs","","",232,[[["self"],["substs"],["location"]]]],[11,"visit_statement","","",232,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"run_pass","","",233,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"no_landing_pads","rustc_mir::transform","This pass removes the unwind branch of all the terminators when the no-landing-pads option is specified.",N,N],[3,"NoLandingPads","rustc_mir::transform::no_landing_pads","",N,N],[5,"no_landing_pads","","",N,[[["tyctxt"],["mir"]]]],[11,"run_pass","","",234,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_terminator","","",234,[[["self"],["basicblock"],["terminator"],["location"]]]],[0,"rustc_peek","rustc_mir::transform","",N,N],[3,"SanityCheck","rustc_mir::transform::rustc_peek","",N,N],[5,"sanity_check_via_rustc_peek","","This function scans `mir` for all calls to the intrinsic `rustc_peek` that have the expression form `rustc_peek(&expr)`.",N,N],[5,"each_block","","",N,[[["tyctxt"],["mir"],["dataflowresults"],["basicblock"]]]],[5,"is_rustc_peek","","",N,[[["tyctxt"],["option"]],["option"]]],[11,"run_pass","","",235,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"elaborate_drops","rustc_mir::transform","",N,N],[3,"ElaborateDrops","rustc_mir::transform::elaborate_drops","",N,N],[3,"InitializationData","","",N,N],[12,"live","","",236,N],[12,"dead","","",236,N],[3,"Elaborator","","",N,N],[12,"init_data","","",237,N],[12,"ctxt","","",237,N],[3,"ElaborateDropsCtxt","","",N,N],[12,"tcx","","",238,N],[12,"mir","","",238,N],[12,"env","","",238,N],[12,"flow_inits","","",238,N],[12,"flow_uninits","","",238,N],[12,"drop_flags","","",238,N],[12,"patch","","",238,N],[5,"find_dead_unwinds","","Return the set of basic blocks whose unwind edges are known to not be reachable, because they are `drop` terminators that can't drop anything.",N,[[["tyctxt"],["mir"],["nodeid"],["movedataparamenv"]],["idxsetbuf",["basicblock"]]]],[11,"run_pass","","",239,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"apply_location","","",236,[[["self"],["tyctxt"],["mir"],["movedataparamenv"],["location"]]]],[11,"state","","",236,N],[11,"fmt","","",237,[[["self"],["formatter"]],["result"]]],[11,"patch","","",237,[[["self"]],["mirpatch"]]],[11,"mir","","",237,[[["self"]],["mir"]]],[11,"tcx","","",237,[[["self"]],["tyctxt"]]],[11,"param_env","","",237,[[["self"]],["paramenv"]]],[11,"drop_style","","",237,N],[11,"clear_drop_flag","","",237,N],[11,"field_subpath","","",237,N],[11,"array_subpath","","",237,N],[11,"deref_subpath","","",237,N],[11,"downcast_subpath","","",237,N],[11,"get_drop_flag","","",237,N],[11,"move_data","","",238,[[["self"]],["movedata"]]],[11,"param_env","","",238,[[["self"]],["paramenv"]]],[11,"initialization_data_at","","",238,[[["self"],["location"]],["initializationdata"]]],[11,"create_drop_flag","","",238,[[["self"],["movepathindex"],["span"]]]],[11,"drop_flag","","",238,[[["self"],["movepathindex"]],["option",["place"]]]],[11,"elaborate","","create a patch that elaborates all drops in the input MIR.",238,[[["self"]],["mirpatch"]]],[11,"collect_drop_flags","","",238,[[["self"]]]],[11,"elaborate_drops","","",238,[[["self"]]]],[11,"elaborate_replace","","Elaborate a MIR `replace` terminator. This instruction is not directly handled by codegen, and therefore must be desugared.",238,[[["self"],["location"],["place"],["operand"],["basicblock"],["option",["basicblock"]]]]],[11,"constant_bool","","",238,[[["self"],["span"],["bool"]],["rvalue"]]],[11,"set_drop_flag","","",238,[[["self"],["location"],["movepathindex"],["dropflagstate"]]]],[11,"drop_flags_on_init","","",238,[[["self"]]]],[11,"drop_flags_for_fn_rets","","",238,[[["self"]]]],[11,"drop_flags_for_args","","",238,[[["self"]]]],[11,"drop_flags_for_locs","","",238,[[["self"]]]],[0,"add_call_guards","rustc_mir::transform","",N,N],[4,"AddCallGuards","rustc_mir::transform::add_call_guards","",N,N],[13,"AllCallEdges","","",240,N],[13,"CriticalCallEdges","","",240,N],[11,"eq","","",240,[[["self"],["addcallguards"]],["bool"]]],[11,"run_pass","","",240,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"add_call_guards","","",240,[[["self"],["mir"]]]],[0,"promote_consts","rustc_mir::transform","A pass that promotes borrows of constant rvalues.",N,N],[3,"TempCollector","rustc_mir::transform::promote_consts","",N,N],[12,"temps","","",241,N],[12,"span","","",241,N],[12,"mir","","",241,N],[3,"Promoter","","",N,N],[12,"tcx","","",242,N],[12,"source","","",242,N],[12,"promoted","","",242,N],[12,"temps","","",242,N],[12,"keep_original","","If true, all nested temps are also kept in the source MIR, not moved to the promoted MIR.",242,N],[4,"TempState","","State of a temporary during collection and promotion.",N,N],[13,"Undefined","","No references to this temp.",243,N],[13,"Defined","","One direct assignment and any number of direct uses. A borrow of this temp is promotable if the assigned value is qualified as constant.",243,N],[12,"location","rustc_mir::transform::promote_consts::TempState","",243,N],[12,"uses","","",243,N],[13,"Unpromotable","rustc_mir::transform::promote_consts","Any other combination of assignments/uses.",243,N],[13,"PromotedOut","","This temp was part of an rvalue which got extracted during promotion and needs cleanup.",243,N],[4,"Candidate","","A \"root candidate\" for promotion, which will become the returned value in a promoted MIR, unless it's a subset of a larger candidate.",N,N],[13,"Ref","","Borrow of a constant temporary.",244,N],[13,"Argument","","Currently applied to function calls where the callee has the unstable `#[rustc_args_required_const]` attribute as well as the SIMD shuffle intrinsic. The intrinsic requires the arguments are indeed constant and the attribute currently provides the semantic requirement that arguments must be constant.",244,N],[12,"bb","rustc_mir::transform::promote_consts::Candidate","",244,N],[12,"index","","",244,N],[5,"collect_temps","rustc_mir::transform::promote_consts","",N,[[["mir"],["reversepostorder"]],["indexvec",["local","tempstate"]]]],[5,"promote_candidates","","",N,[[["mir"],["tyctxt"],["indexvec",["local","tempstate"]],["vec",["candidate"]]]]],[11,"clone","","",243,[[["self"]],["tempstate"]]],[11,"eq","","",243,[[["self"],["tempstate"]],["bool"]]],[11,"ne","","",243,[[["self"],["tempstate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",243,N],[11,"fmt","","",243,[[["self"],["formatter"]],["result"]]],[11,"is_promotable","","",243,[[["self"]],["bool"]]],[11,"fmt","","",244,[[["self"],["formatter"]],["result"]]],[11,"visit_local","","",241,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_source_info","","",241,[[["self"],["sourceinfo"]]]],[11,"new_block","","",242,[[["self"]],["basicblock"]]],[11,"assign","","",242,[[["self"],["local"],["rvalue"],["span"]]]],[11,"promote_temp","","Copy the initialization of this temp to the promoted MIR, recursing through temps.",242,[[["self"],["local"]],["local"]]],[11,"promote_candidate","","",242,[[["self"],["candidate"]]]],[11,"visit_local","","",242,[[["self"],["local"],["placecontext"],["location"]]]],[0,"qualify_consts","rustc_mir::transform","A pass that qualifies constness of temporaries in constants, static initializers and functions and also drives promotion.",N,N],[3,"Qualif","rustc_mir::transform::qualify_consts","",N,N],[12,"bits","","",245,N],[3,"Qualifier","","",N,N],[12,"mode","","",246,N],[12,"span","","",246,N],[12,"def_id","","",246,N],[12,"mir","","",246,N],[12,"rpo","","",246,N],[12,"tcx","","",246,N],[12,"param_env","","",246,N],[12,"local_qualif","","",246,N],[12,"qualif","","",246,N],[12,"const_fn_arg_vars","","",246,N],[12,"temp_promotion_state","","",246,N],[12,"promotion_candidates","","",246,N],[3,"QualifyAndPromoteConstants","","",N,N],[4,"Mode","","What kind of item we are in.",N,N],[13,"Const","","",247,N],[13,"Static","","",247,N],[13,"StaticMut","","",247,N],[13,"ConstFn","","",247,N],[13,"Fn","","",247,N],[5,"provide","","",N,[[["providers"]]]],[5,"mir_const_qualif","","",N,N],[5,"args_required_const","","",N,[[["tyctxt"],["defid"]],["option",["fxhashset"]]]],[11,"eq","","",245,[[["self"],["qualif"]],["bool"]]],[11,"ne","","",245,[[["self"],["qualif"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",245,N],[11,"clone","","",245,[[["self"]],["qualif"]]],[11,"partial_cmp","","",245,[[["self"],["qualif"]],["option",["ordering"]]]],[11,"lt","","",245,[[["self"],["qualif"]],["bool"]]],[11,"le","","",245,[[["self"],["qualif"]],["bool"]]],[11,"gt","","",245,[[["self"],["qualif"]],["bool"]]],[11,"ge","","",245,[[["self"],["qualif"]],["bool"]]],[11,"cmp","","",245,[[["self"],["qualif"]],["ordering"]]],[11,"hash","","",245,N],[11,"fmt","","",245,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",245,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",245,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",245,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",245,[[["self"],["formatter"]],["result"]]],[18,"MUTABLE_INTERIOR","","",245,N],[18,"NEEDS_DROP","","",245,N],[18,"FN_ARGUMENT","","",245,N],[18,"NOT_CONST","","",245,N],[18,"NOT_PROMOTABLE","","",245,N],[18,"CONST_ERROR","","",245,N],[11,"empty","","Returns an empty set of flags.",245,[[],["qualif"]]],[11,"all","","Returns the set containing all flags.",245,[[],["qualif"]]],[11,"bits","","Returns the raw value of the flags currently stored.",245,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",245,[[["u8"]],["option",["qualif"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",245,[[["u8"]],["qualif"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",245,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",245,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",245,[[["self"],["qualif"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",245,[[["self"],["qualif"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",245,[[["self"],["qualif"]]]],[11,"remove","","Removes the specified flags in-place.",245,[[["self"],["qualif"]]]],[11,"toggle","","Toggles the specified flags in-place.",245,[[["self"],["qualif"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",245,[[["self"],["qualif"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",245,[[["self"],["qualif"]],["qualif"]]],[11,"bitor_assign","","Adds the set of flags.",245,[[["self"],["qualif"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",245,[[["self"],["qualif"]],["qualif"]]],[11,"bitxor_assign","","Toggles the set of flags.",245,[[["self"],["qualif"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",245,[[["self"],["qualif"]],["qualif"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",245,[[["self"],["qualif"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",245,[[["self"],["qualif"]],["qualif"]]],[11,"sub_assign","","Disables all flags enabled in the set.",245,[[["self"],["qualif"]]]],[11,"not","","Returns the complement of this set of flags.",245,[[["self"]],["qualif"]]],[11,"extend","","",245,[[["self"],["t"]]]],[11,"from_iter","","",245,[[["t"]],["qualif"]]],[11,"restrict","","Remove flags which are impossible for the given type.",245,[[["self"],["ty"],["tyctxt"],["paramenv"]]]],[11,"clone","","",247,[[["self"]],["mode"]]],[11,"eq","","",247,[[["self"],["mode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",247,N],[11,"fmt","","",247,[[["self"],["formatter"]],["result"]]],[11,"new","","",246,[[["tyctxt"],["defid"],["mir"],["mode"]],["qualifier"]]],[11,"not_const","","",246,[[["self"]]]],[11,"statement_like","","Error about extra statements in a constant.",246,[[["self"]]]],[11,"add","","Add the given qualification to self.qualif.",246,[[["self"],["qualif"]]]],[11,"add_type","","Add the given type's qualification to self.qualif.",246,[[["self"],["ty"]]]],[11,"nest","","Within the provided closure, self.qualif will start out empty, and its value after the closure returns will be combined with the value before the call to nest.",246,[[["self"],["f"]]]],[11,"assign","","Assign the current qualification to the given destination.",246,[[["self"],["place"],["location"]]]],[11,"qualify_const","","Qualify a whole const, static initializer or const fn.",246,N],[11,"visit_local","","",246,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_place","","",246,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_operand","","",246,[[["self"],["operand"],["location"]]]],[11,"visit_rvalue","","",246,[[["self"],["rvalue"],["location"]]]],[11,"visit_terminator_kind","","",246,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_assign","","",246,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_source_info","","",246,[[["self"],["sourceinfo"]]]],[11,"visit_statement","","",246,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_terminator","","",246,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"run_pass","","",248,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"remove_noop_landing_pads","rustc_mir::transform","",N,N],[3,"RemoveNoopLandingPads","rustc_mir::transform::remove_noop_landing_pads","A pass that removes no-op landing pads and replaces jumps to them with `None`. This is important because otherwise LLVM generates terrible code for these.",N,N],[5,"remove_noop_landing_pads","","",N,[[["tyctxt"],["mir"]]]],[11,"run_pass","","",249,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"is_nop_landing_pad","","",249,[[["self"],["basicblock"],["mir"],["bitvector"]],["bool"]]],[11,"remove_nop_landing_pads","","",249,[[["self"],["mir"]]]],[0,"dump_mir","rustc_mir::transform","This pass just dumps MIR at a specified point.",N,N],[3,"Marker","rustc_mir::transform::dump_mir","",N,N],[12,"0","","",250,N],[3,"Disambiguator","","",N,N],[12,"is_after","","",251,N],[5,"on_mir_pass","","",N,[[["tyctxt"],["display"],["str"],["mirsource"],["mir"],["bool"]]]],[5,"emit_mir","","",N,[[["tyctxt"],["outputfilenames"]],["result"]]],[11,"name","","",250,[[["self"]],["cow",["str"]]]],[11,"run_pass","","",250,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"fmt","","",251,[[["self"],["formatter"]],["result"]]],[0,"deaggregator","rustc_mir::transform","",N,N],[3,"Deaggregator","rustc_mir::transform::deaggregator","",N,N],[11,"run_pass","","",252,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"instcombine","rustc_mir::transform","Performs various peephole optimizations.",N,N],[3,"InstCombine","rustc_mir::transform::instcombine","",N,N],[3,"InstCombineVisitor","","",N,N],[12,"optimizations","","",253,N],[3,"OptimizationFinder","","Finds optimization opportunities on the MIR.",N,N],[12,"mir","","",254,N],[12,"tcx","","",254,N],[12,"optimizations","","",254,N],[3,"OptimizationList","","",N,N],[12,"and_stars","","",255,N],[12,"arrays_lengths","","",255,N],[11,"run_pass","","",256,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_rvalue","","",253,[[["self"],["rvalue"],["location"]]]],[11,"new","","",254,[[["mir"],["tyctxt"]],["optimizationfinder"]]],[11,"visit_rvalue","","",254,[[["self"],["rvalue"],["location"]]]],[11,"default","","",255,[[],["optimizationlist"]]],[0,"copy_prop","rustc_mir::transform","Trivial copy propagation pass.",N,N],[3,"CopyPropagation","rustc_mir::transform::copy_prop","",N,N],[3,"ConstantPropagationVisitor","","",N,N],[12,"dest_local","","",257,N],[12,"constant","","",257,N],[12,"uses_replaced","","",257,N],[4,"Action","","",N,N],[13,"PropagateLocalCopy","","",258,N],[13,"PropagateConstant","","",258,N],[5,"eliminate_self_assignments","","",N,[[["mir"],["defuseanalysis"]],["bool"]]],[11,"run_pass","","",259,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"local_copy","","",258,[[["mir"],["defuseanalysis"],["place"]],["option",["action"]]]],[11,"constant","","",258,[[["constant"]],["option",["action"]]]],[11,"perform","","",258,[[["self"],["mir"],["defuseanalysis"],["local"],["location"]],["bool"]]],[11,"new","","",257,[[["local"],["constant"]],["constantpropagationvisitor"]]],[11,"visit_operand","","",257,[[["self"],["operand"],["location"]]]],[0,"const_prop","rustc_mir::transform","Propagates constants for early reporting of statically known assertion failures",N,N],[3,"ConstProp","rustc_mir::transform::const_prop","",N,N],[3,"ConstPropagator","","Finds optimization opportunities on the MIR.",N,N],[12,"ecx","","",260,N],[12,"mir","","",260,N],[12,"tcx","","",260,N],[12,"source","","",260,N],[12,"places","","",260,N],[12,"can_const_prop","","",260,N],[12,"param_env","","",260,N],[3,"CanConstProp","","",N,N],[12,"can_const_prop","","",261,N],[12,"found_assignment","","",261,N],[5,"type_size_of","","",N,[[["tyctxt"],["paramenv"],["ty"]],["option",["u64"]]]],[6,"Const","","",N,N],[11,"run_pass","","",262,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"new","","",260,[[["mir"],["tyctxt"],["mirsource"]],["constpropagator"]]],[11,"use_ecx","","",260,[[["self"],["sourceinfo"],["f"]],["option"]]],[11,"eval_constant","","",260,[[["self"],["constant"],["sourceinfo"]],["option"]]],[11,"eval_place","","",260,[[["self"],["place"],["sourceinfo"]],["option"]]],[11,"eval_operand","","",260,[[["self"],["operand"],["sourceinfo"]],["option"]]],[11,"const_prop","","",260,[[["self"],["rvalue"],["tylayout"],["sourceinfo"]],["option"]]],[11,"check","","returns true if `local` can be propagated",261,[[["mir"]],["indexvec",["local","bool"]]]],[11,"visit_local","","",261,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_constant","","",260,[[["self"],["constant"],["location"]]]],[11,"visit_statement","","",260,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_terminator_kind","","",260,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[0,"generator","rustc_mir::transform","This is the implementation of the pass which transforms generators into state machines.",N,N],[3,"StateTransform","rustc_mir::transform::generator","",N,N],[3,"RenameLocalVisitor","","",N,N],[12,"from","","",263,N],[12,"to","","",263,N],[3,"DerefArgVisitor","","",N,N],[3,"SuspensionPoint","","",N,N],[12,"state","","",264,N],[12,"resume","","",264,N],[12,"drop","","",264,N],[12,"storage_liveness","","",264,N],[3,"TransformVisitor","","",N,N],[12,"tcx","","",265,N],[12,"state_adt_ref","","",265,N],[12,"state_substs","","",265,N],[12,"state_field","","",265,N],[12,"remap","","",265,N],[12,"storage_liveness","","",265,N],[12,"suspension_points","","",265,N],[12,"new_ret_local","","",265,N],[3,"StorageIgnored","","",N,N],[12,"0","","",266,N],[3,"BorrowedLocals","","",N,N],[12,"0","","",267,N],[5,"self_arg","","",N,[[],["local"]]],[5,"make_generator_state_argument_indirect","","",N,[[["tyctxt"],["defid"],["mir"]]]],[5,"replace_result_variable","","",N,[[["ty"],["mir"]],["local"]]],[5,"mark_as_borrowed","","",N,[[["place"],["borrowedlocals"]]]],[5,"locals_live_across_suspend_points","","",N,N],[5,"compute_layout","","",N,N],[5,"insert_switch","","",N,[[["tyctxt"],["mir"],["vec"],["transformvisitor"],["terminatorkind"]]]],[5,"elaborate_generator_drops","","",N,[[["tyctxt"],["defid"],["mir"]]]],[5,"create_generator_drop_shim","","",N,[[["tyctxt"],["transformvisitor"],["defid"],["mirsource"],["ty"],["mir"],["basicblock"]],["mir"]]],[5,"insert_term_block","","",N,[[["mir"],["terminatorkind"]],["basicblock"]]],[5,"insert_panic_block","","",N,[[["tyctxt"],["mir"],["assertmessage"]],["basicblock"]]],[5,"create_generator_resume_function","","",N,[[["tyctxt"],["transformvisitor"],["defid"],["mirsource"],["mir"]]]],[5,"source_info","","",N,[[["mir"]],["sourceinfo"]]],[5,"insert_clean_drop","","",N,[[["mir"]],["basicblock"]]],[5,"create_cases","","",N,[[["mir"],["transformvisitor"],["f"]],["vec"]]],[11,"visit_local","","",263,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_local","","",268,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_place","","",268,[[["self"],["place"],["placecontext"],["location"]]]],[11,"make_state","","",265,[[["self"],["usize"],["operand"]],["rvalue"]]],[11,"make_field","","",265,[[["self"],["usize"],["ty"]],["place"]]],[11,"set_state","","",265,[[["self"],["u32"],["sourceinfo"]],["statement"]]],[11,"visit_local","","",265,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_place","","",265,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_basic_block_data","","",265,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_statement","","",266,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_rvalue","","",267,[[["self"],["rvalue"],["location"]]]],[11,"run_pass","","",269,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"inline","rustc_mir::transform","Inlining pass for MIR functions",N,N],[3,"Inline","rustc_mir::transform::inline","",N,N],[3,"CallSite","","",N,N],[12,"callee","","",270,N],[12,"substs","","",270,N],[12,"bb","","",270,N],[12,"location","","",270,N],[3,"Inliner","","",N,N],[12,"tcx","","",271,N],[12,"source","","",271,N],[3,"Integrator","","Integrator.",N,N],[12,"block_idx","","",272,N],[12,"args","","",272,N],[12,"local_map","","",272,N],[12,"scope_map","","",272,N],[12,"promoted_map","","",272,N],[12,"_callsite","","",272,N],[12,"destination","","",272,N],[12,"return_block","","",272,N],[12,"cleanup_block","","",272,N],[12,"in_cleanup_block","","",272,N],[5,"type_size_of","","",N,[[["tyctxt"],["paramenv"],["ty"]],["option",["u64"]]]],[17,"DEFAULT_THRESHOLD","","",N,N],[17,"HINT_THRESHOLD","","",N,N],[17,"INSTR_COST","","",N,N],[17,"CALL_PENALTY","","",N,N],[17,"UNKNOWN_SIZE_COST","","",N,N],[11,"clone","","",270,[[["self"]],["callsite"]]],[11,"fmt","","",270,[[["self"],["formatter"]],["result"]]],[11,"run_pass","","",273,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"run_pass","","",271,[[["self"],["mir"]]]],[11,"should_inline","","",271,[[["self"],["callsite"],["mir"]],["bool"]]],[11,"inline_call","","",271,[[["self"],["callsite"],["mir"],["mir"]],["bool"]]],[11,"make_call_args","","",271,[[["self"],["vec",["operand"]],["callsite"],["mir"]],["vec",["local"]]]],[11,"create_temp_if_necessary","","If `arg` is already a temporary, returns it. Otherwise, introduces a fresh temporary `T` and an instruction `T = arg`, and returns `T`.",271,[[["self"],["operand"],["callsite"],["mir"]],["local"]]],[11,"update_target","","",272,[[["self"],["basicblock"]],["basicblock"]]],[11,"visit_local","","",272,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_place","","",272,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_basic_block_data","","",272,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_terminator_kind","","",272,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_source_scope","","",272,[[["self"],["sourcescope"]]]],[0,"lower_128bit","rustc_mir::transform","Replaces 128-bit operators with lang item calls",N,N],[3,"Lower128Bit","rustc_mir::transform::lower_128bit","",N,N],[4,"RhsKind","","",N,N],[13,"Unchanged","","",274,N],[13,"ForceU128","","",274,N],[13,"ForceU32","","",274,N],[5,"check_lang_item_type","","",N,[[["langitem"],["place"],["operand"],["operand"],["d"],["tyctxt"]],["defid"]]],[5,"lower_to","","",N,[[["statement"],["d"],["tyctxt"]],["option"]]],[5,"sign_of_128bit","","",N,[[["ty"]],["option",["bool"]]]],[5,"item_for_op","","",N,[[["binop"],["bool"]],["option"]]],[5,"item_for_checked_op","","",N,[[["binop"],["bool"]],["option"]]],[11,"run_pass","","",275,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"lower_128bit_ops","","",275,[[["self"],["tyctxt"],["mir"]]]],[11,"clone","","",274,[[["self"]],["rhskind"]]],[11,"ty","","",274,[[["self"],["tyctxt"]],["option",["ty"]]]],[0,"uniform_array_move_out","rustc_mir::transform","",N,N],[3,"UniformArrayMoveOut","rustc_mir::transform::uniform_array_move_out","",N,N],[3,"UniformArrayMoveOutVisitor","","",N,N],[12,"mir","","",276,N],[12,"patch","","",276,N],[12,"tcx","","",276,N],[3,"RestoreSubsliceArrayMoveOut","","",N,N],[3,"LocalUse","","",N,N],[12,"alive","","",277,N],[12,"dead","","",277,N],[12,"use_count","","",277,N],[12,"first_use","","",277,N],[3,"RestoreDataCollector","","",N,N],[12,"locals_use","","",278,N],[12,"candidates","","",278,N],[11,"run_pass","","",279,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_assign","","",276,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"uniform","","",276,[[["self"],["location"],["place"],["placeprojection"],["tys"],["u32"]]]],[11,"run_pass","","",280,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"check_and_patch","","",280,N],[11,"try_get_item_source","","",280,[[["localuse"],["mir"]],["option"]]],[11,"clone","","",277,[[["self"]],["localuse"]]],[11,"fmt","","",277,[[["self"],["formatter"]],["result"]]],[11,"new","","",277,[[],["self"]]],[11,"visit_assign","","",278,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_local","","",278,[[["self"],["local"],["placecontext"],["location"]]]],[8,"MirPass","rustc_mir::transform","A streamlined trait that you can implement to create a pass; the pass will be named after the type, and it will consist of a main loop that goes over each available MIR and applies `run_pass`.",N,N],[11,"name","","",281,[[["self"]],["cow",["str"]]]],[10,"run_pass","","",281,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"fmt","","",216,[[["self"],["formatter"]],["result"]]],[11,"clone","","",216,[[["self"]],["mirsource"]]],[11,"item","","",216,[[["defid"]],["self"]]],[0,"util","rustc_mir","",N,N],[4,"PassWhere","rustc_mir::util","An indication of where we are in the control flow graph. Used for printing extra information in `dump_mir`",N,N],[13,"BeforeCFG","","We have not started dumping the control flow graph, but we are about to.",282,N],[13,"AfterCFG","","We just finished dumping the control flow graph. This is right before EOF",282,N],[13,"BeforeBlock","","We are about to start dumping the given basic block.",282,N],[13,"BeforeLocation","","We are just about to dump the given statement or terminator.",282,N],[13,"AfterLocation","","We just dumped the given statement or terminator.",282,N],[13,"AfterTerminator","","We just dumped the terminator for a block but not the closing `}`.",282,N],[5,"is_disaligned","","Return `true` if this place is allowed to be less aligned than its containing struct (because it is within a packed struct).",N,[[["tyctxt"],["l"],["paramenv"],["place"]],["bool"]]],[5,"dump_enabled","","",N,[[["tyctxt"],["str"],["mirsource"]],["bool"]]],[5,"dump_mir","","If the session is properly configured, dumps a human-readable representation of the mir into:",N,[[["tyctxt"],["option",["display"]],["str"],["display"],["mirsource"],["mir"],["f"]]]],[5,"write_mir_pretty","","Write out a human-readable textual representation for the given MIR.",N,[[["tyctxt"],["option",["defid"]],["write"]],["result"]]],[5,"write_mir_graphviz","","Write a graphviz DOT graph of a list of MIRs.",N,[[["tyctxt"],["option",["defid"]],["w"]],["result"]]],[5,"write_graphviz_node_label","","Write a graphviz HTML-styled label for the given basic block, with all necessary escaping already performed. (This is suitable for emitting directly, as is done in this module, or for use with the LabelText::HtmlStr from libgraphviz.)",N,[[["basicblock"],["mir"],["w"],["u32"],["init"],["fini"]],["result"]]],[5,"suggest_ref_mut","","If possible, suggest replacing `ref` with `ref mut`.",N,[[["tyctxt"],["span"]],["option"]]],[0,"borrowck_errors","","",N,N],[4,"Origin","rustc_mir::util::borrowck_errors","",N,N],[13,"Ast","","",283,N],[13,"Mir","","",283,N],[8,"BorrowckErrors","","",N,N],[10,"struct_span_err_with_code","","",284,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[10,"struct_span_err","","",284,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[10,"cancel_if_wrong_origin","","Cancels the given error if we shouldn't emit errors for a given origin in the current mode.",284,[[["self"],["diagnosticbuilder"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_when_borrowed","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_use_when_mutably_borrowed","","",284,[[["self"],["span"],["str"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_act_on_uninitialized_variable","","",284,[[["self"],["span"],["str"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_mutably_borrow_multiply","","",284,[[["self"],["span"],["str"],["str"],["span"],["str"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_uniquely_borrow_by_two_closures","","",284,[[["self"],["span"],["str"],["span"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_uniquely_borrow_by_one_closure","","",284,[[["self"],["span"],["str"],["str"],["span"],["str"],["str"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_reborrow_already_uniquely_borrowed","","",284,[[["self"],["span"],["str"],["str"],["str"],["span"],["str"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_reborrow_already_borrowed","","",284,[[["self"],["span"],["str"],["str"],["str"],["span"],["str"],["str"],["str"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_assign_to_borrowed","","",284,[[["self"],["span"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_into_closure","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_reassign_immutable","","",284,[[["self"],["span"],["str"],["bool"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_assign","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_assign_static","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_out_of","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_out_of_interior_noncopy","","Signal an error due to an attempt to move out of the interior of an array or slice. `is_index` is None when error origin didn't capture whether there was an indexing operation or not.",284,[[["self"],["span"],["ty"],["option",["bool"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_out_of_interior_of_drop","","",284,[[["self"],["span"],["ty"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_act_on_moved_value","","",284,[[["self"],["span"],["str"],["str"],["option",["string"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_partially_reinit_an_uninit_struct","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"closure_cannot_assign_to_borrowed","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_borrow_path_as_mutable_because","","",284,[[["self"],["span"],["str"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_borrow_path_as_mutable","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_borrow_across_generator_yield","","",284,[[["self"],["span"],["span"],["origin"]],["diagnosticbuilder"]]],[11,"path_does_not_live_long_enough","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"lifetime_too_short_for_reborrow","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_act_on_capture_in_sharable_fn","","",284,N],[11,"cannot_assign_into_immutable_reference","","",284,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_capture_in_long_lived_closure","","",284,[[["self"],["span"],["str"],["span"],["origin"]],["diagnosticbuilder"]]],[11,"clone","","",283,[[["self"]],["origin"]]],[11,"eq","","",283,[[["self"],["origin"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",283,N],[11,"fmt","","",283,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",283,[[["self"],["formatter"]],["result"]]],[11,"should_emit_errors","","Whether we should emit errors for the origin in the given mode",283,[[["self"],["borrowckmode"]],["bool"]]],[0,"elaborate_drops","rustc_mir::util","",N,N],[3,"DropCtxt","rustc_mir::util::elaborate_drops","",N,N],[12,"elaborator","","",285,N],[12,"source_info","","",285,N],[12,"place","","",285,N],[12,"path","","",285,N],[12,"succ","","",285,N],[12,"unwind","","",285,N],[4,"DropFlagState","","",N,N],[13,"Present","","",286,N],[13,"Absent","","",286,N],[4,"DropStyle","","",N,N],[13,"Dead","","",287,N],[13,"Static","","",287,N],[13,"Conditional","","",287,N],[13,"Open","","",287,N],[4,"DropFlagMode","","",N,N],[13,"Shallow","","",288,N],[13,"Deep","","",288,N],[4,"Unwind","","",N,N],[13,"To","","",289,N],[13,"InCleanup","","",289,N],[5,"elaborate_drop","","",N,N],[8,"DropElaborator","","",N,N],[16,"Path","","",290,N],[10,"patch","","",290,[[["self"]],["mirpatch"]]],[10,"mir","","",290,[[["self"]],["mir"]]],[10,"tcx","","",290,[[["self"]],["tyctxt"]]],[10,"param_env","","",290,[[["self"]],["paramenv"]]],[10,"drop_style","","",290,N],[10,"get_drop_flag","","",290,N],[10,"clear_drop_flag","","",290,N],[10,"field_subpath","","",290,N],[10,"deref_subpath","","",290,N],[10,"downcast_subpath","","",290,N],[10,"array_subpath","","",290,N],[11,"fmt","","",286,[[["self"],["formatter"]],["result"]]],[11,"eq","","",286,[[["self"],["dropflagstate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",286,N],[11,"clone","","",286,[[["self"]],["dropflagstate"]]],[11,"value","","",286,[[["self"]],["bool"]]],[11,"fmt","","",287,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",288,[[["self"],["formatter"]],["result"]]],[11,"clone","","",289,[[["self"]],["unwind"]]],[11,"fmt","","",289,[[["self"],["formatter"]],["result"]]],[11,"is_cleanup","","",289,[[["self"]],["bool"]]],[11,"into_option","","",289,[[["self"]],["option",["basicblock"]]]],[11,"map","","",289,[[["self"],["f"]],["self"]]],[11,"fmt","","",285,[[["self"],["formatter"]],["result"]]],[11,"place_ty","","",285,[[["self"],["place"]],["ty"]]],[11,"tcx","","",285,[[["self"]],["tyctxt"]]],[11,"elaborate_drop","","This elaborates a single drop instruction, located at `bb`, and patches over it.",285,[[["self"],["basicblock"]]]],[11,"move_paths_for_fields","","Return the place and move path for each field of `variant`, (the move path is `None` if the field is a rest field).",285,N],[11,"drop_subpath","","",285,[[["self"],["place"],["option"],["basicblock"],["unwind"]],["basicblock"]]],[11,"drop_halfladder","","Create one-half of the drop ladder for a list of fields, and return the list of steps in it in reverse order, with the first step dropping 0 fields and so on.",285,N],[11,"drop_ladder_bottom","","",285,N],[11,"drop_ladder","","Create a full drop ladder, consisting of 2 connected half-drop-ladders",285,N],[11,"open_drop_for_tuple","","",285,N],[11,"open_drop_for_box","","",285,[[["self"],["adtdef"],["substs"]],["basicblock"]]],[11,"open_drop_for_adt","","",285,[[["self"],["adtdef"],["substs"]],["basicblock"]]],[11,"open_drop_for_adt_contents","","",285,N],[11,"open_drop_for_multivariant","","",285,N],[11,"adt_switch_block","","",285,N],[11,"destructor_call_block","","",285,N],[11,"drop_loop","","create a loop that drops an array:",285,[[["self"],["basicblock"],["local"],["place"],["ty"],["unwind"],["bool"]],["basicblock"]]],[11,"open_drop_for_array","","",285,[[["self"],["ty"],["option",["u64"]]],["basicblock"]]],[11,"drop_loop_pair","","",285,[[["self"],["ty"],["bool"]],["basicblock"]]],[11,"open_drop","","The slow-path - create an \"open\", elaborated drop for a type which is moved-out-of only partially, and patch `bb` to a jump to it. This must not be called on ADTs with a destructor, as these can't be moved-out-of, except for `Box<T>`, which is special-cased.",285,[[["self"]],["basicblock"]]],[11,"complete_drop","","Return a basic block that drop a place using the context and path in `c`. If `mode` is something, also clear `c` according to it.",285,[[["self"],["option",["dropflagmode"]],["basicblock"],["unwind"]],["basicblock"]]],[11,"drop_flag_reset_block","","",285,[[["self"],["dropflagmode"],["basicblock"],["unwind"]],["basicblock"]]],[11,"elaborated_drop_block","","",285,[[["self"]],["basicblock"]]],[11,"box_free_block","","",285,[[["self"],["adtdef"],["substs"],["basicblock"],["unwind"]],["basicblock"]]],[11,"unelaborated_free_block","","",285,[[["self"],["adtdef"],["substs"],["basicblock"],["unwind"]],["basicblock"]]],[11,"drop_block","","",285,[[["self"],["basicblock"],["unwind"]],["basicblock"]]],[11,"drop_flag_test_block","","",285,[[["self"],["basicblock"],["basicblock"],["unwind"]],["basicblock"]]],[11,"new_block","","",285,[[["self"],["unwind"],["terminatorkind"]],["basicblock"]]],[11,"new_temp","","",285,[[["self"],["ty"]],["local"]]],[11,"terminator_loc","","",285,[[["self"],["basicblock"]],["location"]]],[11,"constant_usize","","",285,[[["self"],["u16"]],["operand"]]],[11,"assign","","",285,[[["self"],["place"],["rvalue"]],["statement"]]],[0,"def_use","rustc_mir::util","Def-use analysis.",N,N],[3,"DefUseAnalysis","rustc_mir::util::def_use","",N,N],[12,"info","","",291,N],[3,"Info","","",N,N],[12,"defs_and_uses","","",292,N],[3,"Use","","",N,N],[12,"context","","",293,N],[12,"location","","",293,N],[3,"DefUseFinder","","",N,N],[12,"info","","",294,N],[3,"MutateUseVisitor","","",N,N],[12,"query","","",295,N],[12,"callback","","",295,N],[12,"phantom","","",295,N],[11,"clone","","",292,[[["self"]],["info"]]],[11,"clone","","",293,[[["self"]],["use"]]],[11,"new","","",291,[[["mir"]],["defuseanalysis"]]],[11,"analyze","","",291,[[["self"],["mir"]]]],[11,"clear","","",291,[[["self"]]]],[11,"local_info","","",291,[[["self"],["local"]],["info"]]],[11,"mutate_defs_and_uses","","",291,[[["self"],["local"],["mir"],["f"]]]],[11,"replace_all_defs_and_uses_with","","FIXME(pcwalton): This should update the def-use chains.",291,[[["self"],["local"],["mir"],["local"]]]],[11,"visit_local","","",294,[[["self"],["local"],["placecontext"],["location"]]]],[11,"new","","",292,[[],["info"]]],[11,"clear","","",292,[[["self"]]]],[11,"def_count","","",292,[[["self"]],["usize"]]],[11,"def_count_not_including_drop","","",292,[[["self"]],["usize"]]],[11,"defs_not_including_drop","","",292,[[["self"]],["filter",["iter"]]]],[11,"use_count","","",292,[[["self"]],["usize"]]],[11,"new","","",295,[[["local"],["f"],["mir"]],["mutateusevisitor"]]],[11,"visit_local","","",295,[[["self"],["local"],["placecontext"],["location"]]]],[0,"patch","rustc_mir::util","",N,N],[3,"MirPatch","rustc_mir::util::patch","This struct represents a patch to MIR, which can add new statements and basic blocks and patch over block terminators.",N,N],[12,"patch_map","","",296,N],[12,"new_blocks","","",296,N],[12,"new_statements","","",296,N],[12,"new_locals","","",296,N],[12,"resume_block","","",296,N],[12,"next_local","","",296,N],[12,"make_nop","","",296,N],[11,"new","","",296,[[["mir"]],["self"]]],[11,"resume_block","","",296,[[["self"]],["basicblock"]]],[11,"is_patched","","",296,[[["self"],["basicblock"]],["bool"]]],[11,"terminator_loc","","",296,[[["self"],["mir"],["basicblock"]],["location"]]],[11,"new_temp","","",296,[[["self"],["ty"],["span"]],["local"]]],[11,"new_internal","","",296,[[["self"],["ty"],["span"]],["local"]]],[11,"new_block","","",296,[[["self"],["basicblockdata"]],["basicblock"]]],[11,"patch_terminator","","",296,[[["self"],["basicblock"],["terminatorkind"]]]],[11,"add_statement","","",296,[[["self"],["location"],["statementkind"]]]],[11,"add_assign","","",296,[[["self"],["location"],["place"],["rvalue"]]]],[11,"make_nop","","",296,[[["self"],["location"]]]],[11,"apply","","",296,[[["self"],["mir"]]]],[11,"source_info_for_index","","",296,[[["basicblockdata"],["location"]],["sourceinfo"]]],[11,"source_info_for_location","","",296,[[["self"],["mir"],["location"]],["sourceinfo"]]],[0,"alignment","rustc_mir::util","",N,N],[5,"is_disaligned","rustc_mir::util::alignment","Return `true` if this place is allowed to be less aligned than its containing struct (because it is within a packed struct).",N,[[["tyctxt"],["l"],["paramenv"],["place"]],["bool"]]],[5,"is_within_packed","","",N,[[["tyctxt"],["l"],["place"]],["bool"]]],[0,"graphviz","rustc_mir::util","",N,N],[5,"write_mir_graphviz","rustc_mir::util::graphviz","Write a graphviz DOT graph of a list of MIRs.",N,[[["tyctxt"],["option",["defid"]],["w"]],["result"]]],[5,"write_mir_fn_graphviz","","Write a graphviz DOT graph of the MIR.",N,[[["tyctxt"],["defid"],["mir"],["w"]],["result"]]],[5,"write_node_label","","Write a graphviz HTML-styled label for the given basic block, with all necessary escaping already performed. (This is suitable for emitting directly, as is done in this module, or for use with the LabelText::HtmlStr from libgraphviz.)",N,[[["basicblock"],["mir"],["w"],["u32"],["init"],["fini"]],["result"]]],[5,"write_node","","Write a graphviz DOT node for the given basic block.",N,[[["basicblock"],["mir"],["w"]],["result"]]],[5,"write_edges","","Write graphviz DOT edges with labels between the given basic block and all of its successors.",N,[[["basicblock"],["mir"],["w"]],["result"]]],[5,"write_graph_label","","Write the graphviz DOT label for the overall graph. This is essentially a block of text that will appear below the graph, showing the type of the `fn` this MIR represents and the types of all the variables and temporaries.",N,[[["tyctxt"],["defid"],["mir"],["w"]],["result"]]],[5,"node","","",N,[[["basicblock"]],["string"]]],[5,"escape","","",N,[[["t"]],["string"]]],[0,"pretty","rustc_mir::util","",N,N],[3,"ExtraComments","rustc_mir::util::pretty","",N,N],[12,"_tcx","","",297,N],[12,"comments","","",297,N],[4,"PassWhere","","An indication of where we are in the control flow graph. Used for printing extra information in `dump_mir`",N,N],[13,"BeforeCFG","","We have not started dumping the control flow graph, but we are about to.",282,N],[13,"AfterCFG","","We just finished dumping the control flow graph. This is right before EOF",282,N],[13,"BeforeBlock","","We are about to start dumping the given basic block.",282,N],[13,"BeforeLocation","","We are just about to dump the given statement or terminator.",282,N],[13,"AfterLocation","","We just dumped the given statement or terminator.",282,N],[13,"AfterTerminator","","We just dumped the terminator for a block but not the closing `}`.",282,N],[5,"dump_mir","","If the session is properly configured, dumps a human-readable representation of the mir into:",N,[[["tyctxt"],["option",["display"]],["str"],["display"],["mirsource"],["mir"],["f"]]]],[5,"dump_enabled","","",N,[[["tyctxt"],["str"],["mirsource"]],["bool"]]],[5,"dump_matched_mir_node","","",N,[[["tyctxt"],["option",["display"]],["str"],["str"],["display"],["mirsource"],["mir"],["f"]]]],[5,"dump_path","","Returns the path to the filename where we should dump a given MIR. Also used by other bits of code (e.g., NLL inference) that dump graphviz data or other things.",N,[[["tyctxt"],["str"],["option",["display"]],["str"],["display"],["mirsource"]],["pathbuf"]]],[5,"create_dump_file","","Attempts to open a file where we should dump a given MIR or other bit of MIR-related data. Used by `mir-dump`, but also by other bits of code (e.g., NLL inference) that dump graphviz data or other things, and hence takes the extension as an argument.",N,[[["tyctxt"],["str"],["option",["display"]],["str"],["display"],["mirsource"]],["result",["file"]]]],[5,"write_mir_pretty","","Write out a human-readable textual representation for the given MIR.",N,[[["tyctxt"],["option",["defid"]],["write"]],["result"]]],[5,"write_mir_fn","","",N,[[["tyctxt"],["mirsource"],["mir"],["f"],["write"]],["result"]]],[5,"write_basic_block","","Write out a human-readable textual representation for the given basic block.",N,[[["tyctxt"],["basicblock"],["mir"],["f"],["write"]],["result"]]],[5,"write_extra","","After we print the main statement, we sometimes dump extra information. There's often a lot of little things \"nuzzled up\" in a statement.",N,[[["tyctxt"],["write"],["f"]],["result"]]],[5,"comment","","",N,[[["tyctxt"],["sourceinfo"]],["string"]]],[5,"write_scope_tree","","Prints user-defined variables in a scope tree.",N,[[["tyctxt"],["mir"],["fxhashmap"],["write"],["sourcescope"],["usize"]],["result"]]],[5,"write_mir_intro","","Write out a human-readable textual representation of the MIR's `fn` type and the types of its local variables (both user-defined bindings and compiler temporaries).",N,[[["tyctxt"],["mirsource"],["mir"],["write"]],["result"]]],[5,"write_mir_sig","","",N,[[["tyctxt"],["mirsource"],["mir"],["write"]],["result"]]],[5,"write_temp_decls","","",N,[[["mir"],["write"]],["result"]]],[5,"dump_mir_def_ids","","",N,[[["tyctxt"],["option",["defid"]]],["vec",["defid"]]]],[17,"INDENT","","",N,N],[17,"ALIGN","","Alignment for lining up comments following MIR statements",N,N],[11,"push","","",297,[[["self"],["str"]]]],[11,"visit_constant","","",297,[[["self"],["constant"],["location"]]]],[11,"visit_const","","",297,[[["self"],["const"],["location"]]]],[11,"visit_rvalue","","",297,[[["self"],["rvalue"],["location"]]]],[0,"liveness","rustc_mir::util","Liveness analysis which computes liveness of MIR local variables at the boundary of basic blocks",N,N],[3,"LivenessResult","rustc_mir::util::liveness","This gives the result of the liveness analysis at the boundary of basic blocks. You can use `simulate_block` to obtain the intra-block results.",N,N],[12,"mode","","Liveness mode in use when these results were computed.",298,N],[12,"outs","","Live variables on exit to each basic block. This is equal to the union of the `ins` for each successor.",298,N],[3,"IdentityMap","","",N,N],[12,"mir","","",299,N],[3,"LivenessMode","","",N,N],[12,"include_regular_use","","If true, then we will consider \"regular uses\" of a variable to be live. For example, if the user writes `foo(x)`, then this is a regular use of the variable `x`.",300,N],[12,"include_drops","","If true, then we will consider (implicit) drops of a variable to be live.  For example, if the user writes `{ let x = vec![...]; .. }`, then the drop at the end of the block is an implicit drop.",300,N],[3,"LivenessResults","","A combination of liveness results, used in NLL.",N,N],[12,"regular","","Liveness results where a regular use makes a variable X live, but not a drop.",301,N],[12,"drop","","Liveness results where a drop makes a variable X live, but not a regular use.",301,N],[3,"DefsUsesVisitor","","",N,N],[12,"mode","","",302,N],[12,"map","","",302,N],[12,"defs_uses","","",302,N],[3,"DefsUses","","",N,N],[12,"defs","","",303,N],[12,"uses","","",303,N],[4,"DefUse","","",N,N],[13,"Def","","",304,N],[13,"Use","","",304,N],[5,"liveness_of_locals","","Compute which local variables are live within the given function `mir`. The liveness mode `mode` determines what sorts of uses are considered to make a variable live (e.g., do drops count?).",N,N],[5,"categorize","","",N,[[["placecontext"],["livenessmode"]],["option",["defuse"]]]],[5,"block","","",N,N],[5,"dump_mir","","",N,N],[5,"dump_matched_mir_node","","",N,[[["tyctxt"],["str"],["str"],["mirsource"],["mir"],["livevariablemap"],["livenessresult"]]]],[5,"write_mir_fn","","",N,[[["tyctxt"],["mirsource"],["mir"],["livevariablemap"],["write"],["livenessresult"]],["result"]]],[6,"LiveVarSet","","",N,N],[8,"LiveVariableMap","","Defines the mapping to/from the MIR local variables (`Local`) to the \"live variable indices\" we are using in a particular computation.",N,N],[16,"LiveVar","","",305,N],[10,"from_local","","",305,[[["self"],["local"]],["option"]]],[10,"from_live_var","","",305,N],[10,"num_variables","","",305,[[["self"]],["usize"]]],[11,"fmt","","",299,[[["self"],["formatter"]],["result"]]],[11,"new","","",299,[[["mir"]],["self"]]],[11,"from_local","","",299,[[["self"],["local"]],["option"]]],[11,"from_live_var","","",299,N],[11,"num_variables","","",299,[[["self"]],["usize"]]],[11,"clone","","",300,[[["self"]],["livenessmode"]]],[11,"fmt","","",300,[[["self"],["formatter"]],["result"]]],[11,"compute","","",301,N],[11,"simulate_block","","Walks backwards through the statements/terminator in the given basic block `block`.  At each point within `block`, invokes the callback `op` with the current location and the set of variables that are live on entry to that location.",298,N],[11,"assert_receiver_is_total_eq","","",304,N],[11,"eq","","",304,[[["self"],["defuse"]],["bool"]]],[11,"clone","","",304,[[["self"]],["defuse"]]],[11,"assert_receiver_is_total_eq","","",303,N],[11,"eq","","",303,[[["self"],["defsuses"]],["bool"]]],[11,"ne","","",303,[[["self"],["defsuses"]],["bool"]]],[11,"clone","","",303,[[["self"]],["defsuses"]]],[11,"clear","","",303,[[["self"]]]],[11,"apply","","",303,[[["self"],["livevarset"]],["bool"]]],[11,"add_def","","",303,[[["self"],["v"]]]],[11,"add_use","","",303,[[["self"],["v"]]]],[11,"update_bits_and_do_callback","","Update `bits` with the effects of `value` and call `callback`. We should always visit in reverse order. This method assumes that we have not visited anything before; if you have, clear `bits` first.",302,N],[11,"visit_local","","",302,[[["self"],["local"],["placecontext"],["location"]]]],[0,"collect_writes","rustc_mir::util","",N,N],[3,"FindLocalAssignmentVisitor","rustc_mir::util::collect_writes","",N,N],[12,"needle","","",306,N],[12,"locations","","",306,N],[5,"is_place_assignment","","Returns true if this place context represents an assignment statement",N,[[["placecontext"]],["bool"]]],[8,"FindAssignments","","",N,N],[10,"find_assignments","","",307,[[["self"],["local"]],["vec",["location"]]]],[11,"visit_local","","",306,[[["self"],["local"],["placecontext"],["location"]]]],[0,"interpret","rustc_mir","An interpreter for MIR used in CTFE and by miri",N,N],[5,"write_target_uint","rustc_mir::interpret","",N,N],[5,"write_target_int","","",N,N],[5,"read_target_uint","","",N,N],[3,"EvalContext","","",N,N],[12,"machine","","Stores the `Machine` instance.",308,N],[12,"tcx","","The results of the type checker, from rustc.",308,N],[12,"param_env","","Bounds in scope for polymorphic evaluations.",308,N],[12,"memory","","The virtual memory system.",308,N],[12,"stack","","The virtual call stack.",308,N],[12,"stack_limit","","The maximum number of stack frames allowed",308,N],[12,"steps_since_detector_enabled","","When this value is negative, it indicates the number of interpreter steps until the loop detector is enabled. When it is positive, it is the number of steps after the detector has been enabled modulo the loop detector period.",308,N],[12,"loop_detector","","",308,N],[3,"Frame","","A stack frame.",N,N],[12,"mir","","The MIR for the function called on this frame.",309,N],[12,"instance","","The def_id and substs of the current function",309,N],[12,"span","","The span of the call site.",309,N],[12,"return_to_block","","The block to return to when returning from the current stack frame",309,N],[12,"return_place","","The location where the result of the current stack frame should be written to.",309,N],[12,"locals","","The list of locals for this stack frame, stored in order as `[return_ptr, arguments..., variables..., temporaries...]`. The locals are stored as `Option<Value>`s. `None` represents a local that is currently dead, while a live local can either directly contain `Scalar` or refer to some part of an `Allocation`.",309,N],[12,"block","","The block that is currently executed (or will be executed after the above call stacks return).",309,N],[12,"stmt","","The index of the currently evaluated statement.",309,N],[3,"TyAndPacked","","",N,N],[12,"ty","","",310,N],[12,"packed","","",310,N],[3,"ValTy","","",N,N],[12,"value","","",311,N],[12,"ty","","",311,N],[3,"Memory","","",N,N],[12,"data","","Additional data required by the Machine",312,N],[12,"alloc_kind","","Helps guarantee that stack allocations aren't deallocated via `rust_deallocate`",312,N],[12,"alloc_map","","Actual memory allocations (arbitrary bytes, may contain pointers into other allocations).",312,N],[12,"cur_frame","","The current stack frame.  Used to check accesses against locks.",312,N],[12,"tcx","","",312,N],[3,"CompileTimeEvaluator","","",N,N],[4,"StackPopCleanup","","",N,N],[13,"MarkStatic","","The stackframe existed to compute the initial value of a static/constant, make sure it isn't modifyable afterwards in case of constants. In case of `static mut`, mark the memory to ensure it's never marked as immutable through references or deallocated",313,N],[13,"Goto","","A regular stackframe added due to a function call will need to get forwarded to the next block",313,N],[13,"None","","The main function and diverging functions have nowhere to return to",313,N],[4,"Place","","",N,N],[13,"Ptr","","A place referring to a value allocated in the `Memory` system.",314,N],[12,"ptr","rustc_mir::interpret::Place","A place may have an invalid (integral or undef) pointer, since it might be turned back into a reference before ever being dereferenced.",314,N],[12,"align","","",314,N],[12,"extra","","",314,N],[13,"Local","rustc_mir::interpret","A place referring to a value on the stack. Represented by a stack frame index paired with a Mir local index.",314,N],[12,"frame","rustc_mir::interpret::Place","",314,N],[12,"local","","",314,N],[4,"PlaceExtra","rustc_mir::interpret","",N,N],[13,"None","","",315,N],[13,"Length","","",315,N],[13,"Vtable","","",315,N],[13,"DowncastVariant","","",315,N],[4,"MemoryKind","","",N,N],[13,"Stack","","Error if deallocated except during a stack pop",316,N],[13,"Machine","","Additional memory kinds a machine wishes to distinguish from the builtin ones",316,N],[5,"eval_promoted","","",N,[[["evalcontext"],["globalid"],["mir"],["paramenv"]],["evalresult"]]],[5,"mk_borrowck_eval_cx","","",N,[[["tyctxt"],["instance"],["mir"],["span"]],["evalresult",["evalcontext"]]]],[5,"mk_eval_cx","","",N,[[["tyctxt"],["instance"],["paramenv"]],["evalresult",["evalcontext"]]]],[5,"const_value_to_allocation_provider","","",N,[[["tyctxt"],["const"]],["allocation"]]],[5,"const_eval_provider","","",N,[[["tyctxt"],["paramenvand",["globalid"]]],["constevalresult"]]],[5,"const_val_field","","",N,[[["tyctxt"],["paramenv"],["instance"],["option",["usize"]],["field"],["const"]],["constevalresult"]]],[5,"const_variant_index","","",N,[[["tyctxt"],["paramenv"],["instance"],["const"]],["evalresult",["usize"]]]],[5,"value_to_const_value","","",N,[[["evalcontext"],["value"],["ty"]],["const"]]],[5,"sign_extend","","",N,[[["tyctxt"],["u128"],["ty"]],["evalresult",["u128"]]]],[5,"truncate","","",N,[[["tyctxt"],["u128"],["ty"]],["evalresult",["u128"]]]],[0,"cast","","",N,N],[11,"cast","","",308,[[["self"],["valty"],["castkind"],["ty"],["place"]],["evalresult"]]],[11,"cast_scalar","","",308,[[["self"],["scalar"],["ty"],["ty"]],["evalresult",["scalar"]]]],[11,"cast_from_int","","",308,[[["self"],["u128"],["ty"],["ty"]],["evalresult",["scalar"]]]],[11,"cast_from_float","","",308,[[["self"],["u128"],["floatty"],["ty"]],["evalresult",["scalar"]]]],[11,"cast_from_ptr","","",308,[[["self"],["pointer"],["ty"]],["evalresult",["scalar"]]]],[0,"const_eval","","",N,N],[3,"CompileTimeEvaluator","rustc_mir::interpret::const_eval","",N,N],[4,"ConstEvalError","","",N,N],[13,"NeedsRfc","","",317,N],[13,"NotConst","","",317,N],[5,"mk_borrowck_eval_cx","","",N,[[["tyctxt"],["instance"],["mir"],["span"]],["evalresult",["evalcontext"]]]],[5,"mk_eval_cx","","",N,[[["tyctxt"],["instance"],["paramenv"]],["evalresult",["evalcontext"]]]],[5,"eval_promoted","","",N,[[["evalcontext"],["globalid"],["mir"],["paramenv"]],["evalresult"]]],[5,"value_to_const_value","","",N,[[["evalcontext"],["value"],["ty"]],["const"]]],[5,"eval_body_and_ecx","","",N,N],[5,"eval_body_using_ecx","","",N,[[["evalcontext"],["globalid"],["option",["mir"]],["paramenv"]],["evalresult"]]],[5,"const_val_field","","",N,[[["tyctxt"],["paramenv"],["instance"],["option",["usize"]],["field"],["const"]],["constevalresult"]]],[5,"const_variant_index","","",N,[[["tyctxt"],["paramenv"],["instance"],["const"]],["evalresult",["usize"]]]],[5,"const_value_to_allocation_provider","","",N,[[["tyctxt"],["const"]],["allocation"]]],[5,"const_eval_provider","","",N,[[["tyctxt"],["paramenvand",["globalid"]]],["constevalresult"]]],[5,"numeric_intrinsic","","",N,[[["str"],["u128"],["primitive"]],["evalresult",["scalar"]]]],[11,"fmt","rustc_mir::interpret","",318,[[["self"],["formatter"]],["result"]]],[11,"clone","","",318,[[["self"]],["compiletimeevaluator"]]],[11,"assert_receiver_is_total_eq","","",318,N],[11,"eq","","",318,[[["self"],["compiletimeevaluator"]],["bool"]]],[11,"hash","","",318,N],[11,"into","rustc_mir::interpret::const_eval","",317,[[["self"]],["evalerror"]]],[11,"clone","","",317,[[["self"]],["constevalerror"]]],[11,"fmt","","",317,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",317,[[["self"],["formatter"]],["result"]]],[11,"description","","",317,[[["self"]],["str"]]],[11,"cause","","",317,[[["self"]],["option",["error"]]]],[11,"eval_fn_call","rustc_mir::interpret","",318,N],[11,"call_intrinsic","","",318,N],[11,"try_ptr_op","","",318,[[["evalcontext"],["binop"],["scalar"],["ty"],["scalar"],["ty"]],["evalresult",["option"]]]],[11,"mark_static_initialized","","",318,[[["memory"],["allocid"],["mutability"]],["evalresult",["bool"]]]],[11,"init_static","","",318,[[["evalcontext"],["globalid"]],["evalresult",["allocid"]]]],[11,"box_alloc","","",318,[[["evalcontext"],["ty"],["place"]],["evalresult"]]],[11,"global_item_with_linkage","","",318,[[["evalcontext"],["instance"],["mutability"]],["evalresult"]]],[0,"eval_context","","",N,N],[3,"EvalContext","rustc_mir::interpret::eval_context","",N,N],[12,"machine","","Stores the `Machine` instance.",308,N],[12,"tcx","","The results of the type checker, from rustc.",308,N],[12,"param_env","","Bounds in scope for polymorphic evaluations.",308,N],[12,"memory","","The virtual memory system.",308,N],[12,"stack","","The virtual call stack.",308,N],[12,"stack_limit","","The maximum number of stack frames allowed",308,N],[12,"steps_since_detector_enabled","","When this value is negative, it indicates the number of interpreter steps until the loop detector is enabled. When it is positive, it is the number of steps after the detector has been enabled modulo the loop detector period.",308,N],[12,"loop_detector","","",308,N],[3,"Frame","","A stack frame.",N,N],[12,"mir","","The MIR for the function called on this frame.",309,N],[12,"instance","","The def_id and substs of the current function",309,N],[12,"span","","The span of the call site.",309,N],[12,"return_to_block","","The block to return to when returning from the current stack frame",309,N],[12,"return_place","","The location where the result of the current stack frame should be written to.",309,N],[12,"locals","","The list of locals for this stack frame, stored in order as `[return_ptr, arguments..., variables..., temporaries...]`. The locals are stored as `Option<Value>`s. `None` represents a local that is currently dead, while a live local can either directly contain `Scalar` or refer to some part of an `Allocation`.",309,N],[12,"block","","The block that is currently executed (or will be executed after the above call stacks return).",309,N],[12,"stmt","","The index of the currently evaluated statement.",309,N],[3,"InfiniteLoopDetector","","",N,N],[12,"hashes","","The set of all `EvalSnapshot` hashes observed by this detector.",319,N],[12,"snapshots","","The set of all `EvalSnapshot`s observed by this detector.",319,N],[3,"TyAndPacked","","",N,N],[12,"ty","","",310,N],[12,"packed","","",310,N],[3,"ValTy","","",N,N],[12,"value","","",311,N],[12,"ty","","",311,N],[4,"StackPopCleanup","","",N,N],[13,"MarkStatic","","The stackframe existed to compute the initial value of a static/constant, make sure it isn't modifyable afterwards in case of constants. In case of `static mut`, mark the memory to ensure it's never marked as immutable through references or deallocated",313,N],[13,"Goto","","A regular stackframe added due to a function call will need to get forwarded to the next block",313,N],[13,"None","","The main function and diverging functions have nowhere to return to",313,N],[6,"EvalSnapshot","","The virtual machine state during const-evaluation at a given point in time.",N,N],[17,"STEPS_UNTIL_DETECTOR_ENABLED","","",N,N],[11,"clone","rustc_mir::interpret","",309,[[["self"]],["frame"]]],[11,"eq","","",309,[[["self"],["self"]],["bool"]]],[11,"hash","","",309,[[["self"],["h"]]]],[11,"default","rustc_mir::interpret::eval_context","",319,[[],["self"]]],[11,"is_empty","","Returns `true` if the loop detector has not yet observed a snapshot.",319,[[["self"]],["bool"]]],[11,"observe_and_analyze","","",319,[[["self"],["m"],["vec"],["memory"]],["evalresult"]]],[11,"clone","rustc_mir::interpret","",313,[[["self"]],["stackpopcleanup"]]],[11,"fmt","","",313,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",313,N],[11,"eq","","",313,[[["self"],["stackpopcleanup"]],["bool"]]],[11,"ne","","",313,[[["self"],["stackpopcleanup"]],["bool"]]],[11,"hash","","",313,N],[11,"clone","","",310,[[["self"]],["tyandpacked"]]],[11,"fmt","","",310,[[["self"],["formatter"]],["result"]]],[11,"clone","","",311,[[["self"]],["valty"]]],[11,"fmt","","",311,[[["self"],["formatter"]],["result"]]],[11,"deref","","",311,[[["self"]],["value"]]],[11,"new","","",308,N],[11,"with_fresh_body","","",308,[[["self"],["f"]],["r"]]],[11,"alloc_ptr","","",308,[[["self"],["tylayout"]],["evalresult",["pointer"]]]],[11,"memory","","",308,[[["self"]],["memory"]]],[11,"memory_mut","","",308,[[["self"]],["memory"]]],[11,"stack","","",308,N],[11,"cur_frame","","",308,[[["self"]],["usize"]]],[11,"str_to_value","","",308,[[["self"],["str"]],["evalresult",["value"]]]],[11,"const_to_value","","",308,[[["self"],["constvalue"]],["evalresult",["value"]]]],[11,"resolve","","",308,[[["self"],["defid"],["substs"]],["evalresult",["instance"]]]],[11,"type_is_sized","","",308,[[["self"],["ty"]],["bool"]]],[11,"load_mir","","",308,[[["self"],["instancedef"]],["evalresult",["mir"]]]],[11,"monomorphize","","",308,[[["self"],["ty"],["substs"]],["ty"]]],[11,"size_and_align_of_dst","","Return the size and aligment of the value at the given type. Note that the value does not matter if the type is sized. For unsized types, the value has to be a fat pointer, and we only care about the \"extra\" data in it.",308,[[["self"],["ty"],["value"]],["evalresult"]]],[11,"push_stack_frame","","",308,[[["self"],["instance"],["span"],["mir"],["place"],["stackpopcleanup"]],["evalresult"]]],[11,"pop_stack_frame","","",308,[[["self"]],["evalresult"]]],[11,"deallocate_local","","",308,[[["self"],["option",["value"]]],["evalresult"]]],[11,"eval_rvalue_into_place","","Evaluate an assignment statement.",308,[[["self"],["rvalue"],["place"]],["evalresult"]]],[11,"type_is_fat_ptr","","",308,[[["self"],["ty"]],["bool"]]],[11,"eval_operand_to_scalar","","",308,[[["self"],["operand"]],["evalresult",["scalar"]]]],[11,"operands_to_args","","",308,N],[11,"eval_operand","","",308,[[["self"],["operand"]],["evalresult",["valty"]]]],[11,"read_discriminant_as_variant_index","","reads a tag and produces the corresponding variant index",308,[[["self"],["place"],["tylayout"]],["evalresult",["usize"]]]],[11,"read_discriminant_value","","",308,[[["self"],["place"],["tylayout"]],["evalresult",["u128"]]]],[11,"write_discriminant_value","","",308,[[["self"],["ty"],["place"],["usize"]],["evalresult"]]],[11,"read_global_as_value","","",308,[[["self"],["globalid"]],["evalresult",["value"]]]],[11,"const_eval","","",308,[[["self"],["globalid"]],["evalresult",["const"]]]],[11,"allocate_place_for_value","","",308,[[["self"],["value"],["tylayout"],["option",["usize"]]],["evalresult",["place"]]]],[11,"force_allocation","","",308,[[["self"],["place"]],["evalresult",["place"]]]],[11,"follow_by_ref_value","","ensures this Value is not a ByRef",308,[[["self"],["value"],["ty"]],["evalresult",["value"]]]],[11,"value_to_scalar","","",308,[[["self"],["valty"]],["evalresult",["scalar"]]]],[11,"write_ptr","","",308,[[["self"],["place"],["scalar"],["ty"]],["evalresult"]]],[11,"write_scalar","","",308,[[["self"],["place"],["scalar"],["ty"]],["evalresult"]]],[11,"write_value","","",308,[[["self"],["valty"],["place"]],["evalresult"]]],[11,"write_value_possibly_by_val","","",308,[[["self"],["value"],["f"],["value"],["ty"]],["evalresult"]]],[11,"write_value_to_ptr","","",308,[[["self"],["value"],["scalar"],["align"],["ty"]],["evalresult"]]],[11,"read_value","","",308,[[["self"],["scalar"],["align"],["ty"]],["evalresult",["value"]]]],[11,"read_ptr","","",308,[[["self"],["pointer"],["align"],["ty"]],["evalresult",["value"]]]],[11,"validate_scalar","","",308,[[["self"],["scalar"],["size"],["scalar"],["str"],["ty"]],["evalresult"]]],[11,"validate_ptr_target","","This function checks the memory where `ptr` points to. It will error if the bits at the destination do not match the ones described by the layout.",308,[[["self"],["pointer"],["align"],["tylayout"],["string"],["fxhashset"],["vec"]],["evalresult"]]],[11,"try_read_by_ref","","",308,[[["self"],["value"],["ty"]],["evalresult",["value"]]]],[11,"try_read_value","","",308,[[["self"],["scalar"],["align"],["ty"]],["evalresult",["option"]]]],[11,"frame","","",308,[[["self"]],["frame"]]],[11,"frame_mut","","",308,[[["self"]],["frame"]]],[11,"mir","","",308,[[["self"]],["mir"]]],[11,"substs","","",308,[[["self"]],["substs"]]],[11,"unsize_into_ptr","","",308,[[["self"],["value"],["ty"],["place"],["ty"],["ty"],["ty"]],["evalresult"]]],[11,"unsize_into","","",308,[[["self"],["value"],["tylayout"],["place"],["tylayout"]],["evalresult"]]],[11,"dump_local","","",308,[[["self"],["place"]]]],[11,"modify_local","","Convenience function to ensure correct usage of locals",308,[[["self"],["usize"],["local"],["f"]],["evalresult"]]],[11,"generate_stacktrace","","",308,N],[11,"sign_extend","","",308,[[["self"],["u128"],["ty"]],["evalresult",["u128"]]]],[11,"truncate","","",308,[[["self"],["u128"],["ty"]],["evalresult",["u128"]]]],[11,"write_field_name","","",308,[[["self"],["string"],["ty"],["usize"],["usize"]],["result"]]],[11,"get_local","","",309,[[["self"],["local"]],["evalresult",["value"]]]],[11,"set_local","","",309,[[["self"],["local"],["value"]],["evalresult"]]],[11,"storage_live","","",309,[[["self"],["local"]],["option",["value"]]]],[11,"storage_dead","","Returns the old value of the local",309,[[["self"],["local"]],["option",["value"]]]],[0,"place","","",N,N],[4,"Place","rustc_mir::interpret::place","",N,N],[13,"Ptr","","A place referring to a value allocated in the `Memory` system.",314,N],[12,"ptr","rustc_mir::interpret::place::Place","A place may have an invalid (integral or undef) pointer, since it might be turned back into a reference before ever being dereferenced.",314,N],[12,"align","","",314,N],[12,"extra","","",314,N],[13,"Local","rustc_mir::interpret::place","A place referring to a value on the stack. Represented by a stack frame index paired with a Mir local index.",314,N],[12,"frame","rustc_mir::interpret::place::Place","",314,N],[12,"local","","",314,N],[4,"PlaceExtra","rustc_mir::interpret::place","",N,N],[13,"None","","",315,N],[13,"Length","","",315,N],[13,"Vtable","","",315,N],[13,"DowncastVariant","","",315,N],[11,"clone","rustc_mir::interpret","",314,[[["self"]],["place"]]],[11,"fmt","","",314,[[["self"],["formatter"]],["result"]]],[11,"hash","","",314,N],[11,"eq","","",314,[[["self"],["place"]],["bool"]]],[11,"ne","","",314,[[["self"],["place"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",314,N],[11,"clone","","",315,[[["self"]],["placeextra"]]],[11,"fmt","","",315,[[["self"],["formatter"]],["result"]]],[11,"hash","","",315,N],[11,"eq","","",315,[[["self"],["placeextra"]],["bool"]]],[11,"ne","","",315,[[["self"],["placeextra"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",315,N],[11,"undef","","Produces a Place that will error if attempted to be read from",314,[[],["self"]]],[11,"from_scalar_ptr","","",314,[[["scalar"],["align"]],["self"]]],[11,"from_ptr","","",314,[[["pointer"],["align"]],["self"]]],[11,"to_ptr_align_extra","","",314,N],[11,"to_ptr_align","","",314,N],[11,"to_ptr","","",314,[[["self"]],["evalresult",["pointer"]]]],[11,"elem_ty_and_len","","",314,N],[11,"try_read_place","","Reads a value from the place without going through the intermediate step of obtaining a `miri::Place`",308,[[["self"],["place"]],["evalresult",["option"]]]],[11,"read_field","","",308,[[["self"],["value"],["option",["usize"]],["field"],["tylayout"]],["evalresult"]]],[11,"try_read_place_projection","","",308,[[["self"],["placeprojection"]],["evalresult",["option"]]]],[11,"eval_and_read_place","","Returns a value and (in case of a ByRef) if we are supposed to use aligned accesses.",308,[[["self"],["place"]],["evalresult",["value"]]]],[11,"read_place","","",308,[[["self"],["place"]],["evalresult",["value"]]]],[11,"eval_place","","",308,[[["self"],["place"]],["evalresult",["place"]]]],[11,"place_field","","",308,[[["self"],["place"],["field"],["tylayout"]],["evalresult"]]],[11,"val_to_place","","",308,[[["self"],["value"],["ty"]],["evalresult",["place"]]]],[11,"place_index","","",308,[[["self"],["place"],["ty"],["u64"]],["evalresult",["place"]]]],[11,"place_downcast","","",308,[[["self"],["place"],["usize"]],["evalresult",["place"]]]],[11,"eval_place_projection","","",308,[[["self"],["place"],["ty"],["projectionelem"]],["evalresult",["place"]]]],[11,"place_ty","","",308,[[["self"],["place"]],["ty"]]],[0,"machine","","This module contains everything needed to instantiate an interpreter. This separation exists to ensure that no fancy miri features like interpreting common C functions leak into CTFE.",N,N],[8,"Machine","rustc_mir::interpret::machine","Methods of this trait signifies a point where CTFE evaluation would fail and some use case dependent behaviour can instead be applied",N,N],[16,"MemoryData","","Additional data that can be accessed via the Memory",320,N],[16,"MemoryKinds","","Additional memory kinds a machine wishes to distinguish from the builtin ones",320,N],[10,"eval_fn_call","","Entry point to all function calls.",320,N],[10,"call_intrinsic","","directly process an intrinsic without pushing a stack frame.",320,N],[10,"try_ptr_op","","Called for all binary operations except on float types.",320,[[["evalcontext"],["binop"],["scalar"],["ty"],["scalar"],["ty"]],["evalresult",["option"]]]],[10,"mark_static_initialized","","Called when trying to mark machine defined `MemoryKinds` as static",320,[[["memory"],["allocid"],["mutability"]],["evalresult",["bool"]]]],[10,"init_static","","Called when requiring a pointer to a static. Non const eval can create a mutable memory location for `static mut`",320,[[["evalcontext"],["globalid"]],["evalresult",["allocid"]]]],[10,"box_alloc","","Heap allocations via the `box` keyword",320,[[["evalcontext"],["ty"],["place"]],["evalresult"]]],[10,"global_item_with_linkage","","Called when trying to access a global declared with a `linkage` attribute",320,[[["evalcontext"],["instance"],["mutability"]],["evalresult"]]],[11,"check_locks","","",320,[[["memory"],["pointer"],["size"],["accesskind"]],["evalresult"]]],[11,"add_lock","","",320,[[["memory"],["allocid"]]]],[11,"free_lock","","",320,[[["memory"],["allocid"],["u64"]],["evalresult"]]],[11,"end_region","","",320,[[["evalcontext"],["option",["scope"]]],["evalresult"]]],[11,"validation_op","","",320,[[["evalcontext"],["validationop"],["validationoperand"]],["evalresult"]]],[0,"memory","rustc_mir::interpret","",N,N],[5,"write_target_uint","rustc_mir::interpret::memory","",N,N],[5,"write_target_int","","",N,N],[5,"read_target_uint","","",N,N],[3,"Memory","","",N,N],[12,"data","","Additional data required by the Machine",312,N],[12,"alloc_kind","","Helps guarantee that stack allocations aren't deallocated via `rust_deallocate`",312,N],[12,"alloc_map","","Actual memory allocations (arbitrary bytes, may contain pointers into other allocations).",312,N],[12,"cur_frame","","The current stack frame.  Used to check accesses against locks.",312,N],[12,"tcx","","",312,N],[4,"MemoryKind","","",N,N],[13,"Stack","","Error if deallocated except during a stack pop",316,N],[13,"Machine","","Additional memory kinds a machine wishes to distinguish from the builtin ones",316,N],[22,"","","",N,N],[8,"HasMemory","","",N,N],[10,"memory_mut","","",321,[[["self"]],["memory"]]],[10,"memory","","",321,[[["self"]],["memory"]]],[11,"into_ptr","","Convert the value into a pointer (or a pointer-sized integer).  If the value is a ByRef, this may have to perform a load.",321,[[["self"],["value"]],["evalresult",["scalar"]]]],[11,"into_ptr_vtable_pair","","",321,[[["self"],["value"]],["evalresult"]]],[11,"into_slice","","",321,[[["self"],["value"]],["evalresult"]]],[11,"fmt","rustc_mir::interpret","",316,[[["self"],["formatter"]],["result"]]],[11,"eq","","",316,[[["self"],["memorykind"]],["bool"]]],[11,"ne","","",316,[[["self"],["memorykind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",316,N],[11,"clone","","",316,[[["self"]],["memorykind"]]],[11,"clone","","",312,[[["self"]],["memory"]]],[11,"eq","","",312,[[["self"],["self"]],["bool"]]],[11,"hash","","",312,[[["self"],["h"]]]],[11,"new","","",312,N],[11,"allocations","","",312,[[["self"]],[""]]],[11,"create_fn_alloc","","",312,[[["self"],["instance"]],["pointer"]]],[11,"allocate_bytes","","",312,N],[11,"allocate_value","","kind is `None` for statics",312,[[["self"],["allocation"],["memorykind"]],["evalresult",["allocid"]]]],[11,"allocate","","kind is `None` for statics",312,[[["self"],["size"],["align"],["memorykind"]],["evalresult",["pointer"]]]],[11,"reallocate","","",312,[[["self"],["pointer"],["size"],["align"],["size"],["align"],["memorykind"]],["evalresult",["pointer"]]]],[11,"deallocate_local","","",312,[[["self"],["pointer"]],["evalresult"]]],[11,"deallocate","","",312,[[["self"],["pointer"],["option"],["memorykind"]],["evalresult"]]],[11,"pointer_size","","",312,[[["self"]],["size"]]],[11,"endianness","","",312,[[["self"]],["endian"]]],[11,"check_align","","Check that the pointer is aligned AND non-NULL.",312,[[["self"],["scalar"],["align"]],["evalresult"]]],[11,"check_bounds","","",312,[[["self"],["pointer"],["bool"]],["evalresult"]]],[11,"const_eval_static","","",312,[[["self"],["defid"]],["evalresult",["allocation"]]]],[11,"get","","",312,[[["self"],["allocid"]],["evalresult",["allocation"]]]],[11,"get_mut","","",312,[[["self"],["allocid"]],["evalresult",["allocation"]]]],[11,"get_fn","","",312,[[["self"],["pointer"]],["evalresult",["instance"]]]],[11,"get_alloc_kind","","",312,[[["self"],["allocid"]],["option",["memorykind"]]]],[11,"dump_alloc","","For debugging, print an allocation and all allocations it points to, recursively.",312,[[["self"],["allocid"]]]],[11,"dump_allocs","","For debugging, print a list of allocations and all allocations they point to, recursively.",312,[[["self"],["vec",["allocid"]]]]],[11,"leak_report","","",312,[[["self"]],["usize"]]],[11,"get_bytes_unchecked","","",312,[[["self"],["pointer"],["size"],["align"]],["evalresult"]]],[11,"get_bytes_unchecked_mut","","",312,[[["self"],["pointer"],["size"],["align"]],["evalresult"]]],[11,"get_bytes","","",312,[[["self"],["pointer"],["size"],["align"]],["evalresult"]]],[11,"get_bytes_mut","","",312,[[["self"],["pointer"],["size"],["align"]],["evalresult"]]],[11,"mark_inner_allocation_initialized","","mark an allocation pointed to by a static as static and initialized",312,[[["self"],["allocid"],["mutability"]],["evalresult"]]],[11,"mark_static_initialized","","mark an allocation as static and initialized, either mutable or not",312,[[["self"],["allocid"],["mutability"]],["evalresult"]]],[11,"copy","","",312,[[["self"],["scalar"],["align"],["scalar"],["align"],["size"],["bool"]],["evalresult"]]],[11,"copy_repeatedly","","",312,[[["self"],["scalar"],["align"],["scalar"],["align"],["size"],["u64"],["bool"]],["evalresult"]]],[11,"read_c_str","","",312,[[["self"],["pointer"]],["evalresult"]]],[11,"read_bytes","","",312,[[["self"],["scalar"],["size"]],["evalresult"]]],[11,"write_bytes","","",312,N],[11,"write_repeat","","",312,[[["self"],["scalar"],["u8"],["size"]],["evalresult"]]],[11,"read_scalar","","",312,[[["self"],["pointer"],["align"],["size"]],["evalresult",["scalar"]]]],[11,"read_ptr_sized","","",312,[[["self"],["pointer"],["align"]],["evalresult",["scalar"]]]],[11,"write_scalar","","",312,[[["self"],["scalar"],["align"],["scalar"],["size"],["bool"]],["evalresult"]]],[11,"write_ptr_sized_unsigned","","",312,[[["self"],["pointer"],["align"],["scalar"]],["evalresult"]]],[11,"int_align","","",312,[[["self"],["size"]],["align"]]],[11,"relocations","","",312,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"clear_relocations","","",312,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"check_relocation_edges","","",312,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"copy_undef_mask","","",312,[[["self"],["pointer"],["pointer"],["size"],["u64"]],["evalresult"]]],[11,"check_defined","","",312,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"mark_definedness","","",312,[[["self"],["scalar"],["size"],["bool"]],["evalresult"]]],[11,"memory_mut","","",312,[[["self"]],["memory"]]],[11,"memory","","",312,[[["self"]],["memory"]]],[11,"memory_mut","","",308,[[["self"]],["memory"]]],[11,"memory","","",308,[[["self"]],["memory"]]],[0,"operator","","",N,N],[11,"binop_with_overflow","","",308,[[["self"],["binop"],["valty"],["valty"]],["evalresult"]]],[11,"intrinsic_with_overflow","","Applies the binary operation `op` to the two operands and writes a tuple of the result and a boolean signifying the potential overflow to the destination.",308,[[["self"],["binop"],["valty"],["valty"],["place"],["ty"]],["evalresult"]]],[11,"intrinsic_overflowing","","Applies the binary operation `op` to the arguments and writes the result to the destination. Returns `true` if the operation overflowed.",308,[[["self"],["binop"],["valty"],["valty"],["place"],["ty"]],["evalresult",["bool"]]]],[11,"binary_op","","Returns the result of the specified operation and whether it overflowed.",308,[[["self"],["binop"],["scalar"],["ty"],["scalar"],["ty"]],["evalresult"]]],[11,"unary_op","","",308,[[["self"],["unop"],["scalar"],["ty"]],["evalresult",["scalar"]]]],[0,"step","","This module contains the `EvalContext` methods for executing a single step of the interpreter.",N,N],[11,"inc_step_counter_and_detect_loops","","",308,[[["self"]],["evalresult"]]],[11,"step","","Returns true as long as there are more things to do.",308,[[["self"]],["evalresult",["bool"]]]],[11,"statement","","",308,[[["self"],["statement"]],["evalresult"]]],[11,"terminator","","",308,[[["self"],["terminator"]],["evalresult"]]],[0,"terminator","","",N,N],[0,"drop","rustc_mir::interpret::terminator","",N,N],[11,"drop_place","rustc_mir::interpret","",308,[[["self"],["place"],["instance"],["ty"],["span"],["basicblock"]],["evalresult"]]],[11,"drop","","",308,[[["self"],["value"],["instance"],["ty"],["span"],["basicblock"]],["evalresult"]]],[11,"goto_block","","",308,[[["self"],["basicblock"]]]],[11,"eval_terminator","","",308,[[["self"],["terminator"]],["evalresult"]]],[11,"check_sig_compat","","Decides whether it is okay to call the method with signature `real_sig` using signature `sig`. FIXME: This should take into account the platform-dependent ABI description.",308,[[["self"],["fnsig"],["fnsig"]],["evalresult",["bool"]]]],[11,"eval_fn_call","","",308,N],[0,"traits","","",N,N],[11,"get_vtable","","Creates a dynamic vtable for the given type and vtable origin. This is used only for objects.",308,[[["self"],["ty"],["polytraitref"]],["evalresult",["pointer"]]]],[11,"read_drop_type_from_vtable","","",308,[[["self"],["pointer"]],["evalresult",["option"]]]],[11,"read_size_and_align_from_vtable","","",308,[[["self"],["pointer"]],["evalresult"]]],[8,"HasMemory","","",N,N],[10,"memory_mut","","",321,[[["self"]],["memory"]]],[10,"memory","","",321,[[["self"]],["memory"]]],[11,"into_ptr","rustc_mir::interpret::memory","Convert the value into a pointer (or a pointer-sized integer).  If the value is a ByRef, this may have to perform a load.",321,[[["self"],["value"]],["evalresult",["scalar"]]]],[11,"into_ptr_vtable_pair","","",321,[[["self"],["value"]],["evalresult"]]],[11,"into_slice","","",321,[[["self"],["value"]],["evalresult"]]],[8,"Machine","rustc_mir::interpret","Methods of this trait signifies a point where CTFE evaluation would fail and some use case dependent behaviour can instead be applied",N,N],[16,"MemoryData","","Additional data that can be accessed via the Memory",320,N],[16,"MemoryKinds","","Additional memory kinds a machine wishes to distinguish from the builtin ones",320,N],[10,"eval_fn_call","","Entry point to all function calls.",320,N],[10,"call_intrinsic","","directly process an intrinsic without pushing a stack frame.",320,N],[10,"try_ptr_op","","Called for all binary operations except on float types.",320,[[["evalcontext"],["binop"],["scalar"],["ty"],["scalar"],["ty"]],["evalresult",["option"]]]],[10,"mark_static_initialized","","Called when trying to mark machine defined `MemoryKinds` as static",320,[[["memory"],["allocid"],["mutability"]],["evalresult",["bool"]]]],[10,"init_static","","Called when requiring a pointer to a static. Non const eval can create a mutable memory location for `static mut`",320,[[["evalcontext"],["globalid"]],["evalresult",["allocid"]]]],[10,"box_alloc","","Heap allocations via the `box` keyword",320,[[["evalcontext"],["ty"],["place"]],["evalresult"]]],[10,"global_item_with_linkage","","Called when trying to access a global declared with a `linkage` attribute",320,[[["evalcontext"],["instance"],["mutability"]],["evalresult"]]],[11,"check_locks","rustc_mir::interpret::machine","",320,[[["memory"],["pointer"],["size"],["accesskind"]],["evalresult"]]],[11,"add_lock","","",320,[[["memory"],["allocid"]]]],[11,"free_lock","","",320,[[["memory"],["allocid"],["u64"]],["evalresult"]]],[11,"end_region","","",320,[[["evalcontext"],["option",["scope"]]],["evalresult"]]],[11,"validation_op","","",320,[[["evalcontext"],["validationop"],["validationoperand"]],["evalresult"]]],[0,"monomorphize","rustc_mir","",N,N],[3,"Instance","rustc_mir::monomorphize","",N,N],[12,"def","","",322,N],[12,"substs","","",322,N],[4,"MonoItem","","",N,N],[13,"Fn","","",323,N],[13,"Static","","",323,N],[13,"GlobalAsm","","",323,N],[5,"assert_symbols_are_distinct","","",N,[[["tyctxt"],["i"]]]],[5,"fn_once_adapter_instance","","",N,[[["tyctxt"],["defid"],["closuresubsts"]],["instance"]]],[5,"needs_fn_once_adapter_shim","","",N,[[["closurekind"],["closurekind"]],["result",["bool"]]]],[5,"resolve_closure","","",N,[[["tyctxt"],["defid"],["closuresubsts"],["closurekind"]],["instance"]]],[5,"resolve_drop_in_place","","",N,[[["tyctxt"],["ty"]],["instance"]]],[5,"custom_coerce_unsize_info","","",N,[[["tyctxt"],["ty"],["ty"]],["customcoerceunsized"]]],[0,"collector","","Mono Item Collection ===========================",N,N],[3,"InliningMap","rustc_mir::monomorphize::collector","Maps every mono item to all mono items it references in its body.",N,N],[12,"index","","",324,N],[12,"targets","","",324,N],[12,"inlines","","",324,N],[3,"MirNeighborCollector","","",N,N],[12,"tcx","","",325,N],[12,"mir","","",325,N],[12,"output","","",325,N],[12,"param_substs","","",325,N],[3,"RootCollector","","",N,N],[12,"tcx","","",326,N],[12,"mode","","",326,N],[12,"output","","",326,N],[12,"entry_fn","","",326,N],[4,"MonoItemCollectionMode","","",N,N],[13,"Eager","","",327,N],[13,"Lazy","","",327,N],[5,"collect_crate_mono_items","","",N,N],[5,"collect_roots","","",N,[[["tyctxt"],["monoitemcollectionmode"]],["vec",["monoitem"]]]],[5,"collect_items_rec","","",N,[[["tyctxt"],["monoitem"],["mtref",["mtlock"]],["defidmap"],["mtref",["mtlock"]]]]],[5,"record_accesses","","",N,N],[5,"check_recursion_limit","","",N,N],[5,"check_type_length_limit","","",N,[[["tyctxt"],["instance"]]]],[5,"visit_drop_use","","",N,[[["tyctxt"],["ty"],["bool"],["vec"]]]],[5,"visit_fn_use","","",N,[[["tyctxt"],["ty"],["bool"],["vec"]]]],[5,"visit_instance_use","","",N,[[["tyctxt"],["instance"],["bool"],["vec"]]]],[5,"should_monomorphize_locally","","",N,[[["tyctxt"],["instance"]],["bool"]]],[5,"find_vtable_types_for_unsizing","","For given pair of source and target type that occur in an unsizing coercion, this function finds the pair of types that determines the vtable linking them.",N,N],[5,"create_fn_mono_item","","",N,[[["instance"]],["monoitem"]]],[5,"create_mono_items_for_vtable_methods","","Creates a `MonoItem` for each method that is referenced by the vtable for the given trait/impl pair.",N,[[["tyctxt"],["ty"],["ty"],["vec"]]]],[5,"item_has_type_parameters","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"create_mono_items_for_default_impls","","",N,[[["tyctxt"],["item"],["vec"]]]],[5,"collect_miri","","Scan the miri alloc in order to find function calls, closures, and drop-glue",N,[[["tyctxt"],["allocid"],["vec"]]]],[5,"collect_neighbours","","Scan the MIR in order to find function calls, closures, and drop-glue",N,[[["tyctxt"],["instance"],["vec"]]]],[5,"def_id_to_string","","",N,[[["tyctxt"],["defid"]],["string"]]],[5,"collect_const","","",N,[[["tyctxt"],["const"],["substs"],["vec"]]]],[11,"eq","","",327,[[["self"],["monoitemcollectionmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",327,N],[11,"hash","","",327,N],[11,"clone","","",327,[[["self"]],["monoitemcollectionmode"]]],[11,"fmt","","",327,[[["self"],["formatter"]],["result"]]],[11,"new","","",324,[[],["inliningmap"]]],[11,"record_accesses","","",324,[[["self"],["monoitem"],["i"]]]],[11,"with_inlining_candidates","","",324,[[["self"],["monoitem"],["f"]]]],[11,"iter_accesses","","",324,[[["self"],["f"]]]],[11,"visit_rvalue","","",325,[[["self"],["rvalue"],["location"]]]],[11,"visit_const","","",325,[[["self"],["const"],["location"]]]],[11,"visit_terminator_kind","","",325,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_static","","",325,[[["self"],["static"],["placecontext"],["location"]]]],[11,"visit_item","","",326,[[["self"],["item"]]]],[11,"visit_trait_item","","",326,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",326,[[["self"],["implitem"]]]],[11,"is_root","","",326,[[["self"],["defid"]],["bool"]]],[11,"push_if_root","","If `def_id` represents a root, then push it onto the list of outputs. (Note that all roots must be monomorphic.)",326,[[["self"],["defid"]]]],[11,"push_extra_entry_roots","","As a special case, when/if we encounter the `main()` function, we also have to generate a monomorphized copy of the start lang item based on the return type of `main`. This is not needed when the user writes their own `start` manually.",326,[[["self"]]]],[0,"item","rustc_mir::monomorphize","Walks the crate looking for items/impl-items/trait-items that have either a `rustc_symbol_name` or `rustc_item_path` attribute and generates an error giving, respectively, the symbol name or item-path. This is used for unit testing the code that generates paths etc in all kinds of annoying scenarios.",N,N],[4,"MonoItem","rustc_mir::monomorphize::item","",N,N],[13,"Fn","","",323,N],[13,"Static","","",323,N],[13,"GlobalAsm","","",323,N],[3,"DefPathBasedNames","","Same as `unique_type_name()` but with the result pushed onto the given `output` parameter.",N,N],[12,"tcx","","",328,N],[12,"omit_disambiguators","","",328,N],[12,"omit_local_crate_name","","",328,N],[4,"InstantiationMode","","Describes how a monomorphization will be instantiated in object files.",N,N],[13,"GloballyShared","","There will be exactly one instance of the given MonoItem. It will have external linkage so that it can be linked to from other codegen units.",329,N],[12,"may_conflict","rustc_mir::monomorphize::item::InstantiationMode","In some compilation scenarios we may decide to take functions that are typically `LocalCopy` and instead move them to `GloballyShared` to avoid codegenning them a bunch of times. In this situation, however, our local copy may conflict with other crates also inlining the same function.",329,N],[13,"LocalCopy","rustc_mir::monomorphize::item","Each codegen unit containing a reference to the given MonoItem will have its own private copy of the function (with internal linkage).",329,N],[8,"MonoItemExt","","",N,N],[10,"as_mono_item","","",330,[[["self"]],["monoitem"]]],[11,"is_generic_fn","","",330,[[["self"]],["bool"]]],[11,"symbol_name","","",330,[[["self"],["tyctxt"]],["symbolname"]]],[11,"instantiation_mode","","",330,[[["self"],["tyctxt"]],["instantiationmode"]]],[11,"explicit_linkage","","",330,[[["self"],["tyctxt"]],["option",["linkage"]]]],[11,"is_instantiable","","Returns whether this instance is instantiable - whether it has no unsatisfied predicates.",330,[[["self"],["tyctxt"]],["bool"]]],[11,"to_string","","",330,[[["self"],["tyctxt"]],["string"]]],[11,"local_span","","",330,[[["self"],["tyctxt"]],["option",["span"]]]],[11,"eq","","",329,[[["self"],["instantiationmode"]],["bool"]]],[11,"ne","","",329,[[["self"],["instantiationmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",329,N],[11,"clone","","",329,[[["self"]],["instantiationmode"]]],[11,"fmt","","",329,[[["self"],["formatter"]],["result"]]],[11,"hash","","",329,N],[11,"as_mono_item","","",323,[[["self"]],["monoitem"]]],[11,"new","","",328,[[["tyctxt"],["bool"],["bool"]],["self"]]],[11,"push_type_name","","",328,[[["self"],["ty"],["string"]]]],[11,"push_def_path","","",328,[[["self"],["defid"],["string"]]]],[11,"push_type_params","","",328,[[["self"],["substs"],["i"],["string"]]]],[11,"push_instance_as_string","","",328,[[["self"],["instance"],["string"]]]],[0,"partitioning","rustc_mir::monomorphize","Partitioning Codegen Units for Incremental Compilation ======================================================",N,N],[3,"CodegenUnit","rustc_mir::monomorphize::partitioning","",N,N],[12,"name","","A name for this CGU. Incremental compilation requires that name be unique amongst all crates.  Therefore, it should contain something unique to this crate (e.g., a module path) as well as the crate name and disambiguator.",331,N],[12,"items","","",331,N],[12,"size_estimate","","",331,N],[3,"PreInliningPartitioning","","",N,N],[12,"codegen_units","","",332,N],[12,"roots","","",332,N],[12,"internalization_candidates","","",332,N],[3,"PostInliningPartitioning","","",N,N],[12,"codegen_units","","",333,N],[12,"mono_item_placements","","",333,N],[12,"internalization_candidates","","",333,N],[4,"PartitioningStrategy","","",N,N],[13,"PerModule","","Generate one codegen unit per source-level module.",334,N],[13,"FixedUnitCount","","Partition the whole crate into a fixed number of codegen units.",334,N],[4,"MonoItemPlacement","","For symbol internalization, we need to know whether a symbol/mono-item is accessed from outside the codegen unit it is defined in. This type is used to keep track of that.",N,N],[13,"SingleCgu","","",335,N],[12,"cgu_name","rustc_mir::monomorphize::partitioning::MonoItemPlacement","",335,N],[13,"MultipleCgus","rustc_mir::monomorphize::partitioning","",335,N],[5,"fallback_cgu_name","","",N,[[["tyctxt"]],["internedstring"]]],[5,"partition","","",N,[[["tyctxt"],["i"],["partitioningstrategy"],["inliningmap"]],["vec",["codegenunit"]]]],[5,"place_root_mono_items","","",N,[[["tyctxt"],["i"]],["preinliningpartitioning"]]],[5,"merge_codegen_units","","",N,[[["preinliningpartitioning"],["usize"],["str"]]]],[5,"place_inlined_mono_items","","",N,[[["preinliningpartitioning"],["inliningmap"]],["postinliningpartitioning"]]],[5,"internalize_symbols","","",N,[[["tyctxt"],["postinliningpartitioning"],["inliningmap"]]]],[5,"characteristic_def_id_of_mono_item","","",N,[[["tyctxt"],["monoitem"]],["option",["defid"]]]],[5,"compute_codegen_unit_name","","",N,[[["tyctxt"],["defid"],["bool"]],["internedstring"]]],[5,"numbered_codegen_unit_name","","",N,[[["str"],["usize"]],["internedstring"]]],[5,"debug_dump","","",N,[[["tyctxt"],["str"],["i"]]]],[8,"CodegenUnitExt","","",N,N],[10,"as_codegen_unit","","",336,[[["self"]],["codegenunit"]]],[11,"contains_item","","",336,[[["self"],["monoitem"]],["bool"]]],[11,"name","","",336,[[["self"]],["internedstring"]]],[11,"items","","",336,[[["self"]],["fxhashmap"]]],[11,"work_product_id","","",336,[[["self"]],["workproductid"]]],[11,"items_in_deterministic_order","","",336,[[["self"],["tyctxt"]],["vec"]]],[11,"as_codegen_unit","","",331,[[["self"]],["codegenunit"]]],[11,"clone","","",335,[[["self"]],["monoitemplacement"]]],[11,"eq","","",335,[[["self"],["monoitemplacement"]],["bool"]]],[11,"ne","","",335,[[["self"],["monoitemplacement"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",335,N],[11,"fmt","","",335,[[["self"],["formatter"]],["result"]]],[17,"DIAGNOSTICS","rustc_mir","",N,N],[14,"run_passes","","",N,N],[11,"index","rustc_mir::dataflow::move_paths::indexes","",166,[[["self"]],["usize"]]],[11,"from","","",166,[[["usize"]],["borrowindex"]]],[11,"clone","rustc_mir::monomorphize::item","",323,[[["self"]],["monoitem"]]],[11,"clone","rustc_mir::monomorphize","",322,[[["self"]],["instance"]]],[11,"encode","","",322,[[["self"],["__s"]],["result"]]],[11,"super_fold_with","","",322,[[["self"],["f"]],["instance"]]],[11,"super_visit_with","","",322,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",322,[[["self"],["tyctxt"]],["option",["instance"]]]],[11,"fmt","","",322,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_mir::monomorphize::item","",323,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_mir::monomorphize","",322,[[["self"],["formatter"]],["result",["error"]]]],[11,"assert_receiver_is_total_eq","","",322,N],[11,"assert_receiver_is_total_eq","rustc_mir::monomorphize::item","",323,N],[11,"hash_stable","rustc_mir::monomorphize::partitioning","",331,N],[11,"hash_stable","rustc_mir::monomorphize","",322,N],[11,"hash_stable","rustc_mir::monomorphize::item","",323,N],[11,"decode","rustc_mir::monomorphize","",322,[[["__d"]],["result",["instance"]]]],[11,"hash","rustc_mir::monomorphize::item","",323,N],[11,"hash","rustc_mir::monomorphize","",322,N],[11,"eq","","",322,[[["self"],["instance"]],["bool"]]],[11,"ne","","",322,[[["self"],["instance"]],["bool"]]],[11,"eq","rustc_mir::monomorphize::item","",323,[[["self"],["monoitem"]],["bool"]]],[11,"ne","","",323,[[["self"],["monoitem"]],["bool"]]],[11,"eval_into","rustc_mir::hair","",185,[[["self"],["builder"],["place"],["basicblock"]],["blockand"]]],[11,"eval_into","","",176,[[["self"],["builder"],["place"],["basicblock"]],["blockand"]]],[11,"ty","rustc_mir::monomorphize","",322,[[["self"],["tyctxt"]],["tys"]]],[11,"new","","",322,[[["defid"],["slice"]],["instance"]]],[11,"mono","","",322,[[["tyctxt"],["defid"]],["instance"]]],[11,"def_id","","",322,[[["self"]],["defid"]]],[11,"resolve","","Resolve a (def_id, substs) pair to an (optional) instance -- most commonly, this is used to find the precise code that will run for a trait method invocation, if known.",322,[[["tyctxt"],["paramenv"],["defid"],["slice"]],["option",["instance"]]]],[11,"resolve_closure","","",322,[[["tyctxt"],["defid"],["closuresubsts"],["closurekind"]],["instance"]]],[11,"size_estimate","rustc_mir::monomorphize::item","",323,[[["self"],["tyctxt"]],["usize"]]],[11,"new","rustc_mir::monomorphize::partitioning","",331,[[["internedstring"]],["codegenunit"]]],[11,"name","","",331,[[["self"]],["internedstring"]]],[11,"set_name","","",331,N],[11,"items","","",331,[[["self"]],["hashmap"]]],[11,"items_mut","","",331,[[["self"]],["hashmap"]]],[11,"mangle_name","","",331,[[["str"]],["string"]]],[11,"estimate_size","","",331,N],[11,"size_estimate","","",331,[[["self"]],["usize"]]],[11,"modify_size_estimate","","",331,N]],"paths":[[3,"MirBorrowckCtxt"],[3,"AccessErrorsReported"],[3,"RootPlace"],[3,"Context"],[4,"MutateMode"],[4,"ArtificialField"],[4,"ShallowOrDeep"],[4,"ReadOrWrite"],[4,"ReadKind"],[4,"WriteKind"],[4,"LocalMutationIsAllowed"],[4,"InitializationRequiringAction"],[4,"NoMovePathFound"],[4,"Overlap"],[4,"ContextKind"],[3,"BorrowSet"],[3,"BorrowData"],[3,"GatherBorrows"],[4,"TwoPhaseActivation"],[3,"IncludingDowncast"],[3,"Flows"],[3,"LocationTable"],[3,"LocationIndex"],[4,"RichLocation"],[4,"GroupedMoveError"],[4,"AccessKind"],[4,"Control"],[8,"PlaceExt"],[3,"PlaceComponents"],[3,"PlaceComponentsIter"],[3,"Prefixes"],[4,"PrefixSet"],[8,"IsPrefixOf"],[3,"GatherUsedMutsVisitor"],[3,"ConstraintGeneration"],[3,"UseFinder"],[3,"DefUseVisitor"],[4,"DefUseResult"],[3,"FactWriter"],[8,"AllFactsExt"],[8,"FactRow"],[8,"FactCell"],[3,"InvalidationGenerator"],[3,"RegionInferenceContext"],[3,"RegionDefinition"],[3,"TypeTest"],[4,"Cause"],[4,"RegionTest"],[4,"ConstraintCategory"],[4,"Trace"],[3,"RawConstraints"],[3,"SccConstraints"],[3,"RegionValueElements"],[3,"PointIndex"],[3,"PlaceholderIndex"],[3,"LivenessValues"],[3,"RegionValues"],[4,"RegionElement"],[8,"ToElementIndex"],[8,"ClosureRegionRequirementsExt"],[3,"NLLVisitor"],[3,"TypeVerifier"],[3,"TypeChecker"],[3,"BorrowCheckContext"],[3,"MirTypeckRegionConstraints"],[4,"FieldAccessError"],[4,"Locations"],[3,"ConstraintConversion"],[3,"UniversalRegionRelations"],[3,"CreateResult"],[3,"UniversalRegionRelationsBuilder"],[3,"ObligationAccumulator"],[3,"TypeLivenessGenerator"],[3,"DropData"],[3,"TypeRelating"],[3,"ScopesAndKind"],[3,"BoundRegionScope"],[3,"UniversallyQuantified"],[3,"ScopeInstantiator"],[8,"AtLocation"],[8,"NormalizeLocation"],[3,"TypeckMir"],[3,"UniversalRegions"],[3,"UniversalRegionIndices"],[3,"UniversalRegionsBuilder"],[4,"DefiningTy"],[4,"RegionClassification"],[8,"InferCtxtExt"],[3,"NllLivenessMap"],[3,"LocalWithRegion"],[3,"ConstraintSet"],[3,"OutlivesConstraint"],[3,"ConstraintIndex"],[3,"ConstraintSccIndex"],[3,"ConstraintGraph"],[3,"Edges"],[3,"RegionGraph"],[3,"Successors"],[8,"ToRegionVid"],[3,"GlobalizeMir"],[3,"Builder"],[3,"GuardFrameLocal"],[3,"GuardFrame"],[3,"CFG"],[3,"ScopeId"],[3,"BlockAnd"],[3,"ArgInfo"],[4,"LocalsForNode"],[4,"ForGuard"],[4,"Category"],[4,"RvalueFunc"],[8,"EvalInto"],[3,"ArmHasGuard"],[3,"ArmBlocks"],[3,"Candidate"],[3,"Binding"],[3,"MatchPair"],[3,"Test"],[4,"TestKind"],[3,"Scope"],[3,"DropData"],[3,"CachedBlock"],[3,"BreakableScope"],[4,"DropKind"],[8,"BlockAndExtension"],[3,"DataflowBuilder"],[3,"DebugFormatted"],[3,"MoveDataParamEnv"],[3,"PropagationContext"],[3,"Bits"],[3,"DataflowAnalysis"],[3,"DataflowResults"],[3,"DataflowState"],[3,"AllSets"],[3,"BlockSets"],[3,"FlowAtLocation"],[8,"FlowsAtLocation"],[3,"Graph"],[3,"Edge"],[8,"MirWithFlowState"],[3,"MaybeInitializedPlaces"],[3,"MaybeUninitializedPlaces"],[3,"DefinitelyInitializedPlaces"],[3,"MovingOutStatements"],[3,"EverInitializedPlaces"],[3,"MaybeStorageLive"],[3,"HaveBeenBorrowedLocals"],[3,"BorrowedLocalsVisitor"],[3,"Borrows"],[3,"MovePath"],[3,"MoveData"],[3,"LocationMap"],[3,"MoveOut"],[3,"Init"],[3,"MovePathLookup"],[3,"IllegalMoveOrigin"],[4,"InitKind"],[4,"LookupResult"],[4,"IllegalMoveOriginKind"],[4,"MoveError"],[8,"Lift"],[3,"AbstractOperand"],[3,"AbstractType"],[3,"MovePathIndex"],[3,"MoveOutIndex"],[3,"InitIndex"],[3,"BorrowIndex"],[3,"MoveDataBuilder"],[3,"Gatherer"],[8,"HasMoveData"],[8,"Dataflow"],[8,"DataflowResultsConsumer"],[8,"InitialFlow"],[8,"BitDenotation"],[3,"Block"],[3,"Stmt"],[3,"Expr"],[3,"FieldExprRef"],[3,"FruInfo"],[3,"Arm"],[4,"LintLevel"],[4,"BlockSafety"],[4,"StmtRef"],[4,"StmtKind"],[4,"ExprKind"],[4,"ExprRef"],[4,"LogicalOp"],[3,"Cx"],[8,"ToBorrowKind"],[8,"ToRef"],[3,"FieldPattern"],[3,"Pattern"],[3,"PatternContext"],[4,"PatternError"],[4,"BindingMode"],[4,"PatternKind"],[4,"LitToConstError"],[3,"Matrix"],[3,"MatchCheckCtxt"],[3,"PatternContext"],[3,"Witness"],[4,"Constructor"],[4,"Usefulness"],[4,"WitnessPreference"],[3,"LiteralExpander"],[3,"OuterVisitor"],[3,"MatchVisitor"],[3,"MutationChecker"],[3,"AtBindingPatternVisitor"],[8,"PatternFoldable"],[8,"PatternFolder"],[8,"Mirror"],[3,"DropShimElaborator"],[3,"CloneShimBuilder"],[4,"Adjustment"],[4,"CallKind"],[3,"MirSource"],[3,"AddValidation"],[3,"AddMovesForPackedDrops"],[3,"GatherBorrowedRegions"],[3,"DeleteTrivialEndRegions"],[3,"CleanEndRegions"],[3,"CleanUserAssertTy"],[3,"DeleteUserAssertTy"],[3,"UnsafetyChecker"],[3,"UnusedUnsafeVisitor"],[3,"SimplifyBranches"],[3,"SimplifyCfg"],[3,"CfgSimplifier"],[3,"DeclMarker"],[3,"LocalUpdater"],[3,"SimplifyLocals"],[3,"EraseRegionsVisitor"],[3,"EraseRegions"],[3,"NoLandingPads"],[3,"SanityCheck"],[3,"InitializationData"],[3,"Elaborator"],[3,"ElaborateDropsCtxt"],[3,"ElaborateDrops"],[4,"AddCallGuards"],[3,"TempCollector"],[3,"Promoter"],[4,"TempState"],[4,"Candidate"],[3,"Qualif"],[3,"Qualifier"],[4,"Mode"],[3,"QualifyAndPromoteConstants"],[3,"RemoveNoopLandingPads"],[3,"Marker"],[3,"Disambiguator"],[3,"Deaggregator"],[3,"InstCombineVisitor"],[3,"OptimizationFinder"],[3,"OptimizationList"],[3,"InstCombine"],[3,"ConstantPropagationVisitor"],[4,"Action"],[3,"CopyPropagation"],[3,"ConstPropagator"],[3,"CanConstProp"],[3,"ConstProp"],[3,"RenameLocalVisitor"],[3,"SuspensionPoint"],[3,"TransformVisitor"],[3,"StorageIgnored"],[3,"BorrowedLocals"],[3,"DerefArgVisitor"],[3,"StateTransform"],[3,"CallSite"],[3,"Inliner"],[3,"Integrator"],[3,"Inline"],[4,"RhsKind"],[3,"Lower128Bit"],[3,"UniformArrayMoveOutVisitor"],[3,"LocalUse"],[3,"RestoreDataCollector"],[3,"UniformArrayMoveOut"],[3,"RestoreSubsliceArrayMoveOut"],[8,"MirPass"],[4,"PassWhere"],[4,"Origin"],[8,"BorrowckErrors"],[3,"DropCtxt"],[4,"DropFlagState"],[4,"DropStyle"],[4,"DropFlagMode"],[4,"Unwind"],[8,"DropElaborator"],[3,"DefUseAnalysis"],[3,"Info"],[3,"Use"],[3,"DefUseFinder"],[3,"MutateUseVisitor"],[3,"MirPatch"],[3,"ExtraComments"],[3,"LivenessResult"],[3,"IdentityMap"],[3,"LivenessMode"],[3,"LivenessResults"],[3,"DefsUsesVisitor"],[3,"DefsUses"],[4,"DefUse"],[8,"LiveVariableMap"],[3,"FindLocalAssignmentVisitor"],[8,"FindAssignments"],[3,"EvalContext"],[3,"Frame"],[3,"TyAndPacked"],[3,"ValTy"],[3,"Memory"],[4,"StackPopCleanup"],[4,"Place"],[4,"PlaceExtra"],[4,"MemoryKind"],[4,"ConstEvalError"],[3,"CompileTimeEvaluator"],[3,"InfiniteLoopDetector"],[8,"Machine"],[8,"HasMemory"],[3,"Instance"],[4,"MonoItem"],[3,"InliningMap"],[3,"MirNeighborCollector"],[3,"RootCollector"],[4,"MonoItemCollectionMode"],[3,"DefPathBasedNames"],[4,"InstantiationMode"],[8,"MonoItemExt"],[3,"CodegenUnit"],[3,"PreInliningPartitioning"],[3,"PostInliningPartitioning"],[4,"PartitioningStrategy"],[4,"MonoItemPlacement"],[8,"CodegenUnitExt"]]};
searchIndex["rustc_passes"]={"doc":"Various checks","items":[[5,"provide","rustc_passes","",N,[[["providers"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0130","rustc_passes::diagnostics","",N,N],[0,"__register_diagnostic_E0197","","",N,N],[0,"__register_diagnostic_E0198","","",N,N],[0,"__register_diagnostic_E0267","","",N,N],[0,"__register_diagnostic_E0268","","",N,N],[0,"__register_diagnostic_E0379","","",N,N],[0,"__register_diagnostic_E0380","","",N,N],[0,"__register_diagnostic_E0449","","",N,N],[0,"__register_diagnostic_E0590","","",N,N],[0,"__register_diagnostic_E0571","","",N,N],[0,"__register_diagnostic_E0695","","",N,N],[0,"__register_diagnostic_E0226","","",N,N],[0,"__register_diagnostic_E0472","","",N,N],[0,"__register_diagnostic_E0561","","",N,N],[0,"__register_diagnostic_E0567","","",N,N],[0,"__register_diagnostic_E0568","","",N,N],[0,"__register_diagnostic_E0642","","",N,N],[0,"__register_diagnostic_E0666","","",N,N],[0,"__register_diagnostic_E0667","","",N,N],[0,"__register_diagnostic_E0696","","",N,N],[0,"__register_diagnostic_E0706","","",N,N],[0,"ast_validation","rustc_passes","",N,N],[3,"AstValidator","rustc_passes::ast_validation","",N,N],[12,"session","","",0,N],[3,"NestedImplTraitVisitor","","",N,N],[12,"session","","",1,N],[12,"outer_impl_trait","","",1,N],[3,"ImplTraitProjectionVisitor","","",N,N],[12,"session","","",2,N],[12,"is_banned","","",2,N],[5,"check_crate","","",N,[[["session"],["crate"]]]],[11,"err_handler","","",0,[[["self"]],["handler"]]],[11,"check_lifetime","","",0,[[["self"],["ident"]]]],[11,"check_label","","",0,[[["self"],["ident"]]]],[11,"invalid_non_exhaustive_attribute","","",0,[[["self"],["variant"]]]],[11,"invalid_visibility","","",0,[[["self"],["visibility"],["option",["str"]]]]],[11,"check_decl_no_pat","","",0,[[["self"],["fndecl"],["reportfn"]]]],[11,"check_trait_fn_not_async","","",0,[[["self"],["span"],["isasync"]]]],[11,"check_trait_fn_not_const","","",0,[[["self"],["spanned",["constness"]]]]],[11,"no_questions_in_bounds","","",0,[[["self"],["genericbounds"],["str"],["bool"]]]],[11,"check_expr_within_pat","","matches '-' lit | lit (cf. parser::Parser::parse_literal_maybe_minus), or path for ranges.",0,[[["self"],["expr"],["bool"]]]],[11,"check_late_bound_lifetime_defs","","",0,N],[11,"visit_expr","","",0,[[["self"],["expr"]]]],[11,"visit_ty","","",0,[[["self"],["ty"]]]],[11,"visit_use_tree","","",0,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_label","","",0,[[["self"],["label"]]]],[11,"visit_lifetime","","",0,[[["self"],["lifetime"]]]],[11,"visit_item","","",0,[[["self"],["item"]]]],[11,"visit_foreign_item","","",0,[[["self"],["foreignitem"]]]],[11,"visit_vis","","",0,[[["self"],["visibility"]]]],[11,"visit_generics","","",0,[[["self"],["generics"]]]],[11,"visit_generic_param","","",0,[[["self"],["genericparam"]]]],[11,"visit_pat","","",0,[[["self"],["pat"]]]],[11,"visit_where_predicate","","",0,[[["self"],["wherepredicate"]]]],[11,"visit_poly_trait_ref","","",0,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_mac","","",0,[[["self"],["spanned"]]]],[11,"with_impl_trait","","",1,[[["self"],["option",["span"]],["f"]]]],[11,"visit_ty","","",1,[[["self"],["ty"]]]],[11,"visit_generic_args","","",1,[[["self"],["span"],["genericargs"]]]],[11,"visit_mac","","",1,[[["self"],["spanned"]]]],[11,"with_ban","","",2,[[["self"],["f"]]]],[11,"visit_ty","","",2,[[["self"],["ty"]]]],[11,"visit_mac","","",2,[[["self"],["spanned"]]]],[0,"rvalue_promotion","rustc_passes","",N,N],[3,"CheckCrateVisitor","rustc_passes::rvalue_promotion","",N,N],[12,"tcx","","",3,N],[12,"in_fn","","",3,N],[12,"in_static","","",3,N],[12,"mut_rvalue_borrows","","",3,N],[12,"param_env","","",3,N],[12,"identity_substs","","",3,N],[12,"tables","","",3,N],[12,"result","","",3,N],[4,"Promotability","","",N,N],[13,"Promotable","","",4,N],[13,"NotPromotable","","",4,N],[5,"provide","","",N,[[["providers"]]]],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"const_is_rvalue_promotable_to_static","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"rvalue_promotable_map","","",N,[[["tyctxt"],["defid"]],["lrc",["itemlocalset"]]]],[5,"check_expr_kind","","This function is used to enforce the constraints on const/static items. It walks through the value of the item walking down the expression and evaluating every nested expression. If the expression is not part of a const/static item, it is qualified for promotion instead of producing errors.",N,[[["checkcratevisitor"],["expr"],["ty"]],["promotability"]]],[5,"check_adjustments","","Check the adjustments of an expression",N,[[["checkcratevisitor"],["expr"]],["promotability"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["promotability"]],["bool"]]],[11,"bitand","","",4,[[["self"],["self"]],["self"]]],[11,"bitor","","",4,[[["self"],["self"]],["self"]]],[11,"type_promotability","","",3,[[["self"],["ty"]],["promotability"]]],[11,"handle_const_fn_call","","",3,[[["self"],["defid"],["ty"],["span"]],["promotability"]]],[11,"remove_mut_rvalue_borrow","","While the `ExprUseVisitor` walks, we will identify which expressions are borrowed, and insert their ids into this table. Actually, we insert the \"borrow-id\", which is normally the id of the expession being borrowed: but in the case of `ref mut` borrows, the `id` of the pattern is inserted. Therefore later we remove that entry from the table and transfer it over to the value being matched. This will then prevent said value from being promoted.",3,[[["self"],["pat"]],["bool"]]],[11,"check_nested_body","","",3,[[["self"],["bodyid"]],["promotability"]]],[11,"check_stmt","","",3,[[["self"],["stmt"]],["promotability"]]],[11,"check_expr","","",3,[[["self"],["expr"]],["promotability"]]],[11,"check_block","","",3,[[["self"],["block"]],["promotability"]]],[11,"consume","","",3,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"borrow","","",3,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"decl_without_init","","",3,[[["self"],["nodeid"],["span"]]]],[11,"mutate","","",3,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"matched_pat","","",3,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume_pat","","",3,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[0,"hir_stats","rustc_passes","",N,N],[3,"NodeData","rustc_passes::hir_stats","",N,N],[12,"count","","",5,N],[12,"size","","",5,N],[3,"StatCollector","","",N,N],[12,"krate","","",6,N],[12,"data","","",6,N],[12,"seen","","",6,N],[4,"Id","","",N,N],[13,"Node","","",7,N],[13,"Attr","","",7,N],[13,"None","","",7,N],[5,"print_hir_stats","","",N,[[["crate"]]]],[5,"print_ast_stats","","",N,[[["crate"],["str"]]]],[11,"clone","","",7,[[["self"]],["id"]]],[11,"eq","","",7,[[["self"],["id"]],["bool"]]],[11,"ne","","",7,[[["self"],["id"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"hash","","",7,N],[11,"record","","",6,[[["self"],["str"],["id"],["t"]]]],[11,"print","","",6,[[["self"],["str"]]]],[11,"nested_visit_map","","",6,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_item","","",6,[[["self"],["itemid"]]]],[11,"visit_nested_trait_item","","",6,[[["self"],["traititemid"]]]],[11,"visit_nested_impl_item","","",6,[[["self"],["implitemid"]]]],[11,"visit_nested_body","","",6,[[["self"],["bodyid"]]]],[11,"visit_item","","",6,[[["self"],["item"]]]],[11,"visit_mod","","",6,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"visit_foreign_item","","",6,[[["self"],["foreignitem"]]]],[11,"visit_local","","",6,[[["self"],["local"]]]],[11,"visit_block","","",6,[[["self"],["block"]]]],[11,"visit_stmt","","",6,[[["self"],["stmt"]]]],[11,"visit_arm","","",6,[[["self"],["arm"]]]],[11,"visit_pat","","",6,[[["self"],["pat"]]]],[11,"visit_decl","","",6,[[["self"],["decl"]]]],[11,"visit_expr","","",6,[[["self"],["expr"]]]],[11,"visit_ty","","",6,[[["self"],["ty"]]]],[11,"visit_fn","","",6,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_where_predicate","","",6,[[["self"],["wherepredicate"]]]],[11,"visit_trait_item","","",6,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",6,[[["self"],["implitem"]]]],[11,"visit_param_bound","","",6,[[["self"],["genericbound"]]]],[11,"visit_struct_field","","",6,[[["self"],["structfield"]]]],[11,"visit_variant","","",6,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_lifetime","","",6,[[["self"],["lifetime"]]]],[11,"visit_qpath","","",6,[[["self"],["qpath"],["nodeid"],["span"]]]],[11,"visit_path","","",6,[[["self"],["path"],["nodeid"]]]],[11,"visit_path_segment","","",6,[[["self"],["span"],["pathsegment"]]]],[11,"visit_assoc_type_binding","","",6,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",6,[[["self"],["attribute"]]]],[11,"visit_macro_def","","",6,[[["self"],["macrodef"]]]],[11,"visit_mod","","",6,N],[11,"visit_foreign_item","","",6,[[["self"],["foreignitem"]]]],[11,"visit_item","","",6,[[["self"],["item"]]]],[11,"visit_local","","",6,[[["self"],["local"]]]],[11,"visit_block","","",6,[[["self"],["block"]]]],[11,"visit_stmt","","",6,[[["self"],["stmt"]]]],[11,"visit_arm","","",6,[[["self"],["arm"]]]],[11,"visit_pat","","",6,[[["self"],["pat"]]]],[11,"visit_expr","","",6,[[["self"],["expr"]]]],[11,"visit_ty","","",6,[[["self"],["ty"]]]],[11,"visit_fn","","",6,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",6,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",6,[[["self"],["implitem"]]]],[11,"visit_param_bound","","",6,[[["self"],["genericbound"]]]],[11,"visit_struct_field","","",6,[[["self"],["structfield"]]]],[11,"visit_variant","","",6,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_lifetime","","",6,[[["self"],["lifetime"]]]],[11,"visit_mac","","",6,[[["self"],["mac"]]]],[11,"visit_path_segment","","",6,[[["self"],["span"],["pathsegment"]]]],[11,"visit_assoc_type_binding","","",6,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",6,[[["self"],["attribute"]]]],[0,"loops","rustc_passes","",N,N],[3,"CheckLoopVisitor","rustc_passes::loops","",N,N],[12,"sess","","",8,N],[12,"hir_map","","",8,N],[12,"cx","","",8,N],[4,"LoopKind","","",N,N],[13,"Loop","","",9,N],[13,"WhileLoop","","",9,N],[4,"Context","","",N,N],[13,"Normal","","",10,N],[13,"Loop","","",10,N],[13,"Closure","","",10,N],[13,"LabeledBlock","","",10,N],[13,"AnonConst","","",10,N],[5,"check_crate","","",N,[[["session"],["map"]]]],[11,"clone","","",9,[[["self"]],["loopkind"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"eq","","",9,[[["self"],["loopkind"]],["bool"]]],[11,"ne","","",9,[[["self"],["loopkind"]],["bool"]]],[11,"name","","",9,[[["self"]],["str"]]],[11,"clone","","",10,[[["self"]],["context"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["context"]],["bool"]]],[11,"ne","","",10,[[["self"],["context"]],["bool"]]],[11,"clone","","",8,[[["self"]],["checkloopvisitor"]]],[11,"nested_visit_map","","",8,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",8,[[["self"],["item"]]]],[11,"visit_impl_item","","",8,[[["self"],["implitem"]]]],[11,"visit_anon_const","","",8,[[["self"],["anonconst"]]]],[11,"visit_expr","","",8,[[["self"],["expr"]]]],[11,"with_context","","",8,[[["self"],["context"],["f"]]]],[11,"require_break_cx","","",8,[[["self"],["str"],["span"]]]],[11,"require_label_in_labeled_block","","",8,[[["self"],["span"],["destination"],["str"]],["bool"]]],[11,"emit_unlabled_cf_in_while_condition","","",8,[[["self"],["span"],["str"]]]],[0,"mir_stats","rustc_passes","",N,N],[3,"NodeData","rustc_passes::mir_stats","",N,N],[12,"count","","",11,N],[12,"size","","",11,N],[3,"StatCollector","","",N,N],[12,"_tcx","","",12,N],[12,"data","","",12,N],[11,"record_with_size","","",12,[[["self"],["str"],["usize"]]]],[11,"record","","",12,[[["self"],["str"],["t"]]]],[11,"visit_mir","","",12,[[["self"],["mir"]]]],[11,"visit_basic_block_data","","",12,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_source_scope_data","","",12,[[["self"],["sourcescopedata"]]]],[11,"visit_statement","","",12,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_terminator","","",12,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_terminator_kind","","",12,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_assert_message","","",12,[[["self"],["assertmessage"],["location"]]]],[11,"visit_rvalue","","",12,[[["self"],["rvalue"],["location"]]]],[11,"visit_operand","","",12,[[["self"],["operand"],["location"]]]],[11,"visit_place","","",12,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_projection","","",12,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"visit_projection_elem","","",12,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"visit_constant","","",12,[[["self"],["constant"],["location"]]]],[11,"visit_source_info","","",12,[[["self"],["sourceinfo"]]]],[11,"visit_closure_substs","","",12,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_const","","",12,[[["self"],["const"],["location"]]]],[11,"visit_local_decl","","",12,[[["self"],["local"],["localdecl"]]]],[11,"visit_source_scope","","",12,[[["self"],["sourcescope"]]]],[17,"DIAGNOSTICS","rustc_passes","",N,N]],"paths":[[3,"AstValidator"],[3,"NestedImplTraitVisitor"],[3,"ImplTraitProjectionVisitor"],[3,"CheckCrateVisitor"],[4,"Promotability"],[3,"NodeData"],[3,"StatCollector"],[4,"Id"],[3,"CheckLoopVisitor"],[4,"LoopKind"],[4,"Context"],[3,"NodeData"],[3,"StatCollector"]]};
searchIndex["rustc_platform_intrinsics"]={"doc":"","items":[[3,"Intrinsic","rustc_platform_intrinsics","",N,N],[12,"inputs","","",0,N],[12,"output","","",0,N],[12,"definition","","",0,N],[4,"Type","","",N,N],[13,"Void","","",1,N],[13,"Integer","","",1,N],[13,"Float","","",1,N],[13,"Pointer","","",1,N],[13,"Vector","","",1,N],[13,"Aggregate","","",1,N],[4,"IntrinsicDef","","",N,N],[13,"Named","","",2,N],[0,"x86","","",N,N],[5,"find","rustc_platform_intrinsics::x86","",N,[[["str"]],["option",["intrinsic"]]]],[0,"arm","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::arm","",N,[[["str"]],["option",["intrinsic"]]]],[0,"aarch64","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::aarch64","",N,[[["str"]],["option",["intrinsic"]]]],[0,"nvptx","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::nvptx","",N,[[["str"]],["option",["intrinsic"]]]],[0,"hexagon","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::hexagon","",N,[[["str"]],["option",["intrinsic"]]]],[0,"powerpc","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::powerpc","",N,[[["str"]],["option",["intrinsic"]]]],[7,"I8","rustc_platform_intrinsics","",N,N],[7,"I16","","",N,N],[7,"I32","","",N,N],[7,"I64","","",N,N],[7,"U8","","",N,N],[7,"U16","","",N,N],[7,"U32","","",N,N],[7,"U64","","",N,N],[7,"F32","","",N,N],[7,"F64","","",N,N],[7,"I32_8","","",N,N],[7,"I8x8","","",N,N],[7,"U8x8","","",N,N],[7,"I8x16","","",N,N],[7,"U8x16","","",N,N],[7,"I8x32","","",N,N],[7,"U8x32","","",N,N],[7,"I8x64","","",N,N],[7,"U8x64","","",N,N],[7,"I8x128","","",N,N],[7,"U8x128","","",N,N],[7,"I8x256","","",N,N],[7,"U8x256","","",N,N],[7,"I16x4","","",N,N],[7,"U16x4","","",N,N],[7,"I16x8","","",N,N],[7,"U16x8","","",N,N],[7,"I16x16","","",N,N],[7,"U16x16","","",N,N],[7,"I16x32","","",N,N],[7,"U16x32","","",N,N],[7,"I16x64","","",N,N],[7,"U16x64","","",N,N],[7,"I16x128","","",N,N],[7,"U16x128","","",N,N],[7,"I32x2","","",N,N],[7,"U32x2","","",N,N],[7,"I32x4","","",N,N],[7,"U32x4","","",N,N],[7,"I32x8","","",N,N],[7,"U32x8","","",N,N],[7,"I32x16","","",N,N],[7,"U32x16","","",N,N],[7,"I32x32","","",N,N],[7,"U32x32","","",N,N],[7,"I32x64","","",N,N],[7,"U32x64","","",N,N],[7,"I64x1","","",N,N],[7,"U64x1","","",N,N],[7,"I64x2","","",N,N],[7,"U64x2","","",N,N],[7,"I64x4","","",N,N],[7,"U64x4","","",N,N],[7,"F32x2","","",N,N],[7,"F32x4","","",N,N],[7,"F32x8","","",N,N],[7,"F64x1","","",N,N],[7,"F64x2","","",N,N],[7,"F64x4","","",N,N],[7,"I32x4_F32","","",N,N],[7,"I32x8_F32","","",N,N],[7,"I64x2_F64","","",N,N],[7,"I64x4_F64","","",N,N],[7,"VOID","","",N,N],[11,"clone","","",1,[[["self"]],["type"]]],[11,"hash","","",1,N],[11,"assert_receiver_is_total_eq","","",1,N],[11,"eq","","",1,[[["self"],["type"]],["bool"]]],[11,"ne","","",1,[[["self"],["type"]],["bool"]]],[11,"find","","",0,[[["str"]],["option",["intrinsic"]]]]],"paths":[[3,"Intrinsic"],[4,"Type"],[4,"IntrinsicDef"]]};
searchIndex["rustc_plugin"]={"doc":"Infrastructure for compiler plugins.","items":[[0,"diagnostics","rustc_plugin","",N,N],[0,"__register_diagnostic_E0498","rustc_plugin::diagnostics","",N,N],[0,"registry","rustc_plugin","Used by plugin crates to tell `rustc` about the plugins they provide.",N,N],[3,"Registry","rustc_plugin::registry","Structure used to register plugins.",N,N],[12,"sess","","Compiler session. Useful if you want to emit diagnostic messages from the plugin registrar.",0,N],[12,"args_hidden","","",0,N],[12,"krate_span","","",0,N],[12,"syntax_exts","","",0,N],[12,"early_lint_passes","","",0,N],[12,"late_lint_passes","","",0,N],[12,"lint_groups","","",0,N],[12,"llvm_passes","","",0,N],[12,"attributes","","",0,N],[12,"whitelisted_custom_derives","","",0,N],[11,"new","","",0,[[["session"],["span"]],["registry"]]],[11,"args","","Get the plugin's arguments, if any.",0,N],[11,"register_syntax_extension","","Register a syntax extension of any kind.",0,[[["self"],["name"],["syntaxextension"]]]],[11,"register_custom_derive","","This can be used in place of `register_syntax_extension` to register legacy custom derives (i.e. attribute syntax extensions whose name begins with `derive_`). Legacy custom derives defined by this function do not trigger deprecation warnings when used.",0,[[["self"],["name"],["syntaxextension"]]]],[11,"take_whitelisted_custom_derives","","",0,[[["self"]],["vec",["name"]]]],[11,"register_macro","","Register a macro of the usual kind.",0,[[["self"],["str"],["macroexpanderfn"]]]],[11,"register_early_lint_pass","","Register a compiler lint pass.",0,[[["self"],["earlylintpassobject"]]]],[11,"register_late_lint_pass","","Register a compiler lint pass.",0,[[["self"],["latelintpassobject"]]]],[11,"register_lint_group","","Register a lint group.",0,[[["self"],["str"],["vec",["lint"]]]]],[11,"register_llvm_pass","","Register an LLVM pass.",0,[[["self"],["str"]]]],[11,"register_attribute","","Register an attribute with an attribute type.",0,[[["self"],["string"],["attributetype"]]]],[0,"load","rustc_plugin","Used by `rustc` when loading a plugin.",N,N],[3,"PluginRegistrar","rustc_plugin::load","",N,N],[12,"fun","","",1,N],[12,"args","","",1,N],[3,"PluginLoader","","",N,N],[12,"sess","","",2,N],[12,"reader","","",2,N],[12,"plugins","","",2,N],[5,"call_malformed_plugin_attribute","","",N,[[["session"],["span"]]]],[5,"load_plugins","","Read plugin metadata and dynamically load registrar functions.",N,[[["session"],["cstore"],["crate"],["str"],["option",["vec"]]],["vec",["pluginregistrar"]]]],[6,"PluginRegistrarFun","","Pointer to a registrar function.",N,N],[11,"new","","",2,[[["session"],["cstore"],["str"]],["self"]]],[11,"load_plugin","","",2,[[["self"],["span"],["str"],["vec",["nestedmetaitem"]]]]],[11,"dylink_registrar","","",2,[[["self"],["span"],["pathbuf"],["string"]],["pluginregistrarfun"]]],[0,"build","rustc_plugin","Used by `rustc` when compiling a plugin crate.",N,N],[3,"RegistrarFinder","rustc_plugin::build","",N,N],[12,"registrars","","",3,N],[5,"find_plugin_registrar","","Find the function marked with `#[plugin_registrar]`, if any.",N,[[["handler"],["map"]],["option",["nodeid"]]]],[11,"visit_item","","",3,[[["self"],["item"]]]],[11,"visit_trait_item","","",3,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",3,[[["self"],["implitem"]]]],[17,"DIAGNOSTICS","rustc_plugin","",N,N]],"paths":[[3,"Registry"],[3,"PluginRegistrar"],[3,"PluginLoader"],[3,"RegistrarFinder"]]};
searchIndex["rustc_privacy"]={"doc":"","items":[[3,"PubRestrictedVisitor","rustc_privacy","Visitor used to determine if pub(restricted) is used anywhere in the crate.",N,N],[12,"tcx","","",0,N],[12,"has_pub_restricted","","",0,N],[3,"EmbargoVisitor","","The embargo visitor, used to determine the exports of the ast",N,N],[12,"tcx","","",1,N],[12,"access_levels","","",1,N],[12,"prev_level","","",1,N],[12,"changed","","",1,N],[3,"ReachEverythingInTheInterfaceVisitor","","",N,N],[12,"item_def_id","","",2,N],[12,"ev","","",2,N],[3,"NamePrivacyVisitor","","Name privacy visitor, checks privacy and reports violations. Most of name privacy checks are performed during the main resolution phase, or later in type checking when field accesses and associated items are resolved. This pass performs remaining checks for fields in struct expressions and patterns.",N,N],[12,"tcx","","",3,N],[12,"tables","","",3,N],[12,"current_item","","",3,N],[12,"empty_tables","","",3,N],[3,"TypePrivacyVisitor","","Type privacy visitor, checks types for privacy and reports violations. Both explicitly written types and inferred types of expressions and patters are checked. Checks are performed on \"semantic\" types regardless of names and their hygiene.",N,N],[12,"tcx","","",4,N],[12,"tables","","",4,N],[12,"current_item","","",4,N],[12,"in_body","","",4,N],[12,"span","","",4,N],[12,"empty_tables","","",4,N],[12,"visited_anon_tys","","",4,N],[3,"ObsoleteVisiblePrivateTypesVisitor","","Obsolete visitors for checking for private items in public interfaces. These visitors are supposed to be kept in frozen state and produce an \"old error node set\". For backward compatibility the new visitor reports warnings instead of hard errors when the erroneous node is not in this old set.",N,N],[12,"tcx","","",5,N],[12,"access_levels","","",5,N],[12,"in_variant","","",5,N],[12,"old_error_set","","",5,N],[3,"ObsoleteCheckTypeForPrivatenessVisitor","","",N,N],[12,"inner","","",6,N],[12,"contains_private","","whether the type refers to private types.",6,N],[12,"at_outer_type","","whether we've recurred at all (i.e. if we're pointing at the first type on which visit_ty was called).",6,N],[12,"outer_type_is_public_path","","",6,N],[3,"SearchInterfaceForPrivateItemsVisitor","","SearchInterfaceForPrivateItemsVisitor traverses an item's interface and finds any private components in it. PrivateItemsInPublicInterfacesVisitor ensures there are no private types and traits in public interfaces.",N,N],[12,"tcx","","",7,N],[12,"item_def_id","","",7,N],[12,"span","","",7,N],[12,"required_visibility","","The visitor checks that each component type is at least this visible",7,N],[12,"min_visibility","","The visibility of the least visible component that has been visited",7,N],[12,"has_pub_restricted","","",7,N],[12,"has_old_errors","","",7,N],[12,"in_assoc_ty","","",7,N],[3,"PrivateItemsInPublicInterfacesVisitor","","",N,N],[12,"tcx","","",8,N],[12,"has_pub_restricted","","",8,N],[12,"old_error_set","","",8,N],[12,"inner_visibility","","",8,N],[5,"update_tables","","",N,[[["tyctxt"],["nodeid"],["typecktables"],["typecktables"]],["typecktables"]]],[5,"provide","","",N,[[["providers"]]]],[5,"check_crate","","",N,[[["tyctxt"]],["lrc",["accesslevels"]]]],[5,"privacy_access_levels","","",N,[[["tyctxt"],["cratenum"]],["lrc",["accesslevels"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0445","rustc_privacy::diagnostics","",N,N],[0,"__register_diagnostic_E0446","","",N,N],[0,"__register_diagnostic_E0447","","",N,N],[0,"__register_diagnostic_E0448","","",N,N],[0,"__register_diagnostic_E0451","","",N,N],[17,"DIAGNOSTICS","rustc_privacy","",N,N],[11,"nested_visit_map","","",0,[[["self"]],["nestedvisitormap"]]],[11,"visit_vis","","",0,[[["self"],["visibility"]]]],[11,"item_ty_level","","",1,[[["self"],["defid"]],["option",["accesslevel"]]]],[11,"impl_trait_level","","",1,[[["self"],["defid"]],["option",["accesslevel"]]]],[11,"get","","",1,[[["self"],["nodeid"]],["option",["accesslevel"]]]],[11,"update","","",1,[[["self"],["nodeid"],["option",["accesslevel"]]],["option",["accesslevel"]]]],[11,"reach","","",1,[[["self"],["nodeid"]],["reacheverythingintheinterfacevisitor"]]],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",1,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",1,[[["self"],["item"]]]],[11,"visit_block","","",1,[[["self"],["block"]]]],[11,"visit_mod","","",1,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"visit_macro_def","","",1,[[["self"],["macrodef"]]]],[11,"generics","","",2,[[["self"]],["self"]]],[11,"predicates","","",2,[[["self"]],["self"]]],[11,"ty","","",2,[[["self"]],["self"]]],[11,"impl_trait_ref","","",2,[[["self"]],["self"]]],[11,"check_trait_ref","","",2,[[["self"],["traitref"]]]],[11,"visit_ty","","",2,[[["self"],["ty"]],["bool"]]],[11,"check_field","","",3,[[["self"],["span"],["span"],["adtdef"],["fielddef"]]]],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",3,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",3,[[["self"],["bodyid"]]]],[11,"visit_item","","",3,[[["self"],["item"]]]],[11,"visit_trait_item","","",3,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",3,[[["self"],["implitem"]]]],[11,"visit_expr","","",3,[[["self"],["expr"]]]],[11,"visit_pat","","",3,[[["self"],["pat"]]]],[11,"def_id_visibility","","",4,[[["self"],["defid"]],["visibility"]]],[11,"item_is_accessible","","",4,[[["self"],["defid"]],["bool"]]],[11,"check_expr_pat_type","","",4,[[["self"],["hirid"],["span"]],["bool"]]],[11,"check_trait_ref","","",4,[[["self"],["traitref"]],["bool"]]],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",4,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",4,[[["self"],["bodyid"]]]],[11,"visit_ty","","",4,[[["self"],["ty"]]]],[11,"visit_trait_ref","","",4,[[["self"],["traitref"]]]],[11,"visit_expr","","",4,[[["self"],["expr"]]]],[11,"visit_qpath","","",4,[[["self"],["qpath"],["nodeid"],["span"]]]],[11,"visit_pat","","",4,[[["self"],["pat"]]]],[11,"visit_local","","",4,[[["self"],["local"]]]],[11,"visit_item","","",4,[[["self"],["item"]]]],[11,"visit_trait_item","","",4,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",4,[[["self"],["implitem"]]]],[11,"visit_ty","","",4,[[["self"],["ty"]],["bool"]]],[11,"path_is_private_type","","",5,[[["self"],["path"]],["bool"]]],[11,"trait_is_public","","",5,[[["self"],["nodeid"]],["bool"]]],[11,"check_generic_bound","","",5,[[["self"],["genericbound"]]]],[11,"item_is_public","","",5,[[["self"],["nodeid"],["visibility"]],["bool"]]],[11,"nested_visit_map","","",6,[[["self"]],["nestedvisitormap"]]],[11,"visit_ty","","",6,[[["self"],["ty"]]]],[11,"visit_expr","","",6,[[["self"],["expr"]]]],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",5,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",5,[[["self"],["item"]]]],[11,"visit_generics","","",5,[[["self"],["generics"]]]],[11,"visit_foreign_item","","",5,[[["self"],["foreignitem"]]]],[11,"visit_ty","","",5,[[["self"],["ty"]]]],[11,"visit_variant","","",5,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",5,[[["self"],["structfield"]]]],[11,"visit_block","","",5,[[["self"],["block"]]]],[11,"visit_expr","","",5,[[["self"],["expr"]]]],[11,"generics","","",7,[[["self"]],["self"]]],[11,"predicates","","",7,[[["self"]],["self"]]],[11,"ty","","",7,[[["self"]],["self"]]],[11,"impl_trait_ref","","",7,[[["self"]],["self"]]],[11,"check_trait_ref","","",7,[[["self"],["traitref"]]]],[11,"visit_ty","","",7,[[["self"],["ty"]],["bool"]]],[11,"check","","",8,[[["self"],["nodeid"],["visibility"]],["searchinterfaceforprivateitemsvisitor"]]],[11,"nested_visit_map","","",8,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",8,[[["self"],["item"]]]],[11,"visit_impl_item","","",8,[[["self"],["implitem"]]]],[11,"visit_expr","","",8,[[["self"],["expr"]]]],[11,"visit_pat","","",8,[[["self"],["pat"]]]]],"paths":[[3,"PubRestrictedVisitor"],[3,"EmbargoVisitor"],[3,"ReachEverythingInTheInterfaceVisitor"],[3,"NamePrivacyVisitor"],[3,"TypePrivacyVisitor"],[3,"ObsoleteVisiblePrivateTypesVisitor"],[3,"ObsoleteCheckTypeForPrivatenessVisitor"],[3,"SearchInterfaceForPrivateItemsVisitor"],[3,"PrivateItemsInPublicInterfacesVisitor"]]};
searchIndex["rustc_resolve"]={"doc":"","items":[[4,"Namespace","rustc_resolve","Different kinds of symbols don't influence each other.",N,N],[13,"TypeNS","","",0,N],[13,"ValueNS","","",0,N],[13,"MacroNS","","",0,N],[3,"PerNS","","Just a helper ‒ separate structure for each namespace.",N,N],[12,"value_ns","","",1,N],[12,"type_ns","","",1,N],[12,"macro_ns","","",1,N],[3,"ImportSuggestion","","A free importable items suggested in case of resolution failure.",N,N],[12,"path","","",2,N],[3,"BindingError","","",N,N],[12,"name","","",3,N],[12,"origin","","",3,N],[12,"target","","",3,N],[3,"BindingInfo","","",N,N],[12,"span","","",4,N],[12,"binding_mode","","",4,N],[3,"UsePlacementFinder","","",N,N],[12,"target_module","","",5,N],[12,"span","","",5,N],[12,"found_use","","",5,N],[3,"Rib","","One local scope.",N,N],[12,"bindings","","",6,N],[12,"kind","","",6,N],[3,"ModuleData","","One node in the tree of modules.",N,N],[12,"parent","","",7,N],[12,"kind","","",7,N],[12,"normal_ancestor_id","","",7,N],[12,"resolutions","","",7,N],[12,"legacy_macro_resolutions","","",7,N],[12,"macro_resolutions","","",7,N],[12,"unresolved_invocations","","",7,N],[12,"no_implicit_prelude","","",7,N],[12,"glob_importers","","",7,N],[12,"globs","","",7,N],[12,"traits","","",7,N],[12,"populated","","",7,N],[12,"span","","Span of the module itself. Used for error reporting.",7,N],[12,"expansion","","",7,N],[3,"NameBinding","","Records a possibly-private value, type, or module definition.",N,N],[12,"kind","","",8,N],[12,"expansion","","",8,N],[12,"span","","",8,N],[12,"vis","","",8,N],[3,"PrivacyError","","",N,N],[12,"0","","",9,N],[12,"1","","",9,N],[12,"2","","",9,N],[3,"UseError","","",N,N],[12,"err","","",10,N],[12,"candidates","","Attach `use` statements for these candidates",10,N],[12,"node_id","","The node id of the module to place the use statements in",10,N],[12,"better","","Whether the diagnostic should state that it's \"better\"",10,N],[3,"AmbiguityError","","",N,N],[12,"span","","",11,N],[12,"name","","",11,N],[12,"lexical","","",11,N],[12,"b1","","",11,N],[12,"b2","","",11,N],[3,"PrimitiveTypeTable","","Interns the names of the primitive types.",N,N],[12,"primitive_types","","",12,N],[3,"Resolver","","The main resolver class.",N,N],[12,"session","","",13,N],[12,"cstore","","",13,N],[12,"definitions","","",13,N],[12,"graph_root","","",13,N],[12,"prelude","","",13,N],[12,"extern_prelude","","",13,N],[12,"has_self","","n.b. This is used only for better diagnostics, not name resolution itself.",13,N],[12,"field_names","","Names of fields of an item `DefId` accessible with dot syntax. Used for hints during error reporting.",13,N],[12,"determined_imports","","All imports known to succeed or fail.",13,N],[12,"indeterminate_imports","","All non-determined imports.",13,N],[12,"current_module","","The module that represents the current item scope.",13,N],[12,"ribs","","The current set of local scopes for types and values. FIXME #4948: Reuse ribs to avoid allocation.",13,N],[12,"label_ribs","","The current set of local scopes, for labels.",13,N],[12,"current_trait_ref","","The trait that the current context can refer to.",13,N],[12,"current_self_type","","The current self type if inside an impl (used for better errors).",13,N],[12,"primitive_type_table","","The idents for the primitive types.",13,N],[12,"def_map","","",13,N],[12,"import_map","","",13,N],[12,"freevars","","",13,N],[12,"freevars_seen","","",13,N],[12,"export_map","","",13,N],[12,"trait_map","","",13,N],[12,"block_map","","A map from nodes to anonymous modules. Anonymous modules are pseudo-modules that are implicitly created around items contained within blocks.",13,N],[12,"module_map","","",13,N],[12,"extern_module_map","","",13,N],[12,"make_glob_map","","",13,N],[12,"glob_map","","Maps imports to the names of items actually imported (this actually maps all imports, but only glob imports are actually interesting).",13,N],[12,"used_imports","","",13,N],[12,"maybe_unused_trait_imports","","",13,N],[12,"maybe_unused_extern_crates","","",13,N],[12,"unused_labels","","A list of labels as of yet unused. Labels will be removed from this map when they are used (in a `break` or `continue` statement)",13,N],[12,"privacy_errors","","privacy errors are delayed until the end in order to deduplicate them",13,N],[12,"ambiguity_errors","","ambiguity errors are delayed for deduplication",13,N],[12,"use_injections","","`use` injections are delayed for better placement and deduplication",13,N],[12,"proc_mac_errors","","`use` injections for proc macros wrongly imported with #[macro_use]",13,N],[12,"gated_errors","","",13,N],[12,"disallowed_shadowing","","",13,N],[12,"arenas","","",13,N],[12,"dummy_binding","","",13,N],[12,"use_extern_macros","","true if `#![feature(use_extern_macros)]`",13,N],[12,"crate_loader","","",13,N],[12,"macro_names","","",13,N],[12,"macro_prelude","","",13,N],[12,"all_macros","","",13,N],[12,"lexical_macro_resolutions","","",13,N],[12,"macro_map","","",13,N],[12,"macro_defs","","",13,N],[12,"local_macro_def_scopes","","",13,N],[12,"macro_exports","","",13,N],[12,"whitelisted_legacy_custom_derives","","",13,N],[12,"found_unresolved_macro","","",13,N],[12,"unused_macros","","List of crate local macros that we need to warn about as being unused. Right now this only includes macro_rules! macros, and macros 2.0.",13,N],[12,"invocations","","Maps the `Mark` of an expansion to its containing module or block.",13,N],[12,"name_already_seen","","Avoid duplicated errors for \"name already defined\".",13,N],[12,"warned_proc_macros","","A set of procedural macros imported by `#[macro_use]` that have already been warned about",13,N],[12,"potentially_unused_imports","","",13,N],[12,"struct_constructors","","This table maps struct IDs into struct constructor IDs, it's not used during normal resolution, only for better error reporting.",13,N],[12,"current_type_ascription","","Only used for better errors on `fn(): fn()`",13,N],[12,"injected_crate","","",13,N],[12,"ignore_extern_prelude_feature","","Only supposed to be used by rustdoc, otherwise should be false.",13,N],[3,"ResolverArenas","","Nothing really interesting here, it just provides memory for the rest of the crate.",N,N],[12,"modules","","",14,N],[12,"local_modules","","",14,N],[12,"name_bindings","","",14,N],[12,"import_directives","","",14,N],[12,"name_resolutions","","",14,N],[12,"invocation_data","","",14,N],[12,"legacy_bindings","","",14,N],[4,"AssocSuggestion","","A field or associated item from self type suggested in case of resolution failure.",N,N],[13,"Field","","",15,N],[13,"MethodWithSelf","","",15,N],[13,"AssocItem","","",15,N],[4,"ResolutionError","","",N,N],[13,"TypeParametersFromOuterFunction","","error E0401: can't use type parameters from outer function",16,N],[13,"NameAlreadyUsedInTypeParameterList","","error E0403: the name is already used for a type parameter in this type parameter list",16,N],[13,"MethodNotMemberOfTrait","","error E0407: method is not a member of trait",16,N],[13,"TypeNotMemberOfTrait","","error E0437: type is not a member of trait",16,N],[13,"ConstNotMemberOfTrait","","error E0438: const is not a member of trait",16,N],[13,"VariableNotBoundInPattern","","error E0408: variable `{}` is not bound in all patterns",16,N],[13,"VariableBoundWithDifferentMode","","error E0409: variable `{}` is bound in inconsistent ways within the same match arm",16,N],[13,"IdentifierBoundMoreThanOnceInParameterList","","error E0415: identifier is bound more than once in this parameter list",16,N],[13,"IdentifierBoundMoreThanOnceInSamePattern","","error E0416: identifier is bound more than once in the same pattern",16,N],[13,"UndeclaredLabel","","error E0426: use of undeclared label",16,N],[13,"SelfImportsOnlyAllowedWithin","","error E0429: `self` imports are only allowed within a { } list",16,N],[13,"SelfImportCanOnlyAppearOnceInTheList","","error E0430: `self` import can only appear once in the list",16,N],[13,"SelfImportOnlyInImportListWithNonEmptyPrefix","","error E0431: `self` import can only appear in an import list with a non-empty prefix",16,N],[13,"UnresolvedImport","","error E0432: unresolved import",16,N],[13,"FailedToResolve","","error E0433: failed to resolve",16,N],[13,"CannotCaptureDynamicEnvironmentInFnItem","","error E0434: can't capture dynamic environment in a fn item",16,N],[13,"AttemptToUseNonConstantValueInConstant","","error E0435: attempt to use a non-constant value in a constant",16,N],[13,"BindingShadowsSomethingUnacceptable","","error E0530: X bindings cannot shadow Ys",16,N],[13,"ForwardDeclaredTyParam","","error E0128: type parameters with a default cannot use forward declared identifiers",16,N],[4,"PatternSource","","",N,N],[13,"Match","","",17,N],[13,"IfLet","","",17,N],[13,"WhileLet","","",17,N],[13,"Let","","",17,N],[13,"For","","",17,N],[13,"FnParam","","",17,N],[4,"AliasPossibility","","",N,N],[13,"No","","",18,N],[13,"Maybe","","",18,N],[4,"PathSource","","",N,N],[13,"Type","","",19,N],[13,"Trait","","",19,N],[13,"Expr","","",19,N],[13,"Pat","","",19,N],[13,"Struct","","",19,N],[13,"TupleStruct","","",19,N],[13,"TraitItem","","",19,N],[13,"Visibility","","",19,N],[13,"ImportPrefix","","",19,N],[4,"TypeParameters","","",N,N],[13,"NoTypeParameters","","",20,N],[13,"HasTypeParameters","","",20,N],[4,"RibKind","","The rib kind controls the translation of local definitions (`Def::Local`) to upvars (`Def::Upvar`).",N,N],[13,"NormalRibKind","","No translation needs to be applied.",21,N],[13,"ClosureRibKind","","We passed through a closure scope at the given node ID. Translate upvars as appropriate.",21,N],[13,"TraitOrImplItemRibKind","","We passed through an impl or trait and are now in one of its methods or associated types. Allow references to ty params that impl or trait binds. Disallow any other upvars (including other ty params that are upvars).",21,N],[13,"ItemRibKind","","We passed through an item scope. Disallow upvars.",21,N],[13,"ConstantItemRibKind","","We're in a constant item. Can't refer to dynamic stuff.",21,N],[13,"ModuleRibKind","","We passed through a module.",21,N],[13,"MacroDefinition","","We passed through a `macro_rules!` statement",21,N],[13,"ForwardTyParamBanRibKind","","All bindings in this rib are type parameters that can't be used from the default of a type parameter because they're not declared before said type parameter. Also see the `visit_generics` override.",21,N],[4,"LexicalScopeBinding","","An intermediate resolution result.",N,N],[13,"Item","","",22,N],[13,"Def","","",22,N],[4,"PathResult","","",N,N],[13,"Module","","",23,N],[13,"NonModule","","",23,N],[13,"Indeterminate","","",23,N],[13,"Failed","","",23,N],[4,"ModuleKind","","",N,N],[13,"Block","","An anonymous module, eg. just a block.",24,N],[13,"Def","","Any module with a name.",24,N],[4,"NameBindingKind","","",N,N],[13,"Def","","",25,N],[13,"Module","","",25,N],[13,"Import","","",25,N],[12,"binding","rustc_resolve::NameBindingKind","",25,N],[12,"directive","","",25,N],[12,"used","","",25,N],[13,"Ambiguity","rustc_resolve","",25,N],[12,"b1","rustc_resolve::NameBindingKind","",25,N],[12,"b2","","",25,N],[4,"MakeGlobMap","rustc_resolve","",N,N],[13,"Yes","","",26,N],[13,"No","","",26,N],[4,"CrateLint","","",N,N],[13,"No","","Do not issue the lint",27,N],[13,"SimplePath","","This lint applies to some random path like `impl ::foo::Bar` or whatever. In this case, we can take the span of that path.",27,N],[13,"UsePath","","This lint comes from a `use` statement. In this case, what we care about really is the root `use` statement; e.g., if we have nested things like `use a::{b, c}`, we care about the `use a` part.",27,N],[12,"root_id","rustc_resolve::CrateLint","",27,N],[12,"root_span","","",27,N],[13,"QPathTrait","rustc_resolve","This is the \"trait item\" from a fully qualified path. For example, we might be resolving  `X::Y::Z` from a path like `<T as X::Y>::Z`. The `path_span` is the span of the to the trait itself (`X::Y`).",27,N],[12,"qpath_id","rustc_resolve::CrateLint","",27,N],[12,"qpath_span","","",27,N],[5,"resolve_error","rustc_resolve","Combines an error with provided span and emits it",N,[[["resolver"],["span"],["resolutionerror"]]]],[5,"resolve_struct_error","","",N,[[["resolver"],["span"],["resolutionerror"]],["diagnosticbuilder"]]],[5,"reduce_impl_span_to_impl_keyword","","Adjust the impl span so that just the `impl` keyword is taken by removing everything after `<` (`\"impl<T> Iterator for A<T> {}\" -> \"impl\"`) and everything after the first whitespace (`\"impl Iterator for A\" -> \"impl\"`)",N,[[["codemap"],["span"]],["span"]]],[5,"is_self_type","","",N,N],[5,"is_self_value","","",N,N],[5,"names_to_string","","",N,N],[5,"path_names_to_string","","",N,[[["path"]],["string"]]],[5,"import_candidate_to_paths","","Get the path for an enum and the variant from an `ImportSuggestion` for an enum variant.",N,N],[5,"show_candidates","","When an entity with a given name is not available in scope, we search for entities with that name in all crates. This method allows outputting the results of this search in a programmer-friendly way",N,N],[5,"module_to_string","","A somewhat inefficient routine to obtain the name of a module.",N,[[["moduledata"]],["option",["string"]]]],[5,"err_path_resolution","","",N,[[],["pathresolution"]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0128","rustc_resolve::diagnostics","",N,N],[0,"__register_diagnostic_E0154","","",N,N],[0,"__register_diagnostic_E0251","","",N,N],[0,"__register_diagnostic_E0252","","",N,N],[0,"__register_diagnostic_E0253","","",N,N],[0,"__register_diagnostic_E0254","","",N,N],[0,"__register_diagnostic_E0255","","",N,N],[0,"__register_diagnostic_E0256","","",N,N],[0,"__register_diagnostic_E0259","","",N,N],[0,"__register_diagnostic_E0260","","",N,N],[0,"__register_diagnostic_E0364","","",N,N],[0,"__register_diagnostic_E0365","","",N,N],[0,"__register_diagnostic_E0401","","",N,N],[0,"__register_diagnostic_E0403","","",N,N],[0,"__register_diagnostic_E0404","","",N,N],[0,"__register_diagnostic_E0405","","",N,N],[0,"__register_diagnostic_E0407","","",N,N],[0,"__register_diagnostic_E0408","","",N,N],[0,"__register_diagnostic_E0409","","",N,N],[0,"__register_diagnostic_E0411","","",N,N],[0,"__register_diagnostic_E0412","","",N,N],[0,"__register_diagnostic_E0415","","",N,N],[0,"__register_diagnostic_E0416","","",N,N],[0,"__register_diagnostic_E0422","","",N,N],[0,"__register_diagnostic_E0423","","",N,N],[0,"__register_diagnostic_E0424","","",N,N],[0,"__register_diagnostic_E0425","","",N,N],[0,"__register_diagnostic_E0426","","",N,N],[0,"__register_diagnostic_E0428","","",N,N],[0,"__register_diagnostic_E0429","","",N,N],[0,"__register_diagnostic_E0430","","",N,N],[0,"__register_diagnostic_E0431","","",N,N],[0,"__register_diagnostic_E0432","","",N,N],[0,"__register_diagnostic_E0433","","",N,N],[0,"__register_diagnostic_E0434","","",N,N],[0,"__register_diagnostic_E0435","","",N,N],[0,"__register_diagnostic_E0437","","",N,N],[0,"__register_diagnostic_E0438","","",N,N],[0,"__register_diagnostic_E0466","","",N,N],[0,"__register_diagnostic_E0468","","",N,N],[0,"__register_diagnostic_E0469","","",N,N],[0,"__register_diagnostic_E0530","","",N,N],[0,"__register_diagnostic_E0532","","",N,N],[0,"__register_diagnostic_E0603","","",N,N],[0,"__register_diagnostic_E0659","","",N,N],[0,"__register_diagnostic_E0531","","",N,N],[0,"__register_diagnostic_E0573","","",N,N],[0,"__register_diagnostic_E0574","","",N,N],[0,"__register_diagnostic_E0575","","",N,N],[0,"__register_diagnostic_E0576","","",N,N],[0,"__register_diagnostic_E0577","","",N,N],[0,"__register_diagnostic_E0578","","",N,N],[0,"macros","rustc_resolve","",N,N],[3,"InvocationData","rustc_resolve::macros","",N,N],[12,"module","","",28,N],[12,"def_index","","",28,N],[12,"legacy_scope","","",28,N],[12,"expansion","","",28,N],[3,"LegacyBinding","","",N,N],[12,"parent","","",29,N],[12,"ident","","",29,N],[12,"def_id","","",29,N],[12,"span","","",29,N],[3,"ProcMacError","","",N,N],[12,"crate_name","","",30,N],[12,"name","","",30,N],[12,"module","","",30,N],[12,"use_span","","",30,N],[12,"warn_msg","","",30,N],[4,"LegacyScope","","",N,N],[13,"Empty","","",31,N],[13,"Invocation","","",31,N],[13,"Expansion","","",31,N],[13,"Binding","","",31,N],[4,"MacroBinding","","",N,N],[13,"Legacy","","",32,N],[13,"Global","","",32,N],[13,"Modern","","",32,N],[11,"clone","","",28,[[["self"]],["invocationdata"]]],[11,"root","","",28,[[["moduledata"]],["self"]]],[11,"clone","","",31,[[["self"]],["legacyscope"]]],[11,"clone","","",32,[[["self"]],["macrobinding"]]],[11,"span","","",32,[[["self"]],["span"]]],[11,"binding","","",32,[[["self"]],["namebinding"]]],[11,"def_ignoring_ambiguity","","",32,[[["self"]],["def"]]],[11,"next_node_id","rustc_resolve","",13,[[["self"]],["nodeid"]]],[11,"get_module_scope","","",13,[[["self"],["nodeid"]],["mark"]]],[11,"eliminate_crate_var","","",13,[[["self"],["p",["item"]]],["p",["item"]]]],[11,"is_whitelisted_legacy_custom_derive","","",13,[[["self"],["name"]],["bool"]]],[11,"visit_ast_fragment_with_placeholders","","",13,N],[11,"add_builtin","","",13,[[["self"],["ident"],["lrc",["syntaxextension"]]]]],[11,"resolve_imports","","",13,[[["self"]]]],[11,"find_legacy_attr_invoc","","",13,[[["self"],["vec"],["bool"]],["option",["attribute"]]]],[11,"resolve_invoc","","",13,[[["self"],["invocation"],["mark"],["bool"]],["result",["option","determinacy"]]]],[11,"resolve_macro","","",13,[[["self"],["mark"],["path"],["macrokind"],["bool"]],["result",["lrc","determinacy"]]]],[11,"check_unused_macros","","",13,[[["self"]]]],[11,"report_proc_macro_stub","","",13,[[["self"],["span"]]]],[11,"resolve_invoc_to_def","","",13,[[["self"],["invocation"],["mark"],["bool"]],["result",["def","determinacy"]]]],[11,"resolve_macro_to_def","","",13,[[["self"],["mark"],["path"],["macrokind"],["bool"]],["result",["def","determinacy"]]]],[11,"resolve_macro_to_def_inner","","",13,[[["self"],["mark"],["path"],["macrokind"],["bool"]],["result",["def","determinacy"]]]],[11,"resolve_lexical_macro_path_segment","","",13,[[["self"],["ident"],["namespace"],["bool"],["span"]],["result",["macrobinding","determinacy"]]]],[11,"resolve_legacy_scope","","",13,[[["self"],["cell"],["ident"],["bool"]],["option",["macrobinding"]]]],[11,"finalize_current_module_macro_resolutions","","",13,[[["self"]]]],[11,"suggest_macro_name","","",13,[[["self"],["str"],["macrokind"],["diagnosticbuilder"],["span"]]]],[11,"collect_def_ids","","",13,[[["self"],["mark"],["invocationdata"],["astfragment"]]]],[11,"define_macro","","",13,[[["self"],["item"],["mark"],["legacyscope"]]]],[11,"err_if_macro_use_proc_macro","","Error if `ext` is a Macros 1.1 procedural macro being imported by `#[macro_use]`",13,[[["self"],["name"],["span"],["namebinding"]]]],[11,"report_proc_macro_import","","",13,[[["self"],["crate"]]]],[11,"gate_legacy_custom_derive","","",13,[[["self"],["symbol"],["span"]]]],[0,"check_unused","","",N,N],[3,"UnusedImportCheckVisitor","rustc_resolve::check_unused","",N,N],[12,"resolver","","",33,N],[12,"unused_imports","","All the (so far) unused imports, grouped path list",33,N],[12,"base_id","","",33,N],[12,"item_span","","",33,N],[5,"check_crate","","",N,[[["resolver"],["crate"]]]],[11,"deref","","",33,[[["self"]],["resolver"]]],[11,"deref_mut","","",33,[[["self"]],["resolver"]]],[11,"check_import","","",33,[[["self"],["nodeid"],["nodeid"],["span"]]]],[11,"visit_item","","",33,[[["self"],["item"]]]],[11,"visit_use_tree","","",33,[[["self"],["usetree"],["nodeid"],["bool"]]]],[0,"build_reduced_graph","rustc_resolve","Reduced graph building",N,N],[3,"LegacyMacroImports","rustc_resolve::build_reduced_graph","",N,N],[12,"import_all","","",34,N],[12,"imports","","",34,N],[3,"BuildReducedGraphVisitor","","",N,N],[12,"resolver","","",35,N],[12,"legacy_scope","","",35,N],[12,"expansion","","",35,N],[11,"default","","",34,[[],["legacymacroimports"]]],[11,"eq","","",34,[[["self"],["legacymacroimports"]],["bool"]]],[11,"ne","","",34,[[["self"],["legacymacroimports"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",34,N],[11,"define","rustc_resolve","Defines `name` in namespace `ns` of module `parent` to be `def` if it is not yet defined; otherwise, reports an error.",13,[[["self"],["moduledata"],["ident"],["namespace"],["t"]]]],[11,"block_needs_anonymous_module","","",13,[[["self"],["block"]],["bool"]]],[11,"insert_field_names","","",13,[[["self"],["defid"],["vec",["name"]]]]],[11,"build_reduced_graph_for_use_tree","","",13,[[["self"],["usetree"],["nodeid"],["usetree"],["nodeid"],["visibility"],["path"],["bool"],["item"],["mark"]]]],[11,"build_reduced_graph_for_item","","Constructs the reduced graph for one item.",13,[[["self"],["item"],["mark"]]]],[11,"build_reduced_graph_for_variant","","",13,[[["self"],["variant"],["moduledata"],["visibility"],["mark"]]]],[11,"build_reduced_graph_for_foreign_item","","Constructs the reduced graph for one foreign item.",13,[[["self"],["foreignitem"],["mark"]]]],[11,"build_reduced_graph_for_block","","",13,[[["self"],["block"],["mark"]]]],[11,"build_reduced_graph_for_external_crate_def","","Builds the reduced graph for a single item in an external crate.",13,[[["self"],["moduledata"],["export"]]]],[11,"get_module","","",13,[[["self"],["defid"]],["moduledata"]]],[11,"macro_def_scope","","",13,[[["self"],["mark"]],["moduledata"]]],[11,"get_macro","","",13,[[["self"],["def"]],["lrc",["syntaxextension"]]]],[11,"populate_module_if_necessary","","Ensures that the reduced graph rooted at the given external module is built, building it if it is not.",13,[[["self"],["moduledata"]]]],[11,"legacy_import_macro","","",13,[[["self"],["name"],["namebinding"],["span"],["bool"]]]],[11,"process_legacy_macro_imports","","",13,[[["self"],["item"],["moduledata"],["mark"]],["bool"]]],[11,"contains_macro_use","","",13,N],[11,"legacy_macro_imports","","",13,N],[11,"visit_invoc","rustc_resolve::build_reduced_graph","",35,[[["self"],["nodeid"]],["invocationdata"]]],[11,"visit_impl_item","","",35,[[["self"],["implitem"]]]],[11,"visit_expr","","",35,[[["self"],["expr"]]]],[11,"visit_pat","","",35,[[["self"],["pat"]]]],[11,"visit_ty","","",35,[[["self"],["ty"]]]],[11,"visit_item","","",35,[[["self"],["item"]]]],[11,"visit_stmt","","",35,[[["self"],["stmt"]]]],[11,"visit_foreign_item","","",35,[[["self"],["foreignitem"]]]],[11,"visit_block","","",35,[[["self"],["block"]]]],[11,"visit_trait_item","","",35,[[["self"],["traititem"]]]],[11,"visit_token","","",35,[[["self"],["token"]]]],[0,"resolve_imports","rustc_resolve","",N,N],[3,"ImportDirective","rustc_resolve::resolve_imports","One import directive.",N,N],[12,"id","","The id of the `extern crate`, `UseTree` etc that imported this `ImportDirective`.",36,N],[12,"root_id","","The `id` of the \"root\" use-kind -- this is always the same as `id` except in the case of \"nested\" use trees, in which case it will be the `id` of the root use tree. e.g., in the example from `id`, this would be the id of the `use foo::bar` `UseTree` node.",36,N],[12,"span","","Span of this use tree.",36,N],[12,"root_span","","Span of the root use tree (see `root_id`).",36,N],[12,"parent","","",36,N],[12,"module_path","","",36,N],[12,"imported_module","","",36,N],[12,"subclass","","",36,N],[12,"vis","","",36,N],[12,"expansion","","",36,N],[12,"used","","",36,N],[3,"NameResolution","","Records information about the resolution of a name in a namespace of a module.",N,N],[12,"single_imports","","Single imports that may define the name in the namespace. Import directives are arena-allocated, so it's ok to use pointers as keys.",37,N],[12,"binding","","The least shadowable known binding for this name, or None if there are no known bindings.",37,N],[12,"shadowed_glob","","",37,N],[3,"ImportResolver","","",N,N],[12,"resolver","","",38,N],[4,"ImportDirectiveSubclass","","Contains data for specific types of import directives.",N,N],[13,"SingleImport","","",39,N],[12,"target","rustc_resolve::resolve_imports::ImportDirectiveSubclass","",39,N],[12,"source","","",39,N],[12,"result","","",39,N],[12,"type_ns_only","","",39,N],[13,"GlobImport","rustc_resolve::resolve_imports","",39,N],[12,"is_prelude","rustc_resolve::resolve_imports::ImportDirectiveSubclass","",39,N],[12,"max_vis","","",39,N],[13,"ExternCrate","rustc_resolve::resolve_imports","",39,N],[13,"MacroUse","","",39,N],[5,"import_path_to_string","","",N,N],[5,"import_directive_subclass_to_string","","",N,[[["importdirectivesubclass"]],["string"]]],[11,"clone","","",39,[[["self"]],["importdirectivesubclass"]]],[11,"fmt","","",39,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"clone","","",36,[[["self"]],["importdirective"]]],[11,"is_glob","","",36,[[["self"]],["bool"]]],[11,"crate_lint","","",36,[[["self"]],["cratelint"]]],[11,"clone","","",37,[[["self"]],["nameresolution"]]],[11,"default","","",37,[[],["nameresolution"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"binding","","",37,[[["self"]],["option",["namebinding"]]]],[11,"resolution","rustc_resolve","",13,[[["self"],["moduledata"],["ident"],["namespace"]],["refcell"]]],[11,"resolve_ident_in_module_unadjusted","","Attempts to resolve `ident` in namespaces `ns` of `module`. Invariant: if `record_used` is `Some`, expansion and import resolution must be complete.",13,[[["self"],["moduledata"],["ident"],["namespace"],["bool"],["bool"],["span"]],["result",["namebinding","determinacy"]]]],[11,"add_import_directive","","",13,[[["self"],["vec",["ident"]],["importdirectivesubclass"],["span"],["nodeid"],["span"],["nodeid"],["visibility"],["mark"]]]],[11,"import","","",13,[[["self"],["namebinding"],["importdirective"]],["namebinding"]]],[11,"try_define","","",13,[[["self"],["moduledata"],["ident"],["namespace"],["namebinding"]],["result",["namebinding"]]]],[11,"ambiguity","","",13,[[["self"],["namebinding"],["namebinding"]],["namebinding"]]],[11,"update_resolution","","",13,[[["self"],["moduledata"],["ident"],["namespace"],["f"]],["t"]]],[11,"import_dummy_binding","","",13,[[["self"],["importdirective"]]]],[11,"deref","rustc_resolve::resolve_imports","",38,[[["self"]],["resolver"]]],[11,"deref_mut","","",38,[[["self"]],["resolver"]]],[11,"resolve_imports","","Resolves all imports for the crate. This method performs the fixed- point iteration.",38,[[["self"]]]],[11,"finalize_imports","","",38,[[["self"]]]],[11,"resolve_import","","Attempts to resolve the given import, returning true if its resolution is determined. If successful, the resolved bindings are written into the module.",38,[[["self"],["importdirective"]],["bool"]]],[11,"finalize_import","","",38,[[["self"],["importdirective"]],["option"]]],[11,"resolve_glob_import","","",38,[[["self"],["importdirective"]]]],[11,"finalize_resolutions_in","","",38,[[["self"],["moduledata"]]]],[6,"BindingMap","rustc_resolve","Map from the name in a pattern to its binding mode.",N,N],[6,"Module","","",N,N],[17,"DIAGNOSTICS","","",N,N],[8,"ToNameBinding","","",N,N],[10,"to_name_binding","","",40,[[["self"],["resolverarenas"]],["namebinding"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"partial_cmp","","",3,[[["self"],["bindingerror"]],["option",["ordering"]]]],[11,"eq","","",3,[[["self"],["bindingerror"]],["bool"]]],[11,"cmp","","",3,[[["self"],["bindingerror"]],["ordering"]]],[11,"clone","","",4,[[["self"]],["bindinginfo"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",17,[[["self"]],["patternsource"]]],[11,"eq","","",17,[[["self"],["patternsource"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"descr","","",17,[[["self"]],["str"]]],[11,"clone","","",18,[[["self"]],["aliaspossibility"]]],[11,"eq","","",18,[[["self"],["aliaspossibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",19,[[["self"]],["pathsource"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"namespace","","",19,[[["self"]],["namespace"]]],[11,"global_by_default","","",19,[[["self"]],["bool"]]],[11,"defer_to_typeck","","",19,[[["self"]],["bool"]]],[11,"descr_expected","","",19,[[["self"]],["str"]]],[11,"is_expected","","",19,[[["self"],["def"]],["bool"]]],[11,"error_code","","",19,[[["self"],["bool"]],["str"]]],[11,"check","","",5,N],[11,"visit_mod","","",5,N],[11,"visit_item","","",13,[[["self"],["item"]]]],[11,"visit_arm","","",13,[[["self"],["arm"]]]],[11,"visit_block","","",13,[[["self"],["block"]]]],[11,"visit_anon_const","","",13,[[["self"],["anonconst"]]]],[11,"visit_expr","","",13,[[["self"],["expr"]]]],[11,"visit_local","","",13,[[["self"],["local"]]]],[11,"visit_ty","","",13,[[["self"],["ty"]]]],[11,"visit_poly_trait_ref","","",13,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_foreign_item","","",13,[[["self"],["foreignitem"]]]],[11,"visit_fn","","",13,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_generics","","",13,[[["self"],["generics"]]]],[11,"clone","","",20,[[["self"]],["typeparameters"]]],[11,"clone","","",21,[[["self"]],["ribkind"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"new","","",6,[[["ribkind"]],["rib"]]],[11,"item","","",22,[[["self"]],["option",["namebinding"]]]],[11,"def","","",22,[[["self"]],["def"]]],[11,"clone","","",23,[[["self"]],["pathresult"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"new","","",7,[[["option",["moduledata"]],["modulekind"],["defid"],["mark"],["span"]],["self"]]],[11,"for_each_child","","",7,[[["self"],["f"]]]],[11,"for_each_child_stable","","",7,[[["self"],["f"]]]],[11,"def","","",7,[[["self"]],["option",["def"]]]],[11,"def_id","","",7,[[["self"]],["option",["defid"]]]],[11,"is_normal","","",7,[[["self"]],["bool"]]],[11,"is_trait","","",7,[[["self"]],["bool"]]],[11,"is_local","","",7,[[["self"]],["bool"]]],[11,"nearest_item_scope","","",7,[[["self"]],["moduledata"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["namebinding"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"clone","","",25,[[["self"]],["namebindingkind"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"module","","",8,[[["self"]],["option",["moduledata"]]]],[11,"def","","",8,[[["self"]],["def"]]],[11,"def_ignoring_ambiguity","","",8,[[["self"]],["def"]]],[11,"get_macro","","",8,[[["self"],["resolver"]],["lrc",["syntaxextension"]]]],[11,"pseudo_vis","","",8,[[["self"]],["visibility"]]],[11,"is_variant","","",8,[[["self"]],["bool"]]],[11,"is_extern_crate","","",8,[[["self"]],["bool"]]],[11,"is_import","","",8,[[["self"]],["bool"]]],[11,"is_renamed_extern_crate","","",8,[[["self"]],["bool"]]],[11,"is_glob_import","","",8,[[["self"]],["bool"]]],[11,"is_importable","","",8,[[["self"]],["bool"]]],[11,"is_macro_def","","",8,[[["self"]],["bool"]]],[11,"descr","","",8,[[["self"]],["str"]]],[11,"new","","",12,[[],["primitivetypetable"]]],[11,"intern","","",12,[[["self"],["str"],["primty"]]]],[11,"alloc_module","","",14,[[["self"],["moduledata"]],["moduledata"]]],[11,"local_modules","","",14,[[["self"]],["ref",["vec"]]]],[11,"alloc_name_binding","","",14,[[["self"],["namebinding"]],["namebinding"]]],[11,"alloc_import_directive","","",14,[[["self"],["importdirective"]],["importdirective"]]],[11,"alloc_name_resolution","","",14,[[["self"]],["refcell"]]],[11,"alloc_invocation_data","","",14,[[["self"],["invocationdata"]],["invocationdata"]]],[11,"alloc_legacy_binding","","",14,[[["self"],["legacybinding"]],["legacybinding"]]],[11,"resolve_hir_path","","",13,[[["self"],["path"],["bool"]]]],[11,"resolve_str_path","","",13,N],[11,"get_resolution","","",13,[[["self"],["nodeid"]],["option",["pathresolution"]]]],[11,"get_import","","",13,[[["self"],["nodeid"]],["perns",["option"]]]],[11,"definitions","","",13,[[["self"]],["definitions"]]],[11,"resolve_str_path_error","","Rustdoc uses this to resolve things in a recoverable way. ResolutionError<'a> isn't something that can be returned because it can't be made to live that long, and also it's a private type. Fortunately rustdoc doesn't need to know the error, just that an error occurred.",13,[[["self"],["span"],["str"],["bool"]],["result",["path"]]]],[11,"resolve_hir_path_cb","","resolve_hir_path, but takes a callback in case there was an error",13,[[["self"],["path"],["bool"],["f"]]]],[11,"new","","",13,[[["session"],["cratestore"],["crate"],["str"],["makeglobmap"],["crateloader"],["resolverarenas"]],["resolver"]]],[11,"arenas","","",13,[[],["resolverarenas"]]],[11,"per_ns","","Runs the function on each namespace.",13,[[["self"],["f"]]]],[11,"macro_def","","",13,[[["self"],["syntaxcontext"]],["defid"]]],[11,"resolve_crate","","Entry point to crate resolution.",13,[[["self"],["crate"]]]],[11,"new_module","","",13,[[["self"],["moduledata"],["modulekind"],["defid"],["mark"],["span"]],["moduledata"]]],[11,"record_use","","",13,[[["self"],["ident"],["namespace"],["namebinding"],["span"]],["bool"]]],[11,"add_to_glob_map","","",13,[[["self"],["nodeid"],["ident"]]]],[11,"resolve_ident_in_lexical_scope","","This resolves the identifier `ident` in the namespace `ns` in the current lexical scope. More specifically, we proceed up the hierarchy of scopes and return the binding for `ident` in the first scope that defines it (or None if no scopes define it).",13,[[["self"],["ident"],["namespace"],["option",["nodeid"]],["span"]],["option",["lexicalscopebinding"]]]],[11,"hygienic_lexical_parent","","",13,[[["self"],["moduledata"],["span"]],["option",["moduledata"]]]],[11,"hygienic_lexical_parent_with_compatibility_fallback","","",13,[[["self"],["moduledata"],["span"],["nodeid"],["option"]],["option",["moduledata"]]]],[11,"resolve_ident_in_module","","",13,[[["self"],["moduledata"],["ident"],["namespace"],["bool"],["span"]],["result",["namebinding","determinacy"]]]],[11,"resolve_crate_root","","",13,[[["self"],["ident"]],["moduledata"]]],[11,"resolve_self","","",13,[[["self"],["syntaxcontext"],["moduledata"]],["moduledata"]]],[11,"with_scope","","",13,[[["self"],["nodeid"],["f"]],["t"]]],[11,"search_label","","Searches the current set of local scopes for labels. Returns the first non-None label that is returned by the given predicate function",13,[[["self"],["ident"],["p"]],["option"]]],[11,"resolve_item","","",13,[[["self"],["item"]]]],[11,"resolve_use_tree","","For the most part, use trees are desugared into `ImportDirective` instances when building the reduced graph (see `build_reduced_graph_for_use_tree`). But there is one special case we handle here: an empty nested import like `a::{b::{}}`, which desugares into...no import directives.",13,[[["self"],["nodeid"],["span"],["nodeid"],["usetree"],["path"]]]],[11,"with_type_parameter_rib","","",13,[[["self"],["typeparameters"],["f"]]]],[11,"with_label_rib","","",13,[[["self"],["f"]]]],[11,"with_item_rib","","",13,[[["self"],["f"]]]],[11,"with_constant_rib","","",13,[[["self"],["f"]]]],[11,"with_current_self_type","","",13,[[["self"],["ty"],["f"]],["t"]]],[11,"with_optional_trait_ref","","This is called to resolve a trait reference from an `impl` (i.e. `impl Trait for Foo`)",13,[[["self"],["option",["traitref"]],["f"]],["t"]]],[11,"with_self_rib","","",13,[[["self"],["def"],["f"]]]],[11,"resolve_implementation","","",13,N],[11,"check_trait_item","","",13,[[["self"],["ident"],["namespace"],["span"],["f"]]]],[11,"resolve_local","","",13,[[["self"],["local"]]]],[11,"binding_mode_map","","",13,[[["self"],["pat"]],["fxhashmap",["ident","bindinginfo"]]]],[11,"check_consistent_bindings","","",13,N],[11,"resolve_arm","","",13,[[["self"],["arm"]]]],[11,"resolve_block","","",13,[[["self"],["block"]]]],[11,"fresh_binding","","",13,[[["self"],["ident"],["nodeid"],["nodeid"],["patternsource"],["fxhashmap"]],["pathresolution"]]],[11,"resolve_pattern","","",13,[[["self"],["pat"],["patternsource"],["fxhashmap"]]]],[11,"smart_resolve_path","","",13,[[["self"],["nodeid"],["option",["qself"]],["path"],["pathsource"]],["pathresolution"]]],[11,"smart_resolve_path_with_crate_lint","","A variant of `smart_resolve_path` where you also specify extra information about where the path came from; this extra info is sometimes needed for the lint that recommends rewriting absolute paths to `crate`, so that it knows how to frame the suggestion. If you are just resolving a path like `foo::bar` that appears...somewhere, though, then you just want `CrateLint::SimplePath`, which is what `smart_resolve_path` already provides.",13,[[["self"],["nodeid"],["option",["qself"]],["path"],["pathsource"],["cratelint"]],["pathresolution"]]],[11,"smart_resolve_path_fragment","","",13,N],[11,"type_ascription_suggestion","","",13,[[["self"],["diagnosticbuilder"],["span"]]]],[11,"self_type_is_available","","",13,[[["self"],["span"]],["bool"]]],[11,"self_value_is_available","","",13,[[["self"],["span"],["span"]],["bool"]]],[11,"resolve_qpath_anywhere","","",13,N],[11,"resolve_qpath","","Handles paths that may refer to associated items.",13,N],[11,"resolve_path","","",13,N],[11,"lint_if_path_starts_with_module","","",13,N],[11,"lint_path_starts_with_module","","",13,[[["self"],["nodeid"],["span"]]]],[11,"adjust_local_def","","",13,[[["self"],["namespace"],["usize"],["def"],["bool"],["span"]],["def"]]],[11,"lookup_assoc_candidate","","",13,[[["self"],["ident"],["namespace"],["filterfn"]],["option",["assocsuggestion"]]]],[11,"lookup_typo_candidate","","",13,N],[11,"with_resolved_label","","",13,[[["self"],["option",["label"]],["nodeid"],["f"]]]],[11,"resolve_labeled_block","","",13,[[["self"],["option",["label"]],["nodeid"],["block"]]]],[11,"resolve_expr","","",13,[[["self"],["expr"],["option",["expr"]]]]],[11,"record_candidate_traits_for_expr_if_necessary","","",13,[[["self"],["expr"]]]],[11,"get_traits_containing_item","","",13,[[["self"],["ident"],["namespace"]],["vec",["traitcandidate"]]]],[11,"get_traits_in_module_containing_item","","",13,[[["self"],["ident"],["namespace"],["moduledata"],["vec"]]]],[11,"lookup_import_candidates","","When name resolution fails, this method can be used to look up candidate entities with the expected name. It allows filtering them using the supplied predicate (which should be used to only accept the types of definitions expected e.g. traits). The lookup spans across all crates.",13,[[["self"],["name"],["namespace"],["filterfn"]],["vec",["importsuggestion"]]]],[11,"find_module","","",13,[[["self"],["def"]],["option"]]],[11,"collect_enum_variants","","",13,[[["self"],["def"]],["option",["vec"]]]],[11,"record_def","","",13,[[["self"],["nodeid"],["pathresolution"]]]],[11,"resolve_visibility","","",13,[[["self"],["visibility"]],["visibility"]]],[11,"is_accessible","","",13,[[["self"],["visibility"]],["bool"]]],[11,"is_accessible_from","","",13,[[["self"],["visibility"],["moduledata"]],["bool"]]],[11,"report_errors","","",13,[[["self"],["crate"]]]],[11,"report_with_use_injections","","",13,[[["self"],["crate"]]]],[11,"report_shadowing_errors","","",13,[[["self"]]]],[11,"report_conflict","","",13,[[["self"],["moduledata"],["ident"],["namespace"],["namebinding"],["namebinding"]]]],[11,"check_proc_macro_attrs","","",13,N],[11,"eq","","",26,[[["self"],["makeglobmap"]],["bool"]]],[11,"clone","","",26,[[["self"]],["makeglobmap"]]],[11,"clone","","",27,[[["self"]],["cratelint"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"node_id","","",27,[[["self"]],["option",["nodeid"]]]],[11,"descr","","",0,[[["self"]],["str"]]],[11,"default","","",1,[[],["perns"]]],[11,"index","","",1,[[["self"],["namespace"]],["t"]]],[11,"clone","","",1,[[["self"]],["perns"]]],[11,"clone","","",0,[[["self"]],["namespace"]]],[11,"cmp","","",0,[[["self"],["namespace"]],["ordering"]]],[11,"index_mut","","",1,[[["self"],["namespace"]],["t"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result",["error"]]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"partial_cmp","","",0,[[["self"],["namespace"]],["option",["ordering"]]]],[11,"hash","","",0,N],[11,"eq","","",0,[[["self"],["namespace"]],["bool"]]],[11,"map","","",1,[[["self"],["f"]],["perns"]]],[11,"is_empty","","Returns whether all the items in this collection are `None`.",1,[[["self"]],["bool"]]],[11,"present_items","","Returns an iterator over the items which are `Some`.",1,N]],"paths":[[4,"Namespace"],[3,"PerNS"],[3,"ImportSuggestion"],[3,"BindingError"],[3,"BindingInfo"],[3,"UsePlacementFinder"],[3,"Rib"],[3,"ModuleData"],[3,"NameBinding"],[3,"PrivacyError"],[3,"UseError"],[3,"AmbiguityError"],[3,"PrimitiveTypeTable"],[3,"Resolver"],[3,"ResolverArenas"],[4,"AssocSuggestion"],[4,"ResolutionError"],[4,"PatternSource"],[4,"AliasPossibility"],[4,"PathSource"],[4,"TypeParameters"],[4,"RibKind"],[4,"LexicalScopeBinding"],[4,"PathResult"],[4,"ModuleKind"],[4,"NameBindingKind"],[4,"MakeGlobMap"],[4,"CrateLint"],[3,"InvocationData"],[3,"LegacyBinding"],[3,"ProcMacError"],[4,"LegacyScope"],[4,"MacroBinding"],[3,"UnusedImportCheckVisitor"],[3,"LegacyMacroImports"],[3,"BuildReducedGraphVisitor"],[3,"ImportDirective"],[3,"NameResolution"],[3,"ImportResolver"],[4,"ImportDirectiveSubclass"],[8,"ToNameBinding"]]};
searchIndex["rustc_save_analysis"]={"doc":"","items":[[3,"SaveContext","rustc_save_analysis","",N,N],[12,"tcx","","",0,N],[12,"tables","","",0,N],[12,"analysis","","",0,N],[12,"span_utils","","",0,N],[12,"config","","",0,N],[12,"impl_counter","","",0,N],[3,"PathCollector","","",N,N],[12,"collected_paths","","",1,N],[12,"collected_idents","","",1,N],[3,"DumpHandler","","Dump the save-analysis results to a file.",N,N],[12,"odir","","",2,N],[12,"cratename","","",2,N],[3,"CallbackHandler","","Call a callback with the results of save-analysis.",N,N],[12,"callback","","",3,N],[4,"Data","","",N,N],[13,"RefData","","",4,N],[13,"DefData","","",4,N],[13,"RelationData","","",4,N],[5,"make_signature","","",N,[[["fndecl"],["generics"]],["string"]]],[5,"process_crate","","",N,[[["tyctxt"],["crate"],["crateanalysis"],["str"],["option",["config"]],["h"]]]],[5,"find_config","","",N,[[["option",["config"]]],["config"]]],[5,"escape","","",N,[[["string"]],["string"]]],[5,"generated_code","","",N,[[["span"]],["bool"]]],[5,"id_from_def_id","","",N,[[["defid"]],["id"]]],[5,"id_from_node_id","","",N,[[["nodeid"],["savecontext"]],["id"]]],[5,"null_id","","",N,[[],["id"]]],[5,"lower_attributes","","",N,[[["vec",["attribute"]],["savecontext"]],["vec",["attribute"]]]],[0,"json_dumper","","",N,N],[3,"Access","rustc_save_analysis::json_dumper","",N,N],[12,"reachable","","",5,N],[12,"public","","",5,N],[3,"JsonDumper","","",N,N],[12,"result","","",6,N],[12,"config","","",6,N],[12,"output","","",6,N],[3,"WriteOutput","","",N,N],[12,"output","","",7,N],[3,"CallbackOutput","","",N,N],[12,"callback","","",8,N],[8,"DumpOutput","","",N,N],[10,"dump","","",9,[[["self"],["analysis"]]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"dump","","",7,[[["self"],["analysis"]]]],[11,"dump","","",8,[[["self"],["analysis"]]]],[11,"new","","",6,[[["w"],["config"]],["jsondumper",["writeoutput"]]]],[11,"with_callback","","",6,[[["fnmut"],["config"]],["jsondumper",["callbackoutput"]]]],[11,"drop","","",6,[[["self"]]]],[11,"crate_prelude","","",6,[[["self"],["cratepreludedata"]]]],[11,"macro_use","","",6,[[["self"],["macroref"]]]],[11,"import","","",6,[[["self"],["access"],["import"]]]],[11,"dump_ref","","",6,[[["self"],["ref"]]]],[11,"dump_def","","",6,[[["self"],["access"],["def"]]]],[11,"dump_relation","","",6,[[["self"],["relation"]]]],[11,"dump_impl","","",6,[[["self"],["impl"]]]],[0,"dump_visitor","rustc_save_analysis","Write the output of rustc's analysis to an implementor of Dump.",N,N],[3,"DumpVisitor","rustc_save_analysis::dump_visitor","",N,N],[12,"save_ctxt","","",10,N],[12,"tcx","","",10,N],[12,"dumper","","",10,N],[12,"span","","",10,N],[12,"cur_scope","","",10,N],[12,"macro_calls","","",10,N],[11,"new","","",10,[[["savecontext"],["jsondumper"]],["dumpvisitor"]]],[11,"nest_scope","","",10,[[["self"],["nodeid"],["f"]]]],[11,"nest_tables","","",10,[[["self"],["nodeid"],["f"]]]],[11,"span_from_span","","",10,[[["self"],["span"]],["spandata"]]],[11,"dump_crate_info","","",10,[[["self"],["str"],["crate"]]]],[11,"process_path_prefixes","","",10,[[["self"],["path"]],["vec"]]],[11,"write_sub_paths","","",10,[[["self"],["path"]]]],[11,"write_sub_paths_truncated","","",10,[[["self"],["path"]]]],[11,"write_sub_path_trait_truncated","","",10,[[["self"],["path"]]]],[11,"lookup_def_id","","",10,[[["self"],["nodeid"]],["option",["defid"]]]],[11,"process_formals","","",10,N],[11,"process_method","","",10,[[["self"],["methodsig"],["option",["block"]],["nodeid"],["ident"],["generics"],["visibility"],["span"]]]],[11,"process_struct_field_def","","",10,[[["self"],["structfield"],["nodeid"]]]],[11,"process_generic_params","","",10,[[["self"],["generics"],["span"],["str"],["nodeid"]]]],[11,"process_fn","","",10,[[["self"],["item"],["fndecl"],["generics"],["block"]]]],[11,"process_static_or_const_item","","",10,[[["self"],["item"],["ty"],["expr"]]]],[11,"process_assoc_const","","",10,N],[11,"process_struct","","",10,[[["self"],["item"],["variantdata"],["generics"]]]],[11,"process_enum","","",10,[[["self"],["item"],["enumdef"],["generics"]]]],[11,"process_impl","","",10,N],[11,"process_trait","","",10,N],[11,"process_mod","","",10,[[["self"],["item"]]]],[11,"dump_path_ref","","",10,[[["self"],["nodeid"],["path"]]]],[11,"process_path","","",10,[[["self"],["nodeid"],["path"]]]],[11,"process_struct_lit","","",10,N],[11,"process_method_call","","",10,N],[11,"process_pat","","",10,[[["self"],["pat"]]]],[11,"process_var_decl_multi","","",10,N],[11,"process_var_decl","","",10,[[["self"],["pat"],["string"]]]],[11,"process_macro_use","","Extract macro use and definition information from the AST node defined by the given NodeId, using the expansion information from the node's span.",10,[[["self"],["span"]]]],[11,"process_trait_item","","",10,[[["self"],["traititem"],["defid"]]]],[11,"process_impl_item","","",10,[[["self"],["implitem"],["defid"]]]],[11,"process_use_tree","","Dumps imports in a use tree recursively.",10,[[["self"],["usetree"],["nodeid"],["item"],["path"]]]],[11,"visit_mod","","",10,N],[11,"visit_item","","",10,[[["self"],["item"]]]],[11,"visit_generics","","",10,[[["self"],["generics"]]]],[11,"visit_ty","","",10,[[["self"],["ty"]]]],[11,"visit_expr","","",10,[[["self"],["expr"]]]],[11,"visit_mac","","",10,[[["self"],["mac"]]]],[11,"visit_pat","","",10,[[["self"],["pat"]]]],[11,"visit_arm","","",10,[[["self"],["arm"]]]],[11,"visit_path","","",10,[[["self"],["path"],["nodeid"]]]],[11,"visit_stmt","","",10,[[["self"],["stmt"]]]],[11,"visit_local","","",10,[[["self"],["local"]]]],[11,"visit_foreign_item","","",10,[[["self"],["foreignitem"]]]],[0,"span_utils","rustc_save_analysis","",N,N],[3,"SpanUtils","rustc_save_analysis::span_utils","",N,N],[12,"sess","","",11,N],[12,"err_count","","",11,N],[11,"clone","","",11,[[["self"]],["spanutils"]]],[11,"new","","",11,[[["session"]],["spanutils"]]],[11,"make_path_string","","",11,[[["filename"]],["string"]]],[11,"snippet","","",11,[[["self"],["span"]],["string"]]],[11,"retokenise_span","","",11,[[["self"],["span"]],["stringreader"]]],[11,"span_for_last_ident","","",11,[[["self"],["span"]],["option",["span"]]]],[11,"span_for_first_ident","","",11,[[["self"],["span"]],["option",["span"]]]],[11,"sub_span_for_type_name","","",11,[[["self"],["span"]],["option",["span"]]]],[11,"sub_span_before_token","","",11,[[["self"],["span"],["token"]],["option",["span"]]]],[11,"sub_span_of_token","","",11,[[["self"],["span"],["token"]],["option",["span"]]]],[11,"sub_span_after_keyword","","",11,[[["self"],["span"],["keyword"]],["option",["span"]]]],[11,"sub_span_after","","",11,[[["self"],["span"],["f"]],["option",["span"]]]],[11,"filter_generated","","Return true if the span is generated code, and it is not a subspan of the root callsite.",11,[[["self"],["option",["span"]],["span"]],["bool"]]],[0,"sig","rustc_save_analysis","",N,N],[5,"item_signature","rustc_save_analysis::sig","",N,[[["item"],["savecontext"]],["option",["signature"]]]],[5,"foreign_item_signature","","",N,[[["foreignitem"],["savecontext"]],["option",["signature"]]]],[5,"field_signature","","Signature for a struct or tuple field declaration. Does not include a trailing comma.",N,[[["structfield"],["savecontext"]],["option",["signature"]]]],[5,"variant_signature","","Does not include a trailing comma.",N,[[["variant"],["savecontext"]],["option",["signature"]]]],[5,"method_signature","","",N,[[["nodeid"],["ident"],["generics"],["methodsig"],["savecontext"]],["option",["signature"]]]],[5,"assoc_const_signature","","",N,[[["nodeid"],["name"],["ty"],["option",["expr"]],["savecontext"]],["option",["signature"]]]],[5,"assoc_type_signature","","",N,[[["nodeid"],["ident"],["option",["genericbounds"]],["option",["ty"]],["savecontext"]],["option",["signature"]]]],[5,"extend_sig","","",N,[[["signature"],["string"],["vec",["sigelement"]],["vec",["sigelement"]]],["signature"]]],[5,"replace_text","","",N,[[["signature"],["string"]],["signature"]]],[5,"merge_sigs","","",N,[[["string"],["vec",["signature"]]],["signature"]]],[5,"text_sig","","",N,[[["string"]],["signature"]]],[5,"name_and_generics","","",N,[[["string"],["usize"],["generics"],["nodeid"],["ident"],["savecontext"]],["result",["signature","str"]]]],[5,"make_assoc_type_signature","","",N,[[["nodeid"],["ident"],["option",["genericbounds"]],["option",["ty"]],["savecontext"]],["result",["signature","str"]]]],[5,"make_assoc_const_signature","","",N,[[["nodeid"],["name"],["ty"],["option",["expr"]],["savecontext"]],["result",["signature","str"]]]],[5,"make_method_signature","","",N,[[["nodeid"],["ident"],["generics"],["methodsig"],["savecontext"]],["result",["signature","str"]]]],[6,"Result","","",N,N],[8,"Sig","","",N,N],[10,"make","","",12,[[["self"],["usize"],["option",["nodeid"]],["savecontext"]],["result",["signature","str"]]]],[8,"SaveHandler","rustc_save_analysis","Defines what to do with the results of saving the analysis.",N,N],[10,"save","","",13,[[["self"],["savecontext"],["crate"],["str"]]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"span_from_span","","",0,[[["self"],["span"]],["spandata"]]],[11,"get_external_crates","","",0,[[["self"]],["vec",["externalcratedata"]]]],[11,"get_extern_item_data","","",0,[[["self"],["foreignitem"]],["option",["data"]]]],[11,"get_item_data","","",0,[[["self"],["item"]],["option",["data"]]]],[11,"get_field_data","","",0,[[["self"],["structfield"],["nodeid"]],["option",["def"]]]],[11,"get_method_data","","",0,[[["self"],["nodeid"],["name"],["span"]],["option",["def"]]]],[11,"get_trait_ref_data","","",0,[[["self"],["traitref"]],["option",["ref"]]]],[11,"get_expr_data","","",0,[[["self"],["expr"]],["option",["data"]]]],[11,"get_path_def","","",0,[[["self"],["nodeid"]],["hirdef"]]],[11,"get_path_data","","",0,[[["self"],["nodeid"],["path"]],["option",["ref"]]]],[11,"get_field_ref_data","","",0,[[["self"],["field"],["variantdef"]],["option",["ref"]]]],[11,"get_macro_use_data","","Attempt to return MacroRef for any AST node.",0,[[["self"],["span"]],["option",["macroref"]]]],[11,"lookup_ref_id","","",0,[[["self"],["nodeid"]],["option",["defid"]]]],[11,"docs_for_attrs","","",0,N],[11,"next_impl_id","","",0,[[["self"]],["u32"]]],[11,"new","","",1,[[],["pathcollector"]]],[11,"visit_pat","","",1,[[["self"],["pat"]]]],[11,"new","","",2,[[["option",["path"]],["str"]],["dumphandler"]]],[11,"output_file","","",2,[[["self"],["savecontext"]],["file"]]],[11,"save","","",2,[[["self"],["savecontext"],["crate"],["str"]]]],[11,"save","","",3,[[["self"],["savecontext"],["crate"],["str"]]]]],"paths":[[3,"SaveContext"],[3,"PathCollector"],[3,"DumpHandler"],[3,"CallbackHandler"],[4,"Data"],[3,"Access"],[3,"JsonDumper"],[3,"WriteOutput"],[3,"CallbackOutput"],[8,"DumpOutput"],[3,"DumpVisitor"],[3,"SpanUtils"],[8,"Sig"],[8,"SaveHandler"]]};
searchIndex["rustc_target"]={"doc":"Some stuff used by rustc that doesn't have many dependencies","items":[[0,"abi","rustc_target","",N,N],[3,"TargetDataLayout","rustc_target::abi","Parsed Data layout for a target, which contains everything needed to compute layouts.",N,N],[12,"endian","","",0,N],[12,"i1_align","","",0,N],[12,"i8_align","","",0,N],[12,"i16_align","","",0,N],[12,"i32_align","","",0,N],[12,"i64_align","","",0,N],[12,"i128_align","","",0,N],[12,"f32_align","","",0,N],[12,"f64_align","","",0,N],[12,"pointer_size","","",0,N],[12,"pointer_align","","",0,N],[12,"aggregate_align","","",0,N],[12,"vector_align","","Alignments for vector types.",0,N],[3,"Size","","Size of a type in bytes.",N,N],[12,"raw","","",1,N],[3,"Align","","Alignment of a type in bytes, both ABI-mandated and preferred. Each field is a power of two, giving the alignment a maximum value of 2(28 - 1), which is limited by LLVM to a maximum capacity of 229 or 536870912.",N,N],[12,"abi_pow2","","",2,N],[12,"pref_pow2","","",2,N],[3,"Scalar","","Information about one scalar component of a Rust type.",N,N],[12,"value","","",3,N],[12,"valid_range","","Inclusive wrap-around range of valid values, that is, if min > max, it represents min..=u128::MAX followed by 0..=max.",3,N],[3,"LayoutDetails","","",N,N],[12,"variants","","",4,N],[12,"fields","","",4,N],[12,"abi","","",4,N],[12,"align","","",4,N],[12,"size","","",4,N],[3,"TyLayout","","The details of the layout of a type, alongside the type itself. Provides various type traversal APIs (e.g. recursing into fields).",N,N],[12,"ty","","",5,N],[12,"details","","",5,N],[4,"Endian","","Endianness of the target, which must match cfg(target-endian).",N,N],[13,"Little","","",6,N],[13,"Big","","",6,N],[4,"Integer","","Integers, also used for enum discriminants.",N,N],[13,"I8","","",7,N],[13,"I16","","",7,N],[13,"I32","","",7,N],[13,"I64","","",7,N],[13,"I128","","",7,N],[4,"FloatTy","","",N,N],[13,"F32","","",8,N],[13,"F64","","",8,N],[4,"Primitive","","Fundamental unit of memory access and layout.",N,N],[13,"Int","","The `bool` is the signedness of the `Integer` type.",9,N],[13,"Float","","",9,N],[13,"Pointer","","",9,N],[4,"FieldPlacement","","Describes how the fields of a type are located in memory.",N,N],[13,"Union","","All fields start at no offset. The `usize` is the field count.",10,N],[13,"Array","","Array/vector-like placement, with all fields of identical types.",10,N],[12,"stride","rustc_target::abi::FieldPlacement","",10,N],[12,"count","","",10,N],[13,"Arbitrary","rustc_target::abi","Struct-like placement, with precomputed offsets.",10,N],[12,"offsets","rustc_target::abi::FieldPlacement","Offsets for the first byte of each field, ordered to match the source definition order. This vector does not go in increasing order.",10,N],[12,"memory_index","","Maps source order field indices to memory order indices, depending how fields were permuted.",10,N],[4,"Abi","rustc_target::abi","Describes how values of the type are passed by target ABIs, in terms of categories of C types there are ABI rules for.",N,N],[13,"Uninhabited","","",11,N],[13,"Scalar","","",11,N],[13,"ScalarPair","","",11,N],[13,"Vector","","",11,N],[12,"element","rustc_target::abi::Abi","",11,N],[12,"count","","",11,N],[13,"Aggregate","rustc_target::abi","",11,N],[12,"sized","rustc_target::abi::Abi","If true, the size is exact, otherwise it's only a lower bound.",11,N],[4,"Variants","rustc_target::abi","",N,N],[13,"Single","","Single enum variants, structs/tuples, unions, and all non-ADTs.",12,N],[12,"index","rustc_target::abi::Variants","",12,N],[13,"Tagged","rustc_target::abi","General-case enums: for each case there is a struct, and they all have all space reserved for the tag, and their first field starts at a non-0 offset, after where the tag would go.",12,N],[12,"tag","rustc_target::abi::Variants","",12,N],[12,"variants","","",12,N],[13,"NicheFilling","rustc_target::abi","Multiple cases distinguished by a niche (values invalid for a type): the variant `dataful_variant` contains a niche at an arbitrary offset (field 0 of the enum), which for a variant with discriminant `d` is set to `(d - niche_variants.start).wrapping_add(niche_start)`.",12,N],[12,"dataful_variant","rustc_target::abi::Variants","",12,N],[12,"niche_variants","","",12,N],[12,"niche","","",12,N],[12,"niche_start","","",12,N],[12,"variants","","",12,N],[0,"call","rustc_target::abi","",N,N],[3,"ArgAttribute","rustc_target::abi::call","",N,N],[12,"bits","","",13,N],[3,"ArgAttributes","","A compact representation of LLVM attributes (at least those relevant for this module) that can be manipulated without interacting with LLVM's Attribute machinery.",N,N],[12,"regular","","",14,N],[12,"pointee_size","","",14,N],[12,"pointee_align","","",14,N],[3,"Reg","","",N,N],[12,"kind","","",15,N],[12,"size","","",15,N],[3,"Uniform","","An argument passed entirely registers with the same kind (e.g. HFA / HVA on PPC64 and AArch64).",N,N],[12,"unit","","",16,N],[12,"total","","The total size of the argument, which can be: * equal to `unit.size` (one scalar/vector) * a multiple of `unit.size` (an array of scalar/vectors) * if `unit.kind` is `Integer`, the last element   can be shorter, i.e. `{ i64, i64, i32 }` for   64-bit integers with a total size of 20 bytes",16,N],[3,"CastTarget","","",N,N],[12,"prefix","","",17,N],[12,"prefix_chunk","","",17,N],[12,"rest","","",17,N],[3,"ArgType","","Information about how to pass an argument to, or return a value from, a function, under some ABI.",N,N],[12,"layout","","",18,N],[12,"pad","","Dummy argument, which is emitted before the real argument.",18,N],[12,"mode","","",18,N],[3,"FnType","","Metadata describing how the arguments to a native function should be passed in order to respect the native ABI.",N,N],[12,"args","","The LLVM types of each argument.",19,N],[12,"ret","","LLVM return type.",19,N],[12,"variadic","","",19,N],[12,"conv","","",19,N],[4,"PassMode","","",N,N],[13,"Ignore","","Ignore the argument (useful for empty struct).",20,N],[13,"Direct","","Pass the argument directly.",20,N],[13,"Pair","","Pass a pair's elements directly in two arguments.",20,N],[13,"Cast","","Pass the argument after casting it, to either a single uniform or a pair of registers.",20,N],[13,"Indirect","","Pass the argument indirectly via a hidden pointer.",20,N],[4,"RegKind","","",N,N],[13,"Integer","","",21,N],[13,"Float","","",21,N],[13,"Vector","","",21,N],[4,"Conv","","",N,N],[13,"C","","",22,N],[13,"ArmAapcs","","",22,N],[13,"Msp430Intr","","",22,N],[13,"PtxKernel","","",22,N],[13,"X86Fastcall","","",22,N],[13,"X86Intr","","",22,N],[13,"X86Stdcall","","",22,N],[13,"X86ThisCall","","",22,N],[13,"X86VectorCall","","",22,N],[13,"X86_64SysV","","",22,N],[13,"X86_64Win64","","",22,N],[13,"AmdGpuKernel","","",22,N],[0,"aarch64","","",N,N],[5,"is_homogeneous_aggregate","rustc_target::abi::call::aarch64","",N,[[["c"],["argtype"]],["option",["uniform"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"arm","rustc_target::abi::call","",N,N],[5,"is_homogeneous_aggregate","rustc_target::abi::call::arm","",N,[[["c"],["argtype"]],["option",["uniform"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"],["bool"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["bool"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"asmjs","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::asmjs","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"hexagon","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::hexagon","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"mips","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::mips","",N,[[["c"],["argtype"],["size"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["size"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"mips64","rustc_target::abi::call","",N,N],[5,"extend_integer_width_mips","rustc_target::abi::call::mips64","",N,[[["argtype"],["u64"]]]],[5,"float_reg","","",N,[[["c"],["argtype"],["usize"]],["option",["reg"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"msp430","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::msp430","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"nvptx","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::nvptx","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"nvptx64","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::nvptx64","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"powerpc","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::powerpc","",N,[[["c"],["argtype"],["size"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["size"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"powerpc64","rustc_target::abi::call","",N,N],[4,"ABI","rustc_target::abi::call::powerpc64","",N,N],[13,"ELFv1","","",23,N],[13,"ELFv2","","",23,N],[5,"is_homogeneous_aggregate","","",N,[[["c"],["argtype"],["abi"]],["option",["uniform"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"],["abi"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["abi"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"clone","","",23,[[["self"]],["abi"]]],[11,"eq","","",23,[[["self"],["abi"]],["bool"]]],[0,"s390x","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::s390x","",N,[[["argtype"]]]],[5,"is_single_fp_element","","",N,[[["c"],["tylayout"]],["bool"]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"sparc","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::sparc","",N,[[["c"],["argtype"],["size"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["size"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"sparc64","rustc_target::abi::call","",N,N],[5,"is_homogeneous_aggregate","rustc_target::abi::call::sparc64","",N,[[["c"],["argtype"]],["option",["uniform"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"x86","rustc_target::abi::call","",N,N],[4,"Flavor","rustc_target::abi::call::x86","",N,N],[13,"General","","",24,N],[13,"Fastcall","","",24,N],[5,"is_single_fp_element","","",N,[[["c"],["tylayout"]],["bool"]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"],["flavor"]]]],[11,"eq","","",24,[[["self"],["flavor"]],["bool"]]],[0,"x86_64","rustc_target::abi::call","",N,N],[3,"Memory","rustc_target::abi::call::x86_64","",N,N],[4,"Class","","Classification of \"eightbyte\" components.",N,N],[13,"Int","","",25,N],[13,"Sse","","",25,N],[13,"SseUp","","",25,N],[5,"classify_arg","","",N,[[["c"],["argtype"]],["result",["memory"]]]],[5,"reg_component","","",N,N],[5,"cast_target","","",N,N],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[17,"LARGEST_VECTOR_SIZE","","",N,N],[17,"MAX_EIGHTBYTES","","",N,N],[11,"clone","","",25,[[["self"]],["class"]]],[11,"eq","","",25,[[["self"],["class"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",25,N],[11,"partial_cmp","","",25,[[["self"],["class"]],["option",["ordering"]]]],[11,"cmp","","",25,[[["self"],["class"]],["ordering"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"clone","","",26,[[["self"]],["memory"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[0,"x86_win64","rustc_target::abi::call","",N,N],[5,"compute_abi_info","rustc_target::abi::call::x86_win64","",N,[[["fntype"]]]],[0,"wasm32","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::wasm32","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"attr_impl","rustc_target::abi::call","",N,N],[3,"ArgAttribute","rustc_target::abi::call::attr_impl","",N,N],[12,"bits","","",13,N],[11,"eq","rustc_target::abi::call","",13,[[["self"],["argattribute"]],["bool"]]],[11,"ne","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"clone","","",13,[[["self"]],["argattribute"]]],[11,"partial_cmp","","",13,[[["self"],["argattribute"]],["option",["ordering"]]]],[11,"lt","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"le","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"gt","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"ge","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"cmp","","",13,[[["self"],["argattribute"]],["ordering"]]],[11,"hash","","",13,N],[11,"default","","",13,[[],["argattribute"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[18,"ByVal","","",13,N],[18,"NoAlias","","",13,N],[18,"NoCapture","","",13,N],[18,"NonNull","","",13,N],[18,"ReadOnly","","",13,N],[18,"SExt","","",13,N],[18,"StructRet","","",13,N],[18,"ZExt","","",13,N],[18,"InReg","","",13,N],[11,"empty","","Returns an empty set of flags.",13,[[],["argattribute"]]],[11,"all","","Returns the set containing all flags.",13,[[],["argattribute"]]],[11,"bits","","Returns the raw value of the flags currently stored.",13,[[["self"]],["u16"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",13,[[["u16"]],["option",["argattribute"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",13,[[["u16"]],["argattribute"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",13,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",13,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",13,[[["self"],["argattribute"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",13,[[["self"],["argattribute"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",13,[[["self"],["argattribute"]]]],[11,"remove","","Removes the specified flags in-place.",13,[[["self"],["argattribute"]]]],[11,"toggle","","Toggles the specified flags in-place.",13,[[["self"],["argattribute"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",13,[[["self"],["argattribute"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",13,[[["self"],["argattribute"]],["argattribute"]]],[11,"bitor_assign","","Adds the set of flags.",13,[[["self"],["argattribute"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",13,[[["self"],["argattribute"]],["argattribute"]]],[11,"bitxor_assign","","Toggles the set of flags.",13,[[["self"],["argattribute"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",13,[[["self"],["argattribute"]],["argattribute"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",13,[[["self"],["argattribute"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",13,[[["self"],["argattribute"]],["argattribute"]]],[11,"sub_assign","","Disables all flags enabled in the set.",13,[[["self"],["argattribute"]]]],[11,"not","","Returns the complement of this set of flags.",13,[[["self"]],["argattribute"]]],[11,"extend","","",13,[[["self"],["t"]]]],[11,"from_iter","","",13,[[["t"]],["argattribute"]]],[11,"clone","","",20,[[["self"]],["passmode"]]],[11,"eq","","",20,[[["self"],["passmode"]],["bool"]]],[11,"ne","","",20,[[["self"],["passmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",20,N],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"clone","","",14,[[["self"]],["argattributes"]]],[11,"eq","","",14,[[["self"],["argattributes"]],["bool"]]],[11,"ne","","",14,[[["self"],["argattributes"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",14,N],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"new","","",14,[[],["self"]]],[11,"set","","",14,[[["self"],["argattribute"]],["self"]]],[11,"contains","","",14,[[["self"],["argattribute"]],["bool"]]],[11,"clone","","",21,[[["self"]],["regkind"]]],[11,"eq","","",21,[[["self"],["regkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"clone","","",15,[[["self"]],["reg"]]],[11,"eq","","",15,[[["self"],["reg"]],["bool"]]],[11,"ne","","",15,[[["self"],["reg"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",15,N],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"i8","","",15,[[],["reg"]]],[11,"i16","","",15,[[],["reg"]]],[11,"i32","","",15,[[],["reg"]]],[11,"i64","","",15,[[],["reg"]]],[11,"f32","","",15,[[],["reg"]]],[11,"f64","","",15,[[],["reg"]]],[11,"align","","",15,[[["self"],["c"]],["align"]]],[11,"clone","","",16,[[["self"]],["uniform"]]],[11,"eq","","",16,[[["self"],["uniform"]],["bool"]]],[11,"ne","","",16,[[["self"],["uniform"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",16,N],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"from","","",16,[[["reg"]],["uniform"]]],[11,"align","","",16,[[["self"],["c"]],["align"]]],[11,"clone","","",17,[[["self"]],["casttarget"]]],[11,"eq","","",17,[[["self"],["casttarget"]],["bool"]]],[11,"ne","","",17,[[["self"],["casttarget"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"from","","",17,[[["reg"]],["casttarget"]]],[11,"from","","",17,[[["uniform"]],["casttarget"]]],[11,"pair","","",17,[[["reg"],["reg"]],["casttarget"]]],[11,"size","","",17,[[["self"],["c"]],["size"]]],[11,"align","","",17,[[["self"],["c"]],["align"]]],[11,"is_aggregate","rustc_target::abi","",5,[[["self"]],["bool"]]],[11,"homogeneous_aggregate","","",5,[[["self"],["c"]],["option",["reg"]]]],[11,"fmt","rustc_target::abi::call","",18,[[["self"],["formatter"]],["result"]]],[11,"new","","",18,[[["tylayout"]],["self"]]],[11,"make_indirect","","",18,[[["self"]]]],[11,"make_indirect_byval","","",18,[[["self"]]]],[11,"extend_integer_width_to","","",18,[[["self"],["u64"]]]],[11,"cast_to","","",18,[[["self"],["t"]]]],[11,"pad_with","","",18,[[["self"],["reg"]]]],[11,"is_indirect","","",18,[[["self"]],["bool"]]],[11,"is_ignore","","",18,[[["self"]],["bool"]]],[11,"clone","","",22,[[["self"]],["conv"]]],[11,"eq","","",22,[[["self"],["conv"]],["bool"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"adjust_for_cabi","","",19,[[["self"],["c"],["abi"]],["result",["string"]]]],[22,"","rustc_target::abi","",N,N],[8,"HasDataLayout","","",N,N],[10,"data_layout","","",27,[[["self"]],["targetdatalayout"]]],[8,"LayoutOf","","",N,N],[16,"Ty","","",28,N],[16,"TyLayout","","",28,N],[10,"layout_of","","",28,N],[8,"TyLayoutMethods","","",N,N],[10,"for_variant","","",29,[[["tylayout"],["c"],["usize"]],["tylayout"]]],[10,"field","","",29,N],[11,"default","","Creates an instance of `TargetDataLayout`.",0,[[],["targetdatalayout"]]],[11,"parse","","",0,[[["target"]],["result",["targetdatalayout","string"]]]],[11,"obj_size_bound","","Return exclusive upper bound on object size.",0,[[["self"]],["u64"]]],[11,"ptr_sized_integer","","",0,[[["self"]],["integer"]]],[11,"vector_align","","",0,[[["self"],["size"]],["align"]]],[11,"clone","","",6,[[["self"]],["endian"]]],[11,"clone","","",1,[[["self"]],["size"]]],[11,"eq","","",1,[[["self"],["size"]],["bool"]]],[11,"ne","","",1,[[["self"],["size"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1,N],[11,"partial_cmp","","",1,[[["self"],["size"]],["option",["ordering"]]]],[11,"lt","","",1,[[["self"],["size"]],["bool"]]],[11,"le","","",1,[[["self"],["size"]],["bool"]]],[11,"gt","","",1,[[["self"],["size"]],["bool"]]],[11,"ge","","",1,[[["self"],["size"]],["bool"]]],[11,"cmp","","",1,[[["self"],["size"]],["ordering"]]],[11,"hash","","",1,N],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"encode","","",1,[[["self"],["__s"]],["result"]]],[11,"decode","","",1,[[["__d"]],["result",["size"]]]],[18,"ZERO","","",1,N],[11,"from_bits","","",1,[[["u64"]],["size"]]],[11,"from_bytes","","",1,[[["u64"]],["size"]]],[11,"bytes","","",1,[[["self"]],["u64"]]],[11,"bits","","",1,[[["self"]],["u64"]]],[11,"abi_align","","",1,[[["self"],["align"]],["size"]]],[11,"is_abi_aligned","","",1,[[["self"],["align"]],["bool"]]],[11,"checked_add","","",1,[[["self"],["size"],["c"]],["option",["size"]]]],[11,"checked_mul","","",1,[[["self"],["u64"],["c"]],["option",["size"]]]],[11,"add","","",1,[[["self"],["size"]],["size"]]],[11,"sub","","",1,[[["self"],["size"]],["size"]]],[11,"mul","","",1,[[["self"],["u64"]],["size"]]],[11,"add_assign","","",1,[[["self"],["size"]]]],[11,"clone","","",2,[[["self"]],["align"]]],[11,"eq","","",2,[[["self"],["align"]],["bool"]]],[11,"ne","","",2,[[["self"],["align"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"cmp","","",2,[[["self"],["align"]],["ordering"]]],[11,"partial_cmp","","",2,[[["self"],["align"]],["option",["ordering"]]]],[11,"lt","","",2,[[["self"],["align"]],["bool"]]],[11,"le","","",2,[[["self"],["align"]],["bool"]]],[11,"gt","","",2,[[["self"],["align"]],["bool"]]],[11,"ge","","",2,[[["self"],["align"]],["bool"]]],[11,"hash","","",2,N],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"encode","","",2,[[["self"],["__s"]],["result"]]],[11,"decode","","",2,[[["__d"]],["result",["align"]]]],[11,"from_bits","","",2,[[["u64"],["u64"]],["result",["align","string"]]]],[11,"from_bytes","","",2,[[["u64"],["u64"]],["result",["align","string"]]]],[11,"abi","","",2,[[["self"]],["u64"]]],[11,"pref","","",2,[[["self"]],["u64"]]],[11,"abi_bits","","",2,[[["self"]],["u64"]]],[11,"pref_bits","","",2,[[["self"]],["u64"]]],[11,"min","","",2,[[["self"],["align"]],["align"]]],[11,"max","","",2,[[["self"],["align"]],["align"]]],[11,"clone","","",7,[[["self"]],["integer"]]],[11,"eq","","",7,[[["self"],["integer"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"partial_cmp","","",7,[[["self"],["integer"]],["option",["ordering"]]]],[11,"cmp","","",7,[[["self"],["integer"]],["ordering"]]],[11,"hash","","",7,N],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"size","","",7,[[["self"]],["size"]]],[11,"align","","",7,[[["self"],["c"]],["align"]]],[11,"fit_signed","","Find the smallest Integer type which can represent the signed value.",7,[[["i128"]],["integer"]]],[11,"fit_unsigned","","Find the smallest Integer type which can represent the unsigned value.",7,[[["u128"]],["integer"]]],[11,"for_abi_align","","Find the smallest integer with the given alignment.",7,[[["c"],["align"]],["option",["integer"]]]],[11,"approximate_abi_align","","Find the largest integer with the given alignment or less.",7,[[["c"],["align"]],["integer"]]],[11,"clone","","",8,[[["self"]],["floatty"]]],[11,"eq","","",8,[[["self"],["floatty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"encode","","",8,[[["self"],["__s"]],["result"]]],[11,"decode","","",8,[[["__d"]],["result",["floatty"]]]],[11,"hash","","",8,N],[11,"partial_cmp","","",8,[[["self"],["floatty"]],["option",["ordering"]]]],[11,"cmp","","",8,[[["self"],["floatty"]],["ordering"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"ty_to_string","","",8,[[["self"]],["str"]]],[11,"bit_width","","",8,[[["self"]],["usize"]]],[11,"clone","","",9,[[["self"]],["primitive"]]],[11,"eq","","",9,[[["self"],["primitive"]],["bool"]]],[11,"ne","","",9,[[["self"],["primitive"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"hash","","",9,N],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"size","","",9,[[["self"],["c"]],["size"]]],[11,"align","","",9,[[["self"],["c"]],["align"]]],[11,"is_float","","",9,[[["self"]],["bool"]]],[11,"is_int","","",9,[[["self"]],["bool"]]],[11,"clone","","",3,[[["self"]],["scalar"]]],[11,"eq","","",3,[[["self"],["scalar"]],["bool"]]],[11,"ne","","",3,[[["self"],["scalar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"hash","","",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"is_bool","","",3,[[["self"]],["bool"]]],[11,"valid_range_exclusive","","Returns the valid range as a `x..y` range.",3,[[["self"],["c"]],["range",["u128"]]]],[11,"eq","","",10,[[["self"],["fieldplacement"]],["bool"]]],[11,"ne","","",10,[[["self"],["fieldplacement"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"hash","","",10,N],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"count","","",10,[[["self"]],["usize"]]],[11,"offset","","",10,[[["self"],["usize"]],["size"]]],[11,"memory_index","","",10,[[["self"],["usize"]],["usize"]]],[11,"index_by_increasing_offset","","Get source indices of the fields by increasing offsets.",10,[[["self"]],[""]]],[11,"clone","","",11,[[["self"]],["abi"]]],[11,"eq","","",11,[[["self"],["abi"]],["bool"]]],[11,"ne","","",11,[[["self"],["abi"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",11,N],[11,"hash","","",11,N],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",11,[[["self"]],["bool"]]],[11,"is_signed","","Returns true if this is a single signed integer scalar",11,[[["self"]],["bool"]]],[11,"eq","","",12,[[["self"],["variants"]],["bool"]]],[11,"ne","","",12,[[["self"],["variants"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"hash","","",12,N],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["layoutdetails"]],["bool"]]],[11,"ne","","",4,[[["self"],["layoutdetails"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"hash","","",4,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"scalar","","",4,[[["c"],["scalar"]],["self"]]],[11,"clone","","",5,[[["self"]],["tylayout"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"deref","","",5,[[["self"]],["layoutdetails"]]],[11,"for_variant","","",5,[[["self"],["c"],["usize"]],["self"]]],[11,"field","","",5,N],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",5,[[["self"]],["bool"]]],[11,"is_zst","","Returns true if the type is a ZST and not unsized.",5,[[["self"]],["bool"]]],[11,"size_and_align","","",5,N],[0,"spec","rustc_target","Flexible target specification.",N,N],[3,"Target","rustc_target::spec","Everything `rustc` knows about how to compile for a specific target.",N,N],[12,"llvm_target","","Target triple to pass to LLVM.",30,N],[12,"target_endian","","String to use as the `target_endian` `cfg` variable.",30,N],[12,"target_pointer_width","","String to use as the `target_pointer_width` `cfg` variable.",30,N],[12,"target_c_int_width","","Width of c_int type",30,N],[12,"target_os","","OS name to use for conditional compilation.",30,N],[12,"target_env","","Environment name to use for conditional compilation.",30,N],[12,"target_vendor","","Vendor name to use for conditional compilation.",30,N],[12,"arch","","Architecture to use for ABI considerations. Valid options: \"x86\", \"x86_64\", \"arm\", \"aarch64\", \"mips\", \"powerpc\", and \"powerpc64\".",30,N],[12,"data_layout","","Data layout to pass to LLVM.",30,N],[12,"linker_flavor","","Linker flavor",30,N],[12,"options","","Optional settings with defaults.",30,N],[3,"TargetOptions","","Optional aspects of a target specification.",N,N],[12,"is_builtin","","Whether the target is built-in or loaded from a custom target specification.",31,N],[12,"linker","","Linker to invoke",31,N],[12,"pre_link_args","","Linker arguments that are passed before any user-defined libraries.",31,N],[12,"pre_link_args_crt","","",31,N],[12,"pre_link_objects_exe","","Objects to link before all others, always found within the sysroot folder.",31,N],[12,"pre_link_objects_exe_crt","","",31,N],[12,"pre_link_objects_dll","","",31,N],[12,"late_link_args","","Linker arguments that are unconditionally passed after any user-defined but before post_link_objects.  Standard platform libraries that should be always be linked to, usually go here.",31,N],[12,"post_link_objects","","Objects to link after all others, always found within the sysroot folder.",31,N],[12,"post_link_objects_crt","","",31,N],[12,"post_link_args","","Linker arguments that are unconditionally passed after any user-defined libraries.",31,N],[12,"link_env","","Environment variables to be set before invoking the linker.",31,N],[12,"asm_args","","Extra arguments to pass to the external assembler (when used)",31,N],[12,"cpu","","Default CPU to pass to LLVM. Corresponds to `llc -mcpu=$cpu`. Defaults to \"generic\".",31,N],[12,"features","","Default target features to pass to LLVM. These features will always be passed, and cannot be disabled even via `-C`. Corresponds to `llc -mattr=$features`.",31,N],[12,"dynamic_linking","","Whether dynamic linking is available on this target. Defaults to false.",31,N],[12,"only_cdylib","","If dynamic linking is available, whether only cdylibs are supported.",31,N],[12,"executables","","Whether executables are available on this target. iOS, for example, only allows static libraries. Defaults to false.",31,N],[12,"relocation_model","","Relocation model to use in object file. Corresponds to `llc -relocation-model=$relocation_model`. Defaults to \"pic\".",31,N],[12,"code_model","","Code model to use. Corresponds to `llc -code-model=$code_model`.",31,N],[12,"tls_model","","TLS model to use. Options are \"global-dynamic\" (default), \"local-dynamic\", \"initial-exec\" and \"local-exec\". This is similar to the -ftls-model option in GCC/Clang.",31,N],[12,"disable_redzone","","Do not emit code that uses the \"red zone\", if the ABI has one. Defaults to false.",31,N],[12,"eliminate_frame_pointer","","Eliminate frame pointers from stack frames if possible. Defaults to true.",31,N],[12,"function_sections","","Emit each function in its own section. Defaults to true.",31,N],[12,"dll_prefix","","String to prepend to the name of every dynamic library. Defaults to \"lib\".",31,N],[12,"dll_suffix","","String to append to the name of every dynamic library. Defaults to \".so\".",31,N],[12,"exe_suffix","","String to append to the name of every executable.",31,N],[12,"staticlib_prefix","","String to prepend to the name of every static library. Defaults to \"lib\".",31,N],[12,"staticlib_suffix","","String to append to the name of every static library. Defaults to \".a\".",31,N],[12,"target_family","","OS family to use for conditional compilation. Valid options: \"unix\", \"windows\".",31,N],[12,"abi_return_struct_as_int","","Whether the target toolchain's ABI supports returning small structs as an integer.",31,N],[12,"is_like_osx","","Whether the target toolchain is like macOS's. Only useful for compiling against iOS/macOS, in particular running dsymutil and some other stuff like `-dead_strip`. Defaults to false.",31,N],[12,"is_like_solaris","","Whether the target toolchain is like Solaris's. Only useful for compiling against Illumos/Solaris, as they have a different set of linker flags. Defaults to false.",31,N],[12,"is_like_windows","","Whether the target toolchain is like Windows'. Only useful for compiling against Windows, only really used for figuring out how to find libraries, since Windows uses its own library naming convention. Defaults to false.",31,N],[12,"is_like_msvc","","",31,N],[12,"is_like_android","","Whether the target toolchain is like Android's. Only useful for compiling against Android. Defaults to false.",31,N],[12,"is_like_emscripten","","Whether the target toolchain is like Emscripten's. Only useful for compiling with Emscripten toolchain. Defaults to false.",31,N],[12,"linker_is_gnu","","Whether the linker support GNU-like arguments such as -O. Defaults to false.",31,N],[12,"allows_weak_linkage","","The MinGW toolchain has a known issue that prevents it from correctly handling COFF object files with more than 215 sections. Since each weak symbol needs its own COMDAT section, weak linkage implies a large number sections that easily exceeds the given limit for larger codebases. Consequently we want a way to disallow weak linkage on some platforms.",31,N],[12,"has_rpath","","Whether the linker support rpaths or not. Defaults to false.",31,N],[12,"no_default_libraries","","Whether to disable linking to the default libraries, typically corresponds to `-nodefaultlibs`. Defaults to true.",31,N],[12,"position_independent_executables","","Dynamically linked executables can be compiled as position independent if the default relocation model of position independent code is not changed. This is a requirement to take advantage of ASLR, as otherwise the functions in the executable are not randomized and can be used during an exploit of a vulnerability in any code.",31,N],[12,"relro_level","","Either partial, full, or off. Full RELRO makes the dynamic linker resolve all symbols at startup and marks the GOT read-only before starting the program, preventing overwriting the GOT.",31,N],[12,"archive_format","","Format that archives should be emitted in. This affects whether we use LLVM to assemble an archive or fall back to the system linker, and currently only \"gnu\" is used to fall into LLVM. Unknown strings cause the system linker to be used.",31,N],[12,"allow_asm","","Is asm!() allowed? Defaults to true.",31,N],[12,"custom_unwind_resume","","Whether the target uses a custom unwind resumption routine. By default LLVM lowers `resume` instructions into calls to `_Unwind_Resume` defined in libgcc.  If this option is enabled, the target must provide `eh_unwind_resume` lang item.",31,N],[12,"exe_allocation_crate","","If necessary, a different crate to link exe allocators by default",31,N],[12,"has_elf_tls","","Flag indicating whether ELF TLS (e.g. #[thread_local]) is available for this target.",31,N],[12,"obj_is_bitcode","","",31,N],[12,"no_integrated_as","","",31,N],[12,"min_atomic_width","","Don't use this field; instead use the `.min_atomic_width()` method.",31,N],[12,"max_atomic_width","","Don't use this field; instead use the `.max_atomic_width()` method.",31,N],[12,"atomic_cas","","Whether the target supports atomic CAS operations natively",31,N],[12,"panic_strategy","","Panic strategy: \"unwind\" or \"abort\"",31,N],[12,"abi_blacklist","","A blacklist of ABIs unsupported by the current target. Note that generic ABIs are considered to be supported on all platforms and cannot be blacklisted.",31,N],[12,"crt_static_allows_dylibs","","Whether or not linking dylibs to a static CRT is allowed.",31,N],[12,"crt_static_default","","Whether or not the CRT is statically linked by default.",31,N],[12,"crt_static_respected","","Whether or not crt-static is respected by the compiler (or is a no-op).",31,N],[12,"stack_probes","","Whether or not stack probes (__rust_probestack) are enabled",31,N],[12,"min_global_align","","The minimum alignment for global symbols.",31,N],[12,"default_codegen_units","","Default number of codegen units to use in debug mode",31,N],[12,"trap_unreachable","","Whether to generate trap instructions in places where optimization would otherwise produce control flow that falls through into unrelated memory.",31,N],[12,"requires_lto","","This target requires everything to be compiled with LTO to emit a final executable, aka there is no native linker for this target.",31,N],[12,"singlethread","","This target has no support for threads.",31,N],[12,"no_builtins","","Whether library functions call lowering/optimization is disabled in LLVM for this target unconditionally.",31,N],[12,"i128_lowering","","Whether to lower 128-bit operations to compiler_builtins calls.  Use if your backend only supports 64-bit and smaller math.",31,N],[12,"codegen_backend","","The codegen backend to use for this target, typically \"llvm\"",31,N],[12,"default_hidden_visibility","","The default visibility for symbols in this target should be \"hidden\" rather than \"default\"",31,N],[12,"embed_bitcode","","Whether or not bitcode is embedded in object files",31,N],[12,"emit_debug_gdb_scripts","","Whether a .debug_gdb_scripts section will be added to the output object file",31,N],[12,"requires_uwtable","","Whether or not to unconditionally `uwtable` attributes on functions, typically because the platform needs to unwind for things like stack unwinders.",31,N],[4,"LinkerFlavor","","",N,N],[13,"Em","","",32,N],[13,"Gcc","","",32,N],[13,"Ld","","",32,N],[13,"Msvc","","",32,N],[13,"Lld","","",32,N],[4,"LldFlavor","","",N,N],[13,"Wasm","","",33,N],[13,"Ld64","","",33,N],[13,"Ld","","",33,N],[13,"Link","","",33,N],[4,"PanicStrategy","","",N,N],[13,"Unwind","","",34,N],[13,"Abort","","",34,N],[4,"RelroLevel","","",N,N],[13,"Full","","",35,N],[13,"Partial","","",35,N],[13,"Off","","",35,N],[13,"None","","",35,N],[4,"TargetTriple","","Either a target triple string or a path to a JSON file.",N,N],[13,"TargetTriple","","",36,N],[13,"TargetPath","","",36,N],[5,"load_specific","","",N,[[["str"]],["targetresult"]]],[5,"get_targets","","",N,[[],["box",["iterator"]]]],[5,"maybe_jemalloc","","",N,[[],["option",["string"]]]],[0,"abi","","",N,N],[3,"AbiData","rustc_target::spec::abi","",N,N],[12,"abi","","",37,N],[12,"name","","Name of this ABI as we like it called.",37,N],[12,"generic","","A generic ABI is supported on all platforms.",37,N],[4,"Abi","","",N,N],[13,"Cdecl","","",38,N],[13,"Stdcall","","",38,N],[13,"Fastcall","","",38,N],[13,"Vectorcall","","",38,N],[13,"Thiscall","","",38,N],[13,"Aapcs","","",38,N],[13,"Win64","","",38,N],[13,"SysV64","","",38,N],[13,"PtxKernel","","",38,N],[13,"Msp430Interrupt","","",38,N],[13,"X86Interrupt","","",38,N],[13,"AmdGpuKernel","","",38,N],[13,"Rust","","",38,N],[13,"C","","",38,N],[13,"System","","",38,N],[13,"RustIntrinsic","","",38,N],[13,"RustCall","","",38,N],[13,"PlatformIntrinsic","","",38,N],[13,"Unadjusted","","",38,N],[5,"lookup","","Returns the ABI with the given name (if any).",N,[[["str"]],["option",["abi"]]]],[5,"all_names","","",N,[[],["vec",["str"]]]],[17,"AbiDatas","","",N,N],[11,"eq","","",38,[[["self"],["abi"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",38,N],[11,"partial_cmp","","",38,[[["self"],["abi"]],["option",["ordering"]]]],[11,"cmp","","",38,[[["self"],["abi"]],["ordering"]]],[11,"hash","","",38,N],[11,"encode","","",38,[[["self"],["__s"]],["result"]]],[11,"decode","","",38,[[["__d"]],["result",["abi"]]]],[11,"clone","","",38,[[["self"]],["abi"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"clone","","",37,[[["self"]],["abidata"]]],[11,"index","","",38,[[["self"]],["usize"]]],[11,"data","","",38,[[["self"]],["abidata"]]],[11,"name","","",38,[[["self"]],["str"]]],[11,"generic","","",38,[[["self"]],["bool"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[0,"android_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::android_base","",N,[[],["targetoptions"]]],[0,"apple_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::apple_base","",N,[[],["targetoptions"]]],[0,"apple_ios_base","rustc_target::spec","",N,N],[4,"Arch","rustc_target::spec::apple_ios_base","",N,N],[13,"Armv7","","",39,N],[13,"Armv7s","","",39,N],[13,"Arm64","","",39,N],[13,"I386","","",39,N],[13,"X86_64","","",39,N],[5,"get_sdk_root","","",N,[[["str"]],["result",["string","string"]]]],[5,"build_pre_link_args","","",N,[[["arch"]],["result",["linkargs","string"]]]],[5,"target_cpu","","",N,[[["arch"]],["string"]]],[5,"opts","","",N,[[["arch"]],["result",["targetoptions","string"]]]],[11,"clone","","",39,[[["self"]],["arch"]]],[11,"to_string","","",39,[[["self"]],["str"]]],[0,"arm_base","rustc_target::spec","",N,N],[5,"abi_blacklist","rustc_target::spec::arm_base","",N,[[],["vec",["abi"]]]],[0,"bitrig_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::bitrig_base","",N,[[],["targetoptions"]]],[0,"cloudabi_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::cloudabi_base","",N,[[],["targetoptions"]]],[0,"dragonfly_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::dragonfly_base","",N,[[],["targetoptions"]]],[0,"freebsd_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::freebsd_base","",N,[[],["targetoptions"]]],[0,"haiku_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::haiku_base","",N,[[],["targetoptions"]]],[0,"linux_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::linux_base","",N,[[],["targetoptions"]]],[0,"linux_musl_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::linux_musl_base","",N,[[],["targetoptions"]]],[0,"openbsd_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::openbsd_base","",N,[[],["targetoptions"]]],[0,"netbsd_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::netbsd_base","",N,[[],["targetoptions"]]],[0,"solaris_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::solaris_base","",N,[[],["targetoptions"]]],[0,"windows_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::windows_base","",N,[[],["targetoptions"]]],[0,"windows_msvc_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::windows_msvc_base","",N,[[],["targetoptions"]]],[0,"thumb_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::thumb_base","",N,[[],["targetoptions"]]],[0,"l4re_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::l4re_base","",N,[[],["targetoptions"]]],[0,"fuchsia_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::fuchsia_base","",N,[[],["targetoptions"]]],[0,"redox_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::redox_base","",N,[[],["targetoptions"]]],[0,"x86_64_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"x86_64_unknown_linux_gnux32","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_linux_gnux32","",N,[[],["targetresult"]]],[0,"i686_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"i586_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i586_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"mips_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"mips64_unknown_linux_gnuabi64","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips64_unknown_linux_gnuabi64","",N,[[],["targetresult"]]],[0,"mips64el_unknown_linux_gnuabi64","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips64el_unknown_linux_gnuabi64","",N,[[],["targetresult"]]],[0,"mipsel_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mipsel_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"powerpc_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"powerpc_unknown_linux_gnuspe","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc_unknown_linux_gnuspe","",N,[[],["targetresult"]]],[0,"powerpc64_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc64_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"powerpc64le_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc64le_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"powerpc64le_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc64le_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"s390x_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::s390x_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"sparc_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::sparc_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"sparc64_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::sparc64_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"arm_unknown_linux_gnueabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_unknown_linux_gnueabi","",N,[[],["targetresult"]]],[0,"arm_unknown_linux_gnueabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_unknown_linux_gnueabihf","",N,[[],["targetresult"]]],[0,"arm_unknown_linux_musleabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_unknown_linux_musleabi","",N,[[],["targetresult"]]],[0,"arm_unknown_linux_musleabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_unknown_linux_musleabihf","",N,[[],["targetresult"]]],[0,"armv4t_unknown_linux_gnueabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv4t_unknown_linux_gnueabi","",N,[[],["targetresult"]]],[0,"armv5te_unknown_linux_gnueabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv5te_unknown_linux_gnueabi","",N,[[],["targetresult"]]],[0,"armv5te_unknown_linux_musleabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv5te_unknown_linux_musleabi","",N,[[],["targetresult"]]],[0,"armv7_unknown_linux_gnueabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_unknown_linux_gnueabihf","",N,[[],["targetresult"]]],[0,"armv7_unknown_linux_musleabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_unknown_linux_musleabihf","",N,[[],["targetresult"]]],[0,"aarch64_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"aarch64_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"x86_64_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"i686_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"i586_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i586_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"mips_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"mipsel_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mipsel_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"mips_unknown_linux_uclibc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips_unknown_linux_uclibc","",N,[[],["targetresult"]]],[0,"mipsel_unknown_linux_uclibc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mipsel_unknown_linux_uclibc","",N,[[],["targetresult"]]],[0,"i686_linux_android","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_linux_android","",N,[[],["targetresult"]]],[0,"x86_64_linux_android","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_linux_android","",N,[[],["targetresult"]]],[0,"arm_linux_androideabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_linux_androideabi","",N,[[],["targetresult"]]],[0,"armv7_linux_androideabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_linux_androideabi","",N,[[],["targetresult"]]],[0,"aarch64_linux_android","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_linux_android","",N,[[],["targetresult"]]],[0,"aarch64_unknown_freebsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_freebsd","",N,[[],["targetresult"]]],[0,"i686_unknown_freebsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_freebsd","",N,[[],["targetresult"]]],[0,"x86_64_unknown_freebsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_freebsd","",N,[[],["targetresult"]]],[0,"i686_unknown_dragonfly","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_dragonfly","",N,[[],["targetresult"]]],[0,"x86_64_unknown_dragonfly","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_dragonfly","",N,[[],["targetresult"]]],[0,"x86_64_unknown_bitrig","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_bitrig","",N,[[],["targetresult"]]],[0,"aarch64_unknown_openbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_openbsd","",N,[[],["targetresult"]]],[0,"i686_unknown_openbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_openbsd","",N,[[],["targetresult"]]],[0,"x86_64_unknown_openbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_openbsd","",N,[[],["targetresult"]]],[0,"armv6_unknown_netbsd_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv6_unknown_netbsd_eabihf","",N,[[],["targetresult"]]],[0,"armv7_unknown_netbsd_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_unknown_netbsd_eabihf","",N,[[],["targetresult"]]],[0,"i686_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_netbsd","",N,[[],["targetresult"]]],[0,"powerpc_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc_unknown_netbsd","",N,[[],["targetresult"]]],[0,"sparc64_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::sparc64_unknown_netbsd","",N,[[],["targetresult"]]],[0,"x86_64_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_netbsd","",N,[[],["targetresult"]]],[0,"x86_64_rumprun_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_rumprun_netbsd","",N,[[],["targetresult"]]],[0,"i686_unknown_haiku","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_haiku","",N,[[],["targetresult"]]],[0,"x86_64_unknown_haiku","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_haiku","",N,[[],["targetresult"]]],[0,"x86_64_apple_darwin","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_apple_darwin","",N,[[],["targetresult"]]],[0,"i686_apple_darwin","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_apple_darwin","",N,[[],["targetresult"]]],[0,"aarch64_fuchsia","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_fuchsia","",N,[[],["targetresult"]]],[0,"x86_64_fuchsia","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_fuchsia","",N,[[],["targetresult"]]],[0,"x86_64_unknown_l4re_uclibc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_l4re_uclibc","",N,[[],["targetresult"]]],[0,"x86_64_unknown_redox","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_redox","",N,[[],["targetresult"]]],[0,"i386_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i386_apple_ios","",N,[[],["targetresult"]]],[0,"x86_64_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_apple_ios","",N,[[],["targetresult"]]],[0,"aarch64_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_apple_ios","",N,[[],["targetresult"]]],[0,"armv7_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_apple_ios","",N,[[],["targetresult"]]],[0,"armv7s_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7s_apple_ios","",N,[[],["targetresult"]]],[0,"armebv7r_none_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armebv7r_none_eabihf","",N,[[],["targetresult"]]],[0,"x86_64_sun_solaris","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_sun_solaris","",N,[[],["targetresult"]]],[0,"sparcv9_sun_solaris","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::sparcv9_sun_solaris","",N,[[],["targetresult"]]],[0,"x86_64_pc_windows_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_pc_windows_gnu","",N,[[],["targetresult"]]],[0,"i686_pc_windows_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_pc_windows_gnu","",N,[[],["targetresult"]]],[0,"x86_64_pc_windows_msvc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_pc_windows_msvc","",N,[[],["targetresult"]]],[0,"i686_pc_windows_msvc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_pc_windows_msvc","",N,[[],["targetresult"]]],[0,"i586_pc_windows_msvc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i586_pc_windows_msvc","",N,[[],["targetresult"]]],[0,"asmjs_unknown_emscripten","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::asmjs_unknown_emscripten","",N,[[],["result",["target","string"]]]],[0,"wasm32_unknown_emscripten","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::wasm32_unknown_emscripten","",N,[[],["result",["target","string"]]]],[0,"wasm32_unknown_unknown","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::wasm32_unknown_unknown","",N,[[],["result",["target","string"]]]],[0,"wasm32_experimental_emscripten","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::wasm32_experimental_emscripten","",N,[[],["result",["target","string"]]]],[0,"thumbv6m_none_eabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv6m_none_eabi","",N,[[],["targetresult"]]],[0,"thumbv7m_none_eabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv7m_none_eabi","",N,[[],["targetresult"]]],[0,"thumbv7em_none_eabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv7em_none_eabi","",N,[[],["targetresult"]]],[0,"thumbv7em_none_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv7em_none_eabihf","",N,[[],["targetresult"]]],[0,"msp430_none_elf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::msp430_none_elf","",N,[[],["targetresult"]]],[0,"aarch64_unknown_cloudabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_cloudabi","",N,[[],["targetresult"]]],[0,"armv7_unknown_cloudabi_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_unknown_cloudabi_eabihf","",N,[[],["targetresult"]]],[0,"i686_unknown_cloudabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_cloudabi","",N,[[],["targetresult"]]],[0,"x86_64_unknown_cloudabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_cloudabi","",N,[[],["targetresult"]]],[6,"LinkArgs","rustc_target::spec","",N,N],[6,"TargetResult","","",N,N],[17,"TARGETS","","List of supported targets",N,N],[8,"HasTargetSpec","","",N,N],[10,"target_spec","","",40,[[["self"]],["target"]]],[11,"clone","","",32,[[["self"]],["linkerflavor"]]],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",32,N],[11,"cmp","","",32,[[["self"],["linkerflavor"]],["ordering"]]],[11,"eq","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"ne","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"partial_cmp","","",32,[[["self"],["linkerflavor"]],["option",["ordering"]]]],[11,"lt","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"le","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"gt","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"ge","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"hash","","",32,N],[11,"encode","","",32,[[["self"],["__s"]],["result"]]],[11,"decode","","",32,[[["__d"]],["result",["linkerflavor"]]]],[11,"clone","","",33,[[["self"]],["lldflavor"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",33,N],[11,"cmp","","",33,[[["self"],["lldflavor"]],["ordering"]]],[11,"eq","","",33,[[["self"],["lldflavor"]],["bool"]]],[11,"partial_cmp","","",33,[[["self"],["lldflavor"]],["option",["ordering"]]]],[11,"hash","","",33,N],[11,"encode","","",33,[[["self"],["__s"]],["result"]]],[11,"decode","","",33,[[["__d"]],["result",["lldflavor"]]]],[11,"to_json","","",32,[[["self"]],["json"]]],[11,"one_of","","",32,[[],["str"]]],[11,"from_str","","",32,[[["str"]],["option"]]],[11,"desc","","",32,[[["self"]],["str"]]],[11,"clone","","",34,[[["self"]],["panicstrategy"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"eq","","",34,[[["self"],["panicstrategy"]],["bool"]]],[11,"hash","","",34,N],[11,"encode","","",34,[[["self"],["__s"]],["result"]]],[11,"decode","","",34,[[["__d"]],["result",["panicstrategy"]]]],[11,"desc","","",34,[[["self"]],["str"]]],[11,"to_json","","",34,[[["self"]],["json"]]],[11,"clone","","",35,[[["self"]],["relrolevel"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"eq","","",35,[[["self"],["relrolevel"]],["bool"]]],[11,"hash","","",35,N],[11,"encode","","",35,[[["self"],["__s"]],["result"]]],[11,"decode","","",35,[[["__d"]],["result",["relrolevel"]]]],[11,"desc","","",35,[[["self"]],["str"]]],[11,"from_str","","",35,[[["str"]],["result",["relrolevel"]]]],[11,"to_json","","",35,[[["self"]],["json"]]],[11,"eq","","",30,[[["self"],["target"]],["bool"]]],[11,"ne","","",30,[[["self"],["target"]],["bool"]]],[11,"clone","","",30,[[["self"]],["target"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"eq","","",31,[[["self"],["targetoptions"]],["bool"]]],[11,"ne","","",31,[[["self"],["targetoptions"]],["bool"]]],[11,"clone","","",31,[[["self"]],["targetoptions"]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"default","","Create a set of \"sane defaults\" for any target. This is still incomplete, and if used for compilation, will certainly not work.",31,[[],["targetoptions"]]],[11,"adjust_abi","","Given a function ABI, turn \"System\" into the correct ABI for this target.",30,[[["self"],["abi"]],["abi"]]],[11,"min_atomic_width","","Minimum integer size in bits that this target can perform atomic operations on.",30,[[["self"]],["u64"]]],[11,"max_atomic_width","","Maximum integer size in bits that this target can perform atomic operations on.",30,[[["self"]],["u64"]]],[11,"is_abi_supported","","",30,[[["self"],["abi"]],["bool"]]],[11,"from_json","","Load a target descriptor from a JSON object.",30,[[["json"]],["targetresult"]]],[11,"search","","Search RUST_TARGET_PATH for a JSON file specifying the given target triple. Note that it could also just be a bare filename already, so also check for that. If one of the hardcoded targets we know about, just return it directly.",30,[[["targettriple"]],["result",["target","string"]]]],[11,"to_json","","",30,[[["self"]],["json"]]],[11,"eq","","",36,[[["self"],["targettriple"]],["bool"]]],[11,"ne","","",36,[[["self"],["targettriple"]],["bool"]]],[11,"clone","","",36,[[["self"]],["targettriple"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"hash","","",36,N],[11,"encode","","",36,[[["self"],["__s"]],["result"]]],[11,"decode","","",36,[[["__d"]],["result",["targettriple"]]]],[11,"from_triple","","Creates a target triple from the passed target triple string.",36,[[["str"]],["self"]]],[11,"from_path","","Creates a target triple from the passed target path.",36,[[["path"]],["result",["error"]]]],[11,"triple","","Returns a string triple for this target.",36,[[["self"]],["str"]]],[11,"debug_triple","","Returns an extended string triple for this target.",36,[[["self"]],["string"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]]],"paths":[[3,"TargetDataLayout"],[3,"Size"],[3,"Align"],[3,"Scalar"],[3,"LayoutDetails"],[3,"TyLayout"],[4,"Endian"],[4,"Integer"],[4,"FloatTy"],[4,"Primitive"],[4,"FieldPlacement"],[4,"Abi"],[4,"Variants"],[3,"ArgAttribute"],[3,"ArgAttributes"],[3,"Reg"],[3,"Uniform"],[3,"CastTarget"],[3,"ArgType"],[3,"FnType"],[4,"PassMode"],[4,"RegKind"],[4,"Conv"],[4,"ABI"],[4,"Flavor"],[4,"Class"],[3,"Memory"],[8,"HasDataLayout"],[8,"LayoutOf"],[8,"TyLayoutMethods"],[3,"Target"],[3,"TargetOptions"],[4,"LinkerFlavor"],[4,"LldFlavor"],[4,"PanicStrategy"],[4,"RelroLevel"],[4,"TargetTriple"],[3,"AbiData"],[4,"Abi"],[4,"Arch"],[8,"HasTargetSpec"]]};
searchIndex["rustc_traits"]={"doc":"New recursive solver modeled on Chalk's recursive solver. Most of the guts are broken up into modules; see the comments in those modules.","items":[[5,"provide","rustc_traits","",N,[[["providers"]]]],[0,"chalk_context","","",N,N],[3,"ChalkArenas","rustc_traits::chalk_context","",N,N],[12,"_phantom","","",0,N],[3,"ChalkContext","","",N,N],[12,"_arenas","","",1,N],[12,"_tcx","","",1,N],[3,"ChalkInferenceContext","","",N,N],[12,"infcx","","",2,N],[3,"UniverseMap","","",N,N],[3,"ConstrainedSubst","","",N,N],[12,"subst","","",3,N],[12,"constraints","","",3,N],[6,"ChalkHhGoal","","",N,N],[6,"ChalkExClause","","",N,N],[11,"clone","","",0,[[["self"]],["chalkarenas"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"clone","","",1,[[["self"]],["chalkcontext"]]],[11,"clone","","",2,[[["self"]],["chalkinferencecontext"]]],[11,"clone","","",4,[[["self"]],["universemap"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",3,[[["self"]],["constrainedsubst"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"eq","","",3,[[["self"],["constrainedsubst"]],["bool"]]],[11,"ne","","",3,[[["self"],["constrainedsubst"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"hash","","",3,N],[11,"super_fold_with","","",3,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",3,[[["self"],["v"]],["bool"]]],[11,"into_goal","","",0,[[["domaingoal"]],["goal"]]],[11,"cannot_prove","","",0,[[],["goal"]]],[11,"goal_in_environment","","",0,[[["paramenv"],["goal"]],["paramenvand",["goal"]]]],[11,"make_solution","","",1,N],[11,"is_coinductive","","True if this is a coinductive goal -- e.g., proving an auto trait.",1,[[["self"],["canonical"]],["bool"]]],[11,"instantiate_ucanonical_goal","","Create an inference table for processing a new goal and instantiate that goal in that context, returning \"all the pieces\".",1,N],[11,"instantiate_ex_clause","","",1,N],[11,"empty_constraints","","True if this solution has no region constraints.",1,[[["canonical"]],["bool"]]],[11,"inference_normalized_subst_from_ex_clause","","",1,[[["canonical"]],["canonicalvarvalues"]]],[11,"inference_normalized_subst_from_subst","","",1,[[["canonical"]],["canonicalvarvalues"]]],[11,"canonical","","",1,[[["canonical"]],["canonical"]]],[11,"is_trivial_substitution","","",1,[[["canonical"],["canonical"]],["bool"]]],[11,"num_universes","","",1,[[["canonical"]],["usize"]]],[11,"map_goal_from_canonical","","Convert a goal G from the canonical universes into our local universes. This will yield a goal G' that is the same but for the universes of universally quantified names.",1,[[["universemap"],["canonical"]],["canonical",["paramenvand"]]]],[11,"map_subst_from_canonical","","",1,[[["universemap"],["canonical"]],["canonical",["constrainedsubst"]]]],[11,"into_hh_goal","","",2,[[["self"],["goal"]],["hhgoal",["chalkarenas"]]]],[11,"add_clauses","","",2,[[["self"],["paramenv"],["vec",["programclause"]]],["paramenv"]]],[11,"resolvent_clause","","",2,[[["self"],["paramenv"],["domaingoal"],["canonicalvarvalues"],["programclause"]],["fallible",["canonical"]]]],[11,"apply_answer_subst","","",2,[[["self"],["exclause",["chalkarenas"]],["paramenvand"],["canonical"],["canonical"]],["fallible",["exclause"]]]],[11,"truncate_goal","","",2,[[["self"],["paramenvand"]],["option",["paramenvand"]]]],[11,"truncate_answer","","",2,[[["self"],["canonicalvarvalues"]],["option",["canonicalvarvalues"]]]],[11,"program_clauses","","",2,[[["self"],["paramenv"],["domaingoal"]],["vec",["programclause"]]]],[11,"instantiate_binders_universally","","",2,[[["self"],["binder"]],["goal"]]],[11,"instantiate_binders_existentially","","",2,[[["self"],["binder"]],["goal"]]],[11,"debug_ex_clause","","",2,[[["self"],["exclause"]],["box",["debug"]]]],[11,"canonicalize_goal","","",2,[[["self"],["paramenvand"]],["canonical",["paramenvand"]]]],[11,"canonicalize_ex_clause","","",2,[[["self"],["exclause"]],["canonical",["exclause"]]]],[11,"canonicalize_constrained_subst","","",2,[[["self"],["canonicalvarvalues"],["vec",["queryregionconstraint"]]],["canonical",["constrainedsubst"]]]],[11,"u_canonicalize_goal","","",2,N],[11,"invert_goal","","",2,[[["self"],["paramenvand"]],["option",["paramenvand"]]]],[11,"unify_parameters","","",2,[[["self"],["paramenv"],["kind"],["kind"]],["chalkenginefallible",["inferok"]]]],[11,"sink_answer_subset","","",2,[[["self"],["canonical"]],["canonical",["constrainedsubst"]]]],[11,"lift_delayed_literal","","",2,[[["self"],["delayedliteral",["chalkarenas"]]],["delayedliteral",["chalkarenas"]]]],[11,"into_ex_clause","","",2,[[["self"],["inferok"],["exclause"]]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"lift_ex_clause_to_tcx","","",0,[[["exclause"],["tyctxt"]],["option"]]],[11,"fold_ex_clause_with","","",0,[[["exclause"],["f"]],["exclause",["chalkarenas"]]]],[11,"visit_ex_clause_with","","",0,[[["exclause"],["v"]],["bool"]]],[11,"lift_to_tcx","","",3,[[["self"],["tyctxt"]],["option",["constrainedsubst"]]]],[0,"dropck_outlives","rustc_traits","",N,N],[5,"provide","rustc_traits::dropck_outlives","",N,[[["providers"]]]],[5,"dropck_outlives","","",N,[[["tyctxt"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[5,"dtorck_constraint_for_ty","","Return a set of constraints that needs to be satisfied in order for `ty` to be valid for destruction.",N,[[["tyctxt"],["span"],["ty"],["usize"],["ty"]],["result",["dtorckconstraint","nosolution"]]]],[5,"adt_dtorck_constraint","","Calculates the dtorck constraint for a type.",N,[[["tyctxt"],["defid"]],["result",["dtorckconstraint","nosolution"]]]],[5,"dedup_dtorck_constraint","","",N,[[["dtorckconstraint"]]]],[0,"evaluate_obligation","rustc_traits","",N,N],[5,"provide","rustc_traits::evaluate_obligation","",N,[[["providers"]]]],[5,"evaluate_obligation","","",N,[[["tyctxt"],["canonicalpredicategoal"]],["result",["evaluationresult","overflowerror"]]]],[0,"implied_outlives_bounds","rustc_traits","Provider for the `implied_outlives_bounds` query. Do not call this query directory. See [`rustc::traits::query::implied_outlives_bounds`].",N,N],[5,"provide","rustc_traits::implied_outlives_bounds","",N,[[["providers"]]]],[5,"implied_outlives_bounds","","",N,[[["tyctxt"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[5,"compute_implied_outlives_bounds","","",N,[[["inferctxt"],["paramenv"],["ty"]],["fallible",["vec"]]]],[5,"implied_bounds_from_components","","When we have an implied bound that `T: 'a`, we can further break this down to determine what relationships would have to hold for `T: 'a` to hold. We get to assume that the caller has validated those relationships.",N,[[["region"],["vec",["component"]]],["vec",["outlivesbound"]]]],[0,"normalize_projection_ty","rustc_traits","",N,N],[5,"provide","rustc_traits::normalize_projection_ty","",N,[[["providers"]]]],[5,"normalize_projection_ty","","",N,[[["tyctxt"],["canonicalprojectiongoal"]],["result",["lrc","nosolution"]]]],[0,"normalize_erasing_regions","rustc_traits","",N,N],[5,"provide","rustc_traits::normalize_erasing_regions","",N,[[["providers"]]]],[5,"normalize_ty_after_erasing_regions","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["ty"]]],[5,"not_outlives_predicate","","",N,[[["predicate"]],["bool"]]],[0,"lowering","rustc_traits","",N,N],[3,"ClauseDumper","rustc_traits::lowering","",N,N],[12,"tcx","","",5,N],[5,"provide","","",N,[[["providers"]]]],[5,"program_clauses_for","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_env","","",N,[[["tyctxt"],["paramenv"]],["clauses"]]],[5,"program_clauses_for_trait","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_impl","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_type_def","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_associated_type_def","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_associated_type_value","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"dump_program_clauses","","",N,[[["tyctxt"]]]],[8,"Lower","","",N,N],[10,"lower","","Lower a rustc construct (e.g. `ty::TraitPredicate`) to a chalk-like type.",6,[[["self"]],["t"]]],[8,"IntoFromEnvGoal","","Used for implied bounds related rules (see rustc guide).",N,N],[10,"into_from_env_goal","","Transforms an existing goal into a `FromEnv` goal.",7,[[["self"]],["self"]]],[8,"IntoWellFormedGoal","","Used for well-formedness related rules (see rustc guide).",N,N],[10,"into_well_formed_goal","","Transforms an existing goal into a `WellFormed` goal.",8,[[["self"]],["self"]]],[11,"process_attrs","","",5,N],[11,"nested_visit_map","","",5,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",5,[[["self"],["item"]]]],[11,"visit_trait_item","","",5,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",5,[[["self"],["implitem"]]]],[11,"visit_struct_field","","",5,[[["self"],["structfield"]]]],[0,"type_op","rustc_traits","",N,N],[5,"provide","rustc_traits::type_op","",N,[[["providers"]]]],[5,"type_op_eq","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_normalize","","",N,[[["inferctxt"],["fulfillmentcontext"],["paramenvand",["normalize"]]],["fallible"]]],[5,"type_op_normalize_ty","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_normalize_predicate","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_normalize_fn_sig","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_normalize_poly_fn_sig","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_subtype","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_prove_predicate","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]]],"paths":[[3,"ChalkArenas"],[3,"ChalkContext"],[3,"ChalkInferenceContext"],[3,"ConstrainedSubst"],[3,"UniverseMap"],[3,"ClauseDumper"],[8,"Lower"],[8,"IntoFromEnvGoal"],[8,"IntoWellFormedGoal"]]};
searchIndex["rustc_typeck"]={"doc":"typeck.rs, an introduction","items":[[3,"TypeAndSubsts","rustc_typeck","",N,N],[12,"substs","","",0,N],[12,"ty","","",0,N],[5,"require_c_abi_if_variadic","","",N,[[["tyctxt"],["fndecl"],["abi"],["span"]]]],[5,"require_same_types","","",N,[[["tyctxt"],["obligationcause"],["ty"],["ty"]],["bool"]]],[5,"check_main_fn_ty","","",N,[[["tyctxt"],["nodeid"],["span"]]]],[5,"check_start_fn_ty","","",N,[[["tyctxt"],["nodeid"],["span"]]]],[5,"check_for_entry_fn","","",N,[[["tyctxt"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"check_crate","","",N,[[["tyctxt"]],["result",["compileincomplete"]]]],[5,"hir_ty_to_ty","","A quasi-deprecated helper used in rustdoc and save-analysis to get the type from a HIR node.",N,[[["tyctxt"],["ty"]],["ty"]]],[5,"hir_trait_to_predicates","","",N,N],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0023","rustc_typeck::diagnostics","",N,N],[0,"__register_diagnostic_E0025","","",N,N],[0,"__register_diagnostic_E0026","","",N,N],[0,"__register_diagnostic_E0027","","",N,N],[0,"__register_diagnostic_E0029","","",N,N],[0,"__register_diagnostic_E0033","","",N,N],[0,"__register_diagnostic_E0034","","",N,N],[0,"__register_diagnostic_E0040","","",N,N],[0,"__register_diagnostic_E0044","","",N,N],[0,"__register_diagnostic_E0045","","",N,N],[0,"__register_diagnostic_E0046","","",N,N],[0,"__register_diagnostic_E0049","","",N,N],[0,"__register_diagnostic_E0050","","",N,N],[0,"__register_diagnostic_E0053","","",N,N],[0,"__register_diagnostic_E0054","","",N,N],[0,"__register_diagnostic_E0055","","",N,N],[0,"__register_diagnostic_E0057","","",N,N],[0,"__register_diagnostic_E0059","","",N,N],[0,"__register_diagnostic_E0060","","",N,N],[0,"__register_diagnostic_E0061","","",N,N],[0,"__register_diagnostic_E0062","","",N,N],[0,"__register_diagnostic_E0063","","",N,N],[0,"__register_diagnostic_E0067","","",N,N],[0,"__register_diagnostic_E0069","","",N,N],[0,"__register_diagnostic_E0070","","",N,N],[0,"__register_diagnostic_E0071","","",N,N],[0,"__register_diagnostic_E0073","","",N,N],[0,"__register_diagnostic_E0074","","",N,N],[0,"__register_diagnostic_E0075","","",N,N],[0,"__register_diagnostic_E0076","","",N,N],[0,"__register_diagnostic_E0077","","",N,N],[0,"__register_diagnostic_E0081","","",N,N],[0,"__register_diagnostic_E0084","","",N,N],[0,"__register_diagnostic_E0087","","",N,N],[0,"__register_diagnostic_E0088","","",N,N],[0,"__register_diagnostic_E0089","","",N,N],[0,"__register_diagnostic_E0090","","",N,N],[0,"__register_diagnostic_E0091","","",N,N],[0,"__register_diagnostic_E0092","","",N,N],[0,"__register_diagnostic_E0093","","",N,N],[0,"__register_diagnostic_E0094","","",N,N],[0,"__register_diagnostic_E0107","","",N,N],[0,"__register_diagnostic_E0109","","",N,N],[0,"__register_diagnostic_E0110","","",N,N],[0,"__register_diagnostic_E0116","","",N,N],[0,"__register_diagnostic_E0117","","",N,N],[0,"__register_diagnostic_E0118","","",N,N],[0,"__register_diagnostic_E0120","","",N,N],[0,"__register_diagnostic_E0121","","",N,N],[0,"__register_diagnostic_E0124","","",N,N],[0,"__register_diagnostic_E0131","","",N,N],[0,"__register_diagnostic_E0132","","",N,N],[0,"__register_diagnostic_E0164","","",N,N],[0,"__register_diagnostic_E0184","","",N,N],[0,"__register_diagnostic_E0185","","",N,N],[0,"__register_diagnostic_E0186","","",N,N],[0,"__register_diagnostic_E0191","","",N,N],[0,"__register_diagnostic_E0192","","",N,N],[0,"__register_diagnostic_E0193","","",N,N],[0,"__register_diagnostic_E0194","","",N,N],[0,"__register_diagnostic_E0195","","",N,N],[0,"__register_diagnostic_E0199","","",N,N],[0,"__register_diagnostic_E0200","","",N,N],[0,"__register_diagnostic_E0201","","",N,N],[0,"__register_diagnostic_E0202","","",N,N],[0,"__register_diagnostic_E0204","","",N,N],[0,"__register_diagnostic_E0206","","",N,N],[0,"__register_diagnostic_E0207","","",N,N],[0,"__register_diagnostic_E0210","","",N,N],[0,"__register_diagnostic_E0220","","",N,N],[0,"__register_diagnostic_E0221","","",N,N],[0,"__register_diagnostic_E0223","","",N,N],[0,"__register_diagnostic_E0225","","",N,N],[0,"__register_diagnostic_E0229","","",N,N],[0,"__register_diagnostic_E0243","","",N,N],[0,"__register_diagnostic_E0244","","",N,N],[0,"__register_diagnostic_E0321","","",N,N],[0,"__register_diagnostic_E0322","","",N,N],[0,"__register_diagnostic_E0323","","",N,N],[0,"__register_diagnostic_E0324","","",N,N],[0,"__register_diagnostic_E0325","","",N,N],[0,"__register_diagnostic_E0326","","",N,N],[0,"__register_diagnostic_E0328","","",N,N],[0,"__register_diagnostic_E0366","","",N,N],[0,"__register_diagnostic_E0367","","",N,N],[0,"__register_diagnostic_E0368","","",N,N],[0,"__register_diagnostic_E0369","","",N,N],[0,"__register_diagnostic_E0370","","",N,N],[0,"__register_diagnostic_E0371","","",N,N],[0,"__register_diagnostic_E0374","","",N,N],[0,"__register_diagnostic_E0375","","",N,N],[0,"__register_diagnostic_E0376","","",N,N],[0,"__register_diagnostic_E0390","","",N,N],[0,"__register_diagnostic_E0392","","",N,N],[0,"__register_diagnostic_E0393","","",N,N],[0,"__register_diagnostic_E0399","","",N,N],[0,"__register_diagnostic_E0436","","",N,N],[0,"__register_diagnostic_E0439","","",N,N],[0,"__register_diagnostic_E0440","","",N,N],[0,"__register_diagnostic_E0441","","",N,N],[0,"__register_diagnostic_E0442","","",N,N],[0,"__register_diagnostic_E0443","","",N,N],[0,"__register_diagnostic_E0444","","",N,N],[0,"__register_diagnostic_E0516","","",N,N],[0,"__register_diagnostic_E0520","","",N,N],[0,"__register_diagnostic_E0527","","",N,N],[0,"__register_diagnostic_E0528","","",N,N],[0,"__register_diagnostic_E0529","","",N,N],[0,"__register_diagnostic_E0534","","",N,N],[0,"__register_diagnostic_E0535","","",N,N],[0,"__register_diagnostic_E0558","","",N,N],[0,"__register_diagnostic_E0559","","",N,N],[0,"__register_diagnostic_E0560","","",N,N],[0,"__register_diagnostic_E0569","","",N,N],[0,"__register_diagnostic_E0570","","",N,N],[0,"__register_diagnostic_E0572","","",N,N],[0,"__register_diagnostic_E0581","","",N,N],[0,"__register_diagnostic_E0582","","",N,N],[0,"__register_diagnostic_E0599","","",N,N],[0,"__register_diagnostic_E0600","","",N,N],[0,"__register_diagnostic_E0608","","",N,N],[0,"__register_diagnostic_E0604","","",N,N],[0,"__register_diagnostic_E0605","","",N,N],[0,"__register_diagnostic_E0606","","",N,N],[0,"__register_diagnostic_E0607","","",N,N],[0,"__register_diagnostic_E0609","","",N,N],[0,"__register_diagnostic_E0610","","",N,N],[0,"__register_diagnostic_E0614","","",N,N],[0,"__register_diagnostic_E0615","","",N,N],[0,"__register_diagnostic_E0616","","",N,N],[0,"__register_diagnostic_E0617","","",N,N],[0,"__register_diagnostic_E0618","","",N,N],[0,"__register_diagnostic_E0619","","",N,N],[0,"__register_diagnostic_E0620","","",N,N],[0,"__register_diagnostic_E0622","","",N,N],[0,"__register_diagnostic_E0624","","",N,N],[0,"__register_diagnostic_E0638","","",N,N],[0,"__register_diagnostic_E0639","","",N,N],[0,"__register_diagnostic_E0643","","",N,N],[0,"__register_diagnostic_E0646","","",N,N],[0,"__register_diagnostic_E0647","","",N,N],[0,"__register_diagnostic_E0648","","",N,N],[0,"__register_diagnostic_E0689","","",N,N],[0,"__register_diagnostic_E0690","","",N,N],[0,"__register_diagnostic_E0691","","",N,N],[0,"__register_diagnostic_E0699","","",N,N],[0,"__register_diagnostic_E0183","","",N,N],[0,"__register_diagnostic_E0203","","",N,N],[0,"__register_diagnostic_E0208","","",N,N],[0,"__register_diagnostic_E0212","","",N,N],[0,"__register_diagnostic_E0224","","",N,N],[0,"__register_diagnostic_E0227","","",N,N],[0,"__register_diagnostic_E0228","","",N,N],[0,"__register_diagnostic_E0307","","",N,N],[0,"__register_diagnostic_E0377","","",N,N],[0,"__register_diagnostic_E0533","","",N,N],[0,"__register_diagnostic_E0564","","",N,N],[0,"__register_diagnostic_E0587","","",N,N],[0,"__register_diagnostic_E0588","","",N,N],[0,"__register_diagnostic_E0592","","",N,N],[0,"__register_diagnostic_E0627","","",N,N],[0,"__register_diagnostic_E0632","","",N,N],[0,"__register_diagnostic_E0634","","",N,N],[0,"__register_diagnostic_E0640","","",N,N],[0,"__register_diagnostic_E0641","","",N,N],[0,"__register_diagnostic_E0645","","",N,N],[0,"__register_diagnostic_E0698","","",N,N],[0,"astconv","rustc_typeck","Conversion from AST representation of types to the ty.rs representation.  The main routine here is `ast_ty_to_ty()`: each use is parameterized by an instance of `AstConv`.",N,N],[3,"ConvertedBinding","rustc_typeck::astconv","",N,N],[12,"item_name","","",1,N],[12,"ty","","",1,N],[12,"span","","",1,N],[3,"ParamRange","","",N,N],[12,"required","","",2,N],[12,"accepted","","",2,N],[3,"Bounds","","",N,N],[12,"region_bounds","","",3,N],[12,"implicitly_sized","","",3,N],[12,"trait_bounds","","",3,N],[12,"projection_bounds","","",3,N],[5,"split_auto_traits","","Divides a list of general trait bounds into two groups: auto traits (e.g. Sync and Send) and the remaining general trait bounds.",N,N],[5,"check_type_argument_count","","",N,[[["tyctxt"],["span"],["usize"],["paramrange"]]]],[5,"report_lifetime_number_error","","",N,[[["tyctxt"],["span"],["usize"],["usize"]]]],[17,"TRAIT_OBJECT_DUMMY_SELF","","Dummy type used for the `Self` of a `TraitRef` created for converting a trait object, and which gets removed in `ExistentialTraitRef`. This type must not appear anywhere in other converted types.",N,N],[8,"AstConv","","",N,N],[10,"tcx","","",4,[[["self"]],["tyctxt"]]],[10,"get_type_parameter_bounds","","Returns the set of bounds in scope for the type parameter with the given id.",4,[[["self"],["span"],["defid"]],["genericpredicates"]]],[10,"re_infer","","What lifetime should we use when a lifetime is omitted (and not elided)?",4,[[["self"],["span"],["option",["genericparamdef"]]],["option",["region"]]]],[10,"ty_infer","","What type should we use when a type is omitted?",4,[[["self"],["span"]],["ty"]]],[11,"ty_infer_for_def","","Same as ty_infer, but with a known type parameter definition.",4,[[["self"],["genericparamdef"],["span"]],["ty"]]],[10,"projected_ty_from_poly_trait_ref","","Projecting an associated type from a (potentially) higher-ranked trait reference is more complicated, because of the possibility of late-bound regions appearing in the associated type binding. This is not legal in function signatures for that reason. In a function body, we can always handle it because we can use inference variables to remove the late-bound regions.",4,[[["self"],["span"],["defid"],["polytraitref"]],["ty"]]],[10,"normalize_ty","","Normalize an associated type coming from the user.",4,[[["self"],["span"],["ty"]],["ty"]]],[10,"set_tainted_by_errors","","Invoked when we encounter an error from some prior pass (e.g. resolve) that is translated into a ty-error. This is used to help suppress derived errors typeck might otherwise report.",4,[[["self"]]]],[10,"record_ty","","",4,[[["self"],["hirid"],["ty"],["span"]]]],[11,"ast_region_to_region","","",4,[[["self"],["lifetime"],["option",["genericparamdef"]]],["region"]]],[11,"ast_path_substs_for_ty","","Given a path `path` that refers to an item `I` with the declared generics `decl_generics`, returns an appropriate set of substitutions for this particular reference to `I`.",4,[[["self"],["span"],["defid"],["pathsegment"]],["substs"]]],[11,"create_substs_for_ast_path","","Given the type/region arguments provided to some path (along with an implicit Self, if this is a trait reference) returns the complete set of substitutions. This may involve applying defaulted type parameters.",4,N],[11,"instantiate_mono_trait_ref","","Instantiates the path for the given trait reference, assuming that it's bound to a valid trait type. Returns the def_id for the defining trait. The type cannot be a type other than a trait type.",4,[[["self"],["traitref"],["ty"]],["traitref"]]],[11,"trait_def_id","","Get the DefId of the given trait ref. It must actually be a trait.",4,[[["self"],["traitref"]],["defid"]]],[11,"instantiate_poly_trait_ref_inner","","The given `trait_ref` must actually be trait.",4,[[["self"],["traitref"],["ty"],["vec"],["bool"]],["polytraitref"]]],[11,"instantiate_poly_trait_ref","","",4,[[["self"],["polytraitref"],["ty"],["vec"]],["polytraitref"]]],[11,"ast_path_to_mono_trait_ref","","",4,[[["self"],["span"],["defid"],["ty"],["pathsegment"]],["traitref"]]],[11,"create_substs_for_ast_trait_ref","","",4,N],[11,"trait_defines_associated_type_named","","",4,[[["self"],["defid"],["ident"]],["bool"]]],[11,"ast_type_binding_to_poly_projection_predicate","","",4,[[["self"],["nodeid"],["polytraitref"],["convertedbinding"],["bool"],["fxhashmap"]],["result",["polyprojectionpredicate","errorreported"]]]],[11,"ast_path_to_ty","","",4,[[["self"],["span"],["defid"],["pathsegment"]],["ty"]]],[11,"trait_ref_to_existential","","Transform a PolyTraitRef into a PolyExistentialTraitRef by removing the dummy Self type (TRAIT_OBJECT_DUMMY_SELF).",4,[[["self"],["traitref"]],["existentialtraitref"]]],[11,"conv_object_ty_poly_trait_ref","","",4,N],[11,"report_ambiguous_associated_type","","",4,[[["self"],["span"],["str"],["str"],["str"]]]],[11,"find_bound_for_assoc_item","","",4,[[["self"],["defid"],["ident"],["span"]],["result",["polytraitref","errorreported"]]]],[11,"one_bound_for_assoc_type","","",4,[[["self"],["i"],["str"],["ident"],["span"]],["result",["polytraitref","errorreported"]]]],[11,"associated_path_def_to_ty","","",4,N],[11,"qpath_to_ty","","",4,[[["self"],["span"],["option",["ty"]],["defid"],["pathsegment"],["pathsegment"]],["ty"]]],[11,"prohibit_generics","","",4,N],[11,"prohibit_projection","","",4,[[["self"],["span"]]]],[11,"def_to_ty","","",4,[[["self"],["option",["ty"]],["path"],["bool"]],["ty"]]],[11,"ast_ty_to_ty","","Parses the programmer's textual representation of a type into our internal notion of a type.",4,[[["self"],["ty"]],["ty"]]],[11,"impl_trait_ty_to_ty","","",4,N],[11,"ty_of_arg","","",4,[[["self"],["ty"],["option",["ty"]]],["ty"]]],[11,"ty_of_fn","","",4,[[["self"],["unsafety"],["abi"],["fndecl"]],["polyfnsig"]]],[11,"compute_object_lifetime_bound","","Given the bounds on an object, determines what single region bound (if any) we can use to summarize this type. The basic idea is that we will use the bound the user provided, if they provided one, and otherwise search the supertypes of trait bounds for region bounds. It may be that we can derive no bound at all, in which case we return `None`.",4,[[["self"],["span"],["binder",["slice"]]],["option",["region"]]]],[11,"eq","","",3,[[["self"],["bounds"]],["bool"]]],[11,"ne","","",3,[[["self"],["bounds"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"clone","","",3,[[["self"]],["bounds"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"predicates","","",3,[[["self"],["tyctxt"],["ty"]],["vec",["predicate"]]]],[0,"check","rustc_typeck","",N,N],[3,"MaybeInProgressTables","rustc_typeck::check","A wrapper for InferCtxt's `in_progress_tables` field.",N,N],[12,"maybe_tables","","",5,N],[3,"Inherited","","closures defined within the function.  For example:",N,N],[12,"infcx","","",6,N],[12,"tables","","",6,N],[12,"locals","","",6,N],[12,"fulfillment_cx","","",6,N],[12,"deferred_call_resolutions","","",6,N],[12,"deferred_cast_checks","","",6,N],[12,"deferred_generator_interiors","","",6,N],[12,"anon_types","","",6,N],[12,"implicit_region_bound","","Each type parameter has an implicit region bound that indicates it must outlive at least the function body (the user may specify stronger requirements). This field indicates the region of the callee. If it is `None`, then the parameter environment is for an item or something where the \"callee\" is not clear.",6,N],[12,"body_id","","",6,N],[3,"UnsafetyState","","",N,N],[12,"def","","",7,N],[12,"unsafety","","",7,N],[12,"unsafe_push_count","","",7,N],[12,"from_fn","","",7,N],[3,"BreakableCtxt","","",N,N],[12,"may_break","","",8,N],[12,"coerce","","",8,N],[3,"EnclosingBreakables","","",N,N],[12,"stack","","",9,N],[12,"by_id","","",9,N],[3,"FnCtxt","","",N,N],[12,"body_id","","",10,N],[12,"param_env","","The parameter environment used for proving trait obligations in this function. This can change when we descend into closures (as they bring new things into scope), hence it is not part of `Inherited` (as of the time of this writing, closures do not yet change the environment, but they will eventually).",10,N],[12,"err_count_on_creation","","",10,N],[12,"ret_coercion","","",10,N],[12,"yield_ty","","",10,N],[12,"ps","","",10,N],[12,"diverges","","Whether the last checked node generates a divergence (e.g., `return` will set this to Always). In general, when entering an expression or other node in the tree, the initial value indicates whether prior parts of the containing expression may have diverged. It is then typically set to `Maybe` (and the old value remembered) for processing the subparts of the current expression. As each subpart is processed, they may set the flag to `Always` etc.  Finally, at the end, we take the result and \"union\" it with the original value, so that when we return the flag indicates if any subpart of the the parent expression (up to and including this part) has diverged.  So, if you read it after evaluating a subexpression `X`, the value you get indicates whether any subexpression that was evaluating up to and including `X` diverged.",10,N],[12,"has_errors","","Whether any child nodes have any type errors.",10,N],[12,"enclosing_breakables","","",10,N],[12,"inh","","",10,N],[3,"InheritedBuilder","","Helper type of a temporary returned by Inherited::build(...). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(Inherited<'b, 'gcx, 'tcx>).",N,N],[12,"infcx","","",11,N],[12,"def_id","","",11,N],[3,"CheckItemTypesVisitor","","",N,N],[12,"tcx","","",12,N],[3,"GatherLocalsVisitor","","",N,N],[12,"fcx","","",13,N],[3,"GeneratorTypes","","When `check_fn` is invoked on a generator (i.e., a body that includes yield), it returns back some information about the yield points.",N,N],[12,"yield_ty","","Type of value that is yielded.",14,N],[12,"interior","","Types that are captured (see `GeneratorInterior` for more).",14,N],[12,"movability","","Indicates if the generator is movable or static (immovable)",14,N],[4,"Expectation","","When type-checking an expression, we propagate downward whatever type hint we are able in the form of an `Expectation`.",N,N],[13,"NoExpectation","","We know nothing about what type this expression should have.",15,N],[13,"ExpectIfCondition","","This expression is an `if` condition, it must resolve to `bool`.",15,N],[13,"ExpectHasType","","This expression should have the type given (or some subtype)",15,N],[13,"ExpectCastableToType","","This expression will be cast to the `Ty`",15,N],[13,"ExpectRvalueLikeUnsized","","This rvalue expression will be wrapped in `&` or `Box` and coerced to `&Ty` or `Box<Ty>`, respectively. `Ty` is `[A]` or `Trait`.",15,N],[4,"Needs","","",N,N],[13,"MutPlace","","",16,N],[13,"None","","",16,N],[4,"PlaceOp","","",N,N],[13,"Deref","","",17,N],[13,"Index","","",17,N],[4,"Diverges","","Tracks whether executing a node may exit normally (versus return/break/panic, which \"diverge\", leaving dead code in their wake). Tracked semi-automatically (through type variables marked as diverging), with some manual adjustments for control-flow primitives (approximating a CFG).",N,N],[13,"Maybe","","Potentially unknown, some cases converge, others require a CFG to determine them.",18,N],[13,"Always","","Definitely known to diverge and therefore not reach the next sibling or its parent.",18,N],[13,"WarnedAlways","","Same as `Always` but with a reachability warning already emitted",18,N],[4,"TupleArgumentsFlag","","Controls whether the arguments are tupled. This is used for the call operator.",N,N],[13,"DontTupleArguments","","",19,N],[13,"TupleArguments","","",19,N],[5,"check_wf_new","","",N,[[["tyctxt"]],["result",["errorreported"]]]],[5,"check_item_types","","",N,[[["tyctxt"]],["result",["errorreported"]]]],[5,"check_item_bodies","","",N,[[["tyctxt"]],["result",["compileincomplete"]]]],[5,"typeck_item_bodies","","",N,[[["tyctxt"],["cratenum"]],["result",["compileincomplete"]]]],[5,"check_item_well_formed","","",N,[[["tyctxt"],["defid"]]]],[5,"check_trait_item_well_formed","","",N,[[["tyctxt"],["defid"]]]],[5,"check_impl_item_well_formed","","",N,[[["tyctxt"],["defid"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"adt_destructor","","",N,[[["tyctxt"],["defid"]],["option",["destructor"]]]],[5,"primary_body_of","","If this def-id is a \"primary tables entry\", returns `Some((body_id, decl))` with information about it's body-id and fn-decl (if any). Otherwise, returns `None`.",N,[[["tyctxt"],["nodeid"]],["option"]]],[5,"has_typeck_tables","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"used_trait_imports","","",N,[[["tyctxt"],["defid"]],["lrc",["defidset"]]]],[5,"typeck_tables_of","","",N,[[["tyctxt"],["defid"]],["typecktables"]]],[5,"check_abi","","",N,[[["tyctxt"],["span"],["abi"]]]],[5,"check_fn","","Helper used for fns and closures. Does the grungy work of checking a function body and returns the function context used for that purpose, since in the case of a fn item there is still a bit more to do.",N,N],[5,"check_struct","","",N,[[["tyctxt"],["nodeid"],["span"]]]],[5,"check_union","","",N,[[["tyctxt"],["nodeid"],["span"]]]],[5,"check_item_type","","",N,[[["tyctxt"],["item"]]]],[5,"maybe_check_static_with_link_section","","",N,[[["tyctxt"],["defid"],["span"]]]],[5,"check_on_unimplemented","","",N,[[["tyctxt"],["defid"],["item"]]]],[5,"report_forbidden_specialization","","",N,[[["tyctxt"],["implitem"],["defid"]]]],[5,"check_specialization_validity","","",N,[[["tyctxt"],["traitdef"],["associateditem"],["defid"],["implitem"]]]],[5,"check_impl_items_against_trait","","",N,N],[5,"check_representable","","Checks whether a type can be represented in memory. In particular, it identifies types that contain themselves without indirection through a pointer, which would mean their size is unbounded.",N,[[["tyctxt"],["span"],["defid"]],["bool"]]],[5,"check_simd","","",N,[[["tyctxt"],["span"],["defid"]]]],[5,"check_packed","","",N,[[["tyctxt"],["span"],["defid"]]]],[5,"check_packed_inner","","",N,[[["tyctxt"],["defid"],["vec"]],["bool"]]],[5,"check_transparent","","",N,[[["tyctxt"],["span"],["defid"]]]],[5,"check_enum","","",N,N],[5,"check_bounds_are_used","","",N,[[["tyctxt"],["generics"],["ty"]]]],[5,"fatally_break_rust","","",N,[[["session"]]]],[0,"autoderef","","",N,N],[3,"Autoderef","rustc_typeck::check::autoderef","",N,N],[12,"fcx","","",20,N],[12,"steps","","",20,N],[12,"cur_ty","","",20,N],[12,"obligations","","",20,N],[12,"at_start","","",20,N],[12,"include_raw_pointers","","",20,N],[12,"span","","",20,N],[4,"AutoderefKind","","",N,N],[13,"Builtin","","",21,N],[13,"Overloaded","","",21,N],[11,"clone","","",21,[[["self"]],["autoderefkind"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"next","","",20,[[["self"]],["option"]]],[11,"overloaded_deref_ty","","",20,[[["self"],["ty"]],["option",["ty"]]]],[11,"unambiguous_final_ty","","Returns the final type, generating an error if it is an unresolved inference variable.",20,[[["self"]],["ty"]]],[11,"maybe_ambiguous_final_ty","","Returns the final type we ended up with, which may well be an inference variable (we will resolve it first, if possible).",20,[[["self"]],["ty"]]],[11,"step_count","","",20,[[["self"]],["usize"]]],[11,"adjust_steps","","Returns the adjustment steps.",20,[[["self"],["needs"]],["vec",["adjustment"]]]],[11,"adjust_steps_as_infer_ok","","",20,[[["self"],["needs"]],["inferok",["vec"]]]],[11,"include_raw_pointers","","also dereference through raw pointer types e.g. assuming ptr_to_Foo is the type `*const Foo` fcx.autoderef(span, ptr_to_Foo)  => [*const Foo] fcx.autoderef(span, ptr_to_Foo).include_raw_ptrs() => [*const Foo, Foo]",20,[[["self"]],["self"]]],[11,"finalize","","",20,[[["self"]]]],[11,"into_obligations","","",20,[[["self"]],["vec",["predicateobligation"]]]],[11,"autoderef","rustc_typeck::check","",10,[[["self"],["span"],["ty"]],["autoderef"]]],[11,"try_overloaded_deref","","",10,[[["self"],["span"],["ty"],["needs"]],["option",["inferok"]]]],[0,"dropck","","",N,N],[5,"check_drop_impl","rustc_typeck::check::dropck","check_drop_impl confirms that the Drop implementation identified by `drop_impl_did` is not any more specialized than the type it is attached to (Issue #8142).",N,[[["tyctxt"],["defid"]],["result",["errorreported"]]]],[5,"ensure_drop_params_and_item_params_correspond","","",N,[[["tyctxt"],["defid"],["ty"],["defid"]],["result",["errorreported"]]]],[5,"ensure_drop_predicates_are_implied_by_item_defn","","Confirms that every predicate imposed by dtor_predicates is implied by assuming the predicates attached to self_type_did.",N,[[["tyctxt"],["defid"],["genericpredicates"],["defid"],["substs"]],["result",["errorreported"]]]],[5,"check_safety_of_destructor_if_necessary","","check_safety_of_destructor_if_necessary confirms that the type expression `typ` conforms to the \"Drop Check Rule\" from the Sound Generic Drop (RFC 769).",N,[[["regionctxt"],["ty"],["span"],["nodeid"],["scope"]],["result",["errorreported"]]]],[0,"_match","rustc_typeck::check","",N,N],[11,"check_pat_walk","","The `is_arg` argument indicates whether this pattern is the outermost pattern in an argument (e.g., in `fn foo(&x: &u32)`, it is true for the `&x` pattern but not `x`). This is used to tailor error reporting.",10,[[["self"],["pat"],["ty"],["bindingmode"],["bool"]]]],[11,"check_dereferencable","","",10,[[["self"],["span"],["ty"],["pat"]],["bool"]]],[11,"check_match","","",10,N],[11,"check_pat_struct","","",10,N],[11,"check_pat_path","","",10,[[["self"],["pat"],["qpath"],["ty"]],["ty"]]],[11,"check_pat_tuple_struct","","",10,N],[11,"check_struct_pat_fields","","",10,N],[0,"writeback","","",N,N],[3,"WritebackCx","rustc_typeck::check::writeback","",N,N],[12,"fcx","","",22,N],[12,"tables","","",22,N],[12,"body","","",22,N],[3,"Resolver","","",N,N],[12,"tcx","","",23,N],[12,"infcx","","",23,N],[12,"span","","",23,N],[12,"body","","",23,N],[8,"Locatable","","",N,N],[10,"to_span","","",24,[[["self"],["tyctxt"]],["span"]]],[11,"resolve_type_vars_in_body","rustc_typeck::check","",10,[[["self"],["body"]],["typecktables"]]],[11,"new","rustc_typeck::check::writeback","",22,[[["fnctxt"],["body"]],["writebackcx"]]],[11,"tcx","","",22,[[["self"]],["tyctxt"]]],[11,"write_ty_to_tables","","",22,[[["self"],["hirid"],["ty"]]]],[11,"fix_scalar_builtin_expr","","",22,[[["self"],["expr"]]]],[11,"fix_index_builtin_expr","","",22,[[["self"],["expr"]]]],[11,"nested_visit_map","","",22,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",22,[[["self"],["expr"]]]],[11,"visit_block","","",22,[[["self"],["block"]]]],[11,"visit_pat","","",22,[[["self"],["pat"]]]],[11,"visit_local","","",22,[[["self"],["local"]]]],[11,"visit_ty","","",22,[[["self"],["ty"]]]],[11,"visit_upvar_borrow_map","","",22,[[["self"]]]],[11,"visit_closures","","",22,[[["self"]]]],[11,"visit_cast_types","","",22,[[["self"]]]],[11,"visit_free_region_map","","",22,[[["self"]]]],[11,"visit_user_provided_tys","","",22,[[["self"]]]],[11,"visit_anon_types","","",22,[[["self"],["span"]]]],[11,"visit_field_id","","",22,[[["self"],["nodeid"]]]],[11,"visit_node_id","","",22,[[["self"],["span"],["hirid"]]]],[11,"visit_adjustments","","",22,[[["self"],["span"],["hirid"]]]],[11,"visit_pat_adjustments","","",22,[[["self"],["span"],["hirid"]]]],[11,"visit_liberated_fn_sigs","","",22,[[["self"]]]],[11,"visit_fru_field_types","","",22,[[["self"]]]],[11,"resolve","","",22,N],[11,"new","","",23,[[["fnctxt"],["locatable"],["body"]],["resolver"]]],[11,"report_error","","",23,[[["self"],["ty"]]]],[11,"tcx","","",23,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",23,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",23,[[["self"],["region"]],["region"]]],[0,"regionck","rustc_typeck::check","The region check is a final pass that runs over the AST after we have inferred the type constraints but before we have actually finalized the types.  Its purpose is to embed a variety of region constraints. Inserting these constraints as a separate pass is good because (1) it localizes the code that has to do with region inference and (2) often we cannot know what constraints are needed until the basic types have been inferred.",N,N],[3,"RegionCtxt","rustc_typeck::check::regionck","",N,N],[12,"fcx","","",25,N],[12,"region_scope_tree","","",25,N],[12,"outlives_environment","","",25,N],[12,"body_id","","",25,N],[12,"call_site_scope","","",25,N],[12,"repeating_scope","","",25,N],[12,"subject_def_id","","",25,N],[3,"RepeatingScope","","",N,N],[12,"0","","",26,N],[3,"Subject","","",N,N],[12,"0","","",27,N],[11,"regionck_expr","rustc_typeck::check","",10,[[["self"],["body"]]]],[11,"regionck_item","","Region checking during the WF phase for items. `wf_tys` are the types from which we should derive implied bounds, if any.",10,N],[11,"regionck_fn","","Region check a function body. Not invoked on closures, but only on the \"root\" fn item (in which closures may be embedded). Walks the function body and adds various add'l constraints that are needed for region inference. This is separated both to isolate \"pure\" region constraints from the rest of type check and because sometimes we need type inference to have completed before we can determine which constraints to add.",10,[[["self"],["nodeid"],["body"]]]],[11,"deref","rustc_typeck::check::regionck","",25,N],[11,"new","","",25,[[["fnctxt"],["repeatingscope"],["nodeid"],["subject"],["paramenv"]],["regionctxt"]]],[11,"set_repeating_scope","","",25,[[["self"],["nodeid"]],["nodeid"]]],[11,"resolve_type","","Try to resolve the type for the given node, returning t_err if an error results.  Note that we never care about the details of the error, the same error will be detected and reported in the writeback phase.",25,[[["self"],["ty"]],["ty"]]],[11,"resolve_node_type","","Try to resolve the type for the given node.",25,[[["self"],["hirid"]],["ty"]]],[11,"resolve_expr_type_adjusted","","Try to resolve the type for the given node.",25,[[["self"],["expr"]],["ty"]]],[11,"visit_fn_body","","This is the \"main\" function when region-checking a function item or a closure within a function item. It begins by updating various fields (e.g., `call_site_scope` and `outlives_environment`) to be appropriate to the function and then adds constraints derived from the function body.",25,[[["self"],["nodeid"],["body"],["span"]]]],[11,"visit_region_obligations","","",25,[[["self"],["nodeid"]]]],[11,"resolve_regions_and_report_errors","","",25,[[["self"]]]],[11,"resolve_regions_and_report_errors_unless_nll","","",25,[[["self"]]]],[11,"constrain_bindings_in_pat","","",25,[[["self"],["pat"]]]],[11,"nested_visit_map","","",25,[[["self"]],["nestedvisitormap"]]],[11,"visit_fn","","",25,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_arm","","",25,[[["self"],["arm"]]]],[11,"visit_local","","",25,[[["self"],["local"]]]],[11,"visit_expr","","",25,[[["self"],["expr"]]]],[11,"constrain_cast","","",25,[[["self"],["expr"],["expr"]]]],[11,"walk_cast","","",25,[[["self"],["expr"],["ty"],["ty"]]]],[11,"check_expr_fn_block","","",25,[[["self"],["expr"],["bodyid"]]]],[11,"constrain_callee","","",25,[[["self"],["expr"]]]],[11,"constrain_call","","Invoked on every call site (i.e., normal calls, method calls, and overloaded operators). Constrains the regions which appear in the type of the function. Also constrains the regions that appear in the arguments appropriately.",25,[[["self"],["expr"],["option",["expr"]],["i"]]]],[11,"with_mc","","Create a temporary `MemCategorizationContext` and pass it to the closure.",25,[[["self"],["f"]],["r"]]],[11,"constrain_adjustments","","Invoked on any adjustments that occur. Checks that if this is a region pointer being dereferenced, the lifetime of the pointer includes the deref expr.",25,[[["self"],["expr"]],["mcresult",["cmt_"]]]],[11,"mk_subregion_due_to_dereference","","",25,[[["self"],["span"],["region"],["region"]]]],[11,"check_safety_of_rvalue_destructor_if_necessary","","",25,[[["self"],["cmt_"],["span"]]]],[11,"constrain_index","","Invoked on any index expression that occurs. Checks that if this is a slice being indexed, the lifetime of the pointer includes the deref expr.",25,[[["self"],["expr"],["ty"]]]],[11,"type_of_node_must_outlive","","Guarantees that any lifetimes which appear in the type of the node `id` (after applying adjustments) are valid for at least `minimum_lifetime`",25,[[["self"],["subregionorigin"],["hirid"],["region"]]]],[11,"type_must_outlive","","Adds constraints to inference such that `T: 'a` holds (or reports an error if it cannot).",25,[[["self"],["subregionorigin"],["ty"],["region"]]]],[11,"link_addr_of","","Computes the guarantor for an expression `&base` and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",25,[[["self"],["expr"],["mutability"],["expr"]]]],[11,"link_local","","Computes the guarantors for any ref bindings in a `let` and then ensures that the lifetime of the resulting pointer is linked to the lifetime of the initialization expression.",25,[[["self"],["local"]]]],[11,"link_match","","Computes the guarantors for any ref bindings in a match and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",25,N],[11,"link_fn_args","","Computes the guarantors for any ref bindings in a match and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",25,N],[11,"link_pattern","","Link lifetimes of any ref bindings in `root_pat` to the pointers found in the discriminant, if needed.",25,[[["self"],["cmt"],["pat"]]]],[11,"link_autoref","","Link lifetime of borrowed pointer resulting from autoref to lifetimes in the value being autoref'd.",25,[[["self"],["expr"],["cmt_"],["autoborrow"]]]],[11,"link_region_from_node_type","","Like `link_region()`, except that the region is extracted from the type of `id`, which must be some reference (`&T`, `&str`, etc).",25,[[["self"],["span"],["hirid"],["mutability"],["cmt_"]]]],[11,"link_region","","Informs the inference engine that `borrow_cmt` is being borrowed with kind `borrow_kind` and lifetime `borrow_region`. In order to ensure borrowck is satisfied, this may create constraints between regions, as explained in `link_reborrowed_region()`.",25,[[["self"],["span"],["region"],["borrowkind"],["cmt_"]]]],[11,"link_reborrowed_region","","This is the most complicated case: the path being borrowed is itself the referent of a borrowed pointer. Let me give an example fragment of code to make clear(er) the situation:",25,[[["self"],["span"],["region"],["borrowkind"],["cmt"],["region"],["borrowkind"],["note"]],["option"]]],[11,"substs_wf_in_scope","","Checks that the values provided for type/region arguments in a given expression are well-formed and in-scope.",25,[[["self"],["parameterorigin"],["substs"],["span"],["region"]]]],[0,"coercion","rustc_typeck::check","Type Coercion",N,N],[3,"Coerce","rustc_typeck::check::coercion","",N,N],[12,"fcx","","",28,N],[12,"cause","","",28,N],[12,"use_lub","","",28,N],[12,"allow_two_phase","","Determines whether or not allow_two_phase_borrow is set on any autoref adjustments we create while coercing. We don't want to allow deref coercions to create two-phase borrows, at least initially, but we do need two-phase borrows for function argument reborrows. See #47489 and #48598 See docs on the \"AllowTwoPhase\" type for a more detailed discussion",28,N],[3,"CoerceMany","","CoerceMany encapsulates the pattern you should use when you have many expressions that are all getting coerced to a common type. This arises, for example, when you have a match (the result of each arm is coerced to a common type). It also arises in less obvious places, such as when you have many `break foo` expressions that target the same loop, or the various `return` expressions in a function.",N,N],[12,"expected_ty","","",29,N],[12,"final_ty","","",29,N],[12,"expressions","","",29,N],[12,"pushed","","",29,N],[4,"Expressions","","",N,N],[13,"Dynamic","","",30,N],[13,"UpFront","","",30,N],[5,"coerce_mutbls","","",N,[[["mutability"],["mutability"]],["relateresult"]]],[5,"identity","","",N,[[["ty"]],["vec",["adjustment"]]]],[5,"simple","","",N,[[["adjust"]],[""]]],[5,"success","","",N,[[["vec",["adjustment"]],["ty"],["predicateobligations"]],["inferresult"]]],[6,"CoerceResult","","",N,N],[6,"DynamicCoerceMany","","The type of a `CoerceMany` that is storing up the expressions into a buffer. We use this in `check/mod.rs` for things like `break`.",N,N],[22,"","","",N,N],[8,"AsCoercionSite","","Something that can be converted into an expression to which we can apply a coercion.",N,N],[10,"as_coercion_site","","",31,[[["self"]],["expr"]]],[11,"deref","","",28,N],[11,"new","","",28,[[["fnctxt"],["obligationcause"],["allowtwophase"]],["self"]]],[11,"unify","","",28,[[["self"],["ty"],["ty"]],["inferresult",["ty"]]]],[11,"unify_and","","Unify two types (using sub or lub) and produce a specific coercion.",28,[[["self"],["ty"],["ty"],["f"]],["inferresult"]]],[11,"coerce","","",28,[[["self"],["ty"],["ty"]],["inferresult"]]],[11,"coerce_borrowed_pointer","","Reborrows `&mut A` to `&mut B` and `&(mut) A` to `&B`. To match `A` with `B`, autoderef will be performed, calling `deref`/`deref_mut` where necessary.",28,[[["self"],["ty"],["ty"],["region"],["typeandmut"]],["inferresult"]]],[11,"coerce_unsized","","",28,[[["self"],["ty"],["ty"]],["inferresult"]]],[11,"coerce_from_safe_fn","","",28,[[["self"],["ty"],["polyfnsig"],["ty"],["f"],["g"]],["inferresult"]]],[11,"coerce_from_fn_pointer","","Attempts to coerce from the type of a Rust function item into a closure or a `proc`.",28,[[["self"],["ty"],["polyfnsig"],["ty"]],["inferresult"]]],[11,"coerce_from_fn_item","","Attempts to coerce from the type of a Rust function item into a closure or a `proc`.",28,[[["self"],["ty"],["ty"]],["inferresult"]]],[11,"coerce_closure_to_fn","","Attempts to coerce from the type of a non-capturing closure into a function pointer.",28,[[["self"],["ty"],["defid"],["closuresubsts"],["ty"]],["inferresult"]]],[11,"coerce_unsafe_ptr","","",28,[[["self"],["ty"],["ty"],["mutability"]],["inferresult"]]],[11,"try_coerce","rustc_typeck::check","Attempt to coerce an expression to a type, and return the adjusted type of the expression, if successful. Adjustments are only recorded if the coercion succeeded. The expressions must not have any pre-existing adjustments.",10,[[["self"],["expr"],["ty"],["ty"],["allowtwophase"]],["relateresult",["ty"]]]],[11,"can_coerce","","Same as `try_coerce()`, but without side-effects.",10,[[["self"],["ty"],["ty"]],["bool"]]],[11,"try_find_coercion_lub","","Given some expressions, their known unified type and another expression, tries to unify the types, potentially inserting coercions on any of the provided expressions and returns their LUB (aka \"common supertype\").",10,N],[11,"new","rustc_typeck::check::coercion","The usual case; collect the set of expressions dynamically. If the full set of coercion sites is known before hand, consider `with_coercion_sites()` instead to avoid allocation.",29,[[["ty"]],["self"]]],[11,"with_coercion_sites","","As an optimization, you can create a `CoerceMany` with a pre-existing slice of expressions. In this case, you are expected to pass each element in the slice to `coerce(...)` in order. This is used with arrays in particular to avoid needlessly cloning the slice.",29,N],[11,"make","","",29,[[["ty"],["expressions"]],["self"]]],[11,"expected_ty","","Return the \"expected type\" with which this coercion was constructed.  This represents the \"downward propagated\" type that was given to us at the start of typing whatever construct we are typing (e.g., the match expression).",29,[[["self"]],["ty"]]],[11,"merged_ty","","Returns the current \"merged type\", representing our best-guess at the LUB of the expressions we've seen so far (if any). This isn't final until you call `self.final()`, which will return the merged type.",29,[[["self"]],["ty"]]],[11,"coerce","","Indicates that the value generated by `expression`, which is of type `expression_ty`, is one of the possibility that we could coerce from. This will record `expression` and later calls to `coerce` may come back and add adjustments and things if necessary.",29,[[["self"],["fnctxt"],["obligationcause"],["expr"],["ty"]]]],[11,"coerce_forced_unit","","Indicates that one of the inputs is a \"forced unit\". This occurs in a case like `if foo { ... };`, where the missing else generates a \"forced unit\". Another example is a `loop { break; }`, where the `break` has no argument expression. We treat these cases slightly differently for error-reporting purposes. Note that these tend to correspond to cases where the `()` expression is implicit in the source, and hence we do not take an expression argument.",29,[[["self"],["fnctxt"],["obligationcause"],["fnmut"],["bool"]]]],[11,"coerce_inner","","The inner coercion \"engine\". If `expression` is `None`, this is a forced-unit case, and hence `expression_ty` must be `Nil`.",29,[[["self"],["fnctxt"],["obligationcause"],["option",["expr"]],["ty"],["option",["fnmut"]],["bool"]]]],[11,"complete","","",29,[[["self"],["fnctxt"]],["ty"]]],[0,"demand","rustc_typeck::check","",N,N],[11,"demand_suptype","","",10,[[["self"],["span"],["ty"],["ty"]]]],[11,"demand_suptype_diag","","",10,[[["self"],["span"],["ty"],["ty"]],["option",["diagnosticbuilder"]]]],[11,"demand_eqtype","","",10,[[["self"],["span"],["ty"],["ty"]]]],[11,"demand_eqtype_diag","","",10,[[["self"],["span"],["ty"],["ty"]],["option",["diagnosticbuilder"]]]],[11,"demand_eqtype_with_origin","","",10,[[["self"],["obligationcause"],["ty"],["ty"]],["option",["diagnosticbuilder"]]]],[11,"demand_coerce","","",10,[[["self"],["expr"],["ty"],["ty"],["allowtwophase"]],["ty"]]],[11,"demand_coerce_diag","","",10,N],[11,"get_conversion_methods","","",10,[[["self"],["span"],["ty"],["ty"]],["vec",["associateditem"]]]],[11,"has_no_input_arg","","",10,[[["self"],["associateditem"]],["bool"]]],[11,"can_use_as_ref","","Identify some cases where `as_ref()` would be appropriate and suggest it.",10,[[["self"],["expr"]],["option"]]],[11,"check_ref","","This function is used to determine potential \"simple\" improvements or users' errors and provide them useful help. For example:",10,[[["self"],["expr"],["ty"],["ty"]],["option"]]],[11,"check_for_cast","","",10,[[["self"],["diagnosticbuilder"],["expr"],["ty"],["ty"]],["bool"]]],[0,"method","","Method lookup: the secret sauce of Rust. See the [rustc guide] chapter.",N,N],[3,"MethodCallee","rustc_typeck::check::method","",N,N],[12,"def_id","","Impl method ID, for inherent methods, or trait method ID, otherwise.",32,N],[12,"substs","","",32,N],[12,"sig","","Instantiated method signature, i.e. it has been substituted, normalized, and has had late-bound lifetimes replaced with inference variables.",32,N],[3,"NoMatchData","","",N,N],[12,"static_candidates","","",33,N],[12,"unsatisfied_predicates","","",33,N],[12,"out_of_scope_traits","","",33,N],[12,"lev_candidate","","",33,N],[12,"mode","","",33,N],[4,"MethodError","","",N,N],[13,"NoMatch","","",34,N],[13,"Ambiguity","","",34,N],[13,"PrivateMatch","","",34,N],[13,"IllegalSizedBound","","",34,N],[13,"BadReturnType","","",34,N],[4,"CandidateSource","","",N,N],[13,"ImplSource","","",35,N],[13,"TraitSource","","",35,N],[5,"provide","","",N,[[["providers"]]]],[0,"confirm","","",N,N],[3,"ConfirmContext","rustc_typeck::check::method::confirm","",N,N],[12,"fcx","","",36,N],[12,"span","","",36,N],[12,"self_expr","","",36,N],[12,"call_expr","","",36,N],[3,"ConfirmResult","","",N,N],[12,"callee","","",37,N],[12,"illegal_sized_bound","","",37,N],[11,"deref","","",36,N],[11,"confirm_method","rustc_typeck::check","",10,[[["self"],["span"],["expr"],["expr"],["ty"],["pick"],["pathsegment"]],["confirmresult"]]],[11,"new","rustc_typeck::check::method::confirm","",36,[[["fnctxt"],["span"],["expr"],["expr"]],["confirmcontext"]]],[11,"confirm","","",36,[[["self"],["ty"],["pick"],["pathsegment"]],["confirmresult"]]],[11,"adjust_self_ty","","",36,[[["self"],["ty"],["pick"]],["ty"]]],[11,"fresh_receiver_substs","","Returns a set of substitutions for the method receiver where all type and region parameters are instantiated with fresh variables. This substitution does not include any parameters declared on the method itself.",36,[[["self"],["ty"],["pick"]],["substs"]]],[11,"extract_existential_trait_ref","","",36,[[["self"],["ty"],["f"]],["r"]]],[11,"instantiate_method_substs","","",36,[[["self"],["pick"],["pathsegment"],["substs"]],["substs"]]],[11,"unify_receivers","","",36,[[["self"],["ty"],["ty"]]]],[11,"instantiate_method_sig","","",36,N],[11,"add_obligations","","",36,[[["self"],["ty"],["substs"],["instantiatedpredicates"]]]],[11,"convert_place_derefs_to_mutable","","When we select a method with a mutable autoref, we have to go convert any auto-derefs, indices, etc from `Deref` and `Index` into `DerefMut` and `IndexMut` respectively.",36,[[["self"]]]],[11,"convert_place_op_to_mutable","","",36,N],[11,"predicates_require_illegal_sized_bound","","",36,[[["self"],["instantiatedpredicates"]],["bool"]]],[11,"enforce_illegal_method_limitations","","",36,[[["self"],["pick"]]]],[11,"upcast","","",36,[[["self"],["polytraitref"],["defid"]],["polytraitref"]]],[11,"replace_late_bound_regions_with_fresh_var","","",36,[[["self"],["binder"]],["t"]]],[0,"probe","rustc_typeck::check::method","",N,N],[3,"IsSuggestion","rustc_typeck::check::method::probe","Boolean flag used to indicate if this search is for a suggestion or not.  If true, we can allow ambiguity and so forth.",N,N],[12,"0","","",38,N],[3,"ProbeContext","","",N,N],[12,"fcx","","",39,N],[12,"span","","",39,N],[12,"mode","","",39,N],[12,"method_name","","",39,N],[12,"return_type","","",39,N],[12,"steps","","",39,N],[12,"inherent_candidates","","",39,N],[12,"extension_candidates","","",39,N],[12,"impl_dups","","",39,N],[12,"static_candidates","","Collects near misses when the candidate functions are missing a `self` keyword and is only used for error reporting",39,N],[12,"allow_similar_names","","When probing for names, include names that are close to the requested name (by Levensthein distance)",39,N],[12,"private_candidate","","Some(candidate) if there is a private candidate",39,N],[12,"unsatisfied_predicates","","Collects near misses when trait bounds for type parameters are unsatisfied and is only used for error reporting",39,N],[12,"is_suggestion","","",39,N],[3,"CandidateStep","","",N,N],[12,"self_ty","","",40,N],[12,"autoderefs","","",40,N],[12,"from_unsafe_deref","","",40,N],[12,"unsize","","",40,N],[3,"Candidate","","",N,N],[12,"xform_self_ty","","",41,N],[12,"xform_ret_ty","","",41,N],[12,"item","","",41,N],[12,"kind","","",41,N],[12,"import_id","","",41,N],[3,"Pick","","",N,N],[12,"item","","",42,N],[12,"kind","","",42,N],[12,"import_id","","",42,N],[12,"autoderefs","","",42,N],[12,"autoref","","",42,N],[12,"unsize","","",42,N],[4,"CandidateKind","","",N,N],[13,"InherentImplCandidate","","",43,N],[13,"ObjectCandidate","","",43,N],[13,"TraitCandidate","","",43,N],[13,"WhereClauseCandidate","","",43,N],[4,"ProbeResult","","",N,N],[13,"NoMatch","","",44,N],[13,"BadReturnType","","",44,N],[13,"Match","","",44,N],[4,"PickKind","","",N,N],[13,"InherentImplPick","","",45,N],[13,"ObjectPick","","",45,N],[13,"TraitPick","","",45,N],[13,"WhereClausePick","","",45,N],[4,"Mode","","",N,N],[13,"MethodCall","","",46,N],[13,"Path","","",46,N],[4,"ProbeScope","","",N,N],[13,"TraitsInScope","","",47,N],[13,"AllTraits","","",47,N],[6,"PickResult","","",N,N],[11,"clone","","",38,[[["self"]],["issuggestion"]]],[11,"deref","","",39,N],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",41,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"eq","","",44,[[["self"],["proberesult"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",44,N],[11,"clone","","",44,[[["self"]],["proberesult"]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"eq","","",42,[[["self"],["pick"]],["bool"]]],[11,"ne","","",42,[[["self"],["pick"]],["bool"]]],[11,"clone","","",42,[[["self"]],["pick"]]],[11,"clone","","",45,[[["self"]],["pickkind"]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"eq","","",45,[[["self"],["pickkind"]],["bool"]]],[11,"ne","","",45,[[["self"],["pickkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",45,N],[11,"eq","","",46,[[["self"],["mode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",46,N],[11,"clone","","",46,[[["self"]],["mode"]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"eq","","",47,[[["self"],["probescope"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",47,N],[11,"clone","","",47,[[["self"]],["probescope"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"probe_for_return_type","rustc_typeck::check","This is used to offer suggestions to users. It returns methods that could have been called which have the desired return type. Some effort is made to rule out methods that, if called, would result in an error (basically, the same criteria we would use to decide if a method is a plausible fit for ambiguity purposes).",10,[[["self"],["span"],["mode"],["ty"],["ty"],["nodeid"]],["vec",["associateditem"]]]],[11,"probe_for_name","","",10,[[["self"],["span"],["mode"],["ident"],["issuggestion"],["ty"],["nodeid"],["probescope"]],["result",["pick","methoderror"]]]],[11,"probe_op","","",10,[[["self"],["span"],["mode"],["option",["ident"]],["option",["ty"]],["issuggestion"],["ty"],["nodeid"],["probescope"],["op"]],["result",["methoderror"]]]],[11,"create_steps","","",10,[[["self"],["span"],["nodeid"],["ty"],["issuggestion"]],["option",["vec"]]]],[11,"new","rustc_typeck::check::method::probe","",39,[[["fnctxt"],["span"],["mode"],["option",["ident"]],["option",["ty"]],["rc",["vec"]],["issuggestion"]],["probecontext"]]],[11,"reset","","",39,[[["self"]]]],[11,"push_candidate","","",39,[[["self"],["candidate"],["bool"]]]],[11,"assemble_inherent_candidates","","",39,[[["self"]]]],[11,"assemble_probe","","",39,[[["self"],["ty"]]]],[11,"assemble_inherent_impl_for_primitive","","",39,[[["self"],["option",["defid"]]]]],[11,"assemble_inherent_impl_candidates_for_type","","",39,[[["self"],["defid"]]]],[11,"assemble_inherent_impl_probe","","",39,[[["self"],["defid"]]]],[11,"assemble_inherent_candidates_from_object","","",39,[[["self"],["ty"],["polyexistentialtraitref"]]]],[11,"assemble_inherent_candidates_from_param","","",39,[[["self"],["ty"],["paramty"]]]],[11,"elaborate_bounds","","",39,N],[11,"assemble_extension_candidates_for_traits_in_scope","","",39,[[["self"],["nodeid"]],["result",["methoderror"]]]],[11,"assemble_extension_candidates_for_all_traits","","",39,[[["self"]],["result",["methoderror"]]]],[11,"matches_return_type","","",39,[[["self"],["associateditem"],["option",["ty"]],["ty"]],["bool"]]],[11,"assemble_extension_candidates_for_trait","","",39,[[["self"],["option",["nodeid"]],["defid"]],["result",["methoderror"]]]],[11,"candidate_method_names","","",39,[[["self"]],["vec",["ident"]]]],[11,"pick","","",39,[[["self"]],["result",["pick","methoderror"]]]],[11,"pick_core","","",39,[[["self"]],["option",["result"]]]],[11,"pick_by_value_method","","For each type `T` in the step list, this attempts to find a method where the (transformed) self type is exactly `T`. We do however do one transformation on the adjustment: if we are passing a region pointer in, we will potentially reborrow it to a shorter lifetime. This allows us to transparently pass `&mut` pointers, in particular, without consuming them for their entire lifetime.",39,[[["self"],["candidatestep"]],["option",["result"]]]],[11,"pick_autorefd_method","","",39,[[["self"],["candidatestep"],["mutability"]],["option",["result"]]]],[11,"pick_method","","",39,[[["self"],["ty"]],["option",["result"]]]],[11,"consider_candidates","","",39,[[["self"],["ty"],["probesiter"],["vec"],["option",["vec"]]],["option",["result"]]]],[11,"emit_unstable_name_collision_hint","","",39,N],[11,"select_trait_candidate","","",39,[[["self"],["traitref"]],["selectionresult",["selection"]]]],[11,"candidate_source","","",39,[[["self"],["candidate"],["ty"]],["candidatesource"]]],[11,"consider_probe","","",39,[[["self"],["ty"],["candidate"],["vec"]],["proberesult"]]],[11,"collapse_candidates_to_trait_pick","","Sometimes we get in a situation where we have multiple probes that are all impls of the same trait, but we don't know which impl to use. In this case, since in all cases the external interface of the method can be determined from the trait, it's ok not to decide. We can basically just collapse all of the probes for various impls into one where-clause probe. This will result in a pending obligation so when more type-info is available we can make the final decision.",39,N],[11,"probe_for_lev_candidate","","Similarly to `probe_for_return_type`, this method attempts to find the best matching candidate method where the method name may have been misspelt. Similarly to other Levenshtein based suggestions, we provide at most one such suggestion.",39,[[["self"]],["result",["option","methoderror"]]]],[11,"has_applicable_self","","",39,[[["self"],["associateditem"]],["bool"]]],[11,"record_static_candidate","","",39,[[["self"],["candidatesource"]]]],[11,"xform_self_ty","","",39,N],[11,"xform_method_sig","","",39,[[["self"],["defid"],["substs"]],["fnsig"]]],[11,"impl_ty_and_substs","","Get the type of an impl and generate substitutions with placeholders.",39,N],[11,"fresh_item_substs","","",39,[[["self"],["defid"]],["substs"]]],[11,"erase_late_bound_regions","","Replace late-bound-regions bound by `value` with `'static` using `ty::erase_late_bound_regions`.",39,[[["self"],["binder"]],["t"]]],[11,"impl_or_trait_item","","Find the method with the appropriate name (or return type, as the case may be). If `allow_similar_names` is set, find methods with close-matching names.",39,[[["self"],["defid"]],["vec",["associateditem"]]]],[11,"to_unadjusted_pick","","",41,[[["self"]],["pick"]]],[0,"suggest","rustc_typeck::check::method","Give useful errors and suggestions to users when an item can't be found or is otherwise invalid.",N,N],[3,"TraitInfo","rustc_typeck::check::method::suggest","",N,N],[12,"def_id","","",48,N],[3,"UsePlacementFinder","","",N,N],[12,"target_module","","",49,N],[12,"span","","",49,N],[12,"found_use","","",49,N],[12,"tcx","","",49,N],[5,"all_traits","","Retrieve all traits in this crate and any dependent crates.",N,[[["tyctxt"]],["vec",["traitinfo"]]]],[5,"compute_all_traits","","Compute all traits in this crate and any dependent crates.",N,[[["tyctxt"]],["vec",["defid"]]]],[5,"provide","","",N,[[["providers"]]]],[11,"is_fn_ty","rustc_typeck::check","",10,[[["self"],["ty"],["span"]],["bool"]]],[11,"report_method_error","","",10,[[["self"],["span"],["ty"],["ident"],["option",["expr"]],["methoderror"],["option"]]]],[11,"suggest_use_candidates","","",10,[[["self"],["diagnosticbuilder"],["string"],["vec",["defid"]]]]],[11,"suggest_valid_traits","","",10,[[["self"],["diagnosticbuilder"],["vec",["defid"]]],["bool"]]],[11,"suggest_traits_to_import","","",10,[[["self"],["diagnosticbuilder"],["span"],["ty"],["ident"],["option",["expr"]],["vec",["defid"]]]]],[11,"type_derefs_to_local","","Checks whether there is a local type somewhere in the chain of autoderefs of `rcvr_ty`.",10,[[["self"],["span"],["ty"],["option",["expr"]]],["bool"]]],[11,"clone","rustc_typeck::check::method::suggest","",48,[[["self"]],["traitinfo"]]],[11,"eq","","",48,[[["self"],["traitinfo"]],["bool"]]],[11,"partial_cmp","","",48,[[["self"],["traitinfo"]],["option",["ordering"]]]],[11,"cmp","","",48,[[["self"],["traitinfo"]],["ordering"]]],[11,"check","","",49,N],[11,"visit_mod","","",49,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"nested_visit_map","","",49,[[["self"]],["nestedvisitormap"]]],[11,"clone","rustc_typeck::check::method","",32,[[["self"]],["methodcallee"]]],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"new","","",33,[[["vec",["candidatesource"]],["vec",["traitref"]],["vec",["defid"]],["option",["associateditem"]],["mode"]],["self"]]],[11,"clone","","",35,[[["self"]],["candidatesource"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",35,N],[11,"cmp","","",35,[[["self"],["candidatesource"]],["ordering"]]],[11,"eq","","",35,[[["self"],["candidatesource"]],["bool"]]],[11,"ne","","",35,[[["self"],["candidatesource"]],["bool"]]],[11,"partial_cmp","","",35,[[["self"],["candidatesource"]],["option",["ordering"]]]],[11,"lt","","",35,[[["self"],["candidatesource"]],["bool"]]],[11,"le","","",35,[[["self"],["candidatesource"]],["bool"]]],[11,"gt","","",35,[[["self"],["candidatesource"]],["bool"]]],[11,"ge","","",35,[[["self"],["candidatesource"]],["bool"]]],[11,"method_exists","rustc_typeck::check","Determines whether the type `self_ty` supports a method name `method_name` or not.",10,[[["self"],["ident"],["ty"],["nodeid"],["bool"]],["bool"]]],[11,"lookup_method","","Performs method lookup. If lookup is successful, it will return the callee and store an appropriate adjustment for the self-expr. In some cases it may report an error (e.g., invoking the `drop` method).",10,[[["self"],["ty"],["pathsegment"],["span"],["expr"],["expr"]],["result",["methodcallee","methoderror"]]]],[11,"lookup_probe","","",10,[[["self"],["span"],["ident"],["ty"],["expr"],["probescope"]],["result",["pick","methoderror"]]]],[11,"lookup_method_in_trait","","`lookup_method_in_trait` is used for overloaded operators. It does a very narrow slice of what the normal probe/confirm path does. In particular, it doesn't really do any probing: it simply constructs an obligation for a particular trait with the given self-type and checks whether that trait is implemented.",10,[[["self"],["span"],["ident"],["defid"],["ty"],["option"]],["option",["inferok"]]]],[11,"resolve_ufcs","","",10,[[["self"],["span"],["ident"],["ty"],["nodeid"]],["result",["def","methoderror"]]]],[11,"associated_item","","Find item with name `item_name` defined in impl/trait `def_id` and return it, or `None`, if no such item was defined there.",10,[[["self"],["defid"],["ident"],["namespace"]],["option",["associateditem"]]]],[0,"upvar","","Inferring borrow kinds for upvars",N,N],[3,"InferBorrowKindVisitor","rustc_typeck::check::upvar","",N,N],[12,"fcx","","",50,N],[3,"InferBorrowKind","","",N,N],[12,"fcx","","",51,N],[12,"closure_def_id","","",51,N],[12,"current_closure_kind","","",51,N],[12,"current_origin","","",51,N],[12,"adjust_upvar_captures","","",51,N],[5,"var_name","","",N,[[["tyctxt"],["hirid"]],["name"]]],[11,"closure_analyze","rustc_typeck::check","",10,[[["self"],["body"]]]],[11,"nested_visit_map","rustc_typeck::check::upvar","",50,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",50,[[["self"],["expr"]]]],[11,"analyze_closure","rustc_typeck::check","Analysis starting point.",10,[[["self"],["nodeid"],["hirid"],["span"],["body"],["captureclause"]]]],[11,"final_upvar_tys","","",10,[[["self"],["nodeid"]],["vec",["ty"]]]],[11,"adjust_upvar_borrow_kind_for_consume","rustc_typeck::check::upvar","",51,[[["self"],["cmt_"],["consumemode"]]]],[11,"adjust_upvar_borrow_kind_for_mut","","Indicates that `cmt` is being directly mutated (e.g., assigned to). If cmt contains any by-ref upvars, this implies that those upvars must be borrowed using an `&mut` borrow.",51,[[["self"],["cmt_"]]]],[11,"adjust_upvar_borrow_kind_for_unique","","",51,[[["self"],["cmt_"]]]],[11,"try_adjust_upvar_deref","","",51,[[["self"],["cmt_"],["borrowkind"]],["bool"]]],[11,"adjust_upvar_borrow_kind","","We infer the borrow_kind with which to borrow upvars in a stack closure. The borrow_kind basically follows a lattice of `imm < unique-imm < mut`, moving from left to right as needed (but never right to left). Here the argument `mutbl` is the borrow_kind that is required by some particular use.",51,[[["self"],["upvarid"],["borrowkind"]]]],[11,"adjust_closure_kind","","",51,[[["self"],["localdefid"],["closurekind"],["span"],["name"]]]],[11,"consume","","",51,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"matched_pat","","",51,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume_pat","","",51,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[11,"borrow","","",51,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"decl_without_init","","",51,[[["self"],["nodeid"],["span"]]]],[11,"mutate","","",51,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[0,"wfcheck","rustc_typeck::check","",N,N],[3,"CheckWfFcxBuilder","rustc_typeck::check::wfcheck","Helper type of a temporary returned by .for_item(...). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(FnCtxt<'b, 'gcx, 'tcx>).",N,N],[12,"inherited","","",52,N],[12,"id","","",52,N],[12,"span","","",52,N],[12,"param_env","","",52,N],[3,"CheckTypeWellFormedVisitor","","",N,N],[12,"tcx","","",53,N],[3,"AdtVariant","","",N,N],[12,"fields","","",54,N],[3,"AdtField","","",N,N],[12,"ty","","",55,N],[12,"span","","",55,N],[5,"check_item_well_formed","","Checks that the field types (in a struct def'n) or argument types (in an enum def'n) are well-formed, meaning that they do not require any constraints not declared in the struct definition itself. For example, this definition would be illegal:",N,[[["tyctxt"],["defid"]]]],[5,"check_trait_item","","",N,[[["tyctxt"],["defid"]]]],[5,"check_impl_item","","",N,[[["tyctxt"],["defid"]]]],[5,"check_associated_item","","",N,[[["tyctxt"],["nodeid"],["span"],["option",["methodsig"]]]]],[5,"for_item","","",N,[[["tyctxt"],["item"]],["checkwffcxbuilder"]]],[5,"for_id","","",N,[[["tyctxt"],["nodeid"],["span"]],["checkwffcxbuilder"]]],[5,"check_type_defn","","In a type definition, we check that to ensure that the types of the fields are well-formed.",N,[[["tyctxt"],["item"],["bool"],["f"]]]],[5,"check_trait","","",N,[[["tyctxt"],["item"]]]],[5,"check_item_fn","","",N,[[["tyctxt"],["item"]]]],[5,"check_item_type","","",N,[[["tyctxt"],["item"]]]],[5,"check_impl","","",N,[[["tyctxt"],["item"],["ty"],["option"]]]],[5,"check_where_clauses","","Checks where clauses and inline bounds that are declared on def_id.",N,[[["tyctxt"],["fnctxt"],["span"],["defid"],["option",["ty"]]]]],[5,"check_fn_or_method","","",N,[[["tyctxt"],["fnctxt"],["span"],["polyfnsig"],["defid"],["vec"]]]],[5,"check_existential_types","","Checks \"defining uses\" of existential types to ensure that they meet the restrictions laid for \"higher-order pattern unification\". This ensures that inference is tractable. In particular, definitions of existential types can only use other generics as arguments, and they cannot repeat an argument. Example:",N,[[["tyctxt"],["fnctxt"],["defid"],["span"],["ty"]],["vec",["predicate"]]]],[5,"check_method_receiver","","",N,[[["fnctxt"],["methodsig"],["associateditem"],["ty"]]]],[5,"check_variances_for_type_defn","","",N,[[["tyctxt"],["item"],["generics"]]]],[5,"report_bivariance","","",N,[[["tyctxt"],["span"],["name"]]]],[5,"reject_shadowing_parameters","","",N,[[["tyctxt"],["defid"]]]],[5,"check_false_global_bounds","","Feature gates RFC 2056 - trivial bounds, checking for global bounds that aren't true.",N,[[["fnctxt"],["span"],["nodeid"]]]],[5,"error_392","","",N,[[["tyctxt"],["span"],["name"]],["diagnosticbuilder"]]],[5,"error_194","","",N,[[["tyctxt"],["span"],["span"],["str"]]]],[11,"with_fcx","","",52,[[["self"],["f"]]]],[11,"new","","",53,[[["tyctxt"]],["checktypewellformedvisitor"]]],[11,"nested_visit_map","","",53,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",53,[[["self"],["item"]]]],[11,"visit_trait_item","","",53,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",53,[[["self"],["implitem"]]]],[11,"non_enum_variant","rustc_typeck::check","",10,[[["self"],["variantdata"]],["adtvariant"]]],[11,"enum_variants","","",10,[[["self"],["enumdef"]],["vec",["adtvariant"]]]],[11,"impl_implied_bounds","","",10,[[["self"],["defid"],["span"]],["vec",["ty"]]]],[0,"cast","","Code for type-checking cast expressions.",N,N],[3,"CastCheck","rustc_typeck::check::cast","Reifies a cast check to be checked once we have full type information for a function context.",N,N],[12,"expr","","",56,N],[12,"expr_ty","","",56,N],[12,"cast_ty","","",56,N],[12,"cast_span","","",56,N],[12,"span","","",56,N],[4,"PointerKind","","The kind of pointer and associated metadata (thin, length or vtable) - we only allow casts between fat pointers if their metadata have the same kind.",N,N],[13,"Thin","","No metadata attached, ie pointer to sized type or foreign type",57,N],[13,"Vtable","","A trait object",57,N],[13,"Length","","Slice",57,N],[13,"OfProjection","","The unsize info of this projection",57,N],[13,"OfAnon","","The unsize info of this anon ty",57,N],[13,"OfParam","","The unsize info of this parameter",57,N],[4,"CastError","","",N,N],[13,"ErrorReported","","",58,N],[13,"CastToBool","","",58,N],[13,"CastToChar","","",58,N],[13,"DifferingKinds","","",58,N],[13,"SizedUnsizedCast","","Cast of thin to fat raw ptr (eg. `*const () as *const [u8]`)",58,N],[13,"IllegalCast","","",58,N],[13,"NeedDeref","","",58,N],[13,"NeedViaPtr","","",58,N],[13,"NeedViaThinPtr","","",58,N],[13,"NeedViaInt","","",58,N],[13,"NonScalar","","",58,N],[13,"UnknownExprPtrKind","","",58,N],[13,"UnknownCastPtrKind","","",58,N],[5,"make_invalid_casting_error","","",N,[[["session"],["span"],["ty"],["ty"],["fnctxt"]],["diagnosticbuilder"]]],[11,"clone","","",57,[[["self"]],["pointerkind"]]],[11,"eq","","",57,[[["self"],["pointerkind"]],["bool"]]],[11,"ne","","",57,[[["self"],["pointerkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",57,N],[11,"pointer_kind","rustc_typeck::check","Returns the kind of unsize information of t, or None if t is unknown.",10,[[["self"],["ty"],["span"]],["result",["option","errorreported"]]]],[11,"clone","rustc_typeck::check::cast","",58,[[["self"]],["casterror"]]],[11,"from","","",58,[[["errorreported"]],["self"]]],[11,"new","","",56,[[["fnctxt"],["expr"],["ty"],["ty"],["span"],["span"]],["result",["castcheck","errorreported"]]]],[11,"report_cast_error","","",56,[[["self"],["fnctxt"],["casterror"]]]],[11,"report_cast_to_unsized_type","","",56,[[["self"],["fnctxt"]]]],[11,"trivial_cast_lint","","",56,[[["self"],["fnctxt"]]]],[11,"check","","",56,[[["self"],["fnctxt"]]]],[11,"do_check","","Check a cast, and report an error if one exists. In some cases, this can return Ok and create type errors in the fcx rather than returning directly. coercion-cast is handled in check instead of here.",56,[[["self"],["fnctxt"]],["result",["castkind","casterror"]]]],[11,"check_ptr_ptr_cast","","",56,[[["self"],["fnctxt"],["typeandmut"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"check_fptr_ptr_cast","","",56,[[["self"],["fnctxt"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"check_ptr_addr_cast","","",56,[[["self"],["fnctxt"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"check_ref_cast","","",56,[[["self"],["fnctxt"],["typeandmut"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"check_addr_ptr_cast","","",56,[[["self"],["fnctxt"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"try_coercion_cast","","",56,[[["self"],["fnctxt"]],["bool"]]],[11,"type_is_known_to_be_sized","rustc_typeck::check","",10,[[["self"],["ty"],["span"]],["bool"]]],[0,"closure","","Code for type-checking closure expressions.",N,N],[3,"ExpectedSig","rustc_typeck::check::closure","What signature do we expect the closure to have from context?",N,N],[12,"cause_span","","Span that gave us this expectation, if we know that.",59,N],[12,"sig","","",59,N],[3,"ClosureSignatures","","",N,N],[12,"bound_sig","","",60,N],[12,"liberated_sig","","",60,N],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"check_expr_closure","rustc_typeck::check","",10,[[["self"],["expr"],["captureclause"],["fndecl"],["bodyid"],["option",["generatormovability"]],["expectation"]],["ty"]]],[11,"check_closure","","",10,[[["self"],["expr"],["option",["closurekind"]],["fndecl"],["body"],["option",["generatormovability"]],["option",["expectedsig"]]],["ty"]]],[11,"deduce_expectations_from_expected_type","","Given the expected type, figures out what it can about this closure we are about to type check:",10,N],[11,"deduce_expectations_from_obligations","","",10,N],[11,"deduce_sig_from_projection","","Given a projection like \"<F as Fn(X)>::Result == Y\", we can deduce everything we need to know about a closure.",10,[[["self"],["option",["span"]],["polyprojectionpredicate"]],["option",["expectedsig"]]]],[11,"self_type_matches_expected_vid","","",10,[[["self"],["polytraitref"],["tyvid"]],["option",["polytraitref"]]]],[11,"sig_of_closure","","",10,[[["self"],["defid"],["fndecl"],["body"],["option",["expectedsig"]]],["closuresignatures"]]],[11,"sig_of_closure_no_expectation","","If there is no expected signature, then we will convert the types that the user gave into a signature.",10,[[["self"],["defid"],["fndecl"],["body"]],["closuresignatures"]]],[11,"sig_of_closure_with_expectation","","Invoked to compute the signature of a closure expression. This combines any user-provided type annotations (e.g., `|x: u32| -> u32 { .. }`) with the expected signature.",10,[[["self"],["defid"],["fndecl"],["body"],["expectedsig"]],["closuresignatures"]]],[11,"sig_of_closure_with_mismatched_number_of_arguments","","",10,[[["self"],["defid"],["fndecl"],["body"],["expectedsig"]],["closuresignatures"]]],[11,"check_supplied_sig_against_expectation","","Enforce the user's types against the expectation.  See `sig_of_closure_with_expectation` for details on the overall strategy.",10,[[["self"],["fndecl"],["closuresignatures"]],["inferresult"]]],[11,"supplied_sig_of_closure","","If there is no expected signature, then we will convert the types that the user gave into a signature.",10,[[["self"],["fndecl"]],["polyfnsig"]]],[11,"error_sig_of_closure","","Converts the types that the user supplied, in case that doing so should yield an error, but returns back a signature where all parameters are of type `TyErr`.",10,[[["self"],["fndecl"]],["polyfnsig"]]],[11,"closure_sigs","","",10,[[["self"],["defid"],["body"],["polyfnsig"]],["closuresignatures"]]],[0,"callee","","",N,N],[3,"DeferredCallResolution","rustc_typeck::check::callee","",N,N],[12,"call_expr","","",61,N],[12,"callee_expr","","",61,N],[12,"adjusted_ty","","",61,N],[12,"adjustments","","",61,N],[12,"fn_sig","","",61,N],[12,"closure_def_id","","",61,N],[12,"closure_substs","","",61,N],[4,"CallStep","","",N,N],[13,"Builtin","","",62,N],[13,"DeferredClosure","","",62,N],[13,"Overloaded","","e.g. enum variant constructors",62,N],[5,"check_legal_trait_for_method_call","","Check that it is legal to call methods of the trait corresponding to `trait_id` (this only cares about the trait, not the specific method that is called)",N,[[["tyctxt"],["span"],["defid"]]]],[11,"check_call","rustc_typeck::check","",10,N],[11,"try_overloaded_call_step","","",10,[[["self"],["expr"],["expr"],["autoderef"]],["option",["callstep"]]]],[11,"try_overloaded_call_traits","","",10,[[["self"],["expr"],["ty"]],["option"]]],[11,"confirm_builtin_call","","",10,N],[11,"confirm_deferred_closure_call","","",10,N],[11,"confirm_overloaded_call","","",10,N],[11,"fmt","rustc_typeck::check::callee","",61,[[["self"],["formatter"]],["result"]]],[11,"resolve","","",61,[[["self"],["fnctxt"]]]],[0,"compare_method","rustc_typeck::check","",N,N],[5,"compare_impl_method","rustc_typeck::check::compare_method","Checks that a method from an impl conforms to the signature of the same method as declared in the trait.",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["traitref"],["option",["span"]]]]],[5,"compare_predicate_entailment","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["traitref"]],["result",["errorreported"]]]],[5,"check_region_bounds_on_impl_method","","",N,[[["tyctxt"],["span"],["associateditem"],["associateditem"],["generics"],["generics"],["substs"]],["result",["errorreported"]]]],[5,"extract_spans_for_error_reporting","","",N,N],[5,"compare_self_type","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["traitref"]],["result",["errorreported"]]]],[5,"compare_number_of_generics","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["option",["span"]]],["result",["errorreported"]]]],[5,"compare_number_of_method_arguments","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["option",["span"]]],["result",["errorreported"]]]],[5,"compare_synthetic_generics","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["option",["span"]]],["result",["errorreported"]]]],[5,"compare_const_impl","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["traitref"]]]],[0,"generator_interior","rustc_typeck::check","This calculates the types which has storage which lives across a suspension point in a generator from the perspective of typeck. The actual types used at runtime is calculated in `rustc_mir::transform::generator` and may be a subset of the types computed here.",N,N],[3,"InteriorVisitor","rustc_typeck::check::generator_interior","",N,N],[12,"fcx","","",63,N],[12,"types","","",63,N],[12,"region_scope_tree","","",63,N],[12,"expr_count","","",63,N],[5,"resolve_interior","","",N,[[["fnctxt"],["defid"],["bodyid"],["ty"]]]],[11,"record","","",63,[[["self"],["ty"],["option",["scope"]],["option",["expr"]],["span"]]]],[11,"nested_visit_map","","",63,[[["self"]],["nestedvisitormap"]]],[11,"visit_pat","","",63,[[["self"],["pat"]]]],[11,"visit_expr","","",63,[[["self"],["expr"]]]],[0,"intrinsic","rustc_typeck::check","Type-checking for the rust-intrinsic and platform-intrinsic intrinsics that the compiler exposes.",N,N],[5,"equate_intrinsic_type","rustc_typeck::check::intrinsic","",N,[[["tyctxt"],["foreignitem"],["usize"],["abi"],["vec",["ty"]],["ty"]]]],[5,"check_intrinsic_type","","Remember to add all intrinsics here, in librustc_codegen_llvm/intrinsic.rs, and in libcore/intrinsics.rs",N,[[["tyctxt"],["foreignitem"]]]],[5,"check_platform_intrinsic_type","","Type-check `extern \"platform-intrinsic\" { ... }` functions.",N,[[["tyctxt"],["foreignitem"]]]],[5,"match_intrinsic_type_to_type","","",N,[[["tyctxt"],["str"],["span"],["fxhashmap"],["type"],["ty"]]]],[0,"op","rustc_typeck::check","Code related to processing overloaded binary and unary operators.",N,N],[4,"BinOpCategory","rustc_typeck::check::op","",N,N],[13,"Shortcircuit","","&&, || -- cannot be overridden",64,N],[13,"Shift","","<<, >> -- when shifting a single integer, rhs can be any integer type. For simd, types must match.",64,N],[13,"Math","","+, -, etc -- takes equal types, produces same type as input, applicable to ints/floats/simd",64,N],[13,"Bitwise","","&, |, ^ -- takes equal types, produces same type as input, applicable to ints/floats/simd/bool",64,N],[13,"Comparison","","==, !=, etc -- takes equal types, produces bools, except for simd, which produce the input type",64,N],[4,"IsAssign","","Whether the binary operation is an assignment (`a += b`), or not (`a + b`)",N,N],[13,"No","","",65,N],[13,"Yes","","",65,N],[4,"Op","","",N,N],[13,"Binary","","",66,N],[13,"Unary","","",66,N],[5,"is_builtin_binop","","Returns true if this is a built-in arithmetic operation (e.g. u32 + u32, i16x4 == i16x4) and false if these types would have to be overloaded to be legal. There are two reasons that we distinguish builtin operations from overloaded ones (vs trying to drive everything uniformly through the trait system and intrinsics or something like that):",N,[[["ty"],["ty"],["binop"]],["bool"]]],[11,"check_binop_assign","rustc_typeck::check","Check a `a <op>= b`",10,[[["self"],["expr"],["binop"],["expr"],["expr"]],["ty"]]],[11,"check_binop","","Check a potentially overloaded binary operator.",10,[[["self"],["expr"],["binop"],["expr"],["expr"]],["ty"]]],[11,"enforce_builtin_binop_types","","",10,[[["self"],["expr"],["ty"],["expr"],["ty"],["binop"]],["ty"]]],[11,"check_overloaded_binop","","",10,N],[11,"check_str_addition","","",10,[[["self"],["expr"],["expr"],["expr"],["ty"],["ty"],["diagnosticbuilder"],["bool"]],["bool"]]],[11,"check_user_unop","","",10,[[["self"],["expr"],["ty"],["unop"]],["ty"]]],[11,"lookup_op_method","","",10,N],[11,"from","rustc_typeck::check::op","",64,[[["binop"]],["binopcategory"]]],[11,"clone","","",65,[[["self"]],["isassign"]]],[11,"fmt","","",65,[[["self"],["formatter"]],["result"]]],[11,"eq","","",65,[[["self"],["isassign"]],["bool"]]],[11,"clone","","",66,[[["self"]],["op"]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"clone","rustc_typeck::check","",5,[[["self"]],["maybeinprogresstables"]]],[11,"borrow","","",5,[[["self"]],["ref",["typecktables"]]]],[11,"borrow_mut","","",5,[[["self"]],["refmut",["typecktables"]]]],[11,"deref","","",6,N],[11,"clone","","",15,[[["self"]],["expectation"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"adjust_for_branches","","",15,[[["self"],["fnctxt"]],["expectation"]]],[11,"rvalue_hint","","Provide an expectation for an rvalue expression given an optional hint, which is not required for type safety (the resulting type might be checked higher up, as is the case with `&expr` and `box expr`), but is useful in determining the concrete type.",15,[[["fnctxt"],["ty"]],["expectation"]]],[11,"resolve","","",15,[[["self"],["fnctxt"]],["expectation"]]],[11,"to_option","","",15,[[["self"],["fnctxt"]],["option",["ty"]]]],[11,"only_has_type","","It sometimes happens that we want to turn an expectation into a hard constraint (i.e., something that must be satisfied for the program to type-check). `only_has_type` will return such a constraint, if it exists.",15,[[["self"],["fnctxt"]],["option",["ty"]]]],[11,"coercion_target_type","","Like `only_has_type`, but instead of returning `None` if no hard constraint exists, creates a fresh type variable.",15,[[["self"],["fnctxt"],["span"]],["ty"]]],[11,"clone","","",16,[[["self"]],["needs"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"eq","","",16,[[["self"],["needs"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",16,N],[11,"maybe_mut_place","","",16,[[["mutability"]],["self"]]],[11,"clone","","",7,[[["self"]],["unsafetystate"]]],[11,"function","","",7,[[["unsafety"],["nodeid"]],["unsafetystate"]]],[11,"recurse","","",7,[[["self"],["block"]],["unsafetystate"]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"clone","","",17,[[["self"]],["placeop"]]],[11,"clone","","",18,[[["self"]],["diverges"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"eq","","",18,[[["self"],["diverges"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"partial_cmp","","",18,[[["self"],["diverges"]],["option",["ordering"]]]],[11,"cmp","","",18,[[["self"],["diverges"]],["ordering"]]],[11,"bitand","","",18,[[["self"],["self"]],["self"]]],[11,"bitor","","",18,[[["self"],["self"]],["self"]]],[11,"bitand_assign","","",18,[[["self"],["self"]]]],[11,"bitor_assign","","",18,[[["self"],["self"]]]],[11,"always","","",18,[[["self"]],["bool"]]],[11,"find_breakable","","",9,[[["self"],["nodeid"]],["breakablectxt"]]],[11,"deref","","",10,N],[11,"build","","",6,[[["tyctxt"],["defid"]],["inheritedbuilder"]]],[11,"enter","","",11,[[["self"],["f"]],["r"]]],[11,"new","","",6,[[["inferctxt"],["defid"]],["self"]]],[11,"register_predicate","","",6,[[["self"],["predicateobligation"]]]],[11,"register_predicates","","",6,[[["self"],["i"]]]],[11,"register_infer_ok_obligations","","",6,[[["self"],["inferok"]],["t"]]],[11,"normalize_associated_types_in","","",6,[[["self"],["span"],["nodeid"],["paramenv"],["t"]],["t"]]],[11,"visit_item","","",12,[[["self"],["item"]]]],[11,"visit_trait_item","","",12,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",12,[[["self"],["implitem"]]]],[11,"assign","","",13,[[["self"],["span"],["nodeid"],["option",["ty"]]],["ty"]]],[11,"nested_visit_map","","",13,[[["self"]],["nestedvisitormap"]]],[11,"visit_local","","",13,[[["self"],["local"]]]],[11,"visit_pat","","",13,[[["self"],["pat"]]]],[11,"visit_fn","","",13,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"tcx","","",10,[[["self"]],["tyctxt"]]],[11,"get_type_parameter_bounds","","",10,[[["self"],["span"],["defid"]],["genericpredicates"]]],[11,"re_infer","","",10,[[["self"],["span"],["option",["genericparamdef"]]],["option",["region"]]]],[11,"ty_infer","","",10,[[["self"],["span"]],["ty"]]],[11,"ty_infer_for_def","","",10,[[["self"],["genericparamdef"],["span"]],["ty"]]],[11,"projected_ty_from_poly_trait_ref","","",10,[[["self"],["span"],["defid"],["polytraitref"]],["ty"]]],[11,"normalize_ty","","",10,[[["self"],["span"],["ty"]],["ty"]]],[11,"set_tainted_by_errors","","",10,[[["self"]]]],[11,"record_ty","","",10,[[["self"],["hirid"],["ty"],["span"]]]],[11,"clone","","",19,[[["self"]],["tupleargumentsflag"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"eq","","",19,[[["self"],["tupleargumentsflag"]],["bool"]]],[11,"new","","",10,[[["inherited"],["paramenv"],["nodeid"]],["fnctxt"]]],[11,"sess","","",10,[[["self"]],["session"]]],[11,"err_count_since_creation","","",10,[[["self"]],["usize"]]],[11,"warn_if_unreachable","","Produce warning on the given node, if the current point in the function is unreachable, and there hasn't been another warning.",10,[[["self"],["nodeid"],["span"],["str"]]]],[11,"cause","","",10,[[["self"],["span"],["obligationcausecode"]],["obligationcause"]]],[11,"misc","","",10,[[["self"],["span"]],["obligationcause"]]],[11,"resolve_type_vars_with_obligations","","Resolves type variables in `ty` if possible. Unlike the infcx version (resolve_type_vars_if_possible), this version will also select obligations if it seems useful, in an effort to get more type information.",10,[[["self"],["ty"]],["ty"]]],[11,"record_deferred_call_resolution","","",10,[[["self"],["defid"],["deferredcallresolution"]]]],[11,"remove_deferred_call_resolutions","","",10,[[["self"],["defid"]],["vec",["deferredcallresolution"]]]],[11,"tag","","",10,[[["self"]],["string"]]],[11,"local_ty","","",10,[[["self"],["span"],["nodeid"]],["ty"]]],[11,"write_ty","","",10,[[["self"],["hirid"],["ty"]]]],[11,"write_field_index","","",10,[[["self"],["nodeid"],["usize"]]]],[11,"write_method_call","","",10,[[["self"],["hirid"],["methodcallee"]]]],[11,"write_substs","","",10,[[["self"],["hirid"],["substs"]]]],[11,"apply_adjustments","","",10,[[["self"],["expr"],["vec",["adjustment"]]]]],[11,"instantiate_type_scheme","","Basically whenever we are converting from a type scheme into the fn body space, we always want to normalize associated types as well. This function combines the two.",10,[[["self"],["span"],["substs"],["t"]],["t"]]],[11,"instantiate_bounds","","As `instantiate_type_scheme`, but for the bounds found in a generic type scheme.",10,[[["self"],["span"],["defid"],["substs"]],["instantiatedpredicates"]]],[11,"instantiate_anon_types_from_return_value","","Replace the anonymized types from the return value of the function with type variables and records the `AnonTypeMap` for later use during writeback. See `InferCtxt::instantiate_anon_types` for more details.",10,[[["self"],["nodeid"],["t"]],["t"]]],[11,"normalize_associated_types_in","","",10,[[["self"],["span"],["t"]],["t"]]],[11,"normalize_associated_types_in_as_infer_ok","","",10,[[["self"],["span"],["t"]],["inferok"]]],[11,"require_type_meets","","",10,[[["self"],["ty"],["span"],["obligationcausecode"],["defid"]]]],[11,"require_type_is_sized","","",10,[[["self"],["ty"],["span"],["obligationcausecode"]]]],[11,"register_bound","","",10,[[["self"],["ty"],["defid"],["obligationcause"]]]],[11,"to_ty","","",10,[[["self"],["ty"]],["ty"]]],[11,"node_ty","","",10,[[["self"],["hirid"]],["ty"]]],[11,"register_wf_obligation","","Registers an obligation for checking later, during regionck, that the type `ty` must outlive the region `r`.",10,[[["self"],["ty"],["span"],["obligationcausecode"]]]],[11,"add_wf_bounds","","Registers obligations that all types appearing in `substs` are well-formed.",10,[[["self"],["substs"],["expr"]]]],[11,"add_obligations_for_parameters","","Given a fully substituted set of bounds (`generic_bounds`), and the values with which each type/region parameter was instantiated (`substs`), creates and registers suitable trait/region obligations.",10,[[["self"],["obligationcause"],["instantiatedpredicates"]]]],[11,"field_ty","","",10,[[["self"],["span"],["fielddef"],["substs"]],["ty"]]],[11,"check_casts","","",10,[[["self"]]]],[11,"resolve_generator_interiors","","",10,[[["self"],["defid"]]]],[11,"fallback_if_possible","","",10,[[["self"],["ty"]],["bool"]]],[11,"select_all_obligations_or_error","","",10,[[["self"]]]],[11,"select_obligations_where_possible","","Select as many obligations as we can at present.",10,[[["self"],["bool"]]]],[11,"is_place_expr","","",10,[[["self"],["expr"]],["bool"]]],[11,"make_overloaded_place_return_type","","For the overloaded place expressions (`*x`, `x[3]`), the trait returns a type of `&T`, but the actual type we assign to the expression is `T`. So this function just peels off the return type by one layer to yield `T`.",10,[[["self"],["methodcallee"]],["typeandmut"]]],[11,"lookup_indexing","","",10,[[["self"],["expr"],["expr"],["ty"],["ty"],["needs"]],["option"]]],[11,"try_index_step","","To type-check `base_expr[index_expr]`, we progressively autoderef (and otherwise adjust) `base_expr`, looking for a type which either supports builtin indexing or overloaded indexing. This loop implements one step in that search; the autoderef loop is implemented by `lookup_indexing`.",10,[[["self"],["expr"],["expr"],["autoderef"],["needs"],["ty"]],["option"]]],[11,"resolve_place_op","","",10,N],[11,"try_overloaded_place_op","","",10,N],[11,"check_method_argument_types","","",10,N],[11,"check_argument_types","","Generic function that factors out common logic from function calls, method calls and overloaded operators.",10,N],[11,"err_args","","",10,[[["self"],["usize"]],["vec",["ty"]]]],[11,"check_lit","","",10,[[["self"],["lit"],["expectation"]],["ty"]]],[11,"check_expr_eq_type","","",10,[[["self"],["expr"],["ty"]]]],[11,"check_expr_has_type_or_error","","",10,[[["self"],["expr"],["ty"]],["ty"]]],[11,"check_expr_meets_expectation_or_error","","",10,[[["self"],["expr"],["expectation"]],["ty"]]],[11,"check_expr_coercable_to_type","","",10,[[["self"],["expr"],["ty"]],["ty"]]],[11,"check_expr_with_hint","","",10,[[["self"],["expr"],["ty"]],["ty"]]],[11,"check_expr_with_expectation","","",10,[[["self"],["expr"],["expectation"]],["ty"]]],[11,"check_expr","","",10,[[["self"],["expr"]],["ty"]]],[11,"check_expr_with_needs","","",10,[[["self"],["expr"],["needs"]],["ty"]]],[11,"impl_self_ty","","",10,[[["self"],["span"],["defid"]],["typeandsubsts"]]],[11,"expected_inputs_for_expected_output","","Unifies the output type with the expected type early, for more coercions and forward type information on the input expressions.",10,N],[11,"check_method_call","","",10,N],[11,"check_return_expr","","",10,[[["self"],["expr"]]]],[11,"check_then_else","","",10,[[["self"],["expr"],["expr"],["option",["expr"]],["span"],["expectation"]],["ty"]]],[11,"check_field","","",10,[[["self"],["expr"],["needs"],["expr"],["ident"]],["ty"]]],[11,"suggest_field_name","","",10,[[["variantdef"],["str"],["vec",["localinternedstring"]]],["option",["symbol"]]]],[11,"available_field_names","","",10,[[["self"],["variantdef"]],["vec",["name"]]]],[11,"name_series_display","","",10,[[["self"],["vec",["name"]]],["string"]]],[11,"no_such_field_err","","",10,[[["self"],["span"],["t"],["tys"]],["diagnosticbuilder"]]],[11,"report_unknown_field","","",10,N],[11,"check_expr_struct_fields","","",10,N],[11,"check_struct_fields_on_error","","",10,N],[11,"check_struct_path","","",10,[[["self"],["qpath"],["nodeid"]],["option"]]],[11,"check_expr_struct","","",10,N],[11,"check_expr_with_expectation_and_needs","","Invariant: If an expression has any sub-expressions that result in a type error, inspecting that expression's type with `ty.references_error()` will return true. Likewise, if an expression is known to diverge, inspecting its type with `ty::type_is_bot` will return true (n.b.: since Rust is strict, | can appear in the type of an expression that does not, itself, diverge: for example, fn() -> |.) Note that inspecting a type's structure directly may expose the fact that there are actually multiple representations for `TyError`, so avoid that when err needs to be handled differently.",10,[[["self"],["expr"],["expectation"],["needs"]],["ty"]]],[11,"check_expr_kind","","",10,[[["self"],["expr"],["expectation"],["needs"]],["ty"]]],[11,"finish_resolving_struct_path","","",10,N],[11,"resolve_ty_and_def_ufcs","","",10,N],[11,"check_decl_initializer","","",10,[[["self"],["local"],["expr"]],["ty"]]],[11,"check_decl_local","","",10,[[["self"],["local"]]]],[11,"check_stmt","","",10,[[["self"],["stmt"]]]],[11,"check_block_no_value","","",10,[[["self"],["block"]]]],[11,"check_block_with_expected","","",10,[[["self"],["block"],["expectation"]],["ty"]]],[11,"get_fn_decl","","Given a `NodeId`, return the `FnDecl` of the method it is enclosed by and whether a suggestion can be made, `None` otherwise.",10,[[["self"],["nodeid"]],["option"]]],[11,"suggest_mismatched_types_on_tail","","On implicit return expressions with mismatched types, provide the following suggestions:",10,[[["self"],["diagnosticbuilder"],["expr"],["ty"],["ty"],["span"],["nodeid"]]]],[11,"suggest_ref_or_into","","",10,[[["self"],["diagnosticbuilder"],["expr"],["ty"],["ty"]]]],[11,"suggest_missing_semicolon","","A common error is to forget to add a semicolon at the end of a block:",10,[[["self"],["diagnosticbuilder"],["expr"],["ty"],["span"]]]],[11,"suggest_missing_return_type","","A possible error is to forget to add a return type that is needed:",10,[[["self"],["diagnosticbuilder"],["fndecl"],["ty"],["ty"],["bool"]]]],[11,"consider_hint_about_removing_semicolon","","A common error is to add an extra semicolon:",10,[[["self"],["block"],["ty"],["diagnosticbuilder"]]]],[11,"instantiate_value_path","","",10,N],[11,"check_rustc_args_require_const","","",10,[[["self"],["defid"],["nodeid"],["span"]]]],[11,"check_generic_arg_count","","Report errors if the provided parameters are too few or too many.",10,[[["self"],["span"],["option"],["bool"],["bool"]]]],[11,"check_impl_trait","","Report error if there is an explicit type parameter when using `impl Trait`.",10,[[["self"],["span"],["option"]],["bool"]]],[11,"structurally_resolved_type","","",10,[[["self"],["span"],["ty"]],["ty"]]],[11,"with_breakable_ctxt","","",10,N],[0,"check_unused","rustc_typeck","",N,N],[3,"CheckVisitor","rustc_typeck::check_unused","",N,N],[12,"tcx","","",67,N],[12,"used_trait_imports","","",67,N],[3,"CollectExternCrateVisitor","","",N,N],[12,"tcx","","",68,N],[12,"crates_to_lint","","",68,N],[3,"ExternCrateToLint","","",N,N],[12,"def_id","","def-id of the extern crate",69,N],[12,"span","","span from the item",69,N],[12,"orig_name","","if `Some`, then this is renamed (`extern crate orig_name as crate_name`), and -- perhaps surprisingly -- this stores the original name (`item.name` will contain the new name)",69,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"unused_crates_lint","","",N,[[["tyctxt"]]]],[11,"visit_item","","",67,[[["self"],["item"]]]],[11,"visit_trait_item","","",67,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",67,[[["self"],["implitem"]]]],[11,"check_import","","",67,[[["self"],["nodeid"],["span"]]]],[11,"visit_item","","",68,[[["self"],["item"]]]],[11,"visit_trait_item","","",68,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",68,[[["self"],["implitem"]]]],[0,"coherence","rustc_typeck","",N,N],[5,"check_impl","rustc_typeck::coherence","",N,[[["tyctxt"],["nodeid"]]]],[5,"enforce_trait_manually_implementable","","",N,[[["tyctxt"],["defid"],["defid"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"coherent_trait","","",N,[[["tyctxt"],["defid"]]]],[5,"check_coherence","","",N,[[["tyctxt"]]]],[5,"check_impl_overlap","","Overlap: No two impls for the same trait are implemented for the same type. Likewise, no two inherent impls for a given type constructor provide a method with the same name.",N,[[["tyctxt"],["nodeid"]]]],[0,"builtin","","Check properties that are required by built-in traits and set up data structures required by type-checking/codegen.",N,N],[3,"Checker","rustc_typeck::coherence::builtin","",N,N],[12,"tcx","","",70,N],[12,"trait_def_id","","",70,N],[5,"check_trait","","",N,[[["tyctxt"],["defid"]]]],[5,"visit_implementation_of_drop","","",N,[[["tyctxt"],["defid"],["defid"]]]],[5,"visit_implementation_of_copy","","",N,[[["tyctxt"],["defid"],["defid"]]]],[5,"visit_implementation_of_coerce_unsized","","",N,[[["tyctxt"],["defid"],["defid"]]]],[5,"coerce_unsized_info","","",N,[[["tyctxt"],["defid"]],["coerceunsizedinfo"]]],[11,"check","","",70,[[["self"],["option",["defid"]],["f"]],["self"]]],[0,"inherent_impls","rustc_typeck::coherence","The code in this module gathers up all of the inherent impls in the current crate and organizes them in a map. It winds up touching the whole crate and thus must be recomputed completely for any change, but it is very cheap to compute. In practice, most code in the compiler never directly requests this map. Instead, it requests the inherent impls specific to some type (via `tcx.inherent_impls(def_id)`). That value, however, is computed by selecting an idea from this table.",N,N],[3,"InherentCollect","rustc_typeck::coherence::inherent_impls","",N,N],[12,"tcx","","",71,N],[12,"impls_map","","",71,N],[5,"crate_inherent_impls","","On-demand query: yields a map containing all types mapped to their inherent impls.",N,[[["tyctxt"],["cratenum"]],["crateinherentimpls"]]],[5,"inherent_impls","","On-demand query: yields a vector of the inherent impls for a specific type.",N,[[["tyctxt"],["defid"]],["lrc",["vec"]]]],[11,"visit_item","","",71,[[["self"],["item"]]]],[11,"visit_trait_item","","",71,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",71,[[["self"],["implitem"]]]],[11,"check_def_id","","",71,[[["self"],["item"],["defid"]]]],[11,"check_primitive_impl","","",71,[[["self"],["defid"],["option",["defid"]],["option",["defid"]],["str"],["str"],["span"]]]],[0,"inherent_impls_overlap","rustc_typeck::coherence","",N,N],[3,"InherentOverlapChecker","rustc_typeck::coherence::inherent_impls_overlap","",N,N],[12,"tcx","","",72,N],[5,"crate_inherent_impls_overlap_check","","",N,[[["tyctxt"],["cratenum"]]]],[11,"check_for_common_items_in_impls","","",72,[[["self"],["defid"],["defid"],["overlapresult"],["bool"]]]],[11,"check_for_overlapping_inherent_impls","","",72,[[["self"],["defid"]]]],[11,"visit_item","","",72,[[["self"],["item"]]]],[11,"visit_trait_item","","",72,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",72,[[["self"],["implitem"]]]],[0,"orphan","rustc_typeck::coherence","Orphan checker: every impl either implements a trait defined in this crate or pertains to a type defined in this crate.",N,N],[3,"OrphanChecker","rustc_typeck::coherence::orphan","",N,N],[12,"tcx","","",73,N],[5,"check","","",N,[[["tyctxt"]]]],[11,"visit_item","","Checks exactly one impl for orphan rules and other such restrictions.  In this fn, it can happen that multiple errors apply to a specific impl, so just return after reporting one to prevent inundating the user with a bunch of similar error reports.",73,[[["self"],["item"]]]],[11,"visit_trait_item","","",73,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",73,[[["self"],["implitem"]]]],[0,"unsafety","rustc_typeck::coherence","Unsafety checker: every impl either implements a trait defined in this crate or pertains to a type defined in this crate.",N,N],[3,"UnsafetyChecker","rustc_typeck::coherence::unsafety","",N,N],[12,"tcx","","",74,N],[5,"check","","",N,[[["tyctxt"]]]],[11,"check_unsafety_coherence","","",74,[[["self"],["item"],["option",["generics"]],["unsafety"],["implpolarity"]]]],[11,"visit_item","","",74,[[["self"],["item"]]]],[11,"visit_trait_item","","",74,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",74,[[["self"],["implitem"]]]],[0,"collect","rustc_typeck","\"Collection\" is the process of determining the type and other external details of each item in Rust. Collection is specifically concerned with interprocedural things -- for example, for a function definition, collection will figure out the type and signature of the function, but it will not visit the body of the function in any way, nor examine type annotations on local variables (that's the job of type checking).",N,N],[3,"ItemCtxt","rustc_typeck::collect","Context specific to some particular item. This is what implements AstConv. It has information about the predicates that are defined on the trait. Unfortunately, this predicate information is available in various different forms at various points in the process. So we can't just store a pointer to e.g. the AST or the parsed ty form, we have to be more flexible. To this end, the `ItemCtxt` is parameterized by a `DefId` that it uses to satisfy `get_type_parameter_bounds` requests, drawing the information from the AST (`hir::Generics`), recursively.",N,N],[12,"tcx","","",75,N],[12,"item_def_id","","",75,N],[3,"CollectItemTypesVisitor","","",N,N],[12,"tcx","","",76,N],[4,"SizedByDefault","","",N,N],[13,"Yes","","",77,N],[13,"No","","",77,N],[5,"collect_item_types","","",N,[[["tyctxt"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"type_param_predicates","","",N,N],[5,"is_param","","Tests whether this is the AST for a reference to the type parameter with id `param_id`. We use this so as to avoid running `ast_ty_to_ty`, because we want to avoid triggering an all-out conversion of the type to avoid inducing unnecessary cycles.",N,[[["tyctxt"],["ty"],["nodeid"]],["bool"]]],[5,"convert_item","","",N,[[["tyctxt"],["nodeid"]]]],[5,"convert_trait_item","","",N,[[["tyctxt"],["nodeid"]]]],[5,"convert_impl_item","","",N,[[["tyctxt"],["nodeid"]]]],[5,"convert_variant_ctor","","",N,[[["tyctxt"],["nodeid"]]]],[5,"convert_enum_variant_types","","",N,N],[5,"convert_struct_variant","","",N,[[["tyctxt"],["defid"],["name"],["variantdiscr"],["variantdata"]],["variantdef"]]],[5,"adt_def","","",N,[[["tyctxt"],["defid"]],["adtdef"]]],[5,"super_predicates_of","","Ensures that the super-predicates of the trait with def-id trait_def_id are converted and stored. This also ensures that the transitive super-predicates are converted;",N,[[["tyctxt"],["defid"]],["genericpredicates"]]],[5,"trait_def","","",N,[[["tyctxt"],["defid"]],["traitdef"]]],[5,"has_late_bound_regions","","",N,[[["tyctxt"],["node"]],["option",["span"]]]],[5,"generics_of","","",N,[[["tyctxt"],["defid"]],["generics"]]],[5,"report_assoc_ty_on_inherent_impl","","",N,[[["tyctxt"],["span"]]]],[5,"type_of","","",N,[[["tyctxt"],["defid"]],["ty"]]],[5,"find_existential_constraints","","",N,[[["tyctxt"],["defid"]],["ty"]]],[5,"fn_sig","","",N,[[["tyctxt"],["defid"]],["polyfnsig"]]],[5,"impl_trait_ref","","",N,[[["tyctxt"],["defid"]],["option",["traitref"]]]],[5,"impl_polarity","","",N,[[["tyctxt"],["defid"]],["implpolarity"]]],[5,"is_unsized","","",N,N],[5,"early_bound_lifetimes_from_generics","","Returns the early-bound lifetimes declared in this generics listing.  For anything other than fns/methods, this is just all the lifetimes that are declared. For fns or methods, we have to screen out those that do not appear in any where-clauses etc using `resolve_lifetime::early_bound_lifetimes`.",N,[[["tyctxt"],["generics"]],[""]]],[5,"predicates_defined_on","","",N,[[["tyctxt"],["defid"]],["genericpredicates"]]],[5,"predicates_of","","",N,[[["tyctxt"],["defid"]],["genericpredicates"]]],[5,"explicit_predicates_of","","",N,[[["tyctxt"],["defid"]],["genericpredicates"]]],[5,"compute_bounds","","Translate the AST's notion of ty param bounds (which are an enum consisting of a newtyped Ty or a region) to ty's notion of ty param bounds, which can either be user-defined traits, or the built-in trait (formerly known as kind): Send.",N,N],[5,"predicates_from_bound","","Converts a specific GenericBound from the AST into a set of predicates that apply to the self-type. A vector is returned because this can be anywhere from 0 predicates (`T:?Sized` adds no predicates) to 1 (`T:Foo`) to many (`T:Bar<X=i32>` adds `T:Bar` and `<T as Bar>::X == i32`).",N,[[["astconv"],["ty"],["genericbound"]],["vec",["predicate"]]]],[5,"compute_sig_of_foreign_fn_decl","","",N,[[["tyctxt"],["defid"],["fndecl"],["abi"]],["polyfnsig"]]],[5,"is_foreign_item","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"from_target_feature","","",N,[[["tyctxt"],["defid"],["attribute"],["fxhashmap"],["vec"]]]],[5,"linkage_by_name","","",N,[[["tyctxt"],["defid"],["str"]],["linkage"]]],[5,"codegen_fn_attrs","","",N,[[["tyctxt"],["defid"]],["codegenfnattrs"]]],[22,"","","",N,N],[11,"nested_visit_map","","",76,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",76,[[["self"],["item"]]]],[11,"visit_generics","","",76,[[["self"],["generics"]]]],[11,"visit_expr","","",76,[[["self"],["expr"]]]],[11,"visit_trait_item","","",76,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",76,[[["self"],["implitem"]]]],[11,"new","","",75,[[["tyctxt"],["defid"]],["itemctxt"]]],[11,"to_ty","","",75,[[["self"],["ty"]],["ty"]]],[11,"tcx","","",75,[[["self"]],["tyctxt"]]],[11,"get_type_parameter_bounds","","",75,[[["self"],["span"],["defid"]],["genericpredicates"]]],[11,"re_infer","","",75,[[["self"],["span"],["option",["genericparamdef"]]],["option",["region"]]]],[11,"ty_infer","","",75,[[["self"],["span"]],["ty"]]],[11,"projected_ty_from_poly_trait_ref","","",75,[[["self"],["span"],["defid"],["polytraitref"]],["ty"]]],[11,"normalize_ty","","",75,[[["self"],["span"],["ty"]],["ty"]]],[11,"set_tainted_by_errors","","",75,[[["self"]]]],[11,"record_ty","","",75,[[["self"],["hirid"],["ty"],["span"]]]],[11,"type_parameter_bounds_in_generics","","Find bounds from hir::Generics. This requires scanning through the AST. We do this to avoid having to convert all the bounds, which would create artificial cycles. Instead we can only convert the bounds for a type parameter `X` if `X::Foo` is used.",75,[[["self"],["generics"],["nodeid"],["ty"]],["vec",["predicate"]]]],[0,"constrained_type_params","rustc_typeck","",N,N],[3,"Parameter","rustc_typeck::constrained_type_params","",N,N],[12,"0","","",78,N],[3,"ParameterCollector","","",N,N],[12,"parameters","","",79,N],[12,"include_nonconstraining","","",79,N],[5,"parameters_for_impl","","Return the set of parameters constrained by the impl header.",N,[[["ty"],["option",["traitref"]]],["fxhashset",["parameter"]]]],[5,"parameters_for","","If `include_projections` is false, returns the list of parameters that are constrained by `t` - i.e. the value of each parameter in the list is uniquely determined by `t` (see RFC 447). If it is true, return the list of parameters whose values are needed in order to constrain `ty` - these differ, with the latter being a superset, in the presence of projections.",N,[[["t"],["bool"]],["vec",["parameter"]]]],[5,"identify_constrained_type_params","","",N,N],[5,"setup_constraining_predicates","","Order the predicates in `predicates` such that each parameter is constrained before it is used, if that is possible, and add the parameters so constrained to `input_parameters`. For example, imagine the following impl:",N,N],[11,"clone","","",78,[[["self"]],["parameter"]]],[11,"eq","","",78,[[["self"],["parameter"]],["bool"]]],[11,"ne","","",78,[[["self"],["parameter"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",78,N],[11,"hash","","",78,N],[11,"fmt","","",78,[[["self"],["formatter"]],["result"]]],[11,"from","","",78,[[["paramty"]],["self"]]],[11,"from","","",78,[[["earlyboundregion"]],["self"]]],[11,"visit_ty","","",79,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",79,[[["self"],["region"]],["bool"]]],[0,"structured_errors","rustc_typeck","",N,N],[3,"VariadicError","rustc_typeck::structured_errors","",N,N],[12,"sess","","",80,N],[12,"span","","",80,N],[12,"t","","",80,N],[12,"cast_ty","","",80,N],[3,"SizedUnsizedCastError","","",N,N],[12,"sess","","",81,N],[12,"span","","",81,N],[12,"expr_ty","","",81,N],[12,"cast_ty","","",81,N],[8,"StructuredDiagnostic","","",N,N],[10,"session","","",82,[[["self"]],["session"]]],[10,"code","","",82,[[["self"]],["diagnosticid"]]],[10,"common","","",82,[[["self"]],["diagnosticbuilder"]]],[11,"diagnostic","","",82,[[["self"]],["diagnosticbuilder"]]],[11,"regular","","",82,[[["self"],["diagnosticbuilder"]],["diagnosticbuilder"]]],[11,"extended","","",82,[[["self"],["diagnosticbuilder"]],["diagnosticbuilder"]]],[11,"new","","",80,[[["session"],["span"],["ty"],["str"]],["variadicerror"]]],[11,"session","","",80,[[["self"]],["session"]]],[11,"code","","",80,[[["self"]],["diagnosticid"]]],[11,"common","","",80,[[["self"]],["diagnosticbuilder"]]],[11,"extended","","",80,[[["self"],["diagnosticbuilder"]],["diagnosticbuilder"]]],[11,"new","","",81,[[["session"],["span"],["ty"],["string"]],["sizedunsizedcasterror"]]],[11,"session","","",81,[[["self"]],["session"]]],[11,"code","","",81,[[["self"]],["diagnosticid"]]],[11,"common","","",81,[[["self"]],["diagnosticbuilder"]]],[11,"extended","","",81,[[["self"],["diagnosticbuilder"]],["diagnosticbuilder"]]],[0,"impl_wf_check","rustc_typeck","This pass enforces various \"well-formedness constraints\" on impls. Logically, it is part of wfcheck -- but we do it early so that we can stop compilation afterwards, since part of the trait matching infrastructure gets very grumpy if these conditions don't hold. In particular, if there are type parameters that are not part of the impl, then coherence will report strange inference ambiguity errors; if impls have duplicate items, we get misleading specialization errors. These things can (and probably should) be fixed, but for the moment it's easier to do these checks early.",N,N],[3,"ImplWfCheck","rustc_typeck::impl_wf_check","",N,N],[12,"tcx","","",83,N],[5,"impl_wf_check","","Checks that all the type/lifetime parameters on an impl also appear in the trait ref or self-type (or are constrained by a where-clause). These rules are needed to ensure that, given a trait ref like `<T as Trait<U>>`, we can derive the values of all parameters on the impl (which is needed to make specialization possible).",N,[[["tyctxt"]]]],[5,"enforce_impl_params_are_constrained","","",N,N],[5,"report_unused_parameter","","",N,[[["tyctxt"],["span"],["str"],["str"]]]],[5,"enforce_impl_items_are_distinct","","Enforce that we do not have two items in an impl with the same name.",N,N],[11,"visit_item","","",83,[[["self"],["item"]]]],[11,"visit_trait_item","","",83,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",83,[[["self"],["implitem"]]]],[0,"namespace","rustc_typeck","",N,N],[4,"Namespace","rustc_typeck::namespace","",N,N],[13,"Type","","",84,N],[13,"Value","","",84,N],[11,"clone","","",84,[[["self"]],["namespace"]]],[11,"eq","","",84,[[["self"],["namespace"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",84,N],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"from","","",84,[[["associatedkind"]],["self"]]],[11,"from","","",84,[[["implitemkind"]],["self"]]],[0,"outlives","rustc_typeck","",N,N],[5,"provide","rustc_typeck::outlives","",N,[[["providers"]]]],[5,"inferred_outlives_of","","",N,[[["tyctxt"],["defid"]],["lrc",["vec"]]]],[5,"inferred_outlives_crate","","",N,[[["tyctxt"],["cratenum"]],["lrc",["cratepredicatesmap"]]]],[0,"explicit","","",N,N],[3,"ExplicitPredicatesMap","rustc_typeck::outlives::explicit","",N,N],[12,"map","","",85,N],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"new","","",85,[[],["explicitpredicatesmap"]]],[11,"explicit_predicates_of","","",85,[[["self"],["tyctxt"],["defid"]],["btreeset"]]],[0,"implicit_infer","rustc_typeck::outlives","",N,N],[3,"InferVisitor","rustc_typeck::outlives::implicit_infer","",N,N],[12,"tcx","","",86,N],[12,"global_inferred_outlives","","",86,N],[12,"predicates_added","","",86,N],[12,"explicit_map","","",86,N],[5,"infer_predicates","","Infer predicates for the items in the crate.",N,[[["tyctxt"],["explicitpredicatesmap"]],["fxhashmap",["defid","btreeset"]]]],[5,"insert_required_predicates_to_be_wf","","",N,[[["tyctxt"],["ty"],["fxhashmap"],["btreeset"],["explicitpredicatesmap"]]]],[5,"check_explicit_predicates","","We also have to check the explicit predicates declared on the type.",N,N],[11,"visit_item","","",86,[[["self"],["item"]]]],[11,"visit_trait_item","","",86,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",86,[[["self"],["implitem"]]]],[0,"test","rustc_typeck::outlives","Code to write unit test for outlives.",N,N],[3,"OutlivesTest","rustc_typeck::outlives::test","",N,N],[12,"tcx","","",87,N],[5,"test_inferred_outlives","","",N,[[["tyctxt"]]]],[11,"visit_item","","",87,[[["self"],["item"]]]],[11,"visit_trait_item","","",87,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",87,[[["self"],["implitem"]]]],[0,"utils","rustc_typeck::outlives","",N,N],[5,"insert_outlives_predicate","rustc_typeck::outlives::utils","Given a requirement `T: 'a` or `'b: 'a`, deduce the outlives_component and add it to `required_predicates`",N,[[["tyctxt"],["kind"],["region"],["btreeset"]]]],[5,"is_free_region","","",N,[[["tyctxt"],["region"]],["bool"]]],[6,"RequiredPredicates","","Tracks the `T: 'a` or `'a: 'a` predicates that we have inferred must be added to the struct header.",N,N],[0,"variance","rustc_typeck","Module for inferring the variance of type and lifetime parameters. See the [rustc guide] chapter for more info.",N,N],[5,"provide","rustc_typeck::variance","",N,[[["providers"]]]],[5,"crate_variances","","",N,[[["tyctxt"],["cratenum"]],["lrc",["cratevariancesmap"]]]],[5,"variances_of","","",N,[[["tyctxt"],["defid"]],["lrc",["vec"]]]],[0,"terms","","Defines the `TermsContext` basically houses an arena where we can allocate terms.",N,N],[3,"InferredIndex","rustc_typeck::variance::terms","",N,N],[12,"0","","",88,N],[3,"TermsContext","","",N,N],[12,"tcx","","",89,N],[12,"arena","","",89,N],[12,"lang_items","","",89,N],[12,"inferred_starts","","",89,N],[12,"inferred_terms","","",89,N],[4,"VarianceTerm","","",N,N],[13,"ConstantTerm","","",90,N],[13,"TransformTerm","","",90,N],[13,"InferredTerm","","",90,N],[5,"determine_parameters_to_be_inferred","","",N,[[["tyctxt"],["typedarena"]],["termscontext"]]],[5,"lang_items","","",N,[[["tyctxt"]],["vec"]]],[6,"VarianceTermPtr","","",N,N],[11,"clone","","",88,[[["self"]],["inferredindex"]]],[11,"fmt","","",88,[[["self"],["formatter"]],["result"]]],[11,"clone","","",90,[[["self"]],["varianceterm"]]],[11,"fmt","","",90,[[["self"],["formatter"]],["result"]]],[11,"add_inferreds_for_item","","",89,[[["self"],["nodeid"]]]],[11,"visit_item","","",89,[[["self"],["item"]]]],[11,"visit_trait_item","","",89,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",89,[[["self"],["implitem"]]]],[0,"constraints","rustc_typeck::variance","Code to gather up constraints. Constraint construction and representation",N,N],[3,"ConstraintContext","rustc_typeck::variance::constraints","",N,N],[12,"terms_cx","","",91,N],[12,"covariant","","",91,N],[12,"contravariant","","",91,N],[12,"invariant","","",91,N],[12,"bivariant","","",91,N],[12,"constraints","","",91,N],[3,"Constraint","","Declares that the variable `decl_id` appears in a location with variance `variance`.",N,N],[12,"inferred","","",92,N],[12,"variance","","",92,N],[3,"CurrentItem","","To build constraints, we visit one item (type, trait) at a time and look at its contents. So e.g. if we have",N,N],[12,"inferred_start","","",93,N],[5,"add_constraints_from_crate","","",N,[[["termscontext"]],["constraintcontext"]]],[11,"clone","","",92,[[["self"]],["constraint"]]],[11,"visit_item","","",91,[[["self"],["item"]]]],[11,"visit_trait_item","","",91,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",91,[[["self"],["implitem"]]]],[11,"visit_node_helper","","",91,[[["self"],["nodeid"]]]],[11,"tcx","","",91,[[["self"]],["tyctxt"]]],[11,"build_constraints_for_item","","",91,[[["self"],["defid"]]]],[11,"add_constraint","","",91,[[["self"],["currentitem"],["u32"],["varianceterm"]]]],[11,"contravariant","","",91,[[["self"],["varianceterm"]],["varianceterm"]]],[11,"invariant","","",91,[[["self"],["varianceterm"]],["varianceterm"]]],[11,"constant_term","","",91,[[["self"],["variance"]],["varianceterm"]]],[11,"xform","","",91,[[["self"],["varianceterm"],["varianceterm"]],["varianceterm"]]],[11,"add_constraints_from_trait_ref","","",91,[[["self"],["currentitem"],["traitref"],["varianceterm"]]]],[11,"add_constraints_from_invariant_substs","","",91,[[["self"],["currentitem"],["substs"],["varianceterm"]]]],[11,"add_constraints_from_ty","","Adds constraints appropriate for an instance of `ty` appearing in a context with the generics defined in `generics` and ambient variance `variance`",91,[[["self"],["currentitem"],["ty"],["varianceterm"]]]],[11,"add_constraints_from_substs","","Adds constraints appropriate for a nominal type (enum, struct, object, etc) appearing in a context with ambient variance `variance`",91,[[["self"],["currentitem"],["defid"],["substs"],["varianceterm"]]]],[11,"add_constraints_from_sig","","Adds constraints appropriate for a function with signature `sig` appearing in a context with ambient variance `variance`",91,[[["self"],["currentitem"],["polyfnsig"],["varianceterm"]]]],[11,"add_constraints_from_region","","Adds constraints appropriate for a region appearing in a context with ambient variance `variance`",91,[[["self"],["currentitem"],["region"],["varianceterm"]]]],[11,"add_constraints_from_mt","","Adds constraints appropriate for a mutability-type pair appearing in a context with ambient variance `variance`",91,[[["self"],["currentitem"],["typeandmut"],["varianceterm"]]]],[0,"solve","rustc_typeck::variance","Code to solve constraints and write out the results. Constraint solving",N,N],[3,"SolveContext","rustc_typeck::variance::solve","",N,N],[12,"terms_cx","","",94,N],[12,"constraints","","",94,N],[12,"solutions","","",94,N],[5,"solve_constraints","","",N,[[["constraintcontext"]],["cratevariancesmap"]]],[11,"solve","","",94,[[["self"]]]],[11,"create_map","","",94,[[["self"]],["fxhashmap",["defid","lrc"]]]],[11,"evaluate","","",94,[[["self"],["varianceterm"]],["variance"]]],[0,"test","rustc_typeck::variance","Code to write unit tests of variance.",N,N],[3,"VarianceTest","rustc_typeck::variance::test","",N,N],[12,"tcx","","",95,N],[5,"test_variance","","",N,[[["tyctxt"]]]],[11,"visit_item","","",95,[[["self"],["item"]]]],[11,"visit_trait_item","","",95,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",95,[[["self"],["implitem"]]]],[0,"xform","rustc_typeck::variance","Code for transforming variances.",N,N],[5,"glb","rustc_typeck::variance::xform","",N,[[["variance"],["variance"]],["variance"]]],[17,"DIAGNOSTICS","rustc_typeck","",N,N]],"paths":[[3,"TypeAndSubsts"],[3,"ConvertedBinding"],[3,"ParamRange"],[3,"Bounds"],[8,"AstConv"],[3,"MaybeInProgressTables"],[3,"Inherited"],[3,"UnsafetyState"],[3,"BreakableCtxt"],[3,"EnclosingBreakables"],[3,"FnCtxt"],[3,"InheritedBuilder"],[3,"CheckItemTypesVisitor"],[3,"GatherLocalsVisitor"],[3,"GeneratorTypes"],[4,"Expectation"],[4,"Needs"],[4,"PlaceOp"],[4,"Diverges"],[4,"TupleArgumentsFlag"],[3,"Autoderef"],[4,"AutoderefKind"],[3,"WritebackCx"],[3,"Resolver"],[8,"Locatable"],[3,"RegionCtxt"],[3,"RepeatingScope"],[3,"Subject"],[3,"Coerce"],[3,"CoerceMany"],[4,"Expressions"],[8,"AsCoercionSite"],[3,"MethodCallee"],[3,"NoMatchData"],[4,"MethodError"],[4,"CandidateSource"],[3,"ConfirmContext"],[3,"ConfirmResult"],[3,"IsSuggestion"],[3,"ProbeContext"],[3,"CandidateStep"],[3,"Candidate"],[3,"Pick"],[4,"CandidateKind"],[4,"ProbeResult"],[4,"PickKind"],[4,"Mode"],[4,"ProbeScope"],[3,"TraitInfo"],[3,"UsePlacementFinder"],[3,"InferBorrowKindVisitor"],[3,"InferBorrowKind"],[3,"CheckWfFcxBuilder"],[3,"CheckTypeWellFormedVisitor"],[3,"AdtVariant"],[3,"AdtField"],[3,"CastCheck"],[4,"PointerKind"],[4,"CastError"],[3,"ExpectedSig"],[3,"ClosureSignatures"],[3,"DeferredCallResolution"],[4,"CallStep"],[3,"InteriorVisitor"],[4,"BinOpCategory"],[4,"IsAssign"],[4,"Op"],[3,"CheckVisitor"],[3,"CollectExternCrateVisitor"],[3,"ExternCrateToLint"],[3,"Checker"],[3,"InherentCollect"],[3,"InherentOverlapChecker"],[3,"OrphanChecker"],[3,"UnsafetyChecker"],[3,"ItemCtxt"],[3,"CollectItemTypesVisitor"],[4,"SizedByDefault"],[3,"Parameter"],[3,"ParameterCollector"],[3,"VariadicError"],[3,"SizedUnsizedCastError"],[8,"StructuredDiagnostic"],[3,"ImplWfCheck"],[4,"Namespace"],[3,"ExplicitPredicatesMap"],[3,"InferVisitor"],[3,"OutlivesTest"],[3,"InferredIndex"],[3,"TermsContext"],[4,"VarianceTerm"],[3,"ConstraintContext"],[3,"Constraint"],[3,"CurrentItem"],[3,"SolveContext"],[3,"VarianceTest"]]};
searchIndex["rustdoc"]={"doc":"","items":[[3,"Output","rustdoc","",N,N],[12,"krate","","",0,N],[12,"renderinfo","","",0,N],[12,"passes","","",0,N],[5,"main","","",N,[[]]],[5,"get_args","","",N,[[],["option",["vec"]]]],[5,"stable","","",N,[[["str"],["f"]],["rustcoptgroup"]]],[5,"unstable","","",N,[[["str"],["f"]],["rustcoptgroup"]]],[5,"opts","","",N,[[],["vec",["rustcoptgroup"]]]],[5,"usage","","",N,[[["str"]]]],[5,"main_args","","",N,N],[5,"acquire_input","","Looks inside the command line arguments to extract the relevant input format and files and then generates the necessary rustdoc output for formatting.",N,[[["pathbuf"],["externs"],["edition"],["codegenoptions"],["matches"],["erroroutputtype"],["f"]],["result",["string"]]]],[5,"parse_externs","","Extracts `--extern CRATE=PATH` arguments from `matches` and returns a map mapping crate names to their paths or else an error message.",N,[[["matches"]],["result",["externs","string"]]]],[5,"rust_input","","Interprets the input file as a rust source file, passing it through the compiler all the way through the analysis passes. The rustdoc output is then generated from the cleaned AST of the crate.",N,[[["pathbuf"],["externs"],["edition"],["codegenoptions"],["matches"],["erroroutputtype"],["f"]],["r"]]],[5,"check_deprecated_options","","Prints deprecation warnings for deprecated options",N,[[["matches"],["handler"]]]],[0,"externalfiles","","",N,N],[3,"ExternalHtml","rustdoc::externalfiles","",N,N],[12,"in_header","","Content that will be included inline in the  section of a rendered Markdown file or generated documentation",1,N],[12,"before_content","","Content that will be included inline between  and the content of a rendered Markdown file or generated documentation",1,N],[12,"after_content","","Content that will be included inline between the content and  of a rendered Markdown file or generated documentation",1,N],[4,"LoadStringError","","",N,N],[13,"ReadFail","","",2,N],[13,"BadUtf8","","",2,N],[5,"load_string","","",N,[[["p"],["handler"]],["result",["string","loadstringerror"]]]],[5,"load_external_files","","",N,N],[11,"clone","","",1,[[["self"]],["externalhtml"]]],[11,"load","","",1,N],[0,"clean","rustdoc","This module contains the \"cleaned\" pieces of the AST, and the functions that clean them.",N,N],[3,"Crate","rustdoc::clean","",N,N],[12,"name","","",3,N],[12,"version","","",3,N],[12,"src","","",3,N],[12,"module","","",3,N],[12,"externs","","",3,N],[12,"primitives","","",3,N],[12,"access_levels","","",3,N],[12,"external_traits","","",3,N],[12,"masked_crates","","",3,N],[3,"ExternalCrate","","",N,N],[12,"name","","",4,N],[12,"src","","",4,N],[12,"attrs","","",4,N],[12,"primitives","","",4,N],[12,"keywords","","",4,N],[3,"Item","","Anything with a source location and set of attributes and, optionally, a name. That is, anything that can be documented. This doesn't correspond directly to the AST's concept of an item; it's a strict superset.",N,N],[12,"source","","Stringified span",5,N],[12,"name","","Not everything has a name. E.g., impls",5,N],[12,"attrs","","",5,N],[12,"inner","","",5,N],[12,"visibility","","",5,N],[12,"def_id","","",5,N],[12,"stability","","",5,N],[12,"deprecation","","",5,N],[3,"Module","","",N,N],[12,"items","","",6,N],[12,"is_crate","","",6,N],[3,"ListAttributesIter","","",N,N],[12,"attrs","","",7,N],[12,"current_list","","",7,N],[12,"name","","",7,N],[3,"Attributes","","",N,N],[12,"doc_strings","","",8,N],[12,"other_attrs","","",8,N],[12,"cfg","","",8,N],[12,"span","","",8,N],[12,"links","","map from Rust paths to resolved defs and potential URL fragments",8,N],[3,"Lifetime","","",N,N],[12,"0","","",9,N],[3,"GenericParamDef","","",N,N],[12,"name","","",10,N],[12,"kind","","",10,N],[3,"Generics","","",N,N],[12,"params","","",11,N],[12,"where_predicates","","",11,N],[3,"Method","","",N,N],[12,"generics","","",12,N],[12,"decl","","",12,N],[12,"header","","",12,N],[3,"TyMethod","","",N,N],[12,"header","","",13,N],[12,"decl","","",13,N],[12,"generics","","",13,N],[3,"Function","","",N,N],[12,"decl","","",14,N],[12,"generics","","",14,N],[12,"header","","",14,N],[3,"FnDecl","","",N,N],[12,"inputs","","",15,N],[12,"output","","",15,N],[12,"variadic","","",15,N],[12,"attrs","","",15,N],[3,"Arguments","","",N,N],[12,"values","","",16,N],[3,"Argument","","",N,N],[12,"type_","","",17,N],[12,"name","","",17,N],[3,"Trait","","",N,N],[12,"auto","","",18,N],[12,"unsafety","","",18,N],[12,"items","","",18,N],[12,"generics","","",18,N],[12,"bounds","","",18,N],[12,"is_spotlight","","",18,N],[12,"is_auto","","",18,N],[3,"PolyTrait","","A trait reference, which may have higher ranked lifetimes.",N,N],[12,"trait_","","",19,N],[12,"generic_params","","",19,N],[3,"Struct","","",N,N],[12,"struct_type","","",20,N],[12,"generics","","",20,N],[12,"fields","","",20,N],[12,"fields_stripped","","",20,N],[3,"Union","","",N,N],[12,"struct_type","","",21,N],[12,"generics","","",21,N],[12,"fields","","",21,N],[12,"fields_stripped","","",21,N],[3,"VariantStruct","","This is a more limited form of the standard Struct, different in that it lacks the things most items have (name, id, parameterization). Found only as a variant in an enum.",N,N],[12,"struct_type","","",22,N],[12,"fields","","",22,N],[12,"fields_stripped","","",22,N],[3,"Enum","","",N,N],[12,"variants","","",23,N],[12,"generics","","",23,N],[12,"variants_stripped","","",23,N],[3,"Variant","","",N,N],[12,"kind","","",24,N],[3,"Span","","",N,N],[12,"filename","","",25,N],[12,"loline","","",25,N],[12,"locol","","",25,N],[12,"hiline","","",25,N],[12,"hicol","","",25,N],[3,"Path","","",N,N],[12,"global","","",26,N],[12,"def","","",26,N],[12,"segments","","",26,N],[3,"PathSegment","","",N,N],[12,"name","","",27,N],[12,"args","","",27,N],[3,"Typedef","","",N,N],[12,"type_","","",28,N],[12,"generics","","",28,N],[3,"Existential","","",N,N],[12,"bounds","","",29,N],[12,"generics","","",29,N],[3,"BareFunctionDecl","","",N,N],[12,"unsafety","","",30,N],[12,"generic_params","","",30,N],[12,"decl","","",30,N],[12,"abi","","",30,N],[3,"Static","","",N,N],[12,"type_","","",31,N],[12,"mutability","","",31,N],[12,"expr","","It's useful to have the value of a static documented, but I have no desire to represent expressions (that'd basically be all of the AST, which is huge!). So, have a string.",31,N],[3,"Constant","","",N,N],[12,"type_","","",32,N],[12,"expr","","",32,N],[3,"Impl","","",N,N],[12,"unsafety","","",33,N],[12,"generics","","",33,N],[12,"provided_trait_methods","","",33,N],[12,"trait_","","",33,N],[12,"for_","","",33,N],[12,"items","","",33,N],[12,"polarity","","",33,N],[12,"synthetic","","",33,N],[12,"blanket_impl","","",33,N],[3,"ImportSource","","",N,N],[12,"path","","",34,N],[12,"did","","",34,N],[3,"Macro","","",N,N],[12,"source","","",35,N],[12,"imported_from","","",35,N],[3,"Stability","","",N,N],[12,"level","","",36,N],[12,"feature","","",36,N],[12,"since","","",36,N],[12,"deprecated_since","","",36,N],[12,"deprecated_reason","","",36,N],[12,"unstable_reason","","",36,N],[12,"issue","","",36,N],[3,"Deprecation","","",N,N],[12,"since","","",37,N],[12,"note","","",37,N],[3,"TypeBinding","","An equality constraint on an associated type, e.g. `A=Bar` in `Foo<A=Bar>`",N,N],[12,"name","","",38,N],[12,"ty","","",38,N],[3,"RegionDeps","","",N,N],[12,"larger","","",39,N],[12,"smaller","","",39,N],[4,"ItemEnum","","",N,N],[13,"ExternCrateItem","","",40,N],[13,"ImportItem","","",40,N],[13,"StructItem","","",40,N],[13,"UnionItem","","",40,N],[13,"EnumItem","","",40,N],[13,"FunctionItem","","",40,N],[13,"ModuleItem","","",40,N],[13,"TypedefItem","","",40,N],[13,"ExistentialItem","","",40,N],[13,"StaticItem","","",40,N],[13,"ConstantItem","","",40,N],[13,"TraitItem","","",40,N],[13,"ImplItem","","",40,N],[13,"TyMethodItem","","A method signature only. Used for required methods in traits (ie, non-default-methods).",40,N],[13,"MethodItem","","A method with a body.",40,N],[13,"StructFieldItem","","",40,N],[13,"VariantItem","","",40,N],[13,"ForeignFunctionItem","","`fn`s from an extern block",40,N],[13,"ForeignStaticItem","","`static`s from an extern block",40,N],[13,"ForeignTypeItem","","`type`s from an extern block",40,N],[13,"MacroItem","","",40,N],[13,"PrimitiveItem","","",40,N],[13,"AssociatedConstItem","","",40,N],[13,"AssociatedTypeItem","","",40,N],[13,"StrippedItem","","An item that has been stripped by a rustdoc pass",40,N],[13,"KeywordItem","","",40,N],[4,"DocFragment","","A portion of documentation, extracted from a `#[doc]` attribute.",N,N],[13,"SugaredDoc","","A doc fragment created from a `///` or `//!` doc comment.",41,N],[13,"RawDoc","","A doc fragment created from a \"raw\" `#[doc=\"\"]` attribute.",41,N],[13,"Include","","A doc fragment created from a `#[doc(include=\"filename\")]` attribute. Contains both the given filename and the file contents.",41,N],[4,"PathKind","","",N,N],[13,"Unknown","","can be either value or type, not a macro",42,N],[13,"Macro","","macro",42,N],[13,"Value","","values, functions, consts, statics, everything in the value namespace",42,N],[13,"Type","","types, traits, everything in the type namespace",42,N],[4,"GenericBound","","",N,N],[13,"TraitBound","","",43,N],[13,"Outlives","","",43,N],[4,"WherePredicate","","",N,N],[13,"BoundPredicate","","",44,N],[12,"ty","rustdoc::clean::WherePredicate","",44,N],[12,"bounds","","",44,N],[13,"RegionPredicate","rustdoc::clean","",44,N],[12,"lifetime","rustdoc::clean::WherePredicate","",44,N],[12,"bounds","","",44,N],[13,"EqPredicate","rustdoc::clean","",44,N],[12,"lhs","rustdoc::clean::WherePredicate","",44,N],[12,"rhs","","",44,N],[4,"GenericParamDefKind","rustdoc::clean","",N,N],[13,"Lifetime","","",45,N],[13,"Type","","",45,N],[12,"did","rustdoc::clean::GenericParamDefKind","",45,N],[12,"bounds","","",45,N],[12,"default","","",45,N],[12,"synthetic","","",45,N],[4,"SelfTy","rustdoc::clean","",N,N],[13,"SelfValue","","",46,N],[13,"SelfBorrowed","","",46,N],[13,"SelfExplicit","","",46,N],[4,"FunctionRetTy","","",N,N],[13,"Return","","",47,N],[13,"DefaultReturn","","",47,N],[4,"Type","","A representation of a Type suitable for hyperlinking purposes. Ideally one can get the original type out of the AST/TyCtxt given one of these, if more information is needed. Most importantly it does not preserve mutability or boxes.",N,N],[13,"ResolvedPath","","structs/enums/traits (most that'd be an hir::TyKind::Path)",48,N],[12,"path","rustdoc::clean::Type","",48,N],[12,"typarams","","",48,N],[12,"did","","",48,N],[12,"is_generic","","true if is a `T::Name` path for associated types",48,N],[13,"Generic","rustdoc::clean","For parameterized types, so the consumer of the JSON don't go looking for types which don't exist anywhere.",48,N],[13,"Primitive","","Primitives are the fixed-size numeric types (plus int/usize/float), char, arrays, slices, and tuples.",48,N],[13,"BareFunction","","extern \"ABI\" fn",48,N],[13,"Tuple","","",48,N],[13,"Slice","","",48,N],[13,"Array","","",48,N],[13,"Never","","",48,N],[13,"Unique","","",48,N],[13,"RawPointer","","",48,N],[13,"BorrowedRef","","",48,N],[12,"lifetime","rustdoc::clean::Type","",48,N],[12,"mutability","","",48,N],[12,"type_","","",48,N],[13,"QPath","rustdoc::clean","",48,N],[12,"name","rustdoc::clean::Type","",48,N],[12,"self_type","","",48,N],[12,"trait_","","",48,N],[13,"Infer","rustdoc::clean","",48,N],[13,"ImplTrait","","",48,N],[4,"PrimitiveType","","",N,N],[13,"Isize","","",49,N],[13,"I8","","",49,N],[13,"I16","","",49,N],[13,"I32","","",49,N],[13,"I64","","",49,N],[13,"I128","","",49,N],[13,"Usize","","",49,N],[13,"U8","","",49,N],[13,"U16","","",49,N],[13,"U32","","",49,N],[13,"U64","","",49,N],[13,"U128","","",49,N],[13,"F32","","",49,N],[13,"F64","","",49,N],[13,"Char","","",49,N],[13,"Bool","","",49,N],[13,"Str","","",49,N],[13,"Slice","","",49,N],[13,"Array","","",49,N],[13,"Tuple","","",49,N],[13,"Unit","","",49,N],[13,"RawPointer","","",49,N],[13,"Reference","","",49,N],[13,"Fn","","",49,N],[13,"Never","","",49,N],[4,"TypeKind","","",N,N],[13,"Enum","","",50,N],[13,"Function","","",50,N],[13,"Module","","",50,N],[13,"Const","","",50,N],[13,"Static","","",50,N],[13,"Struct","","",50,N],[13,"Union","","",50,N],[13,"Trait","","",50,N],[13,"Variant","","",50,N],[13,"Typedef","","",50,N],[13,"Foreign","","",50,N],[13,"Macro","","",50,N],[4,"Visibility","","",N,N],[13,"Public","","",51,N],[13,"Inherited","","",51,N],[13,"Crate","","",51,N],[13,"Restricted","","",51,N],[4,"VariantKind","","",N,N],[13,"CLike","","",52,N],[13,"Tuple","","",52,N],[13,"Struct","","",52,N],[4,"GenericArgs","","",N,N],[13,"AngleBracketed","","",53,N],[12,"lifetimes","rustdoc::clean::GenericArgs","",53,N],[12,"types","","",53,N],[12,"bindings","","",53,N],[13,"Parenthesized","rustdoc::clean","",53,N],[12,"inputs","rustdoc::clean::GenericArgs","",53,N],[12,"output","","",53,N],[4,"Mutability","rustdoc::clean","",N,N],[13,"Mutable","","",54,N],[13,"Immutable","","",54,N],[4,"ImplPolarity","","",N,N],[13,"Positive","","",55,N],[13,"Negative","","",55,N],[4,"Import","","",N,N],[13,"Simple","","",56,N],[13,"Glob","","",56,N],[4,"RegionTarget","","",N,N],[13,"Region","","",57,N],[13,"RegionVid","","",57,N],[4,"SimpleBound","","",N,N],[13,"TraitBound","","",58,N],[13,"Outlives","","",58,N],[4,"AutoTraitResult","","",N,N],[13,"ExplicitImpl","","",59,N],[13,"PositiveImpl","","",59,N],[13,"NegativeImpl","","",59,N],[5,"get_stability","","",N,[[["doccontext"],["defid"]],["option",["stability"]]]],[5,"get_deprecation","","",N,[[["doccontext"],["defid"]],["option",["deprecation"]]]],[5,"value_ns_kind","","Given a def, returns its name and disambiguator for a value namespace",N,[[["def"],["str"]],["option"]]],[5,"type_ns_kind","","Given a def, returns its name, the article to be used, and a disambiguator for the type namespace",N,N],[5,"span_of_attrs","","",N,[[["attributes"]],["span"]]],[5,"ambiguity_error","","",N,[[["doccontext"],["attributes"],["str"],["str"],["str"],["str"],["str"],["str"],["str"]]]],[5,"handle_variant","","Given an enum variant's def, return the def of its enum and the associated fragment",N,[[["doccontext"],["def"]],["result"]]],[5,"is_primitive","","",N,[[["str"],["bool"]],["option",["def"]]]],[5,"resolve","","Resolve a given string as a path, along with whether or not it is in the value namespace. Also returns an optional URL fragment in the case of variants and methods",N,[[["doccontext"],["str"],["bool"]],["result"]]],[5,"macro_resolve","","Resolve a string as a macro",N,[[["doccontext"],["str"]],["option",["def"]]]],[5,"resolution_failure","","",N,[[["doccontext"],["attributes"],["str"],["str"],["option",["range"]]]]],[5,"external_generic_args","","",N,[[["doccontext"],["option",["defid"]],["bool"],["vec",["typebinding"]],["substs"]],["genericargs"]]],[5,"external_path","","",N,[[["doccontext"],["str"],["option",["defid"]],["bool"],["vec",["typebinding"]],["substs"]],["path"]]],[5,"strip_type","","",N,[[["type"]],["type"]]],[5,"strip_path","","",N,[[["path"]],["path"]]],[5,"qpath_to_string","","",N,[[["qpath"]],["string"]]],[5,"get_auto_traits_with_node_id","","",N,[[["doccontext"],["nodeid"],["string"]],["vec",["item"]]]],[5,"get_auto_traits_with_def_id","","",N,[[["doccontext"],["defid"]],["vec",["item"]]]],[5,"get_name_if_possible","","",N,[[["doccontext"],["nodeid"]],["option",["name"]]]],[5,"build_deref_target_impls","","",N,N],[5,"name_from_pat","","",N,[[["pat"]],["string"]]],[5,"print_const","","",N,[[["doccontext"],["const"]],["string"]]],[5,"print_const_expr","","",N,[[["doccontext"],["bodyid"]],["string"]]],[5,"resolve_type","","Given a type Path, resolve it to a Type using the TyCtxt",N,[[["doccontext"],["path"],["nodeid"]],["type"]]],[5,"register_def","","",N,[[["doccontext"],["def"]],["defid"]]],[5,"resolve_use_source","","",N,[[["doccontext"],["path"]],["importsource"]]],[5,"def_id_to_path","","",N,[[["doccontext"],["defid"],["option",["string"]]],["vec",["string"]]]],[5,"enter_impl_trait","","",N,[[["doccontext"],["f"]],["r"]]],[5,"path_to_def_local","","",N,N],[5,"path_to_def","","",N,N],[5,"get_path_for_type","","",N,[[["tyctxt"],["defid"],["f"]],["path"]]],[0,"inline","","Support for inlining external documentation into the current AST.",N,N],[5,"try_inline","rustdoc::clean::inline","Attempt to inline a definition into this AST.",N,[[["doccontext"],["def"],["name"],["fxhashset"]],["option",["vec"]]]],[5,"try_inline_glob","","",N,[[["doccontext"],["def"],["fxhashset"]],["option",["vec"]]]],[5,"load_attrs","","",N,[[["doccontext"],["defid"]],["attributes"]]],[5,"record_extern_fqn","","Record an external fully qualified name in the external_paths cache.",N,[[["doccontext"],["defid"],["typekind"]]]],[5,"build_external_trait","","",N,[[["doccontext"],["defid"]],["trait"]]],[5,"build_external_function","","",N,[[["doccontext"],["defid"]],["function"]]],[5,"build_enum","","",N,[[["doccontext"],["defid"]],["enum"]]],[5,"build_struct","","",N,[[["doccontext"],["defid"]],["struct"]]],[5,"build_union","","",N,[[["doccontext"],["defid"]],["union"]]],[5,"build_type_alias","","",N,[[["doccontext"],["defid"]],["typedef"]]],[5,"build_impls","","",N,[[["doccontext"],["defid"],["bool"]],["vec",["item"]]]],[5,"build_impl","","",N,[[["doccontext"],["defid"],["vec"]]]],[5,"build_module","","",N,[[["doccontext"],["defid"],["fxhashset"]],["module"]]],[5,"print_inlined_const","","",N,[[["doccontext"],["defid"]],["string"]]],[5,"build_const","","",N,[[["doccontext"],["defid"]],["constant"]]],[5,"build_static","","",N,[[["doccontext"],["defid"],["bool"]],["static"]]],[5,"build_macro","","",N,[[["doccontext"],["defid"],["name"]],["option",["macro"]]]],[5,"filter_non_trait_generics","","A trait's generics clause actually contains all of the predicates for all of its associated types as well. We specifically move these clauses to the associated types instead when displaying, so when we're generating the generics for the trait itself we need to be sure to remove them. We also need to remove the implied \"recursive\" Self: Trait bound.",N,[[["defid"],["generics"]],["generics"]]],[5,"separate_supertrait_bounds","","Supertrait bounds for a trait are also listed in the generics coming from the metadata for a crate, so we want to separate those out and create a new list of explicit supertrait bounds to render nicely.",N,N],[5,"record_extern_trait","","",N,[[["doccontext"],["defid"]]]],[0,"cfg","rustdoc::clean","Representation of a `#[doc(cfg(...))]` attribute.",N,N],[3,"InvalidCfgError","rustdoc::clean::cfg","",N,N],[12,"msg","","",60,N],[12,"span","","",60,N],[3,"Html","","Pretty-print wrapper for a `Cfg`. Also indicates whether the \"short-form\" rendering should be used.",N,N],[12,"0","","",61,N],[12,"1","","",61,N],[4,"Cfg","","",N,N],[13,"True","","Accepts all configurations.",62,N],[13,"False","","Denies all configurations.",62,N],[13,"Cfg","","A generic configration option, e.g. `test` or `target_os = \"linux\"`.",62,N],[13,"Not","","Negate a configuration requirement, i.e. `not(x)`.",62,N],[13,"Any","","Union of a list of configuration requirements, i.e. `any(...)`.",62,N],[13,"All","","Intersection of a list of configuration requirements, i.e. `all(...)`.",62,N],[5,"write_with_opt_paren","","",N,[[["formatter"],["bool"],["t"]],["result"]]],[11,"clone","","",62,[[["self"]],["cfg"]]],[11,"encode","","",62,[[["self"],["__s"]],["result"]]],[11,"decode","","",62,[[["__d"]],["result",["cfg"]]]],[11,"fmt","","",62,[[["self"],["formatter"]],["result"]]],[11,"eq","","",62,[[["self"],["cfg"]],["bool"]]],[11,"ne","","",62,[[["self"],["cfg"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",62,N],[11,"hash","","",62,N],[11,"eq","","",60,[[["self"],["invalidcfgerror"]],["bool"]]],[11,"ne","","",60,[[["self"],["invalidcfgerror"]],["bool"]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"parse_nested","","Parses a `NestedMetaItem` into a `Cfg`.",62,[[["nestedmetaitem"]],["result",["cfg","invalidcfgerror"]]]],[11,"parse","","Parses a `MetaItem` into a `Cfg`.",62,[[["metaitem"]],["result",["cfg","invalidcfgerror"]]]],[11,"matches","","Checks whether the given configuration can be matched in the current session.",62,[[["self"],["parsesess"],["option",["features"]]],["bool"]]],[11,"is_simple","","Whether the configuration consists of just `Cfg` or `Not`.",62,[[["self"]],["bool"]]],[11,"is_all","","Whether the configuration consists of just `Cfg`, `Not` or `All`.",62,[[["self"]],["bool"]]],[11,"render_short_html","","Renders the configuration for human display, as a short HTML description.",62,[[["self"]],["string"]]],[11,"render_long_html","","Renders the configuration for long display, as a long HTML description.",62,[[["self"]],["string"]]],[11,"should_capitalize_first_letter","","",62,[[["self"]],["bool"]]],[11,"should_append_only_to_description","","",62,[[["self"]],["bool"]]],[11,"should_use_with_in_description","","",62,[[["self"]],["bool"]]],[11,"not","","",62,[[["self"]],["cfg"]]],[11,"bitand_assign","","",62,[[["self"],["cfg"]]]],[11,"bitand","","",62,[[["self"],["cfg"]],["cfg"]]],[11,"bitor_assign","","",62,[[["self"],["cfg"]]]],[11,"bitor","","",62,[[["self"],["cfg"]],["cfg"]]],[11,"fmt","","",61,[[["self"],["formatter"]],["result"]]],[0,"simplify","rustdoc::clean","Simplification of where clauses and parameter bounds into a prettier and more canonical form.",N,N],[5,"where_clauses","rustdoc::clean::simplify","",N,[[["doccontext"],["vec",["wp"]]],["vec",["wp"]]]],[5,"ty_params","","",N,[[["vec",["genericparamdef"]]],["vec",["genericparamdef"]]]],[5,"ty_bounds","","",N,[[["vec",["genericbound"]]],["vec",["genericbound"]]]],[5,"trait_is_same_or_supertrait","","",N,[[["doccontext"],["defid"],["defid"]],["bool"]]],[0,"auto_trait","rustdoc::clean","",N,N],[3,"AutoTraitFinder","rustdoc::clean::auto_trait","",N,N],[12,"cx","","",63,N],[12,"f","","",63,N],[3,"RegionReplacer","","",N,N],[12,"vid_to_region","","",64,N],[12,"tcx","","",64,N],[11,"new","","",63,[[["doccontext"]],["self"]]],[11,"get_with_def_id","","",63,[[["self"],["defid"]],["vec",["item"]]]],[11,"get_with_node_id","","",63,[[["self"],["nodeid"],["string"]],["vec",["item"]]]],[11,"get_real_ty","","",63,[[["self"],["defid"],["f"],["option"],["generics"]],["ty"]]],[11,"get_auto_trait_impls","","",63,[[["self"],["defid"],["f"],["option",["string"]]],["vec",["item"]]]],[11,"get_auto_trait_impl_for","","",63,[[["self"],["defid"],["option",["string"]],["generics"],["f"],["defid"]],["option",["item"]]]],[11,"generics_to_path_params","","",63,[[["self"],["generics"]],["genericargs"]]],[11,"ty_param_to_ty","","",63,[[["self"],["genericparamdef"]],["ty"]]],[11,"find_auto_trait_generics","","",63,[[["self"],["defid"],["defid"],["generics"]],["autotraitresult"]]],[11,"get_lifetime","","",63,[[["self"],["region"],["fxhashmap"]],["lifetime"]]],[11,"region_name","","",63,[[["self"],["region"]],["option",["string"]]]],[11,"handle_lifetimes","","",63,[[["self"],["regionconstraintdata"],["fxhashmap"]],["vec",["wherepredicate"]]]],[11,"extract_for_generics","","",63,[[["self"],["tyctxt"],["predicate"]],["fxhashset",["genericparamdef"]]]],[11,"make_final_bounds","","",63,[[["self"],["fxhashmap",["type","fxhashset"]],["fxhashmap",["type"]],["fxhashmap",["lifetime","fxhashset"]]],["vec",["wherepredicate"]]]],[11,"param_env_to_generics","","",63,[[["self"],["tyctxt"],["defid"],["paramenv"],["generics"],["vec",["wherepredicate"]],["fxhashmap",["regionvid","region"]]],["generics"]]],[11,"sort_where_predicates","","",63,[[["self"],["vec"]]]],[11,"sort_where_bounds","","",63,[[["self"],["vec"]]]],[11,"unstable_debug_sort","","",63,[[["self"],["vec"]]]],[11,"is_fn_ty","","",63,[[["self"],["tyctxt"],["type"]],["bool"]]],[11,"next_def_id","","",63,[[["self"],["cratenum"]],["defid"]]],[11,"tcx","","",64,[[["self"]],["tyctxt"]]],[11,"fold_region","","",64,[[["self"],["region"]],["region"]]],[17,"MAX_DEF_ID","rustdoc::clean","",N,N],[17,"FN_OUTPUT_NAME","","",N,N],[17,"PRIMITIVES","","",N,N],[8,"Clean","","",N,N],[10,"clean","","",65,[[["self"],["doccontext"]],["t"]]],[8,"AttributesExt","","",N,N],[10,"lists","","Finds an attribute as List and returns the list of attributes nested inside.",66,[[["self"],["str"]],["listattributesiter"]]],[8,"NestedAttributesExt","","",N,N],[10,"has_word","","Returns whether the attribute list contains a specific `Word`",67,[[["self"],["str"]],["bool"]]],[8,"GetDefId","","",N,N],[10,"def_id","","",68,[[["self"]],["option",["defid"]]]],[8,"ToSource","","",N,N],[10,"to_src","","",69,[[["self"],["doccontext"]],["string"]]],[11,"clone","","",3,[[["self"]],["crate"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["externalcrate"]]],[11,"encode","","",4,[[["self"],["__s"]],["result"]]],[11,"decode","","",4,[[["__d"]],["result",["externalcrate"]]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",5,[[["self"]],["item"]]],[11,"encode","","",5,[[["self"],["__s"]],["result"]]],[11,"decode","","",5,[[["__d"]],["result",["item"]]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"doc_value","","Finds the `doc` attribute as a NameValue and returns the corresponding value found.",5,[[["self"]],["option",["str"]]]],[11,"collapsed_doc_value","","Finds all `doc` attributes as NameValues and returns their corresponding values, joined with newlines.",5,[[["self"]],["option",["string"]]]],[11,"links","","",5,[[["self"]],["vec"]]],[11,"is_crate","","",5,[[["self"]],["bool"]]],[11,"is_mod","","",5,[[["self"]],["bool"]]],[11,"is_trait","","",5,[[["self"]],["bool"]]],[11,"is_struct","","",5,[[["self"]],["bool"]]],[11,"is_enum","","",5,[[["self"]],["bool"]]],[11,"is_associated_type","","",5,[[["self"]],["bool"]]],[11,"is_associated_const","","",5,[[["self"]],["bool"]]],[11,"is_method","","",5,[[["self"]],["bool"]]],[11,"is_ty_method","","",5,[[["self"]],["bool"]]],[11,"is_typedef","","",5,[[["self"]],["bool"]]],[11,"is_primitive","","",5,[[["self"]],["bool"]]],[11,"is_union","","",5,[[["self"]],["bool"]]],[11,"is_import","","",5,[[["self"]],["bool"]]],[11,"is_extern_crate","","",5,[[["self"]],["bool"]]],[11,"is_keyword","","",5,[[["self"]],["bool"]]],[11,"is_stripped","","",5,[[["self"]],["bool"]]],[11,"has_stripped_fields","","",5,[[["self"]],["option",["bool"]]]],[11,"stability_class","","",5,[[["self"]],["option",["string"]]]],[11,"stable_since","","",5,[[["self"]],["option",["str"]]]],[11,"is_non_exhaustive","","",5,[[["self"]],["bool"]]],[11,"type_","","Returns a documentation-level item type from the item.",5,[[["self"]],["itemtype"]]],[11,"clone","","",40,[[["self"]],["itemenum"]]],[11,"encode","","",40,[[["self"],["__s"]],["result"]]],[11,"decode","","",40,[[["__d"]],["result",["itemenum"]]]],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"generics","","",40,[[["self"]],["option",["generics"]]]],[11,"clone","","",6,[[["self"]],["module"]]],[11,"encode","","",6,[[["self"],["__s"]],["result"]]],[11,"decode","","",6,[[["__d"]],["result",["module"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"next","","",7,[[["self"]],["option"]]],[11,"size_hint","","",7,N],[11,"clone","","",41,[[["self"]],["docfragment"]]],[11,"encode","","",41,[[["self"],["__s"]],["result"]]],[11,"decode","","",41,[[["__d"]],["result",["docfragment"]]]],[11,"eq","","",41,[[["self"],["docfragment"]],["bool"]]],[11,"ne","","",41,[[["self"],["docfragment"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",41,N],[11,"fmt","","",41,[[["self"],["formatter"]],["result"]]],[11,"hash","","",41,N],[11,"as_str","","",41,[[["self"]],["str"]]],[11,"span","","",41,[[["self"]],["span"]]],[11,"clone","","",8,[[["self"]],["attributes"]]],[11,"encode","","",8,[[["self"],["__s"]],["result"]]],[11,"decode","","",8,[[["__d"]],["result",["attributes"]]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"default","","",8,[[],["attributes"]]],[11,"extract_cfg","","Extracts the content from an attribute `#[doc(cfg(content))]`.",8,[[["metaitem"]],["option",["metaitem"]]]],[11,"extract_include","","Reads a `MetaItem` from within an attribute, looks for whether it is a `#[doc(include=\"file\")]`, and returns the filename and contents of the file as loaded from its expansion.",8,[[["metaitem"]],["option"]]],[11,"has_doc_flag","","",8,[[["self"],["str"]],["bool"]]],[11,"from_ast","","",8,N],[11,"doc_value","","Finds the `doc` attribute as a NameValue and returns the corresponding value found.",8,[[["self"]],["option",["str"]]]],[11,"collapsed_doc_value","","Finds all `doc` attributes as NameValues and returns their corresponding values, joined with newlines.",8,[[["self"]],["option",["string"]]]],[11,"links","","Get links as a vector",8,[[["self"],["cratenum"]],["vec"]]],[11,"eq","","",8,[[["self"],["self"]],["bool"]]],[11,"hash","","",8,[[["self"],["h"]]]],[11,"lists","","",8,[[["self"],["str"]],["listattributesiter"]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"clone","","",43,[[["self"]],["genericbound"]]],[11,"encode","","",43,[[["self"],["__s"]],["result"]]],[11,"decode","","",43,[[["__d"]],["result",["genericbound"]]]],[11,"eq","","",43,[[["self"],["genericbound"]],["bool"]]],[11,"ne","","",43,[[["self"],["genericbound"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",43,N],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"hash","","",43,N],[11,"maybe_sized","","",43,[[["doccontext"]],["genericbound"]]],[11,"is_sized_bound","","",43,[[["self"],["doccontext"]],["bool"]]],[11,"get_poly_trait","","",43,[[["self"]],["option",["polytrait"]]]],[11,"get_trait_type","","",43,[[["self"]],["option",["type"]]]],[11,"clone","","",9,[[["self"]],["lifetime"]]],[11,"encode","","",9,[[["self"],["__s"]],["result"]]],[11,"decode","","",9,[[["__d"]],["result",["lifetime"]]]],[11,"eq","","",9,[[["self"],["lifetime"]],["bool"]]],[11,"ne","","",9,[[["self"],["lifetime"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"hash","","",9,N],[11,"get_ref","","",9,[[["self"]],["str"]]],[11,"statik","","",9,[[],["lifetime"]]],[11,"clone","","",44,[[["self"]],["wherepredicate"]]],[11,"encode","","",44,[[["self"],["__s"]],["result"]]],[11,"decode","","",44,[[["__d"]],["result",["wherepredicate"]]]],[11,"eq","","",44,[[["self"],["wherepredicate"]],["bool"]]],[11,"ne","","",44,[[["self"],["wherepredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",44,N],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"hash","","",44,N],[11,"clone","","",45,[[["self"]],["genericparamdefkind"]]],[11,"encode","","",45,[[["self"],["__s"]],["result"]]],[11,"decode","","",45,[[["__d"]],["result",["genericparamdefkind"]]]],[11,"eq","","",45,[[["self"],["genericparamdefkind"]],["bool"]]],[11,"ne","","",45,[[["self"],["genericparamdefkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",45,N],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"hash","","",45,N],[11,"clone","","",10,[[["self"]],["genericparamdef"]]],[11,"encode","","",10,[[["self"],["__s"]],["result"]]],[11,"decode","","",10,[[["__d"]],["result",["genericparamdef"]]]],[11,"eq","","",10,[[["self"],["genericparamdef"]],["bool"]]],[11,"ne","","",10,[[["self"],["genericparamdef"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"hash","","",10,N],[11,"is_synthetic_type_param","","",10,[[["self"]],["bool"]]],[11,"clone","","",11,[[["self"]],["generics"]]],[11,"encode","","",11,[[["self"],["__s"]],["result"]]],[11,"decode","","",11,[[["__d"]],["result",["generics"]]]],[11,"eq","","",11,[[["self"],["generics"]],["bool"]]],[11,"ne","","",11,[[["self"],["generics"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",11,N],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"default","","",11,[[],["generics"]]],[11,"hash","","",11,N],[11,"clone","","",12,[[["self"]],["method"]]],[11,"encode","","",12,[[["self"],["__s"]],["result"]]],[11,"decode","","",12,[[["__d"]],["result",["method"]]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"clone","","",13,[[["self"]],["tymethod"]]],[11,"encode","","",13,[[["self"],["__s"]],["result"]]],[11,"decode","","",13,[[["__d"]],["result",["tymethod"]]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"clone","","",14,[[["self"]],["function"]]],[11,"encode","","",14,[[["self"],["__s"]],["result"]]],[11,"decode","","",14,[[["__d"]],["result",["function"]]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"clone","","",15,[[["self"]],["fndecl"]]],[11,"encode","","",15,[[["self"],["__s"]],["result"]]],[11,"decode","","",15,[[["__d"]],["result",["fndecl"]]]],[11,"eq","","",15,[[["self"],["fndecl"]],["bool"]]],[11,"ne","","",15,[[["self"],["fndecl"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",15,N],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"hash","","",15,N],[11,"self_type","","",15,[[["self"]],["option",["selfty"]]]],[11,"clone","","",16,[[["self"]],["arguments"]]],[11,"encode","","",16,[[["self"],["__s"]],["result"]]],[11,"decode","","",16,[[["__d"]],["result",["arguments"]]]],[11,"eq","","",16,[[["self"],["arguments"]],["bool"]]],[11,"ne","","",16,[[["self"],["arguments"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",16,N],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"hash","","",16,N],[11,"clone","","",17,[[["self"]],["argument"]]],[11,"encode","","",17,[[["self"],["__s"]],["result"]]],[11,"decode","","",17,[[["__d"]],["result",["argument"]]]],[11,"eq","","",17,[[["self"],["argument"]],["bool"]]],[11,"ne","","",17,[[["self"],["argument"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"hash","","",17,N],[11,"clone","","",46,[[["self"]],["selfty"]]],[11,"encode","","",46,[[["self"],["__s"]],["result"]]],[11,"decode","","",46,[[["__d"]],["result",["selfty"]]]],[11,"eq","","",46,[[["self"],["selfty"]],["bool"]]],[11,"ne","","",46,[[["self"],["selfty"]],["bool"]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"to_self","","",17,[[["self"]],["option",["selfty"]]]],[11,"clone","","",47,[[["self"]],["functionretty"]]],[11,"encode","","",47,[[["self"],["__s"]],["result"]]],[11,"decode","","",47,[[["__d"]],["result",["functionretty"]]]],[11,"eq","","",47,[[["self"],["functionretty"]],["bool"]]],[11,"ne","","",47,[[["self"],["functionretty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",47,N],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"hash","","",47,N],[11,"def_id","","",47,[[["self"]],["option",["defid"]]]],[11,"clone","","",18,[[["self"]],["trait"]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[11,"decode","","",18,[[["__d"]],["result",["trait"]]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",19,[[["self"]],["polytrait"]]],[11,"encode","","",19,[[["self"],["__s"]],["result"]]],[11,"decode","","",19,[[["__d"]],["result",["polytrait"]]]],[11,"eq","","",19,[[["self"],["polytrait"]],["bool"]]],[11,"ne","","",19,[[["self"],["polytrait"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"hash","","",19,N],[11,"clone","","",48,[[["self"]],["type"]]],[11,"encode","","",48,[[["self"],["__s"]],["result"]]],[11,"decode","","",48,[[["__d"]],["result",["type"]]]],[11,"eq","","",48,[[["self"],["type"]],["bool"]]],[11,"ne","","",48,[[["self"],["type"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",48,N],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"hash","","",48,N],[11,"clone","","",49,[[["self"]],["primitivetype"]]],[11,"encode","","",49,[[["self"],["__s"]],["result"]]],[11,"decode","","",49,[[["__d"]],["result",["primitivetype"]]]],[11,"eq","","",49,[[["self"],["primitivetype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",49,N],[11,"hash","","",49,N],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"clone","","",50,[[["self"]],["typekind"]]],[11,"encode","","",50,[[["self"],["__s"]],["result"]]],[11,"decode","","",50,[[["__d"]],["result",["typekind"]]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"primitive_type","","",48,[[["self"]],["option",["primitivetype"]]]],[11,"is_generic","","",48,[[["self"]],["bool"]]],[11,"is_self_type","","",48,[[["self"]],["bool"]]],[11,"generics","","",48,[[["self"]],["option"]]],[11,"def_id","","",48,[[["self"]],["option",["defid"]]]],[11,"from_str","","",49,[[["str"]],["option",["primitivetype"]]]],[11,"as_str","","",49,[[["self"]],["str"]]],[11,"to_url_str","","",49,[[["self"]],["str"]]],[11,"from","","",49,[[["intty"]],["primitivetype"]]],[11,"from","","",49,[[["uintty"]],["primitivetype"]]],[11,"from","","",49,[[["floatty"]],["primitivetype"]]],[11,"clone","","",51,[[["self"]],["visibility"]]],[11,"eq","","",51,[[["self"],["visibility"]],["bool"]]],[11,"ne","","",51,[[["self"],["visibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",51,N],[11,"decode","","",51,[[["__d"]],["result",["visibility"]]]],[11,"encode","","",51,[[["self"],["__s"]],["result"]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"clone","","",20,[[["self"]],["struct"]]],[11,"encode","","",20,[[["self"],["__s"]],["result"]]],[11,"decode","","",20,[[["__d"]],["result",["struct"]]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"clone","","",21,[[["self"]],["union"]]],[11,"encode","","",21,[[["self"],["__s"]],["result"]]],[11,"decode","","",21,[[["__d"]],["result",["union"]]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"clone","","",22,[[["self"]],["variantstruct"]]],[11,"encode","","",22,[[["self"],["__s"]],["result"]]],[11,"decode","","",22,[[["__d"]],["result",["variantstruct"]]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",23,[[["self"]],["enum"]]],[11,"encode","","",23,[[["self"],["__s"]],["result"]]],[11,"decode","","",23,[[["__d"]],["result",["enum"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"clone","","",24,[[["self"]],["variant"]]],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[11,"decode","","",24,[[["__d"]],["result",["variant"]]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"clone","","",52,[[["self"]],["variantkind"]]],[11,"encode","","",52,[[["self"],["__s"]],["result"]]],[11,"decode","","",52,[[["__d"]],["result",["variantkind"]]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"clone","","",25,[[["self"]],["span"]]],[11,"encode","","",25,[[["self"],["__s"]],["result"]]],[11,"decode","","",25,[[["__d"]],["result",["span"]]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"empty","","",25,[[],["span"]]],[11,"clone","","",26,[[["self"]],["path"]]],[11,"encode","","",26,[[["self"],["__s"]],["result"]]],[11,"decode","","",26,[[["__d"]],["result",["path"]]]],[11,"eq","","",26,[[["self"],["path"]],["bool"]]],[11,"ne","","",26,[[["self"],["path"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",26,N],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"hash","","",26,N],[11,"last_name","","",26,[[["self"]],["str"]]],[11,"clone","","",53,[[["self"]],["genericargs"]]],[11,"encode","","",53,[[["self"],["__s"]],["result"]]],[11,"decode","","",53,[[["__d"]],["result",["genericargs"]]]],[11,"eq","","",53,[[["self"],["genericargs"]],["bool"]]],[11,"ne","","",53,[[["self"],["genericargs"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",53,N],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"hash","","",53,N],[11,"clone","","",27,[[["self"]],["pathsegment"]]],[11,"encode","","",27,[[["self"],["__s"]],["result"]]],[11,"decode","","",27,[[["__d"]],["result",["pathsegment"]]]],[11,"eq","","",27,[[["self"],["pathsegment"]],["bool"]]],[11,"ne","","",27,[[["self"],["pathsegment"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",27,N],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"hash","","",27,N],[11,"clone","","",28,[[["self"]],["typedef"]]],[11,"encode","","",28,[[["self"],["__s"]],["result"]]],[11,"decode","","",28,[[["__d"]],["result",["typedef"]]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"clone","","",29,[[["self"]],["existential"]]],[11,"encode","","",29,[[["self"],["__s"]],["result"]]],[11,"decode","","",29,[[["__d"]],["result",["existential"]]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"clone","","",30,[[["self"]],["barefunctiondecl"]]],[11,"encode","","",30,[[["self"],["__s"]],["result"]]],[11,"decode","","",30,[[["__d"]],["result",["barefunctiondecl"]]]],[11,"eq","","",30,[[["self"],["barefunctiondecl"]],["bool"]]],[11,"ne","","",30,[[["self"],["barefunctiondecl"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",30,N],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"hash","","",30,N],[11,"clone","","",31,[[["self"]],["static"]]],[11,"encode","","",31,[[["self"],["__s"]],["result"]]],[11,"decode","","",31,[[["__d"]],["result",["static"]]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"clone","","",32,[[["self"]],["constant"]]],[11,"encode","","",32,[[["self"],["__s"]],["result"]]],[11,"decode","","",32,[[["__d"]],["result",["constant"]]]],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"clone","","",54,[[["self"]],["mutability"]]],[11,"encode","","",54,[[["self"],["__s"]],["result"]]],[11,"decode","","",54,[[["__d"]],["result",["mutability"]]]],[11,"eq","","",54,[[["self"],["mutability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",54,N],[11,"hash","","",54,N],[11,"clone","","",55,[[["self"]],["implpolarity"]]],[11,"encode","","",55,[[["self"],["__s"]],["result"]]],[11,"decode","","",55,[[["__d"]],["result",["implpolarity"]]]],[11,"eq","","",55,[[["self"],["implpolarity"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",55,N],[11,"fmt","","",55,[[["self"],["formatter"]],["result"]]],[11,"hash","","",55,N],[11,"clone","","",33,[[["self"]],["impl"]]],[11,"encode","","",33,[[["self"],["__s"]],["result"]]],[11,"decode","","",33,[[["__d"]],["result",["impl"]]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"clone","","",56,[[["self"]],["import"]]],[11,"encode","","",56,[[["self"],["__s"]],["result"]]],[11,"decode","","",56,[[["__d"]],["result",["import"]]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"clone","","",34,[[["self"]],["importsource"]]],[11,"encode","","",34,[[["self"],["__s"]],["result"]]],[11,"decode","","",34,[[["__d"]],["result",["importsource"]]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"clone","","",35,[[["self"]],["macro"]]],[11,"encode","","",35,[[["self"],["__s"]],["result"]]],[11,"decode","","",35,[[["__d"]],["result",["macro"]]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"clone","","",36,[[["self"]],["stability"]]],[11,"encode","","",36,[[["self"],["__s"]],["result"]]],[11,"decode","","",36,[[["__d"]],["result",["stability"]]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"clone","","",37,[[["self"]],["deprecation"]]],[11,"encode","","",37,[[["self"],["__s"]],["result"]]],[11,"decode","","",37,[[["__d"]],["result",["deprecation"]]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"clone","","",38,[[["self"]],["typebinding"]]],[11,"eq","","",38,[[["self"],["typebinding"]],["bool"]]],[11,"ne","","",38,[[["self"],["typebinding"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",38,N],[11,"decode","","",38,[[["__d"]],["result",["typebinding"]]]],[11,"encode","","",38,[[["self"],["__s"]],["result"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"hash","","",38,N],[11,"assert_receiver_is_total_eq","","",57,N],[11,"eq","","",57,[[["self"],["regiontarget"]],["bool"]]],[11,"ne","","",57,[[["self"],["regiontarget"]],["bool"]]],[11,"hash","","",57,N],[11,"clone","","",57,[[["self"]],["regiontarget"]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"default","","",39,[[],["regiondeps"]]],[11,"fmt","","",39,[[["self"],["formatter"]],["result"]]],[11,"clone","","",39,[[["self"]],["regiondeps"]]],[11,"assert_receiver_is_total_eq","","",58,N],[11,"eq","","",58,[[["self"],["simplebound"]],["bool"]]],[11,"ne","","",58,[[["self"],["simplebound"]],["bool"]]],[11,"hash","","",58,N],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[11,"is_auto","","",59,[[["self"]],["bool"]]],[11,"from","","",58,[[["genericbound"]],["self"]]],[0,"core","rustdoc","",N,N],[4,"Input","rustdoc::core","",N,N],[13,"File","","Load source from file",70,N],[13,"Str","","",70,N],[12,"name","rustdoc::core::Input","String that is shown in place of a filename",70,N],[12,"input","","Anonymous source string",70,N],[3,"CodegenOptions","rustdoc::core","",N,N],[12,"ar","","",71,N],[12,"linker","","",71,N],[12,"link_arg","","",71,N],[12,"link_args","","",71,N],[12,"link_dead_code","","",71,N],[12,"lto","","",71,N],[12,"target_cpu","","",71,N],[12,"target_feature","","",71,N],[12,"passes","","",71,N],[12,"llvm_args","","",71,N],[12,"save_temps","","",71,N],[12,"rpath","","",71,N],[12,"overflow_checks","","",71,N],[12,"no_prepopulate_passes","","",71,N],[12,"no_vectorize_loops","","",71,N],[12,"no_vectorize_slp","","",71,N],[12,"soft_float","","",71,N],[12,"prefer_dynamic","","",71,N],[12,"no_integrated_as","","",71,N],[12,"no_redzone","","",71,N],[12,"relocation_model","","",71,N],[12,"code_model","","",71,N],[12,"metadata","","",71,N],[12,"extra_filename","","",71,N],[12,"codegen_units","","",71,N],[12,"remark","","",71,N],[12,"no_stack_check","","",71,N],[12,"debuginfo","","",71,N],[12,"opt_level","","",71,N],[12,"force_frame_pointers","","",71,N],[12,"debug_assertions","","",71,N],[12,"inline_threshold","","",71,N],[12,"panic","","",71,N],[12,"incremental","","",71,N],[3,"SearchPaths","","",N,N],[12,"paths","","",72,N],[3,"DocContext","","",N,N],[12,"tcx","","",73,N],[12,"resolver","","",73,N],[12,"mod_ids","","The stack of module NodeIds up till this point",73,N],[12,"crate_name","","",73,N],[12,"cstore","","",73,N],[12,"populated_all_crate_impls","","",73,N],[12,"access_levels","","Later on moved into `clean::Crate`",73,N],[12,"renderinfo","","Later on moved into `html::render::CACHE_KEY`",73,N],[12,"external_traits","","Later on moved through `clean::Crate` into `html::render::CACHE_KEY`",73,N],[12,"active_extern_traits","","Used while populating `external_traits` to ensure we don't process the same trait twice at the same time.",73,N],[12,"ty_substs","","Table type parameter definition -> substituted type",73,N],[12,"lt_substs","","Table node id of lifetime parameter definition -> substituted lifetime",73,N],[12,"impl_trait_bounds","","Table DefId of `impl Trait` in argument position -> bounds",73,N],[12,"send_trait","","",73,N],[12,"fake_def_ids","","",73,N],[12,"all_fake_def_ids","","",73,N],[12,"generated_synthetics","","Maps (type_id, trait_id) -> auto trait impl",73,N],[12,"current_item_name","","",73,N],[12,"all_traits","","",73,N],[5,"new_handler","","Creates a new diagnostic `Handler` that can be used to emit warnings and errors.",N,[[["erroroutputtype"],["option",["lrc"]]],["handler"]]],[5,"run_core","","",N,N],[6,"ExternalPaths","","",N,N],[8,"DocAccessLevels","","",N,N],[10,"is_doc_reachable","","",74,[[["self"],["defid"]],["bool"]]],[11,"sess","","",73,[[["self"]],["session"]]],[11,"enter_alias","","Call the closure with the given parameters set as the substitutions for a type alias' RHS.",73,[[["self"],["fxhashmap",["def","type"]],["fxhashmap",["defid","lifetime"]],["f"]],["r"]]],[0,"doctree","rustdoc","This module is used to store stuff from Rust's AST in a more convenient manner (and with prettier names) before cleaning.",N,N],[3,"Module","rustdoc::doctree","",N,N],[12,"name","","",75,N],[12,"attrs","","",75,N],[12,"where_outer","","",75,N],[12,"where_inner","","",75,N],[12,"extern_crates","","",75,N],[12,"imports","","",75,N],[12,"structs","","",75,N],[12,"unions","","",75,N],[12,"enums","","",75,N],[12,"fns","","",75,N],[12,"mods","","",75,N],[12,"id","","",75,N],[12,"typedefs","","",75,N],[12,"existentials","","",75,N],[12,"statics","","",75,N],[12,"constants","","",75,N],[12,"traits","","",75,N],[12,"vis","","",75,N],[12,"stab","","",75,N],[12,"depr","","",75,N],[12,"impls","","",75,N],[12,"foreigns","","",75,N],[12,"macros","","",75,N],[12,"is_crate","","",75,N],[3,"Struct","","",N,N],[12,"vis","","",76,N],[12,"stab","","",76,N],[12,"depr","","",76,N],[12,"id","","",76,N],[12,"struct_type","","",76,N],[12,"name","","",76,N],[12,"generics","","",76,N],[12,"attrs","","",76,N],[12,"fields","","",76,N],[12,"whence","","",76,N],[3,"Union","","",N,N],[12,"vis","","",77,N],[12,"stab","","",77,N],[12,"depr","","",77,N],[12,"id","","",77,N],[12,"struct_type","","",77,N],[12,"name","","",77,N],[12,"generics","","",77,N],[12,"attrs","","",77,N],[12,"fields","","",77,N],[12,"whence","","",77,N],[3,"Enum","","",N,N],[12,"vis","","",78,N],[12,"stab","","",78,N],[12,"depr","","",78,N],[12,"variants","","",78,N],[12,"generics","","",78,N],[12,"attrs","","",78,N],[12,"id","","",78,N],[12,"whence","","",78,N],[12,"name","","",78,N],[3,"Variant","","",N,N],[12,"name","","",79,N],[12,"attrs","","",79,N],[12,"def","","",79,N],[12,"stab","","",79,N],[12,"depr","","",79,N],[12,"whence","","",79,N],[3,"Function","","",N,N],[12,"decl","","",80,N],[12,"attrs","","",80,N],[12,"id","","",80,N],[12,"name","","",80,N],[12,"vis","","",80,N],[12,"stab","","",80,N],[12,"depr","","",80,N],[12,"header","","",80,N],[12,"whence","","",80,N],[12,"generics","","",80,N],[12,"body","","",80,N],[3,"Typedef","","",N,N],[12,"ty","","",81,N],[12,"gen","","",81,N],[12,"name","","",81,N],[12,"id","","",81,N],[12,"attrs","","",81,N],[12,"whence","","",81,N],[12,"vis","","",81,N],[12,"stab","","",81,N],[12,"depr","","",81,N],[3,"Existential","","",N,N],[12,"exist_ty","","",82,N],[12,"name","","",82,N],[12,"id","","",82,N],[12,"attrs","","",82,N],[12,"whence","","",82,N],[12,"vis","","",82,N],[12,"stab","","",82,N],[12,"depr","","",82,N],[3,"Static","","",N,N],[12,"type_","","",83,N],[12,"mutability","","",83,N],[12,"expr","","",83,N],[12,"name","","",83,N],[12,"attrs","","",83,N],[12,"vis","","",83,N],[12,"stab","","",83,N],[12,"depr","","",83,N],[12,"id","","",83,N],[12,"whence","","",83,N],[3,"Constant","","",N,N],[12,"type_","","",84,N],[12,"expr","","",84,N],[12,"name","","",84,N],[12,"attrs","","",84,N],[12,"vis","","",84,N],[12,"stab","","",84,N],[12,"depr","","",84,N],[12,"id","","",84,N],[12,"whence","","",84,N],[3,"Trait","","",N,N],[12,"is_auto","","",85,N],[12,"unsafety","","",85,N],[12,"name","","",85,N],[12,"items","","",85,N],[12,"generics","","",85,N],[12,"bounds","","",85,N],[12,"attrs","","",85,N],[12,"id","","",85,N],[12,"whence","","",85,N],[12,"vis","","",85,N],[12,"stab","","",85,N],[12,"depr","","",85,N],[3,"Impl","","",N,N],[12,"unsafety","","",86,N],[12,"polarity","","",86,N],[12,"defaultness","","",86,N],[12,"generics","","",86,N],[12,"trait_","","",86,N],[12,"for_","","",86,N],[12,"items","","",86,N],[12,"attrs","","",86,N],[12,"whence","","",86,N],[12,"vis","","",86,N],[12,"stab","","",86,N],[12,"depr","","",86,N],[12,"id","","",86,N],[3,"Macro","","",N,N],[12,"name","","",87,N],[12,"def_id","","",87,N],[12,"attrs","","",87,N],[12,"whence","","",87,N],[12,"matchers","","",87,N],[12,"stab","","",87,N],[12,"depr","","",87,N],[12,"imported_from","","",87,N],[3,"ExternCrate","","",N,N],[12,"name","","",88,N],[12,"cnum","","",88,N],[12,"path","","",88,N],[12,"vis","","",88,N],[12,"attrs","","",88,N],[12,"whence","","",88,N],[3,"Import","","",N,N],[12,"name","","",89,N],[12,"id","","",89,N],[12,"vis","","",89,N],[12,"attrs","","",89,N],[12,"path","","",89,N],[12,"glob","","",89,N],[12,"whence","","",89,N],[4,"StructType","","",N,N],[13,"Plain","","A braced struct",90,N],[13,"Tuple","","A tuple struct",90,N],[13,"Unit","","A unit struct",90,N],[5,"struct_type_from_def","","",N,[[["variantdata"]],["structtype"]]],[11,"new","","",75,[[["option",["name"]]],["module"]]],[11,"fmt","","",90,[[["self"],["formatter"]],["result"]]],[11,"clone","","",90,[[["self"]],["structtype"]]],[11,"encode","","",90,[[["self"],["__s"]],["result"]]],[11,"decode","","",90,[[["__d"]],["result",["structtype"]]]],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[0,"fold","rustdoc","",N,N],[3,"StripItem","rustdoc::fold","",N,N],[12,"0","","",91,N],[8,"DocFolder","","",N,N],[11,"fold_item","","",92,[[["self"],["item"]],["option",["item"]]]],[11,"fold_inner_recur","","don't override!",92,[[["self"],["itemenum"]],["itemenum"]]],[11,"fold_item_recur","","don't override!",92,[[["self"],["item"]],["option",["item"]]]],[11,"fold_mod","","",92,[[["self"],["module"]],["module"]]],[11,"fold_crate","","",92,[[["self"],["crate"]],["crate"]]],[11,"strip","","",91,[[["self"]],["option",["item"]]]],[0,"html","rustdoc","",N,N],[0,"highlight","rustdoc::html","Basic syntax highlighting functionality.",N,N],[3,"Classifier","rustdoc::html::highlight","Processes a program (nested in the internal `lexer`), classifying strings of text by highlighting category (`Class`). Calls out to a `Writer` to write each span of text in sequence.",N,N],[12,"lexer","","",93,N],[12,"codemap","","",93,N],[12,"in_attribute","","",93,N],[12,"in_macro","","",93,N],[12,"in_macro_nonterminal","","",93,N],[4,"Class","","How a span of text is classified. Mostly corresponds to token kinds.",N,N],[13,"None","","",94,N],[13,"Comment","","",94,N],[13,"DocComment","","",94,N],[13,"Attribute","","",94,N],[13,"KeyWord","","",94,N],[13,"RefKeyWord","","",94,N],[13,"Self_","","",94,N],[13,"Op","","",94,N],[13,"Macro","","",94,N],[13,"MacroNonTerminal","","",94,N],[13,"String","","",94,N],[13,"Number","","",94,N],[13,"Bool","","",94,N],[13,"Ident","","",94,N],[13,"Lifetime","","",94,N],[13,"PreludeTy","","",94,N],[13,"PreludeVal","","",94,N],[13,"QuestionMark","","",94,N],[5,"render_with_highlighting","","Highlights `src`, returning the HTML output.",N,[[["str"],["option",["str"]],["option",["str"]],["option",["str"]],["option"]],["string"]]],[5,"write_header","","",N,[[["option",["str"]],["option",["str"]],["write"]],["result"]]],[5,"write_footer","","",N,[[["write"]],["result"]]],[8,"Writer","","Trait that controls writing the output of syntax highlighting. Users should implement this trait to customize writing output.",N,N],[10,"enter_span","","Called when we start processing a span of text that should be highlighted. The `Class` argument specifies how it should be highlighted.",95,[[["self"],["class"]],["result"]]],[10,"exit_span","","Called at the end of a span of highlighted text.",95,[[["self"]],["result"]]],[10,"string","","Called for a span of text, usually, but not always, a single token. If the string of text (`T`) does correspond to a token, then the token will also be passed. If the text should be highlighted differently from the surrounding text, then the `Class` argument will be a value other than `None`. The following sequences of callbacks are equivalent: `plain enter_span(Foo), string(\"text\", None), exit_span() string(\"text\", Foo)` The latter can be thought of as a shorthand for the former, which is more flexible.",95,[[["self"],["t"],["class"],["option",["tokenandspan"]]],["result"]]],[11,"clone","","",94,[[["self"]],["class"]]],[11,"fmt","","",94,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",94,N],[11,"eq","","",94,[[["self"],["class"]],["bool"]]],[11,"new","","",93,[[["stringreader"],["codemap"]],["classifier"]]],[11,"try_next_token","","Gets the next token out of the lexer, emitting fatal errors if lexing fails.",93,[[["self"]],["result",["tokenandspan"]]]],[11,"write_source","","Exhausts the `lexer` writing the output into `out`.",93,[[["self"],["w"]],["result"]]],[11,"write_token","","",93,[[["self"],["w"],["tokenandspan"]],["result"]]],[11,"snip","","",93,[[["self"],["span"]],["string"]]],[11,"rustdoc_class","","Returns the css class expected by rustdoc for each `Class`.",94,[[["self"]],["str"]]],[0,"escape","rustdoc::html","HTML Escaping",N,N],[3,"Escape","rustdoc::html::escape","Wrapper struct which will emit the HTML-escaped version of the contained string when passed to a format string.",N,N],[12,"0","","",96,N],[11,"fmt","","",96,[[["self"],["formatter"]],["result"]]],[0,"item_type","rustdoc::html","Item types.",N,N],[4,"ItemType","rustdoc::html::item_type","Item type. Corresponds to `clean::ItemEnum` variants.",N,N],[13,"Module","","",97,N],[13,"ExternCrate","","",97,N],[13,"Import","","",97,N],[13,"Struct","","",97,N],[13,"Enum","","",97,N],[13,"Function","","",97,N],[13,"Typedef","","",97,N],[13,"Static","","",97,N],[13,"Trait","","",97,N],[13,"Impl","","",97,N],[13,"TyMethod","","",97,N],[13,"Method","","",97,N],[13,"StructField","","",97,N],[13,"Variant","","",97,N],[13,"Macro","","",97,N],[13,"Primitive","","",97,N],[13,"AssociatedType","","",97,N],[13,"Constant","","",97,N],[13,"AssociatedConst","","",97,N],[13,"Union","","",97,N],[13,"ForeignType","","",97,N],[13,"Keyword","","",97,N],[13,"Existential","","",97,N],[4,"NameSpace","","",N,N],[13,"Type","","",98,N],[13,"Value","","",98,N],[13,"Macro","","",98,N],[13,"Keyword","","",98,N],[17,"NAMESPACE_TYPE","","",N,N],[17,"NAMESPACE_VALUE","","",N,N],[17,"NAMESPACE_MACRO","","",N,N],[17,"NAMESPACE_KEYWORD","","",N,N],[11,"eq","","",97,[[["self"],["itemtype"]],["bool"]]],[11,"clone","","",97,[[["self"]],["itemtype"]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",98,N],[11,"eq","","",98,[[["self"],["namespace"]],["bool"]]],[11,"clone","","",98,[[["self"]],["namespace"]]],[11,"from","","",97,[[["item"]],["itemtype"]]],[11,"from","","",97,[[["typekind"]],["itemtype"]]],[11,"css_class","","",97,[[["self"]],["str"]]],[11,"name_space","","",97,[[["self"]],["namespace"]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"to_static_str","","",98,[[["self"]],["str"]]],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[0,"format","rustdoc::html","HTML formatting module",N,N],[3,"VisSpace","rustdoc::html::format","Helper to render an optional visibility with a space after it (if the visibility is preset)",N,N],[12,"0","","",99,N],[3,"UnsafetySpace","","Similarly to VisSpace, this structure is used to render a function style with a space after it.",N,N],[12,"0","","",100,N],[3,"ConstnessSpace","","Similarly to VisSpace, this structure is used to render a function constness with a space after it.",N,N],[12,"0","","",101,N],[3,"AsyncSpace","","Similarly to VisSpace, this structure is used to render a function asyncness with a space after it.",N,N],[12,"0","","",102,N],[3,"MutableSpace","","Similar to VisSpace, but used for mutability",N,N],[12,"0","","",103,N],[3,"RawMutableSpace","","Similar to VisSpace, but used for mutability",N,N],[12,"0","","",104,N],[3,"GenericBounds","","Wrapper struct for emitting type parameter bounds.",N,N],[12,"0","","",105,N],[3,"CommaSep","","Wrapper struct for emitting a comma-separated list of items",N,N],[12,"0","","",106,N],[3,"AbiSpace","","",N,N],[12,"0","","",107,N],[3,"Method","","Wrapper struct for properly emitting a method declaration.",N,N],[12,"decl","","The declaration to emit.",108,N],[12,"name_len","","The length of the function's \"name\", used to determine line-wrapping.",108,N],[12,"indent","","The number of spaces to indent each successive line with, if line-wrapping is necessary.",108,N],[3,"WhereClause","","Wrapper struct for emitting a where clause from Generics.",N,N],[12,"gens","","The Generics from which to emit a where clause.",109,N],[12,"indent","","The number of spaces to indent each line with.",109,N],[12,"end_newline","","Whether the where clause needs to add a comma and newline after the last bound.",109,N],[3,"HRef","","",N,N],[12,"did","","",110,N],[12,"text","","",110,N],[5,"href","","",N,[[["defid"]],["option"]]],[5,"resolved_path","","Used when rendering a `ResolvedPath` structure. This invokes the `path` rendering function with the necessary arguments for linking to a local path.",N,[[["formatter"],["defid"],["path"],["bool"],["bool"]],["result"]]],[5,"primitive_link","","",N,[[["formatter"],["primitivetype"],["str"]],["result"]]],[5,"tybounds","","Helper to render type parameters",N,[[["formatter"],["option"]],["result"]]],[5,"fmt_type","","",N,[[["type"],["formatter"],["bool"]],["result"]]],[5,"fmt_impl","","",N,[[["impl"],["formatter"],["bool"],["bool"]],["result"]]],[5,"fmt_impl_for_trait_page","","",N,[[["impl"],["formatter"],["bool"]],["result"]]],[11,"clone","","",99,[[["self"]],["visspace"]]],[11,"clone","","",100,[[["self"]],["unsafetyspace"]]],[11,"clone","","",101,[[["self"]],["constnessspace"]]],[11,"clone","","",102,[[["self"]],["asyncspace"]]],[11,"clone","","",103,[[["self"]],["mutablespace"]]],[11,"clone","","",104,[[["self"]],["rawmutablespace"]]],[11,"get","","",99,[[["self"]],["option"]]],[11,"get","","",100,[[["self"]],["unsafety"]]],[11,"get","","",101,[[["self"]],["constness"]]],[11,"fmt","","",106,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",105,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::clean","",10,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::html::format","",109,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::clean","",9,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"new","rustdoc::html::format","",110,[[["defid"],["str"]],["href"]]],[11,"fmt","","",110,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::clean","",48,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::html::format","",108,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::clean","",56,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::html::format","",103,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[0,"layout","rustdoc::html","",N,N],[3,"Layout","rustdoc::html::layout","",N,N],[12,"logo","","",111,N],[12,"favicon","","",111,N],[12,"external_html","","",111,N],[12,"krate","","",111,N],[3,"Page","","",N,N],[12,"title","","",112,N],[12,"css_class","","",112,N],[12,"root_path","","",112,N],[12,"description","","",112,N],[12,"keywords","","",112,N],[12,"resource_suffix","","",112,N],[5,"render","","",N,N],[5,"redirect","","",N,[[["write"],["str"]],["result"]]],[11,"clone","","",111,[[["self"]],["layout"]]],[0,"markdown","rustdoc::html","Markdown formatting for rustdoc",N,N],[3,"Markdown","rustdoc::html::markdown","A unit struct which has the `fmt::Display` trait implemented. When formatted, this struct will emit the HTML corresponding to the rendered version of the contained markdown string. The second parameter is a list of link replacements",N,N],[12,"0","","",113,N],[12,"1","","",113,N],[3,"MarkdownWithToc","","A unit struct like `Markdown`, that renders the markdown with a table of contents.",N,N],[12,"0","","",114,N],[3,"MarkdownHtml","","A unit struct like `Markdown`, that renders the markdown escaping HTML tags.",N,N],[12,"0","","",115,N],[3,"MarkdownSummaryLine","","A unit struct like `Markdown`, that renders only the first paragraph.",N,N],[12,"0","","",116,N],[12,"1","","",116,N],[3,"CodeBlocks","","Adds syntax highlighting and playground Run buttons to rust code blocks.",N,N],[12,"inner","","",117,N],[3,"LinkReplacer","","Make headings links with anchor ids and build up TOC.",N,N],[12,"inner","","",118,N],[12,"links","","",118,N],[3,"HeadingLinks","","Make headings links with anchor ids and build up TOC.",N,N],[12,"inner","","",119,N],[12,"toc","","",119,N],[12,"buf","","",119,N],[3,"SummaryLine","","Extracts just the first paragraph.",N,N],[12,"inner","","",120,N],[12,"started","","",120,N],[12,"depth","","",120,N],[3,"Footnotes","","Moves all footnote definitions to the end and add back links to the references.",N,N],[12,"inner","","",121,N],[12,"footnotes","","",121,N],[3,"LangString","","",N,N],[12,"original","","",122,N],[12,"should_panic","","",122,N],[12,"no_run","","",122,N],[12,"ignore","","",122,N],[12,"rust","","",122,N],[12,"test_harness","","",122,N],[12,"compile_fail","","",122,N],[12,"error_codes","","",122,N],[12,"allow_fail","","",122,N],[4,"Line","","Controls whether a line will be hidden or shown in HTML output.",N,N],[13,"Hidden","","",123,N],[13,"Shown","","",123,N],[5,"map_line","","",N,[[["str"]],["line"]]],[5,"slugify","","Convert chars from a title for an id.",N,[[["char"]],["option",["char"]]]],[5,"check_if_allowed_tag","","",N,[[["tag"]],["bool"]]],[5,"find_testable_code","","",N,[[["str"],["collector"],["span"],["option",["session"]]]]],[5,"plain_summary_line","","",N,[[["str"]],["string"]]],[5,"markdown_links","","",N,[[["str"]],["vec"]]],[17,"PLAYGROUND","","",N,N],[11,"for_html","","",123,[[["self"]],["option",["cow"]]]],[11,"for_code","","",123,[[["self"]],["cow",["str"]]]],[11,"new","","",117,[[["i"]],["self"]]],[11,"next","","",117,[[["self"]],["option"]]],[11,"new","","",118,N],[11,"next","","",118,[[["self"]],["option"]]],[11,"new","","",119,[[["i"],["option",["tocbuilder"]]],["self"]]],[11,"next","","",119,[[["self"]],["option"]]],[11,"new","","",120,[[["i"]],["self"]]],[11,"next","","",120,[[["self"]],["option"]]],[11,"new","","",121,[[["i"]],["self"]]],[11,"get_entry","","",121,N],[11,"next","","",121,[[["self"]],["option"]]],[11,"assert_receiver_is_total_eq","","",122,N],[11,"eq","","",122,[[["self"],["langstring"]],["bool"]]],[11,"ne","","",122,[[["self"],["langstring"]],["bool"]]],[11,"clone","","",122,[[["self"]],["langstring"]]],[11,"fmt","","",122,[[["self"],["formatter"]],["result"]]],[11,"all_false","","",122,[[],["langstring"]]],[11,"parse","","",122,[[["str"]],["langstring"]]],[11,"fmt","","",113,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[0,"render","rustdoc::html","Rustdoc's HTML Rendering module",N,N],[3,"Context","rustdoc::html::render","Major driving force in all rustdoc rendering. This contains information about where in the tree-like hierarchy rendering is occurring and controls how the current page is being rendered.",N,N],[12,"current","","Current hierarchy of components leading down to what's currently being rendered",124,N],[12,"dst","","The current destination folder of where HTML artifacts should be placed. This changes as the context descends into the module hierarchy.",124,N],[12,"render_redirect_pages","","A flag, which when `true`, will render pages which redirect to the real location of an item. This is used to allow external links to publicly reused items to redirect to the right location.",124,N],[12,"shared","","",124,N],[3,"SharedContext","","",N,N],[12,"src_root","","The path to the crate root source minus the file name. Used for simplifying paths to the highlighted source code files.",125,N],[12,"layout","","This describes the layout of each page, and is not modified after creation of the context (contains info like the favicon and added html).",125,N],[12,"include_sources","","This flag indicates whether `[src]` links should be generated or not. If the source files are present in the html rendering, then this will be `true`.",125,N],[12,"local_sources","","The local file sources we've emitted and their respective url-paths.",125,N],[12,"passes","","All the passes that were run on this crate.",125,N],[12,"issue_tracker_base_url","","The base-URL of the issue tracker for when an item has been tagged with an issue number.",125,N],[12,"css_file_extension","","The given user css file which allow to customize the generated documentation theme.",125,N],[12,"created_dirs","","The directories that have already been created in this doc run. Used to reduce the number of spurious `create_dir_all` calls.",125,N],[12,"sort_modules_alphabetically","","This flag indicates whether listings of modules (in the side bar and documentation itself) should be ordered alphabetically or in order of appearance (in the source code).",125,N],[12,"themes","","Additional themes to be added to the generated docs.",125,N],[12,"resource_suffix","","Suffix to be added on resource files (if suffix is \"-v2\" then \"light.css\" becomes \"light-v2.css\").",125,N],[3,"Impl","","Metadata about implementations for a type or trait.",N,N],[12,"impl_item","","",126,N],[3,"Error","","",N,N],[12,"file","","",127,N],[12,"error","","",127,N],[3,"Cache","","This cache is used to store information about the `clean::Crate` being rendered in order to provide more useful documentation. This contains information like all implementors of a trait, all traits a type implements, documentation for all known traits, etc.",N,N],[12,"typarams","","Mapping of typaram ids to the name of the type parameter. This is used when pretty-printing a type (so pretty printing doesn't have to painfully maintain a context like this)",128,N],[12,"impls","","Maps a type id to all known implementations for that type. This is only recognized for intra-crate `ResolvedPath` types, and is used to print out extra documentation on the page of an enum/struct.",128,N],[12,"paths","","Maintains a mapping of local crate node ids to the fully qualified name and \"short type description\" of that node. This is used when generating URLs when a type is being linked to. External paths are not located in this map because the `External` type itself has all the information necessary.",128,N],[12,"external_paths","","Similar to `paths`, but only holds external paths. This is only used for generating explicit hyperlinks to other crates.",128,N],[12,"exact_paths","","Maps local def ids of exported types to fully qualified paths. Unlike 'paths', this mapping ignores any renames that occur due to 'use' statements.",128,N],[12,"traits","","This map contains information about all known traits of this crate. Implementations of a crate should inherit the documentation of the parent trait if no extra documentation is specified, and default methods should show up in documentation about trait implementations.",128,N],[12,"implementors","","When rendering traits, it's often useful to be able to list all implementors of the trait, and this mapping is exactly, that: a mapping of trait ids to the list of known implementors of the trait",128,N],[12,"extern_locations","","Cache of where external crate documentation can be found.",128,N],[12,"primitive_locations","","Cache of where documentation for primitives can be found.",128,N],[12,"access_levels","","",128,N],[12,"crate_version","","The version of the crate being documented, if given fron the `--crate-version` flag.",128,N],[12,"stack","","",128,N],[12,"parent_stack","","",128,N],[12,"parent_is_trait_impl","","",128,N],[12,"search_index","","",128,N],[12,"stripped_mod","","",128,N],[12,"deref_trait_did","","",128,N],[12,"deref_mut_trait_did","","",128,N],[12,"owned_box_did","","",128,N],[12,"masked_crates","","",128,N],[12,"orphan_impl_items","","",128,N],[12,"aliases","","Aliases added through `#[doc(alias = \"...\")]`. Since a few items can have the same alias, we need the alias element to have an array of items.",128,N],[3,"RenderInfo","","Temporary storage for data obtained during `RustdocVisitor::clean()`. Later on moved into `CACHE_KEY`.",N,N],[12,"inlined","","",129,N],[12,"external_paths","","",129,N],[12,"external_typarams","","",129,N],[12,"exact_paths","","",129,N],[12,"deref_trait_did","","",129,N],[12,"deref_mut_trait_did","","",129,N],[12,"owned_box_did","","",129,N],[3,"SourceCollector","","Helper struct to render all source code to HTML pages",N,N],[12,"scx","","",130,N],[12,"dst","","Root destination to place all HTML output into",130,N],[3,"Source","","Wrapper struct to render the source code of a file. This will do things like adding line numbers to the left-hand side.",N,N],[12,"0","","",131,N],[3,"Item","","",N,N],[12,"cx","","",132,N],[12,"item","","",132,N],[3,"Sidebar","","",N,N],[12,"cx","","",133,N],[12,"item","","",133,N],[3,"IndexItem","","Struct representing one entry in the JS search index. These are all emitted by hand to a large JS file at the end of cache-creation.",N,N],[12,"ty","","",134,N],[12,"name","","",134,N],[12,"path","","",134,N],[12,"desc","","",134,N],[12,"parent","","",134,N],[12,"parent_idx","","",134,N],[12,"search_type","","",134,N],[3,"Type","","A type used for the search index.",N,N],[12,"name","","",135,N],[12,"generics","","",135,N],[3,"IndexItemFunctionType","","Full type of functions/methods in the search index.",N,N],[12,"inputs","","",136,N],[12,"output","","",136,N],[3,"ItemEntry","","",N,N],[12,"url","","",137,N],[12,"name","","",137,N],[3,"AllTypes","","",N,N],[12,"structs","","",138,N],[12,"enums","","",138,N],[12,"unions","","",138,N],[12,"primitives","","",138,N],[12,"traits","","",138,N],[12,"macros","","",138,N],[12,"functions","","",138,N],[12,"typedefs","","",138,N],[12,"existentials","","",138,N],[12,"statics","","",138,N],[12,"constants","","",138,N],[12,"keywords","","",138,N],[3,"Settings","","",N,N],[12,"settings","","",139,N],[12,"root_path","","",139,N],[12,"suffix","","",139,N],[3,"Initializer","","",N,N],[12,"0","","",140,N],[4,"ExternalLocation","","Indicates where an external crate can be found.",N,N],[13,"Remote","","Remote URL root of the external crate",141,N],[13,"Local","","This external crate can be found in the local doc/ folder",141,N],[13,"Unknown","","The external crate could not be found.",141,N],[4,"AssocItemLink","","",N,N],[13,"Anchor","","",142,N],[13,"GotoSource","","",142,N],[4,"AssocItemRender","","",N,N],[13,"All","","",143,N],[13,"DerefFor","","",143,N],[12,"trait_","rustdoc::html::render::AssocItemRender","",143,N],[12,"type_","","",143,N],[12,"deref_mut_","","",143,N],[4,"RenderMode","rustdoc::html::render","",N,N],[13,"Normal","","",144,N],[13,"ForDeref","","",144,N],[12,"mut_","rustdoc::html::render::RenderMode","",144,N],[5,"init_ids","rustdoc::html::render","",N,[[],["fxhashmap",["string","usize"]]]],[5,"reset_ids","","This method resets the local table of used ID attributes. This is typically used at the beginning of rendering an entire HTML page to reset from the previous state (if any).",N,[[["bool"]]]],[5,"derive_id","","",N,[[["string"]],["string"]]],[5,"run","","Generates the documentation for `crate` into the directory `dst`",N,[[["crate"],["externalhtml"],["option",["string"]],["pathbuf"],["string"],["fxhashset",["string"]],["option",["pathbuf"]],["renderinfo"],["bool"],["vec",["pathbuf"]],["bool"]],["result",["error"]]]],[5,"build_index","","Build the search index from the collected metadata",N,[[["crate"],["cache"]],["string"]]],[5,"write_shared","","",N,[[["context"],["crate"],["cache"],["string"],["bool"]],["result",["error"]]]],[5,"render_sources","","",N,[[["path"],["sharedcontext"],["crate"]],["result",["crate","error"]]]],[5,"write","","Writes the entire contents of a string to a destination, not attempting to catch any errors.",N,N],[5,"write_minify","","",N,[[["pathbuf"],["str"],["bool"]],["result",["error"]]]],[5,"write_minify_replacer","","",N,N],[5,"clean_srcpath","","Takes a path to a source file and cleans the path to it. This canonicalizes things like \"..\" to components which preserve the \"top down\" hierarchy of a static HTML tree. Each component in the cleaned path will be passed as an argument to `f`. The very last component of the path (ie the file name) will be passed to `f` if `keep_filename` is true, and ignored otherwise.",N,[[["path"],["path"],["bool"],["f"]]]],[5,"extern_location","","Attempts to find where an external crate is located, given that we're rendering in to the specified source destination.",N,[[["externalcrate"],["path"]],["externallocation"]]],[5,"print_entries","","",N,[[["formatter"],["hashset"],["str"],["str"]],["result"]]],[5,"wrap_into_docblock","","",N,[[["formatter"],["f"]],["result"]]],[5,"item_path","","",N,[[["itemtype"],["str"]],["string"]]],[5,"full_path","","",N,[[["context"],["item"]],["string"]]],[5,"shorter","","",N,[[["option",["str"]]],["string"]]],[5,"plain_summary_line","","",N,[[["option",["str"]]],["string"]]],[5,"document","","",N,[[["formatter"],["context"],["item"]],["result"]]],[5,"render_markdown","","Render md_text as markdown.",N,[[["formatter"],["str"],["vec"],["str"]],["result"]]],[5,"document_short","","",N,[[["formatter"],["item"],["associtemlink"],["str"]],["result"]]],[5,"render_assoc_const_value","","",N,[[["item"]],["string"]]],[5,"document_full","","",N,[[["formatter"],["item"],["context"],["str"]],["result"]]],[5,"document_stability","","",N,[[["formatter"],["context"],["item"]],["result"]]],[5,"document_non_exhaustive_header","","",N,[[["item"]],["str"]]],[5,"document_non_exhaustive","","",N,[[["formatter"],["item"]],["result"]]],[5,"name_key","","",N,N],[5,"item_module","","",N,N],[5,"short_stability","","",N,[[["item"],["context"],["bool"]],["vec",["string"]]]],[5,"item_constant","","",N,[[["formatter"],["context"],["item"],["constant"]],["result"]]],[5,"item_static","","",N,[[["formatter"],["context"],["item"],["static"]],["result"]]],[5,"item_function","","",N,[[["formatter"],["context"],["item"],["function"]],["result"]]],[5,"render_implementor","","",N,[[["context"],["impl"],["formatter"],["fxhashmap"]],["result"]]],[5,"render_impls","","",N,N],[5,"bounds","","",N,N],[5,"item_trait","","",N,[[["formatter"],["context"],["item"],["trait"]],["result"]]],[5,"naive_assoc_href","","",N,[[["item"],["associtemlink"]],["string"]]],[5,"assoc_const","","",N,[[["formatter"],["item"],["type"],["option",["string"]],["associtemlink"]],["result"]]],[5,"assoc_type","","",N,N],[5,"render_stability_since_raw","","",N,[[["formatter"],["option",["str"]],["option",["str"]]],["result"]]],[5,"render_stability_since","","",N,[[["formatter"],["item"],["item"]],["result"]]],[5,"render_assoc_item","","",N,[[["formatter"],["item"],["associtemlink"],["itemtype"]],["result"]]],[5,"item_struct","","",N,[[["formatter"],["context"],["item"],["struct"]],["result"]]],[5,"item_union","","",N,[[["formatter"],["context"],["item"],["union"]],["result"]]],[5,"item_enum","","",N,[[["formatter"],["context"],["item"],["enum"]],["result"]]],[5,"render_attribute","","",N,[[["metaitem"]],["option",["string"]]]],[5,"render_attributes","","",N,[[["formatter"],["item"]],["result"]]],[5,"render_struct","","",N,N],[5,"render_union","","",N,N],[5,"render_assoc_items","","",N,[[["formatter"],["context"],["item"],["defid"],["associtemrender"]],["result"]]],[5,"render_deref_methods","","",N,[[["formatter"],["context"],["impl"],["item"],["bool"]],["result"]]],[5,"should_render_item","","",N,[[["item"],["bool"]],["bool"]]],[5,"render_spotlight_traits","","",N,[[["item"]],["result",["string","error"]]]],[5,"spotlight_decl","","",N,[[["fndecl"]],["result",["string","error"]]]],[5,"render_impl","","",N,[[["formatter"],["context"],["impl"],["associtemlink"],["rendermode"],["option",["str"]],["bool"]],["result"]]],[5,"item_existential","","",N,[[["formatter"],["context"],["item"],["existential"]],["result"]]],[5,"item_typedef","","",N,[[["formatter"],["context"],["item"],["typedef"]],["result"]]],[5,"item_foreign_type","","",N,[[["formatter"],["context"],["item"]],["result"]]],[5,"get_methods","","",N,[[["impl"],["bool"]],["vec",["string"]]]],[5,"small_url_encode","","",N,[[["str"]],["string"]]],[5,"sidebar_assoc_items","","",N,[[["item"]],["string"]]],[5,"sidebar_struct","","",N,[[["formatter"],["item"],["struct"]],["result"]]],[5,"extract_for_impl_name","","",N,[[["item"]],["option"]]],[5,"is_negative_impl","","",N,[[["impl"]],["bool"]]],[5,"sidebar_trait","","",N,[[["formatter"],["item"],["trait"]],["result"]]],[5,"sidebar_primitive","","",N,[[["formatter"],["item"],["primitivetype"]],["result"]]],[5,"sidebar_typedef","","",N,[[["formatter"],["item"],["typedef"]],["result"]]],[5,"get_struct_fields_name","","",N,N],[5,"sidebar_union","","",N,[[["formatter"],["item"],["union"]],["result"]]],[5,"sidebar_enum","","",N,[[["formatter"],["item"],["enum"]],["result"]]],[5,"item_ty_to_strs","","",N,N],[5,"sidebar_module","","",N,N],[5,"sidebar_foreign_type","","",N,[[["formatter"],["item"]],["result"]]],[5,"item_macro","","",N,[[["formatter"],["context"],["item"],["macro"]],["result"]]],[5,"item_primitive","","",N,[[["formatter"],["context"],["item"],["primitivetype"]],["result"]]],[5,"item_keyword","","",N,[[["formatter"],["context"],["item"],["str"]],["result"]]],[5,"make_item_keywords","","",N,[[["item"]],["string"]]],[5,"get_index_search_type","","",N,[[["item"]],["option",["indexitemfunctiontype"]]]],[5,"get_index_type","","",N,[[["type"]],["type"]]],[5,"collect_paths_for_type","","Returns a list of all paths used in the type. This is used to help deduplicate imported impls for reexported types. If any of the contained types are re-exported, we don't use the corresponding entry from the js file, as inlining will have already picked up the impl",N,[[["type"]],["vec",["string"]]]],[5,"get_index_type_name","","",N,[[["type"],["bool"]],["option",["string"]]]],[5,"get_generics","","",N,[[["type"]],["option",["vec"]]]],[5,"cache","","",N,[[],["arc",["cache"]]]],[6,"NameDoc","","A pair of name and its optional document.",N,N],[17,"CACHE_KEY","","",N,N],[17,"CURRENT_LOCATION_KEY","","",N,N],[17,"USED_ID_MAP","","",N,N],[17,"ATTRIBUTE_WHITELIST","","",N,N],[17,"BASIC_KEYWORDS","","",N,N],[11,"clone","","",124,[[["self"]],["context"]]],[11,"ensure_dir","","",125,[[["self"],["path"]],["result"]]],[11,"was_collapsed","","Returns whether the `collapse-docs` pass was run on this crate.",125,[[["self"]],["bool"]]],[11,"maybe_collapsed_doc_value","","Based on whether the `collapse-docs` pass was run, return either the `doc_value` or the `collapsed_doc_value` of the given item.",125,[[["self"],["item"]],["option",["cow"]]]],[11,"clone","","",126,[[["self"]],["impl"]]],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"inner_impl","","",126,[[["self"]],["impl"]]],[11,"trait_did","","",126,[[["self"]],["option",["defid"]]]],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"description","","",127,[[["self"]],["str"]]],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"new","","",127,[[["error"],["path"]],["error"]]],[11,"default","","",128,[[],["cache"]]],[11,"default","","",129,[[],["renderinfo"]]],[11,"clone","","",132,[[["self"]],["item"]]],[11,"fmt","","",134,[[["self"],["formatter"]],["result"]]],[11,"to_json","","",134,[[["self"]],["json"]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result"]]],[11,"to_json","","",135,[[["self"]],["json"]]],[11,"fmt","","",136,[[["self"],["formatter"]],["result"]]],[11,"to_json","","",136,[[["self"]],["json"]]],[11,"fold_item","","",130,[[["self"],["item"]],["option",["item"]]]],[11,"emit_source","","Renders the given filename into its corresponding HTML source file.",130,[[["self"],["filename"]],["result"]]],[11,"fold_item","","",128,[[["self"],["item"]],["option",["item"]]]],[11,"generics","","",128,[[["self"],["generics"]]]],[11,"add_aliases","","",128,[[["self"],["item"]]]],[11,"fmt","","",137,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",137,N],[11,"eq","","",137,[[["self"],["itementry"]],["bool"]]],[11,"ne","","",137,[[["self"],["itementry"]],["bool"]]],[11,"hash","","",137,N],[11,"new","","",137,[[["string"],["string"]],["itementry"]]],[11,"fmt","","",137,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",137,[[["self"],["itementry"]],["option",["ordering"]]]],[11,"cmp","","",137,[[["self"],["itementry"]],["ordering"]]],[11,"fmt","","",138,[[["self"],["formatter"]],["result"]]],[11,"new","","",138,[[],["alltypes"]]],[11,"append","","",138,[[["self"],["string"],["itemtype"]]]],[11,"fmt","","",138,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",139,[[["self"],["formatter"]],["result"]]],[11,"new","","",139,[[["str"],["str"]],["settings"]]],[11,"fmt","","",139,[[["self"],["formatter"]],["result"]]],[11,"root_path","","String representation of how to get back to the root path of the 'doc/' folder in terms of a relative URL.",124,[[["self"]],["string"]]],[11,"recurse","","Recurse in the directory structure and change the \"root path\" to make sure it always points to the top (relatively).",124,[[["self"],["string"],["f"]],["t"]]],[11,"krate","","Main method for rendering a crate.",124,[[["self"],["crate"]],["result",["error"]]]],[11,"render_item","","",124,[[["self"],["write"],["item"],["bool"]],["result"]]],[11,"item","","Non-parallelized version of rendering an item. This will take the input item, render its contents, and then invoke the specified closure with all sub-items which need to be rendered.",124,[[["self"],["item"],["alltypes"],["f"]],["result",["error"]]]],[11,"build_sidebar_items","","",124,[[["self"],["module"]],["btreemap",["string","vec"]]]],[11,"src_href","","Generate a url appropriate for an `href` attribute back to the source of this item.",132,[[["self"]],["option",["string"]]]],[11,"fmt","","",132,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",140,[[["self"],["formatter"]],["result"]]],[11,"clone","","",142,[[["self"]],["associtemlink"]]],[11,"anchor","","",142,[[["self"],["string"]],["self"]]],[11,"clone","","",144,[[["self"]],["rendermode"]]],[11,"eq","","",144,[[["self"],["rendermode"]],["bool"]]],[11,"ne","","",144,[[["self"],["rendermode"]],["bool"]]],[11,"fmt","","",133,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result"]]],[0,"toc","rustdoc::html","Table-of-contents creation.",N,N],[3,"Toc","rustdoc::html::toc","A (recursive) table of contents",N,N],[12,"entries","","The levels are strictly decreasing, i.e.",145,N],[3,"TocEntry","","",N,N],[12,"level","","",146,N],[12,"sec_number","","",146,N],[12,"name","","",146,N],[12,"id","","",146,N],[12,"children","","",146,N],[3,"TocBuilder","","Progressive construction of a table of contents.",N,N],[12,"top_level","","",147,N],[12,"chain","","The current hierarchy of parent headings, the levels are strictly increasing (i.e. chain[0].level < chain[1].level < ...) with each entry being the most recent occurrence of a heading with that level (it doesn't include the most recent occurrences of every level, just, if it is in `chain` then it is the most recent one).",147,N],[11,"eq","","",145,[[["self"],["toc"]],["bool"]]],[11,"ne","","",145,[[["self"],["toc"]],["bool"]]],[11,"count_entries_with_level","","",145,[[["self"],["u32"]],["usize"]]],[11,"eq","","",146,[[["self"],["tocentry"]],["bool"]]],[11,"ne","","",146,[[["self"],["tocentry"]],["bool"]]],[11,"eq","","",147,[[["self"],["tocbuilder"]],["bool"]]],[11,"ne","","",147,[[["self"],["tocbuilder"]],["bool"]]],[11,"new","","",147,[[],["tocbuilder"]]],[11,"into_toc","","Convert into a true `Toc` struct.",147,[[["self"]],["toc"]]],[11,"fold_until","","Collapse the chain until the first heading more important than `level` (i.e. lower level)",147,[[["self"],["u32"]]]],[11,"push","","Push a level `level` heading into the appropriate place in the hierarchy, returning a string containing the section number in `<num>.<num>.<num>` format.",147,[[["self"],["u32"],["string"],["string"]],["str"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[0,"markdown","rustdoc","",N,N],[5,"extract_leading_metadata","rustdoc::markdown","Separate any lines at the start of the file that begin with `#` or `%`.",N,N],[5,"render","","Render `input` (e.g. \"foo.md\") into an HTML file in `output` (e.g. output = \"bar\" => \"bar/foo.html\").",N,[[["path"],["pathbuf"],["matches"],["externalhtml"],["bool"],["handler"]],["isize"]]],[5,"test","","Run any tests/code examples in the markdown file `input`.",N,[[["str"],["vec",["string"]],["searchpaths"],["externs"],["vec",["string"]],["option",["pathbuf"]],["bool"],["option",["pathbuf"]],["edition"],["codegenoptions"],["handler"]],["isize"]]],[0,"passes","rustdoc","",N,N],[3,"Stripper","rustdoc::passes","",N,N],[12,"retained","","",148,N],[12,"access_levels","","",148,N],[12,"update_retained","","",148,N],[3,"ImplStripper","","",N,N],[12,"retained","","",149,N],[3,"ImportStripper","","",N,N],[4,"DefaultPassOption","","",N,N],[13,"Default","","",150,N],[13,"Private","","",150,N],[13,"None","","",150,N],[5,"defaults","","",N,N],[0,"collapse_docs","","",N,N],[3,"Collapser","rustdoc::passes::collapse_docs","",N,N],[4,"DocFragmentKind","","",N,N],[13,"Sugared","","",151,N],[13,"Raw","","",151,N],[13,"Include","","",151,N],[5,"collapse_docs","","",N,[[["crate"]],["crate"]]],[5,"collapse","","",N,[[["vec"]]]],[11,"clone","","",151,[[["self"]],["docfragmentkind"]]],[11,"fmt","","",151,[[["self"],["formatter"]],["result"]]],[11,"eq","","",151,[[["self"],["docfragmentkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",151,N],[11,"kind","rustdoc::clean","",41,[[["self"]],["docfragmentkind"]]],[11,"fold_item","rustdoc::passes::collapse_docs","",152,[[["self"],["item"]],["option",["item"]]]],[11,"collapse_doc_comments","rustdoc::clean","",8,[[["self"]]]],[0,"strip_hidden","rustdoc::passes","",N,N],[3,"Stripper","rustdoc::passes::strip_hidden","",N,N],[12,"retained","","",153,N],[12,"update_retained","","",153,N],[5,"strip_hidden","","Strip items marked `#[doc(hidden)]`",N,[[["crate"]],["crate"]]],[11,"fold_item","","",153,[[["self"],["item"]],["option",["item"]]]],[0,"strip_private","rustdoc::passes","",N,N],[5,"strip_private","rustdoc::passes::strip_private","Strip private items from the point of view of a crate or externally from a crate, specified by the `xcrate` flag.",N,[[["crate"]],["crate"]]],[0,"strip_priv_imports","rustdoc::passes","",N,N],[5,"strip_priv_imports","rustdoc::passes::strip_priv_imports","",N,[[["crate"]],["crate"]]],[0,"unindent_comments","rustdoc::passes","",N,N],[3,"CommentCleaner","rustdoc::passes::unindent_comments","",N,N],[5,"unindent_comments","","",N,[[["crate"]],["crate"]]],[5,"unindent_fragments","","",N,[[["vec"]]]],[5,"unindent","","",N,[[["str"]],["string"]]],[11,"fold_item","","",154,[[["self"],["item"]],["option",["item"]]]],[11,"unindent_doc_comments","rustdoc::clean","",8,[[["self"]]]],[0,"propagate_doc_cfg","rustdoc::passes","",N,N],[3,"CfgPropagator","rustdoc::passes::propagate_doc_cfg","",N,N],[12,"parent_cfg","","",155,N],[5,"propagate_doc_cfg","","",N,[[["crate"]],["crate"]]],[11,"fold_item","","",155,[[["self"],["item"]],["option",["item"]]]],[6,"Pass","rustdoc::passes","",N,N],[17,"PASSES","","",N,N],[17,"DEFAULT_PASSES","","",N,N],[17,"DEFAULT_PRIVATE_PASSES","","",N,N],[11,"clone","","",150,[[["self"]],["defaultpassoption"]]],[11,"eq","","",150,[[["self"],["defaultpassoption"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",150,N],[11,"fmt","","",150,[[["self"],["formatter"]],["result"]]],[11,"fold_item","","",148,[[["self"],["item"]],["option",["item"]]]],[11,"fold_item","","",149,[[["self"],["item"]],["option",["item"]]]],[11,"fold_item","","",156,[[["self"],["item"]],["option",["item"]]]],[0,"visit_ast","rustdoc","Rust AST Visitor. Extracts useful information and massages it into a form usable for clean",N,N],[3,"RustdocVisitor","rustdoc::visit_ast","",N,N],[12,"module","","",157,N],[12,"attrs","","",157,N],[12,"cx","","",157,N],[12,"view_item_stack","","",157,N],[12,"inlining","","",157,N],[12,"inside_public_path","","Is the current module and all of its parents public?",157,N],[12,"exact_paths","","",157,N],[11,"new","","",157,[[["doccontext"]],["rustdocvisitor"]]],[11,"store_path","","",157,[[["self"],["defid"]]]],[11,"stability","","",157,[[["self"],["nodeid"]],["option",["stability"]]]],[11,"deprecation","","",157,[[["self"],["nodeid"]],["option",["deprecation"]]]],[11,"visit","","",157,[[["self"],["crate"]]]],[11,"visit_variant_data","","",157,[[["self"],["item"],["name"],["variantdata"],["generics"]],["struct"]]],[11,"visit_union_data","","",157,[[["self"],["item"],["name"],["variantdata"],["generics"]],["union"]]],[11,"visit_enum_def","","",157,[[["self"],["item"],["name"],["enumdef"],["generics"]],["enum"]]],[11,"visit_fn","","",157,[[["self"],["item"],["name"],["fndecl"],["fnheader"],["generics"],["bodyid"]],["function"]]],[11,"visit_mod_contents","","",157,[[["self"],["span"],["hirvec",["attribute"]],["visibility"],["nodeid"],["mod"],["option",["name"]]],["module"]]],[11,"maybe_inline_local","","Tries to resolve the target of a `pub use` statement and inlines the target if it is defined locally and would not be documented otherwise, or when it is specifically requested with `please_inline`. (the latter is the case when the import is marked `doc(inline)`)",157,[[["self"],["nodeid"],["def"],["option",["name"]],["bool"],["module"],["bool"]],["bool"]]],[11,"visit_item","","",157,[[["self"],["item"],["option",["name"]],["module"]]]],[11,"visit_local_macro","","",157,[[["self"],["macrodef"]],["macro"]]],[0,"visit_lib","rustdoc","",N,N],[3,"LibEmbargoVisitor","rustdoc::visit_lib","Similar to `librustc_privacy::EmbargoVisitor`, but also takes specific rustdoc annotations into account (i.e. `doc(hidden)`)",N,N],[12,"cx","","",158,N],[12,"access_levels","","",158,N],[12,"prev_level","","",158,N],[12,"visited_mods","","",158,N],[11,"new","","",158,[[["doccontext"]],["libembargovisitor"]]],[11,"visit_lib","","",158,[[["self"],["cratenum"]]]],[11,"update","","",158,[[["self"],["defid"],["option",["accesslevel"]]],["option",["accesslevel"]]]],[11,"visit_mod","","",158,[[["self"],["defid"]]]],[11,"visit_item","","",158,[[["self"],["def"]]]],[0,"test","rustdoc","",N,N],[3,"TestOptions","rustdoc::test","",N,N],[12,"no_crate_inject","","Whether to disable the default `extern crate my_crate;` when creating doctests.",159,N],[12,"display_warnings","","Whether to emit compilation warnings when compiling doctests. Setting this will suppress the default `#![allow(unused)]`.",159,N],[12,"attrs","","Additional crate-level attributes to add to doctests.",159,N],[3,"Collector","","",N,N],[12,"tests","","",160,N],[12,"names","","",160,N],[12,"cfgs","","",160,N],[12,"libs","","",160,N],[12,"cg","","",160,N],[12,"externs","","",160,N],[12,"use_headers","","",160,N],[12,"cratename","","",160,N],[12,"opts","","",160,N],[12,"maybe_sysroot","","",160,N],[12,"position","","",160,N],[12,"codemap","","",160,N],[12,"filename","","",160,N],[12,"linker","","",160,N],[12,"edition","","",160,N],[3,"HirCollector","","",N,N],[12,"sess","","",161,N],[12,"collector","","",161,N],[12,"map","","",161,N],[5,"run","","",N,[[["path"],["vec",["string"]],["searchpaths"],["externs"],["vec",["string"]],["option",["string"]],["option",["pathbuf"]],["bool"],["option",["pathbuf"]],["edition"],["codegenoptions"]],["isize"]]],[5,"scrape_test_config","","",N,[[["crate"]],["testoptions"]]],[5,"run_test","","",N,[[["str"],["str"],["filename"],["usize"],["vec",["string"]],["searchpaths"],["codegenoptions"],["externs"],["bool"],["bool"],["bool"],["bool"],["vec",["string"]],["testoptions"],["option",["pathbuf"]],["option",["pathbuf"]],["edition"]]]],[5,"make_test","","Makes the test file. Also returns the number of lines before the code begins",N,N],[5,"partition_source","","",N,N],[11,"clone","","",159,[[["self"]],["testoptions"]]],[11,"default","","",159,[[],["testoptions"]]],[11,"new","","",160,[[["string"],["vec",["string"]],["searchpaths"],["codegenoptions"],["externs"],["bool"],["testoptions"],["option",["pathbuf"]],["option",["lrc"]],["option",["pathbuf"]],["option",["pathbuf"]],["edition"]],["collector"]]],[11,"generate_name","","",160,[[["self"],["usize"],["filename"]],["string"]]],[11,"add_test","","",160,[[["self"],["string"],["bool"],["bool"],["bool"],["bool"],["bool"],["vec",["string"]],["usize"],["filename"],["bool"]]]],[11,"get_line","","",160,[[["self"]],["usize"]]],[11,"set_position","","",160,[[["self"],["span"]]]],[11,"get_filename","","",160,[[["self"]],["filename"]]],[11,"register_header","","",160,[[["self"],["str"],["u32"]]]],[11,"visit_testable","","",161,N],[11,"nested_visit_map","","",161,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",161,[[["self"],["item"]]]],[11,"visit_trait_item","","",161,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",161,[[["self"],["implitem"]]]],[11,"visit_foreign_item","","",161,[[["self"],["foreignitem"]]]],[11,"visit_variant","","",161,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",161,[[["self"],["structfield"]]]],[11,"visit_macro_def","","",161,[[["self"],["macrodef"]]]],[0,"theme","rustdoc","",N,N],[3,"CssPath","rustdoc::theme","",N,N],[12,"name","","",162,N],[12,"children","","",162,N],[4,"Events","","All variants contain the position they occur.",N,N],[13,"StartLineComment","","",163,N],[13,"StartComment","","",163,N],[13,"EndComment","","",163,N],[13,"InBlock","","",163,N],[13,"OutBlock","","",163,N],[5,"previous_is_line_comment","","",N,N],[5,"is_line_comment","","",N,N],[5,"load_css_events","","",N,N],[5,"get_useful_next","","",N,N],[5,"get_previous_positions","","",N,N],[5,"build_rule","","",N,N],[5,"inner","","",N,N],[5,"load_css_paths","","",N,N],[5,"get_differences","","",N,[[["csspath"],["csspath"],["vec"]]]],[5,"test_theme_against","","",N,N],[11,"fmt","","",162,[[["self"],["formatter"]],["result"]]],[11,"clone","","",162,[[["self"]],["csspath"]]],[11,"assert_receiver_is_total_eq","","",162,N],[11,"eq","","",162,[[["self"],["csspath"]],["bool"]]],[11,"hash","","",162,[[["self"],["h"]]]],[11,"new","","",162,[[["string"]],["csspath"]]],[11,"fmt","","",163,[[["self"],["formatter"]],["result"]]],[11,"clone","","",163,[[["self"]],["events"]]],[11,"get_pos","","",163,[[["self"]],["usize"]]],[11,"is_comment","","",163,[[["self"]],["bool"]]],[11,"clean","rustdoc::visit_ast","",157,[[["self"],["doccontext"]],["crate"]]],[11,"clean","rustdoc::doctree","",75,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",80,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",85,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",76,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",77,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",78,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",79,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",81,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",82,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",83,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",84,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",86,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",88,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",89,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",87,[[["self"],["doccontext"]],["item"]]],[11,"filestem","rustdoc::core","",70,[[["self"]],["string"]]],[11,"get_input","","",70,[[["self"]],["option",["string"]]]],[11,"clone","","",71,[[["self"]],["codegenoptions"]]],[11,"clone","","",72,[[["self"]],["searchpaths"]]],[11,"fmt","","",72,[[["self"],["formatter"]],["result",["error"]]]],[11,"new","","",72,[[],["searchpaths"]]],[11,"add_path","","",72,N],[11,"iter","","",72,[[["self"],["pathkind"]],["iter"]]]],"paths":[[3,"Output"],[3,"ExternalHtml"],[4,"LoadStringError"],[3,"Crate"],[3,"ExternalCrate"],[3,"Item"],[3,"Module"],[3,"ListAttributesIter"],[3,"Attributes"],[3,"Lifetime"],[3,"GenericParamDef"],[3,"Generics"],[3,"Method"],[3,"TyMethod"],[3,"Function"],[3,"FnDecl"],[3,"Arguments"],[3,"Argument"],[3,"Trait"],[3,"PolyTrait"],[3,"Struct"],[3,"Union"],[3,"VariantStruct"],[3,"Enum"],[3,"Variant"],[3,"Span"],[3,"Path"],[3,"PathSegment"],[3,"Typedef"],[3,"Existential"],[3,"BareFunctionDecl"],[3,"Static"],[3,"Constant"],[3,"Impl"],[3,"ImportSource"],[3,"Macro"],[3,"Stability"],[3,"Deprecation"],[3,"TypeBinding"],[3,"RegionDeps"],[4,"ItemEnum"],[4,"DocFragment"],[4,"PathKind"],[4,"GenericBound"],[4,"WherePredicate"],[4,"GenericParamDefKind"],[4,"SelfTy"],[4,"FunctionRetTy"],[4,"Type"],[4,"PrimitiveType"],[4,"TypeKind"],[4,"Visibility"],[4,"VariantKind"],[4,"GenericArgs"],[4,"Mutability"],[4,"ImplPolarity"],[4,"Import"],[4,"RegionTarget"],[4,"SimpleBound"],[4,"AutoTraitResult"],[3,"InvalidCfgError"],[3,"Html"],[4,"Cfg"],[3,"AutoTraitFinder"],[3,"RegionReplacer"],[8,"Clean"],[8,"AttributesExt"],[8,"NestedAttributesExt"],[8,"GetDefId"],[8,"ToSource"],[4,"Input"],[3,"CodegenOptions"],[3,"SearchPaths"],[3,"DocContext"],[8,"DocAccessLevels"],[3,"Module"],[3,"Struct"],[3,"Union"],[3,"Enum"],[3,"Variant"],[3,"Function"],[3,"Typedef"],[3,"Existential"],[3,"Static"],[3,"Constant"],[3,"Trait"],[3,"Impl"],[3,"Macro"],[3,"ExternCrate"],[3,"Import"],[4,"StructType"],[3,"StripItem"],[8,"DocFolder"],[3,"Classifier"],[4,"Class"],[8,"Writer"],[3,"Escape"],[4,"ItemType"],[4,"NameSpace"],[3,"VisSpace"],[3,"UnsafetySpace"],[3,"ConstnessSpace"],[3,"AsyncSpace"],[3,"MutableSpace"],[3,"RawMutableSpace"],[3,"GenericBounds"],[3,"CommaSep"],[3,"AbiSpace"],[3,"Method"],[3,"WhereClause"],[3,"HRef"],[3,"Layout"],[3,"Page"],[3,"Markdown"],[3,"MarkdownWithToc"],[3,"MarkdownHtml"],[3,"MarkdownSummaryLine"],[3,"CodeBlocks"],[3,"LinkReplacer"],[3,"HeadingLinks"],[3,"SummaryLine"],[3,"Footnotes"],[3,"LangString"],[4,"Line"],[3,"Context"],[3,"SharedContext"],[3,"Impl"],[3,"Error"],[3,"Cache"],[3,"RenderInfo"],[3,"SourceCollector"],[3,"Source"],[3,"Item"],[3,"Sidebar"],[3,"IndexItem"],[3,"Type"],[3,"IndexItemFunctionType"],[3,"ItemEntry"],[3,"AllTypes"],[3,"Settings"],[3,"Initializer"],[4,"ExternalLocation"],[4,"AssocItemLink"],[4,"AssocItemRender"],[4,"RenderMode"],[3,"Toc"],[3,"TocEntry"],[3,"TocBuilder"],[3,"Stripper"],[3,"ImplStripper"],[4,"DefaultPassOption"],[4,"DocFragmentKind"],[3,"Collapser"],[3,"Stripper"],[3,"CommentCleaner"],[3,"CfgPropagator"],[3,"ImportStripper"],[3,"RustdocVisitor"],[3,"LibEmbargoVisitor"],[3,"TestOptions"],[3,"Collector"],[3,"HirCollector"],[3,"CssPath"],[4,"Events"]]};
searchIndex["rustdoc_tool_binary"]={"doc":"","items":[[5,"main","rustdoc_tool_binary","",N,[[]]]],"paths":[]};
searchIndex["serialize"]={"doc":"Support code for encoding and decoding types.","items":[[0,"serialize","serialize","Support code for encoding and decoding types.",N,N],[8,"Encoder","serialize::serialize","",N,N],[16,"Error","","",0,N],[10,"emit_nil","","",0,[[["self"]],["result"]]],[10,"emit_usize","","",0,[[["self"],["usize"]],["result"]]],[10,"emit_u128","","",0,[[["self"],["u128"]],["result"]]],[10,"emit_u64","","",0,[[["self"],["u64"]],["result"]]],[10,"emit_u32","","",0,[[["self"],["u32"]],["result"]]],[10,"emit_u16","","",0,[[["self"],["u16"]],["result"]]],[10,"emit_u8","","",0,[[["self"],["u8"]],["result"]]],[10,"emit_isize","","",0,[[["self"],["isize"]],["result"]]],[10,"emit_i128","","",0,[[["self"],["i128"]],["result"]]],[10,"emit_i64","","",0,[[["self"],["i64"]],["result"]]],[10,"emit_i32","","",0,[[["self"],["i32"]],["result"]]],[10,"emit_i16","","",0,[[["self"],["i16"]],["result"]]],[10,"emit_i8","","",0,[[["self"],["i8"]],["result"]]],[10,"emit_bool","","",0,[[["self"],["bool"]],["result"]]],[10,"emit_f64","","",0,[[["self"],["f64"]],["result"]]],[10,"emit_f32","","",0,[[["self"],["f32"]],["result"]]],[10,"emit_char","","",0,[[["self"],["char"]],["result"]]],[10,"emit_str","","",0,[[["self"],["str"]],["result"]]],[11,"emit_enum","","",0,[[["self"],["str"],["f"]],["result"]]],[11,"emit_enum_variant","","",0,[[["self"],["str"],["usize"],["usize"],["f"]],["result"]]],[11,"emit_enum_variant_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_enum_struct_variant","","",0,[[["self"],["str"],["usize"],["usize"],["f"]],["result"]]],[11,"emit_enum_struct_variant_field","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_struct","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_struct_field","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_tuple","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_tuple_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_tuple_struct","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_tuple_struct_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_option","","",0,[[["self"],["f"]],["result"]]],[11,"emit_option_none","","",0,[[["self"]],["result"]]],[11,"emit_option_some","","",0,[[["self"],["f"]],["result"]]],[11,"emit_seq","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_seq_elt","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map_elt_key","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map_elt_val","","",0,[[["self"],["usize"],["f"]],["result"]]],[8,"Decoder","","",N,N],[16,"Error","","",1,N],[10,"read_nil","","",1,[[["self"]],["result"]]],[10,"read_usize","","",1,[[["self"]],["result",["usize"]]]],[10,"read_u128","","",1,[[["self"]],["result",["u128"]]]],[10,"read_u64","","",1,[[["self"]],["result",["u64"]]]],[10,"read_u32","","",1,[[["self"]],["result",["u32"]]]],[10,"read_u16","","",1,[[["self"]],["result",["u16"]]]],[10,"read_u8","","",1,[[["self"]],["result",["u8"]]]],[10,"read_isize","","",1,[[["self"]],["result",["isize"]]]],[10,"read_i128","","",1,[[["self"]],["result",["i128"]]]],[10,"read_i64","","",1,[[["self"]],["result",["i64"]]]],[10,"read_i32","","",1,[[["self"]],["result",["i32"]]]],[10,"read_i16","","",1,[[["self"]],["result",["i16"]]]],[10,"read_i8","","",1,[[["self"]],["result",["i8"]]]],[10,"read_bool","","",1,[[["self"]],["result",["bool"]]]],[10,"read_f64","","",1,[[["self"]],["result",["f64"]]]],[10,"read_f32","","",1,[[["self"]],["result",["f32"]]]],[10,"read_char","","",1,[[["self"]],["result",["char"]]]],[10,"read_str","","",1,[[["self"]],["result",["cow"]]]],[11,"read_enum","","",1,[[["self"],["str"],["f"]],["result"]]],[11,"read_enum_variant","","",1,N],[11,"read_enum_variant_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_enum_struct_variant","","",1,N],[11,"read_enum_struct_variant_field","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_struct","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_struct_field","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_tuple","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_tuple_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_tuple_struct","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_tuple_struct_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_option","","",1,[[["self"],["f"]],["result"]]],[11,"read_seq","","",1,[[["self"],["f"]],["result"]]],[11,"read_seq_elt","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_map","","",1,[[["self"],["f"]],["result"]]],[11,"read_map_elt_key","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_map_elt_val","","",1,[[["self"],["usize"],["f"]],["result"]]],[10,"error","","",1,N],[8,"Encodable","","",N,N],[10,"encode","","",2,[[["self"],["s"]],["result"]]],[8,"Decodable","","",N,N],[10,"decode","","",3,[[["d"]],["result"]]],[8,"SpecializationError","","Implement this trait on your `{Encodable,Decodable}::Error` types to override the default panic behavior for missing specializations.",N,N],[10,"not_found","","Create an error for a missing method specialization. Defaults to panicking with type, trait & method names. `S` is the encoder/decoder state type, `T` is the type being encoded/decoded, and the arguments are the names of the trait and method that should've been overridden.",4,[[["str"],["str"]],["self"]]],[8,"SpecializedEncoder","","Implement this trait on encoders, with `T` being the type you want to encode (employing `UseSpecializedEncodable`), using a strategy specific to the encoder.",N,N],[10,"specialized_encode","","Encode the value in a manner specific to this encoder state.",5,[[["self"],["t"]],["result"]]],[8,"SpecializedDecoder","","Implement this trait on decoders, with `T` being the type you want to decode (employing `UseSpecializedDecodable`), using a strategy specific to the decoder.",N,N],[10,"specialized_decode","","Decode a value in a manner specific to this decoder state.",6,[[["self"]],["result"]]],[8,"UseSpecializedEncodable","","Implement this trait on your type to get an `Encodable` implementation which goes through `SpecializedEncoder`.",N,N],[11,"default_encode","","Defaults to returning an error (see `SpecializationError`).",7,[[["self"],["e"]],["result"]]],[8,"UseSpecializedDecodable","","Implement this trait on your type to get an `Decodable` implementation which goes through `SpecializedDecoder`.",N,N],[11,"default_decode","","Defaults to returning an error (see `SpecializationError`).",8,[[["d"]],["result"]]],[0,"collection_impls","serialize","Implementations of serialization for structures found in liballoc",N,N],[0,"hex","","Hex binary-to-text encoding",N,N],[4,"FromHexError","serialize::hex","Errors that can occur when decoding a hex encoded string",N,N],[13,"InvalidHexCharacter","","The input contained a character not part of the hex format",9,N],[13,"InvalidHexLength","","The input had an invalid length",9,N],[17,"CHARS","","",N,N],[8,"ToHex","","A trait for converting a value to hexadecimal encoding",N,N],[10,"to_hex","","Converts the value of `self` to a hex value, returning the owned string.",10,[[["self"]],["string"]]],[8,"FromHex","","A trait for converting hexadecimal encoded values",N,N],[10,"from_hex","","Converts the value of `self`, interpreted as hexadecimal encoded data, into an owned vector of bytes, returning the vector.",11,[[["self"]],["result",["vec","fromhexerror"]]]],[11,"clone","","",9,[[["self"]],["fromhexerror"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"description","","",9,[[["self"]],["str"]]],[0,"json","serialize","JSON parsing and serialization",N,N],[3,"PrettyJson","serialize::json","",N,N],[12,"inner","","",12,N],[3,"AsJson","","",N,N],[12,"inner","","",13,N],[3,"AsPrettyJson","","",N,N],[12,"inner","","",14,N],[12,"indent","","",14,N],[3,"Encoder","","A structure for implementing serialization to JSON.",N,N],[12,"writer","","",15,N],[12,"is_emitting_map_key","","",15,N],[3,"PrettyEncoder","","Another encoder for JSON, but prints out human-readable JSON instead of compact data",N,N],[12,"writer","","",16,N],[12,"curr_indent","","",16,N],[12,"indent","","",16,N],[12,"is_emitting_map_key","","",16,N],[3,"Stack","","A Stack represents the current position of the parser in the logical structure of the JSON stream. For example foo.bar[3].x",N,N],[12,"stack","","",17,N],[12,"str_buffer","","",17,N],[3,"Parser","","A streaming JSON parser implemented as an iterator of JsonEvent, consuming an iterator of char.",N,N],[12,"rdr","","",18,N],[12,"ch","","",18,N],[12,"line","","",18,N],[12,"col","","",18,N],[12,"stack","","",18,N],[12,"state","","",18,N],[3,"Builder","","A Builder consumes a json::Parser to create a generic Json structure.",N,N],[12,"parser","","",19,N],[12,"token","","",19,N],[3,"Decoder","","A structure to decode JSON to values in rust.",N,N],[12,"stack","","",20,N],[3,"FormatShim","","",N,N],[12,"inner","","",21,N],[4,"Json","","Represents a json value",N,N],[13,"I64","","",22,N],[13,"U64","","",22,N],[13,"F64","","",22,N],[13,"String","","",22,N],[13,"Boolean","","",22,N],[13,"Array","","",22,N],[13,"Object","","",22,N],[13,"Null","","",22,N],[4,"ErrorCode","","The errors that can arise while parsing a JSON stream.",N,N],[13,"InvalidSyntax","","",23,N],[13,"InvalidNumber","","",23,N],[13,"EOFWhileParsingObject","","",23,N],[13,"EOFWhileParsingArray","","",23,N],[13,"EOFWhileParsingValue","","",23,N],[13,"EOFWhileParsingString","","",23,N],[13,"KeyMustBeAString","","",23,N],[13,"ExpectedColon","","",23,N],[13,"TrailingCharacters","","",23,N],[13,"TrailingComma","","",23,N],[13,"InvalidEscape","","",23,N],[13,"InvalidUnicodeCodePoint","","",23,N],[13,"LoneLeadingSurrogateInHexEscape","","",23,N],[13,"UnexpectedEndOfHexEscape","","",23,N],[13,"UnrecognizedHex","","",23,N],[13,"NotFourDigit","","",23,N],[13,"NotUtf8","","",23,N],[4,"ParserError","","",N,N],[13,"SyntaxError","","msg, line, col",24,N],[13,"IoError","","",24,N],[4,"DecoderError","","",N,N],[13,"ParseError","","",25,N],[13,"ExpectedError","","",25,N],[13,"MissingFieldError","","",25,N],[13,"UnknownVariantError","","",25,N],[13,"ApplicationError","","",25,N],[4,"EncoderError","","",N,N],[13,"FmtError","","",26,N],[13,"BadHashmapKey","","",26,N],[4,"JsonEvent","","The output of the streaming parser.",N,N],[13,"ObjectStart","","",27,N],[13,"ObjectEnd","","",27,N],[13,"ArrayStart","","",27,N],[13,"ArrayEnd","","",27,N],[13,"BooleanValue","","",27,N],[13,"I64Value","","",27,N],[13,"U64Value","","",27,N],[13,"F64Value","","",27,N],[13,"StringValue","","",27,N],[13,"NullValue","","",27,N],[13,"Error","","",27,N],[4,"ParserState","","",N,N],[13,"ParseArray","","",28,N],[13,"ParseArrayComma","","",28,N],[13,"ParseObject","","",28,N],[13,"ParseObjectComma","","",28,N],[13,"ParseStart","","",28,N],[13,"ParseBeforeFinish","","",28,N],[13,"ParseFinished","","",28,N],[4,"StackElement","","StackElements compose a Stack. For example, StackElement::Key(\"foo\"), StackElement::Key(\"bar\"), StackElement::Index(3) and StackElement::Key(\"x\") are the StackElements compositing the stack that represents foo.bar[3].x",N,N],[13,"Index","","",29,N],[13,"Key","","",29,N],[4,"InternalStackElement","","",N,N],[13,"InternalIndex","","",30,N],[13,"InternalKey","","",30,N],[5,"error_str","","Returns a readable error string for a given error code.",N,[[["errorcode"]],["str"]]],[5,"decode","","Shortcut function to decode a JSON `&str` into an object",N,[[["str"]],["decoderesult"]]],[5,"encode","","Shortcut function to encode a `T` into a JSON `String`",N,[[["t"]],["result",["string","encodererror"]]]],[5,"io_error_to_error","","",N,[[["error"]],["parsererror"]]],[5,"escape_str","","",N,[[["write"],["str"]],["encoderesult"]]],[5,"escape_char","","",N,[[["write"],["char"]],["encoderesult"]]],[5,"spaces","","",N,[[["write"],["usize"]],["encoderesult"]]],[5,"fmt_number_or_null","","",N,[[["f64"]],["string"]]],[5,"as_json","","Create an `AsJson` wrapper which can be used to print a value as JSON on-the-fly via `write!`",N,[[["t"]],["asjson"]]],[5,"as_pretty_json","","Create an `AsPrettyJson` wrapper which can be used to print a value as JSON on-the-fly via `write!`",N,[[["t"]],["asprettyjson"]]],[5,"from_reader","","Decodes a json value from an `&mut io::Read`",N,[[["read"]],["result",["json","buildererror"]]]],[5,"from_str","","Decodes a json value from a string",N,[[["str"]],["result",["json","buildererror"]]]],[6,"Array","","",N,N],[6,"Object","","",N,N],[6,"BuilderError","","",N,N],[6,"EncodeResult","","",N,N],[6,"DecodeResult","","",N,N],[8,"ToJson","","A trait for converting values to JSON",N,N],[10,"to_json","","Converts the value of `self` to an instance of JSON",31,[[["self"]],["json"]]],[11,"clone","","",22,[[["self"]],["json"]]],[11,"eq","","",22,[[["self"],["json"]],["bool"]]],[11,"ne","","",22,[[["self"],["json"]],["bool"]]],[11,"partial_cmp","","",22,[[["self"],["json"]],["option",["ordering"]]]],[11,"lt","","",22,[[["self"],["json"]],["bool"]]],[11,"le","","",22,[[["self"],["json"]],["bool"]]],[11,"gt","","",22,[[["self"],["json"]],["bool"]]],[11,"ge","","",22,[[["self"],["json"]],["bool"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",23,[[["self"]],["errorcode"]]],[11,"eq","","",23,[[["self"],["errorcode"]],["bool"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"clone","","",24,[[["self"]],["parsererror"]]],[11,"eq","","",24,[[["self"],["parsererror"]],["bool"]]],[11,"ne","","",24,[[["self"],["parsererror"]],["bool"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"clone","","",25,[[["self"]],["decodererror"]]],[11,"eq","","",25,[[["self"],["decodererror"]],["bool"]]],[11,"ne","","",25,[[["self"],["decodererror"]],["bool"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"clone","","",26,[[["self"]],["encodererror"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"description","","",25,[[["self"]],["str"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"description","","",26,[[["self"]],["str"]]],[11,"from","","",26,[[["error"]],["encodererror"]]],[11,"new","","Creates a new JSON encoder whose output will be written to the writer specified.",15,[[["write"]],["encoder"]]],[11,"emit_nil","","",15,[[["self"]],["encoderesult"]]],[11,"emit_usize","","",15,[[["self"],["usize"]],["encoderesult"]]],[11,"emit_u128","","",15,[[["self"],["u128"]],["encoderesult"]]],[11,"emit_u64","","",15,[[["self"],["u64"]],["encoderesult"]]],[11,"emit_u32","","",15,[[["self"],["u32"]],["encoderesult"]]],[11,"emit_u16","","",15,[[["self"],["u16"]],["encoderesult"]]],[11,"emit_u8","","",15,[[["self"],["u8"]],["encoderesult"]]],[11,"emit_isize","","",15,[[["self"],["isize"]],["encoderesult"]]],[11,"emit_i128","","",15,[[["self"],["i128"]],["encoderesult"]]],[11,"emit_i64","","",15,[[["self"],["i64"]],["encoderesult"]]],[11,"emit_i32","","",15,[[["self"],["i32"]],["encoderesult"]]],[11,"emit_i16","","",15,[[["self"],["i16"]],["encoderesult"]]],[11,"emit_i8","","",15,[[["self"],["i8"]],["encoderesult"]]],[11,"emit_bool","","",15,[[["self"],["bool"]],["encoderesult"]]],[11,"emit_f64","","",15,[[["self"],["f64"]],["encoderesult"]]],[11,"emit_f32","","",15,[[["self"],["f32"]],["encoderesult"]]],[11,"emit_char","","",15,[[["self"],["char"]],["encoderesult"]]],[11,"emit_str","","",15,[[["self"],["str"]],["encoderesult"]]],[11,"emit_enum","","",15,[[["self"],["str"],["f"]],["encoderesult"]]],[11,"emit_enum_variant","","",15,[[["self"],["str"],["usize"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_variant_arg","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_struct_variant","","",15,[[["self"],["str"],["usize"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_struct_variant_field","","",15,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_struct","","",15,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_struct_field","","",15,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_arg","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_struct","","",15,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_struct_arg","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_option","","",15,[[["self"],["f"]],["encoderesult"]]],[11,"emit_option_none","","",15,[[["self"]],["encoderesult"]]],[11,"emit_option_some","","",15,[[["self"],["f"]],["encoderesult"]]],[11,"emit_seq","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_seq_elt","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map_elt_key","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map_elt_val","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"new","","Creates a new encoder whose output will be written to the specified writer",16,[[["write"]],["prettyencoder"]]],[11,"set_indent","","Set the number of spaces to indent for each level. This is safe to set during encoding.",16,[[["self"],["usize"]]]],[11,"emit_nil","","",16,[[["self"]],["encoderesult"]]],[11,"emit_usize","","",16,[[["self"],["usize"]],["encoderesult"]]],[11,"emit_u128","","",16,[[["self"],["u128"]],["encoderesult"]]],[11,"emit_u64","","",16,[[["self"],["u64"]],["encoderesult"]]],[11,"emit_u32","","",16,[[["self"],["u32"]],["encoderesult"]]],[11,"emit_u16","","",16,[[["self"],["u16"]],["encoderesult"]]],[11,"emit_u8","","",16,[[["self"],["u8"]],["encoderesult"]]],[11,"emit_isize","","",16,[[["self"],["isize"]],["encoderesult"]]],[11,"emit_i128","","",16,[[["self"],["i128"]],["encoderesult"]]],[11,"emit_i64","","",16,[[["self"],["i64"]],["encoderesult"]]],[11,"emit_i32","","",16,[[["self"],["i32"]],["encoderesult"]]],[11,"emit_i16","","",16,[[["self"],["i16"]],["encoderesult"]]],[11,"emit_i8","","",16,[[["self"],["i8"]],["encoderesult"]]],[11,"emit_bool","","",16,[[["self"],["bool"]],["encoderesult"]]],[11,"emit_f64","","",16,[[["self"],["f64"]],["encoderesult"]]],[11,"emit_f32","","",16,[[["self"],["f32"]],["encoderesult"]]],[11,"emit_char","","",16,[[["self"],["char"]],["encoderesult"]]],[11,"emit_str","","",16,[[["self"],["str"]],["encoderesult"]]],[11,"emit_enum","","",16,[[["self"],["str"],["f"]],["encoderesult"]]],[11,"emit_enum_variant","","",16,[[["self"],["str"],["usize"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_variant_arg","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_struct_variant","","",16,[[["self"],["str"],["usize"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_struct_variant_field","","",16,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_struct","","",16,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_struct_field","","",16,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_arg","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_struct","","",16,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_struct_arg","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_option","","",16,[[["self"],["f"]],["encoderesult"]]],[11,"emit_option_none","","",16,[[["self"]],["encoderesult"]]],[11,"emit_option_some","","",16,[[["self"],["f"]],["encoderesult"]]],[11,"emit_seq","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_seq_elt","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map_elt_key","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map_elt_val","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"encode","","",22,[[["self"],["e"]],["result"]]],[11,"pretty","","Borrow this json object as a pretty object to generate a pretty representation for it via `Display`.",22,[[["self"]],["prettyjson"]]],[11,"find","","If the Json value is an Object, returns the value associated with the provided key. Otherwise, returns None.",22,[[["self"],["str"]],["option",["json"]]]],[11,"find_path","","Attempts to get a nested Json Object for each key in `keys`. If any key is found not to exist, find_path will return None. Otherwise, it will return the Json value associated with the final key.",22,N],[11,"search","","If the Json value is an Object, performs a depth-first search until a value associated with the provided key is found. If no value is found or the Json value is not an Object, returns None.",22,[[["self"],["str"]],["option",["json"]]]],[11,"is_object","","Returns true if the Json value is an Object. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_object","","If the Json value is an Object, returns the associated BTreeMap. Returns None otherwise.",22,[[["self"]],["option",["object"]]]],[11,"is_array","","Returns true if the Json value is an Array. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_array","","If the Json value is an Array, returns the associated vector. Returns None otherwise.",22,[[["self"]],["option",["array"]]]],[11,"is_string","","Returns true if the Json value is a String. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_string","","If the Json value is a String, returns the associated str. Returns None otherwise.",22,[[["self"]],["option",["str"]]]],[11,"is_number","","Returns true if the Json value is a Number. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"is_i64","","Returns true if the Json value is a i64. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"is_u64","","Returns true if the Json value is a u64. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"is_f64","","Returns true if the Json value is a f64. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_i64","","If the Json value is a number, return or cast it to a i64. Returns None otherwise.",22,[[["self"]],["option",["i64"]]]],[11,"as_u64","","If the Json value is a number, return or cast it to a u64. Returns None otherwise.",22,[[["self"]],["option",["u64"]]]],[11,"as_f64","","If the Json value is a number, return or cast it to a f64. Returns None otherwise.",22,[[["self"]],["option",["f64"]]]],[11,"is_boolean","","Returns true if the Json value is a Boolean. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_boolean","","If the Json value is a Boolean, returns the associated bool. Returns None otherwise.",22,[[["self"]],["option",["bool"]]]],[11,"is_null","","Returns true if the Json value is a Null. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_null","","If the Json value is a Null, returns (). Returns None otherwise.",22,[[["self"]],["option"]]],[11,"index","","",22,[[["self"],["str"]],["json"]]],[11,"index","","",22,[[["self"],["usize"]],["json"]]],[11,"eq","","",27,[[["self"],["jsonevent"]],["bool"]]],[11,"ne","","",27,[[["self"],["jsonevent"]],["bool"]]],[11,"clone","","",27,[[["self"]],["jsonevent"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"eq","","",28,[[["self"],["parserstate"]],["bool"]]],[11,"ne","","",28,[[["self"],["parserstate"]],["bool"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"eq","","",29,[[["self"],["stackelement"]],["bool"]]],[11,"ne","","",29,[[["self"],["stackelement"]],["bool"]]],[11,"clone","","",29,[[["self"]],["stackelement"]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"eq","","",30,[[["self"],["internalstackelement"]],["bool"]]],[11,"ne","","",30,[[["self"],["internalstackelement"]],["bool"]]],[11,"clone","","",30,[[["self"]],["internalstackelement"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"new","","",17,[[],["stack"]]],[11,"len","","Returns The number of elements in the Stack.",17,[[["self"]],["usize"]]],[11,"is_empty","","Returns true if the stack is empty.",17,[[["self"]],["bool"]]],[11,"get","","Provides access to the StackElement at a given index. lower indices are at the bottom of the stack while higher indices are at the top.",17,[[["self"],["usize"]],["stackelement"]]],[11,"is_equal_to","","Compares this stack with an array of StackElements.",17,N],[11,"starts_with","","Returns true if the bottom-most elements of this stack are the same as the ones passed as parameter.",17,N],[11,"ends_with","","Returns true if the top-most elements of this stack are the same as the ones passed as parameter.",17,N],[11,"top","","Returns the top-most element (if any).",17,[[["self"]],["option",["stackelement"]]]],[11,"push_key","","",17,[[["self"],["string"]]]],[11,"push_index","","",17,[[["self"],["u32"]]]],[11,"pop","","",17,[[["self"]]]],[11,"last_is_index","","",17,[[["self"]],["bool"]]],[11,"bump_index","","",17,[[["self"]]]],[11,"next","","",18,[[["self"]],["option",["jsonevent"]]]],[11,"new","","Creates the JSON parser.",18,[[["t"]],["parser"]]],[11,"stack","","Provides access to the current position in the logical structure of the JSON stream.",18,[[["self"]],["stack"]]],[11,"eof","","",18,[[["self"]],["bool"]]],[11,"ch_or_null","","",18,[[["self"]],["char"]]],[11,"bump","","",18,[[["self"]]]],[11,"next_char","","",18,[[["self"]],["option",["char"]]]],[11,"ch_is","","",18,[[["self"],["char"]],["bool"]]],[11,"error","","",18,[[["self"],["errorcode"]],["result",["parsererror"]]]],[11,"parse_whitespace","","",18,[[["self"]]]],[11,"parse_number","","",18,[[["self"]],["jsonevent"]]],[11,"parse_u64","","",18,[[["self"]],["result",["u64","parsererror"]]]],[11,"parse_decimal","","",18,[[["self"],["f64"]],["result",["f64","parsererror"]]]],[11,"parse_exponent","","",18,[[["self"],["f64"]],["result",["f64","parsererror"]]]],[11,"decode_hex_escape","","",18,[[["self"]],["result",["u16","parsererror"]]]],[11,"parse_str","","",18,[[["self"]],["result",["string","parsererror"]]]],[11,"parse","","",18,[[["self"]],["jsonevent"]]],[11,"parse_start","","",18,[[["self"]],["jsonevent"]]],[11,"parse_array","","",18,[[["self"],["bool"]],["jsonevent"]]],[11,"parse_array_comma_or_end","","",18,[[["self"]],["option",["jsonevent"]]]],[11,"parse_object","","",18,[[["self"],["bool"]],["jsonevent"]]],[11,"parse_object_end","","",18,[[["self"]],["jsonevent"]]],[11,"parse_value","","",18,[[["self"]],["jsonevent"]]],[11,"parse_ident","","",18,[[["self"],["str"],["jsonevent"]],["jsonevent"]]],[11,"error_event","","",18,[[["self"],["errorcode"]],["jsonevent"]]],[11,"new","","Create a JSON Builder.",19,[[["t"]],["builder"]]],[11,"build","","",19,[[["self"]],["result",["json","buildererror"]]]],[11,"bump","","",19,[[["self"]]]],[11,"build_value","","",19,[[["self"]],["result",["json","buildererror"]]]],[11,"build_array","","",19,[[["self"]],["result",["json","buildererror"]]]],[11,"build_object","","",19,[[["self"]],["result",["json","buildererror"]]]],[11,"new","","Creates a new decoder instance for decoding the specified JSON value.",20,[[["json"]],["decoder"]]],[11,"pop","","",20,[[["self"]],["json"]]],[11,"read_nil","","",20,[[["self"]],["decoderesult"]]],[11,"read_usize","","",20,[[["self"]],["decoderesult",["usize"]]]],[11,"read_u8","","",20,[[["self"]],["decoderesult",["u8"]]]],[11,"read_u16","","",20,[[["self"]],["decoderesult",["u16"]]]],[11,"read_u32","","",20,[[["self"]],["decoderesult",["u32"]]]],[11,"read_u64","","",20,[[["self"]],["decoderesult",["u64"]]]],[11,"read_u128","","",20,[[["self"]],["decoderesult",["u128"]]]],[11,"read_isize","","",20,[[["self"]],["decoderesult",["isize"]]]],[11,"read_i8","","",20,[[["self"]],["decoderesult",["i8"]]]],[11,"read_i16","","",20,[[["self"]],["decoderesult",["i16"]]]],[11,"read_i32","","",20,[[["self"]],["decoderesult",["i32"]]]],[11,"read_i64","","",20,[[["self"]],["decoderesult",["i64"]]]],[11,"read_i128","","",20,[[["self"]],["decoderesult",["i128"]]]],[11,"read_f32","","",20,[[["self"]],["decoderesult",["f32"]]]],[11,"read_f64","","",20,[[["self"]],["decoderesult",["f64"]]]],[11,"read_bool","","",20,[[["self"]],["decoderesult",["bool"]]]],[11,"read_char","","",20,[[["self"]],["decoderesult",["char"]]]],[11,"read_str","","",20,[[["self"]],["decoderesult",["cow"]]]],[11,"read_enum","","",20,[[["self"],["str"],["f"]],["decoderesult"]]],[11,"read_enum_variant","","",20,N],[11,"read_enum_variant_arg","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_enum_struct_variant","","",20,N],[11,"read_enum_struct_variant_field","","",20,[[["self"],["str"],["usize"],["f"]],["decoderesult"]]],[11,"read_struct","","",20,[[["self"],["str"],["usize"],["f"]],["decoderesult"]]],[11,"read_struct_field","","",20,[[["self"],["str"],["usize"],["f"]],["decoderesult"]]],[11,"read_tuple","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_tuple_arg","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_tuple_struct","","",20,[[["self"],["str"],["usize"],["f"]],["decoderesult"]]],[11,"read_tuple_struct_arg","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_option","","",20,[[["self"],["f"]],["decoderesult"]]],[11,"read_seq","","",20,[[["self"],["f"]],["decoderesult"]]],[11,"read_seq_elt","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_map","","",20,[[["self"],["f"]],["decoderesult"]]],[11,"read_map_elt_key","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_map_elt_val","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"error","","",20,[[["self"],["str"]],["decodererror"]]],[11,"to_json","","",22,[[["self"]],["json"]]],[11,"write_str","","",21,[[["self"],["str"]],["result"]]],[11,"fmt","","Encodes a json value into a string",22,[[["self"],["formatter"]],["result"]]],[11,"fmt","","Encodes a json value into a string",12,[[["self"],["formatter"]],["result"]]],[11,"fmt","","Encodes a json value into a string",13,[[["self"],["formatter"]],["result"]]],[11,"indent","","Set the indentation level for the emitted JSON",14,[[["self"],["usize"]],["asprettyjson"]]],[11,"fmt","","Encodes a json value into a string",14,[[["self"],["formatter"]],["result"]]],[11,"from_str","","",22,[[["str"]],["result",["json","buildererror"]]]],[0,"opaque","serialize","",N,N],[3,"Encoder","serialize::opaque","",N,N],[12,"data","","",32,N],[3,"Decoder","","",N,N],[12,"data","","",33,N],[12,"position","","",33,N],[6,"EncodeResult","","",N,N],[11,"new","","",32,[[["vec",["u8"]]],["encoder"]]],[11,"into_inner","","",32,[[["self"]],["vec",["u8"]]]],[11,"emit_raw_bytes","","",32,N],[11,"emit_nil","","",32,[[["self"]],["encoderesult"]]],[11,"emit_usize","","",32,[[["self"],["usize"]],["encoderesult"]]],[11,"emit_u128","","",32,[[["self"],["u128"]],["encoderesult"]]],[11,"emit_u64","","",32,[[["self"],["u64"]],["encoderesult"]]],[11,"emit_u32","","",32,[[["self"],["u32"]],["encoderesult"]]],[11,"emit_u16","","",32,[[["self"],["u16"]],["encoderesult"]]],[11,"emit_u8","","",32,[[["self"],["u8"]],["encoderesult"]]],[11,"emit_isize","","",32,[[["self"],["isize"]],["encoderesult"]]],[11,"emit_i128","","",32,[[["self"],["i128"]],["encoderesult"]]],[11,"emit_i64","","",32,[[["self"],["i64"]],["encoderesult"]]],[11,"emit_i32","","",32,[[["self"],["i32"]],["encoderesult"]]],[11,"emit_i16","","",32,[[["self"],["i16"]],["encoderesult"]]],[11,"emit_i8","","",32,[[["self"],["i8"]],["encoderesult"]]],[11,"emit_bool","","",32,[[["self"],["bool"]],["encoderesult"]]],[11,"emit_f64","","",32,[[["self"],["f64"]],["encoderesult"]]],[11,"emit_f32","","",32,[[["self"],["f32"]],["encoderesult"]]],[11,"emit_char","","",32,[[["self"],["char"]],["encoderesult"]]],[11,"emit_str","","",32,[[["self"],["str"]],["encoderesult"]]],[11,"position","","",32,[[["self"]],["usize"]]],[11,"new","","",33,N],[11,"position","","",33,[[["self"]],["usize"]]],[11,"set_position","","",33,[[["self"],["usize"]]]],[11,"advance","","",33,[[["self"],["usize"]]]],[11,"read_raw_bytes","","",33,N],[11,"read_nil","","",33,[[["self"]],["result"]]],[11,"read_u128","","",33,[[["self"]],["result",["u128"]]]],[11,"read_u64","","",33,[[["self"]],["result",["u64"]]]],[11,"read_u32","","",33,[[["self"]],["result",["u32"]]]],[11,"read_u16","","",33,[[["self"]],["result",["u16"]]]],[11,"read_u8","","",33,[[["self"]],["result",["u8"]]]],[11,"read_usize","","",33,[[["self"]],["result",["usize"]]]],[11,"read_i128","","",33,[[["self"]],["result",["i128"]]]],[11,"read_i64","","",33,[[["self"]],["result",["i64"]]]],[11,"read_i32","","",33,[[["self"]],["result",["i32"]]]],[11,"read_i16","","",33,[[["self"]],["result",["i16"]]]],[11,"read_i8","","",33,[[["self"]],["result",["i8"]]]],[11,"read_isize","","",33,[[["self"]],["result",["isize"]]]],[11,"read_bool","","",33,[[["self"]],["result",["bool"]]]],[11,"read_f64","","",33,[[["self"]],["result",["f64"]]]],[11,"read_f32","","",33,[[["self"]],["result",["f32"]]]],[11,"read_char","","",33,[[["self"]],["result",["char"]]]],[11,"read_str","","",33,[[["self"]],["result",["cow"]]]],[11,"error","","",33,N],[0,"leb128","serialize","",N,N],[5,"write_to_vec","serialize::leb128","",N,[[["vec"],["u8"]]]],[5,"write_u16_leb128","","",N,[[["vec"],["u16"]]]],[5,"write_u32_leb128","","",N,[[["vec"],["u32"]]]],[5,"write_u64_leb128","","",N,[[["vec"],["u64"]]]],[5,"write_u128_leb128","","",N,[[["vec"],["u128"]]]],[5,"write_usize_leb128","","",N,[[["vec"],["usize"]]]],[5,"read_u16_leb128","","",N,N],[5,"read_u32_leb128","","",N,N],[5,"read_u64_leb128","","",N,N],[5,"read_u128_leb128","","",N,N],[5,"read_usize_leb128","","",N,N],[5,"write_signed_leb128_to","","encodes an integer using signed leb128 encoding and stores the result using a callback function.",N,[[["i128"],["w"]]]],[5,"write_signed_leb128","","",N,[[["vec"],["i128"]]]],[5,"read_signed_leb128","","",N,N],[17,"USIZE_LEB128_SIZE","","",N,N],[0,"rustc_serialize","serialize","",N,N],[8,"Decoder","","",N,N],[16,"Error","","",1,N],[10,"read_nil","","",1,[[["self"]],["result"]]],[10,"read_usize","","",1,[[["self"]],["result",["usize"]]]],[10,"read_u128","","",1,[[["self"]],["result",["u128"]]]],[10,"read_u64","","",1,[[["self"]],["result",["u64"]]]],[10,"read_u32","","",1,[[["self"]],["result",["u32"]]]],[10,"read_u16","","",1,[[["self"]],["result",["u16"]]]],[10,"read_u8","","",1,[[["self"]],["result",["u8"]]]],[10,"read_isize","","",1,[[["self"]],["result",["isize"]]]],[10,"read_i128","","",1,[[["self"]],["result",["i128"]]]],[10,"read_i64","","",1,[[["self"]],["result",["i64"]]]],[10,"read_i32","","",1,[[["self"]],["result",["i32"]]]],[10,"read_i16","","",1,[[["self"]],["result",["i16"]]]],[10,"read_i8","","",1,[[["self"]],["result",["i8"]]]],[10,"read_bool","","",1,[[["self"]],["result",["bool"]]]],[10,"read_f64","","",1,[[["self"]],["result",["f64"]]]],[10,"read_f32","","",1,[[["self"]],["result",["f32"]]]],[10,"read_char","","",1,[[["self"]],["result",["char"]]]],[10,"read_str","","",1,[[["self"]],["result",["cow"]]]],[11,"read_enum","serialize::serialize","",1,[[["self"],["str"],["f"]],["result"]]],[11,"read_enum_variant","","",1,N],[11,"read_enum_variant_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_enum_struct_variant","","",1,N],[11,"read_enum_struct_variant_field","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_struct","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_struct_field","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_tuple","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_tuple_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_tuple_struct","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_tuple_struct_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_option","","",1,[[["self"],["f"]],["result"]]],[11,"read_seq","","",1,[[["self"],["f"]],["result"]]],[11,"read_seq_elt","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_map","","",1,[[["self"],["f"]],["result"]]],[11,"read_map_elt_key","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_map_elt_val","","",1,[[["self"],["usize"],["f"]],["result"]]],[10,"error","serialize","",1,N],[8,"Encoder","","",N,N],[16,"Error","","",0,N],[10,"emit_nil","","",0,[[["self"]],["result"]]],[10,"emit_usize","","",0,[[["self"],["usize"]],["result"]]],[10,"emit_u128","","",0,[[["self"],["u128"]],["result"]]],[10,"emit_u64","","",0,[[["self"],["u64"]],["result"]]],[10,"emit_u32","","",0,[[["self"],["u32"]],["result"]]],[10,"emit_u16","","",0,[[["self"],["u16"]],["result"]]],[10,"emit_u8","","",0,[[["self"],["u8"]],["result"]]],[10,"emit_isize","","",0,[[["self"],["isize"]],["result"]]],[10,"emit_i128","","",0,[[["self"],["i128"]],["result"]]],[10,"emit_i64","","",0,[[["self"],["i64"]],["result"]]],[10,"emit_i32","","",0,[[["self"],["i32"]],["result"]]],[10,"emit_i16","","",0,[[["self"],["i16"]],["result"]]],[10,"emit_i8","","",0,[[["self"],["i8"]],["result"]]],[10,"emit_bool","","",0,[[["self"],["bool"]],["result"]]],[10,"emit_f64","","",0,[[["self"],["f64"]],["result"]]],[10,"emit_f32","","",0,[[["self"],["f32"]],["result"]]],[10,"emit_char","","",0,[[["self"],["char"]],["result"]]],[10,"emit_str","","",0,[[["self"],["str"]],["result"]]],[11,"emit_enum","serialize::serialize","",0,[[["self"],["str"],["f"]],["result"]]],[11,"emit_enum_variant","","",0,[[["self"],["str"],["usize"],["usize"],["f"]],["result"]]],[11,"emit_enum_variant_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_enum_struct_variant","","",0,[[["self"],["str"],["usize"],["usize"],["f"]],["result"]]],[11,"emit_enum_struct_variant_field","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_struct","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_struct_field","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_tuple","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_tuple_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_tuple_struct","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_tuple_struct_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_option","","",0,[[["self"],["f"]],["result"]]],[11,"emit_option_none","","",0,[[["self"]],["result"]]],[11,"emit_option_some","","",0,[[["self"],["f"]],["result"]]],[11,"emit_seq","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_seq_elt","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map_elt_key","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map_elt_val","","",0,[[["self"],["usize"],["f"]],["result"]]],[8,"Decodable","serialize","",N,N],[10,"decode","","",3,[[["d"]],["result"]]],[8,"Encodable","","",N,N],[10,"encode","","",2,[[["self"],["s"]],["result"]]],[8,"SpecializationError","","Implement this trait on your `{Encodable,Decodable}::Error` types to override the default panic behavior for missing specializations.",N,N],[10,"not_found","","Create an error for a missing method specialization. Defaults to panicking with type, trait & method names. `S` is the encoder/decoder state type, `T` is the type being encoded/decoded, and the arguments are the names of the trait and method that should've been overridden.",4,[[["str"],["str"]],["self"]]],[8,"SpecializedEncoder","","Implement this trait on encoders, with `T` being the type you want to encode (employing `UseSpecializedEncodable`), using a strategy specific to the encoder.",N,N],[10,"specialized_encode","","Encode the value in a manner specific to this encoder state.",5,[[["self"],["t"]],["result"]]],[8,"SpecializedDecoder","","Implement this trait on decoders, with `T` being the type you want to decode (employing `UseSpecializedDecodable`), using a strategy specific to the decoder.",N,N],[10,"specialized_decode","","Decode a value in a manner specific to this decoder state.",6,[[["self"]],["result"]]],[8,"UseSpecializedEncodable","","Implement this trait on your type to get an `Encodable` implementation which goes through `SpecializedEncoder`.",N,N],[11,"default_encode","serialize::serialize","Defaults to returning an error (see `SpecializationError`).",7,[[["self"],["e"]],["result"]]],[8,"UseSpecializedDecodable","serialize","Implement this trait on your type to get an `Decodable` implementation which goes through `SpecializedDecoder`.",N,N],[11,"default_decode","serialize::serialize","Defaults to returning an error (see `SpecializationError`).",8,[[["d"]],["result"]]]],"paths":[[8,"Encoder"],[8,"Decoder"],[8,"Encodable"],[8,"Decodable"],[8,"SpecializationError"],[8,"SpecializedEncoder"],[8,"SpecializedDecoder"],[8,"UseSpecializedEncodable"],[8,"UseSpecializedDecodable"],[4,"FromHexError"],[8,"ToHex"],[8,"FromHex"],[3,"PrettyJson"],[3,"AsJson"],[3,"AsPrettyJson"],[3,"Encoder"],[3,"PrettyEncoder"],[3,"Stack"],[3,"Parser"],[3,"Builder"],[3,"Decoder"],[3,"FormatShim"],[4,"Json"],[4,"ErrorCode"],[4,"ParserError"],[4,"DecoderError"],[4,"EncoderError"],[4,"JsonEvent"],[4,"ParserState"],[4,"StackElement"],[4,"InternalStackElement"],[8,"ToJson"],[3,"Encoder"],[3,"Decoder"]]};
searchIndex["syntax"]={"doc":"The Rust parser and macro expander.","items":[[0,"edition","syntax","",N,N],[4,"Edition","syntax::edition","The edition of the compiler (RFC 2052)",N,N],[13,"Edition2015","","The 2015 edition",0,N],[13,"Edition2018","","The 2018 edition",0,N],[17,"ALL_EDITIONS","","",N,N],[17,"EDITION_NAME_LIST","","",N,N],[17,"DEFAULT_EDITION","","",N,N],[0,"symbol","syntax","An \"interner\" is a data structure that associates values with usize tags and allows bidirectional lookup; i.e. given a value, one can easily find the type, and vice versa.",N,N],[3,"Ident","syntax::symbol","",N,N],[12,"name","","",1,N],[12,"span","","",1,N],[3,"Symbol","","A symbol is an interned or gensymed string.",N,N],[12,"0","","",2,N],[3,"Interner","","",N,N],[12,"arena","","",3,N],[12,"names","","",3,N],[12,"strings","","",3,N],[12,"gensyms","","",3,N],[0,"keywords","","",N,N],[3,"Keyword","syntax::symbol::keywords","",N,N],[12,"ident","","",4,N],[17,"Invalid","","",N,N],[17,"CrateRoot","","",N,N],[17,"DollarCrate","","",N,N],[17,"Underscore","","",N,N],[17,"As","","",N,N],[17,"Box","","",N,N],[17,"Break","","",N,N],[17,"Const","","",N,N],[17,"Continue","","",N,N],[17,"Crate","","",N,N],[17,"Else","","",N,N],[17,"Enum","","",N,N],[17,"Extern","","",N,N],[17,"False","","",N,N],[17,"Fn","","",N,N],[17,"For","","",N,N],[17,"If","","",N,N],[17,"Impl","","",N,N],[17,"In","","",N,N],[17,"Let","","",N,N],[17,"Loop","","",N,N],[17,"Match","","",N,N],[17,"Mod","","",N,N],[17,"Move","","",N,N],[17,"Mut","","",N,N],[17,"Pub","","",N,N],[17,"Ref","","",N,N],[17,"Return","","",N,N],[17,"SelfValue","","",N,N],[17,"SelfType","","",N,N],[17,"Static","","",N,N],[17,"Struct","","",N,N],[17,"Super","","",N,N],[17,"Trait","","",N,N],[17,"True","","",N,N],[17,"Type","","",N,N],[17,"Unsafe","","",N,N],[17,"Use","","",N,N],[17,"Where","","",N,N],[17,"While","","",N,N],[17,"Abstract","","",N,N],[17,"Become","","",N,N],[17,"Do","","",N,N],[17,"Final","","",N,N],[17,"Macro","","",N,N],[17,"Override","","",N,N],[17,"Priv","","",N,N],[17,"Typeof","","",N,N],[17,"Unsized","","",N,N],[17,"Virtual","","",N,N],[17,"Yield","","",N,N],[17,"Async","","",N,N],[17,"UnderscoreLifetime","","",N,N],[17,"StaticLifetime","","",N,N],[17,"Auto","","",N,N],[17,"Catch","","",N,N],[17,"Default","","",N,N],[17,"Dyn","","",N,N],[17,"Union","","",N,N],[17,"Existential","","",N,N],[3,"LocalInternedString","syntax::symbol","Represents a string stored in the interner. Because the interner outlives any thread which uses this type, we can safely treat `string` which points to interner data, as an immortal string, as long as this type never crosses between threads.",N,N],[12,"string","","",5,N],[3,"InternedString","","Represents a string stored in the string interner",N,N],[12,"symbol","","",6,N],[3,"Globals","syntax","",N,N],[12,"used_attrs","","",7,N],[12,"known_attrs","","",7,N],[12,"syntax_pos_globals","","",7,N],[5,"with_globals","","",N,[[["f"]],["r"]]],[0,"diagnostics","","",N,N],[0,"macros","syntax::diagnostics","",N,N],[0,"plugin","","",N,N],[0,"emitter","syntax::diagnostics::plugin","",N,N],[8,"Emitter","syntax::diagnostics::plugin::emitter","Emitter trait for emitting errors.",N,N],[10,"emit","","Emit a structured diagnostic.",8,N],[11,"should_show_explain","","Check if should show explanations about \"rustc --explain\"",8,[[["self"]],["bool"]]],[17,"MAX_HIGHLIGHT_LINES","","maximum number of lines we will print for each error; arbitrary.",N,N],[17,"MAX_SUGGESTIONS","","maximum number of suggestions to be shown",N,N],[4,"ColorConfig","","",N,N],[13,"Auto","","",9,N],[13,"Always","","",9,N],[13,"Never","","",9,N],[3,"EmitterWriter","","",N,N],[12,"dst","","",10,N],[12,"cm","","",10,N],[12,"short_message","","",10,N],[12,"teach","","",10,N],[12,"ui_testing","","",10,N],[4,"Destination","","",N,N],[13,"Terminal","","",11,N],[13,"Buffered","","",11,N],[13,"Raw","","",11,N],[4,"WritableDst","","",N,N],[13,"Terminal","","",12,N],[13,"Buffered","","",12,N],[13,"Raw","","",12,N],[0,"registry","syntax::diagnostics::plugin","",N,N],[3,"Registry","syntax::diagnostics::plugin::registry","",N,N],[12,"descriptions","","",13,N],[4,"Applicability","syntax::diagnostics::plugin","",N,N],[13,"MachineApplicable","","",14,N],[13,"HasPlaceholders","","",14,N],[13,"MaybeIncorrect","","",14,N],[13,"Unspecified","","",14,N],[3,"CodeSuggestion","","",N,N],[12,"substitutions","","Each substitute can have multiple variants due to multiple applicable suggestions",15,N],[12,"msg","","",15,N],[12,"show_code_when_inline","","",15,N],[12,"applicability","","Whether or not the suggestion is approximate",15,N],[3,"Substitution","","See the docs on `CodeSuggestion::substitutions`",N,N],[12,"parts","","",16,N],[3,"SubstitutionPart","","",N,N],[12,"span","","",17,N],[12,"snippet","","",17,N],[6,"CodeMapperDyn","","",N,N],[8,"CodeMapper","","",N,N],[10,"lookup_char_pos","","",18,[[["self"],["bytepos"]],["loc"]]],[10,"span_to_lines","","",18,[[["self"],["span"]],["result",["filelines","spanlineserror"]]]],[10,"span_to_string","","",18,[[["self"],["span"]],["string"]]],[10,"span_to_filename","","",18,[[["self"],["span"]],["filename"]]],[10,"merge_spans","","",18,[[["self"],["span"],["span"]],["option",["span"]]]],[10,"call_span_if_macro","","",18,[[["self"],["span"]],["span"]]],[10,"ensure_filemap_source_present","","",18,[[["self"],["rc",["filemap"]]],["bool"]]],[10,"doctest_offset_line","","",18,[[["self"],["usize"]],["usize"]]],[3,"FatalError","","Used as a return value to signify a fatal error occurred. (It is also used as the argument to panic at the moment, but that will eventually not be true.)",N,N],[3,"FatalErrorMarker","","",N,N],[3,"ExplicitBug","","Signifies that the compiler died with an explicit call to `.bug` or `.span_bug` rather than a failed assertion, etc.",N,N],[3,"Handler","","A handler deals with errors; certain errors (fatal, bug, unimpl) may cause immediate exit, others log errors for later reporting.",N,N],[12,"flags","","",19,N],[12,"err_count","","",19,N],[12,"emitter","","",19,N],[12,"continue_after_error","","",19,N],[12,"delayed_span_bugs","","",19,N],[12,"taught_diagnostics","","",19,N],[12,"emitted_diagnostic_codes","","Used to suggest rustc --explain ",19,N],[12,"emitted_diagnostics","","",19,N],[17,"TRACK_DIAGNOSTICS","","",N,N],[3,"HandlerFlags","","",N,N],[12,"can_emit_warnings","","",20,N],[12,"treat_err_as_bug","","",20,N],[12,"report_delayed_bugs","","",20,N],[12,"external_macro_backtrace","","",20,N],[4,"Level","","",N,N],[13,"Bug","","",21,N],[13,"Fatal","","",21,N],[13,"PhaseFatal","","",21,N],[13,"Error","","",21,N],[13,"Warning","","",21,N],[13,"Note","","",21,N],[13,"Help","","",21,N],[13,"Cancelled","","",21,N],[13,"FailureNote","","",21,N],[3,"Diagnostic","","",N,N],[12,"level","","",22,N],[12,"message","","",22,N],[12,"code","","",22,N],[12,"span","","",22,N],[12,"children","","",22,N],[12,"suggestions","","",22,N],[3,"DiagnosticBuilder","","Used for emitting structured error messages and other diagnostic information.",N,N],[12,"handler","","",23,N],[12,"diagnostic","","",23,N],[4,"DiagnosticId","","",N,N],[13,"Error","","",24,N],[13,"Lint","","",24,N],[3,"DiagnosticStyledString","","",N,N],[12,"0","","",25,N],[3,"SubDiagnostic","","For example a note attached to an error.",N,N],[12,"level","","",26,N],[12,"message","","",26,N],[12,"span","","",26,N],[12,"render_span","","",26,N],[3,"ErrorInfo","","Error information type.",N,N],[12,"description","","",27,N],[12,"use_site","","",27,N],[5,"expand_diagnostic_used","","",N,N],[5,"expand_register_diagnostic","","",N,N],[5,"expand_build_diagnostic_array","","",N,N],[6,"ErrorMap","","Mapping from error codes to metadata.",N,N],[17,"MAX_DESCRIPTION_WIDTH","","",N,N],[0,"metadata","syntax::diagnostics","This module contains utilities for outputting metadata for diagnostic errors.",N,N],[3,"ErrorMetadata","syntax::diagnostics::metadata","JSON encodable/decodable version of `ErrorInfo`.",N,N],[12,"description","","",28,N],[12,"use_site","","",28,N],[3,"ErrorLocation","","JSON encodable error location type with filename and line number.",N,N],[12,"filename","","",29,N],[12,"line","","",29,N],[5,"get_metadata_dir","","Get the directory where metadata for a given `prefix` should be stored.",N,[[["str"]],["pathbuf"]]],[5,"get_metadata_path","","Map `name` to a path in the given directory: /.json",N,[[["pathbuf"],["str"]],["pathbuf"]]],[5,"output_metadata","","Write metadata for the errors in `err_map` to disk, to a file corresponding to `prefix/name`.",N,[[["extctxt"],["str"],["str"],["errormap"]],["result",["box"]]]],[6,"ErrorMetadataMap","","Mapping from error codes to metadata that can be (de)serialized.",N,N],[11,"eq","","",28,[[["self"],["errormetadata"]],["bool"]]],[11,"ne","","",28,[[["self"],["errormetadata"]],["bool"]]],[11,"decode","","",28,[[["__d"]],["result",["errormetadata"]]]],[11,"encode","","",28,[[["self"],["__s"]],["result"]]],[11,"eq","","",29,[[["self"],["errorlocation"]],["bool"]]],[11,"ne","","",29,[[["self"],["errorlocation"]],["bool"]]],[11,"decode","","",29,[[["__d"]],["result",["errorlocation"]]]],[11,"encode","","",29,[[["self"],["__s"]],["result"]]],[11,"from_span","","Create an error location from a span.",29,[[["extctxt"],["span"]],["errorlocation"]]],[0,"diagnostic_list","syntax","",N,N],[0,"__register_diagnostic_E0178","syntax::diagnostic_list","",N,N],[0,"__register_diagnostic_E0536","","",N,N],[0,"__register_diagnostic_E0537","","",N,N],[0,"__register_diagnostic_E0538","","",N,N],[0,"__register_diagnostic_E0541","","",N,N],[0,"__register_diagnostic_E0552","","",N,N],[0,"__register_diagnostic_E0554","","",N,N],[0,"__register_diagnostic_E0557","","",N,N],[0,"__register_diagnostic_E0565","","",N,N],[0,"__register_diagnostic_E0583","","",N,N],[0,"__register_diagnostic_E0585","","",N,N],[0,"__register_diagnostic_E0586","","",N,N],[0,"__register_diagnostic_E0589","","",N,N],[0,"__register_diagnostic_E0658","","",N,N],[0,"__register_diagnostic_E0633","","",N,N],[0,"__register_diagnostic_E0539","","",N,N],[0,"__register_diagnostic_E0540","","",N,N],[0,"__register_diagnostic_E0542","","",N,N],[0,"__register_diagnostic_E0543","","",N,N],[0,"__register_diagnostic_E0544","","",N,N],[0,"__register_diagnostic_E0545","","",N,N],[0,"__register_diagnostic_E0546","","",N,N],[0,"__register_diagnostic_E0547","","",N,N],[0,"__register_diagnostic_E0548","","",N,N],[0,"__register_diagnostic_E0549","","",N,N],[0,"__register_diagnostic_E0550","","",N,N],[0,"__register_diagnostic_E0551","","",N,N],[0,"__register_diagnostic_E0553","","",N,N],[0,"__register_diagnostic_E0555","","",N,N],[0,"__register_diagnostic_E0556","","",N,N],[0,"__register_diagnostic_E0584","","",N,N],[0,"__register_diagnostic_E0629","","",N,N],[0,"__register_diagnostic_E0630","","",N,N],[0,"__register_diagnostic_E0693","","",N,N],[0,"__register_diagnostic_E0694","","",N,N],[0,"__register_diagnostic_E0703","","",N,N],[0,"__register_diagnostic_E0704","","",N,N],[0,"util","syntax","",N,N],[3,"ThinVec","syntax::util","A vector type optimized for cases where this size is usually 0 (c.f. `SmallVector`). The `Option<Box<..>>` wrapping allows us to represent a zero sized vector with `None`, which uses only a single (null) pointer.",N,N],[12,"0","","",30,N],[3,"RcSlice","","",N,N],[12,"data","","",31,N],[12,"offset","","",31,N],[12,"len","","",31,N],[0,"lev_distance","","",N,N],[5,"lev_distance","syntax::util::lev_distance","To find the Levenshtein distance between two strings",N,[[["str"],["str"]],["usize"]]],[5,"find_best_match_for_name","","To find the best match for a given string from an iterator of names As a loose rule to avoid the obviously incorrect suggestions, it takes an optional limit for the maximum allowable edit distance, which defaults to one-third of the given word. Besides Levenshtein, we use case insensitive comparison to improve accuracy on an edge case with a lower(upper)case letters mismatch.",N,[[["t"],["str"],["option",["usize"]]],["option",["symbol"]]]],[0,"node_count","syntax::util","",N,N],[3,"NodeCounter","syntax::util::node_count","",N,N],[12,"count","","",32,N],[11,"new","","",32,[[],["nodecounter"]]],[11,"visit_ident","","",32,[[["self"],["ident"]]]],[11,"visit_mod","","",32,N],[11,"visit_foreign_item","","",32,[[["self"],["foreignitem"]]]],[11,"visit_item","","",32,[[["self"],["item"]]]],[11,"visit_local","","",32,[[["self"],["local"]]]],[11,"visit_block","","",32,[[["self"],["block"]]]],[11,"visit_stmt","","",32,[[["self"],["stmt"]]]],[11,"visit_arm","","",32,[[["self"],["arm"]]]],[11,"visit_pat","","",32,[[["self"],["pat"]]]],[11,"visit_expr","","",32,[[["self"],["expr"]]]],[11,"visit_ty","","",32,[[["self"],["ty"]]]],[11,"visit_generic_param","","",32,[[["self"],["genericparam"]]]],[11,"visit_generics","","",32,[[["self"],["generics"]]]],[11,"visit_fn","","",32,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",32,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",32,[[["self"],["implitem"]]]],[11,"visit_trait_ref","","",32,[[["self"],["traitref"]]]],[11,"visit_param_bound","","",32,[[["self"],["genericbound"]]]],[11,"visit_poly_trait_ref","","",32,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_variant_data","","",32,[[["self"],["variantdata"],["ident"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",32,[[["self"],["structfield"]]]],[11,"visit_enum_def","","",32,[[["self"],["enumdef"],["generics"],["nodeid"],["span"]]]],[11,"visit_variant","","",32,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_lifetime","","",32,[[["self"],["lifetime"]]]],[11,"visit_mac","","",32,[[["self"],["mac"]]]],[11,"visit_path","","",32,[[["self"],["path"],["nodeid"]]]],[11,"visit_use_tree","","",32,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_generic_args","","",32,[[["self"],["span"],["genericargs"]]]],[11,"visit_assoc_type_binding","","",32,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",32,[[["self"],["attribute"]]]],[0,"parser","syntax::util","",N,N],[4,"AssocOp","syntax::util::parser","Associative operator with precedence.",N,N],[13,"Add","","`+`",33,N],[13,"Subtract","","`-`",33,N],[13,"Multiply","","`*`",33,N],[13,"Divide","","`/`",33,N],[13,"Modulus","","`%`",33,N],[13,"LAnd","","`&&`",33,N],[13,"LOr","","`||`",33,N],[13,"BitXor","","`^`",33,N],[13,"BitAnd","","`&`",33,N],[13,"BitOr","","`|`",33,N],[13,"ShiftLeft","","`<<`",33,N],[13,"ShiftRight","","`>>`",33,N],[13,"Equal","","`==`",33,N],[13,"Less","","`<`",33,N],[13,"LessEqual","","`<=`",33,N],[13,"NotEqual","","`!=`",33,N],[13,"Greater","","`>`",33,N],[13,"GreaterEqual","","`>=`",33,N],[13,"Assign","","`=`",33,N],[13,"ObsoleteInPlace","","`<-`",33,N],[13,"AssignOp","","`?=` where ? is one of the BinOpToken",33,N],[13,"As","","`as`",33,N],[13,"DotDot","","`..` range",33,N],[13,"DotDotEq","","`..=` range",33,N],[13,"Colon","","`:`",33,N],[4,"Fixity","","",N,N],[13,"Left","","The operator is left-associative",34,N],[13,"Right","","The operator is right-associative",34,N],[13,"None","","The operator is not associative",34,N],[4,"ExprPrecedence","","",N,N],[13,"Closure","","",35,N],[13,"Break","","",35,N],[13,"Continue","","",35,N],[13,"Ret","","",35,N],[13,"Yield","","",35,N],[13,"Range","","",35,N],[13,"Binary","","",35,N],[13,"ObsoleteInPlace","","",35,N],[13,"Cast","","",35,N],[13,"Type","","",35,N],[13,"Assign","","",35,N],[13,"AssignOp","","",35,N],[13,"Box","","",35,N],[13,"AddrOf","","",35,N],[13,"Unary","","",35,N],[13,"Call","","",35,N],[13,"MethodCall","","",35,N],[13,"Field","","",35,N],[13,"Index","","",35,N],[13,"Try","","",35,N],[13,"InlineAsm","","",35,N],[13,"Mac","","",35,N],[13,"Array","","",35,N],[13,"Repeat","","",35,N],[13,"Tup","","",35,N],[13,"Lit","","",35,N],[13,"Path","","",35,N],[13,"Paren","","",35,N],[13,"If","","",35,N],[13,"IfLet","","",35,N],[13,"While","","",35,N],[13,"WhileLet","","",35,N],[13,"ForLoop","","",35,N],[13,"Loop","","",35,N],[13,"Match","","",35,N],[13,"Block","","",35,N],[13,"Catch","","",35,N],[13,"Struct","","",35,N],[13,"Async","","",35,N],[5,"contains_exterior_struct_lit","","Expressions that syntactically contain an \"exterior\" struct literal i.e. not surrounded by any parens or other delimiters, e.g. `X { y: 1 }`, `X { y: 1 }.method()`, `foo == X { y: 1 }` and `X { y: 1 } == foo` all do, but `(X { y: 1 }) == foo` does not.",N,[[["expr"]],["bool"]]],[17,"PREC_RESET","","",N,N],[17,"PREC_CLOSURE","","",N,N],[17,"PREC_JUMP","","",N,N],[17,"PREC_RANGE","","",N,N],[17,"PREC_PREFIX","","",N,N],[17,"PREC_POSTFIX","","",N,N],[17,"PREC_PAREN","","",N,N],[17,"PREC_FORCE_PAREN","","",N,N],[11,"eq","","",33,[[["self"],["assocop"]],["bool"]]],[11,"ne","","",33,[[["self"],["assocop"]],["bool"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"eq","","",34,[[["self"],["fixity"]],["bool"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"from_token","","Create a new AssocOP from a token",33,[[["token"]],["option",["assocop"]]]],[11,"from_ast_binop","","Create a new AssocOp from ast::BinOpKind.",33,[[["binopkind"]],["self"]]],[11,"precedence","","Gets the precedence of this operator",33,[[["self"]],["usize"]]],[11,"fixity","","Gets the fixity of this operator",33,[[["self"]],["fixity"]]],[11,"is_comparison","","",33,[[["self"]],["bool"]]],[11,"is_assign_like","","",33,[[["self"]],["bool"]]],[11,"to_ast_binop","","",33,[[["self"]],["option",["binopkind"]]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"clone","","",35,[[["self"]],["exprprecedence"]]],[11,"order","","",35,[[["self"]],["i8"]]],[0,"small_vector","syntax::util","",N,N],[6,"SmallVector","syntax::util::small_vector","",N,N],[0,"move_map","syntax::util","",N,N],[8,"MoveMap","syntax::util::move_map","",N,N],[11,"move_map","","",36,[[["self"],["f"]],["self"]]],[10,"move_flat_map","","",36,[[["self"],["f"]],["self"]]],[11,"move_flat_map","","",37,[[["self"],["f"]],["self"]]],[0,"thin_vec","syntax::util","",N,N],[3,"ThinVec","syntax::util::thin_vec","A vector type optimized for cases where this size is usually 0 (c.f. `SmallVector`). The `Option<Box<..>>` wrapping allows us to represent a zero sized vector with `None`, which uses only a single (null) pointer.",N,N],[12,"0","","",30,N],[11,"clone","syntax::util","",30,[[["self"]],["thinvec"]]],[11,"eq","","",30,[[["self"],["thinvec"]],["bool"]]],[11,"ne","","",30,[[["self"],["thinvec"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",30,N],[11,"encode","","",30,[[["self"],["__st"]],["result"]]],[11,"decode","","",30,[[["__dt"]],["result",["thinvec"]]]],[11,"hash","","",30,N],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"new","","",30,[[],["self"]]],[11,"from","","",30,[[["vec"]],["self"]]],[11,"into","","",30,[[["self"]],["vec"]]],[11,"deref","","",30,N],[11,"extend","","",30,[[["self"],["i"]]]],[0,"rc_slice","","",N,N],[3,"RcSlice","syntax::util::rc_slice","",N,N],[12,"data","","",31,N],[12,"offset","","",31,N],[12,"len","","",31,N],[11,"clone","syntax::util","",31,[[["self"]],["rcslice"]]],[11,"new","","",31,[[["vec"]],["self"]]],[11,"sub_slice","","",31,[[["self"],["range",["usize"]]],["self"]]],[11,"deref","","",31,N],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"hash_stable","","",31,[[["self"],["ctx"],["stablehasher"]]]],[0,"json","syntax","A JSON emitter for errors.",N,N],[3,"JsonEmitter","syntax::json","",N,N],[12,"dst","","",38,N],[12,"registry","","",38,N],[12,"cm","","",38,N],[12,"pretty","","",38,N],[12,"ui_testing","","",38,N],[3,"Diagnostic","","",N,N],[12,"message","","The primary error message.",39,N],[12,"code","","",39,N],[12,"level","","\"error: internal compiler error\", \"error\", \"warning\", \"note\", \"help\".",39,N],[12,"spans","","",39,N],[12,"children","","Associated diagnostic messages.",39,N],[12,"rendered","","The message as rustc would render it.",39,N],[3,"DiagnosticSpan","","",N,N],[12,"file_name","","",40,N],[12,"byte_start","","",40,N],[12,"byte_end","","",40,N],[12,"line_start","","1-based.",40,N],[12,"line_end","","",40,N],[12,"column_start","","1-based, character offset.",40,N],[12,"column_end","","",40,N],[12,"is_primary","","Is this a \"primary\" span -- meaning the point, or one of the points, where the error occurred?",40,N],[12,"text","","Source text from the start of line_start to the end of line_end.",40,N],[12,"label","","Label that should be placed at this location (if any)",40,N],[12,"suggested_replacement","","If we are suggesting a replacement, this will contain text that should be sliced in atop this span.",40,N],[12,"suggestion_applicability","","If the suggestion is approximate",40,N],[12,"expansion","","Macro invocations that created the code at this span, if any.",40,N],[3,"DiagnosticSpanLine","","",N,N],[12,"text","","",41,N],[12,"highlight_start","","1-based, character offset in self.text.",41,N],[12,"highlight_end","","",41,N],[3,"DiagnosticSpanMacroExpansion","","",N,N],[12,"span","","span where macro was applied to generate this code; note that this may itself derive from a macro (if `span.expansion.is_some()`)",42,N],[12,"macro_decl_name","","name of macro that was applied (e.g., \"foo!\" or \"#[derive(Eq)]\")",42,N],[12,"def_site_span","","span where macro was defined (if known)",42,N],[3,"DiagnosticCode","","",N,N],[12,"code","","The code itself.",43,N],[12,"explanation","","An explanation for the code.",43,N],[11,"stderr","","",38,[[["option",["registry"]],["lrc",["codemap"]],["bool"]],["jsonemitter"]]],[11,"basic","","",38,[[["bool"]],["jsonemitter"]]],[11,"new","","",38,[[["box",["write"]],["option",["registry"]],["lrc",["codemap"]],["bool"]],["jsonemitter"]]],[11,"ui_testing","","",38,[[["self"],["bool"]],["self"]]],[11,"emit","","",38,[[["self"],["diagnosticbuilder"]]]],[11,"encode","","",39,[[["self"],["__s"]],["result"]]],[11,"encode","","",40,[[["self"],["__s"]],["result"]]],[11,"encode","","",41,[[["self"],["__s"]],["result"]]],[11,"encode","","",42,[[["self"],["__s"]],["result"]]],[11,"encode","","",43,[[["self"],["__s"]],["result"]]],[11,"from_diagnostic_builder","","",39,[[["diagnosticbuilder"],["jsonemitter"]],["diagnostic"]]],[11,"from_sub_diagnostic","","",39,[[["subdiagnostic"],["jsonemitter"]],["diagnostic"]]],[11,"from_span_label","","",40,[[["spanlabel"],["option"],["jsonemitter"]],["diagnosticspan"]]],[11,"from_span_etc","","",40,[[["span"],["bool"],["option",["string"]],["option"],["jsonemitter"]],["diagnosticspan"]]],[11,"from_span_full","","",40,[[["span"],["bool"],["option",["string"]],["option"],["intoiter",["macrobacktrace"]],["jsonemitter"]],["diagnosticspan"]]],[11,"from_multispan","","",40,[[["multispan"],["jsonemitter"]],["vec",["diagnosticspan"]]]],[11,"from_suggestion","","",40,[[["codesuggestion"],["jsonemitter"]],["vec",["diagnosticspan"]]]],[11,"line_from_filemap","","",41,[[["filemap"],["usize"],["usize"],["usize"]],["diagnosticspanline"]]],[11,"from_span","","Create a list of DiagnosticSpanLines from span - each line with any part of `span` gets a DiagnosticSpanLine, with the highlight indicating the `span` within the line.",41,[[["span"],["jsonemitter"]],["vec",["diagnosticspanline"]]]],[11,"map_opt_string","","",43,[[["option",["diagnosticid"]],["jsonemitter"]],["option",["diagnosticcode"]]]],[0,"syntax","syntax","",N,N],[0,"ast","","",N,N],[3,"Ident","syntax::ast","",N,N],[12,"name","","",1,N],[12,"span","","",1,N],[3,"Name","","A symbol is an interned or gensymed string.",N,N],[12,"0","","",2,N],[4,"FloatTy","","",N,N],[13,"F32","","",44,N],[13,"F64","","",44,N],[3,"ThinVec","","A vector type optimized for cases where this size is usually 0 (c.f. `SmallVector`). The `Option<Box<..>>` wrapping allows us to represent a zero sized vector with `None`, which uses only a single (null) pointer.",N,N],[12,"0","","",30,N],[3,"Label","","",N,N],[12,"ident","","",45,N],[3,"Lifetime","","",N,N],[12,"id","","",46,N],[12,"ident","","",46,N],[3,"Path","","A \"Path\" is essentially Rust's notion of a name.",N,N],[12,"span","","",47,N],[12,"segments","","The segments in the path: the things separated by `::`. Global paths begin with `keywords::CrateRoot`.",47,N],[3,"PathSegment","","A segment of a path: an identifier, an optional lifetime, and a set of types.",N,N],[12,"ident","","The identifier portion of this path segment.",48,N],[12,"args","","Type/lifetime parameters attached to this path. They come in two flavors: `Path<A,B,C>` and `Path(A,B) -> C`. `None` means that no parameter list is supplied (`Path`), `Some` means that parameter list is supplied (`Path<X, Y>`) but it can be empty (`Path<>`). `P` is used as a size optimization for the common case with no parameters.",48,N],[3,"AngleBracketedArgs","","A path like `Foo<'a, T>`",N,N],[12,"span","","Overall span",49,N],[12,"args","","The arguments for this path segment.",49,N],[12,"bindings","","Bindings (equality constraints) on associated types, if present.",49,N],[3,"ParenthesisedArgs","","A path like `Foo(A,B) -> C`",N,N],[12,"span","","Overall span",50,N],[12,"inputs","","`(A,B)`",50,N],[12,"output","","`C`",50,N],[3,"NodeId","","",N,N],[12,"0","","",51,N],[3,"GenericParam","","",N,N],[12,"id","","",52,N],[12,"ident","","",52,N],[12,"attrs","","",52,N],[12,"bounds","","",52,N],[12,"kind","","",52,N],[3,"Generics","","Represents lifetime, type and const parameters attached to a declaration of a function, enum, trait, etc.",N,N],[12,"params","","",53,N],[12,"where_clause","","",53,N],[12,"span","","",53,N],[3,"WhereClause","","A `where` clause in a definition",N,N],[12,"id","","",54,N],[12,"predicates","","",54,N],[12,"span","","",54,N],[3,"WhereBoundPredicate","","A type bound.",N,N],[12,"span","","",55,N],[12,"bound_generic_params","","Any generics from a `for` binding",55,N],[12,"bounded_ty","","The type being bounded",55,N],[12,"bounds","","Trait and lifetime bounds (`Clone+Send+'static`)",55,N],[3,"WhereRegionPredicate","","A lifetime predicate.",N,N],[12,"span","","",56,N],[12,"lifetime","","",56,N],[12,"bounds","","",56,N],[3,"WhereEqPredicate","","An equality predicate (unsupported).",N,N],[12,"id","","",57,N],[12,"span","","",57,N],[12,"lhs_ty","","",57,N],[12,"rhs_ty","","",57,N],[3,"Crate","","",N,N],[12,"module","","",58,N],[12,"attrs","","",58,N],[12,"span","","",58,N],[3,"MetaItem","","A spanned compile-time attribute item.",N,N],[12,"ident","","",59,N],[12,"node","","",59,N],[12,"span","","",59,N],[3,"Block","","A Block (`{ .. }`).",N,N],[12,"stmts","","Statements in a block",60,N],[12,"id","","",60,N],[12,"rules","","Distinguishes between `unsafe { ... }` and `{ ... }`",60,N],[12,"span","","",60,N],[12,"recovered","","",60,N],[3,"Pat","","",N,N],[12,"id","","",61,N],[12,"node","","",61,N],[12,"span","","",61,N],[3,"FieldPat","","A single field in a struct pattern",N,N],[12,"ident","","The identifier for the field",62,N],[12,"pat","","The pattern the field is destructured to",62,N],[12,"is_shorthand","","",62,N],[12,"attrs","","",62,N],[3,"Stmt","","A statement",N,N],[12,"id","","",63,N],[12,"node","","",63,N],[12,"span","","",63,N],[3,"Local","","Local represents a `let` statement, e.g., `let <pat>:<ty> = <expr>;`",N,N],[12,"pat","","",64,N],[12,"ty","","",64,N],[12,"init","","Initializer expression to set the value, if any",64,N],[12,"id","","",64,N],[12,"span","","",64,N],[12,"attrs","","",64,N],[3,"Arm","","An arm of a 'match'.",N,N],[12,"attrs","","",65,N],[12,"pats","","",65,N],[12,"guard","","",65,N],[12,"body","","",65,N],[3,"Field","","",N,N],[12,"ident","","",66,N],[12,"expr","","",66,N],[12,"span","","",66,N],[12,"is_shorthand","","",66,N],[12,"attrs","","",66,N],[3,"AnonConst","","A constant (expression) that's not an item or associated item, but needs its own `DefId` for type-checking, const-eval, etc. These are usually found nested inside types (e.g. array lengths) or expressions (e.g. repeat counts), and also used to define explicit discriminant values for enum variants.",N,N],[12,"id","","",67,N],[12,"value","","",67,N],[3,"Expr","","An expression",N,N],[12,"id","","",68,N],[12,"node","","",68,N],[12,"span","","",68,N],[12,"attrs","","",68,N],[3,"QSelf","","The explicit Self type in a \"qualified path\". The actual path, including the trait and the associated item, is stored separately. `position` represents the index of the associated item qualified with this Self type.",N,N],[12,"ty","","",69,N],[12,"path_span","","The span of `a::b::Trait` in a path like `<Vec<T> as a::b::Trait>::AssociatedItem`; in the case where `position == 0`, this is an empty span.",69,N],[12,"position","","",69,N],[3,"Mac_","","Represents a macro invocation. The Path indicates which macro is being invoked, and the vector of token-trees contains the source of the macro invocation.",N,N],[12,"path","","",70,N],[12,"delim","","",70,N],[12,"tts","","",70,N],[3,"MacroDef","","",N,N],[12,"tokens","","",71,N],[12,"legacy","","",71,N],[3,"MutTy","","",N,N],[12,"ty","","",72,N],[12,"mutbl","","",72,N],[3,"MethodSig","","Represents a method's signature in a trait declaration, or in an implementation.",N,N],[12,"header","","",73,N],[12,"decl","","",73,N],[3,"TraitItem","","Represents an item declaration within a trait declaration, possibly including a default implementation. A trait item is either required (meaning it doesn't have an implementation, just a signature) or provided (meaning it has a default implementation).",N,N],[12,"id","","",74,N],[12,"ident","","",74,N],[12,"attrs","","",74,N],[12,"generics","","",74,N],[12,"node","","",74,N],[12,"span","","",74,N],[12,"tokens","","See `Item::tokens` for what this is",74,N],[3,"ImplItem","","",N,N],[12,"id","","",75,N],[12,"ident","","",75,N],[12,"vis","","",75,N],[12,"defaultness","","",75,N],[12,"attrs","","",75,N],[12,"generics","","",75,N],[12,"node","","",75,N],[12,"span","","",75,N],[12,"tokens","","See `Item::tokens` for what this is",75,N],[3,"TypeBinding","","",N,N],[12,"id","","",76,N],[12,"ident","","",76,N],[12,"ty","","",76,N],[12,"span","","",76,N],[3,"Ty","","",N,N],[12,"id","","",77,N],[12,"node","","",77,N],[12,"span","","",77,N],[3,"BareFnTy","","",N,N],[12,"unsafety","","",78,N],[12,"abi","","",78,N],[12,"generic_params","","",78,N],[12,"decl","","",78,N],[3,"InlineAsmOutput","","Inline assembly.",N,N],[12,"constraint","","",79,N],[12,"expr","","",79,N],[12,"is_rw","","",79,N],[12,"is_indirect","","",79,N],[3,"InlineAsm","","Inline assembly.",N,N],[12,"asm","","",80,N],[12,"asm_str_style","","",80,N],[12,"outputs","","",80,N],[12,"inputs","","",80,N],[12,"clobbers","","",80,N],[12,"volatile","","",80,N],[12,"alignstack","","",80,N],[12,"dialect","","",80,N],[12,"ctxt","","",80,N],[3,"Arg","","An argument in a function header.",N,N],[12,"ty","","",81,N],[12,"pat","","",81,N],[12,"id","","",81,N],[3,"FnDecl","","Header (not the body) of a function declaration.",N,N],[12,"inputs","","",82,N],[12,"output","","",82,N],[12,"variadic","","",82,N],[3,"Mod","","Module declaration.",N,N],[12,"inner","","A span from the first token past `{` to the last token until `}`. For `mod foo;`, the inner span ranges from the first token to the last token in the external file.",83,N],[12,"items","","",83,N],[3,"ForeignMod","","Foreign module declaration.",N,N],[12,"abi","","",84,N],[12,"items","","",84,N],[3,"GlobalAsm","","Global inline assembly",N,N],[12,"asm","","",85,N],[12,"ctxt","","",85,N],[3,"EnumDef","","",N,N],[12,"variants","","",86,N],[3,"Variant_","","",N,N],[12,"ident","","",87,N],[12,"attrs","","",87,N],[12,"data","","",87,N],[12,"disr_expr","","Explicit discriminant, e.g. `Foo = 1`",87,N],[3,"UseTree","","A tree of paths sharing common prefixes. Used in `use` items both at top-level and inside of braces in import groups.",N,N],[12,"prefix","","",88,N],[12,"kind","","",88,N],[12,"span","","",88,N],[3,"AttrId","","",N,N],[12,"0","","",89,N],[3,"Attribute","","Meta-data associated with an item Doc-comments are promoted to attributes that have is_sugared_doc = true",N,N],[12,"id","","",90,N],[12,"style","","",90,N],[12,"path","","",90,N],[12,"tokens","","",90,N],[12,"is_sugared_doc","","",90,N],[12,"span","","",90,N],[3,"TraitRef","","TraitRef's appear in impls.",N,N],[12,"path","","",91,N],[12,"ref_id","","",91,N],[3,"PolyTraitRef","","",N,N],[12,"bound_generic_params","","The `'a` in `<'a> Foo<&'a T>`",92,N],[12,"trait_ref","","The `Foo<&'a T>` in `<'a> Foo<&'a T>`",92,N],[12,"span","","",92,N],[3,"StructField","","Field of a struct.",N,N],[12,"span","","",93,N],[12,"ident","","",93,N],[12,"vis","","",93,N],[12,"id","","",93,N],[12,"ty","","",93,N],[12,"attrs","","",93,N],[3,"Item","","An item",N,N],[12,"ident","","",94,N],[12,"attrs","","",94,N],[12,"id","","",94,N],[12,"node","","",94,N],[12,"vis","","",94,N],[12,"span","","",94,N],[12,"tokens","","Original tokens this item was parsed from. This isn't necessarily available for all items, although over time more and more items should have this be `Some`. Right now this is primarily used for procedural macros, notably custom attributes.",94,N],[3,"FnHeader","","A function header",N,N],[12,"unsafety","","",95,N],[12,"asyncness","","",95,N],[12,"constness","","",95,N],[12,"abi","","",95,N],[3,"ForeignItem","","",N,N],[12,"ident","","",96,N],[12,"attrs","","",96,N],[12,"node","","",96,N],[12,"id","","",96,N],[12,"span","","",96,N],[12,"vis","","",96,N],[4,"GenericArgs","","Arguments of a path segment.",N,N],[13,"AngleBracketed","","The `<'a, A,B,C>` in `foo::bar::baz::<'a, A,B,C>`",97,N],[13,"Parenthesized","","The `(A,B)` and `C` in `Foo(A,B) -> C`",97,N],[4,"GenericArg","","",N,N],[13,"Lifetime","","",98,N],[13,"Type","","",98,N],[4,"TraitBoundModifier","","A modifier on a bound, currently this is only used for `?Sized`, where the modifier is `Maybe`. Negative bounds should also be handled here.",N,N],[13,"None","","",99,N],[13,"Maybe","","",99,N],[4,"GenericBound","","The AST represents all type param bounds as types. typeck::collect::compute_bounds matches these against the \"special\" built-in traits (see middle::lang_items) and detects Copy, Send and Sync.",N,N],[13,"Trait","","",100,N],[13,"Outlives","","",100,N],[4,"GenericParamKind","","",N,N],[13,"Lifetime","","A lifetime definition, e.g. `'a: 'b+'c+'d`.",101,N],[13,"Type","","",101,N],[12,"default","syntax::ast::GenericParamKind","",101,N],[4,"WherePredicate","syntax::ast","A single predicate in a `where` clause",N,N],[13,"BoundPredicate","","A type binding, e.g. `for<'c> Foo: Send+Clone+'c`",102,N],[13,"RegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",102,N],[13,"EqPredicate","","An equality predicate (unsupported)",102,N],[4,"NestedMetaItemKind","","Possible values inside of compile-time attribute lists.",N,N],[13,"MetaItem","","A full MetaItem, for recursive meta items.",103,N],[13,"Literal","","A literal.",103,N],[4,"MetaItemKind","","A compile-time attribute item.",N,N],[13,"Word","","Word meta item.",104,N],[13,"List","","List meta item.",104,N],[13,"NameValue","","Name value meta item.",104,N],[4,"BindingMode","","",N,N],[13,"ByRef","","",105,N],[13,"ByValue","","",105,N],[4,"RangeEnd","","",N,N],[13,"Included","","",106,N],[13,"Excluded","","",106,N],[4,"RangeSyntax","","",N,N],[13,"DotDotDot","","",107,N],[13,"DotDotEq","","",107,N],[4,"PatKind","","",N,N],[13,"Wild","","Represents a wildcard pattern (`_`)",108,N],[13,"Ident","","A `PatKind::Ident` may either be a new bound variable (`ref mut binding @ OPT_SUBPATTERN`), or a unit struct/variant pattern, or a const pattern (in the last two cases the third field must be `None`). Disambiguation cannot be done with parser alone, so it happens during name resolution.",108,N],[13,"Struct","","A struct or struct variant pattern, e.g. `Variant {x, y, ..}`. The `bool` is `true` in the presence of a `..`.",108,N],[13,"TupleStruct","","A tuple struct/variant pattern `Variant(x, y, .., z)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",108,N],[13,"Path","","A possibly qualified path pattern. Unqualified path patterns `A::B::C` can legally refer to variants, structs, constants or associated constants. Qualified path patterns `<A>::B::C`/`<A as Trait>::B::C` can only legally refer to associated constants.",108,N],[13,"Tuple","","A tuple pattern `(a, b)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",108,N],[13,"Box","","A `box` pattern",108,N],[13,"Ref","","A reference pattern, e.g. `&mut (a, b)`",108,N],[13,"Lit","","A literal",108,N],[13,"Range","","A range pattern, e.g. `1...2`, `1..=2` or `1..2`",108,N],[13,"Slice","","`[a, b, ..i, y, z]` is represented as: `PatKind::Slice(box [a, b], Some(i), box [y, z])`",108,N],[13,"Paren","","Parentheses in patters used for grouping, i.e. `(PAT)`.",108,N],[13,"Mac","","A macro pattern; pre-expansion",108,N],[4,"Mutability","","",N,N],[13,"Mutable","","",109,N],[13,"Immutable","","",109,N],[4,"BinOpKind","","",N,N],[13,"Add","","The `+` operator (addition)",110,N],[13,"Sub","","The `-` operator (subtraction)",110,N],[13,"Mul","","The `*` operator (multiplication)",110,N],[13,"Div","","The `/` operator (division)",110,N],[13,"Rem","","The `%` operator (modulus)",110,N],[13,"And","","The `&&` operator (logical and)",110,N],[13,"Or","","The `||` operator (logical or)",110,N],[13,"BitXor","","The `^` operator (bitwise xor)",110,N],[13,"BitAnd","","The `&` operator (bitwise and)",110,N],[13,"BitOr","","The `|` operator (bitwise or)",110,N],[13,"Shl","","The `<<` operator (shift left)",110,N],[13,"Shr","","The `>>` operator (shift right)",110,N],[13,"Eq","","The `==` operator (equality)",110,N],[13,"Lt","","The `<` operator (less than)",110,N],[13,"Le","","The `<=` operator (less than or equal to)",110,N],[13,"Ne","","The `!=` operator (not equal to)",110,N],[13,"Ge","","The `>=` operator (greater than or equal to)",110,N],[13,"Gt","","The `>` operator (greater than)",110,N],[4,"UnOp","","",N,N],[13,"Deref","","The `*` operator for dereferencing",111,N],[13,"Not","","The `!` operator for logical inversion",111,N],[13,"Neg","","The `-` operator for negation",111,N],[4,"StmtKind","","",N,N],[13,"Local","","A local (let) binding.",112,N],[13,"Item","","An item definition.",112,N],[13,"Expr","","Expr without trailing semi-colon.",112,N],[13,"Semi","","Expr with a trailing semi-colon.",112,N],[13,"Mac","","Macro.",112,N],[4,"MacStmtStyle","","",N,N],[13,"Semicolon","","The macro statement had a trailing semicolon, e.g. `foo! { ... };` `foo!(...);`, `foo![...];`",113,N],[13,"Braces","","The macro statement had braces; e.g. foo! { ... }",113,N],[13,"NoBraces","","The macro statement had parentheses or brackets and no semicolon; e.g. `foo!(...)`. All of these will end up being converted into macro expressions.",113,N],[4,"BlockCheckMode","","",N,N],[13,"Default","","",114,N],[13,"Unsafe","","",114,N],[4,"UnsafeSource","","",N,N],[13,"CompilerGenerated","","",115,N],[13,"UserProvided","","",115,N],[4,"RangeLimits","","Limit types of a range (inclusive or exclusive)",N,N],[13,"HalfOpen","","Inclusive at the beginning, exclusive at the end",116,N],[13,"Closed","","Inclusive at the beginning and end",116,N],[4,"ExprKind","","",N,N],[13,"Box","","A `box x` expression.",117,N],[13,"ObsoleteInPlace","","First expr is the place; second expr is the value.",117,N],[13,"Array","","An array (`[a, b, c, d]`)",117,N],[13,"Call","","A function call",117,N],[13,"MethodCall","","A method call (`x.foo::<'static, Bar, Baz>(a, b, c, d)`)",117,N],[13,"Tup","","A tuple (`(a, b, c ,d)`)",117,N],[13,"Binary","","A binary operation (For example: `a + b`, `a * b`)",117,N],[13,"Unary","","A unary operation (For example: `!x`, `*x`)",117,N],[13,"Lit","","A literal (For example: `1`, `\"foo\"`)",117,N],[13,"Cast","","A cast (`foo as f64`)",117,N],[13,"Type","","",117,N],[13,"If","","An `if` block, with an optional else block",117,N],[13,"IfLet","","An `if let` expression with an optional else block",117,N],[13,"While","","A while loop, with an optional label",117,N],[13,"WhileLet","","A while-let loop, with an optional label",117,N],[13,"ForLoop","","A for loop, with an optional label",117,N],[13,"Loop","","Conditionless loop (can be exited with break, continue, or return)",117,N],[13,"Match","","A `match` block.",117,N],[13,"Closure","","A closure (for example, `move |a, b, c| a + b + c`)",117,N],[13,"Block","","A block (`'label: { ... }`)",117,N],[13,"Async","","An async block (`async move { ... }`)",117,N],[13,"Catch","","A catch block (`catch { ... }`)",117,N],[13,"Assign","","An assignment (`a = foo()`)",117,N],[13,"AssignOp","","An assignment with an operator",117,N],[13,"Field","","Access of a named (`obj.foo`) or unnamed (`obj.0`) struct field",117,N],[13,"Index","","An indexing operation (`foo[2]`)",117,N],[13,"Range","","A range (`1..2`, `1..`, `..2`, `1...2`, `1...`, `...2`)",117,N],[13,"Path","","Variable reference, possibly containing `::` and/or type parameters, e.g. foo::bar::.",117,N],[13,"AddrOf","","A referencing operation (`&a` or `&mut a`)",117,N],[13,"Break","","A `break`, with an optional label to break, and an optional expression",117,N],[13,"Continue","","A `continue`, with an optional label",117,N],[13,"Ret","","A `return`, with an optional value to be returned",117,N],[13,"InlineAsm","","Output of the `asm!()` macro",117,N],[13,"Mac","","A macro invocation; pre-expansion",117,N],[13,"Struct","","A struct literal expression.",117,N],[13,"Repeat","","An array literal constructed from one repeated element.",117,N],[13,"Paren","","No-op: used solely so we can pretty-print faithfully",117,N],[13,"Try","","`expr?`",117,N],[13,"Yield","","A `yield`, with an optional value to be yielded",117,N],[4,"CaptureBy","","A capture clause",N,N],[13,"Value","","",118,N],[13,"Ref","","",118,N],[4,"Movability","","The movability of a generator / closure literal",N,N],[13,"Static","","",119,N],[13,"Movable","","",119,N],[4,"MacDelimiter","","",N,N],[13,"Parenthesis","","",120,N],[13,"Bracket","","",120,N],[13,"Brace","","",120,N],[4,"StrStyle","","",N,N],[13,"Cooked","","A regular string, like `\"foo\"`",121,N],[13,"Raw","","A raw string, like `r##\"foo\"##`",121,N],[4,"LitIntType","","",N,N],[13,"Signed","","",122,N],[13,"Unsigned","","",122,N],[13,"Unsuffixed","","",122,N],[4,"LitKind","","Literal kind.",N,N],[13,"Str","","A string literal (`\"foo\"`)",123,N],[13,"ByteStr","","A byte string (`b\"foo\"`)",123,N],[13,"Byte","","A byte char (`b'f'`)",123,N],[13,"Char","","A character literal (`'a'`)",123,N],[13,"Int","","An integer literal (`1`)",123,N],[13,"Float","","A float literal (`1f64` or `1E10f64`)",123,N],[13,"FloatUnsuffixed","","A float literal without a suffix (`1.0 or 1.0E10`)",123,N],[13,"Bool","","A boolean literal",123,N],[4,"TraitItemKind","","",N,N],[13,"Const","","",124,N],[13,"Method","","",124,N],[13,"Type","","",124,N],[13,"Macro","","",124,N],[4,"ImplItemKind","","",N,N],[13,"Const","","",125,N],[13,"Method","","",125,N],[13,"Type","","",125,N],[13,"Existential","","",125,N],[13,"Macro","","",125,N],[4,"IntTy","","",N,N],[13,"Isize","","",126,N],[13,"I8","","",126,N],[13,"I16","","",126,N],[13,"I32","","",126,N],[13,"I64","","",126,N],[13,"I128","","",126,N],[4,"UintTy","","",N,N],[13,"Usize","","",127,N],[13,"U8","","",127,N],[13,"U16","","",127,N],[13,"U32","","",127,N],[13,"U64","","",127,N],[13,"U128","","",127,N],[4,"TyKind","","The different kinds of types recognized by the compiler",N,N],[13,"Slice","","A variable-length slice (`[T]`)",128,N],[13,"Array","","A fixed length array (`[T; n]`)",128,N],[13,"Ptr","","A raw pointer (`*const T` or `*mut T`)",128,N],[13,"Rptr","","A reference (`&'a T` or `&'a mut T`)",128,N],[13,"BareFn","","A bare function (e.g. `fn(usize) -> bool`)",128,N],[13,"Never","","The never type (`!`)",128,N],[13,"Tup","","A tuple (`(A, B, C, D,...)`)",128,N],[13,"Path","","A path (`module::module::...::Type`), optionally \"qualified\", e.g. `<Vec<T> as SomeTrait>::SomeType`.",128,N],[13,"TraitObject","","A trait object type `Bound1 + Bound2 + Bound3` where `Bound` is a trait or a lifetime.",128,N],[13,"ImplTrait","","An `impl Bound1 + Bound2 + Bound3` type where `Bound` is a trait or a lifetime.",128,N],[13,"Paren","","No-op; kept solely so that we can pretty-print faithfully",128,N],[13,"Typeof","","Unused for now",128,N],[13,"Infer","","TyKind::Infer means the type should be inferred instead of it having been specified. This can appear anywhere in a type.",128,N],[13,"ImplicitSelf","","Inferred type of a `self` or `&self` argument in a method.",128,N],[13,"Mac","","",128,N],[13,"Err","","Placeholder for a kind that has failed to be defined.",128,N],[4,"TraitObjectSyntax","","Syntax used to declare a trait object.",N,N],[13,"Dyn","","",129,N],[13,"None","","",129,N],[4,"AsmDialect","","Inline assembly dialect.",N,N],[13,"Att","","",130,N],[13,"Intel","","",130,N],[4,"SelfKind","","Alternative representation for `Arg`s describing `self` parameter of methods.",N,N],[13,"Value","","`self`, `mut self`",131,N],[13,"Region","","`&'lt self`, `&'lt mut self`",131,N],[13,"Explicit","","`self: TYPE`, `mut self: TYPE`",131,N],[4,"IsAuto","","Is the trait definition an auto trait?",N,N],[13,"Yes","","",132,N],[13,"No","","",132,N],[4,"Unsafety","","",N,N],[13,"Unsafe","","",133,N],[13,"Normal","","",133,N],[4,"IsAsync","","",N,N],[13,"Async","","",134,N],[12,"closure_id","syntax::ast::IsAsync","",134,N],[12,"return_impl_trait_id","","",134,N],[13,"NotAsync","syntax::ast","",134,N],[4,"Constness","","",N,N],[13,"Const","","",135,N],[13,"NotConst","","",135,N],[4,"Defaultness","","",N,N],[13,"Default","","",136,N],[13,"Final","","",136,N],[4,"ImplPolarity","","",N,N],[13,"Positive","","`impl Trait for Type`",137,N],[13,"Negative","","`impl !Trait for Type`",137,N],[4,"FunctionRetTy","","",N,N],[13,"Default","","Return type is not specified.",138,N],[13,"Ty","","Everything else",138,N],[4,"UseTreeKind","","Part of `use` item to the right of its prefix.",N,N],[13,"Simple","","`use prefix` or `use prefix as rename`",139,N],[13,"Nested","","`use prefix::{...}`",139,N],[13,"Glob","","`use prefix::*`",139,N],[4,"AttrStyle","","Distinguishes between Attributes that decorate items and Attributes that are contained as statements within items. These two cases need to be distinguished for pretty-printing.",N,N],[13,"Outer","","",140,N],[13,"Inner","","",140,N],[4,"CrateSugar","","",N,N],[13,"PubCrate","","Source is `pub(crate)`",141,N],[13,"JustCrate","","Source is (just) `crate`",141,N],[4,"VisibilityKind","","",N,N],[13,"Public","","",142,N],[13,"Crate","","",142,N],[13,"Restricted","","",142,N],[12,"path","syntax::ast::VisibilityKind","",142,N],[12,"id","","",142,N],[13,"Inherited","syntax::ast","",142,N],[4,"VariantData","","Fields and Ids of enum variants and structs",N,N],[13,"Struct","","Struct variant.",143,N],[13,"Tuple","","Tuple variant.",143,N],[13,"Unit","","Unit variant.",143,N],[4,"ItemKind","","",N,N],[13,"ExternCrate","","An `extern crate` item, with optional original crate name if the crate was renamed.",144,N],[13,"Use","","A use declaration (`use` or `pub use`) item.",144,N],[13,"Static","","A static item (`static` or `pub static`).",144,N],[13,"Const","","A constant item (`const` or `pub const`).",144,N],[13,"Fn","","A function declaration (`fn` or `pub fn`).",144,N],[13,"Mod","","A module declaration (`mod` or `pub mod`).",144,N],[13,"ForeignMod","","An external module (`extern` or `pub extern`).",144,N],[13,"GlobalAsm","","Module-level inline assembly (from `global_asm!()`)",144,N],[13,"Ty","","A type alias (`type` or `pub type`).",144,N],[13,"Existential","","An existential type declaration (`existential type`).",144,N],[13,"Enum","","An enum definition (`enum` or `pub enum`).",144,N],[13,"Struct","","A struct definition (`struct` or `pub struct`).",144,N],[13,"Union","","A union definition (`union` or `pub union`).",144,N],[13,"Trait","","A Trait declaration (`trait` or `pub trait`).",144,N],[13,"TraitAlias","","Trait alias",144,N],[13,"Impl","","An implementation.",144,N],[13,"Mac","","A macro invocation.",144,N],[13,"MacroDef","","A macro definition.",144,N],[4,"ForeignItemKind","","An item within an `extern` block",N,N],[13,"Fn","","A foreign function",145,N],[13,"Static","","A foreign static item (`static ext: u8`), with optional mutability (the boolean is true when mutable)",145,N],[13,"Ty","","A foreign type",145,N],[13,"Macro","","A macro invocation",145,N],[6,"GenericBounds","","",N,N],[6,"CrateConfig","","The set of MetaItems that define the compilation environment of the crate, used to drive conditional compilation",N,N],[6,"NestedMetaItem","","A spanned compile-time attribute list item.",N,N],[6,"BinOp","","",N,N],[6,"SpannedIdent","","",N,N],[6,"Mac","","",N,N],[6,"Lit","","A literal",N,N],[6,"ExplicitSelf","","",N,N],[6,"Variant","","",N,N],[6,"Visibility","","",N,N],[17,"CRATE_NODE_ID","","Node id used to represent the root of the crate.",N,N],[17,"DUMMY_NODE_ID","","When parsing and doing expansions, we initially give all AST nodes this AST node value. Then later, in the renumber pass, we renumber them to have small, positive ids.",N,N],[11,"clone","","",45,[[["self"]],["label"]]],[11,"encode","","",45,[[["self"],["__s"]],["result"]]],[11,"decode","","",45,[[["__d"]],["result",["label"]]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"clone","","",46,[[["self"]],["lifetime"]]],[11,"encode","","",46,[[["self"],["__s"]],["result"]]],[11,"decode","","",46,[[["__d"]],["result",["lifetime"]]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"clone","","",47,[[["self"]],["path"]]],[11,"encode","","",47,[[["self"],["__s"]],["result"]]],[11,"decode","","",47,[[["__d"]],["result",["path"]]]],[11,"eq","","",47,[[["self"],["str"]],["bool"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"from_ident","","",47,[[["ident"]],["path"]]],[11,"make_root","","",47,[[["self"]],["option",["pathsegment"]]]],[11,"is_global","","",47,[[["self"]],["bool"]]],[11,"clone","","",48,[[["self"]],["pathsegment"]]],[11,"encode","","",48,[[["self"],["__s"]],["result"]]],[11,"decode","","",48,[[["__d"]],["result",["pathsegment"]]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"from_ident","","",48,[[["ident"]],["self"]]],[11,"crate_root","","",48,[[["span"]],["self"]]],[11,"clone","","",97,[[["self"]],["genericargs"]]],[11,"encode","","",97,[[["self"],["__s"]],["result"]]],[11,"decode","","",97,[[["__d"]],["result",["genericargs"]]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"span","","",97,[[["self"]],["span"]]],[11,"clone","","",98,[[["self"]],["genericarg"]]],[11,"encode","","",98,[[["self"],["__s"]],["result"]]],[11,"decode","","",98,[[["__d"]],["result",["genericarg"]]]],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[11,"clone","","",49,[[["self"]],["anglebracketedargs"]]],[11,"encode","","",49,[[["self"],["__s"]],["result"]]],[11,"decode","","",49,[[["__d"]],["result",["anglebracketedargs"]]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"default","","",49,[[],["anglebracketedargs"]]],[11,"into","","",49,[[["self"]],["option",["p"]]]],[11,"into","","",50,[[["self"]],["option",["p"]]]],[11,"clone","","",50,[[["self"]],["parenthesisedargs"]]],[11,"encode","","",50,[[["self"],["__s"]],["result"]]],[11,"decode","","",50,[[["__d"]],["result",["parenthesisedargs"]]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"clone","","",51,[[["self"]],["nodeid"]]],[11,"eq","","",51,[[["self"],["nodeid"]],["bool"]]],[11,"ne","","",51,[[["self"],["nodeid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",51,N],[11,"partial_cmp","","",51,[[["self"],["nodeid"]],["option",["ordering"]]]],[11,"lt","","",51,[[["self"],["nodeid"]],["bool"]]],[11,"le","","",51,[[["self"],["nodeid"]],["bool"]]],[11,"gt","","",51,[[["self"],["nodeid"]],["bool"]]],[11,"ge","","",51,[[["self"],["nodeid"]],["bool"]]],[11,"cmp","","",51,[[["self"],["nodeid"]],["ordering"]]],[11,"hash","","",51,N],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"new","","",51,[[["usize"]],["nodeid"]]],[11,"from_u32","","",51,[[["u32"]],["nodeid"]]],[11,"as_usize","","",51,[[["self"]],["usize"]]],[11,"as_u32","","",51,[[["self"]],["u32"]]],[11,"placeholder_from_mark","","",51,[[["mark"]],["self"]]],[11,"placeholder_to_mark","","",51,[[["self"]],["mark"]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"default_encode","","",51,[[["self"],["s"]],["result"]]],[11,"default_decode","","",51,[[["d"]],["result",["nodeid"]]]],[11,"new","","",51,[[["usize"]],["self"]]],[11,"index","","",51,[[["self"]],["usize"]]],[11,"clone","","",99,[[["self"]],["traitboundmodifier"]]],[11,"eq","","",99,[[["self"],["traitboundmodifier"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",99,N],[11,"encode","","",99,[[["self"],["__s"]],["result"]]],[11,"decode","","",99,[[["__d"]],["result",["traitboundmodifier"]]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result"]]],[11,"clone","","",100,[[["self"]],["genericbound"]]],[11,"encode","","",100,[[["self"],["__s"]],["result"]]],[11,"decode","","",100,[[["__d"]],["result",["genericbound"]]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result"]]],[11,"span","","",100,[[["self"]],["span"]]],[11,"clone","","",101,[[["self"]],["genericparamkind"]]],[11,"encode","","",101,[[["self"],["__s"]],["result"]]],[11,"decode","","",101,[[["__d"]],["result",["genericparamkind"]]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"clone","","",52,[[["self"]],["genericparam"]]],[11,"encode","","",52,[[["self"],["__s"]],["result"]]],[11,"decode","","",52,[[["__d"]],["result",["genericparam"]]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"clone","","",53,[[["self"]],["generics"]]],[11,"encode","","",53,[[["self"],["__s"]],["result"]]],[11,"decode","","",53,[[["__d"]],["result",["generics"]]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"default","","Creates an instance of `Generics`.",53,[[],["generics"]]],[11,"clone","","",54,[[["self"]],["whereclause"]]],[11,"encode","","",54,[[["self"],["__s"]],["result"]]],[11,"decode","","",54,[[["__d"]],["result",["whereclause"]]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"clone","","",102,[[["self"]],["wherepredicate"]]],[11,"encode","","",102,[[["self"],["__s"]],["result"]]],[11,"decode","","",102,[[["__d"]],["result",["wherepredicate"]]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"span","","",102,[[["self"]],["span"]]],[11,"clone","","",55,[[["self"]],["whereboundpredicate"]]],[11,"encode","","",55,[[["self"],["__s"]],["result"]]],[11,"decode","","",55,[[["__d"]],["result",["whereboundpredicate"]]]],[11,"fmt","","",55,[[["self"],["formatter"]],["result"]]],[11,"clone","","",56,[[["self"]],["whereregionpredicate"]]],[11,"encode","","",56,[[["self"],["__s"]],["result"]]],[11,"decode","","",56,[[["__d"]],["result",["whereregionpredicate"]]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"clone","","",57,[[["self"]],["whereeqpredicate"]]],[11,"encode","","",57,[[["self"],["__s"]],["result"]]],[11,"decode","","",57,[[["__d"]],["result",["whereeqpredicate"]]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"clone","","",58,[[["self"]],["crate"]]],[11,"encode","","",58,[[["self"],["__s"]],["result"]]],[11,"decode","","",58,[[["__d"]],["result",["crate"]]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[11,"clone","","",103,[[["self"]],["nestedmetaitemkind"]]],[11,"encode","","",103,[[["self"],["__s"]],["result"]]],[11,"decode","","",103,[[["__d"]],["result",["nestedmetaitemkind"]]]],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[11,"clone","","",59,[[["self"]],["metaitem"]]],[11,"encode","","",59,[[["self"],["__s"]],["result"]]],[11,"decode","","",59,[[["__d"]],["result",["metaitem"]]]],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"clone","","",104,[[["self"]],["metaitemkind"]]],[11,"encode","","",104,[[["self"],["__s"]],["result"]]],[11,"decode","","",104,[[["__d"]],["result",["metaitemkind"]]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"clone","","",60,[[["self"]],["block"]]],[11,"encode","","",60,[[["self"],["__s"]],["result"]]],[11,"decode","","",60,[[["__d"]],["result",["block"]]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"clone","","",61,[[["self"]],["pat"]]],[11,"encode","","",61,[[["self"],["__s"]],["result"]]],[11,"decode","","",61,[[["__d"]],["result",["pat"]]]],[11,"fmt","","",61,[[["self"],["formatter"]],["result"]]],[11,"to_ty","","",61,[[["self"]],["option",["p"]]]],[11,"walk","","",61,[[["self"],["f"]],["bool"]]],[11,"clone","","",62,[[["self"]],["fieldpat"]]],[11,"encode","","",62,[[["self"],["__s"]],["result"]]],[11,"decode","","",62,[[["__d"]],["result",["fieldpat"]]]],[11,"fmt","","",62,[[["self"],["formatter"]],["result"]]],[11,"clone","","",105,[[["self"]],["bindingmode"]]],[11,"eq","","",105,[[["self"],["bindingmode"]],["bool"]]],[11,"ne","","",105,[[["self"],["bindingmode"]],["bool"]]],[11,"encode","","",105,[[["self"],["__s"]],["result"]]],[11,"decode","","",105,[[["__d"]],["result",["bindingmode"]]]],[11,"fmt","","",105,[[["self"],["formatter"]],["result"]]],[11,"clone","","",106,[[["self"]],["rangeend"]]],[11,"encode","","",106,[[["self"],["__s"]],["result"]]],[11,"decode","","",106,[[["__d"]],["result",["rangeend"]]]],[11,"fmt","","",106,[[["self"],["formatter"]],["result"]]],[11,"clone","","",107,[[["self"]],["rangesyntax"]]],[11,"encode","","",107,[[["self"],["__s"]],["result"]]],[11,"decode","","",107,[[["__d"]],["result",["rangesyntax"]]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[11,"clone","","",108,[[["self"]],["patkind"]]],[11,"encode","","",108,[[["self"],["__s"]],["result"]]],[11,"decode","","",108,[[["__d"]],["result",["patkind"]]]],[11,"fmt","","",108,[[["self"],["formatter"]],["result"]]],[11,"clone","","",109,[[["self"]],["mutability"]]],[11,"eq","","",109,[[["self"],["mutability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",109,N],[11,"partial_cmp","","",109,[[["self"],["mutability"]],["option",["ordering"]]]],[11,"cmp","","",109,[[["self"],["mutability"]],["ordering"]]],[11,"hash","","",109,N],[11,"encode","","",109,[[["self"],["__s"]],["result"]]],[11,"decode","","",109,[[["__d"]],["result",["mutability"]]]],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"clone","","",110,[[["self"]],["binopkind"]]],[11,"eq","","",110,[[["self"],["binopkind"]],["bool"]]],[11,"encode","","",110,[[["self"],["__s"]],["result"]]],[11,"decode","","",110,[[["__d"]],["result",["binopkind"]]]],[11,"fmt","","",110,[[["self"],["formatter"]],["result"]]],[11,"to_string","","",110,[[["self"]],["str"]]],[11,"lazy","","",110,[[["self"]],["bool"]]],[11,"is_shift","","",110,[[["self"]],["bool"]]],[11,"is_comparison","","",110,[[["self"]],["bool"]]],[11,"is_by_value","","Returns `true` if the binary operator takes its arguments by value",110,[[["self"]],["bool"]]],[11,"clone","","",111,[[["self"]],["unop"]]],[11,"encode","","",111,[[["self"],["__s"]],["result"]]],[11,"decode","","",111,[[["__d"]],["result",["unop"]]]],[11,"fmt","","",111,[[["self"],["formatter"]],["result"]]],[11,"is_by_value","","Returns `true` if the unary operator takes its argument by value",111,[[["unop"]],["bool"]]],[11,"to_string","","",111,[[["unop"]],["str"]]],[11,"clone","","",63,[[["self"]],["stmt"]]],[11,"encode","","",63,[[["self"],["__s"]],["result"]]],[11,"decode","","",63,[[["__d"]],["result",["stmt"]]]],[11,"add_trailing_semicolon","","",63,[[["self"]],["self"]]],[11,"is_item","","",63,[[["self"]],["bool"]]],[11,"is_expr","","",63,[[["self"]],["bool"]]],[11,"fmt","","",63,[[["self"],["formatter"]],["result"]]],[11,"clone","","",112,[[["self"]],["stmtkind"]]],[11,"encode","","",112,[[["self"],["__s"]],["result"]]],[11,"decode","","",112,[[["__d"]],["result",["stmtkind"]]]],[11,"clone","","",113,[[["self"]],["macstmtstyle"]]],[11,"eq","","",113,[[["self"],["macstmtstyle"]],["bool"]]],[11,"encode","","",113,[[["self"],["__s"]],["result"]]],[11,"decode","","",113,[[["__d"]],["result",["macstmtstyle"]]]],[11,"fmt","","",113,[[["self"],["formatter"]],["result"]]],[11,"clone","","",64,[[["self"]],["local"]]],[11,"encode","","",64,[[["self"],["__s"]],["result"]]],[11,"decode","","",64,[[["__d"]],["result",["local"]]]],[11,"fmt","","",64,[[["self"],["formatter"]],["result"]]],[11,"clone","","",65,[[["self"]],["arm"]]],[11,"encode","","",65,[[["self"],["__s"]],["result"]]],[11,"decode","","",65,[[["__d"]],["result",["arm"]]]],[11,"fmt","","",65,[[["self"],["formatter"]],["result"]]],[11,"clone","","",66,[[["self"]],["field"]]],[11,"encode","","",66,[[["self"],["__s"]],["result"]]],[11,"decode","","",66,[[["__d"]],["result",["field"]]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"clone","","",114,[[["self"]],["blockcheckmode"]]],[11,"encode","","",114,[[["self"],["__s"]],["result"]]],[11,"decode","","",114,[[["__d"]],["result",["blockcheckmode"]]]],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"clone","","",115,[[["self"]],["unsafesource"]]],[11,"encode","","",115,[[["self"],["__s"]],["result"]]],[11,"decode","","",115,[[["__d"]],["result",["unsafesource"]]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",67,[[["self"]],["anonconst"]]],[11,"encode","","",67,[[["self"],["__s"]],["result"]]],[11,"decode","","",67,[[["__d"]],["result",["anonconst"]]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"clone","","",68,[[["self"]],["expr"]]],[11,"encode","","",68,[[["self"],["__s"]],["result"]]],[11,"decode","","",68,[[["__d"]],["result",["expr"]]]],[11,"returns","","Whether this expression would be valid somewhere that expects a value, for example, an `if` condition.",68,[[["self"]],["bool"]]],[11,"to_bound","","",68,[[["self"]],["option",["genericbound"]]]],[11,"to_ty","","",68,[[["self"]],["option",["p"]]]],[11,"precedence","","",68,[[["self"]],["exprprecedence"]]],[11,"fmt","","",68,[[["self"],["formatter"]],["result"]]],[11,"clone","","",116,[[["self"]],["rangelimits"]]],[11,"eq","","",116,[[["self"],["rangelimits"]],["bool"]]],[11,"encode","","",116,[[["self"],["__s"]],["result"]]],[11,"decode","","",116,[[["__d"]],["result",["rangelimits"]]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"clone","","",117,[[["self"]],["exprkind"]]],[11,"encode","","",117,[[["self"],["__s"]],["result"]]],[11,"decode","","",117,[[["__d"]],["result",["exprkind"]]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"clone","","",69,[[["self"]],["qself"]]],[11,"encode","","",69,[[["self"],["__s"]],["result"]]],[11,"decode","","",69,[[["__d"]],["result",["qself"]]]],[11,"fmt","","",69,[[["self"],["formatter"]],["result"]]],[11,"clone","","",118,[[["self"]],["captureby"]]],[11,"eq","","",118,[[["self"],["captureby"]],["bool"]]],[11,"encode","","",118,[[["self"],["__s"]],["result"]]],[11,"decode","","",118,[[["__d"]],["result",["captureby"]]]],[11,"fmt","","",118,[[["self"],["formatter"]],["result"]]],[11,"clone","","",119,[[["self"]],["movability"]]],[11,"eq","","",119,[[["self"],["movability"]],["bool"]]],[11,"encode","","",119,[[["self"],["__s"]],["result"]]],[11,"decode","","",119,[[["__d"]],["result",["movability"]]]],[11,"fmt","","",119,[[["self"],["formatter"]],["result"]]],[11,"clone","","",70,[[["self"]],["mac_"]]],[11,"encode","","",70,[[["self"],["__s"]],["result"]]],[11,"decode","","",70,[[["__d"]],["result",["mac_"]]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"clone","","",120,[[["self"]],["macdelimiter"]]],[11,"eq","","",120,[[["self"],["macdelimiter"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",120,N],[11,"encode","","",120,[[["self"],["__s"]],["result"]]],[11,"decode","","",120,[[["__d"]],["result",["macdelimiter"]]]],[11,"fmt","","",120,[[["self"],["formatter"]],["result"]]],[11,"stream","","",70,[[["self"]],["tokenstream"]]],[11,"clone","","",71,[[["self"]],["macrodef"]]],[11,"encode","","",71,[[["self"],["__s"]],["result"]]],[11,"decode","","",71,[[["__d"]],["result",["macrodef"]]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"stream","","",71,[[["self"]],["tokenstream"]]],[11,"clone","","",121,[[["self"]],["strstyle"]]],[11,"encode","","",121,[[["self"],["__s"]],["result"]]],[11,"decode","","",121,[[["__d"]],["result",["strstyle"]]]],[11,"fmt","","",121,[[["self"],["formatter"]],["result"]]],[11,"hash","","",121,N],[11,"eq","","",121,[[["self"],["strstyle"]],["bool"]]],[11,"ne","","",121,[[["self"],["strstyle"]],["bool"]]],[11,"clone","","",122,[[["self"]],["litinttype"]]],[11,"encode","","",122,[[["self"],["__s"]],["result"]]],[11,"decode","","",122,[[["__d"]],["result",["litinttype"]]]],[11,"fmt","","",122,[[["self"],["formatter"]],["result"]]],[11,"hash","","",122,N],[11,"eq","","",122,[[["self"],["litinttype"]],["bool"]]],[11,"ne","","",122,[[["self"],["litinttype"]],["bool"]]],[11,"clone","","",123,[[["self"]],["litkind"]]],[11,"encode","","",123,[[["self"],["__s"]],["result"]]],[11,"decode","","",123,[[["__d"]],["result",["litkind"]]]],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"hash","","",123,N],[11,"eq","","",123,[[["self"],["litkind"]],["bool"]]],[11,"ne","","",123,[[["self"],["litkind"]],["bool"]]],[11,"is_str","","Returns true if this literal is a string and false otherwise.",123,[[["self"]],["bool"]]],[11,"is_numeric","","Returns true if this is a numeric literal.",123,[[["self"]],["bool"]]],[11,"is_unsuffixed","","Returns true if this literal has no suffix. Note: this will return true for literals with prefixes such as raw strings and byte strings.",123,[[["self"]],["bool"]]],[11,"is_suffixed","","Returns true if this literal has a suffix.",123,[[["self"]],["bool"]]],[11,"clone","","",72,[[["self"]],["mutty"]]],[11,"encode","","",72,[[["self"],["__s"]],["result"]]],[11,"decode","","",72,[[["__d"]],["result",["mutty"]]]],[11,"fmt","","",72,[[["self"],["formatter"]],["result"]]],[11,"clone","","",73,[[["self"]],["methodsig"]]],[11,"encode","","",73,[[["self"],["__s"]],["result"]]],[11,"decode","","",73,[[["__d"]],["result",["methodsig"]]]],[11,"fmt","","",73,[[["self"],["formatter"]],["result"]]],[11,"clone","","",74,[[["self"]],["traititem"]]],[11,"encode","","",74,[[["self"],["__s"]],["result"]]],[11,"decode","","",74,[[["__d"]],["result",["traititem"]]]],[11,"fmt","","",74,[[["self"],["formatter"]],["result"]]],[11,"clone","","",124,[[["self"]],["traititemkind"]]],[11,"encode","","",124,[[["self"],["__s"]],["result"]]],[11,"decode","","",124,[[["__d"]],["result",["traititemkind"]]]],[11,"fmt","","",124,[[["self"],["formatter"]],["result"]]],[11,"clone","","",75,[[["self"]],["implitem"]]],[11,"encode","","",75,[[["self"],["__s"]],["result"]]],[11,"decode","","",75,[[["__d"]],["result",["implitem"]]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"clone","","",125,[[["self"]],["implitemkind"]]],[11,"encode","","",125,[[["self"],["__s"]],["result"]]],[11,"decode","","",125,[[["__d"]],["result",["implitemkind"]]]],[11,"fmt","","",125,[[["self"],["formatter"]],["result"]]],[11,"clone","","",126,[[["self"]],["intty"]]],[11,"eq","","",126,[[["self"],["intty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",126,N],[11,"partial_cmp","","",126,[[["self"],["intty"]],["option",["ordering"]]]],[11,"cmp","","",126,[[["self"],["intty"]],["ordering"]]],[11,"hash","","",126,N],[11,"encode","","",126,[[["self"],["__s"]],["result"]]],[11,"decode","","",126,[[["__d"]],["result",["intty"]]]],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"ty_to_string","","",126,[[["self"]],["str"]]],[11,"val_to_string","","",126,[[["self"],["i128"]],["string"]]],[11,"bit_width","","",126,[[["self"]],["option",["usize"]]]],[11,"clone","","",127,[[["self"]],["uintty"]]],[11,"eq","","",127,[[["self"],["uintty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",127,N],[11,"partial_cmp","","",127,[[["self"],["uintty"]],["option",["ordering"]]]],[11,"cmp","","",127,[[["self"],["uintty"]],["ordering"]]],[11,"hash","","",127,N],[11,"encode","","",127,[[["self"],["__s"]],["result"]]],[11,"decode","","",127,[[["__d"]],["result",["uintty"]]]],[11,"ty_to_string","","",127,[[["self"]],["str"]]],[11,"val_to_string","","",127,[[["self"],["u128"]],["string"]]],[11,"bit_width","","",127,[[["self"]],["option",["usize"]]]],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"clone","","",76,[[["self"]],["typebinding"]]],[11,"encode","","",76,[[["self"],["__s"]],["result"]]],[11,"decode","","",76,[[["__d"]],["result",["typebinding"]]]],[11,"fmt","","",76,[[["self"],["formatter"]],["result"]]],[11,"clone","","",77,[[["self"]],["ty"]]],[11,"encode","","",77,[[["self"],["__s"]],["result"]]],[11,"decode","","",77,[[["__d"]],["result",["ty"]]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"clone","","",78,[[["self"]],["barefnty"]]],[11,"encode","","",78,[[["self"],["__s"]],["result"]]],[11,"decode","","",78,[[["__d"]],["result",["barefnty"]]]],[11,"fmt","","",78,[[["self"],["formatter"]],["result"]]],[11,"clone","","",128,[[["self"]],["tykind"]]],[11,"encode","","",128,[[["self"],["__s"]],["result"]]],[11,"decode","","",128,[[["__d"]],["result",["tykind"]]]],[11,"fmt","","",128,[[["self"],["formatter"]],["result"]]],[11,"is_implicit_self","","",128,[[["self"]],["bool"]]],[11,"is_unit","","",128,[[["self"]],["bool"]]],[11,"clone","","",129,[[["self"]],["traitobjectsyntax"]]],[11,"eq","","",129,[[["self"],["traitobjectsyntax"]],["bool"]]],[11,"encode","","",129,[[["self"],["__s"]],["result"]]],[11,"decode","","",129,[[["__d"]],["result",["traitobjectsyntax"]]]],[11,"fmt","","",129,[[["self"],["formatter"]],["result"]]],[11,"clone","","",130,[[["self"]],["asmdialect"]]],[11,"eq","","",130,[[["self"],["asmdialect"]],["bool"]]],[11,"encode","","",130,[[["self"],["__s"]],["result"]]],[11,"decode","","",130,[[["__d"]],["result",["asmdialect"]]]],[11,"fmt","","",130,[[["self"],["formatter"]],["result"]]],[11,"clone","","",79,[[["self"]],["inlineasmoutput"]]],[11,"encode","","",79,[[["self"],["__s"]],["result"]]],[11,"decode","","",79,[[["__d"]],["result",["inlineasmoutput"]]]],[11,"fmt","","",79,[[["self"],["formatter"]],["result"]]],[11,"clone","","",80,[[["self"]],["inlineasm"]]],[11,"encode","","",80,[[["self"],["__s"]],["result"]]],[11,"decode","","",80,[[["__d"]],["result",["inlineasm"]]]],[11,"fmt","","",80,[[["self"],["formatter"]],["result"]]],[11,"clone","","",81,[[["self"]],["arg"]]],[11,"encode","","",81,[[["self"],["__s"]],["result"]]],[11,"decode","","",81,[[["__d"]],["result",["arg"]]]],[11,"fmt","","",81,[[["self"],["formatter"]],["result"]]],[11,"clone","","",131,[[["self"]],["selfkind"]]],[11,"encode","","",131,[[["self"],["__s"]],["result"]]],[11,"decode","","",131,[[["__d"]],["result",["selfkind"]]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result"]]],[11,"to_self","","",81,[[["self"]],["option",["explicitself"]]]],[11,"is_self","","",81,[[["self"]],["bool"]]],[11,"from_self","","",81,[[["explicitself"],["ident"]],["arg"]]],[11,"clone","","",82,[[["self"]],["fndecl"]]],[11,"encode","","",82,[[["self"],["__s"]],["result"]]],[11,"decode","","",82,[[["__d"]],["result",["fndecl"]]]],[11,"fmt","","",82,[[["self"],["formatter"]],["result"]]],[11,"get_self","","",82,[[["self"]],["option",["explicitself"]]]],[11,"has_self","","",82,[[["self"]],["bool"]]],[11,"clone","","",132,[[["self"]],["isauto"]]],[11,"eq","","",132,[[["self"],["isauto"]],["bool"]]],[11,"encode","","",132,[[["self"],["__s"]],["result"]]],[11,"decode","","",132,[[["__d"]],["result",["isauto"]]]],[11,"fmt","","",132,[[["self"],["formatter"]],["result"]]],[11,"clone","","",133,[[["self"]],["unsafety"]]],[11,"eq","","",133,[[["self"],["unsafety"]],["bool"]]],[11,"encode","","",133,[[["self"],["__s"]],["result"]]],[11,"decode","","",133,[[["__d"]],["result",["unsafety"]]]],[11,"fmt","","",133,[[["self"],["formatter"]],["result"]]],[11,"clone","","",134,[[["self"]],["isasync"]]],[11,"encode","","",134,[[["self"],["__s"]],["result"]]],[11,"decode","","",134,[[["__d"]],["result",["isasync"]]]],[11,"fmt","","",134,[[["self"],["formatter"]],["result"]]],[11,"is_async","","",134,[[["self"]],["bool"]]],[11,"opt_return_id","","In case this is an `Async` return the `NodeId` for the generated impl Trait item",134,[[["self"]],["option",["nodeid"]]]],[11,"clone","","",135,[[["self"]],["constness"]]],[11,"eq","","",135,[[["self"],["constness"]],["bool"]]],[11,"encode","","",135,[[["self"],["__s"]],["result"]]],[11,"decode","","",135,[[["__d"]],["result",["constness"]]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result"]]],[11,"clone","","",136,[[["self"]],["defaultness"]]],[11,"eq","","",136,[[["self"],["defaultness"]],["bool"]]],[11,"encode","","",136,[[["self"],["__s"]],["result"]]],[11,"decode","","",136,[[["__d"]],["result",["defaultness"]]]],[11,"fmt","","",136,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",133,[[["self"],["formatter"]],["result"]]],[11,"clone","","",137,[[["self"]],["implpolarity"]]],[11,"eq","","",137,[[["self"],["implpolarity"]],["bool"]]],[11,"encode","","",137,[[["self"],["__s"]],["result"]]],[11,"decode","","",137,[[["__d"]],["result",["implpolarity"]]]],[11,"fmt","","",137,[[["self"],["formatter"]],["result"]]],[11,"clone","","",138,[[["self"]],["functionretty"]]],[11,"encode","","",138,[[["self"],["__s"]],["result"]]],[11,"decode","","",138,[[["__d"]],["result",["functionretty"]]]],[11,"fmt","","",138,[[["self"],["formatter"]],["result"]]],[11,"span","","",138,[[["self"]],["span"]]],[11,"clone","","",83,[[["self"]],["mod"]]],[11,"encode","","",83,[[["self"],["__s"]],["result"]]],[11,"decode","","",83,[[["__d"]],["result",["mod"]]]],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"clone","","",84,[[["self"]],["foreignmod"]]],[11,"encode","","",84,[[["self"],["__s"]],["result"]]],[11,"decode","","",84,[[["__d"]],["result",["foreignmod"]]]],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"clone","","",85,[[["self"]],["globalasm"]]],[11,"encode","","",85,[[["self"],["__s"]],["result"]]],[11,"decode","","",85,[[["__d"]],["result",["globalasm"]]]],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"clone","","",86,[[["self"]],["enumdef"]]],[11,"encode","","",86,[[["self"],["__s"]],["result"]]],[11,"decode","","",86,[[["__d"]],["result",["enumdef"]]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"clone","","",87,[[["self"]],["variant_"]]],[11,"encode","","",87,[[["self"],["__s"]],["result"]]],[11,"decode","","",87,[[["__d"]],["result",["variant_"]]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[11,"clone","","",139,[[["self"]],["usetreekind"]]],[11,"encode","","",139,[[["self"],["__s"]],["result"]]],[11,"decode","","",139,[[["__d"]],["result",["usetreekind"]]]],[11,"fmt","","",139,[[["self"],["formatter"]],["result"]]],[11,"clone","","",88,[[["self"]],["usetree"]]],[11,"encode","","",88,[[["self"],["__s"]],["result"]]],[11,"decode","","",88,[[["__d"]],["result",["usetree"]]]],[11,"fmt","","",88,[[["self"],["formatter"]],["result"]]],[11,"ident","","",88,[[["self"]],["ident"]]],[11,"clone","","",140,[[["self"]],["attrstyle"]]],[11,"eq","","",140,[[["self"],["attrstyle"]],["bool"]]],[11,"encode","","",140,[[["self"],["__s"]],["result"]]],[11,"decode","","",140,[[["__d"]],["result",["attrstyle"]]]],[11,"fmt","","",140,[[["self"],["formatter"]],["result"]]],[11,"clone","","",89,[[["self"]],["attrid"]]],[11,"eq","","",89,[[["self"],["attrid"]],["bool"]]],[11,"ne","","",89,[[["self"],["attrid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",89,N],[11,"encode","","",89,[[["self"],["__s"]],["result"]]],[11,"decode","","",89,[[["__d"]],["result",["attrid"]]]],[11,"hash","","",89,N],[11,"fmt","","",89,[[["self"],["formatter"]],["result"]]],[11,"clone","","",90,[[["self"]],["attribute"]]],[11,"encode","","",90,[[["self"],["__s"]],["result"]]],[11,"decode","","",90,[[["__d"]],["result",["attribute"]]]],[11,"fmt","","",90,[[["self"],["formatter"]],["result"]]],[11,"clone","","",91,[[["self"]],["traitref"]]],[11,"encode","","",91,[[["self"],["__s"]],["result"]]],[11,"decode","","",91,[[["__d"]],["result",["traitref"]]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"clone","","",92,[[["self"]],["polytraitref"]]],[11,"encode","","",92,[[["self"],["__s"]],["result"]]],[11,"decode","","",92,[[["__d"]],["result",["polytraitref"]]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"new","","",92,[[["vec",["genericparam"]],["path"],["span"]],["self"]]],[11,"clone","","",141,[[["self"]],["cratesugar"]]],[11,"encode","","",141,[[["self"],["__s"]],["result"]]],[11,"decode","","",141,[[["__d"]],["result",["cratesugar"]]]],[11,"fmt","","",141,[[["self"],["formatter"]],["result"]]],[11,"clone","","",142,[[["self"]],["visibilitykind"]]],[11,"encode","","",142,[[["self"],["__s"]],["result"]]],[11,"decode","","",142,[[["__d"]],["result",["visibilitykind"]]]],[11,"fmt","","",142,[[["self"],["formatter"]],["result"]]],[11,"is_pub","","",142,[[["self"]],["bool"]]],[11,"clone","","",93,[[["self"]],["structfield"]]],[11,"encode","","",93,[[["self"],["__s"]],["result"]]],[11,"decode","","",93,[[["__d"]],["result",["structfield"]]]],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[11,"clone","","",143,[[["self"]],["variantdata"]]],[11,"encode","","",143,[[["self"],["__s"]],["result"]]],[11,"decode","","",143,[[["__d"]],["result",["variantdata"]]]],[11,"fmt","","",143,[[["self"],["formatter"]],["result"]]],[11,"fields","","",143,N],[11,"id","","",143,[[["self"]],["nodeid"]]],[11,"is_struct","","",143,[[["self"]],["bool"]]],[11,"is_tuple","","",143,[[["self"]],["bool"]]],[11,"is_unit","","",143,[[["self"]],["bool"]]],[11,"clone","","",94,[[["self"]],["item"]]],[11,"encode","","",94,[[["self"],["__s"]],["result"]]],[11,"decode","","",94,[[["__d"]],["result",["item"]]]],[11,"fmt","","",94,[[["self"],["formatter"]],["result"]]],[11,"clone","","",95,[[["self"]],["fnheader"]]],[11,"encode","","",95,[[["self"],["__s"]],["result"]]],[11,"decode","","",95,[[["__d"]],["result",["fnheader"]]]],[11,"fmt","","",95,[[["self"],["formatter"]],["result"]]],[11,"default","","",95,[[],["fnheader"]]],[11,"clone","","",144,[[["self"]],["itemkind"]]],[11,"encode","","",144,[[["self"],["__s"]],["result"]]],[11,"decode","","",144,[[["__d"]],["result",["itemkind"]]]],[11,"fmt","","",144,[[["self"],["formatter"]],["result"]]],[11,"descriptive_variant","","",144,[[["self"]],["str"]]],[11,"clone","","",96,[[["self"]],["foreignitem"]]],[11,"encode","","",96,[[["self"],["__s"]],["result"]]],[11,"decode","","",96,[[["__d"]],["result",["foreignitem"]]]],[11,"fmt","","",96,[[["self"],["formatter"]],["result"]]],[11,"clone","","",145,[[["self"]],["foreignitemkind"]]],[11,"encode","","",145,[[["self"],["__s"]],["result"]]],[11,"decode","","",145,[[["__d"]],["result",["foreignitemkind"]]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"descriptive_variant","","",145,[[["self"]],["str"]]],[0,"attr","syntax","Functions dealing with attributes and meta items",N,N],[3,"Deprecation","syntax::attr","",N,N],[12,"since","","",146,N],[12,"note","","",146,N],[3,"RustcConstUnstable","","",N,N],[12,"feature","","",147,N],[3,"RustcDeprecation","","",N,N],[12,"since","","",148,N],[12,"reason","","",148,N],[3,"Stability","","Represents the #[stable], #[unstable], #[rustc_{deprecated,const_unstable}] attributes.",N,N],[12,"level","","",149,N],[12,"feature","","",149,N],[12,"rustc_depr","","",149,N],[12,"rustc_const_unstable","","",149,N],[4,"InlineAttr","","",N,N],[13,"None","","",150,N],[13,"Hint","","",150,N],[13,"Always","","",150,N],[13,"Never","","",150,N],[4,"IntType","","",N,N],[13,"SignedInt","","",151,N],[13,"UnsignedInt","","",151,N],[4,"ReprAttr","","",N,N],[13,"ReprInt","","",152,N],[13,"ReprC","","",152,N],[13,"ReprPacked","","",152,N],[13,"ReprSimd","","",152,N],[13,"ReprTransparent","","",152,N],[13,"ReprAlign","","",152,N],[4,"StabilityLevel","","The available stability levels.",N,N],[13,"Unstable","","",153,N],[12,"reason","syntax::attr::StabilityLevel","",153,N],[12,"issue","","",153,N],[13,"Stable","syntax::attr","",153,N],[12,"since","syntax::attr::StabilityLevel","",153,N],[4,"UnwindAttr","syntax::attr","",N,N],[13,"Allowed","","",154,N],[13,"Aborts","","",154,N],[5,"cfg_matches","","Tests if a cfg-pattern matches the cfg set",N,[[["metaitem"],["parsesess"],["option",["features"]]],["bool"]]],[5,"contains_feature_attr","","Check if `attrs` contains an attribute like `#![feature(feature_name)]`. This will not perform any \"sanity checks\" on the form of the attributes.",N,N],[5,"eval_condition","","Evaluate a cfg-like condition (with `any` and `all`), using `eval` to evaluate individual items.",N,[[["metaitem"],["parsesess"],["f"]],["bool"]]],[5,"find_crate_name","","",N,N],[5,"find_deprecation","","Find the deprecation attribute. `None` if none exists.",N,N],[5,"find_repr_attrs","","Parse #[repr(...)] forms.",N,[[["handler"],["attribute"]],["vec",["reprattr"]]]],[5,"find_stability","","Find the first stability attribute. `None` if none exists.",N,N],[5,"find_unwind_attr","","Determine what `#[unwind]` attribute is present in `attrs`, if any.",N,N],[5,"mark_used","","",N,[[["attribute"]]]],[5,"is_used","","",N,[[["attribute"]],["bool"]]],[5,"mark_known","","",N,[[["attribute"]]]],[5,"is_known","","",N,[[["attribute"]],["bool"]]],[5,"is_known_tool","","",N,[[["attribute"]],["bool"]]],[5,"is_known_lint_tool","","",N,[[["ident"]],["bool"]]],[5,"name_from_path","","",N,[[["path"]],["name"]]],[5,"mk_name_value_item_str","","",N,[[["ident"],["spanned",["symbol"]]],["metaitem"]]],[5,"mk_name_value_item","","",N,[[["span"],["ident"],["lit"]],["metaitem"]]],[5,"mk_list_item","","",N,[[["span"],["ident"],["vec",["nestedmetaitem"]]],["metaitem"]]],[5,"mk_word_item","","",N,[[["ident"]],["metaitem"]]],[5,"mk_nested_word_item","","",N,[[["ident"]],["nestedmetaitem"]]],[5,"mk_attr_id","","",N,[[],["attrid"]]],[5,"mk_attr_inner","","Returns an inner attribute with the given value.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_spanned_attr_inner","","Returns an inner attribute with the given value and span.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_attr_outer","","Returns an outer attribute with the given value.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_spanned_attr_outer","","Returns an outer attribute with the given value and span.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_sugared_doc_attr","","",N,[[["attrid"],["symbol"],["span"]],["attribute"]]],[5,"list_contains_name","","",N,N],[5,"contains_name","","",N,N],[5,"find_by_name","","",N,N],[5,"first_attr_value_str_by_name","","",N,N],[5,"inject","","",N,N],[0,"builtin","","Parsing and validation of builtin attributes",N,N],[3,"Stability","syntax::attr::builtin","Represents the #[stable], #[unstable], #[rustc_{deprecated,const_unstable}] attributes.",N,N],[12,"level","","",149,N],[12,"feature","","",149,N],[12,"rustc_depr","","",149,N],[12,"rustc_const_unstable","","",149,N],[3,"RustcDeprecation","","",N,N],[12,"since","","",148,N],[12,"reason","","",148,N],[3,"RustcConstUnstable","","",N,N],[12,"feature","","",147,N],[3,"Deprecation","","",N,N],[12,"since","","",146,N],[12,"note","","",146,N],[4,"AttrError","","",N,N],[13,"MultipleItem","","",155,N],[13,"UnknownMetaItem","","",155,N],[13,"MissingSince","","",155,N],[13,"MissingFeature","","",155,N],[13,"MultipleStabilityLevels","","",155,N],[13,"UnsupportedLiteral","","",155,N],[4,"InlineAttr","","",N,N],[13,"None","","",150,N],[13,"Hint","","",150,N],[13,"Always","","",150,N],[13,"Never","","",150,N],[4,"UnwindAttr","","",N,N],[13,"Allowed","","",154,N],[13,"Aborts","","",154,N],[4,"StabilityLevel","","The available stability levels.",N,N],[13,"Unstable","","",153,N],[12,"reason","syntax::attr::builtin::StabilityLevel","",153,N],[12,"issue","","",153,N],[13,"Stable","syntax::attr::builtin","",153,N],[12,"since","syntax::attr::builtin::StabilityLevel","",153,N],[4,"ReprAttr","syntax::attr::builtin","",N,N],[13,"ReprInt","","",152,N],[13,"ReprC","","",152,N],[13,"ReprPacked","","",152,N],[13,"ReprSimd","","",152,N],[13,"ReprTransparent","","",152,N],[13,"ReprAlign","","",152,N],[4,"IntType","","",N,N],[13,"SignedInt","","",151,N],[13,"UnsignedInt","","",151,N],[5,"handle_errors","","",N,[[["handler"],["span"],["attrerror"]]]],[5,"find_unwind_attr","","Determine what `#[unwind]` attribute is present in `attrs`, if any.",N,N],[5,"contains_feature_attr","","Check if `attrs` contains an attribute like `#![feature(feature_name)]`. This will not perform any \"sanity checks\" on the form of the attributes.",N,N],[5,"find_stability","","Find the first stability attribute. `None` if none exists.",N,N],[5,"find_stability_generic","","",N,[[["handler"],["i"],["span"]],["option",["stability"]]]],[5,"find_crate_name","","",N,N],[5,"cfg_matches","","Tests if a cfg-pattern matches the cfg set",N,[[["metaitem"],["parsesess"],["option",["features"]]],["bool"]]],[5,"eval_condition","","Evaluate a cfg-like condition (with `any` and `all`), using `eval` to evaluate individual items.",N,[[["metaitem"],["parsesess"],["f"]],["bool"]]],[5,"find_deprecation","","Find the deprecation attribute. `None` if none exists.",N,N],[5,"find_deprecation_generic","","",N,[[["handler"],["i"],["span"]],["option",["deprecation"]]]],[5,"find_repr_attrs","","Parse #[repr(...)] forms.",N,[[["handler"],["attribute"]],["vec",["reprattr"]]]],[5,"int_type_of_word","","",N,[[["str"]],["option",["inttype"]]]],[11,"clone","syntax::attr","",150,[[["self"]],["inlineattr"]]],[11,"hash","","",150,N],[11,"eq","","",150,[[["self"],["inlineattr"]],["bool"]]],[11,"encode","","",150,[[["self"],["__s"]],["result"]]],[11,"decode","","",150,[[["__d"]],["result",["inlineattr"]]]],[11,"clone","","",154,[[["self"]],["unwindattr"]]],[11,"eq","","",154,[[["self"],["unwindattr"]],["bool"]]],[11,"encode","","",149,[[["self"],["__s"]],["result"]]],[11,"decode","","",149,[[["__d"]],["result",["stability"]]]],[11,"clone","","",149,[[["self"]],["stability"]]],[11,"fmt","","",149,[[["self"],["formatter"]],["result"]]],[11,"eq","","",149,[[["self"],["stability"]],["bool"]]],[11,"ne","","",149,[[["self"],["stability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",149,N],[11,"hash","","",149,N],[11,"encode","","",153,[[["self"],["__s"]],["result"]]],[11,"decode","","",153,[[["__d"]],["result",["stabilitylevel"]]]],[11,"eq","","",153,[[["self"],["stabilitylevel"]],["bool"]]],[11,"ne","","",153,[[["self"],["stabilitylevel"]],["bool"]]],[11,"partial_cmp","","",153,[[["self"],["stabilitylevel"]],["option",["ordering"]]]],[11,"lt","","",153,[[["self"],["stabilitylevel"]],["bool"]]],[11,"le","","",153,[[["self"],["stabilitylevel"]],["bool"]]],[11,"gt","","",153,[[["self"],["stabilitylevel"]],["bool"]]],[11,"ge","","",153,[[["self"],["stabilitylevel"]],["bool"]]],[11,"clone","","",153,[[["self"]],["stabilitylevel"]]],[11,"fmt","","",153,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",153,N],[11,"hash","","",153,N],[11,"is_unstable","","",153,[[["self"]],["bool"]]],[11,"is_stable","","",153,[[["self"]],["bool"]]],[11,"encode","","",148,[[["self"],["__s"]],["result"]]],[11,"decode","","",148,[[["__d"]],["result",["rustcdeprecation"]]]],[11,"eq","","",148,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"ne","","",148,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"partial_cmp","","",148,[[["self"],["rustcdeprecation"]],["option",["ordering"]]]],[11,"lt","","",148,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"le","","",148,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"gt","","",148,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"ge","","",148,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"clone","","",148,[[["self"]],["rustcdeprecation"]]],[11,"fmt","","",148,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",148,N],[11,"hash","","",148,N],[11,"encode","","",147,[[["self"],["__s"]],["result"]]],[11,"decode","","",147,[[["__d"]],["result",["rustcconstunstable"]]]],[11,"eq","","",147,[[["self"],["rustcconstunstable"]],["bool"]]],[11,"ne","","",147,[[["self"],["rustcconstunstable"]],["bool"]]],[11,"partial_cmp","","",147,[[["self"],["rustcconstunstable"]],["option",["ordering"]]]],[11,"lt","","",147,[[["self"],["rustcconstunstable"]],["bool"]]],[11,"le","","",147,[[["self"],["rustcconstunstable"]],["bool"]]],[11,"gt","","",147,[[["self"],["rustcconstunstable"]],["bool"]]],[11,"ge","","",147,[[["self"],["rustcconstunstable"]],["bool"]]],[11,"clone","","",147,[[["self"]],["rustcconstunstable"]]],[11,"fmt","","",147,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",147,N],[11,"hash","","",147,N],[11,"encode","","",146,[[["self"],["__s"]],["result"]]],[11,"decode","","",146,[[["__d"]],["result",["deprecation"]]]],[11,"eq","","",146,[[["self"],["deprecation"]],["bool"]]],[11,"ne","","",146,[[["self"],["deprecation"]],["bool"]]],[11,"partial_cmp","","",146,[[["self"],["deprecation"]],["option",["ordering"]]]],[11,"lt","","",146,[[["self"],["deprecation"]],["bool"]]],[11,"le","","",146,[[["self"],["deprecation"]],["bool"]]],[11,"gt","","",146,[[["self"],["deprecation"]],["bool"]]],[11,"ge","","",146,[[["self"],["deprecation"]],["bool"]]],[11,"clone","","",146,[[["self"]],["deprecation"]]],[11,"fmt","","",146,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",146,N],[11,"hash","","",146,N],[11,"eq","","",152,[[["self"],["reprattr"]],["bool"]]],[11,"ne","","",152,[[["self"],["reprattr"]],["bool"]]],[11,"fmt","","",152,[[["self"],["formatter"]],["result"]]],[11,"encode","","",152,[[["self"],["__s"]],["result"]]],[11,"decode","","",152,[[["__d"]],["result",["reprattr"]]]],[11,"clone","","",152,[[["self"]],["reprattr"]]],[11,"assert_receiver_is_total_eq","","",151,N],[11,"hash","","",151,N],[11,"eq","","",151,[[["self"],["inttype"]],["bool"]]],[11,"ne","","",151,[[["self"],["inttype"]],["bool"]]],[11,"fmt","","",151,[[["self"],["formatter"]],["result"]]],[11,"encode","","",151,[[["self"],["__s"]],["result"]]],[11,"decode","","",151,[[["__d"]],["result",["inttype"]]]],[11,"clone","","",151,[[["self"]],["inttype"]]],[11,"is_signed","","",151,[[["self"]],["bool"]]],[17,"RUST_KNOWN_TOOL","","",N,N],[17,"RUST_KNOWN_LINT_TOOL","","",N,N],[8,"HasAttrs","","",N,N],[10,"attrs","","",156,N],[10,"map_attrs","","",156,[[["self"],["f"]],["self"]]],[11,"meta_item","","Returns the MetaItem if self is a NestedMetaItemKind::MetaItem.",157,[[["self"]],["option",["metaitem"]]]],[11,"literal","","Returns the Lit if self is a NestedMetaItemKind::Literal.",157,[[["self"]],["option",["lit"]]]],[11,"span","","Returns the Span for `self`.",157,[[["self"]],["span"]]],[11,"check_name","","Returns true if this list item is a MetaItem with a name of `name`.",157,[[["self"],["str"]],["bool"]]],[11,"name","","Returns the name of the meta item, e.g. `foo` in `#[foo]`, `#[foo=\"bar\"]` and `#[foo(bar)]`, if self is a MetaItem",157,[[["self"]],["option",["name"]]]],[11,"value_str","","Gets the string value if self is a MetaItem and the MetaItem is a MetaItemKind::NameValue variant containing a string, otherwise None.",157,[[["self"]],["option",["symbol"]]]],[11,"name_value_literal","","Returns a name and single literal value tuple of the MetaItem.",157,[[["self"]],["option"]]],[11,"word","","Returns a MetaItem if self is a MetaItem with Kind Word.",157,[[["self"]],["option",["metaitem"]]]],[11,"meta_item_list","","Gets a list of inner meta items from a list MetaItem type.",157,[[["self"]],["option"]]],[11,"is_meta_item","","Returns `true` if the variant is MetaItem.",157,[[["self"]],["bool"]]],[11,"is_literal","","Returns `true` if the variant is Literal.",157,[[["self"]],["bool"]]],[11,"is_word","","Returns `true` if self is a MetaItem and the meta item is a word.",157,[[["self"]],["bool"]]],[11,"is_value_str","","Returns `true` if self is a MetaItem and the meta item is a ValueString.",157,[[["self"]],["bool"]]],[11,"is_meta_item_list","","Returns `true` if self is a MetaItem and the meta item is a list.",157,[[["self"]],["bool"]]],[11,"check_name","syntax::ast","",90,[[["self"],["str"]],["bool"]]],[11,"name","","Returns the last segment of the name of this attribute. E.g. `foo` for `#[foo]`, `skip` for `#[rustfmt::skip]`.",90,[[["self"]],["name"]]],[11,"value_str","","",90,[[["self"]],["option",["symbol"]]]],[11,"meta_item_list","","",90,[[["self"]],["option",["vec"]]]],[11,"is_word","","",90,[[["self"]],["bool"]]],[11,"span","","",90,[[["self"]],["span"]]],[11,"is_meta_item_list","","",90,[[["self"]],["bool"]]],[11,"is_value_str","","Indicates if the attribute is a Value String.",90,[[["self"]],["bool"]]],[11,"is_scoped","","",90,[[["self"]],["bool"]]],[11,"name","","",59,[[["self"]],["name"]]],[11,"value_str","","",59,[[["self"]],["option",["symbol"]]]],[11,"meta_item_list","","",59,[[["self"]],["option"]]],[11,"is_word","","",59,[[["self"]],["bool"]]],[11,"span","","",59,[[["self"]],["span"]]],[11,"check_name","","",59,[[["self"],["str"]],["bool"]]],[11,"is_value_str","","",59,[[["self"]],["bool"]]],[11,"is_meta_item_list","","",59,[[["self"]],["bool"]]],[11,"is_scoped","","",59,[[["self"]],["option",["ident"]]]],[11,"meta","","Extract the MetaItem from inside this Attribute.",90,[[["self"]],["option",["metaitem"]]]],[11,"parse","","",90,[[["self"],["parsesess"],["f"]],["presult"]]],[11,"parse_list","","",90,[[["self"],["parsesess"],["f"]],["presult",["vec"]]]],[11,"parse_meta","","",90,[[["self"],["parsesess"]],["presult",["metaitem"]]]],[11,"with_desugared_doc","","Convert self to a normal #[doc=\"foo\"] comment, if it is a comment like `///` or `/** */`. (Returns self unchanged for non-sugared doc attributes.)",90,[[["self"],["f"]],["t"]]],[11,"tokens","","",59,[[["self"]],["tokenstream"]]],[11,"from_tokens","","",59,[[["peekable"]],["option",["metaitem"]]]],[11,"tokens","","",104,[[["self"],["span"]],["tokenstream"]]],[11,"from_tokens","","",104,[[["peekable"]],["option",["metaitemkind"]]]],[11,"span","","",103,[[["self"]],["span"]]],[11,"tokens","","",103,[[["self"]],["tokenstream"]]],[11,"from_tokens","","",103,[[["peekable"]],["option",["nestedmetaitemkind"]]]],[11,"tokens","syntax::attr","",158,[[["self"]],["tokenstream"]]],[11,"token","syntax::ast","",123,[[["self"]],["token"]]],[11,"from_token","","",123,[[["token"]],["option",["litkind"]]]],[11,"attrs","syntax::util","",30,N],[11,"map_attrs","","",30,[[["self"],["f"]],["self"]]],[11,"attrs","syntax::ast","",112,N],[11,"map_attrs","","",112,[[["self"],["f"]],["self"]]],[11,"attrs","","",63,N],[11,"map_attrs","","",63,[[["self"],["f"]],["self"]]],[11,"attrs","","",52,N],[11,"map_attrs","","",52,[[["self"],["f"]],["self"]]],[11,"attrs","","",94,N],[11,"map_attrs","","",94,[[["self"],["f"]],["self"]]],[11,"attrs","","",68,N],[11,"map_attrs","","",68,[[["self"],["f"]],["self"]]],[11,"attrs","","",64,N],[11,"map_attrs","","",64,[[["self"],["f"]],["self"]]],[11,"attrs","","",96,N],[11,"map_attrs","","",96,[[["self"],["f"]],["self"]]],[11,"attrs","","",93,N],[11,"map_attrs","","",93,[[["self"],["f"]],["self"]]],[11,"attrs","","",75,N],[11,"map_attrs","","",75,[[["self"],["f"]],["self"]]],[11,"attrs","","",74,N],[11,"map_attrs","","",74,[[["self"],["f"]],["self"]]],[11,"attrs","","",65,N],[11,"map_attrs","","",65,[[["self"],["f"]],["self"]]],[11,"attrs","","",66,N],[11,"map_attrs","","",66,[[["self"],["f"]],["self"]]],[11,"attrs","","",62,N],[11,"map_attrs","","",62,[[["self"],["f"]],["self"]]],[11,"attrs","","",87,N],[11,"map_attrs","","",87,[[["self"],["f"]],["self"]]],[0,"codemap","syntax","The CodeMap tracks all the source code used within a single crate, mapping from integer byte positions to the original source code location. Each bit of source parsed during crate parsing (typically files, in-memory strings, or various bits of macro expansion) cover a continuous range of bytes in the CodeMap and are represented by FileMaps. Byte positions are stored in `spans` and used pervasively in the compiler. They are absolute positions within the CodeMap, which upon request can be converted to line and column information, source code snippets, etc.",N,N],[0,"edition","syntax::codemap","",N,N],[4,"Edition","syntax::codemap::edition","The edition of the compiler (RFC 2052)",N,N],[13,"Edition2015","","The 2015 edition",0,N],[13,"Edition2018","","The 2018 edition",0,N],[17,"ALL_EDITIONS","","",N,N],[17,"EDITION_NAME_LIST","","",N,N],[17,"DEFAULT_EDITION","","",N,N],[0,"hygiene","syntax::codemap","Machinery for hygienic macros, inspired by the `MTWT[1]` paper.",N,N],[3,"SyntaxContext","syntax::codemap::hygiene","A SyntaxContext represents a chain of macro expansions (represented by marks).",N,N],[12,"0","","",159,N],[3,"Mark","","A mark is a unique id associated with a macro expansion.",N,N],[12,"0","","",160,N],[4,"Transparency","","A property of a macro expansion that determines how identifiers produced by that expansion are resolved.",N,N],[13,"Transparent","","Identifier produced by a transparent expansion is always resolved at call-site. Call-site spans in procedural macros, hygiene opt-out in `macro` should use this.",161,N],[13,"SemiTransparent","","Identifier produced by a semi-transparent expansion may be resolved either at call-site or at definition-site. If it's a local variable, label or `$crate` then it's resolved at def-site. Otherwise it's resolved at call-site. `macro_rules` macros behave like this, built-in macros currently behave like this too, but that's an implementation detail.",161,N],[13,"Opaque","","Identifier produced by an opaque expansion is always resolved at definition-site. Def-site spans in procedural macros, identifiers from `macro` by default use this.",161,N],[5,"default_edition","","",N,[[],["edition"]]],[5,"set_default_edition","","",N,N],[5,"clear_markings","","",N,N],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",N,N],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",162,N],[12,"def_site","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None. This span serves only informational purpose and is not used for resolution.",162,N],[12,"format","","The format with which the macro was invoked.",162,N],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",162,N],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",162,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",162,N],[12,"edition","","Edition of the crate in which the macro is defined.",162,N],[4,"ExpnFormat","","The source of expansion.",N,N],[13,"MacroAttribute","","e.g. #[derive(...)] ",163,N],[13,"MacroBang","","e.g. `format!()`",163,N],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",163,N],[4,"CompilerDesugaringKind","","The kind of compiler desugaring.",N,N],[13,"DotFill","","",164,N],[13,"QuestionMark","","",164,N],[13,"Catch","","",164,N],[13,"ExistentialReturnType","","Desugaring of an `impl Trait` in return type position to an `existential type Foo: Trait;` + replacing the `impl Trait` with `Foo`.",164,N],[13,"Async","","",164,N],[13,"ForLoop","","",164,N],[0,"symbol","syntax::codemap","An \"interner\" is a data structure that associates values with usize tags and allows bidirectional lookup; i.e. given a value, one can easily find the type, and vice versa.",N,N],[3,"Ident","syntax::codemap::symbol","",N,N],[12,"name","","",1,N],[12,"span","","",1,N],[3,"Symbol","","A symbol is an interned or gensymed string.",N,N],[12,"0","","",2,N],[3,"Interner","","",N,N],[12,"arena","","",3,N],[12,"names","","",3,N],[12,"strings","","",3,N],[12,"gensyms","","",3,N],[0,"keywords","","",N,N],[3,"Keyword","syntax::codemap::symbol::keywords","",N,N],[12,"ident","","",4,N],[17,"Invalid","","",N,N],[17,"CrateRoot","","",N,N],[17,"DollarCrate","","",N,N],[17,"Underscore","","",N,N],[17,"As","","",N,N],[17,"Box","","",N,N],[17,"Break","","",N,N],[17,"Const","","",N,N],[17,"Continue","","",N,N],[17,"Crate","","",N,N],[17,"Else","","",N,N],[17,"Enum","","",N,N],[17,"Extern","","",N,N],[17,"False","","",N,N],[17,"Fn","","",N,N],[17,"For","","",N,N],[17,"If","","",N,N],[17,"Impl","","",N,N],[17,"In","","",N,N],[17,"Let","","",N,N],[17,"Loop","","",N,N],[17,"Match","","",N,N],[17,"Mod","","",N,N],[17,"Move","","",N,N],[17,"Mut","","",N,N],[17,"Pub","","",N,N],[17,"Ref","","",N,N],[17,"Return","","",N,N],[17,"SelfValue","","",N,N],[17,"SelfType","","",N,N],[17,"Static","","",N,N],[17,"Struct","","",N,N],[17,"Super","","",N,N],[17,"Trait","","",N,N],[17,"True","","",N,N],[17,"Type","","",N,N],[17,"Unsafe","","",N,N],[17,"Use","","",N,N],[17,"Where","","",N,N],[17,"While","","",N,N],[17,"Abstract","","",N,N],[17,"Become","","",N,N],[17,"Do","","",N,N],[17,"Final","","",N,N],[17,"Macro","","",N,N],[17,"Override","","",N,N],[17,"Priv","","",N,N],[17,"Typeof","","",N,N],[17,"Unsized","","",N,N],[17,"Virtual","","",N,N],[17,"Yield","","",N,N],[17,"Async","","",N,N],[17,"UnderscoreLifetime","","",N,N],[17,"StaticLifetime","","",N,N],[17,"Auto","","",N,N],[17,"Catch","","",N,N],[17,"Default","","",N,N],[17,"Dyn","","",N,N],[17,"Union","","",N,N],[17,"Existential","","",N,N],[3,"LocalInternedString","syntax::codemap::symbol","Represents a string stored in the interner. Because the interner outlives any thread which uses this type, we can safely treat `string` which points to interner data, as an immortal string, as long as this type never crosses between threads.",N,N],[12,"string","","",5,N],[3,"InternedString","","Represents a string stored in the string interner",N,N],[12,"symbol","","",6,N],[3,"Globals","syntax::codemap","",N,N],[12,"symbol_interner","","",165,N],[12,"span_interner","","",165,N],[12,"hygiene_data","","",165,N],[7,"GLOBALS","","",N,N],[4,"FileName","","Differentiates between real files and common virtual files",N,N],[13,"Real","","",166,N],[13,"Macros","","e.g. \"std\" macros",166,N],[13,"QuoteExpansion","","call to `quote!`",166,N],[13,"Anon","","Command line",166,N],[13,"MacroExpansion","","Hack in src/libsyntax/parse.rs FIXME(jseyfried)",166,N],[13,"ProcMacroSourceCode","","",166,N],[13,"CfgSpec","","Strings provided as --cfg [cfgspec] stored in a crate_cfg",166,N],[13,"CliCrateAttr","","Strings provided as crate attributes in the CLI",166,N],[13,"Custom","","Custom sources for explicit parser calls from plugins and drivers",166,N],[3,"SpanData","","Spans represent a region of code, used for error reporting. Positions in spans are absolute positions from the beginning of the codemap, not positions relative to FileMaps. Methods on the CodeMap can be used to relate spans back to the original source. You must be careful if the span crosses more than one file - you will not be able to use many of the functions on spans in codemap and you cannot assume that the length of the span = hi - lo; there may be space in the BytePos range between files.",N,N],[12,"lo","","",167,N],[12,"hi","","",167,N],[12,"ctxt","","Information about where the macro came from, if this piece of code was created by a macro expansion.",167,N],[3,"MultiSpan","","A collection of spans. Spans have two orthogonal attributes:",N,N],[12,"primary_spans","","",168,N],[12,"span_labels","","",168,N],[3,"SpanLabel","","",N,N],[12,"span","","The span we are going to include in the final snippet.",169,N],[12,"is_primary","","Is this a primary span? This is the \"locus\" of the message, and is indicated with a `^^^^` underline, versus `----`.",169,N],[12,"label","","What label should we attach to this span (if any)?",169,N],[17,"NO_EXPANSION","","",N,N],[3,"MultiByteChar","","Identifies an offset of a multi-byte character in a FileMap",N,N],[12,"pos","","The absolute offset of the character in the CodeMap",170,N],[12,"bytes","","The number of bytes, >=2",170,N],[4,"NonNarrowChar","","Identifies an offset of a non-narrow character in a FileMap",N,N],[13,"ZeroWidth","","Represents a zero-width character",171,N],[13,"Wide","","Represents a wide (fullwidth) character",171,N],[13,"Tab","","Represents a tab character, represented visually with a width of 4 characters",171,N],[4,"ExternalSource","","The state of the lazy external source loading mechanism of a FileMap.",N,N],[13,"Present","","The external source has been loaded already.",172,N],[13,"AbsentOk","","No attempt has been made to load the external source.",172,N],[13,"AbsentErr","","A failed attempt has been made to load the external source.",172,N],[13,"Unneeded","","No external source has to be loaded, since the FileMap represents a local crate.",172,N],[3,"FileMap","","A single source in the CodeMap.",N,N],[12,"name","","The name of the file that the source came from, source that doesn't originate from files has names between angle brackets by convention, e.g. `<anon>`",173,N],[12,"name_was_remapped","","True if the `name` field above has been modified by --remap-path-prefix",173,N],[12,"unmapped_path","","The unmapped path of the file that the source came from. Set to `None` if the FileMap was imported from an external crate.",173,N],[12,"crate_of_origin","","Indicates which crate this FileMap was imported from.",173,N],[12,"src","","The complete source code",173,N],[12,"src_hash","","The source code's hash",173,N],[12,"external_src","","The external source code (used for external crates, which will have a `None` value as `self.src`.",173,N],[12,"start_pos","","The start position of this source in the CodeMap",173,N],[12,"end_pos","","The end position of this source in the CodeMap",173,N],[12,"lines","","Locations of lines beginnings in the source code",173,N],[12,"multibyte_chars","","Locations of multi-byte characters in the source code",173,N],[12,"non_narrow_chars","","Width of characters that are not narrow in the source code",173,N],[12,"name_hash","","A hash of the filename, used for speeding up the incr. comp. hashing.",173,N],[8,"Pos","","",N,N],[10,"from_usize","","",174,[[["usize"]],["self"]]],[10,"to_usize","","",174,[[["self"]],["usize"]]],[10,"from_u32","","",174,[[["u32"]],["self"]]],[10,"to_u32","","",174,[[["self"]],["u32"]]],[3,"BytePos","","A byte offset. Keep this small (currently 32-bits), as AST contains a lot of them.",N,N],[12,"0","","",175,N],[3,"CharPos","","A character offset. Because of multibyte utf8 characters, a byte offset is not equivalent to a character offset. The CodeMap will convert BytePos values to CharPos values as necessary.",N,N],[12,"0","","",176,N],[3,"Loc","","A source code location used for error reporting",N,N],[12,"file","","Information about the original source",177,N],[12,"line","","The (1-based) line number",177,N],[12,"col","","The (0-based) column offset",177,N],[12,"col_display","","The (0-based) column offset when displayed",177,N],[3,"LocWithOpt","","A source code location used as the result of lookup_char_pos_adj",N,N],[12,"filename","","",178,N],[12,"line","","",178,N],[12,"col","","",178,N],[12,"file","","",178,N],[3,"FileMapAndLine","","",N,N],[12,"fm","","",179,N],[12,"line","","",179,N],[3,"FileMapAndBytePos","","",N,N],[12,"fm","","",180,N],[12,"pos","","",180,N],[3,"LineInfo","","",N,N],[12,"line_index","","Index of line, starting from 0.",181,N],[12,"start_col","","Column in line where span begins, starting from 0.",181,N],[12,"end_col","","Column in line where span ends, starting from 0, exclusive.",181,N],[3,"FileLines","","",N,N],[12,"file","","",182,N],[12,"lines","","",182,N],[17,"SPAN_DEBUG","","",N,N],[3,"MacroBacktrace","","",N,N],[12,"call_site","","span where macro was applied to generate this code",183,N],[12,"macro_decl_name","","name of macro that was applied (e.g., \"foo!\" or \"#[derive(Eq)]\")",183,N],[12,"def_site_span","","span where macro was defined (if known)",183,N],[6,"FileLinesResult","","",N,N],[4,"SpanLinesError","","",N,N],[13,"IllFormedSpan","","",184,N],[13,"DistinctSources","","",184,N],[4,"SpanSnippetError","","",N,N],[13,"IllFormedSpan","","",185,N],[13,"DistinctSources","","",185,N],[13,"MalformedForCodemap","","",185,N],[13,"SourceNotAvailable","","",185,N],[12,"filename","syntax::codemap::SpanSnippetError","",185,N],[3,"DistinctSources","syntax::codemap","",N,N],[12,"begin","","",186,N],[12,"end","","",186,N],[3,"MalformedCodemapPositions","","",N,N],[12,"name","","",187,N],[12,"source_len","","",187,N],[12,"begin_pos","","",187,N],[12,"end_pos","","",187,N],[3,"Span","","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",N,N],[12,"0","","",188,N],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",N,N],[4,"ExpnFormat","","The source of expansion.",N,N],[13,"MacroAttribute","","e.g. #[derive(...)] ",163,N],[13,"MacroBang","","e.g. `format!()`",163,N],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",163,N],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",N,N],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",162,N],[12,"def_site","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None. This span serves only informational purpose and is not used for resolution.",162,N],[12,"format","","The format with which the macro was invoked.",162,N],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",162,N],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",162,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",162,N],[12,"edition","","Edition of the crate in which the macro is defined.",162,N],[3,"Spanned","","",N,N],[12,"node","","",189,N],[12,"span","","",189,N],[3,"RealFileLoader","","A FileLoader that uses std::fs to load real files.",N,N],[3,"StableFilemapId","","",N,N],[12,"0","","",190,N],[3,"CodeMapFiles","","",N,N],[12,"file_maps","","",191,N],[12,"stable_id_to_filemap","","",191,N],[3,"CodeMap","","",N,N],[12,"files","","",192,N],[12,"file_loader","","",192,N],[12,"path_mapping","","",192,N],[12,"doctest_offset","","In case we are in a doctest, replace all file names with the PathBuf, and add the given offsets to the line info",192,N],[3,"FilePathMapping","","",N,N],[12,"mapping","","",193,N],[5,"original_sp","","Return the span itself if it doesn't come from a macro expansion, otherwise return the call site span up to the `enclosing_sp` by following the `expn_info` chain.",N,[[["span"],["span"]],["span"]]],[5,"respan","","",N,[[["span"],["t"]],["spanned"]]],[5,"dummy_spanned","","",N,[[["t"]],["spanned"]]],[8,"FileLoader","","An abstraction over the fs operations used by the Parser.",N,N],[10,"file_exists","","Query the existence of a file.",194,[[["self"],["path"]],["bool"]]],[10,"abs_path","","Return an absolute path to a file, if possible.",194,[[["self"],["path"]],["option",["pathbuf"]]]],[10,"read_file","","Read the contents of an UTF-8 file into memory.",194,[[["self"],["path"]],["result",["string"]]]],[11,"clone","","",189,[[["self"]],["spanned"]]],[11,"eq","","",189,[[["self"],["spanned"]],["bool"]]],[11,"ne","","",189,[[["self"],["spanned"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",189,N],[11,"encode","","",189,[[["self"],["__st"]],["result"]]],[11,"decode","","",189,[[["__dt"]],["result",["spanned"]]]],[11,"hash","","",189,N],[11,"fmt","","",189,[[["self"],["formatter"]],["result"]]],[11,"file_exists","","",195,[[["self"],["path"]],["bool"]]],[11,"abs_path","","",195,[[["self"],["path"]],["option",["pathbuf"]]]],[11,"read_file","","",195,[[["self"],["path"]],["result",["string"]]]],[11,"clone","","",190,[[["self"]],["stablefilemapid"]]],[11,"eq","","",190,[[["self"],["stablefilemapid"]],["bool"]]],[11,"ne","","",190,[[["self"],["stablefilemapid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",190,N],[11,"hash","","",190,N],[11,"encode","","",190,[[["self"],["__s"]],["result"]]],[11,"decode","","",190,[[["__d"]],["result",["stablefilemapid"]]]],[11,"fmt","","",190,[[["self"],["formatter"]],["result"]]],[11,"new","","",190,[[["filemap"]],["stablefilemapid"]]],[11,"new","","",192,[[["filepathmapping"]],["codemap"]]],[11,"new_doctest","","",192,[[["filepathmapping"],["filename"],["isize"]],["codemap"]]],[11,"with_file_loader","","",192,[[["box",["fileloader"]],["filepathmapping"]],["codemap"]]],[11,"path_mapping","","",192,[[["self"]],["filepathmapping"]]],[11,"file_exists","","",192,[[["self"],["path"]],["bool"]]],[11,"load_file","","",192,[[["self"],["path"]],["result",["lrc"]]]],[11,"files","","",192,[[["self"]],["lockguard",["vec"]]]],[11,"filemap_by_stable_id","","",192,[[["self"],["stablefilemapid"]],["option",["lrc"]]]],[11,"next_start_pos","","",192,[[["self"]],["usize"]]],[11,"new_filemap","","Creates a new filemap. This does not ensure that only one FileMap exists per file name.",192,[[["self"],["filename"],["string"]],["lrc",["filemap"]]]],[11,"new_imported_filemap","","Allocates a new FileMap representing a source file from an external crate. The source code of such an \"imported filemap\" is not available, but we still know enough to generate accurate debuginfo location information for things inlined from other crates.",192,[[["self"],["filename"],["bool"],["u32"],["u128"],["u128"],["usize"],["vec",["bytepos"]],["vec",["multibytechar"]],["vec",["nonnarrowchar"]]],["lrc",["filemap"]]]],[11,"mk_substr_filename","","",192,[[["self"],["span"]],["string"]]],[11,"doctest_offset_line","","",192,[[["self"],["usize"]],["usize"]]],[11,"lookup_char_pos","","Lookup source information about a BytePos",192,[[["self"],["bytepos"]],["loc"]]],[11,"lookup_line","","",192,[[["self"],["bytepos"]],["result",["filemapandline","lrc"]]]],[11,"lookup_char_pos_adj","","",192,[[["self"],["bytepos"]],["locwithopt"]]],[11,"merge_spans","","Returns `Some(span)`, a union of the lhs and rhs span.  The lhs must precede the rhs. If there are gaps between lhs and rhs, the resulting union will cross these gaps. For this to work, the spans have to be:",192,[[["self"],["span"],["span"]],["option",["span"]]]],[11,"span_to_string","","",192,[[["self"],["span"]],["string"]]],[11,"span_to_filename","","",192,[[["self"],["span"]],["filename"]]],[11,"span_to_unmapped_path","","",192,[[["self"],["span"]],["filename"]]],[11,"is_multiline","","",192,[[["self"],["span"]],["bool"]]],[11,"span_to_lines","","",192,[[["self"],["span"]],["filelinesresult"]]],[11,"span_to_source","","Extract the source surrounding the given `Span` using the `extract_source` function. The extract function takes three arguments: a string slice containing the source, an index in the slice for the beginning of the span and an index in the slice for the end of the span.",192,[[["self"],["span"],["f"]],["result",["string","spansnippeterror"]]]],[11,"span_to_snippet","","Return the source snippet as `String` corresponding to the given `Span`",192,[[["self"],["span"]],["result",["string","spansnippeterror"]]]],[11,"span_to_prev_source","","Return the source snippet as `String` before the given `Span`",192,[[["self"],["span"]],["result",["string","spansnippeterror"]]]],[11,"span_extend_to_prev_char","","Extend the given `Span` to just after the previous occurrence of `c`. Return the same span if no character could be found or if an error occurred while retrieving the code snippet.",192,[[["self"],["span"],["char"]],["span"]]],[11,"span_extend_to_prev_str","","Extend the given `Span` to just after the previous occurrence of `pat` when surrounded by whitespace. Return the same span if no character could be found or if an error occurred while retrieving the code snippet.",192,[[["self"],["span"],["str"],["bool"]],["span"]]],[11,"span_until_char","","Given a `Span`, try to get a shorter span ending before the first occurrence of `c` `char`",192,[[["self"],["span"],["char"]],["span"]]],[11,"span_through_char","","Given a `Span`, try to get a shorter span ending just after the first occurrence of `char` `c`.",192,[[["self"],["span"],["char"]],["span"]]],[11,"span_until_non_whitespace","","Given a `Span`, get a new `Span` covering the first token and all its trailing whitespace or the original `Span`.",192,[[["self"],["span"]],["span"]]],[11,"span_until_whitespace","","Given a `Span`, get a new `Span` covering the first token without its trailing whitespace or the original `Span` in case of error.",192,[[["self"],["span"]],["span"]]],[11,"span_take_while","","Given a `Span`, get a shorter one until `predicate` yields false.",192,[[["self"],["span"],["p"]],["span"]]],[11,"def_span","","",192,[[["self"],["span"]],["span"]]],[11,"start_point","","Returns a new span representing just the start-point of this span",192,[[["self"],["span"]],["span"]]],[11,"end_point","","Returns a new span representing just the end-point of this span",192,[[["self"],["span"]],["span"]]],[11,"next_point","","Returns a new span representing the next character after the end-point of this span",192,[[["self"],["span"]],["span"]]],[11,"find_width_of_character_at_span","","Finds the width of a character, either before or after the provided span.",192,[[["self"],["span"],["bool"]],["u32"]]],[11,"get_filemap","","",192,[[["self"],["filename"]],["option",["lrc"]]]],[11,"lookup_byte_offset","","For a global BytePos compute the local offset within the containing FileMap",192,[[["self"],["bytepos"]],["filemapandbytepos"]]],[11,"bytepos_to_file_charpos","","Converts an absolute BytePos to a CharPos relative to the filemap.",192,[[["self"],["bytepos"]],["charpos"]]],[11,"lookup_filemap_idx","","",192,[[["self"],["bytepos"]],["usize"]]],[11,"count_lines","","",192,[[["self"]],["usize"]]],[11,"generate_fn_name_span","","",192,[[["self"],["span"]],["option",["span"]]]],[11,"generate_local_type_param_snippet","","Take the span of a type parameter in a function signature and try to generate a span for the function name (with generics) and a new snippet for this span with the pointed type parameter as a new local type parameter.",192,[[["self"],["span"]],["option"]]],[11,"lookup_char_pos","","",192,[[["self"],["bytepos"]],["loc"]]],[11,"span_to_lines","","",192,[[["self"],["span"]],["filelinesresult"]]],[11,"span_to_string","","",192,[[["self"],["span"]],["string"]]],[11,"span_to_filename","","",192,[[["self"],["span"]],["filename"]]],[11,"merge_spans","","",192,[[["self"],["span"],["span"]],["option",["span"]]]],[11,"call_span_if_macro","","",192,[[["self"],["span"]],["span"]]],[11,"ensure_filemap_source_present","","",192,[[["self"],["lrc",["filemap"]]],["bool"]]],[11,"doctest_offset_line","","",192,[[["self"],["usize"]],["usize"]]],[11,"clone","","",193,[[["self"]],["filepathmapping"]]],[11,"empty","","",193,[[],["filepathmapping"]]],[11,"new","","",193,[[["vec"]],["filepathmapping"]]],[11,"map_prefix","","Applies any path prefix substitution as defined by the mapping. The return value is the remapped path and a boolean indicating whether the path was affected by the mapping.",193,N],[0,"config","syntax","",N,N],[3,"StripUnconfigured","syntax::config","A folder that strips out items that do not belong in the current configuration.",N,N],[12,"should_test","","",196,N],[12,"sess","","",196,N],[12,"features","","",196,N],[5,"features","","",N,N],[5,"is_cfg","","",N,[[["attribute"]],["bool"]]],[5,"is_test_or_bench","","",N,[[["attribute"]],["bool"]]],[11,"configure","","",196,[[["self"],["t"]],["option"]]],[11,"process_cfg_attrs","","",196,[[["self"],["t"]],["t"]]],[11,"process_cfg_attr","","",196,[[["self"],["attribute"]],["option",["attribute"]]]],[11,"in_cfg","","",196,N],[11,"visit_expr_attrs","","",196,N],[11,"maybe_emit_expr_attr_err","","If attributes are not allowed on expressions, emit an error for `attr`",196,[[["self"],["attribute"]]]],[11,"configure_foreign_mod","","",196,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"configure_variant_data","","",196,[[["self"],["variantdata"]],["variantdata"]]],[11,"configure_item_kind","","",196,[[["self"],["itemkind"]],["itemkind"]]],[11,"configure_expr_kind","","",196,[[["self"],["exprkind"]],["exprkind"]]],[11,"configure_expr","","",196,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"configure_stmt","","",196,[[["self"],["stmt"]],["option",["stmt"]]]],[11,"configure_struct_expr_field","","",196,[[["self"],["field"]],["option",["field"]]]],[11,"configure_pat","","",196,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"disallow_cfg_on_generic_param","","",196,[[["self"],["genericparam"]]]],[11,"fold_foreign_mod","","",196,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"fold_item_kind","","",196,[[["self"],["itemkind"]],["itemkind"]]],[11,"fold_expr","","",196,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_opt_expr","","",196,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_stmt","","",196,[[["self"],["stmt"]],["smallvector",["stmt"]]]],[11,"fold_item","","",196,[[["self"],["p",["item"]]],["smallvector",["p"]]]],[11,"fold_impl_item","","",196,[[["self"],["implitem"]],["smallvector",["implitem"]]]],[11,"fold_trait_item","","",196,[[["self"],["traititem"]],["smallvector",["traititem"]]]],[11,"fold_mac","","",196,[[["self"],["mac"]],["mac"]]],[11,"fold_pat","","",196,[[["self"],["p",["pat"]]],["p",["pat"]]]],[0,"entry","syntax","",N,N],[4,"EntryPointType","syntax::entry","",N,N],[13,"None","","",197,N],[13,"MainNamed","","",197,N],[13,"MainAttr","","",197,N],[13,"Start","","",197,N],[13,"OtherMain","","",197,N],[5,"entry_point_type","","",N,[[["item"],["usize"]],["entrypointtype"]]],[0,"feature_gate","syntax","Feature gating",N,N],[3,"Features","syntax::feature_gate","A set of features to be used by later passes.",N,N],[12,"declared_stable_lang_features","","`#![feature]` attrs for stable language features, for error reporting",198,N],[12,"declared_lib_features","","`#![feature]` attrs for non-language (library) features",198,N],[12,"asm","","",198,N],[12,"concat_idents","","",198,N],[12,"link_args","","",198,N],[12,"log_syntax","","",198,N],[12,"non_ascii_idents","","",198,N],[12,"plugin_registrar","","",198,N],[12,"thread_local","","",198,N],[12,"trace_macros","","",198,N],[12,"intrinsics","","",198,N],[12,"lang_items","","",198,N],[12,"format_args_nl","","",198,N],[12,"link_llvm_intrinsics","","",198,N],[12,"linkage","","",198,N],[12,"quote","","",198,N],[12,"rustc_diagnostic_macros","","",198,N],[12,"rustc_const_unstable","","",198,N],[12,"box_syntax","","",198,N],[12,"unboxed_closures","","",198,N],[12,"fundamental","","",198,N],[12,"main","","",198,N],[12,"needs_allocator","","",198,N],[12,"on_unimplemented","","",198,N],[12,"plugin","","",198,N],[12,"simd_ffi","","",198,N],[12,"start","","",198,N],[12,"structural_match","","",198,N],[12,"panic_runtime","","",198,N],[12,"needs_panic_runtime","","",198,N],[12,"optin_builtin_traits","","",198,N],[12,"staged_api","","",198,N],[12,"no_core","","",198,N],[12,"box_patterns","","",198,N],[12,"dropck_parametricity","","",198,N],[12,"dropck_eyepatch","","",198,N],[12,"custom_attribute","","",198,N],[12,"custom_derive","","",198,N],[12,"rustc_attrs","","",198,N],[12,"nll","","",198,N],[12,"allow_internal_unstable","","",198,N],[12,"allow_internal_unsafe","","",198,N],[12,"slice_patterns","","",198,N],[12,"const_fn","","",198,N],[12,"const_let","","",198,N],[12,"prelude_import","","",198,N],[12,"default_type_parameter_fallback","","",198,N],[12,"associated_type_defaults","","",198,N],[12,"repr_simd","","",198,N],[12,"platform_intrinsics","","",198,N],[12,"unwind_attributes","","",198,N],[12,"naked_functions","","",198,N],[12,"no_debug","","",198,N],[12,"omit_gdb_pretty_printer_section","","",198,N],[12,"cfg_target_vendor","","",198,N],[12,"stmt_expr_attributes","","",198,N],[12,"type_ascription","","",198,N],[12,"cfg_target_thread_local","","",198,N],[12,"abi_vectorcall","","",198,N],[12,"exclusive_range_pattern","","",198,N],[12,"specialization","","",198,N],[12,"cfg_target_has_atomic","","",198,N],[12,"never_type","","",198,N],[12,"exhaustive_patterns","","",198,N],[12,"attr_literals","","",198,N],[12,"untagged_unions","","",198,N],[12,"compiler_builtins","","",198,N],[12,"link_cfg","","",198,N],[12,"use_extern_macros","","",198,N],[12,"abi_ptx","","",198,N],[12,"repr128","","",198,N],[12,"abi_unadjusted","","",198,N],[12,"decl_macro","","",198,N],[12,"static_nobundle","","",198,N],[12,"abi_msp430_interrupt","","",198,N],[12,"sanitizer_runtime","","",198,N],[12,"profiler_runtime","","",198,N],[12,"abi_x86_interrupt","","",198,N],[12,"catch_expr","","",198,N],[12,"used","","",198,N],[12,"global_asm","","",198,N],[12,"overlapping_marker_traits","","",198,N],[12,"macro_vis_matcher","","",198,N],[12,"abi_thiscall","","",198,N],[12,"allow_fail","","",198,N],[12,"unsized_tuple_coercion","","",198,N],[12,"generators","","",198,N],[12,"trait_alias","","",198,N],[12,"allocator_internals","","",198,N],[12,"doc_cfg","","",198,N],[12,"doc_masked","","",198,N],[12,"doc_spotlight","","",198,N],[12,"external_doc","","",198,N],[12,"non_exhaustive","","",198,N],[12,"crate_visibility_modifier","","",198,N],[12,"extern_types","","",198,N],[12,"arbitrary_self_types","","",198,N],[12,"crate_in_paths","","",198,N],[12,"in_band_lifetimes","","",198,N],[12,"generic_associated_types","","",198,N],[12,"extern_absolute_paths","","",198,N],[12,"non_modrs_mods","","",198,N],[12,"extern_in_paths","","",198,N],[12,"macro_at_most_once_rep","","",198,N],[12,"infer_outlives_requirements","","",198,N],[12,"infer_static_outlives_requirements","","",198,N],[12,"if_while_or_patterns","","",198,N],[12,"pattern_parentheses","","",198,N],[12,"repr_packed","","",198,N],[12,"underscore_imports","","",198,N],[12,"raw_identifiers","","",198,N],[12,"macros_in_extern","","",198,N],[12,"existential_type","","",198,N],[12,"arm_target_feature","","",198,N],[12,"aarch64_target_feature","","",198,N],[12,"hexagon_target_feature","","",198,N],[12,"powerpc_target_feature","","",198,N],[12,"mips_target_feature","","",198,N],[12,"avx512_target_feature","","",198,N],[12,"mmx_target_feature","","",198,N],[12,"sse4a_target_feature","","",198,N],[12,"tbm_target_feature","","",198,N],[12,"proc_macro_path_invoc","","",198,N],[12,"proc_macro_mod","","",198,N],[12,"proc_macro_expr","","",198,N],[12,"proc_macro_non_items","","",198,N],[12,"proc_macro_gen","","",198,N],[12,"doc_alias","","",198,N],[12,"extern_prelude","","",198,N],[12,"tool_attributes","","",198,N],[12,"tool_lints","","",198,N],[12,"irrefutable_let_patterns","","",198,N],[12,"macro_literal_matcher","","",198,N],[12,"trivial_bounds","","",198,N],[12,"label_break_value","","",198,N],[12,"panic_implementation","","",198,N],[12,"doc_keyword","","",198,N],[12,"async_await","","",198,N],[12,"alloc_error_handler","","",198,N],[12,"abi_amdgpu_kernel","","",198,N],[3,"GatedCfg","","",N,N],[12,"span","","",199,N],[12,"index","","",199,N],[3,"Context","","",N,N],[12,"features","","",200,N],[12,"parse_sess","","",200,N],[12,"plugin_attributes","","",200,N],[3,"PostExpansionVisitor","","",N,N],[12,"context","","",201,N],[3,"FeatureChecker","","A collector for mutually exclusive and interdependent features and their flag spans.",N,N],[12,"use_extern_macros","","",202,N],[12,"custom_attribute","","",202,N],[4,"AttributeType","","",N,N],[13,"Normal","","Normal, builtin attribute that is consumed by the compiler before the unused_attribute check",203,N],[13,"Whitelisted","","Builtin attribute that may not be consumed by the compiler before the unused_attribute check. These attributes will be ignored by the unused_attribute lint",203,N],[13,"CrateLevel","","Builtin attribute that is only allowed at the crate level",203,N],[4,"AttributeGate","","",N,N],[13,"Gated","","Is gated by a given feature gate, reason and function to check if enabled",204,N],[13,"Ungated","","Ungated attribute, can be used on all release channels",204,N],[4,"Stability","","",N,N],[13,"Unstable","","",205,N],[13,"Deprecated","","",205,N],[4,"GateIssue","","",N,N],[13,"Language","","",206,N],[13,"Library","","",206,N],[4,"GateStrength","","",N,N],[13,"Hard","","A hard error. (Most feature gates should use this.)",207,N],[13,"Soft","","Only a warning. (Use this only as backwards-compatibility demands.)",207,N],[4,"UnstableFeatures","","",N,N],[13,"Disallow","","Hard errors for unstable features are active, as on beta/stable channels.",208,N],[13,"Allow","","Allow features to be activated, as on nightly.",208,N],[13,"Cheat","","Errors are bypassed for bootstrapping. This is required any time during the build that feature-related lints are set to warn or above because the build turns on warnings-as-errors and uses lots of unstable features. As a result, this is always required for building Rust itself.",208,N],[5,"deprecated_attributes","","",N,[[],["vec"]]],[5,"is_builtin_attr","","",N,[[["attribute"]],["bool"]]],[5,"check_attribute","","",N,[[["attribute"],["parsesess"],["features"]]]],[5,"find_lang_feature_accepted_version","","",N,[[["str"]],["option",["str"]]]],[5,"find_lang_feature_issue","","",N,[[["str"]],["option",["u32"]]]],[5,"emit_feature_err","","",N,[[["parsesess"],["str"],["span"],["gateissue"],["str"]]]],[5,"feature_err","","",N,[[["parsesess"],["str"],["span"],["gateissue"],["str"]],["diagnosticbuilder"]]],[5,"leveled_feature_err","","",N,[[["parsesess"],["str"],["span"],["gateissue"],["str"],["gatestrength"]],["diagnosticbuilder"]]],[5,"contains_novel_literal","","",N,[[["metaitem"]],["bool"]]],[5,"get_features","","",N,N],[5,"check_crate","","",N,N],[5,"maybe_stage_features","","",N,[[["handler"],["crate"],["unstablefeatures"]]]],[17,"ACTIVE_FEATURES","","Represents active features that are currently being implemented or currently being considered for addition/removal.",N,N],[17,"REMOVED_FEATURES","","Represents unstable features which have since been removed (it was once Active)",N,N],[17,"STABLE_REMOVED_FEATURES","","Represents stable features which have since been removed (it was once Accepted)",N,N],[17,"ACCEPTED_FEATURES","","Those language feature has since been Accepted (it was once Active)",N,N],[17,"BUILTIN_ATTRIBUTES","","",N,N],[17,"GATED_CFGS","","",N,N],[17,"EXPLAIN_BOX_SYNTAX","","",N,N],[17,"EXPLAIN_STMT_ATTR_SYNTAX","","",N,N],[17,"EXPLAIN_ASM","","",N,N],[17,"EXPLAIN_GLOBAL_ASM","","",N,N],[17,"EXPLAIN_LOG_SYNTAX","","",N,N],[17,"EXPLAIN_CONCAT_IDENTS","","",N,N],[17,"EXPLAIN_FORMAT_ARGS_NL","","",N,N],[17,"EXPLAIN_TRACE_MACROS","","",N,N],[17,"EXPLAIN_ALLOW_INTERNAL_UNSTABLE","","",N,N],[17,"EXPLAIN_ALLOW_INTERNAL_UNSAFE","","",N,N],[17,"EXPLAIN_CUSTOM_DERIVE","","",N,N],[17,"EXPLAIN_DEPR_CUSTOM_DERIVE","","",N,N],[17,"EXPLAIN_DERIVE_UNDERSCORE","","",N,N],[17,"EXPLAIN_VIS_MATCHER","","",N,N],[17,"EXPLAIN_LITERAL_MATCHER","","",N,N],[17,"EXPLAIN_UNSIZED_TUPLE_COERCION","","",N,N],[17,"EXPLAIN_MACRO_AT_MOST_ONCE_REP","","",N,N],[17,"EXPLAIN_MACROS_IN_EXTERN","","",N,N],[17,"EXPLAIN_PROC_MACROS_IN_EXTERN","","",N,N],[11,"clone","","",198,[[["self"]],["features"]]],[11,"new","","",198,[[],["features"]]],[11,"walk_feature_fields","","",198,[[["self"],["f"]]]],[11,"clone","","",203,[[["self"]],["attributetype"]]],[11,"eq","","",203,[[["self"],["attributetype"]],["bool"]]],[11,"fmt","","",203,[[["self"],["formatter"]],["result"]]],[11,"is_deprecated","","",204,[[["self"]],["bool"]]],[11,"clone","","",205,[[["self"]],["stability"]]],[11,"fmt","","",205,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",204,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",199,[[["self"],["formatter"]],["result"]]],[11,"gate","","",199,[[["metaitem"]],["option",["gatedcfg"]]]],[11,"check_and_emit","","",199,[[["self"],["parsesess"],["features"]]]],[11,"check_attribute","","",200,[[["self"],["attribute"],["bool"]]]],[11,"fmt","","",207,[[["self"],["formatter"]],["result"]]],[11,"clone","","",207,[[["self"]],["gatestrength"]]],[11,"eq","","",207,[[["self"],["gatestrength"]],["bool"]]],[11,"check_abi","","",201,[[["self"],["abi"],["span"]]]],[11,"whole_crate_feature_gates","","",201,[[["self"],["crate"]]]],[11,"visit_attribute","","",201,[[["self"],["attribute"]]]],[11,"visit_name","","",201,[[["self"],["span"],["name"]]]],[11,"visit_use_tree","","",201,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_item","","",201,[[["self"],["item"]]]],[11,"visit_foreign_item","","",201,[[["self"],["foreignitem"]]]],[11,"visit_ty","","",201,[[["self"],["ty"]]]],[11,"visit_fn_ret_ty","","",201,[[["self"],["functionretty"]]]],[11,"visit_expr","","",201,[[["self"],["expr"]]]],[11,"visit_arm","","",201,[[["self"],["arm"]]]],[11,"visit_pat","","",201,[[["self"],["pat"]]]],[11,"visit_fn","","",201,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",201,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",201,[[["self"],["implitem"]]]],[11,"visit_path","","",201,[[["self"],["path"],["nodeid"]]]],[11,"visit_vis","","",201,[[["self"],["visibility"]]]],[11,"default","","",202,[[],["featurechecker"]]],[11,"collect","","",202,[[["self"],["features"],["span"]]]],[11,"check","","",202,[[["self"],["handler"]]]],[11,"clone","","",208,[[["self"]],["unstablefeatures"]]],[11,"hash","","",208,N],[11,"from_environment","","",208,[[],["unstablefeatures"]]],[11,"is_nightly_build","","",208,[[["self"]],["bool"]]],[0,"fold","syntax","A Folder represents an AST->AST fold; it accepts an AST piece, and returns a piece of the same type. So, for instance, macro expansion is a Folder that walks over an AST and produces another AST.",N,N],[5,"noop_fold_meta_items","syntax::fold","",N,[[["vec",["metaitem"]],["t"]],["vec",["metaitem"]]]],[5,"noop_fold_use_tree","","",N,[[["usetree"],["t"]],["usetree"]]],[5,"fold_attrs","","",N,[[["vec",["attribute"]],["t"]],["vec",["attribute"]]]],[5,"fold_thin_attrs","","",N,[[["thinvec",["attribute"]],["t"]],["thinvec",["attribute"]]]],[5,"noop_fold_arm","","",N,[[["arm"],["t"]],["arm"]]],[5,"noop_fold_ty_binding","","",N,[[["typebinding"],["t"]],["typebinding"]]],[5,"noop_fold_ty","","",N,[[["p",["ty"]],["t"]],["p",["ty"]]]],[5,"noop_fold_foreign_mod","","",N,[[["foreignmod"],["t"]],["foreignmod"]]],[5,"noop_fold_global_asm","","",N,[[["p",["globalasm"]],["t"]],["p",["globalasm"]]]],[5,"noop_fold_variant","","",N,[[["variant"],["t"]],["variant"]]],[5,"noop_fold_ident","","",N,[[["ident"],["t"]],["ident"]]],[5,"noop_fold_usize","","",N,[[["usize"],["t"]],["usize"]]],[5,"noop_fold_path","","",N,[[["path"],["t"]],["path"]]],[5,"noop_fold_qpath","","",N,N],[5,"noop_fold_generic_args","","",N,[[["genericargs"],["t"]],["genericargs"]]],[5,"noop_fold_angle_bracketed_parameter_data","","",N,[[["anglebracketedargs"],["t"]],["anglebracketedargs"]]],[5,"noop_fold_parenthesized_parameter_data","","",N,[[["parenthesisedargs"],["t"]],["parenthesisedargs"]]],[5,"noop_fold_local","","",N,[[["p",["local"]],["t"]],["p",["local"]]]],[5,"noop_fold_attribute","","",N,[[["attribute"],["t"]],["option",["attribute"]]]],[5,"noop_fold_mac","","",N,[[["mac"],["t"]],["mac"]]],[5,"noop_fold_macro_def","","",N,[[["macrodef"],["t"]],["macrodef"]]],[5,"noop_fold_meta_list_item","","",N,[[["nestedmetaitem"],["t"]],["nestedmetaitem"]]],[5,"noop_fold_meta_item","","",N,[[["metaitem"],["t"]],["metaitem"]]],[5,"noop_fold_arg","","",N,[[["arg"],["t"]],["arg"]]],[5,"noop_fold_tt","","",N,[[["tokentree"],["t"]],["tokentree"]]],[5,"noop_fold_tts","","",N,[[["tokenstream"],["t"]],["tokenstream"]]],[5,"noop_fold_token","","",N,[[["token"],["t"]],["token"]]],[5,"noop_fold_interpolated","","apply folder to elements of interpolated nodes",N,[[["nonterminal"],["t"]],["nonterminal"]]],[5,"noop_fold_asyncness","","",N,[[["isasync"],["t"]],["isasync"]]],[5,"noop_fold_fn_decl","","",N,[[["p",["fndecl"]],["t"]],["p",["fndecl"]]]],[5,"noop_fold_param_bound","","",N,[[["genericbound"],["t"]],["genericbound"]]],[5,"noop_fold_generic_param","","",N,[[["genericparam"],["t"]],["genericparam"]]],[5,"noop_fold_generic_params","","",N,[[["vec",["genericparam"]],["t"]],["vec",["genericparam"]]]],[5,"noop_fold_label","","",N,[[["label"],["t"]],["label"]]],[5,"noop_fold_lifetime","","",N,[[["lifetime"],["t"]],["lifetime"]]],[5,"noop_fold_generics","","",N,[[["generics"],["t"]],["generics"]]],[5,"noop_fold_where_clause","","",N,[[["whereclause"],["t"]],["whereclause"]]],[5,"noop_fold_where_predicate","","",N,[[["wherepredicate"],["t"]],["wherepredicate"]]],[5,"noop_fold_variant_data","","",N,[[["variantdata"],["t"]],["variantdata"]]],[5,"noop_fold_trait_ref","","",N,[[["traitref"],["t"]],["traitref"]]],[5,"noop_fold_poly_trait_ref","","",N,[[["polytraitref"],["t"]],["polytraitref"]]],[5,"noop_fold_struct_field","","",N,[[["structfield"],["t"]],["structfield"]]],[5,"noop_fold_field","","",N,[[["field"],["t"]],["field"]]],[5,"noop_fold_mt","","",N,[[["mutty"],["t"]],["mutty"]]],[5,"noop_fold_opt_bounds","","",N,[[["option",["genericbounds"]],["t"]],["option",["genericbounds"]]]],[5,"noop_fold_bounds","","",N,[[["genericbounds"],["t"]],["genericbounds"]]],[5,"noop_fold_block","","",N,[[["p",["block"]],["t"]],["p",["block"]]]],[5,"noop_fold_item_kind","","",N,[[["itemkind"],["t"]],["itemkind"]]],[5,"noop_fold_trait_item","","",N,[[["traititem"],["t"]],["smallvector",["traititem"]]]],[5,"noop_fold_impl_item","","",N,[[["implitem"],["t"]],["smallvector",["implitem"]]]],[5,"noop_fold_fn_header","","",N,[[["fnheader"],["t"]],["fnheader"]]],[5,"noop_fold_mod","","",N,[[["mod"],["t"]],["mod"]]],[5,"noop_fold_crate","","",N,[[["crate"],["t"]],["crate"]]],[5,"noop_fold_item","","",N,[[["p",["item"]],["t"]],["smallvector",["p"]]]],[5,"noop_fold_item_simple","","",N,[[["item"],["t"]],["item"]]],[5,"noop_fold_foreign_item","","",N,[[["foreignitem"],["t"]],["smallvector",["foreignitem"]]]],[5,"noop_fold_foreign_item_simple","","",N,[[["foreignitem"],["t"]],["foreignitem"]]],[5,"noop_fold_method_sig","","",N,[[["methodsig"],["t"]],["methodsig"]]],[5,"noop_fold_pat","","",N,[[["p",["pat"]],["t"]],["p",["pat"]]]],[5,"noop_fold_range_end","","",N,[[["rangeend"],["t"]],["rangeend"]]],[5,"noop_fold_anon_const","","",N,[[["anonconst"],["t"]],["anonconst"]]],[5,"noop_fold_expr","","",N,[[["expr"],["t"]],["expr"]]],[5,"noop_fold_opt_expr","","",N,[[["p",["expr"]],["t"]],["option",["p"]]]],[5,"noop_fold_exprs","","",N,[[["vec",["p"]],["t"]],["vec",["p"]]]],[5,"noop_fold_stmt","","",N,[[["stmt"],["t"]],["smallvector",["stmt"]]]],[5,"noop_fold_stmt_kind","","",N,[[["stmtkind"],["t"]],["smallvector",["stmtkind"]]]],[5,"noop_fold_vis","","",N,[[["visibility"],["t"]],["visibility"]]],[8,"Folder","","",N,N],[11,"fold_crate","","",209,[[["self"],["crate"]],["crate"]]],[11,"fold_meta_items","","",209,[[["self"],["vec",["metaitem"]]],["vec",["metaitem"]]]],[11,"fold_meta_list_item","","",209,[[["self"],["nestedmetaitem"]],["nestedmetaitem"]]],[11,"fold_meta_item","","",209,[[["self"],["metaitem"]],["metaitem"]]],[11,"fold_use_tree","","",209,[[["self"],["usetree"]],["usetree"]]],[11,"fold_foreign_item","","",209,[[["self"],["foreignitem"]],["smallvector",["foreignitem"]]]],[11,"fold_foreign_item_simple","","",209,[[["self"],["foreignitem"]],["foreignitem"]]],[11,"fold_item","","",209,[[["self"],["p",["item"]]],["smallvector",["p"]]]],[11,"fold_item_simple","","",209,[[["self"],["item"]],["item"]]],[11,"fold_fn_header","","",209,[[["self"],["fnheader"]],["fnheader"]]],[11,"fold_struct_field","","",209,[[["self"],["structfield"]],["structfield"]]],[11,"fold_item_kind","","",209,[[["self"],["itemkind"]],["itemkind"]]],[11,"fold_trait_item","","",209,[[["self"],["traititem"]],["smallvector",["traititem"]]]],[11,"fold_impl_item","","",209,[[["self"],["implitem"]],["smallvector",["implitem"]]]],[11,"fold_fn_decl","","",209,[[["self"],["p",["fndecl"]]],["p",["fndecl"]]]],[11,"fold_asyncness","","",209,[[["self"],["isasync"]],["isasync"]]],[11,"fold_block","","",209,[[["self"],["p",["block"]]],["p",["block"]]]],[11,"fold_stmt","","",209,[[["self"],["stmt"]],["smallvector",["stmt"]]]],[11,"fold_arm","","",209,[[["self"],["arm"]],["arm"]]],[11,"fold_pat","","",209,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"fold_anon_const","","",209,[[["self"],["anonconst"]],["anonconst"]]],[11,"fold_expr","","",209,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_range_end","","",209,[[["self"],["rangeend"]],["rangeend"]]],[11,"fold_opt_expr","","",209,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_exprs","","",209,[[["self"],["vec",["p"]]],["vec",["p"]]]],[11,"fold_generic_arg","","",209,[[["self"],["genericarg"]],["genericarg"]]],[11,"fold_ty","","",209,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"fold_lifetime","","",209,[[["self"],["lifetime"]],["lifetime"]]],[11,"fold_ty_binding","","",209,[[["self"],["typebinding"]],["typebinding"]]],[11,"fold_mod","","",209,[[["self"],["mod"]],["mod"]]],[11,"fold_foreign_mod","","",209,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"fold_global_asm","","",209,[[["self"],["p",["globalasm"]]],["p",["globalasm"]]]],[11,"fold_variant","","",209,[[["self"],["variant"]],["variant"]]],[11,"fold_ident","","",209,[[["self"],["ident"]],["ident"]]],[11,"fold_usize","","",209,[[["self"],["usize"]],["usize"]]],[11,"fold_path","","",209,[[["self"],["path"]],["path"]]],[11,"fold_qpath","","",209,N],[11,"fold_generic_args","","",209,[[["self"],["genericargs"]],["genericargs"]]],[11,"fold_angle_bracketed_parameter_data","","",209,[[["self"],["anglebracketedargs"]],["anglebracketedargs"]]],[11,"fold_parenthesized_parameter_data","","",209,[[["self"],["parenthesisedargs"]],["parenthesisedargs"]]],[11,"fold_local","","",209,[[["self"],["p",["local"]]],["p",["local"]]]],[11,"fold_mac","","",209,[[["self"],["mac"]],["mac"]]],[11,"fold_macro_def","","",209,[[["self"],["macrodef"]],["macrodef"]]],[11,"fold_label","","",209,[[["self"],["label"]],["label"]]],[11,"fold_attribute","","",209,[[["self"],["attribute"]],["option",["attribute"]]]],[11,"fold_arg","","",209,[[["self"],["arg"]],["arg"]]],[11,"fold_generics","","",209,[[["self"],["generics"]],["generics"]]],[11,"fold_trait_ref","","",209,[[["self"],["traitref"]],["traitref"]]],[11,"fold_poly_trait_ref","","",209,[[["self"],["polytraitref"]],["polytraitref"]]],[11,"fold_variant_data","","",209,[[["self"],["variantdata"]],["variantdata"]]],[11,"fold_generic_param","","",209,[[["self"],["genericparam"]],["genericparam"]]],[11,"fold_generic_params","","",209,[[["self"],["vec",["genericparam"]]],["vec",["genericparam"]]]],[11,"fold_tt","","",209,[[["self"],["tokentree"]],["tokentree"]]],[11,"fold_tts","","",209,[[["self"],["tokenstream"]],["tokenstream"]]],[11,"fold_token","","",209,[[["self"],["token"]],["token"]]],[11,"fold_interpolated","","",209,[[["self"],["nonterminal"]],["nonterminal"]]],[11,"fold_opt_bounds","","",209,[[["self"],["option",["genericbounds"]]],["option",["genericbounds"]]]],[11,"fold_bounds","","",209,[[["self"],["genericbounds"]],["genericbounds"]]],[11,"fold_param_bound","","",209,[[["self"],["genericbound"]],["genericbound"]]],[11,"fold_mt","","",209,[[["self"],["mutty"]],["mutty"]]],[11,"fold_field","","",209,[[["self"],["field"]],["field"]]],[11,"fold_where_clause","","",209,[[["self"],["whereclause"]],["whereclause"]]],[11,"fold_where_predicate","","",209,[[["self"],["wherepredicate"]],["wherepredicate"]]],[11,"fold_vis","","",209,[[["self"],["visibility"]],["visibility"]]],[11,"new_id","","",209,[[["self"],["nodeid"]],["nodeid"]]],[11,"new_span","","",209,[[["self"],["span"]],["span"]]],[0,"parse","syntax","The main parser interface",N,N],[3,"ParseSess","syntax::parse","Info about a parsing session.",N,N],[12,"span_diagnostic","","",210,N],[12,"unstable_features","","",210,N],[12,"config","","",210,N],[12,"missing_fragment_specifiers","","",210,N],[12,"raw_identifier_spans","","Places where raw identifiers were used. This is used for feature gating raw identifiers",210,N],[12,"registered_diagnostics","","The registered diagnostics codes",210,N],[12,"non_modrs_mods","","",210,N],[12,"included_mod_stack","","Used to determine and report recursive mod inclusions",210,N],[12,"code_map","","",210,N],[12,"buffered_lints","","",210,N],[3,"Directory","","",N,N],[12,"path","","",211,N],[12,"ownership","","",211,N],[3,"SeqSep","","`SeqSep` : a sequence separator (token) and whether a trailing separator is allowed.",N,N],[12,"sep","","",212,N],[12,"trailing_sep_allowed","","",212,N],[4,"DirectoryOwnership","","",N,N],[13,"Owned","","",213,N],[12,"relative","syntax::parse::DirectoryOwnership","",213,N],[13,"UnownedViaBlock","syntax::parse","",213,N],[13,"UnownedViaMod","","",213,N],[5,"parse_crate_from_file","","",N,[[["path"],["parsesess"]],["presult",["crate"]]]],[5,"parse_crate_attrs_from_file","","",N,[[["path"],["parsesess"]],["presult",["vec"]]]],[5,"parse_crate_from_source_str","","",N,[[["filename"],["string"],["parsesess"]],["presult",["crate"]]]],[5,"parse_crate_attrs_from_source_str","","",N,[[["filename"],["string"],["parsesess"]],["presult",["vec"]]]],[5,"parse_expr_from_source_str","","",N,[[["filename"],["string"],["parsesess"]],["presult",["p"]]]],[5,"parse_item_from_source_str","","Parses an item.",N,[[["filename"],["string"],["parsesess"]],["presult",["option"]]]],[5,"parse_stmt_from_source_str","","",N,[[["filename"],["string"],["parsesess"]],["presult",["option"]]]],[5,"parse_stream_from_source_str","","",N,[[["filename"],["string"],["parsesess"],["option",["span"]]],["tokenstream"]]],[5,"new_parser_from_source_str","","",N,[[["parsesess"],["filename"],["string"]],["parser"]]],[5,"new_parser_from_file","","Create a new parser, handling errors as appropriate if the file doesn't exist",N,[[["parsesess"],["path"]],["parser"]]],[5,"new_sub_parser_from_file","","Given a session, a crate config, a path, and a span, add the file at the given path to the codemap, and return a parser. On an error, use the given span as the source of the problem.",N,[[["parsesess"],["path"],["directoryownership"],["option",["string"]],["span"]],["parser"]]],[5,"filemap_to_parser","","Given a filemap and config, return a parser",N,[[["parsesess"],["lrc",["filemap"]]],["parser"]]],[5,"new_parser_from_tts","","",N,[[["parsesess"],["vec",["tokentree"]]],["parser"]]],[5,"file_to_filemap","","Given a session and a path and an optional span (for error reporting), add the path to the session's codemap and return the new filemap.",N,[[["parsesess"],["path"],["option",["span"]]],["lrc",["filemap"]]]],[5,"filemap_to_stream","","Given a filemap, produce a sequence of token-trees",N,[[["parsesess"],["lrc",["filemap"]],["option",["span"]]],["tokenstream"]]],[5,"stream_to_parser","","Given stream and the `ParseSess`, produce a parser",N,[[["parsesess"],["tokenstream"]],["parser"]]],[5,"char_lit","","Parse a string representing a character literal into its final form. Rather than just accepting/rejecting a given literal, unescapes it as well. Can take any slice prefixed by a character escape. Returns the character and the number of characters consumed.",N,N],[5,"str_lit","","Parse a string representing a string literal into its final form. Does unescaping.",N,[[["str"],["option"]],["string"]]],[5,"raw_str_lit","","Parse a string representing a raw string literal into its final form. The only operation this does is convert embedded CRLF into a single LF.",N,[[["str"]],["string"]]],[5,"looks_like_width_suffix","","",N,N],[5,"lit_token","","",N,N],[5,"filtered_float_lit","","",N,[[["symbol"],["option",["symbol"]],["option"]],["option",["litkind"]]]],[5,"float_lit","","",N,[[["str"],["option",["symbol"]],["option"]],["option",["litkind"]]]],[5,"byte_lit","","Parse a string representing a byte literal into its final form. Similar to `char_lit`",N,N],[5,"byte_str_lit","","",N,[[["str"]],["lrc",["vec"]]]],[5,"integer_lit","","",N,[[["str"],["option",["symbol"]],["option"]],["option",["litkind"]]]],[0,"parser","","",N,N],[3,"Restrictions","syntax::parse::parser","",N,N],[12,"bits","","",214,N],[3,"Parser","","",N,N],[12,"sess","","",215,N],[12,"token","","the current token:",215,N],[12,"span","","the span of the current token:",215,N],[12,"meta_var_span","","the span of the previous token:",215,N],[12,"prev_span","","",215,N],[12,"prev_token_kind","","the previous token kind",215,N],[12,"restrictions","","",215,N],[12,"directory","","Used to determine the path to externally loaded source files",215,N],[12,"recurse_into_file_modules","","Whether to parse sub-modules in other files.",215,N],[12,"root_module_name","","Name of the root module this parser originated from. If `None`, then the name is not known. This does not change while the parser is descending into modules, and sub-parsers have new values for this name.",215,N],[12,"expected_tokens","","",215,N],[12,"token_cursor","","",215,N],[12,"desugar_doc_comments","","",215,N],[12,"cfg_mods","","Whether we should configure out of line modules as we parse.",215,N],[3,"TokenCursor","","",N,N],[12,"frame","","",216,N],[12,"stack","","",216,N],[3,"TokenCursorFrame","","",N,N],[12,"delim","","",217,N],[12,"span","","",217,N],[12,"open_delim","","",217,N],[12,"tree_cursor","","",217,N],[12,"close_delim","","",217,N],[12,"last_token","","",217,N],[3,"ModulePath","","Information about the path to a module.",N,N],[12,"name","","",218,N],[12,"path_exists","","",218,N],[12,"result","","",218,N],[3,"ModulePathSuccess","","",N,N],[12,"path","","",219,N],[12,"directory_ownership","","",219,N],[12,"warn","","",219,N],[4,"AliasKind","","Whether the type alias or associated type is a concrete type or an existential type",N,N],[13,"Weak","","Just a new name for the same type",220,N],[13,"Existential","","Only trait impls of the type will be usable, not the actual type itself",220,N],[4,"PathStyle","","How to parse a path.",N,N],[13,"Expr","","In some contexts, notably in expressions, paths with generic arguments are ambiguous with something else. For example, in expressions `segment < ....` can be interpreted as a comparison and `segment ( ....` can be interpreted as a function call. In all such contexts the non-path interpretation is preferred by default for practical reasons, but the path interpretation can be forced by the disambiguator `::`, e.g. `x<y>` - comparisons, `x::<y>` - unambiguously a path.",221,N],[13,"Type","","In other contexts, notably in types, no ambiguity exists and paths can be written without the disambiguator, e.g. `x<y>` - unambiguously a path. Paths with disambiguators are still accepted, `x::<Y>` - unambiguously a path too.",221,N],[13,"Mod","","A path with generic arguments disallowed, e.g. `foo::bar::Baz`, used in imports, visibilities or attributes. Technically, this variant is unnecessary and e.g. `Expr` can be used instead (paths in \"mod\" contexts have to be checked later for absence of generic arguments anyway, due to macros), but it is used to avoid weird suggestions about expected tokens when something goes wrong.",221,N],[4,"SemiColonMode","","",N,N],[13,"Break","","",222,N],[13,"Ignore","","",222,N],[4,"BlockMode","","",N,N],[13,"Break","","",223,N],[13,"Ignore","","",223,N],[4,"PrevTokenKind","","",N,N],[13,"DocComment","","",224,N],[13,"Comma","","",224,N],[13,"Plus","","",224,N],[13,"Interpolated","","",224,N],[13,"Eof","","",224,N],[13,"Ident","","",224,N],[13,"Other","","",224,N],[4,"LastToken","","This is used in `TokenCursorFrame` above to track tokens that are consumed by the parser, and then that's transitively used to record the tokens that each parse AST item is created with.",N,N],[13,"Collecting","","",225,N],[13,"Was","","",225,N],[4,"TokenType","","",N,N],[13,"Token","","",226,N],[13,"Keyword","","",226,N],[13,"Operator","","",226,N],[13,"Lifetime","","",226,N],[13,"Ident","","",226,N],[13,"Path","","",226,N],[13,"Type","","",226,N],[4,"Error","","",N,N],[13,"FileNotFoundForModule","","",227,N],[12,"mod_name","syntax::parse::parser::Error","",227,N],[12,"default_path","","",227,N],[12,"secondary_path","","",227,N],[12,"dir_path","","",227,N],[13,"DuplicatePaths","syntax::parse::parser","",227,N],[12,"mod_name","syntax::parse::parser::Error","",227,N],[12,"default_path","","",227,N],[12,"secondary_path","","",227,N],[13,"UselessDocComment","syntax::parse::parser","",227,N],[13,"InclusiveRangeWithNoEnd","","",227,N],[4,"LhsExpr","","",N,N],[13,"NotYetParsed","","",228,N],[13,"AttributesParsed","","",228,N],[13,"AlreadyParsed","","",228,N],[4,"TokenExpectType","","",N,N],[13,"Expect","","",229,N],[13,"NoExpect","","",229,N],[5,"maybe_append","","",N,[[["vec",["attribute"]],["option",["vec"]]],["vec",["attribute"]]]],[5,"can_continue_type_after_non_fn_ident","","Returns true if `IDENT t` can start a type - `IDENT::a::b`, `IDENT<u8, u8>`, `IDENT<<u8 as Trait>::AssocTy>`.",N,[[["token"]],["bool"]]],[5,"dummy_arg","","Create a placeholder argument.",N,[[["span"]],["arg"]]],[6,"ItemInfo","","",N,N],[8,"RecoverQPath","","",N,N],[18,"PATH_STYLE","","",230,N],[10,"to_ty","","",230,[[["self"]],["option",["p"]]]],[10,"to_recovered","","",230,[[["self"],["option",["qself"]],["path"]],["self"]]],[10,"to_string","","",230,[[["self"]],["string"]]],[11,"fmt","","",220,[[["self"],["formatter"]],["result"]]],[11,"eq","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"ne","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",214,N],[11,"clone","","",214,[[["self"]],["restrictions"]]],[11,"partial_cmp","","",214,[[["self"],["restrictions"]],["option",["ordering"]]]],[11,"lt","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"le","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"gt","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"ge","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"cmp","","",214,[[["self"],["restrictions"]],["ordering"]]],[11,"hash","","",214,N],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[18,"STMT_EXPR","","",214,N],[18,"NO_STRUCT_LITERAL","","",214,N],[11,"empty","","Returns an empty set of flags.",214,[[],["restrictions"]]],[11,"all","","Returns the set containing all flags.",214,[[],["restrictions"]]],[11,"bits","","Returns the raw value of the flags currently stored.",214,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",214,[[["u8"]],["option",["restrictions"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",214,[[["u8"]],["restrictions"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",214,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",214,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",214,[[["self"],["restrictions"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",214,[[["self"],["restrictions"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",214,[[["self"],["restrictions"]]]],[11,"remove","","Removes the specified flags in-place.",214,[[["self"],["restrictions"]]]],[11,"toggle","","Toggles the specified flags in-place.",214,[[["self"],["restrictions"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",214,[[["self"],["restrictions"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",214,[[["self"],["restrictions"]],["restrictions"]]],[11,"bitor_assign","","Adds the set of flags.",214,[[["self"],["restrictions"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",214,[[["self"],["restrictions"]],["restrictions"]]],[11,"bitxor_assign","","Toggles the set of flags.",214,[[["self"],["restrictions"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",214,[[["self"],["restrictions"]],["restrictions"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",214,[[["self"],["restrictions"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",214,[[["self"],["restrictions"]],["restrictions"]]],[11,"sub_assign","","Disables all flags enabled in the set.",214,[[["self"],["restrictions"]]]],[11,"not","","Returns the complement of this set of flags.",214,[[["self"]],["restrictions"]]],[11,"extend","","",214,[[["self"],["t"]]]],[11,"from_iter","","",214,[[["t"]],["restrictions"]]],[11,"clone","","",221,[[["self"]],["pathstyle"]]],[11,"eq","","",221,[[["self"],["pathstyle"]],["bool"]]],[11,"clone","","",222,[[["self"]],["semicolonmode"]]],[11,"eq","","",222,[[["self"],["semicolonmode"]],["bool"]]],[11,"fmt","","",222,[[["self"],["formatter"]],["result"]]],[11,"clone","","",223,[[["self"]],["blockmode"]]],[11,"eq","","",223,[[["self"],["blockmode"]],["bool"]]],[11,"fmt","","",223,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",224,[[["self"],["formatter"]],["result"]]],[11,"clone","","",224,[[["self"]],["prevtokenkind"]]],[11,"eq","","",224,[[["self"],["prevtokenkind"]],["bool"]]],[11,"to_ty","syntax::ast","",77,[[["self"]],["option",["p"]]]],[11,"to_recovered","","",77,[[["self"],["option",["qself"]],["path"]],["self"]]],[11,"to_string","","",77,[[["self"]],["string"]]],[11,"to_ty","","",61,[[["self"]],["option",["p"]]]],[11,"to_recovered","","",61,[[["self"],["option",["qself"]],["path"]],["self"]]],[11,"to_string","","",61,[[["self"]],["string"]]],[11,"to_ty","","",68,[[["self"]],["option",["p"]]]],[11,"to_recovered","","",68,[[["self"],["option",["qself"]],["path"]],["self"]]],[11,"to_string","","",68,[[["self"]],["string"]]],[11,"clone","syntax::parse::parser","",215,[[["self"]],["parser"]]],[11,"clone","","",216,[[["self"]],["tokencursor"]]],[11,"clone","","",217,[[["self"]],["tokencursorframe"]]],[11,"clone","","",225,[[["self"]],["lasttoken"]]],[11,"new","","",217,[[["span"],["delimited"]],["self"]]],[11,"next","","",216,[[["self"]],["tokenandspan"]]],[11,"next_desugared","","",216,[[["self"]],["tokenandspan"]]],[11,"clone","","",226,[[["self"]],["tokentype"]]],[11,"eq","","",226,[[["self"],["tokentype"]],["bool"]]],[11,"ne","","",226,[[["self"],["tokentype"]],["bool"]]],[11,"to_string","","",226,[[["self"]],["string"]]],[11,"span_err","","",227,[[["self"],["s"],["handler"]],["diagnosticbuilder"]]],[11,"fmt","","",228,[[["self"],["formatter"]],["result"]]],[11,"from","","",228,[[["option",["thinvec"]]],["self"]]],[11,"from","","",228,[[["p",["expr"]]],["self"]]],[11,"clone","","",229,[[["self"]],["tokenexpecttype"]]],[11,"fmt","","",229,[[["self"],["formatter"]],["result"]]],[11,"new","","",215,[[["parsesess"],["tokenstream"],["option",["directory"]],["bool"],["bool"]],["self"]]],[11,"next_tok","","",215,[[["self"]],["tokenandspan"]]],[11,"this_token_to_string","","Convert the current token to a string using self's reader",215,[[["self"]],["string"]]],[11,"token_descr","","",215,[[["self"]],["option",["str"]]]],[11,"this_token_descr","","",215,[[["self"]],["string"]]],[11,"unexpected_last","","",215,[[["self"],["token"]],["presult"]]],[11,"unexpected","","",215,[[["self"]],["presult"]]],[11,"expect","","Expect and consume the token t. Signal an error if the next token is not t.",215,[[["self"],["token"]],["presult"]]],[11,"expect_one_of","","Expect next token to be edible or inedible token.  If edible, then consume it; if inedible, then return without consuming anything.  Signal a fatal error if next token is unexpected.",215,N],[11,"interpolated_or_expr_span","","returns the span of expr, if it was not interpolated or the span of the interpolated token",215,[[["self"],["presult",["p"]]],["presult"]]],[11,"expected_ident_found","","",215,[[["self"]],["diagnosticbuilder"]]],[11,"parse_ident","","",215,[[["self"]],["presult",["ident"]]]],[11,"parse_ident_common","","",215,[[["self"],["bool"]],["presult",["ident"]]]],[11,"check","","Check if the next token is `tok`, and return `true` if so.",215,[[["self"],["token"]],["bool"]]],[11,"eat","","Consume token 'tok' if it exists. Returns true if the given token was present, false otherwise.",215,[[["self"],["token"]],["bool"]]],[11,"check_keyword","","",215,[[["self"],["keyword"]],["bool"]]],[11,"eat_keyword","","If the next token is the given keyword, eat it and return true. Otherwise, return false.",215,[[["self"],["keyword"]],["bool"]]],[11,"eat_keyword_noexpect","","",215,[[["self"],["keyword"]],["bool"]]],[11,"expect_keyword","","If the given word is not a keyword, signal an error. If the next token is not the given word, signal an error. Otherwise, eat it.",215,[[["self"],["keyword"]],["presult"]]],[11,"check_ident","","",215,[[["self"]],["bool"]]],[11,"check_path","","",215,[[["self"]],["bool"]]],[11,"check_type","","",215,[[["self"]],["bool"]]],[11,"eat_plus","","Expect and consume a `+`. if `+=` is seen, replace it with a `=` and continue. If a `+` is not seen, return false.",215,[[["self"]],["bool"]]],[11,"check_plus","","Checks to see if the next token is either `+` or `+=`. Otherwise returns false.",215,[[["self"]],["bool"]]],[11,"expect_and","","Expect and consume an `&`. If `&&` is seen, replace it with a single `&` and continue. If an `&` is not seen, signal an error.",215,[[["self"]],["presult"]]],[11,"expect_or","","Expect and consume an `|`. If `||` is seen, replace it with a single `|` and continue. If an `|` is not seen, signal an error.",215,[[["self"]],["presult"]]],[11,"expect_no_suffix","","",215,[[["self"],["span"],["str"],["option",["name"]]]]],[11,"eat_lt","","Attempt to consume a `<`. If `<<` is seen, replace it with a single `<` and continue. If a `<` is not seen, return false.",215,[[["self"]],["bool"]]],[11,"expect_lt","","",215,[[["self"]],["presult"]]],[11,"expect_gt","","Expect and consume a GT. if a >> is seen, replace it with a single > and continue. If a GT is not seen, signal an error.",215,[[["self"]],["presult"]]],[11,"eat_to_tokens","","Eat and discard tokens until one of `kets` is encountered. Respects token trees, passes through any errors encountered. Used for error recovery.",215,N],[11,"parse_seq_to_end","","Parse a sequence, including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",215,[[["self"],["token"],["seqsep"],["f"]],["presult",["vec"]]]],[11,"parse_seq_to_before_end","","Parse a sequence, not including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",215,[[["self"],["token"],["seqsep"],["f"]],["presult",["vec"]]]],[11,"parse_seq_to_before_tokens","","",215,N],[11,"parse_unspanned_seq","","Parse a sequence, including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",215,[[["self"],["token"],["token"],["seqsep"],["f"]],["presult",["vec"]]]],[11,"bump","","Advance the parser by one token",215,[[["self"]]]],[11,"bump_with","","Advance the parser using provided token as a next one. Use this when consuming a part of a token. For example a single `<` from `<<`.",215,[[["self"],["token"],["span"]]]],[11,"look_ahead","","",215,[[["self"],["usize"],["f"]],["r"]]],[11,"look_ahead_span","","",215,[[["self"],["usize"]],["span"]]],[11,"fatal","","",215,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_fatal","","",215,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_fatal_err","","",215,[[["self"],["s"],["error"]],["diagnosticbuilder"]]],[11,"bug","","",215,N],[11,"span_err","","",215,[[["self"],["s"],["str"]]]],[11,"struct_span_err","","",215,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_bug","","",215,N],[11,"abort_if_errors","","",215,[[["self"]]]],[11,"cancel","","",215,[[["self"],["diagnosticbuilder"]]]],[11,"diagnostic","","",215,[[["self"]],["handler"]]],[11,"token_is_bare_fn_keyword","","Is the current token one of the keywords that signals a bare function type?",215,[[["self"]],["bool"]]],[11,"parse_ty_bare_fn","","parse a TyKind::BareFn type:",215,[[["self"],["vec",["genericparam"]]],["presult",["tykind"]]]],[11,"parse_asyncness","","Parse asyncness: `async` or nothing",215,[[["self"]],["isasync"]]],[11,"parse_unsafety","","Parse unsafety: `unsafe` or nothing.",215,[[["self"]],["unsafety"]]],[11,"parse_trait_item","","Parse the items in a trait declaration",215,[[["self"],["bool"]],["presult",["traititem"]]]],[11,"parse_trait_item_","","",215,[[["self"],["bool"],["vec",["attribute"]]],["presult",["traititem"]]]],[11,"parse_ret_ty","","Parse optional return type [ -> TY ] in function decl",215,[[["self"],["bool"]],["presult",["functionretty"]]]],[11,"parse_ty","","",215,[[["self"]],["presult",["p"]]]],[11,"parse_ty_no_plus","","Parse a type in restricted contexts where `+` is not permitted. Example 1: `&'a TYPE`     `+` is prohibited to maintain operator priority (P(+) < P(&)). Example 2: `value1 as TYPE + value2`     `+` is prohibited to avoid interactions with expression grammar.",215,[[["self"]],["presult",["p"]]]],[11,"parse_ty_common","","",215,[[["self"],["bool"],["bool"]],["presult",["p"]]]],[11,"parse_remaining_bounds","","",215,[[["self"],["vec",["genericparam"]],["path"],["span"],["bool"]],["presult",["tykind"]]]],[11,"maybe_report_ambiguous_plus","","",215,[[["self"],["bool"],["bool"],["ty"]]]],[11,"maybe_recover_from_bad_type_plus","","",215,[[["self"],["bool"],["ty"]],["presult"]]],[11,"maybe_recover_from_bad_qpath","","",215,[[["self"],["t"],["bool"]],["presult"]]],[11,"parse_borrowed_pointee","","",215,[[["self"]],["presult",["tykind"]]]],[11,"parse_ptr","","",215,[[["self"]],["presult",["mutty"]]]],[11,"is_named_argument","","",215,[[["self"]],["bool"]]],[11,"parse_arg_general","","This version of parse arg doesn't necessarily require identifier names.",215,[[["self"],["bool"]],["presult",["arg"]]]],[11,"parse_arg","","Parse a single function argument",215,[[["self"]],["presult",["arg"]]]],[11,"parse_fn_block_arg","","Parse an argument in a lambda header e.g. |arg, arg|",215,[[["self"]],["presult",["arg"]]]],[11,"maybe_parse_fixed_length_of_vec","","",215,[[["self"]],["presult",["option"]]]],[11,"parse_lit_token","","Matches token_lit = LIT_INTEGER | ...",215,[[["self"]],["presult",["litkind"]]]],[11,"parse_lit","","Matches lit = true | false | token_lit",215,[[["self"]],["presult",["lit"]]]],[11,"parse_literal_maybe_minus","","matches '-' lit | lit (cf. ast_validation::AstValidator::check_expr_within_pat)",215,[[["self"]],["presult",["p"]]]],[11,"parse_path_segment_ident","","",215,[[["self"]],["presult",["ident"]]]],[11,"parse_qpath","","Parses qualified path. Assumes that the leading `<` has been parsed already.",215,[[["self"],["pathstyle"]],["presult"]]],[11,"parse_path","","Parses simple paths.",215,[[["self"],["pathstyle"]],["presult",["path"]]]],[11,"parse_path_common","","",215,[[["self"],["pathstyle"],["bool"]],["presult",["path"]]]],[11,"parse_path_allowing_meta","","Like `parse_path`, but also supports parsing `Word` meta items into paths for back-compat. This is used when parsing derive macro paths in `#[derive]` attributes.",215,[[["self"],["pathstyle"]],["presult",["path"]]]],[11,"parse_path_segments","","",215,[[["self"],["vec"],["pathstyle"],["bool"]],["presult"]]],[11,"parse_path_segment","","",215,[[["self"],["pathstyle"],["bool"]],["presult",["pathsegment"]]]],[11,"check_lifetime","","",215,[[["self"]],["bool"]]],[11,"expect_lifetime","","Parse single lifetime 'a or panic.",215,[[["self"]],["lifetime"]]],[11,"eat_label","","",215,[[["self"]],["option",["label"]]]],[11,"parse_mutability","","Parse mutability (`mut` or nothing).",215,[[["self"]],["mutability"]]],[11,"parse_field_name","","",215,[[["self"]],["presult",["ident"]]]],[11,"parse_field","","Parse ident (COLON expr)?",215,[[["self"]],["presult",["field"]]]],[11,"mk_expr","","",215,[[["self"],["span"],["exprkind"],["thinvec",["attribute"]]],["p",["expr"]]]],[11,"mk_unary","","",215,[[["self"],["unop"],["p",["expr"]]],["exprkind"]]],[11,"mk_binary","","",215,[[["self"],["binop"],["p",["expr"]],["p",["expr"]]],["exprkind"]]],[11,"mk_call","","",215,[[["self"],["p",["expr"]],["vec",["p"]]],["exprkind"]]],[11,"mk_index","","",215,[[["self"],["p",["expr"]],["p",["expr"]]],["exprkind"]]],[11,"mk_range","","",215,[[["self"],["option",["p"]],["option",["p"]],["rangelimits"]],["presult",["exprkind"]]]],[11,"mk_assign_op","","",215,[[["self"],["binop"],["p",["expr"]],["p",["expr"]]],["exprkind"]]],[11,"mk_mac_expr","","",215,[[["self"],["span"],["mac_"],["thinvec",["attribute"]]],["p",["expr"]]]],[11,"expect_delimited_token_tree","","",215,[[["self"]],["presult"]]],[11,"parse_bottom_expr","","At the bottom (top?) of the precedence hierarchy, parse things like parenthesized exprs, macros, return, etc.",215,[[["self"]],["presult",["p"]]]],[11,"parse_struct_expr","","",215,[[["self"],["span"],["path"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_or_use_outer_attributes","","",215,[[["self"],["option",["thinvec"]]],["presult",["thinvec"]]]],[11,"parse_block_expr","","Parse a block or unsafe block",215,[[["self"],["option",["label"]],["span"],["blockcheckmode"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_dot_or_call_expr","","parse a.b or a(13) or a[4] or just a",215,[[["self"],["option",["thinvec"]]],["presult",["p"]]]],[11,"parse_dot_or_call_expr_with","","",215,[[["self"],["p",["expr"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_dot_suffix","","",215,[[["self"],["p",["expr"]],["span"]],["presult",["p"]]]],[11,"parse_dot_or_call_expr_with_","","",215,[[["self"],["p",["expr"]],["span"]],["presult",["p"]]]],[11,"process_potential_macro_variable","","",215,[[["self"]]]],[11,"parse_token_tree","","parse a single token tree from the input.",215,[[["self"]],["tokentree"]]],[11,"parse_all_token_trees","","",215,[[["self"]],["presult",["vec"]]]],[11,"parse_tokens","","",215,[[["self"]],["tokenstream"]]],[11,"parse_prefix_expr","","Parse a prefix-unary-operator expr",215,[[["self"],["option",["thinvec"]]],["presult",["p"]]]],[11,"parse_assoc_expr","","Parse an associative expression",215,[[["self"],["option",["thinvec"]]],["presult",["p"]]]],[11,"parse_assoc_expr_with","","Parse an associative expression with operators of at least `min_prec` precedence",215,[[["self"],["usize"],["lhsexpr"]],["presult",["p"]]]],[11,"parse_assoc_op_cast","","",215,N],[11,"check_no_chained_comparison","","Produce an error if comparison operators are chained (RFC #558). We only need to check lhs, not rhs, because all comparison ops have same precedence and are left-associative",215,[[["self"],["expr"],["assocop"]]]],[11,"parse_prefix_range_expr","","Parse prefix-forms of range notation: `..expr`, `..`, `..=expr`",215,[[["self"],["option",["thinvec"]]],["presult",["p"]]]],[11,"is_at_start_of_range_notation_rhs","","",215,[[["self"]],["bool"]]],[11,"parse_if_expr","","Parse an 'if' or 'if let' expression ('if' token already eaten)",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_if_let_expr","","Parse an 'if let' expression ('if' token already eaten)",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_lambda_expr","","",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_else_expr","","",215,[[["self"]],["presult",["p"]]]],[11,"parse_for_expr","","Parse a 'for' .. 'in' expression ('for' token already eaten)",215,[[["self"],["option",["label"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_while_expr","","Parse a 'while' or 'while let' expression ('while' token already eaten)",215,[[["self"],["option",["label"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_while_let_expr","","Parse a 'while let' expression ('while' token already eaten)",215,[[["self"],["option",["label"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_loop_expr","","",215,[[["self"],["option",["label"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_async_block","","Parse an `async move {...}` expression",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_catch_expr","","Parse a `do catch {...}` expression (`do catch` token already eaten)",215,[[["self"],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_match_expr","","",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_arm","","",215,[[["self"]],["presult",["arm"]]]],[11,"parse_expr","","Parse an expression",215,[[["self"]],["presult",["p"]]]],[11,"with_res","","Evaluate the closure with restrictions in place.",215,[[["self"],["restrictions"],["f"]],["t"]]],[11,"parse_expr_res","","Parse an expression, subject to the given restrictions",215,[[["self"],["restrictions"],["option",["thinvec"]]],["presult",["p"]]]],[11,"parse_initializer","","Parse the RHS of a local variable declaration (e.g. '= 14;')",215,[[["self"],["bool"]],["presult",["option"]]]],[11,"parse_pats","","Parse patterns, separated by '|' s",215,[[["self"]],["presult",["vec"]]]],[11,"parse_parenthesized_pat_list","","",215,[[["self"]],["presult"]]],[11,"parse_pat_list","","",215,[[["self"]],["presult"]]],[11,"parse_pat_vec_elements","","",215,[[["self"]],["presult"]]],[11,"parse_pat_field","","",215,[[["self"],["span"],["vec",["attribute"]]],["presult",["spanned"]]]],[11,"parse_pat_fields","","Parse the fields of a struct-like pattern",215,[[["self"]],["presult"]]],[11,"parse_pat_range_end","","",215,[[["self"]],["presult",["p"]]]],[11,"parse_as_ident","","",215,[[["self"]],["bool"]]],[11,"parse_top_level_pat","","A wrapper around `parse_pat` with some special error handling for the \"top-level\" patterns in a match arm, `for` loop, `let`, &c. (in contast to subpatterns within such).",215,[[["self"]],["presult",["p"]]]],[11,"parse_pat","","Parse a pattern.",215,[[["self"]],["presult",["p"]]]],[11,"parse_pat_with_range_pat","","Parse a pattern, with a setting whether modern range patterns e.g. `a..=b`, `a..b` are allowed.",215,[[["self"],["bool"]],["presult",["p"]]]],[11,"parse_pat_ident","","Parse ident or ident @ pat used by the copy foo and ref foo patterns to give a good error message when parsing mistakes like ref foo(a,b)",215,[[["self"],["bindingmode"]],["presult",["patkind"]]]],[11,"parse_local","","Parse a local variable declaration",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_name_and_ty","","Parse a structure field",215,[[["self"],["span"],["visibility"],["vec",["attribute"]]],["presult",["structfield"]]]],[11,"expected_item_err","","Emit an expected item after attributes error.",215,N],[11,"parse_stmt","","Parse a statement. This stops just before trailing semicolons on everything but items. e.g. a `StmtKind::Semi` parses to a `StmtKind::Expr`, leaving the trailing `;` unconsumed.",215,[[["self"]],["presult",["option"]]]],[11,"recover_stmt","","",215,[[["self"]]]],[11,"recover_stmt_","","",215,[[["self"],["semicolonmode"],["blockmode"]]]],[11,"parse_stmt_","","",215,[[["self"],["bool"]],["option",["stmt"]]]],[11,"is_async_block","","",215,[[["self"]],["bool"]]],[11,"is_catch_expr","","",215,[[["self"]],["bool"]]],[11,"is_union_item","","",215,[[["self"]],["bool"]]],[11,"is_crate_vis","","",215,[[["self"]],["bool"]]],[11,"is_extern_non_path","","",215,[[["self"]],["bool"]]],[11,"is_existential_type_decl","","",215,[[["self"]],["bool"]]],[11,"is_auto_trait_item","","",215,[[["self"]],["bool"]]],[11,"eat_macro_def","","",215,N],[11,"parse_stmt_without_recovery","","",215,[[["self"],["bool"]],["presult",["option"]]]],[11,"expr_is_complete","","Is this expression a successfully-parsed statement?",215,[[["self"],["expr"]],["bool"]]],[11,"parse_block","","Parse a block. No inner attrs are allowed.",215,[[["self"]],["presult",["p"]]]],[11,"parse_inner_attrs_and_block","","Parse a block. Inner attrs are allowed.",215,[[["self"]],["presult"]]],[11,"parse_block_tail","","Parse the rest of a block expression or function body Precondition: already parsed the '{'.",215,[[["self"],["span"],["blockcheckmode"]],["presult",["p"]]]],[11,"parse_full_stmt","","Parse a statement, including the trailing semicolon.",215,[[["self"],["bool"]],["presult",["option"]]]],[11,"warn_missing_semicolon","","",215,[[["self"]]]],[11,"err_dotdotdot_syntax","","",215,[[["self"],["span"]]]],[11,"parse_generic_bounds_common","","",215,[[["self"],["bool"]],["presult",["genericbounds"]]]],[11,"parse_generic_bounds","","",215,[[["self"]],["presult",["genericbounds"]]]],[11,"parse_lt_param_bounds","","",215,[[["self"]],["genericbounds"]]],[11,"parse_ty_param","","Matches typaram = IDENT (`?` unbound)? optbounds ( EQ ty )?",215,[[["self"],["vec",["attribute"]]],["presult",["genericparam"]]]],[11,"parse_trait_item_assoc_ty","","Parses the following grammar: TraitItemAssocTy = Ident [\"<\"...\">\"] [\":\" [GenericBounds]] [\"where\" ...] [\"=\" Ty]",215,[[["self"]],["presult"]]],[11,"parse_generic_params","","Parses (possibly empty) list of lifetime and type parameters, possibly including trailing comma and erroneous trailing attributes.",215,[[["self"]],["presult",["vec"]]]],[11,"parse_generics","","Parse a set of optional generic type parameter declarations. Where clauses are not parsed here, and must be added later via `parse_where_clause()`.",215,[[["self"]],["presult",["generics"]]]],[11,"parse_generic_args","","Parses (possibly empty) list of lifetime and type arguments and associated type bindings, possibly including trailing comma.",215,[[["self"]],["presult"]]],[11,"parse_where_clause","","Parses an optional `where` clause and places it in `generics`.",215,[[["self"]],["presult",["whereclause"]]]],[11,"parse_fn_args","","",215,[[["self"],["bool"],["bool"]],["presult"]]],[11,"parse_fn_decl","","Parse the argument list and result type of a function declaration",215,[[["self"],["bool"]],["presult",["p"]]]],[11,"parse_self_arg","","Returns the parsed optional self argument and whether a self shortcut was used.",215,[[["self"]],["presult",["option"]]]],[11,"parse_fn_decl_with_self","","Parse the parameter list and result type of a function that may have a `self` parameter.",215,[[["self"],["f"]],["presult",["p"]]]],[11,"parse_fn_block_decl","","",215,[[["self"]],["presult",["p"]]]],[11,"parse_fn_header","","Parse the name and optional generic types of a function header.",215,[[["self"]],["presult"]]],[11,"mk_item","","",215,[[["self"],["span"],["ident"],["itemkind"],["visibility"],["vec",["attribute"]]],["p",["item"]]]],[11,"parse_item_fn","","Parse an item-position function declaration.",215,[[["self"],["unsafety"],["isasync"],["spanned",["constness"]],["abi"]],["presult"]]],[11,"is_const_item","","true if we are looking at `const ID`, false for things like `const fn` etc",215,[[["self"]],["bool"]]],[11,"parse_fn_front_matter","","parses all the \"front matter\" for a `fn` declaration, up to and including the `fn` keyword:",215,[[["self"]],["presult"]]],[11,"parse_impl_item","","Parse an impl item.",215,[[["self"],["bool"]],["presult",["implitem"]]]],[11,"parse_impl_item_","","",215,[[["self"],["bool"],["vec",["attribute"]]],["presult",["implitem"]]]],[11,"complain_if_pub_macro","","",215,[[["self"],["visibilitykind"],["span"]]]],[11,"complain_if_pub_macro_diag","","",215,[[["self"],["visibilitykind"],["span"]],["presult"]]],[11,"missing_assoc_item_kind_err","","",215,[[["self"],["str"],["span"]],["diagnosticbuilder"]]],[11,"parse_impl_method","","Parse a method or a macro invocation in a trait impl.",215,[[["self"],["visibility"],["bool"]],["presult"]]],[11,"parse_item_trait","","Parse `trait Foo { ... }` or `trait Foo = Bar;`",215,[[["self"],["isauto"],["unsafety"]],["presult"]]],[11,"choose_generics_over_qpath","","",215,[[["self"]],["bool"]]],[11,"parse_impl_body","","",215,[[["self"]],["presult"]]],[11,"parse_item_impl","","Parses an implementation item, `impl` keyword is already parsed.    impl<'a, T> TYPE { /* impl items / }    impl<'a, T> TRAIT for TYPE { / impl items / }    impl<'a, T> !TRAIT for TYPE { / impl items */ } We actually parse slightly more relaxed grammar for better error reporting and recovery.     `impl` GENERICS `!`? TYPE `for`? (TYPE | `..`) (`where` PREDICATES)? `{` BODY `}`     `impl` GENERICS `!`? TYPE (`where` PREDICATES)? `{` BODY `}`",215,[[["self"],["unsafety"],["defaultness"]],["presult"]]],[11,"parse_late_bound_lifetime_defs","","",215,[[["self"]],["presult",["vec"]]]],[11,"parse_item_struct","","Parse struct Foo { ... }",215,[[["self"]],["presult"]]],[11,"parse_item_union","","Parse union Foo { ... }",215,[[["self"]],["presult"]]],[11,"consume_block","","",215,[[["self"],["delimtoken"]]]],[11,"parse_record_struct_body","","",215,[[["self"]],["presult",["vec"]]]],[11,"parse_tuple_struct_body","","",215,[[["self"]],["presult",["vec"]]]],[11,"parse_single_struct_field","","Parse a structure field declaration",215,[[["self"],["span"],["visibility"],["vec",["attribute"]]],["presult",["structfield"]]]],[11,"parse_struct_decl_field","","Parse an element of a struct definition",215,[[["self"]],["presult",["structfield"]]]],[11,"parse_visibility","","Parse `pub`, `pub(crate)` and `pub(in path)` plus shortcuts `pub(self)` for `pub(in self)` and `pub(super)` for `pub(in super)`.  If the following element can't be a tuple (i.e. it's a function definition, it's not a tuple struct field) and the contents within the parens isn't valid, emit a proper diagnostic.",215,[[["self"],["bool"]],["presult",["visibility"]]]],[11,"parse_defaultness","","Parse defaultness: `default` or nothing.",215,[[["self"]],["defaultness"]]],[11,"parse_mod_items","","Given a termination token, parse all of the items in a module",215,[[["self"],["token"],["span"]],["presult",["mod"]]]],[11,"parse_item_const","","",215,[[["self"],["option",["mutability"]]],["presult"]]],[11,"parse_item_mod","","Parse a `mod <foo> { ... }` or `mod <foo>;` item",215,N],[11,"push_directory","","",215,N],[11,"submod_path_from_attr","","",215,N],[11,"default_submod_path","","Returns either a path to a module, or .",215,[[["ident"],["option",["ident"]],["path"],["codemap"]],["modulepath"]]],[11,"submod_path","","",215,N],[11,"eval_src_mod","","Read a module from a source file.",215,[[["self"],["pathbuf"],["directoryownership"],["string"],["span"]],["presult"]]],[11,"parse_item_foreign_fn","","Parse a function declaration from a foreign module",215,[[["self"],["visibility"],["span"],["vec",["attribute"]]],["presult",["foreignitem"]]]],[11,"parse_item_foreign_static","","Parse a static item from a foreign module. Assumes that the `static` keyword is already parsed.",215,[[["self"],["visibility"],["span"],["vec",["attribute"]]],["presult",["foreignitem"]]]],[11,"parse_item_foreign_type","","Parse a type from a foreign module",215,[[["self"],["visibility"],["span"],["vec",["attribute"]]],["presult",["foreignitem"]]]],[11,"parse_crate_name_with_dashes","","",215,[[["self"]],["presult",["ident"]]]],[11,"parse_item_extern_crate","","Parse extern crate links",215,[[["self"],["span"],["visibility"],["vec",["attribute"]]],["presult",["p"]]]],[11,"parse_item_foreign_mod","","Parse `extern` for foreign ABIs modules.",215,[[["self"],["span"],["option",["abi"]],["visibility"],["vec",["attribute"]]],["presult",["p"]]]],[11,"eat_type","","Parse type Foo = Bar; or existential type Foo: Bar; or return None without modifying the parser state",215,[[["self"]],["option",["presult"]]]],[11,"parse_existential_or_alias","","Parse type alias or existential type",215,[[["self"],["bool"]],["presult"]]],[11,"parse_enum_def","","Parse the part of an \"enum\" decl following the '{'",215,[[["self"],["generics"]],["presult",["enumdef"]]]],[11,"parse_item_enum","","Parse an \"enum\" declaration",215,[[["self"]],["presult"]]],[11,"parse_opt_abi","","Parses a string as an ABI spec on an extern type or module. Consumes the `extern` keyword, if one is found.",215,[[["self"]],["presult",["option"]]]],[11,"is_static_global","","",215,[[["self"]],["bool"]]],[11,"parse_item_","","",215,[[["self"],["vec",["attribute"]],["bool"],["bool"]],["presult",["option"]]]],[11,"parse_item_implementation","","Parse one of the items allowed by the flags. NB: this function no longer parses the items inside an extern crate.",215,[[["self"],["vec",["attribute"]],["bool"],["bool"]],["presult",["option"]]]],[11,"parse_foreign_item","","Parse a foreign item.",215,[[["self"]],["presult",["option"]]]],[11,"parse_macro_use_or_failure","","This is the fall-through for parsing items.",215,[[["self"],["vec",["attribute"]],["bool"],["bool"],["span"],["visibility"]],["presult",["option"]]]],[11,"parse_assoc_macro_invoc","","Parse a macro invocation inside a `trait`, `impl` or `extern` block",215,[[["self"],["str"],["option",["visibility"]],["bool"]],["presult",["option"]]]],[11,"collect_tokens","","",215,[[["self"],["f"]],["presult"]]],[11,"parse_item","","",215,[[["self"]],["presult",["option"]]]],[11,"is_import_coupler","","`::{` or `::*`",215,[[["self"]],["bool"]]],[11,"parse_use_tree","","Parse UseTree",215,[[["self"]],["presult",["usetree"]]]],[11,"parse_use_tree_list","","Parse UseTreeKind::Nested(list)",215,[[["self"]],["presult",["vec"]]]],[11,"parse_rename","","",215,[[["self"]],["presult",["option"]]]],[11,"parse_crate_mod","","Parses a source module as a crate. This is the main entry point for the parser.",215,[[["self"]],["presult",["crate"]]]],[11,"parse_optional_str","","",215,[[["self"]],["option"]]],[11,"parse_str","","",215,[[["self"]],["presult"]]],[0,"lexer","syntax::parse","",N,N],[3,"TokenAndSpan","syntax::parse::lexer","",N,N],[12,"tok","","",231,N],[12,"sp","","",231,N],[3,"StringReader","","",N,N],[12,"sess","","",232,N],[12,"next_pos","","The absolute offset within the codemap of the next character to read",232,N],[12,"pos","","The absolute offset within the codemap of the current character",232,N],[12,"ch","","The current character (which has been read from self.pos)",232,N],[12,"filemap","","",232,N],[12,"end_src_index","","Stop reading src at this index.",232,N],[12,"peek_tok","","",232,N],[12,"peek_span","","",232,N],[12,"peek_span_src_raw","","",232,N],[12,"fatal_errs","","",232,N],[12,"src","","",232,N],[12,"token","","Stack of open delimiters and their spans. Used for error message.",232,N],[12,"span","","",232,N],[12,"span_src_raw","","The raw source span which does not take `override_span` into account",232,N],[12,"open_braces","","",232,N],[12,"override_span","","",232,N],[5,"is_pattern_whitespace","","",N,[[["option",["char"]]],["bool"]]],[5,"in_range","","",N,[[["option",["char"]],["char"],["char"]],["bool"]]],[5,"is_dec_digit","","",N,[[["option",["char"]]],["bool"]]],[5,"is_doc_comment","","",N,[[["str"]],["bool"]]],[5,"is_block_doc_comment","","",N,[[["str"]],["bool"]]],[5,"ident_start","","",N,[[["option",["char"]]],["bool"]]],[5,"ident_continue","","",N,[[["option",["char"]]],["bool"]]],[0,"comments","","",N,N],[3,"Comment","syntax::parse::lexer::comments","",N,N],[12,"style","","",233,N],[12,"lines","","",233,N],[12,"pos","","",233,N],[3,"Literal","","",N,N],[12,"lit","","",234,N],[12,"pos","","",234,N],[4,"CommentStyle","","",N,N],[13,"Isolated","","No code on either side of each line of the comment",235,N],[13,"Trailing","","Code exists to the left of the comment",235,N],[13,"Mixed","","Code before /* foo */ and after the comment",235,N],[13,"BlankLine","","Just a manual blank line \"\\n\\n\", for layout",235,N],[5,"is_doc_comment","","",N,[[["str"]],["bool"]]],[5,"doc_comment_style","","",N,[[["str"]],["attrstyle"]]],[5,"strip_doc_comment_decoration","","",N,[[["str"]],["string"]]],[5,"push_blank_line_comment","","",N,[[["stringreader"],["vec"]]]],[5,"consume_whitespace_counting_blank_lines","","",N,[[["stringreader"],["vec"]]]],[5,"read_shebang_comment","","",N,[[["stringreader"],["bool"],["vec"]]]],[5,"read_line_comments","","",N,[[["stringreader"],["bool"],["vec"]]]],[5,"all_whitespace","","Returns None if the first col chars of s contain a non-whitespace char. Otherwise returns Some(k) where k is first char offset after that leading whitespace.  Note k may be outside bounds of s.",N,[[["str"],["charpos"]],["option",["usize"]]]],[5,"trim_whitespace_prefix_and_push_line","","",N,[[["vec"],["string"],["charpos"]]]],[5,"read_block_comment","","",N,[[["stringreader"],["bool"],["vec"]]]],[5,"consume_comment","","",N,[[["stringreader"],["vec"],["bool"],["bool"]]]],[5,"gather_comments_and_literals","","",N,N],[11,"clone","","",235,[[["self"]],["commentstyle"]]],[11,"eq","","",235,[[["self"],["commentstyle"]],["bool"]]],[11,"fmt","","",235,[[["self"],["formatter"]],["result"]]],[11,"clone","","",233,[[["self"]],["comment"]]],[11,"clone","","",234,[[["self"]],["literal"]]],[0,"tokentrees","syntax::parse::lexer","",N,N],[11,"parse_all_token_trees","","",232,[[["self"]],["presult",["tokenstream"]]]],[11,"parse_token_trees_until_close_delim","","",232,[[["self"]],["tokenstream"]]],[11,"parse_token_tree","","",232,[[["self"]],["presult",["tokenstream"]]]],[0,"unicode_chars","","",N,N],[5,"check_for_substitution","syntax::parse::lexer::unicode_chars","",N,[[["stringreader"],["char"],["diagnosticbuilder"]],["bool"]]],[17,"UNICODE_ARRAY","","",N,N],[17,"ASCII_ARRAY","","",N,N],[11,"clone","syntax::parse::lexer","",231,[[["self"]],["tokenandspan"]]],[11,"fmt","","",231,[[["self"],["formatter"]],["result"]]],[11,"default","","",231,[[],["self"]]],[11,"mk_sp","","",232,[[["self"],["bytepos"],["bytepos"]],["span"]]],[11,"mk_sp_and_raw","","",232,N],[11,"mk_ident","","",232,[[["self"],["str"]],["ident"]]],[11,"next_token","","",232,[[["self"]],["tokenandspan"]]],[11,"unwrap_or_abort","","",232,[[["self"],["result",["tokenandspan"]]],["tokenandspan"]]],[11,"try_real_token","","",232,[[["self"]],["result",["tokenandspan"]]]],[11,"real_token","","",232,[[["self"]],["tokenandspan"]]],[11,"is_eof","","",232,[[["self"]],["bool"]]],[11,"try_next_token","","Return the next token. EFFECT: advances the string_reader.",232,[[["self"]],["result",["tokenandspan"]]]],[11,"fail_unterminated_raw_string","","",232,[[["self"],["bytepos"],["u16"]]]],[11,"fatal","","",232,[[["self"],["str"]],["fatalerror"]]],[11,"emit_fatal_errors","","",232,[[["self"]]]],[11,"peek","","",232,[[["self"]],["tokenandspan"]]],[11,"new_raw","","For comments.rs, which hackily pokes into next_pos and ch",232,[[["parsesess"],["lrc",["filemap"]],["option",["span"]]],["self"]]],[11,"new_raw_internal","","",232,[[["parsesess"],["lrc",["filemap"]],["option",["span"]]],["self"]]],[11,"new","","",232,[[["parsesess"],["lrc",["filemap"]],["option",["span"]]],["self"]]],[11,"retokenize","","",232,[[["parsesess"],["span"]],["self"]]],[11,"ch_is","","",232,[[["self"],["char"]],["bool"]]],[11,"fatal_span","","Report a fatal lexical error with a given span.",232,[[["self"],["span"],["str"]],["fatalerror"]]],[11,"err_span","","Report a lexical error with a given span.",232,[[["self"],["span"],["str"]]]],[11,"fatal_span_","","Report a fatal error spanning [`from_pos`, `to_pos`).",232,[[["self"],["bytepos"],["bytepos"],["str"]],["fatalerror"]]],[11,"err_span_","","Report a lexical error spanning [`from_pos`, `to_pos`).",232,[[["self"],["bytepos"],["bytepos"],["str"]]]],[11,"push_escaped_char_for_msg","","Pushes a character to a message string for error reporting",232,[[["string"],["char"]]]],[11,"fatal_span_char","","Report a lexical error spanning [`from_pos`, `to_pos`), appending an escaped character to the error message",232,[[["self"],["bytepos"],["bytepos"],["str"],["char"]],["fatalerror"]]],[11,"struct_span_fatal","","",232,[[["self"],["bytepos"],["bytepos"],["str"]],["diagnosticbuilder"]]],[11,"struct_fatal_span_char","","",232,[[["self"],["bytepos"],["bytepos"],["str"],["char"]],["diagnosticbuilder"]]],[11,"err_span_char","","Report a lexical error spanning [`from_pos`, `to_pos`), appending an escaped character to the error message",232,[[["self"],["bytepos"],["bytepos"],["str"],["char"]]]],[11,"struct_err_span_char","","",232,[[["self"],["bytepos"],["bytepos"],["str"],["char"]],["diagnosticbuilder"]]],[11,"fatal_span_verbose","","Report a lexical error spanning [`from_pos`, `to_pos`), appending the offending string to the error message",232,[[["self"],["bytepos"],["bytepos"],["string"]],["fatalerror"]]],[11,"advance_token","","Advance peek_tok and peek_span to refer to the next token, and possibly update the interner.",232,[[["self"]],["result"]]],[11,"src_index","","",232,[[["self"],["bytepos"]],["usize"]]],[11,"with_str_from","","Calls `f` with a string slice of the source text spanning from `start` up to but excluding `self.pos`, meaning the slice does not include the character `self.ch`.",232,[[["self"],["bytepos"],["f"]],["t"]]],[11,"name_from","","Create a Name from a given offset to the current offset, each adjusted 1 towards each other (assumes that on either side there is a single-byte delimiter).",232,[[["self"],["bytepos"]],["name"]]],[11,"name_from_to","","As name_from, with an explicit endpoint.",232,[[["self"],["bytepos"],["bytepos"]],["name"]]],[11,"with_str_from_to","","Calls `f` with a string slice of the source text spanning from `start` up to but excluding `end`.",232,[[["self"],["bytepos"],["bytepos"],["f"]],["t"]]],[11,"translate_crlf","","Converts CRLF to LF in the given string, raising an error on bare CR.",232,[[["self"],["bytepos"],["str"],["str"]],["cow",["str"]]]],[11,"bump","","Advance the StringReader by one character. If a newline is discovered, add it to the FileMap's list of line start offsets.",232,[[["self"]]]],[11,"nextch","","",232,[[["self"]],["option",["char"]]]],[11,"nextch_is","","",232,[[["self"],["char"]],["bool"]]],[11,"nextnextch","","",232,[[["self"]],["option",["char"]]]],[11,"nextnextch_is","","",232,[[["self"],["char"]],["bool"]]],[11,"scan_optional_raw_name","","Eats <XID_start><XID_continue>*, if possible.",232,[[["self"]],["option",["name"]]]],[11,"scan_comment","","PRECONDITION: self.ch is not whitespace Eats any kind of comment.",232,[[["self"]],["option",["tokenandspan"]]]],[11,"scan_whitespace_or_comment","","If there is whitespace, shebang, or a comment, scan it. Otherwise, return None.",232,[[["self"]],["option",["tokenandspan"]]]],[11,"scan_block_comment","","Might return a sugared-doc-attr",232,[[["self"]],["option",["tokenandspan"]]]],[11,"scan_digits","","Scan through any digits (base `scan_radix`) or underscores, and return how many digits there were.",232,[[["self"],["u32"],["u32"]],["usize"]]],[11,"scan_number","","Lex a LIT_INTEGER or a LIT_FLOAT",232,[[["self"],["char"]],["lit"]]],[11,"scan_hex_digits","","Scan over `n_digits` hex digits, stopping at `delim`, reporting an error if too many or too few digits are encountered.",232,[[["self"],["usize"],["char"],["bool"]],["bool"]]],[11,"scan_char_or_byte","","Scan for a single (possibly escaped) byte or char in a byte, (non-raw) byte string, char, or (non-raw) string literal. `start` is the position of `first_source_char`, which is already consumed.",232,[[["self"],["bytepos"],["char"],["bool"],["char"]],["bool"]]],[11,"scan_unicode_escape","","Scan over a `\\u{...}` escape",232,[[["self"],["char"]],["bool"]]],[11,"scan_float_exponent","","Scan over a float exponent.",232,[[["self"]]]],[11,"check_float_base","","Check that a base is valid for a floating literal, emitting a nice error if it isn't.",232,[[["self"],["bytepos"],["bytepos"],["usize"]]]],[11,"binop","","",232,[[["self"],["binoptoken"]],["token"]]],[11,"next_token_inner","","Return the next token from the string, advances the input past that token, and updates the interner",232,[[["self"]],["result",["token"]]]],[11,"consume_whitespace","","",232,[[["self"]]]],[11,"read_to_eol","","",232,[[["self"]],["string"]]],[11,"read_one_line_comment","","",232,[[["self"]],["string"]]],[11,"consume_non_eol_whitespace","","",232,[[["self"]]]],[11,"peeking_at_comment","","",232,[[["self"]],["bool"]]],[11,"scan_byte","","",232,[[["self"]],["lit"]]],[11,"scan_byte_escape","","",232,[[["self"],["char"],["bool"]],["bool"]]],[11,"scan_byte_string","","",232,[[["self"]],["lit"]]],[11,"scan_raw_byte_string","","",232,[[["self"]],["lit"]]],[0,"token","syntax::parse","",N,N],[3,"LazyTokenStream","syntax::parse::token","",N,N],[12,"0","","",236,N],[4,"BinOpToken","","",N,N],[13,"Plus","","",237,N],[13,"Minus","","",237,N],[13,"Star","","",237,N],[13,"Slash","","",237,N],[13,"Percent","","",237,N],[13,"Caret","","",237,N],[13,"And","","",237,N],[13,"Or","","",237,N],[13,"Shl","","",237,N],[13,"Shr","","",237,N],[4,"DelimToken","","A delimiter token",N,N],[13,"Paren","","A round parenthesis: `(` or `)`",238,N],[13,"Bracket","","A square bracket: `[` or `]`",238,N],[13,"Brace","","A curly brace: `{` or `}`",238,N],[13,"NoDelim","","An empty delimiter",238,N],[4,"Lit","","",N,N],[13,"Byte","","",239,N],[13,"Char","","",239,N],[13,"Integer","","",239,N],[13,"Float","","",239,N],[13,"Str_","","",239,N],[13,"StrRaw","","",239,N],[13,"ByteStr","","",239,N],[13,"ByteStrRaw","","",239,N],[4,"Token","","",N,N],[13,"Eq","","",240,N],[13,"Lt","","",240,N],[13,"Le","","",240,N],[13,"EqEq","","",240,N],[13,"Ne","","",240,N],[13,"Ge","","",240,N],[13,"Gt","","",240,N],[13,"AndAnd","","",240,N],[13,"OrOr","","",240,N],[13,"Not","","",240,N],[13,"Tilde","","",240,N],[13,"BinOp","","",240,N],[13,"BinOpEq","","",240,N],[13,"At","","",240,N],[13,"Dot","","",240,N],[13,"DotDot","","",240,N],[13,"DotDotDot","","",240,N],[13,"DotDotEq","","",240,N],[13,"DotEq","","",240,N],[13,"Comma","","",240,N],[13,"Semi","","",240,N],[13,"Colon","","",240,N],[13,"ModSep","","",240,N],[13,"RArrow","","",240,N],[13,"LArrow","","",240,N],[13,"FatArrow","","",240,N],[13,"Pound","","",240,N],[13,"Dollar","","",240,N],[13,"Question","","",240,N],[13,"SingleQuote","","Used by proc macros for representing lifetimes, not generated by lexer right now.",240,N],[13,"OpenDelim","","An opening delimiter, eg. `{`",240,N],[13,"CloseDelim","","A closing delimiter, eg. `}`",240,N],[13,"Literal","","",240,N],[13,"Ident","","",240,N],[13,"Lifetime","","",240,N],[13,"Interpolated","","",240,N],[13,"DocComment","","Doc comment",240,N],[13,"Whitespace","","Whitespace",240,N],[13,"Comment","","Comment",240,N],[13,"Shebang","","",240,N],[13,"Eof","","",240,N],[4,"Nonterminal","","For interpolation during macro expansion.",N,N],[13,"NtItem","","",241,N],[13,"NtBlock","","",241,N],[13,"NtStmt","","",241,N],[13,"NtPat","","",241,N],[13,"NtExpr","","",241,N],[13,"NtTy","","",241,N],[13,"NtIdent","","",241,N],[13,"NtLifetime","","",241,N],[13,"NtLiteral","","",241,N],[13,"NtMeta","","Stuff inside brackets for attributes",241,N],[13,"NtPath","","",241,N],[13,"NtVis","","",241,N],[13,"NtTT","","",241,N],[13,"NtArm","","",241,N],[13,"NtImplItem","","",241,N],[13,"NtTraitItem","","",241,N],[13,"NtForeignItem","","",241,N],[13,"NtGenerics","","",241,N],[13,"NtWhereClause","","",241,N],[13,"NtArg","","",241,N],[5,"ident_can_begin_expr","","",N,[[["ident"],["bool"]],["bool"]]],[5,"ident_can_begin_type","","",N,[[["ident"],["bool"]],["bool"]]],[5,"is_op","","",N,[[["token"]],["bool"]]],[5,"prepend_attrs","","",N,N],[11,"clone","","",237,[[["self"]],["binoptoken"]]],[11,"eq","","",237,[[["self"],["binoptoken"]],["bool"]]],[11,"encode","","",237,[[["self"],["__s"]],["result"]]],[11,"decode","","",237,[[["__d"]],["result",["binoptoken"]]]],[11,"hash","","",237,N],[11,"fmt","","",237,[[["self"],["formatter"]],["result"]]],[11,"clone","","",238,[[["self"]],["delimtoken"]]],[11,"eq","","",238,[[["self"],["delimtoken"]],["bool"]]],[11,"encode","","",238,[[["self"],["__s"]],["result"]]],[11,"decode","","",238,[[["__d"]],["result",["delimtoken"]]]],[11,"hash","","",238,N],[11,"fmt","","",238,[[["self"],["formatter"]],["result"]]],[11,"len","","",238,[[["self"]],["usize"]]],[11,"is_empty","","",238,[[["self"]],["bool"]]],[11,"clone","","",239,[[["self"]],["lit"]]],[11,"eq","","",239,[[["self"],["lit"]],["bool"]]],[11,"ne","","",239,[[["self"],["lit"]],["bool"]]],[11,"encode","","",239,[[["self"],["__s"]],["result"]]],[11,"decode","","",239,[[["__d"]],["result",["lit"]]]],[11,"hash","","",239,N],[11,"fmt","","",239,[[["self"],["formatter"]],["result"]]],[11,"short_name","","",239,[[["self"]],["str"]]],[11,"probably_equal_for_proc_macro","","",239,[[["self"],["lit"]],["bool"]]],[11,"clone","","",240,[[["self"]],["token"]]],[11,"encode","","",240,[[["self"],["__s"]],["result"]]],[11,"decode","","",240,[[["__d"]],["result",["token"]]]],[11,"eq","","",240,[[["self"],["token"]],["bool"]]],[11,"ne","","",240,[[["self"],["token"]],["bool"]]],[11,"fmt","","",240,[[["self"],["formatter"]],["result"]]],[11,"interpolated","","",240,[[["nonterminal"]],["token"]]],[11,"from_ast_ident","","Recovers a `Token` from an `ast::Ident`. This creates a raw identifier if necessary.",240,[[["ident"]],["token"]]],[11,"is_like_plus","","",240,[[["self"]],["bool"]]],[11,"can_begin_expr","","Returns `true` if the token can appear at the start of an expression.",240,[[["self"]],["bool"]]],[11,"can_begin_type","","Returns `true` if the token can appear at the start of a type.",240,[[["self"]],["bool"]]],[11,"can_begin_bound","","Returns `true` if the token can appear at the start of a generic bound.",240,[[["self"]],["bool"]]],[11,"is_lit","","Returns `true` if the token is any literal",240,[[["self"]],["bool"]]],[11,"can_begin_literal_or_bool","","Returns `true` if the token is any literal, a minus (which can follow a literal, for example a '-42', or one of the boolean idents).",240,[[["self"]],["bool"]]],[11,"ident","","Returns an identifier if this token is an identifier.",240,[[["self"]],["option"]]],[11,"lifetime","","Returns a lifetime identifier if this token is a lifetime.",240,[[["self"]],["option",["ident"]]]],[11,"is_ident","","Returns `true` if the token is an identifier.",240,[[["self"]],["bool"]]],[11,"is_lifetime","","Returns `true` if the token is a lifetime.",240,[[["self"]],["bool"]]],[11,"is_ident_named","","Returns `true` if the token is a identifier whose name is the given string slice.",240,[[["self"],["str"]],["bool"]]],[11,"is_path","","Returns `true` if the token is an interpolated path.",240,[[["self"]],["bool"]]],[11,"is_mutability","","Returns `true` if the token is either the `mut` or `const` keyword.",240,[[["self"]],["bool"]]],[11,"is_qpath_start","","",240,[[["self"]],["bool"]]],[11,"is_path_start","","",240,[[["self"]],["bool"]]],[11,"is_keyword","","Returns `true` if the token is a given keyword, `kw`.",240,[[["self"],["keyword"]],["bool"]]],[11,"is_path_segment_keyword","","",240,[[["self"]],["bool"]]],[11,"is_special_ident","","",240,[[["self"]],["bool"]]],[11,"is_used_keyword","","Returns `true` if the token is a keyword used in the language.",240,[[["self"]],["bool"]]],[11,"is_unused_keyword","","Returns `true` if the token is a keyword reserved for possible future use.",240,[[["self"]],["bool"]]],[11,"is_reserved_ident","","Returns `true` if the token is either a special identifier or a keyword.",240,[[["self"]],["bool"]]],[11,"glue","","",240,[[["self"],["token"]],["option",["token"]]]],[11,"similar_tokens","","Returns tokens that are likely to be typed accidentally instead of the current token. Enables better error recovery when the wrong token is found.",240,[[["self"]],["option",["vec"]]]],[11,"interpolated_to_tokenstream","","",240,[[["self"],["parsesess"],["span"]],["tokenstream"]]],[11,"probably_equal_for_proc_macro","","",240,[[["self"],["token"]],["bool"]]],[11,"clone","","",241,[[["self"]],["nonterminal"]]],[11,"encode","","",241,[[["self"],["__s"]],["result"]]],[11,"decode","","",241,[[["__d"]],["result",["nonterminal"]]]],[11,"eq","","",241,[[["self"],["self"]],["bool"]]],[11,"fmt","","",241,[[["self"],["formatter"]],["result"]]],[11,"clone","","",236,[[["self"]],["lazytokenstream"]]],[11,"eq","","",236,[[["self"],["lazytokenstream"]],["bool"]]],[11,"fmt","","",236,[[["self"],["formatter"]],["result"]]],[11,"new","","",236,[[],["self"]]],[11,"force","","",236,[[["self"],["f"]],["tokenstream"]]],[11,"encode","","",236,[[["self"],["s"]],["result"]]],[11,"decode","","",236,[[["d"]],["result",["lazytokenstream"]]]],[11,"hash","","",236,[[["self"],["h"]]]],[0,"attr","syntax::parse","",N,N],[4,"InnerAttributeParsePolicy","syntax::parse::attr","",N,N],[13,"Permitted","","",242,N],[13,"NotPermitted","","",242,N],[12,"reason","syntax::parse::attr::InnerAttributeParsePolicy","",242,N],[17,"DEFAULT_UNEXPECTED_INNER_ATTR_ERR_MSG","syntax::parse::attr","",N,N],[11,"fmt","","",242,[[["self"],["formatter"]],["result"]]],[11,"parse_outer_attributes","syntax::parse::parser","Parse attributes that appear before an item",215,[[["self"]],["presult",["vec"]]]],[11,"parse_attribute","","Matches `attribute = # ! [ meta_item ]`",215,[[["self"],["bool"]],["presult",["attribute"]]]],[11,"parse_attribute_with_inner_parse_policy","","The same as `parse_attribute`, except it takes in an `InnerAttributeParsePolicy` that prescribes how to handle inner attributes.",215,[[["self"],["innerattributeparsepolicy"]],["presult",["attribute"]]]],[11,"parse_path_and_tokens","","",215,[[["self"]],["presult"]]],[11,"parse_inner_attributes","","Parse attributes that appear after the opening of an item. These should be preceded by an exclamation mark, but we accept and warn about one terminated by a semicolon. matches inner_attrs*",215,[[["self"]],["presult",["vec"]]]],[11,"parse_unsuffixed_lit","","",215,[[["self"]],["presult",["lit"]]]],[11,"parse_meta_item","","Per RFC#1559, matches the following grammar:",215,[[["self"]],["presult",["metaitem"]]]],[11,"parse_meta_item_kind","","",215,[[["self"]],["presult",["metaitemkind"]]]],[11,"parse_meta_item_inner","","matches meta_item_inner : (meta_item | UNSUFFIXED_LIT) ;",215,[[["self"]],["presult",["nestedmetaitem"]]]],[11,"parse_meta_seq","","matches meta_seq = ( COMMASEP(meta_item_inner) )",215,[[["self"]],["presult",["vec"]]]],[0,"classify","syntax::parse","Routines the parser uses to classify AST nodes",N,N],[5,"expr_requires_semi_to_be_stmt","syntax::parse::classify","Does this expression require a semicolon to be treated as a statement? The negation of this: 'can this expression be used as a statement without a semicolon' -- is used as an early-bail-out in the parser so that, for instance,     if true {...} else {...}      |x| 5 isn't parsed as (if true {...} else {...} | x) | 5",N,[[["expr"]],["bool"]]],[5,"stmt_ends_with_semi","","this statement requires a semicolon after it. note that in one case (`stmt_semi`), we've already seen the semicolon, and thus don't need another.",N,[[["stmtkind"]],["bool"]]],[6,"PResult","syntax::parse","",N,N],[11,"new","","",210,[[["filepathmapping"]],["self"]]],[11,"with_span_handler","","",210,[[["handler"],["lrc",["codemap"]]],["parsesess"]]],[11,"codemap","","",210,[[["self"]],["codemap"]]],[11,"buffer_lint","","",210,[[["self"],["bufferedearlylintid"],["s"],["nodeid"],["str"]]]],[11,"clone","","",211,[[["self"]],["directory"]]],[11,"clone","","",213,[[["self"]],["directoryownership"]]],[11,"trailing_allowed","","",212,[[["token"]],["seqsep"]]],[11,"none","","",212,[[],["seqsep"]]],[0,"ptr","syntax","The AST pointer",N,N],[3,"P","syntax::ptr","An owned smart pointer.",N,N],[12,"ptr","","",243,N],[5,"P","","Construct a `P<T>` from a `T` value.",N,[[["t"]],["p"]]],[11,"hash","","",243,N],[11,"eq","","",243,[[["self"],["p"]],["bool"]]],[11,"ne","","",243,[[["self"],["p"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",243,N],[11,"and_then","","Move out of the pointer. Intended for chaining transformations not covered by `map`.",243,[[["self"],["f"]],["u"]]],[11,"into_inner","","Equivalent to and_then(|x| x)",243,[[["self"]],["t"]]],[11,"map","","Transform the inner value, consuming `self` and producing a new `P<T>`.",243,[[["self"],["f"]],["p"]]],[11,"deref","","",243,[[["self"]],["t"]]],[11,"clone","","",243,[[["self"]],["p"]]],[11,"fmt","","",243,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",243,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",243,[[["self"],["formatter"]],["result"]]],[11,"decode","","",243,[[["d"]],["result",["p"]]]],[11,"encode","","",243,[[["self"],["s"]],["result"]]],[11,"new","","",243,[[],["p"]]],[11,"from_vec","","",243,[[["vec"]],["p"]]],[11,"into_vec","","",243,[[["self"]],["vec"]]],[11,"default","","Creates an empty `P<[T]>`.",243,[[],["p"]]],[11,"clone","","",243,[[["self"]],["p"]]],[11,"from","","",243,[[["vec"]],["self"]]],[11,"into","","",243,[[["self"]],["vec"]]],[11,"from_iter","","",243,[[["i"]],["p"]]],[11,"into_iter","","",243,N],[11,"encode","","",243,[[["self"],["s"]],["result"]]],[11,"decode","","",243,[[["d"]],["result",["p"]]]],[11,"hash_stable","","",243,[[["self"],["ctx"],["stablehasher"]]]],[0,"show_span","syntax","Span debugger",N,N],[3,"ShowSpanVisitor","syntax::show_span","",N,N],[12,"span_diagnostic","","",244,N],[12,"mode","","",244,N],[4,"Mode","","",N,N],[13,"Expression","","",245,N],[13,"Pattern","","",245,N],[13,"Type","","",245,N],[5,"run","","",N,[[["handler"],["str"],["crate"]]]],[11,"from_str","","",245,[[["str"]],["result",["mode"]]]],[11,"visit_expr","","",244,[[["self"],["expr"]]]],[11,"visit_pat","","",244,[[["self"],["pat"]]]],[11,"visit_ty","","",244,[[["self"],["ty"]]]],[11,"visit_mac","","",244,[[["self"],["mac"]]]],[0,"std_inject","syntax","",N,N],[5,"ignored_span","syntax::std_inject","Craft a span that will be ignored by the stability lint's call to codemap's `is_internal` check. The expanded code uses the unstable `#[prelude_import]` attribute.",N,[[["span"]],["span"]]],[5,"injected_crate_name","","",N,[[],["option",["str"]]]],[5,"maybe_inject_crates_ref","","",N,[[["crate"],["option",["str"]]],["crate"]]],[17,"INJECTED_CRATE_NAME","","",N,N],[0,"str","syntax","",N,N],[5,"char_at","syntax::str","",N,[[["str"],["usize"]],["char"]]],[0,"test","syntax","",N,N],[3,"Test","syntax::test","",N,N],[12,"span","","",246,N],[12,"path","","",246,N],[12,"bench","","",246,N],[12,"ignore","","",246,N],[12,"should_panic","","",246,N],[12,"allow_fail","","",246,N],[3,"TestCtxt","","",N,N],[12,"span_diagnostic","","",247,N],[12,"path","","",247,N],[12,"ext_cx","","",247,N],[12,"testfns","","",247,N],[12,"reexport_test_harness_main","","",247,N],[12,"is_libtest","","",247,N],[12,"ctxt","","",247,N],[12,"features","","",247,N],[12,"toplevel_reexport","","",247,N],[3,"TestHarnessGenerator","","",N,N],[12,"cx","","",248,N],[12,"tests","","",248,N],[12,"tested_submods","","",248,N],[3,"EntryPointCleaner","","",N,N],[12,"depth","","",249,N],[4,"ShouldPanic","","",N,N],[13,"No","","",250,N],[13,"Yes","","",250,N],[4,"HasTestSignature","","",N,N],[13,"Yes","","",251,N],[13,"No","","",251,N],[4,"BadTestSignature","","",N,N],[13,"NotEvenAFunction","","",252,N],[13,"WrongTypeSignature","","",252,N],[13,"NoArgumentsAllowed","","",252,N],[13,"ShouldPanicOnlyWithNoArgs","","",252,N],[5,"modify_for_testing","","",N,[[["parsesess"],["resolver"],["bool"],["crate"],["handler"],["features"]],["crate"]]],[5,"mk_reexport_mod","","",N,N],[5,"generate_test_harness","","",N,[[["parsesess"],["resolver"],["option",["symbol"]],["crate"],["handler"],["features"]],["crate"]]],[5,"ignored_span","","Craft a span that will be ignored by the stability lint's call to codemap's `is_internal` check. The expanded code calls some unstable functions in the test crate.",N,[[["testctxt"],["span"]],["span"]]],[5,"is_test_fn","","",N,[[["testctxt"],["item"]],["bool"]]],[5,"is_bench_fn","","",N,[[["testctxt"],["item"]],["bool"]]],[5,"is_ignored","","",N,[[["item"]],["bool"]]],[5,"is_allowed_fail","","",N,[[["item"]],["bool"]]],[5,"should_panic","","",N,[[["item"],["testctxt"]],["shouldpanic"]]],[5,"mk_std","","",N,[[["testctxt"]],["p",["item"]]]],[5,"mk_main","","",N,[[["testctxt"]],["p",["item"]]]],[5,"mk_test_module","","",N,N],[5,"nospan","","",N,[[["t"]],["spanned"]]],[5,"path_node","","",N,[[["vec",["ident"]]],["path"]]],[5,"path_name_i","","",N,N],[5,"mk_tests","","",N,[[["testctxt"]],["p",["item"]]]],[5,"mk_test_descs","","",N,[[["testctxt"]],["p",["expr"]]]],[5,"mk_test_desc_and_fn_rec","","",N,[[["testctxt"],["test"]],["p",["expr"]]]],[11,"fold_crate","","",248,[[["self"],["crate"]],["crate"]]],[11,"fold_item","","",248,[[["self"],["p",["item"]]],["smallvector",["p"]]]],[11,"fold_mac","","",248,[[["self"],["mac"]],["mac"]]],[11,"fold_item","","",249,[[["self"],["p",["item"]]],["smallvector",["p"]]]],[11,"fold_mac","","",249,[[["self"],["mac"]],["mac"]]],[11,"eq","","",252,[[["self"],["badtestsignature"]],["bool"]]],[0,"tokenstream","syntax","Token Streams",N,N],[3,"Delimited","syntax::tokenstream","A delimited sequence of token trees",N,N],[12,"delim","","The type of delimiter",253,N],[12,"tts","","The delimited sequence of token trees",253,N],[3,"TokenStream","","Token Streams",N,N],[12,"kind","","",254,N],[3,"TokenStreamBuilder","","",N,N],[12,"0","","",255,N],[3,"Cursor","","",N,N],[12,"0","","",256,N],[3,"StreamCursor","","",N,N],[12,"stream","","",257,N],[12,"index","","",257,N],[12,"stack","","",257,N],[3,"ThinTokenStream","","The `TokenStream` type is large enough to represent a single `TokenTree` without allocation. `ThinTokenStream` is smaller, but needs to allocate to represent a single `TokenTree`. We must use `ThinTokenStream` in `TokenTree::Delimited` to avoid infinite size due to recursion.",N,N],[12,"0","","",258,N],[4,"TokenTree","","When the main rust parser encounters a syntax-extension invocation, it parses the arguments to the invocation as a token-tree. This is a very loose structure, such that all sorts of different AST-fragments can be passed to syntax extensions using a uniform type.",N,N],[13,"Token","","A single token",259,N],[13,"Delimited","","A delimited sequence of token trees",259,N],[4,"TokenStreamKind","","",N,N],[13,"Empty","","",260,N],[13,"Tree","","",260,N],[13,"JointTree","","",260,N],[13,"Stream","","",260,N],[4,"CursorKind","","",N,N],[13,"Empty","","",261,N],[13,"Tree","","",261,N],[13,"JointTree","","",261,N],[13,"Stream","","",261,N],[11,"clone","","",253,[[["self"]],["delimited"]]],[11,"eq","","",253,[[["self"],["delimited"]],["bool"]]],[11,"ne","","",253,[[["self"],["delimited"]],["bool"]]],[11,"encode","","",253,[[["self"],["__s"]],["result"]]],[11,"decode","","",253,[[["__d"]],["result",["delimited"]]]],[11,"fmt","","",253,[[["self"],["formatter"]],["result"]]],[11,"open_token","","Returns the opening delimiter as a token.",253,[[["self"]],["token"]]],[11,"close_token","","Returns the closing delimiter as a token.",253,[[["self"]],["token"]]],[11,"open_tt","","Returns the opening delimiter as a token tree.",253,[[["self"],["span"]],["tokentree"]]],[11,"close_tt","","Returns the closing delimiter as a token tree.",253,[[["self"],["span"]],["tokentree"]]],[11,"stream","","Returns the token trees inside the delimiters.",253,[[["self"]],["tokenstream"]]],[11,"fmt","","",259,[[["self"],["formatter"]],["result"]]],[11,"clone","","",259,[[["self"]],["tokentree"]]],[11,"eq","","",259,[[["self"],["tokentree"]],["bool"]]],[11,"ne","","",259,[[["self"],["tokentree"]],["bool"]]],[11,"encode","","",259,[[["self"],["__s"]],["result"]]],[11,"decode","","",259,[[["__d"]],["result",["tokentree"]]]],[11,"parse","","Use this token tree as a matcher to parse given tts.",259,N],[11,"eq_unspanned","","Check if this TokenTree is equal to the other, regardless of span information.",259,[[["self"],["tokentree"]],["bool"]]],[11,"probably_equal_for_proc_macro","","",259,[[["self"],["tokentree"]],["bool"]]],[11,"span","","Retrieve the TokenTree's span.",259,[[["self"]],["span"]]],[11,"set_span","","Modify the `TokenTree`'s span inplace.",259,[[["self"],["span"]]]],[11,"eq_token","","Indicates if the stream is a token that is equal to the provided token.",259,[[["self"],["token"]],["bool"]]],[11,"joint","","",259,[[["self"]],["tokenstream"]]],[11,"clone","","",254,[[["self"]],["tokenstream"]]],[11,"fmt","","",254,[[["self"],["formatter"]],["result"]]],[11,"clone","","",260,[[["self"]],["tokenstreamkind"]]],[11,"fmt","","",260,[[["self"],["formatter"]],["result"]]],[11,"from","","",254,[[["tokentree"]],["tokenstream"]]],[11,"from","","",254,[[["token"]],["tokenstream"]]],[11,"from_iter","","",254,[[["i"]],["self"]]],[11,"eq","","",254,[[["self"],["tokenstream"]],["bool"]]],[11,"len","","",254,[[["self"]],["usize"]]],[11,"empty","","",254,[[],["tokenstream"]]],[11,"is_empty","","",254,[[["self"]],["bool"]]],[11,"concat","","",254,[[["vec",["tokenstream"]]],["tokenstream"]]],[11,"concat_rc_slice","","",254,[[["rcslice",["tokenstream"]]],["tokenstream"]]],[11,"trees","","",254,[[["self"]],["cursor"]]],[11,"into_trees","","",254,[[["self"]],["cursor"]]],[11,"eq_unspanned","","Compares two TokenStreams, checking equality without regarding span information.",254,[[["self"],["tokenstream"]],["bool"]]],[11,"probably_equal_for_proc_macro","","",254,[[["self"],["tokenstream"]],["bool"]]],[11,"as_tree","","Precondition: `self` consists of a single token tree. Returns true if the token tree is a joint operation w.r.t. `proc_macro::TokenNode`.",254,N],[11,"map_enumerated","","",254,[[["self"],["f"]],["tokenstream"]]],[11,"map","","",254,[[["self"],["f"]],["tokenstream"]]],[11,"first_tree_and_joint","","",254,[[["self"]],["option"]]],[11,"last_tree_if_joint","","",254,[[["self"]],["option",["tokentree"]]]],[11,"clone","","",255,[[["self"]],["tokenstreambuilder"]]],[11,"new","","",255,[[],["tokenstreambuilder"]]],[11,"push","","",255,[[["self"],["t"]]]],[11,"add","","",255,[[["self"],["t"]],["self"]]],[11,"build","","",255,[[["self"]],["tokenstream"]]],[11,"push_all_but_last_tree","","",255,[[["self"],["tokenstream"]]]],[11,"push_all_but_first_tree","","",255,[[["self"],["tokenstream"]]]],[11,"clone","","",256,[[["self"]],["cursor"]]],[11,"clone","","",261,[[["self"]],["cursorkind"]]],[11,"clone","","",257,[[["self"]],["streamcursor"]]],[11,"new","","",257,[[["rcslice",["tokenstream"]]],["self"]]],[11,"next_as_stream","","",257,[[["self"]],["option",["tokenstream"]]]],[11,"insert","","",257,[[["self"],["rcslice",["tokenstream"]]]]],[11,"next","","",256,[[["self"]],["option",["tokentree"]]]],[11,"new","","",256,[[["tokenstream"]],["self"]]],[11,"next_as_stream","","",256,[[["self"]],["option",["tokenstream"]]]],[11,"insert","","",256,[[["self"],["tokenstream"]]]],[11,"original_stream","","",256,[[["self"]],["tokenstream"]]],[11,"look_ahead","","",256,[[["self"],["usize"]],["option",["tokentree"]]]],[11,"fmt","","",258,[[["self"],["formatter"]],["result"]]],[11,"clone","","",258,[[["self"]],["thintokenstream"]]],[11,"from","","",258,[[["tokenstream"]],["thintokenstream"]]],[11,"from","","",254,[[["thintokenstream"]],["tokenstream"]]],[11,"eq","","",258,[[["self"],["thintokenstream"]],["bool"]]],[11,"fmt","","",254,[[["self"],["formatter"]],["result"]]],[11,"encode","","",254,[[["self"],["e"]],["result"]]],[11,"decode","","",254,[[["d"]],["result",["tokenstream"]]]],[11,"encode","","",258,[[["self"],["e"]],["result"]]],[11,"decode","","",258,[[["d"]],["result",["thintokenstream"]]]],[0,"visit","syntax","AST walker. Each overridden visit method has full control over what happens with its node, it can do its own traversal of the node's children, call `visit::walk_*` to apply the default traversal algorithm, or prevent deeper traversal by doing nothing.",N,N],[4,"FnKind","syntax::visit","",N,N],[13,"ItemFn","","fn foo() or extern \"Abi\" fn foo()",262,N],[13,"Method","","fn foo(&self)",262,N],[13,"Closure","","|x, y| body",262,N],[5,"walk_ident","","",N,[[["v"],["ident"]]]],[5,"walk_crate","","",N,[[["v"],["crate"]]]],[5,"walk_mod","","",N,[[["v"],["mod"]]]],[5,"walk_local","","",N,[[["v"],["local"]]]],[5,"walk_label","","",N,[[["v"],["label"]]]],[5,"walk_lifetime","","",N,[[["v"],["lifetime"]]]],[5,"walk_poly_trait_ref","","",N,[[["v"],["polytraitref"],["traitboundmodifier"]]]],[5,"walk_trait_ref","","",N,[[["v"],["traitref"]]]],[5,"walk_item","","",N,[[["v"],["item"]]]],[5,"walk_enum_def","","",N,[[["v"],["enumdef"],["generics"],["nodeid"]]]],[5,"walk_variant","","",N,[[["v"],["variant"],["generics"],["nodeid"]]]],[5,"walk_ty","","",N,[[["v"],["ty"]]]],[5,"walk_path","","",N,[[["v"],["path"]]]],[5,"walk_use_tree","","",N,[[["v"],["usetree"],["nodeid"]]]],[5,"walk_path_segment","","",N,[[["v"],["span"],["pathsegment"]]]],[5,"walk_generic_args","","",N,[[["v"],["span"],["genericargs"]]]],[5,"walk_assoc_type_binding","","",N,[[["v"],["typebinding"]]]],[5,"walk_pat","","",N,[[["v"],["pat"]]]],[5,"walk_foreign_item","","",N,[[["v"],["foreignitem"]]]],[5,"walk_global_asm","","",N,[[["v"],["globalasm"]]]],[5,"walk_param_bound","","",N,[[["v"],["genericbound"]]]],[5,"walk_generic_param","","",N,[[["v"],["genericparam"]]]],[5,"walk_generics","","",N,[[["v"],["generics"]]]],[5,"walk_where_predicate","","",N,[[["v"],["wherepredicate"]]]],[5,"walk_fn_ret_ty","","",N,[[["v"],["functionretty"]]]],[5,"walk_fn_decl","","",N,[[["v"],["fndecl"]]]],[5,"walk_fn","","",N,[[["v"],["fnkind"],["fndecl"],["span"]]]],[5,"walk_trait_item","","",N,[[["v"],["traititem"]]]],[5,"walk_impl_item","","",N,[[["v"],["implitem"]]]],[5,"walk_struct_def","","",N,[[["v"],["variantdata"]]]],[5,"walk_struct_field","","",N,[[["v"],["structfield"]]]],[5,"walk_block","","",N,[[["v"],["block"]]]],[5,"walk_stmt","","",N,[[["v"],["stmt"]]]],[5,"walk_mac","","",N,[[["v"],["mac"]]]],[5,"walk_anon_const","","",N,[[["v"],["anonconst"]]]],[5,"walk_expr","","",N,[[["v"],["expr"]]]],[5,"walk_arm","","",N,[[["v"],["arm"]]]],[5,"walk_vis","","",N,[[["v"],["visibility"]]]],[5,"walk_attribute","","",N,[[["v"],["attribute"]]]],[5,"walk_tt","","",N,[[["v"],["tokentree"]]]],[5,"walk_tts","","",N,[[["v"],["tokenstream"]]]],[8,"Visitor","","Each method of the Visitor trait is a hook to be potentially overridden.  Each method's default implementation recursively visits the substructure of the input via the corresponding `walk` method; e.g. the `visit_mod` method by default calls `visit::walk_mod`.",N,N],[11,"visit_name","","",263,[[["self"],["span"],["name"]]]],[11,"visit_ident","","",263,[[["self"],["ident"]]]],[11,"visit_mod","","",263,N],[11,"visit_foreign_item","","",263,[[["self"],["foreignitem"]]]],[11,"visit_global_asm","","",263,[[["self"],["globalasm"]]]],[11,"visit_item","","",263,[[["self"],["item"]]]],[11,"visit_local","","",263,[[["self"],["local"]]]],[11,"visit_block","","",263,[[["self"],["block"]]]],[11,"visit_stmt","","",263,[[["self"],["stmt"]]]],[11,"visit_arm","","",263,[[["self"],["arm"]]]],[11,"visit_pat","","",263,[[["self"],["pat"]]]],[11,"visit_anon_const","","",263,[[["self"],["anonconst"]]]],[11,"visit_expr","","",263,[[["self"],["expr"]]]],[11,"visit_expr_post","","",263,[[["self"],["expr"]]]],[11,"visit_ty","","",263,[[["self"],["ty"]]]],[11,"visit_generic_param","","",263,[[["self"],["genericparam"]]]],[11,"visit_generics","","",263,[[["self"],["generics"]]]],[11,"visit_where_predicate","","",263,[[["self"],["wherepredicate"]]]],[11,"visit_fn","","",263,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",263,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",263,[[["self"],["implitem"]]]],[11,"visit_trait_ref","","",263,[[["self"],["traitref"]]]],[11,"visit_param_bound","","",263,[[["self"],["genericbound"]]]],[11,"visit_poly_trait_ref","","",263,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_variant_data","","",263,[[["self"],["variantdata"],["ident"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",263,[[["self"],["structfield"]]]],[11,"visit_enum_def","","",263,[[["self"],["enumdef"],["generics"],["nodeid"],["span"]]]],[11,"visit_variant","","",263,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_label","","",263,[[["self"],["label"]]]],[11,"visit_lifetime","","",263,[[["self"],["lifetime"]]]],[11,"visit_mac","","",263,[[["self"],["mac"]]]],[11,"visit_mac_def","","",263,[[["self"],["macrodef"],["nodeid"]]]],[11,"visit_path","","",263,[[["self"],["path"],["nodeid"]]]],[11,"visit_use_tree","","",263,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_path_segment","","",263,[[["self"],["span"],["pathsegment"]]]],[11,"visit_generic_args","","",263,[[["self"],["span"],["genericargs"]]]],[11,"visit_generic_arg","","",263,[[["self"],["genericarg"]]]],[11,"visit_assoc_type_binding","","",263,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",263,[[["self"],["attribute"]]]],[11,"visit_tt","","",263,[[["self"],["tokentree"]]]],[11,"visit_tts","","",263,[[["self"],["tokenstream"]]]],[11,"visit_token","","",263,[[["self"],["token"]]]],[11,"visit_vis","","",263,[[["self"],["visibility"]]]],[11,"visit_fn_ret_ty","","",263,[[["self"],["functionretty"]]]],[11,"clone","","",262,[[["self"]],["fnkind"]]],[0,"print","syntax","",N,N],[0,"pp","syntax::print","This pretty-printer is a direct reimplementation of Philip Karlton's Mesa pretty-printer, as described in appendix A of",N,N],[3,"BreakToken","syntax::print::pp","",N,N],[12,"offset","","",264,N],[12,"blank_space","","",264,N],[3,"BeginToken","","",N,N],[12,"offset","","",265,N],[12,"breaks","","",265,N],[3,"PrintStackElem","","",N,N],[12,"offset","","",266,N],[12,"pbreak","","",266,N],[3,"Printer","","",N,N],[12,"out","","",267,N],[12,"buf_max_len","","",267,N],[12,"margin","","Width of lines we're constrained to",267,N],[12,"space","","Number of spaces left on line",267,N],[12,"left","","Index of left side of input stream",267,N],[12,"right","","Index of right side of input stream",267,N],[12,"buf","","Ring-buffer of tokens and calculated sizes",267,N],[12,"left_total","","Running size of stream \"...left\"",267,N],[12,"right_total","","Running size of stream \"...right\"",267,N],[12,"scan_stack","","Pseudo-stack, really a ring too. Holds the primary-ring-buffers index of the Begin that started the current block, possibly with the most recent Break after that Begin (if there is any) on top of it. Stuff is flushed off the bottom as it becomes irrelevant due to the primary ring-buffer advancing.",267,N],[12,"print_stack","","Stack of blocks-in-progress being flushed by print",267,N],[12,"pending_indentation","","Buffered indentation to avoid writing trailing whitespace",267,N],[3,"BufEntry","","",N,N],[12,"token","","",268,N],[12,"size","","",268,N],[4,"Breaks","","How to break. Described in more detail in the module docs.",N,N],[13,"Consistent","","",269,N],[13,"Inconsistent","","",269,N],[4,"Token","","",N,N],[13,"String","","",270,N],[13,"Break","","",270,N],[13,"Begin","","",270,N],[13,"End","","",270,N],[13,"Eof","","",270,N],[4,"PrintStackBreak","","",N,N],[13,"Fits","","",271,N],[13,"Broken","","",271,N],[5,"buf_str","","",N,N],[5,"mk_printer","","",N,[[["box",["write"]],["usize"]],["printer"]]],[17,"SIZE_INFINITY","","",N,N],[11,"clone","","",269,[[["self"]],["breaks"]]],[11,"eq","","",269,[[["self"],["breaks"]],["bool"]]],[11,"clone","","",264,[[["self"]],["breaktoken"]]],[11,"clone","","",265,[[["self"]],["begintoken"]]],[11,"clone","","",270,[[["self"]],["token"]]],[11,"is_eof","","",270,[[["self"]],["bool"]]],[11,"is_hardbreak_tok","","",270,[[["self"]],["bool"]]],[11,"fmt","","",270,[[["self"],["formatter"]],["result"]]],[11,"clone","","",271,[[["self"]],["printstackbreak"]]],[11,"clone","","",266,[[["self"]],["printstackelem"]]],[11,"clone","","",268,[[["self"]],["bufentry"]]],[11,"default","","",268,[[],["self"]]],[11,"last_token","","",267,[[["self"]],["token"]]],[11,"replace_last_token","","be very careful with this!",267,[[["self"],["token"]]]],[11,"pretty_print","","",267,[[["self"],["token"]],["result"]]],[11,"check_stream","","",267,[[["self"]],["result"]]],[11,"scan_push","","",267,[[["self"],["usize"]]]],[11,"scan_pop","","",267,[[["self"]],["usize"]]],[11,"scan_top","","",267,[[["self"]],["usize"]]],[11,"scan_pop_bottom","","",267,[[["self"]],["usize"]]],[11,"advance_right","","",267,[[["self"]]]],[11,"advance_left","","",267,[[["self"]],["result"]]],[11,"check_stack","","",267,[[["self"],["isize"]]]],[11,"print_newline","","",267,[[["self"],["isize"]],["result"]]],[11,"indent","","",267,[[["self"],["isize"]]]],[11,"get_top","","",267,[[["self"]],["printstackelem"]]],[11,"print_str","","",267,[[["self"],["str"]],["result"]]],[11,"print","","",267,[[["self"],["token"],["isize"]],["result"]]],[11,"rbox","","\"raw box\"",267,[[["self"],["usize"],["breaks"]],["result"]]],[11,"ibox","","Inconsistent breaking box",267,[[["self"],["usize"]],["result"]]],[11,"cbox","","Consistent breaking box",267,[[["self"],["usize"]],["result"]]],[11,"break_offset","","",267,[[["self"],["usize"],["isize"]],["result"]]],[11,"end","","",267,[[["self"]],["result"]]],[11,"eof","","",267,[[["self"]],["result"]]],[11,"word","","",267,[[["self"],["str"]],["result"]]],[11,"huge_word","","",267,[[["self"],["str"]],["result"]]],[11,"zero_word","","",267,[[["self"],["str"]],["result"]]],[11,"spaces","","",267,[[["self"],["usize"]],["result"]]],[11,"zerobreak","","",267,[[["self"]],["result"]]],[11,"space","","",267,[[["self"]],["result"]]],[11,"hardbreak","","",267,[[["self"]],["result"]]],[11,"hardbreak_tok_offset","","",267,[[["isize"]],["token"]]],[11,"hardbreak_tok","","",267,[[],["token"]]],[0,"pprust","syntax::print","",N,N],[3,"NoAnn","syntax::print::pprust","",N,N],[3,"State","","",N,N],[12,"s","","",272,N],[12,"cm","","",272,N],[12,"comments","","",272,N],[12,"literals","","",272,N],[12,"cur_cmnt","","",272,N],[12,"boxes","","",272,N],[12,"ann","","",272,N],[4,"AnnNode","","",N,N],[13,"NodeIdent","","",273,N],[13,"NodeName","","",273,N],[13,"NodeBlock","","",273,N],[13,"NodeItem","","",273,N],[13,"NodeSubItem","","",273,N],[13,"NodeExpr","","",273,N],[13,"NodePat","","",273,N],[5,"rust_printer","","",N,[[["box",["write"]],["ppann"]],["state"]]],[5,"print_crate","","Requires you to pass an input filename and reader so that it can scan the input text for comments and literals to copy forward.",N,[[["codemap"],["parsesess"],["crate"],["filename"],["read"],["box",["write"]],["ppann"],["bool"]],["result"]]],[5,"to_string","","",N,[[["f"]],["string"]]],[5,"binop_to_string","","",N,[[["binoptoken"]],["str"]]],[5,"token_to_string","","",N,[[["token"]],["string"]]],[5,"ty_to_string","","",N,[[["ty"]],["string"]]],[5,"bounds_to_string","","",N,N],[5,"pat_to_string","","",N,[[["pat"]],["string"]]],[5,"arm_to_string","","",N,[[["arm"]],["string"]]],[5,"expr_to_string","","",N,[[["expr"]],["string"]]],[5,"lifetime_to_string","","",N,[[["lifetime"]],["string"]]],[5,"tt_to_string","","",N,[[["tokentree"]],["string"]]],[5,"tts_to_string","","",N,N],[5,"tokens_to_string","","",N,[[["tokenstream"]],["string"]]],[5,"stmt_to_string","","",N,[[["stmt"]],["string"]]],[5,"attr_to_string","","",N,[[["attribute"]],["string"]]],[5,"item_to_string","","",N,[[["item"]],["string"]]],[5,"impl_item_to_string","","",N,[[["implitem"]],["string"]]],[5,"trait_item_to_string","","",N,[[["traititem"]],["string"]]],[5,"generic_params_to_string","","",N,N],[5,"where_clause_to_string","","",N,[[["whereclause"]],["string"]]],[5,"fn_block_to_string","","",N,[[["fndecl"]],["string"]]],[5,"path_to_string","","",N,[[["path"]],["string"]]],[5,"path_segment_to_string","","",N,[[["pathsegment"]],["string"]]],[5,"ident_to_string","","",N,[[["ident"]],["string"]]],[5,"vis_to_string","","",N,[[["visibility"]],["string"]]],[5,"fun_to_string","","",N,[[["fndecl"],["fnheader"],["ident"],["generics"]],["string"]]],[5,"block_to_string","","",N,[[["block"]],["string"]]],[5,"meta_list_item_to_string","","",N,[[["nestedmetaitem"]],["string"]]],[5,"meta_item_to_string","","",N,[[["metaitem"]],["string"]]],[5,"attribute_to_string","","",N,[[["attribute"]],["string"]]],[5,"lit_to_string","","",N,[[["lit"]],["string"]]],[5,"variant_to_string","","",N,[[["variant"]],["string"]]],[5,"arg_to_string","","",N,[[["arg"]],["string"]]],[5,"mac_to_string","","",N,[[["mac"]],["string"]]],[5,"foreign_item_to_string","","",N,[[["foreignitem"]],["string"]]],[5,"visibility_qualified","","",N,[[["visibility"],["str"]],["string"]]],[17,"INDENT_UNIT","","",N,N],[17,"DEFAULT_COLUMNS","","",N,N],[8,"PpAnn","","",N,N],[11,"pre","","",274,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",274,[[["self"],["state"],["annnode"]],["result"]]],[8,"PrintState","","",N,N],[10,"writer","","",275,[[["self"]],["printer"]]],[10,"boxes","","",275,[[["self"]],["vec"]]],[10,"comments","","",275,[[["self"]],["option"]]],[10,"cur_cmnt","","",275,[[["self"]],["usize"]]],[10,"cur_lit","","",275,[[["self"]],["option",["literal"]]]],[10,"bump_lit","","",275,[[["self"]],["option",["literal"]]]],[11,"word_space","","",275,[[["self"],["str"]],["result"]]],[11,"popen","","",275,[[["self"]],["result"]]],[11,"pclose","","",275,[[["self"]],["result"]]],[11,"is_begin","","",275,[[["self"]],["bool"]]],[11,"is_end","","",275,[[["self"]],["bool"]]],[11,"is_bol","","",275,[[["self"]],["bool"]]],[11,"hardbreak_if_not_bol","","",275,[[["self"]],["result"]]],[11,"rbox","","",275,[[["self"],["usize"],["breaks"]],["result"]]],[11,"ibox","","",275,[[["self"],["usize"]],["result"]]],[11,"end","","",275,[[["self"]],["result"]]],[11,"commasep","","",275,N],[11,"next_lit","","",275,[[["self"],["bytepos"]],["option",["literal"]]]],[11,"maybe_print_comment","","",275,[[["self"],["bytepos"]],["result"]]],[11,"print_comment","","",275,[[["self"],["comment"]],["result"]]],[11,"next_comment","","",275,[[["self"]],["option",["comment"]]]],[11,"print_literal","","",275,[[["self"],["lit"]],["result"]]],[11,"print_string","","",275,[[["self"],["str"],["strstyle"]],["result"]]],[11,"print_inner_attributes","","",275,N],[11,"print_inner_attributes_no_trailing_hardbreak","","",275,N],[11,"print_outer_attributes","","",275,N],[11,"print_inner_attributes_inline","","",275,N],[11,"print_outer_attributes_inline","","",275,N],[11,"print_either_attributes","","",275,N],[11,"print_attribute_path","","",275,[[["self"],["path"]],["result"]]],[11,"print_attribute","","",275,[[["self"],["attribute"]],["result"]]],[11,"print_attribute_inline","","",275,[[["self"],["attribute"],["bool"]],["result"]]],[11,"print_meta_list_item","","",275,[[["self"],["nestedmetaitem"]],["result"]]],[11,"print_meta_item","","",275,[[["self"],["metaitem"]],["result"]]],[11,"print_tt","","This doesn't deserve to be called \"pretty\" printing, but it should be meaning-preserving. A quick hack that might help would be to look at the spans embedded in the TTs to decide where to put spaces and newlines. But it'd be better to parse these according to the grammar of the appropriate macro, transcribe back into the grammar we just parsed from, and then pretty-print the resulting AST nodes (so, e.g., we print expression arguments as expressions). It can be done! I think.",275,[[["self"],["tokentree"]],["result"]]],[11,"print_tts","","",275,[[["self"],["tokenstream"]],["result"]]],[11,"space_if_not_bol","","",275,[[["self"]],["result"]]],[11,"nbsp","","",275,[[["self"]],["result"]]],[11,"print_dollar_crate","","",275,[[["self"],["syntaxcontext"]],["result"]]],[11,"clone","","",276,[[["self"]],["noann"]]],[11,"new_from_input","","",272,[[["codemap"],["parsesess"],["filename"],["read"],["box",["write"]],["ppann"],["bool"]],["state"]]],[11,"new","","",272,[[["codemap"],["box",["write"]],["ppann"],["option",["vec"]],["option",["vec"]]],["state"]]],[11,"writer","","",272,[[["self"]],["printer"]]],[11,"boxes","","",272,[[["self"]],["vec"]]],[11,"comments","","",272,[[["self"]],["option"]]],[11,"cur_cmnt","","",272,[[["self"]],["usize"]]],[11,"cur_lit","","",272,[[["self"]],["option",["literal"]]]],[11,"bump_lit","","",272,[[["self"]],["option",["literal"]]]],[11,"cbox","","",272,[[["self"],["usize"]],["result"]]],[11,"word_nbsp","","",272,[[["self"],["str"]],["result"]]],[11,"head","","",272,[[["self"],["str"]],["result"]]],[11,"bopen","","",272,[[["self"]],["result"]]],[11,"bclose_","","",272,[[["self"],["span"],["usize"]],["result"]]],[11,"bclose_maybe_open","","",272,[[["self"],["span"],["usize"],["bool"]],["result"]]],[11,"bclose","","",272,[[["self"],["span"]],["result"]]],[11,"in_cbox","","",272,[[["self"]],["bool"]]],[11,"break_offset_if_not_bol","","",272,[[["self"],["usize"],["isize"]],["result"]]],[11,"synth_comment","","",272,[[["self"],["string"]],["result"]]],[11,"commasep_cmnt","","",272,N],[11,"commasep_exprs","","",272,N],[11,"print_mod","","",272,N],[11,"print_foreign_mod","","",272,N],[11,"print_opt_lifetime","","",272,[[["self"],["option"]],["result"]]],[11,"print_generic_arg","","",272,[[["self"],["genericarg"]],["result"]]],[11,"print_type","","",272,[[["self"],["ty"]],["result"]]],[11,"print_foreign_item","","",272,[[["self"],["foreignitem"]],["result"]]],[11,"print_associated_const","","",272,[[["self"],["ident"],["ty"],["option",["expr"]],["visibility"]],["result"]]],[11,"print_associated_type","","",272,[[["self"],["ident"],["option",["genericbounds"]],["option",["ty"]]],["result"]]],[11,"print_item","","Pretty-print an item",272,[[["self"],["item"]],["result"]]],[11,"print_trait_ref","","",272,[[["self"],["traitref"]],["result"]]],[11,"print_formal_generic_params","","",272,N],[11,"print_poly_trait_ref","","",272,[[["self"],["polytraitref"]],["result"]]],[11,"print_enum_def","","",272,[[["self"],["enumdef"],["generics"],["ident"],["span"],["visibility"]],["result"]]],[11,"print_variants","","",272,N],[11,"print_visibility","","",272,[[["self"],["visibility"]],["result"]]],[11,"print_defaultness","","",272,[[["self"],["defaultness"]],["result"]]],[11,"print_struct","","",272,[[["self"],["variantdata"],["generics"],["ident"],["span"],["bool"]],["result"]]],[11,"print_variant","","",272,[[["self"],["variant"]],["result"]]],[11,"print_method_sig","","",272,[[["self"],["ident"],["generics"],["methodsig"],["visibility"]],["result"]]],[11,"print_trait_item","","",272,[[["self"],["traititem"]],["result"]]],[11,"print_impl_item","","",272,[[["self"],["implitem"]],["result"]]],[11,"print_stmt","","",272,[[["self"],["stmt"]],["result"]]],[11,"print_block","","",272,[[["self"],["block"]],["result"]]],[11,"print_block_unclosed","","",272,[[["self"],["block"]],["result"]]],[11,"print_block_unclosed_with_attrs","","",272,N],[11,"print_block_unclosed_indent","","",272,[[["self"],["block"],["usize"]],["result"]]],[11,"print_block_with_attrs","","",272,N],[11,"print_block_maybe_unclosed","","",272,N],[11,"print_else","","",272,[[["self"],["option",["expr"]]],["result"]]],[11,"print_if","","",272,[[["self"],["expr"],["block"],["option",["expr"]]],["result"]]],[11,"print_if_let","","",272,N],[11,"print_mac","","",272,[[["self"],["mac"]],["result"]]],[11,"print_call_post","","",272,N],[11,"print_expr_maybe_paren","","",272,[[["self"],["expr"],["i8"]],["result"]]],[11,"print_expr_as_cond","","Print an expr using syntax that's acceptable in a condition position, such as the `cond` in `if cond { ... }`.",272,[[["self"],["expr"]],["result"]]],[11,"print_expr_vec","","",272,N],[11,"print_expr_repeat","","",272,N],[11,"print_expr_struct","","",272,N],[11,"print_expr_tup","","",272,N],[11,"print_expr_call","","",272,N],[11,"print_expr_method_call","","",272,N],[11,"print_expr_binary","","",272,[[["self"],["binop"],["expr"],["expr"]],["result"]]],[11,"print_expr_unary","","",272,[[["self"],["unop"],["expr"]],["result"]]],[11,"print_expr_addr_of","","",272,[[["self"],["mutability"],["expr"]],["result"]]],[11,"print_expr","","",272,[[["self"],["expr"]],["result"]]],[11,"print_expr_outer_attr_style","","",272,[[["self"],["expr"],["bool"]],["result"]]],[11,"print_local_decl","","",272,[[["self"],["local"]],["result"]]],[11,"print_ident","","",272,[[["self"],["ident"]],["result"]]],[11,"print_usize","","",272,[[["self"],["usize"]],["result"]]],[11,"print_name","","",272,[[["self"],["name"]],["result"]]],[11,"print_for_decl","","",272,[[["self"],["local"],["expr"]],["result"]]],[11,"print_path","","",272,[[["self"],["path"],["bool"],["usize"]],["result"]]],[11,"print_path_segment","","",272,[[["self"],["pathsegment"],["bool"]],["result"]]],[11,"print_qpath","","",272,[[["self"],["path"],["qself"],["bool"]],["result"]]],[11,"print_generic_args","","",272,[[["self"],["genericargs"],["bool"]],["result"]]],[11,"print_pat","","",272,[[["self"],["pat"]],["result"]]],[11,"print_pats","","",272,N],[11,"print_arm","","",272,[[["self"],["arm"]],["result"]]],[11,"print_explicit_self","","",272,[[["self"],["explicitself"]],["result"]]],[11,"print_fn","","",272,[[["self"],["fndecl"],["fnheader"],["option",["ident"]],["generics"],["visibility"]],["result"]]],[11,"print_fn_args_and_ret","","",272,[[["self"],["fndecl"]],["result"]]],[11,"print_fn_block_args","","",272,[[["self"],["fndecl"]],["result"]]],[11,"print_movability","","",272,[[["self"],["movability"]],["result"]]],[11,"print_asyncness","","",272,[[["self"],["isasync"]],["result"]]],[11,"print_capture_clause","","",272,[[["self"],["captureby"]],["result"]]],[11,"print_type_bounds","","",272,N],[11,"print_lifetime","","",272,[[["self"],["lifetime"]],["result"]]],[11,"print_lifetime_bounds","","",272,[[["self"],["lifetime"],["genericbounds"]],["result"]]],[11,"print_generic_params","","",272,N],[11,"print_where_clause","","",272,[[["self"],["whereclause"]],["result"]]],[11,"print_use_tree","","",272,[[["self"],["usetree"]],["result"]]],[11,"print_mutability","","",272,[[["self"],["mutability"]],["result"]]],[11,"print_mt","","",272,[[["self"],["mutty"]],["result"]]],[11,"print_arg","","",272,[[["self"],["arg"],["bool"]],["result"]]],[11,"print_fn_output","","",272,[[["self"],["fndecl"]],["result"]]],[11,"print_ty_fn","","",272,N],[11,"maybe_print_trailing_comment","","",272,[[["self"],["span"],["option",["bytepos"]]],["result"]]],[11,"print_remaining_comments","","",272,[[["self"]],["result"]]],[11,"print_opt_abi_and_extern_if_nondefault","","",272,[[["self"],["option",["abi"]]],["result"]]],[11,"print_extern_opt_abi","","",272,[[["self"],["option",["abi"]]],["result"]]],[11,"print_fn_header_info","","",272,[[["self"],["fnheader"],["visibility"]],["result"]]],[11,"print_unsafety","","",272,[[["self"],["unsafety"]],["result"]]],[11,"print_is_auto","","",272,[[["self"],["isauto"]],["result"]]],[0,"ext","syntax","",N,N],[0,"hygiene","syntax::ext","Machinery for hygienic macros, inspired by the `MTWT[1]` paper.",N,N],[3,"SyntaxContext","syntax::ext::hygiene","A SyntaxContext represents a chain of macro expansions (represented by marks).",N,N],[12,"0","","",159,N],[3,"Mark","","A mark is a unique id associated with a macro expansion.",N,N],[12,"0","","",160,N],[4,"Transparency","","A property of a macro expansion that determines how identifiers produced by that expansion are resolved.",N,N],[13,"Transparent","","Identifier produced by a transparent expansion is always resolved at call-site. Call-site spans in procedural macros, hygiene opt-out in `macro` should use this.",161,N],[13,"SemiTransparent","","Identifier produced by a semi-transparent expansion may be resolved either at call-site or at definition-site. If it's a local variable, label or `$crate` then it's resolved at def-site. Otherwise it's resolved at call-site. `macro_rules` macros behave like this, built-in macros currently behave like this too, but that's an implementation detail.",161,N],[13,"Opaque","","Identifier produced by an opaque expansion is always resolved at definition-site. Def-site spans in procedural macros, identifiers from `macro` by default use this.",161,N],[5,"default_edition","","",N,[[],["edition"]]],[5,"set_default_edition","","",N,N],[5,"clear_markings","","",N,N],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",N,N],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",162,N],[12,"def_site","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None. This span serves only informational purpose and is not used for resolution.",162,N],[12,"format","","The format with which the macro was invoked.",162,N],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",162,N],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",162,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",162,N],[12,"edition","","Edition of the crate in which the macro is defined.",162,N],[4,"ExpnFormat","","The source of expansion.",N,N],[13,"MacroAttribute","","e.g. #[derive(...)] ",163,N],[13,"MacroBang","","e.g. `format!()`",163,N],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",163,N],[4,"CompilerDesugaringKind","","The kind of compiler desugaring.",N,N],[13,"DotFill","","",164,N],[13,"QuestionMark","","",164,N],[13,"Catch","","",164,N],[13,"ExistentialReturnType","","Desugaring of an `impl Trait` in return type position to an `existential type Foo: Trait;` + replacing the `impl Trait` with `Foo`.",164,N],[13,"Async","","",164,N],[13,"ForLoop","","",164,N],[0,"base","syntax::ext","",N,N],[3,"MacEager","syntax::ext::base","`MacResult` implementation for the common case where you've already built each form of AST that you might return.",N,N],[12,"expr","","",277,N],[12,"pat","","",277,N],[12,"items","","",277,N],[12,"impl_items","","",277,N],[12,"trait_items","","",277,N],[12,"foreign_items","","",277,N],[12,"stmts","","",277,N],[12,"ty","","",277,N],[3,"DummyResult","","Fill-in macro expansion result, to allow compilation to continue after hitting errors.",N,N],[12,"expr_only","","",278,N],[12,"span","","",278,N],[3,"DummyResolver","","",N,N],[3,"ModuleData","","",N,N],[12,"mod_path","","",279,N],[12,"directory","","",279,N],[3,"ExpansionData","","",N,N],[12,"mark","","",280,N],[12,"depth","","",280,N],[12,"module","","",280,N],[12,"directory_ownership","","",280,N],[12,"crate_span","","",280,N],[3,"ExtCtxt","","One of these is made during expansion and incrementally updated as we go; when a macro expansion occurs, the resulting nodes have the `backtrace() -> expn_info` of their expansion context stored into their span.",N,N],[12,"parse_sess","","",281,N],[12,"ecfg","","",281,N],[12,"root_path","","",281,N],[12,"resolver","","",281,N],[12,"resolve_err_count","","",281,N],[12,"current_expansion","","",281,N],[12,"expansions","","",281,N],[4,"Annotatable","","",N,N],[13,"Item","","",282,N],[13,"TraitItem","","",282,N],[13,"ImplItem","","",282,N],[13,"ForeignItem","","",282,N],[13,"Stmt","","",282,N],[13,"Expr","","",282,N],[4,"MacroKind","","Represents different kinds of macro invocations that can be resolved.",N,N],[13,"Bang","","A bang macro - foo!()",283,N],[13,"Attr","","An attribute macro - #[foo]",283,N],[13,"Derive","","A derive attribute macro - #[derive(Foo)]",283,N],[13,"ProcMacroStub","","A view of a procedural macro from the same crate that defines it.",283,N],[4,"SyntaxExtension","","An enum representing the different kinds of syntax extensions.",N,N],[13,"MultiDecorator","","A syntax extension that is attached to an item and creates new items based upon it.",284,N],[13,"MultiModifier","","A syntax extension that is attached to an item and modifies it in-place. Also allows decoration, i.e., creating new items.",284,N],[13,"ProcMacro","","A function-like procedural macro. TokenStream -> TokenStream.",284,N],[12,"expander","syntax::ext::base::SyntaxExtension","",284,N],[12,"allow_internal_unstable","","",284,N],[12,"edition","","",284,N],[13,"AttrProcMacro","syntax::ext::base","An attribute-like procedural macro. TokenStream, TokenStream -> TokenStream. The first TokenSteam is the attribute, the second is the annotated item. Allows modification of the input items and adding new items, similar to MultiModifier, but uses TokenStreams, rather than AST nodes.",284,N],[13,"NormalTT","","A normal, function-like syntax extension.",284,N],[12,"expander","syntax::ext::base::SyntaxExtension","",284,N],[12,"def_info","","",284,N],[12,"allow_internal_unstable","","Whether the contents of the macro can directly use `#[unstable]` things (true == yes).",284,N],[12,"allow_internal_unsafe","","Whether the contents of the macro can use `unsafe` without triggering the `unsafe_code` lint.",284,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",284,N],[12,"unstable_feature","","The macro's feature name if it is unstable, and the stability feature",284,N],[12,"edition","","Edition of the crate in which the macro is defined",284,N],[13,"IdentTT","syntax::ext::base","A function-like syntax extension that has an extra ident before the block.",284,N],[13,"ProcMacroDerive","","An attribute-like procedural macro. TokenStream -> TokenStream. The input is the annotated item. Allows generating code to implement a Trait for a given struct or enum item.",284,N],[13,"BuiltinDerive","","An attribute-like procedural macro that derives a builtin trait.",284,N],[13,"DeclMacro","","A declarative macro, e.g. `macro m() {}`.",284,N],[12,"expander","syntax::ext::base::SyntaxExtension","",284,N],[12,"def_info","","",284,N],[12,"is_transparent","","",284,N],[12,"edition","","",284,N],[4,"Determinacy","syntax::ext::base","",N,N],[13,"Determined","","",285,N],[13,"Undetermined","","",285,N],[5,"expr_to_spanned_string","","Extract a string literal from the macro expanded version of `expr`, emitting `err_msg` if `expr` is not a string literal. This does not stop compilation on error, merely emits a non-fatal error and returns None.",N,[[["extctxt"],["p",["expr"]],["str"]],["result",["spanned","diagnosticbuilder"]]]],[5,"expr_to_string","","",N,[[["extctxt"],["p",["expr"]],["str"]],["option"]]],[5,"check_zero_tts","","Non-fatally assert that `tts` is empty. Note that this function returns even when `tts` is non-empty, macros that need to stop compilation should call `cx.parse_sess.span_diagnostic.abort_if_errors()` (this should be done as rarely as possible).",N,N],[5,"get_single_str_from_tts","","Interpreting `tts` as a comma-separated sequence of expressions, expect exactly one string literal, or emit an error and return None.",N,N],[5,"get_exprs_from_tts","","Extract comma-separated expressions from `tts`. If there is a parsing error, emit a non-fatal error and return None.",N,N],[6,"MacroExpanderFn","","",N,N],[6,"IdentMacroExpanderFn","","",N,N],[6,"BuiltinDeriveFn","","",N,N],[6,"NamedSyntaxExtension","","",N,N],[8,"MultiItemDecorator","","",N,N],[10,"expand","","",286,[[["self"],["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[8,"MultiItemModifier","","",N,N],[10,"expand","","",287,[[["self"],["extctxt"],["span"],["metaitem"],["annotatable"]],["vec",["annotatable"]]]],[8,"ProcMacro","","",N,N],[10,"expand","","",288,[[["self"],["extctxt"],["span"],["tokenstream"]],["tokenstream"]]],[8,"AttrProcMacro","","",N,N],[10,"expand","","",289,[[["self"],["extctxt"],["span"],["tokenstream"],["tokenstream"]],["tokenstream"]]],[8,"TTMacroExpander","","Represents a thing that maps token trees to Macro Results",N,N],[10,"expand","","",290,[[["self"],["extctxt"],["span"],["tokenstream"]],["box",["macresult"]]]],[8,"IdentMacroExpander","","",N,N],[10,"expand","","",291,[[["self"],["extctxt"],["span"],["ident"],["vec",["tokentree"]]],["box",["macresult"]]]],[8,"MacResult","","The result of a macro expansion. The return values of the various methods are spliced into the AST at the callsite of the macro.",N,N],[11,"make_expr","","Create an expression.",292,[[["box"]],["option",["p"]]]],[11,"make_items","","Create zero or more items.",292,[[["box"]],["option",["smallvector"]]]],[11,"make_impl_items","","Create zero or more impl items.",292,[[["box"]],["option",["smallvector"]]]],[11,"make_trait_items","","Create zero or more trait items.",292,[[["box"]],["option",["smallvector"]]]],[11,"make_foreign_items","","Create zero or more items in an `extern {}` block",292,[[["box"]],["option",["smallvector"]]]],[11,"make_pat","","Create a pattern.",292,[[["box"]],["option",["p"]]]],[11,"make_stmts","","Create zero or more statements.",292,[[["box"]],["option",["smallvector"]]]],[11,"make_ty","","",292,[[["box"]],["option",["p"]]]],[8,"Resolver","","",N,N],[10,"next_node_id","","",293,[[["self"]],["nodeid"]]],[10,"get_module_scope","","",293,[[["self"],["nodeid"]],["mark"]]],[10,"eliminate_crate_var","","",293,[[["self"],["p",["item"]]],["p",["item"]]]],[10,"is_whitelisted_legacy_custom_derive","","",293,[[["self"],["name"]],["bool"]]],[10,"visit_ast_fragment_with_placeholders","","",293,N],[10,"add_builtin","","",293,[[["self"],["ident"],["lrc",["syntaxextension"]]]]],[10,"resolve_imports","","",293,[[["self"]]]],[10,"find_legacy_attr_invoc","","",293,[[["self"],["vec"],["bool"]],["option",["attribute"]]]],[10,"resolve_invoc","","",293,[[["self"],["invocation"],["mark"],["bool"]],["result",["option","determinacy"]]]],[10,"resolve_macro","","",293,[[["self"],["mark"],["path"],["macrokind"],["bool"]],["result",["lrc","determinacy"]]]],[10,"check_unused_macros","","",293,[[["self"]]]],[11,"fmt","","",282,[[["self"],["formatter"]],["result"]]],[11,"clone","","",282,[[["self"]],["annotatable"]]],[11,"attrs","","",282,N],[11,"map_attrs","","",282,[[["self"],["f"]],["self"]]],[11,"span","","",282,[[["self"]],["span"]]],[11,"expect_item","","",282,[[["self"]],["p",["item"]]]],[11,"map_item_or","","",282,[[["self"],["f"],["g"]],["annotatable"]]],[11,"expect_trait_item","","",282,[[["self"]],["traititem"]]],[11,"expect_impl_item","","",282,[[["self"]],["implitem"]]],[11,"expect_foreign_item","","",282,[[["self"]],["foreignitem"]]],[11,"expect_stmt","","",282,[[["self"]],["stmt"]]],[11,"expect_expr","","",282,[[["self"]],["p",["expr"]]]],[11,"derive_allowed","","",282,[[["self"]],["bool"]]],[11,"into","","",282,[[["self"]],["vec",["annotatable"]]]],[11,"default","","",277,[[],["maceager"]]],[11,"expr","","",277,[[["p",["expr"]]],["box",["macresult"]]]],[11,"pat","","",277,[[["p",["pat"]]],["box",["macresult"]]]],[11,"items","","",277,[[["smallvector",["p"]]],["box",["macresult"]]]],[11,"impl_items","","",277,[[["smallvector",["implitem"]]],["box",["macresult"]]]],[11,"trait_items","","",277,[[["smallvector",["traititem"]]],["box",["macresult"]]]],[11,"foreign_items","","",277,[[["smallvector",["foreignitem"]]],["box",["macresult"]]]],[11,"stmts","","",277,[[["smallvector",["stmt"]]],["box",["macresult"]]]],[11,"ty","","",277,[[["p",["ty"]]],["box",["macresult"]]]],[11,"make_expr","","",277,[[["box"]],["option",["p"]]]],[11,"make_items","","",277,[[["box"]],["option",["smallvector"]]]],[11,"make_impl_items","","",277,[[["box"]],["option",["smallvector"]]]],[11,"make_trait_items","","",277,[[["box"]],["option",["smallvector"]]]],[11,"make_foreign_items","","",277,[[["box"]],["option",["smallvector"]]]],[11,"make_stmts","","",277,[[["box"]],["option",["smallvector"]]]],[11,"make_pat","","",277,[[["box"]],["option",["p"]]]],[11,"make_ty","","",277,[[["box"]],["option",["p"]]]],[11,"clone","","",278,[[["self"]],["dummyresult"]]],[11,"any","","Create a default MacResult that can be anything.",278,[[["span"]],["box",["macresult"]]]],[11,"expr","","Create a default MacResult that can only be an expression.",278,[[["span"]],["box",["macresult"]]]],[11,"raw_expr","","A plain dummy expression.",278,[[["span"]],["p",["expr"]]]],[11,"raw_pat","","A plain dummy pattern.",278,[[["span"]],["pat"]]],[11,"raw_ty","","",278,[[["span"]],["p",["ty"]]]],[11,"make_expr","","",278,[[["box",["dummyresult"]]],["option",["p"]]]],[11,"make_pat","","",278,[[["box",["dummyresult"]]],["option",["p"]]]],[11,"make_items","","",278,[[["box",["dummyresult"]]],["option",["smallvector"]]]],[11,"make_impl_items","","",278,[[["box",["dummyresult"]]],["option",["smallvector"]]]],[11,"make_trait_items","","",278,[[["box",["dummyresult"]]],["option",["smallvector"]]]],[11,"make_foreign_items","","",278,[[["box"]],["option",["smallvector"]]]],[11,"make_stmts","","",278,[[["box",["dummyresult"]]],["option",["smallvector"]]]],[11,"make_ty","","",278,[[["box",["dummyresult"]]],["option",["p"]]]],[11,"clone","","",283,[[["self"]],["macrokind"]]],[11,"eq","","",283,[[["self"],["macrokind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",283,N],[11,"encode","","",283,[[["self"],["__s"]],["result"]]],[11,"decode","","",283,[[["__d"]],["result",["macrokind"]]]],[11,"hash","","",283,N],[11,"fmt","","",283,[[["self"],["formatter"]],["result"]]],[11,"descr","","",283,[[["self"]],["str"]]],[11,"kind","","Return which kind of macro calls this syntax extension.",284,[[["self"]],["macrokind"]]],[11,"default_transparency","","",284,[[["self"]],["transparency"]]],[11,"edition","","",284,[[["self"]],["edition"]]],[11,"clone","","",285,[[["self"]],["determinacy"]]],[11,"eq","","",285,[[["self"],["determinacy"]],["bool"]]],[11,"fmt","","",285,[[["self"],["formatter"]],["result"]]],[11,"next_node_id","","",294,[[["self"]],["nodeid"]]],[11,"get_module_scope","","",294,[[["self"],["nodeid"]],["mark"]]],[11,"eliminate_crate_var","","",294,[[["self"],["p",["item"]]],["p",["item"]]]],[11,"is_whitelisted_legacy_custom_derive","","",294,[[["self"],["name"]],["bool"]]],[11,"visit_ast_fragment_with_placeholders","","",294,N],[11,"add_builtin","","",294,[[["self"],["ident"],["lrc",["syntaxextension"]]]]],[11,"resolve_imports","","",294,[[["self"]]]],[11,"find_legacy_attr_invoc","","",294,[[["self"],["vec"],["bool"]],["option",["attribute"]]]],[11,"resolve_invoc","","",294,[[["self"],["invocation"],["mark"],["bool"]],["result",["option","determinacy"]]]],[11,"resolve_macro","","",294,[[["self"],["mark"],["path"],["macrokind"],["bool"]],["result",["lrc","determinacy"]]]],[11,"check_unused_macros","","",294,[[["self"]]]],[11,"clone","","",279,[[["self"]],["moduledata"]]],[11,"clone","","",280,[[["self"]],["expansiondata"]]],[11,"new","","",281,[[["parsesess"],["expansionconfig"],["resolver"]],["extctxt"]]],[11,"expander","","Returns a `Folder` for deeply expanding all macros in an AST node.",281,[[["self"]],["macroexpander"]]],[11,"monotonic_expander","","Returns a `Folder` that deeply expands all macros and assigns all node ids in an AST node. Once node ids are assigned, the node may not be expanded, removed, or otherwise modified.",281,[[["self"]],["macroexpander"]]],[11,"new_parser_from_tts","","",281,N],[11,"codemap","","",281,[[["self"]],["codemap"]]],[11,"parse_sess","","",281,[[["self"]],["parsesess"]]],[11,"cfg","","",281,[[["self"]],["crateconfig"]]],[11,"call_site","","",281,[[["self"]],["span"]]],[11,"backtrace","","",281,[[["self"]],["syntaxcontext"]]],[11,"expansion_cause","","Returns span for the macro which originally caused the current expansion to happen.",281,[[["self"]],["option",["span"]]]],[11,"struct_span_warn","","",281,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err","","",281,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_fatal","","",281,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_fatal","","Emit `msg` attached to `sp`, and stop compilation immediately.",281,N],[11,"span_err","","Emit `msg` attached to `sp`, without immediately stopping compilation.",281,[[["self"],["s"],["str"]]]],[11,"span_err_with_code","","",281,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"mut_span_err","","",281,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_warn","","",281,[[["self"],["s"],["str"]]]],[11,"span_unimpl","","",281,N],[11,"span_bug","","",281,N],[11,"trace_macros_diag","","",281,[[["self"]]]],[11,"bug","","",281,N],[11,"trace_macros","","",281,[[["self"]],["bool"]]],[11,"set_trace_macros","","",281,[[["self"],["bool"]]]],[11,"ident_of","","",281,[[["self"],["str"]],["ident"]]],[11,"std_path","","",281,N],[11,"name_of","","",281,[[["self"],["str"]],["name"]]],[11,"check_unused_macros","","",281,[[["self"]]]],[0,"build","syntax::ext","",N,N],[0,"syntax","syntax::ext::build","",N,N],[8,"AstBuilder","","",N,N],[10,"path","","",295,[[["self"],["span"],["vec",["ident"]]],["path"]]],[10,"path_ident","","",295,[[["self"],["span"],["ident"]],["path"]]],[10,"path_global","","",295,[[["self"],["span"],["vec",["ident"]]],["path"]]],[10,"path_all","","",295,[[["self"],["span"],["bool"],["vec",["ident"]],["vec",["genericarg"]],["vec",["typebinding"]]],["path"]]],[10,"qpath","","",295,N],[10,"qpath_all","","",295,N],[10,"ty_mt","","",295,[[["self"],["p",["ty"]],["mutability"]],["mutty"]]],[10,"ty","","",295,[[["self"],["span"],["tykind"]],["p",["ty"]]]],[10,"ty_path","","",295,[[["self"],["path"]],["p",["ty"]]]],[10,"ty_ident","","",295,[[["self"],["span"],["ident"]],["p",["ty"]]]],[10,"ty_rptr","","",295,[[["self"],["span"],["p",["ty"]],["option",["lifetime"]],["mutability"]],["p",["ty"]]]],[10,"ty_ptr","","",295,[[["self"],["span"],["p",["ty"]],["mutability"]],["p",["ty"]]]],[10,"ty_option","","",295,[[["self"],["p",["ty"]]],["p",["ty"]]]],[10,"ty_infer","","",295,[[["self"],["span"]],["p",["ty"]]]],[10,"typaram","","",295,[[["self"],["span"],["ident"],["vec",["attribute"]],["genericbounds"],["option",["p"]]],["genericparam"]]],[10,"trait_ref","","",295,[[["self"],["path"]],["traitref"]]],[10,"poly_trait_ref","","",295,[[["self"],["span"],["path"]],["polytraitref"]]],[10,"trait_bound","","",295,[[["self"],["path"]],["genericbound"]]],[10,"lifetime","","",295,[[["self"],["span"],["ident"]],["lifetime"]]],[10,"lifetime_def","","",295,[[["self"],["span"],["ident"],["vec",["attribute"]],["genericbounds"]],["genericparam"]]],[10,"stmt_expr","","",295,[[["self"],["p",["expr"]]],["stmt"]]],[10,"stmt_semi","","",295,[[["self"],["p",["expr"]]],["stmt"]]],[10,"stmt_let","","",295,[[["self"],["span"],["bool"],["ident"],["p",["expr"]]],["stmt"]]],[10,"stmt_let_typed","","",295,[[["self"],["span"],["bool"],["ident"],["p",["ty"]],["p",["expr"]]],["stmt"]]],[10,"stmt_let_type_only","","",295,[[["self"],["span"],["p",["ty"]]],["stmt"]]],[10,"stmt_item","","",295,[[["self"],["span"],["p",["item"]]],["stmt"]]],[10,"block","","",295,[[["self"],["span"],["vec",["stmt"]]],["p",["block"]]]],[10,"block_expr","","",295,[[["self"],["p",["expr"]]],["p",["block"]]]],[10,"expr","","",295,[[["self"],["span"],["exprkind"]],["p",["expr"]]]],[10,"expr_path","","",295,[[["self"],["path"]],["p",["expr"]]]],[10,"expr_qpath","","",295,[[["self"],["span"],["qself"],["path"]],["p",["expr"]]]],[10,"expr_ident","","",295,[[["self"],["span"],["ident"]],["p",["expr"]]]],[10,"expr_self","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_binary","","",295,[[["self"],["span"],["binopkind"],["p",["expr"]],["p",["expr"]]],["p",["expr"]]]],[10,"expr_deref","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_unary","","",295,[[["self"],["span"],["unop"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_addr_of","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_mut_addr_of","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_field_access","","",295,[[["self"],["span"],["p",["expr"]],["ident"]],["p",["expr"]]]],[10,"expr_tup_field_access","","",295,[[["self"],["span"],["p",["expr"]],["usize"]],["p",["expr"]]]],[10,"expr_call","","",295,[[["self"],["span"],["p",["expr"]],["vec",["p"]]],["p",["expr"]]]],[10,"expr_call_ident","","",295,[[["self"],["span"],["ident"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_call_global","","",295,[[["self"],["span"],["vec",["ident"]],["vec",["p"]]],["p",["expr"]]]],[10,"expr_method_call","","",295,[[["self"],["span"],["p",["expr"]],["ident"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_block","","",295,[[["self"],["p",["block"]]],["p",["expr"]]]],[10,"expr_cast","","",295,[[["self"],["span"],["p",["expr"]],["p",["ty"]]],["p",["expr"]]]],[10,"field_imm","","",295,[[["self"],["span"],["ident"],["p",["expr"]]],["field"]]],[10,"expr_struct","","",295,[[["self"],["span"],["path"],["vec",["field"]]],["p",["expr"]]]],[10,"expr_struct_ident","","",295,[[["self"],["span"],["ident"],["vec",["field"]]],["p",["expr"]]]],[10,"expr_lit","","",295,[[["self"],["span"],["litkind"]],["p",["expr"]]]],[10,"expr_usize","","",295,[[["self"],["span"],["usize"]],["p",["expr"]]]],[10,"expr_isize","","",295,[[["self"],["span"],["isize"]],["p",["expr"]]]],[10,"expr_u8","","",295,[[["self"],["span"],["u8"]],["p",["expr"]]]],[10,"expr_u16","","",295,[[["self"],["span"],["u16"]],["p",["expr"]]]],[10,"expr_u32","","",295,[[["self"],["span"],["u32"]],["p",["expr"]]]],[10,"expr_bool","","",295,[[["self"],["span"],["bool"]],["p",["expr"]]]],[10,"expr_vec","","",295,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_vec_ng","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_vec_slice","","",295,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_str","","",295,[[["self"],["span"],["symbol"]],["p",["expr"]]]],[10,"expr_some","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_none","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_break","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_tuple","","",295,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_fail","","",295,[[["self"],["span"],["symbol"]],["p",["expr"]]]],[10,"expr_unreachable","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_ok","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_err","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_try","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"pat","","",295,[[["self"],["span"],["patkind"]],["p",["pat"]]]],[10,"pat_wild","","",295,[[["self"],["span"]],["p",["pat"]]]],[10,"pat_lit","","",295,[[["self"],["span"],["p",["expr"]]],["p",["pat"]]]],[10,"pat_ident","","",295,[[["self"],["span"],["ident"]],["p",["pat"]]]],[10,"pat_ident_binding_mode","","",295,[[["self"],["span"],["ident"],["bindingmode"]],["p",["pat"]]]],[10,"pat_path","","",295,[[["self"],["span"],["path"]],["p",["pat"]]]],[10,"pat_tuple_struct","","",295,[[["self"],["span"],["path"],["vec",["p"]]],["p",["pat"]]]],[10,"pat_struct","","",295,[[["self"],["span"],["path"],["vec",["spanned"]]],["p",["pat"]]]],[10,"pat_tuple","","",295,[[["self"],["span"],["vec",["p"]]],["p",["pat"]]]],[10,"pat_some","","",295,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[10,"pat_none","","",295,[[["self"],["span"]],["p",["pat"]]]],[10,"pat_ok","","",295,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[10,"pat_err","","",295,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[10,"arm","","",295,[[["self"],["span"],["vec",["p"]],["p",["expr"]]],["arm"]]],[10,"arm_unreachable","","",295,[[["self"],["span"]],["arm"]]],[10,"expr_match","","",295,[[["self"],["span"],["p",["expr"]],["vec",["arm"]]],["p",["expr"]]]],[10,"expr_if","","",295,[[["self"],["span"],["p",["expr"]],["p",["expr"]],["option",["p"]]],["p",["expr"]]]],[10,"expr_loop","","",295,[[["self"],["span"],["p",["block"]]],["p",["expr"]]]],[10,"lambda_fn_decl","","",295,[[["self"],["span"],["p",["fndecl"]],["p",["expr"]],["span"]],["p",["expr"]]]],[10,"lambda","","",295,[[["self"],["span"],["vec",["ident"]],["p",["expr"]]],["p",["expr"]]]],[10,"lambda0","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"lambda1","","",295,[[["self"],["span"],["p",["expr"]],["ident"]],["p",["expr"]]]],[10,"lambda_stmts","","",295,[[["self"],["span"],["vec",["ident"]],["vec",["stmt"]]],["p",["expr"]]]],[10,"lambda_stmts_0","","",295,[[["self"],["span"],["vec",["stmt"]]],["p",["expr"]]]],[10,"lambda_stmts_1","","",295,[[["self"],["span"],["vec",["stmt"]],["ident"]],["p",["expr"]]]],[10,"item","","",295,[[["self"],["span"],["ident"],["vec",["attribute"]],["itemkind"]],["p",["item"]]]],[10,"arg","","",295,[[["self"],["span"],["ident"],["p",["ty"]]],["arg"]]],[10,"fn_decl","","",295,[[["self"],["vec",["arg"]],["functionretty"]],["p",["fndecl"]]]],[10,"item_fn_poly","","",295,[[["self"],["span"],["ident"],["vec",["arg"]],["p",["ty"]],["generics"],["p",["block"]]],["p",["item"]]]],[10,"item_fn","","",295,[[["self"],["span"],["ident"],["vec",["arg"]],["p",["ty"]],["p",["block"]]],["p",["item"]]]],[10,"variant","","",295,[[["self"],["span"],["ident"],["vec",["p"]]],["variant"]]],[10,"item_enum_poly","","",295,[[["self"],["span"],["ident"],["enumdef"],["generics"]],["p",["item"]]]],[10,"item_enum","","",295,[[["self"],["span"],["ident"],["enumdef"]],["p",["item"]]]],[10,"item_struct_poly","","",295,[[["self"],["span"],["ident"],["variantdata"],["generics"]],["p",["item"]]]],[10,"item_struct","","",295,[[["self"],["span"],["ident"],["variantdata"]],["p",["item"]]]],[10,"item_mod","","",295,[[["self"],["span"],["span"],["ident"],["vec",["attribute"]],["vec",["p"]]],["p",["item"]]]],[10,"item_extern_crate","","",295,[[["self"],["span"],["ident"]],["p",["item"]]]],[10,"item_static","","",295,[[["self"],["span"],["ident"],["p",["ty"]],["mutability"],["p",["expr"]]],["p",["item"]]]],[10,"item_const","","",295,[[["self"],["span"],["ident"],["p",["ty"]],["p",["expr"]]],["p",["item"]]]],[10,"item_ty_poly","","",295,[[["self"],["span"],["ident"],["p",["ty"]],["generics"]],["p",["item"]]]],[10,"item_ty","","",295,[[["self"],["span"],["ident"],["p",["ty"]]],["p",["item"]]]],[10,"attribute","","",295,[[["self"],["span"],["metaitem"]],["attribute"]]],[10,"meta_word","","",295,[[["self"],["span"],["name"]],["metaitem"]]],[10,"meta_list_item_word","","",295,[[["self"],["span"],["name"]],["nestedmetaitem"]]],[10,"meta_list","","",295,[[["self"],["span"],["name"],["vec",["nestedmetaitem"]]],["metaitem"]]],[10,"meta_name_value","","",295,[[["self"],["span"],["name"],["litkind"]],["metaitem"]]],[10,"item_use","","",295,[[["self"],["span"],["visibility"],["p",["usetree"]]],["p",["item"]]]],[10,"item_use_simple","","",295,[[["self"],["span"],["visibility"],["path"]],["p",["item"]]]],[10,"item_use_simple_","","",295,[[["self"],["span"],["visibility"],["option",["ident"]],["path"]],["p",["item"]]]],[10,"item_use_list","","",295,N],[10,"item_use_glob","","",295,[[["self"],["span"],["visibility"],["vec",["ident"]]],["p",["item"]]]],[11,"path","syntax::ext::base","",281,[[["self"],["span"],["vec",["ident"]]],["path"]]],[11,"path_ident","","",281,[[["self"],["span"],["ident"]],["path"]]],[11,"path_global","","",281,[[["self"],["span"],["vec",["ident"]]],["path"]]],[11,"path_all","","",281,[[["self"],["span"],["bool"],["vec",["ident"]],["vec",["genericarg"]],["vec",["typebinding"]]],["path"]]],[11,"qpath","","Constructs a qualified path.",281,N],[11,"qpath_all","","Constructs a qualified path.",281,N],[11,"ty_mt","","",281,[[["self"],["p",["ty"]],["mutability"]],["mutty"]]],[11,"ty","","",281,[[["self"],["span"],["tykind"]],["p",["ty"]]]],[11,"ty_path","","",281,[[["self"],["path"]],["p",["ty"]]]],[11,"ty_ident","","",281,[[["self"],["span"],["ident"]],["p",["ty"]]]],[11,"ty_rptr","","",281,[[["self"],["span"],["p",["ty"]],["option",["lifetime"]],["mutability"]],["p",["ty"]]]],[11,"ty_ptr","","",281,[[["self"],["span"],["p",["ty"]],["mutability"]],["p",["ty"]]]],[11,"ty_option","","",281,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"ty_infer","","",281,[[["self"],["span"]],["p",["ty"]]]],[11,"typaram","","",281,[[["self"],["span"],["ident"],["vec",["attribute"]],["genericbounds"],["option",["p"]]],["genericparam"]]],[11,"trait_ref","","",281,[[["self"],["path"]],["traitref"]]],[11,"poly_trait_ref","","",281,[[["self"],["span"],["path"]],["polytraitref"]]],[11,"trait_bound","","",281,[[["self"],["path"]],["genericbound"]]],[11,"lifetime","","",281,[[["self"],["span"],["ident"]],["lifetime"]]],[11,"lifetime_def","","",281,[[["self"],["span"],["ident"],["vec",["attribute"]],["genericbounds"]],["genericparam"]]],[11,"stmt_expr","","",281,[[["self"],["p",["expr"]]],["stmt"]]],[11,"stmt_semi","","",281,[[["self"],["p",["expr"]]],["stmt"]]],[11,"stmt_let","","",281,[[["self"],["span"],["bool"],["ident"],["p",["expr"]]],["stmt"]]],[11,"stmt_let_typed","","",281,[[["self"],["span"],["bool"],["ident"],["p",["ty"]],["p",["expr"]]],["stmt"]]],[11,"stmt_let_type_only","","",281,[[["self"],["span"],["p",["ty"]]],["stmt"]]],[11,"stmt_item","","",281,[[["self"],["span"],["p",["item"]]],["stmt"]]],[11,"block_expr","","",281,[[["self"],["p",["expr"]]],["p",["block"]]]],[11,"block","","",281,[[["self"],["span"],["vec",["stmt"]]],["p",["block"]]]],[11,"expr","","",281,[[["self"],["span"],["exprkind"]],["p",["expr"]]]],[11,"expr_path","","",281,[[["self"],["path"]],["p",["expr"]]]],[11,"expr_qpath","","Constructs a QPath expression.",281,[[["self"],["span"],["qself"],["path"]],["p",["expr"]]]],[11,"expr_ident","","",281,[[["self"],["span"],["ident"]],["p",["expr"]]]],[11,"expr_self","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_binary","","",281,[[["self"],["span"],["binopkind"],["p",["expr"]],["p",["expr"]]],["p",["expr"]]]],[11,"expr_deref","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_unary","","",281,[[["self"],["span"],["unop"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_field_access","","",281,[[["self"],["span"],["p",["expr"]],["ident"]],["p",["expr"]]]],[11,"expr_tup_field_access","","",281,[[["self"],["span"],["p",["expr"]],["usize"]],["p",["expr"]]]],[11,"expr_addr_of","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_mut_addr_of","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_call","","",281,[[["self"],["span"],["p",["expr"]],["vec",["p"]]],["p",["expr"]]]],[11,"expr_call_ident","","",281,[[["self"],["span"],["ident"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_call_global","","",281,[[["self"],["span"],["vec",["ident"]],["vec",["p"]]],["p",["expr"]]]],[11,"expr_method_call","","",281,[[["self"],["span"],["p",["expr"]],["ident"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_block","","",281,[[["self"],["p",["block"]]],["p",["expr"]]]],[11,"field_imm","","",281,[[["self"],["span"],["ident"],["p",["expr"]]],["field"]]],[11,"expr_struct","","",281,[[["self"],["span"],["path"],["vec",["field"]]],["p",["expr"]]]],[11,"expr_struct_ident","","",281,[[["self"],["span"],["ident"],["vec",["field"]]],["p",["expr"]]]],[11,"expr_lit","","",281,[[["self"],["span"],["litkind"]],["p",["expr"]]]],[11,"expr_usize","","",281,[[["self"],["span"],["usize"]],["p",["expr"]]]],[11,"expr_isize","","",281,[[["self"],["span"],["isize"]],["p",["expr"]]]],[11,"expr_u32","","",281,[[["self"],["span"],["u32"]],["p",["expr"]]]],[11,"expr_u16","","",281,[[["self"],["span"],["u16"]],["p",["expr"]]]],[11,"expr_u8","","",281,[[["self"],["span"],["u8"]],["p",["expr"]]]],[11,"expr_bool","","",281,[[["self"],["span"],["bool"]],["p",["expr"]]]],[11,"expr_vec","","",281,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_vec_ng","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_vec_slice","","",281,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_str","","",281,[[["self"],["span"],["symbol"]],["p",["expr"]]]],[11,"expr_cast","","",281,[[["self"],["span"],["p",["expr"]],["p",["ty"]]],["p",["expr"]]]],[11,"expr_some","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_none","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_break","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_tuple","","",281,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_fail","","",281,[[["self"],["span"],["symbol"]],["p",["expr"]]]],[11,"expr_unreachable","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_ok","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_err","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_try","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"pat","","",281,[[["self"],["span"],["patkind"]],["p",["pat"]]]],[11,"pat_wild","","",281,[[["self"],["span"]],["p",["pat"]]]],[11,"pat_lit","","",281,[[["self"],["span"],["p",["expr"]]],["p",["pat"]]]],[11,"pat_ident","","",281,[[["self"],["span"],["ident"]],["p",["pat"]]]],[11,"pat_ident_binding_mode","","",281,[[["self"],["span"],["ident"],["bindingmode"]],["p",["pat"]]]],[11,"pat_path","","",281,[[["self"],["span"],["path"]],["p",["pat"]]]],[11,"pat_tuple_struct","","",281,[[["self"],["span"],["path"],["vec",["p"]]],["p",["pat"]]]],[11,"pat_struct","","",281,[[["self"],["span"],["path"],["vec",["spanned"]]],["p",["pat"]]]],[11,"pat_tuple","","",281,[[["self"],["span"],["vec",["p"]]],["p",["pat"]]]],[11,"pat_some","","",281,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_none","","",281,[[["self"],["span"]],["p",["pat"]]]],[11,"pat_ok","","",281,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_err","","",281,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"arm","","",281,[[["self"],["span"],["vec",["p"]],["p",["expr"]]],["arm"]]],[11,"arm_unreachable","","",281,[[["self"],["span"]],["arm"]]],[11,"expr_match","","",281,[[["self"],["span"],["p",["expr"]],["vec",["arm"]]],["p",["expr"]]]],[11,"expr_if","","",281,[[["self"],["span"],["p",["expr"]],["p",["expr"]],["option",["p"]]],["p",["expr"]]]],[11,"expr_loop","","",281,[[["self"],["span"],["p",["block"]]],["p",["expr"]]]],[11,"lambda_fn_decl","","",281,[[["self"],["span"],["p",["fndecl"]],["p",["expr"]],["span"]],["p",["expr"]]]],[11,"lambda","","",281,[[["self"],["span"],["vec",["ident"]],["p",["expr"]]],["p",["expr"]]]],[11,"lambda0","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"lambda1","","",281,[[["self"],["span"],["p",["expr"]],["ident"]],["p",["expr"]]]],[11,"lambda_stmts","","",281,[[["self"],["span"],["vec",["ident"]],["vec",["stmt"]]],["p",["expr"]]]],[11,"lambda_stmts_0","","",281,[[["self"],["span"],["vec",["stmt"]]],["p",["expr"]]]],[11,"lambda_stmts_1","","",281,[[["self"],["span"],["vec",["stmt"]],["ident"]],["p",["expr"]]]],[11,"arg","","",281,[[["self"],["span"],["ident"],["p",["ty"]]],["arg"]]],[11,"fn_decl","","",281,[[["self"],["vec",["arg"]],["functionretty"]],["p",["fndecl"]]]],[11,"item","","",281,[[["self"],["span"],["ident"],["vec",["attribute"]],["itemkind"]],["p",["item"]]]],[11,"item_fn_poly","","",281,[[["self"],["span"],["ident"],["vec",["arg"]],["p",["ty"]],["generics"],["p",["block"]]],["p",["item"]]]],[11,"item_fn","","",281,[[["self"],["span"],["ident"],["vec",["arg"]],["p",["ty"]],["p",["block"]]],["p",["item"]]]],[11,"variant","","",281,[[["self"],["span"],["ident"],["vec",["p"]]],["variant"]]],[11,"item_enum_poly","","",281,[[["self"],["span"],["ident"],["enumdef"],["generics"]],["p",["item"]]]],[11,"item_enum","","",281,[[["self"],["span"],["ident"],["enumdef"]],["p",["item"]]]],[11,"item_struct","","",281,[[["self"],["span"],["ident"],["variantdata"]],["p",["item"]]]],[11,"item_struct_poly","","",281,[[["self"],["span"],["ident"],["variantdata"],["generics"]],["p",["item"]]]],[11,"item_mod","","",281,[[["self"],["span"],["span"],["ident"],["vec",["attribute"]],["vec",["p"]]],["p",["item"]]]],[11,"item_extern_crate","","",281,[[["self"],["span"],["ident"]],["p",["item"]]]],[11,"item_static","","",281,[[["self"],["span"],["ident"],["p",["ty"]],["mutability"],["p",["expr"]]],["p",["item"]]]],[11,"item_const","","",281,[[["self"],["span"],["ident"],["p",["ty"]],["p",["expr"]]],["p",["item"]]]],[11,"item_ty_poly","","",281,[[["self"],["span"],["ident"],["p",["ty"]],["generics"]],["p",["item"]]]],[11,"item_ty","","",281,[[["self"],["span"],["ident"],["p",["ty"]]],["p",["item"]]]],[11,"attribute","","",281,[[["self"],["span"],["metaitem"]],["attribute"]]],[11,"meta_word","","",281,[[["self"],["span"],["name"]],["metaitem"]]],[11,"meta_list_item_word","","",281,[[["self"],["span"],["name"]],["nestedmetaitem"]]],[11,"meta_list","","",281,[[["self"],["span"],["name"],["vec",["nestedmetaitem"]]],["metaitem"]]],[11,"meta_name_value","","",281,[[["self"],["span"],["name"],["litkind"]],["metaitem"]]],[11,"item_use","","",281,[[["self"],["span"],["visibility"],["p",["usetree"]]],["p",["item"]]]],[11,"item_use_simple","","",281,[[["self"],["span"],["visibility"],["path"]],["p",["item"]]]],[11,"item_use_simple_","","",281,[[["self"],["span"],["visibility"],["option",["ident"]],["path"]],["p",["item"]]]],[11,"item_use_list","","",281,N],[11,"item_use_glob","","",281,[[["self"],["span"],["visibility"],["vec",["ident"]]],["p",["item"]]]],[0,"derive","syntax::ext","",N,N],[5,"collect_derives","syntax::ext::derive","",N,[[["extctxt"],["vec"]],["vec",["path"]]]],[5,"add_derived_markers","","",N,N],[0,"expand","syntax::ext","",N,N],[3,"Invocation","syntax::ext::expand","",N,N],[12,"kind","","",296,N],[12,"fragment_kind","","",296,N],[12,"expansion_data","","",296,N],[3,"MacroExpander","","",N,N],[12,"cx","","",297,N],[12,"monotonic","","",297,N],[3,"InvocationCollector","","",N,N],[12,"cx","","",298,N],[12,"cfg","","",298,N],[12,"invocations","","",298,N],[12,"monotonic","","",298,N],[3,"ExpansionConfig","","",N,N],[12,"crate_name","","",299,N],[12,"features","","",299,N],[12,"recursion_limit","","",299,N],[12,"trace_mac","","",299,N],[12,"should_test","","",299,N],[12,"single_step","","",299,N],[12,"keep_macs","","",299,N],[3,"Marker","","",N,N],[12,"0","","",300,N],[4,"AstFragment","","A fragment of AST that can be produced by a single macro expansion. Can also serve as an input and intermediate result for macro expansion operations.",N,N],[13,"OptExpr","","",301,N],[13,"Expr","","",301,N],[13,"Pat","","",301,N],[13,"Ty","","",301,N],[13,"Stmts","","",301,N],[13,"Items","","",301,N],[13,"TraitItems","","",301,N],[13,"ImplItems","","",301,N],[13,"ForeignItems","","",301,N],[4,"AstFragmentKind","","\"Discriminant\" of an AST fragment.",N,N],[13,"OptExpr","","",302,N],[13,"Expr","","",302,N],[13,"Pat","","",302,N],[13,"Ty","","",302,N],[13,"Stmts","","",302,N],[13,"Items","","",302,N],[13,"TraitItems","","",302,N],[13,"ImplItems","","",302,N],[13,"ForeignItems","","",302,N],[4,"InvocationKind","","",N,N],[13,"Bang","","",303,N],[12,"mac","syntax::ext::expand::InvocationKind","",303,N],[12,"ident","","",303,N],[12,"span","","",303,N],[13,"Attr","syntax::ext::expand","",303,N],[12,"attr","syntax::ext::expand::InvocationKind","",303,N],[12,"traits","","",303,N],[12,"item","","",303,N],[13,"Derive","syntax::ext::expand","",303,N],[12,"path","syntax::ext::expand::InvocationKind","",303,N],[12,"item","","",303,N],[5,"macro_bang_format","syntax::ext::expand","",N,[[["path"]],["expnformat"]]],[5,"find_attr_invoc","","",N,[[["vec"]],["option",["attribute"]]]],[11,"clone","","",302,[[["self"]],["astfragmentkind"]]],[11,"eq","","",302,[[["self"],["astfragmentkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",302,N],[11,"name","","",302,[[["self"]],["str"]]],[11,"make_from","","",302,[[["self"],["box",["macresult"]]],["option",["astfragment"]]]],[11,"make_opt_expr","","",301,[[["self"]],["option",["p"]]]],[11,"make_expr","","",301,[[["self"]],["p",["expr"]]]],[11,"make_pat","","",301,[[["self"]],["p",["pat"]]]],[11,"make_ty","","",301,[[["self"]],["p",["ty"]]]],[11,"make_stmts","","",301,[[["self"]],["smallvector",["stmt"]]]],[11,"make_items","","",301,[[["self"]],["smallvector",["p"]]]],[11,"make_trait_items","","",301,[[["self"]],["smallvector",["traititem"]]]],[11,"make_impl_items","","",301,[[["self"]],["smallvector",["implitem"]]]],[11,"make_foreign_items","","",301,[[["self"]],["smallvector",["foreignitem"]]]],[11,"fold_with","","",301,[[["self"],["f"]],["self"]]],[11,"visit_with","","",301,[[["self"],["v"]]]],[11,"fold_opt_expr","","",297,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_expr","","",297,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_pat","","",297,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"fold_ty","","",297,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"fold_stmt","","",297,N],[11,"fold_item","","",297,N],[11,"fold_trait_item","","",297,N],[11,"fold_impl_item","","",297,N],[11,"fold_foreign_item","","",297,N],[11,"dummy","","",302,[[["self"],["span"]],["option",["astfragment"]]]],[11,"expect_from_annotatables","","",302,[[["self"],["i"]],["astfragment"]]],[11,"span","","",296,[[["self"]],["span"]]],[11,"attr_id","","",296,[[["self"]],["option",["attrid"]]]],[11,"new","","",297,[[["extctxt"],["bool"]],["self"]]],[11,"expand_crate","","",297,[[["self"],["crate"]],["crate"]]],[11,"expand_fragment","","",297,[[["self"],["astfragment"]],["astfragment"]]],[11,"resolve_imports","","",297,[[["self"]]]],[11,"collect_invocations","","Collect all macro invocations reachable at this time in this AST fragment, and replace them with \"placeholders\" - dummy macro invocations with specially crafted `NodeId`s. Then call into resolver that builds a skeleton (\"reduced graph\") of the fragment and prepares data for resolving paths of macro invocations.",297,N],[11,"fully_configure","","",297,[[["self"],["annotatable"]],["annotatable"]]],[11,"expand_invoc","","",297,[[["self"],["invocation"],["syntaxextension"]],["option",["astfragment"]]]],[11,"expand_attr_invoc","","",297,[[["self"],["invocation"],["syntaxextension"]],["option",["astfragment"]]]],[11,"extract_proc_macro_attr_input","","",297,[[["self"],["tokenstream"],["span"]],["tokenstream"]]],[11,"gate_proc_macro_attr_item","","",297,[[["self"],["span"],["annotatable"]]]],[11,"gate_proc_macro_expansion","","",297,[[["self"],["span"],["option"]]]],[11,"expand_bang_invoc","","Expand a macro invocation. Returns the resulting expanded AST fragment.",297,[[["self"],["invocation"],["syntaxextension"]],["option",["astfragment"]]]],[11,"gate_proc_macro_expansion_kind","","",297,[[["self"],["span"],["astfragmentkind"]]]],[11,"expand_derive_invoc","","Expand a derive invocation. Returns the resulting expanded AST fragment.",297,[[["self"],["invocation"],["syntaxextension"]],["option",["astfragment"]]]],[11,"parse_ast_fragment","","",297,[[["self"],["tokenstream"],["astfragmentkind"],["path"],["span"]],["option",["astfragment"]]]],[11,"parse_ast_fragment","syntax::parse::parser","",215,[[["self"],["astfragmentkind"],["bool"]],["presult",["astfragment"]]]],[11,"ensure_complete_parse","","",215,[[["self"],["path"],["str"],["span"]]]],[11,"collect","syntax::ext::expand","",298,[[["self"],["astfragmentkind"],["invocationkind"]],["astfragment"]]],[11,"collect_bang","","",298,[[["self"],["mac"],["span"],["astfragmentkind"]],["astfragment"]]],[11,"collect_attr","","",298,[[["self"],["option",["attribute"]],["vec",["path"]],["annotatable"],["astfragmentkind"]],["astfragment"]]],[11,"classify_item","","If `item` is an attr invocation, remove and return the macro attribute and derive traits.",298,N],[11,"classify_nonitem","","Alternative of `classify_item()` that ignores `#[derive]` so invocations fallthrough to the unused-attributes lint (making it an error on statements and expressions is a breaking change)",298,N],[11,"configure","","",298,[[["self"],["t"]],["option"]]],[11,"check_attributes","","",298,N],[11,"check_attribute","","",298,[[["self"],["attribute"]]]],[11,"check_attribute_inner","","",298,[[["self"],["attribute"],["features"]]]],[11,"fold_expr","","",298,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_opt_expr","","",298,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_pat","","",298,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"fold_stmt","","",298,[[["self"],["stmt"]],["smallvector",["stmt"]]]],[11,"fold_block","","",298,[[["self"],["p",["block"]]],["p",["block"]]]],[11,"fold_item","","",298,[[["self"],["p",["item"]]],["smallvector",["p"]]]],[11,"fold_trait_item","","",298,[[["self"],["traititem"]],["smallvector",["traititem"]]]],[11,"fold_impl_item","","",298,[[["self"],["implitem"]],["smallvector",["implitem"]]]],[11,"fold_ty","","",298,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"fold_foreign_mod","","",298,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"fold_foreign_item","","",298,[[["self"],["foreignitem"]],["smallvector",["foreignitem"]]]],[11,"fold_item_kind","","",298,[[["self"],["itemkind"]],["itemkind"]]],[11,"fold_generic_param","","",298,[[["self"],["genericparam"]],["genericparam"]]],[11,"fold_attribute","","",298,[[["self"],["attribute"]],["option",["attribute"]]]],[11,"new_id","","",298,[[["self"],["nodeid"]],["nodeid"]]],[11,"default","","",299,[[["string"]],["expansionconfig"]]],[11,"enable_quotes","","",299,[[["self"]],["bool"]]],[11,"enable_asm","","",299,[[["self"]],["bool"]]],[11,"enable_global_asm","","",299,[[["self"]],["bool"]]],[11,"enable_log_syntax","","",299,[[["self"]],["bool"]]],[11,"enable_concat_idents","","",299,[[["self"]],["bool"]]],[11,"enable_trace_macros","","",299,[[["self"]],["bool"]]],[11,"enable_allow_internal_unstable","","",299,[[["self"]],["bool"]]],[11,"enable_custom_derive","","",299,[[["self"]],["bool"]]],[11,"enable_format_args_nl","","",299,[[["self"]],["bool"]]],[11,"use_extern_macros_enabled","","",299,[[["self"]],["bool"]]],[11,"macros_in_extern_enabled","","",299,[[["self"]],["bool"]]],[11,"proc_macro_mod","","",299,[[["self"]],["bool"]]],[11,"proc_macro_gen","","",299,[[["self"]],["bool"]]],[11,"proc_macro_expr","","",299,[[["self"]],["bool"]]],[11,"proc_macro_non_items","","",299,[[["self"]],["bool"]]],[11,"fmt","","",300,[[["self"],["formatter"]],["result"]]],[11,"new_span","","",300,[[["self"],["span"]],["span"]]],[11,"fold_mac","","",300,[[["self"],["mac"]],["mac"]]],[0,"placeholders","syntax::ext","",N,N],[3,"PlaceholderExpander","syntax::ext::placeholders","",N,N],[12,"expanded_fragments","","",304,N],[12,"cx","","",304,N],[12,"monotonic","","",304,N],[5,"placeholder","","",N,[[["astfragmentkind"],["nodeid"]],["astfragment"]]],[11,"new","","",304,[[["extctxt"],["bool"]],["self"]]],[11,"add","","",304,[[["self"],["nodeid"],["astfragment"],["vec",["mark"]]]]],[11,"remove","","",304,[[["self"],["nodeid"]],["astfragment"]]],[11,"fold_item","","",304,[[["self"],["p",["item"]]],["smallvector",["p"]]]],[11,"fold_trait_item","","",304,[[["self"],["traititem"]],["smallvector",["traititem"]]]],[11,"fold_impl_item","","",304,[[["self"],["implitem"]],["smallvector",["implitem"]]]],[11,"fold_foreign_item","","",304,[[["self"],["foreignitem"]],["smallvector",["foreignitem"]]]],[11,"fold_expr","","",304,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_opt_expr","","",304,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_stmt","","",304,[[["self"],["stmt"]],["smallvector",["stmt"]]]],[11,"fold_pat","","",304,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"fold_ty","","",304,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"fold_block","","",304,[[["self"],["p",["block"]]],["p",["block"]]]],[11,"fold_mod","","",304,[[["self"],["mod"]],["mod"]]],[11,"fold_mac","","",304,[[["self"],["mac"]],["mac"]]],[0,"quote","syntax::ext","",N,N],[5,"unflatten","syntax::ext::quote","",N,[[["vec",["tokentree"]]],["vec",["tokentree"]]]],[5,"parse_expr_panic","","",N,[[["parser"]],["p",["expr"]]]],[5,"parse_item_panic","","",N,[[["parser"]],["option",["p"]]]],[5,"parse_pat_panic","","",N,[[["parser"]],["p",["pat"]]]],[5,"parse_arm_panic","","",N,[[["parser"]],["arm"]]],[5,"parse_ty_panic","","",N,[[["parser"]],["p",["ty"]]]],[5,"parse_stmt_panic","","",N,[[["parser"]],["option",["stmt"]]]],[5,"parse_attribute_panic","","",N,[[["parser"],["bool"]],["attribute"]]],[5,"parse_arg_panic","","",N,[[["parser"]],["arg"]]],[5,"parse_block_panic","","",N,[[["parser"]],["p",["block"]]]],[5,"parse_meta_item_panic","","",N,[[["parser"]],["metaitem"]]],[5,"parse_path_panic","","",N,[[["parser"],["pathstyle"]],["path"]]],[5,"expand_quote_tokens","","",N,N],[5,"expand_quote_expr","","",N,N],[5,"expand_quote_item","","",N,N],[5,"expand_quote_pat","","",N,N],[5,"expand_quote_arm","","",N,N],[5,"expand_quote_ty","","",N,N],[5,"expand_quote_stmt","","",N,N],[5,"expand_quote_attr","","",N,N],[5,"expand_quote_arg","","",N,N],[5,"expand_quote_block","","",N,N],[5,"expand_quote_meta_item","","",N,N],[5,"expand_quote_path","","",N,N],[5,"ids_ext","","",N,[[["vec",["string"]]],["vec",["ident"]]]],[5,"id_ext","","",N,[[["str"]],["ident"]]],[5,"mk_ident","","",N,[[["extctxt"],["span"],["ident"]],["p",["expr"]]]],[5,"mk_name","","",N,[[["extctxt"],["span"],["ident"]],["p",["expr"]]]],[5,"mk_tt_path","","",N,[[["extctxt"],["span"],["str"]],["p",["expr"]]]],[5,"mk_token_path","","",N,[[["extctxt"],["span"],["str"]],["p",["expr"]]]],[5,"mk_parser_path","","",N,N],[5,"mk_binop","","",N,[[["extctxt"],["span"],["binoptoken"]],["p",["expr"]]]],[5,"mk_delim","","",N,[[["extctxt"],["span"],["delimtoken"]],["p",["expr"]]]],[5,"expr_mk_token","","",N,[[["extctxt"],["span"],["token"]],["p",["expr"]]]],[5,"statements_mk_tt","","",N,[[["extctxt"],["tokentree"],["bool"]],["vec",["stmt"]]]],[5,"parse_arguments_to_quote","","",N,N],[5,"mk_stmts_let","","",N,[[["extctxt"],["span"]],["vec",["stmt"]]]],[5,"statements_mk_tts","","",N,[[["extctxt"],["tokenstream"]],["vec",["stmt"]]]],[5,"expand_tts","","",N,N],[5,"expand_wrapper","","",N,N],[5,"expand_parse_call","","",N,N],[0,"rt","","Quasiquoting works via token trees.",N,N],[3,"BytePos","syntax::ext::quote::rt","A byte offset. Keep this small (currently 32-bits), as AST contains a lot of them.",N,N],[12,"0","","",175,N],[3,"Span","","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",N,N],[12,"0","","",188,N],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",N,N],[4,"FileName","","Differentiates between real files and common virtual files",N,N],[13,"Real","","",166,N],[13,"Macros","","e.g. \"std\" macros",166,N],[13,"QuoteExpansion","","call to `quote!`",166,N],[13,"Anon","","Command line",166,N],[13,"MacroExpansion","","Hack in src/libsyntax/parse.rs FIXME(jseyfried)",166,N],[13,"ProcMacroSourceCode","","",166,N],[13,"CfgSpec","","Strings provided as --cfg [cfgspec] stored in a crate_cfg",166,N],[13,"CliCrateAttr","","Strings provided as crate attributes in the CLI",166,N],[13,"Custom","","Custom sources for explicit parser calls from plugins and drivers",166,N],[8,"ToTokens","","",N,N],[10,"to_tokens","","",305,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[8,"ExtParseUtils","","",N,N],[10,"parse_item","","",306,[[["self"],["string"]],["p",["item"]]]],[10,"parse_expr","","",306,[[["self"],["string"]],["p",["expr"]]]],[10,"parse_stmt","","",306,[[["self"],["string"]],["stmt"]]],[10,"parse_tts","","",306,[[["self"],["string"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::tokenstream","",259,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::codemap","",189,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::codemap::symbol","",1,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",47,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",77,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",60,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",53,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",54,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ptr","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",75,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ptr","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",74,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",63,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ptr","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",65,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",81,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ptr","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",46,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",59,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",90,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ext::quote::rt","",158,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"parse_item","syntax::ext::base","",281,[[["self"],["string"]],["p",["item"]]]],[11,"parse_stmt","","",281,[[["self"],["string"]],["stmt"]]],[11,"parse_expr","","",281,[[["self"],["string"]],["p",["expr"]]]],[11,"parse_tts","","",281,[[["self"],["string"]],["vec",["tokentree"]]]],[0,"source_util","syntax::ext","",N,N],[5,"expand_line","syntax::ext::source_util","line!(): expands to the current line number",N,N],[5,"expand_column","","",N,N],[5,"expand_column_gated","","",N,N],[5,"expand_file","","file!(): expands to the current filename */ The filemap (`loc.file`) contains a bunch more information we could spit out if we wanted.",N,N],[5,"expand_stringify","","",N,N],[5,"expand_mod","","",N,N],[5,"expand_include","","include! : parse the given file as an expr This is generally a bad idea because it's going to behave unhygienically.",N,N],[5,"expand_include_str","","",N,N],[5,"expand_include_bytes","","",N,N],[5,"res_rel_file","","",N,[[["extctxt"],["span"],["string"]],["pathbuf"]]],[0,"tt","syntax::ext","",N,N],[0,"transcribe","syntax::ext::tt","",N,N],[4,"Frame","syntax::ext::tt::transcribe","",N,N],[13,"Delimited","","",307,N],[12,"forest","syntax::ext::tt::transcribe::Frame","",307,N],[12,"idx","","",307,N],[12,"span","","",307,N],[13,"Sequence","syntax::ext::tt::transcribe","",307,N],[12,"forest","syntax::ext::tt::transcribe::Frame","",307,N],[12,"idx","","",307,N],[12,"sep","","",307,N],[4,"LockstepIterSize","syntax::ext::tt::transcribe","",N,N],[13,"Unconstrained","","",308,N],[13,"Constraint","","",308,N],[13,"Contradiction","","",308,N],[5,"transcribe","","This can do Macro-By-Example transcription. On the other hand, if `src` contains no `TokenTree::{Sequence, MetaVar, MetaVarDecl}`s, `interp` can (and should) be None.",N,[[["extctxt"],["option",["hashmap"]],["vec",["tokentree"]]],["tokenstream"]]],[5,"lookup_cur_matched","","",N,N],[5,"lockstep_iter_size","","",N,N],[11,"new","","",307,[[["vec",["tokentree"]]],["frame"]]],[11,"next","","",307,[[["self"]],["option",["tokentree"]]]],[11,"clone","","",308,[[["self"]],["lockstepitersize"]]],[11,"add","","",308,[[["self"],["lockstepitersize"]],["lockstepitersize"]]],[0,"macro_parser","syntax::ext::tt","This is an NFA-based parser, which calls out to the main rust parser for named nonterminals (which it commits to fully when it hits one in a grammar). There's a set of current NFA threads and a set of next ones. Instead of NTs, we have a special case for Kleene star. The big-O, in pathological cases, is worse than traditional use of NFA or Earley parsing, but it's an easier fit for Macro-by-Example-style rules.",N,N],[3,"MatcherTtFrame","syntax::ext::tt::macro_parser","An unzipping of `TokenTree`s... see the `stack` field of `MatcherPos`.",N,N],[12,"elts","","The \"parent\" matcher that we are descending into.",309,N],[12,"idx","","The position of the \"dot\" in `elts` at the time we descended.",309,N],[3,"MatcherPos","","Represents a single \"position\" (aka \"matcher position\", aka \"item\"), as described in the module documentation.",N,N],[12,"top_elts","","The token or sequence of tokens that make up the matcher",310,N],[12,"idx","","The position of the \"dot\" in this matcher",310,N],[12,"sp_lo","","The beginning position in the source that the beginning of this matcher corresponds to. In other words, the token in the source at `sp_lo` is matched against the first token of the matcher.",310,N],[12,"matches","","For each named metavar in the matcher, we keep track of token trees matched against the metavar by the black box parser. In particular, there may be more than one match per metavar if we are in a repetition (each repetition matches each of the variables). Moreover, matchers and repetitions can be nested; the `matches` field is shared (hence the `Rc`) among all \"nested\" matchers. `match_lo`, `match_cur`, and `match_hi` keep track of the current position of the `self` matcher position in the shared `matches` list.",310,N],[12,"match_lo","","The position in `matches` corresponding to the first metavar in this matcher's sequence of token trees. In other words, the first metavar in the first token of `top_elts` corresponds to `matches[match_lo]`.",310,N],[12,"match_cur","","The position in `matches` corresponding to the metavar we are currently trying to match against the source token stream. `match_lo <= match_cur <= match_hi`.",310,N],[12,"match_hi","","Similar to `match_lo` except `match_hi` is the position in `matches` of the last metavar in this matcher.",310,N],[12,"seq_op","","The KleeneOp of this sequence if we are in a repetition.",310,N],[12,"sep","","The separator if we are in a repetition",310,N],[12,"up","","The \"parent\" matcher position if we are in a repetition. That is, the matcher position just before we enter the sequence.",310,N],[12,"stack","","When matching against matchers with nested delimited submatchers (e.g. `pat ( pat ( .. ) pat ) pat`), we need to keep track of the matchers we are descending into. This stack does that where the bottom of the stack is the outermost matcher.",310,N],[4,"TokenTreeOrTokenTreeSlice","","Either a sequence of token trees or a single one. This is used as the representation of the sequence of tokens that make up a matcher.",N,N],[13,"Tt","","",311,N],[13,"TtSeq","","",311,N],[4,"MatcherPosHandle","","",N,N],[13,"Ref","","",312,N],[13,"Box","","",312,N],[4,"ParseResult","","Represents the possible results of an attempted parse.",N,N],[13,"Success","","Parsed successfully.",313,N],[13,"Failure","","Arm failed to match. If the second parameter is `token::Eof`, it indicates an unexpected end of macro invocation. Otherwise, it indicates that no rules expected the given token.",313,N],[13,"Error","","Fatal error (malformed macro?). Abort compilation.",313,N],[4,"NamedMatch","","`NamedMatch` is a pattern-match result for a single `token::MATCH_NONTERMINAL`: so it is associated with a single ident in a parse, and all `MatchedNonterminal`s in the `NamedMatch` have the same nonterminal type (expr, item, etc). Each leaf in a single `NamedMatch` corresponds to a single `token::MATCH_NONTERMINAL` in the `TokenTree` that produced it.",N,N],[13,"MatchedSeq","","",314,N],[13,"MatchedNonterminal","","",314,N],[5,"count_names","","Count how many metavars are named in the given matcher `ms`.",N,N],[5,"create_matches","","Initialize `len` empty shared `Vec`s to be used to store matches of metavars.",N,[[["usize"]],["vec",["rc"]]]],[5,"initial_matcher_pos","","Generate the top-level matcher position in which the \"dot\" is before the first token of the matcher `ms` and we are going to start matching at position `lo` in the source.",N,N],[5,"nameize","","Takes a sequence of token trees `ms` representing a matcher which successfully matched input and an iterator of items that matched input and produces a `NamedParseResult`.",N,N],[5,"parse_failure_msg","","Generate an appropriate parsing failure message. For EOF, this is \"unexpected end...\". For other tokens, this is \"unexpected token...\".",N,[[["token"]],["string"]]],[5,"token_name_eq","","Perform a token equality check, ignoring syntax context (that is, an unhygienic comparison)",N,[[["token"],["token"]],["bool"]]],[5,"inner_parse_loop","","Process the matcher positions of `cur_items` until it is empty. In the process, this will produce more items in `next_items`, `eof_items`, and `bb_items`.",N,[[["parsesess"],["smallvector"],["vec"],["smallvector"],["smallvector"],["token"],["span"]],["parseresult"]]],[5,"parse","","Use the given sequence of token trees (`ms`) as a matcher. Match the given token stream `tts` against it and return the match.",N,N],[5,"get_macro_ident","","The token is an identifier, but not `_`. We prohibit passing `_` to macros expecting `ident` for now.",N,[[["token"]],["option"]]],[5,"may_begin_with","","Checks whether a non-terminal may begin with a particular token.",N,[[["str"],["token"]],["bool"]]],[5,"parse_nt","","A call to the \"black-box\" parser to parse some rust nonterminal.",N,[[["parser"],["span"],["str"]],["nonterminal"]]],[6,"NamedParseResult","","A `ParseResult` where the `Success` variant contains a mapping of `Ident`s to `NamedMatch`es. This represents the mapping of metavars to the token trees they bind to.",N,N],[11,"clone","","",311,[[["self"]],["tokentreeortokentreeslice"]]],[11,"len","","Returns the number of constituent top-level token trees of `self` (top-level in that it will not recursively descend into subtrees).",311,[[["self"]],["usize"]]],[11,"get_tt","","The the `index`-th token tree of `self`.",311,[[["self"],["usize"]],["tokentree"]]],[11,"clone","","",309,[[["self"]],["matcherttframe"]]],[11,"clone","","",310,[[["self"]],["matcherpos"]]],[11,"push_match","","Add `m` as a named match for the `idx`-th metavar.",310,[[["self"],["usize"],["namedmatch"]]]],[11,"clone","","",312,[[["self"]],["self"]]],[11,"deref","","",312,N],[11,"deref_mut","","",312,[[["self"]],["matcherpos"]]],[11,"fmt","","",314,[[["self"],["formatter"]],["result"]]],[11,"clone","","",314,[[["self"]],["namedmatch"]]],[0,"macro_rules","syntax::ext::tt","",N,N],[3,"ParserAnyMacro","syntax::ext::tt::macro_rules","",N,N],[12,"parser","","",315,N],[12,"site_span","","Span of the expansion site of the macro this parser is for",315,N],[12,"macro_ident","","The ident of the macro we're parsing",315,N],[3,"MacroRulesMacroExpander","","",N,N],[12,"name","","",316,N],[12,"lhses","","",316,N],[12,"rhses","","",316,N],[12,"valid","","",316,N],[3,"FirstSets","","",N,N],[12,"first","","",317,N],[3,"TokenSet","","",N,N],[12,"tokens","","",318,N],[12,"maybe_empty","","",318,N],[5,"trace_macros_note","","",N,[[["extctxt"],["span"],["string"]]]],[5,"generic_extension","","Given `lhses` and `rhses`, this is the new macro we create",N,N],[5,"compile","","Converts a `macro_rules!` invocation into a syntax extension.",N,[[["parsesess"],["features"],["item"],["edition"]],["syntaxextension"]]],[5,"check_lhs_nt_follows","","",N,N],[5,"check_lhs_no_empty_seq","","Check that the lhs contains no repetition which could match an empty token tree, because then the matcher would hang indefinitely.",N,N],[5,"check_rhs","","",N,[[["parsesess"],["tokentree"]],["bool"]]],[5,"check_matcher","","",N,N],[5,"check_matcher_core","","",N,N],[5,"token_can_be_followed_by_any","","",N,[[["tokentree"]],["bool"]]],[5,"frag_can_be_followed_by_any","","True if a fragment of type `frag` can be followed by any sort of token.  We use this (among other things) as a useful approximation for when `frag` can be followed by a repetition like `$(...)*` or `$(...)+`. In general, these can be a bit tricky to reason about, so we adopt a conservative position that says that any fragment specifier which consumes at most one token tree can be followed by a fragment specifier (indeed, these fragments can be followed by ANYTHING without fear of future compatibility hazards).",N,[[["str"]],["bool"]]],[5,"is_in_follow","","True if `frag` can legally be followed by the token `tok`. For fragments that can consume an unbounded number of tokens, `tok` must be within a well-defined follow set. This is intended to guarantee future compatibility: for example, without this rule, if we expanded `expr` to include a new binary operator, we might break macros that were relying on that binary operator as a separator.",N,[[["tokentree"],["str"]],["result",["bool"]]]],[5,"has_legal_fragment_specifier","","",N,N],[5,"is_legal_fragment_specifier","","",N,N],[5,"quoted_tt_to_string","","",N,[[["tokentree"]],["string"]]],[11,"make","","",315,[[["box",["parseranymacro"]],["astfragmentkind"]],["astfragment"]]],[11,"expand","","",316,[[["self"],["extctxt"],["span"],["tokenstream"]],["box",["macresult"]]]],[11,"new","","",317,N],[11,"first","","",317,N],[11,"clone","","",318,[[["self"]],["tokenset"]]],[11,"fmt","","",318,[[["self"],["formatter"]],["result"]]],[11,"empty","","",318,[[],["self"]]],[11,"singleton","","",318,[[["tokentree"]],["self"]]],[11,"replace_with","","",318,[[["self"],["tokentree"]]]],[11,"replace_with_irrelevant","","",318,[[["self"]]]],[11,"add_one","","",318,[[["self"],["tokentree"]]]],[11,"add_one_maybe","","",318,[[["self"],["tokentree"]]]],[11,"add_all","","",318,[[["self"],["self"]]]],[0,"quoted","syntax::ext::tt","",N,N],[3,"Delimited","syntax::ext::tt::quoted","Contains the sub-token-trees of a \"delimited\" token tree, such as the contents of `(`. Note that the delimiter itself might be `NoDelim`.",N,N],[12,"delim","","",319,N],[12,"tts","","",319,N],[3,"SequenceRepetition","","",N,N],[12,"tts","","The sequence of token trees",320,N],[12,"separator","","The optional separator",320,N],[12,"op","","Whether the sequence can be repeated zero (*), or one or more times (+)",320,N],[12,"num_captures","","The number of `Match`s that appear in the sequence (and subsequences)",320,N],[4,"KleeneOp","","A Kleene-style repetition operator for token sequences.",N,N],[13,"ZeroOrMore","","Kleene star (`*`) for zero or more repetitions",321,N],[13,"OneOrMore","","Kleene plus (`+`) for one or more repetitions",321,N],[13,"ZeroOrOne","","",321,N],[4,"TokenTree","","Similar to `tokenstream::TokenTree`, except that `$i`, `$i:ident`, and `$(...)` are \"first-class\" token trees. Useful for parsing macros.",N,N],[13,"Token","","",322,N],[13,"Delimited","","",322,N],[13,"Sequence","","A kleene-style repetition sequence",322,N],[13,"MetaVar","","E.g. `$var`",322,N],[13,"MetaVarDecl","","E.g. `$var:expr`. This is only used in the left hand side of MBE macros.",322,N],[5,"parse","","Takes a `tokenstream::TokenStream` and returns a `Vec<self::TokenTree>`. Specifically, this takes a generic `TokenStream`, such as is used in the rest of the compiler, and returns a collection of `TokenTree` for use in parsing a macro.",N,N],[5,"parse_tree","","Takes a `tokenstream::TokenTree` and returns a `self::TokenTree`. Specifically, this takes a generic `TokenTree`, such as is used in the rest of the compiler, and returns a `TokenTree` for use in parsing a macro.",N,N],[5,"kleene_op","","Takes a token and returns `Some(KleeneOp)` if the token is `+` `*` or `?`. Otherwise, return `None`.",N,[[["token"]],["option",["kleeneop"]]]],[5,"parse_kleene_op","","Parse the next token tree of the input looking for a KleeneOp. Returns",N,[[["i"],["span"]],["result",["result","span"]]]],[5,"parse_sep_and_kleene_op","","Attempt to parse a single Kleene star, possibly with a separator.",N,N],[5,"parse_sep_and_kleene_op_2015","","",N,N],[5,"parse_sep_and_kleene_op_2018","","",N,N],[11,"clone","","",319,[[["self"]],["delimited"]]],[11,"eq","","",319,[[["self"],["delimited"]],["bool"]]],[11,"ne","","",319,[[["self"],["delimited"]],["bool"]]],[11,"encode","","",319,[[["self"],["__s"]],["result"]]],[11,"decode","","",319,[[["__d"]],["result",["delimited"]]]],[11,"fmt","","",319,[[["self"],["formatter"]],["result"]]],[11,"open_token","","Return the opening delimiter (possibly `NoDelim`).",319,[[["self"]],["token"]]],[11,"close_token","","Return the closing delimiter (possibly `NoDelim`).",319,[[["self"]],["token"]]],[11,"open_tt","","Return a `self::TokenTree` with a `Span` corresponding to the opening delimiter.",319,[[["self"],["span"]],["tokentree"]]],[11,"close_tt","","Return a `self::TokenTree` with a `Span` corresponding to the closing delimiter.",319,[[["self"],["span"]],["tokentree"]]],[11,"clone","","",320,[[["self"]],["sequencerepetition"]]],[11,"eq","","",320,[[["self"],["sequencerepetition"]],["bool"]]],[11,"ne","","",320,[[["self"],["sequencerepetition"]],["bool"]]],[11,"encode","","",320,[[["self"],["__s"]],["result"]]],[11,"decode","","",320,[[["__d"]],["result",["sequencerepetition"]]]],[11,"fmt","","",320,[[["self"],["formatter"]],["result"]]],[11,"clone","","",321,[[["self"]],["kleeneop"]]],[11,"eq","","",321,[[["self"],["kleeneop"]],["bool"]]],[11,"encode","","",321,[[["self"],["__s"]],["result"]]],[11,"decode","","",321,[[["__d"]],["result",["kleeneop"]]]],[11,"hash","","",321,N],[11,"fmt","","",321,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",322,[[["self"],["formatter"]],["result"]]],[11,"clone","","",322,[[["self"]],["tokentree"]]],[11,"eq","","",322,[[["self"],["tokentree"]],["bool"]]],[11,"ne","","",322,[[["self"],["tokentree"]],["bool"]]],[11,"encode","","",322,[[["self"],["__s"]],["result"]]],[11,"decode","","",322,[[["__d"]],["result",["tokentree"]]]],[11,"len","","Return the number of tokens in the tree.",322,[[["self"]],["usize"]]],[11,"is_empty","","Returns true if the given token tree contains no other tokens. This is vacuously true for single tokens or metavar/decls, but may be false for delimited trees or sequences.",322,[[["self"]],["bool"]]],[11,"get_tt","","Get the `index`-th sub-token-tree. This only makes sense for delimited trees and sequences.",322,[[["self"],["usize"]],["tokentree"]]],[11,"span","","Retrieve the `TokenTree`'s span.",322,[[["self"]],["span"]]],[0,"early_buffered_lints","syntax","Allows the buffering of lints for later.",N,N],[3,"BufferedEarlyLint","syntax::early_buffered_lints","Stores buffered lint info which can later be passed to `librustc`.",N,N],[12,"span","","The span of code that we are linting on.",323,N],[12,"msg","","The lint message.",323,N],[12,"id","","The `NodeId` of the AST node that generated the lint.",323,N],[12,"lint_id","","A lint Id that can be passed to `rustc::lint::Lint::from_parser_lint_id`.",323,N],[4,"BufferedEarlyLintId","","Since we cannot import `LintId`s from `rustc::lint`, we define some Ids here which can later be passed to `rustc::lint::Lint::from_parser_lint_id` to get a `rustc::lint::Lint`.",N,N],[13,"QuestionMarkMacroSep","","Usage of `?` as a macro separator is deprecated.",324,N],[7,"GLOBALS","syntax","",N,N],[17,"DIAGNOSTICS","","",N,N],[11,"new","","",7,[[],["globals"]]],[14,"panictry","","",N,N],[14,"unwrap_or","","",N,N],[14,"register_diagnostic","","",N,N],[14,"span_fatal","","",N,N],[14,"span_err","","",N,N],[14,"span_warn","","",N,N],[14,"struct_err","","",N,N],[14,"span_err_or_warn","","",N,N],[14,"struct_span_fatal","","",N,N],[14,"struct_span_err","","",N,N],[14,"stringify_error_code","","",N,N],[14,"type_error_struct","","",N,N],[14,"struct_span_warn","","",N,N],[14,"struct_span_err_or_warn","","",N,N],[14,"span_note","","",N,N],[14,"span_help","","",N,N],[14,"help","","",N,N],[14,"register_diagnostics","","",N,N],[14,"register_long_diagnostics","","",N,N],[14,"walk_list","","",N,N],[11,"lint_name","syntax::codemap::edition","",0,[[["self"]],["str"]]],[11,"feature_name","","",0,[[["self"]],["str"]]],[11,"is_stable","","",0,[[["self"]],["bool"]]],[11,"clone","syntax::diagnostics::plugin","",24,[[["self"]],["diagnosticid"]]],[11,"clone","syntax::diagnostics::plugin::registry","",13,[[["self"]],["registry"]]],[11,"clone","syntax::diagnostics::plugin","",26,[[["self"]],["subdiagnostic"]]],[11,"clone","","",325,[[["self"]],["explicitbug"]]],[11,"clone","","",21,[[["self"]],["level"]]],[11,"clone","","",14,[[["self"]],["applicability"]]],[11,"clone","syntax::diagnostics::plugin::emitter","",9,[[["self"]],["colorconfig"]]],[11,"clone","syntax::diagnostics::plugin","",22,[[["self"]],["diagnostic"]]],[11,"clone","","",17,[[["self"]],["substitutionpart"]]],[11,"clone","","",16,[[["self"]],["substitution"]]],[11,"clone","","",15,[[["self"]],["codesuggestion"]]],[11,"clone","","",326,[[["self"]],["fatalerror"]]],[11,"clone","","",23,[[["self"]],["diagnosticbuilder"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::diagnostics::plugin::emitter","",9,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::diagnostics::plugin","",15,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",325,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",326,[[["self"],["formatter"]],["result",["error"]]]],[11,"description","","",326,[[["self"]],["str"]]],[11,"description","","",325,[[["self"]],["str"]]],[11,"drop","","",19,N],[11,"drop","","",23,N],[11,"drop","syntax::diagnostics::plugin::emitter","",12,N],[11,"deref_mut","syntax::diagnostics::plugin","",23,[[["self"]],["diagnostic"]]],[11,"default","","",20,[[],["handlerflags"]]],[11,"write","syntax::diagnostics::plugin::emitter","",12,N],[11,"flush","","",12,[[["self"]],["result",["error"]]]],[11,"hash","syntax::diagnostics::plugin","",16,N],[11,"hash","","",22,N],[11,"hash","","",17,N],[11,"hash","","",26,N],[11,"hash","","",14,N],[11,"hash","","",24,N],[11,"hash","","",15,N],[11,"hash","","",21,N],[11,"new","","",22,[[["level"],["str"]],["diagnostic"]]],[11,"new_with_code","","",22,[[["level"],["option",["diagnosticid"]],["str"]],["diagnostic"]]],[11,"is_error","","",22,[[["self"]],["bool"]]],[11,"cancel","","Cancel the diagnostic (a structured diagnostic must either be emitted or canceled or it will panic when dropped).",22,N],[11,"cancelled","","",22,[[["self"]],["bool"]]],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",22,[[["self"],["span"],["t"]],["diagnostic"]]],[11,"note_expected_found","","",22,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"]],["diagnostic"]]],[11,"note_expected_found_extra","","",22,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"],["display"],["display"]],["diagnostic"]]],[11,"note_trait_signature","","",22,[[["self"],["string"],["string"]],["diagnostic"]]],[11,"note","","",22,[[["self"],["str"]],["diagnostic"]]],[11,"highlighted_note","","",22,[[["self"],["vec"]],["diagnostic"]]],[11,"span_note","","",22,[[["self"],["s"],["str"]],["diagnostic"]]],[11,"warn","","",22,[[["self"],["str"]],["diagnostic"]]],[11,"span_warn","","",22,[[["self"],["s"],["str"]],["diagnostic"]]],[11,"help","","",22,[[["self"],["str"]],["diagnostic"]]],[11,"span_help","","",22,[[["self"],["s"],["str"]],["diagnostic"]]],[11,"span_suggestion_short","","Prints out a message with a suggested edit of the code. If the suggestion is presented inline it will only show the text message and not the text.",22,[[["self"],["span"],["str"],["string"]],["diagnostic"]]],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",22,[[["self"],["span"],["str"],["string"]],["diagnostic"]]],[11,"multipart_suggestion","","",22,[[["self"],["str"],["vec"]],["diagnostic"]]],[11,"span_suggestions","","Prints out a message with multiple suggested edits of the code.",22,[[["self"],["span"],["str"],["vec",["string"]]],["diagnostic"]]],[11,"span_suggestion_with_applicability","","This is a suggestion that may contain mistakes or fillers and should be read and understood by a human.",22,[[["self"],["span"],["str"],["string"],["applicability"]],["diagnostic"]]],[11,"span_suggestions_with_applicability","","",22,[[["self"],["span"],["str"],["vec",["string"]],["applicability"]],["diagnostic"]]],[11,"span_suggestion_short_with_applicability","","",22,[[["self"],["span"],["str"],["string"],["applicability"]],["diagnostic"]]],[11,"set_span","","",22,[[["self"],["s"]],["diagnostic"]]],[11,"code","","",22,[[["self"],["diagnosticid"]],["diagnostic"]]],[11,"get_code","","",22,[[["self"]],["option",["diagnosticid"]]]],[11,"message","","",22,[[["self"]],["string"]]],[11,"styled_message","","",22,[[["self"]],["vec"]]],[11,"copy_details_not_message","","Used by a lint. Copies over all details but the \"main message\".",22,N],[11,"sub","","Convenience function for internal use, clients should use one of the public methods above.",22,N],[11,"deref","","",23,[[["self"]],["diagnostic"]]],[11,"assert_receiver_is_total_eq","","",25,N],[11,"assert_receiver_is_total_eq","","",24,N],[11,"assert_receiver_is_total_eq","syntax::diagnostics::plugin::emitter","",9,N],[11,"emit","","",10,N],[11,"should_show_explain","","",10,[[["self"]],["bool"]]],[11,"encode","syntax::diagnostics::plugin","",14,[[["self"],["__s"]],["result"]]],[11,"encode","","",26,[[["self"],["__s"]],["result"]]],[11,"encode","","",22,[[["self"],["__s"]],["result"]]],[11,"encode","","",16,[[["self"],["__s"]],["result"]]],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[11,"encode","","",21,[[["self"],["__s"]],["result"]]],[11,"encode","","",15,[[["self"],["__s"]],["result"]]],[11,"encode","","",17,[[["self"],["__s"]],["result"]]],[11,"fmt","","",325,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",326,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result",["error"]]]],[11,"eq","","",22,[[["self"],["diagnostic"]],["bool"]]],[11,"ne","","",22,[[["self"],["diagnostic"]],["bool"]]],[11,"eq","","",25,[[["self"],["diagnosticstyledstring"]],["bool"]]],[11,"ne","","",25,[[["self"],["diagnosticstyledstring"]],["bool"]]],[11,"eq","syntax::diagnostics::plugin::emitter","",9,[[["self"],["colorconfig"]],["bool"]]],[11,"eq","syntax::diagnostics::plugin","",16,[[["self"],["substitution"]],["bool"]]],[11,"ne","","",16,[[["self"],["substitution"]],["bool"]]],[11,"eq","","",24,[[["self"],["diagnosticid"]],["bool"]]],[11,"ne","","",24,[[["self"],["diagnosticid"]],["bool"]]],[11,"eq","","",17,[[["self"],["substitutionpart"]],["bool"]]],[11,"ne","","",17,[[["self"],["substitutionpart"]],["bool"]]],[11,"eq","","",14,[[["self"],["applicability"]],["bool"]]],[11,"eq","","",21,[[["self"],["level"]],["bool"]]],[11,"eq","","",15,[[["self"],["codesuggestion"]],["bool"]]],[11,"ne","","",15,[[["self"],["codesuggestion"]],["bool"]]],[11,"eq","","",26,[[["self"],["subdiagnostic"]],["bool"]]],[11,"ne","","",26,[[["self"],["subdiagnostic"]],["bool"]]],[11,"decode","","",16,[[["__d"]],["result",["substitution"]]]],[11,"decode","","",14,[[["__d"]],["result",["applicability"]]]],[11,"decode","","",15,[[["__d"]],["result",["codesuggestion"]]]],[11,"decode","","",17,[[["__d"]],["result",["substitutionpart"]]]],[11,"decode","","",22,[[["__d"]],["result",["diagnostic"]]]],[11,"decode","","",24,[[["__d"]],["result",["diagnosticid"]]]],[11,"decode","","",26,[[["__d"]],["result",["subdiagnostic"]]]],[11,"decode","","",21,[[["__d"]],["result",["level"]]]],[11,"add","syntax::codemap","",171,[[["self"],["bytepos"]],["nonnarrowchar"]]],[11,"add","","",176,[[["self"],["charpos"]],["charpos"]]],[11,"add","syntax::ext::quote::rt","",175,[[["self"],["bytepos"]],["bytepos"]]],[11,"clone","syntax::codemap","",171,[[["self"]],["nonnarrowchar"]]],[11,"clone","","",181,[[["self"]],["lineinfo"]]],[11,"clone","syntax::ext::hygiene","",160,[[["self"]],["mark"]]],[11,"clone","syntax::codemap","",185,[[["self"]],["spansnippeterror"]]],[11,"clone","","",187,[[["self"]],["malformedcodemappositions"]]],[11,"clone","syntax::ext::hygiene","",162,[[["self"]],["expninfo"]]],[11,"clone","syntax::codemap","",176,[[["self"]],["charpos"]]],[11,"clone","syntax::codemap::symbol","",6,[[["self"]],["internedstring"]]],[11,"clone","syntax::codemap","",173,[[["self"]],["filemap"]]],[11,"clone","","",170,[[["self"]],["multibytechar"]]],[11,"clone","syntax::codemap::edition","",0,[[["self"]],["edition"]]],[11,"clone","syntax::ext::hygiene","",164,[[["self"]],["compilerdesugaringkind"]]],[11,"clone","syntax::ext::quote::rt","",166,[[["self"]],["filename"]]],[11,"clone","syntax::codemap","",172,[[["self"]],["externalsource"]]],[11,"clone","syntax::codemap::symbol","",5,[[["self"]],["localinternedstring"]]],[11,"clone","syntax::codemap","",167,[[["self"]],["spandata"]]],[11,"clone","syntax::codemap::symbol::keywords","",4,[[["self"]],["keyword"]]],[11,"clone","syntax::ext::hygiene","",159,[[["self"]],["syntaxcontext"]]],[11,"clone","syntax::codemap","",168,[[["self"]],["multispan"]]],[11,"clone","syntax::codemap::symbol","",1,[[["self"]],["ident"]]],[11,"clone","syntax::codemap","",169,[[["self"]],["spanlabel"]]],[11,"clone","syntax::codemap::symbol","",2,[[["self"]],["symbol"]]],[11,"clone","syntax::ext::quote::rt","",188,[[["self"]],["span"]]],[11,"clone","syntax::ext::hygiene","",163,[[["self"]],["expnformat"]]],[11,"clone","syntax::codemap","",184,[[["self"]],["spanlineserror"]]],[11,"clone","","",177,[[["self"]],["loc"]]],[11,"clone","","",186,[[["self"]],["distinctsources"]]],[11,"clone","syntax::ext::hygiene","",161,[[["self"]],["transparency"]]],[11,"clone","syntax::ext::quote::rt","",175,[[["self"]],["bytepos"]]],[11,"fmt","syntax::ext::hygiene","",162,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap::symbol","",2,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap","",184,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",180,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",173,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",170,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",187,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",168,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",177,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",169,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap::edition","",0,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap::symbol","",6,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::hygiene","",163,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::quote::rt","",166,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap","",178,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap::symbol","",5,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::quote::rt","",175,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap","",181,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap::symbol","",1,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap","",176,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::hygiene","",161,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap","",183,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",185,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::hygiene","",164,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap","",171,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::quote::rt","",188,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap","",186,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",179,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::hygiene","",160,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",159,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap","",167,[[["self"],["formatter"]],["result",["error"]]]],[11,"partial_cmp","syntax::ext::hygiene","",159,[[["self"],["syntaxcontext"]],["option",["ordering"]]]],[11,"lt","","",159,[[["self"],["syntaxcontext"]],["bool"]]],[11,"le","","",159,[[["self"],["syntaxcontext"]],["bool"]]],[11,"gt","","",159,[[["self"],["syntaxcontext"]],["bool"]]],[11,"ge","","",159,[[["self"],["syntaxcontext"]],["bool"]]],[11,"partial_cmp","syntax::codemap","",167,[[["self"],["spandata"]],["option",["ordering"]]]],[11,"lt","","",167,[[["self"],["spandata"]],["bool"]]],[11,"le","","",167,[[["self"],["spandata"]],["bool"]]],[11,"gt","","",167,[[["self"],["spandata"]],["bool"]]],[11,"ge","","",167,[[["self"],["spandata"]],["bool"]]],[11,"partial_cmp","","",176,[[["self"],["charpos"]],["option",["ordering"]]]],[11,"lt","","",176,[[["self"],["charpos"]],["bool"]]],[11,"le","","",176,[[["self"],["charpos"]],["bool"]]],[11,"gt","","",176,[[["self"],["charpos"]],["bool"]]],[11,"ge","","",176,[[["self"],["charpos"]],["bool"]]],[11,"partial_cmp","syntax::ext::quote::rt","",175,[[["self"],["bytepos"]],["option",["ordering"]]]],[11,"lt","","",175,[[["self"],["bytepos"]],["bool"]]],[11,"le","","",175,[[["self"],["bytepos"]],["bool"]]],[11,"gt","","",175,[[["self"],["bytepos"]],["bool"]]],[11,"ge","","",175,[[["self"],["bytepos"]],["bool"]]],[11,"partial_cmp","syntax::ext::hygiene","",161,[[["self"],["transparency"]],["option",["ordering"]]]],[11,"partial_cmp","syntax::codemap::symbol","",5,[[["self"],["localinternedstring"]],["option",["ordering"]]]],[11,"lt","","",5,[[["self"],["localinternedstring"]],["bool"]]],[11,"le","","",5,[[["self"],["localinternedstring"]],["bool"]]],[11,"gt","","",5,[[["self"],["localinternedstring"]],["bool"]]],[11,"ge","","",5,[[["self"],["localinternedstring"]],["bool"]]],[11,"partial_cmp","","",6,[[["self"],["internedstring"]],["option",["ordering"]]]],[11,"partial_cmp","","",2,[[["self"],["symbol"]],["option",["ordering"]]]],[11,"lt","","",2,[[["self"],["symbol"]],["bool"]]],[11,"le","","",2,[[["self"],["symbol"]],["bool"]]],[11,"gt","","",2,[[["self"],["symbol"]],["bool"]]],[11,"ge","","",2,[[["self"],["symbol"]],["bool"]]],[11,"partial_cmp","syntax::codemap::edition","",0,[[["self"],["edition"]],["option",["ordering"]]]],[11,"partial_cmp","syntax::ext::quote::rt","",188,[[["self"],["span"]],["option",["ordering"]]]],[11,"partial_cmp","","",166,[[["self"],["filename"]],["option",["ordering"]]]],[11,"lt","","",166,[[["self"],["filename"]],["bool"]]],[11,"le","","",166,[[["self"],["filename"]],["bool"]]],[11,"gt","","",166,[[["self"],["filename"]],["bool"]]],[11,"ge","","",166,[[["self"],["filename"]],["bool"]]],[11,"from_usize","","",175,[[["usize"]],["bytepos"]]],[11,"to_usize","","",175,[[["self"]],["usize"]]],[11,"from_u32","","",175,[[["u32"]],["bytepos"]]],[11,"to_u32","","",175,[[["self"]],["u32"]]],[11,"from_usize","syntax::codemap","",176,[[["usize"]],["charpos"]]],[11,"to_usize","","",176,[[["self"]],["usize"]]],[11,"from_u32","","",176,[[["u32"]],["charpos"]]],[11,"to_u32","","",176,[[["self"]],["u32"]]],[11,"sub","syntax::ext::quote::rt","",175,[[["self"],["bytepos"]],["bytepos"]]],[11,"sub","syntax::codemap","",171,[[["self"],["bytepos"]],["nonnarrowchar"]]],[11,"sub","","",176,[[["self"],["charpos"]],["charpos"]]],[11,"cmp","syntax::ext::quote::rt","",175,[[["self"],["bytepos"]],["ordering"]]],[11,"cmp","syntax::codemap::symbol","",2,[[["self"],["symbol"]],["ordering"]]],[11,"cmp","","",6,[[["self"],["internedstring"]],["ordering"]]],[11,"cmp","syntax::ext::quote::rt","",188,[[["self"],["span"]],["ordering"]]],[11,"cmp","syntax::ext::hygiene","",159,[[["self"],["syntaxcontext"]],["ordering"]]],[11,"cmp","syntax::codemap","",176,[[["self"],["charpos"]],["ordering"]]],[11,"cmp","","",167,[[["self"],["spandata"]],["ordering"]]],[11,"cmp","syntax::ext::quote::rt","",166,[[["self"],["filename"]],["ordering"]]],[11,"cmp","syntax::codemap::symbol","",5,[[["self"],["localinternedstring"]],["ordering"]]],[11,"from_str","syntax::codemap::edition","",0,[[["str"]],["result",["edition"]]]],[11,"from_str","syntax::codemap::symbol::keywords","",4,[[["str"]],["result",["keyword"]]]],[11,"default","syntax::ext::quote::rt","",188,[[],["span"]]],[11,"default","syntax::ext::hygiene","",159,[[],["syntaxcontext"]]],[11,"hash","syntax::ext::quote::rt","",175,N],[11,"hash","syntax::codemap::edition","",0,N],[11,"hash","syntax::codemap","",168,N],[11,"hash","","",176,N],[11,"hash","syntax::ext::hygiene","",162,N],[11,"hash","syntax::ext::quote::rt","",166,N],[11,"hash","syntax::codemap::symbol","",5,N],[11,"hash","syntax::ext::hygiene","",161,N],[11,"hash","","",164,N],[11,"hash","","",160,N],[11,"hash","","",159,N],[11,"hash","syntax::codemap::symbol","",6,N],[11,"hash","","",2,N],[11,"hash","syntax::codemap","",167,N],[11,"hash","syntax::ext::hygiene","",163,N],[11,"hash","syntax::codemap::symbol","",1,N],[11,"hash","syntax::ext::quote::rt","",188,N],[11,"decode","syntax::ext::hygiene","",164,[[["__d"]],["result",["compilerdesugaringkind"]]]],[11,"decode","syntax::ext::quote::rt","",175,[[["d"]],["result",["bytepos"]]]],[11,"decode","syntax::ext::hygiene","",159,[[["d"]],["result",["syntaxcontext"]]]],[11,"decode","syntax::codemap","",168,[[["__d"]],["result",["multispan"]]]],[11,"decode","syntax::codemap::edition","",0,[[["__d"]],["result",["edition"]]]],[11,"decode","syntax::ext::hygiene","",163,[[["__d"]],["result",["expnformat"]]]],[11,"decode","syntax::codemap","",173,[[["d"]],["result",["filemap"]]]],[11,"decode","syntax::codemap::symbol","",5,[[["d"]],["result",["localinternedstring"]]]],[11,"decode","syntax::codemap","",171,[[["__d"]],["result",["nonnarrowchar"]]]],[11,"decode","syntax::ext::hygiene","",160,[[["__d"]],["result",["mark"]]]],[11,"decode","syntax::codemap::symbol","",1,[[["d"]],["result",["ident"]]]],[11,"decode","syntax::ext::hygiene","",162,[[["__d"]],["result",["expninfo"]]]],[11,"decode","syntax::codemap","",170,[[["__d"]],["result",["multibytechar"]]]],[11,"decode","syntax::codemap::symbol","",2,[[["d"]],["result",["symbol"]]]],[11,"decode","","",6,[[["d"]],["result",["internedstring"]]]],[11,"decode","syntax::ext::quote::rt","",166,[[["__d"]],["result",["filename"]]]],[11,"deref","syntax::codemap::symbol","",5,[[["self"]],["str"]]],[11,"default_decode","syntax::ext::quote::rt","",188,[[["d"]],["result",["span"]]]],[11,"assert_receiver_is_total_eq","syntax::codemap","",185,N],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",160,N],[11,"assert_receiver_is_total_eq","syntax::codemap","",172,N],[11,"assert_receiver_is_total_eq","syntax::codemap::symbol","",6,N],[11,"assert_receiver_is_total_eq","syntax::codemap","",187,N],[11,"assert_receiver_is_total_eq","","",167,N],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",159,N],[11,"assert_receiver_is_total_eq","syntax::codemap","",171,N],[11,"assert_receiver_is_total_eq","","",186,N],[11,"assert_receiver_is_total_eq","syntax::codemap::symbol","",1,N],[11,"assert_receiver_is_total_eq","syntax::codemap","",168,N],[11,"assert_receiver_is_total_eq","syntax::ext::quote::rt","",175,N],[11,"assert_receiver_is_total_eq","","",166,N],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",161,N],[11,"assert_receiver_is_total_eq","","",164,N],[11,"assert_receiver_is_total_eq","syntax::codemap::symbol","",5,N],[11,"assert_receiver_is_total_eq","syntax::codemap","",176,N],[11,"assert_receiver_is_total_eq","","",170,N],[11,"assert_receiver_is_total_eq","","",184,N],[11,"assert_receiver_is_total_eq","syntax::codemap::symbol","",2,N],[11,"assert_receiver_is_total_eq","syntax::codemap::symbol::keywords","",4,N],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",163,N],[11,"assert_receiver_is_total_eq","syntax::codemap","",181,N],[11,"as_ref","syntax::codemap::symbol","",5,[[["self"]],["u"]]],[11,"from","syntax::codemap","",168,[[["span"]],["multispan"]]],[11,"from","syntax::ext::quote::rt","",166,[[["pathbuf"]],["filename"]]],[11,"from","syntax::codemap","",168,[[["vec",["span"]]],["multispan"]]],[11,"default_encode","syntax::ext::quote::rt","",188,[[["self"],["s"]],["result"]]],[11,"encode","syntax::codemap::symbol","",6,[[["self"],["s"]],["result"]]],[11,"encode","syntax::codemap","",170,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::ext::hygiene","",162,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::codemap","",171,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::ext::hygiene","",164,[[["self"],["__s"]],["result"]]],[11,"encode","","",163,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::ext::quote::rt","",166,[[["self"],["__s"]],["result"]]],[11,"encode","","",175,[[["self"],["s"]],["result"]]],[11,"encode","syntax::ext::hygiene","",159,[[["self"],["e"]],["result"]]],[11,"encode","syntax::codemap::symbol","",1,[[["self"],["s"]],["result"]]],[11,"encode","","",2,[[["self"],["s"]],["result"]]],[11,"encode","syntax::codemap","",168,[[["self"],["__s"]],["result"]]],[11,"encode","","",173,[[["self"],["s"]],["result"]]],[11,"encode","syntax::codemap::symbol","",5,[[["self"],["s"]],["result"]]],[11,"encode","syntax::codemap::edition","",0,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::ext::hygiene","",160,[[["self"],["__s"]],["result"]]],[11,"fmt","syntax::codemap::symbol","",6,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::quote::rt","",166,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap::edition","",0,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::codemap::symbol","",2,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result",["error"]]]],[11,"eq","","",1,[[["self"],["ident"]],["bool"]]],[11,"eq","syntax::ext::hygiene","",161,[[["self"],["transparency"]],["bool"]]],[11,"eq","syntax::codemap","",187,[[["self"],["malformedcodemappositions"]],["bool"]]],[11,"ne","","",187,[[["self"],["malformedcodemappositions"]],["bool"]]],[11,"eq","syntax::ext::hygiene","",164,[[["self"],["compilerdesugaringkind"]],["bool"]]],[11,"eq","","",159,[[["self"],["syntaxcontext"]],["bool"]]],[11,"ne","","",159,[[["self"],["syntaxcontext"]],["bool"]]],[11,"eq","syntax::ext::quote::rt","",188,[[["self"],["span"]],["bool"]]],[11,"eq","syntax::codemap","",172,[[["self"],["externalsource"]],["bool"]]],[11,"ne","","",172,[[["self"],["externalsource"]],["bool"]]],[11,"eq","syntax::codemap::symbol","",6,[[["self"],["internedstring"]],["bool"]]],[11,"eq","syntax::codemap","",186,[[["self"],["distinctsources"]],["bool"]]],[11,"ne","","",186,[[["self"],["distinctsources"]],["bool"]]],[11,"eq","syntax::ext::quote::rt","",166,[[["self"],["filename"]],["bool"]]],[11,"ne","","",166,[[["self"],["filename"]],["bool"]]],[11,"eq","syntax::codemap","",167,[[["self"],["spandata"]],["bool"]]],[11,"ne","","",167,[[["self"],["spandata"]],["bool"]]],[11,"eq","","",185,[[["self"],["spansnippeterror"]],["bool"]]],[11,"ne","","",185,[[["self"],["spansnippeterror"]],["bool"]]],[11,"eq","","",168,[[["self"],["multispan"]],["bool"]]],[11,"ne","","",168,[[["self"],["multispan"]],["bool"]]],[11,"eq","syntax::codemap::symbol","",6,[[["self"],["t"]],["bool"]]],[11,"eq","","",2,[[["self"],["t"]],["bool"]]],[11,"eq","","",5,[[["self"],["t"]],["bool"]]],[11,"eq","syntax::codemap","",184,[[["self"],["spanlineserror"]],["bool"]]],[11,"ne","","",184,[[["self"],["spanlineserror"]],["bool"]]],[11,"eq","syntax::ext::hygiene","",160,[[["self"],["mark"]],["bool"]]],[11,"ne","","",160,[[["self"],["mark"]],["bool"]]],[11,"eq","syntax::codemap::symbol::keywords","",4,[[["self"],["keyword"]],["bool"]]],[11,"ne","","",4,[[["self"],["keyword"]],["bool"]]],[11,"eq","syntax::codemap","",171,[[["self"],["nonnarrowchar"]],["bool"]]],[11,"ne","","",171,[[["self"],["nonnarrowchar"]],["bool"]]],[11,"eq","","",170,[[["self"],["multibytechar"]],["bool"]]],[11,"ne","","",170,[[["self"],["multibytechar"]],["bool"]]],[11,"eq","","",181,[[["self"],["lineinfo"]],["bool"]]],[11,"ne","","",181,[[["self"],["lineinfo"]],["bool"]]],[11,"eq","syntax::codemap::edition","",0,[[["self"],["edition"]],["bool"]]],[11,"eq","syntax::codemap","",176,[[["self"],["charpos"]],["bool"]]],[11,"ne","","",176,[[["self"],["charpos"]],["bool"]]],[11,"eq","syntax::ext::quote::rt","",175,[[["self"],["bytepos"]],["bool"]]],[11,"ne","","",175,[[["self"],["bytepos"]],["bool"]]],[11,"eq","syntax::codemap::symbol","",2,[[["self"],["symbol"]],["bool"]]],[11,"ne","","",2,[[["self"],["symbol"]],["bool"]]],[11,"eq","syntax::ext::hygiene","",163,[[["self"],["expnformat"]],["bool"]]],[11,"ne","","",163,[[["self"],["expnformat"]],["bool"]]],[11,"clone","syntax::ast","",44,[[["self"]],["floatty"]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result",["error"]]]],[11,"encode","","",44,[[["self"],["__s"]],["result"]]],[11,"cmp","","",44,[[["self"],["floatty"]],["ordering"]]],[11,"assert_receiver_is_total_eq","","",44,N],[11,"decode","","",44,[[["__d"]],["result",["floatty"]]]],[11,"partial_cmp","","",44,[[["self"],["floatty"]],["option",["ordering"]]]],[11,"hash","","",44,N],[11,"fmt","","",44,[[["self"],["formatter"]],["result",["error"]]]],[11,"eq","","",44,[[["self"],["floatty"]],["bool"]]],[11,"new","syntax::codemap::symbol","",1,[[["symbol"],["span"]],["ident"]]],[11,"with_empty_ctxt","","",1,[[["symbol"]],["ident"]]],[11,"from_interned_str","","Maps an interned string to an identifier with an empty syntax context.",1,[[["internedstring"]],["ident"]]],[11,"from_str","","Maps a string to an identifier with an empty syntax context.",1,[[["str"]],["ident"]]],[11,"with_span_pos","","Replace `lo` and `hi` with those from `span`, but keep hygiene context.",1,[[["self"],["span"]],["ident"]]],[11,"without_first_quote","","",1,[[["self"]],["ident"]]],[11,"modern","","\"Normalize\" ident for use in comparisons using \"item hygiene\". Identifiers with same string value become same if they came from the same \"modern\" macro (e.g. `macro` item, but not `macro_rules` item) and stay different if they came from different \"modern\" macros. Technically, this operation strips all non-opaque marks from ident's syntactic context.",1,[[["self"]],["ident"]]],[11,"modern_and_legacy","","\"Normalize\" ident for use in comparisons using \"local variable hygiene\". Identifiers with same string value become same if they came from the same non-transparent macro (e.g. `macro` or `macro_rules!` items) and stay different if they came from different non-transparent macros. Technically, this operation strips all transparent marks from ident's syntactic context.",1,[[["self"]],["ident"]]],[11,"gensym","","",1,[[["self"]],["ident"]]],[11,"as_str","","",1,[[["self"]],["localinternedstring"]]],[11,"as_interned_str","","",1,[[["self"]],["internedstring"]]],[11,"is_special","","",1,[[["self"]],["bool"]]],[11,"is_used_keyword","","Returns `true` if the token is a keyword used in the language.",1,[[["self"]],["bool"]]],[11,"is_unused_keyword","","Returns `true` if the token is a keyword reserved for possible future use.",1,[[["self"]],["bool"]]],[11,"is_reserved","","Returns `true` if the token is either a special identifier or a keyword.",1,[[["self"]],["bool"]]],[11,"is_path_segment_keyword","","A keyword or reserved identifier that can be used as a path segment.",1,[[["self"]],["bool"]]],[11,"is_raw_guess","","",1,[[["self"]],["bool"]]],[11,"intern","","Maps a string to its interned representation.",2,[[["str"]],["symbol"]]],[11,"interned","","",2,[[["self"]],["symbol"]]],[11,"gensym","","gensym's a new usize, using the current interner.",2,[[["str"]],["symbol"]]],[11,"gensymed","","",2,[[["self"]],["symbol"]]],[11,"as_str","","",2,[[["self"]],["localinternedstring"]]],[11,"as_interned_str","","",2,[[["self"]],["internedstring"]]],[11,"as_u32","","",2,[[["self"]],["u32"]]],[11,"new","","",3,[[],["interner"]]],[11,"intern","","",3,[[["self"],["str"]],["symbol"]]],[11,"interned","","",3,[[["self"],["symbol"]],["symbol"]]],[11,"get","","",3,[[["self"],["symbol"]],["str"]]],[11,"fresh","","",3,[[],["interner"]]],[11,"ident","syntax::codemap::symbol::keywords","",4,[[["self"]],["ident"]]],[11,"name","","",4,[[["self"]],["symbol"]]],[11,"as_interned_str","syntax::codemap::symbol","",5,[[["self"]],["internedstring"]]],[11,"with","","",6,[[["self"],["f"]],["r"]]],[11,"as_symbol","","",6,[[["self"]],["symbol"]]],[11,"as_str","","",6,[[["self"]],["localinternedstring"]]],[11,"stderr","syntax::diagnostics::plugin::emitter","",10,[[["colorconfig"],["option",["rc"]],["bool"],["bool"]],["emitterwriter"]]],[11,"new","","",10,[[["box",["write"]],["option",["rc"]],["bool"],["bool"]],["emitterwriter"]]],[11,"ui_testing","","",10,[[["self"],["bool"]],["emitterwriter"]]],[11,"new","syntax::diagnostics::plugin::registry","",13,N],[11,"find_description","","",13,[[["self"],["str"]],["option",["str"]]]],[11,"splice_lines","syntax::diagnostics::plugin","Returns the assembled code suggestions and whether they should be shown with an underline.",15,[[["self"],["codemapper"]],["vec"]]],[11,"raise","","",326,N],[11,"with_tty_emitter","","",19,[[["colorconfig"],["bool"],["bool"],["option",["rc"]]],["handler"]]],[11,"with_tty_emitter_and_flags","","",19,[[["colorconfig"],["option",["rc"]],["handlerflags"]],["handler"]]],[11,"with_emitter","","",19,[[["bool"],["bool"],["box",["emitter"]]],["handler"]]],[11,"with_emitter_and_flags","","",19,[[["box",["emitter"]],["handlerflags"]],["handler"]]],[11,"set_continue_after_error","","",19,N],[11,"reset_err_count","","Resets the diagnostic error count as well as the cached emitted diagnostics.",19,N],[11,"struct_dummy","","",19,[[["self"]],["diagnosticbuilder"]]],[11,"struct_span_warn","","",19,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_warn_with_code","","",19,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_warn","","",19,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err","","",19,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err_with_code","","",19,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_err","","",19,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_err_with_code","","",19,[[["self"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_span_fatal","","",19,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_fatal_with_code","","",19,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_fatal","","",19,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"cancel","","",19,N],[11,"span_fatal","","",19,[[["self"],["s"],["str"]],["fatalerror"]]],[11,"span_fatal_with_code","","",19,[[["self"],["s"],["str"],["diagnosticid"]],["fatalerror"]]],[11,"span_err","","",19,N],[11,"mut_span_err","","",19,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_err_with_code","","",19,N],[11,"span_warn","","",19,N],[11,"span_warn_with_code","","",19,N],[11,"span_bug","","",19,N],[11,"delay_span_bug","","",19,N],[11,"span_bug_no_panic","","",19,N],[11,"span_note_without_error","","",19,N],[11,"span_note_diag","","",19,[[["self"],["span"],["str"]],["diagnosticbuilder"]]],[11,"span_unimpl","","",19,N],[11,"failure","","",19,N],[11,"fatal","","",19,[[["self"],["str"]],["fatalerror"]]],[11,"err","","",19,N],[11,"warn","","",19,N],[11,"note_without_error","","",19,N],[11,"bug","","",19,N],[11,"unimpl","","",19,N],[11,"err_count","","",19,[[["self"]],["usize"]]],[11,"has_errors","","",19,[[["self"]],["bool"]]],[11,"print_error_count","","",19,N],[11,"abort_if_errors","","",19,N],[11,"emit","","",19,N],[11,"emit_with_code","","",19,N],[11,"must_teach","","`true` if we haven't taught a diagnostic with this code already. The caller must then teach the user about such a diagnostic.",19,[[["self"],["diagnosticid"]],["bool"]]],[11,"force_print_db","","",19,N],[11,"to_str","","",21,[[["self"]],["str"]]],[11,"is_failure_note","","",21,[[["self"]],["bool"]]],[11,"emit","","Emit the diagnostic.",23,N],[11,"buffer","","Buffers the diagnostic for later emission.",23,N],[11,"sub","","Convenience function for internal use, clients should use one of the span_* methods instead.",23,[[["self"],["level"],["str"],["option"]],["diagnosticbuilder"]]],[11,"delay_as_bug","","Delay emission of this diagnostic as a bug.",23,N],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",23,[[["self"],["span"],["t"]],["diagnosticbuilder"]]],[11,"note_expected_found","","",23,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"]],["diagnosticbuilder"]]],[11,"note_expected_found_extra","","",23,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"],["display"],["display"]],["diagnosticbuilder"]]],[11,"note","","",23,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_note","","",23,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"warn","","",23,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_warn","","",23,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"help","","",23,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_help","","",23,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_suggestion_short","","",23,[[["self"],["span"],["str"],["string"]],["diagnosticbuilder"]]],[11,"multipart_suggestion","","",23,[[["self"],["str"],["vec"]],["diagnosticbuilder"]]],[11,"span_suggestion","","",23,[[["self"],["span"],["str"],["string"]],["diagnosticbuilder"]]],[11,"span_suggestions","","",23,[[["self"],["span"],["str"],["vec",["string"]]],["diagnosticbuilder"]]],[11,"span_suggestion_with_applicability","","",23,[[["self"],["span"],["str"],["string"],["applicability"]],["diagnosticbuilder"]]],[11,"span_suggestions_with_applicability","","",23,[[["self"],["span"],["str"],["vec",["string"]],["applicability"]],["diagnosticbuilder"]]],[11,"span_suggestion_short_with_applicability","","",23,[[["self"],["span"],["str"],["string"],["applicability"]],["diagnosticbuilder"]]],[11,"set_span","","",23,[[["self"],["s"]],["diagnosticbuilder"]]],[11,"code","","",23,[[["self"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"new","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",23,[[["handler"],["level"],["str"]],["diagnosticbuilder"]]],[11,"new_with_code","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",23,[[["handler"],["level"],["option",["diagnosticid"]],["str"]],["diagnosticbuilder"]]],[11,"new_diagnostic","","Creates a new `DiagnosticBuilder` with an already constructed diagnostic.",23,[[["handler"],["diagnostic"]],["diagnosticbuilder"]]],[11,"new","","",25,[[],["diagnosticstyledstring"]]],[11,"push_normal","","",25,N],[11,"push_highlighted","","",25,N],[11,"normal","","",25,[[["s"]],["diagnosticstyledstring"]]],[11,"highlighted","","",25,[[["s"]],["diagnosticstyledstring"]]],[11,"content","","",25,[[["self"]],["string"]]],[11,"message","","",26,[[["self"]],["string"]]],[11,"styled_message","","",26,[[["self"]],["vec"]]],[11,"move_flat_map","syntax::ptr","",243,[[["self"],["f"]],["self"]]],[11,"ty_to_string","syntax::ast","",44,[[["self"]],["str"]]],[11,"bit_width","","",44,[[["self"]],["usize"]]],[11,"attrs","syntax::codemap","",189,N],[11,"map_attrs","","",189,[[["self"],["f"]],["self"]]],[11,"attrs","syntax::ptr","",243,N],[11,"map_attrs","","",243,[[["self"],["f"]],["self"]]],[11,"empty","syntax::ext::hygiene","",159,[[],["syntaxcontext"]]],[11,"allocate_directly","","",159,[[["expninfo"]],["syntaxcontext"]]],[11,"apply_mark","","Extend a syntax context with a given mark and default transparency for that mark.",159,[[["self"],["mark"]],["syntaxcontext"]]],[11,"apply_mark_with_transparency","","Extend a syntax context with a given mark and transparency",159,[[["self"],["mark"],["transparency"]],["syntaxcontext"]]],[11,"remove_mark","","Pulls a single mark off of the syntax context. This effectively moves the context up one macro definition level. That is, if we have a nested macro definition as follows:",159,[[["self"]],["mark"]]],[11,"marks","","",159,[[["self"]],["vec"]]],[11,"adjust","","Adjust this context for resolution in a scope created by the given expansion. For example, consider the following three resolutions of `f`:",159,[[["self"],["mark"]],["option",["mark"]]]],[11,"glob_adjust","","Adjust this context for resolution in a scope created by the given expansion via a glob import with the given `SyntaxContext`. For example:",159,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"reverse_glob_adjust","","Undo `glob_adjust` if possible:",159,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"modern","","",159,[[["self"]],["syntaxcontext"]]],[11,"modern_and_legacy","","",159,[[["self"]],["syntaxcontext"]]],[11,"outer","","",159,[[["self"]],["mark"]]],[11,"fresh","","",160,[[["mark"]],["mark"]]],[11,"root","","The mark of the theoretical expansion that generates freshly parsed, unexpanded AST.",160,[[],["mark"]]],[11,"as_u32","","",160,[[["self"]],["u32"]]],[11,"from_u32","","",160,[[["u32"]],["mark"]]],[11,"expn_info","","",160,[[["self"]],["option",["expninfo"]]]],[11,"set_expn_info","","",160,N],[11,"set_default_transparency","","",160,N],[11,"is_builtin","","",160,[[["self"]],["bool"]]],[11,"set_is_builtin","","",160,N],[11,"is_descendant_of","","",160,[[["self"],["mark"]],["bool"]]],[11,"least_ancestor","","Computes a mark such that both input marks are descendants of (or equal to) the returned mark. That is, the following holds:",160,[[["mark"],["mark"]],["mark"]]],[11,"looks_like_proc_macro_derive","","",160,[[["self"]],["bool"]]],[11,"name","","",163,[[["self"]],["symbol"]]],[11,"name","","",164,[[["self"]],["symbol"]]],[11,"new","syntax::codemap","",165,[[],["globals"]]],[11,"is_real","syntax::ext::quote::rt","",166,[[["self"]],["bool"]]],[11,"is_macros","","",166,[[["self"]],["bool"]]],[11,"with_lo","syntax::codemap","",167,[[["self"],["bytepos"]],["span"]]],[11,"with_hi","","",167,[[["self"],["bytepos"]],["span"]]],[11,"with_ctxt","","",167,[[["self"],["syntaxcontext"]],["span"]]],[11,"new","","",168,[[],["multispan"]]],[11,"from_span","","",168,[[["span"]],["multispan"]]],[11,"from_spans","","",168,[[["vec",["span"]]],["multispan"]]],[11,"push_span_label","","",168,N],[11,"primary_span","","Selects the first primary span (if any)",168,[[["self"]],["option",["span"]]]],[11,"primary_spans","","Returns all primary spans.",168,N],[11,"replace","","Replaces all occurrences of one Span with another. Used to move Spans in areas that don't display well (like std macros). Returns true if replacements occurred.",168,[[["self"],["span"],["span"]],["bool"]]],[11,"span_labels","","Returns the strings to highlight. We always ensure that there is an entry for each of the primary spans -- for each primary span P, if there is at least one label with span P, we return those labels (marked as primary). But otherwise we return `SpanLabel` instances with empty labels.",168,[[["self"]],["vec",["spanlabel"]]]],[11,"pos","","Returns the absolute offset of the character in the CodeMap",171,[[["self"]],["bytepos"]]],[11,"width","","Returns the width of the character, 0 (zero-width) or 2 (wide)",171,[[["self"]],["usize"]]],[11,"is_absent","","",172,[[["self"]],["bool"]]],[11,"get_source","","",172,[[["self"]],["option",["str"]]]],[11,"new","","",173,[[["filename"],["bool"],["filename"],["string"],["bytepos"]],["filemap"]]],[11,"line_begin_pos","","Return the BytePos of the beginning of the current line.",173,[[["self"],["bytepos"]],["bytepos"]]],[11,"add_external_src","","Add externally loaded source. If the hash of the input doesn't match or no input is supplied via None, it is interpreted as an error and the corresponding enum variant is set. The return value signifies whether some kind of source is present.",173,[[["self"],["f"]],["bool"]]],[11,"get_line","","Get a line from the list of pre-computed line-beginnings. The line number here is 0-based.",173,[[["self"],["usize"]],["option",["cow"]]]],[11,"is_real_file","","",173,[[["self"]],["bool"]]],[11,"is_imported","","",173,[[["self"]],["bool"]]],[11,"byte_length","","",173,[[["self"]],["u32"]]],[11,"count_lines","","",173,[[["self"]],["usize"]]],[11,"lookup_line","","Find the line containing the given position. The return value is the index into the `lines` array of this FileMap, not the 1-based line number. If the filemap is empty or the position is located before the first line, None is returned.",173,[[["self"],["bytepos"]],["option",["usize"]]]],[11,"line_bounds","","",173,N],[11,"contains","","",173,[[["self"],["bytepos"]],["bool"]]],[11,"new","syntax::ext::quote::rt","",188,[[["bytepos"],["bytepos"],["syntaxcontext"]],["span"]]],[11,"data","","",188,[[["self"]],["spandata"]]],[11,"lo","","",188,[[["self"]],["bytepos"]]],[11,"with_lo","","",188,[[["self"],["bytepos"]],["span"]]],[11,"hi","","",188,[[["self"]],["bytepos"]]],[11,"with_hi","","",188,[[["self"],["bytepos"]],["span"]]],[11,"ctxt","","",188,[[["self"]],["syntaxcontext"]]],[11,"with_ctxt","","",188,[[["self"],["syntaxcontext"]],["span"]]],[11,"is_dummy","","Returns `true` if this is a dummy span with any hygienic context.",188,[[["self"]],["bool"]]],[11,"shrink_to_lo","","Returns a new span representing an empty span at the beginning of this span",188,[[["self"]],["span"]]],[11,"shrink_to_hi","","Returns a new span representing an empty span at the end of this span",188,[[["self"]],["span"]]],[11,"substitute_dummy","","Returns `self` if `self` is not the dummy span, and `other` otherwise.",188,[[["self"],["span"]],["span"]]],[11,"contains","","Return true if `self` fully encloses `other`.",188,[[["self"],["span"]],["bool"]]],[11,"source_equal","","Return true if the spans are equal with regards to the source text.",188,[[["self"],["span"]],["bool"]]],[11,"trim_start","","Returns `Some(span)`, where the start is trimmed by the end of `other`",188,[[["self"],["span"]],["option",["span"]]]],[11,"source_callsite","","Return the source span - this is either the supplied span, or the span for the macro callsite that expanded to it.",188,[[["self"]],["span"]]],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated, if any",188,[[["self"]],["option",["span"]]]],[11,"edition","","Edition of the crate from which this span came.",188,[[["self"]],["edition"]]],[11,"source_callee","","Return the source callee.",188,[[["self"]],["option",["expninfo"]]]],[11,"allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable] items can be used (that is, a macro marked with `#[allow_internal_unstable]`).",188,[[["self"]],["bool"]]],[11,"is_compiler_desugaring","","Check if this span arises from a compiler desugaring of kind `kind`.",188,[[["self"],["compilerdesugaringkind"]],["bool"]]],[11,"compiler_desugaring_kind","","Return the compiler desugaring that created this span, or None if this span is not from a desugaring.",188,[[["self"]],["option",["compilerdesugaringkind"]]]],[11,"allows_unsafe","","Check if a span is \"internal\" to a macro in which `unsafe` can be used without triggering the `unsafe_code` lint",188,[[["self"]],["bool"]]],[11,"macro_backtrace","","",188,[[["self"]],["vec",["macrobacktrace"]]]],[11,"to","","Return a `Span` that would enclose both `self` and `end`.",188,[[["self"],["span"]],["span"]]],[11,"between","","Return a `Span` between the end of `self` to the beginning of `end`.",188,[[["self"],["span"]],["span"]]],[11,"until","","Return a `Span` between the beginning of `self` to the beginning of `end`.",188,[[["self"],["span"]],["span"]]],[11,"from_inner_byte_pos","","",188,[[["self"],["usize"],["usize"]],["span"]]],[11,"apply_mark","","",188,[[["self"],["mark"]],["span"]]],[11,"remove_mark","","",188,[[["self"]],["mark"]]],[11,"adjust","","",188,[[["self"],["mark"]],["option",["mark"]]]],[11,"glob_adjust","","",188,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"reverse_glob_adjust","","",188,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"modern","","",188,[[["self"]],["span"]]],[11,"modern_and_legacy","","",188,[[["self"]],["span"]]],[11,"make_expr","syntax::ext::tt::macro_rules","",315,[[["box",["parseranymacro"]]],["option",["p"]]]],[11,"make_pat","","",315,[[["box",["parseranymacro"]]],["option",["p"]]]],[11,"make_ty","","",315,[[["box",["parseranymacro"]]],["option",["p"]]]],[11,"make_stmts","","",315,[[["box",["parseranymacro"]]],["option",["smallvector"]]]],[11,"make_items","","",315,[[["box",["parseranymacro"]]],["option",["smallvector"]]]],[11,"make_trait_items","","",315,[[["box",["parseranymacro"]]],["option",["smallvector"]]]],[11,"make_impl_items","","",315,[[["box",["parseranymacro"]]],["option",["smallvector"]]]],[11,"make_foreign_items","","",315,[[["box",["parseranymacro"]]],["option",["smallvector"]]]]],"paths":[[4,"Edition"],[3,"Ident"],[3,"Symbol"],[3,"Interner"],[3,"Keyword"],[3,"LocalInternedString"],[3,"InternedString"],[3,"Globals"],[8,"Emitter"],[4,"ColorConfig"],[3,"EmitterWriter"],[4,"Destination"],[4,"WritableDst"],[3,"Registry"],[4,"Applicability"],[3,"CodeSuggestion"],[3,"Substitution"],[3,"SubstitutionPart"],[8,"CodeMapper"],[3,"Handler"],[3,"HandlerFlags"],[4,"Level"],[3,"Diagnostic"],[3,"DiagnosticBuilder"],[4,"DiagnosticId"],[3,"DiagnosticStyledString"],[3,"SubDiagnostic"],[3,"ErrorInfo"],[3,"ErrorMetadata"],[3,"ErrorLocation"],[3,"ThinVec"],[3,"RcSlice"],[3,"NodeCounter"],[4,"AssocOp"],[4,"Fixity"],[4,"ExprPrecedence"],[8,"MoveMap"],[6,"SmallVector"],[3,"JsonEmitter"],[3,"Diagnostic"],[3,"DiagnosticSpan"],[3,"DiagnosticSpanLine"],[3,"DiagnosticSpanMacroExpansion"],[3,"DiagnosticCode"],[4,"FloatTy"],[3,"Label"],[3,"Lifetime"],[3,"Path"],[3,"PathSegment"],[3,"AngleBracketedArgs"],[3,"ParenthesisedArgs"],[3,"NodeId"],[3,"GenericParam"],[3,"Generics"],[3,"WhereClause"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[3,"MetaItem"],[3,"Block"],[3,"Pat"],[3,"FieldPat"],[3,"Stmt"],[3,"Local"],[3,"Arm"],[3,"Field"],[3,"AnonConst"],[3,"Expr"],[3,"QSelf"],[3,"Mac_"],[3,"MacroDef"],[3,"MutTy"],[3,"MethodSig"],[3,"TraitItem"],[3,"ImplItem"],[3,"TypeBinding"],[3,"Ty"],[3,"BareFnTy"],[3,"InlineAsmOutput"],[3,"InlineAsm"],[3,"Arg"],[3,"FnDecl"],[3,"Mod"],[3,"ForeignMod"],[3,"GlobalAsm"],[3,"EnumDef"],[3,"Variant_"],[3,"UseTree"],[3,"AttrId"],[3,"Attribute"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"StructField"],[3,"Item"],[3,"FnHeader"],[3,"ForeignItem"],[4,"GenericArgs"],[4,"GenericArg"],[4,"TraitBoundModifier"],[4,"GenericBound"],[4,"GenericParamKind"],[4,"WherePredicate"],[4,"NestedMetaItemKind"],[4,"MetaItemKind"],[4,"BindingMode"],[4,"RangeEnd"],[4,"RangeSyntax"],[4,"PatKind"],[4,"Mutability"],[4,"BinOpKind"],[4,"UnOp"],[4,"StmtKind"],[4,"MacStmtStyle"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[4,"RangeLimits"],[4,"ExprKind"],[4,"CaptureBy"],[4,"Movability"],[4,"MacDelimiter"],[4,"StrStyle"],[4,"LitIntType"],[4,"LitKind"],[4,"TraitItemKind"],[4,"ImplItemKind"],[4,"IntTy"],[4,"UintTy"],[4,"TyKind"],[4,"TraitObjectSyntax"],[4,"AsmDialect"],[4,"SelfKind"],[4,"IsAuto"],[4,"Unsafety"],[4,"IsAsync"],[4,"Constness"],[4,"Defaultness"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[4,"UseTreeKind"],[4,"AttrStyle"],[4,"CrateSugar"],[4,"VisibilityKind"],[4,"VariantData"],[4,"ItemKind"],[4,"ForeignItemKind"],[3,"Deprecation"],[3,"RustcConstUnstable"],[3,"RustcDeprecation"],[3,"Stability"],[4,"InlineAttr"],[4,"IntType"],[4,"ReprAttr"],[4,"StabilityLevel"],[4,"UnwindAttr"],[4,"AttrError"],[8,"HasAttrs"],[6,"NestedMetaItem"],[6,"Lit"],[3,"SyntaxContext"],[3,"Mark"],[4,"Transparency"],[3,"ExpnInfo"],[4,"ExpnFormat"],[4,"CompilerDesugaringKind"],[3,"Globals"],[4,"FileName"],[3,"SpanData"],[3,"MultiSpan"],[3,"SpanLabel"],[3,"MultiByteChar"],[4,"NonNarrowChar"],[4,"ExternalSource"],[3,"FileMap"],[8,"Pos"],[3,"BytePos"],[3,"CharPos"],[3,"Loc"],[3,"LocWithOpt"],[3,"FileMapAndLine"],[3,"FileMapAndBytePos"],[3,"LineInfo"],[3,"FileLines"],[3,"MacroBacktrace"],[4,"SpanLinesError"],[4,"SpanSnippetError"],[3,"DistinctSources"],[3,"MalformedCodemapPositions"],[3,"Span"],[3,"Spanned"],[3,"StableFilemapId"],[3,"CodeMapFiles"],[3,"CodeMap"],[3,"FilePathMapping"],[8,"FileLoader"],[3,"RealFileLoader"],[3,"StripUnconfigured"],[4,"EntryPointType"],[3,"Features"],[3,"GatedCfg"],[3,"Context"],[3,"PostExpansionVisitor"],[3,"FeatureChecker"],[4,"AttributeType"],[4,"AttributeGate"],[4,"Stability"],[4,"GateIssue"],[4,"GateStrength"],[4,"UnstableFeatures"],[8,"Folder"],[3,"ParseSess"],[3,"Directory"],[3,"SeqSep"],[4,"DirectoryOwnership"],[3,"Restrictions"],[3,"Parser"],[3,"TokenCursor"],[3,"TokenCursorFrame"],[3,"ModulePath"],[3,"ModulePathSuccess"],[4,"AliasKind"],[4,"PathStyle"],[4,"SemiColonMode"],[4,"BlockMode"],[4,"PrevTokenKind"],[4,"LastToken"],[4,"TokenType"],[4,"Error"],[4,"LhsExpr"],[4,"TokenExpectType"],[8,"RecoverQPath"],[3,"TokenAndSpan"],[3,"StringReader"],[3,"Comment"],[3,"Literal"],[4,"CommentStyle"],[3,"LazyTokenStream"],[4,"BinOpToken"],[4,"DelimToken"],[4,"Lit"],[4,"Token"],[4,"Nonterminal"],[4,"InnerAttributeParsePolicy"],[3,"P"],[3,"ShowSpanVisitor"],[4,"Mode"],[3,"Test"],[3,"TestCtxt"],[3,"TestHarnessGenerator"],[3,"EntryPointCleaner"],[4,"ShouldPanic"],[4,"HasTestSignature"],[4,"BadTestSignature"],[3,"Delimited"],[3,"TokenStream"],[3,"TokenStreamBuilder"],[3,"Cursor"],[3,"StreamCursor"],[3,"ThinTokenStream"],[4,"TokenTree"],[4,"TokenStreamKind"],[4,"CursorKind"],[4,"FnKind"],[8,"Visitor"],[3,"BreakToken"],[3,"BeginToken"],[3,"PrintStackElem"],[3,"Printer"],[3,"BufEntry"],[4,"Breaks"],[4,"Token"],[4,"PrintStackBreak"],[3,"State"],[4,"AnnNode"],[8,"PpAnn"],[8,"PrintState"],[3,"NoAnn"],[3,"MacEager"],[3,"DummyResult"],[3,"ModuleData"],[3,"ExpansionData"],[3,"ExtCtxt"],[4,"Annotatable"],[4,"MacroKind"],[4,"SyntaxExtension"],[4,"Determinacy"],[8,"MultiItemDecorator"],[8,"MultiItemModifier"],[8,"ProcMacro"],[8,"AttrProcMacro"],[8,"TTMacroExpander"],[8,"IdentMacroExpander"],[8,"MacResult"],[8,"Resolver"],[3,"DummyResolver"],[8,"AstBuilder"],[3,"Invocation"],[3,"MacroExpander"],[3,"InvocationCollector"],[3,"ExpansionConfig"],[3,"Marker"],[4,"AstFragment"],[4,"AstFragmentKind"],[4,"InvocationKind"],[3,"PlaceholderExpander"],[8,"ToTokens"],[8,"ExtParseUtils"],[4,"Frame"],[4,"LockstepIterSize"],[3,"MatcherTtFrame"],[3,"MatcherPos"],[4,"TokenTreeOrTokenTreeSlice"],[4,"MatcherPosHandle"],[4,"ParseResult"],[4,"NamedMatch"],[3,"ParserAnyMacro"],[3,"MacroRulesMacroExpander"],[3,"FirstSets"],[3,"TokenSet"],[3,"Delimited"],[3,"SequenceRepetition"],[4,"KleeneOp"],[4,"TokenTree"],[3,"BufferedEarlyLint"],[4,"BufferedEarlyLintId"],[3,"ExplicitBug"],[3,"FatalError"]]};
searchIndex["syntax_ext"]={"doc":"Syntax extensions in the Rust compiler.","items":[[5,"register_builtins","syntax_ext","",N,[[["resolver"],["vec",["namedsyntaxextension"]],["bool"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0660","syntax_ext::diagnostics","",N,N],[0,"__register_diagnostic_E0661","","",N,N],[0,"__register_diagnostic_E0662","","",N,N],[0,"__register_diagnostic_E0663","","",N,N],[0,"__register_diagnostic_E0664","","",N,N],[0,"__register_diagnostic_E0665","","",N,N],[0,"deriving","syntax_ext","The compiler code necessary to implement the `#[derive]` extensions.",N,N],[5,"is_builtin_trait","syntax_ext::deriving","",N,[[["name"]],["bool"]]],[5,"register_builtin_derives","","",N,[[["resolver"]]]],[5,"warn_if_deprecated","","",N,[[["extctxt"],["span"],["str"]]]],[5,"hygienic_type_parameter","","Construct a name for the inner type parameter that can't collide with any type parameters of the item. This is achieved by starting with a base and then concatenating the names of all other type parameters.",N,[[["annotatable"],["str"]],["string"]]],[5,"call_intrinsic","","Constructs an expression that calls an intrinsic",N,[[["extctxt"],["span"],["str"],["vec",["p"]]],["p",["expr"]]]],[0,"bounds","","",N,N],[5,"expand_deriving_unsafe_bound","syntax_ext::deriving::bounds","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_copy","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[0,"clone","syntax_ext::deriving","",N,N],[5,"expand_deriving_clone","syntax_ext::deriving::clone","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"cs_clone_shallow","","",N,[[["str"],["extctxt"],["span"],["substructure"],["bool"]],["p",["expr"]]]],[5,"cs_clone","","",N,[[["str"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"encodable","syntax_ext::deriving","The compiler code necessary to implement the `#[derive(Encodable)]` (and `Decodable`, in decodable.rs) extension.  The idea here is that type-defining items may be tagged with `#[derive(Encodable, Decodable)]`.",N,N],[5,"expand_deriving_rustc_encodable","syntax_ext::deriving::encodable","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_encodable","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_encodable_imp","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"],["str"]]]],[5,"encodable_substructure","","",N,[[["extctxt"],["span"],["substructure"],["str"]],["p",["expr"]]]],[0,"decodable","syntax_ext::deriving","The compiler code necessary for `#[derive(Decodable)]`. See encodable.rs for more.",N,N],[5,"expand_deriving_rustc_decodable","syntax_ext::deriving::decodable","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_decodable","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_decodable_imp","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"],["str"]]]],[5,"decodable_substructure","","",N,[[["extctxt"],["span"],["substructure"],["str"]],["p",["expr"]]]],[5,"decode_static_fields","","Create a decoder for a single enum variant/struct: - `outer_pat_path` is the path to this enum variant/struct - `getarg` should retrieve the `usize`-th field with name `@str`.",N,[[["extctxt"],["span"],["path"],["staticfields"],["f"]],["p",["expr"]]]],[0,"hash","syntax_ext::deriving","",N,N],[5,"expand_deriving_hash","syntax_ext::deriving::hash","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"hash_substructure","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"debug","syntax_ext::deriving","",N,N],[5,"expand_deriving_debug","syntax_ext::deriving::debug","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"show_substructure","","We use the debug builders to do the heavy lifting here",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"stmt_let_undescore","","",N,[[["extctxt"],["span"],["p",["expr"]]],["stmt"]]],[0,"default","syntax_ext::deriving","",N,N],[5,"expand_deriving_default","syntax_ext::deriving::default","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"default_substructure","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"custom","syntax_ext::deriving","",N,N],[3,"MarkAttrs","syntax_ext::deriving::custom","",N,N],[12,"0","","",0,N],[3,"ProcMacroDerive","","",N,N],[12,"inner","","",1,N],[12,"attrs","","",1,N],[11,"visit_attribute","","",0,[[["self"],["attribute"]]]],[11,"visit_mac","","",0,[[["self"],["mac"]]]],[11,"new","","",1,N],[11,"expand","","",1,[[["self"],["extctxt"],["span"],["metaitem"],["annotatable"]],["vec",["annotatable"]]]],[0,"partial_eq","syntax_ext::deriving","",N,N],[5,"expand_deriving_partial_eq","syntax_ext::deriving::partial_eq","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[0,"eq","syntax_ext::deriving","",N,N],[5,"expand_deriving_eq","syntax_ext::deriving::eq","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"cs_total_eq_assert","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"partial_ord","syntax_ext::deriving","",N,N],[4,"OrderingOp","syntax_ext::deriving::partial_ord","",N,N],[13,"PartialCmpOp","","",2,N],[13,"LtOp","","",2,N],[13,"LeOp","","",2,N],[13,"GtOp","","",2,N],[13,"GeOp","","",2,N],[5,"expand_deriving_partial_ord","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"some_ordering_collapsed","","",N,N],[5,"cs_partial_cmp","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"cs_op","","Strict inequality.",N,[[["bool"],["bool"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[11,"clone","","",2,[[["self"]],["orderingop"]]],[0,"ord","syntax_ext::deriving","",N,N],[5,"expand_deriving_ord","syntax_ext::deriving::ord","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"ordering_collapsed","","",N,N],[5,"cs_cmp","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"generic","syntax_ext::deriving","Some code that abstracts away much of the boilerplate of writing `derive` instances for traits. Among other things it manages getting access to the fields of the 4 different sorts of structs and enum variants, as well as creating the method and impl ast instances.",N,N],[3,"TraitDef","syntax_ext::deriving::generic","",N,N],[12,"span","","The span for the current #[derive(Foo)] header.",3,N],[12,"attributes","","",3,N],[12,"path","","Path of the trait, including any type parameters",3,N],[12,"additional_bounds","","Additional bounds required of any type parameters of the type, other than the current trait",3,N],[12,"generics","","Any extra lifetimes and/or bounds, e.g. `D: serialize::Decoder`",3,N],[12,"is_unsafe","","Is it an `unsafe` trait?",3,N],[12,"supports_unions","","Can this trait be derived for unions?",3,N],[12,"methods","","",3,N],[12,"associated_types","","",3,N],[3,"MethodDef","","",N,N],[12,"name","","name of the method",4,N],[12,"generics","","List of generics, e.g. `R: rand::Rng`",4,N],[12,"explicit_self","","Whether there is a self argument (outer Option) i.e. whether this is a static function, and whether it is a pointer (inner Option)",4,N],[12,"args","","Arguments other than the self argument",4,N],[12,"ret_ty","","Return type",4,N],[12,"attributes","","",4,N],[12,"is_unsafe","","",4,N],[12,"unify_fieldless_variants","","Can we combine fieldless variants for enums into a single match arm?",4,N],[12,"combine_substructure","","",4,N],[3,"Substructure","","All the data about the data structure/method being derived upon.",N,N],[12,"type_ident","","ident of self",5,N],[12,"method_ident","","ident of the method",5,N],[12,"self_args","","dereferenced access to any `Self_` or `Ptr(Self_, _)` arguments",5,N],[12,"nonself_args","","verbatim access to any other arguments",5,N],[12,"fields","","",5,N],[3,"FieldInfo","","Summary of the relevant parts of a struct/enum field.",N,N],[12,"span","","",6,N],[12,"name","","None for tuple structs/normal enum variants, Some for normal structs/struct enum variants.",6,N],[12,"self_","","The expression corresponding to this field of `self` (specifically, a reference to it).",6,N],[12,"other","","The expressions corresponding to references to this field in the other `Self` arguments.",6,N],[12,"attrs","","The attributes on the field",6,N],[4,"StaticFields","","Fields for a static method",N,N],[13,"Unnamed","","Tuple and unit structs/enum variants like this.",7,N],[13,"Named","","Normal structs/struct variants.",7,N],[4,"SubstructureFields","","A summary of the possible sets of fields.",N,N],[13,"Struct","","",8,N],[13,"EnumMatching","","Matching variants of the enum: variant index, variant count, ast::Variant, fields: the field name is only non-`None` in the case of a struct variant.",8,N],[13,"EnumNonMatchingCollapsed","","Non-matching variants of the enum, but with all state hidden from the consequent code.  The first component holds `Ident`s for all of the `Self` arguments; the second component is a slice of all of the variants for the enum itself, and the third component is a list of `Ident`s bound to the variant index values for each of the actual input `Self` arguments.",8,N],[13,"StaticStruct","","A static method where `Self` is a struct.",8,N],[13,"StaticEnum","","A static method where `Self` is an enum.",8,N],[5,"combine_substructure","","",N,[[["combinesubstructurefunc"]],["refcell",["combinesubstructurefunc"]]]],[5,"find_type_parameters","","This method helps to extract all the type parameters referenced from a type. For a type parameter `<T>`, it looks for either a `TyPath` that is not global and starts with `T`, or a `TyQPath`.",N,N],[5,"find_repr_type_name","","",N,N],[5,"cs_fold_fields","","",N,N],[5,"cs_fold_enumnonmatch","","",N,[[["enumnonmatchcollapsedfunc"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"cs_fold_static","","",N,[[["extctxt"],["span"]],["p",["expr"]]]],[5,"cs_fold","","Fold the fields. `use_foldl` controls whether this is done left-to-right (`true`) or right-to-left (`false`).",N,[[["bool"],["f"],["p",["expr"]],["enumnonmatchcollapsedfunc"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"cs_fold1","","Function to fold over fields, with three cases, to generate more efficient and concise code. When the `substructure` has grouped fields, there are two cases: Zero fields: call the base case function with None (like the usual base case of `cs_fold`). One or more fields: call the base case function on the first value (which depends on `use_fold`), and use that as the base case. Then perform `cs_fold` on the remainder of the fields. When the `substructure` is a `EnumNonMatchingCollapsed`, the result of `enum_nonmatch_f` is returned. Statics may not be folded over. See `cs_op` in `partial_ord.rs` for a model example.",N,[[["bool"],["f"],["b"],["enumnonmatchcollapsedfunc"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"cs_same_method","","Call the method that is being derived on all the fields, and then process the collected results. i.e.",N,[[["f"],["enumnonmatchcollapsedfunc"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"is_type_without_fields","","Return true if the type has no value fields (for an enum, no variant has any fields)",N,[[["annotatable"]],["bool"]]],[0,"ty","","A mini version of ast::Ty, which is easier to use, and features an explicit `Self` type to use when specifying impls to be derived.",N,N],[3,"Path","syntax_ext::deriving::generic::ty","A path, e.g. `::std::option::Option::<i32>` (global). Has support for type parameters and a lifetime.",N,N],[12,"path","","",9,N],[12,"lifetime","","",9,N],[12,"params","","",9,N],[12,"kind","","",9,N],[3,"LifetimeBounds","","Lifetimes and bounds on type parameters",N,N],[12,"lifetimes","","",10,N],[12,"bounds","","",10,N],[4,"PtrTy","","The types of pointers",N,N],[13,"Borrowed","","&'lifetime mut",11,N],[13,"Raw","","*mut",11,N],[4,"PathKind","","",N,N],[13,"Local","","",12,N],[13,"Global","","",12,N],[13,"Std","","",12,N],[4,"Ty","","A type. Supports pointers, Self, and literals",N,N],[13,"Self_","","",13,N],[13,"Ptr","","&/Box/ Ty",13,N],[13,"Literal","","mod::mod::Type<[lifetime], [Params...]>, including a plain type parameter, and things like `i32`",13,N],[13,"Tuple","","includes unit",13,N],[5,"borrowed_ptrty","","",N,[[],["ptrty"]]],[5,"borrowed","","",N,[[["box",["ty"]]],["ty"]]],[5,"borrowed_explicit_self","","",N,[[],["option",["option"]]]],[5,"borrowed_self","","",N,[[],["ty"]]],[5,"nil_ty","","",N,[[],["ty"]]],[5,"mk_lifetime","","",N,[[["extctxt"],["span"],["option"]],["option",["lifetime"]]]],[5,"mk_lifetimes","","",N,[[["extctxt"],["span"],["option"]],["vec",["lifetime"]]]],[5,"mk_ty_param","","",N,N],[5,"mk_generics","","",N,[[["vec",["genericparam"]],["span"]],["generics"]]],[5,"get_explicit_self","","",N,N],[11,"clone","","",11,[[["self"]],["ptrty"]]],[11,"clone","","",9,[[["self"]],["path"]]],[11,"clone","","",12,[[["self"]],["pathkind"]]],[11,"new","","",9,[[["vec",["str"]]],["path"]]],[11,"new_local","","",9,[[["str"]],["path"]]],[11,"new_","","",9,[[["vec",["str"]],["option",["str"]],["vec",["box"]],["pathkind"]],["path"]]],[11,"to_ty","","",9,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["p",["ty"]]]],[11,"to_path","","",9,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["path"]]],[11,"clone","","",13,[[["self"]],["ty"]]],[11,"to_ty","","",13,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["p",["ty"]]]],[11,"to_path","","",13,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["path"]]],[11,"clone","","",10,[[["self"]],["lifetimebounds"]]],[11,"empty","","",10,[[],["lifetimebounds"]]],[11,"to_generics","","",10,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["generics"]]],[6,"CombineSubstructureFunc","syntax_ext::deriving::generic","Combine the values of all the fields together. The last argument is all the fields of all the structures.",N,N],[6,"EnumNonMatchCollapsedFunc","","Deal with non-matching enum variants.  The tuple is a list of identifiers (one for each `Self` argument, which could be any of the variants since they have been collapsed together) and the identifiers holding the variant index value for each of the `Self` arguments.  The last argument is all the non-`Self` args of the method being derived.",N,N],[11,"expand","","",3,[[["self"],["extctxt"],["metaitem"],["annotatable"],["fnmut"]]]],[11,"expand_ext","","",3,[[["self"],["extctxt"],["metaitem"],["annotatable"],["fnmut"],["bool"]]]],[11,"create_derived_impl","","Given that we are deriving a trait `DerivedTrait` for a type like:",3,[[["self"],["extctxt"],["ident"],["generics"],["vec",["p"]],["vec",["implitem"]]],["p",["item"]]]],[11,"expand_struct_def","","",3,[[["self"],["extctxt"],["variantdata"],["ident"],["generics"],["bool"],["bool"]],["p",["item"]]]],[11,"expand_enum_def","","",3,N],[11,"call_substructure_method","","",4,N],[11,"get_ret_ty","","",4,[[["self"],["extctxt"],["traitdef"],["generics"],["ident"]],["p",["ty"]]]],[11,"is_static","","",4,[[["self"]],["bool"]]],[11,"split_self_nonself_args","","",4,N],[11,"create_method","","",4,[[["self"],["extctxt"],["traitdef"],["ident"],["generics"],["abi"],["option",["explicitself"]],["vec"],["p",["expr"]]],["implitem"]]],[11,"expand_struct_method_body","","",4,N],[11,"expand_static_struct_method_body","","",4,N],[11,"expand_enum_method_body","","",4,N],[11,"build_enum_match_tuple","","Creates a match for a tuple of all `self_args`, where either all variants match, or it falls into a catch-all for when one variant does not match. There are N + 1 cases because is a case for each of the N variants where all of the variants match, and one catch-all for when one does not match. As an optimization we generate code which checks whether all variants match first which makes llvm see that C-like enums can be compiled into a simple equality check (for PartialEq). The catch-all handler is provided access the variant index values for each of the self-args, carried in precomputed variables. ```{.text} let __self0_vi = unsafe {     std::intrinsics::discriminant_value(&self) } as i32; let __self1_vi = unsafe {     std::intrinsics::discriminant_value(&arg1) } as i32; let __self2_vi = unsafe {     std::intrinsics::discriminant_value(&arg2) } as i32;",4,N],[11,"expand_static_enum_method_body","","",4,N],[11,"summarise_struct","","",3,[[["self"],["extctxt"],["variantdata"]],["staticfields"]]],[11,"create_subpatterns","","",3,[[["self"],["extctxt"],["vec",["ident"]],["mutability"],["bool"]],["vec",["p"]]]],[11,"create_struct_pattern","","",3,N],[11,"create_enum_variant_pattern","","",3,N],[0,"asm","syntax_ext","",N,N],[4,"State","syntax_ext::asm","",N,N],[13,"Asm","","",14,N],[13,"Outputs","","",14,N],[13,"Inputs","","",14,N],[13,"Clobbers","","",14,N],[13,"Options","","",14,N],[13,"StateNone","","",14,N],[5,"expand_asm","","",N,N],[17,"OPTIONS","","",N,N],[11,"next","","",14,[[["self"]],["state"]]],[0,"assert","syntax_ext","",N,N],[5,"expand_assert","syntax_ext::assert","",N,N],[0,"cfg","syntax_ext","",N,N],[5,"expand_cfg","syntax_ext::cfg","",N,N],[0,"compile_error","syntax_ext","",N,N],[5,"expand_compile_error","syntax_ext::compile_error","",N,N],[0,"concat","syntax_ext","",N,N],[5,"expand_syntax_ext","syntax_ext::concat","",N,N],[0,"concat_idents","syntax_ext","",N,N],[5,"expand_syntax_ext","syntax_ext::concat_idents","",N,N],[0,"env","syntax_ext","",N,N],[5,"expand_option_env","syntax_ext::env","",N,N],[5,"expand_env","","",N,N],[0,"format","syntax_ext","",N,N],[3,"Context","syntax_ext::format","",N,N],[12,"ecx","","",15,N],[12,"macsp","","The macro's call site. References to unstable formatting internals must use this span to pass the stability checker.",15,N],[12,"fmtsp","","The span of the format string literal.",15,N],[12,"args","","List of parsed argument expressions. Named expressions are resolved early, and are appended to the end of argument expressions.",15,N],[12,"arg_types","","Placeholder slot numbers indexed by argument.",15,N],[12,"arg_unique_types","","Unique format specs seen for each argument.",15,N],[12,"names","","Map from named arguments to their resolved indices.",15,N],[12,"literal","","The latest consecutive literal strings, or empty if there weren't any.",15,N],[12,"pieces","","Collection of the compiled `rt::Argument` structures",15,N],[12,"str_pieces","","Collection of string literals",15,N],[12,"all_pieces_simple","","Stays `true` if all formatting parameters are default (as in \"{}{}\").",15,N],[12,"arg_index_map","","Mapping between positional argument references and indices into the final generated static argument array. We record the starting indices corresponding to each positional argument, and number of references consumed so far for each argument, to facilitate correct `Position` mapping in `build_piece`. In effect this can be seen as a \"flattened\" version of `arg_unique_types`.",15,N],[12,"count_args_index_offset","","Starting offset of count argument slots.",15,N],[12,"count_args","","Count argument slots and tracking data structures. Count arguments are separately tracked for de-duplication in case multiple references are made to one argument. For example, in this format string:",15,N],[12,"count_positions","","Relative slot numbers for count arguments.",15,N],[12,"count_positions_count","","Number of count slots assigned.",15,N],[12,"curarg","","Current position of the implicit positional arg pointer, as if it still existed in this phase of processing. Used only for `all_pieces_simple` tracking in `build_piece`.",15,N],[12,"curpiece","","Current piece being evaluated, used for error reporting.",15,N],[12,"invalid_refs","","Keep track of invalid references to positional arguments.",15,N],[12,"arg_spans","","Spans of all the formatting arguments, in order.",15,N],[12,"is_literal","","Wether this formatting string is a literal or it comes from a macro.",15,N],[4,"ArgumentType","","",N,N],[13,"Placeholder","","",16,N],[13,"Count","","",16,N],[4,"Position","","",N,N],[13,"Exact","","",17,N],[13,"Named","","",17,N],[5,"parse_args","","Parses the arguments from the given list of tokens, returning None if there's a parse error so we can continue parsing other format! expressions.",N,N],[5,"expand_format_args","","",N,N],[5,"expand_format_args_nl","","",N,N],[5,"expand_preparsed_format_args","","Take the various parts of `format_args!(efmt, args..., name=names...)` and construct the appropriate formatting expression.",N,[[["extctxt"],["span"],["p",["expr"]],["vec",["p"]],["hashmap",["string","usize"]],["bool"]],["p",["expr"]]]],[11,"eq","","",16,[[["self"],["argumenttype"]],["bool"]]],[11,"ne","","",16,[[["self"],["argumenttype"]],["bool"]]],[11,"resolve_name_inplace","","",15,[[["self"],["piece"]]]],[11,"verify_piece","","Verifies one piece of a parse string, and remembers it if valid. All errors are not emitted as fatal so we can continue giving errors about this and possibly other format strings.",15,[[["self"],["piece"]]]],[11,"verify_count","","",15,[[["self"],["count"]]]],[11,"describe_num_args","","",15,[[["self"]],["string"]]],[11,"report_invalid_references","","Handle invalid references to positional arguments. Output different errors for the case where all arguments are positional and for when there are named arguments or numbered positional arguments in the format string.",15,[[["self"],["bool"]]]],[11,"verify_arg_type","","Actually verifies and tracks a given format placeholder (a.k.a. argument).",15,[[["self"],["position"],["argumenttype"]]]],[11,"build_index_map","","Builds the mapping between format placeholders and argument objects.",15,[[["self"]]]],[11,"rtpath","","",15,[[["extctxt"],["str"]],["vec",["ident"]]]],[11,"build_count","","",15,[[["self"],["count"]],["p",["expr"]]]],[11,"build_literal_string","","Build a literal expression from the accumulated string literals",15,[[["self"]],["p",["expr"]]]],[11,"build_piece","","Build a static `rt::Argument` from a `parse::Piece` or append to the `literal` string.",15,[[["self"],["piece"],["vec"]],["option",["p"]]]],[11,"into_expr","","Actually builds the expression which the format_args! block will be expanded to",15,[[["self"]],["p",["expr"]]]],[11,"format_arg","","",15,[[["extctxt"],["span"],["span"],["argumenttype"],["ident"]],["p",["expr"]]]],[0,"format_foreign","syntax_ext","",N,N],[0,"printf","syntax_ext::format_foreign","",N,N],[3,"Format","syntax_ext::format_foreign::printf","A single `printf`-style formatting directive.",N,N],[12,"span","","The entire original formatting directive.",18,N],[12,"parameter","","The (1-based) parameter to be converted.",18,N],[12,"flags","","Formatting flags.",18,N],[12,"width","","Minimum width of the output.",18,N],[12,"precision","","Precision of the conversion.",18,N],[12,"length","","Length modifier for the conversion.",18,N],[12,"type_","","Type of parameter being converted.",18,N],[12,"position","","Byte offset for the start and end of this formatting directive.",18,N],[3,"Substitutions","","Iterator over substitutions in a string.",N,N],[12,"s","","",19,N],[12,"pos","","",19,N],[4,"Substitution","","Represents a single `printf`-style substitution.",N,N],[13,"Format","","A formatted output substitution with its internal byte offset.",20,N],[13,"Escape","","A literal `%%` escape.",20,N],[4,"Num","","A general number used in a `printf` formatting directive.",N,N],[13,"Num","","A specific, fixed value.",21,N],[13,"Arg","","The value is derived from a positional argument.",21,N],[13,"Next","","The value is derived from the \"next\" unconverted argument.",21,N],[4,"State","","",N,N],[13,"Start","","",22,N],[13,"Flags","","",22,N],[13,"Width","","",22,N],[13,"WidthArg","","",22,N],[13,"Prec","","",22,N],[13,"PrecInner","","",22,N],[13,"Length","","",22,N],[13,"Type","","",22,N],[5,"iter_subs","","Returns an iterator over all substitutions in a given string.",N,[[["str"]],["substitutions"]]],[5,"parse_next_substitution","","Parse the next substitution from the input string.",N,[[["str"]],["option"]]],[5,"at_next_cp_while","","",N,[[["cur"],["f"]],["cur"]]],[5,"is_digit","","",N,[[["char"]],["bool"]]],[5,"is_flag","","",N,[[["char"]],["bool"]]],[11,"clone","","",20,[[["self"]],["substitution"]]],[11,"eq","","",20,[[["self"],["substitution"]],["bool"]]],[11,"ne","","",20,[[["self"],["substitution"]],["bool"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"as_str","","",20,[[["self"]],["str"]]],[11,"position","","",20,[[["self"]],["option"]]],[11,"set_position","","",20,[[["self"],["usize"],["usize"]]]],[11,"translate","","Translate this substitution into an equivalent Rust formatting directive.",20,[[["self"]],["option",["string"]]]],[11,"clone","","",18,[[["self"]],["format"]]],[11,"eq","","",18,[[["self"],["format"]],["bool"]]],[11,"ne","","",18,[[["self"],["format"]],["bool"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"translate","","Translate this directive into an equivalent Rust formatting directive.",18,[[["self"]],["option",["string"]]]],[11,"clone","","",21,[[["self"]],["num"]]],[11,"eq","","",21,[[["self"],["num"]],["bool"]]],[11,"ne","","",21,[[["self"],["num"]],["bool"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"from_str","","",21,[[["str"],["option",["str"]]],["self"]]],[11,"translate","","",21,[[["self"],["string"]],["result"]]],[11,"next","","",19,[[["self"]],["option"]]],[11,"size_hint","","",19,N],[0,"shell","syntax_ext::format_foreign","",N,N],[3,"Substitutions","syntax_ext::format_foreign::shell","Iterator over substitutions in a string.",N,N],[12,"s","","",23,N],[4,"Substitution","","",N,N],[13,"Ordinal","","",24,N],[13,"Name","","",24,N],[13,"Escape","","",24,N],[5,"iter_subs","","Returns an iterator over all substitutions in a given string.",N,[[["str"]],["substitutions"]]],[5,"parse_next_substitution","","Parse the next substitution from the input string.",N,[[["str"]],["option"]]],[5,"at_next_cp_while","","",N,[[["cur"],["f"]],["cur"]]],[5,"is_ident_head","","",N,[[["char"]],["bool"]]],[5,"is_ident_tail","","",N,[[["char"]],["bool"]]],[11,"clone","","",24,[[["self"]],["substitution"]]],[11,"eq","","",24,[[["self"],["substitution"]],["bool"]]],[11,"ne","","",24,[[["self"],["substitution"]],["bool"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"as_str","","",24,[[["self"]],["string"]]],[11,"position","","",24,[[["self"]],["option"]]],[11,"translate","","",24,[[["self"]],["option",["string"]]]],[11,"next","","",23,[[["self"]],["option"]]],[11,"size_hint","","",23,N],[0,"strcursor","syntax_ext::format_foreign","",N,N],[3,"StrCursor","syntax_ext::format_foreign::strcursor","",N,N],[12,"s","","",25,N],[12,"at","","",25,N],[5,"str_eq_literal","","",N,[[["str"],["str"]],["bool"]]],[11,"new_at_start","","",25,[[["str"]],["strcursor"]]],[11,"new_at","","",25,[[["str"],["usize"]],["strcursor"]]],[11,"at_next_cp","","",25,[[["self"]],["option",["strcursor"]]]],[11,"next_cp","","",25,[[["self"]],["option"]]],[11,"slice_before","","",25,[[["self"]],["str"]]],[11,"slice_after","","",25,[[["self"]],["str"]]],[11,"slice_between","","",25,[[["self"],["strcursor"]],["option",["str"]]]],[11,"cp_after","","",25,[[["self"]],["option",["char"]]]],[11,"try_seek_right_cp","","",25,[[["self"]],["bool"]]],[11,"seek_right","","",25,[[["self"],["usize"]]]],[11,"clone","","",25,[[["self"]],["strcursor"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[0,"global_asm","syntax_ext","",N,N],[5,"expand_global_asm","syntax_ext::global_asm","",N,N],[17,"MACRO","","",N,N],[0,"log_syntax","syntax_ext","",N,N],[5,"expand_syntax_ext","syntax_ext::log_syntax","",N,N],[0,"trace_macros","syntax_ext","",N,N],[5,"expand_trace_macros","syntax_ext::trace_macros","",N,N],[0,"proc_macro_registrar","syntax_ext","",N,N],[3,"ProcMacroDerive","syntax_ext::proc_macro_registrar","",N,N],[12,"trait_name","","",26,N],[12,"function_name","","",26,N],[12,"span","","",26,N],[12,"attrs","","",26,N],[3,"ProcMacroDef","","",N,N],[12,"function_name","","",27,N],[12,"span","","",27,N],[3,"CollectProcMacros","","",N,N],[12,"derives","","",28,N],[12,"attr_macros","","",28,N],[12,"bang_macros","","",28,N],[12,"in_root","","",28,N],[12,"handler","","",28,N],[12,"is_proc_macro_crate","","",28,N],[12,"is_test_crate","","",28,N],[5,"modify","","",N,[[["parsesess"],["resolver"],["crate"],["bool"],["bool"],["usize"],["handler"]],["crate"]]],[5,"is_proc_macro_attr","","",N,[[["attribute"]],["bool"]]],[5,"mk_registrar","","",N,N],[17,"PROC_MACRO_KINDS","","",N,N],[11,"check_not_pub_in_root","","",28,[[["self"],["visibility"],["span"]]]],[11,"collect_custom_derive","","",28,[[["self"],["item"],["attribute"]]]],[11,"collect_attr_proc_macro","","",28,[[["self"],["item"],["attribute"]]]],[11,"collect_bang_proc_macro","","",28,[[["self"],["item"],["attribute"]]]],[11,"visit_item","","",28,[[["self"],["item"]]]],[11,"visit_mac","","",28,[[["self"],["mac"]]]],[0,"proc_macro_impl","syntax_ext","",N,N],[3,"AttrProcMacro","syntax_ext::proc_macro_impl","",N,N],[12,"inner","","",29,N],[3,"BangProcMacro","","",N,N],[12,"inner","","",30,N],[11,"expand","","",29,[[["self"],["extctxt"],["span"],["tokenstream"],["tokenstream"]],["tokenstream"]]],[11,"expand","","",30,[[["self"],["extctxt"],["span"],["tokenstream"]],["tokenstream"]]],[14,"path_local","syntax_ext","",N,N],[14,"pathvec_std","","",N,N],[14,"path_std","","",N,N]],"paths":[[3,"MarkAttrs"],[3,"ProcMacroDerive"],[4,"OrderingOp"],[3,"TraitDef"],[3,"MethodDef"],[3,"Substructure"],[3,"FieldInfo"],[4,"StaticFields"],[4,"SubstructureFields"],[3,"Path"],[3,"LifetimeBounds"],[4,"PtrTy"],[4,"PathKind"],[4,"Ty"],[4,"State"],[3,"Context"],[4,"ArgumentType"],[4,"Position"],[3,"Format"],[3,"Substitutions"],[4,"Substitution"],[4,"Num"],[4,"State"],[3,"Substitutions"],[4,"Substitution"],[3,"StrCursor"],[3,"ProcMacroDerive"],[3,"ProcMacroDef"],[3,"CollectProcMacros"],[3,"AttrProcMacro"],[3,"BangProcMacro"]]};
searchIndex["syntax_pos"]={"doc":"The source positions and related helper functions","items":[[3,"Span","syntax_pos","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",N,N],[12,"0","","",0,N],[3,"Globals","","",N,N],[12,"symbol_interner","","",1,N],[12,"span_interner","","",1,N],[12,"hygiene_data","","",1,N],[3,"SpanData","","Spans represent a region of code, used for error reporting. Positions in spans are absolute positions from the beginning of the codemap, not positions relative to FileMaps. Methods on the CodeMap can be used to relate spans back to the original source. You must be careful if the span crosses more than one file - you will not be able to use many of the functions on spans in codemap and you cannot assume that the length of the span = hi - lo; there may be space in the BytePos range between files.",N,N],[12,"lo","","",2,N],[12,"hi","","",2,N],[12,"ctxt","","Information about where the macro came from, if this piece of code was created by a macro expansion.",2,N],[3,"MultiSpan","","A collection of spans. Spans have two orthogonal attributes:",N,N],[12,"primary_spans","","",3,N],[12,"span_labels","","",3,N],[3,"SpanLabel","","",N,N],[12,"span","","The span we are going to include in the final snippet.",4,N],[12,"is_primary","","Is this a primary span? This is the \"locus\" of the message, and is indicated with a `^^^^` underline, versus `----`.",4,N],[12,"label","","What label should we attach to this span (if any)?",4,N],[3,"MultiByteChar","","Identifies an offset of a multi-byte character in a FileMap",N,N],[12,"pos","","The absolute offset of the character in the CodeMap",5,N],[12,"bytes","","The number of bytes, >=2",5,N],[3,"FileMap","","A single source in the CodeMap.",N,N],[12,"name","","The name of the file that the source came from, source that doesn't originate from files has names between angle brackets by convention, e.g. `<anon>`",6,N],[12,"name_was_remapped","","True if the `name` field above has been modified by --remap-path-prefix",6,N],[12,"unmapped_path","","The unmapped path of the file that the source came from. Set to `None` if the FileMap was imported from an external crate.",6,N],[12,"crate_of_origin","","Indicates which crate this FileMap was imported from.",6,N],[12,"src","","The complete source code",6,N],[12,"src_hash","","The source code's hash",6,N],[12,"external_src","","The external source code (used for external crates, which will have a `None` value as `self.src`.",6,N],[12,"start_pos","","The start position of this source in the CodeMap",6,N],[12,"end_pos","","The end position of this source in the CodeMap",6,N],[12,"lines","","Locations of lines beginnings in the source code",6,N],[12,"multibyte_chars","","Locations of multi-byte characters in the source code",6,N],[12,"non_narrow_chars","","Width of characters that are not narrow in the source code",6,N],[12,"name_hash","","A hash of the filename, used for speeding up the incr. comp. hashing.",6,N],[3,"BytePos","","A byte offset. Keep this small (currently 32-bits), as AST contains a lot of them.",N,N],[12,"0","","",7,N],[3,"CharPos","","A character offset. Because of multibyte utf8 characters, a byte offset is not equivalent to a character offset. The CodeMap will convert BytePos values to CharPos values as necessary.",N,N],[12,"0","","",8,N],[3,"Loc","","A source code location used for error reporting",N,N],[12,"file","","Information about the original source",9,N],[12,"line","","The (1-based) line number",9,N],[12,"col","","The (0-based) column offset",9,N],[12,"col_display","","The (0-based) column offset when displayed",9,N],[3,"LocWithOpt","","A source code location used as the result of lookup_char_pos_adj",N,N],[12,"filename","","",10,N],[12,"line","","",10,N],[12,"col","","",10,N],[12,"file","","",10,N],[3,"FileMapAndLine","","",N,N],[12,"fm","","",11,N],[12,"line","","",11,N],[3,"FileMapAndBytePos","","",N,N],[12,"fm","","",12,N],[12,"pos","","",12,N],[3,"LineInfo","","",N,N],[12,"line_index","","Index of line, starting from 0.",13,N],[12,"start_col","","Column in line where span begins, starting from 0.",13,N],[12,"end_col","","Column in line where span ends, starting from 0, exclusive.",13,N],[3,"FileLines","","",N,N],[12,"file","","",14,N],[12,"lines","","",14,N],[3,"MacroBacktrace","","",N,N],[12,"call_site","","span where macro was applied to generate this code",15,N],[12,"macro_decl_name","","name of macro that was applied (e.g., \"foo!\" or \"#[derive(Eq)]\")",15,N],[12,"def_site_span","","span where macro was defined (if known)",15,N],[3,"DistinctSources","","",N,N],[12,"begin","","",16,N],[12,"end","","",16,N],[3,"MalformedCodemapPositions","","",N,N],[12,"name","","",17,N],[12,"source_len","","",17,N],[12,"begin_pos","","",17,N],[12,"end_pos","","",17,N],[4,"FileName","","Differentiates between real files and common virtual files",N,N],[13,"Real","","",18,N],[13,"Macros","","e.g. \"std\" macros",18,N],[13,"QuoteExpansion","","call to `quote!`",18,N],[13,"Anon","","Command line",18,N],[13,"MacroExpansion","","Hack in src/libsyntax/parse.rs FIXME(jseyfried)",18,N],[13,"ProcMacroSourceCode","","",18,N],[13,"CfgSpec","","Strings provided as --cfg [cfgspec] stored in a crate_cfg",18,N],[13,"CliCrateAttr","","Strings provided as crate attributes in the CLI",18,N],[13,"Custom","","Custom sources for explicit parser calls from plugins and drivers",18,N],[4,"NonNarrowChar","","Identifies an offset of a non-narrow character in a FileMap",N,N],[13,"ZeroWidth","","Represents a zero-width character",19,N],[13,"Wide","","Represents a wide (fullwidth) character",19,N],[13,"Tab","","Represents a tab character, represented visually with a width of 4 characters",19,N],[4,"ExternalSource","","The state of the lazy external source loading mechanism of a FileMap.",N,N],[13,"Present","","The external source has been loaded already.",20,N],[13,"AbsentOk","","No attempt has been made to load the external source.",20,N],[13,"AbsentErr","","A failed attempt has been made to load the external source.",20,N],[13,"Unneeded","","No external source has to be loaded, since the FileMap represents a local crate.",20,N],[4,"SpanLinesError","","",N,N],[13,"IllFormedSpan","","",21,N],[13,"DistinctSources","","",21,N],[4,"SpanSnippetError","","",N,N],[13,"IllFormedSpan","","",22,N],[13,"DistinctSources","","",22,N],[13,"MalformedForCodemap","","",22,N],[13,"SourceNotAvailable","","",22,N],[12,"filename","syntax_pos::SpanSnippetError","",22,N],[5,"default_span_debug","syntax_pos","",N,[[["span"],["formatter"]],["result"]]],[5,"remove_bom","","Remove utf-8 BOM if any.",N,[[["string"]]]],[5,"lookup_line","","",N,N],[0,"edition","","",N,N],[4,"Edition","syntax_pos::edition","The edition of the compiler (RFC 2052)",N,N],[13,"Edition2015","","The 2015 edition",23,N],[13,"Edition2018","","The 2018 edition",23,N],[17,"ALL_EDITIONS","","",N,N],[17,"EDITION_NAME_LIST","","",N,N],[17,"DEFAULT_EDITION","","",N,N],[11,"clone","","",23,[[["self"]],["edition"]]],[11,"hash","","",23,N],[11,"eq","","",23,[[["self"],["edition"]],["bool"]]],[11,"partial_cmp","","",23,[[["self"],["edition"]],["option",["ordering"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"encode","","",23,[[["self"],["__s"]],["result"]]],[11,"decode","","",23,[[["__d"]],["result",["edition"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"lint_name","","",23,[[["self"]],["str"]]],[11,"feature_name","","",23,[[["self"]],["str"]]],[11,"is_stable","","",23,[[["self"]],["bool"]]],[11,"from_str","","",23,[[["str"]],["result"]]],[0,"hygiene","syntax_pos","Machinery for hygienic macros, inspired by the `MTWT[1]` paper.",N,N],[3,"SyntaxContext","syntax_pos::hygiene","A SyntaxContext represents a chain of macro expansions (represented by marks).",N,N],[12,"0","","",24,N],[3,"SyntaxContextData","","",N,N],[12,"outer_mark","","",25,N],[12,"transparency","","",25,N],[12,"prev_ctxt","","",25,N],[12,"opaque","","",25,N],[12,"opaque_and_semitransparent","","",25,N],[3,"Mark","","A mark is a unique id associated with a macro expansion.",N,N],[12,"0","","",26,N],[3,"MarkData","","",N,N],[12,"parent","","",27,N],[12,"default_transparency","","",27,N],[12,"is_builtin","","",27,N],[12,"expn_info","","",27,N],[3,"HygieneData","","",N,N],[12,"marks","","",28,N],[12,"syntax_contexts","","",28,N],[12,"markings","","",28,N],[12,"default_edition","","",28,N],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",N,N],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",29,N],[12,"def_site","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None. This span serves only informational purpose and is not used for resolution.",29,N],[12,"format","","The format with which the macro was invoked.",29,N],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",29,N],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",29,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",29,N],[12,"edition","","Edition of the crate in which the macro is defined.",29,N],[4,"Transparency","","A property of a macro expansion that determines how identifiers produced by that expansion are resolved.",N,N],[13,"Transparent","","Identifier produced by a transparent expansion is always resolved at call-site. Call-site spans in procedural macros, hygiene opt-out in `macro` should use this.",30,N],[13,"SemiTransparent","","Identifier produced by a semi-transparent expansion may be resolved either at call-site or at definition-site. If it's a local variable, label or `$crate` then it's resolved at def-site. Otherwise it's resolved at call-site. `macro_rules` macros behave like this, built-in macros currently behave like this too, but that's an implementation detail.",30,N],[13,"Opaque","","Identifier produced by an opaque expansion is always resolved at definition-site. Def-site spans in procedural macros, identifiers from `macro` by default use this.",30,N],[4,"ExpnFormat","","The source of expansion.",N,N],[13,"MacroAttribute","","e.g. #[derive(...)] ",31,N],[13,"MacroBang","","e.g. `format!()`",31,N],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",31,N],[4,"CompilerDesugaringKind","","The kind of compiler desugaring.",N,N],[13,"DotFill","","",32,N],[13,"QuestionMark","","",32,N],[13,"Catch","","",32,N],[13,"ExistentialReturnType","","Desugaring of an `impl Trait` in return type position to an `existential type Foo: Trait;` + replacing the `impl Trait` with `Foo`.",32,N],[13,"Async","","",32,N],[13,"ForLoop","","",32,N],[5,"default_edition","","",N,[[],["edition"]]],[5,"set_default_edition","","",N,[[["edition"]]]],[5,"clear_markings","","",N,[[]]],[11,"clone","","",24,[[["self"]],["syntaxcontext"]]],[11,"eq","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"ne","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",24,N],[11,"default","","",24,[[],["syntaxcontext"]]],[11,"partial_cmp","","",24,[[["self"],["syntaxcontext"]],["option",["ordering"]]]],[11,"lt","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"le","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"gt","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"ge","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"cmp","","",24,[[["self"],["syntaxcontext"]],["ordering"]]],[11,"hash","","",24,N],[11,"clone","","",25,[[["self"]],["syntaxcontextdata"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"clone","","",26,[[["self"]],["mark"]]],[11,"eq","","",26,[[["self"],["mark"]],["bool"]]],[11,"ne","","",26,[[["self"],["mark"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",26,N],[11,"hash","","",26,N],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"encode","","",26,[[["self"],["__s"]],["result"]]],[11,"decode","","",26,[[["__d"]],["result",["mark"]]]],[11,"clone","","",27,[[["self"]],["markdata"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"clone","","",30,[[["self"]],["transparency"]]],[11,"eq","","",30,[[["self"],["transparency"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",30,N],[11,"partial_cmp","","",30,[[["self"],["transparency"]],["option",["ordering"]]]],[11,"hash","","",30,N],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"fresh","","",26,[[["mark"]],["self"]]],[11,"root","","The mark of the theoretical expansion that generates freshly parsed, unexpanded AST.",26,[[],["self"]]],[11,"as_u32","","",26,[[["self"]],["u32"]]],[11,"from_u32","","",26,[[["u32"]],["mark"]]],[11,"expn_info","","",26,[[["self"]],["option",["expninfo"]]]],[11,"set_expn_info","","",26,[[["self"],["expninfo"]]]],[11,"set_default_transparency","","",26,[[["self"],["transparency"]]]],[11,"is_builtin","","",26,[[["self"]],["bool"]]],[11,"set_is_builtin","","",26,[[["self"],["bool"]]]],[11,"is_descendant_of","","",26,[[["self"],["mark"]],["bool"]]],[11,"least_ancestor","","Computes a mark such that both input marks are descendants of (or equal to) the returned mark. That is, the following holds:",26,[[["mark"],["mark"]],["mark"]]],[11,"looks_like_proc_macro_derive","","",26,[[["self"]],["bool"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"new","","",28,[[],["self"]]],[11,"with","","",28,[[["f"]],["t"]]],[11,"empty","","",24,[[],["self"]]],[11,"as_u32","","",24,[[["self"]],["u32"]]],[11,"from_u32","","",24,[[["u32"]],["syntaxcontext"]]],[11,"allocate_directly","","",24,[[["expninfo"]],["self"]]],[11,"apply_mark","","Extend a syntax context with a given mark and default transparency for that mark.",24,[[["self"],["mark"]],["syntaxcontext"]]],[11,"apply_mark_with_transparency","","Extend a syntax context with a given mark and transparency",24,[[["self"],["mark"],["transparency"]],["syntaxcontext"]]],[11,"apply_mark_internal","","",24,[[["self"],["mark"],["transparency"]],["syntaxcontext"]]],[11,"remove_mark","","Pulls a single mark off of the syntax context. This effectively moves the context up one macro definition level. That is, if we have a nested macro definition as follows:",24,[[["self"]],["mark"]]],[11,"marks","","",24,[[["self"]],["vec"]]],[11,"adjust","","Adjust this context for resolution in a scope created by the given expansion. For example, consider the following three resolutions of `f`:",24,[[["self"],["mark"]],["option",["mark"]]]],[11,"glob_adjust","","Adjust this context for resolution in a scope created by the given expansion via a glob import with the given `SyntaxContext`. For example:",24,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"reverse_glob_adjust","","Undo `glob_adjust` if possible:",24,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"modern","","",24,[[["self"]],["syntaxcontext"]]],[11,"modern_and_legacy","","",24,[[["self"]],["syntaxcontext"]]],[11,"outer","","",24,[[["self"]],["mark"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"clone","","",29,[[["self"]],["expninfo"]]],[11,"hash","","",29,N],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"encode","","",29,[[["self"],["__s"]],["result"]]],[11,"decode","","",29,[[["__d"]],["result",["expninfo"]]]],[11,"clone","","",31,[[["self"]],["expnformat"]]],[11,"hash","","",31,N],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"eq","","",31,[[["self"],["expnformat"]],["bool"]]],[11,"ne","","",31,[[["self"],["expnformat"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",31,N],[11,"encode","","",31,[[["self"],["__s"]],["result"]]],[11,"decode","","",31,[[["__d"]],["result",["expnformat"]]]],[11,"name","","",31,[[["self"]],["symbol"]]],[11,"clone","","",32,[[["self"]],["compilerdesugaringkind"]]],[11,"hash","","",32,N],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"eq","","",32,[[["self"],["compilerdesugaringkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",32,N],[11,"encode","","",32,[[["self"],["__s"]],["result"]]],[11,"decode","","",32,[[["__d"]],["result",["compilerdesugaringkind"]]]],[11,"name","","",32,[[["self"]],["symbol"]]],[11,"encode","","",24,[[["self"],["e"]],["result"]]],[11,"decode","","",24,[[["d"]],["result",["syntaxcontext"]]]],[0,"span_encoding","syntax_pos","",N,N],[3,"Span","syntax_pos::span_encoding","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",N,N],[12,"0","","",0,N],[3,"SpanInterner","","",N,N],[12,"spans","","",33,N],[12,"span_data","","",33,N],[5,"encode","","",N,[[["spandata"]],["span"]]],[5,"decode","","",N,[[["span"]],["spandata"]]],[5,"with_span_interner","","",N,[[["f"]],["t"]]],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",N,N],[17,"TAG_INLINE","","",N,N],[17,"TAG_INTERNED","","",N,N],[17,"TAG_MASK","","",N,N],[17,"BASE_INDEX","","",N,N],[17,"LEN_INDEX","","",N,N],[17,"CTXT_INDEX","","",N,N],[17,"INLINE_SIZES","","",N,N],[17,"INLINE_OFFSETS","","",N,N],[17,"INTERNED_INDEX_SIZE","","",N,N],[17,"INTERNED_INDEX_OFFSET","","",N,N],[11,"clone","syntax_pos","",0,[[["self"]],["span"]]],[11,"eq","","",0,[[["self"],["span"]],["bool"]]],[11,"hash","","",0,[[["self"],["h"]]]],[11,"new","","",0,[[["bytepos"],["bytepos"],["syntaxcontext"]],["self"]]],[11,"data","","",0,[[["self"]],["spandata"]]],[11,"default","syntax_pos::span_encoding","",33,[[],["spaninterner"]]],[11,"intern","","",33,[[["self"],["spandata"]],["u32"]]],[11,"get","","",33,[[["self"],["u32"]],["spandata"]]],[0,"symbol","syntax_pos","An \"interner\" is a data structure that associates values with usize tags and allows bidirectional lookup; i.e. given a value, one can easily find the type, and vice versa.",N,N],[3,"Ident","syntax_pos::symbol","",N,N],[12,"name","","",34,N],[12,"span","","",34,N],[3,"Symbol","","A symbol is an interned or gensymed string.",N,N],[12,"0","","",35,N],[3,"Interner","","",N,N],[12,"arena","","",36,N],[12,"names","","",36,N],[12,"strings","","",36,N],[12,"gensyms","","",36,N],[3,"LocalInternedString","","Represents a string stored in the interner. Because the interner outlives any thread which uses this type, we can safely treat `string` which points to interner data, as an immortal string, as long as this type never crosses between threads.",N,N],[12,"string","","",37,N],[3,"InternedString","","Represents a string stored in the string interner",N,N],[12,"symbol","","",38,N],[5,"with_interner","","",N,[[["f"]],["t"]]],[0,"keywords","","",N,N],[3,"Keyword","syntax_pos::symbol::keywords","",N,N],[12,"ident","","",39,N],[17,"Invalid","","",N,N],[17,"CrateRoot","","",N,N],[17,"DollarCrate","","",N,N],[17,"Underscore","","",N,N],[17,"As","","",N,N],[17,"Box","","",N,N],[17,"Break","","",N,N],[17,"Const","","",N,N],[17,"Continue","","",N,N],[17,"Crate","","",N,N],[17,"Else","","",N,N],[17,"Enum","","",N,N],[17,"Extern","","",N,N],[17,"False","","",N,N],[17,"Fn","","",N,N],[17,"For","","",N,N],[17,"If","","",N,N],[17,"Impl","","",N,N],[17,"In","","",N,N],[17,"Let","","",N,N],[17,"Loop","","",N,N],[17,"Match","","",N,N],[17,"Mod","","",N,N],[17,"Move","","",N,N],[17,"Mut","","",N,N],[17,"Pub","","",N,N],[17,"Ref","","",N,N],[17,"Return","","",N,N],[17,"SelfValue","","",N,N],[17,"SelfType","","",N,N],[17,"Static","","",N,N],[17,"Struct","","",N,N],[17,"Super","","",N,N],[17,"Trait","","",N,N],[17,"True","","",N,N],[17,"Type","","",N,N],[17,"Unsafe","","",N,N],[17,"Use","","",N,N],[17,"Where","","",N,N],[17,"While","","",N,N],[17,"Abstract","","",N,N],[17,"Become","","",N,N],[17,"Do","","",N,N],[17,"Final","","",N,N],[17,"Macro","","",N,N],[17,"Override","","",N,N],[17,"Priv","","",N,N],[17,"Typeof","","",N,N],[17,"Unsized","","",N,N],[17,"Virtual","","",N,N],[17,"Yield","","",N,N],[17,"Async","","",N,N],[17,"UnderscoreLifetime","","",N,N],[17,"StaticLifetime","","",N,N],[17,"Auto","","",N,N],[17,"Catch","","",N,N],[17,"Default","","",N,N],[17,"Dyn","","",N,N],[17,"Union","","",N,N],[17,"Existential","","",N,N],[11,"clone","","",39,[[["self"]],["keyword"]]],[11,"eq","","",39,[[["self"],["keyword"]],["bool"]]],[11,"ne","","",39,[[["self"],["keyword"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",39,N],[11,"ident","","",39,[[["self"]],["ident"]]],[11,"name","","",39,[[["self"]],["symbol"]]],[11,"from_str","","",39,[[["str"]],["result"]]],[11,"clone","syntax_pos::symbol","",34,[[["self"]],["ident"]]],[11,"assert_receiver_is_total_eq","","",34,N],[11,"new","","",34,[[["symbol"],["span"]],["ident"]]],[11,"with_empty_ctxt","","",34,[[["symbol"]],["ident"]]],[11,"from_interned_str","","Maps an interned string to an identifier with an empty syntax context.",34,[[["internedstring"]],["ident"]]],[11,"from_str","","Maps a string to an identifier with an empty syntax context.",34,[[["str"]],["ident"]]],[11,"with_span_pos","","Replace `lo` and `hi` with those from `span`, but keep hygiene context.",34,[[["self"],["span"]],["ident"]]],[11,"without_first_quote","","",34,[[["self"]],["ident"]]],[11,"modern","","\"Normalize\" ident for use in comparisons using \"item hygiene\". Identifiers with same string value become same if they came from the same \"modern\" macro (e.g. `macro` item, but not `macro_rules` item) and stay different if they came from different \"modern\" macros. Technically, this operation strips all non-opaque marks from ident's syntactic context.",34,[[["self"]],["ident"]]],[11,"modern_and_legacy","","\"Normalize\" ident for use in comparisons using \"local variable hygiene\". Identifiers with same string value become same if they came from the same non-transparent macro (e.g. `macro` or `macro_rules!` items) and stay different if they came from different non-transparent macros. Technically, this operation strips all transparent marks from ident's syntactic context.",34,[[["self"]],["ident"]]],[11,"gensym","","",34,[[["self"]],["ident"]]],[11,"as_str","","",34,[[["self"]],["localinternedstring"]]],[11,"as_interned_str","","",34,[[["self"]],["internedstring"]]],[11,"eq","","",34,[[["self"],["self"]],["bool"]]],[11,"hash","","",34,[[["self"],["h"]]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"encode","","",34,[[["self"],["s"]],["result"]]],[11,"decode","","",34,[[["d"]],["result",["ident"]]]],[11,"clone","","",35,[[["self"]],["symbol"]]],[11,"eq","","",35,[[["self"],["symbol"]],["bool"]]],[11,"ne","","",35,[[["self"],["symbol"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",35,N],[11,"partial_cmp","","",35,[[["self"],["symbol"]],["option",["ordering"]]]],[11,"lt","","",35,[[["self"],["symbol"]],["bool"]]],[11,"le","","",35,[[["self"],["symbol"]],["bool"]]],[11,"gt","","",35,[[["self"],["symbol"]],["bool"]]],[11,"ge","","",35,[[["self"],["symbol"]],["bool"]]],[11,"cmp","","",35,[[["self"],["symbol"]],["ordering"]]],[11,"hash","","",35,N],[11,"intern","","Maps a string to its interned representation.",35,[[["str"]],["self"]]],[11,"interned","","",35,[[["self"]],["self"]]],[11,"gensym","","gensym's a new usize, using the current interner.",35,[[["str"]],["self"]]],[11,"gensymed","","",35,[[["self"]],["self"]]],[11,"as_str","","",35,[[["self"]],["localinternedstring"]]],[11,"as_interned_str","","",35,[[["self"]],["internedstring"]]],[11,"as_u32","","",35,[[["self"]],["u32"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"encode","","",35,[[["self"],["s"]],["result"]]],[11,"decode","","",35,[[["d"]],["result",["symbol"]]]],[11,"eq","","",35,[[["self"],["t"]],["bool"]]],[11,"new","","",36,[[],["self"]]],[11,"prefill","","",36,N],[11,"intern","","",36,[[["self"],["str"]],["symbol"]]],[11,"interned","","",36,[[["self"],["symbol"]],["symbol"]]],[11,"gensym","","",36,[[["self"],["str"]],["symbol"]]],[11,"gensymed","","",36,[[["self"],["symbol"]],["symbol"]]],[11,"is_gensymed","","",36,[[["self"],["symbol"]],["bool"]]],[11,"get","","",36,[[["self"],["symbol"]],["str"]]],[11,"fresh","","",36,[[],["self"]]],[11,"is_unused_keyword_2018","","",35,[[["self"]],["bool"]]],[11,"is_special","","",34,[[["self"]],["bool"]]],[11,"is_used_keyword","","Returns `true` if the token is a keyword used in the language.",34,[[["self"]],["bool"]]],[11,"is_unused_keyword","","Returns `true` if the token is a keyword reserved for possible future use.",34,[[["self"]],["bool"]]],[11,"is_reserved","","Returns `true` if the token is either a special identifier or a keyword.",34,[[["self"]],["bool"]]],[11,"is_path_segment_keyword","","A keyword or reserved identifier that can be used as a path segment.",34,[[["self"]],["bool"]]],[11,"is_raw_guess","","",34,[[["self"]],["bool"]]],[11,"clone","","",37,[[["self"]],["localinternedstring"]]],[11,"hash","","",37,N],[11,"partial_cmp","","",37,[[["self"],["localinternedstring"]],["option",["ordering"]]]],[11,"lt","","",37,[[["self"],["localinternedstring"]],["bool"]]],[11,"le","","",37,[[["self"],["localinternedstring"]],["bool"]]],[11,"gt","","",37,[[["self"],["localinternedstring"]],["bool"]]],[11,"ge","","",37,[[["self"],["localinternedstring"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",37,N],[11,"cmp","","",37,[[["self"],["localinternedstring"]],["ordering"]]],[11,"as_interned_str","","",37,[[["self"]],["internedstring"]]],[11,"as_ref","","",37,[[["self"]],["u"]]],[11,"eq","","",37,[[["self"],["t"]],["bool"]]],[11,"deref","","",37,[[["self"]],["str"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"decode","","",37,[[["d"]],["result",["localinternedstring"]]]],[11,"encode","","",37,[[["self"],["s"]],["result"]]],[11,"clone","","",38,[[["self"]],["internedstring"]]],[11,"assert_receiver_is_total_eq","","",38,N],[11,"with","","",38,[[["self"],["f"]],["r"]]],[11,"as_symbol","","",38,[[["self"]],["symbol"]]],[11,"as_str","","",38,[[["self"]],["localinternedstring"]]],[11,"hash","","",38,[[["self"],["h"]]]],[11,"partial_cmp","","",38,[[["self"],["internedstring"]],["option",["ordering"]]]],[11,"cmp","","",38,[[["self"],["internedstring"]],["ordering"]]],[11,"eq","","",38,[[["self"],["t"]],["bool"]]],[11,"eq","","",38,[[["self"],["internedstring"]],["bool"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"decode","","",38,[[["d"]],["result",["internedstring"]]]],[11,"encode","","",38,[[["self"],["s"]],["result"]]],[0,"analyze_filemap","syntax_pos","",N,N],[5,"analyze_filemap","syntax_pos::analyze_filemap","Find all newlines, multi-byte characters, and non-narrow characters in a FileMap.",N,N],[5,"analyze_filemap_dispatch","","",N,[[["str"],["bytepos"],["vec"],["vec"],["vec"]]]],[5,"analyze_filemap_sse2","","Check 16 byte chunks of text at a time. If the chunk contains something other than printable ASCII characters and newlines, the function falls back to the generic implementation. Otherwise it uses SSE2 intrinsics to quickly find all newlines.",N,[[["str"],["bytepos"],["vec"],["vec"],["vec"]]]],[5,"analyze_filemap_generic","","",N,[[["str"],["usize"],["bytepos"],["vec"],["vec"],["vec"]],["usize"]]],[6,"FileLinesResult","syntax_pos","",N,N],[7,"GLOBALS","","",N,N],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",N,N],[17,"NO_EXPANSION","","",N,N],[17,"SPAN_DEBUG","","",N,N],[8,"Pos","","",N,N],[10,"from_usize","","",40,[[["usize"]],["self"]]],[10,"to_usize","","",40,[[["self"]],["usize"]]],[10,"from_u32","","",40,[[["u32"]],["self"]]],[10,"to_u32","","",40,[[["self"]],["u32"]]],[11,"new","","",1,[[],["globals"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"eq","","",18,[[["self"],["filename"]],["bool"]]],[11,"ne","","",18,[[["self"],["filename"]],["bool"]]],[11,"clone","","",18,[[["self"]],["filename"]]],[11,"cmp","","",18,[[["self"],["filename"]],["ordering"]]],[11,"partial_cmp","","",18,[[["self"],["filename"]],["option",["ordering"]]]],[11,"lt","","",18,[[["self"],["filename"]],["bool"]]],[11,"le","","",18,[[["self"],["filename"]],["bool"]]],[11,"gt","","",18,[[["self"],["filename"]],["bool"]]],[11,"ge","","",18,[[["self"],["filename"]],["bool"]]],[11,"hash","","",18,N],[11,"decode","","",18,[[["__d"]],["result",["filename"]]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"from","","",18,[[["pathbuf"]],["self"]]],[11,"is_real","","",18,[[["self"]],["bool"]]],[11,"is_macros","","",18,[[["self"]],["bool"]]],[11,"clone","","",2,[[["self"]],["spandata"]]],[11,"hash","","",2,N],[11,"eq","","",2,[[["self"],["spandata"]],["bool"]]],[11,"ne","","",2,[[["self"],["spandata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"cmp","","",2,[[["self"],["spandata"]],["ordering"]]],[11,"partial_cmp","","",2,[[["self"],["spandata"]],["option",["ordering"]]]],[11,"lt","","",2,[[["self"],["spandata"]],["bool"]]],[11,"le","","",2,[[["self"],["spandata"]],["bool"]]],[11,"gt","","",2,[[["self"],["spandata"]],["bool"]]],[11,"ge","","",2,[[["self"],["spandata"]],["bool"]]],[11,"with_lo","","",2,[[["self"],["bytepos"]],["span"]]],[11,"with_hi","","",2,[[["self"],["bytepos"]],["span"]]],[11,"with_ctxt","","",2,[[["self"],["syntaxcontext"]],["span"]]],[11,"partial_cmp","","",0,[[["self"],["self"]],["option",["ordering"]]]],[11,"cmp","","",0,[[["self"],["self"]],["ordering"]]],[11,"clone","","",3,[[["self"]],["multispan"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"hash","","",3,N],[11,"eq","","",3,[[["self"],["multispan"]],["bool"]]],[11,"ne","","",3,[[["self"],["multispan"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"encode","","",3,[[["self"],["__s"]],["result"]]],[11,"decode","","",3,[[["__d"]],["result",["multispan"]]]],[11,"lo","","",0,[[["self"]],["bytepos"]]],[11,"with_lo","","",0,[[["self"],["bytepos"]],["span"]]],[11,"hi","","",0,[[["self"]],["bytepos"]]],[11,"with_hi","","",0,[[["self"],["bytepos"]],["span"]]],[11,"ctxt","","",0,[[["self"]],["syntaxcontext"]]],[11,"with_ctxt","","",0,[[["self"],["syntaxcontext"]],["span"]]],[11,"is_dummy","","Returns `true` if this is a dummy span with any hygienic context.",0,[[["self"]],["bool"]]],[11,"shrink_to_lo","","Returns a new span representing an empty span at the beginning of this span",0,[[["self"]],["span"]]],[11,"shrink_to_hi","","Returns a new span representing an empty span at the end of this span",0,[[["self"]],["span"]]],[11,"substitute_dummy","","Returns `self` if `self` is not the dummy span, and `other` otherwise.",0,[[["self"],["span"]],["span"]]],[11,"contains","","Return true if `self` fully encloses `other`.",0,[[["self"],["span"]],["bool"]]],[11,"source_equal","","Return true if the spans are equal with regards to the source text.",0,[[["self"],["span"]],["bool"]]],[11,"trim_start","","Returns `Some(span)`, where the start is trimmed by the end of `other`",0,[[["self"],["span"]],["option",["span"]]]],[11,"source_callsite","","Return the source span - this is either the supplied span, or the span for the macro callsite that expanded to it.",0,[[["self"]],["span"]]],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated, if any",0,[[["self"]],["option",["span"]]]],[11,"edition","","Edition of the crate from which this span came.",0,[[["self"]],["edition"]]],[11,"source_callee","","Return the source callee.",0,[[["self"]],["option",["expninfo"]]]],[11,"allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable] items can be used (that is, a macro marked with `#[allow_internal_unstable]`).",0,[[["self"]],["bool"]]],[11,"is_compiler_desugaring","","Check if this span arises from a compiler desugaring of kind `kind`.",0,[[["self"],["compilerdesugaringkind"]],["bool"]]],[11,"compiler_desugaring_kind","","Return the compiler desugaring that created this span, or None if this span is not from a desugaring.",0,[[["self"]],["option",["compilerdesugaringkind"]]]],[11,"allows_unsafe","","Check if a span is \"internal\" to a macro in which `unsafe` can be used without triggering the `unsafe_code` lint",0,[[["self"]],["bool"]]],[11,"macro_backtrace","","",0,[[["self"]],["vec",["macrobacktrace"]]]],[11,"to","","Return a `Span` that would enclose both `self` and `end`.",0,[[["self"],["span"]],["span"]]],[11,"between","","Return a `Span` between the end of `self` to the beginning of `end`.",0,[[["self"],["span"]],["span"]]],[11,"until","","Return a `Span` between the beginning of `self` to the beginning of `end`.",0,[[["self"],["span"]],["span"]]],[11,"from_inner_byte_pos","","",0,[[["self"],["usize"],["usize"]],["span"]]],[11,"apply_mark","","",0,[[["self"],["mark"]],["span"]]],[11,"remove_mark","","",0,[[["self"]],["mark"]]],[11,"adjust","","",0,[[["self"],["mark"]],["option",["mark"]]]],[11,"glob_adjust","","",0,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"reverse_glob_adjust","","",0,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"modern","","",0,[[["self"]],["span"]]],[11,"modern_and_legacy","","",0,[[["self"]],["span"]]],[11,"clone","","",4,[[["self"]],["spanlabel"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"default","","",0,[[],["self"]]],[11,"default_encode","","",0,[[["self"],["s"]],["result"]]],[11,"default_decode","","",0,[[["d"]],["result",["span"]]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"new","","",3,[[],["multispan"]]],[11,"from_span","","",3,[[["span"]],["multispan"]]],[11,"from_spans","","",3,[[["vec",["span"]]],["multispan"]]],[11,"push_span_label","","",3,[[["self"],["span"],["string"]]]],[11,"primary_span","","Selects the first primary span (if any)",3,[[["self"]],["option",["span"]]]],[11,"primary_spans","","Returns all primary spans.",3,N],[11,"replace","","Replaces all occurrences of one Span with another. Used to move Spans in areas that don't display well (like std macros). Returns true if replacements occurred.",3,[[["self"],["span"],["span"]],["bool"]]],[11,"span_labels","","Returns the strings to highlight. We always ensure that there is an entry for each of the primary spans -- for each primary span P, if there is at least one label with span P, we return those labels (marked as primary). But otherwise we return `SpanLabel` instances with empty labels.",3,[[["self"]],["vec",["spanlabel"]]]],[11,"from","","",3,[[["span"]],["multispan"]]],[11,"from","","",3,[[["vec",["span"]]],["multispan"]]],[11,"clone","","",5,[[["self"]],["multibytechar"]]],[11,"encode","","",5,[[["self"],["__s"]],["result"]]],[11,"decode","","",5,[[["__d"]],["result",["multibytechar"]]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"eq","","",5,[[["self"],["multibytechar"]],["bool"]]],[11,"ne","","",5,[[["self"],["multibytechar"]],["bool"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"clone","","",19,[[["self"]],["nonnarrowchar"]]],[11,"encode","","",19,[[["self"],["__s"]],["result"]]],[11,"decode","","",19,[[["__d"]],["result",["nonnarrowchar"]]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"eq","","",19,[[["self"],["nonnarrowchar"]],["bool"]]],[11,"ne","","",19,[[["self"],["nonnarrowchar"]],["bool"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"new","","",19,[[["bytepos"],["usize"]],["self"]]],[11,"pos","","Returns the absolute offset of the character in the CodeMap",19,[[["self"]],["bytepos"]]],[11,"width","","Returns the width of the character, 0 (zero-width) or 2 (wide)",19,[[["self"]],["usize"]]],[11,"add","","",19,[[["self"],["bytepos"]],["self"]]],[11,"sub","","",19,[[["self"],["bytepos"]],["self"]]],[11,"eq","","",20,[[["self"],["externalsource"]],["bool"]]],[11,"ne","","",20,[[["self"],["externalsource"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",20,N],[11,"clone","","",20,[[["self"]],["externalsource"]]],[11,"is_absent","","",20,[[["self"]],["bool"]]],[11,"get_source","","",20,[[["self"]],["option",["str"]]]],[11,"clone","","",6,[[["self"]],["filemap"]]],[11,"encode","","",6,[[["self"],["s"]],["result"]]],[11,"decode","","",6,[[["d"]],["result",["filemap"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"new","","",6,[[["filename"],["bool"],["filename"],["string"],["bytepos"]],["filemap"]]],[11,"line_begin_pos","","Return the BytePos of the beginning of the current line.",6,[[["self"],["bytepos"]],["bytepos"]]],[11,"add_external_src","","Add externally loaded source. If the hash of the input doesn't match or no input is supplied via None, it is interpreted as an error and the corresponding enum variant is set. The return value signifies whether some kind of source is present.",6,[[["self"],["f"]],["bool"]]],[11,"get_line","","Get a line from the list of pre-computed line-beginnings. The line number here is 0-based.",6,[[["self"],["usize"]],["option",["cow"]]]],[11,"is_real_file","","",6,[[["self"]],["bool"]]],[11,"is_imported","","",6,[[["self"]],["bool"]]],[11,"byte_length","","",6,[[["self"]],["u32"]]],[11,"count_lines","","",6,[[["self"]],["usize"]]],[11,"lookup_line","","Find the line containing the given position. The return value is the index into the `lines` array of this FileMap, not the 1-based line number. If the filemap is empty or the position is located before the first line, None is returned.",6,[[["self"],["bytepos"]],["option",["usize"]]]],[11,"line_bounds","","",6,N],[11,"contains","","",6,[[["self"],["bytepos"]],["bool"]]],[11,"clone","","",7,[[["self"]],["bytepos"]]],[11,"eq","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"ne","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"hash","","",7,N],[11,"partial_cmp","","",7,[[["self"],["bytepos"]],["option",["ordering"]]]],[11,"lt","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"le","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"gt","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"ge","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"cmp","","",7,[[["self"],["bytepos"]],["ordering"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["charpos"]]],[11,"eq","","",8,[[["self"],["charpos"]],["bool"]]],[11,"ne","","",8,[[["self"],["charpos"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"hash","","",8,N],[11,"partial_cmp","","",8,[[["self"],["charpos"]],["option",["ordering"]]]],[11,"lt","","",8,[[["self"],["charpos"]],["bool"]]],[11,"le","","",8,[[["self"],["charpos"]],["bool"]]],[11,"gt","","",8,[[["self"],["charpos"]],["bool"]]],[11,"ge","","",8,[[["self"],["charpos"]],["bool"]]],[11,"cmp","","",8,[[["self"],["charpos"]],["ordering"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"from_usize","","",7,[[["usize"]],["bytepos"]]],[11,"to_usize","","",7,[[["self"]],["usize"]]],[11,"from_u32","","",7,[[["u32"]],["bytepos"]]],[11,"to_u32","","",7,[[["self"]],["u32"]]],[11,"add","","",7,[[["self"],["bytepos"]],["bytepos"]]],[11,"sub","","",7,[[["self"],["bytepos"]],["bytepos"]]],[11,"encode","","",7,[[["self"],["s"]],["result"]]],[11,"decode","","",7,[[["d"]],["result",["bytepos"]]]],[11,"from_usize","","",8,[[["usize"]],["charpos"]]],[11,"to_usize","","",8,[[["self"]],["usize"]]],[11,"from_u32","","",8,[[["u32"]],["charpos"]]],[11,"to_u32","","",8,[[["self"]],["u32"]]],[11,"add","","",8,[[["self"],["charpos"]],["charpos"]]],[11,"sub","","",8,[[["self"],["charpos"]],["charpos"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"clone","","",9,[[["self"]],["loc"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"clone","","",13,[[["self"]],["lineinfo"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"eq","","",13,[[["self"],["lineinfo"]],["bool"]]],[11,"ne","","",13,[[["self"],["lineinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"clone","","",21,[[["self"]],["spanlineserror"]]],[11,"eq","","",21,[[["self"],["spanlineserror"]],["bool"]]],[11,"ne","","",21,[[["self"],["spanlineserror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"clone","","",22,[[["self"]],["spansnippeterror"]]],[11,"eq","","",22,[[["self"],["spansnippeterror"]],["bool"]]],[11,"ne","","",22,[[["self"],["spansnippeterror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",22,N],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",16,[[["self"]],["distinctsources"]]],[11,"eq","","",16,[[["self"],["distinctsources"]],["bool"]]],[11,"ne","","",16,[[["self"],["distinctsources"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",16,N],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"clone","","",17,[[["self"]],["malformedcodemappositions"]]],[11,"eq","","",17,[[["self"],["malformedcodemappositions"]],["bool"]]],[11,"ne","","",17,[[["self"],["malformedcodemappositions"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]]],"paths":[[3,"Span"],[3,"Globals"],[3,"SpanData"],[3,"MultiSpan"],[3,"SpanLabel"],[3,"MultiByteChar"],[3,"FileMap"],[3,"BytePos"],[3,"CharPos"],[3,"Loc"],[3,"LocWithOpt"],[3,"FileMapAndLine"],[3,"FileMapAndBytePos"],[3,"LineInfo"],[3,"FileLines"],[3,"MacroBacktrace"],[3,"DistinctSources"],[3,"MalformedCodemapPositions"],[4,"FileName"],[4,"NonNarrowChar"],[4,"ExternalSource"],[4,"SpanLinesError"],[4,"SpanSnippetError"],[4,"Edition"],[3,"SyntaxContext"],[3,"SyntaxContextData"],[3,"Mark"],[3,"MarkData"],[3,"HygieneData"],[3,"ExpnInfo"],[4,"Transparency"],[4,"ExpnFormat"],[4,"CompilerDesugaringKind"],[3,"SpanInterner"],[3,"Ident"],[3,"Symbol"],[3,"Interner"],[3,"LocalInternedString"],[3,"InternedString"],[3,"Keyword"],[8,"Pos"]]};
searchIndex["tempfile"]={"doc":"Temporary files and directories.","items":[[3,"TempDir","tempfile","A directory in the filesystem that is automatically deleted when it goes out of scope.",N,N],[12,"path","","",0,N],[3,"NamedTempFile","","A named temporary file.",N,N],[12,"path","","",1,N],[12,"file","","",1,N],[3,"PersistError","","Error returned when persisting a temporary file fails.",N,N],[12,"error","","The underlying IO error.",2,N],[12,"file","","The temporary file that couldn't be persisted.",2,N],[3,"TempPath","","A path to a named temporary file without an open file handle.",N,N],[12,"path","","",3,N],[3,"Builder","","Create a new temporary file or directory with custom parameters.",N,N],[12,"random_len","","",4,N],[12,"prefix","","",4,N],[12,"suffix","","",4,N],[5,"tempdir","","Create a new temporary directory.",N,[[],["result",["tempdir"]]]],[5,"tempdir_in","","Create a new temporary directory.",N,[[["p"]],["result",["tempdir"]]]],[5,"tempfile","","Create a new temporary file.",N,[[],["result",["file"]]]],[5,"tempfile_in","","Create a new temporary file in the specified directory.",N,[[["p"]],["result",["file"]]]],[0,"dir","","",N,N],[3,"TempDir","tempfile::dir","A directory in the filesystem that is automatically deleted when it goes out of scope.",N,N],[12,"path","","",0,N],[5,"tempdir","","Create a new temporary directory.",N,[[],["result",["tempdir"]]]],[5,"tempdir_in","","Create a new temporary directory.",N,[[["p"]],["result",["tempdir"]]]],[5,"create","","",N,[[["pathbuf"]],["result",["tempdir"]]]],[11,"new","tempfile","Attempts to make a temporary directory inside of `env::temp_dir()`.",0,[[],["result",["tempdir"]]]],[11,"new_in","","Attempts to make a temporary directory inside of `tmpdir` whose name will have the prefix `prefix`. The directory and everything inside it will be automatically deleted once the returned `TempDir` is destroyed.",0,[[["p"]],["result",["tempdir"]]]],[11,"path","","Accesses the [`Path`] to the temporary directory.",0,[[["self"]],["path"]]],[11,"into_path","","Persist the temporary directory to disk, returning the [`PathBuf`] where it is located.",0,[[["self"]],["pathbuf"]]],[11,"close","","Closes and removes the temporary directory, returing a `Result`.",0,[[["self"]],["result"]]],[11,"as_ref","","",0,[[["self"]],["path"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"drop","","",0,[[["self"]]]],[0,"file","","",N,N],[3,"PathPersistError","tempfile::file","Error returned when persisting a temporary file path fails.",N,N],[12,"error","","The underlying IO error.",5,N],[12,"path","","The temporary file path that couldn't be persisted.",5,N],[3,"TempPath","","A path to a named temporary file without an open file handle.",N,N],[12,"path","","",3,N],[3,"NamedTempFile","","A named temporary file.",N,N],[12,"path","","",1,N],[12,"file","","",1,N],[3,"PersistError","","Error returned when persisting a temporary file fails.",N,N],[12,"error","","The underlying IO error.",2,N],[12,"file","","The temporary file that couldn't be persisted.",2,N],[5,"tempfile","","Create a new temporary file.",N,[[],["result",["file"]]]],[5,"tempfile_in","","Create a new temporary file in the specified directory.",N,[[["p"]],["result",["file"]]]],[5,"create_named","","",N,[[["pathbuf"]],["result",["namedtempfile"]]]],[0,"imp","","",N,N],[0,"unix","tempfile::file::imp","",N,N],[5,"cvt_err","tempfile::file::imp::unix","",N,[[["c_int"]],["result",["c_int"]]]],[5,"cstr","","",N,[[["path"]],["result",["cstring"]]]],[5,"create_named","","",N,[[["path"]],["result",["file"]]]],[5,"create_unlinked","","",N,[[["path"]],["result",["file"]]]],[5,"create","","",N,[[["path"]],["result",["file"]]]],[5,"create_unix","","",N,[[["path"]],["result",["file"]]]],[5,"stat","","",N,[[["rawfd"]],["result",["stat_t"]]]],[5,"reopen","","",N,[[["file"],["path"]],["result",["file"]]]],[5,"persist","","",N,[[["path"],["path"],["bool"]],["result"]]],[11,"fmt","tempfile::file","",5,[[["self"],["formatter"]],["result"]]],[11,"from","tempfile","",3,[[["pathpersisterror"]],["temppath"]]],[11,"fmt","tempfile::file","",5,[[["self"],["formatter"]],["result"]]],[11,"description","","",5,[[["self"]],["str"]]],[11,"cause","","",5,[[["self"]],["option",["error"]]]],[11,"close","tempfile","Close and remove the temporary file.",3,[[["self"]],["result"]]],[11,"persist","","Persist the temporary file at the target path.",3,[[["self"],["p"]],["result",["pathpersisterror"]]]],[11,"persist_noclobber","","Persist the temporary file at the target path iff no file exists there.",3,[[["self"],["p"]],["result",["pathpersisterror"]]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"drop","","",3,[[["self"]]]],[11,"deref","","",3,[[["self"]],["path"]]],[11,"as_ref","","",3,[[["self"]],["path"]]],[11,"as_ref","","",3,[[["self"]],["osstr"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"as_ref","","",1,[[["self"]],["path"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"from","","",1,[[["persisterror"]],["namedtempfile"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"description","","",2,[[["self"]],["str"]]],[11,"cause","","",2,[[["self"]],["option",["error"]]]],[11,"new","","Create a new named temporary file.",1,[[],["result",["namedtempfile"]]]],[11,"new_in","","Create a new named temporary file in the specified directory.",1,[[["p"]],["result",["namedtempfile"]]]],[11,"path","","Get the temporary file's path.",1,[[["self"]],["path"]]],[11,"close","","Close and remove the temporary file.",1,[[["self"]],["result"]]],[11,"persist","","Persist the temporary file at the target path.",1,[[["self"],["p"]],["result",["file","persisterror"]]]],[11,"persist_noclobber","","Persist the temporary file at the target path iff no file exists there.",1,[[["self"],["p"]],["result",["file","persisterror"]]]],[11,"reopen","","Reopen the temporary file.",1,[[["self"]],["result",["file"]]]],[11,"as_file","","Get a reference to the underlying file.",1,[[["self"]],["file"]]],[11,"as_file_mut","","Get a mutable reference to the underlying file.",1,[[["self"]],["file"]]],[11,"into_file","","Convert the temporary file into a `std::fs::File`.",1,[[["self"]],["file"]]],[11,"into_temp_path","","Closes the file, leaving only the temporary file path.",1,[[["self"]],["temppath"]]],[11,"read","","",1,N],[11,"write","","",1,N],[11,"flush","","",1,[[["self"]],["result"]]],[11,"seek","","",1,[[["self"],["seekfrom"]],["result",["u64"]]]],[11,"as_raw_fd","","",1,[[["self"]],["rawfd"]]],[0,"util","","",N,N],[5,"tmpname","tempfile::util","",N,[[["str"],["str"],["usize"]],["osstring"]]],[5,"create_helper","","",N,[[["path"],["str"],["str"],["usize"],["f"]],["result"]]],[17,"NUM_RETRIES","tempfile","",N,N],[17,"NUM_RAND_CHARS","","",N,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["builder"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"eq","","",4,[[["self"],["builder"]],["bool"]]],[11,"ne","","",4,[[["self"],["builder"]],["bool"]]],[11,"default","","",4,[[],["self"]]],[11,"new","","Create a new `Builder`.",4,[[],["self"]]],[11,"prefix","","Set a custom filename prefix.",4,[[["self"],["str"]],["self"]]],[11,"suffix","","Set a custom filename suffix.",4,[[["self"],["str"]],["self"]]],[11,"rand_bytes","","Set the number of random bytes.",4,[[["self"],["usize"]],["self"]]],[11,"tempfile","","Create the named temporary file.",4,[[["self"]],["result",["namedtempfile"]]]],[11,"tempfile_in","","Create the named temporary file in the specified directory.",4,[[["self"],["p"]],["result",["namedtempfile"]]]],[11,"tempdir","","Attempts to make a temporary directory inside of `env::temp_dir()` whose name will have the prefix, `prefix`. The directory and everything inside it will be automatically deleted once the returned `TempDir` is destroyed.",4,[[["self"]],["result",["tempdir"]]]],[11,"tempdir_in","","Attempts to make a temporary directory inside of `dir`. The directory and everything inside it will be automatically deleted once the returned `TempDir` is destroyed.",4,[[["self"],["p"]],["result",["tempdir"]]]]],"paths":[[3,"TempDir"],[3,"NamedTempFile"],[3,"PersistError"],[3,"TempPath"],[3,"Builder"],[3,"PathPersistError"]]};
searchIndex["thread_local"]={"doc":"Per-object thread-local storage","items":[[3,"ThreadLocal","thread_local","Thread-local variable wrapper",N,N],[12,"table","","",0,N],[12,"lock","","",0,N],[12,"marker","","",0,N],[3,"Table","","",N,N],[12,"entries","","",1,N],[12,"hash_bits","","",1,N],[12,"prev","","",1,N],[3,"TableEntry","","",N,N],[12,"owner","","",2,N],[12,"data","","",2,N],[3,"RawIter","","",N,N],[12,"remaining","","",3,N],[12,"index","","",3,N],[12,"table","","",3,N],[3,"IterMut","","Mutable iterator over the contents of a `ThreadLocal`.",N,N],[12,"raw","","",4,N],[12,"marker","","",4,N],[3,"IntoIter","","An iterator that moves out of a `ThreadLocal`.",N,N],[12,"raw","","",5,N],[12,"_thread_local","","",5,N],[3,"CachedThreadLocal","","Wrapper around `ThreadLocal` which adds a fast path for a single thread.",N,N],[12,"owner","","",6,N],[12,"local","","",6,N],[12,"global","","",6,N],[5,"hash","","",N,[[["usize"],["usize"]],["usize"]]],[0,"thread_id","","",N,N],[3,"ThreadIdManager","thread_local::thread_id","",N,N],[12,"limit","","",7,N],[12,"free_list","","",7,N],[3,"THREAD_ID_MANAGER","","",N,N],[12,"__private_field","","",8,N],[3,"ThreadId","","",N,N],[12,"0","","",9,N],[5,"get","","Returns a non-zero ID for the current thread",N,[[],["usize"]]],[7,"THREAD_ID_MANAGER","","",N,N],[17,"THREAD_ID","","",N,N],[11,"new","","",7,[[],["threadidmanager"]]],[11,"alloc","","",7,[[["self"]],["usize"]]],[11,"free","","",7,[[["self"],["usize"]]]],[11,"deref","","",8,[[["self"]],["mutex"]]],[11,"initialize","","",8,[[["self"]]]],[11,"new","","",9,[[],["threadid"]]],[11,"drop","","",9,[[["self"]]]],[6,"CachedIterMut","thread_local","Mutable iterator over the contents of a `CachedThreadLocal`.",N,N],[6,"CachedIntoIter","","An iterator that moves out of a `CachedThreadLocal`.",N,N],[11,"default","","",0,[[],["threadlocal"]]],[11,"drop","","",0,[[["self"]]]],[11,"clone","","",2,[[["self"]],["tableentry"]]],[11,"new","","Creates a new empty `ThreadLocal`.",0,[[],["threadlocal"]]],[11,"get","","Returns the element for the current thread, if it exists.",0,[[["self"]],["option"]]],[11,"get_or","","Returns the element for the current thread, or creates it if it doesn't exist.",0,[[["self"],["f"]],["t"]]],[11,"get_or_try","","Returns the element for the current thread, or creates it if it doesn't exist. If `create` fails, that error is returned and no element is added.",0,[[["self"],["f"]],["result"]]],[11,"lookup","","",0,[[["usize"],["table"]],["option",["unsafecell"]]]],[11,"get_fast","","",0,[[["self"],["usize"]],["option"]]],[11,"get_slow","","",0,[[["self"],["usize"],["table"]],["option"]]],[11,"insert","","",0,[[["self"],["usize"],["box"],["bool"]],["t"]]],[11,"iter_mut","","Returns a mutable iterator over the local values of all threads.",0,[[["self"]],["itermut"]]],[11,"clear","","Removes all thread-specific values from the `ThreadLocal`, effectively reseting it to its original state.",0,[[["self"]]]],[11,"into_iter","","",0,[[["self"]],["intoiter"]]],[11,"get_default","","Returns the element for the current thread, or creates a default one if it doesn't exist.",0,[[["self"]],["t"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"next","","",3,[[["self"]],["option"]]],[11,"next","","",4,[[["self"]],["option",["box"]]]],[11,"size_hint","","",4,N],[11,"next","","",5,[[["self"]],["option",["box"]]]],[11,"size_hint","","",5,N],[11,"default","","",6,[[],["cachedthreadlocal"]]],[11,"new","","Creates a new empty `CachedThreadLocal`.",6,[[],["cachedthreadlocal"]]],[11,"get","","Returns the element for the current thread, if it exists.",6,[[["self"]],["option"]]],[11,"get_or","","Returns the element for the current thread, or creates it if it doesn't exist.",6,[[["self"],["f"]],["t"]]],[11,"get_or_try","","Returns the element for the current thread, or creates it if it doesn't exist. If `create` fails, that error is returned and no element is added.",6,[[["self"],["f"]],["result"]]],[11,"get_or_try_slow","","",6,[[["self"],["usize"],["usize"],["f"]],["result"]]],[11,"iter_mut","","Returns a mutable iterator over the local values of all threads.",6,[[["self"]],["cacheditermut"]]],[11,"clear","","Removes all thread-specific values from the `ThreadLocal`, effectively reseting it to its original state.",6,[[["self"]]]],[11,"into_iter","","",6,[[["self"]],["cachedintoiter"]]],[11,"get_default","","Returns the element for the current thread, or creates a default one if it doesn't exist.",6,[[["self"]],["t"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]]],"paths":[[3,"ThreadLocal"],[3,"Table"],[3,"TableEntry"],[3,"RawIter"],[3,"IterMut"],[3,"IntoIter"],[3,"CachedThreadLocal"],[3,"ThreadIdManager"],[3,"THREAD_ID_MANAGER"],[3,"ThreadId"]]};
searchIndex["ucd_util"]={"doc":"The `ucd-util` crate contains a smattering of utility functions that implement various algorithms specified by Unicode. There is no specific goal for exhaustiveness. Instead, implementations should be added on an as-needed basis.","items":[[5,"hangul_name","ucd_util","Return the character name of the given precomposed Hangul codepoint.",N,[[["u32"]],["option",["string"]]]],[5,"hangul_full_canonical_decomposition","","Return the full canonical decomposition of the given precomposed Hangul codepoint.",N,[[["u32"]],["option"]]],[5,"ideograph_name","","Return the character name of the given ideograph codepoint.",N,[[["u32"]],["option",["string"]]]],[5,"character_name_normalize","","Normalize the given character name in place according to UAX44-LM2.",N,[[["string"]]]],[5,"symbolic_name_normalize","","Normalize the given symbolic name in place according to UAX44-LM3.",N,[[["string"]]]],[5,"canonical_property_name","","Find the canonical property name for the given normalized property name.",N,[[["propertytable"],["str"]],["option",["str"]]]],[5,"property_values","","Find the set of possible property values for a given property.",N,[[["propertyvaluetable"],["str"]],["option",["propertyvalues"]]]],[5,"canonical_property_value","","Find the canonical property value for the given normalized property value.",N,[[["propertyvalues"],["str"]],["option",["str"]]]],[0,"hangul","","",N,N],[5,"hangul_name","ucd_util::hangul","Return the character name of the given precomposed Hangul codepoint.",N,[[["u32"]],["option",["string"]]]],[5,"hangul_full_canonical_decomposition","","Return the full canonical decomposition of the given precomposed Hangul codepoint.",N,[[["u32"]],["option"]]],[5,"jamo_short_name","","",N,[[["u32"]],["str"]]],[17,"RANGE_HANGUL_SYLLABLE","","A set of ranges that corresponds to the set of all Hangul syllable codepoints.",N,N],[17,"S_BASE","","",N,N],[17,"L_BASE","","",N,N],[17,"V_BASE","","",N,N],[17,"T_BASE","","",N,N],[17,"T_COUNT","","",N,N],[17,"N_COUNT","","",N,N],[0,"ideograph","ucd_util","",N,N],[5,"ideograph_name","ucd_util::ideograph","Return the character name of the given ideograph codepoint.",N,[[["u32"]],["option",["string"]]]],[17,"RANGE_IDEOGRAPH","","A set of ranges that corresponds to the set of all ideograph codepoints.",N,N],[0,"name","ucd_util","",N,N],[5,"character_name_normalize","ucd_util::name","Normalize the given character name in place according to UAX44-LM2.",N,[[["string"]]]],[5,"character_name_normalize_bytes","","Normalize the given character name in place according to UAX44-LM2.",N,N],[5,"symbolic_name_normalize","","Normalize the given symbolic name in place according to UAX44-LM3.",N,[[["string"]]]],[5,"symbolic_name_normalize_bytes","","Normalize the given symbolic name in place according to UAX44-LM3.",N,N],[0,"property","ucd_util","",N,N],[5,"canonical_property_name","ucd_util::property","Find the canonical property name for the given normalized property name.",N,[[["propertytable"],["str"]],["option",["str"]]]],[5,"property_values","","Find the set of possible property values for a given property.",N,[[["propertyvaluetable"],["str"]],["option",["propertyvalues"]]]],[5,"canonical_property_value","","Find the canonical property value for the given normalized property value.",N,[[["propertyvalues"],["str"]],["option",["str"]]]],[6,"PropertyTable","","The type of a property name table.",N,N],[6,"PropertyValueTable","","Type of a property value table.",N,N],[6,"PropertyValues","","A mapping of property values for a specific property.",N,N],[0,"unicode_tables","ucd_util","",N,N],[0,"jamo_short_name","ucd_util::unicode_tables","",N,N],[17,"JAMO_SHORT_NAME","ucd_util::unicode_tables::jamo_short_name","",N,N],[6,"PropertyTable","ucd_util","The type of a property name table.",N,N],[6,"PropertyValueTable","","Type of a property value table.",N,N],[6,"PropertyValues","","A mapping of property values for a specific property.",N,N],[17,"RANGE_HANGUL_SYLLABLE","","A set of ranges that corresponds to the set of all Hangul syllable codepoints.",N,N],[17,"RANGE_IDEOGRAPH","","A set of ranges that corresponds to the set of all ideograph codepoints.",N,N]],"paths":[]};
searchIndex["unreachable"]={"doc":"unreachable","items":[[5,"unreachable","unreachable","Hint to the optimizer that any code path which calls this function is statically unreachable and can be removed.",N,N],[8,"UncheckedOptionExt","","An extension trait for `Option<T>` providing unchecked unwrapping methods.",N,N],[10,"unchecked_unwrap","","Get the value out of this Option without checking for None.",0,[[["self"]],["t"]]],[10,"unchecked_unwrap_none","","Assert that this Option is a None to the optimizer.",0,[[["self"]]]],[8,"UncheckedResultExt","","An extension trait for `Result<T, E>` providing unchecked unwrapping methods.",N,N],[10,"unchecked_unwrap_ok","","Get the value out of this Result without checking for Err.",1,[[["self"]],["t"]]],[10,"unchecked_unwrap_err","","Get the error out of this Result without checking for Ok.",1,[[["self"]],["e"]]]],"paths":[[8,"UncheckedOptionExt"],[8,"UncheckedResultExt"]]};
searchIndex["utf8_ranges"]={"doc":"Crate `utf8-ranges` converts ranges of Unicode scalar values to equivalent ranges of UTF-8 bytes. This is useful for constructing byte based automatons that need to embed UTF-8 decoding.","items":[[3,"Utf8Range","utf8_ranges","A single inclusive range of UTF-8 bytes.",N,N],[12,"start","","Start of byte range (inclusive).",0,N],[12,"end","","End of byte range (inclusive).",0,N],[3,"Utf8Sequences","","An iterator over ranges of matching UTF-8 byte sequences.",N,N],[12,"range_stack","","",1,N],[3,"ScalarRange","","",N,N],[12,"start","","",2,N],[12,"end","","",2,N],[4,"Utf8Sequence","","Utf8Sequence represents a sequence of byte ranges.",N,N],[13,"One","","One byte range.",3,N],[13,"Two","","Two successive byte ranges.",3,N],[13,"Three","","Three successive byte ranges.",3,N],[13,"Four","","Four successive byte ranges.",3,N],[5,"max_scalar_value","","",N,[[["usize"]],["u32"]]],[0,"char_utf8","","",N,N],[5,"encode_utf8","utf8_ranges::char_utf8","",N,N],[17,"TAG_CONT","","",N,N],[17,"TAG_TWO_B","","",N,N],[17,"TAG_THREE_B","","",N,N],[17,"TAG_FOUR_B","","",N,N],[17,"MAX_ONE_B","","",N,N],[17,"MAX_TWO_B","","",N,N],[17,"MAX_THREE_B","","",N,N],[17,"MAX_UTF8_BYTES","utf8_ranges","",N,N],[11,"clone","","",3,[[["self"]],["utf8sequence"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"eq","","",3,[[["self"],["utf8sequence"]],["bool"]]],[11,"ne","","",3,[[["self"],["utf8sequence"]],["bool"]]],[11,"from_encoded_range","","Creates a new UTF-8 sequence from the encoded bytes of a scalar value range.",3,N],[11,"as_slice","","Returns the underlying sequence of byte ranges as a slice.",3,N],[11,"len","","Returns the number of byte ranges in this sequence.",3,[[["self"]],["usize"]]],[11,"matches","","Returns true if and only if a prefix of `bytes` matches this sequence of byte ranges.",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",0,[[["self"]],["utf8range"]]],[11,"eq","","",0,[[["self"],["utf8range"]],["bool"]]],[11,"ne","","",0,[[["self"],["utf8range"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"new","","",0,[[["u8"],["u8"]],["self"]]],[11,"matches","","Returns true if and only if the given byte is in this range.",0,[[["self"],["u8"]],["bool"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new iterator over UTF-8 byte ranges for the scalar value range given.",1,[[["char"],["char"]],["self"]]],[11,"reset","","reset resets the scalar value range. Any existing state is cleared, but resources may be reused.",1,[[["self"],["char"],["char"]]]],[11,"push","","",1,[[["self"],["u32"],["u32"]]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"next","","",1,[[["self"]],["option"]]],[11,"split","","split splits this range if it overlaps with a surrogate codepoint.",2,[[["self"]],["option"]]],[11,"is_valid","","is_valid returns true if and only if start <= end.",2,[[["self"]],["bool"]]],[11,"as_ascii","","as_ascii returns this range as a Utf8Range if and only if all scalar values in this range can be encoded as a single byte.",2,[[["self"]],["option",["utf8range"]]]],[11,"is_ascii","","is_ascii returns true if the range is ASCII only (i.e., takes a single byte to encode any scalar value).",2,[[["self"]],["bool"]]],[11,"encode","","encode writes the UTF-8 encoding of the start and end of this range to the corresponding destination slices.",2,N]],"paths":[[3,"Utf8Range"],[3,"Utf8Sequences"],[3,"ScalarRange"],[4,"Utf8Sequence"]]};
searchIndex["void"]={"doc":"Void","items":[[4,"Void","void","The empty type for cases which can't occur.",N,N],[5,"unreachable","","A safe version of `intrinsincs::unreachable`.",N,N],[0,"coreprovider","","",N,N],[0,"fmt","void::coreprovider","Utilities for formatting and printing strings.",N,N],[4,"Alignment","void::coreprovider::fmt","Possible alignments returned by `Formatter::align`",N,N],[13,"Left","","Indication that contents should be left-aligned.",0,N],[13,"Right","","Indication that contents should be right-aligned.",0,N],[13,"Center","","Indication that contents should be center-aligned.",0,N],[0,"rt","","",N,N],[0,"v1","void::coreprovider::fmt::rt","This is an internal module used by the ifmt! runtime. These structures are emitted to static arrays to precompile format strings ahead of time.",N,N],[3,"Argument","void::coreprovider::fmt::rt::v1","",N,N],[12,"position","","",1,N],[12,"format","","",1,N],[3,"FormatSpec","","",N,N],[12,"fill","","",2,N],[12,"align","","",2,N],[12,"flags","","",2,N],[12,"precision","","",2,N],[12,"width","","",2,N],[4,"Alignment","","Possible alignments that can be requested as part of a formatting directive.",N,N],[13,"Left","","Indication that contents should be left-aligned.",3,N],[13,"Right","","Indication that contents should be right-aligned.",3,N],[13,"Center","","Indication that contents should be center-aligned.",3,N],[13,"Unknown","","No alignment was requested.",3,N],[4,"Count","","",N,N],[13,"Is","","",4,N],[13,"Param","","",4,N],[13,"NextParam","","",4,N],[13,"Implied","","",4,N],[4,"Position","","",N,N],[13,"Next","","",5,N],[13,"At","","",5,N],[6,"Result","void::coreprovider::fmt","The type returned by formatter methods.",N,N],[3,"Error","","The error type which is returned from formatting a message into a stream.",N,N],[8,"Write","","A collection of methods that are required to format a message into a stream.",N,N],[10,"write_str","","Writes a slice of bytes into this writer, returning whether the write succeeded.",6,[[["self"],["str"]],["result",["error"]]]],[11,"write_char","","Writes a [`char`] into this writer, returning whether the write succeeded.",6,[[["self"],["char"]],["result",["error"]]]],[11,"write_fmt","","Glue for usage of the [`write!`] macro with implementors of this trait.",6,[[["self"],["arguments"]],["result",["error"]]]],[3,"Formatter","","A struct to represent both where to emit formatting strings to and how they should be formatted. A mutable version of this is passed to all formatting traits.",N,N],[12,"flags","","",7,N],[12,"fill","","",7,N],[12,"align","","",7,N],[12,"width","","",7,N],[12,"precision","","",7,N],[12,"buf","","",7,N],[12,"curarg","","",7,N],[12,"args","","",7,N],[3,"ArgumentV1","","This struct represents the generic \"argument\" which is taken by the Xprintf family of functions. It contains a function to format the given value. At compile time it is ensured that the function and the value have the correct types, and then this struct is used to canonicalize arguments to one type.",N,N],[12,"value","","",8,N],[12,"formatter","","",8,N],[3,"Arguments","","This structure represents a safely precompiled version of a format string and its arguments. This cannot be generated at runtime because it cannot safely be done, so no constructors are given and the fields are private to prevent modification.",N,N],[12,"pieces","","",9,N],[12,"fmt","","",9,N],[12,"args","","",9,N],[8,"Debug","","`?` formatting.",N,N],[10,"fmt","","Formats the value using the given formatter.",10,[[["self"],["formatter"]],["result",["error"]]]],[8,"Display","","Format trait for an empty format, `{}`.",N,N],[10,"fmt","","Formats the value using the given formatter.",11,[[["self"],["formatter"]],["result",["error"]]]],[8,"Octal","","`o` formatting.",N,N],[10,"fmt","","Formats the value using the given formatter.",12,[[["self"],["formatter"]],["result",["error"]]]],[8,"Binary","","`b` formatting.",N,N],[10,"fmt","","Formats the value using the given formatter.",13,[[["self"],["formatter"]],["result",["error"]]]],[8,"LowerHex","","`x` formatting.",N,N],[10,"fmt","","Formats the value using the given formatter.",14,[[["self"],["formatter"]],["result",["error"]]]],[8,"UpperHex","","`X` formatting.",N,N],[10,"fmt","","Formats the value using the given formatter.",15,[[["self"],["formatter"]],["result",["error"]]]],[8,"Pointer","","`p` formatting.",N,N],[10,"fmt","","Formats the value using the given formatter.",16,[[["self"],["formatter"]],["result",["error"]]]],[8,"LowerExp","","`e` formatting.",N,N],[10,"fmt","","Formats the value using the given formatter.",17,[[["self"],["formatter"]],["result",["error"]]]],[8,"UpperExp","","`E` formatting.",N,N],[10,"fmt","","Formats the value using the given formatter.",18,[[["self"],["formatter"]],["result",["error"]]]],[5,"write","","The `write` function takes an output stream, and an `Arguments` struct that can be precompiled with the `format_args!` macro.",N,[[["write"],["arguments"]],["result",["error"]]]],[3,"DebugSet","","A struct to help with `fmt::Debug` implementations.",N,N],[12,"inner","","",19,N],[3,"DebugTuple","","A struct to help with `fmt::Debug` implementations.",N,N],[12,"fmt","","",20,N],[12,"result","","",20,N],[12,"fields","","",20,N],[12,"empty_name","","",20,N],[3,"DebugStruct","","A struct to help with `fmt::Debug` implementations.",N,N],[12,"fmt","","",21,N],[12,"result","","",21,N],[12,"has_fields","","",21,N],[3,"DebugMap","","A struct to help with `fmt::Debug` implementations.",N,N],[12,"fmt","","",22,N],[12,"result","","",22,N],[12,"has_fields","","",22,N],[3,"DebugList","","A struct to help with `fmt::Debug` implementations.",N,N],[12,"inner","","",23,N],[0,"cmp","void::coreprovider","Functionality for ordering and comparison.",N,N],[8,"PartialEq","void::coreprovider::cmp","Trait for equality comparisons which are partial equivalence relations.",N,N],[10,"eq","","This method tests for `self` and `other` values to be equal, and is used by `==`.",24,[[["self"],["rhs"]],["bool"]]],[11,"ne","","This method tests for `!=`.",24,[[["self"],["rhs"]],["bool"]]],[8,"Eq","","Trait for equality comparisons which are equivalence relations.",N,N],[11,"assert_receiver_is_total_eq","","",25,N],[3,"AssertParamIsEq","","",N,N],[12,"_field","","",26,N],[4,"Ordering","","An `Ordering` is the result of a comparison between two values.",N,N],[13,"Less","","An ordering where a compared value is less [than another].",27,N],[13,"Equal","","An ordering where a compared value is equal [to another].",27,N],[13,"Greater","","An ordering where a compared value is greater [than another].",27,N],[3,"Reverse","","A helper struct for reverse ordering.",N,N],[12,"0","","",28,N],[8,"Ord","","Trait for types that form a total order.",N,N],[10,"cmp","","This method returns an `Ordering` between `self` and `other`.",29,[[["self"],["self"]],["ordering"]]],[11,"max","","Compares and returns the maximum of two values.",29,[[["self"],["self"]],["self"]]],[11,"min","","Compares and returns the minimum of two values.",29,[[["self"],["self"]],["self"]]],[8,"PartialOrd","","Trait for values that can be compared for a sort-order.",N,N],[10,"partial_cmp","","This method returns an ordering between `self` and `other` values if one exists.",30,[[["self"],["rhs"]],["option",["ordering"]]]],[11,"lt","","This method tests less than (for `self` and `other`) and is used by the `<` operator.",30,[[["self"],["rhs"]],["bool"]]],[11,"le","","This method tests less than or equal to (for `self` and `other`) and is used by the `<=` operator.",30,[[["self"],["rhs"]],["bool"]]],[11,"gt","","This method tests greater than (for `self` and `other`) and is used by the `>` operator.",30,[[["self"],["rhs"]],["bool"]]],[11,"ge","","This method tests greater than or equal to (for `self` and `other`) and is used by the `>=` operator.",30,[[["self"],["rhs"]],["bool"]]],[5,"min","","Compares and returns the minimum of two values.",N,[[["t"],["t"]],["t"]]],[5,"max","","Compares and returns the maximum of two values.",N,[[["t"],["t"]],["t"]]],[8,"ResultVoidExt","void","Extensions to `Result<T, Void>`",N,N],[10,"void_unwrap","","Get the value out of a wrapper.",31,[[["self"]],["t"]]],[8,"ResultVoidErrExt","","Extensions to `Result<Void, E>`",N,N],[10,"void_unwrap_err","","Get the error out of a wrapper.",32,[[["self"]],["e"]]],[11,"clone","","",33,[[["self"]],["void"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"eq","","",33,[[["self"],["t"]],["bool"]]],[11,"partial_cmp","","",33,[[["self"],["t"]],["option",["ordering"]]]],[11,"hash","void::coreprovider::cmp","",27,N],[11,"hash","void::coreprovider::fmt","",34,N],[11,"hash","void::coreprovider::cmp","",28,N],[11,"clone","","",28,[[["self"]],["reverse"]]],[11,"clone","void::coreprovider::fmt","",34,[[["self"]],["error"]]],[11,"clone","","",9,[[["self"]],["arguments"]]],[11,"clone","void::coreprovider::cmp","",27,[[["self"]],["ordering"]]],[11,"fmt","void::coreprovider::fmt","",34,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","void::coreprovider::cmp","",27,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","void::coreprovider::fmt","",0,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","void::coreprovider::cmp","",28,[[["self"],["formatter"]],["result",["error"]]]],[11,"partial_cmp","void::coreprovider::fmt","",34,[[["self"],["error"]],["option",["ordering"]]]],[11,"partial_cmp","void::coreprovider::cmp","",27,[[["self"],["ordering"]],["option",["ordering"]]]],[11,"partial_cmp","","",28,[[["self"],["reverse"]],["option",["ordering"]]]],[11,"lt","","",28,[[["self"],["reverse"]],["bool"]]],[11,"le","","",28,[[["self"],["reverse"]],["bool"]]],[11,"ge","","",28,[[["self"],["reverse"]],["bool"]]],[11,"gt","","",28,[[["self"],["reverse"]],["bool"]]],[11,"cmp","void::coreprovider::fmt","",34,[[["self"],["error"]],["ordering"]]],[11,"cmp","void::coreprovider::cmp","",27,[[["self"],["ordering"]],["ordering"]]],[11,"cmp","","",28,[[["self"],["reverse"]],["ordering"]]],[11,"assert_receiver_is_total_eq","void::coreprovider::fmt","",34,N],[11,"assert_receiver_is_total_eq","void::coreprovider::cmp","",28,N],[11,"eq","","",27,[[["self"],["ordering"]],["bool"]]],[11,"eq","","",28,[[["self"],["reverse"]],["bool"]]],[11,"ne","","",28,[[["self"],["reverse"]],["bool"]]],[11,"eq","void::coreprovider::fmt","",34,[[["self"],["error"]],["bool"]]],[11,"write_str","","",7,[[["self"],["str"]],["result",["error"]]]],[11,"write_char","","",7,[[["self"],["char"]],["result",["error"]]]],[11,"write_fmt","","",7,[[["self"],["arguments"]],["result",["error"]]]],[11,"default","void::coreprovider::cmp","",28,[[],["reverse"]]],[11,"default","void::coreprovider::fmt","",34,[[],["error"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result",["error"]]]],[11,"pad_integral","","Performs the correct padding for an integer which has already been emitted into a str. The str should not contain the sign for the integer, that will be added by this method.",7,[[["self"],["bool"],["str"],["str"]],["result",["error"]]]],[11,"pad","","This function takes a string slice and emits it to the internal buffer after applying the relevant formatting flags specified. The flags recognized for generic strings are:",7,[[["self"],["str"]],["result",["error"]]]],[11,"write_str","","Writes some data to the underlying buffer contained within this formatter.",7,[[["self"],["str"]],["result",["error"]]]],[11,"write_fmt","","Writes some formatted information into this instance.",7,[[["self"],["arguments"]],["result",["error"]]]],[11,"flags","","Flags for formatting",7,[[["self"]],["u32"]]],[11,"fill","","Character used as 'fill' whenever there is alignment.",7,[[["self"]],["char"]]],[11,"align","","Flag indicating what form of alignment was requested.",7,[[["self"]],["option",["alignment"]]]],[11,"width","","Optionally specified integer width that the output should be.",7,[[["self"]],["option",["usize"]]]],[11,"precision","","Optionally specified precision for numeric types.",7,[[["self"]],["option",["usize"]]]],[11,"sign_plus","","Determines if the `+` flag was specified.",7,[[["self"]],["bool"]]],[11,"sign_minus","","Determines if the `-` flag was specified.",7,[[["self"]],["bool"]]],[11,"alternate","","Determines if the `#` flag was specified.",7,[[["self"]],["bool"]]],[11,"sign_aware_zero_pad","","Determines if the `0` flag was specified.",7,[[["self"]],["bool"]]],[11,"debug_struct","","Creates a [`DebugStruct`] builder designed to assist with creation of [`fmt::Debug`] implementations for structs.",7,[[["self"],["str"]],["debugstruct"]]],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of `fmt::Debug` implementations for tuple structs.",7,[[["self"],["str"]],["debugtuple"]]],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of `fmt::Debug` implementations for list-like structures.",7,[[["self"]],["debuglist"]]],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of `fmt::Debug` implementations for set-like structures.",7,[[["self"]],["debugset"]]],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of `fmt::Debug` implementations for map-like structures.",7,[[["self"]],["debugmap"]]],[11,"new_v1","","When using the format_args!() macro, this function is used to generate the Arguments structure.",9,N],[11,"new_v1_formatted","","This function is used to specify nonstandard formatting parameters. The `pieces` array must be at least as long as `fmt` to construct a valid Arguments structure. Also, any `Count` within `fmt` that is `CountIsParam` or `CountIsNextParam` has to point to an argument created with `argumentusize`. However, failing to do so doesn't cause unsafety, but will ignore invalid .",9,N],[11,"estimated_capacity","","Estimates the length of the formatted text.",9,[[["self"]],["usize"]]],[11,"entry","","Adds a new entry to the set output.",19,[[["self"],["debug"]],["debugset"]]],[11,"entries","","Adds the contents of an iterator of entries to the set output.",19,[[["self"],["i"]],["debugset"]]],[11,"finish","","Finishes output and returns any error encountered.",19,[[["self"]],["result",["error"]]]],[11,"field","","Adds a new field to the generated tuple struct output.",20,[[["self"],["debug"]],["debugtuple"]]],[11,"finish","","Finishes output and returns any error encountered.",20,[[["self"]],["result",["error"]]]],[11,"field","","Adds a new field to the generated struct output.",21,[[["self"],["str"],["debug"]],["debugstruct"]]],[11,"finish","","Finishes output and returns any error encountered.",21,[[["self"]],["result",["error"]]]],[11,"entry","","Adds a new entry to the map output.",22,[[["self"],["debug"],["debug"]],["debugmap"]]],[11,"entries","","Adds the contents of an iterator of entries to the map output.",22,[[["self"],["i"]],["debugmap"]]],[11,"finish","","Finishes output and returns any error encountered.",22,[[["self"]],["result",["error"]]]],[11,"entry","","Adds a new entry to the list output.",23,[[["self"],["debug"]],["debuglist"]]],[11,"entries","","Adds the contents of an iterator of entries to the list output.",23,[[["self"],["i"]],["debuglist"]]],[11,"finish","","Finishes output and returns any error encountered.",23,[[["self"]],["result",["error"]]]],[11,"reverse","void::coreprovider::cmp","Reverses the `Ordering`.",27,[[["self"]],["ordering"]]],[11,"then","","Chains two orderings.",27,[[["self"],["ordering"]],["ordering"]]],[11,"then_with","","Chains the ordering with the given function.",27,[[["self"],["f"]],["ordering"]]]],"paths":[[4,"Alignment"],[3,"Argument"],[3,"FormatSpec"],[4,"Alignment"],[4,"Count"],[4,"Position"],[8,"Write"],[3,"Formatter"],[3,"ArgumentV1"],[3,"Arguments"],[8,"Debug"],[8,"Display"],[8,"Octal"],[8,"Binary"],[8,"LowerHex"],[8,"UpperHex"],[8,"Pointer"],[8,"LowerExp"],[8,"UpperExp"],[3,"DebugSet"],[3,"DebugTuple"],[3,"DebugStruct"],[3,"DebugMap"],[3,"DebugList"],[8,"PartialEq"],[8,"Eq"],[3,"AssertParamIsEq"],[4,"Ordering"],[3,"Reverse"],[8,"Ord"],[8,"PartialOrd"],[8,"ResultVoidExt"],[8,"ResultVoidErrExt"],[4,"Void"],[3,"Error"]]};
initSearch(searchIndex);
